var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import * as React from "react";
import React__default, { useState, useMemo, useRef, useEffect, createContext, useContext } from "react";
var __read$3 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useToggle(defaultValue, reverseValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$3(useState(defaultValue), 2), state = _a2[0], setState = _a2[1];
  var actions2 = useMemo(function() {
    var reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    var toggle = function toggle2() {
      return setState(function(s) {
        return s === defaultValue ? reverseValueOrigin : defaultValue;
      });
    };
    var set2 = function set3(value) {
      return setState(value);
    };
    var setLeft = function setLeft2() {
      return setState(defaultValue);
    };
    var setRight = function setRight2() {
      return setState(reverseValueOrigin);
    };
    return {
      toggle,
      set: set2,
      setLeft,
      setRight
    };
  }, []);
  return [state, actions2];
}
var __read$2 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$2(useToggle(defaultValue), 2), state = _a2[0], _b2 = _a2[1], toggle = _b2.toggle, _set = _b2.set;
  var actions2 = useMemo(function() {
    var setTrue = function setTrue2() {
      return _set(true);
    };
    var setFalse = function setFalse2() {
      return _set(false);
    };
    return {
      toggle,
      set: function set2(v4) {
        return _set(!!v4);
      },
      setTrue,
      setFalse
    };
  }, []);
  return [state, actions2];
}
function useLatest(value) {
  var ref = useRef(value);
  ref.current = value;
  return ref;
}
var isBrowser = !!(typeof window !== "undefined" && window.document && window.document.createElement);
var isBrowser$1 = isBrowser;
function getTargetElement(target, defaultElement) {
  if (!isBrowser$1) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  var targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if ("current" in target) {
    targetElement = target.current;
  } else {
    targetElement = target;
  }
  return targetElement;
}
var useUnmount = function useUnmount2(fn) {
  var fnRef = useLatest(fn);
  useEffect(function() {
    return function() {
      fnRef.current();
    };
  }, []);
};
var useUnmount$1 = useUnmount;
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (var i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
var createEffectWithTarget = function createEffectWithTarget2(useEffectType) {
  var useEffectWithTarget2 = function useEffectWithTarget3(effect, deps, target) {
    var hasInitRef = useRef(false);
    var lastElementRef = useRef([]);
    var lastDepsRef = useRef([]);
    var unLoadRef = useRef();
    useEffectType(function() {
      var _a2;
      var targets = Array.isArray(target) ? target : [target];
      var els = targets.map(function(item) {
        return getTargetElement(item);
      });
      if (!hasInitRef.current) {
        hasInitRef.current = true;
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
        return;
      }
      if (els.length !== lastElementRef.current.length || !depsAreSame(els, lastElementRef.current) || !depsAreSame(deps, lastDepsRef.current)) {
        (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
      }
    });
    useUnmount$1(function() {
      var _a2;
      (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
      hasInitRef.current = false;
    });
  };
  return useEffectWithTarget2;
};
var createEffectWithTarget$1 = createEffectWithTarget;
var useEffectWithTarget = createEffectWithTarget$1(useEffect);
var useEffectWithTarget$1 = useEffectWithTarget;
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function isObject$7(value) {
  var type4 = typeof value;
  return value != null && (type4 == "object" || type4 == "function");
}
var isObject_1 = isObject$7;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$2 = freeGlobal || freeSelf || Function("return this")();
var _root = root$2;
var root$1 = _root;
var now$1 = function() {
  return root$1.Date.now();
};
var now_1 = now$1;
var reWhitespace = /\s/;
function trimmedEndIndex$1(string3) {
  var index2 = string3.length;
  while (index2-- && reWhitespace.test(string3.charAt(index2))) {
  }
  return index2;
}
var _trimmedEndIndex = trimmedEndIndex$1;
var trimmedEndIndex = _trimmedEndIndex;
var reTrimStart = /^\s+/;
function baseTrim$1(string3) {
  return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
}
var _baseTrim = baseTrim$1;
var root = _root;
var Symbol$4 = root.Symbol;
var _Symbol = Symbol$4;
var Symbol$3 = _Symbol;
var objectProto$1 = Object.prototype;
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$3 ? Symbol$3.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$1.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e2) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$2 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag$1(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$1;
function isObjectLike$1(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$1;
var baseGetTag = _baseGetTag, isObjectLike = isObjectLike_1;
var symbolTag = "[object Symbol]";
function isSymbol$1(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
var isSymbol_1 = isSymbol$1;
var baseTrim = _baseTrim, isObject$6 = isObject_1, isSymbol = isSymbol_1;
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber$1(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$6(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject$6(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_1 = toNumber$1;
var isObject$5 = isObject_1, now = now_1, toNumber = toNumber_1;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject$5(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel2() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel2;
  debounced.flush = flush;
  return debounced;
}
var debounce_1 = debounce;
var __read$1 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
var __spread = globalThis && globalThis.__spread || function() {
  for (var ar = [], i = 0; i < arguments.length; i++) {
    ar = ar.concat(__read$1(arguments[i]));
  }
  return ar;
};
function useDebounceFn(fn, options) {
  var _a2;
  var fnRef = useLatest(fn);
  var wait = (_a2 = options === null || options === void 0 ? void 0 : options.wait) !== null && _a2 !== void 0 ? _a2 : 1e3;
  var debounced = useMemo(function() {
    return debounce_1(function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return fnRef.current.apply(fnRef, __spread(args));
    }, wait, options);
  }, []);
  useUnmount$1(function() {
    debounced.cancel();
  });
  return {
    run: debounced,
    cancel: debounced.cancel,
    flush: debounced.flush
  };
}
var createUpdateEffect = function createUpdateEffect2(hook) {
  return function(effect, deps) {
    var isMounted = useRef(false);
    hook(function() {
      return function() {
        isMounted.current = false;
      };
    }, []);
    hook(function() {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};
var useUpdateEffect = createUpdateEffect(useEffect);
var __read = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useDebounceEffect(effect, deps, options) {
  var _a2 = __read(useState({}), 2), flag = _a2[0], setFlag = _a2[1];
  var _b2 = useDebounceFn(function() {
    setFlag({});
  }, options), run = _b2.run, cancel2 = _b2.cancel;
  useEffect(function() {
    return run();
  }, deps);
  useUnmount$1(cancel2);
  useUpdateEffect(effect, [flag]);
}
function useEventListener(eventName, handler, options) {
  if (options === void 0) {
    options = {};
  }
  var handlerRef = useLatest(handler);
  useEffectWithTarget$1(function() {
    var targetElement = getTargetElement(options.target, window);
    if (!(targetElement === null || targetElement === void 0 ? void 0 : targetElement.addEventListener)) {
      return;
    }
    var eventListener = function eventListener2(event) {
      return handlerRef.current(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return function() {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d2, b2) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b3) {
    d3.__proto__ = b3;
  } || function(d3, b3) {
    for (var p2 in b3)
      if (Object.prototype.hasOwnProperty.call(b3, p2))
        d3[p2] = b3[p2];
  };
  return extendStatics(d2, b2);
};
function __extends(d2, b2) {
  if (typeof b2 !== "function" && b2 !== null)
    throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
  extendStatics(d2, b2);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
}
var Browser = function() {
  function Browser2() {
    this.firefox = false;
    this.ie = false;
    this.edge = false;
    this.newEdge = false;
    this.weChat = false;
  }
  return Browser2;
}();
var Env = function() {
  function Env2() {
    this.browser = new Browser();
    this.node = false;
    this.wxa = false;
    this.worker = false;
    this.svgSupported = false;
    this.touchEventsSupported = false;
    this.pointerEventsSupported = false;
    this.domSupported = false;
    this.transformSupported = false;
    this.transform3dSupported = false;
    this.hasGlobalWindow = typeof window !== "undefined";
  }
  return Env2;
}();
var env = new Env();
if (typeof wx === "object" && typeof wx.getSystemInfoSync === "function") {
  env.wxa = true;
  env.touchEventsSupported = true;
} else if (typeof document === "undefined" && typeof self !== "undefined") {
  env.worker = true;
} else if (typeof navigator === "undefined") {
  env.node = true;
  env.svgSupported = true;
} else {
  detect(navigator.userAgent, env);
}
function detect(ua, env2) {
  var browser = env2.browser;
  var firefox = ua.match(/Firefox\/([\d.]+)/);
  var ie = ua.match(/MSIE\s([\d.]+)/) || ua.match(/Trident\/.+?rv:(([\d.]+))/);
  var edge = ua.match(/Edge?\/([\d.]+)/);
  var weChat = /micromessenger/i.test(ua);
  if (firefox) {
    browser.firefox = true;
    browser.version = firefox[1];
  }
  if (ie) {
    browser.ie = true;
    browser.version = ie[1];
  }
  if (edge) {
    browser.edge = true;
    browser.version = edge[1];
    browser.newEdge = +edge[1].split(".")[0] > 18;
  }
  if (weChat) {
    browser.weChat = true;
  }
  env2.svgSupported = typeof SVGRect !== "undefined";
  env2.touchEventsSupported = "ontouchstart" in window && !browser.ie && !browser.edge;
  env2.pointerEventsSupported = "onpointerdown" in window && (browser.edge || browser.ie && +browser.version >= 11);
  env2.domSupported = typeof document !== "undefined";
  var style = document.documentElement.style;
  env2.transform3dSupported = (browser.ie && "transition" in style || browser.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in style) && !("OTransition" in style);
  env2.transformSupported = env2.transform3dSupported || browser.ie && +browser.version >= 9;
}
var env$1 = env;
var DEFAULT_FONT_SIZE = 12;
var DEFAULT_FONT_FAMILY = "sans-serif";
var DEFAULT_FONT = DEFAULT_FONT_SIZE + "px " + DEFAULT_FONT_FAMILY;
var OFFSET = 20;
var SCALE = 100;
var defaultWidthMapStr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
function getTextWidthMap(mapStr) {
  var map2 = {};
  if (typeof JSON === "undefined") {
    return map2;
  }
  for (var i = 0; i < mapStr.length; i++) {
    var char = String.fromCharCode(i + 32);
    var size = (mapStr.charCodeAt(i) - OFFSET) / SCALE;
    map2[char] = size;
  }
  return map2;
}
var DEFAULT_TEXT_WIDTH_MAP = getTextWidthMap(defaultWidthMapStr);
var platformApi = {
  createCanvas: function() {
    return typeof document !== "undefined" && document.createElement("canvas");
  },
  measureText: function() {
    var _ctx;
    var _cachedFont;
    return function(text, font) {
      if (!_ctx) {
        var canvas = platformApi.createCanvas();
        _ctx = canvas && canvas.getContext("2d");
      }
      if (_ctx) {
        if (_cachedFont !== font) {
          _cachedFont = _ctx.font = font || DEFAULT_FONT;
        }
        return _ctx.measureText(text);
      } else {
        text = text || "";
        font = font || DEFAULT_FONT;
        var res = /^([0-9]*?)px$/.exec(font);
        var fontSize = +(res && res[1]) || DEFAULT_FONT_SIZE;
        var width = 0;
        if (font.indexOf("mono") >= 0) {
          width = fontSize * text.length;
        } else {
          for (var i = 0; i < text.length; i++) {
            var preCalcWidth = DEFAULT_TEXT_WIDTH_MAP[text[i]];
            width += preCalcWidth == null ? fontSize : preCalcWidth * fontSize;
          }
        }
        return { width };
      }
    };
  }(),
  loadImage: function(src, onload, onerror) {
    var image = new Image();
    image.onload = onload;
    image.onerror = onerror;
    image.src = src;
    return image;
  }
};
var BUILTIN_OBJECT = reduce([
  "Function",
  "RegExp",
  "Date",
  "Error",
  "CanvasGradient",
  "CanvasPattern",
  "Image",
  "Canvas"
], function(obj, val) {
  obj["[object " + val + "]"] = true;
  return obj;
}, {});
var TYPED_ARRAY = reduce([
  "Int8",
  "Uint8",
  "Uint8Clamped",
  "Int16",
  "Uint16",
  "Int32",
  "Uint32",
  "Float32",
  "Float64"
], function(obj, val) {
  obj["[object " + val + "Array]"] = true;
  return obj;
}, {});
var objToString = Object.prototype.toString;
var arrayProto = Array.prototype;
var nativeForEach = arrayProto.forEach;
var nativeFilter = arrayProto.filter;
var nativeSlice = arrayProto.slice;
var nativeMap = arrayProto.map;
var ctorFunction = function() {
}.constructor;
var protoFunction = ctorFunction ? ctorFunction.prototype : null;
var protoKey = "__proto__";
var idStart = 2311;
function guid() {
  return idStart++;
}
function logError() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  if (typeof console !== "undefined") {
    console.error.apply(console, args);
  }
}
function clone$4(source) {
  if (source == null || typeof source !== "object") {
    return source;
  }
  var result = source;
  var typeStr = objToString.call(source);
  if (typeStr === "[object Array]") {
    if (!isPrimitive(source)) {
      result = [];
      for (var i = 0, len2 = source.length; i < len2; i++) {
        result[i] = clone$4(source[i]);
      }
    }
  } else if (TYPED_ARRAY[typeStr]) {
    if (!isPrimitive(source)) {
      var Ctor = source.constructor;
      if (Ctor.from) {
        result = Ctor.from(source);
      } else {
        result = new Ctor(source.length);
        for (var i = 0, len2 = source.length; i < len2; i++) {
          result[i] = source[i];
        }
      }
    }
  } else if (!BUILTIN_OBJECT[typeStr] && !isPrimitive(source) && !isDom(source)) {
    result = {};
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        result[key] = clone$4(source[key]);
      }
    }
  }
  return result;
}
function merge(target, source, overwrite) {
  if (!isObject$4(source) || !isObject$4(target)) {
    return overwrite ? clone$4(source) : target;
  }
  for (var key in source) {
    if (source.hasOwnProperty(key) && key !== protoKey) {
      var targetProp = target[key];
      var sourceProp = source[key];
      if (isObject$4(sourceProp) && isObject$4(targetProp) && !isArray$1(sourceProp) && !isArray$1(targetProp) && !isDom(sourceProp) && !isDom(targetProp) && !isBuiltInObject(sourceProp) && !isBuiltInObject(targetProp) && !isPrimitive(sourceProp) && !isPrimitive(targetProp)) {
        merge(targetProp, sourceProp, overwrite);
      } else if (overwrite || !(key in target)) {
        target[key] = clone$4(source[key]);
      }
    }
  }
  return target;
}
function mergeAll(targetAndSources, overwrite) {
  var result = targetAndSources[0];
  for (var i = 1, len2 = targetAndSources.length; i < len2; i++) {
    result = merge(result, targetAndSources[i], overwrite);
  }
  return result;
}
function extend(target, source) {
  if (Object.assign) {
    Object.assign(target, source);
  } else {
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        target[key] = source[key];
      }
    }
  }
  return target;
}
function defaults(target, source, overlay) {
  var keysArr = keys(source);
  for (var i = 0; i < keysArr.length; i++) {
    var key = keysArr[i];
    if (overlay ? source[key] != null : target[key] == null) {
      target[key] = source[key];
    }
  }
  return target;
}
platformApi.createCanvas;
function indexOf(array4, value) {
  if (array4) {
    if (array4.indexOf) {
      return array4.indexOf(value);
    }
    for (var i = 0, len2 = array4.length; i < len2; i++) {
      if (array4[i] === value) {
        return i;
      }
    }
  }
  return -1;
}
function inherits(clazz, baseClazz) {
  var clazzPrototype = clazz.prototype;
  function F() {
  }
  F.prototype = baseClazz.prototype;
  clazz.prototype = new F();
  for (var prop in clazzPrototype) {
    if (clazzPrototype.hasOwnProperty(prop)) {
      clazz.prototype[prop] = clazzPrototype[prop];
    }
  }
  clazz.prototype.constructor = clazz;
  clazz.superClass = baseClazz;
}
function mixin(target, source, override) {
  target = "prototype" in target ? target.prototype : target;
  source = "prototype" in source ? source.prototype : source;
  if (Object.getOwnPropertyNames) {
    var keyList = Object.getOwnPropertyNames(source);
    for (var i = 0; i < keyList.length; i++) {
      var key = keyList[i];
      if (key !== "constructor") {
        if (override ? source[key] != null : target[key] == null) {
          target[key] = source[key];
        }
      }
    }
  } else {
    defaults(target, source, override);
  }
}
function isArrayLike(data) {
  if (!data) {
    return false;
  }
  if (typeof data === "string") {
    return false;
  }
  return typeof data.length === "number";
}
function each$f(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  if (arr.forEach && arr.forEach === nativeForEach) {
    arr.forEach(cb, context);
  } else if (arr.length === +arr.length) {
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      cb.call(context, arr[i], i, arr);
    }
  } else {
    for (var key in arr) {
      if (arr.hasOwnProperty(key)) {
        cb.call(context, arr[key], key, arr);
      }
    }
  }
}
function map$1(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.map && arr.map === nativeMap) {
    return arr.map(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      result.push(cb.call(context, arr[i], i, arr));
    }
    return result;
  }
}
function reduce(arr, cb, memo, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    memo = cb.call(context, memo, arr[i], i, arr);
  }
  return memo;
}
function filter(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.filter && arr.filter === nativeFilter) {
    return arr.filter(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      if (cb.call(context, arr[i], i, arr)) {
        result.push(arr[i]);
      }
    }
    return result;
  }
}
function find(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    if (cb.call(context, arr[i], i, arr)) {
      return arr[i];
    }
  }
}
function keys(obj) {
  if (!obj) {
    return [];
  }
  if (Object.keys) {
    return Object.keys(obj);
  }
  var keyList = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      keyList.push(key);
    }
  }
  return keyList;
}
function bindPolyfill(func, context) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return function() {
    return func.apply(context, args.concat(nativeSlice.call(arguments)));
  };
}
var bind$1 = protoFunction && isFunction(protoFunction.bind) ? protoFunction.call.bind(protoFunction.bind) : bindPolyfill;
function curry$1(func) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return function() {
    return func.apply(this, args.concat(nativeSlice.call(arguments)));
  };
}
function isArray$1(value) {
  if (Array.isArray) {
    return Array.isArray(value);
  }
  return objToString.call(value) === "[object Array]";
}
function isFunction(value) {
  return typeof value === "function";
}
function isString(value) {
  return typeof value === "string";
}
function isStringSafe(value) {
  return objToString.call(value) === "[object String]";
}
function isNumber(value) {
  return typeof value === "number";
}
function isObject$4(value) {
  var type4 = typeof value;
  return type4 === "function" || !!value && type4 === "object";
}
function isBuiltInObject(value) {
  return !!BUILTIN_OBJECT[objToString.call(value)];
}
function isTypedArray(value) {
  return !!TYPED_ARRAY[objToString.call(value)];
}
function isDom(value) {
  return typeof value === "object" && typeof value.nodeType === "number" && typeof value.ownerDocument === "object";
}
function isGradientObject(value) {
  return value.colorStops != null;
}
function isImagePatternObject(value) {
  return value.image != null;
}
function isRegExp(value) {
  return objToString.call(value) === "[object RegExp]";
}
function eqNaN(value) {
  return value !== value;
}
function retrieve() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  for (var i = 0, len2 = args.length; i < len2; i++) {
    if (args[i] != null) {
      return args[i];
    }
  }
}
function retrieve2(value0, value1) {
  return value0 != null ? value0 : value1;
}
function retrieve3(value0, value1, value2) {
  return value0 != null ? value0 : value1 != null ? value1 : value2;
}
function slice(arr) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return nativeSlice.apply(arr, args);
}
function normalizeCssArray$1(val) {
  if (typeof val === "number") {
    return [val, val, val, val];
  }
  var len2 = val.length;
  if (len2 === 2) {
    return [val[0], val[1], val[0], val[1]];
  } else if (len2 === 3) {
    return [val[0], val[1], val[2], val[1]];
  }
  return val;
}
function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}
function trim$1(str) {
  if (str == null) {
    return null;
  } else if (typeof str.trim === "function") {
    return str.trim();
  } else {
    return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
}
var primitiveKey = "__ec_primitive__";
function setAsPrimitive(obj) {
  obj[primitiveKey] = true;
}
function isPrimitive(obj) {
  return obj[primitiveKey];
}
var HashMap = function() {
  function HashMap2(obj) {
    this.data = {};
    var isArr = isArray$1(obj);
    this.data = {};
    var thisMap = this;
    obj instanceof HashMap2 ? obj.each(visit) : obj && each$f(obj, visit);
    function visit(value, key) {
      isArr ? thisMap.set(value, key) : thisMap.set(key, value);
    }
  }
  HashMap2.prototype.get = function(key) {
    return this.data.hasOwnProperty(key) ? this.data[key] : null;
  };
  HashMap2.prototype.set = function(key, value) {
    return this.data[key] = value;
  };
  HashMap2.prototype.each = function(cb, context) {
    for (var key in this.data) {
      if (this.data.hasOwnProperty(key)) {
        cb.call(context, this.data[key], key);
      }
    }
  };
  HashMap2.prototype.keys = function() {
    return keys(this.data);
  };
  HashMap2.prototype.removeKey = function(key) {
    delete this.data[key];
  };
  return HashMap2;
}();
function createHashMap(obj) {
  return new HashMap(obj);
}
function concatArray(a, b2) {
  var newArray = new a.constructor(a.length + b2.length);
  for (var i = 0; i < a.length; i++) {
    newArray[i] = a[i];
  }
  var offset = a.length;
  for (var i = 0; i < b2.length; i++) {
    newArray[i + offset] = b2[i];
  }
  return newArray;
}
function createObject(proto2, properties) {
  var obj;
  if (Object.create) {
    obj = Object.create(proto2);
  } else {
    var StyleCtor = function() {
    };
    StyleCtor.prototype = proto2;
    obj = new StyleCtor();
  }
  if (properties) {
    extend(obj, properties);
  }
  return obj;
}
function disableUserSelect(dom) {
  var domStyle = dom.style;
  domStyle.webkitUserSelect = "none";
  domStyle.userSelect = "none";
  domStyle.webkitTapHighlightColor = "rgba(0,0,0,0)";
  domStyle["-webkit-touch-callout"] = "none";
}
function hasOwn(own, prop) {
  return own.hasOwnProperty(prop);
}
function noop() {
}
var RADIAN_TO_DEGREE = 180 / Math.PI;
function create$2(x2, y2) {
  if (x2 == null) {
    x2 = 0;
  }
  if (y2 == null) {
    y2 = 0;
  }
  return [x2, y2];
}
function copy$1(out2, v4) {
  out2[0] = v4[0];
  out2[1] = v4[1];
  return out2;
}
function clone$3(v4) {
  return [v4[0], v4[1]];
}
function set$2(out2, a, b2) {
  out2[0] = a;
  out2[1] = b2;
  return out2;
}
function add(out2, v12, v22) {
  out2[0] = v12[0] + v22[0];
  out2[1] = v12[1] + v22[1];
  return out2;
}
function scaleAndAdd$1(out2, v12, v22, a) {
  out2[0] = v12[0] + v22[0] * a;
  out2[1] = v12[1] + v22[1] * a;
  return out2;
}
function sub(out2, v12, v22) {
  out2[0] = v12[0] - v22[0];
  out2[1] = v12[1] - v22[1];
  return out2;
}
function len(v4) {
  return Math.sqrt(lenSquare(v4));
}
function lenSquare(v4) {
  return v4[0] * v4[0] + v4[1] * v4[1];
}
function scale$2(out2, v4, s) {
  out2[0] = v4[0] * s;
  out2[1] = v4[1] * s;
  return out2;
}
function normalize$4(out2, v4) {
  var d2 = len(v4);
  if (d2 === 0) {
    out2[0] = 0;
    out2[1] = 0;
  } else {
    out2[0] = v4[0] / d2;
    out2[1] = v4[1] / d2;
  }
  return out2;
}
function distance(v12, v22) {
  return Math.sqrt((v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]));
}
var dist$1 = distance;
function distanceSquare(v12, v22) {
  return (v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]);
}
var distSquare = distanceSquare;
function lerp$1(out2, v12, v22, t2) {
  out2[0] = v12[0] + t2 * (v22[0] - v12[0]);
  out2[1] = v12[1] + t2 * (v22[1] - v12[1]);
  return out2;
}
function applyTransform$1(out2, v4, m2) {
  var x2 = v4[0];
  var y2 = v4[1];
  out2[0] = m2[0] * x2 + m2[2] * y2 + m2[4];
  out2[1] = m2[1] * x2 + m2[3] * y2 + m2[5];
  return out2;
}
function min$1(out2, v12, v22) {
  out2[0] = Math.min(v12[0], v22[0]);
  out2[1] = Math.min(v12[1], v22[1]);
  return out2;
}
function max$1(out2, v12, v22) {
  out2[0] = Math.max(v12[0], v22[0]);
  out2[1] = Math.max(v12[1], v22[1]);
  return out2;
}
var Param = function() {
  function Param2(target, e2) {
    this.target = target;
    this.topTarget = e2 && e2.topTarget;
  }
  return Param2;
}();
var Draggable = function() {
  function Draggable2(handler) {
    this.handler = handler;
    handler.on("mousedown", this._dragStart, this);
    handler.on("mousemove", this._drag, this);
    handler.on("mouseup", this._dragEnd, this);
  }
  Draggable2.prototype._dragStart = function(e2) {
    var draggingTarget = e2.target;
    while (draggingTarget && !draggingTarget.draggable) {
      draggingTarget = draggingTarget.parent || draggingTarget.__hostTarget;
    }
    if (draggingTarget) {
      this._draggingTarget = draggingTarget;
      draggingTarget.dragging = true;
      this._x = e2.offsetX;
      this._y = e2.offsetY;
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragstart", e2.event);
    }
  };
  Draggable2.prototype._drag = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      var x2 = e2.offsetX;
      var y2 = e2.offsetY;
      var dx = x2 - this._x;
      var dy = y2 - this._y;
      this._x = x2;
      this._y = y2;
      draggingTarget.drift(dx, dy, e2);
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "drag", e2.event);
      var dropTarget = this.handler.findHover(x2, y2, draggingTarget).target;
      var lastDropTarget = this._dropTarget;
      this._dropTarget = dropTarget;
      if (draggingTarget !== dropTarget) {
        if (lastDropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(lastDropTarget, e2), "dragleave", e2.event);
        }
        if (dropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(dropTarget, e2), "dragenter", e2.event);
        }
      }
    }
  };
  Draggable2.prototype._dragEnd = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      draggingTarget.dragging = false;
    }
    this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragend", e2.event);
    if (this._dropTarget) {
      this.handler.dispatchToElement(new Param(this._dropTarget, e2), "drop", e2.event);
    }
    this._draggingTarget = null;
    this._dropTarget = null;
  };
  return Draggable2;
}();
var Draggable$1 = Draggable;
var Eventful = function() {
  function Eventful2(eventProcessors) {
    if (eventProcessors) {
      this._$eventProcessor = eventProcessors;
    }
  }
  Eventful2.prototype.on = function(event, query, handler, context) {
    if (!this._$handlers) {
      this._$handlers = {};
    }
    var _h = this._$handlers;
    if (typeof query === "function") {
      context = handler;
      handler = query;
      query = null;
    }
    if (!handler || !event) {
      return this;
    }
    var eventProcessor = this._$eventProcessor;
    if (query != null && eventProcessor && eventProcessor.normalizeQuery) {
      query = eventProcessor.normalizeQuery(query);
    }
    if (!_h[event]) {
      _h[event] = [];
    }
    for (var i = 0; i < _h[event].length; i++) {
      if (_h[event][i].h === handler) {
        return this;
      }
    }
    var wrap = {
      h: handler,
      query,
      ctx: context || this,
      callAtLast: handler.zrEventfulCallAtLast
    };
    var lastIndex = _h[event].length - 1;
    var lastWrap = _h[event][lastIndex];
    lastWrap && lastWrap.callAtLast ? _h[event].splice(lastIndex, 0, wrap) : _h[event].push(wrap);
    return this;
  };
  Eventful2.prototype.isSilent = function(eventName) {
    var _h = this._$handlers;
    return !_h || !_h[eventName] || !_h[eventName].length;
  };
  Eventful2.prototype.off = function(eventType, handler) {
    var _h = this._$handlers;
    if (!_h) {
      return this;
    }
    if (!eventType) {
      this._$handlers = {};
      return this;
    }
    if (handler) {
      if (_h[eventType]) {
        var newList = [];
        for (var i = 0, l2 = _h[eventType].length; i < l2; i++) {
          if (_h[eventType][i].h !== handler) {
            newList.push(_h[eventType][i]);
          }
        }
        _h[eventType] = newList;
      }
      if (_h[eventType] && _h[eventType].length === 0) {
        delete _h[eventType];
      }
    } else {
      delete _h[eventType];
    }
    return this;
  };
  Eventful2.prototype.trigger = function(eventType) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[eventType];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(eventType, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(hItem.ctx);
            break;
          case 1:
            hItem.h.call(hItem.ctx, args[0]);
            break;
          case 2:
            hItem.h.call(hItem.ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(hItem.ctx, args);
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(eventType);
    return this;
  };
  Eventful2.prototype.triggerWithContext = function(type4) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[type4];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var ctx = args[argLen - 1];
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(type4, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(ctx);
            break;
          case 1:
            hItem.h.call(ctx, args[0]);
            break;
          case 2:
            hItem.h.call(ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(ctx, args.slice(1, argLen - 1));
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(type4);
    return this;
  };
  return Eventful2;
}();
var Eventful$1 = Eventful;
var LN2 = Math.log(2);
function determinant(rows, rank, rowStart, rowMask, colMask, detCache) {
  var cacheKey = rowMask + "-" + colMask;
  var fullRank = rows.length;
  if (detCache.hasOwnProperty(cacheKey)) {
    return detCache[cacheKey];
  }
  if (rank === 1) {
    var colStart = Math.round(Math.log((1 << fullRank) - 1 & ~colMask) / LN2);
    return rows[rowStart][colStart];
  }
  var subRowMask = rowMask | 1 << rowStart;
  var subRowStart = rowStart + 1;
  while (rowMask & 1 << subRowStart) {
    subRowStart++;
  }
  var sum2 = 0;
  for (var j = 0, colLocalIdx = 0; j < fullRank; j++) {
    var colTag = 1 << j;
    if (!(colTag & colMask)) {
      sum2 += (colLocalIdx % 2 ? -1 : 1) * rows[rowStart][j] * determinant(rows, rank - 1, subRowStart, subRowMask, colMask | colTag, detCache);
      colLocalIdx++;
    }
  }
  detCache[cacheKey] = sum2;
  return sum2;
}
function buildTransformer(src, dest) {
  var mA = [
    [src[0], src[1], 1, 0, 0, 0, -dest[0] * src[0], -dest[0] * src[1]],
    [0, 0, 0, src[0], src[1], 1, -dest[1] * src[0], -dest[1] * src[1]],
    [src[2], src[3], 1, 0, 0, 0, -dest[2] * src[2], -dest[2] * src[3]],
    [0, 0, 0, src[2], src[3], 1, -dest[3] * src[2], -dest[3] * src[3]],
    [src[4], src[5], 1, 0, 0, 0, -dest[4] * src[4], -dest[4] * src[5]],
    [0, 0, 0, src[4], src[5], 1, -dest[5] * src[4], -dest[5] * src[5]],
    [src[6], src[7], 1, 0, 0, 0, -dest[6] * src[6], -dest[6] * src[7]],
    [0, 0, 0, src[6], src[7], 1, -dest[7] * src[6], -dest[7] * src[7]]
  ];
  var detCache = {};
  var det = determinant(mA, 8, 0, 0, 0, detCache);
  if (det === 0) {
    return;
  }
  var vh = [];
  for (var i = 0; i < 8; i++) {
    for (var j = 0; j < 8; j++) {
      vh[j] == null && (vh[j] = 0);
      vh[j] += ((i + j) % 2 ? -1 : 1) * determinant(mA, 7, i === 0 ? 1 : 0, 1 << i, 1 << j, detCache) / det * dest[i];
    }
  }
  return function(out2, srcPointX, srcPointY) {
    var pk = srcPointX * vh[6] + srcPointY * vh[7] + 1;
    out2[0] = (srcPointX * vh[0] + srcPointY * vh[1] + vh[2]) / pk;
    out2[1] = (srcPointX * vh[3] + srcPointY * vh[4] + vh[5]) / pk;
  };
}
var EVENT_SAVED_PROP = "___zrEVENTSAVED";
var _calcOut$1 = [];
function transformLocalCoord(out2, elFrom, elTarget, inX, inY) {
  return transformCoordWithViewport(_calcOut$1, elFrom, inX, inY, true) && transformCoordWithViewport(out2, elTarget, _calcOut$1[0], _calcOut$1[1]);
}
function transformCoordWithViewport(out2, el, inX, inY, inverse) {
  if (el.getBoundingClientRect && env$1.domSupported && !isCanvasEl(el)) {
    var saved = el[EVENT_SAVED_PROP] || (el[EVENT_SAVED_PROP] = {});
    var markers = prepareCoordMarkers(el, saved);
    var transformer = preparePointerTransformer(markers, saved, inverse);
    if (transformer) {
      transformer(out2, inX, inY);
      return true;
    }
  }
  return false;
}
function prepareCoordMarkers(el, saved) {
  var markers = saved.markers;
  if (markers) {
    return markers;
  }
  markers = saved.markers = [];
  var propLR = ["left", "right"];
  var propTB = ["top", "bottom"];
  for (var i = 0; i < 4; i++) {
    var marker = document.createElement("div");
    var stl = marker.style;
    var idxLR = i % 2;
    var idxTB = (i >> 1) % 2;
    stl.cssText = [
      "position: absolute",
      "visibility: hidden",
      "padding: 0",
      "margin: 0",
      "border-width: 0",
      "user-select: none",
      "width:0",
      "height:0",
      propLR[idxLR] + ":0",
      propTB[idxTB] + ":0",
      propLR[1 - idxLR] + ":auto",
      propTB[1 - idxTB] + ":auto",
      ""
    ].join("!important;");
    el.appendChild(marker);
    markers.push(marker);
  }
  return markers;
}
function preparePointerTransformer(markers, saved, inverse) {
  var transformerName = inverse ? "invTrans" : "trans";
  var transformer = saved[transformerName];
  var oldSrcCoords = saved.srcCoords;
  var srcCoords = [];
  var destCoords = [];
  var oldCoordTheSame = true;
  for (var i = 0; i < 4; i++) {
    var rect = markers[i].getBoundingClientRect();
    var ii = 2 * i;
    var x2 = rect.left;
    var y2 = rect.top;
    srcCoords.push(x2, y2);
    oldCoordTheSame = oldCoordTheSame && oldSrcCoords && x2 === oldSrcCoords[ii] && y2 === oldSrcCoords[ii + 1];
    destCoords.push(markers[i].offsetLeft, markers[i].offsetTop);
  }
  return oldCoordTheSame && transformer ? transformer : (saved.srcCoords = srcCoords, saved[transformerName] = inverse ? buildTransformer(destCoords, srcCoords) : buildTransformer(srcCoords, destCoords));
}
function isCanvasEl(el) {
  return el.nodeName.toUpperCase() === "CANVAS";
}
var MOUSE_EVENT_REG = /^(?:mouse|pointer|contextmenu|drag|drop)|click/;
var _calcOut = [];
var firefoxNotSupportOffsetXY = env$1.browser.firefox && +env$1.browser.version.split(".")[0] < 39;
function clientToLocal(el, e2, out2, calculate) {
  out2 = out2 || {};
  if (calculate) {
    calculateZrXY(el, e2, out2);
  } else if (firefoxNotSupportOffsetXY && e2.layerX != null && e2.layerX !== e2.offsetX) {
    out2.zrX = e2.layerX;
    out2.zrY = e2.layerY;
  } else if (e2.offsetX != null) {
    out2.zrX = e2.offsetX;
    out2.zrY = e2.offsetY;
  } else {
    calculateZrXY(el, e2, out2);
  }
  return out2;
}
function calculateZrXY(el, e2, out2) {
  if (env$1.domSupported && el.getBoundingClientRect) {
    var ex = e2.clientX;
    var ey = e2.clientY;
    if (isCanvasEl(el)) {
      var box2 = el.getBoundingClientRect();
      out2.zrX = ex - box2.left;
      out2.zrY = ey - box2.top;
      return;
    } else {
      if (transformCoordWithViewport(_calcOut, el, ex, ey)) {
        out2.zrX = _calcOut[0];
        out2.zrY = _calcOut[1];
        return;
      }
    }
  }
  out2.zrX = out2.zrY = 0;
}
function getNativeEvent(e2) {
  return e2 || window.event;
}
function normalizeEvent(el, e2, calculate) {
  e2 = getNativeEvent(e2);
  if (e2.zrX != null) {
    return e2;
  }
  var eventType = e2.type;
  var isTouch = eventType && eventType.indexOf("touch") >= 0;
  if (!isTouch) {
    clientToLocal(el, e2, e2, calculate);
    var wheelDelta = getWheelDeltaMayPolyfill(e2);
    e2.zrDelta = wheelDelta ? wheelDelta / 120 : -(e2.detail || 0) / 3;
  } else {
    var touch = eventType !== "touchend" ? e2.targetTouches[0] : e2.changedTouches[0];
    touch && clientToLocal(el, touch, e2, calculate);
  }
  var button = e2.button;
  if (e2.which == null && button !== void 0 && MOUSE_EVENT_REG.test(e2.type)) {
    e2.which = button & 1 ? 1 : button & 2 ? 3 : button & 4 ? 2 : 0;
  }
  return e2;
}
function getWheelDeltaMayPolyfill(e2) {
  var rawWheelDelta = e2.wheelDelta;
  if (rawWheelDelta) {
    return rawWheelDelta;
  }
  var deltaX = e2.deltaX;
  var deltaY = e2.deltaY;
  if (deltaX == null || deltaY == null) {
    return rawWheelDelta;
  }
  var delta = deltaY !== 0 ? Math.abs(deltaY) : Math.abs(deltaX);
  var sign = deltaY > 0 ? -1 : deltaY < 0 ? 1 : deltaX > 0 ? -1 : 1;
  return 3 * delta * sign;
}
function addEventListener(el, name, handler, opt) {
  el.addEventListener(name, handler, opt);
}
function removeEventListener(el, name, handler, opt) {
  el.removeEventListener(name, handler, opt);
}
var stop = function(e2) {
  e2.preventDefault();
  e2.stopPropagation();
  e2.cancelBubble = true;
};
function isMiddleOrRightButtonOnMouseUpDown(e2) {
  return e2.which === 2 || e2.which === 3;
}
var GestureMgr = function() {
  function GestureMgr2() {
    this._track = [];
  }
  GestureMgr2.prototype.recognize = function(event, target, root2) {
    this._doTrack(event, target, root2);
    return this._recognize(event);
  };
  GestureMgr2.prototype.clear = function() {
    this._track.length = 0;
    return this;
  };
  GestureMgr2.prototype._doTrack = function(event, target, root2) {
    var touches = event.touches;
    if (!touches) {
      return;
    }
    var trackItem = {
      points: [],
      touches: [],
      target,
      event
    };
    for (var i = 0, len2 = touches.length; i < len2; i++) {
      var touch = touches[i];
      var pos = clientToLocal(root2, touch, {});
      trackItem.points.push([pos.zrX, pos.zrY]);
      trackItem.touches.push(touch);
    }
    this._track.push(trackItem);
  };
  GestureMgr2.prototype._recognize = function(event) {
    for (var eventName in recognizers) {
      if (recognizers.hasOwnProperty(eventName)) {
        var gestureInfo = recognizers[eventName](this._track, event);
        if (gestureInfo) {
          return gestureInfo;
        }
      }
    }
  };
  return GestureMgr2;
}();
function dist(pointPair) {
  var dx = pointPair[1][0] - pointPair[0][0];
  var dy = pointPair[1][1] - pointPair[0][1];
  return Math.sqrt(dx * dx + dy * dy);
}
function center$1(pointPair) {
  return [
    (pointPair[0][0] + pointPair[1][0]) / 2,
    (pointPair[0][1] + pointPair[1][1]) / 2
  ];
}
var recognizers = {
  pinch: function(tracks, event) {
    var trackLen = tracks.length;
    if (!trackLen) {
      return;
    }
    var pinchEnd = (tracks[trackLen - 1] || {}).points;
    var pinchPre = (tracks[trackLen - 2] || {}).points || pinchEnd;
    if (pinchPre && pinchPre.length > 1 && pinchEnd && pinchEnd.length > 1) {
      var pinchScale = dist(pinchEnd) / dist(pinchPre);
      !isFinite(pinchScale) && (pinchScale = 1);
      event.pinchScale = pinchScale;
      var pinchCenter = center$1(pinchEnd);
      event.pinchX = pinchCenter[0];
      event.pinchY = pinchCenter[1];
      return {
        type: "pinch",
        target: tracks[0].target,
        event
      };
    }
  }
};
var SILENT = "silent";
function makeEventPacket(eveType, targetInfo, event) {
  return {
    type: eveType,
    event,
    target: targetInfo.target,
    topTarget: targetInfo.topTarget,
    cancelBubble: false,
    offsetX: event.zrX,
    offsetY: event.zrY,
    gestureEvent: event.gestureEvent,
    pinchX: event.pinchX,
    pinchY: event.pinchY,
    pinchScale: event.pinchScale,
    wheelDelta: event.zrDelta,
    zrByTouch: event.zrByTouch,
    which: event.which,
    stop: stopEvent
  };
}
function stopEvent() {
  stop(this.event);
}
var EmptyProxy = function(_super) {
  __extends(EmptyProxy2, _super);
  function EmptyProxy2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.handler = null;
    return _this;
  }
  EmptyProxy2.prototype.dispose = function() {
  };
  EmptyProxy2.prototype.setCursor = function() {
  };
  return EmptyProxy2;
}(Eventful$1);
var HoveredResult = function() {
  function HoveredResult2(x2, y2) {
    this.x = x2;
    this.y = y2;
  }
  return HoveredResult2;
}();
var handlerNames = [
  "click",
  "dblclick",
  "mousewheel",
  "mouseout",
  "mouseup",
  "mousedown",
  "mousemove",
  "contextmenu"
];
var Handler = function(_super) {
  __extends(Handler2, _super);
  function Handler2(storage2, painter, proxy, painterRoot) {
    var _this = _super.call(this) || this;
    _this._hovered = new HoveredResult(0, 0);
    _this.storage = storage2;
    _this.painter = painter;
    _this.painterRoot = painterRoot;
    proxy = proxy || new EmptyProxy();
    _this.proxy = null;
    _this.setHandlerProxy(proxy);
    _this._draggingMgr = new Draggable$1(_this);
    return _this;
  }
  Handler2.prototype.setHandlerProxy = function(proxy) {
    if (this.proxy) {
      this.proxy.dispose();
    }
    if (proxy) {
      each$f(handlerNames, function(name) {
        proxy.on && proxy.on(name, this[name], this);
      }, this);
      proxy.handler = this;
    }
    this.proxy = proxy;
  };
  Handler2.prototype.mousemove = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var lastHovered = this._hovered;
    var lastHoveredTarget = lastHovered.target;
    if (lastHoveredTarget && !lastHoveredTarget.__zr) {
      lastHovered = this.findHover(lastHovered.x, lastHovered.y);
      lastHoveredTarget = lastHovered.target;
    }
    var hovered = this._hovered = isOutside ? new HoveredResult(x2, y2) : this.findHover(x2, y2);
    var hoveredTarget = hovered.target;
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(hoveredTarget ? hoveredTarget.cursor : "default");
    if (lastHoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(lastHovered, "mouseout", event);
    }
    this.dispatchToElement(hovered, "mousemove", event);
    if (hoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(hovered, "mouseover", event);
    }
  };
  Handler2.prototype.mouseout = function(event) {
    var eventControl = event.zrEventControl;
    if (eventControl !== "only_globalout") {
      this.dispatchToElement(this._hovered, "mouseout", event);
    }
    if (eventControl !== "no_globalout") {
      this.trigger("globalout", { type: "globalout", event });
    }
  };
  Handler2.prototype.resize = function() {
    this._hovered = new HoveredResult(0, 0);
  };
  Handler2.prototype.dispatch = function(eventName, eventArgs) {
    var handler = this[eventName];
    handler && handler.call(this, eventArgs);
  };
  Handler2.prototype.dispose = function() {
    this.proxy.dispose();
    this.storage = null;
    this.proxy = null;
    this.painter = null;
  };
  Handler2.prototype.setCursorStyle = function(cursorStyle) {
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(cursorStyle);
  };
  Handler2.prototype.dispatchToElement = function(targetInfo, eventName, event) {
    targetInfo = targetInfo || {};
    var el = targetInfo.target;
    if (el && el.silent) {
      return;
    }
    var eventKey = "on" + eventName;
    var eventPacket = makeEventPacket(eventName, targetInfo, event);
    while (el) {
      el[eventKey] && (eventPacket.cancelBubble = !!el[eventKey].call(el, eventPacket));
      el.trigger(eventName, eventPacket);
      el = el.__hostTarget ? el.__hostTarget : el.parent;
      if (eventPacket.cancelBubble) {
        break;
      }
    }
    if (!eventPacket.cancelBubble) {
      this.trigger(eventName, eventPacket);
      if (this.painter && this.painter.eachOtherLayer) {
        this.painter.eachOtherLayer(function(layer) {
          if (typeof layer[eventKey] === "function") {
            layer[eventKey].call(layer, eventPacket);
          }
          if (layer.trigger) {
            layer.trigger(eventName, eventPacket);
          }
        });
      }
    }
  };
  Handler2.prototype.findHover = function(x2, y2, exclude) {
    var list = this.storage.getDisplayList();
    var out2 = new HoveredResult(x2, y2);
    for (var i = list.length - 1; i >= 0; i--) {
      var hoverCheckResult = void 0;
      if (list[i] !== exclude && !list[i].ignore && (hoverCheckResult = isHover(list[i], x2, y2))) {
        !out2.topTarget && (out2.topTarget = list[i]);
        if (hoverCheckResult !== SILENT) {
          out2.target = list[i];
          break;
        }
      }
    }
    return out2;
  };
  Handler2.prototype.processGesture = function(event, stage) {
    if (!this._gestureMgr) {
      this._gestureMgr = new GestureMgr();
    }
    var gestureMgr = this._gestureMgr;
    stage === "start" && gestureMgr.clear();
    var gestureInfo = gestureMgr.recognize(event, this.findHover(event.zrX, event.zrY, null).target, this.proxy.dom);
    stage === "end" && gestureMgr.clear();
    if (gestureInfo) {
      var type4 = gestureInfo.type;
      event.gestureEvent = type4;
      var res = new HoveredResult();
      res.target = gestureInfo.target;
      this.dispatchToElement(res, type4, gestureInfo.event);
    }
  };
  return Handler2;
}(Eventful$1);
each$f(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(name) {
  Handler.prototype[name] = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var hovered;
    var hoveredTarget;
    if (name !== "mouseup" || !isOutside) {
      hovered = this.findHover(x2, y2);
      hoveredTarget = hovered.target;
    }
    if (name === "mousedown") {
      this._downEl = hoveredTarget;
      this._downPoint = [event.zrX, event.zrY];
      this._upEl = hoveredTarget;
    } else if (name === "mouseup") {
      this._upEl = hoveredTarget;
    } else if (name === "click") {
      if (this._downEl !== this._upEl || !this._downPoint || dist$1(this._downPoint, [event.zrX, event.zrY]) > 4) {
        return;
      }
      this._downPoint = null;
    }
    this.dispatchToElement(hovered, name, event);
  };
});
function isHover(displayable, x2, y2) {
  if (displayable[displayable.rectHover ? "rectContain" : "contain"](x2, y2)) {
    var el = displayable;
    var isSilent = void 0;
    var ignoreClip = false;
    while (el) {
      if (el.ignoreClip) {
        ignoreClip = true;
      }
      if (!ignoreClip) {
        var clipPath = el.getClipPath();
        if (clipPath && !clipPath.contain(x2, y2)) {
          return false;
        }
        if (el.silent) {
          isSilent = true;
        }
      }
      var hostEl = el.__hostTarget;
      el = hostEl ? hostEl : el.parent;
    }
    return isSilent ? SILENT : true;
  }
  return false;
}
function isOutsideBoundary(handlerInstance, x2, y2) {
  var painter = handlerInstance.painter;
  return x2 < 0 || x2 > painter.getWidth() || y2 < 0 || y2 > painter.getHeight();
}
var Handler$1 = Handler;
var DEFAULT_MIN_MERGE = 32;
var DEFAULT_MIN_GALLOPING = 7;
function minRunLength(n2) {
  var r2 = 0;
  while (n2 >= DEFAULT_MIN_MERGE) {
    r2 |= n2 & 1;
    n2 >>= 1;
  }
  return n2 + r2;
}
function makeAscendingRun(array4, lo, hi, compare2) {
  var runHi = lo + 1;
  if (runHi === hi) {
    return 1;
  }
  if (compare2(array4[runHi++], array4[lo]) < 0) {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) < 0) {
      runHi++;
    }
    reverseRun(array4, lo, runHi);
  } else {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) >= 0) {
      runHi++;
    }
  }
  return runHi - lo;
}
function reverseRun(array4, lo, hi) {
  hi--;
  while (lo < hi) {
    var t2 = array4[lo];
    array4[lo++] = array4[hi];
    array4[hi--] = t2;
  }
}
function binaryInsertionSort(array4, lo, hi, start2, compare2) {
  if (start2 === lo) {
    start2++;
  }
  for (; start2 < hi; start2++) {
    var pivot = array4[start2];
    var left = lo;
    var right = start2;
    var mid;
    while (left < right) {
      mid = left + right >>> 1;
      if (compare2(pivot, array4[mid]) < 0) {
        right = mid;
      } else {
        left = mid + 1;
      }
    }
    var n2 = start2 - left;
    switch (n2) {
      case 3:
        array4[left + 3] = array4[left + 2];
      case 2:
        array4[left + 2] = array4[left + 1];
      case 1:
        array4[left + 1] = array4[left];
        break;
      default:
        while (n2 > 0) {
          array4[left + n2] = array4[left + n2 - 1];
          n2--;
        }
    }
    array4[left] = pivot;
  }
}
function gallopLeft(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) > 0) {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) > 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  } else {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) <= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) > 0) {
      lastOffset = m2 + 1;
    } else {
      offset = m2;
    }
  }
  return offset;
}
function gallopRight(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) < 0) {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) < 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  } else {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) >= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) < 0) {
      offset = m2;
    } else {
      lastOffset = m2 + 1;
    }
  }
  return offset;
}
function TimSort(array4, compare2) {
  var minGallop = DEFAULT_MIN_GALLOPING;
  var runStart;
  var runLength;
  var stackSize = 0;
  var tmp = [];
  runStart = [];
  runLength = [];
  function pushRun(_runStart, _runLength) {
    runStart[stackSize] = _runStart;
    runLength[stackSize] = _runLength;
    stackSize += 1;
  }
  function mergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 >= 1 && runLength[n2 - 1] <= runLength[n2] + runLength[n2 + 1] || n2 >= 2 && runLength[n2 - 2] <= runLength[n2] + runLength[n2 - 1]) {
        if (runLength[n2 - 1] < runLength[n2 + 1]) {
          n2--;
        }
      } else if (runLength[n2] > runLength[n2 + 1]) {
        break;
      }
      mergeAt(n2);
    }
  }
  function forceMergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 > 0 && runLength[n2 - 1] < runLength[n2 + 1]) {
        n2--;
      }
      mergeAt(n2);
    }
  }
  function mergeAt(i) {
    var start1 = runStart[i];
    var length1 = runLength[i];
    var start2 = runStart[i + 1];
    var length2 = runLength[i + 1];
    runLength[i] = length1 + length2;
    if (i === stackSize - 3) {
      runStart[i + 1] = runStart[i + 2];
      runLength[i + 1] = runLength[i + 2];
    }
    stackSize--;
    var k2 = gallopRight(array4[start2], array4, start1, length1, 0, compare2);
    start1 += k2;
    length1 -= k2;
    if (length1 === 0) {
      return;
    }
    length2 = gallopLeft(array4[start1 + length1 - 1], array4, start2, length2, length2 - 1, compare2);
    if (length2 === 0) {
      return;
    }
    if (length1 <= length2) {
      mergeLow(start1, length1, start2, length2);
    } else {
      mergeHigh(start1, length1, start2, length2);
    }
  }
  function mergeLow(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length1; i++) {
      tmp[i] = array4[start1 + i];
    }
    var cursor1 = 0;
    var cursor2 = start2;
    var dest = start1;
    array4[dest++] = array4[cursor2++];
    if (--length2 === 0) {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
      return;
    }
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
      return;
    }
    var _minGallop = minGallop;
    var count1;
    var count2;
    var exit;
    while (1) {
      count1 = 0;
      count2 = 0;
      exit = false;
      do {
        if (compare2(array4[cursor2], tmp[cursor1]) < 0) {
          array4[dest++] = array4[cursor2++];
          count2++;
          count1 = 0;
          if (--length2 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest++] = tmp[cursor1++];
          count1++;
          count2 = 0;
          if (--length1 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = gallopRight(array4[cursor2], tmp, cursor1, length1, 0, compare2);
        if (count1 !== 0) {
          for (i = 0; i < count1; i++) {
            array4[dest + i] = tmp[cursor1 + i];
          }
          dest += count1;
          cursor1 += count1;
          length1 -= count1;
          if (length1 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest++] = array4[cursor2++];
        if (--length2 === 0) {
          exit = true;
          break;
        }
        count2 = gallopLeft(tmp[cursor1], array4, cursor2, length2, 0, compare2);
        if (count2 !== 0) {
          for (i = 0; i < count2; i++) {
            array4[dest + i] = array4[cursor2 + i];
          }
          dest += count2;
          cursor2 += count2;
          length2 -= count2;
          if (length2 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest++] = tmp[cursor1++];
        if (--length1 === 1) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    minGallop < 1 && (minGallop = 1);
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
    } else if (length1 === 0) {
      throw new Error();
    } else {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
    }
  }
  function mergeHigh(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length2; i++) {
      tmp[i] = array4[start2 + i];
    }
    var cursor1 = start1 + length1 - 1;
    var cursor2 = length2 - 1;
    var dest = start2 + length2 - 1;
    var customCursor = 0;
    var customDest = 0;
    array4[dest--] = array4[cursor1--];
    if (--length1 === 0) {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
      return;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
      return;
    }
    var _minGallop = minGallop;
    while (true) {
      var count1 = 0;
      var count2 = 0;
      var exit = false;
      do {
        if (compare2(tmp[cursor2], array4[cursor1]) < 0) {
          array4[dest--] = array4[cursor1--];
          count1++;
          count2 = 0;
          if (--length1 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest--] = tmp[cursor2--];
          count2++;
          count1 = 0;
          if (--length2 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = length1 - gallopRight(tmp[cursor2], array4, start1, length1, length1 - 1, compare2);
        if (count1 !== 0) {
          dest -= count1;
          cursor1 -= count1;
          length1 -= count1;
          customDest = dest + 1;
          customCursor = cursor1 + 1;
          for (i = count1 - 1; i >= 0; i--) {
            array4[customDest + i] = array4[customCursor + i];
          }
          if (length1 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest--] = tmp[cursor2--];
        if (--length2 === 1) {
          exit = true;
          break;
        }
        count2 = length2 - gallopLeft(array4[cursor1], tmp, 0, length2, length2 - 1, compare2);
        if (count2 !== 0) {
          dest -= count2;
          cursor2 -= count2;
          length2 -= count2;
          customDest = dest + 1;
          customCursor = cursor2 + 1;
          for (i = 0; i < count2; i++) {
            array4[customDest + i] = tmp[customCursor + i];
          }
          if (length2 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest--] = array4[cursor1--];
        if (--length1 === 0) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    if (minGallop < 1) {
      minGallop = 1;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
    } else if (length2 === 0) {
      throw new Error();
    } else {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
    }
  }
  return {
    mergeRuns,
    forceMergeRuns,
    pushRun
  };
}
function sort$2(array4, compare2, lo, hi) {
  if (!lo) {
    lo = 0;
  }
  if (!hi) {
    hi = array4.length;
  }
  var remaining = hi - lo;
  if (remaining < 2) {
    return;
  }
  var runLength = 0;
  if (remaining < DEFAULT_MIN_MERGE) {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    binaryInsertionSort(array4, lo, hi, lo + runLength, compare2);
    return;
  }
  var ts = TimSort(array4, compare2);
  var minRun = minRunLength(remaining);
  do {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    if (runLength < minRun) {
      var force = remaining;
      if (force > minRun) {
        force = minRun;
      }
      binaryInsertionSort(array4, lo, lo + force, lo + runLength, compare2);
      runLength = force;
    }
    ts.pushRun(lo, runLength);
    ts.mergeRuns();
    remaining -= runLength;
    lo += runLength;
  } while (remaining !== 0);
  ts.forceMergeRuns();
}
var REDRAW_BIT = 1;
var STYLE_CHANGED_BIT = 2;
var SHAPE_CHANGED_BIT = 4;
var invalidZErrorLogged = false;
function logInvalidZError() {
  if (invalidZErrorLogged) {
    return;
  }
  invalidZErrorLogged = true;
  console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors");
}
function shapeCompareFunc(a, b2) {
  if (a.zlevel === b2.zlevel) {
    if (a.z === b2.z) {
      return a.z2 - b2.z2;
    }
    return a.z - b2.z;
  }
  return a.zlevel - b2.zlevel;
}
var Storage = function() {
  function Storage2() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    this.displayableSortFunc = shapeCompareFunc;
  }
  Storage2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._roots.length; i++) {
      this._roots[i].traverse(cb, context);
    }
  };
  Storage2.prototype.getDisplayList = function(update, includeIgnore) {
    includeIgnore = includeIgnore || false;
    var displayList = this._displayList;
    if (update || !displayList.length) {
      this.updateDisplayList(includeIgnore);
    }
    return displayList;
  };
  Storage2.prototype.updateDisplayList = function(includeIgnore) {
    this._displayListLen = 0;
    var roots2 = this._roots;
    var displayList = this._displayList;
    for (var i = 0, len2 = roots2.length; i < len2; i++) {
      this._updateAndAddDisplayable(roots2[i], null, includeIgnore);
    }
    displayList.length = this._displayListLen;
    sort$2(displayList, shapeCompareFunc);
  };
  Storage2.prototype._updateAndAddDisplayable = function(el, clipPaths, includeIgnore) {
    if (el.ignore && !includeIgnore) {
      return;
    }
    el.beforeUpdate();
    el.update();
    el.afterUpdate();
    var userSetClipPath = el.getClipPath();
    if (el.ignoreClip) {
      clipPaths = null;
    } else if (userSetClipPath) {
      if (clipPaths) {
        clipPaths = clipPaths.slice();
      } else {
        clipPaths = [];
      }
      var currentClipPath = userSetClipPath;
      var parentClipPath = el;
      while (currentClipPath) {
        currentClipPath.parent = parentClipPath;
        currentClipPath.updateTransform();
        clipPaths.push(currentClipPath);
        parentClipPath = currentClipPath;
        currentClipPath = currentClipPath.getClipPath();
      }
    }
    if (el.childrenRef) {
      var children = el.childrenRef();
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (el.__dirty) {
          child.__dirty |= REDRAW_BIT;
        }
        this._updateAndAddDisplayable(child, clipPaths, includeIgnore);
      }
      el.__dirty = 0;
    } else {
      var disp = el;
      if (clipPaths && clipPaths.length) {
        disp.__clipPaths = clipPaths;
      } else if (disp.__clipPaths && disp.__clipPaths.length > 0) {
        disp.__clipPaths = [];
      }
      if (isNaN(disp.z)) {
        logInvalidZError();
        disp.z = 0;
      }
      if (isNaN(disp.z2)) {
        logInvalidZError();
        disp.z2 = 0;
      }
      if (isNaN(disp.zlevel)) {
        logInvalidZError();
        disp.zlevel = 0;
      }
      this._displayList[this._displayListLen++] = disp;
    }
    var decalEl = el.getDecalElement && el.getDecalElement();
    if (decalEl) {
      this._updateAndAddDisplayable(decalEl, clipPaths, includeIgnore);
    }
    var textGuide = el.getTextGuideLine();
    if (textGuide) {
      this._updateAndAddDisplayable(textGuide, clipPaths, includeIgnore);
    }
    var textEl = el.getTextContent();
    if (textEl) {
      this._updateAndAddDisplayable(textEl, clipPaths, includeIgnore);
    }
  };
  Storage2.prototype.addRoot = function(el) {
    if (el.__zr && el.__zr.storage === this) {
      return;
    }
    this._roots.push(el);
  };
  Storage2.prototype.delRoot = function(el) {
    if (el instanceof Array) {
      for (var i = 0, l2 = el.length; i < l2; i++) {
        this.delRoot(el[i]);
      }
      return;
    }
    var idx = indexOf(this._roots, el);
    if (idx >= 0) {
      this._roots.splice(idx, 1);
    }
  };
  Storage2.prototype.delAllRoots = function() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    return;
  };
  Storage2.prototype.getRoots = function() {
    return this._roots;
  };
  Storage2.prototype.dispose = function() {
    this._displayList = null;
    this._roots = null;
  };
  return Storage2;
}();
var Storage$1 = Storage;
var requestAnimationFrame$1;
requestAnimationFrame$1 = env$1.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(func) {
  return setTimeout(func, 16);
};
var requestAnimationFrame$2 = requestAnimationFrame$1;
var easingFuncs = {
  linear: function(k2) {
    return k2;
  },
  quadraticIn: function(k2) {
    return k2 * k2;
  },
  quadraticOut: function(k2) {
    return k2 * (2 - k2);
  },
  quadraticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2;
    }
    return -0.5 * (--k2 * (k2 - 2) - 1);
  },
  cubicIn: function(k2) {
    return k2 * k2 * k2;
  },
  cubicOut: function(k2) {
    return --k2 * k2 * k2 + 1;
  },
  cubicInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 + 2);
  },
  quarticIn: function(k2) {
    return k2 * k2 * k2 * k2;
  },
  quarticOut: function(k2) {
    return 1 - --k2 * k2 * k2 * k2;
  },
  quarticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2;
    }
    return -0.5 * ((k2 -= 2) * k2 * k2 * k2 - 2);
  },
  quinticIn: function(k2) {
    return k2 * k2 * k2 * k2 * k2;
  },
  quinticOut: function(k2) {
    return --k2 * k2 * k2 * k2 * k2 + 1;
  },
  quinticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 * k2 * k2 + 2);
  },
  sinusoidalIn: function(k2) {
    return 1 - Math.cos(k2 * Math.PI / 2);
  },
  sinusoidalOut: function(k2) {
    return Math.sin(k2 * Math.PI / 2);
  },
  sinusoidalInOut: function(k2) {
    return 0.5 * (1 - Math.cos(Math.PI * k2));
  },
  exponentialIn: function(k2) {
    return k2 === 0 ? 0 : Math.pow(1024, k2 - 1);
  },
  exponentialOut: function(k2) {
    return k2 === 1 ? 1 : 1 - Math.pow(2, -10 * k2);
  },
  exponentialInOut: function(k2) {
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if ((k2 *= 2) < 1) {
      return 0.5 * Math.pow(1024, k2 - 1);
    }
    return 0.5 * (-Math.pow(2, -10 * (k2 - 1)) + 2);
  },
  circularIn: function(k2) {
    return 1 - Math.sqrt(1 - k2 * k2);
  },
  circularOut: function(k2) {
    return Math.sqrt(1 - --k2 * k2);
  },
  circularInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return -0.5 * (Math.sqrt(1 - k2 * k2) - 1);
    }
    return 0.5 * (Math.sqrt(1 - (k2 -= 2) * k2) + 1);
  },
  elasticIn: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return -(a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
  },
  elasticOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return a * Math.pow(2, -10 * k2) * Math.sin((k2 - s) * (2 * Math.PI) / p2) + 1;
  },
  elasticInOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    if ((k2 *= 2) < 1) {
      return -0.5 * (a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
    }
    return a * Math.pow(2, -10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2) * 0.5 + 1;
  },
  backIn: function(k2) {
    var s = 1.70158;
    return k2 * k2 * ((s + 1) * k2 - s);
  },
  backOut: function(k2) {
    var s = 1.70158;
    return --k2 * k2 * ((s + 1) * k2 + s) + 1;
  },
  backInOut: function(k2) {
    var s = 1.70158 * 1.525;
    if ((k2 *= 2) < 1) {
      return 0.5 * (k2 * k2 * ((s + 1) * k2 - s));
    }
    return 0.5 * ((k2 -= 2) * k2 * ((s + 1) * k2 + s) + 2);
  },
  bounceIn: function(k2) {
    return 1 - easingFuncs.bounceOut(1 - k2);
  },
  bounceOut: function(k2) {
    if (k2 < 1 / 2.75) {
      return 7.5625 * k2 * k2;
    } else if (k2 < 2 / 2.75) {
      return 7.5625 * (k2 -= 1.5 / 2.75) * k2 + 0.75;
    } else if (k2 < 2.5 / 2.75) {
      return 7.5625 * (k2 -= 2.25 / 2.75) * k2 + 0.9375;
    } else {
      return 7.5625 * (k2 -= 2.625 / 2.75) * k2 + 0.984375;
    }
  },
  bounceInOut: function(k2) {
    if (k2 < 0.5) {
      return easingFuncs.bounceIn(k2 * 2) * 0.5;
    }
    return easingFuncs.bounceOut(k2 * 2 - 1) * 0.5 + 0.5;
  }
};
var easingFuncs$1 = easingFuncs;
var mathPow$2 = Math.pow;
var mathSqrt$3 = Math.sqrt;
var EPSILON$4 = 1e-8;
var EPSILON_NUMERIC = 1e-4;
var THREE_SQRT = mathSqrt$3(3);
var ONE_THIRD = 1 / 3;
var _v0 = create$2();
var _v1 = create$2();
var _v2 = create$2();
function isAroundZero$1(val) {
  return val > -EPSILON$4 && val < EPSILON$4;
}
function isNotAroundZero$1(val) {
  return val > EPSILON$4 || val < -EPSILON$4;
}
function cubicAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return onet * onet * (onet * p0 + 3 * t2 * p1) + t2 * t2 * (t2 * p3 + 3 * onet * p2);
}
function cubicDerivativeAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return 3 * (((p1 - p0) * onet + 2 * (p2 - p1) * t2) * onet + (p3 - p2) * t2 * t2);
}
function cubicRootAt(p0, p1, p2, p3, val, roots2) {
  var a = p3 + 3 * (p1 - p2) - p0;
  var b2 = 3 * (p2 - p1 * 2 + p0);
  var c2 = 3 * (p1 - p0);
  var d2 = p0 - val;
  var A2 = b2 * b2 - 3 * a * c2;
  var B = b2 * c2 - 9 * a * d2;
  var C = c2 * c2 - 3 * b2 * d2;
  var n2 = 0;
  if (isAroundZero$1(A2) && isAroundZero$1(B)) {
    if (isAroundZero$1(b2)) {
      roots2[0] = 0;
    } else {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = B * B - 4 * A2 * C;
    if (isAroundZero$1(disc)) {
      var K = B / A2;
      var t1 = -b2 / a + K;
      var t2 = -K / 2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var Y1 = A2 * b2 + 1.5 * a * (-B + discSqrt);
      var Y2 = A2 * b2 + 1.5 * a * (-B - discSqrt);
      if (Y1 < 0) {
        Y1 = -mathPow$2(-Y1, ONE_THIRD);
      } else {
        Y1 = mathPow$2(Y1, ONE_THIRD);
      }
      if (Y2 < 0) {
        Y2 = -mathPow$2(-Y2, ONE_THIRD);
      } else {
        Y2 = mathPow$2(Y2, ONE_THIRD);
      }
      var t1 = (-b2 - (Y1 + Y2)) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else {
      var T = (2 * A2 * b2 - 3 * a * B) / (2 * mathSqrt$3(A2 * A2 * A2));
      var theta = Math.acos(T) / 3;
      var ASqrt = mathSqrt$3(A2);
      var tmp = Math.cos(theta);
      var t1 = (-b2 - 2 * ASqrt * tmp) / (3 * a);
      var t2 = (-b2 + ASqrt * (tmp + THREE_SQRT * Math.sin(theta))) / (3 * a);
      var t3 = (-b2 + ASqrt * (tmp - THREE_SQRT * Math.sin(theta))) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
      if (t3 >= 0 && t3 <= 1) {
        roots2[n2++] = t3;
      }
    }
  }
  return n2;
}
function cubicExtrema(p0, p1, p2, p3, extrema2) {
  var b2 = 6 * p2 - 12 * p1 + 6 * p0;
  var a = 9 * p1 + 3 * p3 - 3 * p0 - 9 * p2;
  var c2 = 3 * p1 - 3 * p0;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      extrema2[0] = -b2 / (2 * a);
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        extrema2[n2++] = t2;
      }
    }
  }
  return n2;
}
function cubicSubdivide(p0, p1, p2, p3, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p23 = (p3 - p2) * t2 + p2;
  var p012 = (p12 - p01) * t2 + p01;
  var p123 = (p23 - p12) * t2 + p12;
  var p0123 = (p123 - p012) * t2 + p012;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p0123;
  out2[4] = p0123;
  out2[5] = p123;
  out2[6] = p23;
  out2[7] = p3;
}
function cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  var prev;
  var next;
  var d1;
  var d22;
  _v0[0] = x4;
  _v0[1] = y4;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = cubicAt(x0, x1, x2, x3, _t);
    _v1[1] = cubicAt(y0, y1, y2, y3, _t);
    d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    prev = t2 - interval;
    next = t2 + interval;
    _v1[0] = cubicAt(x0, x1, x2, x3, prev);
    _v1[1] = cubicAt(y0, y1, y2, y3, prev);
    d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = cubicAt(x0, x1, x2, x3, next);
      _v2[1] = cubicAt(y0, y1, y2, y3, next);
      d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = cubicAt(x0, x1, x2, x3, t2);
    out2[1] = cubicAt(y0, y1, y2, y3, t2);
  }
  return mathSqrt$3(d2);
}
function cubicLength(x0, y0, x1, y1, x2, y2, x3, y3, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x4 = cubicAt(x0, x1, x2, x3, t2);
    var y4 = cubicAt(y0, y1, y2, y3, t2);
    var dx = x4 - px;
    var dy = y4 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x4;
    py = y4;
  }
  return d2;
}
function quadraticAt$1(p0, p1, p2, t2) {
  var onet = 1 - t2;
  return onet * (onet * p0 + 2 * t2 * p1) + t2 * t2 * p2;
}
function quadraticDerivativeAt(p0, p1, p2, t2) {
  return 2 * ((1 - t2) * (p1 - p0) + t2 * (p2 - p1));
}
function quadraticRootAt(p0, p1, p2, val, roots2) {
  var a = p0 - 2 * p1 + p2;
  var b2 = 2 * (p1 - p0);
  var c2 = p0 - val;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      var t1 = -b2 / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    }
  }
  return n2;
}
function quadraticExtremum(p0, p1, p2) {
  var divider = p0 + p2 - 2 * p1;
  if (divider === 0) {
    return 0.5;
  } else {
    return (p0 - p1) / divider;
  }
}
function quadraticSubdivide(p0, p1, p2, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p012 = (p12 - p01) * t2 + p01;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p012;
  out2[4] = p12;
  out2[5] = p2;
}
function quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  _v0[0] = x3;
  _v0[1] = y3;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = quadraticAt$1(x0, x1, x2, _t);
    _v1[1] = quadraticAt$1(y0, y1, y2, _t);
    var d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    var prev = t2 - interval;
    var next = t2 + interval;
    _v1[0] = quadraticAt$1(x0, x1, x2, prev);
    _v1[1] = quadraticAt$1(y0, y1, y2, prev);
    var d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = quadraticAt$1(x0, x1, x2, next);
      _v2[1] = quadraticAt$1(y0, y1, y2, next);
      var d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = quadraticAt$1(x0, x1, x2, t2);
    out2[1] = quadraticAt$1(y0, y1, y2, t2);
  }
  return mathSqrt$3(d2);
}
function quadraticLength(x0, y0, x1, y1, x2, y2, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x3 = quadraticAt$1(x0, x1, x2, t2);
    var y3 = quadraticAt$1(y0, y1, y2, t2);
    var dx = x3 - px;
    var dy = y3 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x3;
    py = y3;
  }
  return d2;
}
var regexp$1 = /cubic-bezier\(([0-9,\.e ]+)\)/;
function createCubicEasingFunc(cubicEasingStr) {
  var cubic = cubicEasingStr && regexp$1.exec(cubicEasingStr);
  if (cubic) {
    var points2 = cubic[1].split(",");
    var a_1 = +trim$1(points2[0]);
    var b_1 = +trim$1(points2[1]);
    var c_1 = +trim$1(points2[2]);
    var d_1 = +trim$1(points2[3]);
    if (isNaN(a_1 + b_1 + c_1 + d_1)) {
      return;
    }
    var roots_1 = [];
    return function(p2) {
      return p2 <= 0 ? 0 : p2 >= 1 ? 1 : cubicRootAt(0, a_1, c_1, 1, p2, roots_1) && cubicAt(0, b_1, d_1, 1, roots_1[0]);
    };
  }
}
var Clip = function() {
  function Clip2(opts) {
    this._inited = false;
    this._startTime = 0;
    this._pausedTime = 0;
    this._paused = false;
    this._life = opts.life || 1e3;
    this._delay = opts.delay || 0;
    this.loop = opts.loop || false;
    this.onframe = opts.onframe || noop;
    this.ondestroy = opts.ondestroy || noop;
    this.onrestart = opts.onrestart || noop;
    opts.easing && this.setEasing(opts.easing);
  }
  Clip2.prototype.step = function(globalTime, deltaTime) {
    if (!this._inited) {
      this._startTime = globalTime + this._delay;
      this._inited = true;
    }
    if (this._paused) {
      this._pausedTime += deltaTime;
      return;
    }
    var life = this._life;
    var elapsedTime = globalTime - this._startTime - this._pausedTime;
    var percent = elapsedTime / life;
    if (percent < 0) {
      percent = 0;
    }
    percent = Math.min(percent, 1);
    var easingFunc = this.easingFunc;
    var schedule = easingFunc ? easingFunc(percent) : percent;
    this.onframe(schedule);
    if (percent === 1) {
      if (this.loop) {
        var remainder = elapsedTime % life;
        this._startTime = globalTime - remainder;
        this._pausedTime = 0;
        this.onrestart();
      } else {
        return true;
      }
    }
    return false;
  };
  Clip2.prototype.pause = function() {
    this._paused = true;
  };
  Clip2.prototype.resume = function() {
    this._paused = false;
  };
  Clip2.prototype.setEasing = function(easing) {
    this.easing = easing;
    this.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
  };
  return Clip2;
}();
var Clip$1 = Clip;
var Entry = function() {
  function Entry2(val) {
    this.value = val;
  }
  return Entry2;
}();
var LinkedList = function() {
  function LinkedList2() {
    this._len = 0;
  }
  LinkedList2.prototype.insert = function(val) {
    var entry = new Entry(val);
    this.insertEntry(entry);
    return entry;
  };
  LinkedList2.prototype.insertEntry = function(entry) {
    if (!this.head) {
      this.head = this.tail = entry;
    } else {
      this.tail.next = entry;
      entry.prev = this.tail;
      entry.next = null;
      this.tail = entry;
    }
    this._len++;
  };
  LinkedList2.prototype.remove = function(entry) {
    var prev = entry.prev;
    var next = entry.next;
    if (prev) {
      prev.next = next;
    } else {
      this.head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this.tail = prev;
    }
    entry.next = entry.prev = null;
    this._len--;
  };
  LinkedList2.prototype.len = function() {
    return this._len;
  };
  LinkedList2.prototype.clear = function() {
    this.head = this.tail = null;
    this._len = 0;
  };
  return LinkedList2;
}();
var LRU = function() {
  function LRU2(maxSize) {
    this._list = new LinkedList();
    this._maxSize = 10;
    this._map = {};
    this._maxSize = maxSize;
  }
  LRU2.prototype.put = function(key, value) {
    var list = this._list;
    var map2 = this._map;
    var removed = null;
    if (map2[key] == null) {
      var len2 = list.len();
      var entry = this._lastRemovedEntry;
      if (len2 >= this._maxSize && len2 > 0) {
        var leastUsedEntry = list.head;
        list.remove(leastUsedEntry);
        delete map2[leastUsedEntry.key];
        removed = leastUsedEntry.value;
        this._lastRemovedEntry = leastUsedEntry;
      }
      if (entry) {
        entry.value = value;
      } else {
        entry = new Entry(value);
      }
      entry.key = key;
      list.insertEntry(entry);
      map2[key] = entry;
    }
    return removed;
  };
  LRU2.prototype.get = function(key) {
    var entry = this._map[key];
    var list = this._list;
    if (entry != null) {
      if (entry !== list.tail) {
        list.remove(entry);
        list.insertEntry(entry);
      }
      return entry.value;
    }
  };
  LRU2.prototype.clear = function() {
    this._list.clear();
    this._map = {};
  };
  LRU2.prototype.len = function() {
    return this._list.len();
  };
  return LRU2;
}();
var LRU$1 = LRU;
var kCSSColorTable = {
  "transparent": [0, 0, 0, 0],
  "aliceblue": [240, 248, 255, 1],
  "antiquewhite": [250, 235, 215, 1],
  "aqua": [0, 255, 255, 1],
  "aquamarine": [127, 255, 212, 1],
  "azure": [240, 255, 255, 1],
  "beige": [245, 245, 220, 1],
  "bisque": [255, 228, 196, 1],
  "black": [0, 0, 0, 1],
  "blanchedalmond": [255, 235, 205, 1],
  "blue": [0, 0, 255, 1],
  "blueviolet": [138, 43, 226, 1],
  "brown": [165, 42, 42, 1],
  "burlywood": [222, 184, 135, 1],
  "cadetblue": [95, 158, 160, 1],
  "chartreuse": [127, 255, 0, 1],
  "chocolate": [210, 105, 30, 1],
  "coral": [255, 127, 80, 1],
  "cornflowerblue": [100, 149, 237, 1],
  "cornsilk": [255, 248, 220, 1],
  "crimson": [220, 20, 60, 1],
  "cyan": [0, 255, 255, 1],
  "darkblue": [0, 0, 139, 1],
  "darkcyan": [0, 139, 139, 1],
  "darkgoldenrod": [184, 134, 11, 1],
  "darkgray": [169, 169, 169, 1],
  "darkgreen": [0, 100, 0, 1],
  "darkgrey": [169, 169, 169, 1],
  "darkkhaki": [189, 183, 107, 1],
  "darkmagenta": [139, 0, 139, 1],
  "darkolivegreen": [85, 107, 47, 1],
  "darkorange": [255, 140, 0, 1],
  "darkorchid": [153, 50, 204, 1],
  "darkred": [139, 0, 0, 1],
  "darksalmon": [233, 150, 122, 1],
  "darkseagreen": [143, 188, 143, 1],
  "darkslateblue": [72, 61, 139, 1],
  "darkslategray": [47, 79, 79, 1],
  "darkslategrey": [47, 79, 79, 1],
  "darkturquoise": [0, 206, 209, 1],
  "darkviolet": [148, 0, 211, 1],
  "deeppink": [255, 20, 147, 1],
  "deepskyblue": [0, 191, 255, 1],
  "dimgray": [105, 105, 105, 1],
  "dimgrey": [105, 105, 105, 1],
  "dodgerblue": [30, 144, 255, 1],
  "firebrick": [178, 34, 34, 1],
  "floralwhite": [255, 250, 240, 1],
  "forestgreen": [34, 139, 34, 1],
  "fuchsia": [255, 0, 255, 1],
  "gainsboro": [220, 220, 220, 1],
  "ghostwhite": [248, 248, 255, 1],
  "gold": [255, 215, 0, 1],
  "goldenrod": [218, 165, 32, 1],
  "gray": [128, 128, 128, 1],
  "green": [0, 128, 0, 1],
  "greenyellow": [173, 255, 47, 1],
  "grey": [128, 128, 128, 1],
  "honeydew": [240, 255, 240, 1],
  "hotpink": [255, 105, 180, 1],
  "indianred": [205, 92, 92, 1],
  "indigo": [75, 0, 130, 1],
  "ivory": [255, 255, 240, 1],
  "khaki": [240, 230, 140, 1],
  "lavender": [230, 230, 250, 1],
  "lavenderblush": [255, 240, 245, 1],
  "lawngreen": [124, 252, 0, 1],
  "lemonchiffon": [255, 250, 205, 1],
  "lightblue": [173, 216, 230, 1],
  "lightcoral": [240, 128, 128, 1],
  "lightcyan": [224, 255, 255, 1],
  "lightgoldenrodyellow": [250, 250, 210, 1],
  "lightgray": [211, 211, 211, 1],
  "lightgreen": [144, 238, 144, 1],
  "lightgrey": [211, 211, 211, 1],
  "lightpink": [255, 182, 193, 1],
  "lightsalmon": [255, 160, 122, 1],
  "lightseagreen": [32, 178, 170, 1],
  "lightskyblue": [135, 206, 250, 1],
  "lightslategray": [119, 136, 153, 1],
  "lightslategrey": [119, 136, 153, 1],
  "lightsteelblue": [176, 196, 222, 1],
  "lightyellow": [255, 255, 224, 1],
  "lime": [0, 255, 0, 1],
  "limegreen": [50, 205, 50, 1],
  "linen": [250, 240, 230, 1],
  "magenta": [255, 0, 255, 1],
  "maroon": [128, 0, 0, 1],
  "mediumaquamarine": [102, 205, 170, 1],
  "mediumblue": [0, 0, 205, 1],
  "mediumorchid": [186, 85, 211, 1],
  "mediumpurple": [147, 112, 219, 1],
  "mediumseagreen": [60, 179, 113, 1],
  "mediumslateblue": [123, 104, 238, 1],
  "mediumspringgreen": [0, 250, 154, 1],
  "mediumturquoise": [72, 209, 204, 1],
  "mediumvioletred": [199, 21, 133, 1],
  "midnightblue": [25, 25, 112, 1],
  "mintcream": [245, 255, 250, 1],
  "mistyrose": [255, 228, 225, 1],
  "moccasin": [255, 228, 181, 1],
  "navajowhite": [255, 222, 173, 1],
  "navy": [0, 0, 128, 1],
  "oldlace": [253, 245, 230, 1],
  "olive": [128, 128, 0, 1],
  "olivedrab": [107, 142, 35, 1],
  "orange": [255, 165, 0, 1],
  "orangered": [255, 69, 0, 1],
  "orchid": [218, 112, 214, 1],
  "palegoldenrod": [238, 232, 170, 1],
  "palegreen": [152, 251, 152, 1],
  "paleturquoise": [175, 238, 238, 1],
  "palevioletred": [219, 112, 147, 1],
  "papayawhip": [255, 239, 213, 1],
  "peachpuff": [255, 218, 185, 1],
  "peru": [205, 133, 63, 1],
  "pink": [255, 192, 203, 1],
  "plum": [221, 160, 221, 1],
  "powderblue": [176, 224, 230, 1],
  "purple": [128, 0, 128, 1],
  "red": [255, 0, 0, 1],
  "rosybrown": [188, 143, 143, 1],
  "royalblue": [65, 105, 225, 1],
  "saddlebrown": [139, 69, 19, 1],
  "salmon": [250, 128, 114, 1],
  "sandybrown": [244, 164, 96, 1],
  "seagreen": [46, 139, 87, 1],
  "seashell": [255, 245, 238, 1],
  "sienna": [160, 82, 45, 1],
  "silver": [192, 192, 192, 1],
  "skyblue": [135, 206, 235, 1],
  "slateblue": [106, 90, 205, 1],
  "slategray": [112, 128, 144, 1],
  "slategrey": [112, 128, 144, 1],
  "snow": [255, 250, 250, 1],
  "springgreen": [0, 255, 127, 1],
  "steelblue": [70, 130, 180, 1],
  "tan": [210, 180, 140, 1],
  "teal": [0, 128, 128, 1],
  "thistle": [216, 191, 216, 1],
  "tomato": [255, 99, 71, 1],
  "turquoise": [64, 224, 208, 1],
  "violet": [238, 130, 238, 1],
  "wheat": [245, 222, 179, 1],
  "white": [255, 255, 255, 1],
  "whitesmoke": [245, 245, 245, 1],
  "yellow": [255, 255, 0, 1],
  "yellowgreen": [154, 205, 50, 1]
};
function clampCssByte(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 255 ? 255 : i;
}
function clampCssAngle(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 360 ? 360 : i;
}
function clampCssFloat(f2) {
  return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
}
function parseCssInt(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssByte(parseFloat(str) / 100 * 255);
  }
  return clampCssByte(parseInt(str, 10));
}
function parseCssFloat(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssFloat(parseFloat(str) / 100);
  }
  return clampCssFloat(parseFloat(str));
}
function cssHueToRgb(m1, m2, h) {
  if (h < 0) {
    h += 1;
  } else if (h > 1) {
    h -= 1;
  }
  if (h * 6 < 1) {
    return m1 + (m2 - m1) * h * 6;
  }
  if (h * 2 < 1) {
    return m2;
  }
  if (h * 3 < 2) {
    return m1 + (m2 - m1) * (2 / 3 - h) * 6;
  }
  return m1;
}
function lerpNumber(a, b2, p2) {
  return a + (b2 - a) * p2;
}
function setRgba(out2, r2, g2, b2, a) {
  out2[0] = r2;
  out2[1] = g2;
  out2[2] = b2;
  out2[3] = a;
  return out2;
}
function copyRgba(out2, a) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  return out2;
}
var colorCache = new LRU$1(20);
var lastRemovedArr = null;
function putToCache(colorStr, rgbaArr) {
  if (lastRemovedArr) {
    copyRgba(lastRemovedArr, rgbaArr);
  }
  lastRemovedArr = colorCache.put(colorStr, lastRemovedArr || rgbaArr.slice());
}
function parse(colorStr, rgbaArr) {
  if (!colorStr) {
    return;
  }
  rgbaArr = rgbaArr || [];
  var cached = colorCache.get(colorStr);
  if (cached) {
    return copyRgba(rgbaArr, cached);
  }
  colorStr = colorStr + "";
  var str = colorStr.replace(/ /g, "").toLowerCase();
  if (str in kCSSColorTable) {
    copyRgba(rgbaArr, kCSSColorTable[str]);
    putToCache(colorStr, rgbaArr);
    return rgbaArr;
  }
  var strLen = str.length;
  if (str.charAt(0) === "#") {
    if (strLen === 4 || strLen === 5) {
      var iv = parseInt(str.slice(1, 4), 16);
      if (!(iv >= 0 && iv <= 4095)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 3840) >> 4 | (iv & 3840) >> 8, iv & 240 | (iv & 240) >> 4, iv & 15 | (iv & 15) << 4, strLen === 5 ? parseInt(str.slice(4), 16) / 15 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    } else if (strLen === 7 || strLen === 9) {
      var iv = parseInt(str.slice(1, 7), 16);
      if (!(iv >= 0 && iv <= 16777215)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 16711680) >> 16, (iv & 65280) >> 8, iv & 255, strLen === 9 ? parseInt(str.slice(7), 16) / 255 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    }
    return;
  }
  var op = str.indexOf("(");
  var ep = str.indexOf(")");
  if (op !== -1 && ep + 1 === strLen) {
    var fname = str.substr(0, op);
    var params = str.substr(op + 1, ep - (op + 1)).split(",");
    var alpha = 1;
    switch (fname) {
      case "rgba":
        if (params.length !== 4) {
          return params.length === 3 ? setRgba(rgbaArr, +params[0], +params[1], +params[2], 1) : setRgba(rgbaArr, 0, 0, 0, 1);
        }
        alpha = parseCssFloat(params.pop());
      case "rgb":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        setRgba(rgbaArr, parseCssInt(params[0]), parseCssInt(params[1]), parseCssInt(params[2]), alpha);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsla":
        if (params.length !== 4) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        params[3] = parseCssFloat(params[3]);
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsl":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      default:
        return;
    }
  }
  setRgba(rgbaArr, 0, 0, 0, 1);
  return;
}
function hsla2rgba(hsla, rgba) {
  var h = (parseFloat(hsla[0]) % 360 + 360) % 360 / 360;
  var s = parseCssFloat(hsla[1]);
  var l2 = parseCssFloat(hsla[2]);
  var m2 = l2 <= 0.5 ? l2 * (s + 1) : l2 + s - l2 * s;
  var m1 = l2 * 2 - m2;
  rgba = rgba || [];
  setRgba(rgba, clampCssByte(cssHueToRgb(m1, m2, h + 1 / 3) * 255), clampCssByte(cssHueToRgb(m1, m2, h) * 255), clampCssByte(cssHueToRgb(m1, m2, h - 1 / 3) * 255), 1);
  if (hsla.length === 4) {
    rgba[3] = hsla[3];
  }
  return rgba;
}
function rgba2hsla(rgba) {
  if (!rgba) {
    return;
  }
  var R = rgba[0] / 255;
  var G = rgba[1] / 255;
  var B = rgba[2] / 255;
  var vMin = Math.min(R, G, B);
  var vMax = Math.max(R, G, B);
  var delta = vMax - vMin;
  var L = (vMax + vMin) / 2;
  var H;
  var S;
  if (delta === 0) {
    H = 0;
    S = 0;
  } else {
    if (L < 0.5) {
      S = delta / (vMax + vMin);
    } else {
      S = delta / (2 - vMax - vMin);
    }
    var deltaR = ((vMax - R) / 6 + delta / 2) / delta;
    var deltaG = ((vMax - G) / 6 + delta / 2) / delta;
    var deltaB = ((vMax - B) / 6 + delta / 2) / delta;
    if (R === vMax) {
      H = deltaB - deltaG;
    } else if (G === vMax) {
      H = 1 / 3 + deltaR - deltaB;
    } else if (B === vMax) {
      H = 2 / 3 + deltaG - deltaR;
    }
    if (H < 0) {
      H += 1;
    }
    if (H > 1) {
      H -= 1;
    }
  }
  var hsla = [H * 360, S, L];
  if (rgba[3] != null) {
    hsla.push(rgba[3]);
  }
  return hsla;
}
function lift(color, level) {
  var colorArr = parse(color);
  if (colorArr) {
    for (var i = 0; i < 3; i++) {
      if (level < 0) {
        colorArr[i] = colorArr[i] * (1 - level) | 0;
      } else {
        colorArr[i] = (255 - colorArr[i]) * level + colorArr[i] | 0;
      }
      if (colorArr[i] > 255) {
        colorArr[i] = 255;
      } else if (colorArr[i] < 0) {
        colorArr[i] = 0;
      }
    }
    return stringify(colorArr, colorArr.length === 4 ? "rgba" : "rgb");
  }
}
function fastLerp(normalizedValue, colors, out2) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  out2 = out2 || [];
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = colors[leftIndex];
  var rightColor = colors[rightIndex];
  var dv = value - leftIndex;
  out2[0] = clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv));
  out2[1] = clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv));
  out2[2] = clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv));
  out2[3] = clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv));
  return out2;
}
function lerp(normalizedValue, colors, fullOutput) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = parse(colors[leftIndex]);
  var rightColor = parse(colors[rightIndex]);
  var dv = value - leftIndex;
  var color = stringify([
    clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv)),
    clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv)),
    clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv)),
    clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv))
  ], "rgba");
  return fullOutput ? {
    color,
    leftIndex,
    rightIndex,
    value
  } : color;
}
function modifyHSL(color, h, s, l2) {
  var colorArr = parse(color);
  if (color) {
    colorArr = rgba2hsla(colorArr);
    h != null && (colorArr[0] = clampCssAngle(h));
    s != null && (colorArr[1] = parseCssFloat(s));
    l2 != null && (colorArr[2] = parseCssFloat(l2));
    return stringify(hsla2rgba(colorArr), "rgba");
  }
}
function modifyAlpha(color, alpha) {
  var colorArr = parse(color);
  if (colorArr && alpha != null) {
    colorArr[3] = clampCssFloat(alpha);
    return stringify(colorArr, "rgba");
  }
}
function stringify(arrColor, type4) {
  if (!arrColor || !arrColor.length) {
    return;
  }
  var colorStr = arrColor[0] + "," + arrColor[1] + "," + arrColor[2];
  if (type4 === "rgba" || type4 === "hsva" || type4 === "hsla") {
    colorStr += "," + arrColor[3];
  }
  return type4 + "(" + colorStr + ")";
}
function lum(color, backgroundLum) {
  var arr = parse(color);
  return arr ? (0.299 * arr[0] + 0.587 * arr[1] + 0.114 * arr[2]) * arr[3] / 255 + (1 - arr[3]) * backgroundLum : 0;
}
var mathRound$1 = Math.round;
function normalizeColor(color) {
  var opacity;
  if (!color || color === "transparent") {
    color = "none";
  } else if (typeof color === "string" && color.indexOf("rgba") > -1) {
    var arr = parse(color);
    if (arr) {
      color = "rgb(" + arr[0] + "," + arr[1] + "," + arr[2] + ")";
      opacity = arr[3];
    }
  }
  return {
    color,
    opacity: opacity == null ? 1 : opacity
  };
}
var EPSILON$3 = 1e-4;
function isAroundZero(transform2) {
  return transform2 < EPSILON$3 && transform2 > -EPSILON$3;
}
function round3(transform2) {
  return mathRound$1(transform2 * 1e3) / 1e3;
}
function round4(transform2) {
  return mathRound$1(transform2 * 1e4) / 1e4;
}
function getMatrixStr(m2) {
  return "matrix(" + round3(m2[0]) + "," + round3(m2[1]) + "," + round3(m2[2]) + "," + round3(m2[3]) + "," + round4(m2[4]) + "," + round4(m2[5]) + ")";
}
var TEXT_ALIGN_TO_ANCHOR = {
  left: "start",
  right: "end",
  center: "middle",
  middle: "middle"
};
function adjustTextY$1(y2, lineHeight, textBaseline) {
  if (textBaseline === "top") {
    y2 += lineHeight / 2;
  } else if (textBaseline === "bottom") {
    y2 -= lineHeight / 2;
  }
  return y2;
}
function hasShadow(style) {
  return style && (style.shadowBlur || style.shadowOffsetX || style.shadowOffsetY);
}
function getShadowKey(displayable) {
  var style = displayable.style;
  var globalScale = displayable.getGlobalScale();
  return [
    style.shadowColor,
    (style.shadowBlur || 0).toFixed(2),
    (style.shadowOffsetX || 0).toFixed(2),
    (style.shadowOffsetY || 0).toFixed(2),
    globalScale[0],
    globalScale[1]
  ].join(",");
}
function isImagePattern(val) {
  return val && !!val.image;
}
function isSVGPattern(val) {
  return val && !!val.svgElement;
}
function isPattern(val) {
  return isImagePattern(val) || isSVGPattern(val);
}
function isLinearGradient(val) {
  return val.type === "linear";
}
function isRadialGradient(val) {
  return val.type === "radial";
}
function isGradient(val) {
  return val && (val.type === "linear" || val.type === "radial");
}
function getIdURL(id2) {
  return "url(#" + id2 + ")";
}
function getPathPrecision(el) {
  var scale2 = el.getGlobalScale();
  var size = Math.max(scale2[0], scale2[1]);
  return Math.max(Math.ceil(Math.log(size) / Math.log(10)), 1);
}
function getSRTTransformString(transform2) {
  var x2 = transform2.x || 0;
  var y2 = transform2.y || 0;
  var rotation = (transform2.rotation || 0) * RADIAN_TO_DEGREE;
  var scaleX = retrieve2(transform2.scaleX, 1);
  var scaleY = retrieve2(transform2.scaleY, 1);
  var skewX = transform2.skewX || 0;
  var skewY = transform2.skewY || 0;
  var res = [];
  if (x2 || y2) {
    res.push("translate(" + x2 + "px," + y2 + "px)");
  }
  if (rotation) {
    res.push("rotate(" + rotation + ")");
  }
  if (scaleX !== 1 || scaleY !== 1) {
    res.push("scale(" + scaleX + "," + scaleY + ")");
  }
  if (skewX || skewY) {
    res.push("skew(" + mathRound$1(skewX * RADIAN_TO_DEGREE) + "deg, " + mathRound$1(skewY * RADIAN_TO_DEGREE) + "deg)");
  }
  return res.join(" ");
}
var encodeBase64 = function() {
  if (env$1.hasGlobalWindow && isFunction(window.btoa)) {
    return function(str) {
      return window.btoa(unescape(str));
    };
  }
  if (typeof Buffer !== "undefined") {
    return function(str) {
      return Buffer.from(str).toString("base64");
    };
  }
  return function(str) {
    return null;
  };
}();
var arraySlice = Array.prototype.slice;
function interpolateNumber$1(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
function interpolate1DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = interpolateNumber$1(p0[i], p1[i], percent);
  }
  return out2;
}
function interpolate2DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = interpolateNumber$1(p0[i][j], p1[i][j], percent);
    }
  }
  return out2;
}
function add1DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = p0[i] + p1[i] * sign;
  }
  return out2;
}
function add2DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = p0[i][j] + p1[i][j] * sign;
    }
  }
  return out2;
}
function fillColorStops(val0, val1) {
  var len0 = val0.length;
  var len1 = val1.length;
  var shorterArr = len0 > len1 ? val1 : val0;
  var shorterLen = Math.min(len0, len1);
  var last = shorterArr[shorterLen - 1] || { color: [0, 0, 0, 0], offset: 0 };
  for (var i = shorterLen; i < Math.max(len0, len1); i++) {
    shorterArr.push({
      offset: last.offset,
      color: last.color.slice()
    });
  }
}
function fillArray(val0, val1, arrDim) {
  var arr0 = val0;
  var arr1 = val1;
  if (!arr0.push || !arr1.push) {
    return;
  }
  var arr0Len = arr0.length;
  var arr1Len = arr1.length;
  if (arr0Len !== arr1Len) {
    var isPreviousLarger = arr0Len > arr1Len;
    if (isPreviousLarger) {
      arr0.length = arr1Len;
    } else {
      for (var i = arr0Len; i < arr1Len; i++) {
        arr0.push(arrDim === 1 ? arr1[i] : arraySlice.call(arr1[i]));
      }
    }
  }
  var len2 = arr0[0] && arr0[0].length;
  for (var i = 0; i < arr0.length; i++) {
    if (arrDim === 1) {
      if (isNaN(arr0[i])) {
        arr0[i] = arr1[i];
      }
    } else {
      for (var j = 0; j < len2; j++) {
        if (isNaN(arr0[i][j])) {
          arr0[i][j] = arr1[i][j];
        }
      }
    }
  }
}
function cloneValue(value) {
  if (isArrayLike(value)) {
    var len2 = value.length;
    if (isArrayLike(value[0])) {
      var ret = [];
      for (var i = 0; i < len2; i++) {
        ret.push(arraySlice.call(value[i]));
      }
      return ret;
    }
    return arraySlice.call(value);
  }
  return value;
}
function rgba2String(rgba) {
  rgba[0] = Math.floor(rgba[0]) || 0;
  rgba[1] = Math.floor(rgba[1]) || 0;
  rgba[2] = Math.floor(rgba[2]) || 0;
  rgba[3] = rgba[3] == null ? 1 : rgba[3];
  return "rgba(" + rgba.join(",") + ")";
}
function guessArrayDim(value) {
  return isArrayLike(value && value[0]) ? 2 : 1;
}
var VALUE_TYPE_NUMBER = 0;
var VALUE_TYPE_1D_ARRAY = 1;
var VALUE_TYPE_2D_ARRAY = 2;
var VALUE_TYPE_COLOR = 3;
var VALUE_TYPE_LINEAR_GRADIENT = 4;
var VALUE_TYPE_RADIAL_GRADIENT = 5;
var VALUE_TYPE_UNKOWN = 6;
function isGradientValueType(valType) {
  return valType === VALUE_TYPE_LINEAR_GRADIENT || valType === VALUE_TYPE_RADIAL_GRADIENT;
}
function isArrayValueType(valType) {
  return valType === VALUE_TYPE_1D_ARRAY || valType === VALUE_TYPE_2D_ARRAY;
}
var tmpRgba = [0, 0, 0, 0];
var Track = function() {
  function Track2(propName) {
    this.keyframes = [];
    this.discrete = false;
    this._invalid = false;
    this._needsSort = false;
    this._lastFr = 0;
    this._lastFrP = 0;
    this.propName = propName;
  }
  Track2.prototype.isFinished = function() {
    return this._finished;
  };
  Track2.prototype.setFinished = function() {
    this._finished = true;
    if (this._additiveTrack) {
      this._additiveTrack.setFinished();
    }
  };
  Track2.prototype.needsAnimate = function() {
    return this.keyframes.length >= 1;
  };
  Track2.prototype.getAdditiveTrack = function() {
    return this._additiveTrack;
  };
  Track2.prototype.addKeyframe = function(time, rawValue, easing) {
    this._needsSort = true;
    var keyframes = this.keyframes;
    var len2 = keyframes.length;
    var discrete = false;
    var valType = VALUE_TYPE_UNKOWN;
    var value = rawValue;
    if (isArrayLike(rawValue)) {
      var arrayDim = guessArrayDim(rawValue);
      valType = arrayDim;
      if (arrayDim === 1 && !isNumber(rawValue[0]) || arrayDim === 2 && !isNumber(rawValue[0][0])) {
        discrete = true;
      }
    } else {
      if (isNumber(rawValue) && !eqNaN(rawValue)) {
        valType = VALUE_TYPE_NUMBER;
      } else if (isString(rawValue)) {
        if (!isNaN(+rawValue)) {
          valType = VALUE_TYPE_NUMBER;
        } else {
          var colorArray = parse(rawValue);
          if (colorArray) {
            value = colorArray;
            valType = VALUE_TYPE_COLOR;
          }
        }
      } else if (isGradientObject(rawValue)) {
        var parsedGradient = extend({}, value);
        parsedGradient.colorStops = map$1(rawValue.colorStops, function(colorStop) {
          return {
            offset: colorStop.offset,
            color: parse(colorStop.color)
          };
        });
        if (isLinearGradient(rawValue)) {
          valType = VALUE_TYPE_LINEAR_GRADIENT;
        } else if (isRadialGradient(rawValue)) {
          valType = VALUE_TYPE_RADIAL_GRADIENT;
        }
        value = parsedGradient;
      }
    }
    if (len2 === 0) {
      this.valType = valType;
    } else if (valType !== this.valType || valType === VALUE_TYPE_UNKOWN) {
      discrete = true;
    }
    this.discrete = this.discrete || discrete;
    var kf = {
      time,
      value,
      rawValue,
      percent: 0
    };
    if (easing) {
      kf.easing = easing;
      kf.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
    }
    keyframes.push(kf);
    return kf;
  };
  Track2.prototype.prepare = function(maxTime, additiveTrack) {
    var kfs = this.keyframes;
    if (this._needsSort) {
      kfs.sort(function(a, b2) {
        return a.time - b2.time;
      });
    }
    var valType = this.valType;
    var kfsLen = kfs.length;
    var lastKf = kfs[kfsLen - 1];
    var isDiscrete = this.discrete;
    var isArr = isArrayValueType(valType);
    var isGradient2 = isGradientValueType(valType);
    for (var i = 0; i < kfsLen; i++) {
      var kf = kfs[i];
      var value = kf.value;
      var lastValue = lastKf.value;
      kf.percent = kf.time / maxTime;
      if (!isDiscrete) {
        if (isArr && i !== kfsLen - 1) {
          fillArray(value, lastValue, valType);
        } else if (isGradient2) {
          fillColorStops(value.colorStops, lastValue.colorStops);
        }
      }
    }
    if (!isDiscrete && valType !== VALUE_TYPE_RADIAL_GRADIENT && additiveTrack && this.needsAnimate() && additiveTrack.needsAnimate() && valType === additiveTrack.valType && !additiveTrack._finished) {
      this._additiveTrack = additiveTrack;
      var startValue = kfs[0].value;
      for (var i = 0; i < kfsLen; i++) {
        if (valType === VALUE_TYPE_NUMBER) {
          kfs[i].additiveValue = kfs[i].value - startValue;
        } else if (valType === VALUE_TYPE_COLOR) {
          kfs[i].additiveValue = add1DArray([], kfs[i].value, startValue, -1);
        } else if (isArrayValueType(valType)) {
          kfs[i].additiveValue = valType === VALUE_TYPE_1D_ARRAY ? add1DArray([], kfs[i].value, startValue, -1) : add2DArray([], kfs[i].value, startValue, -1);
        }
      }
    }
  };
  Track2.prototype.step = function(target, percent) {
    if (this._finished) {
      return;
    }
    if (this._additiveTrack && this._additiveTrack._finished) {
      this._additiveTrack = null;
    }
    var isAdditive = this._additiveTrack != null;
    var valueKey = isAdditive ? "additiveValue" : "value";
    var valType = this.valType;
    var keyframes = this.keyframes;
    var kfsNum = keyframes.length;
    var propName = this.propName;
    var isValueColor = valType === VALUE_TYPE_COLOR;
    var frameIdx;
    var lastFrame = this._lastFr;
    var mathMin2 = Math.min;
    var frame;
    var nextFrame;
    if (kfsNum === 1) {
      frame = nextFrame = keyframes[0];
    } else {
      if (percent < 0) {
        frameIdx = 0;
      } else if (percent < this._lastFrP) {
        var start2 = mathMin2(lastFrame + 1, kfsNum - 1);
        for (frameIdx = start2; frameIdx >= 0; frameIdx--) {
          if (keyframes[frameIdx].percent <= percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx, kfsNum - 2);
      } else {
        for (frameIdx = lastFrame; frameIdx < kfsNum; frameIdx++) {
          if (keyframes[frameIdx].percent > percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx - 1, kfsNum - 2);
      }
      nextFrame = keyframes[frameIdx + 1];
      frame = keyframes[frameIdx];
    }
    if (!(frame && nextFrame)) {
      return;
    }
    this._lastFr = frameIdx;
    this._lastFrP = percent;
    var interval = nextFrame.percent - frame.percent;
    var w2 = interval === 0 ? 1 : mathMin2((percent - frame.percent) / interval, 1);
    if (nextFrame.easingFunc) {
      w2 = nextFrame.easingFunc(w2);
    }
    var targetArr = isAdditive ? this._additiveValue : isValueColor ? tmpRgba : target[propName];
    if ((isArrayValueType(valType) || isValueColor) && !targetArr) {
      targetArr = this._additiveValue = [];
    }
    if (this.discrete) {
      target[propName] = w2 < 1 ? frame.rawValue : nextFrame.rawValue;
    } else if (isArrayValueType(valType)) {
      valType === VALUE_TYPE_1D_ARRAY ? interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2) : interpolate2DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
    } else if (isGradientValueType(valType)) {
      var val = frame[valueKey];
      var nextVal_1 = nextFrame[valueKey];
      var isLinearGradient_1 = valType === VALUE_TYPE_LINEAR_GRADIENT;
      target[propName] = {
        type: isLinearGradient_1 ? "linear" : "radial",
        x: interpolateNumber$1(val.x, nextVal_1.x, w2),
        y: interpolateNumber$1(val.y, nextVal_1.y, w2),
        colorStops: map$1(val.colorStops, function(colorStop, idx) {
          var nextColorStop = nextVal_1.colorStops[idx];
          return {
            offset: interpolateNumber$1(colorStop.offset, nextColorStop.offset, w2),
            color: rgba2String(interpolate1DArray([], colorStop.color, nextColorStop.color, w2))
          };
        }),
        global: nextVal_1.global
      };
      if (isLinearGradient_1) {
        target[propName].x2 = interpolateNumber$1(val.x2, nextVal_1.x2, w2);
        target[propName].y2 = interpolateNumber$1(val.y2, nextVal_1.y2, w2);
      } else {
        target[propName].r = interpolateNumber$1(val.r, nextVal_1.r, w2);
      }
    } else if (isValueColor) {
      interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
      if (!isAdditive) {
        target[propName] = rgba2String(targetArr);
      }
    } else {
      var value = interpolateNumber$1(frame[valueKey], nextFrame[valueKey], w2);
      if (isAdditive) {
        this._additiveValue = value;
      } else {
        target[propName] = value;
      }
    }
    if (isAdditive) {
      this._addToTarget(target);
    }
  };
  Track2.prototype._addToTarget = function(target) {
    var valType = this.valType;
    var propName = this.propName;
    var additiveValue = this._additiveValue;
    if (valType === VALUE_TYPE_NUMBER) {
      target[propName] = target[propName] + additiveValue;
    } else if (valType === VALUE_TYPE_COLOR) {
      parse(target[propName], tmpRgba);
      add1DArray(tmpRgba, tmpRgba, additiveValue, 1);
      target[propName] = rgba2String(tmpRgba);
    } else if (valType === VALUE_TYPE_1D_ARRAY) {
      add1DArray(target[propName], target[propName], additiveValue, 1);
    } else if (valType === VALUE_TYPE_2D_ARRAY) {
      add2DArray(target[propName], target[propName], additiveValue, 1);
    }
  };
  return Track2;
}();
var Animator = function() {
  function Animator2(target, loop, allowDiscreteAnimation, additiveTo) {
    this._tracks = {};
    this._trackKeys = [];
    this._maxTime = 0;
    this._started = 0;
    this._clip = null;
    this._target = target;
    this._loop = loop;
    if (loop && additiveTo) {
      logError("Can' use additive animation on looped animation.");
      return;
    }
    this._additiveAnimators = additiveTo;
    this._allowDiscrete = allowDiscreteAnimation;
  }
  Animator2.prototype.getMaxTime = function() {
    return this._maxTime;
  };
  Animator2.prototype.getDelay = function() {
    return this._delay;
  };
  Animator2.prototype.getLoop = function() {
    return this._loop;
  };
  Animator2.prototype.getTarget = function() {
    return this._target;
  };
  Animator2.prototype.changeTarget = function(target) {
    this._target = target;
  };
  Animator2.prototype.when = function(time, props, easing) {
    return this.whenWithKeys(time, props, keys(props), easing);
  };
  Animator2.prototype.whenWithKeys = function(time, props, propNames, easing) {
    var tracks = this._tracks;
    for (var i = 0; i < propNames.length; i++) {
      var propName = propNames[i];
      var track = tracks[propName];
      if (!track) {
        track = tracks[propName] = new Track(propName);
        var initialValue = void 0;
        var additiveTrack = this._getAdditiveTrack(propName);
        if (additiveTrack) {
          var addtiveTrackKfs = additiveTrack.keyframes;
          var lastFinalKf = addtiveTrackKfs[addtiveTrackKfs.length - 1];
          initialValue = lastFinalKf && lastFinalKf.value;
          if (additiveTrack.valType === VALUE_TYPE_COLOR && initialValue) {
            initialValue = rgba2String(initialValue);
          }
        } else {
          initialValue = this._target[propName];
        }
        if (initialValue == null) {
          continue;
        }
        if (time > 0) {
          track.addKeyframe(0, cloneValue(initialValue), easing);
        }
        this._trackKeys.push(propName);
      }
      track.addKeyframe(time, cloneValue(props[propName]), easing);
    }
    this._maxTime = Math.max(this._maxTime, time);
    return this;
  };
  Animator2.prototype.pause = function() {
    this._clip.pause();
    this._paused = true;
  };
  Animator2.prototype.resume = function() {
    this._clip.resume();
    this._paused = false;
  };
  Animator2.prototype.isPaused = function() {
    return !!this._paused;
  };
  Animator2.prototype.duration = function(duration) {
    this._maxTime = duration;
    this._force = true;
    return this;
  };
  Animator2.prototype._doneCallback = function() {
    this._setTracksFinished();
    this._clip = null;
    var doneList = this._doneCbs;
    if (doneList) {
      var len2 = doneList.length;
      for (var i = 0; i < len2; i++) {
        doneList[i].call(this);
      }
    }
  };
  Animator2.prototype._abortedCallback = function() {
    this._setTracksFinished();
    var animation = this.animation;
    var abortedList = this._abortedCbs;
    if (animation) {
      animation.removeClip(this._clip);
    }
    this._clip = null;
    if (abortedList) {
      for (var i = 0; i < abortedList.length; i++) {
        abortedList[i].call(this);
      }
    }
  };
  Animator2.prototype._setTracksFinished = function() {
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < tracksKeys.length; i++) {
      tracks[tracksKeys[i]].setFinished();
    }
  };
  Animator2.prototype._getAdditiveTrack = function(trackName) {
    var additiveTrack;
    var additiveAnimators = this._additiveAnimators;
    if (additiveAnimators) {
      for (var i = 0; i < additiveAnimators.length; i++) {
        var track = additiveAnimators[i].getTrack(trackName);
        if (track) {
          additiveTrack = track;
        }
      }
    }
    return additiveTrack;
  };
  Animator2.prototype.start = function(easing) {
    if (this._started > 0) {
      return;
    }
    this._started = 1;
    var self2 = this;
    var tracks = [];
    var maxTime = this._maxTime || 0;
    for (var i = 0; i < this._trackKeys.length; i++) {
      var propName = this._trackKeys[i];
      var track = this._tracks[propName];
      var additiveTrack = this._getAdditiveTrack(propName);
      var kfs = track.keyframes;
      var kfsNum = kfs.length;
      track.prepare(maxTime, additiveTrack);
      if (track.needsAnimate()) {
        if (!this._allowDiscrete && track.discrete) {
          var lastKf = kfs[kfsNum - 1];
          if (lastKf) {
            self2._target[track.propName] = lastKf.rawValue;
          }
          track.setFinished();
        } else {
          tracks.push(track);
        }
      }
    }
    if (tracks.length || this._force) {
      var clip2 = new Clip$1({
        life: maxTime,
        loop: this._loop,
        delay: this._delay || 0,
        onframe: function(percent) {
          self2._started = 2;
          var additiveAnimators = self2._additiveAnimators;
          if (additiveAnimators) {
            var stillHasAdditiveAnimator = false;
            for (var i2 = 0; i2 < additiveAnimators.length; i2++) {
              if (additiveAnimators[i2]._clip) {
                stillHasAdditiveAnimator = true;
                break;
              }
            }
            if (!stillHasAdditiveAnimator) {
              self2._additiveAnimators = null;
            }
          }
          for (var i2 = 0; i2 < tracks.length; i2++) {
            tracks[i2].step(self2._target, percent);
          }
          var onframeList = self2._onframeCbs;
          if (onframeList) {
            for (var i2 = 0; i2 < onframeList.length; i2++) {
              onframeList[i2](self2._target, percent);
            }
          }
        },
        ondestroy: function() {
          self2._doneCallback();
        }
      });
      this._clip = clip2;
      if (this.animation) {
        this.animation.addClip(clip2);
      }
      if (easing) {
        clip2.setEasing(easing);
      }
    } else {
      this._doneCallback();
    }
    return this;
  };
  Animator2.prototype.stop = function(forwardToLast) {
    if (!this._clip) {
      return;
    }
    var clip2 = this._clip;
    if (forwardToLast) {
      clip2.onframe(1);
    }
    this._abortedCallback();
  };
  Animator2.prototype.delay = function(time) {
    this._delay = time;
    return this;
  };
  Animator2.prototype.during = function(cb) {
    if (cb) {
      if (!this._onframeCbs) {
        this._onframeCbs = [];
      }
      this._onframeCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.done = function(cb) {
    if (cb) {
      if (!this._doneCbs) {
        this._doneCbs = [];
      }
      this._doneCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.aborted = function(cb) {
    if (cb) {
      if (!this._abortedCbs) {
        this._abortedCbs = [];
      }
      this._abortedCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.getClip = function() {
    return this._clip;
  };
  Animator2.prototype.getTrack = function(propName) {
    return this._tracks[propName];
  };
  Animator2.prototype.getTracks = function() {
    var _this = this;
    return map$1(this._trackKeys, function(key) {
      return _this._tracks[key];
    });
  };
  Animator2.prototype.stopTracks = function(propNames, forwardToLast) {
    if (!propNames.length || !this._clip) {
      return true;
    }
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < propNames.length; i++) {
      var track = tracks[propNames[i]];
      if (track && !track.isFinished()) {
        if (forwardToLast) {
          track.step(this._target, 1);
        } else if (this._started === 1) {
          track.step(this._target, 0);
        }
        track.setFinished();
      }
    }
    var allAborted = true;
    for (var i = 0; i < tracksKeys.length; i++) {
      if (!tracks[tracksKeys[i]].isFinished()) {
        allAborted = false;
        break;
      }
    }
    if (allAborted) {
      this._abortedCallback();
    }
    return allAborted;
  };
  Animator2.prototype.saveTo = function(target, trackKeys, firstOrLast) {
    if (!target) {
      return;
    }
    trackKeys = trackKeys || this._trackKeys;
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track || track.isFinished()) {
        continue;
      }
      var kfs = track.keyframes;
      var kf = kfs[firstOrLast ? 0 : kfs.length - 1];
      if (kf) {
        target[propName] = cloneValue(kf.rawValue);
      }
    }
  };
  Animator2.prototype.__changeFinalValue = function(finalProps, trackKeys) {
    trackKeys = trackKeys || keys(finalProps);
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track) {
        continue;
      }
      var kfs = track.keyframes;
      if (kfs.length > 1) {
        var lastKf = kfs.pop();
        track.addKeyframe(lastKf.time, finalProps[propName]);
        track.prepare(this._maxTime, track.getAdditiveTrack());
      }
    }
  };
  return Animator2;
}();
function getTime() {
  return new Date().getTime();
}
var Animation = function(_super) {
  __extends(Animation2, _super);
  function Animation2(opts) {
    var _this = _super.call(this) || this;
    _this._running = false;
    _this._time = 0;
    _this._pausedTime = 0;
    _this._pauseStart = 0;
    _this._paused = false;
    opts = opts || {};
    _this.stage = opts.stage || {};
    return _this;
  }
  Animation2.prototype.addClip = function(clip2) {
    if (clip2.animation) {
      this.removeClip(clip2);
    }
    if (!this._head) {
      this._head = this._tail = clip2;
    } else {
      this._tail.next = clip2;
      clip2.prev = this._tail;
      clip2.next = null;
      this._tail = clip2;
    }
    clip2.animation = this;
  };
  Animation2.prototype.addAnimator = function(animator) {
    animator.animation = this;
    var clip2 = animator.getClip();
    if (clip2) {
      this.addClip(clip2);
    }
  };
  Animation2.prototype.removeClip = function(clip2) {
    if (!clip2.animation) {
      return;
    }
    var prev = clip2.prev;
    var next = clip2.next;
    if (prev) {
      prev.next = next;
    } else {
      this._head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this._tail = prev;
    }
    clip2.next = clip2.prev = clip2.animation = null;
  };
  Animation2.prototype.removeAnimator = function(animator) {
    var clip2 = animator.getClip();
    if (clip2) {
      this.removeClip(clip2);
    }
    animator.animation = null;
  };
  Animation2.prototype.update = function(notTriggerFrameAndStageUpdate) {
    var time = getTime() - this._pausedTime;
    var delta = time - this._time;
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      var finished = clip2.step(time, delta);
      if (finished) {
        clip2.ondestroy();
        this.removeClip(clip2);
        clip2 = nextClip;
      } else {
        clip2 = nextClip;
      }
    }
    this._time = time;
    if (!notTriggerFrameAndStageUpdate) {
      this.trigger("frame", delta);
      this.stage.update && this.stage.update();
    }
  };
  Animation2.prototype._startLoop = function() {
    var self2 = this;
    this._running = true;
    function step() {
      if (self2._running) {
        requestAnimationFrame$2(step);
        !self2._paused && self2.update();
      }
    }
    requestAnimationFrame$2(step);
  };
  Animation2.prototype.start = function() {
    if (this._running) {
      return;
    }
    this._time = getTime();
    this._pausedTime = 0;
    this._startLoop();
  };
  Animation2.prototype.stop = function() {
    this._running = false;
  };
  Animation2.prototype.pause = function() {
    if (!this._paused) {
      this._pauseStart = getTime();
      this._paused = true;
    }
  };
  Animation2.prototype.resume = function() {
    if (this._paused) {
      this._pausedTime += getTime() - this._pauseStart;
      this._paused = false;
    }
  };
  Animation2.prototype.clear = function() {
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      clip2.prev = clip2.next = clip2.animation = null;
      clip2 = nextClip;
    }
    this._head = this._tail = null;
  };
  Animation2.prototype.isFinished = function() {
    return this._head == null;
  };
  Animation2.prototype.animate = function(target, options) {
    options = options || {};
    this.start();
    var animator = new Animator(target, options.loop);
    this.addAnimator(animator);
    return animator;
  };
  return Animation2;
}(Eventful$1);
var Animation$1 = Animation;
var TOUCH_CLICK_DELAY = 300;
var globalEventSupported = env$1.domSupported;
var localNativeListenerNames = function() {
  var mouseHandlerNames = [
    "click",
    "dblclick",
    "mousewheel",
    "wheel",
    "mouseout",
    "mouseup",
    "mousedown",
    "mousemove",
    "contextmenu"
  ];
  var touchHandlerNames = [
    "touchstart",
    "touchend",
    "touchmove"
  ];
  var pointerEventNameMap = {
    pointerdown: 1,
    pointerup: 1,
    pointermove: 1,
    pointerout: 1
  };
  var pointerHandlerNames = map$1(mouseHandlerNames, function(name) {
    var nm = name.replace("mouse", "pointer");
    return pointerEventNameMap.hasOwnProperty(nm) ? nm : name;
  });
  return {
    mouse: mouseHandlerNames,
    touch: touchHandlerNames,
    pointer: pointerHandlerNames
  };
}();
var globalNativeListenerNames = {
  mouse: ["mousemove", "mouseup"],
  pointer: ["pointermove", "pointerup"]
};
var wheelEventSupported = false;
function isPointerFromTouch(event) {
  var pointerType = event.pointerType;
  return pointerType === "pen" || pointerType === "touch";
}
function setTouchTimer(scope) {
  scope.touching = true;
  if (scope.touchTimer != null) {
    clearTimeout(scope.touchTimer);
    scope.touchTimer = null;
  }
  scope.touchTimer = setTimeout(function() {
    scope.touching = false;
    scope.touchTimer = null;
  }, 700);
}
function markTouch(event) {
  event && (event.zrByTouch = true);
}
function normalizeGlobalEvent(instance, event) {
  return normalizeEvent(instance.dom, new FakeGlobalEvent(instance, event), true);
}
function isLocalEl(instance, el) {
  var elTmp = el;
  var isLocal = false;
  while (elTmp && elTmp.nodeType !== 9 && !(isLocal = elTmp.domBelongToZr || elTmp !== el && elTmp === instance.painterRoot)) {
    elTmp = elTmp.parentNode;
  }
  return isLocal;
}
var FakeGlobalEvent = function() {
  function FakeGlobalEvent2(instance, event) {
    this.stopPropagation = noop;
    this.stopImmediatePropagation = noop;
    this.preventDefault = noop;
    this.type = event.type;
    this.target = this.currentTarget = instance.dom;
    this.pointerType = event.pointerType;
    this.clientX = event.clientX;
    this.clientY = event.clientY;
  }
  return FakeGlobalEvent2;
}();
var localDOMHandlers = {
  mousedown: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__mayPointerCapture = [event.zrX, event.zrY];
    this.trigger("mousedown", event);
  },
  mousemove: function(event) {
    event = normalizeEvent(this.dom, event);
    var downPoint = this.__mayPointerCapture;
    if (downPoint && (event.zrX !== downPoint[0] || event.zrY !== downPoint[1])) {
      this.__togglePointerCapture(true);
    }
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
  },
  mouseout: function(event) {
    event = normalizeEvent(this.dom, event);
    var element = event.toElement || event.relatedTarget;
    if (!isLocalEl(this, element)) {
      if (this.__pointerCapturing) {
        event.zrEventControl = "no_globalout";
      }
      this.trigger("mouseout", event);
    }
  },
  wheel: function(event) {
    wheelEventSupported = true;
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  mousewheel: function(event) {
    if (wheelEventSupported) {
      return;
    }
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  touchstart: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.__lastTouchMoment = new Date();
    this.handler.processGesture(event, "start");
    localDOMHandlers.mousemove.call(this, event);
    localDOMHandlers.mousedown.call(this, event);
  },
  touchmove: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "change");
    localDOMHandlers.mousemove.call(this, event);
  },
  touchend: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "end");
    localDOMHandlers.mouseup.call(this, event);
    if (+new Date() - +this.__lastTouchMoment < TOUCH_CLICK_DELAY) {
      localDOMHandlers.click.call(this, event);
    }
  },
  pointerdown: function(event) {
    localDOMHandlers.mousedown.call(this, event);
  },
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    localDOMHandlers.mouseup.call(this, event);
  },
  pointerout: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mouseout.call(this, event);
    }
  }
};
each$f(["click", "dblclick", "contextmenu"], function(name) {
  localDOMHandlers[name] = function(event) {
    event = normalizeEvent(this.dom, event);
    this.trigger(name, event);
  };
});
var globalDOMHandlers = {
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      globalDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    globalDOMHandlers.mouseup.call(this, event);
  },
  mousemove: function(event) {
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    var pointerCaptureReleasing = this.__pointerCapturing;
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
    if (pointerCaptureReleasing) {
      event.zrEventControl = "only_globalout";
      this.trigger("mouseout", event);
    }
  }
};
function mountLocalDOMEventListeners(instance, scope) {
  var domHandlers = scope.domHandlers;
  if (env$1.pointerEventsSupported) {
    each$f(localNativeListenerNames.pointer, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        domHandlers[nativeEventName].call(instance, event);
      });
    });
  } else {
    if (env$1.touchEventsSupported) {
      each$f(localNativeListenerNames.touch, function(nativeEventName) {
        mountSingleDOMEventListener(scope, nativeEventName, function(event) {
          domHandlers[nativeEventName].call(instance, event);
          setTouchTimer(scope);
        });
      });
    }
    each$f(localNativeListenerNames.mouse, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        event = getNativeEvent(event);
        if (!scope.touching) {
          domHandlers[nativeEventName].call(instance, event);
        }
      });
    });
  }
}
function mountGlobalDOMEventListeners(instance, scope) {
  if (env$1.pointerEventsSupported) {
    each$f(globalNativeListenerNames.pointer, mount);
  } else if (!env$1.touchEventsSupported) {
    each$f(globalNativeListenerNames.mouse, mount);
  }
  function mount(nativeEventName) {
    function nativeEventListener(event) {
      event = getNativeEvent(event);
      if (!isLocalEl(instance, event.target)) {
        event = normalizeGlobalEvent(instance, event);
        scope.domHandlers[nativeEventName].call(instance, event);
      }
    }
    mountSingleDOMEventListener(scope, nativeEventName, nativeEventListener, { capture: true });
  }
}
function mountSingleDOMEventListener(scope, nativeEventName, listener, opt) {
  scope.mounted[nativeEventName] = listener;
  scope.listenerOpts[nativeEventName] = opt;
  addEventListener(scope.domTarget, nativeEventName, listener, opt);
}
function unmountDOMEventListeners(scope) {
  var mounted = scope.mounted;
  for (var nativeEventName in mounted) {
    if (mounted.hasOwnProperty(nativeEventName)) {
      removeEventListener(scope.domTarget, nativeEventName, mounted[nativeEventName], scope.listenerOpts[nativeEventName]);
    }
  }
  scope.mounted = {};
}
var DOMHandlerScope = function() {
  function DOMHandlerScope2(domTarget, domHandlers) {
    this.mounted = {};
    this.listenerOpts = {};
    this.touching = false;
    this.domTarget = domTarget;
    this.domHandlers = domHandlers;
  }
  return DOMHandlerScope2;
}();
var HandlerDomProxy = function(_super) {
  __extends(HandlerDomProxy2, _super);
  function HandlerDomProxy2(dom, painterRoot) {
    var _this = _super.call(this) || this;
    _this.__pointerCapturing = false;
    _this.dom = dom;
    _this.painterRoot = painterRoot;
    _this._localHandlerScope = new DOMHandlerScope(dom, localDOMHandlers);
    if (globalEventSupported) {
      _this._globalHandlerScope = new DOMHandlerScope(document, globalDOMHandlers);
    }
    mountLocalDOMEventListeners(_this, _this._localHandlerScope);
    return _this;
  }
  HandlerDomProxy2.prototype.dispose = function() {
    unmountDOMEventListeners(this._localHandlerScope);
    if (globalEventSupported) {
      unmountDOMEventListeners(this._globalHandlerScope);
    }
  };
  HandlerDomProxy2.prototype.setCursor = function(cursorStyle) {
    this.dom.style && (this.dom.style.cursor = cursorStyle || "default");
  };
  HandlerDomProxy2.prototype.__togglePointerCapture = function(isPointerCapturing) {
    this.__mayPointerCapture = null;
    if (globalEventSupported && +this.__pointerCapturing ^ +isPointerCapturing) {
      this.__pointerCapturing = isPointerCapturing;
      var globalHandlerScope = this._globalHandlerScope;
      isPointerCapturing ? mountGlobalDOMEventListeners(this, globalHandlerScope) : unmountDOMEventListeners(globalHandlerScope);
    }
  };
  return HandlerDomProxy2;
}(Eventful$1);
var HandlerProxy = HandlerDomProxy;
var dpr = 1;
if (env$1.hasGlobalWindow) {
  dpr = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1);
}
var devicePixelRatio = dpr;
var DARK_MODE_THRESHOLD = 0.4;
var DARK_LABEL_COLOR = "#333";
var LIGHT_LABEL_COLOR = "#ccc";
var LIGHTER_LABEL_COLOR = "#eee";
function create$1() {
  return [1, 0, 0, 1, 0, 0];
}
function identity(out2) {
  out2[0] = 1;
  out2[1] = 0;
  out2[2] = 0;
  out2[3] = 1;
  out2[4] = 0;
  out2[5] = 0;
  return out2;
}
function copy(out2, m2) {
  out2[0] = m2[0];
  out2[1] = m2[1];
  out2[2] = m2[2];
  out2[3] = m2[3];
  out2[4] = m2[4];
  out2[5] = m2[5];
  return out2;
}
function mul(out2, m1, m2) {
  var out0 = m1[0] * m2[0] + m1[2] * m2[1];
  var out1 = m1[1] * m2[0] + m1[3] * m2[1];
  var out22 = m1[0] * m2[2] + m1[2] * m2[3];
  var out3 = m1[1] * m2[2] + m1[3] * m2[3];
  var out4 = m1[0] * m2[4] + m1[2] * m2[5] + m1[4];
  var out5 = m1[1] * m2[4] + m1[3] * m2[5] + m1[5];
  out2[0] = out0;
  out2[1] = out1;
  out2[2] = out22;
  out2[3] = out3;
  out2[4] = out4;
  out2[5] = out5;
  return out2;
}
function translate(out2, a, v4) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  out2[4] = a[4] + v4[0];
  out2[5] = a[5] + v4[1];
  return out2;
}
function rotate(out2, a, rad) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var st = Math.sin(rad);
  var ct = Math.cos(rad);
  out2[0] = aa * ct + ab * st;
  out2[1] = -aa * st + ab * ct;
  out2[2] = ac * ct + ad * st;
  out2[3] = -ac * st + ct * ad;
  out2[4] = ct * atx + st * aty;
  out2[5] = ct * aty - st * atx;
  return out2;
}
function scale$1(out2, a, v4) {
  var vx = v4[0];
  var vy = v4[1];
  out2[0] = a[0] * vx;
  out2[1] = a[1] * vy;
  out2[2] = a[2] * vx;
  out2[3] = a[3] * vy;
  out2[4] = a[4] * vx;
  out2[5] = a[5] * vy;
  return out2;
}
function invert(out2, a) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var det = aa * ad - ab * ac;
  if (!det) {
    return null;
  }
  det = 1 / det;
  out2[0] = ad * det;
  out2[1] = -ab * det;
  out2[2] = -ac * det;
  out2[3] = aa * det;
  out2[4] = (ac * aty - ad * atx) * det;
  out2[5] = (ab * atx - aa * aty) * det;
  return out2;
}
function clone$2(a) {
  var b2 = create$1();
  copy(b2, a);
  return b2;
}
var mIdentity = identity;
var EPSILON$2 = 5e-5;
function isNotAroundZero(val) {
  return val > EPSILON$2 || val < -EPSILON$2;
}
var scaleTmp = [];
var tmpTransform = [];
var originTransform = create$1();
var abs = Math.abs;
var Transformable = function() {
  function Transformable2() {
  }
  Transformable2.prototype.getLocalTransform = function(m2) {
    return Transformable2.getLocalTransform(this, m2);
  };
  Transformable2.prototype.setPosition = function(arr) {
    this.x = arr[0];
    this.y = arr[1];
  };
  Transformable2.prototype.setScale = function(arr) {
    this.scaleX = arr[0];
    this.scaleY = arr[1];
  };
  Transformable2.prototype.setSkew = function(arr) {
    this.skewX = arr[0];
    this.skewY = arr[1];
  };
  Transformable2.prototype.setOrigin = function(arr) {
    this.originX = arr[0];
    this.originY = arr[1];
  };
  Transformable2.prototype.needLocalTransform = function() {
    return isNotAroundZero(this.rotation) || isNotAroundZero(this.x) || isNotAroundZero(this.y) || isNotAroundZero(this.scaleX - 1) || isNotAroundZero(this.scaleY - 1) || isNotAroundZero(this.skewX) || isNotAroundZero(this.skewY);
  };
  Transformable2.prototype.updateTransform = function() {
    var parentTransform = this.parent && this.parent.transform;
    var needLocalTransform = this.needLocalTransform();
    var m2 = this.transform;
    if (!(needLocalTransform || parentTransform)) {
      m2 && mIdentity(m2);
      return;
    }
    m2 = m2 || create$1();
    if (needLocalTransform) {
      this.getLocalTransform(m2);
    } else {
      mIdentity(m2);
    }
    if (parentTransform) {
      if (needLocalTransform) {
        mul(m2, parentTransform, m2);
      } else {
        copy(m2, parentTransform);
      }
    }
    this.transform = m2;
    this._resolveGlobalScaleRatio(m2);
  };
  Transformable2.prototype._resolveGlobalScaleRatio = function(m2) {
    var globalScaleRatio = this.globalScaleRatio;
    if (globalScaleRatio != null && globalScaleRatio !== 1) {
      this.getGlobalScale(scaleTmp);
      var relX = scaleTmp[0] < 0 ? -1 : 1;
      var relY = scaleTmp[1] < 0 ? -1 : 1;
      var sx = ((scaleTmp[0] - relX) * globalScaleRatio + relX) / scaleTmp[0] || 0;
      var sy = ((scaleTmp[1] - relY) * globalScaleRatio + relY) / scaleTmp[1] || 0;
      m2[0] *= sx;
      m2[1] *= sx;
      m2[2] *= sy;
      m2[3] *= sy;
    }
    this.invTransform = this.invTransform || create$1();
    invert(this.invTransform, m2);
  };
  Transformable2.prototype.getComputedTransform = function() {
    var transformNode = this;
    var ancestors = [];
    while (transformNode) {
      ancestors.push(transformNode);
      transformNode = transformNode.parent;
    }
    while (transformNode = ancestors.pop()) {
      transformNode.updateTransform();
    }
    return this.transform;
  };
  Transformable2.prototype.setLocalTransform = function(m2) {
    if (!m2) {
      return;
    }
    var sx = m2[0] * m2[0] + m2[1] * m2[1];
    var sy = m2[2] * m2[2] + m2[3] * m2[3];
    var rotation = Math.atan2(m2[1], m2[0]);
    var shearX = Math.PI / 2 + rotation - Math.atan2(m2[3], m2[2]);
    sy = Math.sqrt(sy) * Math.cos(shearX);
    sx = Math.sqrt(sx);
    this.skewX = shearX;
    this.skewY = 0;
    this.rotation = -rotation;
    this.x = +m2[4];
    this.y = +m2[5];
    this.scaleX = sx;
    this.scaleY = sy;
    this.originX = 0;
    this.originY = 0;
  };
  Transformable2.prototype.decomposeTransform = function() {
    if (!this.transform) {
      return;
    }
    var parent = this.parent;
    var m2 = this.transform;
    if (parent && parent.transform) {
      mul(tmpTransform, parent.invTransform, m2);
      m2 = tmpTransform;
    }
    var ox = this.originX;
    var oy = this.originY;
    if (ox || oy) {
      originTransform[4] = ox;
      originTransform[5] = oy;
      mul(tmpTransform, m2, originTransform);
      tmpTransform[4] -= ox;
      tmpTransform[5] -= oy;
      m2 = tmpTransform;
    }
    this.setLocalTransform(m2);
  };
  Transformable2.prototype.getGlobalScale = function(out2) {
    var m2 = this.transform;
    out2 = out2 || [];
    if (!m2) {
      out2[0] = 1;
      out2[1] = 1;
      return out2;
    }
    out2[0] = Math.sqrt(m2[0] * m2[0] + m2[1] * m2[1]);
    out2[1] = Math.sqrt(m2[2] * m2[2] + m2[3] * m2[3]);
    if (m2[0] < 0) {
      out2[0] = -out2[0];
    }
    if (m2[3] < 0) {
      out2[1] = -out2[1];
    }
    return out2;
  };
  Transformable2.prototype.transformCoordToLocal = function(x2, y2) {
    var v22 = [x2, y2];
    var invTransform = this.invTransform;
    if (invTransform) {
      applyTransform$1(v22, v22, invTransform);
    }
    return v22;
  };
  Transformable2.prototype.transformCoordToGlobal = function(x2, y2) {
    var v22 = [x2, y2];
    var transform2 = this.transform;
    if (transform2) {
      applyTransform$1(v22, v22, transform2);
    }
    return v22;
  };
  Transformable2.prototype.getLineScale = function() {
    var m2 = this.transform;
    return m2 && abs(m2[0] - 1) > 1e-10 && abs(m2[3] - 1) > 1e-10 ? Math.sqrt(abs(m2[0] * m2[3] - m2[2] * m2[1])) : 1;
  };
  Transformable2.prototype.copyTransform = function(source) {
    copyTransform(this, source);
  };
  Transformable2.getLocalTransform = function(target, m2) {
    m2 = m2 || [];
    var ox = target.originX || 0;
    var oy = target.originY || 0;
    var sx = target.scaleX;
    var sy = target.scaleY;
    var ax = target.anchorX;
    var ay = target.anchorY;
    var rotation = target.rotation || 0;
    var x2 = target.x;
    var y2 = target.y;
    var skewX = target.skewX ? Math.tan(target.skewX) : 0;
    var skewY = target.skewY ? Math.tan(-target.skewY) : 0;
    if (ox || oy || ax || ay) {
      var dx = ox + ax;
      var dy = oy + ay;
      m2[4] = -dx * sx - skewX * dy * sy;
      m2[5] = -dy * sy - skewY * dx * sx;
    } else {
      m2[4] = m2[5] = 0;
    }
    m2[0] = sx;
    m2[3] = sy;
    m2[1] = skewY * sx;
    m2[2] = skewX * sy;
    rotation && rotate(m2, m2, rotation);
    m2[4] += ox + x2;
    m2[5] += oy + y2;
    return m2;
  };
  Transformable2.initDefaultProps = function() {
    var proto2 = Transformable2.prototype;
    proto2.scaleX = proto2.scaleY = proto2.globalScaleRatio = 1;
    proto2.x = proto2.y = proto2.originX = proto2.originY = proto2.skewX = proto2.skewY = proto2.rotation = proto2.anchorX = proto2.anchorY = 0;
  }();
  return Transformable2;
}();
var TRANSFORMABLE_PROPS = [
  "x",
  "y",
  "originX",
  "originY",
  "anchorX",
  "anchorY",
  "rotation",
  "scaleX",
  "scaleY",
  "skewX",
  "skewY"
];
function copyTransform(target, source) {
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var propName = TRANSFORMABLE_PROPS[i];
    target[propName] = source[propName];
  }
}
var Transformable$1 = Transformable;
var Point = function() {
  function Point2(x2, y2) {
    this.x = x2 || 0;
    this.y = y2 || 0;
  }
  Point2.prototype.copy = function(other) {
    this.x = other.x;
    this.y = other.y;
    return this;
  };
  Point2.prototype.clone = function() {
    return new Point2(this.x, this.y);
  };
  Point2.prototype.set = function(x2, y2) {
    this.x = x2;
    this.y = y2;
    return this;
  };
  Point2.prototype.equal = function(other) {
    return other.x === this.x && other.y === this.y;
  };
  Point2.prototype.add = function(other) {
    this.x += other.x;
    this.y += other.y;
    return this;
  };
  Point2.prototype.scale = function(scalar) {
    this.x *= scalar;
    this.y *= scalar;
  };
  Point2.prototype.scaleAndAdd = function(other, scalar) {
    this.x += other.x * scalar;
    this.y += other.y * scalar;
  };
  Point2.prototype.sub = function(other) {
    this.x -= other.x;
    this.y -= other.y;
    return this;
  };
  Point2.prototype.dot = function(other) {
    return this.x * other.x + this.y * other.y;
  };
  Point2.prototype.len = function() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  };
  Point2.prototype.lenSquare = function() {
    return this.x * this.x + this.y * this.y;
  };
  Point2.prototype.normalize = function() {
    var len2 = this.len();
    this.x /= len2;
    this.y /= len2;
    return this;
  };
  Point2.prototype.distance = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return Math.sqrt(dx * dx + dy * dy);
  };
  Point2.prototype.distanceSquare = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return dx * dx + dy * dy;
  };
  Point2.prototype.negate = function() {
    this.x = -this.x;
    this.y = -this.y;
    return this;
  };
  Point2.prototype.transform = function(m2) {
    if (!m2) {
      return;
    }
    var x2 = this.x;
    var y2 = this.y;
    this.x = m2[0] * x2 + m2[2] * y2 + m2[4];
    this.y = m2[1] * x2 + m2[3] * y2 + m2[5];
    return this;
  };
  Point2.prototype.toArray = function(out2) {
    out2[0] = this.x;
    out2[1] = this.y;
    return out2;
  };
  Point2.prototype.fromArray = function(input) {
    this.x = input[0];
    this.y = input[1];
  };
  Point2.set = function(p2, x2, y2) {
    p2.x = x2;
    p2.y = y2;
  };
  Point2.copy = function(p2, p22) {
    p2.x = p22.x;
    p2.y = p22.y;
  };
  Point2.len = function(p2) {
    return Math.sqrt(p2.x * p2.x + p2.y * p2.y);
  };
  Point2.lenSquare = function(p2) {
    return p2.x * p2.x + p2.y * p2.y;
  };
  Point2.dot = function(p0, p1) {
    return p0.x * p1.x + p0.y * p1.y;
  };
  Point2.add = function(out2, p0, p1) {
    out2.x = p0.x + p1.x;
    out2.y = p0.y + p1.y;
  };
  Point2.sub = function(out2, p0, p1) {
    out2.x = p0.x - p1.x;
    out2.y = p0.y - p1.y;
  };
  Point2.scale = function(out2, p0, scalar) {
    out2.x = p0.x * scalar;
    out2.y = p0.y * scalar;
  };
  Point2.scaleAndAdd = function(out2, p0, p1, scalar) {
    out2.x = p0.x + p1.x * scalar;
    out2.y = p0.y + p1.y * scalar;
  };
  Point2.lerp = function(out2, p0, p1, t2) {
    var onet = 1 - t2;
    out2.x = onet * p0.x + t2 * p1.x;
    out2.y = onet * p0.y + t2 * p1.y;
  };
  return Point2;
}();
var Point$1 = Point;
var mathMin$a = Math.min;
var mathMax$a = Math.max;
var lt = new Point$1();
var rb = new Point$1();
var lb = new Point$1();
var rt = new Point$1();
var minTv$1 = new Point$1();
var maxTv$1 = new Point$1();
var BoundingRect = function() {
  function BoundingRect2(x2, y2, width, height) {
    if (width < 0) {
      x2 = x2 + width;
      width = -width;
    }
    if (height < 0) {
      y2 = y2 + height;
      height = -height;
    }
    this.x = x2;
    this.y = y2;
    this.width = width;
    this.height = height;
  }
  BoundingRect2.prototype.union = function(other) {
    var x2 = mathMin$a(other.x, this.x);
    var y2 = mathMin$a(other.y, this.y);
    if (isFinite(this.x) && isFinite(this.width)) {
      this.width = mathMax$a(other.x + other.width, this.x + this.width) - x2;
    } else {
      this.width = other.width;
    }
    if (isFinite(this.y) && isFinite(this.height)) {
      this.height = mathMax$a(other.y + other.height, this.y + this.height) - y2;
    } else {
      this.height = other.height;
    }
    this.x = x2;
    this.y = y2;
  };
  BoundingRect2.prototype.applyTransform = function(m2) {
    BoundingRect2.applyTransform(this, this, m2);
  };
  BoundingRect2.prototype.calculateTransform = function(b2) {
    var a = this;
    var sx = b2.width / a.width;
    var sy = b2.height / a.height;
    var m2 = create$1();
    translate(m2, m2, [-a.x, -a.y]);
    scale$1(m2, m2, [sx, sy]);
    translate(m2, m2, [b2.x, b2.y]);
    return m2;
  };
  BoundingRect2.prototype.intersect = function(b2, mtv) {
    if (!b2) {
      return false;
    }
    if (!(b2 instanceof BoundingRect2)) {
      b2 = BoundingRect2.create(b2);
    }
    var a = this;
    var ax0 = a.x;
    var ax1 = a.x + a.width;
    var ay0 = a.y;
    var ay1 = a.y + a.height;
    var bx0 = b2.x;
    var bx1 = b2.x + b2.width;
    var by0 = b2.y;
    var by1 = b2.y + b2.height;
    var overlap = !(ax1 < bx0 || bx1 < ax0 || ay1 < by0 || by1 < ay0);
    if (mtv) {
      var dMin = Infinity;
      var dMax = 0;
      var d0 = Math.abs(ax1 - bx0);
      var d1 = Math.abs(bx1 - ax0);
      var d2 = Math.abs(ay1 - by0);
      var d3 = Math.abs(by1 - ay0);
      var dx = Math.min(d0, d1);
      var dy = Math.min(d2, d3);
      if (ax1 < bx0 || bx1 < ax0) {
        if (dx > dMax) {
          dMax = dx;
          if (d0 < d1) {
            Point$1.set(maxTv$1, -d0, 0);
          } else {
            Point$1.set(maxTv$1, d1, 0);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d0 < d1) {
            Point$1.set(minTv$1, d0, 0);
          } else {
            Point$1.set(minTv$1, -d1, 0);
          }
        }
      }
      if (ay1 < by0 || by1 < ay0) {
        if (dy > dMax) {
          dMax = dy;
          if (d2 < d3) {
            Point$1.set(maxTv$1, 0, -d2);
          } else {
            Point$1.set(maxTv$1, 0, d3);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d2 < d3) {
            Point$1.set(minTv$1, 0, d2);
          } else {
            Point$1.set(minTv$1, 0, -d3);
          }
        }
      }
    }
    if (mtv) {
      Point$1.copy(mtv, overlap ? minTv$1 : maxTv$1);
    }
    return overlap;
  };
  BoundingRect2.prototype.contain = function(x2, y2) {
    var rect = this;
    return x2 >= rect.x && x2 <= rect.x + rect.width && y2 >= rect.y && y2 <= rect.y + rect.height;
  };
  BoundingRect2.prototype.clone = function() {
    return new BoundingRect2(this.x, this.y, this.width, this.height);
  };
  BoundingRect2.prototype.copy = function(other) {
    BoundingRect2.copy(this, other);
  };
  BoundingRect2.prototype.plain = function() {
    return {
      x: this.x,
      y: this.y,
      width: this.width,
      height: this.height
    };
  };
  BoundingRect2.prototype.isFinite = function() {
    return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
  };
  BoundingRect2.prototype.isZero = function() {
    return this.width === 0 || this.height === 0;
  };
  BoundingRect2.create = function(rect) {
    return new BoundingRect2(rect.x, rect.y, rect.width, rect.height);
  };
  BoundingRect2.copy = function(target, source) {
    target.x = source.x;
    target.y = source.y;
    target.width = source.width;
    target.height = source.height;
  };
  BoundingRect2.applyTransform = function(target, source, m2) {
    if (!m2) {
      if (target !== source) {
        BoundingRect2.copy(target, source);
      }
      return;
    }
    if (m2[1] < 1e-5 && m2[1] > -1e-5 && m2[2] < 1e-5 && m2[2] > -1e-5) {
      var sx = m2[0];
      var sy = m2[3];
      var tx = m2[4];
      var ty = m2[5];
      target.x = source.x * sx + tx;
      target.y = source.y * sy + ty;
      target.width = source.width * sx;
      target.height = source.height * sy;
      if (target.width < 0) {
        target.x += target.width;
        target.width = -target.width;
      }
      if (target.height < 0) {
        target.y += target.height;
        target.height = -target.height;
      }
      return;
    }
    lt.x = lb.x = source.x;
    lt.y = rt.y = source.y;
    rb.x = rt.x = source.x + source.width;
    rb.y = lb.y = source.y + source.height;
    lt.transform(m2);
    rt.transform(m2);
    rb.transform(m2);
    lb.transform(m2);
    target.x = mathMin$a(lt.x, rb.x, lb.x, rt.x);
    target.y = mathMin$a(lt.y, rb.y, lb.y, rt.y);
    var maxX = mathMax$a(lt.x, rb.x, lb.x, rt.x);
    var maxY = mathMax$a(lt.y, rb.y, lb.y, rt.y);
    target.width = maxX - target.x;
    target.height = maxY - target.y;
  };
  return BoundingRect2;
}();
var BoundingRect$1 = BoundingRect;
var textWidthCache = {};
function getWidth(text, font) {
  font = font || DEFAULT_FONT;
  var cacheOfFont = textWidthCache[font];
  if (!cacheOfFont) {
    cacheOfFont = textWidthCache[font] = new LRU$1(500);
  }
  var width = cacheOfFont.get(text);
  if (width == null) {
    width = platformApi.measureText(text, font).width;
    cacheOfFont.put(text, width);
  }
  return width;
}
function innerGetBoundingRect(text, font, textAlign, textBaseline) {
  var width = getWidth(text, font);
  var height = getLineHeight(font);
  var x2 = adjustTextX(0, width, textAlign);
  var y2 = adjustTextY(0, height, textBaseline);
  var rect = new BoundingRect$1(x2, y2, width, height);
  return rect;
}
function getBoundingRect(text, font, textAlign, textBaseline) {
  var textLines = ((text || "") + "").split("\n");
  var len2 = textLines.length;
  if (len2 === 1) {
    return innerGetBoundingRect(textLines[0], font, textAlign, textBaseline);
  } else {
    var uniondRect = new BoundingRect$1(0, 0, 0, 0);
    for (var i = 0; i < textLines.length; i++) {
      var rect = innerGetBoundingRect(textLines[i], font, textAlign, textBaseline);
      i === 0 ? uniondRect.copy(rect) : uniondRect.union(rect);
    }
    return uniondRect;
  }
}
function adjustTextX(x2, width, textAlign) {
  if (textAlign === "right") {
    x2 -= width;
  } else if (textAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function adjustTextY(y2, height, verticalAlign) {
  if (verticalAlign === "middle") {
    y2 -= height / 2;
  } else if (verticalAlign === "bottom") {
    y2 -= height;
  }
  return y2;
}
function getLineHeight(font) {
  return getWidth("\u56FD", font);
}
function parsePercent$1(value, maxValue) {
  if (typeof value === "string") {
    if (value.lastIndexOf("%") >= 0) {
      return parseFloat(value) / 100 * maxValue;
    }
    return parseFloat(value);
  }
  return value;
}
function calculateTextPosition(out2, opts, rect) {
  var textPosition = opts.position || "inside";
  var distance2 = opts.distance != null ? opts.distance : 5;
  var height = rect.height;
  var width = rect.width;
  var halfHeight = height / 2;
  var x2 = rect.x;
  var y2 = rect.y;
  var textAlign = "left";
  var textVerticalAlign = "top";
  if (textPosition instanceof Array) {
    x2 += parsePercent$1(textPosition[0], rect.width);
    y2 += parsePercent$1(textPosition[1], rect.height);
    textAlign = null;
    textVerticalAlign = null;
  } else {
    switch (textPosition) {
      case "left":
        x2 -= distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "right":
        x2 += distance2 + width;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "top":
        x2 += width / 2;
        y2 -= distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "bottom":
        x2 += width / 2;
        y2 += height + distance2;
        textAlign = "center";
        break;
      case "inside":
        x2 += width / 2;
        y2 += halfHeight;
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "insideLeft":
        x2 += distance2;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "insideRight":
        x2 += width - distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideTop":
        x2 += width / 2;
        y2 += distance2;
        textAlign = "center";
        break;
      case "insideBottom":
        x2 += width / 2;
        y2 += height - distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideTopLeft":
        x2 += distance2;
        y2 += distance2;
        break;
      case "insideTopRight":
        x2 += width - distance2;
        y2 += distance2;
        textAlign = "right";
        break;
      case "insideBottomLeft":
        x2 += distance2;
        y2 += height - distance2;
        textVerticalAlign = "bottom";
        break;
      case "insideBottomRight":
        x2 += width - distance2;
        y2 += height - distance2;
        textAlign = "right";
        textVerticalAlign = "bottom";
        break;
    }
  }
  out2 = out2 || {};
  out2.x = x2;
  out2.y = y2;
  out2.align = textAlign;
  out2.verticalAlign = textVerticalAlign;
  return out2;
}
var PRESERVED_NORMAL_STATE = "__zr_normal__";
var PRIMARY_STATES_KEYS$1 = TRANSFORMABLE_PROPS.concat(["ignore"]);
var DEFAULT_ANIMATABLE_MAP = reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = true;
  return obj;
}, { ignore: false });
var tmpTextPosCalcRes = {};
var tmpBoundingRect = new BoundingRect$1(0, 0, 0, 0);
var Element$1 = function() {
  function Element2(props) {
    this.id = guid();
    this.animators = [];
    this.currentStates = [];
    this.states = {};
    this._init(props);
  }
  Element2.prototype._init = function(props) {
    this.attr(props);
  };
  Element2.prototype.drift = function(dx, dy, e2) {
    switch (this.draggable) {
      case "horizontal":
        dy = 0;
        break;
      case "vertical":
        dx = 0;
        break;
    }
    var m2 = this.transform;
    if (!m2) {
      m2 = this.transform = [1, 0, 0, 1, 0, 0];
    }
    m2[4] += dx;
    m2[5] += dy;
    this.decomposeTransform();
    this.markRedraw();
  };
  Element2.prototype.beforeUpdate = function() {
  };
  Element2.prototype.afterUpdate = function() {
  };
  Element2.prototype.update = function() {
    this.updateTransform();
    if (this.__dirty) {
      this.updateInnerText();
    }
  };
  Element2.prototype.updateInnerText = function(forceUpdate) {
    var textEl = this._textContent;
    if (textEl && (!textEl.ignore || forceUpdate)) {
      if (!this.textConfig) {
        this.textConfig = {};
      }
      var textConfig = this.textConfig;
      var isLocal = textConfig.local;
      var innerTransformable = textEl.innerTransformable;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var textStyleChanged = false;
      innerTransformable.parent = isLocal ? this : null;
      var innerOrigin = false;
      innerTransformable.copyTransform(textEl);
      if (textConfig.position != null) {
        var layoutRect = tmpBoundingRect;
        if (textConfig.layoutRect) {
          layoutRect.copy(textConfig.layoutRect);
        } else {
          layoutRect.copy(this.getBoundingRect());
        }
        if (!isLocal) {
          layoutRect.applyTransform(this.transform);
        }
        if (this.calculateTextPosition) {
          this.calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        } else {
          calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        }
        innerTransformable.x = tmpTextPosCalcRes.x;
        innerTransformable.y = tmpTextPosCalcRes.y;
        textAlign = tmpTextPosCalcRes.align;
        textVerticalAlign = tmpTextPosCalcRes.verticalAlign;
        var textOrigin = textConfig.origin;
        if (textOrigin && textConfig.rotation != null) {
          var relOriginX = void 0;
          var relOriginY = void 0;
          if (textOrigin === "center") {
            relOriginX = layoutRect.width * 0.5;
            relOriginY = layoutRect.height * 0.5;
          } else {
            relOriginX = parsePercent$1(textOrigin[0], layoutRect.width);
            relOriginY = parsePercent$1(textOrigin[1], layoutRect.height);
          }
          innerOrigin = true;
          innerTransformable.originX = -innerTransformable.x + relOriginX + (isLocal ? 0 : layoutRect.x);
          innerTransformable.originY = -innerTransformable.y + relOriginY + (isLocal ? 0 : layoutRect.y);
        }
      }
      if (textConfig.rotation != null) {
        innerTransformable.rotation = textConfig.rotation;
      }
      var textOffset = textConfig.offset;
      if (textOffset) {
        innerTransformable.x += textOffset[0];
        innerTransformable.y += textOffset[1];
        if (!innerOrigin) {
          innerTransformable.originX = -textOffset[0];
          innerTransformable.originY = -textOffset[1];
        }
      }
      var isInside = textConfig.inside == null ? typeof textConfig.position === "string" && textConfig.position.indexOf("inside") >= 0 : textConfig.inside;
      var innerTextDefaultStyle = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {});
      var textFill = void 0;
      var textStroke = void 0;
      var autoStroke = void 0;
      if (isInside && this.canBeInsideText()) {
        textFill = textConfig.insideFill;
        textStroke = textConfig.insideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getInsideTextFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getInsideTextStroke(textFill);
          autoStroke = true;
        }
      } else {
        textFill = textConfig.outsideFill;
        textStroke = textConfig.outsideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getOutsideFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getOutsideStroke(textFill);
          autoStroke = true;
        }
      }
      textFill = textFill || "#000";
      if (textFill !== innerTextDefaultStyle.fill || textStroke !== innerTextDefaultStyle.stroke || autoStroke !== innerTextDefaultStyle.autoStroke || textAlign !== innerTextDefaultStyle.align || textVerticalAlign !== innerTextDefaultStyle.verticalAlign) {
        textStyleChanged = true;
        innerTextDefaultStyle.fill = textFill;
        innerTextDefaultStyle.stroke = textStroke;
        innerTextDefaultStyle.autoStroke = autoStroke;
        innerTextDefaultStyle.align = textAlign;
        innerTextDefaultStyle.verticalAlign = textVerticalAlign;
        textEl.setDefaultTextStyle(innerTextDefaultStyle);
      }
      textEl.__dirty |= REDRAW_BIT;
      if (textStyleChanged) {
        textEl.dirtyStyle(true);
      }
    }
  };
  Element2.prototype.canBeInsideText = function() {
    return true;
  };
  Element2.prototype.getInsideTextFill = function() {
    return "#fff";
  };
  Element2.prototype.getInsideTextStroke = function(textFill) {
    return "#000";
  };
  Element2.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? LIGHT_LABEL_COLOR : DARK_LABEL_COLOR;
  };
  Element2.prototype.getOutsideStroke = function(textFill) {
    var backgroundColor2 = this.__zr && this.__zr.getBackgroundColor();
    var colorArr = typeof backgroundColor2 === "string" && parse(backgroundColor2);
    if (!colorArr) {
      colorArr = [255, 255, 255, 1];
    }
    var alpha = colorArr[3];
    var isDark = this.__zr.isDarkMode();
    for (var i = 0; i < 3; i++) {
      colorArr[i] = colorArr[i] * alpha + (isDark ? 0 : 255) * (1 - alpha);
    }
    colorArr[3] = 1;
    return stringify(colorArr, "rgba");
  };
  Element2.prototype.traverse = function(cb, context) {
  };
  Element2.prototype.attrKV = function(key, value) {
    if (key === "textConfig") {
      this.setTextConfig(value);
    } else if (key === "textContent") {
      this.setTextContent(value);
    } else if (key === "clipPath") {
      this.setClipPath(value);
    } else if (key === "extra") {
      this.extra = this.extra || {};
      extend(this.extra, value);
    } else {
      this[key] = value;
    }
  };
  Element2.prototype.hide = function() {
    this.ignore = true;
    this.markRedraw();
  };
  Element2.prototype.show = function() {
    this.ignore = false;
    this.markRedraw();
  };
  Element2.prototype.attr = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.attrKV(keyOrObj, value);
    } else if (isObject$4(keyOrObj)) {
      var obj = keyOrObj;
      var keysArr = keys(obj);
      for (var i = 0; i < keysArr.length; i++) {
        var key = keysArr[i];
        this.attrKV(key, keyOrObj[key]);
      }
    }
    this.markRedraw();
    return this;
  };
  Element2.prototype.saveCurrentToNormalState = function(toState) {
    this._innerSaveToNormal(toState);
    var normalState = this._normalState;
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      var fromStateTransition = animator.__fromStateTransition;
      if (animator.getLoop() || fromStateTransition && fromStateTransition !== PRESERVED_NORMAL_STATE) {
        continue;
      }
      var targetName = animator.targetName;
      var target = targetName ? normalState[targetName] : normalState;
      animator.saveTo(target);
    }
  };
  Element2.prototype._innerSaveToNormal = function(toState) {
    var normalState = this._normalState;
    if (!normalState) {
      normalState = this._normalState = {};
    }
    if (toState.textConfig && !normalState.textConfig) {
      normalState.textConfig = this.textConfig;
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS$1);
  };
  Element2.prototype._savePrimaryToNormal = function(toState, normalState, primaryKeys) {
    for (var i = 0; i < primaryKeys.length; i++) {
      var key = primaryKeys[i];
      if (toState[key] != null && !(key in normalState)) {
        normalState[key] = this[key];
      }
    }
  };
  Element2.prototype.hasState = function() {
    return this.currentStates.length > 0;
  };
  Element2.prototype.getState = function(name) {
    return this.states[name];
  };
  Element2.prototype.ensureState = function(name) {
    var states = this.states;
    if (!states[name]) {
      states[name] = {};
    }
    return states[name];
  };
  Element2.prototype.clearStates = function(noAnimation) {
    this.useState(PRESERVED_NORMAL_STATE, false, noAnimation);
  };
  Element2.prototype.useState = function(stateName, keepCurrentStates, noAnimation, forceUseHoverLayer) {
    var toNormalState = stateName === PRESERVED_NORMAL_STATE;
    var hasStates = this.hasState();
    if (!hasStates && toNormalState) {
      return;
    }
    var currentStates = this.currentStates;
    var animationCfg = this.stateTransition;
    if (indexOf(currentStates, stateName) >= 0 && (keepCurrentStates || currentStates.length === 1)) {
      return;
    }
    var state;
    if (this.stateProxy && !toNormalState) {
      state = this.stateProxy(stateName);
    }
    if (!state) {
      state = this.states && this.states[stateName];
    }
    if (!state && !toNormalState) {
      logError("State " + stateName + " not exists.");
      return;
    }
    if (!toNormalState) {
      this.saveCurrentToNormalState(state);
    }
    var useHoverLayer = !!(state && state.hoverLayer || forceUseHoverLayer);
    if (useHoverLayer) {
      this._toggleHoverLayerFlag(true);
    }
    this._applyStateObj(stateName, state, this._normalState, keepCurrentStates, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (textGuide) {
      textGuide.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (toNormalState) {
      this.currentStates = [];
      this._normalState = {};
    } else {
      if (!keepCurrentStates) {
        this.currentStates = [stateName];
      } else {
        this.currentStates.push(stateName);
      }
    }
    this._updateAnimationTargets();
    this.markRedraw();
    if (!useHoverLayer && this.__inHover) {
      this._toggleHoverLayerFlag(false);
      this.__dirty &= ~REDRAW_BIT;
    }
    return state;
  };
  Element2.prototype.useStates = function(states, noAnimation, forceUseHoverLayer) {
    if (!states.length) {
      this.clearStates();
    } else {
      var stateObjects = [];
      var currentStates = this.currentStates;
      var len2 = states.length;
      var notChange = len2 === currentStates.length;
      if (notChange) {
        for (var i = 0; i < len2; i++) {
          if (states[i] !== currentStates[i]) {
            notChange = false;
            break;
          }
        }
      }
      if (notChange) {
        return;
      }
      for (var i = 0; i < len2; i++) {
        var stateName = states[i];
        var stateObj = void 0;
        if (this.stateProxy) {
          stateObj = this.stateProxy(stateName, states);
        }
        if (!stateObj) {
          stateObj = this.states[stateName];
        }
        if (stateObj) {
          stateObjects.push(stateObj);
        }
      }
      var lastStateObj = stateObjects[len2 - 1];
      var useHoverLayer = !!(lastStateObj && lastStateObj.hoverLayer || forceUseHoverLayer);
      if (useHoverLayer) {
        this._toggleHoverLayerFlag(true);
      }
      var mergedState = this._mergeStates(stateObjects);
      var animationCfg = this.stateTransition;
      this.saveCurrentToNormalState(mergedState);
      this._applyStateObj(states.join(","), mergedState, this._normalState, false, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
      var textContent = this._textContent;
      var textGuide = this._textGuide;
      if (textContent) {
        textContent.useStates(states, noAnimation, useHoverLayer);
      }
      if (textGuide) {
        textGuide.useStates(states, noAnimation, useHoverLayer);
      }
      this._updateAnimationTargets();
      this.currentStates = states.slice();
      this.markRedraw();
      if (!useHoverLayer && this.__inHover) {
        this._toggleHoverLayerFlag(false);
        this.__dirty &= ~REDRAW_BIT;
      }
    }
  };
  Element2.prototype._updateAnimationTargets = function() {
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      if (animator.targetName) {
        animator.changeTarget(this[animator.targetName]);
      }
    }
  };
  Element2.prototype.removeState = function(state) {
    var idx = indexOf(this.currentStates, state);
    if (idx >= 0) {
      var currentStates = this.currentStates.slice();
      currentStates.splice(idx, 1);
      this.useStates(currentStates);
    }
  };
  Element2.prototype.replaceState = function(oldState, newState, forceAdd) {
    var currentStates = this.currentStates.slice();
    var idx = indexOf(currentStates, oldState);
    var newStateExists = indexOf(currentStates, newState) >= 0;
    if (idx >= 0) {
      if (!newStateExists) {
        currentStates[idx] = newState;
      } else {
        currentStates.splice(idx, 1);
      }
    } else if (forceAdd && !newStateExists) {
      currentStates.push(newState);
    }
    this.useStates(currentStates);
  };
  Element2.prototype.toggleState = function(state, enable) {
    if (enable) {
      this.useState(state, true);
    } else {
      this.removeState(state);
    }
  };
  Element2.prototype._mergeStates = function(states) {
    var mergedState = {};
    var mergedTextConfig;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      extend(mergedState, state);
      if (state.textConfig) {
        mergedTextConfig = mergedTextConfig || {};
        extend(mergedTextConfig, state.textConfig);
      }
    }
    if (mergedTextConfig) {
      mergedState.textConfig = mergedTextConfig;
    }
    return mergedState;
  };
  Element2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    var needsRestoreToNormal = !(state && keepCurrentStates);
    if (state && state.textConfig) {
      this.textConfig = extend({}, keepCurrentStates ? this.textConfig : normalState.textConfig);
      extend(this.textConfig, state.textConfig);
    } else if (needsRestoreToNormal) {
      if (normalState.textConfig) {
        this.textConfig = normalState.textConfig;
      }
    }
    var transitionTarget = {};
    var hasTransition = false;
    for (var i = 0; i < PRIMARY_STATES_KEYS$1.length; i++) {
      var key = PRIMARY_STATES_KEYS$1[i];
      var propNeedsTransition = transition && DEFAULT_ANIMATABLE_MAP[key];
      if (state && state[key] != null) {
        if (propNeedsTransition) {
          hasTransition = true;
          transitionTarget[key] = state[key];
        } else {
          this[key] = state[key];
        }
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          if (propNeedsTransition) {
            hasTransition = true;
            transitionTarget[key] = normalState[key];
          } else {
            this[key] = normalState[key];
          }
        }
      }
    }
    if (!transition) {
      for (var i = 0; i < this.animators.length; i++) {
        var animator = this.animators[i];
        var targetName = animator.targetName;
        if (!animator.getLoop()) {
          animator.__changeFinalValue(targetName ? (state || normalState)[targetName] : state || normalState);
        }
      }
    }
    if (hasTransition) {
      this._transitionState(stateName, transitionTarget, animationCfg);
    }
  };
  Element2.prototype._attachComponent = function(componentEl) {
    if (componentEl.__zr && !componentEl.__hostTarget) {
      return;
    }
    if (componentEl === this) {
      return;
    }
    var zr = this.__zr;
    if (zr) {
      componentEl.addSelfToZr(zr);
    }
    componentEl.__zr = zr;
    componentEl.__hostTarget = this;
  };
  Element2.prototype._detachComponent = function(componentEl) {
    if (componentEl.__zr) {
      componentEl.removeSelfFromZr(componentEl.__zr);
    }
    componentEl.__zr = null;
    componentEl.__hostTarget = null;
  };
  Element2.prototype.getClipPath = function() {
    return this._clipPath;
  };
  Element2.prototype.setClipPath = function(clipPath) {
    if (this._clipPath && this._clipPath !== clipPath) {
      this.removeClipPath();
    }
    this._attachComponent(clipPath);
    this._clipPath = clipPath;
    this.markRedraw();
  };
  Element2.prototype.removeClipPath = function() {
    var clipPath = this._clipPath;
    if (clipPath) {
      this._detachComponent(clipPath);
      this._clipPath = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextContent = function() {
    return this._textContent;
  };
  Element2.prototype.setTextContent = function(textEl) {
    var previousTextContent = this._textContent;
    if (previousTextContent === textEl) {
      return;
    }
    if (previousTextContent && previousTextContent !== textEl) {
      this.removeTextContent();
    }
    textEl.innerTransformable = new Transformable$1();
    this._attachComponent(textEl);
    this._textContent = textEl;
    this.markRedraw();
  };
  Element2.prototype.setTextConfig = function(cfg) {
    if (!this.textConfig) {
      this.textConfig = {};
    }
    extend(this.textConfig, cfg);
    this.markRedraw();
  };
  Element2.prototype.removeTextConfig = function() {
    this.textConfig = null;
    this.markRedraw();
  };
  Element2.prototype.removeTextContent = function() {
    var textEl = this._textContent;
    if (textEl) {
      textEl.innerTransformable = null;
      this._detachComponent(textEl);
      this._textContent = null;
      this._innerTextDefaultStyle = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextGuideLine = function() {
    return this._textGuide;
  };
  Element2.prototype.setTextGuideLine = function(guideLine) {
    if (this._textGuide && this._textGuide !== guideLine) {
      this.removeTextGuideLine();
    }
    this._attachComponent(guideLine);
    this._textGuide = guideLine;
    this.markRedraw();
  };
  Element2.prototype.removeTextGuideLine = function() {
    var textGuide = this._textGuide;
    if (textGuide) {
      this._detachComponent(textGuide);
      this._textGuide = null;
      this.markRedraw();
    }
  };
  Element2.prototype.markRedraw = function() {
    this.__dirty |= REDRAW_BIT;
    var zr = this.__zr;
    if (zr) {
      if (this.__inHover) {
        zr.refreshHover();
      } else {
        zr.refresh();
      }
    }
    if (this.__hostTarget) {
      this.__hostTarget.markRedraw();
    }
  };
  Element2.prototype.dirty = function() {
    this.markRedraw();
  };
  Element2.prototype._toggleHoverLayerFlag = function(inHover) {
    this.__inHover = inHover;
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.__inHover = inHover;
    }
    if (textGuide) {
      textGuide.__inHover = inHover;
    }
  };
  Element2.prototype.addSelfToZr = function(zr) {
    if (this.__zr === zr) {
      return;
    }
    this.__zr = zr;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.addAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.addSelfToZr(zr);
    }
    if (this._textContent) {
      this._textContent.addSelfToZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.addSelfToZr(zr);
    }
  };
  Element2.prototype.removeSelfFromZr = function(zr) {
    if (!this.__zr) {
      return;
    }
    this.__zr = null;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.removeAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.removeSelfFromZr(zr);
    }
    if (this._textContent) {
      this._textContent.removeSelfFromZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.removeSelfFromZr(zr);
    }
  };
  Element2.prototype.animate = function(key, loop, allowDiscreteAnimation) {
    var target = key ? this[key] : this;
    var animator = new Animator(target, loop, allowDiscreteAnimation);
    key && (animator.targetName = key);
    this.addAnimator(animator, key);
    return animator;
  };
  Element2.prototype.addAnimator = function(animator, key) {
    var zr = this.__zr;
    var el = this;
    animator.during(function() {
      el.updateDuringAnimation(key);
    }).done(function() {
      var animators = el.animators;
      var idx = indexOf(animators, animator);
      if (idx >= 0) {
        animators.splice(idx, 1);
      }
    });
    this.animators.push(animator);
    if (zr) {
      zr.animation.addAnimator(animator);
    }
    zr && zr.wakeUp();
  };
  Element2.prototype.updateDuringAnimation = function(key) {
    this.markRedraw();
  };
  Element2.prototype.stopAnimation = function(scope, forwardToLast) {
    var animators = this.animators;
    var len2 = animators.length;
    var leftAnimators = [];
    for (var i = 0; i < len2; i++) {
      var animator = animators[i];
      if (!scope || scope === animator.scope) {
        animator.stop(forwardToLast);
      } else {
        leftAnimators.push(animator);
      }
    }
    this.animators = leftAnimators;
    return this;
  };
  Element2.prototype.animateTo = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps);
  };
  Element2.prototype.animateFrom = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps, true);
  };
  Element2.prototype._transitionState = function(stateName, target, cfg, animationProps) {
    var animators = animateTo(this, target, cfg, animationProps);
    for (var i = 0; i < animators.length; i++) {
      animators[i].__fromStateTransition = stateName;
    }
  };
  Element2.prototype.getBoundingRect = function() {
    return null;
  };
  Element2.prototype.getPaintRect = function() {
    return null;
  };
  Element2.initDefaultProps = function() {
    var elProto = Element2.prototype;
    elProto.type = "element";
    elProto.name = "";
    elProto.ignore = elProto.silent = elProto.isGroup = elProto.draggable = elProto.dragging = elProto.ignoreClip = elProto.__inHover = false;
    elProto.__dirty = REDRAW_BIT;
    function createLegacyProperty(key, privateKey, xKey, yKey) {
      Object.defineProperty(elProto, key, {
        get: function() {
          if (!this[privateKey]) {
            var pos = this[privateKey] = [];
            enhanceArray(this, pos);
          }
          return this[privateKey];
        },
        set: function(pos) {
          this[xKey] = pos[0];
          this[yKey] = pos[1];
          this[privateKey] = pos;
          enhanceArray(this, pos);
        }
      });
      function enhanceArray(self2, pos) {
        Object.defineProperty(pos, 0, {
          get: function() {
            return self2[xKey];
          },
          set: function(val) {
            self2[xKey] = val;
          }
        });
        Object.defineProperty(pos, 1, {
          get: function() {
            return self2[yKey];
          },
          set: function(val) {
            self2[yKey] = val;
          }
        });
      }
    }
    if (Object.defineProperty) {
      createLegacyProperty("position", "_legacyPos", "x", "y");
      createLegacyProperty("scale", "_legacyScale", "scaleX", "scaleY");
      createLegacyProperty("origin", "_legacyOrigin", "originX", "originY");
    }
  }();
  return Element2;
}();
mixin(Element$1, Eventful$1);
mixin(Element$1, Transformable$1);
function animateTo(animatable, target, cfg, animationProps, reverse2) {
  cfg = cfg || {};
  var animators = [];
  animateToShallow(animatable, "", animatable, target, cfg, animationProps, animators, reverse2);
  var finishCount = animators.length;
  var doneHappened = false;
  var cfgDone = cfg.done;
  var cfgAborted = cfg.aborted;
  var doneCb = function() {
    doneHappened = true;
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  var abortedCb = function() {
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  if (!finishCount) {
    cfgDone && cfgDone();
  }
  if (animators.length > 0 && cfg.during) {
    animators[0].during(function(target2, percent) {
      cfg.during(percent);
    });
  }
  for (var i = 0; i < animators.length; i++) {
    var animator = animators[i];
    if (doneCb) {
      animator.done(doneCb);
    }
    if (abortedCb) {
      animator.aborted(abortedCb);
    }
    if (cfg.force) {
      animator.duration(cfg.duration);
    }
    animator.start(cfg.easing);
  }
  return animators;
}
function copyArrShallow(source, target, len2) {
  for (var i = 0; i < len2; i++) {
    source[i] = target[i];
  }
}
function is2DArray(value) {
  return isArrayLike(value[0]);
}
function copyValue(target, source, key) {
  if (isArrayLike(source[key])) {
    if (!isArrayLike(target[key])) {
      target[key] = [];
    }
    if (isTypedArray(source[key])) {
      var len2 = source[key].length;
      if (target[key].length !== len2) {
        target[key] = new source[key].constructor(len2);
        copyArrShallow(target[key], source[key], len2);
      }
    } else {
      var sourceArr = source[key];
      var targetArr = target[key];
      var len0 = sourceArr.length;
      if (is2DArray(sourceArr)) {
        var len1 = sourceArr[0].length;
        for (var i = 0; i < len0; i++) {
          if (!targetArr[i]) {
            targetArr[i] = Array.prototype.slice.call(sourceArr[i]);
          } else {
            copyArrShallow(targetArr[i], sourceArr[i], len1);
          }
        }
      } else {
        copyArrShallow(targetArr, sourceArr, len0);
      }
      targetArr.length = sourceArr.length;
    }
  } else {
    target[key] = source[key];
  }
}
function isValueSame(val1, val2) {
  return val1 === val2 || isArrayLike(val1) && isArrayLike(val2) && is1DArraySame(val1, val2);
}
function is1DArraySame(arr0, arr1) {
  var len2 = arr0.length;
  if (len2 !== arr1.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    if (arr0[i] !== arr1[i]) {
      return false;
    }
  }
  return true;
}
function animateToShallow(animatable, topKey, animateObj, target, cfg, animationProps, animators, reverse2) {
  var targetKeys = keys(target);
  var duration = cfg.duration;
  var delay = cfg.delay;
  var additive = cfg.additive;
  var setToFinal = cfg.setToFinal;
  var animateAll = !isObject$4(animationProps);
  var existsAnimators = animatable.animators;
  var animationKeys = [];
  for (var k2 = 0; k2 < targetKeys.length; k2++) {
    var innerKey = targetKeys[k2];
    var targetVal = target[innerKey];
    if (targetVal != null && animateObj[innerKey] != null && (animateAll || animationProps[innerKey])) {
      if (isObject$4(targetVal) && !isArrayLike(targetVal) && !isGradientObject(targetVal)) {
        if (topKey) {
          if (!reverse2) {
            animateObj[innerKey] = targetVal;
            animatable.updateDuringAnimation(topKey);
          }
          continue;
        }
        animateToShallow(animatable, innerKey, animateObj[innerKey], targetVal, cfg, animationProps && animationProps[innerKey], animators, reverse2);
      } else {
        animationKeys.push(innerKey);
      }
    } else if (!reverse2) {
      animateObj[innerKey] = targetVal;
      animatable.updateDuringAnimation(topKey);
      animationKeys.push(innerKey);
    }
  }
  var keyLen = animationKeys.length;
  if (!additive && keyLen) {
    for (var i = 0; i < existsAnimators.length; i++) {
      var animator = existsAnimators[i];
      if (animator.targetName === topKey) {
        var allAborted = animator.stopTracks(animationKeys);
        if (allAborted) {
          var idx = indexOf(existsAnimators, animator);
          existsAnimators.splice(idx, 1);
        }
      }
    }
  }
  if (!cfg.force) {
    animationKeys = filter(animationKeys, function(key) {
      return !isValueSame(target[key], animateObj[key]);
    });
    keyLen = animationKeys.length;
  }
  if (keyLen > 0 || cfg.force && !animators.length) {
    var revertedSource = void 0;
    var reversedTarget = void 0;
    var sourceClone = void 0;
    if (reverse2) {
      reversedTarget = {};
      if (setToFinal) {
        revertedSource = {};
      }
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        reversedTarget[innerKey] = animateObj[innerKey];
        if (setToFinal) {
          revertedSource[innerKey] = target[innerKey];
        } else {
          animateObj[innerKey] = target[innerKey];
        }
      }
    } else if (setToFinal) {
      sourceClone = {};
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        sourceClone[innerKey] = cloneValue(animateObj[innerKey]);
        copyValue(animateObj, target, innerKey);
      }
    }
    var animator = new Animator(animateObj, false, false, additive ? filter(existsAnimators, function(animator2) {
      return animator2.targetName === topKey;
    }) : null);
    animator.targetName = topKey;
    if (cfg.scope) {
      animator.scope = cfg.scope;
    }
    if (setToFinal && revertedSource) {
      animator.whenWithKeys(0, revertedSource, animationKeys);
    }
    if (sourceClone) {
      animator.whenWithKeys(0, sourceClone, animationKeys);
    }
    animator.whenWithKeys(duration == null ? 500 : duration, reverse2 ? reversedTarget : target, animationKeys).delay(delay || 0);
    animatable.addAnimator(animator, topKey);
    animators.push(animator);
  }
}
var Element$2 = Element$1;
var Group$3 = function(_super) {
  __extends(Group2, _super);
  function Group2(opts) {
    var _this = _super.call(this) || this;
    _this.isGroup = true;
    _this._children = [];
    _this.attr(opts);
    return _this;
  }
  Group2.prototype.childrenRef = function() {
    return this._children;
  };
  Group2.prototype.children = function() {
    return this._children.slice();
  };
  Group2.prototype.childAt = function(idx) {
    return this._children[idx];
  };
  Group2.prototype.childOfName = function(name) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].name === name) {
        return children[i];
      }
    }
  };
  Group2.prototype.childCount = function() {
    return this._children.length;
  };
  Group2.prototype.add = function(child) {
    if (child) {
      if (child !== this && child.parent !== this) {
        this._children.push(child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.addBefore = function(child, nextSibling2) {
    if (child && child !== this && child.parent !== this && nextSibling2 && nextSibling2.parent === this) {
      var children = this._children;
      var idx = children.indexOf(nextSibling2);
      if (idx >= 0) {
        children.splice(idx, 0, child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.replace = function(oldChild, newChild) {
    var idx = indexOf(this._children, oldChild);
    if (idx >= 0) {
      this.replaceAt(newChild, idx);
    }
    return this;
  };
  Group2.prototype.replaceAt = function(child, index2) {
    var children = this._children;
    var old = children[index2];
    if (child && child !== this && child.parent !== this && child !== old) {
      children[index2] = child;
      old.parent = null;
      var zr = this.__zr;
      if (zr) {
        old.removeSelfFromZr(zr);
      }
      this._doAdd(child);
    }
    return this;
  };
  Group2.prototype._doAdd = function(child) {
    if (child.parent) {
      child.parent.remove(child);
    }
    child.parent = this;
    var zr = this.__zr;
    if (zr && zr !== child.__zr) {
      child.addSelfToZr(zr);
    }
    zr && zr.refresh();
  };
  Group2.prototype.remove = function(child) {
    var zr = this.__zr;
    var children = this._children;
    var idx = indexOf(children, child);
    if (idx < 0) {
      return this;
    }
    children.splice(idx, 1);
    child.parent = null;
    if (zr) {
      child.removeSelfFromZr(zr);
    }
    zr && zr.refresh();
    return this;
  };
  Group2.prototype.removeAll = function() {
    var children = this._children;
    var zr = this.__zr;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (zr) {
        child.removeSelfFromZr(zr);
      }
      child.parent = null;
    }
    children.length = 0;
    return this;
  };
  Group2.prototype.eachChild = function(cb, context) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      cb.call(context, child, i);
    }
    return this;
  };
  Group2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      var stopped = cb.call(context, child);
      if (child.isGroup && !stopped) {
        child.traverse(cb, context);
      }
    }
    return this;
  };
  Group2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.addSelfToZr(zr);
    }
  };
  Group2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.removeSelfFromZr(zr);
    }
  };
  Group2.prototype.getBoundingRect = function(includeChildren) {
    var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
    var children = includeChildren || this._children;
    var tmpMat = [];
    var rect = null;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.ignore || child.invisible) {
        continue;
      }
      var childRect = child.getBoundingRect();
      var transform2 = child.getLocalTransform(tmpMat);
      if (transform2) {
        BoundingRect$1.applyTransform(tmpRect2, childRect, transform2);
        rect = rect || tmpRect2.clone();
        rect.union(tmpRect2);
      } else {
        rect = rect || childRect.clone();
        rect.union(childRect);
      }
    }
    return rect || tmpRect2;
  };
  return Group2;
}(Element$2);
Group$3.prototype.type = "group";
var Group$4 = Group$3;
/*!
* ZRender, a high performance 2d drawing library.
*
* Copyright (c) 2013, Baidu Inc.
* All rights reserved.
*
* LICENSE
* https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
*/
var painterCtors = {};
var instances$1 = {};
function delInstance(id2) {
  delete instances$1[id2];
}
function isDarkMode(backgroundColor2) {
  if (!backgroundColor2) {
    return false;
  }
  if (typeof backgroundColor2 === "string") {
    return lum(backgroundColor2, 1) < DARK_MODE_THRESHOLD;
  } else if (backgroundColor2.colorStops) {
    var colorStops = backgroundColor2.colorStops;
    var totalLum = 0;
    var len2 = colorStops.length;
    for (var i = 0; i < len2; i++) {
      totalLum += lum(colorStops[i].color, 1);
    }
    totalLum /= len2;
    return totalLum < DARK_MODE_THRESHOLD;
  }
  return false;
}
var ZRender = function() {
  function ZRender2(id2, dom, opts) {
    var _this = this;
    this._sleepAfterStill = 10;
    this._stillFrameAccum = 0;
    this._needsRefresh = true;
    this._needsRefreshHover = true;
    this._darkMode = false;
    opts = opts || {};
    this.dom = dom;
    this.id = id2;
    var storage2 = new Storage$1();
    var rendererType = opts.renderer || "canvas";
    if (!painterCtors[rendererType]) {
      rendererType = keys(painterCtors)[0];
    }
    opts.useDirtyRect = opts.useDirtyRect == null ? false : opts.useDirtyRect;
    var painter = new painterCtors[rendererType](dom, storage2, opts, id2);
    var ssrMode = opts.ssr || painter.ssrOnly;
    this.storage = storage2;
    this.painter = painter;
    var handerProxy = !env$1.node && !env$1.worker && !ssrMode ? new HandlerProxy(painter.getViewportRoot(), painter.root) : null;
    this.handler = new Handler$1(storage2, painter, handerProxy, painter.root);
    this.animation = new Animation$1({
      stage: {
        update: ssrMode ? null : function() {
          return _this._flush(true);
        }
      }
    });
    if (!ssrMode) {
      this.animation.start();
    }
  }
  ZRender2.prototype.add = function(el) {
    if (!el) {
      return;
    }
    this.storage.addRoot(el);
    el.addSelfToZr(this);
    this.refresh();
  };
  ZRender2.prototype.remove = function(el) {
    if (!el) {
      return;
    }
    this.storage.delRoot(el);
    el.removeSelfFromZr(this);
    this.refresh();
  };
  ZRender2.prototype.configLayer = function(zLevel, config) {
    if (this.painter.configLayer) {
      this.painter.configLayer(zLevel, config);
    }
    this.refresh();
  };
  ZRender2.prototype.setBackgroundColor = function(backgroundColor2) {
    if (this.painter.setBackgroundColor) {
      this.painter.setBackgroundColor(backgroundColor2);
    }
    this.refresh();
    this._backgroundColor = backgroundColor2;
    this._darkMode = isDarkMode(backgroundColor2);
  };
  ZRender2.prototype.getBackgroundColor = function() {
    return this._backgroundColor;
  };
  ZRender2.prototype.setDarkMode = function(darkMode) {
    this._darkMode = darkMode;
  };
  ZRender2.prototype.isDarkMode = function() {
    return this._darkMode;
  };
  ZRender2.prototype.refreshImmediately = function(fromInside) {
    if (!fromInside) {
      this.animation.update(true);
    }
    this._needsRefresh = false;
    this.painter.refresh();
    this._needsRefresh = false;
  };
  ZRender2.prototype.refresh = function() {
    this._needsRefresh = true;
    this.animation.start();
  };
  ZRender2.prototype.flush = function() {
    this._flush(false);
  };
  ZRender2.prototype._flush = function(fromInside) {
    var triggerRendered;
    var start2 = getTime();
    if (this._needsRefresh) {
      triggerRendered = true;
      this.refreshImmediately(fromInside);
    }
    if (this._needsRefreshHover) {
      triggerRendered = true;
      this.refreshHoverImmediately();
    }
    var end2 = getTime();
    if (triggerRendered) {
      this._stillFrameAccum = 0;
      this.trigger("rendered", {
        elapsedTime: end2 - start2
      });
    } else if (this._sleepAfterStill > 0) {
      this._stillFrameAccum++;
      if (this._stillFrameAccum > this._sleepAfterStill) {
        this.animation.stop();
      }
    }
  };
  ZRender2.prototype.setSleepAfterStill = function(stillFramesCount) {
    this._sleepAfterStill = stillFramesCount;
  };
  ZRender2.prototype.wakeUp = function() {
    this.animation.start();
    this._stillFrameAccum = 0;
  };
  ZRender2.prototype.refreshHover = function() {
    this._needsRefreshHover = true;
  };
  ZRender2.prototype.refreshHoverImmediately = function() {
    this._needsRefreshHover = false;
    if (this.painter.refreshHover && this.painter.getType() === "canvas") {
      this.painter.refreshHover();
    }
  };
  ZRender2.prototype.resize = function(opts) {
    opts = opts || {};
    this.painter.resize(opts.width, opts.height);
    this.handler.resize();
  };
  ZRender2.prototype.clearAnimation = function() {
    this.animation.clear();
  };
  ZRender2.prototype.getWidth = function() {
    return this.painter.getWidth();
  };
  ZRender2.prototype.getHeight = function() {
    return this.painter.getHeight();
  };
  ZRender2.prototype.setCursorStyle = function(cursorStyle) {
    this.handler.setCursorStyle(cursorStyle);
  };
  ZRender2.prototype.findHover = function(x2, y2) {
    return this.handler.findHover(x2, y2);
  };
  ZRender2.prototype.on = function(eventName, eventHandler, context) {
    this.handler.on(eventName, eventHandler, context);
    return this;
  };
  ZRender2.prototype.off = function(eventName, eventHandler) {
    this.handler.off(eventName, eventHandler);
  };
  ZRender2.prototype.trigger = function(eventName, event) {
    this.handler.trigger(eventName, event);
  };
  ZRender2.prototype.clear = function() {
    var roots2 = this.storage.getRoots();
    for (var i = 0; i < roots2.length; i++) {
      if (roots2[i] instanceof Group$4) {
        roots2[i].removeSelfFromZr(this);
      }
    }
    this.storage.delAllRoots();
    this.painter.clear();
  };
  ZRender2.prototype.dispose = function() {
    this.animation.stop();
    this.clear();
    this.storage.dispose();
    this.painter.dispose();
    this.handler.dispose();
    this.animation = this.storage = this.painter = this.handler = null;
    delInstance(this.id);
  };
  return ZRender2;
}();
function init$2(dom, opts) {
  var zr = new ZRender(guid(), dom, opts);
  instances$1[zr.id] = zr;
  return zr;
}
function registerPainter(name, Ctor) {
  painterCtors[name] = Ctor;
}
var RADIAN_EPSILON = 1e-4;
var ROUND_SUPPORTED_PRECISION_MAX = 20;
function _trim(str) {
  return str.replace(/^\s+|\s+$/g, "");
}
function linearMap$2(val, domain, range3, clamp2) {
  var d0 = domain[0];
  var d1 = domain[1];
  var r0 = range3[0];
  var r1 = range3[1];
  var subDomain = d1 - d0;
  var subRange = r1 - r0;
  if (subDomain === 0) {
    return subRange === 0 ? r0 : (r0 + r1) / 2;
  }
  if (clamp2) {
    if (subDomain > 0) {
      if (val <= d0) {
        return r0;
      } else if (val >= d1) {
        return r1;
      }
    } else {
      if (val >= d0) {
        return r0;
      } else if (val <= d1) {
        return r1;
      }
    }
  } else {
    if (val === d0) {
      return r0;
    }
    if (val === d1) {
      return r1;
    }
  }
  return (val - d0) / subDomain * subRange + r0;
}
function parsePercent(percent, all) {
  switch (percent) {
    case "center":
    case "middle":
      percent = "50%";
      break;
    case "left":
    case "top":
      percent = "0%";
      break;
    case "right":
    case "bottom":
      percent = "100%";
      break;
  }
  if (isString(percent)) {
    if (_trim(percent).match(/%$/)) {
      return parseFloat(percent) / 100 * all;
    }
    return parseFloat(percent);
  }
  return percent == null ? NaN : +percent;
}
function round$3(x2, precision, returnStr) {
  if (precision == null) {
    precision = 10;
  }
  precision = Math.min(Math.max(0, precision), ROUND_SUPPORTED_PRECISION_MAX);
  x2 = (+x2).toFixed(precision);
  return returnStr ? x2 : +x2;
}
function asc$2(arr) {
  arr.sort(function(a, b2) {
    return a - b2;
  });
  return arr;
}
function getPrecision(val) {
  val = +val;
  if (isNaN(val)) {
    return 0;
  }
  if (val > 1e-14) {
    var e2 = 1;
    for (var i = 0; i < 15; i++, e2 *= 10) {
      if (Math.round(val * e2) / e2 === val) {
        return i;
      }
    }
  }
  return getPrecisionSafe(val);
}
function getPrecisionSafe(val) {
  var str = val.toString().toLowerCase();
  var eIndex = str.indexOf("e");
  var exp = eIndex > 0 ? +str.slice(eIndex + 1) : 0;
  var significandPartLen = eIndex > 0 ? eIndex : str.length;
  var dotIndex = str.indexOf(".");
  var decimalPartLen = dotIndex < 0 ? 0 : significandPartLen - 1 - dotIndex;
  return Math.max(0, decimalPartLen - exp);
}
function getPixelPrecision(dataExtent, pixelExtent) {
  var log = Math.log;
  var LN10 = Math.LN10;
  var dataQuantity = Math.floor(log(dataExtent[1] - dataExtent[0]) / LN10);
  var sizeQuantity = Math.round(log(Math.abs(pixelExtent[1] - pixelExtent[0])) / LN10);
  var precision = Math.min(Math.max(-dataQuantity + sizeQuantity, 0), 20);
  return !isFinite(precision) ? 20 : precision;
}
function getPercentWithPrecision(valueList, idx, precision) {
  if (!valueList[idx]) {
    return 0;
  }
  var sum2 = reduce(valueList, function(acc, val) {
    return acc + (isNaN(val) ? 0 : val);
  }, 0);
  if (sum2 === 0) {
    return 0;
  }
  var digits = Math.pow(10, precision);
  var votesPerQuota = map$1(valueList, function(val) {
    return (isNaN(val) ? 0 : val) / sum2 * digits * 100;
  });
  var targetSeats = digits * 100;
  var seats = map$1(votesPerQuota, function(votes) {
    return Math.floor(votes);
  });
  var currentSum = reduce(seats, function(acc, val) {
    return acc + val;
  }, 0);
  var remainder = map$1(votesPerQuota, function(votes, idx2) {
    return votes - seats[idx2];
  });
  while (currentSum < targetSeats) {
    var max3 = Number.NEGATIVE_INFINITY;
    var maxId = null;
    for (var i = 0, len2 = remainder.length; i < len2; ++i) {
      if (remainder[i] > max3) {
        max3 = remainder[i];
        maxId = i;
      }
    }
    ++seats[maxId];
    remainder[maxId] = 0;
    ++currentSum;
  }
  return seats[idx] / digits;
}
function addSafe(val0, val1) {
  var maxPrecision = Math.max(getPrecision(val0), getPrecision(val1));
  var sum2 = val0 + val1;
  return maxPrecision > ROUND_SUPPORTED_PRECISION_MAX ? sum2 : round$3(sum2, maxPrecision);
}
var MAX_SAFE_INTEGER = 9007199254740991;
function remRadian(radian) {
  var pi2 = Math.PI * 2;
  return (radian % pi2 + pi2) % pi2;
}
function isRadianAroundZero(val) {
  return val > -RADIAN_EPSILON && val < RADIAN_EPSILON;
}
var TIME_REG = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
function parseDate(value) {
  if (value instanceof Date) {
    return value;
  } else if (isString(value)) {
    var match = TIME_REG.exec(value);
    if (!match) {
      return new Date(NaN);
    }
    if (!match[8]) {
      return new Date(+match[1], +(match[2] || 1) - 1, +match[3] || 1, +match[4] || 0, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0);
    } else {
      var hour = +match[4] || 0;
      if (match[8].toUpperCase() !== "Z") {
        hour -= +match[8].slice(0, 3);
      }
      return new Date(Date.UTC(+match[1], +(match[2] || 1) - 1, +match[3] || 1, hour, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0));
    }
  } else if (value == null) {
    return new Date(NaN);
  }
  return new Date(Math.round(value));
}
function quantity(val) {
  return Math.pow(10, quantityExponent(val));
}
function quantityExponent(val) {
  if (val === 0) {
    return 0;
  }
  var exp = Math.floor(Math.log(val) / Math.LN10);
  if (val / Math.pow(10, exp) >= 10) {
    exp++;
  }
  return exp;
}
function nice(val, round2) {
  var exponent = quantityExponent(val);
  var exp10 = Math.pow(10, exponent);
  var f2 = val / exp10;
  var nf;
  if (round2) {
    if (f2 < 1.5) {
      nf = 1;
    } else if (f2 < 2.5) {
      nf = 2;
    } else if (f2 < 4) {
      nf = 3;
    } else if (f2 < 7) {
      nf = 5;
    } else {
      nf = 10;
    }
  } else {
    if (f2 < 1) {
      nf = 1;
    } else if (f2 < 2) {
      nf = 2;
    } else if (f2 < 3) {
      nf = 3;
    } else if (f2 < 5) {
      nf = 5;
    } else {
      nf = 10;
    }
  }
  val = nf * exp10;
  return exponent >= -20 ? +val.toFixed(exponent < 0 ? -exponent : 0) : val;
}
function quantile(ascArr, p2) {
  var H = (ascArr.length - 1) * p2 + 1;
  var h = Math.floor(H);
  var v4 = +ascArr[h - 1];
  var e2 = H - h;
  return e2 ? v4 + e2 * (ascArr[h] - v4) : v4;
}
function reformIntervals(list) {
  list.sort(function(a, b2) {
    return littleThan2(a, b2, 0) ? -1 : 1;
  });
  var curr = -Infinity;
  var currClose = 1;
  for (var i = 0; i < list.length; ) {
    var interval = list[i].interval;
    var close_1 = list[i].close;
    for (var lg = 0; lg < 2; lg++) {
      if (interval[lg] <= curr) {
        interval[lg] = curr;
        close_1[lg] = !lg ? 1 - currClose : 1;
      }
      curr = interval[lg];
      currClose = close_1[lg];
    }
    if (interval[0] === interval[1] && close_1[0] * close_1[1] !== 1) {
      list.splice(i, 1);
    } else {
      i++;
    }
  }
  return list;
  function littleThan2(a, b2, lg2) {
    return a.interval[lg2] < b2.interval[lg2] || a.interval[lg2] === b2.interval[lg2] && (a.close[lg2] - b2.close[lg2] === (!lg2 ? 1 : -1) || !lg2 && littleThan2(a, b2, 1));
  }
}
function numericToNumber(val) {
  var valFloat = parseFloat(val);
  return valFloat == val && (valFloat !== 0 || !isString(val) || val.indexOf("x") <= 0) ? valFloat : NaN;
}
function isNumeric(val) {
  return !isNaN(numericToNumber(val));
}
function getRandomIdBase() {
  return Math.round(Math.random() * 9);
}
function getGreatestCommonDividor(a, b2) {
  if (b2 === 0) {
    return a;
  }
  return getGreatestCommonDividor(b2, a % b2);
}
function getLeastCommonMultiple(a, b2) {
  if (a == null) {
    return b2;
  }
  if (b2 == null) {
    return a;
  }
  return a * b2 / getGreatestCommonDividor(a, b2);
}
function throwError(msg) {
  throw new Error(msg);
}
function interpolateNumber(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
var DUMMY_COMPONENT_NAME_PREFIX = "series\0";
var INTERNAL_COMPONENT_ID_PREFIX = "\0_ec_\0";
function normalizeToArray(value) {
  return value instanceof Array ? value : value == null ? [] : [value];
}
function defaultEmphasis(opt, key, subOpts) {
  if (opt) {
    opt[key] = opt[key] || {};
    opt.emphasis = opt.emphasis || {};
    opt.emphasis[key] = opt.emphasis[key] || {};
    for (var i = 0, len2 = subOpts.length; i < len2; i++) {
      var subOptName = subOpts[i];
      if (!opt.emphasis[key].hasOwnProperty(subOptName) && opt[key].hasOwnProperty(subOptName)) {
        opt.emphasis[key][subOptName] = opt[key][subOptName];
      }
    }
  }
}
var TEXT_STYLE_OPTIONS = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
function getDataItemValue(dataItem) {
  return isObject$4(dataItem) && !isArray$1(dataItem) && !(dataItem instanceof Date) ? dataItem.value : dataItem;
}
function isDataItemOption(dataItem) {
  return isObject$4(dataItem) && !(dataItem instanceof Array);
}
function mappingToExists(existings, newCmptOptions, mode) {
  var isNormalMergeMode = mode === "normalMerge";
  var isReplaceMergeMode = mode === "replaceMerge";
  var isReplaceAllMode = mode === "replaceAll";
  existings = existings || [];
  newCmptOptions = (newCmptOptions || []).slice();
  var existingIdIdxMap = createHashMap();
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!isObject$4(cmptOption)) {
      newCmptOptions[index2] = null;
      return;
    }
  });
  var result = prepareResult(existings, existingIdIdxMap, mode);
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingById(result, existings, existingIdIdxMap, newCmptOptions);
  }
  if (isNormalMergeMode) {
    mappingByName(result, newCmptOptions);
  }
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingByIndex(result, newCmptOptions, isReplaceMergeMode);
  } else if (isReplaceAllMode) {
    mappingInReplaceAllMode(result, newCmptOptions);
  }
  makeIdAndName(result);
  return result;
}
function prepareResult(existings, existingIdIdxMap, mode) {
  var result = [];
  if (mode === "replaceAll") {
    return result;
  }
  for (var index2 = 0; index2 < existings.length; index2++) {
    var existing = existings[index2];
    if (existing && existing.id != null) {
      existingIdIdxMap.set(existing.id, index2);
    }
    result.push({
      existing: mode === "replaceMerge" || isComponentIdInternal(existing) ? null : existing,
      newOption: null,
      keyInfo: null,
      brandNew: null
    });
  }
  return result;
}
function mappingById(result, existings, existingIdIdxMap, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.id == null) {
      return;
    }
    var optionId = makeComparableKey(cmptOption.id);
    var existingIdx = existingIdIdxMap.get(optionId);
    if (existingIdx != null) {
      var resultItem = result[existingIdx];
      assert(!resultItem.newOption, 'Duplicated option on id "' + optionId + '".');
      resultItem.newOption = cmptOption;
      resultItem.existing = existings[existingIdx];
      newCmptOptions[index2] = null;
    }
  });
}
function mappingByName(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.name == null) {
      return;
    }
    for (var i = 0; i < result.length; i++) {
      var existing = result[i].existing;
      if (!result[i].newOption && existing && (existing.id == null || cmptOption.id == null) && !isComponentIdInternal(cmptOption) && !isComponentIdInternal(existing) && keyExistAndEqual("name", existing, cmptOption)) {
        result[i].newOption = cmptOption;
        newCmptOptions[index2] = null;
        return;
      }
    }
  });
}
function mappingByIndex(result, newCmptOptions, brandNew) {
  each$f(newCmptOptions, function(cmptOption) {
    if (!cmptOption) {
      return;
    }
    var resultItem;
    var nextIdx = 0;
    while ((resultItem = result[nextIdx]) && (resultItem.newOption || isComponentIdInternal(resultItem.existing) || resultItem.existing && cmptOption.id != null && !keyExistAndEqual("id", cmptOption, resultItem.existing))) {
      nextIdx++;
    }
    if (resultItem) {
      resultItem.newOption = cmptOption;
      resultItem.brandNew = brandNew;
    } else {
      result.push({
        newOption: cmptOption,
        brandNew,
        existing: null,
        keyInfo: null
      });
    }
    nextIdx++;
  });
}
function mappingInReplaceAllMode(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption) {
    result.push({
      newOption: cmptOption,
      brandNew: true,
      existing: null,
      keyInfo: null
    });
  });
}
function makeIdAndName(mapResult) {
  var idMap = createHashMap();
  each$f(mapResult, function(item) {
    var existing = item.existing;
    existing && idMap.set(existing.id, item);
  });
  each$f(mapResult, function(item) {
    var opt = item.newOption;
    assert(!opt || opt.id == null || !idMap.get(opt.id) || idMap.get(opt.id) === item, "id duplicates: " + (opt && opt.id));
    opt && opt.id != null && idMap.set(opt.id, item);
    !item.keyInfo && (item.keyInfo = {});
  });
  each$f(mapResult, function(item, index2) {
    var existing = item.existing;
    var opt = item.newOption;
    var keyInfo = item.keyInfo;
    if (!isObject$4(opt)) {
      return;
    }
    keyInfo.name = opt.name != null ? makeComparableKey(opt.name) : existing ? existing.name : DUMMY_COMPONENT_NAME_PREFIX + index2;
    if (existing) {
      keyInfo.id = makeComparableKey(existing.id);
    } else if (opt.id != null) {
      keyInfo.id = makeComparableKey(opt.id);
    } else {
      var idNum = 0;
      do {
        keyInfo.id = "\0" + keyInfo.name + "\0" + idNum++;
      } while (idMap.get(keyInfo.id));
    }
    idMap.set(keyInfo.id, item);
  });
}
function keyExistAndEqual(attr, obj1, obj2) {
  var key1 = convertOptionIdName(obj1[attr], null);
  var key2 = convertOptionIdName(obj2[attr], null);
  return key1 != null && key2 != null && key1 === key2;
}
function makeComparableKey(val) {
  return convertOptionIdName(val, "");
}
function convertOptionIdName(idOrName, defaultValue) {
  if (idOrName == null) {
    return defaultValue;
  }
  return isString(idOrName) ? idOrName : isNumber(idOrName) || isStringSafe(idOrName) ? idOrName + "" : defaultValue;
}
function isNameSpecified(componentModel) {
  var name = componentModel.name;
  return !!(name && name.indexOf(DUMMY_COMPONENT_NAME_PREFIX));
}
function isComponentIdInternal(cmptOption) {
  return cmptOption && cmptOption.id != null && makeComparableKey(cmptOption.id).indexOf(INTERNAL_COMPONENT_ID_PREFIX) === 0;
}
function makeInternalComponentId(idSuffix) {
  return INTERNAL_COMPONENT_ID_PREFIX + idSuffix;
}
function setComponentTypeToKeyInfo(mappingResult, mainType, componentModelCtor) {
  each$f(mappingResult, function(item) {
    var newOption = item.newOption;
    if (isObject$4(newOption)) {
      item.keyInfo.mainType = mainType;
      item.keyInfo.subType = determineSubType(mainType, newOption, item.existing, componentModelCtor);
    }
  });
}
function determineSubType(mainType, newCmptOption, existComponent, componentModelCtor) {
  var subType = newCmptOption.type ? newCmptOption.type : existComponent ? existComponent.subType : componentModelCtor.determineSubType(mainType, newCmptOption);
  return subType;
}
function compressBatches(batchA, batchB) {
  var mapA = {};
  var mapB = {};
  makeMap(batchA || [], mapA);
  makeMap(batchB || [], mapB, mapA);
  return [mapToArray(mapA), mapToArray(mapB)];
  function makeMap(sourceBatch, map2, otherMap) {
    for (var i = 0, len2 = sourceBatch.length; i < len2; i++) {
      var seriesId = convertOptionIdName(sourceBatch[i].seriesId, null);
      if (seriesId == null) {
        return;
      }
      var dataIndices = normalizeToArray(sourceBatch[i].dataIndex);
      var otherDataIndices = otherMap && otherMap[seriesId];
      for (var j = 0, lenj = dataIndices.length; j < lenj; j++) {
        var dataIndex = dataIndices[j];
        if (otherDataIndices && otherDataIndices[dataIndex]) {
          otherDataIndices[dataIndex] = null;
        } else {
          (map2[seriesId] || (map2[seriesId] = {}))[dataIndex] = 1;
        }
      }
    }
  }
  function mapToArray(map2, isData) {
    var result = [];
    for (var i in map2) {
      if (map2.hasOwnProperty(i) && map2[i] != null) {
        if (isData) {
          result.push(+i);
        } else {
          var dataIndices = mapToArray(map2[i], true);
          dataIndices.length && result.push({
            seriesId: i,
            dataIndex: dataIndices
          });
        }
      }
    }
    return result;
  }
}
function queryDataIndex(data, payload) {
  if (payload.dataIndexInside != null) {
    return payload.dataIndexInside;
  } else if (payload.dataIndex != null) {
    return isArray$1(payload.dataIndex) ? map$1(payload.dataIndex, function(value) {
      return data.indexOfRawIndex(value);
    }) : data.indexOfRawIndex(payload.dataIndex);
  } else if (payload.name != null) {
    return isArray$1(payload.name) ? map$1(payload.name, function(value) {
      return data.indexOfName(value);
    }) : data.indexOfName(payload.name);
  }
}
function makeInner() {
  var key = "__ec_inner_" + innerUniqueIndex++;
  return function(hostObj) {
    return hostObj[key] || (hostObj[key] = {});
  };
}
var innerUniqueIndex = getRandomIdBase();
function parseFinder$1(ecModel, finderInput, opt) {
  var _a2 = preParseFinder(finderInput, opt), mainTypeSpecified = _a2.mainTypeSpecified, queryOptionMap = _a2.queryOptionMap, others = _a2.others;
  var result = others;
  var defaultMainType = opt ? opt.defaultMainType : null;
  if (!mainTypeSpecified && defaultMainType) {
    queryOptionMap.set(defaultMainType, {});
  }
  queryOptionMap.each(function(queryOption, mainType) {
    var queryResult = queryReferringComponents(ecModel, mainType, queryOption, {
      useDefault: defaultMainType === mainType,
      enableAll: opt && opt.enableAll != null ? opt.enableAll : true,
      enableNone: opt && opt.enableNone != null ? opt.enableNone : true
    });
    result[mainType + "Models"] = queryResult.models;
    result[mainType + "Model"] = queryResult.models[0];
  });
  return result;
}
function preParseFinder(finderInput, opt) {
  var finder;
  if (isString(finderInput)) {
    var obj = {};
    obj[finderInput + "Index"] = 0;
    finder = obj;
  } else {
    finder = finderInput;
  }
  var queryOptionMap = createHashMap();
  var others = {};
  var mainTypeSpecified = false;
  each$f(finder, function(value, key) {
    if (key === "dataIndex" || key === "dataIndexInside") {
      others[key] = value;
      return;
    }
    var parsedKey = key.match(/^(\w+)(Index|Id|Name)$/) || [];
    var mainType = parsedKey[1];
    var queryType = (parsedKey[2] || "").toLowerCase();
    if (!mainType || !queryType || opt && opt.includeMainTypes && indexOf(opt.includeMainTypes, mainType) < 0) {
      return;
    }
    mainTypeSpecified = mainTypeSpecified || !!mainType;
    var queryOption = queryOptionMap.get(mainType) || queryOptionMap.set(mainType, {});
    queryOption[queryType] = value;
  });
  return {
    mainTypeSpecified,
    queryOptionMap,
    others
  };
}
var SINGLE_REFERRING = {
  useDefault: true,
  enableAll: false,
  enableNone: false
};
var MULTIPLE_REFERRING = {
  useDefault: false,
  enableAll: true,
  enableNone: true
};
function queryReferringComponents(ecModel, mainType, userOption, opt) {
  opt = opt || SINGLE_REFERRING;
  var indexOption = userOption.index;
  var idOption = userOption.id;
  var nameOption = userOption.name;
  var result = {
    models: null,
    specified: indexOption != null || idOption != null || nameOption != null
  };
  if (!result.specified) {
    var firstCmpt = void 0;
    result.models = opt.useDefault && (firstCmpt = ecModel.getComponent(mainType)) ? [firstCmpt] : [];
    return result;
  }
  if (indexOption === "none" || indexOption === false) {
    assert(opt.enableNone, '`"none"` or `false` is not a valid value on index option.');
    result.models = [];
    return result;
  }
  if (indexOption === "all") {
    assert(opt.enableAll, '`"all"` is not a valid value on index option.');
    indexOption = idOption = nameOption = null;
  }
  result.models = ecModel.queryComponents({
    mainType,
    index: indexOption,
    id: idOption,
    name: nameOption
  });
  return result;
}
function setAttribute(dom, key, value) {
  dom.setAttribute ? dom.setAttribute(key, value) : dom[key] = value;
}
function getAttribute(dom, key) {
  return dom.getAttribute ? dom.getAttribute(key) : dom[key];
}
function getTooltipRenderMode(renderModeOption) {
  if (renderModeOption === "auto") {
    return env$1.domSupported ? "html" : "richText";
  } else {
    return renderModeOption || "html";
  }
}
function groupData(array4, getKey2) {
  var buckets = createHashMap();
  var keys2 = [];
  each$f(array4, function(item) {
    var key = getKey2(item);
    (buckets.get(key) || (keys2.push(key), buckets.set(key, []))).push(item);
  });
  return {
    keys: keys2,
    buckets
  };
}
function interpolateRawValues(data, precision, sourceValue, targetValue, percent) {
  var isAutoPrecision = precision == null || precision === "auto";
  if (targetValue == null) {
    return targetValue;
  }
  if (isNumber(targetValue)) {
    var value = interpolateNumber(sourceValue || 0, targetValue, percent);
    return round$3(value, isAutoPrecision ? Math.max(getPrecision(sourceValue || 0), getPrecision(targetValue)) : precision);
  } else if (isString(targetValue)) {
    return percent < 1 ? sourceValue : targetValue;
  } else {
    var interpolated = [];
    var leftArr = sourceValue;
    var rightArr = targetValue;
    var length_1 = Math.max(leftArr ? leftArr.length : 0, rightArr.length);
    for (var i = 0; i < length_1; ++i) {
      var info = data.getDimensionInfo(i);
      if (info && info.type === "ordinal") {
        interpolated[i] = (percent < 1 && leftArr ? leftArr : rightArr)[i];
      } else {
        var leftVal = leftArr && leftArr[i] ? leftArr[i] : 0;
        var rightVal = rightArr[i];
        var value = interpolateNumber(leftVal, rightVal, percent);
        interpolated[i] = round$3(value, isAutoPrecision ? Math.max(getPrecision(leftVal), getPrecision(rightVal)) : precision);
      }
    }
    return interpolated;
  }
}
var TYPE_DELIMITER = ".";
var IS_CONTAINER = "___EC__COMPONENT__CONTAINER___";
var IS_EXTENDED_CLASS = "___EC__EXTENDED_CLASS___";
function parseClassType(componentType) {
  var ret = {
    main: "",
    sub: ""
  };
  if (componentType) {
    var typeArr = componentType.split(TYPE_DELIMITER);
    ret.main = typeArr[0] || "";
    ret.sub = typeArr[1] || "";
  }
  return ret;
}
function checkClassType(componentType) {
  assert(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(componentType), 'componentType "' + componentType + '" illegal');
}
function isExtendedClass(clz) {
  return !!(clz && clz[IS_EXTENDED_CLASS]);
}
function enableClassExtend(rootClz, mandatoryMethods) {
  rootClz.$constructor = rootClz;
  rootClz.extend = function(proto2) {
    var superClass = this;
    var ExtendedClass;
    if (isESClass(superClass)) {
      ExtendedClass = function(_super) {
        __extends(class_1, _super);
        function class_1() {
          return _super.apply(this, arguments) || this;
        }
        return class_1;
      }(superClass);
    } else {
      ExtendedClass = function() {
        (proto2.$constructor || superClass).apply(this, arguments);
      };
      inherits(ExtendedClass, this);
    }
    extend(ExtendedClass.prototype, proto2);
    ExtendedClass[IS_EXTENDED_CLASS] = true;
    ExtendedClass.extend = this.extend;
    ExtendedClass.superCall = superCall;
    ExtendedClass.superApply = superApply;
    ExtendedClass.superClass = superClass;
    return ExtendedClass;
  };
}
function isESClass(fn) {
  return isFunction(fn) && /^class\s/.test(Function.prototype.toString.call(fn));
}
function mountExtend(SubClz, SupperClz) {
  SubClz.extend = SupperClz.extend;
}
var classBase = Math.round(Math.random() * 10);
function enableClassCheck(target) {
  var classAttr = ["__\0is_clz", classBase++].join("_");
  target.prototype[classAttr] = true;
  target.isInstance = function(obj) {
    return !!(obj && obj[classAttr]);
  };
}
function superCall(context, methodName) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return this.superClass.prototype[methodName].apply(context, args);
}
function superApply(context, methodName, args) {
  return this.superClass.prototype[methodName].apply(context, args);
}
function enableClassManagement(target) {
  var storage2 = {};
  target.registerClass = function(clz) {
    var componentFullType = clz.type || clz.prototype.type;
    if (componentFullType) {
      checkClassType(componentFullType);
      clz.prototype.type = componentFullType;
      var componentTypeInfo = parseClassType(componentFullType);
      if (!componentTypeInfo.sub) {
        storage2[componentTypeInfo.main] = clz;
      } else if (componentTypeInfo.sub !== IS_CONTAINER) {
        var container2 = makeContainer(componentTypeInfo);
        container2[componentTypeInfo.sub] = clz;
      }
    }
    return clz;
  };
  target.getClass = function(mainType, subType, throwWhenNotFound) {
    var clz = storage2[mainType];
    if (clz && clz[IS_CONTAINER]) {
      clz = subType ? clz[subType] : null;
    }
    if (throwWhenNotFound && !clz) {
      throw new Error(!subType ? mainType + ".type should be specified." : "Component " + mainType + "." + (subType || "") + " is used but not imported.");
    }
    return clz;
  };
  target.getClassesByMainType = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var result = [];
    var obj = storage2[componentTypeInfo.main];
    if (obj && obj[IS_CONTAINER]) {
      each$f(obj, function(o, type4) {
        type4 !== IS_CONTAINER && result.push(o);
      });
    } else {
      result.push(obj);
    }
    return result;
  };
  target.hasClass = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    return !!storage2[componentTypeInfo.main];
  };
  target.getAllClassMainTypes = function() {
    var types2 = [];
    each$f(storage2, function(obj, type4) {
      types2.push(type4);
    });
    return types2;
  };
  target.hasSubTypes = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var obj = storage2[componentTypeInfo.main];
    return obj && obj[IS_CONTAINER];
  };
  function makeContainer(componentTypeInfo) {
    var container2 = storage2[componentTypeInfo.main];
    if (!container2 || !container2[IS_CONTAINER]) {
      container2 = storage2[componentTypeInfo.main] = {};
      container2[IS_CONTAINER] = true;
    }
    return container2;
  }
}
function makeStyleMapper(properties, ignoreParent) {
  for (var i = 0; i < properties.length; i++) {
    if (!properties[i][1]) {
      properties[i][1] = properties[i][0];
    }
  }
  ignoreParent = ignoreParent || false;
  return function(model, excludes, includes) {
    var style = {};
    for (var i2 = 0; i2 < properties.length; i2++) {
      var propName = properties[i2][1];
      if (excludes && indexOf(excludes, propName) >= 0 || includes && indexOf(includes, propName) < 0) {
        continue;
      }
      var val = model.getShallow(propName, ignoreParent);
      if (val != null) {
        style[properties[i2][0]] = val;
      }
    }
    return style;
  };
}
var AREA_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["opacity"],
  ["shadowColor"]
];
var getAreaStyle = makeStyleMapper(AREA_STYLE_KEY_MAP);
var AreaStyleMixin = function() {
  function AreaStyleMixin2() {
  }
  AreaStyleMixin2.prototype.getAreaStyle = function(excludes, includes) {
    return getAreaStyle(this, excludes, includes);
  };
  return AreaStyleMixin2;
}();
var globalImageCache = new LRU$1(50);
function findExistImage(newImageOrSrc) {
  if (typeof newImageOrSrc === "string") {
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    return cachedImgObj && cachedImgObj.image;
  } else {
    return newImageOrSrc;
  }
}
function createOrUpdateImage(newImageOrSrc, image, hostEl, onload, cbPayload) {
  if (!newImageOrSrc) {
    return image;
  } else if (typeof newImageOrSrc === "string") {
    if (image && image.__zrImageSrc === newImageOrSrc || !hostEl) {
      return image;
    }
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    var pendingWrap = { hostEl, cb: onload, cbPayload };
    if (cachedImgObj) {
      image = cachedImgObj.image;
      !isImageReady(image) && cachedImgObj.pending.push(pendingWrap);
    } else {
      var image_1 = platformApi.loadImage(newImageOrSrc, imageOnLoad, imageOnLoad);
      image_1.__zrImageSrc = newImageOrSrc;
      globalImageCache.put(newImageOrSrc, image_1.__cachedImgObj = {
        image: image_1,
        pending: [pendingWrap]
      });
    }
    return image;
  } else {
    return newImageOrSrc;
  }
}
function imageOnLoad() {
  var cachedImgObj = this.__cachedImgObj;
  this.onload = this.onerror = this.__cachedImgObj = null;
  for (var i = 0; i < cachedImgObj.pending.length; i++) {
    var pendingWrap = cachedImgObj.pending[i];
    var cb = pendingWrap.cb;
    cb && cb(this, pendingWrap.cbPayload);
    pendingWrap.hostEl.dirty();
  }
  cachedImgObj.pending.length = 0;
}
function isImageReady(image) {
  return image && image.width && image.height;
}
var STYLE_REG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
function truncateText(text, containerWidth, font, ellipsis, options) {
  if (!containerWidth) {
    return "";
  }
  var textLines = (text + "").split("\n");
  options = prepareTruncateOptions(containerWidth, font, ellipsis, options);
  for (var i = 0, len2 = textLines.length; i < len2; i++) {
    textLines[i] = truncateSingleLine(textLines[i], options);
  }
  return textLines.join("\n");
}
function prepareTruncateOptions(containerWidth, font, ellipsis, options) {
  options = options || {};
  var preparedOpts = extend({}, options);
  preparedOpts.font = font;
  ellipsis = retrieve2(ellipsis, "...");
  preparedOpts.maxIterations = retrieve2(options.maxIterations, 2);
  var minChar = preparedOpts.minChar = retrieve2(options.minChar, 0);
  preparedOpts.cnCharWidth = getWidth("\u56FD", font);
  var ascCharWidth = preparedOpts.ascCharWidth = getWidth("a", font);
  preparedOpts.placeholder = retrieve2(options.placeholder, "");
  var contentWidth = containerWidth = Math.max(0, containerWidth - 1);
  for (var i = 0; i < minChar && contentWidth >= ascCharWidth; i++) {
    contentWidth -= ascCharWidth;
  }
  var ellipsisWidth = getWidth(ellipsis, font);
  if (ellipsisWidth > contentWidth) {
    ellipsis = "";
    ellipsisWidth = 0;
  }
  contentWidth = containerWidth - ellipsisWidth;
  preparedOpts.ellipsis = ellipsis;
  preparedOpts.ellipsisWidth = ellipsisWidth;
  preparedOpts.contentWidth = contentWidth;
  preparedOpts.containerWidth = containerWidth;
  return preparedOpts;
}
function truncateSingleLine(textLine, options) {
  var containerWidth = options.containerWidth;
  var font = options.font;
  var contentWidth = options.contentWidth;
  if (!containerWidth) {
    return "";
  }
  var lineWidth = getWidth(textLine, font);
  if (lineWidth <= containerWidth) {
    return textLine;
  }
  for (var j = 0; ; j++) {
    if (lineWidth <= contentWidth || j >= options.maxIterations) {
      textLine += options.ellipsis;
      break;
    }
    var subLength = j === 0 ? estimateLength(textLine, contentWidth, options.ascCharWidth, options.cnCharWidth) : lineWidth > 0 ? Math.floor(textLine.length * contentWidth / lineWidth) : 0;
    textLine = textLine.substr(0, subLength);
    lineWidth = getWidth(textLine, font);
  }
  if (textLine === "") {
    textLine = options.placeholder;
  }
  return textLine;
}
function estimateLength(text, contentWidth, ascCharWidth, cnCharWidth) {
  var width = 0;
  var i = 0;
  for (var len2 = text.length; i < len2 && width < contentWidth; i++) {
    var charCode = text.charCodeAt(i);
    width += 0 <= charCode && charCode <= 127 ? ascCharWidth : cnCharWidth;
  }
  return i;
}
function parsePlainText(text, style) {
  text != null && (text += "");
  var overflow = style.overflow;
  var padding = style.padding;
  var font = style.font;
  var truncate = overflow === "truncate";
  var calculatedLineHeight = getLineHeight(font);
  var lineHeight = retrieve2(style.lineHeight, calculatedLineHeight);
  var bgColorDrawn = !!style.backgroundColor;
  var truncateLineOverflow = style.lineOverflow === "truncate";
  var width = style.width;
  var lines;
  if (width != null && (overflow === "break" || overflow === "breakAll")) {
    lines = text ? wrapText(text, style.font, width, overflow === "breakAll", 0).lines : [];
  } else {
    lines = text ? text.split("\n") : [];
  }
  var contentHeight = lines.length * lineHeight;
  var height = retrieve2(style.height, contentHeight);
  if (contentHeight > height && truncateLineOverflow) {
    var lineCount = Math.floor(height / lineHeight);
    lines = lines.slice(0, lineCount);
  }
  if (text && truncate && width != null) {
    var options = prepareTruncateOptions(width, font, style.ellipsis, {
      minChar: style.truncateMinChar,
      placeholder: style.placeholder
    });
    for (var i = 0; i < lines.length; i++) {
      lines[i] = truncateSingleLine(lines[i], options);
    }
  }
  var outerHeight = height;
  var contentWidth = 0;
  for (var i = 0; i < lines.length; i++) {
    contentWidth = Math.max(getWidth(lines[i], font), contentWidth);
  }
  if (width == null) {
    width = contentWidth;
  }
  var outerWidth = contentWidth;
  if (padding) {
    outerHeight += padding[0] + padding[2];
    outerWidth += padding[1] + padding[3];
    width += padding[1] + padding[3];
  }
  if (bgColorDrawn) {
    outerWidth = width;
  }
  return {
    lines,
    height,
    outerWidth,
    outerHeight,
    lineHeight,
    calculatedLineHeight,
    contentWidth,
    contentHeight,
    width
  };
}
var RichTextToken = function() {
  function RichTextToken2() {
  }
  return RichTextToken2;
}();
var RichTextLine = function() {
  function RichTextLine2(tokens) {
    this.tokens = [];
    if (tokens) {
      this.tokens = tokens;
    }
  }
  return RichTextLine2;
}();
var RichTextContentBlock = function() {
  function RichTextContentBlock2() {
    this.width = 0;
    this.height = 0;
    this.contentWidth = 0;
    this.contentHeight = 0;
    this.outerWidth = 0;
    this.outerHeight = 0;
    this.lines = [];
  }
  return RichTextContentBlock2;
}();
function parseRichText(text, style) {
  var contentBlock = new RichTextContentBlock();
  text != null && (text += "");
  if (!text) {
    return contentBlock;
  }
  var topWidth = style.width;
  var topHeight = style.height;
  var overflow = style.overflow;
  var wrapInfo = (overflow === "break" || overflow === "breakAll") && topWidth != null ? { width: topWidth, accumWidth: 0, breakAll: overflow === "breakAll" } : null;
  var lastIndex = STYLE_REG.lastIndex = 0;
  var result;
  while ((result = STYLE_REG.exec(text)) != null) {
    var matchedIndex = result.index;
    if (matchedIndex > lastIndex) {
      pushTokens(contentBlock, text.substring(lastIndex, matchedIndex), style, wrapInfo);
    }
    pushTokens(contentBlock, result[2], style, wrapInfo, result[1]);
    lastIndex = STYLE_REG.lastIndex;
  }
  if (lastIndex < text.length) {
    pushTokens(contentBlock, text.substring(lastIndex, text.length), style, wrapInfo);
  }
  var pendingList = [];
  var calculatedHeight = 0;
  var calculatedWidth = 0;
  var stlPadding = style.padding;
  var truncate = overflow === "truncate";
  var truncateLine = style.lineOverflow === "truncate";
  function finishLine(line2, lineWidth2, lineHeight2) {
    line2.width = lineWidth2;
    line2.lineHeight = lineHeight2;
    calculatedHeight += lineHeight2;
    calculatedWidth = Math.max(calculatedWidth, lineWidth2);
  }
  outer:
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var lineHeight = 0;
      var lineWidth = 0;
      for (var j = 0; j < line.tokens.length; j++) {
        var token = line.tokens[j];
        var tokenStyle = token.styleName && style.rich[token.styleName] || {};
        var textPadding = token.textPadding = tokenStyle.padding;
        var paddingH = textPadding ? textPadding[1] + textPadding[3] : 0;
        var font = token.font = tokenStyle.font || style.font;
        token.contentHeight = getLineHeight(font);
        var tokenHeight = retrieve2(tokenStyle.height, token.contentHeight);
        token.innerHeight = tokenHeight;
        textPadding && (tokenHeight += textPadding[0] + textPadding[2]);
        token.height = tokenHeight;
        token.lineHeight = retrieve3(tokenStyle.lineHeight, style.lineHeight, tokenHeight);
        token.align = tokenStyle && tokenStyle.align || style.align;
        token.verticalAlign = tokenStyle && tokenStyle.verticalAlign || "middle";
        if (truncateLine && topHeight != null && calculatedHeight + token.lineHeight > topHeight) {
          if (j > 0) {
            line.tokens = line.tokens.slice(0, j);
            finishLine(line, lineWidth, lineHeight);
            contentBlock.lines = contentBlock.lines.slice(0, i + 1);
          } else {
            contentBlock.lines = contentBlock.lines.slice(0, i);
          }
          break outer;
        }
        var styleTokenWidth = tokenStyle.width;
        var tokenWidthNotSpecified = styleTokenWidth == null || styleTokenWidth === "auto";
        if (typeof styleTokenWidth === "string" && styleTokenWidth.charAt(styleTokenWidth.length - 1) === "%") {
          token.percentWidth = styleTokenWidth;
          pendingList.push(token);
          token.contentWidth = getWidth(token.text, font);
        } else {
          if (tokenWidthNotSpecified) {
            var textBackgroundColor = tokenStyle.backgroundColor;
            var bgImg = textBackgroundColor && textBackgroundColor.image;
            if (bgImg) {
              bgImg = findExistImage(bgImg);
              if (isImageReady(bgImg)) {
                token.width = Math.max(token.width, bgImg.width * tokenHeight / bgImg.height);
              }
            }
          }
          var remainTruncWidth = truncate && topWidth != null ? topWidth - lineWidth : null;
          if (remainTruncWidth != null && remainTruncWidth < token.width) {
            if (!tokenWidthNotSpecified || remainTruncWidth < paddingH) {
              token.text = "";
              token.width = token.contentWidth = 0;
            } else {
              token.text = truncateText(token.text, remainTruncWidth - paddingH, font, style.ellipsis, { minChar: style.truncateMinChar });
              token.width = token.contentWidth = getWidth(token.text, font);
            }
          } else {
            token.contentWidth = getWidth(token.text, font);
          }
        }
        token.width += paddingH;
        lineWidth += token.width;
        tokenStyle && (lineHeight = Math.max(lineHeight, token.lineHeight));
      }
      finishLine(line, lineWidth, lineHeight);
    }
  contentBlock.outerWidth = contentBlock.width = retrieve2(topWidth, calculatedWidth);
  contentBlock.outerHeight = contentBlock.height = retrieve2(topHeight, calculatedHeight);
  contentBlock.contentHeight = calculatedHeight;
  contentBlock.contentWidth = calculatedWidth;
  if (stlPadding) {
    contentBlock.outerWidth += stlPadding[1] + stlPadding[3];
    contentBlock.outerHeight += stlPadding[0] + stlPadding[2];
  }
  for (var i = 0; i < pendingList.length; i++) {
    var token = pendingList[i];
    var percentWidth = token.percentWidth;
    token.width = parseInt(percentWidth, 10) / 100 * contentBlock.width;
  }
  return contentBlock;
}
function pushTokens(block, str, style, wrapInfo, styleName) {
  var isEmptyStr = str === "";
  var tokenStyle = styleName && style.rich[styleName] || {};
  var lines = block.lines;
  var font = tokenStyle.font || style.font;
  var newLine = false;
  var strLines;
  var linesWidths;
  if (wrapInfo) {
    var tokenPadding = tokenStyle.padding;
    var tokenPaddingH = tokenPadding ? tokenPadding[1] + tokenPadding[3] : 0;
    if (tokenStyle.width != null && tokenStyle.width !== "auto") {
      var outerWidth_1 = parsePercent$1(tokenStyle.width, wrapInfo.width) + tokenPaddingH;
      if (lines.length > 0) {
        if (outerWidth_1 + wrapInfo.accumWidth > wrapInfo.width) {
          strLines = str.split("\n");
          newLine = true;
        }
      }
      wrapInfo.accumWidth = outerWidth_1;
    } else {
      var res = wrapText(str, font, wrapInfo.width, wrapInfo.breakAll, wrapInfo.accumWidth);
      wrapInfo.accumWidth = res.accumWidth + tokenPaddingH;
      linesWidths = res.linesWidths;
      strLines = res.lines;
    }
  } else {
    strLines = str.split("\n");
  }
  for (var i = 0; i < strLines.length; i++) {
    var text = strLines[i];
    var token = new RichTextToken();
    token.styleName = styleName;
    token.text = text;
    token.isLineHolder = !text && !isEmptyStr;
    if (typeof tokenStyle.width === "number") {
      token.width = tokenStyle.width;
    } else {
      token.width = linesWidths ? linesWidths[i] : getWidth(text, font);
    }
    if (!i && !newLine) {
      var tokens = (lines[lines.length - 1] || (lines[0] = new RichTextLine())).tokens;
      var tokensLen = tokens.length;
      tokensLen === 1 && tokens[0].isLineHolder ? tokens[0] = token : (text || !tokensLen || isEmptyStr) && tokens.push(token);
    } else {
      lines.push(new RichTextLine([token]));
    }
  }
}
function isLatin(ch) {
  var code = ch.charCodeAt(0);
  return code >= 33 && code <= 383;
}
var breakCharMap = reduce(",&?/;] ".split(""), function(obj, ch) {
  obj[ch] = true;
  return obj;
}, {});
function isWordBreakChar(ch) {
  if (isLatin(ch)) {
    if (breakCharMap[ch]) {
      return true;
    }
    return false;
  }
  return true;
}
function wrapText(text, font, lineWidth, isBreakAll, lastAccumWidth) {
  var lines = [];
  var linesWidths = [];
  var line = "";
  var currentWord = "";
  var currentWordWidth = 0;
  var accumWidth = 0;
  for (var i = 0; i < text.length; i++) {
    var ch = text.charAt(i);
    if (ch === "\n") {
      if (currentWord) {
        line += currentWord;
        accumWidth += currentWordWidth;
      }
      lines.push(line);
      linesWidths.push(accumWidth);
      line = "";
      currentWord = "";
      currentWordWidth = 0;
      accumWidth = 0;
      continue;
    }
    var chWidth = getWidth(ch, font);
    var inWord = isBreakAll ? false : !isWordBreakChar(ch);
    if (!lines.length ? lastAccumWidth + accumWidth + chWidth > lineWidth : accumWidth + chWidth > lineWidth) {
      if (!accumWidth) {
        if (inWord) {
          lines.push(currentWord);
          linesWidths.push(currentWordWidth);
          currentWord = ch;
          currentWordWidth = chWidth;
        } else {
          lines.push(ch);
          linesWidths.push(chWidth);
        }
      } else if (line || currentWord) {
        if (inWord) {
          if (!line) {
            line = currentWord;
            currentWord = "";
            currentWordWidth = 0;
            accumWidth = currentWordWidth;
          }
          lines.push(line);
          linesWidths.push(accumWidth - currentWordWidth);
          currentWord += ch;
          currentWordWidth += chWidth;
          line = "";
          accumWidth = currentWordWidth;
        } else {
          if (currentWord) {
            line += currentWord;
            currentWord = "";
            currentWordWidth = 0;
          }
          lines.push(line);
          linesWidths.push(accumWidth);
          line = ch;
          accumWidth = chWidth;
        }
      }
      continue;
    }
    accumWidth += chWidth;
    if (inWord) {
      currentWord += ch;
      currentWordWidth += chWidth;
    } else {
      if (currentWord) {
        line += currentWord;
        currentWord = "";
        currentWordWidth = 0;
      }
      line += ch;
    }
  }
  if (!lines.length && !line) {
    line = text;
    currentWord = "";
    currentWordWidth = 0;
  }
  if (currentWord) {
    line += currentWord;
  }
  if (line) {
    lines.push(line);
    linesWidths.push(accumWidth);
  }
  if (lines.length === 1) {
    accumWidth += lastAccumWidth;
  }
  return {
    accumWidth,
    lines,
    linesWidths
  };
}
var STYLE_MAGIC_KEY = "__zr_style_" + Math.round(Math.random() * 10);
var DEFAULT_COMMON_STYLE = {
  shadowBlur: 0,
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowColor: "#000",
  opacity: 1,
  blend: "source-over"
};
var DEFAULT_COMMON_ANIMATION_PROPS = {
  style: {
    shadowBlur: true,
    shadowOffsetX: true,
    shadowOffsetY: true,
    shadowColor: true,
    opacity: true
  }
};
DEFAULT_COMMON_STYLE[STYLE_MAGIC_KEY] = true;
var PRIMARY_STATES_KEYS = ["z", "z2", "invisible"];
var PRIMARY_STATES_KEYS_IN_HOVER_LAYER = ["invisible"];
var Displayable = function(_super) {
  __extends(Displayable2, _super);
  function Displayable2(props) {
    return _super.call(this, props) || this;
  }
  Displayable2.prototype._init = function(props) {
    var keysArr = keys(props);
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      if (key === "style") {
        this.useStyle(props[key]);
      } else {
        _super.prototype.attrKV.call(this, key, props[key]);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Displayable2.prototype.beforeBrush = function() {
  };
  Displayable2.prototype.afterBrush = function() {
  };
  Displayable2.prototype.innerBeforeBrush = function() {
  };
  Displayable2.prototype.innerAfterBrush = function() {
  };
  Displayable2.prototype.shouldBePainted = function(viewWidth, viewHeight, considerClipPath, considerAncestors) {
    var m2 = this.transform;
    if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && isDisplayableCulled(this, viewWidth, viewHeight) || m2 && !m2[0] && !m2[3]) {
      return false;
    }
    if (considerClipPath && this.__clipPaths) {
      for (var i = 0; i < this.__clipPaths.length; ++i) {
        if (this.__clipPaths[i].isZeroArea()) {
          return false;
        }
      }
    }
    if (considerAncestors && this.parent) {
      var parent_1 = this.parent;
      while (parent_1) {
        if (parent_1.ignore) {
          return false;
        }
        parent_1 = parent_1.parent;
      }
    }
    return true;
  };
  Displayable2.prototype.contain = function(x2, y2) {
    return this.rectContain(x2, y2);
  };
  Displayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  Displayable2.prototype.rectContain = function(x2, y2) {
    var coord = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    return rect.contain(coord[0], coord[1]);
  };
  Displayable2.prototype.getPaintRect = function() {
    var rect = this._paintRect;
    if (!this._paintRect || this.__dirty) {
      var transform2 = this.transform;
      var elRect = this.getBoundingRect();
      var style = this.style;
      var shadowSize = style.shadowBlur || 0;
      var shadowOffsetX = style.shadowOffsetX || 0;
      var shadowOffsetY = style.shadowOffsetY || 0;
      rect = this._paintRect || (this._paintRect = new BoundingRect$1(0, 0, 0, 0));
      if (transform2) {
        BoundingRect$1.applyTransform(rect, elRect, transform2);
      } else {
        rect.copy(elRect);
      }
      if (shadowSize || shadowOffsetX || shadowOffsetY) {
        rect.width += shadowSize * 2 + Math.abs(shadowOffsetX);
        rect.height += shadowSize * 2 + Math.abs(shadowOffsetY);
        rect.x = Math.min(rect.x, rect.x + shadowOffsetX - shadowSize);
        rect.y = Math.min(rect.y, rect.y + shadowOffsetY - shadowSize);
      }
      var tolerance = this.dirtyRectTolerance;
      if (!rect.isZero()) {
        rect.x = Math.floor(rect.x - tolerance);
        rect.y = Math.floor(rect.y - tolerance);
        rect.width = Math.ceil(rect.width + 1 + tolerance * 2);
        rect.height = Math.ceil(rect.height + 1 + tolerance * 2);
      }
    }
    return rect;
  };
  Displayable2.prototype.setPrevPaintRect = function(paintRect) {
    if (paintRect) {
      this._prevPaintRect = this._prevPaintRect || new BoundingRect$1(0, 0, 0, 0);
      this._prevPaintRect.copy(paintRect);
    } else {
      this._prevPaintRect = null;
    }
  };
  Displayable2.prototype.getPrevPaintRect = function() {
    return this._prevPaintRect;
  };
  Displayable2.prototype.animateStyle = function(loop) {
    return this.animate("style", loop);
  };
  Displayable2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else {
      this.markRedraw();
    }
  };
  Displayable2.prototype.attrKV = function(key, value) {
    if (key !== "style") {
      _super.prototype.attrKV.call(this, key, value);
    } else {
      if (!this.style) {
        this.useStyle(value);
      } else {
        this.setStyle(value);
      }
    }
  };
  Displayable2.prototype.setStyle = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.style[keyOrObj] = value;
    } else {
      extend(this.style, keyOrObj);
    }
    this.dirtyStyle();
    return this;
  };
  Displayable2.prototype.dirtyStyle = function(notRedraw) {
    if (!notRedraw) {
      this.markRedraw();
    }
    this.__dirty |= STYLE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
  };
  Displayable2.prototype.dirty = function() {
    this.dirtyStyle();
  };
  Displayable2.prototype.styleChanged = function() {
    return !!(this.__dirty & STYLE_CHANGED_BIT);
  };
  Displayable2.prototype.styleUpdated = function() {
    this.__dirty &= ~STYLE_CHANGED_BIT;
  };
  Displayable2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_COMMON_STYLE, obj);
  };
  Displayable2.prototype.useStyle = function(obj) {
    if (!obj[STYLE_MAGIC_KEY]) {
      obj = this.createStyle(obj);
    }
    if (this.__inHover) {
      this.__hoverStyle = obj;
    } else {
      this.style = obj;
    }
    this.dirtyStyle();
  };
  Displayable2.prototype.isStyleObject = function(obj) {
    return obj[STYLE_MAGIC_KEY];
  };
  Displayable2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.style && !normalState.style) {
      normalState.style = this._mergeStyle(this.createStyle(), this.style);
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS);
  };
  Displayable2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetStyle;
    if (state && state.style) {
      if (transition) {
        if (keepCurrentStates) {
          targetStyle = state.style;
        } else {
          targetStyle = this._mergeStyle(this.createStyle(), normalState.style);
          this._mergeStyle(targetStyle, state.style);
        }
      } else {
        targetStyle = this._mergeStyle(this.createStyle(), keepCurrentStates ? this.style : normalState.style);
        this._mergeStyle(targetStyle, state.style);
      }
    } else if (needsRestoreToNormal) {
      targetStyle = normalState.style;
    }
    if (targetStyle) {
      if (transition) {
        var sourceStyle = this.style;
        this.style = this.createStyle(needsRestoreToNormal ? {} : sourceStyle);
        if (needsRestoreToNormal) {
          var changedKeys = keys(sourceStyle);
          for (var i = 0; i < changedKeys.length; i++) {
            var key = changedKeys[i];
            if (key in targetStyle) {
              targetStyle[key] = targetStyle[key];
              this.style[key] = sourceStyle[key];
            }
          }
        }
        var targetKeys = keys(targetStyle);
        for (var i = 0; i < targetKeys.length; i++) {
          var key = targetKeys[i];
          this.style[key] = this.style[key];
        }
        this._transitionState(stateName, {
          style: targetStyle
        }, animationCfg, this.getAnimationStyleProps());
      } else {
        this.useStyle(targetStyle);
      }
    }
    var statesKeys = this.__inHover ? PRIMARY_STATES_KEYS_IN_HOVER_LAYER : PRIMARY_STATES_KEYS;
    for (var i = 0; i < statesKeys.length; i++) {
      var key = statesKeys[i];
      if (state && state[key] != null) {
        this[key] = state[key];
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          this[key] = normalState[key];
        }
      }
    }
  };
  Displayable2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedStyle;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.style) {
        mergedStyle = mergedStyle || {};
        this._mergeStyle(mergedStyle, state.style);
      }
    }
    if (mergedStyle) {
      mergedState.style = mergedStyle;
    }
    return mergedState;
  };
  Displayable2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    extend(targetStyle, sourceStyle);
    return targetStyle;
  };
  Displayable2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_COMMON_ANIMATION_PROPS;
  };
  Displayable2.initDefaultProps = function() {
    var dispProto = Displayable2.prototype;
    dispProto.type = "displayable";
    dispProto.invisible = false;
    dispProto.z = 0;
    dispProto.z2 = 0;
    dispProto.zlevel = 0;
    dispProto.culling = false;
    dispProto.cursor = "pointer";
    dispProto.rectHover = false;
    dispProto.incremental = false;
    dispProto._rect = null;
    dispProto.dirtyRectTolerance = 0;
    dispProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT;
  }();
  return Displayable2;
}(Element$2);
var tmpRect = new BoundingRect$1(0, 0, 0, 0);
var viewRect = new BoundingRect$1(0, 0, 0, 0);
function isDisplayableCulled(el, width, height) {
  tmpRect.copy(el.getBoundingRect());
  if (el.transform) {
    tmpRect.applyTransform(el.transform);
  }
  viewRect.width = width;
  viewRect.height = height;
  return !tmpRect.intersect(viewRect);
}
var Displayable$1 = Displayable;
var mathMin$9 = Math.min;
var mathMax$9 = Math.max;
var mathSin$4 = Math.sin;
var mathCos$4 = Math.cos;
var PI2$9 = Math.PI * 2;
var start = create$2();
var end = create$2();
var extremity = create$2();
function fromPoints(points2, min3, max3) {
  if (points2.length === 0) {
    return;
  }
  var p2 = points2[0];
  var left = p2[0];
  var right = p2[0];
  var top = p2[1];
  var bottom = p2[1];
  for (var i = 1; i < points2.length; i++) {
    p2 = points2[i];
    left = mathMin$9(left, p2[0]);
    right = mathMax$9(right, p2[0]);
    top = mathMin$9(top, p2[1]);
    bottom = mathMax$9(bottom, p2[1]);
  }
  min3[0] = left;
  min3[1] = top;
  max3[0] = right;
  max3[1] = bottom;
}
function fromLine(x0, y0, x1, y1, min3, max3) {
  min3[0] = mathMin$9(x0, x1);
  min3[1] = mathMin$9(y0, y1);
  max3[0] = mathMax$9(x0, x1);
  max3[1] = mathMax$9(y0, y1);
}
var xDim = [];
var yDim = [];
function fromCubic(x0, y0, x1, y1, x2, y2, x3, y3, min3, max3) {
  var cubicExtrema$1 = cubicExtrema;
  var cubicAt$1 = cubicAt;
  var n2 = cubicExtrema$1(x0, x1, x2, x3, xDim);
  min3[0] = Infinity;
  min3[1] = Infinity;
  max3[0] = -Infinity;
  max3[1] = -Infinity;
  for (var i = 0; i < n2; i++) {
    var x4 = cubicAt$1(x0, x1, x2, x3, xDim[i]);
    min3[0] = mathMin$9(x4, min3[0]);
    max3[0] = mathMax$9(x4, max3[0]);
  }
  n2 = cubicExtrema$1(y0, y1, y2, y3, yDim);
  for (var i = 0; i < n2; i++) {
    var y4 = cubicAt$1(y0, y1, y2, y3, yDim[i]);
    min3[1] = mathMin$9(y4, min3[1]);
    max3[1] = mathMax$9(y4, max3[1]);
  }
  min3[0] = mathMin$9(x0, min3[0]);
  max3[0] = mathMax$9(x0, max3[0]);
  min3[0] = mathMin$9(x3, min3[0]);
  max3[0] = mathMax$9(x3, max3[0]);
  min3[1] = mathMin$9(y0, min3[1]);
  max3[1] = mathMax$9(y0, max3[1]);
  min3[1] = mathMin$9(y3, min3[1]);
  max3[1] = mathMax$9(y3, max3[1]);
}
function fromQuadratic(x0, y0, x1, y1, x2, y2, min3, max3) {
  var quadraticExtremum$1 = quadraticExtremum;
  var quadraticAt2 = quadraticAt$1;
  var tx = mathMax$9(mathMin$9(quadraticExtremum$1(x0, x1, x2), 1), 0);
  var ty = mathMax$9(mathMin$9(quadraticExtremum$1(y0, y1, y2), 1), 0);
  var x3 = quadraticAt2(x0, x1, x2, tx);
  var y3 = quadraticAt2(y0, y1, y2, ty);
  min3[0] = mathMin$9(x0, x2, x3);
  min3[1] = mathMin$9(y0, y2, y3);
  max3[0] = mathMax$9(x0, x2, x3);
  max3[1] = mathMax$9(y0, y2, y3);
}
function fromArc(x2, y2, rx, ry, startAngle, endAngle, anticlockwise, min3, max3) {
  var vec2Min = min$1;
  var vec2Max = max$1;
  var diff = Math.abs(startAngle - endAngle);
  if (diff % PI2$9 < 1e-4 && diff > 1e-4) {
    min3[0] = x2 - rx;
    min3[1] = y2 - ry;
    max3[0] = x2 + rx;
    max3[1] = y2 + ry;
    return;
  }
  start[0] = mathCos$4(startAngle) * rx + x2;
  start[1] = mathSin$4(startAngle) * ry + y2;
  end[0] = mathCos$4(endAngle) * rx + x2;
  end[1] = mathSin$4(endAngle) * ry + y2;
  vec2Min(min3, start, end);
  vec2Max(max3, start, end);
  startAngle = startAngle % PI2$9;
  if (startAngle < 0) {
    startAngle = startAngle + PI2$9;
  }
  endAngle = endAngle % PI2$9;
  if (endAngle < 0) {
    endAngle = endAngle + PI2$9;
  }
  if (startAngle > endAngle && !anticlockwise) {
    endAngle += PI2$9;
  } else if (startAngle < endAngle && anticlockwise) {
    startAngle += PI2$9;
  }
  if (anticlockwise) {
    var tmp = endAngle;
    endAngle = startAngle;
    startAngle = tmp;
  }
  for (var angle = 0; angle < endAngle; angle += Math.PI / 2) {
    if (angle > startAngle) {
      extremity[0] = mathCos$4(angle) * rx + x2;
      extremity[1] = mathSin$4(angle) * ry + y2;
      vec2Min(min3, extremity, min3);
      vec2Max(max3, extremity, max3);
    }
  }
}
var CMD$4 = {
  M: 1,
  L: 2,
  C: 3,
  Q: 4,
  A: 5,
  Z: 6,
  R: 7
};
var tmpOutX = [];
var tmpOutY = [];
var min = [];
var max = [];
var min2 = [];
var max2 = [];
var mathMin$8 = Math.min;
var mathMax$8 = Math.max;
var mathCos$3 = Math.cos;
var mathSin$3 = Math.sin;
var mathAbs$2 = Math.abs;
var PI$8 = Math.PI;
var PI2$8 = PI$8 * 2;
var hasTypedArray = typeof Float32Array !== "undefined";
var tmpAngles = [];
function modPI2(radian) {
  var n2 = Math.round(radian / PI$8 * 1e8) / 1e8;
  return n2 % 2 * PI$8;
}
function normalizeArcAngles(angles, anticlockwise) {
  var newStartAngle = modPI2(angles[0]);
  if (newStartAngle < 0) {
    newStartAngle += PI2$8;
  }
  var delta = newStartAngle - angles[0];
  var newEndAngle = angles[1];
  newEndAngle += delta;
  if (!anticlockwise && newEndAngle - newStartAngle >= PI2$8) {
    newEndAngle = newStartAngle + PI2$8;
  } else if (anticlockwise && newStartAngle - newEndAngle >= PI2$8) {
    newEndAngle = newStartAngle - PI2$8;
  } else if (!anticlockwise && newStartAngle > newEndAngle) {
    newEndAngle = newStartAngle + (PI2$8 - modPI2(newStartAngle - newEndAngle));
  } else if (anticlockwise && newStartAngle < newEndAngle) {
    newEndAngle = newStartAngle - (PI2$8 - modPI2(newEndAngle - newStartAngle));
  }
  angles[0] = newStartAngle;
  angles[1] = newEndAngle;
}
var PathProxy = function() {
  function PathProxy2(notSaveData) {
    this.dpr = 1;
    this._xi = 0;
    this._yi = 0;
    this._x0 = 0;
    this._y0 = 0;
    this._len = 0;
    if (notSaveData) {
      this._saveData = false;
    }
    if (this._saveData) {
      this.data = [];
    }
  }
  PathProxy2.prototype.increaseVersion = function() {
    this._version++;
  };
  PathProxy2.prototype.getVersion = function() {
    return this._version;
  };
  PathProxy2.prototype.setScale = function(sx, sy, segmentIgnoreThreshold) {
    segmentIgnoreThreshold = segmentIgnoreThreshold || 0;
    if (segmentIgnoreThreshold > 0) {
      this._ux = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sx) || 0;
      this._uy = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sy) || 0;
    }
  };
  PathProxy2.prototype.setDPR = function(dpr2) {
    this.dpr = dpr2;
  };
  PathProxy2.prototype.setContext = function(ctx) {
    this._ctx = ctx;
  };
  PathProxy2.prototype.getContext = function() {
    return this._ctx;
  };
  PathProxy2.prototype.beginPath = function() {
    this._ctx && this._ctx.beginPath();
    this.reset();
    return this;
  };
  PathProxy2.prototype.reset = function() {
    if (this._saveData) {
      this._len = 0;
    }
    if (this._pathSegLen) {
      this._pathSegLen = null;
      this._pathLen = 0;
    }
    this._version++;
  };
  PathProxy2.prototype.moveTo = function(x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.M, x2, y2);
    this._ctx && this._ctx.moveTo(x2, y2);
    this._x0 = x2;
    this._y0 = y2;
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.lineTo = function(x2, y2) {
    var dx = mathAbs$2(x2 - this._xi);
    var dy = mathAbs$2(y2 - this._yi);
    var exceedUnit = dx > this._ux || dy > this._uy;
    this.addData(CMD$4.L, x2, y2);
    if (this._ctx && exceedUnit) {
      this._ctx.lineTo(x2, y2);
    }
    if (exceedUnit) {
      this._xi = x2;
      this._yi = y2;
      this._pendingPtDist = 0;
    } else {
      var d2 = dx * dx + dy * dy;
      if (d2 > this._pendingPtDist) {
        this._pendingPtX = x2;
        this._pendingPtY = y2;
        this._pendingPtDist = d2;
      }
    }
    return this;
  };
  PathProxy2.prototype.bezierCurveTo = function(x1, y1, x2, y2, x3, y3) {
    this._drawPendingPt();
    this.addData(CMD$4.C, x1, y1, x2, y2, x3, y3);
    if (this._ctx) {
      this._ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
    }
    this._xi = x3;
    this._yi = y3;
    return this;
  };
  PathProxy2.prototype.quadraticCurveTo = function(x1, y1, x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.Q, x1, y1, x2, y2);
    if (this._ctx) {
      this._ctx.quadraticCurveTo(x1, y1, x2, y2);
    }
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this._drawPendingPt();
    tmpAngles[0] = startAngle;
    tmpAngles[1] = endAngle;
    normalizeArcAngles(tmpAngles, anticlockwise);
    startAngle = tmpAngles[0];
    endAngle = tmpAngles[1];
    var delta = endAngle - startAngle;
    this.addData(CMD$4.A, cx, cy, r2, r2, startAngle, delta, 0, anticlockwise ? 0 : 1);
    this._ctx && this._ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
    this._xi = mathCos$3(endAngle) * r2 + cx;
    this._yi = mathSin$3(endAngle) * r2 + cy;
    return this;
  };
  PathProxy2.prototype.arcTo = function(x1, y1, x2, y2, radius) {
    this._drawPendingPt();
    if (this._ctx) {
      this._ctx.arcTo(x1, y1, x2, y2, radius);
    }
    return this;
  };
  PathProxy2.prototype.rect = function(x2, y2, w2, h) {
    this._drawPendingPt();
    this._ctx && this._ctx.rect(x2, y2, w2, h);
    this.addData(CMD$4.R, x2, y2, w2, h);
    return this;
  };
  PathProxy2.prototype.closePath = function() {
    this._drawPendingPt();
    this.addData(CMD$4.Z);
    var ctx = this._ctx;
    var x0 = this._x0;
    var y0 = this._y0;
    if (ctx) {
      ctx.closePath();
    }
    this._xi = x0;
    this._yi = y0;
    return this;
  };
  PathProxy2.prototype.fill = function(ctx) {
    ctx && ctx.fill();
    this.toStatic();
  };
  PathProxy2.prototype.stroke = function(ctx) {
    ctx && ctx.stroke();
    this.toStatic();
  };
  PathProxy2.prototype.len = function() {
    return this._len;
  };
  PathProxy2.prototype.setData = function(data) {
    var len2 = data.length;
    if (!(this.data && this.data.length === len2) && hasTypedArray) {
      this.data = new Float32Array(len2);
    }
    for (var i = 0; i < len2; i++) {
      this.data[i] = data[i];
    }
    this._len = len2;
  };
  PathProxy2.prototype.appendPath = function(path) {
    if (!(path instanceof Array)) {
      path = [path];
    }
    var len2 = path.length;
    var appendSize = 0;
    var offset = this._len;
    for (var i = 0; i < len2; i++) {
      appendSize += path[i].len();
    }
    if (hasTypedArray && this.data instanceof Float32Array) {
      this.data = new Float32Array(offset + appendSize);
    }
    for (var i = 0; i < len2; i++) {
      var appendPathData = path[i].data;
      for (var k2 = 0; k2 < appendPathData.length; k2++) {
        this.data[offset++] = appendPathData[k2];
      }
    }
    this._len = offset;
  };
  PathProxy2.prototype.addData = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    if (!this._saveData) {
      return;
    }
    var data = this.data;
    if (this._len + arguments.length > data.length) {
      this._expandData();
      data = this.data;
    }
    for (var i = 0; i < arguments.length; i++) {
      data[this._len++] = arguments[i];
    }
  };
  PathProxy2.prototype._drawPendingPt = function() {
    if (this._pendingPtDist > 0) {
      this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY);
      this._pendingPtDist = 0;
    }
  };
  PathProxy2.prototype._expandData = function() {
    if (!(this.data instanceof Array)) {
      var newData = [];
      for (var i = 0; i < this._len; i++) {
        newData[i] = this.data[i];
      }
      this.data = newData;
    }
  };
  PathProxy2.prototype.toStatic = function() {
    if (!this._saveData) {
      return;
    }
    this._drawPendingPt();
    var data = this.data;
    if (data instanceof Array) {
      data.length = this._len;
      if (hasTypedArray && this._len > 11) {
        this.data = new Float32Array(data);
      }
    }
  };
  PathProxy2.prototype.getBoundingRect = function() {
    min[0] = min[1] = min2[0] = min2[1] = Number.MAX_VALUE;
    max[0] = max[1] = max2[0] = max2[1] = -Number.MAX_VALUE;
    var data = this.data;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    var i;
    for (i = 0; i < this._len; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          min2[0] = x0;
          min2[1] = y0;
          max2[0] = x0;
          max2[1] = y0;
          break;
        case CMD$4.L:
          fromLine(xi, yi, data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.C:
          fromCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.Q:
          fromQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var endAngle = data[i++] + startAngle;
          i += 1;
          var anticlockwise = !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          fromArc(cx, cy, rx, ry, startAngle, endAngle, anticlockwise, min2, max2);
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R:
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          fromLine(x0, y0, x0 + width, y0 + height, min2, max2);
          break;
        case CMD$4.Z:
          xi = x0;
          yi = y0;
          break;
      }
      min$1(min, min, min2);
      max$1(max, max, max2);
    }
    if (i === 0) {
      min[0] = min[1] = max[0] = max[1] = 0;
    }
    return new BoundingRect$1(min[0], min[1], max[0] - min[0], max[1] - min[1]);
  };
  PathProxy2.prototype._calculateLength = function() {
    var data = this.data;
    var len2 = this._len;
    var ux = this._ux;
    var uy = this._uy;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    if (!this._pathSegLen) {
      this._pathSegLen = [];
    }
    var pathSegLen = this._pathSegLen;
    var pathTotalLen = 0;
    var segCount = 0;
    for (var i = 0; i < len2; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      var l2 = -1;
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          break;
        case CMD$4.L: {
          var x2 = data[i++];
          var y2 = data[i++];
          var dx = x2 - xi;
          var dy = y2 - yi;
          if (mathAbs$2(dx) > ux || mathAbs$2(dy) > uy || i === len2 - 1) {
            l2 = Math.sqrt(dx * dx + dy * dy);
            xi = x2;
            yi = y2;
          }
          break;
        }
        case CMD$4.C: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          var x3 = data[i++];
          var y3 = data[i++];
          l2 = cubicLength(xi, yi, x1, y1, x2, y2, x3, y3, 10);
          xi = x3;
          yi = y3;
          break;
        }
        case CMD$4.Q: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          l2 = quadraticLength(xi, yi, x1, y1, x2, y2, 10);
          xi = x2;
          yi = y2;
          break;
        }
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var delta = data[i++];
          var endAngle = delta + startAngle;
          i += 1;
          !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          l2 = mathMax$8(rx, ry) * mathMin$8(PI2$8, Math.abs(delta));
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R: {
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          l2 = width * 2 + height * 2;
          break;
        }
        case CMD$4.Z: {
          var dx = x0 - xi;
          var dy = y0 - yi;
          l2 = Math.sqrt(dx * dx + dy * dy);
          xi = x0;
          yi = y0;
          break;
        }
      }
      if (l2 >= 0) {
        pathSegLen[segCount++] = l2;
        pathTotalLen += l2;
      }
    }
    this._pathLen = pathTotalLen;
    return pathTotalLen;
  };
  PathProxy2.prototype.rebuildPath = function(ctx, percent) {
    var d2 = this.data;
    var ux = this._ux;
    var uy = this._uy;
    var len2 = this._len;
    var x0;
    var y0;
    var xi;
    var yi;
    var x2;
    var y2;
    var drawPart = percent < 1;
    var pathSegLen;
    var pathTotalLen;
    var accumLength = 0;
    var segCount = 0;
    var displayedLength;
    var pendingPtDist = 0;
    var pendingPtX;
    var pendingPtY;
    if (drawPart) {
      if (!this._pathSegLen) {
        this._calculateLength();
      }
      pathSegLen = this._pathSegLen;
      pathTotalLen = this._pathLen;
      displayedLength = percent * pathTotalLen;
      if (!displayedLength) {
        return;
      }
    }
    lo:
      for (var i = 0; i < len2; ) {
        var cmd = d2[i++];
        var isFirst = i === 1;
        if (isFirst) {
          xi = d2[i];
          yi = d2[i + 1];
          x0 = xi;
          y0 = yi;
        }
        if (cmd !== CMD$4.L && pendingPtDist > 0) {
          ctx.lineTo(pendingPtX, pendingPtY);
          pendingPtDist = 0;
        }
        switch (cmd) {
          case CMD$4.M:
            x0 = xi = d2[i++];
            y0 = yi = d2[i++];
            ctx.moveTo(xi, yi);
            break;
          case CMD$4.L: {
            x2 = d2[i++];
            y2 = d2[i++];
            var dx = mathAbs$2(x2 - xi);
            var dy = mathAbs$2(y2 - yi);
            if (dx > ux || dy > uy) {
              if (drawPart) {
                var l2 = pathSegLen[segCount++];
                if (accumLength + l2 > displayedLength) {
                  var t2 = (displayedLength - accumLength) / l2;
                  ctx.lineTo(xi * (1 - t2) + x2 * t2, yi * (1 - t2) + y2 * t2);
                  break lo;
                }
                accumLength += l2;
              }
              ctx.lineTo(x2, y2);
              xi = x2;
              yi = y2;
              pendingPtDist = 0;
            } else {
              var d22 = dx * dx + dy * dy;
              if (d22 > pendingPtDist) {
                pendingPtX = x2;
                pendingPtY = y2;
                pendingPtDist = d22;
              }
            }
            break;
          }
          case CMD$4.C: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            var x3 = d2[i++];
            var y3 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                cubicSubdivide(xi, x1, x22, x3, t2, tmpOutX);
                cubicSubdivide(yi, y1, y22, y3, t2, tmpOutY);
                ctx.bezierCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2], tmpOutX[3], tmpOutY[3]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.bezierCurveTo(x1, y1, x22, y22, x3, y3);
            xi = x3;
            yi = y3;
            break;
          }
          case CMD$4.Q: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                quadraticSubdivide(xi, x1, x22, t2, tmpOutX);
                quadraticSubdivide(yi, y1, y22, t2, tmpOutY);
                ctx.quadraticCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.quadraticCurveTo(x1, y1, x22, y22);
            xi = x22;
            yi = y22;
            break;
          }
          case CMD$4.A:
            var cx = d2[i++];
            var cy = d2[i++];
            var rx = d2[i++];
            var ry = d2[i++];
            var startAngle = d2[i++];
            var delta = d2[i++];
            var psi = d2[i++];
            var anticlockwise = !d2[i++];
            var r2 = rx > ry ? rx : ry;
            var isEllipse = mathAbs$2(rx - ry) > 1e-3;
            var endAngle = startAngle + delta;
            var breakBuild = false;
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                endAngle = startAngle + delta * (displayedLength - accumLength) / l2;
                breakBuild = true;
              }
              accumLength += l2;
            }
            if (isEllipse && ctx.ellipse) {
              ctx.ellipse(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise);
            } else {
              ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
            }
            if (breakBuild) {
              break lo;
            }
            if (isFirst) {
              x0 = mathCos$3(startAngle) * rx + cx;
              y0 = mathSin$3(startAngle) * ry + cy;
            }
            xi = mathCos$3(endAngle) * rx + cx;
            yi = mathSin$3(endAngle) * ry + cy;
            break;
          case CMD$4.R:
            x0 = xi = d2[i];
            y0 = yi = d2[i + 1];
            x2 = d2[i++];
            y2 = d2[i++];
            var width = d2[i++];
            var height = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var d_1 = displayedLength - accumLength;
                ctx.moveTo(x2, y2);
                ctx.lineTo(x2 + mathMin$8(d_1, width), y2);
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + width, y2 + mathMin$8(d_1, height));
                }
                d_1 -= height;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + mathMax$8(width - d_1, 0), y2 + height);
                }
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2, y2 + mathMax$8(height - d_1, 0));
                }
                break lo;
              }
              accumLength += l2;
            }
            ctx.rect(x2, y2, width, height);
            break;
          case CMD$4.Z:
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                ctx.lineTo(xi * (1 - t2) + x0 * t2, yi * (1 - t2) + y0 * t2);
                break lo;
              }
              accumLength += l2;
            }
            ctx.closePath();
            xi = x0;
            yi = y0;
        }
      }
  };
  PathProxy2.prototype.clone = function() {
    var newProxy = new PathProxy2();
    var data = this.data;
    newProxy.data = data.slice ? data.slice() : Array.prototype.slice.call(data);
    newProxy._len = this._len;
    return newProxy;
  };
  PathProxy2.CMD = CMD$4;
  PathProxy2.initDefaultProps = function() {
    var proto2 = PathProxy2.prototype;
    proto2._saveData = true;
    proto2._ux = 0;
    proto2._uy = 0;
    proto2._pendingPtDist = 0;
    proto2._version = 0;
  }();
  return PathProxy2;
}();
var PathProxy$1 = PathProxy;
function containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  var _a2 = 0;
  var _b2 = x0;
  if (y2 > y0 + _l && y2 > y1 + _l || y2 < y0 - _l && y2 < y1 - _l || x2 > x0 + _l && x2 > x1 + _l || x2 < x0 - _l && x2 < x1 - _l) {
    return false;
  }
  if (x0 !== x1) {
    _a2 = (y0 - y1) / (x0 - x1);
    _b2 = (x0 * y1 - x1 * y0) / (x0 - x1);
  } else {
    return Math.abs(x2 - x0) <= _l / 2;
  }
  var tmp = _a2 * x2 - y2 + _b2;
  var _s = tmp * tmp / (_a2 * _a2 + 1);
  return _s <= _l / 2 * _l / 2;
}
function containStroke$3(x0, y0, x1, y1, x2, y2, x3, y3, lineWidth, x4, y4) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y4 > y0 + _l && y4 > y1 + _l && y4 > y2 + _l && y4 > y3 + _l || y4 < y0 - _l && y4 < y1 - _l && y4 < y2 - _l && y4 < y3 - _l || x4 > x0 + _l && x4 > x1 + _l && x4 > x2 + _l && x4 > x3 + _l || x4 < x0 - _l && x4 < x1 - _l && x4 < x2 - _l && x4 < x3 - _l) {
    return false;
  }
  var d2 = cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, null);
  return d2 <= _l / 2;
}
function containStroke$2(x0, y0, x1, y1, x2, y2, lineWidth, x3, y3) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y3 > y0 + _l && y3 > y1 + _l && y3 > y2 + _l || y3 < y0 - _l && y3 < y1 - _l && y3 < y2 - _l || x3 > x0 + _l && x3 > x1 + _l && x3 > x2 + _l || x3 < x0 - _l && x3 < x1 - _l && x3 < x2 - _l) {
    return false;
  }
  var d2 = quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, null);
  return d2 <= _l / 2;
}
var PI2$7 = Math.PI * 2;
function normalizeRadian(angle) {
  angle %= PI2$7;
  if (angle < 0) {
    angle += PI2$7;
  }
  return angle;
}
var PI2$6 = Math.PI * 2;
function containStroke$1(cx, cy, r2, startAngle, endAngle, anticlockwise, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  if (d2 - _l > r2 || d2 + _l < r2) {
    return false;
  }
  if (Math.abs(startAngle - endAngle) % PI2$6 < 1e-4) {
    return true;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$6;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$6;
  }
  return angle >= startAngle && angle <= endAngle || angle + PI2$6 >= startAngle && angle + PI2$6 <= endAngle;
}
function windingLine(x0, y0, x1, y1, x2, y2) {
  if (y2 > y0 && y2 > y1 || y2 < y0 && y2 < y1) {
    return 0;
  }
  if (y1 === y0) {
    return 0;
  }
  var t2 = (y2 - y0) / (y1 - y0);
  var dir3 = y1 < y0 ? 1 : -1;
  if (t2 === 1 || t2 === 0) {
    dir3 = y1 < y0 ? 0.5 : -0.5;
  }
  var x_ = t2 * (x1 - x0) + x0;
  return x_ === x2 ? Infinity : x_ > x2 ? dir3 : 0;
}
var CMD$3 = PathProxy$1.CMD;
var PI2$5 = Math.PI * 2;
var EPSILON$1 = 1e-4;
function isAroundEqual$1(a, b2) {
  return Math.abs(a - b2) < EPSILON$1;
}
var roots = [-1, -1, -1];
var extrema = [-1, -1];
function swapExtrema() {
  var tmp = extrema[0];
  extrema[0] = extrema[1];
  extrema[1] = tmp;
}
function windingCubic(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4) {
  if (y4 > y0 && y4 > y1 && y4 > y2 && y4 > y3 || y4 < y0 && y4 < y1 && y4 < y2 && y4 < y3) {
    return 0;
  }
  var nRoots = cubicRootAt(y0, y1, y2, y3, y4, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var w2 = 0;
    var nExtrema = -1;
    var y0_ = void 0;
    var y1_ = void 0;
    for (var i = 0; i < nRoots; i++) {
      var t2 = roots[i];
      var unit = t2 === 0 || t2 === 1 ? 0.5 : 1;
      var x_ = cubicAt(x0, x1, x2, x3, t2);
      if (x_ < x4) {
        continue;
      }
      if (nExtrema < 0) {
        nExtrema = cubicExtrema(y0, y1, y2, y3, extrema);
        if (extrema[1] < extrema[0] && nExtrema > 1) {
          swapExtrema();
        }
        y0_ = cubicAt(y0, y1, y2, y3, extrema[0]);
        if (nExtrema > 1) {
          y1_ = cubicAt(y0, y1, y2, y3, extrema[1]);
        }
      }
      if (nExtrema === 2) {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else if (t2 < extrema[1]) {
          w2 += y1_ < y0_ ? unit : -unit;
        } else {
          w2 += y3 < y1_ ? unit : -unit;
        }
      } else {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else {
          w2 += y3 < y0_ ? unit : -unit;
        }
      }
    }
    return w2;
  }
}
function windingQuadratic(x0, y0, x1, y1, x2, y2, x3, y3) {
  if (y3 > y0 && y3 > y1 && y3 > y2 || y3 < y0 && y3 < y1 && y3 < y2) {
    return 0;
  }
  var nRoots = quadraticRootAt(y0, y1, y2, y3, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var t2 = quadraticExtremum(y0, y1, y2);
    if (t2 >= 0 && t2 <= 1) {
      var w2 = 0;
      var y_ = quadraticAt$1(y0, y1, y2, t2);
      for (var i = 0; i < nRoots; i++) {
        var unit = roots[i] === 0 || roots[i] === 1 ? 0.5 : 1;
        var x_ = quadraticAt$1(x0, x1, x2, roots[i]);
        if (x_ < x3) {
          continue;
        }
        if (roots[i] < t2) {
          w2 += y_ < y0 ? unit : -unit;
        } else {
          w2 += y2 < y_ ? unit : -unit;
        }
      }
      return w2;
    } else {
      var unit = roots[0] === 0 || roots[0] === 1 ? 0.5 : 1;
      var x_ = quadraticAt$1(x0, x1, x2, roots[0]);
      if (x_ < x3) {
        return 0;
      }
      return y2 < y0 ? unit : -unit;
    }
  }
}
function windingArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2) {
  y2 -= cy;
  if (y2 > r2 || y2 < -r2) {
    return 0;
  }
  var tmp = Math.sqrt(r2 * r2 - y2 * y2);
  roots[0] = -tmp;
  roots[1] = tmp;
  var dTheta = Math.abs(startAngle - endAngle);
  if (dTheta < 1e-4) {
    return 0;
  }
  if (dTheta >= PI2$5 - 1e-4) {
    startAngle = 0;
    endAngle = PI2$5;
    var dir3 = anticlockwise ? 1 : -1;
    if (x2 >= roots[0] + cx && x2 <= roots[1] + cx) {
      return dir3;
    } else {
      return 0;
    }
  }
  if (startAngle > endAngle) {
    var tmp_1 = startAngle;
    startAngle = endAngle;
    endAngle = tmp_1;
  }
  if (startAngle < 0) {
    startAngle += PI2$5;
    endAngle += PI2$5;
  }
  var w2 = 0;
  for (var i = 0; i < 2; i++) {
    var x_ = roots[i];
    if (x_ + cx > x2) {
      var angle = Math.atan2(y2, x_);
      var dir3 = anticlockwise ? 1 : -1;
      if (angle < 0) {
        angle = PI2$5 + angle;
      }
      if (angle >= startAngle && angle <= endAngle || angle + PI2$5 >= startAngle && angle + PI2$5 <= endAngle) {
        if (angle > Math.PI / 2 && angle < Math.PI * 1.5) {
          dir3 = -dir3;
        }
        w2 += dir3;
      }
    }
  }
  return w2;
}
function containPath(path, lineWidth, isStroke, x2, y2) {
  var data = path.data;
  var len2 = path.len();
  var w2 = 0;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (cmd === CMD$3.M && i > 1) {
      if (!isStroke) {
        w2 += windingLine(xi, yi, x0, y0, x2, y2);
      }
    }
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    switch (cmd) {
      case CMD$3.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$3.L:
        if (isStroke) {
          if (containStroke$4(xi, yi, data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.C:
        if (isStroke) {
          if (containStroke$3(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.Q:
        if (isStroke) {
          if (containStroke$2(xi, yi, data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (!isFirst) {
          w2 += windingLine(xi, yi, x1, y1, x2, y2);
        } else {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        if (isStroke) {
          if (containStroke$1(cx, cy, ry, theta, theta + dTheta, anticlockwise, lineWidth, _x, y2)) {
            return true;
          }
        } else {
          w2 += windingArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2);
        }
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$3.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        x1 = x0 + width;
        y1 = y0 + height;
        if (isStroke) {
          if (containStroke$4(x0, y0, x1, y0, lineWidth, x2, y2) || containStroke$4(x1, y0, x1, y1, lineWidth, x2, y2) || containStroke$4(x1, y1, x0, y1, lineWidth, x2, y2) || containStroke$4(x0, y1, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(x1, y0, x1, y1, x2, y2);
          w2 += windingLine(x0, y1, x0, y0, x2, y2);
        }
        break;
      case CMD$3.Z:
        if (isStroke) {
          if (containStroke$4(xi, yi, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, x0, y0, x2, y2);
        }
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (!isStroke && !isAroundEqual$1(yi, y0)) {
    w2 += windingLine(xi, yi, x0, y0, x2, y2) || 0;
  }
  return w2 !== 0;
}
function contain$2(pathProxy, x2, y2) {
  return containPath(pathProxy, 0, false, x2, y2);
}
function containStroke(pathProxy, lineWidth, x2, y2) {
  return containPath(pathProxy, lineWidth, true, x2, y2);
}
var DEFAULT_PATH_STYLE = defaults({
  fill: "#000",
  stroke: null,
  strokePercent: 1,
  fillOpacity: 1,
  strokeOpacity: 1,
  lineDashOffset: 0,
  lineWidth: 1,
  lineCap: "butt",
  miterLimit: 10,
  strokeNoScale: false,
  strokeFirst: false
}, DEFAULT_COMMON_STYLE);
var DEFAULT_PATH_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    strokePercent: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineDashOffset: true,
    lineWidth: true,
    miterLimit: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var pathCopyParams = TRANSFORMABLE_PROPS.concat([
  "invisible",
  "culling",
  "z",
  "z2",
  "zlevel",
  "parent"
]);
var Path = function(_super) {
  __extends(Path2, _super);
  function Path2(opts) {
    return _super.call(this, opts) || this;
  }
  Path2.prototype.update = function() {
    var _this = this;
    _super.prototype.update.call(this);
    var style = this.style;
    if (style.decal) {
      var decalEl = this._decalEl = this._decalEl || new Path2();
      if (decalEl.buildPath === Path2.prototype.buildPath) {
        decalEl.buildPath = function(ctx) {
          _this.buildPath(ctx, _this.shape);
        };
      }
      decalEl.silent = true;
      var decalElStyle = decalEl.style;
      for (var key in style) {
        if (decalElStyle[key] !== style[key]) {
          decalElStyle[key] = style[key];
        }
      }
      decalElStyle.fill = style.fill ? style.decal : null;
      decalElStyle.decal = null;
      decalElStyle.shadowColor = null;
      style.strokeFirst && (decalElStyle.stroke = null);
      for (var i = 0; i < pathCopyParams.length; ++i) {
        decalEl[pathCopyParams[i]] = this[pathCopyParams[i]];
      }
      decalEl.__dirty |= REDRAW_BIT;
    } else if (this._decalEl) {
      this._decalEl = null;
    }
  };
  Path2.prototype.getDecalElement = function() {
    return this._decalEl;
  };
  Path2.prototype._init = function(props) {
    var keysArr = keys(props);
    this.shape = this.getDefaultShape();
    var defaultStyle = this.getDefaultStyle();
    if (defaultStyle) {
      this.useStyle(defaultStyle);
    }
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      var value = props[key];
      if (key === "style") {
        if (!this.style) {
          this.useStyle(value);
        } else {
          extend(this.style, value);
        }
      } else if (key === "shape") {
        extend(this.shape, value);
      } else {
        _super.prototype.attrKV.call(this, key, value);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Path2.prototype.getDefaultStyle = function() {
    return null;
  };
  Path2.prototype.getDefaultShape = function() {
    return {};
  };
  Path2.prototype.canBeInsideText = function() {
    return this.hasFill();
  };
  Path2.prototype.getInsideTextFill = function() {
    var pathFill = this.style.fill;
    if (pathFill !== "none") {
      if (isString(pathFill)) {
        var fillLum = lum(pathFill, 0);
        if (fillLum > 0.5) {
          return DARK_LABEL_COLOR;
        } else if (fillLum > 0.2) {
          return LIGHTER_LABEL_COLOR;
        }
        return LIGHT_LABEL_COLOR;
      } else if (pathFill) {
        return LIGHT_LABEL_COLOR;
      }
    }
    return DARK_LABEL_COLOR;
  };
  Path2.prototype.getInsideTextStroke = function(textFill) {
    var pathFill = this.style.fill;
    if (isString(pathFill)) {
      var zr = this.__zr;
      var isDarkMode2 = !!(zr && zr.isDarkMode());
      var isDarkLabel = lum(textFill, 0) < DARK_MODE_THRESHOLD;
      if (isDarkMode2 === isDarkLabel) {
        return pathFill;
      }
    }
  };
  Path2.prototype.buildPath = function(ctx, shapeCfg, inBatch) {
  };
  Path2.prototype.pathUpdated = function() {
    this.__dirty &= ~SHAPE_CHANGED_BIT;
  };
  Path2.prototype.getUpdatedPathProxy = function(inBatch) {
    !this.path && this.createPathProxy();
    this.path.beginPath();
    this.buildPath(this.path, this.shape, inBatch);
    return this.path;
  };
  Path2.prototype.createPathProxy = function() {
    this.path = new PathProxy$1(false);
  };
  Path2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
  };
  Path2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  Path2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    var style = this.style;
    var needsUpdateRect = !rect;
    if (needsUpdateRect) {
      var firstInvoke = false;
      if (!this.path) {
        firstInvoke = true;
        this.createPathProxy();
      }
      var path = this.path;
      if (firstInvoke || this.__dirty & SHAPE_CHANGED_BIT) {
        path.beginPath();
        this.buildPath(path, this.shape, false);
        this.pathUpdated();
      }
      rect = path.getBoundingRect();
    }
    this._rect = rect;
    if (this.hasStroke() && this.path && this.path.len() > 0) {
      var rectStroke = this._rectStroke || (this._rectStroke = rect.clone());
      if (this.__dirty || needsUpdateRect) {
        rectStroke.copy(rect);
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        var w2 = style.lineWidth;
        if (!this.hasFill()) {
          var strokeContainThreshold = this.strokeContainThreshold;
          w2 = Math.max(w2, strokeContainThreshold == null ? 4 : strokeContainThreshold);
        }
        if (lineScale > 1e-10) {
          rectStroke.width += w2 / lineScale;
          rectStroke.height += w2 / lineScale;
          rectStroke.x -= w2 / lineScale / 2;
          rectStroke.y -= w2 / lineScale / 2;
        }
      }
      return rectStroke;
    }
    return rect;
  };
  Path2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    var style = this.style;
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var pathProxy = this.path;
      if (this.hasStroke()) {
        var lineWidth = style.lineWidth;
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        if (lineScale > 1e-10) {
          if (!this.hasFill()) {
            lineWidth = Math.max(lineWidth, this.strokeContainThreshold);
          }
          if (containStroke(pathProxy, lineWidth / lineScale, x2, y2)) {
            return true;
          }
        }
      }
      if (this.hasFill()) {
        return contain$2(pathProxy, x2, y2);
      }
    }
    return false;
  };
  Path2.prototype.dirtyShape = function() {
    this.__dirty |= SHAPE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
    if (this._decalEl) {
      this._decalEl.dirtyShape();
    }
    this.markRedraw();
  };
  Path2.prototype.dirty = function() {
    this.dirtyStyle();
    this.dirtyShape();
  };
  Path2.prototype.animateShape = function(loop) {
    return this.animate("shape", loop);
  };
  Path2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else if (targetKey === "shape") {
      this.dirtyShape();
    } else {
      this.markRedraw();
    }
  };
  Path2.prototype.attrKV = function(key, value) {
    if (key === "shape") {
      this.setShape(value);
    } else {
      _super.prototype.attrKV.call(this, key, value);
    }
  };
  Path2.prototype.setShape = function(keyOrObj, value) {
    var shape = this.shape;
    if (!shape) {
      shape = this.shape = {};
    }
    if (typeof keyOrObj === "string") {
      shape[keyOrObj] = value;
    } else {
      extend(shape, keyOrObj);
    }
    this.dirtyShape();
    return this;
  };
  Path2.prototype.shapeChanged = function() {
    return !!(this.__dirty & SHAPE_CHANGED_BIT);
  };
  Path2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_PATH_STYLE, obj);
  };
  Path2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.shape && !normalState.shape) {
      normalState.shape = extend({}, this.shape);
    }
  };
  Path2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetShape;
    if (state && state.shape) {
      if (transition) {
        if (keepCurrentStates) {
          targetShape = state.shape;
        } else {
          targetShape = extend({}, normalState.shape);
          extend(targetShape, state.shape);
        }
      } else {
        targetShape = extend({}, keepCurrentStates ? this.shape : normalState.shape);
        extend(targetShape, state.shape);
      }
    } else if (needsRestoreToNormal) {
      targetShape = normalState.shape;
    }
    if (targetShape) {
      if (transition) {
        this.shape = extend({}, this.shape);
        var targetShapePrimaryProps = {};
        var shapeKeys = keys(targetShape);
        for (var i = 0; i < shapeKeys.length; i++) {
          var key = shapeKeys[i];
          if (typeof targetShape[key] === "object") {
            this.shape[key] = targetShape[key];
          } else {
            targetShapePrimaryProps[key] = targetShape[key];
          }
        }
        this._transitionState(stateName, {
          shape: targetShapePrimaryProps
        }, animationCfg);
      } else {
        this.shape = targetShape;
        this.dirtyShape();
      }
    }
  };
  Path2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedShape;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.shape) {
        mergedShape = mergedShape || {};
        this._mergeStyle(mergedShape, state.shape);
      }
    }
    if (mergedShape) {
      mergedState.shape = mergedShape;
    }
    return mergedState;
  };
  Path2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_PATH_ANIMATION_PROPS;
  };
  Path2.prototype.isZeroArea = function() {
    return false;
  };
  Path2.extend = function(defaultProps) {
    var Sub = function(_super2) {
      __extends(Sub2, _super2);
      function Sub2(opts) {
        var _this = _super2.call(this, opts) || this;
        defaultProps.init && defaultProps.init.call(_this, opts);
        return _this;
      }
      Sub2.prototype.getDefaultStyle = function() {
        return clone$4(defaultProps.style);
      };
      Sub2.prototype.getDefaultShape = function() {
        return clone$4(defaultProps.shape);
      };
      return Sub2;
    }(Path2);
    for (var key in defaultProps) {
      if (typeof defaultProps[key] === "function") {
        Sub.prototype[key] = defaultProps[key];
      }
    }
    return Sub;
  };
  Path2.initDefaultProps = function() {
    var pathProto = Path2.prototype;
    pathProto.type = "path";
    pathProto.strokeContainThreshold = 5;
    pathProto.segmentIgnoreThreshold = 0;
    pathProto.subPixelOptimize = false;
    pathProto.autoBatch = false;
    pathProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT | SHAPE_CHANGED_BIT;
  }();
  return Path2;
}(Displayable$1);
var Path$1 = Path;
var DEFAULT_TSPAN_STYLE = defaults({
  strokeFirst: true,
  font: DEFAULT_FONT,
  x: 0,
  y: 0,
  textAlign: "left",
  textBaseline: "top",
  miterLimit: 2
}, DEFAULT_PATH_STYLE);
var TSpan = function(_super) {
  __extends(TSpan2, _super);
  function TSpan2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TSpan2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return stroke != null && stroke !== "none" && style.lineWidth > 0;
  };
  TSpan2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  TSpan2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_TSPAN_STYLE, obj);
  };
  TSpan2.prototype.setBoundingRect = function(rect) {
    this._rect = rect;
  };
  TSpan2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      var text = style.text;
      text != null ? text += "" : text = "";
      var rect = getBoundingRect(text, style.font, style.textAlign, style.textBaseline);
      rect.x += style.x || 0;
      rect.y += style.y || 0;
      if (this.hasStroke()) {
        var w2 = style.lineWidth;
        rect.x -= w2 / 2;
        rect.y -= w2 / 2;
        rect.width += w2;
        rect.height += w2;
      }
      this._rect = rect;
    }
    return this._rect;
  };
  TSpan2.initDefaultProps = function() {
    var tspanProto = TSpan2.prototype;
    tspanProto.dirtyRectTolerance = 10;
  }();
  return TSpan2;
}(Displayable$1);
TSpan.prototype.type = "tspan";
var TSpan$1 = TSpan;
var DEFAULT_IMAGE_STYLE = defaults({
  x: 0,
  y: 0
}, DEFAULT_COMMON_STYLE);
var DEFAULT_IMAGE_ANIMATION_PROPS = {
  style: defaults({
    x: true,
    y: true,
    width: true,
    height: true,
    sx: true,
    sy: true,
    sWidth: true,
    sHeight: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
function isImageLike$1(source) {
  return !!(source && typeof source !== "string" && source.width && source.height);
}
var ZRImage = function(_super) {
  __extends(ZRImage2, _super);
  function ZRImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ZRImage2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_IMAGE_STYLE, obj);
  };
  ZRImage2.prototype._getSize = function(dim) {
    var style = this.style;
    var size = style[dim];
    if (size != null) {
      return size;
    }
    var imageSource = isImageLike$1(style.image) ? style.image : this.__image;
    if (!imageSource) {
      return 0;
    }
    var otherDim = dim === "width" ? "height" : "width";
    var otherDimSize = style[otherDim];
    if (otherDimSize == null) {
      return imageSource[dim];
    } else {
      return imageSource[dim] / imageSource[otherDim] * otherDimSize;
    }
  };
  ZRImage2.prototype.getWidth = function() {
    return this._getSize("width");
  };
  ZRImage2.prototype.getHeight = function() {
    return this._getSize("height");
  };
  ZRImage2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_IMAGE_ANIMATION_PROPS;
  };
  ZRImage2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      this._rect = new BoundingRect$1(style.x || 0, style.y || 0, this.getWidth(), this.getHeight());
    }
    return this._rect;
  };
  return ZRImage2;
}(Displayable$1);
ZRImage.prototype.type = "image";
var ZRImage$1 = ZRImage;
function buildPath$2(ctx, shape) {
  var x2 = shape.x;
  var y2 = shape.y;
  var width = shape.width;
  var height = shape.height;
  var r2 = shape.r;
  var r1;
  var r22;
  var r3;
  var r4;
  if (width < 0) {
    x2 = x2 + width;
    width = -width;
  }
  if (height < 0) {
    y2 = y2 + height;
    height = -height;
  }
  if (typeof r2 === "number") {
    r1 = r22 = r3 = r4 = r2;
  } else if (r2 instanceof Array) {
    if (r2.length === 1) {
      r1 = r22 = r3 = r4 = r2[0];
    } else if (r2.length === 2) {
      r1 = r3 = r2[0];
      r22 = r4 = r2[1];
    } else if (r2.length === 3) {
      r1 = r2[0];
      r22 = r4 = r2[1];
      r3 = r2[2];
    } else {
      r1 = r2[0];
      r22 = r2[1];
      r3 = r2[2];
      r4 = r2[3];
    }
  } else {
    r1 = r22 = r3 = r4 = 0;
  }
  var total;
  if (r1 + r22 > width) {
    total = r1 + r22;
    r1 *= width / total;
    r22 *= width / total;
  }
  if (r3 + r4 > width) {
    total = r3 + r4;
    r3 *= width / total;
    r4 *= width / total;
  }
  if (r22 + r3 > height) {
    total = r22 + r3;
    r22 *= height / total;
    r3 *= height / total;
  }
  if (r1 + r4 > height) {
    total = r1 + r4;
    r1 *= height / total;
    r4 *= height / total;
  }
  ctx.moveTo(x2 + r1, y2);
  ctx.lineTo(x2 + width - r22, y2);
  r22 !== 0 && ctx.arc(x2 + width - r22, y2 + r22, r22, -Math.PI / 2, 0);
  ctx.lineTo(x2 + width, y2 + height - r3);
  r3 !== 0 && ctx.arc(x2 + width - r3, y2 + height - r3, r3, 0, Math.PI / 2);
  ctx.lineTo(x2 + r4, y2 + height);
  r4 !== 0 && ctx.arc(x2 + r4, y2 + height - r4, r4, Math.PI / 2, Math.PI);
  ctx.lineTo(x2, y2 + r1);
  r1 !== 0 && ctx.arc(x2 + r1, y2 + r1, r1, Math.PI, Math.PI * 1.5);
}
var round$2 = Math.round;
function subPixelOptimizeLine$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var x1 = inputShape.x1;
  var x2 = inputShape.x2;
  var y1 = inputShape.y1;
  var y2 = inputShape.y2;
  outputShape.x1 = x1;
  outputShape.x2 = x2;
  outputShape.y1 = y1;
  outputShape.y2 = y2;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  if (round$2(x1 * 2) === round$2(x2 * 2)) {
    outputShape.x1 = outputShape.x2 = subPixelOptimize$1(x1, lineWidth, true);
  }
  if (round$2(y1 * 2) === round$2(y2 * 2)) {
    outputShape.y1 = outputShape.y2 = subPixelOptimize$1(y1, lineWidth, true);
  }
  return outputShape;
}
function subPixelOptimizeRect$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var originX = inputShape.x;
  var originY = inputShape.y;
  var originWidth = inputShape.width;
  var originHeight = inputShape.height;
  outputShape.x = originX;
  outputShape.y = originY;
  outputShape.width = originWidth;
  outputShape.height = originHeight;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  outputShape.x = subPixelOptimize$1(originX, lineWidth, true);
  outputShape.y = subPixelOptimize$1(originY, lineWidth, true);
  outputShape.width = Math.max(subPixelOptimize$1(originX + originWidth, lineWidth, false) - outputShape.x, originWidth === 0 ? 0 : 1);
  outputShape.height = Math.max(subPixelOptimize$1(originY + originHeight, lineWidth, false) - outputShape.y, originHeight === 0 ? 0 : 1);
  return outputShape;
}
function subPixelOptimize$1(position2, lineWidth, positiveOrNegative) {
  if (!lineWidth) {
    return position2;
  }
  var doubledPosition = round$2(position2 * 2);
  return (doubledPosition + round$2(lineWidth)) % 2 === 0 ? doubledPosition / 2 : (doubledPosition + (positiveOrNegative ? 1 : -1)) / 2;
}
var RectShape = function() {
  function RectShape2() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
  }
  return RectShape2;
}();
var subPixelOptimizeOutputShape$1 = {};
var Rect$2 = function(_super) {
  __extends(Rect2, _super);
  function Rect2(opts) {
    return _super.call(this, opts) || this;
  }
  Rect2.prototype.getDefaultShape = function() {
    return new RectShape();
  };
  Rect2.prototype.buildPath = function(ctx, shape) {
    var x2;
    var y2;
    var width;
    var height;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeRect$1(subPixelOptimizeOutputShape$1, shape, this.style);
      x2 = optimizedShape.x;
      y2 = optimizedShape.y;
      width = optimizedShape.width;
      height = optimizedShape.height;
      optimizedShape.r = shape.r;
      shape = optimizedShape;
    } else {
      x2 = shape.x;
      y2 = shape.y;
      width = shape.width;
      height = shape.height;
    }
    if (!shape.r) {
      ctx.rect(x2, y2, width, height);
    } else {
      buildPath$2(ctx, shape);
    }
  };
  Rect2.prototype.isZeroArea = function() {
    return !this.shape.width || !this.shape.height;
  };
  return Rect2;
}(Path$1);
Rect$2.prototype.type = "rect";
var Rect$3 = Rect$2;
var DEFAULT_RICH_TEXT_COLOR = {
  fill: "#000"
};
var DEFAULT_STROKE_LINE_WIDTH = 2;
var DEFAULT_TEXT_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineWidth: true,
    fontSize: true,
    lineHeight: true,
    width: true,
    height: true,
    textShadowColor: true,
    textShadowBlur: true,
    textShadowOffsetX: true,
    textShadowOffsetY: true,
    backgroundColor: true,
    padding: true,
    borderColor: true,
    borderWidth: true,
    borderRadius: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var ZRText = function(_super) {
  __extends(ZRText2, _super);
  function ZRText2(opts) {
    var _this = _super.call(this) || this;
    _this.type = "text";
    _this._children = [];
    _this._defaultStyle = DEFAULT_RICH_TEXT_COLOR;
    _this.attr(opts);
    return _this;
  }
  ZRText2.prototype.childrenRef = function() {
    return this._children;
  };
  ZRText2.prototype.update = function() {
    _super.prototype.update.call(this);
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.zlevel = this.zlevel;
      child.z = this.z;
      child.z2 = this.z2;
      child.culling = this.culling;
      child.cursor = this.cursor;
      child.invisible = this.invisible;
    }
  };
  ZRText2.prototype.updateTransform = function() {
    var innerTransformable = this.innerTransformable;
    if (innerTransformable) {
      innerTransformable.updateTransform();
      if (innerTransformable.transform) {
        this.transform = innerTransformable.transform;
      }
    } else {
      _super.prototype.updateTransform.call(this);
    }
  };
  ZRText2.prototype.getLocalTransform = function(m2) {
    var innerTransformable = this.innerTransformable;
    return innerTransformable ? innerTransformable.getLocalTransform(m2) : _super.prototype.getLocalTransform.call(this, m2);
  };
  ZRText2.prototype.getComputedTransform = function() {
    if (this.__hostTarget) {
      this.__hostTarget.getComputedTransform();
      this.__hostTarget.updateInnerText(true);
    }
    return _super.prototype.getComputedTransform.call(this);
  };
  ZRText2.prototype._updateSubTexts = function() {
    this._childCursor = 0;
    normalizeTextStyle(this.style);
    this.style.rich ? this._updateRichTexts() : this._updatePlainTexts();
    this._children.length = this._childCursor;
    this.styleUpdated();
  };
  ZRText2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = zr;
    }
  };
  ZRText2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = null;
    }
  };
  ZRText2.prototype.getBoundingRect = function() {
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    if (!this._rect) {
      var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
      var children = this._children;
      var tmpMat = [];
      var rect = null;
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var childRect = child.getBoundingRect();
        var transform2 = child.getLocalTransform(tmpMat);
        if (transform2) {
          tmpRect2.copy(childRect);
          tmpRect2.applyTransform(transform2);
          rect = rect || tmpRect2.clone();
          rect.union(tmpRect2);
        } else {
          rect = rect || childRect.clone();
          rect.union(childRect);
        }
      }
      this._rect = rect || tmpRect2;
    }
    return this._rect;
  };
  ZRText2.prototype.setDefaultTextStyle = function(defaultTextStyle) {
    this._defaultStyle = defaultTextStyle || DEFAULT_RICH_TEXT_COLOR;
  };
  ZRText2.prototype.setTextContent = function(textContent) {
  };
  ZRText2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    if (!sourceStyle) {
      return targetStyle;
    }
    var sourceRich = sourceStyle.rich;
    var targetRich = targetStyle.rich || sourceRich && {};
    extend(targetStyle, sourceStyle);
    if (sourceRich && targetRich) {
      this._mergeRich(targetRich, sourceRich);
      targetStyle.rich = targetRich;
    } else if (targetRich) {
      targetStyle.rich = targetRich;
    }
    return targetStyle;
  };
  ZRText2.prototype._mergeRich = function(targetRich, sourceRich) {
    var richNames = keys(sourceRich);
    for (var i = 0; i < richNames.length; i++) {
      var richName = richNames[i];
      targetRich[richName] = targetRich[richName] || {};
      extend(targetRich[richName], sourceRich[richName]);
    }
  };
  ZRText2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_TEXT_ANIMATION_PROPS;
  };
  ZRText2.prototype._getOrCreateChild = function(Ctor) {
    var child = this._children[this._childCursor];
    if (!child || !(child instanceof Ctor)) {
      child = new Ctor();
    }
    this._children[this._childCursor++] = child;
    child.__zr = this.__zr;
    child.parent = this;
    return child;
  };
  ZRText2.prototype._updatePlainTexts = function() {
    var style = this.style;
    var textFont = style.font || DEFAULT_FONT;
    var textPadding = style.padding;
    var text = getStyleText(style);
    var contentBlock = parsePlainText(text, style);
    var needDrawBg = needDrawBackground(style);
    var bgColorDrawn = !!style.backgroundColor;
    var outerHeight = contentBlock.outerHeight;
    var outerWidth = contentBlock.outerWidth;
    var contentWidth = contentBlock.contentWidth;
    var textLines = contentBlock.lines;
    var lineHeight = contentBlock.lineHeight;
    var defaultStyle = this._defaultStyle;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var textAlign = style.align || defaultStyle.align || "left";
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign || "top";
    var textX = baseX;
    var textY = adjustTextY(baseY, contentBlock.contentHeight, verticalAlign);
    if (needDrawBg || textPadding) {
      var boxX = adjustTextX(baseX, outerWidth, textAlign);
      var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
      needDrawBg && this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    textY += lineHeight / 2;
    if (textPadding) {
      textX = getTextXForPadding(baseX, textAlign, textPadding);
      if (verticalAlign === "top") {
        textY += textPadding[0];
      } else if (verticalAlign === "bottom") {
        textY -= textPadding[2];
      }
    }
    var defaultLineWidth = 0;
    var useDefaultFill = false;
    var textFill = getFill("fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in style ? style.stroke : !bgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = style.textShadowBlur > 0;
    var fixedBoundingRect = style.width != null && (style.overflow === "truncate" || style.overflow === "break" || style.overflow === "breakAll");
    var calculatedLineHeight = contentBlock.calculatedLineHeight;
    for (var i = 0; i < textLines.length; i++) {
      var el = this._getOrCreateChild(TSpan$1);
      var subElStyle = el.createStyle();
      el.useStyle(subElStyle);
      subElStyle.text = textLines[i];
      subElStyle.x = textX;
      subElStyle.y = textY;
      if (textAlign) {
        subElStyle.textAlign = textAlign;
      }
      subElStyle.textBaseline = "middle";
      subElStyle.opacity = style.opacity;
      subElStyle.strokeFirst = true;
      if (hasShadow2) {
        subElStyle.shadowBlur = style.textShadowBlur || 0;
        subElStyle.shadowColor = style.textShadowColor || "transparent";
        subElStyle.shadowOffsetX = style.textShadowOffsetX || 0;
        subElStyle.shadowOffsetY = style.textShadowOffsetY || 0;
      }
      subElStyle.stroke = textStroke;
      subElStyle.fill = textFill;
      if (textStroke) {
        subElStyle.lineWidth = style.lineWidth || defaultLineWidth;
        subElStyle.lineDash = style.lineDash;
        subElStyle.lineDashOffset = style.lineDashOffset || 0;
      }
      subElStyle.font = textFont;
      setSeparateFont(subElStyle, style);
      textY += lineHeight;
      if (fixedBoundingRect) {
        el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, style.width, subElStyle.textAlign), adjustTextY(subElStyle.y, calculatedLineHeight, subElStyle.textBaseline), contentWidth, calculatedLineHeight));
      }
    }
  };
  ZRText2.prototype._updateRichTexts = function() {
    var style = this.style;
    var text = getStyleText(style);
    var contentBlock = parseRichText(text, style);
    var contentWidth = contentBlock.width;
    var outerWidth = contentBlock.outerWidth;
    var outerHeight = contentBlock.outerHeight;
    var textPadding = style.padding;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var defaultStyle = this._defaultStyle;
    var textAlign = style.align || defaultStyle.align;
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign;
    var boxX = adjustTextX(baseX, outerWidth, textAlign);
    var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
    var xLeft = boxX;
    var lineTop = boxY;
    if (textPadding) {
      xLeft += textPadding[3];
      lineTop += textPadding[0];
    }
    var xRight = xLeft + contentWidth;
    if (needDrawBackground(style)) {
      this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    var bgColorDrawn = !!style.backgroundColor;
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var tokens = line.tokens;
      var tokenCount = tokens.length;
      var lineHeight = line.lineHeight;
      var remainedWidth = line.width;
      var leftIndex = 0;
      var lineXLeft = xLeft;
      var lineXRight = xRight;
      var rightIndex = tokenCount - 1;
      var token = void 0;
      while (leftIndex < tokenCount && (token = tokens[leftIndex], !token.align || token.align === "left")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft, "left", bgColorDrawn);
        remainedWidth -= token.width;
        lineXLeft += token.width;
        leftIndex++;
      }
      while (rightIndex >= 0 && (token = tokens[rightIndex], token.align === "right")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXRight, "right", bgColorDrawn);
        remainedWidth -= token.width;
        lineXRight -= token.width;
        rightIndex--;
      }
      lineXLeft += (contentWidth - (lineXLeft - xLeft) - (xRight - lineXRight) - remainedWidth) / 2;
      while (leftIndex <= rightIndex) {
        token = tokens[leftIndex];
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft + token.width / 2, "center", bgColorDrawn);
        lineXLeft += token.width;
        leftIndex++;
      }
      lineTop += lineHeight;
    }
  };
  ZRText2.prototype._placeToken = function(token, style, lineHeight, lineTop, x2, textAlign, parentBgColorDrawn) {
    var tokenStyle = style.rich[token.styleName] || {};
    tokenStyle.text = token.text;
    var verticalAlign = token.verticalAlign;
    var y2 = lineTop + lineHeight / 2;
    if (verticalAlign === "top") {
      y2 = lineTop + token.height / 2;
    } else if (verticalAlign === "bottom") {
      y2 = lineTop + lineHeight - token.height / 2;
    }
    var needDrawBg = !token.isLineHolder && needDrawBackground(tokenStyle);
    needDrawBg && this._renderBackground(tokenStyle, style, textAlign === "right" ? x2 - token.width : textAlign === "center" ? x2 - token.width / 2 : x2, y2 - token.height / 2, token.width, token.height);
    var bgColorDrawn = !!tokenStyle.backgroundColor;
    var textPadding = token.textPadding;
    if (textPadding) {
      x2 = getTextXForPadding(x2, textAlign, textPadding);
      y2 -= token.height / 2 - textPadding[0] - token.innerHeight / 2;
    }
    var el = this._getOrCreateChild(TSpan$1);
    var subElStyle = el.createStyle();
    el.useStyle(subElStyle);
    var defaultStyle = this._defaultStyle;
    var useDefaultFill = false;
    var defaultLineWidth = 0;
    var textFill = getFill("fill" in tokenStyle ? tokenStyle.fill : "fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in tokenStyle ? tokenStyle.stroke : "stroke" in style ? style.stroke : !bgColorDrawn && !parentBgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = tokenStyle.textShadowBlur > 0 || style.textShadowBlur > 0;
    subElStyle.text = token.text;
    subElStyle.x = x2;
    subElStyle.y = y2;
    if (hasShadow2) {
      subElStyle.shadowBlur = tokenStyle.textShadowBlur || style.textShadowBlur || 0;
      subElStyle.shadowColor = tokenStyle.textShadowColor || style.textShadowColor || "transparent";
      subElStyle.shadowOffsetX = tokenStyle.textShadowOffsetX || style.textShadowOffsetX || 0;
      subElStyle.shadowOffsetY = tokenStyle.textShadowOffsetY || style.textShadowOffsetY || 0;
    }
    subElStyle.textAlign = textAlign;
    subElStyle.textBaseline = "middle";
    subElStyle.font = token.font || DEFAULT_FONT;
    subElStyle.opacity = retrieve3(tokenStyle.opacity, style.opacity, 1);
    setSeparateFont(subElStyle, tokenStyle);
    if (textStroke) {
      subElStyle.lineWidth = retrieve3(tokenStyle.lineWidth, style.lineWidth, defaultLineWidth);
      subElStyle.lineDash = retrieve2(tokenStyle.lineDash, style.lineDash);
      subElStyle.lineDashOffset = style.lineDashOffset || 0;
      subElStyle.stroke = textStroke;
    }
    if (textFill) {
      subElStyle.fill = textFill;
    }
    var textWidth = token.contentWidth;
    var textHeight = token.contentHeight;
    el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, textWidth, subElStyle.textAlign), adjustTextY(subElStyle.y, textHeight, subElStyle.textBaseline), textWidth, textHeight));
  };
  ZRText2.prototype._renderBackground = function(style, topStyle, x2, y2, width, height) {
    var textBackgroundColor = style.backgroundColor;
    var textBorderWidth = style.borderWidth;
    var textBorderColor = style.borderColor;
    var isImageBg = textBackgroundColor && textBackgroundColor.image;
    var isPlainOrGradientBg = textBackgroundColor && !isImageBg;
    var textBorderRadius = style.borderRadius;
    var self2 = this;
    var rectEl;
    var imgEl;
    if (isPlainOrGradientBg || style.lineHeight || textBorderWidth && textBorderColor) {
      rectEl = this._getOrCreateChild(Rect$3);
      rectEl.useStyle(rectEl.createStyle());
      rectEl.style.fill = null;
      var rectShape = rectEl.shape;
      rectShape.x = x2;
      rectShape.y = y2;
      rectShape.width = width;
      rectShape.height = height;
      rectShape.r = textBorderRadius;
      rectEl.dirtyShape();
    }
    if (isPlainOrGradientBg) {
      var rectStyle = rectEl.style;
      rectStyle.fill = textBackgroundColor || null;
      rectStyle.fillOpacity = retrieve2(style.fillOpacity, 1);
    } else if (isImageBg) {
      imgEl = this._getOrCreateChild(ZRImage$1);
      imgEl.onload = function() {
        self2.dirtyStyle();
      };
      var imgStyle = imgEl.style;
      imgStyle.image = textBackgroundColor.image;
      imgStyle.x = x2;
      imgStyle.y = y2;
      imgStyle.width = width;
      imgStyle.height = height;
    }
    if (textBorderWidth && textBorderColor) {
      var rectStyle = rectEl.style;
      rectStyle.lineWidth = textBorderWidth;
      rectStyle.stroke = textBorderColor;
      rectStyle.strokeOpacity = retrieve2(style.strokeOpacity, 1);
      rectStyle.lineDash = style.borderDash;
      rectStyle.lineDashOffset = style.borderDashOffset || 0;
      rectEl.strokeContainThreshold = 0;
      if (rectEl.hasFill() && rectEl.hasStroke()) {
        rectStyle.strokeFirst = true;
        rectStyle.lineWidth *= 2;
      }
    }
    var commonStyle = (rectEl || imgEl).style;
    commonStyle.shadowBlur = style.shadowBlur || 0;
    commonStyle.shadowColor = style.shadowColor || "transparent";
    commonStyle.shadowOffsetX = style.shadowOffsetX || 0;
    commonStyle.shadowOffsetY = style.shadowOffsetY || 0;
    commonStyle.opacity = retrieve3(style.opacity, topStyle.opacity, 1);
  };
  ZRText2.makeFont = function(style) {
    var font = "";
    if (hasSeparateFont(style)) {
      font = [
        style.fontStyle,
        style.fontWeight,
        parseFontSize(style.fontSize),
        style.fontFamily || "sans-serif"
      ].join(" ");
    }
    return font && trim$1(font) || style.textFont || style.font;
  };
  return ZRText2;
}(Displayable$1);
var VALID_TEXT_ALIGN = { left: true, right: 1, center: 1 };
var VALID_TEXT_VERTICAL_ALIGN = { top: 1, bottom: 1, middle: 1 };
var FONT_PARTS = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
function parseFontSize(fontSize) {
  if (typeof fontSize === "string" && (fontSize.indexOf("px") !== -1 || fontSize.indexOf("rem") !== -1 || fontSize.indexOf("em") !== -1)) {
    return fontSize;
  } else if (!isNaN(+fontSize)) {
    return fontSize + "px";
  } else {
    return DEFAULT_FONT_SIZE + "px";
  }
}
function setSeparateFont(targetStyle, sourceStyle) {
  for (var i = 0; i < FONT_PARTS.length; i++) {
    var fontProp = FONT_PARTS[i];
    var val = sourceStyle[fontProp];
    if (val != null) {
      targetStyle[fontProp] = val;
    }
  }
}
function hasSeparateFont(style) {
  return style.fontSize != null || style.fontFamily || style.fontWeight;
}
function normalizeTextStyle(style) {
  normalizeStyle(style);
  each$f(style.rich, normalizeStyle);
  return style;
}
function normalizeStyle(style) {
  if (style) {
    style.font = ZRText.makeFont(style);
    var textAlign = style.align;
    textAlign === "middle" && (textAlign = "center");
    style.align = textAlign == null || VALID_TEXT_ALIGN[textAlign] ? textAlign : "left";
    var verticalAlign = style.verticalAlign;
    verticalAlign === "center" && (verticalAlign = "middle");
    style.verticalAlign = verticalAlign == null || VALID_TEXT_VERTICAL_ALIGN[verticalAlign] ? verticalAlign : "top";
    var textPadding = style.padding;
    if (textPadding) {
      style.padding = normalizeCssArray$1(style.padding);
    }
  }
}
function getStroke(stroke, lineWidth) {
  return stroke == null || lineWidth <= 0 || stroke === "transparent" || stroke === "none" ? null : stroke.image || stroke.colorStops ? "#000" : stroke;
}
function getFill(fill) {
  return fill == null || fill === "none" ? null : fill.image || fill.colorStops ? "#000" : fill;
}
function getTextXForPadding(x2, textAlign, textPadding) {
  return textAlign === "right" ? x2 - textPadding[1] : textAlign === "center" ? x2 + textPadding[3] / 2 - textPadding[1] / 2 : x2 + textPadding[3];
}
function getStyleText(style) {
  var text = style.text;
  text != null && (text += "");
  return text;
}
function needDrawBackground(style) {
  return !!(style.backgroundColor || style.lineHeight || style.borderWidth && style.borderColor);
}
var ZRText$1 = ZRText;
var getECData = makeInner();
var setCommonECData = function(seriesIndex, dataType, dataIdx, el) {
  if (el) {
    var ecData = getECData(el);
    ecData.dataIndex = dataIdx;
    ecData.dataType = dataType;
    ecData.seriesIndex = seriesIndex;
    if (el.type === "group") {
      el.traverse(function(child) {
        var childECData = getECData(child);
        childECData.seriesIndex = seriesIndex;
        childECData.dataIndex = dataIdx;
        childECData.dataType = dataType;
      });
    }
  }
};
var _highlightNextDigit = 1;
var _highlightKeyMap = {};
var getSavedStates = makeInner();
var getComponentStates = makeInner();
var HOVER_STATE_NORMAL = 0;
var HOVER_STATE_BLUR = 1;
var HOVER_STATE_EMPHASIS = 2;
var SPECIAL_STATES = ["emphasis", "blur", "select"];
var DISPLAY_STATES = ["normal", "emphasis", "blur", "select"];
var Z2_EMPHASIS_LIFT = 10;
var Z2_SELECT_LIFT = 9;
var HIGHLIGHT_ACTION_TYPE = "highlight";
var DOWNPLAY_ACTION_TYPE = "downplay";
var SELECT_ACTION_TYPE = "select";
var UNSELECT_ACTION_TYPE = "unselect";
var TOGGLE_SELECT_ACTION_TYPE = "toggleSelect";
function hasFillOrStroke(fillOrStroke) {
  return fillOrStroke != null && fillOrStroke !== "none";
}
var liftedColorCache = new LRU$1(100);
function liftColor(color) {
  if (isString(color)) {
    var liftedColor = liftedColorCache.get(color);
    if (!liftedColor) {
      liftedColor = lift(color, -0.1);
      liftedColorCache.put(color, liftedColor);
    }
    return liftedColor;
  } else if (isGradientObject(color)) {
    var ret = extend({}, color);
    ret.colorStops = map$1(color.colorStops, function(stop2) {
      return {
        offset: stop2.offset,
        color: lift(stop2.color, -0.1)
      };
    });
    return ret;
  }
  return color;
}
function doChangeHoverState(el, stateName, hoverStateEnum) {
  if (el.onHoverStateChange && (el.hoverState || 0) !== hoverStateEnum) {
    el.onHoverStateChange(stateName);
  }
  el.hoverState = hoverStateEnum;
}
function singleEnterEmphasis(el) {
  doChangeHoverState(el, "emphasis", HOVER_STATE_EMPHASIS);
}
function singleLeaveEmphasis(el) {
  if (el.hoverState === HOVER_STATE_EMPHASIS) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterBlur(el) {
  doChangeHoverState(el, "blur", HOVER_STATE_BLUR);
}
function singleLeaveBlur(el) {
  if (el.hoverState === HOVER_STATE_BLUR) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterSelect(el) {
  el.selected = true;
}
function singleLeaveSelect(el) {
  el.selected = false;
}
function updateElementState(el, updater, commonParam) {
  updater(el, commonParam);
}
function traverseUpdateState(el, updater, commonParam) {
  updateElementState(el, updater, commonParam);
  el.isGroup && el.traverse(function(child) {
    updateElementState(child, updater, commonParam);
  });
}
function setStatesFlag(el, stateName) {
  switch (stateName) {
    case "emphasis":
      el.hoverState = HOVER_STATE_EMPHASIS;
      break;
    case "normal":
      el.hoverState = HOVER_STATE_NORMAL;
      break;
    case "blur":
      el.hoverState = HOVER_STATE_BLUR;
      break;
    case "select":
      el.selected = true;
  }
}
function getFromStateStyle(el, props, toStateName, defaultValue) {
  var style = el.style;
  var fromState = {};
  for (var i = 0; i < props.length; i++) {
    var propName = props[i];
    var val = style[propName];
    fromState[propName] = val == null ? defaultValue && defaultValue[propName] : val;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.__fromStateTransition && animator.__fromStateTransition.indexOf(toStateName) < 0 && animator.targetName === "style") {
      animator.saveTo(fromState, props);
    }
  }
  return fromState;
}
function createEmphasisDefaultState(el, stateName, targetStates, state) {
  var hasSelect = targetStates && indexOf(targetStates, "select") >= 0;
  var cloned = false;
  if (el instanceof Path$1) {
    var store = getSavedStates(el);
    var fromFill = hasSelect ? store.selectFill || store.normalFill : store.normalFill;
    var fromStroke = hasSelect ? store.selectStroke || store.normalStroke : store.normalStroke;
    if (hasFillOrStroke(fromFill) || hasFillOrStroke(fromStroke)) {
      state = state || {};
      var emphasisStyle = state.style || {};
      if (emphasisStyle.fill === "inherit") {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = fromFill;
      } else if (!hasFillOrStroke(emphasisStyle.fill) && hasFillOrStroke(fromFill)) {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = liftColor(fromFill);
      } else if (!hasFillOrStroke(emphasisStyle.stroke) && hasFillOrStroke(fromStroke)) {
        if (!cloned) {
          state = extend({}, state);
          emphasisStyle = extend({}, emphasisStyle);
        }
        emphasisStyle.stroke = liftColor(fromStroke);
      }
      state.style = emphasisStyle;
    }
  }
  if (state) {
    if (state.z2 == null) {
      if (!cloned) {
        state = extend({}, state);
      }
      var z2EmphasisLift = el.z2EmphasisLift;
      state.z2 = el.z2 + (z2EmphasisLift != null ? z2EmphasisLift : Z2_EMPHASIS_LIFT);
    }
  }
  return state;
}
function createSelectDefaultState(el, stateName, state) {
  if (state) {
    if (state.z2 == null) {
      state = extend({}, state);
      var z2SelectLift = el.z2SelectLift;
      state.z2 = el.z2 + (z2SelectLift != null ? z2SelectLift : Z2_SELECT_LIFT);
    }
  }
  return state;
}
function createBlurDefaultState(el, stateName, state) {
  var hasBlur = indexOf(el.currentStates, stateName) >= 0;
  var currentOpacity = el.style.opacity;
  var fromState = !hasBlur ? getFromStateStyle(el, ["opacity"], stateName, {
    opacity: 1
  }) : null;
  state = state || {};
  var blurStyle = state.style || {};
  if (blurStyle.opacity == null) {
    state = extend({}, state);
    blurStyle = extend({
      opacity: hasBlur ? currentOpacity : fromState.opacity * 0.1
    }, blurStyle);
    state.style = blurStyle;
  }
  return state;
}
function elementStateProxy(stateName, targetStates) {
  var state = this.states[stateName];
  if (this.style) {
    if (stateName === "emphasis") {
      return createEmphasisDefaultState(this, stateName, targetStates, state);
    } else if (stateName === "blur") {
      return createBlurDefaultState(this, stateName, state);
    } else if (stateName === "select") {
      return createSelectDefaultState(this, stateName, state);
    }
  }
  return state;
}
function setDefaultStateProxy(el) {
  el.stateProxy = elementStateProxy;
  var textContent = el.getTextContent();
  var textGuide = el.getTextGuideLine();
  if (textContent) {
    textContent.stateProxy = elementStateProxy;
  }
  if (textGuide) {
    textGuide.stateProxy = elementStateProxy;
  }
}
function enterEmphasisWhenMouseOver(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasisWhenMouseOut(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterEmphasis(el, highlightDigit) {
  el.__highByOuter |= 1 << (highlightDigit || 0);
  traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasis(el, highlightDigit) {
  !(el.__highByOuter &= ~(1 << (highlightDigit || 0))) && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterBlur(el) {
  traverseUpdateState(el, singleEnterBlur);
}
function leaveBlur(el) {
  traverseUpdateState(el, singleLeaveBlur);
}
function enterSelect(el) {
  traverseUpdateState(el, singleEnterSelect);
}
function leaveSelect(el) {
  traverseUpdateState(el, singleLeaveSelect);
}
function shouldSilent(el, e2) {
  return el.__highDownSilentOnTouch && e2.zrByTouch;
}
function allLeaveBlur(api) {
  var model = api.getModel();
  model.eachComponent(function(componentType, componentModel) {
    var componentStates = getComponentStates(componentModel);
    if (componentStates.isBlured) {
      var view = componentType === "series" ? api.getViewOfSeriesModel(componentModel) : api.getViewOfComponentModel(componentModel);
      view.group.traverse(function(child) {
        singleLeaveBlur(child);
      });
    }
    componentStates.isBlured = false;
  });
}
function blurSeries(targetSeriesIndex, focus, blurScope, api) {
  var ecModel = api.getModel();
  blurScope = blurScope || "coordinateSystem";
  function leaveBlurOfIndices(data, dataIndices) {
    for (var i = 0; i < dataIndices.length; i++) {
      var itemEl = data.getItemGraphicEl(dataIndices[i]);
      itemEl && leaveBlur(itemEl);
    }
  }
  if (targetSeriesIndex == null) {
    return;
  }
  if (!focus || focus === "none") {
    return;
  }
  var targetSeriesModel = ecModel.getSeriesByIndex(targetSeriesIndex);
  var targetCoordSys = targetSeriesModel.coordinateSystem;
  if (targetCoordSys && targetCoordSys.master) {
    targetCoordSys = targetCoordSys.master;
  }
  var blurredSeries = [];
  ecModel.eachSeries(function(seriesModel) {
    var sameSeries = targetSeriesModel === seriesModel;
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.master) {
      coordSys = coordSys.master;
    }
    var sameCoordSys = coordSys && targetCoordSys ? coordSys === targetCoordSys : sameSeries;
    if (!(blurScope === "series" && !sameSeries || blurScope === "coordinateSystem" && !sameCoordSys || focus === "series" && sameSeries)) {
      var view = api.getViewOfSeriesModel(seriesModel);
      view.group.traverse(function(child) {
        singleEnterBlur(child);
      });
      if (isArrayLike(focus)) {
        leaveBlurOfIndices(seriesModel.getData(), focus);
      } else if (isObject$4(focus)) {
        var dataTypes = keys(focus);
        for (var d2 = 0; d2 < dataTypes.length; d2++) {
          leaveBlurOfIndices(seriesModel.getData(dataTypes[d2]), focus[dataTypes[d2]]);
        }
      }
      blurredSeries.push(seriesModel);
      getComponentStates(seriesModel).isBlured = true;
    }
  });
  ecModel.eachComponent(function(componentType, componentModel) {
    if (componentType === "series") {
      return;
    }
    var view = api.getViewOfComponentModel(componentModel);
    if (view && view.blurSeries) {
      view.blurSeries(blurredSeries, ecModel);
    }
  });
}
function blurComponent(componentMainType, componentIndex, api) {
  if (componentMainType == null || componentIndex == null) {
    return;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return;
  }
  getComponentStates(componentModel).isBlured = true;
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.focusBlurEnabled) {
    return;
  }
  view.group.traverse(function(child) {
    singleEnterBlur(child);
  });
}
function blurSeriesFromHighlightPayload(seriesModel, payload, api) {
  var seriesIndex = seriesModel.seriesIndex;
  var data = seriesModel.getData(payload.dataType);
  if (!data) {
    return;
  }
  var dataIndex = queryDataIndex(data, payload);
  dataIndex = (isArray$1(dataIndex) ? dataIndex[0] : dataIndex) || 0;
  var el = data.getItemGraphicEl(dataIndex);
  if (!el) {
    var count2 = data.count();
    var current = 0;
    while (!el && current < count2) {
      el = data.getItemGraphicEl(current++);
    }
  }
  if (el) {
    var ecData = getECData(el);
    blurSeries(seriesIndex, ecData.focus, ecData.blurScope, api);
  } else {
    var focus_1 = seriesModel.get(["emphasis", "focus"]);
    var blurScope = seriesModel.get(["emphasis", "blurScope"]);
    if (focus_1 != null) {
      blurSeries(seriesIndex, focus_1, blurScope, api);
    }
  }
}
function findComponentHighDownDispatchers(componentMainType, componentIndex, name, api) {
  var ret = {
    focusSelf: false,
    dispatchers: null
  };
  if (componentMainType == null || componentMainType === "series" || componentIndex == null || name == null) {
    return ret;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return ret;
  }
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.findHighDownDispatchers) {
    return ret;
  }
  var dispatchers = view.findHighDownDispatchers(name);
  var focusSelf;
  for (var i = 0; i < dispatchers.length; i++) {
    if (getECData(dispatchers[i]).focus === "self") {
      focusSelf = true;
      break;
    }
  }
  return {
    focusSelf,
    dispatchers
  };
}
function handleGlobalMouseOverForHighDown(dispatcher, e2, api) {
  var ecData = getECData(dispatcher);
  var _a2 = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api), dispatchers = _a2.dispatchers, focusSelf = _a2.focusSelf;
  if (dispatchers) {
    if (focusSelf) {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    each$f(dispatchers, function(dispatcher2) {
      return enterEmphasisWhenMouseOver(dispatcher2, e2);
    });
  } else {
    blurSeries(ecData.seriesIndex, ecData.focus, ecData.blurScope, api);
    if (ecData.focus === "self") {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    enterEmphasisWhenMouseOver(dispatcher, e2);
  }
}
function handleGlobalMouseOutForHighDown(dispatcher, e2, api) {
  allLeaveBlur(api);
  var ecData = getECData(dispatcher);
  var dispatchers = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api).dispatchers;
  if (dispatchers) {
    each$f(dispatchers, function(dispatcher2) {
      return leaveEmphasisWhenMouseOut(dispatcher2, e2);
    });
  } else {
    leaveEmphasisWhenMouseOut(dispatcher, e2);
  }
}
function toggleSelectionFromPayload(seriesModel, payload, api) {
  if (!isSelectChangePayload(payload)) {
    return;
  }
  var dataType = payload.dataType;
  var data = seriesModel.getData(dataType);
  var dataIndex = queryDataIndex(data, payload);
  if (!isArray$1(dataIndex)) {
    dataIndex = [dataIndex];
  }
  seriesModel[payload.type === TOGGLE_SELECT_ACTION_TYPE ? "toggleSelect" : payload.type === SELECT_ACTION_TYPE ? "select" : "unselect"](dataIndex, dataType);
}
function updateSeriesElementSelection(seriesModel) {
  var allData = seriesModel.getAllData();
  each$f(allData, function(_a2) {
    var data = _a2.data, type4 = _a2.type;
    data.eachItemGraphicEl(function(el, idx) {
      seriesModel.isSelected(idx, type4) ? enterSelect(el) : leaveSelect(el);
    });
  });
}
function getAllSelectedIndices(ecModel) {
  var ret = [];
  ecModel.eachSeries(function(seriesModel) {
    var allData = seriesModel.getAllData();
    each$f(allData, function(_a2) {
      _a2.data;
      var type4 = _a2.type;
      var dataIndices = seriesModel.getSelectedDataIndices();
      if (dataIndices.length > 0) {
        var item = {
          dataIndex: dataIndices,
          seriesIndex: seriesModel.seriesIndex
        };
        if (type4 != null) {
          item.dataType = type4;
        }
        ret.push(item);
      }
    });
  });
  return ret;
}
function enableHoverEmphasis(el, focus, blurScope) {
  setAsHighDownDispatcher(el, true);
  traverseUpdateState(el, setDefaultStateProxy);
  enableHoverFocus(el, focus, blurScope);
}
function disableHoverEmphasis(el) {
  setAsHighDownDispatcher(el, false);
}
function toggleHoverEmphasis(el, focus, blurScope, isDisabled) {
  isDisabled ? disableHoverEmphasis(el) : enableHoverEmphasis(el, focus, blurScope);
}
function enableHoverFocus(el, focus, blurScope) {
  var ecData = getECData(el);
  if (focus != null) {
    ecData.focus = focus;
    ecData.blurScope = blurScope;
  } else if (ecData.focus) {
    ecData.focus = null;
  }
}
var OTHER_STATES = ["emphasis", "blur", "select"];
var defaultStyleGetterMap = {
  itemStyle: "getItemStyle",
  lineStyle: "getLineStyle",
  areaStyle: "getAreaStyle"
};
function setStatesStylesFromModel(el, itemModel, styleType, getter) {
  styleType = styleType || "itemStyle";
  for (var i = 0; i < OTHER_STATES.length; i++) {
    var stateName = OTHER_STATES[i];
    var model = itemModel.getModel([stateName, styleType]);
    var state = el.ensureState(stateName);
    state.style = getter ? getter(model) : model[defaultStyleGetterMap[styleType]]();
  }
}
function setAsHighDownDispatcher(el, asDispatcher) {
  var disable = asDispatcher === false;
  var extendedEl = el;
  if (el.highDownSilentOnTouch) {
    extendedEl.__highDownSilentOnTouch = el.highDownSilentOnTouch;
  }
  if (!disable || extendedEl.__highDownDispatcher) {
    extendedEl.__highByOuter = extendedEl.__highByOuter || 0;
    extendedEl.__highDownDispatcher = !disable;
  }
}
function isHighDownDispatcher(el) {
  return !!(el && el.__highDownDispatcher);
}
function enableComponentHighDownFeatures(el, componentModel, componentHighDownName) {
  var ecData = getECData(el);
  ecData.componentMainType = componentModel.mainType;
  ecData.componentIndex = componentModel.componentIndex;
  ecData.componentHighDownName = componentHighDownName;
}
function getHighlightDigit(highlightKey) {
  var highlightDigit = _highlightKeyMap[highlightKey];
  if (highlightDigit == null && _highlightNextDigit <= 32) {
    highlightDigit = _highlightKeyMap[highlightKey] = _highlightNextDigit++;
  }
  return highlightDigit;
}
function isSelectChangePayload(payload) {
  var payloadType = payload.type;
  return payloadType === SELECT_ACTION_TYPE || payloadType === UNSELECT_ACTION_TYPE || payloadType === TOGGLE_SELECT_ACTION_TYPE;
}
function isHighDownPayload(payload) {
  var payloadType = payload.type;
  return payloadType === HIGHLIGHT_ACTION_TYPE || payloadType === DOWNPLAY_ACTION_TYPE;
}
function savePathStates(el) {
  var store = getSavedStates(el);
  store.normalFill = el.style.fill;
  store.normalStroke = el.style.stroke;
  var selectState = el.states.select || {};
  store.selectFill = selectState.style && selectState.style.fill || null;
  store.selectStroke = selectState.style && selectState.style.stroke || null;
}
var CMD$2 = PathProxy$1.CMD;
var points$2 = [[], [], []];
var mathSqrt$2 = Math.sqrt;
var mathAtan2 = Math.atan2;
function transformPath(path, m2) {
  if (!m2) {
    return;
  }
  var data = path.data;
  var len2 = path.len();
  var cmd;
  var nPoint;
  var i;
  var j;
  var k2;
  var p2;
  var M = CMD$2.M;
  var C = CMD$2.C;
  var L = CMD$2.L;
  var R = CMD$2.R;
  var A2 = CMD$2.A;
  var Q = CMD$2.Q;
  for (i = 0, j = 0; i < len2; ) {
    cmd = data[i++];
    j = i;
    nPoint = 0;
    switch (cmd) {
      case M:
        nPoint = 1;
        break;
      case L:
        nPoint = 1;
        break;
      case C:
        nPoint = 3;
        break;
      case Q:
        nPoint = 2;
        break;
      case A2:
        var x2 = m2[4];
        var y2 = m2[5];
        var sx = mathSqrt$2(m2[0] * m2[0] + m2[1] * m2[1]);
        var sy = mathSqrt$2(m2[2] * m2[2] + m2[3] * m2[3]);
        var angle = mathAtan2(-m2[1] / sy, m2[0] / sx);
        data[i] *= sx;
        data[i++] += x2;
        data[i] *= sy;
        data[i++] += y2;
        data[i++] *= sx;
        data[i++] *= sy;
        data[i++] += angle;
        data[i++] += angle;
        i += 2;
        j = i;
        break;
      case R:
        p2[0] = data[i++];
        p2[1] = data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
        p2[0] += data[i++];
        p2[1] += data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
    }
    for (k2 = 0; k2 < nPoint; k2++) {
      var p_1 = points$2[k2];
      p_1[0] = data[i++];
      p_1[1] = data[i++];
      applyTransform$1(p_1, p_1, m2);
      data[j++] = p_1[0];
      data[j++] = p_1[1];
    }
  }
  path.increaseVersion();
}
var mathSqrt$1 = Math.sqrt;
var mathSin$2 = Math.sin;
var mathCos$2 = Math.cos;
var PI$7 = Math.PI;
function vMag(v4) {
  return Math.sqrt(v4[0] * v4[0] + v4[1] * v4[1]);
}
function vRatio(u, v4) {
  return (u[0] * v4[0] + u[1] * v4[1]) / (vMag(u) * vMag(v4));
}
function vAngle(u, v4) {
  return (u[0] * v4[1] < u[1] * v4[0] ? -1 : 1) * Math.acos(vRatio(u, v4));
}
function processArc(x1, y1, x2, y2, fa, fs, rx, ry, psiDeg, cmd, path) {
  var psi = psiDeg * (PI$7 / 180);
  var xp = mathCos$2(psi) * (x1 - x2) / 2 + mathSin$2(psi) * (y1 - y2) / 2;
  var yp = -1 * mathSin$2(psi) * (x1 - x2) / 2 + mathCos$2(psi) * (y1 - y2) / 2;
  var lambda = xp * xp / (rx * rx) + yp * yp / (ry * ry);
  if (lambda > 1) {
    rx *= mathSqrt$1(lambda);
    ry *= mathSqrt$1(lambda);
  }
  var f2 = (fa === fs ? -1 : 1) * mathSqrt$1((rx * rx * (ry * ry) - rx * rx * (yp * yp) - ry * ry * (xp * xp)) / (rx * rx * (yp * yp) + ry * ry * (xp * xp))) || 0;
  var cxp = f2 * rx * yp / ry;
  var cyp = f2 * -ry * xp / rx;
  var cx = (x1 + x2) / 2 + mathCos$2(psi) * cxp - mathSin$2(psi) * cyp;
  var cy = (y1 + y2) / 2 + mathSin$2(psi) * cxp + mathCos$2(psi) * cyp;
  var theta = vAngle([1, 0], [(xp - cxp) / rx, (yp - cyp) / ry]);
  var u = [(xp - cxp) / rx, (yp - cyp) / ry];
  var v4 = [(-1 * xp - cxp) / rx, (-1 * yp - cyp) / ry];
  var dTheta = vAngle(u, v4);
  if (vRatio(u, v4) <= -1) {
    dTheta = PI$7;
  }
  if (vRatio(u, v4) >= 1) {
    dTheta = 0;
  }
  if (dTheta < 0) {
    var n2 = Math.round(dTheta / PI$7 * 1e6) / 1e6;
    dTheta = PI$7 * 2 + n2 % 2 * PI$7;
  }
  path.addData(cmd, cx, cy, rx, ry, theta, dTheta, psi, fs);
}
var commandReg = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig;
var numberReg$1 = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function createPathProxyFromString(data) {
  var path = new PathProxy$1();
  if (!data) {
    return path;
  }
  var cpx = 0;
  var cpy = 0;
  var subpathX = cpx;
  var subpathY = cpy;
  var prevCmd;
  var CMD2 = PathProxy$1.CMD;
  var cmdList = data.match(commandReg);
  if (!cmdList) {
    return path;
  }
  for (var l2 = 0; l2 < cmdList.length; l2++) {
    var cmdText = cmdList[l2];
    var cmdStr = cmdText.charAt(0);
    var cmd = void 0;
    var p2 = cmdText.match(numberReg$1) || [];
    var pLen = p2.length;
    for (var i = 0; i < pLen; i++) {
      p2[i] = parseFloat(p2[i]);
    }
    var off = 0;
    while (off < pLen) {
      var ctlPtx = void 0;
      var ctlPty = void 0;
      var rx = void 0;
      var ry = void 0;
      var psi = void 0;
      var fa = void 0;
      var fs = void 0;
      var x1 = cpx;
      var y1 = cpy;
      var len2 = void 0;
      var pathData = void 0;
      switch (cmdStr) {
        case "l":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "L":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "m":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "l";
          break;
        case "M":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "L";
          break;
        case "h":
          cpx += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "H":
          cpx = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "v":
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "V":
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "C":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++], p2[off++], p2[off++], p2[off++], p2[off++], p2[off++]);
          cpx = p2[off - 2];
          cpy = p2[off - 1];
          break;
        case "c":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy);
          cpx += p2[off - 2];
          cpy += p2[off - 1];
          break;
        case "S":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "s":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = cpx + p2[off++];
          y1 = cpy + p2[off++];
          cpx += p2[off++];
          cpy += p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "Q":
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "q":
          x1 = p2[off++] + cpx;
          y1 = p2[off++] + cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "T":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "t":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "A":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
        case "a":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
      }
    }
    if (cmdStr === "z" || cmdStr === "Z") {
      cmd = CMD2.Z;
      path.addData(cmd);
      cpx = subpathX;
      cpy = subpathY;
    }
    prevCmd = cmd;
  }
  path.toStatic();
  return path;
}
var SVGPath = function(_super) {
  __extends(SVGPath2, _super);
  function SVGPath2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SVGPath2.prototype.applyTransform = function(m2) {
  };
  return SVGPath2;
}(Path$1);
function isPathProxy(path) {
  return path.setData != null;
}
function createPathOptions(str, opts) {
  var pathProxy = createPathProxyFromString(str);
  var innerOpts = extend({}, opts);
  innerOpts.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.setData(pathProxy.data);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    } else {
      var ctx = path;
      pathProxy.rebuildPath(ctx, 1);
    }
  };
  innerOpts.applyTransform = function(m2) {
    transformPath(pathProxy, m2);
    this.dirtyShape();
  };
  return innerOpts;
}
function createFromString(str, opts) {
  return new SVGPath(createPathOptions(str, opts));
}
function extendFromString(str, defaultOpts) {
  var innerOpts = createPathOptions(str, defaultOpts);
  var Sub = function(_super) {
    __extends(Sub2, _super);
    function Sub2(opts) {
      var _this = _super.call(this, opts) || this;
      _this.applyTransform = innerOpts.applyTransform;
      _this.buildPath = innerOpts.buildPath;
      return _this;
    }
    return Sub2;
  }(SVGPath);
  return Sub;
}
function mergePath$1(pathEls, opts) {
  var pathList = [];
  var len2 = pathEls.length;
  for (var i = 0; i < len2; i++) {
    var pathEl = pathEls[i];
    pathList.push(pathEl.getUpdatedPathProxy(true));
  }
  var pathBundle = new Path$1(opts);
  pathBundle.createPathProxy();
  pathBundle.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.appendPath(pathList);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    }
  };
  return pathBundle;
}
function clonePath(sourcePath, opts) {
  opts = opts || {};
  var path = new Path$1();
  if (sourcePath.shape) {
    path.setShape(sourcePath.shape);
  }
  path.setStyle(sourcePath.style);
  if (opts.bakeTransform) {
    transformPath(path.path, sourcePath.getComputedTransform());
  } else {
    if (opts.toLocal) {
      path.setLocalTransform(sourcePath.getComputedTransform());
    } else {
      path.copyTransform(sourcePath);
    }
  }
  path.buildPath = sourcePath.buildPath;
  path.applyTransform = path.applyTransform;
  path.z = sourcePath.z;
  path.z2 = sourcePath.z2;
  path.zlevel = sourcePath.zlevel;
  return path;
}
var CircleShape = function() {
  function CircleShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
  }
  return CircleShape2;
}();
var Circle = function(_super) {
  __extends(Circle2, _super);
  function Circle2(opts) {
    return _super.call(this, opts) || this;
  }
  Circle2.prototype.getDefaultShape = function() {
    return new CircleShape();
  };
  Circle2.prototype.buildPath = function(ctx, shape) {
    ctx.moveTo(shape.cx + shape.r, shape.cy);
    ctx.arc(shape.cx, shape.cy, shape.r, 0, Math.PI * 2);
  };
  return Circle2;
}(Path$1);
Circle.prototype.type = "circle";
var Circle$1 = Circle;
var EllipseShape = function() {
  function EllipseShape2() {
    this.cx = 0;
    this.cy = 0;
    this.rx = 0;
    this.ry = 0;
  }
  return EllipseShape2;
}();
var Ellipse = function(_super) {
  __extends(Ellipse2, _super);
  function Ellipse2(opts) {
    return _super.call(this, opts) || this;
  }
  Ellipse2.prototype.getDefaultShape = function() {
    return new EllipseShape();
  };
  Ellipse2.prototype.buildPath = function(ctx, shape) {
    var k2 = 0.5522848;
    var x2 = shape.cx;
    var y2 = shape.cy;
    var a = shape.rx;
    var b2 = shape.ry;
    var ox = a * k2;
    var oy = b2 * k2;
    ctx.moveTo(x2 - a, y2);
    ctx.bezierCurveTo(x2 - a, y2 - oy, x2 - ox, y2 - b2, x2, y2 - b2);
    ctx.bezierCurveTo(x2 + ox, y2 - b2, x2 + a, y2 - oy, x2 + a, y2);
    ctx.bezierCurveTo(x2 + a, y2 + oy, x2 + ox, y2 + b2, x2, y2 + b2);
    ctx.bezierCurveTo(x2 - ox, y2 + b2, x2 - a, y2 + oy, x2 - a, y2);
    ctx.closePath();
  };
  return Ellipse2;
}(Path$1);
Ellipse.prototype.type = "ellipse";
var Ellipse$1 = Ellipse;
var PI$6 = Math.PI;
var PI2$4 = PI$6 * 2;
var mathSin$1 = Math.sin;
var mathCos$1 = Math.cos;
var mathACos = Math.acos;
var mathATan2 = Math.atan2;
var mathAbs$1 = Math.abs;
var mathSqrt = Math.sqrt;
var mathMax$7 = Math.max;
var mathMin$7 = Math.min;
var e$1 = 1e-4;
function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
  var dx10 = x1 - x0;
  var dy10 = y1 - y0;
  var dx32 = x3 - x2;
  var dy32 = y3 - y2;
  var t2 = dy32 * dx10 - dx32 * dy10;
  if (t2 * t2 < e$1) {
    return;
  }
  t2 = (dx32 * (y0 - y2) - dy32 * (x0 - x2)) / t2;
  return [x0 + t2 * dx10, y0 + t2 * dy10];
}
function computeCornerTangents(x0, y0, x1, y1, radius, cr, clockwise) {
  var x01 = x0 - x1;
  var y01 = y0 - y1;
  var lo = (clockwise ? cr : -cr) / mathSqrt(x01 * x01 + y01 * y01);
  var ox = lo * y01;
  var oy = -lo * x01;
  var x11 = x0 + ox;
  var y11 = y0 + oy;
  var x10 = x1 + ox;
  var y10 = y1 + oy;
  var x00 = (x11 + x10) / 2;
  var y00 = (y11 + y10) / 2;
  var dx = x10 - x11;
  var dy = y10 - y11;
  var d2 = dx * dx + dy * dy;
  var r2 = radius - cr;
  var s = x11 * y10 - x10 * y11;
  var d3 = (dy < 0 ? -1 : 1) * mathSqrt(mathMax$7(0, r2 * r2 * d2 - s * s));
  var cx0 = (s * dy - dx * d3) / d2;
  var cy0 = (-s * dx - dy * d3) / d2;
  var cx1 = (s * dy + dx * d3) / d2;
  var cy1 = (-s * dx + dy * d3) / d2;
  var dx0 = cx0 - x00;
  var dy0 = cy0 - y00;
  var dx1 = cx1 - x00;
  var dy1 = cy1 - y00;
  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
    cx0 = cx1;
    cy0 = cy1;
  }
  return {
    cx: cx0,
    cy: cy0,
    x0: -ox,
    y0: -oy,
    x1: cx0 * (radius / r2 - 1),
    y1: cy0 * (radius / r2 - 1)
  };
}
function normalizeCornerRadius(cr) {
  var arr;
  if (isArray$1(cr)) {
    var len2 = cr.length;
    if (!len2) {
      return cr;
    }
    if (len2 === 1) {
      arr = [cr[0], cr[0], 0, 0];
    } else if (len2 === 2) {
      arr = [cr[0], cr[0], cr[1], cr[1]];
    } else if (len2 === 3) {
      arr = cr.concat(cr[2]);
    } else {
      arr = cr;
    }
  } else {
    arr = [cr, cr, cr, cr];
  }
  return arr;
}
function buildPath$1(ctx, shape) {
  var _a2;
  var radius = mathMax$7(shape.r, 0);
  var innerRadius = mathMax$7(shape.r0 || 0, 0);
  var hasRadius = radius > 0;
  var hasInnerRadius = innerRadius > 0;
  if (!hasRadius && !hasInnerRadius) {
    return;
  }
  if (!hasRadius) {
    radius = innerRadius;
    innerRadius = 0;
  }
  if (innerRadius > radius) {
    var tmp = radius;
    radius = innerRadius;
    innerRadius = tmp;
  }
  var startAngle = shape.startAngle, endAngle = shape.endAngle;
  if (isNaN(startAngle) || isNaN(endAngle)) {
    return;
  }
  var cx = shape.cx, cy = shape.cy;
  var clockwise = !!shape.clockwise;
  var arc = mathAbs$1(endAngle - startAngle);
  var mod = arc > PI2$4 && arc % PI2$4;
  mod > e$1 && (arc = mod);
  if (!(radius > e$1)) {
    ctx.moveTo(cx, cy);
  } else if (arc > PI2$4 - e$1) {
    ctx.moveTo(cx + radius * mathCos$1(startAngle), cy + radius * mathSin$1(startAngle));
    ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    if (innerRadius > e$1) {
      ctx.moveTo(cx + innerRadius * mathCos$1(endAngle), cy + innerRadius * mathSin$1(endAngle));
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  } else {
    var icrStart = void 0;
    var icrEnd = void 0;
    var ocrStart = void 0;
    var ocrEnd = void 0;
    var ocrs = void 0;
    var ocre = void 0;
    var icrs = void 0;
    var icre = void 0;
    var ocrMax = void 0;
    var icrMax = void 0;
    var limitedOcrMax = void 0;
    var limitedIcrMax = void 0;
    var xre = void 0;
    var yre = void 0;
    var xirs = void 0;
    var yirs = void 0;
    var xrs = radius * mathCos$1(startAngle);
    var yrs = radius * mathSin$1(startAngle);
    var xire = innerRadius * mathCos$1(endAngle);
    var yire = innerRadius * mathSin$1(endAngle);
    var hasArc = arc > e$1;
    if (hasArc) {
      var cornerRadius = shape.cornerRadius;
      if (cornerRadius) {
        _a2 = normalizeCornerRadius(cornerRadius), icrStart = _a2[0], icrEnd = _a2[1], ocrStart = _a2[2], ocrEnd = _a2[3];
      }
      var halfRd = mathAbs$1(radius - innerRadius) / 2;
      ocrs = mathMin$7(halfRd, ocrStart);
      ocre = mathMin$7(halfRd, ocrEnd);
      icrs = mathMin$7(halfRd, icrStart);
      icre = mathMin$7(halfRd, icrEnd);
      limitedOcrMax = ocrMax = mathMax$7(ocrs, ocre);
      limitedIcrMax = icrMax = mathMax$7(icrs, icre);
      if (ocrMax > e$1 || icrMax > e$1) {
        xre = radius * mathCos$1(endAngle);
        yre = radius * mathSin$1(endAngle);
        xirs = innerRadius * mathCos$1(startAngle);
        yirs = innerRadius * mathSin$1(startAngle);
        if (arc < PI$6) {
          var it_1 = intersect(xrs, yrs, xirs, yirs, xre, yre, xire, yire);
          if (it_1) {
            var x0 = xrs - it_1[0];
            var y0 = yrs - it_1[1];
            var x1 = xre - it_1[0];
            var y1 = yre - it_1[1];
            var a = 1 / mathSin$1(mathACos((x0 * x1 + y0 * y1) / (mathSqrt(x0 * x0 + y0 * y0) * mathSqrt(x1 * x1 + y1 * y1))) / 2);
            var b2 = mathSqrt(it_1[0] * it_1[0] + it_1[1] * it_1[1]);
            limitedOcrMax = mathMin$7(ocrMax, (radius - b2) / (a + 1));
            limitedIcrMax = mathMin$7(icrMax, (innerRadius - b2) / (a - 1));
          }
        }
      }
    }
    if (!hasArc) {
      ctx.moveTo(cx + xrs, cy + yrs);
    } else if (limitedOcrMax > e$1) {
      var crStart = mathMin$7(ocrStart, limitedOcrMax);
      var crEnd = mathMin$7(ocrEnd, limitedOcrMax);
      var ct0 = computeCornerTangents(xirs, yirs, xrs, yrs, radius, crStart, clockwise);
      var ct1 = computeCornerTangents(xre, yre, xire, yire, radius, crEnd, clockwise);
      ctx.moveTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedOcrMax < ocrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedOcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crStart > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crStart, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, radius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), !clockwise);
        crEnd > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crEnd, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.moveTo(cx + xrs, cy + yrs);
      ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    }
    if (!(innerRadius > e$1) || !hasArc) {
      ctx.lineTo(cx + xire, cy + yire);
    } else if (limitedIcrMax > e$1) {
      var crStart = mathMin$7(icrStart, limitedIcrMax);
      var crEnd = mathMin$7(icrEnd, limitedIcrMax);
      var ct0 = computeCornerTangents(xire, yire, xre, yre, innerRadius, -crEnd, clockwise);
      var ct1 = computeCornerTangents(xrs, yrs, xirs, yirs, innerRadius, -crStart, clockwise);
      ctx.lineTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedIcrMax < icrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedIcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crEnd > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crEnd, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, innerRadius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), clockwise);
        crStart > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crStart, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.lineTo(cx + xire, cy + yire);
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  }
  ctx.closePath();
}
var SectorShape = function() {
  function SectorShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
    this.cornerRadius = 0;
  }
  return SectorShape2;
}();
var Sector = function(_super) {
  __extends(Sector2, _super);
  function Sector2(opts) {
    return _super.call(this, opts) || this;
  }
  Sector2.prototype.getDefaultShape = function() {
    return new SectorShape();
  };
  Sector2.prototype.buildPath = function(ctx, shape) {
    buildPath$1(ctx, shape);
  };
  Sector2.prototype.isZeroArea = function() {
    return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
  };
  return Sector2;
}(Path$1);
Sector.prototype.type = "sector";
var Sector$1 = Sector;
var RingShape = function() {
  function RingShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.r0 = 0;
  }
  return RingShape2;
}();
var Ring = function(_super) {
  __extends(Ring2, _super);
  function Ring2(opts) {
    return _super.call(this, opts) || this;
  }
  Ring2.prototype.getDefaultShape = function() {
    return new RingShape();
  };
  Ring2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var PI22 = Math.PI * 2;
    ctx.moveTo(x2 + shape.r, y2);
    ctx.arc(x2, y2, shape.r, 0, PI22, false);
    ctx.moveTo(x2 + shape.r0, y2);
    ctx.arc(x2, y2, shape.r0, 0, PI22, true);
  };
  return Ring2;
}(Path$1);
Ring.prototype.type = "ring";
var Ring$1 = Ring;
function smoothBezier(points2, smooth, isLoop, constraint) {
  var cps = [];
  var v4 = [];
  var v12 = [];
  var v22 = [];
  var prevPoint;
  var nextPoint;
  var min3;
  var max3;
  if (constraint) {
    min3 = [Infinity, Infinity];
    max3 = [-Infinity, -Infinity];
    for (var i = 0, len2 = points2.length; i < len2; i++) {
      min$1(min3, min3, points2[i]);
      max$1(max3, max3, points2[i]);
    }
    min$1(min3, min3, constraint[0]);
    max$1(max3, max3, constraint[1]);
  }
  for (var i = 0, len2 = points2.length; i < len2; i++) {
    var point = points2[i];
    if (isLoop) {
      prevPoint = points2[i ? i - 1 : len2 - 1];
      nextPoint = points2[(i + 1) % len2];
    } else {
      if (i === 0 || i === len2 - 1) {
        cps.push(clone$3(points2[i]));
        continue;
      } else {
        prevPoint = points2[i - 1];
        nextPoint = points2[i + 1];
      }
    }
    sub(v4, nextPoint, prevPoint);
    scale$2(v4, v4, smooth);
    var d0 = distance(point, prevPoint);
    var d1 = distance(point, nextPoint);
    var sum2 = d0 + d1;
    if (sum2 !== 0) {
      d0 /= sum2;
      d1 /= sum2;
    }
    scale$2(v12, v4, -d0);
    scale$2(v22, v4, d1);
    var cp0 = add([], point, v12);
    var cp1 = add([], point, v22);
    if (constraint) {
      max$1(cp0, cp0, min3);
      min$1(cp0, cp0, max3);
      max$1(cp1, cp1, min3);
      min$1(cp1, cp1, max3);
    }
    cps.push(cp0);
    cps.push(cp1);
  }
  if (isLoop) {
    cps.push(cps.shift());
  }
  return cps;
}
function buildPath(ctx, shape, closePath) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (points2 && points2.length >= 2) {
    if (smooth) {
      var controlPoints = smoothBezier(points2, smooth, closePath, shape.smoothConstraint);
      ctx.moveTo(points2[0][0], points2[0][1]);
      var len2 = points2.length;
      for (var i = 0; i < (closePath ? len2 : len2 - 1); i++) {
        var cp1 = controlPoints[i * 2];
        var cp2 = controlPoints[i * 2 + 1];
        var p2 = points2[(i + 1) % len2];
        ctx.bezierCurveTo(cp1[0], cp1[1], cp2[0], cp2[1], p2[0], p2[1]);
      }
    } else {
      ctx.moveTo(points2[0][0], points2[0][1]);
      for (var i = 1, l2 = points2.length; i < l2; i++) {
        ctx.lineTo(points2[i][0], points2[i][1]);
      }
    }
    closePath && ctx.closePath();
  }
}
var PolygonShape = function() {
  function PolygonShape2() {
    this.points = null;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolygonShape2;
}();
var Polygon = function(_super) {
  __extends(Polygon2, _super);
  function Polygon2(opts) {
    return _super.call(this, opts) || this;
  }
  Polygon2.prototype.getDefaultShape = function() {
    return new PolygonShape();
  };
  Polygon2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, true);
  };
  return Polygon2;
}(Path$1);
Polygon.prototype.type = "polygon";
var Polygon$1 = Polygon;
var PolylineShape = function() {
  function PolylineShape2() {
    this.points = null;
    this.percent = 1;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolylineShape2;
}();
var Polyline$2 = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(opts) {
    return _super.call(this, opts) || this;
  }
  Polyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Polyline2.prototype.getDefaultShape = function() {
    return new PolylineShape();
  };
  Polyline2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, false);
  };
  return Polyline2;
}(Path$1);
Polyline$2.prototype.type = "polyline";
var Polyline$3 = Polyline$2;
var subPixelOptimizeOutputShape = {};
var LineShape = function() {
  function LineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return LineShape2;
}();
var Line$2 = function(_super) {
  __extends(Line2, _super);
  function Line2(opts) {
    return _super.call(this, opts) || this;
  }
  Line2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Line2.prototype.getDefaultShape = function() {
    return new LineShape();
  };
  Line2.prototype.buildPath = function(ctx, shape) {
    var x1;
    var y1;
    var x2;
    var y2;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeLine$1(subPixelOptimizeOutputShape, shape, this.style);
      x1 = optimizedShape.x1;
      y1 = optimizedShape.y1;
      x2 = optimizedShape.x2;
      y2 = optimizedShape.y2;
    } else {
      x1 = shape.x1;
      y1 = shape.y1;
      x2 = shape.x2;
      y2 = shape.y2;
    }
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (percent < 1) {
      x2 = x1 * (1 - percent) + x2 * percent;
      y2 = y1 * (1 - percent) + y2 * percent;
    }
    ctx.lineTo(x2, y2);
  };
  Line2.prototype.pointAt = function(p2) {
    var shape = this.shape;
    return [
      shape.x1 * (1 - p2) + shape.x2 * p2,
      shape.y1 * (1 - p2) + shape.y2 * p2
    ];
  };
  return Line2;
}(Path$1);
Line$2.prototype.type = "line";
var Line$3 = Line$2;
var out = [];
var BezierCurveShape = function() {
  function BezierCurveShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.percent = 1;
  }
  return BezierCurveShape2;
}();
function someVectorAt(shape, t2, isTangent) {
  var cpx2 = shape.cpx2;
  var cpy2 = shape.cpy2;
  if (cpx2 != null || cpy2 != null) {
    return [
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.x1, shape.cpx1, shape.cpx2, shape.x2, t2),
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.y1, shape.cpy1, shape.cpy2, shape.y2, t2)
    ];
  } else {
    return [
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.x1, shape.cpx1, shape.x2, t2),
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.y1, shape.cpy1, shape.y2, t2)
    ];
  }
}
var BezierCurve = function(_super) {
  __extends(BezierCurve2, _super);
  function BezierCurve2(opts) {
    return _super.call(this, opts) || this;
  }
  BezierCurve2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  BezierCurve2.prototype.getDefaultShape = function() {
    return new BezierCurveShape();
  };
  BezierCurve2.prototype.buildPath = function(ctx, shape) {
    var x1 = shape.x1;
    var y1 = shape.y1;
    var x2 = shape.x2;
    var y2 = shape.y2;
    var cpx1 = shape.cpx1;
    var cpy1 = shape.cpy1;
    var cpx2 = shape.cpx2;
    var cpy2 = shape.cpy2;
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (cpx2 == null || cpy2 == null) {
      if (percent < 1) {
        quadraticSubdivide(x1, cpx1, x2, percent, out);
        cpx1 = out[1];
        x2 = out[2];
        quadraticSubdivide(y1, cpy1, y2, percent, out);
        cpy1 = out[1];
        y2 = out[2];
      }
      ctx.quadraticCurveTo(cpx1, cpy1, x2, y2);
    } else {
      if (percent < 1) {
        cubicSubdivide(x1, cpx1, cpx2, x2, percent, out);
        cpx1 = out[1];
        cpx2 = out[2];
        x2 = out[3];
        cubicSubdivide(y1, cpy1, cpy2, y2, percent, out);
        cpy1 = out[1];
        cpy2 = out[2];
        y2 = out[3];
      }
      ctx.bezierCurveTo(cpx1, cpy1, cpx2, cpy2, x2, y2);
    }
  };
  BezierCurve2.prototype.pointAt = function(t2) {
    return someVectorAt(this.shape, t2, false);
  };
  BezierCurve2.prototype.tangentAt = function(t2) {
    var p2 = someVectorAt(this.shape, t2, true);
    return normalize$4(p2, p2);
  };
  return BezierCurve2;
}(Path$1);
BezierCurve.prototype.type = "bezier-curve";
var BezierCurve$1 = BezierCurve;
var ArcShape = function() {
  function ArcShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return ArcShape2;
}();
var Arc = function(_super) {
  __extends(Arc2, _super);
  function Arc2(opts) {
    return _super.call(this, opts) || this;
  }
  Arc2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Arc2.prototype.getDefaultShape = function() {
    return new ArcShape();
  };
  Arc2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var r2 = Math.max(shape.r, 0);
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var unitX = Math.cos(startAngle);
    var unitY = Math.sin(startAngle);
    ctx.moveTo(unitX * r2 + x2, unitY * r2 + y2);
    ctx.arc(x2, y2, r2, startAngle, endAngle, !clockwise);
  };
  return Arc2;
}(Path$1);
Arc.prototype.type = "arc";
var Arc$1 = Arc;
var CompoundPath = function(_super) {
  __extends(CompoundPath2, _super);
  function CompoundPath2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "compound";
    return _this;
  }
  CompoundPath2.prototype._updatePathDirty = function() {
    var paths = this.shape.paths;
    var dirtyPath = this.shapeChanged();
    for (var i = 0; i < paths.length; i++) {
      dirtyPath = dirtyPath || paths[i].shapeChanged();
    }
    if (dirtyPath) {
      this.dirtyShape();
    }
  };
  CompoundPath2.prototype.beforeBrush = function() {
    this._updatePathDirty();
    var paths = this.shape.paths || [];
    var scale2 = this.getGlobalScale();
    for (var i = 0; i < paths.length; i++) {
      if (!paths[i].path) {
        paths[i].createPathProxy();
      }
      paths[i].path.setScale(scale2[0], scale2[1], paths[i].segmentIgnoreThreshold);
    }
  };
  CompoundPath2.prototype.buildPath = function(ctx, shape) {
    var paths = shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].buildPath(ctx, paths[i].shape, true);
    }
  };
  CompoundPath2.prototype.afterBrush = function() {
    var paths = this.shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].pathUpdated();
    }
  };
  CompoundPath2.prototype.getBoundingRect = function() {
    this._updatePathDirty.call(this);
    return Path$1.prototype.getBoundingRect.call(this);
  };
  return CompoundPath2;
}(Path$1);
var CompoundPath$1 = CompoundPath;
var Gradient = function() {
  function Gradient2(colorStops) {
    this.colorStops = colorStops || [];
  }
  Gradient2.prototype.addColorStop = function(offset, color) {
    this.colorStops.push({
      offset,
      color
    });
  };
  return Gradient2;
}();
var Gradient$1 = Gradient;
var LinearGradient = function(_super) {
  __extends(LinearGradient2, _super);
  function LinearGradient2(x2, y2, x22, y22, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0 : x2;
    _this.y = y2 == null ? 0 : y2;
    _this.x2 = x22 == null ? 1 : x22;
    _this.y2 = y22 == null ? 0 : y22;
    _this.type = "linear";
    _this.global = globalCoord || false;
    return _this;
  }
  return LinearGradient2;
}(Gradient$1);
var LinearGradient$1 = LinearGradient;
var RadialGradient = function(_super) {
  __extends(RadialGradient2, _super);
  function RadialGradient2(x2, y2, r2, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0.5 : x2;
    _this.y = y2 == null ? 0.5 : y2;
    _this.r = r2 == null ? 0.5 : r2;
    _this.type = "radial";
    _this.global = globalCoord || false;
    return _this;
  }
  return RadialGradient2;
}(Gradient$1);
var RadialGradient$1 = RadialGradient;
var extent = [0, 0];
var extent2 = [0, 0];
var minTv = new Point$1();
var maxTv = new Point$1();
var OrientedBoundingRect = function() {
  function OrientedBoundingRect2(rect, transform2) {
    this._corners = [];
    this._axes = [];
    this._origin = [0, 0];
    for (var i = 0; i < 4; i++) {
      this._corners[i] = new Point$1();
    }
    for (var i = 0; i < 2; i++) {
      this._axes[i] = new Point$1();
    }
    if (rect) {
      this.fromBoundingRect(rect, transform2);
    }
  }
  OrientedBoundingRect2.prototype.fromBoundingRect = function(rect, transform2) {
    var corners = this._corners;
    var axes = this._axes;
    var x2 = rect.x;
    var y2 = rect.y;
    var x22 = x2 + rect.width;
    var y22 = y2 + rect.height;
    corners[0].set(x2, y2);
    corners[1].set(x22, y2);
    corners[2].set(x22, y22);
    corners[3].set(x2, y22);
    if (transform2) {
      for (var i = 0; i < 4; i++) {
        corners[i].transform(transform2);
      }
    }
    Point$1.sub(axes[0], corners[1], corners[0]);
    Point$1.sub(axes[1], corners[3], corners[0]);
    axes[0].normalize();
    axes[1].normalize();
    for (var i = 0; i < 2; i++) {
      this._origin[i] = axes[i].dot(corners[0]);
    }
  };
  OrientedBoundingRect2.prototype.intersect = function(other, mtv) {
    var overlapped = true;
    var noMtv = !mtv;
    minTv.set(Infinity, Infinity);
    maxTv.set(0, 0);
    if (!this._intersectCheckOneSide(this, other, minTv, maxTv, noMtv, 1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!this._intersectCheckOneSide(other, this, minTv, maxTv, noMtv, -1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!noMtv) {
      Point$1.copy(mtv, overlapped ? minTv : maxTv);
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._intersectCheckOneSide = function(self2, other, minTv2, maxTv2, noMtv, inverse) {
    var overlapped = true;
    for (var i = 0; i < 2; i++) {
      var axis = this._axes[i];
      this._getProjMinMaxOnAxis(i, self2._corners, extent);
      this._getProjMinMaxOnAxis(i, other._corners, extent2);
      if (extent[1] < extent2[0] || extent[0] > extent2[1]) {
        overlapped = false;
        if (noMtv) {
          return overlapped;
        }
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) > maxTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(maxTv2, axis, -dist0 * inverse);
          } else {
            Point$1.scale(maxTv2, axis, dist1 * inverse);
          }
        }
      } else if (minTv2) {
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) < minTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(minTv2, axis, dist0 * inverse);
          } else {
            Point$1.scale(minTv2, axis, -dist1 * inverse);
          }
        }
      }
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._getProjMinMaxOnAxis = function(dim, corners, out2) {
    var axis = this._axes[dim];
    var origin = this._origin;
    var proj = corners[0].dot(axis) + origin[dim];
    var min3 = proj;
    var max3 = proj;
    for (var i = 1; i < corners.length; i++) {
      var proj_1 = corners[i].dot(axis) + origin[dim];
      min3 = Math.min(proj_1, min3);
      max3 = Math.max(proj_1, max3);
    }
    out2[0] = min3;
    out2[1] = max3;
  };
  return OrientedBoundingRect2;
}();
var OrientedBoundingRect$1 = OrientedBoundingRect;
var m$2 = [];
var IncrementalDisplayable = function(_super) {
  __extends(IncrementalDisplayable2, _super);
  function IncrementalDisplayable2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.notClear = true;
    _this.incremental = true;
    _this._displayables = [];
    _this._temporaryDisplayables = [];
    _this._cursor = 0;
    return _this;
  }
  IncrementalDisplayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  IncrementalDisplayable2.prototype.useStyle = function() {
    this.style = {};
  };
  IncrementalDisplayable2.prototype.getCursor = function() {
    return this._cursor;
  };
  IncrementalDisplayable2.prototype.innerAfterBrush = function() {
    this._cursor = this._displayables.length;
  };
  IncrementalDisplayable2.prototype.clearDisplaybles = function() {
    this._displayables = [];
    this._temporaryDisplayables = [];
    this._cursor = 0;
    this.markRedraw();
    this.notClear = false;
  };
  IncrementalDisplayable2.prototype.clearTemporalDisplayables = function() {
    this._temporaryDisplayables = [];
  };
  IncrementalDisplayable2.prototype.addDisplayable = function(displayable, notPersistent) {
    if (notPersistent) {
      this._temporaryDisplayables.push(displayable);
    } else {
      this._displayables.push(displayable);
    }
    this.markRedraw();
  };
  IncrementalDisplayable2.prototype.addDisplayables = function(displayables, notPersistent) {
    notPersistent = notPersistent || false;
    for (var i = 0; i < displayables.length; i++) {
      this.addDisplayable(displayables[i], notPersistent);
    }
  };
  IncrementalDisplayable2.prototype.getDisplayables = function() {
    return this._displayables;
  };
  IncrementalDisplayable2.prototype.getTemporalDisplayables = function() {
    return this._temporaryDisplayables;
  };
  IncrementalDisplayable2.prototype.eachPendingDisplayable = function(cb) {
    for (var i = this._cursor; i < this._displayables.length; i++) {
      cb && cb(this._displayables[i]);
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      cb && cb(this._temporaryDisplayables[i]);
    }
  };
  IncrementalDisplayable2.prototype.update = function() {
    this.updateTransform();
    for (var i = this._cursor; i < this._displayables.length; i++) {
      var displayable = this._displayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      var displayable = this._temporaryDisplayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
  };
  IncrementalDisplayable2.prototype.getBoundingRect = function() {
    if (!this._rect) {
      var rect = new BoundingRect$1(Infinity, Infinity, -Infinity, -Infinity);
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        var childRect = displayable.getBoundingRect().clone();
        if (displayable.needLocalTransform()) {
          childRect.applyTransform(displayable.getLocalTransform(m$2));
        }
        rect.union(childRect);
      }
      this._rect = rect;
    }
    return this._rect;
  };
  IncrementalDisplayable2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    if (rect.contain(localPos[0], localPos[1])) {
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        if (displayable.contain(x2, y2)) {
          return true;
        }
      }
    }
    return false;
  };
  return IncrementalDisplayable2;
}(Displayable$1);
var IncrementalDisplayable$1 = IncrementalDisplayable;
var transitionStore = makeInner();
function getAnimationConfig(animationType, animatableModel, dataIndex, extraOpts, extraDelayParams) {
  var animationPayload;
  if (animatableModel && animatableModel.ecModel) {
    var updatePayload = animatableModel.ecModel.getUpdatePayload();
    animationPayload = updatePayload && updatePayload.animation;
  }
  var animationEnabled = animatableModel && animatableModel.isAnimationEnabled();
  var isUpdate = animationType === "update";
  if (animationEnabled) {
    var duration = void 0;
    var easing = void 0;
    var delay = void 0;
    if (extraOpts) {
      duration = retrieve2(extraOpts.duration, 200);
      easing = retrieve2(extraOpts.easing, "cubicOut");
      delay = 0;
    } else {
      duration = animatableModel.getShallow(isUpdate ? "animationDurationUpdate" : "animationDuration");
      easing = animatableModel.getShallow(isUpdate ? "animationEasingUpdate" : "animationEasing");
      delay = animatableModel.getShallow(isUpdate ? "animationDelayUpdate" : "animationDelay");
    }
    if (animationPayload) {
      animationPayload.duration != null && (duration = animationPayload.duration);
      animationPayload.easing != null && (easing = animationPayload.easing);
      animationPayload.delay != null && (delay = animationPayload.delay);
    }
    if (isFunction(delay)) {
      delay = delay(dataIndex, extraDelayParams);
    }
    if (isFunction(duration)) {
      duration = duration(dataIndex);
    }
    var config = {
      duration: duration || 0,
      delay,
      easing
    };
    return config;
  } else {
    return null;
  }
}
function animateOrSetProps(animationType, el, props, animatableModel, dataIndex, cb, during) {
  var isFrom = false;
  var removeOpt;
  if (isFunction(dataIndex)) {
    during = cb;
    cb = dataIndex;
    dataIndex = null;
  } else if (isObject$4(dataIndex)) {
    cb = dataIndex.cb;
    during = dataIndex.during;
    isFrom = dataIndex.isFrom;
    removeOpt = dataIndex.removeOpt;
    dataIndex = dataIndex.dataIndex;
  }
  var isRemove = animationType === "leave";
  if (!isRemove) {
    el.stopAnimation("leave");
  }
  var animationConfig = getAnimationConfig(animationType, animatableModel, dataIndex, isRemove ? removeOpt || {} : null, animatableModel && animatableModel.getAnimationDelayParams ? animatableModel.getAnimationDelayParams(el, dataIndex) : null);
  if (animationConfig && animationConfig.duration > 0) {
    var duration = animationConfig.duration;
    var animationDelay = animationConfig.delay;
    var animationEasing = animationConfig.easing;
    var animateConfig = {
      duration,
      delay: animationDelay || 0,
      easing: animationEasing,
      done: cb,
      force: !!cb || !!during,
      setToFinal: !isRemove,
      scope: animationType,
      during
    };
    isFrom ? el.animateFrom(props, animateConfig) : el.animateTo(props, animateConfig);
  } else {
    el.stopAnimation();
    !isFrom && el.attr(props);
    during && during(1);
    cb && cb();
  }
}
function updateProps$1(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("update", el, props, animatableModel, dataIndex, cb, during);
}
function initProps(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("enter", el, props, animatableModel, dataIndex, cb, during);
}
function isElementRemoved(el) {
  if (!el.__zr) {
    return true;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.scope === "leave") {
      return true;
    }
  }
  return false;
}
function removeElement(el, props, animatableModel, dataIndex, cb, during) {
  if (isElementRemoved(el)) {
    return;
  }
  animateOrSetProps("leave", el, props, animatableModel, dataIndex, cb, during);
}
function fadeOutDisplayable(el, animatableModel, dataIndex, done) {
  el.removeTextContent();
  el.removeTextGuideLine();
  removeElement(el, {
    style: {
      opacity: 0
    }
  }, animatableModel, dataIndex, done);
}
function removeElementWithFadeOut(el, animatableModel, dataIndex) {
  function doRemove() {
    el.parent && el.parent.remove(el);
  }
  if (!el.isGroup) {
    fadeOutDisplayable(el, animatableModel, dataIndex, doRemove);
  } else {
    el.traverse(function(disp) {
      if (!disp.isGroup) {
        fadeOutDisplayable(disp, animatableModel, dataIndex, doRemove);
      }
    });
  }
}
function saveOldStyle(el) {
  transitionStore(el).oldStyle = el.style;
}
function getOldStyle(el) {
  return transitionStore(el).oldStyle;
}
var mathMax$6 = Math.max;
var mathMin$6 = Math.min;
var _customShapeMap = {};
function extendShape(opts) {
  return Path$1.extend(opts);
}
var extendPathFromString = extendFromString;
function extendPath(pathData, opts) {
  return extendPathFromString(pathData, opts);
}
function registerShape(name, ShapeClass) {
  _customShapeMap[name] = ShapeClass;
}
function getShapeClass(name) {
  if (_customShapeMap.hasOwnProperty(name)) {
    return _customShapeMap[name];
  }
}
function makePath(pathData, opts, rect, layout2) {
  var path = createFromString(pathData, opts);
  if (rect) {
    if (layout2 === "center") {
      rect = centerGraphic(rect, path.getBoundingRect());
    }
    resizePath(path, rect);
  }
  return path;
}
function makeImage(imageUrl, rect, layout2) {
  var zrImg = new ZRImage$1({
    style: {
      image: imageUrl,
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    onload: function(img) {
      if (layout2 === "center") {
        var boundingRect = {
          width: img.width,
          height: img.height
        };
        zrImg.setStyle(centerGraphic(rect, boundingRect));
      }
    }
  });
  return zrImg;
}
function centerGraphic(rect, boundingRect) {
  var aspect = boundingRect.width / boundingRect.height;
  var width = rect.height * aspect;
  var height;
  if (width <= rect.width) {
    height = rect.height;
  } else {
    width = rect.width;
    height = width / aspect;
  }
  var cx = rect.x + rect.width / 2;
  var cy = rect.y + rect.height / 2;
  return {
    x: cx - width / 2,
    y: cy - height / 2,
    width,
    height
  };
}
var mergePath = mergePath$1;
function resizePath(path, rect) {
  if (!path.applyTransform) {
    return;
  }
  var pathRect = path.getBoundingRect();
  var m2 = pathRect.calculateTransform(rect);
  path.applyTransform(m2);
}
function subPixelOptimizeLine(param) {
  subPixelOptimizeLine$1(param.shape, param.shape, param.style);
  return param;
}
function subPixelOptimizeRect(param) {
  subPixelOptimizeRect$1(param.shape, param.shape, param.style);
  return param;
}
var subPixelOptimize = subPixelOptimize$1;
function getTransform$1(target, ancestor) {
  var mat = identity([]);
  while (target && target !== ancestor) {
    mul(mat, target.getLocalTransform(), mat);
    target = target.parent;
  }
  return mat;
}
function applyTransform(target, transform2, invert$1) {
  if (transform2 && !isArrayLike(transform2)) {
    transform2 = Transformable$1.getLocalTransform(transform2);
  }
  if (invert$1) {
    transform2 = invert([], transform2);
  }
  return applyTransform$1([], target, transform2);
}
function transformDirection(direction, transform2, invert2) {
  var hBase = transform2[4] === 0 || transform2[5] === 0 || transform2[0] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[0]);
  var vBase = transform2[4] === 0 || transform2[5] === 0 || transform2[2] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[2]);
  var vertex = [direction === "left" ? -hBase : direction === "right" ? hBase : 0, direction === "top" ? -vBase : direction === "bottom" ? vBase : 0];
  vertex = applyTransform(vertex, transform2, invert2);
  return Math.abs(vertex[0]) > Math.abs(vertex[1]) ? vertex[0] > 0 ? "right" : "left" : vertex[1] > 0 ? "bottom" : "top";
}
function isNotGroup(el) {
  return !el.isGroup;
}
function isPath$1(el) {
  return el.shape != null;
}
function groupTransition(g1, g2, animatableModel) {
  if (!g1 || !g2) {
    return;
  }
  function getElMap(g3) {
    var elMap = {};
    g3.traverse(function(el) {
      if (isNotGroup(el) && el.anid) {
        elMap[el.anid] = el;
      }
    });
    return elMap;
  }
  function getAnimatableProps(el) {
    var obj = {
      x: el.x,
      y: el.y,
      rotation: el.rotation
    };
    if (isPath$1(el)) {
      obj.shape = extend({}, el.shape);
    }
    return obj;
  }
  var elMap1 = getElMap(g1);
  g2.traverse(function(el) {
    if (isNotGroup(el) && el.anid) {
      var oldEl = elMap1[el.anid];
      if (oldEl) {
        var newProp = getAnimatableProps(el);
        el.attr(getAnimatableProps(oldEl));
        updateProps$1(el, newProp, animatableModel, getECData(el).dataIndex);
      }
    }
  });
}
function clipPointsByRect(points2, rect) {
  return map$1(points2, function(point) {
    var x2 = point[0];
    x2 = mathMax$6(x2, rect.x);
    x2 = mathMin$6(x2, rect.x + rect.width);
    var y2 = point[1];
    y2 = mathMax$6(y2, rect.y);
    y2 = mathMin$6(y2, rect.y + rect.height);
    return [x2, y2];
  });
}
function clipRectByRect(targetRect, rect) {
  var x2 = mathMax$6(targetRect.x, rect.x);
  var x22 = mathMin$6(targetRect.x + targetRect.width, rect.x + rect.width);
  var y2 = mathMax$6(targetRect.y, rect.y);
  var y22 = mathMin$6(targetRect.y + targetRect.height, rect.y + rect.height);
  if (x22 >= x2 && y22 >= y2) {
    return {
      x: x2,
      y: y2,
      width: x22 - x2,
      height: y22 - y2
    };
  }
}
function createIcon(iconStr, opt, rect) {
  var innerOpts = extend({
    rectHover: true
  }, opt);
  var style = innerOpts.style = {
    strokeNoScale: true
  };
  rect = rect || {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  };
  if (iconStr) {
    return iconStr.indexOf("image://") === 0 ? (style.image = iconStr.slice(8), defaults(style, rect), new ZRImage$1(innerOpts)) : makePath(iconStr.replace("path://", ""), innerOpts, rect, "center");
  }
}
function linePolygonIntersect(a1x, a1y, a2x, a2y, points2) {
  for (var i = 0, p2 = points2[points2.length - 1]; i < points2.length; i++) {
    var p3 = points2[i];
    if (lineLineIntersect$1(a1x, a1y, a2x, a2y, p3[0], p3[1], p2[0], p2[1])) {
      return true;
    }
    p2 = p3;
  }
}
function lineLineIntersect$1(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d$1(nx, ny, mx, my);
  if (nearZero(nmCrossProduct)) {
    return false;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var q2 = crossProduct2d$1(b1a1x, b1a1y, mx, my) / nmCrossProduct;
  if (q2 < 0 || q2 > 1) {
    return false;
  }
  var p2 = crossProduct2d$1(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return false;
  }
  return true;
}
function crossProduct2d$1(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function nearZero(val) {
  return val <= 1e-6 && val >= -1e-6;
}
function setTooltipConfig(opt) {
  var itemTooltipOption = opt.itemTooltipOption;
  var componentModel = opt.componentModel;
  var itemName = opt.itemName;
  var itemTooltipOptionObj = isString(itemTooltipOption) ? {
    formatter: itemTooltipOption
  } : itemTooltipOption;
  var mainType = componentModel.mainType;
  var componentIndex = componentModel.componentIndex;
  var formatterParams = {
    componentType: mainType,
    name: itemName,
    $vars: ["name"]
  };
  formatterParams[mainType + "Index"] = componentIndex;
  var formatterParamsExtra = opt.formatterParamsExtra;
  if (formatterParamsExtra) {
    each$f(keys(formatterParamsExtra), function(key) {
      if (!hasOwn(formatterParams, key)) {
        formatterParams[key] = formatterParamsExtra[key];
        formatterParams.$vars.push(key);
      }
    });
  }
  var ecData = getECData(opt.el);
  ecData.componentMainType = mainType;
  ecData.componentIndex = componentIndex;
  ecData.tooltipConfig = {
    name: itemName,
    option: defaults({
      content: itemName,
      formatterParams
    }, itemTooltipOptionObj)
  };
}
function traverseElement(el, cb) {
  var stopped;
  if (el.isGroup) {
    stopped = cb(el);
  }
  if (!stopped) {
    el.traverse(cb);
  }
}
function traverseElements(els, cb) {
  if (els) {
    if (isArray$1(els)) {
      for (var i = 0; i < els.length; i++) {
        traverseElement(els[i], cb);
      }
    } else {
      traverseElement(els, cb);
    }
  }
}
registerShape("circle", Circle$1);
registerShape("ellipse", Ellipse$1);
registerShape("sector", Sector$1);
registerShape("ring", Ring$1);
registerShape("polygon", Polygon$1);
registerShape("polyline", Polyline$3);
registerShape("rect", Rect$3);
registerShape("line", Line$3);
registerShape("bezierCurve", BezierCurve$1);
registerShape("arc", Arc$1);
var graphic = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  updateProps: updateProps$1,
  initProps,
  removeElement,
  removeElementWithFadeOut,
  isElementRemoved,
  extendShape,
  extendPath,
  registerShape,
  getShapeClass,
  makePath,
  makeImage,
  mergePath,
  resizePath,
  subPixelOptimizeLine,
  subPixelOptimizeRect,
  subPixelOptimize,
  getTransform: getTransform$1,
  applyTransform,
  transformDirection,
  groupTransition,
  clipPointsByRect,
  clipRectByRect,
  createIcon,
  linePolygonIntersect,
  lineLineIntersect: lineLineIntersect$1,
  setTooltipConfig,
  traverseElements,
  Group: Group$4,
  Image: ZRImage$1,
  Text: ZRText$1,
  Circle: Circle$1,
  Ellipse: Ellipse$1,
  Sector: Sector$1,
  Ring: Ring$1,
  Polygon: Polygon$1,
  Polyline: Polyline$3,
  Rect: Rect$3,
  Line: Line$3,
  BezierCurve: BezierCurve$1,
  Arc: Arc$1,
  IncrementalDisplayable: IncrementalDisplayable$1,
  CompoundPath: CompoundPath$1,
  LinearGradient: LinearGradient$1,
  RadialGradient: RadialGradient$1,
  BoundingRect: BoundingRect$1,
  OrientedBoundingRect: OrientedBoundingRect$1,
  Point: Point$1,
  Path: Path$1
}, Symbol.toStringTag, { value: "Module" }));
var EMPTY_OBJ = {};
function setLabelText(label, labelTexts) {
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var text = labelTexts[stateName];
    var state = label.ensureState(stateName);
    state.style = state.style || {};
    state.style.text = text;
  }
  var oldStates = label.currentStates.slice();
  label.clearStates(true);
  label.setStyle({
    text: labelTexts.normal
  });
  label.useStates(oldStates, true);
}
function getLabelText(opt, stateModels, interpolatedValue) {
  var labelFetcher = opt.labelFetcher;
  var labelDataIndex = opt.labelDataIndex;
  var labelDimIndex = opt.labelDimIndex;
  var normalModel = stateModels.normal;
  var baseText;
  if (labelFetcher) {
    baseText = labelFetcher.getFormattedLabel(labelDataIndex, "normal", null, labelDimIndex, normalModel && normalModel.get("formatter"), interpolatedValue != null ? {
      interpolatedValue
    } : null);
  }
  if (baseText == null) {
    baseText = isFunction(opt.defaultText) ? opt.defaultText(labelDataIndex, opt, interpolatedValue) : opt.defaultText;
  }
  var statesText = {
    normal: baseText
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var stateModel = stateModels[stateName];
    statesText[stateName] = retrieve2(labelFetcher ? labelFetcher.getFormattedLabel(labelDataIndex, stateName, null, labelDimIndex, stateModel && stateModel.get("formatter")) : null, baseText);
  }
  return statesText;
}
function setLabelStyle(targetEl, labelStatesModels, opt, stateSpecified) {
  opt = opt || EMPTY_OBJ;
  var isSetOnText = targetEl instanceof ZRText$1;
  var needsCreateText = false;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateModel = labelStatesModels[DISPLAY_STATES[i]];
    if (stateModel && stateModel.getShallow("show")) {
      needsCreateText = true;
      break;
    }
  }
  var textContent = isSetOnText ? targetEl : targetEl.getTextContent();
  if (needsCreateText) {
    if (!isSetOnText) {
      if (!textContent) {
        textContent = new ZRText$1();
        targetEl.setTextContent(textContent);
      }
      if (targetEl.stateProxy) {
        textContent.stateProxy = targetEl.stateProxy;
      }
    }
    var labelStatesTexts = getLabelText(opt, labelStatesModels);
    var normalModel = labelStatesModels.normal;
    var showNormal = !!normalModel.getShallow("show");
    var normalStyle = createTextStyle(normalModel, stateSpecified && stateSpecified.normal, opt, false, !isSetOnText);
    normalStyle.text = labelStatesTexts.normal;
    if (!isSetOnText) {
      targetEl.setTextConfig(createTextConfig(normalModel, opt, false));
    }
    for (var i = 0; i < SPECIAL_STATES.length; i++) {
      var stateName = SPECIAL_STATES[i];
      var stateModel = labelStatesModels[stateName];
      if (stateModel) {
        var stateObj = textContent.ensureState(stateName);
        var stateShow = !!retrieve2(stateModel.getShallow("show"), showNormal);
        if (stateShow !== showNormal) {
          stateObj.ignore = !stateShow;
        }
        stateObj.style = createTextStyle(stateModel, stateSpecified && stateSpecified[stateName], opt, true, !isSetOnText);
        stateObj.style.text = labelStatesTexts[stateName];
        if (!isSetOnText) {
          var targetElEmphasisState = targetEl.ensureState(stateName);
          targetElEmphasisState.textConfig = createTextConfig(stateModel, opt, true);
        }
      }
    }
    textContent.silent = !!normalModel.getShallow("silent");
    if (textContent.style.x != null) {
      normalStyle.x = textContent.style.x;
    }
    if (textContent.style.y != null) {
      normalStyle.y = textContent.style.y;
    }
    textContent.ignore = !showNormal;
    textContent.useStyle(normalStyle);
    textContent.dirty();
    if (opt.enableTextSetter) {
      labelInner(textContent).setLabelText = function(interpolatedValue) {
        var labelStatesTexts2 = getLabelText(opt, labelStatesModels, interpolatedValue);
        setLabelText(textContent, labelStatesTexts2);
      };
    }
  } else if (textContent) {
    textContent.ignore = true;
  }
  targetEl.dirty();
}
function getLabelStatesModels(itemModel, labelName) {
  labelName = labelName || "label";
  var statesModels = {
    normal: itemModel.getModel(labelName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelName]);
  }
  return statesModels;
}
function createTextStyle(textStyleModel, specifiedTextStyle, opt, isNotNormal, isAttached) {
  var textStyle = {};
  setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached);
  specifiedTextStyle && extend(textStyle, specifiedTextStyle);
  return textStyle;
}
function createTextConfig(textStyleModel, opt, isNotNormal) {
  opt = opt || {};
  var textConfig = {};
  var labelPosition;
  var labelRotate = textStyleModel.getShallow("rotate");
  var labelDistance = retrieve2(textStyleModel.getShallow("distance"), isNotNormal ? null : 5);
  var labelOffset = textStyleModel.getShallow("offset");
  labelPosition = textStyleModel.getShallow("position") || (isNotNormal ? null : "inside");
  labelPosition === "outside" && (labelPosition = opt.defaultOutsidePosition || "top");
  if (labelPosition != null) {
    textConfig.position = labelPosition;
  }
  if (labelOffset != null) {
    textConfig.offset = labelOffset;
  }
  if (labelRotate != null) {
    labelRotate *= Math.PI / 180;
    textConfig.rotation = labelRotate;
  }
  if (labelDistance != null) {
    textConfig.distance = labelDistance;
  }
  textConfig.outsideFill = textStyleModel.get("color") === "inherit" ? opt.inheritColor || null : "auto";
  return textConfig;
}
function setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached) {
  opt = opt || EMPTY_OBJ;
  var ecModel = textStyleModel.ecModel;
  var globalTextStyle = ecModel && ecModel.option.textStyle;
  var richItemNames = getRichItemNames(textStyleModel);
  var richResult;
  if (richItemNames) {
    richResult = {};
    for (var name_1 in richItemNames) {
      if (richItemNames.hasOwnProperty(name_1)) {
        var richTextStyle = textStyleModel.getModel(["rich", name_1]);
        setTokenTextStyle(richResult[name_1] = {}, richTextStyle, globalTextStyle, opt, isNotNormal, isAttached, false, true);
      }
    }
  }
  if (richResult) {
    textStyle.rich = richResult;
  }
  var overflow = textStyleModel.get("overflow");
  if (overflow) {
    textStyle.overflow = overflow;
  }
  var margin = textStyleModel.get("minMargin");
  if (margin != null) {
    textStyle.margin = margin;
  }
  setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, true, false);
}
function getRichItemNames(textStyleModel) {
  var richItemNameMap;
  while (textStyleModel && textStyleModel !== textStyleModel.ecModel) {
    var rich = (textStyleModel.option || EMPTY_OBJ).rich;
    if (rich) {
      richItemNameMap = richItemNameMap || {};
      var richKeys = keys(rich);
      for (var i = 0; i < richKeys.length; i++) {
        var richKey = richKeys[i];
        richItemNameMap[richKey] = 1;
      }
    }
    textStyleModel = textStyleModel.parentModel;
  }
  return richItemNameMap;
}
var TEXT_PROPS_WITH_GLOBAL = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"];
var TEXT_PROPS_SELF = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"];
var TEXT_PROPS_BOX = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
function setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, isBlock, inRich) {
  globalTextStyle = !isNotNormal && globalTextStyle || EMPTY_OBJ;
  var inheritColor = opt && opt.inheritColor;
  var fillColor = textStyleModel.getShallow("color");
  var strokeColor = textStyleModel.getShallow("textBorderColor");
  var opacity = retrieve2(textStyleModel.getShallow("opacity"), globalTextStyle.opacity);
  if (fillColor === "inherit" || fillColor === "auto") {
    if (inheritColor) {
      fillColor = inheritColor;
    } else {
      fillColor = null;
    }
  }
  if (strokeColor === "inherit" || strokeColor === "auto") {
    if (inheritColor) {
      strokeColor = inheritColor;
    } else {
      strokeColor = null;
    }
  }
  if (!isAttached) {
    fillColor = fillColor || globalTextStyle.color;
    strokeColor = strokeColor || globalTextStyle.textBorderColor;
  }
  if (fillColor != null) {
    textStyle.fill = fillColor;
  }
  if (strokeColor != null) {
    textStyle.stroke = strokeColor;
  }
  var textBorderWidth = retrieve2(textStyleModel.getShallow("textBorderWidth"), globalTextStyle.textBorderWidth);
  if (textBorderWidth != null) {
    textStyle.lineWidth = textBorderWidth;
  }
  var textBorderType = retrieve2(textStyleModel.getShallow("textBorderType"), globalTextStyle.textBorderType);
  if (textBorderType != null) {
    textStyle.lineDash = textBorderType;
  }
  var textBorderDashOffset = retrieve2(textStyleModel.getShallow("textBorderDashOffset"), globalTextStyle.textBorderDashOffset);
  if (textBorderDashOffset != null) {
    textStyle.lineDashOffset = textBorderDashOffset;
  }
  if (!isNotNormal && opacity == null && !inRich) {
    opacity = opt && opt.defaultOpacity;
  }
  if (opacity != null) {
    textStyle.opacity = opacity;
  }
  if (!isNotNormal && !isAttached) {
    if (textStyle.fill == null && opt.inheritColor) {
      textStyle.fill = opt.inheritColor;
    }
  }
  for (var i = 0; i < TEXT_PROPS_WITH_GLOBAL.length; i++) {
    var key = TEXT_PROPS_WITH_GLOBAL[i];
    var val = retrieve2(textStyleModel.getShallow(key), globalTextStyle[key]);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  for (var i = 0; i < TEXT_PROPS_SELF.length; i++) {
    var key = TEXT_PROPS_SELF[i];
    var val = textStyleModel.getShallow(key);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  if (textStyle.verticalAlign == null) {
    var baseline = textStyleModel.getShallow("baseline");
    if (baseline != null) {
      textStyle.verticalAlign = baseline;
    }
  }
  if (!isBlock || !opt.disableBox) {
    for (var i = 0; i < TEXT_PROPS_BOX.length; i++) {
      var key = TEXT_PROPS_BOX[i];
      var val = textStyleModel.getShallow(key);
      if (val != null) {
        textStyle[key] = val;
      }
    }
    var borderType = textStyleModel.getShallow("borderType");
    if (borderType != null) {
      textStyle.borderDash = borderType;
    }
    if ((textStyle.backgroundColor === "auto" || textStyle.backgroundColor === "inherit") && inheritColor) {
      textStyle.backgroundColor = inheritColor;
    }
    if ((textStyle.borderColor === "auto" || textStyle.borderColor === "inherit") && inheritColor) {
      textStyle.borderColor = inheritColor;
    }
  }
}
function getFont(opt, ecModel) {
  var gTextStyleModel = ecModel && ecModel.getModel("textStyle");
  return trim$1([
    opt.fontStyle || gTextStyleModel && gTextStyleModel.getShallow("fontStyle") || "",
    opt.fontWeight || gTextStyleModel && gTextStyleModel.getShallow("fontWeight") || "",
    (opt.fontSize || gTextStyleModel && gTextStyleModel.getShallow("fontSize") || 12) + "px",
    opt.fontFamily || gTextStyleModel && gTextStyleModel.getShallow("fontFamily") || "sans-serif"
  ].join(" "));
}
var labelInner = makeInner();
function setLabelValueAnimation(label, labelStatesModels, value, getDefaultText) {
  if (!label) {
    return;
  }
  var obj = labelInner(label);
  obj.prevValue = obj.value;
  obj.value = value;
  var normalLabelModel = labelStatesModels.normal;
  obj.valueAnimation = normalLabelModel.get("valueAnimation");
  if (obj.valueAnimation) {
    obj.precision = normalLabelModel.get("precision");
    obj.defaultInterpolatedText = getDefaultText;
    obj.statesModels = labelStatesModels;
  }
}
function animateLabelValue(textEl, dataIndex, data, animatableModel, labelFetcher) {
  var labelInnerStore = labelInner(textEl);
  if (!labelInnerStore.valueAnimation || labelInnerStore.prevValue === labelInnerStore.value) {
    return;
  }
  var defaultInterpolatedText = labelInnerStore.defaultInterpolatedText;
  var currValue = retrieve2(labelInnerStore.interpolatedValue, labelInnerStore.prevValue);
  var targetValue = labelInnerStore.value;
  function during(percent) {
    var interpolated = interpolateRawValues(data, labelInnerStore.precision, currValue, targetValue, percent);
    labelInnerStore.interpolatedValue = percent === 1 ? null : interpolated;
    var labelText = getLabelText({
      labelDataIndex: dataIndex,
      labelFetcher,
      defaultText: defaultInterpolatedText ? defaultInterpolatedText(interpolated) : interpolated + ""
    }, labelInnerStore.statesModels, interpolated);
    setLabelText(textEl, labelText);
  }
  textEl.percent = 0;
  (labelInnerStore.prevValue == null ? initProps : updateProps$1)(textEl, {
    percent: 1
  }, animatableModel, dataIndex, null, during);
}
var PATH_COLOR = ["textStyle", "color"];
var textStyleParams = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"];
var tmpText = new ZRText$1();
var TextStyleMixin = function() {
  function TextStyleMixin2() {
  }
  TextStyleMixin2.prototype.getTextColor = function(isEmphasis) {
    var ecModel = this.ecModel;
    return this.getShallow("color") || (!isEmphasis && ecModel ? ecModel.get(PATH_COLOR) : null);
  };
  TextStyleMixin2.prototype.getFont = function() {
    return getFont({
      fontStyle: this.getShallow("fontStyle"),
      fontWeight: this.getShallow("fontWeight"),
      fontSize: this.getShallow("fontSize"),
      fontFamily: this.getShallow("fontFamily")
    }, this.ecModel);
  };
  TextStyleMixin2.prototype.getTextRect = function(text) {
    var style = {
      text,
      verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline")
    };
    for (var i = 0; i < textStyleParams.length; i++) {
      style[textStyleParams[i]] = this.getShallow(textStyleParams[i]);
    }
    tmpText.useStyle(style);
    tmpText.update();
    return tmpText.getBoundingRect();
  };
  return TextStyleMixin2;
}();
var TextStyleMixin$1 = TextStyleMixin;
var LINE_STYLE_KEY_MAP = [
  ["lineWidth", "width"],
  ["stroke", "color"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "type"],
  ["lineDashOffset", "dashOffset"],
  ["lineCap", "cap"],
  ["lineJoin", "join"],
  ["miterLimit"]
];
var getLineStyle = makeStyleMapper(LINE_STYLE_KEY_MAP);
var LineStyleMixin = function() {
  function LineStyleMixin2() {
  }
  LineStyleMixin2.prototype.getLineStyle = function(excludes) {
    return getLineStyle(this, excludes);
  };
  return LineStyleMixin2;
}();
var ITEM_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["stroke", "borderColor"],
  ["lineWidth", "borderWidth"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "borderType"],
  ["lineDashOffset", "borderDashOffset"],
  ["lineCap", "borderCap"],
  ["lineJoin", "borderJoin"],
  ["miterLimit", "borderMiterLimit"]
];
var getItemStyle = makeStyleMapper(ITEM_STYLE_KEY_MAP);
var ItemStyleMixin = function() {
  function ItemStyleMixin2() {
  }
  ItemStyleMixin2.prototype.getItemStyle = function(excludes, includes) {
    return getItemStyle(this, excludes, includes);
  };
  return ItemStyleMixin2;
}();
var Model = function() {
  function Model2(option, parentModel, ecModel) {
    this.parentModel = parentModel;
    this.ecModel = ecModel;
    this.option = option;
  }
  Model2.prototype.init = function(option, parentModel, ecModel) {
    var rest = [];
    for (var _i = 3; _i < arguments.length; _i++) {
      rest[_i - 3] = arguments[_i];
    }
  };
  Model2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
  };
  Model2.prototype.get = function(path, ignoreParent) {
    if (path == null) {
      return this.option;
    }
    return this._doGet(this.parsePath(path), !ignoreParent && this.parentModel);
  };
  Model2.prototype.getShallow = function(key, ignoreParent) {
    var option = this.option;
    var val = option == null ? option : option[key];
    if (val == null && !ignoreParent) {
      var parentModel = this.parentModel;
      if (parentModel) {
        val = parentModel.getShallow(key);
      }
    }
    return val;
  };
  Model2.prototype.getModel = function(path, parentModel) {
    var hasPath = path != null;
    var pathFinal = hasPath ? this.parsePath(path) : null;
    var obj = hasPath ? this._doGet(pathFinal) : this.option;
    parentModel = parentModel || this.parentModel && this.parentModel.getModel(this.resolveParentPath(pathFinal));
    return new Model2(obj, parentModel, this.ecModel);
  };
  Model2.prototype.isEmpty = function() {
    return this.option == null;
  };
  Model2.prototype.restoreData = function() {
  };
  Model2.prototype.clone = function() {
    var Ctor = this.constructor;
    return new Ctor(clone$4(this.option));
  };
  Model2.prototype.parsePath = function(path) {
    if (typeof path === "string") {
      return path.split(".");
    }
    return path;
  };
  Model2.prototype.resolveParentPath = function(path) {
    return path;
  };
  Model2.prototype.isAnimationEnabled = function() {
    if (!env$1.node && this.option) {
      if (this.option.animation != null) {
        return !!this.option.animation;
      } else if (this.parentModel) {
        return this.parentModel.isAnimationEnabled();
      }
    }
  };
  Model2.prototype._doGet = function(pathArr, parentModel) {
    var obj = this.option;
    if (!pathArr) {
      return obj;
    }
    for (var i = 0; i < pathArr.length; i++) {
      if (!pathArr[i]) {
        continue;
      }
      obj = obj && typeof obj === "object" ? obj[pathArr[i]] : null;
      if (obj == null) {
        break;
      }
    }
    if (obj == null && parentModel) {
      obj = parentModel._doGet(this.resolveParentPath(pathArr), parentModel.parentModel);
    }
    return obj;
  };
  return Model2;
}();
enableClassExtend(Model);
enableClassCheck(Model);
mixin(Model, LineStyleMixin);
mixin(Model, ItemStyleMixin);
mixin(Model, AreaStyleMixin);
mixin(Model, TextStyleMixin$1);
var Model$1 = Model;
var base = Math.round(Math.random() * 10);
function getUID(type4) {
  return [type4 || "", base++].join("_");
}
function enableSubTypeDefaulter(target) {
  var subTypeDefaulters = {};
  target.registerSubTypeDefaulter = function(componentType, defaulter) {
    var componentTypeInfo = parseClassType(componentType);
    subTypeDefaulters[componentTypeInfo.main] = defaulter;
  };
  target.determineSubType = function(componentType, option) {
    var type4 = option.type;
    if (!type4) {
      var componentTypeMain = parseClassType(componentType).main;
      if (target.hasSubTypes(componentType) && subTypeDefaulters[componentTypeMain]) {
        type4 = subTypeDefaulters[componentTypeMain](option);
      }
    }
    return type4;
  };
}
function enableTopologicalTravel(entity, dependencyGetter) {
  entity.topologicalTravel = function(targetNameList, fullNameList, callback, context) {
    if (!targetNameList.length) {
      return;
    }
    var result = makeDepndencyGraph(fullNameList);
    var graph = result.graph;
    var noEntryList = result.noEntryList;
    var targetNameSet = {};
    each$f(targetNameList, function(name) {
      targetNameSet[name] = true;
    });
    while (noEntryList.length) {
      var currComponentType = noEntryList.pop();
      var currVertex = graph[currComponentType];
      var isInTargetNameSet = !!targetNameSet[currComponentType];
      if (isInTargetNameSet) {
        callback.call(context, currComponentType, currVertex.originalDeps.slice());
        delete targetNameSet[currComponentType];
      }
      each$f(currVertex.successor, isInTargetNameSet ? removeEdgeAndAdd : removeEdge);
    }
    each$f(targetNameSet, function() {
      var errMsg = "";
      throw new Error(errMsg);
    });
    function removeEdge(succComponentType) {
      graph[succComponentType].entryCount--;
      if (graph[succComponentType].entryCount === 0) {
        noEntryList.push(succComponentType);
      }
    }
    function removeEdgeAndAdd(succComponentType) {
      targetNameSet[succComponentType] = true;
      removeEdge(succComponentType);
    }
  };
  function makeDepndencyGraph(fullNameList) {
    var graph = {};
    var noEntryList = [];
    each$f(fullNameList, function(name) {
      var thisItem = createDependencyGraphItem(graph, name);
      var originalDeps = thisItem.originalDeps = dependencyGetter(name);
      var availableDeps = getAvailableDependencies(originalDeps, fullNameList);
      thisItem.entryCount = availableDeps.length;
      if (thisItem.entryCount === 0) {
        noEntryList.push(name);
      }
      each$f(availableDeps, function(dependentName) {
        if (indexOf(thisItem.predecessor, dependentName) < 0) {
          thisItem.predecessor.push(dependentName);
        }
        var thatItem = createDependencyGraphItem(graph, dependentName);
        if (indexOf(thatItem.successor, dependentName) < 0) {
          thatItem.successor.push(name);
        }
      });
    });
    return {
      graph,
      noEntryList
    };
  }
  function createDependencyGraphItem(graph, name) {
    if (!graph[name]) {
      graph[name] = {
        predecessor: [],
        successor: []
      };
    }
    return graph[name];
  }
  function getAvailableDependencies(originalDeps, fullNameList) {
    var availableDeps = [];
    each$f(originalDeps, function(dep) {
      indexOf(fullNameList, dep) >= 0 && availableDeps.push(dep);
    });
    return availableDeps;
  }
}
function inheritDefaultOption(superOption, subOption) {
  return merge(merge({}, superOption, true), subOption, true);
}
var langEN = {
  time: {
    month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
    dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
  },
  legend: {
    selector: {
      all: "All",
      inverse: "Inv"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "Box Select",
        polygon: "Lasso Select",
        lineX: "Horizontally Select",
        lineY: "Vertically Select",
        keep: "Keep Selections",
        clear: "Clear Selections"
      }
    },
    dataView: {
      title: "Data View",
      lang: ["Data View", "Close", "Refresh"]
    },
    dataZoom: {
      title: {
        zoom: "Zoom",
        back: "Zoom Reset"
      }
    },
    magicType: {
      title: {
        line: "Switch to Line Chart",
        bar: "Switch to Bar Chart",
        stack: "Stack",
        tiled: "Tile"
      }
    },
    restore: {
      title: "Restore"
    },
    saveAsImage: {
      title: "Save as Image",
      lang: ["Right Click to Save Image"]
    }
  },
  series: {
    typeNames: {
      pie: "Pie chart",
      bar: "Bar chart",
      line: "Line chart",
      scatter: "Scatter plot",
      effectScatter: "Ripple scatter plot",
      radar: "Radar chart",
      tree: "Tree",
      treemap: "Treemap",
      boxplot: "Boxplot",
      candlestick: "Candlestick",
      k: "K line chart",
      heatmap: "Heat map",
      map: "Map",
      parallel: "Parallel coordinate map",
      lines: "Line graph",
      graph: "Relationship graph",
      sankey: "Sankey diagram",
      funnel: "Funnel chart",
      gauge: "Gauge",
      pictorialBar: "Pictorial bar",
      themeRiver: "Theme River Map",
      sunburst: "Sunburst"
    }
  },
  aria: {
    general: {
      withTitle: 'This is a chart about "{title}"',
      withoutTitle: "This is a chart"
    },
    series: {
      single: {
        prefix: "",
        withName: " with type {seriesType} named {seriesName}.",
        withoutName: " with type {seriesType}."
      },
      multiple: {
        prefix: ". It consists of {seriesCount} series count.",
        withName: " The {seriesId} series is a {seriesType} representing {seriesName}.",
        withoutName: " The {seriesId} series is a {seriesType}.",
        separator: {
          middle: "",
          end: ""
        }
      }
    },
    data: {
      allData: "The data is as follows: ",
      partialData: "The first {displayCnt} items are: ",
      withName: "the data for {name} is {value}",
      withoutName: "{value}",
      separator: {
        middle: ", ",
        end: ". "
      }
    }
  }
};
var langZH = {
  time: {
    month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"],
    monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"],
    dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"]
  },
  legend: {
    selector: {
      all: "\u5168\u9009",
      inverse: "\u53CD\u9009"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "\u77E9\u5F62\u9009\u62E9",
        polygon: "\u5708\u9009",
        lineX: "\u6A2A\u5411\u9009\u62E9",
        lineY: "\u7EB5\u5411\u9009\u62E9",
        keep: "\u4FDD\u6301\u9009\u62E9",
        clear: "\u6E05\u9664\u9009\u62E9"
      }
    },
    dataView: {
      title: "\u6570\u636E\u89C6\u56FE",
      lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"]
    },
    dataZoom: {
      title: {
        zoom: "\u533A\u57DF\u7F29\u653E",
        back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F"
      }
    },
    magicType: {
      title: {
        line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE",
        bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE",
        stack: "\u5207\u6362\u4E3A\u5806\u53E0",
        tiled: "\u5207\u6362\u4E3A\u5E73\u94FA"
      }
    },
    restore: {
      title: "\u8FD8\u539F"
    },
    saveAsImage: {
      title: "\u4FDD\u5B58\u4E3A\u56FE\u7247",
      lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"]
    }
  },
  series: {
    typeNames: {
      pie: "\u997C\u56FE",
      bar: "\u67F1\u72B6\u56FE",
      line: "\u6298\u7EBF\u56FE",
      scatter: "\u6563\u70B9\u56FE",
      effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE",
      radar: "\u96F7\u8FBE\u56FE",
      tree: "\u6811\u56FE",
      treemap: "\u77E9\u5F62\u6811\u56FE",
      boxplot: "\u7BB1\u578B\u56FE",
      candlestick: "K\u7EBF\u56FE",
      k: "K\u7EBF\u56FE",
      heatmap: "\u70ED\u529B\u56FE",
      map: "\u5730\u56FE",
      parallel: "\u5E73\u884C\u5750\u6807\u56FE",
      lines: "\u7EBF\u56FE",
      graph: "\u5173\u7CFB\u56FE",
      sankey: "\u6851\u57FA\u56FE",
      funnel: "\u6F0F\u6597\u56FE",
      gauge: "\u4EEA\u8868\u76D8\u56FE",
      pictorialBar: "\u8C61\u5F62\u67F1\u56FE",
      themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE",
      sunburst: "\u65ED\u65E5\u56FE"
    }
  },
  aria: {
    general: {
      withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002",
      withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C"
    },
    series: {
      single: {
        prefix: "",
        withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002",
        withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002"
      },
      multiple: {
        prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002",
        withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C",
        withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C",
        separator: {
          middle: "\uFF1B",
          end: "\u3002"
        }
      }
    },
    data: {
      allData: "\u5176\u6570\u636E\u662F\u2014\u2014",
      partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014",
      withName: "{name}\u7684\u6570\u636E\u662F{value}",
      withoutName: "{value}",
      separator: {
        middle: "\uFF0C",
        end: ""
      }
    }
  }
};
var LOCALE_ZH = "ZH";
var LOCALE_EN = "EN";
var DEFAULT_LOCALE = LOCALE_EN;
var localeStorage = {};
var localeModels = {};
var SYSTEM_LANG = !env$1.domSupported ? DEFAULT_LOCALE : function() {
  var langStr = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
  return langStr.indexOf(LOCALE_ZH) > -1 ? LOCALE_ZH : DEFAULT_LOCALE;
}();
function registerLocale(locale2, localeObj) {
  locale2 = locale2.toUpperCase();
  localeModels[locale2] = new Model$1(localeObj);
  localeStorage[locale2] = localeObj;
}
function createLocaleObject(locale2) {
  if (isString(locale2)) {
    var localeObj = localeStorage[locale2.toUpperCase()] || {};
    if (locale2 === LOCALE_ZH || locale2 === LOCALE_EN) {
      return clone$4(localeObj);
    } else {
      return merge(clone$4(localeObj), clone$4(localeStorage[DEFAULT_LOCALE]), false);
    }
  } else {
    return merge(clone$4(locale2), clone$4(localeStorage[DEFAULT_LOCALE]), false);
  }
}
function getLocaleModel(lang) {
  return localeModels[lang];
}
function getDefaultLocaleModel() {
  return localeModels[DEFAULT_LOCALE];
}
registerLocale(LOCALE_EN, langEN);
registerLocale(LOCALE_ZH, langZH);
var ONE_SECOND = 1e3;
var ONE_MINUTE = ONE_SECOND * 60;
var ONE_HOUR = ONE_MINUTE * 60;
var ONE_DAY = ONE_HOUR * 24;
var ONE_YEAR = ONE_DAY * 365;
var defaultLeveledFormatter = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
};
var fullDayFormatter = "{yyyy}-{MM}-{dd}";
var fullLeveledFormatter = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: fullDayFormatter,
  hour: fullDayFormatter + " " + defaultLeveledFormatter.hour,
  minute: fullDayFormatter + " " + defaultLeveledFormatter.minute,
  second: fullDayFormatter + " " + defaultLeveledFormatter.second,
  millisecond: defaultLeveledFormatter.none
};
var primaryTimeUnits = ["year", "month", "day", "hour", "minute", "second", "millisecond"];
var timeUnits = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function pad(str, len2) {
  str += "";
  return "0000".substr(0, len2 - str.length) + str;
}
function getPrimaryTimeUnit(timeUnit) {
  switch (timeUnit) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return timeUnit;
  }
}
function isPrimaryTimeUnit(timeUnit) {
  return timeUnit === getPrimaryTimeUnit(timeUnit);
}
function getDefaultFormatPrecisionOfInterval(timeUnit) {
  switch (timeUnit) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function format$1(time, template, isUTC, lang) {
  var date4 = parseDate(time);
  var y2 = date4[fullYearGetterName(isUTC)]();
  var M = date4[monthGetterName(isUTC)]() + 1;
  var q2 = Math.floor((M - 1) / 4) + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var e2 = date4["get" + (isUTC ? "UTC" : "") + "Day"]();
  var H = date4[hoursGetterName(isUTC)]();
  var h = (H - 1) % 12 + 1;
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var localeModel = lang instanceof Model$1 ? lang : getLocaleModel(lang || SYSTEM_LANG) || getDefaultLocaleModel();
  var timeModel = localeModel.getModel("time");
  var month = timeModel.get("month");
  var monthAbbr = timeModel.get("monthAbbr");
  var dayOfWeek = timeModel.get("dayOfWeek");
  var dayOfWeekAbbr = timeModel.get("dayOfWeekAbbr");
  return (template || "").replace(/{yyyy}/g, y2 + "").replace(/{yy}/g, y2 % 100 + "").replace(/{Q}/g, q2 + "").replace(/{MMMM}/g, month[M - 1]).replace(/{MMM}/g, monthAbbr[M - 1]).replace(/{MM}/g, pad(M, 2)).replace(/{M}/g, M + "").replace(/{dd}/g, pad(d2, 2)).replace(/{d}/g, d2 + "").replace(/{eeee}/g, dayOfWeek[e2]).replace(/{ee}/g, dayOfWeekAbbr[e2]).replace(/{e}/g, e2 + "").replace(/{HH}/g, pad(H, 2)).replace(/{H}/g, H + "").replace(/{hh}/g, pad(h + "", 2)).replace(/{h}/g, h + "").replace(/{mm}/g, pad(m2, 2)).replace(/{m}/g, m2 + "").replace(/{ss}/g, pad(s, 2)).replace(/{s}/g, s + "").replace(/{SSS}/g, pad(S, 3)).replace(/{S}/g, S + "");
}
function leveledFormat(tick, idx, formatter, lang, isUTC) {
  var template = null;
  if (isString(formatter)) {
    template = formatter;
  } else if (isFunction(formatter)) {
    template = formatter(tick.value, idx, {
      level: tick.level
    });
  } else {
    var defaults$1 = extend({}, defaultLeveledFormatter);
    if (tick.level > 0) {
      for (var i = 0; i < primaryTimeUnits.length; ++i) {
        defaults$1[primaryTimeUnits[i]] = "{primary|" + defaults$1[primaryTimeUnits[i]] + "}";
      }
    }
    var mergedFormatter = formatter ? formatter.inherit === false ? formatter : defaults(formatter, defaults$1) : defaults$1;
    var unit = getUnitFromValue(tick.value, isUTC);
    if (mergedFormatter[unit]) {
      template = mergedFormatter[unit];
    } else if (mergedFormatter.inherit) {
      var targetId = timeUnits.indexOf(unit);
      for (var i = targetId - 1; i >= 0; --i) {
        if (mergedFormatter[unit]) {
          template = mergedFormatter[unit];
          break;
        }
      }
      template = template || defaults$1.none;
    }
    if (isArray$1(template)) {
      var levelId = tick.level == null ? 0 : tick.level >= 0 ? tick.level : template.length + tick.level;
      levelId = Math.min(levelId, template.length - 1);
      template = template[levelId];
    }
  }
  return format$1(new Date(tick.value), template, isUTC, lang);
}
function getUnitFromValue(value, isUTC) {
  var date4 = parseDate(value);
  var M = date4[monthGetterName(isUTC)]() + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var h = date4[hoursGetterName(isUTC)]();
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var isSecond = S === 0;
  var isMinute = isSecond && s === 0;
  var isHour = isMinute && m2 === 0;
  var isDay = isHour && h === 0;
  var isMonth = isDay && d2 === 1;
  var isYear = isMonth && M === 1;
  if (isYear) {
    return "year";
  } else if (isMonth) {
    return "month";
  } else if (isDay) {
    return "day";
  } else if (isHour) {
    return "hour";
  } else if (isMinute) {
    return "minute";
  } else if (isSecond) {
    return "second";
  } else {
    return "millisecond";
  }
}
function getUnitValue(value, unit, isUTC) {
  var date4 = isNumber(value) ? parseDate(value) : value;
  unit = unit || getUnitFromValue(value, isUTC);
  switch (unit) {
    case "year":
      return date4[fullYearGetterName(isUTC)]();
    case "half-year":
      return date4[monthGetterName(isUTC)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((date4[monthGetterName(isUTC)]() + 1) / 4);
    case "month":
      return date4[monthGetterName(isUTC)]();
    case "day":
      return date4[dateGetterName(isUTC)]();
    case "half-day":
      return date4[hoursGetterName(isUTC)]() / 24;
    case "hour":
      return date4[hoursGetterName(isUTC)]();
    case "minute":
      return date4[minutesGetterName(isUTC)]();
    case "second":
      return date4[secondsGetterName(isUTC)]();
    case "millisecond":
      return date4[millisecondsGetterName(isUTC)]();
  }
}
function fullYearGetterName(isUTC) {
  return isUTC ? "getUTCFullYear" : "getFullYear";
}
function monthGetterName(isUTC) {
  return isUTC ? "getUTCMonth" : "getMonth";
}
function dateGetterName(isUTC) {
  return isUTC ? "getUTCDate" : "getDate";
}
function hoursGetterName(isUTC) {
  return isUTC ? "getUTCHours" : "getHours";
}
function minutesGetterName(isUTC) {
  return isUTC ? "getUTCMinutes" : "getMinutes";
}
function secondsGetterName(isUTC) {
  return isUTC ? "getUTCSeconds" : "getSeconds";
}
function millisecondsGetterName(isUTC) {
  return isUTC ? "getUTCMilliseconds" : "getMilliseconds";
}
function fullYearSetterName(isUTC) {
  return isUTC ? "setUTCFullYear" : "setFullYear";
}
function monthSetterName(isUTC) {
  return isUTC ? "setUTCMonth" : "setMonth";
}
function dateSetterName(isUTC) {
  return isUTC ? "setUTCDate" : "setDate";
}
function hoursSetterName(isUTC) {
  return isUTC ? "setUTCHours" : "setHours";
}
function minutesSetterName(isUTC) {
  return isUTC ? "setUTCMinutes" : "setMinutes";
}
function secondsSetterName(isUTC) {
  return isUTC ? "setUTCSeconds" : "setSeconds";
}
function millisecondsSetterName(isUTC) {
  return isUTC ? "setUTCMilliseconds" : "setMilliseconds";
}
function addCommas(x2) {
  if (!isNumeric(x2)) {
    return isString(x2) ? x2 : "-";
  }
  var parts = (x2 + "").split(".");
  return parts[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (parts.length > 1 ? "." + parts[1] : "");
}
function toCamelCase(str, upperCaseFirst) {
  str = (str || "").toLowerCase().replace(/-(.)/g, function(match, group1) {
    return group1.toUpperCase();
  });
  if (upperCaseFirst && str) {
    str = str.charAt(0).toUpperCase() + str.slice(1);
  }
  return str;
}
var normalizeCssArray = normalizeCssArray$1;
var replaceReg = /([&<>"'])/g;
var replaceMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
};
function encodeHTML(source) {
  return source == null ? "" : (source + "").replace(replaceReg, function(str, c2) {
    return replaceMap[c2];
  });
}
function makeValueReadable(value, valueType, useUTC) {
  var USER_READABLE_DEFUALT_TIME_PATTERN = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
  function stringToUserReadable(str) {
    return str && trim$1(str) ? str : "-";
  }
  function isNumberUserReadable(num) {
    return !!(num != null && !isNaN(num) && isFinite(num));
  }
  var isTypeTime = valueType === "time";
  var isValueDate = value instanceof Date;
  if (isTypeTime || isValueDate) {
    var date4 = isTypeTime ? parseDate(value) : value;
    if (!isNaN(+date4)) {
      return format$1(date4, USER_READABLE_DEFUALT_TIME_PATTERN, useUTC);
    } else if (isValueDate) {
      return "-";
    }
  }
  if (valueType === "ordinal") {
    return isStringSafe(value) ? stringToUserReadable(value) : isNumber(value) ? isNumberUserReadable(value) ? value + "" : "-" : "-";
  }
  var numericResult = numericToNumber(value);
  return isNumberUserReadable(numericResult) ? addCommas(numericResult) : isStringSafe(value) ? stringToUserReadable(value) : typeof value === "boolean" ? value + "" : "-";
}
var TPL_VAR_ALIAS = ["a", "b", "c", "d", "e", "f", "g"];
var wrapVar = function(varName, seriesIdx) {
  return "{" + varName + (seriesIdx == null ? "" : seriesIdx) + "}";
};
function formatTpl(tpl, paramsList, encode) {
  if (!isArray$1(paramsList)) {
    paramsList = [paramsList];
  }
  var seriesLen = paramsList.length;
  if (!seriesLen) {
    return "";
  }
  var $vars = paramsList[0].$vars || [];
  for (var i = 0; i < $vars.length; i++) {
    var alias = TPL_VAR_ALIAS[i];
    tpl = tpl.replace(wrapVar(alias), wrapVar(alias, 0));
  }
  for (var seriesIdx = 0; seriesIdx < seriesLen; seriesIdx++) {
    for (var k2 = 0; k2 < $vars.length; k2++) {
      var val = paramsList[seriesIdx][$vars[k2]];
      tpl = tpl.replace(wrapVar(TPL_VAR_ALIAS[k2], seriesIdx), encode ? encodeHTML(val) : val);
    }
  }
  return tpl;
}
function formatTplSimple(tpl, param, encode) {
  each$f(param, function(value, key) {
    tpl = tpl.replace("{" + key + "}", encode ? encodeHTML(value) : value);
  });
  return tpl;
}
function getTooltipMarker(inOpt, extraCssText) {
  var opt = isString(inOpt) ? {
    color: inOpt,
    extraCssText
  } : inOpt || {};
  var color = opt.color;
  var type4 = opt.type;
  extraCssText = opt.extraCssText;
  var renderMode = opt.renderMode || "html";
  if (!color) {
    return "";
  }
  if (renderMode === "html") {
    return type4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>';
  } else {
    var markerId = opt.markerId || "markerX";
    return {
      renderMode,
      content: "{" + markerId + "|}  ",
      style: type4 === "subItem" ? {
        width: 4,
        height: 4,
        borderRadius: 2,
        backgroundColor: color
      } : {
        width: 10,
        height: 10,
        borderRadius: 5,
        backgroundColor: color
      }
    };
  }
}
function convertToColorString(color, defaultColor) {
  defaultColor = defaultColor || "transparent";
  return isString(color) ? color : isObject$4(color) ? color.colorStops && (color.colorStops[0] || {}).color || defaultColor : defaultColor;
}
function windowOpen(link, target) {
  if (target === "_blank" || target === "blank") {
    var blank = window.open();
    blank.opener = null;
    blank.location.href = link;
  } else {
    window.open(link, target);
  }
}
var each$e = each$f;
var LOCATION_PARAMS = ["left", "right", "top", "bottom", "width", "height"];
var HV_NAMES = [["width", "left", "right"], ["height", "top", "bottom"]];
function boxLayout(orient, group, gap, maxWidth, maxHeight) {
  var x2 = 0;
  var y2 = 0;
  if (maxWidth == null) {
    maxWidth = Infinity;
  }
  if (maxHeight == null) {
    maxHeight = Infinity;
  }
  var currentLineMaxSize = 0;
  group.eachChild(function(child, idx) {
    var rect = child.getBoundingRect();
    var nextChild = group.childAt(idx + 1);
    var nextChildRect = nextChild && nextChild.getBoundingRect();
    var nextX;
    var nextY;
    if (orient === "horizontal") {
      var moveX = rect.width + (nextChildRect ? -nextChildRect.x + rect.x : 0);
      nextX = x2 + moveX;
      if (nextX > maxWidth || child.newline) {
        x2 = 0;
        nextX = moveX;
        y2 += currentLineMaxSize + gap;
        currentLineMaxSize = rect.height;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.height);
      }
    } else {
      var moveY = rect.height + (nextChildRect ? -nextChildRect.y + rect.y : 0);
      nextY = y2 + moveY;
      if (nextY > maxHeight || child.newline) {
        x2 += currentLineMaxSize + gap;
        y2 = 0;
        nextY = moveY;
        currentLineMaxSize = rect.width;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.width);
      }
    }
    if (child.newline) {
      return;
    }
    child.x = x2;
    child.y = y2;
    child.markRedraw();
    orient === "horizontal" ? x2 = nextX + gap : y2 = nextY + gap;
  });
}
var box = boxLayout;
curry$1(boxLayout, "vertical");
curry$1(boxLayout, "horizontal");
function getAvailableSize(positionInfo, containerRect, margin) {
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var x2 = parsePercent(positionInfo.left, containerWidth);
  var y2 = parsePercent(positionInfo.top, containerHeight);
  var x22 = parsePercent(positionInfo.right, containerWidth);
  var y22 = parsePercent(positionInfo.bottom, containerHeight);
  (isNaN(x2) || isNaN(parseFloat(positionInfo.left))) && (x2 = 0);
  (isNaN(x22) || isNaN(parseFloat(positionInfo.right))) && (x22 = containerWidth);
  (isNaN(y2) || isNaN(parseFloat(positionInfo.top))) && (y2 = 0);
  (isNaN(y22) || isNaN(parseFloat(positionInfo.bottom))) && (y22 = containerHeight);
  margin = normalizeCssArray(margin || 0);
  return {
    width: Math.max(x22 - x2 - margin[1] - margin[3], 0),
    height: Math.max(y22 - y2 - margin[0] - margin[2], 0)
  };
}
function getLayoutRect(positionInfo, containerRect, margin) {
  margin = normalizeCssArray(margin || 0);
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var left = parsePercent(positionInfo.left, containerWidth);
  var top = parsePercent(positionInfo.top, containerHeight);
  var right = parsePercent(positionInfo.right, containerWidth);
  var bottom = parsePercent(positionInfo.bottom, containerHeight);
  var width = parsePercent(positionInfo.width, containerWidth);
  var height = parsePercent(positionInfo.height, containerHeight);
  var verticalMargin = margin[2] + margin[0];
  var horizontalMargin = margin[1] + margin[3];
  var aspect = positionInfo.aspect;
  if (isNaN(width)) {
    width = containerWidth - right - horizontalMargin - left;
  }
  if (isNaN(height)) {
    height = containerHeight - bottom - verticalMargin - top;
  }
  if (aspect != null) {
    if (isNaN(width) && isNaN(height)) {
      if (aspect > containerWidth / containerHeight) {
        width = containerWidth * 0.8;
      } else {
        height = containerHeight * 0.8;
      }
    }
    if (isNaN(width)) {
      width = aspect * height;
    }
    if (isNaN(height)) {
      height = width / aspect;
    }
  }
  if (isNaN(left)) {
    left = containerWidth - right - width - horizontalMargin;
  }
  if (isNaN(top)) {
    top = containerHeight - bottom - height - verticalMargin;
  }
  switch (positionInfo.left || positionInfo.right) {
    case "center":
      left = containerWidth / 2 - width / 2 - margin[3];
      break;
    case "right":
      left = containerWidth - width - horizontalMargin;
      break;
  }
  switch (positionInfo.top || positionInfo.bottom) {
    case "middle":
    case "center":
      top = containerHeight / 2 - height / 2 - margin[0];
      break;
    case "bottom":
      top = containerHeight - height - verticalMargin;
      break;
  }
  left = left || 0;
  top = top || 0;
  if (isNaN(width)) {
    width = containerWidth - horizontalMargin - left - (right || 0);
  }
  if (isNaN(height)) {
    height = containerHeight - verticalMargin - top - (bottom || 0);
  }
  var rect = new BoundingRect$1(left + margin[3], top + margin[0], width, height);
  rect.margin = margin;
  return rect;
}
function positionElement(el, positionInfo, containerRect, margin, opt, out2) {
  var h = !opt || !opt.hv || opt.hv[0];
  var v4 = !opt || !opt.hv || opt.hv[1];
  var boundingMode = opt && opt.boundingMode || "all";
  out2 = out2 || el;
  out2.x = el.x;
  out2.y = el.y;
  if (!h && !v4) {
    return false;
  }
  var rect;
  if (boundingMode === "raw") {
    rect = el.type === "group" ? new BoundingRect$1(0, 0, +positionInfo.width || 0, +positionInfo.height || 0) : el.getBoundingRect();
  } else {
    rect = el.getBoundingRect();
    if (el.needLocalTransform()) {
      var transform2 = el.getLocalTransform();
      rect = rect.clone();
      rect.applyTransform(transform2);
    }
  }
  var layoutRect = getLayoutRect(defaults({
    width: rect.width,
    height: rect.height
  }, positionInfo), containerRect, margin);
  var dx = h ? layoutRect.x - rect.x : 0;
  var dy = v4 ? layoutRect.y - rect.y : 0;
  if (boundingMode === "raw") {
    out2.x = dx;
    out2.y = dy;
  } else {
    out2.x += dx;
    out2.y += dy;
  }
  if (out2 === el) {
    el.markRedraw();
  }
  return true;
}
function sizeCalculable(option, hvIdx) {
  return option[HV_NAMES[hvIdx][0]] != null || option[HV_NAMES[hvIdx][1]] != null && option[HV_NAMES[hvIdx][2]] != null;
}
function fetchLayoutMode(ins) {
  var layoutMode = ins.layoutMode || ins.constructor.layoutMode;
  return isObject$4(layoutMode) ? layoutMode : layoutMode ? {
    type: layoutMode
  } : null;
}
function mergeLayoutParam(targetOption, newOption, opt) {
  var ignoreSize = opt && opt.ignoreSize;
  !isArray$1(ignoreSize) && (ignoreSize = [ignoreSize, ignoreSize]);
  var hResult = merge2(HV_NAMES[0], 0);
  var vResult = merge2(HV_NAMES[1], 1);
  copy2(HV_NAMES[0], targetOption, hResult);
  copy2(HV_NAMES[1], targetOption, vResult);
  function merge2(names2, hvIdx) {
    var newParams = {};
    var newValueCount = 0;
    var merged = {};
    var mergedValueCount = 0;
    var enoughParamNumber = 2;
    each$e(names2, function(name) {
      merged[name] = targetOption[name];
    });
    each$e(names2, function(name) {
      hasProp(newOption, name) && (newParams[name] = merged[name] = newOption[name]);
      hasValue(newParams, name) && newValueCount++;
      hasValue(merged, name) && mergedValueCount++;
    });
    if (ignoreSize[hvIdx]) {
      if (hasValue(newOption, names2[1])) {
        merged[names2[2]] = null;
      } else if (hasValue(newOption, names2[2])) {
        merged[names2[1]] = null;
      }
      return merged;
    }
    if (mergedValueCount === enoughParamNumber || !newValueCount) {
      return merged;
    } else if (newValueCount >= enoughParamNumber) {
      return newParams;
    } else {
      for (var i = 0; i < names2.length; i++) {
        var name_1 = names2[i];
        if (!hasProp(newParams, name_1) && hasProp(targetOption, name_1)) {
          newParams[name_1] = targetOption[name_1];
          break;
        }
      }
      return newParams;
    }
  }
  function hasProp(obj, name) {
    return obj.hasOwnProperty(name);
  }
  function hasValue(obj, name) {
    return obj[name] != null && obj[name] !== "auto";
  }
  function copy2(names2, target, source) {
    each$e(names2, function(name) {
      target[name] = source[name];
    });
  }
}
function getLayoutParams(source) {
  return copyLayoutParams({}, source);
}
function copyLayoutParams(target, source) {
  source && target && each$e(LOCATION_PARAMS, function(name) {
    source.hasOwnProperty(name) && (target[name] = source[name]);
  });
  return target;
}
var inner$l = makeInner();
var ComponentModel = function(_super) {
  __extends(ComponentModel2, _super);
  function ComponentModel2(option, parentModel, ecModel) {
    var _this = _super.call(this, option, parentModel, ecModel) || this;
    _this.uid = getUID("ec_cpt_model");
    return _this;
  }
  ComponentModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  ComponentModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeModel = ecModel.getTheme();
    merge(option, themeModel.get(this.mainType));
    merge(option, this.getDefaultOption());
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  ComponentModel2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, option, layoutMode);
    }
  };
  ComponentModel2.prototype.optionUpdated = function(newCptOption, isInit) {
  };
  ComponentModel2.prototype.getDefaultOption = function() {
    var ctor = this.constructor;
    if (!isExtendedClass(ctor)) {
      return ctor.defaultOption;
    }
    var fields = inner$l(this);
    if (!fields.defaultOption) {
      var optList = [];
      var clz = ctor;
      while (clz) {
        var opt = clz.prototype.defaultOption;
        opt && optList.push(opt);
        clz = clz.superClass;
      }
      var defaultOption2 = {};
      for (var i = optList.length - 1; i >= 0; i--) {
        defaultOption2 = merge(defaultOption2, optList[i], true);
      }
      fields.defaultOption = defaultOption2;
    }
    return fields.defaultOption;
  };
  ComponentModel2.prototype.getReferringComponents = function(mainType, opt) {
    var indexKey = mainType + "Index";
    var idKey = mainType + "Id";
    return queryReferringComponents(this.ecModel, mainType, {
      index: this.get(indexKey, true),
      id: this.get(idKey, true)
    }, opt);
  };
  ComponentModel2.prototype.getBoxLayoutParams = function() {
    var boxLayoutModel = this;
    return {
      left: boxLayoutModel.get("left"),
      top: boxLayoutModel.get("top"),
      right: boxLayoutModel.get("right"),
      bottom: boxLayoutModel.get("bottom"),
      width: boxLayoutModel.get("width"),
      height: boxLayoutModel.get("height")
    };
  };
  ComponentModel2.prototype.getZLevelKey = function() {
    return "";
  };
  ComponentModel2.prototype.setZLevel = function(zlevel) {
    this.option.zlevel = zlevel;
  };
  ComponentModel2.protoInitialize = function() {
    var proto2 = ComponentModel2.prototype;
    proto2.type = "component";
    proto2.id = "";
    proto2.name = "";
    proto2.mainType = "";
    proto2.subType = "";
    proto2.componentIndex = 0;
  }();
  return ComponentModel2;
}(Model$1);
mountExtend(ComponentModel, Model$1);
enableClassManagement(ComponentModel);
enableSubTypeDefaulter(ComponentModel);
enableTopologicalTravel(ComponentModel, getDependencies);
function getDependencies(componentType) {
  var deps = [];
  each$f(ComponentModel.getClassesByMainType(componentType), function(clz) {
    deps = deps.concat(clz.dependencies || clz.prototype.dependencies || []);
  });
  deps = map$1(deps, function(type4) {
    return parseClassType(type4).main;
  });
  if (componentType !== "dataset" && indexOf(deps, "dataset") <= 0) {
    deps.unshift("dataset");
  }
  return deps;
}
var ComponentModel$1 = ComponentModel;
var platform = "";
if (typeof navigator !== "undefined") {
  platform = navigator.platform || "";
}
var decalColor = "rgba(0, 0, 0, 0.2)";
var globalDefault = {
  darkMode: "auto",
  colorBy: "series",
  color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"],
  gradientColor: ["#f6efa6", "#d88273", "#bf444c"],
  aria: {
    decal: {
      decals: [{
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [2, 5],
        symbolSize: 1,
        rotation: Math.PI / 6
      }, {
        color: decalColor,
        symbol: "circle",
        dashArrayX: [[8, 8], [0, 8, 8, 0]],
        dashArrayY: [6, 0],
        symbolSize: 0.8
      }, {
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [4, 3],
        rotation: -Math.PI / 4
      }, {
        color: decalColor,
        dashArrayX: [[6, 6], [0, 6, 6, 0]],
        dashArrayY: [6, 0]
      }, {
        color: decalColor,
        dashArrayX: [[1, 0], [1, 6]],
        dashArrayY: [1, 0, 6, 0],
        rotation: Math.PI / 4
      }, {
        color: decalColor,
        symbol: "triangle",
        dashArrayX: [[9, 9], [0, 9, 9, 0]],
        dashArrayY: [7, 2],
        symbolSize: 0.75
      }]
    }
  },
  textStyle: {
    fontFamily: platform.match(/^Win/) ? "Microsoft YaHei" : "sans-serif",
    fontSize: 12,
    fontStyle: "normal",
    fontWeight: "normal"
  },
  blendMode: null,
  stateAnimation: {
    duration: 300,
    easing: "cubicOut"
  },
  animation: "auto",
  animationDuration: 1e3,
  animationDurationUpdate: 500,
  animationEasing: "cubicInOut",
  animationEasingUpdate: "cubicInOut",
  animationThreshold: 2e3,
  progressiveThreshold: 3e3,
  progressive: 400,
  hoverLayerThreshold: 3e3,
  useUTC: false
};
var VISUAL_DIMENSIONS = createHashMap(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]);
var SOURCE_FORMAT_ORIGINAL = "original";
var SOURCE_FORMAT_ARRAY_ROWS = "arrayRows";
var SOURCE_FORMAT_OBJECT_ROWS = "objectRows";
var SOURCE_FORMAT_KEYED_COLUMNS = "keyedColumns";
var SOURCE_FORMAT_TYPED_ARRAY = "typedArray";
var SOURCE_FORMAT_UNKNOWN = "unknown";
var SERIES_LAYOUT_BY_COLUMN = "column";
var SERIES_LAYOUT_BY_ROW = "row";
var BE_ORDINAL = {
  Must: 1,
  Might: 2,
  Not: 3
};
var innerGlobalModel = makeInner();
function resetSourceDefaulter(ecModel) {
  innerGlobalModel(ecModel).datasetMap = createHashMap();
}
function makeSeriesEncodeForAxisCoordSys(coordDimensions, seriesModel, source) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel || !coordDimensions) {
    return encode;
  }
  var encodeItemName = [];
  var encodeSeriesName = [];
  var ecModel = seriesModel.ecModel;
  var datasetMap = innerGlobalModel(ecModel).datasetMap;
  var key = datasetModel.uid + "_" + source.seriesLayoutBy;
  var baseCategoryDimIndex;
  var categoryWayValueDimStart;
  coordDimensions = coordDimensions.slice();
  each$f(coordDimensions, function(coordDimInfoLoose, coordDimIdx) {
    var coordDimInfo = isObject$4(coordDimInfoLoose) ? coordDimInfoLoose : coordDimensions[coordDimIdx] = {
      name: coordDimInfoLoose
    };
    if (coordDimInfo.type === "ordinal" && baseCategoryDimIndex == null) {
      baseCategoryDimIndex = coordDimIdx;
      categoryWayValueDimStart = getDataDimCountOnCoordDim(coordDimInfo);
    }
    encode[coordDimInfo.name] = [];
  });
  var datasetRecord = datasetMap.get(key) || datasetMap.set(key, {
    categoryWayDim: categoryWayValueDimStart,
    valueWayDim: 0
  });
  each$f(coordDimensions, function(coordDimInfo, coordDimIdx) {
    var coordDimName = coordDimInfo.name;
    var count2 = getDataDimCountOnCoordDim(coordDimInfo);
    if (baseCategoryDimIndex == null) {
      var start2 = datasetRecord.valueWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.valueWayDim += count2;
    } else if (baseCategoryDimIndex === coordDimIdx) {
      pushDim(encode[coordDimName], 0, count2);
      pushDim(encodeItemName, 0, count2);
    } else {
      var start2 = datasetRecord.categoryWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.categoryWayDim += count2;
    }
  });
  function pushDim(dimIdxArr, idxFrom, idxCount) {
    for (var i = 0; i < idxCount; i++) {
      dimIdxArr.push(idxFrom + i);
    }
  }
  function getDataDimCountOnCoordDim(coordDimInfo) {
    var dimsDef = coordDimInfo.dimsDef;
    return dimsDef ? dimsDef.length : 1;
  }
  encodeItemName.length && (encode.itemName = encodeItemName);
  encodeSeriesName.length && (encode.seriesName = encodeSeriesName);
  return encode;
}
function makeSeriesEncodeForNameBased(seriesModel, source, dimCount) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel) {
    return encode;
  }
  var sourceFormat = source.sourceFormat;
  var dimensionsDefine = source.dimensionsDefine;
  var potentialNameDimIndex;
  if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    each$f(dimensionsDefine, function(dim, idx) {
      if ((isObject$4(dim) ? dim.name : dim) === "name") {
        potentialNameDimIndex = idx;
      }
    });
  }
  var idxResult = function() {
    var idxRes0 = {};
    var idxRes1 = {};
    var guessRecords = [];
    for (var i = 0, len2 = Math.min(5, dimCount); i < len2; i++) {
      var guessResult = doGuessOrdinal(source.data, sourceFormat, source.seriesLayoutBy, dimensionsDefine, source.startIndex, i);
      guessRecords.push(guessResult);
      var isPureNumber = guessResult === BE_ORDINAL.Not;
      if (isPureNumber && idxRes0.v == null && i !== potentialNameDimIndex) {
        idxRes0.v = i;
      }
      if (idxRes0.n == null || idxRes0.n === idxRes0.v || !isPureNumber && guessRecords[idxRes0.n] === BE_ORDINAL.Not) {
        idxRes0.n = i;
      }
      if (fulfilled(idxRes0) && guessRecords[idxRes0.n] !== BE_ORDINAL.Not) {
        return idxRes0;
      }
      if (!isPureNumber) {
        if (guessResult === BE_ORDINAL.Might && idxRes1.v == null && i !== potentialNameDimIndex) {
          idxRes1.v = i;
        }
        if (idxRes1.n == null || idxRes1.n === idxRes1.v) {
          idxRes1.n = i;
        }
      }
    }
    function fulfilled(idxResult2) {
      return idxResult2.v != null && idxResult2.n != null;
    }
    return fulfilled(idxRes0) ? idxRes0 : fulfilled(idxRes1) ? idxRes1 : null;
  }();
  if (idxResult) {
    encode.value = [idxResult.v];
    var nameDimIndex = potentialNameDimIndex != null ? potentialNameDimIndex : idxResult.n;
    encode.itemName = [nameDimIndex];
    encode.seriesName = [nameDimIndex];
  }
  return encode;
}
function querySeriesUpstreamDatasetModel(seriesModel) {
  var thisData = seriesModel.get("data", true);
  if (!thisData) {
    return queryReferringComponents(seriesModel.ecModel, "dataset", {
      index: seriesModel.get("datasetIndex", true),
      id: seriesModel.get("datasetId", true)
    }, SINGLE_REFERRING).models[0];
  }
}
function queryDatasetUpstreamDatasetModels(datasetModel) {
  if (!datasetModel.get("transform", true) && !datasetModel.get("fromTransformResult", true)) {
    return [];
  }
  return queryReferringComponents(datasetModel.ecModel, "dataset", {
    index: datasetModel.get("fromDatasetIndex", true),
    id: datasetModel.get("fromDatasetId", true)
  }, SINGLE_REFERRING).models;
}
function guessOrdinal(source, dimIndex) {
  return doGuessOrdinal(source.data, source.sourceFormat, source.seriesLayoutBy, source.dimensionsDefine, source.startIndex, dimIndex);
}
function doGuessOrdinal(data, sourceFormat, seriesLayoutBy, dimensionsDefine, startIndex, dimIndex) {
  var result;
  var maxLoop = 5;
  if (isTypedArray(data)) {
    return BE_ORDINAL.Not;
  }
  var dimName;
  var dimType;
  if (dimensionsDefine) {
    var dimDefItem = dimensionsDefine[dimIndex];
    if (isObject$4(dimDefItem)) {
      dimName = dimDefItem.name;
      dimType = dimDefItem.type;
    } else if (isString(dimDefItem)) {
      dimName = dimDefItem;
    }
  }
  if (dimType != null) {
    return dimType === "ordinal" ? BE_ORDINAL.Must : BE_ORDINAL.Not;
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
      var sample = dataArrayRows[dimIndex];
      for (var i = 0; i < (sample || []).length && i < maxLoop; i++) {
        if ((result = detectValue(sample[startIndex + i])) != null) {
          return result;
        }
      }
    } else {
      for (var i = 0; i < dataArrayRows.length && i < maxLoop; i++) {
        var row = dataArrayRows[startIndex + i];
        if (row && (result = detectValue(row[dimIndex])) != null) {
          return result;
        }
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var dataObjectRows = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < dataObjectRows.length && i < maxLoop; i++) {
      var item = dataObjectRows[i];
      if (item && (result = detectValue(item[dimName])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    var dataKeyedColumns = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    var sample = dataKeyedColumns[dimName];
    if (!sample || isTypedArray(sample)) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < sample.length && i < maxLoop; i++) {
      if ((result = detectValue(sample[i])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var dataOriginal = data;
    for (var i = 0; i < dataOriginal.length && i < maxLoop; i++) {
      var item = dataOriginal[i];
      var val = getDataItemValue(item);
      if (!isArray$1(val)) {
        return BE_ORDINAL.Not;
      }
      if ((result = detectValue(val[dimIndex])) != null) {
        return result;
      }
    }
  }
  function detectValue(val2) {
    var beStr = isString(val2);
    if (val2 != null && isFinite(val2) && val2 !== "") {
      return beStr ? BE_ORDINAL.Might : BE_ORDINAL.Not;
    } else if (beStr && val2 !== "-") {
      return BE_ORDINAL.Must;
    }
  }
  return BE_ORDINAL.Not;
}
var internalOptionCreatorMap = createHashMap();
function registerInternalOptionCreator(mainType, creator) {
  assert(internalOptionCreatorMap.get(mainType) == null && creator);
  internalOptionCreatorMap.set(mainType, creator);
}
function concatInternalOptions(ecModel, mainType, newCmptOptionList) {
  var internalOptionCreator = internalOptionCreatorMap.get(mainType);
  if (!internalOptionCreator) {
    return newCmptOptionList;
  }
  var internalOptions = internalOptionCreator(ecModel);
  if (!internalOptions) {
    return newCmptOptionList;
  }
  return newCmptOptionList.concat(internalOptions);
}
var innerColor = makeInner();
var innerDecal = makeInner();
var PaletteMixin = function() {
  function PaletteMixin2() {
  }
  PaletteMixin2.prototype.getColorFromPalette = function(name, scope, requestNum) {
    var defaultPalette = normalizeToArray(this.get("color", true));
    var layeredPalette = this.get("colorLayer", true);
    return getFromPalette(this, innerColor, defaultPalette, layeredPalette, name, scope, requestNum);
  };
  PaletteMixin2.prototype.clearColorPalette = function() {
    clearPalette(this, innerColor);
  };
  return PaletteMixin2;
}();
function getDecalFromPalette(ecModel, name, scope, requestNum) {
  var defaultDecals = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  return getFromPalette(ecModel, innerDecal, defaultDecals, null, name, scope, requestNum);
}
function getNearestPalette(palettes, requestColorNum) {
  var paletteNum = palettes.length;
  for (var i = 0; i < paletteNum; i++) {
    if (palettes[i].length > requestColorNum) {
      return palettes[i];
    }
  }
  return palettes[paletteNum - 1];
}
function getFromPalette(that, inner2, defaultPalette, layeredPalette, name, scope, requestNum) {
  scope = scope || that;
  var scopeFields = inner2(scope);
  var paletteIdx = scopeFields.paletteIdx || 0;
  var paletteNameMap = scopeFields.paletteNameMap = scopeFields.paletteNameMap || {};
  if (paletteNameMap.hasOwnProperty(name)) {
    return paletteNameMap[name];
  }
  var palette = requestNum == null || !layeredPalette ? defaultPalette : getNearestPalette(layeredPalette, requestNum);
  palette = palette || defaultPalette;
  if (!palette || !palette.length) {
    return;
  }
  var pickedPaletteItem = palette[paletteIdx];
  if (name) {
    paletteNameMap[name] = pickedPaletteItem;
  }
  scopeFields.paletteIdx = (paletteIdx + 1) % palette.length;
  return pickedPaletteItem;
}
function clearPalette(that, inner2) {
  inner2(that).paletteIdx = 0;
  inner2(that).paletteNameMap = {};
}
var reCreateSeriesIndices;
var assertSeriesInitialized;
var initBase;
var OPTION_INNER_KEY = "\0_ec_inner";
var OPTION_INNER_VALUE = 1;
var GlobalModel = function(_super) {
  __extends(GlobalModel2, _super);
  function GlobalModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GlobalModel2.prototype.init = function(option, parentModel, ecModel, theme2, locale2, optionManager) {
    theme2 = theme2 || {};
    this.option = null;
    this._theme = new Model$1(theme2);
    this._locale = new Model$1(locale2);
    this._optionManager = optionManager;
  };
  GlobalModel2.prototype.setOption = function(option, opts, optionPreprocessorFuncs2) {
    var innerOpt = normalizeSetOptionInput(opts);
    this._optionManager.setOption(option, optionPreprocessorFuncs2, innerOpt);
    this._resetOption(null, innerOpt);
  };
  GlobalModel2.prototype.resetOption = function(type4, opt) {
    return this._resetOption(type4, normalizeSetOptionInput(opt));
  };
  GlobalModel2.prototype._resetOption = function(type4, opt) {
    var optionChanged = false;
    var optionManager = this._optionManager;
    if (!type4 || type4 === "recreate") {
      var baseOption = optionManager.mountOption(type4 === "recreate");
      if (!this.option || type4 === "recreate") {
        initBase(this, baseOption);
      } else {
        this.restoreData();
        this._mergeOption(baseOption, opt);
      }
      optionChanged = true;
    }
    if (type4 === "timeline" || type4 === "media") {
      this.restoreData();
    }
    if (!type4 || type4 === "recreate" || type4 === "timeline") {
      var timelineOption = optionManager.getTimelineOption(this);
      if (timelineOption) {
        optionChanged = true;
        this._mergeOption(timelineOption, opt);
      }
    }
    if (!type4 || type4 === "recreate" || type4 === "media") {
      var mediaOptions = optionManager.getMediaOption(this);
      if (mediaOptions.length) {
        each$f(mediaOptions, function(mediaOption) {
          optionChanged = true;
          this._mergeOption(mediaOption, opt);
        }, this);
      }
    }
    return optionChanged;
  };
  GlobalModel2.prototype.mergeOption = function(option) {
    this._mergeOption(option, null);
  };
  GlobalModel2.prototype._mergeOption = function(newOption, opt) {
    var option = this.option;
    var componentsMap = this._componentsMap;
    var componentsCount = this._componentsCount;
    var newCmptTypes = [];
    var newCmptTypeMap = createHashMap();
    var replaceMergeMainTypeMap = opt && opt.replaceMergeMainTypeMap;
    resetSourceDefaulter(this);
    each$f(newOption, function(componentOption, mainType) {
      if (componentOption == null) {
        return;
      }
      if (!ComponentModel$1.hasClass(mainType)) {
        option[mainType] = option[mainType] == null ? clone$4(componentOption) : merge(option[mainType], componentOption, true);
      } else if (mainType) {
        newCmptTypes.push(mainType);
        newCmptTypeMap.set(mainType, true);
      }
    });
    if (replaceMergeMainTypeMap) {
      replaceMergeMainTypeMap.each(function(val, mainTypeInReplaceMerge) {
        if (ComponentModel$1.hasClass(mainTypeInReplaceMerge) && !newCmptTypeMap.get(mainTypeInReplaceMerge)) {
          newCmptTypes.push(mainTypeInReplaceMerge);
          newCmptTypeMap.set(mainTypeInReplaceMerge, true);
        }
      });
    }
    ComponentModel$1.topologicalTravel(newCmptTypes, ComponentModel$1.getAllClassMainTypes(), visitComponent, this);
    function visitComponent(mainType) {
      var newCmptOptionList = concatInternalOptions(this, mainType, normalizeToArray(newOption[mainType]));
      var oldCmptList = componentsMap.get(mainType);
      var mergeMode = !oldCmptList ? "replaceAll" : replaceMergeMainTypeMap && replaceMergeMainTypeMap.get(mainType) ? "replaceMerge" : "normalMerge";
      var mappingResult = mappingToExists(oldCmptList, newCmptOptionList, mergeMode);
      setComponentTypeToKeyInfo(mappingResult, mainType, ComponentModel$1);
      option[mainType] = null;
      componentsMap.set(mainType, null);
      componentsCount.set(mainType, 0);
      var optionsByMainType = [];
      var cmptsByMainType = [];
      var cmptsCountByMainType = 0;
      var tooltipExists;
      each$f(mappingResult, function(resultItem, index2) {
        var componentModel = resultItem.existing;
        var newCmptOption = resultItem.newOption;
        if (!newCmptOption) {
          if (componentModel) {
            componentModel.mergeOption({}, this);
            componentModel.optionUpdated({}, false);
          }
        } else {
          var isSeriesType = mainType === "series";
          var ComponentModelClass = ComponentModel$1.getClass(mainType, resultItem.keyInfo.subType, !isSeriesType);
          if (!ComponentModelClass) {
            return;
          }
          if (mainType === "tooltip") {
            if (tooltipExists) {
              return;
            }
            tooltipExists = true;
          }
          if (componentModel && componentModel.constructor === ComponentModelClass) {
            componentModel.name = resultItem.keyInfo.name;
            componentModel.mergeOption(newCmptOption, this);
            componentModel.optionUpdated(newCmptOption, false);
          } else {
            var extraOpt = extend({
              componentIndex: index2
            }, resultItem.keyInfo);
            componentModel = new ComponentModelClass(newCmptOption, this, this, extraOpt);
            extend(componentModel, extraOpt);
            if (resultItem.brandNew) {
              componentModel.__requireNewView = true;
            }
            componentModel.init(newCmptOption, this, this);
            componentModel.optionUpdated(null, true);
          }
        }
        if (componentModel) {
          optionsByMainType.push(componentModel.option);
          cmptsByMainType.push(componentModel);
          cmptsCountByMainType++;
        } else {
          optionsByMainType.push(void 0);
          cmptsByMainType.push(void 0);
        }
      }, this);
      option[mainType] = optionsByMainType;
      componentsMap.set(mainType, cmptsByMainType);
      componentsCount.set(mainType, cmptsCountByMainType);
      if (mainType === "series") {
        reCreateSeriesIndices(this);
      }
    }
    if (!this._seriesIndices) {
      reCreateSeriesIndices(this);
    }
  };
  GlobalModel2.prototype.getOption = function() {
    var option = clone$4(this.option);
    each$f(option, function(optInMainType, mainType) {
      if (ComponentModel$1.hasClass(mainType)) {
        var opts = normalizeToArray(optInMainType);
        var realLen = opts.length;
        var metNonInner = false;
        for (var i = realLen - 1; i >= 0; i--) {
          if (opts[i] && !isComponentIdInternal(opts[i])) {
            metNonInner = true;
          } else {
            opts[i] = null;
            !metNonInner && realLen--;
          }
        }
        opts.length = realLen;
        option[mainType] = opts;
      }
    });
    delete option[OPTION_INNER_KEY];
    return option;
  };
  GlobalModel2.prototype.getTheme = function() {
    return this._theme;
  };
  GlobalModel2.prototype.getLocaleModel = function() {
    return this._locale;
  };
  GlobalModel2.prototype.setUpdatePayload = function(payload) {
    this._payload = payload;
  };
  GlobalModel2.prototype.getUpdatePayload = function() {
    return this._payload;
  };
  GlobalModel2.prototype.getComponent = function(mainType, idx) {
    var list = this._componentsMap.get(mainType);
    if (list) {
      var cmpt = list[idx || 0];
      if (cmpt) {
        return cmpt;
      } else if (idx == null) {
        for (var i = 0; i < list.length; i++) {
          if (list[i]) {
            return list[i];
          }
        }
      }
    }
  };
  GlobalModel2.prototype.queryComponents = function(condition) {
    var mainType = condition.mainType;
    if (!mainType) {
      return [];
    }
    var index2 = condition.index;
    var id2 = condition.id;
    var name = condition.name;
    var cmpts = this._componentsMap.get(mainType);
    if (!cmpts || !cmpts.length) {
      return [];
    }
    var result;
    if (index2 != null) {
      result = [];
      each$f(normalizeToArray(index2), function(idx) {
        cmpts[idx] && result.push(cmpts[idx]);
      });
    } else if (id2 != null) {
      result = queryByIdOrName("id", id2, cmpts);
    } else if (name != null) {
      result = queryByIdOrName("name", name, cmpts);
    } else {
      result = filter(cmpts, function(cmpt) {
        return !!cmpt;
      });
    }
    return filterBySubType(result, condition);
  };
  GlobalModel2.prototype.findComponents = function(condition) {
    var query = condition.query;
    var mainType = condition.mainType;
    var queryCond = getQueryCond(query);
    var result = queryCond ? this.queryComponents(queryCond) : filter(this._componentsMap.get(mainType), function(cmpt) {
      return !!cmpt;
    });
    return doFilter(filterBySubType(result, condition));
    function getQueryCond(q2) {
      var indexAttr = mainType + "Index";
      var idAttr = mainType + "Id";
      var nameAttr = mainType + "Name";
      return q2 && (q2[indexAttr] != null || q2[idAttr] != null || q2[nameAttr] != null) ? {
        mainType,
        index: q2[indexAttr],
        id: q2[idAttr],
        name: q2[nameAttr]
      } : null;
    }
    function doFilter(res) {
      return condition.filter ? filter(res, condition.filter) : res;
    }
  };
  GlobalModel2.prototype.eachComponent = function(mainType, cb, context) {
    var componentsMap = this._componentsMap;
    if (isFunction(mainType)) {
      var ctxForAll_1 = cb;
      var cbForAll_1 = mainType;
      componentsMap.each(function(cmpts2, componentType) {
        for (var i2 = 0; cmpts2 && i2 < cmpts2.length; i2++) {
          var cmpt2 = cmpts2[i2];
          cmpt2 && cbForAll_1.call(ctxForAll_1, componentType, cmpt2, cmpt2.componentIndex);
        }
      });
    } else {
      var cmpts = isString(mainType) ? componentsMap.get(mainType) : isObject$4(mainType) ? this.findComponents(mainType) : null;
      for (var i = 0; cmpts && i < cmpts.length; i++) {
        var cmpt = cmpts[i];
        cmpt && cb.call(context, cmpt, cmpt.componentIndex);
      }
    }
  };
  GlobalModel2.prototype.getSeriesByName = function(name) {
    var nameStr = convertOptionIdName(name, null);
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && nameStr != null && oneSeries.name === nameStr;
    });
  };
  GlobalModel2.prototype.getSeriesByIndex = function(seriesIndex) {
    return this._componentsMap.get("series")[seriesIndex];
  };
  GlobalModel2.prototype.getSeriesByType = function(subType) {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && oneSeries.subType === subType;
    });
  };
  GlobalModel2.prototype.getSeries = function() {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries;
    });
  };
  GlobalModel2.prototype.getSeriesCount = function() {
    return this._componentsCount.get("series");
  };
  GlobalModel2.prototype.eachSeries = function(cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      cb.call(context, series, rawSeriesIndex);
    }, this);
  };
  GlobalModel2.prototype.eachRawSeries = function(cb, context) {
    each$f(this._componentsMap.get("series"), function(series) {
      series && cb.call(context, series, series.componentIndex);
    });
  };
  GlobalModel2.prototype.eachSeriesByType = function(subType, cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      if (series.subType === subType) {
        cb.call(context, series, rawSeriesIndex);
      }
    }, this);
  };
  GlobalModel2.prototype.eachRawSeriesByType = function(subType, cb, context) {
    return each$f(this.getSeriesByType(subType), cb, context);
  };
  GlobalModel2.prototype.isSeriesFiltered = function(seriesModel) {
    assertSeriesInitialized(this);
    return this._seriesIndicesMap.get(seriesModel.componentIndex) == null;
  };
  GlobalModel2.prototype.getCurrentSeriesIndices = function() {
    return (this._seriesIndices || []).slice();
  };
  GlobalModel2.prototype.filterSeries = function(cb, context) {
    assertSeriesInitialized(this);
    var newSeriesIndices = [];
    each$f(this._seriesIndices, function(seriesRawIdx) {
      var series = this._componentsMap.get("series")[seriesRawIdx];
      cb.call(context, series, seriesRawIdx) && newSeriesIndices.push(seriesRawIdx);
    }, this);
    this._seriesIndices = newSeriesIndices;
    this._seriesIndicesMap = createHashMap(newSeriesIndices);
  };
  GlobalModel2.prototype.restoreData = function(payload) {
    reCreateSeriesIndices(this);
    var componentsMap = this._componentsMap;
    var componentTypes = [];
    componentsMap.each(function(components, componentType) {
      if (ComponentModel$1.hasClass(componentType)) {
        componentTypes.push(componentType);
      }
    });
    ComponentModel$1.topologicalTravel(componentTypes, ComponentModel$1.getAllClassMainTypes(), function(componentType) {
      each$f(componentsMap.get(componentType), function(component) {
        if (component && (componentType !== "series" || !isNotTargetSeries(component, payload))) {
          component.restoreData();
        }
      });
    });
  };
  GlobalModel2.internalField = function() {
    reCreateSeriesIndices = function(ecModel) {
      var seriesIndices = ecModel._seriesIndices = [];
      each$f(ecModel._componentsMap.get("series"), function(series) {
        series && seriesIndices.push(series.componentIndex);
      });
      ecModel._seriesIndicesMap = createHashMap(seriesIndices);
    };
    assertSeriesInitialized = function(ecModel) {
    };
    initBase = function(ecModel, baseOption) {
      ecModel.option = {};
      ecModel.option[OPTION_INNER_KEY] = OPTION_INNER_VALUE;
      ecModel._componentsMap = createHashMap({
        series: []
      });
      ecModel._componentsCount = createHashMap();
      var airaOption = baseOption.aria;
      if (isObject$4(airaOption) && airaOption.enabled == null) {
        airaOption.enabled = true;
      }
      mergeTheme(baseOption, ecModel._theme.option);
      merge(baseOption, globalDefault, false);
      ecModel._mergeOption(baseOption, null);
    };
  }();
  return GlobalModel2;
}(Model$1);
function isNotTargetSeries(seriesModel, payload) {
  if (payload) {
    var index2 = payload.seriesIndex;
    var id2 = payload.seriesId;
    var name_1 = payload.seriesName;
    return index2 != null && seriesModel.componentIndex !== index2 || id2 != null && seriesModel.id !== id2 || name_1 != null && seriesModel.name !== name_1;
  }
}
function mergeTheme(option, theme2) {
  var notMergeColorLayer = option.color && !option.colorLayer;
  each$f(theme2, function(themeItem, name) {
    if (name === "colorLayer" && notMergeColorLayer) {
      return;
    }
    if (!ComponentModel$1.hasClass(name)) {
      if (typeof themeItem === "object") {
        option[name] = !option[name] ? clone$4(themeItem) : merge(option[name], themeItem, false);
      } else {
        if (option[name] == null) {
          option[name] = themeItem;
        }
      }
    }
  });
}
function queryByIdOrName(attr, idOrName, cmpts) {
  if (isArray$1(idOrName)) {
    var keyMap_1 = createHashMap();
    each$f(idOrName, function(idOrNameItem) {
      if (idOrNameItem != null) {
        var idName = convertOptionIdName(idOrNameItem, null);
        idName != null && keyMap_1.set(idOrNameItem, true);
      }
    });
    return filter(cmpts, function(cmpt) {
      return cmpt && keyMap_1.get(cmpt[attr]);
    });
  } else {
    var idName_1 = convertOptionIdName(idOrName, null);
    return filter(cmpts, function(cmpt) {
      return cmpt && idName_1 != null && cmpt[attr] === idName_1;
    });
  }
}
function filterBySubType(components, condition) {
  return condition.hasOwnProperty("subType") ? filter(components, function(cmpt) {
    return cmpt && cmpt.subType === condition.subType;
  }) : components;
}
function normalizeSetOptionInput(opts) {
  var replaceMergeMainTypeMap = createHashMap();
  opts && each$f(normalizeToArray(opts.replaceMerge), function(mainType) {
    replaceMergeMainTypeMap.set(mainType, true);
  });
  return {
    replaceMergeMainTypeMap
  };
}
mixin(GlobalModel, PaletteMixin);
var GlobalModel$1 = GlobalModel;
var availableMethods = [
  "getDom",
  "getZr",
  "getWidth",
  "getHeight",
  "getDevicePixelRatio",
  "dispatchAction",
  "isSSR",
  "isDisposed",
  "on",
  "off",
  "getDataURL",
  "getConnectedDataURL",
  "getOption",
  "getId",
  "updateLabelLayout"
];
var ExtensionAPI = function() {
  function ExtensionAPI2(ecInstance) {
    each$f(availableMethods, function(methodName) {
      this[methodName] = bind$1(ecInstance[methodName], ecInstance);
    }, this);
  }
  return ExtensionAPI2;
}();
var ExtensionAPI$1 = ExtensionAPI;
var coordinateSystemCreators = {};
var CoordinateSystemManager = function() {
  function CoordinateSystemManager2() {
    this._coordinateSystems = [];
  }
  CoordinateSystemManager2.prototype.create = function(ecModel, api) {
    var coordinateSystems = [];
    each$f(coordinateSystemCreators, function(creater, type4) {
      var list = creater.create(ecModel, api);
      coordinateSystems = coordinateSystems.concat(list || []);
    });
    this._coordinateSystems = coordinateSystems;
  };
  CoordinateSystemManager2.prototype.update = function(ecModel, api) {
    each$f(this._coordinateSystems, function(coordSys) {
      coordSys.update && coordSys.update(ecModel, api);
    });
  };
  CoordinateSystemManager2.prototype.getCoordinateSystems = function() {
    return this._coordinateSystems.slice();
  };
  CoordinateSystemManager2.register = function(type4, creator) {
    coordinateSystemCreators[type4] = creator;
  };
  CoordinateSystemManager2.get = function(type4) {
    return coordinateSystemCreators[type4];
  };
  return CoordinateSystemManager2;
}();
var CoordinateSystem = CoordinateSystemManager;
var QUERY_REG = /^(min|max)?(.+)$/;
var OptionManager = function() {
  function OptionManager2(api) {
    this._timelineOptions = [];
    this._mediaList = [];
    this._currentMediaIndices = [];
    this._api = api;
  }
  OptionManager2.prototype.setOption = function(rawOption, optionPreprocessorFuncs2, opt) {
    if (rawOption) {
      each$f(normalizeToArray(rawOption.series), function(series) {
        series && series.data && isTypedArray(series.data) && setAsPrimitive(series.data);
      });
      each$f(normalizeToArray(rawOption.dataset), function(dataset) {
        dataset && dataset.source && isTypedArray(dataset.source) && setAsPrimitive(dataset.source);
      });
    }
    rawOption = clone$4(rawOption);
    var optionBackup = this._optionBackup;
    var newParsedOption = parseRawOption(rawOption, optionPreprocessorFuncs2, !optionBackup);
    this._newBaseOption = newParsedOption.baseOption;
    if (optionBackup) {
      if (newParsedOption.timelineOptions.length) {
        optionBackup.timelineOptions = newParsedOption.timelineOptions;
      }
      if (newParsedOption.mediaList.length) {
        optionBackup.mediaList = newParsedOption.mediaList;
      }
      if (newParsedOption.mediaDefault) {
        optionBackup.mediaDefault = newParsedOption.mediaDefault;
      }
    } else {
      this._optionBackup = newParsedOption;
    }
  };
  OptionManager2.prototype.mountOption = function(isRecreate) {
    var optionBackup = this._optionBackup;
    this._timelineOptions = optionBackup.timelineOptions;
    this._mediaList = optionBackup.mediaList;
    this._mediaDefault = optionBackup.mediaDefault;
    this._currentMediaIndices = [];
    return clone$4(isRecreate ? optionBackup.baseOption : this._newBaseOption);
  };
  OptionManager2.prototype.getTimelineOption = function(ecModel) {
    var option;
    var timelineOptions = this._timelineOptions;
    if (timelineOptions.length) {
      var timelineModel = ecModel.getComponent("timeline");
      if (timelineModel) {
        option = clone$4(timelineOptions[timelineModel.getCurrentIndex()]);
      }
    }
    return option;
  };
  OptionManager2.prototype.getMediaOption = function(ecModel) {
    var ecWidth = this._api.getWidth();
    var ecHeight = this._api.getHeight();
    var mediaList = this._mediaList;
    var mediaDefault = this._mediaDefault;
    var indices = [];
    var result = [];
    if (!mediaList.length && !mediaDefault) {
      return result;
    }
    for (var i = 0, len2 = mediaList.length; i < len2; i++) {
      if (applyMediaQuery(mediaList[i].query, ecWidth, ecHeight)) {
        indices.push(i);
      }
    }
    if (!indices.length && mediaDefault) {
      indices = [-1];
    }
    if (indices.length && !indicesEquals(indices, this._currentMediaIndices)) {
      result = map$1(indices, function(index2) {
        return clone$4(index2 === -1 ? mediaDefault.option : mediaList[index2].option);
      });
    }
    this._currentMediaIndices = indices;
    return result;
  };
  return OptionManager2;
}();
function parseRawOption(rawOption, optionPreprocessorFuncs2, isNew) {
  var mediaList = [];
  var mediaDefault;
  var baseOption;
  var declaredBaseOption = rawOption.baseOption;
  var timelineOnRoot = rawOption.timeline;
  var timelineOptionsOnRoot = rawOption.options;
  var mediaOnRoot = rawOption.media;
  var hasMedia = !!rawOption.media;
  var hasTimeline = !!(timelineOptionsOnRoot || timelineOnRoot || declaredBaseOption && declaredBaseOption.timeline);
  if (declaredBaseOption) {
    baseOption = declaredBaseOption;
    if (!baseOption.timeline) {
      baseOption.timeline = timelineOnRoot;
    }
  } else {
    if (hasTimeline || hasMedia) {
      rawOption.options = rawOption.media = null;
    }
    baseOption = rawOption;
  }
  if (hasMedia) {
    if (isArray$1(mediaOnRoot)) {
      each$f(mediaOnRoot, function(singleMedia) {
        if (singleMedia && singleMedia.option) {
          if (singleMedia.query) {
            mediaList.push(singleMedia);
          } else if (!mediaDefault) {
            mediaDefault = singleMedia;
          }
        }
      });
    }
  }
  doPreprocess(baseOption);
  each$f(timelineOptionsOnRoot, function(option) {
    return doPreprocess(option);
  });
  each$f(mediaList, function(media) {
    return doPreprocess(media.option);
  });
  function doPreprocess(option) {
    each$f(optionPreprocessorFuncs2, function(preProcess) {
      preProcess(option, isNew);
    });
  }
  return {
    baseOption,
    timelineOptions: timelineOptionsOnRoot || [],
    mediaDefault,
    mediaList
  };
}
function applyMediaQuery(query, ecWidth, ecHeight) {
  var realMap = {
    width: ecWidth,
    height: ecHeight,
    aspectratio: ecWidth / ecHeight
  };
  var applicatable = true;
  each$f(query, function(value, attr) {
    var matched = attr.match(QUERY_REG);
    if (!matched || !matched[1] || !matched[2]) {
      return;
    }
    var operator = matched[1];
    var realAttr = matched[2].toLowerCase();
    if (!compare(realMap[realAttr], value, operator)) {
      applicatable = false;
    }
  });
  return applicatable;
}
function compare(real, expect, operator) {
  if (operator === "min") {
    return real >= expect;
  } else if (operator === "max") {
    return real <= expect;
  } else {
    return real === expect;
  }
}
function indicesEquals(indices1, indices2) {
  return indices1.join(",") === indices2.join(",");
}
var OptionManager$1 = OptionManager;
var each$d = each$f;
var isObject$3 = isObject$4;
var POSSIBLE_STYLES = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
function compatEC2ItemStyle(opt) {
  var itemStyleOpt = opt && opt.itemStyle;
  if (!itemStyleOpt) {
    return;
  }
  for (var i = 0, len2 = POSSIBLE_STYLES.length; i < len2; i++) {
    var styleName = POSSIBLE_STYLES[i];
    var normalItemStyleOpt = itemStyleOpt.normal;
    var emphasisItemStyleOpt = itemStyleOpt.emphasis;
    if (normalItemStyleOpt && normalItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].normal) {
        opt[styleName].normal = normalItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].normal, normalItemStyleOpt[styleName]);
      }
      normalItemStyleOpt[styleName] = null;
    }
    if (emphasisItemStyleOpt && emphasisItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].emphasis) {
        opt[styleName].emphasis = emphasisItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].emphasis, emphasisItemStyleOpt[styleName]);
      }
      emphasisItemStyleOpt[styleName] = null;
    }
  }
}
function convertNormalEmphasis(opt, optType, useExtend) {
  if (opt && opt[optType] && (opt[optType].normal || opt[optType].emphasis)) {
    var normalOpt = opt[optType].normal;
    var emphasisOpt = opt[optType].emphasis;
    if (normalOpt) {
      if (useExtend) {
        opt[optType].normal = opt[optType].emphasis = null;
        defaults(opt[optType], normalOpt);
      } else {
        opt[optType] = normalOpt;
      }
    }
    if (emphasisOpt) {
      opt.emphasis = opt.emphasis || {};
      opt.emphasis[optType] = emphasisOpt;
      if (emphasisOpt.focus) {
        opt.emphasis.focus = emphasisOpt.focus;
      }
      if (emphasisOpt.blurScope) {
        opt.emphasis.blurScope = emphasisOpt.blurScope;
      }
    }
  }
}
function removeEC3NormalStatus(opt) {
  convertNormalEmphasis(opt, "itemStyle");
  convertNormalEmphasis(opt, "lineStyle");
  convertNormalEmphasis(opt, "areaStyle");
  convertNormalEmphasis(opt, "label");
  convertNormalEmphasis(opt, "labelLine");
  convertNormalEmphasis(opt, "upperLabel");
  convertNormalEmphasis(opt, "edgeLabel");
}
function compatTextStyle(opt, propName) {
  var labelOptSingle = isObject$3(opt) && opt[propName];
  var textStyle = isObject$3(labelOptSingle) && labelOptSingle.textStyle;
  if (textStyle) {
    for (var i = 0, len2 = TEXT_STYLE_OPTIONS.length; i < len2; i++) {
      var textPropName = TEXT_STYLE_OPTIONS[i];
      if (textStyle.hasOwnProperty(textPropName)) {
        labelOptSingle[textPropName] = textStyle[textPropName];
      }
    }
  }
}
function compatEC3CommonStyles(opt) {
  if (opt) {
    removeEC3NormalStatus(opt);
    compatTextStyle(opt, "label");
    opt.emphasis && compatTextStyle(opt.emphasis, "label");
  }
}
function processSeries(seriesOpt) {
  if (!isObject$3(seriesOpt)) {
    return;
  }
  compatEC2ItemStyle(seriesOpt);
  removeEC3NormalStatus(seriesOpt);
  compatTextStyle(seriesOpt, "label");
  compatTextStyle(seriesOpt, "upperLabel");
  compatTextStyle(seriesOpt, "edgeLabel");
  if (seriesOpt.emphasis) {
    compatTextStyle(seriesOpt.emphasis, "label");
    compatTextStyle(seriesOpt.emphasis, "upperLabel");
    compatTextStyle(seriesOpt.emphasis, "edgeLabel");
  }
  var markPoint = seriesOpt.markPoint;
  if (markPoint) {
    compatEC2ItemStyle(markPoint);
    compatEC3CommonStyles(markPoint);
  }
  var markLine = seriesOpt.markLine;
  if (markLine) {
    compatEC2ItemStyle(markLine);
    compatEC3CommonStyles(markLine);
  }
  var markArea = seriesOpt.markArea;
  if (markArea) {
    compatEC3CommonStyles(markArea);
  }
  var data = seriesOpt.data;
  if (seriesOpt.type === "graph") {
    data = data || seriesOpt.nodes;
    var edgeData = seriesOpt.links || seriesOpt.edges;
    if (edgeData && !isTypedArray(edgeData)) {
      for (var i = 0; i < edgeData.length; i++) {
        compatEC3CommonStyles(edgeData[i]);
      }
    }
    each$f(seriesOpt.categories, function(opt) {
      removeEC3NormalStatus(opt);
    });
  }
  if (data && !isTypedArray(data)) {
    for (var i = 0; i < data.length; i++) {
      compatEC3CommonStyles(data[i]);
    }
  }
  markPoint = seriesOpt.markPoint;
  if (markPoint && markPoint.data) {
    var mpData = markPoint.data;
    for (var i = 0; i < mpData.length; i++) {
      compatEC3CommonStyles(mpData[i]);
    }
  }
  markLine = seriesOpt.markLine;
  if (markLine && markLine.data) {
    var mlData = markLine.data;
    for (var i = 0; i < mlData.length; i++) {
      if (isArray$1(mlData[i])) {
        compatEC3CommonStyles(mlData[i][0]);
        compatEC3CommonStyles(mlData[i][1]);
      } else {
        compatEC3CommonStyles(mlData[i]);
      }
    }
  }
  if (seriesOpt.type === "gauge") {
    compatTextStyle(seriesOpt, "axisLabel");
    compatTextStyle(seriesOpt, "title");
    compatTextStyle(seriesOpt, "detail");
  } else if (seriesOpt.type === "treemap") {
    convertNormalEmphasis(seriesOpt.breadcrumb, "itemStyle");
    each$f(seriesOpt.levels, function(opt) {
      removeEC3NormalStatus(opt);
    });
  } else if (seriesOpt.type === "tree") {
    removeEC3NormalStatus(seriesOpt.leaves);
  }
}
function toArr(o) {
  return isArray$1(o) ? o : o ? [o] : [];
}
function toObj(o) {
  return (isArray$1(o) ? o[0] : o) || {};
}
function globalCompatStyle(option, isTheme) {
  each$d(toArr(option.series), function(seriesOpt) {
    isObject$3(seriesOpt) && processSeries(seriesOpt);
  });
  var axes = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
  isTheme && axes.push("valueAxis", "categoryAxis", "logAxis", "timeAxis");
  each$d(axes, function(axisName) {
    each$d(toArr(option[axisName]), function(axisOpt) {
      if (axisOpt) {
        compatTextStyle(axisOpt, "axisLabel");
        compatTextStyle(axisOpt.axisPointer, "label");
      }
    });
  });
  each$d(toArr(option.parallel), function(parallelOpt) {
    var parallelAxisDefault = parallelOpt && parallelOpt.parallelAxisDefault;
    compatTextStyle(parallelAxisDefault, "axisLabel");
    compatTextStyle(parallelAxisDefault && parallelAxisDefault.axisPointer, "label");
  });
  each$d(toArr(option.calendar), function(calendarOpt) {
    convertNormalEmphasis(calendarOpt, "itemStyle");
    compatTextStyle(calendarOpt, "dayLabel");
    compatTextStyle(calendarOpt, "monthLabel");
    compatTextStyle(calendarOpt, "yearLabel");
  });
  each$d(toArr(option.radar), function(radarOpt) {
    compatTextStyle(radarOpt, "name");
    if (radarOpt.name && radarOpt.axisName == null) {
      radarOpt.axisName = radarOpt.name;
      delete radarOpt.name;
    }
    if (radarOpt.nameGap != null && radarOpt.axisNameGap == null) {
      radarOpt.axisNameGap = radarOpt.nameGap;
      delete radarOpt.nameGap;
    }
  });
  each$d(toArr(option.geo), function(geoOpt) {
    if (isObject$3(geoOpt)) {
      compatEC3CommonStyles(geoOpt);
      each$d(toArr(geoOpt.regions), function(regionObj) {
        compatEC3CommonStyles(regionObj);
      });
    }
  });
  each$d(toArr(option.timeline), function(timelineOpt) {
    compatEC3CommonStyles(timelineOpt);
    convertNormalEmphasis(timelineOpt, "label");
    convertNormalEmphasis(timelineOpt, "itemStyle");
    convertNormalEmphasis(timelineOpt, "controlStyle", true);
    var data = timelineOpt.data;
    isArray$1(data) && each$f(data, function(item) {
      if (isObject$4(item)) {
        convertNormalEmphasis(item, "label");
        convertNormalEmphasis(item, "itemStyle");
      }
    });
  });
  each$d(toArr(option.toolbox), function(toolboxOpt) {
    convertNormalEmphasis(toolboxOpt, "iconStyle");
    each$d(toolboxOpt.feature, function(featureOpt) {
      convertNormalEmphasis(featureOpt, "iconStyle");
    });
  });
  compatTextStyle(toObj(option.axisPointer), "label");
  compatTextStyle(toObj(option.tooltip).axisPointer, "label");
}
function get$1(opt, path) {
  var pathArr = path.split(",");
  var obj = opt;
  for (var i = 0; i < pathArr.length; i++) {
    obj = obj && obj[pathArr[i]];
    if (obj == null) {
      break;
    }
  }
  return obj;
}
function set$1(opt, path, val, overwrite) {
  var pathArr = path.split(",");
  var obj = opt;
  var key;
  var i = 0;
  for (; i < pathArr.length - 1; i++) {
    key = pathArr[i];
    if (obj[key] == null) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  if (overwrite || obj[pathArr[i]] == null) {
    obj[pathArr[i]] = val;
  }
}
function compatLayoutProperties(option) {
  option && each$f(LAYOUT_PROPERTIES, function(prop) {
    if (prop[0] in option && !(prop[1] in option)) {
      option[prop[1]] = option[prop[0]];
    }
  });
}
var LAYOUT_PROPERTIES = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]];
var COMPATITABLE_COMPONENTS = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"];
var BAR_ITEM_STYLE_MAP = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
function compatBarItemStyle(option) {
  var itemStyle = option && option.itemStyle;
  if (itemStyle) {
    for (var i = 0; i < BAR_ITEM_STYLE_MAP.length; i++) {
      var oldName = BAR_ITEM_STYLE_MAP[i][1];
      var newName = BAR_ITEM_STYLE_MAP[i][0];
      if (itemStyle[oldName] != null) {
        itemStyle[newName] = itemStyle[oldName];
      }
    }
  }
}
function compatPieLabel(option) {
  if (!option) {
    return;
  }
  if (option.alignTo === "edge" && option.margin != null && option.edgeDistance == null) {
    option.edgeDistance = option.margin;
  }
}
function compatSunburstState(option) {
  if (!option) {
    return;
  }
  if (option.downplay && !option.blur) {
    option.blur = option.downplay;
  }
}
function compatGraphFocus(option) {
  if (!option) {
    return;
  }
  if (option.focusNodeAdjacency != null) {
    option.emphasis = option.emphasis || {};
    if (option.emphasis.focus == null) {
      option.emphasis.focus = "adjacency";
    }
  }
}
function traverseTree(data, cb) {
  if (data) {
    for (var i = 0; i < data.length; i++) {
      cb(data[i]);
      data[i] && traverseTree(data[i].children, cb);
    }
  }
}
function globalBackwardCompat(option, isTheme) {
  globalCompatStyle(option, isTheme);
  option.series = normalizeToArray(option.series);
  each$f(option.series, function(seriesOpt) {
    if (!isObject$4(seriesOpt)) {
      return;
    }
    var seriesType2 = seriesOpt.type;
    if (seriesType2 === "line") {
      if (seriesOpt.clipOverflow != null) {
        seriesOpt.clip = seriesOpt.clipOverflow;
      }
    } else if (seriesType2 === "pie" || seriesType2 === "gauge") {
      if (seriesOpt.clockWise != null) {
        seriesOpt.clockwise = seriesOpt.clockWise;
      }
      compatPieLabel(seriesOpt.label);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          compatPieLabel(data[i]);
        }
      }
      if (seriesOpt.hoverOffset != null) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (seriesOpt.emphasis.scaleSize = null) {
          seriesOpt.emphasis.scaleSize = seriesOpt.hoverOffset;
        }
      }
    } else if (seriesType2 === "gauge") {
      var pointerColor = get$1(seriesOpt, "pointer.color");
      pointerColor != null && set$1(seriesOpt, "itemStyle.color", pointerColor);
    } else if (seriesType2 === "bar") {
      compatBarItemStyle(seriesOpt);
      compatBarItemStyle(seriesOpt.backgroundStyle);
      compatBarItemStyle(seriesOpt.emphasis);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          if (typeof data[i] === "object") {
            compatBarItemStyle(data[i]);
            compatBarItemStyle(data[i] && data[i].emphasis);
          }
        }
      }
    } else if (seriesType2 === "sunburst") {
      var highlightPolicy = seriesOpt.highlightPolicy;
      if (highlightPolicy) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (!seriesOpt.emphasis.focus) {
          seriesOpt.emphasis.focus = highlightPolicy;
        }
      }
      compatSunburstState(seriesOpt);
      traverseTree(seriesOpt.data, compatSunburstState);
    } else if (seriesType2 === "graph" || seriesType2 === "sankey") {
      compatGraphFocus(seriesOpt);
    } else if (seriesType2 === "map") {
      if (seriesOpt.mapType && !seriesOpt.map) {
        seriesOpt.map = seriesOpt.mapType;
      }
      if (seriesOpt.mapLocation) {
        defaults(seriesOpt, seriesOpt.mapLocation);
      }
    }
    if (seriesOpt.hoverAnimation != null) {
      seriesOpt.emphasis = seriesOpt.emphasis || {};
      if (seriesOpt.emphasis && seriesOpt.emphasis.scale == null) {
        seriesOpt.emphasis.scale = seriesOpt.hoverAnimation;
      }
    }
    compatLayoutProperties(seriesOpt);
  });
  if (option.dataRange) {
    option.visualMap = option.dataRange;
  }
  each$f(COMPATITABLE_COMPONENTS, function(componentName) {
    var options = option[componentName];
    if (options) {
      if (!isArray$1(options)) {
        options = [options];
      }
      each$f(options, function(option2) {
        compatLayoutProperties(option2);
      });
    }
  });
}
function dataStack(ecModel) {
  var stackInfoMap = createHashMap();
  ecModel.eachSeries(function(seriesModel) {
    var stack = seriesModel.get("stack");
    if (stack) {
      var stackInfoList = stackInfoMap.get(stack) || stackInfoMap.set(stack, []);
      var data = seriesModel.getData();
      var stackInfo = {
        stackResultDimension: data.getCalculationInfo("stackResultDimension"),
        stackedOverDimension: data.getCalculationInfo("stackedOverDimension"),
        stackedDimension: data.getCalculationInfo("stackedDimension"),
        stackedByDimension: data.getCalculationInfo("stackedByDimension"),
        isStackedByIndex: data.getCalculationInfo("isStackedByIndex"),
        data,
        seriesModel
      };
      if (!stackInfo.stackedDimension || !(stackInfo.isStackedByIndex || stackInfo.stackedByDimension)) {
        return;
      }
      stackInfoList.length && data.setCalculationInfo("stackedOnSeries", stackInfoList[stackInfoList.length - 1].seriesModel);
      stackInfoList.push(stackInfo);
    }
  });
  stackInfoMap.each(calculateStack);
}
function calculateStack(stackInfoList) {
  each$f(stackInfoList, function(targetStackInfo, idxInStack) {
    var resultVal = [];
    var resultNaN = [NaN, NaN];
    var dims = [targetStackInfo.stackResultDimension, targetStackInfo.stackedOverDimension];
    var targetData = targetStackInfo.data;
    var isStackedByIndex = targetStackInfo.isStackedByIndex;
    targetData.modify(dims, function(v0, v12, dataIndex) {
      var sum2 = targetData.get(targetStackInfo.stackedDimension, dataIndex);
      if (isNaN(sum2)) {
        return resultNaN;
      }
      var byValue;
      var stackedDataRawIndex;
      if (isStackedByIndex) {
        stackedDataRawIndex = targetData.getRawIndex(dataIndex);
      } else {
        byValue = targetData.get(targetStackInfo.stackedByDimension, dataIndex);
      }
      var stackedOver = NaN;
      for (var j = idxInStack - 1; j >= 0; j--) {
        var stackInfo = stackInfoList[j];
        if (!isStackedByIndex) {
          stackedDataRawIndex = stackInfo.data.rawIndexOf(stackInfo.stackedByDimension, byValue);
        }
        if (stackedDataRawIndex >= 0) {
          var val = stackInfo.data.getByRawIndex(stackInfo.stackResultDimension, stackedDataRawIndex);
          if (sum2 >= 0 && val > 0 || sum2 <= 0 && val < 0) {
            sum2 = addSafe(sum2, val);
            stackedOver = val;
            break;
          }
        }
      }
      resultVal[0] = sum2;
      resultVal[1] = stackedOver;
      return resultVal;
    });
  });
}
var SourceImpl = function() {
  function SourceImpl2(fields) {
    this.data = fields.data || (fields.sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS ? {} : []);
    this.sourceFormat = fields.sourceFormat || SOURCE_FORMAT_UNKNOWN;
    this.seriesLayoutBy = fields.seriesLayoutBy || SERIES_LAYOUT_BY_COLUMN;
    this.startIndex = fields.startIndex || 0;
    this.dimensionsDetectedCount = fields.dimensionsDetectedCount;
    this.metaRawOption = fields.metaRawOption;
    var dimensionsDefine = this.dimensionsDefine = fields.dimensionsDefine;
    if (dimensionsDefine) {
      for (var i = 0; i < dimensionsDefine.length; i++) {
        var dim = dimensionsDefine[i];
        if (dim.type == null) {
          if (guessOrdinal(this, i) === BE_ORDINAL.Must) {
            dim.type = "ordinal";
          }
        }
      }
    }
  }
  return SourceImpl2;
}();
function isSourceInstance(val) {
  return val instanceof SourceImpl;
}
function createSource(sourceData, thisMetaRawOption, sourceFormat) {
  sourceFormat = sourceFormat || detectSourceFormat(sourceData);
  var seriesLayoutBy = thisMetaRawOption.seriesLayoutBy;
  var determined = determineSourceDimensions(sourceData, sourceFormat, seriesLayoutBy, thisMetaRawOption.sourceHeader, thisMetaRawOption.dimensions);
  var source = new SourceImpl({
    data: sourceData,
    sourceFormat,
    seriesLayoutBy,
    dimensionsDefine: determined.dimensionsDefine,
    startIndex: determined.startIndex,
    dimensionsDetectedCount: determined.dimensionsDetectedCount,
    metaRawOption: clone$4(thisMetaRawOption)
  });
  return source;
}
function createSourceFromSeriesDataOption(data) {
  return new SourceImpl({
    data,
    sourceFormat: isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL
  });
}
function cloneSourceShallow(source) {
  return new SourceImpl({
    data: source.data,
    sourceFormat: source.sourceFormat,
    seriesLayoutBy: source.seriesLayoutBy,
    dimensionsDefine: clone$4(source.dimensionsDefine),
    startIndex: source.startIndex,
    dimensionsDetectedCount: source.dimensionsDetectedCount
  });
}
function detectSourceFormat(data) {
  var sourceFormat = SOURCE_FORMAT_UNKNOWN;
  if (isTypedArray(data)) {
    sourceFormat = SOURCE_FORMAT_TYPED_ARRAY;
  } else if (isArray$1(data)) {
    if (data.length === 0) {
      sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
    }
    for (var i = 0, len2 = data.length; i < len2; i++) {
      var item = data[i];
      if (item == null) {
        continue;
      } else if (isArray$1(item)) {
        sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
        break;
      } else if (isObject$4(item)) {
        sourceFormat = SOURCE_FORMAT_OBJECT_ROWS;
        break;
      }
    }
  } else if (isObject$4(data)) {
    for (var key in data) {
      if (hasOwn(data, key) && isArrayLike(data[key])) {
        sourceFormat = SOURCE_FORMAT_KEYED_COLUMNS;
        break;
      }
    }
  }
  return sourceFormat;
}
function determineSourceDimensions(data, sourceFormat, seriesLayoutBy, sourceHeader, dimensionsDefine) {
  var dimensionsDetectedCount;
  var startIndex;
  if (!data) {
    return {
      dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
      startIndex,
      dimensionsDetectedCount
    };
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (sourceHeader === "auto" || sourceHeader == null) {
      arrayRowsTravelFirst(function(val) {
        if (val != null && val !== "-") {
          if (isString(val)) {
            startIndex == null && (startIndex = 1);
          } else {
            startIndex = 0;
          }
        }
      }, seriesLayoutBy, dataArrayRows, 10);
    } else {
      startIndex = isNumber(sourceHeader) ? sourceHeader : sourceHeader ? 1 : 0;
    }
    if (!dimensionsDefine && startIndex === 1) {
      dimensionsDefine = [];
      arrayRowsTravelFirst(function(val, index2) {
        dimensionsDefine[index2] = val != null ? val + "" : "";
      }, seriesLayoutBy, dataArrayRows, Infinity);
    }
    dimensionsDetectedCount = dimensionsDefine ? dimensionsDefine.length : seriesLayoutBy === SERIES_LAYOUT_BY_ROW ? dataArrayRows.length : dataArrayRows[0] ? dataArrayRows[0].length : null;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    if (!dimensionsDefine) {
      dimensionsDefine = objectRowsCollectDimensions(data);
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    if (!dimensionsDefine) {
      dimensionsDefine = [];
      each$f(data, function(colArr, key) {
        dimensionsDefine.push(key);
      });
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var value0 = getDataItemValue(data[0]);
    dimensionsDetectedCount = isArray$1(value0) && value0.length || 1;
  } else
    ;
  return {
    startIndex,
    dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
    dimensionsDetectedCount
  };
}
function objectRowsCollectDimensions(data) {
  var firstIndex = 0;
  var obj;
  while (firstIndex < data.length && !(obj = data[firstIndex++])) {
  }
  if (obj) {
    var dimensions_1 = [];
    each$f(obj, function(value, key) {
      dimensions_1.push(key);
    });
    return dimensions_1;
  }
}
function normalizeDimensionsOption(dimensionsDefine) {
  if (!dimensionsDefine) {
    return;
  }
  var nameMap = createHashMap();
  return map$1(dimensionsDefine, function(rawItem, index2) {
    rawItem = isObject$4(rawItem) ? rawItem : {
      name: rawItem
    };
    var item = {
      name: rawItem.name,
      displayName: rawItem.displayName,
      type: rawItem.type
    };
    if (item.name == null) {
      return item;
    }
    item.name += "";
    if (item.displayName == null) {
      item.displayName = item.name;
    }
    var exist = nameMap.get(item.name);
    if (!exist) {
      nameMap.set(item.name, {
        count: 1
      });
    } else {
      item.name += "-" + exist.count++;
    }
    return item;
  });
}
function arrayRowsTravelFirst(cb, seriesLayoutBy, data, maxLoop) {
  if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
    for (var i = 0; i < data.length && i < maxLoop; i++) {
      cb(data[i] ? data[i][0] : null, i);
    }
  } else {
    var value0 = data[0] || [];
    for (var i = 0; i < value0.length && i < maxLoop; i++) {
      cb(value0[i], i);
    }
  }
}
function shouldRetrieveDataByName(source) {
  var sourceFormat = source.sourceFormat;
  return sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS;
}
var _a, _b, _c;
var providerMethods;
var mountMethods;
var DefaultDataProvider = function() {
  function DefaultDataProvider2(sourceParam, dimSize) {
    var source = !isSourceInstance(sourceParam) ? createSourceFromSeriesDataOption(sourceParam) : sourceParam;
    this._source = source;
    var data = this._data = source.data;
    if (source.sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
      this._offset = 0;
      this._dimSize = dimSize;
      this._data = data;
    }
    mountMethods(this, data, source);
  }
  DefaultDataProvider2.prototype.getSource = function() {
    return this._source;
  };
  DefaultDataProvider2.prototype.count = function() {
    return 0;
  };
  DefaultDataProvider2.prototype.getItem = function(idx, out2) {
    return;
  };
  DefaultDataProvider2.prototype.appendData = function(newData) {
  };
  DefaultDataProvider2.prototype.clean = function() {
  };
  DefaultDataProvider2.protoInitialize = function() {
    var proto2 = DefaultDataProvider2.prototype;
    proto2.pure = false;
    proto2.persistent = true;
  }();
  DefaultDataProvider2.internalField = function() {
    var _a2;
    mountMethods = function(provider, data, source) {
      var sourceFormat = source.sourceFormat;
      var seriesLayoutBy = source.seriesLayoutBy;
      var startIndex = source.startIndex;
      var dimsDef = source.dimensionsDefine;
      var methods = providerMethods[getMethodMapKey(sourceFormat, seriesLayoutBy)];
      extend(provider, methods);
      if (sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
        provider.getItem = getItemForTypedArray;
        provider.count = countForTypedArray;
        provider.fillStorage = fillStorageForTypedArray;
      } else {
        var rawItemGetter = getRawSourceItemGetter(sourceFormat, seriesLayoutBy);
        provider.getItem = bind$1(rawItemGetter, null, data, startIndex, dimsDef);
        var rawCounter = getRawSourceDataCounter(sourceFormat, seriesLayoutBy);
        provider.count = bind$1(rawCounter, null, data, startIndex, dimsDef);
      }
    };
    var getItemForTypedArray = function(idx, out2) {
      idx = idx - this._offset;
      out2 = out2 || [];
      var data = this._data;
      var dimSize = this._dimSize;
      var offset = dimSize * idx;
      for (var i = 0; i < dimSize; i++) {
        out2[i] = data[offset + i];
      }
      return out2;
    };
    var fillStorageForTypedArray = function(start2, end2, storage2, extent3) {
      var data = this._data;
      var dimSize = this._dimSize;
      for (var dim = 0; dim < dimSize; dim++) {
        var dimExtent = extent3[dim];
        var min3 = dimExtent[0] == null ? Infinity : dimExtent[0];
        var max3 = dimExtent[1] == null ? -Infinity : dimExtent[1];
        var count2 = end2 - start2;
        var arr = storage2[dim];
        for (var i = 0; i < count2; i++) {
          var val = data[i * dimSize + dim];
          arr[start2 + i] = val;
          val < min3 && (min3 = val);
          val > max3 && (max3 = val);
        }
        dimExtent[0] = min3;
        dimExtent[1] = max3;
      }
    };
    var countForTypedArray = function() {
      return this._data ? this._data.length / this._dimSize : 0;
    };
    providerMethods = (_a2 = {}, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = {
      pure: true,
      appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      }
    }, _a2[SOURCE_FORMAT_OBJECT_ROWS] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_KEYED_COLUMNS] = {
      pure: true,
      appendData: function(newData) {
        var data = this._data;
        each$f(newData, function(newCol, key) {
          var oldCol = data[key] || (data[key] = []);
          for (var i = 0; i < (newCol || []).length; i++) {
            oldCol.push(newCol[i]);
          }
        });
      }
    }, _a2[SOURCE_FORMAT_ORIGINAL] = {
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_TYPED_ARRAY] = {
      persistent: false,
      pure: true,
      appendData: function(newData) {
        this._data = newData;
      },
      clean: function() {
        this._offset += this.count();
        this._data = null;
      }
    }, _a2);
    function appendDataSimply(newData) {
      for (var i = 0; i < newData.length; i++) {
        this._data.push(newData[i]);
      }
    }
  }();
  return DefaultDataProvider2;
}();
var getItemSimply = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx];
};
var rawSourceItemGetterMap = (_a = {}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx + startIndex];
}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef, idx, out2) {
  idx += startIndex;
  var item = out2 || [];
  var data = rawData;
  for (var i = 0; i < data.length; i++) {
    var row = data[i];
    item[i] = row ? row[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_OBJECT_ROWS] = getItemSimply, _a[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef, idx, out2) {
  var item = out2 || [];
  for (var i = 0; i < dimsDef.length; i++) {
    var dimName = dimsDef[i].name;
    var col = rawData[dimName];
    item[i] = col ? col[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_ORIGINAL] = getItemSimply, _a);
function getRawSourceItemGetter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceItemGetterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var countSimply = function(rawData, startIndex, dimsDef) {
  return rawData.length;
};
var rawSourceDataCounterMap = (_b = {}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef) {
  return Math.max(0, rawData.length - startIndex);
}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef) {
  var row = rawData[0];
  return row ? Math.max(0, row.length - startIndex) : 0;
}, _b[SOURCE_FORMAT_OBJECT_ROWS] = countSimply, _b[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef) {
  var dimName = dimsDef[0].name;
  var col = rawData[dimName];
  return col ? col.length : 0;
}, _b[SOURCE_FORMAT_ORIGINAL] = countSimply, _b);
function getRawSourceDataCounter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceDataCounterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var getRawValueSimply = function(dataItem, dimIndex, property) {
  return dataItem[dimIndex];
};
var rawSourceValueGetterMap = (_c = {}, _c[SOURCE_FORMAT_ARRAY_ROWS] = getRawValueSimply, _c[SOURCE_FORMAT_OBJECT_ROWS] = function(dataItem, dimIndex, property) {
  return dataItem[property];
}, _c[SOURCE_FORMAT_KEYED_COLUMNS] = getRawValueSimply, _c[SOURCE_FORMAT_ORIGINAL] = function(dataItem, dimIndex, property) {
  var value = getDataItemValue(dataItem);
  return !(value instanceof Array) ? value : value[dimIndex];
}, _c[SOURCE_FORMAT_TYPED_ARRAY] = getRawValueSimply, _c);
function getRawSourceValueGetter(sourceFormat) {
  var method4 = rawSourceValueGetterMap[sourceFormat];
  return method4;
}
function getMethodMapKey(sourceFormat, seriesLayoutBy) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS ? sourceFormat + "_" + seriesLayoutBy : sourceFormat;
}
function retrieveRawValue(data, dataIndex, dim) {
  if (!data) {
    return;
  }
  var dataItem = data.getRawDataItem(dataIndex);
  if (dataItem == null) {
    return;
  }
  var store = data.getStore();
  var sourceFormat = store.getSource().sourceFormat;
  if (dim != null) {
    var dimIndex = data.getDimensionIndex(dim);
    var property = store.getDimensionProperty(dimIndex);
    return getRawSourceValueGetter(sourceFormat)(dataItem, dimIndex, property);
  } else {
    var result = dataItem;
    if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
      result = getDataItemValue(dataItem);
    }
    return result;
  }
}
var DIMENSION_LABEL_REG = /\{@(.+?)\}/g;
var DataFormatMixin = function() {
  function DataFormatMixin2() {
  }
  DataFormatMixin2.prototype.getDataParams = function(dataIndex, dataType) {
    var data = this.getData(dataType);
    var rawValue = this.getRawValue(dataIndex, dataType);
    var rawDataIndex = data.getRawIndex(dataIndex);
    var name = data.getName(dataIndex);
    var itemOpt = data.getRawDataItem(dataIndex);
    var style = data.getItemVisual(dataIndex, "style");
    var color = style && style[data.getItemVisual(dataIndex, "drawType") || "fill"];
    var borderColor = style && style.stroke;
    var mainType = this.mainType;
    var isSeries2 = mainType === "series";
    var userOutput = data.userOutput && data.userOutput.get();
    return {
      componentType: mainType,
      componentSubType: this.subType,
      componentIndex: this.componentIndex,
      seriesType: isSeries2 ? this.subType : null,
      seriesIndex: this.seriesIndex,
      seriesId: isSeries2 ? this.id : null,
      seriesName: isSeries2 ? this.name : null,
      name,
      dataIndex: rawDataIndex,
      data: itemOpt,
      dataType,
      value: rawValue,
      color,
      borderColor,
      dimensionNames: userOutput ? userOutput.fullDimensions : null,
      encode: userOutput ? userOutput.encode : null,
      $vars: ["seriesName", "name", "value"]
    };
  };
  DataFormatMixin2.prototype.getFormattedLabel = function(dataIndex, status, dataType, labelDimIndex, formatter, extendParams) {
    status = status || "normal";
    var data = this.getData(dataType);
    var params = this.getDataParams(dataIndex, dataType);
    if (extendParams) {
      params.value = extendParams.interpolatedValue;
    }
    if (labelDimIndex != null && isArray$1(params.value)) {
      params.value = params.value[labelDimIndex];
    }
    if (!formatter) {
      var itemModel = data.getItemModel(dataIndex);
      formatter = itemModel.get(status === "normal" ? ["label", "formatter"] : [status, "label", "formatter"]);
    }
    if (isFunction(formatter)) {
      params.status = status;
      params.dimensionIndex = labelDimIndex;
      return formatter(params);
    } else if (isString(formatter)) {
      var str = formatTpl(formatter, params);
      return str.replace(DIMENSION_LABEL_REG, function(origin, dimStr) {
        var len2 = dimStr.length;
        var dimLoose = dimStr;
        if (dimLoose.charAt(0) === "[" && dimLoose.charAt(len2 - 1) === "]") {
          dimLoose = +dimLoose.slice(1, len2 - 1);
        }
        var val = retrieveRawValue(data, dataIndex, dimLoose);
        if (extendParams && isArray$1(extendParams.interpolatedValue)) {
          var dimIndex = data.getDimensionIndex(dimLoose);
          if (dimIndex >= 0) {
            val = extendParams.interpolatedValue[dimIndex];
          }
        }
        return val != null ? val + "" : "";
      });
    }
  };
  DataFormatMixin2.prototype.getRawValue = function(idx, dataType) {
    return retrieveRawValue(this.getData(dataType), idx);
  };
  DataFormatMixin2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return;
  };
  return DataFormatMixin2;
}();
function normalizeTooltipFormatResult(result) {
  var markupText;
  var markupFragment;
  if (isObject$4(result)) {
    if (result.type) {
      markupFragment = result;
    }
  } else {
    markupText = result;
  }
  return {
    text: markupText,
    frag: markupFragment
  };
}
function createTask(define) {
  return new Task(define);
}
var Task = function() {
  function Task2(define) {
    define = define || {};
    this._reset = define.reset;
    this._plan = define.plan;
    this._count = define.count;
    this._onDirty = define.onDirty;
    this._dirty = true;
  }
  Task2.prototype.perform = function(performArgs) {
    var upTask = this._upstream;
    var skip = performArgs && performArgs.skip;
    if (this._dirty && upTask) {
      var context = this.context;
      context.data = context.outputData = upTask.context.outputData;
    }
    if (this.__pipeline) {
      this.__pipeline.currentTask = this;
    }
    var planResult;
    if (this._plan && !skip) {
      planResult = this._plan(this.context);
    }
    var lastModBy = normalizeModBy(this._modBy);
    var lastModDataCount = this._modDataCount || 0;
    var modBy = normalizeModBy(performArgs && performArgs.modBy);
    var modDataCount = performArgs && performArgs.modDataCount || 0;
    if (lastModBy !== modBy || lastModDataCount !== modDataCount) {
      planResult = "reset";
    }
    function normalizeModBy(val) {
      !(val >= 1) && (val = 1);
      return val;
    }
    var forceFirstProgress;
    if (this._dirty || planResult === "reset") {
      this._dirty = false;
      forceFirstProgress = this._doReset(skip);
    }
    this._modBy = modBy;
    this._modDataCount = modDataCount;
    var step = performArgs && performArgs.step;
    if (upTask) {
      this._dueEnd = upTask._outputDueEnd;
    } else {
      this._dueEnd = this._count ? this._count(this.context) : Infinity;
    }
    if (this._progress) {
      var start2 = this._dueIndex;
      var end2 = Math.min(step != null ? this._dueIndex + step : Infinity, this._dueEnd);
      if (!skip && (forceFirstProgress || start2 < end2)) {
        var progress = this._progress;
        if (isArray$1(progress)) {
          for (var i = 0; i < progress.length; i++) {
            this._doProgress(progress[i], start2, end2, modBy, modDataCount);
          }
        } else {
          this._doProgress(progress, start2, end2, modBy, modDataCount);
        }
      }
      this._dueIndex = end2;
      var outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : end2;
      this._outputDueEnd = outputDueEnd;
    } else {
      this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
    }
    return this.unfinished();
  };
  Task2.prototype.dirty = function() {
    this._dirty = true;
    this._onDirty && this._onDirty(this.context);
  };
  Task2.prototype._doProgress = function(progress, start2, end2, modBy, modDataCount) {
    iterator.reset(start2, end2, modBy, modDataCount);
    this._callingProgress = progress;
    this._callingProgress({
      start: start2,
      end: end2,
      count: end2 - start2,
      next: iterator.next
    }, this.context);
  };
  Task2.prototype._doReset = function(skip) {
    this._dueIndex = this._outputDueEnd = this._dueEnd = 0;
    this._settedOutputEnd = null;
    var progress;
    var forceFirstProgress;
    if (!skip && this._reset) {
      progress = this._reset(this.context);
      if (progress && progress.progress) {
        forceFirstProgress = progress.forceFirstProgress;
        progress = progress.progress;
      }
      if (isArray$1(progress) && !progress.length) {
        progress = null;
      }
    }
    this._progress = progress;
    this._modBy = this._modDataCount = null;
    var downstream = this._downstream;
    downstream && downstream.dirty();
    return forceFirstProgress;
  };
  Task2.prototype.unfinished = function() {
    return this._progress && this._dueIndex < this._dueEnd;
  };
  Task2.prototype.pipe = function(downTask) {
    if (this._downstream !== downTask || this._dirty) {
      this._downstream = downTask;
      downTask._upstream = this;
      downTask.dirty();
    }
  };
  Task2.prototype.dispose = function() {
    if (this._disposed) {
      return;
    }
    this._upstream && (this._upstream._downstream = null);
    this._downstream && (this._downstream._upstream = null);
    this._dirty = false;
    this._disposed = true;
  };
  Task2.prototype.getUpstream = function() {
    return this._upstream;
  };
  Task2.prototype.getDownstream = function() {
    return this._downstream;
  };
  Task2.prototype.setOutputEnd = function(end2) {
    this._outputDueEnd = this._settedOutputEnd = end2;
  };
  return Task2;
}();
var iterator = function() {
  var end2;
  var current;
  var modBy;
  var modDataCount;
  var winCount;
  var it = {
    reset: function(s, e2, sStep, sCount) {
      current = s;
      end2 = e2;
      modBy = sStep;
      modDataCount = sCount;
      winCount = Math.ceil(modDataCount / modBy);
      it.next = modBy > 1 && modDataCount > 0 ? modNext : sequentialNext;
    }
  };
  return it;
  function sequentialNext() {
    return current < end2 ? current++ : null;
  }
  function modNext() {
    var dataIndex = current % winCount * modBy + Math.ceil(current / winCount);
    var result = current >= end2 ? null : dataIndex < modDataCount ? dataIndex : current;
    current++;
    return result;
  }
}();
function parseDataValue(value, opt) {
  var dimType = opt && opt.type;
  if (dimType === "ordinal") {
    return value;
  }
  if (dimType === "time" && !isNumber(value) && value != null && value !== "-") {
    value = +parseDate(value);
  }
  return value == null || value === "" ? NaN : +value;
}
var valueParserMap = createHashMap({
  "number": function(val) {
    return parseFloat(val);
  },
  "time": function(val) {
    return +parseDate(val);
  },
  "trim": function(val) {
    return isString(val) ? trim$1(val) : val;
  }
});
function getRawValueParser(type4) {
  return valueParserMap.get(type4);
}
var ORDER_COMPARISON_OP_MAP = {
  lt: function(lval, rval) {
    return lval < rval;
  },
  lte: function(lval, rval) {
    return lval <= rval;
  },
  gt: function(lval, rval) {
    return lval > rval;
  },
  gte: function(lval, rval) {
    return lval >= rval;
  }
};
var FilterOrderComparator = function() {
  function FilterOrderComparator2(op, rval) {
    if (!isNumber(rval)) {
      var errMsg = "";
      throwError(errMsg);
    }
    this._opFn = ORDER_COMPARISON_OP_MAP[op];
    this._rvalFloat = numericToNumber(rval);
  }
  FilterOrderComparator2.prototype.evaluate = function(lval) {
    return isNumber(lval) ? this._opFn(lval, this._rvalFloat) : this._opFn(numericToNumber(lval), this._rvalFloat);
  };
  return FilterOrderComparator2;
}();
var SortOrderComparator = function() {
  function SortOrderComparator2(order, incomparable) {
    var isDesc = order === "desc";
    this._resultLT = isDesc ? 1 : -1;
    if (incomparable == null) {
      incomparable = isDesc ? "min" : "max";
    }
    this._incomparable = incomparable === "min" ? -Infinity : Infinity;
  }
  SortOrderComparator2.prototype.evaluate = function(lval, rval) {
    var lvalFloat = isNumber(lval) ? lval : numericToNumber(lval);
    var rvalFloat = isNumber(rval) ? rval : numericToNumber(rval);
    var lvalNotNumeric = isNaN(lvalFloat);
    var rvalNotNumeric = isNaN(rvalFloat);
    if (lvalNotNumeric) {
      lvalFloat = this._incomparable;
    }
    if (rvalNotNumeric) {
      rvalFloat = this._incomparable;
    }
    if (lvalNotNumeric && rvalNotNumeric) {
      var lvalIsStr = isString(lval);
      var rvalIsStr = isString(rval);
      if (lvalIsStr) {
        lvalFloat = rvalIsStr ? lval : 0;
      }
      if (rvalIsStr) {
        rvalFloat = lvalIsStr ? rval : 0;
      }
    }
    return lvalFloat < rvalFloat ? this._resultLT : lvalFloat > rvalFloat ? -this._resultLT : 0;
  };
  return SortOrderComparator2;
}();
var FilterEqualityComparator = function() {
  function FilterEqualityComparator2(isEq, rval) {
    this._rval = rval;
    this._isEQ = isEq;
    this._rvalTypeof = typeof rval;
    this._rvalFloat = numericToNumber(rval);
  }
  FilterEqualityComparator2.prototype.evaluate = function(lval) {
    var eqResult = lval === this._rval;
    if (!eqResult) {
      var lvalTypeof = typeof lval;
      if (lvalTypeof !== this._rvalTypeof && (lvalTypeof === "number" || this._rvalTypeof === "number")) {
        eqResult = numericToNumber(lval) === this._rvalFloat;
      }
    }
    return this._isEQ ? eqResult : !eqResult;
  };
  return FilterEqualityComparator2;
}();
function createFilterComparator(op, rval) {
  return op === "eq" || op === "ne" ? new FilterEqualityComparator(op === "eq", rval) : hasOwn(ORDER_COMPARISON_OP_MAP, op) ? new FilterOrderComparator(op, rval) : null;
}
var ExternalSource = function() {
  function ExternalSource2() {
  }
  ExternalSource2.prototype.getRawData = function() {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.getRawDataItem = function(dataIndex) {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.cloneRawData = function() {
    return;
  };
  ExternalSource2.prototype.getDimensionInfo = function(dim) {
    return;
  };
  ExternalSource2.prototype.cloneAllDimensionInfo = function() {
    return;
  };
  ExternalSource2.prototype.count = function() {
    return;
  };
  ExternalSource2.prototype.retrieveValue = function(dataIndex, dimIndex) {
    return;
  };
  ExternalSource2.prototype.retrieveValueFromItem = function(dataItem, dimIndex) {
    return;
  };
  ExternalSource2.prototype.convertValue = function(rawVal, dimInfo) {
    return parseDataValue(rawVal, dimInfo);
  };
  return ExternalSource2;
}();
function createExternalSource(internalSource, externalTransform) {
  var extSource = new ExternalSource();
  var data = internalSource.data;
  var sourceFormat = extSource.sourceFormat = internalSource.sourceFormat;
  var sourceHeaderCount = internalSource.startIndex;
  var errMsg = "";
  if (internalSource.seriesLayoutBy !== SERIES_LAYOUT_BY_COLUMN) {
    throwError(errMsg);
  }
  var dimensions = [];
  var dimsByName = {};
  var dimsDef = internalSource.dimensionsDefine;
  if (dimsDef) {
    each$f(dimsDef, function(dimDef, idx) {
      var name = dimDef.name;
      var dimDefExt = {
        index: idx,
        name,
        displayName: dimDef.displayName
      };
      dimensions.push(dimDefExt);
      if (name != null) {
        var errMsg_1 = "";
        if (hasOwn(dimsByName, name)) {
          throwError(errMsg_1);
        }
        dimsByName[name] = dimDefExt;
      }
    });
  } else {
    for (var i = 0; i < internalSource.dimensionsDetectedCount || 0; i++) {
      dimensions.push({
        index: i
      });
    }
  }
  var rawItemGetter = getRawSourceItemGetter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  if (externalTransform.__isBuiltIn) {
    extSource.getRawDataItem = function(dataIndex) {
      return rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    };
    extSource.getRawData = bind$1(getRawData, null, internalSource);
  }
  extSource.cloneRawData = bind$1(cloneRawData, null, internalSource);
  var rawCounter = getRawSourceDataCounter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  extSource.count = bind$1(rawCounter, null, data, sourceHeaderCount, dimensions);
  var rawValueGetter = getRawSourceValueGetter(sourceFormat);
  extSource.retrieveValue = function(dataIndex, dimIndex) {
    var rawItem = rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    return retrieveValueFromItem(rawItem, dimIndex);
  };
  var retrieveValueFromItem = extSource.retrieveValueFromItem = function(dataItem, dimIndex) {
    if (dataItem == null) {
      return;
    }
    var dimDef = dimensions[dimIndex];
    if (dimDef) {
      return rawValueGetter(dataItem, dimIndex, dimDef.name);
    }
  };
  extSource.getDimensionInfo = bind$1(getDimensionInfo, null, dimensions, dimsByName);
  extSource.cloneAllDimensionInfo = bind$1(cloneAllDimensionInfo, null, dimensions);
  return extSource;
}
function getRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  return upstream.data;
}
function cloneRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  var data = upstream.data;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(data[i].slice());
    }
    return result;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(extend({}, data[i]));
    }
    return result;
  }
}
function getDimensionInfo(dimensions, dimsByName, dim) {
  if (dim == null) {
    return;
  }
  if (isNumber(dim) || !isNaN(dim) && !hasOwn(dimsByName, dim)) {
    return dimensions[dim];
  } else if (hasOwn(dimsByName, dim)) {
    return dimsByName[dim];
  }
}
function cloneAllDimensionInfo(dimensions) {
  return clone$4(dimensions);
}
var externalTransformMap = createHashMap();
function registerExternalTransform(externalTransform) {
  externalTransform = clone$4(externalTransform);
  var type4 = externalTransform.type;
  var errMsg = "";
  if (!type4) {
    throwError(errMsg);
  }
  var typeParsed = type4.split(":");
  if (typeParsed.length !== 2) {
    throwError(errMsg);
  }
  var isBuiltIn = false;
  if (typeParsed[0] === "echarts") {
    type4 = typeParsed[1];
    isBuiltIn = true;
  }
  externalTransform.__isBuiltIn = isBuiltIn;
  externalTransformMap.set(type4, externalTransform);
}
function applyDataTransform(rawTransOption, sourceList, infoForPrint) {
  var pipedTransOption = normalizeToArray(rawTransOption);
  var pipeLen = pipedTransOption.length;
  var errMsg = "";
  if (!pipeLen) {
    throwError(errMsg);
  }
  for (var i = 0, len2 = pipeLen; i < len2; i++) {
    var transOption = pipedTransOption[i];
    sourceList = applySingleDataTransform(transOption, sourceList);
    if (i !== len2 - 1) {
      sourceList.length = Math.max(sourceList.length, 1);
    }
  }
  return sourceList;
}
function applySingleDataTransform(transOption, upSourceList, infoForPrint, pipeIndex) {
  var errMsg = "";
  if (!upSourceList.length) {
    throwError(errMsg);
  }
  if (!isObject$4(transOption)) {
    throwError(errMsg);
  }
  var transType = transOption.type;
  var externalTransform = externalTransformMap.get(transType);
  if (!externalTransform) {
    throwError(errMsg);
  }
  var extUpSourceList = map$1(upSourceList, function(upSource) {
    return createExternalSource(upSource, externalTransform);
  });
  var resultList = normalizeToArray(externalTransform.transform({
    upstream: extUpSourceList[0],
    upstreamList: extUpSourceList,
    config: clone$4(transOption.config)
  }));
  return map$1(resultList, function(result, resultIndex) {
    var errMsg2 = "";
    if (!isObject$4(result)) {
      throwError(errMsg2);
    }
    if (!result.data) {
      throwError(errMsg2);
    }
    var sourceFormat = detectSourceFormat(result.data);
    if (!isSupportedSourceFormat(sourceFormat)) {
      throwError(errMsg2);
    }
    var resultMetaRawOption;
    var firstUpSource = upSourceList[0];
    if (firstUpSource && resultIndex === 0 && !result.dimensions) {
      var startIndex = firstUpSource.startIndex;
      if (startIndex) {
        result.data = firstUpSource.data.slice(0, startIndex).concat(result.data);
      }
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: startIndex,
        dimensions: firstUpSource.metaRawOption.dimensions
      };
    } else {
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: 0,
        dimensions: result.dimensions
      };
    }
    return createSource(result.data, resultMetaRawOption, null);
  });
}
function isSupportedSourceFormat(sourceFormat) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS || sourceFormat === SOURCE_FORMAT_OBJECT_ROWS;
}
var UNDEFINED = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED ? Array : Uint16Array;
var CtorInt32Array$1 = typeof Int32Array === UNDEFINED ? Array : Int32Array;
var CtorFloat64Array = typeof Float64Array === UNDEFINED ? Array : Float64Array;
var dataCtors = {
  "float": CtorFloat64Array,
  "int": CtorInt32Array$1,
  "ordinal": Array,
  "number": Array,
  "time": CtorFloat64Array
};
var defaultDimValueGetters;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function getInitialExtent() {
  return [Infinity, -Infinity];
}
function cloneChunk(originalChunk) {
  var Ctor = originalChunk.constructor;
  return Ctor === Array ? originalChunk.slice() : new Ctor(originalChunk);
}
function prepareStore(store, dimIdx, dimType, end2, append) {
  var DataCtor = dataCtors[dimType || "float"];
  if (append) {
    var oldStore = store[dimIdx];
    var oldLen = oldStore && oldStore.length;
    if (!(oldLen === end2)) {
      var newStore = new DataCtor(end2);
      for (var j = 0; j < oldLen; j++) {
        newStore[j] = oldStore[j];
      }
      store[dimIdx] = newStore;
    }
  } else {
    store[dimIdx] = new DataCtor(end2);
  }
}
var DataStore = function() {
  function DataStore2() {
    this._chunks = [];
    this._rawExtent = [];
    this._extent = [];
    this._count = 0;
    this._rawCount = 0;
    this._calcDimNameToIdx = createHashMap();
  }
  DataStore2.prototype.initData = function(provider, inputDimensions, dimValueGetter) {
    this._provider = provider;
    this._chunks = [];
    this._indices = null;
    this.getRawIndex = this._getRawIdxIdentity;
    var source = provider.getSource();
    var defaultGetter = this.defaultDimValueGetter = defaultDimValueGetters[source.sourceFormat];
    this._dimValueGetter = dimValueGetter || defaultGetter;
    this._rawExtent = [];
    shouldRetrieveDataByName(source);
    this._dimensions = map$1(inputDimensions, function(dim) {
      return {
        type: dim.type,
        property: dim.property
      };
    });
    this._initDataFromProvider(0, provider.count());
  };
  DataStore2.prototype.getProvider = function() {
    return this._provider;
  };
  DataStore2.prototype.getSource = function() {
    return this._provider.getSource();
  };
  DataStore2.prototype.ensureCalculationDimension = function(dimName, type4) {
    var calcDimNameToIdx = this._calcDimNameToIdx;
    var dimensions = this._dimensions;
    var calcDimIdx = calcDimNameToIdx.get(dimName);
    if (calcDimIdx != null) {
      if (dimensions[calcDimIdx].type === type4) {
        return calcDimIdx;
      }
    } else {
      calcDimIdx = dimensions.length;
    }
    dimensions[calcDimIdx] = {
      type: type4
    };
    calcDimNameToIdx.set(dimName, calcDimIdx);
    this._chunks[calcDimIdx] = new dataCtors[type4 || "float"](this._rawCount);
    this._rawExtent[calcDimIdx] = getInitialExtent();
    return calcDimIdx;
  };
  DataStore2.prototype.collectOrdinalMeta = function(dimIdx, ordinalMeta) {
    var chunk = this._chunks[dimIdx];
    var dim = this._dimensions[dimIdx];
    var rawExtents = this._rawExtent;
    var offset = dim.ordinalOffset || 0;
    var len2 = chunk.length;
    if (offset === 0) {
      rawExtents[dimIdx] = getInitialExtent();
    }
    var dimRawExtent = rawExtents[dimIdx];
    for (var i = offset; i < len2; i++) {
      var val = chunk[i] = ordinalMeta.parseAndCollect(chunk[i]);
      dimRawExtent[0] = Math.min(val, dimRawExtent[0]);
      dimRawExtent[1] = Math.max(val, dimRawExtent[1]);
    }
    dim.ordinalMeta = ordinalMeta;
    dim.ordinalOffset = len2;
    dim.type = "ordinal";
  };
  DataStore2.prototype.getOrdinalMeta = function(dimIdx) {
    var dimInfo = this._dimensions[dimIdx];
    var ordinalMeta = dimInfo.ordinalMeta;
    return ordinalMeta;
  };
  DataStore2.prototype.getDimensionProperty = function(dimIndex) {
    var item = this._dimensions[dimIndex];
    return item && item.property;
  };
  DataStore2.prototype.appendData = function(data) {
    var provider = this._provider;
    var start2 = this.count();
    provider.appendData(data);
    var end2 = provider.count();
    if (!provider.persistent) {
      end2 += start2;
    }
    if (start2 < end2) {
      this._initDataFromProvider(start2, end2, true);
    }
    return [start2, end2];
  };
  DataStore2.prototype.appendValues = function(values, minFillLen) {
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var start2 = this.count();
    var end2 = start2 + Math.max(values.length, minFillLen || 0);
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      prepareStore(chunks, i, dim.type, end2, true);
    }
    var emptyDataItem = [];
    for (var idx = start2; idx < end2; idx++) {
      var sourceIdx = idx - start2;
      for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
        var dim = dimensions[dimIdx];
        var val = defaultDimValueGetters.arrayRows.call(this, values[sourceIdx] || emptyDataItem, dim.property, sourceIdx, dimIdx);
        chunks[dimIdx][idx] = val;
        var dimRawExtent = rawExtent[dimIdx];
        val < dimRawExtent[0] && (dimRawExtent[0] = val);
        val > dimRawExtent[1] && (dimRawExtent[1] = val);
      }
    }
    this._rawCount = this._count = end2;
    return {
      start: start2,
      end: end2
    };
  };
  DataStore2.prototype._initDataFromProvider = function(start2, end2, append) {
    var provider = this._provider;
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var dimNames = map$1(dimensions, function(dim2) {
      return dim2.property;
    });
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      if (!rawExtent[i]) {
        rawExtent[i] = getInitialExtent();
      }
      prepareStore(chunks, i, dim.type, end2, append);
    }
    if (provider.fillStorage) {
      provider.fillStorage(start2, end2, chunks, rawExtent);
    } else {
      var dataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        dataItem = provider.getItem(idx, dataItem);
        for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
          var dimStorage = chunks[dimIdx];
          var val = this._dimValueGetter(dataItem, dimNames[dimIdx], idx, dimIdx);
          dimStorage[idx] = val;
          var dimRawExtent = rawExtent[dimIdx];
          val < dimRawExtent[0] && (dimRawExtent[0] = val);
          val > dimRawExtent[1] && (dimRawExtent[1] = val);
        }
      }
    }
    if (!provider.persistent && provider.clean) {
      provider.clean();
    }
    this._rawCount = this._count = end2;
    this._extent = [];
  };
  DataStore2.prototype.count = function() {
    return this._count;
  };
  DataStore2.prototype.get = function(dim, idx) {
    if (!(idx >= 0 && idx < this._count)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[this.getRawIndex(idx)] : NaN;
  };
  DataStore2.prototype.getValues = function(dimensions, idx) {
    var values = [];
    var dimArr = [];
    if (idx == null) {
      idx = dimensions;
      dimensions = [];
      for (var i = 0; i < this._dimensions.length; i++) {
        dimArr.push(i);
      }
    } else {
      dimArr = dimensions;
    }
    for (var i = 0, len2 = dimArr.length; i < len2; i++) {
      values.push(this.get(dimArr[i], idx));
    }
    return values;
  };
  DataStore2.prototype.getByRawIndex = function(dim, rawIdx) {
    if (!(rawIdx >= 0 && rawIdx < this._rawCount)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[rawIdx] : NaN;
  };
  DataStore2.prototype.getSum = function(dim) {
    var dimData = this._chunks[dim];
    var sum2 = 0;
    if (dimData) {
      for (var i = 0, len2 = this.count(); i < len2; i++) {
        var value = this.get(dim, i);
        if (!isNaN(value)) {
          sum2 += value;
        }
      }
    }
    return sum2;
  };
  DataStore2.prototype.getMedian = function(dim) {
    var dimDataArray = [];
    this.each([dim], function(val) {
      if (!isNaN(val)) {
        dimDataArray.push(val);
      }
    });
    var sortedDimDataArray = dimDataArray.sort(function(a, b2) {
      return a - b2;
    });
    var len2 = this.count();
    return len2 === 0 ? 0 : len2 % 2 === 1 ? sortedDimDataArray[(len2 - 1) / 2] : (sortedDimDataArray[len2 / 2] + sortedDimDataArray[len2 / 2 - 1]) / 2;
  };
  DataStore2.prototype.indexOfRawIndex = function(rawIndex) {
    if (rawIndex >= this._rawCount || rawIndex < 0) {
      return -1;
    }
    if (!this._indices) {
      return rawIndex;
    }
    var indices = this._indices;
    var rawDataIndex = indices[rawIndex];
    if (rawDataIndex != null && rawDataIndex < this._count && rawDataIndex === rawIndex) {
      return rawIndex;
    }
    var left = 0;
    var right = this._count - 1;
    while (left <= right) {
      var mid = (left + right) / 2 | 0;
      if (indices[mid] < rawIndex) {
        left = mid + 1;
      } else if (indices[mid] > rawIndex) {
        right = mid - 1;
      } else {
        return mid;
      }
    }
    return -1;
  };
  DataStore2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    var chunks = this._chunks;
    var dimData = chunks[dim];
    var nearestIndices = [];
    if (!dimData) {
      return nearestIndices;
    }
    if (maxDistance == null) {
      maxDistance = Infinity;
    }
    var minDist = Infinity;
    var minDiff = -1;
    var nearestIndicesLen = 0;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var dataIndex = this.getRawIndex(i);
      var diff = value - dimData[dataIndex];
      var dist2 = Math.abs(diff);
      if (dist2 <= maxDistance) {
        if (dist2 < minDist || dist2 === minDist && diff >= 0 && minDiff < 0) {
          minDist = dist2;
          minDiff = diff;
          nearestIndicesLen = 0;
        }
        if (diff === minDiff) {
          nearestIndices[nearestIndicesLen++] = i;
        }
      }
    }
    nearestIndices.length = nearestIndicesLen;
    return nearestIndices;
  };
  DataStore2.prototype.getIndices = function() {
    var newIndices;
    var indices = this._indices;
    if (indices) {
      var Ctor = indices.constructor;
      var thisCount = this._count;
      if (Ctor === Array) {
        newIndices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          newIndices[i] = indices[i];
        }
      } else {
        newIndices = new Ctor(indices.buffer, 0, thisCount);
      }
    } else {
      var Ctor = getIndicesCtor(this._rawCount);
      newIndices = new Ctor(this.count());
      for (var i = 0; i < newIndices.length; i++) {
        newIndices[i] = i;
      }
    }
    return newIndices;
  };
  DataStore2.prototype.filter = function(dims, cb) {
    if (!this._count) {
      return this;
    }
    var newStore = this.clone();
    var count2 = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(count2);
    var value = [];
    var dimSize = dims.length;
    var offset = 0;
    var dim0 = dims[0];
    var chunks = newStore._chunks;
    for (var i = 0; i < count2; i++) {
      var keep = void 0;
      var rawIdx = newStore.getRawIndex(i);
      if (dimSize === 0) {
        keep = cb(i);
      } else if (dimSize === 1) {
        var val = chunks[dim0][rawIdx];
        keep = cb(val, i);
      } else {
        var k2 = 0;
        for (; k2 < dimSize; k2++) {
          value[k2] = chunks[dims[k2]][rawIdx];
        }
        value[k2] = i;
        keep = cb.apply(null, value);
      }
      if (keep) {
        newIndices[offset++] = rawIdx;
      }
    }
    if (offset < count2) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.selectRange = function(range3) {
    var newStore = this.clone();
    var len2 = newStore._count;
    if (!len2) {
      return this;
    }
    var dims = keys(range3);
    var dimSize = dims.length;
    if (!dimSize) {
      return this;
    }
    var originalCount = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(originalCount);
    var offset = 0;
    var dim0 = dims[0];
    var min3 = range3[dim0][0];
    var max3 = range3[dim0][1];
    var storeArr = newStore._chunks;
    var quickFinished = false;
    if (!newStore._indices) {
      var idx = 0;
      if (dimSize === 1) {
        var dimStorage = storeArr[dims[0]];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      } else if (dimSize === 2) {
        var dimStorage = storeArr[dims[0]];
        var dimStorage2 = storeArr[dims[1]];
        var min22 = range3[dims[1]][0];
        var max22 = range3[dims[1]][1];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          var val2 = dimStorage2[i];
          if ((val >= min3 && val <= max3 || isNaN(val)) && (val2 >= min22 && val2 <= max22 || isNaN(val2))) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      }
    }
    if (!quickFinished) {
      if (dimSize === 1) {
        for (var i = 0; i < originalCount; i++) {
          var rawIndex = newStore.getRawIndex(i);
          var val = storeArr[dims[0]][rawIndex];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = rawIndex;
          }
        }
      } else {
        for (var i = 0; i < originalCount; i++) {
          var keep = true;
          var rawIndex = newStore.getRawIndex(i);
          for (var k2 = 0; k2 < dimSize; k2++) {
            var dimk = dims[k2];
            var val = storeArr[dimk][rawIndex];
            if (val < range3[dimk][0] || val > range3[dimk][1]) {
              keep = false;
            }
          }
          if (keep) {
            newIndices[offset++] = newStore.getRawIndex(i);
          }
        }
      }
    }
    if (offset < originalCount) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.map = function(dims, cb) {
    var target = this.clone(dims);
    this._updateDims(target, dims, cb);
    return target;
  };
  DataStore2.prototype.modify = function(dims, cb) {
    this._updateDims(this, dims, cb);
  };
  DataStore2.prototype._updateDims = function(target, dims, cb) {
    var targetChunks = target._chunks;
    var tmpRetValue = [];
    var dimSize = dims.length;
    var dataCount = target.count();
    var values = [];
    var rawExtent = target._rawExtent;
    for (var i = 0; i < dims.length; i++) {
      rawExtent[dims[i]] = getInitialExtent();
    }
    for (var dataIndex = 0; dataIndex < dataCount; dataIndex++) {
      var rawIndex = target.getRawIndex(dataIndex);
      for (var k2 = 0; k2 < dimSize; k2++) {
        values[k2] = targetChunks[dims[k2]][rawIndex];
      }
      values[dimSize] = dataIndex;
      var retValue = cb && cb.apply(null, values);
      if (retValue != null) {
        if (typeof retValue !== "object") {
          tmpRetValue[0] = retValue;
          retValue = tmpRetValue;
        }
        for (var i = 0; i < retValue.length; i++) {
          var dim = dims[i];
          var val = retValue[i];
          var rawExtentOnDim = rawExtent[dim];
          var dimStore = targetChunks[dim];
          if (dimStore) {
            dimStore[rawIndex] = val;
          }
          if (val < rawExtentOnDim[0]) {
            rawExtentOnDim[0] = val;
          }
          if (val > rawExtentOnDim[1]) {
            rawExtentOnDim[1] = val;
          }
        }
      }
    }
  };
  DataStore2.prototype.lttbDownSample = function(valueDimension, rate) {
    var target = this.clone([valueDimension], true);
    var targetStorage = target._chunks;
    var dimStore = targetStorage[valueDimension];
    var len2 = this.count();
    var sampledIndex = 0;
    var frameSize = Math.floor(1 / rate);
    var currentRawIndex = this.getRawIndex(0);
    var maxArea;
    var area;
    var nextRawIndex;
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.min((Math.ceil(len2 / frameSize) + 2) * 2, len2));
    newIndices[sampledIndex++] = currentRawIndex;
    for (var i = 1; i < len2 - 1; i += frameSize) {
      var nextFrameStart = Math.min(i + frameSize, len2 - 1);
      var nextFrameEnd = Math.min(i + frameSize * 2, len2);
      var avgX = (nextFrameEnd + nextFrameStart) / 2;
      var avgY = 0;
      for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          continue;
        }
        avgY += y2;
      }
      avgY /= nextFrameEnd - nextFrameStart;
      var frameStart = i;
      var frameEnd = Math.min(i + frameSize, len2);
      var pointAX = i - 1;
      var pointAY = dimStore[currentRawIndex];
      maxArea = -1;
      nextRawIndex = frameStart;
      var firstNaNIndex = -1;
      var countNaN = 0;
      for (var idx = frameStart; idx < frameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          countNaN++;
          if (firstNaNIndex < 0) {
            firstNaNIndex = rawIndex;
          }
          continue;
        }
        area = Math.abs((pointAX - avgX) * (y2 - pointAY) - (pointAX - idx) * (avgY - pointAY));
        if (area > maxArea) {
          maxArea = area;
          nextRawIndex = rawIndex;
        }
      }
      if (countNaN > 0 && countNaN < frameEnd - frameStart) {
        newIndices[sampledIndex++] = Math.min(firstNaNIndex, nextRawIndex);
        nextRawIndex = Math.max(firstNaNIndex, nextRawIndex);
      }
      newIndices[sampledIndex++] = nextRawIndex;
      currentRawIndex = nextRawIndex;
    }
    newIndices[sampledIndex++] = this.getRawIndex(len2 - 1);
    target._count = sampledIndex;
    target._indices = newIndices;
    target.getRawIndex = this._getRawIdx;
    return target;
  };
  DataStore2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var target = this.clone([dimension], true);
    var targetStorage = target._chunks;
    var frameValues = [];
    var frameSize = Math.floor(1 / rate);
    var dimStore = targetStorage[dimension];
    var len2 = this.count();
    var rawExtentOnDim = target._rawExtent[dimension] = getInitialExtent();
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.ceil(len2 / frameSize));
    var offset = 0;
    for (var i = 0; i < len2; i += frameSize) {
      if (frameSize > len2 - i) {
        frameSize = len2 - i;
        frameValues.length = frameSize;
      }
      for (var k2 = 0; k2 < frameSize; k2++) {
        var dataIdx = this.getRawIndex(i + k2);
        frameValues[k2] = dimStore[dataIdx];
      }
      var value = sampleValue(frameValues);
      var sampleFrameIdx = this.getRawIndex(Math.min(i + sampleIndex(frameValues, value) || 0, len2 - 1));
      dimStore[sampleFrameIdx] = value;
      if (value < rawExtentOnDim[0]) {
        rawExtentOnDim[0] = value;
      }
      if (value > rawExtentOnDim[1]) {
        rawExtentOnDim[1] = value;
      }
      newIndices[offset++] = sampleFrameIdx;
    }
    target._count = offset;
    target._indices = newIndices;
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype.each = function(dims, cb) {
    if (!this._count) {
      return;
    }
    var dimSize = dims.length;
    var chunks = this._chunks;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var rawIdx = this.getRawIndex(i);
      switch (dimSize) {
        case 0:
          cb(i);
          break;
        case 1:
          cb(chunks[dims[0]][rawIdx], i);
          break;
        case 2:
          cb(chunks[dims[0]][rawIdx], chunks[dims[1]][rawIdx], i);
          break;
        default:
          var k2 = 0;
          var value = [];
          for (; k2 < dimSize; k2++) {
            value[k2] = chunks[dims[k2]][rawIdx];
          }
          value[k2] = i;
          cb.apply(null, value);
      }
    }
  };
  DataStore2.prototype.getDataExtent = function(dim) {
    var dimData = this._chunks[dim];
    var initialExtent = getInitialExtent();
    if (!dimData) {
      return initialExtent;
    }
    var currEnd = this.count();
    var useRaw = !this._indices;
    var dimExtent;
    if (useRaw) {
      return this._rawExtent[dim].slice();
    }
    dimExtent = this._extent[dim];
    if (dimExtent) {
      return dimExtent.slice();
    }
    dimExtent = initialExtent;
    var min3 = dimExtent[0];
    var max3 = dimExtent[1];
    for (var i = 0; i < currEnd; i++) {
      var rawIdx = this.getRawIndex(i);
      var value = dimData[rawIdx];
      value < min3 && (min3 = value);
      value > max3 && (max3 = value);
    }
    dimExtent = [min3, max3];
    this._extent[dim] = dimExtent;
    return dimExtent;
  };
  DataStore2.prototype.getRawDataItem = function(idx) {
    var rawIdx = this.getRawIndex(idx);
    if (!this._provider.persistent) {
      var val = [];
      var chunks = this._chunks;
      for (var i = 0; i < chunks.length; i++) {
        val.push(chunks[i][rawIdx]);
      }
      return val;
    } else {
      return this._provider.getItem(rawIdx);
    }
  };
  DataStore2.prototype.clone = function(clonedDims, ignoreIndices) {
    var target = new DataStore2();
    var chunks = this._chunks;
    var clonedDimsMap = clonedDims && reduce(clonedDims, function(obj, dimIdx) {
      obj[dimIdx] = true;
      return obj;
    }, {});
    if (clonedDimsMap) {
      for (var i = 0; i < chunks.length; i++) {
        target._chunks[i] = !clonedDimsMap[i] ? chunks[i] : cloneChunk(chunks[i]);
      }
    } else {
      target._chunks = chunks;
    }
    this._copyCommonProps(target);
    if (!ignoreIndices) {
      target._indices = this._cloneIndices();
    }
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype._copyCommonProps = function(target) {
    target._count = this._count;
    target._rawCount = this._rawCount;
    target._provider = this._provider;
    target._dimensions = this._dimensions;
    target._extent = clone$4(this._extent);
    target._rawExtent = clone$4(this._rawExtent);
  };
  DataStore2.prototype._cloneIndices = function() {
    if (this._indices) {
      var Ctor = this._indices.constructor;
      var indices = void 0;
      if (Ctor === Array) {
        var thisCount = this._indices.length;
        indices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          indices[i] = this._indices[i];
        }
      } else {
        indices = new Ctor(this._indices);
      }
      return indices;
    }
    return null;
  };
  DataStore2.prototype._getRawIdxIdentity = function(idx) {
    return idx;
  };
  DataStore2.prototype._getRawIdx = function(idx) {
    if (idx < this._count && idx >= 0) {
      return this._indices[idx];
    }
    return -1;
  };
  DataStore2.prototype._updateGetRawIdx = function() {
    this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
  };
  DataStore2.internalField = function() {
    function getDimValueSimply(dataItem, property, dataIndex, dimIndex) {
      return parseDataValue(dataItem[dimIndex], this._dimensions[dimIndex]);
    }
    defaultDimValueGetters = {
      arrayRows: getDimValueSimply,
      objectRows: function(dataItem, property, dataIndex, dimIndex) {
        return parseDataValue(dataItem[property], this._dimensions[dimIndex]);
      },
      keyedColumns: getDimValueSimply,
      original: function(dataItem, property, dataIndex, dimIndex) {
        var value = dataItem && (dataItem.value == null ? dataItem : dataItem.value);
        return parseDataValue(value instanceof Array ? value[dimIndex] : value, this._dimensions[dimIndex]);
      },
      typedArray: function(dataItem, property, dataIndex, dimIndex) {
        return dataItem[dimIndex];
      }
    };
  }();
  return DataStore2;
}();
var SourceManager = function() {
  function SourceManager2(sourceHost) {
    this._sourceList = [];
    this._storeList = [];
    this._upstreamSignList = [];
    this._versionSignBase = 0;
    this._dirty = true;
    this._sourceHost = sourceHost;
  }
  SourceManager2.prototype.dirty = function() {
    this._setLocalSource([], []);
    this._storeList = [];
    this._dirty = true;
  };
  SourceManager2.prototype._setLocalSource = function(sourceList, upstreamSignList) {
    this._sourceList = sourceList;
    this._upstreamSignList = upstreamSignList;
    this._versionSignBase++;
    if (this._versionSignBase > 9e10) {
      this._versionSignBase = 0;
    }
  };
  SourceManager2.prototype._getVersionSign = function() {
    return this._sourceHost.uid + "_" + this._versionSignBase;
  };
  SourceManager2.prototype.prepareSource = function() {
    if (this._isDirty()) {
      this._createSource();
      this._dirty = false;
    }
  };
  SourceManager2.prototype._createSource = function() {
    this._setLocalSource([], []);
    var sourceHost = this._sourceHost;
    var upSourceMgrList = this._getUpstreamSourceManagers();
    var hasUpstream = !!upSourceMgrList.length;
    var resultSourceList;
    var upstreamSignList;
    if (isSeries(sourceHost)) {
      var seriesModel = sourceHost;
      var data = void 0;
      var sourceFormat = void 0;
      var upSource = void 0;
      if (hasUpstream) {
        var upSourceMgr = upSourceMgrList[0];
        upSourceMgr.prepareSource();
        upSource = upSourceMgr.getSource();
        data = upSource.data;
        sourceFormat = upSource.sourceFormat;
        upstreamSignList = [upSourceMgr._getVersionSign()];
      } else {
        data = seriesModel.get("data", true);
        sourceFormat = isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL;
        upstreamSignList = [];
      }
      var newMetaRawOption = this._getSourceMetaRawOption() || {};
      var upMetaRawOption = upSource && upSource.metaRawOption || {};
      var seriesLayoutBy = retrieve2(newMetaRawOption.seriesLayoutBy, upMetaRawOption.seriesLayoutBy) || null;
      var sourceHeader = retrieve2(newMetaRawOption.sourceHeader, upMetaRawOption.sourceHeader);
      var dimensions = retrieve2(newMetaRawOption.dimensions, upMetaRawOption.dimensions);
      var needsCreateSource = seriesLayoutBy !== upMetaRawOption.seriesLayoutBy || !!sourceHeader !== !!upMetaRawOption.sourceHeader || dimensions;
      resultSourceList = needsCreateSource ? [createSource(data, {
        seriesLayoutBy,
        sourceHeader,
        dimensions
      }, sourceFormat)] : [];
    } else {
      var datasetModel = sourceHost;
      if (hasUpstream) {
        var result = this._applyTransform(upSourceMgrList);
        resultSourceList = result.sourceList;
        upstreamSignList = result.upstreamSignList;
      } else {
        var sourceData = datasetModel.get("source", true);
        resultSourceList = [createSource(sourceData, this._getSourceMetaRawOption(), null)];
        upstreamSignList = [];
      }
    }
    this._setLocalSource(resultSourceList, upstreamSignList);
  };
  SourceManager2.prototype._applyTransform = function(upMgrList) {
    var datasetModel = this._sourceHost;
    var transformOption = datasetModel.get("transform", true);
    var fromTransformResult = datasetModel.get("fromTransformResult", true);
    if (fromTransformResult != null) {
      var errMsg = "";
      if (upMgrList.length !== 1) {
        doThrow(errMsg);
      }
    }
    var sourceList;
    var upSourceList = [];
    var upstreamSignList = [];
    each$f(upMgrList, function(upMgr) {
      upMgr.prepareSource();
      var upSource = upMgr.getSource(fromTransformResult || 0);
      var errMsg2 = "";
      if (fromTransformResult != null && !upSource) {
        doThrow(errMsg2);
      }
      upSourceList.push(upSource);
      upstreamSignList.push(upMgr._getVersionSign());
    });
    if (transformOption) {
      sourceList = applyDataTransform(transformOption, upSourceList, {
        datasetIndex: datasetModel.componentIndex
      });
    } else if (fromTransformResult != null) {
      sourceList = [cloneSourceShallow(upSourceList[0])];
    }
    return {
      sourceList,
      upstreamSignList
    };
  };
  SourceManager2.prototype._isDirty = function() {
    if (this._dirty) {
      return true;
    }
    var upSourceMgrList = this._getUpstreamSourceManagers();
    for (var i = 0; i < upSourceMgrList.length; i++) {
      var upSrcMgr = upSourceMgrList[i];
      if (upSrcMgr._isDirty() || this._upstreamSignList[i] !== upSrcMgr._getVersionSign()) {
        return true;
      }
    }
  };
  SourceManager2.prototype.getSource = function(sourceIndex) {
    sourceIndex = sourceIndex || 0;
    var source = this._sourceList[sourceIndex];
    if (!source) {
      var upSourceMgrList = this._getUpstreamSourceManagers();
      return upSourceMgrList[0] && upSourceMgrList[0].getSource(sourceIndex);
    }
    return source;
  };
  SourceManager2.prototype.getSharedDataStore = function(seriesDimRequest) {
    var schema = seriesDimRequest.makeStoreSchema();
    return this._innerGetDataStore(schema.dimensions, seriesDimRequest.source, schema.hash);
  };
  SourceManager2.prototype._innerGetDataStore = function(storeDims, seriesSource, sourceReadKey) {
    var sourceIndex = 0;
    var storeList = this._storeList;
    var cachedStoreMap = storeList[sourceIndex];
    if (!cachedStoreMap) {
      cachedStoreMap = storeList[sourceIndex] = {};
    }
    var cachedStore = cachedStoreMap[sourceReadKey];
    if (!cachedStore) {
      var upSourceMgr = this._getUpstreamSourceManagers()[0];
      if (isSeries(this._sourceHost) && upSourceMgr) {
        cachedStore = upSourceMgr._innerGetDataStore(storeDims, seriesSource, sourceReadKey);
      } else {
        cachedStore = new DataStore();
        cachedStore.initData(new DefaultDataProvider(seriesSource, storeDims.length), storeDims);
      }
      cachedStoreMap[sourceReadKey] = cachedStore;
    }
    return cachedStore;
  };
  SourceManager2.prototype._getUpstreamSourceManagers = function() {
    var sourceHost = this._sourceHost;
    if (isSeries(sourceHost)) {
      var datasetModel = querySeriesUpstreamDatasetModel(sourceHost);
      return !datasetModel ? [] : [datasetModel.getSourceManager()];
    } else {
      return map$1(queryDatasetUpstreamDatasetModels(sourceHost), function(datasetModel2) {
        return datasetModel2.getSourceManager();
      });
    }
  };
  SourceManager2.prototype._getSourceMetaRawOption = function() {
    var sourceHost = this._sourceHost;
    var seriesLayoutBy;
    var sourceHeader;
    var dimensions;
    if (isSeries(sourceHost)) {
      seriesLayoutBy = sourceHost.get("seriesLayoutBy", true);
      sourceHeader = sourceHost.get("sourceHeader", true);
      dimensions = sourceHost.get("dimensions", true);
    } else if (!this._getUpstreamSourceManagers().length) {
      var model = sourceHost;
      seriesLayoutBy = model.get("seriesLayoutBy", true);
      sourceHeader = model.get("sourceHeader", true);
      dimensions = model.get("dimensions", true);
    }
    return {
      seriesLayoutBy,
      sourceHeader,
      dimensions
    };
  };
  return SourceManager2;
}();
function disableTransformOptionMerge(datasetModel) {
  var transformOption = datasetModel.option.transform;
  transformOption && setAsPrimitive(datasetModel.option.transform);
}
function isSeries(sourceHost) {
  return sourceHost.mainType === "series";
}
function doThrow(errMsg) {
  throw new Error(errMsg);
}
var TOOLTIP_LINE_HEIGHT_CSS = "line-height:1";
function getTooltipTextStyle(textStyle, renderMode) {
  var nameFontColor = textStyle.color || "#6e7079";
  var nameFontSize = textStyle.fontSize || 12;
  var nameFontWeight = textStyle.fontWeight || "400";
  var valueFontColor = textStyle.color || "#464646";
  var valueFontSize = textStyle.fontSize || 14;
  var valueFontWeight = textStyle.fontWeight || "900";
  if (renderMode === "html") {
    return {
      nameStyle: "font-size:" + encodeHTML(nameFontSize + "") + "px;color:" + encodeHTML(nameFontColor) + ";font-weight:" + encodeHTML(nameFontWeight + ""),
      valueStyle: "font-size:" + encodeHTML(valueFontSize + "") + "px;color:" + encodeHTML(valueFontColor) + ";font-weight:" + encodeHTML(valueFontWeight + "")
    };
  } else {
    return {
      nameStyle: {
        fontSize: nameFontSize,
        fill: nameFontColor,
        fontWeight: nameFontWeight
      },
      valueStyle: {
        fontSize: valueFontSize,
        fill: valueFontColor,
        fontWeight: valueFontWeight
      }
    };
  }
}
var HTML_GAPS = [0, 10, 20, 30];
var RICH_TEXT_GAPS = ["", "\n", "\n\n", "\n\n\n"];
function createTooltipMarkup(type4, option) {
  option.type = type4;
  return option;
}
function isSectionFragment(frag) {
  return frag.type === "section";
}
function getBuilder(frag) {
  return isSectionFragment(frag) ? buildSection : buildNameValue;
}
function getBlockGapLevel(frag) {
  if (isSectionFragment(frag)) {
    var gapLevel_1 = 0;
    var subBlockLen = frag.blocks.length;
    var hasInnerGap_1 = subBlockLen > 1 || subBlockLen > 0 && !frag.noHeader;
    each$f(frag.blocks, function(subBlock) {
      var subGapLevel = getBlockGapLevel(subBlock);
      if (subGapLevel >= gapLevel_1) {
        gapLevel_1 = subGapLevel + +(hasInnerGap_1 && (!subGapLevel || isSectionFragment(subBlock) && !subBlock.noHeader));
      }
    });
    return gapLevel_1;
  }
  return 0;
}
function buildSection(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var noHeader = fragment.noHeader;
  var gaps = getGap(getBlockGapLevel(fragment));
  var subMarkupTextList = [];
  var subBlocks = fragment.blocks || [];
  assert(!subBlocks || isArray$1(subBlocks));
  subBlocks = subBlocks || [];
  var orderMode = ctx.orderMode;
  if (fragment.sortBlocks && orderMode) {
    subBlocks = subBlocks.slice();
    var orderMap = {
      valueAsc: "asc",
      valueDesc: "desc"
    };
    if (hasOwn(orderMap, orderMode)) {
      var comparator_1 = new SortOrderComparator(orderMap[orderMode], null);
      subBlocks.sort(function(a, b2) {
        return comparator_1.evaluate(a.sortParam, b2.sortParam);
      });
    } else if (orderMode === "seriesDesc") {
      subBlocks.reverse();
    }
  }
  each$f(subBlocks, function(subBlock, idx) {
    var valueFormatter = fragment.valueFormatter;
    var subMarkupText2 = getBuilder(subBlock)(valueFormatter ? extend(extend({}, ctx), {
      valueFormatter
    }) : ctx, subBlock, idx > 0 ? gaps.html : 0, toolTipTextStyle);
    subMarkupText2 != null && subMarkupTextList.push(subMarkupText2);
  });
  var subMarkupText = ctx.renderMode === "richText" ? subMarkupTextList.join(gaps.richText) : wrapBlockHTML(subMarkupTextList.join(""), noHeader ? topMarginForOuterGap : gaps.html);
  if (noHeader) {
    return subMarkupText;
  }
  var displayableHeader = makeValueReadable(fragment.header, "ordinal", ctx.useUTC);
  var nameStyle = getTooltipTextStyle(toolTipTextStyle, ctx.renderMode).nameStyle;
  if (ctx.renderMode === "richText") {
    return wrapInlineNameRichText(ctx, displayableHeader, nameStyle) + gaps.richText + subMarkupText;
  } else {
    return wrapBlockHTML('<div style="' + nameStyle + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodeHTML(displayableHeader) + "</div>" + subMarkupText, topMarginForOuterGap);
  }
}
function buildNameValue(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var renderMode = ctx.renderMode;
  var noName = fragment.noName;
  var noValue = fragment.noValue;
  var noMarker = !fragment.markerType;
  var name = fragment.name;
  var useUTC = ctx.useUTC;
  var valueFormatter = fragment.valueFormatter || ctx.valueFormatter || function(value) {
    value = isArray$1(value) ? value : [value];
    return map$1(value, function(val, idx) {
      return makeValueReadable(val, isArray$1(valueTypeOption) ? valueTypeOption[idx] : valueTypeOption, useUTC);
    });
  };
  if (noName && noValue) {
    return;
  }
  var markerStr = noMarker ? "" : ctx.markupStyleCreator.makeTooltipMarker(fragment.markerType, fragment.markerColor || "#333", renderMode);
  var readableName = noName ? "" : makeValueReadable(name, "ordinal", useUTC);
  var valueTypeOption = fragment.valueType;
  var readableValueList = noValue ? [] : valueFormatter(fragment.value);
  var valueAlignRight = !noMarker || !noName;
  var valueCloseToMarker = !noMarker && noName;
  var _a2 = getTooltipTextStyle(toolTipTextStyle, renderMode), nameStyle = _a2.nameStyle, valueStyle = _a2.valueStyle;
  return renderMode === "richText" ? (noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameRichText(ctx, readableName, nameStyle)) + (noValue ? "" : wrapInlineValueRichText(ctx, readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)) : wrapBlockHTML((noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameHTML(readableName, !noMarker, nameStyle)) + (noValue ? "" : wrapInlineValueHTML(readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)), topMarginForOuterGap);
}
function buildTooltipMarkup(fragment, markupStyleCreator, renderMode, orderMode, useUTC, toolTipTextStyle) {
  if (!fragment) {
    return;
  }
  var builder = getBuilder(fragment);
  var ctx = {
    useUTC,
    renderMode,
    orderMode,
    markupStyleCreator,
    valueFormatter: fragment.valueFormatter
  };
  return builder(ctx, fragment, 0, toolTipTextStyle);
}
function getGap(gapLevel) {
  return {
    html: HTML_GAPS[gapLevel],
    richText: RICH_TEXT_GAPS[gapLevel]
  };
}
function wrapBlockHTML(encodedContent, topGap) {
  var clearfix = '<div style="clear:both"></div>';
  var marginCSS = "margin: " + topGap + "px 0 0";
  return '<div style="' + marginCSS + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodedContent + clearfix + "</div>";
}
function wrapInlineNameHTML(name, leftHasMarker, style) {
  var marginCss = leftHasMarker ? "margin-left:2px" : "";
  return '<span style="' + style + ";" + marginCss + '">' + encodeHTML(name) + "</span>";
}
function wrapInlineValueHTML(valueList, alignRight, valueCloseToMarker, style) {
  var paddingStr = valueCloseToMarker ? "10px" : "20px";
  var alignCSS = alignRight ? "float:right;margin-left:" + paddingStr : "";
  valueList = isArray$1(valueList) ? valueList : [valueList];
  return '<span style="' + alignCSS + ";" + style + '">' + map$1(valueList, function(value) {
    return encodeHTML(value);
  }).join("&nbsp;&nbsp;") + "</span>";
}
function wrapInlineNameRichText(ctx, name, style) {
  return ctx.markupStyleCreator.wrapRichTextStyle(name, style);
}
function wrapInlineValueRichText(ctx, values, alignRight, valueCloseToMarker, style) {
  var styles2 = [style];
  var paddingLeft = valueCloseToMarker ? 10 : 20;
  alignRight && styles2.push({
    padding: [0, 0, 0, paddingLeft],
    align: "right"
  });
  return ctx.markupStyleCreator.wrapRichTextStyle(isArray$1(values) ? values.join("  ") : values, styles2);
}
function retrieveVisualColorForTooltipMarker(series, dataIndex) {
  var style = series.getData().getItemVisual(dataIndex, "style");
  var color = style[series.visualDrawType];
  return convertToColorString(color);
}
function getPaddingFromTooltipModel(model, renderMode) {
  var padding = model.get("padding");
  return padding != null ? padding : renderMode === "richText" ? [8, 10] : 10;
}
var TooltipMarkupStyleCreator = function() {
  function TooltipMarkupStyleCreator2() {
    this.richTextStyles = {};
    this._nextStyleNameId = getRandomIdBase();
  }
  TooltipMarkupStyleCreator2.prototype._generateStyleName = function() {
    return "__EC_aUTo_" + this._nextStyleNameId++;
  };
  TooltipMarkupStyleCreator2.prototype.makeTooltipMarker = function(markerType, colorStr, renderMode) {
    var markerId = renderMode === "richText" ? this._generateStyleName() : null;
    var marker = getTooltipMarker({
      color: colorStr,
      type: markerType,
      renderMode,
      markerId
    });
    if (isString(marker)) {
      return marker;
    } else {
      this.richTextStyles[markerId] = marker.style;
      return marker.content;
    }
  };
  TooltipMarkupStyleCreator2.prototype.wrapRichTextStyle = function(text, styles2) {
    var finalStl = {};
    if (isArray$1(styles2)) {
      each$f(styles2, function(stl) {
        return extend(finalStl, stl);
      });
    } else {
      extend(finalStl, styles2);
    }
    var styleName = this._generateStyleName();
    this.richTextStyles[styleName] = finalStl;
    return "{" + styleName + "|" + text + "}";
  };
  return TooltipMarkupStyleCreator2;
}();
function defaultSeriesFormatTooltip(opt) {
  var series = opt.series;
  var dataIndex = opt.dataIndex;
  var multipleSeries = opt.multipleSeries;
  var data = series.getData();
  var tooltipDims = data.mapDimensionsAll("defaultedTooltip");
  var tooltipDimLen = tooltipDims.length;
  var value = series.getRawValue(dataIndex);
  var isValueArr = isArray$1(value);
  var markerColor = retrieveVisualColorForTooltipMarker(series, dataIndex);
  var inlineValue;
  var inlineValueType;
  var subBlocks;
  var sortParam;
  if (tooltipDimLen > 1 || isValueArr && !tooltipDimLen) {
    var formatArrResult = formatTooltipArrayValue(value, series, dataIndex, tooltipDims, markerColor);
    inlineValue = formatArrResult.inlineValues;
    inlineValueType = formatArrResult.inlineValueTypes;
    subBlocks = formatArrResult.blocks;
    sortParam = formatArrResult.inlineValues[0];
  } else if (tooltipDimLen) {
    var dimInfo = data.getDimensionInfo(tooltipDims[0]);
    sortParam = inlineValue = retrieveRawValue(data, dataIndex, tooltipDims[0]);
    inlineValueType = dimInfo.type;
  } else {
    sortParam = inlineValue = isValueArr ? value[0] : value;
  }
  var seriesNameSpecified = isNameSpecified(series);
  var seriesName = seriesNameSpecified && series.name || "";
  var itemName = data.getName(dataIndex);
  var inlineName = multipleSeries ? seriesName : itemName;
  return createTooltipMarkup("section", {
    header: seriesName,
    noHeader: multipleSeries || !seriesNameSpecified,
    sortParam,
    blocks: [createTooltipMarkup("nameValue", {
      markerType: "item",
      markerColor,
      name: inlineName,
      noName: !trim$1(inlineName),
      value: inlineValue,
      valueType: inlineValueType
    })].concat(subBlocks || [])
  });
}
function formatTooltipArrayValue(value, series, dataIndex, tooltipDims, colorStr) {
  var data = series.getData();
  var isValueMultipleLine = reduce(value, function(isValueMultipleLine2, val, idx) {
    var dimItem = data.getDimensionInfo(idx);
    return isValueMultipleLine2 = isValueMultipleLine2 || dimItem && dimItem.tooltip !== false && dimItem.displayName != null;
  }, false);
  var inlineValues = [];
  var inlineValueTypes = [];
  var blocks = [];
  tooltipDims.length ? each$f(tooltipDims, function(dim) {
    setEachItem(retrieveRawValue(data, dataIndex, dim), dim);
  }) : each$f(value, setEachItem);
  function setEachItem(val, dim) {
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo || dimInfo.otherDims.tooltip === false) {
      return;
    }
    if (isValueMultipleLine) {
      blocks.push(createTooltipMarkup("nameValue", {
        markerType: "subItem",
        markerColor: colorStr,
        name: dimInfo.displayName,
        value: val,
        valueType: dimInfo.type
      }));
    } else {
      inlineValues.push(val);
      inlineValueTypes.push(dimInfo.type);
    }
  }
  return {
    inlineValues,
    inlineValueTypes,
    blocks
  };
}
var inner$k = makeInner();
function getSelectionKey(data, dataIndex) {
  return data.getName(dataIndex) || data.getId(dataIndex);
}
var SERIES_UNIVERSAL_TRANSITION_PROP = "__universalTransitionEnabled";
var SeriesModel = function(_super) {
  __extends(SeriesModel2, _super);
  function SeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._selectedDataIndicesMap = {};
    return _this;
  }
  SeriesModel2.prototype.init = function(option, parentModel, ecModel) {
    this.seriesIndex = this.componentIndex;
    this.dataTask = createTask({
      count: dataTaskCount,
      reset: dataTaskReset
    });
    this.dataTask.context = {
      model: this
    };
    this.mergeDefaultAndTheme(option, ecModel);
    var sourceManager = inner$k(this).sourceManager = new SourceManager(this);
    sourceManager.prepareSource();
    var data = this.getInitialData(option, ecModel);
    wrapData(data, this);
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeSubType = this.subType;
    if (ComponentModel$1.hasClass(themeSubType)) {
      themeSubType += "Series";
    }
    merge(option, ecModel.getTheme().get(this.subType));
    merge(option, this.getDefaultOption());
    defaultEmphasis(option, "label", ["show"]);
    this.fillDataTextStyle(option.data);
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  SeriesModel2.prototype.mergeOption = function(newSeriesOption, ecModel) {
    newSeriesOption = merge(this.option, newSeriesOption, true);
    this.fillDataTextStyle(newSeriesOption.data);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, newSeriesOption, layoutMode);
    }
    var sourceManager = inner$k(this).sourceManager;
    sourceManager.dirty();
    sourceManager.prepareSource();
    var data = this.getInitialData(newSeriesOption, ecModel);
    wrapData(data, this);
    this.dataTask.dirty();
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.fillDataTextStyle = function(data) {
    if (data && !isTypedArray(data)) {
      var props = ["show"];
      for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].label) {
          defaultEmphasis(data[i], "label", props);
        }
      }
    }
  };
  SeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return;
  };
  SeriesModel2.prototype.appendData = function(params) {
    var data = this.getRawData();
    data.appendData(params.data);
  };
  SeriesModel2.prototype.getData = function(dataType) {
    var task = getCurrentTask(this);
    if (task) {
      var data = task.context.data;
      return dataType == null ? data : data.getLinkedData(dataType);
    } else {
      return inner$k(this).data;
    }
  };
  SeriesModel2.prototype.getAllData = function() {
    var mainData = this.getData();
    return mainData && mainData.getLinkedDataAll ? mainData.getLinkedDataAll() : [{
      data: mainData
    }];
  };
  SeriesModel2.prototype.setData = function(data) {
    var task = getCurrentTask(this);
    if (task) {
      var context = task.context;
      context.outputData = data;
      if (task !== this.dataTask) {
        context.data = data;
      }
    }
    inner$k(this).data = data;
  };
  SeriesModel2.prototype.getEncode = function() {
    var encode = this.get("encode", true);
    if (encode) {
      return createHashMap(encode);
    }
  };
  SeriesModel2.prototype.getSourceManager = function() {
    return inner$k(this).sourceManager;
  };
  SeriesModel2.prototype.getSource = function() {
    return this.getSourceManager().getSource();
  };
  SeriesModel2.prototype.getRawData = function() {
    return inner$k(this).dataBeforeProcessed;
  };
  SeriesModel2.prototype.getColorBy = function() {
    var colorBy = this.get("colorBy");
    return colorBy || "series";
  };
  SeriesModel2.prototype.isColorBySeries = function() {
    return this.getColorBy() === "series";
  };
  SeriesModel2.prototype.getBaseAxis = function() {
    var coordSys = this.coordinateSystem;
    return coordSys && coordSys.getBaseAxis && coordSys.getBaseAxis();
  };
  SeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
  };
  SeriesModel2.prototype.isAnimationEnabled = function() {
    var ecModel = this.ecModel;
    if (env$1.node && !(ecModel && ecModel.ssr)) {
      return false;
    }
    var animationEnabled = this.getShallow("animation");
    if (animationEnabled) {
      if (this.getData().count() > this.getShallow("animationThreshold")) {
        animationEnabled = false;
      }
    }
    return !!animationEnabled;
  };
  SeriesModel2.prototype.restoreData = function() {
    this.dataTask.dirty();
  };
  SeriesModel2.prototype.getColorFromPalette = function(name, scope, requestColorNum) {
    var ecModel = this.ecModel;
    var color = PaletteMixin.prototype.getColorFromPalette.call(this, name, scope, requestColorNum);
    if (!color) {
      color = ecModel.getColorFromPalette(name, scope, requestColorNum);
    }
    return color;
  };
  SeriesModel2.prototype.coordDimToDataDim = function(coordDim) {
    return this.getRawData().mapDimensionsAll(coordDim);
  };
  SeriesModel2.prototype.getProgressive = function() {
    return this.get("progressive");
  };
  SeriesModel2.prototype.getProgressiveThreshold = function() {
    return this.get("progressiveThreshold");
  };
  SeriesModel2.prototype.select = function(innerDataIndices, dataType) {
    this._innerSelect(this.getData(dataType), innerDataIndices);
  };
  SeriesModel2.prototype.unselect = function(innerDataIndices, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return;
    }
    var selectedMode = this.option.selectedMode;
    var data = this.getData(dataType);
    if (selectedMode === "series" || selectedMap === "all") {
      this.option.selectedMap = {};
      this._selectedDataIndicesMap = {};
      return;
    }
    for (var i = 0; i < innerDataIndices.length; i++) {
      var dataIndex = innerDataIndices[i];
      var nameOrId = getSelectionKey(data, dataIndex);
      selectedMap[nameOrId] = false;
      this._selectedDataIndicesMap[nameOrId] = -1;
    }
  };
  SeriesModel2.prototype.toggleSelect = function(innerDataIndices, dataType) {
    var tmpArr2 = [];
    for (var i = 0; i < innerDataIndices.length; i++) {
      tmpArr2[0] = innerDataIndices[i];
      this.isSelected(innerDataIndices[i], dataType) ? this.unselect(tmpArr2, dataType) : this.select(tmpArr2, dataType);
    }
  };
  SeriesModel2.prototype.getSelectedDataIndices = function() {
    if (this.option.selectedMap === "all") {
      return [].slice.call(this.getData().getIndices());
    }
    var selectedDataIndicesMap = this._selectedDataIndicesMap;
    var nameOrIds = keys(selectedDataIndicesMap);
    var dataIndices = [];
    for (var i = 0; i < nameOrIds.length; i++) {
      var dataIndex = selectedDataIndicesMap[nameOrIds[i]];
      if (dataIndex >= 0) {
        dataIndices.push(dataIndex);
      }
    }
    return dataIndices;
  };
  SeriesModel2.prototype.isSelected = function(dataIndex, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return false;
    }
    var data = this.getData(dataType);
    return (selectedMap === "all" || selectedMap[getSelectionKey(data, dataIndex)]) && !data.getItemModel(dataIndex).get(["select", "disabled"]);
  };
  SeriesModel2.prototype.isUniversalTransitionEnabled = function() {
    if (this[SERIES_UNIVERSAL_TRANSITION_PROP]) {
      return true;
    }
    var universalTransitionOpt = this.option.universalTransition;
    if (!universalTransitionOpt) {
      return false;
    }
    if (universalTransitionOpt === true) {
      return true;
    }
    return universalTransitionOpt && universalTransitionOpt.enabled;
  };
  SeriesModel2.prototype._innerSelect = function(data, innerDataIndices) {
    var _a2, _b2;
    var option = this.option;
    var selectedMode = option.selectedMode;
    var len2 = innerDataIndices.length;
    if (!selectedMode || !len2) {
      return;
    }
    if (selectedMode === "series") {
      option.selectedMap = "all";
    } else if (selectedMode === "multiple") {
      if (!isObject$4(option.selectedMap)) {
        option.selectedMap = {};
      }
      var selectedMap = option.selectedMap;
      for (var i = 0; i < len2; i++) {
        var dataIndex = innerDataIndices[i];
        var nameOrId = getSelectionKey(data, dataIndex);
        selectedMap[nameOrId] = true;
        this._selectedDataIndicesMap[nameOrId] = data.getRawIndex(dataIndex);
      }
    } else if (selectedMode === "single" || selectedMode === true) {
      var lastDataIndex = innerDataIndices[len2 - 1];
      var nameOrId = getSelectionKey(data, lastDataIndex);
      option.selectedMap = (_a2 = {}, _a2[nameOrId] = true, _a2);
      this._selectedDataIndicesMap = (_b2 = {}, _b2[nameOrId] = data.getRawIndex(lastDataIndex), _b2);
    }
  };
  SeriesModel2.prototype._initSelectedMapFromData = function(data) {
    if (this.option.selectedMap) {
      return;
    }
    var dataIndices = [];
    if (data.hasItemOption) {
      data.each(function(idx) {
        var rawItem = data.getRawDataItem(idx);
        if (rawItem && rawItem.selected) {
          dataIndices.push(idx);
        }
      });
    }
    if (dataIndices.length > 0) {
      this._innerSelect(data, dataIndices);
    }
  };
  SeriesModel2.registerClass = function(clz) {
    return ComponentModel$1.registerClass(clz);
  };
  SeriesModel2.protoInitialize = function() {
    var proto2 = SeriesModel2.prototype;
    proto2.type = "series.__base__";
    proto2.seriesIndex = 0;
    proto2.ignoreStyleOnData = false;
    proto2.hasSymbolVisual = false;
    proto2.defaultSymbol = "circle";
    proto2.visualStyleAccessPath = "itemStyle";
    proto2.visualDrawType = "fill";
  }();
  return SeriesModel2;
}(ComponentModel$1);
mixin(SeriesModel, DataFormatMixin);
mixin(SeriesModel, PaletteMixin);
mountExtend(SeriesModel, ComponentModel$1);
function autoSeriesName(seriesModel) {
  var name = seriesModel.name;
  if (!isNameSpecified(seriesModel)) {
    seriesModel.name = getSeriesAutoName(seriesModel) || name;
  }
}
function getSeriesAutoName(seriesModel) {
  var data = seriesModel.getRawData();
  var dataDims = data.mapDimensionsAll("seriesName");
  var nameArr = [];
  each$f(dataDims, function(dataDim) {
    var dimInfo = data.getDimensionInfo(dataDim);
    dimInfo.displayName && nameArr.push(dimInfo.displayName);
  });
  return nameArr.join(" ");
}
function dataTaskCount(context) {
  return context.model.getRawData().count();
}
function dataTaskReset(context) {
  var seriesModel = context.model;
  seriesModel.setData(seriesModel.getRawData().cloneShallow());
  return dataTaskProgress;
}
function dataTaskProgress(param, context) {
  if (context.outputData && param.end > context.outputData.count()) {
    context.model.getRawData().cloneShallow(context.outputData);
  }
}
function wrapData(data, seriesModel) {
  each$f(concatArray(data.CHANGABLE_METHODS, data.DOWNSAMPLE_METHODS), function(methodName) {
    data.wrapMethod(methodName, curry$1(onDataChange, seriesModel));
  });
}
function onDataChange(seriesModel, newList) {
  var task = getCurrentTask(seriesModel);
  if (task) {
    task.setOutputEnd((newList || this).count());
  }
  return newList;
}
function getCurrentTask(seriesModel) {
  var scheduler = (seriesModel.ecModel || {}).scheduler;
  var pipeline = scheduler && scheduler.getPipeline(seriesModel.uid);
  if (pipeline) {
    var task = pipeline.currentTask;
    if (task) {
      var agentStubMap = task.agentStubMap;
      if (agentStubMap) {
        task = agentStubMap.get(seriesModel.uid);
      }
    }
    return task;
  }
}
var SeriesModel$1 = SeriesModel;
var ComponentView = function() {
  function ComponentView2() {
    this.group = new Group$4();
    this.uid = getUID("viewComponent");
  }
  ComponentView2.prototype.init = function(ecModel, api) {
  };
  ComponentView2.prototype.render = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.dispose = function(ecModel, api) {
  };
  ComponentView2.prototype.updateView = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateLayout = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateVisual = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.blurSeries = function(seriesModels, ecModel) {
  };
  ComponentView2.prototype.eachRendered = function(cb) {
    var group = this.group;
    if (group) {
      group.traverse(cb);
    }
  };
  return ComponentView2;
}();
enableClassExtend(ComponentView);
enableClassManagement(ComponentView);
var ComponentView$1 = ComponentView;
function createRenderPlanner() {
  var inner2 = makeInner();
  return function(seriesModel) {
    var fields = inner2(seriesModel);
    var pipelineContext = seriesModel.pipelineContext;
    var originalLarge = !!fields.large;
    var originalProgressive = !!fields.progressiveRender;
    var large = fields.large = !!(pipelineContext && pipelineContext.large);
    var progressive = fields.progressiveRender = !!(pipelineContext && pipelineContext.progressiveRender);
    return !!(originalLarge !== large || originalProgressive !== progressive) && "reset";
  };
}
var inner$j = makeInner();
var renderPlanner = createRenderPlanner();
var ChartView = function() {
  function ChartView2() {
    this.group = new Group$4();
    this.uid = getUID("viewChart");
    this.renderTask = createTask({
      plan: renderTaskPlan,
      reset: renderTaskReset
    });
    this.renderTask.context = {
      view: this
    };
  }
  ChartView2.prototype.init = function(ecModel, api) {
  };
  ChartView2.prototype.render = function(seriesModel, ecModel, api, payload) {
  };
  ChartView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "emphasis");
  };
  ChartView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "normal");
  };
  ChartView2.prototype.remove = function(ecModel, api) {
    this.group.removeAll();
  };
  ChartView2.prototype.dispose = function(ecModel, api) {
  };
  ChartView2.prototype.updateView = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateLayout = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateVisual = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this.group, cb);
  };
  ChartView2.markUpdateMethod = function(payload, methodName) {
    inner$j(payload).updateMethod = methodName;
  };
  ChartView2.protoInitialize = function() {
    var proto2 = ChartView2.prototype;
    proto2.type = "chart";
  }();
  return ChartView2;
}();
function elSetState(el, state, highlightDigit) {
  if (el && isHighDownDispatcher(el)) {
    (state === "emphasis" ? enterEmphasis : leaveEmphasis)(el, highlightDigit);
  }
}
function toggleHighlight(data, payload, state) {
  var dataIndex = queryDataIndex(data, payload);
  var highlightDigit = payload && payload.highlightKey != null ? getHighlightDigit(payload.highlightKey) : null;
  if (dataIndex != null) {
    each$f(normalizeToArray(dataIndex), function(dataIdx) {
      elSetState(data.getItemGraphicEl(dataIdx), state, highlightDigit);
    });
  } else {
    data.eachItemGraphicEl(function(el) {
      elSetState(el, state, highlightDigit);
    });
  }
}
enableClassExtend(ChartView);
enableClassManagement(ChartView);
function renderTaskPlan(context) {
  return renderPlanner(context.model);
}
function renderTaskReset(context) {
  var seriesModel = context.model;
  var ecModel = context.ecModel;
  var api = context.api;
  var payload = context.payload;
  var progressiveRender = seriesModel.pipelineContext.progressiveRender;
  var view = context.view;
  var updateMethod = payload && inner$j(payload).updateMethod;
  var methodName = progressiveRender ? "incrementalPrepareRender" : updateMethod && view[updateMethod] ? updateMethod : "render";
  if (methodName !== "render") {
    view[methodName](seriesModel, ecModel, api, payload);
  }
  return progressMethodMap[methodName];
}
var progressMethodMap = {
  incrementalPrepareRender: {
    progress: function(params, context) {
      context.view.incrementalRender(params, context.model, context.ecModel, context.api, context.payload);
    }
  },
  render: {
    forceFirstProgress: true,
    progress: function(params, context) {
      context.view.render(context.model, context.ecModel, context.api, context.payload);
    }
  }
};
var ChartView$1 = ChartView;
var ORIGIN_METHOD = "\0__throttleOriginMethod";
var RATE = "\0__throttleRate";
var THROTTLE_TYPE = "\0__throttleType";
function throttle(fn, delay, debounce2) {
  var currCall;
  var lastCall = 0;
  var lastExec = 0;
  var timer = null;
  var diff;
  var scope;
  var args;
  var debounceNextCall;
  delay = delay || 0;
  function exec() {
    lastExec = new Date().getTime();
    timer = null;
    fn.apply(scope, args || []);
  }
  var cb = function() {
    var cbArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      cbArgs[_i] = arguments[_i];
    }
    currCall = new Date().getTime();
    scope = this;
    args = cbArgs;
    var thisDelay = debounceNextCall || delay;
    var thisDebounce = debounceNextCall || debounce2;
    debounceNextCall = null;
    diff = currCall - (thisDebounce ? lastCall : lastExec) - thisDelay;
    clearTimeout(timer);
    if (thisDebounce) {
      timer = setTimeout(exec, thisDelay);
    } else {
      if (diff >= 0) {
        exec();
      } else {
        timer = setTimeout(exec, -diff);
      }
    }
    lastCall = currCall;
  };
  cb.clear = function() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  };
  cb.debounceNextCall = function(debounceDelay) {
    debounceNextCall = debounceDelay;
  };
  return cb;
}
function createOrUpdate(obj, fnAttr, rate, throttleType) {
  var fn = obj[fnAttr];
  if (!fn) {
    return;
  }
  var originFn = fn[ORIGIN_METHOD] || fn;
  var lastThrottleType = fn[THROTTLE_TYPE];
  var lastRate = fn[RATE];
  if (lastRate !== rate || lastThrottleType !== throttleType) {
    if (rate == null || !throttleType) {
      return obj[fnAttr] = originFn;
    }
    fn = obj[fnAttr] = throttle(originFn, rate, throttleType === "debounce");
    fn[ORIGIN_METHOD] = originFn;
    fn[THROTTLE_TYPE] = throttleType;
    fn[RATE] = rate;
  }
  return fn;
}
function clear$1(obj, fnAttr) {
  var fn = obj[fnAttr];
  if (fn && fn[ORIGIN_METHOD]) {
    fn.clear && fn.clear();
    obj[fnAttr] = fn[ORIGIN_METHOD];
  }
}
var inner$i = makeInner();
var defaultStyleMappers = {
  itemStyle: makeStyleMapper(ITEM_STYLE_KEY_MAP, true),
  lineStyle: makeStyleMapper(LINE_STYLE_KEY_MAP, true)
};
var defaultColorKey = {
  lineStyle: "stroke",
  itemStyle: "fill"
};
function getStyleMapper(seriesModel, stylePath) {
  var styleMapper = seriesModel.visualStyleMapper || defaultStyleMappers[stylePath];
  if (!styleMapper) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return defaultStyleMappers.itemStyle;
  }
  return styleMapper;
}
function getDefaultColorKey(seriesModel, stylePath) {
  var colorKey = seriesModel.visualDrawType || defaultColorKey[stylePath];
  if (!colorKey) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return "fill";
  }
  return colorKey;
}
var seriesStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var styleModel = seriesModel.getModel(stylePath);
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var globalStyle = getStyle2(styleModel);
    var decalOption = styleModel.getShallow("decal");
    if (decalOption) {
      data.setVisual("decal", decalOption);
      decalOption.dirty = true;
    }
    var colorKey = getDefaultColorKey(seriesModel, stylePath);
    var color = globalStyle[colorKey];
    var colorCallback = isFunction(color) ? color : null;
    var hasAutoColor = globalStyle.fill === "auto" || globalStyle.stroke === "auto";
    if (!globalStyle[colorKey] || colorCallback || hasAutoColor) {
      var colorPalette2 = seriesModel.getColorFromPalette(seriesModel.name, null, ecModel.getSeriesCount());
      if (!globalStyle[colorKey]) {
        globalStyle[colorKey] = colorPalette2;
        data.setVisual("colorFromPalette", true);
      }
      globalStyle.fill = globalStyle.fill === "auto" || isFunction(globalStyle.fill) ? colorPalette2 : globalStyle.fill;
      globalStyle.stroke = globalStyle.stroke === "auto" || isFunction(globalStyle.stroke) ? colorPalette2 : globalStyle.stroke;
    }
    data.setVisual("style", globalStyle);
    data.setVisual("drawType", colorKey);
    if (!ecModel.isSeriesFiltered(seriesModel) && colorCallback) {
      data.setVisual("colorFromPalette", false);
      return {
        dataEach: function(data2, idx) {
          var dataParams = seriesModel.getDataParams(idx);
          var itemStyle = extend({}, globalStyle);
          itemStyle[colorKey] = colorCallback(dataParams);
          data2.setItemVisual(idx, "style", itemStyle);
        }
      };
    }
  }
};
var sharedModel = new Model$1();
var dataStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (seriesModel.ignoreStyleOnData || ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var colorKey = data.getVisual("drawType");
    return {
      dataEach: data.hasItemOption ? function(data2, idx) {
        var rawItem = data2.getRawDataItem(idx);
        if (rawItem && rawItem[stylePath]) {
          sharedModel.option = rawItem[stylePath];
          var style = getStyle2(sharedModel);
          var existsStyle = data2.ensureUniqueItemVisual(idx, "style");
          extend(existsStyle, style);
          if (sharedModel.option.decal) {
            data2.setItemVisual(idx, "decal", sharedModel.option.decal);
            sharedModel.option.decal.dirty = true;
          }
          if (colorKey in style) {
            data2.setItemVisual(idx, "colorFromPalette", false);
          }
        }
      } : null
    };
  }
};
var dataColorPaletteTask = {
  performRawSeries: true,
  overallReset: function(ecModel) {
    var paletteScopeGroupByType = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var colorBy = seriesModel.getColorBy();
      if (seriesModel.isColorBySeries()) {
        return;
      }
      var key = seriesModel.type + "-" + colorBy;
      var colorScope = paletteScopeGroupByType.get(key);
      if (!colorScope) {
        colorScope = {};
        paletteScopeGroupByType.set(key, colorScope);
      }
      inner$i(seriesModel).scope = colorScope;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.isColorBySeries() || ecModel.isSeriesFiltered(seriesModel)) {
        return;
      }
      var dataAll = seriesModel.getRawData();
      var idxMap = {};
      var data = seriesModel.getData();
      var colorScope = inner$i(seriesModel).scope;
      var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
      var colorKey = getDefaultColorKey(seriesModel, stylePath);
      data.each(function(idx) {
        var rawIdx = data.getRawIndex(idx);
        idxMap[rawIdx] = idx;
      });
      dataAll.each(function(rawIdx) {
        var idx = idxMap[rawIdx];
        var fromPalette = data.getItemVisual(idx, "colorFromPalette");
        if (fromPalette) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          var name_1 = dataAll.getName(rawIdx) || rawIdx + "";
          var dataCount = dataAll.count();
          itemStyle[colorKey] = seriesModel.getColorFromPalette(name_1, colorScope, dataCount);
        }
      });
    });
  }
};
var PI$5 = Math.PI;
function defaultLoading(api, opts) {
  opts = opts || {};
  defaults(opts, {
    text: "loading",
    textColor: "#000",
    fontSize: 12,
    fontWeight: "normal",
    fontStyle: "normal",
    fontFamily: "sans-serif",
    maskColor: "rgba(255, 255, 255, 0.8)",
    showSpinner: true,
    color: "#5470c6",
    spinnerRadius: 10,
    lineWidth: 5,
    zlevel: 0
  });
  var group = new Group$4();
  var mask = new Rect$3({
    style: {
      fill: opts.maskColor
    },
    zlevel: opts.zlevel,
    z: 1e4
  });
  group.add(mask);
  var textContent = new ZRText$1({
    style: {
      text: opts.text,
      fill: opts.textColor,
      fontSize: opts.fontSize,
      fontWeight: opts.fontWeight,
      fontStyle: opts.fontStyle,
      fontFamily: opts.fontFamily
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  var labelRect = new Rect$3({
    style: {
      fill: "none"
    },
    textContent,
    textConfig: {
      position: "right",
      distance: 10
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  group.add(labelRect);
  var arc;
  if (opts.showSpinner) {
    arc = new Arc$1({
      shape: {
        startAngle: -PI$5 / 2,
        endAngle: -PI$5 / 2 + 0.1,
        r: opts.spinnerRadius
      },
      style: {
        stroke: opts.color,
        lineCap: "round",
        lineWidth: opts.lineWidth
      },
      zlevel: opts.zlevel,
      z: 10001
    });
    arc.animateShape(true).when(1e3, {
      endAngle: PI$5 * 3 / 2
    }).start("circularInOut");
    arc.animateShape(true).when(1e3, {
      startAngle: PI$5 * 3 / 2
    }).delay(300).start("circularInOut");
    group.add(arc);
  }
  group.resize = function() {
    var textWidth = textContent.getBoundingRect().width;
    var r2 = opts.showSpinner ? opts.spinnerRadius : 0;
    var cx = (api.getWidth() - r2 * 2 - (opts.showSpinner && textWidth ? 10 : 0) - textWidth) / 2 - (opts.showSpinner && textWidth ? 0 : 5 + textWidth / 2) + (opts.showSpinner ? 0 : textWidth / 2) + (textWidth ? 0 : r2);
    var cy = api.getHeight() / 2;
    opts.showSpinner && arc.setShape({
      cx,
      cy
    });
    labelRect.setShape({
      x: cx - r2,
      y: cy - r2,
      width: r2 * 2,
      height: r2 * 2
    });
    mask.setShape({
      x: 0,
      y: 0,
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  group.resize();
  return group;
}
var Scheduler = function() {
  function Scheduler2(ecInstance, api, dataProcessorHandlers, visualHandlers) {
    this._stageTaskMap = createHashMap();
    this.ecInstance = ecInstance;
    this.api = api;
    dataProcessorHandlers = this._dataProcessorHandlers = dataProcessorHandlers.slice();
    visualHandlers = this._visualHandlers = visualHandlers.slice();
    this._allHandlers = dataProcessorHandlers.concat(visualHandlers);
  }
  Scheduler2.prototype.restoreData = function(ecModel, payload) {
    ecModel.restoreData(payload);
    this._stageTaskMap.each(function(taskRecord) {
      var overallTask = taskRecord.overallTask;
      overallTask && overallTask.dirty();
    });
  };
  Scheduler2.prototype.getPerformArgs = function(task, isBlock) {
    if (!task.__pipeline) {
      return;
    }
    var pipeline = this._pipelineMap.get(task.__pipeline.id);
    var pCtx = pipeline.context;
    var incremental = !isBlock && pipeline.progressiveEnabled && (!pCtx || pCtx.progressiveRender) && task.__idxInPipeline > pipeline.blockIndex;
    var step = incremental ? pipeline.step : null;
    var modDataCount = pCtx && pCtx.modDataCount;
    var modBy = modDataCount != null ? Math.ceil(modDataCount / step) : null;
    return {
      step,
      modBy,
      modDataCount
    };
  };
  Scheduler2.prototype.getPipeline = function(pipelineId) {
    return this._pipelineMap.get(pipelineId);
  };
  Scheduler2.prototype.updateStreamModes = function(seriesModel, view) {
    var pipeline = this._pipelineMap.get(seriesModel.uid);
    var data = seriesModel.getData();
    var dataLen = data.count();
    var progressiveRender = pipeline.progressiveEnabled && view.incrementalPrepareRender && dataLen >= pipeline.threshold;
    var large = seriesModel.get("large") && dataLen >= seriesModel.get("largeThreshold");
    var modDataCount = seriesModel.get("progressiveChunkMode") === "mod" ? dataLen : null;
    seriesModel.pipelineContext = pipeline.context = {
      progressiveRender,
      modDataCount,
      large
    };
  };
  Scheduler2.prototype.restorePipelines = function(ecModel) {
    var scheduler = this;
    var pipelineMap = scheduler._pipelineMap = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var progressive = seriesModel.getProgressive();
      var pipelineId = seriesModel.uid;
      pipelineMap.set(pipelineId, {
        id: pipelineId,
        head: null,
        tail: null,
        threshold: seriesModel.getProgressiveThreshold(),
        progressiveEnabled: progressive && !(seriesModel.preventIncremental && seriesModel.preventIncremental()),
        blockIndex: -1,
        step: Math.round(progressive || 700),
        count: 0
      });
      scheduler._pipe(seriesModel, seriesModel.dataTask);
    });
  };
  Scheduler2.prototype.prepareStageTasks = function() {
    var stageTaskMap = this._stageTaskMap;
    var ecModel = this.api.getModel();
    var api = this.api;
    each$f(this._allHandlers, function(handler) {
      var record = stageTaskMap.get(handler.uid) || stageTaskMap.set(handler.uid, {});
      var errMsg = "";
      assert(!(handler.reset && handler.overallReset), errMsg);
      handler.reset && this._createSeriesStageTask(handler, record, ecModel, api);
      handler.overallReset && this._createOverallStageTask(handler, record, ecModel, api);
    }, this);
  };
  Scheduler2.prototype.prepareView = function(view, model, ecModel, api) {
    var renderTask = view.renderTask;
    var context = renderTask.context;
    context.model = model;
    context.ecModel = ecModel;
    context.api = api;
    renderTask.__block = !view.incrementalPrepareRender;
    this._pipe(model, renderTask);
  };
  Scheduler2.prototype.performDataProcessorTasks = function(ecModel, payload) {
    this._performStageTasks(this._dataProcessorHandlers, ecModel, payload, {
      block: true
    });
  };
  Scheduler2.prototype.performVisualTasks = function(ecModel, payload, opt) {
    this._performStageTasks(this._visualHandlers, ecModel, payload, opt);
  };
  Scheduler2.prototype._performStageTasks = function(stageHandlers, ecModel, payload, opt) {
    opt = opt || {};
    var unfinished = false;
    var scheduler = this;
    each$f(stageHandlers, function(stageHandler, idx) {
      if (opt.visualType && opt.visualType !== stageHandler.visualType) {
        return;
      }
      var stageHandlerRecord = scheduler._stageTaskMap.get(stageHandler.uid);
      var seriesTaskMap = stageHandlerRecord.seriesTaskMap;
      var overallTask = stageHandlerRecord.overallTask;
      if (overallTask) {
        var overallNeedDirty_1;
        var agentStubMap = overallTask.agentStubMap;
        agentStubMap.each(function(stub) {
          if (needSetDirty(opt, stub)) {
            stub.dirty();
            overallNeedDirty_1 = true;
          }
        });
        overallNeedDirty_1 && overallTask.dirty();
        scheduler.updatePayload(overallTask, payload);
        var performArgs_1 = scheduler.getPerformArgs(overallTask, opt.block);
        agentStubMap.each(function(stub) {
          stub.perform(performArgs_1);
        });
        if (overallTask.perform(performArgs_1)) {
          unfinished = true;
        }
      } else if (seriesTaskMap) {
        seriesTaskMap.each(function(task, pipelineId) {
          if (needSetDirty(opt, task)) {
            task.dirty();
          }
          var performArgs = scheduler.getPerformArgs(task, opt.block);
          performArgs.skip = !stageHandler.performRawSeries && ecModel.isSeriesFiltered(task.context.model);
          scheduler.updatePayload(task, payload);
          if (task.perform(performArgs)) {
            unfinished = true;
          }
        });
      }
    });
    function needSetDirty(opt2, task) {
      return opt2.setDirty && (!opt2.dirtyMap || opt2.dirtyMap.get(task.__pipeline.id));
    }
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.performSeriesTasks = function(ecModel) {
    var unfinished;
    ecModel.eachSeries(function(seriesModel) {
      unfinished = seriesModel.dataTask.perform() || unfinished;
    });
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.plan = function() {
    this._pipelineMap.each(function(pipeline) {
      var task = pipeline.tail;
      do {
        if (task.__block) {
          pipeline.blockIndex = task.__idxInPipeline;
          break;
        }
        task = task.getUpstream();
      } while (task);
    });
  };
  Scheduler2.prototype.updatePayload = function(task, payload) {
    payload !== "remain" && (task.context.payload = payload);
  };
  Scheduler2.prototype._createSeriesStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var oldSeriesTaskMap = stageHandlerRecord.seriesTaskMap;
    var newSeriesTaskMap = stageHandlerRecord.seriesTaskMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    if (stageHandler.createOnAllSeries) {
      ecModel.eachRawSeries(create2);
    } else if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, create2);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(create2);
    }
    function create2(seriesModel) {
      var pipelineId = seriesModel.uid;
      var task = newSeriesTaskMap.set(pipelineId, oldSeriesTaskMap && oldSeriesTaskMap.get(pipelineId) || createTask({
        plan: seriesTaskPlan,
        reset: seriesTaskReset,
        count: seriesTaskCount
      }));
      task.context = {
        model: seriesModel,
        ecModel,
        api,
        useClearVisual: stageHandler.isVisual && !stageHandler.isLayout,
        plan: stageHandler.plan,
        reset: stageHandler.reset,
        scheduler
      };
      scheduler._pipe(seriesModel, task);
    }
  };
  Scheduler2.prototype._createOverallStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var overallTask = stageHandlerRecord.overallTask = stageHandlerRecord.overallTask || createTask({
      reset: overallTaskReset
    });
    overallTask.context = {
      ecModel,
      api,
      overallReset: stageHandler.overallReset,
      scheduler
    };
    var oldAgentStubMap = overallTask.agentStubMap;
    var newAgentStubMap = overallTask.agentStubMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    var overallProgress = true;
    var shouldOverallTaskDirty = false;
    var errMsg = "";
    assert(!stageHandler.createOnAllSeries, errMsg);
    if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, createStub);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(createStub);
    } else {
      overallProgress = false;
      each$f(ecModel.getSeries(), createStub);
    }
    function createStub(seriesModel) {
      var pipelineId = seriesModel.uid;
      var stub = newAgentStubMap.set(pipelineId, oldAgentStubMap && oldAgentStubMap.get(pipelineId) || (shouldOverallTaskDirty = true, createTask({
        reset: stubReset,
        onDirty: stubOnDirty
      })));
      stub.context = {
        model: seriesModel,
        overallProgress
      };
      stub.agent = overallTask;
      stub.__block = overallProgress;
      scheduler._pipe(seriesModel, stub);
    }
    if (shouldOverallTaskDirty) {
      overallTask.dirty();
    }
  };
  Scheduler2.prototype._pipe = function(seriesModel, task) {
    var pipelineId = seriesModel.uid;
    var pipeline = this._pipelineMap.get(pipelineId);
    !pipeline.head && (pipeline.head = task);
    pipeline.tail && pipeline.tail.pipe(task);
    pipeline.tail = task;
    task.__idxInPipeline = pipeline.count++;
    task.__pipeline = pipeline;
  };
  Scheduler2.wrapStageHandler = function(stageHandler, visualType) {
    if (isFunction(stageHandler)) {
      stageHandler = {
        overallReset: stageHandler,
        seriesType: detectSeriseType(stageHandler)
      };
    }
    stageHandler.uid = getUID("stageHandler");
    visualType && (stageHandler.visualType = visualType);
    return stageHandler;
  };
  return Scheduler2;
}();
function overallTaskReset(context) {
  context.overallReset(context.ecModel, context.api, context.payload);
}
function stubReset(context) {
  return context.overallProgress && stubProgress;
}
function stubProgress() {
  this.agent.dirty();
  this.getDownstream().dirty();
}
function stubOnDirty() {
  this.agent && this.agent.dirty();
}
function seriesTaskPlan(context) {
  return context.plan ? context.plan(context.model, context.ecModel, context.api, context.payload) : null;
}
function seriesTaskReset(context) {
  if (context.useClearVisual) {
    context.data.clearAllVisual();
  }
  var resetDefines = context.resetDefines = normalizeToArray(context.reset(context.model, context.ecModel, context.api, context.payload));
  return resetDefines.length > 1 ? map$1(resetDefines, function(v4, idx) {
    return makeSeriesTaskProgress(idx);
  }) : singleSeriesTaskProgress;
}
var singleSeriesTaskProgress = makeSeriesTaskProgress(0);
function makeSeriesTaskProgress(resetDefineIdx) {
  return function(params, context) {
    var data = context.data;
    var resetDefine = context.resetDefines[resetDefineIdx];
    if (resetDefine && resetDefine.dataEach) {
      for (var i = params.start; i < params.end; i++) {
        resetDefine.dataEach(data, i);
      }
    } else if (resetDefine && resetDefine.progress) {
      resetDefine.progress(params, data);
    }
  };
}
function seriesTaskCount(context) {
  return context.data.count();
}
function detectSeriseType(legacyFunc) {
  seriesType = null;
  try {
    legacyFunc(ecModelMock, apiMock);
  } catch (e2) {
  }
  return seriesType;
}
var ecModelMock = {};
var apiMock = {};
var seriesType;
mockMethods(ecModelMock, GlobalModel$1);
mockMethods(apiMock, ExtensionAPI$1);
ecModelMock.eachSeriesByType = ecModelMock.eachRawSeriesByType = function(type4) {
  seriesType = type4;
};
ecModelMock.eachComponent = function(cond) {
  if (cond.mainType === "series" && cond.subType) {
    seriesType = cond.subType;
  }
};
function mockMethods(target, Clz) {
  for (var name_1 in Clz.prototype) {
    target[name_1] = noop;
  }
}
var Scheduler$1 = Scheduler;
var colorAll = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"];
var lightTheme = {
  color: colorAll,
  colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], colorAll]
};
var contrastColor = "#B9B8CE";
var backgroundColor = "#100C2A";
var axisCommon = function() {
  return {
    axisLine: {
      lineStyle: {
        color: contrastColor
      }
    },
    splitLine: {
      lineStyle: {
        color: "#484753"
      }
    },
    splitArea: {
      areaStyle: {
        color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"]
      }
    },
    minorSplitLine: {
      lineStyle: {
        color: "#20203B"
      }
    }
  };
};
var colorPalette = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"];
var theme = {
  darkMode: true,
  color: colorPalette,
  backgroundColor,
  axisPointer: {
    lineStyle: {
      color: "#817f91"
    },
    crossStyle: {
      color: "#817f91"
    },
    label: {
      color: "#fff"
    }
  },
  legend: {
    textStyle: {
      color: contrastColor
    }
  },
  textStyle: {
    color: contrastColor
  },
  title: {
    textStyle: {
      color: "#EEF1FA"
    },
    subtextStyle: {
      color: "#B9B8CE"
    }
  },
  toolbox: {
    iconStyle: {
      borderColor: contrastColor
    }
  },
  dataZoom: {
    borderColor: "#71708A",
    textStyle: {
      color: contrastColor
    },
    brushStyle: {
      color: "rgba(135,163,206,0.3)"
    },
    handleStyle: {
      color: "#353450",
      borderColor: "#C5CBE3"
    },
    moveHandleStyle: {
      color: "#B0B6C3",
      opacity: 0.3
    },
    fillerColor: "rgba(135,163,206,0.2)",
    emphasis: {
      handleStyle: {
        borderColor: "#91B7F2",
        color: "#4D587D"
      },
      moveHandleStyle: {
        color: "#636D9A",
        opacity: 0.7
      }
    },
    dataBackground: {
      lineStyle: {
        color: "#71708A",
        width: 1
      },
      areaStyle: {
        color: "#71708A"
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#87A3CE"
      },
      areaStyle: {
        color: "#87A3CE"
      }
    }
  },
  visualMap: {
    textStyle: {
      color: contrastColor
    }
  },
  timeline: {
    lineStyle: {
      color: contrastColor
    },
    label: {
      color: contrastColor
    },
    controlStyle: {
      color: contrastColor,
      borderColor: contrastColor
    }
  },
  calendar: {
    itemStyle: {
      color: backgroundColor
    },
    dayLabel: {
      color: contrastColor
    },
    monthLabel: {
      color: contrastColor
    },
    yearLabel: {
      color: contrastColor
    }
  },
  timeAxis: axisCommon(),
  logAxis: axisCommon(),
  valueAxis: axisCommon(),
  categoryAxis: axisCommon(),
  line: {
    symbol: "circle"
  },
  graph: {
    color: colorPalette
  },
  gauge: {
    title: {
      color: contrastColor
    },
    axisLine: {
      lineStyle: {
        color: [[1, "rgba(207,212,219,0.2)"]]
      }
    },
    axisLabel: {
      color: contrastColor
    },
    detail: {
      color: "#EEF1FA"
    }
  },
  candlestick: {
    itemStyle: {
      color: "#f64e56",
      color0: "#54ea92",
      borderColor: "#f64e56",
      borderColor0: "#54ea92"
    }
  }
};
theme.categoryAxis.splitLine.show = false;
var darkTheme = theme;
var ECEventProcessor = function() {
  function ECEventProcessor2() {
  }
  ECEventProcessor2.prototype.normalizeQuery = function(query) {
    var cptQuery = {};
    var dataQuery = {};
    var otherQuery = {};
    if (isString(query)) {
      var condCptType = parseClassType(query);
      cptQuery.mainType = condCptType.main || null;
      cptQuery.subType = condCptType.sub || null;
    } else {
      var suffixes_1 = ["Index", "Name", "Id"];
      var dataKeys_1 = {
        name: 1,
        dataIndex: 1,
        dataType: 1
      };
      each$f(query, function(val, key) {
        var reserved = false;
        for (var i = 0; i < suffixes_1.length; i++) {
          var propSuffix = suffixes_1[i];
          var suffixPos = key.lastIndexOf(propSuffix);
          if (suffixPos > 0 && suffixPos === key.length - propSuffix.length) {
            var mainType = key.slice(0, suffixPos);
            if (mainType !== "data") {
              cptQuery.mainType = mainType;
              cptQuery[propSuffix.toLowerCase()] = val;
              reserved = true;
            }
          }
        }
        if (dataKeys_1.hasOwnProperty(key)) {
          dataQuery[key] = val;
          reserved = true;
        }
        if (!reserved) {
          otherQuery[key] = val;
        }
      });
    }
    return {
      cptQuery,
      dataQuery,
      otherQuery
    };
  };
  ECEventProcessor2.prototype.filter = function(eventType, query) {
    var eventInfo = this.eventInfo;
    if (!eventInfo) {
      return true;
    }
    var targetEl = eventInfo.targetEl;
    var packedEvent = eventInfo.packedEvent;
    var model = eventInfo.model;
    var view = eventInfo.view;
    if (!model || !view) {
      return true;
    }
    var cptQuery = query.cptQuery;
    var dataQuery = query.dataQuery;
    return check(cptQuery, model, "mainType") && check(cptQuery, model, "subType") && check(cptQuery, model, "index", "componentIndex") && check(cptQuery, model, "name") && check(cptQuery, model, "id") && check(dataQuery, packedEvent, "name") && check(dataQuery, packedEvent, "dataIndex") && check(dataQuery, packedEvent, "dataType") && (!view.filterForExposedEvent || view.filterForExposedEvent(eventType, query.otherQuery, targetEl, packedEvent));
    function check(query2, host, prop, propOnHost) {
      return query2[prop] == null || host[propOnHost || prop] === query2[prop];
    }
  };
  ECEventProcessor2.prototype.afterTrigger = function() {
    this.eventInfo = null;
  };
  return ECEventProcessor2;
}();
var SYMBOL_PROPS_WITH_CB = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"];
var SYMBOL_PROPS = SYMBOL_PROPS_WITH_CB.concat(["symbolKeepAspect"]);
var seriesSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    if (seriesModel.legendIcon) {
      data.setVisual("legendIcon", seriesModel.legendIcon);
    }
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    var symbolOptions = {};
    var symbolOptionsCb = {};
    var hasCallback = false;
    for (var i = 0; i < SYMBOL_PROPS_WITH_CB.length; i++) {
      var symbolPropName = SYMBOL_PROPS_WITH_CB[i];
      var val = seriesModel.get(symbolPropName);
      if (isFunction(val)) {
        hasCallback = true;
        symbolOptionsCb[symbolPropName] = val;
      } else {
        symbolOptions[symbolPropName] = val;
      }
    }
    symbolOptions.symbol = symbolOptions.symbol || seriesModel.defaultSymbol;
    data.setVisual(extend({
      legendIcon: seriesModel.legendIcon || symbolOptions.symbol,
      symbolKeepAspect: seriesModel.get("symbolKeepAspect")
    }, symbolOptions));
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var symbolPropsCb = keys(symbolOptionsCb);
    function dataEach(data2, idx) {
      var rawValue = seriesModel.getRawValue(idx);
      var params = seriesModel.getDataParams(idx);
      for (var i2 = 0; i2 < symbolPropsCb.length; i2++) {
        var symbolPropName2 = symbolPropsCb[i2];
        data2.setItemVisual(idx, symbolPropName2, symbolOptionsCb[symbolPropName2](rawValue, params));
      }
    }
    return {
      dataEach: hasCallback ? dataEach : null
    };
  }
};
var dataSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      for (var i = 0; i < SYMBOL_PROPS.length; i++) {
        var symbolPropName = SYMBOL_PROPS[i];
        var val = itemModel.getShallow(symbolPropName, true);
        if (val != null) {
          data2.setItemVisual(idx, symbolPropName, val);
        }
      }
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
function getItemVisualFromData(data, dataIndex, key) {
  switch (key) {
    case "color":
      var style = data.getItemVisual(dataIndex, "style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getItemVisual(dataIndex, "style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getItemVisual(dataIndex, key);
  }
}
function getVisualFromData(data, key) {
  switch (key) {
    case "color":
      var style = data.getVisual("style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getVisual("style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getVisual(key);
  }
}
function setItemVisualFromData(data, dataIndex, key, value) {
  switch (key) {
    case "color":
      var style = data.ensureUniqueItemVisual(dataIndex, "style");
      style[data.getVisual("drawType")] = value;
      data.setItemVisual(dataIndex, "colorFromPalette", false);
      break;
    case "opacity":
      data.ensureUniqueItemVisual(dataIndex, "style").opacity = value;
      break;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      data.setItemVisual(dataIndex, key, value);
      break;
  }
}
function createLegacyDataSelectAction(seriesType2, ecRegisterAction) {
  function getSeriesIndices(ecModel, payload) {
    var seriesIndices = [];
    ecModel.eachComponent({
      mainType: "series",
      subType: seriesType2,
      query: payload
    }, function(seriesModel) {
      seriesIndices.push(seriesModel.seriesIndex);
    });
    return seriesIndices;
  }
  each$f([[seriesType2 + "ToggleSelect", "toggleSelect"], [seriesType2 + "Select", "select"], [seriesType2 + "UnSelect", "unselect"]], function(eventsMap) {
    ecRegisterAction(eventsMap[0], function(payload, ecModel, api) {
      payload = extend({}, payload);
      api.dispatchAction(extend(payload, {
        type: eventsMap[1],
        seriesIndex: getSeriesIndices(ecModel, payload)
      }));
    });
  });
}
function handleSeriesLegacySelectEvents(type4, eventPostfix, ecIns, ecModel, payload) {
  var legacyEventName = type4 + eventPostfix;
  if (!ecIns.isSilent(legacyEventName)) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "pie"
    }, function(seriesModel) {
      var seriesIndex = seriesModel.seriesIndex;
      var selectedMap = seriesModel.option.selectedMap;
      var selected = payload.selected;
      for (var i = 0; i < selected.length; i++) {
        if (selected[i].seriesIndex === seriesIndex) {
          var data = seriesModel.getData();
          var dataIndex = queryDataIndex(data, payload.fromActionPayload);
          ecIns.trigger(legacyEventName, {
            type: legacyEventName,
            seriesId: seriesModel.id,
            name: isArray$1(dataIndex) ? data.getName(dataIndex[0]) : data.getName(dataIndex),
            selected: isString(selectedMap) ? selectedMap : extend({}, selectedMap)
          });
        }
      }
    });
  }
}
function handleLegacySelectEvents(messageCenter, ecIns, api) {
  messageCenter.on("selectchanged", function(params) {
    var ecModel = api.getModel();
    if (params.isFromClick) {
      handleSeriesLegacySelectEvents("map", "selectchanged", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selectchanged", ecIns, ecModel, params);
    } else if (params.fromAction === "select") {
      handleSeriesLegacySelectEvents("map", "selected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selected", ecIns, ecModel, params);
    } else if (params.fromAction === "unselect") {
      handleSeriesLegacySelectEvents("map", "unselected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "unselected", ecIns, ecModel, params);
    }
  });
}
function findEventDispatcher(target, det, returnFirstMatch) {
  var found;
  while (target) {
    if (det(target)) {
      found = target;
      if (returnFirstMatch) {
        break;
      }
    }
    target = target.__hostTarget || target.parent;
  }
  return found;
}
var wmUniqueIndex = Math.round(Math.random() * 9);
var supportDefineProperty = typeof Object.defineProperty === "function";
var WeakMap2 = function() {
  function WeakMap3() {
    this._id = "__ec_inner_" + wmUniqueIndex++;
  }
  WeakMap3.prototype.get = function(key) {
    return this._guard(key)[this._id];
  };
  WeakMap3.prototype.set = function(key, value) {
    var target = this._guard(key);
    if (supportDefineProperty) {
      Object.defineProperty(target, this._id, {
        value,
        enumerable: false,
        configurable: true
      });
    } else {
      target[this._id] = value;
    }
    return this;
  };
  WeakMap3.prototype["delete"] = function(key) {
    if (this.has(key)) {
      delete this._guard(key)[this._id];
      return true;
    }
    return false;
  };
  WeakMap3.prototype.has = function(key) {
    return !!this._guard(key)[this._id];
  };
  WeakMap3.prototype._guard = function(key) {
    if (key !== Object(key)) {
      throw TypeError("Value of WeakMap is not a non-null object.");
    }
    return key;
  };
  return WeakMap3;
}();
var WeakMap$1 = WeakMap2;
var Triangle = Path$1.extend({
  type: "triangle",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy + height);
    path.lineTo(cx - width, cy + height);
    path.closePath();
  }
});
var Diamond = Path$1.extend({
  type: "diamond",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy);
    path.lineTo(cx, cy + height);
    path.lineTo(cx - width, cy);
    path.closePath();
  }
});
var Pin = Path$1.extend({
  type: "pin",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var x2 = shape.x;
    var y2 = shape.y;
    var w2 = shape.width / 5 * 3;
    var h = Math.max(w2, shape.height);
    var r2 = w2 / 2;
    var dy = r2 * r2 / (h - r2);
    var cy = y2 - h + r2 + dy;
    var angle = Math.asin(dy / r2);
    var dx = Math.cos(angle) * r2;
    var tanX = Math.sin(angle);
    var tanY = Math.cos(angle);
    var cpLen = r2 * 0.6;
    var cpLen2 = r2 * 0.7;
    path.moveTo(x2 - dx, cy + dy);
    path.arc(x2, cy, r2, Math.PI - angle, Math.PI * 2 + angle);
    path.bezierCurveTo(x2 + dx - tanX * cpLen, cy + dy + tanY * cpLen, x2, y2 - cpLen2, x2, y2);
    path.bezierCurveTo(x2, y2 - cpLen2, x2 - dx + tanX * cpLen, cy + dy + tanY * cpLen, x2 - dx, cy + dy);
    path.closePath();
  }
});
var Arrow = Path$1.extend({
  type: "arrow",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(ctx, shape) {
    var height = shape.height;
    var width = shape.width;
    var x2 = shape.x;
    var y2 = shape.y;
    var dx = width / 3 * 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(x2 + dx, y2 + height);
    ctx.lineTo(x2, y2 + height / 4 * 3);
    ctx.lineTo(x2 - dx, y2 + height);
    ctx.lineTo(x2, y2);
    ctx.closePath();
  }
});
var symbolCtors = {
  line: Line$3,
  rect: Rect$3,
  roundRect: Rect$3,
  square: Rect$3,
  circle: Circle$1,
  diamond: Diamond,
  pin: Pin,
  arrow: Arrow,
  triangle: Triangle
};
var symbolShapeMakers = {
  line: function(x2, y2, w2, h, shape) {
    shape.x1 = x2;
    shape.y1 = y2 + h / 2;
    shape.x2 = x2 + w2;
    shape.y2 = y2 + h / 2;
  },
  rect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
  },
  roundRect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
    shape.r = Math.min(w2, h) / 4;
  },
  square: function(x2, y2, w2, h, shape) {
    var size = Math.min(w2, h);
    shape.x = x2;
    shape.y = y2;
    shape.width = size;
    shape.height = size;
  },
  circle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.r = Math.min(w2, h) / 2;
  },
  diamond: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  pin: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  arrow: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  triangle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  }
};
var symbolBuildProxies = {};
each$f(symbolCtors, function(Ctor, name) {
  symbolBuildProxies[name] = new Ctor();
});
var SymbolClz$1 = Path$1.extend({
  type: "symbol",
  shape: {
    symbolType: "",
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  calculateTextPosition: function(out2, config, rect) {
    var res = calculateTextPosition(out2, config, rect);
    var shape = this.shape;
    if (shape && shape.symbolType === "pin" && config.position === "inside") {
      res.y = rect.y + rect.height * 0.4;
    }
    return res;
  },
  buildPath: function(ctx, shape, inBundle) {
    var symbolType = shape.symbolType;
    if (symbolType !== "none") {
      var proxySymbol = symbolBuildProxies[symbolType];
      if (!proxySymbol) {
        symbolType = "rect";
        proxySymbol = symbolBuildProxies[symbolType];
      }
      symbolShapeMakers[symbolType](shape.x, shape.y, shape.width, shape.height, proxySymbol.shape);
      proxySymbol.buildPath(ctx, proxySymbol.shape, inBundle);
    }
  }
});
function symbolPathSetColor(color, innerColor2) {
  if (this.type !== "image") {
    var symbolStyle = this.style;
    if (this.__isEmptyBrush) {
      symbolStyle.stroke = color;
      symbolStyle.fill = innerColor2 || "#fff";
      symbolStyle.lineWidth = 2;
    } else if (this.shape.symbolType === "line") {
      symbolStyle.stroke = color;
    } else {
      symbolStyle.fill = color;
    }
    this.markRedraw();
  }
}
function createSymbol$1(symbolType, x2, y2, w2, h, color, keepAspect) {
  var isEmpty = symbolType.indexOf("empty") === 0;
  if (isEmpty) {
    symbolType = symbolType.substr(5, 1).toLowerCase() + symbolType.substr(6);
  }
  var symbolPath;
  if (symbolType.indexOf("image://") === 0) {
    symbolPath = makeImage(symbolType.slice(8), new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else if (symbolType.indexOf("path://") === 0) {
    symbolPath = makePath(symbolType.slice(7), {}, new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else {
    symbolPath = new SymbolClz$1({
      shape: {
        symbolType,
        x: x2,
        y: y2,
        width: w2,
        height: h
      }
    });
  }
  symbolPath.__isEmptyBrush = isEmpty;
  symbolPath.setColor = symbolPathSetColor;
  if (color) {
    symbolPath.setColor(color);
  }
  return symbolPath;
}
function normalizeSymbolSize(symbolSize) {
  if (!isArray$1(symbolSize)) {
    symbolSize = [+symbolSize, +symbolSize];
  }
  return [symbolSize[0] || 0, symbolSize[1] || 0];
}
function normalizeSymbolOffset(symbolOffset, symbolSize) {
  if (symbolOffset == null) {
    return;
  }
  if (!isArray$1(symbolOffset)) {
    symbolOffset = [symbolOffset, symbolOffset];
  }
  return [parsePercent(symbolOffset[0], symbolSize[0]) || 0, parsePercent(retrieve2(symbolOffset[1], symbolOffset[0]), symbolSize[1]) || 0];
}
function createLinearGradient(ctx, obj, rect) {
  var x2 = obj.x == null ? 0 : obj.x;
  var x22 = obj.x2 == null ? 1 : obj.x2;
  var y2 = obj.y == null ? 0 : obj.y;
  var y22 = obj.y2 == null ? 0 : obj.y2;
  if (!obj.global) {
    x2 = x2 * rect.width + rect.x;
    x22 = x22 * rect.width + rect.x;
    y2 = y2 * rect.height + rect.y;
    y22 = y22 * rect.height + rect.y;
  }
  x2 = isNaN(x2) ? 0 : x2;
  x22 = isNaN(x22) ? 1 : x22;
  y2 = isNaN(y2) ? 0 : y2;
  y22 = isNaN(y22) ? 0 : y22;
  var canvasGradient = ctx.createLinearGradient(x2, y2, x22, y22);
  return canvasGradient;
}
function createRadialGradient(ctx, obj, rect) {
  var width = rect.width;
  var height = rect.height;
  var min3 = Math.min(width, height);
  var x2 = obj.x == null ? 0.5 : obj.x;
  var y2 = obj.y == null ? 0.5 : obj.y;
  var r2 = obj.r == null ? 0.5 : obj.r;
  if (!obj.global) {
    x2 = x2 * width + rect.x;
    y2 = y2 * height + rect.y;
    r2 = r2 * min3;
  }
  var canvasGradient = ctx.createRadialGradient(x2, y2, 0, x2, y2, r2);
  return canvasGradient;
}
function getCanvasGradient(ctx, obj, rect) {
  var canvasGradient = obj.type === "radial" ? createRadialGradient(ctx, obj, rect) : createLinearGradient(ctx, obj, rect);
  var colorStops = obj.colorStops;
  for (var i = 0; i < colorStops.length; i++) {
    canvasGradient.addColorStop(colorStops[i].offset, colorStops[i].color);
  }
  return canvasGradient;
}
function isClipPathChanged(clipPaths, prevClipPaths) {
  if (clipPaths === prevClipPaths || !clipPaths && !prevClipPaths) {
    return false;
  }
  if (!clipPaths || !prevClipPaths || clipPaths.length !== prevClipPaths.length) {
    return true;
  }
  for (var i = 0; i < clipPaths.length; i++) {
    if (clipPaths[i] !== prevClipPaths[i]) {
      return true;
    }
  }
  return false;
}
function parseInt10(val) {
  return parseInt(val, 10);
}
function getSize$1(root2, whIdx, opts) {
  var wh = ["width", "height"][whIdx];
  var cwh = ["clientWidth", "clientHeight"][whIdx];
  var plt = ["paddingLeft", "paddingTop"][whIdx];
  var prb = ["paddingRight", "paddingBottom"][whIdx];
  if (opts[wh] != null && opts[wh] !== "auto") {
    return parseFloat(opts[wh]);
  }
  var stl = document.defaultView.getComputedStyle(root2);
  return (root2[cwh] || parseInt10(stl[wh]) || parseInt10(root2.style[wh])) - (parseInt10(stl[plt]) || 0) - (parseInt10(stl[prb]) || 0) | 0;
}
function normalizeLineDash(lineType, lineWidth) {
  if (!lineType || lineType === "solid" || !(lineWidth > 0)) {
    return null;
  }
  return lineType === "dashed" ? [4 * lineWidth, 2 * lineWidth] : lineType === "dotted" ? [lineWidth] : isNumber(lineType) ? [lineType] : isArray$1(lineType) ? lineType : null;
}
function getLineDash(el) {
  var style = el.style;
  var lineDash = style.lineDash && style.lineWidth > 0 && normalizeLineDash(style.lineDash, style.lineWidth);
  var lineDashOffset = style.lineDashOffset;
  if (lineDash) {
    var lineScale_1 = style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1;
    if (lineScale_1 && lineScale_1 !== 1) {
      lineDash = map$1(lineDash, function(rawVal) {
        return rawVal / lineScale_1;
      });
      lineDashOffset /= lineScale_1;
    }
  }
  return [lineDash, lineDashOffset];
}
var pathProxyForDraw = new PathProxy$1(true);
function styleHasStroke(style) {
  var stroke = style.stroke;
  return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
}
function isValidStrokeFillStyle(strokeOrFill) {
  return typeof strokeOrFill === "string" && strokeOrFill !== "none";
}
function styleHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== "none";
}
function doFillPath(ctx, style) {
  if (style.fillOpacity != null && style.fillOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.fillOpacity * style.opacity;
    ctx.fill();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.fill();
  }
}
function doStrokePath(ctx, style) {
  if (style.strokeOpacity != null && style.strokeOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.strokeOpacity * style.opacity;
    ctx.stroke();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.stroke();
  }
}
function createCanvasPattern(ctx, pattern4, el) {
  var image = createOrUpdateImage(pattern4.image, pattern4.__image, el);
  if (isImageReady(image)) {
    var canvasPattern = ctx.createPattern(image, pattern4.repeat || "repeat");
    if (typeof DOMMatrix === "function" && canvasPattern && canvasPattern.setTransform) {
      var matrix = new DOMMatrix();
      matrix.translateSelf(pattern4.x || 0, pattern4.y || 0);
      matrix.rotateSelf(0, 0, (pattern4.rotation || 0) * RADIAN_TO_DEGREE);
      matrix.scaleSelf(pattern4.scaleX || 1, pattern4.scaleY || 1);
      canvasPattern.setTransform(matrix);
    }
    return canvasPattern;
  }
}
function brushPath(ctx, el, style, inBatch) {
  var _a2;
  var hasStroke = styleHasStroke(style);
  var hasFill = styleHasFill(style);
  var strokePercent = style.strokePercent;
  var strokePart = strokePercent < 1;
  var firstDraw = !el.path;
  if ((!el.silent || strokePart) && firstDraw) {
    el.createPathProxy();
  }
  var path = el.path || pathProxyForDraw;
  var dirtyFlag = el.__dirty;
  if (!inBatch) {
    var fill = style.fill;
    var stroke = style.stroke;
    var hasFillGradient = hasFill && !!fill.colorStops;
    var hasStrokeGradient = hasStroke && !!stroke.colorStops;
    var hasFillPattern = hasFill && !!fill.image;
    var hasStrokePattern = hasStroke && !!stroke.image;
    var fillGradient = void 0;
    var strokeGradient = void 0;
    var fillPattern = void 0;
    var strokePattern = void 0;
    var rect = void 0;
    if (hasFillGradient || hasStrokeGradient) {
      rect = el.getBoundingRect();
    }
    if (hasFillGradient) {
      fillGradient = dirtyFlag ? getCanvasGradient(ctx, fill, rect) : el.__canvasFillGradient;
      el.__canvasFillGradient = fillGradient;
    }
    if (hasStrokeGradient) {
      strokeGradient = dirtyFlag ? getCanvasGradient(ctx, stroke, rect) : el.__canvasStrokeGradient;
      el.__canvasStrokeGradient = strokeGradient;
    }
    if (hasFillPattern) {
      fillPattern = dirtyFlag || !el.__canvasFillPattern ? createCanvasPattern(ctx, fill, el) : el.__canvasFillPattern;
      el.__canvasFillPattern = fillPattern;
    }
    if (hasStrokePattern) {
      strokePattern = dirtyFlag || !el.__canvasStrokePattern ? createCanvasPattern(ctx, stroke, el) : el.__canvasStrokePattern;
      el.__canvasStrokePattern = fillPattern;
    }
    if (hasFillGradient) {
      ctx.fillStyle = fillGradient;
    } else if (hasFillPattern) {
      if (fillPattern) {
        ctx.fillStyle = fillPattern;
      } else {
        hasFill = false;
      }
    }
    if (hasStrokeGradient) {
      ctx.strokeStyle = strokeGradient;
    } else if (hasStrokePattern) {
      if (strokePattern) {
        ctx.strokeStyle = strokePattern;
      } else {
        hasStroke = false;
      }
    }
  }
  var scale2 = el.getGlobalScale();
  path.setScale(scale2[0], scale2[1], el.segmentIgnoreThreshold);
  var lineDash;
  var lineDashOffset;
  if (ctx.setLineDash && style.lineDash) {
    _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
  }
  var needsRebuild = true;
  if (firstDraw || dirtyFlag & SHAPE_CHANGED_BIT) {
    path.setDPR(ctx.dpr);
    if (strokePart) {
      path.setContext(null);
    } else {
      path.setContext(ctx);
      needsRebuild = false;
    }
    path.reset();
    el.buildPath(path, el.shape, inBatch);
    path.toStatic();
    el.pathUpdated();
  }
  if (needsRebuild) {
    path.rebuildPath(ctx, strokePart ? strokePercent : 1);
  }
  if (lineDash) {
    ctx.setLineDash(lineDash);
    ctx.lineDashOffset = lineDashOffset;
  }
  if (!inBatch) {
    if (style.strokeFirst) {
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
      if (hasFill) {
        doFillPath(ctx, style);
      }
    } else {
      if (hasFill) {
        doFillPath(ctx, style);
      }
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
    }
  }
  if (lineDash) {
    ctx.setLineDash([]);
  }
}
function brushImage(ctx, el, style) {
  var image = el.__image = createOrUpdateImage(style.image, el.__image, el, el.onload);
  if (!image || !isImageReady(image)) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var width = el.getWidth();
  var height = el.getHeight();
  var aspect = image.width / image.height;
  if (width == null && height != null) {
    width = height * aspect;
  } else if (height == null && width != null) {
    height = width / aspect;
  } else if (width == null && height == null) {
    width = image.width;
    height = image.height;
  }
  if (style.sWidth && style.sHeight) {
    var sx = style.sx || 0;
    var sy = style.sy || 0;
    ctx.drawImage(image, sx, sy, style.sWidth, style.sHeight, x2, y2, width, height);
  } else if (style.sx && style.sy) {
    var sx = style.sx;
    var sy = style.sy;
    var sWidth = width - sx;
    var sHeight = height - sy;
    ctx.drawImage(image, sx, sy, sWidth, sHeight, x2, y2, width, height);
  } else {
    ctx.drawImage(image, x2, y2, width, height);
  }
}
function brushText(ctx, el, style) {
  var _a2;
  var text = style.text;
  text != null && (text += "");
  if (text) {
    ctx.font = style.font || DEFAULT_FONT;
    ctx.textAlign = style.textAlign;
    ctx.textBaseline = style.textBaseline;
    var lineDash = void 0;
    var lineDashOffset = void 0;
    if (ctx.setLineDash && style.lineDash) {
      _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
    }
    if (lineDash) {
      ctx.setLineDash(lineDash);
      ctx.lineDashOffset = lineDashOffset;
    }
    if (style.strokeFirst) {
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
    } else {
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
    }
    if (lineDash) {
      ctx.setLineDash([]);
    }
  }
}
var SHADOW_NUMBER_PROPS = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"];
var STROKE_PROPS = [
  ["lineCap", "butt"],
  ["lineJoin", "miter"],
  ["miterLimit", 10]
];
function bindCommonProps(ctx, style, prevStyle, forceSetAll, scope) {
  var styleChanged = false;
  if (!forceSetAll) {
    prevStyle = prevStyle || {};
    if (style === prevStyle) {
      return false;
    }
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    flushPathDrawn(ctx, scope);
    styleChanged = true;
    var opacity = Math.max(Math.min(style.opacity, 1), 0);
    ctx.globalAlpha = isNaN(opacity) ? DEFAULT_COMMON_STYLE.opacity : opacity;
  }
  if (forceSetAll || style.blend !== prevStyle.blend) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalCompositeOperation = style.blend || DEFAULT_COMMON_STYLE.blend;
  }
  for (var i = 0; i < SHADOW_NUMBER_PROPS.length; i++) {
    var propName = SHADOW_NUMBER_PROPS[i];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = ctx.dpr * (style[propName] || 0);
    }
  }
  if (forceSetAll || style.shadowColor !== prevStyle.shadowColor) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.shadowColor = style.shadowColor || DEFAULT_COMMON_STYLE.shadowColor;
  }
  return styleChanged;
}
function bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetAll, scope) {
  var style = getStyle(el, scope.inHover);
  var prevStyle = forceSetAll ? null : prevEl && getStyle(prevEl, scope.inHover) || {};
  if (style === prevStyle) {
    return false;
  }
  var styleChanged = bindCommonProps(ctx, style, prevStyle, forceSetAll, scope);
  if (forceSetAll || style.fill !== prevStyle.fill) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.fill) && (ctx.fillStyle = style.fill);
  }
  if (forceSetAll || style.stroke !== prevStyle.stroke) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.stroke) && (ctx.strokeStyle = style.stroke);
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalAlpha = style.opacity == null ? 1 : style.opacity;
  }
  if (el.hasStroke()) {
    var lineWidth = style.lineWidth;
    var newLineWidth = lineWidth / (style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1);
    if (ctx.lineWidth !== newLineWidth) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx.lineWidth = newLineWidth;
    }
  }
  for (var i = 0; i < STROKE_PROPS.length; i++) {
    var prop = STROKE_PROPS[i];
    var propName = prop[0];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = style[propName] || prop[1];
    }
  }
  return styleChanged;
}
function bindImageStyle(ctx, el, prevEl, forceSetAll, scope) {
  return bindCommonProps(ctx, getStyle(el, scope.inHover), prevEl && getStyle(prevEl, scope.inHover), forceSetAll, scope);
}
function setContextTransform(ctx, el) {
  var m2 = el.transform;
  var dpr2 = ctx.dpr || 1;
  if (m2) {
    ctx.setTransform(dpr2 * m2[0], dpr2 * m2[1], dpr2 * m2[2], dpr2 * m2[3], dpr2 * m2[4], dpr2 * m2[5]);
  } else {
    ctx.setTransform(dpr2, 0, 0, dpr2, 0, 0);
  }
}
function updateClipStatus(clipPaths, ctx, scope) {
  var allClipped = false;
  for (var i = 0; i < clipPaths.length; i++) {
    var clipPath = clipPaths[i];
    allClipped = allClipped || clipPath.isZeroArea();
    setContextTransform(ctx, clipPath);
    ctx.beginPath();
    clipPath.buildPath(ctx, clipPath.shape);
    ctx.clip();
  }
  scope.allClipped = allClipped;
}
function isTransformChanged(m0, m1) {
  if (m0 && m1) {
    return m0[0] !== m1[0] || m0[1] !== m1[1] || m0[2] !== m1[2] || m0[3] !== m1[3] || m0[4] !== m1[4] || m0[5] !== m1[5];
  } else if (!m0 && !m1) {
    return false;
  }
  return true;
}
var DRAW_TYPE_PATH = 1;
var DRAW_TYPE_IMAGE = 2;
var DRAW_TYPE_TEXT = 3;
var DRAW_TYPE_INCREMENTAL = 4;
function canPathBatch(style) {
  var hasFill = styleHasFill(style);
  var hasStroke = styleHasStroke(style);
  return !(style.lineDash || !(+hasFill ^ +hasStroke) || hasFill && typeof style.fill !== "string" || hasStroke && typeof style.stroke !== "string" || style.strokePercent < 1 || style.strokeOpacity < 1 || style.fillOpacity < 1);
}
function flushPathDrawn(ctx, scope) {
  scope.batchFill && ctx.fill();
  scope.batchStroke && ctx.stroke();
  scope.batchFill = "";
  scope.batchStroke = "";
}
function getStyle(el, inHover) {
  return inHover ? el.__hoverStyle || el.style : el.style;
}
function brushSingle(ctx, el) {
  brush$1(ctx, el, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
}
function brush$1(ctx, el, scope, isLast) {
  var m2 = el.transform;
  if (!el.shouldBePainted(scope.viewWidth, scope.viewHeight, false, false)) {
    el.__dirty &= ~REDRAW_BIT;
    el.__isRendered = false;
    return;
  }
  var clipPaths = el.__clipPaths;
  var prevElClipPaths = scope.prevElClipPaths;
  var forceSetTransform = false;
  var forceSetStyle = false;
  if (!prevElClipPaths || isClipPathChanged(clipPaths, prevElClipPaths)) {
    if (prevElClipPaths && prevElClipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.restore();
      forceSetStyle = forceSetTransform = true;
      scope.prevElClipPaths = null;
      scope.allClipped = false;
      scope.prevEl = null;
    }
    if (clipPaths && clipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.save();
      updateClipStatus(clipPaths, ctx, scope);
      forceSetTransform = true;
    }
    scope.prevElClipPaths = clipPaths;
  }
  if (scope.allClipped) {
    el.__isRendered = false;
    return;
  }
  el.beforeBrush && el.beforeBrush();
  el.innerBeforeBrush();
  var prevEl = scope.prevEl;
  if (!prevEl) {
    forceSetStyle = forceSetTransform = true;
  }
  var canBatchPath = el instanceof Path$1 && el.autoBatch && canPathBatch(el.style);
  if (forceSetTransform || isTransformChanged(m2, prevEl.transform)) {
    flushPathDrawn(ctx, scope);
    setContextTransform(ctx, el);
  } else if (!canBatchPath) {
    flushPathDrawn(ctx, scope);
  }
  var style = getStyle(el, scope.inHover);
  if (el instanceof Path$1) {
    if (scope.lastDrawType !== DRAW_TYPE_PATH) {
      forceSetStyle = true;
      scope.lastDrawType = DRAW_TYPE_PATH;
    }
    bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
    if (!canBatchPath || !scope.batchFill && !scope.batchStroke) {
      ctx.beginPath();
    }
    brushPath(ctx, el, style, canBatchPath);
    if (canBatchPath) {
      scope.batchFill = style.fill || "";
      scope.batchStroke = style.stroke || "";
    }
  } else {
    if (el instanceof TSpan$1) {
      if (scope.lastDrawType !== DRAW_TYPE_TEXT) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_TEXT;
      }
      bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushText(ctx, el, style);
    } else if (el instanceof ZRImage$1) {
      if (scope.lastDrawType !== DRAW_TYPE_IMAGE) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_IMAGE;
      }
      bindImageStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushImage(ctx, el, style);
    } else if (el.getTemporalDisplayables) {
      if (scope.lastDrawType !== DRAW_TYPE_INCREMENTAL) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_INCREMENTAL;
      }
      brushIncremental(ctx, el, scope);
    }
  }
  if (canBatchPath && isLast) {
    flushPathDrawn(ctx, scope);
  }
  el.innerAfterBrush();
  el.afterBrush && el.afterBrush();
  scope.prevEl = el;
  el.__dirty = 0;
  el.__isRendered = true;
}
function brushIncremental(ctx, el, scope) {
  var displayables = el.getDisplayables();
  var temporalDisplayables = el.getTemporalDisplayables();
  ctx.save();
  var innerScope = {
    prevElClipPaths: null,
    prevEl: null,
    allClipped: false,
    viewWidth: scope.viewWidth,
    viewHeight: scope.viewHeight,
    inHover: scope.inHover
  };
  var i;
  var len2;
  for (i = el.getCursor(), len2 = displayables.length; i < len2; i++) {
    var displayable = displayables[i];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i === len2 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  for (var i_1 = 0, len_1 = temporalDisplayables.length; i_1 < len_1; i_1++) {
    var displayable = temporalDisplayables[i_1];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i_1 === len_1 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  el.clearTemporalDisplayables();
  el.notClear = true;
  ctx.restore();
}
var decalMap = new WeakMap$1();
var decalCache = new LRU$1(100);
var decalKeys = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
function createOrUpdatePatternFromDecal(decalObject, api) {
  if (decalObject === "none") {
    return null;
  }
  var dpr2 = api.getDevicePixelRatio();
  var zr = api.getZr();
  var isSVG = zr.painter.type === "svg";
  if (decalObject.dirty) {
    decalMap["delete"](decalObject);
  }
  var oldPattern = decalMap.get(decalObject);
  if (oldPattern) {
    return oldPattern;
  }
  var decalOpt = defaults(decalObject, {
    symbol: "rect",
    symbolSize: 1,
    symbolKeepAspect: true,
    color: "rgba(0, 0, 0, 0.2)",
    backgroundColor: null,
    dashArrayX: 5,
    dashArrayY: 5,
    rotation: 0,
    maxTileWidth: 512,
    maxTileHeight: 512
  });
  if (decalOpt.backgroundColor === "none") {
    decalOpt.backgroundColor = null;
  }
  var pattern4 = {
    repeat: "repeat"
  };
  setPatternnSource(pattern4);
  pattern4.rotation = decalOpt.rotation;
  pattern4.scaleX = pattern4.scaleY = isSVG ? 1 : 1 / dpr2;
  decalMap.set(decalObject, pattern4);
  decalObject.dirty = false;
  return pattern4;
  function setPatternnSource(pattern5) {
    var keys2 = [dpr2];
    var isValidKey = true;
    for (var i = 0; i < decalKeys.length; ++i) {
      var value = decalOpt[decalKeys[i]];
      if (value != null && !isArray$1(value) && !isString(value) && !isNumber(value) && typeof value !== "boolean") {
        isValidKey = false;
        break;
      }
      keys2.push(value);
    }
    var cacheKey;
    if (isValidKey) {
      cacheKey = keys2.join(",") + (isSVG ? "-svg" : "");
      var cache = decalCache.get(cacheKey);
      if (cache) {
        isSVG ? pattern5.svgElement = cache : pattern5.image = cache;
      }
    }
    var dashArrayX = normalizeDashArrayX(decalOpt.dashArrayX);
    var dashArrayY = normalizeDashArrayY(decalOpt.dashArrayY);
    var symbolArray = normalizeSymbolArray(decalOpt.symbol);
    var lineBlockLengthsX = getLineBlockLengthX(dashArrayX);
    var lineBlockLengthY = getLineBlockLengthY(dashArrayY);
    var canvas = !isSVG && platformApi.createCanvas();
    var svgRoot = isSVG && {
      tag: "g",
      attrs: {},
      key: "dcl",
      children: []
    };
    var pSize = getPatternSize();
    var ctx;
    if (canvas) {
      canvas.width = pSize.width * dpr2;
      canvas.height = pSize.height * dpr2;
      ctx = canvas.getContext("2d");
    }
    brushDecal();
    if (isValidKey) {
      decalCache.put(cacheKey, canvas || svgRoot);
    }
    pattern5.image = canvas;
    pattern5.svgElement = svgRoot;
    pattern5.svgWidth = pSize.width;
    pattern5.svgHeight = pSize.height;
    function getPatternSize() {
      var width = 1;
      for (var i2 = 0, xlen = lineBlockLengthsX.length; i2 < xlen; ++i2) {
        width = getLeastCommonMultiple(width, lineBlockLengthsX[i2]);
      }
      var symbolRepeats = 1;
      for (var i2 = 0, xlen = symbolArray.length; i2 < xlen; ++i2) {
        symbolRepeats = getLeastCommonMultiple(symbolRepeats, symbolArray[i2].length);
      }
      width *= symbolRepeats;
      var height = lineBlockLengthY * lineBlockLengthsX.length * symbolArray.length;
      return {
        width: Math.max(1, Math.min(width, decalOpt.maxTileWidth)),
        height: Math.max(1, Math.min(height, decalOpt.maxTileHeight))
      };
    }
    function brushDecal() {
      if (ctx) {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        if (decalOpt.backgroundColor) {
          ctx.fillStyle = decalOpt.backgroundColor;
          ctx.fillRect(0, 0, canvas.width, canvas.height);
        }
      }
      var ySum = 0;
      for (var i2 = 0; i2 < dashArrayY.length; ++i2) {
        ySum += dashArrayY[i2];
      }
      if (ySum <= 0) {
        return;
      }
      var y2 = -lineBlockLengthY;
      var yId = 0;
      var yIdTotal = 0;
      var xId0 = 0;
      while (y2 < pSize.height) {
        if (yId % 2 === 0) {
          var symbolYId = yIdTotal / 2 % symbolArray.length;
          var x2 = 0;
          var xId1 = 0;
          var xId1Total = 0;
          while (x2 < pSize.width * 2) {
            var xSum = 0;
            for (var i2 = 0; i2 < dashArrayX[xId0].length; ++i2) {
              xSum += dashArrayX[xId0][i2];
            }
            if (xSum <= 0) {
              break;
            }
            if (xId1 % 2 === 0) {
              var size = (1 - decalOpt.symbolSize) * 0.5;
              var left = x2 + dashArrayX[xId0][xId1] * size;
              var top_1 = y2 + dashArrayY[yId] * size;
              var width = dashArrayX[xId0][xId1] * decalOpt.symbolSize;
              var height = dashArrayY[yId] * decalOpt.symbolSize;
              var symbolXId = xId1Total / 2 % symbolArray[symbolYId].length;
              brushSymbol(left, top_1, width, height, symbolArray[symbolYId][symbolXId]);
            }
            x2 += dashArrayX[xId0][xId1];
            ++xId1Total;
            ++xId1;
            if (xId1 === dashArrayX[xId0].length) {
              xId1 = 0;
            }
          }
          ++xId0;
          if (xId0 === dashArrayX.length) {
            xId0 = 0;
          }
        }
        y2 += dashArrayY[yId];
        ++yIdTotal;
        ++yId;
        if (yId === dashArrayY.length) {
          yId = 0;
        }
      }
      function brushSymbol(x3, y3, width2, height2, symbolType) {
        var scale2 = isSVG ? 1 : dpr2;
        var symbol = createSymbol$1(symbolType, x3 * scale2, y3 * scale2, width2 * scale2, height2 * scale2, decalOpt.color, decalOpt.symbolKeepAspect);
        if (isSVG) {
          var symbolVNode = zr.painter.renderOneToVNode(symbol);
          if (symbolVNode) {
            svgRoot.children.push(symbolVNode);
          }
        } else {
          brushSingle(ctx, symbol);
        }
      }
    }
  }
}
function normalizeSymbolArray(symbol) {
  if (!symbol || symbol.length === 0) {
    return [["rect"]];
  }
  if (isString(symbol)) {
    return [[symbol]];
  }
  var isAllString = true;
  for (var i = 0; i < symbol.length; ++i) {
    if (!isString(symbol[i])) {
      isAllString = false;
      break;
    }
  }
  if (isAllString) {
    return normalizeSymbolArray([symbol]);
  }
  var result = [];
  for (var i = 0; i < symbol.length; ++i) {
    if (isString(symbol[i])) {
      result.push([symbol[i]]);
    } else {
      result.push(symbol[i]);
    }
  }
  return result;
}
function normalizeDashArrayX(dash) {
  if (!dash || dash.length === 0) {
    return [[0, 0]];
  }
  if (isNumber(dash)) {
    var dashValue = Math.ceil(dash);
    return [[dashValue, dashValue]];
  }
  var isAllNumber = true;
  for (var i = 0; i < dash.length; ++i) {
    if (!isNumber(dash[i])) {
      isAllNumber = false;
      break;
    }
  }
  if (isAllNumber) {
    return normalizeDashArrayX([dash]);
  }
  var result = [];
  for (var i = 0; i < dash.length; ++i) {
    if (isNumber(dash[i])) {
      var dashValue = Math.ceil(dash[i]);
      result.push([dashValue, dashValue]);
    } else {
      var dashValue = map$1(dash[i], function(n2) {
        return Math.ceil(n2);
      });
      if (dashValue.length % 2 === 1) {
        result.push(dashValue.concat(dashValue));
      } else {
        result.push(dashValue);
      }
    }
  }
  return result;
}
function normalizeDashArrayY(dash) {
  if (!dash || typeof dash === "object" && dash.length === 0) {
    return [0, 0];
  }
  if (isNumber(dash)) {
    var dashValue_1 = Math.ceil(dash);
    return [dashValue_1, dashValue_1];
  }
  var dashValue = map$1(dash, function(n2) {
    return Math.ceil(n2);
  });
  return dash.length % 2 ? dashValue.concat(dashValue) : dashValue;
}
function getLineBlockLengthX(dash) {
  return map$1(dash, function(line) {
    return getLineBlockLengthY(line);
  });
}
function getLineBlockLengthY(dash) {
  var blockLength = 0;
  for (var i = 0; i < dash.length; ++i) {
    blockLength += dash[i];
  }
  if (dash.length % 2 === 1) {
    return blockLength * 2;
  }
  return blockLength;
}
function decalVisual(ecModel, api) {
  ecModel.eachRawSeries(function(seriesModel) {
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    if (data.hasItemVisual()) {
      data.each(function(idx) {
        var decal2 = data.getItemVisual(idx, "decal");
        if (decal2) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          itemStyle.decal = createOrUpdatePatternFromDecal(decal2, api);
        }
      });
    }
    var decal = data.getVisual("decal");
    if (decal) {
      var style = data.getVisual("style");
      style.decal = createOrUpdatePatternFromDecal(decal, api);
    }
  });
}
var lifecycle = new Eventful$1();
var lifecycle$1 = lifecycle;
var implsStore = {};
function registerImpl(name, impl) {
  implsStore[name] = impl;
}
function getImpl(name) {
  return implsStore[name];
}
var hasWindow = typeof window !== "undefined";
var TEST_FRAME_REMAIN_TIME = 1;
var PRIORITY_PROCESSOR_SERIES_FILTER = 800;
var PRIORITY_PROCESSOR_DATASTACK = 900;
var PRIORITY_PROCESSOR_FILTER = 1e3;
var PRIORITY_PROCESSOR_DEFAULT = 2e3;
var PRIORITY_PROCESSOR_STATISTIC = 5e3;
var PRIORITY_VISUAL_LAYOUT = 1e3;
var PRIORITY_VISUAL_PROGRESSIVE_LAYOUT = 1100;
var PRIORITY_VISUAL_GLOBAL = 2e3;
var PRIORITY_VISUAL_CHART = 3e3;
var PRIORITY_VISUAL_COMPONENT = 4e3;
var PRIORITY_VISUAL_CHART_DATA_CUSTOM = 4500;
var PRIORITY_VISUAL_POST_CHART_LAYOUT = 4600;
var PRIORITY_VISUAL_BRUSH = 5e3;
var PRIORITY_VISUAL_ARIA = 6e3;
var PRIORITY_VISUAL_DECAL = 7e3;
var PRIORITY = {
  PROCESSOR: {
    FILTER: PRIORITY_PROCESSOR_FILTER,
    SERIES_FILTER: PRIORITY_PROCESSOR_SERIES_FILTER,
    STATISTIC: PRIORITY_PROCESSOR_STATISTIC
  },
  VISUAL: {
    LAYOUT: PRIORITY_VISUAL_LAYOUT,
    PROGRESSIVE_LAYOUT: PRIORITY_VISUAL_PROGRESSIVE_LAYOUT,
    GLOBAL: PRIORITY_VISUAL_GLOBAL,
    CHART: PRIORITY_VISUAL_CHART,
    POST_CHART_LAYOUT: PRIORITY_VISUAL_POST_CHART_LAYOUT,
    COMPONENT: PRIORITY_VISUAL_COMPONENT,
    BRUSH: PRIORITY_VISUAL_BRUSH,
    CHART_ITEM: PRIORITY_VISUAL_CHART_DATA_CUSTOM,
    ARIA: PRIORITY_VISUAL_ARIA,
    DECAL: PRIORITY_VISUAL_DECAL
  }
};
var IN_MAIN_PROCESS_KEY = "__flagInMainProcess";
var PENDING_UPDATE = "__pendingUpdate";
var STATUS_NEEDS_UPDATE_KEY = "__needsUpdateStatus";
var ACTION_REG = /^[a-zA-Z0-9_]+$/;
var CONNECT_STATUS_KEY = "__connectUpdateStatus";
var CONNECT_STATUS_PENDING = 0;
var CONNECT_STATUS_UPDATING = 1;
var CONNECT_STATUS_UPDATED = 2;
function createRegisterEventWithLowercaseECharts(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    if (this.isDisposed()) {
      disposedWarning(this.id);
      return;
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function createRegisterEventWithLowercaseMessageCenter(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function toLowercaseNameAndCallEventful(host, method4, args) {
  args[0] = args[0] && args[0].toLowerCase();
  return Eventful$1.prototype[method4].apply(host, args);
}
var MessageCenter = function(_super) {
  __extends(MessageCenter2, _super);
  function MessageCenter2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return MessageCenter2;
}(Eventful$1);
var messageCenterProto = MessageCenter.prototype;
messageCenterProto.on = createRegisterEventWithLowercaseMessageCenter("on");
messageCenterProto.off = createRegisterEventWithLowercaseMessageCenter("off");
var prepare;
var prepareView;
var updateDirectly;
var updateMethods;
var doConvertPixel;
var updateStreamModes;
var doDispatchAction;
var flushPendingActions;
var triggerUpdatedEvent;
var bindRenderedEvent;
var bindMouseEvent;
var render;
var renderComponents;
var renderSeries;
var createExtensionAPI;
var enableConnect;
var markStatusToUpdate;
var applyChangedStates;
var ECharts = function(_super) {
  __extends(ECharts2, _super);
  function ECharts2(dom, theme2, opts) {
    var _this = _super.call(this, new ECEventProcessor()) || this;
    _this._chartsViews = [];
    _this._chartsMap = {};
    _this._componentsViews = [];
    _this._componentsMap = {};
    _this._pendingActions = [];
    opts = opts || {};
    if (isString(theme2)) {
      theme2 = themeStorage[theme2];
    }
    _this._dom = dom;
    var defaultRenderer = "canvas";
    var defaultUseDirtyRect = false;
    var zr = _this._zr = init$2(dom, {
      renderer: opts.renderer || defaultRenderer,
      devicePixelRatio: opts.devicePixelRatio,
      width: opts.width,
      height: opts.height,
      ssr: opts.ssr,
      useDirtyRect: opts.useDirtyRect == null ? defaultUseDirtyRect : opts.useDirtyRect
    });
    _this._ssr = opts.ssr;
    _this._throttledZrFlush = throttle(bind$1(zr.flush, zr), 17);
    theme2 = clone$4(theme2);
    theme2 && globalBackwardCompat(theme2, true);
    _this._theme = theme2;
    _this._locale = createLocaleObject(opts.locale || SYSTEM_LANG);
    _this._coordSysMgr = new CoordinateSystem();
    var api = _this._api = createExtensionAPI(_this);
    function prioritySortFunc(a, b2) {
      return a.__prio - b2.__prio;
    }
    sort$2(visualFuncs, prioritySortFunc);
    sort$2(dataProcessorFuncs, prioritySortFunc);
    _this._scheduler = new Scheduler$1(_this, api, dataProcessorFuncs, visualFuncs);
    _this._messageCenter = new MessageCenter();
    _this._initEvents();
    _this.resize = bind$1(_this.resize, _this);
    zr.animation.on("frame", _this._onframe, _this);
    bindRenderedEvent(zr, _this);
    bindMouseEvent(zr, _this);
    setAsPrimitive(_this);
    return _this;
  }
  ECharts2.prototype._onframe = function() {
    if (this._disposed) {
      return;
    }
    applyChangedStates(this);
    var scheduler = this._scheduler;
    if (this[PENDING_UPDATE]) {
      var silent = this[PENDING_UPDATE].silent;
      this[IN_MAIN_PROCESS_KEY] = true;
      try {
        prepare(this);
        updateMethods.update.call(this, null, this[PENDING_UPDATE].updateParams);
      } catch (e2) {
        this[IN_MAIN_PROCESS_KEY] = false;
        this[PENDING_UPDATE] = null;
        throw e2;
      }
      this._zr.flush();
      this[IN_MAIN_PROCESS_KEY] = false;
      this[PENDING_UPDATE] = null;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    } else if (scheduler.unfinished) {
      var remainTime = TEST_FRAME_REMAIN_TIME;
      var ecModel = this._model;
      var api = this._api;
      scheduler.unfinished = false;
      do {
        var startTime = +new Date();
        scheduler.performSeriesTasks(ecModel);
        scheduler.performDataProcessorTasks(ecModel);
        updateStreamModes(this, ecModel);
        scheduler.performVisualTasks(ecModel);
        renderSeries(this, this._model, api, "remain", {});
        remainTime -= +new Date() - startTime;
      } while (remainTime > 0 && scheduler.unfinished);
      if (!scheduler.unfinished) {
        this._zr.flush();
      }
    }
  };
  ECharts2.prototype.getDom = function() {
    return this._dom;
  };
  ECharts2.prototype.getId = function() {
    return this.id;
  };
  ECharts2.prototype.getZr = function() {
    return this._zr;
  };
  ECharts2.prototype.isSSR = function() {
    return this._ssr;
  };
  ECharts2.prototype.setOption = function(option, notMerge, lazyUpdate) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var silent;
    var replaceMerge;
    var transitionOpt;
    if (isObject$4(notMerge)) {
      lazyUpdate = notMerge.lazyUpdate;
      silent = notMerge.silent;
      replaceMerge = notMerge.replaceMerge;
      transitionOpt = notMerge.transition;
      notMerge = notMerge.notMerge;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    if (!this._model || notMerge) {
      var optionManager = new OptionManager$1(this._api);
      var theme2 = this._theme;
      var ecModel = this._model = new GlobalModel$1();
      ecModel.scheduler = this._scheduler;
      ecModel.ssr = this._ssr;
      ecModel.init(null, null, null, theme2, this._locale, optionManager);
    }
    this._model.setOption(option, {
      replaceMerge
    }, optionPreprocessorFuncs);
    var updateParams = {
      seriesTransition: transitionOpt,
      optionChanged: true
    };
    if (lazyUpdate) {
      this[PENDING_UPDATE] = {
        silent,
        updateParams
      };
      this[IN_MAIN_PROCESS_KEY] = false;
      this.getZr().wakeUp();
    } else {
      try {
        prepare(this);
        updateMethods.update.call(this, null, updateParams);
      } catch (e2) {
        this[PENDING_UPDATE] = null;
        this[IN_MAIN_PROCESS_KEY] = false;
        throw e2;
      }
      if (!this._ssr) {
        this._zr.flush();
      }
      this[PENDING_UPDATE] = null;
      this[IN_MAIN_PROCESS_KEY] = false;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    }
  };
  ECharts2.prototype.setTheme = function() {
  };
  ECharts2.prototype.getModel = function() {
    return this._model;
  };
  ECharts2.prototype.getOption = function() {
    return this._model && this._model.getOption();
  };
  ECharts2.prototype.getWidth = function() {
    return this._zr.getWidth();
  };
  ECharts2.prototype.getHeight = function() {
    return this._zr.getHeight();
  };
  ECharts2.prototype.getDevicePixelRatio = function() {
    return this._zr.painter.dpr || hasWindow && window.devicePixelRatio || 1;
  };
  ECharts2.prototype.getRenderedCanvas = function(opts) {
    return this.renderToCanvas(opts);
  };
  ECharts2.prototype.renderToCanvas = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.getRenderedCanvas({
      backgroundColor: opts.backgroundColor || this._model.get("backgroundColor"),
      pixelRatio: opts.pixelRatio || this.getDevicePixelRatio()
    });
  };
  ECharts2.prototype.renderToSVGString = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.renderToString({
      useViewBox: opts.useViewBox
    });
  };
  ECharts2.prototype.getSvgDataURL = function() {
    if (!env$1.svgSupported) {
      return;
    }
    var zr = this._zr;
    var list = zr.storage.getDisplayList();
    each$f(list, function(el) {
      el.stopAnimation(null, true);
    });
    return zr.painter.toDataURL();
  };
  ECharts2.prototype.getDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    opts = opts || {};
    var excludeComponents = opts.excludeComponents;
    var ecModel = this._model;
    var excludesComponentViews = [];
    var self2 = this;
    each$f(excludeComponents, function(componentType) {
      ecModel.eachComponent({
        mainType: componentType
      }, function(component) {
        var view = self2._componentsMap[component.__viewId];
        if (!view.group.ignore) {
          excludesComponentViews.push(view);
          view.group.ignore = true;
        }
      });
    });
    var url2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(opts).toDataURL("image/" + (opts && opts.type || "png"));
    each$f(excludesComponentViews, function(view) {
      view.group.ignore = false;
    });
    return url2;
  };
  ECharts2.prototype.getConnectedDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var isSvg = opts.type === "svg";
    var groupId = this.group;
    var mathMin2 = Math.min;
    var mathMax2 = Math.max;
    var MAX_NUMBER = Infinity;
    if (connectedGroups[groupId]) {
      var left_1 = MAX_NUMBER;
      var top_1 = MAX_NUMBER;
      var right_1 = -MAX_NUMBER;
      var bottom_1 = -MAX_NUMBER;
      var canvasList_1 = [];
      var dpr_1 = opts && opts.pixelRatio || this.getDevicePixelRatio();
      each$f(instances, function(chart, id2) {
        if (chart.group === groupId) {
          var canvas = isSvg ? chart.getZr().painter.getSvgDom().innerHTML : chart.renderToCanvas(clone$4(opts));
          var boundingRect = chart.getDom().getBoundingClientRect();
          left_1 = mathMin2(boundingRect.left, left_1);
          top_1 = mathMin2(boundingRect.top, top_1);
          right_1 = mathMax2(boundingRect.right, right_1);
          bottom_1 = mathMax2(boundingRect.bottom, bottom_1);
          canvasList_1.push({
            dom: canvas,
            left: boundingRect.left,
            top: boundingRect.top
          });
        }
      });
      left_1 *= dpr_1;
      top_1 *= dpr_1;
      right_1 *= dpr_1;
      bottom_1 *= dpr_1;
      var width = right_1 - left_1;
      var height = bottom_1 - top_1;
      var targetCanvas = platformApi.createCanvas();
      var zr_1 = init$2(targetCanvas, {
        renderer: isSvg ? "svg" : "canvas"
      });
      zr_1.resize({
        width,
        height
      });
      if (isSvg) {
        var content_1 = "";
        each$f(canvasList_1, function(item) {
          var x2 = item.left - left_1;
          var y2 = item.top - top_1;
          content_1 += '<g transform="translate(' + x2 + "," + y2 + ')">' + item.dom + "</g>";
        });
        zr_1.painter.getSvgRoot().innerHTML = content_1;
        if (opts.connectedBackgroundColor) {
          zr_1.painter.setBackgroundColor(opts.connectedBackgroundColor);
        }
        zr_1.refreshImmediately();
        return zr_1.painter.toDataURL();
      } else {
        if (opts.connectedBackgroundColor) {
          zr_1.add(new Rect$3({
            shape: {
              x: 0,
              y: 0,
              width,
              height
            },
            style: {
              fill: opts.connectedBackgroundColor
            }
          }));
        }
        each$f(canvasList_1, function(item) {
          var img = new ZRImage$1({
            style: {
              x: item.left * dpr_1 - left_1,
              y: item.top * dpr_1 - top_1,
              image: item.dom
            }
          });
          zr_1.add(img);
        });
        zr_1.refreshImmediately();
        return targetCanvas.toDataURL("image/" + (opts && opts.type || "png"));
      }
    } else {
      return this.getDataURL(opts);
    }
  };
  ECharts2.prototype.convertToPixel = function(finder, value) {
    return doConvertPixel(this, "convertToPixel", finder, value);
  };
  ECharts2.prototype.convertFromPixel = function(finder, value) {
    return doConvertPixel(this, "convertFromPixel", finder, value);
  };
  ECharts2.prototype.containPixel = function(finder, value) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var ecModel = this._model;
    var result;
    var findResult = parseFinder$1(ecModel, finder);
    each$f(findResult, function(models, key) {
      key.indexOf("Models") >= 0 && each$f(models, function(model) {
        var coordSys = model.coordinateSystem;
        if (coordSys && coordSys.containPoint) {
          result = result || !!coordSys.containPoint(value);
        } else if (key === "seriesModels") {
          var view = this._chartsMap[model.__viewId];
          if (view && view.containPoint) {
            result = result || view.containPoint(value, model);
          }
        } else
          ;
      }, this);
    }, this);
    return !!result;
  };
  ECharts2.prototype.getVisual = function(finder, visualType) {
    var ecModel = this._model;
    var parsedFinder = parseFinder$1(ecModel, finder, {
      defaultMainType: "series"
    });
    var seriesModel = parsedFinder.seriesModel;
    var data = seriesModel.getData();
    var dataIndexInside = parsedFinder.hasOwnProperty("dataIndexInside") ? parsedFinder.dataIndexInside : parsedFinder.hasOwnProperty("dataIndex") ? data.indexOfRawIndex(parsedFinder.dataIndex) : null;
    return dataIndexInside != null ? getItemVisualFromData(data, dataIndexInside, visualType) : getVisualFromData(data, visualType);
  };
  ECharts2.prototype.getViewOfComponentModel = function(componentModel) {
    return this._componentsMap[componentModel.__viewId];
  };
  ECharts2.prototype.getViewOfSeriesModel = function(seriesModel) {
    return this._chartsMap[seriesModel.__viewId];
  };
  ECharts2.prototype._initEvents = function() {
    var _this = this;
    each$f(MOUSE_EVENT_NAMES, function(eveName) {
      var handler = function(e2) {
        var ecModel = _this.getModel();
        var el = e2.target;
        var params;
        var isGlobalOut = eveName === "globalout";
        if (isGlobalOut) {
          params = {};
        } else {
          el && findEventDispatcher(el, function(parent) {
            var ecData = getECData(parent);
            if (ecData && ecData.dataIndex != null) {
              var dataModel = ecData.dataModel || ecModel.getSeriesByIndex(ecData.seriesIndex);
              params = dataModel && dataModel.getDataParams(ecData.dataIndex, ecData.dataType) || {};
              return true;
            } else if (ecData.eventData) {
              params = extend({}, ecData.eventData);
              return true;
            }
          }, true);
        }
        if (params) {
          var componentType = params.componentType;
          var componentIndex = params.componentIndex;
          if (componentType === "markLine" || componentType === "markPoint" || componentType === "markArea") {
            componentType = "series";
            componentIndex = params.seriesIndex;
          }
          var model = componentType && componentIndex != null && ecModel.getComponent(componentType, componentIndex);
          var view = model && _this[model.mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId];
          params.event = e2;
          params.type = eveName;
          _this._$eventProcessor.eventInfo = {
            targetEl: el,
            packedEvent: params,
            model,
            view
          };
          _this.trigger(eveName, params);
        }
      };
      handler.zrEventfulCallAtLast = true;
      _this._zr.on(eveName, handler, _this);
    });
    each$f(eventActionMap, function(actionType, eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    each$f(["selectchanged"], function(eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    handleLegacySelectEvents(this._messageCenter, this, this._api);
  };
  ECharts2.prototype.isDisposed = function() {
    return this._disposed;
  };
  ECharts2.prototype.clear = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this.setOption({
      series: []
    }, true);
  };
  ECharts2.prototype.dispose = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._disposed = true;
    var dom = this.getDom();
    if (dom) {
      setAttribute(this.getDom(), DOM_ATTRIBUTE_KEY, "");
    }
    var chart = this;
    var api = chart._api;
    var ecModel = chart._model;
    each$f(chart._componentsViews, function(component) {
      component.dispose(ecModel, api);
    });
    each$f(chart._chartsViews, function(chart2) {
      chart2.dispose(ecModel, api);
    });
    chart._zr.dispose();
    chart._dom = chart._model = chart._chartsMap = chart._componentsMap = chart._chartsViews = chart._componentsViews = chart._scheduler = chart._api = chart._zr = chart._throttledZrFlush = chart._theme = chart._coordSysMgr = chart._messageCenter = null;
    delete instances[chart.id];
  };
  ECharts2.prototype.resize = function(opts) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._zr.resize(opts);
    var ecModel = this._model;
    this._loadingFX && this._loadingFX.resize();
    if (!ecModel) {
      return;
    }
    var needPrepare = ecModel.resetOption("media");
    var silent = opts && opts.silent;
    if (this[PENDING_UPDATE]) {
      if (silent == null) {
        silent = this[PENDING_UPDATE].silent;
      }
      needPrepare = true;
      this[PENDING_UPDATE] = null;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    try {
      needPrepare && prepare(this);
      updateMethods.update.call(this, {
        type: "resize",
        animation: extend({
          duration: 0
        }, opts && opts.animation)
      });
    } catch (e2) {
      this[IN_MAIN_PROCESS_KEY] = false;
      throw e2;
    }
    this[IN_MAIN_PROCESS_KEY] = false;
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.showLoading = function(name, cfg) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (isObject$4(name)) {
      cfg = name;
      name = "";
    }
    name = name || "default";
    this.hideLoading();
    if (!loadingEffects[name]) {
      return;
    }
    var el = loadingEffects[name](this._api, cfg);
    var zr = this._zr;
    this._loadingFX = el;
    zr.add(el);
  };
  ECharts2.prototype.hideLoading = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._loadingFX && this._zr.remove(this._loadingFX);
    this._loadingFX = null;
  };
  ECharts2.prototype.makeActionFromEvent = function(eventObj) {
    var payload = extend({}, eventObj);
    payload.type = eventActionMap[eventObj.type];
    return payload;
  };
  ECharts2.prototype.dispatchAction = function(payload, opt) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (!isObject$4(opt)) {
      opt = {
        silent: !!opt
      };
    }
    if (!actions[payload.type]) {
      return;
    }
    if (!this._model) {
      return;
    }
    if (this[IN_MAIN_PROCESS_KEY]) {
      this._pendingActions.push(payload);
      return;
    }
    var silent = opt.silent;
    doDispatchAction.call(this, payload, silent);
    var flush = opt.flush;
    if (flush) {
      this._zr.flush();
    } else if (flush !== false && env$1.browser.weChat) {
      this._throttledZrFlush();
    }
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.updateLabelLayout = function() {
    lifecycle$1.trigger("series:layoutlabels", this._model, this._api, {
      updatedSeries: []
    });
  };
  ECharts2.prototype.appendData = function(params) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var seriesIndex = params.seriesIndex;
    var ecModel = this.getModel();
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    seriesModel.appendData(params);
    this._scheduler.unfinished = true;
    this.getZr().wakeUp();
  };
  ECharts2.internalField = function() {
    prepare = function(ecIns) {
      var scheduler = ecIns._scheduler;
      scheduler.restorePipelines(ecIns._model);
      scheduler.prepareStageTasks();
      prepareView(ecIns, true);
      prepareView(ecIns, false);
      scheduler.plan();
    };
    prepareView = function(ecIns, isComponent) {
      var ecModel = ecIns._model;
      var scheduler = ecIns._scheduler;
      var viewList = isComponent ? ecIns._componentsViews : ecIns._chartsViews;
      var viewMap = isComponent ? ecIns._componentsMap : ecIns._chartsMap;
      var zr = ecIns._zr;
      var api = ecIns._api;
      for (var i = 0; i < viewList.length; i++) {
        viewList[i].__alive = false;
      }
      isComponent ? ecModel.eachComponent(function(componentType, model) {
        componentType !== "series" && doPrepare(model);
      }) : ecModel.eachSeries(doPrepare);
      function doPrepare(model) {
        var requireNewView = model.__requireNewView;
        model.__requireNewView = false;
        var viewId = "_ec_" + model.id + "_" + model.type;
        var view2 = !requireNewView && viewMap[viewId];
        if (!view2) {
          var classType = parseClassType(model.type);
          var Clazz = isComponent ? ComponentView$1.getClass(classType.main, classType.sub) : ChartView$1.getClass(classType.sub);
          view2 = new Clazz();
          view2.init(ecModel, api);
          viewMap[viewId] = view2;
          viewList.push(view2);
          zr.add(view2.group);
        }
        model.__viewId = view2.__id = viewId;
        view2.__alive = true;
        view2.__model = model;
        view2.group.__ecComponentInfo = {
          mainType: model.mainType,
          index: model.componentIndex
        };
        !isComponent && scheduler.prepareView(view2, model, ecModel, api);
      }
      for (var i = 0; i < viewList.length; ) {
        var view = viewList[i];
        if (!view.__alive) {
          !isComponent && view.renderTask.dispose();
          zr.remove(view.group);
          view.dispose(ecModel, api);
          viewList.splice(i, 1);
          if (viewMap[view.__id] === view) {
            delete viewMap[view.__id];
          }
          view.__id = view.group.__ecComponentInfo = null;
        } else {
          i++;
        }
      }
    };
    updateDirectly = function(ecIns, method4, payload, mainType, subType) {
      var ecModel = ecIns._model;
      ecModel.setUpdatePayload(payload);
      if (!mainType) {
        each$f([].concat(ecIns._componentsViews).concat(ecIns._chartsViews), callView);
        return;
      }
      var query = {};
      query[mainType + "Id"] = payload[mainType + "Id"];
      query[mainType + "Index"] = payload[mainType + "Index"];
      query[mainType + "Name"] = payload[mainType + "Name"];
      var condition = {
        mainType,
        query
      };
      subType && (condition.subType = subType);
      var excludeSeriesId = payload.excludeSeriesId;
      var excludeSeriesIdMap;
      if (excludeSeriesId != null) {
        excludeSeriesIdMap = createHashMap();
        each$f(normalizeToArray(excludeSeriesId), function(id2) {
          var modelId = convertOptionIdName(id2, null);
          if (modelId != null) {
            excludeSeriesIdMap.set(modelId, true);
          }
        });
      }
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        if (isHighDownPayload(payload)) {
          if (model instanceof SeriesModel$1) {
            if (payload.type === HIGHLIGHT_ACTION_TYPE && !payload.notBlur && !model.get(["emphasis", "disabled"])) {
              blurSeriesFromHighlightPayload(model, payload, ecIns._api);
            }
          } else {
            var _a2 = findComponentHighDownDispatchers(model.mainType, model.componentIndex, payload.name, ecIns._api), focusSelf = _a2.focusSelf, dispatchers = _a2.dispatchers;
            if (payload.type === HIGHLIGHT_ACTION_TYPE && focusSelf && !payload.notBlur) {
              blurComponent(model.mainType, model.componentIndex, ecIns._api);
            }
            if (dispatchers) {
              each$f(dispatchers, function(dispatcher) {
                payload.type === HIGHLIGHT_ACTION_TYPE ? enterEmphasis(dispatcher) : leaveEmphasis(dispatcher);
              });
            }
          }
        } else if (isSelectChangePayload(payload)) {
          if (model instanceof SeriesModel$1) {
            toggleSelectionFromPayload(model, payload, ecIns._api);
            updateSeriesElementSelection(model);
            markStatusToUpdate(ecIns);
          }
        }
      }, ecIns);
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        callView(ecIns[mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId]);
      }, ecIns);
      function callView(view) {
        view && view.__alive && view[method4] && view[method4](view.__model, ecModel, ecIns._api, payload);
      }
    };
    updateMethods = {
      prepareAndUpdate: function(payload) {
        prepare(this);
        updateMethods.update.call(this, payload, {
          optionChanged: payload.newOption != null
        });
      },
      update: function(payload, updateParams) {
        var ecModel = this._model;
        var api = this._api;
        var zr = this._zr;
        var coordSysMgr = this._coordSysMgr;
        var scheduler = this._scheduler;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        scheduler.restoreData(ecModel, payload);
        scheduler.performSeriesTasks(ecModel);
        coordSysMgr.create(ecModel, api);
        scheduler.performDataProcessorTasks(ecModel, payload);
        updateStreamModes(this, ecModel);
        coordSysMgr.update(ecModel, api);
        clearColorPalette(ecModel);
        scheduler.performVisualTasks(ecModel, payload);
        render(this, ecModel, api, payload, updateParams);
        var backgroundColor2 = ecModel.get("backgroundColor") || "transparent";
        var darkMode = ecModel.get("darkMode");
        zr.setBackgroundColor(backgroundColor2);
        if (darkMode != null && darkMode !== "auto") {
          zr.setDarkMode(darkMode);
        }
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateTransform: function(payload) {
        var _this = this;
        var ecModel = this._model;
        var api = this._api;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        var componentDirtyList = [];
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType === "series") {
            return;
          }
          var componentView = _this.getViewOfComponentModel(componentModel);
          if (componentView && componentView.__alive) {
            if (componentView.updateTransform) {
              var result = componentView.updateTransform(componentModel, ecModel, api, payload);
              result && result.update && componentDirtyList.push(componentView);
            } else {
              componentDirtyList.push(componentView);
            }
          }
        });
        var seriesDirtyMap = createHashMap();
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          if (chartView.updateTransform) {
            var result = chartView.updateTransform(seriesModel, ecModel, api, payload);
            result && result.update && seriesDirtyMap.set(seriesModel.uid, 1);
          } else {
            seriesDirtyMap.set(seriesModel.uid, 1);
          }
        });
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true,
          dirtyMap: seriesDirtyMap
        });
        renderSeries(this, ecModel, api, payload, {}, seriesDirtyMap);
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateView: function(payload) {
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ChartView$1.markUpdateMethod(payload, "updateView");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true
        });
        render(this, ecModel, this._api, payload, {});
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateVisual: function(payload) {
        var _this = this;
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ecModel.eachSeries(function(seriesModel) {
          seriesModel.getData().clearAllVisual();
        });
        ChartView$1.markUpdateMethod(payload, "updateVisual");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          visualType: "visual",
          setDirty: true
        });
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType !== "series") {
            var componentView = _this.getViewOfComponentModel(componentModel);
            componentView && componentView.__alive && componentView.updateVisual(componentModel, ecModel, _this._api, payload);
          }
        });
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          chartView.updateVisual(seriesModel, ecModel, _this._api, payload);
        });
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateLayout: function(payload) {
        updateMethods.update.call(this, payload);
      }
    };
    doConvertPixel = function(ecIns, methodName, finder, value) {
      if (ecIns._disposed) {
        disposedWarning(ecIns.id);
        return;
      }
      var ecModel = ecIns._model;
      var coordSysList = ecIns._coordSysMgr.getCoordinateSystems();
      var result;
      var parsedFinder = parseFinder$1(ecModel, finder);
      for (var i = 0; i < coordSysList.length; i++) {
        var coordSys = coordSysList[i];
        if (coordSys[methodName] && (result = coordSys[methodName](ecModel, parsedFinder, value)) != null) {
          return result;
        }
      }
    };
    updateStreamModes = function(ecIns, ecModel) {
      var chartsMap = ecIns._chartsMap;
      var scheduler = ecIns._scheduler;
      ecModel.eachSeries(function(seriesModel) {
        scheduler.updateStreamModes(seriesModel, chartsMap[seriesModel.__viewId]);
      });
    };
    doDispatchAction = function(payload, silent) {
      var _this = this;
      var ecModel = this.getModel();
      var payloadType = payload.type;
      var escapeConnect = payload.escapeConnect;
      var actionWrap = actions[payloadType];
      var actionInfo2 = actionWrap.actionInfo;
      var cptTypeTmp = (actionInfo2.update || "update").split(":");
      var updateMethod = cptTypeTmp.pop();
      var cptType = cptTypeTmp[0] != null && parseClassType(cptTypeTmp[0]);
      this[IN_MAIN_PROCESS_KEY] = true;
      var payloads = [payload];
      var batched = false;
      if (payload.batch) {
        batched = true;
        payloads = map$1(payload.batch, function(item) {
          item = defaults(extend({}, item), payload);
          item.batch = null;
          return item;
        });
      }
      var eventObjBatch = [];
      var eventObj;
      var isSelectChange = isSelectChangePayload(payload);
      var isHighDown = isHighDownPayload(payload);
      if (isHighDown) {
        allLeaveBlur(this._api);
      }
      each$f(payloads, function(batchItem) {
        eventObj = actionWrap.action(batchItem, _this._model, _this._api);
        eventObj = eventObj || extend({}, batchItem);
        eventObj.type = actionInfo2.event || eventObj.type;
        eventObjBatch.push(eventObj);
        if (isHighDown) {
          var _a2 = preParseFinder(payload), queryOptionMap = _a2.queryOptionMap, mainTypeSpecified = _a2.mainTypeSpecified;
          var componentMainType = mainTypeSpecified ? queryOptionMap.keys()[0] : "series";
          updateDirectly(_this, updateMethod, batchItem, componentMainType);
          markStatusToUpdate(_this);
        } else if (isSelectChange) {
          updateDirectly(_this, updateMethod, batchItem, "series");
          markStatusToUpdate(_this);
        } else if (cptType) {
          updateDirectly(_this, updateMethod, batchItem, cptType.main, cptType.sub);
        }
      });
      if (updateMethod !== "none" && !isHighDown && !isSelectChange && !cptType) {
        try {
          if (this[PENDING_UPDATE]) {
            prepare(this);
            updateMethods.update.call(this, payload);
            this[PENDING_UPDATE] = null;
          } else {
            updateMethods[updateMethod].call(this, payload);
          }
        } catch (e2) {
          this[IN_MAIN_PROCESS_KEY] = false;
          throw e2;
        }
      }
      if (batched) {
        eventObj = {
          type: actionInfo2.event || payloadType,
          escapeConnect,
          batch: eventObjBatch
        };
      } else {
        eventObj = eventObjBatch[0];
      }
      this[IN_MAIN_PROCESS_KEY] = false;
      if (!silent) {
        var messageCenter = this._messageCenter;
        messageCenter.trigger(eventObj.type, eventObj);
        if (isSelectChange) {
          var newObj = {
            type: "selectchanged",
            escapeConnect,
            selected: getAllSelectedIndices(ecModel),
            isFromClick: payload.isFromClick || false,
            fromAction: payload.type,
            fromActionPayload: payload
          };
          messageCenter.trigger(newObj.type, newObj);
        }
      }
    };
    flushPendingActions = function(silent) {
      var pendingActions = this._pendingActions;
      while (pendingActions.length) {
        var payload = pendingActions.shift();
        doDispatchAction.call(this, payload, silent);
      }
    };
    triggerUpdatedEvent = function(silent) {
      !silent && this.trigger("updated");
    };
    bindRenderedEvent = function(zr, ecIns) {
      zr.on("rendered", function(params) {
        ecIns.trigger("rendered", params);
        if (zr.animation.isFinished() && !ecIns[PENDING_UPDATE] && !ecIns._scheduler.unfinished && !ecIns._pendingActions.length) {
          ecIns.trigger("finished");
        }
      });
    };
    bindMouseEvent = function(zr, ecIns) {
      zr.on("mouseover", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOverForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("mouseout", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOutForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("click", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, function(target) {
          return getECData(target).dataIndex != null;
        }, true);
        if (dispatcher) {
          var actionType = dispatcher.selected ? "unselect" : "select";
          var ecData = getECData(dispatcher);
          ecIns._api.dispatchAction({
            type: actionType,
            dataType: ecData.dataType,
            dataIndexInside: ecData.dataIndex,
            seriesIndex: ecData.seriesIndex,
            isFromClick: true
          });
        }
      });
    };
    function clearColorPalette(ecModel) {
      ecModel.clearColorPalette();
      ecModel.eachSeries(function(seriesModel) {
        seriesModel.clearColorPalette();
      });
    }
    function allocateZlevels(ecModel) {
      var componentZLevels = [];
      var seriesZLevels = [];
      var hasSeperateZLevel = false;
      ecModel.eachComponent(function(componentType, componentModel) {
        var zlevel = componentModel.get("zlevel") || 0;
        var z2 = componentModel.get("z") || 0;
        var zlevelKey = componentModel.getZLevelKey();
        hasSeperateZLevel = hasSeperateZLevel || !!zlevelKey;
        (componentType === "series" ? seriesZLevels : componentZLevels).push({
          zlevel,
          z: z2,
          idx: componentModel.componentIndex,
          type: componentType,
          key: zlevelKey
        });
      });
      if (hasSeperateZLevel) {
        var zLevels = componentZLevels.concat(seriesZLevels);
        var lastSeriesZLevel_1;
        var lastSeriesKey_1;
        sort$2(zLevels, function(a, b2) {
          if (a.zlevel === b2.zlevel) {
            return a.z - b2.z;
          }
          return a.zlevel - b2.zlevel;
        });
        each$f(zLevels, function(item) {
          var componentModel = ecModel.getComponent(item.type, item.idx);
          var zlevel = item.zlevel;
          var key = item.key;
          if (lastSeriesZLevel_1 != null) {
            zlevel = Math.max(lastSeriesZLevel_1, zlevel);
          }
          if (key) {
            if (zlevel === lastSeriesZLevel_1 && key !== lastSeriesKey_1) {
              zlevel++;
            }
            lastSeriesKey_1 = key;
          } else if (lastSeriesKey_1) {
            if (zlevel === lastSeriesZLevel_1) {
              zlevel++;
            }
            lastSeriesKey_1 = "";
          }
          lastSeriesZLevel_1 = zlevel;
          componentModel.setZLevel(zlevel);
        });
      }
    }
    render = function(ecIns, ecModel, api, payload, updateParams) {
      allocateZlevels(ecModel);
      renderComponents(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        chart.__alive = false;
      });
      renderSeries(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        if (!chart.__alive) {
          chart.remove(ecModel, api);
        }
      });
    };
    renderComponents = function(ecIns, ecModel, api, payload, updateParams, dirtyList) {
      each$f(dirtyList || ecIns._componentsViews, function(componentView) {
        var componentModel = componentView.__model;
        clearStates(componentModel, componentView);
        componentView.render(componentModel, ecModel, api, payload);
        updateZ2(componentModel, componentView);
        updateStates(componentModel, componentView);
      });
    };
    renderSeries = function(ecIns, ecModel, api, payload, updateParams, dirtyMap) {
      var scheduler = ecIns._scheduler;
      updateParams = extend(updateParams || {}, {
        updatedSeries: ecModel.getSeries()
      });
      lifecycle$1.trigger("series:beforeupdate", ecModel, api, updateParams);
      var unfinished = false;
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        chartView.__alive = true;
        var renderTask = chartView.renderTask;
        scheduler.updatePayload(renderTask, payload);
        clearStates(seriesModel, chartView);
        if (dirtyMap && dirtyMap.get(seriesModel.uid)) {
          renderTask.dirty();
        }
        if (renderTask.perform(scheduler.getPerformArgs(renderTask))) {
          unfinished = true;
        }
        chartView.group.silent = !!seriesModel.get("silent");
        updateBlend(seriesModel, chartView);
        updateSeriesElementSelection(seriesModel);
      });
      scheduler.unfinished = unfinished || scheduler.unfinished;
      lifecycle$1.trigger("series:layoutlabels", ecModel, api, updateParams);
      lifecycle$1.trigger("series:transition", ecModel, api, updateParams);
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        updateZ2(seriesModel, chartView);
        updateStates(seriesModel, chartView);
      });
      updateHoverLayerStatus(ecIns, ecModel);
      lifecycle$1.trigger("series:afterupdate", ecModel, api, updateParams);
    };
    markStatusToUpdate = function(ecIns) {
      ecIns[STATUS_NEEDS_UPDATE_KEY] = true;
      ecIns.getZr().wakeUp();
    };
    applyChangedStates = function(ecIns) {
      if (!ecIns[STATUS_NEEDS_UPDATE_KEY]) {
        return;
      }
      ecIns.getZr().storage.traverse(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        applyElementStates(el);
      });
      ecIns[STATUS_NEEDS_UPDATE_KEY] = false;
    };
    function applyElementStates(el) {
      var newStates = [];
      var oldStates = el.currentStates;
      for (var i = 0; i < oldStates.length; i++) {
        var stateName = oldStates[i];
        if (!(stateName === "emphasis" || stateName === "blur" || stateName === "select")) {
          newStates.push(stateName);
        }
      }
      if (el.selected && el.states.select) {
        newStates.push("select");
      }
      if (el.hoverState === HOVER_STATE_EMPHASIS && el.states.emphasis) {
        newStates.push("emphasis");
      } else if (el.hoverState === HOVER_STATE_BLUR && el.states.blur) {
        newStates.push("blur");
      }
      el.useStates(newStates);
    }
    function updateHoverLayerStatus(ecIns, ecModel) {
      var zr = ecIns._zr;
      var storage2 = zr.storage;
      var elCount = 0;
      storage2.traverse(function(el) {
        if (!el.isGroup) {
          elCount++;
        }
      });
      if (elCount > ecModel.get("hoverLayerThreshold") && !env$1.node && !env$1.worker) {
        ecModel.eachSeries(function(seriesModel) {
          if (seriesModel.preventUsingHoverLayer) {
            return;
          }
          var chartView = ecIns._chartsMap[seriesModel.__viewId];
          if (chartView.__alive) {
            chartView.eachRendered(function(el) {
              if (el.states.emphasis) {
                el.states.emphasis.hoverLayer = true;
              }
            });
          }
        });
      }
    }
    function updateBlend(seriesModel, chartView) {
      var blendMode = seriesModel.get("blendMode") || null;
      chartView.eachRendered(function(el) {
        if (!el.isGroup) {
          el.style.blend = blendMode;
        }
      });
    }
    function updateZ2(model, view) {
      if (model.preventAutoZ) {
        return;
      }
      var z2 = model.get("z") || 0;
      var zlevel = model.get("zlevel") || 0;
      view.eachRendered(function(el) {
        doUpdateZ(el, z2, zlevel, -Infinity);
        return true;
      });
    }
    function doUpdateZ(el, z2, zlevel, maxZ2) {
      var label = el.getTextContent();
      var labelLine = el.getTextGuideLine();
      var isGroup = el.isGroup;
      if (isGroup) {
        var children = el.childrenRef();
        for (var i = 0; i < children.length; i++) {
          maxZ2 = Math.max(doUpdateZ(children[i], z2, zlevel, maxZ2), maxZ2);
        }
      } else {
        el.z = z2;
        el.zlevel = zlevel;
        maxZ2 = Math.max(el.z2, maxZ2);
      }
      if (label) {
        label.z = z2;
        label.zlevel = zlevel;
        isFinite(maxZ2) && (label.z2 = maxZ2 + 2);
      }
      if (labelLine) {
        var textGuideLineConfig = el.textGuideLineConfig;
        labelLine.z = z2;
        labelLine.zlevel = zlevel;
        isFinite(maxZ2) && (labelLine.z2 = maxZ2 + (textGuideLineConfig && textGuideLineConfig.showAbove ? 1 : -1));
      }
      return maxZ2;
    }
    function clearStates(model, view) {
      view.eachRendered(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        var textContent = el.getTextContent();
        var textGuide = el.getTextGuideLine();
        if (el.stateTransition) {
          el.stateTransition = null;
        }
        if (textContent && textContent.stateTransition) {
          textContent.stateTransition = null;
        }
        if (textGuide && textGuide.stateTransition) {
          textGuide.stateTransition = null;
        }
        if (el.hasState()) {
          el.prevStates = el.currentStates;
          el.clearStates();
        } else if (el.prevStates) {
          el.prevStates = null;
        }
      });
    }
    function updateStates(model, view) {
      var stateAnimationModel = model.getModel("stateAnimation");
      var enableAnimation = model.isAnimationEnabled();
      var duration = stateAnimationModel.get("duration");
      var stateTransition = duration > 0 ? {
        duration,
        delay: stateAnimationModel.get("delay"),
        easing: stateAnimationModel.get("easing")
      } : null;
      view.eachRendered(function(el) {
        if (el.states && el.states.emphasis) {
          if (isElementRemoved(el)) {
            return;
          }
          if (el instanceof Path$1) {
            savePathStates(el);
          }
          if (el.__dirty) {
            var prevStates = el.prevStates;
            if (prevStates) {
              el.useStates(prevStates);
            }
          }
          if (enableAnimation) {
            el.stateTransition = stateTransition;
            var textContent = el.getTextContent();
            var textGuide = el.getTextGuideLine();
            if (textContent) {
              textContent.stateTransition = stateTransition;
            }
            if (textGuide) {
              textGuide.stateTransition = stateTransition;
            }
          }
          if (el.__dirty) {
            applyElementStates(el);
          }
        }
      });
    }
    createExtensionAPI = function(ecIns) {
      return new (function(_super2) {
        __extends(class_1, _super2);
        function class_1() {
          return _super2 !== null && _super2.apply(this, arguments) || this;
        }
        class_1.prototype.getCoordinateSystems = function() {
          return ecIns._coordSysMgr.getCoordinateSystems();
        };
        class_1.prototype.getComponentByElement = function(el) {
          while (el) {
            var modelInfo = el.__ecComponentInfo;
            if (modelInfo != null) {
              return ecIns._model.getComponent(modelInfo.mainType, modelInfo.index);
            }
            el = el.parent;
          }
        };
        class_1.prototype.enterEmphasis = function(el, highlightDigit) {
          enterEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveEmphasis = function(el, highlightDigit) {
          leaveEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterBlur = function(el) {
          enterBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveBlur = function(el) {
          leaveBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterSelect = function(el) {
          enterSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveSelect = function(el) {
          leaveSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.getModel = function() {
          return ecIns.getModel();
        };
        class_1.prototype.getViewOfComponentModel = function(componentModel) {
          return ecIns.getViewOfComponentModel(componentModel);
        };
        class_1.prototype.getViewOfSeriesModel = function(seriesModel) {
          return ecIns.getViewOfSeriesModel(seriesModel);
        };
        return class_1;
      }(ExtensionAPI$1))(ecIns);
    };
    enableConnect = function(chart) {
      function updateConnectedChartsStatus(charts, status) {
        for (var i = 0; i < charts.length; i++) {
          var otherChart = charts[i];
          otherChart[CONNECT_STATUS_KEY] = status;
        }
      }
      each$f(eventActionMap, function(actionType, eventType) {
        chart._messageCenter.on(eventType, function(event) {
          if (connectedGroups[chart.group] && chart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_PENDING) {
            if (event && event.escapeConnect) {
              return;
            }
            var action_1 = chart.makeActionFromEvent(event);
            var otherCharts_1 = [];
            each$f(instances, function(otherChart) {
              if (otherChart !== chart && otherChart.group === chart.group) {
                otherCharts_1.push(otherChart);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_PENDING);
            each$f(otherCharts_1, function(otherChart) {
              if (otherChart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_UPDATING) {
                otherChart.dispatchAction(action_1);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_UPDATED);
          }
        });
      });
    };
  }();
  return ECharts2;
}(Eventful$1);
var echartsProto = ECharts.prototype;
echartsProto.on = createRegisterEventWithLowercaseECharts("on");
echartsProto.off = createRegisterEventWithLowercaseECharts("off");
echartsProto.one = function(eventName, cb, ctx) {
  var self2 = this;
  function wrapped() {
    var args2 = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args2[_i] = arguments[_i];
    }
    cb && cb.apply && cb.apply(this, args2);
    self2.off(eventName, wrapped);
  }
  this.on.call(this, eventName, wrapped, ctx);
};
var MOUSE_EVENT_NAMES = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function disposedWarning(id2) {
}
var actions = {};
var eventActionMap = {};
var dataProcessorFuncs = [];
var optionPreprocessorFuncs = [];
var visualFuncs = [];
var themeStorage = {};
var loadingEffects = {};
var instances = {};
var connectedGroups = {};
var idBase = +new Date() - 0;
var DOM_ATTRIBUTE_KEY = "_echarts_instance_";
function init$1(dom, theme2, opts) {
  var isClient = !(opts && opts.ssr);
  if (isClient) {
    var existInstance = getInstanceByDom(dom);
    if (existInstance) {
      return existInstance;
    }
  }
  var chart = new ECharts(dom, theme2, opts);
  chart.id = "ec_" + idBase++;
  instances[chart.id] = chart;
  isClient && setAttribute(dom, DOM_ATTRIBUTE_KEY, chart.id);
  enableConnect(chart);
  lifecycle$1.trigger("afterinit", chart);
  return chart;
}
function getInstanceByDom(dom) {
  return instances[getAttribute(dom, DOM_ATTRIBUTE_KEY)];
}
function registerTheme(name, theme2) {
  themeStorage[name] = theme2;
}
function registerPreprocessor(preprocessorFunc) {
  if (indexOf(optionPreprocessorFuncs, preprocessorFunc) < 0) {
    optionPreprocessorFuncs.push(preprocessorFunc);
  }
}
function registerProcessor(priority, processor) {
  normalizeRegister(dataProcessorFuncs, priority, processor, PRIORITY_PROCESSOR_DEFAULT);
}
function registerPostInit(postInitFunc) {
  registerUpdateLifecycle("afterinit", postInitFunc);
}
function registerPostUpdate(postUpdateFunc) {
  registerUpdateLifecycle("afterupdate", postUpdateFunc);
}
function registerUpdateLifecycle(name, cb) {
  lifecycle$1.on(name, cb);
}
function registerAction(actionInfo2, eventName, action) {
  if (isFunction(eventName)) {
    action = eventName;
    eventName = "";
  }
  var actionType = isObject$4(actionInfo2) ? actionInfo2.type : [actionInfo2, actionInfo2 = {
    event: eventName
  }][0];
  actionInfo2.event = (actionInfo2.event || actionType).toLowerCase();
  eventName = actionInfo2.event;
  if (eventActionMap[eventName]) {
    return;
  }
  assert(ACTION_REG.test(actionType) && ACTION_REG.test(eventName));
  if (!actions[actionType]) {
    actions[actionType] = {
      action,
      actionInfo: actionInfo2
    };
  }
  eventActionMap[eventName] = actionType;
}
function registerCoordinateSystem(type4, coordSysCreator) {
  CoordinateSystem.register(type4, coordSysCreator);
}
function registerLayout(priority, layoutTask) {
  normalizeRegister(visualFuncs, priority, layoutTask, PRIORITY_VISUAL_LAYOUT, "layout");
}
function registerVisual(priority, visualTask) {
  normalizeRegister(visualFuncs, priority, visualTask, PRIORITY_VISUAL_CHART, "visual");
}
var registeredTasks = [];
function normalizeRegister(targetList, priority, fn, defaultPriority, visualType) {
  if (isFunction(priority) || isObject$4(priority)) {
    fn = priority;
    priority = defaultPriority;
  }
  if (indexOf(registeredTasks, fn) >= 0) {
    return;
  }
  registeredTasks.push(fn);
  var stageHandler = Scheduler$1.wrapStageHandler(fn, visualType);
  stageHandler.__prio = priority;
  stageHandler.__raw = fn;
  targetList.push(stageHandler);
}
function registerLoading(name, loadingFx) {
  loadingEffects[name] = loadingFx;
}
function registerMap$1(mapName, geoJson, specialAreas) {
  var registerMap2 = getImpl("registerMap");
  registerMap2 && registerMap2(mapName, geoJson, specialAreas);
}
var registerTransform = registerExternalTransform;
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataColorPaletteTask);
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesSymbolTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataSymbolTask);
registerVisual(PRIORITY_VISUAL_DECAL, decalVisual);
registerPreprocessor(globalBackwardCompat);
registerProcessor(PRIORITY_PROCESSOR_DATASTACK, dataStack);
registerLoading("default", defaultLoading);
registerAction({
  type: HIGHLIGHT_ACTION_TYPE,
  event: HIGHLIGHT_ACTION_TYPE,
  update: HIGHLIGHT_ACTION_TYPE
}, noop);
registerAction({
  type: DOWNPLAY_ACTION_TYPE,
  event: DOWNPLAY_ACTION_TYPE,
  update: DOWNPLAY_ACTION_TYPE
}, noop);
registerAction({
  type: SELECT_ACTION_TYPE,
  event: SELECT_ACTION_TYPE,
  update: SELECT_ACTION_TYPE
}, noop);
registerAction({
  type: UNSELECT_ACTION_TYPE,
  event: UNSELECT_ACTION_TYPE,
  update: UNSELECT_ACTION_TYPE
}, noop);
registerAction({
  type: TOGGLE_SELECT_ACTION_TYPE,
  event: TOGGLE_SELECT_ACTION_TYPE,
  update: TOGGLE_SELECT_ACTION_TYPE
}, noop);
registerTheme("light", lightTheme);
registerTheme("dark", darkTheme);
var extensions = [];
var extensionRegisters = {
  registerPreprocessor,
  registerProcessor,
  registerPostInit,
  registerPostUpdate,
  registerUpdateLifecycle,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerVisual,
  registerTransform,
  registerLoading,
  registerMap: registerMap$1,
  registerImpl,
  PRIORITY,
  ComponentModel: ComponentModel$1,
  ComponentView: ComponentView$1,
  SeriesModel: SeriesModel$1,
  ChartView: ChartView$1,
  registerComponentModel: function(ComponentModelClass) {
    ComponentModel$1.registerClass(ComponentModelClass);
  },
  registerComponentView: function(ComponentViewClass) {
    ComponentView$1.registerClass(ComponentViewClass);
  },
  registerSeriesModel: function(SeriesModelClass) {
    SeriesModel$1.registerClass(SeriesModelClass);
  },
  registerChartView: function(ChartViewClass) {
    ChartView$1.registerClass(ChartViewClass);
  },
  registerSubTypeDefaulter: function(componentType, defaulter) {
    ComponentModel$1.registerSubTypeDefaulter(componentType, defaulter);
  },
  registerPainter: function(painterType, PainterCtor) {
    registerPainter(painterType, PainterCtor);
  }
};
function use(ext) {
  if (isArray$1(ext)) {
    each$f(ext, function(singleExt) {
      use(singleExt);
    });
    return;
  }
  if (indexOf(extensions, ext) >= 0) {
    return;
  }
  extensions.push(ext);
  if (isFunction(ext)) {
    ext = {
      install: ext
    };
  }
  ext.install(extensionRegisters);
}
function dataIndexMapValueLength(valNumOrArrLengthMoreThan2) {
  return valNumOrArrLengthMoreThan2 == null ? 0 : valNumOrArrLengthMoreThan2.length || 1;
}
function defaultKeyGetter(item) {
  return item;
}
var DataDiffer = function() {
  function DataDiffer2(oldArr, newArr, oldKeyGetter, newKeyGetter, context, diffMode) {
    this._old = oldArr;
    this._new = newArr;
    this._oldKeyGetter = oldKeyGetter || defaultKeyGetter;
    this._newKeyGetter = newKeyGetter || defaultKeyGetter;
    this.context = context;
    this._diffModeMultiple = diffMode === "multiple";
  }
  DataDiffer2.prototype.add = function(func) {
    this._add = func;
    return this;
  };
  DataDiffer2.prototype.update = function(func) {
    this._update = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToOne = function(func) {
    this._updateManyToOne = func;
    return this;
  };
  DataDiffer2.prototype.updateOneToMany = function(func) {
    this._updateOneToMany = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToMany = function(func) {
    this._updateManyToMany = func;
    return this;
  };
  DataDiffer2.prototype.remove = function(func) {
    this._remove = func;
    return this;
  };
  DataDiffer2.prototype.execute = function() {
    this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
  };
  DataDiffer2.prototype._executeOneToOne = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var newDataIndexMap = {};
    var oldDataKeyArr = new Array(oldArr.length);
    var newDataKeyArr = new Array(newArr.length);
    this._initIndexMap(oldArr, null, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (newIdxMapValLen > 1) {
        var newIdx = newIdxMapVal.shift();
        if (newIdxMapVal.length === 1) {
          newDataIndexMap[oldKey] = newIdxMapVal[0];
        }
        this._update && this._update(newIdx, i);
      } else if (newIdxMapValLen === 1) {
        newDataIndexMap[oldKey] = null;
        this._update && this._update(newIdxMapVal, i);
      } else {
        this._remove && this._remove(i);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._executeMultiple = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var oldDataIndexMap = {};
    var newDataIndexMap = {};
    var oldDataKeyArr = [];
    var newDataKeyArr = [];
    this._initIndexMap(oldArr, oldDataIndexMap, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldDataKeyArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var oldIdxMapVal = oldDataIndexMap[oldKey];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var oldIdxMapValLen = dataIndexMapValueLength(oldIdxMapVal);
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (oldIdxMapValLen > 1 && newIdxMapValLen === 1) {
        this._updateManyToOne && this._updateManyToOne(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen > 1) {
        this._updateOneToMany && this._updateOneToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen === 1) {
        this._update && this._update(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1 && newIdxMapValLen > 1) {
        this._updateManyToMany && this._updateManyToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1) {
        for (var i_1 = 0; i_1 < oldIdxMapValLen; i_1++) {
          this._remove && this._remove(oldIdxMapVal[i_1]);
        }
      } else {
        this._remove && this._remove(oldIdxMapVal);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._performRestAdd = function(newDataKeyArr, newDataIndexMap) {
    for (var i = 0; i < newDataKeyArr.length; i++) {
      var newKey = newDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[newKey];
      var idxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (idxMapValLen > 1) {
        for (var j = 0; j < idxMapValLen; j++) {
          this._add && this._add(newIdxMapVal[j]);
        }
      } else if (idxMapValLen === 1) {
        this._add && this._add(newIdxMapVal);
      }
      newDataIndexMap[newKey] = null;
    }
  };
  DataDiffer2.prototype._initIndexMap = function(arr, map2, keyArr, keyGetterName) {
    var cbModeMultiple = this._diffModeMultiple;
    for (var i = 0; i < arr.length; i++) {
      var key = "_ec_" + this[keyGetterName](arr[i], i);
      if (!cbModeMultiple) {
        keyArr[i] = key;
      }
      if (!map2) {
        continue;
      }
      var idxMapVal = map2[key];
      var idxMapValLen = dataIndexMapValueLength(idxMapVal);
      if (idxMapValLen === 0) {
        map2[key] = i;
        if (cbModeMultiple) {
          keyArr.push(key);
        }
      } else if (idxMapValLen === 1) {
        map2[key] = [idxMapVal, i];
      } else {
        idxMapVal.push(i);
      }
    }
  };
  return DataDiffer2;
}();
var DataDiffer$1 = DataDiffer;
var DimensionUserOuput = function() {
  function DimensionUserOuput2(encode, dimRequest) {
    this._encode = encode;
    this._schema = dimRequest;
  }
  DimensionUserOuput2.prototype.get = function() {
    return {
      fullDimensions: this._getFullDimensionNames(),
      encode: this._encode
    };
  };
  DimensionUserOuput2.prototype._getFullDimensionNames = function() {
    if (!this._cachedDimNames) {
      this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : [];
    }
    return this._cachedDimNames;
  };
  return DimensionUserOuput2;
}();
function summarizeDimensions(data, schema) {
  var summary = {};
  var encode = summary.encode = {};
  var notExtraCoordDimMap = createHashMap();
  var defaultedLabel = [];
  var defaultedTooltip = [];
  var userOutputEncode = {};
  each$f(data.dimensions, function(dimName) {
    var dimItem = data.getDimensionInfo(dimName);
    var coordDim = dimItem.coordDim;
    if (coordDim) {
      var coordDimIndex = dimItem.coordDimIndex;
      getOrCreateEncodeArr(encode, coordDim)[coordDimIndex] = dimName;
      if (!dimItem.isExtraCoord) {
        notExtraCoordDimMap.set(coordDim, 1);
        if (mayLabelDimType(dimItem.type)) {
          defaultedLabel[0] = dimName;
        }
        getOrCreateEncodeArr(userOutputEncode, coordDim)[coordDimIndex] = data.getDimensionIndex(dimItem.name);
      }
      if (dimItem.defaultTooltip) {
        defaultedTooltip.push(dimName);
      }
    }
    VISUAL_DIMENSIONS.each(function(v4, otherDim) {
      var encodeArr = getOrCreateEncodeArr(encode, otherDim);
      var dimIndex = dimItem.otherDims[otherDim];
      if (dimIndex != null && dimIndex !== false) {
        encodeArr[dimIndex] = dimItem.name;
      }
    });
  });
  var dataDimsOnCoord = [];
  var encodeFirstDimNotExtra = {};
  notExtraCoordDimMap.each(function(v4, coordDim) {
    var dimArr = encode[coordDim];
    encodeFirstDimNotExtra[coordDim] = dimArr[0];
    dataDimsOnCoord = dataDimsOnCoord.concat(dimArr);
  });
  summary.dataDimsOnCoord = dataDimsOnCoord;
  summary.dataDimIndicesOnCoord = map$1(dataDimsOnCoord, function(dimName) {
    return data.getDimensionInfo(dimName).storeDimIndex;
  });
  summary.encodeFirstDimNotExtra = encodeFirstDimNotExtra;
  var encodeLabel = encode.label;
  if (encodeLabel && encodeLabel.length) {
    defaultedLabel = encodeLabel.slice();
  }
  var encodeTooltip = encode.tooltip;
  if (encodeTooltip && encodeTooltip.length) {
    defaultedTooltip = encodeTooltip.slice();
  } else if (!defaultedTooltip.length) {
    defaultedTooltip = defaultedLabel.slice();
  }
  encode.defaultedLabel = defaultedLabel;
  encode.defaultedTooltip = defaultedTooltip;
  summary.userOutput = new DimensionUserOuput(userOutputEncode, schema);
  return summary;
}
function getOrCreateEncodeArr(encode, dim) {
  if (!encode.hasOwnProperty(dim)) {
    encode[dim] = [];
  }
  return encode[dim];
}
function getDimensionTypeByAxis(axisType) {
  return axisType === "category" ? "ordinal" : axisType === "time" ? "time" : "float";
}
function mayLabelDimType(dimType) {
  return !(dimType === "ordinal" || dimType === "time");
}
var SeriesDimensionDefine = function() {
  function SeriesDimensionDefine2(opt) {
    this.otherDims = {};
    if (opt != null) {
      extend(this, opt);
    }
  }
  return SeriesDimensionDefine2;
}();
var SeriesDimensionDefine$1 = SeriesDimensionDefine;
var inner$h = makeInner();
var dimTypeShort = {
  float: "f",
  int: "i",
  ordinal: "o",
  number: "n",
  time: "t"
};
var SeriesDataSchema = function() {
  function SeriesDataSchema2(opt) {
    this.dimensions = opt.dimensions;
    this._dimOmitted = opt.dimensionOmitted;
    this.source = opt.source;
    this._fullDimCount = opt.fullDimensionCount;
    this._updateDimOmitted(opt.dimensionOmitted);
  }
  SeriesDataSchema2.prototype.isDimensionOmitted = function() {
    return this._dimOmitted;
  };
  SeriesDataSchema2.prototype._updateDimOmitted = function(dimensionOmitted) {
    this._dimOmitted = dimensionOmitted;
    if (!dimensionOmitted) {
      return;
    }
    if (!this._dimNameMap) {
      this._dimNameMap = ensureSourceDimNameMap(this.source);
    }
  };
  SeriesDataSchema2.prototype.getSourceDimensionIndex = function(dimName) {
    return retrieve2(this._dimNameMap.get(dimName), -1);
  };
  SeriesDataSchema2.prototype.getSourceDimension = function(dimIndex) {
    var dimensionsDefine = this.source.dimensionsDefine;
    if (dimensionsDefine) {
      return dimensionsDefine[dimIndex];
    }
  };
  SeriesDataSchema2.prototype.makeStoreSchema = function() {
    var dimCount = this._fullDimCount;
    var willRetrieveDataByName = shouldRetrieveDataByName(this.source);
    var makeHashStrict = !shouldOmitUnusedDimensions(dimCount);
    var dimHash = "";
    var dims = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < dimCount; fullDimIdx++) {
      var property = void 0;
      var type4 = void 0;
      var ordinalMeta = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        property = willRetrieveDataByName ? seriesDimDef.name : null;
        type4 = seriesDimDef.type;
        ordinalMeta = seriesDimDef.ordinalMeta;
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          property = willRetrieveDataByName ? sourceDimDef.name : null;
          type4 = sourceDimDef.type;
        }
      }
      dims.push({
        property,
        type: type4,
        ordinalMeta
      });
      if (willRetrieveDataByName && property != null && (!seriesDimDef || !seriesDimDef.isCalculationCoord)) {
        dimHash += makeHashStrict ? property.replace(/\`/g, "`1").replace(/\$/g, "`2") : property;
      }
      dimHash += "$";
      dimHash += dimTypeShort[type4] || "f";
      if (ordinalMeta) {
        dimHash += ordinalMeta.uid;
      }
      dimHash += "$";
    }
    var source = this.source;
    var hash = [source.seriesLayoutBy, source.startIndex, dimHash].join("$$");
    return {
      dimensions: dims,
      hash
    };
  };
  SeriesDataSchema2.prototype.makeOutputDimensionNames = function() {
    var result = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < this._fullDimCount; fullDimIdx++) {
      var name_1 = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        if (!seriesDimDef.isCalculationCoord) {
          name_1 = seriesDimDef.name;
        }
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          name_1 = sourceDimDef.name;
        }
      }
      result.push(name_1);
    }
    return result;
  };
  SeriesDataSchema2.prototype.appendCalculationDimension = function(dimDef) {
    this.dimensions.push(dimDef);
    dimDef.isCalculationCoord = true;
    this._fullDimCount++;
    this._updateDimOmitted(true);
  };
  return SeriesDataSchema2;
}();
function isSeriesDataSchema(schema) {
  return schema instanceof SeriesDataSchema;
}
function createDimNameMap(dimsDef) {
  var dataDimNameMap = createHashMap();
  for (var i = 0; i < (dimsDef || []).length; i++) {
    var dimDefItemRaw = dimsDef[i];
    var userDimName = isObject$4(dimDefItemRaw) ? dimDefItemRaw.name : dimDefItemRaw;
    if (userDimName != null && dataDimNameMap.get(userDimName) == null) {
      dataDimNameMap.set(userDimName, i);
    }
  }
  return dataDimNameMap;
}
function ensureSourceDimNameMap(source) {
  var innerSource = inner$h(source);
  return innerSource.dimNameMap || (innerSource.dimNameMap = createDimNameMap(source.dimensionsDefine));
}
function shouldOmitUnusedDimensions(dimCount) {
  return dimCount > 30;
}
var isObject$2 = isObject$4;
var map = map$1;
var CtorInt32Array = typeof Int32Array === "undefined" ? Array : Int32Array;
var ID_PREFIX = "e\0\0";
var INDEX_NOT_FOUND = -1;
var TRANSFERABLE_PROPERTIES = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"];
var CLONE_PROPERTIES = ["_approximateExtent"];
var prepareInvertedIndex;
var getId;
var getIdNameFromStore;
var normalizeDimensions;
var transferProperties;
var cloneListForMapAndSample;
var makeIdFromName;
var SeriesData = function() {
  function SeriesData2(dimensionsInput, hostModel) {
    this.type = "list";
    this._dimOmitted = false;
    this._nameList = [];
    this._idList = [];
    this._visual = {};
    this._layout = {};
    this._itemVisuals = [];
    this._itemLayouts = [];
    this._graphicEls = [];
    this._approximateExtent = {};
    this._calculationInfo = {};
    this.hasItemOption = false;
    this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"];
    this.CHANGABLE_METHODS = ["filterSelf", "selectRange"];
    this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
    var dimensions;
    var assignStoreDimIdx = false;
    if (isSeriesDataSchema(dimensionsInput)) {
      dimensions = dimensionsInput.dimensions;
      this._dimOmitted = dimensionsInput.isDimensionOmitted();
      this._schema = dimensionsInput;
    } else {
      assignStoreDimIdx = true;
      dimensions = dimensionsInput;
    }
    dimensions = dimensions || ["x", "y"];
    var dimensionInfos = {};
    var dimensionNames = [];
    var invertedIndicesMap = {};
    var needsHasOwn = false;
    var emptyObj = {};
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfoInput = dimensions[i];
      var dimensionInfo = isString(dimInfoInput) ? new SeriesDimensionDefine$1({
        name: dimInfoInput
      }) : !(dimInfoInput instanceof SeriesDimensionDefine$1) ? new SeriesDimensionDefine$1(dimInfoInput) : dimInfoInput;
      var dimensionName = dimensionInfo.name;
      dimensionInfo.type = dimensionInfo.type || "float";
      if (!dimensionInfo.coordDim) {
        dimensionInfo.coordDim = dimensionName;
        dimensionInfo.coordDimIndex = 0;
      }
      var otherDims = dimensionInfo.otherDims = dimensionInfo.otherDims || {};
      dimensionNames.push(dimensionName);
      dimensionInfos[dimensionName] = dimensionInfo;
      if (emptyObj[dimensionName] != null) {
        needsHasOwn = true;
      }
      if (dimensionInfo.createInvertedIndices) {
        invertedIndicesMap[dimensionName] = [];
      }
      if (otherDims.itemName === 0) {
        this._nameDimIdx = i;
      }
      if (otherDims.itemId === 0) {
        this._idDimIdx = i;
      }
      if (assignStoreDimIdx) {
        dimensionInfo.storeDimIndex = i;
      }
    }
    this.dimensions = dimensionNames;
    this._dimInfos = dimensionInfos;
    this._initGetDimensionInfo(needsHasOwn);
    this.hostModel = hostModel;
    this._invertedIndicesMap = invertedIndicesMap;
    if (this._dimOmitted) {
      var dimIdxToName_1 = this._dimIdxToName = createHashMap();
      each$f(dimensionNames, function(dimName) {
        dimIdxToName_1.set(dimensionInfos[dimName].storeDimIndex, dimName);
      });
    }
  }
  SeriesData2.prototype.getDimension = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx == null) {
      return dim;
    }
    dimIdx = dim;
    if (!this._dimOmitted) {
      return this.dimensions[dimIdx];
    }
    var dimName = this._dimIdxToName.get(dimIdx);
    if (dimName != null) {
      return dimName;
    }
    var sourceDimDef = this._schema.getSourceDimension(dimIdx);
    if (sourceDimDef) {
      return sourceDimDef.name;
    }
  };
  SeriesData2.prototype.getDimensionIndex = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx != null) {
      return dimIdx;
    }
    if (dim == null) {
      return -1;
    }
    var dimInfo = this._getDimInfo(dim);
    return dimInfo ? dimInfo.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(dim) : -1;
  };
  SeriesData2.prototype._recognizeDimIndex = function(dim) {
    if (isNumber(dim) || dim != null && !isNaN(dim) && !this._getDimInfo(dim) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(dim) < 0)) {
      return +dim;
    }
  };
  SeriesData2.prototype._getStoreDimIndex = function(dim) {
    var dimIdx = this.getDimensionIndex(dim);
    return dimIdx;
  };
  SeriesData2.prototype.getDimensionInfo = function(dim) {
    return this._getDimInfo(this.getDimension(dim));
  };
  SeriesData2.prototype._initGetDimensionInfo = function(needsHasOwn) {
    var dimensionInfos = this._dimInfos;
    this._getDimInfo = needsHasOwn ? function(dimName) {
      return dimensionInfos.hasOwnProperty(dimName) ? dimensionInfos[dimName] : void 0;
    } : function(dimName) {
      return dimensionInfos[dimName];
    };
  };
  SeriesData2.prototype.getDimensionsOnCoord = function() {
    return this._dimSummary.dataDimsOnCoord.slice();
  };
  SeriesData2.prototype.mapDimension = function(coordDim, idx) {
    var dimensionsSummary = this._dimSummary;
    if (idx == null) {
      return dimensionsSummary.encodeFirstDimNotExtra[coordDim];
    }
    var dims = dimensionsSummary.encode[coordDim];
    return dims ? dims[idx] : null;
  };
  SeriesData2.prototype.mapDimensionsAll = function(coordDim) {
    var dimensionsSummary = this._dimSummary;
    var dims = dimensionsSummary.encode[coordDim];
    return (dims || []).slice();
  };
  SeriesData2.prototype.getStore = function() {
    return this._store;
  };
  SeriesData2.prototype.initData = function(data, nameList, dimValueGetter) {
    var _this = this;
    var store;
    if (data instanceof DataStore) {
      store = data;
    }
    if (!store) {
      var dimensions = this.dimensions;
      var provider = isSourceInstance(data) || isArrayLike(data) ? new DefaultDataProvider(data, dimensions.length) : data;
      store = new DataStore();
      var dimensionInfos = map(dimensions, function(dimName) {
        return {
          type: _this._dimInfos[dimName].type,
          property: dimName
        };
      });
      store.initData(provider, dimensionInfos, dimValueGetter);
    }
    this._store = store;
    this._nameList = (nameList || []).slice();
    this._idList = [];
    this._nameRepeatCount = {};
    this._doInit(0, store.count());
    this._dimSummary = summarizeDimensions(this, this._schema);
    this.userOutput = this._dimSummary.userOutput;
  };
  SeriesData2.prototype.appendData = function(data) {
    var range3 = this._store.appendData(data);
    this._doInit(range3[0], range3[1]);
  };
  SeriesData2.prototype.appendValues = function(values, names2) {
    var _a2 = this._store.appendValues(values, names2.length), start2 = _a2.start, end2 = _a2.end;
    var shouldMakeIdFromName = this._shouldMakeIdFromName();
    this._updateOrdinalMeta();
    if (names2) {
      for (var idx = start2; idx < end2; idx++) {
        var sourceIdx = idx - start2;
        this._nameList[idx] = names2[sourceIdx];
        if (shouldMakeIdFromName) {
          makeIdFromName(this, idx);
        }
      }
    }
  };
  SeriesData2.prototype._updateOrdinalMeta = function() {
    var store = this._store;
    var dimensions = this.dimensions;
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfo = this._dimInfos[dimensions[i]];
      if (dimInfo.ordinalMeta) {
        store.collectOrdinalMeta(dimInfo.storeDimIndex, dimInfo.ordinalMeta);
      }
    }
  };
  SeriesData2.prototype._shouldMakeIdFromName = function() {
    var provider = this._store.getProvider();
    return this._idDimIdx == null && provider.getSource().sourceFormat !== SOURCE_FORMAT_TYPED_ARRAY && !provider.fillStorage;
  };
  SeriesData2.prototype._doInit = function(start2, end2) {
    if (start2 >= end2) {
      return;
    }
    var store = this._store;
    var provider = store.getProvider();
    this._updateOrdinalMeta();
    var nameList = this._nameList;
    var idList = this._idList;
    var sourceFormat = provider.getSource().sourceFormat;
    var isFormatOriginal = sourceFormat === SOURCE_FORMAT_ORIGINAL;
    if (isFormatOriginal && !provider.pure) {
      var sharedDataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        var dataItem = provider.getItem(idx, sharedDataItem);
        if (!this.hasItemOption && isDataItemOption(dataItem)) {
          this.hasItemOption = true;
        }
        if (dataItem) {
          var itemName = dataItem.name;
          if (nameList[idx] == null && itemName != null) {
            nameList[idx] = convertOptionIdName(itemName, null);
          }
          var itemId = dataItem.id;
          if (idList[idx] == null && itemId != null) {
            idList[idx] = convertOptionIdName(itemId, null);
          }
        }
      }
    }
    if (this._shouldMakeIdFromName()) {
      for (var idx = start2; idx < end2; idx++) {
        makeIdFromName(this, idx);
      }
    }
    prepareInvertedIndex(this);
  };
  SeriesData2.prototype.getApproximateExtent = function(dim) {
    return this._approximateExtent[dim] || this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.setApproximateExtent = function(extent3, dim) {
    dim = this.getDimension(dim);
    this._approximateExtent[dim] = extent3.slice();
  };
  SeriesData2.prototype.getCalculationInfo = function(key) {
    return this._calculationInfo[key];
  };
  SeriesData2.prototype.setCalculationInfo = function(key, value) {
    isObject$2(key) ? extend(this._calculationInfo, key) : this._calculationInfo[key] = value;
  };
  SeriesData2.prototype.getName = function(idx) {
    var rawIndex = this.getRawIndex(idx);
    var name = this._nameList[rawIndex];
    if (name == null && this._nameDimIdx != null) {
      name = getIdNameFromStore(this, this._nameDimIdx, rawIndex);
    }
    if (name == null) {
      name = "";
    }
    return name;
  };
  SeriesData2.prototype._getCategory = function(dimIdx, idx) {
    var ordinal = this._store.get(dimIdx, idx);
    var ordinalMeta = this._store.getOrdinalMeta(dimIdx);
    if (ordinalMeta) {
      return ordinalMeta.categories[ordinal];
    }
    return ordinal;
  };
  SeriesData2.prototype.getId = function(idx) {
    return getId(this, this.getRawIndex(idx));
  };
  SeriesData2.prototype.count = function() {
    return this._store.count();
  };
  SeriesData2.prototype.get = function(dim, idx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.get(dimInfo.storeDimIndex, idx);
    }
  };
  SeriesData2.prototype.getByRawIndex = function(dim, rawIdx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.getByRawIndex(dimInfo.storeDimIndex, rawIdx);
    }
  };
  SeriesData2.prototype.getIndices = function() {
    return this._store.getIndices();
  };
  SeriesData2.prototype.getDataExtent = function(dim) {
    return this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getSum = function(dim) {
    return this._store.getSum(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getMedian = function(dim) {
    return this._store.getMedian(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getValues = function(dimensions, idx) {
    var _this = this;
    var store = this._store;
    return isArray$1(dimensions) ? store.getValues(map(dimensions, function(dim) {
      return _this._getStoreDimIndex(dim);
    }), idx) : store.getValues(dimensions);
  };
  SeriesData2.prototype.hasValue = function(idx) {
    var dataDimIndicesOnCoord = this._dimSummary.dataDimIndicesOnCoord;
    for (var i = 0, len2 = dataDimIndicesOnCoord.length; i < len2; i++) {
      if (isNaN(this._store.get(dataDimIndicesOnCoord[i], idx))) {
        return false;
      }
    }
    return true;
  };
  SeriesData2.prototype.indexOfName = function(name) {
    for (var i = 0, len2 = this._store.count(); i < len2; i++) {
      if (this.getName(i) === name) {
        return i;
      }
    }
    return -1;
  };
  SeriesData2.prototype.getRawIndex = function(idx) {
    return this._store.getRawIndex(idx);
  };
  SeriesData2.prototype.indexOfRawIndex = function(rawIndex) {
    return this._store.indexOfRawIndex(rawIndex);
  };
  SeriesData2.prototype.rawIndexOf = function(dim, value) {
    var invertedIndices = dim && this._invertedIndicesMap[dim];
    var rawIndex = invertedIndices[value];
    if (rawIndex == null || isNaN(rawIndex)) {
      return INDEX_NOT_FOUND;
    }
    return rawIndex;
  };
  SeriesData2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    return this._store.indicesOfNearest(this._getStoreDimIndex(dim), value, maxDistance);
  };
  SeriesData2.prototype.each = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.each(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.filterSelf = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store = this._store.filter(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return this;
  };
  SeriesData2.prototype.selectRange = function(range3) {
    var _this = this;
    var innerRange = {};
    var dims = keys(range3);
    each$f(dims, function(dim) {
      var dimIdx = _this._getStoreDimIndex(dim);
      innerRange[dimIdx] = range3[dim];
    });
    this._store = this._store.selectRange(innerRange);
    return this;
  };
  SeriesData2.prototype.mapArray = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    ctx = ctx || this;
    var result = [];
    this.each(dims, function() {
      result.push(cb && cb.apply(this, arguments));
    }, ctx);
    return result;
  };
  SeriesData2.prototype.map = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    var list = cloneListForMapAndSample(this);
    list._store = this._store.map(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return list;
  };
  SeriesData2.prototype.modify = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.modify(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.downSample(this._getStoreDimIndex(dimension), rate, sampleValue, sampleIndex);
    return list;
  };
  SeriesData2.prototype.lttbDownSample = function(valueDimension, rate) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.lttbDownSample(this._getStoreDimIndex(valueDimension), rate);
    return list;
  };
  SeriesData2.prototype.getRawDataItem = function(idx) {
    return this._store.getRawDataItem(idx);
  };
  SeriesData2.prototype.getItemModel = function(idx) {
    var hostModel = this.hostModel;
    var dataItem = this.getRawDataItem(idx);
    return new Model$1(dataItem, hostModel, hostModel && hostModel.ecModel);
  };
  SeriesData2.prototype.diff = function(otherList) {
    var thisList = this;
    return new DataDiffer$1(otherList ? otherList.getStore().getIndices() : [], this.getStore().getIndices(), function(idx) {
      return getId(otherList, idx);
    }, function(idx) {
      return getId(thisList, idx);
    });
  };
  SeriesData2.prototype.getVisual = function(key) {
    var visual = this._visual;
    return visual && visual[key];
  };
  SeriesData2.prototype.setVisual = function(kvObj, val) {
    this._visual = this._visual || {};
    if (isObject$2(kvObj)) {
      extend(this._visual, kvObj);
    } else {
      this._visual[kvObj] = val;
    }
  };
  SeriesData2.prototype.getItemVisual = function(idx, key) {
    var itemVisual = this._itemVisuals[idx];
    var val = itemVisual && itemVisual[key];
    if (val == null) {
      return this.getVisual(key);
    }
    return val;
  };
  SeriesData2.prototype.hasItemVisual = function() {
    return this._itemVisuals.length > 0;
  };
  SeriesData2.prototype.ensureUniqueItemVisual = function(idx, key) {
    var itemVisuals = this._itemVisuals;
    var itemVisual = itemVisuals[idx];
    if (!itemVisual) {
      itemVisual = itemVisuals[idx] = {};
    }
    var val = itemVisual[key];
    if (val == null) {
      val = this.getVisual(key);
      if (isArray$1(val)) {
        val = val.slice();
      } else if (isObject$2(val)) {
        val = extend({}, val);
      }
      itemVisual[key] = val;
    }
    return val;
  };
  SeriesData2.prototype.setItemVisual = function(idx, key, value) {
    var itemVisual = this._itemVisuals[idx] || {};
    this._itemVisuals[idx] = itemVisual;
    if (isObject$2(key)) {
      extend(itemVisual, key);
    } else {
      itemVisual[key] = value;
    }
  };
  SeriesData2.prototype.clearAllVisual = function() {
    this._visual = {};
    this._itemVisuals = [];
  };
  SeriesData2.prototype.setLayout = function(key, val) {
    isObject$2(key) ? extend(this._layout, key) : this._layout[key] = val;
  };
  SeriesData2.prototype.getLayout = function(key) {
    return this._layout[key];
  };
  SeriesData2.prototype.getItemLayout = function(idx) {
    return this._itemLayouts[idx];
  };
  SeriesData2.prototype.setItemLayout = function(idx, layout2, merge2) {
    this._itemLayouts[idx] = merge2 ? extend(this._itemLayouts[idx] || {}, layout2) : layout2;
  };
  SeriesData2.prototype.clearItemLayouts = function() {
    this._itemLayouts.length = 0;
  };
  SeriesData2.prototype.setItemGraphicEl = function(idx, el) {
    var seriesIndex = this.hostModel && this.hostModel.seriesIndex;
    setCommonECData(seriesIndex, this.dataType, idx, el);
    this._graphicEls[idx] = el;
  };
  SeriesData2.prototype.getItemGraphicEl = function(idx) {
    return this._graphicEls[idx];
  };
  SeriesData2.prototype.eachItemGraphicEl = function(cb, context) {
    each$f(this._graphicEls, function(el, idx) {
      if (el) {
        cb && cb.call(context, el, idx);
      }
    });
  };
  SeriesData2.prototype.cloneShallow = function(list) {
    if (!list) {
      list = new SeriesData2(this._schema ? this._schema : map(this.dimensions, this._getDimInfo, this), this.hostModel);
    }
    transferProperties(list, this);
    list._store = this._store;
    return list;
  };
  SeriesData2.prototype.wrapMethod = function(methodName, injectFunction) {
    var originalMethod = this[methodName];
    if (!isFunction(originalMethod)) {
      return;
    }
    this.__wrappedMethods = this.__wrappedMethods || [];
    this.__wrappedMethods.push(methodName);
    this[methodName] = function() {
      var res = originalMethod.apply(this, arguments);
      return injectFunction.apply(this, [res].concat(slice(arguments)));
    };
  };
  SeriesData2.internalField = function() {
    prepareInvertedIndex = function(data) {
      var invertedIndicesMap = data._invertedIndicesMap;
      each$f(invertedIndicesMap, function(invertedIndices, dim) {
        var dimInfo = data._dimInfos[dim];
        var ordinalMeta = dimInfo.ordinalMeta;
        var store = data._store;
        if (ordinalMeta) {
          invertedIndices = invertedIndicesMap[dim] = new CtorInt32Array(ordinalMeta.categories.length);
          for (var i = 0; i < invertedIndices.length; i++) {
            invertedIndices[i] = INDEX_NOT_FOUND;
          }
          for (var i = 0; i < store.count(); i++) {
            invertedIndices[store.get(dimInfo.storeDimIndex, i)] = i;
          }
        }
      });
    };
    getIdNameFromStore = function(data, dimIdx, idx) {
      return convertOptionIdName(data._getCategory(dimIdx, idx), null);
    };
    getId = function(data, rawIndex) {
      var id2 = data._idList[rawIndex];
      if (id2 == null && data._idDimIdx != null) {
        id2 = getIdNameFromStore(data, data._idDimIdx, rawIndex);
      }
      if (id2 == null) {
        id2 = ID_PREFIX + rawIndex;
      }
      return id2;
    };
    normalizeDimensions = function(dimensions) {
      if (!isArray$1(dimensions)) {
        dimensions = dimensions != null ? [dimensions] : [];
      }
      return dimensions;
    };
    cloneListForMapAndSample = function(original) {
      var list = new SeriesData2(original._schema ? original._schema : map(original.dimensions, original._getDimInfo, original), original.hostModel);
      transferProperties(list, original);
      return list;
    };
    transferProperties = function(target, source) {
      each$f(TRANSFERABLE_PROPERTIES.concat(source.__wrappedMethods || []), function(propName) {
        if (source.hasOwnProperty(propName)) {
          target[propName] = source[propName];
        }
      });
      target.__wrappedMethods = source.__wrappedMethods;
      each$f(CLONE_PROPERTIES, function(propName) {
        target[propName] = clone$4(source[propName]);
      });
      target._calculationInfo = extend({}, source._calculationInfo);
    };
    makeIdFromName = function(data, idx) {
      var nameList = data._nameList;
      var idList = data._idList;
      var nameDimIdx = data._nameDimIdx;
      var idDimIdx = data._idDimIdx;
      var name = nameList[idx];
      var id2 = idList[idx];
      if (name == null && nameDimIdx != null) {
        nameList[idx] = name = getIdNameFromStore(data, nameDimIdx, idx);
      }
      if (id2 == null && idDimIdx != null) {
        idList[idx] = id2 = getIdNameFromStore(data, idDimIdx, idx);
      }
      if (id2 == null && name != null) {
        var nameRepeatCount = data._nameRepeatCount;
        var nmCnt = nameRepeatCount[name] = (nameRepeatCount[name] || 0) + 1;
        id2 = name;
        if (nmCnt > 1) {
          id2 += "__ec__" + nmCnt;
        }
        idList[idx] = id2;
      }
    };
  }();
  return SeriesData2;
}();
var SeriesData$1 = SeriesData;
function prepareSeriesDataSchema(source, opt) {
  if (!isSourceInstance(source)) {
    source = createSourceFromSeriesDataOption(source);
  }
  opt = opt || {};
  var sysDims = opt.coordDimensions || [];
  var dimsDef = opt.dimensionsDefine || source.dimensionsDefine || [];
  var coordDimNameMap = createHashMap();
  var resultList = [];
  var dimCount = getDimCount(source, sysDims, dimsDef, opt.dimensionsCount);
  var omitUnusedDimensions = opt.canOmitUnusedDimensions && shouldOmitUnusedDimensions(dimCount);
  var isUsingSourceDimensionsDef = dimsDef === source.dimensionsDefine;
  var dataDimNameMap = isUsingSourceDimensionsDef ? ensureSourceDimNameMap(source) : createDimNameMap(dimsDef);
  var encodeDef = opt.encodeDefine;
  if (!encodeDef && opt.encodeDefaulter) {
    encodeDef = opt.encodeDefaulter(source, dimCount);
  }
  var encodeDefMap = createHashMap(encodeDef);
  var indicesMap = new CtorInt32Array$1(dimCount);
  for (var i = 0; i < indicesMap.length; i++) {
    indicesMap[i] = -1;
  }
  function getResultItem(dimIdx) {
    var idx = indicesMap[dimIdx];
    if (idx < 0) {
      var dimDefItemRaw = dimsDef[dimIdx];
      var dimDefItem = isObject$4(dimDefItemRaw) ? dimDefItemRaw : {
        name: dimDefItemRaw
      };
      var resultItem2 = new SeriesDimensionDefine$1();
      var userDimName = dimDefItem.name;
      if (userDimName != null && dataDimNameMap.get(userDimName) != null) {
        resultItem2.name = resultItem2.displayName = userDimName;
      }
      dimDefItem.type != null && (resultItem2.type = dimDefItem.type);
      dimDefItem.displayName != null && (resultItem2.displayName = dimDefItem.displayName);
      var newIdx = resultList.length;
      indicesMap[dimIdx] = newIdx;
      resultItem2.storeDimIndex = dimIdx;
      resultList.push(resultItem2);
      return resultItem2;
    }
    return resultList[idx];
  }
  if (!omitUnusedDimensions) {
    for (var i = 0; i < dimCount; i++) {
      getResultItem(i);
    }
  }
  encodeDefMap.each(function(dataDimsRaw, coordDim2) {
    var dataDims = normalizeToArray(dataDimsRaw).slice();
    if (dataDims.length === 1 && !isString(dataDims[0]) && dataDims[0] < 0) {
      encodeDefMap.set(coordDim2, false);
      return;
    }
    var validDataDims = encodeDefMap.set(coordDim2, []);
    each$f(dataDims, function(resultDimIdxOrName, idx) {
      var resultDimIdx2 = isString(resultDimIdxOrName) ? dataDimNameMap.get(resultDimIdxOrName) : resultDimIdxOrName;
      if (resultDimIdx2 != null && resultDimIdx2 < dimCount) {
        validDataDims[idx] = resultDimIdx2;
        applyDim(getResultItem(resultDimIdx2), coordDim2, idx);
      }
    });
  });
  var availDimIdx = 0;
  each$f(sysDims, function(sysDimItemRaw) {
    var coordDim2;
    var sysDimItemDimsDef;
    var sysDimItemOtherDims;
    var sysDimItem;
    if (isString(sysDimItemRaw)) {
      coordDim2 = sysDimItemRaw;
      sysDimItem = {};
    } else {
      sysDimItem = sysDimItemRaw;
      coordDim2 = sysDimItem.name;
      var ordinalMeta = sysDimItem.ordinalMeta;
      sysDimItem.ordinalMeta = null;
      sysDimItem = extend({}, sysDimItem);
      sysDimItem.ordinalMeta = ordinalMeta;
      sysDimItemDimsDef = sysDimItem.dimsDef;
      sysDimItemOtherDims = sysDimItem.otherDims;
      sysDimItem.name = sysDimItem.coordDim = sysDimItem.coordDimIndex = sysDimItem.dimsDef = sysDimItem.otherDims = null;
    }
    var dataDims = encodeDefMap.get(coordDim2);
    if (dataDims === false) {
      return;
    }
    dataDims = normalizeToArray(dataDims);
    if (!dataDims.length) {
      for (var i2 = 0; i2 < (sysDimItemDimsDef && sysDimItemDimsDef.length || 1); i2++) {
        while (availDimIdx < dimCount && getResultItem(availDimIdx).coordDim != null) {
          availDimIdx++;
        }
        availDimIdx < dimCount && dataDims.push(availDimIdx++);
      }
    }
    each$f(dataDims, function(resultDimIdx2, coordDimIndex) {
      var resultItem2 = getResultItem(resultDimIdx2);
      if (isUsingSourceDimensionsDef && sysDimItem.type != null) {
        resultItem2.type = sysDimItem.type;
      }
      applyDim(defaults(resultItem2, sysDimItem), coordDim2, coordDimIndex);
      if (resultItem2.name == null && sysDimItemDimsDef) {
        var sysDimItemDimsDefItem = sysDimItemDimsDef[coordDimIndex];
        !isObject$4(sysDimItemDimsDefItem) && (sysDimItemDimsDefItem = {
          name: sysDimItemDimsDefItem
        });
        resultItem2.name = resultItem2.displayName = sysDimItemDimsDefItem.name;
        resultItem2.defaultTooltip = sysDimItemDimsDefItem.defaultTooltip;
      }
      sysDimItemOtherDims && defaults(resultItem2.otherDims, sysDimItemOtherDims);
    });
  });
  function applyDim(resultItem2, coordDim2, coordDimIndex) {
    if (VISUAL_DIMENSIONS.get(coordDim2) != null) {
      resultItem2.otherDims[coordDim2] = coordDimIndex;
    } else {
      resultItem2.coordDim = coordDim2;
      resultItem2.coordDimIndex = coordDimIndex;
      coordDimNameMap.set(coordDim2, true);
    }
  }
  var generateCoord = opt.generateCoord;
  var generateCoordCount = opt.generateCoordCount;
  var fromZero = generateCoordCount != null;
  generateCoordCount = generateCoord ? generateCoordCount || 1 : 0;
  var extra = generateCoord || "value";
  function ifNoNameFillWithCoordName(resultItem2) {
    if (resultItem2.name == null) {
      resultItem2.name = resultItem2.coordDim;
    }
  }
  if (!omitUnusedDimensions) {
    for (var resultDimIdx = 0; resultDimIdx < dimCount; resultDimIdx++) {
      var resultItem = getResultItem(resultDimIdx);
      var coordDim = resultItem.coordDim;
      if (coordDim == null) {
        resultItem.coordDim = genCoordDimName(extra, coordDimNameMap, fromZero);
        resultItem.coordDimIndex = 0;
        if (!generateCoord || generateCoordCount <= 0) {
          resultItem.isExtraCoord = true;
        }
        generateCoordCount--;
      }
      ifNoNameFillWithCoordName(resultItem);
      if (resultItem.type == null && (guessOrdinal(source, resultDimIdx) === BE_ORDINAL.Must || resultItem.isExtraCoord && (resultItem.otherDims.itemName != null || resultItem.otherDims.seriesName != null))) {
        resultItem.type = "ordinal";
      }
    }
  } else {
    each$f(resultList, function(resultItem2) {
      ifNoNameFillWithCoordName(resultItem2);
    });
    resultList.sort(function(item0, item1) {
      return item0.storeDimIndex - item1.storeDimIndex;
    });
  }
  removeDuplication(resultList);
  return new SeriesDataSchema({
    source,
    dimensions: resultList,
    fullDimensionCount: dimCount,
    dimensionOmitted: omitUnusedDimensions
  });
}
function removeDuplication(result) {
  var duplicationMap = createHashMap();
  for (var i = 0; i < result.length; i++) {
    var dim = result[i];
    var dimOriginalName = dim.name;
    var count2 = duplicationMap.get(dimOriginalName) || 0;
    if (count2 > 0) {
      dim.name = dimOriginalName + (count2 - 1);
    }
    count2++;
    duplicationMap.set(dimOriginalName, count2);
  }
}
function getDimCount(source, sysDims, dimsDef, optDimCount) {
  var dimCount = Math.max(source.dimensionsDetectedCount || 1, sysDims.length, dimsDef.length, optDimCount || 0);
  each$f(sysDims, function(sysDimItem) {
    var sysDimItemDimsDef;
    if (isObject$4(sysDimItem) && (sysDimItemDimsDef = sysDimItem.dimsDef)) {
      dimCount = Math.max(dimCount, sysDimItemDimsDef.length);
    }
  });
  return dimCount;
}
function genCoordDimName(name, map2, fromZero) {
  var mapData = map2.data;
  if (fromZero || mapData.hasOwnProperty(name)) {
    var i = 0;
    while (mapData.hasOwnProperty(name + i)) {
      i++;
    }
    name += i;
  }
  map2.set(name, true);
  return name;
}
var CoordSysInfo = function() {
  function CoordSysInfo2(coordSysName) {
    this.coordSysDims = [];
    this.axisMap = createHashMap();
    this.categoryAxisMap = createHashMap();
    this.coordSysName = coordSysName;
  }
  return CoordSysInfo2;
}();
function getCoordSysInfoBySeries(seriesModel) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var result = new CoordSysInfo(coordSysName);
  var fetch = fetchers[coordSysName];
  if (fetch) {
    fetch(seriesModel, result, result.axisMap, result.categoryAxisMap);
    return result;
  }
}
var fetchers = {
  cartesian2d: function(seriesModel, result, axisMap, categoryAxisMap) {
    var xAxisModel = seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["x", "y"];
    axisMap.set("x", xAxisModel);
    axisMap.set("y", yAxisModel);
    if (isCategory(xAxisModel)) {
      categoryAxisMap.set("x", xAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(yAxisModel)) {
      categoryAxisMap.set("y", yAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  singleAxis: function(seriesModel, result, axisMap, categoryAxisMap) {
    var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["single"];
    axisMap.set("single", singleAxisModel);
    if (isCategory(singleAxisModel)) {
      categoryAxisMap.set("single", singleAxisModel);
      result.firstCategoryDimIndex = 0;
    }
  },
  polar: function(seriesModel, result, axisMap, categoryAxisMap) {
    var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
    var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
    var angleAxisModel = polarModel.findAxisModel("angleAxis");
    result.coordSysDims = ["radius", "angle"];
    axisMap.set("radius", radiusAxisModel);
    axisMap.set("angle", angleAxisModel);
    if (isCategory(radiusAxisModel)) {
      categoryAxisMap.set("radius", radiusAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(angleAxisModel)) {
      categoryAxisMap.set("angle", angleAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  geo: function(seriesModel, result, axisMap, categoryAxisMap) {
    result.coordSysDims = ["lng", "lat"];
  },
  parallel: function(seriesModel, result, axisMap, categoryAxisMap) {
    var ecModel = seriesModel.ecModel;
    var parallelModel = ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
    var coordSysDims = result.coordSysDims = parallelModel.dimensions.slice();
    each$f(parallelModel.parallelAxisIndex, function(axisIndex, index2) {
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axisDim = coordSysDims[index2];
      axisMap.set(axisDim, axisModel);
      if (isCategory(axisModel)) {
        categoryAxisMap.set(axisDim, axisModel);
        if (result.firstCategoryDimIndex == null) {
          result.firstCategoryDimIndex = index2;
        }
      }
    });
  }
};
function isCategory(axisModel) {
  return axisModel.get("type") === "category";
}
function enableDataStack(seriesModel, dimensionsInput, opt) {
  opt = opt || {};
  var byIndex = opt.byIndex;
  var stackedCoordDimension = opt.stackedCoordDimension;
  var dimensionDefineList;
  var schema;
  var store;
  if (isLegacyDimensionsInput(dimensionsInput)) {
    dimensionDefineList = dimensionsInput;
  } else {
    schema = dimensionsInput.schema;
    dimensionDefineList = schema.dimensions;
    store = dimensionsInput.store;
  }
  var mayStack = !!(seriesModel && seriesModel.get("stack"));
  var stackedByDimInfo;
  var stackedDimInfo;
  var stackResultDimension;
  var stackedOverDimension;
  each$f(dimensionDefineList, function(dimensionInfo, index2) {
    if (isString(dimensionInfo)) {
      dimensionDefineList[index2] = dimensionInfo = {
        name: dimensionInfo
      };
    }
    if (mayStack && !dimensionInfo.isExtraCoord) {
      if (!byIndex && !stackedByDimInfo && dimensionInfo.ordinalMeta) {
        stackedByDimInfo = dimensionInfo;
      }
      if (!stackedDimInfo && dimensionInfo.type !== "ordinal" && dimensionInfo.type !== "time" && (!stackedCoordDimension || stackedCoordDimension === dimensionInfo.coordDim)) {
        stackedDimInfo = dimensionInfo;
      }
    }
  });
  if (stackedDimInfo && !byIndex && !stackedByDimInfo) {
    byIndex = true;
  }
  if (stackedDimInfo) {
    stackResultDimension = "__\0ecstackresult_" + seriesModel.id;
    stackedOverDimension = "__\0ecstackedover_" + seriesModel.id;
    if (stackedByDimInfo) {
      stackedByDimInfo.createInvertedIndices = true;
    }
    var stackedDimCoordDim_1 = stackedDimInfo.coordDim;
    var stackedDimType = stackedDimInfo.type;
    var stackedDimCoordIndex_1 = 0;
    each$f(dimensionDefineList, function(dimensionInfo) {
      if (dimensionInfo.coordDim === stackedDimCoordDim_1) {
        stackedDimCoordIndex_1++;
      }
    });
    var stackedOverDimensionDefine = {
      name: stackResultDimension,
      coordDim: stackedDimCoordDim_1,
      coordDimIndex: stackedDimCoordIndex_1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length
    };
    var stackResultDimensionDefine = {
      name: stackedOverDimension,
      coordDim: stackedOverDimension,
      coordDimIndex: stackedDimCoordIndex_1 + 1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length + 1
    };
    if (schema) {
      if (store) {
        stackedOverDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackedOverDimension, stackedDimType);
        stackResultDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackResultDimension, stackedDimType);
      }
      schema.appendCalculationDimension(stackedOverDimensionDefine);
      schema.appendCalculationDimension(stackResultDimensionDefine);
    } else {
      dimensionDefineList.push(stackedOverDimensionDefine);
      dimensionDefineList.push(stackResultDimensionDefine);
    }
  }
  return {
    stackedDimension: stackedDimInfo && stackedDimInfo.name,
    stackedByDimension: stackedByDimInfo && stackedByDimInfo.name,
    isStackedByIndex: byIndex,
    stackedOverDimension,
    stackResultDimension
  };
}
function isLegacyDimensionsInput(dimensionsInput) {
  return !isSeriesDataSchema(dimensionsInput.schema);
}
function isDimensionStacked(data, stackedDim) {
  return !!stackedDim && stackedDim === data.getCalculationInfo("stackedDimension");
}
function getStackedDimension(data, targetDim) {
  return isDimensionStacked(data, targetDim) ? data.getCalculationInfo("stackResultDimension") : targetDim;
}
function getCoordSysDimDefs(seriesModel, coordSysInfo) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var registeredCoordSys = CoordinateSystem.get(coordSysName);
  var coordSysDimDefs;
  if (coordSysInfo && coordSysInfo.coordSysDims) {
    coordSysDimDefs = map$1(coordSysInfo.coordSysDims, function(dim) {
      var dimInfo = {
        name: dim
      };
      var axisModel = coordSysInfo.axisMap.get(dim);
      if (axisModel) {
        var axisType = axisModel.get("type");
        dimInfo.type = getDimensionTypeByAxis(axisType);
      }
      return dimInfo;
    });
  }
  if (!coordSysDimDefs) {
    coordSysDimDefs = registeredCoordSys && (registeredCoordSys.getDimensionsInfo ? registeredCoordSys.getDimensionsInfo() : registeredCoordSys.dimensions.slice()) || ["x", "y"];
  }
  return coordSysDimDefs;
}
function injectOrdinalMeta(dimInfoList, createInvertedIndices, coordSysInfo) {
  var firstCategoryDimIndex;
  var hasNameEncode;
  coordSysInfo && each$f(dimInfoList, function(dimInfo, dimIndex) {
    var coordDim = dimInfo.coordDim;
    var categoryAxisModel = coordSysInfo.categoryAxisMap.get(coordDim);
    if (categoryAxisModel) {
      if (firstCategoryDimIndex == null) {
        firstCategoryDimIndex = dimIndex;
      }
      dimInfo.ordinalMeta = categoryAxisModel.getOrdinalMeta();
      if (createInvertedIndices) {
        dimInfo.createInvertedIndices = true;
      }
    }
    if (dimInfo.otherDims.itemName != null) {
      hasNameEncode = true;
    }
  });
  if (!hasNameEncode && firstCategoryDimIndex != null) {
    dimInfoList[firstCategoryDimIndex].otherDims.itemName = 0;
  }
  return firstCategoryDimIndex;
}
function createSeriesData(sourceRaw, seriesModel, opt) {
  opt = opt || {};
  var sourceManager = seriesModel.getSourceManager();
  var source;
  var isOriginalSource = false;
  if (sourceRaw) {
    isOriginalSource = true;
    source = createSourceFromSeriesDataOption(sourceRaw);
  } else {
    source = sourceManager.getSource();
    isOriginalSource = source.sourceFormat === SOURCE_FORMAT_ORIGINAL;
  }
  var coordSysInfo = getCoordSysInfoBySeries(seriesModel);
  var coordSysDimDefs = getCoordSysDimDefs(seriesModel, coordSysInfo);
  var useEncodeDefaulter = opt.useEncodeDefaulter;
  var encodeDefaulter = isFunction(useEncodeDefaulter) ? useEncodeDefaulter : useEncodeDefaulter ? curry$1(makeSeriesEncodeForAxisCoordSys, coordSysDimDefs, seriesModel) : null;
  var createDimensionOptions = {
    coordDimensions: coordSysDimDefs,
    generateCoord: opt.generateCoord,
    encodeDefine: seriesModel.getEncode(),
    encodeDefaulter,
    canOmitUnusedDimensions: !isOriginalSource
  };
  var schema = prepareSeriesDataSchema(source, createDimensionOptions);
  var firstCategoryDimIndex = injectOrdinalMeta(schema.dimensions, opt.createInvertedIndices, coordSysInfo);
  var store = !isOriginalSource ? sourceManager.getSharedDataStore(schema) : null;
  var stackCalculationInfo = enableDataStack(seriesModel, {
    schema,
    store
  });
  var data = new SeriesData$1(schema, seriesModel);
  data.setCalculationInfo(stackCalculationInfo);
  var dimValueGetter = firstCategoryDimIndex != null && isNeedCompleteOrdinalData(source) ? function(itemOpt, dimName, dataIndex, dimIndex) {
    return dimIndex === firstCategoryDimIndex ? dataIndex : this.defaultDimValueGetter(itemOpt, dimName, dataIndex, dimIndex);
  } : null;
  data.hasItemOption = false;
  data.initData(isOriginalSource ? source : store, null, dimValueGetter);
  return data;
}
function isNeedCompleteOrdinalData(source) {
  if (source.sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var sampleItem = firstDataNotNull(source.data || []);
    return !isArray$1(getDataItemValue(sampleItem));
  }
}
function firstDataNotNull(arr) {
  var i = 0;
  while (i < arr.length && arr[i] == null) {
    i++;
  }
  return arr[i];
}
var Scale = function() {
  function Scale2(setting) {
    this._setting = setting || {};
    this._extent = [Infinity, -Infinity];
  }
  Scale2.prototype.getSetting = function(name) {
    return this._setting[name];
  };
  Scale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
  };
  Scale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  Scale2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Scale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = start2;
    }
    if (!isNaN(end2)) {
      thisExtent[1] = end2;
    }
  };
  Scale2.prototype.isInExtentRange = function(value) {
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  Scale2.prototype.isBlank = function() {
    return this._isBlank;
  };
  Scale2.prototype.setBlank = function(isBlank) {
    this._isBlank = isBlank;
  };
  return Scale2;
}();
enableClassManagement(Scale);
var Scale$1 = Scale;
var uidBase = 0;
var OrdinalMeta = function() {
  function OrdinalMeta2(opt) {
    this.categories = opt.categories || [];
    this._needCollect = opt.needCollect;
    this._deduplication = opt.deduplication;
    this.uid = ++uidBase;
  }
  OrdinalMeta2.createByAxisModel = function(axisModel) {
    var option = axisModel.option;
    var data = option.data;
    var categories = data && map$1(data, getName);
    return new OrdinalMeta2({
      categories,
      needCollect: !categories,
      deduplication: option.dedplication !== false
    });
  };
  OrdinalMeta2.prototype.getOrdinal = function(category) {
    return this._getOrCreateMap().get(category);
  };
  OrdinalMeta2.prototype.parseAndCollect = function(category) {
    var index2;
    var needCollect = this._needCollect;
    if (!isString(category) && !needCollect) {
      return category;
    }
    if (needCollect && !this._deduplication) {
      index2 = this.categories.length;
      this.categories[index2] = category;
      return index2;
    }
    var map2 = this._getOrCreateMap();
    index2 = map2.get(category);
    if (index2 == null) {
      if (needCollect) {
        index2 = this.categories.length;
        this.categories[index2] = category;
        map2.set(category, index2);
      } else {
        index2 = NaN;
      }
    }
    return index2;
  };
  OrdinalMeta2.prototype._getOrCreateMap = function() {
    return this._map || (this._map = createHashMap(this.categories));
  };
  return OrdinalMeta2;
}();
function getName(obj) {
  if (isObject$4(obj) && obj.value != null) {
    return obj.value;
  } else {
    return obj + "";
  }
}
var OrdinalMeta$1 = OrdinalMeta;
function isIntervalOrLogScale(scale2) {
  return scale2.type === "interval" || scale2.type === "log";
}
function intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval) {
  var result = {};
  var span = extent3[1] - extent3[0];
  var interval = result.interval = nice(span / splitNumber, true);
  if (minInterval != null && interval < minInterval) {
    interval = result.interval = minInterval;
  }
  if (maxInterval != null && interval > maxInterval) {
    interval = result.interval = maxInterval;
  }
  var precision = result.intervalPrecision = getIntervalPrecision(interval);
  var niceTickExtent = result.niceTickExtent = [round$3(Math.ceil(extent3[0] / interval) * interval, precision), round$3(Math.floor(extent3[1] / interval) * interval, precision)];
  fixExtent(niceTickExtent, extent3);
  return result;
}
function increaseInterval(interval) {
  var exp10 = Math.pow(10, quantityExponent(interval));
  var f2 = interval / exp10;
  if (!f2) {
    f2 = 1;
  } else if (f2 === 2) {
    f2 = 3;
  } else if (f2 === 3) {
    f2 = 5;
  } else {
    f2 *= 2;
  }
  return round$3(f2 * exp10);
}
function getIntervalPrecision(interval) {
  return getPrecision(interval) + 2;
}
function clamp(niceTickExtent, idx, extent3) {
  niceTickExtent[idx] = Math.max(Math.min(niceTickExtent[idx], extent3[1]), extent3[0]);
}
function fixExtent(niceTickExtent, extent3) {
  !isFinite(niceTickExtent[0]) && (niceTickExtent[0] = extent3[0]);
  !isFinite(niceTickExtent[1]) && (niceTickExtent[1] = extent3[1]);
  clamp(niceTickExtent, 0, extent3);
  clamp(niceTickExtent, 1, extent3);
  if (niceTickExtent[0] > niceTickExtent[1]) {
    niceTickExtent[0] = niceTickExtent[1];
  }
}
function contain$1(val, extent3) {
  return val >= extent3[0] && val <= extent3[1];
}
function normalize$3(val, extent3) {
  if (extent3[1] === extent3[0]) {
    return 0.5;
  }
  return (val - extent3[0]) / (extent3[1] - extent3[0]);
}
function scale(val, extent3) {
  return val * (extent3[1] - extent3[0]) + extent3[0];
}
var OrdinalScale = function(_super) {
  __extends(OrdinalScale2, _super);
  function OrdinalScale2(setting) {
    var _this = _super.call(this, setting) || this;
    _this.type = "ordinal";
    var ordinalMeta = _this.getSetting("ordinalMeta");
    if (!ordinalMeta) {
      ordinalMeta = new OrdinalMeta$1({});
    }
    if (isArray$1(ordinalMeta)) {
      ordinalMeta = new OrdinalMeta$1({
        categories: map$1(ordinalMeta, function(item) {
          return isObject$4(item) ? item.value : item;
        })
      });
    }
    _this._ordinalMeta = ordinalMeta;
    _this._extent = _this.getSetting("extent") || [0, ordinalMeta.categories.length - 1];
    return _this;
  }
  OrdinalScale2.prototype.parse = function(val) {
    return isString(val) ? this._ordinalMeta.getOrdinal(val) : Math.round(val);
  };
  OrdinalScale2.prototype.contain = function(rank) {
    rank = this.parse(rank);
    return contain$1(rank, this._extent) && this._ordinalMeta.categories[rank] != null;
  };
  OrdinalScale2.prototype.normalize = function(val) {
    val = this._getTickNumber(this.parse(val));
    return normalize$3(val, this._extent);
  };
  OrdinalScale2.prototype.scale = function(val) {
    val = Math.round(scale(val, this._extent));
    return this.getRawOrdinalNumber(val);
  };
  OrdinalScale2.prototype.getTicks = function() {
    var ticks = [];
    var extent3 = this._extent;
    var rank = extent3[0];
    while (rank <= extent3[1]) {
      ticks.push({
        value: rank
      });
      rank++;
    }
    return ticks;
  };
  OrdinalScale2.prototype.getMinorTicks = function(splitNumber) {
    return;
  };
  OrdinalScale2.prototype.setSortInfo = function(info) {
    if (info == null) {
      this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
      return;
    }
    var infoOrdinalNumbers = info.ordinalNumbers;
    var ordinalsByTick = this._ordinalNumbersByTick = [];
    var ticksByOrdinal = this._ticksByOrdinalNumber = [];
    var tickNum = 0;
    var allCategoryLen = this._ordinalMeta.categories.length;
    for (var len2 = Math.min(allCategoryLen, infoOrdinalNumbers.length); tickNum < len2; ++tickNum) {
      var ordinalNumber = infoOrdinalNumbers[tickNum];
      ordinalsByTick[tickNum] = ordinalNumber;
      ticksByOrdinal[ordinalNumber] = tickNum;
    }
    var unusedOrdinal = 0;
    for (; tickNum < allCategoryLen; ++tickNum) {
      while (ticksByOrdinal[unusedOrdinal] != null) {
        unusedOrdinal++;
      }
      ordinalsByTick.push(unusedOrdinal);
      ticksByOrdinal[unusedOrdinal] = tickNum;
    }
  };
  OrdinalScale2.prototype._getTickNumber = function(ordinal) {
    var ticksByOrdinalNumber = this._ticksByOrdinalNumber;
    return ticksByOrdinalNumber && ordinal >= 0 && ordinal < ticksByOrdinalNumber.length ? ticksByOrdinalNumber[ordinal] : ordinal;
  };
  OrdinalScale2.prototype.getRawOrdinalNumber = function(tickNumber) {
    var ordinalNumbersByTick = this._ordinalNumbersByTick;
    return ordinalNumbersByTick && tickNumber >= 0 && tickNumber < ordinalNumbersByTick.length ? ordinalNumbersByTick[tickNumber] : tickNumber;
  };
  OrdinalScale2.prototype.getLabel = function(tick) {
    if (!this.isBlank()) {
      var ordinalNumber = this.getRawOrdinalNumber(tick.value);
      var cateogry = this._ordinalMeta.categories[ordinalNumber];
      return cateogry == null ? "" : cateogry + "";
    }
  };
  OrdinalScale2.prototype.count = function() {
    return this._extent[1] - this._extent[0] + 1;
  };
  OrdinalScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  OrdinalScale2.prototype.isInExtentRange = function(value) {
    value = this._getTickNumber(value);
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  OrdinalScale2.prototype.getOrdinalMeta = function() {
    return this._ordinalMeta;
  };
  OrdinalScale2.prototype.calcNiceTicks = function() {
  };
  OrdinalScale2.prototype.calcNiceExtent = function() {
  };
  OrdinalScale2.type = "ordinal";
  return OrdinalScale2;
}(Scale$1);
Scale$1.registerClass(OrdinalScale);
var OrdinalScale$1 = OrdinalScale;
var roundNumber = round$3;
var IntervalScale = function(_super) {
  __extends(IntervalScale2, _super);
  function IntervalScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "interval";
    _this._interval = 0;
    _this._intervalPrecision = 2;
    return _this;
  }
  IntervalScale2.prototype.parse = function(val) {
    return val;
  };
  IntervalScale2.prototype.contain = function(val) {
    return contain$1(val, this._extent);
  };
  IntervalScale2.prototype.normalize = function(val) {
    return normalize$3(val, this._extent);
  };
  IntervalScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  IntervalScale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = parseFloat(start2);
    }
    if (!isNaN(end2)) {
      thisExtent[1] = parseFloat(end2);
    }
  };
  IntervalScale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
    this.setExtent(extent3[0], extent3[1]);
  };
  IntervalScale2.prototype.getInterval = function() {
    return this._interval;
  };
  IntervalScale2.prototype.setInterval = function(interval) {
    this._interval = interval;
    this._niceExtent = this._extent.slice();
    this._intervalPrecision = getIntervalPrecision(interval);
  };
  IntervalScale2.prototype.getTicks = function(expandToNicedExtent) {
    var interval = this._interval;
    var extent3 = this._extent;
    var niceTickExtent = this._niceExtent;
    var intervalPrecision = this._intervalPrecision;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    var safeLimit = 1e4;
    if (extent3[0] < niceTickExtent[0]) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(niceTickExtent[0] - interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[0]
        });
      }
    }
    var tick = niceTickExtent[0];
    while (tick <= niceTickExtent[1]) {
      ticks.push({
        value: tick
      });
      tick = roundNumber(tick + interval, intervalPrecision);
      if (tick === ticks[ticks.length - 1].value) {
        break;
      }
      if (ticks.length > safeLimit) {
        return [];
      }
    }
    var lastNiceTick = ticks.length ? ticks[ticks.length - 1].value : niceTickExtent[1];
    if (extent3[1] > lastNiceTick) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(lastNiceTick + interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[1]
        });
      }
    }
    return ticks;
  };
  IntervalScale2.prototype.getMinorTicks = function(splitNumber) {
    var ticks = this.getTicks(true);
    var minorTicks = [];
    var extent3 = this.getExtent();
    for (var i = 1; i < ticks.length; i++) {
      var nextTick = ticks[i];
      var prevTick = ticks[i - 1];
      var count2 = 0;
      var minorTicksGroup = [];
      var interval = nextTick.value - prevTick.value;
      var minorInterval = interval / splitNumber;
      while (count2 < splitNumber - 1) {
        var minorTick = roundNumber(prevTick.value + (count2 + 1) * minorInterval);
        if (minorTick > extent3[0] && minorTick < extent3[1]) {
          minorTicksGroup.push(minorTick);
        }
        count2++;
      }
      minorTicks.push(minorTicksGroup);
    }
    return minorTicks;
  };
  IntervalScale2.prototype.getLabel = function(data, opt) {
    if (data == null) {
      return "";
    }
    var precision = opt && opt.precision;
    if (precision == null) {
      precision = getPrecision(data.value) || 0;
    } else if (precision === "auto") {
      precision = this._intervalPrecision;
    }
    var dataNum = roundNumber(data.value, precision, true);
    return addCommas(dataNum);
  };
  IntervalScale2.prototype.calcNiceTicks = function(splitNumber, minInterval, maxInterval) {
    splitNumber = splitNumber || 5;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      return;
    }
    if (span < 0) {
      span = -span;
      extent3.reverse();
    }
    var result = intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval);
    this._intervalPrecision = result.intervalPrecision;
    this._interval = result.interval;
    this._niceExtent = result.niceTickExtent;
  };
  IntervalScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      if (extent3[0] !== 0) {
        var expandSize = extent3[0];
        if (!opt.fixMax) {
          extent3[1] += expandSize / 2;
          extent3[0] -= expandSize / 2;
        } else {
          extent3[0] -= expandSize / 2;
        }
      } else {
        extent3[1] = 1;
      }
    }
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      extent3[0] = 0;
      extent3[1] = 1;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
    var interval = this._interval;
    if (!opt.fixMin) {
      extent3[0] = roundNumber(Math.floor(extent3[0] / interval) * interval);
    }
    if (!opt.fixMax) {
      extent3[1] = roundNumber(Math.ceil(extent3[1] / interval) * interval);
    }
  };
  IntervalScale2.prototype.setNiceExtent = function(min3, max3) {
    this._niceExtent = [min3, max3];
  };
  IntervalScale2.type = "interval";
  return IntervalScale2;
}(Scale$1);
Scale$1.registerClass(IntervalScale);
var IntervalScale$1 = IntervalScale;
var supportFloat32Array = typeof Float32Array !== "undefined";
var Float32ArrayCtor = !supportFloat32Array ? Array : Float32Array;
function createFloat32Array(arg) {
  if (isArray$1(arg)) {
    return supportFloat32Array ? new Float32Array(arg) : arg;
  }
  return new Float32ArrayCtor(arg);
}
var STACK_PREFIX = "__ec_stack_";
function getSeriesStackId$1(seriesModel) {
  return seriesModel.get("stack") || STACK_PREFIX + seriesModel.seriesIndex;
}
function getAxisKey$1(axis) {
  return axis.dim + axis.index;
}
function getLayoutOnAxis(opt) {
  var params = [];
  var baseAxis = opt.axis;
  var axisKey = "axis0";
  if (baseAxis.type !== "category") {
    return;
  }
  var bandWidth = baseAxis.getBandWidth();
  for (var i = 0; i < opt.count || 0; i++) {
    params.push(defaults({
      bandWidth,
      axisKey,
      stackId: STACK_PREFIX + i
    }, opt));
  }
  var widthAndOffsets = doCalBarWidthAndOffset(params);
  var result = [];
  for (var i = 0; i < opt.count; i++) {
    var item = widthAndOffsets[axisKey][STACK_PREFIX + i];
    item.offsetCenter = item.offset + item.width / 2;
    result.push(item);
  }
  return result;
}
function prepareLayoutBarSeries(seriesType2, ecModel) {
  var seriesModels = [];
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (isOnCartesian(seriesModel)) {
      seriesModels.push(seriesModel);
    }
  });
  return seriesModels;
}
function getValueAxesMinGaps(barSeries) {
  var axisValues = {};
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    if (baseAxis.type !== "time" && baseAxis.type !== "value") {
      return;
    }
    var data = seriesModel.getData();
    var key2 = baseAxis.dim + "_" + baseAxis.index;
    var dimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
    var store = data.getStore();
    for (var i = 0, cnt = store.count(); i < cnt; ++i) {
      var value = store.get(dimIdx, i);
      if (!axisValues[key2]) {
        axisValues[key2] = [value];
      } else {
        axisValues[key2].push(value);
      }
    }
  });
  var axisMinGaps = {};
  for (var key in axisValues) {
    if (axisValues.hasOwnProperty(key)) {
      var valuesInAxis = axisValues[key];
      if (valuesInAxis) {
        valuesInAxis.sort(function(a, b2) {
          return a - b2;
        });
        var min3 = null;
        for (var j = 1; j < valuesInAxis.length; ++j) {
          var delta = valuesInAxis[j] - valuesInAxis[j - 1];
          if (delta > 0) {
            min3 = min3 === null ? delta : Math.min(min3, delta);
          }
        }
        axisMinGaps[key] = min3;
      }
    }
  }
  return axisMinGaps;
}
function makeColumnLayout(barSeries) {
  var axisMinGaps = getValueAxesMinGaps(barSeries);
  var seriesInfoList = [];
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var axisExtent = baseAxis.getExtent();
    var bandWidth;
    if (baseAxis.type === "category") {
      bandWidth = baseAxis.getBandWidth();
    } else if (baseAxis.type === "value" || baseAxis.type === "time") {
      var key = baseAxis.dim + "_" + baseAxis.index;
      var minGap = axisMinGaps[key];
      var extentSpan = Math.abs(axisExtent[1] - axisExtent[0]);
      var scale2 = baseAxis.scale.getExtent();
      var scaleSpan = Math.abs(scale2[1] - scale2[0]);
      bandWidth = minGap ? extentSpan / scaleSpan * minGap : extentSpan;
    } else {
      var data = seriesModel.getData();
      bandWidth = Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    }
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barMinWidth = parsePercent(seriesModel.get("barMinWidth") || (isInLargeMode(seriesModel) ? 0.5 : 1), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    seriesInfoList.push({
      bandWidth,
      barWidth,
      barMaxWidth,
      barMinWidth,
      barGap,
      barCategoryGap,
      axisKey: getAxisKey$1(baseAxis),
      stackId: getSeriesStackId$1(seriesModel)
    });
  });
  return doCalBarWidthAndOffset(seriesInfoList);
}
function doCalBarWidthAndOffset(seriesInfoList) {
  var columnsMap = {};
  each$f(seriesInfoList, function(seriesInfo, idx) {
    var axisKey = seriesInfo.axisKey;
    var bandWidth = seriesInfo.bandWidth;
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = seriesInfo.stackId;
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = seriesInfo.barWidth;
    if (barWidth && !stacks[stackId].width) {
      stacks[stackId].width = barWidth;
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      columnsOnAxis.remainedWidth -= barWidth;
    }
    var barMaxWidth = seriesInfo.barMaxWidth;
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    var barMinWidth = seriesInfo.barMinWidth;
    barMinWidth && (stacks[stackId].minWidth = barMinWidth);
    var barGap = seriesInfo.barGap;
    barGap != null && (columnsOnAxis.gap = barGap);
    var barCategoryGap = seriesInfo.barCategoryGap;
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGapPercent = columnsOnAxis.categoryGap;
    if (categoryGapPercent == null) {
      var columnCount = keys(stacks).length;
      categoryGapPercent = Math.max(35 - columnCount * 4, 15) + "%";
    }
    var categoryGap = parsePercent(categoryGapPercent, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column) {
      var maxWidth = column.maxWidth;
      var minWidth = column.minWidth;
      if (!column.width) {
        var finalWidth = autoWidth;
        if (maxWidth && maxWidth < finalWidth) {
          finalWidth = Math.min(maxWidth, remainedWidth);
        }
        if (minWidth && minWidth > finalWidth) {
          finalWidth = minWidth;
        }
        if (finalWidth !== autoWidth) {
          column.width = finalWidth;
          remainedWidth -= finalWidth + barGapPercent * finalWidth;
          autoWidthCount--;
        }
      } else {
        var finalWidth = column.width;
        if (maxWidth) {
          finalWidth = Math.min(finalWidth, maxWidth);
        }
        if (minWidth) {
          finalWidth = Math.max(finalWidth, minWidth);
        }
        column.width = finalWidth;
        remainedWidth -= finalWidth + barGapPercent * finalWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        bandWidth,
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
function retrieveColumnLayout(barWidthAndOffset, axis, seriesModel) {
  if (barWidthAndOffset && axis) {
    var result = barWidthAndOffset[getAxisKey$1(axis)];
    if (result != null && seriesModel != null) {
      return result[getSeriesStackId$1(seriesModel)];
    }
    return result;
  }
}
function layout$3(seriesType2, ecModel) {
  var seriesModels = prepareLayoutBarSeries(seriesType2, ecModel);
  var barWidthAndOffset = makeColumnLayout(seriesModels);
  each$f(seriesModels, function(seriesModel) {
    var data = seriesModel.getData();
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var stackId = getSeriesStackId$1(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[getAxisKey$1(baseAxis)][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    data.setLayout({
      bandWidth: columnLayoutInfo.bandWidth,
      offset: columnOffset,
      size: columnWidth
    });
  });
}
function createProgressiveLayout(seriesType2) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      if (!isOnCartesian(seriesModel)) {
        return;
      }
      var data = seriesModel.getData();
      var cartesian = seriesModel.coordinateSystem;
      var baseAxis = cartesian.getBaseAxis();
      var valueAxis2 = cartesian.getOtherAxis(baseAxis);
      var valueDimIdx = data.getDimensionIndex(data.mapDimension(valueAxis2.dim));
      var baseDimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
      var drawBackground = seriesModel.get("showBackground", true);
      var valueDim = data.mapDimension(valueAxis2.dim);
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      var stacked = isDimensionStacked(data, valueDim) && !!data.getCalculationInfo("stackedOnSeries");
      var isValueAxisH = valueAxis2.isHorizontal();
      var valueAxisStart = getValueAxisStart(baseAxis, valueAxis2);
      var isLarge = isInLargeMode(seriesModel);
      var barMinHeight = seriesModel.get("barMinHeight") || 0;
      var stackedDimIdx = stackResultDim && data.getDimensionIndex(stackResultDim);
      var columnWidth = data.getLayout("size");
      var columnOffset = data.getLayout("offset");
      return {
        progress: function(params, data2) {
          var count2 = params.count;
          var largePoints = isLarge && createFloat32Array(count2 * 3);
          var largeBackgroundPoints = isLarge && drawBackground && createFloat32Array(count2 * 3);
          var largeDataIndices = isLarge && createFloat32Array(count2);
          var coordLayout = cartesian.master.getRect();
          var bgSize = isValueAxisH ? coordLayout.width : coordLayout.height;
          var dataIndex;
          var store = data2.getStore();
          var idxOffset = 0;
          while ((dataIndex = params.next()) != null) {
            var value = store.get(stacked ? stackedDimIdx : valueDimIdx, dataIndex);
            var baseValue = store.get(baseDimIdx, dataIndex);
            var baseCoord = valueAxisStart;
            var startValue = void 0;
            if (stacked) {
              startValue = +value - store.get(valueDimIdx, dataIndex);
            }
            var x2 = void 0;
            var y2 = void 0;
            var width = void 0;
            var height = void 0;
            if (isValueAxisH) {
              var coord = cartesian.dataToPoint([value, baseValue]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([startValue, baseValue]);
                baseCoord = startCoord[0];
              }
              x2 = baseCoord;
              y2 = coord[1] + columnOffset;
              width = coord[0] - baseCoord;
              height = columnWidth;
              if (Math.abs(width) < barMinHeight) {
                width = (width < 0 ? -1 : 1) * barMinHeight;
              }
            } else {
              var coord = cartesian.dataToPoint([baseValue, value]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([baseValue, startValue]);
                baseCoord = startCoord[1];
              }
              x2 = coord[0] + columnOffset;
              y2 = baseCoord;
              width = columnWidth;
              height = coord[1] - baseCoord;
              if (Math.abs(height) < barMinHeight) {
                height = (height <= 0 ? -1 : 1) * barMinHeight;
              }
            }
            if (!isLarge) {
              data2.setItemLayout(dataIndex, {
                x: x2,
                y: y2,
                width,
                height
              });
            } else {
              largePoints[idxOffset] = x2;
              largePoints[idxOffset + 1] = y2;
              largePoints[idxOffset + 2] = isValueAxisH ? width : height;
              if (largeBackgroundPoints) {
                largeBackgroundPoints[idxOffset] = isValueAxisH ? coordLayout.x : x2;
                largeBackgroundPoints[idxOffset + 1] = isValueAxisH ? y2 : coordLayout.y;
                largeBackgroundPoints[idxOffset + 2] = bgSize;
              }
              largeDataIndices[dataIndex] = dataIndex;
            }
            idxOffset += 3;
          }
          if (isLarge) {
            data2.setLayout({
              largePoints,
              largeDataIndices,
              largeBackgroundPoints,
              valueAxisHorizontal: isValueAxisH
            });
          }
        }
      };
    }
  };
}
function isOnCartesian(seriesModel) {
  return seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "cartesian2d";
}
function isInLargeMode(seriesModel) {
  return seriesModel.pipelineContext && seriesModel.pipelineContext.large;
}
function getValueAxisStart(baseAxis, valueAxis2) {
  return valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(valueAxis2.type === "log" ? 1 : 0));
}
var bisect = function(a, x2, lo, hi) {
  while (lo < hi) {
    var mid = lo + hi >>> 1;
    if (a[mid][1] < x2) {
      lo = mid + 1;
    } else {
      hi = mid;
    }
  }
  return lo;
};
var TimeScale = function(_super) {
  __extends(TimeScale2, _super);
  function TimeScale2(settings) {
    var _this = _super.call(this, settings) || this;
    _this.type = "time";
    return _this;
  }
  TimeScale2.prototype.getLabel = function(tick) {
    var useUTC = this.getSetting("useUTC");
    return format$1(tick.value, fullLeveledFormatter[getDefaultFormatPrecisionOfInterval(getPrimaryTimeUnit(this._minLevelUnit))] || fullLeveledFormatter.second, useUTC, this.getSetting("locale"));
  };
  TimeScale2.prototype.getFormattedLabel = function(tick, idx, labelFormatter) {
    var isUTC = this.getSetting("useUTC");
    var lang = this.getSetting("locale");
    return leveledFormat(tick, idx, labelFormatter, lang, isUTC);
  };
  TimeScale2.prototype.getTicks = function() {
    var interval = this._interval;
    var extent3 = this._extent;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    ticks.push({
      value: extent3[0],
      level: 0
    });
    var useUTC = this.getSetting("useUTC");
    var innerTicks = getIntervalTicks(this._minLevelUnit, this._approxInterval, useUTC, extent3);
    ticks = ticks.concat(innerTicks);
    ticks.push({
      value: extent3[1],
      level: 0
    });
    return ticks;
  };
  TimeScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      extent3[0] -= ONE_DAY;
      extent3[1] += ONE_DAY;
    }
    if (extent3[1] === -Infinity && extent3[0] === Infinity) {
      var d2 = new Date();
      extent3[1] = +new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
      extent3[0] = extent3[1] - ONE_DAY;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
  };
  TimeScale2.prototype.calcNiceTicks = function(approxTickNum, minInterval, maxInterval) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    this._approxInterval = span / approxTickNum;
    if (minInterval != null && this._approxInterval < minInterval) {
      this._approxInterval = minInterval;
    }
    if (maxInterval != null && this._approxInterval > maxInterval) {
      this._approxInterval = maxInterval;
    }
    var scaleIntervalsLen = scaleIntervals.length;
    var idx = Math.min(bisect(scaleIntervals, this._approxInterval, 0, scaleIntervalsLen), scaleIntervalsLen - 1);
    this._interval = scaleIntervals[idx][1];
    this._minLevelUnit = scaleIntervals[Math.max(idx - 1, 0)][0];
  };
  TimeScale2.prototype.parse = function(val) {
    return isNumber(val) ? val : +parseDate(val);
  };
  TimeScale2.prototype.contain = function(val) {
    return contain$1(this.parse(val), this._extent);
  };
  TimeScale2.prototype.normalize = function(val) {
    return normalize$3(this.parse(val), this._extent);
  };
  TimeScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  TimeScale2.type = "time";
  return TimeScale2;
}(IntervalScale$1);
var scaleIntervals = [
  ["second", ONE_SECOND],
  ["minute", ONE_MINUTE],
  ["hour", ONE_HOUR],
  ["quarter-day", ONE_HOUR * 6],
  ["half-day", ONE_HOUR * 12],
  ["day", ONE_DAY * 1.2],
  ["half-week", ONE_DAY * 3.5],
  ["week", ONE_DAY * 7],
  ["month", ONE_DAY * 31],
  ["quarter", ONE_DAY * 95],
  ["half-year", ONE_YEAR / 2],
  ["year", ONE_YEAR]
];
function isUnitValueSame(unit, valueA, valueB, isUTC) {
  var dateA = parseDate(valueA);
  var dateB = parseDate(valueB);
  var isSame = function(unit2) {
    return getUnitValue(dateA, unit2, isUTC) === getUnitValue(dateB, unit2, isUTC);
  };
  var isSameYear = function() {
    return isSame("year");
  };
  var isSameMonth = function() {
    return isSameYear() && isSame("month");
  };
  var isSameDay = function() {
    return isSameMonth() && isSame("day");
  };
  var isSameHour = function() {
    return isSameDay() && isSame("hour");
  };
  var isSameMinute = function() {
    return isSameHour() && isSame("minute");
  };
  var isSameSecond = function() {
    return isSameMinute() && isSame("second");
  };
  var isSameMilliSecond = function() {
    return isSameSecond() && isSame("millisecond");
  };
  switch (unit) {
    case "year":
      return isSameYear();
    case "month":
      return isSameMonth();
    case "day":
      return isSameDay();
    case "hour":
      return isSameHour();
    case "minute":
      return isSameMinute();
    case "second":
      return isSameSecond();
    case "millisecond":
      return isSameMilliSecond();
  }
}
function getDateInterval(approxInterval, daysInMonth) {
  approxInterval /= ONE_DAY;
  return approxInterval > 16 ? 16 : approxInterval > 7.5 ? 7 : approxInterval > 3.5 ? 4 : approxInterval > 1.5 ? 2 : 1;
}
function getMonthInterval(approxInterval) {
  var APPROX_ONE_MONTH = 30 * ONE_DAY;
  approxInterval /= APPROX_ONE_MONTH;
  return approxInterval > 6 ? 6 : approxInterval > 3 ? 3 : approxInterval > 2 ? 2 : 1;
}
function getHourInterval(approxInterval) {
  approxInterval /= ONE_HOUR;
  return approxInterval > 12 ? 12 : approxInterval > 6 ? 6 : approxInterval > 3.5 ? 4 : approxInterval > 2 ? 2 : 1;
}
function getMinutesAndSecondsInterval(approxInterval, isMinutes) {
  approxInterval /= isMinutes ? ONE_MINUTE : ONE_SECOND;
  return approxInterval > 30 ? 30 : approxInterval > 20 ? 20 : approxInterval > 15 ? 15 : approxInterval > 10 ? 10 : approxInterval > 5 ? 5 : approxInterval > 2 ? 2 : 1;
}
function getMillisecondsInterval(approxInterval) {
  return nice(approxInterval, true);
}
function getFirstTimestampOfUnit(date4, unitName, isUTC) {
  var outDate = new Date(date4);
  switch (getPrimaryTimeUnit(unitName)) {
    case "year":
    case "month":
      outDate[monthSetterName(isUTC)](0);
    case "day":
      outDate[dateSetterName(isUTC)](1);
    case "hour":
      outDate[hoursSetterName(isUTC)](0);
    case "minute":
      outDate[minutesSetterName(isUTC)](0);
    case "second":
      outDate[secondsSetterName(isUTC)](0);
      outDate[millisecondsSetterName(isUTC)](0);
  }
  return outDate.getTime();
}
function getIntervalTicks(bottomUnitName, approxInterval, isUTC, extent3) {
  var safeLimit = 1e4;
  var unitNames = timeUnits;
  var iter = 0;
  function addTicksInSpan(interval, minTimestamp, maxTimestamp, getMethodName, setMethodName, isDate, out2) {
    var date4 = new Date(minTimestamp);
    var dateTime = minTimestamp;
    var d2 = date4[getMethodName]();
    while (dateTime < maxTimestamp && dateTime <= extent3[1]) {
      out2.push({
        value: dateTime
      });
      d2 += interval;
      date4[setMethodName](d2);
      dateTime = date4.getTime();
    }
    out2.push({
      value: dateTime,
      notAdd: true
    });
  }
  function addLevelTicks(unitName, lastLevelTicks, levelTicks2) {
    var newAddedTicks = [];
    var isFirstLevel = !lastLevelTicks.length;
    if (isUnitValueSame(getPrimaryTimeUnit(unitName), extent3[0], extent3[1], isUTC)) {
      return;
    }
    if (isFirstLevel) {
      lastLevelTicks = [{
        value: getFirstTimestampOfUnit(new Date(extent3[0]), unitName, isUTC)
      }, {
        value: extent3[1]
      }];
    }
    for (var i2 = 0; i2 < lastLevelTicks.length - 1; i2++) {
      var startTick = lastLevelTicks[i2].value;
      var endTick = lastLevelTicks[i2 + 1].value;
      if (startTick === endTick) {
        continue;
      }
      var interval = void 0;
      var getterName = void 0;
      var setterName = void 0;
      var isDate = false;
      switch (unitName) {
        case "year":
          interval = Math.max(1, Math.round(approxInterval / ONE_DAY / 365));
          getterName = fullYearGetterName(isUTC);
          setterName = fullYearSetterName(isUTC);
          break;
        case "half-year":
        case "quarter":
        case "month":
          interval = getMonthInterval(approxInterval);
          getterName = monthGetterName(isUTC);
          setterName = monthSetterName(isUTC);
          break;
        case "week":
        case "half-week":
        case "day":
          interval = getDateInterval(approxInterval);
          getterName = dateGetterName(isUTC);
          setterName = dateSetterName(isUTC);
          isDate = true;
          break;
        case "half-day":
        case "quarter-day":
        case "hour":
          interval = getHourInterval(approxInterval);
          getterName = hoursGetterName(isUTC);
          setterName = hoursSetterName(isUTC);
          break;
        case "minute":
          interval = getMinutesAndSecondsInterval(approxInterval, true);
          getterName = minutesGetterName(isUTC);
          setterName = minutesSetterName(isUTC);
          break;
        case "second":
          interval = getMinutesAndSecondsInterval(approxInterval, false);
          getterName = secondsGetterName(isUTC);
          setterName = secondsSetterName(isUTC);
          break;
        case "millisecond":
          interval = getMillisecondsInterval(approxInterval);
          getterName = millisecondsGetterName(isUTC);
          setterName = millisecondsSetterName(isUTC);
          break;
      }
      addTicksInSpan(interval, startTick, endTick, getterName, setterName, isDate, newAddedTicks);
      if (unitName === "year" && levelTicks2.length > 1 && i2 === 0) {
        levelTicks2.unshift({
          value: levelTicks2[0].value - interval
        });
      }
    }
    for (var i2 = 0; i2 < newAddedTicks.length; i2++) {
      levelTicks2.push(newAddedTicks[i2]);
    }
    return newAddedTicks;
  }
  var levelsTicks = [];
  var currentLevelTicks = [];
  var tickCount = 0;
  var lastLevelTickCount = 0;
  for (var i = 0; i < unitNames.length && iter++ < safeLimit; ++i) {
    var primaryTimeUnit = getPrimaryTimeUnit(unitNames[i]);
    if (!isPrimaryTimeUnit(unitNames[i])) {
      continue;
    }
    addLevelTicks(unitNames[i], levelsTicks[levelsTicks.length - 1] || [], currentLevelTicks);
    var nextPrimaryTimeUnit = unitNames[i + 1] ? getPrimaryTimeUnit(unitNames[i + 1]) : null;
    if (primaryTimeUnit !== nextPrimaryTimeUnit) {
      if (currentLevelTicks.length) {
        lastLevelTickCount = tickCount;
        currentLevelTicks.sort(function(a, b2) {
          return a.value - b2.value;
        });
        var levelTicksRemoveDuplicated = [];
        for (var i_1 = 0; i_1 < currentLevelTicks.length; ++i_1) {
          var tickValue = currentLevelTicks[i_1].value;
          if (i_1 === 0 || currentLevelTicks[i_1 - 1].value !== tickValue) {
            levelTicksRemoveDuplicated.push(currentLevelTicks[i_1]);
            if (tickValue >= extent3[0] && tickValue <= extent3[1]) {
              tickCount++;
            }
          }
        }
        var targetTickNum = (extent3[1] - extent3[0]) / approxInterval;
        if (tickCount > targetTickNum * 1.5 && lastLevelTickCount > targetTickNum / 1.5) {
          break;
        }
        levelsTicks.push(levelTicksRemoveDuplicated);
        if (tickCount > targetTickNum || bottomUnitName === unitNames[i]) {
          break;
        }
      }
      currentLevelTicks = [];
    }
  }
  var levelsTicksInExtent = filter(map$1(levelsTicks, function(levelTicks2) {
    return filter(levelTicks2, function(tick) {
      return tick.value >= extent3[0] && tick.value <= extent3[1] && !tick.notAdd;
    });
  }), function(levelTicks2) {
    return levelTicks2.length > 0;
  });
  var ticks = [];
  var maxLevel = levelsTicksInExtent.length - 1;
  for (var i = 0; i < levelsTicksInExtent.length; ++i) {
    var levelTicks = levelsTicksInExtent[i];
    for (var k2 = 0; k2 < levelTicks.length; ++k2) {
      ticks.push({
        value: levelTicks[k2].value,
        level: maxLevel - i
      });
    }
  }
  ticks.sort(function(a, b2) {
    return a.value - b2.value;
  });
  var result = [];
  for (var i = 0; i < ticks.length; ++i) {
    if (i === 0 || ticks[i].value !== ticks[i - 1].value) {
      result.push(ticks[i]);
    }
  }
  return result;
}
Scale$1.registerClass(TimeScale);
var TimeScale$1 = TimeScale;
var scaleProto = Scale$1.prototype;
var intervalScaleProto = IntervalScale$1.prototype;
var roundingErrorFix = round$3;
var mathFloor$1 = Math.floor;
var mathCeil$1 = Math.ceil;
var mathPow$1 = Math.pow;
var mathLog$1 = Math.log;
var LogScale = function(_super) {
  __extends(LogScale2, _super);
  function LogScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "log";
    _this.base = 10;
    _this._originalScale = new IntervalScale$1();
    _this._interval = 0;
    return _this;
  }
  LogScale2.prototype.getTicks = function(expandToNicedExtent) {
    var originalScale = this._originalScale;
    var extent3 = this._extent;
    var originalExtent = originalScale.getExtent();
    var ticks = intervalScaleProto.getTicks.call(this, expandToNicedExtent);
    return map$1(ticks, function(tick) {
      var val = tick.value;
      var powVal = round$3(mathPow$1(this.base, val));
      powVal = val === extent3[0] && this._fixMin ? fixRoundingError(powVal, originalExtent[0]) : powVal;
      powVal = val === extent3[1] && this._fixMax ? fixRoundingError(powVal, originalExtent[1]) : powVal;
      return {
        value: powVal
      };
    }, this);
  };
  LogScale2.prototype.setExtent = function(start2, end2) {
    var base2 = this.base;
    start2 = mathLog$1(start2) / mathLog$1(base2);
    end2 = mathLog$1(end2) / mathLog$1(base2);
    intervalScaleProto.setExtent.call(this, start2, end2);
  };
  LogScale2.prototype.getExtent = function() {
    var base2 = this.base;
    var extent3 = scaleProto.getExtent.call(this);
    extent3[0] = mathPow$1(base2, extent3[0]);
    extent3[1] = mathPow$1(base2, extent3[1]);
    var originalScale = this._originalScale;
    var originalExtent = originalScale.getExtent();
    this._fixMin && (extent3[0] = fixRoundingError(extent3[0], originalExtent[0]));
    this._fixMax && (extent3[1] = fixRoundingError(extent3[1], originalExtent[1]));
    return extent3;
  };
  LogScale2.prototype.unionExtent = function(extent3) {
    this._originalScale.unionExtent(extent3);
    var base2 = this.base;
    extent3[0] = mathLog$1(extent3[0]) / mathLog$1(base2);
    extent3[1] = mathLog$1(extent3[1]) / mathLog$1(base2);
    scaleProto.unionExtent.call(this, extent3);
  };
  LogScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  LogScale2.prototype.calcNiceTicks = function(approxTickNum) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (span === Infinity || span <= 0) {
      return;
    }
    var interval = quantity(span);
    var err = approxTickNum / span * interval;
    if (err <= 0.5) {
      interval *= 10;
    }
    while (!isNaN(interval) && Math.abs(interval) < 1 && Math.abs(interval) > 0) {
      interval *= 10;
    }
    var niceExtent = [round$3(mathCeil$1(extent3[0] / interval) * interval), round$3(mathFloor$1(extent3[1] / interval) * interval)];
    this._interval = interval;
    this._niceExtent = niceExtent;
  };
  LogScale2.prototype.calcNiceExtent = function(opt) {
    intervalScaleProto.calcNiceExtent.call(this, opt);
    this._fixMin = opt.fixMin;
    this._fixMax = opt.fixMax;
  };
  LogScale2.prototype.parse = function(val) {
    return val;
  };
  LogScale2.prototype.contain = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return contain$1(val, this._extent);
  };
  LogScale2.prototype.normalize = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return normalize$3(val, this._extent);
  };
  LogScale2.prototype.scale = function(val) {
    val = scale(val, this._extent);
    return mathPow$1(this.base, val);
  };
  LogScale2.type = "log";
  return LogScale2;
}(Scale$1);
var proto = LogScale.prototype;
proto.getMinorTicks = intervalScaleProto.getMinorTicks;
proto.getLabel = intervalScaleProto.getLabel;
function fixRoundingError(val, originalVal) {
  return roundingErrorFix(val, getPrecision(originalVal));
}
Scale$1.registerClass(LogScale);
var LogScale$1 = LogScale;
var ScaleRawExtentInfo = function() {
  function ScaleRawExtentInfo2(scale2, model, originalExtent) {
    this._prepareParams(scale2, model, originalExtent);
  }
  ScaleRawExtentInfo2.prototype._prepareParams = function(scale2, model, dataExtent) {
    if (dataExtent[1] < dataExtent[0]) {
      dataExtent = [NaN, NaN];
    }
    this._dataMin = dataExtent[0];
    this._dataMax = dataExtent[1];
    var isOrdinal = this._isOrdinal = scale2.type === "ordinal";
    this._needCrossZero = scale2.type === "interval" && model.getNeedCrossZero && model.getNeedCrossZero();
    var modelMinRaw = this._modelMinRaw = model.get("min", true);
    if (isFunction(modelMinRaw)) {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMinRaw !== "dataMin") {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw);
    }
    var modelMaxRaw = this._modelMaxRaw = model.get("max", true);
    if (isFunction(modelMaxRaw)) {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMaxRaw !== "dataMax") {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw);
    }
    if (isOrdinal) {
      this._axisDataLen = model.getCategories().length;
    } else {
      var boundaryGap = model.get("boundaryGap");
      var boundaryGapArr = isArray$1(boundaryGap) ? boundaryGap : [boundaryGap || 0, boundaryGap || 0];
      if (typeof boundaryGapArr[0] === "boolean" || typeof boundaryGapArr[1] === "boolean") {
        this._boundaryGapInner = [0, 0];
      } else {
        this._boundaryGapInner = [parsePercent$1(boundaryGapArr[0], 1), parsePercent$1(boundaryGapArr[1], 1)];
      }
    }
  };
  ScaleRawExtentInfo2.prototype.calculate = function() {
    var isOrdinal = this._isOrdinal;
    var dataMin = this._dataMin;
    var dataMax = this._dataMax;
    var axisDataLen = this._axisDataLen;
    var boundaryGapInner = this._boundaryGapInner;
    var span = !isOrdinal ? dataMax - dataMin || Math.abs(dataMin) : null;
    var min3 = this._modelMinRaw === "dataMin" ? dataMin : this._modelMinNum;
    var max3 = this._modelMaxRaw === "dataMax" ? dataMax : this._modelMaxNum;
    var minFixed = min3 != null;
    var maxFixed = max3 != null;
    if (min3 == null) {
      min3 = isOrdinal ? axisDataLen ? 0 : NaN : dataMin - boundaryGapInner[0] * span;
    }
    if (max3 == null) {
      max3 = isOrdinal ? axisDataLen ? axisDataLen - 1 : NaN : dataMax + boundaryGapInner[1] * span;
    }
    (min3 == null || !isFinite(min3)) && (min3 = NaN);
    (max3 == null || !isFinite(max3)) && (max3 = NaN);
    var isBlank = eqNaN(min3) || eqNaN(max3) || isOrdinal && !axisDataLen;
    if (this._needCrossZero) {
      if (min3 > 0 && max3 > 0 && !minFixed) {
        min3 = 0;
      }
      if (min3 < 0 && max3 < 0 && !maxFixed) {
        max3 = 0;
      }
    }
    var determinedMin = this._determinedMin;
    var determinedMax = this._determinedMax;
    if (determinedMin != null) {
      min3 = determinedMin;
      minFixed = true;
    }
    if (determinedMax != null) {
      max3 = determinedMax;
      maxFixed = true;
    }
    return {
      min: min3,
      max: max3,
      minFixed,
      maxFixed,
      isBlank
    };
  };
  ScaleRawExtentInfo2.prototype.modifyDataMinMax = function(minMaxName, val) {
    this[DATA_MIN_MAX_ATTR[minMaxName]] = val;
  };
  ScaleRawExtentInfo2.prototype.setDeterminedMinMax = function(minMaxName, val) {
    var attr = DETERMINED_MIN_MAX_ATTR[minMaxName];
    this[attr] = val;
  };
  ScaleRawExtentInfo2.prototype.freeze = function() {
    this.frozen = true;
  };
  return ScaleRawExtentInfo2;
}();
var DETERMINED_MIN_MAX_ATTR = {
  min: "_determinedMin",
  max: "_determinedMax"
};
var DATA_MIN_MAX_ATTR = {
  min: "_dataMin",
  max: "_dataMax"
};
function ensureScaleRawExtentInfo(scale2, model, originalExtent) {
  var rawExtentInfo = scale2.rawExtentInfo;
  if (rawExtentInfo) {
    return rawExtentInfo;
  }
  rawExtentInfo = new ScaleRawExtentInfo(scale2, model, originalExtent);
  scale2.rawExtentInfo = rawExtentInfo;
  return rawExtentInfo;
}
function parseAxisModelMinMax(scale2, minMax) {
  return minMax == null ? null : eqNaN(minMax) ? NaN : scale2.parse(minMax);
}
function getScaleExtent(scale2, model) {
  var scaleType = scale2.type;
  var rawExtentResult = ensureScaleRawExtentInfo(scale2, model, scale2.getExtent()).calculate();
  scale2.setBlank(rawExtentResult.isBlank);
  var min3 = rawExtentResult.min;
  var max3 = rawExtentResult.max;
  var ecModel = model.ecModel;
  if (ecModel && scaleType === "time") {
    var barSeriesModels = prepareLayoutBarSeries("bar", ecModel);
    var isBaseAxisAndHasBarSeries_1 = false;
    each$f(barSeriesModels, function(seriesModel) {
      isBaseAxisAndHasBarSeries_1 = isBaseAxisAndHasBarSeries_1 || seriesModel.getBaseAxis() === model.axis;
    });
    if (isBaseAxisAndHasBarSeries_1) {
      var barWidthAndOffset = makeColumnLayout(barSeriesModels);
      var adjustedScale = adjustScaleForOverflow(min3, max3, model, barWidthAndOffset);
      min3 = adjustedScale.min;
      max3 = adjustedScale.max;
    }
  }
  return {
    extent: [min3, max3],
    fixMin: rawExtentResult.minFixed,
    fixMax: rawExtentResult.maxFixed
  };
}
function adjustScaleForOverflow(min3, max3, model, barWidthAndOffset) {
  var axisExtent = model.axis.getExtent();
  var axisLength = axisExtent[1] - axisExtent[0];
  var barsOnCurrentAxis = retrieveColumnLayout(barWidthAndOffset, model.axis);
  if (barsOnCurrentAxis === void 0) {
    return {
      min: min3,
      max: max3
    };
  }
  var minOverflow = Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    minOverflow = Math.min(item.offset, minOverflow);
  });
  var maxOverflow = -Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    maxOverflow = Math.max(item.offset + item.width, maxOverflow);
  });
  minOverflow = Math.abs(minOverflow);
  maxOverflow = Math.abs(maxOverflow);
  var totalOverFlow = minOverflow + maxOverflow;
  var oldRange = max3 - min3;
  var oldRangePercentOfNew = 1 - (minOverflow + maxOverflow) / axisLength;
  var overflowBuffer = oldRange / oldRangePercentOfNew - oldRange;
  max3 += overflowBuffer * (maxOverflow / totalOverFlow);
  min3 -= overflowBuffer * (minOverflow / totalOverFlow);
  return {
    min: min3,
    max: max3
  };
}
function niceScaleExtent(scale2, inModel) {
  var model = inModel;
  var extentInfo = getScaleExtent(scale2, model);
  var extent3 = extentInfo.extent;
  var splitNumber = model.get("splitNumber");
  if (scale2 instanceof LogScale$1) {
    scale2.base = model.get("logBase");
  }
  var scaleType = scale2.type;
  var interval = model.get("interval");
  var isIntervalOrTime = scaleType === "interval" || scaleType === "time";
  scale2.setExtent(extent3[0], extent3[1]);
  scale2.calcNiceExtent({
    splitNumber,
    fixMin: extentInfo.fixMin,
    fixMax: extentInfo.fixMax,
    minInterval: isIntervalOrTime ? model.get("minInterval") : null,
    maxInterval: isIntervalOrTime ? model.get("maxInterval") : null
  });
  if (interval != null) {
    scale2.setInterval && scale2.setInterval(interval);
  }
}
function createScaleByModel$1(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getOrdinalMeta ? model.getOrdinalMeta() : model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new (Scale$1.getClass(axisType) || IntervalScale$1)();
    }
  }
}
function ifAxisCrossZero(axis) {
  var dataExtent = axis.scale.getExtent();
  var min3 = dataExtent[0];
  var max3 = dataExtent[1];
  return !(min3 > 0 && max3 > 0 || min3 < 0 && max3 < 0);
}
function makeLabelFormatter(axis) {
  var labelFormatter = axis.getLabelModel().get("formatter");
  var categoryTickStart = axis.type === "category" ? axis.scale.getExtent()[0] : null;
  if (axis.scale.type === "time") {
    return function(tpl) {
      return function(tick, idx) {
        return axis.scale.getFormattedLabel(tick, idx, tpl);
      };
    }(labelFormatter);
  } else if (isString(labelFormatter)) {
    return function(tpl) {
      return function(tick) {
        var label = axis.scale.getLabel(tick);
        var text = tpl.replace("{value}", label != null ? label : "");
        return text;
      };
    }(labelFormatter);
  } else if (isFunction(labelFormatter)) {
    return function(cb) {
      return function(tick, idx) {
        if (categoryTickStart != null) {
          idx = tick.value - categoryTickStart;
        }
        return cb(getAxisRawValue(axis, tick), idx, tick.level != null ? {
          level: tick.level
        } : null);
      };
    }(labelFormatter);
  } else {
    return function(tick) {
      return axis.scale.getLabel(tick);
    };
  }
}
function getAxisRawValue(axis, tick) {
  return axis.type === "category" ? axis.scale.getLabel(tick) : tick.value;
}
function estimateLabelUnionRect(axis) {
  var axisModel = axis.model;
  var scale2 = axis.scale;
  if (!axisModel.get(["axisLabel", "show"]) || scale2.isBlank()) {
    return;
  }
  var realNumberScaleTicks;
  var tickCount;
  var categoryScaleExtent = scale2.getExtent();
  if (scale2 instanceof OrdinalScale$1) {
    tickCount = scale2.count();
  } else {
    realNumberScaleTicks = scale2.getTicks();
    tickCount = realNumberScaleTicks.length;
  }
  var axisLabelModel = axis.getLabelModel();
  var labelFormatter = makeLabelFormatter(axis);
  var rect;
  var step = 1;
  if (tickCount > 40) {
    step = Math.ceil(tickCount / 40);
  }
  for (var i = 0; i < tickCount; i += step) {
    var tick = realNumberScaleTicks ? realNumberScaleTicks[i] : {
      value: categoryScaleExtent[0] + i
    };
    var label = labelFormatter(tick, i);
    var unrotatedSingleRect = axisLabelModel.getTextRect(label);
    var singleRect = rotateTextRect(unrotatedSingleRect, axisLabelModel.get("rotate") || 0);
    rect ? rect.union(singleRect) : rect = singleRect;
  }
  return rect;
}
function rotateTextRect(textRect, rotate2) {
  var rotateRadians = rotate2 * Math.PI / 180;
  var beforeWidth = textRect.width;
  var beforeHeight = textRect.height;
  var afterWidth = beforeWidth * Math.abs(Math.cos(rotateRadians)) + Math.abs(beforeHeight * Math.sin(rotateRadians));
  var afterHeight = beforeWidth * Math.abs(Math.sin(rotateRadians)) + Math.abs(beforeHeight * Math.cos(rotateRadians));
  var rotatedRect = new BoundingRect$1(textRect.x, textRect.y, afterWidth, afterHeight);
  return rotatedRect;
}
function getOptionCategoryInterval(model) {
  var interval = model.get("interval");
  return interval == null ? "auto" : interval;
}
function shouldShowAllLabels(axis) {
  return axis.type === "category" && getOptionCategoryInterval(axis.getLabelModel()) === 0;
}
function getDataDimensionsOnAxis(data, axisDim) {
  var dataDimMap = {};
  each$f(data.mapDimensionsAll(axisDim), function(dataDim) {
    dataDimMap[getStackedDimension(data, dataDim)] = true;
  });
  return keys(dataDimMap);
}
function unionAxisExtentFromData(dataExtent, data, axisDim) {
  if (data) {
    each$f(getDataDimensionsOnAxis(data, axisDim), function(dim) {
      var seriesExtent = data.getApproximateExtent(dim);
      seriesExtent[0] < dataExtent[0] && (dataExtent[0] = seriesExtent[0]);
      seriesExtent[1] > dataExtent[1] && (dataExtent[1] = seriesExtent[1]);
    });
  }
}
var AxisModelCommonMixin = function() {
  function AxisModelCommonMixin2() {
  }
  AxisModelCommonMixin2.prototype.getNeedCrossZero = function() {
    var option = this.option;
    return !option.scale;
  };
  AxisModelCommonMixin2.prototype.getCoordSysModel = function() {
    return;
  };
  return AxisModelCommonMixin2;
}();
var EPSILON = 1e-8;
function isAroundEqual(a, b2) {
  return Math.abs(a - b2) < EPSILON;
}
function contain(points2, x2, y2) {
  var w2 = 0;
  var p2 = points2[0];
  if (!p2) {
    return false;
  }
  for (var i = 1; i < points2.length; i++) {
    var p22 = points2[i];
    w2 += windingLine(p2[0], p2[1], p22[0], p22[1], x2, y2);
    p2 = p22;
  }
  var p0 = points2[0];
  if (!isAroundEqual(p2[0], p0[0]) || !isAroundEqual(p2[1], p0[1])) {
    w2 += windingLine(p2[0], p2[1], p0[0], p0[1], x2, y2);
  }
  return w2 !== 0;
}
var TMP_TRANSFORM = [];
function transformPoints(points2, transform2) {
  for (var p2 = 0; p2 < points2.length; p2++) {
    applyTransform$1(points2[p2], points2[p2], transform2);
  }
}
function updateBBoxFromPoints(points2, min3, max3, projection) {
  for (var i = 0; i < points2.length; i++) {
    var p2 = points2[i];
    if (projection) {
      p2 = projection.project(p2);
    }
    if (p2 && isFinite(p2[0]) && isFinite(p2[1])) {
      min$1(min3, min3, p2);
      max$1(max3, max3, p2);
    }
  }
}
function centroid$1(points2) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = points2.length;
  var x0 = points2[len2 - 1][0];
  var y0 = points2[len2 - 1][1];
  for (var i = 0; i < len2; i++) {
    var x1 = points2[i][0];
    var y1 = points2[i][1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
    x0 = x1;
    y0 = y1;
  }
  return signedArea ? [cx / signedArea / 3, cy / signedArea / 3, signedArea] : [points2[0][0] || 0, points2[0][1] || 0];
}
var Region = function() {
  function Region2(name) {
    this.name = name;
  }
  Region2.prototype.setCenter = function(center2) {
    this._center = center2;
  };
  Region2.prototype.getCenter = function() {
    var center2 = this._center;
    if (!center2) {
      center2 = this._center = this.calcCenter();
    }
    return center2;
  };
  return Region2;
}();
var GeoJSONPolygonGeometry = function() {
  function GeoJSONPolygonGeometry2(exterior, interiors) {
    this.type = "polygon";
    this.exterior = exterior;
    this.interiors = interiors;
  }
  return GeoJSONPolygonGeometry2;
}();
var GeoJSONLineStringGeometry = function() {
  function GeoJSONLineStringGeometry2(points2) {
    this.type = "linestring";
    this.points = points2;
  }
  return GeoJSONLineStringGeometry2;
}();
var GeoJSONRegion = function(_super) {
  __extends(GeoJSONRegion2, _super);
  function GeoJSONRegion2(name, geometries, cp) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoJSON";
    _this.geometries = geometries;
    _this._center = cp && [cp[0], cp[1]];
    return _this;
  }
  GeoJSONRegion2.prototype.calcCenter = function() {
    var geometries = this.geometries;
    var largestGeo;
    var largestGeoSize = 0;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      var exterior = geo.exterior;
      var size = exterior && exterior.length;
      if (size > largestGeoSize) {
        largestGeo = geo;
        largestGeoSize = size;
      }
    }
    if (largestGeo) {
      return centroid$1(largestGeo.exterior);
    }
    var rect = this.getBoundingRect();
    return [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.getBoundingRect = function(projection) {
    var rect = this._rect;
    if (rect && !projection) {
      return rect;
    }
    var min3 = [Infinity, Infinity];
    var max3 = [-Infinity, -Infinity];
    var geometries = this.geometries;
    each$f(geometries, function(geo) {
      if (geo.type === "polygon") {
        updateBBoxFromPoints(geo.exterior, min3, max3, projection);
      } else {
        each$f(geo.points, function(points2) {
          updateBBoxFromPoints(points2, min3, max3, projection);
        });
      }
    });
    if (!(isFinite(min3[0]) && isFinite(min3[1]) && isFinite(max3[0]) && isFinite(max3[1]))) {
      min3[0] = min3[1] = max3[0] = max3[1] = 0;
    }
    rect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    if (!projection) {
      this._rect = rect;
    }
    return rect;
  };
  GeoJSONRegion2.prototype.contain = function(coord) {
    var rect = this.getBoundingRect();
    var geometries = this.geometries;
    if (!rect.contain(coord[0], coord[1])) {
      return false;
    }
    loopGeo:
      for (var i = 0, len2 = geometries.length; i < len2; i++) {
        var geo = geometries[i];
        if (geo.type !== "polygon") {
          continue;
        }
        var exterior = geo.exterior;
        var interiors = geo.interiors;
        if (contain(exterior, coord[0], coord[1])) {
          for (var k2 = 0; k2 < (interiors ? interiors.length : 0); k2++) {
            if (contain(interiors[k2], coord[0], coord[1])) {
              continue loopGeo;
            }
          }
          return true;
        }
      }
    return false;
  };
  GeoJSONRegion2.prototype.transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var aspect = rect.width / rect.height;
    if (!width) {
      width = aspect * height;
    } else if (!height) {
      height = width / aspect;
    }
    var target = new BoundingRect$1(x2, y2, width, height);
    var transform2 = rect.calculateTransform(target);
    var geometries = this.geometries;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      if (geo.type === "polygon") {
        transformPoints(geo.exterior, transform2);
        each$f(geo.interiors, function(interior) {
          transformPoints(interior, transform2);
        });
      } else {
        each$f(geo.points, function(points2) {
          transformPoints(points2, transform2);
        });
      }
    }
    rect = this._rect;
    rect.copy(target);
    this._center = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.cloneShallow = function(name) {
    name == null && (name = this.name);
    var newRegion = new GeoJSONRegion2(name, this.geometries, this._center);
    newRegion._rect = this._rect;
    newRegion.transformTo = null;
    return newRegion;
  };
  return GeoJSONRegion2;
}(Region);
var GeoSVGRegion = function(_super) {
  __extends(GeoSVGRegion2, _super);
  function GeoSVGRegion2(name, elOnlyForCalculate) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoSVG";
    _this._elOnlyForCalculate = elOnlyForCalculate;
    return _this;
  }
  GeoSVGRegion2.prototype.calcCenter = function() {
    var el = this._elOnlyForCalculate;
    var rect = el.getBoundingRect();
    var center2 = [rect.x + rect.width / 2, rect.y + rect.height / 2];
    var mat = identity(TMP_TRANSFORM);
    var target = el;
    while (target && !target.isGeoSVGGraphicRoot) {
      mul(mat, target.getLocalTransform(), mat);
      target = target.parent;
    }
    invert(mat, mat);
    applyTransform$1(center2, center2, mat);
    return center2;
  };
  return GeoSVGRegion2;
}(Region);
function decode(json) {
  if (!json.UTF8Encoding) {
    return json;
  }
  var jsonCompressed = json;
  var encodeScale = jsonCompressed.UTF8Scale;
  if (encodeScale == null) {
    encodeScale = 1024;
  }
  var features2 = jsonCompressed.features;
  each$f(features2, function(feature) {
    var geometry = feature.geometry;
    var encodeOffsets = geometry.encodeOffsets;
    var coordinates = geometry.coordinates;
    if (!encodeOffsets) {
      return;
    }
    switch (geometry.type) {
      case "LineString":
        geometry.coordinates = decodeRing(coordinates, encodeOffsets, encodeScale);
        break;
      case "Polygon":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiLineString":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiPolygon":
        each$f(coordinates, function(rings, idx) {
          return decodeRings(rings, encodeOffsets[idx], encodeScale);
        });
    }
  });
  jsonCompressed.UTF8Encoding = false;
  return jsonCompressed;
}
function decodeRings(rings, encodeOffsets, encodeScale) {
  for (var c2 = 0; c2 < rings.length; c2++) {
    rings[c2] = decodeRing(rings[c2], encodeOffsets[c2], encodeScale);
  }
}
function decodeRing(coordinate, encodeOffsets, encodeScale) {
  var result = [];
  var prevX = encodeOffsets[0];
  var prevY = encodeOffsets[1];
  for (var i = 0; i < coordinate.length; i += 2) {
    var x2 = coordinate.charCodeAt(i) - 64;
    var y2 = coordinate.charCodeAt(i + 1) - 64;
    x2 = x2 >> 1 ^ -(x2 & 1);
    y2 = y2 >> 1 ^ -(y2 & 1);
    x2 += prevX;
    y2 += prevY;
    prevX = x2;
    prevY = y2;
    result.push([x2 / encodeScale, y2 / encodeScale]);
  }
  return result;
}
function parseGeoJSON(geoJson, nameProperty) {
  geoJson = decode(geoJson);
  return map$1(filter(geoJson.features, function(featureObj) {
    return featureObj.geometry && featureObj.properties && featureObj.geometry.coordinates.length > 0;
  }), function(featureObj) {
    var properties = featureObj.properties;
    var geo = featureObj.geometry;
    var geometries = [];
    switch (geo.type) {
      case "Polygon":
        var coordinates = geo.coordinates;
        geometries.push(new GeoJSONPolygonGeometry(coordinates[0], coordinates.slice(1)));
        break;
      case "MultiPolygon":
        each$f(geo.coordinates, function(item) {
          if (item[0]) {
            geometries.push(new GeoJSONPolygonGeometry(item[0], item.slice(1)));
          }
        });
        break;
      case "LineString":
        geometries.push(new GeoJSONLineStringGeometry([geo.coordinates]));
        break;
      case "MultiLineString":
        geometries.push(new GeoJSONLineStringGeometry(geo.coordinates));
    }
    var region = new GeoJSONRegion(properties[nameProperty || "name"], geometries, properties.cp);
    region.properties = properties;
    return region;
  });
}
var inner$g = makeInner();
function createAxisLabels(axis) {
  return axis.type === "category" ? makeCategoryLabels(axis) : makeRealNumberLabels(axis);
}
function createAxisTicks(axis, tickModel) {
  return axis.type === "category" ? makeCategoryTicks(axis, tickModel) : {
    ticks: map$1(axis.scale.getTicks(), function(tick) {
      return tick.value;
    })
  };
}
function makeCategoryLabels(axis) {
  var labelModel = axis.getLabelModel();
  var result = makeCategoryLabelsActually(axis, labelModel);
  return !labelModel.get("show") || axis.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: result.labelCategoryInterval
  } : result;
}
function makeCategoryLabelsActually(axis, labelModel) {
  var labelsCache = getListCache(axis, "labels");
  var optionLabelInterval = getOptionCategoryInterval(labelModel);
  var result = listCacheGet(labelsCache, optionLabelInterval);
  if (result) {
    return result;
  }
  var labels;
  var numericLabelInterval;
  if (isFunction(optionLabelInterval)) {
    labels = makeLabelsByCustomizedCategoryInterval(axis, optionLabelInterval);
  } else {
    numericLabelInterval = optionLabelInterval === "auto" ? makeAutoCategoryInterval(axis) : optionLabelInterval;
    labels = makeLabelsByNumericCategoryInterval(axis, numericLabelInterval);
  }
  return listCacheSet(labelsCache, optionLabelInterval, {
    labels,
    labelCategoryInterval: numericLabelInterval
  });
}
function makeCategoryTicks(axis, tickModel) {
  var ticksCache = getListCache(axis, "ticks");
  var optionTickInterval = getOptionCategoryInterval(tickModel);
  var result = listCacheGet(ticksCache, optionTickInterval);
  if (result) {
    return result;
  }
  var ticks;
  var tickCategoryInterval;
  if (!tickModel.get("show") || axis.scale.isBlank()) {
    ticks = [];
  }
  if (isFunction(optionTickInterval)) {
    ticks = makeLabelsByCustomizedCategoryInterval(axis, optionTickInterval, true);
  } else if (optionTickInterval === "auto") {
    var labelsResult = makeCategoryLabelsActually(axis, axis.getLabelModel());
    tickCategoryInterval = labelsResult.labelCategoryInterval;
    ticks = map$1(labelsResult.labels, function(labelItem) {
      return labelItem.tickValue;
    });
  } else {
    tickCategoryInterval = optionTickInterval;
    ticks = makeLabelsByNumericCategoryInterval(axis, tickCategoryInterval, true);
  }
  return listCacheSet(ticksCache, optionTickInterval, {
    ticks,
    tickCategoryInterval
  });
}
function makeRealNumberLabels(axis) {
  var ticks = axis.scale.getTicks();
  var labelFormatter = makeLabelFormatter(axis);
  return {
    labels: map$1(ticks, function(tick, idx) {
      return {
        level: tick.level,
        formattedLabel: labelFormatter(tick, idx),
        rawLabel: axis.scale.getLabel(tick),
        tickValue: tick.value
      };
    })
  };
}
function getListCache(axis, prop) {
  return inner$g(axis)[prop] || (inner$g(axis)[prop] = []);
}
function listCacheGet(cache, key) {
  for (var i = 0; i < cache.length; i++) {
    if (cache[i].key === key) {
      return cache[i].value;
    }
  }
}
function listCacheSet(cache, key, value) {
  cache.push({
    key,
    value
  });
  return value;
}
function makeAutoCategoryInterval(axis) {
  var result = inner$g(axis).autoInterval;
  return result != null ? result : inner$g(axis).autoInterval = axis.calculateCategoryInterval();
}
function calculateCategoryInterval(axis) {
  var params = fetchAutoCategoryIntervalCalculationParams(axis);
  var labelFormatter = makeLabelFormatter(axis);
  var rotation = (params.axisRotate - params.labelRotate) / 180 * Math.PI;
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var tickCount = ordinalScale.count();
  if (ordinalExtent[1] - ordinalExtent[0] < 1) {
    return 0;
  }
  var step = 1;
  if (tickCount > 40) {
    step = Math.max(1, Math.floor(tickCount / 40));
  }
  var tickValue = ordinalExtent[0];
  var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
  var unitW = Math.abs(unitSpan * Math.cos(rotation));
  var unitH = Math.abs(unitSpan * Math.sin(rotation));
  var maxW = 0;
  var maxH = 0;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    var width = 0;
    var height = 0;
    var rect = getBoundingRect(labelFormatter({
      value: tickValue
    }), params.font, "center", "top");
    width = rect.width * 1.3;
    height = rect.height * 1.3;
    maxW = Math.max(maxW, width, 7);
    maxH = Math.max(maxH, height, 7);
  }
  var dw = maxW / unitW;
  var dh = maxH / unitH;
  isNaN(dw) && (dw = Infinity);
  isNaN(dh) && (dh = Infinity);
  var interval = Math.max(0, Math.floor(Math.min(dw, dh)));
  var cache = inner$g(axis.model);
  var axisExtent = axis.getExtent();
  var lastAutoInterval = cache.lastAutoInterval;
  var lastTickCount = cache.lastTickCount;
  if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval && cache.axisExtent0 === axisExtent[0] && cache.axisExtent1 === axisExtent[1]) {
    interval = lastAutoInterval;
  } else {
    cache.lastTickCount = tickCount;
    cache.lastAutoInterval = interval;
    cache.axisExtent0 = axisExtent[0];
    cache.axisExtent1 = axisExtent[1];
  }
  return interval;
}
function fetchAutoCategoryIntervalCalculationParams(axis) {
  var labelModel = axis.getLabelModel();
  return {
    axisRotate: axis.getRotate ? axis.getRotate() : axis.isHorizontal && !axis.isHorizontal() ? 90 : 0,
    labelRotate: labelModel.get("rotate") || 0,
    font: labelModel.getFont()
  };
}
function makeLabelsByNumericCategoryInterval(axis, categoryInterval, onlyTick) {
  var labelFormatter = makeLabelFormatter(axis);
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var labelModel = axis.getLabelModel();
  var result = [];
  var step = Math.max((categoryInterval || 0) + 1, 1);
  var startTick = ordinalExtent[0];
  var tickCount = ordinalScale.count();
  if (startTick !== 0 && step > 1 && tickCount / step > 2) {
    startTick = Math.round(Math.ceil(startTick / step) * step);
  }
  var showAllLabel = shouldShowAllLabels(axis);
  var includeMinLabel = labelModel.get("showMinLabel") || showAllLabel;
  var includeMaxLabel = labelModel.get("showMaxLabel") || showAllLabel;
  if (includeMinLabel && startTick !== ordinalExtent[0]) {
    addItem(ordinalExtent[0]);
  }
  var tickValue = startTick;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    addItem(tickValue);
  }
  if (includeMaxLabel && tickValue - step !== ordinalExtent[1]) {
    addItem(ordinalExtent[1]);
  }
  function addItem(tickValue2) {
    var tickObj = {
      value: tickValue2
    };
    result.push(onlyTick ? tickValue2 : {
      formattedLabel: labelFormatter(tickObj),
      rawLabel: ordinalScale.getLabel(tickObj),
      tickValue: tickValue2
    });
  }
  return result;
}
function makeLabelsByCustomizedCategoryInterval(axis, categoryInterval, onlyTick) {
  var ordinalScale = axis.scale;
  var labelFormatter = makeLabelFormatter(axis);
  var result = [];
  each$f(ordinalScale.getTicks(), function(tick) {
    var rawLabel = ordinalScale.getLabel(tick);
    var tickValue = tick.value;
    if (categoryInterval(tick.value, rawLabel)) {
      result.push(onlyTick ? tickValue : {
        formattedLabel: labelFormatter(tick),
        rawLabel,
        tickValue
      });
    }
  });
  return result;
}
var NORMALIZED_EXTENT = [0, 1];
var Axis = function() {
  function Axis2(dim, scale2, extent3) {
    this.onBand = false;
    this.inverse = false;
    this.dim = dim;
    this.scale = scale2;
    this._extent = extent3 || [0, 0];
  }
  Axis2.prototype.contain = function(coord) {
    var extent3 = this._extent;
    var min3 = Math.min(extent3[0], extent3[1]);
    var max3 = Math.max(extent3[0], extent3[1]);
    return coord >= min3 && coord <= max3;
  };
  Axis2.prototype.containData = function(data) {
    return this.scale.contain(data);
  };
  Axis2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Axis2.prototype.getPixelPrecision = function(dataExtent) {
    return getPixelPrecision(dataExtent || this.scale.getExtent(), this._extent);
  };
  Axis2.prototype.setExtent = function(start2, end2) {
    var extent3 = this._extent;
    extent3[0] = start2;
    extent3[1] = end2;
  };
  Axis2.prototype.dataToCoord = function(data, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    data = scale2.normalize(data);
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    return linearMap$2(data, NORMALIZED_EXTENT, extent3, clamp2);
  };
  Axis2.prototype.coordToData = function(coord, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    var t2 = linearMap$2(coord, extent3, NORMALIZED_EXTENT, clamp2);
    return this.scale.scale(t2);
  };
  Axis2.prototype.pointToData = function(point, clamp2) {
    return;
  };
  Axis2.prototype.getTicksCoords = function(opt) {
    opt = opt || {};
    var tickModel = opt.tickModel || this.getTickModel();
    var result = createAxisTicks(this, tickModel);
    var ticks = result.ticks;
    var ticksCoords = map$1(ticks, function(tickVal) {
      return {
        coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(tickVal) : tickVal),
        tickValue: tickVal
      };
    }, this);
    var alignWithLabel = tickModel.get("alignWithLabel");
    fixOnBandTicksCoords(this, ticksCoords, alignWithLabel, opt.clamp);
    return ticksCoords;
  };
  Axis2.prototype.getMinorTicksCoords = function() {
    if (this.scale.type === "ordinal") {
      return [];
    }
    var minorTickModel = this.model.getModel("minorTick");
    var splitNumber = minorTickModel.get("splitNumber");
    if (!(splitNumber > 0 && splitNumber < 100)) {
      splitNumber = 5;
    }
    var minorTicks = this.scale.getMinorTicks(splitNumber);
    var minorTicksCoords = map$1(minorTicks, function(minorTicksGroup) {
      return map$1(minorTicksGroup, function(minorTick) {
        return {
          coord: this.dataToCoord(minorTick),
          tickValue: minorTick
        };
      }, this);
    }, this);
    return minorTicksCoords;
  };
  Axis2.prototype.getViewLabels = function() {
    return createAxisLabels(this).labels;
  };
  Axis2.prototype.getLabelModel = function() {
    return this.model.getModel("axisLabel");
  };
  Axis2.prototype.getTickModel = function() {
    return this.model.getModel("axisTick");
  };
  Axis2.prototype.getBandWidth = function() {
    var axisExtent = this._extent;
    var dataExtent = this.scale.getExtent();
    var len2 = dataExtent[1] - dataExtent[0] + (this.onBand ? 1 : 0);
    len2 === 0 && (len2 = 1);
    var size = Math.abs(axisExtent[1] - axisExtent[0]);
    return Math.abs(size) / len2;
  };
  Axis2.prototype.calculateCategoryInterval = function() {
    return calculateCategoryInterval(this);
  };
  return Axis2;
}();
function fixExtentWithBands(extent3, nTick) {
  var size = extent3[1] - extent3[0];
  var len2 = nTick;
  var margin = size / len2 / 2;
  extent3[0] += margin;
  extent3[1] -= margin;
}
function fixOnBandTicksCoords(axis, ticksCoords, alignWithLabel, clamp2) {
  var ticksLen = ticksCoords.length;
  if (!axis.onBand || alignWithLabel || !ticksLen) {
    return;
  }
  var axisExtent = axis.getExtent();
  var last;
  var diffSize;
  if (ticksLen === 1) {
    ticksCoords[0].coord = axisExtent[0];
    last = ticksCoords[1] = {
      coord: axisExtent[0]
    };
  } else {
    var crossLen = ticksCoords[ticksLen - 1].tickValue - ticksCoords[0].tickValue;
    var shift_1 = (ticksCoords[ticksLen - 1].coord - ticksCoords[0].coord) / crossLen;
    each$f(ticksCoords, function(ticksItem) {
      ticksItem.coord -= shift_1 / 2;
    });
    var dataExtent = axis.scale.getExtent();
    diffSize = 1 + dataExtent[1] - ticksCoords[ticksLen - 1].tickValue;
    last = {
      coord: ticksCoords[ticksLen - 1].coord + shift_1 * diffSize
    };
    ticksCoords.push(last);
  }
  var inverse = axisExtent[0] > axisExtent[1];
  if (littleThan2(ticksCoords[0].coord, axisExtent[0])) {
    clamp2 ? ticksCoords[0].coord = axisExtent[0] : ticksCoords.shift();
  }
  if (clamp2 && littleThan2(axisExtent[0], ticksCoords[0].coord)) {
    ticksCoords.unshift({
      coord: axisExtent[0]
    });
  }
  if (littleThan2(axisExtent[1], last.coord)) {
    clamp2 ? last.coord = axisExtent[1] : ticksCoords.pop();
  }
  if (clamp2 && littleThan2(last.coord, axisExtent[1])) {
    ticksCoords.push({
      coord: axisExtent[1]
    });
  }
  function littleThan2(a, b2) {
    a = round$3(a);
    b2 = round$3(b2);
    return inverse ? a > b2 : a < b2;
  }
}
var Axis$1 = Axis;
var PI2$3 = Math.PI * 2;
var CMD$1 = PathProxy$1.CMD;
var DEFAULT_SEARCH_SPACE = ["top", "right", "bottom", "left"];
function getCandidateAnchor(pos, distance2, rect, outPt, outDir) {
  var width = rect.width;
  var height = rect.height;
  switch (pos) {
    case "top":
      outPt.set(rect.x + width / 2, rect.y - distance2);
      outDir.set(0, -1);
      break;
    case "bottom":
      outPt.set(rect.x + width / 2, rect.y + height + distance2);
      outDir.set(0, 1);
      break;
    case "left":
      outPt.set(rect.x - distance2, rect.y + height / 2);
      outDir.set(-1, 0);
      break;
    case "right":
      outPt.set(rect.x + width + distance2, rect.y + height / 2);
      outDir.set(1, 0);
      break;
  }
}
function projectPointToArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2, out2) {
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  x2 /= d2;
  y2 /= d2;
  var ox = x2 * r2 + cx;
  var oy = y2 * r2 + cy;
  if (Math.abs(startAngle - endAngle) % PI2$3 < 1e-4) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$3;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$3;
  }
  if (angle >= startAngle && angle <= endAngle || angle + PI2$3 >= startAngle && angle + PI2$3 <= endAngle) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  var x1 = r2 * Math.cos(startAngle) + cx;
  var y1 = r2 * Math.sin(startAngle) + cy;
  var x22 = r2 * Math.cos(endAngle) + cx;
  var y22 = r2 * Math.sin(endAngle) + cy;
  var d1 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  var d22 = (x22 - x2) * (x22 - x2) + (y22 - y2) * (y22 - y2);
  if (d1 < d22) {
    out2[0] = x1;
    out2[1] = y1;
    return Math.sqrt(d1);
  } else {
    out2[0] = x22;
    out2[1] = y22;
    return Math.sqrt(d22);
  }
}
function projectPointToLine(x1, y1, x2, y2, x3, y3, out2, limitToEnds) {
  var dx = x3 - x1;
  var dy = y3 - y1;
  var dx1 = x2 - x1;
  var dy1 = y2 - y1;
  var lineLen = Math.sqrt(dx1 * dx1 + dy1 * dy1);
  dx1 /= lineLen;
  dy1 /= lineLen;
  var projectedLen = dx * dx1 + dy * dy1;
  var t2 = projectedLen / lineLen;
  if (limitToEnds) {
    t2 = Math.min(Math.max(t2, 0), 1);
  }
  t2 *= lineLen;
  var ox = out2[0] = x1 + t2 * dx1;
  var oy = out2[1] = y1 + t2 * dy1;
  return Math.sqrt((ox - x3) * (ox - x3) + (oy - y3) * (oy - y3));
}
function projectPointToRect(x1, y1, width, height, x2, y2, out2) {
  if (width < 0) {
    x1 = x1 + width;
    width = -width;
  }
  if (height < 0) {
    y1 = y1 + height;
    height = -height;
  }
  var x22 = x1 + width;
  var y22 = y1 + height;
  var ox = out2[0] = Math.min(Math.max(x2, x1), x22);
  var oy = out2[1] = Math.min(Math.max(y2, y1), y22);
  return Math.sqrt((ox - x2) * (ox - x2) + (oy - y2) * (oy - y2));
}
var tmpPt = [];
function nearestPointOnRect(pt, rect, out2) {
  var dist2 = projectPointToRect(rect.x, rect.y, rect.width, rect.height, pt.x, pt.y, tmpPt);
  out2.set(tmpPt[0], tmpPt[1]);
  return dist2;
}
function nearestPointOnPath(pt, path, out2) {
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  var minDist = Infinity;
  var data = path.data;
  var x2 = pt.x;
  var y2 = pt.y;
  for (var i = 0; i < data.length; ) {
    var cmd = data[i++];
    if (i === 1) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    var d2 = minDist;
    switch (cmd) {
      case CMD$1.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$1.L:
        d2 = projectPointToLine(xi, yi, data[i], data[i + 1], x2, y2, tmpPt, true);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.C:
        d2 = cubicProjectPoint(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.Q:
        d2 = quadraticProjectPoint(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (i <= 1) {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        d2 = projectPointToArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2, tmpPt);
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$1.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        d2 = projectPointToRect(x0, y0, width, height, x2, y2, tmpPt);
        break;
      case CMD$1.Z:
        d2 = projectPointToLine(xi, yi, x0, y0, x2, y2, tmpPt, true);
        xi = x0;
        yi = y0;
        break;
    }
    if (d2 < minDist) {
      minDist = d2;
      out2.set(tmpPt[0], tmpPt[1]);
    }
  }
  return minDist;
}
var pt0 = new Point$1();
var pt1 = new Point$1();
var pt2 = new Point$1();
var dir = new Point$1();
var dir2 = new Point$1();
function updateLabelLinePoints(target, labelLineModel) {
  if (!target) {
    return;
  }
  var labelLine = target.getTextGuideLine();
  var label = target.getTextContent();
  if (!(label && labelLine)) {
    return;
  }
  var labelGuideConfig = target.textGuideLineConfig || {};
  var points2 = [[0, 0], [0, 0], [0, 0]];
  var searchSpace = labelGuideConfig.candidates || DEFAULT_SEARCH_SPACE;
  var labelRect = label.getBoundingRect().clone();
  labelRect.applyTransform(label.getComputedTransform());
  var minDist = Infinity;
  var anchorPoint = labelGuideConfig.anchor;
  var targetTransform = target.getComputedTransform();
  var targetInversedTransform = targetTransform && invert([], targetTransform);
  var len2 = labelLineModel.get("length2") || 0;
  if (anchorPoint) {
    pt2.copy(anchorPoint);
  }
  for (var i = 0; i < searchSpace.length; i++) {
    var candidate = searchSpace[i];
    getCandidateAnchor(candidate, 0, labelRect, pt0, dir);
    Point$1.scaleAndAdd(pt1, pt0, dir, len2);
    pt1.transform(targetInversedTransform);
    var boundingRect = target.getBoundingRect();
    var dist2 = anchorPoint ? anchorPoint.distance(pt1) : target instanceof Path$1 ? nearestPointOnPath(pt1, target.path, pt2) : nearestPointOnRect(pt1, boundingRect, pt2);
    if (dist2 < minDist) {
      minDist = dist2;
      pt1.transform(targetTransform);
      pt2.transform(targetTransform);
      pt2.toArray(points2[0]);
      pt1.toArray(points2[1]);
      pt0.toArray(points2[2]);
    }
  }
  limitTurnAngle(points2, labelLineModel.get("minTurnAngle"));
  labelLine.setShape({
    points: points2
  });
}
var tmpArr = [];
var tmpProjPoint = new Point$1();
function limitTurnAngle(linePoints, minTurnAngle) {
  if (!(minTurnAngle <= 180 && minTurnAngle > 0)) {
    return;
  }
  minTurnAngle = minTurnAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt0, pt1);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(dir2);
  var minTurnAngleCos = Math.cos(minTurnAngle);
  if (minTurnAngleCos < angleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI - minTurnAngle));
    var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
    if (isNaN(t2)) {
      return;
    }
    if (t2 < 0) {
      Point$1.copy(tmpProjPoint, pt1);
    } else if (t2 > 1) {
      Point$1.copy(tmpProjPoint, pt2);
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function limitSurfaceAngle(linePoints, surfaceNormal, maxSurfaceAngle) {
  if (!(maxSurfaceAngle <= 180 && maxSurfaceAngle > 0)) {
    return;
  }
  maxSurfaceAngle = maxSurfaceAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt1, pt0);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(surfaceNormal);
  var maxSurfaceAngleCos = Math.cos(maxSurfaceAngle);
  if (angleCos < maxSurfaceAngleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    var HALF_PI = Math.PI / 2;
    var angle2 = Math.acos(dir2.dot(surfaceNormal));
    var newAngle = HALF_PI + angle2 - maxSurfaceAngle;
    if (newAngle >= HALF_PI) {
      Point$1.copy(tmpProjPoint, pt2);
    } else {
      tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI / 2 - newAngle));
      var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
      if (isNaN(t2)) {
        return;
      }
      if (t2 < 0) {
        Point$1.copy(tmpProjPoint, pt1);
      } else if (t2 > 1) {
        Point$1.copy(tmpProjPoint, pt2);
      }
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function setLabelLineState(labelLine, ignore, stateName, stateModel) {
  var isNormal = stateName === "normal";
  var stateObj = isNormal ? labelLine : labelLine.ensureState(stateName);
  stateObj.ignore = ignore;
  var smooth = stateModel.get("smooth");
  if (smooth && smooth === true) {
    smooth = 0.3;
  }
  stateObj.shape = stateObj.shape || {};
  if (smooth > 0) {
    stateObj.shape.smooth = smooth;
  }
  var styleObj = stateModel.getModel("lineStyle").getLineStyle();
  isNormal ? labelLine.useStyle(styleObj) : stateObj.style = styleObj;
}
function buildLabelLinePath(path, shape) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (!points2) {
    return;
  }
  path.moveTo(points2[0][0], points2[0][1]);
  if (smooth > 0 && points2.length >= 3) {
    var len1 = dist$1(points2[0], points2[1]);
    var len2 = dist$1(points2[1], points2[2]);
    if (!len1 || !len2) {
      path.lineTo(points2[1][0], points2[1][1]);
      path.lineTo(points2[2][0], points2[2][1]);
      return;
    }
    var moveLen = Math.min(len1, len2) * smooth;
    var midPoint0 = lerp$1([], points2[1], points2[0], moveLen / len1);
    var midPoint2 = lerp$1([], points2[1], points2[2], moveLen / len2);
    var midPoint1 = lerp$1([], midPoint0, midPoint2, 0.5);
    path.bezierCurveTo(midPoint0[0], midPoint0[1], midPoint0[0], midPoint0[1], midPoint1[0], midPoint1[1]);
    path.bezierCurveTo(midPoint2[0], midPoint2[1], midPoint2[0], midPoint2[1], points2[2][0], points2[2][1]);
  } else {
    for (var i = 1; i < points2.length; i++) {
      path.lineTo(points2[i][0], points2[i][1]);
    }
  }
}
function setLabelLineStyle(targetEl, statesModels, defaultStyle) {
  var labelLine = targetEl.getTextGuideLine();
  var label = targetEl.getTextContent();
  if (!label) {
    if (labelLine) {
      targetEl.removeTextGuideLine();
    }
    return;
  }
  var normalModel = statesModels.normal;
  var showNormal = normalModel.get("show");
  var labelIgnoreNormal = label.ignore;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateName = DISPLAY_STATES[i];
    var stateModel = statesModels[stateName];
    var isNormal = stateName === "normal";
    if (stateModel) {
      var stateShow = stateModel.get("show");
      var isLabelIgnored = isNormal ? labelIgnoreNormal : retrieve2(label.states[stateName] && label.states[stateName].ignore, labelIgnoreNormal);
      if (isLabelIgnored || !retrieve2(stateShow, showNormal)) {
        var stateObj = isNormal ? labelLine : labelLine && labelLine.states.normal;
        if (stateObj) {
          stateObj.ignore = true;
        }
        continue;
      }
      if (!labelLine) {
        labelLine = new Polyline$3();
        targetEl.setTextGuideLine(labelLine);
        if (!isNormal && (labelIgnoreNormal || !showNormal)) {
          setLabelLineState(labelLine, true, "normal", statesModels.normal);
        }
        if (targetEl.stateProxy) {
          labelLine.stateProxy = targetEl.stateProxy;
        }
      }
      setLabelLineState(labelLine, false, stateName, stateModel);
    }
  }
  if (labelLine) {
    defaults(labelLine.style, defaultStyle);
    labelLine.style.fill = null;
    var showAbove = normalModel.get("showAbove");
    var labelLineConfig = targetEl.textGuideLineConfig = targetEl.textGuideLineConfig || {};
    labelLineConfig.showAbove = showAbove || false;
    labelLine.buildPath = buildLabelLinePath;
  }
}
function getLabelLineStatesModels(itemModel, labelLineName) {
  labelLineName = labelLineName || "labelLine";
  var statesModels = {
    normal: itemModel.getModel(labelLineName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelLineName]);
  }
  return statesModels;
}
function prepareLayoutList(input) {
  var list = [];
  for (var i = 0; i < input.length; i++) {
    var rawItem = input[i];
    if (rawItem.defaultAttr.ignore) {
      continue;
    }
    var label = rawItem.label;
    var transform2 = label.getComputedTransform();
    var localRect = label.getBoundingRect();
    var isAxisAligned = !transform2 || transform2[1] < 1e-5 && transform2[2] < 1e-5;
    var minMargin = label.style.margin || 0;
    var globalRect = localRect.clone();
    globalRect.applyTransform(transform2);
    globalRect.x -= minMargin / 2;
    globalRect.y -= minMargin / 2;
    globalRect.width += minMargin;
    globalRect.height += minMargin;
    var obb = isAxisAligned ? new OrientedBoundingRect$1(localRect, transform2) : null;
    list.push({
      label,
      labelLine: rawItem.labelLine,
      rect: globalRect,
      localRect,
      obb,
      priority: rawItem.priority,
      defaultAttr: rawItem.defaultAttr,
      layoutOption: rawItem.computedLayoutOption,
      axisAligned: isAxisAligned,
      transform: transform2
    });
  }
  return list;
}
function shiftLayout(list, xyDim, sizeDim, minBound, maxBound, balanceShift) {
  var len2 = list.length;
  if (len2 < 2) {
    return;
  }
  list.sort(function(a, b2) {
    return a.rect[xyDim] - b2.rect[xyDim];
  });
  var lastPos = 0;
  var delta;
  var adjusted = false;
  var totalShifts = 0;
  for (var i = 0; i < len2; i++) {
    var item = list[i];
    var rect = item.rect;
    delta = rect[xyDim] - lastPos;
    if (delta < 0) {
      rect[xyDim] -= delta;
      item.label[xyDim] -= delta;
      adjusted = true;
    }
    var shift = Math.max(-delta, 0);
    totalShifts += shift;
    lastPos = rect[xyDim] + rect[sizeDim];
  }
  if (totalShifts > 0 && balanceShift) {
    shiftList(-totalShifts / len2, 0, len2);
  }
  var first = list[0];
  var last = list[len2 - 1];
  var minGap;
  var maxGap;
  updateMinMaxGap();
  minGap < 0 && squeezeGaps(-minGap, 0.8);
  maxGap < 0 && squeezeGaps(maxGap, 0.8);
  updateMinMaxGap();
  takeBoundsGap(minGap, maxGap, 1);
  takeBoundsGap(maxGap, minGap, -1);
  updateMinMaxGap();
  if (minGap < 0) {
    squeezeWhenBailout(-minGap);
  }
  if (maxGap < 0) {
    squeezeWhenBailout(maxGap);
  }
  function updateMinMaxGap() {
    minGap = first.rect[xyDim] - minBound;
    maxGap = maxBound - last.rect[xyDim] - last.rect[sizeDim];
  }
  function takeBoundsGap(gapThisBound, gapOtherBound, moveDir) {
    if (gapThisBound < 0) {
      var moveFromMaxGap = Math.min(gapOtherBound, -gapThisBound);
      if (moveFromMaxGap > 0) {
        shiftList(moveFromMaxGap * moveDir, 0, len2);
        var remained = moveFromMaxGap + gapThisBound;
        if (remained < 0) {
          squeezeGaps(-remained * moveDir, 1);
        }
      } else {
        squeezeGaps(-gapThisBound * moveDir, 1);
      }
    }
  }
  function shiftList(delta2, start2, end2) {
    if (delta2 !== 0) {
      adjusted = true;
    }
    for (var i2 = start2; i2 < end2; i2++) {
      var item2 = list[i2];
      var rect2 = item2.rect;
      rect2[xyDim] += delta2;
      item2.label[xyDim] += delta2;
    }
  }
  function squeezeGaps(delta2, maxSqeezePercent) {
    var gaps = [];
    var totalGaps = 0;
    for (var i2 = 1; i2 < len2; i2++) {
      var prevItemRect = list[i2 - 1].rect;
      var gap = Math.max(list[i2].rect[xyDim] - prevItemRect[xyDim] - prevItemRect[sizeDim], 0);
      gaps.push(gap);
      totalGaps += gap;
    }
    if (!totalGaps) {
      return;
    }
    var squeezePercent = Math.min(Math.abs(delta2) / totalGaps, maxSqeezePercent);
    if (delta2 > 0) {
      for (var i2 = 0; i2 < len2 - 1; i2++) {
        var movement = gaps[i2] * squeezePercent;
        shiftList(movement, 0, i2 + 1);
      }
    } else {
      for (var i2 = len2 - 1; i2 > 0; i2--) {
        var movement = gaps[i2 - 1] * squeezePercent;
        shiftList(-movement, i2, len2);
      }
    }
  }
  function squeezeWhenBailout(delta2) {
    var dir3 = delta2 < 0 ? -1 : 1;
    delta2 = Math.abs(delta2);
    var moveForEachLabel = Math.ceil(delta2 / (len2 - 1));
    for (var i2 = 0; i2 < len2 - 1; i2++) {
      if (dir3 > 0) {
        shiftList(moveForEachLabel, 0, i2 + 1);
      } else {
        shiftList(-moveForEachLabel, len2 - i2 - 1, len2);
      }
      delta2 -= moveForEachLabel;
      if (delta2 <= 0) {
        return;
      }
    }
  }
  return adjusted;
}
function shiftLayoutOnX(list, leftBound, rightBound, balanceShift) {
  return shiftLayout(list, "x", "width", leftBound, rightBound, balanceShift);
}
function shiftLayoutOnY(list, topBound, bottomBound, balanceShift) {
  return shiftLayout(list, "y", "height", topBound, bottomBound, balanceShift);
}
function hideOverlap(labelList) {
  var displayedLabels = [];
  labelList.sort(function(a, b2) {
    return b2.priority - a.priority;
  });
  var globalRect = new BoundingRect$1(0, 0, 0, 0);
  function hideEl(el) {
    if (!el.ignore) {
      var emphasisState = el.ensureState("emphasis");
      if (emphasisState.ignore == null) {
        emphasisState.ignore = false;
      }
    }
    el.ignore = true;
  }
  for (var i = 0; i < labelList.length; i++) {
    var labelItem = labelList[i];
    var isAxisAligned = labelItem.axisAligned;
    var localRect = labelItem.localRect;
    var transform2 = labelItem.transform;
    var label = labelItem.label;
    var labelLine = labelItem.labelLine;
    globalRect.copy(labelItem.rect);
    globalRect.width -= 0.1;
    globalRect.height -= 0.1;
    globalRect.x += 0.05;
    globalRect.y += 0.05;
    var obb = labelItem.obb;
    var overlapped = false;
    for (var j = 0; j < displayedLabels.length; j++) {
      var existsTextCfg = displayedLabels[j];
      if (!globalRect.intersect(existsTextCfg.rect)) {
        continue;
      }
      if (isAxisAligned && existsTextCfg.axisAligned) {
        overlapped = true;
        break;
      }
      if (!existsTextCfg.obb) {
        existsTextCfg.obb = new OrientedBoundingRect$1(existsTextCfg.localRect, existsTextCfg.transform);
      }
      if (!obb) {
        obb = new OrientedBoundingRect$1(localRect, transform2);
      }
      if (obb.intersect(existsTextCfg.obb)) {
        overlapped = true;
        break;
      }
    }
    if (overlapped) {
      hideEl(label);
      labelLine && hideEl(labelLine);
    } else {
      label.attr("ignore", labelItem.defaultAttr.ignore);
      labelLine && labelLine.attr("ignore", labelItem.defaultAttr.labelGuideIgnore);
      displayedLabels.push(labelItem);
    }
  }
}
function cloneArr(points2) {
  if (points2) {
    var newPoints = [];
    for (var i = 0; i < points2.length; i++) {
      newPoints.push(points2[i].slice());
    }
    return newPoints;
  }
}
function prepareLayoutCallbackParams(labelItem, hostEl) {
  var label = labelItem.label;
  var labelLine = hostEl && hostEl.getTextGuideLine();
  return {
    dataIndex: labelItem.dataIndex,
    dataType: labelItem.dataType,
    seriesIndex: labelItem.seriesModel.seriesIndex,
    text: labelItem.label.style.text,
    rect: labelItem.hostRect,
    labelRect: labelItem.rect,
    align: label.style.align,
    verticalAlign: label.style.verticalAlign,
    labelLinePoints: cloneArr(labelLine && labelLine.shape.points)
  };
}
var LABEL_OPTION_TO_STYLE_KEYS = ["align", "verticalAlign", "width", "height", "fontSize"];
var dummyTransformable = new Transformable$1();
var labelLayoutInnerStore = makeInner();
var labelLineAnimationStore = makeInner();
function extendWithKeys(target, source, keys2) {
  for (var i = 0; i < keys2.length; i++) {
    var key = keys2[i];
    if (source[key] != null) {
      target[key] = source[key];
    }
  }
}
var LABEL_LAYOUT_PROPS = ["x", "y", "rotation"];
var LabelManager = function() {
  function LabelManager2() {
    this._labelList = [];
    this._chartViewList = [];
  }
  LabelManager2.prototype.clearLabels = function() {
    this._labelList = [];
    this._chartViewList = [];
  };
  LabelManager2.prototype._addLabel = function(dataIndex, dataType, seriesModel, label, layoutOption) {
    var labelStyle = label.style;
    var hostEl = label.__hostTarget;
    var textConfig = hostEl.textConfig || {};
    var labelTransform = label.getComputedTransform();
    var labelRect = label.getBoundingRect().plain();
    BoundingRect$1.applyTransform(labelRect, labelRect, labelTransform);
    if (labelTransform) {
      dummyTransformable.setLocalTransform(labelTransform);
    } else {
      dummyTransformable.x = dummyTransformable.y = dummyTransformable.rotation = dummyTransformable.originX = dummyTransformable.originY = 0;
      dummyTransformable.scaleX = dummyTransformable.scaleY = 1;
    }
    var host = label.__hostTarget;
    var hostRect;
    if (host) {
      hostRect = host.getBoundingRect().plain();
      var transform2 = host.getComputedTransform();
      BoundingRect$1.applyTransform(hostRect, hostRect, transform2);
    }
    var labelGuide = hostRect && host.getTextGuideLine();
    this._labelList.push({
      label,
      labelLine: labelGuide,
      seriesModel,
      dataIndex,
      dataType,
      layoutOption,
      computedLayoutOption: null,
      rect: labelRect,
      hostRect,
      priority: hostRect ? hostRect.width * hostRect.height : 0,
      defaultAttr: {
        ignore: label.ignore,
        labelGuideIgnore: labelGuide && labelGuide.ignore,
        x: dummyTransformable.x,
        y: dummyTransformable.y,
        scaleX: dummyTransformable.scaleX,
        scaleY: dummyTransformable.scaleY,
        rotation: dummyTransformable.rotation,
        style: {
          x: labelStyle.x,
          y: labelStyle.y,
          align: labelStyle.align,
          verticalAlign: labelStyle.verticalAlign,
          width: labelStyle.width,
          height: labelStyle.height,
          fontSize: labelStyle.fontSize
        },
        cursor: label.cursor,
        attachedPos: textConfig.position,
        attachedRot: textConfig.rotation
      }
    });
  };
  LabelManager2.prototype.addLabelsOfSeries = function(chartView) {
    var _this = this;
    this._chartViewList.push(chartView);
    var seriesModel = chartView.__model;
    var layoutOption = seriesModel.get("labelLayout");
    if (!(isFunction(layoutOption) || keys(layoutOption).length)) {
      return;
    }
    chartView.group.traverse(function(child) {
      if (child.ignore) {
        return true;
      }
      var textEl = child.getTextContent();
      var ecData = getECData(child);
      if (textEl && !textEl.disableLabelLayout) {
        _this._addLabel(ecData.dataIndex, ecData.dataType, seriesModel, textEl, layoutOption);
      }
    });
  };
  LabelManager2.prototype.updateLayoutConfig = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    function createDragHandler(el, labelLineModel) {
      return function() {
        updateLabelLinePoints(el, labelLineModel);
      };
    }
    for (var i = 0; i < this._labelList.length; i++) {
      var labelItem = this._labelList[i];
      var label = labelItem.label;
      var hostEl = label.__hostTarget;
      var defaultLabelAttr = labelItem.defaultAttr;
      var layoutOption = void 0;
      if (isFunction(labelItem.layoutOption)) {
        layoutOption = labelItem.layoutOption(prepareLayoutCallbackParams(labelItem, hostEl));
      } else {
        layoutOption = labelItem.layoutOption;
      }
      layoutOption = layoutOption || {};
      labelItem.computedLayoutOption = layoutOption;
      var degreeToRadian = Math.PI / 180;
      if (hostEl) {
        hostEl.setTextConfig({
          local: false,
          position: layoutOption.x != null || layoutOption.y != null ? null : defaultLabelAttr.attachedPos,
          rotation: layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.attachedRot,
          offset: [layoutOption.dx || 0, layoutOption.dy || 0]
        });
      }
      var needsUpdateLabelLine = false;
      if (layoutOption.x != null) {
        label.x = parsePercent(layoutOption.x, width);
        label.setStyle("x", 0);
        needsUpdateLabelLine = true;
      } else {
        label.x = defaultLabelAttr.x;
        label.setStyle("x", defaultLabelAttr.style.x);
      }
      if (layoutOption.y != null) {
        label.y = parsePercent(layoutOption.y, height);
        label.setStyle("y", 0);
        needsUpdateLabelLine = true;
      } else {
        label.y = defaultLabelAttr.y;
        label.setStyle("y", defaultLabelAttr.style.y);
      }
      if (layoutOption.labelLinePoints) {
        var guideLine = hostEl.getTextGuideLine();
        if (guideLine) {
          guideLine.setShape({
            points: layoutOption.labelLinePoints
          });
          needsUpdateLabelLine = false;
        }
      }
      var labelLayoutStore = labelLayoutInnerStore(label);
      labelLayoutStore.needsUpdateLabelLine = needsUpdateLabelLine;
      label.rotation = layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.rotation;
      label.scaleX = defaultLabelAttr.scaleX;
      label.scaleY = defaultLabelAttr.scaleY;
      for (var k2 = 0; k2 < LABEL_OPTION_TO_STYLE_KEYS.length; k2++) {
        var key = LABEL_OPTION_TO_STYLE_KEYS[k2];
        label.setStyle(key, layoutOption[key] != null ? layoutOption[key] : defaultLabelAttr.style[key]);
      }
      if (layoutOption.draggable) {
        label.draggable = true;
        label.cursor = "move";
        if (hostEl) {
          var hostModel = labelItem.seriesModel;
          if (labelItem.dataIndex != null) {
            var data = labelItem.seriesModel.getData(labelItem.dataType);
            hostModel = data.getItemModel(labelItem.dataIndex);
          }
          label.on("drag", createDragHandler(hostEl, hostModel.getModel("labelLine")));
        }
      } else {
        label.off("drag");
        label.cursor = defaultLabelAttr.cursor;
      }
    }
  };
  LabelManager2.prototype.layout = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    var labelList = prepareLayoutList(this._labelList);
    var labelsNeedsAdjustOnX = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftX";
    });
    var labelsNeedsAdjustOnY = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftY";
    });
    shiftLayoutOnX(labelsNeedsAdjustOnX, 0, width);
    shiftLayoutOnY(labelsNeedsAdjustOnY, 0, height);
    var labelsNeedsHideOverlap = filter(labelList, function(item) {
      return item.layoutOption.hideOverlap;
    });
    hideOverlap(labelsNeedsHideOverlap);
  };
  LabelManager2.prototype.processLabelsOverall = function() {
    var _this = this;
    each$f(this._chartViewList, function(chartView) {
      var seriesModel = chartView.__model;
      var ignoreLabelLineUpdate = chartView.ignoreLabelLineUpdate;
      var animationEnabled = seriesModel.isAnimationEnabled();
      chartView.group.traverse(function(child) {
        if (child.ignore && !child.forceLabelAnimation) {
          return true;
        }
        var needsUpdateLabelLine = !ignoreLabelLineUpdate;
        var label = child.getTextContent();
        if (!needsUpdateLabelLine && label) {
          needsUpdateLabelLine = labelLayoutInnerStore(label).needsUpdateLabelLine;
        }
        if (needsUpdateLabelLine) {
          _this._updateLabelLine(child, seriesModel);
        }
        if (animationEnabled) {
          _this._animateLabels(child, seriesModel);
        }
      });
    });
  };
  LabelManager2.prototype._updateLabelLine = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var ecData = getECData(el);
    var dataIndex = ecData.dataIndex;
    if (textEl && dataIndex != null) {
      var data = seriesModel.getData(ecData.dataType);
      var itemModel = data.getItemModel(dataIndex);
      var defaultStyle = {};
      var visualStyle = data.getItemVisual(dataIndex, "style");
      var visualType = data.getVisual("drawType");
      defaultStyle.stroke = visualStyle[visualType];
      var labelLineModel = itemModel.getModel("labelLine");
      setLabelLineStyle(el, getLabelLineStatesModels(itemModel), defaultStyle);
      updateLabelLinePoints(el, labelLineModel);
    }
  };
  LabelManager2.prototype._animateLabels = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var guideLine = el.getTextGuideLine();
    if (textEl && (el.forceLabelAnimation || !textEl.ignore && !textEl.invisible && !el.disableLabelAnimation && !isElementRemoved(el))) {
      var layoutStore = labelLayoutInnerStore(textEl);
      var oldLayout = layoutStore.oldLayout;
      var ecData = getECData(el);
      var dataIndex = ecData.dataIndex;
      var newProps = {
        x: textEl.x,
        y: textEl.y,
        rotation: textEl.rotation
      };
      var data = seriesModel.getData(ecData.dataType);
      if (!oldLayout) {
        textEl.attr(newProps);
        if (!labelInner(textEl).valueAnimation) {
          var oldOpacity = retrieve2(textEl.style.opacity, 1);
          textEl.style.opacity = 0;
          initProps(textEl, {
            style: {
              opacity: oldOpacity
            }
          }, seriesModel, dataIndex);
        }
      } else {
        textEl.attr(oldLayout);
        var prevStates = el.prevStates;
        if (prevStates) {
          if (indexOf(prevStates, "select") >= 0) {
            textEl.attr(layoutStore.oldLayoutSelect);
          }
          if (indexOf(prevStates, "emphasis") >= 0) {
            textEl.attr(layoutStore.oldLayoutEmphasis);
          }
        }
        updateProps$1(textEl, newProps, seriesModel, dataIndex);
      }
      layoutStore.oldLayout = newProps;
      if (textEl.states.select) {
        var layoutSelect = layoutStore.oldLayoutSelect = {};
        extendWithKeys(layoutSelect, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutSelect, textEl.states.select, LABEL_LAYOUT_PROPS);
      }
      if (textEl.states.emphasis) {
        var layoutEmphasis = layoutStore.oldLayoutEmphasis = {};
        extendWithKeys(layoutEmphasis, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutEmphasis, textEl.states.emphasis, LABEL_LAYOUT_PROPS);
      }
      animateLabelValue(textEl, dataIndex, data, seriesModel, seriesModel);
    }
    if (guideLine && !guideLine.ignore && !guideLine.invisible) {
      var layoutStore = labelLineAnimationStore(guideLine);
      var oldLayout = layoutStore.oldLayout;
      var newLayout = {
        points: guideLine.shape.points
      };
      if (!oldLayout) {
        guideLine.setShape(newLayout);
        guideLine.style.strokePercent = 0;
        initProps(guideLine, {
          style: {
            strokePercent: 1
          }
        }, seriesModel);
      } else {
        guideLine.attr({
          shape: oldLayout
        });
        updateProps$1(guideLine, {
          shape: newLayout
        }, seriesModel);
      }
      layoutStore.oldLayout = newLayout;
    }
  };
  return LabelManager2;
}();
var LabelManager$1 = LabelManager;
var getLabelManager = makeInner();
function installLabelLayout(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    if (!labelManager) {
      labelManager = getLabelManager(api).labelManager = new LabelManager$1();
    }
    labelManager.clearLabels();
  });
  registers.registerUpdateLifecycle("series:layoutlabels", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    params.updatedSeries.forEach(function(series) {
      labelManager.addLabelsOfSeries(api.getViewOfSeriesModel(series));
    });
    labelManager.updateLayoutConfig(api);
    labelManager.layout(api);
    labelManager.processLabelsOverall();
  });
}
var mathSin = Math.sin;
var mathCos = Math.cos;
var PI$4 = Math.PI;
var PI2$2 = Math.PI * 2;
var degree = 180 / PI$4;
var SVGPathRebuilder = function() {
  function SVGPathRebuilder2() {
  }
  SVGPathRebuilder2.prototype.reset = function(precision) {
    this._start = true;
    this._d = [];
    this._str = "";
    this._p = Math.pow(10, precision || 4);
  };
  SVGPathRebuilder2.prototype.moveTo = function(x2, y2) {
    this._add("M", x2, y2);
  };
  SVGPathRebuilder2.prototype.lineTo = function(x2, y2) {
    this._add("L", x2, y2);
  };
  SVGPathRebuilder2.prototype.bezierCurveTo = function(x2, y2, x22, y22, x3, y3) {
    this._add("C", x2, y2, x22, y22, x3, y3);
  };
  SVGPathRebuilder2.prototype.quadraticCurveTo = function(x2, y2, x22, y22) {
    this._add("Q", x2, y2, x22, y22);
  };
  SVGPathRebuilder2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this.ellipse(cx, cy, r2, r2, 0, startAngle, endAngle, anticlockwise);
  };
  SVGPathRebuilder2.prototype.ellipse = function(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise) {
    var dTheta = endAngle - startAngle;
    var clockwise = !anticlockwise;
    var dThetaPositive = Math.abs(dTheta);
    var isCircle = isAroundZero(dThetaPositive - PI2$2) || (clockwise ? dTheta >= PI2$2 : -dTheta >= PI2$2);
    var unifiedTheta = dTheta > 0 ? dTheta % PI2$2 : dTheta % PI2$2 + PI2$2;
    var large = false;
    if (isCircle) {
      large = true;
    } else if (isAroundZero(dThetaPositive)) {
      large = false;
    } else {
      large = unifiedTheta >= PI$4 === !!clockwise;
    }
    var x0 = cx + rx * mathCos(startAngle);
    var y0 = cy + ry * mathSin(startAngle);
    if (this._start) {
      this._add("M", x0, y0);
    }
    var xRot = Math.round(psi * degree);
    if (isCircle) {
      var p2 = 1 / this._p;
      var dTheta_1 = (clockwise ? 1 : -1) * (PI2$2 - p2);
      this._add("A", rx, ry, xRot, 1, +clockwise, cx + rx * mathCos(startAngle + dTheta_1), cy + ry * mathSin(startAngle + dTheta_1));
      if (p2 > 0.01) {
        this._add("A", rx, ry, xRot, 0, +clockwise, x0, y0);
      }
    } else {
      var x2 = cx + rx * mathCos(endAngle);
      var y2 = cy + ry * mathSin(endAngle);
      this._add("A", rx, ry, xRot, +large, +clockwise, x2, y2);
    }
  };
  SVGPathRebuilder2.prototype.rect = function(x2, y2, w2, h) {
    this._add("M", x2, y2);
    this._add("l", w2, 0);
    this._add("l", 0, h);
    this._add("l", -w2, 0);
    this._add("Z");
  };
  SVGPathRebuilder2.prototype.closePath = function() {
    if (this._d.length > 0) {
      this._add("Z");
    }
  };
  SVGPathRebuilder2.prototype._add = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    var vals = [];
    var p2 = this._p;
    for (var i = 1; i < arguments.length; i++) {
      var val = arguments[i];
      if (isNaN(val)) {
        this._invalid = true;
        return;
      }
      vals.push(Math.round(val * p2) / p2);
    }
    this._d.push(cmd + vals.join(" "));
    this._start = cmd === "Z";
  };
  SVGPathRebuilder2.prototype.generateStr = function() {
    this._str = this._invalid ? "" : this._d.join("");
    this._d = [];
  };
  SVGPathRebuilder2.prototype.getStr = function() {
    return this._str;
  };
  return SVGPathRebuilder2;
}();
var SVGPathRebuilder$1 = SVGPathRebuilder;
var NONE = "none";
var mathRound = Math.round;
function pathHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== NONE;
}
function pathHasStroke(style) {
  var stroke = style.stroke;
  return stroke != null && stroke !== NONE;
}
var strokeProps = ["lineCap", "miterLimit", "lineJoin"];
var svgStrokeProps = map$1(strokeProps, function(prop) {
  return "stroke-" + prop.toLowerCase();
});
function mapStyleToAttrs(updateAttr2, style, el, forceUpdate) {
  var opacity = style.opacity == null ? 1 : style.opacity;
  if (el instanceof ZRImage$1) {
    updateAttr2("opacity", opacity);
    return;
  }
  if (pathHasFill(style)) {
    var fill = normalizeColor(style.fill);
    updateAttr2("fill", fill.color);
    var fillOpacity = style.fillOpacity != null ? style.fillOpacity * fill.opacity * opacity : fill.opacity * opacity;
    if (forceUpdate || fillOpacity < 1) {
      updateAttr2("fill-opacity", fillOpacity);
    }
  } else {
    updateAttr2("fill", NONE);
  }
  if (pathHasStroke(style)) {
    var stroke = normalizeColor(style.stroke);
    updateAttr2("stroke", stroke.color);
    var strokeScale = style.strokeNoScale ? el.getLineScale() : 1;
    var strokeWidth = strokeScale ? (style.lineWidth || 0) / strokeScale : 0;
    var strokeOpacity = style.strokeOpacity != null ? style.strokeOpacity * stroke.opacity * opacity : stroke.opacity * opacity;
    var strokeFirst = style.strokeFirst;
    if (forceUpdate || strokeWidth !== 1) {
      updateAttr2("stroke-width", strokeWidth);
    }
    if (forceUpdate || strokeFirst) {
      updateAttr2("paint-order", strokeFirst ? "stroke" : "fill");
    }
    if (forceUpdate || strokeOpacity < 1) {
      updateAttr2("stroke-opacity", strokeOpacity);
    }
    if (style.lineDash) {
      var _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
      if (lineDash) {
        lineDashOffset = mathRound(lineDashOffset || 0);
        updateAttr2("stroke-dasharray", lineDash.join(","));
        if (lineDashOffset || forceUpdate) {
          updateAttr2("stroke-dashoffset", lineDashOffset);
        }
      }
    } else if (forceUpdate) {
      updateAttr2("stroke-dasharray", NONE);
    }
    for (var i = 0; i < strokeProps.length; i++) {
      var propName = strokeProps[i];
      if (forceUpdate || style[propName] !== DEFAULT_PATH_STYLE[propName]) {
        var val = style[propName] || DEFAULT_PATH_STYLE[propName];
        val && updateAttr2(svgStrokeProps[i], val);
      }
    }
  } else if (forceUpdate) {
    updateAttr2("stroke", NONE);
  }
}
var SVGNS = "http://www.w3.org/2000/svg";
var XLINKNS = "http://www.w3.org/1999/xlink";
var XMLNS = "http://www.w3.org/2000/xmlns/";
var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
function createElement(name) {
  return document.createElementNS(SVGNS, name);
}
function createVNode(tag, key, attrs, children, text) {
  return {
    tag,
    attrs: attrs || {},
    children,
    text,
    key
  };
}
function createElementOpen(name, attrs) {
  var attrsStr = [];
  if (attrs) {
    for (var key in attrs) {
      var val = attrs[key];
      var part = key;
      if (val === false) {
        continue;
      } else if (val !== true && val != null) {
        part += '="' + val + '"';
      }
      attrsStr.push(part);
    }
  }
  return "<" + name + " " + attrsStr.join(" ") + ">";
}
function createElementClose(name) {
  return "</" + name + ">";
}
function vNodeToString(el, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  function convertElToString(el2) {
    var children = el2.children, tag = el2.tag, attrs = el2.attrs;
    return createElementOpen(tag, attrs) + (el2.text || "") + (children ? "" + S + map$1(children, function(child) {
      return convertElToString(child);
    }).join(S) + S : "") + createElementClose(tag);
  }
  return convertElToString(el);
}
function getCssString(selectorNodes, animationNodes, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  var bracketBegin = " {" + S;
  var bracketEnd = S + "}";
  var selectors = map$1(keys(selectorNodes), function(className) {
    return className + bracketBegin + map$1(keys(selectorNodes[className]), function(attrName) {
      return attrName + ":" + selectorNodes[className][attrName] + ";";
    }).join(S) + bracketEnd;
  }).join(S);
  var animations = map$1(keys(animationNodes), function(animationName) {
    return "@keyframes " + animationName + bracketBegin + map$1(keys(animationNodes[animationName]), function(percent) {
      return percent + bracketBegin + map$1(keys(animationNodes[animationName][percent]), function(attrName) {
        var val = animationNodes[animationName][percent][attrName];
        if (attrName === "d") {
          val = 'path("' + val + '")';
        }
        return attrName + ":" + val + ";";
      }).join(S) + bracketEnd;
    }).join(S) + bracketEnd;
  }).join(S);
  if (!selectors && !animations) {
    return "";
  }
  return ["<![CDATA[", selectors, animations, "]]>"].join(S);
}
function createBrushScope(zrId) {
  return {
    zrId,
    shadowCache: {},
    patternCache: {},
    gradientCache: {},
    clipPathCache: {},
    defs: {},
    cssNodes: {},
    cssAnims: {},
    cssClassIdx: 0,
    cssAnimIdx: 0,
    shadowIdx: 0,
    gradientIdx: 0,
    patternIdx: 0,
    clipPathIdx: 0
  };
}
function createSVGVNode(width, height, children, useViewBox) {
  return createVNode("svg", "root", {
    "width": width,
    "height": height,
    "xmlns": SVGNS,
    "xmlns:xlink": XLINKNS,
    "version": "1.1",
    "baseProfile": "full",
    "viewBox": useViewBox ? "0 0 " + width + " " + height : false
  }, children);
}
var EASING_MAP = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
};
var transformOriginKey = "transform-origin";
function buildPathString(el, kfShape, path) {
  var shape = extend({}, el.shape);
  extend(shape, kfShape);
  el.buildPath(path, shape);
  var svgPathBuilder = new SVGPathRebuilder$1();
  svgPathBuilder.reset(getPathPrecision(el));
  path.rebuildPath(svgPathBuilder, 1);
  svgPathBuilder.generateStr();
  return svgPathBuilder.getStr();
}
function setTransformOrigin(target, transform2) {
  var originX = transform2.originX, originY = transform2.originY;
  if (originX || originY) {
    target[transformOriginKey] = originX + "px " + originY + "px";
  }
}
var ANIMATE_STYLE_MAP = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function addAnimation(cssAnim, scope) {
  var animationName = scope.zrId + "-ani-" + scope.cssAnimIdx++;
  scope.cssAnims[animationName] = cssAnim;
  return animationName;
}
function createCompoundPathCSSAnimation(el, attrs, scope) {
  var paths = el.shape.paths;
  var composedAnim = {};
  var cssAnimationCfg;
  var cssAnimationName;
  each$f(paths, function(path) {
    var subScope = createBrushScope(scope.zrId);
    subScope.animation = true;
    createCSSAnimation(path, {}, subScope, true);
    var cssAnims = subScope.cssAnims;
    var cssNodes = subScope.cssNodes;
    var animNames = keys(cssAnims);
    var len2 = animNames.length;
    if (!len2) {
      return;
    }
    cssAnimationName = animNames[len2 - 1];
    var lastAnim = cssAnims[cssAnimationName];
    for (var percent in lastAnim) {
      var kf = lastAnim[percent];
      composedAnim[percent] = composedAnim[percent] || { d: "" };
      composedAnim[percent].d += kf.d || "";
    }
    for (var className in cssNodes) {
      var val = cssNodes[className].animation;
      if (val.indexOf(cssAnimationName) >= 0) {
        cssAnimationCfg = val;
      }
    }
  });
  if (!cssAnimationCfg) {
    return;
  }
  attrs.d = false;
  var animationName = addAnimation(composedAnim, scope);
  return cssAnimationCfg.replace(cssAnimationName, animationName);
}
function getEasingFunc(easing) {
  return isString(easing) ? EASING_MAP[easing] ? "cubic-bezier(" + EASING_MAP[easing] + ")" : createCubicEasingFunc(easing) ? easing : "" : "";
}
function createCSSAnimation(el, attrs, scope, onlyShape) {
  var animators = el.animators;
  var len2 = animators.length;
  var cssAnimations = [];
  if (el instanceof CompoundPath$1) {
    var animationCfg = createCompoundPathCSSAnimation(el, attrs, scope);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    } else if (!len2) {
      return;
    }
  } else if (!len2) {
    return;
  }
  var groupAnimators = {};
  for (var i = 0; i < len2; i++) {
    var animator = animators[i];
    var cfgArr = [animator.getMaxTime() / 1e3 + "s"];
    var easing = getEasingFunc(animator.getClip().easing);
    var delay = animator.getDelay();
    if (easing) {
      cfgArr.push(easing);
    } else {
      cfgArr.push("linear");
    }
    if (delay) {
      cfgArr.push(delay / 1e3 + "s");
    }
    if (animator.getLoop()) {
      cfgArr.push("infinite");
    }
    var cfg = cfgArr.join(" ");
    groupAnimators[cfg] = groupAnimators[cfg] || [cfg, []];
    groupAnimators[cfg][1].push(animator);
  }
  function createSingleCSSAnimation(groupAnimator) {
    var animators2 = groupAnimator[1];
    var len3 = animators2.length;
    var transformKfs = {};
    var shapeKfs = {};
    var finalKfs = {};
    var animationTimingFunctionAttrName = "animation-timing-function";
    function saveAnimatorTrackToCssKfs(animator3, cssKfs, toCssAttrName) {
      var tracks = animator3.getTracks();
      var maxTime = animator3.getMaxTime();
      for (var k2 = 0; k2 < tracks.length; k2++) {
        var track = tracks[k2];
        if (track.needsAnimate()) {
          var kfs = track.keyframes;
          var attrName = track.propName;
          toCssAttrName && (attrName = toCssAttrName(attrName));
          if (attrName) {
            for (var i3 = 0; i3 < kfs.length; i3++) {
              var kf = kfs[i3];
              var percent2 = Math.round(kf.time / maxTime * 100) + "%";
              var kfEasing = getEasingFunc(kf.easing);
              var rawValue = kf.rawValue;
              if (isString(rawValue) || isNumber(rawValue)) {
                cssKfs[percent2] = cssKfs[percent2] || {};
                cssKfs[percent2][attrName] = kf.rawValue;
                if (kfEasing) {
                  cssKfs[percent2][animationTimingFunctionAttrName] = kfEasing;
                }
              }
            }
          }
        }
      }
    }
    for (var i2 = 0; i2 < len3; i2++) {
      var animator2 = animators2[i2];
      var targetProp = animator2.targetName;
      if (!targetProp) {
        !onlyShape && saveAnimatorTrackToCssKfs(animator2, transformKfs);
      } else if (targetProp === "shape") {
        saveAnimatorTrackToCssKfs(animator2, shapeKfs);
      }
    }
    for (var percent in transformKfs) {
      var transform2 = {};
      copyTransform(transform2, el);
      extend(transform2, transformKfs[percent]);
      var str = getSRTTransformString(transform2);
      var timingFunction = transformKfs[percent][animationTimingFunctionAttrName];
      finalKfs[percent] = str ? {
        transform: str
      } : {};
      setTransformOrigin(finalKfs[percent], transform2);
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    var path;
    var canAnimateShape = true;
    for (var percent in shapeKfs) {
      finalKfs[percent] = finalKfs[percent] || {};
      var isFirst = !path;
      var timingFunction = shapeKfs[percent][animationTimingFunctionAttrName];
      if (isFirst) {
        path = new PathProxy$1();
      }
      var len_1 = path.len();
      path.reset();
      finalKfs[percent].d = buildPathString(el, shapeKfs[percent], path);
      var newLen = path.len();
      if (!isFirst && len_1 !== newLen) {
        canAnimateShape = false;
        break;
      }
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    if (!canAnimateShape) {
      for (var percent in finalKfs) {
        delete finalKfs[percent].d;
      }
    }
    if (!onlyShape) {
      for (var i2 = 0; i2 < len3; i2++) {
        var animator2 = animators2[i2];
        var targetProp = animator2.targetName;
        if (targetProp === "style") {
          saveAnimatorTrackToCssKfs(animator2, finalKfs, function(propName) {
            return ANIMATE_STYLE_MAP[propName];
          });
        }
      }
    }
    var percents = keys(finalKfs);
    var allTransformOriginSame = true;
    var transformOrigin;
    for (var i2 = 1; i2 < percents.length; i2++) {
      var p0 = percents[i2 - 1];
      var p1 = percents[i2];
      if (finalKfs[p0][transformOriginKey] !== finalKfs[p1][transformOriginKey]) {
        allTransformOriginSame = false;
        break;
      }
      transformOrigin = finalKfs[p0][transformOriginKey];
    }
    if (allTransformOriginSame && transformOrigin) {
      for (var percent in finalKfs) {
        if (finalKfs[percent][transformOriginKey]) {
          delete finalKfs[percent][transformOriginKey];
        }
      }
      attrs[transformOriginKey] = transformOrigin;
    }
    if (filter(percents, function(percent2) {
      return keys(finalKfs[percent2]).length > 0;
    }).length) {
      var animationName = addAnimation(finalKfs, scope);
      return animationName + " " + groupAnimator[0] + " both";
    }
  }
  for (var key in groupAnimators) {
    var animationCfg = createSingleCSSAnimation(groupAnimators[key]);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    }
  }
  if (cssAnimations.length) {
    var className = scope.zrId + "-cls-" + scope.cssClassIdx++;
    scope.cssNodes["." + className] = {
      animation: cssAnimations.join(",")
    };
    attrs["class"] = className;
  }
}
var round$1 = Math.round;
function isImageLike(val) {
  return val && isString(val.src);
}
function isCanvasLike(val) {
  return val && isFunction(val.toDataURL);
}
function setStyleAttrs(attrs, style, el, scope) {
  mapStyleToAttrs(function(key, val) {
    var isFillStroke = key === "fill" || key === "stroke";
    if (isFillStroke && isGradient(val)) {
      setGradient(style, attrs, key, scope);
    } else if (isFillStroke && isPattern(val)) {
      setPattern(el, attrs, key, scope);
    } else {
      attrs[key] = val;
    }
  }, style, el, false);
  setShadow(el, attrs, scope);
}
function noRotateScale(m2) {
  return isAroundZero(m2[0] - 1) && isAroundZero(m2[1]) && isAroundZero(m2[2]) && isAroundZero(m2[3] - 1);
}
function noTranslate(m2) {
  return isAroundZero(m2[4]) && isAroundZero(m2[5]);
}
function setTransform(attrs, m2, compress) {
  if (m2 && !(noTranslate(m2) && noRotateScale(m2))) {
    var mul2 = compress ? 10 : 1e4;
    attrs.transform = noRotateScale(m2) ? "translate(" + round$1(m2[4] * mul2) / mul2 + " " + round$1(m2[5] * mul2) / mul2 + ")" : getMatrixStr(m2);
  }
}
function convertPolyShape(shape, attrs, mul2) {
  var points2 = shape.points;
  var strArr = [];
  for (var i = 0; i < points2.length; i++) {
    strArr.push(round$1(points2[i][0] * mul2) / mul2);
    strArr.push(round$1(points2[i][1] * mul2) / mul2);
  }
  attrs.points = strArr.join(" ");
}
function validatePolyShape(shape) {
  return !shape.smooth;
}
function createAttrsConvert(desc) {
  var normalizedDesc = map$1(desc, function(item) {
    return typeof item === "string" ? [item, item] : item;
  });
  return function(shape, attrs, mul2) {
    for (var i = 0; i < normalizedDesc.length; i++) {
      var item = normalizedDesc[i];
      var val = shape[item[0]];
      if (val != null) {
        attrs[item[1]] = round$1(val * mul2) / mul2;
      }
    }
  };
}
var buitinShapesDef = {
  circle: [createAttrsConvert(["cx", "cy", "r"])],
  polyline: [convertPolyShape, validatePolyShape],
  polygon: [convertPolyShape, validatePolyShape]
};
function hasShapeAnimation(el) {
  var animators = el.animators;
  for (var i = 0; i < animators.length; i++) {
    if (animators[i].targetName === "shape") {
      return true;
    }
  }
  return false;
}
function brushSVGPath(el, scope) {
  var style = el.style;
  var shape = el.shape;
  var builtinShpDef = buitinShapesDef[el.type];
  var attrs = {};
  var needsAnimate = scope.animation;
  var svgElType = "path";
  var strokePercent = el.style.strokePercent;
  var precision = scope.compress && getPathPrecision(el) || 4;
  if (builtinShpDef && !scope.willUpdate && !(builtinShpDef[1] && !builtinShpDef[1](shape)) && !(needsAnimate && hasShapeAnimation(el)) && !(strokePercent < 1)) {
    svgElType = el.type;
    var mul2 = Math.pow(10, precision);
    builtinShpDef[0](shape, attrs, mul2);
  } else {
    if (!el.path) {
      el.createPathProxy();
    }
    var path = el.path;
    if (el.shapeChanged()) {
      path.beginPath();
      el.buildPath(path, el.shape);
      el.pathUpdated();
    }
    var pathVersion = path.getVersion();
    var elExt = el;
    var svgPathBuilder = elExt.__svgPathBuilder;
    if (elExt.__svgPathVersion !== pathVersion || !svgPathBuilder || strokePercent !== elExt.__svgPathStrokePercent) {
      if (!svgPathBuilder) {
        svgPathBuilder = elExt.__svgPathBuilder = new SVGPathRebuilder$1();
      }
      svgPathBuilder.reset(precision);
      path.rebuildPath(svgPathBuilder, strokePercent);
      svgPathBuilder.generateStr();
      elExt.__svgPathVersion = pathVersion;
      elExt.__svgPathStrokePercent = strokePercent;
    }
    attrs.d = svgPathBuilder.getStr();
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode(svgElType, el.id + "", attrs);
}
function brushSVGImage(el, scope) {
  var style = el.style;
  var image = style.image;
  if (image && !isString(image)) {
    if (isImageLike(image)) {
      image = image.src;
    } else if (isCanvasLike(image)) {
      image = image.toDataURL();
    }
  }
  if (!image) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var dw = style.width;
  var dh = style.height;
  var attrs = {
    href: image,
    width: dw,
    height: dh
  };
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("image", el.id + "", attrs);
}
function brushSVGTSpan(el, scope) {
  var style = el.style;
  var text = style.text;
  text != null && (text += "");
  if (!text || isNaN(style.x) || isNaN(style.y)) {
    return;
  }
  var font = style.font || DEFAULT_FONT;
  var x2 = style.x || 0;
  var y2 = adjustTextY$1(style.y || 0, getLineHeight(font), style.textBaseline);
  var textAlign = TEXT_ALIGN_TO_ANCHOR[style.textAlign] || style.textAlign;
  var attrs = {
    "dominant-baseline": "central",
    "text-anchor": textAlign
  };
  if (hasSeparateFont(style)) {
    var separatedFontStr = "";
    var fontStyle = style.fontStyle;
    var fontSize = parseFontSize(style.fontSize);
    if (!parseFloat(fontSize)) {
      return;
    }
    var fontFamily = style.fontFamily || DEFAULT_FONT_FAMILY;
    var fontWeight = style.fontWeight;
    separatedFontStr += "font-size:" + fontSize + ";font-family:" + fontFamily + ";";
    if (fontStyle && fontStyle !== "normal") {
      separatedFontStr += "font-style:" + fontStyle + ";";
    }
    if (fontWeight && fontWeight !== "normal") {
      separatedFontStr += "font-weight:" + fontWeight + ";";
    }
    attrs.style = separatedFontStr;
  } else {
    attrs.style = "font: " + font;
  }
  if (text.match(/\s/)) {
    attrs["xml:space"] = "preserve";
  }
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("text", el.id + "", attrs, void 0, text);
}
function brush(el, scope) {
  if (el instanceof Path$1) {
    return brushSVGPath(el, scope);
  } else if (el instanceof ZRImage$1) {
    return brushSVGImage(el, scope);
  } else if (el instanceof TSpan$1) {
    return brushSVGTSpan(el, scope);
  }
}
function setShadow(el, attrs, scope) {
  var style = el.style;
  if (hasShadow(style)) {
    var shadowKey = getShadowKey(el);
    var shadowCache = scope.shadowCache;
    var shadowId = shadowCache[shadowKey];
    if (!shadowId) {
      var globalScale = el.getGlobalScale();
      var scaleX = globalScale[0];
      var scaleY = globalScale[1];
      if (!scaleX || !scaleY) {
        return;
      }
      var offsetX = style.shadowOffsetX || 0;
      var offsetY = style.shadowOffsetY || 0;
      var blur_1 = style.shadowBlur;
      var _a2 = normalizeColor(style.shadowColor), opacity = _a2.opacity, color = _a2.color;
      var stdDx = blur_1 / 2 / scaleX;
      var stdDy = blur_1 / 2 / scaleY;
      var stdDeviation = stdDx + " " + stdDy;
      shadowId = scope.zrId + "-s" + scope.shadowIdx++;
      scope.defs[shadowId] = createVNode("filter", shadowId, {
        "id": shadowId,
        "x": "-100%",
        "y": "-100%",
        "width": "300%",
        "height": "300%"
      }, [
        createVNode("feDropShadow", "", {
          "dx": offsetX / scaleX,
          "dy": offsetY / scaleY,
          "stdDeviation": stdDeviation,
          "flood-color": color,
          "flood-opacity": opacity
        })
      ]);
      shadowCache[shadowKey] = shadowId;
    }
    attrs.filter = getIdURL(shadowId);
  }
}
function setGradient(style, attrs, target, scope) {
  var val = style[target];
  var gradientTag;
  var gradientAttrs = {
    "gradientUnits": val.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if (isLinearGradient(val)) {
    gradientTag = "linearGradient";
    gradientAttrs.x1 = val.x;
    gradientAttrs.y1 = val.y;
    gradientAttrs.x2 = val.x2;
    gradientAttrs.y2 = val.y2;
  } else if (isRadialGradient(val)) {
    gradientTag = "radialGradient";
    gradientAttrs.cx = retrieve2(val.x, 0.5);
    gradientAttrs.cy = retrieve2(val.y, 0.5);
    gradientAttrs.r = retrieve2(val.r, 0.5);
  } else {
    return;
  }
  var colors = val.colorStops;
  var colorStops = [];
  for (var i = 0, len2 = colors.length; i < len2; ++i) {
    var offset = round4(colors[i].offset) * 100 + "%";
    var stopColor = colors[i].color;
    var _a2 = normalizeColor(stopColor), color = _a2.color, opacity = _a2.opacity;
    var stopsAttrs = {
      "offset": offset
    };
    stopsAttrs["stop-color"] = color;
    if (opacity < 1) {
      stopsAttrs["stop-opacity"] = opacity;
    }
    colorStops.push(createVNode("stop", i + "", stopsAttrs));
  }
  var gradientVNode = createVNode(gradientTag, "", gradientAttrs, colorStops);
  var gradientKey = vNodeToString(gradientVNode);
  var gradientCache = scope.gradientCache;
  var gradientId = gradientCache[gradientKey];
  if (!gradientId) {
    gradientId = scope.zrId + "-g" + scope.gradientIdx++;
    gradientCache[gradientKey] = gradientId;
    gradientAttrs.id = gradientId;
    scope.defs[gradientId] = createVNode(gradientTag, gradientId, gradientAttrs, colorStops);
  }
  attrs[target] = getIdURL(gradientId);
}
function setPattern(el, attrs, target, scope) {
  var val = el.style[target];
  var patternAttrs = {
    "patternUnits": "userSpaceOnUse"
  };
  var child;
  if (isImagePattern(val)) {
    var imageWidth_1 = val.imageWidth;
    var imageHeight_1 = val.imageHeight;
    var imageSrc = void 0;
    var patternImage = val.image;
    if (isString(patternImage)) {
      imageSrc = patternImage;
    } else if (isImageLike(patternImage)) {
      imageSrc = patternImage.src;
    } else if (isCanvasLike(patternImage)) {
      imageSrc = patternImage.toDataURL();
    }
    if (typeof Image === "undefined") {
      var errMsg = "Image width/height must been given explictly in svg-ssr renderer.";
      assert(imageWidth_1, errMsg);
      assert(imageHeight_1, errMsg);
    } else if (imageWidth_1 == null || imageHeight_1 == null) {
      var setSizeToVNode_1 = function(vNode, img) {
        if (vNode) {
          var svgEl = vNode.elm;
          var width = vNode.attrs.width = imageWidth_1 || img.width;
          var height = vNode.attrs.height = imageHeight_1 || img.height;
          if (svgEl) {
            svgEl.setAttribute("width", width);
            svgEl.setAttribute("height", height);
          }
        }
      };
      var createdImage = createOrUpdateImage(imageSrc, null, el, function(img) {
        setSizeToVNode_1(patternVNode, img);
        setSizeToVNode_1(child, img);
      });
      if (createdImage && createdImage.width && createdImage.height) {
        imageWidth_1 = imageWidth_1 || createdImage.width;
        imageHeight_1 = imageHeight_1 || createdImage.height;
      }
    }
    child = createVNode("image", "img", {
      href: imageSrc,
      width: imageWidth_1,
      height: imageHeight_1
    });
    patternAttrs.width = imageWidth_1;
    patternAttrs.height = imageHeight_1;
  } else if (val.svgElement) {
    child = clone$4(val.svgElement);
    patternAttrs.width = val.svgWidth;
    patternAttrs.height = val.svgHeight;
  }
  if (!child) {
    return;
  }
  patternAttrs.patternTransform = getSRTTransformString(val);
  var patternVNode = createVNode("pattern", "", patternAttrs, [child]);
  var patternKey = vNodeToString(patternVNode);
  var patternCache = scope.patternCache;
  var patternId = patternCache[patternKey];
  if (!patternId) {
    patternId = scope.zrId + "-p" + scope.patternIdx++;
    patternCache[patternKey] = patternId;
    patternAttrs.id = patternId;
    patternVNode = scope.defs[patternId] = createVNode("pattern", patternId, patternAttrs, [child]);
  }
  attrs[target] = getIdURL(patternId);
}
function setClipPath(clipPath, attrs, scope) {
  var clipPathCache = scope.clipPathCache, defs = scope.defs;
  var clipPathId = clipPathCache[clipPath.id];
  if (!clipPathId) {
    clipPathId = scope.zrId + "-c" + scope.clipPathIdx++;
    var clipPathAttrs = {
      id: clipPathId
    };
    clipPathCache[clipPath.id] = clipPathId;
    defs[clipPathId] = createVNode("clipPath", clipPathId, clipPathAttrs, [brushSVGPath(clipPath, scope)]);
  }
  attrs["clip-path"] = getIdURL(clipPathId);
}
function createTextNode(text) {
  return document.createTextNode(text);
}
function insertBefore(parentNode2, newNode, referenceNode) {
  parentNode2.insertBefore(newNode, referenceNode);
}
function removeChild(node, child) {
  node.removeChild(child);
}
function appendChild(node, child) {
  node.appendChild(child);
}
function parentNode(node) {
  return node.parentNode;
}
function nextSibling(node) {
  return node.nextSibling;
}
function setTextContent(node, text) {
  node.textContent = text;
}
var colonChar = 58;
var xChar = 120;
var emptyNode = createVNode("", "");
function isUndef(s) {
  return s === void 0;
}
function isDef(s) {
  return s !== void 0;
}
function createKeyToOldIdx(children, beginIdx, endIdx) {
  var map2 = {};
  for (var i = beginIdx; i <= endIdx; ++i) {
    var key = children[i].key;
    if (key !== void 0) {
      map2[key] = i;
    }
  }
  return map2;
}
function sameVnode(vnode1, vnode2) {
  var isSameKey = vnode1.key === vnode2.key;
  var isSameTag = vnode1.tag === vnode2.tag;
  return isSameTag && isSameKey;
}
function createElm(vnode) {
  var i;
  var children = vnode.children;
  var tag = vnode.tag;
  if (isDef(tag)) {
    var elm = vnode.elm = createElement(tag);
    updateAttrs(emptyNode, vnode);
    if (isArray$1(children)) {
      for (i = 0; i < children.length; ++i) {
        var ch = children[i];
        if (ch != null) {
          appendChild(elm, createElm(ch));
        }
      }
    } else if (isDef(vnode.text) && !isObject$4(vnode.text)) {
      appendChild(elm, createTextNode(vnode.text));
    }
  } else {
    vnode.elm = createTextNode(vnode.text);
  }
  return vnode.elm;
}
function addVnodes(parentElm, before, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      insertBefore(parentElm, createElm(ch), before);
    }
  }
}
function removeVnodes(parentElm, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      if (isDef(ch.tag)) {
        var parent_1 = parentNode(ch.elm);
        removeChild(parent_1, ch.elm);
      } else {
        removeChild(parentElm, ch.elm);
      }
    }
  }
}
function updateAttrs(oldVnode, vnode) {
  var key;
  var elm = vnode.elm;
  var oldAttrs = oldVnode && oldVnode.attrs || {};
  var attrs = vnode.attrs || {};
  if (oldAttrs === attrs) {
    return;
  }
  for (key in attrs) {
    var cur = attrs[key];
    var old = oldAttrs[key];
    if (old !== cur) {
      if (cur === true) {
        elm.setAttribute(key, "");
      } else if (cur === false) {
        elm.removeAttribute(key);
      } else {
        if (key.charCodeAt(0) !== xChar) {
          elm.setAttribute(key, cur);
        } else if (key === "xmlns:xlink" || key === "xmlns") {
          elm.setAttributeNS(XMLNS, key, cur);
        } else if (key.charCodeAt(3) === colonChar) {
          elm.setAttributeNS(XML_NAMESPACE, key, cur);
        } else if (key.charCodeAt(5) === colonChar) {
          elm.setAttributeNS(XLINKNS, key, cur);
        } else {
          elm.setAttribute(key, cur);
        }
      }
    }
  }
  for (key in oldAttrs) {
    if (!(key in attrs)) {
      elm.removeAttribute(key);
    }
  }
}
function updateChildren(parentElm, oldCh, newCh) {
  var oldStartIdx = 0;
  var newStartIdx = 0;
  var oldEndIdx = oldCh.length - 1;
  var oldStartVnode = oldCh[0];
  var oldEndVnode = oldCh[oldEndIdx];
  var newEndIdx = newCh.length - 1;
  var newStartVnode = newCh[0];
  var newEndVnode = newCh[newEndIdx];
  var oldKeyToIdx;
  var idxInOld;
  var elmToMove;
  var before;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newStartVnode)) {
      patchVnode(oldStartVnode, newStartVnode);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (sameVnode(oldEndVnode, newEndVnode)) {
      patchVnode(oldEndVnode, newEndVnode);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newEndVnode)) {
      patchVnode(oldStartVnode, newEndVnode);
      insertBefore(parentElm, oldStartVnode.elm, nextSibling(oldEndVnode.elm));
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldEndVnode, newStartVnode)) {
      patchVnode(oldEndVnode, newStartVnode);
      insertBefore(parentElm, oldEndVnode.elm, oldStartVnode.elm);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      if (isUndef(oldKeyToIdx)) {
        oldKeyToIdx = createKeyToOldIdx(oldCh, oldStartIdx, oldEndIdx);
      }
      idxInOld = oldKeyToIdx[newStartVnode.key];
      if (isUndef(idxInOld)) {
        insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
      } else {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.tag !== newStartVnode.tag) {
          insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
        } else {
          patchVnode(elmToMove, newStartVnode);
          oldCh[idxInOld] = void 0;
          insertBefore(parentElm, elmToMove.elm, oldStartVnode.elm);
        }
      }
      newStartVnode = newCh[++newStartIdx];
    }
  }
  if (oldStartIdx <= oldEndIdx || newStartIdx <= newEndIdx) {
    if (oldStartIdx > oldEndIdx) {
      before = newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].elm;
      addVnodes(parentElm, before, newCh, newStartIdx, newEndIdx);
    } else {
      removeVnodes(parentElm, oldCh, oldStartIdx, oldEndIdx);
    }
  }
}
function patchVnode(oldVnode, vnode) {
  var elm = vnode.elm = oldVnode.elm;
  var oldCh = oldVnode.children;
  var ch = vnode.children;
  if (oldVnode === vnode) {
    return;
  }
  updateAttrs(oldVnode, vnode);
  if (isUndef(vnode.text)) {
    if (isDef(oldCh) && isDef(ch)) {
      if (oldCh !== ch) {
        updateChildren(elm, oldCh, ch);
      }
    } else if (isDef(ch)) {
      if (isDef(oldVnode.text)) {
        setTextContent(elm, "");
      }
      addVnodes(elm, null, ch, 0, ch.length - 1);
    } else if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    } else if (isDef(oldVnode.text)) {
      setTextContent(elm, "");
    }
  } else if (oldVnode.text !== vnode.text) {
    if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    }
    setTextContent(elm, vnode.text);
  }
}
function patch(oldVnode, vnode) {
  if (sameVnode(oldVnode, vnode)) {
    patchVnode(oldVnode, vnode);
  } else {
    var elm = oldVnode.elm;
    var parent_2 = parentNode(elm);
    createElm(vnode);
    if (parent_2 !== null) {
      insertBefore(parent_2, vnode.elm, nextSibling(elm));
      removeVnodes(parent_2, [oldVnode], 0, 0);
    }
  }
  return vnode;
}
var svgId = 0;
var SVGPainter = function() {
  function SVGPainter2(root2, storage2, opts) {
    this.type = "svg";
    this.refreshHover = createMethodNotSupport();
    this.configLayer = createMethodNotSupport();
    this.storage = storage2;
    this._opts = opts = extend({}, opts);
    this.root = root2;
    this._id = "zr" + svgId++;
    this._oldVNode = createSVGVNode(opts.width, opts.height);
    if (root2 && !opts.ssr) {
      var viewport = this._viewport = document.createElement("div");
      viewport.style.cssText = "position:relative;overflow:hidden";
      var svgDom = this._svgDom = this._oldVNode.elm = createElement("svg");
      updateAttrs(null, this._oldVNode);
      viewport.appendChild(svgDom);
      root2.appendChild(viewport);
    }
    this.resize(opts.width, opts.height);
  }
  SVGPainter2.prototype.getType = function() {
    return this.type;
  };
  SVGPainter2.prototype.getViewportRoot = function() {
    return this._viewport;
  };
  SVGPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  SVGPainter2.prototype.getSvgDom = function() {
    return this._svgDom;
  };
  SVGPainter2.prototype.refresh = function() {
    if (this.root) {
      var vnode = this.renderToVNode({
        willUpdate: true
      });
      vnode.attrs.style = "position:absolute;left:0;top:0;user-select:none";
      patch(this._oldVNode, vnode);
      this._oldVNode = vnode;
    }
  };
  SVGPainter2.prototype.renderOneToVNode = function(el) {
    return brush(el, createBrushScope(this._id));
  };
  SVGPainter2.prototype.renderToVNode = function(opts) {
    opts = opts || {};
    var list = this.storage.getDisplayList(true);
    var bgColor = this._backgroundColor;
    var width = this._width;
    var height = this._height;
    var scope = createBrushScope(this._id);
    scope.animation = opts.animation;
    scope.willUpdate = opts.willUpdate;
    scope.compress = opts.compress;
    var children = [];
    if (bgColor && bgColor !== "none") {
      var _a2 = normalizeColor(bgColor), color = _a2.color, opacity = _a2.opacity;
      this._bgVNode = createVNode("rect", "bg", {
        width,
        height,
        x: "0",
        y: "0",
        id: "0",
        fill: color,
        "fill-opacity": opacity
      });
      children.push(this._bgVNode);
    } else {
      this._bgVNode = null;
    }
    var mainVNode = !opts.compress ? this._mainVNode = createVNode("g", "main", {}, []) : null;
    this._paintList(list, scope, mainVNode ? mainVNode.children : children);
    mainVNode && children.push(mainVNode);
    var defs = map$1(keys(scope.defs), function(id2) {
      return scope.defs[id2];
    });
    if (defs.length) {
      children.push(createVNode("defs", "defs", {}, defs));
    }
    if (opts.animation) {
      var animationCssStr = getCssString(scope.cssNodes, scope.cssAnims, { newline: true });
      if (animationCssStr) {
        var styleNode = createVNode("style", "stl", {}, [], animationCssStr);
        children.push(styleNode);
      }
    }
    return createSVGVNode(width, height, children, opts.useViewBox);
  };
  SVGPainter2.prototype.renderToString = function(opts) {
    opts = opts || {};
    return vNodeToString(this.renderToVNode({
      animation: retrieve2(opts.cssAnimation, true),
      willUpdate: false,
      compress: true,
      useViewBox: retrieve2(opts.useViewBox, true)
    }), { newline: true });
  };
  SVGPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    var bgVNode = this._bgVNode;
    if (bgVNode && bgVNode.elm) {
      var _a2 = normalizeColor(backgroundColor2), color = _a2.color, opacity = _a2.opacity;
      bgVNode.elm.setAttribute("fill", color);
      if (opacity < 1) {
        bgVNode.elm.setAttribute("fill-opacity", opacity);
      }
    }
  };
  SVGPainter2.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  };
  SVGPainter2.prototype._paintList = function(list, scope, out2) {
    var listLen = list.length;
    var clipPathsGroupsStack = [];
    var clipPathsGroupsStackDepth = 0;
    var currentClipPathGroup;
    var prevClipPaths;
    var clipGroupNodeIdx = 0;
    for (var i = 0; i < listLen; i++) {
      var displayable = list[i];
      if (!displayable.invisible) {
        var clipPaths = displayable.__clipPaths;
        var len2 = clipPaths && clipPaths.length || 0;
        var prevLen = prevClipPaths && prevClipPaths.length || 0;
        var lca = void 0;
        for (lca = Math.max(len2 - 1, prevLen - 1); lca >= 0; lca--) {
          if (clipPaths && prevClipPaths && clipPaths[lca] === prevClipPaths[lca]) {
            break;
          }
        }
        for (var i_1 = prevLen - 1; i_1 > lca; i_1--) {
          clipPathsGroupsStackDepth--;
          currentClipPathGroup = clipPathsGroupsStack[clipPathsGroupsStackDepth - 1];
        }
        for (var i_2 = lca + 1; i_2 < len2; i_2++) {
          var groupAttrs = {};
          setClipPath(clipPaths[i_2], groupAttrs, scope);
          var g2 = createVNode("g", "clip-g-" + clipGroupNodeIdx++, groupAttrs, []);
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(g2);
          clipPathsGroupsStack[clipPathsGroupsStackDepth++] = g2;
          currentClipPathGroup = g2;
        }
        prevClipPaths = clipPaths;
        var ret = brush(displayable, scope);
        if (ret) {
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(ret);
        }
      }
    }
  };
  SVGPainter2.prototype.resize = function(width, height) {
    var opts = this._opts;
    var root2 = this.root;
    var viewport = this._viewport;
    width != null && (opts.width = width);
    height != null && (opts.height = height);
    if (root2 && viewport) {
      viewport.style.display = "none";
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      viewport.style.display = "";
    }
    if (this._width !== width || this._height !== height) {
      this._width = width;
      this._height = height;
      if (viewport) {
        var viewportStyle = viewport.style;
        viewportStyle.width = width + "px";
        viewportStyle.height = height + "px";
      }
      var svgDom = this._svgDom;
      if (svgDom) {
        svgDom.setAttribute("width", width);
        svgDom.setAttribute("height", height);
      }
    }
  };
  SVGPainter2.prototype.getWidth = function() {
    return this._width;
  };
  SVGPainter2.prototype.getHeight = function() {
    return this._height;
  };
  SVGPainter2.prototype.dispose = function() {
    if (this.root) {
      this.root.innerHTML = "";
    }
    this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  };
  SVGPainter2.prototype.clear = function() {
    if (this._svgDom) {
      this._svgDom.innerHTML = null;
    }
    this._oldVNode = null;
  };
  SVGPainter2.prototype.toDataURL = function(base64) {
    var str = encodeURIComponent(this.renderToString());
    var prefix = "data:image/svg+xml;";
    if (base64) {
      str = encodeBase64(str);
      return str && prefix + "base64," + str;
    }
    return prefix + "charset=UTF-8," + str;
  };
  return SVGPainter2;
}();
function createMethodNotSupport(method4) {
  return function() {
  };
}
var SVGPainter$1 = SVGPainter;
function install$S(registers) {
  registers.registerPainter("svg", SVGPainter$1);
}
function createDom(id2, painter, dpr2) {
  var newDom = platformApi.createCanvas();
  var width = painter.getWidth();
  var height = painter.getHeight();
  var newDomStyle = newDom.style;
  if (newDomStyle) {
    newDomStyle.position = "absolute";
    newDomStyle.left = "0";
    newDomStyle.top = "0";
    newDomStyle.width = width + "px";
    newDomStyle.height = height + "px";
    newDom.setAttribute("data-zr-dom-id", id2);
  }
  newDom.width = width * dpr2;
  newDom.height = height * dpr2;
  return newDom;
}
var Layer = function(_super) {
  __extends(Layer2, _super);
  function Layer2(id2, painter, dpr2) {
    var _this = _super.call(this) || this;
    _this.motionBlur = false;
    _this.lastFrameAlpha = 0.7;
    _this.dpr = 1;
    _this.virtual = false;
    _this.config = {};
    _this.incremental = false;
    _this.zlevel = 0;
    _this.maxRepaintRectCount = 5;
    _this.__dirty = true;
    _this.__firstTimePaint = true;
    _this.__used = false;
    _this.__drawIndex = 0;
    _this.__startIndex = 0;
    _this.__endIndex = 0;
    _this.__prevStartIndex = null;
    _this.__prevEndIndex = null;
    var dom;
    dpr2 = dpr2 || devicePixelRatio;
    if (typeof id2 === "string") {
      dom = createDom(id2, painter, dpr2);
    } else if (isObject$4(id2)) {
      dom = id2;
      id2 = dom.id;
    }
    _this.id = id2;
    _this.dom = dom;
    var domStyle = dom.style;
    if (domStyle) {
      disableUserSelect(dom);
      dom.onselectstart = function() {
        return false;
      };
      domStyle.padding = "0";
      domStyle.margin = "0";
      domStyle.borderWidth = "0";
    }
    _this.painter = painter;
    _this.dpr = dpr2;
    return _this;
  }
  Layer2.prototype.getElementCount = function() {
    return this.__endIndex - this.__startIndex;
  };
  Layer2.prototype.afterBrush = function() {
    this.__prevStartIndex = this.__startIndex;
    this.__prevEndIndex = this.__endIndex;
  };
  Layer2.prototype.initContext = function() {
    this.ctx = this.dom.getContext("2d");
    this.ctx.dpr = this.dpr;
  };
  Layer2.prototype.setUnpainted = function() {
    this.__firstTimePaint = true;
  };
  Layer2.prototype.createBackBuffer = function() {
    var dpr2 = this.dpr;
    this.domBack = createDom("back-" + this.id, this.painter, dpr2);
    this.ctxBack = this.domBack.getContext("2d");
    if (dpr2 !== 1) {
      this.ctxBack.scale(dpr2, dpr2);
    }
  };
  Layer2.prototype.createRepaintRects = function(displayList, prevList, viewWidth, viewHeight) {
    if (this.__firstTimePaint) {
      this.__firstTimePaint = false;
      return null;
    }
    var mergedRepaintRects = [];
    var maxRepaintRectCount = this.maxRepaintRectCount;
    var full = false;
    var pendingRect = new BoundingRect$1(0, 0, 0, 0);
    function addRectToMergePool(rect) {
      if (!rect.isFinite() || rect.isZero()) {
        return;
      }
      if (mergedRepaintRects.length === 0) {
        var boundingRect = new BoundingRect$1(0, 0, 0, 0);
        boundingRect.copy(rect);
        mergedRepaintRects.push(boundingRect);
      } else {
        var isMerged = false;
        var minDeltaArea = Infinity;
        var bestRectToMergeIdx = 0;
        for (var i2 = 0; i2 < mergedRepaintRects.length; ++i2) {
          var mergedRect = mergedRepaintRects[i2];
          if (mergedRect.intersect(rect)) {
            var pendingRect_1 = new BoundingRect$1(0, 0, 0, 0);
            pendingRect_1.copy(mergedRect);
            pendingRect_1.union(rect);
            mergedRepaintRects[i2] = pendingRect_1;
            isMerged = true;
            break;
          } else if (full) {
            pendingRect.copy(rect);
            pendingRect.union(mergedRect);
            var aArea = rect.width * rect.height;
            var bArea = mergedRect.width * mergedRect.height;
            var pendingArea = pendingRect.width * pendingRect.height;
            var deltaArea = pendingArea - aArea - bArea;
            if (deltaArea < minDeltaArea) {
              minDeltaArea = deltaArea;
              bestRectToMergeIdx = i2;
            }
          }
        }
        if (full) {
          mergedRepaintRects[bestRectToMergeIdx].union(rect);
          isMerged = true;
        }
        if (!isMerged) {
          var boundingRect = new BoundingRect$1(0, 0, 0, 0);
          boundingRect.copy(rect);
          mergedRepaintRects.push(boundingRect);
        }
        if (!full) {
          full = mergedRepaintRects.length >= maxRepaintRectCount;
        }
      }
    }
    for (var i = this.__startIndex; i < this.__endIndex; ++i) {
      var el = displayList[i];
      if (el) {
        var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
        var prevRect = el.__isRendered && (el.__dirty & REDRAW_BIT || !shouldPaint) ? el.getPrevPaintRect() : null;
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
        var curRect = shouldPaint && (el.__dirty & REDRAW_BIT || !el.__isRendered) ? el.getPaintRect() : null;
        if (curRect) {
          addRectToMergePool(curRect);
        }
      }
    }
    for (var i = this.__prevStartIndex; i < this.__prevEndIndex; ++i) {
      var el = prevList[i];
      var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
      if (el && (!shouldPaint || !el.__zr) && el.__isRendered) {
        var prevRect = el.getPrevPaintRect();
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
      }
    }
    var hasIntersections;
    do {
      hasIntersections = false;
      for (var i = 0; i < mergedRepaintRects.length; ) {
        if (mergedRepaintRects[i].isZero()) {
          mergedRepaintRects.splice(i, 1);
          continue;
        }
        for (var j = i + 1; j < mergedRepaintRects.length; ) {
          if (mergedRepaintRects[i].intersect(mergedRepaintRects[j])) {
            hasIntersections = true;
            mergedRepaintRects[i].union(mergedRepaintRects[j]);
            mergedRepaintRects.splice(j, 1);
          } else {
            j++;
          }
        }
        i++;
      }
    } while (hasIntersections);
    this._paintRects = mergedRepaintRects;
    return mergedRepaintRects;
  };
  Layer2.prototype.debugGetPaintRects = function() {
    return (this._paintRects || []).slice();
  };
  Layer2.prototype.resize = function(width, height) {
    var dpr2 = this.dpr;
    var dom = this.dom;
    var domStyle = dom.style;
    var domBack = this.domBack;
    if (domStyle) {
      domStyle.width = width + "px";
      domStyle.height = height + "px";
    }
    dom.width = width * dpr2;
    dom.height = height * dpr2;
    if (domBack) {
      domBack.width = width * dpr2;
      domBack.height = height * dpr2;
      if (dpr2 !== 1) {
        this.ctxBack.scale(dpr2, dpr2);
      }
    }
  };
  Layer2.prototype.clear = function(clearAll, clearColor, repaintRects) {
    var dom = this.dom;
    var ctx = this.ctx;
    var width = dom.width;
    var height = dom.height;
    clearColor = clearColor || this.clearColor;
    var haveMotionBLur = this.motionBlur && !clearAll;
    var lastFrameAlpha = this.lastFrameAlpha;
    var dpr2 = this.dpr;
    var self2 = this;
    if (haveMotionBLur) {
      if (!this.domBack) {
        this.createBackBuffer();
      }
      this.ctxBack.globalCompositeOperation = "copy";
      this.ctxBack.drawImage(dom, 0, 0, width / dpr2, height / dpr2);
    }
    var domBack = this.domBack;
    function doClear(x2, y2, width2, height2) {
      ctx.clearRect(x2, y2, width2, height2);
      if (clearColor && clearColor !== "transparent") {
        var clearColorGradientOrPattern = void 0;
        if (isGradientObject(clearColor)) {
          clearColorGradientOrPattern = clearColor.__canvasGradient || getCanvasGradient(ctx, clearColor, {
            x: 0,
            y: 0,
            width: width2,
            height: height2
          });
          clearColor.__canvasGradient = clearColorGradientOrPattern;
        } else if (isImagePatternObject(clearColor)) {
          clearColorGradientOrPattern = createCanvasPattern(ctx, clearColor, {
            dirty: function() {
              self2.setUnpainted();
              self2.__painter.refresh();
            }
          });
        }
        ctx.save();
        ctx.fillStyle = clearColorGradientOrPattern || clearColor;
        ctx.fillRect(x2, y2, width2, height2);
        ctx.restore();
      }
      if (haveMotionBLur) {
        ctx.save();
        ctx.globalAlpha = lastFrameAlpha;
        ctx.drawImage(domBack, x2, y2, width2, height2);
        ctx.restore();
      }
    }
    if (!repaintRects || haveMotionBLur) {
      doClear(0, 0, width, height);
    } else if (repaintRects.length) {
      each$f(repaintRects, function(rect) {
        doClear(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
      });
    }
  };
  return Layer2;
}(Eventful$1);
var Layer$1 = Layer;
var HOVER_LAYER_ZLEVEL = 1e5;
var CANVAS_ZLEVEL = 314159;
var EL_AFTER_INCREMENTAL_INC = 0.01;
var INCREMENTAL_INC = 1e-3;
function isLayerValid(layer) {
  if (!layer) {
    return false;
  }
  if (layer.__builtin__) {
    return true;
  }
  if (typeof layer.resize !== "function" || typeof layer.refresh !== "function") {
    return false;
  }
  return true;
}
function createRoot(width, height) {
  var domRoot = document.createElement("div");
  domRoot.style.cssText = [
    "position:relative",
    "width:" + width + "px",
    "height:" + height + "px",
    "padding:0",
    "margin:0",
    "border-width:0"
  ].join(";") + ";";
  return domRoot;
}
var CanvasPainter = function() {
  function CanvasPainter2(root2, storage2, opts, id2) {
    this.type = "canvas";
    this._zlevelList = [];
    this._prevDisplayList = [];
    this._layers = {};
    this._layerConfig = {};
    this._needsManuallyCompositing = false;
    this.type = "canvas";
    var singleCanvas = !root2.nodeName || root2.nodeName.toUpperCase() === "CANVAS";
    this._opts = opts = extend({}, opts || {});
    this.dpr = opts.devicePixelRatio || devicePixelRatio;
    this._singleCanvas = singleCanvas;
    this.root = root2;
    var rootStyle = root2.style;
    if (rootStyle) {
      disableUserSelect(root2);
      root2.innerHTML = "";
    }
    this.storage = storage2;
    var zlevelList = this._zlevelList;
    this._prevDisplayList = [];
    var layers = this._layers;
    if (!singleCanvas) {
      this._width = getSize$1(root2, 0, opts);
      this._height = getSize$1(root2, 1, opts);
      var domRoot = this._domRoot = createRoot(this._width, this._height);
      root2.appendChild(domRoot);
    } else {
      var rootCanvas = root2;
      var width = rootCanvas.width;
      var height = rootCanvas.height;
      if (opts.width != null) {
        width = opts.width;
      }
      if (opts.height != null) {
        height = opts.height;
      }
      this.dpr = opts.devicePixelRatio || 1;
      rootCanvas.width = width * this.dpr;
      rootCanvas.height = height * this.dpr;
      this._width = width;
      this._height = height;
      var mainLayer = new Layer$1(rootCanvas, this, this.dpr);
      mainLayer.__builtin__ = true;
      mainLayer.initContext();
      layers[CANVAS_ZLEVEL] = mainLayer;
      mainLayer.zlevel = CANVAS_ZLEVEL;
      zlevelList.push(CANVAS_ZLEVEL);
      this._domRoot = root2;
    }
  }
  CanvasPainter2.prototype.getType = function() {
    return "canvas";
  };
  CanvasPainter2.prototype.isSingleCanvas = function() {
    return this._singleCanvas;
  };
  CanvasPainter2.prototype.getViewportRoot = function() {
    return this._domRoot;
  };
  CanvasPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  CanvasPainter2.prototype.refresh = function(paintAll) {
    var list = this.storage.getDisplayList(true);
    var prevList = this._prevDisplayList;
    var zlevelList = this._zlevelList;
    this._redrawId = Math.random();
    this._paintList(list, prevList, paintAll, this._redrawId);
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__ && layer.refresh) {
        var clearColor = i === 0 ? this._backgroundColor : null;
        layer.refresh(clearColor);
      }
    }
    if (this._opts.useDirtyRect) {
      this._prevDisplayList = list.slice();
    }
    return this;
  };
  CanvasPainter2.prototype.refreshHover = function() {
    this._paintHoverList(this.storage.getDisplayList(false));
  };
  CanvasPainter2.prototype._paintHoverList = function(list) {
    var len2 = list.length;
    var hoverLayer = this._hoverlayer;
    hoverLayer && hoverLayer.clear();
    if (!len2) {
      return;
    }
    var scope = {
      inHover: true,
      viewWidth: this._width,
      viewHeight: this._height
    };
    var ctx;
    for (var i = 0; i < len2; i++) {
      var el = list[i];
      if (el.__inHover) {
        if (!hoverLayer) {
          hoverLayer = this._hoverlayer = this.getLayer(HOVER_LAYER_ZLEVEL);
        }
        if (!ctx) {
          ctx = hoverLayer.ctx;
          ctx.save();
        }
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    if (ctx) {
      ctx.restore();
    }
  };
  CanvasPainter2.prototype.getHoverLayer = function() {
    return this.getLayer(HOVER_LAYER_ZLEVEL);
  };
  CanvasPainter2.prototype.paintOne = function(ctx, el) {
    brushSingle(ctx, el);
  };
  CanvasPainter2.prototype._paintList = function(list, prevList, paintAll, redrawId) {
    if (this._redrawId !== redrawId) {
      return;
    }
    paintAll = paintAll || false;
    this._updateLayerStatus(list);
    var _a2 = this._doPaintList(list, prevList, paintAll), finished = _a2.finished, needsRefreshHover = _a2.needsRefreshHover;
    if (this._needsManuallyCompositing) {
      this._compositeManually();
    }
    if (needsRefreshHover) {
      this._paintHoverList(list);
    }
    if (!finished) {
      var self_1 = this;
      requestAnimationFrame$2(function() {
        self_1._paintList(list, prevList, paintAll, redrawId);
      });
    } else {
      this.eachLayer(function(layer) {
        layer.afterBrush && layer.afterBrush();
      });
    }
  };
  CanvasPainter2.prototype._compositeManually = function() {
    var ctx = this.getLayer(CANVAS_ZLEVEL).ctx;
    var width = this._domRoot.width;
    var height = this._domRoot.height;
    ctx.clearRect(0, 0, width, height);
    this.eachBuiltinLayer(function(layer) {
      if (layer.virtual) {
        ctx.drawImage(layer.dom, 0, 0, width, height);
      }
    });
  };
  CanvasPainter2.prototype._doPaintList = function(list, prevList, paintAll) {
    var _this = this;
    var layerList = [];
    var useDirtyRect = this._opts.useDirtyRect;
    for (var zi = 0; zi < this._zlevelList.length; zi++) {
      var zlevel = this._zlevelList[zi];
      var layer = this._layers[zlevel];
      if (layer.__builtin__ && layer !== this._hoverlayer && (layer.__dirty || paintAll)) {
        layerList.push(layer);
      }
    }
    var finished = true;
    var needsRefreshHover = false;
    var _loop_1 = function(k3) {
      var layer2 = layerList[k3];
      var ctx = layer2.ctx;
      var repaintRects = useDirtyRect && layer2.createRepaintRects(list, prevList, this_1._width, this_1._height);
      var start2 = paintAll ? layer2.__startIndex : layer2.__drawIndex;
      var useTimer = !paintAll && layer2.incremental && Date.now;
      var startTime = useTimer && Date.now();
      var clearColor = layer2.zlevel === this_1._zlevelList[0] ? this_1._backgroundColor : null;
      if (layer2.__startIndex === layer2.__endIndex) {
        layer2.clear(false, clearColor, repaintRects);
      } else if (start2 === layer2.__startIndex) {
        var firstEl = list[start2];
        if (!firstEl.incremental || !firstEl.notClear || paintAll) {
          layer2.clear(false, clearColor, repaintRects);
        }
      }
      if (start2 === -1) {
        console.error("For some unknown reason. drawIndex is -1");
        start2 = layer2.__startIndex;
      }
      var i;
      var repaint = function(repaintRect) {
        var scope = {
          inHover: false,
          allClipped: false,
          prevEl: null,
          viewWidth: _this._width,
          viewHeight: _this._height
        };
        for (i = start2; i < layer2.__endIndex; i++) {
          var el = list[i];
          if (el.__inHover) {
            needsRefreshHover = true;
          }
          _this._doPaintEl(el, layer2, useDirtyRect, repaintRect, scope, i === layer2.__endIndex - 1);
          if (useTimer) {
            var dTime = Date.now() - startTime;
            if (dTime > 15) {
              break;
            }
          }
        }
        if (scope.prevElClipPaths) {
          ctx.restore();
        }
      };
      if (repaintRects) {
        if (repaintRects.length === 0) {
          i = layer2.__endIndex;
        } else {
          var dpr2 = this_1.dpr;
          for (var r2 = 0; r2 < repaintRects.length; ++r2) {
            var rect = repaintRects[r2];
            ctx.save();
            ctx.beginPath();
            ctx.rect(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
            ctx.clip();
            repaint(rect);
            ctx.restore();
          }
        }
      } else {
        ctx.save();
        repaint();
        ctx.restore();
      }
      layer2.__drawIndex = i;
      if (layer2.__drawIndex < layer2.__endIndex) {
        finished = false;
      }
    };
    var this_1 = this;
    for (var k2 = 0; k2 < layerList.length; k2++) {
      _loop_1(k2);
    }
    if (env$1.wxa) {
      each$f(this._layers, function(layer2) {
        if (layer2 && layer2.ctx && layer2.ctx.draw) {
          layer2.ctx.draw();
        }
      });
    }
    return {
      finished,
      needsRefreshHover
    };
  };
  CanvasPainter2.prototype._doPaintEl = function(el, currentLayer, useDirtyRect, repaintRect, scope, isLast) {
    var ctx = currentLayer.ctx;
    if (useDirtyRect) {
      var paintRect = el.getPaintRect();
      if (!repaintRect || paintRect && paintRect.intersect(repaintRect)) {
        brush$1(ctx, el, scope, isLast);
        el.setPrevPaintRect(paintRect);
      }
    } else {
      brush$1(ctx, el, scope, isLast);
    }
  };
  CanvasPainter2.prototype.getLayer = function(zlevel, virtual) {
    if (this._singleCanvas && !this._needsManuallyCompositing) {
      zlevel = CANVAS_ZLEVEL;
    }
    var layer = this._layers[zlevel];
    if (!layer) {
      layer = new Layer$1("zr_" + zlevel, this, this.dpr);
      layer.zlevel = zlevel;
      layer.__builtin__ = true;
      if (this._layerConfig[zlevel]) {
        merge(layer, this._layerConfig[zlevel], true);
      } else if (this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC]) {
        merge(layer, this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC], true);
      }
      if (virtual) {
        layer.virtual = virtual;
      }
      this.insertLayer(zlevel, layer);
      layer.initContext();
    }
    return layer;
  };
  CanvasPainter2.prototype.insertLayer = function(zlevel, layer) {
    var layersMap = this._layers;
    var zlevelList = this._zlevelList;
    var len2 = zlevelList.length;
    var domRoot = this._domRoot;
    var prevLayer = null;
    var i = -1;
    if (layersMap[zlevel]) {
      return;
    }
    if (!isLayerValid(layer)) {
      return;
    }
    if (len2 > 0 && zlevel > zlevelList[0]) {
      for (i = 0; i < len2 - 1; i++) {
        if (zlevelList[i] < zlevel && zlevelList[i + 1] > zlevel) {
          break;
        }
      }
      prevLayer = layersMap[zlevelList[i]];
    }
    zlevelList.splice(i + 1, 0, zlevel);
    layersMap[zlevel] = layer;
    if (!layer.virtual) {
      if (prevLayer) {
        var prevDom = prevLayer.dom;
        if (prevDom.nextSibling) {
          domRoot.insertBefore(layer.dom, prevDom.nextSibling);
        } else {
          domRoot.appendChild(layer.dom);
        }
      } else {
        if (domRoot.firstChild) {
          domRoot.insertBefore(layer.dom, domRoot.firstChild);
        } else {
          domRoot.appendChild(layer.dom);
        }
      }
    }
    layer.__painter = this;
  };
  CanvasPainter2.prototype.eachLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      cb.call(context, this._layers[z2], z2);
    }
  };
  CanvasPainter2.prototype.eachBuiltinLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.eachOtherLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.getLayers = function() {
    return this._layers;
  };
  CanvasPainter2.prototype._updateLayerStatus = function(list) {
    this.eachBuiltinLayer(function(layer2, z2) {
      layer2.__dirty = layer2.__used = false;
    });
    function updatePrevLayer(idx) {
      if (prevLayer) {
        if (prevLayer.__endIndex !== idx) {
          prevLayer.__dirty = true;
        }
        prevLayer.__endIndex = idx;
      }
    }
    if (this._singleCanvas) {
      for (var i_1 = 1; i_1 < list.length; i_1++) {
        var el = list[i_1];
        if (el.zlevel !== list[i_1 - 1].zlevel || el.incremental) {
          this._needsManuallyCompositing = true;
          break;
        }
      }
    }
    var prevLayer = null;
    var incrementalLayerCount = 0;
    var prevZlevel;
    var i;
    for (i = 0; i < list.length; i++) {
      var el = list[i];
      var zlevel = el.zlevel;
      var layer = void 0;
      if (prevZlevel !== zlevel) {
        prevZlevel = zlevel;
        incrementalLayerCount = 0;
      }
      if (el.incremental) {
        layer = this.getLayer(zlevel + INCREMENTAL_INC, this._needsManuallyCompositing);
        layer.incremental = true;
        incrementalLayerCount = 1;
      } else {
        layer = this.getLayer(zlevel + (incrementalLayerCount > 0 ? EL_AFTER_INCREMENTAL_INC : 0), this._needsManuallyCompositing);
      }
      if (!layer.__builtin__) {
        logError("ZLevel " + zlevel + " has been used by unkown layer " + layer.id);
      }
      if (layer !== prevLayer) {
        layer.__used = true;
        if (layer.__startIndex !== i) {
          layer.__dirty = true;
        }
        layer.__startIndex = i;
        if (!layer.incremental) {
          layer.__drawIndex = i;
        } else {
          layer.__drawIndex = -1;
        }
        updatePrevLayer(i);
        prevLayer = layer;
      }
      if (el.__dirty & REDRAW_BIT && !el.__inHover) {
        layer.__dirty = true;
        if (layer.incremental && layer.__drawIndex < 0) {
          layer.__drawIndex = i;
        }
      }
    }
    updatePrevLayer(i);
    this.eachBuiltinLayer(function(layer2, z2) {
      if (!layer2.__used && layer2.getElementCount() > 0) {
        layer2.__dirty = true;
        layer2.__startIndex = layer2.__endIndex = layer2.__drawIndex = 0;
      }
      if (layer2.__dirty && layer2.__drawIndex < 0) {
        layer2.__drawIndex = layer2.__startIndex;
      }
    });
  };
  CanvasPainter2.prototype.clear = function() {
    this.eachBuiltinLayer(this._clearLayer);
    return this;
  };
  CanvasPainter2.prototype._clearLayer = function(layer) {
    layer.clear();
  };
  CanvasPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    each$f(this._layers, function(layer) {
      layer.setUnpainted();
    });
  };
  CanvasPainter2.prototype.configLayer = function(zlevel, config) {
    if (config) {
      var layerConfig = this._layerConfig;
      if (!layerConfig[zlevel]) {
        layerConfig[zlevel] = config;
      } else {
        merge(layerConfig[zlevel], config, true);
      }
      for (var i = 0; i < this._zlevelList.length; i++) {
        var _zlevel = this._zlevelList[i];
        if (_zlevel === zlevel || _zlevel === zlevel + EL_AFTER_INCREMENTAL_INC) {
          var layer = this._layers[_zlevel];
          merge(layer, layerConfig[zlevel], true);
        }
      }
    }
  };
  CanvasPainter2.prototype.delLayer = function(zlevel) {
    var layers = this._layers;
    var zlevelList = this._zlevelList;
    var layer = layers[zlevel];
    if (!layer) {
      return;
    }
    layer.dom.parentNode.removeChild(layer.dom);
    delete layers[zlevel];
    zlevelList.splice(indexOf(zlevelList, zlevel), 1);
  };
  CanvasPainter2.prototype.resize = function(width, height) {
    if (!this._domRoot.style) {
      if (width == null || height == null) {
        return;
      }
      this._width = width;
      this._height = height;
      this.getLayer(CANVAS_ZLEVEL).resize(width, height);
    } else {
      var domRoot = this._domRoot;
      domRoot.style.display = "none";
      var opts = this._opts;
      var root2 = this.root;
      width != null && (opts.width = width);
      height != null && (opts.height = height);
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      domRoot.style.display = "";
      if (this._width !== width || height !== this._height) {
        domRoot.style.width = width + "px";
        domRoot.style.height = height + "px";
        for (var id2 in this._layers) {
          if (this._layers.hasOwnProperty(id2)) {
            this._layers[id2].resize(width, height);
          }
        }
        this.refresh(true);
      }
      this._width = width;
      this._height = height;
    }
    return this;
  };
  CanvasPainter2.prototype.clearLayer = function(zlevel) {
    var layer = this._layers[zlevel];
    if (layer) {
      layer.clear();
    }
  };
  CanvasPainter2.prototype.dispose = function() {
    this.root.innerHTML = "";
    this.root = this.storage = this._domRoot = this._layers = null;
  };
  CanvasPainter2.prototype.getRenderedCanvas = function(opts) {
    opts = opts || {};
    if (this._singleCanvas && !this._compositeManually) {
      return this._layers[CANVAS_ZLEVEL].dom;
    }
    var imageLayer = new Layer$1("image", this, opts.pixelRatio || this.dpr);
    imageLayer.initContext();
    imageLayer.clear(false, opts.backgroundColor || this._backgroundColor);
    var ctx = imageLayer.ctx;
    if (opts.pixelRatio <= this.dpr) {
      this.refresh();
      var width_1 = imageLayer.dom.width;
      var height_1 = imageLayer.dom.height;
      this.eachLayer(function(layer) {
        if (layer.__builtin__) {
          ctx.drawImage(layer.dom, 0, 0, width_1, height_1);
        } else if (layer.renderToCanvas) {
          ctx.save();
          layer.renderToCanvas(ctx);
          ctx.restore();
        }
      });
    } else {
      var scope = {
        inHover: false,
        viewWidth: this._width,
        viewHeight: this._height
      };
      var displayList = this.storage.getDisplayList(true);
      for (var i = 0, len2 = displayList.length; i < len2; i++) {
        var el = displayList[i];
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    return imageLayer.dom;
  };
  CanvasPainter2.prototype.getWidth = function() {
    return this._width;
  };
  CanvasPainter2.prototype.getHeight = function() {
    return this._height;
  };
  return CanvasPainter2;
}();
var CanvasPainter$1 = CanvasPainter;
function install$R(registers) {
  registers.registerPainter("canvas", CanvasPainter$1);
}
var LineSeriesModel = function(_super) {
  __extends(LineSeriesModel2, _super);
  function LineSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LineSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  LineSeriesModel2.prototype.getInitialData = function(option) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  LineSeriesModel2.prototype.getLegendIcon = function(opt) {
    var group = new Group$4();
    var line = createSymbol$1("line", 0, opt.itemHeight / 2, opt.itemWidth, 0, opt.lineStyle.stroke, false);
    group.add(line);
    line.setStyle(opt.lineStyle);
    var visualType = this.getData().getVisual("symbol");
    var visualRotate = this.getData().getVisual("symbolRotate");
    var symbolType = visualType === "none" ? "circle" : visualType;
    var size = opt.itemHeight * 0.8;
    var symbol = createSymbol$1(symbolType, (opt.itemWidth - size) / 2, (opt.itemHeight - size) / 2, size, size, opt.itemStyle.fill);
    group.add(symbol);
    symbol.setStyle(opt.itemStyle);
    var symbolRotate = opt.iconRotate === "inherit" ? visualRotate : opt.iconRotate || 0;
    symbol.rotation = symbolRotate * Math.PI / 180;
    symbol.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
    if (symbolType.indexOf("empty") > -1) {
      symbol.style.stroke = symbol.style.fill;
      symbol.style.fill = "#fff";
      symbol.style.lineWidth = 2;
    }
    return group;
  };
  LineSeriesModel2.type = "series.line";
  LineSeriesModel2.dependencies = ["grid", "polar"];
  LineSeriesModel2.defaultOption = {
    z: 3,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    clip: true,
    label: {
      position: "top"
    },
    endLabel: {
      show: false,
      valueAnimation: true,
      distance: 8
    },
    lineStyle: {
      width: 2,
      type: "solid"
    },
    emphasis: {
      scale: true
    },
    step: false,
    smooth: false,
    smoothMonotone: null,
    symbol: "emptyCircle",
    symbolSize: 4,
    symbolRotate: null,
    showSymbol: true,
    showAllSymbol: "auto",
    connectNulls: false,
    sampling: "none",
    animationEasing: "linear",
    progressive: 0,
    hoverLayerThreshold: Infinity,
    universalTransition: {
      divideShape: "clone"
    },
    triggerLineEvent: false
  };
  return LineSeriesModel2;
}(SeriesModel$1);
var LineSeries = LineSeriesModel;
function getDefaultLabel(data, dataIndex) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  var len2 = labelDims.length;
  if (len2 === 1) {
    var rawVal = retrieveRawValue(data, dataIndex, labelDims[0]);
    return rawVal != null ? rawVal + "" : null;
  } else if (len2) {
    var vals = [];
    for (var i = 0; i < labelDims.length; i++) {
      vals.push(retrieveRawValue(data, dataIndex, labelDims[i]));
    }
    return vals.join(" ");
  }
}
function getDefaultInterpolatedLabel(data, interpolatedValue) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  if (!isArray$1(interpolatedValue)) {
    return interpolatedValue + "";
  }
  var vals = [];
  for (var i = 0; i < labelDims.length; i++) {
    var dimIndex = data.getDimensionIndex(labelDims[i]);
    if (dimIndex >= 0) {
      vals.push(interpolatedValue[dimIndex]);
    }
  }
  return vals.join(" ");
}
var Symbol$1 = function(_super) {
  __extends(Symbol2, _super);
  function Symbol2(data, idx, seriesScope, opts) {
    var _this = _super.call(this) || this;
    _this.updateData(data, idx, seriesScope, opts);
    return _this;
  }
  Symbol2.prototype._createSymbol = function(symbolType, data, idx, symbolSize, keepAspect) {
    this.removeAll();
    var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2, null, keepAspect);
    symbolPath.attr({
      z2: 100,
      culling: true,
      scaleX: symbolSize[0] / 2,
      scaleY: symbolSize[1] / 2
    });
    symbolPath.drift = driftSymbol;
    this._symbolType = symbolType;
    this.add(symbolPath);
  };
  Symbol2.prototype.stopSymbolAnimation = function(toLastFrame) {
    this.childAt(0).stopAnimation(null, toLastFrame);
  };
  Symbol2.prototype.getSymbolType = function() {
    return this._symbolType;
  };
  Symbol2.prototype.getSymbolPath = function() {
    return this.childAt(0);
  };
  Symbol2.prototype.highlight = function() {
    enterEmphasis(this.childAt(0));
  };
  Symbol2.prototype.downplay = function() {
    leaveEmphasis(this.childAt(0));
  };
  Symbol2.prototype.setZ = function(zlevel, z2) {
    var symbolPath = this.childAt(0);
    symbolPath.zlevel = zlevel;
    symbolPath.z = z2;
  };
  Symbol2.prototype.setDraggable = function(draggable) {
    var symbolPath = this.childAt(0);
    symbolPath.draggable = draggable;
    symbolPath.cursor = draggable ? "move" : symbolPath.cursor;
  };
  Symbol2.prototype.updateData = function(data, idx, seriesScope, opts) {
    this.silent = false;
    var symbolType = data.getItemVisual(idx, "symbol") || "circle";
    var seriesModel = data.hostModel;
    var symbolSize = Symbol2.getSymbolSize(data, idx);
    var isInit = symbolType !== this._symbolType;
    var disableAnimation = opts && opts.disableAnimation;
    if (isInit) {
      var keepAspect = data.getItemVisual(idx, "symbolKeepAspect");
      this._createSymbol(symbolType, data, idx, symbolSize, keepAspect);
    } else {
      var symbolPath = this.childAt(0);
      symbolPath.silent = false;
      var target = {
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2
      };
      disableAnimation ? symbolPath.attr(target) : updateProps$1(symbolPath, target, seriesModel, idx);
      saveOldStyle(symbolPath);
    }
    this._updateCommon(data, idx, symbolSize, seriesScope, opts);
    if (isInit) {
      var symbolPath = this.childAt(0);
      if (!disableAnimation) {
        var target = {
          scaleX: this._sizeX,
          scaleY: this._sizeY,
          style: {
            opacity: symbolPath.style.opacity
          }
        };
        symbolPath.scaleX = symbolPath.scaleY = 0;
        symbolPath.style.opacity = 0;
        initProps(symbolPath, target, seriesModel, idx);
      }
    }
    if (disableAnimation) {
      this.childAt(0).stopAnimation("leave");
    }
  };
  Symbol2.prototype._updateCommon = function(data, idx, symbolSize, seriesScope, opts) {
    var symbolPath = this.childAt(0);
    var seriesModel = data.hostModel;
    var emphasisItemStyle;
    var blurItemStyle;
    var selectItemStyle;
    var focus;
    var blurScope;
    var emphasisDisabled;
    var labelStatesModels;
    var hoverScale;
    var cursorStyle;
    if (seriesScope) {
      emphasisItemStyle = seriesScope.emphasisItemStyle;
      blurItemStyle = seriesScope.blurItemStyle;
      selectItemStyle = seriesScope.selectItemStyle;
      focus = seriesScope.focus;
      blurScope = seriesScope.blurScope;
      labelStatesModels = seriesScope.labelStatesModels;
      hoverScale = seriesScope.hoverScale;
      cursorStyle = seriesScope.cursorStyle;
      emphasisDisabled = seriesScope.emphasisDisabled;
    }
    if (!seriesScope || data.hasItemOption) {
      var itemModel = seriesScope && seriesScope.itemModel ? seriesScope.itemModel : data.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisItemStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      selectItemStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
      blurItemStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      emphasisDisabled = emphasisModel.get("disabled");
      labelStatesModels = getLabelStatesModels(itemModel);
      hoverScale = emphasisModel.getShallow("scale");
      cursorStyle = itemModel.getShallow("cursor");
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    symbolPath.attr("rotation", (symbolRotate || 0) * Math.PI / 180 || 0);
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      symbolPath.x = symbolOffset[0];
      symbolPath.y = symbolOffset[1];
    }
    cursorStyle && symbolPath.attr("cursor", cursorStyle);
    var symbolStyle = data.getItemVisual(idx, "style");
    var visualColor = symbolStyle.fill;
    if (symbolPath instanceof ZRImage$1) {
      var pathStyle = symbolPath.style;
      symbolPath.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolStyle));
    } else {
      if (symbolPath.__isEmptyBrush) {
        symbolPath.useStyle(extend({}, symbolStyle));
      } else {
        symbolPath.useStyle(symbolStyle);
      }
      symbolPath.style.decal = null;
      symbolPath.setColor(visualColor, opts && opts.symbolInnerColor);
      symbolPath.style.strokeNoScale = true;
    }
    var liftZ = data.getItemVisual(idx, "liftZ");
    var z2Origin = this._z2;
    if (liftZ != null) {
      if (z2Origin == null) {
        this._z2 = symbolPath.z2;
        symbolPath.z2 += liftZ;
      }
    } else if (z2Origin != null) {
      symbolPath.z2 = z2Origin;
      this._z2 = null;
    }
    var useNameLabel = opts && opts.useNameLabel;
    setLabelStyle(symbolPath, labelStatesModels, {
      labelFetcher: seriesModel,
      labelDataIndex: idx,
      defaultText: getLabelDefaultText,
      inheritColor: visualColor,
      defaultOpacity: symbolStyle.opacity
    });
    function getLabelDefaultText(idx2) {
      return useNameLabel ? data.getName(idx2) : getDefaultLabel(data, idx2);
    }
    this._sizeX = symbolSize[0] / 2;
    this._sizeY = symbolSize[1] / 2;
    var emphasisState = symbolPath.ensureState("emphasis");
    emphasisState.style = emphasisItemStyle;
    symbolPath.ensureState("select").style = selectItemStyle;
    symbolPath.ensureState("blur").style = blurItemStyle;
    if (hoverScale) {
      var scaleRatio = Math.max(1.1, 3 / this._sizeY);
      emphasisState.scaleX = this._sizeX * scaleRatio;
      emphasisState.scaleY = this._sizeY * scaleRatio;
    }
    this.setSymbolScale(1);
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Symbol2.prototype.setSymbolScale = function(scale2) {
    this.scaleX = this.scaleY = scale2;
  };
  Symbol2.prototype.fadeOut = function(cb, seriesModel, opt) {
    var symbolPath = this.childAt(0);
    var dataIndex = getECData(this).dataIndex;
    var animationOpt = opt && opt.animation;
    this.silent = symbolPath.silent = true;
    if (opt && opt.fadeLabel) {
      var textContent = symbolPath.getTextContent();
      if (textContent) {
        removeElement(textContent, {
          style: {
            opacity: 0
          }
        }, seriesModel, {
          dataIndex,
          removeOpt: animationOpt,
          cb: function() {
            symbolPath.removeTextContent();
          }
        });
      }
    } else {
      symbolPath.removeTextContent();
    }
    removeElement(symbolPath, {
      style: {
        opacity: 0
      },
      scaleX: 0,
      scaleY: 0
    }, seriesModel, {
      dataIndex,
      cb,
      removeOpt: animationOpt
    });
  };
  Symbol2.getSymbolSize = function(data, idx) {
    return normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
  };
  return Symbol2;
}(Group$4);
function driftSymbol(dx, dy) {
  this.parent.drift(dx, dy);
}
var SymbolClz = Symbol$1;
function symbolNeedsDraw$1(data, point, idx, opt) {
  return point && !isNaN(point[0]) && !isNaN(point[1]) && !(opt.isIgnore && opt.isIgnore(idx)) && !(opt.clipShape && !opt.clipShape.contain(point[0], point[1])) && data.getItemVisual(idx, "symbol") !== "none";
}
function normalizeUpdateOpt(opt) {
  if (opt != null && !isObject$4(opt)) {
    opt = {
      isIgnore: opt
    };
  }
  return opt || {};
}
function makeSeriesScope$2(data) {
  var seriesModel = data.hostModel;
  var emphasisModel = seriesModel.getModel("emphasis");
  return {
    emphasisItemStyle: emphasisModel.getModel("itemStyle").getItemStyle(),
    blurItemStyle: seriesModel.getModel(["blur", "itemStyle"]).getItemStyle(),
    selectItemStyle: seriesModel.getModel(["select", "itemStyle"]).getItemStyle(),
    focus: emphasisModel.get("focus"),
    blurScope: emphasisModel.get("blurScope"),
    emphasisDisabled: emphasisModel.get("disabled"),
    hoverScale: emphasisModel.get("scale"),
    labelStatesModels: getLabelStatesModels(seriesModel),
    cursorStyle: seriesModel.get("cursor")
  };
}
var SymbolDraw = function() {
  function SymbolDraw2(SymbolCtor) {
    this.group = new Group$4();
    this._SymbolCtor = SymbolCtor || SymbolClz;
  }
  SymbolDraw2.prototype.updateData = function(data, opt) {
    this._progressiveEls = null;
    opt = normalizeUpdateOpt(opt);
    var group = this.group;
    var seriesModel = data.hostModel;
    var oldData = this._data;
    var SymbolCtor = this._SymbolCtor;
    var disableAnimation = opt.disableAnimation;
    var seriesScope = makeSeriesScope$2(data);
    var symbolUpdateOpt = {
      disableAnimation
    };
    var getSymbolPoint = opt.getSymbolPoint || function(idx) {
      return data.getItemLayout(idx);
    };
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      var point = getSymbolPoint(newIdx);
      if (symbolNeedsDraw$1(data, point, newIdx, opt)) {
        var symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      var point = getSymbolPoint(newIdx);
      if (!symbolNeedsDraw$1(data, point, newIdx, opt)) {
        group.remove(symbolEl);
        return;
      }
      var newSymbolType = data.getItemVisual(newIdx, "symbol") || "circle";
      var oldSymbolType = symbolEl && symbolEl.getSymbolType && symbolEl.getSymbolType();
      if (!symbolEl || oldSymbolType && oldSymbolType !== newSymbolType) {
        group.remove(symbolEl);
        symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
      } else {
        symbolEl.updateData(data, newIdx, seriesScope, symbolUpdateOpt);
        var target = {
          x: point[0],
          y: point[1]
        };
        disableAnimation ? symbolEl.attr(target) : updateProps$1(symbolEl, target, seriesModel);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && el.fadeOut(function() {
        group.remove(el);
      }, seriesModel);
    }).execute();
    this._getSymbolPoint = getSymbolPoint;
    this._data = data;
  };
  SymbolDraw2.prototype.updateLayout = function() {
    var _this = this;
    var data = this._data;
    if (data) {
      data.eachItemGraphicEl(function(el, idx) {
        var point = _this._getSymbolPoint(idx);
        el.setPosition(point);
        el.markRedraw();
      });
    }
  };
  SymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._seriesScope = makeSeriesScope$2(data);
    this._data = null;
    this.group.removeAll();
  };
  SymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    this._progressiveEls = [];
    opt = normalizeUpdateOpt(opt);
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var point = data.getItemLayout(idx);
      if (symbolNeedsDraw$1(data, point, idx, opt)) {
        var el = new this._SymbolCtor(data, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        el.setPosition(point);
        this.group.add(el);
        data.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  SymbolDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  SymbolDraw2.prototype.remove = function(enableAnimation) {
    var group = this.group;
    var data = this._data;
    if (data && enableAnimation) {
      data.eachItemGraphicEl(function(el) {
        el.fadeOut(function() {
          group.remove(el);
        }, data.hostModel);
      });
    } else {
      group.removeAll();
    }
  };
  return SymbolDraw2;
}();
var SymbolDraw$1 = SymbolDraw;
function prepareDataCoordInfo(coordSys, data, valueOrigin) {
  var baseAxis = coordSys.getBaseAxis();
  var valueAxis2 = coordSys.getOtherAxis(baseAxis);
  var valueStart = getValueStart(valueAxis2, valueOrigin);
  var baseAxisDim = baseAxis.dim;
  var valueAxisDim = valueAxis2.dim;
  var valueDim = data.mapDimension(valueAxisDim);
  var baseDim = data.mapDimension(baseAxisDim);
  var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
  var dims = map$1(coordSys.dimensions, function(coordDim) {
    return data.mapDimension(coordDim);
  });
  var stacked = false;
  var stackResultDim = data.getCalculationInfo("stackResultDimension");
  if (isDimensionStacked(data, dims[0])) {
    stacked = true;
    dims[0] = stackResultDim;
  }
  if (isDimensionStacked(data, dims[1])) {
    stacked = true;
    dims[1] = stackResultDim;
  }
  return {
    dataDimsForPoint: dims,
    valueStart,
    valueAxisDim,
    baseAxisDim,
    stacked: !!stacked,
    valueDim,
    baseDim,
    baseDataOffset,
    stackedOverDimension: data.getCalculationInfo("stackedOverDimension")
  };
}
function getValueStart(valueAxis2, valueOrigin) {
  var valueStart = 0;
  var extent3 = valueAxis2.scale.getExtent();
  if (valueOrigin === "start") {
    valueStart = extent3[0];
  } else if (valueOrigin === "end") {
    valueStart = extent3[1];
  } else {
    if (extent3[0] > 0) {
      valueStart = extent3[0];
    } else if (extent3[1] < 0) {
      valueStart = extent3[1];
    }
  }
  return valueStart;
}
function getStackedOnPoint(dataCoordInfo, coordSys, data, idx) {
  var value = NaN;
  if (dataCoordInfo.stacked) {
    value = data.get(data.getCalculationInfo("stackedOverDimension"), idx);
  }
  if (isNaN(value)) {
    value = dataCoordInfo.valueStart;
  }
  var baseDataOffset = dataCoordInfo.baseDataOffset;
  var stackedData = [];
  stackedData[baseDataOffset] = data.get(dataCoordInfo.baseDim, idx);
  stackedData[1 - baseDataOffset] = value;
  return coordSys.dataToPoint(stackedData);
}
function diffData(oldData, newData) {
  var diffResult = [];
  newData.diff(oldData).add(function(idx) {
    diffResult.push({
      cmd: "+",
      idx
    });
  }).update(function(newIdx, oldIdx) {
    diffResult.push({
      cmd: "=",
      idx: oldIdx,
      idx1: newIdx
    });
  }).remove(function(idx) {
    diffResult.push({
      cmd: "-",
      idx
    });
  }).execute();
  return diffResult;
}
function lineAnimationDiff(oldData, newData, oldStackedOnPoints, newStackedOnPoints, oldCoordSys, newCoordSys, oldValueOrigin, newValueOrigin) {
  var diff = diffData(oldData, newData);
  var currPoints = [];
  var nextPoints = [];
  var currStackedPoints = [];
  var nextStackedPoints = [];
  var status = [];
  var sortedIndices = [];
  var rawIndices = [];
  var newDataOldCoordInfo = prepareDataCoordInfo(oldCoordSys, newData, oldValueOrigin);
  var oldPoints = oldData.getLayout("points") || [];
  var newPoints = newData.getLayout("points") || [];
  for (var i = 0; i < diff.length; i++) {
    var diffItem = diff[i];
    var pointAdded = true;
    var oldIdx2 = void 0;
    var newIdx2 = void 0;
    switch (diffItem.cmd) {
      case "=":
        oldIdx2 = diffItem.idx * 2;
        newIdx2 = diffItem.idx1 * 2;
        var currentX = oldPoints[oldIdx2];
        var currentY = oldPoints[oldIdx2 + 1];
        var nextX = newPoints[newIdx2];
        var nextY = newPoints[newIdx2 + 1];
        if (isNaN(currentX) || isNaN(currentY)) {
          currentX = nextX;
          currentY = nextY;
        }
        currPoints.push(currentX, currentY);
        nextPoints.push(nextX, nextY);
        currStackedPoints.push(oldStackedOnPoints[oldIdx2], oldStackedOnPoints[oldIdx2 + 1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(diffItem.idx1));
        break;
      case "+":
        var newIdx = diffItem.idx;
        var newDataDimsForPoint = newDataOldCoordInfo.dataDimsForPoint;
        var oldPt = oldCoordSys.dataToPoint([newData.get(newDataDimsForPoint[0], newIdx), newData.get(newDataDimsForPoint[1], newIdx)]);
        newIdx2 = newIdx * 2;
        currPoints.push(oldPt[0], oldPt[1]);
        nextPoints.push(newPoints[newIdx2], newPoints[newIdx2 + 1]);
        var stackedOnPoint = getStackedOnPoint(newDataOldCoordInfo, oldCoordSys, newData, newIdx);
        currStackedPoints.push(stackedOnPoint[0], stackedOnPoint[1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(newIdx));
        break;
      case "-":
        pointAdded = false;
    }
    if (pointAdded) {
      status.push(diffItem);
      sortedIndices.push(sortedIndices.length);
    }
  }
  sortedIndices.sort(function(a, b2) {
    return rawIndices[a] - rawIndices[b2];
  });
  var len2 = currPoints.length;
  var sortedCurrPoints = createFloat32Array(len2);
  var sortedNextPoints = createFloat32Array(len2);
  var sortedCurrStackedPoints = createFloat32Array(len2);
  var sortedNextStackedPoints = createFloat32Array(len2);
  var sortedStatus = [];
  for (var i = 0; i < sortedIndices.length; i++) {
    var idx = sortedIndices[i];
    var i2 = i * 2;
    var idx2 = idx * 2;
    sortedCurrPoints[i2] = currPoints[idx2];
    sortedCurrPoints[i2 + 1] = currPoints[idx2 + 1];
    sortedNextPoints[i2] = nextPoints[idx2];
    sortedNextPoints[i2 + 1] = nextPoints[idx2 + 1];
    sortedCurrStackedPoints[i2] = currStackedPoints[idx2];
    sortedCurrStackedPoints[i2 + 1] = currStackedPoints[idx2 + 1];
    sortedNextStackedPoints[i2] = nextStackedPoints[idx2];
    sortedNextStackedPoints[i2 + 1] = nextStackedPoints[idx2 + 1];
    sortedStatus[i] = status[idx];
  }
  return {
    current: sortedCurrPoints,
    next: sortedNextPoints,
    stackedOnCurrent: sortedCurrStackedPoints,
    stackedOnNext: sortedNextStackedPoints,
    status: sortedStatus
  };
}
var mathMin$5 = Math.min;
var mathMax$5 = Math.max;
function isPointNull$1(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function drawSegment(ctx, points2, start2, segLen, allLen, dir3, smooth, smoothMonotone, connectNulls) {
  var prevX;
  var prevY;
  var cpx0;
  var cpy0;
  var cpx1;
  var cpy1;
  var idx = start2;
  var k2 = 0;
  for (; k2 < segLen; k2++) {
    var x2 = points2[idx * 2];
    var y2 = points2[idx * 2 + 1];
    if (idx >= allLen || idx < 0) {
      break;
    }
    if (isPointNull$1(x2, y2)) {
      if (connectNulls) {
        idx += dir3;
        continue;
      }
      break;
    }
    if (idx === start2) {
      ctx[dir3 > 0 ? "moveTo" : "lineTo"](x2, y2);
      cpx0 = x2;
      cpy0 = y2;
    } else {
      var dx = x2 - prevX;
      var dy = y2 - prevY;
      if (dx * dx + dy * dy < 0.5) {
        idx += dir3;
        continue;
      }
      if (smooth > 0) {
        var nextIdx = idx + dir3;
        var nextX = points2[nextIdx * 2];
        var nextY = points2[nextIdx * 2 + 1];
        while (nextX === x2 && nextY === y2 && k2 < segLen) {
          k2++;
          nextIdx += dir3;
          idx += dir3;
          nextX = points2[nextIdx * 2];
          nextY = points2[nextIdx * 2 + 1];
          x2 = points2[idx * 2];
          y2 = points2[idx * 2 + 1];
          dx = x2 - prevX;
          dy = y2 - prevY;
        }
        var tmpK = k2 + 1;
        if (connectNulls) {
          while (isPointNull$1(nextX, nextY) && tmpK < segLen) {
            tmpK++;
            nextIdx += dir3;
            nextX = points2[nextIdx * 2];
            nextY = points2[nextIdx * 2 + 1];
          }
        }
        var ratioNextSeg = 0.5;
        var vx = 0;
        var vy = 0;
        var nextCpx0 = void 0;
        var nextCpy0 = void 0;
        if (tmpK >= segLen || isPointNull$1(nextX, nextY)) {
          cpx1 = x2;
          cpy1 = y2;
        } else {
          vx = nextX - prevX;
          vy = nextY - prevY;
          var dx0 = x2 - prevX;
          var dx1 = nextX - x2;
          var dy0 = y2 - prevY;
          var dy1 = nextY - y2;
          var lenPrevSeg = void 0;
          var lenNextSeg = void 0;
          if (smoothMonotone === "x") {
            lenPrevSeg = Math.abs(dx0);
            lenNextSeg = Math.abs(dx1);
            var dir_1 = vx > 0 ? 1 : -1;
            cpx1 = x2 - dir_1 * lenPrevSeg * smooth;
            cpy1 = y2;
            nextCpx0 = x2 + dir_1 * lenNextSeg * smooth;
            nextCpy0 = y2;
          } else if (smoothMonotone === "y") {
            lenPrevSeg = Math.abs(dy0);
            lenNextSeg = Math.abs(dy1);
            var dir_2 = vy > 0 ? 1 : -1;
            cpx1 = x2;
            cpy1 = y2 - dir_2 * lenPrevSeg * smooth;
            nextCpx0 = x2;
            nextCpy0 = y2 + dir_2 * lenNextSeg * smooth;
          } else {
            lenPrevSeg = Math.sqrt(dx0 * dx0 + dy0 * dy0);
            lenNextSeg = Math.sqrt(dx1 * dx1 + dy1 * dy1);
            ratioNextSeg = lenNextSeg / (lenNextSeg + lenPrevSeg);
            cpx1 = x2 - vx * smooth * (1 - ratioNextSeg);
            cpy1 = y2 - vy * smooth * (1 - ratioNextSeg);
            nextCpx0 = x2 + vx * smooth * ratioNextSeg;
            nextCpy0 = y2 + vy * smooth * ratioNextSeg;
            nextCpx0 = mathMin$5(nextCpx0, mathMax$5(nextX, x2));
            nextCpy0 = mathMin$5(nextCpy0, mathMax$5(nextY, y2));
            nextCpx0 = mathMax$5(nextCpx0, mathMin$5(nextX, x2));
            nextCpy0 = mathMax$5(nextCpy0, mathMin$5(nextY, y2));
            vx = nextCpx0 - x2;
            vy = nextCpy0 - y2;
            cpx1 = x2 - vx * lenPrevSeg / lenNextSeg;
            cpy1 = y2 - vy * lenPrevSeg / lenNextSeg;
            cpx1 = mathMin$5(cpx1, mathMax$5(prevX, x2));
            cpy1 = mathMin$5(cpy1, mathMax$5(prevY, y2));
            cpx1 = mathMax$5(cpx1, mathMin$5(prevX, x2));
            cpy1 = mathMax$5(cpy1, mathMin$5(prevY, y2));
            vx = x2 - cpx1;
            vy = y2 - cpy1;
            nextCpx0 = x2 + vx * lenNextSeg / lenPrevSeg;
            nextCpy0 = y2 + vy * lenNextSeg / lenPrevSeg;
          }
        }
        ctx.bezierCurveTo(cpx0, cpy0, cpx1, cpy1, x2, y2);
        cpx0 = nextCpx0;
        cpy0 = nextCpy0;
      } else {
        ctx.lineTo(x2, y2);
      }
    }
    prevX = x2;
    prevY = y2;
    idx += dir3;
  }
  return k2;
}
var ECPolylineShape = function() {
  function ECPolylineShape2() {
    this.smooth = 0;
    this.smoothConstraint = true;
  }
  return ECPolylineShape2;
}();
var ECPolyline = function(_super) {
  __extends(ECPolyline2, _super);
  function ECPolyline2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polyline";
    return _this;
  }
  ECPolyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECPolyline2.prototype.getDefaultShape = function() {
    return new ECPolylineShape();
  };
  ECPolyline2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var i = 0;
    var len2 = points2.length / 2;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      i += drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, shape.smoothMonotone, shape.connectNulls) + 1;
    }
  };
  ECPolyline2.prototype.getPointOn = function(xOrY, dim) {
    if (!this.path) {
      this.createPathProxy();
      this.buildPath(this.path, this.shape);
    }
    var path = this.path;
    var data = path.data;
    var CMD2 = PathProxy$1.CMD;
    var x0;
    var y0;
    var isDimX = dim === "x";
    var roots2 = [];
    for (var i = 0; i < data.length; ) {
      var cmd = data[i++];
      var x2 = void 0;
      var y2 = void 0;
      var x22 = void 0;
      var y22 = void 0;
      var x3 = void 0;
      var y3 = void 0;
      var t2 = void 0;
      switch (cmd) {
        case CMD2.M:
          x0 = data[i++];
          y0 = data[i++];
          break;
        case CMD2.L:
          x2 = data[i++];
          y2 = data[i++];
          t2 = isDimX ? (xOrY - x0) / (x2 - x0) : (xOrY - y0) / (y2 - y0);
          if (t2 <= 1 && t2 >= 0) {
            var val = isDimX ? (y2 - y0) * t2 + y0 : (x2 - x0) * t2 + x0;
            return isDimX ? [xOrY, val] : [val, xOrY];
          }
          x0 = x2;
          y0 = y2;
          break;
        case CMD2.C:
          x2 = data[i++];
          y2 = data[i++];
          x22 = data[i++];
          y22 = data[i++];
          x3 = data[i++];
          y3 = data[i++];
          var nRoot = isDimX ? cubicRootAt(x0, x2, x22, x3, xOrY, roots2) : cubicRootAt(y0, y2, y22, y3, xOrY, roots2);
          if (nRoot > 0) {
            for (var i_1 = 0; i_1 < nRoot; i_1++) {
              var t_1 = roots2[i_1];
              if (t_1 <= 1 && t_1 >= 0) {
                var val = isDimX ? cubicAt(y0, y2, y22, y3, t_1) : cubicAt(x0, x2, x22, x3, t_1);
                return isDimX ? [xOrY, val] : [val, xOrY];
              }
            }
          }
          x0 = x3;
          y0 = y3;
          break;
      }
    }
  };
  return ECPolyline2;
}(Path$1);
var ECPolygonShape = function(_super) {
  __extends(ECPolygonShape2, _super);
  function ECPolygonShape2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return ECPolygonShape2;
}(ECPolylineShape);
var ECPolygon = function(_super) {
  __extends(ECPolygon2, _super);
  function ECPolygon2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polygon";
    return _this;
  }
  ECPolygon2.prototype.getDefaultShape = function() {
    return new ECPolygonShape();
  };
  ECPolygon2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var stackedOnPoints = shape.stackedOnPoints;
    var i = 0;
    var len2 = points2.length / 2;
    var smoothMonotone = shape.smoothMonotone;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      var k2 = drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, smoothMonotone, shape.connectNulls);
      drawSegment(ctx, stackedOnPoints, i + k2 - 1, k2, len2, -1, shape.stackedOnSmooth, smoothMonotone, shape.connectNulls);
      i += k2 + 1;
      ctx.closePath();
    }
  };
  return ECPolygon2;
}(Path$1);
function createGridClipPath(cartesian, hasAnimation, seriesModel, done, during) {
  var rect = cartesian.getArea();
  var x2 = rect.x;
  var y2 = rect.y;
  var width = rect.width;
  var height = rect.height;
  var lineWidth = seriesModel.get(["lineStyle", "width"]) || 2;
  x2 -= lineWidth / 2;
  y2 -= lineWidth / 2;
  width += lineWidth;
  height += lineWidth;
  x2 = Math.floor(x2);
  width = Math.round(width);
  var clipPath = new Rect$3({
    shape: {
      x: x2,
      y: y2,
      width,
      height
    }
  });
  if (hasAnimation) {
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var isAxisInversed = baseAxis.inverse;
    if (isHorizontal) {
      if (isAxisInversed) {
        clipPath.shape.x += width;
      }
      clipPath.shape.width = 0;
    } else {
      if (!isAxisInversed) {
        clipPath.shape.y += height;
      }
      clipPath.shape.height = 0;
    }
    var duringCb = isFunction(during) ? function(percent) {
      during(percent, clipPath);
    } : null;
    initProps(clipPath, {
      shape: {
        width,
        height,
        x: x2,
        y: y2
      }
    }, seriesModel, null, done, duringCb);
  }
  return clipPath;
}
function createPolarClipPath(polar, hasAnimation, seriesModel) {
  var sectorArea = polar.getArea();
  var r0 = round$3(sectorArea.r0, 1);
  var r2 = round$3(sectorArea.r, 1);
  var clipPath = new Sector$1({
    shape: {
      cx: round$3(polar.cx, 1),
      cy: round$3(polar.cy, 1),
      r0,
      r: r2,
      startAngle: sectorArea.startAngle,
      endAngle: sectorArea.endAngle,
      clockwise: sectorArea.clockwise
    }
  });
  if (hasAnimation) {
    var isRadial = polar.getBaseAxis().dim === "angle";
    if (isRadial) {
      clipPath.shape.endAngle = sectorArea.startAngle;
    } else {
      clipPath.shape.r = r0;
    }
    initProps(clipPath, {
      shape: {
        endAngle: sectorArea.endAngle,
        r: r2
      }
    }, seriesModel);
  }
  return clipPath;
}
function createClipPath(coordSys, hasAnimation, seriesModel, done, during) {
  if (!coordSys) {
    return null;
  } else if (coordSys.type === "polar") {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  } else if (coordSys.type === "cartesian2d") {
    return createGridClipPath(coordSys, hasAnimation, seriesModel, done, during);
  }
  return null;
}
function isCoordinateSystemType(coordSys, type4) {
  return coordSys.type === type4;
}
function isPointsSame(points1, points2) {
  if (points1.length !== points2.length) {
    return;
  }
  for (var i = 0; i < points1.length; i++) {
    if (points1[i] !== points2[i]) {
      return;
    }
  }
  return true;
}
function bboxFromPoints(points2) {
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  for (var i = 0; i < points2.length; ) {
    var x2 = points2[i++];
    var y2 = points2[i++];
    if (!isNaN(x2)) {
      minX = Math.min(x2, minX);
      maxX = Math.max(x2, maxX);
    }
    if (!isNaN(y2)) {
      minY = Math.min(y2, minY);
      maxY = Math.max(y2, maxY);
    }
  }
  return [[minX, minY], [maxX, maxY]];
}
function getBoundingDiff(points1, points2) {
  var _a2 = bboxFromPoints(points1), min1 = _a2[0], max1 = _a2[1];
  var _b2 = bboxFromPoints(points2), min22 = _b2[0], max22 = _b2[1];
  return Math.max(Math.abs(min1[0] - min22[0]), Math.abs(min1[1] - min22[1]), Math.abs(max1[0] - max22[0]), Math.abs(max1[1] - max22[1]));
}
function getSmooth(smooth) {
  return isNumber(smooth) ? smooth : smooth ? 0.5 : 0;
}
function getStackedOnPoints(coordSys, data, dataCoordInfo) {
  if (!dataCoordInfo.valueDim) {
    return [];
  }
  var len2 = data.count();
  var points2 = createFloat32Array(len2 * 2);
  for (var idx = 0; idx < len2; idx++) {
    var pt = getStackedOnPoint(dataCoordInfo, coordSys, data, idx);
    points2[idx * 2] = pt[0];
    points2[idx * 2 + 1] = pt[1];
  }
  return points2;
}
function turnPointsIntoStep(points2, coordSys, stepTurnAt, connectNulls) {
  var baseAxis = coordSys.getBaseAxis();
  var baseIndex = baseAxis.dim === "x" || baseAxis.dim === "radius" ? 0 : 1;
  var stepPoints = [];
  var i = 0;
  var stepPt = [];
  var pt = [];
  var nextPt = [];
  var filteredPoints = [];
  if (connectNulls) {
    for (i = 0; i < points2.length; i += 2) {
      if (!isNaN(points2[i]) && !isNaN(points2[i + 1])) {
        filteredPoints.push(points2[i], points2[i + 1]);
      }
    }
    points2 = filteredPoints;
  }
  for (i = 0; i < points2.length - 2; i += 2) {
    nextPt[0] = points2[i + 2];
    nextPt[1] = points2[i + 3];
    pt[0] = points2[i];
    pt[1] = points2[i + 1];
    stepPoints.push(pt[0], pt[1]);
    switch (stepTurnAt) {
      case "end":
        stepPt[baseIndex] = nextPt[baseIndex];
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        break;
      case "middle":
        var middle = (pt[baseIndex] + nextPt[baseIndex]) / 2;
        var stepPt2 = [];
        stepPt[baseIndex] = stepPt2[baseIndex] = middle;
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPt2[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        stepPoints.push(stepPt2[0], stepPt2[1]);
        break;
      default:
        stepPt[baseIndex] = pt[baseIndex];
        stepPt[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
    }
  }
  stepPoints.push(points2[i++], points2[i++]);
  return stepPoints;
}
function clipColorStops(colorStops, maxSize) {
  var newColorStops = [];
  var len2 = colorStops.length;
  var prevOutOfRangeColorStop;
  var prevInRangeColorStop;
  function lerpStop(stop0, stop1, clippedCoord) {
    var coord0 = stop0.coord;
    var p2 = (clippedCoord - coord0) / (stop1.coord - coord0);
    var color = lerp(p2, [stop0.color, stop1.color]);
    return {
      coord: clippedCoord,
      color
    };
  }
  for (var i = 0; i < len2; i++) {
    var stop_1 = colorStops[i];
    var coord = stop_1.coord;
    if (coord < 0) {
      prevOutOfRangeColorStop = stop_1;
    } else if (coord > maxSize) {
      if (prevInRangeColorStop) {
        newColorStops.push(lerpStop(prevInRangeColorStop, stop_1, maxSize));
      } else if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0), lerpStop(prevOutOfRangeColorStop, stop_1, maxSize));
      }
      break;
    } else {
      if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0));
        prevOutOfRangeColorStop = null;
      }
      newColorStops.push(stop_1);
      prevInRangeColorStop = stop_1;
    }
  }
  return newColorStops;
}
function getVisualGradient(data, coordSys, api) {
  var visualMetaList = data.getVisual("visualMeta");
  if (!visualMetaList || !visualMetaList.length || !data.count()) {
    return;
  }
  if (coordSys.type !== "cartesian2d") {
    return;
  }
  var coordDim;
  var visualMeta;
  for (var i = visualMetaList.length - 1; i >= 0; i--) {
    var dimInfo = data.getDimensionInfo(visualMetaList[i].dimension);
    coordDim = dimInfo && dimInfo.coordDim;
    if (coordDim === "x" || coordDim === "y") {
      visualMeta = visualMetaList[i];
      break;
    }
  }
  if (!visualMeta) {
    return;
  }
  var axis = coordSys.getAxis(coordDim);
  var colorStops = map$1(visualMeta.stops, function(stop2) {
    return {
      coord: axis.toGlobalCoord(axis.dataToCoord(stop2.value)),
      color: stop2.color
    };
  });
  var stopLen = colorStops.length;
  var outerColors = visualMeta.outerColors.slice();
  if (stopLen && colorStops[0].coord > colorStops[stopLen - 1].coord) {
    colorStops.reverse();
    outerColors.reverse();
  }
  var colorStopsInRange = clipColorStops(colorStops, coordDim === "x" ? api.getWidth() : api.getHeight());
  var inRangeStopLen = colorStopsInRange.length;
  if (!inRangeStopLen && stopLen) {
    return colorStops[0].coord < 0 ? outerColors[1] ? outerColors[1] : colorStops[stopLen - 1].color : outerColors[0] ? outerColors[0] : colorStops[0].color;
  }
  var tinyExtent = 10;
  var minCoord = colorStopsInRange[0].coord - tinyExtent;
  var maxCoord = colorStopsInRange[inRangeStopLen - 1].coord + tinyExtent;
  var coordSpan = maxCoord - minCoord;
  if (coordSpan < 1e-3) {
    return "transparent";
  }
  each$f(colorStopsInRange, function(stop2) {
    stop2.offset = (stop2.coord - minCoord) / coordSpan;
  });
  colorStopsInRange.push({
    offset: inRangeStopLen ? colorStopsInRange[inRangeStopLen - 1].offset : 0.5,
    color: outerColors[1] || "transparent"
  });
  colorStopsInRange.unshift({
    offset: inRangeStopLen ? colorStopsInRange[0].offset : 0.5,
    color: outerColors[0] || "transparent"
  });
  var gradient = new LinearGradient$1(0, 0, 0, 0, colorStopsInRange, true);
  gradient[coordDim] = minCoord;
  gradient[coordDim + "2"] = maxCoord;
  return gradient;
}
function getIsIgnoreFunc(seriesModel, data, coordSys) {
  var showAllSymbol = seriesModel.get("showAllSymbol");
  var isAuto = showAllSymbol === "auto";
  if (showAllSymbol && !isAuto) {
    return;
  }
  var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
  if (!categoryAxis2) {
    return;
  }
  if (isAuto && canShowAllSymbolForCategory(categoryAxis2, data)) {
    return;
  }
  var categoryDataDim = data.mapDimension(categoryAxis2.dim);
  var labelMap = {};
  each$f(categoryAxis2.getViewLabels(), function(labelItem) {
    var ordinalNumber = categoryAxis2.scale.getRawOrdinalNumber(labelItem.tickValue);
    labelMap[ordinalNumber] = 1;
  });
  return function(dataIndex) {
    return !labelMap.hasOwnProperty(data.get(categoryDataDim, dataIndex));
  };
}
function canShowAllSymbolForCategory(categoryAxis2, data) {
  var axisExtent = categoryAxis2.getExtent();
  var availSize = Math.abs(axisExtent[1] - axisExtent[0]) / categoryAxis2.scale.count();
  isNaN(availSize) && (availSize = 0);
  var dataLen = data.count();
  var step = Math.max(1, Math.round(dataLen / 5));
  for (var dataIndex = 0; dataIndex < dataLen; dataIndex += step) {
    if (SymbolClz.getSymbolSize(data, dataIndex)[categoryAxis2.isHorizontal() ? 1 : 0] * 1.5 > availSize) {
      return false;
    }
  }
  return true;
}
function isPointNull(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function getLastIndexNotNull(points2) {
  var len2 = points2.length / 2;
  for (; len2 > 0; len2--) {
    if (!isPointNull(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
      break;
    }
  }
  return len2 - 1;
}
function getPointAtIndex(points2, idx) {
  return [points2[idx * 2], points2[idx * 2 + 1]];
}
function getIndexRange(points2, xOrY, dim) {
  var len2 = points2.length / 2;
  var dimIdx = dim === "x" ? 0 : 1;
  var a;
  var b2;
  var prevIndex = 0;
  var nextIndex = -1;
  for (var i = 0; i < len2; i++) {
    b2 = points2[i * 2 + dimIdx];
    if (isNaN(b2) || isNaN(points2[i * 2 + 1 - dimIdx])) {
      continue;
    }
    if (i === 0) {
      a = b2;
      continue;
    }
    if (a <= xOrY && b2 >= xOrY || a >= xOrY && b2 <= xOrY) {
      nextIndex = i;
      break;
    }
    prevIndex = i;
    a = b2;
  }
  return {
    range: [prevIndex, nextIndex],
    t: (xOrY - a) / (b2 - a)
  };
}
function anyStateShowEndLabel(seriesModel) {
  if (seriesModel.get(["endLabel", "show"])) {
    return true;
  }
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    if (seriesModel.get([SPECIAL_STATES[i], "endLabel", "show"])) {
      return true;
    }
  }
  return false;
}
function createLineClipPath(lineView, coordSys, hasAnimation, seriesModel) {
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    var endLabelModel_1 = seriesModel.getModel("endLabel");
    var valueAnimation_1 = endLabelModel_1.get("valueAnimation");
    var data_1 = seriesModel.getData();
    var labelAnimationRecord_1 = {
      lastFrameIndex: 0
    };
    var during = anyStateShowEndLabel(seriesModel) ? function(percent, clipRect) {
      lineView._endLabelOnDuring(percent, clipRect, data_1, labelAnimationRecord_1, valueAnimation_1, endLabelModel_1, coordSys);
    } : null;
    var isHorizontal = coordSys.getBaseAxis().isHorizontal();
    var clipPath = createGridClipPath(coordSys, hasAnimation, seriesModel, function() {
      var endLabel = lineView._endLabel;
      if (endLabel && hasAnimation) {
        if (labelAnimationRecord_1.originalX != null) {
          endLabel.attr({
            x: labelAnimationRecord_1.originalX,
            y: labelAnimationRecord_1.originalY
          });
        }
      }
    }, during);
    if (!seriesModel.get("clip", true)) {
      var rectShape = clipPath.shape;
      var expandSize = Math.max(rectShape.width, rectShape.height);
      if (isHorizontal) {
        rectShape.y -= expandSize;
        rectShape.height += expandSize * 2;
      } else {
        rectShape.x -= expandSize;
        rectShape.width += expandSize * 2;
      }
    }
    if (during) {
      during(1, clipPath);
    }
    return clipPath;
  } else {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  }
}
function getEndLabelStateSpecified(endLabelModel, coordSys) {
  var baseAxis = coordSys.getBaseAxis();
  var isHorizontal = baseAxis.isHorizontal();
  var isBaseInversed = baseAxis.inverse;
  var align = isHorizontal ? isBaseInversed ? "right" : "left" : "center";
  var verticalAlign = isHorizontal ? "middle" : isBaseInversed ? "top" : "bottom";
  return {
    normal: {
      align: endLabelModel.get("align") || align,
      verticalAlign: endLabelModel.get("verticalAlign") || verticalAlign
    }
  };
}
var LineView = function(_super) {
  __extends(LineView2, _super);
  function LineView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  LineView2.prototype.init = function() {
    var lineGroup = new Group$4();
    var symbolDraw = new SymbolDraw$1();
    this.group.add(symbolDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineGroup = lineGroup;
  };
  LineView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var lineStyleModel = seriesModel.getModel("lineStyle");
    var areaStyleModel = seriesModel.getModel("areaStyle");
    var points2 = data.getLayout("points") || [];
    var isCoordSysPolar = coordSys.type === "polar";
    var prevCoordSys = this._coordSys;
    var symbolDraw = this._symbolDraw;
    var polyline = this._polyline;
    var polygon = this._polygon;
    var lineGroup = this._lineGroup;
    var hasAnimation = seriesModel.get("animation");
    var isAreaChart = !areaStyleModel.isEmpty();
    var valueOrigin = areaStyleModel.get("origin");
    var dataCoordInfo = prepareDataCoordInfo(coordSys, data, valueOrigin);
    var stackedOnPoints = isAreaChart && getStackedOnPoints(coordSys, data, dataCoordInfo);
    var showSymbol = seriesModel.get("showSymbol");
    var connectNulls = seriesModel.get("connectNulls");
    var isIgnoreFunc = showSymbol && !isCoordSysPolar && getIsIgnoreFunc(seriesModel, data, coordSys);
    var oldData = this._data;
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    if (!showSymbol) {
      symbolDraw.remove();
    }
    group.add(lineGroup);
    var step = !isCoordSysPolar ? seriesModel.get("step") : false;
    var clipShapeForSymbol;
    if (coordSys && coordSys.getArea && seriesModel.get("clip", true)) {
      clipShapeForSymbol = coordSys.getArea();
      if (clipShapeForSymbol.width != null) {
        clipShapeForSymbol.x -= 0.1;
        clipShapeForSymbol.y -= 0.1;
        clipShapeForSymbol.width += 0.2;
        clipShapeForSymbol.height += 0.2;
      } else if (clipShapeForSymbol.r0) {
        clipShapeForSymbol.r0 -= 0.5;
        clipShapeForSymbol.r += 0.5;
      }
    }
    this._clipShapeForSymbol = clipShapeForSymbol;
    var visualColor = getVisualGradient(data, coordSys, api) || data.getVisual("style")[data.getVisual("drawType")];
    if (!(polyline && prevCoordSys.type === coordSys.type && step === this._step)) {
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      hasAnimation && this._initSymbolLabelAnimation(data, coordSys, clipShapeForSymbol);
      if (step) {
        points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
        if (stackedOnPoints) {
          stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
        }
      }
      polyline = this._newPolyline(points2);
      if (isAreaChart) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
    } else {
      if (isAreaChart && !polygon) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      } else if (polygon && !isAreaChart) {
        lineGroup.remove(polygon);
        polygon = this._polygon = null;
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      var oldClipPath = lineGroup.getClipPath();
      if (oldClipPath) {
        var newClipPath = createLineClipPath(this, coordSys, false, seriesModel);
        initProps(oldClipPath, {
          shape: newClipPath.shape
        }, seriesModel);
      } else {
        lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
      }
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      if (!isPointsSame(this._stackedOnPoints, stackedOnPoints) || !isPointsSame(this._points, points2)) {
        if (hasAnimation) {
          this._doUpdateAnimation(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls);
        } else {
          if (step) {
            points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
            if (stackedOnPoints) {
              stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
            }
          }
          polyline.setShape({
            points: points2
          });
          polygon && polygon.setShape({
            points: points2,
            stackedOnPoints
          });
        }
      }
    }
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    polyline.useStyle(defaults(lineStyleModel.getLineStyle(), {
      fill: "none",
      stroke: visualColor,
      lineJoin: "bevel"
    }));
    setStatesStylesFromModel(polyline, seriesModel, "lineStyle");
    if (polyline.style.lineWidth > 0 && seriesModel.get(["emphasis", "lineStyle", "width"]) === "bolder") {
      var emphasisLineStyle = polyline.getState("emphasis").style;
      emphasisLineStyle.lineWidth = +polyline.style.lineWidth + 1;
    }
    getECData(polyline).seriesIndex = seriesModel.seriesIndex;
    toggleHoverEmphasis(polyline, focus, blurScope, emphasisDisabled);
    var smooth = getSmooth(seriesModel.get("smooth"));
    var smoothMonotone = seriesModel.get("smoothMonotone");
    polyline.setShape({
      smooth,
      smoothMonotone,
      connectNulls
    });
    if (polygon) {
      var stackedOnSeries = data.getCalculationInfo("stackedOnSeries");
      var stackedOnSmooth = 0;
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: visualColor,
        opacity: 0.7,
        lineJoin: "bevel",
        decal: data.getVisual("style").decal
      }));
      if (stackedOnSeries) {
        stackedOnSmooth = getSmooth(stackedOnSeries.get("smooth"));
      }
      polygon.setShape({
        smooth,
        stackedOnSmooth,
        smoothMonotone,
        connectNulls
      });
      setStatesStylesFromModel(polygon, seriesModel, "areaStyle");
      getECData(polygon).seriesIndex = seriesModel.seriesIndex;
      toggleHoverEmphasis(polygon, focus, blurScope, emphasisDisabled);
    }
    var changePolyState = function(toState) {
      _this._changePolyState(toState);
    };
    data.eachItemGraphicEl(function(el) {
      el && (el.onHoverStateChange = changePolyState);
    });
    this._polyline.onHoverStateChange = changePolyState;
    this._data = data;
    this._coordSys = coordSys;
    this._stackedOnPoints = stackedOnPoints;
    this._points = points2;
    this._step = step;
    this._valueOrigin = valueOrigin;
    if (seriesModel.get("triggerLineEvent")) {
      this.packEventData(seriesModel, polyline);
      polygon && this.packEventData(seriesModel, polygon);
    }
  };
  LineView2.prototype.packEventData = function(seriesModel, el) {
    getECData(el).eventData = {
      componentType: "series",
      componentSubType: "line",
      componentIndex: seriesModel.componentIndex,
      seriesIndex: seriesModel.seriesIndex,
      seriesName: seriesModel.name,
      seriesType: "line"
    };
  };
  LineView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("emphasis");
    if (!(dataIndex instanceof Array) && dataIndex != null && dataIndex >= 0) {
      var points2 = data.getLayout("points");
      var symbol = data.getItemGraphicEl(dataIndex);
      if (!symbol) {
        var x2 = points2[dataIndex * 2];
        var y2 = points2[dataIndex * 2 + 1];
        if (isNaN(x2) || isNaN(y2)) {
          return;
        }
        if (this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x2, y2)) {
          return;
        }
        var zlevel = seriesModel.get("zlevel");
        var z2 = seriesModel.get("z");
        symbol = new SymbolClz(data, dataIndex);
        symbol.x = x2;
        symbol.y = y2;
        symbol.setZ(zlevel, z2);
        var symbolLabel = symbol.getSymbolPath().getTextContent();
        if (symbolLabel) {
          symbolLabel.zlevel = zlevel;
          symbolLabel.z = z2;
          symbolLabel.z2 = this._polyline.z2 + 1;
        }
        symbol.__temp = true;
        data.setItemGraphicEl(dataIndex, symbol);
        symbol.stopSymbolAnimation(true);
        this.group.add(symbol);
      }
      symbol.highlight();
    } else {
      ChartView$1.prototype.highlight.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("normal");
    if (dataIndex != null && dataIndex >= 0) {
      var symbol = data.getItemGraphicEl(dataIndex);
      if (symbol) {
        if (symbol.__temp) {
          data.setItemGraphicEl(dataIndex, null);
          this.group.remove(symbol);
        } else {
          symbol.downplay();
        }
      }
    } else {
      ChartView$1.prototype.downplay.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype._changePolyState = function(toState) {
    var polygon = this._polygon;
    setStatesFlag(this._polyline, toState);
    polygon && setStatesFlag(polygon, toState);
  };
  LineView2.prototype._newPolyline = function(points2) {
    var polyline = this._polyline;
    if (polyline) {
      this._lineGroup.remove(polyline);
    }
    polyline = new ECPolyline({
      shape: {
        points: points2
      },
      segmentIgnoreThreshold: 2,
      z2: 10
    });
    this._lineGroup.add(polyline);
    this._polyline = polyline;
    return polyline;
  };
  LineView2.prototype._newPolygon = function(points2, stackedOnPoints) {
    var polygon = this._polygon;
    if (polygon) {
      this._lineGroup.remove(polygon);
    }
    polygon = new ECPolygon({
      shape: {
        points: points2,
        stackedOnPoints
      },
      segmentIgnoreThreshold: 2
    });
    this._lineGroup.add(polygon);
    this._polygon = polygon;
    return polygon;
  };
  LineView2.prototype._initSymbolLabelAnimation = function(data, coordSys, clipShape) {
    var isHorizontalOrRadial;
    var isCoordSysPolar;
    var baseAxis = coordSys.getBaseAxis();
    var isAxisInverse = baseAxis.inverse;
    if (coordSys.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
      isCoordSysPolar = false;
    } else if (coordSys.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
      isCoordSysPolar = true;
    }
    var seriesModel = data.hostModel;
    var seriesDuration = seriesModel.get("animationDuration");
    if (isFunction(seriesDuration)) {
      seriesDuration = seriesDuration(null);
    }
    var seriesDalay = seriesModel.get("animationDelay") || 0;
    var seriesDalayValue = isFunction(seriesDalay) ? seriesDalay(null) : seriesDalay;
    data.eachItemGraphicEl(function(symbol, idx) {
      var el = symbol;
      if (el) {
        var point = [symbol.x, symbol.y];
        var start2 = void 0;
        var end2 = void 0;
        var current = void 0;
        if (clipShape) {
          if (isCoordSysPolar) {
            var polarClip = clipShape;
            var coord = coordSys.pointToCoord(point);
            if (isHorizontalOrRadial) {
              start2 = polarClip.startAngle;
              end2 = polarClip.endAngle;
              current = -coord[1] / 180 * Math.PI;
            } else {
              start2 = polarClip.r0;
              end2 = polarClip.r;
              current = coord[0];
            }
          } else {
            var gridClip = clipShape;
            if (isHorizontalOrRadial) {
              start2 = gridClip.x;
              end2 = gridClip.x + gridClip.width;
              current = symbol.x;
            } else {
              start2 = gridClip.y + gridClip.height;
              end2 = gridClip.y;
              current = symbol.y;
            }
          }
        }
        var ratio = end2 === start2 ? 0 : (current - start2) / (end2 - start2);
        if (isAxisInverse) {
          ratio = 1 - ratio;
        }
        var delay = isFunction(seriesDalay) ? seriesDalay(idx) : seriesDuration * ratio + seriesDalayValue;
        var symbolPath = el.getSymbolPath();
        var text = symbolPath.getTextContent();
        el.attr({
          scaleX: 0,
          scaleY: 0
        });
        el.animateTo({
          scaleX: 1,
          scaleY: 1
        }, {
          duration: 200,
          setToFinal: true,
          delay
        });
        if (text) {
          text.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay
          });
        }
        symbolPath.disableLabelAnimation = true;
      }
    });
  };
  LineView2.prototype._initOrUpdateEndLabel = function(seriesModel, coordSys, inheritColor) {
    var endLabelModel = seriesModel.getModel("endLabel");
    if (anyStateShowEndLabel(seriesModel)) {
      var data_2 = seriesModel.getData();
      var polyline = this._polyline;
      var points2 = data_2.getLayout("points");
      if (!points2) {
        polyline.removeTextContent();
        this._endLabel = null;
        return;
      }
      var endLabel = this._endLabel;
      if (!endLabel) {
        endLabel = this._endLabel = new ZRText$1({
          z2: 200
        });
        endLabel.ignoreClip = true;
        polyline.setTextContent(this._endLabel);
        polyline.disableLabelAnimation = true;
      }
      var dataIndex = getLastIndexNotNull(points2);
      if (dataIndex >= 0) {
        setLabelStyle(polyline, getLabelStatesModels(seriesModel, "endLabel"), {
          inheritColor,
          labelFetcher: seriesModel,
          labelDataIndex: dataIndex,
          defaultText: function(dataIndex2, opt, interpolatedValue) {
            return interpolatedValue != null ? getDefaultInterpolatedLabel(data_2, interpolatedValue) : getDefaultLabel(data_2, dataIndex2);
          },
          enableTextSetter: true
        }, getEndLabelStateSpecified(endLabelModel, coordSys));
        polyline.textConfig.position = null;
      }
    } else if (this._endLabel) {
      this._polyline.removeTextContent();
      this._endLabel = null;
    }
  };
  LineView2.prototype._endLabelOnDuring = function(percent, clipRect, data, animationRecord, valueAnimation, endLabelModel, coordSys) {
    var endLabel = this._endLabel;
    var polyline = this._polyline;
    if (endLabel) {
      if (percent < 1 && animationRecord.originalX == null) {
        animationRecord.originalX = endLabel.x;
        animationRecord.originalY = endLabel.y;
      }
      var points2 = data.getLayout("points");
      var seriesModel = data.hostModel;
      var connectNulls = seriesModel.get("connectNulls");
      var precision = endLabelModel.get("precision");
      var distance2 = endLabelModel.get("distance") || 0;
      var baseAxis = coordSys.getBaseAxis();
      var isHorizontal = baseAxis.isHorizontal();
      var isBaseInversed = baseAxis.inverse;
      var clipShape = clipRect.shape;
      var xOrY = isBaseInversed ? isHorizontal ? clipShape.x : clipShape.y + clipShape.height : isHorizontal ? clipShape.x + clipShape.width : clipShape.y;
      var distanceX = (isHorizontal ? distance2 : 0) * (isBaseInversed ? -1 : 1);
      var distanceY = (isHorizontal ? 0 : -distance2) * (isBaseInversed ? -1 : 1);
      var dim = isHorizontal ? "x" : "y";
      var dataIndexRange = getIndexRange(points2, xOrY, dim);
      var indices = dataIndexRange.range;
      var diff = indices[1] - indices[0];
      var value = void 0;
      if (diff >= 1) {
        if (diff > 1 && !connectNulls) {
          var pt = getPointAtIndex(points2, indices[0]);
          endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          valueAnimation && (value = seriesModel.getRawValue(indices[0]));
        } else {
          var pt = polyline.getPointOn(xOrY, dim);
          pt && endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          var startValue = seriesModel.getRawValue(indices[0]);
          var endValue = seriesModel.getRawValue(indices[1]);
          valueAnimation && (value = interpolateRawValues(data, precision, startValue, endValue, dataIndexRange.t));
        }
        animationRecord.lastFrameIndex = indices[0];
      } else {
        var idx = percent === 1 || animationRecord.lastFrameIndex > 0 ? indices[0] : 0;
        var pt = getPointAtIndex(points2, idx);
        valueAnimation && (value = seriesModel.getRawValue(idx));
        endLabel.attr({
          x: pt[0] + distanceX,
          y: pt[1] + distanceY
        });
      }
      if (valueAnimation) {
        labelInner(endLabel).setLabelText(value);
      }
    }
  };
  LineView2.prototype._doUpdateAnimation = function(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls) {
    var polyline = this._polyline;
    var polygon = this._polygon;
    var seriesModel = data.hostModel;
    var diff = lineAnimationDiff(this._data, data, this._stackedOnPoints, stackedOnPoints, this._coordSys, coordSys, this._valueOrigin);
    var current = diff.current;
    var stackedOnCurrent = diff.stackedOnCurrent;
    var next = diff.next;
    var stackedOnNext = diff.stackedOnNext;
    if (step) {
      current = turnPointsIntoStep(diff.current, coordSys, step, connectNulls);
      stackedOnCurrent = turnPointsIntoStep(diff.stackedOnCurrent, coordSys, step, connectNulls);
      next = turnPointsIntoStep(diff.next, coordSys, step, connectNulls);
      stackedOnNext = turnPointsIntoStep(diff.stackedOnNext, coordSys, step, connectNulls);
    }
    if (getBoundingDiff(current, next) > 3e3 || polygon && getBoundingDiff(stackedOnCurrent, stackedOnNext) > 3e3) {
      polyline.stopAnimation();
      polyline.setShape({
        points: next
      });
      if (polygon) {
        polygon.stopAnimation();
        polygon.setShape({
          points: next,
          stackedOnPoints: stackedOnNext
        });
      }
      return;
    }
    polyline.shape.__points = diff.current;
    polyline.shape.points = current;
    var target = {
      shape: {
        points: next
      }
    };
    if (diff.current !== current) {
      target.shape.__points = diff.next;
    }
    polyline.stopAnimation();
    updateProps$1(polyline, target, seriesModel);
    if (polygon) {
      polygon.setShape({
        points: current,
        stackedOnPoints: stackedOnCurrent
      });
      polygon.stopAnimation();
      updateProps$1(polygon, {
        shape: {
          stackedOnPoints: stackedOnNext
        }
      }, seriesModel);
      if (polyline.shape.points !== polygon.shape.points) {
        polygon.shape.points = polyline.shape.points;
      }
    }
    var updatedDataInfo = [];
    var diffStatus = diff.status;
    for (var i = 0; i < diffStatus.length; i++) {
      var cmd = diffStatus[i].cmd;
      if (cmd === "=") {
        var el = data.getItemGraphicEl(diffStatus[i].idx1);
        if (el) {
          updatedDataInfo.push({
            el,
            ptIdx: i
          });
        }
      }
    }
    if (polyline.animators && polyline.animators.length) {
      polyline.animators[0].during(function() {
        polygon && polygon.dirtyShape();
        var points2 = polyline.shape.__points;
        for (var i2 = 0; i2 < updatedDataInfo.length; i2++) {
          var el2 = updatedDataInfo[i2].el;
          var offset = updatedDataInfo[i2].ptIdx * 2;
          el2.x = points2[offset];
          el2.y = points2[offset + 1];
          el2.markRedraw();
        }
      });
    }
  };
  LineView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var oldData = this._data;
    this._lineGroup.removeAll();
    this._symbolDraw.remove(true);
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
  };
  LineView2.type = "line";
  return LineView2;
}(ChartView$1);
var LineView$1 = LineView;
function pointsLayout(seriesType2, forceStoreInTypedArray) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var coordSys = seriesModel.coordinateSystem;
      var pipelineContext = seriesModel.pipelineContext;
      var useTypedArray = forceStoreInTypedArray || pipelineContext.large;
      if (!coordSys) {
        return;
      }
      var dims = map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }).slice(0, 2);
      var dimLen = dims.length;
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      if (isDimensionStacked(data, dims[0])) {
        dims[0] = stackResultDim;
      }
      if (isDimensionStacked(data, dims[1])) {
        dims[1] = stackResultDim;
      }
      var store = data.getStore();
      var dimIdx0 = data.getDimensionIndex(dims[0]);
      var dimIdx1 = data.getDimensionIndex(dims[1]);
      return dimLen && {
        progress: function(params, data2) {
          var segCount = params.end - params.start;
          var points2 = useTypedArray && createFloat32Array(segCount * dimLen);
          var tmpIn = [];
          var tmpOut = [];
          for (var i = params.start, offset = 0; i < params.end; i++) {
            var point = void 0;
            if (dimLen === 1) {
              var x2 = store.get(dimIdx0, i);
              point = coordSys.dataToPoint(x2, null, tmpOut);
            } else {
              tmpIn[0] = store.get(dimIdx0, i);
              tmpIn[1] = store.get(dimIdx1, i);
              point = coordSys.dataToPoint(tmpIn, null, tmpOut);
            }
            if (useTypedArray) {
              points2[offset++] = point[0];
              points2[offset++] = point[1];
            } else {
              data2.setItemLayout(i, point.slice());
            }
          }
          useTypedArray && data2.setLayout("points", points2);
        }
      };
    }
  };
}
var samplers = {
  average: function(frame) {
    var sum2 = 0;
    var count2 = 0;
    for (var i = 0; i < frame.length; i++) {
      if (!isNaN(frame[i])) {
        sum2 += frame[i];
        count2++;
      }
    }
    return count2 === 0 ? NaN : sum2 / count2;
  },
  sum: function(frame) {
    var sum2 = 0;
    for (var i = 0; i < frame.length; i++) {
      sum2 += frame[i] || 0;
    }
    return sum2;
  },
  max: function(frame) {
    var max3 = -Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] > max3 && (max3 = frame[i]);
    }
    return isFinite(max3) ? max3 : NaN;
  },
  min: function(frame) {
    var min3 = Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] < min3 && (min3 = frame[i]);
    }
    return isFinite(min3) ? min3 : NaN;
  },
  nearest: function(frame) {
    return frame[0];
  }
};
var indexSampler = function(frame) {
  return Math.round(frame.length / 2);
};
function dataSample(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel, api) {
      var data = seriesModel.getData();
      var sampling = seriesModel.get("sampling");
      var coordSys = seriesModel.coordinateSystem;
      var count2 = data.count();
      if (count2 > 10 && coordSys.type === "cartesian2d" && sampling) {
        var baseAxis = coordSys.getBaseAxis();
        var valueAxis2 = coordSys.getOtherAxis(baseAxis);
        var extent3 = baseAxis.getExtent();
        var dpr2 = api.getDevicePixelRatio();
        var size = Math.abs(extent3[1] - extent3[0]) * (dpr2 || 1);
        var rate = Math.round(count2 / size);
        if (isFinite(rate) && rate > 1) {
          if (sampling === "lttb") {
            seriesModel.setData(data.lttbDownSample(data.mapDimension(valueAxis2.dim), 1 / rate));
          }
          var sampler = void 0;
          if (isString(sampling)) {
            sampler = samplers[sampling];
          } else if (isFunction(sampling)) {
            sampler = sampling;
          }
          if (sampler) {
            seriesModel.setData(data.downSample(data.mapDimension(valueAxis2.dim), 1 / rate, sampler, indexSampler));
          }
        }
      }
    }
  };
}
function install$Q(registers) {
  registers.registerChartView(LineView$1);
  registers.registerSeriesModel(LineSeries);
  registers.registerLayout(pointsLayout("line", true));
  registers.registerVisual({
    seriesType: "line",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var lineStyle = seriesModel.getModel("lineStyle").getLineStyle();
      if (lineStyle && !lineStyle.stroke) {
        lineStyle.stroke = data.getVisual("style").fill;
      }
      data.setVisual("legendLineStyle", lineStyle);
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("line"));
}
var BaseBarSeriesModel = function(_super) {
  __extends(BaseBarSeriesModel2, _super);
  function BaseBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BaseBarSeriesModel2.type;
    return _this;
  }
  BaseBarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  BaseBarSeriesModel2.prototype.getMarkerPosition = function(value) {
    var coordSys = this.coordinateSystem;
    if (coordSys && coordSys.clampData) {
      var pt = coordSys.dataToPoint(coordSys.clampData(value));
      var data = this.getData();
      var offset = data.getLayout("offset");
      var size = data.getLayout("size");
      var offsetIndex = coordSys.getBaseAxis().isHorizontal() ? 0 : 1;
      pt[offsetIndex] += offset + size / 2;
      return pt;
    }
    return [NaN, NaN];
  };
  BaseBarSeriesModel2.type = "series.__base_bar__";
  BaseBarSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    barMinHeight: 0,
    barMinAngle: 0,
    large: false,
    largeThreshold: 400,
    progressive: 3e3,
    progressiveChunkMode: "mod"
  };
  return BaseBarSeriesModel2;
}(SeriesModel$1);
SeriesModel$1.registerClass(BaseBarSeriesModel);
var BaseBarSeriesModel$1 = BaseBarSeriesModel;
var BarSeriesModel = function(_super) {
  __extends(BarSeriesModel2, _super);
  function BarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BarSeriesModel2.type;
    return _this;
  }
  BarSeriesModel2.prototype.getInitialData = function() {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true,
      createInvertedIndices: !!this.get("realtimeSort", true) || null
    });
  };
  BarSeriesModel2.prototype.getProgressive = function() {
    return this.get("large") ? this.get("progressive") : false;
  };
  BarSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.get("progressiveThreshold");
    var largeThreshold = this.get("largeThreshold");
    if (largeThreshold > progressiveThreshold) {
      progressiveThreshold = largeThreshold;
    }
    return progressiveThreshold;
  };
  BarSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.rect(data.getItemLayout(dataIndex));
  };
  BarSeriesModel2.type = "series.bar";
  BarSeriesModel2.dependencies = ["grid", "polar"];
  BarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    clip: true,
    roundCap: false,
    showBackground: false,
    backgroundStyle: {
      color: "rgba(180, 180, 180, 0.2)",
      borderColor: null,
      borderWidth: 0,
      borderType: "solid",
      borderRadius: 0,
      shadowBlur: 0,
      shadowColor: null,
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    realtimeSort: false
  });
  return BarSeriesModel2;
}(BaseBarSeriesModel$1);
var BarSeries = BarSeriesModel;
var SausageShape = function() {
  function SausageShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return SausageShape2;
}();
var SausagePath = function(_super) {
  __extends(SausagePath2, _super);
  function SausagePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "sausage";
    return _this;
  }
  SausagePath2.prototype.getDefaultShape = function() {
    return new SausageShape();
  };
  SausagePath2.prototype.buildPath = function(ctx, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var r0 = Math.max(shape.r0 || 0, 0);
    var r2 = Math.max(shape.r, 0);
    var dr = (r2 - r0) * 0.5;
    var rCenter = r0 + dr;
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var PI22 = Math.PI * 2;
    var lessThanCircle = clockwise ? endAngle - startAngle < PI22 : startAngle - endAngle < PI22;
    if (!lessThanCircle) {
      startAngle = endAngle - (clockwise ? PI22 : -PI22);
    }
    var unitStartX = Math.cos(startAngle);
    var unitStartY = Math.sin(startAngle);
    var unitEndX = Math.cos(endAngle);
    var unitEndY = Math.sin(endAngle);
    if (lessThanCircle) {
      ctx.moveTo(unitStartX * r0 + cx, unitStartY * r0 + cy);
      ctx.arc(unitStartX * rCenter + cx, unitStartY * rCenter + cy, dr, -Math.PI + startAngle, startAngle, !clockwise);
    } else {
      ctx.moveTo(unitStartX * r2 + cx, unitStartY * r2 + cy);
    }
    ctx.arc(cx, cy, r2, startAngle, endAngle, !clockwise);
    ctx.arc(unitEndX * rCenter + cx, unitEndY * rCenter + cy, dr, endAngle - Math.PI * 2, endAngle - Math.PI, !clockwise);
    if (r0 !== 0) {
      ctx.arc(cx, cy, r0, endAngle, startAngle, clockwise);
    }
  };
  return SausagePath2;
}(Path$1);
var Sausage = SausagePath;
function createSectorCalculateTextPosition(positionMapping, opts) {
  opts = opts || {};
  var isRoundCap = opts.isRoundCap;
  return function(out2, opts2, boundingRect) {
    var textPosition = opts2.position;
    if (!textPosition || textPosition instanceof Array) {
      return calculateTextPosition(out2, opts2, boundingRect);
    }
    var mappedSectorPosition = positionMapping(textPosition);
    var distance2 = opts2.distance != null ? opts2.distance : 5;
    var sector = this.shape;
    var cx = sector.cx;
    var cy = sector.cy;
    var r2 = sector.r;
    var r0 = sector.r0;
    var middleR = (r2 + r0) / 2;
    var startAngle = sector.startAngle;
    var endAngle = sector.endAngle;
    var middleAngle = (startAngle + endAngle) / 2;
    var extraDist = isRoundCap ? Math.abs(r2 - r0) / 2 : 0;
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var x2 = cx + r2 * mathCos2(startAngle);
    var y2 = cy + r2 * mathSin2(startAngle);
    var textAlign = "left";
    var textVerticalAlign = "top";
    switch (mappedSectorPosition) {
      case "startArc":
        x2 = cx + (r0 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "insideStartArc":
        x2 = cx + (r0 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "startAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, distance2 + extraDist, false);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideStartAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, -distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, -distance2 + extraDist, false);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "middle":
        x2 = cx + middleR * mathCos2(middleAngle);
        y2 = cy + middleR * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "endArc":
        x2 = cx + (r2 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideEndArc":
        x2 = cx + (r2 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "endAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, distance2 + extraDist, true);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "insideEndAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, -distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, -distance2 + extraDist, true);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      default:
        return calculateTextPosition(out2, opts2, boundingRect);
    }
    out2 = out2 || {};
    out2.x = x2;
    out2.y = y2;
    out2.align = textAlign;
    out2.verticalAlign = textVerticalAlign;
    return out2;
  };
}
function setSectorTextRotation(sector, textPosition, positionMapping, rotateType) {
  if (isNumber(rotateType)) {
    sector.setTextConfig({
      rotation: rotateType
    });
    return;
  } else if (isArray$1(textPosition)) {
    sector.setTextConfig({
      rotation: 0
    });
    return;
  }
  var shape = sector.shape;
  var startAngle = shape.clockwise ? shape.startAngle : shape.endAngle;
  var endAngle = shape.clockwise ? shape.endAngle : shape.startAngle;
  var middleAngle = (startAngle + endAngle) / 2;
  var anchorAngle;
  var mappedSectorPosition = positionMapping(textPosition);
  switch (mappedSectorPosition) {
    case "startArc":
    case "insideStartArc":
    case "middle":
    case "insideEndArc":
    case "endArc":
      anchorAngle = middleAngle;
      break;
    case "startAngle":
    case "insideStartAngle":
      anchorAngle = startAngle;
      break;
    case "endAngle":
    case "insideEndAngle":
      anchorAngle = endAngle;
      break;
    default:
      sector.setTextConfig({
        rotation: 0
      });
      return;
  }
  var rotate2 = Math.PI * 1.5 - anchorAngle;
  if (mappedSectorPosition === "middle" && rotate2 > Math.PI / 2 && rotate2 < Math.PI * 1.5) {
    rotate2 -= Math.PI;
  }
  sector.setTextConfig({
    rotation: rotate2
  });
}
function adjustAngleDistanceX(angle, distance2, isEnd) {
  return distance2 * Math.sin(angle) * (isEnd ? -1 : 1);
}
function adjustAngleDistanceY(angle, distance2, isEnd) {
  return distance2 * Math.cos(angle) * (isEnd ? 1 : -1);
}
var mathMax$4 = Math.max;
var mathMin$4 = Math.min;
function getClipArea(coord, data) {
  var coordSysClipArea = coord.getArea && coord.getArea();
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var baseAxis = coord.getBaseAxis();
    if (baseAxis.type !== "category" || !baseAxis.onBand) {
      var expandWidth = data.getLayout("bandWidth");
      if (baseAxis.isHorizontal()) {
        coordSysClipArea.x -= expandWidth;
        coordSysClipArea.width += expandWidth * 2;
      } else {
        coordSysClipArea.y -= expandWidth;
        coordSysClipArea.height += expandWidth * 2;
      }
    }
  }
  return coordSysClipArea;
}
var BarView = function(_super) {
  __extends(BarView2, _super);
  function BarView2() {
    var _this = _super.call(this) || this;
    _this.type = BarView2.type;
    _this._isFirstFrame = true;
    return _this;
  }
  BarView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._model = seriesModel;
    this._removeOnRenderedListener(api);
    this._updateDrawMode(seriesModel);
    var coordinateSystemType = seriesModel.get("coordinateSystem");
    if (coordinateSystemType === "cartesian2d" || coordinateSystemType === "polar") {
      this._progressiveEls = null;
      this._isLargeDraw ? this._renderLarge(seriesModel, ecModel, api) : this._renderNormal(seriesModel, ecModel, api, payload);
    }
  };
  BarView2.prototype.incrementalPrepareRender = function(seriesModel) {
    this._clear();
    this._updateDrawMode(seriesModel);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype.incrementalRender = function(params, seriesModel) {
    this._progressiveEls = [];
    this._incrementalRenderLarge(params, seriesModel);
  };
  BarView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  BarView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  BarView2.prototype._renderNormal = function(seriesModel, ecModel, api, payload) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coord = seriesModel.coordinateSystem;
    var baseAxis = coord.getBaseAxis();
    var isHorizontalOrRadial;
    if (coord.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
    } else if (coord.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
    }
    var animationModel = seriesModel.isAnimationEnabled() ? seriesModel : null;
    var realtimeSortCfg = shouldRealtimeSort(seriesModel, coord);
    if (realtimeSortCfg) {
      this._enableRealtimeSort(realtimeSortCfg, data, api);
    }
    var needsClip = seriesModel.get("clip", true) || realtimeSortCfg;
    var coordSysClipArea = getClipArea(coord, data);
    group.removeClipPath();
    var roundCap = seriesModel.get("roundCap", true);
    var drawBackground = seriesModel.get("showBackground", true);
    var backgroundModel = seriesModel.getModel("backgroundStyle");
    var barBorderRadius = backgroundModel.get("borderRadius") || 0;
    var bgEls = [];
    var oldBgEls = this._backgroundEls;
    var isInitSort = payload && payload.isInitSort;
    var isChangeOrder = payload && payload.type === "changeAxisOrder";
    function createBackground(dataIndex) {
      var bgLayout = getLayout[coord.type](data, dataIndex);
      var bgEl = createBackgroundEl(coord, isHorizontalOrRadial, bgLayout);
      bgEl.useStyle(backgroundModel.getItemStyle());
      if (coord.type === "cartesian2d") {
        bgEl.setShape("r", barBorderRadius);
      }
      bgEls[dataIndex] = bgEl;
      return bgEl;
    }
    data.diff(oldData).add(function(dataIndex) {
      var itemModel = data.getItemModel(dataIndex);
      var layout2 = getLayout[coord.type](data, dataIndex, itemModel);
      if (drawBackground) {
        createBackground(dataIndex);
      }
      if (!data.hasValue(dataIndex) || !isValidLayout[coord.type](layout2)) {
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
      }
      var el = elementCreator[coord.type](seriesModel, data, dataIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, false, roundCap);
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, dataIndex, isHorizontalOrRadial, false, false);
      } else {
        initProps(el, {
          shape: layout2
        }, seriesModel, dataIndex);
      }
      data.setItemGraphicEl(dataIndex, el);
      group.add(el);
      el.ignore = isClipped;
    }).update(function(newIndex, oldIndex) {
      var itemModel = data.getItemModel(newIndex);
      var layout2 = getLayout[coord.type](data, newIndex, itemModel);
      if (drawBackground) {
        var bgEl = void 0;
        if (oldBgEls.length === 0) {
          bgEl = createBackground(oldIndex);
        } else {
          bgEl = oldBgEls[oldIndex];
          bgEl.useStyle(backgroundModel.getItemStyle());
          if (coord.type === "cartesian2d") {
            bgEl.setShape("r", barBorderRadius);
          }
          bgEls[newIndex] = bgEl;
        }
        var bgLayout = getLayout[coord.type](data, newIndex);
        var shape = createBackgroundShape(isHorizontalOrRadial, bgLayout, coord);
        updateProps$1(bgEl, {
          shape
        }, animationModel, newIndex);
      }
      var el = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex) || !isValidLayout[coord.type](layout2)) {
        group.remove(el);
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
        if (isClipped) {
          group.remove(el);
        }
      }
      if (!el) {
        el = elementCreator[coord.type](seriesModel, data, newIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, !!el, roundCap);
      } else {
        saveOldStyle(el);
      }
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      if (isChangeOrder) {
        var textEl = el.getTextContent();
        if (textEl) {
          var labelInnerStore = labelInner(textEl);
          if (labelInnerStore.prevValue != null) {
            labelInnerStore.prevValue = labelInnerStore.value;
          }
        }
      } else {
        updateStyle(el, data, newIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      }
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, newIndex, isHorizontalOrRadial, true, isChangeOrder);
      } else {
        updateProps$1(el, {
          shape: layout2
        }, seriesModel, newIndex, null);
      }
      data.setItemGraphicEl(newIndex, el);
      el.ignore = isClipped;
      group.add(el);
    }).remove(function(dataIndex) {
      var el = oldData.getItemGraphicEl(dataIndex);
      el && removeElementWithFadeOut(el, seriesModel, dataIndex);
    }).execute();
    var bgGroup = this._backgroundGroup || (this._backgroundGroup = new Group$4());
    bgGroup.removeAll();
    for (var i = 0; i < bgEls.length; ++i) {
      bgGroup.add(bgEls[i]);
    }
    group.add(bgGroup);
    this._backgroundEls = bgEls;
    this._data = data;
  };
  BarView2.prototype._renderLarge = function(seriesModel, ecModel, api) {
    this._clear();
    createLarge$1(seriesModel, this.group);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    this._removeBackground();
    createLarge$1(seriesModel, this.group, this._progressiveEls, true);
  };
  BarView2.prototype._updateLargeClip = function(seriesModel) {
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    var group = this.group;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
  };
  BarView2.prototype._enableRealtimeSort = function(realtimeSortCfg, data, api) {
    var _this = this;
    if (!data.count()) {
      return;
    }
    var baseAxis = realtimeSortCfg.baseAxis;
    if (this._isFirstFrame) {
      this._dispatchInitSort(data, realtimeSortCfg, api);
      this._isFirstFrame = false;
    } else {
      var orderMapping_1 = function(idx) {
        var el = data.getItemGraphicEl(idx);
        var shape = el && el.shape;
        return shape && Math.abs(baseAxis.isHorizontal() ? shape.height : shape.width) || 0;
      };
      this._onRendered = function() {
        _this._updateSortWithinSameData(data, orderMapping_1, baseAxis, api);
      };
      api.getZr().on("rendered", this._onRendered);
    }
  };
  BarView2.prototype._dataSort = function(data, baseAxis, orderMapping) {
    var info = [];
    data.each(data.mapDimension(baseAxis.dim), function(ordinalNumber, dataIdx) {
      var mappedValue = orderMapping(dataIdx);
      mappedValue = mappedValue == null ? NaN : mappedValue;
      info.push({
        dataIndex: dataIdx,
        mappedValue,
        ordinalNumber
      });
    });
    info.sort(function(a, b2) {
      return b2.mappedValue - a.mappedValue;
    });
    return {
      ordinalNumbers: map$1(info, function(item) {
        return item.ordinalNumber;
      })
    };
  };
  BarView2.prototype._isOrderChangedWithinSameData = function(data, orderMapping, baseAxis) {
    var scale2 = baseAxis.scale;
    var ordinalDataDim = data.mapDimension(baseAxis.dim);
    var lastValue = Number.MAX_VALUE;
    for (var tickNum = 0, len2 = scale2.getOrdinalMeta().categories.length; tickNum < len2; ++tickNum) {
      var rawIdx = data.rawIndexOf(ordinalDataDim, scale2.getRawOrdinalNumber(tickNum));
      var value = rawIdx < 0 ? Number.MIN_VALUE : orderMapping(data.indexOfRawIndex(rawIdx));
      if (value > lastValue) {
        return true;
      }
      lastValue = value;
    }
    return false;
  };
  BarView2.prototype._isOrderDifferentInView = function(orderInfo, baseAxis) {
    var scale2 = baseAxis.scale;
    var extent3 = scale2.getExtent();
    var tickNum = Math.max(0, extent3[0]);
    var tickMax = Math.min(extent3[1], scale2.getOrdinalMeta().categories.length - 1);
    for (; tickNum <= tickMax; ++tickNum) {
      if (orderInfo.ordinalNumbers[tickNum] !== scale2.getRawOrdinalNumber(tickNum)) {
        return true;
      }
    }
  };
  BarView2.prototype._updateSortWithinSameData = function(data, orderMapping, baseAxis, api) {
    if (!this._isOrderChangedWithinSameData(data, orderMapping, baseAxis)) {
      return;
    }
    var sortInfo = this._dataSort(data, baseAxis, orderMapping);
    if (this._isOrderDifferentInView(sortInfo, baseAxis)) {
      this._removeOnRenderedListener(api);
      api.dispatchAction({
        type: "changeAxisOrder",
        componentType: baseAxis.dim + "Axis",
        axisId: baseAxis.index,
        sortInfo
      });
    }
  };
  BarView2.prototype._dispatchInitSort = function(data, realtimeSortCfg, api) {
    var baseAxis = realtimeSortCfg.baseAxis;
    var sortResult = this._dataSort(data, baseAxis, function(dataIdx) {
      return data.get(data.mapDimension(realtimeSortCfg.otherAxis.dim), dataIdx);
    });
    api.dispatchAction({
      type: "changeAxisOrder",
      componentType: baseAxis.dim + "Axis",
      isInitSort: true,
      axisId: baseAxis.index,
      sortInfo: sortResult
    });
  };
  BarView2.prototype.remove = function(ecModel, api) {
    this._clear(this._model);
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype.dispose = function(ecModel, api) {
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype._removeOnRenderedListener = function(api) {
    if (this._onRendered) {
      api.getZr().off("rendered", this._onRendered);
      this._onRendered = null;
    }
  };
  BarView2.prototype._clear = function(model) {
    var group = this.group;
    var data = this._data;
    if (model && model.isAnimationEnabled() && data && !this._isLargeDraw) {
      this._removeBackground();
      this._backgroundEls = [];
      data.eachItemGraphicEl(function(el) {
        removeElementWithFadeOut(el, model, getECData(el).dataIndex);
      });
    } else {
      group.removeAll();
    }
    this._data = null;
    this._isFirstFrame = true;
  };
  BarView2.prototype._removeBackground = function() {
    this.group.remove(this._backgroundGroup);
    this._backgroundGroup = null;
  };
  BarView2.type = "bar";
  return BarView2;
}(ChartView$1);
var clip = {
  cartesian2d: function(coordSysBoundingRect, layout2) {
    var signWidth = layout2.width < 0 ? -1 : 1;
    var signHeight = layout2.height < 0 ? -1 : 1;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    var coordSysX2 = coordSysBoundingRect.x + coordSysBoundingRect.width;
    var coordSysY2 = coordSysBoundingRect.y + coordSysBoundingRect.height;
    var x2 = mathMax$4(layout2.x, coordSysBoundingRect.x);
    var x22 = mathMin$4(layout2.x + layout2.width, coordSysX2);
    var y2 = mathMax$4(layout2.y, coordSysBoundingRect.y);
    var y22 = mathMin$4(layout2.y + layout2.height, coordSysY2);
    var xClipped = x22 < x2;
    var yClipped = y22 < y2;
    layout2.x = xClipped && x2 > coordSysX2 ? x22 : x2;
    layout2.y = yClipped && y2 > coordSysY2 ? y22 : y2;
    layout2.width = xClipped ? 0 : x22 - x2;
    layout2.height = yClipped ? 0 : y22 - y2;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    return xClipped || yClipped;
  },
  polar: function(coordSysClipArea, layout2) {
    var signR = layout2.r0 <= layout2.r ? 1 : -1;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    var r2 = mathMin$4(layout2.r, coordSysClipArea.r);
    var r0 = mathMax$4(layout2.r0, coordSysClipArea.r0);
    layout2.r = r2;
    layout2.r0 = r0;
    var clipped = r2 - r0 < 0;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    return clipped;
  }
};
var elementCreator = {
  cartesian2d: function(seriesModel, data, newIndex, layout2, isHorizontal, animationModel, axisModel, isUpdate, roundCap) {
    var rect = new Rect$3({
      shape: extend({}, layout2),
      z2: 1
    });
    rect.__dataIndex = newIndex;
    rect.name = "item";
    if (animationModel) {
      var rectShape = rect.shape;
      var animateProperty = isHorizontal ? "height" : "width";
      rectShape[animateProperty] = 0;
    }
    return rect;
  },
  polar: function(seriesModel, data, newIndex, layout2, isRadial, animationModel, axisModel, isUpdate, roundCap) {
    var ShapeClass = !isRadial && roundCap ? Sausage : Sector$1;
    var sector = new ShapeClass({
      shape: layout2,
      z2: 1
    });
    sector.name = "item";
    var positionMap = createPolarPositionMapping(isRadial);
    sector.calculateTextPosition = createSectorCalculateTextPosition(positionMap, {
      isRoundCap: ShapeClass === Sausage
    });
    if (animationModel) {
      var sectorShape = sector.shape;
      var animateProperty = isRadial ? "r" : "endAngle";
      var animateTarget = {};
      sectorShape[animateProperty] = isRadial ? 0 : layout2.startAngle;
      animateTarget[animateProperty] = layout2[animateProperty];
      (isUpdate ? updateProps$1 : initProps)(sector, {
        shape: animateTarget
      }, animationModel);
    }
    return sector;
  }
};
function shouldRealtimeSort(seriesModel, coordSys) {
  var realtimeSortOption = seriesModel.get("realtimeSort", true);
  var baseAxis = coordSys.getBaseAxis();
  if (realtimeSortOption && baseAxis.type === "category" && coordSys.type === "cartesian2d") {
    return {
      baseAxis,
      otherAxis: coordSys.getOtherAxis(baseAxis)
    };
  }
}
function updateRealtimeAnimation(realtimeSortCfg, seriesAnimationModel, el, layout2, newIndex, isHorizontal, isUpdate, isChangeOrder) {
  var seriesTarget;
  var axisTarget;
  if (isHorizontal) {
    axisTarget = {
      x: layout2.x,
      width: layout2.width
    };
    seriesTarget = {
      y: layout2.y,
      height: layout2.height
    };
  } else {
    axisTarget = {
      y: layout2.y,
      height: layout2.height
    };
    seriesTarget = {
      x: layout2.x,
      width: layout2.width
    };
  }
  if (!isChangeOrder) {
    (isUpdate ? updateProps$1 : initProps)(el, {
      shape: seriesTarget
    }, seriesAnimationModel, newIndex, null);
  }
  var axisAnimationModel = seriesAnimationModel ? realtimeSortCfg.baseAxis.model : null;
  (isUpdate ? updateProps$1 : initProps)(el, {
    shape: axisTarget
  }, axisAnimationModel, newIndex);
}
function checkPropertiesNotValid(obj, props) {
  for (var i = 0; i < props.length; i++) {
    if (!isFinite(obj[props[i]])) {
      return true;
    }
  }
  return false;
}
var rectPropties = ["x", "y", "width", "height"];
var polarPropties = ["cx", "cy", "r", "startAngle", "endAngle"];
var isValidLayout = {
  cartesian2d: function(layout2) {
    return !checkPropertiesNotValid(layout2, rectPropties);
  },
  polar: function(layout2) {
    return !checkPropertiesNotValid(layout2, polarPropties);
  }
};
var getLayout = {
  cartesian2d: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    var fixedLineWidth = itemModel ? getLineWidth(itemModel, layout2) : 0;
    var signX = layout2.width > 0 ? 1 : -1;
    var signY = layout2.height > 0 ? 1 : -1;
    return {
      x: layout2.x + signX * fixedLineWidth / 2,
      y: layout2.y + signY * fixedLineWidth / 2,
      width: layout2.width - signX * fixedLineWidth,
      height: layout2.height - signY * fixedLineWidth
    };
  },
  polar: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    return {
      cx: layout2.cx,
      cy: layout2.cy,
      r0: layout2.r0,
      r: layout2.r,
      startAngle: layout2.startAngle,
      endAngle: layout2.endAngle,
      clockwise: layout2.clockwise
    };
  }
};
function isZeroOnPolar(layout2) {
  return layout2.startAngle != null && layout2.endAngle != null && layout2.startAngle === layout2.endAngle;
}
function createPolarPositionMapping(isRadial) {
  return function(isRadial2) {
    var arcOrAngle = isRadial2 ? "Arc" : "Angle";
    return function(position2) {
      switch (position2) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return position2 + arcOrAngle;
        default:
          return position2;
      }
    };
  }(isRadial);
}
function updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, isPolar) {
  var style = data.getItemVisual(dataIndex, "style");
  if (!isPolar) {
    el.setShape("r", itemModel.get(["itemStyle", "borderRadius"]) || 0);
  }
  el.useStyle(style);
  var cursorStyle = itemModel.getShallow("cursor");
  cursorStyle && el.attr("cursor", cursorStyle);
  var labelPositionOutside = isPolar ? isHorizontalOrRadial ? layout2.r >= layout2.r0 ? "endArc" : "startArc" : layout2.endAngle >= layout2.startAngle ? "endAngle" : "startAngle" : isHorizontalOrRadial ? layout2.height >= 0 ? "bottom" : "top" : layout2.width >= 0 ? "right" : "left";
  var labelStatesModels = getLabelStatesModels(itemModel);
  setLabelStyle(el, labelStatesModels, {
    labelFetcher: seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(seriesModel.getData(), dataIndex),
    inheritColor: style.fill,
    defaultOpacity: style.opacity,
    defaultOutsidePosition: labelPositionOutside
  });
  var label = el.getTextContent();
  if (isPolar && label) {
    var position2 = itemModel.get(["label", "position"]);
    el.textConfig.inside = position2 === "middle" ? true : null;
    setSectorTextRotation(el, position2 === "outside" ? labelPositionOutside : position2, createPolarPositionMapping(isHorizontalOrRadial), itemModel.get(["label", "rotate"]));
  }
  setLabelValueAnimation(label, labelStatesModels, seriesModel.getRawValue(dataIndex), function(value) {
    return getDefaultInterpolatedLabel(data, value);
  });
  var emphasisModel = itemModel.getModel(["emphasis"]);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  setStatesStylesFromModel(el, itemModel);
  if (isZeroOnPolar(layout2)) {
    el.style.fill = "none";
    el.style.stroke = "none";
    each$f(el.states, function(state) {
      if (state.style) {
        state.style.fill = state.style.stroke = "none";
      }
    });
  }
}
function getLineWidth(itemModel, rawLayout) {
  var borderColor = itemModel.get(["itemStyle", "borderColor"]);
  if (!borderColor || borderColor === "none") {
    return 0;
  }
  var lineWidth = itemModel.get(["itemStyle", "borderWidth"]) || 0;
  var width = isNaN(rawLayout.width) ? Number.MAX_VALUE : Math.abs(rawLayout.width);
  var height = isNaN(rawLayout.height) ? Number.MAX_VALUE : Math.abs(rawLayout.height);
  return Math.min(lineWidth, width, height);
}
var LagePathShape = function() {
  function LagePathShape2() {
  }
  return LagePathShape2;
}();
var LargePath = function(_super) {
  __extends(LargePath2, _super);
  function LargePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeBar";
    return _this;
  }
  LargePath2.prototype.getDefaultShape = function() {
    return new LagePathShape();
  };
  LargePath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var baseDimIdx = this.baseDimIdx;
    var valueDimIdx = 1 - this.baseDimIdx;
    var startPoint = [];
    var size = [];
    var barWidth = this.barWidth;
    for (var i = 0; i < points2.length; i += 3) {
      size[baseDimIdx] = barWidth;
      size[valueDimIdx] = points2[i + 2];
      startPoint[baseDimIdx] = points2[i + baseDimIdx];
      startPoint[valueDimIdx] = points2[i + valueDimIdx];
      ctx.rect(startPoint[0], startPoint[1], size[0], size[1]);
    }
  };
  return LargePath2;
}(Path$1);
function createLarge$1(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var baseDimIdx = data.getLayout("valueAxisHorizontal") ? 1 : 0;
  var largeDataIndices = data.getLayout("largeDataIndices");
  var barWidth = data.getLayout("size");
  var backgroundModel = seriesModel.getModel("backgroundStyle");
  var bgPoints = data.getLayout("largeBackgroundPoints");
  if (bgPoints) {
    var bgEl = new LargePath({
      shape: {
        points: bgPoints
      },
      incremental: !!incremental,
      silent: true,
      z2: 0
    });
    bgEl.baseDimIdx = baseDimIdx;
    bgEl.largeDataIndices = largeDataIndices;
    bgEl.barWidth = barWidth;
    bgEl.useStyle(backgroundModel.getItemStyle());
    group.add(bgEl);
    progressiveEls && progressiveEls.push(bgEl);
  }
  var el = new LargePath({
    shape: {
      points: data.getLayout("largePoints")
    },
    incremental: !!incremental,
    z2: 1
  });
  el.baseDimIdx = baseDimIdx;
  el.largeDataIndices = largeDataIndices;
  el.barWidth = barWidth;
  group.add(el);
  el.useStyle(data.getVisual("style"));
  getECData(el).seriesIndex = seriesModel.seriesIndex;
  if (!seriesModel.get("silent")) {
    el.on("mousedown", largePathUpdateDataIndex);
    el.on("mousemove", largePathUpdateDataIndex);
  }
  progressiveEls && progressiveEls.push(el);
}
var largePathUpdateDataIndex = throttle(function(event) {
  var largePath = this;
  var dataIndex = largePathFindDataIndex(largePath, event.offsetX, event.offsetY);
  getECData(largePath).dataIndex = dataIndex >= 0 ? dataIndex : null;
}, 30, false);
function largePathFindDataIndex(largePath, x2, y2) {
  var baseDimIdx = largePath.baseDimIdx;
  var valueDimIdx = 1 - baseDimIdx;
  var points2 = largePath.shape.points;
  var largeDataIndices = largePath.largeDataIndices;
  var startPoint = [];
  var size = [];
  var barWidth = largePath.barWidth;
  for (var i = 0, len2 = points2.length / 3; i < len2; i++) {
    var ii = i * 3;
    size[baseDimIdx] = barWidth;
    size[valueDimIdx] = points2[ii + 2];
    startPoint[baseDimIdx] = points2[ii + baseDimIdx];
    startPoint[valueDimIdx] = points2[ii + valueDimIdx];
    if (size[valueDimIdx] < 0) {
      startPoint[valueDimIdx] += size[valueDimIdx];
      size[valueDimIdx] = -size[valueDimIdx];
    }
    if (x2 >= startPoint[0] && x2 <= startPoint[0] + size[0] && y2 >= startPoint[1] && y2 <= startPoint[1] + size[1]) {
      return largeDataIndices[i];
    }
  }
  return -1;
}
function createBackgroundShape(isHorizontalOrRadial, layout2, coord) {
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var rectShape = layout2;
    var coordLayout = coord.getArea();
    return {
      x: isHorizontalOrRadial ? rectShape.x : coordLayout.x,
      y: isHorizontalOrRadial ? coordLayout.y : rectShape.y,
      width: isHorizontalOrRadial ? rectShape.width : coordLayout.width,
      height: isHorizontalOrRadial ? coordLayout.height : rectShape.height
    };
  } else {
    var coordLayout = coord.getArea();
    var sectorShape = layout2;
    return {
      cx: coordLayout.cx,
      cy: coordLayout.cy,
      r0: isHorizontalOrRadial ? coordLayout.r0 : sectorShape.r0,
      r: isHorizontalOrRadial ? coordLayout.r : sectorShape.r,
      startAngle: isHorizontalOrRadial ? sectorShape.startAngle : 0,
      endAngle: isHorizontalOrRadial ? sectorShape.endAngle : Math.PI * 2
    };
  }
}
function createBackgroundEl(coord, isHorizontalOrRadial, layout2) {
  var ElementClz = coord.type === "polar" ? Sector$1 : Rect$3;
  return new ElementClz({
    shape: createBackgroundShape(isHorizontalOrRadial, layout2, coord),
    silent: true,
    z2: 0
  });
}
var BarView$1 = BarView;
function install$P(registers) {
  registers.registerChartView(BarView$1);
  registers.registerSeriesModel(BarSeries);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "bar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("bar"));
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("bar"));
  registers.registerAction({
    type: "changeAxisOrder",
    event: "changeAxisOrder",
    update: "update"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      if (payload.sortInfo) {
        componentModel.axis.setCategorySortInfo(payload.sortInfo);
      }
    });
  });
}
var PI2$1 = Math.PI * 2;
var RADIAN$2 = Math.PI / 180;
function getViewRect$5(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getBasicPieLayout(seriesModel, api) {
  var viewRect2 = getViewRect$5(seriesModel, api);
  var center2 = seriesModel.get("center");
  var radius = seriesModel.get("radius");
  if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  if (!isArray$1(center2)) {
    center2 = [center2, center2];
  }
  var width = parsePercent(viewRect2.width, api.getWidth());
  var height = parsePercent(viewRect2.height, api.getHeight());
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], width) + viewRect2.x;
  var cy = parsePercent(center2[1], height) + viewRect2.y;
  var r0 = parsePercent(radius[0], size / 2);
  var r2 = parsePercent(radius[1], size / 2);
  return {
    cx,
    cy,
    r0,
    r: r2
  };
}
function pieLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var viewRect2 = getViewRect$5(seriesModel, api);
    var _a2 = getBasicPieLayout(seriesModel, api), cx = _a2.cx, cy = _a2.cy, r2 = _a2.r, r0 = _a2.r0;
    var startAngle = -seriesModel.get("startAngle") * RADIAN$2;
    var minAngle = seriesModel.get("minAngle") * RADIAN$2;
    var validDataCount = 0;
    data.each(valueDim, function(value) {
      !isNaN(value) && validDataCount++;
    });
    var sum2 = data.getSum(valueDim);
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var clockwise = seriesModel.get("clockwise");
    var roseType = seriesModel.get("roseType");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var extent3 = data.getDataExtent(valueDim);
    extent3[0] = 0;
    var restAngle = PI2$1;
    var valueSumLargerThanMinAngle = 0;
    var currentAngle = startAngle;
    var dir3 = clockwise ? 1 : -1;
    data.setLayout({
      viewRect: viewRect2,
      r: r2
    });
    data.each(valueDim, function(value, idx) {
      var angle;
      if (isNaN(value)) {
        data.setItemLayout(idx, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise,
          cx,
          cy,
          r0,
          r: roseType ? NaN : r2
        });
        return;
      }
      if (roseType !== "area") {
        angle = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
      } else {
        angle = PI2$1 / validDataCount;
      }
      if (angle < minAngle) {
        angle = minAngle;
        restAngle -= minAngle;
      } else {
        valueSumLargerThanMinAngle += value;
      }
      var endAngle = currentAngle + dir3 * angle;
      data.setItemLayout(idx, {
        angle,
        startAngle: currentAngle,
        endAngle,
        clockwise,
        cx,
        cy,
        r0,
        r: roseType ? linearMap$2(value, extent3, [r0, r2]) : r2
      });
      currentAngle = endAngle;
    });
    if (restAngle < PI2$1 && validDataCount) {
      if (restAngle <= 1e-3) {
        var angle_1 = PI2$1 / validDataCount;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_1 = data.getItemLayout(idx);
            layout_1.angle = angle_1;
            layout_1.startAngle = startAngle + dir3 * idx * angle_1;
            layout_1.endAngle = startAngle + dir3 * (idx + 1) * angle_1;
          }
        });
      } else {
        unitRadian = restAngle / valueSumLargerThanMinAngle;
        currentAngle = startAngle;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_2 = data.getItemLayout(idx);
            var angle = layout_2.angle === minAngle ? minAngle : value * unitRadian;
            layout_2.startAngle = currentAngle;
            layout_2.endAngle = currentAngle + dir3 * angle;
            currentAngle += dir3 * angle;
          }
        });
      }
    }
  });
}
function dataFilter$1(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var legendModels = ecModel.findComponents({
        mainType: "legend"
      });
      if (!legendModels || !legendModels.length) {
        return;
      }
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var name = data.getName(idx);
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(name)) {
            return false;
          }
        }
        return true;
      });
    }
  };
}
var RADIAN$1 = Math.PI / 180;
function adjustSingleSide(list, cx, cy, r2, dir3, viewWidth, viewHeight, viewLeft, viewTop, farthestX) {
  if (list.length < 2) {
    return;
  }
  function recalculateXOnSemiToAlignOnEllipseCurve(semi) {
    var rB = semi.rB;
    var rB2 = rB * rB;
    for (var i2 = 0; i2 < semi.list.length; i2++) {
      var item = semi.list[i2];
      var dy = Math.abs(item.label.y - cy);
      var rA = r2 + item.len;
      var rA2 = rA * rA;
      var dx2 = Math.sqrt((1 - Math.abs(dy * dy / rB2)) * rA2);
      var newX = cx + (dx2 + item.len2) * dir3;
      var deltaX = newX - item.label.x;
      var newTargetWidth = item.targetTextWidth - deltaX * dir3;
      constrainTextWidth(item, newTargetWidth, true);
      item.label.x = newX;
    }
  }
  function recalculateX(items) {
    var topSemi = {
      list: [],
      maxY: 0
    };
    var bottomSemi = {
      list: [],
      maxY: 0
    };
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].labelAlignTo !== "none") {
        continue;
      }
      var item = items[i2];
      var semi = item.label.y > cy ? bottomSemi : topSemi;
      var dy = Math.abs(item.label.y - cy);
      if (dy >= semi.maxY) {
        var dx2 = item.label.x - cx - item.len2 * dir3;
        var rA = r2 + item.len;
        var rB = Math.abs(dx2) < rA ? Math.sqrt(dy * dy / (1 - dx2 * dx2 / rA / rA)) : rA;
        semi.rB = rB;
        semi.maxY = dy;
      }
      semi.list.push(item);
    }
    recalculateXOnSemiToAlignOnEllipseCurve(topSemi);
    recalculateXOnSemiToAlignOnEllipseCurve(bottomSemi);
  }
  var len2 = list.length;
  for (var i = 0; i < len2; i++) {
    if (list[i].position === "outer" && list[i].labelAlignTo === "labelLine") {
      var dx = list[i].label.x - farthestX;
      list[i].linePoints[1][0] += dx;
      list[i].label.x = farthestX;
    }
  }
  if (shiftLayoutOnY(list, viewTop, viewTop + viewHeight)) {
    recalculateX(list);
  }
}
function avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop) {
  var leftList = [];
  var rightList = [];
  var leftmostX = Number.MAX_VALUE;
  var rightmostX = -Number.MAX_VALUE;
  for (var i = 0; i < labelLayoutList.length; i++) {
    var label = labelLayoutList[i].label;
    if (isPositionCenter(labelLayoutList[i])) {
      continue;
    }
    if (label.x < cx) {
      leftmostX = Math.min(leftmostX, label.x);
      leftList.push(labelLayoutList[i]);
    } else {
      rightmostX = Math.max(rightmostX, label.x);
      rightList.push(labelLayoutList[i]);
    }
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      if (layout2.labelStyleWidth != null) {
        continue;
      }
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var targetTextWidth = void 0;
      if (layout2.labelAlignTo === "edge") {
        if (label.x < cx) {
          targetTextWidth = linePoints[2][0] - layout2.labelDistance - viewLeft - layout2.edgeDistance;
        } else {
          targetTextWidth = viewLeft + viewWidth - layout2.edgeDistance - linePoints[2][0] - layout2.labelDistance;
        }
      } else if (layout2.labelAlignTo === "labelLine") {
        if (label.x < cx) {
          targetTextWidth = leftmostX - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - rightmostX - layout2.bleedMargin;
        }
      } else {
        if (label.x < cx) {
          targetTextWidth = label.x - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - label.x - layout2.bleedMargin;
        }
      }
      layout2.targetTextWidth = targetTextWidth;
      constrainTextWidth(layout2, targetTextWidth);
    }
  }
  adjustSingleSide(rightList, cx, cy, r2, 1, viewWidth, viewHeight, viewLeft, viewTop, rightmostX);
  adjustSingleSide(leftList, cx, cy, r2, -1, viewWidth, viewHeight, viewLeft, viewTop, leftmostX);
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var isAlignToEdge = layout2.labelAlignTo === "edge";
      var padding = label.style.padding;
      var paddingH = padding ? padding[1] + padding[3] : 0;
      var extraPaddingH = label.style.backgroundColor ? 0 : paddingH;
      var realTextWidth = layout2.rect.width + extraPaddingH;
      var dist2 = linePoints[1][0] - linePoints[2][0];
      if (isAlignToEdge) {
        if (label.x < cx) {
          linePoints[2][0] = viewLeft + layout2.edgeDistance + realTextWidth + layout2.labelDistance;
        } else {
          linePoints[2][0] = viewLeft + viewWidth - layout2.edgeDistance - realTextWidth - layout2.labelDistance;
        }
      } else {
        if (label.x < cx) {
          linePoints[2][0] = label.x + layout2.labelDistance;
        } else {
          linePoints[2][0] = label.x - layout2.labelDistance;
        }
        linePoints[1][0] = linePoints[2][0] + dist2;
      }
      linePoints[1][1] = linePoints[2][1] = label.y;
    }
  }
}
function constrainTextWidth(layout2, availableWidth, forceRecalculate) {
  if (forceRecalculate === void 0) {
    forceRecalculate = false;
  }
  if (layout2.labelStyleWidth != null) {
    return;
  }
  var label = layout2.label;
  var style = label.style;
  var textRect = layout2.rect;
  var bgColor = style.backgroundColor;
  var padding = style.padding;
  var paddingH = padding ? padding[1] + padding[3] : 0;
  var overflow = style.overflow;
  var oldOuterWidth = textRect.width + (bgColor ? 0 : paddingH);
  if (availableWidth < oldOuterWidth || forceRecalculate) {
    var oldHeight = textRect.height;
    if (overflow && overflow.match("break")) {
      label.setStyle("backgroundColor", null);
      label.setStyle("width", availableWidth - paddingH);
      var innerRect = label.getBoundingRect();
      label.setStyle("width", Math.ceil(innerRect.width));
      label.setStyle("backgroundColor", bgColor);
    } else {
      var availableInnerWidth = availableWidth - paddingH;
      var newWidth = availableWidth < oldOuterWidth ? availableInnerWidth : forceRecalculate ? availableInnerWidth > layout2.unconstrainedWidth ? null : availableInnerWidth : null;
      label.setStyle("width", newWidth);
    }
    var newRect = label.getBoundingRect();
    textRect.width = newRect.width;
    var margin = (label.style.margin || 0) + 2.1;
    textRect.height = newRect.height + margin;
    textRect.y -= (textRect.height - oldHeight) / 2;
  }
}
function isPositionCenter(sectorShape) {
  return sectorShape.position === "center";
}
function pieLabelLayout(seriesModel) {
  var data = seriesModel.getData();
  var labelLayoutList = [];
  var cx;
  var cy;
  var hasLabelRotate = false;
  var minShowLabelRadian = (seriesModel.get("minShowLabelAngle") || 0) * RADIAN$1;
  var viewRect2 = data.getLayout("viewRect");
  var r2 = data.getLayout("r");
  var viewWidth = viewRect2.width;
  var viewLeft = viewRect2.x;
  var viewTop = viewRect2.y;
  var viewHeight = viewRect2.height;
  function setNotShow(el) {
    el.ignore = true;
  }
  function isLabelShown(label2) {
    if (!label2.ignore) {
      return true;
    }
    for (var key in label2.states) {
      if (label2.states[key].ignore === false) {
        return true;
      }
    }
    return false;
  }
  data.each(function(idx) {
    var sector = data.getItemGraphicEl(idx);
    var sectorShape = sector.shape;
    var label2 = sector.getTextContent();
    var labelLine2 = sector.getTextGuideLine();
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position") || itemModel.get(["emphasis", "label", "position"]);
    var labelDistance = labelModel.get("distanceToLabelLine");
    var labelAlignTo = labelModel.get("alignTo");
    var edgeDistance = parsePercent(labelModel.get("edgeDistance"), viewWidth);
    var bleedMargin = labelModel.get("bleedMargin");
    var labelLineModel = itemModel.getModel("labelLine");
    var labelLineLen = labelLineModel.get("length");
    labelLineLen = parsePercent(labelLineLen, viewWidth);
    var labelLineLen2 = labelLineModel.get("length2");
    labelLineLen2 = parsePercent(labelLineLen2, viewWidth);
    if (Math.abs(sectorShape.endAngle - sectorShape.startAngle) < minShowLabelRadian) {
      each$f(label2.states, setNotShow);
      label2.ignore = true;
      return;
    }
    if (!isLabelShown(label2)) {
      return;
    }
    var midAngle = (sectorShape.startAngle + sectorShape.endAngle) / 2;
    var nx = Math.cos(midAngle);
    var ny = Math.sin(midAngle);
    var textX;
    var textY;
    var linePoints2;
    var textAlign;
    cx = sectorShape.cx;
    cy = sectorShape.cy;
    var isLabelInside = labelPosition === "inside" || labelPosition === "inner";
    if (labelPosition === "center") {
      textX = sectorShape.cx;
      textY = sectorShape.cy;
      textAlign = "center";
    } else {
      var x1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * nx : sectorShape.r * nx) + cx;
      var y1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * ny : sectorShape.r * ny) + cy;
      textX = x1 + nx * 3;
      textY = y1 + ny * 3;
      if (!isLabelInside) {
        var x2 = x1 + nx * (labelLineLen + r2 - sectorShape.r);
        var y2 = y1 + ny * (labelLineLen + r2 - sectorShape.r);
        var x3 = x2 + (nx < 0 ? -1 : 1) * labelLineLen2;
        var y3 = y2;
        if (labelAlignTo === "edge") {
          textX = nx < 0 ? viewLeft + edgeDistance : viewLeft + viewWidth - edgeDistance;
        } else {
          textX = x3 + (nx < 0 ? -labelDistance : labelDistance);
        }
        textY = y3;
        linePoints2 = [[x1, y1], [x2, y2], [x3, y3]];
      }
      textAlign = isLabelInside ? "center" : labelAlignTo === "edge" ? nx > 0 ? "right" : "left" : nx > 0 ? "left" : "right";
    }
    var PI3 = Math.PI;
    var labelRotate = 0;
    var rotate2 = labelModel.get("rotate");
    if (isNumber(rotate2)) {
      labelRotate = rotate2 * (PI3 / 180);
    } else if (labelPosition === "center") {
      labelRotate = 0;
    } else if (rotate2 === "radial" || rotate2 === true) {
      var radialAngle = nx < 0 ? -midAngle + PI3 : -midAngle;
      labelRotate = radialAngle;
    } else if (rotate2 === "tangential" && labelPosition !== "outside" && labelPosition !== "outer") {
      var rad = Math.atan2(nx, ny);
      if (rad < 0) {
        rad = PI3 * 2 + rad;
      }
      var isDown = ny > 0;
      if (isDown) {
        rad = PI3 + rad;
      }
      labelRotate = rad - PI3;
    }
    hasLabelRotate = !!labelRotate;
    label2.x = textX;
    label2.y = textY;
    label2.rotation = labelRotate;
    label2.setStyle({
      verticalAlign: "middle"
    });
    if (!isLabelInside) {
      var textRect = label2.getBoundingRect().clone();
      textRect.applyTransform(label2.getComputedTransform());
      var margin = (label2.style.margin || 0) + 2.1;
      textRect.y -= margin / 2;
      textRect.height += margin;
      labelLayoutList.push({
        label: label2,
        labelLine: labelLine2,
        position: labelPosition,
        len: labelLineLen,
        len2: labelLineLen2,
        minTurnAngle: labelLineModel.get("minTurnAngle"),
        maxSurfaceAngle: labelLineModel.get("maxSurfaceAngle"),
        surfaceNormal: new Point$1(nx, ny),
        linePoints: linePoints2,
        textAlign,
        labelDistance,
        labelAlignTo,
        edgeDistance,
        bleedMargin,
        rect: textRect,
        unconstrainedWidth: textRect.width,
        labelStyleWidth: label2.style.width
      });
    } else {
      label2.setStyle({
        align: textAlign
      });
      var selectState2 = label2.states.select;
      if (selectState2) {
        selectState2.x += label2.x;
        selectState2.y += label2.y;
      }
    }
    sector.setTextConfig({
      inside: isLabelInside
    });
  });
  if (!hasLabelRotate && seriesModel.get("avoidLabelOverlap")) {
    avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop);
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    var label = layout2.label;
    var labelLine = layout2.labelLine;
    var notShowLabel = isNaN(label.x) || isNaN(label.y);
    if (label) {
      label.setStyle({
        align: layout2.textAlign
      });
      if (notShowLabel) {
        each$f(label.states, setNotShow);
        label.ignore = true;
      }
      var selectState = label.states.select;
      if (selectState) {
        selectState.x += label.x;
        selectState.y += label.y;
      }
    }
    if (labelLine) {
      var linePoints = layout2.linePoints;
      if (notShowLabel || !linePoints) {
        each$f(labelLine.states, setNotShow);
        labelLine.ignore = true;
      } else {
        limitTurnAngle(linePoints, layout2.minTurnAngle);
        limitSurfaceAngle(linePoints, layout2.surfaceNormal, layout2.maxSurfaceAngle);
        labelLine.setShape({
          points: linePoints
        });
        label.__hostTarget.textGuideLineConfig = {
          anchor: new Point$1(linePoints[0][0], linePoints[0][1])
        };
      }
    }
  }
}
function getSectorCornerRadius(model, shape, zeroIfNull) {
  var cornerRadius = model.get("borderRadius");
  if (cornerRadius == null) {
    return zeroIfNull ? {
      cornerRadius: 0
    } : null;
  }
  if (!isArray$1(cornerRadius)) {
    cornerRadius = [cornerRadius, cornerRadius, cornerRadius, cornerRadius];
  }
  var dr = Math.abs(shape.r || 0 - shape.r0 || 0);
  return {
    cornerRadius: map$1(cornerRadius, function(cr) {
      return parsePercent$1(cr, dr);
    })
  };
}
var PiePiece = function(_super) {
  __extends(PiePiece2, _super);
  function PiePiece2(data, idx, startAngle) {
    var _this = _super.call(this) || this;
    _this.z2 = 2;
    var text = new ZRText$1();
    _this.setTextContent(text);
    _this.updateData(data, idx, startAngle, true);
    return _this;
  }
  PiePiece2.prototype.updateData = function(data, idx, startAngle, firstCreate) {
    var sector = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = data.getItemLayout(idx);
    var sectorShape = extend(getSectorCornerRadius(itemModel.getModel("itemStyle"), layout2, true), layout2);
    if (isNaN(sectorShape.startAngle)) {
      sector.setShape(sectorShape);
      return;
    }
    if (firstCreate) {
      sector.setShape(sectorShape);
      var animationType = seriesModel.getShallow("animationType");
      if (seriesModel.ecModel.ssr) {
        initProps(sector, {
          scaleX: 0,
          scaleY: 0
        }, seriesModel, {
          dataIndex: idx,
          isFrom: true
        });
        sector.originX = sectorShape.cx;
        sector.originY = sectorShape.cy;
      } else if (animationType === "scale") {
        sector.shape.r = layout2.r0;
        initProps(sector, {
          shape: {
            r: layout2.r
          }
        }, seriesModel, idx);
      } else {
        if (startAngle != null) {
          sector.setShape({
            startAngle,
            endAngle: startAngle
          });
          initProps(sector, {
            shape: {
              startAngle: layout2.startAngle,
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        } else {
          sector.shape.endAngle = layout2.startAngle;
          updateProps$1(sector, {
            shape: {
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        }
      }
    } else {
      saveOldStyle(sector);
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel, idx);
    }
    sector.useStyle(data.getItemVisual(idx, "style"));
    setStatesStylesFromModel(sector, itemModel);
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var offset = seriesModel.get("selectedOffset");
    var dx = Math.cos(midAngle) * offset;
    var dy = Math.sin(midAngle) * offset;
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._updateLabel(seriesModel, data, idx);
    sector.ensureState("emphasis").shape = extend({
      r: layout2.r + (emphasisModel.get("scale") ? emphasisModel.get("scaleSize") || 0 : 0)
    }, getSectorCornerRadius(emphasisModel.getModel("itemStyle"), layout2));
    extend(sector.ensureState("select"), {
      x: dx,
      y: dy,
      shape: getSectorCornerRadius(itemModel.getModel(["select", "itemStyle"]), layout2)
    });
    extend(sector.ensureState("blur"), {
      shape: getSectorCornerRadius(itemModel.getModel(["blur", "itemStyle"]), layout2)
    });
    var labelLine = sector.getTextGuideLine();
    var labelText = sector.getTextContent();
    labelLine && extend(labelLine.ensureState("select"), {
      x: dx,
      y: dy
    });
    extend(labelText.ensureState("select"), {
      x: dx,
      y: dy
    });
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  PiePiece2.prototype._updateLabel = function(seriesModel, data, idx) {
    var sector = this;
    var itemModel = data.getItemModel(idx);
    var labelLineModel = itemModel.getModel("labelLine");
    var style = data.getItemVisual(idx, "style");
    var visualColor = style && style.fill;
    var visualOpacity = style && style.opacity;
    setLabelStyle(sector, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      defaultText: seriesModel.getFormattedLabel(idx, "normal") || data.getName(idx)
    });
    var labelText = sector.getTextContent();
    sector.setTextConfig({
      position: null,
      rotation: null
    });
    labelText.attr({
      z2: 10
    });
    var labelPosition = seriesModel.get(["label", "position"]);
    if (labelPosition !== "outside" && labelPosition !== "outer") {
      sector.removeTextGuideLine();
    } else {
      var polyline = this.getTextGuideLine();
      if (!polyline) {
        polyline = new Polyline$3();
        this.setTextGuideLine(polyline);
      }
      setLabelLineStyle(this, getLabelLineStatesModels(itemModel), {
        stroke: visualColor,
        opacity: retrieve3(labelLineModel.get(["lineStyle", "opacity"]), visualOpacity, 1)
      });
    }
  };
  return PiePiece2;
}(Sector$1);
var PieView = function(_super) {
  __extends(PieView2, _super);
  function PieView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  PieView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var startAngle;
    if (!oldData && data.count() > 0) {
      var shape = data.getItemLayout(0);
      for (var s = 1; isNaN(shape && shape.startAngle) && s < data.count(); ++s) {
        shape = data.getItemLayout(s);
      }
      if (shape) {
        startAngle = shape.startAngle;
      }
    }
    if (this._emptyCircleSector) {
      group.remove(this._emptyCircleSector);
    }
    if (data.count() === 0 && seriesModel.get("showEmptyCircle")) {
      var sector = new Sector$1({
        shape: getBasicPieLayout(seriesModel, api)
      });
      sector.useStyle(seriesModel.getModel("emptyCircleStyle").getItemStyle());
      this._emptyCircleSector = sector;
      group.add(sector);
    }
    data.diff(oldData).add(function(idx) {
      var piePiece = new PiePiece(data, idx, startAngle);
      data.setItemGraphicEl(idx, piePiece);
      group.add(piePiece);
    }).update(function(newIdx, oldIdx) {
      var piePiece = oldData.getItemGraphicEl(oldIdx);
      piePiece.updateData(data, newIdx, startAngle);
      piePiece.off("click");
      group.add(piePiece);
      data.setItemGraphicEl(newIdx, piePiece);
    }).remove(function(idx) {
      var piePiece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piePiece, seriesModel, idx);
    }).execute();
    pieLabelLayout(seriesModel);
    if (seriesModel.get("animationTypeUpdate") !== "expansion") {
      this._data = data;
    }
  };
  PieView2.prototype.dispose = function() {
  };
  PieView2.prototype.containPoint = function(point, seriesModel) {
    var data = seriesModel.getData();
    var itemLayout = data.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  PieView2.type = "pie";
  return PieView2;
}(ChartView$1);
var PieView$1 = PieView;
function createSeriesDataSimply(seriesModel, opt, nameList) {
  opt = isArray$1(opt) && {
    coordDimensions: opt
  } || extend({
    encodeDefine: seriesModel.getEncode()
  }, opt);
  var source = seriesModel.getSource();
  var dimensions = prepareSeriesDataSchema(source, opt).dimensions;
  var list = new SeriesData$1(dimensions, seriesModel);
  list.initData(source, nameList);
  return list;
}
var LegendVisualProvider = function() {
  function LegendVisualProvider2(getDataWithEncodedVisual, getRawData2) {
    this._getDataWithEncodedVisual = getDataWithEncodedVisual;
    this._getRawData = getRawData2;
  }
  LegendVisualProvider2.prototype.getAllNames = function() {
    var rawData = this._getRawData();
    return rawData.mapArray(rawData.getName);
  };
  LegendVisualProvider2.prototype.containName = function(name) {
    var rawData = this._getRawData();
    return rawData.indexOfName(name) >= 0;
  };
  LegendVisualProvider2.prototype.indexOfName = function(name) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.indexOfName(name);
  };
  LegendVisualProvider2.prototype.getItemVisual = function(dataIndex, key) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.getItemVisual(dataIndex, key);
  };
  return LegendVisualProvider2;
}();
var LegendVisualProvider$1 = LegendVisualProvider;
var PieSeriesModel = function(_super) {
  __extends(PieSeriesModel2, _super);
  function PieSeriesModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PieSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  PieSeriesModel2.prototype.mergeOption = function() {
    _super.prototype.mergeOption.apply(this, arguments);
  };
  PieSeriesModel2.prototype.getInitialData = function() {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  PieSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueList = [];
    data.each(data.mapDimension("value"), function(value) {
      valueList.push(value);
    });
    params.percent = getPercentWithPrecision(valueList, dataIndex, data.hostModel.get("percentPrecision"));
    params.$vars.push("percent");
    return params;
  };
  PieSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  PieSeriesModel2.type = "series.pie";
  PieSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    minShowLabelAngle: 0,
    selectedOffset: 10,
    percentPrecision: 2,
    stillShowZeroSum: true,
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    width: null,
    height: null,
    label: {
      rotate: 0,
      show: true,
      overflow: "truncate",
      position: "outer",
      alignTo: "none",
      edgeDistance: "25%",
      bleedMargin: 10,
      distanceToLabelLine: 5
    },
    labelLine: {
      show: true,
      length: 15,
      length2: 15,
      smooth: false,
      minTurnAngle: 90,
      maxSurfaceAngle: 90,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      borderWidth: 1,
      borderJoin: "round"
    },
    showEmptyCircle: true,
    emptyCircleStyle: {
      color: "lightgray",
      opacity: 1
    },
    labelLayout: {
      hideOverlap: true
    },
    emphasis: {
      scale: true,
      scaleSize: 5
    },
    avoidLabelOverlap: true,
    animationType: "expansion",
    animationDuration: 1e3,
    animationTypeUpdate: "transition",
    animationEasingUpdate: "cubicInOut",
    animationDurationUpdate: 500,
    animationEasing: "cubicInOut"
  };
  return PieSeriesModel2;
}(SeriesModel$1);
var PieSeriesModel$1 = PieSeriesModel;
function negativeDataFilter(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var valueDim = data.mapDimension("value");
        var curValue = data.get(valueDim, idx);
        if (isNumber(curValue) && !isNaN(curValue) && curValue < 0) {
          return false;
        }
        return true;
      });
    }
  };
}
function install$O(registers) {
  registers.registerChartView(PieView$1);
  registers.registerSeriesModel(PieSeriesModel$1);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry$1(pieLayout, "pie"));
  registers.registerProcessor(dataFilter$1("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
var ScatterSeriesModel = function(_super) {
  __extends(ScatterSeriesModel2, _super);
  function ScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  ScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  ScatterSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 5e3 : this.get("progressive");
    }
    return progressive;
  };
  ScatterSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 1e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  ScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  ScatterSeriesModel2.prototype.getZLevelKey = function() {
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
  };
  ScatterSeriesModel2.type = "series.scatter";
  ScatterSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  ScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    symbolSize: 10,
    large: false,
    largeThreshold: 2e3,
    itemStyle: {
      opacity: 0.8
    },
    emphasis: {
      scale: true
    },
    clip: true,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    universalTransition: {
      divideShape: "clone"
    }
  };
  return ScatterSeriesModel2;
}(SeriesModel$1);
var ScatterSeriesModel$1 = ScatterSeriesModel;
var BOOST_SIZE_THRESHOLD = 4;
var LargeSymbolPathShape = function() {
  function LargeSymbolPathShape2() {
  }
  return LargeSymbolPathShape2;
}();
var LargeSymbolPath = function(_super) {
  __extends(LargeSymbolPath2, _super);
  function LargeSymbolPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeSymbolPath2.prototype.getDefaultShape = function() {
    return new LargeSymbolPathShape();
  };
  LargeSymbolPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeSymbolPath2.prototype.buildPath = function(path, shape) {
    var points2 = shape.points;
    var size = shape.size;
    var symbolProxy = this.symbolProxy;
    var symbolProxyShape = symbolProxy.shape;
    var ctx = path.getContext ? path.getContext() : path;
    var canBoost = ctx && size[0] < BOOST_SIZE_THRESHOLD;
    var softClipShape = this.softClipShape;
    var i;
    if (canBoost) {
      this._ctx = ctx;
      return;
    }
    this._ctx = null;
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      symbolProxyShape.x = x2 - size[0] / 2;
      symbolProxyShape.y = y2 - size[1] / 2;
      symbolProxyShape.width = size[0];
      symbolProxyShape.height = size[1];
      symbolProxy.buildPath(path, symbolProxyShape, true);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.afterBrush = function() {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var ctx = this._ctx;
    var softClipShape = this.softClipShape;
    var i;
    if (!ctx) {
      return;
    }
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      ctx.fillRect(x2 - size[0] / 2, y2 - size[1] / 2, size[0], size[1]);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var w2 = Math.max(size[0], 4);
    var h = Math.max(size[1], 4);
    for (var idx = points2.length / 2 - 1; idx >= 0; idx--) {
      var i = idx * 2;
      var x0 = points2[i] - w2 / 2;
      var y0 = points2[i + 1] - h / 2;
      if (x2 >= x0 && y2 >= y0 && x2 <= x0 + w2 && y2 <= y0 + h) {
        return idx;
      }
    }
    return -1;
  };
  LargeSymbolPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeSymbolPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.points;
      var size = shape.size;
      var w2 = size[0];
      var h = size[1];
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX - w2 / 2, minY - h / 2, maxX - minX + w2, maxY - minY + h);
    }
    return rect;
  };
  return LargeSymbolPath2;
}(Path$1);
var LargeSymbolDraw = function() {
  function LargeSymbolDraw2() {
    this.group = new Group$4();
  }
  LargeSymbolDraw2.prototype.updateData = function(data, opt) {
    this._clear();
    var symbolEl = this._create();
    symbolEl.setShape({
      points: data.getLayout("points")
    });
    this._setCommon(symbolEl, data, opt);
  };
  LargeSymbolDraw2.prototype.updateLayout = function(data) {
    var points2 = data.getLayout("points");
    this.group.eachChild(function(child) {
      if (child.startIndex != null) {
        var len2 = (child.endIndex - child.startIndex) * 2;
        var byteOffset = child.startIndex * 4 * 2;
        points2 = new Float32Array(points2.buffer, byteOffset, len2);
      }
      child.setShape("points", points2);
      child.reset();
    });
  };
  LargeSymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._clear();
  };
  LargeSymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    var lastAdded = this._newAdded[0];
    var points2 = data.getLayout("points");
    var oldPoints = lastAdded && lastAdded.shape.points;
    if (oldPoints && oldPoints.length < 2e4) {
      var oldLen = oldPoints.length;
      var newPoints = new Float32Array(oldLen + points2.length);
      newPoints.set(oldPoints);
      newPoints.set(points2, oldLen);
      lastAdded.endIndex = taskParams.end;
      lastAdded.setShape({
        points: newPoints
      });
    } else {
      this._newAdded = [];
      var symbolEl = this._create();
      symbolEl.startIndex = taskParams.start;
      symbolEl.endIndex = taskParams.end;
      symbolEl.incremental = true;
      symbolEl.setShape({
        points: points2
      });
      this._setCommon(symbolEl, data, opt);
    }
  };
  LargeSymbolDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeSymbolDraw2.prototype._create = function() {
    var symbolEl = new LargeSymbolPath({
      cursor: "default"
    });
    this.group.add(symbolEl);
    this._newAdded.push(symbolEl);
    return symbolEl;
  };
  LargeSymbolDraw2.prototype._setCommon = function(symbolEl, data, opt) {
    var hostModel = data.hostModel;
    opt = opt || {};
    var size = data.getVisual("symbolSize");
    symbolEl.setShape("size", size instanceof Array ? size : [size, size]);
    symbolEl.softClipShape = opt.clipShape || null;
    symbolEl.symbolProxy = createSymbol$1(data.getVisual("symbol"), 0, 0, 0, 0);
    symbolEl.setColor = symbolEl.symbolProxy.setColor;
    var extrudeShadow = symbolEl.shape.size[0] < BOOST_SIZE_THRESHOLD;
    symbolEl.useStyle(hostModel.getModel("itemStyle").getItemStyle(extrudeShadow ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
    var globalStyle = data.getVisual("style");
    var visualColor = globalStyle && globalStyle.fill;
    if (visualColor) {
      symbolEl.setColor(visualColor);
    }
    var ecData = getECData(symbolEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    symbolEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = symbolEl.hoverDataIdx;
      if (dataIndex >= 0) {
        ecData.dataIndex = dataIndex + (symbolEl.startIndex || 0);
      }
    });
  };
  LargeSymbolDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeSymbolDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeSymbolDraw2;
}();
var LargeSymbolDraw$1 = LargeSymbolDraw;
var ScatterView = function(_super) {
  __extends(ScatterView2, _super);
  function ScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterView2.type;
    return _this;
  }
  ScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = true;
  };
  ScatterView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.incrementalPrepareUpdate(data);
    this._finished = false;
  };
  ScatterView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._symbolDraw.incrementalUpdate(taskParams, seriesModel.getData(), {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  ScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    if (!this._finished || data.count() > 1e4) {
      return {
        update: true
      };
    } else {
      var res = pointsLayout("").reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._symbolDraw.updateLayout(data);
    }
  };
  ScatterView2.prototype.eachRendered = function(cb) {
    this._symbolDraw && this._symbolDraw.eachRendered(cb);
  };
  ScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  ScatterView2.prototype._updateSymbolDraw = function(data, seriesModel) {
    var symbolDraw = this._symbolDraw;
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!symbolDraw || isLargeDraw !== this._isLargeDraw) {
      symbolDraw && symbolDraw.remove();
      symbolDraw = this._symbolDraw = isLargeDraw ? new LargeSymbolDraw$1() : new SymbolDraw$1();
      this._isLargeDraw = isLargeDraw;
      this.group.removeAll();
    }
    this.group.add(symbolDraw.group);
    return symbolDraw;
  };
  ScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
    this._symbolDraw = null;
  };
  ScatterView2.prototype.dispose = function() {
  };
  ScatterView2.type = "scatter";
  return ScatterView2;
}(ChartView$1);
var ScatterView$1 = ScatterView;
var GridModel = function(_super) {
  __extends(GridModel2, _super);
  function GridModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GridModel2.type = "grid";
  GridModel2.dependencies = ["xAxis", "yAxis"];
  GridModel2.layoutMode = "box";
  GridModel2.defaultOption = {
    show: false,
    z: 0,
    left: "10%",
    top: 60,
    right: "10%",
    bottom: 70,
    containLabel: false,
    backgroundColor: "rgba(0,0,0,0)",
    borderWidth: 1,
    borderColor: "#ccc"
  };
  return GridModel2;
}(ComponentModel$1);
var GridModel$1 = GridModel;
var CartesianAxisModel = function(_super) {
  __extends(CartesianAxisModel2, _super);
  function CartesianAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("grid", SINGLE_REFERRING).models[0];
  };
  CartesianAxisModel2.type = "cartesian2dAxis";
  return CartesianAxisModel2;
}(ComponentModel$1);
mixin(CartesianAxisModel, AxisModelCommonMixin);
var defaultOption$1 = {
  show: true,
  z: 0,
  inverse: false,
  name: "",
  nameLocation: "end",
  nameRotate: null,
  nameTruncate: {
    maxWidth: null,
    ellipsis: "...",
    placeholder: "."
  },
  nameTextStyle: {},
  nameGap: 15,
  silent: false,
  triggerEvent: false,
  tooltip: {
    show: false
  },
  axisPointer: {},
  axisLine: {
    show: true,
    onZero: true,
    onZeroAxisIndex: null,
    lineStyle: {
      color: "#6E7079",
      width: 1,
      type: "solid"
    },
    symbol: ["none", "none"],
    symbolSize: [10, 15]
  },
  axisTick: {
    show: true,
    inside: false,
    length: 5,
    lineStyle: {
      width: 1
    }
  },
  axisLabel: {
    show: true,
    inside: false,
    rotate: 0,
    showMinLabel: null,
    showMaxLabel: null,
    margin: 8,
    fontSize: 12
  },
  splitLine: {
    show: true,
    lineStyle: {
      color: ["#E0E6F1"],
      width: 1,
      type: "solid"
    }
  },
  splitArea: {
    show: false,
    areaStyle: {
      color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"]
    }
  }
};
var categoryAxis = merge({
  boundaryGap: true,
  deduplication: null,
  splitLine: {
    show: false
  },
  axisTick: {
    alignWithLabel: false,
    interval: "auto"
  },
  axisLabel: {
    interval: "auto"
  }
}, defaultOption$1);
var valueAxis = merge({
  boundaryGap: [0, 0],
  axisLine: {
    show: "auto"
  },
  axisTick: {
    show: "auto"
  },
  splitNumber: 5,
  minorTick: {
    show: false,
    splitNumber: 5,
    length: 3,
    lineStyle: {}
  },
  minorSplitLine: {
    show: false,
    lineStyle: {
      color: "#F4F7FD",
      width: 1
    }
  }
}, defaultOption$1);
var timeAxis = merge({
  splitNumber: 6,
  axisLabel: {
    showMinLabel: false,
    showMaxLabel: false,
    rich: {
      primary: {
        fontWeight: "bold"
      }
    }
  },
  splitLine: {
    show: false
  }
}, valueAxis);
var logAxis = defaults({
  logBase: 10
}, valueAxis);
var axisDefault = {
  category: categoryAxis,
  value: valueAxis,
  time: timeAxis,
  log: logAxis
};
var AXIS_TYPES = {
  value: 1,
  category: 1,
  time: 1,
  log: 1
};
function axisModelCreator(registers, axisName, BaseAxisModelClass, extraDefaultOption) {
  each$f(AXIS_TYPES, function(v4, axisType) {
    var defaultOption2 = merge(merge({}, axisDefault[axisType], true), extraDefaultOption, true);
    var AxisModel = function(_super) {
      __extends(AxisModel2, _super);
      function AxisModel2() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.type = axisName + "Axis." + axisType;
        return _this;
      }
      AxisModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
        var layoutMode = fetchLayoutMode(this);
        var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
        var themeModel = ecModel.getTheme();
        merge(option, themeModel.get(axisType + "Axis"));
        merge(option, this.getDefaultOption());
        option.type = getAxisType(option);
        if (layoutMode) {
          mergeLayoutParam(option, inputPositionParams, layoutMode);
        }
      };
      AxisModel2.prototype.optionUpdated = function() {
        var thisOption = this.option;
        if (thisOption.type === "category") {
          this.__ordinalMeta = OrdinalMeta$1.createByAxisModel(this);
        }
      };
      AxisModel2.prototype.getCategories = function(rawData) {
        var option = this.option;
        if (option.type === "category") {
          if (rawData) {
            return option.data;
          }
          return this.__ordinalMeta.categories;
        }
      };
      AxisModel2.prototype.getOrdinalMeta = function() {
        return this.__ordinalMeta;
      };
      AxisModel2.type = axisName + "Axis." + axisType;
      AxisModel2.defaultOption = defaultOption2;
      return AxisModel2;
    }(BaseAxisModelClass);
    registers.registerComponentModel(AxisModel);
  });
  registers.registerSubTypeDefaulter(axisName + "Axis", getAxisType);
}
function getAxisType(option) {
  return option.type || (option.data ? "category" : "value");
}
var Cartesian = function() {
  function Cartesian2(name) {
    this.type = "cartesian";
    this._dimList = [];
    this._axes = {};
    this.name = name || "";
  }
  Cartesian2.prototype.getAxis = function(dim) {
    return this._axes[dim];
  };
  Cartesian2.prototype.getAxes = function() {
    return map$1(this._dimList, function(dim) {
      return this._axes[dim];
    }, this);
  };
  Cartesian2.prototype.getAxesByScale = function(scaleType) {
    scaleType = scaleType.toLowerCase();
    return filter(this.getAxes(), function(axis) {
      return axis.scale.type === scaleType;
    });
  };
  Cartesian2.prototype.addAxis = function(axis) {
    var dim = axis.dim;
    this._axes[dim] = axis;
    this._dimList.push(dim);
  };
  return Cartesian2;
}();
var Cartesian$1 = Cartesian;
var cartesian2DDimensions = ["x", "y"];
function canCalculateAffineTransform(scale2) {
  return scale2.type === "interval" || scale2.type === "time";
}
var Cartesian2D = function(_super) {
  __extends(Cartesian2D2, _super);
  function Cartesian2D2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "cartesian2d";
    _this.dimensions = cartesian2DDimensions;
    return _this;
  }
  Cartesian2D2.prototype.calcAffineTransform = function() {
    this._transform = this._invTransform = null;
    var xAxisScale = this.getAxis("x").scale;
    var yAxisScale = this.getAxis("y").scale;
    if (!canCalculateAffineTransform(xAxisScale) || !canCalculateAffineTransform(yAxisScale)) {
      return;
    }
    var xScaleExtent = xAxisScale.getExtent();
    var yScaleExtent = yAxisScale.getExtent();
    var start2 = this.dataToPoint([xScaleExtent[0], yScaleExtent[0]]);
    var end2 = this.dataToPoint([xScaleExtent[1], yScaleExtent[1]]);
    var xScaleSpan = xScaleExtent[1] - xScaleExtent[0];
    var yScaleSpan = yScaleExtent[1] - yScaleExtent[0];
    if (!xScaleSpan || !yScaleSpan) {
      return;
    }
    var scaleX = (end2[0] - start2[0]) / xScaleSpan;
    var scaleY = (end2[1] - start2[1]) / yScaleSpan;
    var translateX = start2[0] - xScaleExtent[0] * scaleX;
    var translateY = start2[1] - yScaleExtent[0] * scaleY;
    var m2 = this._transform = [scaleX, 0, 0, scaleY, translateX, translateY];
    this._invTransform = invert([], m2);
  };
  Cartesian2D2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
  };
  Cartesian2D2.prototype.containPoint = function(point) {
    var axisX = this.getAxis("x");
    var axisY = this.getAxis("y");
    return axisX.contain(axisX.toLocalCoord(point[0])) && axisY.contain(axisY.toLocalCoord(point[1]));
  };
  Cartesian2D2.prototype.containData = function(data) {
    return this.getAxis("x").containData(data[0]) && this.getAxis("y").containData(data[1]);
  };
  Cartesian2D2.prototype.dataToPoint = function(data, clamp2, out2) {
    out2 = out2 || [];
    var xVal = data[0];
    var yVal = data[1];
    if (this._transform && xVal != null && isFinite(xVal) && yVal != null && isFinite(yVal)) {
      return applyTransform$1(out2, data, this._transform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.toGlobalCoord(xAxis.dataToCoord(xVal, clamp2));
    out2[1] = yAxis.toGlobalCoord(yAxis.dataToCoord(yVal, clamp2));
    return out2;
  };
  Cartesian2D2.prototype.clampData = function(data, out2) {
    var xScale = this.getAxis("x").scale;
    var yScale = this.getAxis("y").scale;
    var xAxisExtent = xScale.getExtent();
    var yAxisExtent = yScale.getExtent();
    var x2 = xScale.parse(data[0]);
    var y2 = yScale.parse(data[1]);
    out2 = out2 || [];
    out2[0] = Math.min(Math.max(Math.min(xAxisExtent[0], xAxisExtent[1]), x2), Math.max(xAxisExtent[0], xAxisExtent[1]));
    out2[1] = Math.min(Math.max(Math.min(yAxisExtent[0], yAxisExtent[1]), y2), Math.max(yAxisExtent[0], yAxisExtent[1]));
    return out2;
  };
  Cartesian2D2.prototype.pointToData = function(point, clamp2) {
    var out2 = [];
    if (this._invTransform) {
      return applyTransform$1(out2, point, this._invTransform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.coordToData(xAxis.toLocalCoord(point[0]), clamp2);
    out2[1] = yAxis.coordToData(yAxis.toLocalCoord(point[1]), clamp2);
    return out2;
  };
  Cartesian2D2.prototype.getOtherAxis = function(axis) {
    return this.getAxis(axis.dim === "x" ? "y" : "x");
  };
  Cartesian2D2.prototype.getArea = function() {
    var xExtent = this.getAxis("x").getGlobalExtent();
    var yExtent = this.getAxis("y").getGlobalExtent();
    var x2 = Math.min(xExtent[0], xExtent[1]);
    var y2 = Math.min(yExtent[0], yExtent[1]);
    var width = Math.max(xExtent[0], xExtent[1]) - x2;
    var height = Math.max(yExtent[0], yExtent[1]) - y2;
    return new BoundingRect$1(x2, y2, width, height);
  };
  return Cartesian2D2;
}(Cartesian$1);
var Cartesian2D$1 = Cartesian2D;
var Axis2D = function(_super) {
  __extends(Axis2D2, _super);
  function Axis2D2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.index = 0;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  Axis2D2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  Axis2D2.prototype.getGlobalExtent = function(asc2) {
    var ret = this.getExtent();
    ret[0] = this.toGlobalCoord(ret[0]);
    ret[1] = this.toGlobalCoord(ret[1]);
    asc2 && ret[0] > ret[1] && ret.reverse();
    return ret;
  };
  Axis2D2.prototype.pointToData = function(point, clamp2) {
    return this.coordToData(this.toLocalCoord(point[this.dim === "x" ? 0 : 1]), clamp2);
  };
  Axis2D2.prototype.setCategorySortInfo = function(info) {
    if (this.type !== "category") {
      return false;
    }
    this.model.option.categorySortInfo = info;
    this.scale.setSortInfo(info);
  };
  return Axis2D2;
}(Axis$1);
var Axis2D$1 = Axis2D;
function layout$2(gridModel, axisModel, opt) {
  opt = opt || {};
  var grid = gridModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var otherAxisOnZeroOf = axis.getAxesOnZeroOf()[0];
  var rawAxisPosition = axis.position;
  var axisPosition = otherAxisOnZeroOf ? "onZero" : rawAxisPosition;
  var axisDim = axis.dim;
  var rect = grid.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var idx = {
    left: 0,
    right: 1,
    top: 0,
    bottom: 1,
    onZero: 2
  };
  var axisOffset = axisModel.get("offset") || 0;
  var posBound = axisDim === "x" ? [rectBound[2] - axisOffset, rectBound[3] + axisOffset] : [rectBound[0] - axisOffset, rectBound[1] + axisOffset];
  if (otherAxisOnZeroOf) {
    var onZeroCoord = otherAxisOnZeroOf.toGlobalCoord(otherAxisOnZeroOf.dataToCoord(0));
    posBound[idx.onZero] = Math.max(Math.min(onZeroCoord, posBound[1]), posBound[0]);
  }
  layout2.position = [axisDim === "y" ? posBound[idx[axisPosition]] : rectBound[0], axisDim === "x" ? posBound[idx[axisPosition]] : rectBound[3]];
  layout2.rotation = Math.PI / 2 * (axisDim === "x" ? 0 : 1);
  var dirMap = {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = dirMap[rawAxisPosition];
  layout2.labelOffset = otherAxisOnZeroOf ? posBound[idx[rawAxisPosition]] - posBound[idx.onZero] : 0;
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotate = axisModel.get(["axisLabel", "rotate"]);
  layout2.labelRotate = axisPosition === "top" ? -labelRotate : labelRotate;
  layout2.z2 = 1;
  return layout2;
}
function isCartesian2DSeries(seriesModel) {
  return seriesModel.get("coordinateSystem") === "cartesian2d";
}
function findAxisModels(seriesModel) {
  var axisModelMap = {
    xAxisModel: null,
    yAxisModel: null
  };
  each$f(axisModelMap, function(v4, key) {
    var axisType = key.replace(/Model$/, "");
    var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
    axisModelMap[key] = axisModel;
  });
  return axisModelMap;
}
var mathLog = Math.log;
function alignScaleTicks(scale2, axisModel, alignToScale) {
  var intervalScaleProto2 = IntervalScale$1.prototype;
  var alignToTicks = intervalScaleProto2.getTicks.call(alignToScale);
  var alignToNicedTicks = intervalScaleProto2.getTicks.call(alignToScale, true);
  var alignToSplitNumber = alignToTicks.length - 1;
  var alignToInterval = intervalScaleProto2.getInterval.call(alignToScale);
  var scaleExtent = getScaleExtent(scale2, axisModel);
  var rawExtent = scaleExtent.extent;
  var isMinFixed = scaleExtent.fixMin;
  var isMaxFixed = scaleExtent.fixMax;
  if (scale2.type === "log") {
    var logBase = mathLog(scale2.base);
    rawExtent = [mathLog(rawExtent[0]) / logBase, mathLog(rawExtent[1]) / logBase];
  }
  scale2.setExtent(rawExtent[0], rawExtent[1]);
  scale2.calcNiceExtent({
    splitNumber: alignToSplitNumber,
    fixMin: isMinFixed,
    fixMax: isMaxFixed
  });
  var extent3 = intervalScaleProto2.getExtent.call(scale2);
  if (isMinFixed) {
    rawExtent[0] = extent3[0];
  }
  if (isMaxFixed) {
    rawExtent[1] = extent3[1];
  }
  var interval = intervalScaleProto2.getInterval.call(scale2);
  var min3 = rawExtent[0];
  var max3 = rawExtent[1];
  if (isMinFixed && isMaxFixed) {
    interval = (max3 - min3) / alignToSplitNumber;
  } else if (isMinFixed) {
    max3 = rawExtent[0] + interval * alignToSplitNumber;
    while (max3 < rawExtent[1] && isFinite(max3) && isFinite(rawExtent[1])) {
      interval = increaseInterval(interval);
      max3 = rawExtent[0] + interval * alignToSplitNumber;
    }
  } else if (isMaxFixed) {
    min3 = rawExtent[1] - interval * alignToSplitNumber;
    while (min3 > rawExtent[0] && isFinite(min3) && isFinite(rawExtent[0])) {
      interval = increaseInterval(interval);
      min3 = rawExtent[1] - interval * alignToSplitNumber;
    }
  } else {
    var nicedSplitNumber = scale2.getTicks().length - 1;
    if (nicedSplitNumber > alignToSplitNumber) {
      interval = increaseInterval(interval);
    }
    var range3 = interval * alignToSplitNumber;
    max3 = Math.ceil(rawExtent[1] / interval) * interval;
    min3 = round$3(max3 - range3);
    if (min3 < 0 && rawExtent[0] >= 0) {
      min3 = 0;
      max3 = round$3(range3);
    } else if (max3 > 0 && rawExtent[1] <= 0) {
      max3 = 0;
      min3 = -round$3(range3);
    }
  }
  var t0 = (alignToTicks[0].value - alignToNicedTicks[0].value) / alignToInterval;
  var t1 = (alignToTicks[alignToSplitNumber].value - alignToNicedTicks[alignToSplitNumber].value) / alignToInterval;
  intervalScaleProto2.setExtent.call(scale2, min3 + interval * t0, max3 + interval * t1);
  intervalScaleProto2.setInterval.call(scale2, interval);
  if (t0 || t1) {
    intervalScaleProto2.setNiceExtent.call(scale2, min3 + interval, max3 - interval);
  }
}
var Grid = function() {
  function Grid2(gridModel, ecModel, api) {
    this.type = "grid";
    this._coordsMap = {};
    this._coordsList = [];
    this._axesMap = {};
    this._axesList = [];
    this.axisPointerEnabled = true;
    this.dimensions = cartesian2DDimensions;
    this._initCartesian(gridModel, ecModel, api);
    this.model = gridModel;
  }
  Grid2.prototype.getRect = function() {
    return this._rect;
  };
  Grid2.prototype.update = function(ecModel, api) {
    var axesMap = this._axesMap;
    this._updateScale(ecModel, this.model);
    function updateAxisTicks(axes) {
      var alignTo;
      var axesIndices = keys(axes);
      var len2 = axesIndices.length;
      if (!len2) {
        return;
      }
      var axisNeedsAlign = [];
      for (var i = len2 - 1; i >= 0; i--) {
        var idx = +axesIndices[i];
        var axis = axes[idx];
        var model = axis.model;
        var scale2 = axis.scale;
        if (isIntervalOrLogScale(scale2) && model.get("alignTicks") && model.get("interval") == null) {
          axisNeedsAlign.push(axis);
        } else {
          niceScaleExtent(scale2, model);
          if (isIntervalOrLogScale(scale2)) {
            alignTo = axis;
          }
        }
      }
      if (axisNeedsAlign.length) {
        if (!alignTo) {
          alignTo = axisNeedsAlign.pop();
          niceScaleExtent(alignTo.scale, alignTo.model);
        }
        each$f(axisNeedsAlign, function(axis2) {
          alignScaleTicks(axis2.scale, axis2.model, alignTo.scale);
        });
      }
    }
    updateAxisTicks(axesMap.x);
    updateAxisTicks(axesMap.y);
    var onZeroRecords = {};
    each$f(axesMap.x, function(xAxis) {
      fixAxisOnZero(axesMap, "y", xAxis, onZeroRecords);
    });
    each$f(axesMap.y, function(yAxis) {
      fixAxisOnZero(axesMap, "x", yAxis, onZeroRecords);
    });
    this.resize(this.model, api);
  };
  Grid2.prototype.resize = function(gridModel, api, ignoreContainLabel) {
    var boxLayoutParams = gridModel.getBoxLayoutParams();
    var isContainLabel = !ignoreContainLabel && gridModel.get("containLabel");
    var gridRect = getLayoutRect(boxLayoutParams, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._rect = gridRect;
    var axesList = this._axesList;
    adjustAxes();
    if (isContainLabel) {
      each$f(axesList, function(axis) {
        if (!axis.model.get(["axisLabel", "inside"])) {
          var labelUnionRect = estimateLabelUnionRect(axis);
          if (labelUnionRect) {
            var dim = axis.isHorizontal() ? "height" : "width";
            var margin = axis.model.get(["axisLabel", "margin"]);
            gridRect[dim] -= labelUnionRect[dim] + margin;
            if (axis.position === "top") {
              gridRect.y += labelUnionRect.height + margin;
            } else if (axis.position === "left") {
              gridRect.x += labelUnionRect.width + margin;
            }
          }
        }
      });
      adjustAxes();
    }
    each$f(this._coordsList, function(coord) {
      coord.calcAffineTransform();
    });
    function adjustAxes() {
      each$f(axesList, function(axis) {
        var isHorizontal = axis.isHorizontal();
        var extent3 = isHorizontal ? [0, gridRect.width] : [0, gridRect.height];
        var idx = axis.inverse ? 1 : 0;
        axis.setExtent(extent3[idx], extent3[1 - idx]);
        updateAxisTransform(axis, isHorizontal ? gridRect.x : gridRect.y);
      });
    }
  };
  Grid2.prototype.getAxis = function(dim, axisIndex) {
    var axesMapOnDim = this._axesMap[dim];
    if (axesMapOnDim != null) {
      return axesMapOnDim[axisIndex || 0];
    }
  };
  Grid2.prototype.getAxes = function() {
    return this._axesList.slice();
  };
  Grid2.prototype.getCartesian = function(xAxisIndex, yAxisIndex) {
    if (xAxisIndex != null && yAxisIndex != null) {
      var key = "x" + xAxisIndex + "y" + yAxisIndex;
      return this._coordsMap[key];
    }
    if (isObject$4(xAxisIndex)) {
      yAxisIndex = xAxisIndex.yAxisIndex;
      xAxisIndex = xAxisIndex.xAxisIndex;
    }
    for (var i = 0, coordList = this._coordsList; i < coordList.length; i++) {
      if (coordList[i].getAxis("x").index === xAxisIndex || coordList[i].getAxis("y").index === yAxisIndex) {
        return coordList[i];
      }
    }
  };
  Grid2.prototype.getCartesians = function() {
    return this._coordsList.slice();
  };
  Grid2.prototype.convertToPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.dataToPoint(value) : target.axis ? target.axis.toGlobalCoord(target.axis.dataToCoord(value)) : null;
  };
  Grid2.prototype.convertFromPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.pointToData(value) : target.axis ? target.axis.coordToData(target.axis.toLocalCoord(value)) : null;
  };
  Grid2.prototype._findConvertTarget = function(finder) {
    var seriesModel = finder.seriesModel;
    var xAxisModel = finder.xAxisModel || seriesModel && seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = finder.yAxisModel || seriesModel && seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    var gridModel = finder.gridModel;
    var coordsList = this._coordsList;
    var cartesian;
    var axis;
    if (seriesModel) {
      cartesian = seriesModel.coordinateSystem;
      indexOf(coordsList, cartesian) < 0 && (cartesian = null);
    } else if (xAxisModel && yAxisModel) {
      cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    } else if (xAxisModel) {
      axis = this.getAxis("x", xAxisModel.componentIndex);
    } else if (yAxisModel) {
      axis = this.getAxis("y", yAxisModel.componentIndex);
    } else if (gridModel) {
      var grid = gridModel.coordinateSystem;
      if (grid === this) {
        cartesian = this._coordsList[0];
      }
    }
    return {
      cartesian,
      axis
    };
  };
  Grid2.prototype.containPoint = function(point) {
    var coord = this._coordsList[0];
    if (coord) {
      return coord.containPoint(point);
    }
  };
  Grid2.prototype._initCartesian = function(gridModel, ecModel, api) {
    var _this = this;
    var grid = this;
    var axisPositionUsed = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };
    var axesMap = {
      x: {},
      y: {}
    };
    var axesCount = {
      x: 0,
      y: 0
    };
    ecModel.eachComponent("xAxis", createAxisCreator("x"), this);
    ecModel.eachComponent("yAxis", createAxisCreator("y"), this);
    if (!axesCount.x || !axesCount.y) {
      this._axesMap = {};
      this._axesList = [];
      return;
    }
    this._axesMap = axesMap;
    each$f(axesMap.x, function(xAxis, xAxisIndex) {
      each$f(axesMap.y, function(yAxis, yAxisIndex) {
        var key = "x" + xAxisIndex + "y" + yAxisIndex;
        var cartesian = new Cartesian2D$1(key);
        cartesian.master = _this;
        cartesian.model = gridModel;
        _this._coordsMap[key] = cartesian;
        _this._coordsList.push(cartesian);
        cartesian.addAxis(xAxis);
        cartesian.addAxis(yAxis);
      });
    });
    function createAxisCreator(dimName) {
      return function(axisModel, idx) {
        if (!isAxisUsedInTheGrid(axisModel, gridModel)) {
          return;
        }
        var axisPosition = axisModel.get("position");
        if (dimName === "x") {
          if (axisPosition !== "top" && axisPosition !== "bottom") {
            axisPosition = axisPositionUsed.bottom ? "top" : "bottom";
          }
        } else {
          if (axisPosition !== "left" && axisPosition !== "right") {
            axisPosition = axisPositionUsed.left ? "right" : "left";
          }
        }
        axisPositionUsed[axisPosition] = true;
        var axis = new Axis2D$1(dimName, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisPosition);
        var isCategory2 = axis.type === "category";
        axis.onBand = isCategory2 && axisModel.get("boundaryGap");
        axis.inverse = axisModel.get("inverse");
        axisModel.axis = axis;
        axis.model = axisModel;
        axis.grid = grid;
        axis.index = idx;
        grid._axesList.push(axis);
        axesMap[dimName][idx] = axis;
        axesCount[dimName]++;
      };
    }
  };
  Grid2.prototype._updateScale = function(ecModel, gridModel) {
    each$f(this._axesList, function(axis) {
      axis.scale.setExtent(Infinity, -Infinity);
      if (axis.type === "category") {
        var categorySortInfo = axis.model.get("categorySortInfo");
        axis.scale.setSortInfo(categorySortInfo);
      }
    });
    ecModel.eachSeries(function(seriesModel) {
      if (isCartesian2DSeries(seriesModel)) {
        var axesModelMap = findAxisModels(seriesModel);
        var xAxisModel = axesModelMap.xAxisModel;
        var yAxisModel = axesModelMap.yAxisModel;
        if (!isAxisUsedInTheGrid(xAxisModel, gridModel) || !isAxisUsedInTheGrid(yAxisModel, gridModel)) {
          return;
        }
        var cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
        var data = seriesModel.getData();
        var xAxis = cartesian.getAxis("x");
        var yAxis = cartesian.getAxis("y");
        unionExtent(data, xAxis);
        unionExtent(data, yAxis);
      }
    }, this);
    function unionExtent(data, axis) {
      each$f(getDataDimensionsOnAxis(data, axis.dim), function(dim) {
        axis.scale.unionExtentFromData(data, dim);
      });
    }
  };
  Grid2.prototype.getTooltipAxes = function(dim) {
    var baseAxes = [];
    var otherAxes = [];
    each$f(this.getCartesians(), function(cartesian) {
      var baseAxis = dim != null && dim !== "auto" ? cartesian.getAxis(dim) : cartesian.getBaseAxis();
      var otherAxis = cartesian.getOtherAxis(baseAxis);
      indexOf(baseAxes, baseAxis) < 0 && baseAxes.push(baseAxis);
      indexOf(otherAxes, otherAxis) < 0 && otherAxes.push(otherAxis);
    });
    return {
      baseAxes,
      otherAxes
    };
  };
  Grid2.create = function(ecModel, api) {
    var grids = [];
    ecModel.eachComponent("grid", function(gridModel, idx) {
      var grid = new Grid2(gridModel, ecModel, api);
      grid.name = "grid_" + idx;
      grid.resize(gridModel, api, true);
      gridModel.coordinateSystem = grid;
      grids.push(grid);
    });
    ecModel.eachSeries(function(seriesModel) {
      if (!isCartesian2DSeries(seriesModel)) {
        return;
      }
      var axesModelMap = findAxisModels(seriesModel);
      var xAxisModel = axesModelMap.xAxisModel;
      var yAxisModel = axesModelMap.yAxisModel;
      var gridModel = xAxisModel.getCoordSysModel();
      var grid = gridModel.coordinateSystem;
      seriesModel.coordinateSystem = grid.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    });
    return grids;
  };
  Grid2.dimensions = cartesian2DDimensions;
  return Grid2;
}();
function isAxisUsedInTheGrid(axisModel, gridModel) {
  return axisModel.getCoordSysModel() === gridModel;
}
function fixAxisOnZero(axesMap, otherAxisDim, axis, onZeroRecords) {
  axis.getAxesOnZeroOf = function() {
    return otherAxisOnZeroOf ? [otherAxisOnZeroOf] : [];
  };
  var otherAxes = axesMap[otherAxisDim];
  var otherAxisOnZeroOf;
  var axisModel = axis.model;
  var onZero = axisModel.get(["axisLine", "onZero"]);
  var onZeroAxisIndex = axisModel.get(["axisLine", "onZeroAxisIndex"]);
  if (!onZero) {
    return;
  }
  if (onZeroAxisIndex != null) {
    if (canOnZeroToAxis(otherAxes[onZeroAxisIndex])) {
      otherAxisOnZeroOf = otherAxes[onZeroAxisIndex];
    }
  } else {
    for (var idx in otherAxes) {
      if (otherAxes.hasOwnProperty(idx) && canOnZeroToAxis(otherAxes[idx]) && !onZeroRecords[getOnZeroRecordKey(otherAxes[idx])]) {
        otherAxisOnZeroOf = otherAxes[idx];
        break;
      }
    }
  }
  if (otherAxisOnZeroOf) {
    onZeroRecords[getOnZeroRecordKey(otherAxisOnZeroOf)] = true;
  }
  function getOnZeroRecordKey(axis2) {
    return axis2.dim + "_" + axis2.index;
  }
}
function canOnZeroToAxis(axis) {
  return axis && axis.type !== "category" && axis.type !== "time" && ifAxisCrossZero(axis);
}
function updateAxisTransform(axis, coordBase) {
  var axisExtent = axis.getExtent();
  var axisExtentSum = axisExtent[0] + axisExtent[1];
  axis.toGlobalCoord = axis.dim === "x" ? function(coord) {
    return coord + coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
  axis.toLocalCoord = axis.dim === "x" ? function(coord) {
    return coord - coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
}
var Grid$1 = Grid;
var PI$3 = Math.PI;
var AxisBuilder = function() {
  function AxisBuilder2(axisModel, opt) {
    this.group = new Group$4();
    this.opt = opt;
    this.axisModel = axisModel;
    defaults(opt, {
      labelOffset: 0,
      nameDirection: 1,
      tickDirection: 1,
      labelDirection: 1,
      silent: true,
      handleAutoShown: function() {
        return true;
      }
    });
    var transformGroup = new Group$4({
      x: opt.position[0],
      y: opt.position[1],
      rotation: opt.rotation
    });
    transformGroup.updateTransform();
    this._transformGroup = transformGroup;
  }
  AxisBuilder2.prototype.hasBuilder = function(name) {
    return !!builders[name];
  };
  AxisBuilder2.prototype.add = function(name) {
    builders[name](this.opt, this.axisModel, this.group, this._transformGroup);
  };
  AxisBuilder2.prototype.getGroup = function() {
    return this.group;
  };
  AxisBuilder2.innerTextLayout = function(axisRotation, textRotation, direction) {
    var rotationDiff = remRadian(textRotation - axisRotation);
    var textAlign;
    var textVerticalAlign;
    if (isRadianAroundZero(rotationDiff)) {
      textVerticalAlign = direction > 0 ? "top" : "bottom";
      textAlign = "center";
    } else if (isRadianAroundZero(rotationDiff - PI$3)) {
      textVerticalAlign = direction > 0 ? "bottom" : "top";
      textAlign = "center";
    } else {
      textVerticalAlign = "middle";
      if (rotationDiff > 0 && rotationDiff < PI$3) {
        textAlign = direction > 0 ? "right" : "left";
      } else {
        textAlign = direction > 0 ? "left" : "right";
      }
    }
    return {
      rotation: rotationDiff,
      textAlign,
      textVerticalAlign
    };
  };
  AxisBuilder2.makeAxisEventDataBase = function(axisModel) {
    var eventData = {
      componentType: axisModel.mainType,
      componentIndex: axisModel.componentIndex
    };
    eventData[axisModel.mainType + "Index"] = axisModel.componentIndex;
    return eventData;
  };
  AxisBuilder2.isLabelSilent = function(axisModel) {
    var tooltipOpt = axisModel.get("tooltip");
    return axisModel.get("silent") || !(axisModel.get("triggerEvent") || tooltipOpt && tooltipOpt.show);
  };
  return AxisBuilder2;
}();
var builders = {
  axisLine: function(opt, axisModel, group, transformGroup) {
    var shown = axisModel.get(["axisLine", "show"]);
    if (shown === "auto" && opt.handleAutoShown) {
      shown = opt.handleAutoShown("axisLine");
    }
    if (!shown) {
      return;
    }
    var extent3 = axisModel.axis.getExtent();
    var matrix = transformGroup.transform;
    var pt12 = [extent3[0], 0];
    var pt22 = [extent3[1], 0];
    if (matrix) {
      applyTransform$1(pt12, pt12, matrix);
      applyTransform$1(pt22, pt22, matrix);
    }
    var lineStyle = extend({
      lineCap: "round"
    }, axisModel.getModel(["axisLine", "lineStyle"]).getLineStyle());
    var line = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: lineStyle,
      strokeContainThreshold: opt.strokeContainThreshold || 5,
      silent: true,
      z2: 1
    });
    line.anid = "line";
    group.add(line);
    var arrows = axisModel.get(["axisLine", "symbol"]);
    if (arrows != null) {
      var arrowSize = axisModel.get(["axisLine", "symbolSize"]);
      if (isString(arrows)) {
        arrows = [arrows, arrows];
      }
      if (isString(arrowSize) || isNumber(arrowSize)) {
        arrowSize = [arrowSize, arrowSize];
      }
      var arrowOffset = normalizeSymbolOffset(axisModel.get(["axisLine", "symbolOffset"]) || 0, arrowSize);
      var symbolWidth_1 = arrowSize[0];
      var symbolHeight_1 = arrowSize[1];
      each$f([{
        rotate: opt.rotation + Math.PI / 2,
        offset: arrowOffset[0],
        r: 0
      }, {
        rotate: opt.rotation - Math.PI / 2,
        offset: arrowOffset[1],
        r: Math.sqrt((pt12[0] - pt22[0]) * (pt12[0] - pt22[0]) + (pt12[1] - pt22[1]) * (pt12[1] - pt22[1]))
      }], function(point, index2) {
        if (arrows[index2] !== "none" && arrows[index2] != null) {
          var symbol = createSymbol$1(arrows[index2], -symbolWidth_1 / 2, -symbolHeight_1 / 2, symbolWidth_1, symbolHeight_1, lineStyle.stroke, true);
          var r2 = point.r + point.offset;
          symbol.attr({
            rotation: point.rotate,
            x: pt12[0] + r2 * Math.cos(opt.rotation),
            y: pt12[1] - r2 * Math.sin(opt.rotation),
            silent: true,
            z2: 11
          });
          group.add(symbol);
        }
      });
    }
  },
  axisTickLabel: function(opt, axisModel, group, transformGroup) {
    var ticksEls = buildAxisMajorTicks(group, transformGroup, axisModel, opt);
    var labelEls = buildAxisLabel(group, transformGroup, axisModel, opt);
    fixMinMaxLabelShow(axisModel, labelEls, ticksEls);
    buildAxisMinorTicks(group, transformGroup, axisModel, opt.tickDirection);
    if (axisModel.get(["axisLabel", "hideOverlap"])) {
      var labelList = prepareLayoutList(map$1(labelEls, function(label) {
        return {
          label,
          priority: label.z2,
          defaultAttr: {
            ignore: label.ignore
          }
        };
      }));
      hideOverlap(labelList);
    }
  },
  axisName: function(opt, axisModel, group, transformGroup) {
    var name = retrieve(opt.axisName, axisModel.get("name"));
    if (!name) {
      return;
    }
    var nameLocation = axisModel.get("nameLocation");
    var nameDirection = opt.nameDirection;
    var textStyleModel = axisModel.getModel("nameTextStyle");
    var gap = axisModel.get("nameGap") || 0;
    var extent3 = axisModel.axis.getExtent();
    var gapSignal = extent3[0] > extent3[1] ? -1 : 1;
    var pos = [
      nameLocation === "start" ? extent3[0] - gapSignal * gap : nameLocation === "end" ? extent3[1] + gapSignal * gap : (extent3[0] + extent3[1]) / 2,
      isNameLocationCenter(nameLocation) ? opt.labelOffset + nameDirection * gap : 0
    ];
    var labelLayout2;
    var nameRotation = axisModel.get("nameRotate");
    if (nameRotation != null) {
      nameRotation = nameRotation * PI$3 / 180;
    }
    var axisNameAvailableWidth;
    if (isNameLocationCenter(nameLocation)) {
      labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, nameRotation != null ? nameRotation : opt.rotation, nameDirection);
    } else {
      labelLayout2 = endTextLayout(opt.rotation, nameLocation, nameRotation || 0, extent3);
      axisNameAvailableWidth = opt.axisNameAvailableWidth;
      if (axisNameAvailableWidth != null) {
        axisNameAvailableWidth = Math.abs(axisNameAvailableWidth / Math.sin(labelLayout2.rotation));
        !isFinite(axisNameAvailableWidth) && (axisNameAvailableWidth = null);
      }
    }
    var textFont = textStyleModel.getFont();
    var truncateOpt = axisModel.get("nameTruncate", true) || {};
    var ellipsis = truncateOpt.ellipsis;
    var maxWidth = retrieve(opt.nameTruncateMaxWidth, truncateOpt.maxWidth, axisNameAvailableWidth);
    var textEl = new ZRText$1({
      x: pos[0],
      y: pos[1],
      rotation: labelLayout2.rotation,
      silent: AxisBuilder.isLabelSilent(axisModel),
      style: createTextStyle(textStyleModel, {
        text: name,
        font: textFont,
        overflow: "truncate",
        width: maxWidth,
        ellipsis,
        fill: textStyleModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]),
        align: textStyleModel.get("align") || labelLayout2.textAlign,
        verticalAlign: textStyleModel.get("verticalAlign") || labelLayout2.textVerticalAlign
      }),
      z2: 1
    });
    setTooltipConfig({
      el: textEl,
      componentModel: axisModel,
      itemName: name
    });
    textEl.__fullText = name;
    textEl.anid = "name";
    if (axisModel.get("triggerEvent")) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisName";
      eventData.name = name;
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    group.add(textEl);
    textEl.decomposeTransform();
  }
};
function endTextLayout(rotation, textPosition, textRotate, extent3) {
  var rotationDiff = remRadian(textRotate - rotation);
  var textAlign;
  var textVerticalAlign;
  var inverse = extent3[0] > extent3[1];
  var onLeft = textPosition === "start" && !inverse || textPosition !== "start" && inverse;
  if (isRadianAroundZero(rotationDiff - PI$3 / 2)) {
    textVerticalAlign = onLeft ? "bottom" : "top";
    textAlign = "center";
  } else if (isRadianAroundZero(rotationDiff - PI$3 * 1.5)) {
    textVerticalAlign = onLeft ? "top" : "bottom";
    textAlign = "center";
  } else {
    textVerticalAlign = "middle";
    if (rotationDiff < PI$3 * 1.5 && rotationDiff > PI$3 / 2) {
      textAlign = onLeft ? "left" : "right";
    } else {
      textAlign = onLeft ? "right" : "left";
    }
  }
  return {
    rotation: rotationDiff,
    textAlign,
    textVerticalAlign
  };
}
function fixMinMaxLabelShow(axisModel, labelEls, tickEls) {
  if (shouldShowAllLabels(axisModel.axis)) {
    return;
  }
  var showMinLabel = axisModel.get(["axisLabel", "showMinLabel"]);
  var showMaxLabel = axisModel.get(["axisLabel", "showMaxLabel"]);
  labelEls = labelEls || [];
  tickEls = tickEls || [];
  var firstLabel = labelEls[0];
  var nextLabel = labelEls[1];
  var lastLabel = labelEls[labelEls.length - 1];
  var prevLabel = labelEls[labelEls.length - 2];
  var firstTick = tickEls[0];
  var nextTick = tickEls[1];
  var lastTick = tickEls[tickEls.length - 1];
  var prevTick = tickEls[tickEls.length - 2];
  if (showMinLabel === false) {
    ignoreEl(firstLabel);
    ignoreEl(firstTick);
  } else if (isTwoLabelOverlapped(firstLabel, nextLabel)) {
    if (showMinLabel) {
      ignoreEl(nextLabel);
      ignoreEl(nextTick);
    } else {
      ignoreEl(firstLabel);
      ignoreEl(firstTick);
    }
  }
  if (showMaxLabel === false) {
    ignoreEl(lastLabel);
    ignoreEl(lastTick);
  } else if (isTwoLabelOverlapped(prevLabel, lastLabel)) {
    if (showMaxLabel) {
      ignoreEl(prevLabel);
      ignoreEl(prevTick);
    } else {
      ignoreEl(lastLabel);
      ignoreEl(lastTick);
    }
  }
}
function ignoreEl(el) {
  el && (el.ignore = true);
}
function isTwoLabelOverlapped(current, next) {
  var firstRect = current && current.getBoundingRect().clone();
  var nextRect = next && next.getBoundingRect().clone();
  if (!firstRect || !nextRect) {
    return;
  }
  var mRotationBack = identity([]);
  rotate(mRotationBack, mRotationBack, -current.rotation);
  firstRect.applyTransform(mul([], mRotationBack, current.getLocalTransform()));
  nextRect.applyTransform(mul([], mRotationBack, next.getLocalTransform()));
  return firstRect.intersect(nextRect);
}
function isNameLocationCenter(nameLocation) {
  return nameLocation === "middle" || nameLocation === "center";
}
function createTicks(ticksCoords, tickTransform, tickEndCoord, tickLineStyle, anidPrefix) {
  var tickEls = [];
  var pt12 = [];
  var pt22 = [];
  for (var i = 0; i < ticksCoords.length; i++) {
    var tickCoord = ticksCoords[i].coord;
    pt12[0] = tickCoord;
    pt12[1] = 0;
    pt22[0] = tickCoord;
    pt22[1] = tickEndCoord;
    if (tickTransform) {
      applyTransform$1(pt12, pt12, tickTransform);
      applyTransform$1(pt22, pt22, tickTransform);
    }
    var tickEl = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: tickLineStyle,
      z2: 2,
      autoBatch: true,
      silent: true
    });
    tickEl.anid = anidPrefix + "_" + ticksCoords[i].tickValue;
    tickEls.push(tickEl);
  }
  return tickEls;
}
function buildAxisMajorTicks(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var tickModel = axisModel.getModel("axisTick");
  var shown = tickModel.get("show");
  if (shown === "auto" && opt.handleAutoShown) {
    shown = opt.handleAutoShown("axisTick");
  }
  if (!shown || axis.scale.isBlank()) {
    return;
  }
  var lineStyleModel = tickModel.getModel("lineStyle");
  var tickEndCoord = opt.tickDirection * tickModel.get("length");
  var ticksCoords = axis.getTicksCoords();
  var ticksEls = createTicks(ticksCoords, transformGroup.transform, tickEndCoord, defaults(lineStyleModel.getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }), "ticks");
  for (var i = 0; i < ticksEls.length; i++) {
    group.add(ticksEls[i]);
  }
  return ticksEls;
}
function buildAxisMinorTicks(group, transformGroup, axisModel, tickDirection) {
  var axis = axisModel.axis;
  var minorTickModel = axisModel.getModel("minorTick");
  if (!minorTickModel.get("show") || axis.scale.isBlank()) {
    return;
  }
  var minorTicksCoords = axis.getMinorTicksCoords();
  if (!minorTicksCoords.length) {
    return;
  }
  var lineStyleModel = minorTickModel.getModel("lineStyle");
  var tickEndCoord = tickDirection * minorTickModel.get("length");
  var minorTickLineStyle = defaults(lineStyleModel.getLineStyle(), defaults(axisModel.getModel("axisTick").getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }));
  for (var i = 0; i < minorTicksCoords.length; i++) {
    var minorTicksEls = createTicks(minorTicksCoords[i], transformGroup.transform, tickEndCoord, minorTickLineStyle, "minorticks_" + i);
    for (var k2 = 0; k2 < minorTicksEls.length; k2++) {
      group.add(minorTicksEls[k2]);
    }
  }
}
function buildAxisLabel(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var show = retrieve(opt.axisLabelShow, axisModel.get(["axisLabel", "show"]));
  if (!show || axis.scale.isBlank()) {
    return;
  }
  var labelModel = axisModel.getModel("axisLabel");
  var labelMargin = labelModel.get("margin");
  var labels = axis.getViewLabels();
  var labelRotation = (retrieve(opt.labelRotate, labelModel.get("rotate")) || 0) * PI$3 / 180;
  var labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, labelRotation, opt.labelDirection);
  var rawCategoryData = axisModel.getCategories && axisModel.getCategories(true);
  var labelEls = [];
  var silent = AxisBuilder.isLabelSilent(axisModel);
  var triggerEvent = axisModel.get("triggerEvent");
  each$f(labels, function(labelItem, index2) {
    var tickValue = axis.scale.type === "ordinal" ? axis.scale.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
    var formattedLabel = labelItem.formattedLabel;
    var rawLabel = labelItem.rawLabel;
    var itemLabelModel = labelModel;
    if (rawCategoryData && rawCategoryData[tickValue]) {
      var rawCategoryItem = rawCategoryData[tickValue];
      if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
        itemLabelModel = new Model$1(rawCategoryItem.textStyle, labelModel, axisModel.ecModel);
      }
    }
    var textColor = itemLabelModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]);
    var tickCoord = axis.dataToCoord(tickValue);
    var textEl = new ZRText$1({
      x: tickCoord,
      y: opt.labelOffset + opt.labelDirection * labelMargin,
      rotation: labelLayout2.rotation,
      silent,
      z2: 10 + (labelItem.level || 0),
      style: createTextStyle(itemLabelModel, {
        text: formattedLabel,
        align: itemLabelModel.getShallow("align", true) || labelLayout2.textAlign,
        verticalAlign: itemLabelModel.getShallow("verticalAlign", true) || itemLabelModel.getShallow("baseline", true) || labelLayout2.textVerticalAlign,
        fill: isFunction(textColor) ? textColor(axis.type === "category" ? rawLabel : axis.type === "value" ? tickValue + "" : tickValue, index2) : textColor
      })
    });
    textEl.anid = "label_" + tickValue;
    if (triggerEvent) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisLabel";
      eventData.value = rawLabel;
      eventData.tickIndex = index2;
      if (axis.type === "category") {
        eventData.dataIndex = tickValue;
      }
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    labelEls.push(textEl);
    group.add(textEl);
    textEl.decomposeTransform();
  });
  return labelEls;
}
var AxisBuilder$1 = AxisBuilder;
function collect(ecModel, api) {
  var result = {
    axesInfo: {},
    seriesInvolved: false,
    coordSysAxesInfo: {},
    coordSysMap: {}
  };
  collectAxesInfo(result, ecModel, api);
  result.seriesInvolved && collectSeriesInfo(result, ecModel);
  return result;
}
function collectAxesInfo(result, ecModel, api) {
  var globalTooltipModel = ecModel.getComponent("tooltip");
  var globalAxisPointerModel = ecModel.getComponent("axisPointer");
  var linksOption = globalAxisPointerModel.get("link", true) || [];
  var linkGroups = [];
  each$f(api.getCoordinateSystems(), function(coordSys) {
    if (!coordSys.axisPointerEnabled) {
      return;
    }
    var coordSysKey = makeKey(coordSys.model);
    var axesInfoInCoordSys = result.coordSysAxesInfo[coordSysKey] = {};
    result.coordSysMap[coordSysKey] = coordSys;
    var coordSysModel = coordSys.model;
    var baseTooltipModel = coordSysModel.getModel("tooltip", globalTooltipModel);
    each$f(coordSys.getAxes(), curry$1(saveTooltipAxisInfo, false, null));
    if (coordSys.getTooltipAxes && globalTooltipModel && baseTooltipModel.get("show")) {
      var triggerAxis = baseTooltipModel.get("trigger") === "axis";
      var cross = baseTooltipModel.get(["axisPointer", "type"]) === "cross";
      var tooltipAxes = coordSys.getTooltipAxes(baseTooltipModel.get(["axisPointer", "axis"]));
      if (triggerAxis || cross) {
        each$f(tooltipAxes.baseAxes, curry$1(saveTooltipAxisInfo, cross ? "cross" : true, triggerAxis));
      }
      if (cross) {
        each$f(tooltipAxes.otherAxes, curry$1(saveTooltipAxisInfo, "cross", false));
      }
    }
    function saveTooltipAxisInfo(fromTooltip, triggerTooltip, axis) {
      var axisPointerModel = axis.model.getModel("axisPointer", globalAxisPointerModel);
      var axisPointerShow = axisPointerModel.get("show");
      if (!axisPointerShow || axisPointerShow === "auto" && !fromTooltip && !isHandleTrigger(axisPointerModel)) {
        return;
      }
      if (triggerTooltip == null) {
        triggerTooltip = axisPointerModel.get("triggerTooltip");
      }
      axisPointerModel = fromTooltip ? makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) : axisPointerModel;
      var snap = axisPointerModel.get("snap");
      var axisKey = makeKey(axis.model);
      var involveSeries = triggerTooltip || snap || axis.type === "category";
      var axisInfo = result.axesInfo[axisKey] = {
        key: axisKey,
        axis,
        coordSys,
        axisPointerModel,
        triggerTooltip,
        involveSeries,
        snap,
        useHandle: isHandleTrigger(axisPointerModel),
        seriesModels: [],
        linkGroup: null
      };
      axesInfoInCoordSys[axisKey] = axisInfo;
      result.seriesInvolved = result.seriesInvolved || involveSeries;
      var groupIndex = getLinkGroupIndex(linksOption, axis);
      if (groupIndex != null) {
        var linkGroup = linkGroups[groupIndex] || (linkGroups[groupIndex] = {
          axesInfo: {}
        });
        linkGroup.axesInfo[axisKey] = axisInfo;
        linkGroup.mapper = linksOption[groupIndex].mapper;
        axisInfo.linkGroup = linkGroup;
      }
    }
  });
}
function makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) {
  var tooltipAxisPointerModel = baseTooltipModel.getModel("axisPointer");
  var fields = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"];
  var volatileOption = {};
  each$f(fields, function(field) {
    volatileOption[field] = clone$4(tooltipAxisPointerModel.get(field));
  });
  volatileOption.snap = axis.type !== "category" && !!triggerTooltip;
  if (tooltipAxisPointerModel.get("type") === "cross") {
    volatileOption.type = "line";
  }
  var labelOption = volatileOption.label || (volatileOption.label = {});
  labelOption.show == null && (labelOption.show = false);
  if (fromTooltip === "cross") {
    var tooltipAxisPointerLabelShow = tooltipAxisPointerModel.get(["label", "show"]);
    labelOption.show = tooltipAxisPointerLabelShow != null ? tooltipAxisPointerLabelShow : true;
    if (!triggerTooltip) {
      var crossStyle = volatileOption.lineStyle = tooltipAxisPointerModel.get("crossStyle");
      crossStyle && defaults(labelOption, crossStyle.textStyle);
    }
  }
  return axis.model.getModel("axisPointer", new Model$1(volatileOption, globalAxisPointerModel, ecModel));
}
function collectSeriesInfo(result, ecModel) {
  ecModel.eachSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesTooltipTrigger = seriesModel.get(["tooltip", "trigger"], true);
    var seriesTooltipShow = seriesModel.get(["tooltip", "show"], true);
    if (!coordSys || seriesTooltipTrigger === "none" || seriesTooltipTrigger === false || seriesTooltipTrigger === "item" || seriesTooltipShow === false || seriesModel.get(["axisPointer", "show"], true) === false) {
      return;
    }
    each$f(result.coordSysAxesInfo[makeKey(coordSys.model)], function(axisInfo) {
      var axis = axisInfo.axis;
      if (coordSys.getAxis(axis.dim) === axis) {
        axisInfo.seriesModels.push(seriesModel);
        axisInfo.seriesDataCount == null && (axisInfo.seriesDataCount = 0);
        axisInfo.seriesDataCount += seriesModel.getData().count();
      }
    });
  });
}
function getLinkGroupIndex(linksOption, axis) {
  var axisModel = axis.model;
  var dim = axis.dim;
  for (var i = 0; i < linksOption.length; i++) {
    var linkOption = linksOption[i] || {};
    if (checkPropInLink(linkOption[dim + "AxisId"], axisModel.id) || checkPropInLink(linkOption[dim + "AxisIndex"], axisModel.componentIndex) || checkPropInLink(linkOption[dim + "AxisName"], axisModel.name)) {
      return i;
    }
  }
}
function checkPropInLink(linkPropValue, axisPropValue) {
  return linkPropValue === "all" || isArray$1(linkPropValue) && indexOf(linkPropValue, axisPropValue) >= 0 || linkPropValue === axisPropValue;
}
function fixValue(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  if (!axisInfo) {
    return;
  }
  var axisPointerModel = axisInfo.axisPointerModel;
  var scale2 = axisInfo.axis.scale;
  var option = axisPointerModel.option;
  var status = axisPointerModel.get("status");
  var value = axisPointerModel.get("value");
  if (value != null) {
    value = scale2.parse(value);
  }
  var useHandle = isHandleTrigger(axisPointerModel);
  if (status == null) {
    option.status = useHandle ? "show" : "hide";
  }
  var extent3 = scale2.getExtent().slice();
  extent3[0] > extent3[1] && extent3.reverse();
  if (value == null || value > extent3[1]) {
    value = extent3[1];
  }
  if (value < extent3[0]) {
    value = extent3[0];
  }
  option.value = value;
  if (useHandle) {
    option.status = axisInfo.axis.scale.isBlank() ? "hide" : "show";
  }
}
function getAxisInfo$1(axisModel) {
  var coordSysAxesInfo = (axisModel.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
  return coordSysAxesInfo && coordSysAxesInfo.axesInfo[makeKey(axisModel)];
}
function getAxisPointerModel(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  return axisInfo && axisInfo.axisPointerModel;
}
function isHandleTrigger(axisPointerModel) {
  return !!axisPointerModel.get(["handle", "show"]);
}
function makeKey(model) {
  return model.type + "||" + model.id;
}
var axisPointerClazz = {};
var AxisView = function(_super) {
  __extends(AxisView2, _super);
  function AxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisView2.type;
    return _this;
  }
  AxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.axisPointerClass && fixValue(axisModel);
    _super.prototype.render.apply(this, arguments);
    this._doUpdateAxisPointerClass(axisModel, api, true);
  };
  AxisView2.prototype.updateAxisPointer = function(axisModel, ecModel, api, payload) {
    this._doUpdateAxisPointerClass(axisModel, api, false);
  };
  AxisView2.prototype.remove = function(ecModel, api) {
    var axisPointer = this._axisPointer;
    axisPointer && axisPointer.remove(api);
  };
  AxisView2.prototype.dispose = function(ecModel, api) {
    this._disposeAxisPointer(api);
    _super.prototype.dispose.apply(this, arguments);
  };
  AxisView2.prototype._doUpdateAxisPointerClass = function(axisModel, api, forceRender) {
    var Clazz = AxisView2.getAxisPointerClass(this.axisPointerClass);
    if (!Clazz) {
      return;
    }
    var axisPointerModel = getAxisPointerModel(axisModel);
    axisPointerModel ? (this._axisPointer || (this._axisPointer = new Clazz())).render(axisModel, axisPointerModel, api, forceRender) : this._disposeAxisPointer(api);
  };
  AxisView2.prototype._disposeAxisPointer = function(api) {
    this._axisPointer && this._axisPointer.dispose(api);
    this._axisPointer = null;
  };
  AxisView2.registerAxisPointerClass = function(type4, clazz) {
    axisPointerClazz[type4] = clazz;
  };
  AxisView2.getAxisPointerClass = function(type4) {
    return type4 && axisPointerClazz[type4];
  };
  AxisView2.type = "axis";
  return AxisView2;
}(ComponentView$1);
var AxisView$1 = AxisView;
var inner$f = makeInner();
function rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel) {
  var axis = axisModel.axis;
  if (axis.scale.isBlank()) {
    return;
  }
  var splitAreaModel = axisModel.getModel("splitArea");
  var areaStyleModel = splitAreaModel.getModel("areaStyle");
  var areaColors = areaStyleModel.get("color");
  var gridRect = gridModel.coordinateSystem.getRect();
  var ticksCoords = axis.getTicksCoords({
    tickModel: splitAreaModel,
    clamp: true
  });
  if (!ticksCoords.length) {
    return;
  }
  var areaColorsLen = areaColors.length;
  var lastSplitAreaColors = inner$f(axisView).splitAreaColors;
  var newSplitAreaColors = createHashMap();
  var colorIndex = 0;
  if (lastSplitAreaColors) {
    for (var i = 0; i < ticksCoords.length; i++) {
      var cIndex = lastSplitAreaColors.get(ticksCoords[i].tickValue);
      if (cIndex != null) {
        colorIndex = (cIndex + (areaColorsLen - 1) * i) % areaColorsLen;
        break;
      }
    }
  }
  var prev = axis.toGlobalCoord(ticksCoords[0].coord);
  var areaStyle = areaStyleModel.getAreaStyle();
  areaColors = isArray$1(areaColors) ? areaColors : [areaColors];
  for (var i = 1; i < ticksCoords.length; i++) {
    var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
    var x2 = void 0;
    var y2 = void 0;
    var width = void 0;
    var height = void 0;
    if (axis.isHorizontal()) {
      x2 = prev;
      y2 = gridRect.y;
      width = tickCoord - x2;
      height = gridRect.height;
      prev = x2 + width;
    } else {
      x2 = gridRect.x;
      y2 = prev;
      width = gridRect.width;
      height = tickCoord - y2;
      prev = y2 + height;
    }
    var tickValue = ticksCoords[i - 1].tickValue;
    tickValue != null && newSplitAreaColors.set(tickValue, colorIndex);
    axisGroup.add(new Rect$3({
      anid: tickValue != null ? "area_" + tickValue : null,
      shape: {
        x: x2,
        y: y2,
        width,
        height
      },
      style: defaults({
        fill: areaColors[colorIndex]
      }, areaStyle),
      autoBatch: true,
      silent: true
    }));
    colorIndex = (colorIndex + 1) % areaColorsLen;
  }
  inner$f(axisView).splitAreaColors = newSplitAreaColors;
}
function rectCoordAxisHandleRemove(axisView) {
  inner$f(axisView).splitAreaColors = null;
}
var axisBuilderAttrs$3 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$2 = ["splitArea", "splitLine", "minorSplitLine"];
var CartesianAxisView = function(_super) {
  __extends(CartesianAxisView2, _super);
  function CartesianAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianAxisView2.type;
    _this.axisPointerClass = "CartesianAxisPointer";
    return _this;
  }
  CartesianAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var gridModel = axisModel.getCoordSysModel();
    var layout2 = layout$2(gridModel, axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, extend({
      handleAutoShown: function(elementType) {
        var cartesians = gridModel.coordinateSystem.getCartesians();
        for (var i = 0; i < cartesians.length; i++) {
          if (isIntervalOrLogScale(cartesians[i].getOtherAxis(axisModel.axis).scale)) {
            return true;
          }
        }
        return false;
      }
    }, layout2));
    each$f(axisBuilderAttrs$3, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs$2, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders$2[name](this, this._axisGroup, axisModel, gridModel);
      }
    }, this);
    var isInitialSortFromBarRacing = payload && payload.type === "changeAxisOrder" && payload.isInitSort;
    if (!isInitialSortFromBarRacing) {
      groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    }
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  CartesianAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  CartesianAxisView2.type = "cartesianAxis";
  return CartesianAxisView2;
}(AxisView$1);
var axisElementBuilders$2 = {
  splitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = isArray$1(lineColors) ? lineColors : [lineColors];
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < ticksCoords.length; i++) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      var tickValue = ticksCoords[i].tickValue;
      axisGroup.add(new Line$3({
        anid: tickValue != null ? "line_" + ticksCoords[i].tickValue : null,
        subPixelOptimize: true,
        autoBatch: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        style: defaults({
          stroke: lineColors[colorIndex]
        }, lineStyle),
        silent: true
      }));
    }
  },
  minorSplitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    var minorSplitLineModel = axisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var minorTicksCoords = axis.getMinorTicksCoords();
    if (!minorTicksCoords.length) {
      return;
    }
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        var tickCoord = axis.toGlobalCoord(minorTicksCoords[i][k2].coord);
        if (isHorizontal) {
          p1[0] = tickCoord;
          p1[1] = gridRect.y;
          p2[0] = tickCoord;
          p2[1] = gridRect.y + gridRect.height;
        } else {
          p1[0] = gridRect.x;
          p1[1] = tickCoord;
          p2[0] = gridRect.x + gridRect.width;
          p2[1] = tickCoord;
        }
        axisGroup.add(new Line$3({
          anid: "minor_line_" + minorTicksCoords[i][k2].tickValue,
          subPixelOptimize: true,
          autoBatch: true,
          shape: {
            x1: p1[0],
            y1: p1[1],
            x2: p2[0],
            y2: p2[1]
          },
          style: lineStyle,
          silent: true
        }));
      }
    }
  },
  splitArea: function(axisView, axisGroup, axisModel, gridModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel);
  }
};
var CartesianXAxisView = function(_super) {
  __extends(CartesianXAxisView2, _super);
  function CartesianXAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView2.type;
    return _this;
  }
  CartesianXAxisView2.type = "xAxis";
  return CartesianXAxisView2;
}(CartesianAxisView);
var CartesianYAxisView = function(_super) {
  __extends(CartesianYAxisView2, _super);
  function CartesianYAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView.type;
    return _this;
  }
  CartesianYAxisView2.type = "yAxis";
  return CartesianYAxisView2;
}(CartesianAxisView);
var GridView = function(_super) {
  __extends(GridView2, _super);
  function GridView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "grid";
    return _this;
  }
  GridView2.prototype.render = function(gridModel, ecModel) {
    this.group.removeAll();
    if (gridModel.get("show")) {
      this.group.add(new Rect$3({
        shape: gridModel.coordinateSystem.getRect(),
        style: defaults({
          fill: gridModel.get("backgroundColor")
        }, gridModel.getItemStyle()),
        silent: true,
        z2: -1
      }));
    }
  };
  GridView2.type = "grid";
  return GridView2;
}(ComponentView$1);
var extraOption = {
  offset: 0
};
function install$N(registers) {
  registers.registerComponentView(GridView);
  registers.registerComponentModel(GridModel$1);
  registers.registerCoordinateSystem("cartesian2d", Grid$1);
  axisModelCreator(registers, "x", CartesianAxisModel, extraOption);
  axisModelCreator(registers, "y", CartesianAxisModel, extraOption);
  registers.registerComponentView(CartesianXAxisView);
  registers.registerComponentView(CartesianYAxisView);
  registers.registerPreprocessor(function(option) {
    if (option.xAxis && option.yAxis && !option.grid) {
      option.grid = {};
    }
  });
}
function install$M(registers) {
  use(install$N);
  registers.registerSeriesModel(ScatterSeriesModel$1);
  registers.registerChartView(ScatterView$1);
  registers.registerLayout(pointsLayout("scatter"));
}
function radarLayout(ecModel) {
  ecModel.eachSeriesByType("radar", function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var axes = coordSys.getIndicatorAxes();
    each$f(axes, function(axis, axisIndex) {
      data.each(data.mapDimension(axes[axisIndex].dim), function(val, dataIndex) {
        points2[dataIndex] = points2[dataIndex] || [];
        var point = coordSys.dataToPoint(val, axisIndex);
        points2[dataIndex][axisIndex] = isValidPoint(point) ? point : getValueMissingPoint(coordSys);
      });
    });
    data.each(function(idx) {
      var firstPoint = find(points2[idx], function(point) {
        return isValidPoint(point);
      }) || getValueMissingPoint(coordSys);
      points2[idx].push(firstPoint.slice());
      data.setItemLayout(idx, points2[idx]);
    });
  });
}
function isValidPoint(point) {
  return !isNaN(point[0]) && !isNaN(point[1]);
}
function getValueMissingPoint(coordSys) {
  return [coordSys.cx, coordSys.cy];
}
function radarBackwardCompat(option) {
  var polarOptArr = option.polar;
  if (polarOptArr) {
    if (!isArray$1(polarOptArr)) {
      polarOptArr = [polarOptArr];
    }
    var polarNotRadar_1 = [];
    each$f(polarOptArr, function(polarOpt, idx) {
      if (polarOpt.indicator) {
        if (polarOpt.type && !polarOpt.shape) {
          polarOpt.shape = polarOpt.type;
        }
        option.radar = option.radar || [];
        if (!isArray$1(option.radar)) {
          option.radar = [option.radar];
        }
        option.radar.push(polarOpt);
      } else {
        polarNotRadar_1.push(polarOpt);
      }
    });
    option.polar = polarNotRadar_1;
  }
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "radar" && seriesOpt.polarIndex) {
      seriesOpt.radarIndex = seriesOpt.polarIndex;
    }
  });
}
var RadarView$2 = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(seriesModel, ecModel, api) {
    var polar = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    function createSymbol2(data2, idx) {
      var symbolType = data2.getItemVisual(idx, "symbol") || "circle";
      if (symbolType === "none") {
        return;
      }
      var symbolSize = normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
      var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2);
      var symbolRotate = data2.getItemVisual(idx, "symbolRotate") || 0;
      symbolPath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 100,
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2,
        rotation: symbolRotate * Math.PI / 180 || 0
      });
      return symbolPath;
    }
    function updateSymbols(oldPoints, newPoints, symbolGroup, data2, idx, isInit) {
      symbolGroup.removeAll();
      for (var i = 0; i < newPoints.length - 1; i++) {
        var symbolPath = createSymbol2(data2, idx);
        if (symbolPath) {
          symbolPath.__dimIdx = i;
          if (oldPoints[i]) {
            symbolPath.setPosition(oldPoints[i]);
            graphic[isInit ? "initProps" : "updateProps"](symbolPath, {
              x: newPoints[i][0],
              y: newPoints[i][1]
            }, seriesModel, idx);
          } else {
            symbolPath.setPosition(newPoints[i]);
          }
          symbolGroup.add(symbolPath);
        }
      }
    }
    function getInitialPoints(points2) {
      return map$1(points2, function(pt) {
        return [polar.cx, polar.cy];
      });
    }
    data.diff(oldData).add(function(idx) {
      var points2 = data.getItemLayout(idx);
      if (!points2) {
        return;
      }
      var polygon = new Polygon$1();
      var polyline = new Polyline$3();
      var target = {
        shape: {
          points: points2
        }
      };
      polygon.shape.points = getInitialPoints(points2);
      polyline.shape.points = getInitialPoints(points2);
      initProps(polygon, target, seriesModel, idx);
      initProps(polyline, target, seriesModel, idx);
      var itemGroup = new Group$4();
      var symbolGroup = new Group$4();
      itemGroup.add(polyline);
      itemGroup.add(polygon);
      itemGroup.add(symbolGroup);
      updateSymbols(polyline.shape.points, points2, symbolGroup, data, idx, true);
      data.setItemGraphicEl(idx, itemGroup);
    }).update(function(newIdx, oldIdx) {
      var itemGroup = oldData.getItemGraphicEl(oldIdx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var target = {
        shape: {
          points: data.getItemLayout(newIdx)
        }
      };
      if (!target.shape.points) {
        return;
      }
      updateSymbols(polyline.shape.points, target.shape.points, symbolGroup, data, newIdx, false);
      saveOldStyle(polygon);
      saveOldStyle(polyline);
      updateProps$1(polyline, target, seriesModel);
      updateProps$1(polygon, target, seriesModel);
      data.setItemGraphicEl(newIdx, itemGroup);
    }).remove(function(idx) {
      group.remove(oldData.getItemGraphicEl(idx));
    }).execute();
    data.eachItemGraphicEl(function(itemGroup, idx) {
      var itemModel = data.getItemModel(idx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var itemStyle = data.getItemVisual(idx, "style");
      var color = itemStyle.fill;
      group.add(itemGroup);
      polyline.useStyle(defaults(itemModel.getModel("lineStyle").getLineStyle(), {
        fill: "none",
        stroke: color
      }));
      setStatesStylesFromModel(polyline, itemModel, "lineStyle");
      setStatesStylesFromModel(polygon, itemModel, "areaStyle");
      var areaStyleModel = itemModel.getModel("areaStyle");
      var polygonIgnore = areaStyleModel.isEmpty() && areaStyleModel.parentModel.isEmpty();
      polygon.ignore = polygonIgnore;
      each$f(["emphasis", "select", "blur"], function(stateName) {
        var stateModel = itemModel.getModel([stateName, "areaStyle"]);
        var stateIgnore = stateModel.isEmpty() && stateModel.parentModel.isEmpty();
        polygon.ensureState(stateName).ignore = stateIgnore && polygonIgnore;
      });
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: color,
        opacity: 0.7,
        decal: itemStyle.decal
      }));
      var emphasisModel = itemModel.getModel("emphasis");
      var itemHoverStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      symbolGroup.eachChild(function(symbolPath) {
        if (symbolPath instanceof ZRImage$1) {
          var pathStyle = symbolPath.style;
          symbolPath.useStyle(extend({
            image: pathStyle.image,
            x: pathStyle.x,
            y: pathStyle.y,
            width: pathStyle.width,
            height: pathStyle.height
          }, itemStyle));
        } else {
          symbolPath.useStyle(itemStyle);
          symbolPath.setColor(color);
          symbolPath.style.strokeNoScale = true;
        }
        var pathEmphasisState = symbolPath.ensureState("emphasis");
        pathEmphasisState.style = clone$4(itemHoverStyle);
        var defaultText = data.getStore().get(data.getDimensionIndex(symbolPath.__dimIdx), idx);
        (defaultText == null || isNaN(defaultText)) && (defaultText = "");
        setLabelStyle(symbolPath, getLabelStatesModels(itemModel), {
          labelFetcher: data.hostModel,
          labelDataIndex: idx,
          labelDimIndex: symbolPath.__dimIdx,
          defaultText,
          inheritColor: color,
          defaultOpacity: itemStyle.opacity
        });
      });
      toggleHoverEmphasis(itemGroup, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    this._data = data;
  };
  RadarView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ChartView$1);
var RadarView$3 = RadarView$2;
var RadarSeriesModel = function(_super) {
  __extends(RadarSeriesModel2, _super);
  function RadarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  RadarSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  RadarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      generateCoord: "indicator_",
      generateCoordCount: Infinity
    });
  };
  RadarSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var coordSys = this.coordinateSystem;
    var indicatorAxes = coordSys.getIndicatorAxes();
    var name = this.getData().getName(dataIndex);
    var nameToDisplay = name === "" ? this.name : name;
    var markerColor = retrieveVisualColorForTooltipMarker(this, dataIndex);
    return createTooltipMarkup("section", {
      header: nameToDisplay,
      sortBlocks: true,
      blocks: map$1(indicatorAxes, function(axis) {
        var val = data.get(data.mapDimension(axis.dim), dataIndex);
        return createTooltipMarkup("nameValue", {
          markerType: "subItem",
          markerColor,
          name: axis.name,
          value: val,
          sortParam: val
        });
      })
    });
  };
  RadarSeriesModel2.prototype.getTooltipPosition = function(dataIndex) {
    if (dataIndex != null) {
      var data_1 = this.getData();
      var coordSys = this.coordinateSystem;
      var values = data_1.getValues(map$1(coordSys.dimensions, function(dim) {
        return data_1.mapDimension(dim);
      }), dataIndex);
      for (var i = 0, len2 = values.length; i < len2; i++) {
        if (!isNaN(values[i])) {
          var indicatorAxes = coordSys.getIndicatorAxes();
          return coordSys.coordToPoint(indicatorAxes[i].dataToCoord(values[i]), i);
        }
      }
    }
  };
  RadarSeriesModel2.type = "series.radar";
  RadarSeriesModel2.dependencies = ["radar"];
  RadarSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "radar",
    legendHoverLink: true,
    radarIndex: 0,
    lineStyle: {
      width: 2,
      type: "solid",
      join: "round"
    },
    label: {
      position: "top"
    },
    symbolSize: 8
  };
  return RadarSeriesModel2;
}(SeriesModel$1);
var RadarSeriesModel$1 = RadarSeriesModel;
var valueAxisDefault = axisDefault.value;
function defaultsShow(opt, show) {
  return defaults({
    show
  }, opt);
}
var RadarModel = function(_super) {
  __extends(RadarModel2, _super);
  function RadarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarModel2.type;
    return _this;
  }
  RadarModel2.prototype.optionUpdated = function() {
    var boundaryGap = this.get("boundaryGap");
    var splitNumber = this.get("splitNumber");
    var scale2 = this.get("scale");
    var axisLine = this.get("axisLine");
    var axisTick = this.get("axisTick");
    var axisLabel = this.get("axisLabel");
    var nameTextStyle = this.get("axisName");
    var showName = this.get(["axisName", "show"]);
    var nameFormatter = this.get(["axisName", "formatter"]);
    var nameGap = this.get("axisNameGap");
    var triggerEvent = this.get("triggerEvent");
    var indicatorModels = map$1(this.get("indicator") || [], function(indicatorOpt) {
      if (indicatorOpt.max != null && indicatorOpt.max > 0 && !indicatorOpt.min) {
        indicatorOpt.min = 0;
      } else if (indicatorOpt.min != null && indicatorOpt.min < 0 && !indicatorOpt.max) {
        indicatorOpt.max = 0;
      }
      var iNameTextStyle = nameTextStyle;
      if (indicatorOpt.color != null) {
        iNameTextStyle = defaults({
          color: indicatorOpt.color
        }, nameTextStyle);
      }
      var innerIndicatorOpt = merge(clone$4(indicatorOpt), {
        boundaryGap,
        splitNumber,
        scale: scale2,
        axisLine,
        axisTick,
        axisLabel,
        name: indicatorOpt.text,
        showName,
        nameLocation: "end",
        nameGap,
        nameTextStyle: iNameTextStyle,
        triggerEvent
      }, false);
      if (!showName) {
        innerIndicatorOpt.name = "";
      }
      if (isString(nameFormatter)) {
        var indName = innerIndicatorOpt.name;
        innerIndicatorOpt.name = nameFormatter.replace("{value}", indName != null ? indName : "");
      } else if (isFunction(nameFormatter)) {
        innerIndicatorOpt.name = nameFormatter(innerIndicatorOpt.name, innerIndicatorOpt);
      }
      var model = new Model$1(innerIndicatorOpt, null, this.ecModel);
      mixin(model, AxisModelCommonMixin.prototype);
      model.mainType = "radar";
      model.componentIndex = this.componentIndex;
      return model;
    }, this);
    this._indicatorModels = indicatorModels;
  };
  RadarModel2.prototype.getIndicatorModels = function() {
    return this._indicatorModels;
  };
  RadarModel2.type = "radar";
  RadarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "75%",
    startAngle: 90,
    axisName: {
      show: true
    },
    boundaryGap: [0, 0],
    splitNumber: 5,
    axisNameGap: 15,
    scale: false,
    shape: "polygon",
    axisLine: merge({
      lineStyle: {
        color: "#bbb"
      }
    }, valueAxisDefault.axisLine),
    axisLabel: defaultsShow(valueAxisDefault.axisLabel, false),
    axisTick: defaultsShow(valueAxisDefault.axisTick, false),
    splitLine: defaultsShow(valueAxisDefault.splitLine, true),
    splitArea: defaultsShow(valueAxisDefault.splitArea, true),
    indicator: []
  };
  return RadarModel2;
}(ComponentModel$1);
var RadarModel$1 = RadarModel;
var axisBuilderAttrs$2 = ["axisLine", "axisTickLabel", "axisName"];
var RadarView = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(radarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    this._buildAxes(radarModel);
    this._buildSplitLineAndArea(radarModel);
  };
  RadarView2.prototype._buildAxes = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    var axisBuilders = map$1(indicatorAxes, function(indicatorAxis) {
      var axisName = indicatorAxis.model.get("showName") ? indicatorAxis.name : "";
      var axisBuilder = new AxisBuilder$1(indicatorAxis.model, {
        axisName,
        position: [radar.cx, radar.cy],
        rotation: indicatorAxis.angle,
        labelDirection: -1,
        tickDirection: -1,
        nameDirection: 1
      });
      return axisBuilder;
    });
    each$f(axisBuilders, function(axisBuilder) {
      each$f(axisBuilderAttrs$2, axisBuilder.add, axisBuilder);
      this.group.add(axisBuilder.getGroup());
    }, this);
  };
  RadarView2.prototype._buildSplitLineAndArea = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    if (!indicatorAxes.length) {
      return;
    }
    var shape = radarModel.get("shape");
    var splitLineModel = radarModel.getModel("splitLine");
    var splitAreaModel = radarModel.getModel("splitArea");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var showSplitLine = splitLineModel.get("show");
    var showSplitArea = splitAreaModel.get("show");
    var splitLineColors = lineStyleModel.get("color");
    var splitAreaColors = areaStyleModel.get("color");
    var splitLineColorsArr = isArray$1(splitLineColors) ? splitLineColors : [splitLineColors];
    var splitAreaColorsArr = isArray$1(splitAreaColors) ? splitAreaColors : [splitAreaColors];
    var splitLines = [];
    var splitAreas = [];
    function getColorIndex(areaOrLine, areaOrLineColorList, idx) {
      var colorIndex2 = idx % areaOrLineColorList.length;
      areaOrLine[colorIndex2] = areaOrLine[colorIndex2] || [];
      return colorIndex2;
    }
    if (shape === "circle") {
      var ticksRadius = indicatorAxes[0].getTicksCoords();
      var cx = radar.cx;
      var cy = radar.cy;
      for (var i = 0; i < ticksRadius.length; i++) {
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Circle$1({
            shape: {
              cx,
              cy,
              r: ticksRadius[i].coord
            }
          }));
        }
        if (showSplitArea && i < ticksRadius.length - 1) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i);
          splitAreas[colorIndex].push(new Ring$1({
            shape: {
              cx,
              cy,
              r0: ticksRadius[i].coord,
              r: ticksRadius[i + 1].coord
            }
          }));
        }
      }
    } else {
      var realSplitNumber_1;
      var axesTicksPoints = map$1(indicatorAxes, function(indicatorAxis, idx) {
        var ticksCoords = indicatorAxis.getTicksCoords();
        realSplitNumber_1 = realSplitNumber_1 == null ? ticksCoords.length - 1 : Math.min(ticksCoords.length - 1, realSplitNumber_1);
        return map$1(ticksCoords, function(tickCoord) {
          return radar.coordToPoint(tickCoord.coord, idx);
        });
      });
      var prevPoints = [];
      for (var i = 0; i <= realSplitNumber_1; i++) {
        var points2 = [];
        for (var j = 0; j < indicatorAxes.length; j++) {
          points2.push(axesTicksPoints[j][i]);
        }
        if (points2[0]) {
          points2.push(points2[0].slice());
        }
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Polyline$3({
            shape: {
              points: points2
            }
          }));
        }
        if (showSplitArea && prevPoints) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i - 1);
          splitAreas[colorIndex].push(new Polygon$1({
            shape: {
              points: points2.concat(prevPoints)
            }
          }));
        }
        prevPoints = points2.slice().reverse();
      }
    }
    var lineStyle = lineStyleModel.getLineStyle();
    var areaStyle = areaStyleModel.getAreaStyle();
    each$f(splitAreas, function(splitAreas2, idx) {
      this.group.add(mergePath(splitAreas2, {
        style: defaults({
          stroke: "none",
          fill: splitAreaColorsArr[idx % splitAreaColorsArr.length]
        }, areaStyle),
        silent: true
      }));
    }, this);
    each$f(splitLines, function(splitLines2, idx) {
      this.group.add(mergePath(splitLines2, {
        style: defaults({
          fill: "none",
          stroke: splitLineColorsArr[idx % splitLineColorsArr.length]
        }, lineStyle),
        silent: true
      }));
    }, this);
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ComponentView$1);
var RadarView$1 = RadarView;
var IndicatorAxis = function(_super) {
  __extends(IndicatorAxis2, _super);
  function IndicatorAxis2(dim, scale2, radiusExtent) {
    var _this = _super.call(this, dim, scale2, radiusExtent) || this;
    _this.type = "value";
    _this.angle = 0;
    _this.name = "";
    return _this;
  }
  return IndicatorAxis2;
}(Axis$1);
var IndicatorAxis$1 = IndicatorAxis;
var Radar = function() {
  function Radar2(radarModel, ecModel, api) {
    this.dimensions = [];
    this._model = radarModel;
    this._indicatorAxes = map$1(radarModel.getIndicatorModels(), function(indicatorModel, idx) {
      var dim = "indicator_" + idx;
      var indicatorAxis = new IndicatorAxis$1(dim, new IntervalScale$1());
      indicatorAxis.name = indicatorModel.get("name");
      indicatorAxis.model = indicatorModel;
      indicatorModel.axis = indicatorAxis;
      this.dimensions.push(dim);
      return indicatorAxis;
    }, this);
    this.resize(radarModel, api);
  }
  Radar2.prototype.getIndicatorAxes = function() {
    return this._indicatorAxes;
  };
  Radar2.prototype.dataToPoint = function(value, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    return this.coordToPoint(indicatorAxis.dataToCoord(value), indicatorIndex);
  };
  Radar2.prototype.coordToPoint = function(coord, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    var angle = indicatorAxis.angle;
    var x2 = this.cx + coord * Math.cos(angle);
    var y2 = this.cy - coord * Math.sin(angle);
    return [x2, y2];
  };
  Radar2.prototype.pointToData = function(pt) {
    var dx = pt[0] - this.cx;
    var dy = pt[1] - this.cy;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx);
    var minRadianDiff = Infinity;
    var closestAxis;
    var closestAxisIdx = -1;
    for (var i = 0; i < this._indicatorAxes.length; i++) {
      var indicatorAxis = this._indicatorAxes[i];
      var diff = Math.abs(radian - indicatorAxis.angle);
      if (diff < minRadianDiff) {
        closestAxis = indicatorAxis;
        closestAxisIdx = i;
        minRadianDiff = diff;
      }
    }
    return [closestAxisIdx, +(closestAxis && closestAxis.coordToData(radius))];
  };
  Radar2.prototype.resize = function(radarModel, api) {
    var center2 = radarModel.get("center");
    var viewWidth = api.getWidth();
    var viewHeight = api.getHeight();
    var viewSize = Math.min(viewWidth, viewHeight) / 2;
    this.cx = parsePercent(center2[0], viewWidth);
    this.cy = parsePercent(center2[1], viewHeight);
    this.startAngle = radarModel.get("startAngle") * Math.PI / 180;
    var radius = radarModel.get("radius");
    if (isString(radius) || isNumber(radius)) {
      radius = [0, radius];
    }
    this.r0 = parsePercent(radius[0], viewSize);
    this.r = parsePercent(radius[1], viewSize);
    each$f(this._indicatorAxes, function(indicatorAxis, idx) {
      indicatorAxis.setExtent(this.r0, this.r);
      var angle = this.startAngle + idx * Math.PI * 2 / this._indicatorAxes.length;
      angle = Math.atan2(Math.sin(angle), Math.cos(angle));
      indicatorAxis.angle = angle;
    }, this);
  };
  Radar2.prototype.update = function(ecModel, api) {
    var indicatorAxes = this._indicatorAxes;
    var radarModel = this._model;
    each$f(indicatorAxes, function(indicatorAxis) {
      indicatorAxis.scale.setExtent(Infinity, -Infinity);
    });
    ecModel.eachSeriesByType("radar", function(radarSeries, idx) {
      if (radarSeries.get("coordinateSystem") !== "radar" || ecModel.getComponent("radar", radarSeries.get("radarIndex")) !== radarModel) {
        return;
      }
      var data = radarSeries.getData();
      each$f(indicatorAxes, function(indicatorAxis) {
        indicatorAxis.scale.unionExtentFromData(data, data.mapDimension(indicatorAxis.dim));
      });
    }, this);
    var splitNumber = radarModel.get("splitNumber");
    var dummyScale = new IntervalScale$1();
    dummyScale.setExtent(0, splitNumber);
    dummyScale.setInterval(1);
    each$f(indicatorAxes, function(indicatorAxis, idx) {
      alignScaleTicks(indicatorAxis.scale, indicatorAxis.model, dummyScale);
    });
  };
  Radar2.prototype.convertToPixel = function(ecModel, finder, value) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Radar2.create = function(ecModel, api) {
    var radarList = [];
    ecModel.eachComponent("radar", function(radarModel) {
      var radar = new Radar2(radarModel, ecModel, api);
      radarList.push(radar);
      radarModel.coordinateSystem = radar;
    });
    ecModel.eachSeriesByType("radar", function(radarSeries) {
      if (radarSeries.get("coordinateSystem") === "radar") {
        radarSeries.coordinateSystem = radarList[radarSeries.get("radarIndex") || 0];
      }
    });
    return radarList;
  };
  Radar2.dimensions = [];
  return Radar2;
}();
var Radar$1 = Radar;
function install$L(registers) {
  registers.registerCoordinateSystem("radar", Radar$1);
  registers.registerComponentModel(RadarModel$1);
  registers.registerComponentView(RadarView$1);
  registers.registerVisual({
    seriesType: "radar",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      data.each(function(idx) {
        data.setItemVisual(idx, "legendIcon", "roundRect");
      });
      data.setVisual("legendIcon", "roundRect");
    }
  });
}
function install$K(registers) {
  use(install$L);
  registers.registerChartView(RadarView$3);
  registers.registerSeriesModel(RadarSeriesModel$1);
  registers.registerLayout(radarLayout);
  registers.registerProcessor(dataFilter$1("radar"));
  registers.registerPreprocessor(radarBackwardCompat);
}
var ATTR = "\0_ec_interaction_mutex";
function take(zr, resourceKey, userKey) {
  var store = getStore(zr);
  store[resourceKey] = userKey;
}
function release(zr, resourceKey, userKey) {
  var store = getStore(zr);
  var uKey = store[resourceKey];
  if (uKey === userKey) {
    store[resourceKey] = null;
  }
}
function isTaken(zr, resourceKey) {
  return !!getStore(zr)[resourceKey];
}
function getStore(zr) {
  return zr[ATTR] || (zr[ATTR] = {});
}
registerAction({
  type: "takeGlobalCursor",
  event: "globalCursorTaken",
  update: "update"
}, noop);
var RoamController = function(_super) {
  __extends(RoamController2, _super);
  function RoamController2(zr) {
    var _this = _super.call(this) || this;
    _this._zr = zr;
    var mousedownHandler = bind$1(_this._mousedownHandler, _this);
    var mousemoveHandler = bind$1(_this._mousemoveHandler, _this);
    var mouseupHandler = bind$1(_this._mouseupHandler, _this);
    var mousewheelHandler = bind$1(_this._mousewheelHandler, _this);
    var pinchHandler = bind$1(_this._pinchHandler, _this);
    _this.enable = function(controlType, opt) {
      this.disable();
      this._opt = defaults(clone$4(opt) || {}, {
        zoomOnMouseWheel: true,
        moveOnMouseMove: true,
        moveOnMouseWheel: false,
        preventDefaultMouseMove: true
      });
      if (controlType == null) {
        controlType = true;
      }
      if (controlType === true || controlType === "move" || controlType === "pan") {
        zr.on("mousedown", mousedownHandler);
        zr.on("mousemove", mousemoveHandler);
        zr.on("mouseup", mouseupHandler);
      }
      if (controlType === true || controlType === "scale" || controlType === "zoom") {
        zr.on("mousewheel", mousewheelHandler);
        zr.on("pinch", pinchHandler);
      }
    };
    _this.disable = function() {
      zr.off("mousedown", mousedownHandler);
      zr.off("mousemove", mousemoveHandler);
      zr.off("mouseup", mouseupHandler);
      zr.off("mousewheel", mousewheelHandler);
      zr.off("pinch", pinchHandler);
    };
    return _this;
  }
  RoamController2.prototype.isDragging = function() {
    return this._dragging;
  };
  RoamController2.prototype.isPinching = function() {
    return this._pinching;
  };
  RoamController2.prototype.setPointerChecker = function(pointerChecker) {
    this.pointerChecker = pointerChecker;
  };
  RoamController2.prototype.dispose = function() {
    this.disable();
  };
  RoamController2.prototype._mousedownHandler = function(e2) {
    if (isMiddleOrRightButtonOnMouseUpDown(e2) || e2.target && e2.target.draggable) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    if (this.pointerChecker && this.pointerChecker(e2, x2, y2)) {
      this._x = x2;
      this._y = y2;
      this._dragging = true;
    }
  };
  RoamController2.prototype._mousemoveHandler = function(e2) {
    if (!this._dragging || !isAvailableBehavior("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || isTaken(this._zr, "globalPan")) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var oldX = this._x;
    var oldY = this._y;
    var dx = x2 - oldX;
    var dy = y2 - oldY;
    this._x = x2;
    this._y = y2;
    this._opt.preventDefaultMouseMove && stop(e2.event);
    trigger$1(this, "pan", "moveOnMouseMove", e2, {
      dx,
      dy,
      oldX,
      oldY,
      newX: x2,
      newY: y2,
      isAvailableBehavior: null
    });
  };
  RoamController2.prototype._mouseupHandler = function(e2) {
    if (!isMiddleOrRightButtonOnMouseUpDown(e2)) {
      this._dragging = false;
    }
  };
  RoamController2.prototype._mousewheelHandler = function(e2) {
    var shouldZoom = isAvailableBehavior("zoomOnMouseWheel", e2, this._opt);
    var shouldMove = isAvailableBehavior("moveOnMouseWheel", e2, this._opt);
    var wheelDelta = e2.wheelDelta;
    var absWheelDeltaDelta = Math.abs(wheelDelta);
    var originX = e2.offsetX;
    var originY = e2.offsetY;
    if (wheelDelta === 0 || !shouldZoom && !shouldMove) {
      return;
    }
    if (shouldZoom) {
      var factor = absWheelDeltaDelta > 3 ? 1.4 : absWheelDeltaDelta > 1 ? 1.2 : 1.1;
      var scale2 = wheelDelta > 0 ? factor : 1 / factor;
      checkPointerAndTrigger(this, "zoom", "zoomOnMouseWheel", e2, {
        scale: scale2,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
    if (shouldMove) {
      var absDelta = Math.abs(wheelDelta);
      var scrollDelta = (wheelDelta > 0 ? 1 : -1) * (absDelta > 3 ? 0.4 : absDelta > 1 ? 0.15 : 0.05);
      checkPointerAndTrigger(this, "scrollMove", "moveOnMouseWheel", e2, {
        scrollDelta,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
  };
  RoamController2.prototype._pinchHandler = function(e2) {
    if (isTaken(this._zr, "globalPan")) {
      return;
    }
    var scale2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
    checkPointerAndTrigger(this, "zoom", null, e2, {
      scale: scale2,
      originX: e2.pinchX,
      originY: e2.pinchY,
      isAvailableBehavior: null
    });
  };
  return RoamController2;
}(Eventful$1);
function checkPointerAndTrigger(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  if (controller.pointerChecker && controller.pointerChecker(e2, contollerEvent.originX, contollerEvent.originY)) {
    stop(e2.event);
    trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent);
  }
}
function trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  contollerEvent.isAvailableBehavior = bind$1(isAvailableBehavior, null, behaviorToCheck, e2);
  controller.trigger(eventName, contollerEvent);
}
function isAvailableBehavior(behaviorToCheck, e2, settings) {
  var setting = settings[behaviorToCheck];
  return !behaviorToCheck || setting && (!isString(setting) || e2.event[setting + "Key"]);
}
var RoamController$1 = RoamController;
function updateViewOnPan(controllerHost, dx, dy) {
  var target = controllerHost.target;
  target.x += dx;
  target.y += dy;
  target.dirty();
}
function updateViewOnZoom(controllerHost, zoomDelta, zoomX, zoomY) {
  var target = controllerHost.target;
  var zoomLimit = controllerHost.zoomLimit;
  var newZoom = controllerHost.zoom = controllerHost.zoom || 1;
  newZoom *= zoomDelta;
  if (zoomLimit) {
    var zoomMin = zoomLimit.min || 0;
    var zoomMax = zoomLimit.max || Infinity;
    newZoom = Math.max(Math.min(zoomMax, newZoom), zoomMin);
  }
  var zoomScale = newZoom / controllerHost.zoom;
  controllerHost.zoom = newZoom;
  target.x -= (zoomX - target.x) * (zoomScale - 1);
  target.y -= (zoomY - target.y) * (zoomScale - 1);
  target.scaleX *= zoomScale;
  target.scaleY *= zoomScale;
  target.dirty();
}
var IRRELEVANT_EXCLUDES = {
  "axisPointer": 1,
  "tooltip": 1,
  "brush": 1
};
function onIrrelevantElement(e2, api, targetCoordSysModel) {
  var model = api.getComponentByElement(e2.topTarget);
  var coordSys = model && model.coordinateSystem;
  return model && model !== targetCoordSysModel && !IRRELEVANT_EXCLUDES.hasOwnProperty(model.mainType) && coordSys && coordSys.model !== targetCoordSysModel;
}
function parseXML(svg) {
  if (isString(svg)) {
    var parser = new DOMParser();
    svg = parser.parseFromString(svg, "text/xml");
  }
  var svgNode = svg;
  if (svgNode.nodeType === 9) {
    svgNode = svgNode.firstChild;
  }
  while (svgNode.nodeName.toLowerCase() !== "svg" || svgNode.nodeType !== 1) {
    svgNode = svgNode.nextSibling;
  }
  return svgNode;
}
var nodeParsers;
var INHERITABLE_STYLE_ATTRIBUTES_MAP = {
  "fill": "fill",
  "stroke": "stroke",
  "stroke-width": "lineWidth",
  "opacity": "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  "visibility": "visibility",
  "display": "display"
};
var INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS = keys(INHERITABLE_STYLE_ATTRIBUTES_MAP);
var SELF_STYLE_ATTRIBUTES_MAP = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
};
var SELF_STYLE_ATTRIBUTES_MAP_KEYS = keys(SELF_STYLE_ATTRIBUTES_MAP);
var SVGParser = function() {
  function SVGParser2() {
    this._defs = {};
    this._root = null;
  }
  SVGParser2.prototype.parse = function(xml, opt) {
    opt = opt || {};
    var svg = parseXML(xml);
    this._defsUsePending = [];
    var root2 = new Group$4();
    this._root = root2;
    var named = [];
    var viewBox = svg.getAttribute("viewBox") || "";
    var width = parseFloat(svg.getAttribute("width") || opt.width);
    var height = parseFloat(svg.getAttribute("height") || opt.height);
    isNaN(width) && (width = null);
    isNaN(height) && (height = null);
    parseAttributes(svg, root2, null, true, false);
    var child = svg.firstChild;
    while (child) {
      this._parseNode(child, root2, named, null, false, false);
      child = child.nextSibling;
    }
    applyDefs(this._defs, this._defsUsePending);
    this._defsUsePending = [];
    var viewBoxRect;
    var viewBoxTransform;
    if (viewBox) {
      var viewBoxArr = splitNumberSequence(viewBox);
      if (viewBoxArr.length >= 4) {
        viewBoxRect = {
          x: parseFloat(viewBoxArr[0] || 0),
          y: parseFloat(viewBoxArr[1] || 0),
          width: parseFloat(viewBoxArr[2]),
          height: parseFloat(viewBoxArr[3])
        };
      }
    }
    if (viewBoxRect && width != null && height != null) {
      viewBoxTransform = makeViewBoxTransform(viewBoxRect, { x: 0, y: 0, width, height });
      if (!opt.ignoreViewBox) {
        var elRoot = root2;
        root2 = new Group$4();
        root2.add(elRoot);
        elRoot.scaleX = elRoot.scaleY = viewBoxTransform.scale;
        elRoot.x = viewBoxTransform.x;
        elRoot.y = viewBoxTransform.y;
      }
    }
    if (!opt.ignoreRootClip && width != null && height != null) {
      root2.setClipPath(new Rect$3({
        shape: { x: 0, y: 0, width, height }
      }));
    }
    return {
      root: root2,
      width,
      height,
      viewBoxRect,
      viewBoxTransform,
      named
    };
  };
  SVGParser2.prototype._parseNode = function(xmlNode, parentGroup, named, namedFrom, isInDefs, isInText) {
    var nodeName = xmlNode.nodeName.toLowerCase();
    var el;
    var namedFromForSub = namedFrom;
    if (nodeName === "defs") {
      isInDefs = true;
    }
    if (nodeName === "text") {
      isInText = true;
    }
    if (nodeName === "defs" || nodeName === "switch") {
      el = parentGroup;
    } else {
      if (!isInDefs) {
        var parser_1 = nodeParsers[nodeName];
        if (parser_1 && hasOwn(nodeParsers, nodeName)) {
          el = parser_1.call(this, xmlNode, parentGroup);
          var nameAttr = xmlNode.getAttribute("name");
          if (nameAttr) {
            var newNamed = {
              name: nameAttr,
              namedFrom: null,
              svgNodeTagLower: nodeName,
              el
            };
            named.push(newNamed);
            if (nodeName === "g") {
              namedFromForSub = newNamed;
            }
          } else if (namedFrom) {
            named.push({
              name: namedFrom.name,
              namedFrom,
              svgNodeTagLower: nodeName,
              el
            });
          }
          parentGroup.add(el);
        }
      }
      var parser = paintServerParsers[nodeName];
      if (parser && hasOwn(paintServerParsers, nodeName)) {
        var def = parser.call(this, xmlNode);
        var id2 = xmlNode.getAttribute("id");
        if (id2) {
          this._defs[id2] = def;
        }
      }
    }
    if (el && el.isGroup) {
      var child = xmlNode.firstChild;
      while (child) {
        if (child.nodeType === 1) {
          this._parseNode(child, el, named, namedFromForSub, isInDefs, isInText);
        } else if (child.nodeType === 3 && isInText) {
          this._parseText(child, el);
        }
        child = child.nextSibling;
      }
    }
  };
  SVGParser2.prototype._parseText = function(xmlNode, parentGroup) {
    var text = new TSpan$1({
      style: {
        text: xmlNode.textContent
      },
      silent: true,
      x: this._textX || 0,
      y: this._textY || 0
    });
    inheritStyle(parentGroup, text);
    parseAttributes(xmlNode, text, this._defsUsePending, false, false);
    applyTextAlignment(text, parentGroup);
    var textStyle = text.style;
    var fontSize = textStyle.fontSize;
    if (fontSize && fontSize < 9) {
      textStyle.fontSize = 9;
      text.scaleX *= fontSize / 9;
      text.scaleY *= fontSize / 9;
    }
    var font = (textStyle.fontSize || textStyle.fontFamily) && [
      textStyle.fontStyle,
      textStyle.fontWeight,
      (textStyle.fontSize || 12) + "px",
      textStyle.fontFamily || "sans-serif"
    ].join(" ");
    textStyle.font = font;
    var rect = text.getBoundingRect();
    this._textX += rect.width;
    parentGroup.add(text);
    return text;
  };
  SVGParser2.internalField = function() {
    nodeParsers = {
      "g": function(xmlNode, parentGroup) {
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, false);
        return g2;
      },
      "rect": function(xmlNode, parentGroup) {
        var rect = new Rect$3();
        inheritStyle(parentGroup, rect);
        parseAttributes(xmlNode, rect, this._defsUsePending, false, false);
        rect.setShape({
          x: parseFloat(xmlNode.getAttribute("x") || "0"),
          y: parseFloat(xmlNode.getAttribute("y") || "0"),
          width: parseFloat(xmlNode.getAttribute("width") || "0"),
          height: parseFloat(xmlNode.getAttribute("height") || "0")
        });
        rect.silent = true;
        return rect;
      },
      "circle": function(xmlNode, parentGroup) {
        var circle = new Circle$1();
        inheritStyle(parentGroup, circle);
        parseAttributes(xmlNode, circle, this._defsUsePending, false, false);
        circle.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          r: parseFloat(xmlNode.getAttribute("r") || "0")
        });
        circle.silent = true;
        return circle;
      },
      "line": function(xmlNode, parentGroup) {
        var line = new Line$3();
        inheritStyle(parentGroup, line);
        parseAttributes(xmlNode, line, this._defsUsePending, false, false);
        line.setShape({
          x1: parseFloat(xmlNode.getAttribute("x1") || "0"),
          y1: parseFloat(xmlNode.getAttribute("y1") || "0"),
          x2: parseFloat(xmlNode.getAttribute("x2") || "0"),
          y2: parseFloat(xmlNode.getAttribute("y2") || "0")
        });
        line.silent = true;
        return line;
      },
      "ellipse": function(xmlNode, parentGroup) {
        var ellipse = new Ellipse$1();
        inheritStyle(parentGroup, ellipse);
        parseAttributes(xmlNode, ellipse, this._defsUsePending, false, false);
        ellipse.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          rx: parseFloat(xmlNode.getAttribute("rx") || "0"),
          ry: parseFloat(xmlNode.getAttribute("ry") || "0")
        });
        ellipse.silent = true;
        return ellipse;
      },
      "polygon": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polygon = new Polygon$1({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polygon);
        parseAttributes(xmlNode, polygon, this._defsUsePending, false, false);
        return polygon;
      },
      "polyline": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polyline = new Polyline$3({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polyline);
        parseAttributes(xmlNode, polyline, this._defsUsePending, false, false);
        return polyline;
      },
      "image": function(xmlNode, parentGroup) {
        var img = new ZRImage$1();
        inheritStyle(parentGroup, img);
        parseAttributes(xmlNode, img, this._defsUsePending, false, false);
        img.setStyle({
          image: xmlNode.getAttribute("xlink:href") || xmlNode.getAttribute("href"),
          x: +xmlNode.getAttribute("x"),
          y: +xmlNode.getAttribute("y"),
          width: +xmlNode.getAttribute("width"),
          height: +xmlNode.getAttribute("height")
        });
        img.silent = true;
        return img;
      },
      "text": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x") || "0";
        var y2 = xmlNode.getAttribute("y") || "0";
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        this._textX = parseFloat(x2) + parseFloat(dx);
        this._textY = parseFloat(y2) + parseFloat(dy);
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        return g2;
      },
      "tspan": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x");
        var y2 = xmlNode.getAttribute("y");
        if (x2 != null) {
          this._textX = parseFloat(x2);
        }
        if (y2 != null) {
          this._textY = parseFloat(y2);
        }
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        this._textX += parseFloat(dx);
        this._textY += parseFloat(dy);
        return g2;
      },
      "path": function(xmlNode, parentGroup) {
        var d2 = xmlNode.getAttribute("d") || "";
        var path = createFromString(d2);
        inheritStyle(parentGroup, path);
        parseAttributes(xmlNode, path, this._defsUsePending, false, false);
        path.silent = true;
        return path;
      }
    };
  }();
  return SVGParser2;
}();
var paintServerParsers = {
  "lineargradient": function(xmlNode) {
    var x1 = parseInt(xmlNode.getAttribute("x1") || "0", 10);
    var y1 = parseInt(xmlNode.getAttribute("y1") || "0", 10);
    var x2 = parseInt(xmlNode.getAttribute("x2") || "10", 10);
    var y2 = parseInt(xmlNode.getAttribute("y2") || "0", 10);
    var gradient = new LinearGradient$1(x1, y1, x2, y2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  },
  "radialgradient": function(xmlNode) {
    var cx = parseInt(xmlNode.getAttribute("cx") || "0", 10);
    var cy = parseInt(xmlNode.getAttribute("cy") || "0", 10);
    var r2 = parseInt(xmlNode.getAttribute("r") || "0", 10);
    var gradient = new RadialGradient$1(cx, cy, r2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  }
};
function parsePaintServerUnit(xmlNode, gradient) {
  var gradientUnits = xmlNode.getAttribute("gradientUnits");
  if (gradientUnits === "userSpaceOnUse") {
    gradient.global = true;
  }
}
function parseGradientColorStops(xmlNode, gradient) {
  var stop2 = xmlNode.firstChild;
  while (stop2) {
    if (stop2.nodeType === 1 && stop2.nodeName.toLocaleLowerCase() === "stop") {
      var offsetStr = stop2.getAttribute("offset");
      var offset = void 0;
      if (offsetStr && offsetStr.indexOf("%") > 0) {
        offset = parseInt(offsetStr, 10) / 100;
      } else if (offsetStr) {
        offset = parseFloat(offsetStr);
      } else {
        offset = 0;
      }
      var styleVals = {};
      parseInlineStyle(stop2, styleVals, styleVals);
      var stopColor = styleVals.stopColor || stop2.getAttribute("stop-color") || "#000000";
      gradient.colorStops.push({
        offset,
        color: stopColor
      });
    }
    stop2 = stop2.nextSibling;
  }
}
function inheritStyle(parent, child) {
  if (parent && parent.__inheritedStyle) {
    if (!child.__inheritedStyle) {
      child.__inheritedStyle = {};
    }
    defaults(child.__inheritedStyle, parent.__inheritedStyle);
  }
}
function parsePoints(pointsString) {
  var list = splitNumberSequence(pointsString);
  var points2 = [];
  for (var i = 0; i < list.length; i += 2) {
    var x2 = parseFloat(list[i]);
    var y2 = parseFloat(list[i + 1]);
    points2.push([x2, y2]);
  }
  return points2;
}
function parseAttributes(xmlNode, el, defsUsePending, onlyInlineStyle, isTextGroup) {
  var disp = el;
  var inheritedStyle = disp.__inheritedStyle = disp.__inheritedStyle || {};
  var selfStyle = {};
  if (xmlNode.nodeType === 1) {
    parseTransformAttribute(xmlNode, el);
    parseInlineStyle(xmlNode, inheritedStyle, selfStyle);
    if (!onlyInlineStyle) {
      parseAttributeStyle(xmlNode, inheritedStyle, selfStyle);
    }
  }
  disp.style = disp.style || {};
  if (inheritedStyle.fill != null) {
    disp.style.fill = getFillStrokeStyle(disp, "fill", inheritedStyle.fill, defsUsePending);
  }
  if (inheritedStyle.stroke != null) {
    disp.style.stroke = getFillStrokeStyle(disp, "stroke", inheritedStyle.stroke, defsUsePending);
  }
  each$f([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = parseFloat(inheritedStyle[propName]);
    }
  });
  each$f([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = inheritedStyle[propName];
    }
  });
  if (isTextGroup) {
    disp.__selfStyle = selfStyle;
  }
  if (inheritedStyle.lineDash) {
    disp.style.lineDash = map$1(splitNumberSequence(inheritedStyle.lineDash), function(str) {
      return parseFloat(str);
    });
  }
  if (inheritedStyle.visibility === "hidden" || inheritedStyle.visibility === "collapse") {
    disp.invisible = true;
  }
  if (inheritedStyle.display === "none") {
    disp.ignore = true;
  }
}
function applyTextAlignment(text, parentGroup) {
  var parentSelfStyle = parentGroup.__selfStyle;
  if (parentSelfStyle) {
    var textBaseline = parentSelfStyle.textBaseline;
    var zrTextBaseline = textBaseline;
    if (!textBaseline || textBaseline === "auto") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "baseline") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "before-edge" || textBaseline === "text-before-edge") {
      zrTextBaseline = "top";
    } else if (textBaseline === "after-edge" || textBaseline === "text-after-edge") {
      zrTextBaseline = "bottom";
    } else if (textBaseline === "central" || textBaseline === "mathematical") {
      zrTextBaseline = "middle";
    }
    text.style.textBaseline = zrTextBaseline;
  }
  var parentInheritedStyle = parentGroup.__inheritedStyle;
  if (parentInheritedStyle) {
    var textAlign = parentInheritedStyle.textAlign;
    var zrTextAlign = textAlign;
    if (textAlign) {
      if (textAlign === "middle") {
        zrTextAlign = "center";
      }
      text.style.textAlign = zrTextAlign;
    }
  }
}
var urlRegex = /^url\(\s*#(.*?)\)/;
function getFillStrokeStyle(el, method4, str, defsUsePending) {
  var urlMatch = str && str.match(urlRegex);
  if (urlMatch) {
    var url2 = trim$1(urlMatch[1]);
    defsUsePending.push([el, method4, url2]);
    return;
  }
  if (str === "none") {
    str = null;
  }
  return str;
}
function applyDefs(defs, defsUsePending) {
  for (var i = 0; i < defsUsePending.length; i++) {
    var item = defsUsePending[i];
    item[0].style[item[1]] = defs[item[2]];
  }
}
var numberReg = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function splitNumberSequence(rawStr) {
  return rawStr.match(numberReg) || [];
}
var transformRegex = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g;
var DEGREE_TO_ANGLE = Math.PI / 180;
function parseTransformAttribute(xmlNode, node) {
  var transform2 = xmlNode.getAttribute("transform");
  if (transform2) {
    transform2 = transform2.replace(/,/g, " ");
    var transformOps_1 = [];
    var mt = null;
    transform2.replace(transformRegex, function(str, type5, value2) {
      transformOps_1.push(type5, value2);
      return "";
    });
    for (var i = transformOps_1.length - 1; i > 0; i -= 2) {
      var value = transformOps_1[i];
      var type4 = transformOps_1[i - 1];
      var valueArr = splitNumberSequence(value);
      mt = mt || create$1();
      switch (type4) {
        case "translate":
          translate(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || "0")]);
          break;
        case "scale":
          scale$1(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || valueArr[0])]);
          break;
        case "rotate":
          rotate(mt, mt, -parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          break;
        case "skewX":
          var sx = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, 0, sx, 1, 0, 0], mt);
          break;
        case "skewY":
          var sy = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, sy, 0, 1, 0, 0], mt);
          break;
        case "matrix":
          mt[0] = parseFloat(valueArr[0]);
          mt[1] = parseFloat(valueArr[1]);
          mt[2] = parseFloat(valueArr[2]);
          mt[3] = parseFloat(valueArr[3]);
          mt[4] = parseFloat(valueArr[4]);
          mt[5] = parseFloat(valueArr[5]);
          break;
      }
    }
    node.setLocalTransform(mt);
  }
}
var styleRegex = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function parseInlineStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  var style = xmlNode.getAttribute("style");
  if (!style) {
    return;
  }
  styleRegex.lastIndex = 0;
  var styleRegResult;
  while ((styleRegResult = styleRegex.exec(style)) != null) {
    var svgStlAttr = styleRegResult[1];
    var zrInheritableStlAttr = hasOwn(INHERITABLE_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? INHERITABLE_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrInheritableStlAttr) {
      inheritableStyleResult[zrInheritableStlAttr] = styleRegResult[2];
    }
    var zrSelfStlAttr = hasOwn(SELF_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? SELF_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrSelfStlAttr) {
      selfStyleResult[zrSelfStlAttr] = styleRegResult[2];
    }
  }
}
function parseAttributeStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  for (var i = 0; i < INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      inheritableStyleResult[INHERITABLE_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
  for (var i = 0; i < SELF_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = SELF_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      selfStyleResult[SELF_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
}
function makeViewBoxTransform(viewBoxRect, boundingRect) {
  var scaleX = boundingRect.width / viewBoxRect.width;
  var scaleY = boundingRect.height / viewBoxRect.height;
  var scale2 = Math.min(scaleX, scaleY);
  return {
    scale: scale2,
    x: -(viewBoxRect.x + viewBoxRect.width / 2) * scale2 + (boundingRect.x + boundingRect.width / 2),
    y: -(viewBoxRect.y + viewBoxRect.height / 2) * scale2 + (boundingRect.y + boundingRect.height / 2)
  };
}
function parseSVG(xml, opt) {
  var parser = new SVGParser();
  return parser.parse(xml, opt);
}
var REGION_AVAILABLE_SVG_TAG_MAP = createHashMap([
  "rect",
  "circle",
  "line",
  "ellipse",
  "polygon",
  "polyline",
  "path",
  "text",
  "tspan",
  "g"
]);
var GeoSVGResource = function() {
  function GeoSVGResource2(mapName, svg) {
    this.type = "geoSVG";
    this._usedGraphicMap = createHashMap();
    this._freedGraphics = [];
    this._mapName = mapName;
    this._parsedXML = parseXML(svg);
  }
  GeoSVGResource2.prototype.load = function() {
    var firstGraphic = this._firstGraphic;
    if (!firstGraphic) {
      firstGraphic = this._firstGraphic = this._buildGraphic(this._parsedXML);
      this._freedGraphics.push(firstGraphic);
      this._boundingRect = this._firstGraphic.boundingRect.clone();
      var _a2 = createRegions(firstGraphic.named), regions = _a2.regions, regionsMap = _a2.regionsMap;
      this._regions = regions;
      this._regionsMap = regionsMap;
    }
    return {
      boundingRect: this._boundingRect,
      regions: this._regions,
      regionsMap: this._regionsMap
    };
  };
  GeoSVGResource2.prototype._buildGraphic = function(svgXML) {
    var result;
    var rootFromParse;
    try {
      result = svgXML && parseSVG(svgXML, {
        ignoreViewBox: true,
        ignoreRootClip: true
      }) || {};
      rootFromParse = result.root;
      assert(rootFromParse != null);
    } catch (e2) {
      throw new Error("Invalid svg format\n" + e2.message);
    }
    var root2 = new Group$4();
    root2.add(rootFromParse);
    root2.isGeoSVGGraphicRoot = true;
    var svgWidth = result.width;
    var svgHeight = result.height;
    var viewBoxRect = result.viewBoxRect;
    var boundingRect = this._boundingRect;
    if (!boundingRect) {
      var bRectX = void 0;
      var bRectY = void 0;
      var bRectWidth = void 0;
      var bRectHeight = void 0;
      if (svgWidth != null) {
        bRectX = 0;
        bRectWidth = svgWidth;
      } else if (viewBoxRect) {
        bRectX = viewBoxRect.x;
        bRectWidth = viewBoxRect.width;
      }
      if (svgHeight != null) {
        bRectY = 0;
        bRectHeight = svgHeight;
      } else if (viewBoxRect) {
        bRectY = viewBoxRect.y;
        bRectHeight = viewBoxRect.height;
      }
      if (bRectX == null || bRectY == null) {
        var calculatedBoundingRect = rootFromParse.getBoundingRect();
        if (bRectX == null) {
          bRectX = calculatedBoundingRect.x;
          bRectWidth = calculatedBoundingRect.width;
        }
        if (bRectY == null) {
          bRectY = calculatedBoundingRect.y;
          bRectHeight = calculatedBoundingRect.height;
        }
      }
      boundingRect = this._boundingRect = new BoundingRect$1(bRectX, bRectY, bRectWidth, bRectHeight);
    }
    if (viewBoxRect) {
      var viewBoxTransform = makeViewBoxTransform(viewBoxRect, boundingRect);
      rootFromParse.scaleX = rootFromParse.scaleY = viewBoxTransform.scale;
      rootFromParse.x = viewBoxTransform.x;
      rootFromParse.y = viewBoxTransform.y;
    }
    root2.setClipPath(new Rect$3({
      shape: boundingRect.plain()
    }));
    var named = [];
    each$f(result.named, function(namedItem) {
      if (REGION_AVAILABLE_SVG_TAG_MAP.get(namedItem.svgNodeTagLower) != null) {
        named.push(namedItem);
        setSilent(namedItem.el);
      }
    });
    return {
      root: root2,
      boundingRect,
      named
    };
  };
  GeoSVGResource2.prototype.useGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      return svgGraphic;
    }
    svgGraphic = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML);
    usedRootMap.set(hostKey, svgGraphic);
    return svgGraphic;
  };
  GeoSVGResource2.prototype.freeGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      usedRootMap.removeKey(hostKey);
      this._freedGraphics.push(svgGraphic);
    }
  };
  return GeoSVGResource2;
}();
function setSilent(el) {
  el.silent = false;
  if (el.isGroup) {
    el.traverse(function(child) {
      child.silent = false;
    });
  }
}
function createRegions(named) {
  var regions = [];
  var regionsMap = createHashMap();
  each$f(named, function(namedItem) {
    if (namedItem.namedFrom != null) {
      return;
    }
    var region = new GeoSVGRegion(namedItem.name, namedItem.el);
    regions.push(region);
    regionsMap.set(namedItem.name, region);
  });
  return {
    regions,
    regionsMap
  };
}
var geoCoord = [126, 25];
var nanhaiName = "\u5357\u6D77\u8BF8\u5C9B";
var points$1 = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
for (var i = 0; i < points$1.length; i++) {
  for (var k$1 = 0; k$1 < points$1[i].length; k$1++) {
    points$1[i][k$1][0] /= 10.5;
    points$1[i][k$1][1] /= -10.5 / 0.75;
    points$1[i][k$1][0] += geoCoord[0];
    points$1[i][k$1][1] += geoCoord[1];
  }
}
function fixNanhai(mapType, regions) {
  if (mapType === "china") {
    for (var i = 0; i < regions.length; i++) {
      if (regions[i].name === nanhaiName) {
        return;
      }
    }
    regions.push(new GeoJSONRegion(nanhaiName, map$1(points$1, function(exterior) {
      return {
        type: "polygon",
        exterior
      };
    }), geoCoord));
  }
}
var coordsOffsetMap = {
  "\u5357\u6D77\u8BF8\u5C9B": [32, 80],
  "\u5E7F\u4E1C": [0, -10],
  "\u9999\u6E2F": [10, 5],
  "\u6FB3\u95E8": [-10, 10],
  "\u5929\u6D25": [5, 5]
};
function fixTextCoords(mapType, region) {
  if (mapType === "china") {
    var coordFix = coordsOffsetMap[region.name];
    if (coordFix) {
      var cp = region.getCenter();
      cp[0] += coordFix[0] / 10.5;
      cp[1] += -coordFix[1] / (10.5 / 0.75);
      region.setCenter(cp);
    }
  }
}
var points = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
function fixDiaoyuIsland(mapType, region) {
  if (mapType === "china" && region.name === "\u53F0\u6E7E") {
    region.geometries.push({
      type: "polygon",
      exterior: points[0]
    });
  }
}
var DEFAULT_NAME_PROPERTY = "name";
var GeoJSONResource = function() {
  function GeoJSONResource2(mapName, geoJSON, specialAreas) {
    this.type = "geoJSON";
    this._parsedMap = createHashMap();
    this._mapName = mapName;
    this._specialAreas = specialAreas;
    this._geoJSON = parseInput(geoJSON);
  }
  GeoJSONResource2.prototype.load = function(nameMap, nameProperty) {
    nameProperty = nameProperty || DEFAULT_NAME_PROPERTY;
    var parsed = this._parsedMap.get(nameProperty);
    if (!parsed) {
      var rawRegions = this._parseToRegions(nameProperty);
      parsed = this._parsedMap.set(nameProperty, {
        regions: rawRegions,
        boundingRect: calculateBoundingRect(rawRegions)
      });
    }
    var regionsMap = createHashMap();
    var finalRegions = [];
    each$f(parsed.regions, function(region) {
      var regionName = region.name;
      if (nameMap && hasOwn(nameMap, regionName)) {
        region = region.cloneShallow(regionName = nameMap[regionName]);
      }
      finalRegions.push(region);
      regionsMap.set(regionName, region);
    });
    return {
      regions: finalRegions,
      boundingRect: parsed.boundingRect || new BoundingRect$1(0, 0, 0, 0),
      regionsMap
    };
  };
  GeoJSONResource2.prototype._parseToRegions = function(nameProperty) {
    var mapName = this._mapName;
    var geoJSON = this._geoJSON;
    var rawRegions;
    try {
      rawRegions = geoJSON ? parseGeoJSON(geoJSON, nameProperty) : [];
    } catch (e2) {
      throw new Error("Invalid geoJson format\n" + e2.message);
    }
    fixNanhai(mapName, rawRegions);
    each$f(rawRegions, function(region) {
      var regionName = region.name;
      fixTextCoords(mapName, region);
      fixDiaoyuIsland(mapName, region);
      var specialArea = this._specialAreas && this._specialAreas[regionName];
      if (specialArea) {
        region.transformTo(specialArea.left, specialArea.top, specialArea.width, specialArea.height);
      }
    }, this);
    return rawRegions;
  };
  GeoJSONResource2.prototype.getMapForUser = function() {
    return {
      geoJson: this._geoJSON,
      geoJSON: this._geoJSON,
      specialAreas: this._specialAreas
    };
  };
  return GeoJSONResource2;
}();
function calculateBoundingRect(regions) {
  var rect;
  for (var i = 0; i < regions.length; i++) {
    var regionRect = regions[i].getBoundingRect();
    rect = rect || regionRect.clone();
    rect.union(regionRect);
  }
  return rect;
}
function parseInput(source) {
  return !isString(source) ? source : typeof JSON !== "undefined" && JSON.parse ? JSON.parse(source) : new Function("return (" + source + ");")();
}
var storage = createHashMap();
var geoSourceManager = {
  registerMap: function(mapName, rawDef, rawSpecialAreas) {
    if (rawDef.svg) {
      var resource = new GeoSVGResource(mapName, rawDef.svg);
      storage.set(mapName, resource);
    } else {
      var geoJSON = rawDef.geoJson || rawDef.geoJSON;
      if (geoJSON && !rawDef.features) {
        rawSpecialAreas = rawDef.specialAreas;
      } else {
        geoJSON = rawDef;
      }
      var resource = new GeoJSONResource(mapName, geoJSON, rawSpecialAreas);
      storage.set(mapName, resource);
    }
  },
  getGeoResource: function(mapName) {
    return storage.get(mapName);
  },
  getMapForUser: function(mapName) {
    var resource = storage.get(mapName);
    return resource && resource.type === "geoJSON" && resource.getMapForUser();
  },
  load: function(mapName, nameMap, nameProperty) {
    var resource = storage.get(mapName);
    if (!resource) {
      return;
    }
    return resource.load(nameMap, nameProperty);
  }
};
var OPTION_STYLE_ENABLED_TAGS = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"];
var OPTION_STYLE_ENABLED_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS);
var STATE_TRIGGER_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var LABEL_HOST_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var mapLabelRaw = makeInner();
function getFixedItemStyle(model) {
  var itemStyle = model.getItemStyle();
  var areaColor = model.get("areaColor");
  if (areaColor != null) {
    itemStyle.fill = areaColor;
  }
  return itemStyle;
}
function fixLineStyle(styleHost) {
  var style = styleHost.style;
  if (style) {
    style.stroke = style.stroke || style.fill;
    style.fill = null;
  }
}
var MapDraw = function() {
  function MapDraw2(api) {
    var group = new Group$4();
    this.uid = getUID("ec_map_draw");
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    this.group = group;
    group.add(this._regionsGroup = new Group$4());
    group.add(this._svgGroup = new Group$4());
  }
  MapDraw2.prototype.draw = function(mapOrGeoModel, ecModel, api, fromView, payload) {
    var isGeo = mapOrGeoModel.mainType === "geo";
    var data = mapOrGeoModel.getData && mapOrGeoModel.getData();
    isGeo && ecModel.eachComponent({
      mainType: "series",
      subType: "map"
    }, function(mapSeries) {
      if (!data && mapSeries.getHostGeoModel() === mapOrGeoModel) {
        data = mapSeries.getData();
      }
    });
    var geo = mapOrGeoModel.coordinateSystem;
    var regionsGroup = this._regionsGroup;
    var group = this.group;
    var transformInfo = geo.getTransformInfo();
    var transformInfoRaw = transformInfo.raw;
    var transformInfoRoam = transformInfo.roam;
    var isFirstDraw = !regionsGroup.childAt(0) || payload;
    if (isFirstDraw) {
      group.x = transformInfoRoam.x;
      group.y = transformInfoRoam.y;
      group.scaleX = transformInfoRoam.scaleX;
      group.scaleY = transformInfoRoam.scaleY;
      group.dirty();
    } else {
      updateProps$1(group, transformInfoRoam, mapOrGeoModel);
    }
    var isVisualEncodedByVisualMap = data && data.getVisual("visualMeta") && data.getVisual("visualMeta").length > 0;
    var viewBuildCtx = {
      api,
      geo,
      mapOrGeoModel,
      data,
      isVisualEncodedByVisualMap,
      isGeo,
      transformInfoRaw
    };
    if (geo.resourceType === "geoJSON") {
      this._buildGeoJSON(viewBuildCtx);
    } else if (geo.resourceType === "geoSVG") {
      this._buildSVG(viewBuildCtx);
    }
    this._updateController(mapOrGeoModel, ecModel, api);
    this._updateMapSelectHandler(mapOrGeoModel, regionsGroup, api, fromView);
  };
  MapDraw2.prototype._buildGeoJSON = function(viewBuildCtx) {
    var regionsGroupByName = this._regionsGroupByName = createHashMap();
    var regionsInfoByName = createHashMap();
    var regionsGroup = this._regionsGroup;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
    var data = viewBuildCtx.data;
    var projection = viewBuildCtx.geo.projection;
    var projectionStream = projection && projection.stream;
    function transformPoint(point, project) {
      if (project) {
        point = project(point);
      }
      return point && [point[0] * transformInfoRaw.scaleX + transformInfoRaw.x, point[1] * transformInfoRaw.scaleY + transformInfoRaw.y];
    }
    function transformPolygonPoints(inPoints) {
      var outPoints = [];
      var project = !projectionStream && projection && projection.project;
      for (var i = 0; i < inPoints.length; ++i) {
        var newPt = transformPoint(inPoints[i], project);
        newPt && outPoints.push(newPt);
      }
      return outPoints;
    }
    function getPolyShape(points2) {
      return {
        shape: {
          points: transformPolygonPoints(points2)
        }
      };
    }
    regionsGroup.removeAll();
    each$f(viewBuildCtx.geo.regions, function(region) {
      var regionName = region.name;
      var regionGroup = regionsGroupByName.get(regionName);
      var _a2 = regionsInfoByName.get(regionName) || {}, dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      if (!regionGroup) {
        regionGroup = regionsGroupByName.set(regionName, new Group$4());
        regionsGroup.add(regionGroup);
        dataIdx = data ? data.indexOfName(regionName) : null;
        regionModel = viewBuildCtx.isGeo ? mapOrGeoModel.getRegionModel(regionName) : data ? data.getItemModel(dataIdx) : null;
        regionsInfoByName.set(regionName, {
          dataIdx,
          regionModel
        });
      }
      var polygonSubpaths = [];
      var polylineSubpaths = [];
      each$f(region.geometries, function(geometry) {
        if (geometry.type === "polygon") {
          var polys = [geometry.exterior].concat(geometry.interiors || []);
          if (projectionStream) {
            polys = projectPolys(polys, projectionStream);
          }
          each$f(polys, function(poly) {
            polygonSubpaths.push(new Polygon$1(getPolyShape(poly)));
          });
        } else {
          var points2 = geometry.points;
          if (projectionStream) {
            points2 = projectPolys(points2, projectionStream, true);
          }
          each$f(points2, function(points3) {
            polylineSubpaths.push(new Polyline$3(getPolyShape(points3)));
          });
        }
      });
      var centerPt = transformPoint(region.getCenter(), projection && projection.project);
      function createCompoundPath(subpaths, isLine) {
        if (!subpaths.length) {
          return;
        }
        var compoundPath = new CompoundPath$1({
          culling: true,
          segmentIgnoreThreshold: 1,
          shape: {
            paths: subpaths
          }
        });
        regionGroup.add(compoundPath);
        applyOptionStyleForRegion(viewBuildCtx, compoundPath, dataIdx, regionModel);
        resetLabelForRegion(viewBuildCtx, compoundPath, regionName, regionModel, mapOrGeoModel, dataIdx, centerPt);
        if (isLine) {
          fixLineStyle(compoundPath);
          each$f(compoundPath.states, fixLineStyle);
        }
      }
      createCompoundPath(polygonSubpaths);
      createCompoundPath(polylineSubpaths, true);
    });
    regionsGroupByName.each(function(regionGroup, regionName) {
      var _a2 = regionsInfoByName.get(regionName), dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      resetEventTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel, dataIdx);
      resetTooltipForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
      resetStateTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
    }, this);
  };
  MapDraw2.prototype._buildSVG = function(viewBuildCtx) {
    var mapName = viewBuildCtx.geo.map;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    this._svgGroup.x = transformInfoRaw.x;
    this._svgGroup.y = transformInfoRaw.y;
    this._svgGroup.scaleX = transformInfoRaw.scaleX;
    this._svgGroup.scaleY = transformInfoRaw.scaleY;
    if (this._svgResourceChanged(mapName)) {
      this._freeSVG();
      this._useSVG(mapName);
    }
    var svgDispatcherMap = this._svgDispatcherMap = createHashMap();
    var focusSelf = false;
    each$f(this._svgGraphicRecord.named, function(namedItem) {
      var regionName = namedItem.name;
      var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
      var data = viewBuildCtx.data;
      var svgNodeTagLower = namedItem.svgNodeTagLower;
      var el = namedItem.el;
      var dataIdx = data ? data.indexOfName(regionName) : null;
      var regionModel = mapOrGeoModel.getRegionModel(regionName);
      if (OPTION_STYLE_ENABLED_TAG_MAP.get(svgNodeTagLower) != null && el instanceof Displayable$1) {
        applyOptionStyleForRegion(viewBuildCtx, el, dataIdx, regionModel);
      }
      if (el instanceof Displayable$1) {
        el.culling = true;
      }
      el.z2EmphasisLift = 0;
      if (!namedItem.namedFrom) {
        if (LABEL_HOST_MAP.get(svgNodeTagLower) != null) {
          resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, null);
        }
        resetEventTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx);
        resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
        if (STATE_TRIGGER_TAG_MAP.get(svgNodeTagLower) != null) {
          var focus_1 = resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
          if (focus_1 === "self") {
            focusSelf = true;
          }
          var els = svgDispatcherMap.get(regionName) || svgDispatcherMap.set(regionName, []);
          els.push(el);
        }
      }
    }, this);
    this._enableBlurEntireSVG(focusSelf, viewBuildCtx);
  };
  MapDraw2.prototype._enableBlurEntireSVG = function(focusSelf, viewBuildCtx) {
    if (focusSelf && viewBuildCtx.isGeo) {
      var blurStyle = viewBuildCtx.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle();
      var opacity_1 = blurStyle.opacity;
      this._svgGraphicRecord.root.traverse(function(el) {
        if (!el.isGroup) {
          setDefaultStateProxy(el);
          var style = el.ensureState("blur").style || {};
          if (style.opacity == null && opacity_1 != null) {
            style.opacity = opacity_1;
          }
          el.ensureState("emphasis");
        }
      });
    }
  };
  MapDraw2.prototype.remove = function() {
    this._regionsGroup.removeAll();
    this._regionsGroupByName = null;
    this._svgGroup.removeAll();
    this._freeSVG();
    this._controller.dispose();
    this._controllerHost = null;
  };
  MapDraw2.prototype.findHighDownDispatchers = function(name, geoModel) {
    if (name == null) {
      return [];
    }
    var geo = geoModel.coordinateSystem;
    if (geo.resourceType === "geoJSON") {
      var regionsGroupByName = this._regionsGroupByName;
      if (regionsGroupByName) {
        var regionGroup = regionsGroupByName.get(name);
        return regionGroup ? [regionGroup] : [];
      }
    } else if (geo.resourceType === "geoSVG") {
      return this._svgDispatcherMap && this._svgDispatcherMap.get(name) || [];
    }
  };
  MapDraw2.prototype._svgResourceChanged = function(mapName) {
    return this._svgMapName !== mapName;
  };
  MapDraw2.prototype._useSVG = function(mapName) {
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      var svgGraphic = resource.useGraphic(this.uid);
      this._svgGroup.add(svgGraphic.root);
      this._svgGraphicRecord = svgGraphic;
      this._svgMapName = mapName;
    }
  };
  MapDraw2.prototype._freeSVG = function() {
    var mapName = this._svgMapName;
    if (mapName == null) {
      return;
    }
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      resource.freeGraphic(this.uid);
    }
    this._svgGraphicRecord = null;
    this._svgDispatcherMap = null;
    this._svgGroup.removeAll();
    this._svgMapName = null;
  };
  MapDraw2.prototype._updateController = function(mapOrGeoModel, ecModel, api) {
    var geo = mapOrGeoModel.coordinateSystem;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    controllerHost.zoomLimit = mapOrGeoModel.get("scaleLimit");
    controllerHost.zoom = geo.getZoom();
    controller.enable(mapOrGeoModel.get("roam") || false);
    var mainType = mapOrGeoModel.mainType;
    function makeActionBase() {
      var action = {
        type: "geoRoam",
        componentType: mainType
      };
      action[mainType + "Id"] = mapOrGeoModel.id;
      return action;
    }
    controller.off("pan").on("pan", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction(extend(makeActionBase(), {
        dx: e2.dx,
        dy: e2.dy,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.off("zoom").on("zoom", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction(extend(makeActionBase(), {
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.setPointerChecker(function(e2, x2, y2) {
      return geo.containPoint([x2, y2]) && !onIrrelevantElement(e2, api, mapOrGeoModel);
    });
  };
  MapDraw2.prototype.resetForLabelLayout = function() {
    this.group.traverse(function(el) {
      var label = el.getTextContent();
      if (label) {
        label.ignore = mapLabelRaw(label).ignore;
      }
    });
  };
  MapDraw2.prototype._updateMapSelectHandler = function(mapOrGeoModel, regionsGroup, api, fromView) {
    var mapDraw = this;
    regionsGroup.off("mousedown");
    regionsGroup.off("click");
    if (mapOrGeoModel.get("selectedMode")) {
      regionsGroup.on("mousedown", function() {
        mapDraw._mouseDownFlag = true;
      });
      regionsGroup.on("click", function(e2) {
        if (!mapDraw._mouseDownFlag) {
          return;
        }
        mapDraw._mouseDownFlag = false;
      });
    }
  };
  return MapDraw2;
}();
function applyOptionStyleForRegion(viewBuildCtx, el, dataIndex, regionModel) {
  var normalStyleModel = regionModel.getModel("itemStyle");
  var emphasisStyleModel = regionModel.getModel(["emphasis", "itemStyle"]);
  var blurStyleModel = regionModel.getModel(["blur", "itemStyle"]);
  var selectStyleModel = regionModel.getModel(["select", "itemStyle"]);
  var normalStyle = getFixedItemStyle(normalStyleModel);
  var emphasisStyle = getFixedItemStyle(emphasisStyleModel);
  var selectStyle = getFixedItemStyle(selectStyleModel);
  var blurStyle = getFixedItemStyle(blurStyleModel);
  var data = viewBuildCtx.data;
  if (data) {
    var style = data.getItemVisual(dataIndex, "style");
    var decal = data.getItemVisual(dataIndex, "decal");
    if (viewBuildCtx.isVisualEncodedByVisualMap && style.fill) {
      normalStyle.fill = style.fill;
    }
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, viewBuildCtx.api);
    }
  }
  el.setStyle(normalStyle);
  el.style.strokeNoScale = true;
  el.ensureState("emphasis").style = emphasisStyle;
  el.ensureState("select").style = selectStyle;
  el.ensureState("blur").style = blurStyle;
  setDefaultStateProxy(el);
}
function resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, labelXY) {
  var data = viewBuildCtx.data;
  var isGeo = viewBuildCtx.isGeo;
  var isDataNaN = data && isNaN(data.get(data.mapDimension("value"), dataIdx));
  var itemLayout = data && data.getItemLayout(dataIdx);
  if (isGeo || isDataNaN || itemLayout && itemLayout.showLabel) {
    var query = !isGeo ? dataIdx : regionName;
    var labelFetcher = void 0;
    if (!data || dataIdx >= 0) {
      labelFetcher = mapOrGeoModel;
    }
    var specifiedTextOpt = labelXY ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    setLabelStyle(el, getLabelStatesModels(regionModel), {
      labelFetcher,
      labelDataIndex: query,
      defaultText: regionName
    }, specifiedTextOpt);
    var textEl = el.getTextContent();
    if (textEl) {
      mapLabelRaw(textEl).ignore = textEl.ignore;
      if (el.textConfig && labelXY) {
        var rect = el.getBoundingRect().clone();
        el.textConfig.layoutRect = rect;
        el.textConfig.position = [(labelXY[0] - rect.x) / rect.width * 100 + "%", (labelXY[1] - rect.y) / rect.height * 100 + "%"];
      }
    }
    el.disableLabelAnimation = true;
  } else {
    el.removeTextContent();
    el.removeTextConfig();
    el.disableLabelAnimation = null;
  }
}
function resetEventTriggerForRegion(viewBuildCtx, eventTrigger, regionName, regionModel, mapOrGeoModel, dataIdx) {
  if (viewBuildCtx.data) {
    viewBuildCtx.data.setItemGraphicEl(dataIdx, eventTrigger);
  } else {
    getECData(eventTrigger).eventData = {
      componentType: "geo",
      componentIndex: mapOrGeoModel.componentIndex,
      geoIndex: mapOrGeoModel.componentIndex,
      name: regionName,
      region: regionModel && regionModel.option || {}
    };
  }
}
function resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  if (!viewBuildCtx.data) {
    setTooltipConfig({
      el,
      componentModel: mapOrGeoModel,
      itemName: regionName,
      itemTooltipOption: regionModel.get("tooltip")
    });
  }
}
function resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  el.highDownSilentOnTouch = !!mapOrGeoModel.get("selectedMode");
  var emphasisModel = regionModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  toggleHoverEmphasis(el, focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  if (viewBuildCtx.isGeo) {
    enableComponentHighDownFeatures(el, mapOrGeoModel, regionName);
  }
  return focus;
}
function projectPolys(rings, createStream, isLine) {
  var polygons = [];
  var curPoly;
  function startPolygon() {
    curPoly = [];
  }
  function endPolygon() {
    if (curPoly.length) {
      polygons.push(curPoly);
      curPoly = [];
    }
  }
  var stream = createStream({
    polygonStart: startPolygon,
    polygonEnd: endPolygon,
    lineStart: startPolygon,
    lineEnd: endPolygon,
    point: function(x2, y2) {
      if (isFinite(x2) && isFinite(y2)) {
        curPoly.push([x2, y2]);
      }
    },
    sphere: function() {
    }
  });
  !isLine && stream.polygonStart();
  each$f(rings, function(ring) {
    stream.lineStart();
    for (var i = 0; i < ring.length; i++) {
      stream.point(ring[i][0], ring[i][1]);
    }
    stream.lineEnd();
  });
  !isLine && stream.polygonEnd();
  return polygons;
}
var MapDraw$1 = MapDraw;
var MapView = function(_super) {
  __extends(MapView2, _super);
  function MapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapView2.type;
    return _this;
  }
  MapView2.prototype.render = function(mapModel, ecModel, api, payload) {
    if (payload && payload.type === "mapToggleSelect" && payload.from === this.uid) {
      return;
    }
    var group = this.group;
    group.removeAll();
    if (mapModel.getHostGeoModel()) {
      return;
    }
    if (this._mapDraw && payload && payload.type === "geoRoam") {
      this._mapDraw.resetForLabelLayout();
    }
    if (!(payload && payload.type === "geoRoam" && payload.componentType === "series" && payload.seriesId === mapModel.id)) {
      if (mapModel.needsDrawMap) {
        var mapDraw = this._mapDraw || new MapDraw$1(api);
        group.add(mapDraw.group);
        mapDraw.draw(mapModel, ecModel, api, this, payload);
        this._mapDraw = mapDraw;
      } else {
        this._mapDraw && this._mapDraw.remove();
        this._mapDraw = null;
      }
    } else {
      var mapDraw = this._mapDraw;
      mapDraw && group.add(mapDraw.group);
    }
    mapModel.get("showLegendSymbol") && ecModel.getComponent("legend") && this._renderSymbols(mapModel, ecModel, api);
  };
  MapView2.prototype.remove = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
    this.group.removeAll();
  };
  MapView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
  };
  MapView2.prototype._renderSymbols = function(mapModel, ecModel, api) {
    var originalData = mapModel.originalData;
    var group = this.group;
    originalData.each(originalData.mapDimension("value"), function(value, originalDataIndex) {
      if (isNaN(value)) {
        return;
      }
      var layout2 = originalData.getItemLayout(originalDataIndex);
      if (!layout2 || !layout2.point) {
        return;
      }
      var point = layout2.point;
      var offset = layout2.offset;
      var circle = new Circle$1({
        style: {
          fill: mapModel.getData().getVisual("style").fill
        },
        shape: {
          cx: point[0] + offset * 9,
          cy: point[1],
          r: 3
        },
        silent: true,
        z2: 8 + (!offset ? Z2_EMPHASIS_LIFT + 1 : 0)
      });
      if (!offset) {
        var fullData = mapModel.mainSeries.getData();
        var name_1 = originalData.getName(originalDataIndex);
        var fullIndex_1 = fullData.indexOfName(name_1);
        var itemModel = originalData.getItemModel(originalDataIndex);
        var labelModel = itemModel.getModel("label");
        var regionGroup = fullData.getItemGraphicEl(fullIndex_1);
        setLabelStyle(circle, getLabelStatesModels(itemModel), {
          labelFetcher: {
            getFormattedLabel: function(idx, state) {
              return mapModel.getFormattedLabel(fullIndex_1, state);
            }
          },
          defaultText: name_1
        });
        circle.disableLabelAnimation = true;
        if (!labelModel.get("position")) {
          circle.setTextConfig({
            position: "bottom"
          });
        }
        regionGroup.onHoverStateChange = function(toState) {
          setStatesFlag(circle, toState);
        };
      }
      group.add(circle);
    });
  };
  MapView2.type = "map";
  return MapView2;
}(ChartView$1);
var MapView$1 = MapView;
var MapSeries = function(_super) {
  __extends(MapSeries2, _super);
  function MapSeries2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapSeries2.type;
    _this.needsDrawMap = false;
    _this.seriesGroup = [];
    _this.getTooltipPosition = function(dataIndex) {
      if (dataIndex != null) {
        var name_1 = this.getData().getName(dataIndex);
        var geo = this.coordinateSystem;
        var region = geo.getRegion(name_1);
        return region && geo.dataToPoint(region.getCenter());
      }
    };
    return _this;
  }
  MapSeries2.prototype.getInitialData = function(option) {
    var data = createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
    var dataNameMap = createHashMap();
    var toAppendNames = [];
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      var name_2 = data.getName(i);
      dataNameMap.set(name_2, true);
    }
    var geoSource = geoSourceManager.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
    each$f(geoSource.regions, function(region) {
      var name = region.name;
      if (!dataNameMap.get(name)) {
        toAppendNames.push(name);
      }
    });
    data.appendValues([], toAppendNames);
    return data;
  };
  MapSeries2.prototype.getHostGeoModel = function() {
    var geoIndex = this.option.geoIndex;
    return geoIndex != null ? this.ecModel.getComponent("geo", geoIndex) : null;
  };
  MapSeries2.prototype.getMapType = function() {
    return (this.getHostGeoModel() || this).option.map;
  };
  MapSeries2.prototype.getRawValue = function(dataIndex) {
    var data = this.getData();
    return data.get(data.mapDimension("value"), dataIndex);
  };
  MapSeries2.prototype.getRegionModel = function(regionName) {
    var data = this.getData();
    return data.getItemModel(data.indexOfName(regionName));
  };
  MapSeries2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    var seriesGroup = this.seriesGroup;
    var seriesNames = [];
    for (var i = 0; i < seriesGroup.length; i++) {
      var otherIndex = seriesGroup[i].originalData.indexOfName(name);
      var valueDim = data.mapDimension("value");
      if (!isNaN(seriesGroup[i].originalData.get(valueDim, otherIndex))) {
        seriesNames.push(seriesGroup[i].name);
      }
    }
    return createTooltipMarkup("section", {
      header: seriesNames.join(", "),
      noHeader: !seriesNames.length,
      blocks: [createTooltipMarkup("nameValue", {
        name,
        value
      })]
    });
  };
  MapSeries2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  MapSeries2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  MapSeries2.prototype.getLegendIcon = function(opt) {
    var iconType = opt.icon || "roundRect";
    var icon = createSymbol$1(iconType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill);
    icon.setStyle(opt.itemStyle);
    icon.style.stroke = "none";
    if (iconType.indexOf("empty") > -1) {
      icon.style.stroke = icon.style.fill;
      icon.style.fill = "#fff";
      icon.style.lineWidth = 2;
    }
    return icon;
  };
  MapSeries2.type = "series.map";
  MapSeries2.dependencies = ["geo"];
  MapSeries2.layoutMode = "box";
  MapSeries2.defaultOption = {
    z: 2,
    coordinateSystem: "geo",
    map: "",
    left: "center",
    top: "center",
    aspectScale: null,
    showLegendSymbol: true,
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    selectedMode: true,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444",
      areaColor: "#eee"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        areaColor: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    nameProperty: "name"
  };
  return MapSeries2;
}(SeriesModel$1);
var MapSeries$1 = MapSeries;
function dataStatistics(datas, statisticType) {
  var dataNameMap = {};
  each$f(datas, function(data) {
    data.each(data.mapDimension("value"), function(value, idx) {
      var mapKey = "ec-" + data.getName(idx);
      dataNameMap[mapKey] = dataNameMap[mapKey] || [];
      if (!isNaN(value)) {
        dataNameMap[mapKey].push(value);
      }
    });
  });
  return datas[0].map(datas[0].mapDimension("value"), function(value, idx) {
    var mapKey = "ec-" + datas[0].getName(idx);
    var sum2 = 0;
    var min3 = Infinity;
    var max3 = -Infinity;
    var len2 = dataNameMap[mapKey].length;
    for (var i = 0; i < len2; i++) {
      min3 = Math.min(min3, dataNameMap[mapKey][i]);
      max3 = Math.max(max3, dataNameMap[mapKey][i]);
      sum2 += dataNameMap[mapKey][i];
    }
    var result;
    if (statisticType === "min") {
      result = min3;
    } else if (statisticType === "max") {
      result = max3;
    } else if (statisticType === "average") {
      result = sum2 / len2;
    } else {
      result = sum2;
    }
    return len2 === 0 ? NaN : result;
  });
}
function mapDataStatistic(ecModel) {
  var seriesGroups = {};
  ecModel.eachSeriesByType("map", function(seriesModel) {
    var hostGeoModel = seriesModel.getHostGeoModel();
    var key = hostGeoModel ? "o" + hostGeoModel.id : "i" + seriesModel.getMapType();
    (seriesGroups[key] = seriesGroups[key] || []).push(seriesModel);
  });
  each$f(seriesGroups, function(seriesList, key) {
    var data = dataStatistics(map$1(seriesList, function(seriesModel) {
      return seriesModel.getData();
    }), seriesList[0].get("mapValueCalculation"));
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].originalData = seriesList[i].getData();
    }
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].seriesGroup = seriesList;
      seriesList[i].needsDrawMap = i === 0 && !seriesList[i].getHostGeoModel();
      seriesList[i].setData(data.cloneShallow());
      seriesList[i].mainSeries = seriesList[0];
    }
  });
}
function mapSymbolLayout(ecModel) {
  var processedMapType = {};
  ecModel.eachSeriesByType("map", function(mapSeries) {
    var mapType = mapSeries.getMapType();
    if (mapSeries.getHostGeoModel() || processedMapType[mapType]) {
      return;
    }
    var mapSymbolOffsets = {};
    each$f(mapSeries.seriesGroup, function(subMapSeries) {
      var geo = subMapSeries.coordinateSystem;
      var data2 = subMapSeries.originalData;
      if (subMapSeries.get("showLegendSymbol") && ecModel.getComponent("legend")) {
        data2.each(data2.mapDimension("value"), function(value, idx) {
          var name = data2.getName(idx);
          var region = geo.getRegion(name);
          if (!region || isNaN(value)) {
            return;
          }
          var offset = mapSymbolOffsets[name] || 0;
          var point = geo.dataToPoint(region.getCenter());
          mapSymbolOffsets[name] = offset + 1;
          data2.setItemLayout(idx, {
            point,
            offset
          });
        });
      }
    });
    var data = mapSeries.getData();
    data.each(function(idx) {
      var name = data.getName(idx);
      var layout2 = data.getItemLayout(idx) || {};
      layout2.showLabel = !mapSymbolOffsets[name];
      data.setItemLayout(idx, layout2);
    });
    processedMapType[mapType] = true;
  });
}
var v2ApplyTransform = applyTransform$1;
var View = function(_super) {
  __extends(View2, _super);
  function View2(name) {
    var _this = _super.call(this) || this;
    _this.type = "view";
    _this.dimensions = ["x", "y"];
    _this._roamTransformable = new Transformable$1();
    _this._rawTransformable = new Transformable$1();
    _this.name = name;
    return _this;
  }
  View2.prototype.setBoundingRect = function(x2, y2, width, height) {
    this._rect = new BoundingRect$1(x2, y2, width, height);
    return this._rect;
  };
  View2.prototype.getBoundingRect = function() {
    return this._rect;
  };
  View2.prototype.setViewRect = function(x2, y2, width, height) {
    this._transformTo(x2, y2, width, height);
    this._viewRect = new BoundingRect$1(x2, y2, width, height);
  };
  View2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var rawTransform = this._rawTransformable;
    rawTransform.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransform.parent;
    rawTransform.parent = null;
    rawTransform.decomposeTransform();
    rawTransform.parent = rawParent;
    this._updateTransform();
  };
  View2.prototype.setCenter = function(centerCoord) {
    if (!centerCoord) {
      return;
    }
    this._center = centerCoord;
    this._updateCenterAndZoom();
  };
  View2.prototype.setZoom = function(zoom) {
    zoom = zoom || 1;
    var zoomLimit = this.zoomLimit;
    if (zoomLimit) {
      if (zoomLimit.max != null) {
        zoom = Math.min(zoomLimit.max, zoom);
      }
      if (zoomLimit.min != null) {
        zoom = Math.max(zoomLimit.min, zoom);
      }
    }
    this._zoom = zoom;
    this._updateCenterAndZoom();
  };
  View2.prototype.getDefaultCenter = function() {
    var rawRect = this.getBoundingRect();
    var cx = rawRect.x + rawRect.width / 2;
    var cy = rawRect.y + rawRect.height / 2;
    return [cx, cy];
  };
  View2.prototype.getCenter = function() {
    return this._center || this.getDefaultCenter();
  };
  View2.prototype.getZoom = function() {
    return this._zoom || 1;
  };
  View2.prototype.getRoamTransform = function() {
    return this._roamTransformable.getLocalTransform();
  };
  View2.prototype._updateCenterAndZoom = function() {
    var rawTransformMatrix = this._rawTransformable.getLocalTransform();
    var roamTransform = this._roamTransformable;
    var defaultCenter = this.getDefaultCenter();
    var center2 = this.getCenter();
    var zoom = this.getZoom();
    center2 = applyTransform$1([], center2, rawTransformMatrix);
    defaultCenter = applyTransform$1([], defaultCenter, rawTransformMatrix);
    roamTransform.originX = center2[0];
    roamTransform.originY = center2[1];
    roamTransform.x = defaultCenter[0] - center2[0];
    roamTransform.y = defaultCenter[1] - center2[1];
    roamTransform.scaleX = roamTransform.scaleY = zoom;
    this._updateTransform();
  };
  View2.prototype._updateTransform = function() {
    var roamTransformable = this._roamTransformable;
    var rawTransformable = this._rawTransformable;
    rawTransformable.parent = roamTransformable;
    roamTransformable.updateTransform();
    rawTransformable.updateTransform();
    copy(this.transform || (this.transform = []), rawTransformable.transform || create$1());
    this._rawTransform = rawTransformable.getLocalTransform();
    this.invTransform = this.invTransform || [];
    invert(this.invTransform, this.transform);
    this.decomposeTransform();
  };
  View2.prototype.getTransformInfo = function() {
    var rawTransformable = this._rawTransformable;
    var roamTransformable = this._roamTransformable;
    var dummyTransformable2 = new Transformable$1();
    dummyTransformable2.transform = roamTransformable.transform;
    dummyTransformable2.decomposeTransform();
    return {
      roam: {
        x: dummyTransformable2.x,
        y: dummyTransformable2.y,
        scaleX: dummyTransformable2.scaleX,
        scaleY: dummyTransformable2.scaleY
      },
      raw: {
        x: rawTransformable.x,
        y: rawTransformable.y,
        scaleX: rawTransformable.scaleX,
        scaleY: rawTransformable.scaleY
      }
    };
  };
  View2.prototype.getViewRect = function() {
    return this._viewRect;
  };
  View2.prototype.getViewRectAfterRoam = function() {
    var rect = this.getBoundingRect().clone();
    rect.applyTransform(this.transform);
    return rect;
  };
  View2.prototype.dataToPoint = function(data, noRoam, out2) {
    var transform2 = noRoam ? this._rawTransform : this.transform;
    out2 = out2 || [];
    return transform2 ? v2ApplyTransform(out2, data, transform2) : copy$1(out2, data);
  };
  View2.prototype.pointToData = function(point) {
    var invTransform = this.invTransform;
    return invTransform ? v2ApplyTransform([], point, invTransform) : [point[0], point[1]];
  };
  View2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  View2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  View2.prototype.containPoint = function(point) {
    return this.getViewRectAfterRoam().contain(point[0], point[1]);
  };
  View2.dimensions = ["x", "y"];
  return View2;
}(Transformable$1);
function getCoordSys$4(finder) {
  var seriesModel = finder.seriesModel;
  return seriesModel ? seriesModel.coordinateSystem : null;
}
var View$1 = View;
var GEO_DEFAULT_PARAMS = {
  "geoJSON": {
    aspectScale: 0.75,
    invertLongitute: true
  },
  "geoSVG": {
    aspectScale: 1,
    invertLongitute: false
  }
};
var geo2DDimensions = ["lng", "lat"];
var Geo = function(_super) {
  __extends(Geo2, _super);
  function Geo2(name, map2, opt) {
    var _this = _super.call(this, name) || this;
    _this.dimensions = geo2DDimensions;
    _this.type = "geo";
    _this._nameCoordMap = createHashMap();
    _this.map = map2;
    var projection = opt.projection;
    var source = geoSourceManager.load(map2, opt.nameMap, opt.nameProperty);
    var resource = geoSourceManager.getGeoResource(map2);
    _this.resourceType = resource ? resource.type : null;
    var regions = _this.regions = source.regions;
    var defaultParams = GEO_DEFAULT_PARAMS[resource.type];
    _this._regionsMap = source.regionsMap;
    _this.regions = source.regions;
    _this.projection = projection;
    var boundingRect;
    if (projection) {
      for (var i = 0; i < regions.length; i++) {
        var regionRect = regions[i].getBoundingRect(projection);
        boundingRect = boundingRect || regionRect.clone();
        boundingRect.union(regionRect);
      }
    } else {
      boundingRect = source.boundingRect;
    }
    _this.setBoundingRect(boundingRect.x, boundingRect.y, boundingRect.width, boundingRect.height);
    _this.aspectScale = projection ? 1 : retrieve2(opt.aspectScale, defaultParams.aspectScale);
    _this._invertLongitute = projection ? false : defaultParams.invertLongitute;
    return _this;
  }
  Geo2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var invertLongitute = this._invertLongitute;
    rect = rect.clone();
    if (invertLongitute) {
      rect.y = -rect.y - rect.height;
    }
    var rawTransformable = this._rawTransformable;
    rawTransformable.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransformable.parent;
    rawTransformable.parent = null;
    rawTransformable.decomposeTransform();
    rawTransformable.parent = rawParent;
    if (invertLongitute) {
      rawTransformable.scaleY = -rawTransformable.scaleY;
    }
    this._updateTransform();
  };
  Geo2.prototype.getRegion = function(name) {
    return this._regionsMap.get(name);
  };
  Geo2.prototype.getRegionByCoord = function(coord) {
    var regions = this.regions;
    for (var i = 0; i < regions.length; i++) {
      var region = regions[i];
      if (region.type === "geoJSON" && region.contain(coord)) {
        return regions[i];
      }
    }
  };
  Geo2.prototype.addGeoCoord = function(name, geoCoord2) {
    this._nameCoordMap.set(name, geoCoord2);
  };
  Geo2.prototype.getGeoCoord = function(name) {
    var region = this._regionsMap.get(name);
    return this._nameCoordMap.get(name) || region && region.getCenter();
  };
  Geo2.prototype.dataToPoint = function(data, noRoam, out2) {
    if (isString(data)) {
      data = this.getGeoCoord(data);
    }
    if (data) {
      var projection = this.projection;
      if (projection) {
        data = projection.project(data);
      }
      return data && this.projectedToPoint(data);
    }
  };
  Geo2.prototype.pointToData = function(point) {
    var projection = this.projection;
    if (projection) {
      point = projection.unproject(point);
    }
    return point && this.pointToProjected(point);
  };
  Geo2.prototype.pointToProjected = function(point) {
    return _super.prototype.pointToData.call(this, point);
  };
  Geo2.prototype.projectedToPoint = function(projected, noRoam, out2) {
    return _super.prototype.dataToPoint.call(this, projected, noRoam, out2);
  };
  Geo2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Geo2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  return Geo2;
}(View$1);
mixin(Geo, View$1);
function getCoordSys$3(finder) {
  var geoModel = finder.geoModel;
  var seriesModel = finder.seriesModel;
  return geoModel ? geoModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem || (seriesModel.getReferringComponents("geo", SINGLE_REFERRING).models[0] || {}).coordinateSystem : null;
}
var Geo$1 = Geo;
function resizeGeo(geoModel, api) {
  var boundingCoords = geoModel.get("boundingCoords");
  if (boundingCoords != null) {
    var leftTop_1 = boundingCoords[0];
    var rightBottom_1 = boundingCoords[1];
    if (!(isFinite(leftTop_1[0]) && isFinite(leftTop_1[1]) && isFinite(rightBottom_1[0]) && isFinite(rightBottom_1[1])))
      ;
    else {
      var projection_1 = this.projection;
      if (projection_1) {
        var xMin = leftTop_1[0];
        var yMin = leftTop_1[1];
        var xMax = rightBottom_1[0];
        var yMax = rightBottom_1[1];
        leftTop_1 = [Infinity, Infinity];
        rightBottom_1 = [-Infinity, -Infinity];
        var sampleLine = function(x0, y0, x1, y1) {
          var dx = x1 - x0;
          var dy = y1 - y0;
          for (var i = 0; i <= 100; i++) {
            var p2 = i / 100;
            var pt = projection_1.project([x0 + dx * p2, y0 + dy * p2]);
            min$1(leftTop_1, leftTop_1, pt);
            max$1(rightBottom_1, rightBottom_1, pt);
          }
        };
        sampleLine(xMin, yMin, xMax, yMin);
        sampleLine(xMax, yMin, xMax, yMax);
        sampleLine(xMax, yMax, xMin, yMax);
        sampleLine(xMin, yMax, xMax, yMin);
      }
      this.setBoundingRect(leftTop_1[0], leftTop_1[1], rightBottom_1[0] - leftTop_1[0], rightBottom_1[1] - leftTop_1[1]);
    }
  }
  var rect = this.getBoundingRect();
  var centerOption = geoModel.get("layoutCenter");
  var sizeOption = geoModel.get("layoutSize");
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  var aspect = rect.width / rect.height * this.aspectScale;
  var useCenterAndSize = false;
  var center2;
  var size;
  if (centerOption && sizeOption) {
    center2 = [parsePercent(centerOption[0], viewWidth), parsePercent(centerOption[1], viewHeight)];
    size = parsePercent(sizeOption, Math.min(viewWidth, viewHeight));
    if (!isNaN(center2[0]) && !isNaN(center2[1]) && !isNaN(size)) {
      useCenterAndSize = true;
    }
  }
  var viewRect2;
  if (useCenterAndSize) {
    viewRect2 = {};
    if (aspect > 1) {
      viewRect2.width = size;
      viewRect2.height = size / aspect;
    } else {
      viewRect2.height = size;
      viewRect2.width = size * aspect;
    }
    viewRect2.y = center2[1] - viewRect2.height / 2;
    viewRect2.x = center2[0] - viewRect2.width / 2;
  } else {
    var boxLayoutOption = geoModel.getBoxLayoutParams();
    boxLayoutOption.aspect = aspect;
    viewRect2 = getLayoutRect(boxLayoutOption, {
      width: viewWidth,
      height: viewHeight
    });
  }
  this.setViewRect(viewRect2.x, viewRect2.y, viewRect2.width, viewRect2.height);
  this.setCenter(geoModel.get("center"));
  this.setZoom(geoModel.get("zoom"));
}
function setGeoCoords(geo, model) {
  each$f(model.get("geoCoord"), function(geoCoord2, name) {
    geo.addGeoCoord(name, geoCoord2);
  });
}
var GeoCreator = function() {
  function GeoCreator2() {
    this.dimensions = geo2DDimensions;
  }
  GeoCreator2.prototype.create = function(ecModel, api) {
    var geoList = [];
    function getCommonGeoProperties(model) {
      return {
        nameProperty: model.get("nameProperty"),
        aspectScale: model.get("aspectScale"),
        projection: model.get("projection")
      };
    }
    ecModel.eachComponent("geo", function(geoModel, idx) {
      var mapName = geoModel.get("map");
      var geo = new Geo$1(mapName + idx, mapName, extend({
        nameMap: geoModel.get("nameMap")
      }, getCommonGeoProperties(geoModel)));
      geo.zoomLimit = geoModel.get("scaleLimit");
      geoList.push(geo);
      geoModel.coordinateSystem = geo;
      geo.model = geoModel;
      geo.resize = resizeGeo;
      geo.resize(geoModel, api);
    });
    ecModel.eachSeries(function(seriesModel) {
      var coordSys = seriesModel.get("coordinateSystem");
      if (coordSys === "geo") {
        var geoIndex = seriesModel.get("geoIndex") || 0;
        seriesModel.coordinateSystem = geoList[geoIndex];
      }
    });
    var mapModelGroupBySeries = {};
    ecModel.eachSeriesByType("map", function(seriesModel) {
      if (!seriesModel.getHostGeoModel()) {
        var mapType = seriesModel.getMapType();
        mapModelGroupBySeries[mapType] = mapModelGroupBySeries[mapType] || [];
        mapModelGroupBySeries[mapType].push(seriesModel);
      }
    });
    each$f(mapModelGroupBySeries, function(mapSeries, mapType) {
      var nameMapList = map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("nameMap");
      });
      var geo = new Geo$1(mapType, mapType, extend({
        nameMap: mergeAll(nameMapList)
      }, getCommonGeoProperties(mapSeries[0])));
      geo.zoomLimit = retrieve.apply(null, map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("scaleLimit");
      }));
      geoList.push(geo);
      geo.resize = resizeGeo;
      geo.resize(mapSeries[0], api);
      each$f(mapSeries, function(singleMapSeries) {
        singleMapSeries.coordinateSystem = geo;
        setGeoCoords(geo, singleMapSeries);
      });
    });
    return geoList;
  };
  GeoCreator2.prototype.getFilledRegions = function(originRegionArr, mapName, nameMap, nameProperty) {
    var regionsArr = (originRegionArr || []).slice();
    var dataNameMap = createHashMap();
    for (var i = 0; i < regionsArr.length; i++) {
      dataNameMap.set(regionsArr[i].name, regionsArr[i]);
    }
    var source = geoSourceManager.load(mapName, nameMap, nameProperty);
    each$f(source.regions, function(region) {
      var name = region.name;
      !dataNameMap.get(name) && regionsArr.push({
        name
      });
    });
    return regionsArr;
  };
  return GeoCreator2;
}();
var geoCreator = new GeoCreator();
var geoCreator$1 = geoCreator;
var GeoModel = function(_super) {
  __extends(GeoModel2, _super);
  function GeoModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoModel2.type;
    return _this;
  }
  GeoModel2.prototype.init = function(option, parentModel, ecModel) {
    var source = geoSourceManager.getGeoResource(option.map);
    if (source && source.type === "geoJSON") {
      var itemStyle = option.itemStyle = option.itemStyle || {};
      if (!("color" in itemStyle)) {
        itemStyle.color = "#eee";
      }
    }
    this.mergeDefaultAndTheme(option, ecModel);
    defaultEmphasis(option, "label", ["show"]);
  };
  GeoModel2.prototype.optionUpdated = function() {
    var _this = this;
    var option = this.option;
    option.regions = geoCreator$1.getFilledRegions(option.regions, option.map, option.nameMap, option.nameProperty);
    var selectedMap = {};
    this._optionModelMap = reduce(option.regions || [], function(optionModelMap, regionOpt) {
      var regionName = regionOpt.name;
      if (regionName) {
        optionModelMap.set(regionName, new Model$1(regionOpt, _this, _this.ecModel));
        if (regionOpt.selected) {
          selectedMap[regionName] = true;
        }
      }
      return optionModelMap;
    }, createHashMap());
    if (!option.selectedMap) {
      option.selectedMap = selectedMap;
    }
  };
  GeoModel2.prototype.getRegionModel = function(name) {
    return this._optionModelMap.get(name) || new Model$1(null, this, this.ecModel);
  };
  GeoModel2.prototype.getFormattedLabel = function(name, status) {
    var regionModel = this.getRegionModel(name);
    var formatter = status === "normal" ? regionModel.get(["label", "formatter"]) : regionModel.get(["emphasis", "label", "formatter"]);
    var params = {
      name
    };
    if (isFunction(formatter)) {
      params.status = status;
      return formatter(params);
    } else if (isString(formatter)) {
      return formatter.replace("{a}", name != null ? name : "");
    }
  };
  GeoModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GeoModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GeoModel2.prototype.select = function(name) {
    var option = this.option;
    var selectedMode = option.selectedMode;
    if (!selectedMode) {
      return;
    }
    if (selectedMode !== "multiple") {
      option.selectedMap = null;
    }
    var selectedMap = option.selectedMap || (option.selectedMap = {});
    selectedMap[name] = true;
  };
  GeoModel2.prototype.unSelect = function(name) {
    var selectedMap = this.option.selectedMap;
    if (selectedMap) {
      selectedMap[name] = false;
    }
  };
  GeoModel2.prototype.toggleSelected = function(name) {
    this[this.isSelected(name) ? "unSelect" : "select"](name);
  };
  GeoModel2.prototype.isSelected = function(name) {
    var selectedMap = this.option.selectedMap;
    return !!(selectedMap && selectedMap[name]);
  };
  GeoModel2.type = "geo";
  GeoModel2.layoutMode = "box";
  GeoModel2.defaultOption = {
    z: 0,
    show: true,
    left: "center",
    top: "center",
    aspectScale: null,
    silent: false,
    map: "",
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    regions: []
  };
  return GeoModel2;
}(ComponentModel$1);
var GeoModel$1 = GeoModel;
function getCenterCoord(view, point) {
  return view.pointToProjected ? view.pointToProjected(point) : view.pointToData(point);
}
function updateCenterAndZoom(view, payload, zoomLimit) {
  var previousZoom = view.getZoom();
  var center2 = view.getCenter();
  var zoom = payload.zoom;
  var point = view.projectedToPoint ? view.projectedToPoint(center2) : view.dataToPoint(center2);
  if (payload.dx != null && payload.dy != null) {
    point[0] -= payload.dx;
    point[1] -= payload.dy;
    view.setCenter(getCenterCoord(view, point));
  }
  if (zoom != null) {
    if (zoomLimit) {
      var zoomMin = zoomLimit.min || 0;
      var zoomMax = zoomLimit.max || Infinity;
      zoom = Math.max(Math.min(previousZoom * zoom, zoomMax), zoomMin) / previousZoom;
    }
    view.scaleX *= zoom;
    view.scaleY *= zoom;
    var fixX = (payload.originX - view.x) * (zoom - 1);
    var fixY = (payload.originY - view.y) * (zoom - 1);
    view.x -= fixX;
    view.y -= fixY;
    view.updateTransform();
    view.setCenter(getCenterCoord(view, point));
    view.setZoom(zoom * previousZoom);
  }
  return {
    center: view.getCenter(),
    zoom: view.getZoom()
  };
}
var GeoView = function(_super) {
  __extends(GeoView2, _super);
  function GeoView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoView2.type;
    _this.focusBlurEnabled = true;
    return _this;
  }
  GeoView2.prototype.init = function(ecModel, api) {
    this._api = api;
  };
  GeoView2.prototype.render = function(geoModel, ecModel, api, payload) {
    this._model = geoModel;
    if (!geoModel.get("show")) {
      this._mapDraw && this._mapDraw.remove();
      this._mapDraw = null;
      return;
    }
    if (!this._mapDraw) {
      this._mapDraw = new MapDraw$1(api);
    }
    var mapDraw = this._mapDraw;
    mapDraw.draw(geoModel, ecModel, api, this, payload);
    mapDraw.group.on("click", this._handleRegionClick, this);
    mapDraw.group.silent = geoModel.get("silent");
    this.group.add(mapDraw.group);
    this.updateSelectStatus(geoModel, ecModel, api);
  };
  GeoView2.prototype._handleRegionClick = function(e2) {
    var eventData;
    findEventDispatcher(e2.target, function(current) {
      return (eventData = getECData(current).eventData) != null;
    }, true);
    if (eventData) {
      this._api.dispatchAction({
        type: "geoToggleSelect",
        geoId: this._model.id,
        name: eventData.name
      });
    }
  };
  GeoView2.prototype.updateSelectStatus = function(model, ecModel, api) {
    var _this = this;
    this._mapDraw.group.traverse(function(node) {
      var eventData = getECData(node).eventData;
      if (eventData) {
        _this._model.isSelected(eventData.name) ? api.enterSelect(node) : api.leaveSelect(node);
        return true;
      }
    });
  };
  GeoView2.prototype.findHighDownDispatchers = function(name) {
    return this._mapDraw && this._mapDraw.findHighDownDispatchers(name, this._model);
  };
  GeoView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
  };
  GeoView2.type = "geo";
  return GeoView2;
}(ComponentView$1);
var GeoView$1 = GeoView;
function registerMap(mapName, geoJson, specialAreas) {
  geoSourceManager.registerMap(mapName, geoJson, specialAreas);
}
function install$J(registers) {
  registers.registerCoordinateSystem("geo", geoCreator$1);
  registers.registerComponentModel(GeoModel$1);
  registers.registerComponentView(GeoView$1);
  registers.registerImpl("registerMap", registerMap);
  registers.registerImpl("getMap", function(mapName) {
    return geoSourceManager.getMapForUser(mapName);
  });
  function makeAction(method4, actionInfo2) {
    actionInfo2.update = "geo:updateSelectStatus";
    registers.registerAction(actionInfo2, function(payload, ecModel) {
      var selected = {};
      var allSelected = [];
      ecModel.eachComponent({
        mainType: "geo",
        query: payload
      }, function(geoModel) {
        geoModel[method4](payload.name);
        var geo = geoModel.coordinateSystem;
        each$f(geo.regions, function(region) {
          selected[region.name] = geoModel.isSelected(region.name) || false;
        });
        var names2 = [];
        each$f(selected, function(v4, name) {
          selected[name] && names2.push(name);
        });
        allSelected.push({
          geoIndex: geoModel.componentIndex,
          name: names2
        });
      });
      return {
        selected,
        allSelected,
        name: payload.name
      };
    });
  }
  makeAction("toggleSelected", {
    type: "geoToggleSelect",
    event: "geoselectchanged"
  });
  makeAction("select", {
    type: "geoSelect",
    event: "geoselected"
  });
  makeAction("unSelect", {
    type: "geoUnSelect",
    event: "geounselected"
  });
  registers.registerAction({
    type: "geoRoam",
    event: "geoRoam",
    update: "updateTransform"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      var geo = componentModel.coordinateSystem;
      if (geo.type !== "geo") {
        return;
      }
      var res = updateCenterAndZoom(geo, payload, componentModel.get("scaleLimit"));
      componentModel.setCenter && componentModel.setCenter(res.center);
      componentModel.setZoom && componentModel.setZoom(res.zoom);
      if (componentType === "series") {
        each$f(componentModel.seriesGroup, function(seriesModel) {
          seriesModel.setCenter(res.center);
          seriesModel.setZoom(res.zoom);
        });
      }
    });
  });
}
function install$I(registers) {
  use(install$J);
  registers.registerChartView(MapView$1);
  registers.registerSeriesModel(MapSeries$1);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
function init(inRoot) {
  var root2 = inRoot;
  root2.hierNode = {
    defaultAncestor: null,
    ancestor: root2,
    prelim: 0,
    modifier: 0,
    change: 0,
    shift: 0,
    i: 0,
    thread: null
  };
  var nodes = [root2];
  var node;
  var children;
  while (node = nodes.pop()) {
    children = node.children;
    if (node.isExpand && children.length) {
      var n2 = children.length;
      for (var i = n2 - 1; i >= 0; i--) {
        var child = children[i];
        child.hierNode = {
          defaultAncestor: null,
          ancestor: child,
          prelim: 0,
          modifier: 0,
          change: 0,
          shift: 0,
          i,
          thread: null
        };
        nodes.push(child);
      }
    }
  }
}
function firstWalk(node, separation2) {
  var children = node.isExpand ? node.children : [];
  var siblings = node.parentNode.children;
  var subtreeW = node.hierNode.i ? siblings[node.hierNode.i - 1] : null;
  if (children.length) {
    executeShifts(node);
    var midPoint = (children[0].hierNode.prelim + children[children.length - 1].hierNode.prelim) / 2;
    if (subtreeW) {
      node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
      node.hierNode.modifier = node.hierNode.prelim - midPoint;
    } else {
      node.hierNode.prelim = midPoint;
    }
  } else if (subtreeW) {
    node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
  }
  node.parentNode.hierNode.defaultAncestor = apportion(node, subtreeW, node.parentNode.hierNode.defaultAncestor || siblings[0], separation2);
}
function secondWalk(node) {
  var nodeX = node.hierNode.prelim + node.parentNode.hierNode.modifier;
  node.setLayout({
    x: nodeX
  }, true);
  node.hierNode.modifier += node.parentNode.hierNode.modifier;
}
function separation(cb) {
  return arguments.length ? cb : defaultSeparation;
}
function radialCoordinate(rad, r2) {
  rad -= Math.PI / 2;
  return {
    x: r2 * Math.cos(rad),
    y: r2 * Math.sin(rad)
  };
}
function getViewRect$4(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function executeShifts(node) {
  var children = node.children;
  var n2 = children.length;
  var shift = 0;
  var change = 0;
  while (--n2 >= 0) {
    var child = children[n2];
    child.hierNode.prelim += shift;
    child.hierNode.modifier += shift;
    change += child.hierNode.change;
    shift += child.hierNode.shift + change;
  }
}
function apportion(subtreeV, subtreeW, ancestor, separation2) {
  if (subtreeW) {
    var nodeOutRight = subtreeV;
    var nodeInRight = subtreeV;
    var nodeOutLeft = nodeInRight.parentNode.children[0];
    var nodeInLeft = subtreeW;
    var sumOutRight = nodeOutRight.hierNode.modifier;
    var sumInRight = nodeInRight.hierNode.modifier;
    var sumOutLeft = nodeOutLeft.hierNode.modifier;
    var sumInLeft = nodeInLeft.hierNode.modifier;
    while (nodeInLeft = nextRight(nodeInLeft), nodeInRight = nextLeft(nodeInRight), nodeInLeft && nodeInRight) {
      nodeOutRight = nextRight(nodeOutRight);
      nodeOutLeft = nextLeft(nodeOutLeft);
      nodeOutRight.hierNode.ancestor = subtreeV;
      var shift = nodeInLeft.hierNode.prelim + sumInLeft - nodeInRight.hierNode.prelim - sumInRight + separation2(nodeInLeft, nodeInRight);
      if (shift > 0) {
        moveSubtree(nextAncestor(nodeInLeft, subtreeV, ancestor), subtreeV, shift);
        sumInRight += shift;
        sumOutRight += shift;
      }
      sumInLeft += nodeInLeft.hierNode.modifier;
      sumInRight += nodeInRight.hierNode.modifier;
      sumOutRight += nodeOutRight.hierNode.modifier;
      sumOutLeft += nodeOutLeft.hierNode.modifier;
    }
    if (nodeInLeft && !nextRight(nodeOutRight)) {
      nodeOutRight.hierNode.thread = nodeInLeft;
      nodeOutRight.hierNode.modifier += sumInLeft - sumOutRight;
    }
    if (nodeInRight && !nextLeft(nodeOutLeft)) {
      nodeOutLeft.hierNode.thread = nodeInRight;
      nodeOutLeft.hierNode.modifier += sumInRight - sumOutLeft;
      ancestor = subtreeV;
    }
  }
  return ancestor;
}
function nextRight(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[children.length - 1] : node.hierNode.thread;
}
function nextLeft(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[0] : node.hierNode.thread;
}
function nextAncestor(nodeInLeft, node, ancestor) {
  return nodeInLeft.hierNode.ancestor.parentNode === node.parentNode ? nodeInLeft.hierNode.ancestor : ancestor;
}
function moveSubtree(wl, wr, shift) {
  var change = shift / (wr.hierNode.i - wl.hierNode.i);
  wr.hierNode.change -= change;
  wr.hierNode.shift += shift;
  wr.hierNode.modifier += shift;
  wr.hierNode.prelim += shift;
  wl.hierNode.change += change;
}
function defaultSeparation(node1, node2) {
  return node1.parentNode === node2.parentNode ? 1 : 2;
}
var TreeEdgeShape = function() {
  function TreeEdgeShape2() {
    this.parentPoint = [];
    this.childPoints = [];
  }
  return TreeEdgeShape2;
}();
var TreePath = function(_super) {
  __extends(TreePath2, _super);
  function TreePath2(opts) {
    return _super.call(this, opts) || this;
  }
  TreePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  TreePath2.prototype.getDefaultShape = function() {
    return new TreeEdgeShape();
  };
  TreePath2.prototype.buildPath = function(ctx, shape) {
    var childPoints = shape.childPoints;
    var childLen = childPoints.length;
    var parentPoint = shape.parentPoint;
    var firstChildPos = childPoints[0];
    var lastChildPos = childPoints[childLen - 1];
    if (childLen === 1) {
      ctx.moveTo(parentPoint[0], parentPoint[1]);
      ctx.lineTo(firstChildPos[0], firstChildPos[1]);
      return;
    }
    var orient = shape.orient;
    var forkDim = orient === "TB" || orient === "BT" ? 0 : 1;
    var otherDim = 1 - forkDim;
    var forkPosition = parsePercent(shape.forkPosition, 1);
    var tmpPoint = [];
    tmpPoint[forkDim] = parentPoint[forkDim];
    tmpPoint[otherDim] = parentPoint[otherDim] + (lastChildPos[otherDim] - parentPoint[otherDim]) * forkPosition;
    ctx.moveTo(parentPoint[0], parentPoint[1]);
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.moveTo(firstChildPos[0], firstChildPos[1]);
    tmpPoint[forkDim] = firstChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    tmpPoint[forkDim] = lastChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.lineTo(lastChildPos[0], lastChildPos[1]);
    for (var i = 1; i < childLen - 1; i++) {
      var point = childPoints[i];
      ctx.moveTo(point[0], point[1]);
      tmpPoint[forkDim] = point[forkDim];
      ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    }
  };
  return TreePath2;
}(Path$1);
var TreeView = function(_super) {
  __extends(TreeView2, _super);
  function TreeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreeView2.type;
    _this._mainGroup = new Group$4();
    return _this;
  }
  TreeView2.prototype.init = function(ecModel, api) {
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: this.group
    };
    this.group.add(this._mainGroup);
  };
  TreeView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var layoutInfo = seriesModel.layoutInfo;
    var group = this._mainGroup;
    var layout2 = seriesModel.get("layout");
    if (layout2 === "radial") {
      group.x = layoutInfo.x + layoutInfo.width / 2;
      group.y = layoutInfo.y + layoutInfo.height / 2;
    } else {
      group.x = layoutInfo.x;
      group.y = layoutInfo.y;
    }
    this._updateViewCoordSys(seriesModel);
    this._updateController(seriesModel, ecModel, api);
    var oldData = this._data;
    data.diff(oldData).add(function(newIdx) {
      if (symbolNeedsDraw(data, newIdx)) {
        updateNode(data, newIdx, null, group, seriesModel);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!symbolNeedsDraw(data, newIdx)) {
        symbolEl && removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
        return;
      }
      updateNode(data, newIdx, symbolEl, group, seriesModel);
    }).remove(function(oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (symbolEl) {
        removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
      }
    }).execute();
    this._nodeScaleRatio = seriesModel.get("nodeScaleRatio");
    this._updateNodeAndLinkScale(seriesModel);
    if (seriesModel.get("expandAndCollapse") === true) {
      data.eachItemGraphicEl(function(el, dataIndex) {
        el.off("click").on("click", function() {
          api.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: seriesModel.id,
            dataIndex
          });
        });
      });
    }
    this._data = data;
  };
  TreeView2.prototype._updateViewCoordSys = function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    data.each(function(idx) {
      var layout2 = data.getItemLayout(idx);
      if (layout2 && !isNaN(layout2.x) && !isNaN(layout2.y)) {
        points2.push([+layout2.x, +layout2.y]);
      }
    });
    var min3 = [];
    var max3 = [];
    fromPoints(points2, min3, max3);
    var oldMin = this._min;
    var oldMax = this._max;
    if (max3[0] - min3[0] === 0) {
      min3[0] = oldMin ? oldMin[0] : min3[0] - 1;
      max3[0] = oldMax ? oldMax[0] : max3[0] + 1;
    }
    if (max3[1] - min3[1] === 0) {
      min3[1] = oldMin ? oldMin[1] : min3[1] - 1;
      max3[1] = oldMax ? oldMax[1] : max3[1] + 1;
    }
    var viewCoordSys = seriesModel.coordinateSystem = new View$1();
    viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
    viewCoordSys.setBoundingRect(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    viewCoordSys.setCenter(seriesModel.get("center"));
    viewCoordSys.setZoom(seriesModel.get("zoom"));
    this.group.attr({
      x: viewCoordSys.x,
      y: viewCoordSys.y,
      scaleX: viewCoordSys.scaleX,
      scaleY: viewCoordSys.scaleY
    });
    this._min = min3;
    this._max = max3;
  };
  TreeView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale(seriesModel);
      api.updateLabelLayout();
    });
  };
  TreeView2.prototype._updateNodeAndLinkScale = function(seriesModel) {
    var data = seriesModel.getData();
    var nodeScale = this._getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el.setSymbolScale(nodeScale);
    });
  };
  TreeView2.prototype._getNodeGlobalScale = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type !== "view") {
      return 1;
    }
    var nodeScaleRatio = this._nodeScaleRatio;
    var groupZoom = coordSys.scaleX || 1;
    var roamZoom = coordSys.getZoom();
    var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
    return nodeScale / groupZoom;
  };
  TreeView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  TreeView2.prototype.remove = function() {
    this._mainGroup.removeAll();
    this._data = null;
  };
  TreeView2.type = "tree";
  return TreeView2;
}(ChartView$1);
function symbolNeedsDraw(data, dataIndex) {
  var layout2 = data.getItemLayout(dataIndex);
  return layout2 && !isNaN(layout2.x) && !isNaN(layout2.y);
}
function updateNode(data, dataIndex, symbolEl, group, seriesModel) {
  var isInit = !symbolEl;
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var itemModel = node.getModel();
  var visualColor = node.getVisual("style").fill;
  var symbolInnerColor = node.isExpand === false && node.children.length !== 0 ? visualColor : "#fff";
  var virtualRoot = data.tree.root;
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceLayout = source.getLayout();
  var sourceOldLayout = sourceSymbolEl ? {
    x: sourceSymbolEl.__oldX,
    y: sourceSymbolEl.__oldY,
    rawX: sourceSymbolEl.__radialOldRawX,
    rawY: sourceSymbolEl.__radialOldRawY
  } : sourceLayout;
  var targetLayout = node.getLayout();
  if (isInit) {
    symbolEl = new SymbolClz(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
    symbolEl.x = sourceOldLayout.x;
    symbolEl.y = sourceOldLayout.y;
  } else {
    symbolEl.updateData(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
  }
  symbolEl.__radialOldRawX = symbolEl.__radialRawX;
  symbolEl.__radialOldRawY = symbolEl.__radialRawY;
  symbolEl.__radialRawX = targetLayout.rawX;
  symbolEl.__radialRawY = targetLayout.rawY;
  group.add(symbolEl);
  data.setItemGraphicEl(dataIndex, symbolEl);
  symbolEl.__oldX = symbolEl.x;
  symbolEl.__oldY = symbolEl.y;
  updateProps$1(symbolEl, {
    x: targetLayout.x,
    y: targetLayout.y
  }, seriesModel);
  var symbolPath = symbolEl.getSymbolPath();
  if (seriesModel.get("layout") === "radial") {
    var realRoot = virtualRoot.children[0];
    var rootLayout = realRoot.getLayout();
    var length_1 = realRoot.children.length;
    var rad = void 0;
    var isLeft = void 0;
    if (targetLayout.x === rootLayout.x && node.isExpand === true) {
      var center2 = {
        x: (realRoot.children[0].getLayout().x + realRoot.children[length_1 - 1].getLayout().x) / 2,
        y: (realRoot.children[0].getLayout().y + realRoot.children[length_1 - 1].getLayout().y) / 2
      };
      rad = Math.atan2(center2.y - rootLayout.y, center2.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      isLeft = center2.x < rootLayout.x;
      if (isLeft) {
        rad = rad - Math.PI;
      }
    } else {
      rad = Math.atan2(targetLayout.y - rootLayout.y, targetLayout.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      if (node.children.length === 0 || node.children.length !== 0 && node.isExpand === false) {
        isLeft = targetLayout.x < rootLayout.x;
        if (isLeft) {
          rad = rad - Math.PI;
        }
      } else {
        isLeft = targetLayout.x > rootLayout.x;
        if (!isLeft) {
          rad = rad - Math.PI;
        }
      }
    }
    var textPosition = isLeft ? "left" : "right";
    var normalLabelModel = itemModel.getModel("label");
    var rotate2 = normalLabelModel.get("rotate");
    var labelRotateRadian = rotate2 * (Math.PI / 180);
    var textContent = symbolPath.getTextContent();
    if (textContent) {
      symbolPath.setTextConfig({
        position: normalLabelModel.get("position") || textPosition,
        rotation: rotate2 == null ? -rad : labelRotateRadian,
        origin: "center"
      });
      textContent.setStyle("verticalAlign", "middle");
    }
  }
  var focus = itemModel.get(["emphasis", "focus"]);
  var focusDataIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : null;
  if (focusDataIndices) {
    getECData(symbolEl).focus = focusDataIndices;
  }
  drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group);
  if (symbolEl.__edge) {
    symbolEl.onHoverStateChange = function(toState) {
      if (toState !== "blur") {
        var parentEl = node.parentNode && data.getItemGraphicEl(node.parentNode.dataIndex);
        if (!(parentEl && parentEl.hoverState === HOVER_STATE_BLUR)) {
          setStatesFlag(symbolEl.__edge, toState);
        }
      }
    };
  }
}
function drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group) {
  var itemModel = node.getModel();
  var edgeShape = seriesModel.get("edgeShape");
  var layout2 = seriesModel.get("layout");
  var orient = seriesModel.getOrient();
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  var edgeForkPosition = seriesModel.get("edgeForkPosition");
  var lineStyle = itemModel.getModel("lineStyle").getLineStyle();
  var edge = symbolEl.__edge;
  if (edgeShape === "curve") {
    if (node.parentNode && node.parentNode !== virtualRoot) {
      if (!edge) {
        edge = symbolEl.__edge = new BezierCurve$1({
          shape: getEdgeShape(layout2, orient, curvature, sourceOldLayout, sourceOldLayout)
        });
      }
      updateProps$1(edge, {
        shape: getEdgeShape(layout2, orient, curvature, sourceLayout, targetLayout)
      }, seriesModel);
    }
  } else if (edgeShape === "polyline") {
    if (layout2 === "orthogonal") {
      if (node !== virtualRoot && node.children && node.children.length !== 0 && node.isExpand === true) {
        var children = node.children;
        var childPoints = [];
        for (var i = 0; i < children.length; i++) {
          var childLayout = children[i].getLayout();
          childPoints.push([childLayout.x, childLayout.y]);
        }
        if (!edge) {
          edge = symbolEl.__edge = new TreePath({
            shape: {
              parentPoint: [targetLayout.x, targetLayout.y],
              childPoints: [[targetLayout.x, targetLayout.y]],
              orient,
              forkPosition: edgeForkPosition
            }
          });
        }
        updateProps$1(edge, {
          shape: {
            parentPoint: [targetLayout.x, targetLayout.y],
            childPoints
          }
        }, seriesModel);
      }
    }
  }
  if (edge) {
    edge.useStyle(defaults({
      strokeNoScale: true,
      fill: null
    }, lineStyle));
    setStatesStylesFromModel(edge, itemModel, "lineStyle");
    setDefaultStateProxy(edge);
    group.add(edge);
  }
}
function removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt) {
  var virtualRoot = data.tree.root;
  var _a2 = getSourceNode(virtualRoot, node), source = _a2.source, sourceLayout = _a2.sourceLayout;
  var symbolEl = data.getItemGraphicEl(node.dataIndex);
  if (!symbolEl) {
    return;
  }
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceEdge = sourceSymbolEl.__edge;
  var edge = symbolEl.__edge || (source.isExpand === false || source.children.length === 1 ? sourceEdge : void 0);
  var edgeShape = seriesModel.get("edgeShape");
  var layoutOpt = seriesModel.get("layout");
  var orient = seriesModel.get("orient");
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  if (edge) {
    if (edgeShape === "curve") {
      removeElement(edge, {
        shape: getEdgeShape(layoutOpt, orient, curvature, sourceLayout, sourceLayout),
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    } else if (edgeShape === "polyline" && seriesModel.get("layout") === "orthogonal") {
      removeElement(edge, {
        shape: {
          parentPoint: [sourceLayout.x, sourceLayout.y],
          childPoints: [[sourceLayout.x, sourceLayout.y]]
        },
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    }
  }
}
function getSourceNode(virtualRoot, node) {
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceLayout;
  while (sourceLayout = source.getLayout(), sourceLayout == null) {
    source = source.parentNode === virtualRoot ? source : source.parentNode || source;
  }
  return {
    source,
    sourceLayout
  };
}
function removeNode(data, dataIndex, symbolEl, group, seriesModel) {
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var virtualRoot = data.tree.root;
  var sourceLayout = getSourceNode(virtualRoot, node).sourceLayout;
  var removeAnimationOpt = {
    duration: seriesModel.get("animationDurationUpdate"),
    easing: seriesModel.get("animationEasingUpdate")
  };
  removeElement(symbolEl, {
    x: sourceLayout.x + 1,
    y: sourceLayout.y + 1
  }, seriesModel, {
    cb: function() {
      group.remove(symbolEl);
      data.setItemGraphicEl(dataIndex, null);
    },
    removeOpt: removeAnimationOpt
  });
  symbolEl.fadeOut(null, data.hostModel, {
    fadeLabel: true,
    animation: removeAnimationOpt
  });
  node.children.forEach(function(childNode) {
    removeNodeEdge(childNode, data, group, seriesModel, removeAnimationOpt);
  });
  removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt);
}
function getEdgeShape(layoutOpt, orient, curvature, sourceLayout, targetLayout) {
  var cpx1;
  var cpy1;
  var cpx2;
  var cpy2;
  var x1;
  var x2;
  var y1;
  var y2;
  if (layoutOpt === "radial") {
    x1 = sourceLayout.rawX;
    y1 = sourceLayout.rawY;
    x2 = targetLayout.rawX;
    y2 = targetLayout.rawY;
    var radialCoor1 = radialCoordinate(x1, y1);
    var radialCoor2 = radialCoordinate(x1, y1 + (y2 - y1) * curvature);
    var radialCoor3 = radialCoordinate(x2, y2 + (y1 - y2) * curvature);
    var radialCoor4 = radialCoordinate(x2, y2);
    return {
      x1: radialCoor1.x || 0,
      y1: radialCoor1.y || 0,
      x2: radialCoor4.x || 0,
      y2: radialCoor4.y || 0,
      cpx1: radialCoor2.x || 0,
      cpy1: radialCoor2.y || 0,
      cpx2: radialCoor3.x || 0,
      cpy2: radialCoor3.y || 0
    };
  } else {
    x1 = sourceLayout.x;
    y1 = sourceLayout.y;
    x2 = targetLayout.x;
    y2 = targetLayout.y;
    if (orient === "LR" || orient === "RL") {
      cpx1 = x1 + (x2 - x1) * curvature;
      cpy1 = y1;
      cpx2 = x2 + (x1 - x2) * curvature;
      cpy2 = y2;
    }
    if (orient === "TB" || orient === "BT") {
      cpx1 = x1;
      cpy1 = y1 + (y2 - y1) * curvature;
      cpx2 = x2;
      cpy2 = y2 + (y1 - y2) * curvature;
    }
  }
  return {
    x1,
    y1,
    x2,
    y2,
    cpx1,
    cpy1,
    cpx2,
    cpy2
  };
}
var TreeView$1 = TreeView;
var inner$e = makeInner();
function linkSeriesData(opt) {
  var mainData = opt.mainData;
  var datas = opt.datas;
  if (!datas) {
    datas = {
      main: mainData
    };
    opt.datasAttr = {
      main: "data"
    };
  }
  opt.datas = opt.mainData = null;
  linkAll(mainData, datas, opt);
  each$f(datas, function(data) {
    each$f(mainData.TRANSFERABLE_METHODS, function(methodName) {
      data.wrapMethod(methodName, curry$1(transferInjection, opt));
    });
  });
  mainData.wrapMethod("cloneShallow", curry$1(cloneShallowInjection, opt));
  each$f(mainData.CHANGABLE_METHODS, function(methodName) {
    mainData.wrapMethod(methodName, curry$1(changeInjection, opt));
  });
  assert(datas[mainData.dataType] === mainData);
}
function transferInjection(opt, res) {
  if (isMainData(this)) {
    var datas = extend({}, inner$e(this).datas);
    datas[this.dataType] = res;
    linkAll(res, datas, opt);
  } else {
    linkSingle(res, this.dataType, inner$e(this).mainData, opt);
  }
  return res;
}
function changeInjection(opt, res) {
  opt.struct && opt.struct.update();
  return res;
}
function cloneShallowInjection(opt, res) {
  each$f(inner$e(res).datas, function(data, dataType) {
    data !== res && linkSingle(data.cloneShallow(), dataType, res, opt);
  });
  return res;
}
function getLinkedData(dataType) {
  var mainData = inner$e(this).mainData;
  return dataType == null || mainData == null ? mainData : inner$e(mainData).datas[dataType];
}
function getLinkedDataAll() {
  var mainData = inner$e(this).mainData;
  return mainData == null ? [{
    data: mainData
  }] : map$1(keys(inner$e(mainData).datas), function(type4) {
    return {
      type: type4,
      data: inner$e(mainData).datas[type4]
    };
  });
}
function isMainData(data) {
  return inner$e(data).mainData === data;
}
function linkAll(mainData, datas, opt) {
  inner$e(mainData).datas = {};
  each$f(datas, function(data, dataType) {
    linkSingle(data, dataType, mainData, opt);
  });
}
function linkSingle(data, dataType, mainData, opt) {
  inner$e(mainData).datas[dataType] = data;
  inner$e(data).mainData = mainData;
  data.dataType = dataType;
  if (opt.struct) {
    data[opt.structAttr] = opt.struct;
    opt.struct[opt.datasAttr[dataType]] = data;
  }
  data.getLinkedData = getLinkedData;
  data.getLinkedDataAll = getLinkedDataAll;
}
var TreeNode = function() {
  function TreeNode2(name, hostTree) {
    this.depth = 0;
    this.height = 0;
    this.dataIndex = -1;
    this.children = [];
    this.viewChildren = [];
    this.isExpand = false;
    this.name = name || "";
    this.hostTree = hostTree;
  }
  TreeNode2.prototype.isRemoved = function() {
    return this.dataIndex < 0;
  };
  TreeNode2.prototype.eachNode = function(options, cb, context) {
    if (isFunction(options)) {
      context = cb;
      cb = options;
      options = null;
    }
    options = options || {};
    if (isString(options)) {
      options = {
        order: options
      };
    }
    var order = options.order || "preorder";
    var children = this[options.attr || "children"];
    var suppressVisitSub;
    order === "preorder" && (suppressVisitSub = cb.call(context, this));
    for (var i = 0; !suppressVisitSub && i < children.length; i++) {
      children[i].eachNode(options, cb, context);
    }
    order === "postorder" && cb.call(context, this);
  };
  TreeNode2.prototype.updateDepthAndHeight = function(depth) {
    var height = 0;
    this.depth = depth;
    for (var i = 0; i < this.children.length; i++) {
      var child = this.children[i];
      child.updateDepthAndHeight(depth + 1);
      if (child.height > height) {
        height = child.height;
      }
    }
    this.height = height + 1;
  };
  TreeNode2.prototype.getNodeById = function(id2) {
    if (this.getId() === id2) {
      return this;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].getNodeById(id2);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.contains = function(node) {
    if (node === this) {
      return true;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].contains(node);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.getAncestors = function(includeSelf) {
    var ancestors = [];
    var node = includeSelf ? this : this.parentNode;
    while (node) {
      ancestors.push(node);
      node = node.parentNode;
    }
    ancestors.reverse();
    return ancestors;
  };
  TreeNode2.prototype.getAncestorsIndices = function() {
    var indices = [];
    var currNode = this;
    while (currNode) {
      indices.push(currNode.dataIndex);
      currNode = currNode.parentNode;
    }
    indices.reverse();
    return indices;
  };
  TreeNode2.prototype.getDescendantIndices = function() {
    var indices = [];
    this.eachNode(function(childNode) {
      indices.push(childNode.dataIndex);
    });
    return indices;
  };
  TreeNode2.prototype.getValue = function(dimension) {
    var data = this.hostTree.data;
    return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
  };
  TreeNode2.prototype.setLayout = function(layout2, merge2) {
    this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, layout2, merge2);
  };
  TreeNode2.prototype.getLayout = function() {
    return this.hostTree.data.getItemLayout(this.dataIndex);
  };
  TreeNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var hostTree = this.hostTree;
    var itemModel = hostTree.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  TreeNode2.prototype.getLevelModel = function() {
    return (this.hostTree.levelModels || [])[this.depth];
  };
  TreeNode2.prototype.setVisual = function(key, value) {
    this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, key, value);
  };
  TreeNode2.prototype.getVisual = function(key) {
    return this.hostTree.data.getItemVisual(this.dataIndex, key);
  };
  TreeNode2.prototype.getRawIndex = function() {
    return this.hostTree.data.getRawIndex(this.dataIndex);
  };
  TreeNode2.prototype.getId = function() {
    return this.hostTree.data.getId(this.dataIndex);
  };
  TreeNode2.prototype.getChildIndex = function() {
    if (this.parentNode) {
      var children = this.parentNode.children;
      for (var i = 0; i < children.length; ++i) {
        if (children[i] === this) {
          return i;
        }
      }
      return -1;
    }
    return -1;
  };
  TreeNode2.prototype.isAncestorOf = function(node) {
    var parent = node.parentNode;
    while (parent) {
      if (parent === this) {
        return true;
      }
      parent = parent.parentNode;
    }
    return false;
  };
  TreeNode2.prototype.isDescendantOf = function(node) {
    return node !== this && node.isAncestorOf(this);
  };
  return TreeNode2;
}();
var Tree = function() {
  function Tree2(hostModel) {
    this.type = "tree";
    this._nodes = [];
    this.hostModel = hostModel;
  }
  Tree2.prototype.eachNode = function(options, cb, context) {
    this.root.eachNode(options, cb, context);
  };
  Tree2.prototype.getNodeByDataIndex = function(dataIndex) {
    var rawIndex = this.data.getRawIndex(dataIndex);
    return this._nodes[rawIndex];
  };
  Tree2.prototype.getNodeById = function(name) {
    return this.root.getNodeById(name);
  };
  Tree2.prototype.update = function() {
    var data = this.data;
    var nodes = this._nodes;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
  };
  Tree2.prototype.clearLayouts = function() {
    this.data.clearItemLayouts();
  };
  Tree2.createTree = function(dataRoot, hostModel, beforeLink) {
    var tree = new Tree2(hostModel);
    var listData = [];
    var dimMax = 1;
    buildHierarchy(dataRoot);
    function buildHierarchy(dataNode, parentNode2) {
      var value = dataNode.value;
      dimMax = Math.max(dimMax, isArray$1(value) ? value.length : 1);
      listData.push(dataNode);
      var node = new TreeNode(convertOptionIdName(dataNode.name, ""), tree);
      parentNode2 ? addChild(node, parentNode2) : tree.root = node;
      tree._nodes.push(node);
      var children = dataNode.children;
      if (children) {
        for (var i = 0; i < children.length; i++) {
          buildHierarchy(children[i], node);
        }
      }
    }
    tree.root.updateDepthAndHeight(0);
    var dimensions = prepareSeriesDataSchema(listData, {
      coordDimensions: ["value"],
      dimensionsCount: dimMax
    }).dimensions;
    var list = new SeriesData$1(dimensions, hostModel);
    list.initData(listData);
    beforeLink && beforeLink(list);
    linkSeriesData({
      mainData: list,
      struct: tree,
      structAttr: "tree"
    });
    tree.update();
    return tree;
  };
  return Tree2;
}();
function addChild(child, node) {
  var children = node.children;
  if (child.parentNode === node) {
    return;
  }
  children.push(child);
  child.parentNode = node;
}
var Tree$1 = Tree;
function retrieveTargetInfo(payload, validPayloadTypes, seriesModel) {
  if (payload && indexOf(validPayloadTypes, payload.type) >= 0) {
    var root2 = seriesModel.getData().tree.root;
    var targetNode = payload.targetNode;
    if (isString(targetNode)) {
      targetNode = root2.getNodeById(targetNode);
    }
    if (targetNode && root2.contains(targetNode)) {
      return {
        node: targetNode
      };
    }
    var targetNodeId = payload.targetNodeId;
    if (targetNodeId != null && (targetNode = root2.getNodeById(targetNodeId))) {
      return {
        node: targetNode
      };
    }
  }
}
function getPathToRoot(node) {
  var path = [];
  while (node) {
    node = node.parentNode;
    node && path.push(node);
  }
  return path.reverse();
}
function aboveViewRoot(viewRoot, node) {
  var viewPath = getPathToRoot(viewRoot);
  return indexOf(viewPath, node) >= 0;
}
function wrapTreePathInfo(node, seriesModel) {
  var treePathInfo = [];
  while (node) {
    var nodeDataIndex = node.dataIndex;
    treePathInfo.push({
      name: node.name,
      dataIndex: nodeDataIndex,
      value: seriesModel.getRawValue(nodeDataIndex)
    });
    node = node.parentNode;
  }
  treePathInfo.reverse();
  return treePathInfo;
}
var TreeSeriesModel = function(_super) {
  __extends(TreeSeriesModel2, _super);
  function TreeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.hasSymbolVisual = true;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  TreeSeriesModel2.prototype.getInitialData = function(option) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    var leaves = option.leaves || {};
    var leavesModel = new Model$1(leaves, this, this.ecModel);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        if (!(node && node.children.length && node.isExpand)) {
          model.parentModel = leavesModel;
        }
        return model;
      });
    }
    var treeDepth = 0;
    tree.eachNode("preorder", function(node) {
      if (node.depth > treeDepth) {
        treeDepth = node.depth;
      }
    });
    var expandAndCollapse = option.expandAndCollapse;
    var expandTreeDepth = expandAndCollapse && option.initialTreeDepth >= 0 ? option.initialTreeDepth : treeDepth;
    tree.root.eachNode("preorder", function(node) {
      var item = node.hostTree.data.getRawDataItem(node.dataIndex);
      node.isExpand = item && item.collapsed != null ? !item.collapsed : node.depth <= expandTreeDepth;
    });
    return tree.data;
  };
  TreeSeriesModel2.prototype.getOrient = function() {
    var orient = this.get("orient");
    if (orient === "horizontal") {
      orient = "LR";
    } else if (orient === "vertical") {
      orient = "TB";
    }
    return orient;
  };
  TreeSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  TreeSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  TreeSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var tree = this.getData().tree;
    var realRoot = tree.root.children[0];
    var node = tree.getNodeByDataIndex(dataIndex);
    var value = node.getValue();
    var name = node.name;
    while (node && node !== realRoot) {
      name = node.parentNode.name + "." + name;
      node = node.parentNode;
    }
    return createTooltipMarkup("nameValue", {
      name,
      value,
      noValue: isNaN(value) || value == null
    });
  };
  TreeSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    return params;
  };
  TreeSeriesModel2.type = "series.tree";
  TreeSeriesModel2.layoutMode = "box";
  TreeSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "12%",
    top: "12%",
    right: "12%",
    bottom: "12%",
    layout: "orthogonal",
    edgeShape: "curve",
    edgeForkPosition: "50%",
    roam: false,
    nodeScaleRatio: 0.4,
    center: null,
    zoom: 1,
    orient: "LR",
    symbol: "emptyCircle",
    symbolSize: 7,
    expandAndCollapse: true,
    initialTreeDepth: 2,
    lineStyle: {
      color: "#ccc",
      width: 1.5,
      curveness: 0.5
    },
    itemStyle: {
      color: "lightsteelblue",
      borderWidth: 1.5
    },
    label: {
      show: true
    },
    animationEasing: "linear",
    animationDuration: 700,
    animationDurationUpdate: 500
  };
  return TreeSeriesModel2;
}(SeriesModel$1);
var TreeSeriesModel$1 = TreeSeriesModel;
function eachAfter(root2, callback, separation2) {
  var nodes = [root2];
  var next = [];
  var node;
  while (node = nodes.pop()) {
    next.push(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = 0; i < children.length; i++) {
          nodes.push(children[i]);
        }
      }
    }
  }
  while (node = next.pop()) {
    callback(node, separation2);
  }
}
function eachBefore(root2, callback) {
  var nodes = [root2];
  var node;
  while (node = nodes.pop()) {
    callback(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = children.length - 1; i >= 0; i--) {
          nodes.push(children[i]);
        }
      }
    }
  }
}
function treeLayout(ecModel, api) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    commonLayout(seriesModel, api);
  });
}
function commonLayout(seriesModel, api) {
  var layoutInfo = getViewRect$4(seriesModel, api);
  seriesModel.layoutInfo = layoutInfo;
  var layout2 = seriesModel.get("layout");
  var width = 0;
  var height = 0;
  var separation$1 = null;
  if (layout2 === "radial") {
    width = 2 * Math.PI;
    height = Math.min(layoutInfo.height, layoutInfo.width) / 2;
    separation$1 = separation(function(node1, node2) {
      return (node1.parentNode === node2.parentNode ? 1 : 2) / node1.depth;
    });
  } else {
    width = layoutInfo.width;
    height = layoutInfo.height;
    separation$1 = separation();
  }
  var virtualRoot = seriesModel.getData().tree.root;
  var realRoot = virtualRoot.children[0];
  if (realRoot) {
    init(virtualRoot);
    eachAfter(realRoot, firstWalk, separation$1);
    virtualRoot.hierNode.modifier = -realRoot.hierNode.prelim;
    eachBefore(realRoot, secondWalk);
    var left_1 = realRoot;
    var right_1 = realRoot;
    var bottom_1 = realRoot;
    eachBefore(realRoot, function(node) {
      var x2 = node.getLayout().x;
      if (x2 < left_1.getLayout().x) {
        left_1 = node;
      }
      if (x2 > right_1.getLayout().x) {
        right_1 = node;
      }
      if (node.depth > bottom_1.depth) {
        bottom_1 = node;
      }
    });
    var delta = left_1 === right_1 ? 1 : separation$1(left_1, right_1) / 2;
    var tx_1 = delta - left_1.getLayout().x;
    var kx_1 = 0;
    var ky_1 = 0;
    var coorX_1 = 0;
    var coorY_1 = 0;
    if (layout2 === "radial") {
      kx_1 = width / (right_1.getLayout().x + delta + tx_1);
      ky_1 = height / (bottom_1.depth - 1 || 1);
      eachBefore(realRoot, function(node) {
        coorX_1 = (node.getLayout().x + tx_1) * kx_1;
        coorY_1 = (node.depth - 1) * ky_1;
        var finalCoor = radialCoordinate(coorX_1, coorY_1);
        node.setLayout({
          x: finalCoor.x,
          y: finalCoor.y,
          rawX: coorX_1,
          rawY: coorY_1
        }, true);
      });
    } else {
      var orient_1 = seriesModel.getOrient();
      if (orient_1 === "RL" || orient_1 === "LR") {
        ky_1 = height / (right_1.getLayout().x + delta + tx_1);
        kx_1 = width / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorY_1 = (node.getLayout().x + tx_1) * ky_1;
          coorX_1 = orient_1 === "LR" ? (node.depth - 1) * kx_1 : width - (node.depth - 1) * kx_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      } else if (orient_1 === "TB" || orient_1 === "BT") {
        kx_1 = width / (right_1.getLayout().x + delta + tx_1);
        ky_1 = height / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorX_1 = (node.getLayout().x + tx_1) * kx_1;
          coorY_1 = orient_1 === "TB" ? (node.depth - 1) * ky_1 : height - (node.depth - 1) * ky_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      }
    }
  }
}
function treeVisual(ecModel) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function installTreeAction(registers) {
  registers.registerAction({
    type: "treeExpandAndCollapse",
    event: "treeExpandAndCollapse",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var dataIndex = payload.dataIndex;
      var tree = seriesModel.getData().tree;
      var node = tree.getNodeByDataIndex(dataIndex);
      node.isExpand = !node.isExpand;
    });
  });
  registers.registerAction({
    type: "treeRoam",
    event: "treeRoam",
    update: "none"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
function install$H(registers) {
  registers.registerChartView(TreeView$1);
  registers.registerSeriesModel(TreeSeriesModel$1);
  registers.registerLayout(treeLayout);
  registers.registerVisual(treeVisual);
  installTreeAction(registers);
}
var actionTypes = ["treemapZoomToNode", "treemapRender", "treemapMove"];
function installTreemapAction(registers) {
  for (var i = 0; i < actionTypes.length; i++) {
    registers.registerAction({
      type: actionTypes[i],
      update: "updateView"
    }, noop);
  }
  registers.registerAction({
    type: "treemapRootToNode",
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "treemap",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var types2 = ["treemapZoomToNode", "treemapRootToNode"];
      var targetInfo = retrieveTargetInfo(payload, types2, model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
}
function enableAriaDecalForTree(seriesModel) {
  var data = seriesModel.getData();
  var tree = data.tree;
  var decalPaletteScope2 = {};
  tree.eachNode(function(node) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var decal = getDecalFromPalette(seriesModel.ecModel, current.name || current.dataIndex + "", decalPaletteScope2);
    node.setVisual("decal", decal);
  });
}
var TreemapSeriesModel = function(_super) {
  __extends(TreemapSeriesModel2, _super);
  function TreemapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapSeriesModel2.type;
    _this.preventUsingHoverLayer = true;
    return _this;
  }
  TreemapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue$1(root2);
    var levels = option.levels || [];
    var designatedVisualItemStyle = this.designatedVisualItemStyle = {};
    var designatedVisualModel = new Model$1({
      itemStyle: designatedVisualItemStyle
    }, this, ecModel);
    levels = option.levels = setDefault(levels, ecModel);
    var levelModels = map$1(levels || [], function(levelDefine) {
      return new Model$1(levelDefine, designatedVisualModel, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = node ? levelModels[node.depth] : null;
        model.parentModel = levelModel || designatedVisualModel;
        return model;
      });
    }
    return tree.data;
  };
  TreemapSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  TreemapSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  TreemapSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    params.treePathInfo = params.treeAncestors;
    return params;
  };
  TreemapSeriesModel2.prototype.setLayoutInfo = function(layoutInfo) {
    this.layoutInfo = this.layoutInfo || {};
    extend(this.layoutInfo, layoutInfo);
  };
  TreemapSeriesModel2.prototype.mapIdToIndex = function(id2) {
    var idIndexMap = this._idIndexMap;
    if (!idIndexMap) {
      idIndexMap = this._idIndexMap = createHashMap();
      this._idIndexMapCount = 0;
    }
    var index2 = idIndexMap.get(id2);
    if (index2 == null) {
      idIndexMap.set(id2, index2 = this._idIndexMapCount++);
    }
    return index2;
  };
  TreemapSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  TreemapSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  TreemapSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  TreemapSeriesModel2.type = "series.treemap";
  TreemapSeriesModel2.layoutMode = "box";
  TreemapSeriesModel2.defaultOption = {
    progressive: 0,
    left: "center",
    top: "middle",
    width: "80%",
    height: "80%",
    sort: true,
    clipWindow: "origin",
    squareRatio: 0.5 * (1 + Math.sqrt(5)),
    leafDepth: null,
    drillDownIcon: "\u25B6",
    zoomToNodeRatio: 0.32 * 0.32,
    roam: true,
    nodeClick: "zoomToNode",
    animation: true,
    animationDurationUpdate: 900,
    animationEasing: "quinticInOut",
    breadcrumb: {
      show: true,
      height: 22,
      left: "center",
      top: "bottom",
      emptyItemWidth: 25,
      itemStyle: {
        color: "rgba(0,0,0,0.7)",
        textStyle: {
          color: "#fff"
        }
      }
    },
    label: {
      show: true,
      distance: 0,
      padding: 5,
      position: "inside",
      color: "#fff",
      overflow: "truncate"
    },
    upperLabel: {
      show: false,
      position: [0, "50%"],
      height: 20,
      overflow: "truncate",
      verticalAlign: "middle"
    },
    itemStyle: {
      color: null,
      colorAlpha: null,
      colorSaturation: null,
      borderWidth: 0,
      gapWidth: 0,
      borderColor: "#fff",
      borderColorSaturation: null
    },
    emphasis: {
      upperLabel: {
        show: true,
        position: [0, "50%"],
        overflow: "truncate",
        verticalAlign: "middle"
      }
    },
    visualDimension: 0,
    visualMin: null,
    visualMax: null,
    color: [],
    colorAlpha: null,
    colorSaturation: null,
    colorMappingBy: "index",
    visibleMin: 10,
    childrenVisibleMin: null,
    levels: []
  };
  return TreemapSeriesModel2;
}(SeriesModel$1);
function completeTreeValue$1(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue$1(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
function setDefault(levels, ecModel) {
  var globalColorList = normalizeToArray(ecModel.get("color"));
  var globalDecalList = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  if (!globalColorList) {
    return;
  }
  levels = levels || [];
  var hasColorDefine;
  var hasDecalDefine;
  each$f(levels, function(levelDefine) {
    var model = new Model$1(levelDefine);
    var modelColor = model.get("color");
    var modelDecal = model.get("decal");
    if (model.get(["itemStyle", "color"]) || modelColor && modelColor !== "none") {
      hasColorDefine = true;
    }
    if (model.get(["itemStyle", "decal"]) || modelDecal && modelDecal !== "none") {
      hasDecalDefine = true;
    }
  });
  var level0 = levels[0] || (levels[0] = {});
  if (!hasColorDefine) {
    level0.color = globalColorList.slice();
  }
  if (!hasDecalDefine && globalDecalList) {
    level0.decal = globalDecalList.slice();
  }
  return levels;
}
var TreemapSeriesModel$1 = TreemapSeriesModel;
var TEXT_PADDING = 8;
var ITEM_GAP = 8;
var ARRAY_LENGTH = 5;
var Breadcrumb = function() {
  function Breadcrumb2(containerGroup) {
    this.group = new Group$4();
    containerGroup.add(this.group);
  }
  Breadcrumb2.prototype.render = function(seriesModel, api, targetNode, onSelect) {
    var model = seriesModel.getModel("breadcrumb");
    var thisGroup = this.group;
    thisGroup.removeAll();
    if (!model.get("show") || !targetNode) {
      return;
    }
    var normalStyleModel = model.getModel("itemStyle");
    var textStyleModel = normalStyleModel.getModel("textStyle");
    var layoutParam = {
      pos: {
        left: model.get("left"),
        right: model.get("right"),
        top: model.get("top"),
        bottom: model.get("bottom")
      },
      box: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      emptyItemWidth: model.get("emptyItemWidth"),
      totalWidth: 0,
      renderList: []
    };
    this._prepare(targetNode, layoutParam, textStyleModel);
    this._renderContent(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect);
    positionElement(thisGroup, layoutParam.pos, layoutParam.box);
  };
  Breadcrumb2.prototype._prepare = function(targetNode, layoutParam, textStyleModel) {
    for (var node = targetNode; node; node = node.parentNode) {
      var text = convertOptionIdName(node.getModel().get("name"), "");
      var textRect = textStyleModel.getTextRect(text);
      var itemWidth = Math.max(textRect.width + TEXT_PADDING * 2, layoutParam.emptyItemWidth);
      layoutParam.totalWidth += itemWidth + ITEM_GAP;
      layoutParam.renderList.push({
        node,
        text,
        width: itemWidth
      });
    }
  };
  Breadcrumb2.prototype._renderContent = function(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect) {
    var lastX = 0;
    var emptyItemWidth = layoutParam.emptyItemWidth;
    var height = seriesModel.get(["breadcrumb", "height"]);
    var availableSize = getAvailableSize(layoutParam.pos, layoutParam.box);
    var totalWidth = layoutParam.totalWidth;
    var renderList = layoutParam.renderList;
    for (var i = renderList.length - 1; i >= 0; i--) {
      var item = renderList[i];
      var itemNode = item.node;
      var itemWidth = item.width;
      var text = item.text;
      if (totalWidth > availableSize.width) {
        totalWidth -= itemWidth - emptyItemWidth;
        itemWidth = emptyItemWidth;
        text = null;
      }
      var el = new Polygon$1({
        shape: {
          points: makeItemPoints(lastX, 0, itemWidth, height, i === renderList.length - 1, i === 0)
        },
        style: defaults(normalStyleModel.getItemStyle(), {
          lineJoin: "bevel"
        }),
        textContent: new ZRText$1({
          style: {
            text,
            fill: textStyleModel.getTextColor(),
            font: textStyleModel.getFont()
          }
        }),
        textConfig: {
          position: "inside"
        },
        z2: Z2_EMPHASIS_LIFT * 1e4,
        onclick: curry$1(onSelect, itemNode)
      });
      el.disableLabelAnimation = true;
      this.group.add(el);
      packEventData(el, seriesModel, itemNode);
      lastX += itemWidth + ITEM_GAP;
    }
  };
  Breadcrumb2.prototype.remove = function() {
    this.group.removeAll();
  };
  return Breadcrumb2;
}();
function makeItemPoints(x2, y2, itemWidth, itemHeight, head, tail) {
  var points2 = [[head ? x2 : x2 - ARRAY_LENGTH, y2], [x2 + itemWidth, y2], [x2 + itemWidth, y2 + itemHeight], [head ? x2 : x2 - ARRAY_LENGTH, y2 + itemHeight]];
  !tail && points2.splice(2, 0, [x2 + itemWidth + ARRAY_LENGTH, y2 + itemHeight / 2]);
  !head && points2.push([x2, y2 + itemHeight / 2]);
  return points2;
}
function packEventData(el, seriesModel, itemNode) {
  getECData(el).eventData = {
    componentType: "series",
    componentSubType: "treemap",
    componentIndex: seriesModel.componentIndex,
    seriesIndex: seriesModel.seriesIndex,
    seriesName: seriesModel.name,
    seriesType: "treemap",
    selfType: "breadcrumb",
    nodeData: {
      dataIndex: itemNode && itemNode.dataIndex,
      name: itemNode && itemNode.name
    },
    treePathInfo: itemNode && wrapTreePathInfo(itemNode, seriesModel)
  };
}
var Breadcrumb$1 = Breadcrumb;
var AnimationWrap = function() {
  function AnimationWrap2() {
    this._storage = [];
    this._elExistsMap = {};
  }
  AnimationWrap2.prototype.add = function(el, target, duration, delay, easing) {
    if (this._elExistsMap[el.id]) {
      return false;
    }
    this._elExistsMap[el.id] = true;
    this._storage.push({
      el,
      target,
      duration,
      delay,
      easing
    });
    return true;
  };
  AnimationWrap2.prototype.finished = function(callback) {
    this._finishedCallback = callback;
    return this;
  };
  AnimationWrap2.prototype.start = function() {
    var _this = this;
    var count2 = this._storage.length;
    var checkTerminate = function() {
      count2--;
      if (count2 <= 0) {
        _this._storage.length = 0;
        _this._elExistsMap = {};
        _this._finishedCallback && _this._finishedCallback();
      }
    };
    for (var i = 0, len2 = this._storage.length; i < len2; i++) {
      var item = this._storage[i];
      item.el.animateTo(item.target, {
        duration: item.duration,
        delay: item.delay,
        easing: item.easing,
        setToFinal: true,
        done: checkTerminate,
        aborted: checkTerminate
      });
    }
    return this;
  };
  return AnimationWrap2;
}();
function createWrap() {
  return new AnimationWrap();
}
var Group$2 = Group$4;
var Rect$1 = Rect$3;
var DRAG_THRESHOLD = 3;
var PATH_LABEL_NOAMAL = "label";
var PATH_UPPERLABEL_NORMAL = "upperLabel";
var Z2_BASE = Z2_EMPHASIS_LIFT * 10;
var Z2_BG = Z2_EMPHASIS_LIFT * 2;
var Z2_CONTENT = Z2_EMPHASIS_LIFT * 3;
var getStateItemStyle = makeStyleMapper([
  ["fill", "color"],
  ["stroke", "strokeColor"],
  ["lineWidth", "strokeWidth"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"]
]);
var getItemStyleNormal = function(model) {
  var itemStyle = getStateItemStyle(model);
  itemStyle.stroke = itemStyle.fill = itemStyle.lineWidth = null;
  return itemStyle;
};
var inner$d = makeInner();
var TreemapView = function(_super) {
  __extends(TreemapView2, _super);
  function TreemapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapView2.type;
    _this._state = "ready";
    _this._storage = createStorage();
    return _this;
  }
  TreemapView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var models = ecModel.findComponents({
      mainType: "series",
      subType: "treemap",
      query: payload
    });
    if (indexOf(models, seriesModel) < 0) {
      return;
    }
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var payloadType = payload && payload.type;
    var layoutInfo = seriesModel.layoutInfo;
    var isInit = !this._oldTree;
    var thisStorage = this._storage;
    var reRoot = payloadType === "treemapRootToNode" && targetInfo && thisStorage ? {
      rootNodeGroup: thisStorage.nodeGroup[targetInfo.node.getRawIndex()],
      direction: payload.direction
    } : null;
    var containerGroup = this._giveContainerGroup(layoutInfo);
    var hasAnimation = seriesModel.get("animation");
    var renderResult = this._doRender(containerGroup, seriesModel, reRoot);
    hasAnimation && !isInit && (!payloadType || payloadType === "treemapZoomToNode" || payloadType === "treemapRootToNode") ? this._doAnimation(containerGroup, renderResult, seriesModel, reRoot) : renderResult.renderFinally();
    this._resetController(api);
    this._renderBreadcrumb(seriesModel, api, targetInfo);
  };
  TreemapView2.prototype._giveContainerGroup = function(layoutInfo) {
    var containerGroup = this._containerGroup;
    if (!containerGroup) {
      containerGroup = this._containerGroup = new Group$2();
      this._initEvents(containerGroup);
      this.group.add(containerGroup);
    }
    containerGroup.x = layoutInfo.x;
    containerGroup.y = layoutInfo.y;
    return containerGroup;
  };
  TreemapView2.prototype._doRender = function(containerGroup, seriesModel, reRoot) {
    var thisTree = seriesModel.getData().tree;
    var oldTree = this._oldTree;
    var lastsForAnimation = createStorage();
    var thisStorage = createStorage();
    var oldStorage = this._storage;
    var willInvisibleEls = [];
    function doRenderNode(thisNode, oldNode, parentGroup, depth) {
      return renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth);
    }
    dualTravel(thisTree.root ? [thisTree.root] : [], oldTree && oldTree.root ? [oldTree.root] : [], containerGroup, thisTree === oldTree || !oldTree, 0);
    var willDeleteEls = clearStorage(oldStorage);
    this._oldTree = thisTree;
    this._storage = thisStorage;
    return {
      lastsForAnimation,
      willDeleteEls,
      renderFinally
    };
    function dualTravel(thisViewChildren, oldViewChildren, parentGroup, sameTree, depth) {
      if (sameTree) {
        oldViewChildren = thisViewChildren;
        each$f(thisViewChildren, function(child, index2) {
          !child.isRemoved() && processNode(index2, index2);
        });
      } else {
        new DataDiffer$1(oldViewChildren, thisViewChildren, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      }
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIndex, oldIndex) {
        var thisNode = newIndex != null ? thisViewChildren[newIndex] : null;
        var oldNode = oldIndex != null ? oldViewChildren[oldIndex] : null;
        var group = doRenderNode(thisNode, oldNode, parentGroup, depth);
        group && dualTravel(thisNode && thisNode.viewChildren || [], oldNode && oldNode.viewChildren || [], group, sameTree, depth + 1);
      }
    }
    function clearStorage(storage2) {
      var willDeleteEls2 = createStorage();
      storage2 && each$f(storage2, function(store, storageName) {
        var delEls = willDeleteEls2[storageName];
        each$f(store, function(el) {
          el && (delEls.push(el), inner$d(el).willDelete = true);
        });
      });
      return willDeleteEls2;
    }
    function renderFinally() {
      each$f(willDeleteEls, function(els) {
        each$f(els, function(el) {
          el.parent && el.parent.remove(el);
        });
      });
      each$f(willInvisibleEls, function(el) {
        el.invisible = true;
        el.dirty();
      });
    }
  };
  TreemapView2.prototype._doAnimation = function(containerGroup, renderResult, seriesModel, reRoot) {
    var durationOption = seriesModel.get("animationDurationUpdate");
    var easingOption = seriesModel.get("animationEasing");
    var duration = (isFunction(durationOption) ? 0 : durationOption) || 0;
    var easing = (isFunction(easingOption) ? null : easingOption) || "cubicOut";
    var animationWrap = createWrap();
    each$f(renderResult.willDeleteEls, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        if (el.invisible) {
          return;
        }
        var parent = el.parent;
        var target;
        var innerStore = inner$d(parent);
        if (reRoot && reRoot.direction === "drillDown") {
          target = parent === reRoot.rootNodeGroup ? {
            shape: {
              x: 0,
              y: 0,
              width: innerStore.nodeWidth,
              height: innerStore.nodeHeight
            },
            style: {
              opacity: 0
            }
          } : {
            style: {
              opacity: 0
            }
          };
        } else {
          var targetX = 0;
          var targetY = 0;
          if (!innerStore.willDelete) {
            targetX = innerStore.nodeWidth / 2;
            targetY = innerStore.nodeHeight / 2;
          }
          target = storageName === "nodeGroup" ? {
            x: targetX,
            y: targetY,
            style: {
              opacity: 0
            }
          } : {
            shape: {
              x: targetX,
              y: targetY,
              width: 0,
              height: 0
            },
            style: {
              opacity: 0
            }
          };
        }
        target && animationWrap.add(el, target, duration, 0, easing);
      });
    });
    each$f(this._storage, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        var last = renderResult.lastsForAnimation[storageName][rawIndex];
        var target = {};
        if (!last) {
          return;
        }
        if (el instanceof Group$4) {
          if (last.oldX != null) {
            target.x = el.x;
            target.y = el.y;
            el.x = last.oldX;
            el.y = last.oldY;
          }
        } else {
          if (last.oldShape) {
            target.shape = extend({}, el.shape);
            el.setShape(last.oldShape);
          }
          if (last.fadein) {
            el.setStyle("opacity", 0);
            target.style = {
              opacity: 1
            };
          } else if (el.style.opacity !== 1) {
            target.style = {
              opacity: 1
            };
          }
        }
        animationWrap.add(el, target, duration, 0, easing);
      });
    }, this);
    this._state = "animating";
    animationWrap.finished(bind$1(function() {
      this._state = "ready";
      renderResult.renderFinally();
    }, this)).start();
  };
  TreemapView2.prototype._resetController = function(api) {
    var controller = this._controller;
    if (!controller) {
      controller = this._controller = new RoamController$1(api.getZr());
      controller.enable(this.seriesModel.get("roam"));
      controller.on("pan", bind$1(this._onPan, this));
      controller.on("zoom", bind$1(this._onZoom, this));
    }
    var rect = new BoundingRect$1(0, 0, api.getWidth(), api.getHeight());
    controller.setPointerChecker(function(e2, x2, y2) {
      return rect.contain(x2, y2);
    });
  };
  TreemapView2.prototype._clearController = function() {
    var controller = this._controller;
    if (controller) {
      controller.dispose();
      controller = null;
    }
  };
  TreemapView2.prototype._onPan = function(e2) {
    if (this._state !== "animating" && (Math.abs(e2.dx) > DRAG_THRESHOLD || Math.abs(e2.dy) > DRAG_THRESHOLD)) {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      this.api.dispatchAction({
        type: "treemapMove",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rootLayout.x + e2.dx,
          y: rootLayout.y + e2.dy,
          width: rootLayout.width,
          height: rootLayout.height
        }
      });
    }
  };
  TreemapView2.prototype._onZoom = function(e2) {
    var mouseX = e2.originX;
    var mouseY = e2.originY;
    if (this._state !== "animating") {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      var rect = new BoundingRect$1(rootLayout.x, rootLayout.y, rootLayout.width, rootLayout.height);
      var layoutInfo = this.seriesModel.layoutInfo;
      mouseX -= layoutInfo.x;
      mouseY -= layoutInfo.y;
      var m2 = create$1();
      translate(m2, m2, [-mouseX, -mouseY]);
      scale$1(m2, m2, [e2.scale, e2.scale]);
      translate(m2, m2, [mouseX, mouseY]);
      rect.applyTransform(m2);
      this.api.dispatchAction({
        type: "treemapRender",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rect.x,
          y: rect.y,
          width: rect.width,
          height: rect.height
        }
      });
    }
  };
  TreemapView2.prototype._initEvents = function(containerGroup) {
    var _this = this;
    containerGroup.on("click", function(e2) {
      if (_this._state !== "ready") {
        return;
      }
      var nodeClick = _this.seriesModel.get("nodeClick", true);
      if (!nodeClick) {
        return;
      }
      var targetInfo = _this.findTarget(e2.offsetX, e2.offsetY);
      if (!targetInfo) {
        return;
      }
      var node = targetInfo.node;
      if (node.getLayout().isLeafRoot) {
        _this._rootToNode(targetInfo);
      } else {
        if (nodeClick === "zoomToNode") {
          _this._zoomToNode(targetInfo);
        } else if (nodeClick === "link") {
          var itemModel = node.hostTree.data.getItemModel(node.dataIndex);
          var link = itemModel.get("link", true);
          var linkTarget = itemModel.get("target", true) || "blank";
          link && windowOpen(link, linkTarget);
        }
      }
    }, this);
  };
  TreemapView2.prototype._renderBreadcrumb = function(seriesModel, api, targetInfo) {
    var _this = this;
    if (!targetInfo) {
      targetInfo = seriesModel.get("leafDepth", true) != null ? {
        node: seriesModel.getViewRoot()
      } : this.findTarget(api.getWidth() / 2, api.getHeight() / 2);
      if (!targetInfo) {
        targetInfo = {
          node: seriesModel.getData().tree.root
        };
      }
    }
    (this._breadcrumb || (this._breadcrumb = new Breadcrumb$1(this.group))).render(seriesModel, api, targetInfo.node, function(node) {
      if (_this._state !== "animating") {
        aboveViewRoot(seriesModel.getViewRoot(), node) ? _this._rootToNode({
          node
        }) : _this._zoomToNode({
          node
        });
      }
    });
  };
  TreemapView2.prototype.remove = function() {
    this._clearController();
    this._containerGroup && this._containerGroup.removeAll();
    this._storage = createStorage();
    this._state = "ready";
    this._breadcrumb && this._breadcrumb.remove();
  };
  TreemapView2.prototype.dispose = function() {
    this._clearController();
  };
  TreemapView2.prototype._zoomToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapZoomToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype._rootToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapRootToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype.findTarget = function(x2, y2) {
    var targetInfo;
    var viewRoot = this.seriesModel.getViewRoot();
    viewRoot.eachNode({
      attr: "viewChildren",
      order: "preorder"
    }, function(node) {
      var bgEl = this._storage.background[node.getRawIndex()];
      if (bgEl) {
        var point = bgEl.transformCoordToLocal(x2, y2);
        var shape = bgEl.shape;
        if (shape.x <= point[0] && point[0] <= shape.x + shape.width && shape.y <= point[1] && point[1] <= shape.y + shape.height) {
          targetInfo = {
            node,
            offsetX: point[0],
            offsetY: point[1]
          };
        } else {
          return false;
        }
      }
    }, this);
    return targetInfo;
  };
  TreemapView2.type = "treemap";
  return TreemapView2;
}(ChartView$1);
function createStorage() {
  return {
    nodeGroup: [],
    background: [],
    content: []
  };
}
function renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth) {
  if (!thisNode) {
    return;
  }
  var thisLayout = thisNode.getLayout();
  var data = seriesModel.getData();
  var nodeModel = thisNode.getModel();
  data.setItemGraphicEl(thisNode.dataIndex, null);
  if (!thisLayout || !thisLayout.isInView) {
    return;
  }
  var thisWidth = thisLayout.width;
  var thisHeight = thisLayout.height;
  var borderWidth = thisLayout.borderWidth;
  var thisInvisible = thisLayout.invisible;
  var thisRawIndex = thisNode.getRawIndex();
  var oldRawIndex = oldNode && oldNode.getRawIndex();
  var thisViewChildren = thisNode.viewChildren;
  var upperHeight = thisLayout.upperHeight;
  var isParent = thisViewChildren && thisViewChildren.length;
  var itemStyleNormalModel = nodeModel.getModel("itemStyle");
  var itemStyleEmphasisModel = nodeModel.getModel(["emphasis", "itemStyle"]);
  var itemStyleBlurModel = nodeModel.getModel(["blur", "itemStyle"]);
  var itemStyleSelectModel = nodeModel.getModel(["select", "itemStyle"]);
  var borderRadius = itemStyleNormalModel.get("borderRadius") || 0;
  var group = giveGraphic("nodeGroup", Group$2);
  if (!group) {
    return;
  }
  parentGroup.add(group);
  group.x = thisLayout.x || 0;
  group.y = thisLayout.y || 0;
  group.markRedraw();
  inner$d(group).nodeWidth = thisWidth;
  inner$d(group).nodeHeight = thisHeight;
  if (thisLayout.isAboveViewRoot) {
    return group;
  }
  var bg = giveGraphic("background", Rect$1, depth, Z2_BG);
  bg && renderBackground(group, bg, isParent && thisLayout.upperLabelHeight);
  var emphasisModel = nodeModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var isDisabled = emphasisModel.get("disabled");
  var focusOrIndices = focus === "ancestor" ? thisNode.getAncestorsIndices() : focus === "descendant" ? thisNode.getDescendantIndices() : focus;
  if (isParent) {
    if (isHighDownDispatcher(group)) {
      setAsHighDownDispatcher(group, false);
    }
    if (bg) {
      setAsHighDownDispatcher(bg, !isDisabled);
      data.setItemGraphicEl(thisNode.dataIndex, bg);
      enableHoverFocus(bg, focusOrIndices, blurScope);
    }
  } else {
    var content = giveGraphic("content", Rect$1, depth, Z2_CONTENT);
    content && renderContent(group, content);
    bg.disableMorphing = true;
    if (bg && isHighDownDispatcher(bg)) {
      setAsHighDownDispatcher(bg, false);
    }
    setAsHighDownDispatcher(group, !isDisabled);
    data.setItemGraphicEl(thisNode.dataIndex, group);
    enableHoverFocus(group, focusOrIndices, blurScope);
  }
  return group;
  function renderBackground(group2, bg2, useUpperLabel) {
    var ecData = getECData(bg2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    bg2.setShape({
      x: 0,
      y: 0,
      width: thisWidth,
      height: thisHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(bg2);
    } else {
      bg2.invisible = false;
      var style = thisNode.getVisual("style");
      var visualBorderColor = style.stroke;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualBorderColor;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      emphasisStyle.fill = itemStyleEmphasisModel.get("borderColor");
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      blurStyle.fill = itemStyleBlurModel.get("borderColor");
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      selectStyle.fill = itemStyleSelectModel.get("borderColor");
      if (useUpperLabel) {
        var upperLabelWidth = thisWidth - 2 * borderWidth;
        prepareText(bg2, visualBorderColor, style.opacity, {
          x: borderWidth,
          y: 0,
          width: upperLabelWidth,
          height: upperHeight
        });
      } else {
        bg2.removeTextContent();
      }
      bg2.setStyle(normalStyle);
      bg2.ensureState("emphasis").style = emphasisStyle;
      bg2.ensureState("blur").style = blurStyle;
      bg2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(bg2);
    }
    group2.add(bg2);
  }
  function renderContent(group2, content2) {
    var ecData = getECData(content2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    var contentWidth = Math.max(thisWidth - 2 * borderWidth, 0);
    var contentHeight = Math.max(thisHeight - 2 * borderWidth, 0);
    content2.culling = true;
    content2.setShape({
      x: borderWidth,
      y: borderWidth,
      width: contentWidth,
      height: contentHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(content2);
    } else {
      content2.invisible = false;
      var nodeStyle = thisNode.getVisual("style");
      var visualColor = nodeStyle.fill;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualColor;
      normalStyle.decal = nodeStyle.decal;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      prepareText(content2, visualColor, nodeStyle.opacity, null);
      content2.setStyle(normalStyle);
      content2.ensureState("emphasis").style = emphasisStyle;
      content2.ensureState("blur").style = blurStyle;
      content2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(content2);
    }
    group2.add(content2);
  }
  function processInvisible(element) {
    !element.invisible && willInvisibleEls.push(element);
  }
  function prepareText(rectEl, visualColor, visualOpacity, upperLabelRect) {
    var normalLabelModel = nodeModel.getModel(upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL);
    var defaultText = convertOptionIdName(nodeModel.get("name"), null);
    var isShow = normalLabelModel.getShallow("show");
    setLabelStyle(rectEl, getLabelStatesModels(nodeModel, upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL), {
      defaultText: isShow ? defaultText : null,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      labelFetcher: seriesModel,
      labelDataIndex: thisNode.dataIndex
    });
    var textEl = rectEl.getTextContent();
    if (!textEl) {
      return;
    }
    var textStyle = textEl.style;
    var textPadding = normalizeCssArray$1(textStyle.padding || 0);
    if (upperLabelRect) {
      rectEl.setTextConfig({
        layoutRect: upperLabelRect
      });
      textEl.disableLabelLayout = true;
    }
    textEl.beforeUpdate = function() {
      var width = Math.max((upperLabelRect ? upperLabelRect.width : rectEl.shape.width) - textPadding[1] - textPadding[3], 0);
      var height = Math.max((upperLabelRect ? upperLabelRect.height : rectEl.shape.height) - textPadding[0] - textPadding[2], 0);
      if (textStyle.width !== width || textStyle.height !== height) {
        textEl.setStyle({
          width,
          height
        });
      }
    };
    textStyle.truncateMinChar = 2;
    textStyle.lineOverflow = "truncate";
    addDrillDownIcon(textStyle, upperLabelRect, thisLayout);
    var textEmphasisState = textEl.getState("emphasis");
    addDrillDownIcon(textEmphasisState ? textEmphasisState.style : null, upperLabelRect, thisLayout);
  }
  function addDrillDownIcon(style, upperLabelRect, thisLayout2) {
    var text = style ? style.text : null;
    if (!upperLabelRect && thisLayout2.isLeafRoot && text != null) {
      var iconChar = seriesModel.get("drillDownIcon", true);
      style.text = iconChar ? iconChar + " " + text : text;
    }
  }
  function giveGraphic(storageName, Ctor, depth2, z2) {
    var element = oldRawIndex != null && oldStorage[storageName][oldRawIndex];
    var lasts = lastsForAnimation[storageName];
    if (element) {
      oldStorage[storageName][oldRawIndex] = null;
      prepareAnimationWhenHasOld(lasts, element);
    } else if (!thisInvisible) {
      element = new Ctor();
      if (element instanceof Displayable$1) {
        element.z2 = calculateZ2(depth2, z2);
      }
      prepareAnimationWhenNoOld(lasts, element);
    }
    return thisStorage[storageName][thisRawIndex] = element;
  }
  function prepareAnimationWhenHasOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    if (element instanceof Group$2) {
      lastCfg.oldX = element.x;
      lastCfg.oldY = element.y;
    } else {
      lastCfg.oldShape = extend({}, element.shape);
    }
  }
  function prepareAnimationWhenNoOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    var parentNode2 = thisNode.parentNode;
    var isGroup = element instanceof Group$4;
    if (parentNode2 && (!reRoot || reRoot.direction === "drillDown")) {
      var parentOldX = 0;
      var parentOldY = 0;
      var parentOldBg = lastsForAnimation.background[parentNode2.getRawIndex()];
      if (!reRoot && parentOldBg && parentOldBg.oldShape) {
        parentOldX = parentOldBg.oldShape.width;
        parentOldY = parentOldBg.oldShape.height;
      }
      if (isGroup) {
        lastCfg.oldX = 0;
        lastCfg.oldY = parentOldY;
      } else {
        lastCfg.oldShape = {
          x: parentOldX,
          y: parentOldY,
          width: 0,
          height: 0
        };
      }
    }
    lastCfg.fadein = !isGroup;
  }
}
function calculateZ2(depth, z2InLevel) {
  return depth * Z2_BASE + z2InLevel;
}
var TreemapView$1 = TreemapView;
var each$c = each$f;
var isObject$1 = isObject$4;
var CATEGORY_DEFAULT_VISUAL_INDEX = -1;
var VisualMapping = function() {
  function VisualMapping2(option) {
    var mappingMethod = option.mappingMethod;
    var visualType = option.type;
    var thisOption = this.option = clone$4(option);
    this.type = visualType;
    this.mappingMethod = mappingMethod;
    this._normalizeData = normalizers[mappingMethod];
    var visualHandler = VisualMapping2.visualHandlers[visualType];
    this.applyVisual = visualHandler.applyVisual;
    this.getColorMapper = visualHandler.getColorMapper;
    this._normalizedToVisual = visualHandler._normalizedToVisual[mappingMethod];
    if (mappingMethod === "piecewise") {
      normalizeVisualRange(thisOption);
      preprocessForPiecewise(thisOption);
    } else if (mappingMethod === "category") {
      thisOption.categories ? preprocessForSpecifiedCategory(thisOption) : normalizeVisualRange(thisOption, true);
    } else {
      assert(mappingMethod !== "linear" || thisOption.dataExtent);
      normalizeVisualRange(thisOption);
    }
  }
  VisualMapping2.prototype.mapValueToVisual = function(value) {
    var normalized = this._normalizeData(value);
    return this._normalizedToVisual(normalized, value);
  };
  VisualMapping2.prototype.getNormalizer = function() {
    return bind$1(this._normalizeData, this);
  };
  VisualMapping2.listVisualTypes = function() {
    return keys(VisualMapping2.visualHandlers);
  };
  VisualMapping2.isValidType = function(visualType) {
    return VisualMapping2.visualHandlers.hasOwnProperty(visualType);
  };
  VisualMapping2.eachVisual = function(visual, callback, context) {
    if (isObject$4(visual)) {
      each$f(visual, callback, context);
    } else {
      callback.call(context, visual);
    }
  };
  VisualMapping2.mapVisual = function(visual, callback, context) {
    var isPrimary;
    var newVisual = isArray$1(visual) ? [] : isObject$4(visual) ? {} : (isPrimary = true, null);
    VisualMapping2.eachVisual(visual, function(v4, key) {
      var newVal = callback.call(context, v4, key);
      isPrimary ? newVisual = newVal : newVisual[key] = newVal;
    });
    return newVisual;
  };
  VisualMapping2.retrieveVisuals = function(obj) {
    var ret = {};
    var hasVisual;
    obj && each$c(VisualMapping2.visualHandlers, function(h, visualType) {
      if (obj.hasOwnProperty(visualType)) {
        ret[visualType] = obj[visualType];
        hasVisual = true;
      }
    });
    return hasVisual ? ret : null;
  };
  VisualMapping2.prepareVisualTypes = function(visualTypes) {
    if (isArray$1(visualTypes)) {
      visualTypes = visualTypes.slice();
    } else if (isObject$1(visualTypes)) {
      var types_1 = [];
      each$c(visualTypes, function(item, type4) {
        types_1.push(type4);
      });
      visualTypes = types_1;
    } else {
      return [];
    }
    visualTypes.sort(function(type1, type22) {
      return type22 === "color" && type1 !== "color" && type1.indexOf("color") === 0 ? 1 : -1;
    });
    return visualTypes;
  };
  VisualMapping2.dependsOn = function(visualType1, visualType2) {
    return visualType2 === "color" ? !!(visualType1 && visualType1.indexOf(visualType2) === 0) : visualType1 === visualType2;
  };
  VisualMapping2.findPieceIndex = function(value, pieceList, findClosestWhenOutside) {
    var possibleI;
    var abs2 = Infinity;
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var pieceValue = pieceList[i].value;
      if (pieceValue != null) {
        if (pieceValue === value || isString(pieceValue) && pieceValue === value + "") {
          return i;
        }
        findClosestWhenOutside && updatePossible(pieceValue, i);
      }
    }
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var piece = pieceList[i];
      var interval = piece.interval;
      var close_1 = piece.close;
      if (interval) {
        if (interval[0] === -Infinity) {
          if (littleThan(close_1[1], value, interval[1])) {
            return i;
          }
        } else if (interval[1] === Infinity) {
          if (littleThan(close_1[0], interval[0], value)) {
            return i;
          }
        } else if (littleThan(close_1[0], interval[0], value) && littleThan(close_1[1], value, interval[1])) {
          return i;
        }
        findClosestWhenOutside && updatePossible(interval[0], i);
        findClosestWhenOutside && updatePossible(interval[1], i);
      }
    }
    if (findClosestWhenOutside) {
      return value === Infinity ? pieceList.length - 1 : value === -Infinity ? 0 : possibleI;
    }
    function updatePossible(val, index2) {
      var newAbs = Math.abs(val - value);
      if (newAbs < abs2) {
        abs2 = newAbs;
        possibleI = index2;
      }
    }
  };
  VisualMapping2.visualHandlers = {
    color: {
      applyVisual: makeApplyVisual("color"),
      getColorMapper: function() {
        var thisOption = this.option;
        return bind$1(thisOption.mappingMethod === "category" ? function(value, isNormalized) {
          !isNormalized && (value = this._normalizeData(value));
          return doMapCategory.call(this, value);
        } : function(value, isNormalized, out2) {
          var returnRGBArray = !!out2;
          !isNormalized && (value = this._normalizeData(value));
          out2 = fastLerp(value, thisOption.parsedVisual, out2);
          return returnRGBArray ? out2 : stringify(out2, "rgba");
        }, this);
      },
      _normalizedToVisual: {
        linear: function(normalized) {
          return stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
        },
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    colorHue: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, value);
    }),
    colorSaturation: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, value);
    }),
    colorLightness: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, null, value);
    }),
    colorAlpha: makePartialColorVisualHandler(function(color, value) {
      return modifyAlpha(color, value);
    }),
    decal: {
      applyVisual: makeApplyVisual("decal"),
      _normalizedToVisual: {
        linear: null,
        category: doMapCategory,
        piecewise: null,
        fixed: null
      }
    },
    opacity: {
      applyVisual: makeApplyVisual("opacity"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    },
    liftZ: {
      applyVisual: makeApplyVisual("liftZ"),
      _normalizedToVisual: {
        linear: doMapFixed,
        category: doMapFixed,
        piecewise: doMapFixed,
        fixed: doMapFixed
      }
    },
    symbol: {
      applyVisual: function(value, getter, setter) {
        var symbolCfg = this.mapValueToVisual(value);
        setter("symbol", symbolCfg);
      },
      _normalizedToVisual: {
        linear: doMapToArray,
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = doMapToArray.call(this, normalized);
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    symbolSize: {
      applyVisual: makeApplyVisual("symbolSize"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    }
  };
  return VisualMapping2;
}();
function preprocessForPiecewise(thisOption) {
  var pieceList = thisOption.pieceList;
  thisOption.hasSpecialVisual = false;
  each$f(pieceList, function(piece, index2) {
    piece.originIndex = index2;
    if (piece.visual != null) {
      thisOption.hasSpecialVisual = true;
    }
  });
}
function preprocessForSpecifiedCategory(thisOption) {
  var categories = thisOption.categories;
  var categoryMap = thisOption.categoryMap = {};
  var visual = thisOption.visual;
  each$c(categories, function(cate, index2) {
    categoryMap[cate] = index2;
  });
  if (!isArray$1(visual)) {
    var visualArr_1 = [];
    if (isObject$4(visual)) {
      each$c(visual, function(v4, cate) {
        var index2 = categoryMap[cate];
        visualArr_1[index2 != null ? index2 : CATEGORY_DEFAULT_VISUAL_INDEX] = v4;
      });
    } else {
      visualArr_1[CATEGORY_DEFAULT_VISUAL_INDEX] = visual;
    }
    visual = setVisualToOption(thisOption, visualArr_1);
  }
  for (var i = categories.length - 1; i >= 0; i--) {
    if (visual[i] == null) {
      delete categoryMap[categories[i]];
      categories.pop();
    }
  }
}
function normalizeVisualRange(thisOption, isCategory2) {
  var visual = thisOption.visual;
  var visualArr = [];
  if (isObject$4(visual)) {
    each$c(visual, function(v4) {
      visualArr.push(v4);
    });
  } else if (visual != null) {
    visualArr.push(visual);
  }
  var doNotNeedPair = {
    color: 1,
    symbol: 1
  };
  if (!isCategory2 && visualArr.length === 1 && !doNotNeedPair.hasOwnProperty(thisOption.type)) {
    visualArr[1] = visualArr[0];
  }
  setVisualToOption(thisOption, visualArr);
}
function makePartialColorVisualHandler(applyValue) {
  return {
    applyVisual: function(value, getter, setter) {
      var colorChannel = this.mapValueToVisual(value);
      setter("color", applyValue(getter("color"), colorChannel));
    },
    _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
  };
}
function doMapToArray(normalized) {
  var visual = this.option.visual;
  return visual[Math.round(linearMap$2(normalized, [0, 1], [0, visual.length - 1], true))] || {};
}
function makeApplyVisual(visualType) {
  return function(value, getter, setter) {
    setter(visualType, this.mapValueToVisual(value));
  };
}
function doMapCategory(normalized) {
  var visual = this.option.visual;
  return visual[this.option.loop && normalized !== CATEGORY_DEFAULT_VISUAL_INDEX ? normalized % visual.length : normalized];
}
function doMapFixed() {
  return this.option.visual[0];
}
function createNormalizedToNumericVisual(sourceExtent) {
  return {
    linear: function(normalized) {
      return linearMap$2(normalized, sourceExtent, this.option.visual, true);
    },
    category: doMapCategory,
    piecewise: function(normalized, value) {
      var result = getSpecifiedVisual.call(this, value);
      if (result == null) {
        result = linearMap$2(normalized, sourceExtent, this.option.visual, true);
      }
      return result;
    },
    fixed: doMapFixed
  };
}
function getSpecifiedVisual(value) {
  var thisOption = this.option;
  var pieceList = thisOption.pieceList;
  if (thisOption.hasSpecialVisual) {
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList);
    var piece = pieceList[pieceIndex];
    if (piece && piece.visual) {
      return piece.visual[this.type];
    }
  }
}
function setVisualToOption(thisOption, visualArr) {
  thisOption.visual = visualArr;
  if (thisOption.type === "color") {
    thisOption.parsedVisual = map$1(visualArr, function(item) {
      return parse(item);
    });
  }
  return visualArr;
}
var normalizers = {
  linear: function(value) {
    return linearMap$2(value, this.option.dataExtent, [0, 1], true);
  },
  piecewise: function(value) {
    var pieceList = this.option.pieceList;
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList, true);
    if (pieceIndex != null) {
      return linearMap$2(pieceIndex, [0, pieceList.length - 1], [0, 1], true);
    }
  },
  category: function(value) {
    var index2 = this.option.categories ? this.option.categoryMap[value] : value;
    return index2 == null ? CATEGORY_DEFAULT_VISUAL_INDEX : index2;
  },
  fixed: noop
};
function littleThan(close, a, b2) {
  return close ? a <= b2 : a < b2;
}
var VisualMapping$1 = VisualMapping;
var ITEM_STYLE_NORMAL = "itemStyle";
var inner$c = makeInner();
var treemapVisual = {
  seriesType: "treemap",
  reset: function(seriesModel) {
    var tree = seriesModel.getData().tree;
    var root2 = tree.root;
    if (root2.isRemoved()) {
      return;
    }
    travelTree(root2, {}, seriesModel.getViewRoot().getAncestors(), seriesModel);
  }
};
function travelTree(node, designatedVisual, viewRootAncestors, seriesModel) {
  var nodeModel = node.getModel();
  var nodeLayout = node.getLayout();
  var data = node.hostTree.data;
  if (!nodeLayout || nodeLayout.invisible || !nodeLayout.isInView) {
    return;
  }
  var nodeItemStyleModel = nodeModel.getModel(ITEM_STYLE_NORMAL);
  var visuals = buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel);
  var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
  var borderColor = nodeItemStyleModel.get("borderColor");
  var borderColorSaturation = nodeItemStyleModel.get("borderColorSaturation");
  var thisNodeColor;
  if (borderColorSaturation != null) {
    thisNodeColor = calculateColor(visuals);
    borderColor = calculateBorderColor(borderColorSaturation, thisNodeColor);
  }
  existsStyle.stroke = borderColor;
  var viewChildren = node.viewChildren;
  if (!viewChildren || !viewChildren.length) {
    thisNodeColor = calculateColor(visuals);
    existsStyle.fill = thisNodeColor;
  } else {
    var mapping_1 = buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren);
    each$f(viewChildren, function(child, index2) {
      if (child.depth >= viewRootAncestors.length || child === viewRootAncestors[child.depth]) {
        var childVisual = mapVisual$1(nodeModel, visuals, child, index2, mapping_1, seriesModel);
        travelTree(child, childVisual, viewRootAncestors, seriesModel);
      }
    });
  }
}
function buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel) {
  var visuals = extend({}, designatedVisual);
  var designatedVisualItemStyle = seriesModel.designatedVisualItemStyle;
  each$f(["color", "colorAlpha", "colorSaturation"], function(visualName) {
    designatedVisualItemStyle[visualName] = designatedVisual[visualName];
    var val = nodeItemStyleModel.get(visualName);
    designatedVisualItemStyle[visualName] = null;
    val != null && (visuals[visualName] = val);
  });
  return visuals;
}
function calculateColor(visuals) {
  var color = getValueVisualDefine(visuals, "color");
  if (color) {
    var colorAlpha = getValueVisualDefine(visuals, "colorAlpha");
    var colorSaturation = getValueVisualDefine(visuals, "colorSaturation");
    if (colorSaturation) {
      color = modifyHSL(color, null, null, colorSaturation);
    }
    if (colorAlpha) {
      color = modifyAlpha(color, colorAlpha);
    }
    return color;
  }
}
function calculateBorderColor(borderColorSaturation, thisNodeColor) {
  return thisNodeColor != null ? modifyHSL(thisNodeColor, null, null, borderColorSaturation) : null;
}
function getValueVisualDefine(visuals, name) {
  var value = visuals[name];
  if (value != null && value !== "none") {
    return value;
  }
}
function buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren) {
  if (!viewChildren || !viewChildren.length) {
    return;
  }
  var rangeVisual = getRangeVisual(nodeModel, "color") || visuals.color != null && visuals.color !== "none" && (getRangeVisual(nodeModel, "colorAlpha") || getRangeVisual(nodeModel, "colorSaturation"));
  if (!rangeVisual) {
    return;
  }
  var visualMin = nodeModel.get("visualMin");
  var visualMax = nodeModel.get("visualMax");
  var dataExtent = nodeLayout.dataExtent.slice();
  visualMin != null && visualMin < dataExtent[0] && (dataExtent[0] = visualMin);
  visualMax != null && visualMax > dataExtent[1] && (dataExtent[1] = visualMax);
  var colorMappingBy = nodeModel.get("colorMappingBy");
  var opt = {
    type: rangeVisual.name,
    dataExtent,
    visual: rangeVisual.range
  };
  if (opt.type === "color" && (colorMappingBy === "index" || colorMappingBy === "id")) {
    opt.mappingMethod = "category";
    opt.loop = true;
  } else {
    opt.mappingMethod = "linear";
  }
  var mapping = new VisualMapping$1(opt);
  inner$c(mapping).drColorMappingBy = colorMappingBy;
  return mapping;
}
function getRangeVisual(nodeModel, name) {
  var range3 = nodeModel.get(name);
  return isArray$1(range3) && range3.length ? {
    name,
    range: range3
  } : null;
}
function mapVisual$1(nodeModel, visuals, child, index2, mapping, seriesModel) {
  var childVisuals = extend({}, visuals);
  if (mapping) {
    var mappingType = mapping.type;
    var colorMappingBy = mappingType === "color" && inner$c(mapping).drColorMappingBy;
    var value = colorMappingBy === "index" ? index2 : colorMappingBy === "id" ? seriesModel.mapIdToIndex(child.getId()) : child.getValue(nodeModel.get("visualDimension"));
    childVisuals[mappingType] = mapping.mapValueToVisual(value);
  }
  return childVisuals;
}
var mathMax$3 = Math.max;
var mathMin$3 = Math.min;
var retrieveValue = retrieve;
var each$b = each$f;
var PATH_BORDER_WIDTH = ["itemStyle", "borderWidth"];
var PATH_GAP_WIDTH = ["itemStyle", "gapWidth"];
var PATH_UPPER_LABEL_SHOW = ["upperLabel", "show"];
var PATH_UPPER_LABEL_HEIGHT = ["upperLabel", "height"];
var treemapLayout = {
  seriesType: "treemap",
  reset: function(seriesModel, ecModel, api, payload) {
    var ecWidth = api.getWidth();
    var ecHeight = api.getHeight();
    var seriesOption = seriesModel.option;
    var layoutInfo = getLayoutRect(seriesModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    var size = seriesOption.size || [];
    var containerWidth = parsePercent(retrieveValue(layoutInfo.width, size[0]), ecWidth);
    var containerHeight = parsePercent(retrieveValue(layoutInfo.height, size[1]), ecHeight);
    var payloadType = payload && payload.type;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var rootRect = payloadType === "treemapRender" || payloadType === "treemapMove" ? payload.rootRect : null;
    var viewRoot = seriesModel.getViewRoot();
    var viewAbovePath = getPathToRoot(viewRoot);
    if (payloadType !== "treemapMove") {
      var rootSize = payloadType === "treemapZoomToNode" ? estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) : rootRect ? [rootRect.width, rootRect.height] : [containerWidth, containerHeight];
      var sort_1 = seriesOption.sort;
      if (sort_1 && sort_1 !== "asc" && sort_1 !== "desc") {
        sort_1 = "desc";
      }
      var options = {
        squareRatio: seriesOption.squareRatio,
        sort: sort_1,
        leafDepth: seriesOption.leafDepth
      };
      viewRoot.hostTree.clearLayouts();
      var viewRootLayout_1 = {
        x: 0,
        y: 0,
        width: rootSize[0],
        height: rootSize[1],
        area: rootSize[0] * rootSize[1]
      };
      viewRoot.setLayout(viewRootLayout_1);
      squarify(viewRoot, options, false, 0);
      viewRootLayout_1 = viewRoot.getLayout();
      each$b(viewAbovePath, function(node, index2) {
        var childValue = (viewAbovePath[index2 + 1] || viewRoot).getValue();
        node.setLayout(extend({
          dataExtent: [childValue, childValue],
          borderWidth: 0,
          upperHeight: 0
        }, viewRootLayout_1));
      });
    }
    var treeRoot = seriesModel.getData().tree.root;
    treeRoot.setLayout(calculateRootPosition(layoutInfo, rootRect, targetInfo), true);
    seriesModel.setLayoutInfo(layoutInfo);
    prunning(treeRoot, new BoundingRect$1(-layoutInfo.x, -layoutInfo.y, ecWidth, ecHeight), viewAbovePath, viewRoot, 0);
  }
};
function squarify(node, options, hideChildren, depth) {
  var width;
  var height;
  if (node.isRemoved()) {
    return;
  }
  var thisLayout = node.getLayout();
  width = thisLayout.width;
  height = thisLayout.height;
  var nodeModel = node.getModel();
  var borderWidth = nodeModel.get(PATH_BORDER_WIDTH);
  var halfGapWidth = nodeModel.get(PATH_GAP_WIDTH) / 2;
  var upperLabelHeight = getUpperLabelHeight(nodeModel);
  var upperHeight = Math.max(borderWidth, upperLabelHeight);
  var layoutOffset = borderWidth - halfGapWidth;
  var layoutOffsetUpper = upperHeight - halfGapWidth;
  node.setLayout({
    borderWidth,
    upperHeight,
    upperLabelHeight
  }, true);
  width = mathMax$3(width - 2 * layoutOffset, 0);
  height = mathMax$3(height - layoutOffset - layoutOffsetUpper, 0);
  var totalArea = width * height;
  var viewChildren = initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth);
  if (!viewChildren.length) {
    return;
  }
  var rect = {
    x: layoutOffset,
    y: layoutOffsetUpper,
    width,
    height
  };
  var rowFixedLength = mathMin$3(width, height);
  var best = Infinity;
  var row = [];
  row.area = 0;
  for (var i = 0, len2 = viewChildren.length; i < len2; ) {
    var child = viewChildren[i];
    row.push(child);
    row.area += child.getLayout().area;
    var score = worst(row, rowFixedLength, options.squareRatio);
    if (score <= best) {
      i++;
      best = score;
    } else {
      row.area -= row.pop().getLayout().area;
      position(row, rowFixedLength, rect, halfGapWidth, false);
      rowFixedLength = mathMin$3(rect.width, rect.height);
      row.length = row.area = 0;
      best = Infinity;
    }
  }
  if (row.length) {
    position(row, rowFixedLength, rect, halfGapWidth, true);
  }
  if (!hideChildren) {
    var childrenVisibleMin = nodeModel.get("childrenVisibleMin");
    if (childrenVisibleMin != null && totalArea < childrenVisibleMin) {
      hideChildren = true;
    }
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    squarify(viewChildren[i], options, hideChildren, depth + 1);
  }
}
function initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth) {
  var viewChildren = node.children || [];
  var orderBy = options.sort;
  orderBy !== "asc" && orderBy !== "desc" && (orderBy = null);
  var overLeafDepth = options.leafDepth != null && options.leafDepth <= depth;
  if (hideChildren && !overLeafDepth) {
    return node.viewChildren = [];
  }
  viewChildren = filter(viewChildren, function(child) {
    return !child.isRemoved();
  });
  sort$1(viewChildren, orderBy);
  var info = statistic(nodeModel, viewChildren, orderBy);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  info.sum = filterByThreshold(nodeModel, totalArea, info.sum, orderBy, viewChildren);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    var area = viewChildren[i].getValue() / info.sum * totalArea;
    viewChildren[i].setLayout({
      area
    });
  }
  if (overLeafDepth) {
    viewChildren.length && node.setLayout({
      isLeafRoot: true
    }, true);
    viewChildren.length = 0;
  }
  node.viewChildren = viewChildren;
  node.setLayout({
    dataExtent: info.dataExtent
  }, true);
  return viewChildren;
}
function filterByThreshold(nodeModel, totalArea, sum2, orderBy, orderedChildren) {
  if (!orderBy) {
    return sum2;
  }
  var visibleMin = nodeModel.get("visibleMin");
  var len2 = orderedChildren.length;
  var deletePoint = len2;
  for (var i = len2 - 1; i >= 0; i--) {
    var value = orderedChildren[orderBy === "asc" ? len2 - i - 1 : i].getValue();
    if (value / sum2 * totalArea < visibleMin) {
      deletePoint = i;
      sum2 -= value;
    }
  }
  orderBy === "asc" ? orderedChildren.splice(0, len2 - deletePoint) : orderedChildren.splice(deletePoint, len2 - deletePoint);
  return sum2;
}
function sort$1(viewChildren, orderBy) {
  if (orderBy) {
    viewChildren.sort(function(a, b2) {
      var diff = orderBy === "asc" ? a.getValue() - b2.getValue() : b2.getValue() - a.getValue();
      return diff === 0 ? orderBy === "asc" ? a.dataIndex - b2.dataIndex : b2.dataIndex - a.dataIndex : diff;
    });
  }
  return viewChildren;
}
function statistic(nodeModel, children, orderBy) {
  var sum2 = 0;
  for (var i = 0, len2 = children.length; i < len2; i++) {
    sum2 += children[i].getValue();
  }
  var dimension = nodeModel.get("visualDimension");
  var dataExtent;
  if (!children || !children.length) {
    dataExtent = [NaN, NaN];
  } else if (dimension === "value" && orderBy) {
    dataExtent = [children[children.length - 1].getValue(), children[0].getValue()];
    orderBy === "asc" && dataExtent.reverse();
  } else {
    dataExtent = [Infinity, -Infinity];
    each$b(children, function(child) {
      var value = child.getValue(dimension);
      value < dataExtent[0] && (dataExtent[0] = value);
      value > dataExtent[1] && (dataExtent[1] = value);
    });
  }
  return {
    sum: sum2,
    dataExtent
  };
}
function worst(row, rowFixedLength, ratio) {
  var areaMax = 0;
  var areaMin = Infinity;
  for (var i = 0, area = void 0, len2 = row.length; i < len2; i++) {
    area = row[i].getLayout().area;
    if (area) {
      area < areaMin && (areaMin = area);
      area > areaMax && (areaMax = area);
    }
  }
  var squareArea = row.area * row.area;
  var f2 = rowFixedLength * rowFixedLength * ratio;
  return squareArea ? mathMax$3(f2 * areaMax / squareArea, squareArea / (f2 * areaMin)) : Infinity;
}
function position(row, rowFixedLength, rect, halfGapWidth, flush) {
  var idx0WhenH = rowFixedLength === rect.width ? 0 : 1;
  var idx1WhenH = 1 - idx0WhenH;
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  var last = rect[xy[idx0WhenH]];
  var rowOtherLength = rowFixedLength ? row.area / rowFixedLength : 0;
  if (flush || rowOtherLength > rect[wh[idx1WhenH]]) {
    rowOtherLength = rect[wh[idx1WhenH]];
  }
  for (var i = 0, rowLen = row.length; i < rowLen; i++) {
    var node = row[i];
    var nodeLayout = {};
    var step = rowOtherLength ? node.getLayout().area / rowOtherLength : 0;
    var wh1 = nodeLayout[wh[idx1WhenH]] = mathMax$3(rowOtherLength - 2 * halfGapWidth, 0);
    var remain = rect[xy[idx0WhenH]] + rect[wh[idx0WhenH]] - last;
    var modWH = i === rowLen - 1 || remain < step ? remain : step;
    var wh0 = nodeLayout[wh[idx0WhenH]] = mathMax$3(modWH - 2 * halfGapWidth, 0);
    nodeLayout[xy[idx1WhenH]] = rect[xy[idx1WhenH]] + mathMin$3(halfGapWidth, wh1 / 2);
    nodeLayout[xy[idx0WhenH]] = last + mathMin$3(halfGapWidth, wh0 / 2);
    last += modWH;
    node.setLayout(nodeLayout, true);
  }
  rect[xy[idx1WhenH]] += rowOtherLength;
  rect[wh[idx1WhenH]] -= rowOtherLength;
}
function estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) {
  var currNode = (targetInfo || {}).node;
  var defaultSize = [containerWidth, containerHeight];
  if (!currNode || currNode === viewRoot) {
    return defaultSize;
  }
  var parent;
  var viewArea = containerWidth * containerHeight;
  var area = viewArea * seriesModel.option.zoomToNodeRatio;
  while (parent = currNode.parentNode) {
    var sum2 = 0;
    var siblings = parent.children;
    for (var i = 0, len2 = siblings.length; i < len2; i++) {
      sum2 += siblings[i].getValue();
    }
    var currNodeValue = currNode.getValue();
    if (currNodeValue === 0) {
      return defaultSize;
    }
    area *= sum2 / currNodeValue;
    var parentModel = parent.getModel();
    var borderWidth = parentModel.get(PATH_BORDER_WIDTH);
    var upperHeight = Math.max(borderWidth, getUpperLabelHeight(parentModel));
    area += 4 * borderWidth * borderWidth + (3 * borderWidth + upperHeight) * Math.pow(area, 0.5);
    area > MAX_SAFE_INTEGER && (area = MAX_SAFE_INTEGER);
    currNode = parent;
  }
  area < viewArea && (area = viewArea);
  var scale2 = Math.pow(area / viewArea, 0.5);
  return [containerWidth * scale2, containerHeight * scale2];
}
function calculateRootPosition(layoutInfo, rootRect, targetInfo) {
  if (rootRect) {
    return {
      x: rootRect.x,
      y: rootRect.y
    };
  }
  var defaultPosition = {
    x: 0,
    y: 0
  };
  if (!targetInfo) {
    return defaultPosition;
  }
  var targetNode = targetInfo.node;
  var layout2 = targetNode.getLayout();
  if (!layout2) {
    return defaultPosition;
  }
  var targetCenter = [layout2.width / 2, layout2.height / 2];
  var node = targetNode;
  while (node) {
    var nodeLayout = node.getLayout();
    targetCenter[0] += nodeLayout.x;
    targetCenter[1] += nodeLayout.y;
    node = node.parentNode;
  }
  return {
    x: layoutInfo.width / 2 - targetCenter[0],
    y: layoutInfo.height / 2 - targetCenter[1]
  };
}
function prunning(node, clipRect, viewAbovePath, viewRoot, depth) {
  var nodeLayout = node.getLayout();
  var nodeInViewAbovePath = viewAbovePath[depth];
  var isAboveViewRoot = nodeInViewAbovePath && nodeInViewAbovePath === node;
  if (nodeInViewAbovePath && !isAboveViewRoot || depth === viewAbovePath.length && node !== viewRoot) {
    return;
  }
  node.setLayout({
    isInView: true,
    invisible: !isAboveViewRoot && !clipRect.intersect(nodeLayout),
    isAboveViewRoot
  }, true);
  var childClipRect = new BoundingRect$1(clipRect.x - nodeLayout.x, clipRect.y - nodeLayout.y, clipRect.width, clipRect.height);
  each$b(node.viewChildren || [], function(child) {
    prunning(child, childClipRect, viewAbovePath, viewRoot, depth + 1);
  });
}
function getUpperLabelHeight(model) {
  return model.get(PATH_UPPER_LABEL_SHOW) ? model.get(PATH_UPPER_LABEL_HEIGHT) : 0;
}
function install$G(registers) {
  registers.registerSeriesModel(TreemapSeriesModel$1);
  registers.registerChartView(TreemapView$1);
  registers.registerVisual(treemapVisual);
  registers.registerLayout(treemapLayout);
  installTreemapAction(registers);
}
function categoryFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (!legendModels || !legendModels.length) {
    return;
  }
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var categoriesData = graphSeries.getCategoriesData();
    var graph = graphSeries.getGraph();
    var data = graph.data;
    var categoryNames = categoriesData.mapArray(categoriesData.getName);
    data.filterSelf(function(idx) {
      var model = data.getItemModel(idx);
      var category = model.getShallow("category");
      if (category != null) {
        if (isNumber(category)) {
          category = categoryNames[category];
        }
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(category)) {
            return false;
          }
        }
      }
      return true;
    });
  });
}
function categoryVisual(ecModel) {
  var paletteScope = {};
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var categoriesData = seriesModel.getCategoriesData();
    var data = seriesModel.getData();
    var categoryNameIdxMap = {};
    categoriesData.each(function(idx) {
      var name = categoriesData.getName(idx);
      categoryNameIdxMap["ec-" + name] = idx;
      var itemModel = categoriesData.getItemModel(idx);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = seriesModel.getColorFromPalette(name, paletteScope);
      }
      categoriesData.setItemVisual(idx, "style", style);
      var symbolVisualList = ["symbol", "symbolSize", "symbolKeepAspect"];
      for (var i = 0; i < symbolVisualList.length; i++) {
        var symbolVisual = itemModel.getShallow(symbolVisualList[i], true);
        if (symbolVisual != null) {
          categoriesData.setItemVisual(idx, symbolVisualList[i], symbolVisual);
        }
      }
    });
    if (categoriesData.count()) {
      data.each(function(idx) {
        var model = data.getItemModel(idx);
        var categoryIdx = model.getShallow("category");
        if (categoryIdx != null) {
          if (isString(categoryIdx)) {
            categoryIdx = categoryNameIdxMap["ec-" + categoryIdx];
          }
          var categoryStyle = categoriesData.getItemVisual(categoryIdx, "style");
          var style = data.ensureUniqueItemVisual(idx, "style");
          extend(style, categoryStyle);
          var visualList = ["symbol", "symbolSize", "symbolKeepAspect"];
          for (var i = 0; i < visualList.length; i++) {
            data.setItemVisual(idx, visualList[i], categoriesData.getItemVisual(categoryIdx, visualList[i]));
          }
        }
      });
    }
  });
}
function normalize$2(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
function graphEdgeVisual(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var edgeData = seriesModel.getEdgeData();
    var symbolType = normalize$2(seriesModel.get("edgeSymbol"));
    var symbolSize = normalize$2(seriesModel.get("edgeSymbolSize"));
    edgeData.setVisual("fromSymbol", symbolType && symbolType[0]);
    edgeData.setVisual("toSymbol", symbolType && symbolType[1]);
    edgeData.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    edgeData.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    edgeData.setVisual("style", seriesModel.getModel("lineStyle").getLineStyle());
    edgeData.each(function(idx) {
      var itemModel = edgeData.getItemModel(idx);
      var edge = graph.getEdgeByIndex(idx);
      var symbolType2 = normalize$2(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$2(itemModel.getShallow("symbolSize", true));
      var style = itemModel.getModel("lineStyle").getLineStyle();
      var existsStyle = edgeData.ensureUniqueItemVisual(idx, "style");
      extend(existsStyle, style);
      switch (existsStyle.stroke) {
        case "source": {
          var nodeStyle = edge.node1.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
        case "target": {
          var nodeStyle = edge.node2.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
      }
      symbolType2[0] && edge.setVisual("fromSymbol", symbolType2[0]);
      symbolType2[1] && edge.setVisual("toSymbol", symbolType2[1]);
      symbolSize2[0] && edge.setVisual("fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && edge.setVisual("toSymbolSize", symbolSize2[1]);
    });
  });
}
var KEY_DELIMITER = "-->";
var getAutoCurvenessParams = function(seriesModel) {
  return seriesModel.get("autoCurveness") || null;
};
var createCurveness = function(seriesModel, appendLength) {
  var autoCurvenessParmas = getAutoCurvenessParams(seriesModel);
  var length = 20;
  var curvenessList = [];
  if (isNumber(autoCurvenessParmas)) {
    length = autoCurvenessParmas;
  } else if (isArray$1(autoCurvenessParmas)) {
    seriesModel.__curvenessList = autoCurvenessParmas;
    return;
  }
  if (appendLength > length) {
    length = appendLength;
  }
  var len2 = length % 2 ? length + 2 : length + 3;
  curvenessList = [];
  for (var i = 0; i < len2; i++) {
    curvenessList.push((i % 2 ? i + 1 : i) / 10 * (i % 2 ? -1 : 1));
  }
  seriesModel.__curvenessList = curvenessList;
};
var getKeyOfEdges = function(n1, n2, seriesModel) {
  var source = [n1.id, n1.dataIndex].join(".");
  var target = [n2.id, n2.dataIndex].join(".");
  return [seriesModel.uid, source, target].join(KEY_DELIMITER);
};
var getOppositeKey = function(key) {
  var keys2 = key.split(KEY_DELIMITER);
  return [keys2[0], keys2[2], keys2[1]].join(KEY_DELIMITER);
};
var getEdgeFromMap = function(edge, seriesModel) {
  var key = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  return seriesModel.__edgeMap[key];
};
var getTotalLengthBetweenNodes = function(edge, seriesModel) {
  var len2 = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node1, edge.node2, seriesModel), seriesModel);
  var lenV = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node2, edge.node1, seriesModel), seriesModel);
  return len2 + lenV;
};
var getEdgeMapLengthWithKey = function(key, seriesModel) {
  var edgeMap = seriesModel.__edgeMap;
  return edgeMap[key] ? edgeMap[key].length : 0;
};
function initCurvenessList(seriesModel) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  seriesModel.__curvenessList = [];
  seriesModel.__edgeMap = {};
  createCurveness(seriesModel);
}
function createEdgeMapForCurveness(n1, n2, seriesModel, index2) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  var key = getKeyOfEdges(n1, n2, seriesModel);
  var edgeMap = seriesModel.__edgeMap;
  var oppositeEdges = edgeMap[getOppositeKey(key)];
  if (edgeMap[key] && !oppositeEdges) {
    edgeMap[key].isForward = true;
  } else if (oppositeEdges && edgeMap[key]) {
    oppositeEdges.isForward = true;
    edgeMap[key].isForward = false;
  }
  edgeMap[key] = edgeMap[key] || [];
  edgeMap[key].push(index2);
}
function getCurvenessForEdge(edge, seriesModel, index2, needReverse) {
  var autoCurvenessParams = getAutoCurvenessParams(seriesModel);
  var isArrayParam = isArray$1(autoCurvenessParams);
  if (!autoCurvenessParams) {
    return null;
  }
  var edgeArray = getEdgeFromMap(edge, seriesModel);
  if (!edgeArray) {
    return null;
  }
  var edgeIndex = -1;
  for (var i = 0; i < edgeArray.length; i++) {
    if (edgeArray[i] === index2) {
      edgeIndex = i;
      break;
    }
  }
  var totalLen = getTotalLengthBetweenNodes(edge, seriesModel);
  createCurveness(seriesModel, totalLen);
  edge.lineStyle = edge.lineStyle || {};
  var curKey = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  var curvenessList = seriesModel.__curvenessList;
  var parityCorrection = isArrayParam ? 0 : totalLen % 2 ? 0 : 1;
  if (!edgeArray.isForward) {
    var oppositeKey = getOppositeKey(curKey);
    var len2 = getEdgeMapLengthWithKey(oppositeKey, seriesModel);
    var resValue = curvenessList[edgeIndex + len2 + parityCorrection];
    if (needReverse) {
      if (isArrayParam) {
        if (autoCurvenessParams && autoCurvenessParams[0] === 0) {
          return (len2 + parityCorrection) % 2 ? resValue : -resValue;
        } else {
          return ((len2 % 2 ? 0 : 1) + parityCorrection) % 2 ? resValue : -resValue;
        }
      } else {
        return (len2 + parityCorrection) % 2 ? resValue : -resValue;
      }
    } else {
      return curvenessList[edgeIndex + len2 + parityCorrection];
    }
  } else {
    return curvenessList[parityCorrection + edgeIndex];
  }
}
function simpleLayout(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var graph = seriesModel.getGraph();
  graph.eachNode(function(node) {
    var model = node.getModel();
    node.setLayout([+model.get("x"), +model.get("y")]);
  });
  simpleLayoutEdge(graph, seriesModel);
}
function simpleLayoutEdge(graph, seriesModel) {
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, seriesModel, index2, true), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var points2 = [p1, p2];
    if (+curveness) {
      points2.push([(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * curveness]);
    }
    edge.setLayout(points2);
  });
}
function graphSimpleLayout(ecModel, api) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var layout2 = seriesModel.get("layout");
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      var data_1 = seriesModel.getData();
      var dimensions_1 = [];
      each$f(coordSys.dimensions, function(coordDim) {
        dimensions_1 = dimensions_1.concat(data_1.mapDimensionsAll(coordDim));
      });
      for (var dataIndex = 0; dataIndex < data_1.count(); dataIndex++) {
        var value = [];
        var hasValue = false;
        for (var i = 0; i < dimensions_1.length; i++) {
          var val = data_1.get(dimensions_1[i], dataIndex);
          if (!isNaN(val)) {
            hasValue = true;
          }
          value.push(val);
        }
        if (hasValue) {
          data_1.setItemLayout(dataIndex, coordSys.dataToPoint(value));
        } else {
          data_1.setItemLayout(dataIndex, [NaN, NaN]);
        }
      }
      simpleLayoutEdge(data_1.graph, seriesModel);
    } else if (!layout2 || layout2 === "none") {
      simpleLayout(seriesModel);
    }
  });
}
function getNodeGlobalScale(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys.type !== "view") {
    return 1;
  }
  var nodeScaleRatio = seriesModel.option.nodeScaleRatio;
  var groupZoom = coordSys.scaleX;
  var roamZoom = coordSys.getZoom();
  var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
  return nodeScale / groupZoom;
}
function getSymbolSize(node) {
  var symbolSize = node.getVisual("symbolSize");
  if (symbolSize instanceof Array) {
    symbolSize = (symbolSize[0] + symbolSize[1]) / 2;
  }
  return +symbolSize;
}
var PI$2 = Math.PI;
var _symbolRadiansHalf = [];
function circularLayout(seriesModel, basedOn) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var rect = coordSys.getBoundingRect();
  var nodeData = seriesModel.getData();
  var graph = nodeData.graph;
  var cx = rect.width / 2 + rect.x;
  var cy = rect.height / 2 + rect.y;
  var r2 = Math.min(rect.width, rect.height) / 2;
  var count2 = nodeData.count();
  nodeData.setLayout({
    cx,
    cy
  });
  if (!count2) {
    return;
  }
  _layoutNodesBasedOn[basedOn](seriesModel, graph, nodeData, r2, cx, cy, count2);
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), getCurvenessForEdge(edge, seriesModel, index2), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var cp1;
    var x12 = (p1[0] + p2[0]) / 2;
    var y12 = (p1[1] + p2[1]) / 2;
    if (+curveness) {
      curveness *= 3;
      cp1 = [cx * curveness + x12 * (1 - curveness), cy * curveness + y12 * (1 - curveness)];
    }
    edge.setLayout([p1, p2, cp1]);
  });
}
var _layoutNodesBasedOn = {
  value: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var angle = 0;
    var sum2 = nodeData.getSum("value");
    var unitAngle = Math.PI * 2 / (sum2 || count2);
    graph.eachNode(function(node) {
      var value = node.getValue("value");
      var radianHalf = unitAngle * (sum2 ? value : 1) / 2;
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  },
  symbolSize: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var sumRadian = 0;
    _symbolRadiansHalf.length = count2;
    var nodeScale = getNodeGlobalScale(seriesModel);
    graph.eachNode(function(node) {
      var symbolSize = getSymbolSize(node);
      isNaN(symbolSize) && (symbolSize = 2);
      symbolSize < 0 && (symbolSize = 0);
      symbolSize *= nodeScale;
      var symbolRadianHalf = Math.asin(symbolSize / 2 / r2);
      isNaN(symbolRadianHalf) && (symbolRadianHalf = PI$2 / 2);
      _symbolRadiansHalf[node.dataIndex] = symbolRadianHalf;
      sumRadian += symbolRadianHalf * 2;
    });
    var halfRemainRadian = (2 * PI$2 - sumRadian) / count2 / 2;
    var angle = 0;
    graph.eachNode(function(node) {
      var radianHalf = halfRemainRadian + _symbolRadiansHalf[node.dataIndex];
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  }
};
function graphCircularLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    if (seriesModel.get("layout") === "circular") {
      circularLayout(seriesModel, "symbolSize");
    }
  });
}
var scaleAndAdd = scaleAndAdd$1;
function forceLayout(inNodes, inEdges, opts) {
  var nodes = inNodes;
  var edges = inEdges;
  var rect = opts.rect;
  var width = rect.width;
  var height = rect.height;
  var center2 = [rect.x + width / 2, rect.y + height / 2];
  var gravity = opts.gravity == null ? 0.1 : opts.gravity;
  for (var i = 0; i < nodes.length; i++) {
    var n2 = nodes[i];
    if (!n2.p) {
      n2.p = create$2(width * (Math.random() - 0.5) + center2[0], height * (Math.random() - 0.5) + center2[1]);
    }
    n2.pp = clone$3(n2.p);
    n2.edges = null;
  }
  var initialFriction = opts.friction == null ? 0.6 : opts.friction;
  var friction = initialFriction;
  var beforeStepCallback;
  var afterStepCallback;
  return {
    warmUp: function() {
      friction = initialFriction * 0.8;
    },
    setFixed: function(idx) {
      nodes[idx].fixed = true;
    },
    setUnfixed: function(idx) {
      nodes[idx].fixed = false;
    },
    beforeStep: function(cb) {
      beforeStepCallback = cb;
    },
    afterStep: function(cb) {
      afterStepCallback = cb;
    },
    step: function(cb) {
      beforeStepCallback && beforeStepCallback(nodes, edges);
      var v12 = [];
      var nLen = nodes.length;
      for (var i2 = 0; i2 < edges.length; i2++) {
        var e2 = edges[i2];
        if (e2.ignoreForceLayout) {
          continue;
        }
        var n1 = e2.n1;
        var n22 = e2.n2;
        sub(v12, n22.p, n1.p);
        var d2 = len(v12) - e2.d;
        var w2 = n22.w / (n1.w + n22.w);
        if (isNaN(w2)) {
          w2 = 0;
        }
        normalize$4(v12, v12);
        !n1.fixed && scaleAndAdd(n1.p, n1.p, v12, w2 * d2 * friction);
        !n22.fixed && scaleAndAdd(n22.p, n22.p, v12, -(1 - w2) * d2 * friction);
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v12, center2, n3.p);
          scaleAndAdd(n3.p, n3.p, v12, gravity * friction);
        }
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n1 = nodes[i2];
        for (var j = i2 + 1; j < nLen; j++) {
          var n22 = nodes[j];
          sub(v12, n22.p, n1.p);
          var d2 = len(v12);
          if (d2 === 0) {
            set$2(v12, Math.random() - 0.5, Math.random() - 0.5);
            d2 = 1;
          }
          var repFact = (n1.rep + n22.rep) / d2 / d2;
          !n1.fixed && scaleAndAdd(n1.pp, n1.pp, v12, repFact);
          !n22.fixed && scaleAndAdd(n22.pp, n22.pp, v12, -repFact);
        }
      }
      var v4 = [];
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v4, n3.p, n3.pp);
          scaleAndAdd(n3.p, n3.p, v4, friction);
          copy$1(n3.pp, n3.p);
        }
      }
      friction = friction * 0.992;
      var finished = friction < 0.01;
      afterStepCallback && afterStepCallback(nodes, edges, finished);
      cb && cb(finished);
    }
  };
}
function graphForceLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var coordSys = graphSeries.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      return;
    }
    if (graphSeries.get("layout") === "force") {
      var preservedPoints_1 = graphSeries.preservedPoints || {};
      var graph_1 = graphSeries.getGraph();
      var nodeData_1 = graph_1.data;
      var edgeData = graph_1.edgeData;
      var forceModel = graphSeries.getModel("force");
      var initLayout = forceModel.get("initLayout");
      if (graphSeries.preservedPoints) {
        nodeData_1.each(function(idx) {
          var id2 = nodeData_1.getId(idx);
          nodeData_1.setItemLayout(idx, preservedPoints_1[id2] || [NaN, NaN]);
        });
      } else if (!initLayout || initLayout === "none") {
        simpleLayout(graphSeries);
      } else if (initLayout === "circular") {
        circularLayout(graphSeries, "value");
      }
      var nodeDataExtent_1 = nodeData_1.getDataExtent("value");
      var edgeDataExtent_1 = edgeData.getDataExtent("value");
      var repulsion = forceModel.get("repulsion");
      var edgeLength = forceModel.get("edgeLength");
      var repulsionArr_1 = isArray$1(repulsion) ? repulsion : [repulsion, repulsion];
      var edgeLengthArr_1 = isArray$1(edgeLength) ? edgeLength : [edgeLength, edgeLength];
      edgeLengthArr_1 = [edgeLengthArr_1[1], edgeLengthArr_1[0]];
      var nodes_1 = nodeData_1.mapArray("value", function(value, idx) {
        var point = nodeData_1.getItemLayout(idx);
        var rep = linearMap$2(value, nodeDataExtent_1, repulsionArr_1);
        if (isNaN(rep)) {
          rep = (repulsionArr_1[0] + repulsionArr_1[1]) / 2;
        }
        return {
          w: rep,
          rep,
          fixed: nodeData_1.getItemModel(idx).get("fixed"),
          p: !point || isNaN(point[0]) || isNaN(point[1]) ? null : point
        };
      });
      var edges = edgeData.mapArray("value", function(value, idx) {
        var edge = graph_1.getEdgeByIndex(idx);
        var d2 = linearMap$2(value, edgeDataExtent_1, edgeLengthArr_1);
        if (isNaN(d2)) {
          d2 = (edgeLengthArr_1[0] + edgeLengthArr_1[1]) / 2;
        }
        var edgeModel = edge.getModel();
        var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, graphSeries, idx, true), 0);
        return {
          n1: nodes_1[edge.node1.dataIndex],
          n2: nodes_1[edge.node2.dataIndex],
          d: d2,
          curveness,
          ignoreForceLayout: edgeModel.get("ignoreForceLayout")
        };
      });
      var rect = coordSys.getBoundingRect();
      var forceInstance = forceLayout(nodes_1, edges, {
        rect,
        gravity: forceModel.get("gravity"),
        friction: forceModel.get("friction")
      });
      forceInstance.beforeStep(function(nodes, edges2) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (nodes[i].fixed) {
            copy$1(nodes[i].p, graph_1.getNodeByIndex(i).getLayout());
          }
        }
      });
      forceInstance.afterStep(function(nodes, edges2, stopped) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (!nodes[i].fixed) {
            graph_1.getNodeByIndex(i).setLayout(nodes[i].p);
          }
          preservedPoints_1[nodeData_1.getId(i)] = nodes[i].p;
        }
        for (var i = 0, l2 = edges2.length; i < l2; i++) {
          var e2 = edges2[i];
          var edge = graph_1.getEdgeByIndex(i);
          var p1 = e2.n1.p;
          var p2 = e2.n2.p;
          var points2 = edge.getLayout();
          points2 = points2 ? points2.slice() : [];
          points2[0] = points2[0] || [];
          points2[1] = points2[1] || [];
          copy$1(points2[0], p1);
          copy$1(points2[1], p2);
          if (+e2.curveness) {
            points2[2] = [(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * e2.curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * e2.curveness];
          }
          edge.setLayout(points2);
        }
      });
      graphSeries.forceLayout = forceInstance;
      graphSeries.preservedPoints = preservedPoints_1;
      forceInstance.step();
    } else {
      graphSeries.forceLayout = null;
    }
  });
}
function getViewRect$3(seriesModel, api, aspect) {
  var option = extend(seriesModel.getBoxLayoutParams(), {
    aspect
  });
  return getLayoutRect(option, {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function createViewCoordSys(ecModel, api) {
  var viewList = [];
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var coordSysType = seriesModel.get("coordinateSystem");
    if (!coordSysType || coordSysType === "view") {
      var data_1 = seriesModel.getData();
      var positions = data_1.mapArray(function(idx) {
        var itemModel = data_1.getItemModel(idx);
        return [+itemModel.get("x"), +itemModel.get("y")];
      });
      var min3 = [];
      var max3 = [];
      fromPoints(positions, min3, max3);
      if (max3[0] - min3[0] === 0) {
        max3[0] += 1;
        min3[0] -= 1;
      }
      if (max3[1] - min3[1] === 0) {
        max3[1] += 1;
        min3[1] -= 1;
      }
      var aspect = (max3[0] - min3[0]) / (max3[1] - min3[1]);
      var viewRect2 = getViewRect$3(seriesModel, api, aspect);
      if (isNaN(aspect)) {
        min3 = [viewRect2.x, viewRect2.y];
        max3 = [viewRect2.x + viewRect2.width, viewRect2.y + viewRect2.height];
      }
      var bbWidth = max3[0] - min3[0];
      var bbHeight = max3[1] - min3[1];
      var viewWidth = viewRect2.width;
      var viewHeight = viewRect2.height;
      var viewCoordSys = seriesModel.coordinateSystem = new View$1();
      viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
      viewCoordSys.setBoundingRect(min3[0], min3[1], bbWidth, bbHeight);
      viewCoordSys.setViewRect(viewRect2.x, viewRect2.y, viewWidth, viewHeight);
      viewCoordSys.setCenter(seriesModel.get("center"));
      viewCoordSys.setZoom(seriesModel.get("zoom"));
      viewList.push(viewCoordSys);
    }
  });
  return viewList;
}
var straightLineProto = Line$3.prototype;
var bezierCurveProto = BezierCurve$1.prototype;
var StraightLineShape = function() {
  function StraightLineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return StraightLineShape2;
}();
(function(_super) {
  __extends(CurveShape, _super);
  function CurveShape() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return CurveShape;
})(StraightLineShape);
function isStraightLine(shape) {
  return isNaN(+shape.cpx1) || isNaN(+shape.cpy1);
}
var ECLinePath = function(_super) {
  __extends(ECLinePath2, _super);
  function ECLinePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-line";
    return _this;
  }
  ECLinePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECLinePath2.prototype.getDefaultShape = function() {
    return new StraightLineShape();
  };
  ECLinePath2.prototype.buildPath = function(ctx, shape) {
    if (isStraightLine(shape)) {
      straightLineProto.buildPath.call(this, ctx, shape);
    } else {
      bezierCurveProto.buildPath.call(this, ctx, shape);
    }
  };
  ECLinePath2.prototype.pointAt = function(t2) {
    if (isStraightLine(this.shape)) {
      return straightLineProto.pointAt.call(this, t2);
    } else {
      return bezierCurveProto.pointAt.call(this, t2);
    }
  };
  ECLinePath2.prototype.tangentAt = function(t2) {
    var shape = this.shape;
    var p2 = isStraightLine(shape) ? [shape.x2 - shape.x1, shape.y2 - shape.y1] : bezierCurveProto.tangentAt.call(this, t2);
    return normalize$4(p2, p2);
  };
  return ECLinePath2;
}(Path$1);
var ECLinePath$1 = ECLinePath;
var SYMBOL_CATEGORIES = ["fromSymbol", "toSymbol"];
function makeSymbolTypeKey(symbolCategory) {
  return "_" + symbolCategory + "Type";
}
function createSymbol(name, lineData, idx) {
  var symbolType = lineData.getItemVisual(idx, name);
  if (!symbolType || symbolType === "none") {
    return;
  }
  var symbolSize = lineData.getItemVisual(idx, name + "Size");
  var symbolRotate = lineData.getItemVisual(idx, name + "Rotate");
  var symbolOffset = lineData.getItemVisual(idx, name + "Offset");
  var symbolKeepAspect = lineData.getItemVisual(idx, name + "KeepAspect");
  var symbolSizeArr = normalizeSymbolSize(symbolSize);
  var symbolOffsetArr = normalizeSymbolOffset(symbolOffset || 0, symbolSizeArr);
  var symbolPath = createSymbol$1(symbolType, -symbolSizeArr[0] / 2 + symbolOffsetArr[0], -symbolSizeArr[1] / 2 + symbolOffsetArr[1], symbolSizeArr[0], symbolSizeArr[1], null, symbolKeepAspect);
  symbolPath.__specifiedRotation = symbolRotate == null || isNaN(symbolRotate) ? void 0 : +symbolRotate * Math.PI / 180 || 0;
  symbolPath.name = name;
  return symbolPath;
}
function createLine(points2) {
  var line = new ECLinePath$1({
    name: "line",
    subPixelOptimize: true
  });
  setLinePoints(line.shape, points2);
  return line;
}
function setLinePoints(targetShape, points2) {
  targetShape.x1 = points2[0][0];
  targetShape.y1 = points2[0][1];
  targetShape.x2 = points2[1][0];
  targetShape.y2 = points2[1][1];
  targetShape.percent = 1;
  var cp1 = points2[2];
  if (cp1) {
    targetShape.cpx1 = cp1[0];
    targetShape.cpy1 = cp1[1];
  } else {
    targetShape.cpx1 = NaN;
    targetShape.cpy1 = NaN;
  }
}
var Line = function(_super) {
  __extends(Line2, _super);
  function Line2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createLine(lineData, idx, seriesScope);
    return _this;
  }
  Line2.prototype._createLine = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var linePoints = lineData.getItemLayout(idx);
    var line = createLine(linePoints);
    line.shape.percent = 0;
    initProps(line, {
      shape: {
        percent: 1
      }
    }, seriesModel, idx);
    this.add(line);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = createSymbol(symbolCategory, lineData, idx);
      this.add(symbol);
      this[makeSymbolTypeKey(symbolCategory)] = lineData.getItemVisual(idx, symbolCategory);
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var linePoints = lineData.getItemLayout(idx);
    var target = {
      shape: {}
    };
    setLinePoints(target.shape, linePoints);
    updateProps$1(line, target, seriesModel, idx);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbolType = lineData.getItemVisual(idx, symbolCategory);
      var key = makeSymbolTypeKey(symbolCategory);
      if (this[key] !== symbolType) {
        this.remove(this.childOfName(symbolCategory));
        var symbol = createSymbol(symbolCategory, lineData, idx);
        this.add(symbol);
      }
      this[key] = symbolType;
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.getLinePath = function() {
    return this.childAt(0);
  };
  Line2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var blurLineStyle = seriesScope && seriesScope.blurLineStyle;
    var selectLineStyle = seriesScope && seriesScope.selectLineStyle;
    var labelStatesModels = seriesScope && seriesScope.labelStatesModels;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    if (!seriesScope || lineData.hasItemOption) {
      var itemModel = lineData.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      blurLineStyle = itemModel.getModel(["blur", "lineStyle"]).getLineStyle();
      selectLineStyle = itemModel.getModel(["select", "lineStyle"]).getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      labelStatesModels = getLabelStatesModels(itemModel);
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var visualColor = lineStyle.stroke;
    line.useStyle(lineStyle);
    line.style.fill = null;
    line.style.strokeNoScale = true;
    line.ensureState("emphasis").style = emphasisLineStyle;
    line.ensureState("blur").style = blurLineStyle;
    line.ensureState("select").style = selectLineStyle;
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = this.childOfName(symbolCategory);
      if (symbol) {
        symbol.setColor(visualColor);
        symbol.style.opacity = lineStyle.opacity;
        for (var i = 0; i < SPECIAL_STATES.length; i++) {
          var stateName = SPECIAL_STATES[i];
          var lineState = line.getState(stateName);
          if (lineState) {
            var lineStateStyle = lineState.style || {};
            var state = symbol.ensureState(stateName);
            var stateStyle = state.style || (state.style = {});
            if (lineStateStyle.stroke != null) {
              stateStyle[symbol.__isEmptyBrush ? "stroke" : "fill"] = lineStateStyle.stroke;
            }
            if (lineStateStyle.opacity != null) {
              stateStyle.opacity = lineStateStyle.opacity;
            }
          }
        }
        symbol.markRedraw();
      }
    }, this);
    var rawVal = seriesModel.getRawValue(idx);
    setLabelStyle(this, labelStatesModels, {
      labelDataIndex: idx,
      labelFetcher: {
        getFormattedLabel: function(dataIndex, stateName) {
          return seriesModel.getFormattedLabel(dataIndex, stateName, lineData.dataType);
        }
      },
      inheritColor: visualColor || "#000",
      defaultOpacity: lineStyle.opacity,
      defaultText: (rawVal == null ? lineData.getName(idx) : isFinite(rawVal) ? round$3(rawVal) : rawVal) + ""
    });
    var label = this.getTextContent();
    if (label) {
      var labelNormalModel = labelStatesModels.normal;
      label.__align = label.style.align;
      label.__verticalAlign = label.style.verticalAlign;
      label.__position = labelNormalModel.get("position") || "middle";
      var distance2 = labelNormalModel.get("distance");
      if (!isArray$1(distance2)) {
        distance2 = [distance2, distance2];
      }
      label.__labelDistance = distance2;
    }
    this.setTextConfig({
      position: null,
      local: true,
      inside: false
    });
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Line2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  Line2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  Line2.prototype.updateLayout = function(lineData, idx) {
    this.setLinePoints(lineData.getItemLayout(idx));
  };
  Line2.prototype.setLinePoints = function(points2) {
    var linePath = this.childOfName("line");
    setLinePoints(linePath.shape, points2);
    linePath.dirty();
  };
  Line2.prototype.beforeUpdate = function() {
    var lineGroup = this;
    var symbolFrom = lineGroup.childOfName("fromSymbol");
    var symbolTo = lineGroup.childOfName("toSymbol");
    var label = lineGroup.getTextContent();
    if (!symbolFrom && !symbolTo && (!label || label.ignore)) {
      return;
    }
    var invScale = 1;
    var parentNode2 = this.parent;
    while (parentNode2) {
      if (parentNode2.scaleX) {
        invScale /= parentNode2.scaleX;
      }
      parentNode2 = parentNode2.parent;
    }
    var line = lineGroup.childOfName("line");
    if (!this.__dirty && !line.__dirty) {
      return;
    }
    var percent = line.shape.percent;
    var fromPos = line.pointAt(0);
    var toPos = line.pointAt(percent);
    var d2 = sub([], toPos, fromPos);
    normalize$4(d2, d2);
    function setSymbolRotation(symbol, percent2) {
      var specifiedRotation = symbol.__specifiedRotation;
      if (specifiedRotation == null) {
        var tangent2 = line.tangentAt(percent2);
        symbol.attr("rotation", (percent2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(tangent2[1], tangent2[0]));
      } else {
        symbol.attr("rotation", specifiedRotation);
      }
    }
    if (symbolFrom) {
      symbolFrom.setPosition(fromPos);
      setSymbolRotation(symbolFrom, 0);
      symbolFrom.scaleX = symbolFrom.scaleY = invScale * percent;
      symbolFrom.markRedraw();
    }
    if (symbolTo) {
      symbolTo.setPosition(toPos);
      setSymbolRotation(symbolTo, 1);
      symbolTo.scaleX = symbolTo.scaleY = invScale * percent;
      symbolTo.markRedraw();
    }
    if (label && !label.ignore) {
      label.x = label.y = 0;
      label.originX = label.originY = 0;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var distance2 = label.__labelDistance;
      var distanceX = distance2[0] * invScale;
      var distanceY = distance2[1] * invScale;
      var halfPercent = percent / 2;
      var tangent = line.tangentAt(halfPercent);
      var n2 = [tangent[1], -tangent[0]];
      var cp = line.pointAt(halfPercent);
      if (n2[1] > 0) {
        n2[0] = -n2[0];
        n2[1] = -n2[1];
      }
      var dir3 = tangent[0] < 0 ? -1 : 1;
      if (label.__position !== "start" && label.__position !== "end") {
        var rotation = -Math.atan2(tangent[1], tangent[0]);
        if (toPos[0] < fromPos[0]) {
          rotation = Math.PI + rotation;
        }
        label.rotation = rotation;
      }
      var dy = void 0;
      switch (label.__position) {
        case "insideStartTop":
        case "insideMiddleTop":
        case "insideEndTop":
        case "middle":
          dy = -distanceY;
          textVerticalAlign = "bottom";
          break;
        case "insideStartBottom":
        case "insideMiddleBottom":
        case "insideEndBottom":
          dy = distanceY;
          textVerticalAlign = "top";
          break;
        default:
          dy = 0;
          textVerticalAlign = "middle";
      }
      switch (label.__position) {
        case "end":
          label.x = d2[0] * distanceX + toPos[0];
          label.y = d2[1] * distanceY + toPos[1];
          textAlign = d2[0] > 0.8 ? "left" : d2[0] < -0.8 ? "right" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "top" : d2[1] < -0.8 ? "bottom" : "middle";
          break;
        case "start":
          label.x = -d2[0] * distanceX + fromPos[0];
          label.y = -d2[1] * distanceY + fromPos[1];
          textAlign = d2[0] > 0.8 ? "right" : d2[0] < -0.8 ? "left" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "bottom" : d2[1] < -0.8 ? "top" : "middle";
          break;
        case "insideStartTop":
        case "insideStart":
        case "insideStartBottom":
          label.x = distanceX * dir3 + fromPos[0];
          label.y = fromPos[1] + dy;
          textAlign = tangent[0] < 0 ? "right" : "left";
          label.originX = -distanceX * dir3;
          label.originY = -dy;
          break;
        case "insideMiddleTop":
        case "insideMiddle":
        case "insideMiddleBottom":
        case "middle":
          label.x = cp[0];
          label.y = cp[1] + dy;
          textAlign = "center";
          label.originY = -dy;
          break;
        case "insideEndTop":
        case "insideEnd":
        case "insideEndBottom":
          label.x = -distanceX * dir3 + toPos[0];
          label.y = toPos[1] + dy;
          textAlign = tangent[0] >= 0 ? "right" : "left";
          label.originX = distanceX * dir3;
          label.originY = -dy;
          break;
      }
      label.scaleX = label.scaleY = invScale;
      label.setStyle({
        verticalAlign: label.__verticalAlign || textVerticalAlign,
        align: label.__align || textAlign
      });
    }
  };
  return Line2;
}(Group$4);
var Line$1 = Line;
var LineDraw = function() {
  function LineDraw2(LineCtor) {
    this.group = new Group$4();
    this._LineCtor = LineCtor || Line$1;
  }
  LineDraw2.prototype.updateData = function(lineData) {
    var _this = this;
    this._progressiveEls = null;
    var lineDraw = this;
    var group = lineDraw.group;
    var oldLineData = lineDraw._lineData;
    lineDraw._lineData = lineData;
    if (!oldLineData) {
      group.removeAll();
    }
    var seriesScope = makeSeriesScope$1(lineData);
    lineData.diff(oldLineData).add(function(idx) {
      _this._doAdd(lineData, idx, seriesScope);
    }).update(function(newIdx, oldIdx) {
      _this._doUpdate(oldLineData, lineData, oldIdx, newIdx, seriesScope);
    }).remove(function(idx) {
      group.remove(oldLineData.getItemGraphicEl(idx));
    }).execute();
  };
  LineDraw2.prototype.updateLayout = function() {
    var lineData = this._lineData;
    if (!lineData) {
      return;
    }
    lineData.eachItemGraphicEl(function(el, idx) {
      el.updateLayout(lineData, idx);
    }, this);
  };
  LineDraw2.prototype.incrementalPrepareUpdate = function(lineData) {
    this._seriesScope = makeSeriesScope$1(lineData);
    this._lineData = null;
    this.group.removeAll();
  };
  LineDraw2.prototype.incrementalUpdate = function(taskParams, lineData) {
    this._progressiveEls = [];
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup && !isEffectObject(el2)) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var itemLayout = lineData.getItemLayout(idx);
      if (lineNeedsDraw(itemLayout)) {
        var el = new this._LineCtor(lineData, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        this.group.add(el);
        lineData.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  LineDraw2.prototype.remove = function() {
    this.group.removeAll();
  };
  LineDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  LineDraw2.prototype._doAdd = function(lineData, idx, seriesScope) {
    var itemLayout = lineData.getItemLayout(idx);
    if (!lineNeedsDraw(itemLayout)) {
      return;
    }
    var el = new this._LineCtor(lineData, idx, seriesScope);
    lineData.setItemGraphicEl(idx, el);
    this.group.add(el);
  };
  LineDraw2.prototype._doUpdate = function(oldLineData, newLineData, oldIdx, newIdx, seriesScope) {
    var itemEl = oldLineData.getItemGraphicEl(oldIdx);
    if (!lineNeedsDraw(newLineData.getItemLayout(newIdx))) {
      this.group.remove(itemEl);
      return;
    }
    if (!itemEl) {
      itemEl = new this._LineCtor(newLineData, newIdx, seriesScope);
    } else {
      itemEl.updateData(newLineData, newIdx, seriesScope);
    }
    newLineData.setItemGraphicEl(newIdx, itemEl);
    this.group.add(itemEl);
  };
  return LineDraw2;
}();
function isEffectObject(el) {
  return el.animators && el.animators.length > 0;
}
function makeSeriesScope$1(lineData) {
  var hostModel = lineData.hostModel;
  var emphasisModel = hostModel.getModel("emphasis");
  return {
    lineStyle: hostModel.getModel("lineStyle").getLineStyle(),
    emphasisLineStyle: emphasisModel.getModel(["lineStyle"]).getLineStyle(),
    blurLineStyle: hostModel.getModel(["blur", "lineStyle"]).getLineStyle(),
    selectLineStyle: hostModel.getModel(["select", "lineStyle"]).getLineStyle(),
    emphasisDisabled: emphasisModel.get("disabled"),
    blurScope: emphasisModel.get("blurScope"),
    focus: emphasisModel.get("focus"),
    labelStatesModels: getLabelStatesModels(hostModel)
  };
}
function isPointNaN(pt) {
  return isNaN(pt[0]) || isNaN(pt[1]);
}
function lineNeedsDraw(pts) {
  return pts && !isPointNaN(pts[0]) && !isPointNaN(pts[1]);
}
var LineDraw$1 = LineDraw;
var v1 = [];
var v2 = [];
var v3 = [];
var quadraticAt = quadraticAt$1;
var v2DistSquare = distSquare;
var mathAbs = Math.abs;
function intersectCurveCircle(curvePoints, center2, radius) {
  var p0 = curvePoints[0];
  var p1 = curvePoints[1];
  var p2 = curvePoints[2];
  var d2 = Infinity;
  var t2;
  var radiusSquare = radius * radius;
  var interval = 0.1;
  for (var _t = 0.1; _t <= 0.9; _t += 0.1) {
    v1[0] = quadraticAt(p0[0], p1[0], p2[0], _t);
    v1[1] = quadraticAt(p0[1], p1[1], p2[1], _t);
    var diff = mathAbs(v2DistSquare(v1, center2) - radiusSquare);
    if (diff < d2) {
      d2 = diff;
      t2 = _t;
    }
  }
  for (var i = 0; i < 32; i++) {
    var next = t2 + interval;
    v2[0] = quadraticAt(p0[0], p1[0], p2[0], t2);
    v2[1] = quadraticAt(p0[1], p1[1], p2[1], t2);
    v3[0] = quadraticAt(p0[0], p1[0], p2[0], next);
    v3[1] = quadraticAt(p0[1], p1[1], p2[1], next);
    var diff = v2DistSquare(v2, center2) - radiusSquare;
    if (mathAbs(diff) < 0.01) {
      break;
    }
    var nextDiff = v2DistSquare(v3, center2) - radiusSquare;
    interval /= 2;
    if (diff < 0) {
      if (nextDiff >= 0) {
        t2 = t2 + interval;
      } else {
        t2 = t2 - interval;
      }
    } else {
      if (nextDiff >= 0) {
        t2 = t2 - interval;
      } else {
        t2 = t2 + interval;
      }
    }
  }
  return t2;
}
function adjustEdge(graph, scale2) {
  var tmp0 = [];
  var quadraticSubdivide$1 = quadraticSubdivide;
  var pts = [[], [], []];
  var pts2 = [[], []];
  var v4 = [];
  scale2 /= 2;
  graph.eachEdge(function(edge, idx) {
    var linePoints = edge.getLayout();
    var fromSymbol = edge.getVisual("fromSymbol");
    var toSymbol = edge.getVisual("toSymbol");
    if (!linePoints.__original) {
      linePoints.__original = [clone$3(linePoints[0]), clone$3(linePoints[1])];
      if (linePoints[2]) {
        linePoints.__original.push(clone$3(linePoints[2]));
      }
    }
    var originalPoints = linePoints.__original;
    if (linePoints[2] != null) {
      copy$1(pts[0], originalPoints[0]);
      copy$1(pts[1], originalPoints[2]);
      copy$1(pts[2], originalPoints[1]);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        var t2 = intersectCurveCircle(pts, originalPoints[0], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[0][0] = tmp0[3];
        pts[1][0] = tmp0[4];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[0][1] = tmp0[3];
        pts[1][1] = tmp0[4];
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        var t2 = intersectCurveCircle(pts, originalPoints[1], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[1][0] = tmp0[1];
        pts[2][0] = tmp0[2];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[1][1] = tmp0[1];
        pts[2][1] = tmp0[2];
      }
      copy$1(linePoints[0], pts[0]);
      copy$1(linePoints[1], pts[2]);
      copy$1(linePoints[2], pts[1]);
    } else {
      copy$1(pts2[0], originalPoints[0]);
      copy$1(pts2[1], originalPoints[1]);
      sub(v4, pts2[1], pts2[0]);
      normalize$4(v4, v4);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        scaleAndAdd$1(pts2[0], pts2[0], v4, symbolSize * scale2);
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        scaleAndAdd$1(pts2[1], pts2[1], v4, -symbolSize * scale2);
      }
      copy$1(linePoints[0], pts2[0]);
      copy$1(linePoints[1], pts2[1]);
    }
  });
}
function isViewCoordSys(coordSys) {
  return coordSys.type === "view";
}
var GraphView = function(_super) {
  __extends(GraphView2, _super);
  function GraphView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphView2.type;
    return _this;
  }
  GraphView2.prototype.init = function(ecModel, api) {
    var symbolDraw = new SymbolDraw$1();
    var lineDraw = new LineDraw$1();
    var group = this.group;
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    group.add(symbolDraw.group);
    group.add(lineDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineDraw = lineDraw;
    this._firstRender = true;
  };
  GraphView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    this._model = seriesModel;
    var symbolDraw = this._symbolDraw;
    var lineDraw = this._lineDraw;
    var group = this.group;
    if (isViewCoordSys(coordSys)) {
      var groupNewProp = {
        x: coordSys.x,
        y: coordSys.y,
        scaleX: coordSys.scaleX,
        scaleY: coordSys.scaleY
      };
      if (this._firstRender) {
        group.attr(groupNewProp);
      } else {
        updateProps$1(group, groupNewProp, seriesModel);
      }
    }
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    var data = seriesModel.getData();
    symbolDraw.updateData(data);
    var edgeData = seriesModel.getEdgeData();
    lineDraw.updateData(edgeData);
    this._updateNodeAndLinkScale();
    this._updateController(seriesModel, ecModel, api);
    clearTimeout(this._layoutTimeout);
    var forceLayout2 = seriesModel.forceLayout;
    var layoutAnimation = seriesModel.get(["force", "layoutAnimation"]);
    if (forceLayout2) {
      this._startForceLayoutIteration(forceLayout2, layoutAnimation);
    }
    data.graph.eachNode(function(node) {
      var idx = node.dataIndex;
      var el = node.getGraphicEl();
      var itemModel = node.getModel();
      if (!el) {
        return;
      }
      el.off("drag").off("dragend");
      var draggable = itemModel.get("draggable");
      if (draggable) {
        el.on("drag", function() {
          if (forceLayout2) {
            forceLayout2.warmUp();
            !_this._layouting && _this._startForceLayoutIteration(forceLayout2, layoutAnimation);
            forceLayout2.setFixed(idx);
            data.setItemLayout(idx, [el.x, el.y]);
          }
        }).on("dragend", function() {
          if (forceLayout2) {
            forceLayout2.setUnfixed(idx);
          }
        });
      }
      el.setDraggable(draggable && !!forceLayout2);
      var focus = itemModel.get(["emphasis", "focus"]);
      if (focus === "adjacency") {
        getECData(el).focus = node.getAdjacentDataIndices();
      }
    });
    data.graph.eachEdge(function(edge) {
      var el = edge.getGraphicEl();
      var focus = edge.getModel().get(["emphasis", "focus"]);
      if (!el) {
        return;
      }
      if (focus === "adjacency") {
        getECData(el).focus = {
          edge: [edge.dataIndex],
          node: [edge.node1.dataIndex, edge.node2.dataIndex]
        };
      }
    });
    var circularRotateLabel = seriesModel.get("layout") === "circular" && seriesModel.get(["circular", "rotateLabel"]);
    var cx = data.getLayout("cx");
    var cy = data.getLayout("cy");
    data.eachItemGraphicEl(function(el, idx) {
      var itemModel = data.getItemModel(idx);
      var labelRotate = itemModel.get(["label", "rotate"]) || 0;
      var symbolPath = el.getSymbolPath();
      if (circularRotateLabel) {
        var pos = data.getItemLayout(idx);
        var rad = Math.atan2(pos[1] - cy, pos[0] - cx);
        if (rad < 0) {
          rad = Math.PI * 2 + rad;
        }
        var isLeft = pos[0] < cx;
        if (isLeft) {
          rad = rad - Math.PI;
        }
        var textPosition = isLeft ? "left" : "right";
        symbolPath.setTextConfig({
          rotation: -rad,
          position: textPosition,
          origin: "center"
        });
        var emphasisState = symbolPath.ensureState("emphasis");
        extend(emphasisState.textConfig || (emphasisState.textConfig = {}), {
          position: textPosition
        });
      } else {
        symbolPath.setTextConfig({
          rotation: labelRotate *= Math.PI / 180
        });
      }
    });
    this._firstRender = false;
  };
  GraphView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  GraphView2.prototype._startForceLayoutIteration = function(forceLayout2, layoutAnimation) {
    var self2 = this;
    (function step() {
      forceLayout2.step(function(stopped) {
        self2.updateLayout(self2._model);
        (self2._layouting = !stopped) && (layoutAnimation ? self2._layoutTimeout = setTimeout(step, 16) : step());
      });
    })();
  };
  GraphView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    if (!isViewCoordSys(seriesModel.coordinateSystem)) {
      controller.disable();
      return;
    }
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale();
      adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
      _this._lineDraw.updateLayout();
      api.updateLabelLayout();
    });
  };
  GraphView2.prototype._updateNodeAndLinkScale = function() {
    var seriesModel = this._model;
    var data = seriesModel.getData();
    var nodeScale = getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el && el.setSymbolScale(nodeScale);
    });
  };
  GraphView2.prototype.updateLayout = function(seriesModel) {
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    this._symbolDraw.updateLayout();
    this._lineDraw.updateLayout();
  };
  GraphView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove();
    this._lineDraw && this._lineDraw.remove();
  };
  GraphView2.type = "graph";
  return GraphView2;
}(ChartView$1);
var GraphView$1 = GraphView;
function generateNodeKey(id2) {
  return "_EC_" + id2;
}
var Graph = function() {
  function Graph2(directed) {
    this.type = "graph";
    this.nodes = [];
    this.edges = [];
    this._nodesMap = {};
    this._edgesMap = {};
    this._directed = directed || false;
  }
  Graph2.prototype.isDirected = function() {
    return this._directed;
  };
  Graph2.prototype.addNode = function(id2, dataIndex) {
    id2 = id2 == null ? "" + dataIndex : "" + id2;
    var nodesMap = this._nodesMap;
    if (nodesMap[generateNodeKey(id2)]) {
      return;
    }
    var node = new GraphNode(id2, dataIndex);
    node.hostGraph = this;
    this.nodes.push(node);
    nodesMap[generateNodeKey(id2)] = node;
    return node;
  };
  Graph2.prototype.getNodeByIndex = function(dataIndex) {
    var rawIdx = this.data.getRawIndex(dataIndex);
    return this.nodes[rawIdx];
  };
  Graph2.prototype.getNodeById = function(id2) {
    return this._nodesMap[generateNodeKey(id2)];
  };
  Graph2.prototype.addEdge = function(n1, n2, dataIndex) {
    var nodesMap = this._nodesMap;
    var edgesMap = this._edgesMap;
    if (isNumber(n1)) {
      n1 = this.nodes[n1];
    }
    if (isNumber(n2)) {
      n2 = this.nodes[n2];
    }
    if (!(n1 instanceof GraphNode)) {
      n1 = nodesMap[generateNodeKey(n1)];
    }
    if (!(n2 instanceof GraphNode)) {
      n2 = nodesMap[generateNodeKey(n2)];
    }
    if (!n1 || !n2) {
      return;
    }
    var key = n1.id + "-" + n2.id;
    var edge = new GraphEdge(n1, n2, dataIndex);
    edge.hostGraph = this;
    if (this._directed) {
      n1.outEdges.push(edge);
      n2.inEdges.push(edge);
    }
    n1.edges.push(edge);
    if (n1 !== n2) {
      n2.edges.push(edge);
    }
    this.edges.push(edge);
    edgesMap[key] = edge;
    return edge;
  };
  Graph2.prototype.getEdgeByIndex = function(dataIndex) {
    var rawIdx = this.edgeData.getRawIndex(dataIndex);
    return this.edges[rawIdx];
  };
  Graph2.prototype.getEdge = function(n1, n2) {
    if (n1 instanceof GraphNode) {
      n1 = n1.id;
    }
    if (n2 instanceof GraphNode) {
      n2 = n2.id;
    }
    var edgesMap = this._edgesMap;
    if (this._directed) {
      return edgesMap[n1 + "-" + n2];
    } else {
      return edgesMap[n1 + "-" + n2] || edgesMap[n2 + "-" + n1];
    }
  };
  Graph2.prototype.eachNode = function(cb, context) {
    var nodes = this.nodes;
    var len2 = nodes.length;
    for (var i = 0; i < len2; i++) {
      if (nodes[i].dataIndex >= 0) {
        cb.call(context, nodes[i], i);
      }
    }
  };
  Graph2.prototype.eachEdge = function(cb, context) {
    var edges = this.edges;
    var len2 = edges.length;
    for (var i = 0; i < len2; i++) {
      if (edges[i].dataIndex >= 0 && edges[i].node1.dataIndex >= 0 && edges[i].node2.dataIndex >= 0) {
        cb.call(context, edges[i], i);
      }
    }
  };
  Graph2.prototype.breadthFirstTraverse = function(cb, startNode, direction, context) {
    if (!(startNode instanceof GraphNode)) {
      startNode = this._nodesMap[generateNodeKey(startNode)];
    }
    if (!startNode) {
      return;
    }
    var edgeType = direction === "out" ? "outEdges" : direction === "in" ? "inEdges" : "edges";
    for (var i = 0; i < this.nodes.length; i++) {
      this.nodes[i].__visited = false;
    }
    if (cb.call(context, startNode, null)) {
      return;
    }
    var queue = [startNode];
    while (queue.length) {
      var currentNode = queue.shift();
      var edges = currentNode[edgeType];
      for (var i = 0; i < edges.length; i++) {
        var e2 = edges[i];
        var otherNode = e2.node1 === currentNode ? e2.node2 : e2.node1;
        if (!otherNode.__visited) {
          if (cb.call(context, otherNode, currentNode)) {
            return;
          }
          queue.push(otherNode);
          otherNode.__visited = true;
        }
      }
    }
  };
  Graph2.prototype.update = function() {
    var data = this.data;
    var edgeData = this.edgeData;
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
    edgeData.filterSelf(function(idx) {
      var edge = edges[edgeData.getRawIndex(idx)];
      return edge.node1.dataIndex >= 0 && edge.node2.dataIndex >= 0;
    });
    for (var i = 0, len2 = edges.length; i < len2; i++) {
      edges[i].dataIndex = -1;
    }
    for (var i = 0, len2 = edgeData.count(); i < len2; i++) {
      edges[edgeData.getRawIndex(i)].dataIndex = i;
    }
  };
  Graph2.prototype.clone = function() {
    var graph = new Graph2(this._directed);
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0; i < nodes.length; i++) {
      graph.addNode(nodes[i].id, nodes[i].dataIndex);
    }
    for (var i = 0; i < edges.length; i++) {
      var e2 = edges[i];
      graph.addEdge(e2.node1.id, e2.node2.id, e2.dataIndex);
    }
    return graph;
  };
  return Graph2;
}();
var GraphNode = function() {
  function GraphNode2(id2, dataIndex) {
    this.inEdges = [];
    this.outEdges = [];
    this.edges = [];
    this.dataIndex = -1;
    this.id = id2 == null ? "" : id2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphNode2.prototype.degree = function() {
    return this.edges.length;
  };
  GraphNode2.prototype.inDegree = function() {
    return this.inEdges.length;
  };
  GraphNode2.prototype.outDegree = function() {
    return this.outEdges.length;
  };
  GraphNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphNode2.prototype.getAdjacentDataIndices = function() {
    var dataIndices = {
      edge: [],
      node: []
    };
    for (var i = 0; i < this.edges.length; i++) {
      var adjacentEdge = this.edges[i];
      if (adjacentEdge.dataIndex < 0) {
        continue;
      }
      dataIndices.edge.push(adjacentEdge.dataIndex);
      dataIndices.node.push(adjacentEdge.node1.dataIndex, adjacentEdge.node2.dataIndex);
    }
    return dataIndices;
  };
  return GraphNode2;
}();
var GraphEdge = function() {
  function GraphEdge2(n1, n2, dataIndex) {
    this.dataIndex = -1;
    this.node1 = n1;
    this.node2 = n2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphEdge2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.edgeData.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphEdge2.prototype.getAdjacentDataIndices = function() {
    return {
      edge: [this.dataIndex],
      node: [this.node1.dataIndex, this.node2.dataIndex]
    };
  };
  return GraphEdge2;
}();
function createGraphDataProxyMixin(hostName, dataName) {
  return {
    getValue: function(dimension) {
      var data = this[hostName][dataName];
      return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
    },
    setVisual: function(key, value) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemVisual(this.dataIndex, key, value);
    },
    getVisual: function(key) {
      return this[hostName][dataName].getItemVisual(this.dataIndex, key);
    },
    setLayout: function(layout2, merge2) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemLayout(this.dataIndex, layout2, merge2);
    },
    getLayout: function() {
      return this[hostName][dataName].getItemLayout(this.dataIndex);
    },
    getGraphicEl: function() {
      return this[hostName][dataName].getItemGraphicEl(this.dataIndex);
    },
    getRawIndex: function() {
      return this[hostName][dataName].getRawIndex(this.dataIndex);
    }
  };
}
mixin(GraphNode, createGraphDataProxyMixin("hostGraph", "data"));
mixin(GraphEdge, createGraphDataProxyMixin("hostGraph", "edgeData"));
var Graph$1 = Graph;
function createGraphFromNodeEdge(nodes, edges, seriesModel, directed, beforeLink) {
  var graph = new Graph$1(directed);
  for (var i = 0; i < nodes.length; i++) {
    graph.addNode(retrieve(nodes[i].id, nodes[i].name, i), i);
  }
  var linkNameList = [];
  var validEdges = [];
  var linkCount = 0;
  for (var i = 0; i < edges.length; i++) {
    var link = edges[i];
    var source = link.source;
    var target = link.target;
    if (graph.addEdge(source, target, linkCount)) {
      validEdges.push(link);
      linkNameList.push(retrieve(convertOptionIdName(link.id, null), source + " > " + target));
      linkCount++;
    }
  }
  var coordSys = seriesModel.get("coordinateSystem");
  var nodeData;
  if (coordSys === "cartesian2d" || coordSys === "polar") {
    nodeData = createSeriesData(nodes, seriesModel);
  } else {
    var coordSysCtor = CoordinateSystem.get(coordSys);
    var coordDimensions = coordSysCtor ? coordSysCtor.dimensions || [] : [];
    if (indexOf(coordDimensions, "value") < 0) {
      coordDimensions.concat(["value"]);
    }
    var dimensions = prepareSeriesDataSchema(nodes, {
      coordDimensions,
      encodeDefine: seriesModel.getEncode()
    }).dimensions;
    nodeData = new SeriesData$1(dimensions, seriesModel);
    nodeData.initData(nodes);
  }
  var edgeData = new SeriesData$1(["value"], seriesModel);
  edgeData.initData(validEdges, linkNameList);
  beforeLink && beforeLink(nodeData, edgeData);
  linkSeriesData({
    mainData: nodeData,
    struct: graph,
    structAttr: "graph",
    datas: {
      node: nodeData,
      edge: edgeData
    },
    datasAttr: {
      node: "data",
      edge: "edgeData"
    }
  });
  graph.update();
  return graph;
}
var GraphSeriesModel = function(_super) {
  __extends(GraphSeriesModel2, _super);
  function GraphSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  GraphSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    var self2 = this;
    function getCategoriesData() {
      return self2._categoriesData;
    }
    this.legendVisualProvider = new LegendVisualProvider$1(getCategoriesData, getCategoriesData);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeDefaultAndTheme = function(option) {
    _super.prototype.mergeDefaultAndTheme.apply(this, arguments);
    defaultEmphasis(option, "edgeLabel", ["show"]);
  };
  GraphSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var edges = option.edges || option.links || [];
    var nodes = option.data || option.nodes || [];
    var self2 = this;
    if (nodes && edges) {
      initCurvenessList(this);
      var graph = createGraphFromNodeEdge(nodes, edges, this, true, beforeLink);
      each$f(graph.edges, function(edge) {
        createEdgeMapForCurveness(edge.node1, edge.node2, this, edge.dataIndex);
      }, this);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model) {
        var categoriesModels = self2._categoriesModels;
        var categoryIdx = model.getShallow("category");
        var categoryModel = categoriesModels[categoryIdx];
        if (categoryModel) {
          categoryModel.parentModel = model.parentModel;
          model.parentModel = categoryModel;
        }
        return model;
      });
      var oldGetModel = Model$1.prototype.getModel;
      function newGetModel(path, parentModel) {
        var model = oldGetModel.call(this, path, parentModel);
        model.resolveParentPath = resolveParentPath;
        return model;
      }
      edgeData.wrapMethod("getItemModel", function(model) {
        model.resolveParentPath = resolveParentPath;
        model.getModel = newGetModel;
        return model;
      });
      function resolveParentPath(pathArr) {
        if (pathArr && (pathArr[0] === "label" || pathArr[1] === "label")) {
          var newPathArr = pathArr.slice();
          if (pathArr[0] === "label") {
            newPathArr[0] = "edgeLabel";
          } else if (pathArr[1] === "label") {
            newPathArr[1] = "edgeLabel";
          }
          return newPathArr;
        }
        return pathArr;
      }
    }
  };
  GraphSeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  GraphSeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  GraphSeriesModel2.prototype.getCategoriesData = function() {
    return this._categoriesData;
  };
  GraphSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    if (dataType === "edge") {
      var nodeData = this.getData();
      var params = this.getDataParams(dataIndex, dataType);
      var edge = nodeData.graph.getEdgeByIndex(dataIndex);
      var sourceName = nodeData.getName(edge.node1.dataIndex);
      var targetName = nodeData.getName(edge.node2.dataIndex);
      var nameArr = [];
      sourceName != null && nameArr.push(sourceName);
      targetName != null && nameArr.push(targetName);
      return createTooltipMarkup("nameValue", {
        name: nameArr.join(" > "),
        value: params.value,
        noValue: params.value == null
      });
    }
    var nodeMarkup = defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
    return nodeMarkup;
  };
  GraphSeriesModel2.prototype._updateCategoriesData = function() {
    var categories = map$1(this.option.categories || [], function(category) {
      return category.value != null ? category : extend({
        value: 0
      }, category);
    });
    var categoriesData = new SeriesData$1(["value"], this);
    categoriesData.initData(categories);
    this._categoriesData = categoriesData;
    this._categoriesModels = categoriesData.mapArray(function(idx) {
      return categoriesData.getItemModel(idx);
    });
  };
  GraphSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GraphSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GraphSeriesModel2.prototype.isAnimationEnabled = function() {
    return _super.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
  };
  GraphSeriesModel2.type = "series.graph";
  GraphSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  GraphSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    legendHoverLink: true,
    layout: null,
    circular: {
      rotateLabel: false
    },
    force: {
      initLayout: null,
      repulsion: [0, 50],
      gravity: 0.1,
      friction: 0.6,
      edgeLength: 30,
      layoutAnimation: true
    },
    left: "center",
    top: "center",
    symbol: "circle",
    symbolSize: 10,
    edgeSymbol: ["none", "none"],
    edgeSymbolSize: 10,
    edgeLabel: {
      position: "middle",
      distance: 5
    },
    draggable: false,
    roam: false,
    center: null,
    zoom: 1,
    nodeScaleRatio: 0.6,
    label: {
      show: false,
      formatter: "{b}"
    },
    itemStyle: {},
    lineStyle: {
      color: "#aaa",
      width: 1,
      opacity: 0.5
    },
    emphasis: {
      scale: true,
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return GraphSeriesModel2;
}(SeriesModel$1);
var GraphSeriesModel$1 = GraphSeriesModel;
var actionInfo$1 = {
  type: "graphRoam",
  event: "graphRoam",
  update: "none"
};
function install$F(registers) {
  registers.registerChartView(GraphView$1);
  registers.registerSeriesModel(GraphSeriesModel$1);
  registers.registerProcessor(categoryFilter);
  registers.registerVisual(categoryVisual);
  registers.registerVisual(graphEdgeVisual);
  registers.registerLayout(graphSimpleLayout);
  registers.registerLayout(registers.PRIORITY.VISUAL.POST_CHART_LAYOUT, graphCircularLayout);
  registers.registerLayout(graphForceLayout);
  registers.registerCoordinateSystem("graphView", {
    dimensions: View$1.dimensions,
    create: createViewCoordSys
  });
  registers.registerAction({
    type: "focusNodeAdjacency",
    event: "focusNodeAdjacency",
    update: "series:focusNodeAdjacency"
  }, noop);
  registers.registerAction({
    type: "unfocusNodeAdjacency",
    event: "unfocusNodeAdjacency",
    update: "series:unfocusNodeAdjacency"
  }, noop);
  registers.registerAction(actionInfo$1, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
var PointerShape = function() {
  function PointerShape2() {
    this.angle = 0;
    this.width = 10;
    this.r = 10;
    this.x = 0;
    this.y = 0;
  }
  return PointerShape2;
}();
var PointerPath = function(_super) {
  __extends(PointerPath2, _super);
  function PointerPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "pointer";
    return _this;
  }
  PointerPath2.prototype.getDefaultShape = function() {
    return new PointerShape();
  };
  PointerPath2.prototype.buildPath = function(ctx, shape) {
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var r2 = shape.r;
    var width = shape.width;
    var angle = shape.angle;
    var x2 = shape.x - mathCos2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    var y2 = shape.y - mathSin2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    angle = shape.angle - Math.PI / 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(shape.x + mathCos2(angle) * width, shape.y + mathSin2(angle) * width);
    ctx.lineTo(shape.x + mathCos2(shape.angle) * r2, shape.y + mathSin2(shape.angle) * r2);
    ctx.lineTo(shape.x - mathCos2(angle) * width, shape.y - mathSin2(angle) * width);
    ctx.lineTo(x2, y2);
  };
  return PointerPath2;
}(Path$1);
var PointerPath$1 = PointerPath;
function parsePosition(seriesModel, api) {
  var center2 = seriesModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], api.getWidth());
  var cy = parsePercent(center2[1], api.getHeight());
  var r2 = parsePercent(seriesModel.get("radius"), size / 2);
  return {
    cx,
    cy,
    r: r2
  };
}
function formatLabel(value, labelFormatter) {
  var label = value == null ? "" : value + "";
  if (labelFormatter) {
    if (isString(labelFormatter)) {
      label = labelFormatter.replace("{value}", label);
    } else if (isFunction(labelFormatter)) {
      label = labelFormatter(value);
    }
  }
  return label;
}
var PI2 = Math.PI * 2;
var GaugeView = function(_super) {
  __extends(GaugeView2, _super);
  function GaugeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeView2.type;
    return _this;
  }
  GaugeView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeAll();
    var colorList = seriesModel.get(["axisLine", "lineStyle", "color"]);
    var posInfo = parsePosition(seriesModel, api);
    this._renderMain(seriesModel, ecModel, api, colorList, posInfo);
    this._data = seriesModel.getData();
  };
  GaugeView2.prototype.dispose = function() {
  };
  GaugeView2.prototype._renderMain = function(seriesModel, ecModel, api, colorList, posInfo) {
    var group = this.group;
    var clockwise = seriesModel.get("clockwise");
    var startAngle = -seriesModel.get("startAngle") / 180 * Math.PI;
    var endAngle = -seriesModel.get("endAngle") / 180 * Math.PI;
    var axisLineModel = seriesModel.getModel("axisLine");
    var roundCap = axisLineModel.get("roundCap");
    var MainPath = roundCap ? Sausage : Sector$1;
    var showAxis = axisLineModel.get("show");
    var lineStyleModel = axisLineModel.getModel("lineStyle");
    var axisLineWidth = lineStyleModel.get("width");
    var angleRangeSpan = !((endAngle - startAngle) % PI2) && endAngle !== startAngle ? PI2 : (endAngle - startAngle) % PI2;
    var prevEndAngle = startAngle;
    for (var i = 0; showAxis && i < colorList.length; i++) {
      var percent = Math.min(Math.max(colorList[i][0], 0), 1);
      endAngle = startAngle + angleRangeSpan * percent;
      var sector = new MainPath({
        shape: {
          startAngle: prevEndAngle,
          endAngle,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0: posInfo.r - axisLineWidth,
          r: posInfo.r
        },
        silent: true
      });
      sector.setStyle({
        fill: colorList[i][1]
      });
      sector.setStyle(lineStyleModel.getLineStyle(["color", "width"]));
      group.add(sector);
      prevEndAngle = endAngle;
    }
    var getColor = function(percent2) {
      if (percent2 <= 0) {
        return colorList[0][1];
      }
      var i2;
      for (i2 = 0; i2 < colorList.length; i2++) {
        if (colorList[i2][0] >= percent2 && (i2 === 0 ? 0 : colorList[i2 - 1][0]) < percent2) {
          return colorList[i2][1];
        }
      }
      return colorList[i2 - 1][1];
    };
    if (!clockwise) {
      var tmp = startAngle;
      startAngle = endAngle;
      endAngle = tmp;
    }
    this._renderTicks(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
    this._renderTitleAndDetail(seriesModel, ecModel, api, getColor, posInfo);
    this._renderAnchor(seriesModel, posInfo);
    this._renderPointer(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
  };
  GaugeView2.prototype._renderTicks = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var cx = posInfo.cx;
    var cy = posInfo.cy;
    var r2 = posInfo.r;
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var splitLineModel = seriesModel.getModel("splitLine");
    var tickModel = seriesModel.getModel("axisTick");
    var labelModel = seriesModel.getModel("axisLabel");
    var splitNumber = seriesModel.get("splitNumber");
    var subSplitNumber = tickModel.get("splitNumber");
    var splitLineLen = parsePercent(splitLineModel.get("length"), r2);
    var tickLen = parsePercent(tickModel.get("length"), r2);
    var angle = startAngle;
    var step = (endAngle - startAngle) / splitNumber;
    var subStep = step / subSplitNumber;
    var splitLineStyle = splitLineModel.getModel("lineStyle").getLineStyle();
    var tickLineStyle = tickModel.getModel("lineStyle").getLineStyle();
    var splitLineDistance = splitLineModel.get("distance");
    var unitX;
    var unitY;
    for (var i = 0; i <= splitNumber; i++) {
      unitX = Math.cos(angle);
      unitY = Math.sin(angle);
      if (splitLineModel.get("show")) {
        var distance2 = splitLineDistance ? splitLineDistance + axisLineWidth : axisLineWidth;
        var splitLine = new Line$3({
          shape: {
            x1: unitX * (r2 - distance2) + cx,
            y1: unitY * (r2 - distance2) + cy,
            x2: unitX * (r2 - splitLineLen - distance2) + cx,
            y2: unitY * (r2 - splitLineLen - distance2) + cy
          },
          style: splitLineStyle,
          silent: true
        });
        if (splitLineStyle.stroke === "auto") {
          splitLine.setStyle({
            stroke: getColor(i / splitNumber)
          });
        }
        group.add(splitLine);
      }
      if (labelModel.get("show")) {
        var distance2 = labelModel.get("distance") + splitLineDistance;
        var label = formatLabel(round$3(i / splitNumber * (maxVal - minVal) + minVal), labelModel.get("formatter"));
        var autoColor = getColor(i / splitNumber);
        group.add(new ZRText$1({
          style: createTextStyle(labelModel, {
            text: label,
            x: unitX * (r2 - splitLineLen - distance2) + cx,
            y: unitY * (r2 - splitLineLen - distance2) + cy,
            verticalAlign: unitY < -0.8 ? "top" : unitY > 0.8 ? "bottom" : "middle",
            align: unitX < -0.4 ? "left" : unitX > 0.4 ? "right" : "center"
          }, {
            inheritColor: autoColor
          }),
          silent: true
        }));
      }
      if (tickModel.get("show") && i !== splitNumber) {
        var distance2 = tickModel.get("distance");
        distance2 = distance2 ? distance2 + axisLineWidth : axisLineWidth;
        for (var j = 0; j <= subSplitNumber; j++) {
          unitX = Math.cos(angle);
          unitY = Math.sin(angle);
          var tickLine = new Line$3({
            shape: {
              x1: unitX * (r2 - distance2) + cx,
              y1: unitY * (r2 - distance2) + cy,
              x2: unitX * (r2 - tickLen - distance2) + cx,
              y2: unitY * (r2 - tickLen - distance2) + cy
            },
            silent: true,
            style: tickLineStyle
          });
          if (tickLineStyle.stroke === "auto") {
            tickLine.setStyle({
              stroke: getColor((i + j / subSplitNumber) / splitNumber)
            });
          }
          group.add(tickLine);
          angle += subStep;
        }
        angle -= subStep;
      } else {
        angle += step;
      }
    }
  };
  GaugeView2.prototype._renderPointer = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var oldData = this._data;
    var oldProgressData = this._progressEls;
    var progressList = [];
    var showPointer2 = seriesModel.get(["pointer", "show"]);
    var progressModel = seriesModel.getModel("progress");
    var showProgress = progressModel.get("show");
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var valueExtent = [minVal, maxVal];
    var angleExtent = [startAngle, endAngle];
    function createPointer(idx, angle) {
      var itemModel = data.getItemModel(idx);
      var pointerModel = itemModel.getModel("pointer");
      var pointerWidth = parsePercent(pointerModel.get("width"), posInfo.r);
      var pointerLength = parsePercent(pointerModel.get("length"), posInfo.r);
      var pointerStr = seriesModel.get(["pointer", "icon"]);
      var pointerOffset = pointerModel.get("offsetCenter");
      var pointerOffsetX = parsePercent(pointerOffset[0], posInfo.r);
      var pointerOffsetY = parsePercent(pointerOffset[1], posInfo.r);
      var pointerKeepAspect = pointerModel.get("keepAspect");
      var pointer;
      if (pointerStr) {
        pointer = createSymbol$1(pointerStr, pointerOffsetX - pointerWidth / 2, pointerOffsetY - pointerLength, pointerWidth, pointerLength, null, pointerKeepAspect);
      } else {
        pointer = new PointerPath$1({
          shape: {
            angle: -Math.PI / 2,
            width: pointerWidth,
            r: pointerLength,
            x: pointerOffsetX,
            y: pointerOffsetY
          }
        });
      }
      pointer.rotation = -(angle + Math.PI / 2);
      pointer.x = posInfo.cx;
      pointer.y = posInfo.cy;
      return pointer;
    }
    function createProgress(idx, endAngle2) {
      var roundCap = progressModel.get("roundCap");
      var ProgressPath = roundCap ? Sausage : Sector$1;
      var isOverlap = progressModel.get("overlap");
      var progressWidth = isOverlap ? progressModel.get("width") : axisLineWidth / data.count();
      var r0 = isOverlap ? posInfo.r - progressWidth : posInfo.r - (idx + 1) * progressWidth;
      var r2 = isOverlap ? posInfo.r : posInfo.r - idx * progressWidth;
      var progress = new ProgressPath({
        shape: {
          startAngle,
          endAngle: endAngle2,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0,
          r: r2
        }
      });
      isOverlap && (progress.z2 = maxVal - data.get(valueDim, idx) % maxVal);
      return progress;
    }
    if (showProgress || showPointer2) {
      data.diff(oldData).add(function(idx) {
        var val = data.get(valueDim, idx);
        if (showPointer2) {
          var pointer = createPointer(idx, startAngle);
          initProps(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(idx, pointer);
        }
        if (showProgress) {
          var progress = createProgress(idx, startAngle);
          var isClip = progressModel.get("clip");
          initProps(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, idx, progress);
          progressList[idx] = progress;
        }
      }).update(function(newIdx, oldIdx) {
        var val = data.get(valueDim, newIdx);
        if (showPointer2) {
          var previousPointer = oldData.getItemGraphicEl(oldIdx);
          var previousRotate = previousPointer ? previousPointer.rotation : startAngle;
          var pointer = createPointer(newIdx, previousRotate);
          pointer.rotation = previousRotate;
          updateProps$1(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(newIdx, pointer);
        }
        if (showProgress) {
          var previousProgress = oldProgressData[oldIdx];
          var previousEndAngle = previousProgress ? previousProgress.shape.endAngle : startAngle;
          var progress = createProgress(newIdx, previousEndAngle);
          var isClip = progressModel.get("clip");
          updateProps$1(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, newIdx, progress);
          progressList[newIdx] = progress;
        }
      }).execute();
      data.each(function(idx) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel = itemModel.getModel("emphasis");
        var focus = emphasisModel.get("focus");
        var blurScope = emphasisModel.get("blurScope");
        var emphasisDisabled = emphasisModel.get("disabled");
        if (showPointer2) {
          var pointer = data.getItemGraphicEl(idx);
          var symbolStyle = data.getItemVisual(idx, "style");
          var visualColor = symbolStyle.fill;
          if (pointer instanceof ZRImage$1) {
            var pathStyle = pointer.style;
            pointer.useStyle(extend({
              image: pathStyle.image,
              x: pathStyle.x,
              y: pathStyle.y,
              width: pathStyle.width,
              height: pathStyle.height
            }, symbolStyle));
          } else {
            pointer.useStyle(symbolStyle);
            pointer.type !== "pointer" && pointer.setColor(visualColor);
          }
          pointer.setStyle(itemModel.getModel(["pointer", "itemStyle"]).getItemStyle());
          if (pointer.style.fill === "auto") {
            pointer.setStyle("fill", getColor(linearMap$2(data.get(valueDim, idx), valueExtent, [0, 1], true)));
          }
          pointer.z2EmphasisLift = 0;
          setStatesStylesFromModel(pointer, itemModel);
          toggleHoverEmphasis(pointer, focus, blurScope, emphasisDisabled);
        }
        if (showProgress) {
          var progress = progressList[idx];
          progress.useStyle(data.getItemVisual(idx, "style"));
          progress.setStyle(itemModel.getModel(["progress", "itemStyle"]).getItemStyle());
          progress.z2EmphasisLift = 0;
          setStatesStylesFromModel(progress, itemModel);
          toggleHoverEmphasis(progress, focus, blurScope, emphasisDisabled);
        }
      });
      this._progressEls = progressList;
    }
  };
  GaugeView2.prototype._renderAnchor = function(seriesModel, posInfo) {
    var anchorModel = seriesModel.getModel("anchor");
    var showAnchor = anchorModel.get("show");
    if (showAnchor) {
      var anchorSize = anchorModel.get("size");
      var anchorType = anchorModel.get("icon");
      var offsetCenter = anchorModel.get("offsetCenter");
      var anchorKeepAspect = anchorModel.get("keepAspect");
      var anchor = createSymbol$1(anchorType, posInfo.cx - anchorSize / 2 + parsePercent(offsetCenter[0], posInfo.r), posInfo.cy - anchorSize / 2 + parsePercent(offsetCenter[1], posInfo.r), anchorSize, anchorSize, null, anchorKeepAspect);
      anchor.z2 = anchorModel.get("showAbove") ? 1 : 0;
      anchor.setStyle(anchorModel.getModel("itemStyle").getItemStyle());
      this.group.add(anchor);
    }
  };
  GaugeView2.prototype._renderTitleAndDetail = function(seriesModel, ecModel, api, getColor, posInfo) {
    var _this = this;
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var contentGroup = new Group$4();
    var newTitleEls = [];
    var newDetailEls = [];
    var hasAnimation = seriesModel.isAnimationEnabled();
    var showPointerAbove = seriesModel.get(["pointer", "showAbove"]);
    data.diff(this._data).add(function(idx) {
      newTitleEls[idx] = new ZRText$1({
        silent: true
      });
      newDetailEls[idx] = new ZRText$1({
        silent: true
      });
    }).update(function(idx, oldIdx) {
      newTitleEls[idx] = _this._titleEls[oldIdx];
      newDetailEls[idx] = _this._detailEls[oldIdx];
    }).execute();
    data.each(function(idx) {
      var itemModel = data.getItemModel(idx);
      var value = data.get(valueDim, idx);
      var itemGroup = new Group$4();
      var autoColor = getColor(linearMap$2(value, [minVal, maxVal], [0, 1], true));
      var itemTitleModel = itemModel.getModel("title");
      if (itemTitleModel.get("show")) {
        var titleOffsetCenter = itemTitleModel.get("offsetCenter");
        var titleX = posInfo.cx + parsePercent(titleOffsetCenter[0], posInfo.r);
        var titleY = posInfo.cy + parsePercent(titleOffsetCenter[1], posInfo.r);
        var labelEl = newTitleEls[idx];
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemTitleModel, {
            x: titleX,
            y: titleY,
            text: data.getName(idx),
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: autoColor
          })
        });
        itemGroup.add(labelEl);
      }
      var itemDetailModel = itemModel.getModel("detail");
      if (itemDetailModel.get("show")) {
        var detailOffsetCenter = itemDetailModel.get("offsetCenter");
        var detailX = posInfo.cx + parsePercent(detailOffsetCenter[0], posInfo.r);
        var detailY = posInfo.cy + parsePercent(detailOffsetCenter[1], posInfo.r);
        var width = parsePercent(itemDetailModel.get("width"), posInfo.r);
        var height = parsePercent(itemDetailModel.get("height"), posInfo.r);
        var detailColor = seriesModel.get(["progress", "show"]) ? data.getItemVisual(idx, "style").fill : autoColor;
        var labelEl = newDetailEls[idx];
        var formatter_1 = itemDetailModel.get("formatter");
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemDetailModel, {
            x: detailX,
            y: detailY,
            text: formatLabel(value, formatter_1),
            width: isNaN(width) ? null : width,
            height: isNaN(height) ? null : height,
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: detailColor
          })
        });
        setLabelValueAnimation(labelEl, {
          normal: itemDetailModel
        }, value, function(value2) {
          return formatLabel(value2, formatter_1);
        });
        hasAnimation && animateLabelValue(labelEl, idx, data, seriesModel, {
          getFormattedLabel: function(labelDataIndex, status, dataType, labelDimIndex, fmt, extendParams) {
            return formatLabel(extendParams ? extendParams.interpolatedValue : value, formatter_1);
          }
        });
        itemGroup.add(labelEl);
      }
      contentGroup.add(itemGroup);
    });
    this.group.add(contentGroup);
    this._titleEls = newTitleEls;
    this._detailEls = newDetailEls;
  };
  GaugeView2.type = "gauge";
  return GaugeView2;
}(ChartView$1);
var GaugeView$1 = GaugeView;
var GaugeSeriesModel = function(_super) {
  __extends(GaugeSeriesModel2, _super);
  function GaugeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeSeriesModel2.type;
    _this.visualStyleAccessPath = "itemStyle";
    return _this;
  }
  GaugeSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, ["value"]);
  };
  GaugeSeriesModel2.type = "series.gauge";
  GaugeSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    center: ["50%", "50%"],
    legendHoverLink: true,
    radius: "75%",
    startAngle: 225,
    endAngle: -45,
    clockwise: true,
    min: 0,
    max: 100,
    splitNumber: 10,
    axisLine: {
      show: true,
      roundCap: false,
      lineStyle: {
        color: [[1, "#E6EBF8"]],
        width: 10
      }
    },
    progress: {
      show: false,
      overlap: true,
      width: 10,
      roundCap: false,
      clip: true
    },
    splitLine: {
      show: true,
      length: 10,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 3,
        type: "solid"
      }
    },
    axisTick: {
      show: true,
      splitNumber: 5,
      length: 6,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 1,
        type: "solid"
      }
    },
    axisLabel: {
      show: true,
      distance: 15,
      color: "#464646",
      fontSize: 12
    },
    pointer: {
      icon: null,
      offsetCenter: [0, 0],
      show: true,
      showAbove: true,
      length: "60%",
      width: 6,
      keepAspect: false
    },
    anchor: {
      show: false,
      showAbove: false,
      size: 6,
      icon: "circle",
      offsetCenter: [0, 0],
      keepAspect: false,
      itemStyle: {
        color: "#fff",
        borderWidth: 0,
        borderColor: "#5470c6"
      }
    },
    title: {
      show: true,
      offsetCenter: [0, "20%"],
      color: "#464646",
      fontSize: 16,
      valueAnimation: false
    },
    detail: {
      show: true,
      backgroundColor: "rgba(0,0,0,0)",
      borderWidth: 0,
      borderColor: "#ccc",
      width: 100,
      height: null,
      padding: [5, 10],
      offsetCenter: [0, "40%"],
      color: "#464646",
      fontSize: 30,
      fontWeight: "bold",
      lineHeight: 30,
      valueAnimation: false
    }
  };
  return GaugeSeriesModel2;
}(SeriesModel$1);
var GaugeSeriesModel$1 = GaugeSeriesModel;
function install$E(registers) {
  registers.registerChartView(GaugeView$1);
  registers.registerSeriesModel(GaugeSeriesModel$1);
}
var opacityAccessPath$1 = ["itemStyle", "opacity"];
var FunnelPiece = function(_super) {
  __extends(FunnelPiece2, _super);
  function FunnelPiece2(data, idx) {
    var _this = _super.call(this) || this;
    var polygon = _this;
    var labelLine = new Polyline$3();
    var text = new ZRText$1();
    polygon.setTextContent(text);
    _this.setTextGuideLine(labelLine);
    _this.updateData(data, idx, true);
    return _this;
  }
  FunnelPiece2.prototype.updateData = function(data, idx, firstCreate) {
    var polygon = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var opacity = itemModel.get(opacityAccessPath$1);
    opacity = opacity == null ? 1 : opacity;
    if (!firstCreate) {
      saveOldStyle(polygon);
    }
    polygon.useStyle(data.getItemVisual(idx, "style"));
    polygon.style.lineJoin = "round";
    if (firstCreate) {
      polygon.setShape({
        points: layout2.points
      });
      polygon.style.opacity = 0;
      initProps(polygon, {
        style: {
          opacity
        }
      }, seriesModel, idx);
    } else {
      updateProps$1(polygon, {
        style: {
          opacity
        },
        shape: {
          points: layout2.points
        }
      }, seriesModel, idx);
    }
    setStatesStylesFromModel(polygon, itemModel);
    this._updateLabel(data, idx);
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  FunnelPiece2.prototype._updateLabel = function(data, idx) {
    var polygon = this;
    var labelLine = this.getTextGuideLine();
    var labelText = polygon.getTextContent();
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var labelLayout2 = layout2.label;
    var style = data.getItemVisual(idx, "style");
    var visualColor = style.fill;
    setLabelStyle(labelText, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      defaultOpacity: style.opacity,
      defaultText: data.getName(idx)
    }, {
      normal: {
        align: labelLayout2.textAlign,
        verticalAlign: labelLayout2.verticalAlign
      }
    });
    polygon.setTextConfig({
      local: true,
      inside: !!labelLayout2.inside,
      insideStroke: visualColor,
      outsideFill: visualColor
    });
    var linePoints = labelLayout2.linePoints;
    labelLine.setShape({
      points: linePoints
    });
    polygon.textGuideLineConfig = {
      anchor: linePoints ? new Point$1(linePoints[0][0], linePoints[0][1]) : null
    };
    updateProps$1(labelText, {
      style: {
        x: labelLayout2.x,
        y: labelLayout2.y
      }
    }, seriesModel, idx);
    labelText.attr({
      rotation: labelLayout2.rotation,
      originX: labelLayout2.x,
      originY: labelLayout2.y,
      z2: 10
    });
    setLabelLineStyle(polygon, getLabelLineStatesModels(itemModel), {
      stroke: visualColor
    });
  };
  return FunnelPiece2;
}(Polygon$1);
var FunnelView = function(_super) {
  __extends(FunnelView2, _super);
  function FunnelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelView2.type;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  FunnelView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    data.diff(oldData).add(function(idx) {
      var funnelPiece = new FunnelPiece(data, idx);
      data.setItemGraphicEl(idx, funnelPiece);
      group.add(funnelPiece);
    }).update(function(newIdx, oldIdx) {
      var piece = oldData.getItemGraphicEl(oldIdx);
      piece.updateData(data, newIdx);
      group.add(piece);
      data.setItemGraphicEl(newIdx, piece);
    }).remove(function(idx) {
      var piece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piece, seriesModel, idx);
    }).execute();
    this._data = data;
  };
  FunnelView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  FunnelView2.prototype.dispose = function() {
  };
  FunnelView2.type = "funnel";
  return FunnelView2;
}(ChartView$1);
var FunnelView$1 = FunnelView;
var FunnelSeriesModel = function(_super) {
  __extends(FunnelSeriesModel2, _super);
  function FunnelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelSeriesModel2.type;
    return _this;
  }
  FunnelSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  FunnelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  FunnelSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  FunnelSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueDim = data.mapDimension("value");
    var sum2 = data.getSum(valueDim);
    params.percent = !sum2 ? 0 : +(data.get(valueDim, dataIndex) / sum2 * 100).toFixed(2);
    params.$vars.push("percent");
    return params;
  };
  FunnelSeriesModel2.type = "series.funnel";
  FunnelSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    minSize: "0%",
    maxSize: "100%",
    sort: "descending",
    orient: "vertical",
    gap: 0,
    funnelAlign: "center",
    label: {
      show: true,
      position: "outer"
    },
    labelLine: {
      show: true,
      length: 20,
      lineStyle: {
        width: 1
      }
    },
    itemStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return FunnelSeriesModel2;
}(SeriesModel$1);
var FunnelSeriesModel$1 = FunnelSeriesModel;
function getViewRect$2(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getSortedIndices(data, sort2) {
  var valueDim = data.mapDimension("value");
  var valueArr = data.mapArray(valueDim, function(val) {
    return val;
  });
  var indices = [];
  var isAscending = sort2 === "ascending";
  for (var i = 0, len2 = data.count(); i < len2; i++) {
    indices[i] = i;
  }
  if (isFunction(sort2)) {
    indices.sort(sort2);
  } else if (sort2 !== "none") {
    indices.sort(function(a, b2) {
      return isAscending ? valueArr[a] - valueArr[b2] : valueArr[b2] - valueArr[a];
    });
  }
  return indices;
}
function labelLayout(data) {
  var seriesModel = data.hostModel;
  var orient = seriesModel.get("orient");
  data.each(function(idx) {
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position");
    var labelLineModel = itemModel.getModel("labelLine");
    var layout2 = data.getItemLayout(idx);
    var points2 = layout2.points;
    var isLabelInside = labelPosition === "inner" || labelPosition === "inside" || labelPosition === "center" || labelPosition === "insideLeft" || labelPosition === "insideRight";
    var textAlign;
    var textX;
    var textY;
    var linePoints;
    if (isLabelInside) {
      if (labelPosition === "insideLeft") {
        textX = (points2[0][0] + points2[3][0]) / 2 + 5;
        textY = (points2[0][1] + points2[3][1]) / 2;
        textAlign = "left";
      } else if (labelPosition === "insideRight") {
        textX = (points2[1][0] + points2[2][0]) / 2 - 5;
        textY = (points2[1][1] + points2[2][1]) / 2;
        textAlign = "right";
      } else {
        textX = (points2[0][0] + points2[1][0] + points2[2][0] + points2[3][0]) / 4;
        textY = (points2[0][1] + points2[1][1] + points2[2][1] + points2[3][1]) / 4;
        textAlign = "center";
      }
      linePoints = [[textX, textY], [textX, textY]];
    } else {
      var x1 = void 0;
      var y1 = void 0;
      var x2 = void 0;
      var y2 = void 0;
      var labelLineLen = labelLineModel.get("length");
      if (labelPosition === "left") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        x2 = x1 - labelLineLen;
        textX = x2 - 5;
        textAlign = "right";
      } else if (labelPosition === "right") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        x2 = x1 + labelLineLen;
        textX = x2 + 5;
        textAlign = "left";
      } else if (labelPosition === "top") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        y2 = y1 - labelLineLen;
        textY = y2 - 5;
        textAlign = "center";
      } else if (labelPosition === "bottom") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        y2 = y1 + labelLineLen;
        textY = y2 + 5;
        textAlign = "center";
      } else if (labelPosition === "rightTop") {
        x1 = orient === "horizontal" ? points2[3][0] : points2[1][0];
        y1 = orient === "horizontal" ? points2[3][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "top";
        }
      } else if (labelPosition === "rightBottom") {
        x1 = points2[2][0];
        y1 = points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "bottom";
        }
      } else if (labelPosition === "leftTop") {
        x1 = points2[0][0];
        y1 = orient === "horizontal" ? points2[0][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else if (labelPosition === "leftBottom") {
        x1 = orient === "horizontal" ? points2[1][0] : points2[3][0];
        y1 = orient === "horizontal" ? points2[1][1] : points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "left";
        }
      }
      if (orient === "horizontal") {
        x2 = x1;
        textX = x2;
      } else {
        y2 = y1;
        textY = y2;
      }
      linePoints = [[x1, y1], [x2, y2]];
    }
    layout2.label = {
      linePoints,
      x: textX,
      y: textY,
      verticalAlign: "middle",
      textAlign,
      inside: isLabelInside
    };
  });
}
function funnelLayout(ecModel, api) {
  ecModel.eachSeriesByType("funnel", function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var sort2 = seriesModel.get("sort");
    var viewRect2 = getViewRect$2(seriesModel, api);
    var orient = seriesModel.get("orient");
    var viewWidth = viewRect2.width;
    var viewHeight = viewRect2.height;
    var indices = getSortedIndices(data, sort2);
    var x2 = viewRect2.x;
    var y2 = viewRect2.y;
    var sizeExtent = orient === "horizontal" ? [parsePercent(seriesModel.get("minSize"), viewHeight), parsePercent(seriesModel.get("maxSize"), viewHeight)] : [parsePercent(seriesModel.get("minSize"), viewWidth), parsePercent(seriesModel.get("maxSize"), viewWidth)];
    var dataExtent = data.getDataExtent(valueDim);
    var min3 = seriesModel.get("min");
    var max3 = seriesModel.get("max");
    if (min3 == null) {
      min3 = Math.min(dataExtent[0], 0);
    }
    if (max3 == null) {
      max3 = dataExtent[1];
    }
    var funnelAlign = seriesModel.get("funnelAlign");
    var gap = seriesModel.get("gap");
    var viewSize = orient === "horizontal" ? viewWidth : viewHeight;
    var itemSize = (viewSize - gap * (data.count() - 1)) / data.count();
    var getLinePoints = function(idx2, offset) {
      if (orient === "horizontal") {
        var val_1 = data.get(valueDim, idx2) || 0;
        var itemHeight = linearMap$2(val_1, [min3, max3], sizeExtent, true);
        var y0 = void 0;
        switch (funnelAlign) {
          case "top":
            y0 = y2;
            break;
          case "center":
            y0 = y2 + (viewHeight - itemHeight) / 2;
            break;
          case "bottom":
            y0 = y2 + (viewHeight - itemHeight);
            break;
        }
        return [[offset, y0], [offset, y0 + itemHeight]];
      }
      var val = data.get(valueDim, idx2) || 0;
      var itemWidth = linearMap$2(val, [min3, max3], sizeExtent, true);
      var x0;
      switch (funnelAlign) {
        case "left":
          x0 = x2;
          break;
        case "center":
          x0 = x2 + (viewWidth - itemWidth) / 2;
          break;
        case "right":
          x0 = x2 + viewWidth - itemWidth;
          break;
      }
      return [[x0, offset], [x0 + itemWidth, offset]];
    };
    if (sort2 === "ascending") {
      itemSize = -itemSize;
      gap = -gap;
      if (orient === "horizontal") {
        x2 += viewWidth;
      } else {
        y2 += viewHeight;
      }
      indices = indices.reverse();
    }
    for (var i = 0; i < indices.length; i++) {
      var idx = indices[i];
      var nextIdx = indices[i + 1];
      var itemModel = data.getItemModel(idx);
      if (orient === "horizontal") {
        var width = itemModel.get(["itemStyle", "width"]);
        if (width == null) {
          width = itemSize;
        } else {
          width = parsePercent(width, viewWidth);
          if (sort2 === "ascending") {
            width = -width;
          }
        }
        var start2 = getLinePoints(idx, x2);
        var end2 = getLinePoints(nextIdx, x2 + width);
        x2 += width + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      } else {
        var height = itemModel.get(["itemStyle", "height"]);
        if (height == null) {
          height = itemSize;
        } else {
          height = parsePercent(height, viewHeight);
          if (sort2 === "ascending") {
            height = -height;
          }
        }
        var start2 = getLinePoints(idx, y2);
        var end2 = getLinePoints(nextIdx, y2 + height);
        y2 += height + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      }
    }
    labelLayout(data);
  });
}
function install$D(registers) {
  registers.registerChartView(FunnelView$1);
  registers.registerSeriesModel(FunnelSeriesModel$1);
  registers.registerLayout(funnelLayout);
  registers.registerProcessor(dataFilter$1("funnel"));
}
var DEFAULT_SMOOTH = 0.3;
var ParallelView$2 = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    _this._dataGroup = new Group$4();
    _this._initialized = false;
    return _this;
  }
  ParallelView2.prototype.init = function() {
    this.group.add(this._dataGroup);
  };
  ParallelView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._progressiveEls = null;
    var dataGroup = this._dataGroup;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    data.diff(oldData).add(add2).update(update).remove(remove).execute();
    function add2(newDataIndex) {
      var line = addEl(data, dataGroup, newDataIndex, dimensions, coordSys);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function update(newDataIndex, oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      var points2 = createLinePoints(data, newDataIndex, dimensions, coordSys);
      data.setItemGraphicEl(newDataIndex, line);
      updateProps$1(line, {
        shape: {
          points: points2
        }
      }, seriesModel, newDataIndex);
      saveOldStyle(line);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function remove(oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      dataGroup.remove(line);
    }
    if (!this._initialized) {
      this._initialized = true;
      var clipPath = createGridClipShape$2(coordSys, seriesModel, function() {
        setTimeout(function() {
          dataGroup.removeClipPath();
        });
      });
      dataGroup.setClipPath(clipPath);
    }
    this._data = data;
  };
  ParallelView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._initialized = true;
    this._data = null;
    this._dataGroup.removeAll();
  };
  ParallelView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    var data = seriesModel.getData();
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    var progressiveEls = this._progressiveEls = [];
    for (var dataIndex = taskParams.start; dataIndex < taskParams.end; dataIndex++) {
      var line = addEl(data, this._dataGroup, dataIndex, dimensions, coordSys);
      line.incremental = true;
      updateElCommon(line, data, dataIndex, seriesScope);
      progressiveEls.push(line);
    }
  };
  ParallelView2.prototype.remove = function() {
    this._dataGroup && this._dataGroup.removeAll();
    this._data = null;
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ChartView$1);
function createGridClipShape$2(coordSys, seriesModel, cb) {
  var parallelModel = coordSys.model;
  var rect = coordSys.getRect();
  var rectEl = new Rect$3({
    shape: {
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    }
  });
  var dim = parallelModel.get("layout") === "horizontal" ? "width" : "height";
  rectEl.setShape(dim, 0);
  initProps(rectEl, {
    shape: {
      width: rect.width,
      height: rect.height
    }
  }, seriesModel, cb);
  return rectEl;
}
function createLinePoints(data, dataIndex, dimensions, coordSys) {
  var points2 = [];
  for (var i = 0; i < dimensions.length; i++) {
    var dimName = dimensions[i];
    var value = data.get(data.mapDimension(dimName), dataIndex);
    if (!isEmptyValue$1(value, coordSys.getAxis(dimName).type)) {
      points2.push(coordSys.dataToPoint(value, dimName));
    }
  }
  return points2;
}
function addEl(data, dataGroup, dataIndex, dimensions, coordSys) {
  var points2 = createLinePoints(data, dataIndex, dimensions, coordSys);
  var line = new Polyline$3({
    shape: {
      points: points2
    },
    z2: 10
  });
  dataGroup.add(line);
  data.setItemGraphicEl(dataIndex, line);
  return line;
}
function makeSeriesScope(seriesModel) {
  var smooth = seriesModel.get("smooth", true);
  smooth === true && (smooth = DEFAULT_SMOOTH);
  smooth = numericToNumber(smooth);
  eqNaN(smooth) && (smooth = 0);
  return {
    smooth
  };
}
function updateElCommon(el, data, dataIndex, seriesScope) {
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.fill = null;
  el.setShape("smooth", seriesScope.smooth);
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel, "lineStyle");
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function isEmptyValue$1(val, axisType) {
  return axisType === "category" ? val == null : val == null || isNaN(val);
}
var ParallelView$3 = ParallelView$2;
var ParallelSeriesModel = function(_super) {
  __extends(ParallelSeriesModel2, _super);
  function ParallelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  ParallelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: bind$1(makeDefaultEncode, null, this)
    });
  };
  ParallelSeriesModel2.prototype.getRawIndicesByActiveState = function(activeState) {
    var coordSys = this.coordinateSystem;
    var data = this.getData();
    var indices = [];
    coordSys.eachActiveState(data, function(theActiveState, dataIndex) {
      if (activeState === theActiveState) {
        indices.push(data.getRawIndex(dataIndex));
      }
    });
    return indices;
  };
  ParallelSeriesModel2.type = "series.parallel";
  ParallelSeriesModel2.dependencies = ["parallel"];
  ParallelSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "parallel",
    parallelIndex: 0,
    label: {
      show: false
    },
    inactiveOpacity: 0.05,
    activeOpacity: 1,
    lineStyle: {
      width: 1,
      opacity: 0.45,
      type: "solid"
    },
    emphasis: {
      label: {
        show: false
      }
    },
    progressive: 500,
    smooth: false,
    animationEasing: "linear"
  };
  return ParallelSeriesModel2;
}(SeriesModel$1);
function makeDefaultEncode(seriesModel) {
  var parallelModel = seriesModel.ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
  if (!parallelModel) {
    return;
  }
  var encodeDefine = {};
  each$f(parallelModel.dimensions, function(axisDim) {
    var dataDimIndex = convertDimNameToNumber(axisDim);
    encodeDefine[axisDim] = dataDimIndex;
  });
  return encodeDefine;
}
function convertDimNameToNumber(dimName) {
  return +dimName.replace("dim", "");
}
var ParallelSeriesModel$1 = ParallelSeriesModel;
var opacityAccessPath = ["lineStyle", "opacity"];
var parallelVisual = {
  seriesType: "parallel",
  reset: function(seriesModel, ecModel) {
    var coordSys = seriesModel.coordinateSystem;
    var opacityMap = {
      normal: seriesModel.get(["lineStyle", "opacity"]),
      active: seriesModel.get("activeOpacity"),
      inactive: seriesModel.get("inactiveOpacity")
    };
    return {
      progress: function(params, data) {
        coordSys.eachActiveState(data, function(activeState, dataIndex) {
          var opacity = opacityMap[activeState];
          if (activeState === "normal" && data.hasItemOption) {
            var itemOpacity = data.getItemModel(dataIndex).get(opacityAccessPath, true);
            itemOpacity != null && (opacity = itemOpacity);
          }
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          existsStyle.opacity = opacity;
        }, params.start, params.end);
      }
    };
  }
};
var parallelVisual$1 = parallelVisual;
function parallelPreprocessor(option) {
  createParallelIfNeeded(option);
  mergeAxisOptionFromParallel(option);
}
function createParallelIfNeeded(option) {
  if (option.parallel) {
    return;
  }
  var hasParallelSeries = false;
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "parallel") {
      hasParallelSeries = true;
    }
  });
  if (hasParallelSeries) {
    option.parallel = [{}];
  }
}
function mergeAxisOptionFromParallel(option) {
  var axes = normalizeToArray(option.parallelAxis);
  each$f(axes, function(axisOption) {
    if (!isObject$4(axisOption)) {
      return;
    }
    var parallelIndex = axisOption.parallelIndex || 0;
    var parallelOption = normalizeToArray(option.parallel)[parallelIndex];
    if (parallelOption && parallelOption.parallelAxisDefault) {
      merge(axisOption, parallelOption.parallelAxisDefault, false);
    }
  });
}
var CLICK_THRESHOLD = 5;
var ParallelView = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    return _this;
  }
  ParallelView2.prototype.render = function(parallelModel, ecModel, api) {
    this._model = parallelModel;
    this._api = api;
    if (!this._handlers) {
      this._handlers = {};
      each$f(handlers$1, function(handler, eventName) {
        api.getZr().on(eventName, this._handlers[eventName] = bind$1(handler, this));
      }, this);
    }
    createOrUpdate(this, "_throttledDispatchExpand", parallelModel.get("axisExpandRate"), "fixRate");
  };
  ParallelView2.prototype.dispose = function(ecModel, api) {
    clear$1(this, "_throttledDispatchExpand");
    each$f(this._handlers, function(handler, eventName) {
      api.getZr().off(eventName, handler);
    });
    this._handlers = null;
  };
  ParallelView2.prototype._throttledDispatchExpand = function(opt) {
    this._dispatchExpand(opt);
  };
  ParallelView2.prototype._dispatchExpand = function(opt) {
    opt && this._api.dispatchAction(extend({
      type: "parallelAxisExpand"
    }, opt));
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ComponentView$1);
var handlers$1 = {
  mousedown: function(e2) {
    if (checkTrigger(this, "click")) {
      this._mouseDownPoint = [e2.offsetX, e2.offsetY];
    }
  },
  mouseup: function(e2) {
    var mouseDownPoint = this._mouseDownPoint;
    if (checkTrigger(this, "click") && mouseDownPoint) {
      var point = [e2.offsetX, e2.offsetY];
      var dist2 = Math.pow(mouseDownPoint[0] - point[0], 2) + Math.pow(mouseDownPoint[1] - point[1], 2);
      if (dist2 > CLICK_THRESHOLD) {
        return;
      }
      var result = this._model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
      result.behavior !== "none" && this._dispatchExpand({
        axisExpandWindow: result.axisExpandWindow
      });
    }
    this._mouseDownPoint = null;
  },
  mousemove: function(e2) {
    if (this._mouseDownPoint || !checkTrigger(this, "mousemove")) {
      return;
    }
    var model = this._model;
    var result = model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
    var behavior = result.behavior;
    behavior === "jump" && this._throttledDispatchExpand.debounceNextCall(model.get("axisExpandDebounce"));
    this._throttledDispatchExpand(behavior === "none" ? null : {
      axisExpandWindow: result.axisExpandWindow,
      animation: behavior === "jump" ? null : {
        duration: 0
      }
    });
  }
};
function checkTrigger(view, triggerOn) {
  var model = view._model;
  return model.get("axisExpandable") && model.get("axisExpandTriggerOn") === triggerOn;
}
var ParallelView$1 = ParallelView;
var ParallelModel = function(_super) {
  __extends(ParallelModel2, _super);
  function ParallelModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelModel2.type;
    return _this;
  }
  ParallelModel2.prototype.init = function() {
    _super.prototype.init.apply(this, arguments);
    this.mergeOption({});
  };
  ParallelModel2.prototype.mergeOption = function(newOption) {
    var thisOption = this.option;
    newOption && merge(thisOption, newOption, true);
    this._initDimensions();
  };
  ParallelModel2.prototype.contains = function(model, ecModel) {
    var parallelIndex = model.get("parallelIndex");
    return parallelIndex != null && ecModel.getComponent("parallel", parallelIndex) === this;
  };
  ParallelModel2.prototype.setAxisExpand = function(opt) {
    each$f(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(name) {
      if (opt.hasOwnProperty(name)) {
        this.option[name] = opt[name];
      }
    }, this);
  };
  ParallelModel2.prototype._initDimensions = function() {
    var dimensions = this.dimensions = [];
    var parallelAxisIndex = this.parallelAxisIndex = [];
    var axisModels = filter(this.ecModel.queryComponents({
      mainType: "parallelAxis"
    }), function(axisModel) {
      return (axisModel.get("parallelIndex") || 0) === this.componentIndex;
    }, this);
    each$f(axisModels, function(axisModel) {
      dimensions.push("dim" + axisModel.get("dim"));
      parallelAxisIndex.push(axisModel.componentIndex);
    });
  };
  ParallelModel2.type = "parallel";
  ParallelModel2.dependencies = ["parallelAxis"];
  ParallelModel2.layoutMode = "box";
  ParallelModel2.defaultOption = {
    z: 0,
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    layout: "horizontal",
    axisExpandable: false,
    axisExpandCenter: null,
    axisExpandCount: 0,
    axisExpandWidth: 50,
    axisExpandRate: 17,
    axisExpandDebounce: 50,
    axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4],
    axisExpandTriggerOn: "click",
    parallelAxisDefault: null
  };
  return ParallelModel2;
}(ComponentModel$1);
var ParallelModel$1 = ParallelModel;
var ParallelAxis = function(_super) {
  __extends(ParallelAxis2, _super);
  function ParallelAxis2(dim, scale2, coordExtent, axisType, axisIndex) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.axisIndex = axisIndex;
    return _this;
  }
  ParallelAxis2.prototype.isHorizontal = function() {
    return this.coordinateSystem.getModel().get("layout") !== "horizontal";
  };
  return ParallelAxis2;
}(Axis$1);
var ParallelAxis$1 = ParallelAxis;
function sliderMove(delta, handleEnds, extent3, handleIndex, minSpan, maxSpan) {
  delta = delta || 0;
  var extentSpan = extent3[1] - extent3[0];
  if (minSpan != null) {
    minSpan = restrict$1(minSpan, [0, extentSpan]);
  }
  if (maxSpan != null) {
    maxSpan = Math.max(maxSpan, minSpan != null ? minSpan : 0);
  }
  if (handleIndex === "all") {
    var handleSpan = Math.abs(handleEnds[1] - handleEnds[0]);
    handleSpan = restrict$1(handleSpan, [0, extentSpan]);
    minSpan = maxSpan = restrict$1(handleSpan, [minSpan, maxSpan]);
    handleIndex = 0;
  }
  handleEnds[0] = restrict$1(handleEnds[0], extent3);
  handleEnds[1] = restrict$1(handleEnds[1], extent3);
  var originalDistSign = getSpanSign(handleEnds, handleIndex);
  handleEnds[handleIndex] += delta;
  var extentMinSpan = minSpan || 0;
  var realExtent = extent3.slice();
  originalDistSign.sign < 0 ? realExtent[0] += extentMinSpan : realExtent[1] -= extentMinSpan;
  handleEnds[handleIndex] = restrict$1(handleEnds[handleIndex], realExtent);
  var currDistSign;
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (minSpan != null && (currDistSign.sign !== originalDistSign.sign || currDistSign.span < minSpan)) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + originalDistSign.sign * minSpan;
  }
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (maxSpan != null && currDistSign.span > maxSpan) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + currDistSign.sign * maxSpan;
  }
  return handleEnds;
}
function getSpanSign(handleEnds, handleIndex) {
  var dist2 = handleEnds[handleIndex] - handleEnds[1 - handleIndex];
  return {
    span: Math.abs(dist2),
    sign: dist2 > 0 ? -1 : dist2 < 0 ? 1 : handleIndex ? -1 : 1
  };
}
function restrict$1(value, extend2) {
  return Math.min(extend2[1] != null ? extend2[1] : Infinity, Math.max(extend2[0] != null ? extend2[0] : -Infinity, value));
}
var each$a = each$f;
var mathMin$2 = Math.min;
var mathMax$2 = Math.max;
var mathFloor = Math.floor;
var mathCeil = Math.ceil;
var round = round$3;
var PI$1 = Math.PI;
var Parallel = function() {
  function Parallel2(parallelModel, ecModel, api) {
    this.type = "parallel";
    this._axesMap = createHashMap();
    this._axesLayout = {};
    this.dimensions = parallelModel.dimensions;
    this._model = parallelModel;
    this._init(parallelModel, ecModel, api);
  }
  Parallel2.prototype._init = function(parallelModel, ecModel, api) {
    var dimensions = parallelModel.dimensions;
    var parallelAxisIndex = parallelModel.parallelAxisIndex;
    each$a(dimensions, function(dim, idx) {
      var axisIndex = parallelAxisIndex[idx];
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axis = this._axesMap.set(dim, new ParallelAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisIndex));
      var isCategory2 = axis.type === "category";
      axis.onBand = isCategory2 && axisModel.get("boundaryGap");
      axis.inverse = axisModel.get("inverse");
      axisModel.axis = axis;
      axis.model = axisModel;
      axis.coordinateSystem = axisModel.coordinateSystem = this;
    }, this);
  };
  Parallel2.prototype.update = function(ecModel, api) {
    this._updateAxesFromSeries(this._model, ecModel);
  };
  Parallel2.prototype.containPoint = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var axisBase = layoutInfo.axisBase;
    var layoutBase = layoutInfo.layoutBase;
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var pAxis = point[1 - pixelDimIndex];
    var pLayout = point[pixelDimIndex];
    return pAxis >= axisBase && pAxis <= axisBase + layoutInfo.axisLength && pLayout >= layoutBase && pLayout <= layoutBase + layoutInfo.layoutLength;
  };
  Parallel2.prototype.getModel = function() {
    return this._model;
  };
  Parallel2.prototype._updateAxesFromSeries = function(parallelModel, ecModel) {
    ecModel.eachSeries(function(seriesModel) {
      if (!parallelModel.contains(seriesModel, ecModel)) {
        return;
      }
      var data = seriesModel.getData();
      each$a(this.dimensions, function(dim) {
        var axis = this._axesMap.get(dim);
        axis.scale.unionExtentFromData(data, data.mapDimension(dim));
        niceScaleExtent(axis.scale, axis.model);
      }, this);
    }, this);
  };
  Parallel2.prototype.resize = function(parallelModel, api) {
    this._rect = getLayoutRect(parallelModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._layoutAxes();
  };
  Parallel2.prototype.getRect = function() {
    return this._rect;
  };
  Parallel2.prototype._makeLayoutInfo = function() {
    var parallelModel = this._model;
    var rect = this._rect;
    var xy = ["x", "y"];
    var wh = ["width", "height"];
    var layout2 = parallelModel.get("layout");
    var pixelDimIndex = layout2 === "horizontal" ? 0 : 1;
    var layoutLength = rect[wh[pixelDimIndex]];
    var layoutExtent = [0, layoutLength];
    var axisCount = this.dimensions.length;
    var axisExpandWidth = restrict(parallelModel.get("axisExpandWidth"), layoutExtent);
    var axisExpandCount = restrict(parallelModel.get("axisExpandCount") || 0, [0, axisCount]);
    var axisExpandable = parallelModel.get("axisExpandable") && axisCount > 3 && axisCount > axisExpandCount && axisExpandCount > 1 && axisExpandWidth > 0 && layoutLength > 0;
    var axisExpandWindow = parallelModel.get("axisExpandWindow");
    var winSize;
    if (!axisExpandWindow) {
      winSize = restrict(axisExpandWidth * (axisExpandCount - 1), layoutExtent);
      var axisExpandCenter = parallelModel.get("axisExpandCenter") || mathFloor(axisCount / 2);
      axisExpandWindow = [axisExpandWidth * axisExpandCenter - winSize / 2];
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    } else {
      winSize = restrict(axisExpandWindow[1] - axisExpandWindow[0], layoutExtent);
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    }
    var axisCollapseWidth = (layoutLength - winSize) / (axisCount - axisExpandCount);
    axisCollapseWidth < 3 && (axisCollapseWidth = 0);
    var winInnerIndices = [mathFloor(round(axisExpandWindow[0] / axisExpandWidth, 1)) + 1, mathCeil(round(axisExpandWindow[1] / axisExpandWidth, 1)) - 1];
    var axisExpandWindow0Pos = axisCollapseWidth / axisExpandWidth * axisExpandWindow[0];
    return {
      layout: layout2,
      pixelDimIndex,
      layoutBase: rect[xy[pixelDimIndex]],
      layoutLength,
      axisBase: rect[xy[1 - pixelDimIndex]],
      axisLength: rect[wh[1 - pixelDimIndex]],
      axisExpandable,
      axisExpandWidth,
      axisCollapseWidth,
      axisExpandWindow,
      axisCount,
      winInnerIndices,
      axisExpandWindow0Pos
    };
  };
  Parallel2.prototype._layoutAxes = function() {
    var rect = this._rect;
    var axes = this._axesMap;
    var dimensions = this.dimensions;
    var layoutInfo = this._makeLayoutInfo();
    var layout2 = layoutInfo.layout;
    axes.each(function(axis) {
      var axisExtent = [0, layoutInfo.axisLength];
      var idx = axis.inverse ? 1 : 0;
      axis.setExtent(axisExtent[idx], axisExtent[1 - idx]);
    });
    each$a(dimensions, function(dim, idx) {
      var posInfo = (layoutInfo.axisExpandable ? layoutAxisWithExpand : layoutAxisWithoutExpand)(idx, layoutInfo);
      var positionTable = {
        horizontal: {
          x: posInfo.position,
          y: layoutInfo.axisLength
        },
        vertical: {
          x: 0,
          y: posInfo.position
        }
      };
      var rotationTable = {
        horizontal: PI$1 / 2,
        vertical: 0
      };
      var position2 = [positionTable[layout2].x + rect.x, positionTable[layout2].y + rect.y];
      var rotation = rotationTable[layout2];
      var transform2 = create$1();
      rotate(transform2, transform2, rotation);
      translate(transform2, transform2, position2);
      this._axesLayout[dim] = {
        position: position2,
        rotation,
        transform: transform2,
        axisNameAvailableWidth: posInfo.axisNameAvailableWidth,
        axisLabelShow: posInfo.axisLabelShow,
        nameTruncateMaxWidth: posInfo.nameTruncateMaxWidth,
        tickDirection: 1,
        labelDirection: 1
      };
    }, this);
  };
  Parallel2.prototype.getAxis = function(dim) {
    return this._axesMap.get(dim);
  };
  Parallel2.prototype.dataToPoint = function(value, dim) {
    return this.axisCoordToPoint(this._axesMap.get(dim).dataToCoord(value), dim);
  };
  Parallel2.prototype.eachActiveState = function(data, callback, start2, end2) {
    start2 == null && (start2 = 0);
    end2 == null && (end2 = data.count());
    var axesMap = this._axesMap;
    var dimensions = this.dimensions;
    var dataDimensions = [];
    var axisModels = [];
    each$f(dimensions, function(axisDim) {
      dataDimensions.push(data.mapDimension(axisDim));
      axisModels.push(axesMap.get(axisDim).model);
    });
    var hasActiveSet = this.hasAxisBrushed();
    for (var dataIndex = start2; dataIndex < end2; dataIndex++) {
      var activeState = void 0;
      if (!hasActiveSet) {
        activeState = "normal";
      } else {
        activeState = "active";
        var values = data.getValues(dataDimensions, dataIndex);
        for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
          var state = axisModels[j].getActiveState(values[j]);
          if (state === "inactive") {
            activeState = "inactive";
            break;
          }
        }
      }
      callback(activeState, dataIndex);
    }
  };
  Parallel2.prototype.hasAxisBrushed = function() {
    var dimensions = this.dimensions;
    var axesMap = this._axesMap;
    var hasActiveSet = false;
    for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
      if (axesMap.get(dimensions[j]).model.getActiveState() !== "normal") {
        hasActiveSet = true;
      }
    }
    return hasActiveSet;
  };
  Parallel2.prototype.axisCoordToPoint = function(coord, dim) {
    var axisLayout = this._axesLayout[dim];
    return applyTransform([coord, 0], axisLayout.transform);
  };
  Parallel2.prototype.getAxisLayout = function(dim) {
    return clone$4(this._axesLayout[dim]);
  };
  Parallel2.prototype.getSlidedAxisExpandWindow = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var axisExpandWindow = layoutInfo.axisExpandWindow.slice();
    var winSize = axisExpandWindow[1] - axisExpandWindow[0];
    var extent3 = [0, layoutInfo.axisExpandWidth * (layoutInfo.axisCount - 1)];
    if (!this.containPoint(point)) {
      return {
        behavior: "none",
        axisExpandWindow
      };
    }
    var pointCoord = point[pixelDimIndex] - layoutInfo.layoutBase - layoutInfo.axisExpandWindow0Pos;
    var delta;
    var behavior = "slide";
    var axisCollapseWidth = layoutInfo.axisCollapseWidth;
    var triggerArea = this._model.get("axisExpandSlideTriggerArea");
    var useJump = triggerArea[0] != null;
    if (axisCollapseWidth) {
      if (useJump && axisCollapseWidth && pointCoord < winSize * triggerArea[0]) {
        behavior = "jump";
        delta = pointCoord - winSize * triggerArea[2];
      } else if (useJump && axisCollapseWidth && pointCoord > winSize * (1 - triggerArea[0])) {
        behavior = "jump";
        delta = pointCoord - winSize * (1 - triggerArea[2]);
      } else {
        (delta = pointCoord - winSize * triggerArea[1]) >= 0 && (delta = pointCoord - winSize * (1 - triggerArea[1])) <= 0 && (delta = 0);
      }
      delta *= layoutInfo.axisExpandWidth / axisCollapseWidth;
      delta ? sliderMove(delta, axisExpandWindow, extent3, "all") : behavior = "none";
    } else {
      var winSize2 = axisExpandWindow[1] - axisExpandWindow[0];
      var pos = extent3[1] * pointCoord / winSize2;
      axisExpandWindow = [mathMax$2(0, pos - winSize2 / 2)];
      axisExpandWindow[1] = mathMin$2(extent3[1], axisExpandWindow[0] + winSize2);
      axisExpandWindow[0] = axisExpandWindow[1] - winSize2;
    }
    return {
      axisExpandWindow,
      behavior
    };
  };
  return Parallel2;
}();
function restrict(len2, extent3) {
  return mathMin$2(mathMax$2(len2, extent3[0]), extent3[1]);
}
function layoutAxisWithoutExpand(axisIndex, layoutInfo) {
  var step = layoutInfo.layoutLength / (layoutInfo.axisCount - 1);
  return {
    position: step * axisIndex,
    axisNameAvailableWidth: step,
    axisLabelShow: true
  };
}
function layoutAxisWithExpand(axisIndex, layoutInfo) {
  var layoutLength = layoutInfo.layoutLength;
  var axisExpandWidth = layoutInfo.axisExpandWidth;
  var axisCount = layoutInfo.axisCount;
  var axisCollapseWidth = layoutInfo.axisCollapseWidth;
  var winInnerIndices = layoutInfo.winInnerIndices;
  var position2;
  var axisNameAvailableWidth = axisCollapseWidth;
  var axisLabelShow = false;
  var nameTruncateMaxWidth;
  if (axisIndex < winInnerIndices[0]) {
    position2 = axisIndex * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  } else if (axisIndex <= winInnerIndices[1]) {
    position2 = layoutInfo.axisExpandWindow0Pos + axisIndex * axisExpandWidth - layoutInfo.axisExpandWindow[0];
    axisNameAvailableWidth = axisExpandWidth;
    axisLabelShow = true;
  } else {
    position2 = layoutLength - (axisCount - 1 - axisIndex) * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  }
  return {
    position: position2,
    axisNameAvailableWidth,
    axisLabelShow,
    nameTruncateMaxWidth
  };
}
var Parallel$1 = Parallel;
function createParallelCoordSys(ecModel, api) {
  var coordSysList = [];
  ecModel.eachComponent("parallel", function(parallelModel, idx) {
    var coordSys = new Parallel$1(parallelModel, ecModel, api);
    coordSys.name = "parallel_" + idx;
    coordSys.resize(parallelModel, api);
    parallelModel.coordinateSystem = coordSys;
    coordSys.model = parallelModel;
    coordSysList.push(coordSys);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "parallel") {
      var parallelModel = seriesModel.getReferringComponents("parallel", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = parallelModel.coordinateSystem;
    }
  });
  return coordSysList;
}
var parallelCoordSysCreator = {
  create: createParallelCoordSys
};
var parallelCoordSysCreator$1 = parallelCoordSysCreator;
var ParallelAxisModel = function(_super) {
  __extends(ParallelAxisModel2, _super);
  function ParallelAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisModel2.type;
    _this.activeIntervals = [];
    return _this;
  }
  ParallelAxisModel2.prototype.getAreaSelectStyle = function() {
    return makeStyleMapper([
      ["fill", "color"],
      ["lineWidth", "borderWidth"],
      ["stroke", "borderColor"],
      ["width", "width"],
      ["opacity", "opacity"]
    ])(this.getModel("areaSelectStyle"));
  };
  ParallelAxisModel2.prototype.setActiveIntervals = function(intervals) {
    var activeIntervals = this.activeIntervals = clone$4(intervals);
    if (activeIntervals) {
      for (var i = activeIntervals.length - 1; i >= 0; i--) {
        asc$2(activeIntervals[i]);
      }
    }
  };
  ParallelAxisModel2.prototype.getActiveState = function(value) {
    var activeIntervals = this.activeIntervals;
    if (!activeIntervals.length) {
      return "normal";
    }
    if (value == null || isNaN(+value)) {
      return "inactive";
    }
    if (activeIntervals.length === 1) {
      var interval = activeIntervals[0];
      if (interval[0] <= value && value <= interval[1]) {
        return "active";
      }
    } else {
      for (var i = 0, len2 = activeIntervals.length; i < len2; i++) {
        if (activeIntervals[i][0] <= value && value <= activeIntervals[i][1]) {
          return "active";
        }
      }
    }
    return "inactive";
  };
  return ParallelAxisModel2;
}(ComponentModel$1);
mixin(ParallelAxisModel, AxisModelCommonMixin);
var ParallelAxisModel$1 = ParallelAxisModel;
var BRUSH_PANEL_GLOBAL = true;
var mathMin$1 = Math.min;
var mathMax$1 = Math.max;
var mathPow = Math.pow;
var COVER_Z = 1e4;
var UNSELECT_THRESHOLD = 6;
var MIN_RESIZE_LINE_WIDTH = 6;
var MUTEX_RESOURCE_KEY = "globalPan";
var DIRECTION_MAP = {
  w: [0, 0],
  e: [0, 1],
  n: [1, 0],
  s: [1, 1]
};
var CURSOR_MAP = {
  w: "ew",
  e: "ew",
  n: "ns",
  s: "ns",
  ne: "nesw",
  sw: "nesw",
  nw: "nwse",
  se: "nwse"
};
var DEFAULT_BRUSH_OPT = {
  brushStyle: {
    lineWidth: 2,
    stroke: "rgba(210,219,238,0.3)",
    fill: "#D2DBEE"
  },
  transformable: true,
  brushMode: "single",
  removeOnClick: false
};
var baseUID = 0;
var BrushController = function(_super) {
  __extends(BrushController2, _super);
  function BrushController2(zr) {
    var _this = _super.call(this) || this;
    _this._track = [];
    _this._covers = [];
    _this._handlers = {};
    _this._zr = zr;
    _this.group = new Group$4();
    _this._uid = "brushController_" + baseUID++;
    each$f(pointerHandlers, function(handler, eventName) {
      this._handlers[eventName] = bind$1(handler, this);
    }, _this);
    return _this;
  }
  BrushController2.prototype.enableBrush = function(brushOption) {
    this._brushType && this._doDisableBrush();
    brushOption.brushType && this._doEnableBrush(brushOption);
    return this;
  };
  BrushController2.prototype._doEnableBrush = function(brushOption) {
    var zr = this._zr;
    if (!this._enableGlobalPan) {
      take(zr, MUTEX_RESOURCE_KEY, this._uid);
    }
    each$f(this._handlers, function(handler, eventName) {
      zr.on(eventName, handler);
    });
    this._brushType = brushOption.brushType;
    this._brushOption = merge(clone$4(DEFAULT_BRUSH_OPT), brushOption, true);
  };
  BrushController2.prototype._doDisableBrush = function() {
    var zr = this._zr;
    release(zr, MUTEX_RESOURCE_KEY, this._uid);
    each$f(this._handlers, function(handler, eventName) {
      zr.off(eventName, handler);
    });
    this._brushType = this._brushOption = null;
  };
  BrushController2.prototype.setPanels = function(panelOpts) {
    if (panelOpts && panelOpts.length) {
      var panels_1 = this._panels = {};
      each$f(panelOpts, function(panelOpts2) {
        panels_1[panelOpts2.panelId] = clone$4(panelOpts2);
      });
    } else {
      this._panels = null;
    }
    return this;
  };
  BrushController2.prototype.mount = function(opt) {
    opt = opt || {};
    this._enableGlobalPan = opt.enableGlobalPan;
    var thisGroup = this.group;
    this._zr.add(thisGroup);
    thisGroup.attr({
      x: opt.x || 0,
      y: opt.y || 0,
      rotation: opt.rotation || 0,
      scaleX: opt.scaleX || 1,
      scaleY: opt.scaleY || 1
    });
    this._transform = thisGroup.getLocalTransform();
    return this;
  };
  BrushController2.prototype.updateCovers = function(coverConfigList) {
    coverConfigList = map$1(coverConfigList, function(coverConfig) {
      return merge(clone$4(DEFAULT_BRUSH_OPT), coverConfig, true);
    });
    var tmpIdPrefix = "\0-brush-index-";
    var oldCovers = this._covers;
    var newCovers = this._covers = [];
    var controller = this;
    var creatingCover = this._creatingCover;
    new DataDiffer$1(oldCovers, coverConfigList, oldGetKey, getKey2).add(addOrUpdate).update(addOrUpdate).remove(remove).execute();
    return this;
    function getKey2(brushOption, index2) {
      return (brushOption.id != null ? brushOption.id : tmpIdPrefix + index2) + "-" + brushOption.brushType;
    }
    function oldGetKey(cover, index2) {
      return getKey2(cover.__brushOption, index2);
    }
    function addOrUpdate(newIndex, oldIndex) {
      var newBrushInternal = coverConfigList[newIndex];
      if (oldIndex != null && oldCovers[oldIndex] === creatingCover) {
        newCovers[newIndex] = oldCovers[oldIndex];
      } else {
        var cover = newCovers[newIndex] = oldIndex != null ? (oldCovers[oldIndex].__brushOption = newBrushInternal, oldCovers[oldIndex]) : endCreating(controller, createCover(controller, newBrushInternal));
        updateCoverAfterCreation(controller, cover);
      }
    }
    function remove(oldIndex) {
      if (oldCovers[oldIndex] !== creatingCover) {
        controller.group.remove(oldCovers[oldIndex]);
      }
    }
  };
  BrushController2.prototype.unmount = function() {
    this.enableBrush(false);
    clearCovers(this);
    this._zr.remove(this.group);
    return this;
  };
  BrushController2.prototype.dispose = function() {
    this.unmount();
    this.off();
  };
  return BrushController2;
}(Eventful$1);
function createCover(controller, brushOption) {
  var cover = coverRenderers[brushOption.brushType].createCover(controller, brushOption);
  cover.__brushOption = brushOption;
  updateZ$1(cover, brushOption);
  controller.group.add(cover);
  return cover;
}
function endCreating(controller, creatingCover) {
  var coverRenderer = getCoverRenderer(creatingCover);
  if (coverRenderer.endCreating) {
    coverRenderer.endCreating(controller, creatingCover);
    updateZ$1(creatingCover, creatingCover.__brushOption);
  }
  return creatingCover;
}
function updateCoverShape(controller, cover) {
  var brushOption = cover.__brushOption;
  getCoverRenderer(cover).updateCoverShape(controller, cover, brushOption.range, brushOption);
}
function updateZ$1(cover, brushOption) {
  var z2 = brushOption.z;
  z2 == null && (z2 = COVER_Z);
  cover.traverse(function(el) {
    el.z = z2;
    el.z2 = z2;
  });
}
function updateCoverAfterCreation(controller, cover) {
  getCoverRenderer(cover).updateCommon(controller, cover);
  updateCoverShape(controller, cover);
}
function getCoverRenderer(cover) {
  return coverRenderers[cover.__brushOption.brushType];
}
function getPanelByPoint(controller, e2, localCursorPoint) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panel;
  var transform2 = controller._transform;
  each$f(panels, function(pn) {
    pn.isTargetByCursor(e2, localCursorPoint, transform2) && (panel = pn);
  });
  return panel;
}
function getPanelByCover(controller, cover) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panelId = cover.__brushOption.panelId;
  return panelId != null ? panels[panelId] : BRUSH_PANEL_GLOBAL;
}
function clearCovers(controller) {
  var covers = controller._covers;
  var originalLength = covers.length;
  each$f(covers, function(cover) {
    controller.group.remove(cover);
  }, controller);
  covers.length = 0;
  return !!originalLength;
}
function trigger(controller, opt) {
  var areas = map$1(controller._covers, function(cover) {
    var brushOption = cover.__brushOption;
    var range3 = clone$4(brushOption.range);
    return {
      brushType: brushOption.brushType,
      panelId: brushOption.panelId,
      range: range3
    };
  });
  controller.trigger("brush", {
    areas,
    isEnd: !!opt.isEnd,
    removeOnClick: !!opt.removeOnClick
  });
}
function shouldShowCover(controller) {
  var track = controller._track;
  if (!track.length) {
    return false;
  }
  var p2 = track[track.length - 1];
  var p1 = track[0];
  var dx = p2[0] - p1[0];
  var dy = p2[1] - p1[1];
  var dist2 = mathPow(dx * dx + dy * dy, 0.5);
  return dist2 > UNSELECT_THRESHOLD;
}
function getTrackEnds(track) {
  var tail = track.length - 1;
  tail < 0 && (tail = 0);
  return [track[0], track[tail]];
}
function createBaseRectCover(rectRangeConverter, controller, brushOption, edgeNameSequences) {
  var cover = new Group$4();
  cover.add(new Rect$3({
    name: "main",
    style: makeStyle(brushOption),
    silent: true,
    draggable: true,
    cursor: "move",
    drift: curry$1(driftRect, rectRangeConverter, controller, cover, ["n", "s", "w", "e"]),
    ondragend: curry$1(trigger, controller, {
      isEnd: true
    })
  }));
  each$f(edgeNameSequences, function(nameSequence) {
    cover.add(new Rect$3({
      name: nameSequence.join(""),
      style: {
        opacity: 0
      },
      draggable: true,
      silent: true,
      invisible: true,
      drift: curry$1(driftRect, rectRangeConverter, controller, cover, nameSequence),
      ondragend: curry$1(trigger, controller, {
        isEnd: true
      })
    }));
  });
  return cover;
}
function updateBaseRect(controller, cover, localRange, brushOption) {
  var lineWidth = brushOption.brushStyle.lineWidth || 0;
  var handleSize = mathMax$1(lineWidth, MIN_RESIZE_LINE_WIDTH);
  var x2 = localRange[0][0];
  var y2 = localRange[1][0];
  var xa = x2 - lineWidth / 2;
  var ya = y2 - lineWidth / 2;
  var x22 = localRange[0][1];
  var y22 = localRange[1][1];
  var x2a = x22 - handleSize + lineWidth / 2;
  var y2a = y22 - handleSize + lineWidth / 2;
  var width = x22 - x2;
  var height = y22 - y2;
  var widtha = width + lineWidth;
  var heighta = height + lineWidth;
  updateRectShape(controller, cover, "main", x2, y2, width, height);
  if (brushOption.transformable) {
    updateRectShape(controller, cover, "w", xa, ya, handleSize, heighta);
    updateRectShape(controller, cover, "e", x2a, ya, handleSize, heighta);
    updateRectShape(controller, cover, "n", xa, ya, widtha, handleSize);
    updateRectShape(controller, cover, "s", xa, y2a, widtha, handleSize);
    updateRectShape(controller, cover, "nw", xa, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "ne", x2a, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "sw", xa, y2a, handleSize, handleSize);
    updateRectShape(controller, cover, "se", x2a, y2a, handleSize, handleSize);
  }
}
function updateCommon$1(controller, cover) {
  var brushOption = cover.__brushOption;
  var transformable = brushOption.transformable;
  var mainEl = cover.childAt(0);
  mainEl.useStyle(makeStyle(brushOption));
  mainEl.attr({
    silent: !transformable,
    cursor: transformable ? "move" : "default"
  });
  each$f([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(nameSequence) {
    var el = cover.childOfName(nameSequence.join(""));
    var globalDir = nameSequence.length === 1 ? getGlobalDirection1(controller, nameSequence[0]) : getGlobalDirection2(controller, nameSequence);
    el && el.attr({
      silent: !transformable,
      invisible: !transformable,
      cursor: transformable ? CURSOR_MAP[globalDir] + "-resize" : null
    });
  });
}
function updateRectShape(controller, cover, name, x2, y2, w2, h) {
  var el = cover.childOfName(name);
  el && el.setShape(pointsToRect(clipByPanel(controller, cover, [[x2, y2], [x2 + w2, y2 + h]])));
}
function makeStyle(brushOption) {
  return defaults({
    strokeNoScale: true
  }, brushOption.brushStyle);
}
function formatRectRange(x2, y2, x22, y22) {
  var min3 = [mathMin$1(x2, x22), mathMin$1(y2, y22)];
  var max3 = [mathMax$1(x2, x22), mathMax$1(y2, y22)];
  return [
    [min3[0], max3[0]],
    [min3[1], max3[1]]
  ];
}
function getTransform(controller) {
  return getTransform$1(controller.group);
}
function getGlobalDirection1(controller, localDirName) {
  var map2 = {
    w: "left",
    e: "right",
    n: "top",
    s: "bottom"
  };
  var inverseMap = {
    left: "w",
    right: "e",
    top: "n",
    bottom: "s"
  };
  var dir3 = transformDirection(map2[localDirName], getTransform(controller));
  return inverseMap[dir3];
}
function getGlobalDirection2(controller, localDirNameSeq) {
  var globalDir = [getGlobalDirection1(controller, localDirNameSeq[0]), getGlobalDirection1(controller, localDirNameSeq[1])];
  (globalDir[0] === "e" || globalDir[0] === "w") && globalDir.reverse();
  return globalDir.join("");
}
function driftRect(rectRangeConverter, controller, cover, dirNameSequence, dx, dy) {
  var brushOption = cover.__brushOption;
  var rectRange = rectRangeConverter.toRectRange(brushOption.range);
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(dirNameSequence, function(dirName) {
    var ind = DIRECTION_MAP[dirName];
    rectRange[ind[0]][ind[1]] += localDelta[ind[0]];
  });
  brushOption.range = rectRangeConverter.fromRectRange(formatRectRange(rectRange[0][0], rectRange[1][0], rectRange[0][1], rectRange[1][1]));
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function driftPolygon(controller, cover, dx, dy) {
  var range3 = cover.__brushOption.range;
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(range3, function(point) {
    point[0] += localDelta[0];
    point[1] += localDelta[1];
  });
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function toLocalDelta(controller, dx, dy) {
  var thisGroup = controller.group;
  var localD = thisGroup.transformCoordToLocal(dx, dy);
  var localZero = thisGroup.transformCoordToLocal(0, 0);
  return [localD[0] - localZero[0], localD[1] - localZero[1]];
}
function clipByPanel(controller, cover, data) {
  var panel = getPanelByCover(controller, cover);
  return panel && panel !== BRUSH_PANEL_GLOBAL ? panel.clipPath(data, controller._transform) : clone$4(data);
}
function pointsToRect(points2) {
  var xmin = mathMin$1(points2[0][0], points2[1][0]);
  var ymin = mathMin$1(points2[0][1], points2[1][1]);
  var xmax = mathMax$1(points2[0][0], points2[1][0]);
  var ymax = mathMax$1(points2[0][1], points2[1][1]);
  return {
    x: xmin,
    y: ymin,
    width: xmax - xmin,
    height: ymax - ymin
  };
}
function resetCursor(controller, e2, localCursorPoint) {
  if (!controller._brushType || isOutsideZrArea(controller, e2.offsetX, e2.offsetY)) {
    return;
  }
  var zr = controller._zr;
  var covers = controller._covers;
  var currPanel = getPanelByPoint(controller, e2, localCursorPoint);
  if (!controller._dragging) {
    for (var i = 0; i < covers.length; i++) {
      var brushOption = covers[i].__brushOption;
      if (currPanel && (currPanel === BRUSH_PANEL_GLOBAL || brushOption.panelId === currPanel.panelId) && coverRenderers[brushOption.brushType].contain(covers[i], localCursorPoint[0], localCursorPoint[1])) {
        return;
      }
    }
  }
  currPanel && zr.setCursorStyle("crosshair");
}
function preventDefault(e2) {
  var rawE = e2.event;
  rawE.preventDefault && rawE.preventDefault();
}
function mainShapeContain(cover, x2, y2) {
  return cover.childOfName("main").contain(x2, y2);
}
function updateCoverByMouse(controller, e2, localCursorPoint, isEnd) {
  var creatingCover = controller._creatingCover;
  var panel = controller._creatingPanel;
  var thisBrushOption = controller._brushOption;
  var eventParams;
  controller._track.push(localCursorPoint.slice());
  if (shouldShowCover(controller) || creatingCover) {
    if (panel && !creatingCover) {
      thisBrushOption.brushMode === "single" && clearCovers(controller);
      var brushOption = clone$4(thisBrushOption);
      brushOption.brushType = determineBrushType(brushOption.brushType, panel);
      brushOption.panelId = panel === BRUSH_PANEL_GLOBAL ? null : panel.panelId;
      creatingCover = controller._creatingCover = createCover(controller, brushOption);
      controller._covers.push(creatingCover);
    }
    if (creatingCover) {
      var coverRenderer = coverRenderers[determineBrushType(controller._brushType, panel)];
      var coverBrushOption = creatingCover.__brushOption;
      coverBrushOption.range = coverRenderer.getCreatingRange(clipByPanel(controller, creatingCover, controller._track));
      if (isEnd) {
        endCreating(controller, creatingCover);
        coverRenderer.updateCommon(controller, creatingCover);
      }
      updateCoverShape(controller, creatingCover);
      eventParams = {
        isEnd
      };
    }
  } else if (isEnd && thisBrushOption.brushMode === "single" && thisBrushOption.removeOnClick) {
    if (getPanelByPoint(controller, e2, localCursorPoint) && clearCovers(controller)) {
      eventParams = {
        isEnd,
        removeOnClick: true
      };
    }
  }
  return eventParams;
}
function determineBrushType(brushType, panel) {
  if (brushType === "auto") {
    return panel.defaultBrushType;
  }
  return brushType;
}
var pointerHandlers = {
  mousedown: function(e2) {
    if (this._dragging) {
      handleDragEnd(this, e2);
    } else if (!e2.target || !e2.target.draggable) {
      preventDefault(e2);
      var localCursorPoint = this.group.transformCoordToLocal(e2.offsetX, e2.offsetY);
      this._creatingCover = null;
      var panel = this._creatingPanel = getPanelByPoint(this, e2, localCursorPoint);
      if (panel) {
        this._dragging = true;
        this._track = [localCursorPoint.slice()];
      }
    }
  },
  mousemove: function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = this.group.transformCoordToLocal(x2, y2);
    resetCursor(this, e2, localCursorPoint);
    if (this._dragging) {
      preventDefault(e2);
      var eventParams = updateCoverByMouse(this, e2, localCursorPoint, false);
      eventParams && trigger(this, eventParams);
    }
  },
  mouseup: function(e2) {
    handleDragEnd(this, e2);
  }
};
function handleDragEnd(controller, e2) {
  if (controller._dragging) {
    preventDefault(e2);
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = controller.group.transformCoordToLocal(x2, y2);
    var eventParams = updateCoverByMouse(controller, e2, localCursorPoint, true);
    controller._dragging = false;
    controller._track = [];
    controller._creatingCover = null;
    eventParams && trigger(controller, eventParams);
  }
}
function isOutsideZrArea(controller, x2, y2) {
  var zr = controller._zr;
  return x2 < 0 || x2 > zr.getWidth() || y2 < 0 || y2 > zr.getHeight();
}
var coverRenderers = {
  lineX: getLineRenderer(0),
  lineY: getLineRenderer(1),
  rect: {
    createCover: function(controller, brushOption) {
      function returnInput(range3) {
        return range3;
      }
      return createBaseRectCover({
        toRectRange: returnInput,
        fromRectRange: returnInput
      }, controller, brushOption, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      return formatRectRange(ends[1][0], ends[1][1], ends[0][0], ends[0][1]);
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      updateBaseRect(controller, cover, localRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  },
  polygon: {
    createCover: function(controller, brushOption) {
      var cover = new Group$4();
      cover.add(new Polyline$3({
        name: "main",
        style: makeStyle(brushOption),
        silent: true
      }));
      return cover;
    },
    getCreatingRange: function(localTrack) {
      return localTrack;
    },
    endCreating: function(controller, cover) {
      cover.remove(cover.childAt(0));
      cover.add(new Polygon$1({
        name: "main",
        draggable: true,
        drift: curry$1(driftPolygon, controller, cover),
        ondragend: curry$1(trigger, controller, {
          isEnd: true
        })
      }));
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      cover.childAt(0).setShape({
        points: clipByPanel(controller, cover, localRange)
      });
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  }
};
function getLineRenderer(xyIndex) {
  return {
    createCover: function(controller, brushOption) {
      return createBaseRectCover({
        toRectRange: function(range3) {
          var rectRange = [range3, [0, 100]];
          xyIndex && rectRange.reverse();
          return rectRange;
        },
        fromRectRange: function(rectRange) {
          return rectRange[xyIndex];
        }
      }, controller, brushOption, [[["w"], ["e"]], [["n"], ["s"]]][xyIndex]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      var min3 = mathMin$1(ends[0][xyIndex], ends[1][xyIndex]);
      var max3 = mathMax$1(ends[0][xyIndex], ends[1][xyIndex]);
      return [min3, max3];
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      var otherExtent;
      var panel = getPanelByCover(controller, cover);
      if (panel !== BRUSH_PANEL_GLOBAL && panel.getLinearBrushOtherExtent) {
        otherExtent = panel.getLinearBrushOtherExtent(xyIndex);
      } else {
        var zr = controller._zr;
        otherExtent = [0, [zr.getWidth(), zr.getHeight()][1 - xyIndex]];
      }
      var rectRange = [localRange, otherExtent];
      xyIndex && rectRange.reverse();
      updateBaseRect(controller, cover, rectRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  };
}
var BrushController$1 = BrushController;
function makeRectPanelClipPath(rect) {
  rect = normalizeRect(rect);
  return function(localPoints) {
    return clipPointsByRect(localPoints, rect);
  };
}
function makeLinearBrushOtherExtent(rect, specifiedXYIndex) {
  rect = normalizeRect(rect);
  return function(xyIndex) {
    var idx = specifiedXYIndex != null ? specifiedXYIndex : xyIndex;
    var brushWidth = idx ? rect.width : rect.height;
    var base2 = idx ? rect.x : rect.y;
    return [base2, base2 + (brushWidth || 0)];
  };
}
function makeRectIsTargetByCursor(rect, api, targetModel) {
  var boundingRect = normalizeRect(rect);
  return function(e2, localCursorPoint) {
    return boundingRect.contain(localCursorPoint[0], localCursorPoint[1]) && !onIrrelevantElement(e2, api, targetModel);
  };
}
function normalizeRect(rect) {
  return BoundingRect$1.create(rect);
}
var elementList$1 = ["axisLine", "axisTickLabel", "axisName"];
var ParallelAxisView = function(_super) {
  __extends(ParallelAxisView2, _super);
  function ParallelAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisView2.type;
    return _this;
  }
  ParallelAxisView2.prototype.init = function(ecModel, api) {
    _super.prototype.init.apply(this, arguments);
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this));
  };
  ParallelAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    if (fromAxisAreaSelect(axisModel, ecModel, payload)) {
      return;
    }
    this.axisModel = axisModel;
    this.api = api;
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var coordSysModel = getCoordSysModel(axisModel, ecModel);
    var coordSys = coordSysModel.coordinateSystem;
    var areaSelectStyle = axisModel.getAreaSelectStyle();
    var areaWidth = areaSelectStyle.width;
    var dim = axisModel.axis.dim;
    var axisLayout = coordSys.getAxisLayout(dim);
    var builderOpt = extend({
      strokeContainThreshold: areaWidth
    }, axisLayout);
    var axisBuilder = new AxisBuilder$1(axisModel, builderOpt);
    each$f(elementList$1, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    this._refreshBrushController(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
  };
  ParallelAxisView2.prototype._refreshBrushController = function(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api) {
    var extent3 = axisModel.axis.getExtent();
    var extentLen = extent3[1] - extent3[0];
    var extra = Math.min(30, Math.abs(extentLen) * 0.1);
    var rect = BoundingRect$1.create({
      x: extent3[0],
      y: -areaWidth / 2,
      width: extentLen,
      height: areaWidth
    });
    rect.x -= extra;
    rect.width += 2 * extra;
    this._brushController.mount({
      enableGlobalPan: true,
      rotation: builderOpt.rotation,
      x: builderOpt.position[0],
      y: builderOpt.position[1]
    }).setPanels([{
      panelId: "pl",
      clipPath: makeRectPanelClipPath(rect),
      isTargetByCursor: makeRectIsTargetByCursor(rect, api, coordSysModel),
      getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect, 0)
    }]).enableBrush({
      brushType: "lineX",
      brushStyle: areaSelectStyle,
      removeOnClick: true
    }).updateCovers(getCoverInfoList(axisModel));
  };
  ParallelAxisView2.prototype._onBrush = function(eventParam) {
    var coverInfoList = eventParam.areas;
    var axisModel = this.axisModel;
    var axis = axisModel.axis;
    var intervals = map$1(coverInfoList, function(coverInfo) {
      return [axis.coordToData(coverInfo.range[0], true), axis.coordToData(coverInfo.range[1], true)];
    });
    if (!axisModel.option.realtime === eventParam.isEnd || eventParam.removeOnClick) {
      this.api.dispatchAction({
        type: "axisAreaSelect",
        parallelAxisId: axisModel.id,
        intervals
      });
    }
  };
  ParallelAxisView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  ParallelAxisView2.type = "parallelAxis";
  return ParallelAxisView2;
}(ComponentView$1);
function fromAxisAreaSelect(axisModel, ecModel, payload) {
  return payload && payload.type === "axisAreaSelect" && ecModel.findComponents({
    mainType: "parallelAxis",
    query: payload
  })[0] === axisModel;
}
function getCoverInfoList(axisModel) {
  var axis = axisModel.axis;
  return map$1(axisModel.activeIntervals, function(interval) {
    return {
      brushType: "lineX",
      panelId: "pl",
      range: [axis.dataToCoord(interval[0], true), axis.dataToCoord(interval[1], true)]
    };
  });
}
function getCoordSysModel(axisModel, ecModel) {
  return ecModel.getComponent("parallel", axisModel.get("parallelIndex"));
}
var ParallelAxisView$1 = ParallelAxisView;
var actionInfo = {
  type: "axisAreaSelect",
  event: "axisAreaSelected"
};
function installParallelActions(registers) {
  registers.registerAction(actionInfo, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallelAxis",
      query: payload
    }, function(parallelAxisModel) {
      parallelAxisModel.axis.model.setActiveIntervals(payload.intervals);
    });
  });
  registers.registerAction("parallelAxisExpand", function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallel",
      query: payload
    }, function(parallelModel) {
      parallelModel.setAxisExpand(payload);
    });
  });
}
var defaultAxisOption = {
  type: "value",
  areaSelectStyle: {
    width: 20,
    borderWidth: 1,
    borderColor: "rgba(160,197,232)",
    color: "rgba(160,197,232)",
    opacity: 0.3
  },
  realtime: true,
  z: 10
};
function install$C(registers) {
  registers.registerComponentView(ParallelView$1);
  registers.registerComponentModel(ParallelModel$1);
  registers.registerCoordinateSystem("parallel", parallelCoordSysCreator$1);
  registers.registerPreprocessor(parallelPreprocessor);
  registers.registerComponentModel(ParallelAxisModel$1);
  registers.registerComponentView(ParallelAxisView$1);
  axisModelCreator(registers, "parallel", ParallelAxisModel$1, defaultAxisOption);
  installParallelActions(registers);
}
function install$B(registers) {
  use(install$C);
  registers.registerChartView(ParallelView$3);
  registers.registerSeriesModel(ParallelSeriesModel$1);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, parallelVisual$1);
}
var SankeyPathShape = function() {
  function SankeyPathShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.cpx2 = 0;
    this.cpy2 = 0;
    this.extent = 0;
  }
  return SankeyPathShape2;
}();
var SankeyPath = function(_super) {
  __extends(SankeyPath2, _super);
  function SankeyPath2(opts) {
    return _super.call(this, opts) || this;
  }
  SankeyPath2.prototype.getDefaultShape = function() {
    return new SankeyPathShape();
  };
  SankeyPath2.prototype.buildPath = function(ctx, shape) {
    var extent3 = shape.extent;
    ctx.moveTo(shape.x1, shape.y1);
    ctx.bezierCurveTo(shape.cpx1, shape.cpy1, shape.cpx2, shape.cpy2, shape.x2, shape.y2);
    if (shape.orient === "vertical") {
      ctx.lineTo(shape.x2 + extent3, shape.y2);
      ctx.bezierCurveTo(shape.cpx2 + extent3, shape.cpy2, shape.cpx1 + extent3, shape.cpy1, shape.x1 + extent3, shape.y1);
    } else {
      ctx.lineTo(shape.x2, shape.y2 + extent3);
      ctx.bezierCurveTo(shape.cpx2, shape.cpy2 + extent3, shape.cpx1, shape.cpy1 + extent3, shape.x1, shape.y1 + extent3);
    }
    ctx.closePath();
  };
  SankeyPath2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  SankeyPath2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  return SankeyPath2;
}(Path$1);
var SankeyView = function(_super) {
  __extends(SankeyView2, _super);
  function SankeyView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeyView2.type;
    _this._focusAdjacencyDisabled = false;
    return _this;
  }
  SankeyView2.prototype.render = function(seriesModel, ecModel, api) {
    var sankeyView = this;
    var graph = seriesModel.getGraph();
    var group = this.group;
    var layoutInfo = seriesModel.layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var nodeData = seriesModel.getData();
    var edgeData = seriesModel.getData("edge");
    var orient = seriesModel.get("orient");
    this._model = seriesModel;
    group.removeAll();
    group.x = layoutInfo.x;
    group.y = layoutInfo.y;
    graph.eachEdge(function(edge) {
      var curve = new SankeyPath();
      var ecData = getECData(curve);
      ecData.dataIndex = edge.dataIndex;
      ecData.seriesIndex = seriesModel.seriesIndex;
      ecData.dataType = "edge";
      var edgeModel = edge.getModel();
      var lineStyleModel = edgeModel.getModel("lineStyle");
      var curvature = lineStyleModel.get("curveness");
      var n1Layout = edge.node1.getLayout();
      var node1Model = edge.node1.getModel();
      var dragX1 = node1Model.get("localX");
      var dragY1 = node1Model.get("localY");
      var n2Layout = edge.node2.getLayout();
      var node2Model = edge.node2.getModel();
      var dragX2 = node2Model.get("localX");
      var dragY2 = node2Model.get("localY");
      var edgeLayout = edge.getLayout();
      var x1;
      var y1;
      var x2;
      var y2;
      var cpx1;
      var cpy1;
      var cpx2;
      var cpy2;
      curve.shape.extent = Math.max(1, edgeLayout.dy);
      curve.shape.orient = orient;
      if (orient === "vertical") {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + edgeLayout.sy;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + n1Layout.dy;
        x2 = (dragX2 != null ? dragX2 * width : n2Layout.x) + edgeLayout.ty;
        y2 = dragY2 != null ? dragY2 * height : n2Layout.y;
        cpx1 = x1;
        cpy1 = y1 * (1 - curvature) + y2 * curvature;
        cpx2 = x2;
        cpy2 = y1 * curvature + y2 * (1 - curvature);
      } else {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + n1Layout.dx;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + edgeLayout.sy;
        x2 = dragX2 != null ? dragX2 * width : n2Layout.x;
        y2 = (dragY2 != null ? dragY2 * height : n2Layout.y) + edgeLayout.ty;
        cpx1 = x1 * (1 - curvature) + x2 * curvature;
        cpy1 = y1;
        cpx2 = x1 * curvature + x2 * (1 - curvature);
        cpy2 = y2;
      }
      curve.setShape({
        x1,
        y1,
        x2,
        y2,
        cpx1,
        cpy1,
        cpx2,
        cpy2
      });
      curve.useStyle(lineStyleModel.getItemStyle());
      switch (curve.style.fill) {
        case "source":
          curve.style.fill = edge.node1.getVisual("color");
          curve.style.decal = edge.node1.getVisual("style").decal;
          break;
        case "target":
          curve.style.fill = edge.node2.getVisual("color");
          curve.style.decal = edge.node2.getVisual("style").decal;
          break;
        case "gradient":
          var sourceColor = edge.node1.getVisual("color");
          var targetColor = edge.node2.getVisual("color");
          if (isString(sourceColor) && isString(targetColor)) {
            curve.style.fill = new LinearGradient$1(0, 0, +(orient === "horizontal"), +(orient === "vertical"), [{
              color: sourceColor,
              offset: 0
            }, {
              color: targetColor,
              offset: 1
            }]);
          }
      }
      var emphasisModel = edgeModel.getModel("emphasis");
      setStatesStylesFromModel(curve, edgeModel, "lineStyle", function(model) {
        return model.getItemStyle();
      });
      group.add(curve);
      edgeData.setItemGraphicEl(edge.dataIndex, curve);
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(curve, focus === "adjacency" ? edge.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
      getECData(curve).dataType = "edge";
    });
    graph.eachNode(function(node) {
      var layout2 = node.getLayout();
      var itemModel = node.getModel();
      var dragX = itemModel.get("localX");
      var dragY = itemModel.get("localY");
      var emphasisModel = itemModel.getModel("emphasis");
      var rect = new Rect$3({
        shape: {
          x: dragX != null ? dragX * width : layout2.x,
          y: dragY != null ? dragY * height : layout2.y,
          width: layout2.dx,
          height: layout2.dy
        },
        style: itemModel.getModel("itemStyle").getItemStyle(),
        z2: 10
      });
      setLabelStyle(rect, getLabelStatesModels(itemModel), {
        labelFetcher: seriesModel,
        labelDataIndex: node.dataIndex,
        defaultText: node.id
      });
      rect.disableLabelAnimation = true;
      rect.setStyle("fill", node.getVisual("color"));
      rect.setStyle("decal", node.getVisual("style").decal);
      setStatesStylesFromModel(rect, itemModel);
      group.add(rect);
      nodeData.setItemGraphicEl(node.dataIndex, rect);
      getECData(rect).dataType = "node";
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(rect, focus === "adjacency" ? node.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    nodeData.eachItemGraphicEl(function(el, dataIndex) {
      var itemModel = nodeData.getItemModel(dataIndex);
      if (itemModel.get("draggable")) {
        el.drift = function(dx, dy) {
          sankeyView._focusAdjacencyDisabled = true;
          this.shape.x += dx;
          this.shape.y += dy;
          this.dirty();
          api.dispatchAction({
            type: "dragNode",
            seriesId: seriesModel.id,
            dataIndex: nodeData.getRawIndex(dataIndex),
            localX: this.shape.x / width,
            localY: this.shape.y / height
          });
        };
        el.ondragend = function() {
          sankeyView._focusAdjacencyDisabled = false;
        };
        el.draggable = true;
        el.cursor = "move";
      }
    });
    if (!this._data && seriesModel.isAnimationEnabled()) {
      group.setClipPath(createGridClipShape$1(group.getBoundingRect(), seriesModel, function() {
        group.removeClipPath();
      }));
    }
    this._data = seriesModel.getData();
  };
  SankeyView2.prototype.dispose = function() {
  };
  SankeyView2.type = "sankey";
  return SankeyView2;
}(ChartView$1);
function createGridClipShape$1(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      width: rect.width + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var SankeyView$1 = SankeyView;
var SankeySeriesModel = function(_super) {
  __extends(SankeySeriesModel2, _super);
  function SankeySeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeySeriesModel2.type;
    return _this;
  }
  SankeySeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var links = option.edges || option.links;
    var nodes = option.data || option.nodes;
    var levels = option.levels;
    this.levelModels = [];
    var levelModels = this.levelModels;
    for (var i = 0; i < levels.length; i++) {
      if (levels[i].depth != null && levels[i].depth >= 0) {
        levelModels[levels[i].depth] = new Model$1(levels[i], this, ecModel);
      }
    }
    if (nodes && links) {
      var graph = createGraphFromNodeEdge(nodes, links, this, true, beforeLink);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var layout2 = seriesModel.getData().getItemLayout(idx);
        if (layout2) {
          var nodeDepth = layout2.depth;
          var levelModel = seriesModel.levelModels[nodeDepth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
      edgeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var edge = seriesModel.getGraph().getEdgeByIndex(idx);
        var layout2 = edge.node1.getLayout();
        if (layout2) {
          var depth = layout2.depth;
          var levelModel = seriesModel.levelModels[depth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
    }
  };
  SankeySeriesModel2.prototype.setNodePosition = function(dataIndex, localPosition) {
    var nodes = this.option.data || this.option.nodes;
    var dataItem = nodes[dataIndex];
    dataItem.localX = localPosition[0];
    dataItem.localY = localPosition[1];
  };
  SankeySeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  SankeySeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  SankeySeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    function noValue(val) {
      return isNaN(val) || val == null;
    }
    if (dataType === "edge") {
      var params = this.getDataParams(dataIndex, dataType);
      var rawDataOpt = params.data;
      var edgeValue = params.value;
      var edgeName = rawDataOpt.source + " -- " + rawDataOpt.target;
      return createTooltipMarkup("nameValue", {
        name: edgeName,
        value: edgeValue,
        noValue: noValue(edgeValue)
      });
    } else {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var value = node.getLayout().value;
      var name_1 = this.getDataParams(dataIndex, dataType).data.name;
      return createTooltipMarkup("nameValue", {
        name: name_1 != null ? name_1 + "" : null,
        value,
        noValue: noValue(value)
      });
    }
  };
  SankeySeriesModel2.prototype.optionUpdated = function() {
  };
  SankeySeriesModel2.prototype.getDataParams = function(dataIndex, dataType) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    if (params.value == null && dataType === "node") {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var nodeValue = node.getLayout().value;
      params.value = nodeValue;
    }
    return params;
  };
  SankeySeriesModel2.type = "series.sankey";
  SankeySeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "5%",
    top: "5%",
    right: "20%",
    bottom: "5%",
    orient: "horizontal",
    nodeWidth: 20,
    nodeGap: 8,
    draggable: true,
    layoutIterations: 32,
    label: {
      show: true,
      position: "right",
      fontSize: 12
    },
    levels: [],
    nodeAlign: "justify",
    lineStyle: {
      color: "#314656",
      opacity: 0.2,
      curveness: 0.5
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        opacity: 0.5
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    animationEasing: "linear",
    animationDuration: 1e3
  };
  return SankeySeriesModel2;
}(SeriesModel$1);
var SankeySeriesModel$1 = SankeySeriesModel;
function sankeyLayout(ecModel, api) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var nodeWidth = seriesModel.get("nodeWidth");
    var nodeGap = seriesModel.get("nodeGap");
    var layoutInfo = getViewRect$1(seriesModel, api);
    seriesModel.layoutInfo = layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    var edges = graph.edges;
    computeNodeValues(nodes);
    var filteredNodes = filter(nodes, function(node) {
      return node.getLayout().value === 0;
    });
    var iterations = filteredNodes.length !== 0 ? 0 : seriesModel.get("layoutIterations");
    var orient = seriesModel.get("orient");
    var nodeAlign = seriesModel.get("nodeAlign");
    layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign);
  });
}
function getViewRect$1(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign) {
  computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign);
  computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient);
  computeEdgeDepths(nodes, orient);
}
function computeNodeValues(nodes) {
  each$f(nodes, function(node) {
    var value1 = sum(node.outEdges, getEdgeValue);
    var value2 = sum(node.inEdges, getEdgeValue);
    var nodeRawValue = node.getValue() || 0;
    var value = Math.max(value1, value2, nodeRawValue);
    node.setLayout({
      value
    }, true);
  });
}
function computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign) {
  var remainEdges = [];
  var indegreeArr = [];
  var zeroIndegrees = [];
  var nextTargetNode = [];
  var x2 = 0;
  for (var i = 0; i < edges.length; i++) {
    remainEdges[i] = 1;
  }
  for (var i = 0; i < nodes.length; i++) {
    indegreeArr[i] = nodes[i].inEdges.length;
    if (indegreeArr[i] === 0) {
      zeroIndegrees.push(nodes[i]);
    }
  }
  var maxNodeDepth = -1;
  while (zeroIndegrees.length) {
    for (var idx = 0; idx < zeroIndegrees.length; idx++) {
      var node = zeroIndegrees[idx];
      var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
      var isItemDepth = item.depth != null && item.depth >= 0;
      if (isItemDepth && item.depth > maxNodeDepth) {
        maxNodeDepth = item.depth;
      }
      node.setLayout({
        depth: isItemDepth ? item.depth : x2
      }, true);
      orient === "vertical" ? node.setLayout({
        dy: nodeWidth
      }, true) : node.setLayout({
        dx: nodeWidth
      }, true);
      for (var edgeIdx = 0; edgeIdx < node.outEdges.length; edgeIdx++) {
        var edge = node.outEdges[edgeIdx];
        var indexEdge = edges.indexOf(edge);
        remainEdges[indexEdge] = 0;
        var targetNode = edge.node2;
        var nodeIndex = nodes.indexOf(targetNode);
        if (--indegreeArr[nodeIndex] === 0 && nextTargetNode.indexOf(targetNode) < 0) {
          nextTargetNode.push(targetNode);
        }
      }
    }
    ++x2;
    zeroIndegrees = nextTargetNode;
    nextTargetNode = [];
  }
  for (var i = 0; i < remainEdges.length; i++) {
    if (remainEdges[i] === 1) {
      throw new Error("Sankey is a DAG, the original data has cycle!");
    }
  }
  var maxDepth = maxNodeDepth > x2 - 1 ? maxNodeDepth : x2 - 1;
  if (nodeAlign && nodeAlign !== "left") {
    adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth);
  }
  var kx = orient === "vertical" ? (height - nodeWidth) / maxDepth : (width - nodeWidth) / maxDepth;
  scaleNodeBreadths(nodes, kx, orient);
}
function isNodeDepth(node) {
  var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
  return item.depth != null && item.depth >= 0;
}
function adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth) {
  if (nodeAlign === "right") {
    var nextSourceNode = [];
    var remainNodes = nodes;
    var nodeHeight = 0;
    while (remainNodes.length) {
      for (var i = 0; i < remainNodes.length; i++) {
        var node = remainNodes[i];
        node.setLayout({
          skNodeHeight: nodeHeight
        }, true);
        for (var j = 0; j < node.inEdges.length; j++) {
          var edge = node.inEdges[j];
          if (nextSourceNode.indexOf(edge.node1) < 0) {
            nextSourceNode.push(edge.node1);
          }
        }
      }
      remainNodes = nextSourceNode;
      nextSourceNode = [];
      ++nodeHeight;
    }
    each$f(nodes, function(node2) {
      if (!isNodeDepth(node2)) {
        node2.setLayout({
          depth: Math.max(0, maxDepth - node2.getLayout().skNodeHeight)
        }, true);
      }
    });
  } else if (nodeAlign === "justify") {
    moveSinksRight(nodes, maxDepth);
  }
}
function moveSinksRight(nodes, maxDepth) {
  each$f(nodes, function(node) {
    if (!isNodeDepth(node) && !node.outEdges.length) {
      node.setLayout({
        depth: maxDepth
      }, true);
    }
  });
}
function scaleNodeBreadths(nodes, kx, orient) {
  each$f(nodes, function(node) {
    var nodeDepth = node.getLayout().depth * kx;
    orient === "vertical" ? node.setLayout({
      y: nodeDepth
    }, true) : node.setLayout({
      x: nodeDepth
    }, true);
  });
}
function computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient) {
  var nodesByBreadth = prepareNodesByBreadth(nodes, orient);
  initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient);
  resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  for (var alpha = 1; iterations > 0; iterations--) {
    alpha *= 0.99;
    relaxRightToLeft(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
    relaxLeftToRight(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  }
}
function prepareNodesByBreadth(nodes, orient) {
  var nodesByBreadth = [];
  var keyAttr = orient === "vertical" ? "y" : "x";
  var groupResult = groupData(nodes, function(node) {
    return node.getLayout()[keyAttr];
  });
  groupResult.keys.sort(function(a, b2) {
    return a - b2;
  });
  each$f(groupResult.keys, function(key) {
    nodesByBreadth.push(groupResult.buckets.get(key));
  });
  return nodesByBreadth;
}
function initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient) {
  var minKy = Infinity;
  each$f(nodesByBreadth, function(nodes) {
    var n2 = nodes.length;
    var sum2 = 0;
    each$f(nodes, function(node) {
      sum2 += node.getLayout().value;
    });
    var ky = orient === "vertical" ? (width - (n2 - 1) * nodeGap) / sum2 : (height - (n2 - 1) * nodeGap) / sum2;
    if (ky < minKy) {
      minKy = ky;
    }
  });
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node, i) {
      var nodeDy = node.getLayout().value * minKy;
      if (orient === "vertical") {
        node.setLayout({
          x: i
        }, true);
        node.setLayout({
          dx: nodeDy
        }, true);
      } else {
        node.setLayout({
          y: i
        }, true);
        node.setLayout({
          dy: nodeDy
        }, true);
      }
    });
  });
  each$f(edges, function(edge) {
    var edgeDy = +edge.getValue() * minKy;
    edge.setLayout({
      dy: edgeDy
    }, true);
  });
}
function resolveCollisions(nodesByBreadth, nodeGap, height, width, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodesByBreadth, function(nodes) {
    nodes.sort(function(a, b2) {
      return a.getLayout()[keyAttr] - b2.getLayout()[keyAttr];
    });
    var nodeX;
    var node;
    var dy;
    var y0 = 0;
    var n2 = nodes.length;
    var nodeDyAttr = orient === "vertical" ? "dx" : "dy";
    for (var i = 0; i < n2; i++) {
      node = nodes[i];
      dy = y0 - node.getLayout()[keyAttr];
      if (dy > 0) {
        nodeX = node.getLayout()[keyAttr] + dy;
        orient === "vertical" ? node.setLayout({
          x: nodeX
        }, true) : node.setLayout({
          y: nodeX
        }, true);
      }
      y0 = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap;
    }
    var viewWidth = orient === "vertical" ? width : height;
    dy = y0 - nodeGap - viewWidth;
    if (dy > 0) {
      nodeX = node.getLayout()[keyAttr] - dy;
      orient === "vertical" ? node.setLayout({
        x: nodeX
      }, true) : node.setLayout({
        y: nodeX
      }, true);
      y0 = nodeX;
      for (var i = n2 - 2; i >= 0; --i) {
        node = nodes[i];
        dy = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap - y0;
        if (dy > 0) {
          nodeX = node.getLayout()[keyAttr] - dy;
          orient === "vertical" ? node.setLayout({
            x: nodeX
          }, true) : node.setLayout({
            y: nodeX
          }, true);
        }
        y0 = node.getLayout()[keyAttr];
      }
    }
  });
}
function relaxRightToLeft(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth.slice().reverse(), function(nodes) {
    each$f(nodes, function(node) {
      if (node.outEdges.length) {
        var y2 = sum(node.outEdges, weightedTarget, orient) / sum(node.outEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.outEdges.length;
          y2 = len2 ? sum(node.outEdges, centerTarget, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function weightedTarget(edge, orient) {
  return center(edge.node2, orient) * edge.getValue();
}
function centerTarget(edge, orient) {
  return center(edge.node2, orient);
}
function weightedSource(edge, orient) {
  return center(edge.node1, orient) * edge.getValue();
}
function centerSource(edge, orient) {
  return center(edge.node1, orient);
}
function center(node, orient) {
  return orient === "vertical" ? node.getLayout().x + node.getLayout().dx / 2 : node.getLayout().y + node.getLayout().dy / 2;
}
function getEdgeValue(edge) {
  return edge.getValue();
}
function sum(array4, cb, orient) {
  var sum2 = 0;
  var len2 = array4.length;
  var i = -1;
  while (++i < len2) {
    var value = +cb(array4[i], orient);
    if (!isNaN(value)) {
      sum2 += value;
    }
  }
  return sum2;
}
function relaxLeftToRight(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node) {
      if (node.inEdges.length) {
        var y2 = sum(node.inEdges, weightedSource, orient) / sum(node.inEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.inEdges.length;
          y2 = len2 ? sum(node.inEdges, centerSource, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function computeEdgeDepths(nodes, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodes, function(node) {
    node.outEdges.sort(function(a, b2) {
      return a.node2.getLayout()[keyAttr] - b2.node2.getLayout()[keyAttr];
    });
    node.inEdges.sort(function(a, b2) {
      return a.node1.getLayout()[keyAttr] - b2.node1.getLayout()[keyAttr];
    });
  });
  each$f(nodes, function(node) {
    var sy = 0;
    var ty = 0;
    each$f(node.outEdges, function(edge) {
      edge.setLayout({
        sy
      }, true);
      sy += edge.getLayout().dy;
    });
    each$f(node.inEdges, function(edge) {
      edge.setLayout({
        ty
      }, true);
      ty += edge.getLayout().dy;
    });
  });
}
function sankeyVisual(ecModel) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    if (nodes.length) {
      var minValue_1 = Infinity;
      var maxValue_1 = -Infinity;
      each$f(nodes, function(node) {
        var nodeValue = node.getLayout().value;
        if (nodeValue < minValue_1) {
          minValue_1 = nodeValue;
        }
        if (nodeValue > maxValue_1) {
          maxValue_1 = nodeValue;
        }
      });
      each$f(nodes, function(node) {
        var mapping = new VisualMapping$1({
          type: "color",
          mappingMethod: "linear",
          dataExtent: [minValue_1, maxValue_1],
          visual: seriesModel.get("color")
        });
        var mapValueToColor = mapping.mapValueToVisual(node.getLayout().value);
        var customColor = node.getModel().get(["itemStyle", "color"]);
        if (customColor != null) {
          node.setVisual("color", customColor);
          node.setVisual("style", {
            fill: customColor
          });
        } else {
          node.setVisual("color", mapValueToColor);
          node.setVisual("style", {
            fill: mapValueToColor
          });
        }
      });
    }
  });
}
function install$A(registers) {
  registers.registerChartView(SankeyView$1);
  registers.registerSeriesModel(SankeySeriesModel$1);
  registers.registerLayout(sankeyLayout);
  registers.registerVisual(sankeyVisual);
  registers.registerAction({
    type: "dragNode",
    event: "dragnode",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sankey",
      query: payload
    }, function(seriesModel) {
      seriesModel.setNodePosition(payload.dataIndex, [payload.localX, payload.localY]);
    });
  });
}
var WhiskerBoxCommonMixin = function() {
  function WhiskerBoxCommonMixin2() {
  }
  WhiskerBoxCommonMixin2.prototype.getInitialData = function(option, ecModel) {
    var ordinalMeta;
    var xAxisModel = ecModel.getComponent("xAxis", this.get("xAxisIndex"));
    var yAxisModel = ecModel.getComponent("yAxis", this.get("yAxisIndex"));
    var xAxisType = xAxisModel.get("type");
    var yAxisType = yAxisModel.get("type");
    var addOrdinal;
    if (xAxisType === "category") {
      option.layout = "horizontal";
      ordinalMeta = xAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else if (yAxisType === "category") {
      option.layout = "vertical";
      ordinalMeta = yAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else {
      option.layout = option.layout || "horizontal";
    }
    var coordDims = ["x", "y"];
    var baseAxisDimIndex = option.layout === "horizontal" ? 0 : 1;
    var baseAxisDim = this._baseAxisDim = coordDims[baseAxisDimIndex];
    var otherAxisDim = coordDims[1 - baseAxisDimIndex];
    var axisModels = [xAxisModel, yAxisModel];
    var baseAxisType = axisModels[baseAxisDimIndex].get("type");
    var otherAxisType = axisModels[1 - baseAxisDimIndex].get("type");
    var data = option.data;
    if (data && addOrdinal) {
      var newOptionData_1 = [];
      each$f(data, function(item, index2) {
        var newItem;
        if (isArray$1(item)) {
          newItem = item.slice();
          item.unshift(index2);
        } else if (isArray$1(item.value)) {
          newItem = extend({}, item);
          newItem.value = newItem.value.slice();
          item.value.unshift(index2);
        } else {
          newItem = item;
        }
        newOptionData_1.push(newItem);
      });
      option.data = newOptionData_1;
    }
    var defaultValueDimensions = this.defaultValueDimensions;
    var coordDimensions = [{
      name: baseAxisDim,
      type: getDimensionTypeByAxis(baseAxisType),
      ordinalMeta,
      otherDims: {
        tooltip: false,
        itemName: 0
      },
      dimsDef: ["base"]
    }, {
      name: otherAxisDim,
      type: getDimensionTypeByAxis(otherAxisType),
      dimsDef: defaultValueDimensions.slice()
    }];
    return createSeriesDataSimply(this, {
      coordDimensions,
      dimensionsCount: defaultValueDimensions.length + 1,
      encodeDefaulter: curry$1(makeSeriesEncodeForAxisCoordSys, coordDimensions, this)
    });
  };
  WhiskerBoxCommonMixin2.prototype.getBaseAxis = function() {
    var dim = this._baseAxisDim;
    return this.ecModel.getComponent(dim + "Axis", this.get(dim + "AxisIndex")).axis;
  };
  return WhiskerBoxCommonMixin2;
}();
var BoxplotSeriesModel = function(_super) {
  __extends(BoxplotSeriesModel2, _super);
  function BoxplotSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "min",
      defaultTooltip: true
    }, {
      name: "Q1",
      defaultTooltip: true
    }, {
      name: "median",
      defaultTooltip: true
    }, {
      name: "Q3",
      defaultTooltip: true
    }, {
      name: "max",
      defaultTooltip: true
    }];
    _this.visualDrawType = "stroke";
    return _this;
  }
  BoxplotSeriesModel2.type = "series.boxplot";
  BoxplotSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  BoxplotSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    boxWidth: [7, 50],
    itemStyle: {
      color: "#fff",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2,
        shadowBlur: 5,
        shadowOffsetX: 1,
        shadowOffsetY: 1,
        shadowColor: "rgba(0,0,0,0.2)"
      }
    },
    animationDuration: 800
  };
  return BoxplotSeriesModel2;
}(SeriesModel$1);
mixin(BoxplotSeriesModel, WhiskerBoxCommonMixin, true);
var BoxplotSeriesModel$1 = BoxplotSeriesModel;
var BoxplotView = function(_super) {
  __extends(BoxplotView2, _super);
  function BoxplotView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotView2.type;
    return _this;
  }
  BoxplotView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var group = this.group;
    var oldData = this._data;
    if (!this._data) {
      group.removeAll();
    }
    var constDim = seriesModel.get("layout") === "horizontal" ? 1 : 0;
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        var symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim, true);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(symbolEl);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (!symbolEl) {
        symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim);
      } else {
        saveOldStyle(symbolEl);
        updateNormalBoxData(itemLayout, symbolEl, data, newIdx);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  BoxplotView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var data = this._data;
    this._data = null;
    data && data.eachItemGraphicEl(function(el) {
      el && group.remove(el);
    });
  };
  BoxplotView2.type = "boxplot";
  return BoxplotView2;
}(ChartView$1);
var BoxPathShape = function() {
  function BoxPathShape2() {
  }
  return BoxPathShape2;
}();
var BoxPath = function(_super) {
  __extends(BoxPath2, _super);
  function BoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "boxplotBoxPath";
    return _this;
  }
  BoxPath2.prototype.getDefaultShape = function() {
    return new BoxPathShape();
  };
  BoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    var i = 0;
    ctx.moveTo(ends[i][0], ends[i][1]);
    i++;
    for (; i < 4; i++) {
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
    ctx.closePath();
    for (; i < ends.length; i++) {
      ctx.moveTo(ends[i][0], ends[i][1]);
      i++;
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
  };
  return BoxPath2;
}(Path$1);
function createNormalBox$1(itemLayout, data, dataIndex, constDim, isInit) {
  var ends = itemLayout.ends;
  var el = new BoxPath({
    shape: {
      points: isInit ? transInit$1(ends, constDim, itemLayout) : ends
    }
  });
  updateNormalBoxData(itemLayout, el, data, dataIndex, isInit);
  return el;
}
function updateNormalBoxData(itemLayout, el, data, dataIndex, isInit) {
  var seriesModel = data.hostModel;
  var updateMethod = graphic[isInit ? "initProps" : "updateProps"];
  updateMethod(el, {
    shape: {
      points: itemLayout.ends
    }
  }, seriesModel, dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.z2 = 100;
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function transInit$1(points2, dim, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[dim] = itemLayout.initBaseline;
    return point;
  });
}
var BoxplotView$1 = BoxplotView;
function boxplotVisual(ecModel, api) {
}
var each$9 = each$f;
function boxplotLayout(ecModel) {
  var groupResult = groupSeriesByAxis(ecModel);
  each$9(groupResult, function(groupItem) {
    var seriesModels = groupItem.seriesModels;
    if (!seriesModels.length) {
      return;
    }
    calculateBase(groupItem);
    each$9(seriesModels, function(seriesModel, idx) {
      layoutSingleSeries(seriesModel, groupItem.boxOffsetList[idx], groupItem.boxWidthList[idx]);
    });
  });
}
function groupSeriesByAxis(ecModel) {
  var result = [];
  var axisList = [];
  ecModel.eachSeriesByType("boxplot", function(seriesModel) {
    var baseAxis = seriesModel.getBaseAxis();
    var idx = indexOf(axisList, baseAxis);
    if (idx < 0) {
      idx = axisList.length;
      axisList[idx] = baseAxis;
      result[idx] = {
        axis: baseAxis,
        seriesModels: []
      };
    }
    result[idx].seriesModels.push(seriesModel);
  });
  return result;
}
function calculateBase(groupItem) {
  var baseAxis = groupItem.axis;
  var seriesModels = groupItem.seriesModels;
  var seriesCount = seriesModels.length;
  var boxWidthList = groupItem.boxWidthList = [];
  var boxOffsetList = groupItem.boxOffsetList = [];
  var boundList = [];
  var bandWidth;
  if (baseAxis.type === "category") {
    bandWidth = baseAxis.getBandWidth();
  } else {
    var maxDataCount_1 = 0;
    each$9(seriesModels, function(seriesModel) {
      maxDataCount_1 = Math.max(maxDataCount_1, seriesModel.getData().count());
    });
    var extent3 = baseAxis.getExtent();
    bandWidth = Math.abs(extent3[1] - extent3[0]) / maxDataCount_1;
  }
  each$9(seriesModels, function(seriesModel) {
    var boxWidthBound = seriesModel.get("boxWidth");
    if (!isArray$1(boxWidthBound)) {
      boxWidthBound = [boxWidthBound, boxWidthBound];
    }
    boundList.push([parsePercent(boxWidthBound[0], bandWidth) || 0, parsePercent(boxWidthBound[1], bandWidth) || 0]);
  });
  var availableWidth = bandWidth * 0.8 - 2;
  var boxGap = availableWidth / seriesCount * 0.3;
  var boxWidth = (availableWidth - boxGap * (seriesCount - 1)) / seriesCount;
  var base2 = boxWidth / 2 - availableWidth / 2;
  each$9(seriesModels, function(seriesModel, idx) {
    boxOffsetList.push(base2);
    base2 += boxGap + boxWidth;
    boxWidthList.push(Math.min(Math.max(boxWidth, boundList[idx][0]), boundList[idx][1]));
  });
}
function layoutSingleSeries(seriesModel, offset, boxWidth) {
  var coordSys = seriesModel.coordinateSystem;
  var data = seriesModel.getData();
  var halfWidth = boxWidth / 2;
  var cDimIdx = seriesModel.get("layout") === "horizontal" ? 0 : 1;
  var vDimIdx = 1 - cDimIdx;
  var coordDims = ["x", "y"];
  var cDim = data.mapDimension(coordDims[cDimIdx]);
  var vDims = data.mapDimensionsAll(coordDims[vDimIdx]);
  if (cDim == null || vDims.length < 5) {
    return;
  }
  for (var dataIndex = 0; dataIndex < data.count(); dataIndex++) {
    var axisDimVal = data.get(cDim, dataIndex);
    var median = getPoint(axisDimVal, vDims[2], dataIndex);
    var end1 = getPoint(axisDimVal, vDims[0], dataIndex);
    var end2 = getPoint(axisDimVal, vDims[1], dataIndex);
    var end4 = getPoint(axisDimVal, vDims[3], dataIndex);
    var end5 = getPoint(axisDimVal, vDims[4], dataIndex);
    var ends = [];
    addBodyEnd(ends, end2, false);
    addBodyEnd(ends, end4, true);
    ends.push(end1, end2, end5, end4);
    layEndLine(ends, end1);
    layEndLine(ends, end5);
    layEndLine(ends, median);
    data.setItemLayout(dataIndex, {
      initBaseline: median[vDimIdx],
      ends
    });
  }
  function getPoint(axisDimVal2, dim, dataIndex2) {
    var val = data.get(dim, dataIndex2);
    var p2 = [];
    p2[cDimIdx] = axisDimVal2;
    p2[vDimIdx] = val;
    var point;
    if (isNaN(axisDimVal2) || isNaN(val)) {
      point = [NaN, NaN];
    } else {
      point = coordSys.dataToPoint(p2);
      point[cDimIdx] += offset;
    }
    return point;
  }
  function addBodyEnd(ends2, point, start2) {
    var point1 = point.slice();
    var point2 = point.slice();
    point1[cDimIdx] += halfWidth;
    point2[cDimIdx] -= halfWidth;
    start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
  }
  function layEndLine(ends2, endCenter) {
    var from = endCenter.slice();
    var to = endCenter.slice();
    from[cDimIdx] -= halfWidth;
    to[cDimIdx] += halfWidth;
    ends2.push(from, to);
  }
}
function prepareBoxplotData(rawData, opt) {
  opt = opt || {};
  var boxData = [];
  var outliers = [];
  var boundIQR = opt.boundIQR;
  var useExtreme = boundIQR === "none" || boundIQR === 0;
  for (var i = 0; i < rawData.length; i++) {
    var ascList = asc$2(rawData[i].slice());
    var Q1 = quantile(ascList, 0.25);
    var Q2 = quantile(ascList, 0.5);
    var Q3 = quantile(ascList, 0.75);
    var min3 = ascList[0];
    var max3 = ascList[ascList.length - 1];
    var bound = (boundIQR == null ? 1.5 : boundIQR) * (Q3 - Q1);
    var low = useExtreme ? min3 : Math.max(min3, Q1 - bound);
    var high = useExtreme ? max3 : Math.min(max3, Q3 + bound);
    var itemNameFormatter = opt.itemNameFormatter;
    var itemName = isFunction(itemNameFormatter) ? itemNameFormatter({
      value: i
    }) : isString(itemNameFormatter) ? itemNameFormatter.replace("{value}", i + "") : i + "";
    boxData.push([itemName, low, Q1, Q2, Q3, high]);
    for (var j = 0; j < ascList.length; j++) {
      var dataItem = ascList[j];
      if (dataItem < low || dataItem > high) {
        var outlier = [itemName, dataItem];
        outliers.push(outlier);
      }
    }
  }
  return {
    boxData,
    outliers
  };
}
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      throwError(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
function install$z(registers) {
  registers.registerSeriesModel(BoxplotSeriesModel$1);
  registers.registerChartView(BoxplotView$1);
  registers.registerVisual(boxplotVisual);
  registers.registerLayout(boxplotLayout);
  registers.registerTransform(boxplotTransform);
}
var SKIP_PROPS = ["color", "borderColor"];
var CandlestickView = function(_super) {
  __extends(CandlestickView2, _super);
  function CandlestickView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickView2.type;
    return _this;
  }
  CandlestickView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeClipPath();
    this._progressiveEls = null;
    this._updateDrawMode(seriesModel);
    this._isLargeDraw ? this._renderLarge(seriesModel) : this._renderNormal(seriesModel);
  };
  CandlestickView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._clear();
    this._updateDrawMode(seriesModel);
  };
  CandlestickView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    this._progressiveEls = [];
    this._isLargeDraw ? this._incrementalRenderLarge(params, seriesModel) : this._incrementalRenderNormal(params, seriesModel);
  };
  CandlestickView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CandlestickView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  CandlestickView2.prototype._renderNormal = function(seriesModel) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var isSimpleBox = data.getLayout("isSimpleBox");
    var needsClip = seriesModel.get("clip", true);
    var coord = seriesModel.coordinateSystem;
    var clipArea = coord.getArea && coord.getArea();
    if (!this._data) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
          return;
        }
        var el = createNormalBox(itemLayout, newIdx, true);
        initProps(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        setBoxCommon(el, data, newIdx, isSimpleBox);
        group.add(el);
        data.setItemGraphicEl(newIdx, el);
      }
    }).update(function(newIdx, oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(el);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
        group.remove(el);
        return;
      }
      if (!el) {
        el = createNormalBox(itemLayout);
      } else {
        updateProps$1(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        saveOldStyle(el);
      }
      setBoxCommon(el, data, newIdx, isSimpleBox);
      group.add(el);
      data.setItemGraphicEl(newIdx, el);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  CandlestickView2.prototype._renderLarge = function(seriesModel) {
    this._clear();
    createLarge(seriesModel, this.group);
    var clipPath = seriesModel.get("clip", true) ? createClipPath(seriesModel.coordinateSystem, false, seriesModel) : null;
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
  };
  CandlestickView2.prototype._incrementalRenderNormal = function(params, seriesModel) {
    var data = seriesModel.getData();
    var isSimpleBox = data.getLayout("isSimpleBox");
    var dataIndex;
    while ((dataIndex = params.next()) != null) {
      var itemLayout = data.getItemLayout(dataIndex);
      var el = createNormalBox(itemLayout);
      setBoxCommon(el, data, dataIndex, isSimpleBox);
      el.incremental = true;
      this.group.add(el);
      this._progressiveEls.push(el);
    }
  };
  CandlestickView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    createLarge(seriesModel, this.group, this._progressiveEls, true);
  };
  CandlestickView2.prototype.remove = function(ecModel) {
    this._clear();
  };
  CandlestickView2.prototype._clear = function() {
    this.group.removeAll();
    this._data = null;
  };
  CandlestickView2.type = "candlestick";
  return CandlestickView2;
}(ChartView$1);
var NormalBoxPathShape = function() {
  function NormalBoxPathShape2() {
  }
  return NormalBoxPathShape2;
}();
var NormalBoxPath = function(_super) {
  __extends(NormalBoxPath2, _super);
  function NormalBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "normalCandlestickBox";
    return _this;
  }
  NormalBoxPath2.prototype.getDefaultShape = function() {
    return new NormalBoxPathShape();
  };
  NormalBoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    if (this.__simpleBox) {
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[6][0], ends[6][1]);
    } else {
      ctx.moveTo(ends[0][0], ends[0][1]);
      ctx.lineTo(ends[1][0], ends[1][1]);
      ctx.lineTo(ends[2][0], ends[2][1]);
      ctx.lineTo(ends[3][0], ends[3][1]);
      ctx.closePath();
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[5][0], ends[5][1]);
      ctx.moveTo(ends[6][0], ends[6][1]);
      ctx.lineTo(ends[7][0], ends[7][1]);
    }
  };
  return NormalBoxPath2;
}(Path$1);
function createNormalBox(itemLayout, dataIndex, isInit) {
  var ends = itemLayout.ends;
  return new NormalBoxPath({
    shape: {
      points: isInit ? transInit(ends, itemLayout) : ends
    },
    z2: 100
  });
}
function isNormalBoxClipped(clipArea, itemLayout) {
  var clipped = true;
  for (var i = 0; i < itemLayout.ends.length; i++) {
    if (clipArea.contain(itemLayout.ends[i][0], itemLayout.ends[i][1])) {
      clipped = false;
      break;
    }
  }
  return clipped;
}
function setBoxCommon(el, data, dataIndex, isSimpleBox) {
  var itemModel = data.getItemModel(dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.__simpleBox = isSimpleBox;
  setStatesStylesFromModel(el, itemModel);
}
function transInit(points2, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[1] = itemLayout.initBaseline;
    return point;
  });
}
var LargeBoxPathShape = function() {
  function LargeBoxPathShape2() {
  }
  return LargeBoxPathShape2;
}();
var LargeBoxPath = function(_super) {
  __extends(LargeBoxPath2, _super);
  function LargeBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeCandlestickBox";
    return _this;
  }
  LargeBoxPath2.prototype.getDefaultShape = function() {
    return new LargeBoxPathShape();
  };
  LargeBoxPath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    for (var i = 0; i < points2.length; ) {
      if (this.__sign === points2[i++]) {
        var x2 = points2[i++];
        ctx.moveTo(x2, points2[i++]);
        ctx.lineTo(x2, points2[i++]);
      } else {
        i += 3;
      }
    }
  };
  return LargeBoxPath2;
}(Path$1);
function createLarge(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var largePoints = data.getLayout("largePoints");
  var elP = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: 1
  });
  group.add(elP);
  var elN = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: -1
  });
  group.add(elN);
  setLargeStyle(1, elP, seriesModel);
  setLargeStyle(-1, elN, seriesModel);
  if (incremental) {
    elP.incremental = true;
    elN.incremental = true;
  }
  if (progressiveEls) {
    progressiveEls.push(elP, elN);
  }
}
function setLargeStyle(sign, el, seriesModel, data) {
  var borderColor = seriesModel.get(["itemStyle", sign > 0 ? "borderColor" : "borderColor0"]) || seriesModel.get(["itemStyle", sign > 0 ? "color" : "color0"]);
  var itemStyle = seriesModel.getModel("itemStyle").getItemStyle(SKIP_PROPS);
  el.useStyle(itemStyle);
  el.style.fill = null;
  el.style.stroke = borderColor;
}
var CandlestickView$1 = CandlestickView;
var CandlestickSeriesModel = function(_super) {
  __extends(CandlestickSeriesModel2, _super);
  function CandlestickSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "open",
      defaultTooltip: true
    }, {
      name: "close",
      defaultTooltip: true
    }, {
      name: "lowest",
      defaultTooltip: true
    }, {
      name: "highest",
      defaultTooltip: true
    }];
    return _this;
  }
  CandlestickSeriesModel2.prototype.getShadowDim = function() {
    return "open";
  };
  CandlestickSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    var itemLayout = data.getItemLayout(dataIndex);
    return itemLayout && selectors.rect(itemLayout.brushRect);
  };
  CandlestickSeriesModel2.type = "series.candlestick";
  CandlestickSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  CandlestickSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    clip: true,
    itemStyle: {
      color: "#eb5454",
      color0: "#47b262",
      borderColor: "#eb5454",
      borderColor0: "#47b262",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2
      }
    },
    barMaxWidth: null,
    barMinWidth: null,
    barWidth: null,
    large: true,
    largeThreshold: 600,
    progressive: 3e3,
    progressiveThreshold: 1e4,
    progressiveChunkMode: "mod",
    animationEasing: "linear",
    animationDuration: 300
  };
  return CandlestickSeriesModel2;
}(SeriesModel$1);
mixin(CandlestickSeriesModel, WhiskerBoxCommonMixin, true);
var CandlestickSeriesModel$1 = CandlestickSeriesModel;
function candlestickPreprocessor(option) {
  if (!option || !isArray$1(option.series)) {
    return;
  }
  each$f(option.series, function(seriesItem) {
    if (isObject$4(seriesItem) && seriesItem.type === "k") {
      seriesItem.type = "candlestick";
    }
  });
}
var positiveBorderColorQuery = ["itemStyle", "borderColor"];
var negativeBorderColorQuery = ["itemStyle", "borderColor0"];
var positiveColorQuery = ["itemStyle", "color"];
var negativeColorQuery = ["itemStyle", "color0"];
var candlestickVisual = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    function getColor(sign, model) {
      return model.get(sign > 0 ? positiveColorQuery : negativeColorQuery);
    }
    function getBorderColor(sign, model) {
      return model.get(sign > 0 ? positiveBorderColorQuery : negativeBorderColorQuery);
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var isLargeRender = seriesModel.pipelineContext.large;
    return !isLargeRender && {
      progress: function(params, data) {
        var dataIndex;
        while ((dataIndex = params.next()) != null) {
          var itemModel = data.getItemModel(dataIndex);
          var sign = data.getItemLayout(dataIndex).sign;
          var style = itemModel.getItemStyle();
          style.fill = getColor(sign, itemModel);
          style.stroke = getBorderColor(sign, itemModel) || style.fill;
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          extend(existsStyle, style);
        }
      }
    };
  }
};
var candlestickVisual$1 = candlestickVisual;
var candlestickLayout = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var data = seriesModel.getData();
    var candleWidth = calculateCandleWidth(seriesModel, data);
    var cDimIdx = 0;
    var vDimIdx = 1;
    var coordDims = ["x", "y"];
    var cDimI = data.getDimensionIndex(data.mapDimension(coordDims[cDimIdx]));
    var vDimsI = map$1(data.mapDimensionsAll(coordDims[vDimIdx]), data.getDimensionIndex, data);
    var openDimI = vDimsI[0];
    var closeDimI = vDimsI[1];
    var lowestDimI = vDimsI[2];
    var highestDimI = vDimsI[3];
    data.setLayout({
      candleWidth,
      isSimpleBox: candleWidth <= 1.3
    });
    if (cDimI < 0 || vDimsI.length < 4) {
      return;
    }
    return {
      progress: seriesModel.pipelineContext.large ? largeProgress : normalProgress
    };
    function normalProgress(params, data2) {
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        var ocLow = Math.min(openVal, closeVal);
        var ocHigh = Math.max(openVal, closeVal);
        var ocLowPoint = getPoint(ocLow, axisDimVal);
        var ocHighPoint = getPoint(ocHigh, axisDimVal);
        var lowestPoint = getPoint(lowestVal, axisDimVal);
        var highestPoint = getPoint(highestVal, axisDimVal);
        var ends = [];
        addBodyEnd(ends, ocHighPoint, 0);
        addBodyEnd(ends, ocLowPoint, 1);
        ends.push(subPixelOptimizePoint(highestPoint), subPixelOptimizePoint(ocHighPoint), subPixelOptimizePoint(lowestPoint), subPixelOptimizePoint(ocLowPoint));
        data2.setItemLayout(dataIndex, {
          sign: getSign(store, dataIndex, openVal, closeVal, closeDimI),
          initBaseline: openVal > closeVal ? ocHighPoint[vDimIdx] : ocLowPoint[vDimIdx],
          ends,
          brushRect: makeBrushRect(lowestVal, highestVal, axisDimVal)
        });
      }
      function getPoint(val, axisDimVal2) {
        var p2 = [];
        p2[cDimIdx] = axisDimVal2;
        p2[vDimIdx] = val;
        return isNaN(axisDimVal2) || isNaN(val) ? [NaN, NaN] : coordSys.dataToPoint(p2);
      }
      function addBodyEnd(ends2, point, start2) {
        var point1 = point.slice();
        var point2 = point.slice();
        point1[cDimIdx] = subPixelOptimize(point1[cDimIdx] + candleWidth / 2, 1, false);
        point2[cDimIdx] = subPixelOptimize(point2[cDimIdx] - candleWidth / 2, 1, true);
        start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
      }
      function makeBrushRect(lowestVal2, highestVal2, axisDimVal2) {
        var pmin = getPoint(lowestVal2, axisDimVal2);
        var pmax = getPoint(highestVal2, axisDimVal2);
        pmin[cDimIdx] -= candleWidth / 2;
        pmax[cDimIdx] -= candleWidth / 2;
        return {
          x: pmin[0],
          y: pmin[1],
          width: candleWidth,
          height: pmax[1] - pmin[1]
        };
      }
      function subPixelOptimizePoint(point) {
        point[cDimIdx] = subPixelOptimize(point[cDimIdx], 1);
        return point;
      }
    }
    function largeProgress(params, data2) {
      var points2 = createFloat32Array(params.count * 4);
      var offset = 0;
      var point;
      var tmpIn = [];
      var tmpOut = [];
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        if (isNaN(axisDimVal) || isNaN(lowestVal) || isNaN(highestVal)) {
          points2[offset++] = NaN;
          offset += 3;
          continue;
        }
        points2[offset++] = getSign(store, dataIndex, openVal, closeVal, closeDimI);
        tmpIn[cDimIdx] = axisDimVal;
        tmpIn[vDimIdx] = lowestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[0] : NaN;
        points2[offset++] = point ? point[1] : NaN;
        tmpIn[vDimIdx] = highestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[1] : NaN;
      }
      data2.setLayout("largePoints", points2);
    }
  }
};
function getSign(store, dataIndex, openVal, closeVal, closeDimI) {
  var sign;
  if (openVal > closeVal) {
    sign = -1;
  } else if (openVal < closeVal) {
    sign = 1;
  } else {
    sign = dataIndex > 0 ? store.get(closeDimI, dataIndex - 1) <= closeVal ? 1 : -1 : 1;
  }
  return sign;
}
function calculateCandleWidth(seriesModel, data) {
  var baseAxis = seriesModel.getBaseAxis();
  var extent3;
  var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : (extent3 = baseAxis.getExtent(), Math.abs(extent3[1] - extent3[0]) / data.count());
  var barMaxWidth = parsePercent(retrieve2(seriesModel.get("barMaxWidth"), bandWidth), bandWidth);
  var barMinWidth = parsePercent(retrieve2(seriesModel.get("barMinWidth"), 1), bandWidth);
  var barWidth = seriesModel.get("barWidth");
  return barWidth != null ? parsePercent(barWidth, bandWidth) : Math.max(Math.min(bandWidth / 2, barMaxWidth), barMinWidth);
}
var candlestickLayout$1 = candlestickLayout;
function install$y(registers) {
  registers.registerChartView(CandlestickView$1);
  registers.registerSeriesModel(CandlestickSeriesModel$1);
  registers.registerPreprocessor(candlestickPreprocessor);
  registers.registerVisual(candlestickVisual$1);
  registers.registerLayout(candlestickLayout$1);
}
function updateRipplePath(rippleGroup, effectCfg) {
  var color = effectCfg.rippleEffectColor || effectCfg.color;
  rippleGroup.eachChild(function(ripplePath) {
    ripplePath.attr({
      z: effectCfg.z,
      zlevel: effectCfg.zlevel,
      style: {
        stroke: effectCfg.brushType === "stroke" ? color : null,
        fill: effectCfg.brushType === "fill" ? color : null
      }
    });
  });
}
var EffectSymbol = function(_super) {
  __extends(EffectSymbol2, _super);
  function EffectSymbol2(data, idx) {
    var _this = _super.call(this) || this;
    var symbol = new SymbolClz(data, idx);
    var rippleGroup = new Group$4();
    _this.add(symbol);
    _this.add(rippleGroup);
    _this.updateData(data, idx);
    return _this;
  }
  EffectSymbol2.prototype.stopEffectAnimation = function() {
    this.childAt(1).removeAll();
  };
  EffectSymbol2.prototype.startEffectAnimation = function(effectCfg) {
    var symbolType = effectCfg.symbolType;
    var color = effectCfg.color;
    var rippleNumber = effectCfg.rippleNumber;
    var rippleGroup = this.childAt(1);
    for (var i = 0; i < rippleNumber; i++) {
      var ripplePath = createSymbol$1(symbolType, -1, -1, 2, 2, color);
      ripplePath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 99,
        silent: true,
        scaleX: 0.5,
        scaleY: 0.5
      });
      var delay = -i / rippleNumber * effectCfg.period + effectCfg.effectOffset;
      ripplePath.animate("", true).when(effectCfg.period, {
        scaleX: effectCfg.rippleScale / 2,
        scaleY: effectCfg.rippleScale / 2
      }).delay(delay).start();
      ripplePath.animateStyle(true).when(effectCfg.period, {
        opacity: 0
      }).delay(delay).start();
      rippleGroup.add(ripplePath);
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.updateEffectAnimation = function(effectCfg) {
    var oldEffectCfg = this._effectCfg;
    var rippleGroup = this.childAt(1);
    var DIFFICULT_PROPS = ["symbolType", "period", "rippleScale", "rippleNumber"];
    for (var i = 0; i < DIFFICULT_PROPS.length; i++) {
      var propName = DIFFICULT_PROPS[i];
      if (oldEffectCfg[propName] !== effectCfg[propName]) {
        this.stopEffectAnimation();
        this.startEffectAnimation(effectCfg);
        return;
      }
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  EffectSymbol2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  EffectSymbol2.prototype.getSymbolType = function() {
    var symbol = this.childAt(0);
    return symbol && symbol.getSymbolType();
  };
  EffectSymbol2.prototype.updateData = function(data, idx) {
    var _this = this;
    var seriesModel = data.hostModel;
    this.childAt(0).updateData(data, idx);
    var rippleGroup = this.childAt(1);
    var itemModel = data.getItemModel(idx);
    var symbolType = data.getItemVisual(idx, "symbol");
    var symbolSize = normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
    var symbolStyle = data.getItemVisual(idx, "style");
    var color = symbolStyle && symbolStyle.fill;
    var emphasisModel = itemModel.getModel("emphasis");
    rippleGroup.setScale(symbolSize);
    rippleGroup.traverse(function(ripplePath) {
      ripplePath.setStyle("fill", color);
    });
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      rippleGroup.x = symbolOffset[0];
      rippleGroup.y = symbolOffset[1];
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    rippleGroup.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
    var effectCfg = {};
    effectCfg.showEffectOn = seriesModel.get("showEffectOn");
    effectCfg.rippleScale = itemModel.get(["rippleEffect", "scale"]);
    effectCfg.brushType = itemModel.get(["rippleEffect", "brushType"]);
    effectCfg.period = itemModel.get(["rippleEffect", "period"]) * 1e3;
    effectCfg.effectOffset = idx / data.count();
    effectCfg.z = seriesModel.getShallow("z") || 0;
    effectCfg.zlevel = seriesModel.getShallow("zlevel") || 0;
    effectCfg.symbolType = symbolType;
    effectCfg.color = color;
    effectCfg.rippleEffectColor = itemModel.get(["rippleEffect", "color"]);
    effectCfg.rippleNumber = itemModel.get(["rippleEffect", "number"]);
    if (effectCfg.showEffectOn === "render") {
      this._effectCfg ? this.updateEffectAnimation(effectCfg) : this.startEffectAnimation(effectCfg);
      this._effectCfg = effectCfg;
    } else {
      this._effectCfg = null;
      this.stopEffectAnimation();
      this.onHoverStateChange = function(toState) {
        if (toState === "emphasis") {
          if (effectCfg.showEffectOn !== "render") {
            _this.startEffectAnimation(effectCfg);
          }
        } else if (toState === "normal") {
          if (effectCfg.showEffectOn !== "render") {
            _this.stopEffectAnimation();
          }
        }
      };
    }
    this._effectCfg = effectCfg;
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  EffectSymbol2.prototype.fadeOut = function(cb) {
    cb && cb();
  };
  return EffectSymbol2;
}(Group$4);
var EffectSymbol$1 = EffectSymbol;
var EffectScatterView = function(_super) {
  __extends(EffectScatterView2, _super);
  function EffectScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterView2.type;
    return _this;
  }
  EffectScatterView2.prototype.init = function() {
    this._symbolDraw = new SymbolDraw$1(EffectSymbol$1);
  };
  EffectScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var effectSymbolDraw = this._symbolDraw;
    effectSymbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this.group.add(effectSymbolDraw.group);
  };
  EffectScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  EffectScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    var res = pointsLayout("").reset(seriesModel, ecModel, api);
    if (res.progress) {
      res.progress({
        start: 0,
        end: data.count(),
        count: data.count()
      }, data);
    }
    this._symbolDraw.updateLayout();
  };
  EffectScatterView2.prototype._updateGroupTransform = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.getRoamTransform) {
      this.group.transform = clone$2(coordSys.getRoamTransform());
      this.group.decomposeTransform();
    }
  };
  EffectScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
  };
  EffectScatterView2.type = "effectScatter";
  return EffectScatterView2;
}(ChartView$1);
var EffectScatterView$1 = EffectScatterView;
var EffectScatterSeriesModel = function(_super) {
  __extends(EffectScatterSeriesModel2, _super);
  function EffectScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  EffectScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  EffectScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  EffectScatterSeriesModel2.type = "series.effectScatter";
  EffectScatterSeriesModel2.dependencies = ["grid", "polar"];
  EffectScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    effectType: "ripple",
    progressive: 0,
    showEffectOn: "render",
    clip: true,
    rippleEffect: {
      period: 4,
      scale: 2.5,
      brushType: "fill",
      number: 3
    },
    universalTransition: {
      divideShape: "clone"
    },
    symbolSize: 10
  };
  return EffectScatterSeriesModel2;
}(SeriesModel$1);
var EffectScatterSeriesModel$1 = EffectScatterSeriesModel;
function install$x(registers) {
  registers.registerChartView(EffectScatterView$1);
  registers.registerSeriesModel(EffectScatterSeriesModel$1);
  registers.registerLayout(pointsLayout("effectScatter"));
}
var EffectLine = function(_super) {
  __extends(EffectLine2, _super);
  function EffectLine2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this.add(_this.createLine(lineData, idx, seriesScope));
    _this._updateEffectSymbol(lineData, idx);
    return _this;
  }
  EffectLine2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Line$1(lineData, idx, seriesScope);
  };
  EffectLine2.prototype._updateEffectSymbol = function(lineData, idx) {
    var itemModel = lineData.getItemModel(idx);
    var effectModel = itemModel.getModel("effect");
    var size = effectModel.get("symbolSize");
    var symbolType = effectModel.get("symbol");
    if (!isArray$1(size)) {
      size = [size, size];
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var color = effectModel.get("color") || lineStyle && lineStyle.stroke;
    var symbol = this.childAt(1);
    if (this._symbolType !== symbolType) {
      this.remove(symbol);
      symbol = createSymbol$1(symbolType, -0.5, -0.5, 1, 1, color);
      symbol.z2 = 100;
      symbol.culling = true;
      this.add(symbol);
    }
    if (!symbol) {
      return;
    }
    symbol.setStyle("shadowColor", color);
    symbol.setStyle(effectModel.getItemStyle(["color"]));
    symbol.scaleX = size[0];
    symbol.scaleY = size[1];
    symbol.setColor(color);
    this._symbolType = symbolType;
    this._symbolScale = size;
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  EffectLine2.prototype._updateEffectAnimation = function(lineData, effectModel, idx) {
    var symbol = this.childAt(1);
    if (!symbol) {
      return;
    }
    var points2 = lineData.getItemLayout(idx);
    var period = effectModel.get("period") * 1e3;
    var loop = effectModel.get("loop");
    var constantSpeed = effectModel.get("constantSpeed");
    var delayExpr = retrieve(effectModel.get("delay"), function(idx2) {
      return idx2 / lineData.count() * period / 3;
    });
    symbol.ignore = true;
    this._updateAnimationPoints(symbol, points2);
    if (constantSpeed > 0) {
      period = this._getLineLength(symbol) / constantSpeed * 1e3;
    }
    if (period !== this._period || loop !== this._loop) {
      symbol.stopAnimation();
      var delayNum = void 0;
      if (isFunction(delayExpr)) {
        delayNum = delayExpr(idx);
      } else {
        delayNum = delayExpr;
      }
      if (symbol.__t > 0) {
        delayNum = -period * symbol.__t;
      }
      this._animateSymbol(symbol, period, delayNum, loop);
    }
    this._period = period;
    this._loop = loop;
  };
  EffectLine2.prototype._animateSymbol = function(symbol, period, delayNum, loop) {
    if (period > 0) {
      symbol.__t = 0;
      var self_1 = this;
      var animator = symbol.animate("", loop).when(period, {
        __t: 1
      }).delay(delayNum).during(function() {
        self_1._updateSymbolPosition(symbol);
      });
      if (!loop) {
        animator.done(function() {
          self_1.remove(symbol);
        });
      }
      animator.start();
    }
  };
  EffectLine2.prototype._getLineLength = function(symbol) {
    return dist$1(symbol.__p1, symbol.__cp1) + dist$1(symbol.__cp1, symbol.__p2);
  };
  EffectLine2.prototype._updateAnimationPoints = function(symbol, points2) {
    symbol.__p1 = points2[0];
    symbol.__p2 = points2[1];
    symbol.__cp1 = points2[2] || [(points2[0][0] + points2[1][0]) / 2, (points2[0][1] + points2[1][1]) / 2];
  };
  EffectLine2.prototype.updateData = function(lineData, idx, seriesScope) {
    this.childAt(0).updateData(lineData, idx, seriesScope);
    this._updateEffectSymbol(lineData, idx);
  };
  EffectLine2.prototype._updateSymbolPosition = function(symbol) {
    var p1 = symbol.__p1;
    var p2 = symbol.__p2;
    var cp1 = symbol.__cp1;
    var t2 = symbol.__t;
    var pos = [symbol.x, symbol.y];
    var lastPos = pos.slice();
    var quadraticAt2 = quadraticAt$1;
    var quadraticDerivativeAt$1 = quadraticDerivativeAt;
    pos[0] = quadraticAt2(p1[0], cp1[0], p2[0], t2);
    pos[1] = quadraticAt2(p1[1], cp1[1], p2[1], t2);
    var tx = quadraticDerivativeAt$1(p1[0], cp1[0], p2[0], t2);
    var ty = quadraticDerivativeAt$1(p1[1], cp1[1], p2[1], t2);
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    if (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") {
      if (symbol.__lastT !== void 0 && symbol.__lastT < symbol.__t) {
        symbol.scaleY = dist$1(lastPos, pos) * 1.05;
        if (t2 === 1) {
          pos[0] = lastPos[0] + (pos[0] - lastPos[0]) / 2;
          pos[1] = lastPos[1] + (pos[1] - lastPos[1]) / 2;
        }
      } else if (symbol.__lastT === 1) {
        symbol.scaleY = 2 * dist$1(p1, pos);
      } else {
        symbol.scaleY = this._symbolScale[1];
      }
    }
    symbol.__lastT = symbol.__t;
    symbol.ignore = false;
    symbol.x = pos[0];
    symbol.y = pos[1];
  };
  EffectLine2.prototype.updateLayout = function(lineData, idx) {
    this.childAt(0).updateLayout(lineData, idx);
    var effectModel = lineData.getItemModel(idx).getModel("effect");
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  return EffectLine2;
}(Group$4);
var EffectLine$1 = EffectLine;
var Polyline = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createPolyline(lineData, idx, seriesScope);
    return _this;
  }
  Polyline2.prototype._createPolyline = function(lineData, idx, seriesScope) {
    var points2 = lineData.getItemLayout(idx);
    var line = new Polyline$3({
      shape: {
        points: points2
      }
    });
    this.add(line);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childAt(0);
    var target = {
      shape: {
        points: lineData.getItemLayout(idx)
      }
    };
    updateProps$1(line, target, seriesModel, idx);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var line = this.childAt(0);
    var itemModel = lineData.getItemModel(idx);
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    if (!seriesScope || lineData.hasItemOption) {
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
    }
    line.useStyle(lineData.getItemVisual(idx, "style"));
    line.style.fill = null;
    line.style.strokeNoScale = true;
    var lineEmphasisState = line.ensureState("emphasis");
    lineEmphasisState.style = emphasisLineStyle;
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Polyline2.prototype.updateLayout = function(lineData, idx) {
    var polyline = this.childAt(0);
    polyline.setShape("points", lineData.getItemLayout(idx));
  };
  return Polyline2;
}(Group$4);
var Polyline$1 = Polyline;
var EffectPolyline = function(_super) {
  __extends(EffectPolyline2, _super);
  function EffectPolyline2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._lastFrame = 0;
    _this._lastFramePercent = 0;
    return _this;
  }
  EffectPolyline2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Polyline$1(lineData, idx, seriesScope);
  };
  EffectPolyline2.prototype._updateAnimationPoints = function(symbol, points2) {
    this._points = points2;
    var accLenArr = [0];
    var len2 = 0;
    for (var i = 1; i < points2.length; i++) {
      var p1 = points2[i - 1];
      var p2 = points2[i];
      len2 += dist$1(p1, p2);
      accLenArr.push(len2);
    }
    if (len2 === 0) {
      this._length = 0;
      return;
    }
    for (var i = 0; i < accLenArr.length; i++) {
      accLenArr[i] /= len2;
    }
    this._offsets = accLenArr;
    this._length = len2;
  };
  EffectPolyline2.prototype._getLineLength = function() {
    return this._length;
  };
  EffectPolyline2.prototype._updateSymbolPosition = function(symbol) {
    var t2 = symbol.__t;
    var points2 = this._points;
    var offsets = this._offsets;
    var len2 = points2.length;
    if (!offsets) {
      return;
    }
    var lastFrame = this._lastFrame;
    var frame;
    if (t2 < this._lastFramePercent) {
      var start2 = Math.min(lastFrame + 1, len2 - 1);
      for (frame = start2; frame >= 0; frame--) {
        if (offsets[frame] <= t2) {
          break;
        }
      }
      frame = Math.min(frame, len2 - 2);
    } else {
      for (frame = lastFrame; frame < len2; frame++) {
        if (offsets[frame] > t2) {
          break;
        }
      }
      frame = Math.min(frame - 1, len2 - 2);
    }
    var p2 = (t2 - offsets[frame]) / (offsets[frame + 1] - offsets[frame]);
    var p0 = points2[frame];
    var p1 = points2[frame + 1];
    symbol.x = p0[0] * (1 - p2) + p2 * p1[0];
    symbol.y = p0[1] * (1 - p2) + p2 * p1[1];
    var tx = p1[0] - p0[0];
    var ty = p1[1] - p0[1];
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    this._lastFrame = frame;
    this._lastFramePercent = t2;
    symbol.ignore = false;
  };
  return EffectPolyline2;
}(EffectLine$1);
var EffectPolyline$1 = EffectPolyline;
var LargeLinesPathShape = function() {
  function LargeLinesPathShape2() {
    this.polyline = false;
    this.curveness = 0;
    this.segs = [];
  }
  return LargeLinesPathShape2;
}();
var LargeLinesPath = function(_super) {
  __extends(LargeLinesPath2, _super);
  function LargeLinesPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeLinesPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeLinesPath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  LargeLinesPath2.prototype.getDefaultShape = function() {
    return new LargeLinesPathShape();
  };
  LargeLinesPath2.prototype.buildPath = function(ctx, shape) {
    var segs = shape.segs;
    var curveness = shape.curveness;
    var i;
    if (shape.polyline) {
      for (i = this._off; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          ctx.moveTo(segs[i++], segs[i++]);
          for (var k2 = 1; k2 < count2; k2++) {
            ctx.lineTo(segs[i++], segs[i++]);
          }
        }
      }
    } else {
      for (i = this._off; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        ctx.moveTo(x0, y0);
        if (curveness > 0) {
          var x2 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y2 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          ctx.quadraticCurveTo(x2, y2, x1, y1);
        } else {
          ctx.lineTo(x1, y1);
        }
      }
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeLinesPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var segs = shape.segs;
    var curveness = shape.curveness;
    var lineWidth = this.style.lineWidth;
    if (shape.polyline) {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          var x0 = segs[i++];
          var y0 = segs[i++];
          for (var k2 = 1; k2 < count2; k2++) {
            var x1 = segs[i++];
            var y1 = segs[i++];
            if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
              return dataIndex;
            }
          }
        }
        dataIndex++;
      }
    } else {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        if (curveness > 0) {
          var x22 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y22 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          if (containStroke$2(x0, y0, x22, y22, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        } else {
          if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        }
        dataIndex++;
      }
    }
    return -1;
  };
  LargeLinesPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeLinesPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.segs;
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX, minY, maxX, maxY);
    }
    return rect;
  };
  return LargeLinesPath2;
}(Path$1);
var LargeLineDraw = function() {
  function LargeLineDraw2() {
    this.group = new Group$4();
  }
  LargeLineDraw2.prototype.updateData = function(data) {
    this._clear();
    var lineEl = this._create();
    lineEl.setShape({
      segs: data.getLayout("linesPoints")
    });
    this._setCommon(lineEl, data);
  };
  LargeLineDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this.group.removeAll();
    this._clear();
  };
  LargeLineDraw2.prototype.incrementalUpdate = function(taskParams, data) {
    var lastAdded = this._newAdded[0];
    var linePoints = data.getLayout("linesPoints");
    var oldSegs = lastAdded && lastAdded.shape.segs;
    if (oldSegs && oldSegs.length < 2e4) {
      var oldLen = oldSegs.length;
      var newSegs = new Float32Array(oldLen + linePoints.length);
      newSegs.set(oldSegs);
      newSegs.set(linePoints, oldLen);
      lastAdded.setShape({
        segs: newSegs
      });
    } else {
      this._newAdded = [];
      var lineEl = this._create();
      lineEl.incremental = true;
      lineEl.setShape({
        segs: linePoints
      });
      this._setCommon(lineEl, data);
      lineEl.__startIndex = taskParams.start;
    }
  };
  LargeLineDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeLineDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeLineDraw2.prototype._create = function() {
    var lineEl = new LargeLinesPath({
      cursor: "default"
    });
    this._newAdded.push(lineEl);
    this.group.add(lineEl);
    return lineEl;
  };
  LargeLineDraw2.prototype._setCommon = function(lineEl, data, isIncremental) {
    var hostModel = data.hostModel;
    lineEl.setShape({
      polyline: hostModel.get("polyline"),
      curveness: hostModel.get(["lineStyle", "curveness"])
    });
    lineEl.useStyle(hostModel.getModel("lineStyle").getLineStyle());
    lineEl.style.strokeNoScale = true;
    var style = data.getVisual("style");
    if (style && style.stroke) {
      lineEl.setStyle("stroke", style.stroke);
    }
    lineEl.setStyle("fill", null);
    var ecData = getECData(lineEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    lineEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = lineEl.hoverDataIdx;
      if (dataIndex > 0) {
        ecData.dataIndex = dataIndex + lineEl.__startIndex;
      }
    });
  };
  LargeLineDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeLineDraw2;
}();
var LargeLineDraw$1 = LargeLineDraw;
var linesLayout = {
  seriesType: "lines",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var isPolyline = seriesModel.get("polyline");
    var isLarge = seriesModel.pipelineContext.large;
    return {
      progress: function(params, lineData) {
        var lineCoords = [];
        if (isLarge) {
          var points2 = void 0;
          var segCount = params.end - params.start;
          if (isPolyline) {
            var totalCoordsCount = 0;
            for (var i = params.start; i < params.end; i++) {
              totalCoordsCount += seriesModel.getLineCoordsCount(i);
            }
            points2 = new Float32Array(segCount + totalCoordsCount * 2);
          } else {
            points2 = new Float32Array(segCount * 4);
          }
          var offset = 0;
          var pt = [];
          for (var i = params.start; i < params.end; i++) {
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            if (isPolyline) {
              points2[offset++] = len2;
            }
            for (var k2 = 0; k2 < len2; k2++) {
              pt = coordSys.dataToPoint(lineCoords[k2], false, pt);
              points2[offset++] = pt[0];
              points2[offset++] = pt[1];
            }
          }
          lineData.setLayout("linesPoints", points2);
        } else {
          for (var i = params.start; i < params.end; i++) {
            var itemModel = lineData.getItemModel(i);
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            var pts = [];
            if (isPolyline) {
              for (var j = 0; j < len2; j++) {
                pts.push(coordSys.dataToPoint(lineCoords[j]));
              }
            } else {
              pts[0] = coordSys.dataToPoint(lineCoords[0]);
              pts[1] = coordSys.dataToPoint(lineCoords[1]);
              var curveness = itemModel.get(["lineStyle", "curveness"]);
              if (+curveness) {
                pts[2] = [(pts[0][0] + pts[1][0]) / 2 - (pts[0][1] - pts[1][1]) * curveness, (pts[0][1] + pts[1][1]) / 2 - (pts[1][0] - pts[0][0]) * curveness];
              }
            }
            lineData.setItemLayout(i, pts);
          }
        }
      }
    };
  }
};
var linesLayout$1 = linesLayout;
var LinesView = function(_super) {
  __extends(LinesView2, _super);
  function LinesView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesView2.type;
    return _this;
  }
  LinesView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    var zlevel = seriesModel.get("zlevel");
    var trailLength = seriesModel.get(["effect", "trailLength"]);
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg) {
      zr.painter.getLayer(zlevel).clear(true);
    }
    if (this._lastZlevel != null && !isSvg) {
      zr.configLayer(this._lastZlevel, {
        motionBlur: false
      });
    }
    if (this._showEffect(seriesModel) && trailLength > 0) {
      if (!isSvg) {
        zr.configLayer(zlevel, {
          motionBlur: true,
          lastFrameAlpha: Math.max(Math.min(trailLength / 10 + 0.9, 1), 0)
        });
      }
    }
    lineDraw.updateData(data);
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
    this._lastZlevel = zlevel;
    this._finished = true;
  };
  LinesView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    lineDraw.incrementalPrepareUpdate(data);
    this._clearLayer(api);
    this._finished = false;
  };
  LinesView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._lineDraw.incrementalUpdate(taskParams, seriesModel.getData());
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  LinesView2.prototype.eachRendered = function(cb) {
    this._lineDraw && this._lineDraw.eachRendered(cb);
  };
  LinesView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var pipelineContext = seriesModel.pipelineContext;
    if (!this._finished || pipelineContext.large || pipelineContext.progressiveRender) {
      return {
        update: true
      };
    } else {
      var res = linesLayout$1.reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._lineDraw.updateLayout();
      this._clearLayer(api);
    }
  };
  LinesView2.prototype._updateLineDraw = function(data, seriesModel) {
    var lineDraw = this._lineDraw;
    var hasEffect = this._showEffect(seriesModel);
    var isPolyline = !!seriesModel.get("polyline");
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!lineDraw || hasEffect !== this._hasEffet || isPolyline !== this._isPolyline || isLargeDraw !== this._isLargeDraw) {
      if (lineDraw) {
        lineDraw.remove();
      }
      lineDraw = this._lineDraw = isLargeDraw ? new LargeLineDraw$1() : new LineDraw$1(isPolyline ? hasEffect ? EffectPolyline$1 : Polyline$1 : hasEffect ? EffectLine$1 : Line$1);
      this._hasEffet = hasEffect;
      this._isPolyline = isPolyline;
      this._isLargeDraw = isLargeDraw;
    }
    this.group.add(lineDraw.group);
    return lineDraw;
  };
  LinesView2.prototype._showEffect = function(seriesModel) {
    return !!seriesModel.get(["effect", "show"]);
  };
  LinesView2.prototype._clearLayer = function(api) {
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg && this._lastZlevel != null) {
      zr.painter.getLayer(this._lastZlevel).clear(true);
    }
  };
  LinesView2.prototype.remove = function(ecModel, api) {
    this._lineDraw && this._lineDraw.remove();
    this._lineDraw = null;
    this._clearLayer(api);
  };
  LinesView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  LinesView2.type = "lines";
  return LinesView2;
}(ChartView$1);
var LinesView$1 = LinesView;
var Uint32Arr = typeof Uint32Array === "undefined" ? Array : Uint32Array;
var Float64Arr = typeof Float64Array === "undefined" ? Array : Float64Array;
function compatEc2(seriesOpt) {
  var data = seriesOpt.data;
  if (data && data[0] && data[0][0] && data[0][0].coord) {
    seriesOpt.data = map$1(data, function(itemOpt) {
      var coords = [itemOpt[0].coord, itemOpt[1].coord];
      var target = {
        coords
      };
      if (itemOpt[0].name) {
        target.fromName = itemOpt[0].name;
      }
      if (itemOpt[1].name) {
        target.toName = itemOpt[1].name;
      }
      return mergeAll([target, itemOpt[0], itemOpt[1]]);
    });
  }
}
var LinesSeriesModel = function(_super) {
  __extends(LinesSeriesModel2, _super);
  function LinesSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  LinesSeriesModel2.prototype.init = function(option) {
    option.data = option.data || [];
    compatEc2(option);
    var result = this._processFlatCoordsArray(option.data);
    this._flatCoords = result.flatCoords;
    this._flatCoordsOffset = result.flatCoordsOffset;
    if (result.flatCoords) {
      option.data = new Float32Array(result.count);
    }
    _super.prototype.init.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.mergeOption = function(option) {
    compatEc2(option);
    if (option.data) {
      var result = this._processFlatCoordsArray(option.data);
      this._flatCoords = result.flatCoords;
      this._flatCoordsOffset = result.flatCoordsOffset;
      if (result.flatCoords) {
        option.data = new Float32Array(result.count);
      }
    }
    _super.prototype.mergeOption.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.appendData = function(params) {
    var result = this._processFlatCoordsArray(params.data);
    if (result.flatCoords) {
      if (!this._flatCoords) {
        this._flatCoords = result.flatCoords;
        this._flatCoordsOffset = result.flatCoordsOffset;
      } else {
        this._flatCoords = concatArray(this._flatCoords, result.flatCoords);
        this._flatCoordsOffset = concatArray(this._flatCoordsOffset, result.flatCoordsOffset);
      }
      params.data = new Float32Array(result.count);
    }
    this.getRawData().appendData(params.data);
  };
  LinesSeriesModel2.prototype._getCoordsFromItemModel = function(idx) {
    var itemModel = this.getData().getItemModel(idx);
    var coords = itemModel.option instanceof Array ? itemModel.option : itemModel.getShallow("coords");
    return coords;
  };
  LinesSeriesModel2.prototype.getLineCoordsCount = function(idx) {
    if (this._flatCoordsOffset) {
      return this._flatCoordsOffset[idx * 2 + 1];
    } else {
      return this._getCoordsFromItemModel(idx).length;
    }
  };
  LinesSeriesModel2.prototype.getLineCoords = function(idx, out2) {
    if (this._flatCoordsOffset) {
      var offset = this._flatCoordsOffset[idx * 2];
      var len2 = this._flatCoordsOffset[idx * 2 + 1];
      for (var i = 0; i < len2; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = this._flatCoords[offset + i * 2];
        out2[i][1] = this._flatCoords[offset + i * 2 + 1];
      }
      return len2;
    } else {
      var coords = this._getCoordsFromItemModel(idx);
      for (var i = 0; i < coords.length; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = coords[i][0];
        out2[i][1] = coords[i][1];
      }
      return coords.length;
    }
  };
  LinesSeriesModel2.prototype._processFlatCoordsArray = function(data) {
    var startOffset = 0;
    if (this._flatCoords) {
      startOffset = this._flatCoords.length;
    }
    if (isNumber(data[0])) {
      var len2 = data.length;
      var coordsOffsetAndLenStorage = new Uint32Arr(len2);
      var coordsStorage = new Float64Arr(len2);
      var coordsCursor = 0;
      var offsetCursor = 0;
      var dataCount = 0;
      for (var i = 0; i < len2; ) {
        dataCount++;
        var count2 = data[i++];
        coordsOffsetAndLenStorage[offsetCursor++] = coordsCursor + startOffset;
        coordsOffsetAndLenStorage[offsetCursor++] = count2;
        for (var k2 = 0; k2 < count2; k2++) {
          var x2 = data[i++];
          var y2 = data[i++];
          coordsStorage[coordsCursor++] = x2;
          coordsStorage[coordsCursor++] = y2;
        }
      }
      return {
        flatCoordsOffset: new Uint32Array(coordsOffsetAndLenStorage.buffer, 0, offsetCursor),
        flatCoords: coordsStorage,
        count: dataCount
      };
    }
    return {
      flatCoordsOffset: null,
      flatCoords: null,
      count: data.length
    };
  };
  LinesSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var lineData = new SeriesData$1(["value"], this);
    lineData.hasItemOption = false;
    lineData.initData(option.data, [], function(dataItem, dimName, dataIndex, dimIndex) {
      if (dataItem instanceof Array) {
        return NaN;
      } else {
        lineData.hasItemOption = true;
        var value = dataItem.value;
        if (value != null) {
          return value instanceof Array ? value[dimIndex] : value;
        }
      }
    });
    return lineData;
  };
  LinesSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var itemModel = data.getItemModel(dataIndex);
    var name = itemModel.get("name");
    if (name) {
      return name;
    }
    var fromName = itemModel.get("fromName");
    var toName = itemModel.get("toName");
    var nameArr = [];
    fromName != null && nameArr.push(fromName);
    toName != null && nameArr.push(toName);
    return createTooltipMarkup("nameValue", {
      name: nameArr.join(" > ")
    });
  };
  LinesSeriesModel2.prototype.preventIncremental = function() {
    return !!this.get(["effect", "show"]);
  };
  LinesSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 1e4 : this.get("progressive");
    }
    return progressive;
  };
  LinesSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 2e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  LinesSeriesModel2.prototype.getZLevelKey = function() {
    var effectModel = this.getModel("effect");
    var trailLength = effectModel.get("trailLength");
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : effectModel.get("show") && trailLength > 0 ? trailLength + "" : "";
  };
  LinesSeriesModel2.type = "series.lines";
  LinesSeriesModel2.dependencies = ["grid", "polar", "geo", "calendar"];
  LinesSeriesModel2.defaultOption = {
    coordinateSystem: "geo",
    z: 2,
    legendHoverLink: true,
    xAxisIndex: 0,
    yAxisIndex: 0,
    symbol: ["none", "none"],
    symbolSize: [10, 10],
    geoIndex: 0,
    effect: {
      show: false,
      period: 4,
      constantSpeed: 0,
      symbol: "circle",
      symbolSize: 3,
      loop: true,
      trailLength: 0.2
    },
    large: false,
    largeThreshold: 2e3,
    polyline: false,
    clip: true,
    label: {
      show: false,
      position: "end"
    },
    lineStyle: {
      opacity: 0.5
    }
  };
  return LinesSeriesModel2;
}(SeriesModel$1);
var LinesSeriesModel$1 = LinesSeriesModel;
function normalize$1(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
var linesVisual = {
  seriesType: "lines",
  reset: function(seriesModel) {
    var symbolType = normalize$1(seriesModel.get("symbol"));
    var symbolSize = normalize$1(seriesModel.get("symbolSize"));
    var data = seriesModel.getData();
    data.setVisual("fromSymbol", symbolType && symbolType[0]);
    data.setVisual("toSymbol", symbolType && symbolType[1]);
    data.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    data.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      var symbolType2 = normalize$1(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$1(itemModel.getShallow("symbolSize", true));
      symbolType2[0] && data2.setItemVisual(idx, "fromSymbol", symbolType2[0]);
      symbolType2[1] && data2.setItemVisual(idx, "toSymbol", symbolType2[1]);
      symbolSize2[0] && data2.setItemVisual(idx, "fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && data2.setItemVisual(idx, "toSymbolSize", symbolSize2[1]);
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
var linesVisual$1 = linesVisual;
function install$w(registers) {
  registers.registerChartView(LinesView$1);
  registers.registerSeriesModel(LinesSeriesModel$1);
  registers.registerLayout(linesLayout$1);
  registers.registerVisual(linesVisual$1);
}
var GRADIENT_LEVELS = 256;
var HeatmapLayer = function() {
  function HeatmapLayer2() {
    this.blurSize = 30;
    this.pointSize = 20;
    this.maxOpacity = 1;
    this.minOpacity = 0;
    this._gradientPixels = {
      inRange: null,
      outOfRange: null
    };
    var canvas = platformApi.createCanvas();
    this.canvas = canvas;
  }
  HeatmapLayer2.prototype.update = function(data, width, height, normalize2, colorFunc, isInRange) {
    var brush2 = this._getBrush();
    var gradientInRange = this._getGradient(colorFunc, "inRange");
    var gradientOutOfRange = this._getGradient(colorFunc, "outOfRange");
    var r2 = this.pointSize + this.blurSize;
    var canvas = this.canvas;
    var ctx = canvas.getContext("2d");
    var len2 = data.length;
    canvas.width = width;
    canvas.height = height;
    for (var i = 0; i < len2; ++i) {
      var p2 = data[i];
      var x2 = p2[0];
      var y2 = p2[1];
      var value = p2[2];
      var alpha = normalize2(value);
      ctx.globalAlpha = alpha;
      ctx.drawImage(brush2, x2 - r2, y2 - r2);
    }
    if (!canvas.width || !canvas.height) {
      return canvas;
    }
    var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    var pixels = imageData.data;
    var offset = 0;
    var pixelLen = pixels.length;
    var minOpacity = this.minOpacity;
    var maxOpacity = this.maxOpacity;
    var diffOpacity = maxOpacity - minOpacity;
    while (offset < pixelLen) {
      var alpha = pixels[offset + 3] / 256;
      var gradientOffset = Math.floor(alpha * (GRADIENT_LEVELS - 1)) * 4;
      if (alpha > 0) {
        var gradient = isInRange(alpha) ? gradientInRange : gradientOutOfRange;
        alpha > 0 && (alpha = alpha * diffOpacity + minOpacity);
        pixels[offset++] = gradient[gradientOffset];
        pixels[offset++] = gradient[gradientOffset + 1];
        pixels[offset++] = gradient[gradientOffset + 2];
        pixels[offset++] = gradient[gradientOffset + 3] * alpha * 256;
      } else {
        offset += 4;
      }
    }
    ctx.putImageData(imageData, 0, 0);
    return canvas;
  };
  HeatmapLayer2.prototype._getBrush = function() {
    var brushCanvas = this._brushCanvas || (this._brushCanvas = platformApi.createCanvas());
    var r2 = this.pointSize + this.blurSize;
    var d2 = r2 * 2;
    brushCanvas.width = d2;
    brushCanvas.height = d2;
    var ctx = brushCanvas.getContext("2d");
    ctx.clearRect(0, 0, d2, d2);
    ctx.shadowOffsetX = d2;
    ctx.shadowBlur = this.blurSize;
    ctx.shadowColor = "#000";
    ctx.beginPath();
    ctx.arc(-r2, r2, this.pointSize, 0, Math.PI * 2, true);
    ctx.closePath();
    ctx.fill();
    return brushCanvas;
  };
  HeatmapLayer2.prototype._getGradient = function(colorFunc, state) {
    var gradientPixels = this._gradientPixels;
    var pixelsSingleState = gradientPixels[state] || (gradientPixels[state] = new Uint8ClampedArray(256 * 4));
    var color = [0, 0, 0, 0];
    var off = 0;
    for (var i = 0; i < 256; i++) {
      colorFunc[state](i / 255, true, color);
      pixelsSingleState[off++] = color[0];
      pixelsSingleState[off++] = color[1];
      pixelsSingleState[off++] = color[2];
      pixelsSingleState[off++] = color[3];
    }
    return pixelsSingleState;
  };
  return HeatmapLayer2;
}();
var HeatmapLayer$1 = HeatmapLayer;
function getIsInPiecewiseRange(dataExtent, pieceList, selected) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  pieceList = map$1(pieceList, function(piece) {
    return {
      interval: [(piece.interval[0] - dataExtent[0]) / dataSpan, (piece.interval[1] - dataExtent[0]) / dataSpan]
    };
  });
  var len2 = pieceList.length;
  var lastIndex = 0;
  return function(val) {
    var i;
    for (i = lastIndex; i < len2; i++) {
      var interval = pieceList[i].interval;
      if (interval[0] <= val && val <= interval[1]) {
        lastIndex = i;
        break;
      }
    }
    if (i === len2) {
      for (i = lastIndex - 1; i >= 0; i--) {
        var interval = pieceList[i].interval;
        if (interval[0] <= val && val <= interval[1]) {
          lastIndex = i;
          break;
        }
      }
    }
    return i >= 0 && i < len2 && selected[i];
  };
}
function getIsInContinuousRange(dataExtent, range3) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  range3 = [(range3[0] - dataExtent[0]) / dataSpan, (range3[1] - dataExtent[0]) / dataSpan];
  return function(val) {
    return val >= range3[0] && val <= range3[1];
  };
}
function isGeoCoordSys(coordSys) {
  var dimensions = coordSys.dimensions;
  return dimensions[0] === "lng" && dimensions[1] === "lat";
}
var HeatmapView = function(_super) {
  __extends(HeatmapView2, _super);
  function HeatmapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapView2.type;
    return _this;
  }
  HeatmapView2.prototype.render = function(seriesModel, ecModel, api) {
    var visualMapOfThisSeries;
    ecModel.eachComponent("visualMap", function(visualMap) {
      visualMap.eachTargetSeries(function(targetSeries) {
        if (targetSeries === seriesModel) {
          visualMapOfThisSeries = visualMap;
        }
      });
    });
    this._progressiveEls = null;
    this.group.removeAll();
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type === "cartesian2d" || coordSys.type === "calendar") {
      this._renderOnCartesianAndCalendar(seriesModel, api, 0, seriesModel.getData().count());
    } else if (isGeoCoordSys(coordSys)) {
      this._renderOnGeo(coordSys, seriesModel, visualMapOfThisSeries, api);
    }
  };
  HeatmapView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this.group.removeAll();
  };
  HeatmapView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys) {
      if (isGeoCoordSys(coordSys)) {
        this.render(seriesModel, ecModel, api);
      } else {
        this._progressiveEls = [];
        this._renderOnCartesianAndCalendar(seriesModel, api, params.start, params.end, true);
      }
    }
  };
  HeatmapView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  HeatmapView2.prototype._renderOnCartesianAndCalendar = function(seriesModel, api, start2, end2, incremental) {
    var coordSys = seriesModel.coordinateSystem;
    var width;
    var height;
    var xAxisExtent;
    var yAxisExtent;
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      width = xAxis.getBandWidth();
      height = yAxis.getBandWidth();
      xAxisExtent = xAxis.scale.getExtent();
      yAxisExtent = yAxis.scale.getExtent();
    }
    var group = this.group;
    var data = seriesModel.getData();
    var emphasisStyle = seriesModel.getModel(["emphasis", "itemStyle"]).getItemStyle();
    var blurStyle = seriesModel.getModel(["blur", "itemStyle"]).getItemStyle();
    var selectStyle = seriesModel.getModel(["select", "itemStyle"]).getItemStyle();
    var borderRadius = seriesModel.get(["itemStyle", "borderRadius"]);
    var labelStatesModels = getLabelStatesModels(seriesModel);
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    var dataDims = isCoordinateSystemType(coordSys, "cartesian2d") ? [data.mapDimension("x"), data.mapDimension("y"), data.mapDimension("value")] : [data.mapDimension("time"), data.mapDimension("value")];
    for (var idx = start2; idx < end2; idx++) {
      var rect = void 0;
      var style = data.getItemVisual(idx, "style");
      if (isCoordinateSystemType(coordSys, "cartesian2d")) {
        var dataDimX = data.get(dataDims[0], idx);
        var dataDimY = data.get(dataDims[1], idx);
        if (isNaN(data.get(dataDims[2], idx)) || dataDimX < xAxisExtent[0] || dataDimX > xAxisExtent[1] || dataDimY < yAxisExtent[0] || dataDimY > yAxisExtent[1]) {
          continue;
        }
        var point = coordSys.dataToPoint([dataDimX, dataDimY]);
        rect = new Rect$3({
          shape: {
            x: Math.floor(Math.round(point[0]) - width / 2),
            y: Math.floor(Math.round(point[1]) - height / 2),
            width: Math.ceil(width),
            height: Math.ceil(height)
          },
          style
        });
      } else {
        if (isNaN(data.get(dataDims[1], idx))) {
          continue;
        }
        rect = new Rect$3({
          z2: 1,
          shape: coordSys.dataToRect([data.get(dataDims[0], idx)]).contentShape,
          style
        });
      }
      if (data.hasItemOption) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel_1 = itemModel.getModel("emphasis");
        emphasisStyle = emphasisModel_1.getModel("itemStyle").getItemStyle();
        blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
        selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
        borderRadius = itemModel.get(["itemStyle", "borderRadius"]);
        focus = emphasisModel_1.get("focus");
        blurScope = emphasisModel_1.get("blurScope");
        emphasisDisabled = emphasisModel_1.get("disabled");
        labelStatesModels = getLabelStatesModels(itemModel);
      }
      rect.shape.r = borderRadius;
      var rawValue = seriesModel.getRawValue(idx);
      var defaultText = "-";
      if (rawValue && rawValue[2] != null) {
        defaultText = rawValue[2] + "";
      }
      setLabelStyle(rect, labelStatesModels, {
        labelFetcher: seriesModel,
        labelDataIndex: idx,
        defaultOpacity: style.opacity,
        defaultText
      });
      rect.ensureState("emphasis").style = emphasisStyle;
      rect.ensureState("blur").style = blurStyle;
      rect.ensureState("select").style = selectStyle;
      toggleHoverEmphasis(rect, focus, blurScope, emphasisDisabled);
      rect.incremental = incremental;
      if (incremental) {
        rect.states.emphasis.hoverLayer = true;
      }
      group.add(rect);
      data.setItemGraphicEl(idx, rect);
      if (this._progressiveEls) {
        this._progressiveEls.push(rect);
      }
    }
  };
  HeatmapView2.prototype._renderOnGeo = function(geo, seriesModel, visualMapModel, api) {
    var inRangeVisuals = visualMapModel.targetVisuals.inRange;
    var outOfRangeVisuals = visualMapModel.targetVisuals.outOfRange;
    var data = seriesModel.getData();
    var hmLayer = this._hmLayer || this._hmLayer || new HeatmapLayer$1();
    hmLayer.blurSize = seriesModel.get("blurSize");
    hmLayer.pointSize = seriesModel.get("pointSize");
    hmLayer.minOpacity = seriesModel.get("minOpacity");
    hmLayer.maxOpacity = seriesModel.get("maxOpacity");
    var rect = geo.getViewRect().clone();
    var roamTransform = geo.getRoamTransform();
    rect.applyTransform(roamTransform);
    var x2 = Math.max(rect.x, 0);
    var y2 = Math.max(rect.y, 0);
    var x22 = Math.min(rect.width + rect.x, api.getWidth());
    var y22 = Math.min(rect.height + rect.y, api.getHeight());
    var width = x22 - x2;
    var height = y22 - y2;
    var dims = [data.mapDimension("lng"), data.mapDimension("lat"), data.mapDimension("value")];
    var points2 = data.mapArray(dims, function(lng, lat, value) {
      var pt = geo.dataToPoint([lng, lat]);
      pt[0] -= x2;
      pt[1] -= y2;
      pt.push(value);
      return pt;
    });
    var dataExtent = visualMapModel.getExtent();
    var isInRange = visualMapModel.type === "visualMap.continuous" ? getIsInContinuousRange(dataExtent, visualMapModel.option.range) : getIsInPiecewiseRange(dataExtent, visualMapModel.getPieceList(), visualMapModel.option.selected);
    hmLayer.update(points2, width, height, inRangeVisuals.color.getNormalizer(), {
      inRange: inRangeVisuals.color.getColorMapper(),
      outOfRange: outOfRangeVisuals.color.getColorMapper()
    }, isInRange);
    var img = new ZRImage$1({
      style: {
        width,
        height,
        x: x2,
        y: y2,
        image: hmLayer.canvas
      },
      silent: true
    });
    this.group.add(img);
  };
  HeatmapView2.type = "heatmap";
  return HeatmapView2;
}(ChartView$1);
var HeatmapView$1 = HeatmapView;
var HeatmapSeriesModel = function(_super) {
  __extends(HeatmapSeriesModel2, _super);
  function HeatmapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapSeriesModel2.type;
    return _this;
  }
  HeatmapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      generateCoord: "value"
    });
  };
  HeatmapSeriesModel2.prototype.preventIncremental = function() {
    var coordSysCreator = CoordinateSystem.get(this.get("coordinateSystem"));
    if (coordSysCreator && coordSysCreator.dimensions) {
      return coordSysCreator.dimensions[0] === "lng" && coordSysCreator.dimensions[1] === "lat";
    }
  };
  HeatmapSeriesModel2.type = "series.heatmap";
  HeatmapSeriesModel2.dependencies = ["grid", "geo", "calendar"];
  HeatmapSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    geoIndex: 0,
    blurSize: 30,
    pointSize: 20,
    maxOpacity: 1,
    minOpacity: 0,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return HeatmapSeriesModel2;
}(SeriesModel$1);
var HeatmapSeriesModel$1 = HeatmapSeriesModel;
function install$v(registers) {
  registers.registerChartView(HeatmapView$1);
  registers.registerSeriesModel(HeatmapSeriesModel$1);
}
var BAR_BORDER_WIDTH_QUERY = ["itemStyle", "borderWidth"];
var LAYOUT_ATTRS = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}];
var pathForLineWidth = new Circle$1();
var PictorialBarView = function(_super) {
  __extends(PictorialBarView2, _super);
  function PictorialBarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarView2.type;
    return _this;
  }
  PictorialBarView2.prototype.render = function(seriesModel, ecModel, api) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var coordSysRect = cartesian.master.getRect();
    var opt = {
      ecSize: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      seriesModel,
      coordSys: cartesian,
      coordSysExtent: [[coordSysRect.x, coordSysRect.x + coordSysRect.width], [coordSysRect.y, coordSysRect.y + coordSysRect.height]],
      isHorizontal,
      valueDim: LAYOUT_ATTRS[+isHorizontal],
      categoryDim: LAYOUT_ATTRS[1 - +isHorizontal]
    };
    data.diff(oldData).add(function(dataIndex) {
      if (!data.hasValue(dataIndex)) {
        return;
      }
      var itemModel = getItemModel(data, dataIndex);
      var symbolMeta = getSymbolMeta(data, dataIndex, itemModel, opt);
      var bar = createBar(data, opt, symbolMeta);
      data.setItemGraphicEl(dataIndex, bar);
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).update(function(newIndex, oldIndex) {
      var bar = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex)) {
        group.remove(bar);
        return;
      }
      var itemModel = getItemModel(data, newIndex);
      var symbolMeta = getSymbolMeta(data, newIndex, itemModel, opt);
      var pictorialShapeStr = getShapeStr(data, symbolMeta);
      if (bar && pictorialShapeStr !== bar.__pictorialShapeStr) {
        group.remove(bar);
        data.setItemGraphicEl(newIndex, null);
        bar = null;
      }
      if (bar) {
        updateBar(bar, opt, symbolMeta);
      } else {
        bar = createBar(data, opt, symbolMeta, true);
      }
      data.setItemGraphicEl(newIndex, bar);
      bar.__pictorialSymbolMeta = symbolMeta;
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).remove(function(dataIndex) {
      var bar = oldData.getItemGraphicEl(dataIndex);
      bar && removeBar(oldData, dataIndex, bar.__pictorialSymbolMeta.animationModel, bar);
    }).execute();
    this._data = data;
    return this.group;
  };
  PictorialBarView2.prototype.remove = function(ecModel, api) {
    var group = this.group;
    var data = this._data;
    if (ecModel.get("animation")) {
      if (data) {
        data.eachItemGraphicEl(function(bar) {
          removeBar(data, getECData(bar).dataIndex, ecModel, bar);
        });
      }
    } else {
      group.removeAll();
    }
  };
  PictorialBarView2.type = "pictorialBar";
  return PictorialBarView2;
}(ChartView$1);
function getSymbolMeta(data, dataIndex, itemModel, opt) {
  var layout2 = data.getItemLayout(dataIndex);
  var symbolRepeat = itemModel.get("symbolRepeat");
  var symbolClip = itemModel.get("symbolClip");
  var symbolPosition = itemModel.get("symbolPosition") || "start";
  var symbolRotate = itemModel.get("symbolRotate");
  var rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  var symbolPatternSize = itemModel.get("symbolPatternSize") || 2;
  var isAnimationEnabled2 = itemModel.isAnimationEnabled();
  var symbolMeta = {
    dataIndex,
    layout: layout2,
    itemModel,
    symbolType: data.getItemVisual(dataIndex, "symbol") || "circle",
    style: data.getItemVisual(dataIndex, "style"),
    symbolClip,
    symbolRepeat,
    symbolRepeatDirection: itemModel.get("symbolRepeatDirection"),
    symbolPatternSize,
    rotation,
    animationModel: isAnimationEnabled2 ? itemModel : null,
    hoverScale: isAnimationEnabled2 && itemModel.get(["emphasis", "scale"]),
    z2: itemModel.getShallow("z", true) || 0
  };
  prepareBarLength(itemModel, symbolRepeat, layout2, opt, symbolMeta);
  prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, symbolMeta.boundingLength, symbolMeta.pxSign, symbolPatternSize, opt, symbolMeta);
  prepareLineWidth(itemModel, symbolMeta.symbolScale, rotation, opt, symbolMeta);
  var symbolSize = symbolMeta.symbolSize;
  var symbolOffset = normalizeSymbolOffset(itemModel.get("symbolOffset"), symbolSize);
  prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, symbolMeta.valueLineWidth, symbolMeta.boundingLength, symbolMeta.repeatCutLength, opt, symbolMeta);
  return symbolMeta;
}
function prepareBarLength(itemModel, symbolRepeat, layout2, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var symbolBoundingData = itemModel.get("symbolBoundingData");
  var valueAxis2 = opt.coordSys.getOtherAxis(opt.coordSys.getBaseAxis());
  var zeroPx = valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(0));
  var pxSignIdx = 1 - +(layout2[valueDim.wh] <= 0);
  var boundingLength;
  if (isArray$1(symbolBoundingData)) {
    var symbolBoundingExtent = [convertToCoordOnAxis(valueAxis2, symbolBoundingData[0]) - zeroPx, convertToCoordOnAxis(valueAxis2, symbolBoundingData[1]) - zeroPx];
    symbolBoundingExtent[1] < symbolBoundingExtent[0] && symbolBoundingExtent.reverse();
    boundingLength = symbolBoundingExtent[pxSignIdx];
  } else if (symbolBoundingData != null) {
    boundingLength = convertToCoordOnAxis(valueAxis2, symbolBoundingData) - zeroPx;
  } else if (symbolRepeat) {
    boundingLength = opt.coordSysExtent[valueDim.index][pxSignIdx] - zeroPx;
  } else {
    boundingLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.boundingLength = boundingLength;
  if (symbolRepeat) {
    outputSymbolMeta.repeatCutLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.pxSign = boundingLength > 0 ? 1 : -1;
}
function convertToCoordOnAxis(axis, value) {
  return axis.toGlobalCoord(axis.dataToCoord(axis.scale.parse(value)));
}
function prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, boundingLength, pxSign, symbolPatternSize, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var categoryDim = opt.categoryDim;
  var categorySize = Math.abs(layout2[categoryDim.wh]);
  var symbolSize = data.getItemVisual(dataIndex, "symbolSize");
  var parsedSymbolSize;
  if (isArray$1(symbolSize)) {
    parsedSymbolSize = symbolSize.slice();
  } else {
    if (symbolSize == null) {
      parsedSymbolSize = ["100%", "100%"];
    } else {
      parsedSymbolSize = [symbolSize, symbolSize];
    }
  }
  parsedSymbolSize[categoryDim.index] = parsePercent(parsedSymbolSize[categoryDim.index], categorySize);
  parsedSymbolSize[valueDim.index] = parsePercent(parsedSymbolSize[valueDim.index], symbolRepeat ? categorySize : Math.abs(boundingLength));
  outputSymbolMeta.symbolSize = parsedSymbolSize;
  var symbolScale = outputSymbolMeta.symbolScale = [parsedSymbolSize[0] / symbolPatternSize, parsedSymbolSize[1] / symbolPatternSize];
  symbolScale[valueDim.index] *= (opt.isHorizontal ? -1 : 1) * pxSign;
}
function prepareLineWidth(itemModel, symbolScale, rotation, opt, outputSymbolMeta) {
  var valueLineWidth = itemModel.get(BAR_BORDER_WIDTH_QUERY) || 0;
  if (valueLineWidth) {
    pathForLineWidth.attr({
      scaleX: symbolScale[0],
      scaleY: symbolScale[1],
      rotation
    });
    pathForLineWidth.updateTransform();
    valueLineWidth /= pathForLineWidth.getLineScale();
    valueLineWidth *= symbolScale[opt.valueDim.index];
  }
  outputSymbolMeta.valueLineWidth = valueLineWidth || 0;
}
function prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, valueLineWidth, boundingLength, repeatCutLength, opt, outputSymbolMeta) {
  var categoryDim = opt.categoryDim;
  var valueDim = opt.valueDim;
  var pxSign = outputSymbolMeta.pxSign;
  var unitLength = Math.max(symbolSize[valueDim.index] + valueLineWidth, 0);
  var pathLen = unitLength;
  if (symbolRepeat) {
    var absBoundingLength = Math.abs(boundingLength);
    var symbolMargin = retrieve(itemModel.get("symbolMargin"), "15%") + "";
    var hasEndGap = false;
    if (symbolMargin.lastIndexOf("!") === symbolMargin.length - 1) {
      hasEndGap = true;
      symbolMargin = symbolMargin.slice(0, symbolMargin.length - 1);
    }
    var symbolMarginNumeric = parsePercent(symbolMargin, symbolSize[valueDim.index]);
    var uLenWithMargin = Math.max(unitLength + symbolMarginNumeric * 2, 0);
    var endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    var repeatSpecified = isNumeric(symbolRepeat);
    var repeatTimes = repeatSpecified ? symbolRepeat : toIntTimes((absBoundingLength + endFix) / uLenWithMargin);
    var mDiff = absBoundingLength - repeatTimes * unitLength;
    symbolMarginNumeric = mDiff / 2 / (hasEndGap ? repeatTimes : Math.max(repeatTimes - 1, 1));
    uLenWithMargin = unitLength + symbolMarginNumeric * 2;
    endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    if (!repeatSpecified && symbolRepeat !== "fixed") {
      repeatTimes = repeatCutLength ? toIntTimes((Math.abs(repeatCutLength) + endFix) / uLenWithMargin) : 0;
    }
    pathLen = repeatTimes * uLenWithMargin - endFix;
    outputSymbolMeta.repeatTimes = repeatTimes;
    outputSymbolMeta.symbolMargin = symbolMarginNumeric;
  }
  var sizeFix = pxSign * (pathLen / 2);
  var pathPosition = outputSymbolMeta.pathPosition = [];
  pathPosition[categoryDim.index] = layout2[categoryDim.wh] / 2;
  pathPosition[valueDim.index] = symbolPosition === "start" ? sizeFix : symbolPosition === "end" ? boundingLength - sizeFix : boundingLength / 2;
  if (symbolOffset) {
    pathPosition[0] += symbolOffset[0];
    pathPosition[1] += symbolOffset[1];
  }
  var bundlePosition = outputSymbolMeta.bundlePosition = [];
  bundlePosition[categoryDim.index] = layout2[categoryDim.xy];
  bundlePosition[valueDim.index] = layout2[valueDim.xy];
  var barRectShape = outputSymbolMeta.barRectShape = extend({}, layout2);
  barRectShape[valueDim.wh] = pxSign * Math.max(Math.abs(layout2[valueDim.wh]), Math.abs(pathPosition[valueDim.index] + sizeFix));
  barRectShape[categoryDim.wh] = layout2[categoryDim.wh];
  var clipShape = outputSymbolMeta.clipShape = {};
  clipShape[categoryDim.xy] = -layout2[categoryDim.xy];
  clipShape[categoryDim.wh] = opt.ecSize[categoryDim.wh];
  clipShape[valueDim.xy] = 0;
  clipShape[valueDim.wh] = layout2[valueDim.wh];
}
function createPath(symbolMeta) {
  var symbolPatternSize = symbolMeta.symbolPatternSize;
  var path = createSymbol$1(symbolMeta.symbolType, -symbolPatternSize / 2, -symbolPatternSize / 2, symbolPatternSize, symbolPatternSize);
  path.attr({
    culling: true
  });
  path.type !== "image" && path.setStyle({
    strokeNoScale: true
  });
  return path;
}
function createOrUpdateRepeatSymbols(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var symbolSize = symbolMeta.symbolSize;
  var valueLineWidth = symbolMeta.valueLineWidth;
  var pathPosition = symbolMeta.pathPosition;
  var valueDim = opt.valueDim;
  var repeatTimes = symbolMeta.repeatTimes || 0;
  var index2 = 0;
  var unit = symbolSize[opt.valueDim.index] + valueLineWidth + symbolMeta.symbolMargin * 2;
  eachPath(bar, function(path2) {
    path2.__pictorialAnimationIndex = index2;
    path2.__pictorialRepeatTimes = repeatTimes;
    if (index2 < repeatTimes) {
      updateAttr(path2, null, makeTarget(index2), symbolMeta, isUpdate);
    } else {
      updateAttr(path2, null, {
        scaleX: 0,
        scaleY: 0
      }, symbolMeta, isUpdate, function() {
        bundle.remove(path2);
      });
    }
    index2++;
  });
  for (; index2 < repeatTimes; index2++) {
    var path = createPath(symbolMeta);
    path.__pictorialAnimationIndex = index2;
    path.__pictorialRepeatTimes = repeatTimes;
    bundle.add(path);
    var target = makeTarget(index2);
    updateAttr(path, {
      x: target.x,
      y: target.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: target.scaleX,
      scaleY: target.scaleY,
      rotation: target.rotation
    }, symbolMeta, isUpdate);
  }
  function makeTarget(index3) {
    var position2 = pathPosition.slice();
    var pxSign = symbolMeta.pxSign;
    var i = index3;
    if (symbolMeta.symbolRepeatDirection === "start" ? pxSign > 0 : pxSign < 0) {
      i = repeatTimes - 1 - index3;
    }
    position2[valueDim.index] = unit * (i - repeatTimes / 2 + 0.5) + pathPosition[valueDim.index];
    return {
      x: position2[0],
      y: position2[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    };
  }
}
function createOrUpdateSingleSymbol(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var mainPath = bar.__pictorialMainPath;
  if (!mainPath) {
    mainPath = bar.__pictorialMainPath = createPath(symbolMeta);
    bundle.add(mainPath);
    updateAttr(mainPath, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: 0,
      scaleY: 0,
      rotation: symbolMeta.rotation
    }, {
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1]
    }, symbolMeta, isUpdate);
  } else {
    updateAttr(mainPath, null, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateBarRect(bar, symbolMeta, isUpdate) {
  var rectShape = extend({}, symbolMeta.barRectShape);
  var barRect = bar.__pictorialBarRect;
  if (!barRect) {
    barRect = bar.__pictorialBarRect = new Rect$3({
      z2: 2,
      shape: rectShape,
      silent: true,
      style: {
        stroke: "transparent",
        fill: "transparent",
        lineWidth: 0
      }
    });
    barRect.disableMorphing = true;
    bar.add(barRect);
  } else {
    updateAttr(barRect, null, {
      shape: rectShape
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateClip(bar, opt, symbolMeta, isUpdate) {
  if (symbolMeta.symbolClip) {
    var clipPath = bar.__pictorialClipPath;
    var clipShape = extend({}, symbolMeta.clipShape);
    var valueDim = opt.valueDim;
    var animationModel = symbolMeta.animationModel;
    var dataIndex = symbolMeta.dataIndex;
    if (clipPath) {
      updateProps$1(clipPath, {
        shape: clipShape
      }, animationModel, dataIndex);
    } else {
      clipShape[valueDim.wh] = 0;
      clipPath = new Rect$3({
        shape: clipShape
      });
      bar.__pictorialBundle.setClipPath(clipPath);
      bar.__pictorialClipPath = clipPath;
      var target = {};
      target[valueDim.wh] = symbolMeta.clipShape[valueDim.wh];
      graphic[isUpdate ? "updateProps" : "initProps"](clipPath, {
        shape: target
      }, animationModel, dataIndex);
    }
  }
}
function getItemModel(data, dataIndex) {
  var itemModel = data.getItemModel(dataIndex);
  itemModel.getAnimationDelayParams = getAnimationDelayParams;
  itemModel.isAnimationEnabled = isAnimationEnabled;
  return itemModel;
}
function getAnimationDelayParams(path) {
  return {
    index: path.__pictorialAnimationIndex,
    count: path.__pictorialRepeatTimes
  };
}
function isAnimationEnabled() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function createBar(data, opt, symbolMeta, isUpdate) {
  var bar = new Group$4();
  var bundle = new Group$4();
  bar.add(bundle);
  bar.__pictorialBundle = bundle;
  bundle.x = symbolMeta.bundlePosition[0];
  bundle.y = symbolMeta.bundlePosition[1];
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta);
  }
  createOrUpdateBarRect(bar, symbolMeta, isUpdate);
  createOrUpdateClip(bar, opt, symbolMeta, isUpdate);
  bar.__pictorialShapeStr = getShapeStr(data, symbolMeta);
  bar.__pictorialSymbolMeta = symbolMeta;
  return bar;
}
function updateBar(bar, opt, symbolMeta) {
  var animationModel = symbolMeta.animationModel;
  var dataIndex = symbolMeta.dataIndex;
  var bundle = bar.__pictorialBundle;
  updateProps$1(bundle, {
    x: symbolMeta.bundlePosition[0],
    y: symbolMeta.bundlePosition[1]
  }, animationModel, dataIndex);
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta, true);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta, true);
  }
  createOrUpdateBarRect(bar, symbolMeta, true);
  createOrUpdateClip(bar, opt, symbolMeta, true);
}
function removeBar(data, dataIndex, animationModel, bar) {
  var labelRect = bar.__pictorialBarRect;
  labelRect && labelRect.removeTextContent();
  var pathes = [];
  eachPath(bar, function(path) {
    pathes.push(path);
  });
  bar.__pictorialMainPath && pathes.push(bar.__pictorialMainPath);
  bar.__pictorialClipPath && (animationModel = null);
  each$f(pathes, function(path) {
    removeElement(path, {
      scaleX: 0,
      scaleY: 0
    }, animationModel, dataIndex, function() {
      bar.parent && bar.parent.remove(bar);
    });
  });
  data.setItemGraphicEl(dataIndex, null);
}
function getShapeStr(data, symbolMeta) {
  return [data.getItemVisual(symbolMeta.dataIndex, "symbol") || "none", !!symbolMeta.symbolRepeat, !!symbolMeta.symbolClip].join(":");
}
function eachPath(bar, cb, context) {
  each$f(bar.__pictorialBundle.children(), function(el) {
    el !== bar.__pictorialBarRect && cb.call(context, el);
  });
}
function updateAttr(el, immediateAttrs, animationAttrs, symbolMeta, isUpdate, cb) {
  immediateAttrs && el.attr(immediateAttrs);
  if (symbolMeta.symbolClip && !isUpdate) {
    animationAttrs && el.attr(animationAttrs);
  } else {
    animationAttrs && graphic[isUpdate ? "updateProps" : "initProps"](el, animationAttrs, symbolMeta.animationModel, symbolMeta.dataIndex, cb);
  }
}
function updateCommon(bar, opt, symbolMeta) {
  var dataIndex = symbolMeta.dataIndex;
  var itemModel = symbolMeta.itemModel;
  var emphasisModel = itemModel.getModel("emphasis");
  var emphasisStyle = emphasisModel.getModel("itemStyle").getItemStyle();
  var blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
  var selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
  var cursorStyle = itemModel.getShallow("cursor");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var hoverScale = emphasisModel.get("scale");
  eachPath(bar, function(path) {
    if (path instanceof ZRImage$1) {
      var pathStyle = path.style;
      path.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolMeta.style));
    } else {
      path.useStyle(symbolMeta.style);
    }
    var emphasisState = path.ensureState("emphasis");
    emphasisState.style = emphasisStyle;
    if (hoverScale) {
      emphasisState.scaleX = path.scaleX * 1.1;
      emphasisState.scaleY = path.scaleY * 1.1;
    }
    path.ensureState("blur").style = blurStyle;
    path.ensureState("select").style = selectStyle;
    cursorStyle && (path.cursor = cursorStyle);
    path.z2 = symbolMeta.z2;
  });
  var barPositionOutside = opt.valueDim.posDesc[+(symbolMeta.boundingLength > 0)];
  var barRect = bar.__pictorialBarRect;
  setLabelStyle(barRect, getLabelStatesModels(itemModel), {
    labelFetcher: opt.seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(opt.seriesModel.getData(), dataIndex),
    inheritColor: symbolMeta.style.fill,
    defaultOpacity: symbolMeta.style.opacity,
    defaultOutsidePosition: barPositionOutside
  });
  toggleHoverEmphasis(bar, focus, blurScope, emphasisModel.get("disabled"));
}
function toIntTimes(times) {
  var roundedTimes = Math.round(times);
  return Math.abs(times - roundedTimes) < 1e-4 ? roundedTimes : Math.ceil(times);
}
var PictorialBarView$1 = PictorialBarView;
var PictorialBarSeriesModel = function(_super) {
  __extends(PictorialBarSeriesModel2, _super);
  function PictorialBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    _this.defaultSymbol = "roundRect";
    return _this;
  }
  PictorialBarSeriesModel2.prototype.getInitialData = function(option) {
    option.stack = null;
    return _super.prototype.getInitialData.apply(this, arguments);
  };
  PictorialBarSeriesModel2.type = "series.pictorialBar";
  PictorialBarSeriesModel2.dependencies = ["grid"];
  PictorialBarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    symbol: "circle",
    symbolSize: null,
    symbolRotate: null,
    symbolPosition: null,
    symbolOffset: null,
    symbolMargin: null,
    symbolRepeat: false,
    symbolRepeatDirection: "end",
    symbolClip: false,
    symbolBoundingData: null,
    symbolPatternSize: 400,
    barGap: "-100%",
    progressive: 0,
    emphasis: {
      scale: false
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  });
  return PictorialBarSeriesModel2;
}(BaseBarSeriesModel$1);
var PictorialBarSeriesModel$1 = PictorialBarSeriesModel;
function install$u(registers) {
  registers.registerChartView(PictorialBarView$1);
  registers.registerSeriesModel(PictorialBarSeriesModel$1);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "pictorialBar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("pictorialBar"));
}
var ThemeRiverView = function(_super) {
  __extends(ThemeRiverView2, _super);
  function ThemeRiverView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverView2.type;
    _this._layers = [];
    return _this;
  }
  ThemeRiverView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var self2 = this;
    var group = this.group;
    var layersSeries = seriesModel.getLayerSeries();
    var layoutInfo = data.getLayout("layoutInfo");
    var rect = layoutInfo.rect;
    var boundaryGap = layoutInfo.boundaryGap;
    group.x = 0;
    group.y = rect.y + boundaryGap[0];
    function keyGetter(item) {
      return item.name;
    }
    var dataDiffer = new DataDiffer$1(this._layersSeries || [], layersSeries, keyGetter, keyGetter);
    var newLayersGroups = [];
    dataDiffer.add(bind$1(process2, this, "add")).update(bind$1(process2, this, "update")).remove(bind$1(process2, this, "remove")).execute();
    function process2(status, idx, oldIdx) {
      var oldLayersGroups = self2._layers;
      if (status === "remove") {
        group.remove(oldLayersGroups[idx]);
        return;
      }
      var points0 = [];
      var points1 = [];
      var style;
      var indices = layersSeries[idx].indices;
      var j = 0;
      for (; j < indices.length; j++) {
        var layout2 = data.getItemLayout(indices[j]);
        var x2 = layout2.x;
        var y0 = layout2.y0;
        var y2 = layout2.y;
        points0.push(x2, y0);
        points1.push(x2, y0 + y2);
        style = data.getItemVisual(indices[j], "style");
      }
      var polygon;
      var textLayout = data.getItemLayout(indices[0]);
      var labelModel = seriesModel.getModel("label");
      var margin = labelModel.get("margin");
      var emphasisModel = seriesModel.getModel("emphasis");
      if (status === "add") {
        var layerGroup = newLayersGroups[idx] = new Group$4();
        polygon = new ECPolygon({
          shape: {
            points: points0,
            stackedOnPoints: points1,
            smooth: 0.4,
            stackedOnSmooth: 0.4,
            smoothConstraint: false
          },
          z2: 0
        });
        layerGroup.add(polygon);
        group.add(layerGroup);
        if (seriesModel.isAnimationEnabled()) {
          polygon.setClipPath(createGridClipShape(polygon.getBoundingRect(), seriesModel, function() {
            polygon.removeClipPath();
          }));
        }
      } else {
        var layerGroup = oldLayersGroups[oldIdx];
        polygon = layerGroup.childAt(0);
        group.add(layerGroup);
        newLayersGroups[idx] = layerGroup;
        updateProps$1(polygon, {
          shape: {
            points: points0,
            stackedOnPoints: points1
          }
        }, seriesModel);
        saveOldStyle(polygon);
      }
      setLabelStyle(polygon, getLabelStatesModels(seriesModel), {
        labelDataIndex: indices[j - 1],
        defaultText: data.getName(indices[j - 1]),
        inheritColor: style.fill
      }, {
        normal: {
          verticalAlign: "middle"
        }
      });
      polygon.setTextConfig({
        position: null,
        local: true
      });
      var labelEl = polygon.getTextContent();
      if (labelEl) {
        labelEl.x = textLayout.x - margin;
        labelEl.y = textLayout.y0 + textLayout.y / 2;
      }
      polygon.useStyle(style);
      data.setItemGraphicEl(idx, polygon);
      setStatesStylesFromModel(polygon, seriesModel);
      toggleHoverEmphasis(polygon, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    }
    this._layersSeries = layersSeries;
    this._layers = newLayersGroups;
  };
  ThemeRiverView2.type = "themeRiver";
  return ThemeRiverView2;
}(ChartView$1);
function createGridClipShape(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      x: rect.x - 50,
      width: rect.width + 100,
      height: rect.height + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var ThemeRiverView$1 = ThemeRiverView;
var DATA_NAME_INDEX = 2;
var ThemeRiverSeriesModel = function(_super) {
  __extends(ThemeRiverSeriesModel2, _super);
  function ThemeRiverSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverSeriesModel2.type;
    return _this;
  }
  ThemeRiverSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  ThemeRiverSeriesModel2.prototype.fixData = function(data) {
    var rawDataLength = data.length;
    var timeValueKeys = {};
    var groupResult = groupData(data, function(item) {
      if (!timeValueKeys.hasOwnProperty(item[0] + "")) {
        timeValueKeys[item[0] + ""] = -1;
      }
      return item[2];
    });
    var layerData = [];
    groupResult.buckets.each(function(items, key) {
      layerData.push({
        name: key,
        dataList: items
      });
    });
    var layerNum = layerData.length;
    for (var k2 = 0; k2 < layerNum; ++k2) {
      var name_1 = layerData[k2].name;
      for (var j = 0; j < layerData[k2].dataList.length; ++j) {
        var timeValue = layerData[k2].dataList[j][0] + "";
        timeValueKeys[timeValue] = k2;
      }
      for (var timeValue in timeValueKeys) {
        if (timeValueKeys.hasOwnProperty(timeValue) && timeValueKeys[timeValue] !== k2) {
          timeValueKeys[timeValue] = k2;
          data[rawDataLength] = [timeValue, 0, name_1];
          rawDataLength++;
        }
      }
    }
    return data;
  };
  ThemeRiverSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var singleAxisModel = this.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    var axisType = singleAxisModel.get("type");
    var filterData = filter(option.data, function(dataItem) {
      return dataItem[2] !== void 0;
    });
    var data = this.fixData(filterData || []);
    var nameList = [];
    var nameMap = this.nameMap = createHashMap();
    var count2 = 0;
    for (var i = 0; i < data.length; ++i) {
      nameList.push(data[i][DATA_NAME_INDEX]);
      if (!nameMap.get(data[i][DATA_NAME_INDEX])) {
        nameMap.set(data[i][DATA_NAME_INDEX], count2);
        count2++;
      }
    }
    var dimensions = prepareSeriesDataSchema(data, {
      coordDimensions: ["single"],
      dimensionsDefine: [{
        name: "time",
        type: getDimensionTypeByAxis(axisType)
      }, {
        name: "value",
        type: "float"
      }, {
        name: "name",
        type: "ordinal"
      }],
      encodeDefine: {
        single: 0,
        value: 1,
        itemName: 2
      }
    }).dimensions;
    var list = new SeriesData$1(dimensions, this);
    list.initData(data);
    return list;
  };
  ThemeRiverSeriesModel2.prototype.getLayerSeries = function() {
    var data = this.getData();
    var lenCount = data.count();
    var indexArr = [];
    for (var i = 0; i < lenCount; ++i) {
      indexArr[i] = i;
    }
    var timeDim = data.mapDimension("single");
    var groupResult = groupData(indexArr, function(index2) {
      return data.get("name", index2);
    });
    var layerSeries = [];
    groupResult.buckets.each(function(items, key) {
      items.sort(function(index1, index2) {
        return data.get(timeDim, index1) - data.get(timeDim, index2);
      });
      layerSeries.push({
        name: key,
        indices: items
      });
    });
    return layerSeries;
  };
  ThemeRiverSeriesModel2.prototype.getAxisTooltipData = function(dim, value, baseAxis) {
    if (!isArray$1(dim)) {
      dim = dim ? [dim] : [];
    }
    var data = this.getData();
    var layerSeries = this.getLayerSeries();
    var indices = [];
    var layerNum = layerSeries.length;
    var nestestValue;
    for (var i = 0; i < layerNum; ++i) {
      var minDist = Number.MAX_VALUE;
      var nearestIdx = -1;
      var pointNum = layerSeries[i].indices.length;
      for (var j = 0; j < pointNum; ++j) {
        var theValue = data.get(dim[0], layerSeries[i].indices[j]);
        var dist2 = Math.abs(theValue - value);
        if (dist2 <= minDist) {
          nestestValue = theValue;
          minDist = dist2;
          nearestIdx = layerSeries[i].indices[j];
        }
      }
      indices.push(nearestIdx);
    }
    return {
      dataIndices: indices,
      nestestValue
    };
  };
  ThemeRiverSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var name = data.getName(dataIndex);
    var value = data.get(data.mapDimension("value"), dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  ThemeRiverSeriesModel2.type = "series.themeRiver";
  ThemeRiverSeriesModel2.dependencies = ["singleAxis"];
  ThemeRiverSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "singleAxis",
    boundaryGap: ["10%", "10%"],
    singleAxisIndex: 0,
    animationEasing: "linear",
    label: {
      margin: 4,
      show: true,
      position: "left",
      fontSize: 11
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return ThemeRiverSeriesModel2;
}(SeriesModel$1);
var ThemeRiverSeriesModel$1 = ThemeRiverSeriesModel;
function themeRiverLayout(ecModel, api) {
  ecModel.eachSeriesByType("themeRiver", function(seriesModel) {
    var data = seriesModel.getData();
    var single = seriesModel.coordinateSystem;
    var layoutInfo = {};
    var rect = single.getRect();
    layoutInfo.rect = rect;
    var boundaryGap = seriesModel.get("boundaryGap");
    var axis = single.getAxis();
    layoutInfo.boundaryGap = boundaryGap;
    if (axis.orient === "horizontal") {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.height);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.height);
      var height = rect.height - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, height);
    } else {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.width);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.width);
      var width = rect.width - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, width);
    }
    data.setLayout("layoutInfo", layoutInfo);
  });
}
function doThemeRiverLayout(data, seriesModel, height) {
  if (!data.count()) {
    return;
  }
  var coordSys = seriesModel.coordinateSystem;
  var layerSeries = seriesModel.getLayerSeries();
  var timeDim = data.mapDimension("single");
  var valueDim = data.mapDimension("value");
  var layerPoints = map$1(layerSeries, function(singleLayer) {
    return map$1(singleLayer.indices, function(idx) {
      var pt = coordSys.dataToPoint(data.get(timeDim, idx));
      pt[1] = data.get(valueDim, idx);
      return pt;
    });
  });
  var base2 = computeBaseline(layerPoints);
  var baseLine = base2.y0;
  var ky = height / base2.max;
  var n2 = layerSeries.length;
  var m2 = layerSeries[0].indices.length;
  var baseY0;
  for (var j = 0; j < m2; ++j) {
    baseY0 = baseLine[j] * ky;
    data.setItemLayout(layerSeries[0].indices[j], {
      layerIndex: 0,
      x: layerPoints[0][j][0],
      y0: baseY0,
      y: layerPoints[0][j][1] * ky
    });
    for (var i = 1; i < n2; ++i) {
      baseY0 += layerPoints[i - 1][j][1] * ky;
      data.setItemLayout(layerSeries[i].indices[j], {
        layerIndex: i,
        x: layerPoints[i][j][0],
        y0: baseY0,
        y: layerPoints[i][j][1] * ky
      });
    }
  }
}
function computeBaseline(data) {
  var layerNum = data.length;
  var pointNum = data[0].length;
  var sums = [];
  var y0 = [];
  var max3 = 0;
  for (var i = 0; i < pointNum; ++i) {
    var temp = 0;
    for (var j = 0; j < layerNum; ++j) {
      temp += data[j][i][1];
    }
    if (temp > max3) {
      max3 = temp;
    }
    sums.push(temp);
  }
  for (var k2 = 0; k2 < pointNum; ++k2) {
    y0[k2] = (max3 - sums[k2]) / 2;
  }
  max3 = 0;
  for (var l2 = 0; l2 < pointNum; ++l2) {
    var sum2 = sums[l2] + y0[l2];
    if (sum2 > max3) {
      max3 = sum2;
    }
  }
  return {
    y0,
    max: max3
  };
}
function install$t(registers) {
  registers.registerChartView(ThemeRiverView$1);
  registers.registerSeriesModel(ThemeRiverSeriesModel$1);
  registers.registerLayout(themeRiverLayout);
  registers.registerProcessor(dataFilter$1("themeRiver"));
}
var DEFAULT_SECTOR_Z = 2;
var DEFAULT_TEXT_Z = 4;
var SunburstPiece = function(_super) {
  __extends(SunburstPiece2, _super);
  function SunburstPiece2(node, seriesModel, ecModel, api) {
    var _this = _super.call(this) || this;
    _this.z2 = DEFAULT_SECTOR_Z;
    _this.textConfig = {
      inside: true
    };
    getECData(_this).seriesIndex = seriesModel.seriesIndex;
    var text = new ZRText$1({
      z2: DEFAULT_TEXT_Z,
      silent: node.getModel().get(["label", "silent"])
    });
    _this.setTextContent(text);
    _this.updateData(true, node, seriesModel, ecModel, api);
    return _this;
  }
  SunburstPiece2.prototype.updateData = function(firstCreate, node, seriesModel, ecModel, api) {
    this.node = node;
    node.piece = this;
    seriesModel = seriesModel || this._seriesModel;
    ecModel = ecModel || this._ecModel;
    var sector = this;
    getECData(sector).dataIndex = node.dataIndex;
    var itemModel = node.getModel();
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = node.getLayout();
    var sectorShape = extend({}, layout2);
    sectorShape.label = null;
    var normalStyle = node.getVisual("style");
    normalStyle.lineJoin = "bevel";
    var decal = node.getVisual("decal");
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, api);
    }
    var cornerRadius = getSectorCornerRadius(itemModel.getModel("itemStyle"), sectorShape, true);
    extend(sectorShape, cornerRadius);
    each$f(SPECIAL_STATES, function(stateName) {
      var state = sector.ensureState(stateName);
      var itemStyleModel = itemModel.getModel([stateName, "itemStyle"]);
      state.style = itemStyleModel.getItemStyle();
      var cornerRadius2 = getSectorCornerRadius(itemStyleModel, sectorShape);
      if (cornerRadius2) {
        state.shape = cornerRadius2;
      }
    });
    if (firstCreate) {
      sector.setShape(sectorShape);
      sector.shape.r = layout2.r0;
      updateProps$1(sector, {
        shape: {
          r: layout2.r
        }
      }, seriesModel, node.dataIndex);
    } else {
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel);
      saveOldStyle(sector);
    }
    sector.useStyle(normalStyle);
    this._updateLabel(seriesModel);
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._seriesModel = seriesModel || this._seriesModel;
    this._ecModel = ecModel || this._ecModel;
    var focus = emphasisModel.get("focus");
    var focusOrIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : focus;
    toggleHoverEmphasis(this, focusOrIndices, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  SunburstPiece2.prototype._updateLabel = function(seriesModel) {
    var _this = this;
    var itemModel = this.node.getModel();
    var normalLabelModel = itemModel.getModel("label");
    var layout2 = this.node.getLayout();
    var angle = layout2.endAngle - layout2.startAngle;
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var dx = Math.cos(midAngle);
    var dy = Math.sin(midAngle);
    var sector = this;
    var label = sector.getTextContent();
    var dataIndex = this.node.dataIndex;
    var labelMinAngle = normalLabelModel.get("minAngle") / 180 * Math.PI;
    var isNormalShown = normalLabelModel.get("show") && !(labelMinAngle != null && Math.abs(angle) < labelMinAngle);
    label.ignore = !isNormalShown;
    each$f(DISPLAY_STATES, function(stateName) {
      var labelStateModel = stateName === "normal" ? itemModel.getModel("label") : itemModel.getModel([stateName, "label"]);
      var isNormal = stateName === "normal";
      var state = isNormal ? label : label.ensureState(stateName);
      var text = seriesModel.getFormattedLabel(dataIndex, stateName);
      if (isNormal) {
        text = text || _this.node.name;
      }
      state.style = createTextStyle(labelStateModel, {}, null, stateName !== "normal", true);
      if (text) {
        state.style.text = text;
      }
      var isShown = labelStateModel.get("show");
      if (isShown != null && !isNormal) {
        state.ignore = !isShown;
      }
      var labelPosition = getLabelAttr(labelStateModel, "position");
      var sectorState = isNormal ? sector : sector.states[stateName];
      var labelColor = sectorState.style.fill;
      sectorState.textConfig = {
        outsideFill: labelStateModel.get("color") === "inherit" ? labelColor : null,
        inside: labelPosition !== "outside"
      };
      var r2;
      var labelPadding = getLabelAttr(labelStateModel, "distance") || 0;
      var textAlign = getLabelAttr(labelStateModel, "align");
      if (labelPosition === "outside") {
        r2 = layout2.r + labelPadding;
        textAlign = midAngle > Math.PI / 2 ? "right" : "left";
      } else {
        if (!textAlign || textAlign === "center") {
          if (angle === 2 * Math.PI && layout2.r0 === 0) {
            r2 = 0;
          } else {
            r2 = (layout2.r + layout2.r0) / 2;
          }
          textAlign = "center";
        } else if (textAlign === "left") {
          r2 = layout2.r0 + labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "right";
          }
        } else if (textAlign === "right") {
          r2 = layout2.r - labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "left";
          }
        }
      }
      state.style.align = textAlign;
      state.style.verticalAlign = getLabelAttr(labelStateModel, "verticalAlign") || "middle";
      state.x = r2 * dx + layout2.cx;
      state.y = r2 * dy + layout2.cy;
      var rotateType = getLabelAttr(labelStateModel, "rotate");
      var rotate2 = 0;
      if (rotateType === "radial") {
        rotate2 = -midAngle;
        if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (rotateType === "tangential") {
        rotate2 = Math.PI / 2 - midAngle;
        if (rotate2 > Math.PI / 2) {
          rotate2 -= Math.PI;
        } else if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (isNumber(rotateType)) {
        rotate2 = rotateType * Math.PI / 180;
      }
      state.rotation = rotate2;
    });
    function getLabelAttr(model, name) {
      var stateAttr = model.get(name);
      if (stateAttr == null) {
        return normalLabelModel.get(name);
      }
      return stateAttr;
    }
    label.dirtyStyle();
  };
  return SunburstPiece2;
}(Sector$1);
var SunburstPiece$1 = SunburstPiece;
var ROOT_TO_NODE_ACTION = "sunburstRootToNode";
var HIGHLIGHT_ACTION = "sunburstHighlight";
var UNHIGHLIGHT_ACTION = "sunburstUnhighlight";
function installSunburstAction(registers) {
  registers.registerAction({
    type: ROOT_TO_NODE_ACTION,
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var targetInfo = retrieveTargetInfo(payload, [ROOT_TO_NODE_ACTION], model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
  registers.registerAction({
    type: HIGHLIGHT_ACTION,
    update: "none"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleHighlight);
    function handleHighlight(model) {
      var targetInfo = retrieveTargetInfo(payload, [HIGHLIGHT_ACTION], model);
      if (targetInfo) {
        payload.dataIndex = targetInfo.node.dataIndex;
      }
    }
    api.dispatchAction(extend(payload, {
      type: "highlight"
    }));
  });
  registers.registerAction({
    type: UNHIGHLIGHT_ACTION,
    update: "updateView"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    api.dispatchAction(extend(payload, {
      type: "downplay"
    }));
  });
}
var SunburstView = function(_super) {
  __extends(SunburstView2, _super);
  function SunburstView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstView2.type;
    return _this;
  }
  SunburstView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var self2 = this;
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var data = seriesModel.getData();
    var virtualRoot = data.tree.root;
    var newRoot = seriesModel.getViewRoot();
    var group = this.group;
    var renderLabelForZeroData = seriesModel.get("renderLabelForZeroData");
    var newChildren = [];
    newRoot.eachNode(function(node) {
      newChildren.push(node);
    });
    var oldChildren = this._oldChildren || [];
    dualTravel(newChildren, oldChildren);
    renderRollUp(virtualRoot, newRoot);
    this._initEvents();
    this._oldChildren = newChildren;
    function dualTravel(newChildren2, oldChildren2) {
      if (newChildren2.length === 0 && oldChildren2.length === 0) {
        return;
      }
      new DataDiffer$1(oldChildren2, newChildren2, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIdx, oldIdx) {
        var newNode = newIdx == null ? null : newChildren2[newIdx];
        var oldNode = oldIdx == null ? null : oldChildren2[oldIdx];
        doRenderNode(newNode, oldNode);
      }
    }
    function doRenderNode(newNode, oldNode) {
      if (!renderLabelForZeroData && newNode && !newNode.getValue()) {
        newNode = null;
      }
      if (newNode !== virtualRoot && oldNode !== virtualRoot) {
        if (oldNode && oldNode.piece) {
          if (newNode) {
            oldNode.piece.updateData(false, newNode, seriesModel, ecModel, api);
            data.setItemGraphicEl(newNode.dataIndex, oldNode.piece);
          } else {
            removeNode2(oldNode);
          }
        } else if (newNode) {
          var piece = new SunburstPiece$1(newNode, seriesModel, ecModel, api);
          group.add(piece);
          data.setItemGraphicEl(newNode.dataIndex, piece);
        }
      }
    }
    function removeNode2(node) {
      if (!node) {
        return;
      }
      if (node.piece) {
        group.remove(node.piece);
        node.piece = null;
      }
    }
    function renderRollUp(virtualRoot2, viewRoot) {
      if (viewRoot.depth > 0) {
        if (self2.virtualPiece) {
          self2.virtualPiece.updateData(false, virtualRoot2, seriesModel, ecModel, api);
        } else {
          self2.virtualPiece = new SunburstPiece$1(virtualRoot2, seriesModel, ecModel, api);
          group.add(self2.virtualPiece);
        }
        viewRoot.piece.off("click");
        self2.virtualPiece.on("click", function(e2) {
          self2._rootToNode(viewRoot.parentNode);
        });
      } else if (self2.virtualPiece) {
        group.remove(self2.virtualPiece);
        self2.virtualPiece = null;
      }
    }
  };
  SunburstView2.prototype._initEvents = function() {
    var _this = this;
    this.group.off("click");
    this.group.on("click", function(e2) {
      var targetFound = false;
      var viewRoot = _this.seriesModel.getViewRoot();
      viewRoot.eachNode(function(node) {
        if (!targetFound && node.piece && node.piece === e2.target) {
          var nodeClick = node.getModel().get("nodeClick");
          if (nodeClick === "rootToNode") {
            _this._rootToNode(node);
          } else if (nodeClick === "link") {
            var itemModel = node.getModel();
            var link = itemModel.get("link");
            if (link) {
              var linkTarget = itemModel.get("target", true) || "_blank";
              windowOpen(link, linkTarget);
            }
          }
          targetFound = true;
        }
      });
    });
  };
  SunburstView2.prototype._rootToNode = function(node) {
    if (node !== this.seriesModel.getViewRoot()) {
      this.api.dispatchAction({
        type: ROOT_TO_NODE_ACTION,
        from: this.uid,
        seriesId: this.seriesModel.id,
        targetNode: node
      });
    }
  };
  SunburstView2.prototype.containPoint = function(point, seriesModel) {
    var treeRoot = seriesModel.getData();
    var itemLayout = treeRoot.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  SunburstView2.type = "sunburst";
  return SunburstView2;
}(ChartView$1);
var SunburstView$1 = SunburstView;
var SunburstSeriesModel = function(_super) {
  __extends(SunburstSeriesModel2, _super);
  function SunburstSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstSeriesModel2.type;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  SunburstSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue(root2);
    var levelModels = this._levelModels = map$1(option.levels || [], function(levelDefine) {
      return new Model$1(levelDefine, this, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = levelModels[node.depth];
        levelModel && (model.parentModel = levelModel);
        return model;
      });
    }
    return tree.data;
  };
  SunburstSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  SunburstSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treePathInfo = wrapTreePathInfo(node, this);
    return params;
  };
  SunburstSeriesModel2.prototype.getLevelModel = function(node) {
    return this._levelModels && this._levelModels[node.depth];
  };
  SunburstSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  SunburstSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  SunburstSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  SunburstSeriesModel2.type = "series.sunburst";
  SunburstSeriesModel2.defaultOption = {
    z: 2,
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    stillShowZeroSum: true,
    nodeClick: "rootToNode",
    renderLabelForZeroData: false,
    label: {
      rotate: "radial",
      show: true,
      opacity: 1,
      align: "center",
      position: "inside",
      distance: 5,
      silent: true
    },
    itemStyle: {
      borderWidth: 1,
      borderColor: "white",
      borderType: "solid",
      shadowBlur: 0,
      shadowColor: "rgba(0, 0, 0, 0.2)",
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    emphasis: {
      focus: "descendant"
    },
    blur: {
      itemStyle: {
        opacity: 0.2
      },
      label: {
        opacity: 0.1
      }
    },
    animationType: "expansion",
    animationDuration: 1e3,
    animationDurationUpdate: 500,
    data: [],
    sort: "desc"
  };
  return SunburstSeriesModel2;
}(SeriesModel$1);
function completeTreeValue(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
var SunburstSeriesModel$1 = SunburstSeriesModel;
var RADIAN = Math.PI / 180;
function sunburstLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var center2 = seriesModel.get("center");
    var radius = seriesModel.get("radius");
    if (!isArray$1(radius)) {
      radius = [0, radius];
    }
    if (!isArray$1(center2)) {
      center2 = [center2, center2];
    }
    var width = api.getWidth();
    var height = api.getHeight();
    var size = Math.min(width, height);
    var cx = parsePercent(center2[0], width);
    var cy = parsePercent(center2[1], height);
    var r0 = parsePercent(radius[0], size / 2);
    var r2 = parsePercent(radius[1], size / 2);
    var startAngle = -seriesModel.get("startAngle") * RADIAN;
    var minAngle = seriesModel.get("minAngle") * RADIAN;
    var virtualRoot = seriesModel.getData().tree.root;
    var treeRoot = seriesModel.getViewRoot();
    var rootDepth = treeRoot.depth;
    var sort2 = seriesModel.get("sort");
    if (sort2 != null) {
      initChildren(treeRoot, sort2);
    }
    var validDataCount = 0;
    each$f(treeRoot.children, function(child) {
      !isNaN(child.getValue()) && validDataCount++;
    });
    var sum2 = treeRoot.getValue();
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var renderRollupNode = treeRoot.depth > 0;
    var levels = treeRoot.height - (renderRollupNode ? -1 : 1);
    var rPerLevel = (r2 - r0) / (levels || 1);
    var clockwise = seriesModel.get("clockwise");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var dir3 = clockwise ? 1 : -1;
    var renderNode2 = function(node, startAngle2) {
      if (!node) {
        return;
      }
      var endAngle = startAngle2;
      if (node !== virtualRoot) {
        var value = node.getValue();
        var angle2 = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
        if (angle2 < minAngle) {
          angle2 = minAngle;
        }
        endAngle = startAngle2 + dir3 * angle2;
        var depth = node.depth - rootDepth - (renderRollupNode ? -1 : 1);
        var rStart2 = r0 + rPerLevel * depth;
        var rEnd2 = r0 + rPerLevel * (depth + 1);
        var levelModel = seriesModel.getLevelModel(node);
        if (levelModel) {
          var r0_1 = levelModel.get("r0", true);
          var r_1 = levelModel.get("r", true);
          var radius_1 = levelModel.get("radius", true);
          if (radius_1 != null) {
            r0_1 = radius_1[0];
            r_1 = radius_1[1];
          }
          r0_1 != null && (rStart2 = parsePercent(r0_1, size / 2));
          r_1 != null && (rEnd2 = parsePercent(r_1, size / 2));
        }
        node.setLayout({
          angle: angle2,
          startAngle: startAngle2,
          endAngle,
          clockwise,
          cx,
          cy,
          r0: rStart2,
          r: rEnd2
        });
      }
      if (node.children && node.children.length) {
        var siblingAngle_1 = 0;
        each$f(node.children, function(node2) {
          siblingAngle_1 += renderNode2(node2, startAngle2 + siblingAngle_1);
        });
      }
      return endAngle - startAngle2;
    };
    if (renderRollupNode) {
      var rStart = r0;
      var rEnd = r0 + rPerLevel;
      var angle = Math.PI * 2;
      virtualRoot.setLayout({
        angle,
        startAngle,
        endAngle: startAngle + angle,
        clockwise,
        cx,
        cy,
        r0: rStart,
        r: rEnd
      });
    }
    renderNode2(treeRoot, startAngle);
  });
}
function initChildren(node, sortOrder) {
  var children = node.children || [];
  node.children = sort(children, sortOrder);
  if (children.length) {
    each$f(node.children, function(child) {
      initChildren(child, sortOrder);
    });
  }
}
function sort(children, sortOrder) {
  if (isFunction(sortOrder)) {
    var sortTargets = map$1(children, function(child, idx) {
      var value = child.getValue();
      return {
        params: {
          depth: child.depth,
          height: child.height,
          dataIndex: child.dataIndex,
          getValue: function() {
            return value;
          }
        },
        index: idx
      };
    });
    sortTargets.sort(function(a, b2) {
      return sortOrder(a.params, b2.params);
    });
    return map$1(sortTargets, function(target) {
      return children[target.index];
    });
  } else {
    var isAsc_1 = sortOrder === "asc";
    return children.sort(function(a, b2) {
      var diff = (a.getValue() - b2.getValue()) * (isAsc_1 ? 1 : -1);
      return diff === 0 ? (a.dataIndex - b2.dataIndex) * (isAsc_1 ? -1 : 1) : diff;
    });
  }
}
function sunburstVisual(ecModel) {
  var paletteScope = {};
  function pickColor(node, seriesModel, treeHeight) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var color = seriesModel.getColorFromPalette(current.name || current.dataIndex + "", paletteScope);
    if (node.depth > 1 && isString(color)) {
      color = lift(color, (node.depth - 1) / (treeHeight - 1) * 0.5);
    }
    return color;
  }
  ecModel.eachSeriesByType("sunburst", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = pickColor(node, seriesModel, tree.root.height);
      }
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function install$s(registers) {
  registers.registerChartView(SunburstView$1);
  registers.registerSeriesModel(SunburstSeriesModel$1);
  registers.registerLayout(curry$1(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry$1(dataFilter$1, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
var STYLE_VISUAL_TYPE = {
  color: "fill",
  borderColor: "stroke"
};
var NON_STYLE_VISUAL_PROPS = {
  symbol: 1,
  symbolSize: 1,
  symbolKeepAspect: 1,
  legendIcon: 1,
  visualMeta: 1,
  liftZ: 1,
  decal: 1
};
var customInnerStore = makeInner();
var CustomSeriesModel = function(_super) {
  __extends(CustomSeriesModel2, _super);
  function CustomSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomSeriesModel2.type;
    return _this;
  }
  CustomSeriesModel2.prototype.optionUpdated = function() {
    this.currentZLevel = this.get("zlevel", true);
    this.currentZ = this.get("z", true);
  };
  CustomSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this);
  };
  CustomSeriesModel2.prototype.getDataParams = function(dataIndex, dataType, el) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    el && (params.info = customInnerStore(el).info);
    return params;
  };
  CustomSeriesModel2.type = "series.custom";
  CustomSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  CustomSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    clip: false
  };
  return CustomSeriesModel2;
}(SeriesModel$1);
var CustomSeriesModel$1 = CustomSeriesModel;
function dataToCoordSize$3(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["x", "y"], function(dim, dimIdx) {
    var axis = this.getAxis(dim);
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
  }, this);
}
function cartesianPrepareCustom(coordSys) {
  var rect = coordSys.master.getRect();
  return {
    coordSys: {
      type: "cartesian2d",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$3, coordSys)
    }
  };
}
function dataToCoordSize$2(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1([0, 1], function(dimIdx) {
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var p1 = [];
    var p2 = [];
    p1[dimIdx] = val - halfSize;
    p2[dimIdx] = val + halfSize;
    p1[1 - dimIdx] = p2[1 - dimIdx] = dataItem[1 - dimIdx];
    return Math.abs(this.dataToPoint(p1)[dimIdx] - this.dataToPoint(p2)[dimIdx]);
  }, this);
}
function geoPrepareCustom(coordSys) {
  var rect = coordSys.getBoundingRect();
  return {
    coordSys: {
      type: "geo",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      zoom: coordSys.getZoom()
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$2, coordSys)
    }
  };
}
function dataToCoordSize$1(dataSize, dataItem) {
  var axis = this.getAxis();
  var val = dataItem instanceof Array ? dataItem[0] : dataItem;
  var halfSize = (dataSize instanceof Array ? dataSize[0] : dataSize) / 2;
  return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
}
function singlePrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  return {
    coordSys: {
      type: "singleAxis",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(val) {
        return coordSys.dataToPoint(val);
      },
      size: bind$1(dataToCoordSize$1, coordSys)
    }
  };
}
function dataToCoordSize(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["Radius", "Angle"], function(dim, dimIdx) {
    var getterName = "get" + dim + "Axis";
    var axis = this[getterName]();
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var result = axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
    if (dim === "Angle") {
      result = result * Math.PI / 180;
    }
    return result;
  }, this);
}
function polarPrepareCustom(coordSys) {
  var radiusAxis = coordSys.getRadiusAxis();
  var angleAxis = coordSys.getAngleAxis();
  var radius = radiusAxis.getExtent();
  radius[0] > radius[1] && radius.reverse();
  return {
    coordSys: {
      type: "polar",
      cx: coordSys.cx,
      cy: coordSys.cy,
      r: radius[1],
      r0: radius[0]
    },
    api: {
      coord: function(data) {
        var radius2 = radiusAxis.dataToRadius(data[0]);
        var angle = angleAxis.dataToAngle(data[1]);
        var coord = coordSys.coordToPoint([radius2, angle]);
        coord.push(radius2, angle * Math.PI / 180);
        return coord;
      },
      size: bind$1(dataToCoordSize, coordSys)
    }
  };
}
function calendarPrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  var rangeInfo = coordSys.getRangeInfo();
  return {
    coordSys: {
      type: "calendar",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      cellWidth: coordSys.getCellWidth(),
      cellHeight: coordSys.getCellHeight(),
      rangeInfo: {
        start: rangeInfo.start,
        end: rangeInfo.end,
        weeks: rangeInfo.weeks,
        dayCount: rangeInfo.allDay
      }
    },
    api: {
      coord: function(data, clamp2) {
        return coordSys.dataToPoint(data, clamp2);
      }
    }
  };
}
function isEC4CompatibleStyle(style, elType, hasOwnTextContentOption, hasOwnTextConfig) {
  return style && (style.legacy || style.legacy !== false && !hasOwnTextContentOption && !hasOwnTextConfig && elType !== "tspan" && (elType === "text" || hasOwn(style, "text")));
}
function convertFromEC4CompatibleStyle(hostStyle, elType, isNormal) {
  var srcStyle = hostStyle;
  var textConfig;
  var textContent;
  var textContentStyle;
  if (elType === "text") {
    textContentStyle = srcStyle;
  } else {
    textContentStyle = {};
    hasOwn(srcStyle, "text") && (textContentStyle.text = srcStyle.text);
    hasOwn(srcStyle, "rich") && (textContentStyle.rich = srcStyle.rich);
    hasOwn(srcStyle, "textFill") && (textContentStyle.fill = srcStyle.textFill);
    hasOwn(srcStyle, "textStroke") && (textContentStyle.stroke = srcStyle.textStroke);
    hasOwn(srcStyle, "fontFamily") && (textContentStyle.fontFamily = srcStyle.fontFamily);
    hasOwn(srcStyle, "fontSize") && (textContentStyle.fontSize = srcStyle.fontSize);
    hasOwn(srcStyle, "fontStyle") && (textContentStyle.fontStyle = srcStyle.fontStyle);
    hasOwn(srcStyle, "fontWeight") && (textContentStyle.fontWeight = srcStyle.fontWeight);
    textContent = {
      type: "text",
      style: textContentStyle,
      silent: true
    };
    textConfig = {};
    var hasOwnPos = hasOwn(srcStyle, "textPosition");
    if (isNormal) {
      textConfig.position = hasOwnPos ? srcStyle.textPosition : "inside";
    } else {
      hasOwnPos && (textConfig.position = srcStyle.textPosition);
    }
    hasOwn(srcStyle, "textPosition") && (textConfig.position = srcStyle.textPosition);
    hasOwn(srcStyle, "textOffset") && (textConfig.offset = srcStyle.textOffset);
    hasOwn(srcStyle, "textRotation") && (textConfig.rotation = srcStyle.textRotation);
    hasOwn(srcStyle, "textDistance") && (textConfig.distance = srcStyle.textDistance);
  }
  convertEC4CompatibleRichItem(textContentStyle, hostStyle);
  each$f(textContentStyle.rich, function(richItem) {
    convertEC4CompatibleRichItem(richItem, richItem);
  });
  return {
    textConfig,
    textContent
  };
}
function convertEC4CompatibleRichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  richItem.font = richItem.textFont || richItem.font;
  hasOwn(richItem, "textStrokeWidth") && (out2.lineWidth = richItem.textStrokeWidth);
  hasOwn(richItem, "textAlign") && (out2.align = richItem.textAlign);
  hasOwn(richItem, "textVerticalAlign") && (out2.verticalAlign = richItem.textVerticalAlign);
  hasOwn(richItem, "textLineHeight") && (out2.lineHeight = richItem.textLineHeight);
  hasOwn(richItem, "textWidth") && (out2.width = richItem.textWidth);
  hasOwn(richItem, "textHeight") && (out2.height = richItem.textHeight);
  hasOwn(richItem, "textBackgroundColor") && (out2.backgroundColor = richItem.textBackgroundColor);
  hasOwn(richItem, "textPadding") && (out2.padding = richItem.textPadding);
  hasOwn(richItem, "textBorderColor") && (out2.borderColor = richItem.textBorderColor);
  hasOwn(richItem, "textBorderWidth") && (out2.borderWidth = richItem.textBorderWidth);
  hasOwn(richItem, "textBorderRadius") && (out2.borderRadius = richItem.textBorderRadius);
  hasOwn(richItem, "textBoxShadowColor") && (out2.shadowColor = richItem.textBoxShadowColor);
  hasOwn(richItem, "textBoxShadowBlur") && (out2.shadowBlur = richItem.textBoxShadowBlur);
  hasOwn(richItem, "textBoxShadowOffsetX") && (out2.shadowOffsetX = richItem.textBoxShadowOffsetX);
  hasOwn(richItem, "textBoxShadowOffsetY") && (out2.shadowOffsetY = richItem.textBoxShadowOffsetY);
}
function convertToEC4StyleForCustomSerise(itemStl, txStl, txCfg) {
  var out2 = itemStl;
  out2.textPosition = out2.textPosition || txCfg.position || "inside";
  txCfg.offset != null && (out2.textOffset = txCfg.offset);
  txCfg.rotation != null && (out2.textRotation = txCfg.rotation);
  txCfg.distance != null && (out2.textDistance = txCfg.distance);
  var isInside = out2.textPosition.indexOf("inside") >= 0;
  var hostFill = itemStl.fill || "#000";
  convertToEC4RichItem(out2, txStl);
  var textFillNotSet = out2.textFill == null;
  if (isInside) {
    if (textFillNotSet) {
      out2.textFill = txCfg.insideFill || "#fff";
      !out2.textStroke && txCfg.insideStroke && (out2.textStroke = txCfg.insideStroke);
      !out2.textStroke && (out2.textStroke = hostFill);
      out2.textStrokeWidth == null && (out2.textStrokeWidth = 2);
    }
  } else {
    if (textFillNotSet) {
      out2.textFill = itemStl.fill || txCfg.outsideFill || "#000";
    }
    !out2.textStroke && txCfg.outsideStroke && (out2.textStroke = txCfg.outsideStroke);
  }
  out2.text = txStl.text;
  out2.rich = txStl.rich;
  each$f(txStl.rich, function(richItem) {
    convertToEC4RichItem(richItem, richItem);
  });
  return out2;
}
function convertToEC4RichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  hasOwn(richItem, "fill") && (out2.textFill = richItem.fill);
  hasOwn(richItem, "stroke") && (out2.textStroke = richItem.fill);
  hasOwn(richItem, "lineWidth") && (out2.textStrokeWidth = richItem.lineWidth);
  hasOwn(richItem, "font") && (out2.font = richItem.font);
  hasOwn(richItem, "fontStyle") && (out2.fontStyle = richItem.fontStyle);
  hasOwn(richItem, "fontWeight") && (out2.fontWeight = richItem.fontWeight);
  hasOwn(richItem, "fontSize") && (out2.fontSize = richItem.fontSize);
  hasOwn(richItem, "fontFamily") && (out2.fontFamily = richItem.fontFamily);
  hasOwn(richItem, "align") && (out2.textAlign = richItem.align);
  hasOwn(richItem, "verticalAlign") && (out2.textVerticalAlign = richItem.verticalAlign);
  hasOwn(richItem, "lineHeight") && (out2.textLineHeight = richItem.lineHeight);
  hasOwn(richItem, "width") && (out2.textWidth = richItem.width);
  hasOwn(richItem, "height") && (out2.textHeight = richItem.height);
  hasOwn(richItem, "backgroundColor") && (out2.textBackgroundColor = richItem.backgroundColor);
  hasOwn(richItem, "padding") && (out2.textPadding = richItem.padding);
  hasOwn(richItem, "borderColor") && (out2.textBorderColor = richItem.borderColor);
  hasOwn(richItem, "borderWidth") && (out2.textBorderWidth = richItem.borderWidth);
  hasOwn(richItem, "borderRadius") && (out2.textBorderRadius = richItem.borderRadius);
  hasOwn(richItem, "shadowColor") && (out2.textBoxShadowColor = richItem.shadowColor);
  hasOwn(richItem, "shadowBlur") && (out2.textBoxShadowBlur = richItem.shadowBlur);
  hasOwn(richItem, "shadowOffsetX") && (out2.textBoxShadowOffsetX = richItem.shadowOffsetX);
  hasOwn(richItem, "shadowOffsetY") && (out2.textBoxShadowOffsetY = richItem.shadowOffsetY);
  hasOwn(richItem, "textShadowColor") && (out2.textShadowColor = richItem.textShadowColor);
  hasOwn(richItem, "textShadowBlur") && (out2.textShadowBlur = richItem.textShadowBlur);
  hasOwn(richItem, "textShadowOffsetX") && (out2.textShadowOffsetX = richItem.textShadowOffsetX);
  hasOwn(richItem, "textShadowOffsetY") && (out2.textShadowOffsetY = richItem.textShadowOffsetY);
}
var LEGACY_TRANSFORM_PROPS_MAP = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
};
var LEGACY_TRANSFORM_PROPS = keys(LEGACY_TRANSFORM_PROPS_MAP);
reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = 1;
  return obj;
}, {});
TRANSFORMABLE_PROPS.join(", ");
var ELEMENT_ANIMATABLE_PROPS = ["", "style", "shape", "extra"];
var transitionInnerStore = makeInner();
function getElementAnimationConfig(animationType, el, elOption, parentModel, dataIndex) {
  var animationProp = animationType + "Animation";
  var config = getAnimationConfig(animationType, parentModel, dataIndex) || {};
  var userDuring = transitionInnerStore(el).userDuring;
  if (config.duration > 0) {
    config.during = userDuring ? bind$1(duringCall, {
      el,
      userDuring
    }) : null;
    config.setToFinal = true;
    config.scope = animationType;
  }
  extend(config, elOption[animationProp]);
  return config;
}
function applyUpdateTransition(el, elOption, animatableModel, opts) {
  opts = opts || {};
  var dataIndex = opts.dataIndex, isInit = opts.isInit, clearStyle = opts.clearStyle;
  var hasAnimation = animatableModel.isAnimationEnabled();
  var store = transitionInnerStore(el);
  var styleOpt = elOption.style;
  store.userDuring = elOption.during;
  var transFromProps = {};
  var propsToSet = {};
  prepareTransformAllPropsFinal(el, elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("shape", elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("extra", elOption, propsToSet);
  if (!isInit && hasAnimation) {
    prepareTransformTransitionFrom(el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("shape", el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("extra", el, elOption, transFromProps);
    prepareStyleTransitionFrom(el, elOption, styleOpt, transFromProps);
  }
  propsToSet.style = styleOpt;
  applyPropsDirectly(el, propsToSet, clearStyle);
  applyMiscProps(el, elOption);
  if (hasAnimation) {
    if (isInit) {
      var enterFromProps_1 = {};
      each$f(ELEMENT_ANIMATABLE_PROPS, function(propName) {
        var prop = propName ? elOption[propName] : elOption;
        if (prop && prop.enterFrom) {
          if (propName) {
            enterFromProps_1[propName] = enterFromProps_1[propName] || {};
          }
          extend(propName ? enterFromProps_1[propName] : enterFromProps_1, prop.enterFrom);
        }
      });
      var config = getElementAnimationConfig("enter", el, elOption, animatableModel, dataIndex);
      if (config.duration > 0) {
        el.animateFrom(enterFromProps_1, config);
      }
    } else {
      applyPropsTransition(el, elOption, dataIndex || 0, animatableModel, transFromProps);
    }
  }
  updateLeaveTo(el, elOption);
  styleOpt ? el.dirty() : el.markRedraw();
}
function updateLeaveTo(el, elOption) {
  var leaveToProps = transitionInnerStore(el).leaveToProps;
  for (var i = 0; i < ELEMENT_ANIMATABLE_PROPS.length; i++) {
    var propName = ELEMENT_ANIMATABLE_PROPS[i];
    var prop = propName ? elOption[propName] : elOption;
    if (prop && prop.leaveTo) {
      if (!leaveToProps) {
        leaveToProps = transitionInnerStore(el).leaveToProps = {};
      }
      if (propName) {
        leaveToProps[propName] = leaveToProps[propName] || {};
      }
      extend(propName ? leaveToProps[propName] : leaveToProps, prop.leaveTo);
    }
  }
}
function applyLeaveTransition(el, elOption, animatableModel, onRemove) {
  if (el) {
    var parent_1 = el.parent;
    var leaveToProps = transitionInnerStore(el).leaveToProps;
    if (leaveToProps) {
      var config = getElementAnimationConfig("update", el, elOption, animatableModel, 0);
      config.done = function() {
        parent_1.remove(el);
        onRemove && onRemove();
      };
      el.animateTo(leaveToProps, config);
    } else {
      parent_1.remove(el);
      onRemove && onRemove();
    }
  }
}
function isTransitionAll(transition) {
  return transition === "all";
}
function applyPropsDirectly(el, allPropsFinal, clearStyle) {
  var styleOpt = allPropsFinal.style;
  if (!el.isGroup && styleOpt) {
    if (clearStyle) {
      el.useStyle({});
      var animators = el.animators;
      for (var i = 0; i < animators.length; i++) {
        var animator = animators[i];
        if (animator.targetName === "style") {
          animator.changeTarget(el.style);
        }
      }
    }
    el.setStyle(styleOpt);
  }
  if (allPropsFinal) {
    allPropsFinal.style = null;
    allPropsFinal && el.attr(allPropsFinal);
    allPropsFinal.style = styleOpt;
  }
}
function applyPropsTransition(el, elOption, dataIndex, model, transFromProps) {
  if (transFromProps) {
    var config = getElementAnimationConfig("update", el, elOption, model, dataIndex);
    if (config.duration > 0) {
      el.animateFrom(transFromProps, config);
    }
  }
}
function applyMiscProps(el, elOption) {
  hasOwn(elOption, "silent") && (el.silent = elOption.silent);
  hasOwn(elOption, "ignore") && (el.ignore = elOption.ignore);
  if (el instanceof Displayable$1) {
    hasOwn(elOption, "invisible") && (el.invisible = elOption.invisible);
  }
  if (el instanceof Path$1) {
    hasOwn(elOption, "autoBatch") && (el.autoBatch = elOption.autoBatch);
  }
}
var tmpDuringScope = {};
var transitionDuringAPI = {
  setTransform: function(key, val) {
    tmpDuringScope.el[key] = val;
    return this;
  },
  getTransform: function(key) {
    return tmpDuringScope.el[key];
  },
  setShape: function(key, val) {
    var el = tmpDuringScope.el;
    var shape = el.shape || (el.shape = {});
    shape[key] = val;
    el.dirtyShape && el.dirtyShape();
    return this;
  },
  getShape: function(key) {
    var shape = tmpDuringScope.el.shape;
    if (shape) {
      return shape[key];
    }
  },
  setStyle: function(key, val) {
    var el = tmpDuringScope.el;
    var style = el.style;
    if (style) {
      style[key] = val;
      el.dirtyStyle && el.dirtyStyle();
    }
    return this;
  },
  getStyle: function(key) {
    var style = tmpDuringScope.el.style;
    if (style) {
      return style[key];
    }
  },
  setExtra: function(key, val) {
    var extra = tmpDuringScope.el.extra || (tmpDuringScope.el.extra = {});
    extra[key] = val;
    return this;
  },
  getExtra: function(key) {
    var extra = tmpDuringScope.el.extra;
    if (extra) {
      return extra[key];
    }
  }
};
function duringCall() {
  var scope = this;
  var el = scope.el;
  if (!el) {
    return;
  }
  var latestUserDuring = transitionInnerStore(el).userDuring;
  var scopeUserDuring = scope.userDuring;
  if (latestUserDuring !== scopeUserDuring) {
    scope.el = scope.userDuring = null;
    return;
  }
  tmpDuringScope.el = el;
  scopeUserDuring(transitionDuringAPI);
}
function prepareShapeOrExtraTransitionFrom(mainAttr, fromEl, elOption, transFromProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var elPropsInAttr = fromEl[mainAttr];
  var transFromPropsInAttr;
  if (elPropsInAttr) {
    var transition = elOption.transition;
    var attrTransition = attrOpt.transition;
    if (attrTransition) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      if (isTransitionAll(attrTransition)) {
        extend(transFromPropsInAttr, elPropsInAttr);
      } else {
        var transitionKeys = normalizeToArray(attrTransition);
        for (var i = 0; i < transitionKeys.length; i++) {
          var key = transitionKeys[i];
          var elVal = elPropsInAttr[key];
          transFromPropsInAttr[key] = elVal;
        }
      }
    } else if (isTransitionAll(transition) || indexOf(transition, mainAttr) >= 0) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      var elPropsInAttrKeys = keys(elPropsInAttr);
      for (var i = 0; i < elPropsInAttrKeys.length; i++) {
        var key = elPropsInAttrKeys[i];
        var elVal = elPropsInAttr[key];
        if (isNonStyleTransitionEnabled(attrOpt[key], elVal)) {
          transFromPropsInAttr[key] = elVal;
        }
      }
    }
  }
}
function prepareShapeOrExtraAllPropsFinal(mainAttr, elOption, allProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var allPropsInAttr = allProps[mainAttr] = {};
  var keysInAttr = keys(attrOpt);
  for (var i = 0; i < keysInAttr.length; i++) {
    var key = keysInAttr[i];
    allPropsInAttr[key] = cloneValue(attrOpt[key]);
  }
}
function prepareTransformTransitionFrom(el, elOption, transFromProps) {
  var transition = elOption.transition;
  var transitionKeys = isTransitionAll(transition) ? TRANSFORMABLE_PROPS : normalizeToArray(transition || []);
  for (var i = 0; i < transitionKeys.length; i++) {
    var key = transitionKeys[i];
    if (key === "style" || key === "shape" || key === "extra") {
      continue;
    }
    var elVal = el[key];
    transFromProps[key] = elVal;
  }
}
function prepareTransformAllPropsFinal(el, elOption, allProps) {
  for (var i = 0; i < LEGACY_TRANSFORM_PROPS.length; i++) {
    var legacyName = LEGACY_TRANSFORM_PROPS[i];
    var xyName = LEGACY_TRANSFORM_PROPS_MAP[legacyName];
    var legacyArr = elOption[legacyName];
    if (legacyArr) {
      allProps[xyName[0]] = legacyArr[0];
      allProps[xyName[1]] = legacyArr[1];
    }
  }
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var key = TRANSFORMABLE_PROPS[i];
    if (elOption[key] != null) {
      allProps[key] = elOption[key];
    }
  }
}
function prepareStyleTransitionFrom(fromEl, elOption, styleOpt, transFromProps) {
  if (!styleOpt) {
    return;
  }
  var fromElStyle = fromEl.style;
  var transFromStyleProps;
  if (fromElStyle) {
    var styleTransition = styleOpt.transition;
    var elTransition = elOption.transition;
    if (styleTransition && !isTransitionAll(styleTransition)) {
      var transitionKeys = normalizeToArray(styleTransition);
      !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
      for (var i = 0; i < transitionKeys.length; i++) {
        var key = transitionKeys[i];
        var elVal = fromElStyle[key];
        transFromStyleProps[key] = elVal;
      }
    } else if (fromEl.getAnimationStyleProps && (isTransitionAll(elTransition) || isTransitionAll(styleTransition) || indexOf(elTransition, "style") >= 0)) {
      var animationProps = fromEl.getAnimationStyleProps();
      var animationStyleProps = animationProps ? animationProps.style : null;
      if (animationStyleProps) {
        !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
        var styleKeys = keys(styleOpt);
        for (var i = 0; i < styleKeys.length; i++) {
          var key = styleKeys[i];
          if (animationStyleProps[key]) {
            var elVal = fromElStyle[key];
            transFromStyleProps[key] = elVal;
          }
        }
      }
    }
  }
}
function isNonStyleTransitionEnabled(optVal, elVal) {
  return !isArrayLike(optVal) ? optVal != null && isFinite(optVal) : optVal !== elVal;
}
var getStateToRestore = makeInner();
var KEYFRAME_EXCLUDE_KEYS = ["percent", "easing", "shape", "style", "extra"];
function stopPreviousKeyframeAnimationAndRestore(el) {
  el.stopAnimation("keyframe");
  el.attr(getStateToRestore(el));
}
function applyKeyframeAnimation(el, animationOpts, animatableModel) {
  if (!animatableModel.isAnimationEnabled() || !animationOpts) {
    return;
  }
  if (isArray$1(animationOpts)) {
    each$f(animationOpts, function(singleAnimationOpts) {
      applyKeyframeAnimation(el, singleAnimationOpts, animatableModel);
    });
    return;
  }
  var keyframes = animationOpts.keyframes;
  var duration = animationOpts.duration;
  if (animatableModel && duration == null) {
    var config = getAnimationConfig("enter", animatableModel, 0);
    duration = config && config.duration;
  }
  if (!keyframes || !duration) {
    return;
  }
  var stateToRestore = getStateToRestore(el);
  each$f(ELEMENT_ANIMATABLE_PROPS, function(targetPropName) {
    if (targetPropName && !el[targetPropName]) {
      return;
    }
    var animator;
    keyframes.sort(function(a, b2) {
      return a.percent - b2.percent;
    });
    each$f(keyframes, function(kf) {
      var animators = el.animators;
      var kfValues = targetPropName ? kf[targetPropName] : kf;
      if (!kfValues) {
        return;
      }
      var propKeys = keys(kfValues);
      if (!targetPropName) {
        propKeys = filter(propKeys, function(key) {
          return indexOf(KEYFRAME_EXCLUDE_KEYS, key) < 0;
        });
      }
      if (!propKeys.length) {
        return;
      }
      if (!animator) {
        animator = el.animate(targetPropName, animationOpts.loop, true);
        animator.scope = "keyframe";
      }
      for (var i = 0; i < animators.length; i++) {
        if (animators[i] !== animator && animators[i].targetName === animator.targetName) {
          animators[i].stopTracks(propKeys);
        }
      }
      targetPropName && (stateToRestore[targetPropName] = stateToRestore[targetPropName] || {});
      var savedTarget = targetPropName ? stateToRestore[targetPropName] : stateToRestore;
      each$f(propKeys, function(key) {
        savedTarget[key] = ((targetPropName ? el[targetPropName] : el) || {})[key];
      });
      animator.whenWithKeys(duration * kf.percent, kfValues, propKeys, kf.easing);
    });
    if (!animator) {
      return;
    }
    animator.delay(animationOpts.delay || 0).duration(duration).start(animationOpts.easing);
  });
}
var EMPHASIS = "emphasis";
var NORMAL = "normal";
var BLUR = "blur";
var SELECT = "select";
var STATES = [NORMAL, EMPHASIS, BLUR, SELECT];
var PATH_ITEM_STYLE = {
  normal: ["itemStyle"],
  emphasis: [EMPHASIS, "itemStyle"],
  blur: [BLUR, "itemStyle"],
  select: [SELECT, "itemStyle"]
};
var PATH_LABEL = {
  normal: ["label"],
  emphasis: [EMPHASIS, "label"],
  blur: [BLUR, "label"],
  select: [SELECT, "label"]
};
var DEFAULT_TRANSITION = ["x", "y"];
var GROUP_DIFF_PREFIX = "e\0\0";
var attachedTxInfoTmp = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
};
var prepareCustoms = {
  cartesian2d: cartesianPrepareCustom,
  geo: geoPrepareCustom,
  singleAxis: singlePrepareCustom,
  polar: polarPrepareCustom,
  calendar: calendarPrepareCustom
};
function isPath(el) {
  return el instanceof Path$1;
}
function isDisplayable(el) {
  return el instanceof Displayable$1;
}
function copyElement(sourceEl, targetEl) {
  targetEl.copyTransform(sourceEl);
  if (isDisplayable(targetEl) && isDisplayable(sourceEl)) {
    targetEl.setStyle(sourceEl.style);
    targetEl.z = sourceEl.z;
    targetEl.z2 = sourceEl.z2;
    targetEl.zlevel = sourceEl.zlevel;
    targetEl.invisible = sourceEl.invisible;
    targetEl.ignore = sourceEl.ignore;
    if (isPath(targetEl) && isPath(sourceEl)) {
      targetEl.setShape(sourceEl.shape);
    }
  }
}
var CustomChartView = function(_super) {
  __extends(CustomChartView2, _super);
  function CustomChartView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomChartView2.type;
    return _this;
  }
  CustomChartView2.prototype.render = function(customSeries, ecModel, api, payload) {
    this._progressiveEls = null;
    var oldData = this._data;
    var data = customSeries.getData();
    var group = this.group;
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      createOrUpdateItem(api, null, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      applyLeaveTransition(el, customInnerStore(el).option, customSeries);
    }).update(function(newIdx, oldIdx) {
      var oldEl = oldData.getItemGraphicEl(oldIdx);
      createOrUpdateItem(api, oldEl, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).execute();
    var clipPath = customSeries.get("clip", true) ? createClipPath(customSeries.coordinateSystem, false, customSeries) : null;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
    this._data = data;
  };
  CustomChartView2.prototype.incrementalPrepareRender = function(customSeries, ecModel, api) {
    this.group.removeAll();
    this._data = null;
  };
  CustomChartView2.prototype.incrementalRender = function(params, customSeries, ecModel, api, payload) {
    var data = customSeries.getData();
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    var progressiveEls = this._progressiveEls = [];
    function setIncrementalAndHoverLayer(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = params.start; idx < params.end; idx++) {
      var el = createOrUpdateItem(null, null, idx, renderItem(idx, payload), customSeries, this.group, data);
      if (el) {
        el.traverse(setIncrementalAndHoverLayer);
        progressiveEls.push(el);
      }
    }
  };
  CustomChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CustomChartView2.prototype.filterForExposedEvent = function(eventType, query, targetEl, packedEvent) {
    var elementName = query.element;
    if (elementName == null || targetEl.name === elementName) {
      return true;
    }
    while ((targetEl = targetEl.__hostTarget || targetEl.parent) && targetEl !== this.group) {
      if (targetEl.name === elementName) {
        return true;
      }
    }
    return false;
  };
  CustomChartView2.type = "custom";
  return CustomChartView2;
}(ChartView$1);
var CustomChartView$1 = CustomChartView;
function createEl$1(elOption) {
  var graphicType = elOption.type;
  var el;
  if (graphicType === "path") {
    var shape = elOption.shape;
    var pathRect = shape.width != null && shape.height != null ? {
      x: shape.x || 0,
      y: shape.y || 0,
      width: shape.width,
      height: shape.height
    } : null;
    var pathData = getPathData(shape);
    el = makePath(pathData, null, pathRect, shape.layout || "center");
    customInnerStore(el).customPathData = pathData;
  } else if (graphicType === "image") {
    el = new ZRImage$1({});
    customInnerStore(el).customImagePath = elOption.style.image;
  } else if (graphicType === "text") {
    el = new ZRText$1({});
  } else if (graphicType === "group") {
    el = new Group$4();
  } else if (graphicType === "compoundPath") {
    throw new Error('"compoundPath" is not supported yet.');
  } else {
    var Clz = getShapeClass(graphicType);
    if (!Clz) {
      var errMsg = "";
      throwError(errMsg);
    }
    el = new Clz();
  }
  customInnerStore(el).customGraphicType = graphicType;
  el.name = elOption.name;
  el.z2EmphasisLift = 1;
  el.z2SelectLift = 1;
  return el;
}
function updateElNormal(api, el, dataIndex, elOption, attachedTxInfo, seriesModel, isInit) {
  stopPreviousKeyframeAnimationAndRestore(el);
  var txCfgOpt = attachedTxInfo && attachedTxInfo.normal.cfg;
  if (txCfgOpt) {
    el.setTextConfig(txCfgOpt);
  }
  if (elOption && elOption.transition == null) {
    elOption.transition = DEFAULT_TRANSITION;
  }
  var styleOpt = elOption && elOption.style;
  if (styleOpt) {
    if (el.type === "text") {
      var textOptionStyle = styleOpt;
      hasOwn(textOptionStyle, "textFill") && (textOptionStyle.fill = textOptionStyle.textFill);
      hasOwn(textOptionStyle, "textStroke") && (textOptionStyle.stroke = textOptionStyle.textStroke);
    }
    var decalPattern = void 0;
    var decalObj = isPath(el) ? styleOpt.decal : null;
    if (api && decalObj) {
      decalObj.dirty = true;
      decalPattern = createOrUpdatePatternFromDecal(decalObj, api);
    }
    styleOpt.__decalPattern = decalPattern;
  }
  if (isDisplayable(el)) {
    if (styleOpt) {
      var decalPattern = styleOpt.__decalPattern;
      if (decalPattern) {
        styleOpt.decal = decalPattern;
      }
    }
  }
  applyUpdateTransition(el, elOption, seriesModel, {
    dataIndex,
    isInit,
    clearStyle: true
  });
  applyKeyframeAnimation(el, elOption.keyframeAnimation, seriesModel);
}
function updateElOnState(state, el, elStateOpt, styleOpt, attachedTxInfo) {
  var elDisplayable = el.isGroup ? null : el;
  var txCfgOpt = attachedTxInfo && attachedTxInfo[state].cfg;
  if (elDisplayable) {
    var stateObj = elDisplayable.ensureState(state);
    if (styleOpt === false) {
      var existingEmphasisState = elDisplayable.getState(state);
      if (existingEmphasisState) {
        existingEmphasisState.style = null;
      }
    } else {
      stateObj.style = styleOpt || null;
    }
    if (txCfgOpt) {
      stateObj.textConfig = txCfgOpt;
    }
    setDefaultStateProxy(elDisplayable);
  }
}
function updateZ(el, elOption, seriesModel) {
  if (el.isGroup) {
    return;
  }
  var elDisplayable = el;
  var currentZ = seriesModel.currentZ;
  var currentZLevel = seriesModel.currentZLevel;
  elDisplayable.z = currentZ;
  elDisplayable.zlevel = currentZLevel;
  var optZ2 = elOption.z2;
  optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  for (var i = 0; i < STATES.length; i++) {
    updateZForEachState(elDisplayable, elOption, STATES[i]);
  }
}
function updateZForEachState(elDisplayable, elOption, state) {
  var isNormal = state === NORMAL;
  var elStateOpt = isNormal ? elOption : retrieveStateOption(elOption, state);
  var optZ2 = elStateOpt ? elStateOpt.z2 : null;
  var stateObj;
  if (optZ2 != null) {
    stateObj = isNormal ? elDisplayable : elDisplayable.ensureState(state);
    stateObj.z2 = optZ2 || 0;
  }
}
function makeRenderItem(customSeries, data, ecModel, api) {
  var renderItem = customSeries.get("renderItem");
  var coordSys = customSeries.coordinateSystem;
  var prepareResult2 = {};
  if (coordSys) {
    prepareResult2 = coordSys.prepareCustoms ? coordSys.prepareCustoms(coordSys) : prepareCustoms[coordSys.type](coordSys);
  }
  var userAPI = defaults({
    getWidth: api.getWidth,
    getHeight: api.getHeight,
    getZr: api.getZr,
    getDevicePixelRatio: api.getDevicePixelRatio,
    value,
    style,
    ordinalRawValue,
    styleEmphasis,
    visual,
    barLayout,
    currentSeriesIndices,
    font
  }, prepareResult2.api || {});
  var userParams = {
    context: {},
    seriesId: customSeries.id,
    seriesName: customSeries.name,
    seriesIndex: customSeries.seriesIndex,
    coordSys: prepareResult2.coordSys,
    dataInsideLength: data.count(),
    encode: wrapEncodeDef(customSeries.getData())
  };
  var currDataIndexInside;
  var currItemModel;
  var currItemStyleModels = {};
  var currLabelModels = {};
  var seriesItemStyleModels = {};
  var seriesLabelModels = {};
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    seriesItemStyleModels[stateName] = customSeries.getModel(PATH_ITEM_STYLE[stateName]);
    seriesLabelModels[stateName] = customSeries.getModel(PATH_LABEL[stateName]);
  }
  function getItemModel2(dataIndexInside) {
    return dataIndexInside === currDataIndexInside ? currItemModel || (currItemModel = data.getItemModel(dataIndexInside)) : data.getItemModel(dataIndexInside);
  }
  function getItemStyleModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesItemStyleModels[state] : dataIndexInside === currDataIndexInside ? currItemStyleModels[state] || (currItemStyleModels[state] = getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state])) : getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state]);
  }
  function getLabelModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesLabelModels[state] : dataIndexInside === currDataIndexInside ? currLabelModels[state] || (currLabelModels[state] = getItemModel2(dataIndexInside).getModel(PATH_LABEL[state])) : getItemModel2(dataIndexInside).getModel(PATH_LABEL[state]);
  }
  return function(dataIndexInside, payload) {
    currDataIndexInside = dataIndexInside;
    currItemModel = null;
    currItemStyleModels = {};
    currLabelModels = {};
    return renderItem && renderItem(defaults({
      dataIndexInside,
      dataIndex: data.getRawIndex(dataIndexInside),
      actionType: payload ? payload.type : null
    }, userParams), userAPI);
  };
  function value(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    return data.getStore().get(data.getDimensionIndex(dim || 0), dataIndexInside);
  }
  function ordinalRawValue(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    dim = dim || 0;
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo) {
      var dimIndex = data.getDimensionIndex(dim);
      return dimIndex >= 0 ? data.getStore().get(dimIndex, dataIndexInside) : void 0;
    }
    var val = data.get(dimInfo.name, dataIndexInside);
    var ordinalMeta = dimInfo && dimInfo.ordinalMeta;
    return ordinalMeta ? ordinalMeta.categories[val] : val;
  }
  function style(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var style2 = data.getItemVisual(dataIndexInside, "style");
    var visualColor = style2 && style2.fill;
    var opacity = style2 && style2.opacity;
    var itemStyle = getItemStyleModel(dataIndexInside, NORMAL).getItemStyle();
    visualColor != null && (itemStyle.fill = visualColor);
    opacity != null && (itemStyle.opacity = opacity);
    var opt = {
      inheritColor: isString(visualColor) ? visualColor : "#000"
    };
    var labelModel = getLabelModel(dataIndexInside, NORMAL);
    var textStyle = createTextStyle(labelModel, null, opt, false, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve2(customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, opt, false);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function styleEmphasis(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var itemStyle = getItemStyleModel(dataIndexInside, EMPHASIS).getItemStyle();
    var labelModel = getLabelModel(dataIndexInside, EMPHASIS);
    var textStyle = createTextStyle(labelModel, null, null, true, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve3(customSeries.getFormattedLabel(dataIndexInside, EMPHASIS), customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, null, true);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function applyUserPropsAfter(itemStyle, extra) {
    for (var key in extra) {
      if (hasOwn(extra, key)) {
        itemStyle[key] = extra[key];
      }
    }
  }
  function preFetchFromExtra(extra, itemStyle) {
    if (extra) {
      extra.textFill && (itemStyle.textFill = extra.textFill);
      extra.textPosition && (itemStyle.textPosition = extra.textPosition);
    }
  }
  function visual(visualType, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    if (hasOwn(STYLE_VISUAL_TYPE, visualType)) {
      var style_1 = data.getItemVisual(dataIndexInside, "style");
      return style_1 ? style_1[STYLE_VISUAL_TYPE[visualType]] : null;
    }
    if (hasOwn(NON_STYLE_VISUAL_PROPS, visualType)) {
      return data.getItemVisual(dataIndexInside, visualType);
    }
  }
  function barLayout(opt) {
    if (coordSys.type === "cartesian2d") {
      var baseAxis = coordSys.getBaseAxis();
      return getLayoutOnAxis(defaults({
        axis: baseAxis
      }, opt));
    }
  }
  function currentSeriesIndices() {
    return ecModel.getCurrentSeriesIndices();
  }
  function font(opt) {
    return getFont(opt, ecModel);
  }
}
function wrapEncodeDef(data) {
  var encodeDef = {};
  each$f(data.dimensions, function(dimName) {
    var dimInfo = data.getDimensionInfo(dimName);
    if (!dimInfo.isExtraCoord) {
      var coordDim = dimInfo.coordDim;
      var dataDims = encodeDef[coordDim] = encodeDef[coordDim] || [];
      dataDims[dimInfo.coordDimIndex] = data.getDimensionIndex(dimName);
    }
  });
  return encodeDef;
}
function createOrUpdateItem(api, existsEl, dataIndex, elOption, seriesModel, group, data) {
  if (!elOption) {
    group.remove(existsEl);
    return;
  }
  var el = doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group);
  el && data.setItemGraphicEl(dataIndex, el);
  el && toggleHoverEmphasis(el, elOption.focus, elOption.blurScope, elOption.emphasisDisabled);
  return el;
}
function doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group) {
  var toBeReplacedIdx = -1;
  var oldEl = existsEl;
  if (existsEl && doesElNeedRecreate(existsEl, elOption, seriesModel)) {
    toBeReplacedIdx = indexOf(group.childrenRef(), existsEl);
    existsEl = null;
  }
  var isInit = !existsEl;
  var el = existsEl;
  if (!el) {
    el = createEl$1(elOption);
    if (oldEl) {
      copyElement(oldEl, el);
    }
  } else {
    el.clearStates();
  }
  if (elOption.morph === false) {
    el.disableMorphing = true;
  } else if (el.disableMorphing) {
    el.disableMorphing = false;
  }
  attachedTxInfoTmp.normal.cfg = attachedTxInfoTmp.normal.conOpt = attachedTxInfoTmp.emphasis.cfg = attachedTxInfoTmp.emphasis.conOpt = attachedTxInfoTmp.blur.cfg = attachedTxInfoTmp.blur.conOpt = attachedTxInfoTmp.select.cfg = attachedTxInfoTmp.select.conOpt = null;
  attachedTxInfoTmp.isLegacy = false;
  doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfoTmp);
  doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit);
  updateElNormal(api, el, dataIndex, elOption, attachedTxInfoTmp, seriesModel, isInit);
  hasOwn(elOption, "info") && (customInnerStore(el).info = elOption.info);
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    if (stateName !== NORMAL) {
      var otherStateOpt = retrieveStateOption(elOption, stateName);
      var otherStyleOpt = retrieveStyleOptionOnState(elOption, otherStateOpt, stateName);
      updateElOnState(stateName, el, otherStateOpt, otherStyleOpt, attachedTxInfoTmp);
    }
  }
  updateZ(el, elOption, seriesModel);
  if (elOption.type === "group") {
    mergeChildren(api, el, dataIndex, elOption, seriesModel);
  }
  if (toBeReplacedIdx >= 0) {
    group.replaceAt(el, toBeReplacedIdx);
  } else {
    group.add(el);
  }
  return el;
}
function doesElNeedRecreate(el, elOption, seriesModel) {
  var elInner = customInnerStore(el);
  var elOptionType = elOption.type;
  var elOptionShape = elOption.shape;
  var elOptionStyle = elOption.style;
  return seriesModel.isUniversalTransitionEnabled() || elOptionType != null && elOptionType !== elInner.customGraphicType || elOptionType === "path" && hasOwnPathData(elOptionShape) && getPathData(elOptionShape) !== elInner.customPathData || elOptionType === "image" && hasOwn(elOptionStyle, "image") && elOptionStyle.image !== elInner.customImagePath;
}
function doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit) {
  var clipPathOpt = elOption.clipPath;
  if (clipPathOpt === false) {
    if (el && el.getClipPath()) {
      el.removeClipPath();
    }
  } else if (clipPathOpt) {
    var clipPath = el.getClipPath();
    if (clipPath && doesElNeedRecreate(clipPath, clipPathOpt, seriesModel)) {
      clipPath = null;
    }
    if (!clipPath) {
      clipPath = createEl$1(clipPathOpt);
      el.setClipPath(clipPath);
    }
    updateElNormal(null, clipPath, dataIndex, clipPathOpt, null, seriesModel, isInit);
  }
}
function doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfo) {
  if (el.isGroup) {
    return;
  }
  processTxInfo(elOption, null, attachedTxInfo);
  processTxInfo(elOption, EMPHASIS, attachedTxInfo);
  var txConOptNormal = attachedTxInfo.normal.conOpt;
  var txConOptEmphasis = attachedTxInfo.emphasis.conOpt;
  var txConOptBlur = attachedTxInfo.blur.conOpt;
  var txConOptSelect = attachedTxInfo.select.conOpt;
  if (txConOptNormal != null || txConOptEmphasis != null || txConOptSelect != null || txConOptBlur != null) {
    var textContent = el.getTextContent();
    if (txConOptNormal === false) {
      textContent && el.removeTextContent();
    } else {
      txConOptNormal = attachedTxInfo.normal.conOpt = txConOptNormal || {
        type: "text"
      };
      if (!textContent) {
        textContent = createEl$1(txConOptNormal);
        el.setTextContent(textContent);
      } else {
        textContent.clearStates();
      }
      updateElNormal(null, textContent, dataIndex, txConOptNormal, null, seriesModel, isInit);
      var txConStlOptNormal = txConOptNormal && txConOptNormal.style;
      for (var i = 0; i < STATES.length; i++) {
        var stateName = STATES[i];
        if (stateName !== NORMAL) {
          var txConOptOtherState = attachedTxInfo[stateName].conOpt;
          updateElOnState(stateName, textContent, txConOptOtherState, retrieveStyleOptionOnState(txConOptNormal, txConOptOtherState, stateName), null);
        }
      }
      txConStlOptNormal ? textContent.dirty() : textContent.markRedraw();
    }
  }
}
function processTxInfo(elOption, state, attachedTxInfo) {
  var stateOpt = !state ? elOption : retrieveStateOption(elOption, state);
  var styleOpt = !state ? elOption.style : retrieveStyleOptionOnState(elOption, stateOpt, EMPHASIS);
  var elType = elOption.type;
  var txCfg = stateOpt ? stateOpt.textConfig : null;
  var txConOptNormal = elOption.textContent;
  var txConOpt = !txConOptNormal ? null : !state ? txConOptNormal : retrieveStateOption(txConOptNormal, state);
  if (styleOpt && (attachedTxInfo.isLegacy || isEC4CompatibleStyle(styleOpt, elType, !!txCfg, !!txConOpt))) {
    attachedTxInfo.isLegacy = true;
    var convertResult = convertFromEC4CompatibleStyle(styleOpt, elType, !state);
    if (!txCfg && convertResult.textConfig) {
      txCfg = convertResult.textConfig;
    }
    if (!txConOpt && convertResult.textContent) {
      txConOpt = convertResult.textContent;
    }
  }
  if (!state && txConOpt) {
    var txConOptNormal_1 = txConOpt;
    !txConOptNormal_1.type && (txConOptNormal_1.type = "text");
  }
  var info = !state ? attachedTxInfo.normal : attachedTxInfo[state];
  info.cfg = txCfg;
  info.conOpt = txConOpt;
}
function retrieveStateOption(elOption, state) {
  return !state ? elOption : elOption ? elOption[state] : null;
}
function retrieveStyleOptionOnState(stateOptionNormal, stateOption, state) {
  var style = stateOption && stateOption.style;
  if (style == null && state === EMPHASIS && stateOptionNormal) {
    style = stateOptionNormal.styleEmphasis;
  }
  return style;
}
function mergeChildren(api, el, dataIndex, elOption, seriesModel) {
  var newChildren = elOption.children;
  var newLen = newChildren ? newChildren.length : 0;
  var mergeChildren2 = elOption.$mergeChildren;
  var byName = mergeChildren2 === "byName" || elOption.diffChildrenByName;
  var notMerge = mergeChildren2 === false;
  if (!newLen && !byName && !notMerge) {
    return;
  }
  if (byName) {
    diffGroupChildren({
      api,
      oldChildren: el.children() || [],
      newChildren: newChildren || [],
      dataIndex,
      seriesModel,
      group: el
    });
    return;
  }
  notMerge && el.removeAll();
  var index2 = 0;
  for (; index2 < newLen; index2++) {
    newChildren[index2] && doCreateOrUpdateEl(api, el.childAt(index2), dataIndex, newChildren[index2], seriesModel, el);
  }
  for (var i = el.childCount() - 1; i >= index2; i--) {
    var child = el.childAt(i);
    applyLeaveTransition(child, customInnerStore(el).option, seriesModel);
  }
}
function diffGroupChildren(context) {
  new DataDiffer$1(context.oldChildren, context.newChildren, getKey, getKey, context).add(processAddUpdate).update(processAddUpdate).remove(processRemove).execute();
}
function getKey(item, idx) {
  var name = item && item.name;
  return name != null ? name : GROUP_DIFF_PREFIX + idx;
}
function processAddUpdate(newIndex, oldIndex) {
  var context = this.context;
  var childOption = newIndex != null ? context.newChildren[newIndex] : null;
  var child = oldIndex != null ? context.oldChildren[oldIndex] : null;
  doCreateOrUpdateEl(context.api, child, context.dataIndex, childOption, context.seriesModel, context.group);
}
function processRemove(oldIndex) {
  var context = this.context;
  var child = context.oldChildren[oldIndex];
  applyLeaveTransition(child, customInnerStore(child).option, context.seriesModel);
}
function getPathData(shape) {
  return shape && (shape.pathData || shape.d);
}
function hasOwnPathData(shape) {
  return shape && (hasOwn(shape, "pathData") || hasOwn(shape, "d"));
}
function install$r(registers) {
  registers.registerChartView(CustomChartView$1);
  registers.registerSeriesModel(CustomSeriesModel$1);
}
var inner$b = makeInner();
var clone$1 = clone$4;
var bind = bind$1;
var BaseAxisPointer = function() {
  function BaseAxisPointer2() {
    this._dragging = false;
    this.animationThreshold = 15;
  }
  BaseAxisPointer2.prototype.render = function(axisModel, axisPointerModel, api, forceRender) {
    var value = axisPointerModel.get("value");
    var status = axisPointerModel.get("status");
    this._axisModel = axisModel;
    this._axisPointerModel = axisPointerModel;
    this._api = api;
    if (!forceRender && this._lastValue === value && this._lastStatus === status) {
      return;
    }
    this._lastValue = value;
    this._lastStatus = status;
    var group = this._group;
    var handle = this._handle;
    if (!status || status === "hide") {
      group && group.hide();
      handle && handle.hide();
      return;
    }
    group && group.show();
    handle && handle.show();
    var elOption = {};
    this.makeElOption(elOption, value, axisModel, axisPointerModel, api);
    var graphicKey = elOption.graphicKey;
    if (graphicKey !== this._lastGraphicKey) {
      this.clear(api);
    }
    this._lastGraphicKey = graphicKey;
    var moveAnimation = this._moveAnimation = this.determineAnimation(axisModel, axisPointerModel);
    if (!group) {
      group = this._group = new Group$4();
      this.createPointerEl(group, elOption, axisModel, axisPointerModel);
      this.createLabelEl(group, elOption, axisModel, axisPointerModel);
      api.getZr().add(group);
    } else {
      var doUpdateProps = curry$1(updateProps, axisPointerModel, moveAnimation);
      this.updatePointerEl(group, elOption, doUpdateProps);
      this.updateLabelEl(group, elOption, doUpdateProps, axisPointerModel);
    }
    updateMandatoryProps(group, axisPointerModel, true);
    this._renderHandle(value);
  };
  BaseAxisPointer2.prototype.remove = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.dispose = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.determineAnimation = function(axisModel, axisPointerModel) {
    var animation = axisPointerModel.get("animation");
    var axis = axisModel.axis;
    var isCategoryAxis = axis.type === "category";
    var useSnap = axisPointerModel.get("snap");
    if (!useSnap && !isCategoryAxis) {
      return false;
    }
    if (animation === "auto" || animation == null) {
      var animationThreshold = this.animationThreshold;
      if (isCategoryAxis && axis.getBandWidth() > animationThreshold) {
        return true;
      }
      if (useSnap) {
        var seriesDataCount = getAxisInfo$1(axisModel).seriesDataCount;
        var axisExtent = axis.getExtent();
        return Math.abs(axisExtent[0] - axisExtent[1]) / seriesDataCount > animationThreshold;
      }
      return false;
    }
    return animation === true;
  };
  BaseAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
  };
  BaseAxisPointer2.prototype.createPointerEl = function(group, elOption, axisModel, axisPointerModel) {
    var pointerOption = elOption.pointer;
    if (pointerOption) {
      var pointerEl = inner$b(group).pointerEl = new graphic[pointerOption.type](clone$1(elOption.pointer));
      group.add(pointerEl);
    }
  };
  BaseAxisPointer2.prototype.createLabelEl = function(group, elOption, axisModel, axisPointerModel) {
    if (elOption.label) {
      var labelEl = inner$b(group).labelEl = new ZRText$1(clone$1(elOption.label));
      group.add(labelEl);
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype.updatePointerEl = function(group, elOption, updateProps2) {
    var pointerEl = inner$b(group).pointerEl;
    if (pointerEl && elOption.pointer) {
      pointerEl.setStyle(elOption.pointer.style);
      updateProps2(pointerEl, {
        shape: elOption.pointer.shape
      });
    }
  };
  BaseAxisPointer2.prototype.updateLabelEl = function(group, elOption, updateProps2, axisPointerModel) {
    var labelEl = inner$b(group).labelEl;
    if (labelEl) {
      labelEl.setStyle(elOption.label.style);
      updateProps2(labelEl, {
        x: elOption.label.x,
        y: elOption.label.y
      });
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype._renderHandle = function(value) {
    if (this._dragging || !this.updateHandleTransform) {
      return;
    }
    var axisPointerModel = this._axisPointerModel;
    var zr = this._api.getZr();
    var handle = this._handle;
    var handleModel = axisPointerModel.getModel("handle");
    var status = axisPointerModel.get("status");
    if (!handleModel.get("show") || !status || status === "hide") {
      handle && zr.remove(handle);
      this._handle = null;
      return;
    }
    var isInit;
    if (!this._handle) {
      isInit = true;
      handle = this._handle = createIcon(handleModel.get("icon"), {
        cursor: "move",
        draggable: true,
        onmousemove: function(e2) {
          stop(e2.event);
        },
        onmousedown: bind(this._onHandleDragMove, this, 0, 0),
        drift: bind(this._onHandleDragMove, this),
        ondragend: bind(this._onHandleDragEnd, this)
      });
      zr.add(handle);
    }
    updateMandatoryProps(handle, axisPointerModel, false);
    handle.setStyle(handleModel.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
    var handleSize = handleModel.get("size");
    if (!isArray$1(handleSize)) {
      handleSize = [handleSize, handleSize];
    }
    handle.scaleX = handleSize[0] / 2;
    handle.scaleY = handleSize[1] / 2;
    createOrUpdate(this, "_doDispatchAxisPointer", handleModel.get("throttle") || 0, "fixRate");
    this._moveHandleToValue(value, isInit);
  };
  BaseAxisPointer2.prototype._moveHandleToValue = function(value, isInit) {
    updateProps(this._axisPointerModel, !isInit && this._moveAnimation, this._handle, getHandleTransProps(this.getHandleTransform(value, this._axisModel, this._axisPointerModel)));
  };
  BaseAxisPointer2.prototype._onHandleDragMove = function(dx, dy) {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    this._dragging = true;
    var trans = this.updateHandleTransform(getHandleTransProps(handle), [dx, dy], this._axisModel, this._axisPointerModel);
    this._payloadInfo = trans;
    handle.stopAnimation();
    handle.attr(getHandleTransProps(trans));
    inner$b(handle).lastProp = null;
    this._doDispatchAxisPointer();
  };
  BaseAxisPointer2.prototype._doDispatchAxisPointer = function() {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var payloadInfo = this._payloadInfo;
    var axisModel = this._axisModel;
    this._api.dispatchAction({
      type: "updateAxisPointer",
      x: payloadInfo.cursorPoint[0],
      y: payloadInfo.cursorPoint[1],
      tooltipOption: payloadInfo.tooltipOption,
      axesInfo: [{
        axisDim: axisModel.axis.dim,
        axisIndex: axisModel.componentIndex
      }]
    });
  };
  BaseAxisPointer2.prototype._onHandleDragEnd = function() {
    this._dragging = false;
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var value = this._axisPointerModel.get("value");
    this._moveHandleToValue(value);
    this._api.dispatchAction({
      type: "hideTip"
    });
  };
  BaseAxisPointer2.prototype.clear = function(api) {
    this._lastValue = null;
    this._lastStatus = null;
    var zr = api.getZr();
    var group = this._group;
    var handle = this._handle;
    if (zr && group) {
      this._lastGraphicKey = null;
      group && zr.remove(group);
      handle && zr.remove(handle);
      this._group = null;
      this._handle = null;
      this._payloadInfo = null;
    }
    clear$1(this, "_doDispatchAxisPointer");
  };
  BaseAxisPointer2.prototype.doClear = function() {
  };
  BaseAxisPointer2.prototype.buildLabel = function(xy, wh, xDimIndex) {
    xDimIndex = xDimIndex || 0;
    return {
      x: xy[xDimIndex],
      y: xy[1 - xDimIndex],
      width: wh[xDimIndex],
      height: wh[1 - xDimIndex]
    };
  };
  return BaseAxisPointer2;
}();
function updateProps(animationModel, moveAnimation, el, props) {
  if (!propsEqual(inner$b(el).lastProp, props)) {
    inner$b(el).lastProp = props;
    moveAnimation ? updateProps$1(el, props, animationModel) : (el.stopAnimation(), el.attr(props));
  }
}
function propsEqual(lastProps, newProps) {
  if (isObject$4(lastProps) && isObject$4(newProps)) {
    var equals_1 = true;
    each$f(newProps, function(item, key) {
      equals_1 = equals_1 && propsEqual(lastProps[key], item);
    });
    return !!equals_1;
  } else {
    return lastProps === newProps;
  }
}
function updateLabelShowHide(labelEl, axisPointerModel) {
  labelEl[axisPointerModel.get(["label", "show"]) ? "show" : "hide"]();
}
function getHandleTransProps(trans) {
  return {
    x: trans.x || 0,
    y: trans.y || 0,
    rotation: trans.rotation || 0
  };
}
function updateMandatoryProps(group, axisPointerModel, silent) {
  var z2 = axisPointerModel.get("z");
  var zlevel = axisPointerModel.get("zlevel");
  group && group.traverse(function(el) {
    if (el.type !== "group") {
      z2 != null && (el.z = z2);
      zlevel != null && (el.zlevel = zlevel);
      el.silent = silent;
    }
  });
}
var BaseAxisPointer$1 = BaseAxisPointer;
function buildElStyle(axisPointerModel) {
  var axisPointerType = axisPointerModel.get("type");
  var styleModel = axisPointerModel.getModel(axisPointerType + "Style");
  var style;
  if (axisPointerType === "line") {
    style = styleModel.getLineStyle();
    style.fill = null;
  } else if (axisPointerType === "shadow") {
    style = styleModel.getAreaStyle();
    style.stroke = null;
  }
  return style;
}
function buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos) {
  var value = axisPointerModel.get("value");
  var text = getValueLabel(value, axisModel.axis, axisModel.ecModel, axisPointerModel.get("seriesDataIndices"), {
    precision: axisPointerModel.get(["label", "precision"]),
    formatter: axisPointerModel.get(["label", "formatter"])
  });
  var labelModel = axisPointerModel.getModel("label");
  var paddings = normalizeCssArray(labelModel.get("padding") || 0);
  var font = labelModel.getFont();
  var textRect = getBoundingRect(text, font);
  var position2 = labelPos.position;
  var width = textRect.width + paddings[1] + paddings[3];
  var height = textRect.height + paddings[0] + paddings[2];
  var align = labelPos.align;
  align === "right" && (position2[0] -= width);
  align === "center" && (position2[0] -= width / 2);
  var verticalAlign = labelPos.verticalAlign;
  verticalAlign === "bottom" && (position2[1] -= height);
  verticalAlign === "middle" && (position2[1] -= height / 2);
  confineInContainer(position2, width, height, api);
  var bgColor = labelModel.get("backgroundColor");
  if (!bgColor || bgColor === "auto") {
    bgColor = axisModel.get(["axisLine", "lineStyle", "color"]);
  }
  elOption.label = {
    x: position2[0],
    y: position2[1],
    style: createTextStyle(labelModel, {
      text,
      font,
      fill: labelModel.getTextColor(),
      padding: paddings,
      backgroundColor: bgColor
    }),
    z2: 10
  };
}
function confineInContainer(position2, width, height, api) {
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  position2[0] = Math.min(position2[0] + width, viewWidth) - width;
  position2[1] = Math.min(position2[1] + height, viewHeight) - height;
  position2[0] = Math.max(position2[0], 0);
  position2[1] = Math.max(position2[1], 0);
}
function getValueLabel(value, axis, ecModel, seriesDataIndices, opt) {
  value = axis.scale.parse(value);
  var text = axis.scale.getLabel({
    value
  }, {
    precision: opt.precision
  });
  var formatter = opt.formatter;
  if (formatter) {
    var params_1 = {
      value: getAxisRawValue(axis, {
        value
      }),
      axisDimension: axis.dim,
      axisIndex: axis.index,
      seriesData: []
    };
    each$f(seriesDataIndices, function(idxItem) {
      var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
      var dataIndex = idxItem.dataIndexInside;
      var dataParams = series && series.getDataParams(dataIndex);
      dataParams && params_1.seriesData.push(dataParams);
    });
    if (isString(formatter)) {
      text = formatter.replace("{value}", text);
    } else if (isFunction(formatter)) {
      text = formatter(params_1);
    }
  }
  return text;
}
function getTransformedPosition(axis, value, layoutInfo) {
  var transform2 = create$1();
  rotate(transform2, transform2, layoutInfo.rotation);
  translate(transform2, transform2, layoutInfo.position);
  return applyTransform([axis.dataToCoord(value), (layoutInfo.labelOffset || 0) + (layoutInfo.labelDirection || 1) * (layoutInfo.labelMargin || 0)], transform2);
}
function buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api) {
  var textLayout = AxisBuilder$1.innerTextLayout(layoutInfo.rotation, 0, layoutInfo.labelDirection);
  layoutInfo.labelMargin = axisPointerModel.get(["label", "margin"]);
  buildLabelElOption(elOption, axisModel, axisPointerModel, api, {
    position: getTransformedPosition(axisModel.axis, value, layoutInfo),
    align: textLayout.textAlign,
    verticalAlign: textLayout.textVerticalAlign
  });
}
function makeLineShape(p1, p2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x1: p1[xDimIndex],
    y1: p1[1 - xDimIndex],
    x2: p2[xDimIndex],
    y2: p2[1 - xDimIndex]
  };
}
function makeRectShape(xy, wh, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x: xy[xDimIndex],
    y: xy[1 - xDimIndex],
    width: wh[xDimIndex],
    height: wh[1 - xDimIndex]
  };
}
function makeSectorShape(cx, cy, r0, r2, startAngle, endAngle) {
  return {
    cx,
    cy,
    r0,
    r: r2,
    startAngle,
    endAngle,
    clockwise: true
  };
}
var CartesianAxisPointer = function(_super) {
  __extends(CartesianAxisPointer2, _super);
  function CartesianAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisPointerType = axisPointerModel.get("type");
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var pixelValue = axis.toGlobalCoord(axis.dataToCoord(value, true));
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$2[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$2(grid.model, axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  CartesianAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$2(axisModel.axis.grid.model, axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var pos = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: pos[0],
      y: pos[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  CartesianAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisExtent = axis.getGlobalExtent(true);
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var dimIndex = axis.dim === "x" ? 0 : 1;
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    var tooltipOptions = [{
      verticalAlign: "middle"
    }, {
      align: "center"
    }];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: tooltipOptions[dimIndex]
    };
  };
  return CartesianAxisPointer2;
}(BaseAxisPointer$1);
function getCartesian(grid, axis) {
  var opt = {};
  opt[axis.dim + "AxisIndex"] = axis.index;
  return grid.getCartesian(opt);
}
var pointerShapeBuilder$2 = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getAxisDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getAxisDimIndex(axis))
    };
  }
};
function getAxisDimIndex(axis) {
  return axis.dim === "x" ? 0 : 1;
}
var CartesianAxisPointer$1 = CartesianAxisPointer;
var AxisPointerModel = function(_super) {
  __extends(AxisPointerModel2, _super);
  function AxisPointerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerModel2.type;
    return _this;
  }
  AxisPointerModel2.type = "axisPointer";
  AxisPointerModel2.defaultOption = {
    show: "auto",
    z: 50,
    type: "line",
    snap: false,
    triggerTooltip: true,
    value: null,
    status: null,
    link: [],
    animation: null,
    animationDurationUpdate: 200,
    lineStyle: {
      color: "#B9BEC9",
      width: 1,
      type: "dashed"
    },
    shadowStyle: {
      color: "rgba(210,219,238,0.2)"
    },
    label: {
      show: true,
      formatter: null,
      precision: "auto",
      margin: 3,
      color: "#fff",
      padding: [5, 7, 5, 7],
      backgroundColor: "auto",
      borderColor: null,
      borderWidth: 0,
      borderRadius: 3
    },
    handle: {
      show: false,
      icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z",
      size: 45,
      margin: 50,
      color: "#333",
      shadowBlur: 3,
      shadowColor: "#aaa",
      shadowOffsetX: 0,
      shadowOffsetY: 2,
      throttle: 40
    }
  };
  return AxisPointerModel2;
}(ComponentModel$1);
var AxisPointerModel$1 = AxisPointerModel;
var inner$a = makeInner();
var each$8 = each$f;
function register(key, api, handler) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  inner$a(zr).records || (inner$a(zr).records = {});
  initGlobalListeners(zr, api);
  var record = inner$a(zr).records[key] || (inner$a(zr).records[key] = {});
  record.handler = handler;
}
function initGlobalListeners(zr, api) {
  if (inner$a(zr).initialized) {
    return;
  }
  inner$a(zr).initialized = true;
  useHandler("click", curry$1(doEnter, "click"));
  useHandler("mousemove", curry$1(doEnter, "mousemove"));
  useHandler("globalout", onLeave);
  function useHandler(eventType, cb) {
    zr.on(eventType, function(e2) {
      var dis = makeDispatchAction$1(api);
      each$8(inner$a(zr).records, function(record) {
        record && cb(record, e2, dis.dispatchAction);
      });
      dispatchTooltipFinally(dis.pendings, api);
    });
  }
}
function dispatchTooltipFinally(pendings, api) {
  var showLen = pendings.showTip.length;
  var hideLen = pendings.hideTip.length;
  var actuallyPayload;
  if (showLen) {
    actuallyPayload = pendings.showTip[showLen - 1];
  } else if (hideLen) {
    actuallyPayload = pendings.hideTip[hideLen - 1];
  }
  if (actuallyPayload) {
    actuallyPayload.dispatchAction = null;
    api.dispatchAction(actuallyPayload);
  }
}
function onLeave(record, e2, dispatchAction2) {
  record.handler("leave", null, dispatchAction2);
}
function doEnter(currTrigger, record, e2, dispatchAction2) {
  record.handler(currTrigger, e2, dispatchAction2);
}
function makeDispatchAction$1(api) {
  var pendings = {
    showTip: [],
    hideTip: []
  };
  var dispatchAction2 = function(payload) {
    var pendingList = pendings[payload.type];
    if (pendingList) {
      pendingList.push(payload);
    } else {
      payload.dispatchAction = dispatchAction2;
      api.dispatchAction(payload);
    }
  };
  return {
    dispatchAction: dispatchAction2,
    pendings
  };
}
function unregister(key, api) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  var record = (inner$a(zr).records || {})[key];
  if (record) {
    inner$a(zr).records[key] = null;
  }
}
var AxisPointerView = function(_super) {
  __extends(AxisPointerView2, _super);
  function AxisPointerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerView2.type;
    return _this;
  }
  AxisPointerView2.prototype.render = function(globalAxisPointerModel, ecModel, api) {
    var globalTooltipModel = ecModel.getComponent("tooltip");
    var triggerOn = globalAxisPointerModel.get("triggerOn") || globalTooltipModel && globalTooltipModel.get("triggerOn") || "mousemove|click";
    register("axisPointer", api, function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none" && (currTrigger === "leave" || triggerOn.indexOf(currTrigger) >= 0)) {
        dispatchAction2({
          type: "updateAxisPointer",
          currTrigger,
          x: e2 && e2.offsetX,
          y: e2 && e2.offsetY
        });
      }
    });
  };
  AxisPointerView2.prototype.remove = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.prototype.dispose = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.type = "axisPointer";
  return AxisPointerView2;
}(ComponentView$1);
var AxisPointerView$1 = AxisPointerView;
function findPointFromSeries(finder, ecModel) {
  var point = [];
  var seriesIndex = finder.seriesIndex;
  var seriesModel;
  if (seriesIndex == null || !(seriesModel = ecModel.getSeriesByIndex(seriesIndex))) {
    return {
      point: []
    };
  }
  var data = seriesModel.getData();
  var dataIndex = queryDataIndex(data, finder);
  if (dataIndex == null || dataIndex < 0 || isArray$1(dataIndex)) {
    return {
      point: []
    };
  }
  var el = data.getItemGraphicEl(dataIndex);
  var coordSys = seriesModel.coordinateSystem;
  if (seriesModel.getTooltipPosition) {
    point = seriesModel.getTooltipPosition(dataIndex) || [];
  } else if (coordSys && coordSys.dataToPoint) {
    if (finder.isStacked) {
      var baseAxis = coordSys.getBaseAxis();
      var valueAxis2 = coordSys.getOtherAxis(baseAxis);
      var valueAxisDim = valueAxis2.dim;
      var baseAxisDim = baseAxis.dim;
      var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
      var baseDim = data.mapDimension(baseAxisDim);
      var stackedData = [];
      stackedData[baseDataOffset] = data.get(baseDim, dataIndex);
      stackedData[1 - baseDataOffset] = data.get(data.getCalculationInfo("stackResultDimension"), dataIndex);
      point = coordSys.dataToPoint(stackedData) || [];
    } else {
      point = coordSys.dataToPoint(data.getValues(map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }), dataIndex)) || [];
    }
  } else if (el) {
    var rect = el.getBoundingRect().clone();
    rect.applyTransform(el.transform);
    point = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  }
  return {
    point,
    el
  };
}
var inner$9 = makeInner();
function axisTrigger(payload, ecModel, api) {
  var currTrigger = payload.currTrigger;
  var point = [payload.x, payload.y];
  var finder = payload;
  var dispatchAction2 = payload.dispatchAction || bind$1(api.dispatchAction, api);
  var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
  if (!coordSysAxesInfo) {
    return;
  }
  if (illegalPoint(point)) {
    point = findPointFromSeries({
      seriesIndex: finder.seriesIndex,
      dataIndex: finder.dataIndex
    }, ecModel).point;
  }
  var isIllegalPoint = illegalPoint(point);
  var inputAxesInfo = finder.axesInfo;
  var axesInfo = coordSysAxesInfo.axesInfo;
  var shouldHide = currTrigger === "leave" || illegalPoint(point);
  var outputPayload = {};
  var showValueMap = {};
  var dataByCoordSys = {
    list: [],
    map: {}
  };
  var updaters = {
    showPointer: curry$1(showPointer, showValueMap),
    showTooltip: curry$1(showTooltip, dataByCoordSys)
  };
  each$f(coordSysAxesInfo.coordSysMap, function(coordSys, coordSysKey) {
    var coordSysContainsPoint = isIllegalPoint || coordSys.containPoint(point);
    each$f(coordSysAxesInfo.coordSysAxesInfo[coordSysKey], function(axisInfo, key) {
      var axis = axisInfo.axis;
      var inputAxisInfo = findInputAxisInfo(inputAxesInfo, axisInfo);
      if (!shouldHide && coordSysContainsPoint && (!inputAxesInfo || inputAxisInfo)) {
        var val = inputAxisInfo && inputAxisInfo.value;
        if (val == null && !isIllegalPoint) {
          val = axis.pointToData(point);
        }
        val != null && processOnAxis(axisInfo, val, updaters, false, outputPayload);
      }
    });
  });
  var linkTriggers = {};
  each$f(axesInfo, function(tarAxisInfo, tarKey) {
    var linkGroup = tarAxisInfo.linkGroup;
    if (linkGroup && !showValueMap[tarKey]) {
      each$f(linkGroup.axesInfo, function(srcAxisInfo, srcKey) {
        var srcValItem = showValueMap[srcKey];
        if (srcAxisInfo !== tarAxisInfo && srcValItem) {
          var val = srcValItem.value;
          linkGroup.mapper && (val = tarAxisInfo.axis.scale.parse(linkGroup.mapper(val, makeMapperParam(srcAxisInfo), makeMapperParam(tarAxisInfo))));
          linkTriggers[tarAxisInfo.key] = val;
        }
      });
    }
  });
  each$f(linkTriggers, function(val, tarKey) {
    processOnAxis(axesInfo[tarKey], val, updaters, true, outputPayload);
  });
  updateModelActually(showValueMap, axesInfo, outputPayload);
  dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2);
  dispatchHighDownActually(axesInfo, dispatchAction2, api);
  return outputPayload;
}
function processOnAxis(axisInfo, newValue, updaters, noSnap, outputFinder) {
  var axis = axisInfo.axis;
  if (axis.scale.isBlank() || !axis.containData(newValue)) {
    return;
  }
  if (!axisInfo.involveSeries) {
    updaters.showPointer(axisInfo, newValue);
    return;
  }
  var payloadInfo = buildPayloadsBySeries(newValue, axisInfo);
  var payloadBatch = payloadInfo.payloadBatch;
  var snapToValue = payloadInfo.snapToValue;
  if (payloadBatch[0] && outputFinder.seriesIndex == null) {
    extend(outputFinder, payloadBatch[0]);
  }
  if (!noSnap && axisInfo.snap) {
    if (axis.containData(snapToValue) && snapToValue != null) {
      newValue = snapToValue;
    }
  }
  updaters.showPointer(axisInfo, newValue, payloadBatch);
  updaters.showTooltip(axisInfo, payloadInfo, snapToValue);
}
function buildPayloadsBySeries(value, axisInfo) {
  var axis = axisInfo.axis;
  var dim = axis.dim;
  var snapToValue = value;
  var payloadBatch = [];
  var minDist = Number.MAX_VALUE;
  var minDiff = -1;
  each$f(axisInfo.seriesModels, function(series, idx) {
    var dataDim = series.getData().mapDimensionsAll(dim);
    var seriesNestestValue;
    var dataIndices;
    if (series.getAxisTooltipData) {
      var result = series.getAxisTooltipData(dataDim, value, axis);
      dataIndices = result.dataIndices;
      seriesNestestValue = result.nestestValue;
    } else {
      dataIndices = series.getData().indicesOfNearest(dataDim[0], value, axis.type === "category" ? 0.5 : null);
      if (!dataIndices.length) {
        return;
      }
      seriesNestestValue = series.getData().get(dataDim[0], dataIndices[0]);
    }
    if (seriesNestestValue == null || !isFinite(seriesNestestValue)) {
      return;
    }
    var diff = value - seriesNestestValue;
    var dist2 = Math.abs(diff);
    if (dist2 <= minDist) {
      if (dist2 < minDist || diff >= 0 && minDiff < 0) {
        minDist = dist2;
        minDiff = diff;
        snapToValue = seriesNestestValue;
        payloadBatch.length = 0;
      }
      each$f(dataIndices, function(dataIndex) {
        payloadBatch.push({
          seriesIndex: series.seriesIndex,
          dataIndexInside: dataIndex,
          dataIndex: series.getData().getRawIndex(dataIndex)
        });
      });
    }
  });
  return {
    payloadBatch,
    snapToValue
  };
}
function showPointer(showValueMap, axisInfo, value, payloadBatch) {
  showValueMap[axisInfo.key] = {
    value,
    payloadBatch
  };
}
function showTooltip(dataByCoordSys, axisInfo, payloadInfo, value) {
  var payloadBatch = payloadInfo.payloadBatch;
  var axis = axisInfo.axis;
  var axisModel = axis.model;
  var axisPointerModel = axisInfo.axisPointerModel;
  if (!axisInfo.triggerTooltip || !payloadBatch.length) {
    return;
  }
  var coordSysModel = axisInfo.coordSys.model;
  var coordSysKey = makeKey(coordSysModel);
  var coordSysItem = dataByCoordSys.map[coordSysKey];
  if (!coordSysItem) {
    coordSysItem = dataByCoordSys.map[coordSysKey] = {
      coordSysId: coordSysModel.id,
      coordSysIndex: coordSysModel.componentIndex,
      coordSysType: coordSysModel.type,
      coordSysMainType: coordSysModel.mainType,
      dataByAxis: []
    };
    dataByCoordSys.list.push(coordSysItem);
  }
  coordSysItem.dataByAxis.push({
    axisDim: axis.dim,
    axisIndex: axisModel.componentIndex,
    axisType: axisModel.type,
    axisId: axisModel.id,
    value,
    valueLabelOpt: {
      precision: axisPointerModel.get(["label", "precision"]),
      formatter: axisPointerModel.get(["label", "formatter"])
    },
    seriesDataIndices: payloadBatch.slice()
  });
}
function updateModelActually(showValueMap, axesInfo, outputPayload) {
  var outputAxesInfo = outputPayload.axesInfo = [];
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    var valItem = showValueMap[key];
    if (valItem) {
      !axisInfo.useHandle && (option.status = "show");
      option.value = valItem.value;
      option.seriesDataIndices = (valItem.payloadBatch || []).slice();
    } else {
      !axisInfo.useHandle && (option.status = "hide");
    }
    option.status === "show" && outputAxesInfo.push({
      axisDim: axisInfo.axis.dim,
      axisIndex: axisInfo.axis.model.componentIndex,
      value: option.value
    });
  });
}
function dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2) {
  if (illegalPoint(point) || !dataByCoordSys.list.length) {
    dispatchAction2({
      type: "hideTip"
    });
    return;
  }
  var sampleItem = ((dataByCoordSys.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
  dispatchAction2({
    type: "showTip",
    escapeConnect: true,
    x: point[0],
    y: point[1],
    tooltipOption: payload.tooltipOption,
    position: payload.position,
    dataIndexInside: sampleItem.dataIndexInside,
    dataIndex: sampleItem.dataIndex,
    seriesIndex: sampleItem.seriesIndex,
    dataByCoordSys: dataByCoordSys.list
  });
}
function dispatchHighDownActually(axesInfo, dispatchAction2, api) {
  var zr = api.getZr();
  var highDownKey = "axisPointerLastHighlights";
  var lastHighlights = inner$9(zr)[highDownKey] || {};
  var newHighlights = inner$9(zr)[highDownKey] = {};
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    option.status === "show" && each$f(option.seriesDataIndices, function(batchItem) {
      var key2 = batchItem.seriesIndex + " | " + batchItem.dataIndex;
      newHighlights[key2] = batchItem;
    });
  });
  var toHighlight = [];
  var toDownplay = [];
  each$f(lastHighlights, function(batchItem, key) {
    !newHighlights[key] && toDownplay.push(batchItem);
  });
  each$f(newHighlights, function(batchItem, key) {
    !lastHighlights[key] && toHighlight.push(batchItem);
  });
  toDownplay.length && api.dispatchAction({
    type: "downplay",
    escapeConnect: true,
    notBlur: true,
    batch: toDownplay
  });
  toHighlight.length && api.dispatchAction({
    type: "highlight",
    escapeConnect: true,
    notBlur: true,
    batch: toHighlight
  });
}
function findInputAxisInfo(inputAxesInfo, axisInfo) {
  for (var i = 0; i < (inputAxesInfo || []).length; i++) {
    var inputAxisInfo = inputAxesInfo[i];
    if (axisInfo.axis.dim === inputAxisInfo.axisDim && axisInfo.axis.model.componentIndex === inputAxisInfo.axisIndex) {
      return inputAxisInfo;
    }
  }
}
function makeMapperParam(axisInfo) {
  var axisModel = axisInfo.axis.model;
  var item = {};
  var dim = item.axisDim = axisInfo.axis.dim;
  item.axisIndex = item[dim + "AxisIndex"] = axisModel.componentIndex;
  item.axisName = item[dim + "AxisName"] = axisModel.name;
  item.axisId = item[dim + "AxisId"] = axisModel.id;
  return item;
}
function illegalPoint(point) {
  return !point || point[0] == null || isNaN(point[0]) || point[1] == null || isNaN(point[1]);
}
function install$q(registers) {
  AxisView$1.registerAxisPointerClass("CartesianAxisPointer", CartesianAxisPointer$1);
  registers.registerComponentModel(AxisPointerModel$1);
  registers.registerComponentView(AxisPointerView$1);
  registers.registerPreprocessor(function(option) {
    if (option) {
      (!option.axisPointer || option.axisPointer.length === 0) && (option.axisPointer = {});
      var link = option.axisPointer.link;
      if (link && !isArray$1(link)) {
        option.axisPointer.link = [link];
      }
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, function(ecModel, api) {
    ecModel.getComponent("axisPointer").coordSysAxesInfo = collect(ecModel, api);
  });
  registers.registerAction({
    type: "updateAxisPointer",
    event: "updateAxisPointer",
    update: ":updateAxisPointer"
  }, axisTrigger);
}
function install$p(registers) {
  use(install$N);
  use(install$q);
}
var PolarAxisPointer = function(_super) {
  __extends(PolarAxisPointer2, _super);
  function PolarAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    if (axis.dim === "angle") {
      this.animationThreshold = Math.PI / 18;
    }
    var polar = axis.polar;
    var otherAxis = polar.getOtherAxis(axis);
    var otherExtent = otherAxis.getExtent();
    var coordValue = axis.dataToCoord(value);
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$1[axisPointerType](axis, polar, coordValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var labelMargin = axisPointerModel.get(["label", "margin"]);
    var labelPos = getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin);
    buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos);
  };
  return PolarAxisPointer2;
}(BaseAxisPointer$1);
function getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin) {
  var axis = axisModel.axis;
  var coord = axis.dataToCoord(value);
  var axisAngle = polar.getAngleAxis().getExtent()[0];
  axisAngle = axisAngle / 180 * Math.PI;
  var radiusExtent = polar.getRadiusAxis().getExtent();
  var position2;
  var align;
  var verticalAlign;
  if (axis.dim === "radius") {
    var transform2 = create$1();
    rotate(transform2, transform2, axisAngle);
    translate(transform2, transform2, [polar.cx, polar.cy]);
    position2 = applyTransform([coord, -labelMargin], transform2);
    var labelRotation = axisModel.getModel("axisLabel").get("rotate") || 0;
    var labelLayout2 = AxisBuilder$1.innerTextLayout(axisAngle, labelRotation * Math.PI / 180, -1);
    align = labelLayout2.textAlign;
    verticalAlign = labelLayout2.textVerticalAlign;
  } else {
    var r2 = radiusExtent[1];
    position2 = polar.coordToPoint([r2 + labelMargin, coord]);
    var cx = polar.cx;
    var cy = polar.cy;
    align = Math.abs(position2[0] - cx) / r2 < 0.3 ? "center" : position2[0] > cx ? "left" : "right";
    verticalAlign = Math.abs(position2[1] - cy) / r2 < 0.3 ? "middle" : position2[1] > cy ? "top" : "bottom";
  }
  return {
    position: position2,
    align,
    verticalAlign
  };
}
var pointerShapeBuilder$1 = {
  line: function(axis, polar, coordValue, otherExtent) {
    return axis.dim === "angle" ? {
      type: "Line",
      shape: makeLineShape(polar.coordToPoint([otherExtent[0], coordValue]), polar.coordToPoint([otherExtent[1], coordValue]))
    } : {
      type: "Circle",
      shape: {
        cx: polar.cx,
        cy: polar.cy,
        r: coordValue
      }
    };
  },
  shadow: function(axis, polar, coordValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var radian = Math.PI / 180;
    return axis.dim === "angle" ? {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, otherExtent[0], otherExtent[1], (-coordValue - bandWidth / 2) * radian, (-coordValue + bandWidth / 2) * radian)
    } : {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, coordValue - bandWidth / 2, coordValue + bandWidth / 2, 0, Math.PI * 2)
    };
  }
};
var PolarAxisPointer$1 = PolarAxisPointer;
var PolarModel = function(_super) {
  __extends(PolarModel2, _super);
  function PolarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarModel2.type;
    return _this;
  }
  PolarModel2.prototype.findAxisModel = function(axisType) {
    var foundAxisModel;
    var ecModel = this.ecModel;
    ecModel.eachComponent(axisType, function(axisModel) {
      if (axisModel.getCoordSysModel() === this) {
        foundAxisModel = axisModel;
      }
    }, this);
    return foundAxisModel;
  };
  PolarModel2.type = "polar";
  PolarModel2.dependencies = ["radiusAxis", "angleAxis"];
  PolarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "80%"
  };
  return PolarModel2;
}(ComponentModel$1);
var PolarModel$1 = PolarModel;
var PolarAxisModel = function(_super) {
  __extends(PolarAxisModel2, _super);
  function PolarAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("polar", SINGLE_REFERRING).models[0];
  };
  PolarAxisModel2.type = "polarAxis";
  return PolarAxisModel2;
}(ComponentModel$1);
mixin(PolarAxisModel, AxisModelCommonMixin);
var AngleAxisModel = function(_super) {
  __extends(AngleAxisModel2, _super);
  function AngleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisModel2.type;
    return _this;
  }
  AngleAxisModel2.type = "angleAxis";
  return AngleAxisModel2;
}(PolarAxisModel);
var RadiusAxisModel = function(_super) {
  __extends(RadiusAxisModel2, _super);
  function RadiusAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisModel2.type;
    return _this;
  }
  RadiusAxisModel2.type = "radiusAxis";
  return RadiusAxisModel2;
}(PolarAxisModel);
var RadiusAxis = function(_super) {
  __extends(RadiusAxis2, _super);
  function RadiusAxis2(scale2, radiusExtent) {
    return _super.call(this, "radius", scale2, radiusExtent) || this;
  }
  RadiusAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  return RadiusAxis2;
}(Axis$1);
RadiusAxis.prototype.dataToRadius = Axis$1.prototype.dataToCoord;
RadiusAxis.prototype.radiusToData = Axis$1.prototype.coordToData;
var RadiusAxis$1 = RadiusAxis;
var inner$8 = makeInner();
var AngleAxis = function(_super) {
  __extends(AngleAxis2, _super);
  function AngleAxis2(scale2, angleExtent) {
    return _super.call(this, "angle", scale2, angleExtent || [0, 360]) || this;
  }
  AngleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  AngleAxis2.prototype.calculateCategoryInterval = function() {
    var axis = this;
    var labelModel = axis.getLabelModel();
    var ordinalScale = axis.scale;
    var ordinalExtent = ordinalScale.getExtent();
    var tickCount = ordinalScale.count();
    if (ordinalExtent[1] - ordinalExtent[0] < 1) {
      return 0;
    }
    var tickValue = ordinalExtent[0];
    var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
    var unitH = Math.abs(unitSpan);
    var rect = getBoundingRect(tickValue == null ? "" : tickValue + "", labelModel.getFont(), "center", "top");
    var maxH = Math.max(rect.height, 7);
    var dh = maxH / unitH;
    isNaN(dh) && (dh = Infinity);
    var interval = Math.max(0, Math.floor(dh));
    var cache = inner$8(axis.model);
    var lastAutoInterval = cache.lastAutoInterval;
    var lastTickCount = cache.lastTickCount;
    if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval) {
      interval = lastAutoInterval;
    } else {
      cache.lastTickCount = tickCount;
      cache.lastAutoInterval = interval;
    }
    return interval;
  };
  return AngleAxis2;
}(Axis$1);
AngleAxis.prototype.dataToAngle = Axis$1.prototype.dataToCoord;
AngleAxis.prototype.angleToData = Axis$1.prototype.coordToData;
var AngleAxis$1 = AngleAxis;
var polarDimensions = ["radius", "angle"];
var Polar = function() {
  function Polar2(name) {
    this.dimensions = polarDimensions;
    this.type = "polar";
    this.cx = 0;
    this.cy = 0;
    this._radiusAxis = new RadiusAxis$1();
    this._angleAxis = new AngleAxis$1();
    this.axisPointerEnabled = true;
    this.name = name || "";
    this._radiusAxis.polar = this._angleAxis.polar = this;
  }
  Polar2.prototype.containPoint = function(point) {
    var coord = this.pointToCoord(point);
    return this._radiusAxis.contain(coord[0]) && this._angleAxis.contain(coord[1]);
  };
  Polar2.prototype.containData = function(data) {
    return this._radiusAxis.containData(data[0]) && this._angleAxis.containData(data[1]);
  };
  Polar2.prototype.getAxis = function(dim) {
    var key = "_" + dim + "Axis";
    return this[key];
  };
  Polar2.prototype.getAxes = function() {
    return [this._radiusAxis, this._angleAxis];
  };
  Polar2.prototype.getAxesByScale = function(scaleType) {
    var axes = [];
    var angleAxis = this._angleAxis;
    var radiusAxis = this._radiusAxis;
    angleAxis.scale.type === scaleType && axes.push(angleAxis);
    radiusAxis.scale.type === scaleType && axes.push(radiusAxis);
    return axes;
  };
  Polar2.prototype.getAngleAxis = function() {
    return this._angleAxis;
  };
  Polar2.prototype.getRadiusAxis = function() {
    return this._radiusAxis;
  };
  Polar2.prototype.getOtherAxis = function(axis) {
    var angleAxis = this._angleAxis;
    return axis === angleAxis ? this._radiusAxis : angleAxis;
  };
  Polar2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
  };
  Polar2.prototype.getTooltipAxes = function(dim) {
    var baseAxis = dim != null && dim !== "auto" ? this.getAxis(dim) : this.getBaseAxis();
    return {
      baseAxes: [baseAxis],
      otherAxes: [this.getOtherAxis(baseAxis)]
    };
  };
  Polar2.prototype.dataToPoint = function(data, clamp2) {
    return this.coordToPoint([this._radiusAxis.dataToRadius(data[0], clamp2), this._angleAxis.dataToAngle(data[1], clamp2)]);
  };
  Polar2.prototype.pointToData = function(point, clamp2) {
    var coord = this.pointToCoord(point);
    return [this._radiusAxis.radiusToData(coord[0], clamp2), this._angleAxis.angleToData(coord[1], clamp2)];
  };
  Polar2.prototype.pointToCoord = function(point) {
    var dx = point[0] - this.cx;
    var dy = point[1] - this.cy;
    var angleAxis = this.getAngleAxis();
    var extent3 = angleAxis.getExtent();
    var minAngle = Math.min(extent3[0], extent3[1]);
    var maxAngle = Math.max(extent3[0], extent3[1]);
    angleAxis.inverse ? minAngle = maxAngle - 360 : maxAngle = minAngle + 360;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx) / Math.PI * 180;
    var dir3 = radian < minAngle ? 1 : -1;
    while (radian < minAngle || radian > maxAngle) {
      radian += dir3 * 360;
    }
    return [radius, radian];
  };
  Polar2.prototype.coordToPoint = function(coord) {
    var radius = coord[0];
    var radian = coord[1] / 180 * Math.PI;
    var x2 = Math.cos(radian) * radius + this.cx;
    var y2 = -Math.sin(radian) * radius + this.cy;
    return [x2, y2];
  };
  Polar2.prototype.getArea = function() {
    var angleAxis = this.getAngleAxis();
    var radiusAxis = this.getRadiusAxis();
    var radiusExtent = radiusAxis.getExtent().slice();
    radiusExtent[0] > radiusExtent[1] && radiusExtent.reverse();
    var angleExtent = angleAxis.getExtent();
    var RADIAN2 = Math.PI / 180;
    return {
      cx: this.cx,
      cy: this.cy,
      r0: radiusExtent[0],
      r: radiusExtent[1],
      startAngle: -angleExtent[0] * RADIAN2,
      endAngle: -angleExtent[1] * RADIAN2,
      clockwise: angleAxis.inverse,
      contain: function(x2, y2) {
        var dx = x2 - this.cx;
        var dy = y2 - this.cy;
        var d2 = dx * dx + dy * dy - 1e-4;
        var r2 = this.r;
        var r0 = this.r0;
        return d2 <= r2 * r2 && d2 >= r0 * r0;
      }
    };
  };
  Polar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Polar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Polar2;
}();
function getCoordSys$2(finder) {
  var seriesModel = finder.seriesModel;
  var polarModel = finder.polarModel;
  return polarModel && polarModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
var Polar$1 = Polar;
function resizePolar(polar, polarModel, api) {
  var center2 = polarModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  polar.cx = parsePercent(center2[0], width);
  polar.cy = parsePercent(center2[1], height);
  var radiusAxis = polar.getRadiusAxis();
  var size = Math.min(width, height) / 2;
  var radius = polarModel.get("radius");
  if (radius == null) {
    radius = [0, "100%"];
  } else if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  var parsedRadius = [parsePercent(radius[0], size), parsePercent(radius[1], size)];
  radiusAxis.inverse ? radiusAxis.setExtent(parsedRadius[1], parsedRadius[0]) : radiusAxis.setExtent(parsedRadius[0], parsedRadius[1]);
}
function updatePolarScale(ecModel, api) {
  var polar = this;
  var angleAxis = polar.getAngleAxis();
  var radiusAxis = polar.getRadiusAxis();
  angleAxis.scale.setExtent(Infinity, -Infinity);
  radiusAxis.scale.setExtent(Infinity, -Infinity);
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.coordinateSystem === polar) {
      var data_1 = seriesModel.getData();
      each$f(getDataDimensionsOnAxis(data_1, "radius"), function(dim) {
        radiusAxis.scale.unionExtentFromData(data_1, dim);
      });
      each$f(getDataDimensionsOnAxis(data_1, "angle"), function(dim) {
        angleAxis.scale.unionExtentFromData(data_1, dim);
      });
    }
  });
  niceScaleExtent(angleAxis.scale, angleAxis.model);
  niceScaleExtent(radiusAxis.scale, radiusAxis.model);
  if (angleAxis.type === "category" && !angleAxis.onBand) {
    var extent3 = angleAxis.getExtent();
    var diff = 360 / angleAxis.scale.count();
    angleAxis.inverse ? extent3[1] += diff : extent3[1] -= diff;
    angleAxis.setExtent(extent3[0], extent3[1]);
  }
}
function isAngleAxisModel(axisModel) {
  return axisModel.mainType === "angleAxis";
}
function setAxis(axis, axisModel) {
  axis.type = axisModel.get("type");
  axis.scale = createScaleByModel$1(axisModel);
  axis.onBand = axisModel.get("boundaryGap") && axis.type === "category";
  axis.inverse = axisModel.get("inverse");
  if (isAngleAxisModel(axisModel)) {
    axis.inverse = axis.inverse !== axisModel.get("clockwise");
    var startAngle = axisModel.get("startAngle");
    axis.setExtent(startAngle, startAngle + (axis.inverse ? -360 : 360));
  }
  axisModel.axis = axis;
  axis.model = axisModel;
}
var polarCreator = {
  dimensions: polarDimensions,
  create: function(ecModel, api) {
    var polarList = [];
    ecModel.eachComponent("polar", function(polarModel, idx) {
      var polar = new Polar$1(idx + "");
      polar.update = updatePolarScale;
      var radiusAxis = polar.getRadiusAxis();
      var angleAxis = polar.getAngleAxis();
      var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
      var angleAxisModel = polarModel.findAxisModel("angleAxis");
      setAxis(radiusAxis, radiusAxisModel);
      setAxis(angleAxis, angleAxisModel);
      resizePolar(polar, polarModel, api);
      polarList.push(polar);
      polarModel.coordinateSystem = polar;
      polar.model = polarModel;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.get("coordinateSystem") === "polar") {
        var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
        seriesModel.coordinateSystem = polarModel.coordinateSystem;
      }
    });
    return polarList;
  }
};
var polarCreator$1 = polarCreator;
var elementList = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function getAxisLineShape(polar, rExtent, angle) {
  rExtent[1] > rExtent[0] && (rExtent = rExtent.slice().reverse());
  var start2 = polar.coordToPoint([rExtent[0], angle]);
  var end2 = polar.coordToPoint([rExtent[1], angle]);
  return {
    x1: start2[0],
    y1: start2[1],
    x2: end2[0],
    y2: end2[1]
  };
}
function getRadiusIdx(polar) {
  var radiusAxis = polar.getRadiusAxis();
  return radiusAxis.inverse ? 0 : 1;
}
function fixAngleOverlap(list) {
  var firstItem = list[0];
  var lastItem = list[list.length - 1];
  if (firstItem && lastItem && Math.abs(Math.abs(firstItem.coord - lastItem.coord) - 360) < 1e-4) {
    list.pop();
  }
}
var AngleAxisView = function(_super) {
  __extends(AngleAxisView2, _super);
  function AngleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  AngleAxisView2.prototype.render = function(angleAxisModel, ecModel) {
    this.group.removeAll();
    if (!angleAxisModel.get("show")) {
      return;
    }
    var angleAxis = angleAxisModel.axis;
    var polar = angleAxis.polar;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var ticksAngles = angleAxis.getTicksCoords();
    var minorTickAngles = angleAxis.getMinorTicksCoords();
    var labels = map$1(angleAxis.getViewLabels(), function(labelItem) {
      labelItem = clone$4(labelItem);
      var scale2 = angleAxis.scale;
      var tickValue = scale2.type === "ordinal" ? scale2.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
      labelItem.coord = angleAxis.dataToCoord(tickValue);
      return labelItem;
    });
    fixAngleOverlap(labels);
    fixAngleOverlap(ticksAngles);
    each$f(elementList, function(name) {
      if (angleAxisModel.get([name, "show"]) && (!angleAxis.scale.isBlank() || name === "axisLine")) {
        angelAxisElementsBuilders[name](this.group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels);
      }
    }, this);
  };
  AngleAxisView2.type = "angleAxis";
  return AngleAxisView2;
}(AxisView$1);
var angelAxisElementsBuilders = {
  axisLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var lineStyleModel = angleAxisModel.getModel(["axisLine", "lineStyle"]);
    var rId = getRadiusIdx(polar);
    var r0Id = rId ? 0 : 1;
    var shape;
    if (radiusExtent[r0Id] === 0) {
      shape = new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    } else {
      shape = new Ring$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId],
          r0: radiusExtent[r0Id]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    }
    shape.style.fill = null;
    group.add(shape);
  },
  axisTick: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var tickModel = angleAxisModel.getModel("axisTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * tickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = map$1(ticksAngles, function(tickAngleItem) {
      return new Line$3({
        shape: getAxisLineShape(polar, [radius, radius + tickLen], tickAngleItem.coord)
      });
    });
    group.add(mergePath(lines, {
      style: defaults(tickModel.getModel("lineStyle").getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(group, angleAxisModel, polar, tickAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var tickModel = angleAxisModel.getModel("axisTick");
    var minorTickModel = angleAxisModel.getModel("minorTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * minorTickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, [radius, radius + tickLen], minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults(minorTickModel.getModel("lineStyle").getLineStyle(), defaults(tickModel.getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      }))
    }));
  },
  axisLabel: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels) {
    var rawCategoryData = angleAxisModel.getCategories(true);
    var commonLabelModel = angleAxisModel.getModel("axisLabel");
    var labelMargin = commonLabelModel.get("margin");
    var triggerEvent = angleAxisModel.get("triggerEvent");
    each$f(labels, function(labelItem, idx) {
      var labelModel = commonLabelModel;
      var tickValue = labelItem.tickValue;
      var r2 = radiusExtent[getRadiusIdx(polar)];
      var p2 = polar.coordToPoint([r2 + labelMargin, labelItem.coord]);
      var cx = polar.cx;
      var cy = polar.cy;
      var labelTextAlign = Math.abs(p2[0] - cx) / r2 < 0.3 ? "center" : p2[0] > cx ? "left" : "right";
      var labelTextVerticalAlign = Math.abs(p2[1] - cy) / r2 < 0.3 ? "middle" : p2[1] > cy ? "top" : "bottom";
      if (rawCategoryData && rawCategoryData[tickValue]) {
        var rawCategoryItem = rawCategoryData[tickValue];
        if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
          labelModel = new Model$1(rawCategoryItem.textStyle, commonLabelModel, commonLabelModel.ecModel);
        }
      }
      var textEl = new ZRText$1({
        silent: AxisBuilder$1.isLabelSilent(angleAxisModel),
        style: createTextStyle(labelModel, {
          x: p2[0],
          y: p2[1],
          fill: labelModel.getTextColor() || angleAxisModel.get(["axisLine", "lineStyle", "color"]),
          text: labelItem.formattedLabel,
          align: labelTextAlign,
          verticalAlign: labelTextVerticalAlign
        })
      });
      group.add(textEl);
      if (triggerEvent) {
        var eventData = AxisBuilder$1.makeAxisEventDataBase(angleAxisModel);
        eventData.targetType = "axisLabel";
        eventData.value = labelItem.rawLabel;
        getECData(textEl).eventData = eventData;
      }
    }, this);
  },
  splitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var splitLineModel = angleAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksAngles.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        shape: getAxisLineShape(polar, radiusExtent, ticksAngles[i].coord)
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyleModel.getLineStyle()),
        silent: true,
        z: angleAxisModel.get("z")
      }));
    }
  },
  minorSplitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var minorSplitLineModel = angleAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, radiusExtent, minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: lineStyleModel.getLineStyle(),
      silent: true,
      z: angleAxisModel.get("z")
    }));
  },
  splitArea: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!ticksAngles.length) {
      return;
    }
    var splitAreaModel = angleAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var RADIAN2 = Math.PI / 180;
    var prevAngle = -ticksAngles[0].coord * RADIAN2;
    var r0 = Math.min(radiusExtent[0], radiusExtent[1]);
    var r1 = Math.max(radiusExtent[0], radiusExtent[1]);
    var clockwise = angleAxisModel.get("clockwise");
    for (var i = 1, len2 = ticksAngles.length; i <= len2; i++) {
      var coord = i === len2 ? ticksAngles[0].coord : ticksAngles[i].coord;
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0,
          r: r1,
          startAngle: prevAngle,
          endAngle: -coord * RADIAN2,
          clockwise
        },
        silent: true
      }));
      prevAngle = -coord * RADIAN2;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
var AngleAxisView$1 = AngleAxisView;
var axisBuilderAttrs$1 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$1 = ["splitLine", "splitArea", "minorSplitLine"];
var RadiusAxisView = function(_super) {
  __extends(RadiusAxisView2, _super);
  function RadiusAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  RadiusAxisView2.prototype.render = function(radiusAxisModel, ecModel) {
    this.group.removeAll();
    if (!radiusAxisModel.get("show")) {
      return;
    }
    var oldAxisGroup = this._axisGroup;
    var newAxisGroup = this._axisGroup = new Group$4();
    this.group.add(newAxisGroup);
    var radiusAxis = radiusAxisModel.axis;
    var polar = radiusAxis.polar;
    var angleAxis = polar.getAngleAxis();
    var ticksCoords = radiusAxis.getTicksCoords();
    var minorTicksCoords = radiusAxis.getMinorTicksCoords();
    var axisAngle = angleAxis.getExtent()[0];
    var radiusExtent = radiusAxis.getExtent();
    var layout2 = layoutAxis(polar, radiusAxisModel, axisAngle);
    var axisBuilder = new AxisBuilder$1(radiusAxisModel, layout2);
    each$f(axisBuilderAttrs$1, axisBuilder.add, axisBuilder);
    newAxisGroup.add(axisBuilder.getGroup());
    groupTransition(oldAxisGroup, newAxisGroup, radiusAxisModel);
    each$f(selfBuilderAttrs$1, function(name) {
      if (radiusAxisModel.get([name, "show"]) && !radiusAxis.scale.isBlank()) {
        axisElementBuilders$1[name](this.group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords);
      }
    }, this);
  };
  RadiusAxisView2.type = "radiusAxis";
  return RadiusAxisView2;
}(AxisView$1);
var axisElementBuilders$1 = {
  splitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    var splitLineModel = radiusAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: ticksCoords[i].coord
        }
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length],
          fill: null
        }, lineStyleModel.getLineStyle()),
        silent: true
      }));
    }
  },
  minorSplitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords) {
    if (!minorTicksCoords.length) {
      return;
    }
    var minorSplitLineModel = radiusAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        lines.push(new Circle$1({
          shape: {
            cx: polar.cx,
            cy: polar.cy,
            r: minorTicksCoords[i][k2].coord
          }
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults({
        fill: null
      }, lineStyleModel.getLineStyle()),
      silent: true
    }));
  },
  splitArea: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    if (!ticksCoords.length) {
      return;
    }
    var splitAreaModel = radiusAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var prevRadius = ticksCoords[0].coord;
    for (var i = 1; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0: prevRadius,
          r: ticksCoords[i].coord,
          startAngle: 0,
          endAngle: Math.PI * 2
        },
        silent: true
      }));
      prevRadius = ticksCoords[i].coord;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
function layoutAxis(polar, radiusAxisModel, axisAngle) {
  return {
    position: [polar.cx, polar.cy],
    rotation: axisAngle / 180 * Math.PI,
    labelDirection: -1,
    tickDirection: -1,
    nameDirection: 1,
    labelRotate: radiusAxisModel.getModel("axisLabel").get("rotate"),
    z2: 1
  };
}
var RadiusAxisView$1 = RadiusAxisView;
function getSeriesStackId(seriesModel) {
  return seriesModel.get("stack") || "__ec_stack_" + seriesModel.seriesIndex;
}
function getAxisKey(polar, axis) {
  return axis.dim + polar.model.componentIndex;
}
function barLayoutPolar(seriesType2, ecModel, api) {
  var lastStackCoords = {};
  var barWidthAndOffset = calRadialBar(filter(ecModel.getSeriesByType(seriesType2), function(seriesModel) {
    return !ecModel.isSeriesFiltered(seriesModel) && seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "polar";
  }));
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (seriesModel.coordinateSystem.type !== "polar") {
      return;
    }
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var stackId = getSeriesStackId(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[axisKey][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    var valueAxis2 = polar.getOtherAxis(baseAxis);
    var cx = seriesModel.coordinateSystem.cx;
    var cy = seriesModel.coordinateSystem.cy;
    var barMinHeight = seriesModel.get("barMinHeight") || 0;
    var barMinAngle = seriesModel.get("barMinAngle") || 0;
    lastStackCoords[stackId] = lastStackCoords[stackId] || [];
    var valueDim = data.mapDimension(valueAxis2.dim);
    var baseDim = data.mapDimension(baseAxis.dim);
    var stacked = isDimensionStacked(data, valueDim);
    var clampLayout = baseAxis.dim !== "radius" || !seriesModel.get("roundCap", true);
    var valueAxisStart = valueAxis2.dataToCoord(0);
    for (var idx = 0, len2 = data.count(); idx < len2; idx++) {
      var value = data.get(valueDim, idx);
      var baseValue = data.get(baseDim, idx);
      var sign = value >= 0 ? "p" : "n";
      var baseCoord = valueAxisStart;
      if (stacked) {
        if (!lastStackCoords[stackId][baseValue]) {
          lastStackCoords[stackId][baseValue] = {
            p: valueAxisStart,
            n: valueAxisStart
          };
        }
        baseCoord = lastStackCoords[stackId][baseValue][sign];
      }
      var r0 = void 0;
      var r2 = void 0;
      var startAngle = void 0;
      var endAngle = void 0;
      if (valueAxis2.dim === "radius") {
        var radiusSpan = valueAxis2.dataToCoord(value) - valueAxisStart;
        var angle = baseAxis.dataToCoord(baseValue);
        if (Math.abs(radiusSpan) < barMinHeight) {
          radiusSpan = (radiusSpan < 0 ? -1 : 1) * barMinHeight;
        }
        r0 = baseCoord;
        r2 = baseCoord + radiusSpan;
        startAngle = angle - columnOffset;
        endAngle = startAngle - columnWidth;
        stacked && (lastStackCoords[stackId][baseValue][sign] = r2);
      } else {
        var angleSpan = valueAxis2.dataToCoord(value, clampLayout) - valueAxisStart;
        var radius = baseAxis.dataToCoord(baseValue);
        if (Math.abs(angleSpan) < barMinAngle) {
          angleSpan = (angleSpan < 0 ? -1 : 1) * barMinAngle;
        }
        r0 = radius + columnOffset;
        r2 = r0 + columnWidth;
        startAngle = baseCoord;
        endAngle = baseCoord + angleSpan;
        stacked && (lastStackCoords[stackId][baseValue][sign] = endAngle);
      }
      data.setItemLayout(idx, {
        cx,
        cy,
        r0,
        r: r2,
        startAngle: -startAngle * Math.PI / 180,
        endAngle: -endAngle * Math.PI / 180,
        clockwise: startAngle >= endAngle
      });
    }
  });
}
function calRadialBar(barSeries) {
  var columnsMap = {};
  each$f(barSeries, function(seriesModel, idx) {
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var axisExtent = baseAxis.getExtent();
    var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: "20%",
      gap: "30%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = getSeriesStackId(seriesModel);
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    if (barWidth && !stacks[stackId].width) {
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      stacks[stackId].width = barWidth;
      columnsOnAxis.remainedWidth -= barWidth;
    }
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    barGap != null && (columnsOnAxis.gap = barGap);
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGap = parsePercent(columnsOnAxis.categoryGap, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column, stack) {
      var maxWidth = column.maxWidth;
      if (maxWidth && maxWidth < autoWidth) {
        maxWidth = Math.min(maxWidth, remainedWidth);
        if (column.width) {
          maxWidth = Math.min(maxWidth, column.width);
        }
        remainedWidth -= maxWidth;
        column.width = maxWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
var angleAxisExtraOption = {
  startAngle: 90,
  clockwise: true,
  splitNumber: 12,
  axisLabel: {
    rotate: 0
  }
};
var radiusAxisExtraOption = {
  splitNumber: 5
};
var PolarView = function(_super) {
  __extends(PolarView2, _super);
  function PolarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarView2.type;
    return _this;
  }
  PolarView2.type = "polar";
  return PolarView2;
}(ComponentView$1);
function install$o(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("PolarAxisPointer", PolarAxisPointer$1);
  registers.registerCoordinateSystem("polar", polarCreator$1);
  registers.registerComponentModel(PolarModel$1);
  registers.registerComponentView(PolarView);
  axisModelCreator(registers, "angle", AngleAxisModel, angleAxisExtraOption);
  axisModelCreator(registers, "radius", RadiusAxisModel, radiusAxisExtraOption);
  registers.registerComponentView(AngleAxisView$1);
  registers.registerComponentView(RadiusAxisView$1);
  registers.registerLayout(curry$1(barLayoutPolar, "bar"));
}
function layout$1(axisModel, opt) {
  opt = opt || {};
  var single = axisModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var axisPosition = axis.position;
  var orient = axis.orient;
  var rect = single.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var positionMap = {
    horizontal: {
      top: rectBound[2],
      bottom: rectBound[3]
    },
    vertical: {
      left: rectBound[0],
      right: rectBound[1]
    }
  };
  layout2.position = [orient === "vertical" ? positionMap.vertical[axisPosition] : rectBound[0], orient === "horizontal" ? positionMap.horizontal[axisPosition] : rectBound[3]];
  var r2 = {
    horizontal: 0,
    vertical: 1
  };
  layout2.rotation = Math.PI / 2 * r2[orient];
  var directionMap = {
    top: -1,
    bottom: 1,
    right: 1,
    left: -1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = directionMap[axisPosition];
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotation = opt.rotate;
  labelRotation == null && (labelRotation = axisModel.get(["axisLabel", "rotate"]));
  layout2.labelRotation = axisPosition === "top" ? -labelRotation : labelRotation;
  layout2.z2 = 1;
  return layout2;
}
var axisBuilderAttrs = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs = ["splitArea", "splitLine"];
var SingleAxisView = function(_super) {
  __extends(SingleAxisView2, _super);
  function SingleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisView2.type;
    _this.axisPointerClass = "SingleAxisPointer";
    return _this;
  }
  SingleAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    var layout2 = layout$1(axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, layout2);
    each$f(axisBuilderAttrs, axisBuilder.add, axisBuilder);
    group.add(this._axisGroup);
    group.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders[name](this, this.group, this._axisGroup, axisModel);
      }
    }, this);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  SingleAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  SingleAxisView2.type = "singleAxis";
  return SingleAxisView2;
}(AxisView$1);
var axisElementBuilders = {
  splitLine: function(axisView, group, axisGroup, axisModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var gridRect = axisModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var splitLines = [];
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    for (var i = 0; i < ticksCoords.length; ++i) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        subPixelOptimize: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        silent: true
      }));
    }
    var lineStyle = lineStyleModel.getLineStyle(["color"]);
    for (var i = 0; i < splitLines.length; ++i) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyle),
        silent: true
      }));
    }
  },
  splitArea: function(axisView, group, axisGroup, axisModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, axisModel);
  }
};
var SingleAxisView$1 = SingleAxisView;
var SingleAxisModel = function(_super) {
  __extends(SingleAxisModel2, _super);
  function SingleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisModel2.type;
    return _this;
  }
  SingleAxisModel2.prototype.getCoordSysModel = function() {
    return this;
  };
  SingleAxisModel2.type = "singleAxis";
  SingleAxisModel2.layoutMode = "box";
  SingleAxisModel2.defaultOption = {
    left: "5%",
    top: "5%",
    right: "5%",
    bottom: "5%",
    type: "value",
    position: "bottom",
    orient: "horizontal",
    axisLine: {
      show: true,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    tooltip: {
      show: true
    },
    axisTick: {
      show: true,
      length: 6,
      lineStyle: {
        width: 1
      }
    },
    axisLabel: {
      show: true,
      interval: "auto"
    },
    splitLine: {
      show: true,
      lineStyle: {
        type: "dashed",
        opacity: 0.2
      }
    }
  };
  return SingleAxisModel2;
}(ComponentModel$1);
mixin(SingleAxisModel, AxisModelCommonMixin.prototype);
var SingleAxisModel$1 = SingleAxisModel;
var SingleAxis = function(_super) {
  __extends(SingleAxis2, _super);
  function SingleAxis2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  SingleAxis2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  SingleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.coordinateSystem.pointToData(point)[0];
  };
  return SingleAxis2;
}(Axis$1);
var SingleAxis$1 = SingleAxis;
var singleDimensions = ["single"];
var Single = function() {
  function Single2(axisModel, ecModel, api) {
    this.type = "single";
    this.dimension = "single";
    this.dimensions = singleDimensions;
    this.axisPointerEnabled = true;
    this.model = axisModel;
    this._init(axisModel, ecModel, api);
  }
  Single2.prototype._init = function(axisModel, ecModel, api) {
    var dim = this.dimension;
    var axis = new SingleAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisModel.get("position"));
    var isCategory2 = axis.type === "category";
    axis.onBand = isCategory2 && axisModel.get("boundaryGap");
    axis.inverse = axisModel.get("inverse");
    axis.orient = axisModel.get("orient");
    axisModel.axis = axis;
    axis.model = axisModel;
    axis.coordinateSystem = this;
    this._axis = axis;
  };
  Single2.prototype.update = function(ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.coordinateSystem === this) {
        var data_1 = seriesModel.getData();
        each$f(data_1.mapDimensionsAll(this.dimension), function(dim) {
          this._axis.scale.unionExtentFromData(data_1, dim);
        }, this);
        niceScaleExtent(this._axis.scale, this._axis.model);
      }
    }, this);
  };
  Single2.prototype.resize = function(axisModel, api) {
    this._rect = getLayoutRect({
      left: axisModel.get("left"),
      top: axisModel.get("top"),
      right: axisModel.get("right"),
      bottom: axisModel.get("bottom"),
      width: axisModel.get("width"),
      height: axisModel.get("height")
    }, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._adjustAxis();
  };
  Single2.prototype.getRect = function() {
    return this._rect;
  };
  Single2.prototype._adjustAxis = function() {
    var rect = this._rect;
    var axis = this._axis;
    var isHorizontal = axis.isHorizontal();
    var extent3 = isHorizontal ? [0, rect.width] : [0, rect.height];
    var idx = axis.reverse ? 1 : 0;
    axis.setExtent(extent3[idx], extent3[1 - idx]);
    this._updateAxisTransform(axis, isHorizontal ? rect.x : rect.y);
  };
  Single2.prototype._updateAxisTransform = function(axis, coordBase) {
    var axisExtent = axis.getExtent();
    var extentSum = axisExtent[0] + axisExtent[1];
    var isHorizontal = axis.isHorizontal();
    axis.toGlobalCoord = isHorizontal ? function(coord) {
      return coord + coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
    axis.toLocalCoord = isHorizontal ? function(coord) {
      return coord - coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
  };
  Single2.prototype.getAxis = function() {
    return this._axis;
  };
  Single2.prototype.getBaseAxis = function() {
    return this._axis;
  };
  Single2.prototype.getAxes = function() {
    return [this._axis];
  };
  Single2.prototype.getTooltipAxes = function() {
    return {
      baseAxes: [this.getAxis()],
      otherAxes: []
    };
  };
  Single2.prototype.containPoint = function(point) {
    var rect = this.getRect();
    var axis = this.getAxis();
    var orient = axis.orient;
    if (orient === "horizontal") {
      return axis.contain(axis.toLocalCoord(point[0])) && point[1] >= rect.y && point[1] <= rect.y + rect.height;
    } else {
      return axis.contain(axis.toLocalCoord(point[1])) && point[0] >= rect.y && point[0] <= rect.y + rect.height;
    }
  };
  Single2.prototype.pointToData = function(point) {
    var axis = this.getAxis();
    return [axis.coordToData(axis.toLocalCoord(point[axis.orient === "horizontal" ? 0 : 1]))];
  };
  Single2.prototype.dataToPoint = function(val) {
    var axis = this.getAxis();
    var rect = this.getRect();
    var pt = [];
    var idx = axis.orient === "horizontal" ? 0 : 1;
    if (val instanceof Array) {
      val = val[0];
    }
    pt[idx] = axis.toGlobalCoord(axis.dataToCoord(+val));
    pt[1 - idx] = idx === 0 ? rect.y + rect.height / 2 : rect.x + rect.width / 2;
    return pt;
  };
  Single2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Single2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Single2;
}();
function getCoordSys$1(finder) {
  var seriesModel = finder.seriesModel;
  var singleModel = finder.singleAxisModel;
  return singleModel && singleModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
function create(ecModel, api) {
  var singles = [];
  ecModel.eachComponent("singleAxis", function(axisModel, idx) {
    var single = new Single(axisModel, ecModel, api);
    single.name = "single_" + idx;
    single.resize(axisModel, api);
    axisModel.coordinateSystem = single;
    singles.push(single);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "singleAxis") {
      var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = singleAxisModel && singleAxisModel.coordinateSystem;
    }
  });
  return singles;
}
var singleCreator = {
  create,
  dimensions: singleDimensions
};
var singleCreator$1 = singleCreator;
var XY$1 = ["x", "y"];
var WH$1 = ["width", "height"];
var SingleAxisPointer = function(_super) {
  __extends(SingleAxisPointer2, _super);
  function SingleAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SingleAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var otherExtent = getGlobalExtent(coordSys, 1 - getPointDimIndex(axis));
    var pixelValue = coordSys.dataToPoint(value)[0];
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$1(axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  SingleAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$1(axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var position2 = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: position2[0],
      y: position2[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  SingleAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var dimIndex = getPointDimIndex(axis);
    var axisExtent = getGlobalExtent(coordSys, dimIndex);
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var otherExtent = getGlobalExtent(coordSys, 1 - dimIndex);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: {
        verticalAlign: "middle"
      }
    };
  };
  return SingleAxisPointer2;
}(BaseAxisPointer$1);
var pointerShapeBuilder = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getPointDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = axis.getBandWidth();
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getPointDimIndex(axis))
    };
  }
};
function getPointDimIndex(axis) {
  return axis.isHorizontal() ? 0 : 1;
}
function getGlobalExtent(coordSys, dimIndex) {
  var rect = coordSys.getRect();
  return [rect[XY$1[dimIndex]], rect[XY$1[dimIndex]] + rect[WH$1[dimIndex]]];
}
var SingleAxisPointer$1 = SingleAxisPointer;
var SingleView = function(_super) {
  __extends(SingleView2, _super);
  function SingleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleView2.type;
    return _this;
  }
  SingleView2.type = "single";
  return SingleView2;
}(ComponentView$1);
function install$n(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("SingleAxisPointer", SingleAxisPointer$1);
  registers.registerComponentView(SingleView);
  registers.registerComponentView(SingleAxisView$1);
  registers.registerComponentModel(SingleAxisModel$1);
  axisModelCreator(registers, "single", SingleAxisModel$1, SingleAxisModel$1.defaultOption);
  registers.registerCoordinateSystem("single", singleCreator$1);
}
var CalendarModel = function(_super) {
  __extends(CalendarModel2, _super);
  function CalendarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarModel2.type;
    return _this;
  }
  CalendarModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(option, inputPositionParams);
  };
  CalendarModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(this.option, option);
  };
  CalendarModel2.prototype.getCellSize = function() {
    return this.option.cellSize;
  };
  CalendarModel2.type = "calendar";
  CalendarModel2.defaultOption = {
    z: 2,
    left: 80,
    top: 60,
    cellSize: 20,
    orient: "horizontal",
    splitLine: {
      show: true,
      lineStyle: {
        color: "#000",
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      color: "#fff",
      borderWidth: 1,
      borderColor: "#ccc"
    },
    dayLabel: {
      show: true,
      firstDay: 0,
      position: "start",
      margin: "50%",
      color: "#000"
    },
    monthLabel: {
      show: true,
      position: "start",
      margin: 5,
      align: "center",
      formatter: null,
      color: "#000"
    },
    yearLabel: {
      show: true,
      position: null,
      margin: 30,
      formatter: null,
      color: "#ccc",
      fontFamily: "sans-serif",
      fontWeight: "bolder",
      fontSize: 20
    }
  };
  return CalendarModel2;
}(ComponentModel$1);
function mergeAndNormalizeLayoutParams$1(target, raw) {
  var cellSize = target.cellSize;
  var cellSizeArr;
  if (!isArray$1(cellSize)) {
    cellSizeArr = target.cellSize = [cellSize, cellSize];
  } else {
    cellSizeArr = cellSize;
  }
  if (cellSizeArr.length === 1) {
    cellSizeArr[1] = cellSizeArr[0];
  }
  var ignoreSize = map$1([0, 1], function(hvIdx) {
    if (sizeCalculable(raw, hvIdx)) {
      cellSizeArr[hvIdx] = "auto";
    }
    return cellSizeArr[hvIdx] != null && cellSizeArr[hvIdx] !== "auto";
  });
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize
  });
}
var CalendarModel$1 = CalendarModel;
var CalendarView = function(_super) {
  __extends(CalendarView2, _super);
  function CalendarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarView2.type;
    return _this;
  }
  CalendarView2.prototype.render = function(calendarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    var coordSys = calendarModel.coordinateSystem;
    var rangeData = coordSys.getRangeInfo();
    var orient = coordSys.getOrient();
    var localeModel = ecModel.getLocaleModel();
    this._renderDayRect(calendarModel, rangeData, group);
    this._renderLines(calendarModel, rangeData, orient, group);
    this._renderYearText(calendarModel, rangeData, orient, group);
    this._renderMonthText(calendarModel, localeModel, orient, group);
    this._renderWeekText(calendarModel, localeModel, rangeData, orient, group);
  };
  CalendarView2.prototype._renderDayRect = function(calendarModel, rangeData, group) {
    var coordSys = calendarModel.coordinateSystem;
    var itemRectStyleModel = calendarModel.getModel("itemStyle").getItemStyle();
    var sw = coordSys.getCellWidth();
    var sh = coordSys.getCellHeight();
    for (var i = rangeData.start.time; i <= rangeData.end.time; i = coordSys.getNextNDay(i, 1).time) {
      var point = coordSys.dataToRect([i], false).tl;
      var rect = new Rect$3({
        shape: {
          x: point[0],
          y: point[1],
          width: sw,
          height: sh
        },
        cursor: "default",
        style: itemRectStyleModel
      });
      group.add(rect);
    }
  };
  CalendarView2.prototype._renderLines = function(calendarModel, rangeData, orient, group) {
    var self2 = this;
    var coordSys = calendarModel.coordinateSystem;
    var lineStyleModel = calendarModel.getModel(["splitLine", "lineStyle"]).getLineStyle();
    var show = calendarModel.get(["splitLine", "show"]);
    var lineWidth = lineStyleModel.lineWidth;
    this._tlpoints = [];
    this._blpoints = [];
    this._firstDayOfMonth = [];
    this._firstDayPoints = [];
    var firstDay = rangeData.start;
    for (var i = 0; firstDay.time <= rangeData.end.time; i++) {
      addPoints(firstDay.formatedDate);
      if (i === 0) {
        firstDay = coordSys.getDateInfo(rangeData.start.y + "-" + rangeData.start.m);
      }
      var date4 = firstDay.date;
      date4.setMonth(date4.getMonth() + 1);
      firstDay = coordSys.getDateInfo(date4);
    }
    addPoints(coordSys.getNextNDay(rangeData.end.time, 1).formatedDate);
    function addPoints(date5) {
      self2._firstDayOfMonth.push(coordSys.getDateInfo(date5));
      self2._firstDayPoints.push(coordSys.dataToRect([date5], false).tl);
      var points2 = self2._getLinePointsOfOneWeek(calendarModel, date5, orient);
      self2._tlpoints.push(points2[0]);
      self2._blpoints.push(points2[points2.length - 1]);
      show && self2._drawSplitline(points2, lineStyleModel, group);
    }
    show && this._drawSplitline(self2._getEdgesPoints(self2._tlpoints, lineWidth, orient), lineStyleModel, group);
    show && this._drawSplitline(self2._getEdgesPoints(self2._blpoints, lineWidth, orient), lineStyleModel, group);
  };
  CalendarView2.prototype._getEdgesPoints = function(points2, lineWidth, orient) {
    var rs = [points2[0].slice(), points2[points2.length - 1].slice()];
    var idx = orient === "horizontal" ? 0 : 1;
    rs[0][idx] = rs[0][idx] - lineWidth / 2;
    rs[1][idx] = rs[1][idx] + lineWidth / 2;
    return rs;
  };
  CalendarView2.prototype._drawSplitline = function(points2, lineStyle, group) {
    var poyline = new Polyline$3({
      z2: 20,
      shape: {
        points: points2
      },
      style: lineStyle
    });
    group.add(poyline);
  };
  CalendarView2.prototype._getLinePointsOfOneWeek = function(calendarModel, date4, orient) {
    var coordSys = calendarModel.coordinateSystem;
    var parsedDate = coordSys.getDateInfo(date4);
    var points2 = [];
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(parsedDate.time, i);
      var point = coordSys.dataToRect([tmpD.time], false);
      points2[2 * tmpD.day] = point.tl;
      points2[2 * tmpD.day + 1] = point[orient === "horizontal" ? "bl" : "tr"];
    }
    return points2;
  };
  CalendarView2.prototype._formatterLabel = function(formatter, params) {
    if (isString(formatter) && formatter) {
      return formatTplSimple(formatter, params);
    }
    if (isFunction(formatter)) {
      return formatter(params);
    }
    return params.nameMap;
  };
  CalendarView2.prototype._yearTextPositionControl = function(textEl, point, orient, position2, margin) {
    var x2 = point[0];
    var y2 = point[1];
    var aligns = ["center", "bottom"];
    if (position2 === "bottom") {
      y2 += margin;
      aligns = ["center", "top"];
    } else if (position2 === "left") {
      x2 -= margin;
    } else if (position2 === "right") {
      x2 += margin;
      aligns = ["center", "top"];
    } else {
      y2 -= margin;
    }
    var rotate2 = 0;
    if (position2 === "left" || position2 === "right") {
      rotate2 = Math.PI / 2;
    }
    return {
      rotation: rotate2,
      x: x2,
      y: y2,
      style: {
        align: aligns[0],
        verticalAlign: aligns[1]
      }
    };
  };
  CalendarView2.prototype._renderYearText = function(calendarModel, rangeData, orient, group) {
    var yearLabel = calendarModel.getModel("yearLabel");
    if (!yearLabel.get("show")) {
      return;
    }
    var margin = yearLabel.get("margin");
    var pos = yearLabel.get("position");
    if (!pos) {
      pos = orient !== "horizontal" ? "top" : "left";
    }
    var points2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]];
    var xc = (points2[0][0] + points2[1][0]) / 2;
    var yc = (points2[0][1] + points2[1][1]) / 2;
    var idx = orient === "horizontal" ? 0 : 1;
    var posPoints = {
      top: [xc, points2[idx][1]],
      bottom: [xc, points2[1 - idx][1]],
      left: [points2[1 - idx][0], yc],
      right: [points2[idx][0], yc]
    };
    var name = rangeData.start.y;
    if (+rangeData.end.y > +rangeData.start.y) {
      name = name + "-" + rangeData.end.y;
    }
    var formatter = yearLabel.get("formatter");
    var params = {
      start: rangeData.start.y,
      end: rangeData.end.y,
      nameMap: name
    };
    var content = this._formatterLabel(formatter, params);
    var yearText = new ZRText$1({
      z2: 30,
      style: createTextStyle(yearLabel, {
        text: content
      })
    });
    yearText.attr(this._yearTextPositionControl(yearText, posPoints[pos], orient, pos, margin));
    group.add(yearText);
  };
  CalendarView2.prototype._monthTextPositionControl = function(point, isCenter, orient, position2, margin) {
    var align = "left";
    var vAlign = "top";
    var x2 = point[0];
    var y2 = point[1];
    if (orient === "horizontal") {
      y2 = y2 + margin;
      if (isCenter) {
        align = "center";
      }
      if (position2 === "start") {
        vAlign = "bottom";
      }
    } else {
      x2 = x2 + margin;
      if (isCenter) {
        vAlign = "middle";
      }
      if (position2 === "start") {
        align = "right";
      }
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderMonthText = function(calendarModel, localeModel, orient, group) {
    var monthLabel = calendarModel.getModel("monthLabel");
    if (!monthLabel.get("show")) {
      return;
    }
    var nameMap = monthLabel.get("nameMap");
    var margin = monthLabel.get("margin");
    var pos = monthLabel.get("position");
    var align = monthLabel.get("align");
    var termPoints = [this._tlpoints, this._blpoints];
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      nameMap = localeModel.get(["time", "monthAbbr"]) || [];
    }
    var idx = pos === "start" ? 0 : 1;
    var axis = orient === "horizontal" ? 0 : 1;
    margin = pos === "start" ? -margin : margin;
    var isCenter = align === "center";
    for (var i = 0; i < termPoints[idx].length - 1; i++) {
      var tmp = termPoints[idx][i].slice();
      var firstDay = this._firstDayOfMonth[i];
      if (isCenter) {
        var firstDayPoints = this._firstDayPoints[i];
        tmp[axis] = (firstDayPoints[axis] + termPoints[0][i + 1][axis]) / 2;
      }
      var formatter = monthLabel.get("formatter");
      var name_1 = nameMap[+firstDay.m - 1];
      var params = {
        yyyy: firstDay.y,
        yy: (firstDay.y + "").slice(2),
        MM: firstDay.m,
        M: +firstDay.m,
        nameMap: name_1
      };
      var content = this._formatterLabel(formatter, params);
      var monthText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(monthLabel, {
          text: content
        }), this._monthTextPositionControl(tmp, isCenter, orient, pos, margin))
      });
      group.add(monthText);
    }
  };
  CalendarView2.prototype._weekTextPositionControl = function(point, orient, position2, margin, cellSize) {
    var align = "center";
    var vAlign = "middle";
    var x2 = point[0];
    var y2 = point[1];
    var isStart = position2 === "start";
    if (orient === "horizontal") {
      x2 = x2 + margin + (isStart ? 1 : -1) * cellSize[0] / 2;
      align = isStart ? "right" : "left";
    } else {
      y2 = y2 + margin + (isStart ? 1 : -1) * cellSize[1] / 2;
      vAlign = isStart ? "bottom" : "top";
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderWeekText = function(calendarModel, localeModel, rangeData, orient, group) {
    var dayLabel = calendarModel.getModel("dayLabel");
    if (!dayLabel.get("show")) {
      return;
    }
    var coordSys = calendarModel.coordinateSystem;
    var pos = dayLabel.get("position");
    var nameMap = dayLabel.get("nameMap");
    var margin = dayLabel.get("margin");
    var firstDayOfWeek = coordSys.getFirstDayOfWeek();
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      var dayOfWeekShort = localeModel.get(["time", "dayOfWeekShort"]);
      nameMap = dayOfWeekShort || map$1(localeModel.get(["time", "dayOfWeekAbbr"]), function(val) {
        return val[0];
      });
    }
    var start2 = coordSys.getNextNDay(rangeData.end.time, 7 - rangeData.lweek).time;
    var cellSize = [coordSys.getCellWidth(), coordSys.getCellHeight()];
    margin = parsePercent(margin, Math.min(cellSize[1], cellSize[0]));
    if (pos === "start") {
      start2 = coordSys.getNextNDay(rangeData.start.time, -(7 + rangeData.fweek)).time;
      margin = -margin;
    }
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(start2, i);
      var point = coordSys.dataToRect([tmpD.time], false).center;
      var day = i;
      day = Math.abs((i + firstDayOfWeek) % 7);
      var weekText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(dayLabel, {
          text: nameMap[day]
        }), this._weekTextPositionControl(point, orient, pos, margin, cellSize))
      });
      group.add(weekText);
    }
  };
  CalendarView2.type = "calendar";
  return CalendarView2;
}(ComponentView$1);
var CalendarView$1 = CalendarView;
var PROXIMATE_ONE_DAY = 864e5;
var Calendar = function() {
  function Calendar2(calendarModel, ecModel, api) {
    this.type = "calendar";
    this.dimensions = Calendar2.dimensions;
    this.getDimensionsInfo = Calendar2.getDimensionsInfo;
    this._model = calendarModel;
  }
  Calendar2.getDimensionsInfo = function() {
    return [{
      name: "time",
      type: "time"
    }, "value"];
  };
  Calendar2.prototype.getRangeInfo = function() {
    return this._rangeInfo;
  };
  Calendar2.prototype.getModel = function() {
    return this._model;
  };
  Calendar2.prototype.getRect = function() {
    return this._rect;
  };
  Calendar2.prototype.getCellWidth = function() {
    return this._sw;
  };
  Calendar2.prototype.getCellHeight = function() {
    return this._sh;
  };
  Calendar2.prototype.getOrient = function() {
    return this._orient;
  };
  Calendar2.prototype.getFirstDayOfWeek = function() {
    return this._firstDayOfWeek;
  };
  Calendar2.prototype.getDateInfo = function(date4) {
    date4 = parseDate(date4);
    var y2 = date4.getFullYear();
    var m2 = date4.getMonth() + 1;
    var mStr = m2 < 10 ? "0" + m2 : "" + m2;
    var d2 = date4.getDate();
    var dStr = d2 < 10 ? "0" + d2 : "" + d2;
    var day = date4.getDay();
    day = Math.abs((day + 7 - this.getFirstDayOfWeek()) % 7);
    return {
      y: y2 + "",
      m: mStr,
      d: dStr,
      day,
      time: date4.getTime(),
      formatedDate: y2 + "-" + mStr + "-" + dStr,
      date: date4
    };
  };
  Calendar2.prototype.getNextNDay = function(date4, n2) {
    n2 = n2 || 0;
    if (n2 === 0) {
      return this.getDateInfo(date4);
    }
    date4 = new Date(this.getDateInfo(date4).time);
    date4.setDate(date4.getDate() + n2);
    return this.getDateInfo(date4);
  };
  Calendar2.prototype.update = function(ecModel, api) {
    this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay");
    this._orient = this._model.get("orient");
    this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0;
    this._rangeInfo = this._getRangeInfo(this._initRangeOption());
    var weeks = this._rangeInfo.weeks || 1;
    var whNames = ["width", "height"];
    var cellSize = this._model.getCellSize().slice();
    var layoutParams = this._model.getBoxLayoutParams();
    var cellNumbers = this._orient === "horizontal" ? [weeks, 7] : [7, weeks];
    each$f([0, 1], function(idx) {
      if (cellSizeSpecified(cellSize, idx)) {
        layoutParams[whNames[idx]] = cellSize[idx] * cellNumbers[idx];
      }
    });
    var whGlobal = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var calendarRect = this._rect = getLayoutRect(layoutParams, whGlobal);
    each$f([0, 1], function(idx) {
      if (!cellSizeSpecified(cellSize, idx)) {
        cellSize[idx] = calendarRect[whNames[idx]] / cellNumbers[idx];
      }
    });
    function cellSizeSpecified(cellSize2, idx) {
      return cellSize2[idx] != null && cellSize2[idx] !== "auto";
    }
    this._sw = cellSize[0];
    this._sh = cellSize[1];
  };
  Calendar2.prototype.dataToPoint = function(data, clamp2) {
    isArray$1(data) && (data = data[0]);
    clamp2 == null && (clamp2 = true);
    var dayInfo = this.getDateInfo(data);
    var range3 = this._rangeInfo;
    var date4 = dayInfo.formatedDate;
    if (clamp2 && !(dayInfo.time >= range3.start.time && dayInfo.time < range3.end.time + PROXIMATE_ONE_DAY)) {
      return [NaN, NaN];
    }
    var week = dayInfo.day;
    var nthWeek = this._getRangeInfo([range3.start.time, date4]).nthWeek;
    if (this._orient === "vertical") {
      return [this._rect.x + week * this._sw + this._sw / 2, this._rect.y + nthWeek * this._sh + this._sh / 2];
    }
    return [this._rect.x + nthWeek * this._sw + this._sw / 2, this._rect.y + week * this._sh + this._sh / 2];
  };
  Calendar2.prototype.pointToData = function(point) {
    var date4 = this.pointToDate(point);
    return date4 && date4.time;
  };
  Calendar2.prototype.dataToRect = function(data, clamp2) {
    var point = this.dataToPoint(data, clamp2);
    return {
      contentShape: {
        x: point[0] - (this._sw - this._lineWidth) / 2,
        y: point[1] - (this._sh - this._lineWidth) / 2,
        width: this._sw - this._lineWidth,
        height: this._sh - this._lineWidth
      },
      center: point,
      tl: [point[0] - this._sw / 2, point[1] - this._sh / 2],
      tr: [point[0] + this._sw / 2, point[1] - this._sh / 2],
      br: [point[0] + this._sw / 2, point[1] + this._sh / 2],
      bl: [point[0] - this._sw / 2, point[1] + this._sh / 2]
    };
  };
  Calendar2.prototype.pointToDate = function(point) {
    var nthX = Math.floor((point[0] - this._rect.x) / this._sw) + 1;
    var nthY = Math.floor((point[1] - this._rect.y) / this._sh) + 1;
    var range3 = this._rangeInfo.range;
    if (this._orient === "vertical") {
      return this._getDateByWeeksAndDay(nthY, nthX - 1, range3);
    }
    return this._getDateByWeeksAndDay(nthX, nthY - 1, range3);
  };
  Calendar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Calendar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  Calendar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Calendar2.prototype._initRangeOption = function() {
    var range3 = this._model.get("range");
    var normalizedRange;
    if (isArray$1(range3) && range3.length === 1) {
      range3 = range3[0];
    }
    if (!isArray$1(range3)) {
      var rangeStr = range3.toString();
      if (/^\d{4}$/.test(rangeStr)) {
        normalizedRange = [rangeStr + "-01-01", rangeStr + "-12-31"];
      }
      if (/^\d{4}[\/|-]\d{1,2}$/.test(rangeStr)) {
        var start2 = this.getDateInfo(rangeStr);
        var firstDay = start2.date;
        firstDay.setMonth(firstDay.getMonth() + 1);
        var end2 = this.getNextNDay(firstDay, -1);
        normalizedRange = [start2.formatedDate, end2.formatedDate];
      }
      if (/^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(rangeStr)) {
        normalizedRange = [rangeStr, rangeStr];
      }
    } else {
      normalizedRange = range3;
    }
    if (!normalizedRange) {
      return range3;
    }
    var tmp = this._getRangeInfo(normalizedRange);
    if (tmp.start.time > tmp.end.time) {
      normalizedRange.reverse();
    }
    return normalizedRange;
  };
  Calendar2.prototype._getRangeInfo = function(range3) {
    var parsedRange = [this.getDateInfo(range3[0]), this.getDateInfo(range3[1])];
    var reversed;
    if (parsedRange[0].time > parsedRange[1].time) {
      reversed = true;
      parsedRange.reverse();
    }
    var allDay = Math.floor(parsedRange[1].time / PROXIMATE_ONE_DAY) - Math.floor(parsedRange[0].time / PROXIMATE_ONE_DAY) + 1;
    var date4 = new Date(parsedRange[0].time);
    var startDateNum = date4.getDate();
    var endDateNum = parsedRange[1].date.getDate();
    date4.setDate(startDateNum + allDay - 1);
    var dateNum = date4.getDate();
    if (dateNum !== endDateNum) {
      var sign = date4.getTime() - parsedRange[1].time > 0 ? 1 : -1;
      while ((dateNum = date4.getDate()) !== endDateNum && (date4.getTime() - parsedRange[1].time) * sign > 0) {
        allDay -= sign;
        date4.setDate(dateNum - sign);
      }
    }
    var weeks = Math.floor((allDay + parsedRange[0].day + 6) / 7);
    var nthWeek = reversed ? -weeks + 1 : weeks - 1;
    reversed && parsedRange.reverse();
    return {
      range: [parsedRange[0].formatedDate, parsedRange[1].formatedDate],
      start: parsedRange[0],
      end: parsedRange[1],
      allDay,
      weeks,
      nthWeek,
      fweek: parsedRange[0].day,
      lweek: parsedRange[1].day
    };
  };
  Calendar2.prototype._getDateByWeeksAndDay = function(nthWeek, day, range3) {
    var rangeInfo = this._getRangeInfo(range3);
    if (nthWeek > rangeInfo.weeks || nthWeek === 0 && day < rangeInfo.fweek || nthWeek === rangeInfo.weeks && day > rangeInfo.lweek) {
      return null;
    }
    var nthDay = (nthWeek - 1) * 7 - rangeInfo.fweek + day;
    var date4 = new Date(rangeInfo.start.time);
    date4.setDate(+rangeInfo.start.d + nthDay);
    return this.getDateInfo(date4);
  };
  Calendar2.create = function(ecModel, api) {
    var calendarList = [];
    ecModel.eachComponent("calendar", function(calendarModel) {
      var calendar = new Calendar2(calendarModel, ecModel, api);
      calendarList.push(calendar);
      calendarModel.coordinateSystem = calendar;
    });
    ecModel.eachSeries(function(calendarSeries) {
      if (calendarSeries.get("coordinateSystem") === "calendar") {
        calendarSeries.coordinateSystem = calendarList[calendarSeries.get("calendarIndex") || 0];
      }
    });
    return calendarList;
  };
  Calendar2.dimensions = ["time", "value"];
  return Calendar2;
}();
function getCoordSys(finder) {
  var calendarModel = finder.calendarModel;
  var seriesModel = finder.seriesModel;
  var coordSys = calendarModel ? calendarModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem : null;
  return coordSys;
}
var Calendar$1 = Calendar;
function install$m(registers) {
  registers.registerComponentModel(CalendarModel$1);
  registers.registerComponentView(CalendarView$1);
  registers.registerCoordinateSystem("calendar", Calendar$1);
}
function setKeyInfoToNewElOption(resultItem, newElOption) {
  var existElOption = resultItem.existing;
  newElOption.id = resultItem.keyInfo.id;
  !newElOption.type && existElOption && (newElOption.type = existElOption.type);
  if (newElOption.parentId == null) {
    var newElParentOption = newElOption.parentOption;
    if (newElParentOption) {
      newElOption.parentId = newElParentOption.id;
    } else if (existElOption) {
      newElOption.parentId = existElOption.parentId;
    }
  }
  newElOption.parentOption = null;
}
function isSetLoc(obj, props) {
  var isSet;
  each$f(props, function(prop) {
    obj[prop] != null && obj[prop] !== "auto" && (isSet = true);
  });
  return isSet;
}
function mergeNewElOptionToExist(existList, index2, newElOption) {
  var newElOptCopy = extend({}, newElOption);
  var existElOption = existList[index2];
  var $action = newElOption.$action || "merge";
  if ($action === "merge") {
    if (existElOption) {
      merge(existElOption, newElOptCopy, true);
      mergeLayoutParam(existElOption, newElOptCopy, {
        ignoreSize: true
      });
      copyLayoutParams(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption, "shape");
      copyTransitionInfo(newElOption, existElOption, "style");
      copyTransitionInfo(newElOption, existElOption, "extra");
      newElOption.clipPath = existElOption.clipPath;
    } else {
      existList[index2] = newElOptCopy;
    }
  } else if ($action === "replace") {
    existList[index2] = newElOptCopy;
  } else if ($action === "remove") {
    existElOption && (existList[index2] = null);
  }
}
var TRANSITION_PROPS_TO_COPY = ["transition", "enterFrom", "leaveTo"];
var ROOT_TRANSITION_PROPS_TO_COPY = TRANSITION_PROPS_TO_COPY.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
function copyTransitionInfo(target, source, targetProp) {
  if (targetProp) {
    if (!target[targetProp] && source[targetProp]) {
      target[targetProp] = {};
    }
    target = target[targetProp];
    source = source[targetProp];
  }
  if (!target || !source) {
    return;
  }
  var props = targetProp ? TRANSITION_PROPS_TO_COPY : ROOT_TRANSITION_PROPS_TO_COPY;
  for (var i = 0; i < props.length; i++) {
    var prop = props[i];
    if (target[prop] == null && source[prop] != null) {
      target[prop] = source[prop];
    }
  }
}
function setLayoutInfoToExist(existItem, newElOption) {
  if (!existItem) {
    return;
  }
  existItem.hv = newElOption.hv = [
    isSetLoc(newElOption, ["left", "right"]),
    isSetLoc(newElOption, ["top", "bottom"])
  ];
  if (existItem.type === "group") {
    var existingGroupOpt = existItem;
    var newGroupOpt = newElOption;
    existingGroupOpt.width == null && (existingGroupOpt.width = newGroupOpt.width = 0);
    existingGroupOpt.height == null && (existingGroupOpt.height = newGroupOpt.height = 0);
  }
}
var GraphicComponentModel = function(_super) {
  __extends(GraphicComponentModel2, _super);
  function GraphicComponentModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentModel2.type;
    _this.preventAutoZ = true;
    return _this;
  }
  GraphicComponentModel2.prototype.mergeOption = function(option, ecModel) {
    var elements = this.option.elements;
    this.option.elements = null;
    _super.prototype.mergeOption.call(this, option, ecModel);
    this.option.elements = elements;
  };
  GraphicComponentModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    var newList = (isInit ? thisOption : newOption).elements;
    var existList = thisOption.elements = isInit ? [] : thisOption.elements;
    var flattenedList = [];
    this._flatten(newList, flattenedList, null);
    var mappingResult = mappingToExists(existList, flattenedList, "normalMerge");
    var elOptionsToUpdate = this._elOptionsToUpdate = [];
    each$f(mappingResult, function(resultItem, index2) {
      var newElOption = resultItem.newOption;
      if (!newElOption) {
        return;
      }
      elOptionsToUpdate.push(newElOption);
      setKeyInfoToNewElOption(resultItem, newElOption);
      mergeNewElOptionToExist(existList, index2, newElOption);
      setLayoutInfoToExist(existList[index2], newElOption);
    }, this);
    thisOption.elements = filter(existList, function(item) {
      item && delete item.$action;
      return item != null;
    });
  };
  GraphicComponentModel2.prototype._flatten = function(optionList, result, parentOption) {
    each$f(optionList, function(option) {
      if (!option) {
        return;
      }
      if (parentOption) {
        option.parentOption = parentOption;
      }
      result.push(option);
      var children = option.children;
      if (option.type === "group" && children) {
        this._flatten(children, result, option);
      }
      delete option.children;
    }, this);
  };
  GraphicComponentModel2.prototype.useElOptionsToUpdate = function() {
    var els = this._elOptionsToUpdate;
    this._elOptionsToUpdate = null;
    return els;
  };
  GraphicComponentModel2.type = "graphic";
  GraphicComponentModel2.defaultOption = {
    elements: []
  };
  return GraphicComponentModel2;
}(ComponentModel$1);
var nonShapeGraphicElements = {
  path: null,
  compoundPath: null,
  group: Group$4,
  image: ZRImage$1,
  text: ZRText$1
};
var inner$7 = makeInner();
var GraphicComponentView = function(_super) {
  __extends(GraphicComponentView2, _super);
  function GraphicComponentView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentView2.type;
    return _this;
  }
  GraphicComponentView2.prototype.init = function() {
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.render = function(graphicModel, ecModel, api) {
    if (graphicModel !== this._lastGraphicModel) {
      this._clear();
    }
    this._lastGraphicModel = graphicModel;
    this._updateElements(graphicModel);
    this._relocate(graphicModel, api);
  };
  GraphicComponentView2.prototype._updateElements = function(graphicModel) {
    var elOptionsToUpdate = graphicModel.useElOptionsToUpdate();
    if (!elOptionsToUpdate) {
      return;
    }
    var elMap = this._elMap;
    var rootGroup = this.group;
    var globalZ = graphicModel.get("z");
    var globalZLevel = graphicModel.get("zlevel");
    each$f(elOptionsToUpdate, function(elOption) {
      var id2 = convertOptionIdName(elOption.id, null);
      var elExisting = id2 != null ? elMap.get(id2) : null;
      var parentId = convertOptionIdName(elOption.parentId, null);
      var targetElParent = parentId != null ? elMap.get(parentId) : rootGroup;
      var elType = elOption.type;
      var elOptionStyle = elOption.style;
      if (elType === "text" && elOptionStyle) {
        if (elOption.hv && elOption.hv[1]) {
          elOptionStyle.textVerticalAlign = elOptionStyle.textBaseline = elOptionStyle.verticalAlign = elOptionStyle.align = null;
        }
      }
      var textContentOption = elOption.textContent;
      var textConfig = elOption.textConfig;
      if (elOptionStyle && isEC4CompatibleStyle(elOptionStyle, elType, !!textConfig, !!textContentOption)) {
        var convertResult = convertFromEC4CompatibleStyle(elOptionStyle, elType, true);
        if (!textConfig && convertResult.textConfig) {
          textConfig = elOption.textConfig = convertResult.textConfig;
        }
        if (!textContentOption && convertResult.textContent) {
          textContentOption = convertResult.textContent;
        }
      }
      var elOptionCleaned = getCleanedElOption(elOption);
      var $action = elOption.$action || "merge";
      var isMerge = $action === "merge";
      var isReplace = $action === "replace";
      if (isMerge) {
        var isInit = !elExisting;
        var el_1 = elExisting;
        if (isInit) {
          el_1 = createEl(id2, targetElParent, elOption.type, elMap);
        } else {
          el_1 && (inner$7(el_1).isNew = false);
          stopPreviousKeyframeAnimationAndRestore(el_1);
        }
        if (el_1) {
          applyUpdateTransition(el_1, elOptionCleaned, graphicModel, {
            isInit
          });
          updateCommonAttrs(el_1, elOption, globalZ, globalZLevel);
        }
      } else if (isReplace) {
        removeEl$1(elExisting, elOption, elMap, graphicModel);
        var el_2 = createEl(id2, targetElParent, elOption.type, elMap);
        if (el_2) {
          applyUpdateTransition(el_2, elOptionCleaned, graphicModel, {
            isInit: true
          });
          updateCommonAttrs(el_2, elOption, globalZ, globalZLevel);
        }
      } else if ($action === "remove") {
        updateLeaveTo(elExisting, elOption);
        removeEl$1(elExisting, elOption, elMap, graphicModel);
      }
      var el = elMap.get(id2);
      if (el && textContentOption) {
        if (isMerge) {
          var textContentExisting = el.getTextContent();
          textContentExisting ? textContentExisting.attr(textContentOption) : el.setTextContent(new ZRText$1(textContentOption));
        } else if (isReplace) {
          el.setTextContent(new ZRText$1(textContentOption));
        }
      }
      if (el) {
        var clipPathOption = elOption.clipPath;
        if (clipPathOption) {
          var clipPathType = clipPathOption.type;
          var clipPath = void 0;
          var isInit = false;
          if (isMerge) {
            var oldClipPath = el.getClipPath();
            isInit = !oldClipPath || inner$7(oldClipPath).type !== clipPathType;
            clipPath = isInit ? newEl(clipPathType) : oldClipPath;
          } else if (isReplace) {
            isInit = true;
            clipPath = newEl(clipPathType);
          }
          el.setClipPath(clipPath);
          applyUpdateTransition(clipPath, clipPathOption, graphicModel, {
            isInit
          });
          applyKeyframeAnimation(clipPath, clipPathOption.keyframeAnimation, graphicModel);
        }
        var elInner = inner$7(el);
        el.setTextConfig(textConfig);
        elInner.option = elOption;
        setEventData(el, graphicModel, elOption);
        setTooltipConfig({
          el,
          componentModel: graphicModel,
          itemName: el.name,
          itemTooltipOption: elOption.tooltip
        });
        applyKeyframeAnimation(el, elOption.keyframeAnimation, graphicModel);
      }
    });
  };
  GraphicComponentView2.prototype._relocate = function(graphicModel, api) {
    var elOptions = graphicModel.option.elements;
    var rootGroup = this.group;
    var elMap = this._elMap;
    var apiWidth = api.getWidth();
    var apiHeight = api.getHeight();
    var xy = ["x", "y"];
    for (var i = 0; i < elOptions.length; i++) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el || !el.isGroup) {
        continue;
      }
      var parentEl = el.parent;
      var isParentRoot = parentEl === rootGroup;
      var elInner = inner$7(el);
      var parentElInner = inner$7(parentEl);
      elInner.width = parsePercent(elInner.option.width, isParentRoot ? apiWidth : parentElInner.width) || 0;
      elInner.height = parsePercent(elInner.option.height, isParentRoot ? apiHeight : parentElInner.height) || 0;
    }
    for (var i = elOptions.length - 1; i >= 0; i--) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el) {
        continue;
      }
      var parentEl = el.parent;
      var parentElInner = inner$7(parentEl);
      var containerInfo = parentEl === rootGroup ? {
        width: apiWidth,
        height: apiHeight
      } : {
        width: parentElInner.width,
        height: parentElInner.height
      };
      var layoutPos = {};
      var layouted = positionElement(el, elOption, containerInfo, null, {
        hv: elOption.hv,
        boundingMode: elOption.bounding
      }, layoutPos);
      if (!inner$7(el).isNew && layouted) {
        var transition = elOption.transition;
        var animatePos = {};
        for (var k2 = 0; k2 < xy.length; k2++) {
          var key = xy[k2];
          var val = layoutPos[key];
          if (transition && (isTransitionAll(transition) || indexOf(transition, key) >= 0)) {
            animatePos[key] = val;
          } else {
            el[key] = val;
          }
        }
        updateProps$1(el, animatePos, graphicModel, 0);
      } else {
        el.attr(layoutPos);
      }
    }
  };
  GraphicComponentView2.prototype._clear = function() {
    var _this = this;
    var elMap = this._elMap;
    elMap.each(function(el) {
      removeEl$1(el, inner$7(el).option, elMap, _this._lastGraphicModel);
    });
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.dispose = function() {
    this._clear();
  };
  GraphicComponentView2.type = "graphic";
  return GraphicComponentView2;
}(ComponentView$1);
function newEl(graphicType) {
  var Clz = hasOwn(nonShapeGraphicElements, graphicType) ? nonShapeGraphicElements[graphicType] : getShapeClass(graphicType);
  var el = new Clz({});
  inner$7(el).type = graphicType;
  return el;
}
function createEl(id2, targetElParent, graphicType, elMap) {
  var el = newEl(graphicType);
  targetElParent.add(el);
  elMap.set(id2, el);
  inner$7(el).id = id2;
  inner$7(el).isNew = true;
  return el;
}
function removeEl$1(elExisting, elOption, elMap, graphicModel) {
  var existElParent = elExisting && elExisting.parent;
  if (existElParent) {
    elExisting.type === "group" && elExisting.traverse(function(el) {
      removeEl$1(el, elOption, elMap, graphicModel);
    });
    applyLeaveTransition(elExisting, elOption, graphicModel);
    elMap.removeKey(inner$7(elExisting).id);
  }
}
function updateCommonAttrs(el, elOption, defaultZ, defaultZlevel) {
  if (!el.isGroup) {
    var elDisplayable = el;
    elDisplayable.cursor = retrieve2(elOption.cursor, Displayable$1.prototype.cursor);
    elDisplayable.z = retrieve2(elOption.z, defaultZ || 0);
    elDisplayable.zlevel = retrieve2(elOption.zlevel, defaultZlevel || 0);
    var optZ2 = elOption.z2;
    optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  }
  each$f(keys(elOption), function(key) {
    var val = elOption[key];
    if (key.indexOf("on") === 0 && isFunction(val)) {
      el[key] = val;
    }
  });
  el.draggable = elOption.draggable;
  elOption.name != null && (el.name = elOption.name);
  elOption.id != null && (el.id = elOption.id);
}
function getCleanedElOption(elOption) {
  elOption = extend({}, elOption);
  each$f(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(LOCATION_PARAMS), function(name) {
    delete elOption[name];
  });
  return elOption;
}
function setEventData(el, graphicModel, elOption) {
  var eventData = getECData(el).eventData;
  if (!el.silent && !el.ignore && !eventData) {
    eventData = getECData(el).eventData = {
      componentType: "graphic",
      componentIndex: graphicModel.componentIndex,
      name: el.name
    };
  }
  if (eventData) {
    eventData.info = elOption.info;
  }
}
function install$l(registers) {
  registers.registerComponentModel(GraphicComponentModel);
  registers.registerComponentView(GraphicComponentView);
  registers.registerPreprocessor(function(option) {
    var graphicOption = option.graphic;
    if (isArray$1(graphicOption)) {
      if (!graphicOption[0] || !graphicOption[0].elements) {
        option.graphic = [{
          elements: graphicOption
        }];
      } else {
        option.graphic = [option.graphic[0]];
      }
    } else if (graphicOption && !graphicOption.elements) {
      option.graphic = [{
        elements: [graphicOption]
      }];
    }
  });
}
var DATA_ZOOM_AXIS_DIMENSIONS = ["x", "y", "radius", "angle", "single"];
var SERIES_COORDS = ["cartesian2d", "polar", "singleAxis"];
function isCoordSupported(seriesModel) {
  var coordType = seriesModel.get("coordinateSystem");
  return indexOf(SERIES_COORDS, coordType) >= 0;
}
function getAxisMainType(axisDim) {
  return axisDim + "Axis";
}
function findEffectedDataZooms(ecModel, payload) {
  var axisRecords = createHashMap();
  var effectedModels = [];
  var effectedModelMap = createHashMap();
  ecModel.eachComponent({
    mainType: "dataZoom",
    query: payload
  }, function(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid)) {
      addToEffected(dataZoomModel);
    }
  });
  var foundNewLink;
  do {
    foundNewLink = false;
    ecModel.eachComponent("dataZoom", processSingle);
  } while (foundNewLink);
  function processSingle(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid) && isLinked(dataZoomModel)) {
      addToEffected(dataZoomModel);
      foundNewLink = true;
    }
  }
  function addToEffected(dataZoom) {
    effectedModelMap.set(dataZoom.uid, true);
    effectedModels.push(dataZoom);
    markAxisControlled(dataZoom);
  }
  function isLinked(dataZoomModel) {
    var isLink = false;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var axisIdxArr = axisRecords.get(axisDim);
      if (axisIdxArr && axisIdxArr[axisIndex]) {
        isLink = true;
      }
    });
    return isLink;
  }
  function markAxisControlled(dataZoomModel) {
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      (axisRecords.get(axisDim) || axisRecords.set(axisDim, []))[axisIndex] = true;
    });
  }
  return effectedModels;
}
function collectReferCoordSysModelInfo(dataZoomModel) {
  var ecModel = dataZoomModel.ecModel;
  var coordSysInfoWrap = {
    infoList: [],
    infoMap: createHashMap()
  };
  dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
    var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    if (!axisModel) {
      return;
    }
    var coordSysModel = axisModel.getCoordSysModel();
    if (!coordSysModel) {
      return;
    }
    var coordSysUid = coordSysModel.uid;
    var coordSysInfo = coordSysInfoWrap.infoMap.get(coordSysUid);
    if (!coordSysInfo) {
      coordSysInfo = {
        model: coordSysModel,
        axisModels: []
      };
      coordSysInfoWrap.infoList.push(coordSysInfo);
      coordSysInfoWrap.infoMap.set(coordSysUid, coordSysInfo);
    }
    coordSysInfo.axisModels.push(axisModel);
  });
  return coordSysInfoWrap;
}
var DataZoomAxisInfo = function() {
  function DataZoomAxisInfo2() {
    this.indexList = [];
    this.indexMap = [];
  }
  DataZoomAxisInfo2.prototype.add = function(axisCmptIdx) {
    if (!this.indexMap[axisCmptIdx]) {
      this.indexList.push(axisCmptIdx);
      this.indexMap[axisCmptIdx] = true;
    }
  };
  return DataZoomAxisInfo2;
}();
var DataZoomModel = function(_super) {
  __extends(DataZoomModel2, _super);
  function DataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomModel2.type;
    _this._autoThrottle = true;
    _this._noTarget = true;
    _this._rangePropMode = ["percent", "percent"];
    return _this;
  }
  DataZoomModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputRawOption = retrieveRawOption(option);
    this.settledOption = inputRawOption;
    this.mergeDefaultAndTheme(option, ecModel);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype.mergeOption = function(newOption) {
    var inputRawOption = retrieveRawOption(newOption);
    merge(this.option, newOption, true);
    merge(this.settledOption, inputRawOption, true);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype._doInit = function(inputRawOption) {
    var thisOption = this.option;
    this._setDefaultThrottle(inputRawOption);
    this._updateRangeUse(inputRawOption);
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      if (this._rangePropMode[index2] === "value") {
        thisOption[names2[0]] = settledOption[names2[0]] = null;
      }
    }, this);
    this._resetTarget();
  };
  DataZoomModel2.prototype._resetTarget = function() {
    var optionOrient = this.get("orient", true);
    var targetAxisIndexMap = this._targetAxisInfoMap = createHashMap();
    var hasAxisSpecified = this._fillSpecifiedTargetAxis(targetAxisIndexMap);
    if (hasAxisSpecified) {
      this._orient = optionOrient || this._makeAutoOrientByTargetAxis();
    } else {
      this._orient = optionOrient || "horizontal";
      this._fillAutoTargetAxisByOrient(targetAxisIndexMap, this._orient);
    }
    this._noTarget = true;
    targetAxisIndexMap.each(function(axisInfo) {
      if (axisInfo.indexList.length) {
        this._noTarget = false;
      }
    }, this);
  };
  DataZoomModel2.prototype._fillSpecifiedTargetAxis = function(targetAxisIndexMap) {
    var hasAxisSpecified = false;
    each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim) {
      var refering = this.getReferringComponents(getAxisMainType(axisDim), MULTIPLE_REFERRING);
      if (!refering.specified) {
        return;
      }
      hasAxisSpecified = true;
      var axisInfo = new DataZoomAxisInfo();
      each$f(refering.models, function(axisModel) {
        axisInfo.add(axisModel.componentIndex);
      });
      targetAxisIndexMap.set(axisDim, axisInfo);
    }, this);
    return hasAxisSpecified;
  };
  DataZoomModel2.prototype._fillAutoTargetAxisByOrient = function(targetAxisIndexMap, orient) {
    var ecModel = this.ecModel;
    var needAuto = true;
    if (needAuto) {
      var axisDim = orient === "vertical" ? "y" : "x";
      var axisModels = ecModel.findComponents({
        mainType: axisDim + "Axis"
      });
      setParallelAxis(axisModels, axisDim);
    }
    if (needAuto) {
      var axisModels = ecModel.findComponents({
        mainType: "singleAxis",
        filter: function(axisModel) {
          return axisModel.get("orient", true) === orient;
        }
      });
      setParallelAxis(axisModels, "single");
    }
    function setParallelAxis(axisModels2, axisDim2) {
      var axisModel = axisModels2[0];
      if (!axisModel) {
        return;
      }
      var axisInfo = new DataZoomAxisInfo();
      axisInfo.add(axisModel.componentIndex);
      targetAxisIndexMap.set(axisDim2, axisInfo);
      needAuto = false;
      if (axisDim2 === "x" || axisDim2 === "y") {
        var gridModel_1 = axisModel.getReferringComponents("grid", SINGLE_REFERRING).models[0];
        gridModel_1 && each$f(axisModels2, function(axModel) {
          if (axisModel.componentIndex !== axModel.componentIndex && gridModel_1 === axModel.getReferringComponents("grid", SINGLE_REFERRING).models[0]) {
            axisInfo.add(axModel.componentIndex);
          }
        });
      }
    }
    if (needAuto) {
      each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim2) {
        if (!needAuto) {
          return;
        }
        var axisModels2 = ecModel.findComponents({
          mainType: getAxisMainType(axisDim2),
          filter: function(axisModel) {
            return axisModel.get("type", true) === "category";
          }
        });
        if (axisModels2[0]) {
          var axisInfo = new DataZoomAxisInfo();
          axisInfo.add(axisModels2[0].componentIndex);
          targetAxisIndexMap.set(axisDim2, axisInfo);
          needAuto = false;
        }
      }, this);
    }
  };
  DataZoomModel2.prototype._makeAutoOrientByTargetAxis = function() {
    var dim;
    this.eachTargetAxis(function(axisDim) {
      !dim && (dim = axisDim);
    }, this);
    return dim === "y" ? "vertical" : "horizontal";
  };
  DataZoomModel2.prototype._setDefaultThrottle = function(inputRawOption) {
    if (inputRawOption.hasOwnProperty("throttle")) {
      this._autoThrottle = false;
    }
    if (this._autoThrottle) {
      var globalOption = this.ecModel.option;
      this.option.throttle = globalOption.animation && globalOption.animationDurationUpdate > 0 ? 100 : 20;
    }
  };
  DataZoomModel2.prototype._updateRangeUse = function(inputRawOption) {
    var rangePropMode = this._rangePropMode;
    var rangeModeInOption = this.get("rangeMode");
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      var percentSpecified = inputRawOption[names2[0]] != null;
      var valueSpecified = inputRawOption[names2[1]] != null;
      if (percentSpecified && !valueSpecified) {
        rangePropMode[index2] = "percent";
      } else if (!percentSpecified && valueSpecified) {
        rangePropMode[index2] = "value";
      } else if (rangeModeInOption) {
        rangePropMode[index2] = rangeModeInOption[index2];
      } else if (percentSpecified) {
        rangePropMode[index2] = "percent";
      }
    });
  };
  DataZoomModel2.prototype.noTarget = function() {
    return this._noTarget;
  };
  DataZoomModel2.prototype.getFirstTargetAxisModel = function() {
    var firstAxisModel;
    this.eachTargetAxis(function(axisDim, axisIndex) {
      if (firstAxisModel == null) {
        firstAxisModel = this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
      }
    }, this);
    return firstAxisModel;
  };
  DataZoomModel2.prototype.eachTargetAxis = function(callback, context) {
    this._targetAxisInfoMap.each(function(axisInfo, axisDim) {
      each$f(axisInfo.indexList, function(axisIndex) {
        callback.call(context, axisDim, axisIndex);
      });
    });
  };
  DataZoomModel2.prototype.getAxisProxy = function(axisDim, axisIndex) {
    var axisModel = this.getAxisModel(axisDim, axisIndex);
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
  };
  DataZoomModel2.prototype.getAxisModel = function(axisDim, axisIndex) {
    var axisInfo = this._targetAxisInfoMap.get(axisDim);
    if (axisInfo && axisInfo.indexMap[axisIndex]) {
      return this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    }
  };
  DataZoomModel2.prototype.setRawRange = function(opt) {
    var thisOption = this.option;
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2) {
      if (opt[names2[0]] != null || opt[names2[1]] != null) {
        thisOption[names2[0]] = settledOption[names2[0]] = opt[names2[0]];
        thisOption[names2[1]] = settledOption[names2[1]] = opt[names2[1]];
      }
    }, this);
    this._updateRangeUse(opt);
  };
  DataZoomModel2.prototype.setCalculatedRange = function(opt) {
    var option = this.option;
    each$f(["start", "startValue", "end", "endValue"], function(name) {
      option[name] = opt[name];
    });
  };
  DataZoomModel2.prototype.getPercentRange = function() {
    var axisProxy = this.findRepresentativeAxisProxy();
    if (axisProxy) {
      return axisProxy.getDataPercentWindow();
    }
  };
  DataZoomModel2.prototype.getValueRange = function(axisDim, axisIndex) {
    if (axisDim == null && axisIndex == null) {
      var axisProxy = this.findRepresentativeAxisProxy();
      if (axisProxy) {
        return axisProxy.getDataValueWindow();
      }
    } else {
      return this.getAxisProxy(axisDim, axisIndex).getDataValueWindow();
    }
  };
  DataZoomModel2.prototype.findRepresentativeAxisProxy = function(axisModel) {
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
    var firstProxy;
    var axisDimList = this._targetAxisInfoMap.keys();
    for (var i = 0; i < axisDimList.length; i++) {
      var axisDim = axisDimList[i];
      var axisInfo = this._targetAxisInfoMap.get(axisDim);
      for (var j = 0; j < axisInfo.indexList.length; j++) {
        var proxy = this.getAxisProxy(axisDim, axisInfo.indexList[j]);
        if (proxy.hostedBy(this)) {
          return proxy;
        }
        if (!firstProxy) {
          firstProxy = proxy;
        }
      }
    }
    return firstProxy;
  };
  DataZoomModel2.prototype.getRangePropMode = function() {
    return this._rangePropMode.slice();
  };
  DataZoomModel2.prototype.getOrient = function() {
    return this._orient;
  };
  DataZoomModel2.type = "dataZoom";
  DataZoomModel2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"];
  DataZoomModel2.defaultOption = {
    z: 4,
    filterMode: "filter",
    start: 0,
    end: 100
  };
  return DataZoomModel2;
}(ComponentModel$1);
function retrieveRawOption(option) {
  var ret = {};
  each$f(["start", "end", "startValue", "endValue", "throttle"], function(name) {
    option.hasOwnProperty(name) && (ret[name] = option[name]);
  });
  return ret;
}
var DataZoomModel$1 = DataZoomModel;
var SelectDataZoomModel = function(_super) {
  __extends(SelectDataZoomModel2, _super);
  function SelectDataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomModel2.type;
    return _this;
  }
  SelectDataZoomModel2.type = "dataZoom.select";
  return SelectDataZoomModel2;
}(DataZoomModel$1);
var SelectZoomModel = SelectDataZoomModel;
var DataZoomView = function(_super) {
  __extends(DataZoomView2, _super);
  function DataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomView2.type;
    return _this;
  }
  DataZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    this.dataZoomModel = dataZoomModel;
    this.ecModel = ecModel;
    this.api = api;
  };
  DataZoomView2.type = "dataZoom";
  return DataZoomView2;
}(ComponentView$1);
var DataZoomView$1 = DataZoomView;
var SelectDataZoomView = function(_super) {
  __extends(SelectDataZoomView2, _super);
  function SelectDataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomView2.type;
    return _this;
  }
  SelectDataZoomView2.type = "dataZoom.select";
  return SelectDataZoomView2;
}(DataZoomView$1);
var SelectZoomView = SelectDataZoomView;
var each$7 = each$f;
var asc$1 = asc$2;
var AxisProxy = function() {
  function AxisProxy2(dimName, axisIndex, dataZoomModel, ecModel) {
    this._dimName = dimName;
    this._axisIndex = axisIndex;
    this.ecModel = ecModel;
    this._dataZoomModel = dataZoomModel;
  }
  AxisProxy2.prototype.hostedBy = function(dataZoomModel) {
    return this._dataZoomModel === dataZoomModel;
  };
  AxisProxy2.prototype.getDataValueWindow = function() {
    return this._valueWindow.slice();
  };
  AxisProxy2.prototype.getDataPercentWindow = function() {
    return this._percentWindow.slice();
  };
  AxisProxy2.prototype.getTargetSeriesModels = function() {
    var seriesModels = [];
    this.ecModel.eachSeries(function(seriesModel) {
      if (isCoordSupported(seriesModel)) {
        var axisMainType = getAxisMainType(this._dimName);
        var axisModel = seriesModel.getReferringComponents(axisMainType, SINGLE_REFERRING).models[0];
        if (axisModel && this._axisIndex === axisModel.componentIndex) {
          seriesModels.push(seriesModel);
        }
      }
    }, this);
    return seriesModels;
  };
  AxisProxy2.prototype.getAxisModel = function() {
    return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
  };
  AxisProxy2.prototype.getMinMaxSpan = function() {
    return clone$4(this._minMaxSpan);
  };
  AxisProxy2.prototype.calculateDataWindow = function(opt) {
    var dataExtent = this._dataExtent;
    var axisModel = this.getAxisModel();
    var scale2 = axisModel.axis.scale;
    var rangePropMode = this._dataZoomModel.getRangePropMode();
    var percentExtent = [0, 100];
    var percentWindow = [];
    var valueWindow = [];
    var hasPropModeValue;
    each$7(["start", "end"], function(prop, idx) {
      var boundPercent = opt[prop];
      var boundValue = opt[prop + "Value"];
      if (rangePropMode[idx] === "percent") {
        boundPercent == null && (boundPercent = percentExtent[idx]);
        boundValue = scale2.parse(linearMap$2(boundPercent, percentExtent, dataExtent));
      } else {
        hasPropModeValue = true;
        boundValue = boundValue == null ? dataExtent[idx] : scale2.parse(boundValue);
        boundPercent = linearMap$2(boundValue, dataExtent, percentExtent);
      }
      valueWindow[idx] = boundValue;
      percentWindow[idx] = boundPercent;
    });
    asc$1(valueWindow);
    asc$1(percentWindow);
    var spans = this._minMaxSpan;
    hasPropModeValue ? restrictSet(valueWindow, percentWindow, dataExtent, percentExtent, false) : restrictSet(percentWindow, valueWindow, percentExtent, dataExtent, true);
    function restrictSet(fromWindow, toWindow, fromExtent, toExtent, toValue) {
      var suffix = toValue ? "Span" : "ValueSpan";
      sliderMove(0, fromWindow, fromExtent, "all", spans["min" + suffix], spans["max" + suffix]);
      for (var i = 0; i < 2; i++) {
        toWindow[i] = linearMap$2(fromWindow[i], fromExtent, toExtent, true);
        toValue && (toWindow[i] = scale2.parse(toWindow[i]));
      }
    }
    return {
      valueWindow,
      percentWindow
    };
  };
  AxisProxy2.prototype.reset = function(dataZoomModel) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var targetSeries = this.getTargetSeriesModels();
    this._dataExtent = calculateDataExtent(this, this._dimName, targetSeries);
    this._updateMinMaxSpan();
    var dataWindow = this.calculateDataWindow(dataZoomModel.settledOption);
    this._valueWindow = dataWindow.valueWindow;
    this._percentWindow = dataWindow.percentWindow;
    this._setAxisModel();
  };
  AxisProxy2.prototype.filterData = function(dataZoomModel, api) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var axisDim = this._dimName;
    var seriesModels = this.getTargetSeriesModels();
    var filterMode = dataZoomModel.get("filterMode");
    var valueWindow = this._valueWindow;
    if (filterMode === "none") {
      return;
    }
    each$7(seriesModels, function(seriesModel) {
      var seriesData = seriesModel.getData();
      var dataDims = seriesData.mapDimensionsAll(axisDim);
      if (!dataDims.length) {
        return;
      }
      if (filterMode === "weakFilter") {
        var store_1 = seriesData.getStore();
        var dataDimIndices_1 = map$1(dataDims, function(dim) {
          return seriesData.getDimensionIndex(dim);
        }, seriesData);
        seriesData.filterSelf(function(dataIndex) {
          var leftOut;
          var rightOut;
          var hasValue;
          for (var i = 0; i < dataDims.length; i++) {
            var value = store_1.get(dataDimIndices_1[i], dataIndex);
            var thisHasValue = !isNaN(value);
            var thisLeftOut = value < valueWindow[0];
            var thisRightOut = value > valueWindow[1];
            if (thisHasValue && !thisLeftOut && !thisRightOut) {
              return true;
            }
            thisHasValue && (hasValue = true);
            thisLeftOut && (leftOut = true);
            thisRightOut && (rightOut = true);
          }
          return hasValue && leftOut && rightOut;
        });
      } else {
        each$7(dataDims, function(dim) {
          if (filterMode === "empty") {
            seriesModel.setData(seriesData = seriesData.map(dim, function(value) {
              return !isInWindow(value) ? NaN : value;
            }));
          } else {
            var range3 = {};
            range3[dim] = valueWindow;
            seriesData.selectRange(range3);
          }
        });
      }
      each$7(dataDims, function(dim) {
        seriesData.setApproximateExtent(valueWindow, dim);
      });
    });
    function isInWindow(value) {
      return value >= valueWindow[0] && value <= valueWindow[1];
    }
  };
  AxisProxy2.prototype._updateMinMaxSpan = function() {
    var minMaxSpan = this._minMaxSpan = {};
    var dataZoomModel = this._dataZoomModel;
    var dataExtent = this._dataExtent;
    each$7(["min", "max"], function(minMax) {
      var percentSpan = dataZoomModel.get(minMax + "Span");
      var valueSpan = dataZoomModel.get(minMax + "ValueSpan");
      valueSpan != null && (valueSpan = this.getAxisModel().axis.scale.parse(valueSpan));
      if (valueSpan != null) {
        percentSpan = linearMap$2(dataExtent[0] + valueSpan, dataExtent, [0, 100], true);
      } else if (percentSpan != null) {
        valueSpan = linearMap$2(percentSpan, [0, 100], dataExtent, true) - dataExtent[0];
      }
      minMaxSpan[minMax + "Span"] = percentSpan;
      minMaxSpan[minMax + "ValueSpan"] = valueSpan;
    }, this);
  };
  AxisProxy2.prototype._setAxisModel = function() {
    var axisModel = this.getAxisModel();
    var percentWindow = this._percentWindow;
    var valueWindow = this._valueWindow;
    if (!percentWindow) {
      return;
    }
    var precision = getPixelPrecision(valueWindow, [0, 500]);
    precision = Math.min(precision, 20);
    var rawExtentInfo = axisModel.axis.scale.rawExtentInfo;
    if (percentWindow[0] !== 0) {
      rawExtentInfo.setDeterminedMinMax("min", +valueWindow[0].toFixed(precision));
    }
    if (percentWindow[1] !== 100) {
      rawExtentInfo.setDeterminedMinMax("max", +valueWindow[1].toFixed(precision));
    }
    rawExtentInfo.freeze();
  };
  return AxisProxy2;
}();
function calculateDataExtent(axisProxy, axisDim, seriesModels) {
  var dataExtent = [Infinity, -Infinity];
  each$7(seriesModels, function(seriesModel) {
    unionAxisExtentFromData(dataExtent, seriesModel.getData(), axisDim);
  });
  var axisModel = axisProxy.getAxisModel();
  var rawExtentResult = ensureScaleRawExtentInfo(axisModel.axis.scale, axisModel, dataExtent).calculate();
  return [rawExtentResult.min, rawExtentResult.max];
}
var AxisProxy$1 = AxisProxy;
var dataZoomProcessor = {
  getTargetSeries: function(ecModel) {
    function eachAxisModel(cb) {
      ecModel.eachComponent("dataZoom", function(dataZoomModel) {
        dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
          var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
          cb(axisDim, axisIndex, axisModel, dataZoomModel);
        });
      });
    }
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      axisModel.__dzAxisProxy = null;
    });
    var proxyList = [];
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      if (!axisModel.__dzAxisProxy) {
        axisModel.__dzAxisProxy = new AxisProxy$1(axisDim, axisIndex, dataZoomModel, ecModel);
        proxyList.push(axisModel.__dzAxisProxy);
      }
    });
    var seriesModelMap = createHashMap();
    each$f(proxyList, function(axisProxy) {
      each$f(axisProxy.getTargetSeriesModels(), function(seriesModel) {
        seriesModelMap.set(seriesModel.uid, seriesModel);
      });
    });
    return seriesModelMap;
  },
  overallReset: function(ecModel, api) {
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).reset(dataZoomModel);
      });
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).filterData(dataZoomModel, api);
      });
    });
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var percentRange = axisProxy.getDataPercentWindow();
        var valueRange = axisProxy.getDataValueWindow();
        dataZoomModel.setCalculatedRange({
          start: percentRange[0],
          end: percentRange[1],
          startValue: valueRange[0],
          endValue: valueRange[1]
        });
      }
    });
  }
};
var dataZoomProcessor$1 = dataZoomProcessor;
function installDataZoomAction(registers) {
  registers.registerAction("dataZoom", function(payload, ecModel) {
    var effectedModels = findEffectedDataZooms(ecModel, payload);
    each$f(effectedModels, function(dataZoomModel) {
      dataZoomModel.setRawRange({
        start: payload.start,
        end: payload.end,
        startValue: payload.startValue,
        endValue: payload.endValue
      });
    });
  });
}
var installed$1 = false;
function installCommon$1(registers) {
  if (installed$1) {
    return;
  }
  installed$1 = true;
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, dataZoomProcessor$1);
  installDataZoomAction(registers);
  registers.registerSubTypeDefaulter("dataZoom", function() {
    return "slider";
  });
}
function install$k(registers) {
  registers.registerComponentModel(SelectZoomModel);
  registers.registerComponentView(SelectZoomView);
  installCommon$1(registers);
}
var ToolboxFeature = function() {
  function ToolboxFeature2() {
  }
  return ToolboxFeature2;
}();
var features = {};
function registerFeature(name, ctor) {
  features[name] = ctor;
}
function getFeature(name) {
  return features[name];
}
var ToolboxModel = function(_super) {
  __extends(ToolboxModel2, _super);
  function ToolboxModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ToolboxModel2.type;
    return _this;
  }
  ToolboxModel2.prototype.optionUpdated = function() {
    _super.prototype.optionUpdated.apply(this, arguments);
    var ecModel = this.ecModel;
    each$f(this.option.feature, function(featureOpt, featureName) {
      var Feature = getFeature(featureName);
      if (Feature) {
        if (Feature.getDefaultOption) {
          Feature.defaultOption = Feature.getDefaultOption(ecModel);
        }
        merge(featureOpt, Feature.defaultOption);
      }
    });
  };
  ToolboxModel2.type = "toolbox";
  ToolboxModel2.layoutMode = {
    type: "box",
    ignoreSize: true
  };
  ToolboxModel2.defaultOption = {
    show: true,
    z: 6,
    orient: "horizontal",
    left: "right",
    top: "top",
    backgroundColor: "transparent",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemSize: 15,
    itemGap: 8,
    showTitle: true,
    iconStyle: {
      borderColor: "#666",
      color: "none"
    },
    emphasis: {
      iconStyle: {
        borderColor: "#3E98C5"
      }
    },
    tooltip: {
      show: false,
      position: "bottom"
    }
  };
  return ToolboxModel2;
}(ComponentModel$1);
var ToolboxModel$1 = ToolboxModel;
function layout(group, componentModel, api) {
  var boxLayoutParams = componentModel.getBoxLayoutParams();
  var padding = componentModel.get("padding");
  var viewportSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var rect = getLayoutRect(boxLayoutParams, viewportSize, padding);
  box(componentModel.get("orient"), group, componentModel.get("itemGap"), rect.width, rect.height);
  positionElement(group, boxLayoutParams, viewportSize, padding);
}
function makeBackground(rect, componentModel) {
  var padding = normalizeCssArray(componentModel.get("padding"));
  var style = componentModel.getItemStyle(["color", "opacity"]);
  style.fill = componentModel.get("backgroundColor");
  rect = new Rect$3({
    shape: {
      x: rect.x - padding[3],
      y: rect.y - padding[0],
      width: rect.width + padding[1] + padding[3],
      height: rect.height + padding[0] + padding[2],
      r: componentModel.get("borderRadius")
    },
    style,
    silent: true,
    z2: -1
  });
  return rect;
}
var ToolboxView = function(_super) {
  __extends(ToolboxView2, _super);
  function ToolboxView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ToolboxView2.prototype.render = function(toolboxModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    if (!toolboxModel.get("show")) {
      return;
    }
    var itemSize = +toolboxModel.get("itemSize");
    var featureOpts = toolboxModel.get("feature") || {};
    var features2 = this._features || (this._features = {});
    var featureNames = [];
    each$f(featureOpts, function(opt, name) {
      featureNames.push(name);
    });
    new DataDiffer$1(this._featureNames || [], featureNames).add(processFeature).update(processFeature).remove(curry$1(processFeature, null)).execute();
    this._featureNames = featureNames;
    function processFeature(newIndex, oldIndex) {
      var featureName = featureNames[newIndex];
      var oldName = featureNames[oldIndex];
      var featureOpt = featureOpts[featureName];
      var featureModel = new Model$1(featureOpt, toolboxModel, toolboxModel.ecModel);
      var feature;
      if (payload && payload.newTitle != null && payload.featureName === featureName) {
        featureOpt.title = payload.newTitle;
      }
      if (featureName && !oldName) {
        if (isUserFeatureName(featureName)) {
          feature = {
            onclick: featureModel.option.onclick,
            featureName
          };
        } else {
          var Feature = getFeature(featureName);
          if (!Feature) {
            return;
          }
          feature = new Feature();
        }
        features2[featureName] = feature;
      } else {
        feature = features2[oldName];
        if (!feature) {
          return;
        }
      }
      feature.uid = getUID("toolbox-feature");
      feature.model = featureModel;
      feature.ecModel = ecModel;
      feature.api = api;
      var isToolboxFeature = feature instanceof ToolboxFeature;
      if (!featureName && oldName) {
        isToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
        return;
      }
      if (!featureModel.get("show") || isToolboxFeature && feature.unusable) {
        isToolboxFeature && feature.remove && feature.remove(ecModel, api);
        return;
      }
      createIconPaths(featureModel, feature, featureName);
      featureModel.setIconStatus = function(iconName, status) {
        var option = this.option;
        var iconPaths = this.iconPaths;
        option.iconStatus = option.iconStatus || {};
        option.iconStatus[iconName] = status;
        if (iconPaths[iconName]) {
          (status === "emphasis" ? enterEmphasis : leaveEmphasis)(iconPaths[iconName]);
        }
      };
      if (feature instanceof ToolboxFeature) {
        if (feature.render) {
          feature.render(featureModel, ecModel, api, payload);
        }
      }
    }
    function createIconPaths(featureModel, feature, featureName) {
      var iconStyleModel = featureModel.getModel("iconStyle");
      var iconStyleEmphasisModel = featureModel.getModel(["emphasis", "iconStyle"]);
      var icons = feature instanceof ToolboxFeature && feature.getIcons ? feature.getIcons() : featureModel.get("icon");
      var titles = featureModel.get("title") || {};
      var iconsMap;
      var titlesMap;
      if (isString(icons)) {
        iconsMap = {};
        iconsMap[featureName] = icons;
      } else {
        iconsMap = icons;
      }
      if (isString(titles)) {
        titlesMap = {};
        titlesMap[featureName] = titles;
      } else {
        titlesMap = titles;
      }
      var iconPaths = featureModel.iconPaths = {};
      each$f(iconsMap, function(iconStr, iconName) {
        var path = createIcon(iconStr, {}, {
          x: -itemSize / 2,
          y: -itemSize / 2,
          width: itemSize,
          height: itemSize
        });
        path.setStyle(iconStyleModel.getItemStyle());
        var pathEmphasisState = path.ensureState("emphasis");
        pathEmphasisState.style = iconStyleEmphasisModel.getItemStyle();
        var textContent = new ZRText$1({
          style: {
            text: titlesMap[iconName],
            align: iconStyleEmphasisModel.get("textAlign"),
            borderRadius: iconStyleEmphasisModel.get("textBorderRadius"),
            padding: iconStyleEmphasisModel.get("textPadding"),
            fill: null
          },
          ignore: true
        });
        path.setTextContent(textContent);
        setTooltipConfig({
          el: path,
          componentModel: toolboxModel,
          itemName: iconName,
          formatterParamsExtra: {
            title: titlesMap[iconName]
          }
        });
        path.__title = titlesMap[iconName];
        path.on("mouseover", function() {
          var hoverStyle = iconStyleEmphasisModel.getItemStyle();
          var defaultTextPosition = toolboxModel.get("orient") === "vertical" ? toolboxModel.get("right") == null ? "right" : "left" : toolboxModel.get("bottom") == null ? "bottom" : "top";
          textContent.setStyle({
            fill: iconStyleEmphasisModel.get("textFill") || hoverStyle.fill || hoverStyle.stroke || "#000",
            backgroundColor: iconStyleEmphasisModel.get("textBackgroundColor")
          });
          path.setTextConfig({
            position: iconStyleEmphasisModel.get("textPosition") || defaultTextPosition
          });
          textContent.ignore = !toolboxModel.get("showTitle");
          enterEmphasis(this);
        }).on("mouseout", function() {
          if (featureModel.get(["iconStatus", iconName]) !== "emphasis") {
            leaveEmphasis(this);
          }
          textContent.hide();
        });
        (featureModel.get(["iconStatus", iconName]) === "emphasis" ? enterEmphasis : leaveEmphasis)(path);
        group.add(path);
        path.on("click", bind$1(feature.onclick, feature, ecModel, api, iconName));
        iconPaths[iconName] = path;
      });
    }
    layout(group, toolboxModel, api);
    group.add(makeBackground(group.getBoundingRect(), toolboxModel));
    group.eachChild(function(icon) {
      var titleText = icon.__title;
      var emphasisState = icon.ensureState("emphasis");
      var emphasisTextConfig = emphasisState.textConfig || (emphasisState.textConfig = {});
      var textContent = icon.getTextContent();
      var emphasisTextState = textContent && textContent.states.emphasis;
      if (emphasisTextState && !isFunction(emphasisTextState) && titleText) {
        var emphasisTextStyle = emphasisTextState.style || (emphasisTextState.style = {});
        var rect = getBoundingRect(titleText, ZRText$1.makeFont(emphasisTextStyle));
        var offsetX = icon.x + group.x;
        var offsetY = icon.y + group.y + itemSize;
        var needPutOnTop = false;
        if (offsetY + rect.height > api.getHeight()) {
          emphasisTextConfig.position = "top";
          needPutOnTop = true;
        }
        var topOffset = needPutOnTop ? -5 - rect.height : itemSize + 8;
        if (offsetX + rect.width / 2 > api.getWidth()) {
          emphasisTextConfig.position = ["100%", topOffset];
          emphasisTextStyle.align = "right";
        } else if (offsetX - rect.width / 2 < 0) {
          emphasisTextConfig.position = [0, topOffset];
          emphasisTextStyle.align = "left";
        }
      }
    });
  };
  ToolboxView2.prototype.updateView = function(toolboxModel, ecModel, api, payload) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.updateView && feature.updateView(feature.model, ecModel, api, payload);
    });
  };
  ToolboxView2.prototype.remove = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.remove && feature.remove(ecModel, api);
    });
    this.group.removeAll();
  };
  ToolboxView2.prototype.dispose = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
    });
  };
  ToolboxView2.type = "toolbox";
  return ToolboxView2;
}(ComponentView$1);
function isUserFeatureName(featureName) {
  return featureName.indexOf("my") === 0;
}
var ToolboxView$1 = ToolboxView;
var SaveAsImage = function(_super) {
  __extends(SaveAsImage2, _super);
  function SaveAsImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SaveAsImage2.prototype.onclick = function(ecModel, api) {
    var model = this.model;
    var title = model.get("name") || ecModel.get("title.0.text") || "echarts";
    var isSvg = api.getZr().painter.getType() === "svg";
    var type4 = isSvg ? "svg" : model.get("type", true) || "png";
    var url2 = api.getConnectedDataURL({
      type: type4,
      backgroundColor: model.get("backgroundColor", true) || ecModel.get("backgroundColor") || "#fff",
      connectedBackgroundColor: model.get("connectedBackgroundColor"),
      excludeComponents: model.get("excludeComponents"),
      pixelRatio: model.get("pixelRatio")
    });
    var browser = env$1.browser;
    if (isFunction(MouseEvent) && (browser.newEdge || !browser.ie && !browser.edge)) {
      var $a = document.createElement("a");
      $a.download = title + "." + type4;
      $a.target = "_blank";
      $a.href = url2;
      var evt = new MouseEvent("click", {
        view: document.defaultView,
        bubbles: true,
        cancelable: false
      });
      $a.dispatchEvent(evt);
    } else {
      if (window.navigator.msSaveOrOpenBlob || isSvg) {
        var parts = url2.split(",");
        var base64Encoded = parts[0].indexOf("base64") > -1;
        var bstr = isSvg ? decodeURIComponent(parts[1]) : parts[1];
        base64Encoded && (bstr = window.atob(bstr));
        var filename = title + "." + type4;
        if (window.navigator.msSaveOrOpenBlob) {
          var n2 = bstr.length;
          var u8arr = new Uint8Array(n2);
          while (n2--) {
            u8arr[n2] = bstr.charCodeAt(n2);
          }
          var blob = new Blob([u8arr]);
          window.navigator.msSaveOrOpenBlob(blob, filename);
        } else {
          var frame = document.createElement("iframe");
          document.body.appendChild(frame);
          var cw = frame.contentWindow;
          var doc = cw.document;
          doc.open("image/svg+xml", "replace");
          doc.write(bstr);
          doc.close();
          cw.focus();
          doc.execCommand("SaveAs", true, filename);
          document.body.removeChild(frame);
        }
      } else {
        var lang = model.get("lang");
        var html = '<body style="margin:0;"><img src="' + url2 + '" style="max-width:100%;" title="' + (lang && lang[0] || "") + '" /></body>';
        var tab = window.open();
        tab.document.write(html);
        tab.document.title = title;
      }
    }
  };
  SaveAsImage2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0",
      title: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "title"]),
      type: "png",
      connectedBackgroundColor: "#fff",
      name: "",
      excludeComponents: ["toolbox"],
      lang: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "lang"])
    };
    return defaultOption2;
  };
  return SaveAsImage2;
}(ToolboxFeature);
var SaveAsImage$1 = SaveAsImage;
var INNER_STACK_KEYWORD = "__ec_magicType_stack__";
var radioTypes = [["line", "bar"], ["stack"]];
var MagicType = function(_super) {
  __extends(MagicType2, _super);
  function MagicType2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  MagicType2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon");
    var icons = {};
    each$f(model.get("type"), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  MagicType2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: [],
      icon: {
        line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4",
        bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7",
        stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "magicType", "title"]),
      option: {},
      seriesIndex: {}
    };
    return defaultOption2;
  };
  MagicType2.prototype.onclick = function(ecModel, api, type4) {
    var model = this.model;
    var seriesIndex = model.get(["seriesIndex", type4]);
    if (!seriesOptGenreator[type4]) {
      return;
    }
    var newOption = {
      series: []
    };
    var generateNewSeriesTypes = function(seriesModel) {
      var seriesType2 = seriesModel.subType;
      var seriesId = seriesModel.id;
      var newSeriesOpt = seriesOptGenreator[type4](seriesType2, seriesId, seriesModel, model);
      if (newSeriesOpt) {
        defaults(newSeriesOpt, seriesModel.option);
        newOption.series.push(newSeriesOpt);
      }
      var coordSys = seriesModel.coordinateSystem;
      if (coordSys && coordSys.type === "cartesian2d" && (type4 === "line" || type4 === "bar")) {
        var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
        if (categoryAxis2) {
          var axisDim = categoryAxis2.dim;
          var axisType = axisDim + "Axis";
          var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
          var axisIndex = axisModel.componentIndex;
          newOption[axisType] = newOption[axisType] || [];
          for (var i = 0; i <= axisIndex; i++) {
            newOption[axisType][axisIndex] = newOption[axisType][axisIndex] || {};
          }
          newOption[axisType][axisIndex].boundaryGap = type4 === "bar";
        }
      }
    };
    each$f(radioTypes, function(radio) {
      if (indexOf(radio, type4) >= 0) {
        each$f(radio, function(item) {
          model.setIconStatus(item, "normal");
        });
      }
    });
    model.setIconStatus(type4, "emphasis");
    ecModel.eachComponent({
      mainType: "series",
      query: seriesIndex == null ? null : {
        seriesIndex
      }
    }, generateNewSeriesTypes);
    var newTitle;
    var currentType = type4;
    if (type4 === "stack") {
      newTitle = merge({
        stack: model.option.title.tiled,
        tiled: model.option.title.stack
      }, model.option.title);
      if (model.get(["iconStatus", type4]) !== "emphasis") {
        currentType = "tiled";
      }
    }
    api.dispatchAction({
      type: "changeMagicType",
      currentType,
      newOption,
      newTitle,
      featureName: "magicType"
    });
  };
  return MagicType2;
}(ToolboxFeature);
var seriesOptGenreator = {
  "line": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "bar") {
      return merge({
        id: seriesId,
        type: "line",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "line"]) || {}, true);
    }
  },
  "bar": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "line") {
      return merge({
        id: seriesId,
        type: "bar",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "bar"]) || {}, true);
    }
  },
  "stack": function(seriesType2, seriesId, seriesModel, model) {
    var isStack = seriesModel.get("stack") === INNER_STACK_KEYWORD;
    if (seriesType2 === "line" || seriesType2 === "bar") {
      model.setIconStatus("stack", isStack ? "normal" : "emphasis");
      return merge({
        id: seriesId,
        stack: isStack ? "" : INNER_STACK_KEYWORD
      }, model.get(["option", "stack"]) || {}, true);
    }
  }
};
registerAction({
  type: "changeMagicType",
  event: "magicTypeChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.mergeOption(payload.newOption);
});
var MagicType$1 = MagicType;
var BLOCK_SPLITER = new Array(60).join("-");
var ITEM_SPLITER = "	";
function groupSeries(ecModel) {
  var seriesGroupByCategoryAxis = {};
  var otherSeries = [];
  var meta = [];
  ecModel.eachRawSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && (coordSys.type === "cartesian2d" || coordSys.type === "polar")) {
      var baseAxis = coordSys.getBaseAxis();
      if (baseAxis.type === "category") {
        var key = baseAxis.dim + "_" + baseAxis.index;
        if (!seriesGroupByCategoryAxis[key]) {
          seriesGroupByCategoryAxis[key] = {
            categoryAxis: baseAxis,
            valueAxis: coordSys.getOtherAxis(baseAxis),
            series: []
          };
          meta.push({
            axisDim: baseAxis.dim,
            axisIndex: baseAxis.index
          });
        }
        seriesGroupByCategoryAxis[key].series.push(seriesModel);
      } else {
        otherSeries.push(seriesModel);
      }
    } else {
      otherSeries.push(seriesModel);
    }
  });
  return {
    seriesGroupByCategoryAxis,
    other: otherSeries,
    meta
  };
}
function assembleSeriesWithCategoryAxis(groups) {
  var tables = [];
  each$f(groups, function(group, key) {
    var categoryAxis2 = group.categoryAxis;
    var valueAxis2 = group.valueAxis;
    var valueAxisDim = valueAxis2.dim;
    var headers = [" "].concat(map$1(group.series, function(series) {
      return series.name;
    }));
    var columns = [categoryAxis2.model.getCategories()];
    each$f(group.series, function(series) {
      var rawData = series.getRawData();
      columns.push(series.getRawData().mapArray(rawData.mapDimension(valueAxisDim), function(val) {
        return val;
      }));
    });
    var lines = [headers.join(ITEM_SPLITER)];
    for (var i = 0; i < columns[0].length; i++) {
      var items = [];
      for (var j = 0; j < columns.length; j++) {
        items.push(columns[j][i]);
      }
      lines.push(items.join(ITEM_SPLITER));
    }
    tables.push(lines.join("\n"));
  });
  return tables.join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function assembleOtherSeries(series) {
  return map$1(series, function(series2) {
    var data = series2.getRawData();
    var lines = [series2.name];
    var vals = [];
    data.each(data.dimensions, function() {
      var argLen = arguments.length;
      var dataIndex = arguments[argLen - 1];
      var name = data.getName(dataIndex);
      for (var i = 0; i < argLen - 1; i++) {
        vals[i] = arguments[i];
      }
      lines.push((name ? name + ITEM_SPLITER : "") + vals.join(ITEM_SPLITER));
    });
    return lines.join("\n");
  }).join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function getContentFromModel(ecModel) {
  var result = groupSeries(ecModel);
  return {
    value: filter([assembleSeriesWithCategoryAxis(result.seriesGroupByCategoryAxis), assembleOtherSeries(result.other)], function(str) {
      return !!str.replace(/[\n\t\s]/g, "");
    }).join("\n\n" + BLOCK_SPLITER + "\n\n"),
    meta: result.meta
  };
}
function trim(str) {
  return str.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function isTSVFormat(block) {
  var firstLine = block.slice(0, block.indexOf("\n"));
  if (firstLine.indexOf(ITEM_SPLITER) >= 0) {
    return true;
  }
}
var itemSplitRegex = new RegExp("[" + ITEM_SPLITER + "]+", "g");
function parseTSVContents(tsv) {
  var tsvLines = tsv.split(/\n+/g);
  var headers = trim(tsvLines.shift()).split(itemSplitRegex);
  var categories = [];
  var series = map$1(headers, function(header) {
    return {
      name: header,
      data: []
    };
  });
  for (var i = 0; i < tsvLines.length; i++) {
    var items = trim(tsvLines[i]).split(itemSplitRegex);
    categories.push(items.shift());
    for (var j = 0; j < items.length; j++) {
      series[j] && (series[j].data[i] = items[j]);
    }
  }
  return {
    series,
    categories
  };
}
function parseListContents(str) {
  var lines = str.split(/\n+/g);
  var seriesName = trim(lines.shift());
  var data = [];
  for (var i = 0; i < lines.length; i++) {
    var line = trim(lines[i]);
    if (!line) {
      continue;
    }
    var items = line.split(itemSplitRegex);
    var name_1 = "";
    var value = void 0;
    var hasName = false;
    if (isNaN(items[0])) {
      hasName = true;
      name_1 = items[0];
      items = items.slice(1);
      data[i] = {
        name: name_1,
        value: []
      };
      value = data[i].value;
    } else {
      value = data[i] = [];
    }
    for (var j = 0; j < items.length; j++) {
      value.push(+items[j]);
    }
    if (value.length === 1) {
      hasName ? data[i].value = value[0] : data[i] = value[0];
    }
  }
  return {
    name: seriesName,
    data
  };
}
function parseContents(str, blockMetaList) {
  var blocks = str.split(new RegExp("\n*" + BLOCK_SPLITER + "\n*", "g"));
  var newOption = {
    series: []
  };
  each$f(blocks, function(block, idx) {
    if (isTSVFormat(block)) {
      var result = parseTSVContents(block);
      var blockMeta = blockMetaList[idx];
      var axisKey = blockMeta.axisDim + "Axis";
      if (blockMeta) {
        newOption[axisKey] = newOption[axisKey] || [];
        newOption[axisKey][blockMeta.axisIndex] = {
          data: result.categories
        };
        newOption.series = newOption.series.concat(result.series);
      }
    } else {
      var result = parseListContents(block);
      newOption.series.push(result);
    }
  });
  return newOption;
}
var DataView = function(_super) {
  __extends(DataView2, _super);
  function DataView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataView2.prototype.onclick = function(ecModel, api) {
    setTimeout(function() {
      api.dispatchAction({
        type: "hideTip"
      });
    });
    var container2 = api.getDom();
    var model = this.model;
    if (this._dom) {
      container2.removeChild(this._dom);
    }
    var root2 = document.createElement("div");
    root2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px";
    root2.style.backgroundColor = model.get("backgroundColor") || "#fff";
    var header = document.createElement("h4");
    var lang = model.get("lang") || [];
    header.innerHTML = lang[0] || model.get("title");
    header.style.cssText = "margin:10px 20px";
    header.style.color = model.get("textColor");
    var viewMain = document.createElement("div");
    var textarea = document.createElement("textarea");
    viewMain.style.cssText = "overflow:auto";
    var optionToContent = model.get("optionToContent");
    var contentToOption = model.get("contentToOption");
    var result = getContentFromModel(ecModel);
    if (isFunction(optionToContent)) {
      var htmlOrDom = optionToContent(api.getOption());
      if (isString(htmlOrDom)) {
        viewMain.innerHTML = htmlOrDom;
      } else if (isDom(htmlOrDom)) {
        viewMain.appendChild(htmlOrDom);
      }
    } else {
      textarea.readOnly = model.get("readOnly");
      var style = textarea.style;
      style.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none";
      style.color = model.get("textColor");
      style.borderColor = model.get("textareaBorderColor");
      style.backgroundColor = model.get("textareaColor");
      textarea.value = result.value;
      viewMain.appendChild(textarea);
    }
    var blockMetaList = result.meta;
    var buttonContainer = document.createElement("div");
    buttonContainer.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
    var buttonStyle = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px";
    var closeButton = document.createElement("div");
    var refreshButton = document.createElement("div");
    buttonStyle += ";background-color:" + model.get("buttonColor");
    buttonStyle += ";color:" + model.get("buttonTextColor");
    var self2 = this;
    function close() {
      container2.removeChild(root2);
      self2._dom = null;
    }
    addEventListener(closeButton, "click", close);
    addEventListener(refreshButton, "click", function() {
      if (contentToOption == null && optionToContent != null || contentToOption != null && optionToContent == null) {
        close();
        return;
      }
      var newOption;
      try {
        if (isFunction(contentToOption)) {
          newOption = contentToOption(viewMain, api.getOption());
        } else {
          newOption = parseContents(textarea.value, blockMetaList);
        }
      } catch (e2) {
        close();
        throw new Error("Data view format error " + e2);
      }
      if (newOption) {
        api.dispatchAction({
          type: "changeDataView",
          newOption
        });
      }
      close();
    });
    closeButton.innerHTML = lang[1];
    refreshButton.innerHTML = lang[2];
    refreshButton.style.cssText = closeButton.style.cssText = buttonStyle;
    !model.get("readOnly") && buttonContainer.appendChild(refreshButton);
    buttonContainer.appendChild(closeButton);
    root2.appendChild(header);
    root2.appendChild(viewMain);
    root2.appendChild(buttonContainer);
    viewMain.style.height = container2.clientHeight - 80 + "px";
    container2.appendChild(root2);
    this._dom = root2;
  };
  DataView2.prototype.remove = function(ecModel, api) {
    this._dom && api.getDom().removeChild(this._dom);
  };
  DataView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  DataView2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      readOnly: false,
      optionToContent: null,
      contentToOption: null,
      icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28",
      title: ecModel.getLocaleModel().get(["toolbox", "dataView", "title"]),
      lang: ecModel.getLocaleModel().get(["toolbox", "dataView", "lang"]),
      backgroundColor: "#fff",
      textColor: "#000",
      textareaColor: "#fff",
      textareaBorderColor: "#333",
      buttonColor: "#c23531",
      buttonTextColor: "#fff"
    };
    return defaultOption2;
  };
  return DataView2;
}(ToolboxFeature);
function tryMergeDataOption(newData, originalData) {
  return map$1(newData, function(newVal, idx) {
    var original = originalData && originalData[idx];
    if (isObject$4(original) && !isArray$1(original)) {
      var newValIsObject = isObject$4(newVal) && !isArray$1(newVal);
      if (!newValIsObject) {
        newVal = {
          value: newVal
        };
      }
      var shouldDeleteName = original.name != null && newVal.name == null;
      newVal = defaults(newVal, original);
      shouldDeleteName && delete newVal.name;
      return newVal;
    } else {
      return newVal;
    }
  });
}
registerAction({
  type: "changeDataView",
  event: "dataViewChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  var newSeriesOptList = [];
  each$f(payload.newOption.series, function(seriesOpt) {
    var seriesModel = ecModel.getSeriesByName(seriesOpt.name)[0];
    if (!seriesModel) {
      newSeriesOptList.push(extend({
        type: "scatter"
      }, seriesOpt));
    } else {
      var originalData = seriesModel.get("data");
      newSeriesOptList.push({
        name: seriesOpt.name,
        data: tryMergeDataOption(seriesOpt.data, originalData)
      });
    }
  });
  ecModel.mergeOption(defaults({
    series: newSeriesOptList
  }, payload.newOption));
});
var DataView$1 = DataView;
var each$6 = each$f;
var inner$6 = makeInner();
function push(ecModel, newSnapshot) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  each$6(newSnapshot, function(batchItem, dataZoomId) {
    var i = storedSnapshots.length - 1;
    for (; i >= 0; i--) {
      var snapshot = storedSnapshots[i];
      if (snapshot[dataZoomId]) {
        break;
      }
    }
    if (i < 0) {
      var dataZoomModel = ecModel.queryComponents({
        mainType: "dataZoom",
        subType: "select",
        id: dataZoomId
      })[0];
      if (dataZoomModel) {
        var percentRange = dataZoomModel.getPercentRange();
        storedSnapshots[0][dataZoomId] = {
          dataZoomId,
          start: percentRange[0],
          end: percentRange[1]
        };
      }
    }
  });
  storedSnapshots.push(newSnapshot);
}
function pop(ecModel) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  var head = storedSnapshots[storedSnapshots.length - 1];
  storedSnapshots.length > 1 && storedSnapshots.pop();
  var snapshot = {};
  each$6(head, function(batchItem, dataZoomId) {
    for (var i = storedSnapshots.length - 1; i >= 0; i--) {
      batchItem = storedSnapshots[i][dataZoomId];
      if (batchItem) {
        snapshot[dataZoomId] = batchItem;
        break;
      }
    }
  });
  return snapshot;
}
function clear(ecModel) {
  inner$6(ecModel).snapshots = null;
}
function count(ecModel) {
  return getStoreSnapshots(ecModel).length;
}
function getStoreSnapshots(ecModel) {
  var store = inner$6(ecModel);
  if (!store.snapshots) {
    store.snapshots = [{}];
  }
  return store.snapshots;
}
var RestoreOption = function(_super) {
  __extends(RestoreOption2, _super);
  function RestoreOption2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  RestoreOption2.prototype.onclick = function(ecModel, api) {
    clear(ecModel);
    api.dispatchAction({
      type: "restore",
      from: this.uid
    });
  };
  RestoreOption2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5",
      title: ecModel.getLocaleModel().get(["toolbox", "restore", "title"])
    };
    return defaultOption2;
  };
  return RestoreOption2;
}(ToolboxFeature);
registerAction({
  type: "restore",
  event: "restore",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.resetOption("recreate");
});
var Restore = RestoreOption;
var INCLUDE_FINDER_MAIN_TYPES = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"];
var BrushTargetManager = function() {
  function BrushTargetManager2(finder, ecModel, opt) {
    var _this = this;
    this._targetInfoList = [];
    var foundCpts = parseFinder(ecModel, finder);
    each$f(targetInfoBuilders, function(builder, type4) {
      if (!opt || !opt.include || indexOf(opt.include, type4) >= 0) {
        builder(foundCpts, _this._targetInfoList);
      }
    });
  }
  BrushTargetManager2.prototype.setOutputRanges = function(areas, ecModel) {
    this.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      (area.coordRanges || (area.coordRanges = [])).push(coordRange);
      if (!area.coordRange) {
        area.coordRange = coordRange;
        var result = coordConvert[area.brushType](0, coordSys, coordRange);
        area.__rangeOffset = {
          offset: diffProcessor[area.brushType](result.values, area.range, [1, 1]),
          xyMinMax: result.xyMinMax
        };
      }
    });
    return areas;
  };
  BrushTargetManager2.prototype.matchOutputRanges = function(areas, ecModel, cb) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      if (targetInfo && targetInfo !== true) {
        each$f(targetInfo.coordSyses, function(coordSys) {
          var result = coordConvert[area.brushType](1, coordSys, area.range, true);
          cb(area, result.values, coordSys, ecModel);
        });
      }
    }, this);
  };
  BrushTargetManager2.prototype.setInputRanges = function(areas, ecModel) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      area.range = area.range || [];
      if (targetInfo && targetInfo !== true) {
        area.panelId = targetInfo.panelId;
        var result = coordConvert[area.brushType](0, targetInfo.coordSys, area.coordRange);
        var rangeOffset = area.__rangeOffset;
        area.range = rangeOffset ? diffProcessor[area.brushType](result.values, rangeOffset.offset, getScales(result.xyMinMax, rangeOffset.xyMinMax)) : result.values;
      }
    }, this);
  };
  BrushTargetManager2.prototype.makePanelOpts = function(api, getDefaultBrushType) {
    return map$1(this._targetInfoList, function(targetInfo) {
      var rect = targetInfo.getPanelRect();
      return {
        panelId: targetInfo.panelId,
        defaultBrushType: getDefaultBrushType ? getDefaultBrushType(targetInfo) : null,
        clipPath: makeRectPanelClipPath(rect),
        isTargetByCursor: makeRectIsTargetByCursor(rect, api, targetInfo.coordSysModel),
        getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect)
      };
    });
  };
  BrushTargetManager2.prototype.controlSeries = function(area, seriesModel, ecModel) {
    var targetInfo = this.findTargetInfo(area, ecModel);
    return targetInfo === true || targetInfo && indexOf(targetInfo.coordSyses, seriesModel.coordinateSystem) >= 0;
  };
  BrushTargetManager2.prototype.findTargetInfo = function(area, ecModel) {
    var targetInfoList = this._targetInfoList;
    var foundCpts = parseFinder(ecModel, area);
    for (var i = 0; i < targetInfoList.length; i++) {
      var targetInfo = targetInfoList[i];
      var areaPanelId = area.panelId;
      if (areaPanelId) {
        if (targetInfo.panelId === areaPanelId) {
          return targetInfo;
        }
      } else {
        for (var j = 0; j < targetInfoMatchers.length; j++) {
          if (targetInfoMatchers[j](foundCpts, targetInfo)) {
            return targetInfo;
          }
        }
      }
    }
    return true;
  };
  return BrushTargetManager2;
}();
function formatMinMax(minMax) {
  minMax[0] > minMax[1] && minMax.reverse();
  return minMax;
}
function parseFinder(ecModel, finder) {
  return parseFinder$1(ecModel, finder, {
    includeMainTypes: INCLUDE_FINDER_MAIN_TYPES
  });
}
var targetInfoBuilders = {
  grid: function(foundCpts, targetInfoList) {
    var xAxisModels = foundCpts.xAxisModels;
    var yAxisModels = foundCpts.yAxisModels;
    var gridModels = foundCpts.gridModels;
    var gridModelMap = createHashMap();
    var xAxesHas = {};
    var yAxesHas = {};
    if (!xAxisModels && !yAxisModels && !gridModels) {
      return;
    }
    each$f(xAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
    });
    each$f(yAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      yAxesHas[gridModel.id] = true;
    });
    each$f(gridModels, function(gridModel) {
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
      yAxesHas[gridModel.id] = true;
    });
    gridModelMap.each(function(gridModel) {
      var grid = gridModel.coordinateSystem;
      var cartesians = [];
      each$f(grid.getCartesians(), function(cartesian, index2) {
        if (indexOf(xAxisModels, cartesian.getAxis("x").model) >= 0 || indexOf(yAxisModels, cartesian.getAxis("y").model) >= 0) {
          cartesians.push(cartesian);
        }
      });
      targetInfoList.push({
        panelId: "grid--" + gridModel.id,
        gridModel,
        coordSysModel: gridModel,
        coordSys: cartesians[0],
        coordSyses: cartesians,
        getPanelRect: panelRectBuilders.grid,
        xAxisDeclared: xAxesHas[gridModel.id],
        yAxisDeclared: yAxesHas[gridModel.id]
      });
    });
  },
  geo: function(foundCpts, targetInfoList) {
    each$f(foundCpts.geoModels, function(geoModel) {
      var coordSys = geoModel.coordinateSystem;
      targetInfoList.push({
        panelId: "geo--" + geoModel.id,
        geoModel,
        coordSysModel: geoModel,
        coordSys,
        coordSyses: [coordSys],
        getPanelRect: panelRectBuilders.geo
      });
    });
  }
};
var targetInfoMatchers = [
  function(foundCpts, targetInfo) {
    var xAxisModel = foundCpts.xAxisModel;
    var yAxisModel = foundCpts.yAxisModel;
    var gridModel = foundCpts.gridModel;
    !gridModel && xAxisModel && (gridModel = xAxisModel.axis.grid.model);
    !gridModel && yAxisModel && (gridModel = yAxisModel.axis.grid.model);
    return gridModel && gridModel === targetInfo.gridModel;
  },
  function(foundCpts, targetInfo) {
    var geoModel = foundCpts.geoModel;
    return geoModel && geoModel === targetInfo.geoModel;
  }
];
var panelRectBuilders = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var coordSys = this.coordSys;
    var rect = coordSys.getBoundingRect().clone();
    rect.applyTransform(getTransform$1(coordSys));
    return rect;
  }
};
var coordConvert = {
  lineX: curry$1(axisConvert, 0),
  lineY: curry$1(axisConvert, 1),
  rect: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xminymin = to ? coordSys.pointToData([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2);
    var xmaxymax = to ? coordSys.pointToData([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2);
    var values = [formatMinMax([xminymin[0], xmaxymax[0]]), formatMinMax([xminymin[1], xmaxymax[1]])];
    return {
      values,
      xyMinMax: values
    };
  },
  polygon: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xyMinMax = [[Infinity, -Infinity], [Infinity, -Infinity]];
    var values = map$1(rangeOrCoordRange, function(item) {
      var p2 = to ? coordSys.pointToData(item, clamp2) : coordSys.dataToPoint(item, clamp2);
      xyMinMax[0][0] = Math.min(xyMinMax[0][0], p2[0]);
      xyMinMax[1][0] = Math.min(xyMinMax[1][0], p2[1]);
      xyMinMax[0][1] = Math.max(xyMinMax[0][1], p2[0]);
      xyMinMax[1][1] = Math.max(xyMinMax[1][1], p2[1]);
      return p2;
    });
    return {
      values,
      xyMinMax
    };
  }
};
function axisConvert(axisNameIndex, to, coordSys, rangeOrCoordRange) {
  var axis = coordSys.getAxis(["x", "y"][axisNameIndex]);
  var values = formatMinMax(map$1([0, 1], function(i) {
    return to ? axis.coordToData(axis.toLocalCoord(rangeOrCoordRange[i]), true) : axis.toGlobalCoord(axis.dataToCoord(rangeOrCoordRange[i]));
  }));
  var xyMinMax = [];
  xyMinMax[axisNameIndex] = values;
  xyMinMax[1 - axisNameIndex] = [NaN, NaN];
  return {
    values,
    xyMinMax
  };
}
var diffProcessor = {
  lineX: curry$1(axisDiffProcessor, 0),
  lineY: curry$1(axisDiffProcessor, 1),
  rect: function(values, refer, scales) {
    return [[values[0][0] - scales[0] * refer[0][0], values[0][1] - scales[0] * refer[0][1]], [values[1][0] - scales[1] * refer[1][0], values[1][1] - scales[1] * refer[1][1]]];
  },
  polygon: function(values, refer, scales) {
    return map$1(values, function(item, idx) {
      return [item[0] - scales[0] * refer[idx][0], item[1] - scales[1] * refer[idx][1]];
    });
  }
};
function axisDiffProcessor(axisNameIndex, values, refer, scales) {
  return [values[0] - scales[axisNameIndex] * refer[0], values[1] - scales[axisNameIndex] * refer[1]];
}
function getScales(xyMinMaxCurr, xyMinMaxOrigin) {
  var sizeCurr = getSize(xyMinMaxCurr);
  var sizeOrigin = getSize(xyMinMaxOrigin);
  var scales = [sizeCurr[0] / sizeOrigin[0], sizeCurr[1] / sizeOrigin[1]];
  isNaN(scales[0]) && (scales[0] = 1);
  isNaN(scales[1]) && (scales[1] = 1);
  return scales;
}
function getSize(xyMinMax) {
  return xyMinMax ? [xyMinMax[0][1] - xyMinMax[0][0], xyMinMax[1][1] - xyMinMax[1][0]] : [NaN, NaN];
}
var BrushTargetManager$1 = BrushTargetManager;
var each$5 = each$f;
var DATA_ZOOM_ID_BASE = makeInternalComponentId("toolbox-dataZoom_");
var DataZoomFeature = function(_super) {
  __extends(DataZoomFeature2, _super);
  function DataZoomFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataZoomFeature2.prototype.render = function(featureModel, ecModel, api, payload) {
    if (!this._brushController) {
      this._brushController = new BrushController$1(api.getZr());
      this._brushController.on("brush", bind$1(this._onBrush, this)).mount();
    }
    updateZoomBtnStatus(featureModel, ecModel, this, payload, api);
    updateBackBtnStatus(featureModel, ecModel);
  };
  DataZoomFeature2.prototype.onclick = function(ecModel, api, type4) {
    handlers[type4].call(this);
  };
  DataZoomFeature2.prototype.remove = function(ecModel, api) {
    this._brushController && this._brushController.unmount();
  };
  DataZoomFeature2.prototype.dispose = function(ecModel, api) {
    this._brushController && this._brushController.dispose();
  };
  DataZoomFeature2.prototype._onBrush = function(eventParam) {
    var areas = eventParam.areas;
    if (!eventParam.isEnd || !areas.length) {
      return;
    }
    var snapshot = {};
    var ecModel = this.ecModel;
    this._brushController.updateCovers([]);
    var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(this.model), ecModel, {
      include: ["grid"]
    });
    brushTargetManager.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      if (coordSys.type !== "cartesian2d") {
        return;
      }
      var brushType = area.brushType;
      if (brushType === "rect") {
        setBatch("x", coordSys, coordRange[0]);
        setBatch("y", coordSys, coordRange[1]);
      } else {
        setBatch({
          lineX: "x",
          lineY: "y"
        }[brushType], coordSys, coordRange);
      }
    });
    push(ecModel, snapshot);
    this._dispatchZoomAction(snapshot);
    function setBatch(dimName, coordSys, minMax) {
      var axis = coordSys.getAxis(dimName);
      var axisModel = axis.model;
      var dataZoomModel = findDataZoom(dimName, axisModel, ecModel);
      var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy(axisModel).getMinMaxSpan();
      if (minMaxSpan.minValueSpan != null || minMaxSpan.maxValueSpan != null) {
        minMax = sliderMove(0, minMax.slice(), axis.scale.getExtent(), 0, minMaxSpan.minValueSpan, minMaxSpan.maxValueSpan);
      }
      dataZoomModel && (snapshot[dataZoomModel.id] = {
        dataZoomId: dataZoomModel.id,
        startValue: minMax[0],
        endValue: minMax[1]
      });
    }
    function findDataZoom(dimName, axisModel, ecModel2) {
      var found;
      ecModel2.eachComponent({
        mainType: "dataZoom",
        subType: "select"
      }, function(dzModel) {
        var has2 = dzModel.getAxisModel(dimName, axisModel.componentIndex);
        has2 && (found = dzModel);
      });
      return found;
    }
  };
  DataZoomFeature2.prototype._dispatchZoomAction = function(snapshot) {
    var batch = [];
    each$5(snapshot, function(batchItem, dataZoomId) {
      batch.push(clone$4(batchItem));
    });
    batch.length && this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      batch
    });
  };
  DataZoomFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      filterMode: "filter",
      icon: {
        zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1",
        back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "dataZoom", "title"]),
      brushStyle: {
        borderWidth: 0,
        color: "rgba(210,219,238,0.2)"
      }
    };
    return defaultOption2;
  };
  return DataZoomFeature2;
}(ToolboxFeature);
var handlers = {
  zoom: function() {
    var nextActive = !this._isZoomActive;
    this.api.dispatchAction({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      dataZoomSelectActive: nextActive
    });
  },
  back: function() {
    this._dispatchZoomAction(pop(this.ecModel));
  }
};
function makeAxisFinder(dzFeatureModel) {
  var setting = {
    xAxisIndex: dzFeatureModel.get("xAxisIndex", true),
    yAxisIndex: dzFeatureModel.get("yAxisIndex", true),
    xAxisId: dzFeatureModel.get("xAxisId", true),
    yAxisId: dzFeatureModel.get("yAxisId", true)
  };
  if (setting.xAxisIndex == null && setting.xAxisId == null) {
    setting.xAxisIndex = "all";
  }
  if (setting.yAxisIndex == null && setting.yAxisId == null) {
    setting.yAxisIndex = "all";
  }
  return setting;
}
function updateBackBtnStatus(featureModel, ecModel) {
  featureModel.setIconStatus("back", count(ecModel) > 1 ? "emphasis" : "normal");
}
function updateZoomBtnStatus(featureModel, ecModel, view, payload, api) {
  var zoomActive = view._isZoomActive;
  if (payload && payload.type === "takeGlobalCursor") {
    zoomActive = payload.key === "dataZoomSelect" ? payload.dataZoomSelectActive : false;
  }
  view._isZoomActive = zoomActive;
  featureModel.setIconStatus("zoom", zoomActive ? "emphasis" : "normal");
  var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(featureModel), ecModel, {
    include: ["grid"]
  });
  var panels = brushTargetManager.makePanelOpts(api, function(targetInfo) {
    return targetInfo.xAxisDeclared && !targetInfo.yAxisDeclared ? "lineX" : !targetInfo.xAxisDeclared && targetInfo.yAxisDeclared ? "lineY" : "rect";
  });
  view._brushController.setPanels(panels).enableBrush(zoomActive && panels.length ? {
    brushType: "auto",
    brushStyle: featureModel.getModel("brushStyle").getItemStyle()
  } : false);
}
registerInternalOptionCreator("dataZoom", function(ecModel) {
  var toolboxModel = ecModel.getComponent("toolbox", 0);
  var featureDataZoomPath = ["feature", "dataZoom"];
  if (!toolboxModel || toolboxModel.get(featureDataZoomPath) == null) {
    return;
  }
  var dzFeatureModel = toolboxModel.getModel(featureDataZoomPath);
  var dzOptions = [];
  var finder = makeAxisFinder(dzFeatureModel);
  var finderResult = parseFinder$1(ecModel, finder);
  each$5(finderResult.xAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "xAxis", "xAxisIndex");
  });
  each$5(finderResult.yAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "yAxis", "yAxisIndex");
  });
  function buildInternalOptions(axisModel, axisMainType, axisIndexPropName) {
    var axisIndex = axisModel.componentIndex;
    var newOpt = {
      type: "select",
      $fromToolbox: true,
      filterMode: dzFeatureModel.get("filterMode", true) || "filter",
      id: DATA_ZOOM_ID_BASE + axisMainType + axisIndex
    };
    newOpt[axisIndexPropName] = axisIndex;
    dzOptions.push(newOpt);
  }
  return dzOptions;
});
var DataZoom = DataZoomFeature;
function install$j(registers) {
  registers.registerComponentModel(ToolboxModel$1);
  registers.registerComponentView(ToolboxView$1);
  registerFeature("saveAsImage", SaveAsImage$1);
  registerFeature("magicType", MagicType$1);
  registerFeature("dataView", DataView$1);
  registerFeature("dataZoom", DataZoom);
  registerFeature("restore", Restore);
  use(install$k);
}
var TooltipModel = function(_super) {
  __extends(TooltipModel2, _super);
  function TooltipModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipModel2.type;
    return _this;
  }
  TooltipModel2.type = "tooltip";
  TooltipModel2.dependencies = ["axisPointer"];
  TooltipModel2.defaultOption = {
    z: 60,
    show: true,
    showContent: true,
    trigger: "item",
    triggerOn: "mousemove|click",
    alwaysShowContent: false,
    displayMode: "single",
    renderMode: "auto",
    confine: null,
    showDelay: 0,
    hideDelay: 100,
    transitionDuration: 0.4,
    enterable: false,
    backgroundColor: "#fff",
    shadowBlur: 10,
    shadowColor: "rgba(0, 0, 0, .2)",
    shadowOffsetX: 1,
    shadowOffsetY: 2,
    borderRadius: 4,
    borderWidth: 1,
    padding: null,
    extraCssText: "",
    axisPointer: {
      type: "line",
      axis: "auto",
      animation: "auto",
      animationDurationUpdate: 200,
      animationEasingUpdate: "exponentialOut",
      crossStyle: {
        color: "#999",
        width: 1,
        type: "dashed",
        textStyle: {}
      }
    },
    textStyle: {
      color: "#666",
      fontSize: 14
    }
  };
  return TooltipModel2;
}(ComponentModel$1);
var TooltipModel$1 = TooltipModel;
function shouldTooltipConfine(tooltipModel) {
  var confineOption = tooltipModel.get("confine");
  return confineOption != null ? !!confineOption : tooltipModel.get("renderMode") === "richText";
}
function testStyle(styleProps) {
  if (!env$1.domSupported) {
    return;
  }
  var style = document.documentElement.style;
  for (var i = 0, len2 = styleProps.length; i < len2; i++) {
    if (styleProps[i] in style) {
      return styleProps[i];
    }
  }
}
var TRANSFORM_VENDOR = testStyle(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]);
var TRANSITION_VENDOR = testStyle(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
function toCSSVendorPrefix(styleVendor, styleProp) {
  if (!styleVendor) {
    return styleProp;
  }
  styleProp = toCamelCase(styleProp, true);
  var idx = styleVendor.indexOf(styleProp);
  styleVendor = idx === -1 ? styleProp : "-" + styleVendor.slice(0, idx) + "-" + styleProp;
  return styleVendor.toLowerCase();
}
function getComputedStyle$1(el, style) {
  var stl = el.currentStyle || document.defaultView && document.defaultView.getComputedStyle(el);
  return stl ? style ? stl[style] : stl : null;
}
var CSS_TRANSITION_VENDOR = toCSSVendorPrefix(TRANSITION_VENDOR, "transition");
var CSS_TRANSFORM_VENDOR = toCSSVendorPrefix(TRANSFORM_VENDOR, "transform");
var gCssText = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (env$1.transform3dSupported ? "will-change:transform;" : "");
function mirrorPos(pos) {
  pos = pos === "left" ? "right" : pos === "right" ? "left" : pos === "top" ? "bottom" : "top";
  return pos;
}
function assembleArrow(tooltipModel, borderColor, arrowPosition) {
  if (!isString(arrowPosition) || arrowPosition === "inside") {
    return "";
  }
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var borderWidth = tooltipModel.get("borderWidth");
  borderColor = convertToColorString(borderColor);
  var arrowPos = mirrorPos(arrowPosition);
  var arrowSize = Math.max(Math.round(borderWidth) * 1.5, 6);
  var positionStyle = "";
  var transformStyle = CSS_TRANSFORM_VENDOR + ":";
  var rotateDeg;
  if (indexOf(["left", "right"], arrowPos) > -1) {
    positionStyle += "top:50%";
    transformStyle += "translateY(-50%) rotate(" + (rotateDeg = arrowPos === "left" ? -225 : -45) + "deg)";
  } else {
    positionStyle += "left:50%";
    transformStyle += "translateX(-50%) rotate(" + (rotateDeg = arrowPos === "top" ? 225 : 45) + "deg)";
  }
  var rotateRadian = rotateDeg * Math.PI / 180;
  var arrowWH = arrowSize + borderWidth;
  var rotatedWH = arrowWH * Math.abs(Math.cos(rotateRadian)) + arrowWH * Math.abs(Math.sin(rotateRadian));
  var arrowOffset = Math.round(((rotatedWH - Math.SQRT2 * borderWidth) / 2 + Math.SQRT2 * borderWidth - (rotatedWH - arrowWH) / 2) * 100) / 100;
  positionStyle += ";" + arrowPos + ":-" + arrowOffset + "px";
  var borderStyle = borderColor + " solid " + borderWidth + "px;";
  var styleCss = ["position:absolute;width:" + arrowSize + "px;height:" + arrowSize + "px;", positionStyle + ";" + transformStyle + ";", "border-bottom:" + borderStyle, "border-right:" + borderStyle, "background-color:" + backgroundColor2 + ";"];
  return '<div style="' + styleCss.join("") + '"></div>';
}
function assembleTransition(duration, onlyFade) {
  var transitionCurve = "cubic-bezier(0.23,1,0.32,1)";
  var transitionOption = " " + duration / 2 + "s " + transitionCurve;
  var transitionText = "opacity" + transitionOption + ",visibility" + transitionOption;
  if (!onlyFade) {
    transitionOption = " " + duration + "s " + transitionCurve;
    transitionText += env$1.transformSupported ? "," + CSS_TRANSFORM_VENDOR + transitionOption : ",left" + transitionOption + ",top" + transitionOption;
  }
  return CSS_TRANSITION_VENDOR + ":" + transitionText;
}
function assembleTransform(x2, y2, toString) {
  var x0 = x2.toFixed(0) + "px";
  var y0 = y2.toFixed(0) + "px";
  if (!env$1.transformSupported) {
    return toString ? "top:" + y0 + ";left:" + x0 + ";" : [["top", y0], ["left", x0]];
  }
  var is3d = env$1.transform3dSupported;
  var translate2 = "translate" + (is3d ? "3d" : "") + "(" + x0 + "," + y0 + (is3d ? ",0" : "") + ")";
  return toString ? "top:0;left:0;" + CSS_TRANSFORM_VENDOR + ":" + translate2 + ";" : [["top", 0], ["left", 0], [TRANSFORM_VENDOR, translate2]];
}
function assembleFont(textStyleModel) {
  var cssText = [];
  var fontSize = textStyleModel.get("fontSize");
  var color = textStyleModel.getTextColor();
  color && cssText.push("color:" + color);
  cssText.push("font:" + textStyleModel.getFont());
  fontSize && cssText.push("line-height:" + Math.round(fontSize * 3 / 2) + "px");
  var shadowColor = textStyleModel.get("textShadowColor");
  var shadowBlur = textStyleModel.get("textShadowBlur") || 0;
  var shadowOffsetX = textStyleModel.get("textShadowOffsetX") || 0;
  var shadowOffsetY = textStyleModel.get("textShadowOffsetY") || 0;
  shadowColor && shadowBlur && cssText.push("text-shadow:" + shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor);
  each$f(["decoration", "align"], function(name) {
    var val = textStyleModel.get(name);
    val && cssText.push("text-" + name + ":" + val);
  });
  return cssText.join(";");
}
function assembleCssText(tooltipModel, enableTransition, onlyFade) {
  var cssText = [];
  var transitionDuration = tooltipModel.get("transitionDuration");
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var shadowBlur = tooltipModel.get("shadowBlur");
  var shadowColor = tooltipModel.get("shadowColor");
  var shadowOffsetX = tooltipModel.get("shadowOffsetX");
  var shadowOffsetY = tooltipModel.get("shadowOffsetY");
  var textStyleModel = tooltipModel.getModel("textStyle");
  var padding = getPaddingFromTooltipModel(tooltipModel, "html");
  var boxShadow = shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor;
  cssText.push("box-shadow:" + boxShadow);
  enableTransition && transitionDuration && cssText.push(assembleTransition(transitionDuration, onlyFade));
  if (backgroundColor2) {
    cssText.push("background-color:" + backgroundColor2);
  }
  each$f(["width", "color", "radius"], function(name) {
    var borderName = "border-" + name;
    var camelCase = toCamelCase(borderName);
    var val = tooltipModel.get(camelCase);
    val != null && cssText.push(borderName + ":" + val + (name === "color" ? "" : "px"));
  });
  cssText.push(assembleFont(textStyleModel));
  if (padding != null) {
    cssText.push("padding:" + normalizeCssArray(padding).join("px ") + "px");
  }
  return cssText.join(";") + ";";
}
function makeStyleCoord$1(out2, zr, appendToBody, zrX, zrY) {
  var zrPainter = zr && zr.painter;
  if (appendToBody) {
    var zrViewportRoot = zrPainter && zrPainter.getViewportRoot();
    if (zrViewportRoot) {
      transformLocalCoord(out2, zrViewportRoot, document.body, zrX, zrY);
    }
  } else {
    out2[0] = zrX;
    out2[1] = zrY;
    var viewportRootOffset = zrPainter && zrPainter.getViewportRootOffset();
    if (viewportRootOffset) {
      out2[0] += viewportRootOffset.offsetLeft;
      out2[1] += viewportRootOffset.offsetTop;
    }
  }
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipHTMLContent = function() {
  function TooltipHTMLContent2(container2, api, opt) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._firstShow = true;
    this._longHide = true;
    if (env$1.wxa) {
      return null;
    }
    var el = document.createElement("div");
    el.domBelongToZr = true;
    this.el = el;
    var zr = this._zr = api.getZr();
    var appendToBody = this._appendToBody = opt && opt.appendToBody;
    makeStyleCoord$1(this._styleCoord, zr, appendToBody, api.getWidth() / 2, api.getHeight() / 2);
    if (appendToBody) {
      document.body.appendChild(el);
    } else {
      container2.appendChild(el);
    }
    this._container = container2;
    var self2 = this;
    el.onmouseenter = function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    };
    el.onmousemove = function(e2) {
      e2 = e2 || window.event;
      if (!self2._enterable) {
        var handler = zr.handler;
        var zrViewportRoot = zr.painter.getViewportRoot();
        normalizeEvent(zrViewportRoot, e2, true);
        handler.dispatch("mousemove", e2);
      }
    };
    el.onmouseleave = function() {
      self2._inContent = false;
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
    };
  }
  TooltipHTMLContent2.prototype.update = function(tooltipModel) {
    var container2 = this._container;
    var position2 = getComputedStyle$1(container2, "position");
    var domStyle = container2.style;
    if (domStyle.position !== "absolute" && position2 !== "absolute") {
      domStyle.position = "relative";
    }
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
    this.el.className = tooltipModel.get("className") || "";
  };
  TooltipHTMLContent2.prototype.show = function(tooltipModel, nearPointColor) {
    clearTimeout(this._hideTimeout);
    clearTimeout(this._longHideTimeout);
    var el = this.el;
    var style = el.style;
    var styleCoord = this._styleCoord;
    if (!el.innerHTML) {
      style.display = "none";
    } else {
      style.cssText = gCssText + assembleCssText(tooltipModel, !this._firstShow, this._longHide) + assembleTransform(styleCoord[0], styleCoord[1], true) + ("border-color:" + convertToColorString(nearPointColor) + ";") + (tooltipModel.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none"));
    }
    this._show = true;
    this._firstShow = false;
    this._longHide = false;
  };
  TooltipHTMLContent2.prototype.setContent = function(content, markers, tooltipModel, borderColor, arrowPosition) {
    var el = this.el;
    if (content == null) {
      el.innerHTML = "";
      return;
    }
    var arrow = "";
    if (isString(arrowPosition) && tooltipModel.get("trigger") === "item" && !shouldTooltipConfine(tooltipModel)) {
      arrow = assembleArrow(tooltipModel, borderColor, arrowPosition);
    }
    if (isString(content)) {
      el.innerHTML = content + arrow;
    } else if (content) {
      el.innerHTML = "";
      if (!isArray$1(content)) {
        content = [content];
      }
      for (var i = 0; i < content.length; i++) {
        if (isDom(content[i]) && content[i].parentNode !== el) {
          el.appendChild(content[i]);
        }
      }
      if (arrow && el.childNodes.length) {
        var arrowEl = document.createElement("div");
        arrowEl.innerHTML = arrow;
        el.appendChild(arrowEl);
      }
    }
  };
  TooltipHTMLContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipHTMLContent2.prototype.getSize = function() {
    var el = this.el;
    return [el.offsetWidth, el.offsetHeight];
  };
  TooltipHTMLContent2.prototype.moveTo = function(zrX, zrY) {
    var styleCoord = this._styleCoord;
    makeStyleCoord$1(styleCoord, this._zr, this._appendToBody, zrX, zrY);
    if (styleCoord[0] != null && styleCoord[1] != null) {
      var style_1 = this.el.style;
      var transforms = assembleTransform(styleCoord[0], styleCoord[1]);
      each$f(transforms, function(transform2) {
        style_1[transform2[0]] = transform2[1];
      });
    }
  };
  TooltipHTMLContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipHTMLContent2.prototype.hide = function() {
    var _this = this;
    var style = this.el.style;
    style.visibility = "hidden";
    style.opacity = "0";
    env$1.transform3dSupported && (style.willChange = "");
    this._show = false;
    this._longHideTimeout = setTimeout(function() {
      return _this._longHide = true;
    }, 500);
  };
  TooltipHTMLContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipHTMLContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipHTMLContent2.prototype.dispose = function() {
    this.el.parentNode.removeChild(this.el);
  };
  return TooltipHTMLContent2;
}();
var TooltipHTMLContent$1 = TooltipHTMLContent;
var TooltipRichContent = function() {
  function TooltipRichContent2(api) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._zr = api.getZr();
    makeStyleCoord(this._styleCoord, this._zr, api.getWidth() / 2, api.getHeight() / 2);
  }
  TooltipRichContent2.prototype.update = function(tooltipModel) {
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
  };
  TooltipRichContent2.prototype.show = function() {
    if (this._hideTimeout) {
      clearTimeout(this._hideTimeout);
    }
    this.el.show();
    this._show = true;
  };
  TooltipRichContent2.prototype.setContent = function(content, markupStyleCreator, tooltipModel, borderColor, arrowPosition) {
    var _this = this;
    if (isObject$4(content)) {
      throwError("");
    }
    if (this.el) {
      this._zr.remove(this.el);
    }
    var textStyleModel = tooltipModel.getModel("textStyle");
    this.el = new ZRText$1({
      style: {
        rich: markupStyleCreator.richTextStyles,
        text: content,
        lineHeight: 22,
        borderWidth: 1,
        borderColor,
        textShadowColor: textStyleModel.get("textShadowColor"),
        fill: tooltipModel.get(["textStyle", "color"]),
        padding: getPaddingFromTooltipModel(tooltipModel, "richText"),
        verticalAlign: "top",
        align: "left"
      },
      z: tooltipModel.get("z")
    });
    each$f(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(propName) {
      _this.el.style[propName] = tooltipModel.get(propName);
    });
    each$f(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(propName) {
      _this.el.style[propName] = textStyleModel.get(propName) || 0;
    });
    this._zr.add(this.el);
    var self2 = this;
    this.el.on("mouseover", function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    });
    this.el.on("mouseout", function() {
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
      self2._inContent = false;
    });
  };
  TooltipRichContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipRichContent2.prototype.getSize = function() {
    var el = this.el;
    var bounding = this.el.getBoundingRect();
    var shadowOuterSize = calcShadowOuterSize(el.style);
    return [bounding.width + shadowOuterSize.left + shadowOuterSize.right, bounding.height + shadowOuterSize.top + shadowOuterSize.bottom];
  };
  TooltipRichContent2.prototype.moveTo = function(x2, y2) {
    var el = this.el;
    if (el) {
      var styleCoord = this._styleCoord;
      makeStyleCoord(styleCoord, this._zr, x2, y2);
      x2 = styleCoord[0];
      y2 = styleCoord[1];
      var style = el.style;
      var borderWidth = mathMaxWith0(style.borderWidth || 0);
      var shadowOuterSize = calcShadowOuterSize(style);
      el.x = x2 + borderWidth + shadowOuterSize.left;
      el.y = y2 + borderWidth + shadowOuterSize.top;
      el.markRedraw();
    }
  };
  TooltipRichContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipRichContent2.prototype.hide = function() {
    if (this.el) {
      this.el.hide();
    }
    this._show = false;
  };
  TooltipRichContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipRichContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipRichContent2.prototype.dispose = function() {
    this._zr.remove(this.el);
  };
  return TooltipRichContent2;
}();
function mathMaxWith0(val) {
  return Math.max(0, val);
}
function calcShadowOuterSize(style) {
  var shadowBlur = mathMaxWith0(style.shadowBlur || 0);
  var shadowOffsetX = mathMaxWith0(style.shadowOffsetX || 0);
  var shadowOffsetY = mathMaxWith0(style.shadowOffsetY || 0);
  return {
    left: mathMaxWith0(shadowBlur - shadowOffsetX),
    right: mathMaxWith0(shadowBlur + shadowOffsetX),
    top: mathMaxWith0(shadowBlur - shadowOffsetY),
    bottom: mathMaxWith0(shadowBlur + shadowOffsetY)
  };
}
function makeStyleCoord(out2, zr, zrX, zrY) {
  out2[0] = zrX;
  out2[1] = zrY;
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipRichContent$1 = TooltipRichContent;
var proxyRect = new Rect$3({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
});
var TooltipView = function(_super) {
  __extends(TooltipView2, _super);
  function TooltipView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipView2.type;
    return _this;
  }
  TooltipView2.prototype.init = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    var tooltipModel = ecModel.getComponent("tooltip");
    var renderMode = this._renderMode = getTooltipRenderMode(tooltipModel.get("renderMode"));
    this._tooltipContent = renderMode === "richText" ? new TooltipRichContent$1(api) : new TooltipHTMLContent$1(api.getDom(), api, {
      appendToBody: tooltipModel.get("appendToBody", true)
    });
  };
  TooltipView2.prototype.render = function(tooltipModel, ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    this.group.removeAll();
    this._tooltipModel = tooltipModel;
    this._ecModel = ecModel;
    this._api = api;
    this._alwaysShowContent = tooltipModel.get("alwaysShowContent");
    var tooltipContent = this._tooltipContent;
    tooltipContent.update(tooltipModel);
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    this._initGlobalListener();
    this._keepShow();
    if (this._renderMode !== "richText" && tooltipModel.get("transitionDuration")) {
      createOrUpdate(this, "_updatePosition", 50, "fixRate");
    } else {
      clear$1(this, "_updatePosition");
    }
  };
  TooltipView2.prototype._initGlobalListener = function() {
    var tooltipModel = this._tooltipModel;
    var triggerOn = tooltipModel.get("triggerOn");
    register("itemTooltip", this._api, bind$1(function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none") {
        if (triggerOn.indexOf(currTrigger) >= 0) {
          this._tryShow(e2, dispatchAction2);
        } else if (currTrigger === "leave") {
          this._hide(dispatchAction2);
        }
      }
    }, this));
  };
  TooltipView2.prototype._keepShow = function() {
    var tooltipModel = this._tooltipModel;
    var ecModel = this._ecModel;
    var api = this._api;
    if (this._lastX != null && this._lastY != null && tooltipModel.get("triggerOn") !== "none") {
      var self_1 = this;
      clearTimeout(this._refreshUpdateTimeout);
      this._refreshUpdateTimeout = setTimeout(function() {
        !api.isDisposed() && self_1.manuallyShowTip(tooltipModel, ecModel, api, {
          x: self_1._lastX,
          y: self_1._lastY,
          dataByCoordSys: self_1._lastDataByCoordSys
        });
      });
    }
  };
  TooltipView2.prototype.manuallyShowTip = function(tooltipModel, ecModel, api, payload) {
    if (payload.from === this.uid || env$1.node || !api.getDom()) {
      return;
    }
    var dispatchAction2 = makeDispatchAction(payload, api);
    this._ticket = "";
    var dataByCoordSys = payload.dataByCoordSys;
    var cmptRef = findComponentReference(payload, ecModel, api);
    if (cmptRef) {
      var rect = cmptRef.el.getBoundingRect().clone();
      rect.applyTransform(cmptRef.el.transform);
      this._tryShow({
        offsetX: rect.x + rect.width / 2,
        offsetY: rect.y + rect.height / 2,
        target: cmptRef.el,
        position: payload.position,
        positionDefault: "bottom"
      }, dispatchAction2);
    } else if (payload.tooltip && payload.x != null && payload.y != null) {
      var el = proxyRect;
      el.x = payload.x;
      el.y = payload.y;
      el.update();
      getECData(el).tooltipConfig = {
        name: null,
        option: payload.tooltip
      };
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        target: el
      }, dispatchAction2);
    } else if (dataByCoordSys) {
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        dataByCoordSys,
        tooltipOption: payload.tooltipOption
      }, dispatchAction2);
    } else if (payload.seriesIndex != null) {
      if (this._manuallyAxisShowTip(tooltipModel, ecModel, api, payload)) {
        return;
      }
      var pointInfo = findPointFromSeries(payload, ecModel);
      var cx = pointInfo.point[0];
      var cy = pointInfo.point[1];
      if (cx != null && cy != null) {
        this._tryShow({
          offsetX: cx,
          offsetY: cy,
          target: pointInfo.el,
          position: payload.position,
          positionDefault: "bottom"
        }, dispatchAction2);
      }
    } else if (payload.x != null && payload.y != null) {
      api.dispatchAction({
        type: "updateAxisPointer",
        x: payload.x,
        y: payload.y
      });
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        target: api.getZr().findHover(payload.x, payload.y).target
      }, dispatchAction2);
    }
  };
  TooltipView2.prototype.manuallyHideTip = function(tooltipModel, ecModel, api, payload) {
    var tooltipContent = this._tooltipContent;
    if (!this._alwaysShowContent && this._tooltipModel) {
      tooltipContent.hideLater(this._tooltipModel.get("hideDelay"));
    }
    this._lastX = this._lastY = this._lastDataByCoordSys = null;
    if (payload.from !== this.uid) {
      this._hide(makeDispatchAction(payload, api));
    }
  };
  TooltipView2.prototype._manuallyAxisShowTip = function(tooltipModel, ecModel, api, payload) {
    var seriesIndex = payload.seriesIndex;
    var dataIndex = payload.dataIndex;
    var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
    if (seriesIndex == null || dataIndex == null || coordSysAxesInfo == null) {
      return;
    }
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    if (!seriesModel) {
      return;
    }
    var data = seriesModel.getData();
    var tooltipCascadedModel = buildTooltipModel([data.getItemModel(dataIndex), seriesModel, (seriesModel.coordinateSystem || {}).model], this._tooltipModel);
    if (tooltipCascadedModel.get("trigger") !== "axis") {
      return;
    }
    api.dispatchAction({
      type: "updateAxisPointer",
      seriesIndex,
      dataIndex,
      position: payload.position
    });
    return true;
  };
  TooltipView2.prototype._tryShow = function(e2, dispatchAction2) {
    var el = e2.target;
    var tooltipModel = this._tooltipModel;
    if (!tooltipModel) {
      return;
    }
    this._lastX = e2.offsetX;
    this._lastY = e2.offsetY;
    var dataByCoordSys = e2.dataByCoordSys;
    if (dataByCoordSys && dataByCoordSys.length) {
      this._showAxisTooltip(dataByCoordSys, e2);
    } else if (el) {
      this._lastDataByCoordSys = null;
      var seriesDispatcher_1;
      var cmptDispatcher_1;
      findEventDispatcher(el, function(target) {
        if (getECData(target).dataIndex != null) {
          seriesDispatcher_1 = target;
          return true;
        }
        if (getECData(target).tooltipConfig != null) {
          cmptDispatcher_1 = target;
          return true;
        }
      }, true);
      if (seriesDispatcher_1) {
        this._showSeriesItemTooltip(e2, seriesDispatcher_1, dispatchAction2);
      } else if (cmptDispatcher_1) {
        this._showComponentItemTooltip(e2, cmptDispatcher_1, dispatchAction2);
      } else {
        this._hide(dispatchAction2);
      }
    } else {
      this._lastDataByCoordSys = null;
      this._hide(dispatchAction2);
    }
  };
  TooltipView2.prototype._showOrMove = function(tooltipModel, cb) {
    var delay = tooltipModel.get("showDelay");
    cb = bind$1(cb, this);
    clearTimeout(this._showTimout);
    delay > 0 ? this._showTimout = setTimeout(cb, delay) : cb();
  };
  TooltipView2.prototype._showAxisTooltip = function(dataByCoordSys, e2) {
    var ecModel = this._ecModel;
    var globalTooltipModel = this._tooltipModel;
    var point = [e2.offsetX, e2.offsetY];
    var singleTooltipModel = buildTooltipModel([e2.tooltipOption], globalTooltipModel);
    var renderMode = this._renderMode;
    var cbParamsList = [];
    var articleMarkup = createTooltipMarkup("section", {
      blocks: [],
      noHeader: true
    });
    var markupTextArrLegacy = [];
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    each$f(dataByCoordSys, function(itemCoordSys) {
      each$f(itemCoordSys.dataByAxis, function(axisItem) {
        var axisModel = ecModel.getComponent(axisItem.axisDim + "Axis", axisItem.axisIndex);
        var axisValue = axisItem.value;
        if (!axisModel || axisValue == null) {
          return;
        }
        var axisValueLabel = getValueLabel(axisValue, axisModel.axis, ecModel, axisItem.seriesDataIndices, axisItem.valueLabelOpt);
        var axisSectionMarkup = createTooltipMarkup("section", {
          header: axisValueLabel,
          noHeader: !trim$1(axisValueLabel),
          sortBlocks: true,
          blocks: []
        });
        articleMarkup.blocks.push(axisSectionMarkup);
        each$f(axisItem.seriesDataIndices, function(idxItem) {
          var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
          var dataIndex = idxItem.dataIndexInside;
          var cbParams = series.getDataParams(dataIndex);
          if (cbParams.dataIndex < 0) {
            return;
          }
          cbParams.axisDim = axisItem.axisDim;
          cbParams.axisIndex = axisItem.axisIndex;
          cbParams.axisType = axisItem.axisType;
          cbParams.axisId = axisItem.axisId;
          cbParams.axisValue = getAxisRawValue(axisModel.axis, {
            value: axisValue
          });
          cbParams.axisValueLabel = axisValueLabel;
          cbParams.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(cbParams.color), renderMode);
          var seriesTooltipResult = normalizeTooltipFormatResult(series.formatTooltip(dataIndex, true, null));
          var frag = seriesTooltipResult.frag;
          if (frag) {
            var valueFormatter = buildTooltipModel([series], globalTooltipModel).get("valueFormatter");
            axisSectionMarkup.blocks.push(valueFormatter ? extend({
              valueFormatter
            }, frag) : frag);
          }
          if (seriesTooltipResult.text) {
            markupTextArrLegacy.push(seriesTooltipResult.text);
          }
          cbParamsList.push(cbParams);
        });
      });
    });
    articleMarkup.blocks.reverse();
    markupTextArrLegacy.reverse();
    var positionExpr = e2.position;
    var orderMode = singleTooltipModel.get("order");
    var builtMarkupText = buildTooltipMarkup(articleMarkup, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), singleTooltipModel.get("textStyle"));
    builtMarkupText && markupTextArrLegacy.unshift(builtMarkupText);
    var blockBreak = renderMode === "richText" ? "\n\n" : "<br/>";
    var allMarkupText = markupTextArrLegacy.join(blockBreak);
    this._showOrMove(singleTooltipModel, function() {
      if (this._updateContentNotChangedOnAxis(dataByCoordSys, cbParamsList)) {
        this._updatePosition(singleTooltipModel, positionExpr, point[0], point[1], this._tooltipContent, cbParamsList);
      } else {
        this._showTooltipContent(singleTooltipModel, allMarkupText, cbParamsList, Math.random() + "", point[0], point[1], positionExpr, null, markupStyleCreator);
      }
    });
  };
  TooltipView2.prototype._showSeriesItemTooltip = function(e2, dispatcher, dispatchAction2) {
    var ecModel = this._ecModel;
    var ecData = getECData(dispatcher);
    var seriesIndex = ecData.seriesIndex;
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    var dataModel = ecData.dataModel || seriesModel;
    var dataIndex = ecData.dataIndex;
    var dataType = ecData.dataType;
    var data = dataModel.getData(dataType);
    var renderMode = this._renderMode;
    var positionDefault = e2.positionDefault;
    var tooltipModel = buildTooltipModel([data.getItemModel(dataIndex), dataModel, seriesModel && (seriesModel.coordinateSystem || {}).model], this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var tooltipTrigger = tooltipModel.get("trigger");
    if (tooltipTrigger != null && tooltipTrigger !== "item") {
      return;
    }
    var params = dataModel.getDataParams(dataIndex, dataType);
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    params.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(params.color), renderMode);
    var seriesTooltipResult = normalizeTooltipFormatResult(dataModel.formatTooltip(dataIndex, false, dataType));
    var orderMode = tooltipModel.get("order");
    var valueFormatter = tooltipModel.get("valueFormatter");
    var frag = seriesTooltipResult.frag;
    var markupText = frag ? buildTooltipMarkup(valueFormatter ? extend({
      valueFormatter
    }, frag) : frag, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), tooltipModel.get("textStyle")) : seriesTooltipResult.text;
    var asyncTicket = "item_" + dataModel.name + "_" + dataIndex;
    this._showOrMove(tooltipModel, function() {
      this._showTooltipContent(tooltipModel, markupText, params, asyncTicket, e2.offsetX, e2.offsetY, e2.position, e2.target, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      dataIndexInside: dataIndex,
      dataIndex: data.getRawIndex(dataIndex),
      seriesIndex,
      from: this.uid
    });
  };
  TooltipView2.prototype._showComponentItemTooltip = function(e2, el, dispatchAction2) {
    var ecData = getECData(el);
    var tooltipConfig = ecData.tooltipConfig;
    var tooltipOpt = tooltipConfig.option || {};
    if (isString(tooltipOpt)) {
      var content = tooltipOpt;
      tooltipOpt = {
        content,
        formatter: content
      };
    }
    var tooltipModelCascade = [tooltipOpt];
    var cmpt = this._ecModel.getComponent(ecData.componentMainType, ecData.componentIndex);
    if (cmpt) {
      tooltipModelCascade.push(cmpt);
    }
    tooltipModelCascade.push({
      formatter: tooltipOpt.content
    });
    var positionDefault = e2.positionDefault;
    var subTooltipModel = buildTooltipModel(tooltipModelCascade, this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var defaultHtml = subTooltipModel.get("content");
    var asyncTicket = Math.random() + "";
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    this._showOrMove(subTooltipModel, function() {
      var formatterParams = clone$4(subTooltipModel.get("formatterParams") || {});
      this._showTooltipContent(subTooltipModel, defaultHtml, formatterParams, asyncTicket, e2.offsetX, e2.offsetY, e2.position, el, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      from: this.uid
    });
  };
  TooltipView2.prototype._showTooltipContent = function(tooltipModel, defaultHtml, params, asyncTicket, x2, y2, positionExpr, el, markupStyleCreator) {
    this._ticket = "";
    if (!tooltipModel.get("showContent") || !tooltipModel.get("show")) {
      return;
    }
    var tooltipContent = this._tooltipContent;
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    var formatter = tooltipModel.get("formatter");
    positionExpr = positionExpr || tooltipModel.get("position");
    var html = defaultHtml;
    var nearPoint = this._getNearestPoint([x2, y2], params, tooltipModel.get("trigger"), tooltipModel.get("borderColor"));
    var nearPointColor = nearPoint.color;
    if (formatter) {
      if (isString(formatter)) {
        var useUTC = tooltipModel.ecModel.get("useUTC");
        var params0 = isArray$1(params) ? params[0] : params;
        var isTimeAxis = params0 && params0.axisType && params0.axisType.indexOf("time") >= 0;
        html = formatter;
        if (isTimeAxis) {
          html = format$1(params0.axisValue, html, useUTC);
        }
        html = formatTpl(html, params, true);
      } else if (isFunction(formatter)) {
        var callback = bind$1(function(cbTicket, html2) {
          if (cbTicket === this._ticket) {
            tooltipContent.setContent(html2, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
            this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
          }
        }, this);
        this._ticket = asyncTicket;
        html = formatter(params, asyncTicket, callback);
      } else {
        html = formatter;
      }
    }
    tooltipContent.setContent(html, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
    tooltipContent.show(tooltipModel, nearPointColor);
    this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
  };
  TooltipView2.prototype._getNearestPoint = function(point, tooltipDataParams, trigger2, borderColor) {
    if (trigger2 === "axis" || isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || (this._renderMode === "html" ? "#fff" : "none")
      };
    }
    if (!isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || tooltipDataParams.color || tooltipDataParams.borderColor
      };
    }
  };
  TooltipView2.prototype._updatePosition = function(tooltipModel, positionExpr, x2, y2, content, params, el) {
    var viewWidth = this._api.getWidth();
    var viewHeight = this._api.getHeight();
    positionExpr = positionExpr || tooltipModel.get("position");
    var contentSize = content.getSize();
    var align = tooltipModel.get("align");
    var vAlign = tooltipModel.get("verticalAlign");
    var rect = el && el.getBoundingRect().clone();
    el && rect.applyTransform(el.transform);
    if (isFunction(positionExpr)) {
      positionExpr = positionExpr([x2, y2], params, content.el, rect, {
        viewSize: [viewWidth, viewHeight],
        contentSize: contentSize.slice()
      });
    }
    if (isArray$1(positionExpr)) {
      x2 = parsePercent(positionExpr[0], viewWidth);
      y2 = parsePercent(positionExpr[1], viewHeight);
    } else if (isObject$4(positionExpr)) {
      var boxLayoutPosition = positionExpr;
      boxLayoutPosition.width = contentSize[0];
      boxLayoutPosition.height = contentSize[1];
      var layoutRect = getLayoutRect(boxLayoutPosition, {
        width: viewWidth,
        height: viewHeight
      });
      x2 = layoutRect.x;
      y2 = layoutRect.y;
      align = null;
      vAlign = null;
    } else if (isString(positionExpr) && el) {
      var pos = calcTooltipPosition(positionExpr, rect, contentSize, tooltipModel.get("borderWidth"));
      x2 = pos[0];
      y2 = pos[1];
    } else {
      var pos = refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, align ? null : 20, vAlign ? null : 20);
      x2 = pos[0];
      y2 = pos[1];
    }
    align && (x2 -= isCenterAlign(align) ? contentSize[0] / 2 : align === "right" ? contentSize[0] : 0);
    vAlign && (y2 -= isCenterAlign(vAlign) ? contentSize[1] / 2 : vAlign === "bottom" ? contentSize[1] : 0);
    if (shouldTooltipConfine(tooltipModel)) {
      var pos = confineTooltipPosition(x2, y2, content, viewWidth, viewHeight);
      x2 = pos[0];
      y2 = pos[1];
    }
    content.moveTo(x2, y2);
  };
  TooltipView2.prototype._updateContentNotChangedOnAxis = function(dataByCoordSys, cbParamsList) {
    var lastCoordSys = this._lastDataByCoordSys;
    var lastCbParamsList = this._cbParamsList;
    var contentNotChanged = !!lastCoordSys && lastCoordSys.length === dataByCoordSys.length;
    contentNotChanged && each$f(lastCoordSys, function(lastItemCoordSys, indexCoordSys) {
      var lastDataByAxis = lastItemCoordSys.dataByAxis || [];
      var thisItemCoordSys = dataByCoordSys[indexCoordSys] || {};
      var thisDataByAxis = thisItemCoordSys.dataByAxis || [];
      contentNotChanged = contentNotChanged && lastDataByAxis.length === thisDataByAxis.length;
      contentNotChanged && each$f(lastDataByAxis, function(lastItem, indexAxis) {
        var thisItem = thisDataByAxis[indexAxis] || {};
        var lastIndices = lastItem.seriesDataIndices || [];
        var newIndices = thisItem.seriesDataIndices || [];
        contentNotChanged = contentNotChanged && lastItem.value === thisItem.value && lastItem.axisType === thisItem.axisType && lastItem.axisId === thisItem.axisId && lastIndices.length === newIndices.length;
        contentNotChanged && each$f(lastIndices, function(lastIdxItem, j) {
          var newIdxItem = newIndices[j];
          contentNotChanged = contentNotChanged && lastIdxItem.seriesIndex === newIdxItem.seriesIndex && lastIdxItem.dataIndex === newIdxItem.dataIndex;
        });
        lastCbParamsList && each$f(lastItem.seriesDataIndices, function(idxItem) {
          var seriesIdx = idxItem.seriesIndex;
          var cbParams = cbParamsList[seriesIdx];
          var lastCbParams = lastCbParamsList[seriesIdx];
          if (cbParams && lastCbParams && lastCbParams.data !== cbParams.data) {
            contentNotChanged = false;
          }
        });
      });
    });
    this._lastDataByCoordSys = dataByCoordSys;
    this._cbParamsList = cbParamsList;
    return !!contentNotChanged;
  };
  TooltipView2.prototype._hide = function(dispatchAction2) {
    this._lastDataByCoordSys = null;
    dispatchAction2({
      type: "hideTip",
      from: this.uid
    });
  };
  TooltipView2.prototype.dispose = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    clear$1(this, "_updatePosition");
    this._tooltipContent.dispose();
    unregister("itemTooltip", api);
  };
  TooltipView2.type = "tooltip";
  return TooltipView2;
}(ComponentView$1);
function buildTooltipModel(modelCascade, globalTooltipModel, defaultTooltipOption) {
  var ecModel = globalTooltipModel.ecModel;
  var resultModel;
  if (defaultTooltipOption) {
    resultModel = new Model$1(defaultTooltipOption, ecModel, ecModel);
    resultModel = new Model$1(globalTooltipModel.option, resultModel, ecModel);
  } else {
    resultModel = globalTooltipModel;
  }
  for (var i = modelCascade.length - 1; i >= 0; i--) {
    var tooltipOpt = modelCascade[i];
    if (tooltipOpt) {
      if (tooltipOpt instanceof Model$1) {
        tooltipOpt = tooltipOpt.get("tooltip", true);
      }
      if (isString(tooltipOpt)) {
        tooltipOpt = {
          formatter: tooltipOpt
        };
      }
      if (tooltipOpt) {
        resultModel = new Model$1(tooltipOpt, resultModel, ecModel);
      }
    }
  }
  return resultModel;
}
function makeDispatchAction(payload, api) {
  return payload.dispatchAction || bind$1(api.dispatchAction, api);
}
function refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, gapH, gapV) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  if (gapH != null) {
    if (x2 + width + gapH + 2 > viewWidth) {
      x2 -= width + gapH;
    } else {
      x2 += gapH;
    }
  }
  if (gapV != null) {
    if (y2 + height + gapV > viewHeight) {
      y2 -= height + gapV;
    } else {
      y2 += gapV;
    }
  }
  return [x2, y2];
}
function confineTooltipPosition(x2, y2, content, viewWidth, viewHeight) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  x2 = Math.min(x2 + width, viewWidth) - width;
  y2 = Math.min(y2 + height, viewHeight) - height;
  x2 = Math.max(x2, 0);
  y2 = Math.max(y2, 0);
  return [x2, y2];
}
function calcTooltipPosition(position2, rect, contentSize, borderWidth) {
  var domWidth = contentSize[0];
  var domHeight = contentSize[1];
  var offset = Math.ceil(Math.SQRT2 * borderWidth) + 8;
  var x2 = 0;
  var y2 = 0;
  var rectWidth = rect.width;
  var rectHeight = rect.height;
  switch (position2) {
    case "inside":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "top":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y - domHeight - offset;
      break;
    case "bottom":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight + offset;
      break;
    case "left":
      x2 = rect.x - domWidth - offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "right":
      x2 = rect.x + rectWidth + offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
  }
  return [x2, y2];
}
function isCenterAlign(align) {
  return align === "center" || align === "middle";
}
function findComponentReference(payload, ecModel, api) {
  var queryOptionMap = preParseFinder(payload).queryOptionMap;
  var componentMainType = queryOptionMap.keys()[0];
  if (!componentMainType || componentMainType === "series") {
    return;
  }
  var queryResult = queryReferringComponents(ecModel, componentMainType, queryOptionMap.get(componentMainType), {
    useDefault: false,
    enableAll: false,
    enableNone: false
  });
  var model = queryResult.models[0];
  if (!model) {
    return;
  }
  var view = api.getViewOfComponentModel(model);
  var el;
  view.group.traverse(function(subEl) {
    var tooltipConfig = getECData(subEl).tooltipConfig;
    if (tooltipConfig && tooltipConfig.name === payload.name) {
      el = subEl;
      return true;
    }
  });
  if (el) {
    return {
      componentMainType,
      componentIndex: model.componentIndex,
      el
    };
  }
}
var TooltipView$1 = TooltipView;
function install$i(registers) {
  use(install$q);
  registers.registerComponentModel(TooltipModel$1);
  registers.registerComponentView(TooltipView$1);
  registers.registerAction({
    type: "showTip",
    event: "showTip",
    update: "tooltip:manuallyShowTip"
  }, noop);
  registers.registerAction({
    type: "hideTip",
    event: "hideTip",
    update: "tooltip:manuallyHideTip"
  }, noop);
}
var DEFAULT_TOOLBOX_BTNS = ["rect", "polygon", "keep", "clear"];
function brushPreprocessor(option, isNew) {
  var brushComponents = normalizeToArray(option ? option.brush : []);
  if (!brushComponents.length) {
    return;
  }
  var brushComponentSpecifiedBtns = [];
  each$f(brushComponents, function(brushOpt) {
    var tbs = brushOpt.hasOwnProperty("toolbox") ? brushOpt.toolbox : [];
    if (tbs instanceof Array) {
      brushComponentSpecifiedBtns = brushComponentSpecifiedBtns.concat(tbs);
    }
  });
  var toolbox = option && option.toolbox;
  if (isArray$1(toolbox)) {
    toolbox = toolbox[0];
  }
  if (!toolbox) {
    toolbox = {
      feature: {}
    };
    option.toolbox = [toolbox];
  }
  var toolboxFeature = toolbox.feature || (toolbox.feature = {});
  var toolboxBrush = toolboxFeature.brush || (toolboxFeature.brush = {});
  var brushTypes = toolboxBrush.type || (toolboxBrush.type = []);
  brushTypes.push.apply(brushTypes, brushComponentSpecifiedBtns);
  removeDuplicate(brushTypes);
  if (isNew && !brushTypes.length) {
    brushTypes.push.apply(brushTypes, DEFAULT_TOOLBOX_BTNS);
  }
}
function removeDuplicate(arr) {
  var map2 = {};
  each$f(arr, function(val) {
    map2[val] = 1;
  });
  arr.length = 0;
  each$f(map2, function(flag, val) {
    arr.push(val);
  });
}
var each$4 = each$f;
function hasKeys(obj) {
  if (obj) {
    for (var name_1 in obj) {
      if (obj.hasOwnProperty(name_1)) {
        return true;
      }
    }
  }
}
function createVisualMappings(option, stateList, supplementVisualOption) {
  var visualMappings = {};
  each$4(stateList, function(state) {
    var mappings = visualMappings[state] = createMappings();
    each$4(option[state], function(visualData, visualType) {
      if (!VisualMapping$1.isValidType(visualType)) {
        return;
      }
      var mappingOption = {
        type: visualType,
        visual: visualData
      };
      supplementVisualOption && supplementVisualOption(mappingOption, state);
      mappings[visualType] = new VisualMapping$1(mappingOption);
      if (visualType === "opacity") {
        mappingOption = clone$4(mappingOption);
        mappingOption.type = "colorAlpha";
        mappings.__hidden.__alphaForOpacity = new VisualMapping$1(mappingOption);
      }
    });
  });
  return visualMappings;
  function createMappings() {
    var Creater = function() {
    };
    Creater.prototype.__hidden = Creater.prototype;
    var obj = new Creater();
    return obj;
  }
}
function replaceVisualOption(thisOption, newOption, keys2) {
  var has2;
  each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      has2 = true;
    }
  });
  has2 && each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      thisOption[key] = clone$4(newOption[key]);
    } else {
      delete thisOption[key];
    }
  });
}
function applyVisual(stateList, visualMappings, data, getValueState, scope, dimension) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  var dataIndex;
  function getVisual(key) {
    return getItemVisualFromData(data, dataIndex, key);
  }
  function setVisual(key, value) {
    setItemVisualFromData(data, dataIndex, key, value);
  }
  if (dimension == null) {
    data.each(eachItem);
  } else {
    data.each([dimension], eachItem);
  }
  function eachItem(valueOrIndex, index2) {
    dataIndex = dimension == null ? valueOrIndex : index2;
    var rawDataItem = data.getRawDataItem(dataIndex);
    if (rawDataItem && rawDataItem.visualMap === false) {
      return;
    }
    var valueState = getValueState.call(scope, valueOrIndex);
    var mappings = visualMappings[valueState];
    var visualTypes = visualTypesMap[valueState];
    for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
      var type4 = visualTypes[i];
      mappings[type4] && mappings[type4].applyVisual(valueOrIndex, getVisual, setVisual);
    }
  }
}
function incrementalApplyVisual(stateList, visualMappings, getValueState, dim) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  return {
    progress: function progress(params, data) {
      var dimIndex;
      if (dim != null) {
        dimIndex = data.getDimensionIndex(dim);
      }
      function getVisual(key) {
        return getItemVisualFromData(data, dataIndex, key);
      }
      function setVisual(key, value2) {
        setItemVisualFromData(data, dataIndex, key, value2);
      }
      var dataIndex;
      var store = data.getStore();
      while ((dataIndex = params.next()) != null) {
        var rawDataItem = data.getRawDataItem(dataIndex);
        if (rawDataItem && rawDataItem.visualMap === false) {
          continue;
        }
        var value = dim != null ? store.get(dimIndex, dataIndex) : dataIndex;
        var valueState = getValueState(value);
        var mappings = visualMappings[valueState];
        var visualTypes = visualTypesMap[valueState];
        for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
          var type4 = visualTypes[i];
          mappings[type4] && mappings[type4].applyVisual(value, getVisual, setVisual);
        }
      }
    }
  };
}
function makeBrushCommonSelectorForSeries(area) {
  var brushType = area.brushType;
  var selectors = {
    point: function(itemLayout) {
      return selector[brushType].point(itemLayout, selectors, area);
    },
    rect: function(itemLayout) {
      return selector[brushType].rect(itemLayout, selectors, area);
    }
  };
  return selectors;
}
var selector = {
  lineX: getLineSelectors(0),
  lineY: getLineSelectors(1),
  rect: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.intersect(itemLayout);
    }
  },
  polygon: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]) && contain(area.range, itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      var points2 = area.range;
      if (!itemLayout || points2.length <= 1) {
        return false;
      }
      var x2 = itemLayout.x;
      var y2 = itemLayout.y;
      var width = itemLayout.width;
      var height = itemLayout.height;
      var p2 = points2[0];
      if (contain(points2, x2, y2) || contain(points2, x2 + width, y2) || contain(points2, x2, y2 + height) || contain(points2, x2 + width, y2 + height) || BoundingRect$1.create(itemLayout).contain(p2[0], p2[1]) || linePolygonIntersect(x2, y2, x2 + width, y2, points2) || linePolygonIntersect(x2, y2, x2, y2 + height, points2) || linePolygonIntersect(x2 + width, y2, x2 + width, y2 + height, points2) || linePolygonIntersect(x2, y2 + height, x2 + width, y2 + height, points2)) {
        return true;
      }
    }
  }
};
function getLineSelectors(xyIndex) {
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  return {
    point: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var p2 = itemLayout[xyIndex];
        return inLineRange(p2, range3);
      }
    },
    rect: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var layoutRange = [itemLayout[xy[xyIndex]], itemLayout[xy[xyIndex]] + itemLayout[wh[xyIndex]]];
        layoutRange[1] < layoutRange[0] && layoutRange.reverse();
        return inLineRange(layoutRange[0], range3) || inLineRange(layoutRange[1], range3) || inLineRange(range3[0], layoutRange) || inLineRange(range3[1], layoutRange);
      }
    }
  };
}
function inLineRange(p2, range3) {
  return range3[0] <= p2 && p2 <= range3[1];
}
var STATE_LIST = ["inBrush", "outOfBrush"];
var DISPATCH_METHOD = "__ecBrushSelect";
var DISPATCH_FLAG = "__ecInBrushSelectEvent";
function layoutCovers(ecModel) {
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    var brushTargetManager = brushModel.brushTargetManager = new BrushTargetManager$1(brushModel.option, ecModel);
    brushTargetManager.setInputRanges(brushModel.areas, ecModel);
  });
}
function brushVisual(ecModel, api, payload) {
  var brushSelected = [];
  var throttleType;
  var throttleDelay;
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    payload && payload.type === "takeGlobalCursor" && brushModel.setBrushOption(payload.key === "brush" ? payload.brushOption : {
      brushType: false
    });
  });
  layoutCovers(ecModel);
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel, brushIndex) {
    var thisBrushSelected = {
      brushId: brushModel.id,
      brushIndex,
      brushName: brushModel.name,
      areas: clone$4(brushModel.areas),
      selected: []
    };
    brushSelected.push(thisBrushSelected);
    var brushOption = brushModel.option;
    var brushLink = brushOption.brushLink;
    var linkedSeriesMap = [];
    var selectedDataIndexForLink = [];
    var rangeInfoBySeries = [];
    var hasBrushExists = false;
    if (!brushIndex) {
      throttleType = brushOption.throttleType;
      throttleDelay = brushOption.throttleDelay;
    }
    var areas = map$1(brushModel.areas, function(area) {
      var builder = boundingRectBuilders[area.brushType];
      var selectableArea = defaults({
        boundingRect: builder ? builder(area) : void 0
      }, area);
      selectableArea.selectors = makeBrushCommonSelectorForSeries(selectableArea);
      return selectableArea;
    });
    var visualMappings = createVisualMappings(brushModel.option, STATE_LIST, function(mappingOption) {
      mappingOption.mappingMethod = "fixed";
    });
    isArray$1(brushLink) && each$f(brushLink, function(seriesIndex) {
      linkedSeriesMap[seriesIndex] = 1;
    });
    function linkOthers(seriesIndex) {
      return brushLink === "all" || !!linkedSeriesMap[seriesIndex];
    }
    function brushed(rangeInfoList) {
      return !!rangeInfoList.length;
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var rangeInfoList = rangeInfoBySeries[seriesIndex] = [];
      seriesModel.subType === "parallel" ? stepAParallel(seriesModel, seriesIndex) : stepAOthers(seriesModel, seriesIndex, rangeInfoList);
    });
    function stepAParallel(seriesModel, seriesIndex) {
      var coordSys = seriesModel.coordinateSystem;
      hasBrushExists = hasBrushExists || coordSys.hasAxisBrushed();
      linkOthers(seriesIndex) && coordSys.eachActiveState(seriesModel.getData(), function(activeState, dataIndex) {
        activeState === "active" && (selectedDataIndexForLink[dataIndex] = 1);
      });
    }
    function stepAOthers(seriesModel, seriesIndex, rangeInfoList) {
      if (!seriesModel.brushSelector || brushModelNotControll(brushModel, seriesIndex)) {
        return;
      }
      each$f(areas, function(area) {
        if (brushModel.brushTargetManager.controlSeries(area, seriesModel, ecModel)) {
          rangeInfoList.push(area);
        }
        hasBrushExists = hasBrushExists || brushed(rangeInfoList);
      });
      if (linkOthers(seriesIndex) && brushed(rangeInfoList)) {
        var data_1 = seriesModel.getData();
        data_1.each(function(dataIndex) {
          if (checkInRange(seriesModel, rangeInfoList, data_1, dataIndex)) {
            selectedDataIndexForLink[dataIndex] = 1;
          }
        });
      }
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var seriesBrushSelected = {
        seriesId: seriesModel.id,
        seriesIndex,
        seriesName: seriesModel.name,
        dataIndex: []
      };
      thisBrushSelected.selected.push(seriesBrushSelected);
      var rangeInfoList = rangeInfoBySeries[seriesIndex];
      var data = seriesModel.getData();
      var getValueState = linkOthers(seriesIndex) ? function(dataIndex) {
        return selectedDataIndexForLink[dataIndex] ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      } : function(dataIndex) {
        return checkInRange(seriesModel, rangeInfoList, data, dataIndex) ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      };
      (linkOthers(seriesIndex) ? hasBrushExists : brushed(rangeInfoList)) && applyVisual(STATE_LIST, visualMappings, data, getValueState);
    });
  });
  dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload);
}
function dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload) {
  if (!payload) {
    return;
  }
  var zr = api.getZr();
  if (zr[DISPATCH_FLAG]) {
    return;
  }
  if (!zr[DISPATCH_METHOD]) {
    zr[DISPATCH_METHOD] = doDispatch;
  }
  var fn = createOrUpdate(zr, DISPATCH_METHOD, throttleDelay, throttleType);
  fn(api, brushSelected);
}
function doDispatch(api, brushSelected) {
  if (!api.isDisposed()) {
    var zr = api.getZr();
    zr[DISPATCH_FLAG] = true;
    api.dispatchAction({
      type: "brushSelect",
      batch: brushSelected
    });
    zr[DISPATCH_FLAG] = false;
  }
}
function checkInRange(seriesModel, rangeInfoList, data, dataIndex) {
  for (var i = 0, len2 = rangeInfoList.length; i < len2; i++) {
    var area = rangeInfoList[i];
    if (seriesModel.brushSelector(dataIndex, data, area.selectors, area)) {
      return true;
    }
  }
}
function brushModelNotControll(brushModel, seriesIndex) {
  var seriesIndices = brushModel.option.seriesIndex;
  return seriesIndices != null && seriesIndices !== "all" && (isArray$1(seriesIndices) ? indexOf(seriesIndices, seriesIndex) < 0 : seriesIndex !== seriesIndices);
}
var boundingRectBuilders = {
  rect: function(area) {
    return getBoundingRectFromMinMax(area.range);
  },
  polygon: function(area) {
    var minMax;
    var range3 = area.range;
    for (var i = 0, len2 = range3.length; i < len2; i++) {
      minMax = minMax || [[Infinity, -Infinity], [Infinity, -Infinity]];
      var rg = range3[i];
      rg[0] < minMax[0][0] && (minMax[0][0] = rg[0]);
      rg[0] > minMax[0][1] && (minMax[0][1] = rg[0]);
      rg[1] < minMax[1][0] && (minMax[1][0] = rg[1]);
      rg[1] > minMax[1][1] && (minMax[1][1] = rg[1]);
    }
    return minMax && getBoundingRectFromMinMax(minMax);
  }
};
function getBoundingRectFromMinMax(minMax) {
  return new BoundingRect$1(minMax[0][0], minMax[1][0], minMax[0][1] - minMax[0][0], minMax[1][1] - minMax[1][0]);
}
var BrushView = function(_super) {
  __extends(BrushView2, _super);
  function BrushView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushView2.type;
    return _this;
  }
  BrushView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
    this.model;
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this)).mount();
  };
  BrushView2.prototype.render = function(brushModel, ecModel, api, payload) {
    this.model = brushModel;
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateTransform = function(brushModel, ecModel, api, payload) {
    layoutCovers(ecModel);
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateVisual = function(brushModel, ecModel, api, payload) {
    this.updateTransform(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateView = function(brushModel, ecModel, api, payload) {
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype._updateController = function(brushModel, ecModel, api, payload) {
    (!payload || payload.$from !== brushModel.id) && this._brushController.setPanels(brushModel.brushTargetManager.makePanelOpts(api)).enableBrush(brushModel.brushOption).updateCovers(brushModel.areas.slice());
  };
  BrushView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  BrushView2.prototype._onBrush = function(eventParam) {
    var modelId = this.model.id;
    var areas = this.model.brushTargetManager.setOutputRanges(eventParam.areas, this.ecModel);
    (!eventParam.isEnd || eventParam.removeOnClick) && this.api.dispatchAction({
      type: "brush",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
    eventParam.isEnd && this.api.dispatchAction({
      type: "brushEnd",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
  };
  BrushView2.type = "brush";
  return BrushView2;
}(ComponentView$1);
var BrushView$1 = BrushView;
var DEFAULT_OUT_OF_BRUSH_COLOR = "#ddd";
var BrushModel = function(_super) {
  __extends(BrushModel2, _super);
  function BrushModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushModel2.type;
    _this.areas = [];
    _this.brushOption = {};
    return _this;
  }
  BrushModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, ["inBrush", "outOfBrush"]);
    var inBrush = thisOption.inBrush = thisOption.inBrush || {};
    thisOption.outOfBrush = thisOption.outOfBrush || {
      color: DEFAULT_OUT_OF_BRUSH_COLOR
    };
    if (!inBrush.hasOwnProperty("liftZ")) {
      inBrush.liftZ = 5;
    }
  };
  BrushModel2.prototype.setAreas = function(areas) {
    if (!areas) {
      return;
    }
    this.areas = map$1(areas, function(area) {
      return generateBrushOption(this.option, area);
    }, this);
  };
  BrushModel2.prototype.setBrushOption = function(brushOption) {
    this.brushOption = generateBrushOption(this.option, brushOption);
    this.brushType = this.brushOption.brushType;
  };
  BrushModel2.type = "brush";
  BrushModel2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"];
  BrushModel2.defaultOption = {
    seriesIndex: "all",
    brushType: "rect",
    brushMode: "single",
    transformable: true,
    brushStyle: {
      borderWidth: 1,
      color: "rgba(210,219,238,0.3)",
      borderColor: "#D2DBEE"
    },
    throttleType: "fixRate",
    throttleDelay: 0,
    removeOnClick: true,
    z: 1e4
  };
  return BrushModel2;
}(ComponentModel$1);
function generateBrushOption(option, brushOption) {
  return merge({
    brushType: option.brushType,
    brushMode: option.brushMode,
    transformable: option.transformable,
    brushStyle: new Model$1(option.brushStyle).getItemStyle(),
    removeOnClick: option.removeOnClick,
    z: option.z
  }, brushOption, true);
}
var BrushModel$1 = BrushModel;
var ICON_TYPES = ["rect", "polygon", "lineX", "lineY", "keep", "clear"];
var BrushFeature = function(_super) {
  __extends(BrushFeature2, _super);
  function BrushFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  BrushFeature2.prototype.render = function(featureModel, ecModel, api) {
    var brushType;
    var brushMode;
    var isBrushed;
    ecModel.eachComponent({
      mainType: "brush"
    }, function(brushModel) {
      brushType = brushModel.brushType;
      brushMode = brushModel.brushOption.brushMode || "single";
      isBrushed = isBrushed || !!brushModel.areas.length;
    });
    this._brushType = brushType;
    this._brushMode = brushMode;
    each$f(featureModel.get("type", true), function(type4) {
      featureModel.setIconStatus(type4, (type4 === "keep" ? brushMode === "multiple" : type4 === "clear" ? isBrushed : type4 === brushType) ? "emphasis" : "normal");
    });
  };
  BrushFeature2.prototype.updateView = function(featureModel, ecModel, api) {
    this.render(featureModel, ecModel, api);
  };
  BrushFeature2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon", true);
    var icons = {};
    each$f(model.get("type", true), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  BrushFeature2.prototype.onclick = function(ecModel, api, type4) {
    var brushType = this._brushType;
    var brushMode = this._brushMode;
    if (type4 === "clear") {
      api.dispatchAction({
        type: "axisAreaSelect",
        intervals: []
      });
      api.dispatchAction({
        type: "brush",
        command: "clear",
        areas: []
      });
    } else {
      api.dispatchAction({
        type: "takeGlobalCursor",
        key: "brush",
        brushOption: {
          brushType: type4 === "keep" ? brushType : brushType === type4 ? false : type4,
          brushMode: type4 === "keep" ? brushMode === "multiple" ? "single" : "multiple" : brushMode
        }
      });
    }
  };
  BrushFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: ICON_TYPES.slice(),
      icon: {
        rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13",
        polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2",
        lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4",
        lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4",
        keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z",
        clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "brush", "title"])
    };
    return defaultOption2;
  };
  return BrushFeature2;
}(ToolboxFeature);
var BrushFeature$1 = BrushFeature;
function install$h(registers) {
  registers.registerComponentView(BrushView$1);
  registers.registerComponentModel(BrushModel$1);
  registers.registerPreprocessor(brushPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, brushVisual);
  registers.registerAction({
    type: "brush",
    event: "brush",
    update: "updateVisual"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "brush",
      query: payload
    }, function(brushModel) {
      brushModel.setAreas(payload.areas);
    });
  });
  registers.registerAction({
    type: "brushSelect",
    event: "brushSelected",
    update: "none"
  }, noop);
  registers.registerAction({
    type: "brushEnd",
    event: "brushEnd",
    update: "none"
  }, noop);
  registerFeature("brush", BrushFeature$1);
}
var TitleModel = function(_super) {
  __extends(TitleModel2, _super);
  function TitleModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  TitleModel2.type = "title";
  TitleModel2.defaultOption = {
    z: 6,
    show: true,
    text: "",
    target: "blank",
    subtext: "",
    subtarget: "blank",
    left: 0,
    top: 0,
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    textStyle: {
      fontSize: 18,
      fontWeight: "bold",
      color: "#464646"
    },
    subtextStyle: {
      fontSize: 12,
      color: "#6E7079"
    }
  };
  return TitleModel2;
}(ComponentModel$1);
var TitleView = function(_super) {
  __extends(TitleView2, _super);
  function TitleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleView2.type;
    return _this;
  }
  TitleView2.prototype.render = function(titleModel, ecModel, api) {
    this.group.removeAll();
    if (!titleModel.get("show")) {
      return;
    }
    var group = this.group;
    var textStyleModel = titleModel.getModel("textStyle");
    var subtextStyleModel = titleModel.getModel("subtextStyle");
    var textAlign = titleModel.get("textAlign");
    var textVerticalAlign = retrieve2(titleModel.get("textBaseline"), titleModel.get("textVerticalAlign"));
    var textEl = new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: titleModel.get("text"),
        fill: textStyleModel.getTextColor()
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var textRect = textEl.getBoundingRect();
    var subText = titleModel.get("subtext");
    var subTextEl = new ZRText$1({
      style: createTextStyle(subtextStyleModel, {
        text: subText,
        fill: subtextStyleModel.getTextColor(),
        y: textRect.height + titleModel.get("itemGap"),
        verticalAlign: "top"
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var link = titleModel.get("link");
    var sublink = titleModel.get("sublink");
    var triggerEvent = titleModel.get("triggerEvent", true);
    textEl.silent = !link && !triggerEvent;
    subTextEl.silent = !sublink && !triggerEvent;
    if (link) {
      textEl.on("click", function() {
        windowOpen(link, "_" + titleModel.get("target"));
      });
    }
    if (sublink) {
      subTextEl.on("click", function() {
        windowOpen(sublink, "_" + titleModel.get("subtarget"));
      });
    }
    getECData(textEl).eventData = getECData(subTextEl).eventData = triggerEvent ? {
      componentType: "title",
      componentIndex: titleModel.componentIndex
    } : null;
    group.add(textEl);
    subText && group.add(subTextEl);
    var groupRect = group.getBoundingRect();
    var layoutOption = titleModel.getBoxLayoutParams();
    layoutOption.width = groupRect.width;
    layoutOption.height = groupRect.height;
    var layoutRect = getLayoutRect(layoutOption, {
      width: api.getWidth(),
      height: api.getHeight()
    }, titleModel.get("padding"));
    if (!textAlign) {
      textAlign = titleModel.get("left") || titleModel.get("right");
      if (textAlign === "middle") {
        textAlign = "center";
      }
      if (textAlign === "right") {
        layoutRect.x += layoutRect.width;
      } else if (textAlign === "center") {
        layoutRect.x += layoutRect.width / 2;
      }
    }
    if (!textVerticalAlign) {
      textVerticalAlign = titleModel.get("top") || titleModel.get("bottom");
      if (textVerticalAlign === "center") {
        textVerticalAlign = "middle";
      }
      if (textVerticalAlign === "bottom") {
        layoutRect.y += layoutRect.height;
      } else if (textVerticalAlign === "middle") {
        layoutRect.y += layoutRect.height / 2;
      }
      textVerticalAlign = textVerticalAlign || "top";
    }
    group.x = layoutRect.x;
    group.y = layoutRect.y;
    group.markRedraw();
    var alignStyle = {
      align: textAlign,
      verticalAlign: textVerticalAlign
    };
    textEl.setStyle(alignStyle);
    subTextEl.setStyle(alignStyle);
    groupRect = group.getBoundingRect();
    var padding = layoutRect.margin;
    var style = titleModel.getItemStyle(["color", "opacity"]);
    style.fill = titleModel.get("backgroundColor");
    var rect = new Rect$3({
      shape: {
        x: groupRect.x - padding[3],
        y: groupRect.y - padding[0],
        width: groupRect.width + padding[1] + padding[3],
        height: groupRect.height + padding[0] + padding[2],
        r: titleModel.get("borderRadius")
      },
      style,
      subPixelOptimize: true,
      silent: true
    });
    group.add(rect);
  };
  TitleView2.type = "title";
  return TitleView2;
}(ComponentView$1);
function install$g(registers) {
  registers.registerComponentModel(TitleModel);
  registers.registerComponentView(TitleView);
}
var TimelineModel = function(_super) {
  __extends(TimelineModel2, _super);
  function TimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineModel2.type;
    _this.layoutMode = "box";
    return _this;
  }
  TimelineModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._initData();
  };
  TimelineModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this._initData();
  };
  TimelineModel2.prototype.setCurrentIndex = function(currentIndex) {
    if (currentIndex == null) {
      currentIndex = this.option.currentIndex;
    }
    var count2 = this._data.count();
    if (this.option.loop) {
      currentIndex = (currentIndex % count2 + count2) % count2;
    } else {
      currentIndex >= count2 && (currentIndex = count2 - 1);
      currentIndex < 0 && (currentIndex = 0);
    }
    this.option.currentIndex = currentIndex;
  };
  TimelineModel2.prototype.getCurrentIndex = function() {
    return this.option.currentIndex;
  };
  TimelineModel2.prototype.isIndexMax = function() {
    return this.getCurrentIndex() >= this._data.count() - 1;
  };
  TimelineModel2.prototype.setPlayState = function(state) {
    this.option.autoPlay = !!state;
  };
  TimelineModel2.prototype.getPlayState = function() {
    return !!this.option.autoPlay;
  };
  TimelineModel2.prototype._initData = function() {
    var thisOption = this.option;
    var dataArr = thisOption.data || [];
    var axisType = thisOption.axisType;
    var names2 = this._names = [];
    var processedDataArr;
    if (axisType === "category") {
      processedDataArr = [];
      each$f(dataArr, function(item, index2) {
        var value = convertOptionIdName(getDataItemValue(item), "");
        var newItem;
        if (isObject$4(item)) {
          newItem = clone$4(item);
          newItem.value = index2;
        } else {
          newItem = index2;
        }
        processedDataArr.push(newItem);
        names2.push(value);
      });
    } else {
      processedDataArr = dataArr;
    }
    var dimType = {
      category: "ordinal",
      time: "time",
      value: "number"
    }[axisType] || "number";
    var data = this._data = new SeriesData$1([{
      name: "value",
      type: dimType
    }], this);
    data.initData(processedDataArr, names2);
  };
  TimelineModel2.prototype.getData = function() {
    return this._data;
  };
  TimelineModel2.prototype.getCategories = function() {
    if (this.get("axisType") === "category") {
      return this._names.slice();
    }
  };
  TimelineModel2.type = "timeline";
  TimelineModel2.defaultOption = {
    z: 4,
    show: true,
    axisType: "time",
    realtime: true,
    left: "20%",
    top: null,
    right: "20%",
    bottom: 0,
    width: null,
    height: 40,
    padding: 5,
    controlPosition: "left",
    autoPlay: false,
    rewind: false,
    loop: true,
    playInterval: 2e3,
    currentIndex: 0,
    itemStyle: {},
    label: {
      color: "#000"
    },
    data: []
  };
  return TimelineModel2;
}(ComponentModel$1);
var TimelineModel$1 = TimelineModel;
var SliderTimelineModel = function(_super) {
  __extends(SliderTimelineModel2, _super);
  function SliderTimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineModel2.type;
    return _this;
  }
  SliderTimelineModel2.type = "timeline.slider";
  SliderTimelineModel2.defaultOption = inheritDefaultOption(TimelineModel$1.defaultOption, {
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    orient: "horizontal",
    inverse: false,
    tooltip: {
      trigger: "item"
    },
    symbol: "circle",
    symbolSize: 12,
    lineStyle: {
      show: true,
      width: 2,
      color: "#DAE1F5"
    },
    label: {
      position: "auto",
      show: true,
      interval: "auto",
      rotate: 0,
      color: "#A4B1D7"
    },
    itemStyle: {
      color: "#A4B1D7",
      borderWidth: 1
    },
    checkpointStyle: {
      symbol: "circle",
      symbolSize: 15,
      color: "#316bf3",
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0, 0, 0, 0.3)",
      animation: true,
      animationDuration: 300,
      animationEasing: "quinticInOut"
    },
    controlStyle: {
      show: true,
      showPlayBtn: true,
      showPrevBtn: true,
      showNextBtn: true,
      itemSize: 24,
      itemGap: 12,
      position: "left",
      playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z",
      stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z",
      nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z",
      prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z",
      prevBtnSize: 18,
      nextBtnSize: 18,
      color: "#A4B1D7",
      borderColor: "#A4B1D7",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true,
        color: "#6f778d"
      },
      itemStyle: {
        color: "#316BF3"
      },
      controlStyle: {
        color: "#316BF3",
        borderColor: "#316BF3",
        borderWidth: 2
      }
    },
    progress: {
      lineStyle: {
        color: "#316BF3"
      },
      itemStyle: {
        color: "#316BF3"
      },
      label: {
        color: "#6f778d"
      }
    },
    data: []
  });
  return SliderTimelineModel2;
}(TimelineModel$1);
mixin(SliderTimelineModel, DataFormatMixin.prototype);
var SliderTimelineModel$1 = SliderTimelineModel;
var TimelineView = function(_super) {
  __extends(TimelineView2, _super);
  function TimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineView2.type;
    return _this;
  }
  TimelineView2.type = "timeline";
  return TimelineView2;
}(ComponentView$1);
var TimelineView$1 = TimelineView;
var TimelineAxis = function(_super) {
  __extends(TimelineAxis2, _super);
  function TimelineAxis2(dim, scale2, coordExtent, axisType) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    return _this;
  }
  TimelineAxis2.prototype.getLabelModel = function() {
    return this.model.getModel("label");
  };
  TimelineAxis2.prototype.isHorizontal = function() {
    return this.model.get("orient") === "horizontal";
  };
  return TimelineAxis2;
}(Axis$1);
var TimelineAxis$1 = TimelineAxis;
var PI = Math.PI;
var labelDataIndexStore = makeInner();
var SliderTimelineView = function(_super) {
  __extends(SliderTimelineView2, _super);
  function SliderTimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineView2.type;
    return _this;
  }
  SliderTimelineView2.prototype.init = function(ecModel, api) {
    this.api = api;
  };
  SliderTimelineView2.prototype.render = function(timelineModel, ecModel, api) {
    this.model = timelineModel;
    this.api = api;
    this.ecModel = ecModel;
    this.group.removeAll();
    if (timelineModel.get("show", true)) {
      var layoutInfo_1 = this._layout(timelineModel, api);
      var mainGroup_1 = this._createGroup("_mainGroup");
      var labelGroup = this._createGroup("_labelGroup");
      var axis_1 = this._axis = this._createAxis(layoutInfo_1, timelineModel);
      timelineModel.formatTooltip = function(dataIndex) {
        var name = axis_1.scale.getLabel({
          value: dataIndex
        });
        return createTooltipMarkup("nameValue", {
          noName: true,
          value: name
        });
      };
      each$f(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(name) {
        this["_render" + name](layoutInfo_1, mainGroup_1, axis_1, timelineModel);
      }, this);
      this._renderAxisLabel(layoutInfo_1, labelGroup, axis_1, timelineModel);
      this._position(layoutInfo_1, timelineModel);
    }
    this._doPlayStop();
    this._updateTicksStatus();
  };
  SliderTimelineView2.prototype.remove = function() {
    this._clearTimer();
    this.group.removeAll();
  };
  SliderTimelineView2.prototype.dispose = function() {
    this._clearTimer();
  };
  SliderTimelineView2.prototype._layout = function(timelineModel, api) {
    var labelPosOpt = timelineModel.get(["label", "position"]);
    var orient = timelineModel.get("orient");
    var viewRect2 = getViewRect(timelineModel, api);
    var parsedLabelPos;
    if (labelPosOpt == null || labelPosOpt === "auto") {
      parsedLabelPos = orient === "horizontal" ? viewRect2.y + viewRect2.height / 2 < api.getHeight() / 2 ? "-" : "+" : viewRect2.x + viewRect2.width / 2 < api.getWidth() / 2 ? "+" : "-";
    } else if (isString(labelPosOpt)) {
      parsedLabelPos = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[orient][labelPosOpt];
    } else {
      parsedLabelPos = labelPosOpt;
    }
    var labelAlignMap = {
      horizontal: "center",
      vertical: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "left" : "right"
    };
    var labelBaselineMap = {
      horizontal: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "top" : "bottom",
      vertical: "middle"
    };
    var rotationMap = {
      horizontal: 0,
      vertical: PI / 2
    };
    var mainLength = orient === "vertical" ? viewRect2.height : viewRect2.width;
    var controlModel = timelineModel.getModel("controlStyle");
    var showControl = controlModel.get("show", true);
    var controlSize = showControl ? controlModel.get("itemSize") : 0;
    var controlGap = showControl ? controlModel.get("itemGap") : 0;
    var sizePlusGap = controlSize + controlGap;
    var labelRotation = timelineModel.get(["label", "rotate"]) || 0;
    labelRotation = labelRotation * PI / 180;
    var playPosition;
    var prevBtnPosition;
    var nextBtnPosition;
    var controlPosition = controlModel.get("position", true);
    var showPlayBtn = showControl && controlModel.get("showPlayBtn", true);
    var showPrevBtn = showControl && controlModel.get("showPrevBtn", true);
    var showNextBtn = showControl && controlModel.get("showNextBtn", true);
    var xLeft = 0;
    var xRight = mainLength;
    if (controlPosition === "left" || controlPosition === "bottom") {
      showPlayBtn && (playPosition = [0, 0], xLeft += sizePlusGap);
      showPrevBtn && (prevBtnPosition = [xLeft, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    } else {
      showPlayBtn && (playPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
      showPrevBtn && (prevBtnPosition = [0, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    }
    var axisExtent = [xLeft, xRight];
    if (timelineModel.get("inverse")) {
      axisExtent.reverse();
    }
    return {
      viewRect: viewRect2,
      mainLength,
      orient,
      rotation: rotationMap[orient],
      labelRotation,
      labelPosOpt: parsedLabelPos,
      labelAlign: timelineModel.get(["label", "align"]) || labelAlignMap[orient],
      labelBaseline: timelineModel.get(["label", "verticalAlign"]) || timelineModel.get(["label", "baseline"]) || labelBaselineMap[orient],
      playPosition,
      prevBtnPosition,
      nextBtnPosition,
      axisExtent,
      controlSize,
      controlGap
    };
  };
  SliderTimelineView2.prototype._position = function(layoutInfo, timelineModel) {
    var mainGroup = this._mainGroup;
    var labelGroup = this._labelGroup;
    var viewRect2 = layoutInfo.viewRect;
    if (layoutInfo.orient === "vertical") {
      var m2 = create$1();
      var rotateOriginX = viewRect2.x;
      var rotateOriginY = viewRect2.y + viewRect2.height;
      translate(m2, m2, [-rotateOriginX, -rotateOriginY]);
      rotate(m2, m2, -PI / 2);
      translate(m2, m2, [rotateOriginX, rotateOriginY]);
      viewRect2 = viewRect2.clone();
      viewRect2.applyTransform(m2);
    }
    var viewBound = getBound(viewRect2);
    var mainBound = getBound(mainGroup.getBoundingRect());
    var labelBound = getBound(labelGroup.getBoundingRect());
    var mainPosition = [mainGroup.x, mainGroup.y];
    var labelsPosition = [labelGroup.x, labelGroup.y];
    labelsPosition[0] = mainPosition[0] = viewBound[0][0];
    var labelPosOpt = layoutInfo.labelPosOpt;
    if (labelPosOpt == null || isString(labelPosOpt)) {
      var mainBoundIdx = labelPosOpt === "+" ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      toBound(labelsPosition, labelBound, viewBound, 1, 1 - mainBoundIdx);
    } else {
      var mainBoundIdx = labelPosOpt >= 0 ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      labelsPosition[1] = mainPosition[1] + labelPosOpt;
    }
    mainGroup.setPosition(mainPosition);
    labelGroup.setPosition(labelsPosition);
    mainGroup.rotation = labelGroup.rotation = layoutInfo.rotation;
    setOrigin(mainGroup);
    setOrigin(labelGroup);
    function setOrigin(targetGroup) {
      targetGroup.originX = viewBound[0][0] - targetGroup.x;
      targetGroup.originY = viewBound[1][0] - targetGroup.y;
    }
    function getBound(rect) {
      return [[rect.x, rect.x + rect.width], [rect.y, rect.y + rect.height]];
    }
    function toBound(fromPos, from, to, dimIdx, boundIdx) {
      fromPos[dimIdx] += to[dimIdx][boundIdx] - from[dimIdx][boundIdx];
    }
  };
  SliderTimelineView2.prototype._createAxis = function(layoutInfo, timelineModel) {
    var data = timelineModel.getData();
    var axisType = timelineModel.get("axisType");
    var scale2 = createScaleByModel(timelineModel, axisType);
    scale2.getTicks = function() {
      return data.mapArray(["value"], function(value) {
        return {
          value
        };
      });
    };
    var dataExtent = data.getDataExtent("value");
    scale2.setExtent(dataExtent[0], dataExtent[1]);
    scale2.calcNiceTicks();
    var axis = new TimelineAxis$1("value", scale2, layoutInfo.axisExtent, axisType);
    axis.model = timelineModel;
    return axis;
  };
  SliderTimelineView2.prototype._createGroup = function(key) {
    var newGroup = this[key] = new Group$4();
    this.group.add(newGroup);
    return newGroup;
  };
  SliderTimelineView2.prototype._renderAxisLine = function(layoutInfo, group, axis, timelineModel) {
    var axisExtent = axis.getExtent();
    if (!timelineModel.get(["lineStyle", "show"])) {
      return;
    }
    var line = new Line$3({
      shape: {
        x1: axisExtent[0],
        y1: 0,
        x2: axisExtent[1],
        y2: 0
      },
      style: extend({
        lineCap: "round"
      }, timelineModel.getModel("lineStyle").getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(line);
    var progressLine = this._progressLine = new Line$3({
      shape: {
        x1: axisExtent[0],
        x2: this._currentPointer ? this._currentPointer.x : axisExtent[0],
        y1: 0,
        y2: 0
      },
      style: defaults({
        lineCap: "round",
        lineWidth: line.style.lineWidth
      }, timelineModel.getModel(["progress", "lineStyle"]).getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(progressLine);
  };
  SliderTimelineView2.prototype._renderAxisTick = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var data = timelineModel.getData();
    var ticks = axis.scale.getTicks();
    this._tickSymbols = [];
    each$f(ticks, function(tick) {
      var tickCoord = axis.dataToCoord(tick.value);
      var itemModel = data.getItemModel(tick.value);
      var itemStyleModel = itemModel.getModel("itemStyle");
      var hoverStyleModel = itemModel.getModel(["emphasis", "itemStyle"]);
      var progressStyleModel = itemModel.getModel(["progress", "itemStyle"]);
      var symbolOpt = {
        x: tickCoord,
        y: 0,
        onclick: bind$1(_this._changeTimeline, _this, tick.value)
      };
      var el = giveSymbol(itemModel, itemStyleModel, group, symbolOpt);
      el.ensureState("emphasis").style = hoverStyleModel.getItemStyle();
      el.ensureState("progress").style = progressStyleModel.getItemStyle();
      enableHoverEmphasis(el);
      var ecData = getECData(el);
      if (itemModel.get("tooltip")) {
        ecData.dataIndex = tick.value;
        ecData.dataModel = timelineModel;
      } else {
        ecData.dataIndex = ecData.dataModel = null;
      }
      _this._tickSymbols.push(el);
    });
  };
  SliderTimelineView2.prototype._renderAxisLabel = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var labelModel = axis.getLabelModel();
    if (!labelModel.get("show")) {
      return;
    }
    var data = timelineModel.getData();
    var labels = axis.getViewLabels();
    this._tickLabels = [];
    each$f(labels, function(labelItem) {
      var dataIndex = labelItem.tickValue;
      var itemModel = data.getItemModel(dataIndex);
      var normalLabelModel = itemModel.getModel("label");
      var hoverLabelModel = itemModel.getModel(["emphasis", "label"]);
      var progressLabelModel = itemModel.getModel(["progress", "label"]);
      var tickCoord = axis.dataToCoord(labelItem.tickValue);
      var textEl = new ZRText$1({
        x: tickCoord,
        y: 0,
        rotation: layoutInfo.labelRotation - layoutInfo.rotation,
        onclick: bind$1(_this._changeTimeline, _this, dataIndex),
        silent: false,
        style: createTextStyle(normalLabelModel, {
          text: labelItem.formattedLabel,
          align: layoutInfo.labelAlign,
          verticalAlign: layoutInfo.labelBaseline
        })
      });
      textEl.ensureState("emphasis").style = createTextStyle(hoverLabelModel);
      textEl.ensureState("progress").style = createTextStyle(progressLabelModel);
      group.add(textEl);
      enableHoverEmphasis(textEl);
      labelDataIndexStore(textEl).dataIndex = dataIndex;
      _this._tickLabels.push(textEl);
    });
  };
  SliderTimelineView2.prototype._renderControl = function(layoutInfo, group, axis, timelineModel) {
    var controlSize = layoutInfo.controlSize;
    var rotation = layoutInfo.rotation;
    var itemStyle = timelineModel.getModel("controlStyle").getItemStyle();
    var hoverStyle = timelineModel.getModel(["emphasis", "controlStyle"]).getItemStyle();
    var playState = timelineModel.getPlayState();
    var inverse = timelineModel.get("inverse", true);
    makeBtn(layoutInfo.nextBtnPosition, "next", bind$1(this._changeTimeline, this, inverse ? "-" : "+"));
    makeBtn(layoutInfo.prevBtnPosition, "prev", bind$1(this._changeTimeline, this, inverse ? "+" : "-"));
    makeBtn(layoutInfo.playPosition, playState ? "stop" : "play", bind$1(this._handlePlayClick, this, !playState), true);
    function makeBtn(position2, iconName, onclick, willRotate) {
      if (!position2) {
        return;
      }
      var iconSize = parsePercent$1(retrieve2(timelineModel.get(["controlStyle", iconName + "BtnSize"]), controlSize), controlSize);
      var rect = [0, -iconSize / 2, iconSize, iconSize];
      var btn = makeControlIcon(timelineModel, iconName + "Icon", rect, {
        x: position2[0],
        y: position2[1],
        originX: controlSize / 2,
        originY: 0,
        rotation: willRotate ? -rotation : 0,
        rectHover: true,
        style: itemStyle,
        onclick
      });
      btn.ensureState("emphasis").style = hoverStyle;
      group.add(btn);
      enableHoverEmphasis(btn);
    }
  };
  SliderTimelineView2.prototype._renderCurrentPointer = function(layoutInfo, group, axis, timelineModel) {
    var data = timelineModel.getData();
    var currentIndex = timelineModel.getCurrentIndex();
    var pointerModel = data.getItemModel(currentIndex).getModel("checkpointStyle");
    var me = this;
    var callback = {
      onCreate: function(pointer) {
        pointer.draggable = true;
        pointer.drift = bind$1(me._handlePointerDrag, me);
        pointer.ondragend = bind$1(me._handlePointerDragend, me);
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel, true);
      },
      onUpdate: function(pointer) {
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel);
      }
    };
    this._currentPointer = giveSymbol(pointerModel, pointerModel, this._mainGroup, {}, this._currentPointer, callback);
  };
  SliderTimelineView2.prototype._handlePlayClick = function(nextState) {
    this._clearTimer();
    this.api.dispatchAction({
      type: "timelinePlayChange",
      playState: nextState,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._handlePointerDrag = function(dx, dy, e2) {
    this._clearTimer();
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY]);
  };
  SliderTimelineView2.prototype._handlePointerDragend = function(e2) {
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
  };
  SliderTimelineView2.prototype._pointerChangeTimeline = function(mousePos, trigger2) {
    var toCoord = this._toAxisCoord(mousePos)[0];
    var axis = this._axis;
    var axisExtent = asc$2(axis.getExtent().slice());
    toCoord > axisExtent[1] && (toCoord = axisExtent[1]);
    toCoord < axisExtent[0] && (toCoord = axisExtent[0]);
    this._currentPointer.x = toCoord;
    this._currentPointer.markRedraw();
    this._progressLine.shape.x2 = toCoord;
    this._progressLine.dirty();
    var targetDataIndex = this._findNearestTick(toCoord);
    var timelineModel = this.model;
    if (trigger2 || targetDataIndex !== timelineModel.getCurrentIndex() && timelineModel.get("realtime")) {
      this._changeTimeline(targetDataIndex);
    }
  };
  SliderTimelineView2.prototype._doPlayStop = function() {
    var _this = this;
    this._clearTimer();
    if (this.model.getPlayState()) {
      this._timer = setTimeout(function() {
        var timelineModel = _this.model;
        _this._changeTimeline(timelineModel.getCurrentIndex() + (timelineModel.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval"));
    }
  };
  SliderTimelineView2.prototype._toAxisCoord = function(vertex) {
    var trans = this._mainGroup.getLocalTransform();
    return applyTransform(vertex, trans, true);
  };
  SliderTimelineView2.prototype._findNearestTick = function(axisCoord) {
    var data = this.model.getData();
    var dist2 = Infinity;
    var targetDataIndex;
    var axis = this._axis;
    data.each(["value"], function(value, dataIndex) {
      var coord = axis.dataToCoord(value);
      var d2 = Math.abs(coord - axisCoord);
      if (d2 < dist2) {
        dist2 = d2;
        targetDataIndex = dataIndex;
      }
    });
    return targetDataIndex;
  };
  SliderTimelineView2.prototype._clearTimer = function() {
    if (this._timer) {
      clearTimeout(this._timer);
      this._timer = null;
    }
  };
  SliderTimelineView2.prototype._changeTimeline = function(nextIndex) {
    var currentIndex = this.model.getCurrentIndex();
    if (nextIndex === "+") {
      nextIndex = currentIndex + 1;
    } else if (nextIndex === "-") {
      nextIndex = currentIndex - 1;
    }
    this.api.dispatchAction({
      type: "timelineChange",
      currentIndex: nextIndex,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._updateTicksStatus = function() {
    var currentIndex = this.model.getCurrentIndex();
    var tickSymbols = this._tickSymbols;
    var tickLabels = this._tickLabels;
    if (tickSymbols) {
      for (var i = 0; i < tickSymbols.length; i++) {
        tickSymbols && tickSymbols[i] && tickSymbols[i].toggleState("progress", i < currentIndex);
      }
    }
    if (tickLabels) {
      for (var i = 0; i < tickLabels.length; i++) {
        tickLabels && tickLabels[i] && tickLabels[i].toggleState("progress", labelDataIndexStore(tickLabels[i]).dataIndex <= currentIndex);
      }
    }
  };
  SliderTimelineView2.type = "timeline.slider";
  return SliderTimelineView2;
}(TimelineView$1);
function createScaleByModel(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new IntervalScale$1();
    }
  }
}
function getViewRect(model, api) {
  return getLayoutRect(model.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  }, model.get("padding"));
}
function makeControlIcon(timelineModel, objPath, rect, opts) {
  var style = opts.style;
  var icon = createIcon(timelineModel.get(["controlStyle", objPath]), opts || {}, new BoundingRect$1(rect[0], rect[1], rect[2], rect[3]));
  if (style) {
    icon.setStyle(style);
  }
  return icon;
}
function giveSymbol(hostModel, itemStyleModel, group, opt, symbol, callback) {
  var color = itemStyleModel.get("color");
  if (!symbol) {
    var symbolType = hostModel.get("symbol");
    symbol = createSymbol$1(symbolType, -1, -1, 2, 2, color);
    symbol.setStyle("strokeNoScale", true);
    group.add(symbol);
    callback && callback.onCreate(symbol);
  } else {
    symbol.setColor(color);
    group.add(symbol);
    callback && callback.onUpdate(symbol);
  }
  var itemStyle = itemStyleModel.getItemStyle(["color"]);
  symbol.setStyle(itemStyle);
  opt = merge({
    rectHover: true,
    z2: 100
  }, opt, true);
  var symbolSize = normalizeSymbolSize(hostModel.get("symbolSize"));
  opt.scaleX = symbolSize[0] / 2;
  opt.scaleY = symbolSize[1] / 2;
  var symbolOffset = normalizeSymbolOffset(hostModel.get("symbolOffset"), symbolSize);
  if (symbolOffset) {
    opt.x = (opt.x || 0) + symbolOffset[0];
    opt.y = (opt.y || 0) + symbolOffset[1];
  }
  var symbolRotate = hostModel.get("symbolRotate");
  opt.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  symbol.attr(opt);
  symbol.updateTransform();
  return symbol;
}
function pointerMoveTo(pointer, progressLine, dataIndex, axis, timelineModel, noAnimation) {
  if (pointer.dragging) {
    return;
  }
  var pointerModel = timelineModel.getModel("checkpointStyle");
  var toCoord = axis.dataToCoord(timelineModel.getData().get("value", dataIndex));
  if (noAnimation || !pointerModel.get("animation", true)) {
    pointer.attr({
      x: toCoord,
      y: 0
    });
    progressLine && progressLine.attr({
      shape: {
        x2: toCoord
      }
    });
  } else {
    var animationCfg = {
      duration: pointerModel.get("animationDuration", true),
      easing: pointerModel.get("animationEasing", true)
    };
    pointer.stopAnimation(null, true);
    pointer.animateTo({
      x: toCoord,
      y: 0
    }, animationCfg);
    progressLine && progressLine.animateTo({
      shape: {
        x2: toCoord
      }
    }, animationCfg);
  }
}
var SliderTimelineView$1 = SliderTimelineView;
function installTimelineAction(registers) {
  registers.registerAction({
    type: "timelineChange",
    event: "timelineChanged",
    update: "prepareAndUpdate"
  }, function(payload, ecModel, api) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.currentIndex != null) {
      timelineModel.setCurrentIndex(payload.currentIndex);
      if (!timelineModel.get("loop", true) && timelineModel.isIndexMax() && timelineModel.getPlayState()) {
        timelineModel.setPlayState(false);
        api.dispatchAction({
          type: "timelinePlayChange",
          playState: false,
          from: payload.from
        });
      }
    }
    ecModel.resetOption("timeline", {
      replaceMerge: timelineModel.get("replaceMerge", true)
    });
    return defaults({
      currentIndex: timelineModel.option.currentIndex
    }, payload);
  });
  registers.registerAction({
    type: "timelinePlayChange",
    event: "timelinePlayChanged",
    update: "update"
  }, function(payload, ecModel) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.playState != null) {
      timelineModel.setPlayState(payload.playState);
    }
  });
}
function timelinePreprocessor(option) {
  var timelineOpt = option && option.timeline;
  if (!isArray$1(timelineOpt)) {
    timelineOpt = timelineOpt ? [timelineOpt] : [];
  }
  each$f(timelineOpt, function(opt) {
    if (!opt) {
      return;
    }
    compatibleEC2(opt);
  });
}
function compatibleEC2(opt) {
  var type4 = opt.type;
  var ec2Types = {
    "number": "value",
    "time": "time"
  };
  if (ec2Types[type4]) {
    opt.axisType = ec2Types[type4];
    delete opt.type;
  }
  transferItem(opt);
  if (has$1(opt, "controlPosition")) {
    var controlStyle = opt.controlStyle || (opt.controlStyle = {});
    if (!has$1(controlStyle, "position")) {
      controlStyle.position = opt.controlPosition;
    }
    if (controlStyle.position === "none" && !has$1(controlStyle, "show")) {
      controlStyle.show = false;
      delete controlStyle.position;
    }
    delete opt.controlPosition;
  }
  each$f(opt.data || [], function(dataItem) {
    if (isObject$4(dataItem) && !isArray$1(dataItem)) {
      if (!has$1(dataItem, "value") && has$1(dataItem, "name")) {
        dataItem.value = dataItem.name;
      }
      transferItem(dataItem);
    }
  });
}
function transferItem(opt) {
  var itemStyle = opt.itemStyle || (opt.itemStyle = {});
  var itemStyleEmphasis = itemStyle.emphasis || (itemStyle.emphasis = {});
  var label = opt.label || opt.label || {};
  var labelNormal = label.normal || (label.normal = {});
  var excludeLabelAttr = {
    normal: 1,
    emphasis: 1
  };
  each$f(label, function(value, name) {
    if (!excludeLabelAttr[name] && !has$1(labelNormal, name)) {
      labelNormal[name] = value;
    }
  });
  if (itemStyleEmphasis.label && !has$1(label, "emphasis")) {
    label.emphasis = itemStyleEmphasis.label;
    delete itemStyleEmphasis.label;
  }
}
function has$1(obj, attr) {
  return obj.hasOwnProperty(attr);
}
function install$f(registers) {
  registers.registerComponentModel(SliderTimelineModel$1);
  registers.registerComponentView(SliderTimelineView$1);
  registers.registerSubTypeDefaulter("timeline", function() {
    return "slider";
  });
  installTimelineAction(registers);
  registers.registerPreprocessor(timelinePreprocessor);
}
function checkMarkerInSeries(seriesOpts, markerType) {
  if (!seriesOpts) {
    return false;
  }
  var seriesOptArr = isArray$1(seriesOpts) ? seriesOpts : [seriesOpts];
  for (var idx = 0; idx < seriesOptArr.length; idx++) {
    if (seriesOptArr[idx] && seriesOptArr[idx][markerType]) {
      return true;
    }
  }
  return false;
}
function fillLabel(opt) {
  defaultEmphasis(opt, "label", ["show"]);
}
var inner$5 = makeInner();
var MarkerModel = function(_super) {
  __extends(MarkerModel2, _super);
  function MarkerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerModel2.type;
    _this.createdBySelf = false;
    return _this;
  }
  MarkerModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._mergeOption(option, ecModel, false, true);
  };
  MarkerModel2.prototype.isAnimationEnabled = function() {
    if (env$1.node) {
      return false;
    }
    var hostSeries = this.__hostSeries;
    return this.getShallow("animation") && hostSeries && hostSeries.isAnimationEnabled();
  };
  MarkerModel2.prototype.mergeOption = function(newOpt, ecModel) {
    this._mergeOption(newOpt, ecModel, false, false);
  };
  MarkerModel2.prototype._mergeOption = function(newOpt, ecModel, createdBySelf, isInit) {
    var componentType = this.mainType;
    if (!createdBySelf) {
      ecModel.eachSeries(function(seriesModel) {
        var markerOpt = seriesModel.get(this.mainType, true);
        var markerModel = inner$5(seriesModel)[componentType];
        if (!markerOpt || !markerOpt.data) {
          inner$5(seriesModel)[componentType] = null;
          return;
        }
        if (!markerModel) {
          if (isInit) {
            fillLabel(markerOpt);
          }
          each$f(markerOpt.data, function(item) {
            if (item instanceof Array) {
              fillLabel(item[0]);
              fillLabel(item[1]);
            } else {
              fillLabel(item);
            }
          });
          markerModel = this.createMarkerModelFromSeries(markerOpt, this, ecModel);
          extend(markerModel, {
            mainType: this.mainType,
            seriesIndex: seriesModel.seriesIndex,
            name: seriesModel.name,
            createdBySelf: true
          });
          markerModel.__hostSeries = seriesModel;
        } else {
          markerModel._mergeOption(markerOpt, ecModel, true);
        }
        inner$5(seriesModel)[componentType] = markerModel;
      }, this);
    }
  };
  MarkerModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var itemName = data.getName(dataIndex);
    return createTooltipMarkup("section", {
      header: this.name,
      blocks: [createTooltipMarkup("nameValue", {
        name: itemName,
        value,
        noName: !itemName,
        noValue: value == null
      })]
    });
  };
  MarkerModel2.prototype.getData = function() {
    return this._data;
  };
  MarkerModel2.prototype.setData = function(data) {
    this._data = data;
  };
  MarkerModel2.getMarkerModelFromSeries = function(seriesModel, componentType) {
    return inner$5(seriesModel)[componentType];
  };
  MarkerModel2.type = "marker";
  MarkerModel2.dependencies = ["series", "grid", "polar", "geo"];
  return MarkerModel2;
}(ComponentModel$1);
mixin(MarkerModel, DataFormatMixin.prototype);
var MarkerModel$1 = MarkerModel;
var MarkPointModel = function(_super) {
  __extends(MarkPointModel2, _super);
  function MarkPointModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointModel2.type;
    return _this;
  }
  MarkPointModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkPointModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkPointModel2.type = "markPoint";
  MarkPointModel2.defaultOption = {
    z: 5,
    symbol: "pin",
    symbolSize: 50,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "inside"
    },
    itemStyle: {
      borderWidth: 2
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return MarkPointModel2;
}(MarkerModel$1);
var MarkPointModel$1 = MarkPointModel;
function hasXOrY(item) {
  return !(isNaN(parseFloat(item.x)) && isNaN(parseFloat(item.y)));
}
function hasXAndY(item) {
  return !isNaN(parseFloat(item.x)) && !isNaN(parseFloat(item.y));
}
function markerTypeCalculatorWithExtent(markerType, data, otherDataDim, targetDataDim, otherCoordIndex, targetCoordIndex) {
  var coordArr = [];
  var stacked = isDimensionStacked(data, targetDataDim);
  var calcDataDim = stacked ? data.getCalculationInfo("stackResultDimension") : targetDataDim;
  var value = numCalculate(data, calcDataDim, markerType);
  var dataIndex = data.indicesOfNearest(calcDataDim, value)[0];
  coordArr[otherCoordIndex] = data.get(otherDataDim, dataIndex);
  coordArr[targetCoordIndex] = data.get(calcDataDim, dataIndex);
  var coordArrValue = data.get(targetDataDim, dataIndex);
  var precision = getPrecision(data.get(targetDataDim, dataIndex));
  precision = Math.min(precision, 20);
  if (precision >= 0) {
    coordArr[targetCoordIndex] = +coordArr[targetCoordIndex].toFixed(precision);
  }
  return [coordArr, coordArrValue];
}
var markerTypeCalculator = {
  min: curry$1(markerTypeCalculatorWithExtent, "min"),
  max: curry$1(markerTypeCalculatorWithExtent, "max"),
  average: curry$1(markerTypeCalculatorWithExtent, "average"),
  median: curry$1(markerTypeCalculatorWithExtent, "median")
};
function dataTransform(seriesModel, item) {
  var data = seriesModel.getData();
  var coordSys = seriesModel.coordinateSystem;
  if (item && !hasXAndY(item) && !isArray$1(item.coord) && coordSys) {
    var dims = coordSys.dimensions;
    var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
    item = clone$4(item);
    if (item.type && markerTypeCalculator[item.type] && axisInfo.baseAxis && axisInfo.valueAxis) {
      var otherCoordIndex = indexOf(dims, axisInfo.baseAxis.dim);
      var targetCoordIndex = indexOf(dims, axisInfo.valueAxis.dim);
      var coordInfo = markerTypeCalculator[item.type](data, axisInfo.baseDataDim, axisInfo.valueDataDim, otherCoordIndex, targetCoordIndex);
      item.coord = coordInfo[0];
      item.value = coordInfo[1];
    } else {
      var coord = [item.xAxis != null ? item.xAxis : item.radiusAxis, item.yAxis != null ? item.yAxis : item.angleAxis];
      for (var i = 0; i < 2; i++) {
        if (markerTypeCalculator[coord[i]]) {
          coord[i] = numCalculate(data, data.mapDimension(dims[i]), coord[i]);
        }
      }
      item.coord = coord;
    }
  }
  return item;
}
function getAxisInfo(item, data, coordSys, seriesModel) {
  var ret = {};
  if (item.valueIndex != null || item.valueDim != null) {
    ret.valueDataDim = item.valueIndex != null ? data.getDimension(item.valueIndex) : item.valueDim;
    ret.valueAxis = coordSys.getAxis(dataDimToCoordDim(seriesModel, ret.valueDataDim));
    ret.baseAxis = coordSys.getOtherAxis(ret.valueAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
  } else {
    ret.baseAxis = seriesModel.getBaseAxis();
    ret.valueAxis = coordSys.getOtherAxis(ret.baseAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
    ret.valueDataDim = data.mapDimension(ret.valueAxis.dim);
  }
  return ret;
}
function dataDimToCoordDim(seriesModel, dataDim) {
  var dimItem = seriesModel.getData().getDimensionInfo(dataDim);
  return dimItem && dimItem.coordDim;
}
function dataFilter(coordSys, item) {
  return coordSys && coordSys.containData && item.coord && !hasXOrY(item) ? coordSys.containData(item.coord) : true;
}
function createMarkerDimValueGetter(inCoordSys, dims) {
  return inCoordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = dimIndex < 2 ? item.coord && item.coord[dimIndex] : item.value;
    return parseDataValue(rawVal, dims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dims[dimIndex]);
  };
}
function numCalculate(data, valueDataDim, type4) {
  if (type4 === "average") {
    var sum_1 = 0;
    var count_1 = 0;
    data.each(valueDataDim, function(val, idx) {
      if (!isNaN(val)) {
        sum_1 += val;
        count_1++;
      }
    });
    return sum_1 / count_1;
  } else if (type4 === "median") {
    return data.getMedian(valueDataDim);
  } else {
    return data.getDataExtent(valueDataDim)[type4 === "max" ? 1 : 0];
  }
}
var inner$4 = makeInner();
var MarkerView = function(_super) {
  __extends(MarkerView2, _super);
  function MarkerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerView2.type;
    return _this;
  }
  MarkerView2.prototype.init = function() {
    this.markerGroupMap = createHashMap();
  };
  MarkerView2.prototype.render = function(markerModel, ecModel, api) {
    var _this = this;
    var markerGroupMap = this.markerGroupMap;
    markerGroupMap.each(function(item) {
      inner$4(item).keep = false;
    });
    ecModel.eachSeries(function(seriesModel) {
      var markerModel2 = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      markerModel2 && _this.renderSeries(seriesModel, markerModel2, ecModel, api);
    });
    markerGroupMap.each(function(item) {
      !inner$4(item).keep && _this.group.remove(item.group);
    });
  };
  MarkerView2.prototype.markKeep = function(drawGroup) {
    inner$4(drawGroup).keep = true;
  };
  MarkerView2.prototype.blurSeries = function(seriesModelList) {
    var _this = this;
    each$f(seriesModelList, function(seriesModel) {
      var markerModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      if (markerModel) {
        var data = markerModel.getData();
        data.eachItemGraphicEl(function(el) {
          if (el) {
            enterBlur(el);
          }
        });
      }
    });
  };
  MarkerView2.type = "marker";
  return MarkerView2;
}(ComponentView$1);
var MarkerView$1 = MarkerView;
function updateMarkerLayout(mpData, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  mpData.each(function(idx) {
    var itemModel = mpData.getItemModel(idx);
    var point;
    var xPx = parsePercent(itemModel.get("x"), api.getWidth());
    var yPx = parsePercent(itemModel.get("y"), api.getHeight());
    if (!isNaN(xPx) && !isNaN(yPx)) {
      point = [xPx, yPx];
    } else if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(mpData.getValues(mpData.dimensions, idx));
    } else if (coordSys) {
      var x2 = mpData.get(coordSys.dimensions[0], idx);
      var y2 = mpData.get(coordSys.dimensions[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
    mpData.setItemLayout(idx, point);
  });
}
var MarkPointView = function(_super) {
  __extends(MarkPointView2, _super);
  function MarkPointView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointView2.type;
    return _this;
  }
  MarkPointView2.prototype.updateTransform = function(markPointModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mpModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markPoint");
      if (mpModel) {
        updateMarkerLayout(mpModel.getData(), seriesModel, api);
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkPointView2.prototype.renderSeries = function(seriesModel, mpModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var symbolDrawMap = this.markerGroupMap;
    var symbolDraw = symbolDrawMap.get(seriesId) || symbolDrawMap.set(seriesId, new SymbolDraw$1());
    var mpData = createData(coordSys, seriesModel, mpModel);
    mpModel.setData(mpData);
    updateMarkerLayout(mpModel.getData(), seriesModel, api);
    mpData.each(function(idx) {
      var itemModel = mpData.getItemModel(idx);
      var symbol = itemModel.getShallow("symbol");
      var symbolSize = itemModel.getShallow("symbolSize");
      var symbolRotate = itemModel.getShallow("symbolRotate");
      var symbolOffset = itemModel.getShallow("symbolOffset");
      var symbolKeepAspect = itemModel.getShallow("symbolKeepAspect");
      if (isFunction(symbol) || isFunction(symbolSize) || isFunction(symbolRotate) || isFunction(symbolOffset)) {
        var rawIdx = mpModel.getRawValue(idx);
        var dataParams = mpModel.getDataParams(idx);
        if (isFunction(symbol)) {
          symbol = symbol(rawIdx, dataParams);
        }
        if (isFunction(symbolSize)) {
          symbolSize = symbolSize(rawIdx, dataParams);
        }
        if (isFunction(symbolRotate)) {
          symbolRotate = symbolRotate(rawIdx, dataParams);
        }
        if (isFunction(symbolOffset)) {
          symbolOffset = symbolOffset(rawIdx, dataParams);
        }
      }
      var style = itemModel.getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
      }
      mpData.setItemVisual(idx, {
        symbol,
        symbolSize,
        symbolRotate,
        symbolOffset,
        symbolKeepAspect,
        style
      });
    });
    symbolDraw.updateData(mpData);
    this.group.add(symbolDraw.group);
    mpData.eachItemGraphicEl(function(el) {
      el.traverse(function(child) {
        getECData(child).dataModel = mpModel;
      });
    });
    this.markKeep(symbolDraw);
    symbolDraw.group.silent = mpModel.get("silent") || seriesModel.get("silent");
  };
  MarkPointView2.type = "markPoint";
  return MarkPointView2;
}(MarkerView$1);
function createData(coordSys, seriesModel, mpModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var mpData = new SeriesData$1(coordDimsInfos, mpModel);
  var dataOpt = map$1(mpModel.get("data"), curry$1(dataTransform, seriesModel));
  if (coordSys) {
    dataOpt = filter(dataOpt, curry$1(dataFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  mpData.initData(dataOpt, null, dimValueGetter);
  return mpData;
}
var MarkPointView$1 = MarkPointView;
function install$e(registers) {
  registers.registerComponentModel(MarkPointModel$1);
  registers.registerComponentView(MarkPointView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markPoint")) {
      opt.markPoint = opt.markPoint || {};
    }
  });
}
var MarkLineModel = function(_super) {
  __extends(MarkLineModel2, _super);
  function MarkLineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineModel2.type;
    return _this;
  }
  MarkLineModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkLineModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkLineModel2.type = "markLine";
  MarkLineModel2.defaultOption = {
    z: 5,
    symbol: ["circle", "arrow"],
    symbolSize: [8, 16],
    symbolOffset: 0,
    precision: 2,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "end",
      distance: 5
    },
    lineStyle: {
      type: "dashed"
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        width: 3
      }
    },
    animationEasing: "linear"
  };
  return MarkLineModel2;
}(MarkerModel$1);
var MarkLineModel$1 = MarkLineModel;
var inner$3 = makeInner();
var markLineTransform = function(seriesModel, coordSys, mlModel, item) {
  var data = seriesModel.getData();
  var itemArray;
  if (!isArray$1(item)) {
    var mlType = item.type;
    if (mlType === "min" || mlType === "max" || mlType === "average" || mlType === "median" || item.xAxis != null || item.yAxis != null) {
      var valueAxis2 = void 0;
      var value = void 0;
      if (item.yAxis != null || item.xAxis != null) {
        valueAxis2 = coordSys.getAxis(item.yAxis != null ? "y" : "x");
        value = retrieve(item.yAxis, item.xAxis);
      } else {
        var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
        valueAxis2 = axisInfo.valueAxis;
        var valueDataDim = getStackedDimension(data, axisInfo.valueDataDim);
        value = numCalculate(data, valueDataDim, mlType);
      }
      var valueIndex = valueAxis2.dim === "x" ? 0 : 1;
      var baseIndex = 1 - valueIndex;
      var mlFrom = clone$4(item);
      var mlTo = {
        coord: []
      };
      mlFrom.type = null;
      mlFrom.coord = [];
      mlFrom.coord[baseIndex] = -Infinity;
      mlTo.coord[baseIndex] = Infinity;
      var precision = mlModel.get("precision");
      if (precision >= 0 && isNumber(value)) {
        value = +value.toFixed(Math.min(precision, 20));
      }
      mlFrom.coord[valueIndex] = mlTo.coord[valueIndex] = value;
      itemArray = [mlFrom, mlTo, {
        type: mlType,
        valueIndex: item.valueIndex,
        value
      }];
    } else {
      itemArray = [];
    }
  } else {
    itemArray = item;
  }
  var normalizedItem = [dataTransform(seriesModel, itemArray[0]), dataTransform(seriesModel, itemArray[1]), extend({}, itemArray[2])];
  normalizedItem[2].type = normalizedItem[2].type || null;
  merge(normalizedItem[2], normalizedItem[0]);
  merge(normalizedItem[2], normalizedItem[1]);
  return normalizedItem;
};
function isInifinity$1(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkLineHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  var dimName = coordSys.dimensions[dimIndex];
  return isInifinity$1(fromCoord[otherDimIndex]) && isInifinity$1(toCoord[otherDimIndex]) && fromCoord[dimIndex] === toCoord[dimIndex] && coordSys.getAxis(dimName).containData(fromCoord[dimIndex]);
}
function markLineFilter(coordSys, item) {
  if (coordSys.type === "cartesian2d") {
    var fromCoord = item[0].coord;
    var toCoord = item[1].coord;
    if (fromCoord && toCoord && (ifMarkLineHasOnlyDim(1, fromCoord, toCoord, coordSys) || ifMarkLineHasOnlyDim(0, fromCoord, toCoord, coordSys))) {
      return true;
    }
  }
  return dataFilter(coordSys, item[0]) && dataFilter(coordSys, item[1]);
}
function updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get("x"), api.getWidth());
  var yPx = parsePercent(itemModel.get("y"), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(data.dimensions, idx));
    } else {
      var dims = coordSys.dimensions;
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var dims = coordSys.dimensions;
      if (isInifinity$1(data.get(dims[0], idx))) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[isFrom ? 0 : 1]);
      } else if (isInifinity$1(data.get(dims[1], idx))) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[isFrom ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  data.setItemLayout(idx, point);
}
var MarkLineView = function(_super) {
  __extends(MarkLineView2, _super);
  function MarkLineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineView2.type;
    return _this;
  }
  MarkLineView2.prototype.updateTransform = function(markLineModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mlModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markLine");
      if (mlModel) {
        var mlData_1 = mlModel.getData();
        var fromData_1 = inner$3(mlModel).from;
        var toData_1 = inner$3(mlModel).to;
        fromData_1.each(function(idx) {
          updateSingleMarkerEndLayout(fromData_1, idx, true, seriesModel, api);
          updateSingleMarkerEndLayout(toData_1, idx, false, seriesModel, api);
        });
        mlData_1.each(function(idx) {
          mlData_1.setItemLayout(idx, [fromData_1.getItemLayout(idx), toData_1.getItemLayout(idx)]);
        });
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkLineView2.prototype.renderSeries = function(seriesModel, mlModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var lineDrawMap = this.markerGroupMap;
    var lineDraw = lineDrawMap.get(seriesId) || lineDrawMap.set(seriesId, new LineDraw$1());
    this.group.add(lineDraw.group);
    var mlData = createList$1(coordSys, seriesModel, mlModel);
    var fromData = mlData.from;
    var toData = mlData.to;
    var lineData = mlData.line;
    inner$3(mlModel).from = fromData;
    inner$3(mlModel).to = toData;
    mlModel.setData(lineData);
    var symbolType = mlModel.get("symbol");
    var symbolSize = mlModel.get("symbolSize");
    var symbolRotate = mlModel.get("symbolRotate");
    var symbolOffset = mlModel.get("symbolOffset");
    if (!isArray$1(symbolType)) {
      symbolType = [symbolType, symbolType];
    }
    if (!isArray$1(symbolSize)) {
      symbolSize = [symbolSize, symbolSize];
    }
    if (!isArray$1(symbolRotate)) {
      symbolRotate = [symbolRotate, symbolRotate];
    }
    if (!isArray$1(symbolOffset)) {
      symbolOffset = [symbolOffset, symbolOffset];
    }
    mlData.from.each(function(idx) {
      updateDataVisualAndLayout(fromData, idx, true);
      updateDataVisualAndLayout(toData, idx, false);
    });
    lineData.each(function(idx) {
      var lineStyle = lineData.getItemModel(idx).getModel("lineStyle").getLineStyle();
      lineData.setItemLayout(idx, [fromData.getItemLayout(idx), toData.getItemLayout(idx)]);
      if (lineStyle.stroke == null) {
        lineStyle.stroke = fromData.getItemVisual(idx, "style").fill;
      }
      lineData.setItemVisual(idx, {
        fromSymbolKeepAspect: fromData.getItemVisual(idx, "symbolKeepAspect"),
        fromSymbolOffset: fromData.getItemVisual(idx, "symbolOffset"),
        fromSymbolRotate: fromData.getItemVisual(idx, "symbolRotate"),
        fromSymbolSize: fromData.getItemVisual(idx, "symbolSize"),
        fromSymbol: fromData.getItemVisual(idx, "symbol"),
        toSymbolKeepAspect: toData.getItemVisual(idx, "symbolKeepAspect"),
        toSymbolOffset: toData.getItemVisual(idx, "symbolOffset"),
        toSymbolRotate: toData.getItemVisual(idx, "symbolRotate"),
        toSymbolSize: toData.getItemVisual(idx, "symbolSize"),
        toSymbol: toData.getItemVisual(idx, "symbol"),
        style: lineStyle
      });
    });
    lineDraw.updateData(lineData);
    mlData.line.eachItemGraphicEl(function(el, idx) {
      el.traverse(function(child) {
        getECData(child).dataModel = mlModel;
      });
    });
    function updateDataVisualAndLayout(data, idx, isFrom) {
      var itemModel = data.getItemModel(idx);
      updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (style.fill == null) {
        style.fill = getVisualFromData(seriesData, "color");
      }
      data.setItemVisual(idx, {
        symbolKeepAspect: itemModel.get("symbolKeepAspect"),
        symbolOffset: retrieve2(itemModel.get("symbolOffset", true), symbolOffset[isFrom ? 0 : 1]),
        symbolRotate: retrieve2(itemModel.get("symbolRotate", true), symbolRotate[isFrom ? 0 : 1]),
        symbolSize: retrieve2(itemModel.get("symbolSize"), symbolSize[isFrom ? 0 : 1]),
        symbol: retrieve2(itemModel.get("symbol", true), symbolType[isFrom ? 0 : 1]),
        style
      });
    }
    this.markKeep(lineDraw);
    lineDraw.group.silent = mlModel.get("silent") || seriesModel.get("silent");
  };
  MarkLineView2.type = "markLine";
  return MarkLineView2;
}(MarkerView$1);
function createList$1(coordSys, seriesModel, mlModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var fromData = new SeriesData$1(coordDimsInfos, mlModel);
  var toData = new SeriesData$1(coordDimsInfos, mlModel);
  var lineData = new SeriesData$1([], mlModel);
  var optData = map$1(mlModel.get("data"), curry$1(markLineTransform, seriesModel, coordSys, mlModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markLineFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  fromData.initData(map$1(optData, function(item) {
    return item[0];
  }), null, dimValueGetter);
  toData.initData(map$1(optData, function(item) {
    return item[1];
  }), null, dimValueGetter);
  lineData.initData(map$1(optData, function(item) {
    return item[2];
  }));
  lineData.hasItemOption = true;
  return {
    from: fromData,
    to: toData,
    line: lineData
  };
}
var MarkLineView$1 = MarkLineView;
function install$d(registers) {
  registers.registerComponentModel(MarkLineModel$1);
  registers.registerComponentView(MarkLineView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markLine")) {
      opt.markLine = opt.markLine || {};
    }
  });
}
var MarkAreaModel = function(_super) {
  __extends(MarkAreaModel2, _super);
  function MarkAreaModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaModel2.type;
    return _this;
  }
  MarkAreaModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkAreaModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkAreaModel2.type = "markArea";
  MarkAreaModel2.defaultOption = {
    z: 1,
    tooltip: {
      trigger: "item"
    },
    animation: false,
    label: {
      show: true,
      position: "top"
    },
    itemStyle: {
      borderWidth: 0
    },
    emphasis: {
      label: {
        show: true,
        position: "top"
      }
    }
  };
  return MarkAreaModel2;
}(MarkerModel$1);
var MarkAreaModel$1 = MarkAreaModel;
var inner$2 = makeInner();
var markAreaTransform = function(seriesModel, coordSys, maModel, item) {
  var lt2 = dataTransform(seriesModel, item[0]);
  var rb2 = dataTransform(seriesModel, item[1]);
  var ltCoord = lt2.coord;
  var rbCoord = rb2.coord;
  ltCoord[0] = retrieve(ltCoord[0], -Infinity);
  ltCoord[1] = retrieve(ltCoord[1], -Infinity);
  rbCoord[0] = retrieve(rbCoord[0], Infinity);
  rbCoord[1] = retrieve(rbCoord[1], Infinity);
  var result = mergeAll([{}, lt2, rb2]);
  result.coord = [lt2.coord, rb2.coord];
  result.x0 = lt2.x;
  result.y0 = lt2.y;
  result.x1 = rb2.x;
  result.y1 = rb2.y;
  return result;
};
function isInifinity(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkAreaHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  return isInifinity(fromCoord[otherDimIndex]) && isInifinity(toCoord[otherDimIndex]);
}
function markAreaFilter(coordSys, item) {
  var fromCoord = item.coord[0];
  var toCoord = item.coord[1];
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    if (fromCoord && toCoord && (ifMarkAreaHasOnlyDim(1, fromCoord, toCoord) || ifMarkAreaHasOnlyDim(0, fromCoord, toCoord))) {
      return true;
    }
  }
  return dataFilter(coordSys, {
    coord: fromCoord,
    x: item.x0,
    y: item.y0
  }) || dataFilter(coordSys, {
    coord: toCoord,
    x: item.x1,
    y: item.y1
  });
}
function getSingleMarkerEndPoint(data, idx, dims, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get(dims[0]), api.getWidth());
  var yPx = parsePercent(itemModel.get(dims[1]), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(dims, idx));
    } else {
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      var pt = [x2, y2];
      coordSys.clampData && coordSys.clampData(pt, pt);
      point = coordSys.dataToPoint(pt, true);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      if (isInifinity(x2)) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[dims[0] === "x0" ? 0 : 1]);
      } else if (isInifinity(y2)) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[dims[1] === "y0" ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  return point;
}
var dimPermutations = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]];
var MarkAreaView = function(_super) {
  __extends(MarkAreaView2, _super);
  function MarkAreaView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaView2.type;
    return _this;
  }
  MarkAreaView2.prototype.updateTransform = function(markAreaModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var maModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markArea");
      if (maModel) {
        var areaData_1 = maModel.getData();
        areaData_1.each(function(idx) {
          var points2 = map$1(dimPermutations, function(dim) {
            return getSingleMarkerEndPoint(areaData_1, idx, dim, seriesModel, api);
          });
          areaData_1.setItemLayout(idx, points2);
          var el = areaData_1.getItemGraphicEl(idx);
          el.setShape("points", points2);
        });
      }
    }, this);
  };
  MarkAreaView2.prototype.renderSeries = function(seriesModel, maModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var areaGroupMap = this.markerGroupMap;
    var polygonGroup = areaGroupMap.get(seriesId) || areaGroupMap.set(seriesId, {
      group: new Group$4()
    });
    this.group.add(polygonGroup.group);
    this.markKeep(polygonGroup);
    var areaData = createList(coordSys, seriesModel, maModel);
    maModel.setData(areaData);
    areaData.each(function(idx) {
      var points2 = map$1(dimPermutations, function(dim) {
        return getSingleMarkerEndPoint(areaData, idx, dim, seriesModel, api);
      });
      var xAxisScale = coordSys.getAxis("x").scale;
      var yAxisScale = coordSys.getAxis("y").scale;
      var xAxisExtent = xAxisScale.getExtent();
      var yAxisExtent = yAxisScale.getExtent();
      var xPointExtent = [xAxisScale.parse(areaData.get("x0", idx)), xAxisScale.parse(areaData.get("x1", idx))];
      var yPointExtent = [yAxisScale.parse(areaData.get("y0", idx)), yAxisScale.parse(areaData.get("y1", idx))];
      asc$2(xPointExtent);
      asc$2(yPointExtent);
      var overlapped = !(xAxisExtent[0] > xPointExtent[1] || xAxisExtent[1] < xPointExtent[0] || yAxisExtent[0] > yPointExtent[1] || yAxisExtent[1] < yPointExtent[0]);
      var allClipped = !overlapped;
      areaData.setItemLayout(idx, {
        points: points2,
        allClipped
      });
      var style = areaData.getItemModel(idx).getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
        if (isString(style.fill)) {
          style.fill = modifyAlpha(style.fill, 0.4);
        }
      }
      if (!style.stroke) {
        style.stroke = color;
      }
      areaData.setItemVisual(idx, "style", style);
    });
    areaData.diff(inner$2(polygonGroup).data).add(function(idx) {
      var layout2 = areaData.getItemLayout(idx);
      if (!layout2.allClipped) {
        var polygon = new Polygon$1({
          shape: {
            points: layout2.points
          }
        });
        areaData.setItemGraphicEl(idx, polygon);
        polygonGroup.group.add(polygon);
      }
    }).update(function(newIdx, oldIdx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(oldIdx);
      var layout2 = areaData.getItemLayout(newIdx);
      if (!layout2.allClipped) {
        if (polygon) {
          updateProps$1(polygon, {
            shape: {
              points: layout2.points
            }
          }, maModel, newIdx);
        } else {
          polygon = new Polygon$1({
            shape: {
              points: layout2.points
            }
          });
        }
        areaData.setItemGraphicEl(newIdx, polygon);
        polygonGroup.group.add(polygon);
      } else if (polygon) {
        polygonGroup.group.remove(polygon);
      }
    }).remove(function(idx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(idx);
      polygonGroup.group.remove(polygon);
    }).execute();
    areaData.eachItemGraphicEl(function(polygon, idx) {
      var itemModel = areaData.getItemModel(idx);
      var style = areaData.getItemVisual(idx, "style");
      polygon.useStyle(areaData.getItemVisual(idx, "style"));
      setLabelStyle(polygon, getLabelStatesModels(itemModel), {
        labelFetcher: maModel,
        labelDataIndex: idx,
        defaultText: areaData.getName(idx) || "",
        inheritColor: isString(style.fill) ? modifyAlpha(style.fill, 1) : "#000"
      });
      setStatesStylesFromModel(polygon, itemModel);
      toggleHoverEmphasis(polygon, null, null, itemModel.get(["emphasis", "disabled"]));
      getECData(polygon).dataModel = maModel;
    });
    inner$2(polygonGroup).data = areaData;
    polygonGroup.group.silent = maModel.get("silent") || seriesModel.get("silent");
  };
  MarkAreaView2.type = "markArea";
  return MarkAreaView2;
}(MarkerView$1);
function createList(coordSys, seriesModel, maModel) {
  var areaData;
  var dataDims;
  var dims = ["x0", "y0", "x1", "y1"];
  if (coordSys) {
    var coordDimsInfos_1 = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var data = seriesModel.getData();
      var info = data.getDimensionInfo(data.mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
    dataDims = map$1(dims, function(dim, idx) {
      return {
        name: dim,
        type: coordDimsInfos_1[idx % 2].type
      };
    });
    areaData = new SeriesData$1(dataDims, maModel);
  } else {
    dataDims = [{
      name: "value",
      type: "float"
    }];
    areaData = new SeriesData$1(dataDims, maModel);
  }
  var optData = map$1(maModel.get("data"), curry$1(markAreaTransform, seriesModel, coordSys, maModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markAreaFilter, coordSys));
  }
  var dimValueGetter = coordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = item.coord[Math.floor(dimIndex / 2)][dimIndex % 2];
    return parseDataValue(rawVal, dataDims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dataDims[dimIndex]);
  };
  areaData.initData(optData, null, dimValueGetter);
  areaData.hasItemOption = true;
  return areaData;
}
var MarkAreaView$1 = MarkAreaView;
function install$c(registers) {
  registers.registerComponentModel(MarkAreaModel$1);
  registers.registerComponentView(MarkAreaView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markArea")) {
      opt.markArea = opt.markArea || {};
    }
  });
}
var getDefaultSelectorOptions = function(ecModel, type4) {
  if (type4 === "all") {
    return {
      type: "all",
      title: ecModel.getLocaleModel().get(["legend", "selector", "all"])
    };
  } else if (type4 === "inverse") {
    return {
      type: "inverse",
      title: ecModel.getLocaleModel().get(["legend", "selector", "inverse"])
    };
  }
};
var LegendModel = function(_super) {
  __extends(LegendModel2, _super);
  function LegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  LegendModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    option.selected = option.selected || {};
    this._updateSelector(option);
  };
  LegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    this._updateSelector(option);
  };
  LegendModel2.prototype._updateSelector = function(option) {
    var selector2 = option.selector;
    var ecModel = this.ecModel;
    if (selector2 === true) {
      selector2 = option.selector = ["all", "inverse"];
    }
    if (isArray$1(selector2)) {
      each$f(selector2, function(item, index2) {
        isString(item) && (item = {
          type: item
        });
        selector2[index2] = merge(item, getDefaultSelectorOptions(ecModel, item.type));
      });
    }
  };
  LegendModel2.prototype.optionUpdated = function() {
    this._updateData(this.ecModel);
    var legendData = this._data;
    if (legendData[0] && this.get("selectedMode") === "single") {
      var hasSelected = false;
      for (var i = 0; i < legendData.length; i++) {
        var name_1 = legendData[i].get("name");
        if (this.isSelected(name_1)) {
          this.select(name_1);
          hasSelected = true;
          break;
        }
      }
      !hasSelected && this.select(legendData[0].get("name"));
    }
  };
  LegendModel2.prototype._updateData = function(ecModel) {
    var potentialData = [];
    var availableNames = [];
    ecModel.eachRawSeries(function(seriesModel) {
      var seriesName = seriesModel.name;
      availableNames.push(seriesName);
      var isPotential;
      if (seriesModel.legendVisualProvider) {
        var provider = seriesModel.legendVisualProvider;
        var names2 = provider.getAllNames();
        if (!ecModel.isSeriesFiltered(seriesModel)) {
          availableNames = availableNames.concat(names2);
        }
        if (names2.length) {
          potentialData = potentialData.concat(names2);
        } else {
          isPotential = true;
        }
      } else {
        isPotential = true;
      }
      if (isPotential && isNameSpecified(seriesModel)) {
        potentialData.push(seriesModel.name);
      }
    });
    this._availableNames = availableNames;
    var rawData = this.get("data") || potentialData;
    var legendData = map$1(rawData, function(dataItem) {
      if (isString(dataItem) || isNumber(dataItem)) {
        dataItem = {
          name: dataItem
        };
      }
      return new Model$1(dataItem, this, this.ecModel);
    }, this);
    this._data = legendData;
  };
  LegendModel2.prototype.getData = function() {
    return this._data;
  };
  LegendModel2.prototype.select = function(name) {
    var selected = this.option.selected;
    var selectedMode = this.get("selectedMode");
    if (selectedMode === "single") {
      var data = this._data;
      each$f(data, function(dataItem) {
        selected[dataItem.get("name")] = false;
      });
    }
    selected[name] = true;
  };
  LegendModel2.prototype.unSelect = function(name) {
    if (this.get("selectedMode") !== "single") {
      this.option.selected[name] = false;
    }
  };
  LegendModel2.prototype.toggleSelected = function(name) {
    var selected = this.option.selected;
    if (!selected.hasOwnProperty(name)) {
      selected[name] = true;
    }
    this[selected[name] ? "unSelect" : "select"](name);
  };
  LegendModel2.prototype.allSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      selected[dataItem.get("name", true)] = true;
    });
  };
  LegendModel2.prototype.inverseSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      var name = dataItem.get("name", true);
      if (!selected.hasOwnProperty(name)) {
        selected[name] = true;
      }
      selected[name] = !selected[name];
    });
  };
  LegendModel2.prototype.isSelected = function(name) {
    var selected = this.option.selected;
    return !(selected.hasOwnProperty(name) && !selected[name]) && indexOf(this._availableNames, name) >= 0;
  };
  LegendModel2.prototype.getOrient = function() {
    return this.get("orient") === "vertical" ? {
      index: 1,
      name: "vertical"
    } : {
      index: 0,
      name: "horizontal"
    };
  };
  LegendModel2.type = "legend.plain";
  LegendModel2.dependencies = ["series"];
  LegendModel2.defaultOption = {
    z: 4,
    show: true,
    orient: "horizontal",
    left: "center",
    top: 0,
    align: "auto",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    itemWidth: 25,
    itemHeight: 14,
    symbolRotate: "inherit",
    symbolKeepAspect: true,
    inactiveColor: "#ccc",
    inactiveBorderColor: "#ccc",
    inactiveBorderWidth: "auto",
    itemStyle: {
      color: "inherit",
      opacity: "inherit",
      borderColor: "inherit",
      borderWidth: "auto",
      borderCap: "inherit",
      borderJoin: "inherit",
      borderDashOffset: "inherit",
      borderMiterLimit: "inherit"
    },
    lineStyle: {
      width: "auto",
      color: "inherit",
      inactiveColor: "#ccc",
      inactiveWidth: 2,
      opacity: "inherit",
      type: "inherit",
      cap: "inherit",
      join: "inherit",
      dashOffset: "inherit",
      miterLimit: "inherit"
    },
    textStyle: {
      color: "#333"
    },
    selectedMode: true,
    selector: false,
    selectorLabel: {
      show: true,
      borderRadius: 10,
      padding: [3, 5, 3, 5],
      fontSize: 12,
      fontFamily: "sans-serif",
      color: "#666",
      borderWidth: 1,
      borderColor: "#666"
    },
    emphasis: {
      selectorLabel: {
        show: true,
        color: "#eee",
        backgroundColor: "#666"
      }
    },
    selectorPosition: "auto",
    selectorItemGap: 7,
    selectorButtonGap: 10,
    tooltip: {
      show: false
    }
  };
  return LegendModel2;
}(ComponentModel$1);
var LegendModel$1 = LegendModel;
var curry = curry$1;
var each$3 = each$f;
var Group$1 = Group$4;
var LegendView = function(_super) {
  __extends(LegendView2, _super);
  function LegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendView2.type;
    _this.newlineDisabled = false;
    return _this;
  }
  LegendView2.prototype.init = function() {
    this.group.add(this._contentGroup = new Group$1());
    this.group.add(this._selectorGroup = new Group$1());
    this._isFirstRender = true;
  };
  LegendView2.prototype.getContentGroup = function() {
    return this._contentGroup;
  };
  LegendView2.prototype.getSelectorGroup = function() {
    return this._selectorGroup;
  };
  LegendView2.prototype.render = function(legendModel, ecModel, api) {
    var isFirstRender = this._isFirstRender;
    this._isFirstRender = false;
    this.resetInner();
    if (!legendModel.get("show", true)) {
      return;
    }
    var itemAlign = legendModel.get("align");
    var orient = legendModel.get("orient");
    if (!itemAlign || itemAlign === "auto") {
      itemAlign = legendModel.get("left") === "right" && orient === "vertical" ? "right" : "left";
    }
    var selector2 = legendModel.get("selector", true);
    var selectorPosition = legendModel.get("selectorPosition", true);
    if (selector2 && (!selectorPosition || selectorPosition === "auto")) {
      selectorPosition = orient === "horizontal" ? "end" : "start";
    }
    this.renderInner(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var positionInfo = legendModel.getBoxLayoutParams();
    var viewportSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var padding = legendModel.get("padding");
    var maxSize = getLayoutRect(positionInfo, viewportSize, padding);
    var mainRect = this.layoutInner(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition);
    var layoutRect = getLayoutRect(defaults({
      width: mainRect.width,
      height: mainRect.height
    }, positionInfo), viewportSize, padding);
    this.group.x = layoutRect.x - mainRect.x;
    this.group.y = layoutRect.y - mainRect.y;
    this.group.markRedraw();
    this.group.add(this._backgroundEl = makeBackground(mainRect, legendModel));
  };
  LegendView2.prototype.resetInner = function() {
    this.getContentGroup().removeAll();
    this._backgroundEl && this.group.remove(this._backgroundEl);
    this.getSelectorGroup().removeAll();
  };
  LegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var legendDrawnMap = createHashMap();
    var selectMode = legendModel.get("selectedMode");
    var excludeSeriesId = [];
    ecModel.eachRawSeries(function(seriesModel) {
      !seriesModel.get("legendHoverLink") && excludeSeriesId.push(seriesModel.id);
    });
    each$3(legendModel.getData(), function(legendItemModel, dataIndex) {
      var name = legendItemModel.get("name");
      if (!this.newlineDisabled && (name === "" || name === "\n")) {
        var g2 = new Group$1();
        g2.newline = true;
        contentGroup.add(g2);
        return;
      }
      var seriesModel = ecModel.getSeriesByName(name)[0];
      if (legendDrawnMap.get(name)) {
        return;
      }
      if (seriesModel) {
        var data = seriesModel.getData();
        var lineVisualStyle = data.getVisual("legendLineStyle") || {};
        var legendIcon = data.getVisual("legendIcon");
        var style = data.getVisual("style");
        var itemGroup = this._createItem(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, style, legendIcon, selectMode);
        itemGroup.on("click", curry(dispatchSelectAction, name, null, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, seriesModel.name, null, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, seriesModel.name, null, api, excludeSeriesId));
        legendDrawnMap.set(name, true);
      } else {
        ecModel.eachRawSeries(function(seriesModel2) {
          if (legendDrawnMap.get(name)) {
            return;
          }
          if (seriesModel2.legendVisualProvider) {
            var provider = seriesModel2.legendVisualProvider;
            if (!provider.containName(name)) {
              return;
            }
            var idx = provider.indexOfName(name);
            var style2 = provider.getItemVisual(idx, "style");
            var legendIcon2 = provider.getItemVisual(idx, "legendIcon");
            var colorArr = parse(style2.fill);
            if (colorArr && colorArr[3] === 0) {
              colorArr[3] = 0.2;
              style2 = extend(extend({}, style2), {
                fill: stringify(colorArr, "rgba")
              });
            }
            var itemGroup2 = this._createItem(seriesModel2, name, dataIndex, legendItemModel, legendModel, itemAlign, {}, style2, legendIcon2, selectMode);
            itemGroup2.on("click", curry(dispatchSelectAction, null, name, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, null, name, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, null, name, api, excludeSeriesId));
            legendDrawnMap.set(name, true);
          }
        }, this);
      }
    }, this);
    if (selector2) {
      this._createSelector(selector2, legendModel, api, orient, selectorPosition);
    }
  };
  LegendView2.prototype._createSelector = function(selector2, legendModel, api, orient, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    each$3(selector2, function createSelectorButton(selectorItem) {
      var type4 = selectorItem.type;
      var labelText = new ZRText$1({
        style: {
          x: 0,
          y: 0,
          align: "center",
          verticalAlign: "middle"
        },
        onclick: function() {
          api.dispatchAction({
            type: type4 === "all" ? "legendAllSelect" : "legendInverseSelect"
          });
        }
      });
      selectorGroup.add(labelText);
      var labelModel = legendModel.getModel("selectorLabel");
      var emphasisLabelModel = legendModel.getModel(["emphasis", "selectorLabel"]);
      setLabelStyle(labelText, {
        normal: labelModel,
        emphasis: emphasisLabelModel
      }, {
        defaultText: selectorItem.title
      });
      enableHoverEmphasis(labelText);
    });
  };
  LegendView2.prototype._createItem = function(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, itemVisualStyle, legendIcon, selectMode) {
    var drawType = seriesModel.visualDrawType;
    var itemWidth = legendModel.get("itemWidth");
    var itemHeight = legendModel.get("itemHeight");
    var isSelected = legendModel.isSelected(name);
    var iconRotate = legendItemModel.get("symbolRotate");
    var symbolKeepAspect = legendItemModel.get("symbolKeepAspect");
    var legendIconType = legendItemModel.get("icon");
    legendIcon = legendIconType || legendIcon || "roundRect";
    var style = getLegendStyle(legendIcon, legendItemModel, lineVisualStyle, itemVisualStyle, drawType, isSelected);
    var itemGroup = new Group$1();
    var textStyleModel = legendItemModel.getModel("textStyle");
    if (isFunction(seriesModel.getLegendIcon) && (!legendIconType || legendIconType === "inherit")) {
      itemGroup.add(seriesModel.getLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    } else {
      var rotate2 = legendIconType === "inherit" && seriesModel.getData().getVisual("symbol") ? iconRotate === "inherit" ? seriesModel.getData().getVisual("symbolRotate") : iconRotate : 0;
      itemGroup.add(getDefaultLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate: rotate2,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    }
    var textX = itemAlign === "left" ? itemWidth + 5 : -5;
    var textAlign = itemAlign;
    var formatter = legendModel.get("formatter");
    var content = name;
    if (isString(formatter) && formatter) {
      content = formatter.replace("{name}", name != null ? name : "");
    } else if (isFunction(formatter)) {
      content = formatter(name);
    }
    var inactiveColor = legendItemModel.get("inactiveColor");
    itemGroup.add(new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: content,
        x: textX,
        y: itemHeight / 2,
        fill: isSelected ? textStyleModel.getTextColor() : inactiveColor,
        align: textAlign,
        verticalAlign: "middle"
      })
    }));
    var hitRect = new Rect$3({
      shape: itemGroup.getBoundingRect(),
      invisible: true
    });
    var tooltipModel = legendItemModel.getModel("tooltip");
    if (tooltipModel.get("show")) {
      setTooltipConfig({
        el: hitRect,
        componentModel: legendModel,
        itemName: name,
        itemTooltipOption: tooltipModel.option
      });
    }
    itemGroup.add(hitRect);
    itemGroup.eachChild(function(child) {
      child.silent = true;
    });
    hitRect.silent = !selectMode;
    this.getContentGroup().add(itemGroup);
    enableHoverEmphasis(itemGroup);
    itemGroup.__legendDataIndex = dataIndex;
    return itemGroup;
  };
  LegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var selectorGroup = this.getSelectorGroup();
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), maxSize.width, maxSize.height);
    var contentRect = contentGroup.getBoundingRect();
    var contentPos = [-contentRect.x, -contentRect.y];
    selectorGroup.markRedraw();
    contentGroup.markRedraw();
    if (selector2) {
      box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
      var selectorRect = selectorGroup.getBoundingRect();
      var selectorPos = [-selectorRect.x, -selectorRect.y];
      var selectorButtonGap = legendModel.get("selectorButtonGap", true);
      var orientIdx = legendModel.getOrient().index;
      var wh = orientIdx === 0 ? "width" : "height";
      var hw = orientIdx === 0 ? "height" : "width";
      var yx = orientIdx === 0 ? "y" : "x";
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += contentRect[wh] + selectorButtonGap;
      } else {
        contentPos[orientIdx] += selectorRect[wh] + selectorButtonGap;
      }
      selectorPos[1 - orientIdx] += contentRect[hw] / 2 - selectorRect[hw] / 2;
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      var mainRect = {
        x: 0,
        y: 0
      };
      mainRect[wh] = contentRect[wh] + selectorButtonGap + selectorRect[wh];
      mainRect[hw] = Math.max(contentRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(0, selectorRect[yx] + selectorPos[1 - orientIdx]);
      return mainRect;
    } else {
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      return this.group.getBoundingRect();
    }
  };
  LegendView2.prototype.remove = function() {
    this.getContentGroup().removeAll();
    this._isFirstRender = true;
  };
  LegendView2.type = "legend.plain";
  return LegendView2;
}(ComponentView$1);
function getLegendStyle(iconType, legendModel, lineVisualStyle, itemVisualStyle, drawType, isSelected) {
  function handleCommonProps(style, visualStyle) {
    if (style.lineWidth === "auto") {
      style.lineWidth = visualStyle.lineWidth > 0 ? 2 : 0;
    }
    each$3(style, function(propVal, propName) {
      style[propName] === "inherit" && (style[propName] = visualStyle[propName]);
    });
  }
  var legendItemModel = legendModel.getModel("itemStyle");
  var itemStyle = legendItemModel.getItemStyle();
  var iconBrushType = iconType.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
  itemStyle.decal = itemVisualStyle.decal;
  if (itemStyle.fill === "inherit") {
    itemStyle.fill = itemVisualStyle[drawType];
  }
  if (itemStyle.stroke === "inherit") {
    itemStyle.stroke = itemVisualStyle[iconBrushType];
  }
  if (itemStyle.opacity === "inherit") {
    itemStyle.opacity = (drawType === "fill" ? itemVisualStyle : lineVisualStyle).opacity;
  }
  handleCommonProps(itemStyle, itemVisualStyle);
  var legendLineModel = legendModel.getModel("lineStyle");
  var lineStyle = legendLineModel.getLineStyle();
  handleCommonProps(lineStyle, lineVisualStyle);
  itemStyle.fill === "auto" && (itemStyle.fill = itemVisualStyle.fill);
  itemStyle.stroke === "auto" && (itemStyle.stroke = itemVisualStyle.fill);
  lineStyle.stroke === "auto" && (lineStyle.stroke = itemVisualStyle.fill);
  if (!isSelected) {
    var borderWidth = legendModel.get("inactiveBorderWidth");
    var visualHasBorder = itemStyle[iconBrushType];
    itemStyle.lineWidth = borderWidth === "auto" ? itemVisualStyle.lineWidth > 0 && visualHasBorder ? 2 : 0 : itemStyle.lineWidth;
    itemStyle.fill = legendModel.get("inactiveColor");
    itemStyle.stroke = legendModel.get("inactiveBorderColor");
    lineStyle.stroke = legendLineModel.get("inactiveColor");
    lineStyle.lineWidth = legendLineModel.get("inactiveWidth");
  }
  return {
    itemStyle,
    lineStyle
  };
}
function getDefaultLegendIcon(opt) {
  var symboType = opt.icon || "roundRect";
  var icon = createSymbol$1(symboType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill, opt.symbolKeepAspect);
  icon.setStyle(opt.itemStyle);
  icon.rotation = (opt.iconRotate || 0) * Math.PI / 180;
  icon.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
  if (symboType.indexOf("empty") > -1) {
    icon.style.stroke = icon.style.fill;
    icon.style.fill = "#fff";
    icon.style.lineWidth = 2;
  }
  return icon;
}
function dispatchSelectAction(seriesName, dataName, api, excludeSeriesId) {
  dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId);
  api.dispatchAction({
    type: "legendToggleSelect",
    name: seriesName != null ? seriesName : dataName
  });
  dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId);
}
function isUseHoverLayer(api) {
  var list = api.getZr().storage.getDisplayList();
  var emphasisState;
  var i = 0;
  var len2 = list.length;
  while (i < len2 && !(emphasisState = list[i].states.emphasis)) {
    i++;
  }
  return emphasisState && emphasisState.hoverLayer;
}
function dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "highlight",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
function dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "downplay",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
var LegendView$1 = LegendView;
function legendFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (legendModels && legendModels.length) {
    ecModel.filterSeries(function(series) {
      for (var i = 0; i < legendModels.length; i++) {
        if (!legendModels[i].isSelected(series.name)) {
          return false;
        }
      }
      return true;
    });
  }
}
function legendSelectActionHandler(methodName, payload, ecModel) {
  var selectedMap = {};
  var isToggleSelect = methodName === "toggleSelected";
  var isSelected;
  ecModel.eachComponent("legend", function(legendModel) {
    if (isToggleSelect && isSelected != null) {
      legendModel[isSelected ? "select" : "unSelect"](payload.name);
    } else if (methodName === "allSelect" || methodName === "inverseSelect") {
      legendModel[methodName]();
    } else {
      legendModel[methodName](payload.name);
      isSelected = legendModel.isSelected(payload.name);
    }
    var legendData = legendModel.getData();
    each$f(legendData, function(model) {
      var name = model.get("name");
      if (name === "\n" || name === "") {
        return;
      }
      var isItemSelected = legendModel.isSelected(name);
      if (selectedMap.hasOwnProperty(name)) {
        selectedMap[name] = selectedMap[name] && isItemSelected;
      } else {
        selectedMap[name] = isItemSelected;
      }
    });
  });
  return methodName === "allSelect" || methodName === "inverseSelect" ? {
    selected: selectedMap
  } : {
    name: payload.name,
    selected: selectedMap
  };
}
function installLegendAction(registers) {
  registers.registerAction("legendToggleSelect", "legendselectchanged", curry$1(legendSelectActionHandler, "toggleSelected"));
  registers.registerAction("legendAllSelect", "legendselectall", curry$1(legendSelectActionHandler, "allSelect"));
  registers.registerAction("legendInverseSelect", "legendinverseselect", curry$1(legendSelectActionHandler, "inverseSelect"));
  registers.registerAction("legendSelect", "legendselected", curry$1(legendSelectActionHandler, "select"));
  registers.registerAction("legendUnSelect", "legendunselected", curry$1(legendSelectActionHandler, "unSelect"));
}
function install$b(registers) {
  registers.registerComponentModel(LegendModel$1);
  registers.registerComponentView(LegendView$1);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.SERIES_FILTER, legendFilter);
  registers.registerSubTypeDefaulter("legend", function() {
    return "plain";
  });
  installLegendAction(registers);
}
var ScrollableLegendModel = function(_super) {
  __extends(ScrollableLegendModel2, _super);
  function ScrollableLegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendModel2.type;
    return _this;
  }
  ScrollableLegendModel2.prototype.setScrollDataIndex = function(scrollDataIndex) {
    this.option.scrollDataIndex = scrollDataIndex;
  };
  ScrollableLegendModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.call(this, option, parentModel, ecModel);
    mergeAndNormalizeLayoutParams(this, option, inputPositionParams);
  };
  ScrollableLegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    mergeAndNormalizeLayoutParams(this, this.option, option);
  };
  ScrollableLegendModel2.type = "legend.scroll";
  ScrollableLegendModel2.defaultOption = inheritDefaultOption(LegendModel$1.defaultOption, {
    scrollDataIndex: 0,
    pageButtonItemGap: 5,
    pageButtonGap: null,
    pageButtonPosition: "end",
    pageFormatter: "{current}/{total}",
    pageIcons: {
      horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"],
      vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"]
    },
    pageIconColor: "#2f4554",
    pageIconInactiveColor: "#aaa",
    pageIconSize: 15,
    pageTextStyle: {
      color: "#333"
    },
    animationDurationUpdate: 800
  });
  return ScrollableLegendModel2;
}(LegendModel$1);
function mergeAndNormalizeLayoutParams(legendModel, target, raw) {
  var orient = legendModel.getOrient();
  var ignoreSize = [1, 1];
  ignoreSize[orient.index] = 0;
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize: !!ignoreSize
  });
}
var ScrollableLegendModel$1 = ScrollableLegendModel;
var Group = Group$4;
var WH = ["width", "height"];
var XY = ["x", "y"];
var ScrollableLegendView = function(_super) {
  __extends(ScrollableLegendView2, _super);
  function ScrollableLegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendView2.type;
    _this.newlineDisabled = true;
    _this._currentIndex = 0;
    return _this;
  }
  ScrollableLegendView2.prototype.init = function() {
    _super.prototype.init.call(this);
    this.group.add(this._containerGroup = new Group());
    this._containerGroup.add(this.getContentGroup());
    this.group.add(this._controllerGroup = new Group());
  };
  ScrollableLegendView2.prototype.resetInner = function() {
    _super.prototype.resetInner.call(this);
    this._controllerGroup.removeAll();
    this._containerGroup.removeClipPath();
    this._containerGroup.__rectSize = null;
  };
  ScrollableLegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var self2 = this;
    _super.prototype.renderInner.call(this, itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var controllerGroup = this._controllerGroup;
    var pageIconSize = legendModel.get("pageIconSize", true);
    var pageIconSizeArr = isArray$1(pageIconSize) ? pageIconSize : [pageIconSize, pageIconSize];
    createPageButton("pagePrev", 0);
    var pageTextStyleModel = legendModel.getModel("pageTextStyle");
    controllerGroup.add(new ZRText$1({
      name: "pageText",
      style: {
        text: "xx/xx",
        fill: pageTextStyleModel.getTextColor(),
        font: pageTextStyleModel.getFont(),
        verticalAlign: "middle",
        align: "center"
      },
      silent: true
    }));
    createPageButton("pageNext", 1);
    function createPageButton(name, iconIdx) {
      var pageDataIndexName = name + "DataIndex";
      var icon = createIcon(legendModel.get("pageIcons", true)[legendModel.getOrient().name][iconIdx], {
        onclick: bind$1(self2._pageGo, self2, pageDataIndexName, legendModel, api)
      }, {
        x: -pageIconSizeArr[0] / 2,
        y: -pageIconSizeArr[1] / 2,
        width: pageIconSizeArr[0],
        height: pageIconSizeArr[1]
      });
      icon.name = name;
      controllerGroup.add(icon);
    }
  };
  ScrollableLegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var hw = WH[1 - orientIdx];
    var yx = XY[1 - orientIdx];
    selector2 && box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
    var selectorButtonGap = legendModel.get("selectorButtonGap", true);
    var selectorRect = selectorGroup.getBoundingRect();
    var selectorPos = [-selectorRect.x, -selectorRect.y];
    var processMaxSize = clone$4(maxSize);
    selector2 && (processMaxSize[wh] = maxSize[wh] - selectorRect[wh] - selectorButtonGap);
    var mainRect = this._layoutContentAndController(legendModel, isFirstRender, processMaxSize, orientIdx, wh, hw, yx, xy);
    if (selector2) {
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += mainRect[wh] + selectorButtonGap;
      } else {
        var offset = selectorRect[wh] + selectorButtonGap;
        selectorPos[orientIdx] -= offset;
        mainRect[xy] -= offset;
      }
      mainRect[wh] += selectorRect[wh] + selectorButtonGap;
      selectorPos[1 - orientIdx] += mainRect[yx] + mainRect[hw] / 2 - selectorRect[hw] / 2;
      mainRect[hw] = Math.max(mainRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(mainRect[yx], selectorRect[yx] + selectorPos[1 - orientIdx]);
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      selectorGroup.markRedraw();
    }
    return mainRect;
  };
  ScrollableLegendView2.prototype._layoutContentAndController = function(legendModel, isFirstRender, maxSize, orientIdx, wh, hw, yx, xy) {
    var contentGroup = this.getContentGroup();
    var containerGroup = this._containerGroup;
    var controllerGroup = this._controllerGroup;
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), !orientIdx ? null : maxSize.width, orientIdx ? null : maxSize.height);
    box("horizontal", controllerGroup, legendModel.get("pageButtonItemGap", true));
    var contentRect = contentGroup.getBoundingRect();
    var controllerRect = controllerGroup.getBoundingRect();
    var showController = this._showController = contentRect[wh] > maxSize[wh];
    var contentPos = [-contentRect.x, -contentRect.y];
    if (!isFirstRender) {
      contentPos[orientIdx] = contentGroup[xy];
    }
    var containerPos = [0, 0];
    var controllerPos = [-controllerRect.x, -controllerRect.y];
    var pageButtonGap = retrieve2(legendModel.get("pageButtonGap", true), legendModel.get("itemGap", true));
    if (showController) {
      var pageButtonPosition = legendModel.get("pageButtonPosition", true);
      if (pageButtonPosition === "end") {
        controllerPos[orientIdx] += maxSize[wh] - controllerRect[wh];
      } else {
        containerPos[orientIdx] += controllerRect[wh] + pageButtonGap;
      }
    }
    controllerPos[1 - orientIdx] += contentRect[hw] / 2 - controllerRect[hw] / 2;
    contentGroup.setPosition(contentPos);
    containerGroup.setPosition(containerPos);
    controllerGroup.setPosition(controllerPos);
    var mainRect = {
      x: 0,
      y: 0
    };
    mainRect[wh] = showController ? maxSize[wh] : contentRect[wh];
    mainRect[hw] = Math.max(contentRect[hw], controllerRect[hw]);
    mainRect[yx] = Math.min(0, controllerRect[yx] + controllerPos[1 - orientIdx]);
    containerGroup.__rectSize = maxSize[wh];
    if (showController) {
      var clipShape = {
        x: 0,
        y: 0
      };
      clipShape[wh] = Math.max(maxSize[wh] - controllerRect[wh] - pageButtonGap, 0);
      clipShape[hw] = mainRect[hw];
      containerGroup.setClipPath(new Rect$3({
        shape: clipShape
      }));
      containerGroup.__rectSize = clipShape[wh];
    } else {
      controllerGroup.eachChild(function(child) {
        child.attr({
          invisible: true,
          silent: true
        });
      });
    }
    var pageInfo = this._getPageInfo(legendModel);
    pageInfo.pageIndex != null && updateProps$1(contentGroup, {
      x: pageInfo.contentPosition[0],
      y: pageInfo.contentPosition[1]
    }, showController ? legendModel : null);
    this._updatePageInfoView(legendModel, pageInfo);
    return mainRect;
  };
  ScrollableLegendView2.prototype._pageGo = function(to, legendModel, api) {
    var scrollDataIndex = this._getPageInfo(legendModel)[to];
    scrollDataIndex != null && api.dispatchAction({
      type: "legendScroll",
      scrollDataIndex,
      legendId: legendModel.id
    });
  };
  ScrollableLegendView2.prototype._updatePageInfoView = function(legendModel, pageInfo) {
    var controllerGroup = this._controllerGroup;
    each$f(["pagePrev", "pageNext"], function(name) {
      var key = name + "DataIndex";
      var canJump = pageInfo[key] != null;
      var icon = controllerGroup.childOfName(name);
      if (icon) {
        icon.setStyle("fill", canJump ? legendModel.get("pageIconColor", true) : legendModel.get("pageIconInactiveColor", true));
        icon.cursor = canJump ? "pointer" : "default";
      }
    });
    var pageText = controllerGroup.childOfName("pageText");
    var pageFormatter = legendModel.get("pageFormatter");
    var pageIndex = pageInfo.pageIndex;
    var current = pageIndex != null ? pageIndex + 1 : 0;
    var total = pageInfo.pageCount;
    pageText && pageFormatter && pageText.setStyle("text", isString(pageFormatter) ? pageFormatter.replace("{current}", current == null ? "" : current + "").replace("{total}", total == null ? "" : total + "") : pageFormatter({
      current,
      total
    }));
  };
  ScrollableLegendView2.prototype._getPageInfo = function(legendModel) {
    var scrollDataIndex = legendModel.get("scrollDataIndex", true);
    var contentGroup = this.getContentGroup();
    var containerRectSize = this._containerGroup.__rectSize;
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var targetItemIndex = this._findTargetItemIndex(scrollDataIndex);
    var children = contentGroup.children();
    var targetItem = children[targetItemIndex];
    var itemCount = children.length;
    var pCount = !itemCount ? 0 : 1;
    var result = {
      contentPosition: [contentGroup.x, contentGroup.y],
      pageCount: pCount,
      pageIndex: pCount - 1,
      pagePrevDataIndex: null,
      pageNextDataIndex: null
    };
    if (!targetItem) {
      return result;
    }
    var targetItemInfo = getItemInfo(targetItem);
    result.contentPosition[orientIdx] = -targetItemInfo.s;
    for (var i = targetItemIndex + 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i <= itemCount; ++i) {
      currItemInfo = getItemInfo(children[i]);
      if (!currItemInfo && winEndItemInfo.e > winStartItemInfo.s + containerRectSize || currItemInfo && !intersect2(currItemInfo, winStartItemInfo.s)) {
        if (winEndItemInfo.i > winStartItemInfo.i) {
          winStartItemInfo = winEndItemInfo;
        } else {
          winStartItemInfo = currItemInfo;
        }
        if (winStartItemInfo) {
          if (result.pageNextDataIndex == null) {
            result.pageNextDataIndex = winStartItemInfo.i;
          }
          ++result.pageCount;
        }
      }
      winEndItemInfo = currItemInfo;
    }
    for (var i = targetItemIndex - 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i >= -1; --i) {
      currItemInfo = getItemInfo(children[i]);
      if ((!currItemInfo || !intersect2(winEndItemInfo, currItemInfo.s)) && winStartItemInfo.i < winEndItemInfo.i) {
        winEndItemInfo = winStartItemInfo;
        if (result.pagePrevDataIndex == null) {
          result.pagePrevDataIndex = winStartItemInfo.i;
        }
        ++result.pageCount;
        ++result.pageIndex;
      }
      winStartItemInfo = currItemInfo;
    }
    return result;
    function getItemInfo(el) {
      if (el) {
        var itemRect = el.getBoundingRect();
        var start2 = itemRect[xy] + el[xy];
        return {
          s: start2,
          e: start2 + itemRect[wh],
          i: el.__legendDataIndex
        };
      }
    }
    function intersect2(itemInfo, winStart) {
      return itemInfo.e >= winStart && itemInfo.s <= winStart + containerRectSize;
    }
  };
  ScrollableLegendView2.prototype._findTargetItemIndex = function(targetDataIndex) {
    if (!this._showController) {
      return 0;
    }
    var index2;
    var contentGroup = this.getContentGroup();
    var defaultIndex;
    contentGroup.eachChild(function(child, idx) {
      var legendDataIdx = child.__legendDataIndex;
      if (defaultIndex == null && legendDataIdx != null) {
        defaultIndex = idx;
      }
      if (legendDataIdx === targetDataIndex) {
        index2 = idx;
      }
    });
    return index2 != null ? index2 : defaultIndex;
  };
  ScrollableLegendView2.type = "legend.scroll";
  return ScrollableLegendView2;
}(LegendView$1);
var ScrollableLegendView$1 = ScrollableLegendView;
function installScrollableLegendAction(registers) {
  registers.registerAction("legendScroll", "legendscroll", function(payload, ecModel) {
    var scrollDataIndex = payload.scrollDataIndex;
    scrollDataIndex != null && ecModel.eachComponent({
      mainType: "legend",
      subType: "scroll",
      query: payload
    }, function(legendModel) {
      legendModel.setScrollDataIndex(scrollDataIndex);
    });
  });
}
function install$a(registers) {
  use(install$b);
  registers.registerComponentModel(ScrollableLegendModel$1);
  registers.registerComponentView(ScrollableLegendView$1);
  installScrollableLegendAction(registers);
}
function install$9(registers) {
  use(install$b);
  use(install$a);
}
var InsideZoomModel = function(_super) {
  __extends(InsideZoomModel2, _super);
  function InsideZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = InsideZoomModel2.type;
    return _this;
  }
  InsideZoomModel2.type = "dataZoom.inside";
  InsideZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    disabled: false,
    zoomLock: false,
    zoomOnMouseWheel: true,
    moveOnMouseMove: true,
    moveOnMouseWheel: false,
    preventDefaultMouseMove: true
  });
  return InsideZoomModel2;
}(DataZoomModel$1);
var InsideZoomModel$1 = InsideZoomModel;
var inner$1 = makeInner();
function setViewInfoToCoordSysRecord(api, dataZoomModel, getRange) {
  inner$1(api).coordSysRecordMap.each(function(coordSysRecord) {
    var dzInfo = coordSysRecord.dataZoomInfoMap.get(dataZoomModel.uid);
    if (dzInfo) {
      dzInfo.getRange = getRange;
    }
  });
}
function disposeCoordSysRecordIfNeeded(api, dataZoomModel) {
  var coordSysRecordMap = inner$1(api).coordSysRecordMap;
  var coordSysKeyArr = coordSysRecordMap.keys();
  for (var i = 0; i < coordSysKeyArr.length; i++) {
    var coordSysKey = coordSysKeyArr[i];
    var coordSysRecord = coordSysRecordMap.get(coordSysKey);
    var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
    if (dataZoomInfoMap) {
      var dzUid = dataZoomModel.uid;
      var dzInfo = dataZoomInfoMap.get(dzUid);
      if (dzInfo) {
        dataZoomInfoMap.removeKey(dzUid);
        if (!dataZoomInfoMap.keys().length) {
          disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        }
      }
    }
  }
}
function disposeCoordSysRecord(coordSysRecordMap, coordSysRecord) {
  if (coordSysRecord) {
    coordSysRecordMap.removeKey(coordSysRecord.model.uid);
    var controller = coordSysRecord.controller;
    controller && controller.dispose();
  }
}
function createCoordSysRecord(api, coordSysModel) {
  var coordSysRecord = {
    model: coordSysModel,
    containsPoint: curry$1(containsPoint, coordSysModel),
    dispatchAction: curry$1(dispatchAction, api),
    dataZoomInfoMap: null,
    controller: null
  };
  var controller = coordSysRecord.controller = new RoamController$1(api.getZr());
  each$f(["pan", "zoom", "scrollMove"], function(eventName) {
    controller.on(eventName, function(event) {
      var batch = [];
      coordSysRecord.dataZoomInfoMap.each(function(dzInfo) {
        if (!event.isAvailableBehavior(dzInfo.model.option)) {
          return;
        }
        var method4 = (dzInfo.getRange || {})[eventName];
        var range3 = method4 && method4(dzInfo.dzReferCoordSysInfo, coordSysRecord.model.mainType, coordSysRecord.controller, event);
        !dzInfo.model.get("disabled", true) && range3 && batch.push({
          dataZoomId: dzInfo.model.id,
          start: range3[0],
          end: range3[1]
        });
      });
      batch.length && coordSysRecord.dispatchAction(batch);
    });
  });
  return coordSysRecord;
}
function dispatchAction(api, batch) {
  if (!api.isDisposed()) {
    api.dispatchAction({
      type: "dataZoom",
      animation: {
        easing: "cubicOut",
        duration: 100
      },
      batch
    });
  }
}
function containsPoint(coordSysModel, e2, x2, y2) {
  return coordSysModel.coordinateSystem.containPoint([x2, y2]);
}
function mergeControllerParams(dataZoomInfoMap) {
  var controlType;
  var prefix = "type_";
  var typePriority = {
    "type_true": 2,
    "type_move": 1,
    "type_false": 0,
    "type_undefined": -1
  };
  var preventDefaultMouseMove = true;
  dataZoomInfoMap.each(function(dataZoomInfo) {
    var dataZoomModel = dataZoomInfo.model;
    var oneType = dataZoomModel.get("disabled", true) ? false : dataZoomModel.get("zoomLock", true) ? "move" : true;
    if (typePriority[prefix + oneType] > typePriority[prefix + controlType]) {
      controlType = oneType;
    }
    preventDefaultMouseMove = preventDefaultMouseMove && dataZoomModel.get("preventDefaultMouseMove", true);
  });
  return {
    controlType,
    opt: {
      zoomOnMouseWheel: true,
      moveOnMouseMove: true,
      moveOnMouseWheel: true,
      preventDefaultMouseMove: !!preventDefaultMouseMove
    }
  };
}
function installDataZoomRoamProcessor(registers) {
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, function(ecModel, api) {
    var apiInner = inner$1(api);
    var coordSysRecordMap = apiInner.coordSysRecordMap || (apiInner.coordSysRecordMap = createHashMap());
    coordSysRecordMap.each(function(coordSysRecord) {
      coordSysRecord.dataZoomInfoMap = null;
    });
    ecModel.eachComponent({
      mainType: "dataZoom",
      subType: "inside"
    }, function(dataZoomModel) {
      var dzReferCoordSysWrap = collectReferCoordSysModelInfo(dataZoomModel);
      each$f(dzReferCoordSysWrap.infoList, function(dzCoordSysInfo) {
        var coordSysUid = dzCoordSysInfo.model.uid;
        var coordSysRecord = coordSysRecordMap.get(coordSysUid) || coordSysRecordMap.set(coordSysUid, createCoordSysRecord(api, dzCoordSysInfo.model));
        var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap || (coordSysRecord.dataZoomInfoMap = createHashMap());
        dataZoomInfoMap.set(dataZoomModel.uid, {
          dzReferCoordSysInfo: dzCoordSysInfo,
          model: dataZoomModel,
          getRange: null
        });
      });
    });
    coordSysRecordMap.each(function(coordSysRecord) {
      var controller = coordSysRecord.controller;
      var firstDzInfo;
      var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
      if (dataZoomInfoMap) {
        var firstDzKey = dataZoomInfoMap.keys()[0];
        if (firstDzKey != null) {
          firstDzInfo = dataZoomInfoMap.get(firstDzKey);
        }
      }
      if (!firstDzInfo) {
        disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        return;
      }
      var controllerParams = mergeControllerParams(dataZoomInfoMap);
      controller.enable(controllerParams.controlType, controllerParams.opt);
      controller.setPointerChecker(coordSysRecord.containsPoint);
      createOrUpdate(coordSysRecord, "dispatchAction", firstDzInfo.model.get("throttle", true), "fixRate");
    });
  });
}
var InsideZoomView = function(_super) {
  __extends(InsideZoomView2, _super);
  function InsideZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataZoom.inside";
    return _this;
  }
  InsideZoomView2.prototype.render = function(dataZoomModel, ecModel, api) {
    _super.prototype.render.apply(this, arguments);
    if (dataZoomModel.noTarget()) {
      this._clear();
      return;
    }
    this.range = dataZoomModel.getPercentRange();
    setViewInfoToCoordSysRecord(api, dataZoomModel, {
      pan: bind$1(getRangeHandlers.pan, this),
      zoom: bind$1(getRangeHandlers.zoom, this),
      scrollMove: bind$1(getRangeHandlers.scrollMove, this)
    });
  };
  InsideZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  InsideZoomView2.prototype._clear = function() {
    disposeCoordSysRecordIfNeeded(this.api, this.dataZoomModel);
    this.range = null;
  };
  InsideZoomView2.type = "dataZoom.inside";
  return InsideZoomView2;
}(DataZoomView$1);
var getRangeHandlers = {
  zoom: function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var directionInfo = getDirectionInfo[coordSysMainType](null, [e2.originX, e2.originY], axisModel, controller, coordSysInfo);
    var percentPoint = (directionInfo.signal > 0 ? directionInfo.pixelStart + directionInfo.pixelLength - directionInfo.pixel : directionInfo.pixel - directionInfo.pixelStart) / directionInfo.pixelLength * (range3[1] - range3[0]) + range3[0];
    var scale2 = Math.max(1 / e2.scale, 0);
    range3[0] = (range3[0] - percentPoint) * scale2 + percentPoint;
    range3[1] = (range3[1] - percentPoint) * scale2 + percentPoint;
    var minMaxSpan = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    sliderMove(0, range3, [0, 100], 0, minMaxSpan.minSpan, minMaxSpan.maxSpan);
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  },
  pan: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([e2.oldX, e2.oldY], [e2.newX, e2.newY], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * directionInfo.pixel / directionInfo.pixelLength;
  }),
  scrollMove: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([0, 0], [e2.scrollDelta, e2.scrollDelta], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * e2.scrollDelta;
  })
};
function makeMover(getPercentDelta) {
  return function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var percentDelta = getPercentDelta(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2);
    sliderMove(percentDelta, range3, [0, 100], "all");
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  };
}
var getDirectionInfo = {
  grid: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    oldPoint = oldPoint || [0, 0];
    if (axis.dim === "x") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  polar: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var polar = coordSysInfo.model.coordinateSystem;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var angleExtent = polar.getAngleAxis().getExtent();
    oldPoint = oldPoint ? polar.pointToCoord(oldPoint) : [0, 0];
    newPoint = polar.pointToCoord(newPoint);
    if (axisModel.mainType === "radiusAxis") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = radiusExtent[1] - radiusExtent[0];
      ret.pixelStart = radiusExtent[0];
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = angleExtent[1] - angleExtent[0];
      ret.pixelStart = angleExtent[0];
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  singleAxis: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    var ret = {};
    oldPoint = oldPoint || [0, 0];
    if (axis.orient === "horizontal") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  }
};
var InsideZoomView$1 = InsideZoomView;
function install$8(registers) {
  installCommon$1(registers);
  registers.registerComponentModel(InsideZoomModel$1);
  registers.registerComponentView(InsideZoomView$1);
  installDataZoomRoamProcessor(registers);
}
var SliderZoomModel = function(_super) {
  __extends(SliderZoomModel2, _super);
  function SliderZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomModel2.type;
    return _this;
  }
  SliderZoomModel2.type = "dataZoom.slider";
  SliderZoomModel2.layoutMode = "box";
  SliderZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    show: true,
    right: "ph",
    top: "ph",
    width: "ph",
    height: "ph",
    left: null,
    bottom: null,
    borderColor: "#d2dbee",
    borderRadius: 3,
    backgroundColor: "rgba(47,69,84,0)",
    dataBackground: {
      lineStyle: {
        color: "#d2dbee",
        width: 0.5
      },
      areaStyle: {
        color: "#d2dbee",
        opacity: 0.2
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#8fb0f7",
        width: 0.5
      },
      areaStyle: {
        color: "#8fb0f7",
        opacity: 0.2
      }
    },
    fillerColor: "rgba(135,175,274,0.2)",
    handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z",
    handleSize: "100%",
    handleStyle: {
      color: "#fff",
      borderColor: "#ACB8D1"
    },
    moveHandleSize: 7,
    moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z",
    moveHandleStyle: {
      color: "#D2DBEE",
      opacity: 0.7
    },
    showDetail: true,
    showDataShadow: "auto",
    realtime: true,
    zoomLock: false,
    textStyle: {
      color: "#6E7079"
    },
    brushSelect: true,
    brushStyle: {
      color: "rgba(135,175,274,0.15)"
    },
    emphasis: {
      handleStyle: {
        borderColor: "#8FB0F7"
      },
      moveHandleStyle: {
        color: "#8FB0F7"
      }
    }
  });
  return SliderZoomModel2;
}(DataZoomModel$1);
var SliderZoomModel$1 = SliderZoomModel;
var Rect = Rect$3;
var DEFAULT_LOCATION_EDGE_GAP = 7;
var DEFAULT_FRAME_BORDER_WIDTH = 1;
var DEFAULT_FILLER_SIZE = 30;
var DEFAULT_MOVE_HANDLE_SIZE = 7;
var HORIZONTAL = "horizontal";
var VERTICAL = "vertical";
var LABEL_GAP = 5;
var SHOW_DATA_SHADOW_SERIES_TYPE = ["line", "bar", "candlestick", "scatter"];
var REALTIME_ANIMATION_CONFIG = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
};
var SliderZoomView = function(_super) {
  __extends(SliderZoomView2, _super);
  function SliderZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomView2.type;
    _this._displayables = {};
    return _this;
  }
  SliderZoomView2.prototype.init = function(ecModel, api) {
    this.api = api;
    this._onBrush = bind$1(this._onBrush, this);
    this._onBrushEnd = bind$1(this._onBrushEnd, this);
  };
  SliderZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    _super.prototype.render.apply(this, arguments);
    createOrUpdate(this, "_dispatchZoomAction", dataZoomModel.get("throttle"), "fixRate");
    this._orient = dataZoomModel.getOrient();
    if (dataZoomModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    if (dataZoomModel.noTarget()) {
      this._clear();
      this.group.removeAll();
      return;
    }
    if (!payload || payload.type !== "dataZoom" || payload.from !== this.uid) {
      this._buildView();
    }
    this._updateView();
  };
  SliderZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  SliderZoomView2.prototype._clear = function() {
    clear$1(this, "_dispatchZoomAction");
    var zr = this.api.getZr();
    zr.off("mousemove", this._onBrush);
    zr.off("mouseup", this._onBrushEnd);
  };
  SliderZoomView2.prototype._buildView = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    this._brushing = false;
    this._displayables.brushRect = null;
    this._resetLocation();
    this._resetInterval();
    var barGroup = this._displayables.sliderGroup = new Group$4();
    this._renderBackground();
    this._renderHandle();
    this._renderDataShadow();
    thisGroup.add(barGroup);
    this._positionGroup();
  };
  SliderZoomView2.prototype._resetLocation = function() {
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var showMoveHandle = dataZoomModel.get("brushSelect");
    var moveHandleSize = showMoveHandle ? DEFAULT_MOVE_HANDLE_SIZE : 0;
    var coordRect = this._findCoordRect();
    var ecSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var positionInfo = this._orient === HORIZONTAL ? {
      right: ecSize.width - coordRect.x - coordRect.width,
      top: ecSize.height - DEFAULT_FILLER_SIZE - DEFAULT_LOCATION_EDGE_GAP - moveHandleSize,
      width: coordRect.width,
      height: DEFAULT_FILLER_SIZE
    } : {
      right: DEFAULT_LOCATION_EDGE_GAP,
      top: coordRect.y,
      width: DEFAULT_FILLER_SIZE,
      height: coordRect.height
    };
    var layoutParams = getLayoutParams(dataZoomModel.option);
    each$f(["right", "top", "width", "height"], function(name) {
      if (layoutParams[name] === "ph") {
        layoutParams[name] = positionInfo[name];
      }
    });
    var layoutRect = getLayoutRect(layoutParams, ecSize);
    this._location = {
      x: layoutRect.x,
      y: layoutRect.y
    };
    this._size = [layoutRect.width, layoutRect.height];
    this._orient === VERTICAL && this._size.reverse();
  };
  SliderZoomView2.prototype._positionGroup = function() {
    var thisGroup = this.group;
    var location = this._location;
    var orient = this._orient;
    var targetAxisModel = this.dataZoomModel.getFirstTargetAxisModel();
    var inverse = targetAxisModel && targetAxisModel.get("inverse");
    var sliderGroup = this._displayables.sliderGroup;
    var otherAxisInverse = (this._dataShadowInfo || {}).otherAxisInverse;
    sliderGroup.attr(orient === HORIZONTAL && !inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: 1
    } : orient === HORIZONTAL && inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: -1
    } : orient === VERTICAL && !inverse ? {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: 1,
      rotation: Math.PI / 2
    } : {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: -1,
      rotation: Math.PI / 2
    });
    var rect = thisGroup.getBoundingRect([sliderGroup]);
    thisGroup.x = location.x - rect.x;
    thisGroup.y = location.y - rect.y;
    thisGroup.markRedraw();
  };
  SliderZoomView2.prototype._getViewExtent = function() {
    return [0, this._size[0]];
  };
  SliderZoomView2.prototype._renderBackground = function() {
    var dataZoomModel = this.dataZoomModel;
    var size = this._size;
    var barGroup = this._displayables.sliderGroup;
    var brushSelect = dataZoomModel.get("brushSelect");
    barGroup.add(new Rect({
      silent: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: dataZoomModel.get("backgroundColor")
      },
      z2: -40
    }));
    var clickPanel = new Rect({
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: "transparent"
      },
      z2: 0,
      onclick: bind$1(this._onClickPanel, this)
    });
    var zr = this.api.getZr();
    if (brushSelect) {
      clickPanel.on("mousedown", this._onBrushStart, this);
      clickPanel.cursor = "crosshair";
      zr.on("mousemove", this._onBrush);
      zr.on("mouseup", this._onBrushEnd);
    } else {
      zr.off("mousemove", this._onBrush);
      zr.off("mouseup", this._onBrushEnd);
    }
    barGroup.add(clickPanel);
  };
  SliderZoomView2.prototype._renderDataShadow = function() {
    var info = this._dataShadowInfo = this._prepareDataShadowInfo();
    this._displayables.dataShadowSegs = [];
    if (!info) {
      return;
    }
    var size = this._size;
    var oldSize = this._shadowSize || [];
    var seriesModel = info.series;
    var data = seriesModel.getRawData();
    var otherDim = seriesModel.getShadowDim ? seriesModel.getShadowDim() : info.otherDim;
    if (otherDim == null) {
      return;
    }
    var polygonPts = this._shadowPolygonPts;
    var polylinePts = this._shadowPolylinePts;
    if (data !== this._shadowData || otherDim !== this._shadowDim || size[0] !== oldSize[0] || size[1] !== oldSize[1]) {
      var otherDataExtent_1 = data.getDataExtent(otherDim);
      var otherOffset = (otherDataExtent_1[1] - otherDataExtent_1[0]) * 0.3;
      otherDataExtent_1 = [otherDataExtent_1[0] - otherOffset, otherDataExtent_1[1] + otherOffset];
      var otherShadowExtent_1 = [0, size[1]];
      var thisShadowExtent = [0, size[0]];
      var areaPoints_1 = [[size[0], 0], [0, 0]];
      var linePoints_1 = [];
      var step_1 = thisShadowExtent[1] / (data.count() - 1);
      var thisCoord_1 = 0;
      var stride_1 = Math.round(data.count() / size[0]);
      var lastIsEmpty_1;
      data.each([otherDim], function(value, index2) {
        if (stride_1 > 0 && index2 % stride_1) {
          thisCoord_1 += step_1;
          return;
        }
        var isEmpty = value == null || isNaN(value) || value === "";
        var otherCoord = isEmpty ? 0 : linearMap$2(value, otherDataExtent_1, otherShadowExtent_1, true);
        if (isEmpty && !lastIsEmpty_1 && index2) {
          areaPoints_1.push([areaPoints_1[areaPoints_1.length - 1][0], 0]);
          linePoints_1.push([linePoints_1[linePoints_1.length - 1][0], 0]);
        } else if (!isEmpty && lastIsEmpty_1) {
          areaPoints_1.push([thisCoord_1, 0]);
          linePoints_1.push([thisCoord_1, 0]);
        }
        areaPoints_1.push([thisCoord_1, otherCoord]);
        linePoints_1.push([thisCoord_1, otherCoord]);
        thisCoord_1 += step_1;
        lastIsEmpty_1 = isEmpty;
      });
      polygonPts = this._shadowPolygonPts = areaPoints_1;
      polylinePts = this._shadowPolylinePts = linePoints_1;
    }
    this._shadowData = data;
    this._shadowDim = otherDim;
    this._shadowSize = [size[0], size[1]];
    var dataZoomModel = this.dataZoomModel;
    function createDataShadowGroup(isSelectedArea) {
      var model = dataZoomModel.getModel(isSelectedArea ? "selectedDataBackground" : "dataBackground");
      var group2 = new Group$4();
      var polygon = new Polygon$1({
        shape: {
          points: polygonPts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("areaStyle").getAreaStyle(),
        silent: true,
        z2: -20
      });
      var polyline = new Polyline$3({
        shape: {
          points: polylinePts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("lineStyle").getLineStyle(),
        silent: true,
        z2: -19
      });
      group2.add(polygon);
      group2.add(polyline);
      return group2;
    }
    for (var i = 0; i < 3; i++) {
      var group = createDataShadowGroup(i === 1);
      this._displayables.sliderGroup.add(group);
      this._displayables.dataShadowSegs.push(group);
    }
  };
  SliderZoomView2.prototype._prepareDataShadowInfo = function() {
    var dataZoomModel = this.dataZoomModel;
    var showDataShadow = dataZoomModel.get("showDataShadow");
    if (showDataShadow === false) {
      return;
    }
    var result;
    var ecModel = this.ecModel;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var seriesModels = dataZoomModel.getAxisProxy(axisDim, axisIndex).getTargetSeriesModels();
      each$f(seriesModels, function(seriesModel) {
        if (result) {
          return;
        }
        if (showDataShadow !== true && indexOf(SHOW_DATA_SHADOW_SERIES_TYPE, seriesModel.get("type")) < 0) {
          return;
        }
        var thisAxis = ecModel.getComponent(getAxisMainType(axisDim), axisIndex).axis;
        var otherDim = getOtherDim(axisDim);
        var otherAxisInverse;
        var coordSys = seriesModel.coordinateSystem;
        if (otherDim != null && coordSys.getOtherAxis) {
          otherAxisInverse = coordSys.getOtherAxis(thisAxis).inverse;
        }
        otherDim = seriesModel.getData().mapDimension(otherDim);
        result = {
          thisAxis,
          series: seriesModel,
          thisDim: axisDim,
          otherDim,
          otherAxisInverse
        };
      }, this);
    }, this);
    return result;
  };
  SliderZoomView2.prototype._renderHandle = function() {
    var thisGroup = this.group;
    var displayables = this._displayables;
    var handles = displayables.handles = [null, null];
    var handleLabels = displayables.handleLabels = [null, null];
    var sliderGroup = this._displayables.sliderGroup;
    var size = this._size;
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var borderRadius = dataZoomModel.get("borderRadius") || 0;
    var brushSelect = dataZoomModel.get("brushSelect");
    var filler = displayables.filler = new Rect({
      silent: brushSelect,
      style: {
        fill: dataZoomModel.get("fillerColor")
      },
      textConfig: {
        position: "inside"
      }
    });
    sliderGroup.add(filler);
    sliderGroup.add(new Rect({
      silent: true,
      subPixelOptimize: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1],
        r: borderRadius
      },
      style: {
        stroke: dataZoomModel.get("dataBackgroundColor") || dataZoomModel.get("borderColor"),
        lineWidth: DEFAULT_FRAME_BORDER_WIDTH,
        fill: "rgba(0,0,0,0)"
      }
    }));
    each$f([0, 1], function(handleIndex) {
      var iconStr = dataZoomModel.get("handleIcon");
      if (!symbolBuildProxies[iconStr] && iconStr.indexOf("path://") < 0 && iconStr.indexOf("image://") < 0) {
        iconStr = "path://" + iconStr;
      }
      var path = createSymbol$1(iconStr, -1, 0, 2, 2, null, true);
      path.attr({
        cursor: getCursor$1(this._orient),
        draggable: true,
        drift: bind$1(this._onDragMove, this, handleIndex),
        ondragend: bind$1(this._onDragEnd, this),
        onmouseover: bind$1(this._showDataInfo, this, true),
        onmouseout: bind$1(this._showDataInfo, this, false),
        z2: 5
      });
      var bRect = path.getBoundingRect();
      var handleSize = dataZoomModel.get("handleSize");
      this._handleHeight = parsePercent(handleSize, this._size[1]);
      this._handleWidth = bRect.width / bRect.height * this._handleHeight;
      path.setStyle(dataZoomModel.getModel("handleStyle").getItemStyle());
      path.style.strokeNoScale = true;
      path.rectHover = true;
      path.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
      enableHoverEmphasis(path);
      var handleColor = dataZoomModel.get("handleColor");
      if (handleColor != null) {
        path.style.fill = handleColor;
      }
      sliderGroup.add(handles[handleIndex] = path);
      var textStyleModel = dataZoomModel.getModel("textStyle");
      thisGroup.add(handleLabels[handleIndex] = new ZRText$1({
        silent: true,
        invisible: true,
        style: createTextStyle(textStyleModel, {
          x: 0,
          y: 0,
          text: "",
          verticalAlign: "middle",
          align: "center",
          fill: textStyleModel.getTextColor(),
          font: textStyleModel.getFont()
        }),
        z2: 10
      }));
    }, this);
    var actualMoveZone = filler;
    if (brushSelect) {
      var moveHandleHeight = parsePercent(dataZoomModel.get("moveHandleSize"), size[1]);
      var moveHandle_1 = displayables.moveHandle = new Rect$3({
        style: dataZoomModel.getModel("moveHandleStyle").getItemStyle(),
        silent: true,
        shape: {
          r: [0, 0, 2, 2],
          y: size[1] - 0.5,
          height: moveHandleHeight
        }
      });
      var iconSize = moveHandleHeight * 0.8;
      var moveHandleIcon = displayables.moveHandleIcon = createSymbol$1(dataZoomModel.get("moveHandleIcon"), -iconSize / 2, -iconSize / 2, iconSize, iconSize, "#fff", true);
      moveHandleIcon.silent = true;
      moveHandleIcon.y = size[1] + moveHandleHeight / 2 - 0.5;
      moveHandle_1.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
      var moveZoneExpandSize = Math.min(size[1] / 2, Math.max(moveHandleHeight, 10));
      actualMoveZone = displayables.moveZone = new Rect$3({
        invisible: true,
        shape: {
          y: size[1] - moveZoneExpandSize,
          height: moveHandleHeight + moveZoneExpandSize
        }
      });
      actualMoveZone.on("mouseover", function() {
        api.enterEmphasis(moveHandle_1);
      }).on("mouseout", function() {
        api.leaveEmphasis(moveHandle_1);
      });
      sliderGroup.add(moveHandle_1);
      sliderGroup.add(moveHandleIcon);
      sliderGroup.add(actualMoveZone);
    }
    actualMoveZone.attr({
      draggable: true,
      cursor: getCursor$1(this._orient),
      drift: bind$1(this._onDragMove, this, "all"),
      ondragstart: bind$1(this._showDataInfo, this, true),
      ondragend: bind$1(this._onDragEnd, this),
      onmouseover: bind$1(this._showDataInfo, this, true),
      onmouseout: bind$1(this._showDataInfo, this, false)
    });
  };
  SliderZoomView2.prototype._resetInterval = function() {
    var range3 = this._range = this.dataZoomModel.getPercentRange();
    var viewExtent = this._getViewExtent();
    this._handleEnds = [linearMap$2(range3[0], [0, 100], viewExtent, true), linearMap$2(range3[1], [0, 100], viewExtent, true)];
  };
  SliderZoomView2.prototype._updateInterval = function(handleIndex, delta) {
    var dataZoomModel = this.dataZoomModel;
    var handleEnds = this._handleEnds;
    var viewExtend = this._getViewExtent();
    var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    var percentExtent = [0, 100];
    sliderMove(delta, handleEnds, viewExtend, dataZoomModel.get("zoomLock") ? "all" : handleIndex, minMaxSpan.minSpan != null ? linearMap$2(minMaxSpan.minSpan, percentExtent, viewExtend, true) : null, minMaxSpan.maxSpan != null ? linearMap$2(minMaxSpan.maxSpan, percentExtent, viewExtend, true) : null);
    var lastRange = this._range;
    var range3 = this._range = asc$2([linearMap$2(handleEnds[0], viewExtend, percentExtent, true), linearMap$2(handleEnds[1], viewExtend, percentExtent, true)]);
    return !lastRange || lastRange[0] !== range3[0] || lastRange[1] !== range3[1];
  };
  SliderZoomView2.prototype._updateView = function(nonRealtime) {
    var displaybles = this._displayables;
    var handleEnds = this._handleEnds;
    var handleInterval = asc$2(handleEnds.slice());
    var size = this._size;
    each$f([0, 1], function(handleIndex) {
      var handle = displaybles.handles[handleIndex];
      var handleHeight = this._handleHeight;
      handle.attr({
        scaleX: handleHeight / 2,
        scaleY: handleHeight / 2,
        x: handleEnds[handleIndex] + (handleIndex ? -1 : 1),
        y: size[1] / 2 - handleHeight / 2
      });
    }, this);
    displaybles.filler.setShape({
      x: handleInterval[0],
      y: 0,
      width: handleInterval[1] - handleInterval[0],
      height: size[1]
    });
    var viewExtent = {
      x: handleInterval[0],
      width: handleInterval[1] - handleInterval[0]
    };
    if (displaybles.moveHandle) {
      displaybles.moveHandle.setShape(viewExtent);
      displaybles.moveZone.setShape(viewExtent);
      displaybles.moveZone.getBoundingRect();
      displaybles.moveHandleIcon && displaybles.moveHandleIcon.attr("x", viewExtent.x + viewExtent.width / 2);
    }
    var dataShadowSegs = displaybles.dataShadowSegs;
    var segIntervals = [0, handleInterval[0], handleInterval[1], size[0]];
    for (var i = 0; i < dataShadowSegs.length; i++) {
      var segGroup = dataShadowSegs[i];
      var clipPath = segGroup.getClipPath();
      if (!clipPath) {
        clipPath = new Rect$3();
        segGroup.setClipPath(clipPath);
      }
      clipPath.setShape({
        x: segIntervals[i],
        y: 0,
        width: segIntervals[i + 1] - segIntervals[i],
        height: size[1]
      });
    }
    this._updateDataInfo(nonRealtime);
  };
  SliderZoomView2.prototype._updateDataInfo = function(nonRealtime) {
    var dataZoomModel = this.dataZoomModel;
    var displaybles = this._displayables;
    var handleLabels = displaybles.handleLabels;
    var orient = this._orient;
    var labelTexts = ["", ""];
    if (dataZoomModel.get("showDetail")) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var axis = axisProxy.getAxisModel().axis;
        var range3 = this._range;
        var dataInterval = nonRealtime ? axisProxy.calculateDataWindow({
          start: range3[0],
          end: range3[1]
        }).valueWindow : axisProxy.getDataValueWindow();
        labelTexts = [this._formatLabel(dataInterval[0], axis), this._formatLabel(dataInterval[1], axis)];
      }
    }
    var orderedHandleEnds = asc$2(this._handleEnds.slice());
    setLabel.call(this, 0);
    setLabel.call(this, 1);
    function setLabel(handleIndex) {
      var barTransform = getTransform$1(displaybles.handles[handleIndex].parent, this.group);
      var direction = transformDirection(handleIndex === 0 ? "right" : "left", barTransform);
      var offset = this._handleWidth / 2 + LABEL_GAP;
      var textPoint = applyTransform([orderedHandleEnds[handleIndex] + (handleIndex === 0 ? -offset : offset), this._size[1] / 2], barTransform);
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        verticalAlign: orient === HORIZONTAL ? "middle" : direction,
        align: orient === HORIZONTAL ? direction : "center",
        text: labelTexts[handleIndex]
      });
    }
  };
  SliderZoomView2.prototype._formatLabel = function(value, axis) {
    var dataZoomModel = this.dataZoomModel;
    var labelFormatter = dataZoomModel.get("labelFormatter");
    var labelPrecision = dataZoomModel.get("labelPrecision");
    if (labelPrecision == null || labelPrecision === "auto") {
      labelPrecision = axis.getPixelPrecision();
    }
    var valueStr = value == null || isNaN(value) ? "" : axis.type === "category" || axis.type === "time" ? axis.scale.getLabel({
      value: Math.round(value)
    }) : value.toFixed(Math.min(labelPrecision, 20));
    return isFunction(labelFormatter) ? labelFormatter(value, valueStr) : isString(labelFormatter) ? labelFormatter.replace("{value}", valueStr) : valueStr;
  };
  SliderZoomView2.prototype._showDataInfo = function(showOrHide) {
    showOrHide = this._dragging || showOrHide;
    var displayables = this._displayables;
    var handleLabels = displayables.handleLabels;
    handleLabels[0].attr("invisible", !showOrHide);
    handleLabels[1].attr("invisible", !showOrHide);
    displayables.moveHandle && this.api[showOrHide ? "enterEmphasis" : "leaveEmphasis"](displayables.moveHandle, 1);
  };
  SliderZoomView2.prototype._onDragMove = function(handleIndex, dx, dy, event) {
    this._dragging = true;
    stop(event.event);
    var barTransform = this._displayables.sliderGroup.getLocalTransform();
    var vertex = applyTransform([dx, dy], barTransform, true);
    var changed = this._updateInterval(handleIndex, vertex[0]);
    var realtime = this.dataZoomModel.get("realtime");
    this._updateView(!realtime);
    changed && realtime && this._dispatchZoomAction(true);
  };
  SliderZoomView2.prototype._onDragEnd = function() {
    this._dragging = false;
    this._showDataInfo(false);
    var realtime = this.dataZoomModel.get("realtime");
    !realtime && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onClickPanel = function(e2) {
    var size = this._size;
    var localPoint = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
    if (localPoint[0] < 0 || localPoint[0] > size[0] || localPoint[1] < 0 || localPoint[1] > size[1]) {
      return;
    }
    var handleEnds = this._handleEnds;
    var center2 = (handleEnds[0] + handleEnds[1]) / 2;
    var changed = this._updateInterval("all", localPoint[0] - center2);
    this._updateView();
    changed && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrushStart = function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    this._brushStart = new Point$1(x2, y2);
    this._brushing = true;
    this._brushStartTime = +new Date();
  };
  SliderZoomView2.prototype._onBrushEnd = function(e2) {
    if (!this._brushing) {
      return;
    }
    var brushRect = this._displayables.brushRect;
    this._brushing = false;
    if (!brushRect) {
      return;
    }
    brushRect.attr("ignore", true);
    var brushShape = brushRect.shape;
    var brushEndTime = +new Date();
    if (brushEndTime - this._brushStartTime < 200 && Math.abs(brushShape.width) < 5) {
      return;
    }
    var viewExtend = this._getViewExtent();
    var percentExtent = [0, 100];
    this._range = asc$2([linearMap$2(brushShape.x, viewExtend, percentExtent, true), linearMap$2(brushShape.x + brushShape.width, viewExtend, percentExtent, true)]);
    this._handleEnds = [brushShape.x, brushShape.x + brushShape.width];
    this._updateView();
    this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrush = function(e2) {
    if (this._brushing) {
      stop(e2.event);
      this._updateBrushRect(e2.offsetX, e2.offsetY);
    }
  };
  SliderZoomView2.prototype._updateBrushRect = function(mouseX, mouseY) {
    var displayables = this._displayables;
    var dataZoomModel = this.dataZoomModel;
    var brushRect = displayables.brushRect;
    if (!brushRect) {
      brushRect = displayables.brushRect = new Rect({
        silent: true,
        style: dataZoomModel.getModel("brushStyle").getItemStyle()
      });
      displayables.sliderGroup.add(brushRect);
    }
    brushRect.attr("ignore", false);
    var brushStart = this._brushStart;
    var sliderGroup = this._displayables.sliderGroup;
    var endPoint = sliderGroup.transformCoordToLocal(mouseX, mouseY);
    var startPoint = sliderGroup.transformCoordToLocal(brushStart.x, brushStart.y);
    var size = this._size;
    endPoint[0] = Math.max(Math.min(size[0], endPoint[0]), 0);
    brushRect.setShape({
      x: startPoint[0],
      y: 0,
      width: endPoint[0] - startPoint[0],
      height: size[1]
    });
  };
  SliderZoomView2.prototype._dispatchZoomAction = function(realtime) {
    var range3 = this._range;
    this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      dataZoomId: this.dataZoomModel.id,
      animation: realtime ? REALTIME_ANIMATION_CONFIG : null,
      start: range3[0],
      end: range3[1]
    });
  };
  SliderZoomView2.prototype._findCoordRect = function() {
    var rect;
    var coordSysInfoList = collectReferCoordSysModelInfo(this.dataZoomModel).infoList;
    if (!rect && coordSysInfoList.length) {
      var coordSys = coordSysInfoList[0].model.coordinateSystem;
      rect = coordSys.getRect && coordSys.getRect();
    }
    if (!rect) {
      var width = this.api.getWidth();
      var height = this.api.getHeight();
      rect = {
        x: width * 0.2,
        y: height * 0.2,
        width: width * 0.6,
        height: height * 0.6
      };
    }
    return rect;
  };
  SliderZoomView2.type = "dataZoom.slider";
  return SliderZoomView2;
}(DataZoomView$1);
function getOtherDim(thisDim) {
  var map2 = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return map2[thisDim];
}
function getCursor$1(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var SliderZoomView$1 = SliderZoomView;
function install$7(registers) {
  registers.registerComponentModel(SliderZoomModel$1);
  registers.registerComponentView(SliderZoomView$1);
  installCommon$1(registers);
}
function install$6(registers) {
  use(install$8);
  use(install$7);
}
var visualDefault = {
  get: function(visualType, key, isCategory2) {
    var value = clone$4((defaultOption[visualType] || {})[key]);
    return isCategory2 ? isArray$1(value) ? value[value.length - 1] : value : value;
  }
};
var defaultOption = {
  color: {
    active: ["#006edd", "#e0ffff"],
    inactive: ["rgba(0,0,0,0)"]
  },
  colorHue: {
    active: [0, 360],
    inactive: [0, 0]
  },
  colorSaturation: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  colorLightness: {
    active: [0.9, 0.5],
    inactive: [0, 0]
  },
  colorAlpha: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  opacity: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  symbol: {
    active: ["circle", "roundRect", "diamond"],
    inactive: ["none"]
  },
  symbolSize: {
    active: [10, 50],
    inactive: [0, 0]
  }
};
var visualDefault$1 = visualDefault;
var mapVisual = VisualMapping$1.mapVisual;
var eachVisual = VisualMapping$1.eachVisual;
var isArray = isArray$1;
var each$2 = each$f;
var asc = asc$2;
var linearMap$1 = linearMap$2;
var VisualMapModel = function(_super) {
  __extends(VisualMapModel2, _super);
  function VisualMapModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapModel2.type;
    _this.stateList = ["inRange", "outOfRange"];
    _this.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"];
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    _this.dataBound = [-Infinity, Infinity];
    _this.targetVisuals = {};
    _this.controllerVisuals = {};
    return _this;
  }
  VisualMapModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  VisualMapModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, this.replacableOptionKeys);
    this.textStyleModel = this.getModel("textStyle");
    this.resetItemSize();
    this.completeVisualOption();
  };
  VisualMapModel2.prototype.resetVisual = function(supplementVisualOption) {
    var stateList = this.stateList;
    supplementVisualOption = bind$1(supplementVisualOption, this);
    this.controllerVisuals = createVisualMappings(this.option.controller, stateList, supplementVisualOption);
    this.targetVisuals = createVisualMappings(this.option.target, stateList, supplementVisualOption);
  };
  VisualMapModel2.prototype.getItemSymbol = function() {
    return null;
  };
  VisualMapModel2.prototype.getTargetSeriesIndices = function() {
    var optionSeriesIndex = this.option.seriesIndex;
    var seriesIndices = [];
    if (optionSeriesIndex == null || optionSeriesIndex === "all") {
      this.ecModel.eachSeries(function(seriesModel, index2) {
        seriesIndices.push(index2);
      });
    } else {
      seriesIndices = normalizeToArray(optionSeriesIndex);
    }
    return seriesIndices;
  };
  VisualMapModel2.prototype.eachTargetSeries = function(callback, context) {
    each$f(this.getTargetSeriesIndices(), function(seriesIndex) {
      var seriesModel = this.ecModel.getSeriesByIndex(seriesIndex);
      if (seriesModel) {
        callback.call(context, seriesModel);
      }
    }, this);
  };
  VisualMapModel2.prototype.isTargetSeries = function(seriesModel) {
    var is = false;
    this.eachTargetSeries(function(model) {
      model === seriesModel && (is = true);
    });
    return is;
  };
  VisualMapModel2.prototype.formatValueText = function(value, isCategory2, edgeSymbols) {
    var option = this.option;
    var precision = option.precision;
    var dataBound = this.dataBound;
    var formatter = option.formatter;
    var isMinMax;
    edgeSymbols = edgeSymbols || ["<", ">"];
    if (isArray$1(value)) {
      value = value.slice();
      isMinMax = true;
    }
    var textValue = isCategory2 ? value : isMinMax ? [toFixed(value[0]), toFixed(value[1])] : toFixed(value);
    if (isString(formatter)) {
      return formatter.replace("{value}", isMinMax ? textValue[0] : textValue).replace("{value2}", isMinMax ? textValue[1] : textValue);
    } else if (isFunction(formatter)) {
      return isMinMax ? formatter(value[0], value[1]) : formatter(value);
    }
    if (isMinMax) {
      if (value[0] === dataBound[0]) {
        return edgeSymbols[0] + " " + textValue[1];
      } else if (value[1] === dataBound[1]) {
        return edgeSymbols[1] + " " + textValue[0];
      } else {
        return textValue[0] + " - " + textValue[1];
      }
    } else {
      return textValue;
    }
    function toFixed(val) {
      return val === dataBound[0] ? "min" : val === dataBound[1] ? "max" : (+val).toFixed(Math.min(precision, 20));
    }
  };
  VisualMapModel2.prototype.resetExtent = function() {
    var thisOption = this.option;
    var extent3 = asc([thisOption.min, thisOption.max]);
    this._dataExtent = extent3;
  };
  VisualMapModel2.prototype.getDataDimensionIndex = function(data) {
    var optDim = this.option.dimension;
    if (optDim != null) {
      return data.getDimensionIndex(optDim);
    }
    var dimNames = data.dimensions;
    for (var i = dimNames.length - 1; i >= 0; i--) {
      var dimName = dimNames[i];
      var dimInfo = data.getDimensionInfo(dimName);
      if (!dimInfo.isCalculationCoord) {
        return dimInfo.storeDimIndex;
      }
    }
  };
  VisualMapModel2.prototype.getExtent = function() {
    return this._dataExtent.slice();
  };
  VisualMapModel2.prototype.completeVisualOption = function() {
    var ecModel = this.ecModel;
    var thisOption = this.option;
    var base2 = {
      inRange: thisOption.inRange,
      outOfRange: thisOption.outOfRange
    };
    var target = thisOption.target || (thisOption.target = {});
    var controller = thisOption.controller || (thisOption.controller = {});
    merge(target, base2);
    merge(controller, base2);
    var isCategory2 = this.isCategory();
    completeSingle.call(this, target);
    completeSingle.call(this, controller);
    completeInactive.call(this, target, "inRange", "outOfRange");
    completeController.call(this, controller);
    function completeSingle(base3) {
      if (isArray(thisOption.color) && !base3.inRange) {
        base3.inRange = {
          color: thisOption.color.slice().reverse()
        };
      }
      base3.inRange = base3.inRange || {
        color: ecModel.get("gradientColor")
      };
    }
    function completeInactive(base3, stateExist, stateAbsent) {
      var optExist = base3[stateExist];
      var optAbsent = base3[stateAbsent];
      if (optExist && !optAbsent) {
        optAbsent = base3[stateAbsent] = {};
        each$2(optExist, function(visualData, visualType) {
          if (!VisualMapping$1.isValidType(visualType)) {
            return;
          }
          var defa = visualDefault$1.get(visualType, "inactive", isCategory2);
          if (defa != null) {
            optAbsent[visualType] = defa;
            if (visualType === "color" && !optAbsent.hasOwnProperty("opacity") && !optAbsent.hasOwnProperty("colorAlpha")) {
              optAbsent.opacity = [0, 0];
            }
          }
        });
      }
    }
    function completeController(controller2) {
      var symbolExists = (controller2.inRange || {}).symbol || (controller2.outOfRange || {}).symbol;
      var symbolSizeExists = (controller2.inRange || {}).symbolSize || (controller2.outOfRange || {}).symbolSize;
      var inactiveColor = this.get("inactiveColor");
      var itemSymbol = this.getItemSymbol();
      var defaultSymbol = itemSymbol || "roundRect";
      each$2(this.stateList, function(state) {
        var itemSize = this.itemSize;
        var visuals = controller2[state];
        if (!visuals) {
          visuals = controller2[state] = {
            color: isCategory2 ? inactiveColor : [inactiveColor]
          };
        }
        if (visuals.symbol == null) {
          visuals.symbol = symbolExists && clone$4(symbolExists) || (isCategory2 ? defaultSymbol : [defaultSymbol]);
        }
        if (visuals.symbolSize == null) {
          visuals.symbolSize = symbolSizeExists && clone$4(symbolSizeExists) || (isCategory2 ? itemSize[0] : [itemSize[0], itemSize[0]]);
        }
        visuals.symbol = mapVisual(visuals.symbol, function(symbol) {
          return symbol === "none" ? defaultSymbol : symbol;
        });
        var symbolSize = visuals.symbolSize;
        if (symbolSize != null) {
          var max_1 = -Infinity;
          eachVisual(symbolSize, function(value) {
            value > max_1 && (max_1 = value);
          });
          visuals.symbolSize = mapVisual(symbolSize, function(value) {
            return linearMap$1(value, [0, max_1], [0, itemSize[0]], true);
          });
        }
      }, this);
    }
  };
  VisualMapModel2.prototype.resetItemSize = function() {
    this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
  };
  VisualMapModel2.prototype.isCategory = function() {
    return !!this.option.categories;
  };
  VisualMapModel2.prototype.setSelected = function(selected) {
  };
  VisualMapModel2.prototype.getSelected = function() {
    return null;
  };
  VisualMapModel2.prototype.getValueState = function(value) {
    return null;
  };
  VisualMapModel2.prototype.getVisualMeta = function(getColorVisual2) {
    return null;
  };
  VisualMapModel2.type = "visualMap";
  VisualMapModel2.dependencies = ["series"];
  VisualMapModel2.defaultOption = {
    show: true,
    z: 4,
    seriesIndex: "all",
    min: 0,
    max: 200,
    left: 0,
    right: null,
    top: null,
    bottom: 0,
    itemWidth: null,
    itemHeight: null,
    inverse: false,
    orient: "vertical",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    contentColor: "#5793f3",
    inactiveColor: "#aaa",
    borderWidth: 0,
    padding: 5,
    textGap: 10,
    precision: 0,
    textStyle: {
      color: "#333"
    }
  };
  return VisualMapModel2;
}(ComponentModel$1);
var VisualMapModel$1 = VisualMapModel;
var DEFAULT_BAR_BOUND = [20, 140];
var ContinuousModel = function(_super) {
  __extends(ContinuousModel2, _super);
  function ContinuousModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousModel2.type;
    return _this;
  }
  ContinuousModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    this.resetVisual(function(mappingOption) {
      mappingOption.mappingMethod = "linear";
      mappingOption.dataExtent = this.getExtent();
    });
    this._resetRange();
  };
  ContinuousModel2.prototype.resetItemSize = function() {
    _super.prototype.resetItemSize.apply(this, arguments);
    var itemSize = this.itemSize;
    (itemSize[0] == null || isNaN(itemSize[0])) && (itemSize[0] = DEFAULT_BAR_BOUND[0]);
    (itemSize[1] == null || isNaN(itemSize[1])) && (itemSize[1] = DEFAULT_BAR_BOUND[1]);
  };
  ContinuousModel2.prototype._resetRange = function() {
    var dataExtent = this.getExtent();
    var range3 = this.option.range;
    if (!range3 || range3.auto) {
      dataExtent.auto = 1;
      this.option.range = dataExtent;
    } else if (isArray$1(range3)) {
      if (range3[0] > range3[1]) {
        range3.reverse();
      }
      range3[0] = Math.max(range3[0], dataExtent[0]);
      range3[1] = Math.min(range3[1], dataExtent[1]);
    }
  };
  ContinuousModel2.prototype.completeVisualOption = function() {
    _super.prototype.completeVisualOption.apply(this, arguments);
    each$f(this.stateList, function(state) {
      var symbolSize = this.option.controller[state].symbolSize;
      if (symbolSize && symbolSize[0] !== symbolSize[1]) {
        symbolSize[0] = symbolSize[1] / 3;
      }
    }, this);
  };
  ContinuousModel2.prototype.setSelected = function(selected) {
    this.option.range = selected.slice();
    this._resetRange();
  };
  ContinuousModel2.prototype.getSelected = function() {
    var dataExtent = this.getExtent();
    var dataInterval = asc$2((this.get("range") || []).slice());
    dataInterval[0] > dataExtent[1] && (dataInterval[0] = dataExtent[1]);
    dataInterval[1] > dataExtent[1] && (dataInterval[1] = dataExtent[1]);
    dataInterval[0] < dataExtent[0] && (dataInterval[0] = dataExtent[0]);
    dataInterval[1] < dataExtent[0] && (dataInterval[1] = dataExtent[0]);
    return dataInterval;
  };
  ContinuousModel2.prototype.getValueState = function(value) {
    var range3 = this.option.range;
    var dataExtent = this.getExtent();
    return (range3[0] <= dataExtent[0] || range3[0] <= value) && (range3[1] >= dataExtent[1] || value <= range3[1]) ? "inRange" : "outOfRange";
  };
  ContinuousModel2.prototype.findTargetDataIndices = function(range3) {
    var result = [];
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        range3[0] <= value && value <= range3[1] && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  ContinuousModel2.prototype.getVisualMeta = function(getColorVisual2) {
    var oVals = getColorStopValues(this, "outOfRange", this.getExtent());
    var iVals = getColorStopValues(this, "inRange", this.option.range.slice());
    var stops = [];
    function setStop(value, valueState) {
      stops.push({
        value,
        color: getColorVisual2(value, valueState)
      });
    }
    var iIdx = 0;
    var oIdx = 0;
    var iLen = iVals.length;
    var oLen = oVals.length;
    for (; oIdx < oLen && (!iVals.length || oVals[oIdx] <= iVals[0]); oIdx++) {
      if (oVals[oIdx] < iVals[iIdx]) {
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    for (var first = 1; iIdx < iLen; iIdx++, first = 0) {
      first && stops.length && setStop(iVals[iIdx], "outOfRange");
      setStop(iVals[iIdx], "inRange");
    }
    for (var first = 1; oIdx < oLen; oIdx++) {
      if (!iVals.length || iVals[iVals.length - 1] < oVals[oIdx]) {
        if (first) {
          stops.length && setStop(stops[stops.length - 1].value, "outOfRange");
          first = 0;
        }
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    var stopsLen = stops.length;
    return {
      stops,
      outerColors: [stopsLen ? stops[0].color : "transparent", stopsLen ? stops[stopsLen - 1].color : "transparent"]
    };
  };
  ContinuousModel2.type = "visualMap.continuous";
  ContinuousModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    align: "auto",
    calculable: false,
    hoverLink: true,
    realtime: true,
    handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z",
    handleSize: "120%",
    handleStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    indicatorIcon: "circle",
    indicatorSize: "50%",
    indicatorStyle: {
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0,0,0,0.2)"
    }
  });
  return ContinuousModel2;
}(VisualMapModel$1);
function getColorStopValues(visualMapModel, valueState, dataExtent) {
  if (dataExtent[0] === dataExtent[1]) {
    return dataExtent.slice();
  }
  var count2 = 200;
  var step = (dataExtent[1] - dataExtent[0]) / count2;
  var value = dataExtent[0];
  var stopValues = [];
  for (var i = 0; i <= count2 && value < dataExtent[1]; i++) {
    stopValues.push(value);
    value += step;
  }
  stopValues.push(dataExtent[1]);
  return stopValues;
}
var ContinuousModel$1 = ContinuousModel;
var VisualMapView = function(_super) {
  __extends(VisualMapView2, _super);
  function VisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapView2.type;
    _this.autoPositionValues = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 1
    };
    return _this;
  }
  VisualMapView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
  };
  VisualMapView2.prototype.render = function(visualMapModel, ecModel, api, payload) {
    this.visualMapModel = visualMapModel;
    if (visualMapModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    this.doRender(visualMapModel, ecModel, api, payload);
  };
  VisualMapView2.prototype.renderBackground = function(group) {
    var visualMapModel = this.visualMapModel;
    var padding = normalizeCssArray(visualMapModel.get("padding") || 0);
    var rect = group.getBoundingRect();
    group.add(new Rect$3({
      z2: -1,
      silent: true,
      shape: {
        x: rect.x - padding[3],
        y: rect.y - padding[0],
        width: rect.width + padding[3] + padding[1],
        height: rect.height + padding[0] + padding[2]
      },
      style: {
        fill: visualMapModel.get("backgroundColor"),
        stroke: visualMapModel.get("borderColor"),
        lineWidth: visualMapModel.get("borderWidth")
      }
    }));
  };
  VisualMapView2.prototype.getControllerVisual = function(targetValue, visualCluster, opts) {
    opts = opts || {};
    var forceState = opts.forceState;
    var visualMapModel = this.visualMapModel;
    var visualObj = {};
    if (visualCluster === "color") {
      var defaultColor = visualMapModel.get("contentColor");
      visualObj.color = defaultColor;
    }
    function getter(key) {
      return visualObj[key];
    }
    function setter(key, value) {
      visualObj[key] = value;
    }
    var mappings = visualMapModel.controllerVisuals[forceState || visualMapModel.getValueState(targetValue)];
    var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
    each$f(visualTypes, function(type4) {
      var visualMapping = mappings[type4];
      if (opts.convertOpacityToAlpha && type4 === "opacity") {
        type4 = "colorAlpha";
        visualMapping = mappings.__alphaForOpacity;
      }
      if (VisualMapping$1.dependsOn(type4, visualCluster)) {
        visualMapping && visualMapping.applyVisual(targetValue, getter, setter);
      }
    });
    return visualObj[visualCluster];
  };
  VisualMapView2.prototype.positionGroup = function(group) {
    var model = this.visualMapModel;
    var api = this.api;
    positionElement(group, model.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  VisualMapView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
  };
  VisualMapView2.type = "visualMap";
  return VisualMapView2;
}(ComponentView$1);
var VisualMapView$1 = VisualMapView;
var paramsSet = [["left", "right", "width"], ["top", "bottom", "height"]];
function getItemAlign(visualMapModel, api, itemSize) {
  var modelOption = visualMapModel.option;
  var itemAlign = modelOption.align;
  if (itemAlign != null && itemAlign !== "auto") {
    return itemAlign;
  }
  var ecSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var realIndex = modelOption.orient === "horizontal" ? 1 : 0;
  var reals = paramsSet[realIndex];
  var fakeValue = [0, null, 10];
  var layoutInput = {};
  for (var i = 0; i < 3; i++) {
    layoutInput[paramsSet[1 - realIndex][i]] = fakeValue[i];
    layoutInput[reals[i]] = i === 2 ? itemSize[0] : modelOption[reals[i]];
  }
  var rParam = [["x", "width", 3], ["y", "height", 0]][realIndex];
  var rect = getLayoutRect(layoutInput, ecSize, modelOption.padding);
  return reals[(rect.margin[rParam[2]] || 0) + rect[rParam[0]] + rect[rParam[1]] * 0.5 < ecSize[rParam[1]] * 0.5 ? 0 : 1];
}
function makeHighDownBatch(batch, visualMapModel) {
  each$f(batch || [], function(batchItem) {
    if (batchItem.dataIndex != null) {
      batchItem.dataIndexInside = batchItem.dataIndex;
      batchItem.dataIndex = null;
    }
    batchItem.highlightKey = "visualMap" + (visualMapModel ? visualMapModel.componentIndex : "");
  });
  return batch;
}
var linearMap = linearMap$2;
var each$1 = each$f;
var mathMin = Math.min;
var mathMax = Math.max;
var HOVER_LINK_SIZE = 12;
var HOVER_LINK_OUT = 6;
var ContinuousView = function(_super) {
  __extends(ContinuousView2, _super);
  function ContinuousView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousView2.type;
    _this._shapes = {};
    _this._dataInterval = [];
    _this._handleEnds = [];
    _this._hoverLinkDataIndices = [];
    return _this;
  }
  ContinuousView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
    this._api = api;
    if (!payload || payload.type !== "selectDataRange" || payload.from !== this.uid) {
      this._buildView();
    }
  };
  ContinuousView2.prototype._buildView = function() {
    this.group.removeAll();
    var visualMapModel = this.visualMapModel;
    var thisGroup = this.group;
    this._orient = visualMapModel.get("orient");
    this._useHandle = visualMapModel.get("calculable");
    this._resetInterval();
    this._renderBar(thisGroup);
    var dataRangeText = visualMapModel.get("text");
    this._renderEndsText(thisGroup, dataRangeText, 0);
    this._renderEndsText(thisGroup, dataRangeText, 1);
    this._updateView(true);
    this.renderBackground(thisGroup);
    this._updateView();
    this._enableHoverLinkToSeries();
    this._enableHoverLinkFromSeries();
    this.positionGroup(thisGroup);
  };
  ContinuousView2.prototype._renderEndsText = function(group, dataRangeText, endsIndex) {
    if (!dataRangeText) {
      return;
    }
    var text = dataRangeText[1 - endsIndex];
    text = text != null ? text + "" : "";
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var itemSize = visualMapModel.itemSize;
    var barGroup = this._shapes.mainGroup;
    var position2 = this._applyTransform([itemSize[0] / 2, endsIndex === 0 ? -textGap : itemSize[1] + textGap], barGroup);
    var align = this._applyTransform(endsIndex === 0 ? "bottom" : "top", barGroup);
    var orient = this._orient;
    var textStyleModel = this.visualMapModel.textStyleModel;
    this.group.add(new ZRText$1({
      style: {
        x: position2[0],
        y: position2[1],
        verticalAlign: orient === "horizontal" ? "middle" : align,
        align: orient === "horizontal" ? align : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
  };
  ContinuousView2.prototype._renderBar = function(targetGroup) {
    var visualMapModel = this.visualMapModel;
    var shapes = this._shapes;
    var itemSize = visualMapModel.itemSize;
    var orient = this._orient;
    var useHandle = this._useHandle;
    var itemAlign = getItemAlign(visualMapModel, this.api, itemSize);
    var mainGroup = shapes.mainGroup = this._createBarGroup(itemAlign);
    var gradientBarGroup = new Group$4();
    mainGroup.add(gradientBarGroup);
    gradientBarGroup.add(shapes.outOfRange = createPolygon());
    gradientBarGroup.add(shapes.inRange = createPolygon(null, useHandle ? getCursor(this._orient) : null, bind$1(this._dragHandle, this, "all", false), bind$1(this._dragHandle, this, "all", true)));
    gradientBarGroup.setClipPath(new Rect$3({
      shape: {
        x: 0,
        y: 0,
        width: itemSize[0],
        height: itemSize[1],
        r: 3
      }
    }));
    var textRect = visualMapModel.textStyleModel.getTextRect("\u56FD");
    var textSize = mathMax(textRect.width, textRect.height);
    if (useHandle) {
      shapes.handleThumbs = [];
      shapes.handleLabels = [];
      shapes.handleLabelPoints = [];
      this._createHandle(visualMapModel, mainGroup, 0, itemSize, textSize, orient);
      this._createHandle(visualMapModel, mainGroup, 1, itemSize, textSize, orient);
    }
    this._createIndicator(visualMapModel, mainGroup, itemSize, textSize, orient);
    targetGroup.add(mainGroup);
  };
  ContinuousView2.prototype._createHandle = function(visualMapModel, mainGroup, handleIndex, itemSize, textSize, orient) {
    var onDrift = bind$1(this._dragHandle, this, handleIndex, false);
    var onDragEnd = bind$1(this._dragHandle, this, handleIndex, true);
    var handleSize = parsePercent$1(visualMapModel.get("handleSize"), itemSize[0]);
    var handleThumb = createSymbol$1(visualMapModel.get("handleIcon"), -handleSize / 2, -handleSize / 2, handleSize, handleSize, null, true);
    var cursor = getCursor(this._orient);
    handleThumb.attr({
      cursor,
      draggable: true,
      drift: onDrift,
      ondragend: onDragEnd,
      onmousemove: function(e2) {
        stop(e2.event);
      }
    });
    handleThumb.x = itemSize[0] / 2;
    handleThumb.useStyle(visualMapModel.getModel("handleStyle").getItemStyle());
    handleThumb.setStyle({
      strokeNoScale: true,
      strokeFirst: true
    });
    handleThumb.style.lineWidth *= 2;
    handleThumb.ensureState("emphasis").style = visualMapModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
    setAsHighDownDispatcher(handleThumb, true);
    mainGroup.add(handleThumb);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var handleLabel = new ZRText$1({
      cursor,
      draggable: true,
      drift: onDrift,
      onmousemove: function(e2) {
        stop(e2.event);
      },
      ondragend: onDragEnd,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    handleLabel.ensureState("blur").style = {
      opacity: 0.1
    };
    handleLabel.stateTransition = {
      duration: 200
    };
    this.group.add(handleLabel);
    var handleLabelPoint = [handleSize, 0];
    var shapes = this._shapes;
    shapes.handleThumbs[handleIndex] = handleThumb;
    shapes.handleLabelPoints[handleIndex] = handleLabelPoint;
    shapes.handleLabels[handleIndex] = handleLabel;
  };
  ContinuousView2.prototype._createIndicator = function(visualMapModel, mainGroup, itemSize, textSize, orient) {
    var scale2 = parsePercent$1(visualMapModel.get("indicatorSize"), itemSize[0]);
    var indicator = createSymbol$1(visualMapModel.get("indicatorIcon"), -scale2 / 2, -scale2 / 2, scale2, scale2, null, true);
    indicator.attr({
      cursor: "move",
      invisible: true,
      silent: true,
      x: itemSize[0] / 2
    });
    var indicatorStyle = visualMapModel.getModel("indicatorStyle").getItemStyle();
    if (indicator instanceof ZRImage$1) {
      var pathStyle = indicator.style;
      indicator.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, indicatorStyle));
    } else {
      indicator.useStyle(indicatorStyle);
    }
    mainGroup.add(indicator);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var indicatorLabel = new ZRText$1({
      silent: true,
      invisible: true,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    this.group.add(indicatorLabel);
    var indicatorLabelPoint = [(orient === "horizontal" ? textSize / 2 : HOVER_LINK_OUT) + itemSize[0] / 2, 0];
    var shapes = this._shapes;
    shapes.indicator = indicator;
    shapes.indicatorLabel = indicatorLabel;
    shapes.indicatorLabelPoint = indicatorLabelPoint;
    this._firstShowIndicator = true;
  };
  ContinuousView2.prototype._dragHandle = function(handleIndex, isEnd, dx, dy) {
    if (!this._useHandle) {
      return;
    }
    this._dragging = !isEnd;
    if (!isEnd) {
      var vertex = this._applyTransform([dx, dy], this._shapes.mainGroup, true);
      this._updateInterval(handleIndex, vertex[1]);
      this._hideIndicator();
      this._updateView();
    }
    if (isEnd === !this.visualMapModel.get("realtime")) {
      this.api.dispatchAction({
        type: "selectDataRange",
        from: this.uid,
        visualMapId: this.visualMapModel.id,
        selected: this._dataInterval.slice()
      });
    }
    if (isEnd) {
      !this._hovering && this._clearHoverLinkToSeries();
    } else if (useHoverLinkOnHandle(this.visualMapModel)) {
      this._doHoverLinkToSeries(this._handleEnds[handleIndex], false);
    }
  };
  ContinuousView2.prototype._resetInterval = function() {
    var visualMapModel = this.visualMapModel;
    var dataInterval = this._dataInterval = visualMapModel.getSelected();
    var dataExtent = visualMapModel.getExtent();
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    this._handleEnds = [linearMap(dataInterval[0], dataExtent, sizeExtent, true), linearMap(dataInterval[1], dataExtent, sizeExtent, true)];
  };
  ContinuousView2.prototype._updateInterval = function(handleIndex, delta) {
    delta = delta || 0;
    var visualMapModel = this.visualMapModel;
    var handleEnds = this._handleEnds;
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    sliderMove(delta, handleEnds, sizeExtent, handleIndex, 0);
    var dataExtent = visualMapModel.getExtent();
    this._dataInterval = [linearMap(handleEnds[0], sizeExtent, dataExtent, true), linearMap(handleEnds[1], sizeExtent, dataExtent, true)];
  };
  ContinuousView2.prototype._updateView = function(forSketch) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var shapes = this._shapes;
    var outOfRangeHandleEnds = [0, visualMapModel.itemSize[1]];
    var inRangeHandleEnds = forSketch ? outOfRangeHandleEnds : this._handleEnds;
    var visualInRange = this._createBarVisual(this._dataInterval, dataExtent, inRangeHandleEnds, "inRange");
    var visualOutOfRange = this._createBarVisual(dataExtent, dataExtent, outOfRangeHandleEnds, "outOfRange");
    shapes.inRange.setStyle({
      fill: visualInRange.barColor
    }).setShape("points", visualInRange.barPoints);
    shapes.outOfRange.setStyle({
      fill: visualOutOfRange.barColor
    }).setShape("points", visualOutOfRange.barPoints);
    this._updateHandle(inRangeHandleEnds, visualInRange);
  };
  ContinuousView2.prototype._createBarVisual = function(dataInterval, dataExtent, handleEnds, forceState) {
    var opts = {
      forceState,
      convertOpacityToAlpha: true
    };
    var colorStops = this._makeColorGradient(dataInterval, opts);
    var symbolSizes = [this.getControllerVisual(dataInterval[0], "symbolSize", opts), this.getControllerVisual(dataInterval[1], "symbolSize", opts)];
    var barPoints = this._createBarPoints(handleEnds, symbolSizes);
    return {
      barColor: new LinearGradient$1(0, 0, 0, 1, colorStops),
      barPoints,
      handlesColor: [colorStops[0].color, colorStops[colorStops.length - 1].color]
    };
  };
  ContinuousView2.prototype._makeColorGradient = function(dataInterval, opts) {
    var sampleNumber = 100;
    var colorStops = [];
    var step = (dataInterval[1] - dataInterval[0]) / sampleNumber;
    colorStops.push({
      color: this.getControllerVisual(dataInterval[0], "color", opts),
      offset: 0
    });
    for (var i = 1; i < sampleNumber; i++) {
      var currValue = dataInterval[0] + step * i;
      if (currValue > dataInterval[1]) {
        break;
      }
      colorStops.push({
        color: this.getControllerVisual(currValue, "color", opts),
        offset: i / sampleNumber
      });
    }
    colorStops.push({
      color: this.getControllerVisual(dataInterval[1], "color", opts),
      offset: 1
    });
    return colorStops;
  };
  ContinuousView2.prototype._createBarPoints = function(handleEnds, symbolSizes) {
    var itemSize = this.visualMapModel.itemSize;
    return [[itemSize[0] - symbolSizes[0], handleEnds[0]], [itemSize[0], handleEnds[0]], [itemSize[0], handleEnds[1]], [itemSize[0] - symbolSizes[1], handleEnds[1]]];
  };
  ContinuousView2.prototype._createBarGroup = function(itemAlign) {
    var orient = this._orient;
    var inverse = this.visualMapModel.get("inverse");
    return new Group$4(orient === "horizontal" && !inverse ? {
      scaleX: itemAlign === "bottom" ? 1 : -1,
      rotation: Math.PI / 2
    } : orient === "horizontal" && inverse ? {
      scaleX: itemAlign === "bottom" ? -1 : 1,
      rotation: -Math.PI / 2
    } : orient === "vertical" && !inverse ? {
      scaleX: itemAlign === "left" ? 1 : -1,
      scaleY: -1
    } : {
      scaleX: itemAlign === "left" ? 1 : -1
    });
  };
  ContinuousView2.prototype._updateHandle = function(handleEnds, visualInRange) {
    if (!this._useHandle) {
      return;
    }
    var shapes = this._shapes;
    var visualMapModel = this.visualMapModel;
    var handleThumbs = shapes.handleThumbs;
    var handleLabels = shapes.handleLabels;
    var itemSize = visualMapModel.itemSize;
    var dataExtent = visualMapModel.getExtent();
    each$1([0, 1], function(handleIndex) {
      var handleThumb = handleThumbs[handleIndex];
      handleThumb.setStyle("fill", visualInRange.handlesColor[handleIndex]);
      handleThumb.y = handleEnds[handleIndex];
      var val = linearMap(handleEnds[handleIndex], [0, itemSize[1]], dataExtent, true);
      var symbolSize = this.getControllerVisual(val, "symbolSize");
      handleThumb.scaleX = handleThumb.scaleY = symbolSize / itemSize[0];
      handleThumb.x = itemSize[0] - symbolSize / 2;
      var textPoint = applyTransform(shapes.handleLabelPoints[handleIndex], getTransform$1(handleThumb, this.group));
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        text: visualMapModel.formatValueText(this._dataInterval[handleIndex]),
        verticalAlign: "middle",
        align: this._orient === "vertical" ? this._applyTransform("left", shapes.mainGroup) : "center"
      });
    }, this);
  };
  ContinuousView2.prototype._showIndicator = function(cursorValue, textValue, rangeSymbol, halfHoverLinkSize) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var itemSize = visualMapModel.itemSize;
    var sizeExtent = [0, itemSize[1]];
    var shapes = this._shapes;
    var indicator = shapes.indicator;
    if (!indicator) {
      return;
    }
    indicator.attr("invisible", false);
    var opts = {
      convertOpacityToAlpha: true
    };
    var color = this.getControllerVisual(cursorValue, "color", opts);
    var symbolSize = this.getControllerVisual(cursorValue, "symbolSize");
    var y2 = linearMap(cursorValue, dataExtent, sizeExtent, true);
    var x2 = itemSize[0] - symbolSize / 2;
    var oldIndicatorPos = {
      x: indicator.x,
      y: indicator.y
    };
    indicator.y = y2;
    indicator.x = x2;
    var textPoint = applyTransform(shapes.indicatorLabelPoint, getTransform$1(indicator, this.group));
    var indicatorLabel = shapes.indicatorLabel;
    indicatorLabel.attr("invisible", false);
    var align = this._applyTransform("left", shapes.mainGroup);
    var orient = this._orient;
    var isHorizontal = orient === "horizontal";
    indicatorLabel.setStyle({
      text: (rangeSymbol ? rangeSymbol : "") + visualMapModel.formatValueText(textValue),
      verticalAlign: isHorizontal ? align : "middle",
      align: isHorizontal ? "center" : align
    });
    var indicatorNewProps = {
      x: x2,
      y: y2,
      style: {
        fill: color
      }
    };
    var labelNewProps = {
      style: {
        x: textPoint[0],
        y: textPoint[1]
      }
    };
    if (visualMapModel.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
      var animationCfg = {
        duration: 100,
        easing: "cubicInOut",
        additive: true
      };
      indicator.x = oldIndicatorPos.x;
      indicator.y = oldIndicatorPos.y;
      indicator.animateTo(indicatorNewProps, animationCfg);
      indicatorLabel.animateTo(labelNewProps, animationCfg);
    } else {
      indicator.attr(indicatorNewProps);
      indicatorLabel.attr(labelNewProps);
    }
    this._firstShowIndicator = false;
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.enterBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._enableHoverLinkToSeries = function() {
    var self2 = this;
    this._shapes.mainGroup.on("mousemove", function(e2) {
      self2._hovering = true;
      if (!self2._dragging) {
        var itemSize = self2.visualMapModel.itemSize;
        var pos = self2._applyTransform([e2.offsetX, e2.offsetY], self2._shapes.mainGroup, true, true);
        pos[1] = mathMin(mathMax(0, pos[1]), itemSize[1]);
        self2._doHoverLinkToSeries(pos[1], 0 <= pos[0] && pos[0] <= itemSize[0]);
      }
    }).on("mouseout", function() {
      self2._hovering = false;
      !self2._dragging && self2._clearHoverLinkToSeries();
    });
  };
  ContinuousView2.prototype._enableHoverLinkFromSeries = function() {
    var zr = this.api.getZr();
    if (this.visualMapModel.option.hoverLink) {
      zr.on("mouseover", this._hoverLinkFromSeriesMouseOver, this);
      zr.on("mouseout", this._hideIndicator, this);
    } else {
      this._clearHoverLinkFromSeries();
    }
  };
  ContinuousView2.prototype._doHoverLinkToSeries = function(cursorPos, hoverOnBar) {
    var visualMapModel = this.visualMapModel;
    var itemSize = visualMapModel.itemSize;
    if (!visualMapModel.option.hoverLink) {
      return;
    }
    var sizeExtent = [0, itemSize[1]];
    var dataExtent = visualMapModel.getExtent();
    cursorPos = mathMin(mathMax(sizeExtent[0], cursorPos), sizeExtent[1]);
    var halfHoverLinkSize = getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent);
    var hoverRange = [cursorPos - halfHoverLinkSize, cursorPos + halfHoverLinkSize];
    var cursorValue = linearMap(cursorPos, sizeExtent, dataExtent, true);
    var valueRange = [linearMap(hoverRange[0], sizeExtent, dataExtent, true), linearMap(hoverRange[1], sizeExtent, dataExtent, true)];
    hoverRange[0] < sizeExtent[0] && (valueRange[0] = -Infinity);
    hoverRange[1] > sizeExtent[1] && (valueRange[1] = Infinity);
    if (hoverOnBar) {
      if (valueRange[0] === -Infinity) {
        this._showIndicator(cursorValue, valueRange[1], "< ", halfHoverLinkSize);
      } else if (valueRange[1] === Infinity) {
        this._showIndicator(cursorValue, valueRange[0], "> ", halfHoverLinkSize);
      } else {
        this._showIndicator(cursorValue, cursorValue, "\u2248 ", halfHoverLinkSize);
      }
    }
    var oldBatch = this._hoverLinkDataIndices;
    var newBatch = [];
    if (hoverOnBar || useHoverLinkOnHandle(visualMapModel)) {
      newBatch = this._hoverLinkDataIndices = visualMapModel.findTargetDataIndices(valueRange);
    }
    var resultBatches = compressBatches(oldBatch, newBatch);
    this._dispatchHighDown("downplay", makeHighDownBatch(resultBatches[0], visualMapModel));
    this._dispatchHighDown("highlight", makeHighDownBatch(resultBatches[1], visualMapModel));
  };
  ContinuousView2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
    var el = e2.target;
    var visualMapModel = this.visualMapModel;
    if (!el || getECData(el).dataIndex == null) {
      return;
    }
    var ecData = getECData(el);
    var dataModel = this.ecModel.getSeriesByIndex(ecData.seriesIndex);
    if (!visualMapModel.isTargetSeries(dataModel)) {
      return;
    }
    var data = dataModel.getData(ecData.dataType);
    var value = data.getStore().get(visualMapModel.getDataDimensionIndex(data), ecData.dataIndex);
    if (!isNaN(value)) {
      this._showIndicator(value, value);
    }
  };
  ContinuousView2.prototype._hideIndicator = function() {
    var shapes = this._shapes;
    shapes.indicator && shapes.indicator.attr("invisible", true);
    shapes.indicatorLabel && shapes.indicatorLabel.attr("invisible", true);
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.leaveBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._clearHoverLinkToSeries = function() {
    this._hideIndicator();
    var indices = this._hoverLinkDataIndices;
    this._dispatchHighDown("downplay", makeHighDownBatch(indices, this.visualMapModel));
    indices.length = 0;
  };
  ContinuousView2.prototype._clearHoverLinkFromSeries = function() {
    this._hideIndicator();
    var zr = this.api.getZr();
    zr.off("mouseover", this._hoverLinkFromSeriesMouseOver);
    zr.off("mouseout", this._hideIndicator);
  };
  ContinuousView2.prototype._applyTransform = function(vertex, element, inverse, global2) {
    var transform2 = getTransform$1(element, global2 ? null : this.group);
    return isArray$1(vertex) ? applyTransform(vertex, transform2, inverse) : transformDirection(vertex, transform2, inverse);
  };
  ContinuousView2.prototype._dispatchHighDown = function(type4, batch) {
    batch && batch.length && this.api.dispatchAction({
      type: type4,
      batch
    });
  };
  ContinuousView2.prototype.dispose = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.prototype.remove = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.type = "visualMap.continuous";
  return ContinuousView2;
}(VisualMapView$1);
function createPolygon(points2, cursor, onDrift, onDragEnd) {
  return new Polygon$1({
    shape: {
      points: points2
    },
    draggable: !!onDrift,
    cursor,
    drift: onDrift,
    onmousemove: function(e2) {
      stop(e2.event);
    },
    ondragend: onDragEnd
  });
}
function getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent) {
  var halfHoverLinkSize = HOVER_LINK_SIZE / 2;
  var hoverLinkDataSize = visualMapModel.get("hoverLinkDataSize");
  if (hoverLinkDataSize) {
    halfHoverLinkSize = linearMap(hoverLinkDataSize, dataExtent, sizeExtent, true) / 2;
  }
  return halfHoverLinkSize;
}
function useHoverLinkOnHandle(visualMapModel) {
  var hoverLinkOnHandle = visualMapModel.get("hoverLinkOnHandle");
  return !!(hoverLinkOnHandle == null ? visualMapModel.get("realtime") : hoverLinkOnHandle);
}
function getCursor(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var ContinuousView$1 = ContinuousView;
var visualMapActionInfo = {
  type: "selectDataRange",
  event: "dataRangeSelected",
  update: "update"
};
var visualMapActionHander = function(payload, ecModel) {
  ecModel.eachComponent({
    mainType: "visualMap",
    query: payload
  }, function(model) {
    model.setSelected(payload.selected);
  });
};
var visualMapEncodingHandlers = [
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var resetDefines = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        var pipelineContext = seriesModel.pipelineContext;
        if (!visualMapModel.isTargetSeries(seriesModel) || pipelineContext && pipelineContext.large) {
          return;
        }
        resetDefines.push(incrementalApplyVisual(visualMapModel.stateList, visualMapModel.targetVisuals, bind$1(visualMapModel.getValueState, visualMapModel), visualMapModel.getDataDimensionIndex(seriesModel.getData())));
      });
      return resetDefines;
    }
  },
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      var visualMetaList = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        if (visualMapModel.isTargetSeries(seriesModel)) {
          var visualMeta = visualMapModel.getVisualMeta(bind$1(getColorVisual, null, seriesModel, visualMapModel)) || {
            stops: [],
            outerColors: []
          };
          var dimIdx = visualMapModel.getDataDimensionIndex(data);
          if (dimIdx >= 0) {
            visualMeta.dimension = dimIdx;
            visualMetaList.push(visualMeta);
          }
        }
      });
      seriesModel.getData().setVisual("visualMeta", visualMetaList);
    }
  }
];
function getColorVisual(seriesModel, visualMapModel, value, valueState) {
  var mappings = visualMapModel.targetVisuals[valueState];
  var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
  var resultVisual = {
    color: getVisualFromData(seriesModel.getData(), "color")
  };
  for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
    var type4 = visualTypes[i];
    var mapping = mappings[type4 === "opacity" ? "__alphaForOpacity" : type4];
    mapping && mapping.applyVisual(value, getVisual, setVisual);
  }
  return resultVisual.color;
  function getVisual(key) {
    return resultVisual[key];
  }
  function setVisual(key, value2) {
    resultVisual[key] = value2;
  }
}
var each = each$f;
function visualMapPreprocessor(option) {
  var visualMap = option && option.visualMap;
  if (!isArray$1(visualMap)) {
    visualMap = visualMap ? [visualMap] : [];
  }
  each(visualMap, function(opt) {
    if (!opt) {
      return;
    }
    if (has(opt, "splitList") && !has(opt, "pieces")) {
      opt.pieces = opt.splitList;
      delete opt.splitList;
    }
    var pieces = opt.pieces;
    if (pieces && isArray$1(pieces)) {
      each(pieces, function(piece) {
        if (isObject$4(piece)) {
          if (has(piece, "start") && !has(piece, "min")) {
            piece.min = piece.start;
          }
          if (has(piece, "end") && !has(piece, "max")) {
            piece.max = piece.end;
          }
        }
      });
    }
  });
}
function has(obj, name) {
  return obj && obj.hasOwnProperty && obj.hasOwnProperty(name);
}
var installed = false;
function installCommon(registers) {
  if (installed) {
    return;
  }
  installed = true;
  registers.registerSubTypeDefaulter("visualMap", function(option) {
    return !option.categories && (!(option.pieces ? option.pieces.length > 0 : option.splitNumber > 0) || option.calculable) ? "continuous" : "piecewise";
  });
  registers.registerAction(visualMapActionInfo, visualMapActionHander);
  each$f(visualMapEncodingHandlers, function(handler) {
    registers.registerVisual(registers.PRIORITY.VISUAL.COMPONENT, handler);
  });
  registers.registerPreprocessor(visualMapPreprocessor);
}
function install$5(registers) {
  registers.registerComponentModel(ContinuousModel$1);
  registers.registerComponentView(ContinuousView$1);
  installCommon(registers);
}
var PiecewiseModel = function(_super) {
  __extends(PiecewiseModel2, _super);
  function PiecewiseModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseModel2.type;
    _this._pieceList = [];
    return _this;
  }
  PiecewiseModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    var mode = this._mode = this._determineMode();
    this._pieceList = [];
    resetMethods[this._mode].call(this, this._pieceList);
    this._resetSelected(newOption, isInit);
    var categories = this.option.categories;
    this.resetVisual(function(mappingOption, state) {
      if (mode === "categories") {
        mappingOption.mappingMethod = "category";
        mappingOption.categories = clone$4(categories);
      } else {
        mappingOption.dataExtent = this.getExtent();
        mappingOption.mappingMethod = "piecewise";
        mappingOption.pieceList = map$1(this._pieceList, function(piece) {
          piece = clone$4(piece);
          if (state !== "inRange") {
            piece.visual = null;
          }
          return piece;
        });
      }
    });
  };
  PiecewiseModel2.prototype.completeVisualOption = function() {
    var option = this.option;
    var visualTypesInPieces = {};
    var visualTypes = VisualMapping$1.listVisualTypes();
    var isCategory2 = this.isCategory();
    each$f(option.pieces, function(piece) {
      each$f(visualTypes, function(visualType) {
        if (piece.hasOwnProperty(visualType)) {
          visualTypesInPieces[visualType] = 1;
        }
      });
    });
    each$f(visualTypesInPieces, function(v4, visualType) {
      var exists = false;
      each$f(this.stateList, function(state) {
        exists = exists || has2(option, state, visualType) || has2(option.target, state, visualType);
      }, this);
      !exists && each$f(this.stateList, function(state) {
        (option[state] || (option[state] = {}))[visualType] = visualDefault$1.get(visualType, state === "inRange" ? "active" : "inactive", isCategory2);
      });
    }, this);
    function has2(obj, state, visualType) {
      return obj && obj[state] && obj[state].hasOwnProperty(visualType);
    }
    _super.prototype.completeVisualOption.apply(this, arguments);
  };
  PiecewiseModel2.prototype._resetSelected = function(newOption, isInit) {
    var thisOption = this.option;
    var pieceList = this._pieceList;
    var selected = (isInit ? thisOption : newOption).selected || {};
    thisOption.selected = selected;
    each$f(pieceList, function(piece, index2) {
      var key = this.getSelectedMapKey(piece);
      if (!selected.hasOwnProperty(key)) {
        selected[key] = true;
      }
    }, this);
    if (thisOption.selectedMode === "single") {
      var hasSel_1 = false;
      each$f(pieceList, function(piece, index2) {
        var key = this.getSelectedMapKey(piece);
        if (selected[key]) {
          hasSel_1 ? selected[key] = false : hasSel_1 = true;
        }
      }, this);
    }
  };
  PiecewiseModel2.prototype.getItemSymbol = function() {
    return this.get("itemSymbol");
  };
  PiecewiseModel2.prototype.getSelectedMapKey = function(piece) {
    return this._mode === "categories" ? piece.value + "" : piece.index + "";
  };
  PiecewiseModel2.prototype.getPieceList = function() {
    return this._pieceList;
  };
  PiecewiseModel2.prototype._determineMode = function() {
    var option = this.option;
    return option.pieces && option.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
  };
  PiecewiseModel2.prototype.setSelected = function(selected) {
    this.option.selected = clone$4(selected);
  };
  PiecewiseModel2.prototype.getValueState = function(value) {
    var index2 = VisualMapping$1.findPieceIndex(value, this._pieceList);
    return index2 != null ? this.option.selected[this.getSelectedMapKey(this._pieceList[index2])] ? "inRange" : "outOfRange" : "outOfRange";
  };
  PiecewiseModel2.prototype.findTargetDataIndices = function(pieceIndex) {
    var result = [];
    var pieceList = this._pieceList;
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        var pIdx = VisualMapping$1.findPieceIndex(value, pieceList);
        pIdx === pieceIndex && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  PiecewiseModel2.prototype.getRepresentValue = function(piece) {
    var representValue;
    if (this.isCategory()) {
      representValue = piece.value;
    } else {
      if (piece.value != null) {
        representValue = piece.value;
      } else {
        var pieceInterval = piece.interval || [];
        representValue = pieceInterval[0] === -Infinity && pieceInterval[1] === Infinity ? 0 : (pieceInterval[0] + pieceInterval[1]) / 2;
      }
    }
    return representValue;
  };
  PiecewiseModel2.prototype.getVisualMeta = function(getColorVisual2) {
    if (this.isCategory()) {
      return;
    }
    var stops = [];
    var outerColors = ["", ""];
    var visualMapModel = this;
    function setStop(interval, valueState) {
      var representValue = visualMapModel.getRepresentValue({
        interval
      });
      if (!valueState) {
        valueState = visualMapModel.getValueState(representValue);
      }
      var color = getColorVisual2(representValue, valueState);
      if (interval[0] === -Infinity) {
        outerColors[0] = color;
      } else if (interval[1] === Infinity) {
        outerColors[1] = color;
      } else {
        stops.push({
          value: interval[0],
          color
        }, {
          value: interval[1],
          color
        });
      }
    }
    var pieceList = this._pieceList.slice();
    if (!pieceList.length) {
      pieceList.push({
        interval: [-Infinity, Infinity]
      });
    } else {
      var edge = pieceList[0].interval[0];
      edge !== -Infinity && pieceList.unshift({
        interval: [-Infinity, edge]
      });
      edge = pieceList[pieceList.length - 1].interval[1];
      edge !== Infinity && pieceList.push({
        interval: [edge, Infinity]
      });
    }
    var curr = -Infinity;
    each$f(pieceList, function(piece) {
      var interval = piece.interval;
      if (interval) {
        interval[0] > curr && setStop([curr, interval[0]], "outOfRange");
        setStop(interval.slice());
        curr = interval[1];
      }
    }, this);
    return {
      stops,
      outerColors
    };
  };
  PiecewiseModel2.type = "visualMap.piecewise";
  PiecewiseModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    selected: null,
    minOpen: false,
    maxOpen: false,
    align: "auto",
    itemWidth: 20,
    itemHeight: 14,
    itemSymbol: "roundRect",
    pieces: null,
    categories: null,
    splitNumber: 5,
    selectedMode: "multiple",
    itemGap: 10,
    hoverLink: true
  });
  return PiecewiseModel2;
}(VisualMapModel$1);
var resetMethods = {
  splitNumber: function(outPieceList) {
    var thisOption = this.option;
    var precision = Math.min(thisOption.precision, 20);
    var dataExtent = this.getExtent();
    var splitNumber = thisOption.splitNumber;
    splitNumber = Math.max(parseInt(splitNumber, 10), 1);
    thisOption.splitNumber = splitNumber;
    var splitStep = (dataExtent[1] - dataExtent[0]) / splitNumber;
    while (+splitStep.toFixed(precision) !== splitStep && precision < 5) {
      precision++;
    }
    thisOption.precision = precision;
    splitStep = +splitStep.toFixed(precision);
    if (thisOption.minOpen) {
      outPieceList.push({
        interval: [-Infinity, dataExtent[0]],
        close: [0, 0]
      });
    }
    for (var index2 = 0, curr = dataExtent[0]; index2 < splitNumber; curr += splitStep, index2++) {
      var max3 = index2 === splitNumber - 1 ? dataExtent[1] : curr + splitStep;
      outPieceList.push({
        interval: [curr, max3],
        close: [1, 1]
      });
    }
    if (thisOption.maxOpen) {
      outPieceList.push({
        interval: [dataExtent[1], Infinity],
        close: [0, 0]
      });
    }
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece, index3) {
      piece.index = index3;
      piece.text = this.formatValueText(piece.interval);
    }, this);
  },
  categories: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.categories, function(cate) {
      outPieceList.push({
        text: this.formatValueText(cate, true),
        value: cate
      });
    }, this);
    normalizeReverse(thisOption, outPieceList);
  },
  pieces: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.pieces, function(pieceListItem, index2) {
      if (!isObject$4(pieceListItem)) {
        pieceListItem = {
          value: pieceListItem
        };
      }
      var item = {
        text: "",
        index: index2
      };
      if (pieceListItem.label != null) {
        item.text = pieceListItem.label;
      }
      if (pieceListItem.hasOwnProperty("value")) {
        var value = item.value = pieceListItem.value;
        item.interval = [value, value];
        item.close = [1, 1];
      } else {
        var interval = item.interval = [];
        var close_1 = item.close = [0, 0];
        var closeList = [1, 0, 1];
        var infinityList = [-Infinity, Infinity];
        var useMinMax = [];
        for (var lg = 0; lg < 2; lg++) {
          var names2 = [["gte", "gt", "min"], ["lte", "lt", "max"]][lg];
          for (var i = 0; i < 3 && interval[lg] == null; i++) {
            interval[lg] = pieceListItem[names2[i]];
            close_1[lg] = closeList[i];
            useMinMax[lg] = i === 2;
          }
          interval[lg] == null && (interval[lg] = infinityList[lg]);
        }
        useMinMax[0] && interval[1] === Infinity && (close_1[0] = 0);
        useMinMax[1] && interval[0] === -Infinity && (close_1[1] = 0);
        if (interval[0] === interval[1] && close_1[0] && close_1[1]) {
          item.value = interval[0];
        }
      }
      item.visual = VisualMapping$1.retrieveVisuals(pieceListItem);
      outPieceList.push(item);
    }, this);
    normalizeReverse(thisOption, outPieceList);
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece) {
      var close = piece.close;
      var edgeSymbols = [["<", "\u2264"][close[1]], [">", "\u2265"][close[0]]];
      piece.text = piece.text || this.formatValueText(piece.value != null ? piece.value : piece.interval, false, edgeSymbols);
    }, this);
  }
};
function normalizeReverse(thisOption, pieceList) {
  var inverse = thisOption.inverse;
  if (thisOption.orient === "vertical" ? !inverse : inverse) {
    pieceList.reverse();
  }
}
var PiecewiseModel$1 = PiecewiseModel;
var PiecewiseVisualMapView = function(_super) {
  __extends(PiecewiseVisualMapView2, _super);
  function PiecewiseVisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseVisualMapView2.type;
    return _this;
  }
  PiecewiseVisualMapView2.prototype.doRender = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var textStyleModel = visualMapModel.textStyleModel;
    var textFont = textStyleModel.getFont();
    var textFill = textStyleModel.getTextColor();
    var itemAlign = this._getItemAlign();
    var itemSize = visualMapModel.itemSize;
    var viewData = this._getViewData();
    var endsText = viewData.endsText;
    var showLabel = retrieve(visualMapModel.get("showLabel", true), !endsText);
    endsText && this._renderEndsText(thisGroup, endsText[0], itemSize, showLabel, itemAlign);
    each$f(viewData.viewPieceList, function(item) {
      var piece = item.piece;
      var itemGroup = new Group$4();
      itemGroup.onclick = bind$1(this._onItemClick, this, piece);
      this._enableHoverLink(itemGroup, item.indexInModelPieceList);
      var representValue = visualMapModel.getRepresentValue(piece);
      this._createItemSymbol(itemGroup, representValue, [0, 0, itemSize[0], itemSize[1]]);
      if (showLabel) {
        var visualState = this.visualMapModel.getValueState(representValue);
        itemGroup.add(new ZRText$1({
          style: {
            x: itemAlign === "right" ? -textGap : itemSize[0] + textGap,
            y: itemSize[1] / 2,
            text: piece.text,
            verticalAlign: "middle",
            align: itemAlign,
            font: textFont,
            fill: textFill,
            opacity: visualState === "outOfRange" ? 0.5 : 1
          }
        }));
      }
      thisGroup.add(itemGroup);
    }, this);
    endsText && this._renderEndsText(thisGroup, endsText[1], itemSize, showLabel, itemAlign);
    box(visualMapModel.get("orient"), thisGroup, visualMapModel.get("itemGap"));
    this.renderBackground(thisGroup);
    this.positionGroup(thisGroup);
  };
  PiecewiseVisualMapView2.prototype._enableHoverLink = function(itemGroup, pieceIndex) {
    var _this = this;
    itemGroup.on("mouseover", function() {
      return onHoverLink("highlight");
    }).on("mouseout", function() {
      return onHoverLink("downplay");
    });
    var onHoverLink = function(method4) {
      var visualMapModel = _this.visualMapModel;
      visualMapModel.option.hoverLink && _this.api.dispatchAction({
        type: method4,
        batch: makeHighDownBatch(visualMapModel.findTargetDataIndices(pieceIndex), visualMapModel)
      });
    };
  };
  PiecewiseVisualMapView2.prototype._getItemAlign = function() {
    var visualMapModel = this.visualMapModel;
    var modelOption = visualMapModel.option;
    if (modelOption.orient === "vertical") {
      return getItemAlign(visualMapModel, this.api, visualMapModel.itemSize);
    } else {
      var align = modelOption.align;
      if (!align || align === "auto") {
        align = "left";
      }
      return align;
    }
  };
  PiecewiseVisualMapView2.prototype._renderEndsText = function(group, text, itemSize, showLabel, itemAlign) {
    if (!text) {
      return;
    }
    var itemGroup = new Group$4();
    var textStyleModel = this.visualMapModel.textStyleModel;
    itemGroup.add(new ZRText$1({
      style: {
        x: showLabel ? itemAlign === "right" ? itemSize[0] : 0 : itemSize[0] / 2,
        y: itemSize[1] / 2,
        verticalAlign: "middle",
        align: showLabel ? itemAlign : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
    group.add(itemGroup);
  };
  PiecewiseVisualMapView2.prototype._getViewData = function() {
    var visualMapModel = this.visualMapModel;
    var viewPieceList = map$1(visualMapModel.getPieceList(), function(piece, index2) {
      return {
        piece,
        indexInModelPieceList: index2
      };
    });
    var endsText = visualMapModel.get("text");
    var orient = visualMapModel.get("orient");
    var inverse = visualMapModel.get("inverse");
    if (orient === "horizontal" ? inverse : !inverse) {
      viewPieceList.reverse();
    } else if (endsText) {
      endsText = endsText.slice().reverse();
    }
    return {
      viewPieceList,
      endsText
    };
  };
  PiecewiseVisualMapView2.prototype._createItemSymbol = function(group, representValue, shapeParam) {
    group.add(createSymbol$1(this.getControllerVisual(representValue, "symbol"), shapeParam[0], shapeParam[1], shapeParam[2], shapeParam[3], this.getControllerVisual(representValue, "color")));
  };
  PiecewiseVisualMapView2.prototype._onItemClick = function(piece) {
    var visualMapModel = this.visualMapModel;
    var option = visualMapModel.option;
    var selected = clone$4(option.selected);
    var newKey = visualMapModel.getSelectedMapKey(piece);
    if (option.selectedMode === "single") {
      selected[newKey] = true;
      each$f(selected, function(o, key) {
        selected[key] = key === newKey;
      });
    } else {
      selected[newKey] = !selected[newKey];
    }
    this.api.dispatchAction({
      type: "selectDataRange",
      from: this.uid,
      visualMapId: this.visualMapModel.id,
      selected
    });
  };
  PiecewiseVisualMapView2.type = "visualMap.piecewise";
  return PiecewiseVisualMapView2;
}(VisualMapView$1);
var PiecewiseView = PiecewiseVisualMapView;
function install$4(registers) {
  registers.registerComponentModel(PiecewiseModel$1);
  registers.registerComponentView(PiecewiseView);
  installCommon(registers);
}
function install$3(registers) {
  use(install$5);
  use(install$4);
}
var DEFAULT_OPTION = {
  label: {
    enabled: true
  },
  decal: {
    show: false
  }
};
var inner = makeInner();
var decalPaletteScope = {};
function ariaVisual(ecModel, api) {
  var ariaModel = ecModel.getModel("aria");
  if (!ariaModel.get("enabled")) {
    return;
  }
  var defaultOption2 = clone$4(DEFAULT_OPTION);
  merge(defaultOption2.label, ecModel.getLocaleModel().get("aria"), false);
  merge(ariaModel.option, defaultOption2, false);
  setDecal();
  setLabel();
  function setDecal() {
    var decalModel = ariaModel.getModel("decal");
    var useDecal = decalModel.get("show");
    if (useDecal) {
      var paletteScopeGroupByType_1 = createHashMap();
      ecModel.eachSeries(function(seriesModel) {
        if (seriesModel.isColorBySeries()) {
          return;
        }
        var decalScope = paletteScopeGroupByType_1.get(seriesModel.type);
        if (!decalScope) {
          decalScope = {};
          paletteScopeGroupByType_1.set(seriesModel.type, decalScope);
        }
        inner(seriesModel).scope = decalScope;
      });
      ecModel.eachRawSeries(function(seriesModel) {
        if (ecModel.isSeriesFiltered(seriesModel)) {
          return;
        }
        if (isFunction(seriesModel.enableAriaDecal)) {
          seriesModel.enableAriaDecal();
          return;
        }
        var data = seriesModel.getData();
        if (!seriesModel.isColorBySeries()) {
          var dataAll_1 = seriesModel.getRawData();
          var idxMap_1 = {};
          var decalScope_1 = inner(seriesModel).scope;
          data.each(function(idx) {
            var rawIdx = data.getRawIndex(idx);
            idxMap_1[rawIdx] = idx;
          });
          var dataCount_1 = dataAll_1.count();
          dataAll_1.each(function(rawIdx) {
            var idx = idxMap_1[rawIdx];
            var name = dataAll_1.getName(rawIdx) || rawIdx + "";
            var paletteDecal2 = getDecalFromPalette(seriesModel.ecModel, name, decalScope_1, dataCount_1);
            var specifiedDecal2 = data.getItemVisual(idx, "decal");
            data.setItemVisual(idx, "decal", mergeDecal(specifiedDecal2, paletteDecal2));
          });
        } else {
          var paletteDecal = getDecalFromPalette(seriesModel.ecModel, seriesModel.name, decalPaletteScope, ecModel.getSeriesCount());
          var specifiedDecal = data.getVisual("decal");
          data.setVisual("decal", mergeDecal(specifiedDecal, paletteDecal));
        }
        function mergeDecal(specifiedDecal2, paletteDecal2) {
          var resultDecal = specifiedDecal2 ? extend(extend({}, paletteDecal2), specifiedDecal2) : paletteDecal2;
          resultDecal.dirty = true;
          return resultDecal;
        }
      });
    }
  }
  function setLabel() {
    var labelLocale = ecModel.getLocaleModel().get("aria");
    var labelModel = ariaModel.getModel("label");
    labelModel.option = defaults(labelModel.option, labelLocale);
    if (!labelModel.get("enabled")) {
      return;
    }
    var dom = api.getZr().dom;
    if (labelModel.get("description")) {
      dom.setAttribute("aria-label", labelModel.get("description"));
      return;
    }
    var seriesCnt = ecModel.getSeriesCount();
    var maxDataCnt = labelModel.get(["data", "maxCount"]) || 10;
    var maxSeriesCnt = labelModel.get(["series", "maxCount"]) || 10;
    var displaySeriesCnt = Math.min(seriesCnt, maxSeriesCnt);
    var ariaLabel;
    if (seriesCnt < 1) {
      return;
    } else {
      var title = getTitle();
      if (title) {
        var withTitle = labelModel.get(["general", "withTitle"]);
        ariaLabel = replace(withTitle, {
          title
        });
      } else {
        ariaLabel = labelModel.get(["general", "withoutTitle"]);
      }
      var seriesLabels_1 = [];
      var prefix = seriesCnt > 1 ? labelModel.get(["series", "multiple", "prefix"]) : labelModel.get(["series", "single", "prefix"]);
      ariaLabel += replace(prefix, {
        seriesCount: seriesCnt
      });
      ecModel.eachSeries(function(seriesModel, idx) {
        if (idx < displaySeriesCnt) {
          var seriesLabel = void 0;
          var seriesName = seriesModel.get("name");
          var withName = seriesName ? "withName" : "withoutName";
          seriesLabel = seriesCnt > 1 ? labelModel.get(["series", "multiple", withName]) : labelModel.get(["series", "single", withName]);
          seriesLabel = replace(seriesLabel, {
            seriesId: seriesModel.seriesIndex,
            seriesName: seriesModel.get("name"),
            seriesType: getSeriesTypeName(seriesModel.subType)
          });
          var data = seriesModel.getData();
          if (data.count() > maxDataCnt) {
            var partialLabel = labelModel.get(["data", "partialData"]);
            seriesLabel += replace(partialLabel, {
              displayCnt: maxDataCnt
            });
          } else {
            seriesLabel += labelModel.get(["data", "allData"]);
          }
          var middleSeparator_1 = labelModel.get(["data", "separator", "middle"]);
          var endSeparator_1 = labelModel.get(["data", "separator", "end"]);
          var dataLabels = [];
          for (var i = 0; i < data.count(); i++) {
            if (i < maxDataCnt) {
              var name_1 = data.getName(i);
              var value = data.getValues(i);
              var dataLabel = labelModel.get(["data", name_1 ? "withName" : "withoutName"]);
              dataLabels.push(replace(dataLabel, {
                name: name_1,
                value: value.join(middleSeparator_1)
              }));
            }
          }
          seriesLabel += dataLabels.join(middleSeparator_1) + endSeparator_1;
          seriesLabels_1.push(seriesLabel);
        }
      });
      var separatorModel = labelModel.getModel(["series", "multiple", "separator"]);
      var middleSeparator = separatorModel.get("middle");
      var endSeparator = separatorModel.get("end");
      ariaLabel += seriesLabels_1.join(middleSeparator) + endSeparator;
      dom.setAttribute("aria-label", ariaLabel);
    }
  }
  function replace(str, keyValues) {
    if (!isString(str)) {
      return str;
    }
    var result = str;
    each$f(keyValues, function(value, key) {
      result = result.replace(new RegExp("\\{\\s*" + key + "\\s*\\}", "g"), value);
    });
    return result;
  }
  function getTitle() {
    var title = ecModel.get("title");
    if (title && title.length) {
      title = title[0];
    }
    return title && title.text;
  }
  function getSeriesTypeName(type4) {
    return ecModel.getLocaleModel().get(["series", "typeNames"])[type4] || "\u81EA\u5B9A\u4E49\u56FE";
  }
}
function ariaPreprocessor(option) {
  if (!option || !option.aria) {
    return;
  }
  var aria = option.aria;
  if (aria.show != null) {
    aria.enabled = aria.show;
  }
  aria.label = aria.label || {};
  each$f(["description", "general", "series", "data"], function(name) {
    if (aria[name] != null) {
      aria.label[name] = aria[name];
    }
  });
}
function install$2(registers) {
  registers.registerPreprocessor(ariaPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.ARIA, ariaVisual);
}
var RELATIONAL_EXPRESSION_OP_ALIAS_MAP = {
  value: "eq",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  "=": "eq",
  "!=": "ne",
  "<>": "ne"
};
var RegExpEvaluator = function() {
  function RegExpEvaluator2(rVal) {
    var condValue = this._condVal = isString(rVal) ? new RegExp(rVal) : isRegExp(rVal) ? rVal : null;
    if (condValue == null) {
      var errMsg = "";
      throwError(errMsg);
    }
  }
  RegExpEvaluator2.prototype.evaluate = function(lVal) {
    var type4 = typeof lVal;
    return isString(type4) ? this._condVal.test(lVal) : isNumber(type4) ? this._condVal.test(lVal + "") : false;
  };
  return RegExpEvaluator2;
}();
var ConstConditionInternal = function() {
  function ConstConditionInternal2() {
  }
  ConstConditionInternal2.prototype.evaluate = function() {
    return this.value;
  };
  return ConstConditionInternal2;
}();
var AndConditionInternal = function() {
  function AndConditionInternal2() {
  }
  AndConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (!children[i].evaluate()) {
        return false;
      }
    }
    return true;
  };
  return AndConditionInternal2;
}();
var OrConditionInternal = function() {
  function OrConditionInternal2() {
  }
  OrConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].evaluate()) {
        return true;
      }
    }
    return false;
  };
  return OrConditionInternal2;
}();
var NotConditionInternal = function() {
  function NotConditionInternal2() {
  }
  NotConditionInternal2.prototype.evaluate = function() {
    return !this.child.evaluate();
  };
  return NotConditionInternal2;
}();
var RelationalConditionInternal = function() {
  function RelationalConditionInternal2() {
  }
  RelationalConditionInternal2.prototype.evaluate = function() {
    var needParse = !!this.valueParser;
    var getValue2 = this.getValue;
    var tarValRaw = getValue2(this.valueGetterParam);
    var tarValParsed = needParse ? this.valueParser(tarValRaw) : null;
    for (var i = 0; i < this.subCondList.length; i++) {
      if (!this.subCondList[i].evaluate(needParse ? tarValParsed : tarValRaw)) {
        return false;
      }
    }
    return true;
  };
  return RelationalConditionInternal2;
}();
function parseOption(exprOption, getters) {
  if (exprOption === true || exprOption === false) {
    var cond = new ConstConditionInternal();
    cond.value = exprOption;
    return cond;
  }
  var errMsg = "";
  if (!isObjectNotArray(exprOption)) {
    throwError(errMsg);
  }
  if (exprOption.and) {
    return parseAndOrOption("and", exprOption, getters);
  } else if (exprOption.or) {
    return parseAndOrOption("or", exprOption, getters);
  } else if (exprOption.not) {
    return parseNotOption(exprOption, getters);
  }
  return parseRelationalOption(exprOption, getters);
}
function parseAndOrOption(op, exprOption, getters) {
  var subOptionArr = exprOption[op];
  var errMsg = "";
  if (!isArray$1(subOptionArr)) {
    throwError(errMsg);
  }
  if (!subOptionArr.length) {
    throwError(errMsg);
  }
  var cond = op === "and" ? new AndConditionInternal() : new OrConditionInternal();
  cond.children = map$1(subOptionArr, function(subOption) {
    return parseOption(subOption, getters);
  });
  if (!cond.children.length) {
    throwError(errMsg);
  }
  return cond;
}
function parseNotOption(exprOption, getters) {
  var subOption = exprOption.not;
  var errMsg = "";
  if (!isObjectNotArray(subOption)) {
    throwError(errMsg);
  }
  var cond = new NotConditionInternal();
  cond.child = parseOption(subOption, getters);
  if (!cond.child) {
    throwError(errMsg);
  }
  return cond;
}
function parseRelationalOption(exprOption, getters) {
  var errMsg = "";
  var valueGetterParam = getters.prepareGetValue(exprOption);
  var subCondList = [];
  var exprKeys = keys(exprOption);
  var parserName = exprOption.parser;
  var valueParser = parserName ? getRawValueParser(parserName) : null;
  for (var i = 0; i < exprKeys.length; i++) {
    var keyRaw = exprKeys[i];
    if (keyRaw === "parser" || getters.valueGetterAttrMap.get(keyRaw)) {
      continue;
    }
    var op = hasOwn(RELATIONAL_EXPRESSION_OP_ALIAS_MAP, keyRaw) ? RELATIONAL_EXPRESSION_OP_ALIAS_MAP[keyRaw] : keyRaw;
    var condValueRaw = exprOption[keyRaw];
    var condValueParsed = valueParser ? valueParser(condValueRaw) : condValueRaw;
    var evaluator = createFilterComparator(op, condValueParsed) || op === "reg" && new RegExpEvaluator(condValueParsed);
    if (!evaluator) {
      throwError(errMsg);
    }
    subCondList.push(evaluator);
  }
  if (!subCondList.length) {
    throwError(errMsg);
  }
  var cond = new RelationalConditionInternal();
  cond.valueGetterParam = valueGetterParam;
  cond.valueParser = valueParser;
  cond.getValue = getters.getValue;
  cond.subCondList = subCondList;
  return cond;
}
function isObjectNotArray(val) {
  return isObject$4(val) && !isArrayLike(val);
}
var ConditionalExpressionParsed = function() {
  function ConditionalExpressionParsed2(exprOption, getters) {
    this._cond = parseOption(exprOption, getters);
  }
  ConditionalExpressionParsed2.prototype.evaluate = function() {
    return this._cond.evaluate();
  };
  return ConditionalExpressionParsed2;
}();
function parseConditionalExpression(exprOption, getters) {
  return new ConditionalExpressionParsed(exprOption, getters);
}
var filterTransform = {
  type: "echarts:filter",
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = parseConditionalExpression(params.config, {
      valueGetterAttrMap: createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!hasOwn(exprOption, "dimension")) {
          throwError(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          throwError(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
var sortTransform = {
  type: "echarts:sort",
  transform: function(params) {
    var upstream = params.upstream;
    var config = params.config;
    var errMsg = "";
    var orderExprList = normalizeToArray(config);
    if (!orderExprList.length) {
      throwError(errMsg);
    }
    var orderDefList = [];
    each$f(orderExprList, function(orderExpr) {
      var dimLoose = orderExpr.dimension;
      var order = orderExpr.order;
      var parserName = orderExpr.parser;
      var incomparable = orderExpr.incomparable;
      if (dimLoose == null) {
        throwError(errMsg);
      }
      if (order !== "asc" && order !== "desc") {
        throwError(errMsg);
      }
      if (incomparable && incomparable !== "min" && incomparable !== "max") {
        var errMsg_1 = "";
        throwError(errMsg_1);
      }
      if (order !== "asc" && order !== "desc") {
        var errMsg_2 = "";
        throwError(errMsg_2);
      }
      var dimInfo = upstream.getDimensionInfo(dimLoose);
      if (!dimInfo) {
        throwError(errMsg);
      }
      var parser = parserName ? getRawValueParser(parserName) : null;
      if (parserName && !parser) {
        throwError(errMsg);
      }
      orderDefList.push({
        dimIdx: dimInfo.index,
        parser,
        comparator: new SortOrderComparator(order, incomparable)
      });
    });
    var sourceFormat = upstream.sourceFormat;
    if (sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS && sourceFormat !== SOURCE_FORMAT_OBJECT_ROWS) {
      throwError(errMsg);
    }
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      resultData.push(upstream.getRawDataItem(i));
    }
    resultData.sort(function(item0, item1) {
      for (var i2 = 0; i2 < orderDefList.length; i2++) {
        var orderDef = orderDefList[i2];
        var val0 = upstream.retrieveValueFromItem(item0, orderDef.dimIdx);
        var val1 = upstream.retrieveValueFromItem(item1, orderDef.dimIdx);
        if (orderDef.parser) {
          val0 = orderDef.parser(val0);
          val1 = orderDef.parser(val1);
        }
        var result = orderDef.comparator.evaluate(val0, val1);
        if (result !== 0) {
          return result;
        }
      }
      return 0;
    });
    return {
      data: resultData
    };
  }
};
function install$1(registers) {
  registers.registerTransform(filterTransform);
  registers.registerTransform(sortTransform);
}
var DatasetModel = function(_super) {
  __extends(DatasetModel2, _super);
  function DatasetModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetModel2.prototype.init = function(option, parentModel, ecModel) {
    _super.prototype.init.call(this, option, parentModel, ecModel);
    this._sourceManager = new SourceManager(this);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.mergeOption = function(newOption, ecModel) {
    _super.prototype.mergeOption.call(this, newOption, ecModel);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.optionUpdated = function() {
    this._sourceManager.dirty();
  };
  DatasetModel2.prototype.getSourceManager = function() {
    return this._sourceManager;
  };
  DatasetModel2.type = "dataset";
  DatasetModel2.defaultOption = {
    seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN
  };
  return DatasetModel2;
}(ComponentModel$1);
var DatasetView = function(_super) {
  __extends(DatasetView2, _super);
  function DatasetView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetView2.type = "dataset";
  return DatasetView2;
}(ComponentView$1);
function install(registers) {
  registers.registerComponentModel(DatasetModel);
  registers.registerComponentView(DatasetView);
}
var CMD = PathProxy$1.CMD;
function aroundEqual(a, b2) {
  return Math.abs(a - b2) < 1e-5;
}
function pathToBezierCurves(path) {
  var data = path.data;
  var len2 = path.len();
  var bezierArrayGroups = [];
  var currentSubpath;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  function createNewSubpath(x3, y3) {
    if (currentSubpath && currentSubpath.length > 2) {
      bezierArrayGroups.push(currentSubpath);
    }
    currentSubpath = [x3, y3];
  }
  function addLine(x02, y02, x12, y12) {
    if (!(aroundEqual(x02, x12) && aroundEqual(y02, y12))) {
      currentSubpath.push(x02, y02, x12, y12, x12, y12);
    }
  }
  function addArc(startAngle2, endAngle2, cx2, cy2, rx2, ry2) {
    var delta = Math.abs(endAngle2 - startAngle2);
    var len3 = Math.tan(delta / 4) * 4 / 3;
    var dir3 = endAngle2 < startAngle2 ? -1 : 1;
    var c1 = Math.cos(startAngle2);
    var s1 = Math.sin(startAngle2);
    var c2 = Math.cos(endAngle2);
    var s2 = Math.sin(endAngle2);
    var x12 = c1 * rx2 + cx2;
    var y12 = s1 * ry2 + cy2;
    var x4 = c2 * rx2 + cx2;
    var y4 = s2 * ry2 + cy2;
    var hx = rx2 * len3 * dir3;
    var hy = ry2 * len3 * dir3;
    currentSubpath.push(x12 - hx * s1, y12 + hy * c1, x4 + hx * s2, y4 - hy * c2, x4, y4);
  }
  var x1;
  var y1;
  var x2;
  var y2;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
      if (cmd === CMD.L || cmd === CMD.C || cmd === CMD.Q) {
        currentSubpath = [x0, y0];
      }
    }
    switch (cmd) {
      case CMD.M:
        xi = x0 = data[i++];
        yi = y0 = data[i++];
        createNewSubpath(x0, y0);
        break;
      case CMD.L:
        x1 = data[i++];
        y1 = data[i++];
        addLine(xi, yi, x1, y1);
        xi = x1;
        yi = y1;
        break;
      case CMD.C:
        currentSubpath.push(data[i++], data[i++], data[i++], data[i++], xi = data[i++], yi = data[i++]);
        break;
      case CMD.Q:
        x1 = data[i++];
        y1 = data[i++];
        x2 = data[i++];
        y2 = data[i++];
        currentSubpath.push(xi + 2 / 3 * (x1 - xi), yi + 2 / 3 * (y1 - yi), x2 + 2 / 3 * (x1 - x2), y2 + 2 / 3 * (y1 - y2), x2, y2);
        xi = x2;
        yi = y2;
        break;
      case CMD.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var startAngle = data[i++];
        var endAngle = data[i++] + startAngle;
        i += 1;
        var anticlockwise = !data[i++];
        x1 = Math.cos(startAngle) * rx + cx;
        y1 = Math.sin(startAngle) * ry + cy;
        if (isFirst) {
          x0 = x1;
          y0 = y1;
          createNewSubpath(x0, y0);
        } else {
          addLine(xi, yi, x1, y1);
        }
        xi = Math.cos(endAngle) * rx + cx;
        yi = Math.sin(endAngle) * ry + cy;
        var step = (anticlockwise ? -1 : 1) * Math.PI / 2;
        for (var angle = startAngle; anticlockwise ? angle > endAngle : angle < endAngle; angle += step) {
          var nextAngle = anticlockwise ? Math.max(angle + step, endAngle) : Math.min(angle + step, endAngle);
          addArc(angle, nextAngle, cx, cy, rx, ry);
        }
        break;
      case CMD.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        x1 = x0 + data[i++];
        y1 = y0 + data[i++];
        createNewSubpath(x1, y0);
        addLine(x1, y0, x1, y1);
        addLine(x1, y1, x0, y1);
        addLine(x0, y1, x0, y0);
        addLine(x0, y0, x1, y0);
        break;
      case CMD.Z:
        currentSubpath && addLine(xi, yi, x0, y0);
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (currentSubpath && currentSubpath.length > 2) {
    bezierArrayGroups.push(currentSubpath);
  }
  return bezierArrayGroups;
}
function adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, out2, scale2) {
  if (aroundEqual(x0, x1) && aroundEqual(y0, y1) && aroundEqual(x2, x3) && aroundEqual(y2, y3)) {
    out2.push(x3, y3);
    return;
  }
  var PIXEL_DISTANCE = 2 / scale2;
  var PIXEL_DISTANCE_SQR = PIXEL_DISTANCE * PIXEL_DISTANCE;
  var dx = x3 - x0;
  var dy = y3 - y0;
  var d2 = Math.sqrt(dx * dx + dy * dy);
  dx /= d2;
  dy /= d2;
  var dx1 = x1 - x0;
  var dy1 = y1 - y0;
  var dx2 = x2 - x3;
  var dy2 = y2 - y3;
  var cp1LenSqr = dx1 * dx1 + dy1 * dy1;
  var cp2LenSqr = dx2 * dx2 + dy2 * dy2;
  if (cp1LenSqr < PIXEL_DISTANCE_SQR && cp2LenSqr < PIXEL_DISTANCE_SQR) {
    out2.push(x3, y3);
    return;
  }
  var projLen1 = dx * dx1 + dy * dy1;
  var projLen2 = -dx * dx2 - dy * dy2;
  var d1Sqr = cp1LenSqr - projLen1 * projLen1;
  var d2Sqr = cp2LenSqr - projLen2 * projLen2;
  if (d1Sqr < PIXEL_DISTANCE_SQR && projLen1 >= 0 && d2Sqr < PIXEL_DISTANCE_SQR && projLen2 >= 0) {
    out2.push(x3, y3);
    return;
  }
  var tmpSegX = [];
  var tmpSegY = [];
  cubicSubdivide(x0, x1, x2, x3, 0.5, tmpSegX);
  cubicSubdivide(y0, y1, y2, y3, 0.5, tmpSegY);
  adpativeBezier(tmpSegX[0], tmpSegY[0], tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], tmpSegX[3], tmpSegY[3], out2, scale2);
  adpativeBezier(tmpSegX[4], tmpSegY[4], tmpSegX[5], tmpSegY[5], tmpSegX[6], tmpSegY[6], tmpSegX[7], tmpSegY[7], out2, scale2);
}
function pathToPolygons(path, scale2) {
  var bezierArrayGroups = pathToBezierCurves(path);
  var polygons = [];
  scale2 = scale2 || 1;
  for (var i = 0; i < bezierArrayGroups.length; i++) {
    var beziers = bezierArrayGroups[i];
    var polygon = [];
    var x0 = beziers[0];
    var y0 = beziers[1];
    polygon.push(x0, y0);
    for (var k2 = 2; k2 < beziers.length; ) {
      var x1 = beziers[k2++];
      var y1 = beziers[k2++];
      var x2 = beziers[k2++];
      var y2 = beziers[k2++];
      var x3 = beziers[k2++];
      var y3 = beziers[k2++];
      adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, polygon, scale2);
      x0 = x3;
      y0 = y3;
    }
    polygons.push(polygon);
  }
  return polygons;
}
function getDividingGrids(dimSize, rowDim, count2) {
  var rowSize = dimSize[rowDim];
  var columnSize = dimSize[1 - rowDim];
  var ratio = Math.abs(rowSize / columnSize);
  var rowCount = Math.ceil(Math.sqrt(ratio * count2));
  var columnCount = Math.floor(count2 / rowCount);
  if (columnCount === 0) {
    columnCount = 1;
    rowCount = count2;
  }
  var grids = [];
  for (var i = 0; i < rowCount; i++) {
    grids.push(columnCount);
  }
  var currentCount = rowCount * columnCount;
  var remained = count2 - currentCount;
  if (remained > 0) {
    for (var i = 0; i < remained; i++) {
      grids[i % rowCount] += 1;
    }
  }
  return grids;
}
function divideSector(sectorShape, count2, outShapes) {
  var r0 = sectorShape.r0;
  var r2 = sectorShape.r;
  var startAngle = sectorShape.startAngle;
  var endAngle = sectorShape.endAngle;
  var angle = Math.abs(endAngle - startAngle);
  var arcLen = angle * r2;
  var deltaR = r2 - r0;
  var isAngleRow = arcLen > Math.abs(deltaR);
  var grids = getDividingGrids([arcLen, deltaR], isAngleRow ? 0 : 1, count2);
  var rowSize = (isAngleRow ? angle : deltaR) / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = (isAngleRow ? deltaR : angle) / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      if (isAngleRow) {
        newShape.startAngle = startAngle + rowSize * row;
        newShape.endAngle = startAngle + rowSize * (row + 1);
        newShape.r0 = r0 + columnSize * column;
        newShape.r = r0 + columnSize * (column + 1);
      } else {
        newShape.startAngle = startAngle + columnSize * column;
        newShape.endAngle = startAngle + columnSize * (column + 1);
        newShape.r0 = r0 + rowSize * row;
        newShape.r = r0 + rowSize * (row + 1);
      }
      newShape.clockwise = sectorShape.clockwise;
      newShape.cx = sectorShape.cx;
      newShape.cy = sectorShape.cy;
      outShapes.push(newShape);
    }
  }
}
function divideRect(rectShape, count2, outShapes) {
  var width = rectShape.width;
  var height = rectShape.height;
  var isHorizontalRow = width > height;
  var grids = getDividingGrids([width, height], isHorizontalRow ? 0 : 1, count2);
  var rowSizeDim = isHorizontalRow ? "width" : "height";
  var columnSizeDim = isHorizontalRow ? "height" : "width";
  var rowDim = isHorizontalRow ? "x" : "y";
  var columnDim = isHorizontalRow ? "y" : "x";
  var rowSize = rectShape[rowSizeDim] / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = rectShape[columnSizeDim] / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      newShape[rowDim] = row * rowSize;
      newShape[columnDim] = column * columnSize;
      newShape[rowSizeDim] = rowSize;
      newShape[columnSizeDim] = columnSize;
      newShape.x += rectShape.x;
      newShape.y += rectShape.y;
      outShapes.push(newShape);
    }
  }
}
function crossProduct2d(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function lineLineIntersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d(nx, ny, mx, my);
  if (Math.abs(nmCrossProduct) < 1e-6) {
    return null;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var p2 = crossProduct2d(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return null;
  }
  return new Point$1(p2 * mx + a1x, p2 * my + a1y);
}
function projPtOnLine(pt, lineA, lineB) {
  var dir3 = new Point$1();
  Point$1.sub(dir3, lineB, lineA);
  dir3.normalize();
  var dir22 = new Point$1();
  Point$1.sub(dir22, pt, lineA);
  var len2 = dir22.dot(dir3);
  return len2;
}
function addToPoly(poly, pt) {
  var last = poly[poly.length - 1];
  if (last && last[0] === pt[0] && last[1] === pt[1]) {
    return;
  }
  poly.push(pt);
}
function splitPolygonByLine(points2, lineA, lineB) {
  var len2 = points2.length;
  var intersections = [];
  for (var i = 0; i < len2; i++) {
    var p0 = points2[i];
    var p1 = points2[(i + 1) % len2];
    var intersectionPt = lineLineIntersect(p0[0], p0[1], p1[0], p1[1], lineA.x, lineA.y, lineB.x, lineB.y);
    if (intersectionPt) {
      intersections.push({
        projPt: projPtOnLine(intersectionPt, lineA, lineB),
        pt: intersectionPt,
        idx: i
      });
    }
  }
  if (intersections.length < 2) {
    return [{ points: points2 }, { points: points2 }];
  }
  intersections.sort(function(a, b2) {
    return a.projPt - b2.projPt;
  });
  var splitPt0 = intersections[0];
  var splitPt1 = intersections[intersections.length - 1];
  if (splitPt1.idx < splitPt0.idx) {
    var tmp = splitPt0;
    splitPt0 = splitPt1;
    splitPt1 = tmp;
  }
  var splitPt0Arr = [splitPt0.pt.x, splitPt0.pt.y];
  var splitPt1Arr = [splitPt1.pt.x, splitPt1.pt.y];
  var newPolyA = [splitPt0Arr];
  var newPolyB = [splitPt1Arr];
  for (var i = splitPt0.idx + 1; i <= splitPt1.idx; i++) {
    addToPoly(newPolyA, points2[i].slice());
  }
  addToPoly(newPolyA, splitPt1Arr);
  addToPoly(newPolyA, splitPt0Arr);
  for (var i = splitPt1.idx + 1; i <= splitPt0.idx + len2; i++) {
    addToPoly(newPolyB, points2[i % len2].slice());
  }
  addToPoly(newPolyB, splitPt0Arr);
  addToPoly(newPolyB, splitPt1Arr);
  return [{
    points: newPolyA
  }, {
    points: newPolyB
  }];
}
function binaryDividePolygon(polygonShape) {
  var points2 = polygonShape.points;
  var min3 = [];
  var max3 = [];
  fromPoints(points2, min3, max3);
  var boundingRect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
  var width = boundingRect.width;
  var height = boundingRect.height;
  var x2 = boundingRect.x;
  var y2 = boundingRect.y;
  var pt02 = new Point$1();
  var pt12 = new Point$1();
  if (width > height) {
    pt02.x = pt12.x = x2 + width / 2;
    pt02.y = y2;
    pt12.y = y2 + height;
  } else {
    pt02.y = pt12.y = y2 + height / 2;
    pt02.x = x2;
    pt12.x = x2 + width;
  }
  return splitPolygonByLine(points2, pt02, pt12);
}
function binaryDivideRecursive(divider, shape, count2, out2) {
  if (count2 === 1) {
    out2.push(shape);
  } else {
    var mid = Math.floor(count2 / 2);
    var sub2 = divider(shape);
    binaryDivideRecursive(divider, sub2[0], mid, out2);
    binaryDivideRecursive(divider, sub2[1], count2 - mid, out2);
  }
  return out2;
}
function clone(path, count2) {
  var paths = [];
  for (var i = 0; i < count2; i++) {
    paths.push(clonePath(path));
  }
  return paths;
}
function copyPathProps(source, target) {
  target.setStyle(source.style);
  target.z = source.z;
  target.z2 = source.z2;
  target.zlevel = source.zlevel;
}
function polygonConvert(points2) {
  var out2 = [];
  for (var i = 0; i < points2.length; ) {
    out2.push([points2[i++], points2[i++]]);
  }
  return out2;
}
function split(path, count2) {
  var outShapes = [];
  var shape = path.shape;
  var OutShapeCtor;
  switch (path.type) {
    case "rect":
      divideRect(shape, count2, outShapes);
      OutShapeCtor = Rect$3;
      break;
    case "sector":
      divideSector(shape, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    case "circle":
      divideSector({
        r0: 0,
        r: shape.r,
        startAngle: 0,
        endAngle: Math.PI * 2,
        cx: shape.cx,
        cy: shape.cy
      }, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    default:
      var m2 = path.getComputedTransform();
      var scale2 = m2 ? Math.sqrt(Math.max(m2[0] * m2[0] + m2[1] * m2[1], m2[2] * m2[2] + m2[3] * m2[3])) : 1;
      var polygons = map$1(pathToPolygons(path.getUpdatedPathProxy(), scale2), function(poly) {
        return polygonConvert(poly);
      });
      var polygonCount = polygons.length;
      if (polygonCount === 0) {
        binaryDivideRecursive(binaryDividePolygon, {
          points: polygons[0]
        }, count2, outShapes);
      } else if (polygonCount === count2) {
        for (var i = 0; i < polygonCount; i++) {
          outShapes.push({
            points: polygons[i]
          });
        }
      } else {
        var totalArea_1 = 0;
        var items = map$1(polygons, function(poly) {
          var min3 = [];
          var max3 = [];
          fromPoints(poly, min3, max3);
          var area = (max3[1] - min3[1]) * (max3[0] - min3[0]);
          totalArea_1 += area;
          return { poly, area };
        });
        items.sort(function(a, b2) {
          return b2.area - a.area;
        });
        var left = count2;
        for (var i = 0; i < polygonCount; i++) {
          var item = items[i];
          if (left <= 0) {
            break;
          }
          var selfCount = i === polygonCount - 1 ? left : Math.ceil(item.area / totalArea_1 * count2);
          if (selfCount < 0) {
            continue;
          }
          binaryDivideRecursive(binaryDividePolygon, {
            points: item.poly
          }, selfCount, outShapes);
          left -= selfCount;
        }
      }
      OutShapeCtor = Polygon$1;
      break;
  }
  if (!OutShapeCtor) {
    return clone(path, count2);
  }
  var out2 = [];
  for (var i = 0; i < outShapes.length; i++) {
    var subPath = new OutShapeCtor();
    subPath.setShape(outShapes[i]);
    copyPathProps(path, subPath);
    out2.push(subPath);
  }
  return out2;
}
function alignSubpath(subpath1, subpath2) {
  var len1 = subpath1.length;
  var len2 = subpath2.length;
  if (len1 === len2) {
    return [subpath1, subpath2];
  }
  var tmpSegX = [];
  var tmpSegY = [];
  var shorterPath = len1 < len2 ? subpath1 : subpath2;
  var shorterLen = Math.min(len1, len2);
  var diff = Math.abs(len2 - len1) / 6;
  var shorterBezierCount = (shorterLen - 2) / 6;
  var eachCurveSubDivCount = Math.ceil(diff / shorterBezierCount) + 1;
  var newSubpath = [shorterPath[0], shorterPath[1]];
  var remained = diff;
  for (var i = 2; i < shorterLen; ) {
    var x0 = shorterPath[i - 2];
    var y0 = shorterPath[i - 1];
    var x1 = shorterPath[i++];
    var y1 = shorterPath[i++];
    var x2 = shorterPath[i++];
    var y2 = shorterPath[i++];
    var x3 = shorterPath[i++];
    var y3 = shorterPath[i++];
    if (remained <= 0) {
      newSubpath.push(x1, y1, x2, y2, x3, y3);
      continue;
    }
    var actualSubDivCount = Math.min(remained, eachCurveSubDivCount - 1) + 1;
    for (var k2 = 1; k2 <= actualSubDivCount; k2++) {
      var p2 = k2 / actualSubDivCount;
      cubicSubdivide(x0, x1, x2, x3, p2, tmpSegX);
      cubicSubdivide(y0, y1, y2, y3, p2, tmpSegY);
      x0 = tmpSegX[3];
      y0 = tmpSegY[3];
      newSubpath.push(tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], x0, y0);
      x1 = tmpSegX[5];
      y1 = tmpSegY[5];
      x2 = tmpSegX[6];
      y2 = tmpSegY[6];
    }
    remained -= actualSubDivCount - 1;
  }
  return shorterPath === subpath1 ? [newSubpath, subpath2] : [subpath1, newSubpath];
}
function createSubpath(lastSubpathSubpath, otherSubpath) {
  var len2 = lastSubpathSubpath.length;
  var lastX = lastSubpathSubpath[len2 - 2];
  var lastY = lastSubpathSubpath[len2 - 1];
  var newSubpath = [];
  for (var i = 0; i < otherSubpath.length; ) {
    newSubpath[i++] = lastX;
    newSubpath[i++] = lastY;
  }
  return newSubpath;
}
function alignBezierCurves(array1, array22) {
  var _a2;
  var lastSubpath1;
  var lastSubpath2;
  var newArray1 = [];
  var newArray2 = [];
  for (var i = 0; i < Math.max(array1.length, array22.length); i++) {
    var subpath1 = array1[i];
    var subpath2 = array22[i];
    var newSubpath1 = void 0;
    var newSubpath2 = void 0;
    if (!subpath1) {
      newSubpath1 = createSubpath(lastSubpath1 || subpath2, subpath2);
      newSubpath2 = subpath2;
    } else if (!subpath2) {
      newSubpath2 = createSubpath(lastSubpath2 || subpath1, subpath1);
      newSubpath1 = subpath1;
    } else {
      _a2 = alignSubpath(subpath1, subpath2), newSubpath1 = _a2[0], newSubpath2 = _a2[1];
      lastSubpath1 = newSubpath1;
      lastSubpath2 = newSubpath2;
    }
    newArray1.push(newSubpath1);
    newArray2.push(newSubpath2);
  }
  return [newArray1, newArray2];
}
function centroid(array4) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = array4.length;
  for (var i = 0, j = len2 - 2; i < len2; j = i, i += 2) {
    var x0 = array4[j];
    var y0 = array4[j + 1];
    var x1 = array4[i];
    var y1 = array4[i + 1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
  }
  if (signedArea === 0) {
    return [array4[0] || 0, array4[1] || 0];
  }
  return [cx / signedArea / 3, cy / signedArea / 3, signedArea];
}
function findBestRingOffset(fromSubBeziers, toSubBeziers, fromCp, toCp) {
  var bezierCount = (fromSubBeziers.length - 2) / 6;
  var bestScore = Infinity;
  var bestOffset = 0;
  var len2 = fromSubBeziers.length;
  var len22 = len2 - 2;
  for (var offset = 0; offset < bezierCount; offset++) {
    var cursorOffset = offset * 6;
    var score = 0;
    for (var k2 = 0; k2 < len2; k2 += 2) {
      var idx = k2 === 0 ? cursorOffset : (cursorOffset + k2 - 2) % len22 + 2;
      var x0 = fromSubBeziers[idx] - fromCp[0];
      var y0 = fromSubBeziers[idx + 1] - fromCp[1];
      var x1 = toSubBeziers[k2] - toCp[0];
      var y1 = toSubBeziers[k2 + 1] - toCp[1];
      var dx = x1 - x0;
      var dy = y1 - y0;
      score += dx * dx + dy * dy;
    }
    if (score < bestScore) {
      bestScore = score;
      bestOffset = offset;
    }
  }
  return bestOffset;
}
function reverse(array4) {
  var newArr = [];
  var len2 = array4.length;
  for (var i = 0; i < len2; i += 2) {
    newArr[i] = array4[len2 - i - 2];
    newArr[i + 1] = array4[len2 - i - 1];
  }
  return newArr;
}
function findBestMorphingRotation(fromArr, toArr2, searchAngleIteration, searchAngleRange) {
  var result = [];
  var fromNeedsReverse;
  for (var i = 0; i < fromArr.length; i++) {
    var fromSubpathBezier = fromArr[i];
    var toSubpathBezier = toArr2[i];
    var fromCp = centroid(fromSubpathBezier);
    var toCp = centroid(toSubpathBezier);
    if (fromNeedsReverse == null) {
      fromNeedsReverse = fromCp[2] < 0 !== toCp[2] < 0;
    }
    var newFromSubpathBezier = [];
    var newToSubpathBezier = [];
    var bestAngle = 0;
    var bestScore = Infinity;
    var tmpArr2 = [];
    var len2 = fromSubpathBezier.length;
    if (fromNeedsReverse) {
      fromSubpathBezier = reverse(fromSubpathBezier);
    }
    var offset = findBestRingOffset(fromSubpathBezier, toSubpathBezier, fromCp, toCp) * 6;
    var len22 = len2 - 2;
    for (var k2 = 0; k2 < len22; k2 += 2) {
      var idx = (offset + k2) % len22 + 2;
      newFromSubpathBezier[k2 + 2] = fromSubpathBezier[idx] - fromCp[0];
      newFromSubpathBezier[k2 + 3] = fromSubpathBezier[idx + 1] - fromCp[1];
    }
    newFromSubpathBezier[0] = fromSubpathBezier[offset] - fromCp[0];
    newFromSubpathBezier[1] = fromSubpathBezier[offset + 1] - fromCp[1];
    if (searchAngleIteration > 0) {
      var step = searchAngleRange / searchAngleIteration;
      for (var angle = -searchAngleRange / 2; angle <= searchAngleRange / 2; angle += step) {
        var sa = Math.sin(angle);
        var ca = Math.cos(angle);
        var score = 0;
        for (var k2 = 0; k2 < fromSubpathBezier.length; k2 += 2) {
          var x0 = newFromSubpathBezier[k2];
          var y0 = newFromSubpathBezier[k2 + 1];
          var x1 = toSubpathBezier[k2] - toCp[0];
          var y1 = toSubpathBezier[k2 + 1] - toCp[1];
          var newX1 = x1 * ca - y1 * sa;
          var newY1 = x1 * sa + y1 * ca;
          tmpArr2[k2] = newX1;
          tmpArr2[k2 + 1] = newY1;
          var dx = newX1 - x0;
          var dy = newY1 - y0;
          score += dx * dx + dy * dy;
        }
        if (score < bestScore) {
          bestScore = score;
          bestAngle = angle;
          for (var m2 = 0; m2 < tmpArr2.length; m2++) {
            newToSubpathBezier[m2] = tmpArr2[m2];
          }
        }
      }
    } else {
      for (var i_1 = 0; i_1 < len2; i_1 += 2) {
        newToSubpathBezier[i_1] = toSubpathBezier[i_1] - toCp[0];
        newToSubpathBezier[i_1 + 1] = toSubpathBezier[i_1 + 1] - toCp[1];
      }
    }
    result.push({
      from: newFromSubpathBezier,
      to: newToSubpathBezier,
      fromCp,
      toCp,
      rotation: -bestAngle
    });
  }
  return result;
}
function isCombineMorphing(path) {
  return path.__isCombineMorphing;
}
var SAVED_METHOD_PREFIX = "__mOriginal_";
function saveAndModifyMethod(obj, methodName, modifiers) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  var originalMethod = obj[savedMethodName] || obj[methodName];
  if (!obj[savedMethodName]) {
    obj[savedMethodName] = obj[methodName];
  }
  var replace = modifiers.replace;
  var after = modifiers.after;
  var before = modifiers.before;
  obj[methodName] = function() {
    var args = arguments;
    var res;
    before && before.apply(this, args);
    if (replace) {
      res = replace.apply(this, args);
    } else {
      res = originalMethod.apply(this, args);
    }
    after && after.apply(this, args);
    return res;
  };
}
function restoreMethod(obj, methodName) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  if (obj[savedMethodName]) {
    obj[methodName] = obj[savedMethodName];
    obj[savedMethodName] = null;
  }
}
function applyTransformOnBeziers(bezierCurves, mm) {
  for (var i = 0; i < bezierCurves.length; i++) {
    var subBeziers = bezierCurves[i];
    for (var k2 = 0; k2 < subBeziers.length; ) {
      var x2 = subBeziers[k2];
      var y2 = subBeziers[k2 + 1];
      subBeziers[k2++] = mm[0] * x2 + mm[2] * y2 + mm[4];
      subBeziers[k2++] = mm[1] * x2 + mm[3] * y2 + mm[5];
    }
  }
}
function prepareMorphPath(fromPath, toPath) {
  var fromPathProxy = fromPath.getUpdatedPathProxy();
  var toPathProxy = toPath.getUpdatedPathProxy();
  var _a2 = alignBezierCurves(pathToBezierCurves(fromPathProxy), pathToBezierCurves(toPathProxy)), fromBezierCurves = _a2[0], toBezierCurves = _a2[1];
  var fromPathTransform = fromPath.getComputedTransform();
  var toPathTransform = toPath.getComputedTransform();
  function updateIdentityTransform() {
    this.transform = null;
  }
  fromPathTransform && applyTransformOnBeziers(fromBezierCurves, fromPathTransform);
  toPathTransform && applyTransformOnBeziers(toBezierCurves, toPathTransform);
  saveAndModifyMethod(toPath, "updateTransform", { replace: updateIdentityTransform });
  toPath.transform = null;
  var morphingData = findBestMorphingRotation(fromBezierCurves, toBezierCurves, 10, Math.PI);
  var tmpArr2 = [];
  saveAndModifyMethod(toPath, "buildPath", { replace: function(path) {
    var t2 = toPath.__morphT;
    var onet = 1 - t2;
    var newCp = [];
    for (var i = 0; i < morphingData.length; i++) {
      var item = morphingData[i];
      var from = item.from;
      var to = item.to;
      var angle = item.rotation * t2;
      var fromCp = item.fromCp;
      var toCp = item.toCp;
      var sa = Math.sin(angle);
      var ca = Math.cos(angle);
      lerp$1(newCp, fromCp, toCp, t2);
      for (var m2 = 0; m2 < from.length; m2 += 2) {
        var x0_1 = from[m2];
        var y0_1 = from[m2 + 1];
        var x1 = to[m2];
        var y1 = to[m2 + 1];
        var x2 = x0_1 * onet + x1 * t2;
        var y2 = y0_1 * onet + y1 * t2;
        tmpArr2[m2] = x2 * ca - y2 * sa + newCp[0];
        tmpArr2[m2 + 1] = x2 * sa + y2 * ca + newCp[1];
      }
      var x0 = tmpArr2[0];
      var y0 = tmpArr2[1];
      path.moveTo(x0, y0);
      for (var m2 = 2; m2 < from.length; ) {
        var x1 = tmpArr2[m2++];
        var y1 = tmpArr2[m2++];
        var x22 = tmpArr2[m2++];
        var y22 = tmpArr2[m2++];
        var x3 = tmpArr2[m2++];
        var y3 = tmpArr2[m2++];
        if (x0 === x1 && y0 === y1 && x22 === x3 && y22 === y3) {
          path.lineTo(x3, y3);
        } else {
          path.bezierCurveTo(x1, y1, x22, y22, x3, y3);
        }
        x0 = x3;
        y0 = y3;
      }
    }
  } });
}
function morphPath(fromPath, toPath, animationOpts) {
  if (!fromPath || !toPath) {
    return toPath;
  }
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  prepareMorphPath(fromPath, toPath);
  toPath.__morphT = 0;
  function restoreToPath() {
    restoreMethod(toPath, "buildPath");
    restoreMethod(toPath, "updateTransform");
    toPath.__morphT = -1;
    toPath.createPathProxy();
    toPath.dirtyShape();
  }
  toPath.animateTo({
    __morphT: 1
  }, defaults({
    during: function(p2) {
      toPath.dirtyShape();
      oldDuring && oldDuring(p2);
    },
    done: function() {
      restoreToPath();
      oldDone && oldDone();
    }
  }, animationOpts));
  return toPath;
}
function hilbert(x2, y2, minX, minY, maxX, maxY) {
  var bits = 16;
  x2 = maxX === minX ? 0 : Math.round(32767 * (x2 - minX) / (maxX - minX));
  y2 = maxY === minY ? 0 : Math.round(32767 * (y2 - minY) / (maxY - minY));
  var d2 = 0;
  var tmp;
  for (var s = (1 << bits) / 2; s > 0; s /= 2) {
    var rx = 0;
    var ry = 0;
    if ((x2 & s) > 0) {
      rx = 1;
    }
    if ((y2 & s) > 0) {
      ry = 1;
    }
    d2 += s * s * (3 * rx ^ ry);
    if (ry === 0) {
      if (rx === 1) {
        x2 = s - 1 - x2;
        y2 = s - 1 - y2;
      }
      tmp = x2;
      x2 = y2;
      y2 = tmp;
    }
  }
  return d2;
}
function sortPaths(pathList) {
  var xMin = Infinity;
  var yMin = Infinity;
  var xMax = -Infinity;
  var yMax = -Infinity;
  var cps = map$1(pathList, function(path) {
    var rect = path.getBoundingRect();
    var m2 = path.getComputedTransform();
    var x2 = rect.x + rect.width / 2 + (m2 ? m2[4] : 0);
    var y2 = rect.y + rect.height / 2 + (m2 ? m2[5] : 0);
    xMin = Math.min(x2, xMin);
    yMin = Math.min(y2, yMin);
    xMax = Math.max(x2, xMax);
    yMax = Math.max(y2, yMax);
    return [x2, y2];
  });
  var items = map$1(cps, function(cp, idx) {
    return {
      cp,
      z: hilbert(cp[0], cp[1], xMin, yMin, xMax, yMax),
      path: pathList[idx]
    };
  });
  return items.sort(function(a, b2) {
    return a.z - b2.z;
  }).map(function(item) {
    return item.path;
  });
}
function defaultDividePath(param) {
  return split(param.path, param.count);
}
function createEmptyReturn() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function combineMorph(fromList, toPath, animationOpts) {
  var fromPathList = [];
  function addFromPath(fromList2) {
    for (var i2 = 0; i2 < fromList2.length; i2++) {
      var from2 = fromList2[i2];
      if (isCombineMorphing(from2)) {
        addFromPath(from2.childrenRef());
      } else if (from2 instanceof Path$1) {
        fromPathList.push(from2);
      }
    }
  }
  addFromPath(fromList);
  var separateCount = fromPathList.length;
  if (!separateCount) {
    return createEmptyReturn();
  }
  var dividePath = animationOpts.dividePath || defaultDividePath;
  var toSubPathList = dividePath({
    path: toPath,
    count: separateCount
  });
  if (toSubPathList.length !== separateCount) {
    console.error("Invalid morphing: unmatched splitted path");
    return createEmptyReturn();
  }
  fromPathList = sortPaths(fromPathList);
  toSubPathList = sortPaths(toSubPathList);
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  var individualDelay = animationOpts.individualDelay;
  var identityTransform = new Transformable$1();
  for (var i = 0; i < separateCount; i++) {
    var from = fromPathList[i];
    var to = toSubPathList[i];
    to.parent = toPath;
    to.copyTransform(identityTransform);
    if (!individualDelay) {
      prepareMorphPath(from, to);
    }
  }
  toPath.__isCombineMorphing = true;
  toPath.childrenRef = function() {
    return toSubPathList;
  };
  function addToSubPathListToZr(zr) {
    for (var i2 = 0; i2 < toSubPathList.length; i2++) {
      toSubPathList[i2].addSelfToZr(zr);
    }
  }
  saveAndModifyMethod(toPath, "addSelfToZr", {
    after: function(zr) {
      addToSubPathListToZr(zr);
    }
  });
  saveAndModifyMethod(toPath, "removeSelfFromZr", {
    after: function(zr) {
      for (var i2 = 0; i2 < toSubPathList.length; i2++) {
        toSubPathList[i2].removeSelfFromZr(zr);
      }
    }
  });
  function restoreToPath() {
    toPath.__isCombineMorphing = false;
    toPath.__morphT = -1;
    toPath.childrenRef = null;
    restoreMethod(toPath, "addSelfToZr");
    restoreMethod(toPath, "removeSelfFromZr");
  }
  var toLen = toSubPathList.length;
  if (individualDelay) {
    var animating_1 = toLen;
    var eachDone = function() {
      animating_1--;
      if (animating_1 === 0) {
        restoreToPath();
        oldDone && oldDone();
      }
    };
    for (var i = 0; i < toLen; i++) {
      var indivdualAnimationOpts = individualDelay ? defaults({
        delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toSubPathList[i]),
        done: eachDone
      }, animationOpts) : animationOpts;
      morphPath(fromPathList[i], toSubPathList[i], indivdualAnimationOpts);
    }
  } else {
    toPath.__morphT = 0;
    toPath.animateTo({
      __morphT: 1
    }, defaults({
      during: function(p2) {
        for (var i2 = 0; i2 < toLen; i2++) {
          var child = toSubPathList[i2];
          child.__morphT = toPath.__morphT;
          child.dirtyShape();
        }
        oldDuring && oldDuring(p2);
      },
      done: function() {
        restoreToPath();
        for (var i2 = 0; i2 < fromList.length; i2++) {
          restoreMethod(fromList[i2], "updateTransform");
        }
        oldDone && oldDone();
      }
    }, animationOpts));
  }
  if (toPath.__zr) {
    addToSubPathListToZr(toPath.__zr);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toSubPathList,
    count: toLen
  };
}
function separateMorph(fromPath, toPathList, animationOpts) {
  var toLen = toPathList.length;
  var fromPathList = [];
  var dividePath = animationOpts.dividePath || defaultDividePath;
  function addFromPath(fromList) {
    for (var i2 = 0; i2 < fromList.length; i2++) {
      var from = fromList[i2];
      if (isCombineMorphing(from)) {
        addFromPath(from.childrenRef());
      } else if (from instanceof Path$1) {
        fromPathList.push(from);
      }
    }
  }
  if (isCombineMorphing(fromPath)) {
    addFromPath(fromPath.childrenRef());
    var fromLen = fromPathList.length;
    if (fromLen < toLen) {
      var k2 = 0;
      for (var i = fromLen; i < toLen; i++) {
        fromPathList.push(clonePath(fromPathList[k2++ % fromLen]));
      }
    }
    fromPathList.length = toLen;
  } else {
    fromPathList = dividePath({ path: fromPath, count: toLen });
    var fromPathTransform = fromPath.getComputedTransform();
    for (var i = 0; i < fromPathList.length; i++) {
      fromPathList[i].setLocalTransform(fromPathTransform);
    }
    if (fromPathList.length !== toLen) {
      console.error("Invalid morphing: unmatched splitted path");
      return createEmptyReturn();
    }
  }
  fromPathList = sortPaths(fromPathList);
  toPathList = sortPaths(toPathList);
  var individualDelay = animationOpts.individualDelay;
  for (var i = 0; i < toLen; i++) {
    var indivdualAnimationOpts = individualDelay ? defaults({
      delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toPathList[i])
    }, animationOpts) : animationOpts;
    morphPath(fromPathList[i], toPathList[i], indivdualAnimationOpts);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toPathList,
    count: toPathList.length
  };
}
function isMultiple(elements) {
  return isArray$1(elements[0]);
}
function prepareMorphBatches(one, many) {
  var batches = [];
  var batchCount = one.length;
  for (var i = 0; i < batchCount; i++) {
    batches.push({
      one: one[i],
      many: []
    });
  }
  for (var i = 0; i < many.length; i++) {
    var len2 = many[i].length;
    var k2 = void 0;
    for (k2 = 0; k2 < len2; k2++) {
      batches[k2 % batchCount].many.push(many[i][k2]);
    }
  }
  var off = 0;
  for (var i = batchCount - 1; i >= 0; i--) {
    if (!batches[i].many.length) {
      var moveFrom = batches[off].many;
      if (moveFrom.length <= 1) {
        if (off) {
          off = 0;
        } else {
          return batches;
        }
      }
      var len2 = moveFrom.length;
      var mid = Math.ceil(len2 / 2);
      batches[i].many = moveFrom.slice(mid, len2);
      batches[off].many = moveFrom.slice(0, mid);
      off++;
    }
  }
  return batches;
}
var pathDividers = {
  clone: function(params) {
    var ret = [];
    var approxOpacity = 1 - Math.pow(1 - params.path.style.opacity, 1 / params.count);
    for (var i = 0; i < params.count; i++) {
      var cloned = clonePath(params.path);
      cloned.setStyle("opacity", approxOpacity);
      ret.push(cloned);
    }
    return ret;
  },
  split: null
};
function applyMorphAnimation(from, to, divideShape, seriesModel, dataIndex, animateOtherProps) {
  if (!from.length || !to.length) {
    return;
  }
  var updateAnimationCfg = getAnimationConfig("update", seriesModel, dataIndex);
  if (!(updateAnimationCfg && updateAnimationCfg.duration > 0)) {
    return;
  }
  var animationDelay = seriesModel.getModel("universalTransition").get("delay");
  var animationCfg = Object.assign({
    setToFinal: true
  }, updateAnimationCfg);
  var many;
  var one;
  if (isMultiple(from)) {
    many = from;
    one = to;
  }
  if (isMultiple(to)) {
    many = to;
    one = from;
  }
  function morphOneBatch(batch, fromIsMany2, animateIndex2, animateCount2, forceManyOne) {
    var batchMany = batch.many;
    var batchOne = batch.one;
    if (batchMany.length === 1 && !forceManyOne) {
      var batchFrom = fromIsMany2 ? batchMany[0] : batchOne;
      var batchTo = fromIsMany2 ? batchOne : batchMany[0];
      if (isCombineMorphing(batchFrom)) {
        morphOneBatch({
          many: [batchFrom],
          one: batchTo
        }, true, animateIndex2, animateCount2, true);
      } else {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(animateIndex2, animateCount2)
        }, animationCfg) : animationCfg;
        morphPath(batchFrom, batchTo, individualAnimationCfg);
        animateOtherProps(batchFrom, batchTo, batchFrom, batchTo, individualAnimationCfg);
      }
    } else {
      var separateAnimationCfg = defaults({
        dividePath: pathDividers[divideShape],
        individualDelay: animationDelay && function(idx, count3, fromPath, toPath) {
          return animationDelay(idx + animateIndex2, animateCount2);
        }
      }, animationCfg);
      var _a2 = fromIsMany2 ? combineMorph(batchMany, batchOne, separateAnimationCfg) : separateMorph(batchOne, batchMany, separateAnimationCfg), fromIndividuals = _a2.fromIndividuals, toIndividuals = _a2.toIndividuals;
      var count2 = fromIndividuals.length;
      for (var k2 = 0; k2 < count2; k2++) {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(k2, count2)
        }, animationCfg) : animationCfg;
        animateOtherProps(fromIndividuals[k2], toIndividuals[k2], fromIsMany2 ? batchMany[k2] : batch.one, fromIsMany2 ? batch.one : batchMany[k2], individualAnimationCfg);
      }
    }
  }
  var fromIsMany = many ? many === from : from.length > to.length;
  var morphBatches = many ? prepareMorphBatches(one, many) : prepareMorphBatches(fromIsMany ? to : from, [fromIsMany ? from : to]);
  var animateCount = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    animateCount += morphBatches[i].many.length;
  }
  var animateIndex = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    morphOneBatch(morphBatches[i], fromIsMany, animateIndex, animateCount);
    animateIndex += morphBatches[i].many.length;
  }
}
function getPathList(elements) {
  if (!elements) {
    return [];
  }
  if (isArray$1(elements)) {
    var pathList_1 = [];
    for (var i = 0; i < elements.length; i++) {
      pathList_1.push(getPathList(elements[i]));
    }
    return pathList_1;
  }
  var pathList = [];
  elements.traverse(function(el) {
    if (el instanceof Path$1 && !el.disableMorphing && !el.invisible && !el.ignore) {
      pathList.push(el);
    }
  });
  return pathList;
}
var DATA_COUNT_THRESHOLD = 1e4;
var getUniversalTransitionGlobalStore = makeInner();
function getGroupIdDimension(data) {
  var dimensions = data.dimensions;
  for (var i = 0; i < dimensions.length; i++) {
    var dimInfo = data.getDimensionInfo(dimensions[i]);
    if (dimInfo && dimInfo.otherDims.itemGroupId === 0) {
      return dimensions[i];
    }
  }
}
function flattenDataDiffItems(list) {
  var items = [];
  each$f(list, function(seriesInfo) {
    var data = seriesInfo.data;
    if (data.count() > DATA_COUNT_THRESHOLD) {
      return;
    }
    var indices = data.getIndices();
    var groupDim = getGroupIdDimension(data);
    for (var dataIndex = 0; dataIndex < indices.length; dataIndex++) {
      items.push({
        data,
        dim: seriesInfo.dim || groupDim,
        divide: seriesInfo.divide,
        dataIndex
      });
    }
  });
  return items;
}
function fadeInElement(newEl2, newSeries, newIndex) {
  newEl2.traverse(function(el) {
    if (el instanceof Path$1) {
      initProps(el, {
        style: {
          opacity: 0
        }
      }, newSeries, {
        dataIndex: newIndex,
        isFrom: true
      });
    }
  });
}
function removeEl(el) {
  if (el.parent) {
    var computedTransform = el.getComputedTransform();
    el.setLocalTransform(computedTransform);
    el.parent.remove(el);
  }
}
function stopAnimation(el) {
  el.stopAnimation();
  if (el.isGroup) {
    el.traverse(function(child) {
      child.stopAnimation();
    });
  }
}
function animateElementStyles(el, dataIndex, seriesModel) {
  var animationConfig = getAnimationConfig("update", seriesModel, dataIndex);
  animationConfig && el.traverse(function(child) {
    if (child instanceof Displayable$1) {
      var oldStyle = getOldStyle(child);
      if (oldStyle) {
        child.animateFrom({
          style: oldStyle
        }, animationConfig);
      }
    }
  });
}
function isAllIdSame(oldDiffItems, newDiffItems) {
  var len2 = oldDiffItems.length;
  if (len2 !== newDiffItems.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    var oldItem = oldDiffItems[i];
    var newItem = newDiffItems[i];
    if (oldItem.data.getId(oldItem.dataIndex) !== newItem.data.getId(newItem.dataIndex)) {
      return false;
    }
  }
  return true;
}
function transitionBetween(oldList, newList, api) {
  var oldDiffItems = flattenDataDiffItems(oldList);
  var newDiffItems = flattenDataDiffItems(newList);
  function updateMorphingPathProps(from, to, rawFrom, rawTo, animationCfg) {
    if (rawFrom || from) {
      to.animateFrom({
        style: rawFrom && rawFrom !== from ? extend(extend({}, rawFrom.style), from.style) : from.style
      }, animationCfg);
    }
  }
  function findKeyDim(items) {
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].dim) {
        return items[i2].dim;
      }
    }
  }
  var oldKeyDim = findKeyDim(oldDiffItems);
  var newKeyDim = findKeyDim(newDiffItems);
  var hasMorphAnimation = false;
  function createKeyGetter(isOld, onlyGetId) {
    return function(diffItem) {
      var data = diffItem.data;
      var dataIndex = diffItem.dataIndex;
      if (onlyGetId) {
        return data.getId(dataIndex);
      }
      var dataGroupId = data.hostModel && data.hostModel.get("dataGroupId");
      var keyDim = isOld ? oldKeyDim || newKeyDim : newKeyDim || oldKeyDim;
      var dimInfo = keyDim && data.getDimensionInfo(keyDim);
      var dimOrdinalMeta = dimInfo && dimInfo.ordinalMeta;
      if (dimInfo) {
        var key = data.get(dimInfo.name, dataIndex);
        if (dimOrdinalMeta) {
          return dimOrdinalMeta.categories[key] || key + "";
        }
        return key + "";
      }
      var itemVal = data.getRawDataItem(dataIndex);
      if (itemVal && itemVal.groupId) {
        return itemVal.groupId + "";
      }
      return dataGroupId || data.getId(dataIndex);
    };
  }
  var useId = isAllIdSame(oldDiffItems, newDiffItems);
  var isElementStillInChart = {};
  if (!useId) {
    for (var i = 0; i < newDiffItems.length; i++) {
      var newItem = newDiffItems[i];
      var el = newItem.data.getItemGraphicEl(newItem.dataIndex);
      if (el) {
        isElementStillInChart[el.id] = true;
      }
    }
  }
  function updateOneToOne(newIndex, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var newItem2 = newDiffItems[newIndex];
    var newSeries = newItem2.data.hostModel;
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    var newEl2 = newItem2.data.getItemGraphicEl(newItem2.dataIndex);
    if (oldEl === newEl2) {
      newEl2 && animateElementStyles(newEl2, newItem2.dataIndex, newSeries);
      return;
    }
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newIndex);
      }
    }
  }
  new DataDiffer$1(oldDiffItems, newDiffItems, createKeyGetter(true, useId), createKeyGetter(false, useId), null, "multiple").update(updateOneToOne).updateManyToOne(function(newIndex, oldIndices) {
    var newItem2 = newDiffItems[newIndex];
    var newData = newItem2.data;
    var newSeries = newData.hostModel;
    var newEl2 = newData.getItemGraphicEl(newItem2.dataIndex);
    var oldElsList = filter(map$1(oldIndices, function(idx) {
      return oldDiffItems[idx].data.getItemGraphicEl(oldDiffItems[idx].dataIndex);
    }), function(oldEl) {
      return oldEl && oldEl !== newEl2 && !isElementStillInChart[oldEl.id];
    });
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldElsList.length) {
        each$f(oldElsList, function(oldEl) {
          stopAnimation(oldEl);
          removeEl(oldEl);
        });
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldElsList), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newItem2.dataIndex);
      }
    }
  }).updateOneToMany(function(newIndices, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    var newElsList = filter(map$1(newIndices, function(idx) {
      return newDiffItems[idx].data.getItemGraphicEl(newDiffItems[idx].dataIndex);
    }), function(el2) {
      return el2 && el2 !== oldEl;
    });
    var newSeris = newDiffItems[newIndices[0]].data.hostModel;
    if (newElsList.length) {
      each$f(newElsList, function(newEl2) {
        return stopAnimation(newEl2);
      });
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newElsList), oldItem.divide, newSeris, newIndices[0], updateMorphingPathProps);
      } else {
        each$f(newElsList, function(newEl2) {
          return fadeInElement(newEl2, newSeris, newIndices[0]);
        });
      }
    }
  }).updateManyToMany(function(newIndices, oldIndices) {
    new DataDiffer$1(oldIndices, newIndices, function(rawIdx) {
      return oldDiffItems[rawIdx].data.getId(oldDiffItems[rawIdx].dataIndex);
    }, function(rawIdx) {
      return newDiffItems[rawIdx].data.getId(newDiffItems[rawIdx].dataIndex);
    }).update(function(newIndex, oldIndex) {
      updateOneToOne(newIndices[newIndex], oldIndices[oldIndex]);
    }).execute();
  }).execute();
  if (hasMorphAnimation) {
    each$f(newList, function(_a2) {
      var data = _a2.data;
      var seriesModel = data.hostModel;
      var view = seriesModel && api.getViewOfSeriesModel(seriesModel);
      var animationCfg = getAnimationConfig("update", seriesModel, 0);
      if (view && seriesModel.isAnimationEnabled() && animationCfg && animationCfg.duration > 0) {
        view.group.traverse(function(el2) {
          if (el2 instanceof Path$1 && !el2.animators.length) {
            el2.animateFrom({
              style: {
                opacity: 0
              }
            }, animationCfg);
          }
        });
      }
    });
  }
}
function getSeriesTransitionKey(series) {
  var seriesKey = series.getModel("universalTransition").get("seriesKey");
  if (!seriesKey) {
    return series.id;
  }
  return seriesKey;
}
function convertArraySeriesKeyToString(seriesKey) {
  if (isArray$1(seriesKey)) {
    return seriesKey.sort().join(",");
  }
  return seriesKey;
}
function getDivideShapeFromData(data) {
  if (data.hostModel) {
    return data.hostModel.getModel("universalTransition").get("divideShape");
  }
}
function findTransitionSeriesBatches(globalStore, params) {
  var updateBatches = createHashMap();
  var oldDataMap = createHashMap();
  var oldDataMapForSplit = createHashMap();
  each$f(globalStore.oldSeries, function(series, idx) {
    var oldData = globalStore.oldData[idx];
    var transitionKey = getSeriesTransitionKey(series);
    var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
    oldDataMap.set(transitionKeyStr, oldData);
    if (isArray$1(transitionKey)) {
      each$f(transitionKey, function(key) {
        oldDataMapForSplit.set(key, {
          data: oldData,
          key: transitionKeyStr
        });
      });
    }
  });
  each$f(params.updatedSeries, function(series) {
    if (series.isUniversalTransitionEnabled() && series.isAnimationEnabled()) {
      var newData = series.getData();
      var transitionKey = getSeriesTransitionKey(series);
      var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
      var oldData = oldDataMap.get(transitionKeyStr);
      if (oldData) {
        updateBatches.set(transitionKeyStr, {
          oldSeries: [{
            divide: getDivideShapeFromData(oldData),
            data: oldData
          }],
          newSeries: [{
            divide: getDivideShapeFromData(newData),
            data: newData
          }]
        });
      } else {
        if (isArray$1(transitionKey)) {
          var oldSeries_1 = [];
          each$f(transitionKey, function(key) {
            var oldData2 = oldDataMap.get(key);
            if (oldData2) {
              oldSeries_1.push({
                divide: getDivideShapeFromData(oldData2),
                data: oldData2
              });
            }
          });
          if (oldSeries_1.length) {
            updateBatches.set(transitionKeyStr, {
              oldSeries: oldSeries_1,
              newSeries: [{
                data: newData,
                divide: getDivideShapeFromData(newData)
              }]
            });
          }
        } else {
          var oldData_1 = oldDataMapForSplit.get(transitionKey);
          if (oldData_1) {
            var batch = updateBatches.get(oldData_1.key);
            if (!batch) {
              batch = {
                oldSeries: [{
                  data: oldData_1.data,
                  divide: getDivideShapeFromData(oldData_1.data)
                }],
                newSeries: []
              };
              updateBatches.set(oldData_1.key, batch);
            }
            batch.newSeries.push({
              data: newData,
              divide: getDivideShapeFromData(newData)
            });
          }
        }
      }
    }
  });
  return updateBatches;
}
function querySeries(series, finder) {
  for (var i = 0; i < series.length; i++) {
    var found = finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id;
    if (found) {
      return i;
    }
  }
}
function transitionSeriesFromOpt(transitionOpt, globalStore, params, api) {
  var from = [];
  var to = [];
  each$f(normalizeToArray(transitionOpt.from), function(finder) {
    var idx = querySeries(globalStore.oldSeries, finder);
    if (idx >= 0) {
      from.push({
        data: globalStore.oldData[idx],
        divide: getDivideShapeFromData(globalStore.oldData[idx]),
        dim: finder.dimension
      });
    }
  });
  each$f(normalizeToArray(transitionOpt.to), function(finder) {
    var idx = querySeries(params.updatedSeries, finder);
    if (idx >= 0) {
      var data = params.updatedSeries[idx].getData();
      to.push({
        data,
        divide: getDivideShapeFromData(data),
        dim: finder.dimension
      });
    }
  });
  if (from.length > 0 && to.length > 0) {
    transitionBetween(from, to, api);
  }
}
function installUniversalTransition(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecMOdel, api, params) {
    each$f(normalizeToArray(params.seriesTransition), function(transOpt) {
      each$f(normalizeToArray(transOpt.to), function(finder) {
        var series = params.updatedSeries;
        for (var i = 0; i < series.length; i++) {
          if (finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id) {
            series[i][SERIES_UNIVERSAL_TRANSITION_PROP] = true;
          }
        }
      });
    });
  });
  registers.registerUpdateLifecycle("series:transition", function(ecModel, api, params) {
    var globalStore = getUniversalTransitionGlobalStore(api);
    if (globalStore.oldSeries && params.updatedSeries && params.optionChanged) {
      var transitionOpt = params.seriesTransition;
      if (transitionOpt) {
        each$f(normalizeToArray(transitionOpt), function(opt) {
          transitionSeriesFromOpt(opt, globalStore, params, api);
        });
      } else {
        var updateBatches_1 = findTransitionSeriesBatches(globalStore, params);
        each$f(updateBatches_1.keys(), function(key) {
          var batch = updateBatches_1.get(key);
          transitionBetween(batch.oldSeries, batch.newSeries, api);
        });
      }
      each$f(params.updatedSeries, function(series) {
        if (series[SERIES_UNIVERSAL_TRANSITION_PROP]) {
          series[SERIES_UNIVERSAL_TRANSITION_PROP] = false;
        }
      });
    }
    var allSeries = ecModel.getSeries();
    var savedSeries = globalStore.oldSeries = [];
    var savedData = globalStore.oldData = [];
    for (var i = 0; i < allSeries.length; i++) {
      var data = allSeries[i].getData();
      if (data.count() < DATA_COUNT_THRESHOLD) {
        savedSeries.push(allSeries[i]);
        savedData.push(data);
      }
    }
  });
}
use([install$R]);
use([install$S]);
use([install$Q, install$P, install$O, install$M, install$K, install$I, install$H, install$G, install$F, install$E, install$D, install$B, install$A, install$z, install$y, install$x, install$w, install$v, install$u, install$t, install$s, install$r]);
use(install$p);
use(install$o);
use(install$J);
use(install$n);
use(install$C);
use(install$m);
use(install$l);
use(install$j);
use(install$i);
use(install$q);
use(install$h);
use(install$g);
use(install$f);
use(install$e);
use(install$d);
use(install$c);
use(install$9);
use(install$6);
use(install$8);
use(install$7);
use(install$3);
use(install$5);
use(install$4);
use(install$2);
use(install$1);
use(install);
use(installUniversalTransition);
use(installLabelLayout);
function useEcharts(options) {
  const {
    defaultOptions
  } = options != null ? options : {};
  const container2 = useRef(null);
  const chart = useRef();
  const optionsRef = useRef(defaultOptions);
  useEffect(() => {
    if (!container2.current) {
      return;
    }
    const myEcharts = init$1(container2.current);
    chart.current = myEcharts;
    if (optionsRef.current) {
      myEcharts.setOption(optionsRef.current);
    }
  }, []);
  useEffect(() => {
    return () => {
      var _a2, _b2, _c2, _d;
      (_b2 = (_a2 = chart.current) == null ? void 0 : _a2.dispose) == null ? void 0 : _b2.call(_a2);
      (_d = (_c2 = chart.current) == null ? void 0 : _c2.off) == null ? void 0 : _d.call(_c2, "*");
      chart.current = void 0;
    };
  }, []);
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a2, _b2;
      (_b2 = (_a2 = chart == null ? void 0 : chart.current) == null ? void 0 : _a2.resize) == null ? void 0 : _b2.call(_a2);
    });
  });
  return {
    chart,
    container: container2
  };
}
class Charts {
  constructor() {
    __publicField(this, "chartsEmitters", /* @__PURE__ */ new Map());
    __publicField(this, "add", (id2, chart, option, title) => {
      if (chart && option) {
        this.chartsEmitters.set(id2, {
          chart,
          option,
          title
        });
      } else {
        console.log("\u6DFB\u52A0\u5931\u8D25");
      }
    });
    __publicField(this, "get", (id2) => {
      return this.chartsEmitters.get(id2);
    });
    __publicField(this, "clear", () => {
      this.chartsEmitters.clear();
    });
    __publicField(this, "delete", (id2) => {
      this.chartsEmitters.delete(id2);
    });
    __publicField(this, "list", () => {
      var _a2, _b2, _c2;
      const list = [];
      for (const key of this.chartsEmitters.keys()) {
        list.push({
          id: key,
          chart: (_a2 = this.chartsEmitters.get(key)) == null ? void 0 : _a2.chart,
          option: (_b2 = this.chartsEmitters.get(key)) == null ? void 0 : _b2.option,
          title: (_c2 = this.chartsEmitters.get(key)) == null ? void 0 : _c2.title
        });
      }
      return list;
    });
  }
}
const _Charts = new Charts();
var lodash = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(module, exports) {
  (function() {
    var undefined$1;
    var VERSION = "4.17.21";
    var LARGE_ARRAY_SIZE = 200;
    var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT2 = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = "__lodash_placeholder__";
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER2 = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN2 = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [
      ["ary", WRAP_ARY_FLAG],
      ["bind", WRAP_BIND_FLAG],
      ["bindKey", WRAP_BIND_KEY_FLAG],
      ["curry", WRAP_CURRY_FLAG],
      ["curryRight", WRAP_CURRY_RIGHT_FLAG],
      ["flip", WRAP_FLIP_FLAG],
      ["partial", WRAP_PARTIAL_FLAG],
      ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
      ["rearg", WRAP_REARG_FLAG]
    ];
    var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag2 = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag2 = "[object Symbol]", undefinedTag2 = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
    var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
    var reTrimStart2 = /^\s+/;
    var reWhitespace2 = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex2 = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary2 = /^0b[01]+$/i;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var reIsOctal2 = /^0o[0-7]+$/i;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reApos = RegExp(rsApos, "g");
    var reComboMark = RegExp(rsCombo, "g");
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ];
    var templateCounter = -1;
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag2] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    };
    var htmlUnescapes = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    };
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    };
    var freeParseFloat = parseFloat, freeParseInt2 = parseInt;
    var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && true && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal2.process;
    var nodeUtil = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array4, setter, iteratee, accumulator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        var value = array4[index2];
        setter(accumulator, value, iteratee(value), array4);
      }
      return accumulator;
    }
    function arrayEach(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (iteratee(array4[index2], index2, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEachRight(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      while (length--) {
        if (iteratee(array4[length], length, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEvery(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (!predicate(array4[index2], index2, array4)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (predicate(value, index2, array4)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array4, value) {
      var length = array4 == null ? 0 : array4.length;
      return !!length && baseIndexOf(array4, value, 0) > -1;
    }
    function arrayIncludesWith(array4, value, comparator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (comparator(value, array4[index2])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, result = Array(length);
      while (++index2 < length) {
        result[index2] = iteratee(array4[index2], index2, array4);
      }
      return result;
    }
    function arrayPush(array4, values) {
      var index2 = -1, length = values.length, offset = array4.length;
      while (++index2 < length) {
        array4[offset + index2] = values[index2];
      }
      return array4;
    }
    function arrayReduce(array4, iteratee, accumulator, initAccum) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[++index2];
      }
      while (++index2 < length) {
        accumulator = iteratee(accumulator, array4[index2], index2, array4);
      }
      return accumulator;
    }
    function arrayReduceRight(array4, iteratee, accumulator, initAccum) {
      var length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array4[length], length, array4);
      }
      return accumulator;
    }
    function arraySome(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty("length");
    function asciiToArray(string3) {
      return string3.split("");
    }
    function asciiWords(string3) {
      return string3.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function(value, key, collection2) {
        if (predicate(value, key, collection2)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array4, predicate, fromIndex, fromRight) {
      var length = array4.length, index2 = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index2-- : ++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIndexOf(array4, value, fromIndex) {
      return value === value ? strictIndexOf(array4, value, fromIndex) : baseFindIndex(array4, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array4, value, fromIndex, comparator) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (comparator(array4[index2], value)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      return length ? baseSum(array4, iteratee) / length : NAN2;
    }
    function baseProperty(key) {
      return function(object4) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function basePropertyOf(object4) {
      return function(key) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function(value, index2, collection2) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index2, collection2);
      });
      return accumulator;
    }
    function baseSortBy(array4, comparer) {
      var length = array4.length;
      array4.sort(comparer);
      while (length--) {
        array4[length] = array4[length].value;
      }
      return array4;
    }
    function baseSum(array4, iteratee) {
      var result, index2 = -1, length = array4.length;
      while (++index2 < length) {
        var current = iteratee(array4[index2]);
        if (current !== undefined$1) {
          result = result === undefined$1 ? current : result + current;
        }
      }
      return result;
    }
    function baseTimes(n2, iteratee) {
      var index2 = -1, result = Array(n2);
      while (++index2 < n2) {
        result[index2] = iteratee(index2);
      }
      return result;
    }
    function baseToPairs(object4, props) {
      return arrayMap(props, function(key) {
        return [key, object4[key]];
      });
    }
    function baseTrim2(string3) {
      return string3 ? string3.slice(0, trimmedEndIndex2(string3) + 1).replace(reTrimStart2, "") : string3;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object4, props) {
      return arrayMap(props, function(key) {
        return object4[key];
      });
    }
    function cacheHas(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index2 = -1, length = strSymbols.length;
      while (++index2 < length && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index2 = strSymbols.length;
      while (index2-- && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function countHolders(array4, placeholder) {
      var length = array4.length, result = 0;
      while (length--) {
        if (array4[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue2(object4, key) {
      return object4 == null ? undefined$1 : object4[key];
    }
    function hasUnicode(string3) {
      return reHasUnicode.test(string3);
    }
    function hasUnicodeWord(string3) {
      return reHasUnicodeWord.test(string3);
    }
    function iteratorToArray(iterator2) {
      var data, result = [];
      while (!(data = iterator2.next()).done) {
        result.push(data.value);
      }
      return result;
    }
    function mapToArray(map2) {
      var index2 = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index2] = [key, value];
      });
      return result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function replaceHolders(array4, placeholder) {
      var index2 = -1, length = array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (value === placeholder || value === PLACEHOLDER) {
          array4[index2] = PLACEHOLDER;
          result[resIndex++] = index2;
        }
      }
      return result;
    }
    function setToArray(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = value;
      });
      return result;
    }
    function setToPairs(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex + 1;
      while (index2--) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return index2;
    }
    function stringSize(string3) {
      return hasUnicode(string3) ? unicodeSize(string3) : asciiSize(string3);
    }
    function stringToArray(string3) {
      return hasUnicode(string3) ? unicodeToArray(string3) : asciiToArray(string3);
    }
    function trimmedEndIndex2(string3) {
      var index2 = string3.length;
      while (index2-- && reWhitespace2.test(string3.charAt(index2))) {
      }
      return index2;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string3) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string3)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string3) {
      return string3.match(reUnicode) || [];
    }
    function unicodeWords(string3) {
      return string3.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext2(context) {
      context = context == null ? root2 : _.defaults(root2.Object(), context, _.pick(root2, contextProps));
      var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
      var arrayProto2 = Array2.prototype, funcProto = Function2.prototype, objectProto2 = Object2.prototype;
      var coreJsData = context["__core-js_shared__"];
      var funcToString = funcProto.toString;
      var hasOwnProperty2 = objectProto2.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey = function() {
        var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var nativeObjectToString2 = objectProto2.toString;
      var objectCtorString = funcToString.call(Object2);
      var oldDash = root2._;
      var reIsNative = RegExp2("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? context.Buffer : undefined$1, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined$1, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto2.propertyIsEnumerable, splice = arrayProto2.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined$1, symIterator = Symbol2 ? Symbol2.iterator : undefined$1, symToStringTag2 = Symbol2 ? Symbol2.toStringTag : undefined$1;
      var defineProperty = function() {
        try {
          var func = getNative(Object2, "defineProperty");
          func({}, "", {});
          return func;
        } catch (e2) {
        }
      }();
      var ctxClearTimeout = context.clearTimeout !== root2.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root2.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root2.setTimeout && context.setTimeout;
      var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto2.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax2 = Math2.max, nativeMin2 = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto2.reverse;
      var DataView2 = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set2 = getNative(context, "Set"), WeakMap3 = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
      var metaMap = WeakMap3 && new WeakMap3();
      var realNames = {};
      var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap3);
      var symbolProto = Symbol2 ? Symbol2.prototype : undefined$1, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined$1, symbolToString = symbolProto ? symbolProto.toString : undefined$1;
      function lodash2(value) {
        if (isObjectLike2(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty2.call(value, "__wrapped__")) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = function() {
        function object4() {
        }
        return function(proto2) {
          if (!isObject2(proto2)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto2);
          }
          object4.prototype = proto2;
          var result2 = new object4();
          object4.prototype = undefined$1;
          return result2;
        };
      }();
      function baseLodash() {
      }
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash2.templateSettings = {
        "escape": reEscape,
        "evaluate": reEvaluate,
        "interpolate": reInterpolate,
        "variable": "",
        "imports": {
          "_": lodash2
        }
      };
      lodash2.prototype = baseLodash.prototype;
      lodash2.prototype.constructor = lodash2;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result2 = new LazyWrapper(this.__wrapped__);
        result2.__actions__ = copyArray(this.__actions__);
        result2.__dir__ = this.__dir__;
        result2.__filtered__ = this.__filtered__;
        result2.__iteratees__ = copyArray(this.__iteratees__);
        result2.__takeCount__ = this.__takeCount__;
        result2.__views__ = copyArray(this.__views__);
        return result2;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result2 = new LazyWrapper(this);
          result2.__dir__ = -1;
          result2.__filtered__ = true;
        } else {
          result2 = this.clone();
          result2.__dir__ *= -1;
        }
        return result2;
      }
      function lazyValue() {
        var array4 = this.__wrapped__.value(), dir3 = this.__dir__, isArr = isArray2(array4), isRight = dir3 < 0, arrLength = isArr ? array4.length : 0, view = getView(0, arrLength, this.__views__), start2 = view.start, end2 = view.end, length = end2 - start2, index2 = isRight ? end2 : start2 - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin2(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array4, this.__actions__);
        }
        var result2 = [];
        outer:
          while (length-- && resIndex < takeCount) {
            index2 += dir3;
            var iterIndex = -1, value = array4[index2];
            while (++iterIndex < iterLength) {
              var data = iteratees[iterIndex], iteratee2 = data.iteratee, type4 = data.type, computed = iteratee2(value);
              if (type4 == LAZY_MAP_FLAG) {
                value = computed;
              } else if (!computed) {
                if (type4 == LAZY_FILTER_FLAG) {
                  continue outer;
                } else {
                  break outer;
                }
              }
            }
            result2[resIndex++] = value;
          }
        return result2;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear() {
        this.__data__ = nativeCreate ? nativeCreate(null) : {};
        this.size = 0;
      }
      function hashDelete(key) {
        var result2 = this.has(key) && delete this.__data__[key];
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function hashGet(key) {
        var data = this.__data__;
        if (nativeCreate) {
          var result2 = data[key];
          return result2 === HASH_UNDEFINED ? undefined$1 : result2;
        }
        return hasOwnProperty2.call(data, key) ? data[key] : undefined$1;
      }
      function hashHas(key) {
        var data = this.__data__;
        return nativeCreate ? data[key] !== undefined$1 : hasOwnProperty2.call(data, key);
      }
      function hashSet(key, value) {
        var data = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data[key] = nativeCreate && value === undefined$1 ? HASH_UNDEFINED : value;
        return this;
      }
      Hash.prototype.clear = hashClear;
      Hash.prototype["delete"] = hashDelete;
      Hash.prototype.get = hashGet;
      Hash.prototype.has = hashHas;
      Hash.prototype.set = hashSet;
      function ListCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index2 == lastIndex) {
          data.pop();
        } else {
          splice.call(data, index2, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet2(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        return index2 < 0 ? undefined$1 : data[index2][1];
      }
      function listCacheHas(key) {
        return assocIndexOf(this.__data__, key) > -1;
      }
      function listCacheSet2(key, value) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          ++this.size;
          data.push([key, value]);
        } else {
          data[index2][1] = value;
        }
        return this;
      }
      ListCache.prototype.clear = listCacheClear;
      ListCache.prototype["delete"] = listCacheDelete;
      ListCache.prototype.get = listCacheGet2;
      ListCache.prototype.has = listCacheHas;
      ListCache.prototype.set = listCacheSet2;
      function MapCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear() {
        this.size = 0;
        this.__data__ = {
          "hash": new Hash(),
          "map": new (Map2 || ListCache)(),
          "string": new Hash()
        };
      }
      function mapCacheDelete(key) {
        var result2 = getMapData(this, key)["delete"](key);
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function mapCacheGet(key) {
        return getMapData(this, key).get(key);
      }
      function mapCacheHas(key) {
        return getMapData(this, key).has(key);
      }
      function mapCacheSet(key, value) {
        var data = getMapData(this, key), size2 = data.size;
        data.set(key, value);
        this.size += data.size == size2 ? 0 : 1;
        return this;
      }
      MapCache.prototype.clear = mapCacheClear;
      MapCache.prototype["delete"] = mapCacheDelete;
      MapCache.prototype.get = mapCacheGet;
      MapCache.prototype.has = mapCacheHas;
      MapCache.prototype.set = mapCacheSet;
      function SetCache(values2) {
        var index2 = -1, length = values2 == null ? 0 : values2.length;
        this.__data__ = new MapCache();
        while (++index2 < length) {
          this.add(values2[index2]);
        }
      }
      function setCacheAdd(value) {
        this.__data__.set(value, HASH_UNDEFINED);
        return this;
      }
      function setCacheHas(value) {
        return this.__data__.has(value);
      }
      SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
      SetCache.prototype.has = setCacheHas;
      function Stack(entries) {
        var data = this.__data__ = new ListCache(entries);
        this.size = data.size;
      }
      function stackClear() {
        this.__data__ = new ListCache();
        this.size = 0;
      }
      function stackDelete(key) {
        var data = this.__data__, result2 = data["delete"](key);
        this.size = data.size;
        return result2;
      }
      function stackGet(key) {
        return this.__data__.get(key);
      }
      function stackHas(key) {
        return this.__data__.has(key);
      }
      function stackSet(key, value) {
        var data = this.__data__;
        if (data instanceof ListCache) {
          var pairs = data.__data__;
          if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
          }
          data = this.__data__ = new MapCache(pairs);
        }
        data.set(key, value);
        this.size = data.size;
        return this;
      }
      Stack.prototype.clear = stackClear;
      Stack.prototype["delete"] = stackDelete;
      Stack.prototype.get = stackGet;
      Stack.prototype.has = stackHas;
      Stack.prototype.set = stackSet;
      function arrayLikeKeys(value, inherited) {
        var isArr = isArray2(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String2) : [], length = result2.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function arraySample(array4) {
        var length = array4.length;
        return length ? array4[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array4, n2) {
        return shuffleSelf(copyArray(array4), baseClamp(n2, 0, array4.length));
      }
      function arrayShuffle(array4) {
        return shuffleSelf(copyArray(array4));
      }
      function assignMergeValue(object4, key, value) {
        if (value !== undefined$1 && !eq(object4[key], value) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assignValue(object4, key, value) {
        var objValue = object4[key];
        if (!(hasOwnProperty2.call(object4, key) && eq(objValue, value)) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assocIndexOf(array4, key) {
        var length = array4.length;
        while (length--) {
          if (eq(array4[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee2, accumulator) {
        baseEach(collection, function(value, key, collection2) {
          setter(accumulator, value, iteratee2(value), collection2);
        });
        return accumulator;
      }
      function baseAssign(object4, source) {
        return object4 && copyObject(source, keys2(source), object4);
      }
      function baseAssignIn(object4, source) {
        return object4 && copyObject(source, keysIn(source), object4);
      }
      function baseAssignValue(object4, key, value) {
        if (key == "__proto__" && defineProperty) {
          defineProperty(object4, key, {
            "configurable": true,
            "enumerable": true,
            "value": value,
            "writable": true
          });
        } else {
          object4[key] = value;
        }
      }
      function baseAt(object4, paths) {
        var index2 = -1, length = paths.length, result2 = Array2(length), skip = object4 == null;
        while (++index2 < length) {
          result2[index2] = skip ? undefined$1 : get2(object4, paths[index2]);
        }
        return result2;
      }
      function baseClamp(number4, lower, upper) {
        if (number4 === number4) {
          if (upper !== undefined$1) {
            number4 = number4 <= upper ? number4 : upper;
          }
          if (lower !== undefined$1) {
            number4 = number4 >= lower ? number4 : lower;
          }
        }
        return number4;
      }
      function baseClone(value, bitmask, customizer, key, object4, stack) {
        var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result2 = object4 ? customizer(value, key, object4, stack) : customizer(value);
        }
        if (result2 !== undefined$1) {
          return result2;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result2 = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result2);
          }
        } else {
          var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
          if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag || tag == argsTag || isFunc && !object4) {
            result2 = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object4 ? value : {};
            }
            result2 = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result2);
        if (isSet(value)) {
          value.forEach(function(subValue) {
            result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function(subValue, key2) {
            result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys2;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
        return result2;
      }
      function baseConforms(source) {
        var props = keys2(source);
        return function(object4) {
          return baseConformsTo(object4, source, props);
        };
      }
      function baseConformsTo(object4, source, props) {
        var length = props.length;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (length--) {
          var key = props[length], predicate = source[key], value = object4[key];
          if (value === undefined$1 && !(key in object4) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return setTimeout2(function() {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array4, values2, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, isCommon = true, length = array4.length, result2 = [], valuesLength = values2.length;
        if (!length) {
          return result2;
        }
        if (iteratee2) {
          values2 = arrayMap(values2, baseUnary(iteratee2));
        }
        if (comparator) {
          includes2 = arrayIncludesWith;
          isCommon = false;
        } else if (values2.length >= LARGE_ARRAY_SIZE) {
          includes2 = cacheHas;
          isCommon = false;
          values2 = new SetCache(values2);
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 == null ? value : iteratee2(value);
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var valuesIndex = valuesLength;
              while (valuesIndex--) {
                if (values2[valuesIndex] === computed) {
                  continue outer;
                }
              }
              result2.push(value);
            } else if (!includes2(values2, computed, comparator)) {
              result2.push(value);
            }
          }
        return result2;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result2 = true;
        baseEach(collection, function(value, index2, collection2) {
          result2 = !!predicate(value, index2, collection2);
          return result2;
        });
        return result2;
      }
      function baseExtremum(array4, iteratee2, comparator) {
        var index2 = -1, length = array4.length;
        while (++index2 < length) {
          var value = array4[index2], current = iteratee2(value);
          if (current != null && (computed === undefined$1 ? current === current && !isSymbol2(current) : comparator(current, computed))) {
            var computed = current, result2 = value;
          }
        }
        return result2;
      }
      function baseFill(array4, value, start2, end2) {
        var length = array4.length;
        start2 = toInteger(start2);
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 === undefined$1 || end2 > length ? length : toInteger(end2);
        if (end2 < 0) {
          end2 += length;
        }
        end2 = start2 > end2 ? 0 : toLength(end2);
        while (start2 < end2) {
          array4[start2++] = value;
        }
        return array4;
      }
      function baseFilter(collection, predicate) {
        var result2 = [];
        baseEach(collection, function(value, index2, collection2) {
          if (predicate(value, index2, collection2)) {
            result2.push(value);
          }
        });
        return result2;
      }
      function baseFlatten(array4, depth, predicate, isStrict, result2) {
        var index2 = -1, length = array4.length;
        predicate || (predicate = isFlattenable);
        result2 || (result2 = []);
        while (++index2 < length) {
          var value = array4[index2];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result2);
            } else {
              arrayPush(result2, value);
            }
          } else if (!isStrict) {
            result2[result2.length] = value;
          }
        }
        return result2;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object4, iteratee2) {
        return object4 && baseFor(object4, iteratee2, keys2);
      }
      function baseForOwnRight(object4, iteratee2) {
        return object4 && baseForRight(object4, iteratee2, keys2);
      }
      function baseFunctions(object4, props) {
        return arrayFilter(props, function(key) {
          return isFunction2(object4[key]);
        });
      }
      function baseGet(object4, path) {
        path = castPath(path, object4);
        var index2 = 0, length = path.length;
        while (object4 != null && index2 < length) {
          object4 = object4[toKey(path[index2++])];
        }
        return index2 && index2 == length ? object4 : undefined$1;
      }
      function baseGetAllKeys(object4, keysFunc, symbolsFunc) {
        var result2 = keysFunc(object4);
        return isArray2(object4) ? result2 : arrayPush(result2, symbolsFunc(object4));
      }
      function baseGetTag2(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag2 : nullTag2;
        }
        return symToStringTag2 && symToStringTag2 in Object2(value) ? getRawTag2(value) : objectToString2(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object4, key) {
        return object4 != null && hasOwnProperty2.call(object4, key);
      }
      function baseHasIn(object4, key) {
        return object4 != null && key in Object2(object4);
      }
      function baseInRange(number4, start2, end2) {
        return number4 >= nativeMin2(start2, end2) && number4 < nativeMax2(start2, end2);
      }
      function baseIntersection(arrays, iteratee2, comparator) {
        var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
        while (othIndex--) {
          var array4 = arrays[othIndex];
          if (othIndex && iteratee2) {
            array4 = arrayMap(array4, baseUnary(iteratee2));
          }
          maxLength = nativeMin2(array4.length, maxLength);
          caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array4.length >= 120) ? new SetCache(othIndex && array4) : undefined$1;
        }
        array4 = arrays[0];
        var index2 = -1, seen = caches[0];
        outer:
          while (++index2 < length && result2.length < maxLength) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (!(seen ? cacheHas(seen, computed) : includes2(result2, computed, comparator))) {
              othIndex = othLength;
              while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                  continue outer;
                }
              }
              if (seen) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseInverter(object4, setter, iteratee2, accumulator) {
        baseForOwn(object4, function(value, key, object5) {
          setter(accumulator, iteratee2(value), key, object5);
        });
        return accumulator;
      }
      function baseInvoke(object4, path, args) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        var func = object4 == null ? object4 : object4[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object4, args);
      }
      function baseIsArguments(value) {
        return isObjectLike2(value) && baseGetTag2(value) == argsTag;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike2(value) && baseGetTag2(value) == arrayBufferTag;
      }
      function baseIsDate(value) {
        return isObjectLike2(value) && baseGetTag2(value) == dateTag;
      }
      function baseIsEqual(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike2(value) && !isObjectLike2(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
      }
      function baseIsEqualDeep(object4, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray2(object4), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag : getTag(object4), othTag = othIsArr ? arrayTag : getTag(other);
        objTag = objTag == argsTag ? objectTag : objTag;
        othTag = othTag == argsTag ? objectTag : othTag;
        var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer(object4)) {
          if (!isBuffer(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack());
          return objIsArr || isTypedArray2(object4) ? equalArrays(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag(object4, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
          var objIsWrapped = objIsObj && hasOwnProperty2.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack());
        return equalObjects(object4, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike2(value) && getTag(value) == mapTag;
      }
      function baseIsMatch(object4, source, matchData, customizer) {
        var index2 = matchData.length, length = index2, noCustomizer = !customizer;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (index2--) {
          var data = matchData[index2];
          if (noCustomizer && data[2] ? data[1] !== object4[data[0]] : !(data[0] in object4)) {
            return false;
          }
        }
        while (++index2 < length) {
          data = matchData[index2];
          var key = data[0], objValue = object4[key], srcValue = data[1];
          if (noCustomizer && data[2]) {
            if (objValue === undefined$1 && !(key in object4)) {
              return false;
            }
          } else {
            var stack = new Stack();
            if (customizer) {
              var result2 = customizer(objValue, srcValue, key, object4, source, stack);
            }
            if (!(result2 === undefined$1 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative(value) {
        if (!isObject2(value) || isMasked(value)) {
          return false;
        }
        var pattern4 = isFunction2(value) ? reIsNative : reIsHostCtor;
        return pattern4.test(toSource(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike2(value) && baseGetTag2(value) == regexpTag;
      }
      function baseIsSet(value) {
        return isObjectLike2(value) && getTag(value) == setTag;
      }
      function baseIsTypedArray(value) {
        return isObjectLike2(value) && isLength(value.length) && !!typedArrayTags[baseGetTag2(value)];
      }
      function baseIteratee(value) {
        if (typeof value == "function") {
          return value;
        }
        if (value == null) {
          return identity2;
        }
        if (typeof value == "object") {
          return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys(object4) {
        if (!isPrototype(object4)) {
          return nativeKeys(object4);
        }
        var result2 = [];
        for (var key in Object2(object4)) {
          if (hasOwnProperty2.call(object4, key) && key != "constructor") {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseKeysIn(object4) {
        if (!isObject2(object4)) {
          return nativeKeysIn(object4);
        }
        var isProto = isPrototype(object4), result2 = [];
        for (var key in object4) {
          if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object4, key)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee2) {
        var index2 = -1, result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value, key, collection2) {
          result2[++index2] = iteratee2(value, key, collection2);
        });
        return result2;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function(object4) {
          return object4 === source || baseIsMatch(object4, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function(object4) {
          var objValue = get2(object4, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object4, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
        };
      }
      function baseMerge(object4, source, srcIndex, customizer, stack) {
        if (object4 === source) {
          return;
        }
        baseFor(source, function(srcValue, key) {
          stack || (stack = new Stack());
          if (isObject2(srcValue)) {
            baseMergeDeep(object4, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object4, key), srcValue, key + "", object4, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object4, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object4, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object4, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object4, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + "", object4, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray2(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray2(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
            newValue = objValue;
            if (isArguments(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject2(objValue) || isFunction2(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack["delete"](srcValue);
        }
        assignMergeValue(object4, key, newValue);
      }
      function baseNth(array4, n2) {
        var length = array4.length;
        if (!length) {
          return;
        }
        n2 += n2 < 0 ? length : 0;
        return isIndex(n2, length) ? array4[n2] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function(iteratee2) {
            if (isArray2(iteratee2)) {
              return function(value) {
                return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
              };
            }
            return iteratee2;
          });
        } else {
          iteratees = [identity2];
        }
        var index2 = -1;
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        var result2 = baseMap(collection, function(value, key, collection2) {
          var criteria = arrayMap(iteratees, function(iteratee2) {
            return iteratee2(value);
          });
          return { "criteria": criteria, "index": ++index2, "value": value };
        });
        return baseSortBy(result2, function(object4, other) {
          return compareMultiple(object4, other, orders);
        });
      }
      function basePick(object4, paths) {
        return basePickBy(object4, paths, function(value, path) {
          return hasIn(object4, path);
        });
      }
      function basePickBy(object4, paths, predicate) {
        var index2 = -1, length = paths.length, result2 = {};
        while (++index2 < length) {
          var path = paths[index2], value = baseGet(object4, path);
          if (predicate(value, path)) {
            baseSet(result2, castPath(path, object4), value);
          }
        }
        return result2;
      }
      function basePropertyDeep(path) {
        return function(object4) {
          return baseGet(object4, path);
        };
      }
      function basePullAll(array4, values2, iteratee2, comparator) {
        var indexOf3 = comparator ? baseIndexOfWith : baseIndexOf, index2 = -1, length = values2.length, seen = array4;
        if (array4 === values2) {
          values2 = copyArray(values2);
        }
        if (iteratee2) {
          seen = arrayMap(array4, baseUnary(iteratee2));
        }
        while (++index2 < length) {
          var fromIndex = 0, value = values2[index2], computed = iteratee2 ? iteratee2(value) : value;
          while ((fromIndex = indexOf3(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array4) {
              splice.call(seen, fromIndex, 1);
            }
            splice.call(array4, fromIndex, 1);
          }
        }
        return array4;
      }
      function basePullAt(array4, indexes) {
        var length = array4 ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index2 = indexes[length];
          if (length == lastIndex || index2 !== previous) {
            var previous = index2;
            if (isIndex(index2)) {
              splice.call(array4, index2, 1);
            } else {
              baseUnset(array4, index2);
            }
          }
        }
        return array4;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start2, end2, step, fromRight) {
        var index2 = -1, length = nativeMax2(nativeCeil((end2 - start2) / (step || 1)), 0), result2 = Array2(length);
        while (length--) {
          result2[fromRight ? length : ++index2] = start2;
          start2 += step;
        }
        return result2;
      }
      function baseRepeat(string3, n2) {
        var result2 = "";
        if (!string3 || n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return result2;
        }
        do {
          if (n2 % 2) {
            result2 += string3;
          }
          n2 = nativeFloor(n2 / 2);
          if (n2) {
            string3 += string3;
          }
        } while (n2);
        return result2;
      }
      function baseRest(func, start2) {
        return setToString(overRest(func, start2, identity2), func + "");
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n2) {
        var array4 = values(collection);
        return shuffleSelf(array4, baseClamp(n2, 0, array4.length));
      }
      function baseSet(object4, path, value, customizer) {
        if (!isObject2(object4)) {
          return object4;
        }
        path = castPath(path, object4);
        var index2 = -1, length = path.length, lastIndex = length - 1, nested = object4;
        while (nested != null && ++index2 < length) {
          var key = toKey(path[index2]), newValue = value;
          if (key === "__proto__" || key === "constructor" || key === "prototype") {
            return object4;
          }
          if (index2 != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject2(objValue) ? objValue : isIndex(path[index2 + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object4;
      }
      var baseSetData = !metaMap ? identity2 : function(func, data) {
        metaMap.set(func, data);
        return func;
      };
      var baseSetToString = !defineProperty ? identity2 : function(func, string3) {
        return defineProperty(func, "toString", {
          "configurable": true,
          "enumerable": false,
          "value": constant(string3),
          "writable": true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array4, start2, end2) {
        var index2 = -1, length = array4.length;
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 > length ? length : end2;
        if (end2 < 0) {
          end2 += length;
        }
        length = start2 > end2 ? 0 : end2 - start2 >>> 0;
        start2 >>>= 0;
        var result2 = Array2(length);
        while (++index2 < length) {
          result2[index2] = array4[index2 + start2];
        }
        return result2;
      }
      function baseSome(collection, predicate) {
        var result2;
        baseEach(collection, function(value, index2, collection2) {
          result2 = predicate(value, index2, collection2);
          return !result2;
        });
        return !!result2;
      }
      function baseSortedIndex(array4, value, retHighest) {
        var low = 0, high = array4 == null ? low : array4.length;
        if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array4[mid];
            if (computed !== null && !isSymbol2(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array4, value, identity2, retHighest);
      }
      function baseSortedIndexBy(array4, value, iteratee2, retHighest) {
        var low = 0, high = array4 == null ? 0 : array4.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee2(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol2(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee2(array4[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol2(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin2(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array4, iteratee2) {
        var index2 = -1, length = array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
          if (!index2 || !eq(computed, seen)) {
            var seen = computed;
            result2[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result2;
      }
      function baseToNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == "string") {
          return value;
        }
        if (isArray2(value)) {
          return arrayMap(value, baseToString) + "";
        }
        if (isSymbol2(value)) {
          return symbolToString ? symbolToString.call(value) : "";
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function baseUniq(array4, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, length = array4.length, isCommon = true, result2 = [], seen = result2;
        if (comparator) {
          isCommon = false;
          includes2 = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE) {
          var set3 = iteratee2 ? null : createSet(array4);
          if (set3) {
            return setToArray(set3);
          }
          isCommon = false;
          includes2 = cacheHas;
          seen = new SetCache();
        } else {
          seen = iteratee2 ? [] : result2;
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var seenIndex = seen.length;
              while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                  continue outer;
                }
              }
              if (iteratee2) {
                seen.push(computed);
              }
              result2.push(value);
            } else if (!includes2(seen, computed, comparator)) {
              if (seen !== result2) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseUnset(object4, path) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        return object4 == null || delete object4[toKey(last(path))];
      }
      function baseUpdate(object4, path, updater, customizer) {
        return baseSet(object4, path, updater(baseGet(object4, path)), customizer);
      }
      function baseWhile(array4, predicate, isDrop, fromRight) {
        var length = array4.length, index2 = fromRight ? length : -1;
        while ((fromRight ? index2-- : ++index2 < length) && predicate(array4[index2], index2, array4)) {
        }
        return isDrop ? baseSlice(array4, fromRight ? 0 : index2, fromRight ? index2 + 1 : length) : baseSlice(array4, fromRight ? index2 + 1 : 0, fromRight ? length : index2);
      }
      function baseWrapperValue(value, actions2) {
        var result2 = value;
        if (result2 instanceof LazyWrapper) {
          result2 = result2.value();
        }
        return arrayReduce(actions2, function(result3, action) {
          return action.func.apply(action.thisArg, arrayPush([result3], action.args));
        }, result2);
      }
      function baseXor(arrays, iteratee2, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index2 = -1, result2 = Array2(length);
        while (++index2 < length) {
          var array4 = arrays[index2], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index2) {
              result2[index2] = baseDifference(result2[index2] || array4, arrays[othIndex], iteratee2, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
      }
      function baseZipObject(props, values2, assignFunc) {
        var index2 = -1, length = props.length, valsLength = values2.length, result2 = {};
        while (++index2 < length) {
          var value = index2 < valsLength ? values2[index2] : undefined$1;
          assignFunc(result2, props[index2], value);
        }
        return result2;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == "function" ? value : identity2;
      }
      function castPath(value, object4) {
        if (isArray2(value)) {
          return value;
        }
        return isKey(value, object4) ? [value] : stringToPath(toString(value));
      }
      var castRest = baseRest;
      function castSlice(array4, start2, end2) {
        var length = array4.length;
        end2 = end2 === undefined$1 ? length : end2;
        return !start2 && end2 >= length ? array4 : baseSlice(array4, start2, end2);
      }
      var clearTimeout2 = ctxClearTimeout || function(id2) {
        return root2.clearTimeout(id2);
      };
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result2);
        return result2;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
        return result2;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp4) {
        var result2 = new regexp4.constructor(regexp4.source, reFlags.exec(regexp4));
        result2.lastIndex = regexp4.lastIndex;
        return result2;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol2(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol2(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object4, other, orders) {
        var index2 = -1, objCriteria = object4.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index2 < length) {
          var result2 = compareAscending(objCriteria[index2], othCriteria[index2]);
          if (result2) {
            if (index2 >= ordersLength) {
              return result2;
            }
            var order = orders[index2];
            return result2 * (order == "desc" ? -1 : 1);
          }
        }
        return object4.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result2[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result2[leftIndex++] = args[argsIndex++];
        }
        return result2;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result2[argsIndex] = args[argsIndex];
        }
        var offset = argsIndex;
        while (++rightIndex < rightLength) {
          result2[offset + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[offset + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result2;
      }
      function copyArray(source, array4) {
        var index2 = -1, length = source.length;
        array4 || (array4 = Array2(length));
        while (++index2 < length) {
          array4[index2] = source[index2];
        }
        return array4;
      }
      function copyObject(source, props, object4, customizer) {
        var isNew = !object4;
        object4 || (object4 = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object4[key], source[key], key, object4, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object4, key, newValue);
          } else {
            assignValue(object4, key, newValue);
          }
        }
        return object4;
      }
      function copySymbols(source, object4) {
        return copyObject(source, getSymbols(source), object4);
      }
      function copySymbolsIn(source, object4) {
        return copyObject(source, getSymbolsIn(source), object4);
      }
      function createAggregator(setter, initializer) {
        return function(collection, iteratee2) {
          var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function(object4, sources) {
          var index2 = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object4 = Object2(object4);
          while (++index2 < length) {
            var source = sources[index2];
            if (source) {
              assigner(object4, source, index2, customizer);
            }
          }
          return object4;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function(collection, iteratee2) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike2(collection)) {
            return eachFunc(collection, iteratee2);
          }
          var length = collection.length, index2 = fromRight ? length : -1, iterable = Object2(collection);
          while (fromRight ? index2-- : ++index2 < length) {
            if (iteratee2(iterable[index2], index2, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function(object4, iteratee2, keysFunc) {
          var index2 = -1, iterable = Object2(object4), props = keysFunc(object4), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index2];
            if (iteratee2(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object4;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function(string3) {
          string3 = toString(string3);
          var strSymbols = hasUnicode(string3) ? stringToArray(string3) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string3.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function(string3) {
          return arrayReduce(words(deburr(string3).replace(reApos, "")), callback, "");
        };
      }
      function createCtor(Ctor) {
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
          return isObject2(result2) ? result2 : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length, placeholder = getHolder(wrapper);
          while (index2--) {
            args[index2] = arguments[index2];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function(collection, predicate, fromIndex) {
          var iterable = Object2(collection);
          if (!isArrayLike2(collection)) {
            var iteratee2 = getIteratee(predicate, 3);
            collection = keys2(collection);
            predicate = function(key) {
              return iteratee2(iterable[key], key, iterable);
            };
          }
          var index2 = findIndexFunc(collection, predicate, fromIndex);
          return index2 > -1 ? iterable[iteratee2 ? collection[index2] : index2] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function(funcs) {
          var length = funcs.length, index2 = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index2--) {
            var func = funcs[index2];
            if (typeof func != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT2);
            }
            if (prereq && !wrapper && getFuncName(func) == "wrapper") {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index2 = wrapper ? index2 : length;
          while (++index2 < length) {
            func = funcs[index2];
            var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined$1;
            if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
              wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function() {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray2(value)) {
              return wrapper.plant(value).value();
            }
            var index3 = 0, result2 = length ? funcs[index3].apply(this, args) : value;
            while (++index3 < length) {
              result2 = funcs[index3].call(this, result2);
            }
            return result2;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length;
          while (index2--) {
            args[index2] = arguments[index2];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary2 < length) {
            args.length = ary2;
          }
          if (this && this !== root2 && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function(object4, iteratee2) {
          return baseInverter(object4, setter, toIteratee(iteratee2), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function(value, other) {
          var result2;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result2 = value;
          }
          if (other !== undefined$1) {
            if (result2 === undefined$1) {
              return other;
            }
            if (typeof value == "string" || typeof other == "string") {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result2 = operator(value, other);
          }
          return result2;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function(iteratees) {
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          return baseRest(function(args) {
            var thisArg = this;
            return arrayFunc(iteratees, function(iteratee2) {
              return apply(iteratee2, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? " " : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function(start2, end2, step) {
          if (step && typeof step != "number" && isIterateeCall(start2, end2, step)) {
            end2 = step = undefined$1;
          }
          start2 = toFinite(start2);
          if (end2 === undefined$1) {
            end2 = start2;
            start2 = 0;
          } else {
            end2 = toFinite(end2);
          }
          step = step === undefined$1 ? start2 < end2 ? 1 : -1 : toFinite(step);
          return baseRange(start2, end2, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function(value, other) {
          if (!(typeof value == "string" && typeof other == "string")) {
            value = toNumber2(value);
            other = toNumber2(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [
          func,
          bitmask,
          thisArg,
          newPartials,
          newHolders,
          newPartialsRight,
          newHoldersRight,
          argPos,
          ary2,
          arity
        ];
        var result2 = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result2, newData);
        }
        result2.placeholder = placeholder;
        return setWrapToString(result2, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math2[methodName];
        return function(number4, precision) {
          number4 = toNumber2(number4);
          precision = precision == null ? 0 : nativeMin2(toInteger(precision), 292);
          if (precision && nativeIsFinite(number4)) {
            var pair = (toString(number4) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
            pair = (toString(value) + "e").split("e");
            return +(pair[0] + "e" + (+pair[1] - precision));
          }
          return func(number4);
        };
      }
      var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
        return new Set2(values2);
      };
      function createToPairs(keysFunc) {
        return function(object4) {
          var tag = getTag(object4);
          if (tag == mapTag) {
            return mapToArray(object4);
          }
          if (tag == setTag) {
            return setToPairs(object4);
          }
          return baseToPairs(object4, keysFunc(object4));
        };
      }
      function createWrap2(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary2 = ary2 === undefined$1 ? ary2 : nativeMax2(toInteger(ary2), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data = isBindKey ? undefined$1 : getData(func);
        var newData = [
          func,
          bitmask,
          thisArg,
          partials,
          holders,
          partialsRight,
          holdersRight,
          argPos,
          ary2,
          arity
        ];
        if (data) {
          mergeData(newData, data);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax2(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result2 = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result2 = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result2 = createPartial(func, bitmask, thisArg, partials);
        } else {
          result2 = createHybrid.apply(undefined$1, newData);
        }
        var setter = data ? baseSetData : setData;
        return setWrapToString(setter(result2, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object4) {
        if (objValue === undefined$1 || eq(objValue, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object4, source, stack) {
        if (isObject2(objValue) && isObject2(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack["delete"](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays(array4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array4.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array4);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array4;
        }
        var index2 = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined$1;
        stack.set(array4, other);
        stack.set(other, array4);
        while (++index2 < arrLength) {
          var arrValue = array4[index2], othValue = other[index2];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result2 = false;
            break;
          }
          if (seen) {
            if (!arraySome(other, function(othValue2, othIndex) {
              if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result2 = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result2 = false;
            break;
          }
        }
        stack["delete"](array4);
        stack["delete"](other);
        return result2;
      }
      function equalByTag(object4, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag:
            if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
              return false;
            }
            object4 = object4.buffer;
            other = other.buffer;
          case arrayBufferTag:
            if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object4), new Uint8Array2(other))) {
              return false;
            }
            return true;
          case boolTag:
          case dateTag:
          case numberTag:
            return eq(+object4, +other);
          case errorTag:
            return object4.name == other.name && object4.message == other.message;
          case regexpTag:
          case stringTag:
            return object4 == other + "";
          case mapTag:
            var convert = mapToArray;
          case setTag:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
            convert || (convert = setToArray);
            if (object4.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object4);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG;
            stack.set(object4, other);
            var result2 = equalArrays(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
            stack["delete"](object4);
            return result2;
          case symbolTag2:
            if (symbolValueOf) {
              return symbolValueOf.call(object4) == symbolValueOf.call(other);
            }
        }
        return false;
      }
      function equalObjects(object4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object4), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index2 = objLength;
        while (index2--) {
          var key = objProps[index2];
          if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object4);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object4;
        }
        var result2 = true;
        stack.set(object4, other);
        stack.set(other, object4);
        var skipCtor = isPartial;
        while (++index2 < objLength) {
          key = objProps[index2];
          var objValue = object4[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result2 = false;
            break;
          }
          skipCtor || (skipCtor = key == "constructor");
        }
        if (result2 && !skipCtor) {
          var objCtor = object4.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
            result2 = false;
          }
        }
        stack["delete"](object4);
        stack["delete"](other);
        return result2;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + "");
      }
      function getAllKeys(object4) {
        return baseGetAllKeys(object4, keys2, getSymbols);
      }
      function getAllKeysIn(object4) {
        return baseGetAllKeys(object4, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop2 : function(func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result2 = func.name + "", array4 = realNames[result2], length = hasOwnProperty2.call(realNames, result2) ? array4.length : 0;
        while (length--) {
          var data = array4[length], otherFunc = data.func;
          if (otherFunc == null || otherFunc == func) {
            return data.name;
          }
        }
        return result2;
      }
      function getHolder(func) {
        var object4 = hasOwnProperty2.call(lodash2, "placeholder") ? lodash2 : func;
        return object4.placeholder;
      }
      function getIteratee() {
        var result2 = lodash2.iteratee || iteratee;
        result2 = result2 === iteratee ? baseIteratee : result2;
        return arguments.length ? result2(arguments[0], arguments[1]) : result2;
      }
      function getMapData(map3, key) {
        var data = map3.__data__;
        return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
      }
      function getMatchData(object4) {
        var result2 = keys2(object4), length = result2.length;
        while (length--) {
          var key = result2[length], value = object4[key];
          result2[length] = [key, value, isStrictComparable(value)];
        }
        return result2;
      }
      function getNative(object4, key) {
        var value = getValue2(object4, key);
        return baseIsNative(value) ? value : undefined$1;
      }
      function getRawTag2(value) {
        var isOwn = hasOwnProperty2.call(value, symToStringTag2), tag = value[symToStringTag2];
        try {
          value[symToStringTag2] = undefined$1;
          var unmasked = true;
        } catch (e2) {
        }
        var result2 = nativeObjectToString2.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag2] = tag;
          } else {
            delete value[symToStringTag2];
          }
        }
        return result2;
      }
      var getSymbols = !nativeGetSymbols ? stubArray : function(object4) {
        if (object4 == null) {
          return [];
        }
        object4 = Object2(object4);
        return arrayFilter(nativeGetSymbols(object4), function(symbol) {
          return propertyIsEnumerable.call(object4, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object4) {
        var result2 = [];
        while (object4) {
          arrayPush(result2, getSymbols(object4));
          object4 = getPrototype(object4);
        }
        return result2;
      };
      var getTag = baseGetTag2;
      if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap3 && getTag(new WeakMap3()) != weakMapTag) {
        getTag = function(value) {
          var result2 = baseGetTag2(value), Ctor = result2 == objectTag ? value.constructor : undefined$1, ctorString = Ctor ? toSource(Ctor) : "";
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString:
                return dataViewTag;
              case mapCtorString:
                return mapTag;
              case promiseCtorString:
                return promiseTag;
              case setCtorString:
                return setTag;
              case weakMapCtorString:
                return weakMapTag;
            }
          }
          return result2;
        };
      }
      function getView(start2, end2, transforms) {
        var index2 = -1, length = transforms.length;
        while (++index2 < length) {
          var data = transforms[index2], size2 = data.size;
          switch (data.type) {
            case "drop":
              start2 += size2;
              break;
            case "dropRight":
              end2 -= size2;
              break;
            case "take":
              end2 = nativeMin2(end2, start2 + size2);
              break;
            case "takeRight":
              start2 = nativeMax2(start2, end2 - size2);
              break;
          }
        }
        return { "start": start2, "end": end2 };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object4, path, hasFunc) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length, result2 = false;
        while (++index2 < length) {
          var key = toKey(path[index2]);
          if (!(result2 = object4 != null && hasFunc(object4, key))) {
            break;
          }
          object4 = object4[key];
        }
        if (result2 || ++index2 != length) {
          return result2;
        }
        length = object4 == null ? 0 : object4.length;
        return !!length && isLength(length) && isIndex(key, length) && (isArray2(object4) || isArguments(object4));
      }
      function initCloneArray(array4) {
        var length = array4.length, result2 = new array4.constructor(length);
        if (length && typeof array4[0] == "string" && hasOwnProperty2.call(array4, "index")) {
          result2.index = array4.index;
          result2.input = array4.input;
        }
        return result2;
      }
      function initCloneObject(object4) {
        return typeof object4.constructor == "function" && !isPrototype(object4) ? baseCreate(getPrototype(object4)) : {};
      }
      function initCloneByTag(object4, tag, isDeep) {
        var Ctor = object4.constructor;
        switch (tag) {
          case arrayBufferTag:
            return cloneArrayBuffer(object4);
          case boolTag:
          case dateTag:
            return new Ctor(+object4);
          case dataViewTag:
            return cloneDataView(object4, isDeep);
          case float32Tag:
          case float64Tag:
          case int8Tag:
          case int16Tag:
          case int32Tag:
          case uint8Tag:
          case uint8ClampedTag:
          case uint16Tag:
          case uint32Tag:
            return cloneTypedArray(object4, isDeep);
          case mapTag:
            return new Ctor();
          case numberTag:
          case stringTag:
            return new Ctor(object4);
          case regexpTag:
            return cloneRegExp(object4);
          case setTag:
            return new Ctor();
          case symbolTag2:
            return cloneSymbol(object4);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
        details = details.join(length > 2 ? ", " : " ");
        return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
      }
      function isFlattenable(value) {
        return isArray2(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex(value, length) {
        var type4 = typeof value;
        length = length == null ? MAX_SAFE_INTEGER2 : length;
        return !!length && (type4 == "number" || type4 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index2, object4) {
        if (!isObject2(object4)) {
          return false;
        }
        var type4 = typeof index2;
        if (type4 == "number" ? isArrayLike2(object4) && isIndex(index2, object4.length) : type4 == "string" && index2 in object4) {
          return eq(object4[index2], value);
        }
        return false;
      }
      function isKey(value, object4) {
        if (isArray2(value)) {
          return false;
        }
        var type4 = typeof value;
        if (type4 == "number" || type4 == "symbol" || type4 == "boolean" || value == null || isSymbol2(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object4 != null && value in Object2(object4);
      }
      function isKeyable(value) {
        var type4 = typeof value;
        return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash2[funcName];
        if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data = getData(other);
        return !!data && func === data[0];
      }
      function isMasked(func) {
        return !!maskSrcKey && maskSrcKey in func;
      }
      var isMaskable = coreJsData ? isFunction2 : stubFalse;
      function isPrototype(value) {
        var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto2;
        return value === proto2;
      }
      function isStrictComparable(value) {
        return value === value && !isObject2(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function(object4) {
          if (object4 == null) {
            return false;
          }
          return object4[key] === srcValue && (srcValue !== undefined$1 || key in Object2(object4));
        };
      }
      function memoizeCapped(func) {
        var result2 = memoize(func, function(key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result2.cache;
        return result2;
      }
      function mergeData(data, source) {
        var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data[3];
          data[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data[5];
          data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data[8] = data[8] == null ? source[8] : nativeMin2(data[8], source[8]);
        }
        if (data[9] == null) {
          data[9] = source[9];
        }
        data[0] = source[0];
        data[1] = newBitmask;
        return data;
      }
      function nativeKeysIn(object4) {
        var result2 = [];
        if (object4 != null) {
          for (var key in Object2(object4)) {
            result2.push(key);
          }
        }
        return result2;
      }
      function objectToString2(value) {
        return nativeObjectToString2.call(value);
      }
      function overRest(func, start2, transform3) {
        start2 = nativeMax2(start2 === undefined$1 ? func.length - 1 : start2, 0);
        return function() {
          var args = arguments, index2 = -1, length = nativeMax2(args.length - start2, 0), array4 = Array2(length);
          while (++index2 < length) {
            array4[index2] = args[start2 + index2];
          }
          index2 = -1;
          var otherArgs = Array2(start2 + 1);
          while (++index2 < start2) {
            otherArgs[index2] = args[index2];
          }
          otherArgs[start2] = transform3(array4);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object4, path) {
        return path.length < 2 ? object4 : baseGet(object4, baseSlice(path, 0, -1));
      }
      function reorder(array4, indexes) {
        var arrLength = array4.length, length = nativeMin2(indexes.length, arrLength), oldArray = copyArray(array4);
        while (length--) {
          var index2 = indexes[length];
          array4[length] = isIndex(index2, arrLength) ? oldArray[index2] : undefined$1;
        }
        return array4;
      }
      function safeGet(object4, key) {
        if (key === "constructor" && typeof object4[key] === "function") {
          return;
        }
        if (key == "__proto__") {
          return;
        }
        return object4[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout2 = ctxSetTimeout || function(func, wait) {
        return root2.setTimeout(func, wait);
      };
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + "";
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count2 = 0, lastCalled = 0;
        return function() {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count2 >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count2 = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array4, size2) {
        var index2 = -1, length = array4.length, lastIndex = length - 1;
        size2 = size2 === undefined$1 ? length : size2;
        while (++index2 < size2) {
          var rand = baseRandom(index2, lastIndex), value = array4[rand];
          array4[rand] = array4[index2];
          array4[index2] = value;
        }
        array4.length = size2;
        return array4;
      }
      var stringToPath = memoizeCapped(function(string3) {
        var result2 = [];
        if (string3.charCodeAt(0) === 46) {
          result2.push("");
        }
        string3.replace(rePropName, function(match, number4, quote, subString) {
          result2.push(quote ? subString.replace(reEscapeChar, "$1") : number4 || match);
        });
        return result2;
      });
      function toKey(value) {
        if (typeof value == "string" || isSymbol2(value)) {
          return value;
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function toSource(func) {
        if (func != null) {
          try {
            return funcToString.call(func);
          } catch (e2) {
          }
          try {
            return func + "";
          } catch (e2) {
          }
        }
        return "";
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function(pair) {
          var value = "_." + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result2.__actions__ = copyArray(wrapper.__actions__);
        result2.__index__ = wrapper.__index__;
        result2.__values__ = wrapper.__values__;
        return result2;
      }
      function chunk(array4, size2, guard) {
        if (guard ? isIterateeCall(array4, size2, guard) : size2 === undefined$1) {
          size2 = 1;
        } else {
          size2 = nativeMax2(toInteger(size2), 0);
        }
        var length = array4 == null ? 0 : array4.length;
        if (!length || size2 < 1) {
          return [];
        }
        var index2 = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
        while (index2 < length) {
          result2[resIndex++] = baseSlice(array4, index2, index2 += size2);
        }
        return result2;
      }
      function compact(array4) {
        var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2];
          if (value) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array2(length - 1), array4 = arguments[0], index2 = length;
        while (index2--) {
          args[index2 - 1] = arguments[index2];
        }
        return arrayPush(isArray2(array4) ? copyArray(array4) : [array4], baseFlatten(args, 1));
      }
      var difference = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function(array4, values2) {
        var iteratee2 = last(values2);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
      });
      var differenceWith = baseRest(function(array4, values2) {
        var comparator = last(values2);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function dropRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function dropRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true) : [];
      }
      function fill(array4, value, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (start2 && typeof start2 != "number" && isIterateeCall(array4, value, start2)) {
          start2 = 0;
          end2 = length;
        }
        return baseFill(array4, value, start2, end2);
      }
      function findIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2);
      }
      function findLastIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length - 1;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = fromIndex < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2, true);
      }
      function flatten(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, 1) : [];
      }
      function flattenDeep(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, INFINITY) : [];
      }
      function flattenDepth(array4, depth) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array4, depth);
      }
      function fromPairs(pairs) {
        var index2 = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
        while (++index2 < length) {
          var pair = pairs[index2];
          result2[pair[0]] = pair[1];
        }
        return result2;
      }
      function head(array4) {
        return array4 && array4.length ? array4[0] : undefined$1;
      }
      function indexOf2(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseIndexOf(array4, value, index2);
      }
      function initial(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 0, -1) : [];
      }
      var intersection = baseRest(function(arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee2 === last(mapped)) {
          iteratee2 = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
      });
      var intersectionWith = baseRest(function(arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array4, separator) {
        return array4 == null ? "" : nativeJoin.call(array4, separator);
      }
      function last(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? array4[length - 1] : undefined$1;
      }
      function lastIndexOf(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = index2 < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return value === value ? strictLastIndexOf(array4, value, index2) : baseFindIndex(array4, baseIsNaN, index2, true);
      }
      function nth(array4, n2) {
        return array4 && array4.length ? baseNth(array4, toInteger(n2)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array4, values2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2) : array4;
      }
      function pullAllBy(array4, values2, iteratee2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, getIteratee(iteratee2, 2)) : array4;
      }
      function pullAllWith(array4, values2, comparator) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, undefined$1, comparator) : array4;
      }
      var pullAt = flatRest(function(array4, indexes) {
        var length = array4 == null ? 0 : array4.length, result2 = baseAt(array4, indexes);
        basePullAt(array4, arrayMap(indexes, function(index2) {
          return isIndex(index2, length) ? +index2 : index2;
        }).sort(compareAscending));
        return result2;
      });
      function remove(array4, predicate) {
        var result2 = [];
        if (!(array4 && array4.length)) {
          return result2;
        }
        var index2 = -1, indexes = [], length = array4.length;
        predicate = getIteratee(predicate, 3);
        while (++index2 < length) {
          var value = array4[index2];
          if (predicate(value, index2, array4)) {
            result2.push(value);
            indexes.push(index2);
          }
        }
        basePullAt(array4, indexes);
        return result2;
      }
      function reverse2(array4) {
        return array4 == null ? array4 : nativeReverse.call(array4);
      }
      function slice2(array4, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (end2 && typeof end2 != "number" && isIterateeCall(array4, start2, end2)) {
          start2 = 0;
          end2 = length;
        } else {
          start2 = start2 == null ? 0 : toInteger(start2);
          end2 = end2 === undefined$1 ? length : toInteger(end2);
        }
        return baseSlice(array4, start2, end2);
      }
      function sortedIndex(array4, value) {
        return baseSortedIndex(array4, value);
      }
      function sortedIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2));
      }
      function sortedIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value);
          if (index2 < length && eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedLastIndex(array4, value) {
        return baseSortedIndex(array4, value, true);
      }
      function sortedLastIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2), true);
      }
      function sortedLastIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value, true) - 1;
          if (eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedUniq(array4) {
        return array4 && array4.length ? baseSortedUniq(array4) : [];
      }
      function sortedUniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseSortedUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function tail(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 1, length) : [];
      }
      function take2(array4, n2, guard) {
        if (!(array4 && array4.length)) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function takeRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function takeRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function(arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
      });
      var unionWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array4) {
        return array4 && array4.length ? baseUniq(array4) : [];
      }
      function uniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function uniqWith(array4, comparator) {
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return array4 && array4.length ? baseUniq(array4, undefined$1, comparator) : [];
      }
      function unzip(array4) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var length = 0;
        array4 = arrayFilter(array4, function(group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax2(group.length, length);
            return true;
          }
        });
        return baseTimes(length, function(index2) {
          return arrayMap(array4, baseProperty(index2));
        });
      }
      function unzipWith(array4, iteratee2) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var result2 = unzip(array4);
        if (iteratee2 == null) {
          return result2;
        }
        return arrayMap(result2, function(group) {
          return apply(iteratee2, undefined$1, group);
        });
      }
      var without = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, values2) : [];
      });
      var xor = baseRest(function(arrays) {
        return baseXor(arrayFilter(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
      });
      var xorWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values2) {
        return baseZipObject(props || [], values2 || [], assignValue);
      }
      function zipObjectDeep(props, values2) {
        return baseZipObject(props || [], values2 || [], baseSet);
      }
      var zipWith = baseRest(function(arrays) {
        var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined$1;
        return unzipWith(arrays, iteratee2);
      });
      function chain(value) {
        var result2 = lodash2(value);
        result2.__chain__ = true;
        return result2;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function(paths) {
        var length = paths.length, start2 = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object4) {
          return baseAt(object4, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start2)) {
          return this.thru(interceptor);
        }
        value = value.slice(start2, +start2 + (length ? 1 : 0));
        value.__actions__.push({
          "func": thru,
          "args": [interceptor],
          "thisArg": undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function(array4) {
          if (length && !array4.length) {
            array4.push(undefined$1);
          }
          return array4;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray2(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return { "done": done, "value": value };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result2, parent2 = this;
        while (parent2 instanceof baseLodash) {
          var clone3 = wrapperClone(parent2);
          clone3.__index__ = 0;
          clone3.__values__ = undefined$1;
          if (result2) {
            previous.__wrapped__ = clone3;
          } else {
            result2 = clone3;
          }
          var previous = clone3;
          parent2 = parent2.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result2;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            "func": thru,
            "args": [reverse2],
            "thisArg": undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse2);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          ++result2[key];
        } else {
          baseAssignValue(result2, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray2(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter2(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find2 = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), 1);
      }
      function flatMapDeep(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), INFINITY);
      }
      function flatMapDepth(collection, iteratee2, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map2(collection, iteratee2), depth);
      }
      function forEach(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function forEachRight(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee2, 3));
      }
      var groupBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          result2[key].push(value);
        } else {
          baseAssignValue(result2, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike2(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax2(length + fromIndex, 0);
        }
        return isString2(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function(collection, path, args) {
        var index2 = -1, isFunc = typeof path == "function", result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value) {
          result2[++index2] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result2;
      });
      var keyBy = createAggregator(function(result2, value, key) {
        baseAssignValue(result2, key, value);
      });
      function map2(collection, iteratee2) {
        var func = isArray2(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray2(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray2(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function(result2, value, key) {
        result2[key ? 0 : 1].push(value);
      }, function() {
        return [[], []];
      });
      function reduce2(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray2(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n2, guard) {
        if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n2);
      }
      function shuffle(collection) {
        var func = isArray2(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike2(collection)) {
          return isString2(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag(collection);
        if (tag == mapTag || tag == setTag) {
          return collection.size;
        }
        return baseKeys(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray2(collection) ? arraySome : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function(collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now2 = ctxNow || function() {
        return root2.Date.now();
      };
      function after(n2, func) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n2, guard) {
        n2 = guard ? undefined$1 : n2;
        n2 = func && n2 == null ? func.length : n2;
        return createWrap2(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n2);
      }
      function before(n2, func) {
        var result2;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 > 0) {
            result2 = func.apply(this, arguments);
          }
          if (n2 <= 1) {
            func = undefined$1;
          }
          return result2;
        };
      }
      var bind2 = baseRest(function(func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind2));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function(object4, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(key, bitmask, object4, partials, holders);
      });
      function curry2(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curry2.placeholder;
        return result2;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curryRight.placeholder;
        return result2;
      }
      function debounce2(func, wait, options) {
        var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        wait = toNumber2(wait) || 0;
        if (isObject2(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax2(toNumber2(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result2 = func.apply(thisArg, args);
          return result2;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout2(timerExpired, wait);
          return leading ? invokeFunc(time) : result2;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin2(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now2();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout2(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result2;
        }
        function cancel2() {
          if (timerId !== undefined$1) {
            clearTimeout2(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result2 : trailingEdge(now2());
        }
        function debounced() {
          var time = now2(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout2(timerId);
              timerId = setTimeout2(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout2(timerExpired, wait);
          }
          return result2;
        }
        debounced.cancel = cancel2;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function(func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function(func, wait, args) {
        return baseDelay(func, toNumber2(wait) || 0, args);
      });
      function flip(func) {
        return createWrap2(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != "function" || resolver != null && typeof resolver != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var memoized = function() {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result2 = func.apply(this, args);
          memoized.cache = cache.set(key, result2) || cache;
          return result2;
        };
        memoized.cache = new (memoize.Cache || MapCache)();
        return memoized;
      }
      memoize.Cache = MapCache;
      function negate(predicate) {
        if (typeof predicate != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function(func, transforms) {
        transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function(args) {
          var index2 = -1, length = nativeMin2(args.length, funcsLength);
          while (++index2 < length) {
            args[index2] = transforms[index2].call(this, args[index2]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap2(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap2(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function(func, indexes) {
        return createWrap2(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 === undefined$1 ? start2 : toInteger(start2);
        return baseRest(func, start2);
      }
      function spread(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 == null ? 0 : nativeMax2(toInteger(start2), 0);
        return baseRest(function(args) {
          var array4 = args[start2], otherArgs = castSlice(args, 0, start2);
          if (array4) {
            arrayPush(otherArgs, array4);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        if (isObject2(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce2(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray2(value) ? value : [value];
      }
      function clone2(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object4, source) {
        return source == null || baseConformsTo(object4, source, keys2(source));
      }
      function eq(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function(value, other) {
        return value >= other;
      });
      var isArguments = baseIsArguments(function() {
        return arguments;
      }()) ? baseIsArguments : function(value) {
        return isObjectLike2(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
      };
      var isArray2 = Array2.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike2(value) {
        return value != null && isLength(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike2(value) && isArrayLike2(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike2(value) && baseGetTag2(value) == boolTag;
      }
      var isBuffer = nativeIsBuffer || stubFalse;
      var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike2(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike2(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray2(value) || isArguments(value))) {
          return !value.length;
        }
        var tag = getTag(value);
        if (tag == mapTag || tag == setTag) {
          return !value.size;
        }
        if (isPrototype(value)) {
          return !baseKeys(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty2.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual(value, other) {
        return baseIsEqual(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        var result2 = customizer ? customizer(value, other) : undefined$1;
        return result2 === undefined$1 ? baseIsEqual(value, other, undefined$1, customizer) : !!result2;
      }
      function isError(value) {
        if (!isObjectLike2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
      }
      function isFinite2(value) {
        return typeof value == "number" && nativeIsFinite(value);
      }
      function isFunction2(value) {
        if (!isObject2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
      }
      function isInteger(value) {
        return typeof value == "number" && value == toInteger(value);
      }
      function isLength(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
      }
      function isObject2(value) {
        var type4 = typeof value;
        return value != null && (type4 == "object" || type4 == "function");
      }
      function isObjectLike2(value) {
        return value != null && typeof value == "object";
      }
      var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
      function isMatch(object4, source) {
        return object4 === source || baseIsMatch(object4, source, getMatchData(source));
      }
      function isMatchWith(object4, source, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseIsMatch(object4, source, getMatchData(source), customizer);
      }
      function isNaN2(value) {
        return isNumber2(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error2(CORE_ERROR_TEXT);
        }
        return baseIsNative(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber2(value) {
        return typeof value == "number" || isObjectLike2(value) && baseGetTag2(value) == numberTag;
      }
      function isPlainObject(value) {
        if (!isObjectLike2(value) || baseGetTag2(value) != objectTag) {
          return false;
        }
        var proto2 = getPrototype(value);
        if (proto2 === null) {
          return true;
        }
        var Ctor = hasOwnProperty2.call(proto2, "constructor") && proto2.constructor;
        return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
      }
      var isRegExp2 = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER2 && value <= MAX_SAFE_INTEGER2;
      }
      var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
      function isString2(value) {
        return typeof value == "string" || !isArray2(value) && isObjectLike2(value) && baseGetTag2(value) == stringTag;
      }
      function isSymbol2(value) {
        return typeof value == "symbol" || isObjectLike2(value) && baseGetTag2(value) == symbolTag2;
      }
      var isTypedArray2 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike2(value) && getTag(value) == weakMapTag;
      }
      function isWeakSet(value) {
        return isObjectLike2(value) && baseGetTag2(value) == weakSetTag;
      }
      var lt2 = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function(value, other) {
        return value <= other;
      });
      function toArray2(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike2(value)) {
          return isString2(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber2(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result2 = toFinite(value), remainder = result2 % 1;
        return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber2(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        if (isObject2(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject2(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim2(value);
        var isBinary = reIsBinary2.test(value);
        return isBinary || reIsOctal2.test(value) ? freeParseInt2(value.slice(2), isBinary ? 2 : 8) : reIsBadHex2.test(value) ? NAN2 : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER2, MAX_SAFE_INTEGER2) : value === 0 ? value : 0;
      }
      function toString(value) {
        return value == null ? "" : baseToString(value);
      }
      var assign = createAssigner(function(object4, source) {
        if (isPrototype(source) || isArrayLike2(source)) {
          copyObject(source, keys2(source), object4);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty2.call(source, key)) {
            assignValue(object4, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function(object4, source) {
        copyObject(source, keysIn(source), object4);
      });
      var assignInWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object4, customizer);
      });
      var assignWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keys2(source), object4, customizer);
      });
      var at = flatRest(baseAt);
      function create2(prototype, properties) {
        var result2 = baseCreate(prototype);
        return properties == null ? result2 : baseAssign(result2, properties);
      }
      var defaults2 = baseRest(function(object4, sources) {
        object4 = Object2(object4);
        var index2 = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index2 < length) {
          var source = sources[index2];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object4[key];
            if (value === undefined$1 || eq(value, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
              object4[key] = source[key];
            }
          }
        }
        return object4;
      });
      var defaultsDeep = baseRest(function(args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object4, iteratee2) {
        return object4 == null ? object4 : baseFor(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forInRight(object4, iteratee2) {
        return object4 == null ? object4 : baseForRight(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forOwn(object4, iteratee2) {
        return object4 && baseForOwn(object4, getIteratee(iteratee2, 3));
      }
      function forOwnRight(object4, iteratee2) {
        return object4 && baseForOwnRight(object4, getIteratee(iteratee2, 3));
      }
      function functions(object4) {
        return object4 == null ? [] : baseFunctions(object4, keys2(object4));
      }
      function functionsIn(object4) {
        return object4 == null ? [] : baseFunctions(object4, keysIn(object4));
      }
      function get2(object4, path, defaultValue) {
        var result2 = object4 == null ? undefined$1 : baseGet(object4, path);
        return result2 === undefined$1 ? defaultValue : result2;
      }
      function has2(object4, path) {
        return object4 != null && hasPath(object4, path, baseHas);
      }
      function hasIn(object4, path) {
        return object4 != null && hasPath(object4, path, baseHasIn);
      }
      var invert2 = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        result2[value] = key;
      }, constant(identity2));
      var invertBy = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        if (hasOwnProperty2.call(result2, value)) {
          result2[value].push(key);
        } else {
          result2[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys2(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4) : baseKeys(object4);
      }
      function keysIn(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4, true) : baseKeysIn(object4);
      }
      function mapKeys(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, iteratee2(value, key, object5), value);
        });
        return result2;
      }
      function mapValues(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, key, iteratee2(value, key, object5));
        });
        return result2;
      }
      var merge2 = createAssigner(function(object4, source, srcIndex) {
        baseMerge(object4, source, srcIndex);
      });
      var mergeWith = createAssigner(function(object4, source, srcIndex, customizer) {
        baseMerge(object4, source, srcIndex, customizer);
      });
      var omit = flatRest(function(object4, paths) {
        var result2 = {};
        if (object4 == null) {
          return result2;
        }
        var isDeep = false;
        paths = arrayMap(paths, function(path) {
          path = castPath(path, object4);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object4, getAllKeysIn(object4), result2);
        if (isDeep) {
          result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result2, paths[length]);
        }
        return result2;
      });
      function omitBy(object4, predicate) {
        return pickBy(object4, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function(object4, paths) {
        return object4 == null ? {} : basePick(object4, paths);
      });
      function pickBy(object4, predicate) {
        if (object4 == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object4), function(prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object4, props, function(value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object4, path, defaultValue) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length;
        if (!length) {
          length = 1;
          object4 = undefined$1;
        }
        while (++index2 < length) {
          var value = object4 == null ? undefined$1 : object4[toKey(path[index2])];
          if (value === undefined$1) {
            index2 = length;
            value = defaultValue;
          }
          object4 = isFunction2(value) ? value.call(object4) : value;
        }
        return object4;
      }
      function set2(object4, path, value) {
        return object4 == null ? object4 : baseSet(object4, path, value);
      }
      function setWith(object4, path, value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseSet(object4, path, value, customizer);
      }
      var toPairs = createToPairs(keys2);
      var toPairsIn = createToPairs(keysIn);
      function transform2(object4, iteratee2, accumulator) {
        var isArr = isArray2(object4), isArrLike = isArr || isBuffer(object4) || isTypedArray2(object4);
        iteratee2 = getIteratee(iteratee2, 4);
        if (accumulator == null) {
          var Ctor = object4 && object4.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject2(object4)) {
            accumulator = isFunction2(Ctor) ? baseCreate(getPrototype(object4)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object4, function(value, index2, object5) {
          return iteratee2(accumulator, value, index2, object5);
        });
        return accumulator;
      }
      function unset(object4, path) {
        return object4 == null ? true : baseUnset(object4, path);
      }
      function update(object4, path, updater) {
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater));
      }
      function updateWith(object4, path, updater, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater), customizer);
      }
      function values(object4) {
        return object4 == null ? [] : baseValues(object4, keys2(object4));
      }
      function valuesIn(object4) {
        return object4 == null ? [] : baseValues(object4, keysIn(object4));
      }
      function clamp2(number4, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber2(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber2(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber2(number4), lower, upper);
      }
      function inRange(number4, start2, end2) {
        start2 = toFinite(start2);
        if (end2 === undefined$1) {
          end2 = start2;
          start2 = 0;
        } else {
          end2 = toFinite(end2);
        }
        number4 = toNumber2(number4);
        return baseInRange(number4, start2, end2);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == "boolean") {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == "boolean") {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin2(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function(result2, word, index2) {
        word = word.toLowerCase();
        return result2 + (index2 ? capitalize(word) : word);
      });
      function capitalize(string3) {
        return upperFirst(toString(string3).toLowerCase());
      }
      function deburr(string3) {
        string3 = toString(string3);
        return string3 && string3.replace(reLatin, deburrLetter).replace(reComboMark, "");
      }
      function endsWith(string3, target, position2) {
        string3 = toString(string3);
        target = baseToString(target);
        var length = string3.length;
        position2 = position2 === undefined$1 ? length : baseClamp(toInteger(position2), 0, length);
        var end2 = position2;
        position2 -= target.length;
        return position2 >= 0 && string3.slice(position2, end2) == target;
      }
      function escape(string3) {
        string3 = toString(string3);
        return string3 && reHasUnescapedHtml.test(string3) ? string3.replace(reUnescapedHtml, escapeHtmlChar) : string3;
      }
      function escapeRegExp(string3) {
        string3 = toString(string3);
        return string3 && reHasRegExpChar.test(string3) ? string3.replace(reRegExpChar, "\\$&") : string3;
      }
      var kebabCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "-" : "") + word.toLowerCase();
      });
      var lowerCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst("toLowerCase");
      function pad3(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        if (!length || strLength >= length) {
          return string3;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string3 + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? string3 + createPadding(length - strLength, chars) : string3;
      }
      function padStart(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string3 : string3;
      }
      function parseInt2(string3, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString(string3).replace(reTrimStart2, ""), radix || 0);
      }
      function repeat(string3, n2, guard) {
        if (guard ? isIterateeCall(string3, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        return baseRepeat(toString(string3), n2);
      }
      function replace() {
        var args = arguments, string3 = toString(args[0]);
        return args.length < 3 ? string3 : string3.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "_" : "") + word.toLowerCase();
      });
      function split2(string3, separator, limit) {
        if (limit && typeof limit != "number" && isIterateeCall(string3, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string3 = toString(string3);
        if (string3 && (typeof separator == "string" || separator != null && !isRegExp2(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string3)) {
            return castSlice(stringToArray(string3), 0, limit);
          }
        }
        return string3.split(separator, limit);
      }
      var startCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + upperFirst(word);
      });
      function startsWith(string3, target, position2) {
        string3 = toString(string3);
        position2 = position2 == null ? 0 : baseClamp(toInteger(position2), 0, string3.length);
        target = baseToString(target);
        return string3.slice(position2, position2 + target.length) == target;
      }
      function template(string3, options, guard) {
        var settings = lodash2.templateSettings;
        if (guard && isIterateeCall(string3, options, guard)) {
          options = undefined$1;
        }
        string3 = toString(string3);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys2(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index2 = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
        var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
        string3.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string3.slice(index2, offset).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index2 = offset + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty2.call(options, "variable") && options.variable;
        if (!variable) {
          source = "with (obj) {\n" + source + "\n}\n";
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
        source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
        var result2 = attempt(function() {
          return Function2(importsKeys, sourceURL + "return " + source).apply(undefined$1, importsValues);
        });
        result2.source = source;
        if (isError(result2)) {
          throw result2;
        }
        return result2;
      }
      function toLower(value) {
        return toString(value).toLowerCase();
      }
      function toUpper(value) {
        return toString(value).toUpperCase();
      }
      function trim2(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return baseTrim2(string3);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), chrSymbols = stringToArray(chars), start2 = charsStartIndex(strSymbols, chrSymbols), end2 = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start2, end2).join("");
      }
      function trimEnd(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.slice(0, trimmedEndIndex2(string3) + 1);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), end2 = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end2).join("");
      }
      function trimStart(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.replace(reTrimStart2, "");
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), start2 = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start2).join("");
      }
      function truncate(string3, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject2(options)) {
          var separator = "separator" in options ? options.separator : separator;
          length = "length" in options ? toInteger(options.length) : length;
          omission = "omission" in options ? baseToString(options.omission) : omission;
        }
        string3 = toString(string3);
        var strLength = string3.length;
        if (hasUnicode(string3)) {
          var strSymbols = stringToArray(string3);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string3;
        }
        var end2 = length - stringSize(omission);
        if (end2 < 1) {
          return omission;
        }
        var result2 = strSymbols ? castSlice(strSymbols, 0, end2).join("") : string3.slice(0, end2);
        if (separator === undefined$1) {
          return result2 + omission;
        }
        if (strSymbols) {
          end2 += result2.length - end2;
        }
        if (isRegExp2(separator)) {
          if (string3.slice(end2).search(separator)) {
            var match, substring = result2;
            if (!separator.global) {
              separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result2 = result2.slice(0, newEnd === undefined$1 ? end2 : newEnd);
          }
        } else if (string3.indexOf(baseToString(separator), end2) != end2) {
          var index2 = result2.lastIndexOf(separator);
          if (index2 > -1) {
            result2 = result2.slice(0, index2);
          }
        }
        return result2 + omission;
      }
      function unescape2(string3) {
        string3 = toString(string3);
        return string3 && reHasEscapedHtml.test(string3) ? string3.replace(reEscapedHtml, unescapeHtmlChar) : string3;
      }
      var upperCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toUpperCase();
      });
      var upperFirst = createCaseFirst("toUpperCase");
      function words(string3, pattern4, guard) {
        string3 = toString(string3);
        pattern4 = guard ? undefined$1 : pattern4;
        if (pattern4 === undefined$1) {
          return hasUnicodeWord(string3) ? unicodeWords(string3) : asciiWords(string3);
        }
        return string3.match(pattern4) || [];
      }
      var attempt = baseRest(function(func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e2) {
          return isError(e2) ? e2 : new Error2(e2);
        }
      });
      var bindAll = flatRest(function(object4, methodNames) {
        arrayEach(methodNames, function(key) {
          key = toKey(key);
          baseAssignValue(object4, key, bind2(object4[key], object4));
        });
        return object4;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function(pair) {
          if (typeof pair[1] != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT2);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function(args) {
          var index2 = -1;
          while (++index2 < length) {
            var pair = pairs[index2];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function() {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity2(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method4 = baseRest(function(path, args) {
        return function(object4) {
          return baseInvoke(object4, path, args);
        };
      });
      var methodOf = baseRest(function(object4, args) {
        return function(path) {
          return baseInvoke(object4, path, args);
        };
      });
      function mixin2(object4, source, options) {
        var props = keys2(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object4;
          object4 = this;
          methodNames = baseFunctions(source, keys2(source));
        }
        var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction2(object4);
        arrayEach(methodNames, function(methodName) {
          var func = source[methodName];
          object4[methodName] = func;
          if (isFunc) {
            object4.prototype[methodName] = function() {
              var chainAll = this.__chain__;
              if (chain2 || chainAll) {
                var result2 = object4(this.__wrapped__), actions2 = result2.__actions__ = copyArray(this.__actions__);
                actions2.push({ "func": func, "args": arguments, "thisArg": object4 });
                result2.__chain__ = chainAll;
                return result2;
              }
              return func.apply(object4, arrayPush([this.value()], arguments));
            };
          }
        });
        return object4;
      }
      function noConflict() {
        if (root2._ === this) {
          root2._ = oldDash;
        }
        return this;
      }
      function noop2() {
      }
      function nthArg(n2) {
        n2 = toInteger(n2);
        return baseRest(function(args) {
          return baseNth(args, n2);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object4) {
        return function(path) {
          return object4 == null ? undefined$1 : baseGet(object4, path);
        };
      }
      var range3 = createRange();
      var rangeRight = createRange(true);
      function stubArray() {
        return [];
      }
      function stubFalse() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return "";
      }
      function stubTrue() {
        return true;
      }
      function times(n2, iteratee2) {
        n2 = toInteger(n2);
        if (n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return [];
        }
        var index2 = MAX_ARRAY_LENGTH, length = nativeMin2(n2, MAX_ARRAY_LENGTH);
        iteratee2 = getIteratee(iteratee2);
        n2 -= MAX_ARRAY_LENGTH;
        var result2 = baseTimes(length, iteratee2);
        while (++index2 < n2) {
          iteratee2(index2);
        }
        return result2;
      }
      function toPath(value) {
        if (isArray2(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol2(value) ? [value] : copyArray(stringToPath(toString(value)));
      }
      function uniqueId(prefix) {
        var id2 = ++idCounter;
        return toString(prefix) + id2;
      }
      var add2 = createMathOperation(function(augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound("ceil");
      var divide = createMathOperation(function(dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound("floor");
      function max3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseGt) : undefined$1;
      }
      function maxBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseGt) : undefined$1;
      }
      function mean(array4) {
        return baseMean(array4, identity2);
      }
      function meanBy(array4, iteratee2) {
        return baseMean(array4, getIteratee(iteratee2, 2));
      }
      function min3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseLt) : undefined$1;
      }
      function minBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function(multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round2 = createRound("round");
      var subtract = createMathOperation(function(minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum2(array4) {
        return array4 && array4.length ? baseSum(array4, identity2) : 0;
      }
      function sumBy(array4, iteratee2) {
        return array4 && array4.length ? baseSum(array4, getIteratee(iteratee2, 2)) : 0;
      }
      lodash2.after = after;
      lodash2.ary = ary;
      lodash2.assign = assign;
      lodash2.assignIn = assignIn;
      lodash2.assignInWith = assignInWith;
      lodash2.assignWith = assignWith;
      lodash2.at = at;
      lodash2.before = before;
      lodash2.bind = bind2;
      lodash2.bindAll = bindAll;
      lodash2.bindKey = bindKey;
      lodash2.castArray = castArray;
      lodash2.chain = chain;
      lodash2.chunk = chunk;
      lodash2.compact = compact;
      lodash2.concat = concat;
      lodash2.cond = cond;
      lodash2.conforms = conforms;
      lodash2.constant = constant;
      lodash2.countBy = countBy;
      lodash2.create = create2;
      lodash2.curry = curry2;
      lodash2.curryRight = curryRight;
      lodash2.debounce = debounce2;
      lodash2.defaults = defaults2;
      lodash2.defaultsDeep = defaultsDeep;
      lodash2.defer = defer;
      lodash2.delay = delay;
      lodash2.difference = difference;
      lodash2.differenceBy = differenceBy;
      lodash2.differenceWith = differenceWith;
      lodash2.drop = drop;
      lodash2.dropRight = dropRight;
      lodash2.dropRightWhile = dropRightWhile;
      lodash2.dropWhile = dropWhile;
      lodash2.fill = fill;
      lodash2.filter = filter2;
      lodash2.flatMap = flatMap;
      lodash2.flatMapDeep = flatMapDeep;
      lodash2.flatMapDepth = flatMapDepth;
      lodash2.flatten = flatten;
      lodash2.flattenDeep = flattenDeep;
      lodash2.flattenDepth = flattenDepth;
      lodash2.flip = flip;
      lodash2.flow = flow;
      lodash2.flowRight = flowRight;
      lodash2.fromPairs = fromPairs;
      lodash2.functions = functions;
      lodash2.functionsIn = functionsIn;
      lodash2.groupBy = groupBy;
      lodash2.initial = initial;
      lodash2.intersection = intersection;
      lodash2.intersectionBy = intersectionBy;
      lodash2.intersectionWith = intersectionWith;
      lodash2.invert = invert2;
      lodash2.invertBy = invertBy;
      lodash2.invokeMap = invokeMap;
      lodash2.iteratee = iteratee;
      lodash2.keyBy = keyBy;
      lodash2.keys = keys2;
      lodash2.keysIn = keysIn;
      lodash2.map = map2;
      lodash2.mapKeys = mapKeys;
      lodash2.mapValues = mapValues;
      lodash2.matches = matches;
      lodash2.matchesProperty = matchesProperty;
      lodash2.memoize = memoize;
      lodash2.merge = merge2;
      lodash2.mergeWith = mergeWith;
      lodash2.method = method4;
      lodash2.methodOf = methodOf;
      lodash2.mixin = mixin2;
      lodash2.negate = negate;
      lodash2.nthArg = nthArg;
      lodash2.omit = omit;
      lodash2.omitBy = omitBy;
      lodash2.once = once;
      lodash2.orderBy = orderBy;
      lodash2.over = over;
      lodash2.overArgs = overArgs;
      lodash2.overEvery = overEvery;
      lodash2.overSome = overSome;
      lodash2.partial = partial;
      lodash2.partialRight = partialRight;
      lodash2.partition = partition;
      lodash2.pick = pick;
      lodash2.pickBy = pickBy;
      lodash2.property = property;
      lodash2.propertyOf = propertyOf;
      lodash2.pull = pull;
      lodash2.pullAll = pullAll;
      lodash2.pullAllBy = pullAllBy;
      lodash2.pullAllWith = pullAllWith;
      lodash2.pullAt = pullAt;
      lodash2.range = range3;
      lodash2.rangeRight = rangeRight;
      lodash2.rearg = rearg;
      lodash2.reject = reject;
      lodash2.remove = remove;
      lodash2.rest = rest;
      lodash2.reverse = reverse2;
      lodash2.sampleSize = sampleSize;
      lodash2.set = set2;
      lodash2.setWith = setWith;
      lodash2.shuffle = shuffle;
      lodash2.slice = slice2;
      lodash2.sortBy = sortBy;
      lodash2.sortedUniq = sortedUniq;
      lodash2.sortedUniqBy = sortedUniqBy;
      lodash2.split = split2;
      lodash2.spread = spread;
      lodash2.tail = tail;
      lodash2.take = take2;
      lodash2.takeRight = takeRight;
      lodash2.takeRightWhile = takeRightWhile;
      lodash2.takeWhile = takeWhile;
      lodash2.tap = tap;
      lodash2.throttle = throttle2;
      lodash2.thru = thru;
      lodash2.toArray = toArray2;
      lodash2.toPairs = toPairs;
      lodash2.toPairsIn = toPairsIn;
      lodash2.toPath = toPath;
      lodash2.toPlainObject = toPlainObject;
      lodash2.transform = transform2;
      lodash2.unary = unary;
      lodash2.union = union;
      lodash2.unionBy = unionBy;
      lodash2.unionWith = unionWith;
      lodash2.uniq = uniq;
      lodash2.uniqBy = uniqBy;
      lodash2.uniqWith = uniqWith;
      lodash2.unset = unset;
      lodash2.unzip = unzip;
      lodash2.unzipWith = unzipWith;
      lodash2.update = update;
      lodash2.updateWith = updateWith;
      lodash2.values = values;
      lodash2.valuesIn = valuesIn;
      lodash2.without = without;
      lodash2.words = words;
      lodash2.wrap = wrap;
      lodash2.xor = xor;
      lodash2.xorBy = xorBy;
      lodash2.xorWith = xorWith;
      lodash2.zip = zip;
      lodash2.zipObject = zipObject;
      lodash2.zipObjectDeep = zipObjectDeep;
      lodash2.zipWith = zipWith;
      lodash2.entries = toPairs;
      lodash2.entriesIn = toPairsIn;
      lodash2.extend = assignIn;
      lodash2.extendWith = assignInWith;
      mixin2(lodash2, lodash2);
      lodash2.add = add2;
      lodash2.attempt = attempt;
      lodash2.camelCase = camelCase;
      lodash2.capitalize = capitalize;
      lodash2.ceil = ceil;
      lodash2.clamp = clamp2;
      lodash2.clone = clone2;
      lodash2.cloneDeep = cloneDeep;
      lodash2.cloneDeepWith = cloneDeepWith;
      lodash2.cloneWith = cloneWith;
      lodash2.conformsTo = conformsTo;
      lodash2.deburr = deburr;
      lodash2.defaultTo = defaultTo;
      lodash2.divide = divide;
      lodash2.endsWith = endsWith;
      lodash2.eq = eq;
      lodash2.escape = escape;
      lodash2.escapeRegExp = escapeRegExp;
      lodash2.every = every;
      lodash2.find = find2;
      lodash2.findIndex = findIndex;
      lodash2.findKey = findKey;
      lodash2.findLast = findLast;
      lodash2.findLastIndex = findLastIndex;
      lodash2.findLastKey = findLastKey;
      lodash2.floor = floor;
      lodash2.forEach = forEach;
      lodash2.forEachRight = forEachRight;
      lodash2.forIn = forIn;
      lodash2.forInRight = forInRight;
      lodash2.forOwn = forOwn;
      lodash2.forOwnRight = forOwnRight;
      lodash2.get = get2;
      lodash2.gt = gt;
      lodash2.gte = gte;
      lodash2.has = has2;
      lodash2.hasIn = hasIn;
      lodash2.head = head;
      lodash2.identity = identity2;
      lodash2.includes = includes;
      lodash2.indexOf = indexOf2;
      lodash2.inRange = inRange;
      lodash2.invoke = invoke;
      lodash2.isArguments = isArguments;
      lodash2.isArray = isArray2;
      lodash2.isArrayBuffer = isArrayBuffer;
      lodash2.isArrayLike = isArrayLike2;
      lodash2.isArrayLikeObject = isArrayLikeObject;
      lodash2.isBoolean = isBoolean;
      lodash2.isBuffer = isBuffer;
      lodash2.isDate = isDate;
      lodash2.isElement = isElement;
      lodash2.isEmpty = isEmpty;
      lodash2.isEqual = isEqual;
      lodash2.isEqualWith = isEqualWith;
      lodash2.isError = isError;
      lodash2.isFinite = isFinite2;
      lodash2.isFunction = isFunction2;
      lodash2.isInteger = isInteger;
      lodash2.isLength = isLength;
      lodash2.isMap = isMap;
      lodash2.isMatch = isMatch;
      lodash2.isMatchWith = isMatchWith;
      lodash2.isNaN = isNaN2;
      lodash2.isNative = isNative;
      lodash2.isNil = isNil;
      lodash2.isNull = isNull;
      lodash2.isNumber = isNumber2;
      lodash2.isObject = isObject2;
      lodash2.isObjectLike = isObjectLike2;
      lodash2.isPlainObject = isPlainObject;
      lodash2.isRegExp = isRegExp2;
      lodash2.isSafeInteger = isSafeInteger;
      lodash2.isSet = isSet;
      lodash2.isString = isString2;
      lodash2.isSymbol = isSymbol2;
      lodash2.isTypedArray = isTypedArray2;
      lodash2.isUndefined = isUndefined;
      lodash2.isWeakMap = isWeakMap;
      lodash2.isWeakSet = isWeakSet;
      lodash2.join = join;
      lodash2.kebabCase = kebabCase;
      lodash2.last = last;
      lodash2.lastIndexOf = lastIndexOf;
      lodash2.lowerCase = lowerCase;
      lodash2.lowerFirst = lowerFirst;
      lodash2.lt = lt2;
      lodash2.lte = lte;
      lodash2.max = max3;
      lodash2.maxBy = maxBy;
      lodash2.mean = mean;
      lodash2.meanBy = meanBy;
      lodash2.min = min3;
      lodash2.minBy = minBy;
      lodash2.stubArray = stubArray;
      lodash2.stubFalse = stubFalse;
      lodash2.stubObject = stubObject;
      lodash2.stubString = stubString;
      lodash2.stubTrue = stubTrue;
      lodash2.multiply = multiply;
      lodash2.nth = nth;
      lodash2.noConflict = noConflict;
      lodash2.noop = noop2;
      lodash2.now = now2;
      lodash2.pad = pad3;
      lodash2.padEnd = padEnd;
      lodash2.padStart = padStart;
      lodash2.parseInt = parseInt2;
      lodash2.random = random;
      lodash2.reduce = reduce2;
      lodash2.reduceRight = reduceRight;
      lodash2.repeat = repeat;
      lodash2.replace = replace;
      lodash2.result = result;
      lodash2.round = round2;
      lodash2.runInContext = runInContext2;
      lodash2.sample = sample;
      lodash2.size = size;
      lodash2.snakeCase = snakeCase;
      lodash2.some = some;
      lodash2.sortedIndex = sortedIndex;
      lodash2.sortedIndexBy = sortedIndexBy;
      lodash2.sortedIndexOf = sortedIndexOf;
      lodash2.sortedLastIndex = sortedLastIndex;
      lodash2.sortedLastIndexBy = sortedLastIndexBy;
      lodash2.sortedLastIndexOf = sortedLastIndexOf;
      lodash2.startCase = startCase;
      lodash2.startsWith = startsWith;
      lodash2.subtract = subtract;
      lodash2.sum = sum2;
      lodash2.sumBy = sumBy;
      lodash2.template = template;
      lodash2.times = times;
      lodash2.toFinite = toFinite;
      lodash2.toInteger = toInteger;
      lodash2.toLength = toLength;
      lodash2.toLower = toLower;
      lodash2.toNumber = toNumber2;
      lodash2.toSafeInteger = toSafeInteger;
      lodash2.toString = toString;
      lodash2.toUpper = toUpper;
      lodash2.trim = trim2;
      lodash2.trimEnd = trimEnd;
      lodash2.trimStart = trimStart;
      lodash2.truncate = truncate;
      lodash2.unescape = unescape2;
      lodash2.uniqueId = uniqueId;
      lodash2.upperCase = upperCase;
      lodash2.upperFirst = upperFirst;
      lodash2.each = forEach;
      lodash2.eachRight = forEachRight;
      lodash2.first = head;
      mixin2(lodash2, function() {
        var source = {};
        baseForOwn(lodash2, function(func, methodName) {
          if (!hasOwnProperty2.call(lodash2.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      }(), { "chain": false });
      lodash2.VERSION = VERSION;
      arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
        lodash2[methodName].placeholder = lodash2;
      });
      arrayEach(["drop", "take"], function(methodName, index2) {
        LazyWrapper.prototype[methodName] = function(n2) {
          n2 = n2 === undefined$1 ? 1 : nativeMax2(toInteger(n2), 0);
          var result2 = this.__filtered__ && !index2 ? new LazyWrapper(this) : this.clone();
          if (result2.__filtered__) {
            result2.__takeCount__ = nativeMin2(n2, result2.__takeCount__);
          } else {
            result2.__views__.push({
              "size": nativeMin2(n2, MAX_ARRAY_LENGTH),
              "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
            });
          }
          return result2;
        };
        LazyWrapper.prototype[methodName + "Right"] = function(n2) {
          return this.reverse()[methodName](n2).reverse();
        };
      });
      arrayEach(["filter", "map", "takeWhile"], function(methodName, index2) {
        var type4 = index2 + 1, isFilter = type4 == LAZY_FILTER_FLAG || type4 == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function(iteratee2) {
          var result2 = this.clone();
          result2.__iteratees__.push({
            "iteratee": getIteratee(iteratee2, 3),
            "type": type4
          });
          result2.__filtered__ = result2.__filtered__ || isFilter;
          return result2;
        };
      });
      arrayEach(["head", "last"], function(methodName, index2) {
        var takeName = "take" + (index2 ? "Right" : "");
        LazyWrapper.prototype[methodName] = function() {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(["initial", "tail"], function(methodName, index2) {
        var dropName = "drop" + (index2 ? "" : "Right");
        LazyWrapper.prototype[methodName] = function() {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function() {
        return this.filter(identity2);
      };
      LazyWrapper.prototype.find = function(predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function(predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
        if (typeof path == "function") {
          return new LazyWrapper(this);
        }
        return this.map(function(value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function(predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function(start2, end2) {
        start2 = toInteger(start2);
        var result2 = this;
        if (result2.__filtered__ && (start2 > 0 || end2 < 0)) {
          return new LazyWrapper(result2);
        }
        if (start2 < 0) {
          result2 = result2.takeRight(-start2);
        } else if (start2) {
          result2 = result2.drop(start2);
        }
        if (end2 !== undefined$1) {
          end2 = toInteger(end2);
          result2 = end2 < 0 ? result2.dropRight(-end2) : result2.take(end2 - start2);
        }
        return result2;
      };
      LazyWrapper.prototype.takeRightWhile = function(predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function() {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash2[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash2.prototype[methodName] = function() {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
          var interceptor = function(value2) {
            var result3 = lodashFunc.apply(lodash2, arrayPush([value2], args));
            return isTaker && chainAll ? result3[0] : result3;
          };
          if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result2 = func.apply(value, args);
            result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined$1 });
            return new LodashWrapper(result2, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result2 = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
        };
      });
      arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
        var func = arrayProto2[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
        lodash2.prototype[methodName] = function() {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray2(value) ? value : [], args);
          }
          return this[chainName](function(value2) {
            return func.apply(isArray2(value2) ? value2 : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var lodashFunc = lodash2[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + "";
          if (!hasOwnProperty2.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({ "name": methodName, "func": lodashFunc });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        "name": "wrapper",
        "func": undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash2.prototype.at = wrapperAt;
      lodash2.prototype.chain = wrapperChain;
      lodash2.prototype.commit = wrapperCommit;
      lodash2.prototype.next = wrapperNext;
      lodash2.prototype.plant = wrapperPlant;
      lodash2.prototype.reverse = wrapperReverse;
      lodash2.prototype.toJSON = lodash2.prototype.valueOf = lodash2.prototype.value = wrapperValue;
      lodash2.prototype.first = lodash2.prototype.head;
      if (symIterator) {
        lodash2.prototype[symIterator] = wrapperToIterator;
      }
      return lodash2;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root2._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = useRef();
      useEffect(() => {
        var _a2, _b2;
        callbackRef.current = listener;
        function subscription(val) {
          if (callbackRef.current) {
            callbackRef.current(val);
          }
        }
        const subscriptions = (_b2 = (_a2 = this.subscriptions) == null ? void 0 : _a2.get(event)) != null ? _b2 : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        return () => {
          this.subscriptions.delete(event);
        };
      });
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners == null ? void 0 : listeners.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useEventEmitter(options) {
  const ref = useRef();
  const eventEmitterOptions = useMemo(() => options != null ? options : { global: false }, [options]);
  if (!ref.current) {
    ref.current = eventEmitterOptions.global ? ref.current = eventEmitterOverall : ref.current = new EventEmitter();
  }
  useEffect(() => {
    return () => {
      var _a2;
      return (_a2 = ref.current) == null ? void 0 : _a2.clear();
    };
  }, []);
  return ref.current;
}
const useEchartsTool = ({
  id: id2,
  title,
  chart,
  option
}, deps) => {
  const ref = useRef(_Charts);
  const event = useEventEmitter({ global: true });
  useDebounceEffect(() => {
    console.log("id", id2);
    console.log("chart", chart == null ? void 0 : chart.current);
    if (ref.current && (chart == null ? void 0 : chart.current) && id2 && option) {
      ref.current.add(id2, chart == null ? void 0 : chart.current, option, title);
      event.emit("list");
    }
  }, deps != null ? deps : [], {
    wait: 100
  });
  return { tool: ref.current };
};
var IconContext = /* @__PURE__ */ createContext({});
var IconContext$1 = IconContext;
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
    })), keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _arrayLikeToArray(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
var classnames = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function(module) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames2() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames2.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString === Object.prototype.toString) {
            for (var key in arg) {
              if (hasOwn2.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          } else {
            classes.push(arg.toString());
          }
        }
      }
      return classes.join(" ");
    }
    if (module.exports) {
      classNames2.default = classNames2;
      module.exports = classNames2;
    } else {
      window.classNames = classNames2;
    }
  })();
})(classnames);
var classNames = classnames.exports;
function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
function bound01(n2, max3) {
  if (isOnePointZero(n2)) {
    n2 = "100%";
  }
  var isPercent = isPercentage(n2);
  n2 = max3 === 360 ? n2 : Math.min(max3, Math.max(0, parseFloat(n2)));
  if (isPercent) {
    n2 = parseInt(String(n2 * max3), 10) / 100;
  }
  if (Math.abs(n2 - max3) < 1e-6) {
    return 1;
  }
  if (max3 === 360) {
    n2 = (n2 < 0 ? n2 % max3 + max3 : n2 % max3) / parseFloat(String(max3));
  } else {
    n2 = n2 % max3 / parseFloat(String(max3));
  }
  return n2;
}
function isOnePointZero(n2) {
  return typeof n2 === "string" && n2.indexOf(".") !== -1 && parseFloat(n2) === 1;
}
function isPercentage(n2) {
  return typeof n2 === "string" && n2.indexOf("%") !== -1;
}
function boundAlpha(a) {
  a = parseFloat(a);
  if (isNaN(a) || a < 0 || a > 1) {
    a = 1;
  }
  return a;
}
function convertToPercentage(n2) {
  if (n2 <= 1) {
    return Number(n2) * 100 + "%";
  }
  return n2;
}
function pad2(c2) {
  return c2.length === 1 ? "0" + c2 : String(c2);
}
function rgbToRgb(r2, g2, b2) {
  return {
    r: bound01(r2, 255) * 255,
    g: bound01(g2, 255) * 255,
    b: bound01(b2, 255) * 255
  };
}
function hue2rgb(p2, q2, t2) {
  if (t2 < 0) {
    t2 += 1;
  }
  if (t2 > 1) {
    t2 -= 1;
  }
  if (t2 < 1 / 6) {
    return p2 + (q2 - p2) * (6 * t2);
  }
  if (t2 < 1 / 2) {
    return q2;
  }
  if (t2 < 2 / 3) {
    return p2 + (q2 - p2) * (2 / 3 - t2) * 6;
  }
  return p2;
}
function hslToRgb(h, s, l2) {
  var r2;
  var g2;
  var b2;
  h = bound01(h, 360);
  s = bound01(s, 100);
  l2 = bound01(l2, 100);
  if (s === 0) {
    g2 = l2;
    b2 = l2;
    r2 = l2;
  } else {
    var q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    var p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h + 1 / 3);
    g2 = hue2rgb(p2, q2, h);
    b2 = hue2rgb(p2, q2, h - 1 / 3);
  }
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHsv(r2, g2, b2) {
  r2 = bound01(r2, 255);
  g2 = bound01(g2, 255);
  b2 = bound01(b2, 255);
  var max3 = Math.max(r2, g2, b2);
  var min3 = Math.min(r2, g2, b2);
  var h = 0;
  var v4 = max3;
  var d2 = max3 - min3;
  var s = max3 === 0 ? 0 : d2 / max3;
  if (max3 === min3) {
    h = 0;
  } else {
    switch (max3) {
      case r2:
        h = (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
        break;
      case g2:
        h = (b2 - r2) / d2 + 2;
        break;
      case b2:
        h = (r2 - g2) / d2 + 4;
        break;
    }
    h /= 6;
  }
  return { h, s, v: v4 };
}
function hsvToRgb(h, s, v4) {
  h = bound01(h, 360) * 6;
  s = bound01(s, 100);
  v4 = bound01(v4, 100);
  var i = Math.floor(h);
  var f2 = h - i;
  var p2 = v4 * (1 - s);
  var q2 = v4 * (1 - f2 * s);
  var t2 = v4 * (1 - (1 - f2) * s);
  var mod = i % 6;
  var r2 = [v4, q2, p2, p2, t2, v4][mod];
  var g2 = [t2, v4, v4, q2, p2, p2][mod];
  var b2 = [p2, p2, t2, v4, v4, q2][mod];
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHex(r2, g2, b2, allow3Char) {
  var hex2 = [
    pad2(Math.round(r2).toString(16)),
    pad2(Math.round(g2).toString(16)),
    pad2(Math.round(b2).toString(16))
  ];
  if (allow3Char && hex2[0].startsWith(hex2[0].charAt(1)) && hex2[1].startsWith(hex2[1].charAt(1)) && hex2[2].startsWith(hex2[2].charAt(1))) {
    return hex2[0].charAt(0) + hex2[1].charAt(0) + hex2[2].charAt(0);
  }
  return hex2.join("");
}
function convertHexToDecimal(h) {
  return parseIntFromHex(h) / 255;
}
function parseIntFromHex(val) {
  return parseInt(val, 16);
}
var names = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function inputToRGB(color) {
  var rgb = { r: 0, g: 0, b: 0 };
  var a = 1;
  var s = null;
  var v4 = null;
  var l2 = null;
  var ok = false;
  var format2 = false;
  if (typeof color === "string") {
    color = stringInputToObject(color);
  }
  if (typeof color === "object") {
    if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
      rgb = rgbToRgb(color.r, color.g, color.b);
      ok = true;
      format2 = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
      s = convertToPercentage(color.s);
      v4 = convertToPercentage(color.v);
      rgb = hsvToRgb(color.h, s, v4);
      ok = true;
      format2 = "hsv";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
      s = convertToPercentage(color.s);
      l2 = convertToPercentage(color.l);
      rgb = hslToRgb(color.h, s, l2);
      ok = true;
      format2 = "hsl";
    }
    if (Object.prototype.hasOwnProperty.call(color, "a")) {
      a = color.a;
    }
  }
  a = boundAlpha(a);
  return {
    ok,
    format: color.format || format2,
    r: Math.min(255, Math.max(rgb.r, 0)),
    g: Math.min(255, Math.max(rgb.g, 0)),
    b: Math.min(255, Math.max(rgb.b, 0)),
    a
  };
}
var CSS_INTEGER = "[-\\+]?\\d+%?";
var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
  CSS_UNIT: new RegExp(CSS_UNIT),
  rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
  rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
  hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
  hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
  hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
  hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function stringInputToObject(color) {
  color = color.trim().toLowerCase();
  if (color.length === 0) {
    return false;
  }
  var named = false;
  if (names[color]) {
    color = names[color];
    named = true;
  } else if (color === "transparent") {
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  }
  var match = matchers.rgb.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3] };
  }
  match = matchers.rgba.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3], a: match[4] };
  }
  match = matchers.hsl.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3] };
  }
  match = matchers.hsla.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3], a: match[4] };
  }
  match = matchers.hsv.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3] };
  }
  match = matchers.hsva.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3], a: match[4] };
  }
  match = matchers.hex8.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      a: convertHexToDecimal(match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex6.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      format: named ? "name" : "hex"
    };
  }
  match = matchers.hex4.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      a: convertHexToDecimal(match[4] + match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex3.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      format: named ? "name" : "hex"
    };
  }
  return false;
}
function isValidCSSUnit(color) {
  return Boolean(matchers.CSS_UNIT.exec(String(color)));
}
var hueStep = 2;
var saturationStep = 0.16;
var saturationStep2 = 0.05;
var brightnessStep1 = 0.05;
var brightnessStep2 = 0.15;
var lightColorCount = 5;
var darkColorCount = 4;
var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function toHsv(_ref) {
  var r2 = _ref.r, g2 = _ref.g, b2 = _ref.b;
  var hsv = rgbToHsv(r2, g2, b2);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
}
function toHex(_ref2) {
  var r2 = _ref2.r, g2 = _ref2.g, b2 = _ref2.b;
  return "#".concat(rgbToHex(r2, g2, b2, false));
}
function mix(rgb1, rgb2, amount) {
  var p2 = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p2 + rgb1.r,
    g: (rgb2.g - rgb1.g) * p2 + rgb1.g,
    b: (rgb2.b - rgb1.b) * p2 + rgb1.b
  };
  return rgb;
}
function getHue(hsv, i, light) {
  var hue;
  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }
  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }
  return hue;
}
function getSaturation(hsv, i, light) {
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }
  var saturation;
  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  }
  if (saturation > 1) {
    saturation = 1;
  }
  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }
  if (saturation < 0.06) {
    saturation = 0.06;
  }
  return Number(saturation.toFixed(2));
}
function getValue$2(hsv, i, light) {
  var value;
  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }
  if (value > 1) {
    value = 1;
  }
  return Number(value.toFixed(2));
}
function generate$1(color) {
  var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);
  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue$2(hsv, i, true)
    }));
    patterns.push(colorString);
  }
  patterns.push(toHex(pColor));
  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);
    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue$2(_hsv, _i)
    }));
    patterns.push(_colorString);
  }
  if (opts.theme === "dark") {
    return darkColorMap.map(function(_ref3) {
      var index2 = _ref3.index, opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || "#141414"), inputToRGB(patterns[index2]), opacity * 100));
      return darkColorString;
    });
  }
  return patterns;
}
var presetPrimaryColors = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function(key) {
  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5];
  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
    theme: "dark",
    backgroundColor: "#141414"
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
presetPalettes.red;
presetPalettes.volcano;
presetPalettes.gold;
presetPalettes.orange;
presetPalettes.yellow;
presetPalettes.lime;
presetPalettes.green;
presetPalettes.cyan;
presetPalettes.blue;
presetPalettes.geekblue;
presetPalettes.purple;
presetPalettes.magenta;
presetPalettes.grey;
var warned = {};
function warning$2(valid, message) {
}
function call(method4, valid, message) {
  if (!valid && !warned[message]) {
    method4(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning$2, valid, message);
}
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
var MARK_KEY = "rc-util-key";
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, mark = _ref.mark;
  if (mark) {
    return mark.startsWith("data-") ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector("head");
  return head || document.body;
}
function injectCSS(css) {
  var _option$csp;
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var styleNode = document.createElement("style");
  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;
    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }
  styleNode.innerHTML = css;
  var container2 = getContainer(option);
  var firstChild = container2.firstChild;
  if (option.prepend && container2.prepend) {
    container2.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    container2.insertBefore(styleNode, firstChild);
  } else {
    container2.appendChild(styleNode);
  }
  return styleNode;
}
var containerCache = /* @__PURE__ */ new Map();
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var container2 = getContainer(option);
  return Array.from(containerCache.get(container2).children).find(function(node) {
    return node.tagName === "STYLE" && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var container2 = getContainer(option);
  if (!containerCache.has(container2)) {
    var placeholderStyle = injectCSS("", option);
    var parentNode2 = placeholderStyle.parentNode;
    containerCache.set(container2, parentNode2);
    parentNode2.removeChild(placeholderStyle);
  }
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp3, _option$csp4;
    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;
      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }
    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }
    return existNode;
  }
  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}
function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === "object" && typeof target.name === "string" && typeof target.theme === "string" && (_typeof(target.icon) === "object" || typeof target.icon === "function");
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return Object.keys(attrs).reduce(function(acc, key) {
    var val = attrs[key];
    switch (key) {
      case "class":
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2({
      key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function(child, index2) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
    }));
  }
  return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function(child, index2) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
  }));
}
function getSecondaryColor(primaryColor) {
  return generate$1(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles2() {
  var styleStr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : iconStyles;
  var _useContext = useContext(IconContext$1), csp = _useContext.csp;
  useEffect(function() {
    updateCSS(styleStr, "@ant-design-icons", {
      prepend: true,
      csp
    });
  }, []);
};
var _excluded$4 = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: "#333",
  secondaryColor: "#E6E6E6",
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor, secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}
var IconBase = function IconBase2(props) {
  var icon = props.icon, className = props.className, onClick = props.onClick, style = props.style, primaryColor = props.primaryColor, secondaryColor = props.secondaryColor, restProps = _objectWithoutProperties(props, _excluded$4);
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === "function") {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate(target.icon, "svg-".concat(target.name), _objectSpread2({
    className,
    onClick,
    style,
    "data-icon": target.name,
    width: "1em",
    height: "1em",
    fill: "currentColor",
    "aria-hidden": "true"
  }, restProps));
};
IconBase.displayName = "IconReact";
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
var ReactIcon = IconBase;
function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return ReactIcon.setTwoToneColors({
    primaryColor,
    secondaryColor
  });
}
function getTwoToneColor() {
  var colors = ReactIcon.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}
var _excluded$3 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
setTwoToneColor("#1890ff");
var Icon = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var className = props.className, icon = props.icon, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, twoToneColor = props.twoToneColor, restProps = _objectWithoutProperties(props, _excluded$3);
  var _React$useContext = React.useContext(IconContext$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === "loading"), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return /* @__PURE__ */ React.createElement("span", _objectSpread2(_objectSpread2({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), /* @__PURE__ */ React.createElement(ReactIcon, {
    icon,
    primaryColor,
    secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = "AntdIcon";
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;
var AntdIcon = Icon;
var LoadingOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
var LoadingOutlinedSvg = LoadingOutlined$2;
var LoadingOutlined = function LoadingOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref,
    icon: LoadingOutlinedSvg
  }));
};
LoadingOutlined.displayName = "LoadingOutlined";
var LoadingOutlined$1 = /* @__PURE__ */ React.forwardRef(LoadingOutlined);
function _extends$1() {
  _extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _setPrototypeOf$1(o, p2) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf$1(o, p2);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf$1(subClass, superClass);
}
function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf$1(o);
}
function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
function _possibleConstructorReturn(self2, call2) {
  if (call2 && (_typeof(call2) === "object" || typeof call2 === "function")) {
    return call2;
  } else if (call2 !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
var reactIs = { exports: {} };
var reactIs_production_min = {};
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b = typeof Symbol === "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f$1 = b ? Symbol.for("react.strict_mode") : 60108, g$1 = b ? Symbol.for("react.profiler") : 60114, h$1 = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m$1 = b ? Symbol.for("react.concurrent_mode") : 60111, n$1 = b ? Symbol.for("react.forward_ref") : 60112, p$1 = b ? Symbol.for("react.suspense") : 60113, q$1 = b ? Symbol.for("react.suspense_list") : 60120, r = b ? Symbol.for("react.memo") : 60115, t = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y = b ? Symbol.for("react.scope") : 60119;
function z(a) {
  if (typeof a === "object" && a !== null) {
    var u = a.$$typeof;
    switch (u) {
      case c:
        switch (a = a.type, a) {
          case l:
          case m$1:
          case e:
          case g$1:
          case f$1:
          case p$1:
            return a;
          default:
            switch (a = a && a.$$typeof, a) {
              case k:
              case n$1:
              case t:
              case r:
              case h$1:
                return a;
              default:
                return u;
            }
        }
      case d:
        return u;
    }
  }
}
function A(a) {
  return z(a) === m$1;
}
reactIs_production_min.AsyncMode = l;
reactIs_production_min.ConcurrentMode = m$1;
reactIs_production_min.ContextConsumer = k;
reactIs_production_min.ContextProvider = h$1;
reactIs_production_min.Element = c;
reactIs_production_min.ForwardRef = n$1;
reactIs_production_min.Fragment = e;
reactIs_production_min.Lazy = t;
reactIs_production_min.Memo = r;
reactIs_production_min.Portal = d;
reactIs_production_min.Profiler = g$1;
reactIs_production_min.StrictMode = f$1;
reactIs_production_min.Suspense = p$1;
reactIs_production_min.isAsyncMode = function(a) {
  return A(a) || z(a) === l;
};
reactIs_production_min.isConcurrentMode = A;
reactIs_production_min.isContextConsumer = function(a) {
  return z(a) === k;
};
reactIs_production_min.isContextProvider = function(a) {
  return z(a) === h$1;
};
reactIs_production_min.isElement = function(a) {
  return typeof a === "object" && a !== null && a.$$typeof === c;
};
reactIs_production_min.isForwardRef = function(a) {
  return z(a) === n$1;
};
reactIs_production_min.isFragment = function(a) {
  return z(a) === e;
};
reactIs_production_min.isLazy = function(a) {
  return z(a) === t;
};
reactIs_production_min.isMemo = function(a) {
  return z(a) === r;
};
reactIs_production_min.isPortal = function(a) {
  return z(a) === d;
};
reactIs_production_min.isProfiler = function(a) {
  return z(a) === g$1;
};
reactIs_production_min.isStrictMode = function(a) {
  return z(a) === f$1;
};
reactIs_production_min.isSuspense = function(a) {
  return z(a) === p$1;
};
reactIs_production_min.isValidElementType = function(a) {
  return typeof a === "string" || typeof a === "function" || a === e || a === m$1 || a === g$1 || a === f$1 || a === p$1 || a === q$1 || typeof a === "object" && a !== null && (a.$$typeof === t || a.$$typeof === r || a.$$typeof === h$1 || a.$$typeof === k || a.$$typeof === n$1 || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y || a.$$typeof === v);
};
reactIs_production_min.typeOf = z;
{
  reactIs.exports = reactIs_production_min;
}
function toArray$1(children) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var ret = [];
  React__default.Children.forEach(children, function(child) {
    if ((child === void 0 || child === null) && !option.keepEmpty) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(toArray$1(child));
    } else if (reactIs.exports.isFragment(child) && child.props) {
      ret = ret.concat(toArray$1(child.props.children, option));
    } else {
      ret.push(child);
    }
  });
  return ret;
}
function fillRef(ref, node) {
  if (typeof ref === "function") {
    ref(node);
  } else if (_typeof(ref) === "object" && ref && "current" in ref) {
    ref.current = node;
  }
}
function composeRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  var refList = refs.filter(function(ref) {
    return ref;
  });
  if (refList.length <= 1) {
    return refList[0];
  }
  return function(node) {
    refs.forEach(function(ref) {
      fillRef(ref, node);
    });
  };
}
function supportRef(nodeOrComponent) {
  var _type$prototype, _nodeOrComponent$prot;
  var type4 = reactIs.exports.isMemo(nodeOrComponent) ? nodeOrComponent.type.type : nodeOrComponent.type;
  if (typeof type4 === "function" && !((_type$prototype = type4.prototype) === null || _type$prototype === void 0 ? void 0 : _type$prototype.render)) {
    return false;
  }
  if (typeof nodeOrComponent === "function" && !((_nodeOrComponent$prot = nodeOrComponent.prototype) === null || _nodeOrComponent$prot === void 0 ? void 0 : _nodeOrComponent$prot.render)) {
    return false;
  }
  return true;
}
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
var HOOK_MARK = "RC_FORM_INTERNAL_HOOKS";
var warningFunc = function warningFunc2() {
  warningOnce(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
};
var Context = /* @__PURE__ */ React.createContext({
  getFieldValue: warningFunc,
  getFieldsValue: warningFunc,
  getFieldError: warningFunc,
  getFieldWarning: warningFunc,
  getFieldsError: warningFunc,
  isFieldsTouched: warningFunc,
  isFieldTouched: warningFunc,
  isFieldValidating: warningFunc,
  isFieldsValidating: warningFunc,
  resetFields: warningFunc,
  setFields: warningFunc,
  setFieldsValue: warningFunc,
  validateFields: warningFunc,
  submit: warningFunc,
  getInternalHooks: function getInternalHooks() {
    warningFunc();
    return {
      dispatch: warningFunc,
      initEntityValue: warningFunc,
      registerField: warningFunc,
      useSubscribe: warningFunc,
      setInitialValues: warningFunc,
      setCallbacks: warningFunc,
      getFields: warningFunc,
      setValidateMessages: warningFunc,
      setPreserve: warningFunc,
      getInitialValue: warningFunc
    };
  }
});
function toArray(value) {
  if (value === void 0 || value === null) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var runtime = { exports: {} };
(function(module) {
  var runtime2 = function(exports) {
    var Op = Object.prototype;
    var hasOwn2 = Op.hasOwnProperty;
    var undefined$1;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self2, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context2(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self2, context);
      return generator;
    }
    exports.wrap = wrap;
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }
    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};
    function Generator() {
    }
    function GeneratorFunction() {
    }
    function GeneratorFunctionPrototype() {
    }
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function() {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn2.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method4) {
        define(prototype, method4, function(arg) {
          return this._invoke(method4, arg);
        });
      });
    }
    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };
    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };
    exports.awrap = function(arg) {
      return { __await: arg };
    };
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method4, arg, resolve, reject) {
        var record = tryCatch(generator[method4], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value && typeof value === "object" && hasOwn2.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }
          return PromiseImpl.resolve(value).then(function(unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }
      var previousPromise;
      function enqueue(method4, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method4, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
      this._invoke = enqueue;
    }
    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function() {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;
    exports.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0)
        PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
        return result.done ? result.value : iter.next();
      });
    };
    function makeInvokeMethod(innerFn, self2, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method4, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }
        if (state === GenStateCompleted) {
          if (method4 === "throw") {
            throw arg;
          }
          return doneResult();
        }
        context.method = method4;
        context.arg = arg;
        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel)
                continue;
              return delegateResult;
            }
          }
          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }
            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }
          state = GenStateExecuting;
          var record = tryCatch(innerFn, self2, context);
          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;
            if (record.arg === ContinueSentinel) {
              continue;
            }
            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var method4 = delegate.iterator[context.method];
      if (method4 === undefined$1) {
        context.delegate = null;
        if (context.method === "throw") {
          if (delegate.iterator["return"]) {
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);
            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }
          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }
        return ContinueSentinel;
      }
      var record = tryCatch(method4, delegate.iterator, context.arg);
      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }
      var info = record.arg;
      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }
      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        return info;
      }
      context.delegate = null;
      return ContinueSentinel;
    }
    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator");
    define(Gp, iteratorSymbol, function() {
      return this;
    });
    define(Gp, "toString", function() {
      return "[object Generator]";
    });
    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };
      if (1 in locs) {
        entry.catchLoc = locs[1];
      }
      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }
      this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }
    function Context2(tryLocsList) {
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }
    exports.keys = function(object4) {
      var keys2 = [];
      for (var key in object4) {
        keys2.push(key);
      }
      keys2.reverse();
      return function next() {
        while (keys2.length) {
          var key2 = keys2.pop();
          if (key2 in object4) {
            next.value = key2;
            next.done = false;
            return next;
          }
        }
        next.done = true;
        return next;
      };
    };
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }
        if (typeof iterable.next === "function") {
          return iterable;
        }
        if (!isNaN(iterable.length)) {
          var i = -1, next = function next2() {
            while (++i < iterable.length) {
              if (hasOwn2.call(iterable, i)) {
                next2.value = iterable[i];
                next2.done = false;
                return next2;
              }
            }
            next2.value = undefined$1;
            next2.done = true;
            return next2;
          };
          return next.next = next;
        }
      }
      return { next: doneResult };
    }
    exports.values = values;
    function doneResult() {
      return { value: undefined$1, done: true };
    }
    Context2.prototype = {
      constructor: Context2,
      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);
        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn2.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }
        return this.rval;
      },
      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }
        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;
          if (caught) {
            context.method = "next";
            context.arg = undefined$1;
          }
          return !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;
          if (entry.tryLoc === "root") {
            return handle("end");
          }
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn2.call(entry, "catchLoc");
            var hasFinally = hasOwn2.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function(type4, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn2.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        if (finallyEntry && (type4 === "break" || type4 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }
        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type4;
        record.arg = arg;
        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }
        return this.complete(record);
      },
      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }
        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }
        return ContinueSentinel;
      },
      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName,
          nextLoc
        };
        if (this.method === "next") {
          this.arg = undefined$1;
        }
        return ContinueSentinel;
      }
    };
    return exports;
  }(module.exports);
  try {
    regeneratorRuntime = runtime2;
  } catch (accidentalStrictMode) {
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime2;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime2);
    }
  }
})(runtime);
var regenerator = runtime.exports;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var formatRegExp = /%[sdj%]/g;
var warning = function warning2() {
};
if (typeof process !== "undefined" && process.env && false) {
  warning = function warning3(type4, errors) {
    if (typeof console !== "undefined" && console.warn && typeof ASYNC_VALIDATOR_NO_WARNING === "undefined") {
      if (errors.every(function(e2) {
        return typeof e2 === "string";
      })) {
        console.warn(type4, errors);
      }
    }
  };
}
function convertFieldsError(errors) {
  if (!errors || !errors.length)
    return null;
  var fields = {};
  errors.forEach(function(error) {
    var field = error.field;
    fields[field] = fields[field] || [];
    fields[field].push(error);
  });
  return fields;
}
function format(template) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var i = 0;
  var len2 = args.length;
  if (typeof template === "function") {
    return template.apply(null, args);
  }
  if (typeof template === "string") {
    var str = template.replace(formatRegExp, function(x2) {
      if (x2 === "%%") {
        return "%";
      }
      if (i >= len2) {
        return x2;
      }
      switch (x2) {
        case "%s":
          return String(args[i++]);
        case "%d":
          return Number(args[i++]);
        case "%j":
          try {
            return JSON.stringify(args[i++]);
          } catch (_) {
            return "[Circular]";
          }
          break;
        default:
          return x2;
      }
    });
    return str;
  }
  return template;
}
function isNativeStringType(type4) {
  return type4 === "string" || type4 === "url" || type4 === "hex" || type4 === "email" || type4 === "date" || type4 === "pattern";
}
function isEmptyValue(value, type4) {
  if (value === void 0 || value === null) {
    return true;
  }
  if (type4 === "array" && Array.isArray(value) && !value.length) {
    return true;
  }
  if (isNativeStringType(type4) && typeof value === "string" && !value) {
    return true;
  }
  return false;
}
function asyncParallelArray(arr, func, callback) {
  var results = [];
  var total = 0;
  var arrLength = arr.length;
  function count2(errors) {
    results.push.apply(results, errors || []);
    total++;
    if (total === arrLength) {
      callback(results);
    }
  }
  arr.forEach(function(a) {
    func(a, count2);
  });
}
function asyncSerialArray(arr, func, callback) {
  var index2 = 0;
  var arrLength = arr.length;
  function next(errors) {
    if (errors && errors.length) {
      callback(errors);
      return;
    }
    var original = index2;
    index2 = index2 + 1;
    if (original < arrLength) {
      func(arr[original], next);
    } else {
      callback([]);
    }
  }
  next([]);
}
function flattenObjArr(objArr) {
  var ret = [];
  Object.keys(objArr).forEach(function(k2) {
    ret.push.apply(ret, objArr[k2] || []);
  });
  return ret;
}
var AsyncValidationError = /* @__PURE__ */ function(_Error) {
  _inheritsLoose(AsyncValidationError2, _Error);
  function AsyncValidationError2(errors, fields) {
    var _this;
    _this = _Error.call(this, "Async Validation Error") || this;
    _this.errors = errors;
    _this.fields = fields;
    return _this;
  }
  return AsyncValidationError2;
}(/* @__PURE__ */ _wrapNativeSuper(Error));
function asyncMap(objArr, option, func, callback, source) {
  if (option.first) {
    var _pending = new Promise(function(resolve, reject) {
      var next = function next2(errors) {
        callback(errors);
        return errors.length ? reject(new AsyncValidationError(errors, convertFieldsError(errors))) : resolve(source);
      };
      var flattenArr = flattenObjArr(objArr);
      asyncSerialArray(flattenArr, func, next);
    });
    _pending["catch"](function(e2) {
      return e2;
    });
    return _pending;
  }
  var firstFields = option.firstFields === true ? Object.keys(objArr) : option.firstFields || [];
  var objArrKeys = Object.keys(objArr);
  var objArrLength = objArrKeys.length;
  var total = 0;
  var results = [];
  var pending = new Promise(function(resolve, reject) {
    var next = function next2(errors) {
      results.push.apply(results, errors);
      total++;
      if (total === objArrLength) {
        callback(results);
        return results.length ? reject(new AsyncValidationError(results, convertFieldsError(results))) : resolve(source);
      }
    };
    if (!objArrKeys.length) {
      callback(results);
      resolve(source);
    }
    objArrKeys.forEach(function(key) {
      var arr = objArr[key];
      if (firstFields.indexOf(key) !== -1) {
        asyncSerialArray(arr, func, next);
      } else {
        asyncParallelArray(arr, func, next);
      }
    });
  });
  pending["catch"](function(e2) {
    return e2;
  });
  return pending;
}
function isErrorObj(obj) {
  return !!(obj && obj.message !== void 0);
}
function getValue$1(value, path) {
  var v4 = value;
  for (var i = 0; i < path.length; i++) {
    if (v4 == void 0) {
      return v4;
    }
    v4 = v4[path[i]];
  }
  return v4;
}
function complementError(rule, source) {
  return function(oe) {
    var fieldValue;
    if (rule.fullFields) {
      fieldValue = getValue$1(source, rule.fullFields);
    } else {
      fieldValue = source[oe.field || rule.fullField];
    }
    if (isErrorObj(oe)) {
      oe.field = oe.field || rule.fullField;
      oe.fieldValue = fieldValue;
      return oe;
    }
    return {
      message: typeof oe === "function" ? oe() : oe,
      fieldValue,
      field: oe.field || rule.fullField
    };
  };
}
function deepMerge(target, source) {
  if (source) {
    for (var s in source) {
      if (source.hasOwnProperty(s)) {
        var value = source[s];
        if (typeof value === "object" && typeof target[s] === "object") {
          target[s] = _extends({}, target[s], value);
        } else {
          target[s] = value;
        }
      }
    }
  }
  return target;
}
var required$1 = function required(rule, value, source, errors, options, type4) {
  if (rule.required && (!source.hasOwnProperty(rule.field) || isEmptyValue(value, type4 || rule.type))) {
    errors.push(format(options.messages.required, rule.fullField));
  }
};
var whitespace = function whitespace2(rule, value, source, errors, options) {
  if (/^\s+$/.test(value) || value === "") {
    errors.push(format(options.messages.whitespace, rule.fullField));
  }
};
var pattern$2 = {
  email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/,
  url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"),
  hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i
};
var types = {
  integer: function integer(value) {
    return types.number(value) && parseInt(value, 10) === value;
  },
  "float": function float(value) {
    return types.number(value) && !types.integer(value);
  },
  array: function array(value) {
    return Array.isArray(value);
  },
  regexp: function regexp(value) {
    if (value instanceof RegExp) {
      return true;
    }
    try {
      return !!new RegExp(value);
    } catch (e2) {
      return false;
    }
  },
  date: function date(value) {
    return typeof value.getTime === "function" && typeof value.getMonth === "function" && typeof value.getYear === "function" && !isNaN(value.getTime());
  },
  number: function number(value) {
    if (isNaN(value)) {
      return false;
    }
    return typeof value === "number";
  },
  object: function object(value) {
    return typeof value === "object" && !types.array(value);
  },
  method: function method(value) {
    return typeof value === "function";
  },
  email: function email(value) {
    return typeof value === "string" && value.length <= 320 && !!value.match(pattern$2.email);
  },
  url: function url(value) {
    return typeof value === "string" && value.length <= 2048 && !!value.match(pattern$2.url);
  },
  hex: function hex(value) {
    return typeof value === "string" && !!value.match(pattern$2.hex);
  }
};
var type$1 = function type(rule, value, source, errors, options) {
  if (rule.required && value === void 0) {
    required$1(rule, value, source, errors, options);
    return;
  }
  var custom = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"];
  var ruleType = rule.type;
  if (custom.indexOf(ruleType) > -1) {
    if (!types[ruleType](value)) {
      errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
    }
  } else if (ruleType && typeof value !== rule.type) {
    errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
  }
};
var range = function range2(rule, value, source, errors, options) {
  var len2 = typeof rule.len === "number";
  var min3 = typeof rule.min === "number";
  var max3 = typeof rule.max === "number";
  var spRegexp = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
  var val = value;
  var key = null;
  var num = typeof value === "number";
  var str = typeof value === "string";
  var arr = Array.isArray(value);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = value.length;
  }
  if (str) {
    val = value.replace(spRegexp, "_").length;
  }
  if (len2) {
    if (val !== rule.len) {
      errors.push(format(options.messages[key].len, rule.fullField, rule.len));
    }
  } else if (min3 && !max3 && val < rule.min) {
    errors.push(format(options.messages[key].min, rule.fullField, rule.min));
  } else if (max3 && !min3 && val > rule.max) {
    errors.push(format(options.messages[key].max, rule.fullField, rule.max));
  } else if (min3 && max3 && (val < rule.min || val > rule.max)) {
    errors.push(format(options.messages[key].range, rule.fullField, rule.min, rule.max));
  }
};
var ENUM$1 = "enum";
var enumerable$1 = function enumerable(rule, value, source, errors, options) {
  rule[ENUM$1] = Array.isArray(rule[ENUM$1]) ? rule[ENUM$1] : [];
  if (rule[ENUM$1].indexOf(value) === -1) {
    errors.push(format(options.messages[ENUM$1], rule.fullField, rule[ENUM$1].join(", ")));
  }
};
var pattern$1 = function pattern(rule, value, source, errors, options) {
  if (rule.pattern) {
    if (rule.pattern instanceof RegExp) {
      rule.pattern.lastIndex = 0;
      if (!rule.pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    } else if (typeof rule.pattern === "string") {
      var _pattern = new RegExp(rule.pattern);
      if (!_pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    }
  }
};
var rules = {
  required: required$1,
  whitespace,
  type: type$1,
  range,
  "enum": enumerable$1,
  pattern: pattern$1
};
var string = function string2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "string");
    if (!isEmptyValue(value, "string")) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
      rules.pattern(rule, value, source, errors, options);
      if (rule.whitespace === true) {
        rules.whitespace(rule, value, source, errors, options);
      }
    }
  }
  callback(errors);
};
var method2 = function method3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var number2 = function number3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (value === "") {
      value = void 0;
    }
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var _boolean = function _boolean2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var regexp2 = function regexp3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var integer2 = function integer3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var floatFn = function floatFn2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var array2 = function array3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if ((value === void 0 || value === null) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "array");
    if (value !== void 0 && value !== null) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var object2 = function object3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var ENUM = "enum";
var enumerable2 = function enumerable3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules[ENUM](rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var pattern2 = function pattern3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "string")) {
      rules.pattern(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var date2 = function date3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "date") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "date")) {
      var dateObject;
      if (value instanceof Date) {
        dateObject = value;
      } else {
        dateObject = new Date(value);
      }
      rules.type(rule, dateObject, source, errors, options);
      if (dateObject) {
        rules.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
};
var required2 = function required3(rule, value, callback, source, options) {
  var errors = [];
  var type4 = Array.isArray(value) ? "array" : typeof value;
  rules.required(rule, value, source, errors, options, type4);
  callback(errors);
};
var type2 = function type3(rule, value, callback, source, options) {
  var ruleType = rule.type;
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, ruleType) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, ruleType);
    if (!isEmptyValue(value, ruleType)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var any = function any2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
  }
  callback(errors);
};
var validators = {
  string,
  method: method2,
  number: number2,
  "boolean": _boolean,
  regexp: regexp2,
  integer: integer2,
  "float": floatFn,
  array: array2,
  object: object2,
  "enum": enumerable2,
  pattern: pattern2,
  date: date2,
  url: type2,
  hex: type2,
  email: type2,
  required: required2,
  any
};
function newMessages() {
  return {
    "default": "Validation error on field %s",
    required: "%s is required",
    "enum": "%s must be one of %s",
    whitespace: "%s cannot be empty",
    date: {
      format: "%s date %s is invalid for format %s",
      parse: "%s date could not be parsed, %s is invalid ",
      invalid: "%s date %s is invalid"
    },
    types: {
      string: "%s is not a %s",
      method: "%s is not a %s (function)",
      array: "%s is not an %s",
      object: "%s is not an %s",
      number: "%s is not a %s",
      date: "%s is not a %s",
      "boolean": "%s is not a %s",
      integer: "%s is not an %s",
      "float": "%s is not a %s",
      regexp: "%s is not a valid %s",
      email: "%s is not a valid %s",
      url: "%s is not a valid %s",
      hex: "%s is not a valid %s"
    },
    string: {
      len: "%s must be exactly %s characters",
      min: "%s must be at least %s characters",
      max: "%s cannot be longer than %s characters",
      range: "%s must be between %s and %s characters"
    },
    number: {
      len: "%s must equal %s",
      min: "%s cannot be less than %s",
      max: "%s cannot be greater than %s",
      range: "%s must be between %s and %s"
    },
    array: {
      len: "%s must be exactly %s in length",
      min: "%s cannot be less than %s in length",
      max: "%s cannot be greater than %s in length",
      range: "%s must be between %s and %s in length"
    },
    pattern: {
      mismatch: "%s value %s does not match pattern %s"
    },
    clone: function clone2() {
      var cloned = JSON.parse(JSON.stringify(this));
      cloned.clone = this.clone;
      return cloned;
    }
  };
}
var messages = newMessages();
var Schema = /* @__PURE__ */ function() {
  function Schema2(descriptor) {
    this.rules = null;
    this._messages = messages;
    this.define(descriptor);
  }
  var _proto = Schema2.prototype;
  _proto.define = function define(rules2) {
    var _this = this;
    if (!rules2) {
      throw new Error("Cannot configure a schema with no rules");
    }
    if (typeof rules2 !== "object" || Array.isArray(rules2)) {
      throw new Error("Rules must be an object");
    }
    this.rules = {};
    Object.keys(rules2).forEach(function(name) {
      var item = rules2[name];
      _this.rules[name] = Array.isArray(item) ? item : [item];
    });
  };
  _proto.messages = function messages2(_messages) {
    if (_messages) {
      this._messages = deepMerge(newMessages(), _messages);
    }
    return this._messages;
  };
  _proto.validate = function validate(source_, o, oc) {
    var _this2 = this;
    if (o === void 0) {
      o = {};
    }
    if (oc === void 0) {
      oc = function oc2() {
      };
    }
    var source = source_;
    var options = o;
    var callback = oc;
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    if (!this.rules || Object.keys(this.rules).length === 0) {
      if (callback) {
        callback(null, source);
      }
      return Promise.resolve(source);
    }
    function complete(results) {
      var errors = [];
      var fields = {};
      function add2(e2) {
        if (Array.isArray(e2)) {
          var _errors;
          errors = (_errors = errors).concat.apply(_errors, e2);
        } else {
          errors.push(e2);
        }
      }
      for (var i = 0; i < results.length; i++) {
        add2(results[i]);
      }
      if (!errors.length) {
        callback(null, source);
      } else {
        fields = convertFieldsError(errors);
        callback(errors, fields);
      }
    }
    if (options.messages) {
      var messages$1 = this.messages();
      if (messages$1 === messages) {
        messages$1 = newMessages();
      }
      deepMerge(messages$1, options.messages);
      options.messages = messages$1;
    } else {
      options.messages = this.messages();
    }
    var series = {};
    var keys2 = options.keys || Object.keys(this.rules);
    keys2.forEach(function(z2) {
      var arr = _this2.rules[z2];
      var value = source[z2];
      arr.forEach(function(r2) {
        var rule = r2;
        if (typeof rule.transform === "function") {
          if (source === source_) {
            source = _extends({}, source);
          }
          value = source[z2] = rule.transform(value);
        }
        if (typeof rule === "function") {
          rule = {
            validator: rule
          };
        } else {
          rule = _extends({}, rule);
        }
        rule.validator = _this2.getValidationMethod(rule);
        if (!rule.validator) {
          return;
        }
        rule.field = z2;
        rule.fullField = rule.fullField || z2;
        rule.type = _this2.getType(rule);
        series[z2] = series[z2] || [];
        series[z2].push({
          rule,
          value,
          source,
          field: z2
        });
      });
    });
    var errorFields = {};
    return asyncMap(series, options, function(data, doIt) {
      var rule = data.rule;
      var deep = (rule.type === "object" || rule.type === "array") && (typeof rule.fields === "object" || typeof rule.defaultField === "object");
      deep = deep && (rule.required || !rule.required && data.value);
      rule.field = data.field;
      function addFullField(key, schema) {
        return _extends({}, schema, {
          fullField: rule.fullField + "." + key,
          fullFields: rule.fullFields ? [].concat(rule.fullFields, [key]) : [key]
        });
      }
      function cb(e2) {
        if (e2 === void 0) {
          e2 = [];
        }
        var errorList = Array.isArray(e2) ? e2 : [e2];
        if (!options.suppressWarning && errorList.length) {
          Schema2.warning("async-validator:", errorList);
        }
        if (errorList.length && rule.message !== void 0) {
          errorList = [].concat(rule.message);
        }
        var filledErrors = errorList.map(complementError(rule, source));
        if (options.first && filledErrors.length) {
          errorFields[rule.field] = 1;
          return doIt(filledErrors);
        }
        if (!deep) {
          doIt(filledErrors);
        } else {
          if (rule.required && !data.value) {
            if (rule.message !== void 0) {
              filledErrors = [].concat(rule.message).map(complementError(rule, source));
            } else if (options.error) {
              filledErrors = [options.error(rule, format(options.messages.required, rule.field))];
            }
            return doIt(filledErrors);
          }
          var fieldsSchema = {};
          if (rule.defaultField) {
            Object.keys(data.value).map(function(key) {
              fieldsSchema[key] = rule.defaultField;
            });
          }
          fieldsSchema = _extends({}, fieldsSchema, data.rule.fields);
          var paredFieldsSchema = {};
          Object.keys(fieldsSchema).forEach(function(field) {
            var fieldSchema = fieldsSchema[field];
            var fieldSchemaList = Array.isArray(fieldSchema) ? fieldSchema : [fieldSchema];
            paredFieldsSchema[field] = fieldSchemaList.map(addFullField.bind(null, field));
          });
          var schema = new Schema2(paredFieldsSchema);
          schema.messages(options.messages);
          if (data.rule.options) {
            data.rule.options.messages = options.messages;
            data.rule.options.error = options.error;
          }
          schema.validate(data.value, data.rule.options || options, function(errs) {
            var finalErrors = [];
            if (filledErrors && filledErrors.length) {
              finalErrors.push.apply(finalErrors, filledErrors);
            }
            if (errs && errs.length) {
              finalErrors.push.apply(finalErrors, errs);
            }
            doIt(finalErrors.length ? finalErrors : null);
          });
        }
      }
      var res;
      if (rule.asyncValidator) {
        res = rule.asyncValidator(rule, data.value, cb, data.source, options);
      } else if (rule.validator) {
        res = rule.validator(rule, data.value, cb, data.source, options);
        if (res === true) {
          cb();
        } else if (res === false) {
          cb(typeof rule.message === "function" ? rule.message(rule.fullField || rule.field) : rule.message || (rule.fullField || rule.field) + " fails");
        } else if (res instanceof Array) {
          cb(res);
        } else if (res instanceof Error) {
          cb(res.message);
        }
      }
      if (res && res.then) {
        res.then(function() {
          return cb();
        }, function(e2) {
          return cb(e2);
        });
      }
    }, function(results) {
      complete(results);
    }, source);
  };
  _proto.getType = function getType(rule) {
    if (rule.type === void 0 && rule.pattern instanceof RegExp) {
      rule.type = "pattern";
    }
    if (typeof rule.validator !== "function" && rule.type && !validators.hasOwnProperty(rule.type)) {
      throw new Error(format("Unknown rule type %s", rule.type));
    }
    return rule.type || "string";
  };
  _proto.getValidationMethod = function getValidationMethod(rule) {
    if (typeof rule.validator === "function") {
      return rule.validator;
    }
    var keys2 = Object.keys(rule);
    var messageIndex = keys2.indexOf("message");
    if (messageIndex !== -1) {
      keys2.splice(messageIndex, 1);
    }
    if (keys2.length === 1 && keys2[0] === "required") {
      return validators.required;
    }
    return validators[this.getType(rule)] || void 0;
  };
  return Schema2;
}();
Schema.register = function register2(type4, validator) {
  if (typeof validator !== "function") {
    throw new Error("Cannot register a validator by type, validator is not a function");
  }
  validators[type4] = validator;
};
Schema.warning = warning;
Schema.messages = messages;
Schema.validators = validators;
var typeTemplate$1 = "'${name}' is not a valid ${type}";
var defaultValidateMessages = {
  default: "Validation error on field '${name}'",
  required: "'${name}' is required",
  enum: "'${name}' must be one of [${enum}]",
  whitespace: "'${name}' cannot be empty",
  date: {
    format: "'${name}' is invalid for format date",
    parse: "'${name}' could not be parsed as date",
    invalid: "'${name}' is invalid date"
  },
  types: {
    string: typeTemplate$1,
    method: typeTemplate$1,
    array: typeTemplate$1,
    object: typeTemplate$1,
    number: typeTemplate$1,
    date: typeTemplate$1,
    boolean: typeTemplate$1,
    integer: typeTemplate$1,
    float: typeTemplate$1,
    regexp: typeTemplate$1,
    email: typeTemplate$1,
    url: typeTemplate$1,
    hex: typeTemplate$1
  },
  string: {
    len: "'${name}' must be exactly ${len} characters",
    min: "'${name}' must be at least ${min} characters",
    max: "'${name}' cannot be longer than ${max} characters",
    range: "'${name}' must be between ${min} and ${max} characters"
  },
  number: {
    len: "'${name}' must equal ${len}",
    min: "'${name}' cannot be less than ${min}",
    max: "'${name}' cannot be greater than ${max}",
    range: "'${name}' must be between ${min} and ${max}"
  },
  array: {
    len: "'${name}' must be exactly ${len} in length",
    min: "'${name}' cannot be less than ${min} in length",
    max: "'${name}' cannot be greater than ${max} in length",
    range: "'${name}' must be between ${min} and ${max} in length"
  },
  pattern: {
    mismatch: "'${name}' does not match pattern ${pattern}"
  }
};
function get(entity, path) {
  var current = entity;
  for (var i = 0; i < path.length; i += 1) {
    if (current === null || current === void 0) {
      return void 0;
    }
    current = current[path[i]];
  }
  return current;
}
function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}
function internalSet(entity, paths, value, removeIfUndefined) {
  if (!paths.length) {
    return value;
  }
  var _paths = _toArray(paths), path = _paths[0], restPath = _paths.slice(1);
  var clone2;
  if (!entity && typeof path === "number") {
    clone2 = [];
  } else if (Array.isArray(entity)) {
    clone2 = _toConsumableArray(entity);
  } else {
    clone2 = _objectSpread2({}, entity);
  }
  if (removeIfUndefined && value === void 0 && restPath.length === 1) {
    delete clone2[path][restPath[0]];
  } else {
    clone2[path] = internalSet(clone2[path], restPath, value, removeIfUndefined);
  }
  return clone2;
}
function set(entity, paths, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  if (paths.length && removeIfUndefined && value === void 0 && !get(entity, paths.slice(0, -1))) {
    return entity;
  }
  return internalSet(entity, paths, value, removeIfUndefined);
}
function getNamePath(path) {
  return toArray(path);
}
function getValue(store, namePath) {
  var value = get(store, namePath);
  return value;
}
function setValue(store, namePath, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  var newStore = set(store, namePath, value, removeIfUndefined);
  return newStore;
}
function cloneByNamePathList(store, namePathList) {
  var newStore = {};
  namePathList.forEach(function(namePath) {
    var value = getValue(store, namePath);
    newStore = setValue(newStore, namePath, value);
  });
  return newStore;
}
function containsNamePath(namePathList, namePath) {
  return namePathList && namePathList.some(function(path) {
    return matchNamePath(path, namePath);
  });
}
function isObject(obj) {
  return _typeof(obj) === "object" && obj !== null && Object.getPrototypeOf(obj) === Object.prototype;
}
function internalSetValues(store, values) {
  var newStore = Array.isArray(store) ? _toConsumableArray(store) : _objectSpread2({}, store);
  if (!values) {
    return newStore;
  }
  Object.keys(values).forEach(function(key) {
    var prevValue = newStore[key];
    var value = values[key];
    var recursive = isObject(prevValue) && isObject(value);
    newStore[key] = recursive ? internalSetValues(prevValue, value || {}) : value;
  });
  return newStore;
}
function setValues(store) {
  for (var _len = arguments.length, restValues = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    restValues[_key - 1] = arguments[_key];
  }
  return restValues.reduce(function(current, newStore) {
    return internalSetValues(current, newStore);
  }, store);
}
function matchNamePath(namePath, changedNamePath) {
  if (!namePath || !changedNamePath || namePath.length !== changedNamePath.length) {
    return false;
  }
  return namePath.every(function(nameUnit, i) {
    return changedNamePath[i] === nameUnit;
  });
}
function isSimilar(source, target) {
  if (source === target) {
    return true;
  }
  if (!source && target || source && !target) {
    return false;
  }
  if (!source || !target || _typeof(source) !== "object" || _typeof(target) !== "object") {
    return false;
  }
  var sourceKeys = Object.keys(source);
  var targetKeys = Object.keys(target);
  var keys2 = new Set([].concat(_toConsumableArray(sourceKeys), _toConsumableArray(targetKeys)));
  return _toConsumableArray(keys2).every(function(key) {
    var sourceValue = source[key];
    var targetValue = target[key];
    if (typeof sourceValue === "function" && typeof targetValue === "function") {
      return true;
    }
    return sourceValue === targetValue;
  });
}
function defaultGetValueFromEvent(valuePropName) {
  var event = arguments.length <= 1 ? void 0 : arguments[1];
  if (event && event.target && _typeof(event.target) === "object" && valuePropName in event.target) {
    return event.target[valuePropName];
  }
  return event;
}
function move(array4, moveIndex, toIndex) {
  var length = array4.length;
  if (moveIndex < 0 || moveIndex >= length || toIndex < 0 || toIndex >= length) {
    return array4;
  }
  var item = array4[moveIndex];
  var diff = moveIndex - toIndex;
  if (diff > 0) {
    return [].concat(_toConsumableArray(array4.slice(0, toIndex)), [item], _toConsumableArray(array4.slice(toIndex, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, length)));
  }
  if (diff < 0) {
    return [].concat(_toConsumableArray(array4.slice(0, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, toIndex + 1)), [item], _toConsumableArray(array4.slice(toIndex + 1, length)));
  }
  return array4;
}
var AsyncValidator = Schema;
function replaceMessage(template, kv) {
  return template.replace(/\$\{\w+\}/g, function(str) {
    var key = str.slice(2, -1);
    return kv[key];
  });
}
function validateRule(_x, _x2, _x3, _x4, _x5) {
  return _validateRule.apply(this, arguments);
}
function _validateRule() {
  _validateRule = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee2(name, value, rule, options, messageVariables) {
    var cloneRule, subRuleField, validator, messages2, result, subResults, kv, fillVariableResult;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cloneRule = _objectSpread2({}, rule);
            delete cloneRule.ruleIndex;
            subRuleField = null;
            if (cloneRule && cloneRule.type === "array" && cloneRule.defaultField) {
              subRuleField = cloneRule.defaultField;
              delete cloneRule.defaultField;
            }
            validator = new AsyncValidator(_defineProperty({}, name, [cloneRule]));
            messages2 = setValues({}, defaultValidateMessages, options.validateMessages);
            validator.messages(messages2);
            result = [];
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.resolve(validator.validate(_defineProperty({}, name, value), _objectSpread2({}, options)));
          case 11:
            _context2.next = 16;
            break;
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            if (_context2.t0.errors) {
              result = _context2.t0.errors.map(function(_ref4, index2) {
                var message = _ref4.message;
                return /* @__PURE__ */ React.isValidElement(message) ? /* @__PURE__ */ React.cloneElement(message, {
                  key: "error_".concat(index2)
                }) : message;
              });
            } else {
              console.error(_context2.t0);
              result = [messages2.default];
            }
          case 16:
            if (!(!result.length && subRuleField)) {
              _context2.next = 21;
              break;
            }
            _context2.next = 19;
            return Promise.all(value.map(function(subValue, i) {
              return validateRule("".concat(name, ".").concat(i), subValue, subRuleField, options, messageVariables);
            }));
          case 19:
            subResults = _context2.sent;
            return _context2.abrupt("return", subResults.reduce(function(prev, errors) {
              return [].concat(_toConsumableArray(prev), _toConsumableArray(errors));
            }, []));
          case 21:
            kv = _objectSpread2(_objectSpread2({}, rule), {}, {
              name,
              enum: (rule.enum || []).join(", ")
            }, messageVariables);
            fillVariableResult = result.map(function(error) {
              if (typeof error === "string") {
                return replaceMessage(error, kv);
              }
              return error;
            });
            return _context2.abrupt("return", fillVariableResult);
          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13]]);
  }));
  return _validateRule.apply(this, arguments);
}
function validateRules(namePath, value, rules2, options, validateFirst, messageVariables) {
  var name = namePath.join(".");
  var filledRules = rules2.map(function(currentRule, ruleIndex) {
    var originValidatorFunc = currentRule.validator;
    var cloneRule = _objectSpread2(_objectSpread2({}, currentRule), {}, {
      ruleIndex
    });
    if (originValidatorFunc) {
      cloneRule.validator = function(rule, val, callback) {
        var hasPromise = false;
        var wrappedCallback = function wrappedCallback2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          Promise.resolve().then(function() {
            warningOnce(!hasPromise, "Your validator function has already return a promise. `callback` will be ignored.");
            if (!hasPromise) {
              callback.apply(void 0, args);
            }
          });
        };
        var promise = originValidatorFunc(rule, val, wrappedCallback);
        hasPromise = promise && typeof promise.then === "function" && typeof promise.catch === "function";
        warningOnce(hasPromise, "`callback` is deprecated. Please return a promise instead.");
        if (hasPromise) {
          promise.then(function() {
            callback();
          }).catch(function(err) {
            callback(err || " ");
          });
        }
      };
    }
    return cloneRule;
  }).sort(function(_ref, _ref2) {
    var w1 = _ref.warningOnly, i1 = _ref.ruleIndex;
    var w2 = _ref2.warningOnly, i2 = _ref2.ruleIndex;
    if (!!w1 === !!w2) {
      return i1 - i2;
    }
    if (w1) {
      return 1;
    }
    return -1;
  });
  var summaryPromise;
  if (validateFirst === true) {
    summaryPromise = new Promise(/* @__PURE__ */ function() {
      var _ref3 = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee(resolve, reject) {
        var i, rule, errors;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = 0;
              case 1:
                if (!(i < filledRules.length)) {
                  _context.next = 12;
                  break;
                }
                rule = filledRules[i];
                _context.next = 5;
                return validateRule(name, value, rule, options, messageVariables);
              case 5:
                errors = _context.sent;
                if (!errors.length) {
                  _context.next = 9;
                  break;
                }
                reject([{
                  errors,
                  rule
                }]);
                return _context.abrupt("return");
              case 9:
                i += 1;
                _context.next = 1;
                break;
              case 12:
                resolve([]);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return function(_x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
  } else {
    var rulePromises = filledRules.map(function(rule) {
      return validateRule(name, value, rule, options, messageVariables).then(function(errors) {
        return {
          errors,
          rule
        };
      });
    });
    summaryPromise = (validateFirst ? finishOnFirstFailed(rulePromises) : finishOnAllFailed(rulePromises)).then(function(errors) {
      return Promise.reject(errors);
    });
  }
  summaryPromise.catch(function(e2) {
    return e2;
  });
  return summaryPromise;
}
function finishOnAllFailed(_x8) {
  return _finishOnAllFailed.apply(this, arguments);
}
function _finishOnAllFailed() {
  _finishOnAllFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee3(rulePromises) {
    return regenerator.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", Promise.all(rulePromises).then(function(errorsList) {
              var _ref5;
              var errors = (_ref5 = []).concat.apply(_ref5, _toConsumableArray(errorsList));
              return errors;
            }));
          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _finishOnAllFailed.apply(this, arguments);
}
function finishOnFirstFailed(_x9) {
  return _finishOnFirstFailed.apply(this, arguments);
}
function _finishOnFirstFailed() {
  _finishOnFirstFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee4(rulePromises) {
    var count2;
    return regenerator.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            count2 = 0;
            return _context4.abrupt("return", new Promise(function(resolve) {
              rulePromises.forEach(function(promise) {
                promise.then(function(ruleError) {
                  if (ruleError.errors.length) {
                    resolve([ruleError]);
                  }
                  count2 += 1;
                  if (count2 === rulePromises.length) {
                    resolve([]);
                  }
                });
              });
            }));
          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _finishOnFirstFailed.apply(this, arguments);
}
var _excluded$2 = ["name"];
var EMPTY_ERRORS = [];
function requireUpdate(shouldUpdate, prev, next, prevValue, nextValue, info) {
  if (typeof shouldUpdate === "function") {
    return shouldUpdate(prev, next, "source" in info ? {
      source: info.source
    } : {});
  }
  return prevValue !== nextValue;
}
var Field = /* @__PURE__ */ function(_React$Component) {
  _inherits(Field2, _React$Component);
  var _super = _createSuper(Field2);
  function Field2(props) {
    var _this;
    _classCallCheck(this, Field2);
    _this = _super.call(this, props);
    _this.state = {
      resetCount: 0
    };
    _this.cancelRegisterFunc = null;
    _this.mounted = false;
    _this.touched = false;
    _this.dirty = false;
    _this.validatePromise = null;
    _this.prevValidating = void 0;
    _this.errors = EMPTY_ERRORS;
    _this.warnings = EMPTY_ERRORS;
    _this.cancelRegister = function() {
      var _this$props = _this.props, preserve = _this$props.preserve, isListField = _this$props.isListField, name = _this$props.name;
      if (_this.cancelRegisterFunc) {
        _this.cancelRegisterFunc(isListField, preserve, getNamePath(name));
      }
      _this.cancelRegisterFunc = null;
    };
    _this.getNamePath = function() {
      var _this$props2 = _this.props, name = _this$props2.name, fieldContext = _this$props2.fieldContext;
      var _fieldContext$prefixN = fieldContext.prefixName, prefixName = _fieldContext$prefixN === void 0 ? [] : _fieldContext$prefixN;
      return name !== void 0 ? [].concat(_toConsumableArray(prefixName), _toConsumableArray(name)) : [];
    };
    _this.getRules = function() {
      var _this$props3 = _this.props, _this$props3$rules = _this$props3.rules, rules2 = _this$props3$rules === void 0 ? [] : _this$props3$rules, fieldContext = _this$props3.fieldContext;
      return rules2.map(function(rule) {
        if (typeof rule === "function") {
          return rule(fieldContext);
        }
        return rule;
      });
    };
    _this.refresh = function() {
      if (!_this.mounted)
        return;
      _this.setState(function(_ref) {
        var resetCount = _ref.resetCount;
        return {
          resetCount: resetCount + 1
        };
      });
    };
    _this.triggerMetaEvent = function(destroy) {
      var onMetaChange = _this.props.onMetaChange;
      onMetaChange === null || onMetaChange === void 0 ? void 0 : onMetaChange(_objectSpread2(_objectSpread2({}, _this.getMeta()), {}, {
        destroy
      }));
    };
    _this.onStoreChange = function(prevStore, namePathList, info) {
      var _this$props4 = _this.props, shouldUpdate = _this$props4.shouldUpdate, _this$props4$dependen = _this$props4.dependencies, dependencies = _this$props4$dependen === void 0 ? [] : _this$props4$dependen, onReset = _this$props4.onReset;
      var store = info.store;
      var namePath = _this.getNamePath();
      var prevValue = _this.getValue(prevStore);
      var curValue = _this.getValue(store);
      var namePathMatch = namePathList && containsNamePath(namePathList, namePath);
      if (info.type === "valueUpdate" && info.source === "external" && prevValue !== curValue) {
        _this.touched = true;
        _this.dirty = true;
        _this.validatePromise = null;
        _this.errors = EMPTY_ERRORS;
        _this.warnings = EMPTY_ERRORS;
        _this.triggerMetaEvent();
      }
      switch (info.type) {
        case "reset":
          if (!namePathList || namePathMatch) {
            _this.touched = false;
            _this.dirty = false;
            _this.validatePromise = null;
            _this.errors = EMPTY_ERRORS;
            _this.warnings = EMPTY_ERRORS;
            _this.triggerMetaEvent();
            onReset === null || onReset === void 0 ? void 0 : onReset();
            _this.refresh();
            return;
          }
          break;
        case "remove": {
          if (shouldUpdate) {
            _this.reRender();
            return;
          }
          break;
        }
        case "setField": {
          if (namePathMatch) {
            var data = info.data;
            if ("touched" in data) {
              _this.touched = data.touched;
            }
            if ("validating" in data && !("originRCField" in data)) {
              _this.validatePromise = data.validating ? Promise.resolve([]) : null;
            }
            if ("errors" in data) {
              _this.errors = data.errors || EMPTY_ERRORS;
            }
            if ("warnings" in data) {
              _this.warnings = data.warnings || EMPTY_ERRORS;
            }
            _this.dirty = true;
            _this.triggerMetaEvent();
            _this.reRender();
            return;
          }
          if (shouldUpdate && !namePath.length && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
        }
        case "dependenciesUpdate": {
          var dependencyList = dependencies.map(getNamePath);
          if (dependencyList.some(function(dependency) {
            return containsNamePath(info.relatedFields, dependency);
          })) {
            _this.reRender();
            return;
          }
          break;
        }
        default:
          if (namePathMatch || (!dependencies.length || namePath.length || shouldUpdate) && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
      }
      if (shouldUpdate === true) {
        _this.reRender();
      }
    };
    _this.validateRules = function(options) {
      var namePath = _this.getNamePath();
      var currentValue = _this.getValue();
      var rootPromise = Promise.resolve().then(function() {
        if (!_this.mounted) {
          return [];
        }
        var _this$props5 = _this.props, _this$props5$validate = _this$props5.validateFirst, validateFirst = _this$props5$validate === void 0 ? false : _this$props5$validate, messageVariables = _this$props5.messageVariables;
        var _ref2 = options || {}, triggerName = _ref2.triggerName;
        var filteredRules = _this.getRules();
        if (triggerName) {
          filteredRules = filteredRules.filter(function(rule) {
            var validateTrigger = rule.validateTrigger;
            if (!validateTrigger) {
              return true;
            }
            var triggerList = toArray(validateTrigger);
            return triggerList.includes(triggerName);
          });
        }
        var promise = validateRules(namePath, currentValue, filteredRules, options, validateFirst, messageVariables);
        promise.catch(function(e2) {
          return e2;
        }).then(function() {
          var ruleErrors = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : EMPTY_ERRORS;
          if (_this.validatePromise === rootPromise) {
            _this.validatePromise = null;
            var nextErrors = [];
            var nextWarnings = [];
            ruleErrors.forEach(function(_ref3) {
              var warningOnly = _ref3.rule.warningOnly, _ref3$errors = _ref3.errors, errors = _ref3$errors === void 0 ? EMPTY_ERRORS : _ref3$errors;
              if (warningOnly) {
                nextWarnings.push.apply(nextWarnings, _toConsumableArray(errors));
              } else {
                nextErrors.push.apply(nextErrors, _toConsumableArray(errors));
              }
            });
            _this.errors = nextErrors;
            _this.warnings = nextWarnings;
            _this.triggerMetaEvent();
            _this.reRender();
          }
        });
        return promise;
      });
      _this.validatePromise = rootPromise;
      _this.dirty = true;
      _this.errors = EMPTY_ERRORS;
      _this.warnings = EMPTY_ERRORS;
      _this.triggerMetaEvent();
      _this.reRender();
      return rootPromise;
    };
    _this.isFieldValidating = function() {
      return !!_this.validatePromise;
    };
    _this.isFieldTouched = function() {
      return _this.touched;
    };
    _this.isFieldDirty = function() {
      if (_this.dirty || _this.props.initialValue !== void 0) {
        return true;
      }
      var fieldContext = _this.props.fieldContext;
      var _fieldContext$getInte = fieldContext.getInternalHooks(HOOK_MARK), getInitialValue = _fieldContext$getInte.getInitialValue;
      if (getInitialValue(_this.getNamePath()) !== void 0) {
        return true;
      }
      return false;
    };
    _this.getErrors = function() {
      return _this.errors;
    };
    _this.getWarnings = function() {
      return _this.warnings;
    };
    _this.isListField = function() {
      return _this.props.isListField;
    };
    _this.isList = function() {
      return _this.props.isList;
    };
    _this.isPreserve = function() {
      return _this.props.preserve;
    };
    _this.getMeta = function() {
      _this.prevValidating = _this.isFieldValidating();
      var meta = {
        touched: _this.isFieldTouched(),
        validating: _this.prevValidating,
        errors: _this.errors,
        warnings: _this.warnings,
        name: _this.getNamePath()
      };
      return meta;
    };
    _this.getOnlyChild = function(children) {
      if (typeof children === "function") {
        var meta = _this.getMeta();
        return _objectSpread2(_objectSpread2({}, _this.getOnlyChild(children(_this.getControlled(), meta, _this.props.fieldContext))), {}, {
          isFunction: true
        });
      }
      var childList = toArray$1(children);
      if (childList.length !== 1 || !/* @__PURE__ */ React.isValidElement(childList[0])) {
        return {
          child: childList,
          isFunction: false
        };
      }
      return {
        child: childList[0],
        isFunction: false
      };
    };
    _this.getValue = function(store) {
      var getFieldsValue = _this.props.fieldContext.getFieldsValue;
      var namePath = _this.getNamePath();
      return getValue(store || getFieldsValue(true), namePath);
    };
    _this.getControlled = function() {
      var childProps = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      var _this$props6 = _this.props, trigger2 = _this$props6.trigger, validateTrigger = _this$props6.validateTrigger, getValueFromEvent = _this$props6.getValueFromEvent, normalize2 = _this$props6.normalize, valuePropName = _this$props6.valuePropName, getValueProps = _this$props6.getValueProps, fieldContext = _this$props6.fieldContext;
      var mergedValidateTrigger = validateTrigger !== void 0 ? validateTrigger : fieldContext.validateTrigger;
      var namePath = _this.getNamePath();
      var getInternalHooks3 = fieldContext.getInternalHooks, getFieldsValue = fieldContext.getFieldsValue;
      var _getInternalHooks = getInternalHooks3(HOOK_MARK), dispatch2 = _getInternalHooks.dispatch;
      var value = _this.getValue();
      var mergedGetValueProps = getValueProps || function(val) {
        return _defineProperty({}, valuePropName, val);
      };
      var originTriggerFunc = childProps[trigger2];
      var control = _objectSpread2(_objectSpread2({}, childProps), mergedGetValueProps(value));
      control[trigger2] = function() {
        _this.touched = true;
        _this.dirty = true;
        _this.triggerMetaEvent();
        var newValue;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        if (getValueFromEvent) {
          newValue = getValueFromEvent.apply(void 0, args);
        } else {
          newValue = defaultGetValueFromEvent.apply(void 0, [valuePropName].concat(args));
        }
        if (normalize2) {
          newValue = normalize2(newValue, value, getFieldsValue(true));
        }
        dispatch2({
          type: "updateValue",
          namePath,
          value: newValue
        });
        if (originTriggerFunc) {
          originTriggerFunc.apply(void 0, args);
        }
      };
      var validateTriggerList = toArray(mergedValidateTrigger || []);
      validateTriggerList.forEach(function(triggerName) {
        var originTrigger = control[triggerName];
        control[triggerName] = function() {
          if (originTrigger) {
            originTrigger.apply(void 0, arguments);
          }
          var rules2 = _this.props.rules;
          if (rules2 && rules2.length) {
            dispatch2({
              type: "validateField",
              namePath,
              triggerName
            });
          }
        };
      });
      return control;
    };
    if (props.fieldContext) {
      var getInternalHooks2 = props.fieldContext.getInternalHooks;
      var _getInternalHooks2 = getInternalHooks2(HOOK_MARK), initEntityValue = _getInternalHooks2.initEntityValue;
      initEntityValue(_assertThisInitialized(_this));
    }
    return _this;
  }
  _createClass(Field2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props7 = this.props, shouldUpdate = _this$props7.shouldUpdate, fieldContext = _this$props7.fieldContext;
      this.mounted = true;
      if (fieldContext) {
        var getInternalHooks2 = fieldContext.getInternalHooks;
        var _getInternalHooks3 = getInternalHooks2(HOOK_MARK), registerField = _getInternalHooks3.registerField;
        this.cancelRegisterFunc = registerField(this);
      }
      if (shouldUpdate === true) {
        this.reRender();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cancelRegister();
      this.triggerMetaEvent(true);
      this.mounted = false;
    }
  }, {
    key: "reRender",
    value: function reRender() {
      if (!this.mounted)
        return;
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render2() {
      var resetCount = this.state.resetCount;
      var children = this.props.children;
      var _this$getOnlyChild = this.getOnlyChild(children), child = _this$getOnlyChild.child, isFunction2 = _this$getOnlyChild.isFunction;
      var returnChildNode;
      if (isFunction2) {
        returnChildNode = child;
      } else if (/* @__PURE__ */ React.isValidElement(child)) {
        returnChildNode = /* @__PURE__ */ React.cloneElement(child, this.getControlled(child.props));
      } else {
        warningOnce(!child, "`children` of Field is not validate ReactElement.");
        returnChildNode = child;
      }
      return /* @__PURE__ */ React.createElement(React.Fragment, {
        key: resetCount
      }, returnChildNode);
    }
  }]);
  return Field2;
}(React.Component);
Field.contextType = Context;
Field.defaultProps = {
  trigger: "onChange",
  valuePropName: "value"
};
function WrapperField(_ref5) {
  var name = _ref5.name, restProps = _objectWithoutProperties(_ref5, _excluded$2);
  var fieldContext = React.useContext(Context);
  var namePath = name !== void 0 ? getNamePath(name) : void 0;
  var key = "keep";
  if (!restProps.isListField) {
    key = "_".concat((namePath || []).join("_"));
  }
  return /* @__PURE__ */ React.createElement(Field, _extends$1({
    key,
    name: namePath
  }, restProps, {
    fieldContext
  }));
}
var ListContext = /* @__PURE__ */ React.createContext(null);
var List = function List2(_ref) {
  var name = _ref.name, initialValue = _ref.initialValue, children = _ref.children, rules2 = _ref.rules, validateTrigger = _ref.validateTrigger;
  var context = React.useContext(Context);
  var keyRef = React.useRef({
    keys: [],
    id: 0
  });
  var keyManager = keyRef.current;
  var prefixName = React.useMemo(function() {
    var parentPrefixName = getNamePath(context.prefixName) || [];
    return [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray(getNamePath(name)));
  }, [context.prefixName, name]);
  var fieldContext = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, context), {}, {
      prefixName
    });
  }, [context, prefixName]);
  var listContext = React.useMemo(function() {
    return {
      getKey: function getKey2(namePath) {
        var len2 = prefixName.length;
        var pathName = namePath[len2];
        return [keyManager.keys[pathName], namePath.slice(len2 + 1)];
      }
    };
  }, [prefixName]);
  if (typeof children !== "function") {
    warningOnce(false, "Form.List only accepts function as children.");
    return null;
  }
  var shouldUpdate = function shouldUpdate2(prevValue, nextValue, _ref2) {
    var source = _ref2.source;
    if (source === "internal") {
      return false;
    }
    return prevValue !== nextValue;
  };
  return /* @__PURE__ */ React.createElement(ListContext.Provider, {
    value: listContext
  }, /* @__PURE__ */ React.createElement(Context.Provider, {
    value: fieldContext
  }, /* @__PURE__ */ React.createElement(WrapperField, {
    name: [],
    shouldUpdate,
    rules: rules2,
    validateTrigger,
    initialValue,
    isList: true
  }, function(_ref3, meta) {
    var _ref3$value = _ref3.value, value = _ref3$value === void 0 ? [] : _ref3$value, onChange = _ref3.onChange;
    var getFieldValue = context.getFieldValue;
    var getNewValue = function getNewValue2() {
      var values = getFieldValue(prefixName || []);
      return values || [];
    };
    var operations = {
      add: function add2(defaultValue, index2) {
        var newValue = getNewValue();
        if (index2 >= 0 && index2 <= newValue.length) {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys.slice(0, index2)), [keyManager.id], _toConsumableArray(keyManager.keys.slice(index2)));
          onChange([].concat(_toConsumableArray(newValue.slice(0, index2)), [defaultValue], _toConsumableArray(newValue.slice(index2))));
        } else {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys), [keyManager.id]);
          onChange([].concat(_toConsumableArray(newValue), [defaultValue]));
        }
        keyManager.id += 1;
      },
      remove: function remove(index2) {
        var newValue = getNewValue();
        var indexSet = new Set(Array.isArray(index2) ? index2 : [index2]);
        if (indexSet.size <= 0) {
          return;
        }
        keyManager.keys = keyManager.keys.filter(function(_, keysIndex) {
          return !indexSet.has(keysIndex);
        });
        onChange(newValue.filter(function(_, valueIndex) {
          return !indexSet.has(valueIndex);
        }));
      },
      move: function move$1(from, to) {
        if (from === to) {
          return;
        }
        var newValue = getNewValue();
        if (from < 0 || from >= newValue.length || to < 0 || to >= newValue.length) {
          return;
        }
        keyManager.keys = move(keyManager.keys, from, to);
        onChange(move(newValue, from, to));
      }
    };
    var listValue = value || [];
    if (!Array.isArray(listValue)) {
      listValue = [];
    }
    return children(listValue.map(function(__, index2) {
      var key = keyManager.keys[index2];
      if (key === void 0) {
        keyManager.keys[index2] = keyManager.id;
        key = keyManager.keys[index2];
        keyManager.id += 1;
      }
      return {
        name: index2,
        key,
        isListField: true
      };
    }), operations, meta);
  })));
};
function allPromiseFinish(promiseList) {
  var hasError = false;
  var count2 = promiseList.length;
  var results = [];
  if (!promiseList.length) {
    return Promise.resolve([]);
  }
  return new Promise(function(resolve, reject) {
    promiseList.forEach(function(promise, index2) {
      promise.catch(function(e2) {
        hasError = true;
        return e2;
      }).then(function(result) {
        count2 -= 1;
        results[index2] = result;
        if (count2 > 0) {
          return;
        }
        if (hasError) {
          reject(results);
        }
        resolve(results);
      });
    });
  });
}
var SPLIT = "__@field_split__";
function normalize(namePath) {
  return namePath.map(function(cell) {
    return "".concat(_typeof(cell), ":").concat(cell);
  }).join(SPLIT);
}
var NameMap = /* @__PURE__ */ function() {
  function NameMap2() {
    _classCallCheck(this, NameMap2);
    this.kvs = /* @__PURE__ */ new Map();
  }
  _createClass(NameMap2, [{
    key: "set",
    value: function set2(key, value) {
      this.kvs.set(normalize(key), value);
    }
  }, {
    key: "get",
    value: function get2(key) {
      return this.kvs.get(normalize(key));
    }
  }, {
    key: "update",
    value: function update(key, updater) {
      var origin = this.get(key);
      var next = updater(origin);
      if (!next) {
        this.delete(key);
      } else {
        this.set(key, next);
      }
    }
  }, {
    key: "delete",
    value: function _delete(key) {
      this.kvs.delete(normalize(key));
    }
  }, {
    key: "map",
    value: function map2(callback) {
      return _toConsumableArray(this.kvs.entries()).map(function(_ref) {
        var _ref2 = _slicedToArray(_ref, 2), key = _ref2[0], value = _ref2[1];
        var cells = key.split(SPLIT);
        return callback({
          key: cells.map(function(cell) {
            var _cell$match = cell.match(/^([^:]*):(.*)$/), _cell$match2 = _slicedToArray(_cell$match, 3), type4 = _cell$match2[1], unit = _cell$match2[2];
            return type4 === "number" ? Number(unit) : unit;
          }),
          value
        });
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      this.map(function(_ref3) {
        var key = _ref3.key, value = _ref3.value;
        json[key.join(".")] = value;
        return null;
      });
      return json;
    }
  }]);
  return NameMap2;
}();
var _excluded$1 = ["name", "errors"];
var FormStore = /* @__PURE__ */ _createClass(function FormStore2(forceRootUpdate) {
  var _this = this;
  _classCallCheck(this, FormStore2);
  this.formHooked = false;
  this.forceRootUpdate = void 0;
  this.subscribable = true;
  this.store = {};
  this.fieldEntities = [];
  this.initialValues = {};
  this.callbacks = {};
  this.validateMessages = null;
  this.preserve = null;
  this.lastValidatePromise = null;
  this.getForm = function() {
    return {
      getFieldValue: _this.getFieldValue,
      getFieldsValue: _this.getFieldsValue,
      getFieldError: _this.getFieldError,
      getFieldWarning: _this.getFieldWarning,
      getFieldsError: _this.getFieldsError,
      isFieldsTouched: _this.isFieldsTouched,
      isFieldTouched: _this.isFieldTouched,
      isFieldValidating: _this.isFieldValidating,
      isFieldsValidating: _this.isFieldsValidating,
      resetFields: _this.resetFields,
      setFields: _this.setFields,
      setFieldsValue: _this.setFieldsValue,
      validateFields: _this.validateFields,
      submit: _this.submit,
      getInternalHooks: _this.getInternalHooks
    };
  };
  this.getInternalHooks = function(key) {
    if (key === HOOK_MARK) {
      _this.formHooked = true;
      return {
        dispatch: _this.dispatch,
        initEntityValue: _this.initEntityValue,
        registerField: _this.registerField,
        useSubscribe: _this.useSubscribe,
        setInitialValues: _this.setInitialValues,
        setCallbacks: _this.setCallbacks,
        setValidateMessages: _this.setValidateMessages,
        getFields: _this.getFields,
        setPreserve: _this.setPreserve,
        getInitialValue: _this.getInitialValue
      };
    }
    warningOnce(false, "`getInternalHooks` is internal usage. Should not call directly.");
    return null;
  };
  this.useSubscribe = function(subscribable) {
    _this.subscribable = subscribable;
  };
  this.setInitialValues = function(initialValues, init2) {
    _this.initialValues = initialValues || {};
    if (init2) {
      _this.store = setValues({}, initialValues, _this.store);
    }
  };
  this.getInitialValue = function(namePath) {
    return getValue(_this.initialValues, namePath);
  };
  this.setCallbacks = function(callbacks) {
    _this.callbacks = callbacks;
  };
  this.setValidateMessages = function(validateMessages) {
    _this.validateMessages = validateMessages;
  };
  this.setPreserve = function(preserve) {
    _this.preserve = preserve;
  };
  this.timeoutId = null;
  this.warningUnhooked = function() {
  };
  this.getFieldEntities = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    if (!pure) {
      return _this.fieldEntities;
    }
    return _this.fieldEntities.filter(function(field) {
      return field.getNamePath().length;
    });
  };
  this.getFieldsMap = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    var cache = new NameMap();
    _this.getFieldEntities(pure).forEach(function(field) {
      var namePath = field.getNamePath();
      cache.set(namePath, field);
    });
    return cache;
  };
  this.getFieldEntitiesForNamePathList = function(nameList) {
    if (!nameList) {
      return _this.getFieldEntities(true);
    }
    var cache = _this.getFieldsMap(true);
    return nameList.map(function(name) {
      var namePath = getNamePath(name);
      return cache.get(namePath) || {
        INVALIDATE_NAME_PATH: getNamePath(name)
      };
    });
  };
  this.getFieldsValue = function(nameList, filterFunc) {
    _this.warningUnhooked();
    if (nameList === true && !filterFunc) {
      return _this.store;
    }
    var fieldEntities = _this.getFieldEntitiesForNamePathList(Array.isArray(nameList) ? nameList : null);
    var filteredNameList = [];
    fieldEntities.forEach(function(entity) {
      var _entity$isListField;
      var namePath = "INVALIDATE_NAME_PATH" in entity ? entity.INVALIDATE_NAME_PATH : entity.getNamePath();
      if (!nameList && ((_entity$isListField = entity.isListField) === null || _entity$isListField === void 0 ? void 0 : _entity$isListField.call(entity))) {
        return;
      }
      if (!filterFunc) {
        filteredNameList.push(namePath);
      } else {
        var meta = "getMeta" in entity ? entity.getMeta() : null;
        if (filterFunc(meta)) {
          filteredNameList.push(namePath);
        }
      }
    });
    return cloneByNamePathList(_this.store, filteredNameList.map(getNamePath));
  };
  this.getFieldValue = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    return getValue(_this.store, namePath);
  };
  this.getFieldsError = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntitiesForNamePathList(nameList);
    return fieldEntities.map(function(entity, index2) {
      if (entity && !("INVALIDATE_NAME_PATH" in entity)) {
        return {
          name: entity.getNamePath(),
          errors: entity.getErrors(),
          warnings: entity.getWarnings()
        };
      }
      return {
        name: getNamePath(nameList[index2]),
        errors: [],
        warnings: []
      };
    });
  };
  this.getFieldError = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.errors;
  };
  this.getFieldWarning = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.warnings;
  };
  this.isFieldsTouched = function() {
    _this.warningUnhooked();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var arg0 = args[0], arg1 = args[1];
    var namePathList;
    var isAllFieldsTouched = false;
    if (args.length === 0) {
      namePathList = null;
    } else if (args.length === 1) {
      if (Array.isArray(arg0)) {
        namePathList = arg0.map(getNamePath);
        isAllFieldsTouched = false;
      } else {
        namePathList = null;
        isAllFieldsTouched = arg0;
      }
    } else {
      namePathList = arg0.map(getNamePath);
      isAllFieldsTouched = arg1;
    }
    var fieldEntities = _this.getFieldEntities(true);
    var isFieldTouched = function isFieldTouched2(field) {
      return field.isFieldTouched();
    };
    if (!namePathList) {
      return isAllFieldsTouched ? fieldEntities.every(isFieldTouched) : fieldEntities.some(isFieldTouched);
    }
    var map2 = new NameMap();
    namePathList.forEach(function(shortNamePath) {
      map2.set(shortNamePath, []);
    });
    fieldEntities.forEach(function(field) {
      var fieldNamePath = field.getNamePath();
      namePathList.forEach(function(shortNamePath) {
        if (shortNamePath.every(function(nameUnit, i) {
          return fieldNamePath[i] === nameUnit;
        })) {
          map2.update(shortNamePath, function(list) {
            return [].concat(_toConsumableArray(list), [field]);
          });
        }
      });
    });
    var isNamePathListTouched = function isNamePathListTouched2(entities) {
      return entities.some(isFieldTouched);
    };
    var namePathListEntities = map2.map(function(_ref) {
      var value = _ref.value;
      return value;
    });
    return isAllFieldsTouched ? namePathListEntities.every(isNamePathListTouched) : namePathListEntities.some(isNamePathListTouched);
  };
  this.isFieldTouched = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsTouched([name]);
  };
  this.isFieldsValidating = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntities();
    if (!nameList) {
      return fieldEntities.some(function(testField) {
        return testField.isFieldValidating();
      });
    }
    var namePathList = nameList.map(getNamePath);
    return fieldEntities.some(function(testField) {
      var fieldNamePath = testField.getNamePath();
      return containsNamePath(namePathList, fieldNamePath) && testField.isFieldValidating();
    });
  };
  this.isFieldValidating = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsValidating([name]);
  };
  this.resetWithFieldInitialValue = function() {
    var info = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var cache = new NameMap();
    var fieldEntities = _this.getFieldEntities(true);
    fieldEntities.forEach(function(field) {
      var initialValue = field.props.initialValue;
      var namePath = field.getNamePath();
      if (initialValue !== void 0) {
        var records = cache.get(namePath) || /* @__PURE__ */ new Set();
        records.add({
          entity: field,
          value: initialValue
        });
        cache.set(namePath, records);
      }
    });
    var resetWithFields = function resetWithFields2(entities) {
      entities.forEach(function(field) {
        var initialValue = field.props.initialValue;
        if (initialValue !== void 0) {
          var namePath = field.getNamePath();
          var formInitialValue = _this.getInitialValue(namePath);
          if (formInitialValue !== void 0) {
            warningOnce(false, "Form already set 'initialValues' with path '".concat(namePath.join("."), "'. Field can not overwrite it."));
          } else {
            var records = cache.get(namePath);
            if (records && records.size > 1) {
              warningOnce(false, "Multiple Field with path '".concat(namePath.join("."), "' set 'initialValue'. Can not decide which one to pick."));
            } else if (records) {
              var originValue = _this.getFieldValue(namePath);
              if (!info.skipExist || originValue === void 0) {
                _this.store = setValue(_this.store, namePath, _toConsumableArray(records)[0].value);
              }
            }
          }
        }
      });
    };
    var requiredFieldEntities;
    if (info.entities) {
      requiredFieldEntities = info.entities;
    } else if (info.namePathList) {
      requiredFieldEntities = [];
      info.namePathList.forEach(function(namePath) {
        var records = cache.get(namePath);
        if (records) {
          var _requiredFieldEntitie;
          (_requiredFieldEntitie = requiredFieldEntities).push.apply(_requiredFieldEntitie, _toConsumableArray(_toConsumableArray(records).map(function(r2) {
            return r2.entity;
          })));
        }
      });
    } else {
      requiredFieldEntities = fieldEntities;
    }
    resetWithFields(requiredFieldEntities);
  };
  this.resetFields = function(nameList) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (!nameList) {
      _this.store = setValues({}, _this.initialValues);
      _this.resetWithFieldInitialValue();
      _this.notifyObservers(prevStore, null, {
        type: "reset"
      });
      return;
    }
    var namePathList = nameList.map(getNamePath);
    namePathList.forEach(function(namePath) {
      var initialValue = _this.getInitialValue(namePath);
      _this.store = setValue(_this.store, namePath, initialValue);
    });
    _this.resetWithFieldInitialValue({
      namePathList
    });
    _this.notifyObservers(prevStore, namePathList, {
      type: "reset"
    });
  };
  this.setFields = function(fields) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    fields.forEach(function(fieldData) {
      var name = fieldData.name;
      fieldData.errors;
      var data = _objectWithoutProperties(fieldData, _excluded$1);
      var namePath = getNamePath(name);
      if ("value" in data) {
        _this.store = setValue(_this.store, namePath, data.value);
      }
      _this.notifyObservers(prevStore, [namePath], {
        type: "setField",
        data: fieldData
      });
    });
  };
  this.getFields = function() {
    var entities = _this.getFieldEntities(true);
    var fields = entities.map(function(field) {
      var namePath = field.getNamePath();
      var meta = field.getMeta();
      var fieldData = _objectSpread2(_objectSpread2({}, meta), {}, {
        name: namePath,
        value: _this.getFieldValue(namePath)
      });
      Object.defineProperty(fieldData, "originRCField", {
        value: true
      });
      return fieldData;
    });
    return fields;
  };
  this.initEntityValue = function(entity) {
    var initialValue = entity.props.initialValue;
    if (initialValue !== void 0) {
      var namePath = entity.getNamePath();
      var prevValue = getValue(_this.store, namePath);
      if (prevValue === void 0) {
        _this.store = setValue(_this.store, namePath, initialValue);
      }
    }
  };
  this.registerField = function(entity) {
    _this.fieldEntities.push(entity);
    if (entity.props.initialValue !== void 0) {
      var prevStore = _this.store;
      _this.resetWithFieldInitialValue({
        entities: [entity],
        skipExist: true
      });
      _this.notifyObservers(prevStore, [entity.getNamePath()], {
        type: "valueUpdate",
        source: "internal"
      });
    }
    return function(isListField, preserve) {
      var subNamePath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
      _this.fieldEntities = _this.fieldEntities.filter(function(item) {
        return item !== entity;
      });
      var mergedPreserve = preserve !== void 0 ? preserve : _this.preserve;
      if (mergedPreserve === false && (!isListField || subNamePath.length > 1)) {
        var namePath = entity.getNamePath();
        var defaultValue = isListField ? void 0 : getValue(_this.initialValues, namePath);
        if (namePath.length && _this.getFieldValue(namePath) !== defaultValue && _this.fieldEntities.every(function(field) {
          return !matchNamePath(field.getNamePath(), namePath);
        })) {
          var _prevStore = _this.store;
          _this.store = setValue(_prevStore, namePath, defaultValue, true);
          _this.notifyObservers(_prevStore, [namePath], {
            type: "remove"
          });
          _this.triggerDependenciesUpdate(_prevStore, namePath);
        }
      }
    };
  };
  this.dispatch = function(action) {
    switch (action.type) {
      case "updateValue": {
        var namePath = action.namePath, value = action.value;
        _this.updateValue(namePath, value);
        break;
      }
      case "validateField": {
        var _namePath = action.namePath, triggerName = action.triggerName;
        _this.validateFields([_namePath], {
          triggerName
        });
        break;
      }
    }
  };
  this.notifyObservers = function(prevStore, namePathList, info) {
    if (_this.subscribable) {
      var mergedInfo = _objectSpread2(_objectSpread2({}, info), {}, {
        store: _this.getFieldsValue(true)
      });
      _this.getFieldEntities().forEach(function(_ref2) {
        var onStoreChange = _ref2.onStoreChange;
        onStoreChange(prevStore, namePathList, mergedInfo);
      });
    } else {
      _this.forceRootUpdate();
    }
  };
  this.triggerDependenciesUpdate = function(prevStore, namePath) {
    var childrenFields = _this.getDependencyChildrenFields(namePath);
    if (childrenFields.length) {
      _this.validateFields(childrenFields);
    }
    _this.notifyObservers(prevStore, childrenFields, {
      type: "dependenciesUpdate",
      relatedFields: [namePath].concat(_toConsumableArray(childrenFields))
    });
    return childrenFields;
  };
  this.updateValue = function(name, value) {
    var namePath = getNamePath(name);
    var prevStore = _this.store;
    _this.store = setValue(_this.store, namePath, value);
    _this.notifyObservers(prevStore, [namePath], {
      type: "valueUpdate",
      source: "internal"
    });
    var childrenFields = _this.triggerDependenciesUpdate(prevStore, namePath);
    var onValuesChange = _this.callbacks.onValuesChange;
    if (onValuesChange) {
      var changedValues = cloneByNamePathList(_this.store, [namePath]);
      onValuesChange(changedValues, _this.getFieldsValue());
    }
    _this.triggerOnFieldsChange([namePath].concat(_toConsumableArray(childrenFields)));
  };
  this.setFieldsValue = function(store) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (store) {
      _this.store = setValues(_this.store, store);
    }
    _this.notifyObservers(prevStore, null, {
      type: "valueUpdate",
      source: "external"
    });
  };
  this.getDependencyChildrenFields = function(rootNamePath) {
    var children = /* @__PURE__ */ new Set();
    var childrenFields = [];
    var dependencies2fields = new NameMap();
    _this.getFieldEntities().forEach(function(field) {
      var dependencies = field.props.dependencies;
      (dependencies || []).forEach(function(dependency) {
        var dependencyNamePath = getNamePath(dependency);
        dependencies2fields.update(dependencyNamePath, function() {
          var fields = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
          fields.add(field);
          return fields;
        });
      });
    });
    var fillChildren = function fillChildren2(namePath) {
      var fields = dependencies2fields.get(namePath) || /* @__PURE__ */ new Set();
      fields.forEach(function(field) {
        if (!children.has(field)) {
          children.add(field);
          var fieldNamePath = field.getNamePath();
          if (field.isFieldDirty() && fieldNamePath.length) {
            childrenFields.push(fieldNamePath);
            fillChildren2(fieldNamePath);
          }
        }
      });
    };
    fillChildren(rootNamePath);
    return childrenFields;
  };
  this.triggerOnFieldsChange = function(namePathList, filedErrors) {
    var onFieldsChange = _this.callbacks.onFieldsChange;
    if (onFieldsChange) {
      var fields = _this.getFields();
      if (filedErrors) {
        var cache = new NameMap();
        filedErrors.forEach(function(_ref3) {
          var name = _ref3.name, errors = _ref3.errors;
          cache.set(name, errors);
        });
        fields.forEach(function(field) {
          field.errors = cache.get(field.name) || field.errors;
        });
      }
      var changedFields = fields.filter(function(_ref4) {
        var fieldName = _ref4.name;
        return containsNamePath(namePathList, fieldName);
      });
      onFieldsChange(changedFields, fields);
    }
  };
  this.validateFields = function(nameList, options) {
    _this.warningUnhooked();
    var provideNameList = !!nameList;
    var namePathList = provideNameList ? nameList.map(getNamePath) : [];
    var promiseList = [];
    _this.getFieldEntities(true).forEach(function(field) {
      if (!provideNameList) {
        namePathList.push(field.getNamePath());
      }
      if ((options === null || options === void 0 ? void 0 : options.recursive) && provideNameList) {
        var namePath = field.getNamePath();
        if (namePath.every(function(nameUnit, i) {
          return nameList[i] === nameUnit || nameList[i] === void 0;
        })) {
          namePathList.push(namePath);
        }
      }
      if (!field.props.rules || !field.props.rules.length) {
        return;
      }
      var fieldNamePath = field.getNamePath();
      if (!provideNameList || containsNamePath(namePathList, fieldNamePath)) {
        var promise = field.validateRules(_objectSpread2({
          validateMessages: _objectSpread2(_objectSpread2({}, defaultValidateMessages), _this.validateMessages)
        }, options));
        promiseList.push(promise.then(function() {
          return {
            name: fieldNamePath,
            errors: [],
            warnings: []
          };
        }).catch(function(ruleErrors) {
          var mergedErrors = [];
          var mergedWarnings = [];
          ruleErrors.forEach(function(_ref5) {
            var warningOnly = _ref5.rule.warningOnly, errors = _ref5.errors;
            if (warningOnly) {
              mergedWarnings.push.apply(mergedWarnings, _toConsumableArray(errors));
            } else {
              mergedErrors.push.apply(mergedErrors, _toConsumableArray(errors));
            }
          });
          if (mergedErrors.length) {
            return Promise.reject({
              name: fieldNamePath,
              errors: mergedErrors,
              warnings: mergedWarnings
            });
          }
          return {
            name: fieldNamePath,
            errors: mergedErrors,
            warnings: mergedWarnings
          };
        }));
      }
    });
    var summaryPromise = allPromiseFinish(promiseList);
    _this.lastValidatePromise = summaryPromise;
    summaryPromise.catch(function(results) {
      return results;
    }).then(function(results) {
      var resultNamePathList = results.map(function(_ref6) {
        var name = _ref6.name;
        return name;
      });
      _this.notifyObservers(_this.store, resultNamePathList, {
        type: "validateFinish"
      });
      _this.triggerOnFieldsChange(resultNamePathList, results);
    });
    var returnPromise = summaryPromise.then(function() {
      if (_this.lastValidatePromise === summaryPromise) {
        return Promise.resolve(_this.getFieldsValue(namePathList));
      }
      return Promise.reject([]);
    }).catch(function(results) {
      var errorList = results.filter(function(result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: _this.getFieldsValue(namePathList),
        errorFields: errorList,
        outOfDate: _this.lastValidatePromise !== summaryPromise
      });
    });
    returnPromise.catch(function(e2) {
      return e2;
    });
    return returnPromise;
  };
  this.submit = function() {
    _this.warningUnhooked();
    _this.validateFields().then(function(values) {
      var onFinish = _this.callbacks.onFinish;
      if (onFinish) {
        try {
          onFinish(values);
        } catch (err) {
          console.error(err);
        }
      }
    }).catch(function(e2) {
      var onFinishFailed = _this.callbacks.onFinishFailed;
      if (onFinishFailed) {
        onFinishFailed(e2);
      }
    });
  };
  this.forceRootUpdate = forceRootUpdate;
});
function useForm(form) {
  var formRef = React.useRef();
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), forceUpdate = _React$useState2[1];
  if (!formRef.current) {
    if (form) {
      formRef.current = form;
    } else {
      var forceReRender = function forceReRender2() {
        forceUpdate({});
      };
      var formStore = new FormStore(forceReRender);
      formRef.current = formStore.getForm();
    }
  }
  return [formRef.current];
}
var FormContext = /* @__PURE__ */ React.createContext({
  triggerFormChange: function triggerFormChange() {
  },
  triggerFormFinish: function triggerFormFinish() {
  },
  registerForm: function registerForm() {
  },
  unregisterForm: function unregisterForm() {
  }
});
var FormProvider = function FormProvider2(_ref) {
  var validateMessages = _ref.validateMessages, onFormChange = _ref.onFormChange, onFormFinish = _ref.onFormFinish, children = _ref.children;
  var formContext = React.useContext(FormContext);
  var formsRef = React.useRef({});
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: _objectSpread2(_objectSpread2({}, formContext), {}, {
      validateMessages: _objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages),
      triggerFormChange: function triggerFormChange2(name, changedFields) {
        if (onFormChange) {
          onFormChange(name, {
            changedFields,
            forms: formsRef.current
          });
        }
        formContext.triggerFormChange(name, changedFields);
      },
      triggerFormFinish: function triggerFormFinish2(name, values) {
        if (onFormFinish) {
          onFormFinish(name, {
            values,
            forms: formsRef.current
          });
        }
        formContext.triggerFormFinish(name, values);
      },
      registerForm: function registerForm2(name, form) {
        if (name) {
          formsRef.current = _objectSpread2(_objectSpread2({}, formsRef.current), {}, _defineProperty({}, name, form));
        }
        formContext.registerForm(name, form);
      },
      unregisterForm: function unregisterForm2(name) {
        var newForms = _objectSpread2({}, formsRef.current);
        delete newForms[name];
        formsRef.current = newForms;
        formContext.unregisterForm(name);
      }
    })
  }, children);
};
var _excluded = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"];
var Form = function Form2(_ref, ref) {
  var name = _ref.name, initialValues = _ref.initialValues, fields = _ref.fields, form = _ref.form, preserve = _ref.preserve, children = _ref.children, _ref$component = _ref.component, Component = _ref$component === void 0 ? "form" : _ref$component, validateMessages = _ref.validateMessages, _ref$validateTrigger = _ref.validateTrigger, validateTrigger = _ref$validateTrigger === void 0 ? "onChange" : _ref$validateTrigger, onValuesChange = _ref.onValuesChange, _onFieldsChange = _ref.onFieldsChange, _onFinish = _ref.onFinish, onFinishFailed = _ref.onFinishFailed, restProps = _objectWithoutProperties(_ref, _excluded);
  var formContext = React.useContext(FormContext);
  var _useForm = useForm(form), _useForm2 = _slicedToArray(_useForm, 1), formInstance = _useForm2[0];
  var _formInstance$getInte = formInstance.getInternalHooks(HOOK_MARK), useSubscribe = _formInstance$getInte.useSubscribe, setInitialValues = _formInstance$getInte.setInitialValues, setCallbacks = _formInstance$getInte.setCallbacks, setValidateMessages = _formInstance$getInte.setValidateMessages, setPreserve = _formInstance$getInte.setPreserve;
  React.useImperativeHandle(ref, function() {
    return formInstance;
  });
  React.useEffect(function() {
    formContext.registerForm(name, formInstance);
    return function() {
      formContext.unregisterForm(name);
    };
  }, [formContext, formInstance, name]);
  setValidateMessages(_objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages));
  setCallbacks({
    onValuesChange,
    onFieldsChange: function onFieldsChange(changedFields) {
      formContext.triggerFormChange(name, changedFields);
      if (_onFieldsChange) {
        for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          rest[_key - 1] = arguments[_key];
        }
        _onFieldsChange.apply(void 0, [changedFields].concat(rest));
      }
    },
    onFinish: function onFinish(values2) {
      formContext.triggerFormFinish(name, values2);
      if (_onFinish) {
        _onFinish(values2);
      }
    },
    onFinishFailed
  });
  setPreserve(preserve);
  var mountRef = React.useRef(null);
  setInitialValues(initialValues, !mountRef.current);
  if (!mountRef.current) {
    mountRef.current = true;
  }
  var childrenNode = children;
  var childrenRenderProps = typeof children === "function";
  if (childrenRenderProps) {
    var values = formInstance.getFieldsValue(true);
    childrenNode = children(values, formInstance);
  }
  useSubscribe(!childrenRenderProps);
  var prevFieldsRef = React.useRef();
  React.useEffect(function() {
    if (!isSimilar(prevFieldsRef.current || [], fields || [])) {
      formInstance.setFields(fields || []);
    }
    prevFieldsRef.current = fields;
  }, [fields, formInstance]);
  var formContextValue = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, formInstance), {}, {
      validateTrigger
    });
  }, [formInstance, validateTrigger]);
  var wrapperNode = /* @__PURE__ */ React.createElement(Context.Provider, {
    value: formContextValue
  }, childrenNode);
  if (Component === false) {
    return wrapperNode;
  }
  return /* @__PURE__ */ React.createElement(Component, _extends$1({}, restProps, {
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      event.stopPropagation();
      formInstance.submit();
    },
    onReset: function onReset(event) {
      var _restProps$onReset;
      event.preventDefault();
      formInstance.resetFields();
      (_restProps$onReset = restProps.onReset) === null || _restProps$onReset === void 0 ? void 0 : _restProps$onReset.call(restProps, event);
    }
  }), wrapperNode);
};
var InternalForm = /* @__PURE__ */ React.forwardRef(Form);
var RefForm = InternalForm;
RefForm.FormProvider = FormProvider;
RefForm.Field = WrapperField;
RefForm.List = List;
RefForm.useForm = useForm;
var devWarning = function(valid, component, message) {
  warningOnce(valid, "[antd: ".concat(component, "] ").concat(message));
};
var enUS$1 = {
  items_per_page: "/ page",
  jump_to: "Go to",
  jump_to_confirm: "confirm",
  page: "Page",
  prev_page: "Previous Page",
  next_page: "Next Page",
  prev_5: "Previous 5 Pages",
  next_5: "Next 5 Pages",
  prev_3: "Previous 3 Pages",
  next_3: "Next 3 Pages",
  page_size: "Page Size"
};
var locale$2 = {
  locale: "en_US",
  today: "Today",
  now: "Now",
  backToToday: "Back to today",
  ok: "Ok",
  clear: "Clear",
  month: "Month",
  year: "Year",
  timeSelect: "select time",
  dateSelect: "select date",
  weekSelect: "Choose a week",
  monthSelect: "Choose a month",
  yearSelect: "Choose a year",
  decadeSelect: "Choose a decade",
  yearFormat: "YYYY",
  dateFormat: "M/D/YYYY",
  dayFormat: "D",
  dateTimeFormat: "M/D/YYYY HH:mm:ss",
  monthBeforeYear: true,
  previousMonth: "Previous month (PageUp)",
  nextMonth: "Next month (PageDown)",
  previousYear: "Last year (Control + left)",
  nextYear: "Next year (Control + right)",
  previousDecade: "Last decade",
  nextDecade: "Next decade",
  previousCentury: "Last century",
  nextCentury: "Next century"
};
var locale$1 = {
  placeholder: "Select time",
  rangePlaceholder: ["Start time", "End time"]
};
var TimePicker = locale$1;
var locale = {
  lang: _extends$1({
    placeholder: "Select date",
    yearPlaceholder: "Select year",
    quarterPlaceholder: "Select quarter",
    monthPlaceholder: "Select month",
    weekPlaceholder: "Select week",
    rangePlaceholder: ["Start date", "End date"],
    rangeYearPlaceholder: ["Start year", "End year"],
    rangeQuarterPlaceholder: ["Start quarter", "End quarter"],
    rangeMonthPlaceholder: ["Start month", "End month"],
    rangeWeekPlaceholder: ["Start week", "End week"]
  }, locale$2),
  timePickerLocale: _extends$1({}, TimePicker)
};
var enUS = locale;
var typeTemplate = "${label} is not a valid ${type}";
var localeValues = {
  locale: "en",
  Pagination: enUS$1,
  DatePicker: enUS,
  TimePicker,
  Calendar: enUS,
  global: {
    placeholder: "Please select"
  },
  Table: {
    filterTitle: "Filter menu",
    filterConfirm: "OK",
    filterReset: "Reset",
    filterEmptyText: "No filters",
    filterCheckall: "Select all items",
    filterSearchPlaceholder: "Search in filters",
    emptyText: "No data",
    selectAll: "Select current page",
    selectInvert: "Invert current page",
    selectNone: "Clear all data",
    selectionAll: "Select all data",
    sortTitle: "Sort",
    expand: "Expand row",
    collapse: "Collapse row",
    triggerDesc: "Click to sort descending",
    triggerAsc: "Click to sort ascending",
    cancelSort: "Click to cancel sorting"
  },
  Modal: {
    okText: "OK",
    cancelText: "Cancel",
    justOkText: "OK"
  },
  Popconfirm: {
    okText: "OK",
    cancelText: "Cancel"
  },
  Transfer: {
    titles: ["", ""],
    searchPlaceholder: "Search here",
    itemUnit: "item",
    itemsUnit: "items",
    remove: "Remove",
    selectCurrent: "Select current page",
    removeCurrent: "Remove current page",
    selectAll: "Select all data",
    removeAll: "Remove all data",
    selectInvert: "Invert current page"
  },
  Upload: {
    uploading: "Uploading...",
    removeFile: "Remove file",
    uploadError: "Upload error",
    previewFile: "Preview file",
    downloadFile: "Download file"
  },
  Empty: {
    description: "No Data"
  },
  Icon: {
    icon: "icon"
  },
  Text: {
    edit: "Edit",
    copy: "Copy",
    copied: "Copied",
    expand: "Expand"
  },
  PageHeader: {
    back: "Back"
  },
  Form: {
    optional: "(optional)",
    defaultValidateMessages: {
      "default": "Field validation error for ${label}",
      required: "Please enter ${label}",
      "enum": "${label} must be one of [${enum}]",
      whitespace: "${label} cannot be a blank character",
      date: {
        format: "${label} date format is invalid",
        parse: "${label} cannot be converted to a date",
        invalid: "${label} is an invalid date"
      },
      types: {
        string: typeTemplate,
        method: typeTemplate,
        array: typeTemplate,
        object: typeTemplate,
        number: typeTemplate,
        date: typeTemplate,
        "boolean": typeTemplate,
        integer: typeTemplate,
        "float": typeTemplate,
        regexp: typeTemplate,
        email: typeTemplate,
        url: typeTemplate,
        hex: typeTemplate
      },
      string: {
        len: "${label} must be ${len} characters",
        min: "${label} must be at least ${min} characters",
        max: "${label} must be up to ${max} characters",
        range: "${label} must be between ${min}-${max} characters"
      },
      number: {
        len: "${label} must be equal to ${len}",
        min: "${label} must be minimum ${min}",
        max: "${label} must be maximum ${max}",
        range: "${label} must be between ${min}-${max}"
      },
      array: {
        len: "Must be ${len} ${label}",
        min: "At least ${min} ${label}",
        max: "At most ${max} ${label}",
        range: "The amount of ${label} must be between ${min}-${max}"
      },
      pattern: {
        mismatch: "${label} does not match the pattern ${pattern}"
      }
    }
  },
  Image: {
    preview: "Preview"
  }
};
var defaultLocale = localeValues;
var LocaleContext = /* @__PURE__ */ createContext(void 0);
var LocaleContext$1 = LocaleContext;
var LocaleReceiver = /* @__PURE__ */ function(_React$Component) {
  _inherits(LocaleReceiver2, _React$Component);
  var _super = _createSuper(LocaleReceiver2);
  function LocaleReceiver2() {
    _classCallCheck(this, LocaleReceiver2);
    return _super.apply(this, arguments);
  }
  _createClass(LocaleReceiver2, [{
    key: "getLocale",
    value: function getLocale() {
      var _this$props = this.props, componentName = _this$props.componentName, defaultLocale$1 = _this$props.defaultLocale;
      var locale2 = defaultLocale$1 || defaultLocale[componentName !== null && componentName !== void 0 ? componentName : "global"];
      var antLocale = this.context;
      var localeFromContext = componentName && antLocale ? antLocale[componentName] : {};
      return _extends$1(_extends$1({}, locale2 instanceof Function ? locale2() : locale2), localeFromContext || {});
    }
  }, {
    key: "getLocaleCode",
    value: function getLocaleCode() {
      var antLocale = this.context;
      var localeCode = antLocale && antLocale.locale;
      if (antLocale && antLocale.exist && !localeCode) {
        return defaultLocale.locale;
      }
      return localeCode;
    }
  }, {
    key: "render",
    value: function render2() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    }
  }]);
  return LocaleReceiver2;
}(React.Component);
LocaleReceiver.defaultProps = {
  componentName: "global"
};
LocaleReceiver.contextType = LocaleContext$1;
var Empty$2 = function Empty() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-default");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "184",
    height: "152",
    viewBox: "0 0 184 152",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(24 31.67)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "67.797",
    cy: "106.89",
    rx: "67.797",
    ry: "12.668"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-1"),
    d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-2"),
    d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z",
    transform: "translate(13.56)"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-3"),
    d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-4"),
    d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z"
  })), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-5"),
    d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    transform: "translate(149.65 15.383)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    cx: "20.654",
    cy: "3.167",
    rx: "2.849",
    ry: "2.815"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z"
  }))));
};
var DefaultEmptyImg = Empty$2;
var Simple = function Simple2() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-simple");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "64",
    height: "41",
    viewBox: "0 0 64 41",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(0 1)",
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "32",
    cy: "33",
    rx: "32",
    ry: "7"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    fillRule: "nonzero"
  }, /* @__PURE__ */ React.createElement("path", {
    d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z",
    className: "".concat(prefixCls, "-path")
  }))));
};
var SimpleEmptyImg = Simple;
var __rest$3 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var defaultEmptyImg = /* @__PURE__ */ React.createElement(DefaultEmptyImg, null);
var simpleEmptyImg = /* @__PURE__ */ React.createElement(SimpleEmptyImg, null);
var Empty2 = function Empty3(_a2) {
  var className = _a2.className, customizePrefixCls = _a2.prefixCls, _a$image = _a2.image, image = _a$image === void 0 ? defaultEmptyImg : _a$image, description = _a2.description, children = _a2.children, imageStyle = _a2.imageStyle, restProps = __rest$3(_a2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  return /* @__PURE__ */ React.createElement(LocaleReceiver, {
    componentName: "Empty"
  }, function(locale2) {
    var _classNames;
    var prefixCls = getPrefixCls("empty", customizePrefixCls);
    var des = typeof description !== "undefined" ? description : locale2.description;
    var alt = typeof des === "string" ? des : "empty";
    var imageNode = null;
    if (typeof image === "string") {
      imageNode = /* @__PURE__ */ React.createElement("img", {
        alt,
        src: image
      });
    } else {
      imageNode = image;
    }
    return /* @__PURE__ */ React.createElement("div", _extends$1({
      className: classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-normal"), image === simpleEmptyImg), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className)
    }, restProps), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-image"),
      style: imageStyle
    }, imageNode), des && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-description")
    }, des), children && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, children));
  });
};
Empty2.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty2.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
var Empty$1 = Empty2;
var renderEmpty = function renderEmpty2(componentName) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var getPrefixCls = _ref.getPrefixCls;
    var prefix = getPrefixCls("empty");
    switch (componentName) {
      case "Table":
      case "List":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE
        });
      case "Select":
      case "TreeSelect":
      case "Cascader":
      case "Transfer":
      case "Mentions":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE,
          className: "".concat(prefix, "-small")
        });
      default:
        return /* @__PURE__ */ React.createElement(Empty$1, null);
    }
  });
};
var defaultRenderEmpty = renderEmpty;
var defaultGetPrefixCls = function defaultGetPrefixCls2(suffixCls, customizePrefixCls) {
  if (customizePrefixCls)
    return customizePrefixCls;
  return suffixCls ? "ant-".concat(suffixCls) : "ant";
};
var ConfigContext = /* @__PURE__ */ React.createContext({
  getPrefixCls: defaultGetPrefixCls,
  renderEmpty: defaultRenderEmpty
});
var ConfigConsumer = ConfigContext.Consumer;
var SizeContext = /* @__PURE__ */ React.createContext(void 0);
var SizeContext$1 = SizeContext;
var raf = function raf2(callback) {
  return +setTimeout(callback, 16);
};
var caf = function caf2(num) {
  return clearTimeout(num);
};
if (typeof window !== "undefined" && "requestAnimationFrame" in window) {
  raf = function raf3(callback) {
    return window.requestAnimationFrame(callback);
  };
  caf = function caf3(handle) {
    return window.cancelAnimationFrame(handle);
  };
}
var rafUUID = 0;
var rafIds = /* @__PURE__ */ new Map();
function cleanup(id2) {
  rafIds.delete(id2);
}
function wrapperRaf$1(callback) {
  var times = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  rafUUID += 1;
  var id2 = rafUUID;
  function callRef(leftTimes) {
    if (leftTimes === 0) {
      cleanup(id2);
      callback();
    } else {
      var realId = raf(function() {
        callRef(leftTimes - 1);
      });
      rafIds.set(id2, realId);
    }
  }
  callRef(times);
  return id2;
}
wrapperRaf$1.cancel = function(id2) {
  var realId = rafIds.get(id2);
  cleanup(realId);
  return caf(realId);
};
function useControlledState(defaultStateValue, option) {
  var _ref = option || {}, defaultValue = _ref.defaultValue, value = _ref.value, onChange = _ref.onChange, postState = _ref.postState;
  var _React$useState = React.useState(function() {
    if (value !== void 0) {
      return value;
    }
    if (defaultValue !== void 0) {
      return typeof defaultValue === "function" ? defaultValue() : defaultValue;
    }
    return typeof defaultStateValue === "function" ? defaultStateValue() : defaultStateValue;
  }), _React$useState2 = _slicedToArray(_React$useState, 2), innerValue = _React$useState2[0], setInnerValue = _React$useState2[1];
  var mergedValue = value !== void 0 ? value : innerValue;
  if (postState) {
    mergedValue = postState(mergedValue);
  }
  var onChangeRef = React.useRef(onChange);
  onChangeRef.current = onChange;
  var triggerChange = React.useCallback(function(newValue) {
    setInnerValue(newValue);
    if (mergedValue !== newValue && onChangeRef.current) {
      onChangeRef.current(newValue, mergedValue);
    }
  }, [mergedValue, onChangeRef]);
  var firstRenderRef = React.useRef(true);
  React.useEffect(function() {
    if (firstRenderRef.current) {
      firstRenderRef.current = false;
      return;
    }
    if (value === void 0) {
      setInnerValue(value);
    }
  }, [value]);
  return [mergedValue, triggerChange];
}
var KeyCode = {
  MAC_ENTER: 3,
  BACKSPACE: 8,
  TAB: 9,
  NUM_CENTER: 12,
  ENTER: 13,
  SHIFT: 16,
  CTRL: 17,
  ALT: 18,
  PAUSE: 19,
  CAPS_LOCK: 20,
  ESC: 27,
  SPACE: 32,
  PAGE_UP: 33,
  PAGE_DOWN: 34,
  END: 35,
  HOME: 36,
  LEFT: 37,
  UP: 38,
  RIGHT: 39,
  DOWN: 40,
  PRINT_SCREEN: 44,
  INSERT: 45,
  DELETE: 46,
  ZERO: 48,
  ONE: 49,
  TWO: 50,
  THREE: 51,
  FOUR: 52,
  FIVE: 53,
  SIX: 54,
  SEVEN: 55,
  EIGHT: 56,
  NINE: 57,
  QUESTION_MARK: 63,
  A: 65,
  B: 66,
  C: 67,
  D: 68,
  E: 69,
  F: 70,
  G: 71,
  H: 72,
  I: 73,
  J: 74,
  K: 75,
  L: 76,
  M: 77,
  N: 78,
  O: 79,
  P: 80,
  Q: 81,
  R: 82,
  S: 83,
  T: 84,
  U: 85,
  V: 86,
  W: 87,
  X: 88,
  Y: 89,
  Z: 90,
  META: 91,
  WIN_KEY_RIGHT: 92,
  CONTEXT_MENU: 93,
  NUM_ZERO: 96,
  NUM_ONE: 97,
  NUM_TWO: 98,
  NUM_THREE: 99,
  NUM_FOUR: 100,
  NUM_FIVE: 101,
  NUM_SIX: 102,
  NUM_SEVEN: 103,
  NUM_EIGHT: 104,
  NUM_NINE: 105,
  NUM_MULTIPLY: 106,
  NUM_PLUS: 107,
  NUM_MINUS: 109,
  NUM_PERIOD: 110,
  NUM_DIVISION: 111,
  F1: 112,
  F2: 113,
  F3: 114,
  F4: 115,
  F5: 116,
  F6: 117,
  F7: 118,
  F8: 119,
  F9: 120,
  F10: 121,
  F11: 122,
  F12: 123,
  NUMLOCK: 144,
  SEMICOLON: 186,
  DASH: 189,
  EQUALS: 187,
  COMMA: 188,
  PERIOD: 190,
  SLASH: 191,
  APOSTROPHE: 192,
  SINGLE_QUOTE: 222,
  OPEN_SQUARE_BRACKET: 219,
  BACKSLASH: 220,
  CLOSE_SQUARE_BRACKET: 221,
  WIN_KEY: 224,
  MAC_FF_META: 224,
  WIN_IME: 229,
  isTextModifyingKeyEvent: function isTextModifyingKeyEvent(e2) {
    var keyCode = e2.keyCode;
    if (e2.altKey && !e2.ctrlKey || e2.metaKey || keyCode >= KeyCode.F1 && keyCode <= KeyCode.F12) {
      return false;
    }
    switch (keyCode) {
      case KeyCode.ALT:
      case KeyCode.CAPS_LOCK:
      case KeyCode.CONTEXT_MENU:
      case KeyCode.CTRL:
      case KeyCode.DOWN:
      case KeyCode.END:
      case KeyCode.ESC:
      case KeyCode.HOME:
      case KeyCode.INSERT:
      case KeyCode.LEFT:
      case KeyCode.MAC_FF_META:
      case KeyCode.META:
      case KeyCode.NUMLOCK:
      case KeyCode.NUM_CENTER:
      case KeyCode.PAGE_DOWN:
      case KeyCode.PAGE_UP:
      case KeyCode.PAUSE:
      case KeyCode.PRINT_SCREEN:
      case KeyCode.RIGHT:
      case KeyCode.SHIFT:
      case KeyCode.UP:
      case KeyCode.WIN_KEY:
      case KeyCode.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  },
  isCharacterKey: function isCharacterKey(keyCode) {
    if (keyCode >= KeyCode.ZERO && keyCode <= KeyCode.NINE) {
      return true;
    }
    if (keyCode >= KeyCode.NUM_ZERO && keyCode <= KeyCode.NUM_MULTIPLY) {
      return true;
    }
    if (keyCode >= KeyCode.A && keyCode <= KeyCode.Z) {
      return true;
    }
    if (window.navigator.userAgent.indexOf("WebKit") !== -1 && keyCode === 0) {
      return true;
    }
    switch (keyCode) {
      case KeyCode.SPACE:
      case KeyCode.QUESTION_MARK:
      case KeyCode.NUM_PLUS:
      case KeyCode.NUM_MINUS:
      case KeyCode.NUM_PERIOD:
      case KeyCode.NUM_DIVISION:
      case KeyCode.SEMICOLON:
      case KeyCode.DASH:
      case KeyCode.EQUALS:
      case KeyCode.COMMA:
      case KeyCode.PERIOD:
      case KeyCode.SLASH:
      case KeyCode.APOSTROPHE:
      case KeyCode.SINGLE_QUOTE:
      case KeyCode.OPEN_SQUARE_BRACKET:
      case KeyCode.BACKSLASH:
      case KeyCode.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  }
};
var tuple = function tuple2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return args;
};
var isValidElement = React.isValidElement;
function replaceElement(element, replacement, props) {
  if (!isValidElement(element))
    return replacement;
  return /* @__PURE__ */ React.cloneElement(element, typeof props === "function" ? props(element.props || {}) : props);
}
function cloneElement(element, props) {
  return replaceElement(element, element, props);
}
var responsiveArray = ["xxl", "xl", "lg", "md", "sm", "xs"];
var responsiveMap = {
  xs: "(max-width: 575px)",
  sm: "(min-width: 576px)",
  md: "(min-width: 768px)",
  lg: "(min-width: 992px)",
  xl: "(min-width: 1200px)",
  xxl: "(min-width: 1600px)"
};
var subscribers = /* @__PURE__ */ new Map();
var subUid = -1;
var screens = {};
var responsiveObserve = {
  matchHandlers: {},
  dispatch: function dispatch(pointMap) {
    screens = pointMap;
    subscribers.forEach(function(func) {
      return func(screens);
    });
    return subscribers.size >= 1;
  },
  subscribe: function subscribe(func) {
    if (!subscribers.size)
      this.register();
    subUid += 1;
    subscribers.set(subUid, func);
    func(screens);
    return subUid;
  },
  unsubscribe: function unsubscribe(token) {
    subscribers["delete"](token);
    if (!subscribers.size)
      this.unregister();
  },
  unregister: function unregister2() {
    var _this = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var handler = _this.matchHandlers[matchMediaQuery];
      handler === null || handler === void 0 ? void 0 : handler.mql.removeListener(handler === null || handler === void 0 ? void 0 : handler.listener);
    });
    subscribers.clear();
  },
  register: function register3() {
    var _this2 = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var listener = function listener2(_ref) {
        var matches = _ref.matches;
        _this2.dispatch(_extends$1(_extends$1({}, screens), _defineProperty({}, screen, matches)));
      };
      var mql = window.matchMedia(matchMediaQuery);
      mql.addListener(listener);
      _this2.matchHandlers[matchMediaQuery] = {
        mql,
        listener
      };
      listener(mql);
    });
  }
};
var ResponsiveObserve = responsiveObserve;
var id = 0;
var ids = {};
function wrapperRaf(callback) {
  var delayFrames = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var myId = id++;
  var restFrames = delayFrames;
  function internalCallback() {
    restFrames -= 1;
    if (restFrames <= 0) {
      callback();
      delete ids[myId];
    } else {
      ids[myId] = wrapperRaf$1(internalCallback);
    }
  }
  ids[myId] = wrapperRaf$1(internalCallback);
  return myId;
}
wrapperRaf.cancel = function cancel(pid) {
  if (pid === void 0)
    return;
  wrapperRaf$1.cancel(ids[pid]);
  delete ids[pid];
};
wrapperRaf.ids = ids;
var styleForPseudo;
function isHidden(element) {
  return !element || element.offsetParent === null || element.hidden;
}
function isNotGrey(color) {
  var match = (color || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
  if (match && match[1] && match[2] && match[3]) {
    return !(match[1] === match[2] && match[2] === match[3]);
  }
  return true;
}
var Wave = /* @__PURE__ */ function(_React$Component) {
  _inherits(Wave2, _React$Component);
  var _super = _createSuper(Wave2);
  function Wave2() {
    var _this;
    _classCallCheck(this, Wave2);
    _this = _super.apply(this, arguments);
    _this.containerRef = /* @__PURE__ */ React.createRef();
    _this.animationStart = false;
    _this.destroyed = false;
    _this.onClick = function(node, waveColor) {
      var _a2, _b2;
      var _this$props = _this.props, insertExtraNode = _this$props.insertExtraNode, disabled = _this$props.disabled;
      if (disabled || !node || isHidden(node) || node.className.indexOf("-leave") >= 0) {
        return;
      }
      _this.extraNode = document.createElement("div");
      var _assertThisInitialize = _assertThisInitialized(_this), extraNode = _assertThisInitialize.extraNode;
      var getPrefixCls = _this.context.getPrefixCls;
      extraNode.className = "".concat(getPrefixCls(""), "-click-animating-node");
      var attributeName = _this.getAttributeName();
      node.setAttribute(attributeName, "true");
      if (waveColor && waveColor !== "#ffffff" && waveColor !== "rgb(255, 255, 255)" && isNotGrey(waveColor) && !/rgba\((?:\d*, ){3}0\)/.test(waveColor) && waveColor !== "transparent") {
        extraNode.style.borderColor = waveColor;
        var nodeRoot = ((_a2 = node.getRootNode) === null || _a2 === void 0 ? void 0 : _a2.call(node)) || node.ownerDocument;
        var nodeBody = nodeRoot instanceof Document ? nodeRoot.body : (_b2 = nodeRoot.firstChild) !== null && _b2 !== void 0 ? _b2 : nodeRoot;
        styleForPseudo = updateCSS("\n      [".concat(getPrefixCls(""), "-click-animating-without-extra-node='true']::after, .").concat(getPrefixCls(""), "-click-animating-node {\n        --antd-wave-shadow-color: ").concat(waveColor, ";\n      }"), "antd-wave", {
          csp: _this.csp,
          attachTo: nodeBody
        });
      }
      if (insertExtraNode) {
        node.appendChild(extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.addEventListener("".concat(name, "start"), _this.onTransitionStart);
        node.addEventListener("".concat(name, "end"), _this.onTransitionEnd);
      });
    };
    _this.onTransitionStart = function(e2) {
      if (_this.destroyed) {
        return;
      }
      var node = _this.containerRef.current;
      if (!e2 || e2.target !== node || _this.animationStart) {
        return;
      }
      _this.resetEffect(node);
    };
    _this.onTransitionEnd = function(e2) {
      if (!e2 || e2.animationName !== "fadeEffect") {
        return;
      }
      _this.resetEffect(e2.target);
    };
    _this.bindAnimationEvent = function(node) {
      if (!node || !node.getAttribute || node.getAttribute("disabled") || node.className.indexOf("disabled") >= 0) {
        return;
      }
      var onClick = function onClick2(e2) {
        if (e2.target.tagName === "INPUT" || isHidden(e2.target)) {
          return;
        }
        _this.resetEffect(node);
        var waveColor = getComputedStyle(node).getPropertyValue("border-top-color") || getComputedStyle(node).getPropertyValue("border-color") || getComputedStyle(node).getPropertyValue("background-color");
        _this.clickWaveTimeoutId = window.setTimeout(function() {
          return _this.onClick(node, waveColor);
        }, 0);
        wrapperRaf.cancel(_this.animationStartId);
        _this.animationStart = true;
        _this.animationStartId = wrapperRaf(function() {
          _this.animationStart = false;
        }, 10);
      };
      node.addEventListener("click", onClick, true);
      return {
        cancel: function cancel2() {
          node.removeEventListener("click", onClick, true);
        }
      };
    };
    _this.renderWave = function(_ref) {
      var csp = _ref.csp;
      var children = _this.props.children;
      _this.csp = csp;
      if (!/* @__PURE__ */ React.isValidElement(children))
        return children;
      var ref = _this.containerRef;
      if (supportRef(children)) {
        ref = composeRef(children.ref, _this.containerRef);
      }
      return cloneElement(children, {
        ref
      });
    };
    return _this;
  }
  _createClass(Wave2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.containerRef.current;
      if (!node || node.nodeType !== 1) {
        return;
      }
      this.instance = this.bindAnimationEvent(node);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.instance) {
        this.instance.cancel();
      }
      if (this.clickWaveTimeoutId) {
        clearTimeout(this.clickWaveTimeoutId);
      }
      this.destroyed = true;
    }
  }, {
    key: "getAttributeName",
    value: function getAttributeName() {
      var getPrefixCls = this.context.getPrefixCls;
      var insertExtraNode = this.props.insertExtraNode;
      return insertExtraNode ? "".concat(getPrefixCls(""), "-click-animating") : "".concat(getPrefixCls(""), "-click-animating-without-extra-node");
    }
  }, {
    key: "resetEffect",
    value: function resetEffect(node) {
      var _this2 = this;
      if (!node || node === this.extraNode || !(node instanceof Element)) {
        return;
      }
      var insertExtraNode = this.props.insertExtraNode;
      var attributeName = this.getAttributeName();
      node.setAttribute(attributeName, "false");
      if (styleForPseudo) {
        styleForPseudo.innerHTML = "";
      }
      if (insertExtraNode && this.extraNode && node.contains(this.extraNode)) {
        node.removeChild(this.extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.removeEventListener("".concat(name, "start"), _this2.onTransitionStart);
        node.removeEventListener("".concat(name, "end"), _this2.onTransitionEnd);
      });
    }
  }, {
    key: "render",
    value: function render2() {
      return /* @__PURE__ */ React.createElement(ConfigConsumer, null, this.renderWave);
    }
  }]);
  return Wave2;
}(React.Component);
Wave.contextType = ConfigContext;
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React__default, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c2, a, k2) {
  var b2, d2 = {}, e2 = null, l2 = null;
  k2 !== void 0 && (e2 = "" + k2);
  a.key !== void 0 && (e2 = "" + a.key);
  a.ref !== void 0 && (l2 = a.ref);
  for (b2 in a)
    n.call(a, b2) && !p.hasOwnProperty(b2) && (d2[b2] = a[b2]);
  if (c2 && c2.defaultProps)
    for (b2 in a = c2.defaultProps, a)
      d2[b2] === void 0 && (d2[b2] = a[b2]);
  return { $$typeof: g, type: c2, key: e2, ref: l2, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
var RowContext = /* @__PURE__ */ createContext({});
var RowContext$1 = RowContext;
var canUseDocElement = function canUseDocElement2() {
  return canUseDom() && window.document.documentElement;
};
var flexGapSupported;
var detectFlexGapSupported = function detectFlexGapSupported2() {
  if (!canUseDocElement()) {
    return false;
  }
  if (flexGapSupported !== void 0) {
    return flexGapSupported;
  }
  var flex = document.createElement("div");
  flex.style.display = "flex";
  flex.style.flexDirection = "column";
  flex.style.rowGap = "1px";
  flex.appendChild(document.createElement("div"));
  flex.appendChild(document.createElement("div"));
  document.body.appendChild(flex);
  flexGapSupported = flex.scrollHeight === 1;
  document.body.removeChild(flex);
  return flexGapSupported;
};
var useFlexGapSupport = function() {
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), flexible = _React$useState2[0], setFlexible = _React$useState2[1];
  React.useEffect(function() {
    setFlexible(detectFlexGapSupported());
  }, []);
  return flexible;
};
var __rest$2 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
tuple("top", "middle", "bottom", "stretch");
tuple("start", "end", "center", "space-around", "space-between");
var Row = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var customizePrefixCls = props.prefixCls, justify = props.justify, align = props.align, className = props.className, style = props.style, children = props.children, _props$gutter = props.gutter, gutter = _props$gutter === void 0 ? 0 : _props$gutter, wrap = props.wrap, others = __rest$2(props, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useState = React.useState({
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
    xxl: true
  }), _React$useState2 = _slicedToArray(_React$useState, 2), screens2 = _React$useState2[0], setScreens = _React$useState2[1];
  var supportFlexGap = useFlexGapSupport();
  var gutterRef = React.useRef(gutter);
  React.useEffect(function() {
    var token = ResponsiveObserve.subscribe(function(screen) {
      var currentGutter = gutterRef.current || 0;
      if (!Array.isArray(currentGutter) && _typeof(currentGutter) === "object" || Array.isArray(currentGutter) && (_typeof(currentGutter[0]) === "object" || _typeof(currentGutter[1]) === "object")) {
        setScreens(screen);
      }
    });
    return function() {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  var getGutter = function getGutter2() {
    var results = [0, 0];
    var normalizedGutter = Array.isArray(gutter) ? gutter : [gutter, 0];
    normalizedGutter.forEach(function(g2, index2) {
      if (_typeof(g2) === "object") {
        for (var i = 0; i < responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (screens2[breakpoint] && g2[breakpoint] !== void 0) {
            results[index2] = g2[breakpoint];
            break;
          }
        }
      } else {
        results[index2] = g2 || 0;
      }
    });
    return results;
  };
  var prefixCls = getPrefixCls("row", customizePrefixCls);
  var gutters = getGutter();
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-no-wrap"), wrap === false), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(justify), justify), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(align), align), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var rowStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / -2 : void 0;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / -2 : void 0;
  if (horizontalGutter) {
    rowStyle.marginLeft = horizontalGutter;
    rowStyle.marginRight = horizontalGutter;
  }
  if (supportFlexGap) {
    var _gutters = _slicedToArray(gutters, 2);
    rowStyle.rowGap = _gutters[1];
  } else if (verticalGutter) {
    rowStyle.marginTop = verticalGutter;
    rowStyle.marginBottom = verticalGutter;
  }
  var _gutters2 = _slicedToArray(gutters, 2), gutterH = _gutters2[0], gutterV = _gutters2[1];
  var rowContext = React.useMemo(function() {
    return {
      gutter: [gutterH, gutterV],
      wrap,
      supportFlexGap
    };
  }, [gutterH, gutterV, wrap, supportFlexGap]);
  return /* @__PURE__ */ React.createElement(RowContext$1.Provider, {
    value: rowContext
  }, /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    className: classes,
    style: _extends$1(_extends$1({}, rowStyle), style),
    ref
  }), children));
});
Row.displayName = "Row";
var Row$1 = Row;
var __rest$1 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function parseFlex(flex) {
  if (typeof flex === "number") {
    return "".concat(flex, " ").concat(flex, " auto");
  }
  if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(flex)) {
    return "0 0 ".concat(flex);
  }
  return flex;
}
var sizes = ["xs", "sm", "md", "lg", "xl", "xxl"];
var Col = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useContext2 = React.useContext(RowContext$1), gutter = _React$useContext2.gutter, wrap = _React$useContext2.wrap, supportFlexGap = _React$useContext2.supportFlexGap;
  var customizePrefixCls = props.prefixCls, span = props.span, order = props.order, offset = props.offset, push2 = props.push, pull = props.pull, className = props.className, children = props.children, flex = props.flex, style = props.style, others = __rest$1(props, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]);
  var prefixCls = getPrefixCls("col", customizePrefixCls);
  var sizeClassObj = {};
  sizes.forEach(function(size) {
    var _extends2;
    var sizeProps = {};
    var propSize = props[size];
    if (typeof propSize === "number") {
      sizeProps.span = propSize;
    } else if (_typeof(propSize) === "object") {
      sizeProps = propSize || {};
    }
    delete others[size];
    sizeClassObj = _extends$1(_extends$1({}, sizeClassObj), (_extends2 = {}, _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-").concat(sizeProps.span), sizeProps.span !== void 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-order-").concat(sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-push-").concat(sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-pull-").concat(sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _defineProperty(_extends2, "".concat(prefixCls, "-rtl"), direction === "rtl"), _extends2));
  });
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(span), span !== void 0), _defineProperty(_classNames, "".concat(prefixCls, "-order-").concat(order), order), _defineProperty(_classNames, "".concat(prefixCls, "-offset-").concat(offset), offset), _defineProperty(_classNames, "".concat(prefixCls, "-push-").concat(push2), push2), _defineProperty(_classNames, "".concat(prefixCls, "-pull-").concat(pull), pull), _classNames), className, sizeClassObj);
  var mergedStyle = {};
  if (gutter && gutter[0] > 0) {
    var horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingLeft = horizontalGutter;
    mergedStyle.paddingRight = horizontalGutter;
  }
  if (gutter && gutter[1] > 0 && !supportFlexGap) {
    var verticalGutter = gutter[1] / 2;
    mergedStyle.paddingTop = verticalGutter;
    mergedStyle.paddingBottom = verticalGutter;
  }
  if (flex) {
    mergedStyle.flex = parseFlex(flex);
    if (wrap === false && !mergedStyle.minWidth) {
      mergedStyle.minWidth = 0;
    }
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    style: _extends$1(_extends$1({}, mergedStyle), style),
    className: classes,
    ref
  }), children);
});
Col.displayName = "Col";
var Col$1 = Col;
var Switch$2 = React.forwardRef(function(_ref, ref) {
  var _classNames;
  var _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-switch" : _ref$prefixCls, className = _ref.className, checked = _ref.checked, defaultChecked = _ref.defaultChecked, disabled = _ref.disabled, loadingIcon = _ref.loadingIcon, checkedChildren = _ref.checkedChildren, unCheckedChildren = _ref.unCheckedChildren, onClick = _ref.onClick, onChange = _ref.onChange, onKeyDown = _ref.onKeyDown, restProps = _objectWithoutProperties(_ref, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]);
  var _useMergedState = useControlledState(false, {
    value: checked,
    defaultValue: defaultChecked
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), innerChecked = _useMergedState2[0], setInnerChecked = _useMergedState2[1];
  function triggerChange(newChecked, event) {
    var mergedChecked = innerChecked;
    if (!disabled) {
      mergedChecked = newChecked;
      setInnerChecked(mergedChecked);
      onChange === null || onChange === void 0 ? void 0 : onChange(mergedChecked, event);
    }
    return mergedChecked;
  }
  function onInternalKeyDown(e2) {
    if (e2.which === KeyCode.LEFT) {
      triggerChange(false, e2);
    } else if (e2.which === KeyCode.RIGHT) {
      triggerChange(true, e2);
    }
    onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(e2);
  }
  function onInternalClick(e2) {
    var ret = triggerChange(!innerChecked, e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(ret, e2);
  }
  var switchClassName = classNames(prefixCls, className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-checked"), innerChecked), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
  return React.createElement("button", Object.assign({}, restProps, {
    type: "button",
    role: "switch",
    "aria-checked": innerChecked,
    disabled,
    className: switchClassName,
    ref,
    onKeyDown: onInternalKeyDown,
    onClick: onInternalClick
  }), loadingIcon, React.createElement("span", {
    className: "".concat(prefixCls, "-inner")
  }, innerChecked ? checkedChildren : unCheckedChildren));
});
Switch$2.displayName = "Switch";
var __rest = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Switch = /* @__PURE__ */ React.forwardRef(function(_a2, ref) {
  var _classNames;
  var customizePrefixCls = _a2.prefixCls, customizeSize = _a2.size, loading = _a2.loading, _a$className = _a2.className, className = _a$className === void 0 ? "" : _a$className, disabled = _a2.disabled, props = __rest(_a2, ["prefixCls", "size", "loading", "className", "disabled"]);
  devWarning("checked" in props || !("value" in props), "Switch", "`value` is not a valid prop, do you mean `checked`?");
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var prefixCls = getPrefixCls("switch", customizePrefixCls);
  var loadingIcon = /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-handle")
  }, loading && /* @__PURE__ */ React.createElement(LoadingOutlined$1, {
    className: "".concat(prefixCls, "-loading-icon")
  }));
  var classes = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-small"), (customizeSize || size) === "small"), _defineProperty(_classNames, "".concat(prefixCls, "-loading"), loading), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement(Wave, {
    insertExtraNode: true
  }, /* @__PURE__ */ React.createElement(Switch$2, _extends$1({}, props, {
    prefixCls,
    className: classes,
    disabled: disabled || loading,
    ref,
    loadingIcon
  })));
});
Switch.__ANT_SWITCH = true;
Switch.displayName = "Switch";
var Switch$1 = Switch;
var _default = "";
var index$7 = "";
var index$6 = "";
var index$5 = "";
var index$4 = "";
var index$3 = "";
var index$2 = "";
var index$1 = "";
const container = "_container_oi76t_1";
var styles = {
  container,
  "function": "_function_oi76t_10"
};
var reactEchartsJson_cjs = {};
(function(exports) {
  var Rre = Object.defineProperty;
  var c8 = Object.getOwnPropertySymbols;
  var Fre = Object.prototype.hasOwnProperty, Nre = Object.prototype.propertyIsEnumerable;
  var YL = (r2, t2, e2) => t2 in r2 ? Rre(r2, t2, { enumerable: true, configurable: true, writable: true, value: e2 }) : r2[t2] = e2, f8 = (r2, t2) => {
    for (var e2 in t2 || (t2 = {}))
      Fre.call(t2, e2) && YL(r2, e2, t2[e2]);
    if (c8)
      for (var e2 of c8(t2))
        Nre.call(t2, e2) && YL(r2, e2, t2[e2]);
    return r2;
  };
  var lf = (r2, t2, e2) => (YL(r2, typeof t2 != "symbol" ? t2 + "" : t2, e2), e2);
  Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
  var Li = React__default;
  function Vre(r2) {
    return r2 && typeof r2 == "object" && "default" in r2 ? r2 : { default: r2 };
  }
  function jre(r2) {
    if (r2 && r2.__esModule)
      return r2;
    var t2 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
    return r2 && Object.keys(r2).forEach(function(e2) {
      if (e2 !== "default") {
        var n2 = Object.getOwnPropertyDescriptor(r2, e2);
        Object.defineProperty(t2, e2, n2.get ? n2 : { enumerable: true, get: function() {
          return r2[e2];
        } });
      }
    }), t2.default = r2, Object.freeze(t2);
  }
  var ew = Vre(Li), Lr = jre(Li), Bre = globalThis && globalThis.__read || function(r2, t2) {
    var e2 = typeof Symbol == "function" && r2[Symbol.iterator];
    if (!e2)
      return r2;
    var n2 = e2.call(r2), a, i = [], o;
    try {
      for (; (t2 === void 0 || t2-- > 0) && !(a = n2.next()).done; )
        i.push(a.value);
    } catch (s) {
      o = { error: s };
    } finally {
      try {
        a && !a.done && (e2 = n2.return) && e2.call(n2);
      } finally {
        if (o)
          throw o.error;
      }
    }
    return i;
  };
  function zre(r2, t2) {
    r2 === void 0 && (r2 = false);
    var e2 = Bre(Li.useState(r2), 2), n2 = e2[0], a = e2[1], i = Li.useMemo(function() {
      var o = t2 === void 0 ? !r2 : t2, s = function() {
        return a(function(h) {
          return h === r2 ? o : r2;
        });
      }, u = function(h) {
        return a(h);
      }, l2 = function() {
        return a(r2);
      }, c2 = function() {
        return a(o);
      };
      return { toggle: s, set: u, setLeft: l2, setRight: c2 };
    }, []);
    return [n2, i];
  }
  var $re = globalThis && globalThis.__read || function(r2, t2) {
    var e2 = typeof Symbol == "function" && r2[Symbol.iterator];
    if (!e2)
      return r2;
    var n2 = e2.call(r2), a, i = [], o;
    try {
      for (; (t2 === void 0 || t2-- > 0) && !(a = n2.next()).done; )
        i.push(a.value);
    } catch (s) {
      o = { error: s };
    } finally {
      try {
        a && !a.done && (e2 = n2.return) && e2.call(n2);
      } finally {
        if (o)
          throw o.error;
      }
    }
    return i;
  };
  function Gre(r2) {
    r2 === void 0 && (r2 = false);
    var t2 = $re(zre(r2), 2), e2 = t2[0], n2 = t2[1], a = n2.toggle, i = n2.set, o = Li.useMemo(function() {
      var s = function() {
        return i(true);
      }, u = function() {
        return i(false);
      };
      return { toggle: a, set: function(c2) {
        return i(!!c2);
      }, setTrue: s, setFalse: u };
    }, []);
    return [e2, o];
  }
  function L6(r2) {
    var t2 = Li.useRef(r2);
    return t2.current = r2, t2;
  }
  var Wre = !!(typeof window != "undefined" && window.document && window.document.createElement), Ure = Wre;
  function KG(r2, t2) {
    if (!!Ure) {
      if (!r2)
        return t2;
      var e2;
      return typeof r2 == "function" ? e2 = r2() : "current" in r2 ? e2 = r2.current : e2 = r2, e2;
    }
  }
  var Hre = function(t2) {
    var e2 = L6(t2);
    Li.useEffect(function() {
      return function() {
        e2.current();
      };
    }, []);
  }, ZG = Hre;
  function h8(r2, t2) {
    if (r2 === t2)
      return true;
    for (var e2 = 0; e2 < r2.length; e2++)
      if (!Object.is(r2[e2], t2[e2]))
        return false;
    return true;
  }
  var qre = function(t2) {
    var e2 = function(a, i, o) {
      var s = Li.useRef(false), u = Li.useRef([]), l2 = Li.useRef([]), c2 = Li.useRef();
      t2(function() {
        var f2, h = Array.isArray(o) ? o : [o], v9 = h.map(function(d2) {
          return KG(d2);
        });
        if (!s.current) {
          s.current = true, u.current = v9, l2.current = i, c2.current = a();
          return;
        }
        (v9.length !== u.current.length || !h8(v9, u.current) || !h8(i, l2.current)) && ((f2 = c2.current) === null || f2 === void 0 || f2.call(c2), u.current = v9, l2.current = i, c2.current = a());
      }), ZG(function() {
        var f2;
        (f2 = c2.current) === null || f2 === void 0 || f2.call(c2), s.current = false;
      });
    };
    return e2;
  }, Yre = qre, Kre = Yre(Li.useEffect), Zre = Kre, jh = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : {};
  function Xre(r2) {
    return r2 && r2.__esModule && Object.prototype.hasOwnProperty.call(r2, "default") ? r2.default : r2;
  }
  function Jre(r2) {
    var t2 = typeof r2;
    return r2 != null && (t2 == "object" || t2 == "function");
  }
  var XG = Jre, Qre = typeof jh == "object" && jh && jh.Object === Object && jh, ene = Qre, tne = ene, rne = typeof self == "object" && self && self.Object === Object && self, nne = tne || rne || Function("return this")(), JG = nne, ane = JG, ine = function() {
    return ane.Date.now();
  }, one = ine, sne = /\s/;
  function une(r2) {
    for (var t2 = r2.length; t2-- && sne.test(r2.charAt(t2)); )
      ;
    return t2;
  }
  var lne = une, cne = lne, fne = /^\s+/;
  function hne(r2) {
    return r2 && r2.slice(0, cne(r2) + 1).replace(fne, "");
  }
  var vne = hne, dne = JG, pne = dne.Symbol, QG = pne, v8 = QG, eW = Object.prototype, gne = eW.hasOwnProperty, yne = eW.toString, j2 = v8 ? v8.toStringTag : void 0;
  function mne(r2) {
    var t2 = gne.call(r2, j2), e2 = r2[j2];
    try {
      r2[j2] = void 0;
      var n2 = true;
    } catch {
    }
    var a = yne.call(r2);
    return n2 && (t2 ? r2[j2] = e2 : delete r2[j2]), a;
  }
  var bne = mne, _ne = Object.prototype, xne = _ne.toString;
  function wne(r2) {
    return xne.call(r2);
  }
  var Sne = wne, d8 = QG, Cne = bne, Ene = Sne, Ane = "[object Null]", Tne = "[object Undefined]", p8 = d8 ? d8.toStringTag : void 0;
  function Mne(r2) {
    return r2 == null ? r2 === void 0 ? Tne : Ane : p8 && p8 in Object(r2) ? Cne(r2) : Ene(r2);
  }
  var Pne = Mne;
  function Dne(r2) {
    return r2 != null && typeof r2 == "object";
  }
  var Ine = Dne, Lne = Pne, One = Ine, kne = "[object Symbol]";
  function Rne(r2) {
    return typeof r2 == "symbol" || One(r2) && Lne(r2) == kne;
  }
  var Fne = Rne, Nne = vne, g8 = XG, Vne = Fne, y8 = 0 / 0, jne = /^[-+]0x[0-9a-f]+$/i, Bne = /^0b[01]+$/i, zne = /^0o[0-7]+$/i, $ne = parseInt;
  function Gne(r2) {
    if (typeof r2 == "number")
      return r2;
    if (Vne(r2))
      return y8;
    if (g8(r2)) {
      var t2 = typeof r2.valueOf == "function" ? r2.valueOf() : r2;
      r2 = g8(t2) ? t2 + "" : t2;
    }
    if (typeof r2 != "string")
      return r2 === 0 ? r2 : +r2;
    r2 = Nne(r2);
    var e2 = Bne.test(r2);
    return e2 || zne.test(r2) ? $ne(r2.slice(2), e2 ? 2 : 8) : jne.test(r2) ? y8 : +r2;
  }
  var Wne = Gne, Une = XG, KL = one, m8 = Wne, Hne = "Expected a function", qne = Math.max, Yne = Math.min;
  function Kne(r2, t2, e2) {
    var n2, a, i, o, s, u, l2 = 0, c2 = false, f2 = false, h = true;
    if (typeof r2 != "function")
      throw new TypeError(Hne);
    t2 = m8(t2) || 0, Une(e2) && (c2 = !!e2.leading, f2 = "maxWait" in e2, i = f2 ? qne(m8(e2.maxWait) || 0, t2) : i, h = "trailing" in e2 ? !!e2.trailing : h);
    function v9(V) {
      var $ = n2, U = a;
      return n2 = a = void 0, l2 = V, o = r2.apply(U, $), o;
    }
    function d2(V) {
      return l2 = V, s = setTimeout(_, t2), c2 ? v9(V) : o;
    }
    function m2(V) {
      var $ = V - u, U = V - l2, H = t2 - $;
      return f2 ? Yne(H, i - U) : H;
    }
    function b2(V) {
      var $ = V - u, U = V - l2;
      return u === void 0 || $ >= t2 || $ < 0 || f2 && U >= i;
    }
    function _() {
      var V = KL();
      if (b2(V))
        return C(V);
      s = setTimeout(_, m2(V));
    }
    function C(V) {
      return s = void 0, h && n2 ? v9(V) : (n2 = a = void 0, o);
    }
    function M() {
      s !== void 0 && clearTimeout(s), l2 = 0, n2 = u = a = s = void 0;
    }
    function E() {
      return s === void 0 ? o : C(KL());
    }
    function z9() {
      var V = KL(), $ = b2(V);
      if (n2 = arguments, a = this, u = V, $) {
        if (s === void 0)
          return d2(u);
        if (f2)
          return clearTimeout(s), s = setTimeout(_, t2), v9(u);
      }
      return s === void 0 && (s = setTimeout(_, t2)), o;
    }
    return z9.cancel = M, z9.flush = E, z9;
  }
  var Zne = Kne, Xne = globalThis && globalThis.__read || function(r2, t2) {
    var e2 = typeof Symbol == "function" && r2[Symbol.iterator];
    if (!e2)
      return r2;
    var n2 = e2.call(r2), a, i = [], o;
    try {
      for (; (t2 === void 0 || t2-- > 0) && !(a = n2.next()).done; )
        i.push(a.value);
    } catch (s) {
      o = { error: s };
    } finally {
      try {
        a && !a.done && (e2 = n2.return) && e2.call(n2);
      } finally {
        if (o)
          throw o.error;
      }
    }
    return i;
  }, Jne = globalThis && globalThis.__spread || function() {
    for (var r2 = [], t2 = 0; t2 < arguments.length; t2++)
      r2 = r2.concat(Xne(arguments[t2]));
    return r2;
  };
  function Qne(r2, t2) {
    var e2, n2 = L6(r2), a = (e2 = t2 == null ? void 0 : t2.wait) !== null && e2 !== void 0 ? e2 : 1e3, i = Li.useMemo(function() {
      return Zne(function() {
        for (var o = [], s = 0; s < arguments.length; s++)
          o[s] = arguments[s];
        return n2.current.apply(n2, Jne(o));
      }, a, t2);
    }, []);
    return ZG(function() {
      i.cancel();
    }), { run: i, cancel: i.cancel, flush: i.flush };
  }
  function eae(r2, t2, e2) {
    e2 === void 0 && (e2 = {});
    var n2 = L6(t2);
    Zre(function() {
      var a = KG(e2.target, window);
      if (!!(a != null && a.addEventListener)) {
        var i = function(s) {
          return n2.current(s);
        };
        return a.addEventListener(r2, i, { capture: e2.capture, once: e2.once, passive: e2.passive }), function() {
          a.removeEventListener(r2, i, { capture: e2.capture });
        };
      }
    }, [r2, e2.capture, e2.once, e2.passive], e2.target);
  }
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.
  
  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  var PR = function(r2, t2) {
    return PR = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(e2, n2) {
      e2.__proto__ = n2;
    } || function(e2, n2) {
      for (var a in n2)
        Object.prototype.hasOwnProperty.call(n2, a) && (e2[a] = n2[a]);
    }, PR(r2, t2);
  };
  function ot(r2, t2) {
    if (typeof t2 != "function" && t2 !== null)
      throw new TypeError("Class extends value " + String(t2) + " is not a constructor or null");
    PR(r2, t2);
    function e2() {
      this.constructor = r2;
    }
    r2.prototype = t2 === null ? Object.create(t2) : (e2.prototype = t2.prototype, new e2());
  }
  var tae = function() {
    function r2() {
      this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
    }
    return r2;
  }(), rae = function() {
    function r2() {
      this.browser = new tae(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
    }
    return r2;
  }(), Ab = new rae();
  typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (Ab.wxa = true, Ab.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? Ab.worker = true : typeof navigator == "undefined" ? (Ab.node = true, Ab.svgSupported = true) : nae(navigator.userAgent, Ab);
  function nae(r2, t2) {
    var e2 = t2.browser, n2 = r2.match(/Firefox\/([\d.]+)/), a = r2.match(/MSIE\s([\d.]+)/) || r2.match(/Trident\/.+?rv:(([\d.]+))/), i = r2.match(/Edge?\/([\d.]+)/), o = /micromessenger/i.test(r2);
    n2 && (e2.firefox = true, e2.version = n2[1]), a && (e2.ie = true, e2.version = a[1]), i && (e2.edge = true, e2.version = i[1], e2.newEdge = +i[1].split(".")[0] > 18), o && (e2.weChat = true), t2.svgSupported = typeof SVGRect != "undefined", t2.touchEventsSupported = "ontouchstart" in window && !e2.ie && !e2.edge, t2.pointerEventsSupported = "onpointerdown" in window && (e2.edge || e2.ie && +e2.version >= 11), t2.domSupported = typeof document != "undefined";
    var s = document.documentElement.style;
    t2.transform3dSupported = (e2.ie && "transition" in s || e2.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in s) && !("OTransition" in s), t2.transformSupported = t2.transform3dSupported || e2.ie && +e2.version >= 9;
  }
  var Ei = Ab, O6 = 12, tW = "sans-serif", gy = O6 + "px " + tW, aae = 20, iae = 100, oae = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
  function sae(r2) {
    var t2 = {};
    if (typeof JSON == "undefined")
      return t2;
    for (var e2 = 0; e2 < r2.length; e2++) {
      var n2 = String.fromCharCode(e2 + 32), a = (r2.charCodeAt(e2) - aae) / iae;
      t2[n2] = a;
    }
    return t2;
  }
  var uae = sae(oae), Tg = { createCanvas: function() {
    return typeof document != "undefined" && document.createElement("canvas");
  }, measureText: function() {
    var r2, t2;
    return function(e2, n2) {
      if (!r2) {
        var a = Tg.createCanvas();
        r2 = a && a.getContext("2d");
      }
      if (r2)
        return t2 !== n2 && (t2 = r2.font = n2 || gy), r2.measureText(e2);
      e2 = e2 || "", n2 = n2 || gy;
      var i = /^([0-9]*?)px$/.exec(n2), o = +(i && i[1]) || O6, s = 0;
      if (n2.indexOf("mono") >= 0)
        s = o * e2.length;
      else
        for (var u = 0; u < e2.length; u++) {
          var l2 = uae[e2[u]];
          s += l2 == null ? o : l2 * o;
        }
      return { width: s };
    };
  }(), loadImage: function(r2, t2, e2) {
    var n2 = new Image();
    return n2.onload = t2, n2.onerror = e2, n2.src = r2, n2;
  } }, rW = Qd(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(r2, t2) {
    return r2["[object " + t2 + "]"] = true, r2;
  }, {}), nW = Qd(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(r2, t2) {
    return r2["[object " + t2 + "Array]"] = true, r2;
  }, {}), cw = Object.prototype.toString, $P = Array.prototype, lae = $P.forEach, cae = $P.filter, k6 = $P.slice, fae = $P.map, b8 = function() {
  }.constructor, hM = b8 ? b8.prototype : null, R6 = "__proto__", hae = 2311;
  function aW() {
    return hae++;
  }
  function F6() {
    for (var r2 = [], t2 = 0; t2 < arguments.length; t2++)
      r2[t2] = arguments[t2];
    typeof console != "undefined" && console.error.apply(console, r2);
  }
  function On(r2) {
    if (r2 == null || typeof r2 != "object")
      return r2;
    var t2 = r2, e2 = cw.call(r2);
    if (e2 === "[object Array]") {
      if (!IC(r2)) {
        t2 = [];
        for (var n2 = 0, a = r2.length; n2 < a; n2++)
          t2[n2] = On(r2[n2]);
      }
    } else if (nW[e2]) {
      if (!IC(r2)) {
        var i = r2.constructor;
        if (i.from)
          t2 = i.from(r2);
        else {
          t2 = new i(r2.length);
          for (var n2 = 0, a = r2.length; n2 < a; n2++)
            t2[n2] = r2[n2];
        }
      }
    } else if (!rW[e2] && !IC(r2) && !ZC(r2)) {
      t2 = {};
      for (var o in r2)
        r2.hasOwnProperty(o) && o !== R6 && (t2[o] = On(r2[o]));
    }
    return t2;
  }
  function ea(r2, t2, e2) {
    if (!Tn(t2) || !Tn(r2))
      return e2 ? On(t2) : r2;
    for (var n2 in t2)
      if (t2.hasOwnProperty(n2) && n2 !== R6) {
        var a = r2[n2], i = t2[n2];
        Tn(i) && Tn(a) && !vr(i) && !vr(a) && !ZC(i) && !ZC(a) && !_8(i) && !_8(a) && !IC(i) && !IC(a) ? ea(a, i, e2) : (e2 || !(n2 in r2)) && (r2[n2] = On(t2[n2]));
      }
    return r2;
  }
  function N6(r2, t2) {
    for (var e2 = r2[0], n2 = 1, a = r2.length; n2 < a; n2++)
      e2 = ea(e2, r2[n2], t2);
    return e2;
  }
  function qt(r2, t2) {
    if (Object.assign)
      Object.assign(r2, t2);
    else
      for (var e2 in t2)
        t2.hasOwnProperty(e2) && e2 !== R6 && (r2[e2] = t2[e2]);
    return r2;
  }
  function En(r2, t2, e2) {
    for (var n2 = ja(t2), a = 0; a < n2.length; a++) {
      var i = n2[a];
      (e2 ? t2[i] != null : r2[i] == null) && (r2[i] = t2[i]);
    }
    return r2;
  }
  function va(r2, t2) {
    if (r2) {
      if (r2.indexOf)
        return r2.indexOf(t2);
      for (var e2 = 0, n2 = r2.length; e2 < n2; e2++)
        if (r2[e2] === t2)
          return e2;
    }
    return -1;
  }
  function vae(r2, t2) {
    var e2 = r2.prototype;
    function n2() {
    }
    n2.prototype = t2.prototype, r2.prototype = new n2();
    for (var a in e2)
      e2.hasOwnProperty(a) && (r2.prototype[a] = e2[a]);
    r2.prototype.constructor = r2, r2.superClass = t2;
  }
  function fu(r2, t2, e2) {
    if (r2 = "prototype" in r2 ? r2.prototype : r2, t2 = "prototype" in t2 ? t2.prototype : t2, Object.getOwnPropertyNames)
      for (var n2 = Object.getOwnPropertyNames(t2), a = 0; a < n2.length; a++) {
        var i = n2[a];
        i !== "constructor" && (e2 ? t2[i] != null : r2[i] == null) && (r2[i] = t2[i]);
      }
    else
      En(r2, t2, e2);
  }
  function lc(r2) {
    return !r2 || typeof r2 == "string" ? false : typeof r2.length == "number";
  }
  function ae(r2, t2, e2) {
    if (!!(r2 && t2))
      if (r2.forEach && r2.forEach === lae)
        r2.forEach(t2, e2);
      else if (r2.length === +r2.length)
        for (var n2 = 0, a = r2.length; n2 < a; n2++)
          t2.call(e2, r2[n2], n2, r2);
      else
        for (var i in r2)
          r2.hasOwnProperty(i) && t2.call(e2, r2[i], i, r2);
  }
  function pr(r2, t2, e2) {
    if (!r2)
      return [];
    if (!t2)
      return V6(r2);
    if (r2.map && r2.map === fae)
      return r2.map(t2, e2);
    for (var n2 = [], a = 0, i = r2.length; a < i; a++)
      n2.push(t2.call(e2, r2[a], a, r2));
    return n2;
  }
  function Qd(r2, t2, e2, n2) {
    if (!!(r2 && t2)) {
      for (var a = 0, i = r2.length; a < i; a++)
        e2 = t2.call(n2, e2, r2[a], a, r2);
      return e2;
    }
  }
  function no(r2, t2, e2) {
    if (!r2)
      return [];
    if (!t2)
      return V6(r2);
    if (r2.filter && r2.filter === cae)
      return r2.filter(t2, e2);
    for (var n2 = [], a = 0, i = r2.length; a < i; a++)
      t2.call(e2, r2[a], a, r2) && n2.push(r2[a]);
    return n2;
  }
  function dae(r2, t2, e2) {
    if (!!(r2 && t2)) {
      for (var n2 = 0, a = r2.length; n2 < a; n2++)
        if (t2.call(e2, r2[n2], n2, r2))
          return r2[n2];
    }
  }
  function ja(r2) {
    if (!r2)
      return [];
    if (Object.keys)
      return Object.keys(r2);
    var t2 = [];
    for (var e2 in r2)
      r2.hasOwnProperty(e2) && t2.push(e2);
    return t2;
  }
  function pae(r2, t2) {
    for (var e2 = [], n2 = 2; n2 < arguments.length; n2++)
      e2[n2 - 2] = arguments[n2];
    return function() {
      return r2.apply(t2, e2.concat(k6.call(arguments)));
    };
  }
  var en = hM && xn(hM.bind) ? hM.call.bind(hM.bind) : pae;
  function Gn(r2) {
    for (var t2 = [], e2 = 1; e2 < arguments.length; e2++)
      t2[e2 - 1] = arguments[e2];
    return function() {
      return r2.apply(this, t2.concat(k6.call(arguments)));
    };
  }
  function vr(r2) {
    return Array.isArray ? Array.isArray(r2) : cw.call(r2) === "[object Array]";
  }
  function xn(r2) {
    return typeof r2 == "function";
  }
  function Zr(r2) {
    return typeof r2 == "string";
  }
  function DR(r2) {
    return cw.call(r2) === "[object String]";
  }
  function Ai(r2) {
    return typeof r2 == "number";
  }
  function Tn(r2) {
    var t2 = typeof r2;
    return t2 === "function" || !!r2 && t2 === "object";
  }
  function _8(r2) {
    return !!rW[cw.call(r2)];
  }
  function Qf(r2) {
    return !!nW[cw.call(r2)];
  }
  function ZC(r2) {
    return typeof r2 == "object" && typeof r2.nodeType == "number" && typeof r2.ownerDocument == "object";
  }
  function GP(r2) {
    return r2.colorStops != null;
  }
  function gae(r2) {
    return r2.image != null;
  }
  function yae(r2) {
    return cw.call(r2) === "[object RegExp]";
  }
  function XC(r2) {
    return r2 !== r2;
  }
  function ml() {
    for (var r2 = [], t2 = 0; t2 < arguments.length; t2++)
      r2[t2] = arguments[t2];
    for (var e2 = 0, n2 = r2.length; e2 < n2; e2++)
      if (r2[e2] != null)
        return r2[e2];
  }
  function ia(r2, t2) {
    return r2 != null ? r2 : t2;
  }
  function _g(r2, t2, e2) {
    return r2 != null ? r2 : t2 != null ? t2 : e2;
  }
  function V6(r2) {
    for (var t2 = [], e2 = 1; e2 < arguments.length; e2++)
      t2[e2 - 1] = arguments[e2];
    return k6.apply(r2, t2);
  }
  function j6(r2) {
    if (typeof r2 == "number")
      return [r2, r2, r2, r2];
    var t2 = r2.length;
    return t2 === 2 ? [r2[0], r2[1], r2[0], r2[1]] : t2 === 3 ? [r2[0], r2[1], r2[2], r2[1]] : r2;
  }
  function Fc(r2, t2) {
    if (!r2)
      throw new Error(t2);
  }
  function jv(r2) {
    return r2 == null ? null : typeof r2.trim == "function" ? r2.trim() : r2.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
  var iW = "__ec_primitive__";
  function G5(r2) {
    r2[iW] = true;
  }
  function IC(r2) {
    return r2[iW];
  }
  var mae = function() {
    function r2(t2) {
      this.data = {};
      var e2 = vr(t2);
      this.data = {};
      var n2 = this;
      t2 instanceof r2 ? t2.each(a) : t2 && ae(t2, a);
      function a(i, o) {
        e2 ? n2.set(i, o) : n2.set(o, i);
      }
    }
    return r2.prototype.get = function(t2) {
      return this.data.hasOwnProperty(t2) ? this.data[t2] : null;
    }, r2.prototype.set = function(t2, e2) {
      return this.data[t2] = e2;
    }, r2.prototype.each = function(t2, e2) {
      for (var n2 in this.data)
        this.data.hasOwnProperty(n2) && t2.call(e2, this.data[n2], n2);
    }, r2.prototype.keys = function() {
      return ja(this.data);
    }, r2.prototype.removeKey = function(t2) {
      delete this.data[t2];
    }, r2;
  }();
  function mn(r2) {
    return new mae(r2);
  }
  function IR(r2, t2) {
    for (var e2 = new r2.constructor(r2.length + t2.length), n2 = 0; n2 < r2.length; n2++)
      e2[n2] = r2[n2];
    for (var a = r2.length, n2 = 0; n2 < t2.length; n2++)
      e2[n2 + a] = t2[n2];
    return e2;
  }
  function WP(r2, t2) {
    var e2;
    if (Object.create)
      e2 = Object.create(r2);
    else {
      var n2 = function() {
      };
      n2.prototype = r2, e2 = new n2();
    }
    return t2 && qt(e2, t2), e2;
  }
  function oW(r2) {
    var t2 = r2.style;
    t2.webkitUserSelect = "none", t2.userSelect = "none", t2.webkitTapHighlightColor = "rgba(0,0,0,0)", t2["-webkit-touch-callout"] = "none";
  }
  function sn(r2, t2) {
    return r2.hasOwnProperty(t2);
  }
  function lu() {
  }
  var x5 = 180 / Math.PI;
  function o1(r2, t2) {
    return r2 == null && (r2 = 0), t2 == null && (t2 = 0), [r2, t2];
  }
  function Lc(r2, t2) {
    return r2[0] = t2[0], r2[1] = t2[1], r2;
  }
  function xg(r2) {
    return [r2[0], r2[1]];
  }
  function bae(r2, t2, e2) {
    return r2[0] = t2, r2[1] = e2, r2;
  }
  function x8(r2, t2, e2) {
    return r2[0] = t2[0] + e2[0], r2[1] = t2[1] + e2[1], r2;
  }
  function LR(r2, t2, e2, n2) {
    return r2[0] = t2[0] + e2[0] * n2, r2[1] = t2[1] + e2[1] * n2, r2;
  }
  function Vb(r2, t2, e2) {
    return r2[0] = t2[0] - e2[0], r2[1] = t2[1] - e2[1], r2;
  }
  function OR(r2) {
    return Math.sqrt(_ae(r2));
  }
  function _ae(r2) {
    return r2[0] * r2[0] + r2[1] * r2[1];
  }
  function ZL(r2, t2, e2) {
    return r2[0] = t2[0] * e2, r2[1] = t2[1] * e2, r2;
  }
  function TE(r2, t2) {
    var e2 = OR(t2);
    return e2 === 0 ? (r2[0] = 0, r2[1] = 0) : (r2[0] = t2[0] / e2, r2[1] = t2[1] / e2), r2;
  }
  function kR(r2, t2) {
    return Math.sqrt((r2[0] - t2[0]) * (r2[0] - t2[0]) + (r2[1] - t2[1]) * (r2[1] - t2[1]));
  }
  var ty = kR;
  function xae(r2, t2) {
    return (r2[0] - t2[0]) * (r2[0] - t2[0]) + (r2[1] - t2[1]) * (r2[1] - t2[1]);
  }
  var Wb = xae;
  function w5(r2, t2, e2, n2) {
    return r2[0] = t2[0] + n2 * (e2[0] - t2[0]), r2[1] = t2[1] + n2 * (e2[1] - t2[1]), r2;
  }
  function Nl(r2, t2, e2) {
    var n2 = t2[0], a = t2[1];
    return r2[0] = e2[0] * n2 + e2[2] * a + e2[4], r2[1] = e2[1] * n2 + e2[3] * a + e2[5], r2;
  }
  function ry(r2, t2, e2) {
    return r2[0] = Math.min(t2[0], e2[0]), r2[1] = Math.min(t2[1], e2[1]), r2;
  }
  function ny(r2, t2, e2) {
    return r2[0] = Math.max(t2[0], e2[0]), r2[1] = Math.max(t2[1], e2[1]), r2;
  }
  var fx = function() {
    function r2(t2, e2) {
      this.target = t2, this.topTarget = e2 && e2.topTarget;
    }
    return r2;
  }(), wae = function() {
    function r2(t2) {
      this.handler = t2, t2.on("mousedown", this._dragStart, this), t2.on("mousemove", this._drag, this), t2.on("mouseup", this._dragEnd, this);
    }
    return r2.prototype._dragStart = function(t2) {
      for (var e2 = t2.target; e2 && !e2.draggable; )
        e2 = e2.parent || e2.__hostTarget;
      e2 && (this._draggingTarget = e2, e2.dragging = true, this._x = t2.offsetX, this._y = t2.offsetY, this.handler.dispatchToElement(new fx(e2, t2), "dragstart", t2.event));
    }, r2.prototype._drag = function(t2) {
      var e2 = this._draggingTarget;
      if (e2) {
        var n2 = t2.offsetX, a = t2.offsetY, i = n2 - this._x, o = a - this._y;
        this._x = n2, this._y = a, e2.drift(i, o, t2), this.handler.dispatchToElement(new fx(e2, t2), "drag", t2.event);
        var s = this.handler.findHover(n2, a, e2).target, u = this._dropTarget;
        this._dropTarget = s, e2 !== s && (u && s !== u && this.handler.dispatchToElement(new fx(u, t2), "dragleave", t2.event), s && s !== u && this.handler.dispatchToElement(new fx(s, t2), "dragenter", t2.event));
      }
    }, r2.prototype._dragEnd = function(t2) {
      var e2 = this._draggingTarget;
      e2 && (e2.dragging = false), this.handler.dispatchToElement(new fx(e2, t2), "dragend", t2.event), this._dropTarget && this.handler.dispatchToElement(new fx(this._dropTarget, t2), "drop", t2.event), this._draggingTarget = null, this._dropTarget = null;
    }, r2;
  }(), Sae = wae, Cae = function() {
    function r2(t2) {
      t2 && (this._$eventProcessor = t2);
    }
    return r2.prototype.on = function(t2, e2, n2, a) {
      this._$handlers || (this._$handlers = {});
      var i = this._$handlers;
      if (typeof e2 == "function" && (a = n2, n2 = e2, e2 = null), !n2 || !t2)
        return this;
      var o = this._$eventProcessor;
      e2 != null && o && o.normalizeQuery && (e2 = o.normalizeQuery(e2)), i[t2] || (i[t2] = []);
      for (var s = 0; s < i[t2].length; s++)
        if (i[t2][s].h === n2)
          return this;
      var u = { h: n2, query: e2, ctx: a || this, callAtLast: n2.zrEventfulCallAtLast }, l2 = i[t2].length - 1, c2 = i[t2][l2];
      return c2 && c2.callAtLast ? i[t2].splice(l2, 0, u) : i[t2].push(u), this;
    }, r2.prototype.isSilent = function(t2) {
      var e2 = this._$handlers;
      return !e2 || !e2[t2] || !e2[t2].length;
    }, r2.prototype.off = function(t2, e2) {
      var n2 = this._$handlers;
      if (!n2)
        return this;
      if (!t2)
        return this._$handlers = {}, this;
      if (e2) {
        if (n2[t2]) {
          for (var a = [], i = 0, o = n2[t2].length; i < o; i++)
            n2[t2][i].h !== e2 && a.push(n2[t2][i]);
          n2[t2] = a;
        }
        n2[t2] && n2[t2].length === 0 && delete n2[t2];
      } else
        delete n2[t2];
      return this;
    }, r2.prototype.trigger = function(t2) {
      for (var e2 = [], n2 = 1; n2 < arguments.length; n2++)
        e2[n2 - 1] = arguments[n2];
      if (!this._$handlers)
        return this;
      var a = this._$handlers[t2], i = this._$eventProcessor;
      if (a)
        for (var o = e2.length, s = a.length, u = 0; u < s; u++) {
          var l2 = a[u];
          if (!(i && i.filter && l2.query != null && !i.filter(t2, l2.query)))
            switch (o) {
              case 0:
                l2.h.call(l2.ctx);
                break;
              case 1:
                l2.h.call(l2.ctx, e2[0]);
                break;
              case 2:
                l2.h.call(l2.ctx, e2[0], e2[1]);
                break;
              default:
                l2.h.apply(l2.ctx, e2);
                break;
            }
        }
      return i && i.afterTrigger && i.afterTrigger(t2), this;
    }, r2.prototype.triggerWithContext = function(t2) {
      for (var e2 = [], n2 = 1; n2 < arguments.length; n2++)
        e2[n2 - 1] = arguments[n2];
      if (!this._$handlers)
        return this;
      var a = this._$handlers[t2], i = this._$eventProcessor;
      if (a)
        for (var o = e2.length, s = e2[o - 1], u = a.length, l2 = 0; l2 < u; l2++) {
          var c2 = a[l2];
          if (!(i && i.filter && c2.query != null && !i.filter(t2, c2.query)))
            switch (o) {
              case 0:
                c2.h.call(s);
                break;
              case 1:
                c2.h.call(s, e2[0]);
                break;
              case 2:
                c2.h.call(s, e2[0], e2[1]);
                break;
              default:
                c2.h.apply(s, e2.slice(1, o - 1));
                break;
            }
        }
      return i && i.afterTrigger && i.afterTrigger(t2), this;
    }, r2;
  }(), Yh = Cae, Eae = Math.log(2);
  function RR(r2, t2, e2, n2, a, i) {
    var o = n2 + "-" + a, s = r2.length;
    if (i.hasOwnProperty(o))
      return i[o];
    if (t2 === 1) {
      var u = Math.round(Math.log((1 << s) - 1 & ~a) / Eae);
      return r2[e2][u];
    }
    for (var l2 = n2 | 1 << e2, c2 = e2 + 1; n2 & 1 << c2; )
      c2++;
    for (var f2 = 0, h = 0, v9 = 0; h < s; h++) {
      var d2 = 1 << h;
      d2 & a || (f2 += (v9 % 2 ? -1 : 1) * r2[e2][h] * RR(r2, t2 - 1, c2, l2, a | d2, i), v9++);
    }
    return i[o] = f2, f2;
  }
  function w8(r2, t2) {
    var e2 = [[r2[0], r2[1], 1, 0, 0, 0, -t2[0] * r2[0], -t2[0] * r2[1]], [0, 0, 0, r2[0], r2[1], 1, -t2[1] * r2[0], -t2[1] * r2[1]], [r2[2], r2[3], 1, 0, 0, 0, -t2[2] * r2[2], -t2[2] * r2[3]], [0, 0, 0, r2[2], r2[3], 1, -t2[3] * r2[2], -t2[3] * r2[3]], [r2[4], r2[5], 1, 0, 0, 0, -t2[4] * r2[4], -t2[4] * r2[5]], [0, 0, 0, r2[4], r2[5], 1, -t2[5] * r2[4], -t2[5] * r2[5]], [r2[6], r2[7], 1, 0, 0, 0, -t2[6] * r2[6], -t2[6] * r2[7]], [0, 0, 0, r2[6], r2[7], 1, -t2[7] * r2[6], -t2[7] * r2[7]]], n2 = {}, a = RR(e2, 8, 0, 0, 0, n2);
    if (a !== 0) {
      for (var i = [], o = 0; o < 8; o++)
        for (var s = 0; s < 8; s++)
          i[s] == null && (i[s] = 0), i[s] += ((o + s) % 2 ? -1 : 1) * RR(e2, 7, o === 0 ? 1 : 0, 1 << o, 1 << s, n2) / a * t2[o];
      return function(u, l2, c2) {
        var f2 = l2 * i[6] + c2 * i[7] + 1;
        u[0] = (l2 * i[0] + c2 * i[1] + i[2]) / f2, u[1] = (l2 * i[3] + c2 * i[4] + i[5]) / f2;
      };
    }
  }
  var S8 = "___zrEVENTSAVED", XL = [];
  function Aae(r2, t2, e2, n2, a) {
    return FR(XL, t2, n2, a, true) && FR(r2, e2, XL[0], XL[1]);
  }
  function FR(r2, t2, e2, n2, a) {
    if (t2.getBoundingClientRect && Ei.domSupported && !sW(t2)) {
      var i = t2[S8] || (t2[S8] = {}), o = Tae(t2, i), s = Mae(o, i, a);
      if (s)
        return s(r2, e2, n2), true;
    }
    return false;
  }
  function Tae(r2, t2) {
    var e2 = t2.markers;
    if (e2)
      return e2;
    e2 = t2.markers = [];
    for (var n2 = ["left", "right"], a = ["top", "bottom"], i = 0; i < 4; i++) {
      var o = document.createElement("div"), s = o.style, u = i % 2, l2 = (i >> 1) % 2;
      s.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", n2[u] + ":0", a[l2] + ":0", n2[1 - u] + ":auto", a[1 - l2] + ":auto", ""].join("!important;"), r2.appendChild(o), e2.push(o);
    }
    return e2;
  }
  function Mae(r2, t2, e2) {
    for (var n2 = e2 ? "invTrans" : "trans", a = t2[n2], i = t2.srcCoords, o = [], s = [], u = true, l2 = 0; l2 < 4; l2++) {
      var c2 = r2[l2].getBoundingClientRect(), f2 = 2 * l2, h = c2.left, v9 = c2.top;
      o.push(h, v9), u = u && i && h === i[f2] && v9 === i[f2 + 1], s.push(r2[l2].offsetLeft, r2[l2].offsetTop);
    }
    return u && a ? a : (t2.srcCoords = o, t2[n2] = e2 ? w8(s, o) : w8(o, s));
  }
  function sW(r2) {
    return r2.nodeName.toUpperCase() === "CANVAS";
  }
  var Pae = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, JL = [], Dae = Ei.browser.firefox && +Ei.browser.version.split(".")[0] < 39;
  function NR(r2, t2, e2, n2) {
    return e2 = e2 || {}, n2 ? C8(r2, t2, e2) : Dae && t2.layerX != null && t2.layerX !== t2.offsetX ? (e2.zrX = t2.layerX, e2.zrY = t2.layerY) : t2.offsetX != null ? (e2.zrX = t2.offsetX, e2.zrY = t2.offsetY) : C8(r2, t2, e2), e2;
  }
  function C8(r2, t2, e2) {
    if (Ei.domSupported && r2.getBoundingClientRect) {
      var n2 = t2.clientX, a = t2.clientY;
      if (sW(r2)) {
        var i = r2.getBoundingClientRect();
        e2.zrX = n2 - i.left, e2.zrY = a - i.top;
        return;
      } else if (FR(JL, r2, n2, a)) {
        e2.zrX = JL[0], e2.zrY = JL[1];
        return;
      }
    }
    e2.zrX = e2.zrY = 0;
  }
  function B6(r2) {
    return r2 || window.event;
  }
  function Oh(r2, t2, e2) {
    if (t2 = B6(t2), t2.zrX != null)
      return t2;
    var n2 = t2.type, a = n2 && n2.indexOf("touch") >= 0;
    if (a) {
      var o = n2 !== "touchend" ? t2.targetTouches[0] : t2.changedTouches[0];
      o && NR(r2, o, t2, e2);
    } else {
      NR(r2, t2, t2, e2);
      var i = Iae(t2);
      t2.zrDelta = i ? i / 120 : -(t2.detail || 0) / 3;
    }
    var s = t2.button;
    return t2.which == null && s !== void 0 && Pae.test(t2.type) && (t2.which = s & 1 ? 1 : s & 2 ? 3 : s & 4 ? 2 : 0), t2;
  }
  function Iae(r2) {
    var t2 = r2.wheelDelta;
    if (t2)
      return t2;
    var e2 = r2.deltaX, n2 = r2.deltaY;
    if (e2 == null || n2 == null)
      return t2;
    var a = Math.abs(n2 !== 0 ? n2 : e2), i = n2 > 0 ? -1 : n2 < 0 ? 1 : e2 > 0 ? -1 : 1;
    return 3 * a * i;
  }
  function VR(r2, t2, e2, n2) {
    r2.addEventListener(t2, e2, n2);
  }
  function Lae(r2, t2, e2, n2) {
    r2.removeEventListener(t2, e2, n2);
  }
  var Mg = function(r2) {
    r2.preventDefault(), r2.stopPropagation(), r2.cancelBubble = true;
  };
  function E8(r2) {
    return r2.which === 2 || r2.which === 3;
  }
  var Oae = function() {
    function r2() {
      this._track = [];
    }
    return r2.prototype.recognize = function(t2, e2, n2) {
      return this._doTrack(t2, e2, n2), this._recognize(t2);
    }, r2.prototype.clear = function() {
      return this._track.length = 0, this;
    }, r2.prototype._doTrack = function(t2, e2, n2) {
      var a = t2.touches;
      if (!!a) {
        for (var i = { points: [], touches: [], target: e2, event: t2 }, o = 0, s = a.length; o < s; o++) {
          var u = a[o], l2 = NR(n2, u, {});
          i.points.push([l2.zrX, l2.zrY]), i.touches.push(u);
        }
        this._track.push(i);
      }
    }, r2.prototype._recognize = function(t2) {
      for (var e2 in QL)
        if (QL.hasOwnProperty(e2)) {
          var n2 = QL[e2](this._track, t2);
          if (n2)
            return n2;
        }
    }, r2;
  }();
  function A8(r2) {
    var t2 = r2[1][0] - r2[0][0], e2 = r2[1][1] - r2[0][1];
    return Math.sqrt(t2 * t2 + e2 * e2);
  }
  function kae(r2) {
    return [(r2[0][0] + r2[1][0]) / 2, (r2[0][1] + r2[1][1]) / 2];
  }
  var QL = { pinch: function(r2, t2) {
    var e2 = r2.length;
    if (!!e2) {
      var n2 = (r2[e2 - 1] || {}).points, a = (r2[e2 - 2] || {}).points || n2;
      if (a && a.length > 1 && n2 && n2.length > 1) {
        var i = A8(n2) / A8(a);
        !isFinite(i) && (i = 1), t2.pinchScale = i;
        var o = kae(n2);
        return t2.pinchX = o[0], t2.pinchY = o[1], { type: "pinch", target: r2[0].target, event: t2 };
      }
    }
  } }, uW = "silent";
  function Rae(r2, t2, e2) {
    return { type: r2, event: e2, target: t2.target, topTarget: t2.topTarget, cancelBubble: false, offsetX: e2.zrX, offsetY: e2.zrY, gestureEvent: e2.gestureEvent, pinchX: e2.pinchX, pinchY: e2.pinchY, pinchScale: e2.pinchScale, wheelDelta: e2.zrDelta, zrByTouch: e2.zrByTouch, which: e2.which, stop: Fae };
  }
  function Fae() {
    Mg(this.event);
  }
  var Nae = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.handler = null, e2;
    }
    return t2.prototype.dispose = function() {
    }, t2.prototype.setCursor = function() {
    }, t2;
  }(Yh), B2 = function() {
    function r2(t2, e2) {
      this.x = t2, this.y = e2;
    }
    return r2;
  }(), Vae = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], lW = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i) {
      var o = r2.call(this) || this;
      return o._hovered = new B2(0, 0), o.storage = e2, o.painter = n2, o.painterRoot = i, a = a || new Nae(), o.proxy = null, o.setHandlerProxy(a), o._draggingMgr = new Sae(o), o;
    }
    return t2.prototype.setHandlerProxy = function(e2) {
      this.proxy && this.proxy.dispose(), e2 && (ae(Vae, function(n2) {
        e2.on && e2.on(n2, this[n2], this);
      }, this), e2.handler = this), this.proxy = e2;
    }, t2.prototype.mousemove = function(e2) {
      var n2 = e2.zrX, a = e2.zrY, i = cW(this, n2, a), o = this._hovered, s = o.target;
      s && !s.__zr && (o = this.findHover(o.x, o.y), s = o.target);
      var u = this._hovered = i ? new B2(n2, a) : this.findHover(n2, a), l2 = u.target, c2 = this.proxy;
      c2.setCursor && c2.setCursor(l2 ? l2.cursor : "default"), s && l2 !== s && this.dispatchToElement(o, "mouseout", e2), this.dispatchToElement(u, "mousemove", e2), l2 && l2 !== s && this.dispatchToElement(u, "mouseover", e2);
    }, t2.prototype.mouseout = function(e2) {
      var n2 = e2.zrEventControl;
      n2 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", e2), n2 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: e2 });
    }, t2.prototype.resize = function() {
      this._hovered = new B2(0, 0);
    }, t2.prototype.dispatch = function(e2, n2) {
      var a = this[e2];
      a && a.call(this, n2);
    }, t2.prototype.dispose = function() {
      this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
    }, t2.prototype.setCursorStyle = function(e2) {
      var n2 = this.proxy;
      n2.setCursor && n2.setCursor(e2);
    }, t2.prototype.dispatchToElement = function(e2, n2, a) {
      e2 = e2 || {};
      var i = e2.target;
      if (!(i && i.silent)) {
        for (var o = "on" + n2, s = Rae(n2, e2, a); i && (i[o] && (s.cancelBubble = !!i[o].call(i, s)), i.trigger(n2, s), i = i.__hostTarget ? i.__hostTarget : i.parent, !s.cancelBubble); )
          ;
        s.cancelBubble || (this.trigger(n2, s), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(u) {
          typeof u[o] == "function" && u[o].call(u, s), u.trigger && u.trigger(n2, s);
        }));
      }
    }, t2.prototype.findHover = function(e2, n2, a) {
      for (var i = this.storage.getDisplayList(), o = new B2(e2, n2), s = i.length - 1; s >= 0; s--) {
        var u = void 0;
        if (i[s] !== a && !i[s].ignore && (u = jae(i[s], e2, n2)) && (!o.topTarget && (o.topTarget = i[s]), u !== uW)) {
          o.target = i[s];
          break;
        }
      }
      return o;
    }, t2.prototype.processGesture = function(e2, n2) {
      this._gestureMgr || (this._gestureMgr = new Oae());
      var a = this._gestureMgr;
      n2 === "start" && a.clear();
      var i = a.recognize(e2, this.findHover(e2.zrX, e2.zrY, null).target, this.proxy.dom);
      if (n2 === "end" && a.clear(), i) {
        var o = i.type;
        e2.gestureEvent = o;
        var s = new B2();
        s.target = i.target, this.dispatchToElement(s, o, i.event);
      }
    }, t2;
  }(Yh);
  ae(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(r2) {
    lW.prototype[r2] = function(t2) {
      var e2 = t2.zrX, n2 = t2.zrY, a = cW(this, e2, n2), i, o;
      if ((r2 !== "mouseup" || !a) && (i = this.findHover(e2, n2), o = i.target), r2 === "mousedown")
        this._downEl = o, this._downPoint = [t2.zrX, t2.zrY], this._upEl = o;
      else if (r2 === "mouseup")
        this._upEl = o;
      else if (r2 === "click") {
        if (this._downEl !== this._upEl || !this._downPoint || ty(this._downPoint, [t2.zrX, t2.zrY]) > 4)
          return;
        this._downPoint = null;
      }
      this.dispatchToElement(i, r2, t2);
    };
  });
  function jae(r2, t2, e2) {
    if (r2[r2.rectHover ? "rectContain" : "contain"](t2, e2)) {
      for (var n2 = r2, a = void 0, i = false; n2; ) {
        if (n2.ignoreClip && (i = true), !i) {
          var o = n2.getClipPath();
          if (o && !o.contain(t2, e2))
            return false;
          n2.silent && (a = true);
        }
        var s = n2.__hostTarget;
        n2 = s || n2.parent;
      }
      return a ? uW : true;
    }
    return false;
  }
  function cW(r2, t2, e2) {
    var n2 = r2.painter;
    return t2 < 0 || t2 > n2.getWidth() || e2 < 0 || e2 > n2.getHeight();
  }
  var Bae = lW, fW = 32, z2 = 7;
  function zae(r2) {
    for (var t2 = 0; r2 >= fW; )
      t2 |= r2 & 1, r2 >>= 1;
    return r2 + t2;
  }
  function T8(r2, t2, e2, n2) {
    var a = t2 + 1;
    if (a === e2)
      return 1;
    if (n2(r2[a++], r2[t2]) < 0) {
      for (; a < e2 && n2(r2[a], r2[a - 1]) < 0; )
        a++;
      $ae(r2, t2, a);
    } else
      for (; a < e2 && n2(r2[a], r2[a - 1]) >= 0; )
        a++;
    return a - t2;
  }
  function $ae(r2, t2, e2) {
    for (e2--; t2 < e2; ) {
      var n2 = r2[t2];
      r2[t2++] = r2[e2], r2[e2--] = n2;
    }
  }
  function M8(r2, t2, e2, n2, a) {
    for (n2 === t2 && n2++; n2 < e2; n2++) {
      for (var i = r2[n2], o = t2, s = n2, u; o < s; )
        u = o + s >>> 1, a(i, r2[u]) < 0 ? s = u : o = u + 1;
      var l2 = n2 - o;
      switch (l2) {
        case 3:
          r2[o + 3] = r2[o + 2];
        case 2:
          r2[o + 2] = r2[o + 1];
        case 1:
          r2[o + 1] = r2[o];
          break;
        default:
          for (; l2 > 0; )
            r2[o + l2] = r2[o + l2 - 1], l2--;
      }
      r2[o] = i;
    }
  }
  function eO(r2, t2, e2, n2, a, i) {
    var o = 0, s = 0, u = 1;
    if (i(r2, t2[e2 + a]) > 0) {
      for (s = n2 - a; u < s && i(r2, t2[e2 + a + u]) > 0; )
        o = u, u = (u << 1) + 1, u <= 0 && (u = s);
      u > s && (u = s), o += a, u += a;
    } else {
      for (s = a + 1; u < s && i(r2, t2[e2 + a - u]) <= 0; )
        o = u, u = (u << 1) + 1, u <= 0 && (u = s);
      u > s && (u = s);
      var l2 = o;
      o = a - u, u = a - l2;
    }
    for (o++; o < u; ) {
      var c2 = o + (u - o >>> 1);
      i(r2, t2[e2 + c2]) > 0 ? o = c2 + 1 : u = c2;
    }
    return u;
  }
  function tO(r2, t2, e2, n2, a, i) {
    var o = 0, s = 0, u = 1;
    if (i(r2, t2[e2 + a]) < 0) {
      for (s = a + 1; u < s && i(r2, t2[e2 + a - u]) < 0; )
        o = u, u = (u << 1) + 1, u <= 0 && (u = s);
      u > s && (u = s);
      var l2 = o;
      o = a - u, u = a - l2;
    } else {
      for (s = n2 - a; u < s && i(r2, t2[e2 + a + u]) >= 0; )
        o = u, u = (u << 1) + 1, u <= 0 && (u = s);
      u > s && (u = s), o += a, u += a;
    }
    for (o++; o < u; ) {
      var c2 = o + (u - o >>> 1);
      i(r2, t2[e2 + c2]) < 0 ? u = c2 : o = c2 + 1;
    }
    return u;
  }
  function Gae(r2, t2) {
    var e2 = z2, n2, a, i = 0, o = [];
    n2 = [], a = [];
    function s(v9, d2) {
      n2[i] = v9, a[i] = d2, i += 1;
    }
    function u() {
      for (; i > 1; ) {
        var v9 = i - 2;
        if (v9 >= 1 && a[v9 - 1] <= a[v9] + a[v9 + 1] || v9 >= 2 && a[v9 - 2] <= a[v9] + a[v9 - 1])
          a[v9 - 1] < a[v9 + 1] && v9--;
        else if (a[v9] > a[v9 + 1])
          break;
        c2(v9);
      }
    }
    function l2() {
      for (; i > 1; ) {
        var v9 = i - 2;
        v9 > 0 && a[v9 - 1] < a[v9 + 1] && v9--, c2(v9);
      }
    }
    function c2(v9) {
      var d2 = n2[v9], m2 = a[v9], b2 = n2[v9 + 1], _ = a[v9 + 1];
      a[v9] = m2 + _, v9 === i - 3 && (n2[v9 + 1] = n2[v9 + 2], a[v9 + 1] = a[v9 + 2]), i--;
      var C = tO(r2[b2], r2, d2, m2, 0, t2);
      d2 += C, m2 -= C, m2 !== 0 && (_ = eO(r2[d2 + m2 - 1], r2, b2, _, _ - 1, t2), _ !== 0 && (m2 <= _ ? f2(d2, m2, b2, _) : h(d2, m2, b2, _)));
    }
    function f2(v9, d2, m2, b2) {
      var _ = 0;
      for (_ = 0; _ < d2; _++)
        o[_] = r2[v9 + _];
      var C = 0, M = m2, E = v9;
      if (r2[E++] = r2[M++], --b2 === 0) {
        for (_ = 0; _ < d2; _++)
          r2[E + _] = o[C + _];
        return;
      }
      if (d2 === 1) {
        for (_ = 0; _ < b2; _++)
          r2[E + _] = r2[M + _];
        r2[E + b2] = o[C];
        return;
      }
      for (var z9 = e2, V, $, U; ; ) {
        V = 0, $ = 0, U = false;
        do
          if (t2(r2[M], o[C]) < 0) {
            if (r2[E++] = r2[M++], $++, V = 0, --b2 === 0) {
              U = true;
              break;
            }
          } else if (r2[E++] = o[C++], V++, $ = 0, --d2 === 1) {
            U = true;
            break;
          }
        while ((V | $) < z9);
        if (U)
          break;
        do {
          if (V = tO(r2[M], o, C, d2, 0, t2), V !== 0) {
            for (_ = 0; _ < V; _++)
              r2[E + _] = o[C + _];
            if (E += V, C += V, d2 -= V, d2 <= 1) {
              U = true;
              break;
            }
          }
          if (r2[E++] = r2[M++], --b2 === 0) {
            U = true;
            break;
          }
          if ($ = eO(o[C], r2, M, b2, 0, t2), $ !== 0) {
            for (_ = 0; _ < $; _++)
              r2[E + _] = r2[M + _];
            if (E += $, M += $, b2 -= $, b2 === 0) {
              U = true;
              break;
            }
          }
          if (r2[E++] = o[C++], --d2 === 1) {
            U = true;
            break;
          }
          z9--;
        } while (V >= z2 || $ >= z2);
        if (U)
          break;
        z9 < 0 && (z9 = 0), z9 += 2;
      }
      if (e2 = z9, e2 < 1 && (e2 = 1), d2 === 1) {
        for (_ = 0; _ < b2; _++)
          r2[E + _] = r2[M + _];
        r2[E + b2] = o[C];
      } else {
        if (d2 === 0)
          throw new Error();
        for (_ = 0; _ < d2; _++)
          r2[E + _] = o[C + _];
      }
    }
    function h(v9, d2, m2, b2) {
      var _ = 0;
      for (_ = 0; _ < b2; _++)
        o[_] = r2[m2 + _];
      var C = v9 + d2 - 1, M = b2 - 1, E = m2 + b2 - 1, z9 = 0, V = 0;
      if (r2[E--] = r2[C--], --d2 === 0) {
        for (z9 = E - (b2 - 1), _ = 0; _ < b2; _++)
          r2[z9 + _] = o[_];
        return;
      }
      if (b2 === 1) {
        for (E -= d2, C -= d2, V = E + 1, z9 = C + 1, _ = d2 - 1; _ >= 0; _--)
          r2[V + _] = r2[z9 + _];
        r2[E] = o[M];
        return;
      }
      for (var $ = e2; ; ) {
        var U = 0, H = 0, q3 = false;
        do
          if (t2(o[M], r2[C]) < 0) {
            if (r2[E--] = r2[C--], U++, H = 0, --d2 === 0) {
              q3 = true;
              break;
            }
          } else if (r2[E--] = o[M--], H++, U = 0, --b2 === 1) {
            q3 = true;
            break;
          }
        while ((U | H) < $);
        if (q3)
          break;
        do {
          if (U = d2 - tO(o[M], r2, v9, d2, d2 - 1, t2), U !== 0) {
            for (E -= U, C -= U, d2 -= U, V = E + 1, z9 = C + 1, _ = U - 1; _ >= 0; _--)
              r2[V + _] = r2[z9 + _];
            if (d2 === 0) {
              q3 = true;
              break;
            }
          }
          if (r2[E--] = o[M--], --b2 === 1) {
            q3 = true;
            break;
          }
          if (H = b2 - eO(r2[C], o, 0, b2, b2 - 1, t2), H !== 0) {
            for (E -= H, M -= H, b2 -= H, V = E + 1, z9 = M + 1, _ = 0; _ < H; _++)
              r2[V + _] = o[z9 + _];
            if (b2 <= 1) {
              q3 = true;
              break;
            }
          }
          if (r2[E--] = r2[C--], --d2 === 0) {
            q3 = true;
            break;
          }
          $--;
        } while (U >= z2 || H >= z2);
        if (q3)
          break;
        $ < 0 && ($ = 0), $ += 2;
      }
      if (e2 = $, e2 < 1 && (e2 = 1), b2 === 1) {
        for (E -= d2, C -= d2, V = E + 1, z9 = C + 1, _ = d2 - 1; _ >= 0; _--)
          r2[V + _] = r2[z9 + _];
        r2[E] = o[M];
      } else {
        if (b2 === 0)
          throw new Error();
        for (z9 = E - (b2 - 1), _ = 0; _ < b2; _++)
          r2[z9 + _] = o[_];
      }
    }
    return { mergeRuns: u, forceMergeRuns: l2, pushRun: s };
  }
  function S5(r2, t2, e2, n2) {
    e2 || (e2 = 0), n2 || (n2 = r2.length);
    var a = n2 - e2;
    if (!(a < 2)) {
      var i = 0;
      if (a < fW) {
        i = T8(r2, e2, n2, t2), M8(r2, e2, n2, e2 + i, t2);
        return;
      }
      var o = Gae(r2, t2), s = zae(a);
      do {
        if (i = T8(r2, e2, n2, t2), i < s) {
          var u = a;
          u > s && (u = s), M8(r2, e2, e2 + u, e2 + i, t2), i = u;
        }
        o.pushRun(e2, i), o.mergeRuns(), a -= i, e2 += i;
      } while (a !== 0);
      o.forceMergeRuns();
    }
  }
  var Kf = 1, mC = 2, kx = 4, P8 = false;
  function rO() {
    P8 || (P8 = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
  }
  function D8(r2, t2) {
    return r2.zlevel === t2.zlevel ? r2.z === t2.z ? r2.z2 - t2.z2 : r2.z - t2.z : r2.zlevel - t2.zlevel;
  }
  var Wae = function() {
    function r2() {
      this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = D8;
    }
    return r2.prototype.traverse = function(t2, e2) {
      for (var n2 = 0; n2 < this._roots.length; n2++)
        this._roots[n2].traverse(t2, e2);
    }, r2.prototype.getDisplayList = function(t2, e2) {
      e2 = e2 || false;
      var n2 = this._displayList;
      return (t2 || !n2.length) && this.updateDisplayList(e2), n2;
    }, r2.prototype.updateDisplayList = function(t2) {
      this._displayListLen = 0;
      for (var e2 = this._roots, n2 = this._displayList, a = 0, i = e2.length; a < i; a++)
        this._updateAndAddDisplayable(e2[a], null, t2);
      n2.length = this._displayListLen, S5(n2, D8);
    }, r2.prototype._updateAndAddDisplayable = function(t2, e2, n2) {
      if (!(t2.ignore && !n2)) {
        t2.beforeUpdate(), t2.update(), t2.afterUpdate();
        var a = t2.getClipPath();
        if (t2.ignoreClip)
          e2 = null;
        else if (a) {
          e2 ? e2 = e2.slice() : e2 = [];
          for (var i = a, o = t2; i; )
            i.parent = o, i.updateTransform(), e2.push(i), o = i, i = i.getClipPath();
        }
        if (t2.childrenRef) {
          for (var s = t2.childrenRef(), u = 0; u < s.length; u++) {
            var l2 = s[u];
            t2.__dirty && (l2.__dirty |= Kf), this._updateAndAddDisplayable(l2, e2, n2);
          }
          t2.__dirty = 0;
        } else {
          var c2 = t2;
          e2 && e2.length ? c2.__clipPaths = e2 : c2.__clipPaths && c2.__clipPaths.length > 0 && (c2.__clipPaths = []), isNaN(c2.z) && (rO(), c2.z = 0), isNaN(c2.z2) && (rO(), c2.z2 = 0), isNaN(c2.zlevel) && (rO(), c2.zlevel = 0), this._displayList[this._displayListLen++] = c2;
        }
        var f2 = t2.getDecalElement && t2.getDecalElement();
        f2 && this._updateAndAddDisplayable(f2, e2, n2);
        var h = t2.getTextGuideLine();
        h && this._updateAndAddDisplayable(h, e2, n2);
        var v9 = t2.getTextContent();
        v9 && this._updateAndAddDisplayable(v9, e2, n2);
      }
    }, r2.prototype.addRoot = function(t2) {
      t2.__zr && t2.__zr.storage === this || this._roots.push(t2);
    }, r2.prototype.delRoot = function(t2) {
      if (t2 instanceof Array) {
        for (var e2 = 0, n2 = t2.length; e2 < n2; e2++)
          this.delRoot(t2[e2]);
        return;
      }
      var a = va(this._roots, t2);
      a >= 0 && this._roots.splice(a, 1);
    }, r2.prototype.delAllRoots = function() {
      this._roots = [], this._displayList = [], this._displayListLen = 0;
    }, r2.prototype.getRoots = function() {
      return this._roots;
    }, r2.prototype.dispose = function() {
      this._displayList = null, this._roots = null;
    }, r2;
  }(), Uae = Wae, hW;
  hW = Ei.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(r2) {
    return setTimeout(r2, 16);
  };
  var jR = hW, C5 = { linear: function(r2) {
    return r2;
  }, quadraticIn: function(r2) {
    return r2 * r2;
  }, quadraticOut: function(r2) {
    return r2 * (2 - r2);
  }, quadraticInOut: function(r2) {
    return (r2 *= 2) < 1 ? 0.5 * r2 * r2 : -0.5 * (--r2 * (r2 - 2) - 1);
  }, cubicIn: function(r2) {
    return r2 * r2 * r2;
  }, cubicOut: function(r2) {
    return --r2 * r2 * r2 + 1;
  }, cubicInOut: function(r2) {
    return (r2 *= 2) < 1 ? 0.5 * r2 * r2 * r2 : 0.5 * ((r2 -= 2) * r2 * r2 + 2);
  }, quarticIn: function(r2) {
    return r2 * r2 * r2 * r2;
  }, quarticOut: function(r2) {
    return 1 - --r2 * r2 * r2 * r2;
  }, quarticInOut: function(r2) {
    return (r2 *= 2) < 1 ? 0.5 * r2 * r2 * r2 * r2 : -0.5 * ((r2 -= 2) * r2 * r2 * r2 - 2);
  }, quinticIn: function(r2) {
    return r2 * r2 * r2 * r2 * r2;
  }, quinticOut: function(r2) {
    return --r2 * r2 * r2 * r2 * r2 + 1;
  }, quinticInOut: function(r2) {
    return (r2 *= 2) < 1 ? 0.5 * r2 * r2 * r2 * r2 * r2 : 0.5 * ((r2 -= 2) * r2 * r2 * r2 * r2 + 2);
  }, sinusoidalIn: function(r2) {
    return 1 - Math.cos(r2 * Math.PI / 2);
  }, sinusoidalOut: function(r2) {
    return Math.sin(r2 * Math.PI / 2);
  }, sinusoidalInOut: function(r2) {
    return 0.5 * (1 - Math.cos(Math.PI * r2));
  }, exponentialIn: function(r2) {
    return r2 === 0 ? 0 : Math.pow(1024, r2 - 1);
  }, exponentialOut: function(r2) {
    return r2 === 1 ? 1 : 1 - Math.pow(2, -10 * r2);
  }, exponentialInOut: function(r2) {
    return r2 === 0 ? 0 : r2 === 1 ? 1 : (r2 *= 2) < 1 ? 0.5 * Math.pow(1024, r2 - 1) : 0.5 * (-Math.pow(2, -10 * (r2 - 1)) + 2);
  }, circularIn: function(r2) {
    return 1 - Math.sqrt(1 - r2 * r2);
  }, circularOut: function(r2) {
    return Math.sqrt(1 - --r2 * r2);
  }, circularInOut: function(r2) {
    return (r2 *= 2) < 1 ? -0.5 * (Math.sqrt(1 - r2 * r2) - 1) : 0.5 * (Math.sqrt(1 - (r2 -= 2) * r2) + 1);
  }, elasticIn: function(r2) {
    var t2, e2 = 0.1, n2 = 0.4;
    return r2 === 0 ? 0 : r2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, t2 = n2 / 4) : t2 = n2 * Math.asin(1 / e2) / (2 * Math.PI), -(e2 * Math.pow(2, 10 * (r2 -= 1)) * Math.sin((r2 - t2) * (2 * Math.PI) / n2)));
  }, elasticOut: function(r2) {
    var t2, e2 = 0.1, n2 = 0.4;
    return r2 === 0 ? 0 : r2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, t2 = n2 / 4) : t2 = n2 * Math.asin(1 / e2) / (2 * Math.PI), e2 * Math.pow(2, -10 * r2) * Math.sin((r2 - t2) * (2 * Math.PI) / n2) + 1);
  }, elasticInOut: function(r2) {
    var t2, e2 = 0.1, n2 = 0.4;
    return r2 === 0 ? 0 : r2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, t2 = n2 / 4) : t2 = n2 * Math.asin(1 / e2) / (2 * Math.PI), (r2 *= 2) < 1 ? -0.5 * (e2 * Math.pow(2, 10 * (r2 -= 1)) * Math.sin((r2 - t2) * (2 * Math.PI) / n2)) : e2 * Math.pow(2, -10 * (r2 -= 1)) * Math.sin((r2 - t2) * (2 * Math.PI) / n2) * 0.5 + 1);
  }, backIn: function(r2) {
    var t2 = 1.70158;
    return r2 * r2 * ((t2 + 1) * r2 - t2);
  }, backOut: function(r2) {
    var t2 = 1.70158;
    return --r2 * r2 * ((t2 + 1) * r2 + t2) + 1;
  }, backInOut: function(r2) {
    var t2 = 2.5949095;
    return (r2 *= 2) < 1 ? 0.5 * (r2 * r2 * ((t2 + 1) * r2 - t2)) : 0.5 * ((r2 -= 2) * r2 * ((t2 + 1) * r2 + t2) + 2);
  }, bounceIn: function(r2) {
    return 1 - C5.bounceOut(1 - r2);
  }, bounceOut: function(r2) {
    return r2 < 1 / 2.75 ? 7.5625 * r2 * r2 : r2 < 2 / 2.75 ? 7.5625 * (r2 -= 1.5 / 2.75) * r2 + 0.75 : r2 < 2.5 / 2.75 ? 7.5625 * (r2 -= 2.25 / 2.75) * r2 + 0.9375 : 7.5625 * (r2 -= 2.625 / 2.75) * r2 + 0.984375;
  }, bounceInOut: function(r2) {
    return r2 < 0.5 ? C5.bounceIn(r2 * 2) * 0.5 : C5.bounceOut(r2 * 2 - 1) * 0.5 + 0.5;
  } }, vW = C5, vM = Math.pow, hy = Math.sqrt, W5 = 1e-8, dW = 1e-4, I8 = hy(3), dM = 1 / 3, Gd = o1(), Nh = o1(), Yx = o1();
  function ay(r2) {
    return r2 > -W5 && r2 < W5;
  }
  function pW(r2) {
    return r2 > W5 || r2 < -W5;
  }
  function Wu(r2, t2, e2, n2, a) {
    var i = 1 - a;
    return i * i * (i * r2 + 3 * a * t2) + a * a * (a * n2 + 3 * i * e2);
  }
  function L8(r2, t2, e2, n2, a) {
    var i = 1 - a;
    return 3 * (((t2 - r2) * i + 2 * (e2 - t2) * a) * i + (n2 - e2) * a * a);
  }
  function U5(r2, t2, e2, n2, a, i) {
    var o = n2 + 3 * (t2 - e2) - r2, s = 3 * (e2 - t2 * 2 + r2), u = 3 * (t2 - r2), l2 = r2 - a, c2 = s * s - 3 * o * u, f2 = s * u - 9 * o * l2, h = u * u - 3 * s * l2, v9 = 0;
    if (ay(c2) && ay(f2))
      if (ay(s))
        i[0] = 0;
      else {
        var d2 = -u / s;
        d2 >= 0 && d2 <= 1 && (i[v9++] = d2);
      }
    else {
      var m2 = f2 * f2 - 4 * c2 * h;
      if (ay(m2)) {
        var b2 = f2 / c2, d2 = -s / o + b2, _ = -b2 / 2;
        d2 >= 0 && d2 <= 1 && (i[v9++] = d2), _ >= 0 && _ <= 1 && (i[v9++] = _);
      } else if (m2 > 0) {
        var C = hy(m2), M = c2 * s + 1.5 * o * (-f2 + C), E = c2 * s + 1.5 * o * (-f2 - C);
        M < 0 ? M = -vM(-M, dM) : M = vM(M, dM), E < 0 ? E = -vM(-E, dM) : E = vM(E, dM);
        var d2 = (-s - (M + E)) / (3 * o);
        d2 >= 0 && d2 <= 1 && (i[v9++] = d2);
      } else {
        var z9 = (2 * c2 * s - 3 * o * f2) / (2 * hy(c2 * c2 * c2)), V = Math.acos(z9) / 3, $ = hy(c2), U = Math.cos(V), d2 = (-s - 2 * $ * U) / (3 * o), _ = (-s + $ * (U + I8 * Math.sin(V))) / (3 * o), H = (-s + $ * (U - I8 * Math.sin(V))) / (3 * o);
        d2 >= 0 && d2 <= 1 && (i[v9++] = d2), _ >= 0 && _ <= 1 && (i[v9++] = _), H >= 0 && H <= 1 && (i[v9++] = H);
      }
    }
    return v9;
  }
  function gW(r2, t2, e2, n2, a) {
    var i = 6 * e2 - 12 * t2 + 6 * r2, o = 9 * t2 + 3 * n2 - 3 * r2 - 9 * e2, s = 3 * t2 - 3 * r2, u = 0;
    if (ay(o)) {
      if (pW(i)) {
        var l2 = -s / i;
        l2 >= 0 && l2 <= 1 && (a[u++] = l2);
      }
    } else {
      var c2 = i * i - 4 * o * s;
      if (ay(c2))
        a[0] = -i / (2 * o);
      else if (c2 > 0) {
        var f2 = hy(c2), l2 = (-i + f2) / (2 * o), h = (-i - f2) / (2 * o);
        l2 >= 0 && l2 <= 1 && (a[u++] = l2), h >= 0 && h <= 1 && (a[u++] = h);
      }
    }
    return u;
  }
  function yy(r2, t2, e2, n2, a, i) {
    var o = (t2 - r2) * a + r2, s = (e2 - t2) * a + t2, u = (n2 - e2) * a + e2, l2 = (s - o) * a + o, c2 = (u - s) * a + s, f2 = (c2 - l2) * a + l2;
    i[0] = r2, i[1] = o, i[2] = l2, i[3] = f2, i[4] = f2, i[5] = c2, i[6] = u, i[7] = n2;
  }
  function yW(r2, t2, e2, n2, a, i, o, s, u, l2, c2) {
    var f2, h = 5e-3, v9 = 1 / 0, d2, m2, b2, _;
    Gd[0] = u, Gd[1] = l2;
    for (var C = 0; C < 1; C += 0.05)
      Nh[0] = Wu(r2, e2, a, o, C), Nh[1] = Wu(t2, n2, i, s, C), b2 = Wb(Gd, Nh), b2 < v9 && (f2 = C, v9 = b2);
    v9 = 1 / 0;
    for (var M = 0; M < 32 && !(h < dW); M++)
      d2 = f2 - h, m2 = f2 + h, Nh[0] = Wu(r2, e2, a, o, d2), Nh[1] = Wu(t2, n2, i, s, d2), b2 = Wb(Nh, Gd), d2 >= 0 && b2 < v9 ? (f2 = d2, v9 = b2) : (Yx[0] = Wu(r2, e2, a, o, m2), Yx[1] = Wu(t2, n2, i, s, m2), _ = Wb(Yx, Gd), m2 <= 1 && _ < v9 ? (f2 = m2, v9 = _) : h *= 0.5);
    return c2 && (c2[0] = Wu(r2, e2, a, o, f2), c2[1] = Wu(t2, n2, i, s, f2)), hy(v9);
  }
  function Hae(r2, t2, e2, n2, a, i, o, s, u) {
    for (var l2 = r2, c2 = t2, f2 = 0, h = 1 / u, v9 = 1; v9 <= u; v9++) {
      var d2 = v9 * h, m2 = Wu(r2, e2, a, o, d2), b2 = Wu(t2, n2, i, s, d2), _ = m2 - l2, C = b2 - c2;
      f2 += Math.sqrt(_ * _ + C * C), l2 = m2, c2 = b2;
    }
    return f2;
  }
  function yl(r2, t2, e2, n2) {
    var a = 1 - n2;
    return a * (a * r2 + 2 * n2 * t2) + n2 * n2 * e2;
  }
  function BR(r2, t2, e2, n2) {
    return 2 * ((1 - n2) * (t2 - r2) + n2 * (e2 - t2));
  }
  function qae(r2, t2, e2, n2, a) {
    var i = r2 - 2 * t2 + e2, o = 2 * (t2 - r2), s = r2 - n2, u = 0;
    if (ay(i)) {
      if (pW(o)) {
        var l2 = -s / o;
        l2 >= 0 && l2 <= 1 && (a[u++] = l2);
      }
    } else {
      var c2 = o * o - 4 * i * s;
      if (ay(c2)) {
        var l2 = -o / (2 * i);
        l2 >= 0 && l2 <= 1 && (a[u++] = l2);
      } else if (c2 > 0) {
        var f2 = hy(c2), l2 = (-o + f2) / (2 * i), h = (-o - f2) / (2 * i);
        l2 >= 0 && l2 <= 1 && (a[u++] = l2), h >= 0 && h <= 1 && (a[u++] = h);
      }
    }
    return u;
  }
  function mW(r2, t2, e2) {
    var n2 = r2 + e2 - 2 * t2;
    return n2 === 0 ? 0.5 : (r2 - t2) / n2;
  }
  function JC(r2, t2, e2, n2, a) {
    var i = (t2 - r2) * n2 + r2, o = (e2 - t2) * n2 + t2, s = (o - i) * n2 + i;
    a[0] = r2, a[1] = i, a[2] = s, a[3] = s, a[4] = o, a[5] = e2;
  }
  function bW(r2, t2, e2, n2, a, i, o, s, u) {
    var l2, c2 = 5e-3, f2 = 1 / 0;
    Gd[0] = o, Gd[1] = s;
    for (var h = 0; h < 1; h += 0.05) {
      Nh[0] = yl(r2, e2, a, h), Nh[1] = yl(t2, n2, i, h);
      var v9 = Wb(Gd, Nh);
      v9 < f2 && (l2 = h, f2 = v9);
    }
    f2 = 1 / 0;
    for (var d2 = 0; d2 < 32 && !(c2 < dW); d2++) {
      var m2 = l2 - c2, b2 = l2 + c2;
      Nh[0] = yl(r2, e2, a, m2), Nh[1] = yl(t2, n2, i, m2);
      var v9 = Wb(Nh, Gd);
      if (m2 >= 0 && v9 < f2)
        l2 = m2, f2 = v9;
      else {
        Yx[0] = yl(r2, e2, a, b2), Yx[1] = yl(t2, n2, i, b2);
        var _ = Wb(Yx, Gd);
        b2 <= 1 && _ < f2 ? (l2 = b2, f2 = _) : c2 *= 0.5;
      }
    }
    return u && (u[0] = yl(r2, e2, a, l2), u[1] = yl(t2, n2, i, l2)), hy(f2);
  }
  function Yae(r2, t2, e2, n2, a, i, o) {
    for (var s = r2, u = t2, l2 = 0, c2 = 1 / o, f2 = 1; f2 <= o; f2++) {
      var h = f2 * c2, v9 = yl(r2, e2, a, h), d2 = yl(t2, n2, i, h), m2 = v9 - s, b2 = d2 - u;
      l2 += Math.sqrt(m2 * m2 + b2 * b2), s = v9, u = d2;
    }
    return l2;
  }
  var Kae = /cubic-bezier\(([0-9,\.e ]+)\)/;
  function z6(r2) {
    var t2 = r2 && Kae.exec(r2);
    if (t2) {
      var e2 = t2[1].split(","), n2 = +jv(e2[0]), a = +jv(e2[1]), i = +jv(e2[2]), o = +jv(e2[3]);
      if (isNaN(n2 + a + i + o))
        return;
      var s = [];
      return function(u) {
        return u <= 0 ? 0 : u >= 1 ? 1 : U5(0, n2, i, 1, u, s) && Wu(0, a, o, 1, s[0]);
      };
    }
  }
  var Zae = function() {
    function r2(t2) {
      this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = t2.life || 1e3, this._delay = t2.delay || 0, this.loop = t2.loop || false, this.onframe = t2.onframe || lu, this.ondestroy = t2.ondestroy || lu, this.onrestart = t2.onrestart || lu, t2.easing && this.setEasing(t2.easing);
    }
    return r2.prototype.step = function(t2, e2) {
      if (this._inited || (this._startTime = t2 + this._delay, this._inited = true), this._paused) {
        this._pausedTime += e2;
        return;
      }
      var n2 = this._life, a = t2 - this._startTime - this._pausedTime, i = a / n2;
      i < 0 && (i = 0), i = Math.min(i, 1);
      var o = this.easingFunc, s = o ? o(i) : i;
      if (this.onframe(s), i === 1)
        if (this.loop) {
          var u = a % n2;
          this._startTime = t2 - u, this._pausedTime = 0, this.onrestart();
        } else
          return true;
      return false;
    }, r2.prototype.pause = function() {
      this._paused = true;
    }, r2.prototype.resume = function() {
      this._paused = false;
    }, r2.prototype.setEasing = function(t2) {
      this.easing = t2, this.easingFunc = xn(t2) ? t2 : vW[t2] || z6(t2);
    }, r2;
  }(), Xae = Zae, _W = function() {
    function r2(t2) {
      this.value = t2;
    }
    return r2;
  }(), Jae = function() {
    function r2() {
      this._len = 0;
    }
    return r2.prototype.insert = function(t2) {
      var e2 = new _W(t2);
      return this.insertEntry(e2), e2;
    }, r2.prototype.insertEntry = function(t2) {
      this.head ? (this.tail.next = t2, t2.prev = this.tail, t2.next = null, this.tail = t2) : this.head = this.tail = t2, this._len++;
    }, r2.prototype.remove = function(t2) {
      var e2 = t2.prev, n2 = t2.next;
      e2 ? e2.next = n2 : this.head = n2, n2 ? n2.prev = e2 : this.tail = e2, t2.next = t2.prev = null, this._len--;
    }, r2.prototype.len = function() {
      return this._len;
    }, r2.prototype.clear = function() {
      this.head = this.tail = null, this._len = 0;
    }, r2;
  }(), Qae = function() {
    function r2(t2) {
      this._list = new Jae(), this._maxSize = 10, this._map = {}, this._maxSize = t2;
    }
    return r2.prototype.put = function(t2, e2) {
      var n2 = this._list, a = this._map, i = null;
      if (a[t2] == null) {
        var o = n2.len(), s = this._lastRemovedEntry;
        if (o >= this._maxSize && o > 0) {
          var u = n2.head;
          n2.remove(u), delete a[u.key], i = u.value, this._lastRemovedEntry = u;
        }
        s ? s.value = e2 : s = new _W(e2), s.key = t2, n2.insertEntry(s), a[t2] = s;
      }
      return i;
    }, r2.prototype.get = function(t2) {
      var e2 = this._map[t2], n2 = this._list;
      if (e2 != null)
        return e2 !== n2.tail && (n2.remove(e2), n2.insertEntry(e2)), e2.value;
    }, r2.prototype.clear = function() {
      this._list.clear(), this._map = {};
    }, r2.prototype.len = function() {
      return this._list.len();
    }, r2;
  }(), ME = Qae, O8 = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
  function zv(r2) {
    return r2 = Math.round(r2), r2 < 0 ? 0 : r2 > 255 ? 255 : r2;
  }
  function eie(r2) {
    return r2 = Math.round(r2), r2 < 0 ? 0 : r2 > 360 ? 360 : r2;
  }
  function QC(r2) {
    return r2 < 0 ? 0 : r2 > 1 ? 1 : r2;
  }
  function nO(r2) {
    var t2 = r2;
    return t2.length && t2.charAt(t2.length - 1) === "%" ? zv(parseFloat(t2) / 100 * 255) : zv(parseInt(t2, 10));
  }
  function tw(r2) {
    var t2 = r2;
    return t2.length && t2.charAt(t2.length - 1) === "%" ? QC(parseFloat(t2) / 100) : QC(parseFloat(t2));
  }
  function aO(r2, t2, e2) {
    return e2 < 0 ? e2 += 1 : e2 > 1 && (e2 -= 1), e2 * 6 < 1 ? r2 + (t2 - r2) * e2 * 6 : e2 * 2 < 1 ? t2 : e2 * 3 < 2 ? r2 + (t2 - r2) * (2 / 3 - e2) * 6 : r2;
  }
  function iy(r2, t2, e2) {
    return r2 + (t2 - r2) * e2;
  }
  function Lh(r2, t2, e2, n2, a) {
    return r2[0] = t2, r2[1] = e2, r2[2] = n2, r2[3] = a, r2;
  }
  function zR(r2, t2) {
    return r2[0] = t2[0], r2[1] = t2[1], r2[2] = t2[2], r2[3] = t2[3], r2;
  }
  var xW = new ME(20), pM = null;
  function hx(r2, t2) {
    pM && zR(pM, t2), pM = xW.put(r2, pM || t2.slice());
  }
  function Xf(r2, t2) {
    if (!!r2) {
      t2 = t2 || [];
      var e2 = xW.get(r2);
      if (e2)
        return zR(t2, e2);
      r2 = r2 + "";
      var n2 = r2.replace(/ /g, "").toLowerCase();
      if (n2 in O8)
        return zR(t2, O8[n2]), hx(r2, t2), t2;
      var a = n2.length;
      if (n2.charAt(0) === "#") {
        if (a === 4 || a === 5) {
          var i = parseInt(n2.slice(1, 4), 16);
          if (!(i >= 0 && i <= 4095)) {
            Lh(t2, 0, 0, 0, 1);
            return;
          }
          return Lh(t2, (i & 3840) >> 4 | (i & 3840) >> 8, i & 240 | (i & 240) >> 4, i & 15 | (i & 15) << 4, a === 5 ? parseInt(n2.slice(4), 16) / 15 : 1), hx(r2, t2), t2;
        } else if (a === 7 || a === 9) {
          var i = parseInt(n2.slice(1, 7), 16);
          if (!(i >= 0 && i <= 16777215)) {
            Lh(t2, 0, 0, 0, 1);
            return;
          }
          return Lh(t2, (i & 16711680) >> 16, (i & 65280) >> 8, i & 255, a === 9 ? parseInt(n2.slice(7), 16) / 255 : 1), hx(r2, t2), t2;
        }
        return;
      }
      var o = n2.indexOf("("), s = n2.indexOf(")");
      if (o !== -1 && s + 1 === a) {
        var u = n2.substr(0, o), l2 = n2.substr(o + 1, s - (o + 1)).split(","), c2 = 1;
        switch (u) {
          case "rgba":
            if (l2.length !== 4)
              return l2.length === 3 ? Lh(t2, +l2[0], +l2[1], +l2[2], 1) : Lh(t2, 0, 0, 0, 1);
            c2 = tw(l2.pop());
          case "rgb":
            if (l2.length !== 3) {
              Lh(t2, 0, 0, 0, 1);
              return;
            }
            return Lh(t2, nO(l2[0]), nO(l2[1]), nO(l2[2]), c2), hx(r2, t2), t2;
          case "hsla":
            if (l2.length !== 4) {
              Lh(t2, 0, 0, 0, 1);
              return;
            }
            return l2[3] = tw(l2[3]), $R(l2, t2), hx(r2, t2), t2;
          case "hsl":
            if (l2.length !== 3) {
              Lh(t2, 0, 0, 0, 1);
              return;
            }
            return $R(l2, t2), hx(r2, t2), t2;
          default:
            return;
        }
      }
      Lh(t2, 0, 0, 0, 1);
    }
  }
  function $R(r2, t2) {
    var e2 = (parseFloat(r2[0]) % 360 + 360) % 360 / 360, n2 = tw(r2[1]), a = tw(r2[2]), i = a <= 0.5 ? a * (n2 + 1) : a + n2 - a * n2, o = a * 2 - i;
    return t2 = t2 || [], Lh(t2, zv(aO(o, i, e2 + 1 / 3) * 255), zv(aO(o, i, e2) * 255), zv(aO(o, i, e2 - 1 / 3) * 255), 1), r2.length === 4 && (t2[3] = r2[3]), t2;
  }
  function tie(r2) {
    if (!!r2) {
      var t2 = r2[0] / 255, e2 = r2[1] / 255, n2 = r2[2] / 255, a = Math.min(t2, e2, n2), i = Math.max(t2, e2, n2), o = i - a, s = (i + a) / 2, u, l2;
      if (o === 0)
        u = 0, l2 = 0;
      else {
        s < 0.5 ? l2 = o / (i + a) : l2 = o / (2 - i - a);
        var c2 = ((i - t2) / 6 + o / 2) / o, f2 = ((i - e2) / 6 + o / 2) / o, h = ((i - n2) / 6 + o / 2) / o;
        t2 === i ? u = h - f2 : e2 === i ? u = 1 / 3 + c2 - h : n2 === i && (u = 2 / 3 + f2 - c2), u < 0 && (u += 1), u > 1 && (u -= 1);
      }
      var v9 = [u * 360, l2, s];
      return r2[3] != null && v9.push(r2[3]), v9;
    }
  }
  function GR(r2, t2) {
    var e2 = Xf(r2);
    if (e2) {
      for (var n2 = 0; n2 < 3; n2++)
        t2 < 0 ? e2[n2] = e2[n2] * (1 - t2) | 0 : e2[n2] = (255 - e2[n2]) * t2 + e2[n2] | 0, e2[n2] > 255 ? e2[n2] = 255 : e2[n2] < 0 && (e2[n2] = 0);
      return wg(e2, e2.length === 4 ? "rgba" : "rgb");
    }
  }
  function iO(r2, t2, e2) {
    if (!(!(t2 && t2.length) || !(r2 >= 0 && r2 <= 1))) {
      e2 = e2 || [];
      var n2 = r2 * (t2.length - 1), a = Math.floor(n2), i = Math.ceil(n2), o = t2[a], s = t2[i], u = n2 - a;
      return e2[0] = zv(iy(o[0], s[0], u)), e2[1] = zv(iy(o[1], s[1], u)), e2[2] = zv(iy(o[2], s[2], u)), e2[3] = QC(iy(o[3], s[3], u)), e2;
    }
  }
  function rie(r2, t2, e2) {
    if (!(!(t2 && t2.length) || !(r2 >= 0 && r2 <= 1))) {
      var n2 = r2 * (t2.length - 1), a = Math.floor(n2), i = Math.ceil(n2), o = Xf(t2[a]), s = Xf(t2[i]), u = n2 - a, l2 = wg([zv(iy(o[0], s[0], u)), zv(iy(o[1], s[1], u)), zv(iy(o[2], s[2], u)), QC(iy(o[3], s[3], u))], "rgba");
      return e2 ? { color: l2, leftIndex: a, rightIndex: i, value: n2 } : l2;
    }
  }
  function LC(r2, t2, e2, n2) {
    var a = Xf(r2);
    if (r2)
      return a = tie(a), t2 != null && (a[0] = eie(t2)), e2 != null && (a[1] = tw(e2)), n2 != null && (a[2] = tw(n2)), wg($R(a), "rgba");
  }
  function H5(r2, t2) {
    var e2 = Xf(r2);
    if (e2 && t2 != null)
      return e2[3] = QC(t2), wg(e2, "rgba");
  }
  function wg(r2, t2) {
    if (!(!r2 || !r2.length)) {
      var e2 = r2[0] + "," + r2[1] + "," + r2[2];
      return (t2 === "rgba" || t2 === "hsva" || t2 === "hsla") && (e2 += "," + r2[3]), t2 + "(" + e2 + ")";
    }
  }
  function q5(r2, t2) {
    var e2 = Xf(r2);
    return e2 ? (0.299 * e2[0] + 0.587 * e2[1] + 0.114 * e2[2]) * e2[3] / 255 + (1 - e2[3]) * t2 : 0;
  }
  var Y5 = Math.round;
  function rw(r2) {
    var t2;
    if (!r2 || r2 === "transparent")
      r2 = "none";
    else if (typeof r2 == "string" && r2.indexOf("rgba") > -1) {
      var e2 = Xf(r2);
      e2 && (r2 = "rgb(" + e2[0] + "," + e2[1] + "," + e2[2] + ")", t2 = e2[3]);
    }
    return { color: r2, opacity: t2 == null ? 1 : t2 };
  }
  var k8 = 1e-4;
  function oy(r2) {
    return r2 < k8 && r2 > -k8;
  }
  function gM(r2) {
    return Y5(r2 * 1e3) / 1e3;
  }
  function WR(r2) {
    return Y5(r2 * 1e4) / 1e4;
  }
  function nie(r2) {
    return "matrix(" + gM(r2[0]) + "," + gM(r2[1]) + "," + gM(r2[2]) + "," + gM(r2[3]) + "," + WR(r2[4]) + "," + WR(r2[5]) + ")";
  }
  var aie = { left: "start", right: "end", center: "middle", middle: "middle" };
  function iie(r2, t2, e2) {
    return e2 === "top" ? r2 += t2 / 2 : e2 === "bottom" && (r2 -= t2 / 2), r2;
  }
  function oie(r2) {
    return r2 && (r2.shadowBlur || r2.shadowOffsetX || r2.shadowOffsetY);
  }
  function sie(r2) {
    var t2 = r2.style, e2 = r2.getGlobalScale();
    return [t2.shadowColor, (t2.shadowBlur || 0).toFixed(2), (t2.shadowOffsetX || 0).toFixed(2), (t2.shadowOffsetY || 0).toFixed(2), e2[0], e2[1]].join(",");
  }
  function wW(r2) {
    return r2 && !!r2.image;
  }
  function uie(r2) {
    return r2 && !!r2.svgElement;
  }
  function lie(r2) {
    return wW(r2) || uie(r2);
  }
  function SW(r2) {
    return r2.type === "linear";
  }
  function CW(r2) {
    return r2.type === "radial";
  }
  function cie(r2) {
    return r2 && (r2.type === "linear" || r2.type === "radial");
  }
  function UP(r2) {
    return "url(#" + r2 + ")";
  }
  function EW(r2) {
    var t2 = r2.getGlobalScale(), e2 = Math.max(t2[0], t2[1]);
    return Math.max(Math.ceil(Math.log(e2) / Math.log(10)), 1);
  }
  function AW(r2) {
    var t2 = r2.x || 0, e2 = r2.y || 0, n2 = (r2.rotation || 0) * x5, a = ia(r2.scaleX, 1), i = ia(r2.scaleY, 1), o = r2.skewX || 0, s = r2.skewY || 0, u = [];
    return (t2 || e2) && u.push("translate(" + t2 + "px," + e2 + "px)"), n2 && u.push("rotate(" + n2 + ")"), (a !== 1 || i !== 1) && u.push("scale(" + a + "," + i + ")"), (o || s) && u.push("skew(" + Y5(o * x5) + "deg, " + Y5(s * x5) + "deg)"), u.join(" ");
  }
  var fie = function() {
    return Ei.hasGlobalWindow && xn(window.btoa) ? function(r2) {
      return window.btoa(unescape(r2));
    } : typeof Buffer != "undefined" ? function(r2) {
      return Buffer.from(r2).toString("base64");
    } : function(r2) {
      return null;
    };
  }(), UR = Array.prototype.slice;
  function gg(r2, t2, e2) {
    return (t2 - r2) * e2 + r2;
  }
  function oO(r2, t2, e2, n2) {
    for (var a = t2.length, i = 0; i < a; i++)
      r2[i] = gg(t2[i], e2[i], n2);
    return r2;
  }
  function hie(r2, t2, e2, n2) {
    for (var a = t2.length, i = a && t2[0].length, o = 0; o < a; o++) {
      r2[o] || (r2[o] = []);
      for (var s = 0; s < i; s++)
        r2[o][s] = gg(t2[o][s], e2[o][s], n2);
    }
    return r2;
  }
  function yM(r2, t2, e2, n2) {
    for (var a = t2.length, i = 0; i < a; i++)
      r2[i] = t2[i] + e2[i] * n2;
    return r2;
  }
  function R8(r2, t2, e2, n2) {
    for (var a = t2.length, i = a && t2[0].length, o = 0; o < a; o++) {
      r2[o] || (r2[o] = []);
      for (var s = 0; s < i; s++)
        r2[o][s] = t2[o][s] + e2[o][s] * n2;
    }
    return r2;
  }
  function vie(r2, t2) {
    for (var e2 = r2.length, n2 = t2.length, a = e2 > n2 ? t2 : r2, i = Math.min(e2, n2), o = a[i - 1] || { color: [0, 0, 0, 0], offset: 0 }, s = i; s < Math.max(e2, n2); s++)
      a.push({ offset: o.offset, color: o.color.slice() });
  }
  function die(r2, t2, e2) {
    var n2 = r2, a = t2;
    if (!(!n2.push || !a.push)) {
      var i = n2.length, o = a.length;
      if (i !== o) {
        var s = i > o;
        if (s)
          n2.length = o;
        else
          for (var u = i; u < o; u++)
            n2.push(e2 === 1 ? a[u] : UR.call(a[u]));
      }
      for (var l2 = n2[0] && n2[0].length, u = 0; u < n2.length; u++)
        if (e2 === 1)
          isNaN(n2[u]) && (n2[u] = a[u]);
        else
          for (var c2 = 0; c2 < l2; c2++)
            isNaN(n2[u][c2]) && (n2[u][c2] = a[u][c2]);
    }
  }
  function OC(r2) {
    if (lc(r2)) {
      var t2 = r2.length;
      if (lc(r2[0])) {
        for (var e2 = [], n2 = 0; n2 < t2; n2++)
          e2.push(UR.call(r2[n2]));
        return e2;
      }
      return UR.call(r2);
    }
    return r2;
  }
  function E5(r2) {
    return r2[0] = Math.floor(r2[0]) || 0, r2[1] = Math.floor(r2[1]) || 0, r2[2] = Math.floor(r2[2]) || 0, r2[3] = r2[3] == null ? 1 : r2[3], "rgba(" + r2.join(",") + ")";
  }
  function pie(r2) {
    return lc(r2 && r2[0]) ? 2 : 1;
  }
  var mM = 0, A5 = 1, TW = 2, bC = 3, HR = 4, qR = 5, F8 = 6;
  function N8(r2) {
    return r2 === HR || r2 === qR;
  }
  function bM(r2) {
    return r2 === A5 || r2 === TW;
  }
  var $2 = [0, 0, 0, 0], gie = function() {
    function r2(t2) {
      this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = t2;
    }
    return r2.prototype.isFinished = function() {
      return this._finished;
    }, r2.prototype.setFinished = function() {
      this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
    }, r2.prototype.needsAnimate = function() {
      return this.keyframes.length >= 1;
    }, r2.prototype.getAdditiveTrack = function() {
      return this._additiveTrack;
    }, r2.prototype.addKeyframe = function(t2, e2, n2) {
      this._needsSort = true;
      var a = this.keyframes, i = a.length, o = false, s = F8, u = e2;
      if (lc(e2)) {
        var l2 = pie(e2);
        s = l2, (l2 === 1 && !Ai(e2[0]) || l2 === 2 && !Ai(e2[0][0])) && (o = true);
      } else if (Ai(e2) && !XC(e2))
        s = mM;
      else if (Zr(e2))
        if (!isNaN(+e2))
          s = mM;
        else {
          var c2 = Xf(e2);
          c2 && (u = c2, s = bC);
        }
      else if (GP(e2)) {
        var f2 = qt({}, u);
        f2.colorStops = pr(e2.colorStops, function(v9) {
          return { offset: v9.offset, color: Xf(v9.color) };
        }), SW(e2) ? s = HR : CW(e2) && (s = qR), u = f2;
      }
      i === 0 ? this.valType = s : (s !== this.valType || s === F8) && (o = true), this.discrete = this.discrete || o;
      var h = { time: t2, value: u, rawValue: e2, percent: 0 };
      return n2 && (h.easing = n2, h.easingFunc = xn(n2) ? n2 : vW[n2] || z6(n2)), a.push(h), h;
    }, r2.prototype.prepare = function(t2, e2) {
      var n2 = this.keyframes;
      this._needsSort && n2.sort(function(m2, b2) {
        return m2.time - b2.time;
      });
      for (var a = this.valType, i = n2.length, o = n2[i - 1], s = this.discrete, u = bM(a), l2 = N8(a), c2 = 0; c2 < i; c2++) {
        var f2 = n2[c2], h = f2.value, v9 = o.value;
        f2.percent = f2.time / t2, s || (u && c2 !== i - 1 ? die(h, v9, a) : l2 && vie(h.colorStops, v9.colorStops));
      }
      if (!s && a !== qR && e2 && this.needsAnimate() && e2.needsAnimate() && a === e2.valType && !e2._finished) {
        this._additiveTrack = e2;
        for (var d2 = n2[0].value, c2 = 0; c2 < i; c2++)
          a === mM ? n2[c2].additiveValue = n2[c2].value - d2 : a === bC ? n2[c2].additiveValue = yM([], n2[c2].value, d2, -1) : bM(a) && (n2[c2].additiveValue = a === A5 ? yM([], n2[c2].value, d2, -1) : R8([], n2[c2].value, d2, -1));
      }
    }, r2.prototype.step = function(t2, e2) {
      if (!this._finished) {
        this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
        var n2 = this._additiveTrack != null, a = n2 ? "additiveValue" : "value", i = this.valType, o = this.keyframes, s = o.length, u = this.propName, l2 = i === bC, c2, f2 = this._lastFr, h = Math.min, v9, d2;
        if (s === 1)
          v9 = d2 = o[0];
        else {
          if (e2 < 0)
            c2 = 0;
          else if (e2 < this._lastFrP) {
            var m2 = h(f2 + 1, s - 1);
            for (c2 = m2; c2 >= 0 && !(o[c2].percent <= e2); c2--)
              ;
            c2 = h(c2, s - 2);
          } else {
            for (c2 = f2; c2 < s && !(o[c2].percent > e2); c2++)
              ;
            c2 = h(c2 - 1, s - 2);
          }
          d2 = o[c2 + 1], v9 = o[c2];
        }
        if (!!(v9 && d2)) {
          this._lastFr = c2, this._lastFrP = e2;
          var b2 = d2.percent - v9.percent, _ = b2 === 0 ? 1 : h((e2 - v9.percent) / b2, 1);
          d2.easingFunc && (_ = d2.easingFunc(_));
          var C = n2 ? this._additiveValue : l2 ? $2 : t2[u];
          if ((bM(i) || l2) && !C && (C = this._additiveValue = []), this.discrete)
            t2[u] = _ < 1 ? v9.rawValue : d2.rawValue;
          else if (bM(i))
            i === A5 ? oO(C, v9[a], d2[a], _) : hie(C, v9[a], d2[a], _);
          else if (N8(i)) {
            var M = v9[a], E = d2[a], z9 = i === HR;
            t2[u] = { type: z9 ? "linear" : "radial", x: gg(M.x, E.x, _), y: gg(M.y, E.y, _), colorStops: pr(M.colorStops, function($, U) {
              var H = E.colorStops[U];
              return { offset: gg($.offset, H.offset, _), color: E5(oO([], $.color, H.color, _)) };
            }), global: E.global }, z9 ? (t2[u].x2 = gg(M.x2, E.x2, _), t2[u].y2 = gg(M.y2, E.y2, _)) : t2[u].r = gg(M.r, E.r, _);
          } else if (l2)
            oO(C, v9[a], d2[a], _), n2 || (t2[u] = E5(C));
          else {
            var V = gg(v9[a], d2[a], _);
            n2 ? this._additiveValue = V : t2[u] = V;
          }
          n2 && this._addToTarget(t2);
        }
      }
    }, r2.prototype._addToTarget = function(t2) {
      var e2 = this.valType, n2 = this.propName, a = this._additiveValue;
      e2 === mM ? t2[n2] = t2[n2] + a : e2 === bC ? (Xf(t2[n2], $2), yM($2, $2, a, 1), t2[n2] = E5($2)) : e2 === A5 ? yM(t2[n2], t2[n2], a, 1) : e2 === TW && R8(t2[n2], t2[n2], a, 1);
    }, r2;
  }(), $6 = function() {
    function r2(t2, e2, n2, a) {
      if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = t2, this._loop = e2, e2 && a) {
        F6("Can' use additive animation on looped animation.");
        return;
      }
      this._additiveAnimators = a, this._allowDiscrete = n2;
    }
    return r2.prototype.getMaxTime = function() {
      return this._maxTime;
    }, r2.prototype.getDelay = function() {
      return this._delay;
    }, r2.prototype.getLoop = function() {
      return this._loop;
    }, r2.prototype.getTarget = function() {
      return this._target;
    }, r2.prototype.changeTarget = function(t2) {
      this._target = t2;
    }, r2.prototype.when = function(t2, e2, n2) {
      return this.whenWithKeys(t2, e2, ja(e2), n2);
    }, r2.prototype.whenWithKeys = function(t2, e2, n2, a) {
      for (var i = this._tracks, o = 0; o < n2.length; o++) {
        var s = n2[o], u = i[s];
        if (!u) {
          u = i[s] = new gie(s);
          var l2 = void 0, c2 = this._getAdditiveTrack(s);
          if (c2) {
            var f2 = c2.keyframes, h = f2[f2.length - 1];
            l2 = h && h.value, c2.valType === bC && l2 && (l2 = E5(l2));
          } else
            l2 = this._target[s];
          if (l2 == null)
            continue;
          t2 > 0 && u.addKeyframe(0, OC(l2), a), this._trackKeys.push(s);
        }
        u.addKeyframe(t2, OC(e2[s]), a);
      }
      return this._maxTime = Math.max(this._maxTime, t2), this;
    }, r2.prototype.pause = function() {
      this._clip.pause(), this._paused = true;
    }, r2.prototype.resume = function() {
      this._clip.resume(), this._paused = false;
    }, r2.prototype.isPaused = function() {
      return !!this._paused;
    }, r2.prototype.duration = function(t2) {
      return this._maxTime = t2, this._force = true, this;
    }, r2.prototype._doneCallback = function() {
      this._setTracksFinished(), this._clip = null;
      var t2 = this._doneCbs;
      if (t2)
        for (var e2 = t2.length, n2 = 0; n2 < e2; n2++)
          t2[n2].call(this);
    }, r2.prototype._abortedCallback = function() {
      this._setTracksFinished();
      var t2 = this.animation, e2 = this._abortedCbs;
      if (t2 && t2.removeClip(this._clip), this._clip = null, e2)
        for (var n2 = 0; n2 < e2.length; n2++)
          e2[n2].call(this);
    }, r2.prototype._setTracksFinished = function() {
      for (var t2 = this._tracks, e2 = this._trackKeys, n2 = 0; n2 < e2.length; n2++)
        t2[e2[n2]].setFinished();
    }, r2.prototype._getAdditiveTrack = function(t2) {
      var e2, n2 = this._additiveAnimators;
      if (n2)
        for (var a = 0; a < n2.length; a++) {
          var i = n2[a].getTrack(t2);
          i && (e2 = i);
        }
      return e2;
    }, r2.prototype.start = function(t2) {
      if (!(this._started > 0)) {
        this._started = 1;
        for (var e2 = this, n2 = [], a = this._maxTime || 0, i = 0; i < this._trackKeys.length; i++) {
          var o = this._trackKeys[i], s = this._tracks[o], u = this._getAdditiveTrack(o), l2 = s.keyframes, c2 = l2.length;
          if (s.prepare(a, u), s.needsAnimate())
            if (!this._allowDiscrete && s.discrete) {
              var f2 = l2[c2 - 1];
              f2 && (e2._target[s.propName] = f2.rawValue), s.setFinished();
            } else
              n2.push(s);
        }
        if (n2.length || this._force) {
          var h = new Xae({ life: a, loop: this._loop, delay: this._delay || 0, onframe: function(v9) {
            e2._started = 2;
            var d2 = e2._additiveAnimators;
            if (d2) {
              for (var m2 = false, b2 = 0; b2 < d2.length; b2++)
                if (d2[b2]._clip) {
                  m2 = true;
                  break;
                }
              m2 || (e2._additiveAnimators = null);
            }
            for (var b2 = 0; b2 < n2.length; b2++)
              n2[b2].step(e2._target, v9);
            var _ = e2._onframeCbs;
            if (_)
              for (var b2 = 0; b2 < _.length; b2++)
                _[b2](e2._target, v9);
          }, ondestroy: function() {
            e2._doneCallback();
          } });
          this._clip = h, this.animation && this.animation.addClip(h), t2 && h.setEasing(t2);
        } else
          this._doneCallback();
        return this;
      }
    }, r2.prototype.stop = function(t2) {
      if (!!this._clip) {
        var e2 = this._clip;
        t2 && e2.onframe(1), this._abortedCallback();
      }
    }, r2.prototype.delay = function(t2) {
      return this._delay = t2, this;
    }, r2.prototype.during = function(t2) {
      return t2 && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(t2)), this;
    }, r2.prototype.done = function(t2) {
      return t2 && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(t2)), this;
    }, r2.prototype.aborted = function(t2) {
      return t2 && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(t2)), this;
    }, r2.prototype.getClip = function() {
      return this._clip;
    }, r2.prototype.getTrack = function(t2) {
      return this._tracks[t2];
    }, r2.prototype.getTracks = function() {
      var t2 = this;
      return pr(this._trackKeys, function(e2) {
        return t2._tracks[e2];
      });
    }, r2.prototype.stopTracks = function(t2, e2) {
      if (!t2.length || !this._clip)
        return true;
      for (var n2 = this._tracks, a = this._trackKeys, i = 0; i < t2.length; i++) {
        var o = n2[t2[i]];
        o && !o.isFinished() && (e2 ? o.step(this._target, 1) : this._started === 1 && o.step(this._target, 0), o.setFinished());
      }
      for (var s = true, i = 0; i < a.length; i++)
        if (!n2[a[i]].isFinished()) {
          s = false;
          break;
        }
      return s && this._abortedCallback(), s;
    }, r2.prototype.saveTo = function(t2, e2, n2) {
      if (!!t2) {
        e2 = e2 || this._trackKeys;
        for (var a = 0; a < e2.length; a++) {
          var i = e2[a], o = this._tracks[i];
          if (!(!o || o.isFinished())) {
            var s = o.keyframes, u = s[n2 ? 0 : s.length - 1];
            u && (t2[i] = OC(u.rawValue));
          }
        }
      }
    }, r2.prototype.__changeFinalValue = function(t2, e2) {
      e2 = e2 || ja(t2);
      for (var n2 = 0; n2 < e2.length; n2++) {
        var a = e2[n2], i = this._tracks[a];
        if (!!i) {
          var o = i.keyframes;
          if (o.length > 1) {
            var s = o.pop();
            i.addKeyframe(s.time, t2[a]), i.prepare(this._maxTime, i.getAdditiveTrack());
          }
        }
      }
    }, r2;
  }();
  function Bx() {
    return new Date().getTime();
  }
  var yie = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      return n2._running = false, n2._time = 0, n2._pausedTime = 0, n2._pauseStart = 0, n2._paused = false, e2 = e2 || {}, n2.stage = e2.stage || {}, n2;
    }
    return t2.prototype.addClip = function(e2) {
      e2.animation && this.removeClip(e2), this._head ? (this._tail.next = e2, e2.prev = this._tail, e2.next = null, this._tail = e2) : this._head = this._tail = e2, e2.animation = this;
    }, t2.prototype.addAnimator = function(e2) {
      e2.animation = this;
      var n2 = e2.getClip();
      n2 && this.addClip(n2);
    }, t2.prototype.removeClip = function(e2) {
      if (!!e2.animation) {
        var n2 = e2.prev, a = e2.next;
        n2 ? n2.next = a : this._head = a, a ? a.prev = n2 : this._tail = n2, e2.next = e2.prev = e2.animation = null;
      }
    }, t2.prototype.removeAnimator = function(e2) {
      var n2 = e2.getClip();
      n2 && this.removeClip(n2), e2.animation = null;
    }, t2.prototype.update = function(e2) {
      for (var n2 = Bx() - this._pausedTime, a = n2 - this._time, i = this._head; i; ) {
        var o = i.next, s = i.step(n2, a);
        s && (i.ondestroy(), this.removeClip(i)), i = o;
      }
      this._time = n2, e2 || (this.trigger("frame", a), this.stage.update && this.stage.update());
    }, t2.prototype._startLoop = function() {
      var e2 = this;
      this._running = true;
      function n2() {
        e2._running && (jR(n2), !e2._paused && e2.update());
      }
      jR(n2);
    }, t2.prototype.start = function() {
      this._running || (this._time = Bx(), this._pausedTime = 0, this._startLoop());
    }, t2.prototype.stop = function() {
      this._running = false;
    }, t2.prototype.pause = function() {
      this._paused || (this._pauseStart = Bx(), this._paused = true);
    }, t2.prototype.resume = function() {
      this._paused && (this._pausedTime += Bx() - this._pauseStart, this._paused = false);
    }, t2.prototype.clear = function() {
      for (var e2 = this._head; e2; ) {
        var n2 = e2.next;
        e2.prev = e2.next = e2.animation = null, e2 = n2;
      }
      this._head = this._tail = null;
    }, t2.prototype.isFinished = function() {
      return this._head == null;
    }, t2.prototype.animate = function(e2, n2) {
      n2 = n2 || {}, this.start();
      var a = new $6(e2, n2.loop);
      return this.addAnimator(a), a;
    }, t2;
  }(Yh), mie = yie, bie = 300, sO = Ei.domSupported, uO = function() {
    var r2 = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], t2 = ["touchstart", "touchend", "touchmove"], e2 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, n2 = pr(r2, function(a) {
      var i = a.replace("mouse", "pointer");
      return e2.hasOwnProperty(i) ? i : a;
    });
    return { mouse: r2, touch: t2, pointer: n2 };
  }(), V8 = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, j8 = false;
  function YR(r2) {
    var t2 = r2.pointerType;
    return t2 === "pen" || t2 === "touch";
  }
  function _ie(r2) {
    r2.touching = true, r2.touchTimer != null && (clearTimeout(r2.touchTimer), r2.touchTimer = null), r2.touchTimer = setTimeout(function() {
      r2.touching = false, r2.touchTimer = null;
    }, 700);
  }
  function lO(r2) {
    r2 && (r2.zrByTouch = true);
  }
  function xie(r2, t2) {
    return Oh(r2.dom, new wie(r2, t2), true);
  }
  function MW(r2, t2) {
    for (var e2 = t2, n2 = false; e2 && e2.nodeType !== 9 && !(n2 = e2.domBelongToZr || e2 !== t2 && e2 === r2.painterRoot); )
      e2 = e2.parentNode;
    return n2;
  }
  var wie = function() {
    function r2(t2, e2) {
      this.stopPropagation = lu, this.stopImmediatePropagation = lu, this.preventDefault = lu, this.type = e2.type, this.target = this.currentTarget = t2.dom, this.pointerType = e2.pointerType, this.clientX = e2.clientX, this.clientY = e2.clientY;
    }
    return r2;
  }(), Fv = { mousedown: function(r2) {
    r2 = Oh(this.dom, r2), this.__mayPointerCapture = [r2.zrX, r2.zrY], this.trigger("mousedown", r2);
  }, mousemove: function(r2) {
    r2 = Oh(this.dom, r2);
    var t2 = this.__mayPointerCapture;
    t2 && (r2.zrX !== t2[0] || r2.zrY !== t2[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", r2);
  }, mouseup: function(r2) {
    r2 = Oh(this.dom, r2), this.__togglePointerCapture(false), this.trigger("mouseup", r2);
  }, mouseout: function(r2) {
    r2 = Oh(this.dom, r2);
    var t2 = r2.toElement || r2.relatedTarget;
    MW(this, t2) || (this.__pointerCapturing && (r2.zrEventControl = "no_globalout"), this.trigger("mouseout", r2));
  }, wheel: function(r2) {
    j8 = true, r2 = Oh(this.dom, r2), this.trigger("mousewheel", r2);
  }, mousewheel: function(r2) {
    j8 || (r2 = Oh(this.dom, r2), this.trigger("mousewheel", r2));
  }, touchstart: function(r2) {
    r2 = Oh(this.dom, r2), lO(r2), this.__lastTouchMoment = new Date(), this.handler.processGesture(r2, "start"), Fv.mousemove.call(this, r2), Fv.mousedown.call(this, r2);
  }, touchmove: function(r2) {
    r2 = Oh(this.dom, r2), lO(r2), this.handler.processGesture(r2, "change"), Fv.mousemove.call(this, r2);
  }, touchend: function(r2) {
    r2 = Oh(this.dom, r2), lO(r2), this.handler.processGesture(r2, "end"), Fv.mouseup.call(this, r2), +new Date() - +this.__lastTouchMoment < bie && Fv.click.call(this, r2);
  }, pointerdown: function(r2) {
    Fv.mousedown.call(this, r2);
  }, pointermove: function(r2) {
    YR(r2) || Fv.mousemove.call(this, r2);
  }, pointerup: function(r2) {
    Fv.mouseup.call(this, r2);
  }, pointerout: function(r2) {
    YR(r2) || Fv.mouseout.call(this, r2);
  } };
  ae(["click", "dblclick", "contextmenu"], function(r2) {
    Fv[r2] = function(t2) {
      t2 = Oh(this.dom, t2), this.trigger(r2, t2);
    };
  });
  var KR = { pointermove: function(r2) {
    YR(r2) || KR.mousemove.call(this, r2);
  }, pointerup: function(r2) {
    KR.mouseup.call(this, r2);
  }, mousemove: function(r2) {
    this.trigger("mousemove", r2);
  }, mouseup: function(r2) {
    var t2 = this.__pointerCapturing;
    this.__togglePointerCapture(false), this.trigger("mouseup", r2), t2 && (r2.zrEventControl = "only_globalout", this.trigger("mouseout", r2));
  } };
  function Sie(r2, t2) {
    var e2 = t2.domHandlers;
    Ei.pointerEventsSupported ? ae(uO.pointer, function(n2) {
      T5(t2, n2, function(a) {
        e2[n2].call(r2, a);
      });
    }) : (Ei.touchEventsSupported && ae(uO.touch, function(n2) {
      T5(t2, n2, function(a) {
        e2[n2].call(r2, a), _ie(t2);
      });
    }), ae(uO.mouse, function(n2) {
      T5(t2, n2, function(a) {
        a = B6(a), t2.touching || e2[n2].call(r2, a);
      });
    }));
  }
  function Cie(r2, t2) {
    Ei.pointerEventsSupported ? ae(V8.pointer, e2) : Ei.touchEventsSupported || ae(V8.mouse, e2);
    function e2(n2) {
      function a(i) {
        i = B6(i), MW(r2, i.target) || (i = xie(r2, i), t2.domHandlers[n2].call(r2, i));
      }
      T5(t2, n2, a, { capture: true });
    }
  }
  function T5(r2, t2, e2, n2) {
    r2.mounted[t2] = e2, r2.listenerOpts[t2] = n2, VR(r2.domTarget, t2, e2, n2);
  }
  function cO(r2) {
    var t2 = r2.mounted;
    for (var e2 in t2)
      t2.hasOwnProperty(e2) && Lae(r2.domTarget, e2, t2[e2], r2.listenerOpts[e2]);
    r2.mounted = {};
  }
  var B8 = function() {
    function r2(t2, e2) {
      this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = t2, this.domHandlers = e2;
    }
    return r2;
  }(), Eie = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      var a = r2.call(this) || this;
      return a.__pointerCapturing = false, a.dom = e2, a.painterRoot = n2, a._localHandlerScope = new B8(e2, Fv), sO && (a._globalHandlerScope = new B8(document, KR)), Sie(a, a._localHandlerScope), a;
    }
    return t2.prototype.dispose = function() {
      cO(this._localHandlerScope), sO && cO(this._globalHandlerScope);
    }, t2.prototype.setCursor = function(e2) {
      this.dom.style && (this.dom.style.cursor = e2 || "default");
    }, t2.prototype.__togglePointerCapture = function(e2) {
      if (this.__mayPointerCapture = null, sO && +this.__pointerCapturing ^ +e2) {
        this.__pointerCapturing = e2;
        var n2 = this._globalHandlerScope;
        e2 ? Cie(this, n2) : cO(n2);
      }
    }, t2;
  }(Yh), Aie = Eie, PW = 1;
  Ei.hasGlobalWindow && (PW = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
  var K5 = PW, ZR = 0.4, XR = "#333", JR = "#ccc", Tie = "#eee";
  function Hh() {
    return [1, 0, 0, 1, 0, 0];
  }
  function HP(r2) {
    return r2[0] = 1, r2[1] = 0, r2[2] = 0, r2[3] = 1, r2[4] = 0, r2[5] = 0, r2;
  }
  function G6(r2, t2) {
    return r2[0] = t2[0], r2[1] = t2[1], r2[2] = t2[2], r2[3] = t2[3], r2[4] = t2[4], r2[5] = t2[5], r2;
  }
  function Sg(r2, t2, e2) {
    var n2 = t2[0] * e2[0] + t2[2] * e2[1], a = t2[1] * e2[0] + t2[3] * e2[1], i = t2[0] * e2[2] + t2[2] * e2[3], o = t2[1] * e2[2] + t2[3] * e2[3], s = t2[0] * e2[4] + t2[2] * e2[5] + t2[4], u = t2[1] * e2[4] + t2[3] * e2[5] + t2[5];
    return r2[0] = n2, r2[1] = a, r2[2] = i, r2[3] = o, r2[4] = s, r2[5] = u, r2;
  }
  function ep(r2, t2, e2) {
    return r2[0] = t2[0], r2[1] = t2[1], r2[2] = t2[2], r2[3] = t2[3], r2[4] = t2[4] + e2[0], r2[5] = t2[5] + e2[1], r2;
  }
  function s1(r2, t2, e2) {
    var n2 = t2[0], a = t2[2], i = t2[4], o = t2[1], s = t2[3], u = t2[5], l2 = Math.sin(e2), c2 = Math.cos(e2);
    return r2[0] = n2 * c2 + o * l2, r2[1] = -n2 * l2 + o * c2, r2[2] = a * c2 + s * l2, r2[3] = -a * l2 + c2 * s, r2[4] = c2 * i + l2 * u, r2[5] = c2 * u - l2 * i, r2;
  }
  function W6(r2, t2, e2) {
    var n2 = e2[0], a = e2[1];
    return r2[0] = t2[0] * n2, r2[1] = t2[1] * a, r2[2] = t2[2] * n2, r2[3] = t2[3] * a, r2[4] = t2[4] * n2, r2[5] = t2[5] * a, r2;
  }
  function fw(r2, t2) {
    var e2 = t2[0], n2 = t2[2], a = t2[4], i = t2[1], o = t2[3], s = t2[5], u = e2 * o - i * n2;
    return u ? (u = 1 / u, r2[0] = o * u, r2[1] = -i * u, r2[2] = -n2 * u, r2[3] = e2 * u, r2[4] = (n2 * s - o * a) * u, r2[5] = (i * a - e2 * s) * u, r2) : null;
  }
  function Mie(r2) {
    var t2 = Hh();
    return G6(t2, r2), t2;
  }
  var z8 = HP, $8 = 5e-5;
  function eb(r2) {
    return r2 > $8 || r2 < -$8;
  }
  var tb = [], vx = [], fO = Hh(), hO = Math.abs, Pie = function() {
    function r2() {
    }
    return r2.prototype.getLocalTransform = function(t2) {
      return r2.getLocalTransform(this, t2);
    }, r2.prototype.setPosition = function(t2) {
      this.x = t2[0], this.y = t2[1];
    }, r2.prototype.setScale = function(t2) {
      this.scaleX = t2[0], this.scaleY = t2[1];
    }, r2.prototype.setSkew = function(t2) {
      this.skewX = t2[0], this.skewY = t2[1];
    }, r2.prototype.setOrigin = function(t2) {
      this.originX = t2[0], this.originY = t2[1];
    }, r2.prototype.needLocalTransform = function() {
      return eb(this.rotation) || eb(this.x) || eb(this.y) || eb(this.scaleX - 1) || eb(this.scaleY - 1) || eb(this.skewX) || eb(this.skewY);
    }, r2.prototype.updateTransform = function() {
      var t2 = this.parent && this.parent.transform, e2 = this.needLocalTransform(), n2 = this.transform;
      if (!(e2 || t2)) {
        n2 && z8(n2);
        return;
      }
      n2 = n2 || Hh(), e2 ? this.getLocalTransform(n2) : z8(n2), t2 && (e2 ? Sg(n2, t2, n2) : G6(n2, t2)), this.transform = n2, this._resolveGlobalScaleRatio(n2);
    }, r2.prototype._resolveGlobalScaleRatio = function(t2) {
      var e2 = this.globalScaleRatio;
      if (e2 != null && e2 !== 1) {
        this.getGlobalScale(tb);
        var n2 = tb[0] < 0 ? -1 : 1, a = tb[1] < 0 ? -1 : 1, i = ((tb[0] - n2) * e2 + n2) / tb[0] || 0, o = ((tb[1] - a) * e2 + a) / tb[1] || 0;
        t2[0] *= i, t2[1] *= i, t2[2] *= o, t2[3] *= o;
      }
      this.invTransform = this.invTransform || Hh(), fw(this.invTransform, t2);
    }, r2.prototype.getComputedTransform = function() {
      for (var t2 = this, e2 = []; t2; )
        e2.push(t2), t2 = t2.parent;
      for (; t2 = e2.pop(); )
        t2.updateTransform();
      return this.transform;
    }, r2.prototype.setLocalTransform = function(t2) {
      if (!!t2) {
        var e2 = t2[0] * t2[0] + t2[1] * t2[1], n2 = t2[2] * t2[2] + t2[3] * t2[3], a = Math.atan2(t2[1], t2[0]), i = Math.PI / 2 + a - Math.atan2(t2[3], t2[2]);
        n2 = Math.sqrt(n2) * Math.cos(i), e2 = Math.sqrt(e2), this.skewX = i, this.skewY = 0, this.rotation = -a, this.x = +t2[4], this.y = +t2[5], this.scaleX = e2, this.scaleY = n2, this.originX = 0, this.originY = 0;
      }
    }, r2.prototype.decomposeTransform = function() {
      if (!!this.transform) {
        var t2 = this.parent, e2 = this.transform;
        t2 && t2.transform && (Sg(vx, t2.invTransform, e2), e2 = vx);
        var n2 = this.originX, a = this.originY;
        (n2 || a) && (fO[4] = n2, fO[5] = a, Sg(vx, e2, fO), vx[4] -= n2, vx[5] -= a, e2 = vx), this.setLocalTransform(e2);
      }
    }, r2.prototype.getGlobalScale = function(t2) {
      var e2 = this.transform;
      return t2 = t2 || [], e2 ? (t2[0] = Math.sqrt(e2[0] * e2[0] + e2[1] * e2[1]), t2[1] = Math.sqrt(e2[2] * e2[2] + e2[3] * e2[3]), e2[0] < 0 && (t2[0] = -t2[0]), e2[3] < 0 && (t2[1] = -t2[1]), t2) : (t2[0] = 1, t2[1] = 1, t2);
    }, r2.prototype.transformCoordToLocal = function(t2, e2) {
      var n2 = [t2, e2], a = this.invTransform;
      return a && Nl(n2, n2, a), n2;
    }, r2.prototype.transformCoordToGlobal = function(t2, e2) {
      var n2 = [t2, e2], a = this.transform;
      return a && Nl(n2, n2, a), n2;
    }, r2.prototype.getLineScale = function() {
      var t2 = this.transform;
      return t2 && hO(t2[0] - 1) > 1e-10 && hO(t2[3] - 1) > 1e-10 ? Math.sqrt(hO(t2[0] * t2[3] - t2[2] * t2[1])) : 1;
    }, r2.prototype.copyTransform = function(t2) {
      DW(this, t2);
    }, r2.getLocalTransform = function(t2, e2) {
      e2 = e2 || [];
      var n2 = t2.originX || 0, a = t2.originY || 0, i = t2.scaleX, o = t2.scaleY, s = t2.anchorX, u = t2.anchorY, l2 = t2.rotation || 0, c2 = t2.x, f2 = t2.y, h = t2.skewX ? Math.tan(t2.skewX) : 0, v9 = t2.skewY ? Math.tan(-t2.skewY) : 0;
      if (n2 || a || s || u) {
        var d2 = n2 + s, m2 = a + u;
        e2[4] = -d2 * i - h * m2 * o, e2[5] = -m2 * o - v9 * d2 * i;
      } else
        e2[4] = e2[5] = 0;
      return e2[0] = i, e2[3] = o, e2[1] = v9 * i, e2[2] = h * o, l2 && s1(e2, e2, l2), e2[4] += n2 + c2, e2[5] += a + f2, e2;
    }, r2.initDefaultProps = function() {
      var t2 = r2.prototype;
      t2.scaleX = t2.scaleY = t2.globalScaleRatio = 1, t2.x = t2.y = t2.originX = t2.originY = t2.skewX = t2.skewY = t2.rotation = t2.anchorX = t2.anchorY = 0;
    }(), r2;
  }(), tp = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
  function DW(r2, t2) {
    for (var e2 = 0; e2 < tp.length; e2++) {
      var n2 = tp[e2];
      r2[n2] = t2[n2];
    }
  }
  var mg = Pie, Die = function() {
    function r2(t2, e2) {
      this.x = t2 || 0, this.y = e2 || 0;
    }
    return r2.prototype.copy = function(t2) {
      return this.x = t2.x, this.y = t2.y, this;
    }, r2.prototype.clone = function() {
      return new r2(this.x, this.y);
    }, r2.prototype.set = function(t2, e2) {
      return this.x = t2, this.y = e2, this;
    }, r2.prototype.equal = function(t2) {
      return t2.x === this.x && t2.y === this.y;
    }, r2.prototype.add = function(t2) {
      return this.x += t2.x, this.y += t2.y, this;
    }, r2.prototype.scale = function(t2) {
      this.x *= t2, this.y *= t2;
    }, r2.prototype.scaleAndAdd = function(t2, e2) {
      this.x += t2.x * e2, this.y += t2.y * e2;
    }, r2.prototype.sub = function(t2) {
      return this.x -= t2.x, this.y -= t2.y, this;
    }, r2.prototype.dot = function(t2) {
      return this.x * t2.x + this.y * t2.y;
    }, r2.prototype.len = function() {
      return Math.sqrt(this.x * this.x + this.y * this.y);
    }, r2.prototype.lenSquare = function() {
      return this.x * this.x + this.y * this.y;
    }, r2.prototype.normalize = function() {
      var t2 = this.len();
      return this.x /= t2, this.y /= t2, this;
    }, r2.prototype.distance = function(t2) {
      var e2 = this.x - t2.x, n2 = this.y - t2.y;
      return Math.sqrt(e2 * e2 + n2 * n2);
    }, r2.prototype.distanceSquare = function(t2) {
      var e2 = this.x - t2.x, n2 = this.y - t2.y;
      return e2 * e2 + n2 * n2;
    }, r2.prototype.negate = function() {
      return this.x = -this.x, this.y = -this.y, this;
    }, r2.prototype.transform = function(t2) {
      if (!!t2) {
        var e2 = this.x, n2 = this.y;
        return this.x = t2[0] * e2 + t2[2] * n2 + t2[4], this.y = t2[1] * e2 + t2[3] * n2 + t2[5], this;
      }
    }, r2.prototype.toArray = function(t2) {
      return t2[0] = this.x, t2[1] = this.y, t2;
    }, r2.prototype.fromArray = function(t2) {
      this.x = t2[0], this.y = t2[1];
    }, r2.set = function(t2, e2, n2) {
      t2.x = e2, t2.y = n2;
    }, r2.copy = function(t2, e2) {
      t2.x = e2.x, t2.y = e2.y;
    }, r2.len = function(t2) {
      return Math.sqrt(t2.x * t2.x + t2.y * t2.y);
    }, r2.lenSquare = function(t2) {
      return t2.x * t2.x + t2.y * t2.y;
    }, r2.dot = function(t2, e2) {
      return t2.x * e2.x + t2.y * e2.y;
    }, r2.add = function(t2, e2, n2) {
      t2.x = e2.x + n2.x, t2.y = e2.y + n2.y;
    }, r2.sub = function(t2, e2, n2) {
      t2.x = e2.x - n2.x, t2.y = e2.y - n2.y;
    }, r2.scale = function(t2, e2, n2) {
      t2.x = e2.x * n2, t2.y = e2.y * n2;
    }, r2.scaleAndAdd = function(t2, e2, n2, a) {
      t2.x = e2.x + n2.x * a, t2.y = e2.y + n2.y * a;
    }, r2.lerp = function(t2, e2, n2, a) {
      var i = 1 - a;
      t2.x = i * e2.x + a * n2.x, t2.y = i * e2.y + a * n2.y;
    }, r2;
  }(), Jn = Die, _M = Math.min, xM = Math.max, rb2 = new Jn(), nb = new Jn(), ab = new Jn(), ib = new Jn(), G2 = new Jn(), W2 = new Jn(), Iie = function() {
    function r2(t2, e2, n2, a) {
      n2 < 0 && (t2 = t2 + n2, n2 = -n2), a < 0 && (e2 = e2 + a, a = -a), this.x = t2, this.y = e2, this.width = n2, this.height = a;
    }
    return r2.prototype.union = function(t2) {
      var e2 = _M(t2.x, this.x), n2 = _M(t2.y, this.y);
      isFinite(this.x) && isFinite(this.width) ? this.width = xM(t2.x + t2.width, this.x + this.width) - e2 : this.width = t2.width, isFinite(this.y) && isFinite(this.height) ? this.height = xM(t2.y + t2.height, this.y + this.height) - n2 : this.height = t2.height, this.x = e2, this.y = n2;
    }, r2.prototype.applyTransform = function(t2) {
      r2.applyTransform(this, this, t2);
    }, r2.prototype.calculateTransform = function(t2) {
      var e2 = this, n2 = t2.width / e2.width, a = t2.height / e2.height, i = Hh();
      return ep(i, i, [-e2.x, -e2.y]), W6(i, i, [n2, a]), ep(i, i, [t2.x, t2.y]), i;
    }, r2.prototype.intersect = function(t2, e2) {
      if (!t2)
        return false;
      t2 instanceof r2 || (t2 = r2.create(t2));
      var n2 = this, a = n2.x, i = n2.x + n2.width, o = n2.y, s = n2.y + n2.height, u = t2.x, l2 = t2.x + t2.width, c2 = t2.y, f2 = t2.y + t2.height, h = !(i < u || l2 < a || s < c2 || f2 < o);
      if (e2) {
        var v9 = 1 / 0, d2 = 0, m2 = Math.abs(i - u), b2 = Math.abs(l2 - a), _ = Math.abs(s - c2), C = Math.abs(f2 - o), M = Math.min(m2, b2), E = Math.min(_, C);
        i < u || l2 < a ? M > d2 && (d2 = M, m2 < b2 ? Jn.set(W2, -m2, 0) : Jn.set(W2, b2, 0)) : M < v9 && (v9 = M, m2 < b2 ? Jn.set(G2, m2, 0) : Jn.set(G2, -b2, 0)), s < c2 || f2 < o ? E > d2 && (d2 = E, _ < C ? Jn.set(W2, 0, -_) : Jn.set(W2, 0, C)) : M < v9 && (v9 = M, _ < C ? Jn.set(G2, 0, _) : Jn.set(G2, 0, -C));
      }
      return e2 && Jn.copy(e2, h ? G2 : W2), h;
    }, r2.prototype.contain = function(t2, e2) {
      var n2 = this;
      return t2 >= n2.x && t2 <= n2.x + n2.width && e2 >= n2.y && e2 <= n2.y + n2.height;
    }, r2.prototype.clone = function() {
      return new r2(this.x, this.y, this.width, this.height);
    }, r2.prototype.copy = function(t2) {
      r2.copy(this, t2);
    }, r2.prototype.plain = function() {
      return { x: this.x, y: this.y, width: this.width, height: this.height };
    }, r2.prototype.isFinite = function() {
      return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
    }, r2.prototype.isZero = function() {
      return this.width === 0 || this.height === 0;
    }, r2.create = function(t2) {
      return new r2(t2.x, t2.y, t2.width, t2.height);
    }, r2.copy = function(t2, e2) {
      t2.x = e2.x, t2.y = e2.y, t2.width = e2.width, t2.height = e2.height;
    }, r2.applyTransform = function(t2, e2, n2) {
      if (!n2) {
        t2 !== e2 && r2.copy(t2, e2);
        return;
      }
      if (n2[1] < 1e-5 && n2[1] > -1e-5 && n2[2] < 1e-5 && n2[2] > -1e-5) {
        var a = n2[0], i = n2[3], o = n2[4], s = n2[5];
        t2.x = e2.x * a + o, t2.y = e2.y * i + s, t2.width = e2.width * a, t2.height = e2.height * i, t2.width < 0 && (t2.x += t2.width, t2.width = -t2.width), t2.height < 0 && (t2.y += t2.height, t2.height = -t2.height);
        return;
      }
      rb2.x = ab.x = e2.x, rb2.y = ib.y = e2.y, nb.x = ib.x = e2.x + e2.width, nb.y = ab.y = e2.y + e2.height, rb2.transform(n2), ib.transform(n2), nb.transform(n2), ab.transform(n2), t2.x = _M(rb2.x, nb.x, ab.x, ib.x), t2.y = _M(rb2.y, nb.y, ab.y, ib.y);
      var u = xM(rb2.x, nb.x, ab.x, ib.x), l2 = xM(rb2.y, nb.y, ab.y, ib.y);
      t2.width = u - t2.x, t2.height = l2 - t2.y;
    }, r2;
  }(), da = Iie, G8 = {};
  function Jf(r2, t2) {
    t2 = t2 || gy;
    var e2 = G8[t2];
    e2 || (e2 = G8[t2] = new ME(500));
    var n2 = e2.get(r2);
    return n2 == null && (n2 = Tg.measureText(r2, t2).width, e2.put(r2, n2)), n2;
  }
  function W8(r2, t2, e2, n2) {
    var a = Jf(r2, t2), i = qP(t2), o = _C(0, a, e2), s = Rx(0, i, n2), u = new da(o, s, a, i);
    return u;
  }
  function PE(r2, t2, e2, n2) {
    var a = ((r2 || "") + "").split(`
`), i = a.length;
    if (i === 1)
      return W8(a[0], t2, e2, n2);
    for (var o = new da(0, 0, 0, 0), s = 0; s < a.length; s++) {
      var u = W8(a[s], t2, e2, n2);
      s === 0 ? o.copy(u) : o.union(u);
    }
    return o;
  }
  function _C(r2, t2, e2) {
    return e2 === "right" ? r2 -= t2 : e2 === "center" && (r2 -= t2 / 2), r2;
  }
  function Rx(r2, t2, e2) {
    return e2 === "middle" ? r2 -= t2 / 2 : e2 === "bottom" && (r2 -= t2), r2;
  }
  function qP(r2) {
    return Jf("\u56FD", r2);
  }
  function Gv(r2, t2) {
    return typeof r2 == "string" ? r2.lastIndexOf("%") >= 0 ? parseFloat(r2) / 100 * t2 : parseFloat(r2) : r2;
  }
  function Z5(r2, t2, e2) {
    var n2 = t2.position || "inside", a = t2.distance != null ? t2.distance : 5, i = e2.height, o = e2.width, s = i / 2, u = e2.x, l2 = e2.y, c2 = "left", f2 = "top";
    if (n2 instanceof Array)
      u += Gv(n2[0], e2.width), l2 += Gv(n2[1], e2.height), c2 = null, f2 = null;
    else
      switch (n2) {
        case "left":
          u -= a, l2 += s, c2 = "right", f2 = "middle";
          break;
        case "right":
          u += a + o, l2 += s, f2 = "middle";
          break;
        case "top":
          u += o / 2, l2 -= a, c2 = "center", f2 = "bottom";
          break;
        case "bottom":
          u += o / 2, l2 += i + a, c2 = "center";
          break;
        case "inside":
          u += o / 2, l2 += s, c2 = "center", f2 = "middle";
          break;
        case "insideLeft":
          u += a, l2 += s, f2 = "middle";
          break;
        case "insideRight":
          u += o - a, l2 += s, c2 = "right", f2 = "middle";
          break;
        case "insideTop":
          u += o / 2, l2 += a, c2 = "center";
          break;
        case "insideBottom":
          u += o / 2, l2 += i - a, c2 = "center", f2 = "bottom";
          break;
        case "insideTopLeft":
          u += a, l2 += a;
          break;
        case "insideTopRight":
          u += o - a, l2 += a, c2 = "right";
          break;
        case "insideBottomLeft":
          u += a, l2 += i - a, f2 = "bottom";
          break;
        case "insideBottomRight":
          u += o - a, l2 += i - a, c2 = "right", f2 = "bottom";
          break;
      }
    return r2 = r2 || {}, r2.x = u, r2.y = l2, r2.align = c2, r2.verticalAlign = f2, r2;
  }
  var vO = "__zr_normal__", dO = tp.concat(["ignore"]), Lie = Qd(tp, function(r2, t2) {
    return r2[t2] = true, r2;
  }, { ignore: false }), dx = {}, Oie = new da(0, 0, 0, 0), U6 = function() {
    function r2(t2) {
      this.id = aW(), this.animators = [], this.currentStates = [], this.states = {}, this._init(t2);
    }
    return r2.prototype._init = function(t2) {
      this.attr(t2);
    }, r2.prototype.drift = function(t2, e2, n2) {
      switch (this.draggable) {
        case "horizontal":
          e2 = 0;
          break;
        case "vertical":
          t2 = 0;
          break;
      }
      var a = this.transform;
      a || (a = this.transform = [1, 0, 0, 1, 0, 0]), a[4] += t2, a[5] += e2, this.decomposeTransform(), this.markRedraw();
    }, r2.prototype.beforeUpdate = function() {
    }, r2.prototype.afterUpdate = function() {
    }, r2.prototype.update = function() {
      this.updateTransform(), this.__dirty && this.updateInnerText();
    }, r2.prototype.updateInnerText = function(t2) {
      var e2 = this._textContent;
      if (e2 && (!e2.ignore || t2)) {
        this.textConfig || (this.textConfig = {});
        var n2 = this.textConfig, a = n2.local, i = e2.innerTransformable, o = void 0, s = void 0, u = false;
        i.parent = a ? this : null;
        var l2 = false;
        if (i.copyTransform(e2), n2.position != null) {
          var c2 = Oie;
          n2.layoutRect ? c2.copy(n2.layoutRect) : c2.copy(this.getBoundingRect()), a || c2.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(dx, n2, c2) : Z5(dx, n2, c2), i.x = dx.x, i.y = dx.y, o = dx.align, s = dx.verticalAlign;
          var f2 = n2.origin;
          if (f2 && n2.rotation != null) {
            var h = void 0, v9 = void 0;
            f2 === "center" ? (h = c2.width * 0.5, v9 = c2.height * 0.5) : (h = Gv(f2[0], c2.width), v9 = Gv(f2[1], c2.height)), l2 = true, i.originX = -i.x + h + (a ? 0 : c2.x), i.originY = -i.y + v9 + (a ? 0 : c2.y);
          }
        }
        n2.rotation != null && (i.rotation = n2.rotation);
        var d2 = n2.offset;
        d2 && (i.x += d2[0], i.y += d2[1], l2 || (i.originX = -d2[0], i.originY = -d2[1]));
        var m2 = n2.inside == null ? typeof n2.position == "string" && n2.position.indexOf("inside") >= 0 : n2.inside, b2 = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), _ = void 0, C = void 0, M = void 0;
        m2 && this.canBeInsideText() ? (_ = n2.insideFill, C = n2.insideStroke, (_ == null || _ === "auto") && (_ = this.getInsideTextFill()), (C == null || C === "auto") && (C = this.getInsideTextStroke(_), M = true)) : (_ = n2.outsideFill, C = n2.outsideStroke, (_ == null || _ === "auto") && (_ = this.getOutsideFill()), (C == null || C === "auto") && (C = this.getOutsideStroke(_), M = true)), _ = _ || "#000", (_ !== b2.fill || C !== b2.stroke || M !== b2.autoStroke || o !== b2.align || s !== b2.verticalAlign) && (u = true, b2.fill = _, b2.stroke = C, b2.autoStroke = M, b2.align = o, b2.verticalAlign = s, e2.setDefaultTextStyle(b2)), e2.__dirty |= Kf, u && e2.dirtyStyle(true);
      }
    }, r2.prototype.canBeInsideText = function() {
      return true;
    }, r2.prototype.getInsideTextFill = function() {
      return "#fff";
    }, r2.prototype.getInsideTextStroke = function(t2) {
      return "#000";
    }, r2.prototype.getOutsideFill = function() {
      return this.__zr && this.__zr.isDarkMode() ? JR : XR;
    }, r2.prototype.getOutsideStroke = function(t2) {
      var e2 = this.__zr && this.__zr.getBackgroundColor(), n2 = typeof e2 == "string" && Xf(e2);
      n2 || (n2 = [255, 255, 255, 1]);
      for (var a = n2[3], i = this.__zr.isDarkMode(), o = 0; o < 3; o++)
        n2[o] = n2[o] * a + (i ? 0 : 255) * (1 - a);
      return n2[3] = 1, wg(n2, "rgba");
    }, r2.prototype.traverse = function(t2, e2) {
    }, r2.prototype.attrKV = function(t2, e2) {
      t2 === "textConfig" ? this.setTextConfig(e2) : t2 === "textContent" ? this.setTextContent(e2) : t2 === "clipPath" ? this.setClipPath(e2) : t2 === "extra" ? (this.extra = this.extra || {}, qt(this.extra, e2)) : this[t2] = e2;
    }, r2.prototype.hide = function() {
      this.ignore = true, this.markRedraw();
    }, r2.prototype.show = function() {
      this.ignore = false, this.markRedraw();
    }, r2.prototype.attr = function(t2, e2) {
      if (typeof t2 == "string")
        this.attrKV(t2, e2);
      else if (Tn(t2))
        for (var n2 = t2, a = ja(n2), i = 0; i < a.length; i++) {
          var o = a[i];
          this.attrKV(o, t2[o]);
        }
      return this.markRedraw(), this;
    }, r2.prototype.saveCurrentToNormalState = function(t2) {
      this._innerSaveToNormal(t2);
      for (var e2 = this._normalState, n2 = 0; n2 < this.animators.length; n2++) {
        var a = this.animators[n2], i = a.__fromStateTransition;
        if (!(a.getLoop() || i && i !== vO)) {
          var o = a.targetName, s = o ? e2[o] : e2;
          a.saveTo(s);
        }
      }
    }, r2.prototype._innerSaveToNormal = function(t2) {
      var e2 = this._normalState;
      e2 || (e2 = this._normalState = {}), t2.textConfig && !e2.textConfig && (e2.textConfig = this.textConfig), this._savePrimaryToNormal(t2, e2, dO);
    }, r2.prototype._savePrimaryToNormal = function(t2, e2, n2) {
      for (var a = 0; a < n2.length; a++) {
        var i = n2[a];
        t2[i] != null && !(i in e2) && (e2[i] = this[i]);
      }
    }, r2.prototype.hasState = function() {
      return this.currentStates.length > 0;
    }, r2.prototype.getState = function(t2) {
      return this.states[t2];
    }, r2.prototype.ensureState = function(t2) {
      var e2 = this.states;
      return e2[t2] || (e2[t2] = {}), e2[t2];
    }, r2.prototype.clearStates = function(t2) {
      this.useState(vO, false, t2);
    }, r2.prototype.useState = function(t2, e2, n2, a) {
      var i = t2 === vO, o = this.hasState();
      if (!(!o && i)) {
        var s = this.currentStates, u = this.stateTransition;
        if (!(va(s, t2) >= 0 && (e2 || s.length === 1))) {
          var l2;
          if (this.stateProxy && !i && (l2 = this.stateProxy(t2)), l2 || (l2 = this.states && this.states[t2]), !l2 && !i) {
            F6("State " + t2 + " not exists.");
            return;
          }
          i || this.saveCurrentToNormalState(l2);
          var c2 = !!(l2 && l2.hoverLayer || a);
          c2 && this._toggleHoverLayerFlag(true), this._applyStateObj(t2, l2, this._normalState, e2, !n2 && !this.__inHover && u && u.duration > 0, u);
          var f2 = this._textContent, h = this._textGuide;
          return f2 && f2.useState(t2, e2, n2, c2), h && h.useState(t2, e2, n2, c2), i ? (this.currentStates = [], this._normalState = {}) : e2 ? this.currentStates.push(t2) : this.currentStates = [t2], this._updateAnimationTargets(), this.markRedraw(), !c2 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Kf), l2;
        }
      }
    }, r2.prototype.useStates = function(t2, e2, n2) {
      if (!t2.length)
        this.clearStates();
      else {
        var a = [], i = this.currentStates, o = t2.length, s = o === i.length;
        if (s) {
          for (var u = 0; u < o; u++)
            if (t2[u] !== i[u]) {
              s = false;
              break;
            }
        }
        if (s)
          return;
        for (var u = 0; u < o; u++) {
          var l2 = t2[u], c2 = void 0;
          this.stateProxy && (c2 = this.stateProxy(l2, t2)), c2 || (c2 = this.states[l2]), c2 && a.push(c2);
        }
        var f2 = a[o - 1], h = !!(f2 && f2.hoverLayer || n2);
        h && this._toggleHoverLayerFlag(true);
        var v9 = this._mergeStates(a), d2 = this.stateTransition;
        this.saveCurrentToNormalState(v9), this._applyStateObj(t2.join(","), v9, this._normalState, false, !e2 && !this.__inHover && d2 && d2.duration > 0, d2);
        var m2 = this._textContent, b2 = this._textGuide;
        m2 && m2.useStates(t2, e2, h), b2 && b2.useStates(t2, e2, h), this._updateAnimationTargets(), this.currentStates = t2.slice(), this.markRedraw(), !h && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Kf);
      }
    }, r2.prototype._updateAnimationTargets = function() {
      for (var t2 = 0; t2 < this.animators.length; t2++) {
        var e2 = this.animators[t2];
        e2.targetName && e2.changeTarget(this[e2.targetName]);
      }
    }, r2.prototype.removeState = function(t2) {
      var e2 = va(this.currentStates, t2);
      if (e2 >= 0) {
        var n2 = this.currentStates.slice();
        n2.splice(e2, 1), this.useStates(n2);
      }
    }, r2.prototype.replaceState = function(t2, e2, n2) {
      var a = this.currentStates.slice(), i = va(a, t2), o = va(a, e2) >= 0;
      i >= 0 ? o ? a.splice(i, 1) : a[i] = e2 : n2 && !o && a.push(e2), this.useStates(a);
    }, r2.prototype.toggleState = function(t2, e2) {
      e2 ? this.useState(t2, true) : this.removeState(t2);
    }, r2.prototype._mergeStates = function(t2) {
      for (var e2 = {}, n2, a = 0; a < t2.length; a++) {
        var i = t2[a];
        qt(e2, i), i.textConfig && (n2 = n2 || {}, qt(n2, i.textConfig));
      }
      return n2 && (e2.textConfig = n2), e2;
    }, r2.prototype._applyStateObj = function(t2, e2, n2, a, i, o) {
      var s = !(e2 && a);
      e2 && e2.textConfig ? (this.textConfig = qt({}, a ? this.textConfig : n2.textConfig), qt(this.textConfig, e2.textConfig)) : s && n2.textConfig && (this.textConfig = n2.textConfig);
      for (var u = {}, l2 = false, c2 = 0; c2 < dO.length; c2++) {
        var f2 = dO[c2], h = i && Lie[f2];
        e2 && e2[f2] != null ? h ? (l2 = true, u[f2] = e2[f2]) : this[f2] = e2[f2] : s && n2[f2] != null && (h ? (l2 = true, u[f2] = n2[f2]) : this[f2] = n2[f2]);
      }
      if (!i)
        for (var c2 = 0; c2 < this.animators.length; c2++) {
          var v9 = this.animators[c2], d2 = v9.targetName;
          v9.getLoop() || v9.__changeFinalValue(d2 ? (e2 || n2)[d2] : e2 || n2);
        }
      l2 && this._transitionState(t2, u, o);
    }, r2.prototype._attachComponent = function(t2) {
      if (!(t2.__zr && !t2.__hostTarget) && t2 !== this) {
        var e2 = this.__zr;
        e2 && t2.addSelfToZr(e2), t2.__zr = e2, t2.__hostTarget = this;
      }
    }, r2.prototype._detachComponent = function(t2) {
      t2.__zr && t2.removeSelfFromZr(t2.__zr), t2.__zr = null, t2.__hostTarget = null;
    }, r2.prototype.getClipPath = function() {
      return this._clipPath;
    }, r2.prototype.setClipPath = function(t2) {
      this._clipPath && this._clipPath !== t2 && this.removeClipPath(), this._attachComponent(t2), this._clipPath = t2, this.markRedraw();
    }, r2.prototype.removeClipPath = function() {
      var t2 = this._clipPath;
      t2 && (this._detachComponent(t2), this._clipPath = null, this.markRedraw());
    }, r2.prototype.getTextContent = function() {
      return this._textContent;
    }, r2.prototype.setTextContent = function(t2) {
      var e2 = this._textContent;
      e2 !== t2 && (e2 && e2 !== t2 && this.removeTextContent(), t2.innerTransformable = new mg(), this._attachComponent(t2), this._textContent = t2, this.markRedraw());
    }, r2.prototype.setTextConfig = function(t2) {
      this.textConfig || (this.textConfig = {}), qt(this.textConfig, t2), this.markRedraw();
    }, r2.prototype.removeTextConfig = function() {
      this.textConfig = null, this.markRedraw();
    }, r2.prototype.removeTextContent = function() {
      var t2 = this._textContent;
      t2 && (t2.innerTransformable = null, this._detachComponent(t2), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
    }, r2.prototype.getTextGuideLine = function() {
      return this._textGuide;
    }, r2.prototype.setTextGuideLine = function(t2) {
      this._textGuide && this._textGuide !== t2 && this.removeTextGuideLine(), this._attachComponent(t2), this._textGuide = t2, this.markRedraw();
    }, r2.prototype.removeTextGuideLine = function() {
      var t2 = this._textGuide;
      t2 && (this._detachComponent(t2), this._textGuide = null, this.markRedraw());
    }, r2.prototype.markRedraw = function() {
      this.__dirty |= Kf;
      var t2 = this.__zr;
      t2 && (this.__inHover ? t2.refreshHover() : t2.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
    }, r2.prototype.dirty = function() {
      this.markRedraw();
    }, r2.prototype._toggleHoverLayerFlag = function(t2) {
      this.__inHover = t2;
      var e2 = this._textContent, n2 = this._textGuide;
      e2 && (e2.__inHover = t2), n2 && (n2.__inHover = t2);
    }, r2.prototype.addSelfToZr = function(t2) {
      if (this.__zr !== t2) {
        this.__zr = t2;
        var e2 = this.animators;
        if (e2)
          for (var n2 = 0; n2 < e2.length; n2++)
            t2.animation.addAnimator(e2[n2]);
        this._clipPath && this._clipPath.addSelfToZr(t2), this._textContent && this._textContent.addSelfToZr(t2), this._textGuide && this._textGuide.addSelfToZr(t2);
      }
    }, r2.prototype.removeSelfFromZr = function(t2) {
      if (!!this.__zr) {
        this.__zr = null;
        var e2 = this.animators;
        if (e2)
          for (var n2 = 0; n2 < e2.length; n2++)
            t2.animation.removeAnimator(e2[n2]);
        this._clipPath && this._clipPath.removeSelfFromZr(t2), this._textContent && this._textContent.removeSelfFromZr(t2), this._textGuide && this._textGuide.removeSelfFromZr(t2);
      }
    }, r2.prototype.animate = function(t2, e2, n2) {
      var a = t2 ? this[t2] : this, i = new $6(a, e2, n2);
      return t2 && (i.targetName = t2), this.addAnimator(i, t2), i;
    }, r2.prototype.addAnimator = function(t2, e2) {
      var n2 = this.__zr, a = this;
      t2.during(function() {
        a.updateDuringAnimation(e2);
      }).done(function() {
        var i = a.animators, o = va(i, t2);
        o >= 0 && i.splice(o, 1);
      }), this.animators.push(t2), n2 && n2.animation.addAnimator(t2), n2 && n2.wakeUp();
    }, r2.prototype.updateDuringAnimation = function(t2) {
      this.markRedraw();
    }, r2.prototype.stopAnimation = function(t2, e2) {
      for (var n2 = this.animators, a = n2.length, i = [], o = 0; o < a; o++) {
        var s = n2[o];
        !t2 || t2 === s.scope ? s.stop(e2) : i.push(s);
      }
      return this.animators = i, this;
    }, r2.prototype.animateTo = function(t2, e2, n2) {
      pO(this, t2, e2, n2);
    }, r2.prototype.animateFrom = function(t2, e2, n2) {
      pO(this, t2, e2, n2, true);
    }, r2.prototype._transitionState = function(t2, e2, n2, a) {
      for (var i = pO(this, e2, n2, a), o = 0; o < i.length; o++)
        i[o].__fromStateTransition = t2;
    }, r2.prototype.getBoundingRect = function() {
      return null;
    }, r2.prototype.getPaintRect = function() {
      return null;
    }, r2.initDefaultProps = function() {
      var t2 = r2.prototype;
      t2.type = "element", t2.name = "", t2.ignore = t2.silent = t2.isGroup = t2.draggable = t2.dragging = t2.ignoreClip = t2.__inHover = false, t2.__dirty = Kf;
      function e2(n2, a, i, o) {
        Object.defineProperty(t2, n2, { get: function() {
          if (!this[a]) {
            var u = this[a] = [];
            s(this, u);
          }
          return this[a];
        }, set: function(u) {
          this[i] = u[0], this[o] = u[1], this[a] = u, s(this, u);
        } });
        function s(u, l2) {
          Object.defineProperty(l2, 0, { get: function() {
            return u[i];
          }, set: function(c2) {
            u[i] = c2;
          } }), Object.defineProperty(l2, 1, { get: function() {
            return u[o];
          }, set: function(c2) {
            u[o] = c2;
          } });
        }
      }
      Object.defineProperty && (e2("position", "_legacyPos", "x", "y"), e2("scale", "_legacyScale", "scaleX", "scaleY"), e2("origin", "_legacyOrigin", "originX", "originY"));
    }(), r2;
  }();
  fu(U6, Yh);
  fu(U6, mg);
  function pO(r2, t2, e2, n2, a) {
    e2 = e2 || {};
    var i = [];
    IW(r2, "", r2, t2, e2, n2, i, a);
    var o = i.length, s = false, u = e2.done, l2 = e2.aborted, c2 = function() {
      s = true, o--, o <= 0 && (s ? u && u() : l2 && l2());
    }, f2 = function() {
      o--, o <= 0 && (s ? u && u() : l2 && l2());
    };
    o || u && u(), i.length > 0 && e2.during && i[0].during(function(d2, m2) {
      e2.during(m2);
    });
    for (var h = 0; h < i.length; h++) {
      var v9 = i[h];
      c2 && v9.done(c2), f2 && v9.aborted(f2), e2.force && v9.duration(e2.duration), v9.start(e2.easing);
    }
    return i;
  }
  function gO(r2, t2, e2) {
    for (var n2 = 0; n2 < e2; n2++)
      r2[n2] = t2[n2];
  }
  function kie(r2) {
    return lc(r2[0]);
  }
  function Rie(r2, t2, e2) {
    if (lc(t2[e2]))
      if (lc(r2[e2]) || (r2[e2] = []), Qf(t2[e2])) {
        var n2 = t2[e2].length;
        r2[e2].length !== n2 && (r2[e2] = new t2[e2].constructor(n2), gO(r2[e2], t2[e2], n2));
      } else {
        var a = t2[e2], i = r2[e2], o = a.length;
        if (kie(a))
          for (var s = a[0].length, u = 0; u < o; u++)
            i[u] ? gO(i[u], a[u], s) : i[u] = Array.prototype.slice.call(a[u]);
        else
          gO(i, a, o);
        i.length = a.length;
      }
    else
      r2[e2] = t2[e2];
  }
  function Fie(r2, t2) {
    return r2 === t2 || lc(r2) && lc(t2) && Nie(r2, t2);
  }
  function Nie(r2, t2) {
    var e2 = r2.length;
    if (e2 !== t2.length)
      return false;
    for (var n2 = 0; n2 < e2; n2++)
      if (r2[n2] !== t2[n2])
        return false;
    return true;
  }
  function IW(r2, t2, e2, n2, a, i, o, s) {
    for (var u = ja(n2), l2 = a.duration, c2 = a.delay, f2 = a.additive, h = a.setToFinal, v9 = !Tn(i), d2 = r2.animators, m2 = [], b2 = 0; b2 < u.length; b2++) {
      var _ = u[b2], C = n2[_];
      if (C != null && e2[_] != null && (v9 || i[_]))
        if (Tn(C) && !lc(C) && !GP(C)) {
          if (t2) {
            s || (e2[_] = C, r2.updateDuringAnimation(t2));
            continue;
          }
          IW(r2, _, e2[_], C, a, i && i[_], o, s);
        } else
          m2.push(_);
      else
        s || (e2[_] = C, r2.updateDuringAnimation(t2), m2.push(_));
    }
    var M = m2.length;
    if (!f2 && M)
      for (var E = 0; E < d2.length; E++) {
        var z9 = d2[E];
        if (z9.targetName === t2) {
          var V = z9.stopTracks(m2);
          if (V) {
            var $ = va(d2, z9);
            d2.splice($, 1);
          }
        }
      }
    if (a.force || (m2 = no(m2, function(ee) {
      return !Fie(n2[ee], e2[ee]);
    }), M = m2.length), M > 0 || a.force && !o.length) {
      var U = void 0, H = void 0, q3 = void 0;
      if (s) {
        H = {}, h && (U = {});
        for (var E = 0; E < M; E++) {
          var _ = m2[E];
          H[_] = e2[_], h ? U[_] = n2[_] : e2[_] = n2[_];
        }
      } else if (h) {
        q3 = {};
        for (var E = 0; E < M; E++) {
          var _ = m2[E];
          q3[_] = OC(e2[_]), Rie(e2, n2, _);
        }
      }
      var z9 = new $6(e2, false, false, f2 ? no(d2, function(oe) {
        return oe.targetName === t2;
      }) : null);
      z9.targetName = t2, a.scope && (z9.scope = a.scope), h && U && z9.whenWithKeys(0, U, m2), q3 && z9.whenWithKeys(0, q3, m2), z9.whenWithKeys(l2 == null ? 500 : l2, s ? H : n2, m2).delay(c2 || 0), r2.addAnimator(z9, t2), o.push(z9);
    }
  }
  var LW = U6, OW = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      return n2.isGroup = true, n2._children = [], n2.attr(e2), n2;
    }
    return t2.prototype.childrenRef = function() {
      return this._children;
    }, t2.prototype.children = function() {
      return this._children.slice();
    }, t2.prototype.childAt = function(e2) {
      return this._children[e2];
    }, t2.prototype.childOfName = function(e2) {
      for (var n2 = this._children, a = 0; a < n2.length; a++)
        if (n2[a].name === e2)
          return n2[a];
    }, t2.prototype.childCount = function() {
      return this._children.length;
    }, t2.prototype.add = function(e2) {
      return e2 && e2 !== this && e2.parent !== this && (this._children.push(e2), this._doAdd(e2)), this;
    }, t2.prototype.addBefore = function(e2, n2) {
      if (e2 && e2 !== this && e2.parent !== this && n2 && n2.parent === this) {
        var a = this._children, i = a.indexOf(n2);
        i >= 0 && (a.splice(i, 0, e2), this._doAdd(e2));
      }
      return this;
    }, t2.prototype.replace = function(e2, n2) {
      var a = va(this._children, e2);
      return a >= 0 && this.replaceAt(n2, a), this;
    }, t2.prototype.replaceAt = function(e2, n2) {
      var a = this._children, i = a[n2];
      if (e2 && e2 !== this && e2.parent !== this && e2 !== i) {
        a[n2] = e2, i.parent = null;
        var o = this.__zr;
        o && i.removeSelfFromZr(o), this._doAdd(e2);
      }
      return this;
    }, t2.prototype._doAdd = function(e2) {
      e2.parent && e2.parent.remove(e2), e2.parent = this;
      var n2 = this.__zr;
      n2 && n2 !== e2.__zr && e2.addSelfToZr(n2), n2 && n2.refresh();
    }, t2.prototype.remove = function(e2) {
      var n2 = this.__zr, a = this._children, i = va(a, e2);
      return i < 0 ? this : (a.splice(i, 1), e2.parent = null, n2 && e2.removeSelfFromZr(n2), n2 && n2.refresh(), this);
    }, t2.prototype.removeAll = function() {
      for (var e2 = this._children, n2 = this.__zr, a = 0; a < e2.length; a++) {
        var i = e2[a];
        n2 && i.removeSelfFromZr(n2), i.parent = null;
      }
      return e2.length = 0, this;
    }, t2.prototype.eachChild = function(e2, n2) {
      for (var a = this._children, i = 0; i < a.length; i++) {
        var o = a[i];
        e2.call(n2, o, i);
      }
      return this;
    }, t2.prototype.traverse = function(e2, n2) {
      for (var a = 0; a < this._children.length; a++) {
        var i = this._children[a], o = e2.call(n2, i);
        i.isGroup && !o && i.traverse(e2, n2);
      }
      return this;
    }, t2.prototype.addSelfToZr = function(e2) {
      r2.prototype.addSelfToZr.call(this, e2);
      for (var n2 = 0; n2 < this._children.length; n2++) {
        var a = this._children[n2];
        a.addSelfToZr(e2);
      }
    }, t2.prototype.removeSelfFromZr = function(e2) {
      r2.prototype.removeSelfFromZr.call(this, e2);
      for (var n2 = 0; n2 < this._children.length; n2++) {
        var a = this._children[n2];
        a.removeSelfFromZr(e2);
      }
    }, t2.prototype.getBoundingRect = function(e2) {
      for (var n2 = new da(0, 0, 0, 0), a = e2 || this._children, i = [], o = null, s = 0; s < a.length; s++) {
        var u = a[s];
        if (!(u.ignore || u.invisible)) {
          var l2 = u.getBoundingRect(), c2 = u.getLocalTransform(i);
          c2 ? (da.applyTransform(n2, l2, c2), o = o || n2.clone(), o.union(n2)) : (o = o || l2.clone(), o.union(l2));
        }
      }
      return o || n2;
    }, t2;
  }(LW);
  OW.prototype.type = "group";
  var Fn = OW;
  /*!
  * ZRender, a high performance 2d drawing library.
  *
  * Copyright (c) 2013, Baidu Inc.
  * All rights reserved.
  *
  * LICENSE
  * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
  */
  var M5 = {}, kW = {};
  function Vie(r2) {
    delete kW[r2];
  }
  function jie(r2) {
    if (!r2)
      return false;
    if (typeof r2 == "string")
      return q5(r2, 1) < ZR;
    if (r2.colorStops) {
      for (var t2 = r2.colorStops, e2 = 0, n2 = t2.length, a = 0; a < n2; a++)
        e2 += q5(t2[a].color, 1);
      return e2 /= n2, e2 < ZR;
    }
    return false;
  }
  var Bie = function() {
    function r2(t2, e2, n2) {
      var a = this;
      this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, n2 = n2 || {}, this.dom = e2, this.id = t2;
      var i = new Uae(), o = n2.renderer || "canvas";
      M5[o] || (o = ja(M5)[0]), n2.useDirtyRect = n2.useDirtyRect == null ? false : n2.useDirtyRect;
      var s = new M5[o](e2, i, n2, t2), u = n2.ssr || s.ssrOnly;
      this.storage = i, this.painter = s;
      var l2 = !Ei.node && !Ei.worker && !u ? new Aie(s.getViewportRoot(), s.root) : null;
      this.handler = new Bae(i, s, l2, s.root), this.animation = new mie({ stage: { update: u ? null : function() {
        return a._flush(true);
      } } }), u || this.animation.start();
    }
    return r2.prototype.add = function(t2) {
      !t2 || (this.storage.addRoot(t2), t2.addSelfToZr(this), this.refresh());
    }, r2.prototype.remove = function(t2) {
      !t2 || (this.storage.delRoot(t2), t2.removeSelfFromZr(this), this.refresh());
    }, r2.prototype.configLayer = function(t2, e2) {
      this.painter.configLayer && this.painter.configLayer(t2, e2), this.refresh();
    }, r2.prototype.setBackgroundColor = function(t2) {
      this.painter.setBackgroundColor && this.painter.setBackgroundColor(t2), this.refresh(), this._backgroundColor = t2, this._darkMode = jie(t2);
    }, r2.prototype.getBackgroundColor = function() {
      return this._backgroundColor;
    }, r2.prototype.setDarkMode = function(t2) {
      this._darkMode = t2;
    }, r2.prototype.isDarkMode = function() {
      return this._darkMode;
    }, r2.prototype.refreshImmediately = function(t2) {
      t2 || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
    }, r2.prototype.refresh = function() {
      this._needsRefresh = true, this.animation.start();
    }, r2.prototype.flush = function() {
      this._flush(false);
    }, r2.prototype._flush = function(t2) {
      var e2, n2 = Bx();
      this._needsRefresh && (e2 = true, this.refreshImmediately(t2)), this._needsRefreshHover && (e2 = true, this.refreshHoverImmediately());
      var a = Bx();
      e2 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: a - n2 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
    }, r2.prototype.setSleepAfterStill = function(t2) {
      this._sleepAfterStill = t2;
    }, r2.prototype.wakeUp = function() {
      this.animation.start(), this._stillFrameAccum = 0;
    }, r2.prototype.refreshHover = function() {
      this._needsRefreshHover = true;
    }, r2.prototype.refreshHoverImmediately = function() {
      this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
    }, r2.prototype.resize = function(t2) {
      t2 = t2 || {}, this.painter.resize(t2.width, t2.height), this.handler.resize();
    }, r2.prototype.clearAnimation = function() {
      this.animation.clear();
    }, r2.prototype.getWidth = function() {
      return this.painter.getWidth();
    }, r2.prototype.getHeight = function() {
      return this.painter.getHeight();
    }, r2.prototype.setCursorStyle = function(t2) {
      this.handler.setCursorStyle(t2);
    }, r2.prototype.findHover = function(t2, e2) {
      return this.handler.findHover(t2, e2);
    }, r2.prototype.on = function(t2, e2, n2) {
      return this.handler.on(t2, e2, n2), this;
    }, r2.prototype.off = function(t2, e2) {
      this.handler.off(t2, e2);
    }, r2.prototype.trigger = function(t2, e2) {
      this.handler.trigger(t2, e2);
    }, r2.prototype.clear = function() {
      for (var t2 = this.storage.getRoots(), e2 = 0; e2 < t2.length; e2++)
        t2[e2] instanceof Fn && t2[e2].removeSelfFromZr(this);
      this.storage.delAllRoots(), this.painter.clear();
    }, r2.prototype.dispose = function() {
      this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, Vie(this.id);
    }, r2;
  }();
  function U8(r2, t2) {
    var e2 = new Bie(aW(), r2, t2);
    return kW[e2.id] = e2, e2;
  }
  function zie(r2, t2) {
    M5[r2] = t2;
  }
  var H8 = 1e-4, RW = 20;
  function $ie(r2) {
    return r2.replace(/^\s+|\s+$/g, "");
  }
  function Gi(r2, t2, e2, n2) {
    var a = t2[0], i = t2[1], o = e2[0], s = e2[1], u = i - a, l2 = s - o;
    if (u === 0)
      return l2 === 0 ? o : (o + s) / 2;
    if (n2)
      if (u > 0) {
        if (r2 <= a)
          return o;
        if (r2 >= i)
          return s;
      } else {
        if (r2 >= a)
          return o;
        if (r2 <= i)
          return s;
      }
    else {
      if (r2 === a)
        return o;
      if (r2 === i)
        return s;
    }
    return (r2 - a) / u * l2 + o;
  }
  function qr(r2, t2) {
    switch (r2) {
      case "center":
      case "middle":
        r2 = "50%";
        break;
      case "left":
      case "top":
        r2 = "0%";
        break;
      case "right":
      case "bottom":
        r2 = "100%";
        break;
    }
    return Zr(r2) ? $ie(r2).match(/%$/) ? parseFloat(r2) / 100 * t2 : parseFloat(r2) : r2 == null ? NaN : +r2;
  }
  function Os(r2, t2, e2) {
    return t2 == null && (t2 = 10), t2 = Math.min(Math.max(0, t2), RW), r2 = (+r2).toFixed(t2), e2 ? r2 : +r2;
  }
  function $h(r2) {
    return r2.sort(function(t2, e2) {
      return t2 - e2;
    }), r2;
  }
  function Ud(r2) {
    if (r2 = +r2, isNaN(r2))
      return 0;
    if (r2 > 1e-14) {
      for (var t2 = 1, e2 = 0; e2 < 15; e2++, t2 *= 10)
        if (Math.round(r2 * t2) / t2 === r2)
          return e2;
    }
    return Gie(r2);
  }
  function Gie(r2) {
    var t2 = r2.toString().toLowerCase(), e2 = t2.indexOf("e"), n2 = e2 > 0 ? +t2.slice(e2 + 1) : 0, a = e2 > 0 ? e2 : t2.length, i = t2.indexOf("."), o = i < 0 ? 0 : a - 1 - i;
    return Math.max(0, o - n2);
  }
  function FW(r2, t2) {
    var e2 = Math.log, n2 = Math.LN10, a = Math.floor(e2(r2[1] - r2[0]) / n2), i = Math.round(e2(Math.abs(t2[1] - t2[0])) / n2), o = Math.min(Math.max(-a + i, 0), 20);
    return isFinite(o) ? o : 20;
  }
  function Wie(r2, t2, e2) {
    if (!r2[t2])
      return 0;
    var n2 = Qd(r2, function(d2, m2) {
      return d2 + (isNaN(m2) ? 0 : m2);
    }, 0);
    if (n2 === 0)
      return 0;
    for (var a = Math.pow(10, e2), i = pr(r2, function(d2) {
      return (isNaN(d2) ? 0 : d2) / n2 * a * 100;
    }), o = a * 100, s = pr(i, function(d2) {
      return Math.floor(d2);
    }), u = Qd(s, function(d2, m2) {
      return d2 + m2;
    }, 0), l2 = pr(i, function(d2, m2) {
      return d2 - s[m2];
    }); u < o; ) {
      for (var c2 = Number.NEGATIVE_INFINITY, f2 = null, h = 0, v9 = l2.length; h < v9; ++h)
        l2[h] > c2 && (c2 = l2[h], f2 = h);
      ++s[f2], l2[f2] = 0, ++u;
    }
    return s[t2] / a;
  }
  function Uie(r2, t2) {
    var e2 = Math.max(Ud(r2), Ud(t2)), n2 = r2 + t2;
    return e2 > RW ? n2 : Os(n2, e2);
  }
  var q8 = 9007199254740991;
  function NW(r2) {
    var t2 = Math.PI * 2;
    return (r2 % t2 + t2) % t2;
  }
  function X5(r2) {
    return r2 > -H8 && r2 < H8;
  }
  var Hie = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
  function rp(r2) {
    if (r2 instanceof Date)
      return r2;
    if (Zr(r2)) {
      var t2 = Hie.exec(r2);
      if (!t2)
        return new Date(NaN);
      if (t2[8]) {
        var e2 = +t2[4] || 0;
        return t2[8].toUpperCase() !== "Z" && (e2 -= +t2[8].slice(0, 3)), new Date(Date.UTC(+t2[1], +(t2[2] || 1) - 1, +t2[3] || 1, e2, +(t2[5] || 0), +t2[6] || 0, t2[7] ? +t2[7].substring(0, 3) : 0));
      } else
        return new Date(+t2[1], +(t2[2] || 1) - 1, +t2[3] || 1, +t2[4] || 0, +(t2[5] || 0), +t2[6] || 0, t2[7] ? +t2[7].substring(0, 3) : 0);
    } else if (r2 == null)
      return new Date(NaN);
    return new Date(Math.round(r2));
  }
  function qie(r2) {
    return Math.pow(10, H6(r2));
  }
  function H6(r2) {
    if (r2 === 0)
      return 0;
    var t2 = Math.floor(Math.log(r2) / Math.LN10);
    return r2 / Math.pow(10, t2) >= 10 && t2++, t2;
  }
  function VW(r2, t2) {
    var e2 = H6(r2), n2 = Math.pow(10, e2), a = r2 / n2, i;
    return t2 ? a < 1.5 ? i = 1 : a < 2.5 ? i = 2 : a < 4 ? i = 3 : a < 7 ? i = 5 : i = 10 : a < 1 ? i = 1 : a < 2 ? i = 2 : a < 3 ? i = 3 : a < 5 ? i = 5 : i = 10, r2 = i * n2, e2 >= -20 ? +r2.toFixed(e2 < 0 ? -e2 : 0) : r2;
  }
  function yO(r2, t2) {
    var e2 = (r2.length - 1) * t2 + 1, n2 = Math.floor(e2), a = +r2[n2 - 1], i = e2 - n2;
    return i ? a + i * (r2[n2] - a) : a;
  }
  function Y8(r2) {
    r2.sort(function(u, l2) {
      return s(u, l2, 0) ? -1 : 1;
    });
    for (var t2 = -1 / 0, e2 = 1, n2 = 0; n2 < r2.length; ) {
      for (var a = r2[n2].interval, i = r2[n2].close, o = 0; o < 2; o++)
        a[o] <= t2 && (a[o] = t2, i[o] = o ? 1 : 1 - e2), t2 = a[o], e2 = i[o];
      a[0] === a[1] && i[0] * i[1] !== 1 ? r2.splice(n2, 1) : n2++;
    }
    return r2;
    function s(u, l2, c2) {
      return u.interval[c2] < l2.interval[c2] || u.interval[c2] === l2.interval[c2] && (u.close[c2] - l2.close[c2] === (c2 ? -1 : 1) || !c2 && s(u, l2, 1));
    }
  }
  function Pg(r2) {
    var t2 = parseFloat(r2);
    return t2 == r2 && (t2 !== 0 || !Zr(r2) || r2.indexOf("x") <= 0) ? t2 : NaN;
  }
  function jW(r2) {
    return !isNaN(Pg(r2));
  }
  function BW() {
    return Math.round(Math.random() * 9);
  }
  function zW(r2, t2) {
    return t2 === 0 ? r2 : zW(t2, r2 % t2);
  }
  function K8(r2, t2) {
    return r2 == null ? t2 : t2 == null ? r2 : r2 * t2 / zW(r2, t2);
  }
  function Ii(r2) {
    throw new Error(r2);
  }
  function Z8(r2, t2, e2) {
    return (t2 - r2) * e2 + r2;
  }
  var $W = "series\0", GW = "\0_ec_\0";
  function ao(r2) {
    return r2 instanceof Array ? r2 : r2 == null ? [] : [r2];
  }
  function Qb(r2, t2, e2) {
    if (r2) {
      r2[t2] = r2[t2] || {}, r2.emphasis = r2.emphasis || {}, r2.emphasis[t2] = r2.emphasis[t2] || {};
      for (var n2 = 0, a = e2.length; n2 < a; n2++) {
        var i = e2[n2];
        !r2.emphasis[t2].hasOwnProperty(i) && r2[t2].hasOwnProperty(i) && (r2.emphasis[t2][i] = r2[t2][i]);
      }
    }
  }
  var X8 = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
  function hw(r2) {
    return Tn(r2) && !vr(r2) && !(r2 instanceof Date) ? r2.value : r2;
  }
  function Yie(r2) {
    return Tn(r2) && !(r2 instanceof Array);
  }
  function WW(r2, t2, e2) {
    var n2 = e2 === "normalMerge", a = e2 === "replaceMerge", i = e2 === "replaceAll";
    r2 = r2 || [], t2 = (t2 || []).slice();
    var o = mn();
    ae(t2, function(u, l2) {
      if (!Tn(u)) {
        t2[l2] = null;
        return;
      }
    });
    var s = Kie(r2, o, e2);
    return (n2 || a) && Zie(s, r2, o, t2), n2 && Xie(s, t2), n2 || a ? Jie(s, t2, a) : i && Qie(s, t2), eoe(s), s;
  }
  function Kie(r2, t2, e2) {
    var n2 = [];
    if (e2 === "replaceAll")
      return n2;
    for (var a = 0; a < r2.length; a++) {
      var i = r2[a];
      i && i.id != null && t2.set(i.id, a), n2.push({ existing: e2 === "replaceMerge" || eE(i) ? null : i, newOption: null, keyInfo: null, brandNew: null });
    }
    return n2;
  }
  function Zie(r2, t2, e2, n2) {
    ae(n2, function(a, i) {
      if (!(!a || a.id == null)) {
        var o = kC(a.id), s = e2.get(o);
        if (s != null) {
          var u = r2[s];
          Fc(!u.newOption, 'Duplicated option on id "' + o + '".'), u.newOption = a, u.existing = t2[s], n2[i] = null;
        }
      }
    });
  }
  function Xie(r2, t2) {
    ae(t2, function(e2, n2) {
      if (!(!e2 || e2.name == null))
        for (var a = 0; a < r2.length; a++) {
          var i = r2[a].existing;
          if (!r2[a].newOption && i && (i.id == null || e2.id == null) && !eE(e2) && !eE(i) && UW("name", i, e2)) {
            r2[a].newOption = e2, t2[n2] = null;
            return;
          }
        }
    });
  }
  function Jie(r2, t2, e2) {
    ae(t2, function(n2) {
      if (!!n2) {
        for (var a, i = 0; (a = r2[i]) && (a.newOption || eE(a.existing) || a.existing && n2.id != null && !UW("id", n2, a.existing)); )
          i++;
        a ? (a.newOption = n2, a.brandNew = e2) : r2.push({ newOption: n2, brandNew: e2, existing: null, keyInfo: null }), i++;
      }
    });
  }
  function Qie(r2, t2) {
    ae(t2, function(e2) {
      r2.push({ newOption: e2, brandNew: true, existing: null, keyInfo: null });
    });
  }
  function eoe(r2) {
    var t2 = mn();
    ae(r2, function(e2) {
      var n2 = e2.existing;
      n2 && t2.set(n2.id, e2);
    }), ae(r2, function(e2) {
      var n2 = e2.newOption;
      Fc(!n2 || n2.id == null || !t2.get(n2.id) || t2.get(n2.id) === e2, "id duplicates: " + (n2 && n2.id)), n2 && n2.id != null && t2.set(n2.id, e2), !e2.keyInfo && (e2.keyInfo = {});
    }), ae(r2, function(e2, n2) {
      var a = e2.existing, i = e2.newOption, o = e2.keyInfo;
      if (!!Tn(i)) {
        if (o.name = i.name != null ? kC(i.name) : a ? a.name : $W + n2, a)
          o.id = kC(a.id);
        else if (i.id != null)
          o.id = kC(i.id);
        else {
          var s = 0;
          do
            o.id = "\0" + o.name + "\0" + s++;
          while (t2.get(o.id));
        }
        t2.set(o.id, e2);
      }
    });
  }
  function UW(r2, t2, e2) {
    var n2 = Cu(t2[r2], null), a = Cu(e2[r2], null);
    return n2 != null && a != null && n2 === a;
  }
  function kC(r2) {
    return Cu(r2, "");
  }
  function Cu(r2, t2) {
    return r2 == null ? t2 : Zr(r2) ? r2 : Ai(r2) || DR(r2) ? r2 + "" : t2;
  }
  function q6(r2) {
    var t2 = r2.name;
    return !!(t2 && t2.indexOf($W));
  }
  function eE(r2) {
    return r2 && r2.id != null && kC(r2.id).indexOf(GW) === 0;
  }
  function toe(r2) {
    return GW + r2;
  }
  function roe(r2, t2, e2) {
    ae(r2, function(n2) {
      var a = n2.newOption;
      Tn(a) && (n2.keyInfo.mainType = t2, n2.keyInfo.subType = noe(t2, a, n2.existing, e2));
    });
  }
  function noe(r2, t2, e2, n2) {
    var a = t2.type ? t2.type : e2 ? e2.subType : n2.determineSubType(r2, t2);
    return a;
  }
  function aoe(r2, t2) {
    var e2 = {}, n2 = {};
    return a(r2 || [], e2), a(t2 || [], n2, e2), [i(e2), i(n2)];
    function a(o, s, u) {
      for (var l2 = 0, c2 = o.length; l2 < c2; l2++) {
        var f2 = Cu(o[l2].seriesId, null);
        if (f2 == null)
          return;
        for (var h = ao(o[l2].dataIndex), v9 = u && u[f2], d2 = 0, m2 = h.length; d2 < m2; d2++) {
          var b2 = h[d2];
          v9 && v9[b2] ? v9[b2] = null : (s[f2] || (s[f2] = {}))[b2] = 1;
        }
      }
    }
    function i(o, s) {
      var u = [];
      for (var l2 in o)
        if (o.hasOwnProperty(l2) && o[l2] != null)
          if (s)
            u.push(+l2);
          else {
            var c2 = i(o[l2], true);
            c2.length && u.push({ seriesId: l2, dataIndex: c2 });
          }
      return u;
    }
  }
  function e1(r2, t2) {
    if (t2.dataIndexInside != null)
      return t2.dataIndexInside;
    if (t2.dataIndex != null)
      return vr(t2.dataIndex) ? pr(t2.dataIndex, function(e2) {
        return r2.indexOfRawIndex(e2);
      }) : r2.indexOfRawIndex(t2.dataIndex);
    if (t2.name != null)
      return vr(t2.name) ? pr(t2.name, function(e2) {
        return r2.indexOfName(e2);
      }) : r2.indexOfName(t2.name);
  }
  function fi() {
    var r2 = "__ec_inner_" + ioe++;
    return function(t2) {
      return t2[r2] || (t2[r2] = {});
    };
  }
  var ioe = BW();
  function RC(r2, t2, e2) {
    var n2 = Y6(t2, e2), a = n2.mainTypeSpecified, i = n2.queryOptionMap, o = n2.others, s = o, u = e2 ? e2.defaultMainType : null;
    return !a && u && i.set(u, {}), i.each(function(l2, c2) {
      var f2 = DE(r2, c2, l2, { useDefault: u === c2, enableAll: e2 && e2.enableAll != null ? e2.enableAll : true, enableNone: e2 && e2.enableNone != null ? e2.enableNone : true });
      s[c2 + "Models"] = f2.models, s[c2 + "Model"] = f2.models[0];
    }), s;
  }
  function Y6(r2, t2) {
    var e2;
    if (Zr(r2)) {
      var n2 = {};
      n2[r2 + "Index"] = 0, e2 = n2;
    } else
      e2 = r2;
    var a = mn(), i = {}, o = false;
    return ae(e2, function(s, u) {
      if (u === "dataIndex" || u === "dataIndexInside") {
        i[u] = s;
        return;
      }
      var l2 = u.match(/^(\w+)(Index|Id|Name)$/) || [], c2 = l2[1], f2 = (l2[2] || "").toLowerCase();
      if (!(!c2 || !f2 || t2 && t2.includeMainTypes && va(t2.includeMainTypes, c2) < 0)) {
        o = o || !!c2;
        var h = a.get(c2) || a.set(c2, {});
        h[f2] = s;
      }
    }), { mainTypeSpecified: o, queryOptionMap: a, others: i };
  }
  var uu = { useDefault: true, enableAll: false, enableNone: false }, ooe = { useDefault: false, enableAll: true, enableNone: true };
  function DE(r2, t2, e2, n2) {
    n2 = n2 || uu;
    var a = e2.index, i = e2.id, o = e2.name, s = { models: null, specified: a != null || i != null || o != null };
    if (!s.specified) {
      var u = void 0;
      return s.models = n2.useDefault && (u = r2.getComponent(t2)) ? [u] : [], s;
    }
    return a === "none" || a === false ? (Fc(n2.enableNone, '`"none"` or `false` is not a valid value on index option.'), s.models = [], s) : (a === "all" && (Fc(n2.enableAll, '`"all"` is not a valid value on index option.'), a = i = o = null), s.models = r2.queryComponents({ mainType: t2, index: a, id: i, name: o }), s);
  }
  function HW(r2, t2, e2) {
    r2.setAttribute ? r2.setAttribute(t2, e2) : r2[t2] = e2;
  }
  function soe(r2, t2) {
    return r2.getAttribute ? r2.getAttribute(t2) : r2[t2];
  }
  function uoe(r2) {
    return r2 === "auto" ? Ei.domSupported ? "html" : "richText" : r2 || "html";
  }
  function QR(r2, t2) {
    var e2 = mn(), n2 = [];
    return ae(r2, function(a) {
      var i = t2(a);
      (e2.get(i) || (n2.push(i), e2.set(i, []))).push(a);
    }), { keys: n2, buckets: e2 };
  }
  function qW(r2, t2, e2, n2, a) {
    var i = t2 == null || t2 === "auto";
    if (n2 == null)
      return n2;
    if (Ai(n2)) {
      var o = Z8(e2 || 0, n2, a);
      return Os(o, i ? Math.max(Ud(e2 || 0), Ud(n2)) : t2);
    } else {
      if (Zr(n2))
        return a < 1 ? e2 : n2;
      for (var s = [], u = e2, l2 = n2, c2 = Math.max(u ? u.length : 0, l2.length), f2 = 0; f2 < c2; ++f2) {
        var h = r2.getDimensionInfo(f2);
        if (h && h.type === "ordinal")
          s[f2] = (a < 1 && u ? u : l2)[f2];
        else {
          var v9 = u && u[f2] ? u[f2] : 0, d2 = l2[f2], o = Z8(v9, d2, a);
          s[f2] = Os(o, i ? Math.max(Ud(v9), Ud(d2)) : t2);
        }
      }
      return s;
    }
  }
  var loe = ".", ob = "___EC__COMPONENT__CONTAINER___", YW = "___EC__EXTENDED_CLASS___";
  function Hd(r2) {
    var t2 = { main: "", sub: "" };
    if (r2) {
      var e2 = r2.split(loe);
      t2.main = e2[0] || "", t2.sub = e2[1] || "";
    }
    return t2;
  }
  function coe(r2) {
    Fc(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(r2), 'componentType "' + r2 + '" illegal');
  }
  function foe(r2) {
    return !!(r2 && r2[YW]);
  }
  function K6(r2, t2) {
    r2.$constructor = r2, r2.extend = function(e2) {
      var n2 = this, a;
      return hoe(n2) ? a = function(i) {
        ot(o, i);
        function o() {
          return i.apply(this, arguments) || this;
        }
        return o;
      }(n2) : (a = function() {
        (e2.$constructor || n2).apply(this, arguments);
      }, vae(a, this)), qt(a.prototype, e2), a[YW] = true, a.extend = this.extend, a.superCall = poe, a.superApply = goe, a.superClass = n2, a;
    };
  }
  function hoe(r2) {
    return xn(r2) && /^class\s/.test(Function.prototype.toString.call(r2));
  }
  function KW(r2, t2) {
    r2.extend = t2.extend;
  }
  var voe = Math.round(Math.random() * 10);
  function doe(r2) {
    var t2 = ["__\0is_clz", voe++].join("_");
    r2.prototype[t2] = true, r2.isInstance = function(e2) {
      return !!(e2 && e2[t2]);
    };
  }
  function poe(r2, t2) {
    for (var e2 = [], n2 = 2; n2 < arguments.length; n2++)
      e2[n2 - 2] = arguments[n2];
    return this.superClass.prototype[t2].apply(r2, e2);
  }
  function goe(r2, t2, e2) {
    return this.superClass.prototype[t2].apply(r2, e2);
  }
  function YP(r2) {
    var t2 = {};
    r2.registerClass = function(n2) {
      var a = n2.type || n2.prototype.type;
      if (a) {
        coe(a), n2.prototype.type = a;
        var i = Hd(a);
        if (!i.sub)
          t2[i.main] = n2;
        else if (i.sub !== ob) {
          var o = e2(i);
          o[i.sub] = n2;
        }
      }
      return n2;
    }, r2.getClass = function(n2, a, i) {
      var o = t2[n2];
      if (o && o[ob] && (o = a ? o[a] : null), i && !o)
        throw new Error(a ? "Component " + n2 + "." + (a || "") + " is used but not imported." : n2 + ".type should be specified.");
      return o;
    }, r2.getClassesByMainType = function(n2) {
      var a = Hd(n2), i = [], o = t2[a.main];
      return o && o[ob] ? ae(o, function(s, u) {
        u !== ob && i.push(s);
      }) : i.push(o), i;
    }, r2.hasClass = function(n2) {
      var a = Hd(n2);
      return !!t2[a.main];
    }, r2.getAllClassMainTypes = function() {
      var n2 = [];
      return ae(t2, function(a, i) {
        n2.push(i);
      }), n2;
    }, r2.hasSubTypes = function(n2) {
      var a = Hd(n2), i = t2[a.main];
      return i && i[ob];
    };
    function e2(n2) {
      var a = t2[n2.main];
      return (!a || !a[ob]) && (a = t2[n2.main] = {}, a[ob] = true), a;
    }
  }
  function t1(r2, t2) {
    for (var e2 = 0; e2 < r2.length; e2++)
      r2[e2][1] || (r2[e2][1] = r2[e2][0]);
    return t2 = t2 || false, function(n2, a, i) {
      for (var o = {}, s = 0; s < r2.length; s++) {
        var u = r2[s][1];
        if (!(a && va(a, u) >= 0 || i && va(i, u) < 0)) {
          var l2 = n2.getShallow(u, t2);
          l2 != null && (o[r2[s][0]] = l2);
        }
      }
      return o;
    };
  }
  var yoe = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], moe = t1(yoe), boe = function() {
    function r2() {
    }
    return r2.prototype.getAreaStyle = function(t2, e2) {
      return moe(this, t2, e2);
    }, r2;
  }(), e4 = new ME(50);
  function _oe(r2) {
    if (typeof r2 == "string") {
      var t2 = e4.get(r2);
      return t2 && t2.image;
    } else
      return r2;
  }
  function Z6(r2, t2, e2, n2, a) {
    if (r2)
      if (typeof r2 == "string") {
        if (t2 && t2.__zrImageSrc === r2 || !e2)
          return t2;
        var i = e4.get(r2), o = { hostEl: e2, cb: n2, cbPayload: a };
        if (i)
          t2 = i.image, !KP(t2) && i.pending.push(o);
        else {
          var s = Tg.loadImage(r2, J8, J8);
          s.__zrImageSrc = r2, e4.put(r2, s.__cachedImgObj = { image: s, pending: [o] });
        }
        return t2;
      } else
        return r2;
    else
      return t2;
  }
  function J8() {
    var r2 = this.__cachedImgObj;
    this.onload = this.onerror = this.__cachedImgObj = null;
    for (var t2 = 0; t2 < r2.pending.length; t2++) {
      var e2 = r2.pending[t2], n2 = e2.cb;
      n2 && n2(this, e2.cbPayload), e2.hostEl.dirty();
    }
    r2.pending.length = 0;
  }
  function KP(r2) {
    return r2 && r2.width && r2.height;
  }
  var mO = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
  function xoe(r2, t2, e2, n2, a) {
    if (!t2)
      return "";
    var i = (r2 + "").split(`
`);
    a = ZW(t2, e2, n2, a);
    for (var o = 0, s = i.length; o < s; o++)
      i[o] = XW(i[o], a);
    return i.join(`
`);
  }
  function ZW(r2, t2, e2, n2) {
    n2 = n2 || {};
    var a = qt({}, n2);
    a.font = t2, e2 = ia(e2, "..."), a.maxIterations = ia(n2.maxIterations, 2);
    var i = a.minChar = ia(n2.minChar, 0);
    a.cnCharWidth = Jf("\u56FD", t2);
    var o = a.ascCharWidth = Jf("a", t2);
    a.placeholder = ia(n2.placeholder, "");
    for (var s = r2 = Math.max(0, r2 - 1), u = 0; u < i && s >= o; u++)
      s -= o;
    var l2 = Jf(e2, t2);
    return l2 > s && (e2 = "", l2 = 0), s = r2 - l2, a.ellipsis = e2, a.ellipsisWidth = l2, a.contentWidth = s, a.containerWidth = r2, a;
  }
  function XW(r2, t2) {
    var e2 = t2.containerWidth, n2 = t2.font, a = t2.contentWidth;
    if (!e2)
      return "";
    var i = Jf(r2, n2);
    if (i <= e2)
      return r2;
    for (var o = 0; ; o++) {
      if (i <= a || o >= t2.maxIterations) {
        r2 += t2.ellipsis;
        break;
      }
      var s = o === 0 ? woe(r2, a, t2.ascCharWidth, t2.cnCharWidth) : i > 0 ? Math.floor(r2.length * a / i) : 0;
      r2 = r2.substr(0, s), i = Jf(r2, n2);
    }
    return r2 === "" && (r2 = t2.placeholder), r2;
  }
  function woe(r2, t2, e2, n2) {
    for (var a = 0, i = 0, o = r2.length; i < o && a < t2; i++) {
      var s = r2.charCodeAt(i);
      a += 0 <= s && s <= 127 ? e2 : n2;
    }
    return i;
  }
  function Soe(r2, t2) {
    r2 != null && (r2 += "");
    var e2 = t2.overflow, n2 = t2.padding, a = t2.font, i = e2 === "truncate", o = qP(a), s = ia(t2.lineHeight, o), u = !!t2.backgroundColor, l2 = t2.lineOverflow === "truncate", c2 = t2.width, f2;
    c2 != null && (e2 === "break" || e2 === "breakAll") ? f2 = r2 ? JW(r2, t2.font, c2, e2 === "breakAll", 0).lines : [] : f2 = r2 ? r2.split(`
`) : [];
    var h = f2.length * s, v9 = ia(t2.height, h);
    if (h > v9 && l2) {
      var d2 = Math.floor(v9 / s);
      f2 = f2.slice(0, d2);
    }
    if (r2 && i && c2 != null)
      for (var m2 = ZW(c2, a, t2.ellipsis, { minChar: t2.truncateMinChar, placeholder: t2.placeholder }), b2 = 0; b2 < f2.length; b2++)
        f2[b2] = XW(f2[b2], m2);
    for (var _ = v9, C = 0, b2 = 0; b2 < f2.length; b2++)
      C = Math.max(Jf(f2[b2], a), C);
    c2 == null && (c2 = C);
    var M = C;
    return n2 && (_ += n2[0] + n2[2], M += n2[1] + n2[3], c2 += n2[1] + n2[3]), u && (M = c2), { lines: f2, height: v9, outerWidth: M, outerHeight: _, lineHeight: s, calculatedLineHeight: o, contentWidth: C, contentHeight: h, width: c2 };
  }
  var Coe = function() {
    function r2() {
    }
    return r2;
  }(), Q8 = function() {
    function r2(t2) {
      this.tokens = [], t2 && (this.tokens = t2);
    }
    return r2;
  }(), Eoe = function() {
    function r2() {
      this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
    }
    return r2;
  }();
  function Aoe(r2, t2) {
    var e2 = new Eoe();
    if (r2 != null && (r2 += ""), !r2)
      return e2;
    for (var n2 = t2.width, a = t2.height, i = t2.overflow, o = (i === "break" || i === "breakAll") && n2 != null ? { width: n2, accumWidth: 0, breakAll: i === "breakAll" } : null, s = mO.lastIndex = 0, u; (u = mO.exec(r2)) != null; ) {
      var l2 = u.index;
      l2 > s && bO(e2, r2.substring(s, l2), t2, o), bO(e2, u[2], t2, o, u[1]), s = mO.lastIndex;
    }
    s < r2.length && bO(e2, r2.substring(s, r2.length), t2, o);
    var c2 = [], f2 = 0, h = 0, v9 = t2.padding, d2 = i === "truncate", m2 = t2.lineOverflow === "truncate";
    function b2(Le, Fe, qe) {
      Le.width = Fe, Le.lineHeight = qe, f2 += qe, h = Math.max(h, Fe);
    }
    e:
      for (var _ = 0; _ < e2.lines.length; _++) {
        for (var C = e2.lines[_], M = 0, E = 0, z9 = 0; z9 < C.tokens.length; z9++) {
          var V = C.tokens[z9], $ = V.styleName && t2.rich[V.styleName] || {}, U = V.textPadding = $.padding, H = U ? U[1] + U[3] : 0, q3 = V.font = $.font || t2.font;
          V.contentHeight = qP(q3);
          var ee = ia($.height, V.contentHeight);
          if (V.innerHeight = ee, U && (ee += U[0] + U[2]), V.height = ee, V.lineHeight = _g($.lineHeight, t2.lineHeight, ee), V.align = $ && $.align || t2.align, V.verticalAlign = $ && $.verticalAlign || "middle", m2 && a != null && f2 + V.lineHeight > a) {
            z9 > 0 ? (C.tokens = C.tokens.slice(0, z9), b2(C, E, M), e2.lines = e2.lines.slice(0, _ + 1)) : e2.lines = e2.lines.slice(0, _);
            break e;
          }
          var oe = $.width, ne = oe == null || oe === "auto";
          if (typeof oe == "string" && oe.charAt(oe.length - 1) === "%")
            V.percentWidth = oe, c2.push(V), V.contentWidth = Jf(V.text, q3);
          else {
            if (ne) {
              var be = $.backgroundColor, Ee = be && be.image;
              Ee && (Ee = _oe(Ee), KP(Ee) && (V.width = Math.max(V.width, Ee.width * ee / Ee.height)));
            }
            var ye = d2 && n2 != null ? n2 - E : null;
            ye != null && ye < V.width ? !ne || ye < H ? (V.text = "", V.width = V.contentWidth = 0) : (V.text = xoe(V.text, ye - H, q3, t2.ellipsis, { minChar: t2.truncateMinChar }), V.width = V.contentWidth = Jf(V.text, q3)) : V.contentWidth = Jf(V.text, q3);
          }
          V.width += H, E += V.width, $ && (M = Math.max(M, V.lineHeight));
        }
        b2(C, E, M);
      }
    e2.outerWidth = e2.width = ia(n2, h), e2.outerHeight = e2.height = ia(a, f2), e2.contentHeight = f2, e2.contentWidth = h, v9 && (e2.outerWidth += v9[1] + v9[3], e2.outerHeight += v9[0] + v9[2]);
    for (var _ = 0; _ < c2.length; _++) {
      var V = c2[_], et = V.percentWidth;
      V.width = parseInt(et, 10) / 100 * e2.width;
    }
    return e2;
  }
  function bO(r2, t2, e2, n2, a) {
    var i = t2 === "", o = a && e2.rich[a] || {}, s = r2.lines, u = o.font || e2.font, l2 = false, c2, f2;
    if (n2) {
      var h = o.padding, v9 = h ? h[1] + h[3] : 0;
      if (o.width != null && o.width !== "auto") {
        var d2 = Gv(o.width, n2.width) + v9;
        s.length > 0 && d2 + n2.accumWidth > n2.width && (c2 = t2.split(`
`), l2 = true), n2.accumWidth = d2;
      } else {
        var m2 = JW(t2, u, n2.width, n2.breakAll, n2.accumWidth);
        n2.accumWidth = m2.accumWidth + v9, f2 = m2.linesWidths, c2 = m2.lines;
      }
    } else
      c2 = t2.split(`
`);
    for (var b2 = 0; b2 < c2.length; b2++) {
      var _ = c2[b2], C = new Coe();
      if (C.styleName = a, C.text = _, C.isLineHolder = !_ && !i, typeof o.width == "number" ? C.width = o.width : C.width = f2 ? f2[b2] : Jf(_, u), !b2 && !l2) {
        var M = (s[s.length - 1] || (s[0] = new Q8())).tokens, E = M.length;
        E === 1 && M[0].isLineHolder ? M[0] = C : (_ || !E || i) && M.push(C);
      } else
        s.push(new Q8([C]));
    }
  }
  function Toe(r2) {
    var t2 = r2.charCodeAt(0);
    return t2 >= 33 && t2 <= 383;
  }
  var Moe = Qd(",&?/;] ".split(""), function(r2, t2) {
    return r2[t2] = true, r2;
  }, {});
  function Poe(r2) {
    return Toe(r2) ? !!Moe[r2] : true;
  }
  function JW(r2, t2, e2, n2, a) {
    for (var i = [], o = [], s = "", u = "", l2 = 0, c2 = 0, f2 = 0; f2 < r2.length; f2++) {
      var h = r2.charAt(f2);
      if (h === `
`) {
        u && (s += u, c2 += l2), i.push(s), o.push(c2), s = "", u = "", l2 = 0, c2 = 0;
        continue;
      }
      var v9 = Jf(h, t2), d2 = n2 ? false : !Poe(h);
      if (i.length ? c2 + v9 > e2 : a + c2 + v9 > e2) {
        c2 ? (s || u) && (d2 ? (s || (s = u, u = "", l2 = 0, c2 = l2), i.push(s), o.push(c2 - l2), u += h, l2 += v9, s = "", c2 = l2) : (u && (s += u, u = "", l2 = 0), i.push(s), o.push(c2), s = h, c2 = v9)) : d2 ? (i.push(u), o.push(l2), u = h, l2 = v9) : (i.push(h), o.push(v9));
        continue;
      }
      c2 += v9, d2 ? (u += h, l2 += v9) : (u && (s += u, u = "", l2 = 0), s += h);
    }
    return !i.length && !s && (s = r2, u = "", l2 = 0), u && (s += u), s && (i.push(s), o.push(c2)), i.length === 1 && (c2 += a), { accumWidth: c2, lines: i, linesWidths: o };
  }
  var t4 = "__zr_style_" + Math.round(Math.random() * 10), Ub = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, ZP = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
  Ub[t4] = true;
  var e7 = ["z", "z2", "invisible"], Doe = ["invisible"], Ioe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype._init = function(e2) {
      for (var n2 = ja(e2), a = 0; a < n2.length; a++) {
        var i = n2[a];
        i === "style" ? this.useStyle(e2[i]) : r2.prototype.attrKV.call(this, i, e2[i]);
      }
      this.style || this.useStyle({});
    }, t2.prototype.beforeBrush = function() {
    }, t2.prototype.afterBrush = function() {
    }, t2.prototype.innerBeforeBrush = function() {
    }, t2.prototype.innerAfterBrush = function() {
    }, t2.prototype.shouldBePainted = function(e2, n2, a, i) {
      var o = this.transform;
      if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && Loe(this, e2, n2) || o && !o[0] && !o[3])
        return false;
      if (a && this.__clipPaths) {
        for (var s = 0; s < this.__clipPaths.length; ++s)
          if (this.__clipPaths[s].isZeroArea())
            return false;
      }
      if (i && this.parent)
        for (var u = this.parent; u; ) {
          if (u.ignore)
            return false;
          u = u.parent;
        }
      return true;
    }, t2.prototype.contain = function(e2, n2) {
      return this.rectContain(e2, n2);
    }, t2.prototype.traverse = function(e2, n2) {
      e2.call(n2, this);
    }, t2.prototype.rectContain = function(e2, n2) {
      var a = this.transformCoordToLocal(e2, n2), i = this.getBoundingRect();
      return i.contain(a[0], a[1]);
    }, t2.prototype.getPaintRect = function() {
      var e2 = this._paintRect;
      if (!this._paintRect || this.__dirty) {
        var n2 = this.transform, a = this.getBoundingRect(), i = this.style, o = i.shadowBlur || 0, s = i.shadowOffsetX || 0, u = i.shadowOffsetY || 0;
        e2 = this._paintRect || (this._paintRect = new da(0, 0, 0, 0)), n2 ? da.applyTransform(e2, a, n2) : e2.copy(a), (o || s || u) && (e2.width += o * 2 + Math.abs(s), e2.height += o * 2 + Math.abs(u), e2.x = Math.min(e2.x, e2.x + s - o), e2.y = Math.min(e2.y, e2.y + u - o));
        var l2 = this.dirtyRectTolerance;
        e2.isZero() || (e2.x = Math.floor(e2.x - l2), e2.y = Math.floor(e2.y - l2), e2.width = Math.ceil(e2.width + 1 + l2 * 2), e2.height = Math.ceil(e2.height + 1 + l2 * 2));
      }
      return e2;
    }, t2.prototype.setPrevPaintRect = function(e2) {
      e2 ? (this._prevPaintRect = this._prevPaintRect || new da(0, 0, 0, 0), this._prevPaintRect.copy(e2)) : this._prevPaintRect = null;
    }, t2.prototype.getPrevPaintRect = function() {
      return this._prevPaintRect;
    }, t2.prototype.animateStyle = function(e2) {
      return this.animate("style", e2);
    }, t2.prototype.updateDuringAnimation = function(e2) {
      e2 === "style" ? this.dirtyStyle() : this.markRedraw();
    }, t2.prototype.attrKV = function(e2, n2) {
      e2 !== "style" ? r2.prototype.attrKV.call(this, e2, n2) : this.style ? this.setStyle(n2) : this.useStyle(n2);
    }, t2.prototype.setStyle = function(e2, n2) {
      return typeof e2 == "string" ? this.style[e2] = n2 : qt(this.style, e2), this.dirtyStyle(), this;
    }, t2.prototype.dirtyStyle = function(e2) {
      e2 || this.markRedraw(), this.__dirty |= mC, this._rect && (this._rect = null);
    }, t2.prototype.dirty = function() {
      this.dirtyStyle();
    }, t2.prototype.styleChanged = function() {
      return !!(this.__dirty & mC);
    }, t2.prototype.styleUpdated = function() {
      this.__dirty &= ~mC;
    }, t2.prototype.createStyle = function(e2) {
      return WP(Ub, e2);
    }, t2.prototype.useStyle = function(e2) {
      e2[t4] || (e2 = this.createStyle(e2)), this.__inHover ? this.__hoverStyle = e2 : this.style = e2, this.dirtyStyle();
    }, t2.prototype.isStyleObject = function(e2) {
      return e2[t4];
    }, t2.prototype._innerSaveToNormal = function(e2) {
      r2.prototype._innerSaveToNormal.call(this, e2);
      var n2 = this._normalState;
      e2.style && !n2.style && (n2.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(e2, n2, e7);
    }, t2.prototype._applyStateObj = function(e2, n2, a, i, o, s) {
      r2.prototype._applyStateObj.call(this, e2, n2, a, i, o, s);
      var u = !(n2 && i), l2;
      if (n2 && n2.style ? o ? i ? l2 = n2.style : (l2 = this._mergeStyle(this.createStyle(), a.style), this._mergeStyle(l2, n2.style)) : (l2 = this._mergeStyle(this.createStyle(), i ? this.style : a.style), this._mergeStyle(l2, n2.style)) : u && (l2 = a.style), l2)
        if (o) {
          var c2 = this.style;
          if (this.style = this.createStyle(u ? {} : c2), u)
            for (var f2 = ja(c2), h = 0; h < f2.length; h++) {
              var v9 = f2[h];
              v9 in l2 && (l2[v9] = l2[v9], this.style[v9] = c2[v9]);
            }
          for (var d2 = ja(l2), h = 0; h < d2.length; h++) {
            var v9 = d2[h];
            this.style[v9] = this.style[v9];
          }
          this._transitionState(e2, { style: l2 }, s, this.getAnimationStyleProps());
        } else
          this.useStyle(l2);
      for (var m2 = this.__inHover ? Doe : e7, h = 0; h < m2.length; h++) {
        var v9 = m2[h];
        n2 && n2[v9] != null ? this[v9] = n2[v9] : u && a[v9] != null && (this[v9] = a[v9]);
      }
    }, t2.prototype._mergeStates = function(e2) {
      for (var n2 = r2.prototype._mergeStates.call(this, e2), a, i = 0; i < e2.length; i++) {
        var o = e2[i];
        o.style && (a = a || {}, this._mergeStyle(a, o.style));
      }
      return a && (n2.style = a), n2;
    }, t2.prototype._mergeStyle = function(e2, n2) {
      return qt(e2, n2), e2;
    }, t2.prototype.getAnimationStyleProps = function() {
      return ZP;
    }, t2.initDefaultProps = function() {
      var e2 = t2.prototype;
      e2.type = "displayable", e2.invisible = false, e2.z = 0, e2.z2 = 0, e2.zlevel = 0, e2.culling = false, e2.cursor = "pointer", e2.rectHover = false, e2.incremental = false, e2._rect = null, e2.dirtyRectTolerance = 0, e2.__dirty = Kf | mC;
    }(), t2;
  }(LW), _O = new da(0, 0, 0, 0), xO = new da(0, 0, 0, 0);
  function Loe(r2, t2, e2) {
    return _O.copy(r2.getBoundingRect()), r2.transform && _O.applyTransform(r2.transform), xO.width = t2, xO.height = e2, !_O.intersect(xO);
  }
  var qh = Ioe, hf = Math.min, vf = Math.max, wO = Math.sin, SO = Math.cos, sb = Math.PI * 2, wM = o1(), SM = o1(), CM = o1();
  function XP(r2, t2, e2) {
    if (r2.length !== 0) {
      for (var n2 = r2[0], a = n2[0], i = n2[0], o = n2[1], s = n2[1], u = 1; u < r2.length; u++)
        n2 = r2[u], a = hf(a, n2[0]), i = vf(i, n2[0]), o = hf(o, n2[1]), s = vf(s, n2[1]);
      t2[0] = a, t2[1] = o, e2[0] = i, e2[1] = s;
    }
  }
  function t7(r2, t2, e2, n2, a, i) {
    a[0] = hf(r2, e2), a[1] = hf(t2, n2), i[0] = vf(r2, e2), i[1] = vf(t2, n2);
  }
  var r7 = [], n7 = [];
  function Ooe(r2, t2, e2, n2, a, i, o, s, u, l2) {
    var c2 = gW, f2 = Wu, h = c2(r2, e2, a, o, r7);
    u[0] = 1 / 0, u[1] = 1 / 0, l2[0] = -1 / 0, l2[1] = -1 / 0;
    for (var v9 = 0; v9 < h; v9++) {
      var d2 = f2(r2, e2, a, o, r7[v9]);
      u[0] = hf(d2, u[0]), l2[0] = vf(d2, l2[0]);
    }
    h = c2(t2, n2, i, s, n7);
    for (var v9 = 0; v9 < h; v9++) {
      var m2 = f2(t2, n2, i, s, n7[v9]);
      u[1] = hf(m2, u[1]), l2[1] = vf(m2, l2[1]);
    }
    u[0] = hf(r2, u[0]), l2[0] = vf(r2, l2[0]), u[0] = hf(o, u[0]), l2[0] = vf(o, l2[0]), u[1] = hf(t2, u[1]), l2[1] = vf(t2, l2[1]), u[1] = hf(s, u[1]), l2[1] = vf(s, l2[1]);
  }
  function koe(r2, t2, e2, n2, a, i, o, s) {
    var u = mW, l2 = yl, c2 = vf(hf(u(r2, e2, a), 1), 0), f2 = vf(hf(u(t2, n2, i), 1), 0), h = l2(r2, e2, a, c2), v9 = l2(t2, n2, i, f2);
    o[0] = hf(r2, a, h), o[1] = hf(t2, i, v9), s[0] = vf(r2, a, h), s[1] = vf(t2, i, v9);
  }
  function Roe(r2, t2, e2, n2, a, i, o, s, u) {
    var l2 = ry, c2 = ny, f2 = Math.abs(a - i);
    if (f2 % sb < 1e-4 && f2 > 1e-4) {
      s[0] = r2 - e2, s[1] = t2 - n2, u[0] = r2 + e2, u[1] = t2 + n2;
      return;
    }
    if (wM[0] = SO(a) * e2 + r2, wM[1] = wO(a) * n2 + t2, SM[0] = SO(i) * e2 + r2, SM[1] = wO(i) * n2 + t2, l2(s, wM, SM), c2(u, wM, SM), a = a % sb, a < 0 && (a = a + sb), i = i % sb, i < 0 && (i = i + sb), a > i && !o ? i += sb : a < i && o && (a += sb), o) {
      var h = i;
      i = a, a = h;
    }
    for (var v9 = 0; v9 < i; v9 += Math.PI / 2)
      v9 > a && (CM[0] = SO(v9) * e2 + r2, CM[1] = wO(v9) * n2 + t2, l2(s, CM, s), c2(u, CM, u));
  }
  var po = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, ub = [], lb2 = [], Rd = [], G0 = [], Fd = [], Nd = [], CO = Math.min, EO = Math.max, cb = Math.cos, fb = Math.sin, hg = Math.abs, r4 = Math.PI, X0 = r4 * 2, AO = typeof Float32Array != "undefined", U2 = [];
  function TO(r2) {
    var t2 = Math.round(r2 / r4 * 1e8) / 1e8;
    return t2 % 2 * r4;
  }
  function Foe(r2, t2) {
    var e2 = TO(r2[0]);
    e2 < 0 && (e2 += X0);
    var n2 = e2 - r2[0], a = r2[1];
    a += n2, !t2 && a - e2 >= X0 ? a = e2 + X0 : t2 && e2 - a >= X0 ? a = e2 - X0 : !t2 && e2 > a ? a = e2 + (X0 - TO(e2 - a)) : t2 && e2 < a && (a = e2 - (X0 - TO(a - e2))), r2[0] = e2, r2[1] = a;
  }
  var Noe = function() {
    function r2(t2) {
      this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, t2 && (this._saveData = false), this._saveData && (this.data = []);
    }
    return r2.prototype.increaseVersion = function() {
      this._version++;
    }, r2.prototype.getVersion = function() {
      return this._version;
    }, r2.prototype.setScale = function(t2, e2, n2) {
      n2 = n2 || 0, n2 > 0 && (this._ux = hg(n2 / K5 / t2) || 0, this._uy = hg(n2 / K5 / e2) || 0);
    }, r2.prototype.setDPR = function(t2) {
      this.dpr = t2;
    }, r2.prototype.setContext = function(t2) {
      this._ctx = t2;
    }, r2.prototype.getContext = function() {
      return this._ctx;
    }, r2.prototype.beginPath = function() {
      return this._ctx && this._ctx.beginPath(), this.reset(), this;
    }, r2.prototype.reset = function() {
      this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
    }, r2.prototype.moveTo = function(t2, e2) {
      return this._drawPendingPt(), this.addData(po.M, t2, e2), this._ctx && this._ctx.moveTo(t2, e2), this._x0 = t2, this._y0 = e2, this._xi = t2, this._yi = e2, this;
    }, r2.prototype.lineTo = function(t2, e2) {
      var n2 = hg(t2 - this._xi), a = hg(e2 - this._yi), i = n2 > this._ux || a > this._uy;
      if (this.addData(po.L, t2, e2), this._ctx && i && this._ctx.lineTo(t2, e2), i)
        this._xi = t2, this._yi = e2, this._pendingPtDist = 0;
      else {
        var o = n2 * n2 + a * a;
        o > this._pendingPtDist && (this._pendingPtX = t2, this._pendingPtY = e2, this._pendingPtDist = o);
      }
      return this;
    }, r2.prototype.bezierCurveTo = function(t2, e2, n2, a, i, o) {
      return this._drawPendingPt(), this.addData(po.C, t2, e2, n2, a, i, o), this._ctx && this._ctx.bezierCurveTo(t2, e2, n2, a, i, o), this._xi = i, this._yi = o, this;
    }, r2.prototype.quadraticCurveTo = function(t2, e2, n2, a) {
      return this._drawPendingPt(), this.addData(po.Q, t2, e2, n2, a), this._ctx && this._ctx.quadraticCurveTo(t2, e2, n2, a), this._xi = n2, this._yi = a, this;
    }, r2.prototype.arc = function(t2, e2, n2, a, i, o) {
      this._drawPendingPt(), U2[0] = a, U2[1] = i, Foe(U2, o), a = U2[0], i = U2[1];
      var s = i - a;
      return this.addData(po.A, t2, e2, n2, n2, a, s, 0, o ? 0 : 1), this._ctx && this._ctx.arc(t2, e2, n2, a, i, o), this._xi = cb(i) * n2 + t2, this._yi = fb(i) * n2 + e2, this;
    }, r2.prototype.arcTo = function(t2, e2, n2, a, i) {
      return this._drawPendingPt(), this._ctx && this._ctx.arcTo(t2, e2, n2, a, i), this;
    }, r2.prototype.rect = function(t2, e2, n2, a) {
      return this._drawPendingPt(), this._ctx && this._ctx.rect(t2, e2, n2, a), this.addData(po.R, t2, e2, n2, a), this;
    }, r2.prototype.closePath = function() {
      this._drawPendingPt(), this.addData(po.Z);
      var t2 = this._ctx, e2 = this._x0, n2 = this._y0;
      return t2 && t2.closePath(), this._xi = e2, this._yi = n2, this;
    }, r2.prototype.fill = function(t2) {
      t2 && t2.fill(), this.toStatic();
    }, r2.prototype.stroke = function(t2) {
      t2 && t2.stroke(), this.toStatic();
    }, r2.prototype.len = function() {
      return this._len;
    }, r2.prototype.setData = function(t2) {
      var e2 = t2.length;
      !(this.data && this.data.length === e2) && AO && (this.data = new Float32Array(e2));
      for (var n2 = 0; n2 < e2; n2++)
        this.data[n2] = t2[n2];
      this._len = e2;
    }, r2.prototype.appendPath = function(t2) {
      t2 instanceof Array || (t2 = [t2]);
      for (var e2 = t2.length, n2 = 0, a = this._len, i = 0; i < e2; i++)
        n2 += t2[i].len();
      AO && this.data instanceof Float32Array && (this.data = new Float32Array(a + n2));
      for (var i = 0; i < e2; i++)
        for (var o = t2[i].data, s = 0; s < o.length; s++)
          this.data[a++] = o[s];
      this._len = a;
    }, r2.prototype.addData = function(t2, e2, n2, a, i, o, s, u, l2) {
      if (!!this._saveData) {
        var c2 = this.data;
        this._len + arguments.length > c2.length && (this._expandData(), c2 = this.data);
        for (var f2 = 0; f2 < arguments.length; f2++)
          c2[this._len++] = arguments[f2];
      }
    }, r2.prototype._drawPendingPt = function() {
      this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
    }, r2.prototype._expandData = function() {
      if (!(this.data instanceof Array)) {
        for (var t2 = [], e2 = 0; e2 < this._len; e2++)
          t2[e2] = this.data[e2];
        this.data = t2;
      }
    }, r2.prototype.toStatic = function() {
      if (!!this._saveData) {
        this._drawPendingPt();
        var t2 = this.data;
        t2 instanceof Array && (t2.length = this._len, AO && this._len > 11 && (this.data = new Float32Array(t2)));
      }
    }, r2.prototype.getBoundingRect = function() {
      Rd[0] = Rd[1] = Fd[0] = Fd[1] = Number.MAX_VALUE, G0[0] = G0[1] = Nd[0] = Nd[1] = -Number.MAX_VALUE;
      var t2 = this.data, e2 = 0, n2 = 0, a = 0, i = 0, o;
      for (o = 0; o < this._len; ) {
        var s = t2[o++], u = o === 1;
        switch (u && (e2 = t2[o], n2 = t2[o + 1], a = e2, i = n2), s) {
          case po.M:
            e2 = a = t2[o++], n2 = i = t2[o++], Fd[0] = a, Fd[1] = i, Nd[0] = a, Nd[1] = i;
            break;
          case po.L:
            t7(e2, n2, t2[o], t2[o + 1], Fd, Nd), e2 = t2[o++], n2 = t2[o++];
            break;
          case po.C:
            Ooe(e2, n2, t2[o++], t2[o++], t2[o++], t2[o++], t2[o], t2[o + 1], Fd, Nd), e2 = t2[o++], n2 = t2[o++];
            break;
          case po.Q:
            koe(e2, n2, t2[o++], t2[o++], t2[o], t2[o + 1], Fd, Nd), e2 = t2[o++], n2 = t2[o++];
            break;
          case po.A:
            var l2 = t2[o++], c2 = t2[o++], f2 = t2[o++], h = t2[o++], v9 = t2[o++], d2 = t2[o++] + v9;
            o += 1;
            var m2 = !t2[o++];
            u && (a = cb(v9) * f2 + l2, i = fb(v9) * h + c2), Roe(l2, c2, f2, h, v9, d2, m2, Fd, Nd), e2 = cb(d2) * f2 + l2, n2 = fb(d2) * h + c2;
            break;
          case po.R:
            a = e2 = t2[o++], i = n2 = t2[o++];
            var b2 = t2[o++], _ = t2[o++];
            t7(a, i, a + b2, i + _, Fd, Nd);
            break;
          case po.Z:
            e2 = a, n2 = i;
            break;
        }
        ry(Rd, Rd, Fd), ny(G0, G0, Nd);
      }
      return o === 0 && (Rd[0] = Rd[1] = G0[0] = G0[1] = 0), new da(Rd[0], Rd[1], G0[0] - Rd[0], G0[1] - Rd[1]);
    }, r2.prototype._calculateLength = function() {
      var t2 = this.data, e2 = this._len, n2 = this._ux, a = this._uy, i = 0, o = 0, s = 0, u = 0;
      this._pathSegLen || (this._pathSegLen = []);
      for (var l2 = this._pathSegLen, c2 = 0, f2 = 0, h = 0; h < e2; ) {
        var v9 = t2[h++], d2 = h === 1;
        d2 && (i = t2[h], o = t2[h + 1], s = i, u = o);
        var m2 = -1;
        switch (v9) {
          case po.M:
            i = s = t2[h++], o = u = t2[h++];
            break;
          case po.L: {
            var b2 = t2[h++], _ = t2[h++], C = b2 - i, M = _ - o;
            (hg(C) > n2 || hg(M) > a || h === e2 - 1) && (m2 = Math.sqrt(C * C + M * M), i = b2, o = _);
            break;
          }
          case po.C: {
            var E = t2[h++], z9 = t2[h++], b2 = t2[h++], _ = t2[h++], V = t2[h++], $ = t2[h++];
            m2 = Hae(i, o, E, z9, b2, _, V, $, 10), i = V, o = $;
            break;
          }
          case po.Q: {
            var E = t2[h++], z9 = t2[h++], b2 = t2[h++], _ = t2[h++];
            m2 = Yae(i, o, E, z9, b2, _, 10), i = b2, o = _;
            break;
          }
          case po.A:
            var U = t2[h++], H = t2[h++], q3 = t2[h++], ee = t2[h++], oe = t2[h++], ne = t2[h++], be = ne + oe;
            h += 1, t2[h++], d2 && (s = cb(oe) * q3 + U, u = fb(oe) * ee + H), m2 = EO(q3, ee) * CO(X0, Math.abs(ne)), i = cb(be) * q3 + U, o = fb(be) * ee + H;
            break;
          case po.R: {
            s = i = t2[h++], u = o = t2[h++];
            var Ee = t2[h++], ye = t2[h++];
            m2 = Ee * 2 + ye * 2;
            break;
          }
          case po.Z: {
            var C = s - i, M = u - o;
            m2 = Math.sqrt(C * C + M * M), i = s, o = u;
            break;
          }
        }
        m2 >= 0 && (l2[f2++] = m2, c2 += m2);
      }
      return this._pathLen = c2, c2;
    }, r2.prototype.rebuildPath = function(t2, e2) {
      var n2 = this.data, a = this._ux, i = this._uy, o = this._len, s, u, l2, c2, f2, h, v9 = e2 < 1, d2, m2, b2 = 0, _ = 0, C, M = 0, E, z9;
      if (v9 && (this._pathSegLen || this._calculateLength(), d2 = this._pathSegLen, m2 = this._pathLen, C = e2 * m2, !C))
        return;
      e:
        for (var V = 0; V < o; ) {
          var $ = n2[V++], U = V === 1;
          switch (U && (l2 = n2[V], c2 = n2[V + 1], s = l2, u = c2), $ !== po.L && M > 0 && (t2.lineTo(E, z9), M = 0), $) {
            case po.M:
              s = l2 = n2[V++], u = c2 = n2[V++], t2.moveTo(l2, c2);
              break;
            case po.L: {
              f2 = n2[V++], h = n2[V++];
              var H = hg(f2 - l2), q3 = hg(h - c2);
              if (H > a || q3 > i) {
                if (v9) {
                  var ee = d2[_++];
                  if (b2 + ee > C) {
                    var oe = (C - b2) / ee;
                    t2.lineTo(l2 * (1 - oe) + f2 * oe, c2 * (1 - oe) + h * oe);
                    break e;
                  }
                  b2 += ee;
                }
                t2.lineTo(f2, h), l2 = f2, c2 = h, M = 0;
              } else {
                var ne = H * H + q3 * q3;
                ne > M && (E = f2, z9 = h, M = ne);
              }
              break;
            }
            case po.C: {
              var be = n2[V++], Ee = n2[V++], ye = n2[V++], et = n2[V++], Le = n2[V++], Fe = n2[V++];
              if (v9) {
                var ee = d2[_++];
                if (b2 + ee > C) {
                  var oe = (C - b2) / ee;
                  yy(l2, be, ye, Le, oe, ub), yy(c2, Ee, et, Fe, oe, lb2), t2.bezierCurveTo(ub[1], lb2[1], ub[2], lb2[2], ub[3], lb2[3]);
                  break e;
                }
                b2 += ee;
              }
              t2.bezierCurveTo(be, Ee, ye, et, Le, Fe), l2 = Le, c2 = Fe;
              break;
            }
            case po.Q: {
              var be = n2[V++], Ee = n2[V++], ye = n2[V++], et = n2[V++];
              if (v9) {
                var ee = d2[_++];
                if (b2 + ee > C) {
                  var oe = (C - b2) / ee;
                  JC(l2, be, ye, oe, ub), JC(c2, Ee, et, oe, lb2), t2.quadraticCurveTo(ub[1], lb2[1], ub[2], lb2[2]);
                  break e;
                }
                b2 += ee;
              }
              t2.quadraticCurveTo(be, Ee, ye, et), l2 = ye, c2 = et;
              break;
            }
            case po.A:
              var qe = n2[V++], st = n2[V++], dt = n2[V++], Ar = n2[V++], Hr = n2[V++], hn = n2[V++], cn = n2[V++], nn = !n2[V++], Wr = dt > Ar ? dt : Ar, on = hg(dt - Ar) > 1e-3, un = Hr + hn, Xr = false;
              if (v9) {
                var ee = d2[_++];
                b2 + ee > C && (un = Hr + hn * (C - b2) / ee, Xr = true), b2 += ee;
              }
              if (on && t2.ellipse ? t2.ellipse(qe, st, dt, Ar, cn, Hr, un, nn) : t2.arc(qe, st, Wr, Hr, un, nn), Xr)
                break e;
              U && (s = cb(Hr) * dt + qe, u = fb(Hr) * Ar + st), l2 = cb(un) * dt + qe, c2 = fb(un) * Ar + st;
              break;
            case po.R:
              s = l2 = n2[V], u = c2 = n2[V + 1], f2 = n2[V++], h = n2[V++];
              var _n = n2[V++], Za = n2[V++];
              if (v9) {
                var ee = d2[_++];
                if (b2 + ee > C) {
                  var Dn = C - b2;
                  t2.moveTo(f2, h), t2.lineTo(f2 + CO(Dn, _n), h), Dn -= _n, Dn > 0 && t2.lineTo(f2 + _n, h + CO(Dn, Za)), Dn -= Za, Dn > 0 && t2.lineTo(f2 + EO(_n - Dn, 0), h + Za), Dn -= _n, Dn > 0 && t2.lineTo(f2, h + EO(Za - Dn, 0));
                  break e;
                }
                b2 += ee;
              }
              t2.rect(f2, h, _n, Za);
              break;
            case po.Z:
              if (v9) {
                var ee = d2[_++];
                if (b2 + ee > C) {
                  var oe = (C - b2) / ee;
                  t2.lineTo(l2 * (1 - oe) + s * oe, c2 * (1 - oe) + u * oe);
                  break e;
                }
                b2 += ee;
              }
              t2.closePath(), l2 = s, c2 = u;
          }
        }
    }, r2.prototype.clone = function() {
      var t2 = new r2(), e2 = this.data;
      return t2.data = e2.slice ? e2.slice() : Array.prototype.slice.call(e2), t2._len = this._len, t2;
    }, r2.CMD = po, r2.initDefaultProps = function() {
      var t2 = r2.prototype;
      t2._saveData = true, t2._ux = 0, t2._uy = 0, t2._pendingPtDist = 0, t2._version = 0;
    }(), r2;
  }(), np = Noe;
  function Q0(r2, t2, e2, n2, a, i, o) {
    if (a === 0)
      return false;
    var s = a, u = 0, l2 = r2;
    if (o > t2 + s && o > n2 + s || o < t2 - s && o < n2 - s || i > r2 + s && i > e2 + s || i < r2 - s && i < e2 - s)
      return false;
    if (r2 !== e2)
      u = (t2 - n2) / (r2 - e2), l2 = (r2 * n2 - e2 * t2) / (r2 - e2);
    else
      return Math.abs(i - r2) <= s / 2;
    var c2 = u * i - o + l2, f2 = c2 * c2 / (u * u + 1);
    return f2 <= s / 2 * s / 2;
  }
  function Voe(r2, t2, e2, n2, a, i, o, s, u, l2, c2) {
    if (u === 0)
      return false;
    var f2 = u;
    if (c2 > t2 + f2 && c2 > n2 + f2 && c2 > i + f2 && c2 > s + f2 || c2 < t2 - f2 && c2 < n2 - f2 && c2 < i - f2 && c2 < s - f2 || l2 > r2 + f2 && l2 > e2 + f2 && l2 > a + f2 && l2 > o + f2 || l2 < r2 - f2 && l2 < e2 - f2 && l2 < a - f2 && l2 < o - f2)
      return false;
    var h = yW(r2, t2, e2, n2, a, i, o, s, l2, c2, null);
    return h <= f2 / 2;
  }
  function QW(r2, t2, e2, n2, a, i, o, s, u) {
    if (o === 0)
      return false;
    var l2 = o;
    if (u > t2 + l2 && u > n2 + l2 && u > i + l2 || u < t2 - l2 && u < n2 - l2 && u < i - l2 || s > r2 + l2 && s > e2 + l2 && s > a + l2 || s < r2 - l2 && s < e2 - l2 && s < a - l2)
      return false;
    var c2 = bW(r2, t2, e2, n2, a, i, s, u, null);
    return c2 <= l2 / 2;
  }
  var a7 = Math.PI * 2;
  function sy(r2) {
    return r2 %= a7, r2 < 0 && (r2 += a7), r2;
  }
  var H2 = Math.PI * 2;
  function joe(r2, t2, e2, n2, a, i, o, s, u) {
    if (o === 0)
      return false;
    var l2 = o;
    s -= r2, u -= t2;
    var c2 = Math.sqrt(s * s + u * u);
    if (c2 - l2 > e2 || c2 + l2 < e2)
      return false;
    if (Math.abs(n2 - a) % H2 < 1e-4)
      return true;
    if (i) {
      var f2 = n2;
      n2 = sy(a), a = sy(f2);
    } else
      n2 = sy(n2), a = sy(a);
    n2 > a && (a += H2);
    var h = Math.atan2(u, s);
    return h < 0 && (h += H2), h >= n2 && h <= a || h + H2 >= n2 && h + H2 <= a;
  }
  function yg(r2, t2, e2, n2, a, i) {
    if (i > t2 && i > n2 || i < t2 && i < n2 || n2 === t2)
      return 0;
    var o = (i - t2) / (n2 - t2), s = n2 < t2 ? 1 : -1;
    (o === 1 || o === 0) && (s = n2 < t2 ? 0.5 : -0.5);
    var u = o * (e2 - r2) + r2;
    return u === a ? 1 / 0 : u > a ? s : 0;
  }
  var W0 = np.CMD, hb = Math.PI * 2, Boe = 1e-4;
  function zoe(r2, t2) {
    return Math.abs(r2 - t2) < Boe;
  }
  var Oc = [-1, -1, -1], Rh = [-1, -1];
  function $oe() {
    var r2 = Rh[0];
    Rh[0] = Rh[1], Rh[1] = r2;
  }
  function Goe(r2, t2, e2, n2, a, i, o, s, u, l2) {
    if (l2 > t2 && l2 > n2 && l2 > i && l2 > s || l2 < t2 && l2 < n2 && l2 < i && l2 < s)
      return 0;
    var c2 = U5(t2, n2, i, s, l2, Oc);
    if (c2 === 0)
      return 0;
    for (var f2 = 0, h = -1, v9 = void 0, d2 = void 0, m2 = 0; m2 < c2; m2++) {
      var b2 = Oc[m2], _ = b2 === 0 || b2 === 1 ? 0.5 : 1, C = Wu(r2, e2, a, o, b2);
      C < u || (h < 0 && (h = gW(t2, n2, i, s, Rh), Rh[1] < Rh[0] && h > 1 && $oe(), v9 = Wu(t2, n2, i, s, Rh[0]), h > 1 && (d2 = Wu(t2, n2, i, s, Rh[1]))), h === 2 ? b2 < Rh[0] ? f2 += v9 < t2 ? _ : -_ : b2 < Rh[1] ? f2 += d2 < v9 ? _ : -_ : f2 += s < d2 ? _ : -_ : b2 < Rh[0] ? f2 += v9 < t2 ? _ : -_ : f2 += s < v9 ? _ : -_);
    }
    return f2;
  }
  function Woe(r2, t2, e2, n2, a, i, o, s) {
    if (s > t2 && s > n2 && s > i || s < t2 && s < n2 && s < i)
      return 0;
    var u = qae(t2, n2, i, s, Oc);
    if (u === 0)
      return 0;
    var l2 = mW(t2, n2, i);
    if (l2 >= 0 && l2 <= 1) {
      for (var c2 = 0, f2 = yl(t2, n2, i, l2), h = 0; h < u; h++) {
        var v9 = Oc[h] === 0 || Oc[h] === 1 ? 0.5 : 1, d2 = yl(r2, e2, a, Oc[h]);
        d2 < o || (Oc[h] < l2 ? c2 += f2 < t2 ? v9 : -v9 : c2 += i < f2 ? v9 : -v9);
      }
      return c2;
    } else {
      var v9 = Oc[0] === 0 || Oc[0] === 1 ? 0.5 : 1, d2 = yl(r2, e2, a, Oc[0]);
      return d2 < o ? 0 : i < t2 ? v9 : -v9;
    }
  }
  function Uoe(r2, t2, e2, n2, a, i, o, s) {
    if (s -= t2, s > e2 || s < -e2)
      return 0;
    var u = Math.sqrt(e2 * e2 - s * s);
    Oc[0] = -u, Oc[1] = u;
    var l2 = Math.abs(n2 - a);
    if (l2 < 1e-4)
      return 0;
    if (l2 >= hb - 1e-4) {
      n2 = 0, a = hb;
      var c2 = i ? 1 : -1;
      return o >= Oc[0] + r2 && o <= Oc[1] + r2 ? c2 : 0;
    }
    if (n2 > a) {
      var f2 = n2;
      n2 = a, a = f2;
    }
    n2 < 0 && (n2 += hb, a += hb);
    for (var h = 0, v9 = 0; v9 < 2; v9++) {
      var d2 = Oc[v9];
      if (d2 + r2 > o) {
        var m2 = Math.atan2(s, d2), c2 = i ? 1 : -1;
        m2 < 0 && (m2 = hb + m2), (m2 >= n2 && m2 <= a || m2 + hb >= n2 && m2 + hb <= a) && (m2 > Math.PI / 2 && m2 < Math.PI * 1.5 && (c2 = -c2), h += c2);
      }
    }
    return h;
  }
  function eU(r2, t2, e2, n2, a) {
    for (var i = r2.data, o = r2.len(), s = 0, u = 0, l2 = 0, c2 = 0, f2 = 0, h, v9, d2 = 0; d2 < o; ) {
      var m2 = i[d2++], b2 = d2 === 1;
      switch (m2 === W0.M && d2 > 1 && (e2 || (s += yg(u, l2, c2, f2, n2, a))), b2 && (u = i[d2], l2 = i[d2 + 1], c2 = u, f2 = l2), m2) {
        case W0.M:
          c2 = i[d2++], f2 = i[d2++], u = c2, l2 = f2;
          break;
        case W0.L:
          if (e2) {
            if (Q0(u, l2, i[d2], i[d2 + 1], t2, n2, a))
              return true;
          } else
            s += yg(u, l2, i[d2], i[d2 + 1], n2, a) || 0;
          u = i[d2++], l2 = i[d2++];
          break;
        case W0.C:
          if (e2) {
            if (Voe(u, l2, i[d2++], i[d2++], i[d2++], i[d2++], i[d2], i[d2 + 1], t2, n2, a))
              return true;
          } else
            s += Goe(u, l2, i[d2++], i[d2++], i[d2++], i[d2++], i[d2], i[d2 + 1], n2, a) || 0;
          u = i[d2++], l2 = i[d2++];
          break;
        case W0.Q:
          if (e2) {
            if (QW(u, l2, i[d2++], i[d2++], i[d2], i[d2 + 1], t2, n2, a))
              return true;
          } else
            s += Woe(u, l2, i[d2++], i[d2++], i[d2], i[d2 + 1], n2, a) || 0;
          u = i[d2++], l2 = i[d2++];
          break;
        case W0.A:
          var _ = i[d2++], C = i[d2++], M = i[d2++], E = i[d2++], z9 = i[d2++], V = i[d2++];
          d2 += 1;
          var $ = !!(1 - i[d2++]);
          h = Math.cos(z9) * M + _, v9 = Math.sin(z9) * E + C, b2 ? (c2 = h, f2 = v9) : s += yg(u, l2, h, v9, n2, a);
          var U = (n2 - _) * E / M + _;
          if (e2) {
            if (joe(_, C, E, z9, z9 + V, $, t2, U, a))
              return true;
          } else
            s += Uoe(_, C, E, z9, z9 + V, $, U, a);
          u = Math.cos(z9 + V) * M + _, l2 = Math.sin(z9 + V) * E + C;
          break;
        case W0.R:
          c2 = u = i[d2++], f2 = l2 = i[d2++];
          var H = i[d2++], q3 = i[d2++];
          if (h = c2 + H, v9 = f2 + q3, e2) {
            if (Q0(c2, f2, h, f2, t2, n2, a) || Q0(h, f2, h, v9, t2, n2, a) || Q0(h, v9, c2, v9, t2, n2, a) || Q0(c2, v9, c2, f2, t2, n2, a))
              return true;
          } else
            s += yg(h, f2, h, v9, n2, a), s += yg(c2, v9, c2, f2, n2, a);
          break;
        case W0.Z:
          if (e2) {
            if (Q0(u, l2, c2, f2, t2, n2, a))
              return true;
          } else
            s += yg(u, l2, c2, f2, n2, a);
          u = c2, l2 = f2;
          break;
      }
    }
    return !e2 && !zoe(l2, f2) && (s += yg(u, l2, c2, f2, n2, a) || 0), s !== 0;
  }
  function Hoe(r2, t2, e2) {
    return eU(r2, 0, false, t2, e2);
  }
  function qoe(r2, t2, e2, n2) {
    return eU(r2, t2, true, e2, n2);
  }
  var J5 = En({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, Ub), Yoe = { style: En({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, ZP.style) }, MO = tp.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), Koe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.update = function() {
      var e2 = this;
      r2.prototype.update.call(this);
      var n2 = this.style;
      if (n2.decal) {
        var a = this._decalEl = this._decalEl || new t2();
        a.buildPath === t2.prototype.buildPath && (a.buildPath = function(u) {
          e2.buildPath(u, e2.shape);
        }), a.silent = true;
        var i = a.style;
        for (var o in n2)
          i[o] !== n2[o] && (i[o] = n2[o]);
        i.fill = n2.fill ? n2.decal : null, i.decal = null, i.shadowColor = null, n2.strokeFirst && (i.stroke = null);
        for (var s = 0; s < MO.length; ++s)
          a[MO[s]] = this[MO[s]];
        a.__dirty |= Kf;
      } else
        this._decalEl && (this._decalEl = null);
    }, t2.prototype.getDecalElement = function() {
      return this._decalEl;
    }, t2.prototype._init = function(e2) {
      var n2 = ja(e2);
      this.shape = this.getDefaultShape();
      var a = this.getDefaultStyle();
      a && this.useStyle(a);
      for (var i = 0; i < n2.length; i++) {
        var o = n2[i], s = e2[o];
        o === "style" ? this.style ? qt(this.style, s) : this.useStyle(s) : o === "shape" ? qt(this.shape, s) : r2.prototype.attrKV.call(this, o, s);
      }
      this.style || this.useStyle({});
    }, t2.prototype.getDefaultStyle = function() {
      return null;
    }, t2.prototype.getDefaultShape = function() {
      return {};
    }, t2.prototype.canBeInsideText = function() {
      return this.hasFill();
    }, t2.prototype.getInsideTextFill = function() {
      var e2 = this.style.fill;
      if (e2 !== "none") {
        if (Zr(e2)) {
          var n2 = q5(e2, 0);
          return n2 > 0.5 ? XR : n2 > 0.2 ? Tie : JR;
        } else if (e2)
          return JR;
      }
      return XR;
    }, t2.prototype.getInsideTextStroke = function(e2) {
      var n2 = this.style.fill;
      if (Zr(n2)) {
        var a = this.__zr, i = !!(a && a.isDarkMode()), o = q5(e2, 0) < ZR;
        if (i === o)
          return n2;
      }
    }, t2.prototype.buildPath = function(e2, n2, a) {
    }, t2.prototype.pathUpdated = function() {
      this.__dirty &= ~kx;
    }, t2.prototype.getUpdatedPathProxy = function(e2) {
      return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, e2), this.path;
    }, t2.prototype.createPathProxy = function() {
      this.path = new np(false);
    }, t2.prototype.hasStroke = function() {
      var e2 = this.style, n2 = e2.stroke;
      return !(n2 == null || n2 === "none" || !(e2.lineWidth > 0));
    }, t2.prototype.hasFill = function() {
      var e2 = this.style, n2 = e2.fill;
      return n2 != null && n2 !== "none";
    }, t2.prototype.getBoundingRect = function() {
      var e2 = this._rect, n2 = this.style, a = !e2;
      if (a) {
        var i = false;
        this.path || (i = true, this.createPathProxy());
        var o = this.path;
        (i || this.__dirty & kx) && (o.beginPath(), this.buildPath(o, this.shape, false), this.pathUpdated()), e2 = o.getBoundingRect();
      }
      if (this._rect = e2, this.hasStroke() && this.path && this.path.len() > 0) {
        var s = this._rectStroke || (this._rectStroke = e2.clone());
        if (this.__dirty || a) {
          s.copy(e2);
          var u = n2.strokeNoScale ? this.getLineScale() : 1, l2 = n2.lineWidth;
          if (!this.hasFill()) {
            var c2 = this.strokeContainThreshold;
            l2 = Math.max(l2, c2 == null ? 4 : c2);
          }
          u > 1e-10 && (s.width += l2 / u, s.height += l2 / u, s.x -= l2 / u / 2, s.y -= l2 / u / 2);
        }
        return s;
      }
      return e2;
    }, t2.prototype.contain = function(e2, n2) {
      var a = this.transformCoordToLocal(e2, n2), i = this.getBoundingRect(), o = this.style;
      if (e2 = a[0], n2 = a[1], i.contain(e2, n2)) {
        var s = this.path;
        if (this.hasStroke()) {
          var u = o.lineWidth, l2 = o.strokeNoScale ? this.getLineScale() : 1;
          if (l2 > 1e-10 && (this.hasFill() || (u = Math.max(u, this.strokeContainThreshold)), qoe(s, u / l2, e2, n2)))
            return true;
        }
        if (this.hasFill())
          return Hoe(s, e2, n2);
      }
      return false;
    }, t2.prototype.dirtyShape = function() {
      this.__dirty |= kx, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
    }, t2.prototype.dirty = function() {
      this.dirtyStyle(), this.dirtyShape();
    }, t2.prototype.animateShape = function(e2) {
      return this.animate("shape", e2);
    }, t2.prototype.updateDuringAnimation = function(e2) {
      e2 === "style" ? this.dirtyStyle() : e2 === "shape" ? this.dirtyShape() : this.markRedraw();
    }, t2.prototype.attrKV = function(e2, n2) {
      e2 === "shape" ? this.setShape(n2) : r2.prototype.attrKV.call(this, e2, n2);
    }, t2.prototype.setShape = function(e2, n2) {
      var a = this.shape;
      return a || (a = this.shape = {}), typeof e2 == "string" ? a[e2] = n2 : qt(a, e2), this.dirtyShape(), this;
    }, t2.prototype.shapeChanged = function() {
      return !!(this.__dirty & kx);
    }, t2.prototype.createStyle = function(e2) {
      return WP(J5, e2);
    }, t2.prototype._innerSaveToNormal = function(e2) {
      r2.prototype._innerSaveToNormal.call(this, e2);
      var n2 = this._normalState;
      e2.shape && !n2.shape && (n2.shape = qt({}, this.shape));
    }, t2.prototype._applyStateObj = function(e2, n2, a, i, o, s) {
      r2.prototype._applyStateObj.call(this, e2, n2, a, i, o, s);
      var u = !(n2 && i), l2;
      if (n2 && n2.shape ? o ? i ? l2 = n2.shape : (l2 = qt({}, a.shape), qt(l2, n2.shape)) : (l2 = qt({}, i ? this.shape : a.shape), qt(l2, n2.shape)) : u && (l2 = a.shape), l2)
        if (o) {
          this.shape = qt({}, this.shape);
          for (var c2 = {}, f2 = ja(l2), h = 0; h < f2.length; h++) {
            var v9 = f2[h];
            typeof l2[v9] == "object" ? this.shape[v9] = l2[v9] : c2[v9] = l2[v9];
          }
          this._transitionState(e2, { shape: c2 }, s);
        } else
          this.shape = l2, this.dirtyShape();
    }, t2.prototype._mergeStates = function(e2) {
      for (var n2 = r2.prototype._mergeStates.call(this, e2), a, i = 0; i < e2.length; i++) {
        var o = e2[i];
        o.shape && (a = a || {}, this._mergeStyle(a, o.shape));
      }
      return a && (n2.shape = a), n2;
    }, t2.prototype.getAnimationStyleProps = function() {
      return Yoe;
    }, t2.prototype.isZeroArea = function() {
      return false;
    }, t2.extend = function(e2) {
      var n2 = function(i) {
        ot(o, i);
        function o(s) {
          var u = i.call(this, s) || this;
          return e2.init && e2.init.call(u, s), u;
        }
        return o.prototype.getDefaultStyle = function() {
          return On(e2.style);
        }, o.prototype.getDefaultShape = function() {
          return On(e2.shape);
        }, o;
      }(t2);
      for (var a in e2)
        typeof e2[a] == "function" && (n2.prototype[a] = e2[a]);
      return n2;
    }, t2.initDefaultProps = function() {
      var e2 = t2.prototype;
      e2.type = "path", e2.strokeContainThreshold = 5, e2.segmentIgnoreThreshold = 0, e2.subPixelOptimize = false, e2.autoBatch = false, e2.__dirty = Kf | mC | kx;
    }(), t2;
  }(qh), xa = Koe, Zoe = En({ strokeFirst: true, font: gy, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, J5), tU = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.hasStroke = function() {
      var e2 = this.style, n2 = e2.stroke;
      return n2 != null && n2 !== "none" && e2.lineWidth > 0;
    }, t2.prototype.hasFill = function() {
      var e2 = this.style, n2 = e2.fill;
      return n2 != null && n2 !== "none";
    }, t2.prototype.createStyle = function(e2) {
      return WP(Zoe, e2);
    }, t2.prototype.setBoundingRect = function(e2) {
      this._rect = e2;
    }, t2.prototype.getBoundingRect = function() {
      var e2 = this.style;
      if (!this._rect) {
        var n2 = e2.text;
        n2 != null ? n2 += "" : n2 = "";
        var a = PE(n2, e2.font, e2.textAlign, e2.textBaseline);
        if (a.x += e2.x || 0, a.y += e2.y || 0, this.hasStroke()) {
          var i = e2.lineWidth;
          a.x -= i / 2, a.y -= i / 2, a.width += i, a.height += i;
        }
        this._rect = a;
      }
      return this._rect;
    }, t2.initDefaultProps = function() {
      var e2 = t2.prototype;
      e2.dirtyRectTolerance = 10;
    }(), t2;
  }(qh);
  tU.prototype.type = "tspan";
  var tE = tU, Xoe = En({ x: 0, y: 0 }, Ub), Joe = { style: En({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, ZP.style) };
  function Qoe(r2) {
    return !!(r2 && typeof r2 != "string" && r2.width && r2.height);
  }
  var rU = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.createStyle = function(e2) {
      return WP(Xoe, e2);
    }, t2.prototype._getSize = function(e2) {
      var n2 = this.style, a = n2[e2];
      if (a != null)
        return a;
      var i = Qoe(n2.image) ? n2.image : this.__image;
      if (!i)
        return 0;
      var o = e2 === "width" ? "height" : "width", s = n2[o];
      return s == null ? i[e2] : i[e2] / i[o] * s;
    }, t2.prototype.getWidth = function() {
      return this._getSize("width");
    }, t2.prototype.getHeight = function() {
      return this._getSize("height");
    }, t2.prototype.getAnimationStyleProps = function() {
      return Joe;
    }, t2.prototype.getBoundingRect = function() {
      var e2 = this.style;
      return this._rect || (this._rect = new da(e2.x || 0, e2.y || 0, this.getWidth(), this.getHeight())), this._rect;
    }, t2;
  }(qh);
  rU.prototype.type = "image";
  var Bl = rU;
  function ese(r2, t2) {
    var e2 = t2.x, n2 = t2.y, a = t2.width, i = t2.height, o = t2.r, s, u, l2, c2;
    a < 0 && (e2 = e2 + a, a = -a), i < 0 && (n2 = n2 + i, i = -i), typeof o == "number" ? s = u = l2 = c2 = o : o instanceof Array ? o.length === 1 ? s = u = l2 = c2 = o[0] : o.length === 2 ? (s = l2 = o[0], u = c2 = o[1]) : o.length === 3 ? (s = o[0], u = c2 = o[1], l2 = o[2]) : (s = o[0], u = o[1], l2 = o[2], c2 = o[3]) : s = u = l2 = c2 = 0;
    var f2;
    s + u > a && (f2 = s + u, s *= a / f2, u *= a / f2), l2 + c2 > a && (f2 = l2 + c2, l2 *= a / f2, c2 *= a / f2), u + l2 > i && (f2 = u + l2, u *= i / f2, l2 *= i / f2), s + c2 > i && (f2 = s + c2, s *= i / f2, c2 *= i / f2), r2.moveTo(e2 + s, n2), r2.lineTo(e2 + a - u, n2), u !== 0 && r2.arc(e2 + a - u, n2 + u, u, -Math.PI / 2, 0), r2.lineTo(e2 + a, n2 + i - l2), l2 !== 0 && r2.arc(e2 + a - l2, n2 + i - l2, l2, 0, Math.PI / 2), r2.lineTo(e2 + c2, n2 + i), c2 !== 0 && r2.arc(e2 + c2, n2 + i - c2, c2, Math.PI / 2, Math.PI), r2.lineTo(e2, n2 + s), s !== 0 && r2.arc(e2 + s, n2 + s, s, Math.PI, Math.PI * 1.5);
  }
  var zx = Math.round;
  function nU(r2, t2, e2) {
    if (!!t2) {
      var n2 = t2.x1, a = t2.x2, i = t2.y1, o = t2.y2;
      r2.x1 = n2, r2.x2 = a, r2.y1 = i, r2.y2 = o;
      var s = e2 && e2.lineWidth;
      return s && (zx(n2 * 2) === zx(a * 2) && (r2.x1 = r2.x2 = jb(n2, s, true)), zx(i * 2) === zx(o * 2) && (r2.y1 = r2.y2 = jb(i, s, true))), r2;
    }
  }
  function aU(r2, t2, e2) {
    if (!!t2) {
      var n2 = t2.x, a = t2.y, i = t2.width, o = t2.height;
      r2.x = n2, r2.y = a, r2.width = i, r2.height = o;
      var s = e2 && e2.lineWidth;
      return s && (r2.x = jb(n2, s, true), r2.y = jb(a, s, true), r2.width = Math.max(jb(n2 + i, s, false) - r2.x, i === 0 ? 0 : 1), r2.height = Math.max(jb(a + o, s, false) - r2.y, o === 0 ? 0 : 1)), r2;
    }
  }
  function jb(r2, t2, e2) {
    if (!t2)
      return r2;
    var n2 = zx(r2 * 2);
    return (n2 + zx(t2)) % 2 === 0 ? n2 / 2 : (n2 + (e2 ? 1 : -1)) / 2;
  }
  var tse = function() {
    function r2() {
      this.x = 0, this.y = 0, this.width = 0, this.height = 0;
    }
    return r2;
  }(), rse = {}, iU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new tse();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a, i, o, s;
      if (this.subPixelOptimize) {
        var u = aU(rse, n2, this.style);
        a = u.x, i = u.y, o = u.width, s = u.height, u.r = n2.r, n2 = u;
      } else
        a = n2.x, i = n2.y, o = n2.width, s = n2.height;
      n2.r ? ese(e2, n2) : e2.rect(a, i, o, s);
    }, t2.prototype.isZeroArea = function() {
      return !this.shape.width || !this.shape.height;
    }, t2;
  }(xa);
  iU.prototype.type = "rect";
  var ni = iU, i7 = { fill: "#000" }, o7 = 2, nse = { style: En({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, ZP.style) }, oU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      return n2.type = "text", n2._children = [], n2._defaultStyle = i7, n2.attr(e2), n2;
    }
    return t2.prototype.childrenRef = function() {
      return this._children;
    }, t2.prototype.update = function() {
      r2.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
      for (var e2 = 0; e2 < this._children.length; e2++) {
        var n2 = this._children[e2];
        n2.zlevel = this.zlevel, n2.z = this.z, n2.z2 = this.z2, n2.culling = this.culling, n2.cursor = this.cursor, n2.invisible = this.invisible;
      }
    }, t2.prototype.updateTransform = function() {
      var e2 = this.innerTransformable;
      e2 ? (e2.updateTransform(), e2.transform && (this.transform = e2.transform)) : r2.prototype.updateTransform.call(this);
    }, t2.prototype.getLocalTransform = function(e2) {
      var n2 = this.innerTransformable;
      return n2 ? n2.getLocalTransform(e2) : r2.prototype.getLocalTransform.call(this, e2);
    }, t2.prototype.getComputedTransform = function() {
      return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), r2.prototype.getComputedTransform.call(this);
    }, t2.prototype._updateSubTexts = function() {
      this._childCursor = 0, ose(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
    }, t2.prototype.addSelfToZr = function(e2) {
      r2.prototype.addSelfToZr.call(this, e2);
      for (var n2 = 0; n2 < this._children.length; n2++)
        this._children[n2].__zr = e2;
    }, t2.prototype.removeSelfFromZr = function(e2) {
      r2.prototype.removeSelfFromZr.call(this, e2);
      for (var n2 = 0; n2 < this._children.length; n2++)
        this._children[n2].__zr = null;
    }, t2.prototype.getBoundingRect = function() {
      if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
        for (var e2 = new da(0, 0, 0, 0), n2 = this._children, a = [], i = null, o = 0; o < n2.length; o++) {
          var s = n2[o], u = s.getBoundingRect(), l2 = s.getLocalTransform(a);
          l2 ? (e2.copy(u), e2.applyTransform(l2), i = i || e2.clone(), i.union(e2)) : (i = i || u.clone(), i.union(u));
        }
        this._rect = i || e2;
      }
      return this._rect;
    }, t2.prototype.setDefaultTextStyle = function(e2) {
      this._defaultStyle = e2 || i7;
    }, t2.prototype.setTextContent = function(e2) {
    }, t2.prototype._mergeStyle = function(e2, n2) {
      if (!n2)
        return e2;
      var a = n2.rich, i = e2.rich || a && {};
      return qt(e2, n2), a && i ? (this._mergeRich(i, a), e2.rich = i) : i && (e2.rich = i), e2;
    }, t2.prototype._mergeRich = function(e2, n2) {
      for (var a = ja(n2), i = 0; i < a.length; i++) {
        var o = a[i];
        e2[o] = e2[o] || {}, qt(e2[o], n2[o]);
      }
    }, t2.prototype.getAnimationStyleProps = function() {
      return nse;
    }, t2.prototype._getOrCreateChild = function(e2) {
      var n2 = this._children[this._childCursor];
      return (!n2 || !(n2 instanceof e2)) && (n2 = new e2()), this._children[this._childCursor++] = n2, n2.__zr = this.__zr, n2.parent = this, n2;
    }, t2.prototype._updatePlainTexts = function() {
      var e2 = this.style, n2 = e2.font || gy, a = e2.padding, i = v7(e2), o = Soe(i, e2), s = PO(e2), u = !!e2.backgroundColor, l2 = o.outerHeight, c2 = o.outerWidth, f2 = o.contentWidth, h = o.lines, v9 = o.lineHeight, d2 = this._defaultStyle, m2 = e2.x || 0, b2 = e2.y || 0, _ = e2.align || d2.align || "left", C = e2.verticalAlign || d2.verticalAlign || "top", M = m2, E = Rx(b2, o.contentHeight, C);
      if (s || a) {
        var z9 = _C(m2, c2, _), V = Rx(b2, l2, C);
        s && this._renderBackground(e2, e2, z9, V, c2, l2);
      }
      E += v9 / 2, a && (M = h7(m2, _, a), C === "top" ? E += a[0] : C === "bottom" && (E -= a[2]));
      for (var $ = 0, U = false, H = f7("fill" in e2 ? e2.fill : (U = true, d2.fill)), q3 = c7("stroke" in e2 ? e2.stroke : !u && (!d2.autoStroke || U) ? ($ = o7, d2.stroke) : null), ee = e2.textShadowBlur > 0, oe = e2.width != null && (e2.overflow === "truncate" || e2.overflow === "break" || e2.overflow === "breakAll"), ne = o.calculatedLineHeight, be = 0; be < h.length; be++) {
        var Ee = this._getOrCreateChild(tE), ye = Ee.createStyle();
        Ee.useStyle(ye), ye.text = h[be], ye.x = M, ye.y = E, _ && (ye.textAlign = _), ye.textBaseline = "middle", ye.opacity = e2.opacity, ye.strokeFirst = true, ee && (ye.shadowBlur = e2.textShadowBlur || 0, ye.shadowColor = e2.textShadowColor || "transparent", ye.shadowOffsetX = e2.textShadowOffsetX || 0, ye.shadowOffsetY = e2.textShadowOffsetY || 0), ye.stroke = q3, ye.fill = H, q3 && (ye.lineWidth = e2.lineWidth || $, ye.lineDash = e2.lineDash, ye.lineDashOffset = e2.lineDashOffset || 0), ye.font = n2, u7(ye, e2), E += v9, oe && Ee.setBoundingRect(new da(_C(ye.x, e2.width, ye.textAlign), Rx(ye.y, ne, ye.textBaseline), f2, ne));
      }
    }, t2.prototype._updateRichTexts = function() {
      var e2 = this.style, n2 = v7(e2), a = Aoe(n2, e2), i = a.width, o = a.outerWidth, s = a.outerHeight, u = e2.padding, l2 = e2.x || 0, c2 = e2.y || 0, f2 = this._defaultStyle, h = e2.align || f2.align, v9 = e2.verticalAlign || f2.verticalAlign, d2 = _C(l2, o, h), m2 = Rx(c2, s, v9), b2 = d2, _ = m2;
      u && (b2 += u[3], _ += u[0]);
      var C = b2 + i;
      PO(e2) && this._renderBackground(e2, e2, d2, m2, o, s);
      for (var M = !!e2.backgroundColor, E = 0; E < a.lines.length; E++) {
        for (var z9 = a.lines[E], V = z9.tokens, $ = V.length, U = z9.lineHeight, H = z9.width, q3 = 0, ee = b2, oe = C, ne = $ - 1, be = void 0; q3 < $ && (be = V[q3], !be.align || be.align === "left"); )
          this._placeToken(be, e2, U, _, ee, "left", M), H -= be.width, ee += be.width, q3++;
        for (; ne >= 0 && (be = V[ne], be.align === "right"); )
          this._placeToken(be, e2, U, _, oe, "right", M), H -= be.width, oe -= be.width, ne--;
        for (ee += (i - (ee - b2) - (C - oe) - H) / 2; q3 <= ne; )
          be = V[q3], this._placeToken(be, e2, U, _, ee + be.width / 2, "center", M), ee += be.width, q3++;
        _ += U;
      }
    }, t2.prototype._placeToken = function(e2, n2, a, i, o, s, u) {
      var l2 = n2.rich[e2.styleName] || {};
      l2.text = e2.text;
      var c2 = e2.verticalAlign, f2 = i + a / 2;
      c2 === "top" ? f2 = i + e2.height / 2 : c2 === "bottom" && (f2 = i + a - e2.height / 2);
      var h = !e2.isLineHolder && PO(l2);
      h && this._renderBackground(l2, n2, s === "right" ? o - e2.width : s === "center" ? o - e2.width / 2 : o, f2 - e2.height / 2, e2.width, e2.height);
      var v9 = !!l2.backgroundColor, d2 = e2.textPadding;
      d2 && (o = h7(o, s, d2), f2 -= e2.height / 2 - d2[0] - e2.innerHeight / 2);
      var m2 = this._getOrCreateChild(tE), b2 = m2.createStyle();
      m2.useStyle(b2);
      var _ = this._defaultStyle, C = false, M = 0, E = f7("fill" in l2 ? l2.fill : "fill" in n2 ? n2.fill : (C = true, _.fill)), z9 = c7("stroke" in l2 ? l2.stroke : "stroke" in n2 ? n2.stroke : !v9 && !u && (!_.autoStroke || C) ? (M = o7, _.stroke) : null), V = l2.textShadowBlur > 0 || n2.textShadowBlur > 0;
      b2.text = e2.text, b2.x = o, b2.y = f2, V && (b2.shadowBlur = l2.textShadowBlur || n2.textShadowBlur || 0, b2.shadowColor = l2.textShadowColor || n2.textShadowColor || "transparent", b2.shadowOffsetX = l2.textShadowOffsetX || n2.textShadowOffsetX || 0, b2.shadowOffsetY = l2.textShadowOffsetY || n2.textShadowOffsetY || 0), b2.textAlign = s, b2.textBaseline = "middle", b2.font = e2.font || gy, b2.opacity = _g(l2.opacity, n2.opacity, 1), u7(b2, l2), z9 && (b2.lineWidth = _g(l2.lineWidth, n2.lineWidth, M), b2.lineDash = ia(l2.lineDash, n2.lineDash), b2.lineDashOffset = n2.lineDashOffset || 0, b2.stroke = z9), E && (b2.fill = E);
      var $ = e2.contentWidth, U = e2.contentHeight;
      m2.setBoundingRect(new da(_C(b2.x, $, b2.textAlign), Rx(b2.y, U, b2.textBaseline), $, U));
    }, t2.prototype._renderBackground = function(e2, n2, a, i, o, s) {
      var u = e2.backgroundColor, l2 = e2.borderWidth, c2 = e2.borderColor, f2 = u && u.image, h = u && !f2, v9 = e2.borderRadius, d2 = this, m2, b2;
      if (h || e2.lineHeight || l2 && c2) {
        m2 = this._getOrCreateChild(ni), m2.useStyle(m2.createStyle()), m2.style.fill = null;
        var _ = m2.shape;
        _.x = a, _.y = i, _.width = o, _.height = s, _.r = v9, m2.dirtyShape();
      }
      if (h) {
        var C = m2.style;
        C.fill = u || null, C.fillOpacity = ia(e2.fillOpacity, 1);
      } else if (f2) {
        b2 = this._getOrCreateChild(Bl), b2.onload = function() {
          d2.dirtyStyle();
        };
        var M = b2.style;
        M.image = u.image, M.x = a, M.y = i, M.width = o, M.height = s;
      }
      if (l2 && c2) {
        var C = m2.style;
        C.lineWidth = l2, C.stroke = c2, C.strokeOpacity = ia(e2.strokeOpacity, 1), C.lineDash = e2.borderDash, C.lineDashOffset = e2.borderDashOffset || 0, m2.strokeContainThreshold = 0, m2.hasFill() && m2.hasStroke() && (C.strokeFirst = true, C.lineWidth *= 2);
      }
      var E = (m2 || b2).style;
      E.shadowBlur = e2.shadowBlur || 0, E.shadowColor = e2.shadowColor || "transparent", E.shadowOffsetX = e2.shadowOffsetX || 0, E.shadowOffsetY = e2.shadowOffsetY || 0, E.opacity = _g(e2.opacity, n2.opacity, 1);
    }, t2.makeFont = function(e2) {
      var n2 = "";
      return uU(e2) && (n2 = [e2.fontStyle, e2.fontWeight, sU(e2.fontSize), e2.fontFamily || "sans-serif"].join(" ")), n2 && jv(n2) || e2.textFont || e2.font;
    }, t2;
  }(qh), ase = { left: true, right: 1, center: 1 }, ise = { top: 1, bottom: 1, middle: 1 }, s7 = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
  function sU(r2) {
    return typeof r2 == "string" && (r2.indexOf("px") !== -1 || r2.indexOf("rem") !== -1 || r2.indexOf("em") !== -1) ? r2 : isNaN(+r2) ? O6 + "px" : r2 + "px";
  }
  function u7(r2, t2) {
    for (var e2 = 0; e2 < s7.length; e2++) {
      var n2 = s7[e2], a = t2[n2];
      a != null && (r2[n2] = a);
    }
  }
  function uU(r2) {
    return r2.fontSize != null || r2.fontFamily || r2.fontWeight;
  }
  function ose(r2) {
    return l7(r2), ae(r2.rich, l7), r2;
  }
  function l7(r2) {
    if (r2) {
      r2.font = oU.makeFont(r2);
      var t2 = r2.align;
      t2 === "middle" && (t2 = "center"), r2.align = t2 == null || ase[t2] ? t2 : "left";
      var e2 = r2.verticalAlign;
      e2 === "center" && (e2 = "middle"), r2.verticalAlign = e2 == null || ise[e2] ? e2 : "top";
      var n2 = r2.padding;
      n2 && (r2.padding = j6(r2.padding));
    }
  }
  function c7(r2, t2) {
    return r2 == null || t2 <= 0 || r2 === "transparent" || r2 === "none" ? null : r2.image || r2.colorStops ? "#000" : r2;
  }
  function f7(r2) {
    return r2 == null || r2 === "none" ? null : r2.image || r2.colorStops ? "#000" : r2;
  }
  function h7(r2, t2, e2) {
    return t2 === "right" ? r2 - e2[1] : t2 === "center" ? r2 + e2[3] / 2 - e2[1] / 2 : r2 + e2[3];
  }
  function v7(r2) {
    var t2 = r2.text;
    return t2 != null && (t2 += ""), t2;
  }
  function PO(r2) {
    return !!(r2.backgroundColor || r2.lineHeight || r2.borderWidth && r2.borderColor);
  }
  var xi = oU, zn = fi(), n4 = function(r2, t2, e2, n2) {
    if (n2) {
      var a = zn(n2);
      a.dataIndex = e2, a.dataType = t2, a.seriesIndex = r2, n2.type === "group" && n2.traverse(function(i) {
        var o = zn(i);
        o.seriesIndex = r2, o.dataIndex = e2, o.dataType = t2;
      });
    }
  }, d7 = 1, p7 = {}, lU = fi(), X6 = fi(), J6 = 0, IE = 1, JP = 2, Nc = ["emphasis", "blur", "select"], rE = ["normal", "emphasis", "blur", "select"], vw = 10, sse = 9, Hb = "highlight", P5 = "downplay", FC = "select", D5 = "unselect", NC = "toggleSelect";
  function px(r2) {
    return r2 != null && r2 !== "none";
  }
  var g7 = new ME(100);
  function y7(r2) {
    if (Zr(r2)) {
      var t2 = g7.get(r2);
      return t2 || (t2 = GR(r2, -0.1), g7.put(r2, t2)), t2;
    } else if (GP(r2)) {
      var e2 = qt({}, r2);
      return e2.colorStops = pr(r2.colorStops, function(n2) {
        return { offset: n2.offset, color: GR(n2.color, -0.1) };
      }), e2;
    }
    return r2;
  }
  function QP(r2, t2, e2) {
    r2.onHoverStateChange && (r2.hoverState || 0) !== e2 && r2.onHoverStateChange(t2), r2.hoverState = e2;
  }
  function cU(r2) {
    QP(r2, "emphasis", JP);
  }
  function fU(r2) {
    r2.hoverState === JP && QP(r2, "normal", J6);
  }
  function Q6(r2) {
    QP(r2, "blur", IE);
  }
  function hU(r2) {
    r2.hoverState === IE && QP(r2, "normal", J6);
  }
  function use2(r2) {
    r2.selected = true;
  }
  function lse(r2) {
    r2.selected = false;
  }
  function m7(r2, t2, e2) {
    t2(r2, e2);
  }
  function Og(r2, t2, e2) {
    m7(r2, t2, e2), r2.isGroup && r2.traverse(function(n2) {
      m7(n2, t2, e2);
    });
  }
  function Q5(r2, t2) {
    switch (t2) {
      case "emphasis":
        r2.hoverState = JP;
        break;
      case "normal":
        r2.hoverState = J6;
        break;
      case "blur":
        r2.hoverState = IE;
        break;
      case "select":
        r2.selected = true;
    }
  }
  function cse(r2, t2, e2, n2) {
    for (var a = r2.style, i = {}, o = 0; o < t2.length; o++) {
      var s = t2[o], u = a[s];
      i[s] = u == null ? n2 && n2[s] : u;
    }
    for (var o = 0; o < r2.animators.length; o++) {
      var l2 = r2.animators[o];
      l2.__fromStateTransition && l2.__fromStateTransition.indexOf(e2) < 0 && l2.targetName === "style" && l2.saveTo(i, t2);
    }
    return i;
  }
  function fse(r2, t2, e2, n2) {
    var a = e2 && va(e2, "select") >= 0, i = false;
    if (r2 instanceof xa) {
      var o = lU(r2), s = a && o.selectFill || o.normalFill, u = a && o.selectStroke || o.normalStroke;
      if (px(s) || px(u)) {
        n2 = n2 || {};
        var l2 = n2.style || {};
        l2.fill === "inherit" ? (i = true, n2 = qt({}, n2), l2 = qt({}, l2), l2.fill = s) : !px(l2.fill) && px(s) ? (i = true, n2 = qt({}, n2), l2 = qt({}, l2), l2.fill = y7(s)) : !px(l2.stroke) && px(u) && (i || (n2 = qt({}, n2), l2 = qt({}, l2)), l2.stroke = y7(u)), n2.style = l2;
      }
    }
    if (n2 && n2.z2 == null) {
      i || (n2 = qt({}, n2));
      var c2 = r2.z2EmphasisLift;
      n2.z2 = r2.z2 + (c2 != null ? c2 : vw);
    }
    return n2;
  }
  function hse(r2, t2, e2) {
    if (e2 && e2.z2 == null) {
      e2 = qt({}, e2);
      var n2 = r2.z2SelectLift;
      e2.z2 = r2.z2 + (n2 != null ? n2 : sse);
    }
    return e2;
  }
  function vse(r2, t2, e2) {
    var n2 = va(r2.currentStates, t2) >= 0, a = r2.style.opacity, i = n2 ? null : cse(r2, ["opacity"], t2, { opacity: 1 });
    e2 = e2 || {};
    var o = e2.style || {};
    return o.opacity == null && (e2 = qt({}, e2), o = qt({ opacity: n2 ? a : i.opacity * 0.1 }, o), e2.style = o), e2;
  }
  function DO(r2, t2) {
    var e2 = this.states[r2];
    if (this.style) {
      if (r2 === "emphasis")
        return fse(this, r2, t2, e2);
      if (r2 === "blur")
        return vse(this, r2, e2);
      if (r2 === "select")
        return hse(this, r2, e2);
    }
    return e2;
  }
  function r1(r2) {
    r2.stateProxy = DO;
    var t2 = r2.getTextContent(), e2 = r2.getTextGuideLine();
    t2 && (t2.stateProxy = DO), e2 && (e2.stateProxy = DO);
  }
  function b7(r2, t2) {
    !yU(r2, t2) && !r2.__highByOuter && Og(r2, cU);
  }
  function _7(r2, t2) {
    !yU(r2, t2) && !r2.__highByOuter && Og(r2, fU);
  }
  function Kd(r2, t2) {
    r2.__highByOuter |= 1 << (t2 || 0), Og(r2, cU);
  }
  function Zd(r2, t2) {
    !(r2.__highByOuter &= ~(1 << (t2 || 0))) && Og(r2, fU);
  }
  function vU(r2) {
    Og(r2, Q6);
  }
  function dU(r2) {
    Og(r2, hU);
  }
  function pU(r2) {
    Og(r2, use2);
  }
  function gU(r2) {
    Og(r2, lse);
  }
  function yU(r2, t2) {
    return r2.__highDownSilentOnTouch && t2.zrByTouch;
  }
  function mU(r2) {
    var t2 = r2.getModel();
    t2.eachComponent(function(e2, n2) {
      var a = X6(n2);
      if (a.isBlured) {
        var i = e2 === "series" ? r2.getViewOfSeriesModel(n2) : r2.getViewOfComponentModel(n2);
        i.group.traverse(function(o) {
          hU(o);
        });
      }
      a.isBlured = false;
    });
  }
  function a4(r2, t2, e2, n2) {
    var a = n2.getModel();
    e2 = e2 || "coordinateSystem";
    function i(l2, c2) {
      for (var f2 = 0; f2 < c2.length; f2++) {
        var h = l2.getItemGraphicEl(c2[f2]);
        h && dU(h);
      }
    }
    if (r2 != null && !(!t2 || t2 === "none")) {
      var o = a.getSeriesByIndex(r2), s = o.coordinateSystem;
      s && s.master && (s = s.master);
      var u = [];
      a.eachSeries(function(l2) {
        var c2 = o === l2, f2 = l2.coordinateSystem;
        f2 && f2.master && (f2 = f2.master);
        var h = f2 && s ? f2 === s : c2;
        if (!(e2 === "series" && !c2 || e2 === "coordinateSystem" && !h || t2 === "series" && c2)) {
          var v9 = n2.getViewOfSeriesModel(l2);
          if (v9.group.traverse(function(b2) {
            Q6(b2);
          }), lc(t2))
            i(l2.getData(), t2);
          else if (Tn(t2))
            for (var d2 = ja(t2), m2 = 0; m2 < d2.length; m2++)
              i(l2.getData(d2[m2]), t2[d2[m2]]);
          u.push(l2), X6(l2).isBlured = true;
        }
      }), a.eachComponent(function(l2, c2) {
        if (l2 !== "series") {
          var f2 = n2.getViewOfComponentModel(c2);
          f2 && f2.blurSeries && f2.blurSeries(u, a);
        }
      });
    }
  }
  function i4(r2, t2, e2) {
    if (!(r2 == null || t2 == null)) {
      var n2 = e2.getModel().getComponent(r2, t2);
      if (!!n2) {
        X6(n2).isBlured = true;
        var a = e2.getViewOfComponentModel(n2);
        !a || !a.focusBlurEnabled || a.group.traverse(function(i) {
          Q6(i);
        });
      }
    }
  }
  function dse(r2, t2, e2) {
    var n2 = r2.seriesIndex, a = r2.getData(t2.dataType);
    if (!!a) {
      var i = e1(a, t2);
      i = (vr(i) ? i[0] : i) || 0;
      var o = a.getItemGraphicEl(i);
      if (!o)
        for (var s = a.count(), u = 0; !o && u < s; )
          o = a.getItemGraphicEl(u++);
      if (o) {
        var l2 = zn(o);
        a4(n2, l2.focus, l2.blurScope, e2);
      } else {
        var c2 = r2.get(["emphasis", "focus"]), f2 = r2.get(["emphasis", "blurScope"]);
        c2 != null && a4(n2, c2, f2, e2);
      }
    }
  }
  function eF(r2, t2, e2, n2) {
    var a = { focusSelf: false, dispatchers: null };
    if (r2 == null || r2 === "series" || t2 == null || e2 == null)
      return a;
    var i = n2.getModel().getComponent(r2, t2);
    if (!i)
      return a;
    var o = n2.getViewOfComponentModel(i);
    if (!o || !o.findHighDownDispatchers)
      return a;
    for (var s = o.findHighDownDispatchers(e2), u, l2 = 0; l2 < s.length; l2++)
      if (zn(s[l2]).focus === "self") {
        u = true;
        break;
      }
    return { focusSelf: u, dispatchers: s };
  }
  function pse(r2, t2, e2) {
    var n2 = zn(r2), a = eF(n2.componentMainType, n2.componentIndex, n2.componentHighDownName, e2), i = a.dispatchers, o = a.focusSelf;
    i ? (o && i4(n2.componentMainType, n2.componentIndex, e2), ae(i, function(s) {
      return b7(s, t2);
    })) : (a4(n2.seriesIndex, n2.focus, n2.blurScope, e2), n2.focus === "self" && i4(n2.componentMainType, n2.componentIndex, e2), b7(r2, t2));
  }
  function gse(r2, t2, e2) {
    mU(e2);
    var n2 = zn(r2), a = eF(n2.componentMainType, n2.componentIndex, n2.componentHighDownName, e2).dispatchers;
    a ? ae(a, function(i) {
      return _7(i, t2);
    }) : _7(r2, t2);
  }
  function yse(r2, t2, e2) {
    if (!!s4(t2)) {
      var n2 = t2.dataType, a = r2.getData(n2), i = e1(a, t2);
      vr(i) || (i = [i]), r2[t2.type === NC ? "toggleSelect" : t2.type === FC ? "select" : "unselect"](i, n2);
    }
  }
  function x7(r2) {
    var t2 = r2.getAllData();
    ae(t2, function(e2) {
      var n2 = e2.data, a = e2.type;
      n2.eachItemGraphicEl(function(i, o) {
        r2.isSelected(o, a) ? pU(i) : gU(i);
      });
    });
  }
  function mse(r2) {
    var t2 = [];
    return r2.eachSeries(function(e2) {
      var n2 = e2.getAllData();
      ae(n2, function(a) {
        a.data;
        var i = a.type, o = e2.getSelectedDataIndices();
        if (o.length > 0) {
          var s = { dataIndex: o, seriesIndex: e2.seriesIndex };
          i != null && (s.dataType = i), t2.push(s);
        }
      });
    }), t2;
  }
  function qb(r2, t2, e2) {
    Bb(r2, true), Og(r2, r1), o4(r2, t2, e2);
  }
  function bse(r2) {
    Bb(r2, false);
  }
  function ks(r2, t2, e2, n2) {
    n2 ? bse(r2) : qb(r2, t2, e2);
  }
  function o4(r2, t2, e2) {
    var n2 = zn(r2);
    t2 != null ? (n2.focus = t2, n2.blurScope = e2) : n2.focus && (n2.focus = null);
  }
  var w7 = ["emphasis", "blur", "select"], _se = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
  function jl(r2, t2, e2, n2) {
    e2 = e2 || "itemStyle";
    for (var a = 0; a < w7.length; a++) {
      var i = w7[a], o = t2.getModel([i, e2]), s = r2.ensureState(i);
      s.style = n2 ? n2(o) : o[_se[e2]]();
    }
  }
  function Bb(r2, t2) {
    var e2 = t2 === false, n2 = r2;
    r2.highDownSilentOnTouch && (n2.__highDownSilentOnTouch = r2.highDownSilentOnTouch), (!e2 || n2.__highDownDispatcher) && (n2.__highByOuter = n2.__highByOuter || 0, n2.__highDownDispatcher = !e2);
  }
  function nE(r2) {
    return !!(r2 && r2.__highDownDispatcher);
  }
  function xse(r2, t2, e2) {
    var n2 = zn(r2);
    n2.componentMainType = t2.mainType, n2.componentIndex = t2.componentIndex, n2.componentHighDownName = e2;
  }
  function wse(r2) {
    var t2 = p7[r2];
    return t2 == null && d7 <= 32 && (t2 = p7[r2] = d7++), t2;
  }
  function s4(r2) {
    var t2 = r2.type;
    return t2 === FC || t2 === D5 || t2 === NC;
  }
  function S7(r2) {
    var t2 = r2.type;
    return t2 === Hb || t2 === P5;
  }
  function Sse(r2) {
    var t2 = lU(r2);
    t2.normalFill = r2.style.fill, t2.normalStroke = r2.style.stroke;
    var e2 = r2.states.select || {};
    t2.selectFill = e2.style && e2.style.fill || null, t2.selectStroke = e2.style && e2.style.stroke || null;
  }
  var gx = np.CMD, Cse = [[], [], []], C7 = Math.sqrt, Ese = Math.atan2;
  function bU(r2, t2) {
    if (!!t2) {
      var e2 = r2.data, n2 = r2.len(), a, i, o, s, u, l2, c2 = gx.M, f2 = gx.C, h = gx.L, v9 = gx.R, d2 = gx.A, m2 = gx.Q;
      for (o = 0, s = 0; o < n2; ) {
        switch (a = e2[o++], s = o, i = 0, a) {
          case c2:
            i = 1;
            break;
          case h:
            i = 1;
            break;
          case f2:
            i = 3;
            break;
          case m2:
            i = 2;
            break;
          case d2:
            var b2 = t2[4], _ = t2[5], C = C7(t2[0] * t2[0] + t2[1] * t2[1]), M = C7(t2[2] * t2[2] + t2[3] * t2[3]), E = Ese(-t2[1] / M, t2[0] / C);
            e2[o] *= C, e2[o++] += b2, e2[o] *= M, e2[o++] += _, e2[o++] *= C, e2[o++] *= M, e2[o++] += E, e2[o++] += E, o += 2, s = o;
            break;
          case v9:
            l2[0] = e2[o++], l2[1] = e2[o++], Nl(l2, l2, t2), e2[s++] = l2[0], e2[s++] = l2[1], l2[0] += e2[o++], l2[1] += e2[o++], Nl(l2, l2, t2), e2[s++] = l2[0], e2[s++] = l2[1];
        }
        for (u = 0; u < i; u++) {
          var z9 = Cse[u];
          z9[0] = e2[o++], z9[1] = e2[o++], Nl(z9, z9, t2), e2[s++] = z9[0], e2[s++] = z9[1];
        }
      }
      r2.increaseVersion();
    }
  }
  var IO = Math.sqrt, EM = Math.sin, AM = Math.cos, q2 = Math.PI;
  function E7(r2) {
    return Math.sqrt(r2[0] * r2[0] + r2[1] * r2[1]);
  }
  function u4(r2, t2) {
    return (r2[0] * t2[0] + r2[1] * t2[1]) / (E7(r2) * E7(t2));
  }
  function A7(r2, t2) {
    return (r2[0] * t2[1] < r2[1] * t2[0] ? -1 : 1) * Math.acos(u4(r2, t2));
  }
  function T7(r2, t2, e2, n2, a, i, o, s, u, l2, c2) {
    var f2 = u * (q2 / 180), h = AM(f2) * (r2 - e2) / 2 + EM(f2) * (t2 - n2) / 2, v9 = -1 * EM(f2) * (r2 - e2) / 2 + AM(f2) * (t2 - n2) / 2, d2 = h * h / (o * o) + v9 * v9 / (s * s);
    d2 > 1 && (o *= IO(d2), s *= IO(d2));
    var m2 = (a === i ? -1 : 1) * IO((o * o * (s * s) - o * o * (v9 * v9) - s * s * (h * h)) / (o * o * (v9 * v9) + s * s * (h * h))) || 0, b2 = m2 * o * v9 / s, _ = m2 * -s * h / o, C = (r2 + e2) / 2 + AM(f2) * b2 - EM(f2) * _, M = (t2 + n2) / 2 + EM(f2) * b2 + AM(f2) * _, E = A7([1, 0], [(h - b2) / o, (v9 - _) / s]), z9 = [(h - b2) / o, (v9 - _) / s], V = [(-1 * h - b2) / o, (-1 * v9 - _) / s], $ = A7(z9, V);
    if (u4(z9, V) <= -1 && ($ = q2), u4(z9, V) >= 1 && ($ = 0), $ < 0) {
      var U = Math.round($ / q2 * 1e6) / 1e6;
      $ = q2 * 2 + U % 2 * q2;
    }
    c2.addData(l2, C, M, o, s, E, $, f2, i);
  }
  var Ase = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, Tse = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function Mse(r2) {
    var t2 = new np();
    if (!r2)
      return t2;
    var e2 = 0, n2 = 0, a = e2, i = n2, o, s = np.CMD, u = r2.match(Ase);
    if (!u)
      return t2;
    for (var l2 = 0; l2 < u.length; l2++) {
      for (var c2 = u[l2], f2 = c2.charAt(0), h = void 0, v9 = c2.match(Tse) || [], d2 = v9.length, m2 = 0; m2 < d2; m2++)
        v9[m2] = parseFloat(v9[m2]);
      for (var b2 = 0; b2 < d2; ) {
        var _ = void 0, C = void 0, M = void 0, E = void 0, z9 = void 0, V = void 0, $ = void 0, U = e2, H = n2, q3 = void 0, ee = void 0;
        switch (f2) {
          case "l":
            e2 += v9[b2++], n2 += v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "L":
            e2 = v9[b2++], n2 = v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "m":
            e2 += v9[b2++], n2 += v9[b2++], h = s.M, t2.addData(h, e2, n2), a = e2, i = n2, f2 = "l";
            break;
          case "M":
            e2 = v9[b2++], n2 = v9[b2++], h = s.M, t2.addData(h, e2, n2), a = e2, i = n2, f2 = "L";
            break;
          case "h":
            e2 += v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "H":
            e2 = v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "v":
            n2 += v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "V":
            n2 = v9[b2++], h = s.L, t2.addData(h, e2, n2);
            break;
          case "C":
            h = s.C, t2.addData(h, v9[b2++], v9[b2++], v9[b2++], v9[b2++], v9[b2++], v9[b2++]), e2 = v9[b2 - 2], n2 = v9[b2 - 1];
            break;
          case "c":
            h = s.C, t2.addData(h, v9[b2++] + e2, v9[b2++] + n2, v9[b2++] + e2, v9[b2++] + n2, v9[b2++] + e2, v9[b2++] + n2), e2 += v9[b2 - 2], n2 += v9[b2 - 1];
            break;
          case "S":
            _ = e2, C = n2, q3 = t2.len(), ee = t2.data, o === s.C && (_ += e2 - ee[q3 - 4], C += n2 - ee[q3 - 3]), h = s.C, U = v9[b2++], H = v9[b2++], e2 = v9[b2++], n2 = v9[b2++], t2.addData(h, _, C, U, H, e2, n2);
            break;
          case "s":
            _ = e2, C = n2, q3 = t2.len(), ee = t2.data, o === s.C && (_ += e2 - ee[q3 - 4], C += n2 - ee[q3 - 3]), h = s.C, U = e2 + v9[b2++], H = n2 + v9[b2++], e2 += v9[b2++], n2 += v9[b2++], t2.addData(h, _, C, U, H, e2, n2);
            break;
          case "Q":
            U = v9[b2++], H = v9[b2++], e2 = v9[b2++], n2 = v9[b2++], h = s.Q, t2.addData(h, U, H, e2, n2);
            break;
          case "q":
            U = v9[b2++] + e2, H = v9[b2++] + n2, e2 += v9[b2++], n2 += v9[b2++], h = s.Q, t2.addData(h, U, H, e2, n2);
            break;
          case "T":
            _ = e2, C = n2, q3 = t2.len(), ee = t2.data, o === s.Q && (_ += e2 - ee[q3 - 4], C += n2 - ee[q3 - 3]), e2 = v9[b2++], n2 = v9[b2++], h = s.Q, t2.addData(h, _, C, e2, n2);
            break;
          case "t":
            _ = e2, C = n2, q3 = t2.len(), ee = t2.data, o === s.Q && (_ += e2 - ee[q3 - 4], C += n2 - ee[q3 - 3]), e2 += v9[b2++], n2 += v9[b2++], h = s.Q, t2.addData(h, _, C, e2, n2);
            break;
          case "A":
            M = v9[b2++], E = v9[b2++], z9 = v9[b2++], V = v9[b2++], $ = v9[b2++], U = e2, H = n2, e2 = v9[b2++], n2 = v9[b2++], h = s.A, T7(U, H, e2, n2, V, $, M, E, z9, h, t2);
            break;
          case "a":
            M = v9[b2++], E = v9[b2++], z9 = v9[b2++], V = v9[b2++], $ = v9[b2++], U = e2, H = n2, e2 += v9[b2++], n2 += v9[b2++], h = s.A, T7(U, H, e2, n2, V, $, M, E, z9, h, t2);
            break;
        }
      }
      (f2 === "z" || f2 === "Z") && (h = s.Z, t2.addData(h), e2 = a, n2 = i), o = h;
    }
    return t2.toStatic(), t2;
  }
  var _U = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.applyTransform = function(e2) {
    }, t2;
  }(xa);
  function xU(r2) {
    return r2.setData != null;
  }
  function wU(r2, t2) {
    var e2 = Mse(r2), n2 = qt({}, t2);
    return n2.buildPath = function(a) {
      if (xU(a)) {
        a.setData(e2.data);
        var i = a.getContext();
        i && a.rebuildPath(i, 1);
      } else {
        var i = a;
        e2.rebuildPath(i, 1);
      }
    }, n2.applyTransform = function(a) {
      bU(e2, a), this.dirtyShape();
    }, n2;
  }
  function SU(r2, t2) {
    return new _U(wU(r2, t2));
  }
  function Pse(r2, t2) {
    var e2 = wU(r2, t2), n2 = function(a) {
      ot(i, a);
      function i(o) {
        var s = a.call(this, o) || this;
        return s.applyTransform = e2.applyTransform, s.buildPath = e2.buildPath, s;
      }
      return i;
    }(_U);
    return n2;
  }
  function Dse(r2, t2) {
    for (var e2 = [], n2 = r2.length, a = 0; a < n2; a++) {
      var i = r2[a];
      e2.push(i.getUpdatedPathProxy(true));
    }
    var o = new xa(t2);
    return o.createPathProxy(), o.buildPath = function(s) {
      if (xU(s)) {
        s.appendPath(e2);
        var u = s.getContext();
        u && s.rebuildPath(u, 1);
      }
    }, o;
  }
  function tF(r2, t2) {
    t2 = t2 || {};
    var e2 = new xa();
    return r2.shape && e2.setShape(r2.shape), e2.setStyle(r2.style), t2.bakeTransform ? bU(e2.path, r2.getComputedTransform()) : t2.toLocal ? e2.setLocalTransform(r2.getComputedTransform()) : e2.copyTransform(r2), e2.buildPath = r2.buildPath, e2.applyTransform = e2.applyTransform, e2.z = r2.z, e2.z2 = r2.z2, e2.zlevel = r2.zlevel, e2;
  }
  var Ise = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.r = 0;
    }
    return r2;
  }(), CU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Ise();
    }, t2.prototype.buildPath = function(e2, n2) {
      e2.moveTo(n2.cx + n2.r, n2.cy), e2.arc(n2.cx, n2.cy, n2.r, 0, Math.PI * 2);
    }, t2;
  }(xa);
  CU.prototype.type = "circle";
  var ap = CU, Lse = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
    }
    return r2;
  }(), EU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Lse();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = 0.5522848, i = n2.cx, o = n2.cy, s = n2.rx, u = n2.ry, l2 = s * a, c2 = u * a;
      e2.moveTo(i - s, o), e2.bezierCurveTo(i - s, o - c2, i - l2, o - u, i, o - u), e2.bezierCurveTo(i + l2, o - u, i + s, o - c2, i + s, o), e2.bezierCurveTo(i + s, o + c2, i + l2, o + u, i, o + u), e2.bezierCurveTo(i - l2, o + u, i - s, o + c2, i - s, o), e2.closePath();
    }, t2;
  }(xa);
  EU.prototype.type = "ellipse";
  var rF = EU, AU = Math.PI, LO = AU * 2, vb = Math.sin, yx = Math.cos, Ose = Math.acos, ac = Math.atan2, M7 = Math.abs, VC = Math.sqrt, xC = Math.max, Vd = Math.min, kv = 1e-4;
  function kse(r2, t2, e2, n2, a, i, o, s) {
    var u = e2 - r2, l2 = n2 - t2, c2 = o - a, f2 = s - i, h = f2 * u - c2 * l2;
    if (!(h * h < kv))
      return h = (c2 * (t2 - i) - f2 * (r2 - a)) / h, [r2 + h * u, t2 + h * l2];
  }
  function TM(r2, t2, e2, n2, a, i, o) {
    var s = r2 - e2, u = t2 - n2, l2 = (o ? i : -i) / VC(s * s + u * u), c2 = l2 * u, f2 = -l2 * s, h = r2 + c2, v9 = t2 + f2, d2 = e2 + c2, m2 = n2 + f2, b2 = (h + d2) / 2, _ = (v9 + m2) / 2, C = d2 - h, M = m2 - v9, E = C * C + M * M, z9 = a - i, V = h * m2 - d2 * v9, $ = (M < 0 ? -1 : 1) * VC(xC(0, z9 * z9 * E - V * V)), U = (V * M - C * $) / E, H = (-V * C - M * $) / E, q3 = (V * M + C * $) / E, ee = (-V * C + M * $) / E, oe = U - b2, ne = H - _, be = q3 - b2, Ee = ee - _;
    return oe * oe + ne * ne > be * be + Ee * Ee && (U = q3, H = ee), { cx: U, cy: H, x0: -c2, y0: -f2, x1: U * (a / z9 - 1), y1: H * (a / z9 - 1) };
  }
  function Rse(r2) {
    var t2;
    if (vr(r2)) {
      var e2 = r2.length;
      if (!e2)
        return r2;
      e2 === 1 ? t2 = [r2[0], r2[0], 0, 0] : e2 === 2 ? t2 = [r2[0], r2[0], r2[1], r2[1]] : e2 === 3 ? t2 = r2.concat(r2[2]) : t2 = r2;
    } else
      t2 = [r2, r2, r2, r2];
    return t2;
  }
  function Fse(r2, t2) {
    var e2, n2 = xC(t2.r, 0), a = xC(t2.r0 || 0, 0), i = n2 > 0, o = a > 0;
    if (!(!i && !o)) {
      if (i || (n2 = a, a = 0), a > n2) {
        var s = n2;
        n2 = a, a = s;
      }
      var u = t2.startAngle, l2 = t2.endAngle;
      if (!(isNaN(u) || isNaN(l2))) {
        var c2 = t2.cx, f2 = t2.cy, h = !!t2.clockwise, v9 = M7(l2 - u), d2 = v9 > LO && v9 % LO;
        if (d2 > kv && (v9 = d2), !(n2 > kv))
          r2.moveTo(c2, f2);
        else if (v9 > LO - kv)
          r2.moveTo(c2 + n2 * yx(u), f2 + n2 * vb(u)), r2.arc(c2, f2, n2, u, l2, !h), a > kv && (r2.moveTo(c2 + a * yx(l2), f2 + a * vb(l2)), r2.arc(c2, f2, a, l2, u, h));
        else {
          var m2 = void 0, b2 = void 0, _ = void 0, C = void 0, M = void 0, E = void 0, z9 = void 0, V = void 0, $ = void 0, U = void 0, H = void 0, q3 = void 0, ee = void 0, oe = void 0, ne = void 0, be = void 0, Ee = n2 * yx(u), ye = n2 * vb(u), et = a * yx(l2), Le = a * vb(l2), Fe = v9 > kv;
          if (Fe) {
            var qe = t2.cornerRadius;
            qe && (e2 = Rse(qe), m2 = e2[0], b2 = e2[1], _ = e2[2], C = e2[3]);
            var st = M7(n2 - a) / 2;
            if (M = Vd(st, _), E = Vd(st, C), z9 = Vd(st, m2), V = Vd(st, b2), H = $ = xC(M, E), q3 = U = xC(z9, V), ($ > kv || U > kv) && (ee = n2 * yx(l2), oe = n2 * vb(l2), ne = a * yx(u), be = a * vb(u), v9 < AU)) {
              var dt = kse(Ee, ye, ne, be, ee, oe, et, Le);
              if (dt) {
                var Ar = Ee - dt[0], Hr = ye - dt[1], hn = ee - dt[0], cn = oe - dt[1], nn = 1 / vb(Ose((Ar * hn + Hr * cn) / (VC(Ar * Ar + Hr * Hr) * VC(hn * hn + cn * cn))) / 2), Wr = VC(dt[0] * dt[0] + dt[1] * dt[1]);
                H = Vd($, (n2 - Wr) / (nn + 1)), q3 = Vd(U, (a - Wr) / (nn - 1));
              }
            }
          }
          if (!Fe)
            r2.moveTo(c2 + Ee, f2 + ye);
          else if (H > kv) {
            var on = Vd(_, H), un = Vd(C, H), Xr = TM(ne, be, Ee, ye, n2, on, h), _n = TM(ee, oe, et, Le, n2, un, h);
            r2.moveTo(c2 + Xr.cx + Xr.x0, f2 + Xr.cy + Xr.y0), H < $ && on === un ? r2.arc(c2 + Xr.cx, f2 + Xr.cy, H, ac(Xr.y0, Xr.x0), ac(_n.y0, _n.x0), !h) : (on > 0 && r2.arc(c2 + Xr.cx, f2 + Xr.cy, on, ac(Xr.y0, Xr.x0), ac(Xr.y1, Xr.x1), !h), r2.arc(c2, f2, n2, ac(Xr.cy + Xr.y1, Xr.cx + Xr.x1), ac(_n.cy + _n.y1, _n.cx + _n.x1), !h), un > 0 && r2.arc(c2 + _n.cx, f2 + _n.cy, un, ac(_n.y1, _n.x1), ac(_n.y0, _n.x0), !h));
          } else
            r2.moveTo(c2 + Ee, f2 + ye), r2.arc(c2, f2, n2, u, l2, !h);
          if (!(a > kv) || !Fe)
            r2.lineTo(c2 + et, f2 + Le);
          else if (q3 > kv) {
            var on = Vd(m2, q3), un = Vd(b2, q3), Xr = TM(et, Le, ee, oe, a, -un, h), _n = TM(Ee, ye, ne, be, a, -on, h);
            r2.lineTo(c2 + Xr.cx + Xr.x0, f2 + Xr.cy + Xr.y0), q3 < U && on === un ? r2.arc(c2 + Xr.cx, f2 + Xr.cy, q3, ac(Xr.y0, Xr.x0), ac(_n.y0, _n.x0), !h) : (un > 0 && r2.arc(c2 + Xr.cx, f2 + Xr.cy, un, ac(Xr.y0, Xr.x0), ac(Xr.y1, Xr.x1), !h), r2.arc(c2, f2, a, ac(Xr.cy + Xr.y1, Xr.cx + Xr.x1), ac(_n.cy + _n.y1, _n.cx + _n.x1), h), on > 0 && r2.arc(c2 + _n.cx, f2 + _n.cy, on, ac(_n.y1, _n.x1), ac(_n.y0, _n.x0), !h));
          } else
            r2.lineTo(c2 + et, f2 + Le), r2.arc(c2, f2, a, l2, u, h);
        }
        r2.closePath();
      }
    }
  }
  var Nse = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
    }
    return r2;
  }(), TU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Nse();
    }, t2.prototype.buildPath = function(e2, n2) {
      Fse(e2, n2);
    }, t2.prototype.isZeroArea = function() {
      return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
    }, t2;
  }(xa);
  TU.prototype.type = "sector";
  var pf = TU, Vse = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
    }
    return r2;
  }(), MU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Vse();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.cx, i = n2.cy, o = Math.PI * 2;
      e2.moveTo(a + n2.r, i), e2.arc(a, i, n2.r, 0, o, false), e2.moveTo(a + n2.r0, i), e2.arc(a, i, n2.r0, 0, o, true);
    }, t2;
  }(xa);
  MU.prototype.type = "ring";
  var e3 = MU;
  function jse(r2, t2, e2, n2) {
    var a = [], i = [], o = [], s = [], u, l2, c2, f2;
    if (n2) {
      c2 = [1 / 0, 1 / 0], f2 = [-1 / 0, -1 / 0];
      for (var h = 0, v9 = r2.length; h < v9; h++)
        ry(c2, c2, r2[h]), ny(f2, f2, r2[h]);
      ry(c2, c2, n2[0]), ny(f2, f2, n2[1]);
    }
    for (var h = 0, v9 = r2.length; h < v9; h++) {
      var d2 = r2[h];
      if (e2)
        u = r2[h ? h - 1 : v9 - 1], l2 = r2[(h + 1) % v9];
      else if (h === 0 || h === v9 - 1) {
        a.push(xg(r2[h]));
        continue;
      } else
        u = r2[h - 1], l2 = r2[h + 1];
      Vb(i, l2, u), ZL(i, i, t2);
      var m2 = kR(d2, u), b2 = kR(d2, l2), _ = m2 + b2;
      _ !== 0 && (m2 /= _, b2 /= _), ZL(o, i, -m2), ZL(s, i, b2);
      var C = x8([], d2, o), M = x8([], d2, s);
      n2 && (ny(C, C, c2), ry(C, C, f2), ny(M, M, c2), ry(M, M, f2)), a.push(C), a.push(M);
    }
    return e2 && a.push(a.shift()), a;
  }
  function PU(r2, t2, e2) {
    var n2 = t2.smooth, a = t2.points;
    if (a && a.length >= 2) {
      if (n2) {
        var i = jse(a, n2, e2, t2.smoothConstraint);
        r2.moveTo(a[0][0], a[0][1]);
        for (var o = a.length, s = 0; s < (e2 ? o : o - 1); s++) {
          var u = i[s * 2], l2 = i[s * 2 + 1], c2 = a[(s + 1) % o];
          r2.bezierCurveTo(u[0], u[1], l2[0], l2[1], c2[0], c2[1]);
        }
      } else {
        r2.moveTo(a[0][0], a[0][1]);
        for (var s = 1, f2 = a.length; s < f2; s++)
          r2.lineTo(a[s][0], a[s][1]);
      }
      e2 && r2.closePath();
    }
  }
  var Bse = function() {
    function r2() {
      this.points = null, this.smooth = 0, this.smoothConstraint = null;
    }
    return r2;
  }(), DU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Bse();
    }, t2.prototype.buildPath = function(e2, n2) {
      PU(e2, n2, true);
    }, t2;
  }(xa);
  DU.prototype.type = "polygon";
  var gf = DU, zse = function() {
    function r2() {
      this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
    }
    return r2;
  }(), IU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new zse();
    }, t2.prototype.buildPath = function(e2, n2) {
      PU(e2, n2, false);
    }, t2;
  }(xa);
  IU.prototype.type = "polyline";
  var yf = IU, $se = {}, Gse = function() {
    function r2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return r2;
  }(), LU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new Gse();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a, i, o, s;
      if (this.subPixelOptimize) {
        var u = nU($se, n2, this.style);
        a = u.x1, i = u.y1, o = u.x2, s = u.y2;
      } else
        a = n2.x1, i = n2.y1, o = n2.x2, s = n2.y2;
      var l2 = n2.percent;
      l2 !== 0 && (e2.moveTo(a, i), l2 < 1 && (o = a * (1 - l2) + o * l2, s = i * (1 - l2) + s * l2), e2.lineTo(o, s));
    }, t2.prototype.pointAt = function(e2) {
      var n2 = this.shape;
      return [n2.x1 * (1 - e2) + n2.x2 * e2, n2.y1 * (1 - e2) + n2.y2 * e2];
    }, t2;
  }(xa);
  LU.prototype.type = "line";
  var bl = LU, cf = [], Wse = function() {
    function r2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
    }
    return r2;
  }();
  function P7(r2, t2, e2) {
    var n2 = r2.cpx2, a = r2.cpy2;
    return n2 != null || a != null ? [(e2 ? L8 : Wu)(r2.x1, r2.cpx1, r2.cpx2, r2.x2, t2), (e2 ? L8 : Wu)(r2.y1, r2.cpy1, r2.cpy2, r2.y2, t2)] : [(e2 ? BR : yl)(r2.x1, r2.cpx1, r2.x2, t2), (e2 ? BR : yl)(r2.y1, r2.cpy1, r2.y2, t2)];
  }
  var OU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new Wse();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.x1, i = n2.y1, o = n2.x2, s = n2.y2, u = n2.cpx1, l2 = n2.cpy1, c2 = n2.cpx2, f2 = n2.cpy2, h = n2.percent;
      h !== 0 && (e2.moveTo(a, i), c2 == null || f2 == null ? (h < 1 && (JC(a, u, o, h, cf), u = cf[1], o = cf[2], JC(i, l2, s, h, cf), l2 = cf[1], s = cf[2]), e2.quadraticCurveTo(u, l2, o, s)) : (h < 1 && (yy(a, u, c2, o, h, cf), u = cf[1], c2 = cf[2], o = cf[3], yy(i, l2, f2, s, h, cf), l2 = cf[1], f2 = cf[2], s = cf[3]), e2.bezierCurveTo(u, l2, c2, f2, o, s)));
    }, t2.prototype.pointAt = function(e2) {
      return P7(this.shape, e2, false);
    }, t2.prototype.tangentAt = function(e2) {
      var n2 = P7(this.shape, e2, true);
      return TE(n2, n2);
    }, t2;
  }(xa);
  OU.prototype.type = "bezier-curve";
  var t3 = OU, Use = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return r2;
  }(), kU = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new Use();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.cx, i = n2.cy, o = Math.max(n2.r, 0), s = n2.startAngle, u = n2.endAngle, l2 = n2.clockwise, c2 = Math.cos(s), f2 = Math.sin(s);
      e2.moveTo(c2 * o + a, f2 * o + i), e2.arc(a, i, o, s, u, !l2);
    }, t2;
  }(xa);
  kU.prototype.type = "arc";
  var nF = kU, Hse = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "compound", e2;
    }
    return t2.prototype._updatePathDirty = function() {
      for (var e2 = this.shape.paths, n2 = this.shapeChanged(), a = 0; a < e2.length; a++)
        n2 = n2 || e2[a].shapeChanged();
      n2 && this.dirtyShape();
    }, t2.prototype.beforeBrush = function() {
      this._updatePathDirty();
      for (var e2 = this.shape.paths || [], n2 = this.getGlobalScale(), a = 0; a < e2.length; a++)
        e2[a].path || e2[a].createPathProxy(), e2[a].path.setScale(n2[0], n2[1], e2[a].segmentIgnoreThreshold);
    }, t2.prototype.buildPath = function(e2, n2) {
      for (var a = n2.paths || [], i = 0; i < a.length; i++)
        a[i].buildPath(e2, a[i].shape, true);
    }, t2.prototype.afterBrush = function() {
      for (var e2 = this.shape.paths || [], n2 = 0; n2 < e2.length; n2++)
        e2[n2].pathUpdated();
    }, t2.prototype.getBoundingRect = function() {
      return this._updatePathDirty.call(this), xa.prototype.getBoundingRect.call(this);
    }, t2;
  }(xa), aF = Hse, qse = function() {
    function r2(t2) {
      this.colorStops = t2 || [];
    }
    return r2.prototype.addColorStop = function(t2, e2) {
      this.colorStops.push({ offset: t2, color: e2 });
    }, r2;
  }(), RU = qse, Yse = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i, o, s) {
      var u = r2.call(this, o) || this;
      return u.x = e2 == null ? 0 : e2, u.y = n2 == null ? 0 : n2, u.x2 = a == null ? 1 : a, u.y2 = i == null ? 0 : i, u.type = "linear", u.global = s || false, u;
    }
    return t2;
  }(RU), LE = Yse, Kse = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i, o) {
      var s = r2.call(this, i) || this;
      return s.x = e2 == null ? 0.5 : e2, s.y = n2 == null ? 0.5 : n2, s.r = a == null ? 0.5 : a, s.type = "radial", s.global = o || false, s;
    }
    return t2;
  }(RU), FU = Kse, db = [0, 0], pb = [0, 0], MM = new Jn(), PM = new Jn(), Zse = function() {
    function r2(t2, e2) {
      this._corners = [], this._axes = [], this._origin = [0, 0];
      for (var n2 = 0; n2 < 4; n2++)
        this._corners[n2] = new Jn();
      for (var n2 = 0; n2 < 2; n2++)
        this._axes[n2] = new Jn();
      t2 && this.fromBoundingRect(t2, e2);
    }
    return r2.prototype.fromBoundingRect = function(t2, e2) {
      var n2 = this._corners, a = this._axes, i = t2.x, o = t2.y, s = i + t2.width, u = o + t2.height;
      if (n2[0].set(i, o), n2[1].set(s, o), n2[2].set(s, u), n2[3].set(i, u), e2)
        for (var l2 = 0; l2 < 4; l2++)
          n2[l2].transform(e2);
      Jn.sub(a[0], n2[1], n2[0]), Jn.sub(a[1], n2[3], n2[0]), a[0].normalize(), a[1].normalize();
      for (var l2 = 0; l2 < 2; l2++)
        this._origin[l2] = a[l2].dot(n2[0]);
    }, r2.prototype.intersect = function(t2, e2) {
      var n2 = true, a = !e2;
      return MM.set(1 / 0, 1 / 0), PM.set(0, 0), !this._intersectCheckOneSide(this, t2, MM, PM, a, 1) && (n2 = false, a) || !this._intersectCheckOneSide(t2, this, MM, PM, a, -1) && (n2 = false, a) || a || Jn.copy(e2, n2 ? MM : PM), n2;
    }, r2.prototype._intersectCheckOneSide = function(t2, e2, n2, a, i, o) {
      for (var s = true, u = 0; u < 2; u++) {
        var l2 = this._axes[u];
        if (this._getProjMinMaxOnAxis(u, t2._corners, db), this._getProjMinMaxOnAxis(u, e2._corners, pb), db[1] < pb[0] || db[0] > pb[1]) {
          if (s = false, i)
            return s;
          var c2 = Math.abs(pb[0] - db[1]), f2 = Math.abs(db[0] - pb[1]);
          Math.min(c2, f2) > a.len() && (c2 < f2 ? Jn.scale(a, l2, -c2 * o) : Jn.scale(a, l2, f2 * o));
        } else if (n2) {
          var c2 = Math.abs(pb[0] - db[1]), f2 = Math.abs(db[0] - pb[1]);
          Math.min(c2, f2) < n2.len() && (c2 < f2 ? Jn.scale(n2, l2, c2 * o) : Jn.scale(n2, l2, -f2 * o));
        }
      }
      return s;
    }, r2.prototype._getProjMinMaxOnAxis = function(t2, e2, n2) {
      for (var a = this._axes[t2], i = this._origin, o = e2[0].dot(a) + i[t2], s = o, u = o, l2 = 1; l2 < e2.length; l2++) {
        var c2 = e2[l2].dot(a) + i[t2];
        s = Math.min(c2, s), u = Math.max(c2, u);
      }
      n2[0] = s, n2[1] = u;
    }, r2;
  }(), eP = Zse, Xse = [], Jse = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.notClear = true, e2.incremental = true, e2._displayables = [], e2._temporaryDisplayables = [], e2._cursor = 0, e2;
    }
    return t2.prototype.traverse = function(e2, n2) {
      e2.call(n2, this);
    }, t2.prototype.useStyle = function() {
      this.style = {};
    }, t2.prototype.getCursor = function() {
      return this._cursor;
    }, t2.prototype.innerAfterBrush = function() {
      this._cursor = this._displayables.length;
    }, t2.prototype.clearDisplaybles = function() {
      this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
    }, t2.prototype.clearTemporalDisplayables = function() {
      this._temporaryDisplayables = [];
    }, t2.prototype.addDisplayable = function(e2, n2) {
      n2 ? this._temporaryDisplayables.push(e2) : this._displayables.push(e2), this.markRedraw();
    }, t2.prototype.addDisplayables = function(e2, n2) {
      n2 = n2 || false;
      for (var a = 0; a < e2.length; a++)
        this.addDisplayable(e2[a], n2);
    }, t2.prototype.getDisplayables = function() {
      return this._displayables;
    }, t2.prototype.getTemporalDisplayables = function() {
      return this._temporaryDisplayables;
    }, t2.prototype.eachPendingDisplayable = function(e2) {
      for (var n2 = this._cursor; n2 < this._displayables.length; n2++)
        e2 && e2(this._displayables[n2]);
      for (var n2 = 0; n2 < this._temporaryDisplayables.length; n2++)
        e2 && e2(this._temporaryDisplayables[n2]);
    }, t2.prototype.update = function() {
      this.updateTransform();
      for (var e2 = this._cursor; e2 < this._displayables.length; e2++) {
        var n2 = this._displayables[e2];
        n2.parent = this, n2.update(), n2.parent = null;
      }
      for (var e2 = 0; e2 < this._temporaryDisplayables.length; e2++) {
        var n2 = this._temporaryDisplayables[e2];
        n2.parent = this, n2.update(), n2.parent = null;
      }
    }, t2.prototype.getBoundingRect = function() {
      if (!this._rect) {
        for (var e2 = new da(1 / 0, 1 / 0, -1 / 0, -1 / 0), n2 = 0; n2 < this._displayables.length; n2++) {
          var a = this._displayables[n2], i = a.getBoundingRect().clone();
          a.needLocalTransform() && i.applyTransform(a.getLocalTransform(Xse)), e2.union(i);
        }
        this._rect = e2;
      }
      return this._rect;
    }, t2.prototype.contain = function(e2, n2) {
      var a = this.transformCoordToLocal(e2, n2), i = this.getBoundingRect();
      if (i.contain(a[0], a[1]))
        for (var o = 0; o < this._displayables.length; o++) {
          var s = this._displayables[o];
          if (s.contain(e2, n2))
            return true;
        }
      return false;
    }, t2;
  }(qh), Qse = Jse, NU = fi();
  function dw(r2, t2, e2, n2, a) {
    var i;
    if (t2 && t2.ecModel) {
      var o = t2.ecModel.getUpdatePayload();
      i = o && o.animation;
    }
    var s = t2 && t2.isAnimationEnabled(), u = r2 === "update";
    if (s) {
      var l2 = void 0, c2 = void 0, f2 = void 0;
      n2 ? (l2 = ia(n2.duration, 200), c2 = ia(n2.easing, "cubicOut"), f2 = 0) : (l2 = t2.getShallow(u ? "animationDurationUpdate" : "animationDuration"), c2 = t2.getShallow(u ? "animationEasingUpdate" : "animationEasing"), f2 = t2.getShallow(u ? "animationDelayUpdate" : "animationDelay")), i && (i.duration != null && (l2 = i.duration), i.easing != null && (c2 = i.easing), i.delay != null && (f2 = i.delay)), xn(f2) && (f2 = f2(e2, a)), xn(l2) && (l2 = l2(e2));
      var h = { duration: l2 || 0, delay: f2, easing: c2 };
      return h;
    } else
      return null;
  }
  function iF(r2, t2, e2, n2, a, i, o) {
    var s = false, u;
    xn(a) ? (o = i, i = a, a = null) : Tn(a) && (i = a.cb, o = a.during, s = a.isFrom, u = a.removeOpt, a = a.dataIndex);
    var l2 = r2 === "leave";
    l2 || t2.stopAnimation("leave");
    var c2 = dw(r2, n2, a, l2 ? u || {} : null, n2 && n2.getAnimationDelayParams ? n2.getAnimationDelayParams(t2, a) : null);
    if (c2 && c2.duration > 0) {
      var f2 = c2.duration, h = c2.delay, v9 = c2.easing, d2 = { duration: f2, delay: h || 0, easing: v9, done: i, force: !!i || !!o, setToFinal: !l2, scope: r2, during: o };
      s ? t2.animateFrom(e2, d2) : t2.animateTo(e2, d2);
    } else
      t2.stopAnimation(), !s && t2.attr(e2), o && o(1), i && i();
  }
  function ci(r2, t2, e2, n2, a, i) {
    iF("update", r2, t2, e2, n2, a, i);
  }
  function rs(r2, t2, e2, n2, a, i) {
    iF("enter", r2, t2, e2, n2, a, i);
  }
  function Kx(r2) {
    if (!r2.__zr)
      return true;
    for (var t2 = 0; t2 < r2.animators.length; t2++) {
      var e2 = r2.animators[t2];
      if (e2.scope === "leave")
        return true;
    }
    return false;
  }
  function my(r2, t2, e2, n2, a, i) {
    Kx(r2) || iF("leave", r2, t2, e2, n2, a, i);
  }
  function D7(r2, t2, e2, n2) {
    r2.removeTextContent(), r2.removeTextGuideLine(), my(r2, { style: { opacity: 0 } }, t2, e2, n2);
  }
  function aE(r2, t2, e2) {
    function n2() {
      r2.parent && r2.parent.remove(r2);
    }
    r2.isGroup ? r2.traverse(function(a) {
      a.isGroup || D7(a, t2, e2, n2);
    }) : D7(r2, t2, e2, n2);
  }
  function Wv(r2) {
    NU(r2).oldStyle = r2.style;
  }
  function eue(r2) {
    return NU(r2).oldStyle;
  }
  var tP = Math.max, rP = Math.min, l4 = {};
  function tue(r2) {
    return xa.extend(r2);
  }
  var rue = Pse;
  function nue(r2, t2) {
    return rue(r2, t2);
  }
  function Uv(r2, t2) {
    l4[r2] = t2;
  }
  function oF(r2) {
    if (l4.hasOwnProperty(r2))
      return l4[r2];
  }
  function r3(r2, t2, e2, n2) {
    var a = SU(r2, t2);
    return e2 && (n2 === "center" && (e2 = jU(e2, a.getBoundingRect())), BU(a, e2)), a;
  }
  function VU(r2, t2, e2) {
    var n2 = new Bl({ style: { image: r2, x: t2.x, y: t2.y, width: t2.width, height: t2.height }, onload: function(a) {
      if (e2 === "center") {
        var i = { width: a.width, height: a.height };
        n2.setStyle(jU(t2, i));
      }
    } });
    return n2;
  }
  function jU(r2, t2) {
    var e2 = t2.width / t2.height, n2 = r2.height * e2, a;
    n2 <= r2.width ? a = r2.height : (n2 = r2.width, a = n2 / e2);
    var i = r2.x + r2.width / 2, o = r2.y + r2.height / 2;
    return { x: i - n2 / 2, y: o - a / 2, width: n2, height: a };
  }
  var Bh = Dse;
  function BU(r2, t2) {
    if (!!r2.applyTransform) {
      var e2 = r2.getBoundingRect(), n2 = e2.calculateTransform(t2);
      r2.applyTransform(n2);
    }
  }
  function aue(r2) {
    return nU(r2.shape, r2.shape, r2.style), r2;
  }
  function iue(r2) {
    return aU(r2.shape, r2.shape, r2.style), r2;
  }
  var I5 = jb;
  function Yb(r2, t2) {
    for (var e2 = HP([]); r2 && r2 !== t2; )
      Sg(e2, r2.getLocalTransform(), e2), r2 = r2.parent;
    return e2;
  }
  function $v(r2, t2, e2) {
    return t2 && !lc(t2) && (t2 = mg.getLocalTransform(t2)), e2 && (t2 = fw([], t2)), Nl([], r2, t2);
  }
  function n3(r2, t2, e2) {
    var n2 = t2[4] === 0 || t2[5] === 0 || t2[0] === 0 ? 1 : Math.abs(2 * t2[4] / t2[0]), a = t2[4] === 0 || t2[5] === 0 || t2[2] === 0 ? 1 : Math.abs(2 * t2[4] / t2[2]), i = [r2 === "left" ? -n2 : r2 === "right" ? n2 : 0, r2 === "top" ? -a : r2 === "bottom" ? a : 0];
    return i = $v(i, t2, e2), Math.abs(i[0]) > Math.abs(i[1]) ? i[0] > 0 ? "right" : "left" : i[1] > 0 ? "bottom" : "top";
  }
  function I7(r2) {
    return !r2.isGroup;
  }
  function oue(r2) {
    return r2.shape != null;
  }
  function OE(r2, t2, e2) {
    if (!r2 || !t2)
      return;
    function n2(o) {
      var s = {};
      return o.traverse(function(u) {
        I7(u) && u.anid && (s[u.anid] = u);
      }), s;
    }
    function a(o) {
      var s = { x: o.x, y: o.y, rotation: o.rotation };
      return oue(o) && (s.shape = qt({}, o.shape)), s;
    }
    var i = n2(r2);
    t2.traverse(function(o) {
      if (I7(o) && o.anid) {
        var s = i[o.anid];
        if (s) {
          var u = a(o);
          o.attr(a(s)), ci(o, u, e2, zn(o).dataIndex);
        }
      }
    });
  }
  function zU(r2, t2) {
    return pr(r2, function(e2) {
      var n2 = e2[0];
      n2 = tP(n2, t2.x), n2 = rP(n2, t2.x + t2.width);
      var a = e2[1];
      return a = tP(a, t2.y), a = rP(a, t2.y + t2.height), [n2, a];
    });
  }
  function sue(r2, t2) {
    var e2 = tP(r2.x, t2.x), n2 = rP(r2.x + r2.width, t2.x + t2.width), a = tP(r2.y, t2.y), i = rP(r2.y + r2.height, t2.y + t2.height);
    if (n2 >= e2 && i >= a)
      return { x: e2, y: a, width: n2 - e2, height: i - a };
  }
  function kE(r2, t2, e2) {
    var n2 = qt({ rectHover: true }, t2), a = n2.style = { strokeNoScale: true };
    if (e2 = e2 || { x: -1, y: -1, width: 2, height: 2 }, r2)
      return r2.indexOf("image://") === 0 ? (a.image = r2.slice(8), En(a, e2), new Bl(n2)) : r3(r2.replace("path://", ""), n2, e2, "center");
  }
  function wC(r2, t2, e2, n2, a) {
    for (var i = 0, o = a[a.length - 1]; i < a.length; i++) {
      var s = a[i];
      if ($U(r2, t2, e2, n2, s[0], s[1], o[0], o[1]))
        return true;
      o = s;
    }
  }
  function $U(r2, t2, e2, n2, a, i, o, s) {
    var u = e2 - r2, l2 = n2 - t2, c2 = o - a, f2 = s - i, h = OO(c2, f2, u, l2);
    if (uue(h))
      return false;
    var v9 = r2 - a, d2 = t2 - i, m2 = OO(v9, d2, u, l2) / h;
    if (m2 < 0 || m2 > 1)
      return false;
    var b2 = OO(v9, d2, c2, f2) / h;
    return !(b2 < 0 || b2 > 1);
  }
  function OO(r2, t2, e2, n2) {
    return r2 * n2 - e2 * t2;
  }
  function uue(r2) {
    return r2 <= 1e-6 && r2 >= -1e-6;
  }
  function pw(r2) {
    var t2 = r2.itemTooltipOption, e2 = r2.componentModel, n2 = r2.itemName, a = Zr(t2) ? { formatter: t2 } : t2, i = e2.mainType, o = e2.componentIndex, s = { componentType: i, name: n2, $vars: ["name"] };
    s[i + "Index"] = o;
    var u = r2.formatterParamsExtra;
    u && ae(ja(u), function(c2) {
      sn(s, c2) || (s[c2] = u[c2], s.$vars.push(c2));
    });
    var l2 = zn(r2.el);
    l2.componentMainType = i, l2.componentIndex = o, l2.tooltipConfig = { name: n2, option: En({ content: n2, formatterParams: s }, a) };
  }
  function L7(r2, t2) {
    var e2;
    r2.isGroup && (e2 = t2(r2)), e2 || r2.traverse(t2);
  }
  function Ay(r2, t2) {
    if (r2)
      if (vr(r2))
        for (var e2 = 0; e2 < r2.length; e2++)
          L7(r2[e2], t2);
      else
        L7(r2, t2);
  }
  Uv("circle", ap);
  Uv("ellipse", rF);
  Uv("sector", pf);
  Uv("ring", e3);
  Uv("polygon", gf);
  Uv("polyline", yf);
  Uv("rect", ni);
  Uv("line", bl);
  Uv("bezierCurve", t3);
  Uv("arc", nF);
  var RE = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: ci, initProps: rs, removeElement: my, removeElementWithFadeOut: aE, isElementRemoved: Kx, extendShape: tue, extendPath: nue, registerShape: Uv, getShapeClass: oF, makePath: r3, makeImage: VU, mergePath: Bh, resizePath: BU, subPixelOptimizeLine: aue, subPixelOptimizeRect: iue, subPixelOptimize: I5, getTransform: Yb, applyTransform: $v, transformDirection: n3, groupTransition: OE, clipPointsByRect: zU, clipRectByRect: sue, createIcon: kE, linePolygonIntersect: wC, lineLineIntersect: $U, setTooltipConfig: pw, traverseElements: Ay, Group: Fn, Image: Bl, Text: xi, Circle: ap, Ellipse: rF, Sector: pf, Ring: e3, Polygon: gf, Polyline: yf, Rect: ni, Line: bl, BezierCurve: t3, Arc: nF, IncrementalDisplayable: Qse, CompoundPath: aF, LinearGradient: LE, RadialGradient: FU, BoundingRect: da, OrientedBoundingRect: eP, Point: Jn, Path: xa }, Symbol.toStringTag, { value: "Module" })), a3 = {};
  function GU(r2, t2) {
    for (var e2 = 0; e2 < Nc.length; e2++) {
      var n2 = Nc[e2], a = t2[n2], i = r2.ensureState(n2);
      i.style = i.style || {}, i.style.text = a;
    }
    var o = r2.currentStates.slice();
    r2.clearStates(true), r2.setStyle({ text: t2.normal }), r2.useStates(o, true);
  }
  function c4(r2, t2, e2) {
    var n2 = r2.labelFetcher, a = r2.labelDataIndex, i = r2.labelDimIndex, o = t2.normal, s;
    n2 && (s = n2.getFormattedLabel(a, "normal", null, i, o && o.get("formatter"), e2 != null ? { interpolatedValue: e2 } : null)), s == null && (s = xn(r2.defaultText) ? r2.defaultText(a, r2, e2) : r2.defaultText);
    for (var u = { normal: s }, l2 = 0; l2 < Nc.length; l2++) {
      var c2 = Nc[l2], f2 = t2[c2];
      u[c2] = ia(n2 ? n2.getFormattedLabel(a, c2, null, i, f2 && f2.get("formatter")) : null, s);
    }
    return u;
  }
  function fc(r2, t2, e2, n2) {
    e2 = e2 || a3;
    for (var a = r2 instanceof xi, i = false, o = 0; o < rE.length; o++) {
      var s = t2[rE[o]];
      if (s && s.getShallow("show")) {
        i = true;
        break;
      }
    }
    var u = a ? r2 : r2.getTextContent();
    if (i) {
      a || (u || (u = new xi(), r2.setTextContent(u)), r2.stateProxy && (u.stateProxy = r2.stateProxy));
      var l2 = c4(e2, t2), c2 = t2.normal, f2 = !!c2.getShallow("show"), h = Hs(c2, n2 && n2.normal, e2, false, !a);
      h.text = l2.normal, a || r2.setTextConfig(nP(c2, e2, false));
      for (var o = 0; o < Nc.length; o++) {
        var v9 = Nc[o], s = t2[v9];
        if (s) {
          var d2 = u.ensureState(v9), m2 = !!ia(s.getShallow("show"), f2);
          if (m2 !== f2 && (d2.ignore = !m2), d2.style = Hs(s, n2 && n2[v9], e2, true, !a), d2.style.text = l2[v9], !a) {
            var b2 = r2.ensureState(v9);
            b2.textConfig = nP(s, e2, true);
          }
        }
      }
      u.silent = !!c2.getShallow("silent"), u.style.x != null && (h.x = u.style.x), u.style.y != null && (h.y = u.style.y), u.ignore = !f2, u.useStyle(h), u.dirty(), e2.enableTextSetter && (gw(u).setLabelText = function(_) {
        var C = c4(e2, t2, _);
        GU(u, C);
      });
    } else
      u && (u.ignore = true);
    r2.dirty();
  }
  function _l(r2, t2) {
    t2 = t2 || "label";
    for (var e2 = { normal: r2.getModel(t2) }, n2 = 0; n2 < Nc.length; n2++) {
      var a = Nc[n2];
      e2[a] = r2.getModel([a, t2]);
    }
    return e2;
  }
  function Hs(r2, t2, e2, n2, a) {
    var i = {};
    return lue(i, r2, e2, n2, a), t2 && qt(i, t2), i;
  }
  function nP(r2, t2, e2) {
    t2 = t2 || {};
    var n2 = {}, a, i = r2.getShallow("rotate"), o = ia(r2.getShallow("distance"), e2 ? null : 5), s = r2.getShallow("offset");
    return a = r2.getShallow("position") || (e2 ? null : "inside"), a === "outside" && (a = t2.defaultOutsidePosition || "top"), a != null && (n2.position = a), s != null && (n2.offset = s), i != null && (i *= Math.PI / 180, n2.rotation = i), o != null && (n2.distance = o), n2.outsideFill = r2.get("color") === "inherit" ? t2.inheritColor || null : "auto", n2;
  }
  function lue(r2, t2, e2, n2, a) {
    e2 = e2 || a3;
    var i = t2.ecModel, o = i && i.option.textStyle, s = cue(t2), u;
    if (s) {
      u = {};
      for (var l2 in s)
        if (s.hasOwnProperty(l2)) {
          var c2 = t2.getModel(["rich", l2]);
          F7(u[l2] = {}, c2, o, e2, n2, a, false, true);
        }
    }
    u && (r2.rich = u);
    var f2 = t2.get("overflow");
    f2 && (r2.overflow = f2);
    var h = t2.get("minMargin");
    h != null && (r2.margin = h), F7(r2, t2, o, e2, n2, a, true, false);
  }
  function cue(r2) {
    for (var t2; r2 && r2 !== r2.ecModel; ) {
      var e2 = (r2.option || a3).rich;
      if (e2) {
        t2 = t2 || {};
        for (var n2 = ja(e2), a = 0; a < n2.length; a++) {
          var i = n2[a];
          t2[i] = 1;
        }
      }
      r2 = r2.parentModel;
    }
    return t2;
  }
  var O7 = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], k7 = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], R7 = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
  function F7(r2, t2, e2, n2, a, i, o, s) {
    e2 = !a && e2 || a3;
    var u = n2 && n2.inheritColor, l2 = t2.getShallow("color"), c2 = t2.getShallow("textBorderColor"), f2 = ia(t2.getShallow("opacity"), e2.opacity);
    (l2 === "inherit" || l2 === "auto") && (u ? l2 = u : l2 = null), (c2 === "inherit" || c2 === "auto") && (u ? c2 = u : c2 = null), i || (l2 = l2 || e2.color, c2 = c2 || e2.textBorderColor), l2 != null && (r2.fill = l2), c2 != null && (r2.stroke = c2);
    var h = ia(t2.getShallow("textBorderWidth"), e2.textBorderWidth);
    h != null && (r2.lineWidth = h);
    var v9 = ia(t2.getShallow("textBorderType"), e2.textBorderType);
    v9 != null && (r2.lineDash = v9);
    var d2 = ia(t2.getShallow("textBorderDashOffset"), e2.textBorderDashOffset);
    d2 != null && (r2.lineDashOffset = d2), !a && f2 == null && !s && (f2 = n2 && n2.defaultOpacity), f2 != null && (r2.opacity = f2), !a && !i && r2.fill == null && n2.inheritColor && (r2.fill = n2.inheritColor);
    for (var m2 = 0; m2 < O7.length; m2++) {
      var b2 = O7[m2], _ = ia(t2.getShallow(b2), e2[b2]);
      _ != null && (r2[b2] = _);
    }
    for (var m2 = 0; m2 < k7.length; m2++) {
      var b2 = k7[m2], _ = t2.getShallow(b2);
      _ != null && (r2[b2] = _);
    }
    if (r2.verticalAlign == null) {
      var C = t2.getShallow("baseline");
      C != null && (r2.verticalAlign = C);
    }
    if (!o || !n2.disableBox) {
      for (var m2 = 0; m2 < R7.length; m2++) {
        var b2 = R7[m2], _ = t2.getShallow(b2);
        _ != null && (r2[b2] = _);
      }
      var M = t2.getShallow("borderType");
      M != null && (r2.borderDash = M), (r2.backgroundColor === "auto" || r2.backgroundColor === "inherit") && u && (r2.backgroundColor = u), (r2.borderColor === "auto" || r2.borderColor === "inherit") && u && (r2.borderColor = u);
    }
  }
  function WU(r2, t2) {
    var e2 = t2 && t2.getModel("textStyle");
    return jv([r2.fontStyle || e2 && e2.getShallow("fontStyle") || "", r2.fontWeight || e2 && e2.getShallow("fontWeight") || "", (r2.fontSize || e2 && e2.getShallow("fontSize") || 12) + "px", r2.fontFamily || e2 && e2.getShallow("fontFamily") || "sans-serif"].join(" "));
  }
  var gw = fi();
  function UU(r2, t2, e2, n2) {
    if (!!r2) {
      var a = gw(r2);
      a.prevValue = a.value, a.value = e2;
      var i = t2.normal;
      a.valueAnimation = i.get("valueAnimation"), a.valueAnimation && (a.precision = i.get("precision"), a.defaultInterpolatedText = n2, a.statesModels = t2);
    }
  }
  function HU(r2, t2, e2, n2, a) {
    var i = gw(r2);
    if (!i.valueAnimation || i.prevValue === i.value)
      return;
    var o = i.defaultInterpolatedText, s = ia(i.interpolatedValue, i.prevValue), u = i.value;
    function l2(c2) {
      var f2 = qW(e2, i.precision, s, u, c2);
      i.interpolatedValue = c2 === 1 ? null : f2;
      var h = c4({ labelDataIndex: t2, labelFetcher: a, defaultText: o ? o(f2) : f2 + "" }, i.statesModels, f2);
      GU(r2, h);
    }
    r2.percent = 0, (i.prevValue == null ? rs : ci)(r2, { percent: 1 }, n2, t2, null, l2);
  }
  var fue = ["textStyle", "color"], kO = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], RO = new xi(), hue = function() {
    function r2() {
    }
    return r2.prototype.getTextColor = function(t2) {
      var e2 = this.ecModel;
      return this.getShallow("color") || (!t2 && e2 ? e2.get(fue) : null);
    }, r2.prototype.getFont = function() {
      return WU({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
    }, r2.prototype.getTextRect = function(t2) {
      for (var e2 = { text: t2, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, n2 = 0; n2 < kO.length; n2++)
        e2[kO[n2]] = this.getShallow(kO[n2]);
      return RO.useStyle(e2), RO.update(), RO.getBoundingRect();
    }, r2;
  }(), vue = hue, qU = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], due = t1(qU), pue = function() {
    function r2() {
    }
    return r2.prototype.getLineStyle = function(t2) {
      return due(this, t2);
    }, r2;
  }(), YU = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], gue = t1(YU), yue = function() {
    function r2() {
    }
    return r2.prototype.getItemStyle = function(t2, e2) {
      return gue(this, t2, e2);
    }, r2;
  }(), u1 = function() {
    function r2(t2, e2, n2) {
      this.parentModel = e2, this.ecModel = n2, this.option = t2;
    }
    return r2.prototype.init = function(t2, e2, n2) {
      for (var a = [], i = 3; i < arguments.length; i++)
        a[i - 3] = arguments[i];
    }, r2.prototype.mergeOption = function(t2, e2) {
      ea(this.option, t2, true);
    }, r2.prototype.get = function(t2, e2) {
      return t2 == null ? this.option : this._doGet(this.parsePath(t2), !e2 && this.parentModel);
    }, r2.prototype.getShallow = function(t2, e2) {
      var n2 = this.option, a = n2 == null ? n2 : n2[t2];
      if (a == null && !e2) {
        var i = this.parentModel;
        i && (a = i.getShallow(t2));
      }
      return a;
    }, r2.prototype.getModel = function(t2, e2) {
      var n2 = t2 != null, a = n2 ? this.parsePath(t2) : null, i = n2 ? this._doGet(a) : this.option;
      return e2 = e2 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(a)), new r2(i, e2, this.ecModel);
    }, r2.prototype.isEmpty = function() {
      return this.option == null;
    }, r2.prototype.restoreData = function() {
    }, r2.prototype.clone = function() {
      var t2 = this.constructor;
      return new t2(On(this.option));
    }, r2.prototype.parsePath = function(t2) {
      return typeof t2 == "string" ? t2.split(".") : t2;
    }, r2.prototype.resolveParentPath = function(t2) {
      return t2;
    }, r2.prototype.isAnimationEnabled = function() {
      if (!Ei.node && this.option) {
        if (this.option.animation != null)
          return !!this.option.animation;
        if (this.parentModel)
          return this.parentModel.isAnimationEnabled();
      }
    }, r2.prototype._doGet = function(t2, e2) {
      var n2 = this.option;
      if (!t2)
        return n2;
      for (var a = 0; a < t2.length && !(!!t2[a] && (n2 = n2 && typeof n2 == "object" ? n2[t2[a]] : null, n2 == null)); a++)
        ;
      return n2 == null && e2 && (n2 = e2._doGet(this.resolveParentPath(t2), e2.parentModel)), n2;
    }, r2;
  }();
  K6(u1);
  doe(u1);
  fu(u1, pue);
  fu(u1, yue);
  fu(u1, boe);
  fu(u1, vue);
  var To = u1, mue = Math.round(Math.random() * 10);
  function yw(r2) {
    return [r2 || "", mue++].join("_");
  }
  function bue(r2) {
    var t2 = {};
    r2.registerSubTypeDefaulter = function(e2, n2) {
      var a = Hd(e2);
      t2[a.main] = n2;
    }, r2.determineSubType = function(e2, n2) {
      var a = n2.type;
      if (!a) {
        var i = Hd(e2).main;
        r2.hasSubTypes(e2) && t2[i] && (a = t2[i](n2));
      }
      return a;
    };
  }
  function _ue(r2, t2) {
    r2.topologicalTravel = function(i, o, s, u) {
      if (!i.length)
        return;
      var l2 = e2(o), c2 = l2.graph, f2 = l2.noEntryList, h = {};
      for (ae(i, function(C) {
        h[C] = true;
      }); f2.length; ) {
        var v9 = f2.pop(), d2 = c2[v9], m2 = !!h[v9];
        m2 && (s.call(u, v9, d2.originalDeps.slice()), delete h[v9]), ae(d2.successor, m2 ? _ : b2);
      }
      ae(h, function() {
        var C = "";
        throw new Error(C);
      });
      function b2(C) {
        c2[C].entryCount--, c2[C].entryCount === 0 && f2.push(C);
      }
      function _(C) {
        h[C] = true, b2(C);
      }
    };
    function e2(i) {
      var o = {}, s = [];
      return ae(i, function(u) {
        var l2 = n2(o, u), c2 = l2.originalDeps = t2(u), f2 = a(c2, i);
        l2.entryCount = f2.length, l2.entryCount === 0 && s.push(u), ae(f2, function(h) {
          va(l2.predecessor, h) < 0 && l2.predecessor.push(h);
          var v9 = n2(o, h);
          va(v9.successor, h) < 0 && v9.successor.push(u);
        });
      }), { graph: o, noEntryList: s };
    }
    function n2(i, o) {
      return i[o] || (i[o] = { predecessor: [], successor: [] }), i[o];
    }
    function a(i, o) {
      var s = [];
      return ae(i, function(u) {
        va(o, u) >= 0 && s.push(u);
      }), s;
    }
  }
  function Ty(r2, t2) {
    return ea(ea({}, r2, true), t2, true);
  }
  var xue = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, wue = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, aP = "ZH", sF = "EN", iE = sF, L5 = {}, uF = {}, KU = Ei.domSupported ? function() {
    var r2 = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
    return r2.indexOf(aP) > -1 ? aP : iE;
  }() : iE;
  function ZU(r2, t2) {
    r2 = r2.toUpperCase(), uF[r2] = new To(t2), L5[r2] = t2;
  }
  function Sue(r2) {
    if (Zr(r2)) {
      var t2 = L5[r2.toUpperCase()] || {};
      return r2 === aP || r2 === sF ? On(t2) : ea(On(t2), On(L5[iE]), false);
    } else
      return ea(On(r2), On(L5[iE]), false);
  }
  function f4(r2) {
    return uF[r2];
  }
  function Cue() {
    return uF[iE];
  }
  ZU(sF, xue);
  ZU(aP, wue);
  var lF = 1e3, cF = lF * 60, jC = cF * 60, zh = jC * 24, N7 = zh * 365, SC = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, DM = "{yyyy}-{MM}-{dd}", V7 = { year: "{yyyy}", month: "{yyyy}-{MM}", day: DM, hour: DM + " " + SC.hour, minute: DM + " " + SC.minute, second: DM + " " + SC.second, millisecond: SC.none }, FO = ["year", "month", "day", "hour", "minute", "second", "millisecond"], XU = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
  function gb(r2, t2) {
    return r2 += "", "0000".substr(0, t2 - r2.length) + r2;
  }
  function Zx(r2) {
    switch (r2) {
      case "half-year":
      case "quarter":
        return "month";
      case "week":
      case "half-week":
        return "day";
      case "half-day":
      case "quarter-day":
        return "hour";
      default:
        return r2;
    }
  }
  function Eue(r2) {
    return r2 === Zx(r2);
  }
  function Aue(r2) {
    switch (r2) {
      case "year":
      case "month":
        return "day";
      case "millisecond":
        return "millisecond";
      default:
        return "second";
    }
  }
  function i3(r2, t2, e2, n2) {
    var a = rp(r2), i = a[fF(e2)](), o = a[Xx(e2)]() + 1, s = Math.floor((o - 1) / 4) + 1, u = a[o3(e2)](), l2 = a["get" + (e2 ? "UTC" : "") + "Day"](), c2 = a[oE(e2)](), f2 = (c2 - 1) % 12 + 1, h = a[s3(e2)](), v9 = a[u3(e2)](), d2 = a[l3(e2)](), m2 = n2 instanceof To ? n2 : f4(n2 || KU) || Cue(), b2 = m2.getModel("time"), _ = b2.get("month"), C = b2.get("monthAbbr"), M = b2.get("dayOfWeek"), E = b2.get("dayOfWeekAbbr");
    return (t2 || "").replace(/{yyyy}/g, i + "").replace(/{yy}/g, i % 100 + "").replace(/{Q}/g, s + "").replace(/{MMMM}/g, _[o - 1]).replace(/{MMM}/g, C[o - 1]).replace(/{MM}/g, gb(o, 2)).replace(/{M}/g, o + "").replace(/{dd}/g, gb(u, 2)).replace(/{d}/g, u + "").replace(/{eeee}/g, M[l2]).replace(/{ee}/g, E[l2]).replace(/{e}/g, l2 + "").replace(/{HH}/g, gb(c2, 2)).replace(/{H}/g, c2 + "").replace(/{hh}/g, gb(f2 + "", 2)).replace(/{h}/g, f2 + "").replace(/{mm}/g, gb(h, 2)).replace(/{m}/g, h + "").replace(/{ss}/g, gb(v9, 2)).replace(/{s}/g, v9 + "").replace(/{SSS}/g, gb(d2, 3)).replace(/{S}/g, d2 + "");
  }
  function Tue(r2, t2, e2, n2, a) {
    var i = null;
    if (Zr(e2))
      i = e2;
    else if (xn(e2))
      i = e2(r2.value, t2, { level: r2.level });
    else {
      var o = qt({}, SC);
      if (r2.level > 0)
        for (var s = 0; s < FO.length; ++s)
          o[FO[s]] = "{primary|" + o[FO[s]] + "}";
      var u = e2 ? e2.inherit === false ? e2 : En(e2, o) : o, l2 = JU(r2.value, a);
      if (u[l2])
        i = u[l2];
      else if (u.inherit) {
        for (var c2 = XU.indexOf(l2), s = c2 - 1; s >= 0; --s)
          if (u[l2]) {
            i = u[l2];
            break;
          }
        i = i || o.none;
      }
      if (vr(i)) {
        var f2 = r2.level == null ? 0 : r2.level >= 0 ? r2.level : i.length + r2.level;
        f2 = Math.min(f2, i.length - 1), i = i[f2];
      }
    }
    return i3(new Date(r2.value), i, a, n2);
  }
  function JU(r2, t2) {
    var e2 = rp(r2), n2 = e2[Xx(t2)]() + 1, a = e2[o3(t2)](), i = e2[oE(t2)](), o = e2[s3(t2)](), s = e2[u3(t2)](), u = e2[l3(t2)](), l2 = u === 0, c2 = l2 && s === 0, f2 = c2 && o === 0, h = f2 && i === 0, v9 = h && a === 1, d2 = v9 && n2 === 1;
    return d2 ? "year" : v9 ? "month" : h ? "day" : f2 ? "hour" : c2 ? "minute" : l2 ? "second" : "millisecond";
  }
  function j7(r2, t2, e2) {
    var n2 = Ai(r2) ? rp(r2) : r2;
    switch (t2 = t2 || JU(r2, e2), t2) {
      case "year":
        return n2[fF(e2)]();
      case "half-year":
        return n2[Xx(e2)]() >= 6 ? 1 : 0;
      case "quarter":
        return Math.floor((n2[Xx(e2)]() + 1) / 4);
      case "month":
        return n2[Xx(e2)]();
      case "day":
        return n2[o3(e2)]();
      case "half-day":
        return n2[oE(e2)]() / 24;
      case "hour":
        return n2[oE(e2)]();
      case "minute":
        return n2[s3(e2)]();
      case "second":
        return n2[u3(e2)]();
      case "millisecond":
        return n2[l3(e2)]();
    }
  }
  function fF(r2) {
    return r2 ? "getUTCFullYear" : "getFullYear";
  }
  function Xx(r2) {
    return r2 ? "getUTCMonth" : "getMonth";
  }
  function o3(r2) {
    return r2 ? "getUTCDate" : "getDate";
  }
  function oE(r2) {
    return r2 ? "getUTCHours" : "getHours";
  }
  function s3(r2) {
    return r2 ? "getUTCMinutes" : "getMinutes";
  }
  function u3(r2) {
    return r2 ? "getUTCSeconds" : "getSeconds";
  }
  function l3(r2) {
    return r2 ? "getUTCMilliseconds" : "getMilliseconds";
  }
  function Mue(r2) {
    return r2 ? "setUTCFullYear" : "setFullYear";
  }
  function QU(r2) {
    return r2 ? "setUTCMonth" : "setMonth";
  }
  function eH(r2) {
    return r2 ? "setUTCDate" : "setDate";
  }
  function tH(r2) {
    return r2 ? "setUTCHours" : "setHours";
  }
  function rH(r2) {
    return r2 ? "setUTCMinutes" : "setMinutes";
  }
  function nH(r2) {
    return r2 ? "setUTCSeconds" : "setSeconds";
  }
  function aH(r2) {
    return r2 ? "setUTCMilliseconds" : "setMilliseconds";
  }
  function iH(r2) {
    if (!jW(r2))
      return Zr(r2) ? r2 : "-";
    var t2 = (r2 + "").split(".");
    return t2[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (t2.length > 1 ? "." + t2[1] : "");
  }
  function oH(r2, t2) {
    return r2 = (r2 || "").toLowerCase().replace(/-(.)/g, function(e2, n2) {
      return n2.toUpperCase();
    }), t2 && r2 && (r2 = r2.charAt(0).toUpperCase() + r2.slice(1)), r2;
  }
  var mw = j6, Pue = /([&<>"'])/g, Due = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
  function Yf(r2) {
    return r2 == null ? "" : (r2 + "").replace(Pue, function(t2, e2) {
      return Due[e2];
    });
  }
  function h4(r2, t2, e2) {
    var n2 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
    function a(c2) {
      return c2 && jv(c2) ? c2 : "-";
    }
    function i(c2) {
      return !!(c2 != null && !isNaN(c2) && isFinite(c2));
    }
    var o = t2 === "time", s = r2 instanceof Date;
    if (o || s) {
      var u = o ? rp(r2) : r2;
      if (isNaN(+u)) {
        if (s)
          return "-";
      } else
        return i3(u, n2, e2);
    }
    if (t2 === "ordinal")
      return DR(r2) ? a(r2) : Ai(r2) && i(r2) ? r2 + "" : "-";
    var l2 = Pg(r2);
    return i(l2) ? iH(l2) : DR(r2) ? a(r2) : typeof r2 == "boolean" ? r2 + "" : "-";
  }
  var B7 = ["a", "b", "c", "d", "e", "f", "g"], NO = function(r2, t2) {
    return "{" + r2 + (t2 == null ? "" : t2) + "}";
  };
  function sH(r2, t2, e2) {
    vr(t2) || (t2 = [t2]);
    var n2 = t2.length;
    if (!n2)
      return "";
    for (var a = t2[0].$vars || [], i = 0; i < a.length; i++) {
      var o = B7[i];
      r2 = r2.replace(NO(o), NO(o, 0));
    }
    for (var s = 0; s < n2; s++)
      for (var u = 0; u < a.length; u++) {
        var l2 = t2[s][a[u]];
        r2 = r2.replace(NO(B7[u], s), e2 ? Yf(l2) : l2);
      }
    return r2;
  }
  function Iue(r2, t2, e2) {
    return ae(t2, function(n2, a) {
      r2 = r2.replace("{" + a + "}", e2 ? Yf(n2) : n2);
    }), r2;
  }
  function Lue(r2, t2) {
    var e2 = Zr(r2) ? { color: r2, extraCssText: t2 } : r2 || {}, n2 = e2.color, a = e2.type;
    t2 = e2.extraCssText;
    var i = e2.renderMode || "html";
    if (!n2)
      return "";
    if (i === "html")
      return a === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + Yf(n2) + ";" + (t2 || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + Yf(n2) + ";" + (t2 || "") + '"></span>';
    var o = e2.markerId || "markerX";
    return { renderMode: i, content: "{" + o + "|}  ", style: a === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: n2 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: n2 } };
  }
  function n1(r2, t2) {
    return t2 = t2 || "transparent", Zr(r2) ? r2 : Tn(r2) && r2.colorStops && (r2.colorStops[0] || {}).color || t2;
  }
  function iP(r2, t2) {
    if (t2 === "_blank" || t2 === "blank") {
      var e2 = window.open();
      e2.opener = null, e2.location.href = r2;
    } else
      window.open(r2, t2);
  }
  var O5 = ae, uH = ["left", "right", "top", "bottom", "width", "height"], zb = [["width", "left", "right"], ["height", "top", "bottom"]];
  function hF(r2, t2, e2, n2, a) {
    var i = 0, o = 0;
    n2 == null && (n2 = 1 / 0), a == null && (a = 1 / 0);
    var s = 0;
    t2.eachChild(function(u, l2) {
      var c2 = u.getBoundingRect(), f2 = t2.childAt(l2 + 1), h = f2 && f2.getBoundingRect(), v9, d2;
      if (r2 === "horizontal") {
        var m2 = c2.width + (h ? -h.x + c2.x : 0);
        v9 = i + m2, v9 > n2 || u.newline ? (i = 0, v9 = m2, o += s + e2, s = c2.height) : s = Math.max(s, c2.height);
      } else {
        var b2 = c2.height + (h ? -h.y + c2.y : 0);
        d2 = o + b2, d2 > a || u.newline ? (i += s + e2, o = 0, d2 = b2, s = c2.width) : s = Math.max(s, c2.width);
      }
      u.newline || (u.x = i, u.y = o, u.markRedraw(), r2 === "horizontal" ? i = v9 + e2 : o = d2 + e2);
    });
  }
  var Kb = hF;
  Gn(hF, "vertical");
  Gn(hF, "horizontal");
  function Oue(r2, t2, e2) {
    var n2 = t2.width, a = t2.height, i = qr(r2.left, n2), o = qr(r2.top, a), s = qr(r2.right, n2), u = qr(r2.bottom, a);
    return (isNaN(i) || isNaN(parseFloat(r2.left))) && (i = 0), (isNaN(s) || isNaN(parseFloat(r2.right))) && (s = n2), (isNaN(o) || isNaN(parseFloat(r2.top))) && (o = 0), (isNaN(u) || isNaN(parseFloat(r2.bottom))) && (u = a), e2 = mw(e2 || 0), { width: Math.max(s - i - e2[1] - e2[3], 0), height: Math.max(u - o - e2[0] - e2[2], 0) };
  }
  function Eu(r2, t2, e2) {
    e2 = mw(e2 || 0);
    var n2 = t2.width, a = t2.height, i = qr(r2.left, n2), o = qr(r2.top, a), s = qr(r2.right, n2), u = qr(r2.bottom, a), l2 = qr(r2.width, n2), c2 = qr(r2.height, a), f2 = e2[2] + e2[0], h = e2[1] + e2[3], v9 = r2.aspect;
    switch (isNaN(l2) && (l2 = n2 - s - h - i), isNaN(c2) && (c2 = a - u - f2 - o), v9 != null && (isNaN(l2) && isNaN(c2) && (v9 > n2 / a ? l2 = n2 * 0.8 : c2 = a * 0.8), isNaN(l2) && (l2 = v9 * c2), isNaN(c2) && (c2 = l2 / v9)), isNaN(i) && (i = n2 - s - l2 - h), isNaN(o) && (o = a - u - c2 - f2), r2.left || r2.right) {
      case "center":
        i = n2 / 2 - l2 / 2 - e2[3];
        break;
      case "right":
        i = n2 - l2 - h;
        break;
    }
    switch (r2.top || r2.bottom) {
      case "middle":
      case "center":
        o = a / 2 - c2 / 2 - e2[0];
        break;
      case "bottom":
        o = a - c2 - f2;
        break;
    }
    i = i || 0, o = o || 0, isNaN(l2) && (l2 = n2 - h - i - (s || 0)), isNaN(c2) && (c2 = a - f2 - o - (u || 0));
    var d2 = new da(i + e2[3], o + e2[0], l2, c2);
    return d2.margin = e2, d2;
  }
  function c3(r2, t2, e2, n2, a, i) {
    var o = !a || !a.hv || a.hv[0], s = !a || !a.hv || a.hv[1], u = a && a.boundingMode || "all";
    if (i = i || r2, i.x = r2.x, i.y = r2.y, !o && !s)
      return false;
    var l2;
    if (u === "raw")
      l2 = r2.type === "group" ? new da(0, 0, +t2.width || 0, +t2.height || 0) : r2.getBoundingRect();
    else if (l2 = r2.getBoundingRect(), r2.needLocalTransform()) {
      var c2 = r2.getLocalTransform();
      l2 = l2.clone(), l2.applyTransform(c2);
    }
    var f2 = Eu(En({ width: l2.width, height: l2.height }, t2), e2, n2), h = o ? f2.x - l2.x : 0, v9 = s ? f2.y - l2.y : 0;
    return u === "raw" ? (i.x = h, i.y = v9) : (i.x += h, i.y += v9), i === r2 && r2.markRedraw(), true;
  }
  function kue(r2, t2) {
    return r2[zb[t2][0]] != null || r2[zb[t2][1]] != null && r2[zb[t2][2]] != null;
  }
  function sE(r2) {
    var t2 = r2.layoutMode || r2.constructor.layoutMode;
    return Tn(t2) ? t2 : t2 ? { type: t2 } : null;
  }
  function by(r2, t2, e2) {
    var n2 = e2 && e2.ignoreSize;
    !vr(n2) && (n2 = [n2, n2]);
    var a = o(zb[0], 0), i = o(zb[1], 1);
    l2(zb[0], r2, a), l2(zb[1], r2, i);
    function o(c2, f2) {
      var h = {}, v9 = 0, d2 = {}, m2 = 0, b2 = 2;
      if (O5(c2, function(M) {
        d2[M] = r2[M];
      }), O5(c2, function(M) {
        s(t2, M) && (h[M] = d2[M] = t2[M]), u(h, M) && v9++, u(d2, M) && m2++;
      }), n2[f2])
        return u(t2, c2[1]) ? d2[c2[2]] = null : u(t2, c2[2]) && (d2[c2[1]] = null), d2;
      if (m2 === b2 || !v9)
        return d2;
      if (v9 >= b2)
        return h;
      for (var _ = 0; _ < c2.length; _++) {
        var C = c2[_];
        if (!s(h, C) && s(r2, C)) {
          h[C] = r2[C];
          break;
        }
      }
      return h;
    }
    function s(c2, f2) {
      return c2.hasOwnProperty(f2);
    }
    function u(c2, f2) {
      return c2[f2] != null && c2[f2] !== "auto";
    }
    function l2(c2, f2, h) {
      O5(c2, function(v9) {
        f2[v9] = h[v9];
      });
    }
  }
  function bw(r2) {
    return lH({}, r2);
  }
  function lH(r2, t2) {
    return t2 && r2 && O5(uH, function(e2) {
      t2.hasOwnProperty(e2) && (r2[e2] = t2[e2]);
    }), r2;
  }
  var Rue = fi(), _w = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this, e2, n2, a) || this;
      return i.uid = yw("ec_cpt_model"), i;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.mergeDefaultAndTheme(e2, a);
    }, t2.prototype.mergeDefaultAndTheme = function(e2, n2) {
      var a = sE(this), i = a ? bw(e2) : {}, o = n2.getTheme();
      ea(e2, o.get(this.mainType)), ea(e2, this.getDefaultOption()), a && by(e2, i, a);
    }, t2.prototype.mergeOption = function(e2, n2) {
      ea(this.option, e2, true);
      var a = sE(this);
      a && by(this.option, e2, a);
    }, t2.prototype.optionUpdated = function(e2, n2) {
    }, t2.prototype.getDefaultOption = function() {
      var e2 = this.constructor;
      if (!foe(e2))
        return e2.defaultOption;
      var n2 = Rue(this);
      if (!n2.defaultOption) {
        for (var a = [], i = e2; i; ) {
          var o = i.prototype.defaultOption;
          o && a.push(o), i = i.superClass;
        }
        for (var s = {}, u = a.length - 1; u >= 0; u--)
          s = ea(s, a[u], true);
        n2.defaultOption = s;
      }
      return n2.defaultOption;
    }, t2.prototype.getReferringComponents = function(e2, n2) {
      var a = e2 + "Index", i = e2 + "Id";
      return DE(this.ecModel, e2, { index: this.get(a, true), id: this.get(i, true) }, n2);
    }, t2.prototype.getBoxLayoutParams = function() {
      var e2 = this;
      return { left: e2.get("left"), top: e2.get("top"), right: e2.get("right"), bottom: e2.get("bottom"), width: e2.get("width"), height: e2.get("height") };
    }, t2.prototype.getZLevelKey = function() {
      return "";
    }, t2.prototype.setZLevel = function(e2) {
      this.option.zlevel = e2;
    }, t2.protoInitialize = function() {
      var e2 = t2.prototype;
      e2.type = "component", e2.id = "", e2.name = "", e2.mainType = "", e2.subType = "", e2.componentIndex = 0;
    }(), t2;
  }(To);
  KW(_w, To);
  YP(_w);
  bue(_w);
  _ue(_w, Fue);
  function Fue(r2) {
    var t2 = [];
    return ae(_w.getClassesByMainType(r2), function(e2) {
      t2 = t2.concat(e2.dependencies || e2.prototype.dependencies || []);
    }), t2 = pr(t2, function(e2) {
      return Hd(e2).main;
    }), r2 !== "dataset" && va(t2, "dataset") <= 0 && t2.unshift("dataset"), t2;
  }
  var li = _w, cH = "";
  typeof navigator != "undefined" && (cH = navigator.platform || "");
  var mx = "rgba(0, 0, 0, 0.2)", Nue = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: mx, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: mx, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: mx, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: mx, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: mx, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: mx, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: cH.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, fH = mn(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), Kh = "original", cc = "arrayRows", Zh = "objectRows", ip = "keyedColumns", vy = "typedArray", hH = "unknown", Xd = "column", xw = "row", Fl = { Must: 1, Might: 2, Not: 3 }, vH = fi();
  function Vue(r2) {
    vH(r2).datasetMap = mn();
  }
  function dH(r2, t2, e2) {
    var n2 = {}, a = dF(t2);
    if (!a || !r2)
      return n2;
    var i = [], o = [], s = t2.ecModel, u = vH(s).datasetMap, l2 = a.uid + "_" + e2.seriesLayoutBy, c2, f2;
    r2 = r2.slice(), ae(r2, function(m2, b2) {
      var _ = Tn(m2) ? m2 : r2[b2] = { name: m2 };
      _.type === "ordinal" && c2 == null && (c2 = b2, f2 = d2(_)), n2[_.name] = [];
    });
    var h = u.get(l2) || u.set(l2, { categoryWayDim: f2, valueWayDim: 0 });
    ae(r2, function(m2, b2) {
      var _ = m2.name, C = d2(m2);
      if (c2 == null) {
        var M = h.valueWayDim;
        v9(n2[_], M, C), v9(o, M, C), h.valueWayDim += C;
      } else if (c2 === b2)
        v9(n2[_], 0, C), v9(i, 0, C);
      else {
        var M = h.categoryWayDim;
        v9(n2[_], M, C), v9(o, M, C), h.categoryWayDim += C;
      }
    });
    function v9(m2, b2, _) {
      for (var C = 0; C < _; C++)
        m2.push(b2 + C);
    }
    function d2(m2) {
      var b2 = m2.dimsDef;
      return b2 ? b2.length : 1;
    }
    return i.length && (n2.itemName = i), o.length && (n2.seriesName = o), n2;
  }
  function vF(r2, t2, e2) {
    var n2 = {}, a = dF(r2);
    if (!a)
      return n2;
    var i = t2.sourceFormat, o = t2.dimensionsDefine, s;
    (i === Zh || i === ip) && ae(o, function(c2, f2) {
      (Tn(c2) ? c2.name : c2) === "name" && (s = f2);
    });
    var u = function() {
      for (var c2 = {}, f2 = {}, h = [], v9 = 0, d2 = Math.min(5, e2); v9 < d2; v9++) {
        var m2 = gH(t2.data, i, t2.seriesLayoutBy, o, t2.startIndex, v9);
        h.push(m2);
        var b2 = m2 === Fl.Not;
        if (b2 && c2.v == null && v9 !== s && (c2.v = v9), (c2.n == null || c2.n === c2.v || !b2 && h[c2.n] === Fl.Not) && (c2.n = v9), _(c2) && h[c2.n] !== Fl.Not)
          return c2;
        b2 || (m2 === Fl.Might && f2.v == null && v9 !== s && (f2.v = v9), (f2.n == null || f2.n === f2.v) && (f2.n = v9));
      }
      function _(C) {
        return C.v != null && C.n != null;
      }
      return _(c2) ? c2 : _(f2) ? f2 : null;
    }();
    if (u) {
      n2.value = [u.v];
      var l2 = s != null ? s : u.n;
      n2.itemName = [l2], n2.seriesName = [l2];
    }
    return n2;
  }
  function dF(r2) {
    var t2 = r2.get("data", true);
    if (!t2)
      return DE(r2.ecModel, "dataset", { index: r2.get("datasetIndex", true), id: r2.get("datasetId", true) }, uu).models[0];
  }
  function jue(r2) {
    return !r2.get("transform", true) && !r2.get("fromTransformResult", true) ? [] : DE(r2.ecModel, "dataset", { index: r2.get("fromDatasetIndex", true), id: r2.get("fromDatasetId", true) }, uu).models;
  }
  function pH(r2, t2) {
    return gH(r2.data, r2.sourceFormat, r2.seriesLayoutBy, r2.dimensionsDefine, r2.startIndex, t2);
  }
  function gH(r2, t2, e2, n2, a, i) {
    var o, s = 5;
    if (Qf(r2))
      return Fl.Not;
    var u, l2;
    if (n2) {
      var c2 = n2[i];
      Tn(c2) ? (u = c2.name, l2 = c2.type) : Zr(c2) && (u = c2);
    }
    if (l2 != null)
      return l2 === "ordinal" ? Fl.Must : Fl.Not;
    if (t2 === cc) {
      var f2 = r2;
      if (e2 === xw) {
        for (var h = f2[i], v9 = 0; v9 < (h || []).length && v9 < s; v9++)
          if ((o = E(h[a + v9])) != null)
            return o;
      } else
        for (var v9 = 0; v9 < f2.length && v9 < s; v9++) {
          var d2 = f2[a + v9];
          if (d2 && (o = E(d2[i])) != null)
            return o;
        }
    } else if (t2 === Zh) {
      var m2 = r2;
      if (!u)
        return Fl.Not;
      for (var v9 = 0; v9 < m2.length && v9 < s; v9++) {
        var b2 = m2[v9];
        if (b2 && (o = E(b2[u])) != null)
          return o;
      }
    } else if (t2 === ip) {
      var _ = r2;
      if (!u)
        return Fl.Not;
      var h = _[u];
      if (!h || Qf(h))
        return Fl.Not;
      for (var v9 = 0; v9 < h.length && v9 < s; v9++)
        if ((o = E(h[v9])) != null)
          return o;
    } else if (t2 === Kh)
      for (var C = r2, v9 = 0; v9 < C.length && v9 < s; v9++) {
        var b2 = C[v9], M = hw(b2);
        if (!vr(M))
          return Fl.Not;
        if ((o = E(M[i])) != null)
          return o;
      }
    function E(z9) {
      var V = Zr(z9);
      if (z9 != null && isFinite(z9) && z9 !== "")
        return V ? Fl.Might : Fl.Not;
      if (V && z9 !== "-")
        return Fl.Must;
    }
    return Fl.Not;
  }
  var v4 = mn();
  function Bue(r2, t2) {
    Fc(v4.get(r2) == null && t2), v4.set(r2, t2);
  }
  function zue(r2, t2, e2) {
    var n2 = v4.get(t2);
    if (!n2)
      return e2;
    var a = n2(r2);
    return a ? e2.concat(a) : e2;
  }
  var z7 = fi(), $ue = fi(), pF = function() {
    function r2() {
    }
    return r2.prototype.getColorFromPalette = function(t2, e2, n2) {
      var a = ao(this.get("color", true)), i = this.get("colorLayer", true);
      return yH(this, z7, a, i, t2, e2, n2);
    }, r2.prototype.clearColorPalette = function() {
      Wue(this, z7);
    }, r2;
  }();
  function d4(r2, t2, e2, n2) {
    var a = ao(r2.get(["aria", "decal", "decals"]));
    return yH(r2, $ue, a, null, t2, e2, n2);
  }
  function Gue(r2, t2) {
    for (var e2 = r2.length, n2 = 0; n2 < e2; n2++)
      if (r2[n2].length > t2)
        return r2[n2];
    return r2[e2 - 1];
  }
  function yH(r2, t2, e2, n2, a, i, o) {
    i = i || r2;
    var s = t2(i), u = s.paletteIdx || 0, l2 = s.paletteNameMap = s.paletteNameMap || {};
    if (l2.hasOwnProperty(a))
      return l2[a];
    var c2 = o == null || !n2 ? e2 : Gue(n2, o);
    if (c2 = c2 || e2, !(!c2 || !c2.length)) {
      var f2 = c2[u];
      return a && (l2[a] = f2), s.paletteIdx = (u + 1) % c2.length, f2;
    }
  }
  function Wue(r2, t2) {
    t2(r2).paletteIdx = 0, t2(r2).paletteNameMap = {};
  }
  var IM, Y2, $7, G7 = "\0_ec_inner", Uue = 1, mH = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.init = function(e2, n2, a, i, o, s) {
      i = i || {}, this.option = null, this._theme = new To(i), this._locale = new To(o), this._optionManager = s;
    }, t2.prototype.setOption = function(e2, n2, a) {
      var i = H7(n2);
      this._optionManager.setOption(e2, a, i), this._resetOption(null, i);
    }, t2.prototype.resetOption = function(e2, n2) {
      return this._resetOption(e2, H7(n2));
    }, t2.prototype._resetOption = function(e2, n2) {
      var a = false, i = this._optionManager;
      if (!e2 || e2 === "recreate") {
        var o = i.mountOption(e2 === "recreate");
        !this.option || e2 === "recreate" ? $7(this, o) : (this.restoreData(), this._mergeOption(o, n2)), a = true;
      }
      if ((e2 === "timeline" || e2 === "media") && this.restoreData(), !e2 || e2 === "recreate" || e2 === "timeline") {
        var s = i.getTimelineOption(this);
        s && (a = true, this._mergeOption(s, n2));
      }
      if (!e2 || e2 === "recreate" || e2 === "media") {
        var u = i.getMediaOption(this);
        u.length && ae(u, function(l2) {
          a = true, this._mergeOption(l2, n2);
        }, this);
      }
      return a;
    }, t2.prototype.mergeOption = function(e2) {
      this._mergeOption(e2, null);
    }, t2.prototype._mergeOption = function(e2, n2) {
      var a = this.option, i = this._componentsMap, o = this._componentsCount, s = [], u = mn(), l2 = n2 && n2.replaceMergeMainTypeMap;
      Vue(this), ae(e2, function(f2, h) {
        f2 != null && (li.hasClass(h) ? h && (s.push(h), u.set(h, true)) : a[h] = a[h] == null ? On(f2) : ea(a[h], f2, true));
      }), l2 && l2.each(function(f2, h) {
        li.hasClass(h) && !u.get(h) && (s.push(h), u.set(h, true));
      }), li.topologicalTravel(s, li.getAllClassMainTypes(), c2, this);
      function c2(f2) {
        var h = zue(this, f2, ao(e2[f2])), v9 = i.get(f2), d2 = v9 ? l2 && l2.get(f2) ? "replaceMerge" : "normalMerge" : "replaceAll", m2 = WW(v9, h, d2);
        roe(m2, f2, li), a[f2] = null, i.set(f2, null), o.set(f2, 0);
        var b2 = [], _ = [], C = 0, M;
        ae(m2, function(E, z9) {
          var V = E.existing, $ = E.newOption;
          if (!$)
            V && (V.mergeOption({}, this), V.optionUpdated({}, false));
          else {
            var U = f2 === "series", H = li.getClass(f2, E.keyInfo.subType, !U);
            if (!H)
              return;
            if (f2 === "tooltip") {
              if (M)
                return;
              M = true;
            }
            if (V && V.constructor === H)
              V.name = E.keyInfo.name, V.mergeOption($, this), V.optionUpdated($, false);
            else {
              var q3 = qt({ componentIndex: z9 }, E.keyInfo);
              V = new H($, this, this, q3), qt(V, q3), E.brandNew && (V.__requireNewView = true), V.init($, this, this), V.optionUpdated(null, true);
            }
          }
          V ? (b2.push(V.option), _.push(V), C++) : (b2.push(void 0), _.push(void 0));
        }, this), a[f2] = b2, i.set(f2, _), o.set(f2, C), f2 === "series" && IM(this);
      }
      this._seriesIndices || IM(this);
    }, t2.prototype.getOption = function() {
      var e2 = On(this.option);
      return ae(e2, function(n2, a) {
        if (li.hasClass(a)) {
          for (var i = ao(n2), o = i.length, s = false, u = o - 1; u >= 0; u--)
            i[u] && !eE(i[u]) ? s = true : (i[u] = null, !s && o--);
          i.length = o, e2[a] = i;
        }
      }), delete e2[G7], e2;
    }, t2.prototype.getTheme = function() {
      return this._theme;
    }, t2.prototype.getLocaleModel = function() {
      return this._locale;
    }, t2.prototype.setUpdatePayload = function(e2) {
      this._payload = e2;
    }, t2.prototype.getUpdatePayload = function() {
      return this._payload;
    }, t2.prototype.getComponent = function(e2, n2) {
      var a = this._componentsMap.get(e2);
      if (a) {
        var i = a[n2 || 0];
        if (i)
          return i;
        if (n2 == null) {
          for (var o = 0; o < a.length; o++)
            if (a[o])
              return a[o];
        }
      }
    }, t2.prototype.queryComponents = function(e2) {
      var n2 = e2.mainType;
      if (!n2)
        return [];
      var a = e2.index, i = e2.id, o = e2.name, s = this._componentsMap.get(n2);
      if (!s || !s.length)
        return [];
      var u;
      return a != null ? (u = [], ae(ao(a), function(l2) {
        s[l2] && u.push(s[l2]);
      })) : i != null ? u = W7("id", i, s) : o != null ? u = W7("name", o, s) : u = no(s, function(l2) {
        return !!l2;
      }), U7(u, e2);
    }, t2.prototype.findComponents = function(e2) {
      var n2 = e2.query, a = e2.mainType, i = s(n2), o = i ? this.queryComponents(i) : no(this._componentsMap.get(a), function(l2) {
        return !!l2;
      });
      return u(U7(o, e2));
      function s(l2) {
        var c2 = a + "Index", f2 = a + "Id", h = a + "Name";
        return l2 && (l2[c2] != null || l2[f2] != null || l2[h] != null) ? { mainType: a, index: l2[c2], id: l2[f2], name: l2[h] } : null;
      }
      function u(l2) {
        return e2.filter ? no(l2, e2.filter) : l2;
      }
    }, t2.prototype.eachComponent = function(e2, n2, a) {
      var i = this._componentsMap;
      if (xn(e2)) {
        var o = n2, s = e2;
        i.each(function(f2, h) {
          for (var v9 = 0; f2 && v9 < f2.length; v9++) {
            var d2 = f2[v9];
            d2 && s.call(o, h, d2, d2.componentIndex);
          }
        });
      } else
        for (var u = Zr(e2) ? i.get(e2) : Tn(e2) ? this.findComponents(e2) : null, l2 = 0; u && l2 < u.length; l2++) {
          var c2 = u[l2];
          c2 && n2.call(a, c2, c2.componentIndex);
        }
    }, t2.prototype.getSeriesByName = function(e2) {
      var n2 = Cu(e2, null);
      return no(this._componentsMap.get("series"), function(a) {
        return !!a && n2 != null && a.name === n2;
      });
    }, t2.prototype.getSeriesByIndex = function(e2) {
      return this._componentsMap.get("series")[e2];
    }, t2.prototype.getSeriesByType = function(e2) {
      return no(this._componentsMap.get("series"), function(n2) {
        return !!n2 && n2.subType === e2;
      });
    }, t2.prototype.getSeries = function() {
      return no(this._componentsMap.get("series"), function(e2) {
        return !!e2;
      });
    }, t2.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, t2.prototype.eachSeries = function(e2, n2) {
      Y2(this), ae(this._seriesIndices, function(a) {
        var i = this._componentsMap.get("series")[a];
        e2.call(n2, i, a);
      }, this);
    }, t2.prototype.eachRawSeries = function(e2, n2) {
      ae(this._componentsMap.get("series"), function(a) {
        a && e2.call(n2, a, a.componentIndex);
      });
    }, t2.prototype.eachSeriesByType = function(e2, n2, a) {
      Y2(this), ae(this._seriesIndices, function(i) {
        var o = this._componentsMap.get("series")[i];
        o.subType === e2 && n2.call(a, o, i);
      }, this);
    }, t2.prototype.eachRawSeriesByType = function(e2, n2, a) {
      return ae(this.getSeriesByType(e2), n2, a);
    }, t2.prototype.isSeriesFiltered = function(e2) {
      return Y2(this), this._seriesIndicesMap.get(e2.componentIndex) == null;
    }, t2.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, t2.prototype.filterSeries = function(e2, n2) {
      Y2(this);
      var a = [];
      ae(this._seriesIndices, function(i) {
        var o = this._componentsMap.get("series")[i];
        e2.call(n2, o, i) && a.push(i);
      }, this), this._seriesIndices = a, this._seriesIndicesMap = mn(a);
    }, t2.prototype.restoreData = function(e2) {
      IM(this);
      var n2 = this._componentsMap, a = [];
      n2.each(function(i, o) {
        li.hasClass(o) && a.push(o);
      }), li.topologicalTravel(a, li.getAllClassMainTypes(), function(i) {
        ae(n2.get(i), function(o) {
          o && (i !== "series" || !Hue(o, e2)) && o.restoreData();
        });
      });
    }, t2.internalField = function() {
      IM = function(e2) {
        var n2 = e2._seriesIndices = [];
        ae(e2._componentsMap.get("series"), function(a) {
          a && n2.push(a.componentIndex);
        }), e2._seriesIndicesMap = mn(n2);
      }, Y2 = function(e2) {
      }, $7 = function(e2, n2) {
        e2.option = {}, e2.option[G7] = Uue, e2._componentsMap = mn({ series: [] }), e2._componentsCount = mn();
        var a = n2.aria;
        Tn(a) && a.enabled == null && (a.enabled = true), que(n2, e2._theme.option), ea(n2, Nue, false), e2._mergeOption(n2, null);
      };
    }(), t2;
  }(To);
  function Hue(r2, t2) {
    if (t2) {
      var e2 = t2.seriesIndex, n2 = t2.seriesId, a = t2.seriesName;
      return e2 != null && r2.componentIndex !== e2 || n2 != null && r2.id !== n2 || a != null && r2.name !== a;
    }
  }
  function que(r2, t2) {
    var e2 = r2.color && !r2.colorLayer;
    ae(t2, function(n2, a) {
      a === "colorLayer" && e2 || li.hasClass(a) || (typeof n2 == "object" ? r2[a] = r2[a] ? ea(r2[a], n2, false) : On(n2) : r2[a] == null && (r2[a] = n2));
    });
  }
  function W7(r2, t2, e2) {
    if (vr(t2)) {
      var n2 = mn();
      return ae(t2, function(i) {
        if (i != null) {
          var o = Cu(i, null);
          o != null && n2.set(i, true);
        }
      }), no(e2, function(i) {
        return i && n2.get(i[r2]);
      });
    } else {
      var a = Cu(t2, null);
      return no(e2, function(i) {
        return i && a != null && i[r2] === a;
      });
    }
  }
  function U7(r2, t2) {
    return t2.hasOwnProperty("subType") ? no(r2, function(e2) {
      return e2 && e2.subType === t2.subType;
    }) : r2;
  }
  function H7(r2) {
    var t2 = mn();
    return r2 && ae(ao(r2.replaceMerge), function(e2) {
      t2.set(e2, true);
    }), { replaceMergeMainTypeMap: t2 };
  }
  fu(mH, pF);
  var bH = mH, Yue = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], Kue = function() {
    function r2(t2) {
      ae(Yue, function(e2) {
        this[e2] = en(t2[e2], t2);
      }, this);
    }
    return r2;
  }(), _H = Kue, VO = {}, Zue = function() {
    function r2() {
      this._coordinateSystems = [];
    }
    return r2.prototype.create = function(t2, e2) {
      var n2 = [];
      ae(VO, function(a, i) {
        var o = a.create(t2, e2);
        n2 = n2.concat(o || []);
      }), this._coordinateSystems = n2;
    }, r2.prototype.update = function(t2, e2) {
      ae(this._coordinateSystems, function(n2) {
        n2.update && n2.update(t2, e2);
      });
    }, r2.prototype.getCoordinateSystems = function() {
      return this._coordinateSystems.slice();
    }, r2.register = function(t2, e2) {
      VO[t2] = e2;
    }, r2.get = function(t2) {
      return VO[t2];
    }, r2;
  }(), FE = Zue, Xue = /^(min|max)?(.+)$/, Jue = function() {
    function r2(t2) {
      this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = t2;
    }
    return r2.prototype.setOption = function(t2, e2, n2) {
      t2 && (ae(ao(t2.series), function(o) {
        o && o.data && Qf(o.data) && G5(o.data);
      }), ae(ao(t2.dataset), function(o) {
        o && o.source && Qf(o.source) && G5(o.source);
      })), t2 = On(t2);
      var a = this._optionBackup, i = Que(t2, e2, !a);
      this._newBaseOption = i.baseOption, a ? (i.timelineOptions.length && (a.timelineOptions = i.timelineOptions), i.mediaList.length && (a.mediaList = i.mediaList), i.mediaDefault && (a.mediaDefault = i.mediaDefault)) : this._optionBackup = i;
    }, r2.prototype.mountOption = function(t2) {
      var e2 = this._optionBackup;
      return this._timelineOptions = e2.timelineOptions, this._mediaList = e2.mediaList, this._mediaDefault = e2.mediaDefault, this._currentMediaIndices = [], On(t2 ? e2.baseOption : this._newBaseOption);
    }, r2.prototype.getTimelineOption = function(t2) {
      var e2, n2 = this._timelineOptions;
      if (n2.length) {
        var a = t2.getComponent("timeline");
        a && (e2 = On(n2[a.getCurrentIndex()]));
      }
      return e2;
    }, r2.prototype.getMediaOption = function(t2) {
      var e2 = this._api.getWidth(), n2 = this._api.getHeight(), a = this._mediaList, i = this._mediaDefault, o = [], s = [];
      if (!a.length && !i)
        return s;
      for (var u = 0, l2 = a.length; u < l2; u++)
        ele(a[u].query, e2, n2) && o.push(u);
      return !o.length && i && (o = [-1]), o.length && !rle(o, this._currentMediaIndices) && (s = pr(o, function(c2) {
        return On(c2 === -1 ? i.option : a[c2].option);
      })), this._currentMediaIndices = o, s;
    }, r2;
  }();
  function Que(r2, t2, e2) {
    var n2 = [], a, i, o = r2.baseOption, s = r2.timeline, u = r2.options, l2 = r2.media, c2 = !!r2.media, f2 = !!(u || s || o && o.timeline);
    o ? (i = o, i.timeline || (i.timeline = s)) : ((f2 || c2) && (r2.options = r2.media = null), i = r2), c2 && vr(l2) && ae(l2, function(v9) {
      v9 && v9.option && (v9.query ? n2.push(v9) : a || (a = v9));
    }), h(i), ae(u, function(v9) {
      return h(v9);
    }), ae(n2, function(v9) {
      return h(v9.option);
    });
    function h(v9) {
      ae(t2, function(d2) {
        d2(v9, e2);
      });
    }
    return { baseOption: i, timelineOptions: u || [], mediaDefault: a, mediaList: n2 };
  }
  function ele(r2, t2, e2) {
    var n2 = { width: t2, height: e2, aspectratio: t2 / e2 }, a = true;
    return ae(r2, function(i, o) {
      var s = o.match(Xue);
      if (!(!s || !s[1] || !s[2])) {
        var u = s[1], l2 = s[2].toLowerCase();
        tle(n2[l2], i, u) || (a = false);
      }
    }), a;
  }
  function tle(r2, t2, e2) {
    return e2 === "min" ? r2 >= t2 : e2 === "max" ? r2 <= t2 : r2 === t2;
  }
  function rle(r2, t2) {
    return r2.join(",") === t2.join(",");
  }
  var nle = Jue, Ov = ae, uE = Tn, q7 = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
  function jO(r2) {
    var t2 = r2 && r2.itemStyle;
    if (!!t2)
      for (var e2 = 0, n2 = q7.length; e2 < n2; e2++) {
        var a = q7[e2], i = t2.normal, o = t2.emphasis;
        i && i[a] && (r2[a] = r2[a] || {}, r2[a].normal ? ea(r2[a].normal, i[a]) : r2[a].normal = i[a], i[a] = null), o && o[a] && (r2[a] = r2[a] || {}, r2[a].emphasis ? ea(r2[a].emphasis, o[a]) : r2[a].emphasis = o[a], o[a] = null);
      }
  }
  function oc(r2, t2, e2) {
    if (r2 && r2[t2] && (r2[t2].normal || r2[t2].emphasis)) {
      var n2 = r2[t2].normal, a = r2[t2].emphasis;
      n2 && (e2 ? (r2[t2].normal = r2[t2].emphasis = null, En(r2[t2], n2)) : r2[t2] = n2), a && (r2.emphasis = r2.emphasis || {}, r2.emphasis[t2] = a, a.focus && (r2.emphasis.focus = a.focus), a.blurScope && (r2.emphasis.blurScope = a.blurScope));
    }
  }
  function CC(r2) {
    oc(r2, "itemStyle"), oc(r2, "lineStyle"), oc(r2, "areaStyle"), oc(r2, "label"), oc(r2, "labelLine"), oc(r2, "upperLabel"), oc(r2, "edgeLabel");
  }
  function su(r2, t2) {
    var e2 = uE(r2) && r2[t2], n2 = uE(e2) && e2.textStyle;
    if (n2)
      for (var a = 0, i = X8.length; a < i; a++) {
        var o = X8[a];
        n2.hasOwnProperty(o) && (e2[o] = n2[o]);
      }
  }
  function kh(r2) {
    r2 && (CC(r2), su(r2, "label"), r2.emphasis && su(r2.emphasis, "label"));
  }
  function ale(r2) {
    if (!!uE(r2)) {
      jO(r2), CC(r2), su(r2, "label"), su(r2, "upperLabel"), su(r2, "edgeLabel"), r2.emphasis && (su(r2.emphasis, "label"), su(r2.emphasis, "upperLabel"), su(r2.emphasis, "edgeLabel"));
      var t2 = r2.markPoint;
      t2 && (jO(t2), kh(t2));
      var e2 = r2.markLine;
      e2 && (jO(e2), kh(e2));
      var n2 = r2.markArea;
      n2 && kh(n2);
      var a = r2.data;
      if (r2.type === "graph") {
        a = a || r2.nodes;
        var i = r2.links || r2.edges;
        if (i && !Qf(i))
          for (var o = 0; o < i.length; o++)
            kh(i[o]);
        ae(r2.categories, function(l2) {
          CC(l2);
        });
      }
      if (a && !Qf(a))
        for (var o = 0; o < a.length; o++)
          kh(a[o]);
      if (t2 = r2.markPoint, t2 && t2.data)
        for (var s = t2.data, o = 0; o < s.length; o++)
          kh(s[o]);
      if (e2 = r2.markLine, e2 && e2.data)
        for (var u = e2.data, o = 0; o < u.length; o++)
          vr(u[o]) ? (kh(u[o][0]), kh(u[o][1])) : kh(u[o]);
      r2.type === "gauge" ? (su(r2, "axisLabel"), su(r2, "title"), su(r2, "detail")) : r2.type === "treemap" ? (oc(r2.breadcrumb, "itemStyle"), ae(r2.levels, function(l2) {
        CC(l2);
      })) : r2.type === "tree" && CC(r2.leaves);
    }
  }
  function vg(r2) {
    return vr(r2) ? r2 : r2 ? [r2] : [];
  }
  function Y7(r2) {
    return (vr(r2) ? r2[0] : r2) || {};
  }
  function ile(r2, t2) {
    Ov(vg(r2.series), function(n2) {
      uE(n2) && ale(n2);
    });
    var e2 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
    t2 && e2.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), Ov(e2, function(n2) {
      Ov(vg(r2[n2]), function(a) {
        a && (su(a, "axisLabel"), su(a.axisPointer, "label"));
      });
    }), Ov(vg(r2.parallel), function(n2) {
      var a = n2 && n2.parallelAxisDefault;
      su(a, "axisLabel"), su(a && a.axisPointer, "label");
    }), Ov(vg(r2.calendar), function(n2) {
      oc(n2, "itemStyle"), su(n2, "dayLabel"), su(n2, "monthLabel"), su(n2, "yearLabel");
    }), Ov(vg(r2.radar), function(n2) {
      su(n2, "name"), n2.name && n2.axisName == null && (n2.axisName = n2.name, delete n2.name), n2.nameGap != null && n2.axisNameGap == null && (n2.axisNameGap = n2.nameGap, delete n2.nameGap);
    }), Ov(vg(r2.geo), function(n2) {
      uE(n2) && (kh(n2), Ov(vg(n2.regions), function(a) {
        kh(a);
      }));
    }), Ov(vg(r2.timeline), function(n2) {
      kh(n2), oc(n2, "label"), oc(n2, "itemStyle"), oc(n2, "controlStyle", true);
      var a = n2.data;
      vr(a) && ae(a, function(i) {
        Tn(i) && (oc(i, "label"), oc(i, "itemStyle"));
      });
    }), Ov(vg(r2.toolbox), function(n2) {
      oc(n2, "iconStyle"), Ov(n2.feature, function(a) {
        oc(a, "iconStyle");
      });
    }), su(Y7(r2.axisPointer), "label"), su(Y7(r2.tooltip).axisPointer, "label");
  }
  function ole(r2, t2) {
    for (var e2 = t2.split(","), n2 = r2, a = 0; a < e2.length && (n2 = n2 && n2[e2[a]], n2 != null); a++)
      ;
    return n2;
  }
  function sle(r2, t2, e2, n2) {
    for (var a = t2.split(","), i = r2, o, s = 0; s < a.length - 1; s++)
      o = a[s], i[o] == null && (i[o] = {}), i = i[o];
    (n2 || i[a[s]] == null) && (i[a[s]] = e2);
  }
  function K7(r2) {
    r2 && ae(ule, function(t2) {
      t2[0] in r2 && !(t2[1] in r2) && (r2[t2[1]] = r2[t2[0]]);
    });
  }
  var ule = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], lle = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], BO = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
  function K2(r2) {
    var t2 = r2 && r2.itemStyle;
    if (t2)
      for (var e2 = 0; e2 < BO.length; e2++) {
        var n2 = BO[e2][1], a = BO[e2][0];
        t2[n2] != null && (t2[a] = t2[n2]);
      }
  }
  function Z7(r2) {
    !r2 || r2.alignTo === "edge" && r2.margin != null && r2.edgeDistance == null && (r2.edgeDistance = r2.margin);
  }
  function X7(r2) {
    !r2 || r2.downplay && !r2.blur && (r2.blur = r2.downplay);
  }
  function cle(r2) {
    !r2 || r2.focusNodeAdjacency != null && (r2.emphasis = r2.emphasis || {}, r2.emphasis.focus == null && (r2.emphasis.focus = "adjacency"));
  }
  function xH(r2, t2) {
    if (r2)
      for (var e2 = 0; e2 < r2.length; e2++)
        t2(r2[e2]), r2[e2] && xH(r2[e2].children, t2);
  }
  function wH(r2, t2) {
    ile(r2, t2), r2.series = ao(r2.series), ae(r2.series, function(e2) {
      if (!!Tn(e2)) {
        var n2 = e2.type;
        if (n2 === "line")
          e2.clipOverflow != null && (e2.clip = e2.clipOverflow);
        else if (n2 === "pie" || n2 === "gauge") {
          e2.clockWise != null && (e2.clockwise = e2.clockWise), Z7(e2.label);
          var a = e2.data;
          if (a && !Qf(a))
            for (var i = 0; i < a.length; i++)
              Z7(a[i]);
          e2.hoverOffset != null && (e2.emphasis = e2.emphasis || {}, (e2.emphasis.scaleSize = null) && (e2.emphasis.scaleSize = e2.hoverOffset));
        } else if (n2 === "gauge") {
          var o = ole(e2, "pointer.color");
          o != null && sle(e2, "itemStyle.color", o);
        } else if (n2 === "bar") {
          K2(e2), K2(e2.backgroundStyle), K2(e2.emphasis);
          var a = e2.data;
          if (a && !Qf(a))
            for (var i = 0; i < a.length; i++)
              typeof a[i] == "object" && (K2(a[i]), K2(a[i] && a[i].emphasis));
        } else if (n2 === "sunburst") {
          var s = e2.highlightPolicy;
          s && (e2.emphasis = e2.emphasis || {}, e2.emphasis.focus || (e2.emphasis.focus = s)), X7(e2), xH(e2.data, X7);
        } else
          n2 === "graph" || n2 === "sankey" ? cle(e2) : n2 === "map" && (e2.mapType && !e2.map && (e2.map = e2.mapType), e2.mapLocation && En(e2, e2.mapLocation));
        e2.hoverAnimation != null && (e2.emphasis = e2.emphasis || {}, e2.emphasis && e2.emphasis.scale == null && (e2.emphasis.scale = e2.hoverAnimation)), K7(e2);
      }
    }), r2.dataRange && (r2.visualMap = r2.dataRange), ae(lle, function(e2) {
      var n2 = r2[e2];
      n2 && (vr(n2) || (n2 = [n2]), ae(n2, function(a) {
        K7(a);
      }));
    });
  }
  function fle(r2) {
    var t2 = mn();
    r2.eachSeries(function(e2) {
      var n2 = e2.get("stack");
      if (n2) {
        var a = t2.get(n2) || t2.set(n2, []), i = e2.getData(), o = { stackResultDimension: i.getCalculationInfo("stackResultDimension"), stackedOverDimension: i.getCalculationInfo("stackedOverDimension"), stackedDimension: i.getCalculationInfo("stackedDimension"), stackedByDimension: i.getCalculationInfo("stackedByDimension"), isStackedByIndex: i.getCalculationInfo("isStackedByIndex"), data: i, seriesModel: e2 };
        if (!o.stackedDimension || !(o.isStackedByIndex || o.stackedByDimension))
          return;
        a.length && i.setCalculationInfo("stackedOnSeries", a[a.length - 1].seriesModel), a.push(o);
      }
    }), t2.each(hle);
  }
  function hle(r2) {
    ae(r2, function(t2, e2) {
      var n2 = [], a = [NaN, NaN], i = [t2.stackResultDimension, t2.stackedOverDimension], o = t2.data, s = t2.isStackedByIndex;
      o.modify(i, function(u, l2, c2) {
        var f2 = o.get(t2.stackedDimension, c2);
        if (isNaN(f2))
          return a;
        var h, v9;
        s ? v9 = o.getRawIndex(c2) : h = o.get(t2.stackedByDimension, c2);
        for (var d2 = NaN, m2 = e2 - 1; m2 >= 0; m2--) {
          var b2 = r2[m2];
          if (s || (v9 = b2.data.rawIndexOf(b2.stackedByDimension, h)), v9 >= 0) {
            var _ = b2.data.getByRawIndex(b2.stackResultDimension, v9);
            if (f2 >= 0 && _ > 0 || f2 <= 0 && _ < 0) {
              f2 = Uie(f2, _), d2 = _;
              break;
            }
          }
        }
        return n2[0] = f2, n2[1] = d2, n2;
      });
    });
  }
  var f3 = function() {
    function r2(t2) {
      this.data = t2.data || (t2.sourceFormat === ip ? {} : []), this.sourceFormat = t2.sourceFormat || hH, this.seriesLayoutBy = t2.seriesLayoutBy || Xd, this.startIndex = t2.startIndex || 0, this.dimensionsDetectedCount = t2.dimensionsDetectedCount, this.metaRawOption = t2.metaRawOption;
      var e2 = this.dimensionsDefine = t2.dimensionsDefine;
      if (e2)
        for (var n2 = 0; n2 < e2.length; n2++) {
          var a = e2[n2];
          a.type == null && pH(this, n2) === Fl.Must && (a.type = "ordinal");
        }
    }
    return r2;
  }();
  function gF(r2) {
    return r2 instanceof f3;
  }
  function p4(r2, t2, e2) {
    e2 = e2 || SH(r2);
    var n2 = t2.seriesLayoutBy, a = dle(r2, e2, n2, t2.sourceHeader, t2.dimensions), i = new f3({ data: r2, sourceFormat: e2, seriesLayoutBy: n2, dimensionsDefine: a.dimensionsDefine, startIndex: a.startIndex, dimensionsDetectedCount: a.dimensionsDetectedCount, metaRawOption: On(t2) });
    return i;
  }
  function yF(r2) {
    return new f3({ data: r2, sourceFormat: Qf(r2) ? vy : Kh });
  }
  function vle(r2) {
    return new f3({ data: r2.data, sourceFormat: r2.sourceFormat, seriesLayoutBy: r2.seriesLayoutBy, dimensionsDefine: On(r2.dimensionsDefine), startIndex: r2.startIndex, dimensionsDetectedCount: r2.dimensionsDetectedCount });
  }
  function SH(r2) {
    var t2 = hH;
    if (Qf(r2))
      t2 = vy;
    else if (vr(r2)) {
      r2.length === 0 && (t2 = cc);
      for (var e2 = 0, n2 = r2.length; e2 < n2; e2++) {
        var a = r2[e2];
        if (a != null) {
          if (vr(a)) {
            t2 = cc;
            break;
          } else if (Tn(a)) {
            t2 = Zh;
            break;
          }
        }
      }
    } else if (Tn(r2)) {
      for (var i in r2)
        if (sn(r2, i) && lc(r2[i])) {
          t2 = ip;
          break;
        }
    }
    return t2;
  }
  function dle(r2, t2, e2, n2, a) {
    var i, o;
    if (!r2)
      return { dimensionsDefine: J7(a), startIndex: o, dimensionsDetectedCount: i };
    if (t2 === cc) {
      var s = r2;
      n2 === "auto" || n2 == null ? Q7(function(l2) {
        l2 != null && l2 !== "-" && (Zr(l2) ? o == null && (o = 1) : o = 0);
      }, e2, s, 10) : o = Ai(n2) ? n2 : n2 ? 1 : 0, !a && o === 1 && (a = [], Q7(function(l2, c2) {
        a[c2] = l2 != null ? l2 + "" : "";
      }, e2, s, 1 / 0)), i = a ? a.length : e2 === xw ? s.length : s[0] ? s[0].length : null;
    } else if (t2 === Zh)
      a || (a = ple(r2));
    else if (t2 === ip)
      a || (a = [], ae(r2, function(l2, c2) {
        a.push(c2);
      }));
    else if (t2 === Kh) {
      var u = hw(r2[0]);
      i = vr(u) && u.length || 1;
    }
    return { startIndex: o, dimensionsDefine: J7(a), dimensionsDetectedCount: i };
  }
  function ple(r2) {
    for (var t2 = 0, e2; t2 < r2.length && !(e2 = r2[t2++]); )
      ;
    if (e2) {
      var n2 = [];
      return ae(e2, function(a, i) {
        n2.push(i);
      }), n2;
    }
  }
  function J7(r2) {
    if (!!r2) {
      var t2 = mn();
      return pr(r2, function(e2, n2) {
        e2 = Tn(e2) ? e2 : { name: e2 };
        var a = { name: e2.name, displayName: e2.displayName, type: e2.type };
        if (a.name == null)
          return a;
        a.name += "", a.displayName == null && (a.displayName = a.name);
        var i = t2.get(a.name);
        return i ? a.name += "-" + i.count++ : t2.set(a.name, { count: 1 }), a;
      });
    }
  }
  function Q7(r2, t2, e2, n2) {
    if (t2 === xw)
      for (var a = 0; a < e2.length && a < n2; a++)
        r2(e2[a] ? e2[a][0] : null, a);
    else
      for (var i = e2[0] || [], a = 0; a < i.length && a < n2; a++)
        r2(i[a], a);
  }
  function CH(r2) {
    var t2 = r2.sourceFormat;
    return t2 === Zh || t2 === ip;
  }
  var yb, mb, bb, eV, tV, EH = function() {
    function r2(t2, e2) {
      var n2 = gF(t2) ? t2 : yF(t2);
      this._source = n2;
      var a = this._data = n2.data;
      n2.sourceFormat === vy && (this._offset = 0, this._dimSize = e2, this._data = a), tV(this, a, n2);
    }
    return r2.prototype.getSource = function() {
      return this._source;
    }, r2.prototype.count = function() {
      return 0;
    }, r2.prototype.getItem = function(t2, e2) {
    }, r2.prototype.appendData = function(t2) {
    }, r2.prototype.clean = function() {
    }, r2.protoInitialize = function() {
      var t2 = r2.prototype;
      t2.pure = false, t2.persistent = true;
    }(), r2.internalField = function() {
      var t2;
      tV = function(o, s, u) {
        var l2 = u.sourceFormat, c2 = u.seriesLayoutBy, f2 = u.startIndex, h = u.dimensionsDefine, v9 = eV[mF(l2, c2)];
        if (qt(o, v9), l2 === vy)
          o.getItem = e2, o.count = a, o.fillStorage = n2;
        else {
          var d2 = AH(l2, c2);
          o.getItem = en(d2, null, s, f2, h);
          var m2 = TH(l2, c2);
          o.count = en(m2, null, s, f2, h);
        }
      };
      var e2 = function(o, s) {
        o = o - this._offset, s = s || [];
        for (var u = this._data, l2 = this._dimSize, c2 = l2 * o, f2 = 0; f2 < l2; f2++)
          s[f2] = u[c2 + f2];
        return s;
      }, n2 = function(o, s, u, l2) {
        for (var c2 = this._data, f2 = this._dimSize, h = 0; h < f2; h++) {
          for (var v9 = l2[h], d2 = v9[0] == null ? 1 / 0 : v9[0], m2 = v9[1] == null ? -1 / 0 : v9[1], b2 = s - o, _ = u[h], C = 0; C < b2; C++) {
            var M = c2[C * f2 + h];
            _[o + C] = M, M < d2 && (d2 = M), M > m2 && (m2 = M);
          }
          v9[0] = d2, v9[1] = m2;
        }
      }, a = function() {
        return this._data ? this._data.length / this._dimSize : 0;
      };
      eV = (t2 = {}, t2[cc + "_" + Xd] = { pure: true, appendData: i }, t2[cc + "_" + xw] = { pure: true, appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      } }, t2[Zh] = { pure: true, appendData: i }, t2[ip] = { pure: true, appendData: function(o) {
        var s = this._data;
        ae(o, function(u, l2) {
          for (var c2 = s[l2] || (s[l2] = []), f2 = 0; f2 < (u || []).length; f2++)
            c2.push(u[f2]);
        });
      } }, t2[Kh] = { appendData: i }, t2[vy] = { persistent: false, pure: true, appendData: function(o) {
        this._data = o;
      }, clean: function() {
        this._offset += this.count(), this._data = null;
      } }, t2);
      function i(o) {
        for (var s = 0; s < o.length; s++)
          this._data.push(o[s]);
      }
    }(), r2;
  }(), rV = function(r2, t2, e2, n2) {
    return r2[n2];
  }, gle = (yb = {}, yb[cc + "_" + Xd] = function(r2, t2, e2, n2) {
    return r2[n2 + t2];
  }, yb[cc + "_" + xw] = function(r2, t2, e2, n2, a) {
    n2 += t2;
    for (var i = a || [], o = r2, s = 0; s < o.length; s++) {
      var u = o[s];
      i[s] = u ? u[n2] : null;
    }
    return i;
  }, yb[Zh] = rV, yb[ip] = function(r2, t2, e2, n2, a) {
    for (var i = a || [], o = 0; o < e2.length; o++) {
      var s = e2[o].name, u = r2[s];
      i[o] = u ? u[n2] : null;
    }
    return i;
  }, yb[Kh] = rV, yb);
  function AH(r2, t2) {
    var e2 = gle[mF(r2, t2)];
    return e2;
  }
  var nV = function(r2, t2, e2) {
    return r2.length;
  }, yle = (mb = {}, mb[cc + "_" + Xd] = function(r2, t2, e2) {
    return Math.max(0, r2.length - t2);
  }, mb[cc + "_" + xw] = function(r2, t2, e2) {
    var n2 = r2[0];
    return n2 ? Math.max(0, n2.length - t2) : 0;
  }, mb[Zh] = nV, mb[ip] = function(r2, t2, e2) {
    var n2 = e2[0].name, a = r2[n2];
    return a ? a.length : 0;
  }, mb[Kh] = nV, mb);
  function TH(r2, t2) {
    var e2 = yle[mF(r2, t2)];
    return e2;
  }
  var zO = function(r2, t2, e2) {
    return r2[t2];
  }, mle = (bb = {}, bb[cc] = zO, bb[Zh] = function(r2, t2, e2) {
    return r2[e2];
  }, bb[ip] = zO, bb[Kh] = function(r2, t2, e2) {
    var n2 = hw(r2);
    return n2 instanceof Array ? n2[t2] : n2;
  }, bb[vy] = zO, bb);
  function MH(r2) {
    var t2 = mle[r2];
    return t2;
  }
  function mF(r2, t2) {
    return r2 === cc ? r2 + "_" + t2 : r2;
  }
  function nw(r2, t2, e2) {
    if (!!r2) {
      var n2 = r2.getRawDataItem(t2);
      if (n2 != null) {
        var a = r2.getStore(), i = a.getSource().sourceFormat;
        if (e2 != null) {
          var o = r2.getDimensionIndex(e2), s = a.getDimensionProperty(o);
          return MH(i)(n2, o, s);
        } else {
          var u = n2;
          return i === Kh && (u = hw(n2)), u;
        }
      }
    }
  }
  var ble = /\{@(.+?)\}/g, bF = function() {
    function r2() {
    }
    return r2.prototype.getDataParams = function(t2, e2) {
      var n2 = this.getData(e2), a = this.getRawValue(t2, e2), i = n2.getRawIndex(t2), o = n2.getName(t2), s = n2.getRawDataItem(t2), u = n2.getItemVisual(t2, "style"), l2 = u && u[n2.getItemVisual(t2, "drawType") || "fill"], c2 = u && u.stroke, f2 = this.mainType, h = f2 === "series", v9 = n2.userOutput && n2.userOutput.get();
      return { componentType: f2, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: h ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: h ? this.id : null, seriesName: h ? this.name : null, name: o, dataIndex: i, data: s, dataType: e2, value: a, color: l2, borderColor: c2, dimensionNames: v9 ? v9.fullDimensions : null, encode: v9 ? v9.encode : null, $vars: ["seriesName", "name", "value"] };
    }, r2.prototype.getFormattedLabel = function(t2, e2, n2, a, i, o) {
      e2 = e2 || "normal";
      var s = this.getData(n2), u = this.getDataParams(t2, n2);
      if (o && (u.value = o.interpolatedValue), a != null && vr(u.value) && (u.value = u.value[a]), !i) {
        var l2 = s.getItemModel(t2);
        i = l2.get(e2 === "normal" ? ["label", "formatter"] : [e2, "label", "formatter"]);
      }
      if (xn(i))
        return u.status = e2, u.dimensionIndex = a, i(u);
      if (Zr(i)) {
        var c2 = sH(i, u);
        return c2.replace(ble, function(f2, h) {
          var v9 = h.length, d2 = h;
          d2.charAt(0) === "[" && d2.charAt(v9 - 1) === "]" && (d2 = +d2.slice(1, v9 - 1));
          var m2 = nw(s, t2, d2);
          if (o && vr(o.interpolatedValue)) {
            var b2 = s.getDimensionIndex(d2);
            b2 >= 0 && (m2 = o.interpolatedValue[b2]);
          }
          return m2 != null ? m2 + "" : "";
        });
      }
    }, r2.prototype.getRawValue = function(t2, e2) {
      return nw(this.getData(e2), t2);
    }, r2.prototype.formatTooltip = function(t2, e2, n2) {
    }, r2;
  }();
  function aV(r2) {
    var t2, e2;
    return Tn(r2) ? r2.type && (e2 = r2) : t2 = r2, { text: t2, frag: e2 };
  }
  function BC(r2) {
    return new _le(r2);
  }
  var _le = function() {
    function r2(t2) {
      t2 = t2 || {}, this._reset = t2.reset, this._plan = t2.plan, this._count = t2.count, this._onDirty = t2.onDirty, this._dirty = true;
    }
    return r2.prototype.perform = function(t2) {
      var e2 = this._upstream, n2 = t2 && t2.skip;
      if (this._dirty && e2) {
        var a = this.context;
        a.data = a.outputData = e2.context.outputData;
      }
      this.__pipeline && (this.__pipeline.currentTask = this);
      var i;
      this._plan && !n2 && (i = this._plan(this.context));
      var o = c2(this._modBy), s = this._modDataCount || 0, u = c2(t2 && t2.modBy), l2 = t2 && t2.modDataCount || 0;
      (o !== u || s !== l2) && (i = "reset");
      function c2(C) {
        return !(C >= 1) && (C = 1), C;
      }
      var f2;
      (this._dirty || i === "reset") && (this._dirty = false, f2 = this._doReset(n2)), this._modBy = u, this._modDataCount = l2;
      var h = t2 && t2.step;
      if (e2 ? this._dueEnd = e2._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
        var v9 = this._dueIndex, d2 = Math.min(h != null ? this._dueIndex + h : 1 / 0, this._dueEnd);
        if (!n2 && (f2 || v9 < d2)) {
          var m2 = this._progress;
          if (vr(m2))
            for (var b2 = 0; b2 < m2.length; b2++)
              this._doProgress(m2[b2], v9, d2, u, l2);
          else
            this._doProgress(m2, v9, d2, u, l2);
        }
        this._dueIndex = d2;
        var _ = this._settedOutputEnd != null ? this._settedOutputEnd : d2;
        this._outputDueEnd = _;
      } else
        this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
      return this.unfinished();
    }, r2.prototype.dirty = function() {
      this._dirty = true, this._onDirty && this._onDirty(this.context);
    }, r2.prototype._doProgress = function(t2, e2, n2, a, i) {
      iV.reset(e2, n2, a, i), this._callingProgress = t2, this._callingProgress({ start: e2, end: n2, count: n2 - e2, next: iV.next }, this.context);
    }, r2.prototype._doReset = function(t2) {
      this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
      var e2, n2;
      !t2 && this._reset && (e2 = this._reset(this.context), e2 && e2.progress && (n2 = e2.forceFirstProgress, e2 = e2.progress), vr(e2) && !e2.length && (e2 = null)), this._progress = e2, this._modBy = this._modDataCount = null;
      var a = this._downstream;
      return a && a.dirty(), n2;
    }, r2.prototype.unfinished = function() {
      return this._progress && this._dueIndex < this._dueEnd;
    }, r2.prototype.pipe = function(t2) {
      (this._downstream !== t2 || this._dirty) && (this._downstream = t2, t2._upstream = this, t2.dirty());
    }, r2.prototype.dispose = function() {
      this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
    }, r2.prototype.getUpstream = function() {
      return this._upstream;
    }, r2.prototype.getDownstream = function() {
      return this._downstream;
    }, r2.prototype.setOutputEnd = function(t2) {
      this._outputDueEnd = this._settedOutputEnd = t2;
    }, r2;
  }(), iV = function() {
    var r2, t2, e2, n2, a, i = { reset: function(u, l2, c2, f2) {
      t2 = u, r2 = l2, e2 = c2, n2 = f2, a = Math.ceil(n2 / e2), i.next = e2 > 1 && n2 > 0 ? s : o;
    } };
    return i;
    function o() {
      return t2 < r2 ? t2++ : null;
    }
    function s() {
      var u = t2 % a * e2 + Math.ceil(t2 / a), l2 = t2 >= r2 ? null : u < n2 ? u : t2;
      return t2++, l2;
    }
  }();
  function dy(r2, t2) {
    var e2 = t2 && t2.type;
    return e2 === "ordinal" ? r2 : (e2 === "time" && !Ai(r2) && r2 != null && r2 !== "-" && (r2 = +rp(r2)), r2 == null || r2 === "" ? NaN : +r2);
  }
  var xle = mn({ number: function(r2) {
    return parseFloat(r2);
  }, time: function(r2) {
    return +rp(r2);
  }, trim: function(r2) {
    return Zr(r2) ? jv(r2) : r2;
  } });
  function PH(r2) {
    return xle.get(r2);
  }
  var DH = { lt: function(r2, t2) {
    return r2 < t2;
  }, lte: function(r2, t2) {
    return r2 <= t2;
  }, gt: function(r2, t2) {
    return r2 > t2;
  }, gte: function(r2, t2) {
    return r2 >= t2;
  } }, wle = function() {
    function r2(t2, e2) {
      if (!Ai(e2)) {
        var n2 = "";
        Ii(n2);
      }
      this._opFn = DH[t2], this._rvalFloat = Pg(e2);
    }
    return r2.prototype.evaluate = function(t2) {
      return Ai(t2) ? this._opFn(t2, this._rvalFloat) : this._opFn(Pg(t2), this._rvalFloat);
    }, r2;
  }(), IH = function() {
    function r2(t2, e2) {
      var n2 = t2 === "desc";
      this._resultLT = n2 ? 1 : -1, e2 == null && (e2 = n2 ? "min" : "max"), this._incomparable = e2 === "min" ? -1 / 0 : 1 / 0;
    }
    return r2.prototype.evaluate = function(t2, e2) {
      var n2 = Ai(t2) ? t2 : Pg(t2), a = Ai(e2) ? e2 : Pg(e2), i = isNaN(n2), o = isNaN(a);
      if (i && (n2 = this._incomparable), o && (a = this._incomparable), i && o) {
        var s = Zr(t2), u = Zr(e2);
        s && (n2 = u ? t2 : 0), u && (a = s ? e2 : 0);
      }
      return n2 < a ? this._resultLT : n2 > a ? -this._resultLT : 0;
    }, r2;
  }(), Sle = function() {
    function r2(t2, e2) {
      this._rval = e2, this._isEQ = t2, this._rvalTypeof = typeof e2, this._rvalFloat = Pg(e2);
    }
    return r2.prototype.evaluate = function(t2) {
      var e2 = t2 === this._rval;
      if (!e2) {
        var n2 = typeof t2;
        n2 !== this._rvalTypeof && (n2 === "number" || this._rvalTypeof === "number") && (e2 = Pg(t2) === this._rvalFloat);
      }
      return this._isEQ ? e2 : !e2;
    }, r2;
  }();
  function Cle(r2, t2) {
    return r2 === "eq" || r2 === "ne" ? new Sle(r2 === "eq", t2) : sn(DH, r2) ? new wle(r2, t2) : null;
  }
  var Ele = function() {
    function r2() {
    }
    return r2.prototype.getRawData = function() {
      throw new Error("not supported");
    }, r2.prototype.getRawDataItem = function(t2) {
      throw new Error("not supported");
    }, r2.prototype.cloneRawData = function() {
    }, r2.prototype.getDimensionInfo = function(t2) {
    }, r2.prototype.cloneAllDimensionInfo = function() {
    }, r2.prototype.count = function() {
    }, r2.prototype.retrieveValue = function(t2, e2) {
    }, r2.prototype.retrieveValueFromItem = function(t2, e2) {
    }, r2.prototype.convertValue = function(t2, e2) {
      return dy(t2, e2);
    }, r2;
  }();
  function Ale(r2, t2) {
    var e2 = new Ele(), n2 = r2.data, a = e2.sourceFormat = r2.sourceFormat, i = r2.startIndex, o = "";
    r2.seriesLayoutBy !== Xd && Ii(o);
    var s = [], u = {}, l2 = r2.dimensionsDefine;
    if (l2)
      ae(l2, function(m2, b2) {
        var _ = m2.name, C = { index: b2, name: _, displayName: m2.displayName };
        if (s.push(C), _ != null) {
          var M = "";
          sn(u, _) && Ii(M), u[_] = C;
        }
      });
    else
      for (var c2 = 0; c2 < r2.dimensionsDetectedCount; c2++)
        s.push({ index: c2 });
    var f2 = AH(a, Xd);
    t2.__isBuiltIn && (e2.getRawDataItem = function(m2) {
      return f2(n2, i, s, m2);
    }, e2.getRawData = en(Tle, null, r2)), e2.cloneRawData = en(Mle, null, r2);
    var h = TH(a, Xd);
    e2.count = en(h, null, n2, i, s);
    var v9 = MH(a);
    e2.retrieveValue = function(m2, b2) {
      var _ = f2(n2, i, s, m2);
      return d2(_, b2);
    };
    var d2 = e2.retrieveValueFromItem = function(m2, b2) {
      if (m2 != null) {
        var _ = s[b2];
        if (_)
          return v9(m2, b2, _.name);
      }
    };
    return e2.getDimensionInfo = en(Ple, null, s, u), e2.cloneAllDimensionInfo = en(Dle, null, s), e2;
  }
  function Tle(r2) {
    var t2 = r2.sourceFormat;
    if (!_F(t2)) {
      var e2 = "";
      Ii(e2);
    }
    return r2.data;
  }
  function Mle(r2) {
    var t2 = r2.sourceFormat, e2 = r2.data;
    if (!_F(t2)) {
      var n2 = "";
      Ii(n2);
    }
    if (t2 === cc) {
      for (var a = [], i = 0, o = e2.length; i < o; i++)
        a.push(e2[i].slice());
      return a;
    } else if (t2 === Zh) {
      for (var a = [], i = 0, o = e2.length; i < o; i++)
        a.push(qt({}, e2[i]));
      return a;
    }
  }
  function Ple(r2, t2, e2) {
    if (e2 != null) {
      if (Ai(e2) || !isNaN(e2) && !sn(t2, e2))
        return r2[e2];
      if (sn(t2, e2))
        return t2[e2];
    }
  }
  function Dle(r2) {
    return On(r2);
  }
  var LH = mn();
  function Ile(r2) {
    r2 = On(r2);
    var t2 = r2.type, e2 = "";
    t2 || Ii(e2);
    var n2 = t2.split(":");
    n2.length !== 2 && Ii(e2);
    var a = false;
    n2[0] === "echarts" && (t2 = n2[1], a = true), r2.__isBuiltIn = a, LH.set(t2, r2);
  }
  function Lle(r2, t2, e2) {
    var n2 = ao(r2), a = n2.length, i = "";
    a || Ii(i);
    for (var o = 0, s = a; o < s; o++) {
      var u = n2[o];
      t2 = Ole(u, t2), o !== s - 1 && (t2.length = Math.max(t2.length, 1));
    }
    return t2;
  }
  function Ole(r2, t2, e2, n2) {
    var a = "";
    t2.length || Ii(a), Tn(r2) || Ii(a);
    var i = r2.type, o = LH.get(i);
    o || Ii(a);
    var s = pr(t2, function(l2) {
      return Ale(l2, o);
    }), u = ao(o.transform({ upstream: s[0], upstreamList: s, config: On(r2.config) }));
    return pr(u, function(l2, c2) {
      var f2 = "";
      Tn(l2) || Ii(f2), l2.data || Ii(f2);
      var h = SH(l2.data);
      _F(h) || Ii(f2);
      var v9, d2 = t2[0];
      if (d2 && c2 === 0 && !l2.dimensions) {
        var m2 = d2.startIndex;
        m2 && (l2.data = d2.data.slice(0, m2).concat(l2.data)), v9 = { seriesLayoutBy: Xd, sourceHeader: m2, dimensions: d2.metaRawOption.dimensions };
      } else
        v9 = { seriesLayoutBy: Xd, sourceHeader: 0, dimensions: l2.dimensions };
      return p4(l2.data, v9, null);
    });
  }
  function _F(r2) {
    return r2 === cc || r2 === Zh;
  }
  var h3 = "undefined", kle = typeof Uint32Array === h3 ? Array : Uint32Array, Rle = typeof Uint16Array === h3 ? Array : Uint16Array, OH = typeof Int32Array === h3 ? Array : Int32Array, oV = typeof Float64Array === h3 ? Array : Float64Array, kH = { float: oV, int: OH, ordinal: Array, number: Array, time: oV }, $O;
  function Z2(r2) {
    return r2 > 65535 ? kle : Rle;
  }
  function bx() {
    return [1 / 0, -1 / 0];
  }
  function Fle(r2) {
    var t2 = r2.constructor;
    return t2 === Array ? r2.slice() : new t2(r2);
  }
  function sV(r2, t2, e2, n2, a) {
    var i = kH[e2 || "float"];
    if (a) {
      var o = r2[t2], s = o && o.length;
      if (s !== n2) {
        for (var u = new i(n2), l2 = 0; l2 < s; l2++)
          u[l2] = o[l2];
        r2[t2] = u;
      }
    } else
      r2[t2] = new i(n2);
  }
  var g4 = function() {
    function r2() {
      this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = mn();
    }
    return r2.prototype.initData = function(t2, e2, n2) {
      this._provider = t2, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
      var a = t2.getSource(), i = this.defaultDimValueGetter = $O[a.sourceFormat];
      this._dimValueGetter = n2 || i, this._rawExtent = [], CH(a), this._dimensions = pr(e2, function(o) {
        return { type: o.type, property: o.property };
      }), this._initDataFromProvider(0, t2.count());
    }, r2.prototype.getProvider = function() {
      return this._provider;
    }, r2.prototype.getSource = function() {
      return this._provider.getSource();
    }, r2.prototype.ensureCalculationDimension = function(t2, e2) {
      var n2 = this._calcDimNameToIdx, a = this._dimensions, i = n2.get(t2);
      if (i != null) {
        if (a[i].type === e2)
          return i;
      } else
        i = a.length;
      return a[i] = { type: e2 }, n2.set(t2, i), this._chunks[i] = new kH[e2 || "float"](this._rawCount), this._rawExtent[i] = bx(), i;
    }, r2.prototype.collectOrdinalMeta = function(t2, e2) {
      var n2 = this._chunks[t2], a = this._dimensions[t2], i = this._rawExtent, o = a.ordinalOffset || 0, s = n2.length;
      o === 0 && (i[t2] = bx());
      for (var u = i[t2], l2 = o; l2 < s; l2++) {
        var c2 = n2[l2] = e2.parseAndCollect(n2[l2]);
        u[0] = Math.min(c2, u[0]), u[1] = Math.max(c2, u[1]);
      }
      a.ordinalMeta = e2, a.ordinalOffset = s, a.type = "ordinal";
    }, r2.prototype.getOrdinalMeta = function(t2) {
      var e2 = this._dimensions[t2], n2 = e2.ordinalMeta;
      return n2;
    }, r2.prototype.getDimensionProperty = function(t2) {
      var e2 = this._dimensions[t2];
      return e2 && e2.property;
    }, r2.prototype.appendData = function(t2) {
      var e2 = this._provider, n2 = this.count();
      e2.appendData(t2);
      var a = e2.count();
      return e2.persistent || (a += n2), n2 < a && this._initDataFromProvider(n2, a, true), [n2, a];
    }, r2.prototype.appendValues = function(t2, e2) {
      for (var n2 = this._chunks, a = this._dimensions, i = a.length, o = this._rawExtent, s = this.count(), u = s + Math.max(t2.length, e2 || 0), l2 = 0; l2 < i; l2++) {
        var c2 = a[l2];
        sV(n2, l2, c2.type, u, true);
      }
      for (var f2 = [], h = s; h < u; h++)
        for (var v9 = h - s, d2 = 0; d2 < i; d2++) {
          var c2 = a[d2], m2 = $O.arrayRows.call(this, t2[v9] || f2, c2.property, v9, d2);
          n2[d2][h] = m2;
          var b2 = o[d2];
          m2 < b2[0] && (b2[0] = m2), m2 > b2[1] && (b2[1] = m2);
        }
      return this._rawCount = this._count = u, { start: s, end: u };
    }, r2.prototype._initDataFromProvider = function(t2, e2, n2) {
      for (var a = this._provider, i = this._chunks, o = this._dimensions, s = o.length, u = this._rawExtent, l2 = pr(o, function(C) {
        return C.property;
      }), c2 = 0; c2 < s; c2++) {
        var f2 = o[c2];
        u[c2] || (u[c2] = bx()), sV(i, c2, f2.type, e2, n2);
      }
      if (a.fillStorage)
        a.fillStorage(t2, e2, i, u);
      else
        for (var h = [], v9 = t2; v9 < e2; v9++) {
          h = a.getItem(v9, h);
          for (var d2 = 0; d2 < s; d2++) {
            var m2 = i[d2], b2 = this._dimValueGetter(h, l2[d2], v9, d2);
            m2[v9] = b2;
            var _ = u[d2];
            b2 < _[0] && (_[0] = b2), b2 > _[1] && (_[1] = b2);
          }
        }
      !a.persistent && a.clean && a.clean(), this._rawCount = this._count = e2, this._extent = [];
    }, r2.prototype.count = function() {
      return this._count;
    }, r2.prototype.get = function(t2, e2) {
      if (!(e2 >= 0 && e2 < this._count))
        return NaN;
      var n2 = this._chunks[t2];
      return n2 ? n2[this.getRawIndex(e2)] : NaN;
    }, r2.prototype.getValues = function(t2, e2) {
      var n2 = [], a = [];
      if (e2 == null) {
        e2 = t2, t2 = [];
        for (var i = 0; i < this._dimensions.length; i++)
          a.push(i);
      } else
        a = t2;
      for (var i = 0, o = a.length; i < o; i++)
        n2.push(this.get(a[i], e2));
      return n2;
    }, r2.prototype.getByRawIndex = function(t2, e2) {
      if (!(e2 >= 0 && e2 < this._rawCount))
        return NaN;
      var n2 = this._chunks[t2];
      return n2 ? n2[e2] : NaN;
    }, r2.prototype.getSum = function(t2) {
      var e2 = this._chunks[t2], n2 = 0;
      if (e2)
        for (var a = 0, i = this.count(); a < i; a++) {
          var o = this.get(t2, a);
          isNaN(o) || (n2 += o);
        }
      return n2;
    }, r2.prototype.getMedian = function(t2) {
      var e2 = [];
      this.each([t2], function(i) {
        isNaN(i) || e2.push(i);
      });
      var n2 = e2.sort(function(i, o) {
        return i - o;
      }), a = this.count();
      return a === 0 ? 0 : a % 2 === 1 ? n2[(a - 1) / 2] : (n2[a / 2] + n2[a / 2 - 1]) / 2;
    }, r2.prototype.indexOfRawIndex = function(t2) {
      if (t2 >= this._rawCount || t2 < 0)
        return -1;
      if (!this._indices)
        return t2;
      var e2 = this._indices, n2 = e2[t2];
      if (n2 != null && n2 < this._count && n2 === t2)
        return t2;
      for (var a = 0, i = this._count - 1; a <= i; ) {
        var o = (a + i) / 2 | 0;
        if (e2[o] < t2)
          a = o + 1;
        else if (e2[o] > t2)
          i = o - 1;
        else
          return o;
      }
      return -1;
    }, r2.prototype.indicesOfNearest = function(t2, e2, n2) {
      var a = this._chunks, i = a[t2], o = [];
      if (!i)
        return o;
      n2 == null && (n2 = 1 / 0);
      for (var s = 1 / 0, u = -1, l2 = 0, c2 = 0, f2 = this.count(); c2 < f2; c2++) {
        var h = this.getRawIndex(c2), v9 = e2 - i[h], d2 = Math.abs(v9);
        d2 <= n2 && ((d2 < s || d2 === s && v9 >= 0 && u < 0) && (s = d2, u = v9, l2 = 0), v9 === u && (o[l2++] = c2));
      }
      return o.length = l2, o;
    }, r2.prototype.getIndices = function() {
      var t2, e2 = this._indices;
      if (e2) {
        var n2 = e2.constructor, a = this._count;
        if (n2 === Array) {
          t2 = new n2(a);
          for (var i = 0; i < a; i++)
            t2[i] = e2[i];
        } else
          t2 = new n2(e2.buffer, 0, a);
      } else {
        var n2 = Z2(this._rawCount);
        t2 = new n2(this.count());
        for (var i = 0; i < t2.length; i++)
          t2[i] = i;
      }
      return t2;
    }, r2.prototype.filter = function(t2, e2) {
      if (!this._count)
        return this;
      for (var n2 = this.clone(), a = n2.count(), i = Z2(n2._rawCount), o = new i(a), s = [], u = t2.length, l2 = 0, c2 = t2[0], f2 = n2._chunks, h = 0; h < a; h++) {
        var v9 = void 0, d2 = n2.getRawIndex(h);
        if (u === 0)
          v9 = e2(h);
        else if (u === 1) {
          var m2 = f2[c2][d2];
          v9 = e2(m2, h);
        } else {
          for (var b2 = 0; b2 < u; b2++)
            s[b2] = f2[t2[b2]][d2];
          s[b2] = h, v9 = e2.apply(null, s);
        }
        v9 && (o[l2++] = d2);
      }
      return l2 < a && (n2._indices = o), n2._count = l2, n2._extent = [], n2._updateGetRawIdx(), n2;
    }, r2.prototype.selectRange = function(t2) {
      var e2 = this.clone(), n2 = e2._count;
      if (!n2)
        return this;
      var a = ja(t2), i = a.length;
      if (!i)
        return this;
      var o = e2.count(), s = Z2(e2._rawCount), u = new s(o), l2 = 0, c2 = a[0], f2 = t2[c2][0], h = t2[c2][1], v9 = e2._chunks, d2 = false;
      if (!e2._indices) {
        var m2 = 0;
        if (i === 1) {
          for (var b2 = v9[a[0]], _ = 0; _ < n2; _++) {
            var C = b2[_];
            (C >= f2 && C <= h || isNaN(C)) && (u[l2++] = m2), m2++;
          }
          d2 = true;
        } else if (i === 2) {
          for (var b2 = v9[a[0]], M = v9[a[1]], E = t2[a[1]][0], z9 = t2[a[1]][1], _ = 0; _ < n2; _++) {
            var C = b2[_], V = M[_];
            (C >= f2 && C <= h || isNaN(C)) && (V >= E && V <= z9 || isNaN(V)) && (u[l2++] = m2), m2++;
          }
          d2 = true;
        }
      }
      if (!d2)
        if (i === 1)
          for (var _ = 0; _ < o; _++) {
            var $ = e2.getRawIndex(_), C = v9[a[0]][$];
            (C >= f2 && C <= h || isNaN(C)) && (u[l2++] = $);
          }
        else
          for (var _ = 0; _ < o; _++) {
            for (var U = true, $ = e2.getRawIndex(_), H = 0; H < i; H++) {
              var q3 = a[H], C = v9[q3][$];
              (C < t2[q3][0] || C > t2[q3][1]) && (U = false);
            }
            U && (u[l2++] = e2.getRawIndex(_));
          }
      return l2 < o && (e2._indices = u), e2._count = l2, e2._extent = [], e2._updateGetRawIdx(), e2;
    }, r2.prototype.map = function(t2, e2) {
      var n2 = this.clone(t2);
      return this._updateDims(n2, t2, e2), n2;
    }, r2.prototype.modify = function(t2, e2) {
      this._updateDims(this, t2, e2);
    }, r2.prototype._updateDims = function(t2, e2, n2) {
      for (var a = t2._chunks, i = [], o = e2.length, s = t2.count(), u = [], l2 = t2._rawExtent, c2 = 0; c2 < e2.length; c2++)
        l2[e2[c2]] = bx();
      for (var f2 = 0; f2 < s; f2++) {
        for (var h = t2.getRawIndex(f2), v9 = 0; v9 < o; v9++)
          u[v9] = a[e2[v9]][h];
        u[o] = f2;
        var d2 = n2 && n2.apply(null, u);
        if (d2 != null) {
          typeof d2 != "object" && (i[0] = d2, d2 = i);
          for (var c2 = 0; c2 < d2.length; c2++) {
            var m2 = e2[c2], b2 = d2[c2], _ = l2[m2], C = a[m2];
            C && (C[h] = b2), b2 < _[0] && (_[0] = b2), b2 > _[1] && (_[1] = b2);
          }
        }
      }
    }, r2.prototype.lttbDownSample = function(t2, e2) {
      var n2 = this.clone([t2], true), a = n2._chunks, i = a[t2], o = this.count(), s = 0, u = Math.floor(1 / e2), l2 = this.getRawIndex(0), c2, f2, h, v9 = new (Z2(this._rawCount))(Math.min((Math.ceil(o / u) + 2) * 2, o));
      v9[s++] = l2;
      for (var d2 = 1; d2 < o - 1; d2 += u) {
        for (var m2 = Math.min(d2 + u, o - 1), b2 = Math.min(d2 + u * 2, o), _ = (b2 + m2) / 2, C = 0, M = m2; M < b2; M++) {
          var E = this.getRawIndex(M), z9 = i[E];
          isNaN(z9) || (C += z9);
        }
        C /= b2 - m2;
        var V = d2, $ = Math.min(d2 + u, o), U = d2 - 1, H = i[l2];
        c2 = -1, h = V;
        for (var q3 = -1, ee = 0, M = V; M < $; M++) {
          var E = this.getRawIndex(M), z9 = i[E];
          if (isNaN(z9)) {
            ee++, q3 < 0 && (q3 = E);
            continue;
          }
          f2 = Math.abs((U - _) * (z9 - H) - (U - M) * (C - H)), f2 > c2 && (c2 = f2, h = E);
        }
        ee > 0 && ee < $ - V && (v9[s++] = Math.min(q3, h), h = Math.max(q3, h)), v9[s++] = h, l2 = h;
      }
      return v9[s++] = this.getRawIndex(o - 1), n2._count = s, n2._indices = v9, n2.getRawIndex = this._getRawIdx, n2;
    }, r2.prototype.downSample = function(t2, e2, n2, a) {
      for (var i = this.clone([t2], true), o = i._chunks, s = [], u = Math.floor(1 / e2), l2 = o[t2], c2 = this.count(), f2 = i._rawExtent[t2] = bx(), h = new (Z2(this._rawCount))(Math.ceil(c2 / u)), v9 = 0, d2 = 0; d2 < c2; d2 += u) {
        u > c2 - d2 && (u = c2 - d2, s.length = u);
        for (var m2 = 0; m2 < u; m2++) {
          var b2 = this.getRawIndex(d2 + m2);
          s[m2] = l2[b2];
        }
        var _ = n2(s), C = this.getRawIndex(Math.min(d2 + a(s, _) || 0, c2 - 1));
        l2[C] = _, _ < f2[0] && (f2[0] = _), _ > f2[1] && (f2[1] = _), h[v9++] = C;
      }
      return i._count = v9, i._indices = h, i._updateGetRawIdx(), i;
    }, r2.prototype.each = function(t2, e2) {
      if (!!this._count)
        for (var n2 = t2.length, a = this._chunks, i = 0, o = this.count(); i < o; i++) {
          var s = this.getRawIndex(i);
          switch (n2) {
            case 0:
              e2(i);
              break;
            case 1:
              e2(a[t2[0]][s], i);
              break;
            case 2:
              e2(a[t2[0]][s], a[t2[1]][s], i);
              break;
            default:
              for (var u = 0, l2 = []; u < n2; u++)
                l2[u] = a[t2[u]][s];
              l2[u] = i, e2.apply(null, l2);
          }
        }
    }, r2.prototype.getDataExtent = function(t2) {
      var e2 = this._chunks[t2], n2 = bx();
      if (!e2)
        return n2;
      var a = this.count(), i = !this._indices, o;
      if (i)
        return this._rawExtent[t2].slice();
      if (o = this._extent[t2], o)
        return o.slice();
      o = n2;
      for (var s = o[0], u = o[1], l2 = 0; l2 < a; l2++) {
        var c2 = this.getRawIndex(l2), f2 = e2[c2];
        f2 < s && (s = f2), f2 > u && (u = f2);
      }
      return o = [s, u], this._extent[t2] = o, o;
    }, r2.prototype.getRawDataItem = function(t2) {
      var e2 = this.getRawIndex(t2);
      if (this._provider.persistent)
        return this._provider.getItem(e2);
      for (var n2 = [], a = this._chunks, i = 0; i < a.length; i++)
        n2.push(a[i][e2]);
      return n2;
    }, r2.prototype.clone = function(t2, e2) {
      var n2 = new r2(), a = this._chunks, i = t2 && Qd(t2, function(s, u) {
        return s[u] = true, s;
      }, {});
      if (i)
        for (var o = 0; o < a.length; o++)
          n2._chunks[o] = i[o] ? Fle(a[o]) : a[o];
      else
        n2._chunks = a;
      return this._copyCommonProps(n2), e2 || (n2._indices = this._cloneIndices()), n2._updateGetRawIdx(), n2;
    }, r2.prototype._copyCommonProps = function(t2) {
      t2._count = this._count, t2._rawCount = this._rawCount, t2._provider = this._provider, t2._dimensions = this._dimensions, t2._extent = On(this._extent), t2._rawExtent = On(this._rawExtent);
    }, r2.prototype._cloneIndices = function() {
      if (this._indices) {
        var t2 = this._indices.constructor, e2 = void 0;
        if (t2 === Array) {
          var n2 = this._indices.length;
          e2 = new t2(n2);
          for (var a = 0; a < n2; a++)
            e2[a] = this._indices[a];
        } else
          e2 = new t2(this._indices);
        return e2;
      }
      return null;
    }, r2.prototype._getRawIdxIdentity = function(t2) {
      return t2;
    }, r2.prototype._getRawIdx = function(t2) {
      return t2 < this._count && t2 >= 0 ? this._indices[t2] : -1;
    }, r2.prototype._updateGetRawIdx = function() {
      this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
    }, r2.internalField = function() {
      function t2(e2, n2, a, i) {
        return dy(e2[i], this._dimensions[i]);
      }
      $O = { arrayRows: t2, objectRows: function(e2, n2, a, i) {
        return dy(e2[n2], this._dimensions[i]);
      }, keyedColumns: t2, original: function(e2, n2, a, i) {
        var o = e2 && (e2.value == null ? e2 : e2.value);
        return dy(o instanceof Array ? o[i] : o, this._dimensions[i]);
      }, typedArray: function(e2, n2, a, i) {
        return e2[i];
      } };
    }(), r2;
  }(), RH = function() {
    function r2(t2) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = t2;
    }
    return r2.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = true;
    }, r2.prototype._setLocalSource = function(t2, e2) {
      this._sourceList = t2, this._upstreamSignList = e2, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, r2.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, r2.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = false);
    }, r2.prototype._createSource = function() {
      this._setLocalSource([], []);
      var t2 = this._sourceHost, e2 = this._getUpstreamSourceManagers(), n2 = !!e2.length, a, i;
      if (LM(t2)) {
        var o = t2, s = void 0, u = void 0, l2 = void 0;
        if (n2) {
          var c2 = e2[0];
          c2.prepareSource(), l2 = c2.getSource(), s = l2.data, u = l2.sourceFormat, i = [c2._getVersionSign()];
        } else
          s = o.get("data", true), u = Qf(s) ? vy : Kh, i = [];
        var f2 = this._getSourceMetaRawOption() || {}, h = l2 && l2.metaRawOption || {}, v9 = ia(f2.seriesLayoutBy, h.seriesLayoutBy) || null, d2 = ia(f2.sourceHeader, h.sourceHeader), m2 = ia(f2.dimensions, h.dimensions), b2 = v9 !== h.seriesLayoutBy || !!d2 != !!h.sourceHeader || m2;
        a = b2 ? [p4(s, { seriesLayoutBy: v9, sourceHeader: d2, dimensions: m2 }, u)] : [];
      } else {
        var _ = t2;
        if (n2) {
          var C = this._applyTransform(e2);
          a = C.sourceList, i = C.upstreamSignList;
        } else {
          var M = _.get("source", true);
          a = [p4(M, this._getSourceMetaRawOption(), null)], i = [];
        }
      }
      this._setLocalSource(a, i);
    }, r2.prototype._applyTransform = function(t2) {
      var e2 = this._sourceHost, n2 = e2.get("transform", true), a = e2.get("fromTransformResult", true);
      if (a != null) {
        var i = "";
        t2.length !== 1 && lV(i);
      }
      var o, s = [], u = [];
      return ae(t2, function(l2) {
        l2.prepareSource();
        var c2 = l2.getSource(a || 0), f2 = "";
        a != null && !c2 && lV(f2), s.push(c2), u.push(l2._getVersionSign());
      }), n2 ? o = Lle(n2, s, { datasetIndex: e2.componentIndex }) : a != null && (o = [vle(s[0])]), { sourceList: o, upstreamSignList: u };
    }, r2.prototype._isDirty = function() {
      if (this._dirty)
        return true;
      for (var t2 = this._getUpstreamSourceManagers(), e2 = 0; e2 < t2.length; e2++) {
        var n2 = t2[e2];
        if (n2._isDirty() || this._upstreamSignList[e2] !== n2._getVersionSign())
          return true;
      }
    }, r2.prototype.getSource = function(t2) {
      t2 = t2 || 0;
      var e2 = this._sourceList[t2];
      if (!e2) {
        var n2 = this._getUpstreamSourceManagers();
        return n2[0] && n2[0].getSource(t2);
      }
      return e2;
    }, r2.prototype.getSharedDataStore = function(t2) {
      var e2 = t2.makeStoreSchema();
      return this._innerGetDataStore(e2.dimensions, t2.source, e2.hash);
    }, r2.prototype._innerGetDataStore = function(t2, e2, n2) {
      var a = 0, i = this._storeList, o = i[a];
      o || (o = i[a] = {});
      var s = o[n2];
      if (!s) {
        var u = this._getUpstreamSourceManagers()[0];
        LM(this._sourceHost) && u ? s = u._innerGetDataStore(t2, e2, n2) : (s = new g4(), s.initData(new EH(e2, t2.length), t2)), o[n2] = s;
      }
      return s;
    }, r2.prototype._getUpstreamSourceManagers = function() {
      var t2 = this._sourceHost;
      if (LM(t2)) {
        var e2 = dF(t2);
        return e2 ? [e2.getSourceManager()] : [];
      } else
        return pr(jue(t2), function(n2) {
          return n2.getSourceManager();
        });
    }, r2.prototype._getSourceMetaRawOption = function() {
      var t2 = this._sourceHost, e2, n2, a;
      if (LM(t2))
        e2 = t2.get("seriesLayoutBy", true), n2 = t2.get("sourceHeader", true), a = t2.get("dimensions", true);
      else if (!this._getUpstreamSourceManagers().length) {
        var i = t2;
        e2 = i.get("seriesLayoutBy", true), n2 = i.get("sourceHeader", true), a = i.get("dimensions", true);
      }
      return { seriesLayoutBy: e2, sourceHeader: n2, dimensions: a };
    }, r2;
  }();
  function uV(r2) {
    var t2 = r2.option.transform;
    t2 && G5(r2.option.transform);
  }
  function LM(r2) {
    return r2.mainType === "series";
  }
  function lV(r2) {
    throw new Error(r2);
  }
  var FH = "line-height:1";
  function NH(r2, t2) {
    var e2 = r2.color || "#6e7079", n2 = r2.fontSize || 12, a = r2.fontWeight || "400", i = r2.color || "#464646", o = r2.fontSize || 14, s = r2.fontWeight || "900";
    return t2 === "html" ? { nameStyle: "font-size:" + Yf(n2 + "") + "px;color:" + Yf(e2) + ";font-weight:" + Yf(a + ""), valueStyle: "font-size:" + Yf(o + "") + "px;color:" + Yf(i) + ";font-weight:" + Yf(s + "") } : { nameStyle: { fontSize: n2, fill: e2, fontWeight: a }, valueStyle: { fontSize: o, fill: i, fontWeight: s } };
  }
  var Nle = [0, 10, 20, 30], Vle = ["", `
`, `

`, `


`];
  function Hu(r2, t2) {
    return t2.type = r2, t2;
  }
  function y4(r2) {
    return r2.type === "section";
  }
  function VH(r2) {
    return y4(r2) ? jle : Ble;
  }
  function jH(r2) {
    if (y4(r2)) {
      var t2 = 0, e2 = r2.blocks.length, n2 = e2 > 1 || e2 > 0 && !r2.noHeader;
      return ae(r2.blocks, function(a) {
        var i = jH(a);
        i >= t2 && (t2 = i + +(n2 && (!i || y4(a) && !a.noHeader)));
      }), t2;
    }
    return 0;
  }
  function jle(r2, t2, e2, n2) {
    var a = t2.noHeader, i = zle(jH(t2)), o = [], s = t2.blocks || [];
    Fc(!s || vr(s)), s = s || [];
    var u = r2.orderMode;
    if (t2.sortBlocks && u) {
      s = s.slice();
      var l2 = { valueAsc: "asc", valueDesc: "desc" };
      if (sn(l2, u)) {
        var c2 = new IH(l2[u], null);
        s.sort(function(d2, m2) {
          return c2.evaluate(d2.sortParam, m2.sortParam);
        });
      } else
        u === "seriesDesc" && s.reverse();
    }
    ae(s, function(d2, m2) {
      var b2 = t2.valueFormatter, _ = VH(d2)(b2 ? qt(qt({}, r2), { valueFormatter: b2 }) : r2, d2, m2 > 0 ? i.html : 0, n2);
      _ != null && o.push(_);
    });
    var f2 = r2.renderMode === "richText" ? o.join(i.richText) : m4(o.join(""), a ? e2 : i.html);
    if (a)
      return f2;
    var h = h4(t2.header, "ordinal", r2.useUTC), v9 = NH(n2, r2.renderMode).nameStyle;
    return r2.renderMode === "richText" ? BH(r2, h, v9) + i.richText + f2 : m4('<div style="' + v9 + ";" + FH + ';">' + Yf(h) + "</div>" + f2, e2);
  }
  function Ble(r2, t2, e2, n2) {
    var a = r2.renderMode, i = t2.noName, o = t2.noValue, s = !t2.markerType, u = t2.name, l2 = r2.useUTC, c2 = t2.valueFormatter || r2.valueFormatter || function(E) {
      return E = vr(E) ? E : [E], pr(E, function(z9, V) {
        return h4(z9, vr(v9) ? v9[V] : v9, l2);
      });
    };
    if (!(i && o)) {
      var f2 = s ? "" : r2.markupStyleCreator.makeTooltipMarker(t2.markerType, t2.markerColor || "#333", a), h = i ? "" : h4(u, "ordinal", l2), v9 = t2.valueType, d2 = o ? [] : c2(t2.value), m2 = !s || !i, b2 = !s && i, _ = NH(n2, a), C = _.nameStyle, M = _.valueStyle;
      return a === "richText" ? (s ? "" : f2) + (i ? "" : BH(r2, h, C)) + (o ? "" : Wle(r2, d2, m2, b2, M)) : m4((s ? "" : f2) + (i ? "" : $le(h, !s, C)) + (o ? "" : Gle(d2, m2, b2, M)), e2);
    }
  }
  function cV(r2, t2, e2, n2, a, i) {
    if (!!r2) {
      var o = VH(r2), s = { useUTC: a, renderMode: e2, orderMode: n2, markupStyleCreator: t2, valueFormatter: r2.valueFormatter };
      return o(s, r2, 0, i);
    }
  }
  function zle(r2) {
    return { html: Nle[r2], richText: Vle[r2] };
  }
  function m4(r2, t2) {
    var e2 = '<div style="clear:both"></div>', n2 = "margin: " + t2 + "px 0 0";
    return '<div style="' + n2 + ";" + FH + ';">' + r2 + e2 + "</div>";
  }
  function $le(r2, t2, e2) {
    var n2 = t2 ? "margin-left:2px" : "";
    return '<span style="' + e2 + ";" + n2 + '">' + Yf(r2) + "</span>";
  }
  function Gle(r2, t2, e2, n2) {
    var a = e2 ? "10px" : "20px", i = t2 ? "float:right;margin-left:" + a : "";
    return r2 = vr(r2) ? r2 : [r2], '<span style="' + i + ";" + n2 + '">' + pr(r2, function(o) {
      return Yf(o);
    }).join("&nbsp;&nbsp;") + "</span>";
  }
  function BH(r2, t2, e2) {
    return r2.markupStyleCreator.wrapRichTextStyle(t2, e2);
  }
  function Wle(r2, t2, e2, n2, a) {
    var i = [a], o = n2 ? 10 : 20;
    return e2 && i.push({ padding: [0, 0, 0, o], align: "right" }), r2.markupStyleCreator.wrapRichTextStyle(vr(t2) ? t2.join("  ") : t2, i);
  }
  function zH(r2, t2) {
    var e2 = r2.getData().getItemVisual(t2, "style"), n2 = e2[r2.visualDrawType];
    return n1(n2);
  }
  function $H(r2, t2) {
    var e2 = r2.get("padding");
    return e2 != null ? e2 : t2 === "richText" ? [8, 10] : 10;
  }
  var GO = function() {
    function r2() {
      this.richTextStyles = {}, this._nextStyleNameId = BW();
    }
    return r2.prototype._generateStyleName = function() {
      return "__EC_aUTo_" + this._nextStyleNameId++;
    }, r2.prototype.makeTooltipMarker = function(t2, e2, n2) {
      var a = n2 === "richText" ? this._generateStyleName() : null, i = Lue({ color: e2, type: t2, renderMode: n2, markerId: a });
      return Zr(i) ? i : (this.richTextStyles[a] = i.style, i.content);
    }, r2.prototype.wrapRichTextStyle = function(t2, e2) {
      var n2 = {};
      vr(e2) ? ae(e2, function(i) {
        return qt(n2, i);
      }) : qt(n2, e2);
      var a = this._generateStyleName();
      return this.richTextStyles[a] = n2, "{" + a + "|" + t2 + "}";
    }, r2;
  }();
  function GH(r2) {
    var t2 = r2.series, e2 = r2.dataIndex, n2 = r2.multipleSeries, a = t2.getData(), i = a.mapDimensionsAll("defaultedTooltip"), o = i.length, s = t2.getRawValue(e2), u = vr(s), l2 = zH(t2, e2), c2, f2, h, v9;
    if (o > 1 || u && !o) {
      var d2 = Ule(s, t2, e2, i, l2);
      c2 = d2.inlineValues, f2 = d2.inlineValueTypes, h = d2.blocks, v9 = d2.inlineValues[0];
    } else if (o) {
      var m2 = a.getDimensionInfo(i[0]);
      v9 = c2 = nw(a, e2, i[0]), f2 = m2.type;
    } else
      v9 = c2 = u ? s[0] : s;
    var b2 = q6(t2), _ = b2 && t2.name || "", C = a.getName(e2), M = n2 ? _ : C;
    return Hu("section", { header: _, noHeader: n2 || !b2, sortParam: v9, blocks: [Hu("nameValue", { markerType: "item", markerColor: l2, name: M, noName: !jv(M), value: c2, valueType: f2 })].concat(h || []) });
  }
  function Ule(r2, t2, e2, n2, a) {
    var i = t2.getData(), o = Qd(r2, function(f2, h, v9) {
      var d2 = i.getDimensionInfo(v9);
      return f2 = f2 || d2 && d2.tooltip !== false && d2.displayName != null;
    }, false), s = [], u = [], l2 = [];
    n2.length ? ae(n2, function(f2) {
      c2(nw(i, e2, f2), f2);
    }) : ae(r2, c2);
    function c2(f2, h) {
      var v9 = i.getDimensionInfo(h);
      !v9 || v9.otherDims.tooltip === false || (o ? l2.push(Hu("nameValue", { markerType: "subItem", markerColor: a, name: v9.displayName, value: f2, valueType: v9.type })) : (s.push(f2), u.push(v9.type)));
    }
    return { inlineValues: s, inlineValueTypes: u, blocks: l2 };
  }
  var U0 = fi();
  function OM(r2, t2) {
    return r2.getName(t2) || r2.getId(t2);
  }
  var k5 = "__universalTransitionEnabled", v32 = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2._selectedDataIndicesMap = {}, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.seriesIndex = this.componentIndex, this.dataTask = BC({ count: qle, reset: Yle }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(e2, a);
      var i = U0(this).sourceManager = new RH(this);
      i.prepareSource();
      var o = this.getInitialData(e2, a);
      hV(o, this), this.dataTask.context.data = o, U0(this).dataBeforeProcessed = o, fV(this), this._initSelectedMapFromData(o);
    }, t2.prototype.mergeDefaultAndTheme = function(e2, n2) {
      var a = sE(this), i = a ? bw(e2) : {}, o = this.subType;
      li.hasClass(o) && (o += "Series"), ea(e2, n2.getTheme().get(this.subType)), ea(e2, this.getDefaultOption()), Qb(e2, "label", ["show"]), this.fillDataTextStyle(e2.data), a && by(e2, i, a);
    }, t2.prototype.mergeOption = function(e2, n2) {
      e2 = ea(this.option, e2, true), this.fillDataTextStyle(e2.data);
      var a = sE(this);
      a && by(this.option, e2, a);
      var i = U0(this).sourceManager;
      i.dirty(), i.prepareSource();
      var o = this.getInitialData(e2, n2);
      hV(o, this), this.dataTask.dirty(), this.dataTask.context.data = o, U0(this).dataBeforeProcessed = o, fV(this), this._initSelectedMapFromData(o);
    }, t2.prototype.fillDataTextStyle = function(e2) {
      if (e2 && !Qf(e2))
        for (var n2 = ["show"], a = 0; a < e2.length; a++)
          e2[a] && e2[a].label && Qb(e2[a], "label", n2);
    }, t2.prototype.getInitialData = function(e2, n2) {
    }, t2.prototype.appendData = function(e2) {
      var n2 = this.getRawData();
      n2.appendData(e2.data);
    }, t2.prototype.getData = function(e2) {
      var n2 = b4(this);
      if (n2) {
        var a = n2.context.data;
        return e2 == null ? a : a.getLinkedData(e2);
      } else
        return U0(this).data;
    }, t2.prototype.getAllData = function() {
      var e2 = this.getData();
      return e2 && e2.getLinkedDataAll ? e2.getLinkedDataAll() : [{ data: e2 }];
    }, t2.prototype.setData = function(e2) {
      var n2 = b4(this);
      if (n2) {
        var a = n2.context;
        a.outputData = e2, n2 !== this.dataTask && (a.data = e2);
      }
      U0(this).data = e2;
    }, t2.prototype.getEncode = function() {
      var e2 = this.get("encode", true);
      if (e2)
        return mn(e2);
    }, t2.prototype.getSourceManager = function() {
      return U0(this).sourceManager;
    }, t2.prototype.getSource = function() {
      return this.getSourceManager().getSource();
    }, t2.prototype.getRawData = function() {
      return U0(this).dataBeforeProcessed;
    }, t2.prototype.getColorBy = function() {
      var e2 = this.get("colorBy");
      return e2 || "series";
    }, t2.prototype.isColorBySeries = function() {
      return this.getColorBy() === "series";
    }, t2.prototype.getBaseAxis = function() {
      var e2 = this.coordinateSystem;
      return e2 && e2.getBaseAxis && e2.getBaseAxis();
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      return GH({ series: this, dataIndex: e2, multipleSeries: n2 });
    }, t2.prototype.isAnimationEnabled = function() {
      var e2 = this.ecModel;
      if (Ei.node && !(e2 && e2.ssr))
        return false;
      var n2 = this.getShallow("animation");
      return n2 && this.getData().count() > this.getShallow("animationThreshold") && (n2 = false), !!n2;
    }, t2.prototype.restoreData = function() {
      this.dataTask.dirty();
    }, t2.prototype.getColorFromPalette = function(e2, n2, a) {
      var i = this.ecModel, o = pF.prototype.getColorFromPalette.call(this, e2, n2, a);
      return o || (o = i.getColorFromPalette(e2, n2, a)), o;
    }, t2.prototype.coordDimToDataDim = function(e2) {
      return this.getRawData().mapDimensionsAll(e2);
    }, t2.prototype.getProgressive = function() {
      return this.get("progressive");
    }, t2.prototype.getProgressiveThreshold = function() {
      return this.get("progressiveThreshold");
    }, t2.prototype.select = function(e2, n2) {
      this._innerSelect(this.getData(n2), e2);
    }, t2.prototype.unselect = function(e2, n2) {
      var a = this.option.selectedMap;
      if (!!a) {
        var i = this.option.selectedMode, o = this.getData(n2);
        if (i === "series" || a === "all") {
          this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
          return;
        }
        for (var s = 0; s < e2.length; s++) {
          var u = e2[s], l2 = OM(o, u);
          a[l2] = false, this._selectedDataIndicesMap[l2] = -1;
        }
      }
    }, t2.prototype.toggleSelect = function(e2, n2) {
      for (var a = [], i = 0; i < e2.length; i++)
        a[0] = e2[i], this.isSelected(e2[i], n2) ? this.unselect(a, n2) : this.select(a, n2);
    }, t2.prototype.getSelectedDataIndices = function() {
      if (this.option.selectedMap === "all")
        return [].slice.call(this.getData().getIndices());
      for (var e2 = this._selectedDataIndicesMap, n2 = ja(e2), a = [], i = 0; i < n2.length; i++) {
        var o = e2[n2[i]];
        o >= 0 && a.push(o);
      }
      return a;
    }, t2.prototype.isSelected = function(e2, n2) {
      var a = this.option.selectedMap;
      if (!a)
        return false;
      var i = this.getData(n2);
      return (a === "all" || a[OM(i, e2)]) && !i.getItemModel(e2).get(["select", "disabled"]);
    }, t2.prototype.isUniversalTransitionEnabled = function() {
      if (this[k5])
        return true;
      var e2 = this.option.universalTransition;
      return e2 ? e2 === true ? true : e2 && e2.enabled : false;
    }, t2.prototype._innerSelect = function(e2, n2) {
      var a, i, o = this.option, s = o.selectedMode, u = n2.length;
      if (!(!s || !u)) {
        if (s === "series")
          o.selectedMap = "all";
        else if (s === "multiple") {
          Tn(o.selectedMap) || (o.selectedMap = {});
          for (var l2 = o.selectedMap, c2 = 0; c2 < u; c2++) {
            var f2 = n2[c2], h = OM(e2, f2);
            l2[h] = true, this._selectedDataIndicesMap[h] = e2.getRawIndex(f2);
          }
        } else if (s === "single" || s === true) {
          var v9 = n2[u - 1], h = OM(e2, v9);
          o.selectedMap = (a = {}, a[h] = true, a), this._selectedDataIndicesMap = (i = {}, i[h] = e2.getRawIndex(v9), i);
        }
      }
    }, t2.prototype._initSelectedMapFromData = function(e2) {
      if (!this.option.selectedMap) {
        var n2 = [];
        e2.hasItemOption && e2.each(function(a) {
          var i = e2.getRawDataItem(a);
          i && i.selected && n2.push(a);
        }), n2.length > 0 && this._innerSelect(e2, n2);
      }
    }, t2.registerClass = function(e2) {
      return li.registerClass(e2);
    }, t2.protoInitialize = function() {
      var e2 = t2.prototype;
      e2.type = "series.__base__", e2.seriesIndex = 0, e2.ignoreStyleOnData = false, e2.hasSymbolVisual = false, e2.defaultSymbol = "circle", e2.visualStyleAccessPath = "itemStyle", e2.visualDrawType = "fill";
    }(), t2;
  }(li);
  fu(v32, bF);
  fu(v32, pF);
  KW(v32, li);
  function fV(r2) {
    var t2 = r2.name;
    q6(r2) || (r2.name = Hle(r2) || t2);
  }
  function Hle(r2) {
    var t2 = r2.getRawData(), e2 = t2.mapDimensionsAll("seriesName"), n2 = [];
    return ae(e2, function(a) {
      var i = t2.getDimensionInfo(a);
      i.displayName && n2.push(i.displayName);
    }), n2.join(" ");
  }
  function qle(r2) {
    return r2.model.getRawData().count();
  }
  function Yle(r2) {
    var t2 = r2.model;
    return t2.setData(t2.getRawData().cloneShallow()), Kle;
  }
  function Kle(r2, t2) {
    t2.outputData && r2.end > t2.outputData.count() && t2.model.getRawData().cloneShallow(t2.outputData);
  }
  function hV(r2, t2) {
    ae(IR(r2.CHANGABLE_METHODS, r2.DOWNSAMPLE_METHODS), function(e2) {
      r2.wrapMethod(e2, Gn(Zle, t2));
    });
  }
  function Zle(r2, t2) {
    var e2 = b4(r2);
    return e2 && e2.setOutputEnd((t2 || this).count()), t2;
  }
  function b4(r2) {
    var t2 = (r2.ecModel || {}).scheduler, e2 = t2 && t2.getPipeline(r2.uid);
    if (e2) {
      var n2 = e2.currentTask;
      if (n2) {
        var a = n2.agentStubMap;
        a && (n2 = a.get(r2.uid));
      }
      return n2;
    }
  }
  var ns = v32, xF = function() {
    function r2() {
      this.group = new Fn(), this.uid = yw("viewComponent");
    }
    return r2.prototype.init = function(t2, e2) {
    }, r2.prototype.render = function(t2, e2, n2, a) {
    }, r2.prototype.dispose = function(t2, e2) {
    }, r2.prototype.updateView = function(t2, e2, n2, a) {
    }, r2.prototype.updateLayout = function(t2, e2, n2, a) {
    }, r2.prototype.updateVisual = function(t2, e2, n2, a) {
    }, r2.prototype.blurSeries = function(t2, e2) {
    }, r2.prototype.eachRendered = function(t2) {
      var e2 = this.group;
      e2 && e2.traverse(t2);
    }, r2;
  }();
  K6(xF);
  YP(xF);
  var gs = xF;
  function ww() {
    var r2 = fi();
    return function(t2) {
      var e2 = r2(t2), n2 = t2.pipelineContext, a = !!e2.large, i = !!e2.progressiveRender, o = e2.large = !!(n2 && n2.large), s = e2.progressiveRender = !!(n2 && n2.progressiveRender);
      return (a !== o || i !== s) && "reset";
    };
  }
  var WH2 = fi(), Xle = ww(), wF = function() {
    function r2() {
      this.group = new Fn(), this.uid = yw("viewChart"), this.renderTask = BC({ plan: Jle, reset: Qle }), this.renderTask.context = { view: this };
    }
    return r2.prototype.init = function(t2, e2) {
    }, r2.prototype.render = function(t2, e2, n2, a) {
    }, r2.prototype.highlight = function(t2, e2, n2, a) {
      var i = t2.getData(a && a.dataType);
      !i || dV(i, a, "emphasis");
    }, r2.prototype.downplay = function(t2, e2, n2, a) {
      var i = t2.getData(a && a.dataType);
      !i || dV(i, a, "normal");
    }, r2.prototype.remove = function(t2, e2) {
      this.group.removeAll();
    }, r2.prototype.dispose = function(t2, e2) {
    }, r2.prototype.updateView = function(t2, e2, n2, a) {
      this.render(t2, e2, n2, a);
    }, r2.prototype.updateLayout = function(t2, e2, n2, a) {
      this.render(t2, e2, n2, a);
    }, r2.prototype.updateVisual = function(t2, e2, n2, a) {
      this.render(t2, e2, n2, a);
    }, r2.prototype.eachRendered = function(t2) {
      Ay(this.group, t2);
    }, r2.markUpdateMethod = function(t2, e2) {
      WH2(t2).updateMethod = e2;
    }, r2.protoInitialize = function() {
      var t2 = r2.prototype;
      t2.type = "chart";
    }(), r2;
  }();
  function vV(r2, t2, e2) {
    r2 && nE(r2) && (t2 === "emphasis" ? Kd : Zd)(r2, e2);
  }
  function dV(r2, t2, e2) {
    var n2 = e1(r2, t2), a = t2 && t2.highlightKey != null ? wse(t2.highlightKey) : null;
    n2 != null ? ae(ao(n2), function(i) {
      vV(r2.getItemGraphicEl(i), e2, a);
    }) : r2.eachItemGraphicEl(function(i) {
      vV(i, e2, a);
    });
  }
  K6(wF);
  YP(wF);
  function Jle(r2) {
    return Xle(r2.model);
  }
  function Qle(r2) {
    var t2 = r2.model, e2 = r2.ecModel, n2 = r2.api, a = r2.payload, i = t2.pipelineContext.progressiveRender, o = r2.view, s = a && WH2(a).updateMethod, u = i ? "incrementalPrepareRender" : s && o[s] ? s : "render";
    return u !== "render" && o[u](t2, e2, n2, a), ece[u];
  }
  var ece = { incrementalPrepareRender: { progress: function(r2, t2) {
    t2.view.incrementalRender(r2, t2.model, t2.ecModel, t2.api, t2.payload);
  } }, render: { forceFirstProgress: true, progress: function(r2, t2) {
    t2.view.render(t2.model, t2.ecModel, t2.api, t2.payload);
  } } }, Mo = wF, oP = "\0__throttleOriginMethod", pV = "\0__throttleRate", gV = "\0__throttleType";
  function SF(r2, t2, e2) {
    var n2, a = 0, i = 0, o = null, s, u, l2, c2;
    t2 = t2 || 0;
    function f2() {
      i = new Date().getTime(), o = null, r2.apply(u, l2 || []);
    }
    var h = function() {
      for (var v9 = [], d2 = 0; d2 < arguments.length; d2++)
        v9[d2] = arguments[d2];
      n2 = new Date().getTime(), u = this, l2 = v9;
      var m2 = c2 || t2, b2 = c2 || e2;
      c2 = null, s = n2 - (b2 ? a : i) - m2, clearTimeout(o), b2 ? o = setTimeout(f2, m2) : s >= 0 ? f2() : o = setTimeout(f2, -s), a = n2;
    };
    return h.clear = function() {
      o && (clearTimeout(o), o = null);
    }, h.debounceNextCall = function(v9) {
      c2 = v9;
    }, h;
  }
  function Sw(r2, t2, e2, n2) {
    var a = r2[t2];
    if (!!a) {
      var i = a[oP] || a, o = a[gV], s = a[pV];
      if (s !== e2 || o !== n2) {
        if (e2 == null || !n2)
          return r2[t2] = i;
        a = r2[t2] = SF(i, e2, n2 === "debounce"), a[oP] = i, a[gV] = n2, a[pV] = e2;
      }
      return a;
    }
  }
  function lE(r2, t2) {
    var e2 = r2[t2];
    e2 && e2[oP] && (e2.clear && e2.clear(), r2[t2] = e2[oP]);
  }
  var yV = fi(), mV = { itemStyle: t1(YU, true), lineStyle: t1(qU, true) }, tce = { lineStyle: "stroke", itemStyle: "fill" };
  function UH(r2, t2) {
    var e2 = r2.visualStyleMapper || mV[t2];
    return e2 || (console.warn("Unkown style type '" + t2 + "'."), mV.itemStyle);
  }
  function HH(r2, t2) {
    var e2 = r2.visualDrawType || tce[t2];
    return e2 || (console.warn("Unkown style type '" + t2 + "'."), "fill");
  }
  var rce = { createOnAllSeries: true, performRawSeries: true, reset: function(r2, t2) {
    var e2 = r2.getData(), n2 = r2.visualStyleAccessPath || "itemStyle", a = r2.getModel(n2), i = UH(r2, n2), o = i(a), s = a.getShallow("decal");
    s && (e2.setVisual("decal", s), s.dirty = true);
    var u = HH(r2, n2), l2 = o[u], c2 = xn(l2) ? l2 : null, f2 = o.fill === "auto" || o.stroke === "auto";
    if (!o[u] || c2 || f2) {
      var h = r2.getColorFromPalette(r2.name, null, t2.getSeriesCount());
      o[u] || (o[u] = h, e2.setVisual("colorFromPalette", true)), o.fill = o.fill === "auto" || xn(o.fill) ? h : o.fill, o.stroke = o.stroke === "auto" || xn(o.stroke) ? h : o.stroke;
    }
    if (e2.setVisual("style", o), e2.setVisual("drawType", u), !t2.isSeriesFiltered(r2) && c2)
      return e2.setVisual("colorFromPalette", false), { dataEach: function(v9, d2) {
        var m2 = r2.getDataParams(d2), b2 = qt({}, o);
        b2[u] = c2(m2), v9.setItemVisual(d2, "style", b2);
      } };
  } }, X2 = new To(), nce = { createOnAllSeries: true, performRawSeries: true, reset: function(r2, t2) {
    if (!(r2.ignoreStyleOnData || t2.isSeriesFiltered(r2))) {
      var e2 = r2.getData(), n2 = r2.visualStyleAccessPath || "itemStyle", a = UH(r2, n2), i = e2.getVisual("drawType");
      return { dataEach: e2.hasItemOption ? function(o, s) {
        var u = o.getRawDataItem(s);
        if (u && u[n2]) {
          X2.option = u[n2];
          var l2 = a(X2), c2 = o.ensureUniqueItemVisual(s, "style");
          qt(c2, l2), X2.option.decal && (o.setItemVisual(s, "decal", X2.option.decal), X2.option.decal.dirty = true), i in l2 && o.setItemVisual(s, "colorFromPalette", false);
        }
      } : null };
    }
  } }, ace = { performRawSeries: true, overallReset: function(r2) {
    var t2 = mn();
    r2.eachSeries(function(e2) {
      var n2 = e2.getColorBy();
      if (!e2.isColorBySeries()) {
        var a = e2.type + "-" + n2, i = t2.get(a);
        i || (i = {}, t2.set(a, i)), yV(e2).scope = i;
      }
    }), r2.eachSeries(function(e2) {
      if (!(e2.isColorBySeries() || r2.isSeriesFiltered(e2))) {
        var n2 = e2.getRawData(), a = {}, i = e2.getData(), o = yV(e2).scope, s = e2.visualStyleAccessPath || "itemStyle", u = HH(e2, s);
        i.each(function(l2) {
          var c2 = i.getRawIndex(l2);
          a[c2] = l2;
        }), n2.each(function(l2) {
          var c2 = a[l2], f2 = i.getItemVisual(c2, "colorFromPalette");
          if (f2) {
            var h = i.ensureUniqueItemVisual(c2, "style"), v9 = n2.getName(l2) || l2 + "", d2 = n2.count();
            h[u] = e2.getColorFromPalette(v9, o, d2);
          }
        });
      }
    });
  } }, kM = Math.PI;
  function ice(r2, t2) {
    t2 = t2 || {}, En(t2, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
    var e2 = new Fn(), n2 = new ni({ style: { fill: t2.maskColor }, zlevel: t2.zlevel, z: 1e4 });
    e2.add(n2);
    var a = new xi({ style: { text: t2.text, fill: t2.textColor, fontSize: t2.fontSize, fontWeight: t2.fontWeight, fontStyle: t2.fontStyle, fontFamily: t2.fontFamily }, zlevel: t2.zlevel, z: 10001 }), i = new ni({ style: { fill: "none" }, textContent: a, textConfig: { position: "right", distance: 10 }, zlevel: t2.zlevel, z: 10001 });
    e2.add(i);
    var o;
    return t2.showSpinner && (o = new nF({ shape: { startAngle: -kM / 2, endAngle: -kM / 2 + 0.1, r: t2.spinnerRadius }, style: { stroke: t2.color, lineCap: "round", lineWidth: t2.lineWidth }, zlevel: t2.zlevel, z: 10001 }), o.animateShape(true).when(1e3, { endAngle: kM * 3 / 2 }).start("circularInOut"), o.animateShape(true).when(1e3, { startAngle: kM * 3 / 2 }).delay(300).start("circularInOut"), e2.add(o)), e2.resize = function() {
      var s = a.getBoundingRect().width, u = t2.showSpinner ? t2.spinnerRadius : 0, l2 = (r2.getWidth() - u * 2 - (t2.showSpinner && s ? 10 : 0) - s) / 2 - (t2.showSpinner && s ? 0 : 5 + s / 2) + (t2.showSpinner ? 0 : s / 2) + (s ? 0 : u), c2 = r2.getHeight() / 2;
      t2.showSpinner && o.setShape({ cx: l2, cy: c2 }), i.setShape({ x: l2 - u, y: c2 - u, width: u * 2, height: u * 2 }), n2.setShape({ x: 0, y: 0, width: r2.getWidth(), height: r2.getHeight() });
    }, e2.resize(), e2;
  }
  var oce = function() {
    function r2(t2, e2, n2, a) {
      this._stageTaskMap = mn(), this.ecInstance = t2, this.api = e2, n2 = this._dataProcessorHandlers = n2.slice(), a = this._visualHandlers = a.slice(), this._allHandlers = n2.concat(a);
    }
    return r2.prototype.restoreData = function(t2, e2) {
      t2.restoreData(e2), this._stageTaskMap.each(function(n2) {
        var a = n2.overallTask;
        a && a.dirty();
      });
    }, r2.prototype.getPerformArgs = function(t2, e2) {
      if (!!t2.__pipeline) {
        var n2 = this._pipelineMap.get(t2.__pipeline.id), a = n2.context, i = !e2 && n2.progressiveEnabled && (!a || a.progressiveRender) && t2.__idxInPipeline > n2.blockIndex, o = i ? n2.step : null, s = a && a.modDataCount, u = s != null ? Math.ceil(s / o) : null;
        return { step: o, modBy: u, modDataCount: s };
      }
    }, r2.prototype.getPipeline = function(t2) {
      return this._pipelineMap.get(t2);
    }, r2.prototype.updateStreamModes = function(t2, e2) {
      var n2 = this._pipelineMap.get(t2.uid), a = t2.getData(), i = a.count(), o = n2.progressiveEnabled && e2.incrementalPrepareRender && i >= n2.threshold, s = t2.get("large") && i >= t2.get("largeThreshold"), u = t2.get("progressiveChunkMode") === "mod" ? i : null;
      t2.pipelineContext = n2.context = { progressiveRender: o, modDataCount: u, large: s };
    }, r2.prototype.restorePipelines = function(t2) {
      var e2 = this, n2 = e2._pipelineMap = mn();
      t2.eachSeries(function(a) {
        var i = a.getProgressive(), o = a.uid;
        n2.set(o, { id: o, head: null, tail: null, threshold: a.getProgressiveThreshold(), progressiveEnabled: i && !(a.preventIncremental && a.preventIncremental()), blockIndex: -1, step: Math.round(i || 700), count: 0 }), e2._pipe(a, a.dataTask);
      });
    }, r2.prototype.prepareStageTasks = function() {
      var t2 = this._stageTaskMap, e2 = this.api.getModel(), n2 = this.api;
      ae(this._allHandlers, function(a) {
        var i = t2.get(a.uid) || t2.set(a.uid, {}), o = "";
        Fc(!(a.reset && a.overallReset), o), a.reset && this._createSeriesStageTask(a, i, e2, n2), a.overallReset && this._createOverallStageTask(a, i, e2, n2);
      }, this);
    }, r2.prototype.prepareView = function(t2, e2, n2, a) {
      var i = t2.renderTask, o = i.context;
      o.model = e2, o.ecModel = n2, o.api = a, i.__block = !t2.incrementalPrepareRender, this._pipe(e2, i);
    }, r2.prototype.performDataProcessorTasks = function(t2, e2) {
      this._performStageTasks(this._dataProcessorHandlers, t2, e2, { block: true });
    }, r2.prototype.performVisualTasks = function(t2, e2, n2) {
      this._performStageTasks(this._visualHandlers, t2, e2, n2);
    }, r2.prototype._performStageTasks = function(t2, e2, n2, a) {
      a = a || {};
      var i = false, o = this;
      ae(t2, function(u, l2) {
        if (!(a.visualType && a.visualType !== u.visualType)) {
          var c2 = o._stageTaskMap.get(u.uid), f2 = c2.seriesTaskMap, h = c2.overallTask;
          if (h) {
            var v9, d2 = h.agentStubMap;
            d2.each(function(b2) {
              s(a, b2) && (b2.dirty(), v9 = true);
            }), v9 && h.dirty(), o.updatePayload(h, n2);
            var m2 = o.getPerformArgs(h, a.block);
            d2.each(function(b2) {
              b2.perform(m2);
            }), h.perform(m2) && (i = true);
          } else
            f2 && f2.each(function(b2, _) {
              s(a, b2) && b2.dirty();
              var C = o.getPerformArgs(b2, a.block);
              C.skip = !u.performRawSeries && e2.isSeriesFiltered(b2.context.model), o.updatePayload(b2, n2), b2.perform(C) && (i = true);
            });
        }
      });
      function s(u, l2) {
        return u.setDirty && (!u.dirtyMap || u.dirtyMap.get(l2.__pipeline.id));
      }
      this.unfinished = i || this.unfinished;
    }, r2.prototype.performSeriesTasks = function(t2) {
      var e2;
      t2.eachSeries(function(n2) {
        e2 = n2.dataTask.perform() || e2;
      }), this.unfinished = e2 || this.unfinished;
    }, r2.prototype.plan = function() {
      this._pipelineMap.each(function(t2) {
        var e2 = t2.tail;
        do {
          if (e2.__block) {
            t2.blockIndex = e2.__idxInPipeline;
            break;
          }
          e2 = e2.getUpstream();
        } while (e2);
      });
    }, r2.prototype.updatePayload = function(t2, e2) {
      e2 !== "remain" && (t2.context.payload = e2);
    }, r2.prototype._createSeriesStageTask = function(t2, e2, n2, a) {
      var i = this, o = e2.seriesTaskMap, s = e2.seriesTaskMap = mn(), u = t2.seriesType, l2 = t2.getTargetSeries;
      t2.createOnAllSeries ? n2.eachRawSeries(c2) : u ? n2.eachRawSeriesByType(u, c2) : l2 && l2(n2, a).each(c2);
      function c2(f2) {
        var h = f2.uid, v9 = s.set(h, o && o.get(h) || BC({ plan: fce, reset: hce, count: dce }));
        v9.context = { model: f2, ecModel: n2, api: a, useClearVisual: t2.isVisual && !t2.isLayout, plan: t2.plan, reset: t2.reset, scheduler: i }, i._pipe(f2, v9);
      }
    }, r2.prototype._createOverallStageTask = function(t2, e2, n2, a) {
      var i = this, o = e2.overallTask = e2.overallTask || BC({ reset: sce });
      o.context = { ecModel: n2, api: a, overallReset: t2.overallReset, scheduler: i };
      var s = o.agentStubMap, u = o.agentStubMap = mn(), l2 = t2.seriesType, c2 = t2.getTargetSeries, f2 = true, h = false, v9 = "";
      Fc(!t2.createOnAllSeries, v9), l2 ? n2.eachRawSeriesByType(l2, d2) : c2 ? c2(n2, a).each(d2) : (f2 = false, ae(n2.getSeries(), d2));
      function d2(m2) {
        var b2 = m2.uid, _ = u.set(b2, s && s.get(b2) || (h = true, BC({ reset: uce, onDirty: cce })));
        _.context = { model: m2, overallProgress: f2 }, _.agent = o, _.__block = f2, i._pipe(m2, _);
      }
      h && o.dirty();
    }, r2.prototype._pipe = function(t2, e2) {
      var n2 = t2.uid, a = this._pipelineMap.get(n2);
      !a.head && (a.head = e2), a.tail && a.tail.pipe(e2), a.tail = e2, e2.__idxInPipeline = a.count++, e2.__pipeline = a;
    }, r2.wrapStageHandler = function(t2, e2) {
      return xn(t2) && (t2 = { overallReset: t2, seriesType: pce(t2) }), t2.uid = yw("stageHandler"), e2 && (t2.visualType = e2), t2;
    }, r2;
  }();
  function sce(r2) {
    r2.overallReset(r2.ecModel, r2.api, r2.payload);
  }
  function uce(r2) {
    return r2.overallProgress && lce;
  }
  function lce() {
    this.agent.dirty(), this.getDownstream().dirty();
  }
  function cce() {
    this.agent && this.agent.dirty();
  }
  function fce(r2) {
    return r2.plan ? r2.plan(r2.model, r2.ecModel, r2.api, r2.payload) : null;
  }
  function hce(r2) {
    r2.useClearVisual && r2.data.clearAllVisual();
    var t2 = r2.resetDefines = ao(r2.reset(r2.model, r2.ecModel, r2.api, r2.payload));
    return t2.length > 1 ? pr(t2, function(e2, n2) {
      return qH(n2);
    }) : vce;
  }
  var vce = qH(0);
  function qH(r2) {
    return function(t2, e2) {
      var n2 = e2.data, a = e2.resetDefines[r2];
      if (a && a.dataEach)
        for (var i = t2.start; i < t2.end; i++)
          a.dataEach(n2, i);
      else
        a && a.progress && a.progress(t2, n2);
    };
  }
  function dce(r2) {
    return r2.data.count();
  }
  function pce(r2) {
    sP = null;
    try {
      r2(cE, YH);
    } catch {
    }
    return sP;
  }
  var cE = {}, YH = {}, sP;
  KH(cE, bH);
  KH(YH, _H);
  cE.eachSeriesByType = cE.eachRawSeriesByType = function(r2) {
    sP = r2;
  };
  cE.eachComponent = function(r2) {
    r2.mainType === "series" && r2.subType && (sP = r2.subType);
  };
  function KH(r2, t2) {
    for (var e2 in t2.prototype)
      r2[e2] = lu;
  }
  var ZH = oce, bV = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], gce = { color: bV, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], bV] }, Ic = "#B9B8CE", _V = "#100C2A", RM = function() {
    return { axisLine: { lineStyle: { color: Ic } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
  }, xV = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], XH = { darkMode: true, color: xV, backgroundColor: _V, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: Ic } }, textStyle: { color: Ic }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: Ic } }, dataZoom: { borderColor: "#71708A", textStyle: { color: Ic }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: Ic } }, timeline: { lineStyle: { color: Ic }, label: { color: Ic }, controlStyle: { color: Ic, borderColor: Ic } }, calendar: { itemStyle: { color: _V }, dayLabel: { color: Ic }, monthLabel: { color: Ic }, yearLabel: { color: Ic } }, timeAxis: RM(), logAxis: RM(), valueAxis: RM(), categoryAxis: RM(), line: { symbol: "circle" }, graph: { color: xV }, gauge: { title: { color: Ic }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: Ic }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
  XH.categoryAxis.splitLine.show = false;
  var yce = XH, mce = function() {
    function r2() {
    }
    return r2.prototype.normalizeQuery = function(t2) {
      var e2 = {}, n2 = {}, a = {};
      if (Zr(t2)) {
        var i = Hd(t2);
        e2.mainType = i.main || null, e2.subType = i.sub || null;
      } else {
        var o = ["Index", "Name", "Id"], s = { name: 1, dataIndex: 1, dataType: 1 };
        ae(t2, function(u, l2) {
          for (var c2 = false, f2 = 0; f2 < o.length; f2++) {
            var h = o[f2], v9 = l2.lastIndexOf(h);
            if (v9 > 0 && v9 === l2.length - h.length) {
              var d2 = l2.slice(0, v9);
              d2 !== "data" && (e2.mainType = d2, e2[h.toLowerCase()] = u, c2 = true);
            }
          }
          s.hasOwnProperty(l2) && (n2[l2] = u, c2 = true), c2 || (a[l2] = u);
        });
      }
      return { cptQuery: e2, dataQuery: n2, otherQuery: a };
    }, r2.prototype.filter = function(t2, e2) {
      var n2 = this.eventInfo;
      if (!n2)
        return true;
      var a = n2.targetEl, i = n2.packedEvent, o = n2.model, s = n2.view;
      if (!o || !s)
        return true;
      var u = e2.cptQuery, l2 = e2.dataQuery;
      return c2(u, o, "mainType") && c2(u, o, "subType") && c2(u, o, "index", "componentIndex") && c2(u, o, "name") && c2(u, o, "id") && c2(l2, i, "name") && c2(l2, i, "dataIndex") && c2(l2, i, "dataType") && (!s.filterForExposedEvent || s.filterForExposedEvent(t2, e2.otherQuery, a, i));
      function c2(f2, h, v9, d2) {
        return f2[v9] == null || h[d2 || v9] === f2[v9];
      }
    }, r2.prototype.afterTrigger = function() {
      this.eventInfo = null;
    }, r2;
  }(), _4 = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], wV = _4.concat(["symbolKeepAspect"]), bce = { createOnAllSeries: true, performRawSeries: true, reset: function(r2, t2) {
    var e2 = r2.getData();
    if (r2.legendIcon && e2.setVisual("legendIcon", r2.legendIcon), !r2.hasSymbolVisual)
      return;
    for (var n2 = {}, a = {}, i = false, o = 0; o < _4.length; o++) {
      var s = _4[o], u = r2.get(s);
      xn(u) ? (i = true, a[s] = u) : n2[s] = u;
    }
    if (n2.symbol = n2.symbol || r2.defaultSymbol, e2.setVisual(qt({ legendIcon: r2.legendIcon || n2.symbol, symbolKeepAspect: r2.get("symbolKeepAspect") }, n2)), t2.isSeriesFiltered(r2))
      return;
    var l2 = ja(a);
    function c2(f2, h) {
      for (var v9 = r2.getRawValue(h), d2 = r2.getDataParams(h), m2 = 0; m2 < l2.length; m2++) {
        var b2 = l2[m2];
        f2.setItemVisual(h, b2, a[b2](v9, d2));
      }
    }
    return { dataEach: i ? c2 : null };
  } }, _ce = { createOnAllSeries: true, performRawSeries: true, reset: function(r2, t2) {
    if (!r2.hasSymbolVisual || t2.isSeriesFiltered(r2))
      return;
    var e2 = r2.getData();
    function n2(a, i) {
      for (var o = a.getItemModel(i), s = 0; s < wV.length; s++) {
        var u = wV[s], l2 = o.getShallow(u, true);
        l2 != null && a.setItemVisual(i, u, l2);
      }
    }
    return { dataEach: e2.hasItemOption ? n2 : null };
  } };
  function CF(r2, t2, e2) {
    switch (e2) {
      case "color":
        var n2 = r2.getItemVisual(t2, "style");
        return n2[r2.getVisual("drawType")];
      case "opacity":
        return r2.getItemVisual(t2, "style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return r2.getItemVisual(t2, e2);
    }
  }
  function NE(r2, t2) {
    switch (t2) {
      case "color":
        var e2 = r2.getVisual("style");
        return e2[r2.getVisual("drawType")];
      case "opacity":
        return r2.getVisual("style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return r2.getVisual(t2);
    }
  }
  function JH(r2, t2, e2, n2) {
    switch (e2) {
      case "color":
        var a = r2.ensureUniqueItemVisual(t2, "style");
        a[r2.getVisual("drawType")] = n2, r2.setItemVisual(t2, "colorFromPalette", false);
        break;
      case "opacity":
        r2.ensureUniqueItemVisual(t2, "style").opacity = n2;
        break;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        r2.setItemVisual(t2, e2, n2);
        break;
    }
  }
  function QH(r2, t2) {
    function e2(n2, a) {
      var i = [];
      return n2.eachComponent({ mainType: "series", subType: r2, query: a }, function(o) {
        i.push(o.seriesIndex);
      }), i;
    }
    ae([[r2 + "ToggleSelect", "toggleSelect"], [r2 + "Select", "select"], [r2 + "UnSelect", "unselect"]], function(n2) {
      t2(n2[0], function(a, i, o) {
        a = qt({}, a), o.dispatchAction(qt(a, { type: n2[1], seriesIndex: e2(i, a) }));
      });
    });
  }
  function _x(r2, t2, e2, n2, a) {
    var i = r2 + t2;
    e2.isSilent(i) || n2.eachComponent({ mainType: "series", subType: "pie" }, function(o) {
      for (var s = o.seriesIndex, u = o.option.selectedMap, l2 = a.selected, c2 = 0; c2 < l2.length; c2++)
        if (l2[c2].seriesIndex === s) {
          var f2 = o.getData(), h = e1(f2, a.fromActionPayload);
          e2.trigger(i, { type: i, seriesId: o.id, name: vr(h) ? f2.getName(h[0]) : f2.getName(h), selected: Zr(u) ? u : qt({}, u) });
        }
    });
  }
  function xce(r2, t2, e2) {
    r2.on("selectchanged", function(n2) {
      var a = e2.getModel();
      n2.isFromClick ? (_x("map", "selectchanged", t2, a, n2), _x("pie", "selectchanged", t2, a, n2)) : n2.fromAction === "select" ? (_x("map", "selected", t2, a, n2), _x("pie", "selected", t2, a, n2)) : n2.fromAction === "unselect" && (_x("map", "unselected", t2, a, n2), _x("pie", "unselected", t2, a, n2));
    });
  }
  function $x(r2, t2, e2) {
    for (var n2; r2 && !(t2(r2) && (n2 = r2, e2)); )
      r2 = r2.__hostTarget || r2.parent;
    return n2;
  }
  var wce = Math.round(Math.random() * 9), Sce = typeof Object.defineProperty == "function", Cce = function() {
    function r2() {
      this._id = "__ec_inner_" + wce++;
    }
    return r2.prototype.get = function(t2) {
      return this._guard(t2)[this._id];
    }, r2.prototype.set = function(t2, e2) {
      var n2 = this._guard(t2);
      return Sce ? Object.defineProperty(n2, this._id, { value: e2, enumerable: false, configurable: true }) : n2[this._id] = e2, this;
    }, r2.prototype.delete = function(t2) {
      return this.has(t2) ? (delete this._guard(t2)[this._id], true) : false;
    }, r2.prototype.has = function(t2) {
      return !!this._guard(t2)[this._id];
    }, r2.prototype._guard = function(t2) {
      if (t2 !== Object(t2))
        throw TypeError("Value of WeakMap is not a non-null object.");
      return t2;
    }, r2;
  }(), Ece = Cce, Ace = xa.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(r2, t2) {
    var e2 = t2.cx, n2 = t2.cy, a = t2.width / 2, i = t2.height / 2;
    r2.moveTo(e2, n2 - i), r2.lineTo(e2 + a, n2 + i), r2.lineTo(e2 - a, n2 + i), r2.closePath();
  } }), Tce = xa.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(r2, t2) {
    var e2 = t2.cx, n2 = t2.cy, a = t2.width / 2, i = t2.height / 2;
    r2.moveTo(e2, n2 - i), r2.lineTo(e2 + a, n2), r2.lineTo(e2, n2 + i), r2.lineTo(e2 - a, n2), r2.closePath();
  } }), Mce = xa.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(r2, t2) {
    var e2 = t2.x, n2 = t2.y, a = t2.width / 5 * 3, i = Math.max(a, t2.height), o = a / 2, s = o * o / (i - o), u = n2 - i + o + s, l2 = Math.asin(s / o), c2 = Math.cos(l2) * o, f2 = Math.sin(l2), h = Math.cos(l2), v9 = o * 0.6, d2 = o * 0.7;
    r2.moveTo(e2 - c2, u + s), r2.arc(e2, u, o, Math.PI - l2, Math.PI * 2 + l2), r2.bezierCurveTo(e2 + c2 - f2 * v9, u + s + h * v9, e2, n2 - d2, e2, n2), r2.bezierCurveTo(e2, n2 - d2, e2 - c2 + f2 * v9, u + s + h * v9, e2 - c2, u + s), r2.closePath();
  } }), Pce = xa.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(r2, t2) {
    var e2 = t2.height, n2 = t2.width, a = t2.x, i = t2.y, o = n2 / 3 * 2;
    r2.moveTo(a, i), r2.lineTo(a + o, i + e2), r2.lineTo(a, i + e2 / 4 * 3), r2.lineTo(a - o, i + e2), r2.lineTo(a, i), r2.closePath();
  } }), Dce = { line: bl, rect: ni, roundRect: ni, square: ni, circle: ap, diamond: Tce, pin: Mce, arrow: Pce, triangle: Ace }, Ice = { line: function(r2, t2, e2, n2, a) {
    a.x1 = r2, a.y1 = t2 + n2 / 2, a.x2 = r2 + e2, a.y2 = t2 + n2 / 2;
  }, rect: function(r2, t2, e2, n2, a) {
    a.x = r2, a.y = t2, a.width = e2, a.height = n2;
  }, roundRect: function(r2, t2, e2, n2, a) {
    a.x = r2, a.y = t2, a.width = e2, a.height = n2, a.r = Math.min(e2, n2) / 4;
  }, square: function(r2, t2, e2, n2, a) {
    var i = Math.min(e2, n2);
    a.x = r2, a.y = t2, a.width = i, a.height = i;
  }, circle: function(r2, t2, e2, n2, a) {
    a.cx = r2 + e2 / 2, a.cy = t2 + n2 / 2, a.r = Math.min(e2, n2) / 2;
  }, diamond: function(r2, t2, e2, n2, a) {
    a.cx = r2 + e2 / 2, a.cy = t2 + n2 / 2, a.width = e2, a.height = n2;
  }, pin: function(r2, t2, e2, n2, a) {
    a.x = r2 + e2 / 2, a.y = t2 + n2 / 2, a.width = e2, a.height = n2;
  }, arrow: function(r2, t2, e2, n2, a) {
    a.x = r2 + e2 / 2, a.y = t2 + n2 / 2, a.width = e2, a.height = n2;
  }, triangle: function(r2, t2, e2, n2, a) {
    a.cx = r2 + e2 / 2, a.cy = t2 + n2 / 2, a.width = e2, a.height = n2;
  } }, uP = {};
  ae(Dce, function(r2, t2) {
    uP[t2] = new r2();
  });
  var Lce = xa.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(r2, t2, e2) {
    var n2 = Z5(r2, t2, e2), a = this.shape;
    return a && a.symbolType === "pin" && t2.position === "inside" && (n2.y = e2.y + e2.height * 0.4), n2;
  }, buildPath: function(r2, t2, e2) {
    var n2 = t2.symbolType;
    if (n2 !== "none") {
      var a = uP[n2];
      a || (n2 = "rect", a = uP[n2]), Ice[n2](t2.x, t2.y, t2.width, t2.height, a.shape), a.buildPath(r2, a.shape, e2);
    }
  } });
  function Oce(r2, t2) {
    if (this.type !== "image") {
      var e2 = this.style;
      this.__isEmptyBrush ? (e2.stroke = r2, e2.fill = t2 || "#fff", e2.lineWidth = 2) : this.shape.symbolType === "line" ? e2.stroke = r2 : e2.fill = r2, this.markRedraw();
    }
  }
  function cu(r2, t2, e2, n2, a, i, o) {
    var s = r2.indexOf("empty") === 0;
    s && (r2 = r2.substr(5, 1).toLowerCase() + r2.substr(6));
    var u;
    return r2.indexOf("image://") === 0 ? u = VU(r2.slice(8), new da(t2, e2, n2, a), o ? "center" : "cover") : r2.indexOf("path://") === 0 ? u = r3(r2.slice(7), {}, new da(t2, e2, n2, a), o ? "center" : "cover") : u = new Lce({ shape: { symbolType: r2, x: t2, y: e2, width: n2, height: a } }), u.__isEmptyBrush = s, u.setColor = Oce, i && u.setColor(i), u;
  }
  function VE(r2) {
    return vr(r2) || (r2 = [+r2, +r2]), [r2[0] || 0, r2[1] || 0];
  }
  function Cw(r2, t2) {
    if (r2 != null)
      return vr(r2) || (r2 = [r2, r2]), [qr(r2[0], t2[0]) || 0, qr(ia(r2[1], r2[0]), t2[1]) || 0];
  }
  function kce(r2, t2, e2) {
    var n2 = t2.x == null ? 0 : t2.x, a = t2.x2 == null ? 1 : t2.x2, i = t2.y == null ? 0 : t2.y, o = t2.y2 == null ? 0 : t2.y2;
    t2.global || (n2 = n2 * e2.width + e2.x, a = a * e2.width + e2.x, i = i * e2.height + e2.y, o = o * e2.height + e2.y), n2 = isNaN(n2) ? 0 : n2, a = isNaN(a) ? 1 : a, i = isNaN(i) ? 0 : i, o = isNaN(o) ? 0 : o;
    var s = r2.createLinearGradient(n2, i, a, o);
    return s;
  }
  function Rce(r2, t2, e2) {
    var n2 = e2.width, a = e2.height, i = Math.min(n2, a), o = t2.x == null ? 0.5 : t2.x, s = t2.y == null ? 0.5 : t2.y, u = t2.r == null ? 0.5 : t2.r;
    t2.global || (o = o * n2 + e2.x, s = s * a + e2.y, u = u * i);
    var l2 = r2.createRadialGradient(o, s, 0, o, s, u);
    return l2;
  }
  function x4(r2, t2, e2) {
    for (var n2 = t2.type === "radial" ? Rce(r2, t2, e2) : kce(r2, t2, e2), a = t2.colorStops, i = 0; i < a.length; i++)
      n2.addColorStop(a[i].offset, a[i].color);
    return n2;
  }
  function Fce(r2, t2) {
    if (r2 === t2 || !r2 && !t2)
      return false;
    if (!r2 || !t2 || r2.length !== t2.length)
      return true;
    for (var e2 = 0; e2 < r2.length; e2++)
      if (r2[e2] !== t2[e2])
        return true;
    return false;
  }
  function FM(r2) {
    return parseInt(r2, 10);
  }
  function Gx(r2, t2, e2) {
    var n2 = ["width", "height"][t2], a = ["clientWidth", "clientHeight"][t2], i = ["paddingLeft", "paddingTop"][t2], o = ["paddingRight", "paddingBottom"][t2];
    if (e2[n2] != null && e2[n2] !== "auto")
      return parseFloat(e2[n2]);
    var s = document.defaultView.getComputedStyle(r2);
    return (r2[a] || FM(s[n2]) || FM(r2.style[n2])) - (FM(s[i]) || 0) - (FM(s[o]) || 0) | 0;
  }
  function Nce(r2, t2) {
    return !r2 || r2 === "solid" || !(t2 > 0) ? null : r2 === "dashed" ? [4 * t2, 2 * t2] : r2 === "dotted" ? [t2] : Ai(r2) ? [r2] : vr(r2) ? r2 : null;
  }
  function EF(r2) {
    var t2 = r2.style, e2 = t2.lineDash && t2.lineWidth > 0 && Nce(t2.lineDash, t2.lineWidth), n2 = t2.lineDashOffset;
    if (e2) {
      var a = t2.strokeNoScale && r2.getLineScale ? r2.getLineScale() : 1;
      a && a !== 1 && (e2 = pr(e2, function(i) {
        return i / a;
      }), n2 /= a);
    }
    return [e2, n2];
  }
  var Vce = new np(true);
  function lP(r2) {
    var t2 = r2.stroke;
    return !(t2 == null || t2 === "none" || !(r2.lineWidth > 0));
  }
  function SV(r2) {
    return typeof r2 == "string" && r2 !== "none";
  }
  function cP(r2) {
    var t2 = r2.fill;
    return t2 != null && t2 !== "none";
  }
  function CV(r2, t2) {
    if (t2.fillOpacity != null && t2.fillOpacity !== 1) {
      var e2 = r2.globalAlpha;
      r2.globalAlpha = t2.fillOpacity * t2.opacity, r2.fill(), r2.globalAlpha = e2;
    } else
      r2.fill();
  }
  function EV(r2, t2) {
    if (t2.strokeOpacity != null && t2.strokeOpacity !== 1) {
      var e2 = r2.globalAlpha;
      r2.globalAlpha = t2.strokeOpacity * t2.opacity, r2.stroke(), r2.globalAlpha = e2;
    } else
      r2.stroke();
  }
  function w4(r2, t2, e2) {
    var n2 = Z6(t2.image, t2.__image, e2);
    if (KP(n2)) {
      var a = r2.createPattern(n2, t2.repeat || "repeat");
      if (typeof DOMMatrix == "function" && a && a.setTransform) {
        var i = new DOMMatrix();
        i.translateSelf(t2.x || 0, t2.y || 0), i.rotateSelf(0, 0, (t2.rotation || 0) * x5), i.scaleSelf(t2.scaleX || 1, t2.scaleY || 1), a.setTransform(i);
      }
      return a;
    }
  }
  function jce(r2, t2, e2, n2) {
    var a, i = lP(e2), o = cP(e2), s = e2.strokePercent, u = s < 1, l2 = !t2.path;
    (!t2.silent || u) && l2 && t2.createPathProxy();
    var c2 = t2.path || Vce, f2 = t2.__dirty;
    if (!n2) {
      var h = e2.fill, v9 = e2.stroke, d2 = o && !!h.colorStops, m2 = i && !!v9.colorStops, b2 = o && !!h.image, _ = i && !!v9.image, C = void 0, M = void 0, E = void 0, z9 = void 0, V = void 0;
      (d2 || m2) && (V = t2.getBoundingRect()), d2 && (C = f2 ? x4(r2, h, V) : t2.__canvasFillGradient, t2.__canvasFillGradient = C), m2 && (M = f2 ? x4(r2, v9, V) : t2.__canvasStrokeGradient, t2.__canvasStrokeGradient = M), b2 && (E = f2 || !t2.__canvasFillPattern ? w4(r2, h, t2) : t2.__canvasFillPattern, t2.__canvasFillPattern = E), _ && (z9 = f2 || !t2.__canvasStrokePattern ? w4(r2, v9, t2) : t2.__canvasStrokePattern, t2.__canvasStrokePattern = E), d2 ? r2.fillStyle = C : b2 && (E ? r2.fillStyle = E : o = false), m2 ? r2.strokeStyle = M : _ && (z9 ? r2.strokeStyle = z9 : i = false);
    }
    var $ = t2.getGlobalScale();
    c2.setScale($[0], $[1], t2.segmentIgnoreThreshold);
    var U, H;
    r2.setLineDash && e2.lineDash && (a = EF(t2), U = a[0], H = a[1]);
    var q3 = true;
    (l2 || f2 & kx) && (c2.setDPR(r2.dpr), u ? c2.setContext(null) : (c2.setContext(r2), q3 = false), c2.reset(), t2.buildPath(c2, t2.shape, n2), c2.toStatic(), t2.pathUpdated()), q3 && c2.rebuildPath(r2, u ? s : 1), U && (r2.setLineDash(U), r2.lineDashOffset = H), n2 || (e2.strokeFirst ? (i && EV(r2, e2), o && CV(r2, e2)) : (o && CV(r2, e2), i && EV(r2, e2))), U && r2.setLineDash([]);
  }
  function Bce(r2, t2, e2) {
    var n2 = t2.__image = Z6(e2.image, t2.__image, t2, t2.onload);
    if (!(!n2 || !KP(n2))) {
      var a = e2.x || 0, i = e2.y || 0, o = t2.getWidth(), s = t2.getHeight(), u = n2.width / n2.height;
      if (o == null && s != null ? o = s * u : s == null && o != null ? s = o / u : o == null && s == null && (o = n2.width, s = n2.height), e2.sWidth && e2.sHeight) {
        var l2 = e2.sx || 0, c2 = e2.sy || 0;
        r2.drawImage(n2, l2, c2, e2.sWidth, e2.sHeight, a, i, o, s);
      } else if (e2.sx && e2.sy) {
        var l2 = e2.sx, c2 = e2.sy, f2 = o - l2, h = s - c2;
        r2.drawImage(n2, l2, c2, f2, h, a, i, o, s);
      } else
        r2.drawImage(n2, a, i, o, s);
    }
  }
  function zce(r2, t2, e2) {
    var n2, a = e2.text;
    if (a != null && (a += ""), a) {
      r2.font = e2.font || gy, r2.textAlign = e2.textAlign, r2.textBaseline = e2.textBaseline;
      var i = void 0, o = void 0;
      r2.setLineDash && e2.lineDash && (n2 = EF(t2), i = n2[0], o = n2[1]), i && (r2.setLineDash(i), r2.lineDashOffset = o), e2.strokeFirst ? (lP(e2) && r2.strokeText(a, e2.x, e2.y), cP(e2) && r2.fillText(a, e2.x, e2.y)) : (cP(e2) && r2.fillText(a, e2.x, e2.y), lP(e2) && r2.strokeText(a, e2.x, e2.y)), i && r2.setLineDash([]);
    }
  }
  var AV = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], TV = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
  function eq(r2, t2, e2, n2, a) {
    var i = false;
    if (!n2 && (e2 = e2 || {}, t2 === e2))
      return false;
    if (n2 || t2.opacity !== e2.opacity) {
      df(r2, a), i = true;
      var o = Math.max(Math.min(t2.opacity, 1), 0);
      r2.globalAlpha = isNaN(o) ? Ub.opacity : o;
    }
    (n2 || t2.blend !== e2.blend) && (i || (df(r2, a), i = true), r2.globalCompositeOperation = t2.blend || Ub.blend);
    for (var s = 0; s < AV.length; s++) {
      var u = AV[s];
      (n2 || t2[u] !== e2[u]) && (i || (df(r2, a), i = true), r2[u] = r2.dpr * (t2[u] || 0));
    }
    return (n2 || t2.shadowColor !== e2.shadowColor) && (i || (df(r2, a), i = true), r2.shadowColor = t2.shadowColor || Ub.shadowColor), i;
  }
  function MV(r2, t2, e2, n2, a) {
    var i = fE(t2, a.inHover), o = n2 ? null : e2 && fE(e2, a.inHover) || {};
    if (i === o)
      return false;
    var s = eq(r2, i, o, n2, a);
    if ((n2 || i.fill !== o.fill) && (s || (df(r2, a), s = true), SV(i.fill) && (r2.fillStyle = i.fill)), (n2 || i.stroke !== o.stroke) && (s || (df(r2, a), s = true), SV(i.stroke) && (r2.strokeStyle = i.stroke)), (n2 || i.opacity !== o.opacity) && (s || (df(r2, a), s = true), r2.globalAlpha = i.opacity == null ? 1 : i.opacity), t2.hasStroke()) {
      var u = i.lineWidth, l2 = u / (i.strokeNoScale && t2.getLineScale ? t2.getLineScale() : 1);
      r2.lineWidth !== l2 && (s || (df(r2, a), s = true), r2.lineWidth = l2);
    }
    for (var c2 = 0; c2 < TV.length; c2++) {
      var f2 = TV[c2], h = f2[0];
      (n2 || i[h] !== o[h]) && (s || (df(r2, a), s = true), r2[h] = i[h] || f2[1]);
    }
    return s;
  }
  function $ce(r2, t2, e2, n2, a) {
    return eq(r2, fE(t2, a.inHover), e2 && fE(e2, a.inHover), n2, a);
  }
  function tq(r2, t2) {
    var e2 = t2.transform, n2 = r2.dpr || 1;
    e2 ? r2.setTransform(n2 * e2[0], n2 * e2[1], n2 * e2[2], n2 * e2[3], n2 * e2[4], n2 * e2[5]) : r2.setTransform(n2, 0, 0, n2, 0, 0);
  }
  function Gce(r2, t2, e2) {
    for (var n2 = false, a = 0; a < r2.length; a++) {
      var i = r2[a];
      n2 = n2 || i.isZeroArea(), tq(t2, i), t2.beginPath(), i.buildPath(t2, i.shape), t2.clip();
    }
    e2.allClipped = n2;
  }
  function Wce(r2, t2) {
    return r2 && t2 ? r2[0] !== t2[0] || r2[1] !== t2[1] || r2[2] !== t2[2] || r2[3] !== t2[3] || r2[4] !== t2[4] || r2[5] !== t2[5] : !(!r2 && !t2);
  }
  var PV = 1, DV = 2, IV = 3, LV = 4;
  function Uce(r2) {
    var t2 = cP(r2), e2 = lP(r2);
    return !(r2.lineDash || !(+t2 ^ +e2) || t2 && typeof r2.fill != "string" || e2 && typeof r2.stroke != "string" || r2.strokePercent < 1 || r2.strokeOpacity < 1 || r2.fillOpacity < 1);
  }
  function df(r2, t2) {
    t2.batchFill && r2.fill(), t2.batchStroke && r2.stroke(), t2.batchFill = "", t2.batchStroke = "";
  }
  function fE(r2, t2) {
    return t2 && r2.__hoverStyle || r2.style;
  }
  function rq(r2, t2) {
    $b(r2, t2, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
  }
  function $b(r2, t2, e2, n2) {
    var a = t2.transform;
    if (!t2.shouldBePainted(e2.viewWidth, e2.viewHeight, false, false)) {
      t2.__dirty &= ~Kf, t2.__isRendered = false;
      return;
    }
    var i = t2.__clipPaths, o = e2.prevElClipPaths, s = false, u = false;
    if ((!o || Fce(i, o)) && (o && o.length && (df(r2, e2), r2.restore(), u = s = true, e2.prevElClipPaths = null, e2.allClipped = false, e2.prevEl = null), i && i.length && (df(r2, e2), r2.save(), Gce(i, r2, e2), s = true), e2.prevElClipPaths = i), e2.allClipped) {
      t2.__isRendered = false;
      return;
    }
    t2.beforeBrush && t2.beforeBrush(), t2.innerBeforeBrush();
    var l2 = e2.prevEl;
    l2 || (u = s = true);
    var c2 = t2 instanceof xa && t2.autoBatch && Uce(t2.style);
    s || Wce(a, l2.transform) ? (df(r2, e2), tq(r2, t2)) : c2 || df(r2, e2);
    var f2 = fE(t2, e2.inHover);
    t2 instanceof xa ? (e2.lastDrawType !== PV && (u = true, e2.lastDrawType = PV), MV(r2, t2, l2, u, e2), (!c2 || !e2.batchFill && !e2.batchStroke) && r2.beginPath(), jce(r2, t2, f2, c2), c2 && (e2.batchFill = f2.fill || "", e2.batchStroke = f2.stroke || "")) : t2 instanceof tE ? (e2.lastDrawType !== IV && (u = true, e2.lastDrawType = IV), MV(r2, t2, l2, u, e2), zce(r2, t2, f2)) : t2 instanceof Bl ? (e2.lastDrawType !== DV && (u = true, e2.lastDrawType = DV), $ce(r2, t2, l2, u, e2), Bce(r2, t2, f2)) : t2.getTemporalDisplayables && (e2.lastDrawType !== LV && (u = true, e2.lastDrawType = LV), Hce(r2, t2, e2)), c2 && n2 && df(r2, e2), t2.innerAfterBrush(), t2.afterBrush && t2.afterBrush(), e2.prevEl = t2, t2.__dirty = 0, t2.__isRendered = true;
  }
  function Hce(r2, t2, e2) {
    var n2 = t2.getDisplayables(), a = t2.getTemporalDisplayables();
    r2.save();
    var i = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: e2.viewWidth, viewHeight: e2.viewHeight, inHover: e2.inHover }, o, s;
    for (o = t2.getCursor(), s = n2.length; o < s; o++) {
      var u = n2[o];
      u.beforeBrush && u.beforeBrush(), u.innerBeforeBrush(), $b(r2, u, i, o === s - 1), u.innerAfterBrush(), u.afterBrush && u.afterBrush(), i.prevEl = u;
    }
    for (var l2 = 0, c2 = a.length; l2 < c2; l2++) {
      var u = a[l2];
      u.beforeBrush && u.beforeBrush(), u.innerBeforeBrush(), $b(r2, u, i, l2 === c2 - 1), u.innerAfterBrush(), u.afterBrush && u.afterBrush(), i.prevEl = u;
    }
    t2.clearTemporalDisplayables(), t2.notClear = true, r2.restore();
  }
  var WO = new Ece(), OV = new ME(100), kV = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
  function hE(r2, t2) {
    if (r2 === "none")
      return null;
    var e2 = t2.getDevicePixelRatio(), n2 = t2.getZr(), a = n2.painter.type === "svg";
    r2.dirty && WO.delete(r2);
    var i = WO.get(r2);
    if (i)
      return i;
    var o = En(r2, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
    o.backgroundColor === "none" && (o.backgroundColor = null);
    var s = { repeat: "repeat" };
    return u(s), s.rotation = o.rotation, s.scaleX = s.scaleY = a ? 1 : 1 / e2, WO.set(r2, s), r2.dirty = false, s;
    function u(l2) {
      for (var c2 = [e2], f2 = true, h = 0; h < kV.length; ++h) {
        var v9 = o[kV[h]];
        if (v9 != null && !vr(v9) && !Zr(v9) && !Ai(v9) && typeof v9 != "boolean") {
          f2 = false;
          break;
        }
        c2.push(v9);
      }
      var d2;
      if (f2) {
        d2 = c2.join(",") + (a ? "-svg" : "");
        var m2 = OV.get(d2);
        m2 && (a ? l2.svgElement = m2 : l2.image = m2);
      }
      var b2 = aq(o.dashArrayX), _ = qce(o.dashArrayY), C = nq(o.symbol), M = Yce(b2), E = iq(_), z9 = !a && Tg.createCanvas(), V = a && { tag: "g", attrs: {}, key: "dcl", children: [] }, $ = H(), U;
      z9 && (z9.width = $.width * e2, z9.height = $.height * e2, U = z9.getContext("2d")), q3(), f2 && OV.put(d2, z9 || V), l2.image = z9, l2.svgElement = V, l2.svgWidth = $.width, l2.svgHeight = $.height;
      function H() {
        for (var ee = 1, oe = 0, ne = M.length; oe < ne; ++oe)
          ee = K8(ee, M[oe]);
        for (var be = 1, oe = 0, ne = C.length; oe < ne; ++oe)
          be = K8(be, C[oe].length);
        ee *= be;
        var Ee = E * M.length * C.length;
        return { width: Math.max(1, Math.min(ee, o.maxTileWidth)), height: Math.max(1, Math.min(Ee, o.maxTileHeight)) };
      }
      function q3() {
        U && (U.clearRect(0, 0, z9.width, z9.height), o.backgroundColor && (U.fillStyle = o.backgroundColor, U.fillRect(0, 0, z9.width, z9.height)));
        for (var ee = 0, oe = 0; oe < _.length; ++oe)
          ee += _[oe];
        if (ee <= 0)
          return;
        for (var ne = -E, be = 0, Ee = 0, ye = 0; ne < $.height; ) {
          if (be % 2 === 0) {
            for (var et = Ee / 2 % C.length, Le = 0, Fe = 0, qe = 0; Le < $.width * 2; ) {
              for (var st = 0, oe = 0; oe < b2[ye].length; ++oe)
                st += b2[ye][oe];
              if (st <= 0)
                break;
              if (Fe % 2 === 0) {
                var dt = (1 - o.symbolSize) * 0.5, Ar = Le + b2[ye][Fe] * dt, Hr = ne + _[be] * dt, hn = b2[ye][Fe] * o.symbolSize, cn = _[be] * o.symbolSize, nn = qe / 2 % C[et].length;
                Wr(Ar, Hr, hn, cn, C[et][nn]);
              }
              Le += b2[ye][Fe], ++qe, ++Fe, Fe === b2[ye].length && (Fe = 0);
            }
            ++ye, ye === b2.length && (ye = 0);
          }
          ne += _[be], ++Ee, ++be, be === _.length && (be = 0);
        }
        function Wr(on, un, Xr, _n, Za) {
          var Dn = a ? 1 : e2, ai = cu(Za, on * Dn, un * Dn, Xr * Dn, _n * Dn, o.color, o.symbolKeepAspect);
          if (a) {
            var wi = n2.painter.renderOneToVNode(ai);
            wi && V.children.push(wi);
          } else
            rq(U, ai);
        }
      }
    }
  }
  function nq(r2) {
    if (!r2 || r2.length === 0)
      return [["rect"]];
    if (Zr(r2))
      return [[r2]];
    for (var t2 = true, e2 = 0; e2 < r2.length; ++e2)
      if (!Zr(r2[e2])) {
        t2 = false;
        break;
      }
    if (t2)
      return nq([r2]);
    for (var n2 = [], e2 = 0; e2 < r2.length; ++e2)
      Zr(r2[e2]) ? n2.push([r2[e2]]) : n2.push(r2[e2]);
    return n2;
  }
  function aq(r2) {
    if (!r2 || r2.length === 0)
      return [[0, 0]];
    if (Ai(r2)) {
      var t2 = Math.ceil(r2);
      return [[t2, t2]];
    }
    for (var e2 = true, n2 = 0; n2 < r2.length; ++n2)
      if (!Ai(r2[n2])) {
        e2 = false;
        break;
      }
    if (e2)
      return aq([r2]);
    for (var a = [], n2 = 0; n2 < r2.length; ++n2)
      if (Ai(r2[n2])) {
        var t2 = Math.ceil(r2[n2]);
        a.push([t2, t2]);
      } else {
        var t2 = pr(r2[n2], function(s) {
          return Math.ceil(s);
        });
        t2.length % 2 === 1 ? a.push(t2.concat(t2)) : a.push(t2);
      }
    return a;
  }
  function qce(r2) {
    if (!r2 || typeof r2 == "object" && r2.length === 0)
      return [0, 0];
    if (Ai(r2)) {
      var t2 = Math.ceil(r2);
      return [t2, t2];
    }
    var e2 = pr(r2, function(n2) {
      return Math.ceil(n2);
    });
    return r2.length % 2 ? e2.concat(e2) : e2;
  }
  function Yce(r2) {
    return pr(r2, function(t2) {
      return iq(t2);
    });
  }
  function iq(r2) {
    for (var t2 = 0, e2 = 0; e2 < r2.length; ++e2)
      t2 += r2[e2];
    return r2.length % 2 === 1 ? t2 * 2 : t2;
  }
  function Kce(r2, t2) {
    r2.eachRawSeries(function(e2) {
      if (!r2.isSeriesFiltered(e2)) {
        var n2 = e2.getData();
        n2.hasItemVisual() && n2.each(function(o) {
          var s = n2.getItemVisual(o, "decal");
          if (s) {
            var u = n2.ensureUniqueItemVisual(o, "style");
            u.decal = hE(s, t2);
          }
        });
        var a = n2.getVisual("decal");
        if (a) {
          var i = n2.getVisual("style");
          i.decal = hE(a, t2);
        }
      }
    });
  }
  var Zce = new Yh(), Nv = Zce, oq = {};
  function Xce(r2, t2) {
    oq[r2] = t2;
  }
  function Jce(r2) {
    return oq[r2];
  }
  var Qce = typeof window != "undefined", efe = 1, tfe = 800, rfe = 900, nfe = 1e3, afe = 2e3, ife = 5e3, sq = 1e3, ofe = 1100, AF = 2e3, uq = 3e3, sfe = 4e3, d3 = 4500, ufe = 4600, lfe = 5e3, cfe = 6e3, lq = 7e3, ffe = { PROCESSOR: { FILTER: nfe, SERIES_FILTER: tfe, STATISTIC: ife }, VISUAL: { LAYOUT: sq, PROGRESSIVE_LAYOUT: ofe, GLOBAL: AF, CHART: uq, POST_CHART_LAYOUT: ufe, COMPONENT: sfe, BRUSH: lfe, CHART_ITEM: d3, ARIA: cfe, DECAL: lq } }, ic = "__flagInMainProcess", ff = "__pendingUpdate", UO = "__needsUpdateStatus", RV = /^[a-zA-Z0-9_]+$/, HO = "__connectUpdateStatus", FV = 0, hfe = 1, vfe = 2;
  function cq(r2) {
    return function() {
      for (var t2 = [], e2 = 0; e2 < arguments.length; e2++)
        t2[e2] = arguments[e2];
      if (this.isDisposed()) {
        this.id;
        return;
      }
      return hq(this, r2, t2);
    };
  }
  function fq(r2) {
    return function() {
      for (var t2 = [], e2 = 0; e2 < arguments.length; e2++)
        t2[e2] = arguments[e2];
      return hq(this, r2, t2);
    };
  }
  function hq(r2, t2, e2) {
    return e2[0] = e2[0] && e2[0].toLowerCase(), Yh.prototype[t2].apply(r2, e2);
  }
  var vq = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2;
  }(Yh), dq = vq.prototype;
  dq.on = fq("on");
  dq.off = fq("off");
  var xx, qO, NM, H0, YO, KO, ZO, J2, Q2, NV, VV, XO, jV, VM, BV, pq, Ah, zV, gq = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this, new mce()) || this;
      i._chartsViews = [], i._chartsMap = {}, i._componentsViews = [], i._componentsMap = {}, i._pendingActions = [], a = a || {}, Zr(n2) && (n2 = yq[n2]), i._dom = e2;
      var o = "canvas", s = false, u = i._zr = U8(e2, { renderer: a.renderer || o, devicePixelRatio: a.devicePixelRatio, width: a.width, height: a.height, ssr: a.ssr, useDirtyRect: a.useDirtyRect == null ? s : a.useDirtyRect });
      i._ssr = a.ssr, i._throttledZrFlush = SF(en(u.flush, u), 17), n2 = On(n2), n2 && wH(n2, true), i._theme = n2, i._locale = Sue(a.locale || KU), i._coordSysMgr = new FE();
      var l2 = i._api = BV(i);
      function c2(f2, h) {
        return f2.__prio - h.__prio;
      }
      return S5(hP, c2), S5(S4, c2), i._scheduler = new ZH(i, l2, S4, hP), i._messageCenter = new vq(), i._initEvents(), i.resize = en(i.resize, i), u.animation.on("frame", i._onframe, i), NV(u, i), VV(u, i), G5(i), i;
    }
    return t2.prototype._onframe = function() {
      if (!this._disposed) {
        zV(this);
        var e2 = this._scheduler;
        if (this[ff]) {
          var n2 = this[ff].silent;
          this[ic] = true;
          try {
            xx(this), H0.update.call(this, null, this[ff].updateParams);
          } catch (u) {
            throw this[ic] = false, this[ff] = null, u;
          }
          this._zr.flush(), this[ic] = false, this[ff] = null, J2.call(this, n2), Q2.call(this, n2);
        } else if (e2.unfinished) {
          var a = efe, i = this._model, o = this._api;
          e2.unfinished = false;
          do {
            var s = +new Date();
            e2.performSeriesTasks(i), e2.performDataProcessorTasks(i), KO(this, i), e2.performVisualTasks(i), VM(this, this._model, o, "remain", {}), a -= +new Date() - s;
          } while (a > 0 && e2.unfinished);
          e2.unfinished || this._zr.flush();
        }
      }
    }, t2.prototype.getDom = function() {
      return this._dom;
    }, t2.prototype.getId = function() {
      return this.id;
    }, t2.prototype.getZr = function() {
      return this._zr;
    }, t2.prototype.isSSR = function() {
      return this._ssr;
    }, t2.prototype.setOption = function(e2, n2, a) {
      if (!this[ic]) {
        if (this._disposed) {
          this.id;
          return;
        }
        var i, o, s;
        if (Tn(n2) && (a = n2.lazyUpdate, i = n2.silent, o = n2.replaceMerge, s = n2.transition, n2 = n2.notMerge), this[ic] = true, !this._model || n2) {
          var u = new nle(this._api), l2 = this._theme, c2 = this._model = new bH();
          c2.scheduler = this._scheduler, c2.ssr = this._ssr, c2.init(null, null, null, l2, this._locale, u);
        }
        this._model.setOption(e2, { replaceMerge: o }, C4);
        var f2 = { seriesTransition: s, optionChanged: true };
        if (a)
          this[ff] = { silent: i, updateParams: f2 }, this[ic] = false, this.getZr().wakeUp();
        else {
          try {
            xx(this), H0.update.call(this, null, f2);
          } catch (h) {
            throw this[ff] = null, this[ic] = false, h;
          }
          this._ssr || this._zr.flush(), this[ff] = null, this[ic] = false, J2.call(this, i), Q2.call(this, i);
        }
      }
    }, t2.prototype.setTheme = function() {
    }, t2.prototype.getModel = function() {
      return this._model;
    }, t2.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, t2.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, t2.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, t2.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || Qce && window.devicePixelRatio || 1;
    }, t2.prototype.getRenderedCanvas = function(e2) {
      return this.renderToCanvas(e2);
    }, t2.prototype.renderToCanvas = function(e2) {
      e2 = e2 || {};
      var n2 = this._zr.painter;
      return n2.getRenderedCanvas({ backgroundColor: e2.backgroundColor || this._model.get("backgroundColor"), pixelRatio: e2.pixelRatio || this.getDevicePixelRatio() });
    }, t2.prototype.renderToSVGString = function(e2) {
      e2 = e2 || {};
      var n2 = this._zr.painter;
      return n2.renderToString({ useViewBox: e2.useViewBox });
    }, t2.prototype.getSvgDataURL = function() {
      if (!!Ei.svgSupported) {
        var e2 = this._zr, n2 = e2.storage.getDisplayList();
        return ae(n2, function(a) {
          a.stopAnimation(null, true);
        }), e2.painter.toDataURL();
      }
    }, t2.prototype.getDataURL = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      e2 = e2 || {};
      var n2 = e2.excludeComponents, a = this._model, i = [], o = this;
      ae(n2, function(u) {
        a.eachComponent({ mainType: u }, function(l2) {
          var c2 = o._componentsMap[l2.__viewId];
          c2.group.ignore || (i.push(c2), c2.group.ignore = true);
        });
      });
      var s = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(e2).toDataURL("image/" + (e2 && e2.type || "png"));
      return ae(i, function(u) {
        u.group.ignore = false;
      }), s;
    }, t2.prototype.getConnectedDataURL = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var n2 = e2.type === "svg", a = this.group, i = Math.min, o = Math.max, s = 1 / 0;
      if ($V[a]) {
        var u = s, l2 = s, c2 = -s, f2 = -s, h = [], v9 = e2 && e2.pixelRatio || this.getDevicePixelRatio();
        ae($C, function(M, E) {
          if (M.group === a) {
            var z9 = n2 ? M.getZr().painter.getSvgDom().innerHTML : M.renderToCanvas(On(e2)), V = M.getDom().getBoundingClientRect();
            u = i(V.left, u), l2 = i(V.top, l2), c2 = o(V.right, c2), f2 = o(V.bottom, f2), h.push({ dom: z9, left: V.left, top: V.top });
          }
        }), u *= v9, l2 *= v9, c2 *= v9, f2 *= v9;
        var d2 = c2 - u, m2 = f2 - l2, b2 = Tg.createCanvas(), _ = U8(b2, { renderer: n2 ? "svg" : "canvas" });
        if (_.resize({ width: d2, height: m2 }), n2) {
          var C = "";
          return ae(h, function(M) {
            var E = M.left - u, z9 = M.top - l2;
            C += '<g transform="translate(' + E + "," + z9 + ')">' + M.dom + "</g>";
          }), _.painter.getSvgRoot().innerHTML = C, e2.connectedBackgroundColor && _.painter.setBackgroundColor(e2.connectedBackgroundColor), _.refreshImmediately(), _.painter.toDataURL();
        } else
          return e2.connectedBackgroundColor && _.add(new ni({ shape: { x: 0, y: 0, width: d2, height: m2 }, style: { fill: e2.connectedBackgroundColor } })), ae(h, function(M) {
            var E = new Bl({ style: { x: M.left * v9 - u, y: M.top * v9 - l2, image: M.dom } });
            _.add(E);
          }), _.refreshImmediately(), b2.toDataURL("image/" + (e2 && e2.type || "png"));
      } else
        return this.getDataURL(e2);
    }, t2.prototype.convertToPixel = function(e2, n2) {
      return YO(this, "convertToPixel", e2, n2);
    }, t2.prototype.convertFromPixel = function(e2, n2) {
      return YO(this, "convertFromPixel", e2, n2);
    }, t2.prototype.containPixel = function(e2, n2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var a = this._model, i, o = RC(a, e2);
      return ae(o, function(s, u) {
        u.indexOf("Models") >= 0 && ae(s, function(l2) {
          var c2 = l2.coordinateSystem;
          if (c2 && c2.containPoint)
            i = i || !!c2.containPoint(n2);
          else if (u === "seriesModels") {
            var f2 = this._chartsMap[l2.__viewId];
            f2 && f2.containPoint && (i = i || f2.containPoint(n2, l2));
          }
        }, this);
      }, this), !!i;
    }, t2.prototype.getVisual = function(e2, n2) {
      var a = this._model, i = RC(a, e2, { defaultMainType: "series" }), o = i.seriesModel, s = o.getData(), u = i.hasOwnProperty("dataIndexInside") ? i.dataIndexInside : i.hasOwnProperty("dataIndex") ? s.indexOfRawIndex(i.dataIndex) : null;
      return u != null ? CF(s, u, n2) : NE(s, n2);
    }, t2.prototype.getViewOfComponentModel = function(e2) {
      return this._componentsMap[e2.__viewId];
    }, t2.prototype.getViewOfSeriesModel = function(e2) {
      return this._chartsMap[e2.__viewId];
    }, t2.prototype._initEvents = function() {
      var e2 = this;
      ae(dfe, function(n2) {
        var a = function(i) {
          var o = e2.getModel(), s = i.target, u, l2 = n2 === "globalout";
          if (l2 ? u = {} : s && $x(s, function(d2) {
            var m2 = zn(d2);
            if (m2 && m2.dataIndex != null) {
              var b2 = m2.dataModel || o.getSeriesByIndex(m2.seriesIndex);
              return u = b2 && b2.getDataParams(m2.dataIndex, m2.dataType) || {}, true;
            } else if (m2.eventData)
              return u = qt({}, m2.eventData), true;
          }, true), u) {
            var c2 = u.componentType, f2 = u.componentIndex;
            (c2 === "markLine" || c2 === "markPoint" || c2 === "markArea") && (c2 = "series", f2 = u.seriesIndex);
            var h = c2 && f2 != null && o.getComponent(c2, f2), v9 = h && e2[h.mainType === "series" ? "_chartsMap" : "_componentsMap"][h.__viewId];
            u.event = i, u.type = n2, e2._$eventProcessor.eventInfo = { targetEl: s, packedEvent: u, model: h, view: v9 }, e2.trigger(n2, u);
          }
        };
        a.zrEventfulCallAtLast = true, e2._zr.on(n2, a, e2);
      }), ae(zC, function(n2, a) {
        e2._messageCenter.on(a, function(i) {
          this.trigger(a, i);
        }, e2);
      }), ae(["selectchanged"], function(n2) {
        e2._messageCenter.on(n2, function(a) {
          this.trigger(n2, a);
        }, e2);
      }), xce(this._messageCenter, this, this._api);
    }, t2.prototype.isDisposed = function() {
      return this._disposed;
    }, t2.prototype.clear = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this.setOption({ series: [] }, true);
    }, t2.prototype.dispose = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._disposed = true;
      var e2 = this.getDom();
      e2 && HW(this.getDom(), MF, "");
      var n2 = this, a = n2._api, i = n2._model;
      ae(n2._componentsViews, function(o) {
        o.dispose(i, a);
      }), ae(n2._chartsViews, function(o) {
        o.dispose(i, a);
      }), n2._zr.dispose(), n2._dom = n2._model = n2._chartsMap = n2._componentsMap = n2._chartsViews = n2._componentsViews = n2._scheduler = n2._api = n2._zr = n2._throttledZrFlush = n2._theme = n2._coordSysMgr = n2._messageCenter = null, delete $C[n2.id];
    }, t2.prototype.resize = function(e2) {
      if (!this[ic]) {
        if (this._disposed) {
          this.id;
          return;
        }
        this._zr.resize(e2);
        var n2 = this._model;
        if (this._loadingFX && this._loadingFX.resize(), !!n2) {
          var a = n2.resetOption("media"), i = e2 && e2.silent;
          this[ff] && (i == null && (i = this[ff].silent), a = true, this[ff] = null), this[ic] = true;
          try {
            a && xx(this), H0.update.call(this, { type: "resize", animation: qt({ duration: 0 }, e2 && e2.animation) });
          } catch (o) {
            throw this[ic] = false, o;
          }
          this[ic] = false, J2.call(this, i), Q2.call(this, i);
        }
      }
    }, t2.prototype.showLoading = function(e2, n2) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (Tn(e2) && (n2 = e2, e2 = ""), e2 = e2 || "default", this.hideLoading(), !!E4[e2]) {
        var a = E4[e2](this._api, n2), i = this._zr;
        this._loadingFX = a, i.add(a);
      }
    }, t2.prototype.hideLoading = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, t2.prototype.makeActionFromEvent = function(e2) {
      var n2 = qt({}, e2);
      return n2.type = zC[e2.type], n2;
    }, t2.prototype.dispatchAction = function(e2, n2) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (Tn(n2) || (n2 = { silent: !!n2 }), !!fP[e2.type] && !!this._model) {
        if (this[ic]) {
          this._pendingActions.push(e2);
          return;
        }
        var a = n2.silent;
        ZO.call(this, e2, a);
        var i = n2.flush;
        i ? this._zr.flush() : i !== false && Ei.browser.weChat && this._throttledZrFlush(), J2.call(this, a), Q2.call(this, a);
      }
    }, t2.prototype.updateLabelLayout = function() {
      Nv.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
    }, t2.prototype.appendData = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var n2 = e2.seriesIndex, a = this.getModel(), i = a.getSeriesByIndex(n2);
      i.appendData(e2), this._scheduler.unfinished = true, this.getZr().wakeUp();
    }, t2.internalField = function() {
      xx = function(f2) {
        var h = f2._scheduler;
        h.restorePipelines(f2._model), h.prepareStageTasks(), qO(f2, true), qO(f2, false), h.plan();
      }, qO = function(f2, h) {
        for (var v9 = f2._model, d2 = f2._scheduler, m2 = h ? f2._componentsViews : f2._chartsViews, b2 = h ? f2._componentsMap : f2._chartsMap, _ = f2._zr, C = f2._api, M = 0; M < m2.length; M++)
          m2[M].__alive = false;
        h ? v9.eachComponent(function(V, $) {
          V !== "series" && E($);
        }) : v9.eachSeries(E);
        function E(V) {
          var $ = V.__requireNewView;
          V.__requireNewView = false;
          var U = "_ec_" + V.id + "_" + V.type, H = !$ && b2[U];
          if (!H) {
            var q3 = Hd(V.type), ee = h ? gs.getClass(q3.main, q3.sub) : Mo.getClass(q3.sub);
            H = new ee(), H.init(v9, C), b2[U] = H, m2.push(H), _.add(H.group);
          }
          V.__viewId = H.__id = U, H.__alive = true, H.__model = V, H.group.__ecComponentInfo = { mainType: V.mainType, index: V.componentIndex }, !h && d2.prepareView(H, V, v9, C);
        }
        for (var M = 0; M < m2.length; ) {
          var z9 = m2[M];
          z9.__alive ? M++ : (!h && z9.renderTask.dispose(), _.remove(z9.group), z9.dispose(v9, C), m2.splice(M, 1), b2[z9.__id] === z9 && delete b2[z9.__id], z9.__id = z9.group.__ecComponentInfo = null);
        }
      }, NM = function(f2, h, v9, d2, m2) {
        var b2 = f2._model;
        if (b2.setUpdatePayload(v9), !d2) {
          ae([].concat(f2._componentsViews).concat(f2._chartsViews), z9);
          return;
        }
        var _ = {};
        _[d2 + "Id"] = v9[d2 + "Id"], _[d2 + "Index"] = v9[d2 + "Index"], _[d2 + "Name"] = v9[d2 + "Name"];
        var C = { mainType: d2, query: _ };
        m2 && (C.subType = m2);
        var M = v9.excludeSeriesId, E;
        M != null && (E = mn(), ae(ao(M), function(V) {
          var $ = Cu(V, null);
          $ != null && E.set($, true);
        })), b2 && b2.eachComponent(C, function(V) {
          var $ = E && E.get(V.id) !== null;
          if (!$)
            if (S7(v9))
              if (V instanceof ns)
                v9.type === Hb && !v9.notBlur && !V.get(["emphasis", "disabled"]) && dse(V, v9, f2._api);
              else {
                var U = eF(V.mainType, V.componentIndex, v9.name, f2._api), H = U.focusSelf, q3 = U.dispatchers;
                v9.type === Hb && H && !v9.notBlur && i4(V.mainType, V.componentIndex, f2._api), q3 && ae(q3, function(ee) {
                  v9.type === Hb ? Kd(ee) : Zd(ee);
                });
              }
            else
              s4(v9) && V instanceof ns && (yse(V, v9, f2._api), x7(V), Ah(f2));
        }, f2), b2 && b2.eachComponent(C, function(V) {
          var $ = E && E.get(V.id) !== null;
          $ || z9(f2[d2 === "series" ? "_chartsMap" : "_componentsMap"][V.__viewId]);
        }, f2);
        function z9(V) {
          V && V.__alive && V[h] && V[h](V.__model, b2, f2._api, v9);
        }
      }, H0 = { prepareAndUpdate: function(f2) {
        xx(this), H0.update.call(this, f2, { optionChanged: f2.newOption != null });
      }, update: function(f2, h) {
        var v9 = this._model, d2 = this._api, m2 = this._zr, b2 = this._coordSysMgr, _ = this._scheduler;
        if (!!v9) {
          v9.setUpdatePayload(f2), _.restoreData(v9, f2), _.performSeriesTasks(v9), b2.create(v9, d2), _.performDataProcessorTasks(v9, f2), KO(this, v9), b2.update(v9, d2), e2(v9), _.performVisualTasks(v9, f2), XO(this, v9, d2, f2, h);
          var C = v9.get("backgroundColor") || "transparent", M = v9.get("darkMode");
          m2.setBackgroundColor(C), M != null && M !== "auto" && m2.setDarkMode(M), Nv.trigger("afterupdate", v9, d2);
        }
      }, updateTransform: function(f2) {
        var h = this, v9 = this._model, d2 = this._api;
        if (!!v9) {
          v9.setUpdatePayload(f2);
          var m2 = [];
          v9.eachComponent(function(_, C) {
            if (_ !== "series") {
              var M = h.getViewOfComponentModel(C);
              if (M && M.__alive)
                if (M.updateTransform) {
                  var E = M.updateTransform(C, v9, d2, f2);
                  E && E.update && m2.push(M);
                } else
                  m2.push(M);
            }
          });
          var b2 = mn();
          v9.eachSeries(function(_) {
            var C = h._chartsMap[_.__viewId];
            if (C.updateTransform) {
              var M = C.updateTransform(_, v9, d2, f2);
              M && M.update && b2.set(_.uid, 1);
            } else
              b2.set(_.uid, 1);
          }), e2(v9), this._scheduler.performVisualTasks(v9, f2, { setDirty: true, dirtyMap: b2 }), VM(this, v9, d2, f2, {}, b2), Nv.trigger("afterupdate", v9, d2);
        }
      }, updateView: function(f2) {
        var h = this._model;
        !h || (h.setUpdatePayload(f2), Mo.markUpdateMethod(f2, "updateView"), e2(h), this._scheduler.performVisualTasks(h, f2, { setDirty: true }), XO(this, h, this._api, f2, {}), Nv.trigger("afterupdate", h, this._api));
      }, updateVisual: function(f2) {
        var h = this, v9 = this._model;
        !v9 || (v9.setUpdatePayload(f2), v9.eachSeries(function(d2) {
          d2.getData().clearAllVisual();
        }), Mo.markUpdateMethod(f2, "updateVisual"), e2(v9), this._scheduler.performVisualTasks(v9, f2, { visualType: "visual", setDirty: true }), v9.eachComponent(function(d2, m2) {
          if (d2 !== "series") {
            var b2 = h.getViewOfComponentModel(m2);
            b2 && b2.__alive && b2.updateVisual(m2, v9, h._api, f2);
          }
        }), v9.eachSeries(function(d2) {
          var m2 = h._chartsMap[d2.__viewId];
          m2.updateVisual(d2, v9, h._api, f2);
        }), Nv.trigger("afterupdate", v9, this._api));
      }, updateLayout: function(f2) {
        H0.update.call(this, f2);
      } }, YO = function(f2, h, v9, d2) {
        if (f2._disposed) {
          f2.id;
          return;
        }
        for (var m2 = f2._model, b2 = f2._coordSysMgr.getCoordinateSystems(), _, C = RC(m2, v9), M = 0; M < b2.length; M++) {
          var E = b2[M];
          if (E[h] && (_ = E[h](m2, C, d2)) != null)
            return _;
        }
      }, KO = function(f2, h) {
        var v9 = f2._chartsMap, d2 = f2._scheduler;
        h.eachSeries(function(m2) {
          d2.updateStreamModes(m2, v9[m2.__viewId]);
        });
      }, ZO = function(f2, h) {
        var v9 = this, d2 = this.getModel(), m2 = f2.type, b2 = f2.escapeConnect, _ = fP[m2], C = _.actionInfo, M = (C.update || "update").split(":"), E = M.pop(), z9 = M[0] != null && Hd(M[0]);
        this[ic] = true;
        var V = [f2], $ = false;
        f2.batch && ($ = true, V = pr(f2.batch, function(be) {
          return be = En(qt({}, be), f2), be.batch = null, be;
        }));
        var U = [], H, q3 = s4(f2), ee = S7(f2);
        if (ee && mU(this._api), ae(V, function(be) {
          if (H = _.action(be, v9._model, v9._api), H = H || qt({}, be), H.type = C.event || H.type, U.push(H), ee) {
            var Ee = Y6(f2), ye = Ee.queryOptionMap, et = Ee.mainTypeSpecified, Le = et ? ye.keys()[0] : "series";
            NM(v9, E, be, Le), Ah(v9);
          } else
            q3 ? (NM(v9, E, be, "series"), Ah(v9)) : z9 && NM(v9, E, be, z9.main, z9.sub);
        }), E !== "none" && !ee && !q3 && !z9)
          try {
            this[ff] ? (xx(this), H0.update.call(this, f2), this[ff] = null) : H0[E].call(this, f2);
          } catch (be) {
            throw this[ic] = false, be;
          }
        if ($ ? H = { type: C.event || m2, escapeConnect: b2, batch: U } : H = U[0], this[ic] = false, !h) {
          var oe = this._messageCenter;
          if (oe.trigger(H.type, H), q3) {
            var ne = { type: "selectchanged", escapeConnect: b2, selected: mse(d2), isFromClick: f2.isFromClick || false, fromAction: f2.type, fromActionPayload: f2 };
            oe.trigger(ne.type, ne);
          }
        }
      }, J2 = function(f2) {
        for (var h = this._pendingActions; h.length; ) {
          var v9 = h.shift();
          ZO.call(this, v9, f2);
        }
      }, Q2 = function(f2) {
        !f2 && this.trigger("updated");
      }, NV = function(f2, h) {
        f2.on("rendered", function(v9) {
          h.trigger("rendered", v9), f2.animation.isFinished() && !h[ff] && !h._scheduler.unfinished && !h._pendingActions.length && h.trigger("finished");
        });
      }, VV = function(f2, h) {
        f2.on("mouseover", function(v9) {
          var d2 = v9.target, m2 = $x(d2, nE);
          m2 && (pse(m2, v9, h._api), Ah(h));
        }).on("mouseout", function(v9) {
          var d2 = v9.target, m2 = $x(d2, nE);
          m2 && (gse(m2, v9, h._api), Ah(h));
        }).on("click", function(v9) {
          var d2 = v9.target, m2 = $x(d2, function(C) {
            return zn(C).dataIndex != null;
          }, true);
          if (m2) {
            var b2 = m2.selected ? "unselect" : "select", _ = zn(m2);
            h._api.dispatchAction({ type: b2, dataType: _.dataType, dataIndexInside: _.dataIndex, seriesIndex: _.seriesIndex, isFromClick: true });
          }
        });
      };
      function e2(f2) {
        f2.clearColorPalette(), f2.eachSeries(function(h) {
          h.clearColorPalette();
        });
      }
      function n2(f2) {
        var h = [], v9 = [], d2 = false;
        if (f2.eachComponent(function(C, M) {
          var E = M.get("zlevel") || 0, z9 = M.get("z") || 0, V = M.getZLevelKey();
          d2 = d2 || !!V, (C === "series" ? v9 : h).push({ zlevel: E, z: z9, idx: M.componentIndex, type: C, key: V });
        }), d2) {
          var m2 = h.concat(v9), b2, _;
          S5(m2, function(C, M) {
            return C.zlevel === M.zlevel ? C.z - M.z : C.zlevel - M.zlevel;
          }), ae(m2, function(C) {
            var M = f2.getComponent(C.type, C.idx), E = C.zlevel, z9 = C.key;
            b2 != null && (E = Math.max(b2, E)), z9 ? (E === b2 && z9 !== _ && E++, _ = z9) : _ && (E === b2 && E++, _ = ""), b2 = E, M.setZLevel(E);
          });
        }
      }
      XO = function(f2, h, v9, d2, m2) {
        n2(h), jV(f2, h, v9, d2, m2), ae(f2._chartsViews, function(b2) {
          b2.__alive = false;
        }), VM(f2, h, v9, d2, m2), ae(f2._chartsViews, function(b2) {
          b2.__alive || b2.remove(h, v9);
        });
      }, jV = function(f2, h, v9, d2, m2, b2) {
        ae(b2 || f2._componentsViews, function(_) {
          var C = _.__model;
          l2(C, _), _.render(C, h, v9, d2), s(C, _), c2(C, _);
        });
      }, VM = function(f2, h, v9, d2, m2, b2) {
        var _ = f2._scheduler;
        m2 = qt(m2 || {}, { updatedSeries: h.getSeries() }), Nv.trigger("series:beforeupdate", h, v9, m2);
        var C = false;
        h.eachSeries(function(M) {
          var E = f2._chartsMap[M.__viewId];
          E.__alive = true;
          var z9 = E.renderTask;
          _.updatePayload(z9, d2), l2(M, E), b2 && b2.get(M.uid) && z9.dirty(), z9.perform(_.getPerformArgs(z9)) && (C = true), E.group.silent = !!M.get("silent"), o(M, E), x7(M);
        }), _.unfinished = C || _.unfinished, Nv.trigger("series:layoutlabels", h, v9, m2), Nv.trigger("series:transition", h, v9, m2), h.eachSeries(function(M) {
          var E = f2._chartsMap[M.__viewId];
          s(M, E), c2(M, E);
        }), i(f2, h), Nv.trigger("series:afterupdate", h, v9, m2);
      }, Ah = function(f2) {
        f2[UO] = true, f2.getZr().wakeUp();
      }, zV = function(f2) {
        !f2[UO] || (f2.getZr().storage.traverse(function(h) {
          Kx(h) || a(h);
        }), f2[UO] = false);
      };
      function a(f2) {
        for (var h = [], v9 = f2.currentStates, d2 = 0; d2 < v9.length; d2++) {
          var m2 = v9[d2];
          m2 === "emphasis" || m2 === "blur" || m2 === "select" || h.push(m2);
        }
        f2.selected && f2.states.select && h.push("select"), f2.hoverState === JP && f2.states.emphasis ? h.push("emphasis") : f2.hoverState === IE && f2.states.blur && h.push("blur"), f2.useStates(h);
      }
      function i(f2, h) {
        var v9 = f2._zr, d2 = v9.storage, m2 = 0;
        d2.traverse(function(b2) {
          b2.isGroup || m2++;
        }), m2 > h.get("hoverLayerThreshold") && !Ei.node && !Ei.worker && h.eachSeries(function(b2) {
          if (!b2.preventUsingHoverLayer) {
            var _ = f2._chartsMap[b2.__viewId];
            _.__alive && _.eachRendered(function(C) {
              C.states.emphasis && (C.states.emphasis.hoverLayer = true);
            });
          }
        });
      }
      function o(f2, h) {
        var v9 = f2.get("blendMode") || null;
        h.eachRendered(function(d2) {
          d2.isGroup || (d2.style.blend = v9);
        });
      }
      function s(f2, h) {
        if (!f2.preventAutoZ) {
          var v9 = f2.get("z") || 0, d2 = f2.get("zlevel") || 0;
          h.eachRendered(function(m2) {
            return u(m2, v9, d2, -1 / 0), true;
          });
        }
      }
      function u(f2, h, v9, d2) {
        var m2 = f2.getTextContent(), b2 = f2.getTextGuideLine(), _ = f2.isGroup;
        if (_)
          for (var C = f2.childrenRef(), M = 0; M < C.length; M++)
            d2 = Math.max(u(C[M], h, v9, d2), d2);
        else
          f2.z = h, f2.zlevel = v9, d2 = Math.max(f2.z2, d2);
        if (m2 && (m2.z = h, m2.zlevel = v9, isFinite(d2) && (m2.z2 = d2 + 2)), b2) {
          var E = f2.textGuideLineConfig;
          b2.z = h, b2.zlevel = v9, isFinite(d2) && (b2.z2 = d2 + (E && E.showAbove ? 1 : -1));
        }
        return d2;
      }
      function l2(f2, h) {
        h.eachRendered(function(v9) {
          if (!Kx(v9)) {
            var d2 = v9.getTextContent(), m2 = v9.getTextGuideLine();
            v9.stateTransition && (v9.stateTransition = null), d2 && d2.stateTransition && (d2.stateTransition = null), m2 && m2.stateTransition && (m2.stateTransition = null), v9.hasState() ? (v9.prevStates = v9.currentStates, v9.clearStates()) : v9.prevStates && (v9.prevStates = null);
          }
        });
      }
      function c2(f2, h) {
        var v9 = f2.getModel("stateAnimation"), d2 = f2.isAnimationEnabled(), m2 = v9.get("duration"), b2 = m2 > 0 ? { duration: m2, delay: v9.get("delay"), easing: v9.get("easing") } : null;
        h.eachRendered(function(_) {
          if (_.states && _.states.emphasis) {
            if (Kx(_))
              return;
            if (_ instanceof xa && Sse(_), _.__dirty) {
              var C = _.prevStates;
              C && _.useStates(C);
            }
            if (d2) {
              _.stateTransition = b2;
              var M = _.getTextContent(), E = _.getTextGuideLine();
              M && (M.stateTransition = b2), E && (E.stateTransition = b2);
            }
            _.__dirty && a(_);
          }
        });
      }
      BV = function(f2) {
        return new (function(h) {
          ot(v9, h);
          function v9() {
            return h !== null && h.apply(this, arguments) || this;
          }
          return v9.prototype.getCoordinateSystems = function() {
            return f2._coordSysMgr.getCoordinateSystems();
          }, v9.prototype.getComponentByElement = function(d2) {
            for (; d2; ) {
              var m2 = d2.__ecComponentInfo;
              if (m2 != null)
                return f2._model.getComponent(m2.mainType, m2.index);
              d2 = d2.parent;
            }
          }, v9.prototype.enterEmphasis = function(d2, m2) {
            Kd(d2, m2), Ah(f2);
          }, v9.prototype.leaveEmphasis = function(d2, m2) {
            Zd(d2, m2), Ah(f2);
          }, v9.prototype.enterBlur = function(d2) {
            vU(d2), Ah(f2);
          }, v9.prototype.leaveBlur = function(d2) {
            dU(d2), Ah(f2);
          }, v9.prototype.enterSelect = function(d2) {
            pU(d2), Ah(f2);
          }, v9.prototype.leaveSelect = function(d2) {
            gU(d2), Ah(f2);
          }, v9.prototype.getModel = function() {
            return f2.getModel();
          }, v9.prototype.getViewOfComponentModel = function(d2) {
            return f2.getViewOfComponentModel(d2);
          }, v9.prototype.getViewOfSeriesModel = function(d2) {
            return f2.getViewOfSeriesModel(d2);
          }, v9;
        }(_H))(f2);
      }, pq = function(f2) {
        function h(v9, d2) {
          for (var m2 = 0; m2 < v9.length; m2++) {
            var b2 = v9[m2];
            b2[HO] = d2;
          }
        }
        ae(zC, function(v9, d2) {
          f2._messageCenter.on(d2, function(m2) {
            if ($V[f2.group] && f2[HO] !== FV) {
              if (m2 && m2.escapeConnect)
                return;
              var b2 = f2.makeActionFromEvent(m2), _ = [];
              ae($C, function(C) {
                C !== f2 && C.group === f2.group && _.push(C);
              }), h(_, FV), ae(_, function(C) {
                C[HO] !== hfe && C.dispatchAction(b2);
              }), h(_, vfe);
            }
          });
        });
      };
    }(), t2;
  }(Yh), TF = gq.prototype;
  TF.on = cq("on");
  TF.off = cq("off");
  TF.one = function(r2, t2, e2) {
    var n2 = this;
    function a() {
      for (var i = [], o = 0; o < arguments.length; o++)
        i[o] = arguments[o];
      t2 && t2.apply && t2.apply(this, i), n2.off(r2, a);
    }
    this.on.call(this, r2, a, e2);
  };
  var dfe = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
  var fP = {}, zC = {}, S4 = [], C4 = [], hP = [], yq = {}, E4 = {}, $C = {}, $V = {}, pfe = +new Date() - 0, MF = "_echarts_instance_";
  function gfe(r2, t2, e2) {
    var n2 = !(e2 && e2.ssr);
    if (n2) {
      var a = yfe(r2);
      if (a)
        return a;
    }
    var i = new gq(r2, t2, e2);
    return i.id = "ec_" + pfe++, $C[i.id] = i, n2 && HW(r2, MF, i.id), pq(i), Nv.trigger("afterinit", i), i;
  }
  function yfe(r2) {
    return $C[soe(r2, MF)];
  }
  function mq(r2, t2) {
    yq[r2] = t2;
  }
  function bq(r2) {
    va(C4, r2) < 0 && C4.push(r2);
  }
  function _q(r2, t2) {
    DF(S4, r2, t2, afe);
  }
  function mfe(r2) {
    PF("afterinit", r2);
  }
  function bfe(r2) {
    PF("afterupdate", r2);
  }
  function PF(r2, t2) {
    Nv.on(r2, t2);
  }
  function op(r2, t2, e2) {
    xn(t2) && (e2 = t2, t2 = "");
    var n2 = Tn(r2) ? r2.type : [r2, r2 = { event: t2 }][0];
    r2.event = (r2.event || n2).toLowerCase(), t2 = r2.event, !zC[t2] && (Fc(RV.test(n2) && RV.test(t2)), fP[n2] || (fP[n2] = { action: e2, actionInfo: r2 }), zC[t2] = n2);
  }
  function _fe(r2, t2) {
    FE.register(r2, t2);
  }
  function xfe(r2, t2) {
    DF(hP, r2, t2, sq, "layout");
  }
  function l1(r2, t2) {
    DF(hP, r2, t2, uq, "visual");
  }
  var GV = [];
  function DF(r2, t2, e2, n2, a) {
    if ((xn(t2) || Tn(t2)) && (e2 = t2, t2 = n2), !(va(GV, e2) >= 0)) {
      GV.push(e2);
      var i = ZH.wrapStageHandler(e2, a);
      i.__prio = t2, i.__raw = e2, r2.push(i);
    }
  }
  function xq(r2, t2) {
    E4[r2] = t2;
  }
  function wfe(r2, t2, e2) {
    var n2 = Jce("registerMap");
    n2 && n2(r2, t2, e2);
  }
  var Sfe = Ile;
  l1(AF, rce);
  l1(d3, nce);
  l1(d3, ace);
  l1(AF, bce);
  l1(d3, _ce);
  l1(lq, Kce);
  bq(wH);
  _q(rfe, fle);
  xq("default", ice);
  op({ type: Hb, event: Hb, update: Hb }, lu);
  op({ type: P5, event: P5, update: P5 }, lu);
  op({ type: FC, event: FC, update: FC }, lu);
  op({ type: D5, event: D5, update: D5 }, lu);
  op({ type: NC, event: NC, update: NC }, lu);
  mq("light", gce);
  mq("dark", yce);
  var WV = [], Cfe = { registerPreprocessor: bq, registerProcessor: _q, registerPostInit: mfe, registerPostUpdate: bfe, registerUpdateLifecycle: PF, registerAction: op, registerCoordinateSystem: _fe, registerLayout: xfe, registerVisual: l1, registerTransform: Sfe, registerLoading: xq, registerMap: wfe, registerImpl: Xce, PRIORITY: ffe, ComponentModel: li, ComponentView: gs, SeriesModel: ns, ChartView: Mo, registerComponentModel: function(r2) {
    li.registerClass(r2);
  }, registerComponentView: function(r2) {
    gs.registerClass(r2);
  }, registerSeriesModel: function(r2) {
    ns.registerClass(r2);
  }, registerChartView: function(r2) {
    Mo.registerClass(r2);
  }, registerSubTypeDefaulter: function(r2, t2) {
    li.registerSubTypeDefaulter(r2, t2);
  }, registerPainter: function(r2, t2) {
    zie(r2, t2);
  } };
  function ya(r2) {
    if (vr(r2)) {
      ae(r2, function(t2) {
        ya(t2);
      });
      return;
    }
    va(WV, r2) >= 0 || (WV.push(r2), xn(r2) && (r2 = { install: r2 }), r2.install(Cfe));
  }
  function eC(r2) {
    return r2 == null ? 0 : r2.length || 1;
  }
  function UV(r2) {
    return r2;
  }
  var Efe = function() {
    function r2(t2, e2, n2, a, i, o) {
      this._old = t2, this._new = e2, this._oldKeyGetter = n2 || UV, this._newKeyGetter = a || UV, this.context = i, this._diffModeMultiple = o === "multiple";
    }
    return r2.prototype.add = function(t2) {
      return this._add = t2, this;
    }, r2.prototype.update = function(t2) {
      return this._update = t2, this;
    }, r2.prototype.updateManyToOne = function(t2) {
      return this._updateManyToOne = t2, this;
    }, r2.prototype.updateOneToMany = function(t2) {
      return this._updateOneToMany = t2, this;
    }, r2.prototype.updateManyToMany = function(t2) {
      return this._updateManyToMany = t2, this;
    }, r2.prototype.remove = function(t2) {
      return this._remove = t2, this;
    }, r2.prototype.execute = function() {
      this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
    }, r2.prototype._executeOneToOne = function() {
      var t2 = this._old, e2 = this._new, n2 = {}, a = new Array(t2.length), i = new Array(e2.length);
      this._initIndexMap(t2, null, a, "_oldKeyGetter"), this._initIndexMap(e2, n2, i, "_newKeyGetter");
      for (var o = 0; o < t2.length; o++) {
        var s = a[o], u = n2[s], l2 = eC(u);
        if (l2 > 1) {
          var c2 = u.shift();
          u.length === 1 && (n2[s] = u[0]), this._update && this._update(c2, o);
        } else
          l2 === 1 ? (n2[s] = null, this._update && this._update(u, o)) : this._remove && this._remove(o);
      }
      this._performRestAdd(i, n2);
    }, r2.prototype._executeMultiple = function() {
      var t2 = this._old, e2 = this._new, n2 = {}, a = {}, i = [], o = [];
      this._initIndexMap(t2, n2, i, "_oldKeyGetter"), this._initIndexMap(e2, a, o, "_newKeyGetter");
      for (var s = 0; s < i.length; s++) {
        var u = i[s], l2 = n2[u], c2 = a[u], f2 = eC(l2), h = eC(c2);
        if (f2 > 1 && h === 1)
          this._updateManyToOne && this._updateManyToOne(c2, l2), a[u] = null;
        else if (f2 === 1 && h > 1)
          this._updateOneToMany && this._updateOneToMany(c2, l2), a[u] = null;
        else if (f2 === 1 && h === 1)
          this._update && this._update(c2, l2), a[u] = null;
        else if (f2 > 1 && h > 1)
          this._updateManyToMany && this._updateManyToMany(c2, l2), a[u] = null;
        else if (f2 > 1)
          for (var v9 = 0; v9 < f2; v9++)
            this._remove && this._remove(l2[v9]);
        else
          this._remove && this._remove(l2);
      }
      this._performRestAdd(o, a);
    }, r2.prototype._performRestAdd = function(t2, e2) {
      for (var n2 = 0; n2 < t2.length; n2++) {
        var a = t2[n2], i = e2[a], o = eC(i);
        if (o > 1)
          for (var s = 0; s < o; s++)
            this._add && this._add(i[s]);
        else
          o === 1 && this._add && this._add(i);
        e2[a] = null;
      }
    }, r2.prototype._initIndexMap = function(t2, e2, n2, a) {
      for (var i = this._diffModeMultiple, o = 0; o < t2.length; o++) {
        var s = "_ec_" + this[a](t2[o], o);
        if (i || (n2[o] = s), !!e2) {
          var u = e2[s], l2 = eC(u);
          l2 === 0 ? (e2[s] = o, i && n2.push(s)) : l2 === 1 ? e2[s] = [u, o] : u.push(o);
        }
      }
    }, r2;
  }(), Dg = Efe, Afe = function() {
    function r2(t2, e2) {
      this._encode = t2, this._schema = e2;
    }
    return r2.prototype.get = function() {
      return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
    }, r2.prototype._getFullDimensionNames = function() {
      return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
    }, r2;
  }();
  function Tfe(r2, t2) {
    var e2 = {}, n2 = e2.encode = {}, a = mn(), i = [], o = [], s = {};
    ae(r2.dimensions, function(h) {
      var v9 = r2.getDimensionInfo(h), d2 = v9.coordDim;
      if (d2) {
        var m2 = v9.coordDimIndex;
        JO(n2, d2)[m2] = h, v9.isExtraCoord || (a.set(d2, 1), Mfe(v9.type) && (i[0] = h), JO(s, d2)[m2] = r2.getDimensionIndex(v9.name)), v9.defaultTooltip && o.push(h);
      }
      fH.each(function(b2, _) {
        var C = JO(n2, _), M = v9.otherDims[_];
        M != null && M !== false && (C[M] = v9.name);
      });
    });
    var u = [], l2 = {};
    a.each(function(h, v9) {
      var d2 = n2[v9];
      l2[v9] = d2[0], u = u.concat(d2);
    }), e2.dataDimsOnCoord = u, e2.dataDimIndicesOnCoord = pr(u, function(h) {
      return r2.getDimensionInfo(h).storeDimIndex;
    }), e2.encodeFirstDimNotExtra = l2;
    var c2 = n2.label;
    c2 && c2.length && (i = c2.slice());
    var f2 = n2.tooltip;
    return f2 && f2.length ? o = f2.slice() : o.length || (o = i.slice()), n2.defaultedLabel = i, n2.defaultedTooltip = o, e2.userOutput = new Afe(s, t2), e2;
  }
  function JO(r2, t2) {
    return r2.hasOwnProperty(t2) || (r2[t2] = []), r2[t2];
  }
  function vP(r2) {
    return r2 === "category" ? "ordinal" : r2 === "time" ? "time" : "float";
  }
  function Mfe(r2) {
    return !(r2 === "ordinal" || r2 === "time");
  }
  var Pfe = function() {
    function r2(t2) {
      this.otherDims = {}, t2 != null && qt(this, t2);
    }
    return r2;
  }(), R5 = Pfe, Dfe = fi(), Ife = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, wq = function() {
    function r2(t2) {
      this.dimensions = t2.dimensions, this._dimOmitted = t2.dimensionOmitted, this.source = t2.source, this._fullDimCount = t2.fullDimensionCount, this._updateDimOmitted(t2.dimensionOmitted);
    }
    return r2.prototype.isDimensionOmitted = function() {
      return this._dimOmitted;
    }, r2.prototype._updateDimOmitted = function(t2) {
      this._dimOmitted = t2, t2 && (this._dimNameMap || (this._dimNameMap = Eq(this.source)));
    }, r2.prototype.getSourceDimensionIndex = function(t2) {
      return ia(this._dimNameMap.get(t2), -1);
    }, r2.prototype.getSourceDimension = function(t2) {
      var e2 = this.source.dimensionsDefine;
      if (e2)
        return e2[t2];
    }, r2.prototype.makeStoreSchema = function() {
      for (var t2 = this._fullDimCount, e2 = CH(this.source), n2 = !Aq(t2), a = "", i = [], o = 0, s = 0; o < t2; o++) {
        var u = void 0, l2 = void 0, c2 = void 0, f2 = this.dimensions[s];
        if (f2 && f2.storeDimIndex === o)
          u = e2 ? f2.name : null, l2 = f2.type, c2 = f2.ordinalMeta, s++;
        else {
          var h = this.getSourceDimension(o);
          h && (u = e2 ? h.name : null, l2 = h.type);
        }
        i.push({ property: u, type: l2, ordinalMeta: c2 }), e2 && u != null && (!f2 || !f2.isCalculationCoord) && (a += n2 ? u.replace(/\`/g, "`1").replace(/\$/g, "`2") : u), a += "$", a += Ife[l2] || "f", c2 && (a += c2.uid), a += "$";
      }
      var v9 = this.source, d2 = [v9.seriesLayoutBy, v9.startIndex, a].join("$$");
      return { dimensions: i, hash: d2 };
    }, r2.prototype.makeOutputDimensionNames = function() {
      for (var t2 = [], e2 = 0, n2 = 0; e2 < this._fullDimCount; e2++) {
        var a = void 0, i = this.dimensions[n2];
        if (i && i.storeDimIndex === e2)
          i.isCalculationCoord || (a = i.name), n2++;
        else {
          var o = this.getSourceDimension(e2);
          o && (a = o.name);
        }
        t2.push(a);
      }
      return t2;
    }, r2.prototype.appendCalculationDimension = function(t2) {
      this.dimensions.push(t2), t2.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
    }, r2;
  }();
  function Sq(r2) {
    return r2 instanceof wq;
  }
  function Cq(r2) {
    for (var t2 = mn(), e2 = 0; e2 < (r2 || []).length; e2++) {
      var n2 = r2[e2], a = Tn(n2) ? n2.name : n2;
      a != null && t2.get(a) == null && t2.set(a, e2);
    }
    return t2;
  }
  function Eq(r2) {
    var t2 = Dfe(r2);
    return t2.dimNameMap || (t2.dimNameMap = Cq(r2.dimensionsDefine));
  }
  function Aq(r2) {
    return r2 > 30;
  }
  var tC = Tn, q0 = pr, Lfe = typeof Int32Array == "undefined" ? Array : Int32Array, Ofe = "e\0\0", HV = -1, kfe = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], Rfe = ["_approximateExtent"], qV, jM, rC, nC, QO, BM, ek, Ffe = function() {
    function r2(t2, e2) {
      this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
      var n2, a = false;
      Sq(t2) ? (n2 = t2.dimensions, this._dimOmitted = t2.isDimensionOmitted(), this._schema = t2) : (a = true, n2 = t2), n2 = n2 || ["x", "y"];
      for (var i = {}, o = [], s = {}, u = false, l2 = {}, c2 = 0; c2 < n2.length; c2++) {
        var f2 = n2[c2], h = Zr(f2) ? new R5({ name: f2 }) : f2 instanceof R5 ? f2 : new R5(f2), v9 = h.name;
        h.type = h.type || "float", h.coordDim || (h.coordDim = v9, h.coordDimIndex = 0);
        var d2 = h.otherDims = h.otherDims || {};
        o.push(v9), i[v9] = h, l2[v9] != null && (u = true), h.createInvertedIndices && (s[v9] = []), d2.itemName === 0 && (this._nameDimIdx = c2), d2.itemId === 0 && (this._idDimIdx = c2), a && (h.storeDimIndex = c2);
      }
      if (this.dimensions = o, this._dimInfos = i, this._initGetDimensionInfo(u), this.hostModel = e2, this._invertedIndicesMap = s, this._dimOmitted) {
        var m2 = this._dimIdxToName = mn();
        ae(o, function(b2) {
          m2.set(i[b2].storeDimIndex, b2);
        });
      }
    }
    return r2.prototype.getDimension = function(t2) {
      var e2 = this._recognizeDimIndex(t2);
      if (e2 == null)
        return t2;
      if (e2 = t2, !this._dimOmitted)
        return this.dimensions[e2];
      var n2 = this._dimIdxToName.get(e2);
      if (n2 != null)
        return n2;
      var a = this._schema.getSourceDimension(e2);
      if (a)
        return a.name;
    }, r2.prototype.getDimensionIndex = function(t2) {
      var e2 = this._recognizeDimIndex(t2);
      if (e2 != null)
        return e2;
      if (t2 == null)
        return -1;
      var n2 = this._getDimInfo(t2);
      return n2 ? n2.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(t2) : -1;
    }, r2.prototype._recognizeDimIndex = function(t2) {
      if (Ai(t2) || t2 != null && !isNaN(t2) && !this._getDimInfo(t2) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(t2) < 0))
        return +t2;
    }, r2.prototype._getStoreDimIndex = function(t2) {
      var e2 = this.getDimensionIndex(t2);
      return e2;
    }, r2.prototype.getDimensionInfo = function(t2) {
      return this._getDimInfo(this.getDimension(t2));
    }, r2.prototype._initGetDimensionInfo = function(t2) {
      var e2 = this._dimInfos;
      this._getDimInfo = t2 ? function(n2) {
        return e2.hasOwnProperty(n2) ? e2[n2] : void 0;
      } : function(n2) {
        return e2[n2];
      };
    }, r2.prototype.getDimensionsOnCoord = function() {
      return this._dimSummary.dataDimsOnCoord.slice();
    }, r2.prototype.mapDimension = function(t2, e2) {
      var n2 = this._dimSummary;
      if (e2 == null)
        return n2.encodeFirstDimNotExtra[t2];
      var a = n2.encode[t2];
      return a ? a[e2] : null;
    }, r2.prototype.mapDimensionsAll = function(t2) {
      var e2 = this._dimSummary, n2 = e2.encode[t2];
      return (n2 || []).slice();
    }, r2.prototype.getStore = function() {
      return this._store;
    }, r2.prototype.initData = function(t2, e2, n2) {
      var a = this, i;
      if (t2 instanceof g4 && (i = t2), !i) {
        var o = this.dimensions, s = gF(t2) || lc(t2) ? new EH(t2, o.length) : t2;
        i = new g4();
        var u = q0(o, function(l2) {
          return { type: a._dimInfos[l2].type, property: l2 };
        });
        i.initData(s, u, n2);
      }
      this._store = i, this._nameList = (e2 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, i.count()), this._dimSummary = Tfe(this, this._schema), this.userOutput = this._dimSummary.userOutput;
    }, r2.prototype.appendData = function(t2) {
      var e2 = this._store.appendData(t2);
      this._doInit(e2[0], e2[1]);
    }, r2.prototype.appendValues = function(t2, e2) {
      var n2 = this._store.appendValues(t2, e2.length), a = n2.start, i = n2.end, o = this._shouldMakeIdFromName();
      if (this._updateOrdinalMeta(), e2)
        for (var s = a; s < i; s++) {
          var u = s - a;
          this._nameList[s] = e2[u], o && ek(this, s);
        }
    }, r2.prototype._updateOrdinalMeta = function() {
      for (var t2 = this._store, e2 = this.dimensions, n2 = 0; n2 < e2.length; n2++) {
        var a = this._dimInfos[e2[n2]];
        a.ordinalMeta && t2.collectOrdinalMeta(a.storeDimIndex, a.ordinalMeta);
      }
    }, r2.prototype._shouldMakeIdFromName = function() {
      var t2 = this._store.getProvider();
      return this._idDimIdx == null && t2.getSource().sourceFormat !== vy && !t2.fillStorage;
    }, r2.prototype._doInit = function(t2, e2) {
      if (!(t2 >= e2)) {
        var n2 = this._store, a = n2.getProvider();
        this._updateOrdinalMeta();
        var i = this._nameList, o = this._idList, s = a.getSource().sourceFormat, u = s === Kh;
        if (u && !a.pure)
          for (var l2 = [], c2 = t2; c2 < e2; c2++) {
            var f2 = a.getItem(c2, l2);
            if (!this.hasItemOption && Yie(f2) && (this.hasItemOption = true), f2) {
              var h = f2.name;
              i[c2] == null && h != null && (i[c2] = Cu(h, null));
              var v9 = f2.id;
              o[c2] == null && v9 != null && (o[c2] = Cu(v9, null));
            }
          }
        if (this._shouldMakeIdFromName())
          for (var c2 = t2; c2 < e2; c2++)
            ek(this, c2);
        qV(this);
      }
    }, r2.prototype.getApproximateExtent = function(t2) {
      return this._approximateExtent[t2] || this._store.getDataExtent(this._getStoreDimIndex(t2));
    }, r2.prototype.setApproximateExtent = function(t2, e2) {
      e2 = this.getDimension(e2), this._approximateExtent[e2] = t2.slice();
    }, r2.prototype.getCalculationInfo = function(t2) {
      return this._calculationInfo[t2];
    }, r2.prototype.setCalculationInfo = function(t2, e2) {
      tC(t2) ? qt(this._calculationInfo, t2) : this._calculationInfo[t2] = e2;
    }, r2.prototype.getName = function(t2) {
      var e2 = this.getRawIndex(t2), n2 = this._nameList[e2];
      return n2 == null && this._nameDimIdx != null && (n2 = rC(this, this._nameDimIdx, e2)), n2 == null && (n2 = ""), n2;
    }, r2.prototype._getCategory = function(t2, e2) {
      var n2 = this._store.get(t2, e2), a = this._store.getOrdinalMeta(t2);
      return a ? a.categories[n2] : n2;
    }, r2.prototype.getId = function(t2) {
      return jM(this, this.getRawIndex(t2));
    }, r2.prototype.count = function() {
      return this._store.count();
    }, r2.prototype.get = function(t2, e2) {
      var n2 = this._store, a = this._dimInfos[t2];
      if (a)
        return n2.get(a.storeDimIndex, e2);
    }, r2.prototype.getByRawIndex = function(t2, e2) {
      var n2 = this._store, a = this._dimInfos[t2];
      if (a)
        return n2.getByRawIndex(a.storeDimIndex, e2);
    }, r2.prototype.getIndices = function() {
      return this._store.getIndices();
    }, r2.prototype.getDataExtent = function(t2) {
      return this._store.getDataExtent(this._getStoreDimIndex(t2));
    }, r2.prototype.getSum = function(t2) {
      return this._store.getSum(this._getStoreDimIndex(t2));
    }, r2.prototype.getMedian = function(t2) {
      return this._store.getMedian(this._getStoreDimIndex(t2));
    }, r2.prototype.getValues = function(t2, e2) {
      var n2 = this, a = this._store;
      return vr(t2) ? a.getValues(q0(t2, function(i) {
        return n2._getStoreDimIndex(i);
      }), e2) : a.getValues(t2);
    }, r2.prototype.hasValue = function(t2) {
      for (var e2 = this._dimSummary.dataDimIndicesOnCoord, n2 = 0, a = e2.length; n2 < a; n2++)
        if (isNaN(this._store.get(e2[n2], t2)))
          return false;
      return true;
    }, r2.prototype.indexOfName = function(t2) {
      for (var e2 = 0, n2 = this._store.count(); e2 < n2; e2++)
        if (this.getName(e2) === t2)
          return e2;
      return -1;
    }, r2.prototype.getRawIndex = function(t2) {
      return this._store.getRawIndex(t2);
    }, r2.prototype.indexOfRawIndex = function(t2) {
      return this._store.indexOfRawIndex(t2);
    }, r2.prototype.rawIndexOf = function(t2, e2) {
      var n2 = t2 && this._invertedIndicesMap[t2], a = n2[e2];
      return a == null || isNaN(a) ? HV : a;
    }, r2.prototype.indicesOfNearest = function(t2, e2, n2) {
      return this._store.indicesOfNearest(this._getStoreDimIndex(t2), e2, n2);
    }, r2.prototype.each = function(t2, e2, n2) {
      xn(t2) && (n2 = e2, e2 = t2, t2 = []);
      var a = n2 || this, i = q0(nC(t2), this._getStoreDimIndex, this);
      this._store.each(i, a ? en(e2, a) : e2);
    }, r2.prototype.filterSelf = function(t2, e2, n2) {
      xn(t2) && (n2 = e2, e2 = t2, t2 = []);
      var a = n2 || this, i = q0(nC(t2), this._getStoreDimIndex, this);
      return this._store = this._store.filter(i, a ? en(e2, a) : e2), this;
    }, r2.prototype.selectRange = function(t2) {
      var e2 = this, n2 = {}, a = ja(t2);
      return ae(a, function(i) {
        var o = e2._getStoreDimIndex(i);
        n2[o] = t2[i];
      }), this._store = this._store.selectRange(n2), this;
    }, r2.prototype.mapArray = function(t2, e2, n2) {
      xn(t2) && (n2 = e2, e2 = t2, t2 = []), n2 = n2 || this;
      var a = [];
      return this.each(t2, function() {
        a.push(e2 && e2.apply(this, arguments));
      }, n2), a;
    }, r2.prototype.map = function(t2, e2, n2, a) {
      var i = n2 || a || this, o = q0(nC(t2), this._getStoreDimIndex, this), s = BM(this);
      return s._store = this._store.map(o, i ? en(e2, i) : e2), s;
    }, r2.prototype.modify = function(t2, e2, n2, a) {
      var i = n2 || a || this, o = q0(nC(t2), this._getStoreDimIndex, this);
      this._store.modify(o, i ? en(e2, i) : e2);
    }, r2.prototype.downSample = function(t2, e2, n2, a) {
      var i = BM(this);
      return i._store = this._store.downSample(this._getStoreDimIndex(t2), e2, n2, a), i;
    }, r2.prototype.lttbDownSample = function(t2, e2) {
      var n2 = BM(this);
      return n2._store = this._store.lttbDownSample(this._getStoreDimIndex(t2), e2), n2;
    }, r2.prototype.getRawDataItem = function(t2) {
      return this._store.getRawDataItem(t2);
    }, r2.prototype.getItemModel = function(t2) {
      var e2 = this.hostModel, n2 = this.getRawDataItem(t2);
      return new To(n2, e2, e2 && e2.ecModel);
    }, r2.prototype.diff = function(t2) {
      var e2 = this;
      return new Dg(t2 ? t2.getStore().getIndices() : [], this.getStore().getIndices(), function(n2) {
        return jM(t2, n2);
      }, function(n2) {
        return jM(e2, n2);
      });
    }, r2.prototype.getVisual = function(t2) {
      var e2 = this._visual;
      return e2 && e2[t2];
    }, r2.prototype.setVisual = function(t2, e2) {
      this._visual = this._visual || {}, tC(t2) ? qt(this._visual, t2) : this._visual[t2] = e2;
    }, r2.prototype.getItemVisual = function(t2, e2) {
      var n2 = this._itemVisuals[t2], a = n2 && n2[e2];
      return a == null ? this.getVisual(e2) : a;
    }, r2.prototype.hasItemVisual = function() {
      return this._itemVisuals.length > 0;
    }, r2.prototype.ensureUniqueItemVisual = function(t2, e2) {
      var n2 = this._itemVisuals, a = n2[t2];
      a || (a = n2[t2] = {});
      var i = a[e2];
      return i == null && (i = this.getVisual(e2), vr(i) ? i = i.slice() : tC(i) && (i = qt({}, i)), a[e2] = i), i;
    }, r2.prototype.setItemVisual = function(t2, e2, n2) {
      var a = this._itemVisuals[t2] || {};
      this._itemVisuals[t2] = a, tC(e2) ? qt(a, e2) : a[e2] = n2;
    }, r2.prototype.clearAllVisual = function() {
      this._visual = {}, this._itemVisuals = [];
    }, r2.prototype.setLayout = function(t2, e2) {
      tC(t2) ? qt(this._layout, t2) : this._layout[t2] = e2;
    }, r2.prototype.getLayout = function(t2) {
      return this._layout[t2];
    }, r2.prototype.getItemLayout = function(t2) {
      return this._itemLayouts[t2];
    }, r2.prototype.setItemLayout = function(t2, e2, n2) {
      this._itemLayouts[t2] = n2 ? qt(this._itemLayouts[t2] || {}, e2) : e2;
    }, r2.prototype.clearItemLayouts = function() {
      this._itemLayouts.length = 0;
    }, r2.prototype.setItemGraphicEl = function(t2, e2) {
      var n2 = this.hostModel && this.hostModel.seriesIndex;
      n4(n2, this.dataType, t2, e2), this._graphicEls[t2] = e2;
    }, r2.prototype.getItemGraphicEl = function(t2) {
      return this._graphicEls[t2];
    }, r2.prototype.eachItemGraphicEl = function(t2, e2) {
      ae(this._graphicEls, function(n2, a) {
        n2 && t2 && t2.call(e2, n2, a);
      });
    }, r2.prototype.cloneShallow = function(t2) {
      return t2 || (t2 = new r2(this._schema ? this._schema : q0(this.dimensions, this._getDimInfo, this), this.hostModel)), QO(t2, this), t2._store = this._store, t2;
    }, r2.prototype.wrapMethod = function(t2, e2) {
      var n2 = this[t2];
      !xn(n2) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(t2), this[t2] = function() {
        var a = n2.apply(this, arguments);
        return e2.apply(this, [a].concat(V6(arguments)));
      });
    }, r2.internalField = function() {
      qV = function(t2) {
        var e2 = t2._invertedIndicesMap;
        ae(e2, function(n2, a) {
          var i = t2._dimInfos[a], o = i.ordinalMeta, s = t2._store;
          if (o) {
            n2 = e2[a] = new Lfe(o.categories.length);
            for (var u = 0; u < n2.length; u++)
              n2[u] = HV;
            for (var u = 0; u < s.count(); u++)
              n2[s.get(i.storeDimIndex, u)] = u;
          }
        });
      }, rC = function(t2, e2, n2) {
        return Cu(t2._getCategory(e2, n2), null);
      }, jM = function(t2, e2) {
        var n2 = t2._idList[e2];
        return n2 == null && t2._idDimIdx != null && (n2 = rC(t2, t2._idDimIdx, e2)), n2 == null && (n2 = Ofe + e2), n2;
      }, nC = function(t2) {
        return vr(t2) || (t2 = t2 != null ? [t2] : []), t2;
      }, BM = function(t2) {
        var e2 = new r2(t2._schema ? t2._schema : q0(t2.dimensions, t2._getDimInfo, t2), t2.hostModel);
        return QO(e2, t2), e2;
      }, QO = function(t2, e2) {
        ae(kfe.concat(e2.__wrappedMethods || []), function(n2) {
          e2.hasOwnProperty(n2) && (t2[n2] = e2[n2]);
        }), t2.__wrappedMethods = e2.__wrappedMethods, ae(Rfe, function(n2) {
          t2[n2] = On(e2[n2]);
        }), t2._calculationInfo = qt({}, e2._calculationInfo);
      }, ek = function(t2, e2) {
        var n2 = t2._nameList, a = t2._idList, i = t2._nameDimIdx, o = t2._idDimIdx, s = n2[e2], u = a[e2];
        if (s == null && i != null && (n2[e2] = s = rC(t2, i, e2)), u == null && o != null && (a[e2] = u = rC(t2, o, e2)), u == null && s != null) {
          var l2 = t2._nameRepeatCount, c2 = l2[s] = (l2[s] || 0) + 1;
          u = s, c2 > 1 && (u += "__ec__" + c2), a[e2] = u;
        }
      };
    }(), r2;
  }(), Rc = Ffe;
  function jE(r2, t2) {
    gF(r2) || (r2 = yF(r2)), t2 = t2 || {};
    var e2 = t2.coordDimensions || [], n2 = t2.dimensionsDefine || r2.dimensionsDefine || [], a = mn(), i = [], o = Vfe(r2, e2, n2, t2.dimensionsCount), s = t2.canOmitUnusedDimensions && Aq(o), u = n2 === r2.dimensionsDefine, l2 = u ? Eq(r2) : Cq(n2), c2 = t2.encodeDefine;
    !c2 && t2.encodeDefaulter && (c2 = t2.encodeDefaulter(r2, o));
    for (var f2 = mn(c2), h = new OH(o), v9 = 0; v9 < h.length; v9++)
      h[v9] = -1;
    function d2(H) {
      var q3 = h[H];
      if (q3 < 0) {
        var ee = n2[H], oe = Tn(ee) ? ee : { name: ee }, ne = new R5(), be = oe.name;
        be != null && l2.get(be) != null && (ne.name = ne.displayName = be), oe.type != null && (ne.type = oe.type), oe.displayName != null && (ne.displayName = oe.displayName);
        var Ee = i.length;
        return h[H] = Ee, ne.storeDimIndex = H, i.push(ne), ne;
      }
      return i[q3];
    }
    if (!s)
      for (var v9 = 0; v9 < o; v9++)
        d2(v9);
    f2.each(function(H, q3) {
      var ee = ao(H).slice();
      if (ee.length === 1 && !Zr(ee[0]) && ee[0] < 0) {
        f2.set(q3, false);
        return;
      }
      var oe = f2.set(q3, []);
      ae(ee, function(ne, be) {
        var Ee = Zr(ne) ? l2.get(ne) : ne;
        Ee != null && Ee < o && (oe[be] = Ee, b2(d2(Ee), q3, be));
      });
    });
    var m2 = 0;
    ae(e2, function(H) {
      var q3, ee, oe, ne;
      if (Zr(H))
        q3 = H, ne = {};
      else {
        ne = H, q3 = ne.name;
        var be = ne.ordinalMeta;
        ne.ordinalMeta = null, ne = qt({}, ne), ne.ordinalMeta = be, ee = ne.dimsDef, oe = ne.otherDims, ne.name = ne.coordDim = ne.coordDimIndex = ne.dimsDef = ne.otherDims = null;
      }
      var Ee = f2.get(q3);
      if (Ee !== false) {
        if (Ee = ao(Ee), !Ee.length)
          for (var ye = 0; ye < (ee && ee.length || 1); ye++) {
            for (; m2 < o && d2(m2).coordDim != null; )
              m2++;
            m2 < o && Ee.push(m2++);
          }
        ae(Ee, function(et, Le) {
          var Fe = d2(et);
          if (u && ne.type != null && (Fe.type = ne.type), b2(En(Fe, ne), q3, Le), Fe.name == null && ee) {
            var qe = ee[Le];
            !Tn(qe) && (qe = { name: qe }), Fe.name = Fe.displayName = qe.name, Fe.defaultTooltip = qe.defaultTooltip;
          }
          oe && En(Fe.otherDims, oe);
        });
      }
    });
    function b2(H, q3, ee) {
      fH.get(q3) != null ? H.otherDims[q3] = ee : (H.coordDim = q3, H.coordDimIndex = ee, a.set(q3, true));
    }
    var _ = t2.generateCoord, C = t2.generateCoordCount, M = C != null;
    C = _ ? C || 1 : 0;
    var E = _ || "value";
    function z9(H) {
      H.name == null && (H.name = H.coordDim);
    }
    if (s)
      ae(i, function(H) {
        z9(H);
      }), i.sort(function(H, q3) {
        return H.storeDimIndex - q3.storeDimIndex;
      });
    else
      for (var V = 0; V < o; V++) {
        var $ = d2(V), U = $.coordDim;
        U == null && ($.coordDim = jfe(E, a, M), $.coordDimIndex = 0, (!_ || C <= 0) && ($.isExtraCoord = true), C--), z9($), $.type == null && (pH(r2, V) === Fl.Must || $.isExtraCoord && ($.otherDims.itemName != null || $.otherDims.seriesName != null)) && ($.type = "ordinal");
      }
    return Nfe(i), new wq({ source: r2, dimensions: i, fullDimensionCount: o, dimensionOmitted: s });
  }
  function Nfe(r2) {
    for (var t2 = mn(), e2 = 0; e2 < r2.length; e2++) {
      var n2 = r2[e2], a = n2.name, i = t2.get(a) || 0;
      i > 0 && (n2.name = a + (i - 1)), i++, t2.set(a, i);
    }
  }
  function Vfe(r2, t2, e2, n2) {
    var a = Math.max(r2.dimensionsDetectedCount || 1, t2.length, e2.length, n2 || 0);
    return ae(t2, function(i) {
      var o;
      Tn(i) && (o = i.dimsDef) && (a = Math.max(a, o.length));
    }), a;
  }
  function jfe(r2, t2, e2) {
    var n2 = t2.data;
    if (e2 || n2.hasOwnProperty(r2)) {
      for (var a = 0; n2.hasOwnProperty(r2 + a); )
        a++;
      r2 += a;
    }
    return t2.set(r2, true), r2;
  }
  var Bfe = function() {
    function r2(t2) {
      this.coordSysDims = [], this.axisMap = mn(), this.categoryAxisMap = mn(), this.coordSysName = t2;
    }
    return r2;
  }();
  function zfe(r2) {
    var t2 = r2.get("coordinateSystem"), e2 = new Bfe(t2), n2 = $fe[t2];
    if (n2)
      return n2(r2, e2, e2.axisMap, e2.categoryAxisMap), e2;
  }
  var $fe = { cartesian2d: function(r2, t2, e2, n2) {
    var a = r2.getReferringComponents("xAxis", uu).models[0], i = r2.getReferringComponents("yAxis", uu).models[0];
    t2.coordSysDims = ["x", "y"], e2.set("x", a), e2.set("y", i), Sx(a) && (n2.set("x", a), t2.firstCategoryDimIndex = 0), Sx(i) && (n2.set("y", i), t2.firstCategoryDimIndex == null && (t2.firstCategoryDimIndex = 1));
  }, singleAxis: function(r2, t2, e2, n2) {
    var a = r2.getReferringComponents("singleAxis", uu).models[0];
    t2.coordSysDims = ["single"], e2.set("single", a), Sx(a) && (n2.set("single", a), t2.firstCategoryDimIndex = 0);
  }, polar: function(r2, t2, e2, n2) {
    var a = r2.getReferringComponents("polar", uu).models[0], i = a.findAxisModel("radiusAxis"), o = a.findAxisModel("angleAxis");
    t2.coordSysDims = ["radius", "angle"], e2.set("radius", i), e2.set("angle", o), Sx(i) && (n2.set("radius", i), t2.firstCategoryDimIndex = 0), Sx(o) && (n2.set("angle", o), t2.firstCategoryDimIndex == null && (t2.firstCategoryDimIndex = 1));
  }, geo: function(r2, t2, e2, n2) {
    t2.coordSysDims = ["lng", "lat"];
  }, parallel: function(r2, t2, e2, n2) {
    var a = r2.ecModel, i = a.getComponent("parallel", r2.get("parallelIndex")), o = t2.coordSysDims = i.dimensions.slice();
    ae(i.parallelAxisIndex, function(s, u) {
      var l2 = a.getComponent("parallelAxis", s), c2 = o[u];
      e2.set(c2, l2), Sx(l2) && (n2.set(c2, l2), t2.firstCategoryDimIndex == null && (t2.firstCategoryDimIndex = u));
    });
  } };
  function Sx(r2) {
    return r2.get("type") === "category";
  }
  function Gfe(r2, t2, e2) {
    e2 = e2 || {};
    var n2 = e2.byIndex, a = e2.stackedCoordDimension, i, o, s;
    Wfe(t2) ? i = t2 : (o = t2.schema, i = o.dimensions, s = t2.store);
    var u = !!(r2 && r2.get("stack")), l2, c2, f2, h;
    if (ae(i, function(C, M) {
      Zr(C) && (i[M] = C = { name: C }), u && !C.isExtraCoord && (!n2 && !l2 && C.ordinalMeta && (l2 = C), !c2 && C.type !== "ordinal" && C.type !== "time" && (!a || a === C.coordDim) && (c2 = C));
    }), c2 && !n2 && !l2 && (n2 = true), c2) {
      f2 = "__\0ecstackresult_" + r2.id, h = "__\0ecstackedover_" + r2.id, l2 && (l2.createInvertedIndices = true);
      var v9 = c2.coordDim, d2 = c2.type, m2 = 0;
      ae(i, function(C) {
        C.coordDim === v9 && m2++;
      });
      var b2 = { name: f2, coordDim: v9, coordDimIndex: m2, type: d2, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: i.length }, _ = { name: h, coordDim: h, coordDimIndex: m2 + 1, type: d2, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: i.length + 1 };
      o ? (s && (b2.storeDimIndex = s.ensureCalculationDimension(h, d2), _.storeDimIndex = s.ensureCalculationDimension(f2, d2)), o.appendCalculationDimension(b2), o.appendCalculationDimension(_)) : (i.push(b2), i.push(_));
    }
    return { stackedDimension: c2 && c2.name, stackedByDimension: l2 && l2.name, isStackedByIndex: n2, stackedOverDimension: h, stackResultDimension: f2 };
  }
  function Wfe(r2) {
    return !Sq(r2.schema);
  }
  function _y(r2, t2) {
    return !!t2 && t2 === r2.getCalculationInfo("stackedDimension");
  }
  function Tq(r2, t2) {
    return _y(r2, t2) ? r2.getCalculationInfo("stackResultDimension") : t2;
  }
  function Ufe(r2, t2) {
    var e2 = r2.get("coordinateSystem"), n2 = FE.get(e2), a;
    return t2 && t2.coordSysDims && (a = pr(t2.coordSysDims, function(i) {
      var o = { name: i }, s = t2.axisMap.get(i);
      if (s) {
        var u = s.get("type");
        o.type = vP(u);
      }
      return o;
    })), a || (a = n2 && (n2.getDimensionsInfo ? n2.getDimensionsInfo() : n2.dimensions.slice()) || ["x", "y"]), a;
  }
  function Hfe(r2, t2, e2) {
    var n2, a;
    return e2 && ae(r2, function(i, o) {
      var s = i.coordDim, u = e2.categoryAxisMap.get(s);
      u && (n2 == null && (n2 = o), i.ordinalMeta = u.getOrdinalMeta(), t2 && (i.createInvertedIndices = true)), i.otherDims.itemName != null && (a = true);
    }), !a && n2 != null && (r2[n2].otherDims.itemName = 0), n2;
  }
  function kg(r2, t2, e2) {
    e2 = e2 || {};
    var n2 = t2.getSourceManager(), a, i = false;
    r2 ? (i = true, a = yF(r2)) : (a = n2.getSource(), i = a.sourceFormat === Kh);
    var o = zfe(t2), s = Ufe(t2, o), u = e2.useEncodeDefaulter, l2 = xn(u) ? u : u ? Gn(dH, s, t2) : null, c2 = { coordDimensions: s, generateCoord: e2.generateCoord, encodeDefine: t2.getEncode(), encodeDefaulter: l2, canOmitUnusedDimensions: !i }, f2 = jE(a, c2), h = Hfe(f2.dimensions, e2.createInvertedIndices, o), v9 = i ? null : n2.getSharedDataStore(f2), d2 = Gfe(t2, { schema: f2, store: v9 }), m2 = new Rc(f2, t2);
    m2.setCalculationInfo(d2);
    var b2 = h != null && qfe(a) ? function(_, C, M, E) {
      return E === h ? M : this.defaultDimValueGetter(_, C, M, E);
    } : null;
    return m2.hasItemOption = false, m2.initData(i ? a : v9, null, b2), m2;
  }
  function qfe(r2) {
    if (r2.sourceFormat === Kh) {
      var t2 = Yfe(r2.data || []);
      return !vr(hw(t2));
    }
  }
  function Yfe(r2) {
    for (var t2 = 0; t2 < r2.length && r2[t2] == null; )
      t2++;
    return r2[t2];
  }
  var Mq = function() {
    function r2(t2) {
      this._setting = t2 || {}, this._extent = [1 / 0, -1 / 0];
    }
    return r2.prototype.getSetting = function(t2) {
      return this._setting[t2];
    }, r2.prototype.unionExtent = function(t2) {
      var e2 = this._extent;
      t2[0] < e2[0] && (e2[0] = t2[0]), t2[1] > e2[1] && (e2[1] = t2[1]);
    }, r2.prototype.unionExtentFromData = function(t2, e2) {
      this.unionExtent(t2.getApproximateExtent(e2));
    }, r2.prototype.getExtent = function() {
      return this._extent.slice();
    }, r2.prototype.setExtent = function(t2, e2) {
      var n2 = this._extent;
      isNaN(t2) || (n2[0] = t2), isNaN(e2) || (n2[1] = e2);
    }, r2.prototype.isInExtentRange = function(t2) {
      return this._extent[0] <= t2 && this._extent[1] >= t2;
    }, r2.prototype.isBlank = function() {
      return this._isBlank;
    }, r2.prototype.setBlank = function(t2) {
      this._isBlank = t2;
    }, r2;
  }();
  YP(Mq);
  var Rg = Mq, Kfe = 0, Zfe = function() {
    function r2(t2) {
      this.categories = t2.categories || [], this._needCollect = t2.needCollect, this._deduplication = t2.deduplication, this.uid = ++Kfe;
    }
    return r2.createByAxisModel = function(t2) {
      var e2 = t2.option, n2 = e2.data, a = n2 && pr(n2, Xfe);
      return new r2({ categories: a, needCollect: !a, deduplication: e2.dedplication !== false });
    }, r2.prototype.getOrdinal = function(t2) {
      return this._getOrCreateMap().get(t2);
    }, r2.prototype.parseAndCollect = function(t2) {
      var e2, n2 = this._needCollect;
      if (!Zr(t2) && !n2)
        return t2;
      if (n2 && !this._deduplication)
        return e2 = this.categories.length, this.categories[e2] = t2, e2;
      var a = this._getOrCreateMap();
      return e2 = a.get(t2), e2 == null && (n2 ? (e2 = this.categories.length, this.categories[e2] = t2, a.set(t2, e2)) : e2 = NaN), e2;
    }, r2.prototype._getOrCreateMap = function() {
      return this._map || (this._map = mn(this.categories));
    }, r2;
  }();
  function Xfe(r2) {
    return Tn(r2) && r2.value != null ? r2.value : r2 + "";
  }
  var A4 = Zfe;
  function T4(r2) {
    return r2.type === "interval" || r2.type === "log";
  }
  function Jfe(r2, t2, e2, n2) {
    var a = {}, i = r2[1] - r2[0], o = a.interval = VW(i / t2, true);
    e2 != null && o < e2 && (o = a.interval = e2), n2 != null && o > n2 && (o = a.interval = n2);
    var s = a.intervalPrecision = Pq(o), u = a.niceTickExtent = [Os(Math.ceil(r2[0] / o) * o, s), Os(Math.floor(r2[1] / o) * o, s)];
    return Qfe(u, r2), a;
  }
  function tk(r2) {
    var t2 = Math.pow(10, H6(r2)), e2 = r2 / t2;
    return e2 ? e2 === 2 ? e2 = 3 : e2 === 3 ? e2 = 5 : e2 *= 2 : e2 = 1, Os(e2 * t2);
  }
  function Pq(r2) {
    return Ud(r2) + 2;
  }
  function YV(r2, t2, e2) {
    r2[t2] = Math.max(Math.min(r2[t2], e2[1]), e2[0]);
  }
  function Qfe(r2, t2) {
    !isFinite(r2[0]) && (r2[0] = t2[0]), !isFinite(r2[1]) && (r2[1] = t2[1]), YV(r2, 0, t2), YV(r2, 1, t2), r2[0] > r2[1] && (r2[0] = r2[1]);
  }
  function p3(r2, t2) {
    return r2 >= t2[0] && r2 <= t2[1];
  }
  function g3(r2, t2) {
    return t2[1] === t2[0] ? 0.5 : (r2 - t2[0]) / (t2[1] - t2[0]);
  }
  function y3(r2, t2) {
    return r2 * (t2[1] - t2[0]) + t2[0];
  }
  var Dq = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      n2.type = "ordinal";
      var a = n2.getSetting("ordinalMeta");
      return a || (a = new A4({})), vr(a) && (a = new A4({ categories: pr(a, function(i) {
        return Tn(i) ? i.value : i;
      }) })), n2._ordinalMeta = a, n2._extent = n2.getSetting("extent") || [0, a.categories.length - 1], n2;
    }
    return t2.prototype.parse = function(e2) {
      return Zr(e2) ? this._ordinalMeta.getOrdinal(e2) : Math.round(e2);
    }, t2.prototype.contain = function(e2) {
      return e2 = this.parse(e2), p3(e2, this._extent) && this._ordinalMeta.categories[e2] != null;
    }, t2.prototype.normalize = function(e2) {
      return e2 = this._getTickNumber(this.parse(e2)), g3(e2, this._extent);
    }, t2.prototype.scale = function(e2) {
      return e2 = Math.round(y3(e2, this._extent)), this.getRawOrdinalNumber(e2);
    }, t2.prototype.getTicks = function() {
      for (var e2 = [], n2 = this._extent, a = n2[0]; a <= n2[1]; )
        e2.push({ value: a }), a++;
      return e2;
    }, t2.prototype.getMinorTicks = function(e2) {
    }, t2.prototype.setSortInfo = function(e2) {
      if (e2 == null) {
        this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
        return;
      }
      for (var n2 = e2.ordinalNumbers, a = this._ordinalNumbersByTick = [], i = this._ticksByOrdinalNumber = [], o = 0, s = this._ordinalMeta.categories.length, u = Math.min(s, n2.length); o < u; ++o) {
        var l2 = n2[o];
        a[o] = l2, i[l2] = o;
      }
      for (var c2 = 0; o < s; ++o) {
        for (; i[c2] != null; )
          c2++;
        a.push(c2), i[c2] = o;
      }
    }, t2.prototype._getTickNumber = function(e2) {
      var n2 = this._ticksByOrdinalNumber;
      return n2 && e2 >= 0 && e2 < n2.length ? n2[e2] : e2;
    }, t2.prototype.getRawOrdinalNumber = function(e2) {
      var n2 = this._ordinalNumbersByTick;
      return n2 && e2 >= 0 && e2 < n2.length ? n2[e2] : e2;
    }, t2.prototype.getLabel = function(e2) {
      if (!this.isBlank()) {
        var n2 = this.getRawOrdinalNumber(e2.value), a = this._ordinalMeta.categories[n2];
        return a == null ? "" : a + "";
      }
    }, t2.prototype.count = function() {
      return this._extent[1] - this._extent[0] + 1;
    }, t2.prototype.unionExtentFromData = function(e2, n2) {
      this.unionExtent(e2.getApproximateExtent(n2));
    }, t2.prototype.isInExtentRange = function(e2) {
      return e2 = this._getTickNumber(e2), this._extent[0] <= e2 && this._extent[1] >= e2;
    }, t2.prototype.getOrdinalMeta = function() {
      return this._ordinalMeta;
    }, t2.prototype.calcNiceTicks = function() {
    }, t2.prototype.calcNiceExtent = function() {
    }, t2.type = "ordinal", t2;
  }(Rg);
  Rg.registerClass(Dq);
  var IF = Dq, _b2 = Os, Iq = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "interval", e2._interval = 0, e2._intervalPrecision = 2, e2;
    }
    return t2.prototype.parse = function(e2) {
      return e2;
    }, t2.prototype.contain = function(e2) {
      return p3(e2, this._extent);
    }, t2.prototype.normalize = function(e2) {
      return g3(e2, this._extent);
    }, t2.prototype.scale = function(e2) {
      return y3(e2, this._extent);
    }, t2.prototype.setExtent = function(e2, n2) {
      var a = this._extent;
      isNaN(e2) || (a[0] = parseFloat(e2)), isNaN(n2) || (a[1] = parseFloat(n2));
    }, t2.prototype.unionExtent = function(e2) {
      var n2 = this._extent;
      e2[0] < n2[0] && (n2[0] = e2[0]), e2[1] > n2[1] && (n2[1] = e2[1]), this.setExtent(n2[0], n2[1]);
    }, t2.prototype.getInterval = function() {
      return this._interval;
    }, t2.prototype.setInterval = function(e2) {
      this._interval = e2, this._niceExtent = this._extent.slice(), this._intervalPrecision = Pq(e2);
    }, t2.prototype.getTicks = function(e2) {
      var n2 = this._interval, a = this._extent, i = this._niceExtent, o = this._intervalPrecision, s = [];
      if (!n2)
        return s;
      var u = 1e4;
      a[0] < i[0] && (e2 ? s.push({ value: _b2(i[0] - n2, o) }) : s.push({ value: a[0] }));
      for (var l2 = i[0]; l2 <= i[1] && (s.push({ value: l2 }), l2 = _b2(l2 + n2, o), l2 !== s[s.length - 1].value); )
        if (s.length > u)
          return [];
      var c2 = s.length ? s[s.length - 1].value : i[1];
      return a[1] > c2 && (e2 ? s.push({ value: _b2(c2 + n2, o) }) : s.push({ value: a[1] })), s;
    }, t2.prototype.getMinorTicks = function(e2) {
      for (var n2 = this.getTicks(true), a = [], i = this.getExtent(), o = 1; o < n2.length; o++) {
        for (var s = n2[o], u = n2[o - 1], l2 = 0, c2 = [], f2 = s.value - u.value, h = f2 / e2; l2 < e2 - 1; ) {
          var v9 = _b2(u.value + (l2 + 1) * h);
          v9 > i[0] && v9 < i[1] && c2.push(v9), l2++;
        }
        a.push(c2);
      }
      return a;
    }, t2.prototype.getLabel = function(e2, n2) {
      if (e2 == null)
        return "";
      var a = n2 && n2.precision;
      a == null ? a = Ud(e2.value) || 0 : a === "auto" && (a = this._intervalPrecision);
      var i = _b2(e2.value, a, true);
      return iH(i);
    }, t2.prototype.calcNiceTicks = function(e2, n2, a) {
      e2 = e2 || 5;
      var i = this._extent, o = i[1] - i[0];
      if (!!isFinite(o)) {
        o < 0 && (o = -o, i.reverse());
        var s = Jfe(i, e2, n2, a);
        this._intervalPrecision = s.intervalPrecision, this._interval = s.interval, this._niceExtent = s.niceTickExtent;
      }
    }, t2.prototype.calcNiceExtent = function(e2) {
      var n2 = this._extent;
      if (n2[0] === n2[1])
        if (n2[0] !== 0) {
          var a = n2[0];
          e2.fixMax || (n2[1] += a / 2), n2[0] -= a / 2;
        } else
          n2[1] = 1;
      var i = n2[1] - n2[0];
      isFinite(i) || (n2[0] = 0, n2[1] = 1), this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
      var o = this._interval;
      e2.fixMin || (n2[0] = _b2(Math.floor(n2[0] / o) * o)), e2.fixMax || (n2[1] = _b2(Math.ceil(n2[1] / o) * o));
    }, t2.prototype.setNiceExtent = function(e2, n2) {
      this._niceExtent = [e2, n2];
    }, t2.type = "interval", t2;
  }(Rg);
  Rg.registerClass(Iq);
  var xy = Iq, Lq = typeof Float32Array != "undefined", ehe = Lq ? Float32Array : Array;
  function qd(r2) {
    return vr(r2) ? Lq ? new Float32Array(r2) : r2 : new ehe(r2);
  }
  var M4 = "__ec_stack_";
  function LF(r2) {
    return r2.get("stack") || M4 + r2.seriesIndex;
  }
  function OF(r2) {
    return r2.dim + r2.index;
  }
  function the(r2) {
    var t2 = [], e2 = r2.axis, n2 = "axis0";
    if (e2.type === "category") {
      for (var a = e2.getBandWidth(), i = 0; i < r2.count; i++)
        t2.push(En({ bandWidth: a, axisKey: n2, stackId: M4 + i }, r2));
      for (var o = Rq(t2), s = [], i = 0; i < r2.count; i++) {
        var u = o[n2][M4 + i];
        u.offsetCenter = u.offset + u.width / 2, s.push(u);
      }
      return s;
    }
  }
  function Oq(r2, t2) {
    var e2 = [];
    return t2.eachSeriesByType(r2, function(n2) {
      Vq(n2) && e2.push(n2);
    }), e2;
  }
  function rhe(r2) {
    var t2 = {};
    ae(r2, function(u) {
      var l2 = u.coordinateSystem, c2 = l2.getBaseAxis();
      if (!(c2.type !== "time" && c2.type !== "value"))
        for (var f2 = u.getData(), h = c2.dim + "_" + c2.index, v9 = f2.getDimensionIndex(f2.mapDimension(c2.dim)), d2 = f2.getStore(), m2 = 0, b2 = d2.count(); m2 < b2; ++m2) {
          var _ = d2.get(v9, m2);
          t2[h] ? t2[h].push(_) : t2[h] = [_];
        }
    });
    var e2 = {};
    for (var n2 in t2)
      if (t2.hasOwnProperty(n2)) {
        var a = t2[n2];
        if (a) {
          a.sort(function(u, l2) {
            return u - l2;
          });
          for (var i = null, o = 1; o < a.length; ++o) {
            var s = a[o] - a[o - 1];
            s > 0 && (i = i === null ? s : Math.min(i, s));
          }
          e2[n2] = i;
        }
      }
    return e2;
  }
  function kq(r2) {
    var t2 = rhe(r2), e2 = [];
    return ae(r2, function(n2) {
      var a = n2.coordinateSystem, i = a.getBaseAxis(), o = i.getExtent(), s;
      if (i.type === "category")
        s = i.getBandWidth();
      else if (i.type === "value" || i.type === "time") {
        var u = i.dim + "_" + i.index, l2 = t2[u], c2 = Math.abs(o[1] - o[0]), f2 = i.scale.getExtent(), h = Math.abs(f2[1] - f2[0]);
        s = l2 ? c2 / h * l2 : c2;
      } else {
        var v9 = n2.getData();
        s = Math.abs(o[1] - o[0]) / v9.count();
      }
      var d2 = qr(n2.get("barWidth"), s), m2 = qr(n2.get("barMaxWidth"), s), b2 = qr(n2.get("barMinWidth") || (jq(n2) ? 0.5 : 1), s), _ = n2.get("barGap"), C = n2.get("barCategoryGap");
      e2.push({ bandWidth: s, barWidth: d2, barMaxWidth: m2, barMinWidth: b2, barGap: _, barCategoryGap: C, axisKey: OF(i), stackId: LF(n2) });
    }), Rq(e2);
  }
  function Rq(r2) {
    var t2 = {};
    ae(r2, function(n2, a) {
      var i = n2.axisKey, o = n2.bandWidth, s = t2[i] || { bandWidth: o, remainedWidth: o, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, u = s.stacks;
      t2[i] = s;
      var l2 = n2.stackId;
      u[l2] || s.autoWidthCount++, u[l2] = u[l2] || { width: 0, maxWidth: 0 };
      var c2 = n2.barWidth;
      c2 && !u[l2].width && (u[l2].width = c2, c2 = Math.min(s.remainedWidth, c2), s.remainedWidth -= c2);
      var f2 = n2.barMaxWidth;
      f2 && (u[l2].maxWidth = f2);
      var h = n2.barMinWidth;
      h && (u[l2].minWidth = h);
      var v9 = n2.barGap;
      v9 != null && (s.gap = v9);
      var d2 = n2.barCategoryGap;
      d2 != null && (s.categoryGap = d2);
    });
    var e2 = {};
    return ae(t2, function(n2, a) {
      e2[a] = {};
      var i = n2.stacks, o = n2.bandWidth, s = n2.categoryGap;
      if (s == null) {
        var u = ja(i).length;
        s = Math.max(35 - u * 4, 15) + "%";
      }
      var l2 = qr(s, o), c2 = qr(n2.gap, 1), f2 = n2.remainedWidth, h = n2.autoWidthCount, v9 = (f2 - l2) / (h + (h - 1) * c2);
      v9 = Math.max(v9, 0), ae(i, function(_) {
        var C = _.maxWidth, M = _.minWidth;
        if (_.width) {
          var E = _.width;
          C && (E = Math.min(E, C)), M && (E = Math.max(E, M)), _.width = E, f2 -= E + c2 * E, h--;
        } else {
          var E = v9;
          C && C < E && (E = Math.min(C, f2)), M && M > E && (E = M), E !== v9 && (_.width = E, f2 -= E + c2 * E, h--);
        }
      }), v9 = (f2 - l2) / (h + (h - 1) * c2), v9 = Math.max(v9, 0);
      var d2 = 0, m2;
      ae(i, function(_, C) {
        _.width || (_.width = v9), m2 = _, d2 += _.width * (1 + c2);
      }), m2 && (d2 -= m2.width * c2);
      var b2 = -d2 / 2;
      ae(i, function(_, C) {
        e2[a][C] = e2[a][C] || { bandWidth: o, offset: b2, width: _.width }, b2 += _.width * (1 + c2);
      });
    }), e2;
  }
  function nhe(r2, t2, e2) {
    if (r2 && t2) {
      var n2 = r2[OF(t2)];
      return n2 != null && e2 != null ? n2[LF(e2)] : n2;
    }
  }
  function Fq(r2, t2) {
    var e2 = Oq(r2, t2), n2 = kq(e2);
    ae(e2, function(a) {
      var i = a.getData(), o = a.coordinateSystem, s = o.getBaseAxis(), u = LF(a), l2 = n2[OF(s)][u], c2 = l2.offset, f2 = l2.width;
      i.setLayout({ bandWidth: l2.bandWidth, offset: c2, size: f2 });
    });
  }
  function Nq(r2) {
    return { seriesType: r2, plan: ww(), reset: function(t2) {
      if (!!Vq(t2)) {
        var e2 = t2.getData(), n2 = t2.coordinateSystem, a = n2.getBaseAxis(), i = n2.getOtherAxis(a), o = e2.getDimensionIndex(e2.mapDimension(i.dim)), s = e2.getDimensionIndex(e2.mapDimension(a.dim)), u = t2.get("showBackground", true), l2 = e2.mapDimension(i.dim), c2 = e2.getCalculationInfo("stackResultDimension"), f2 = _y(e2, l2) && !!e2.getCalculationInfo("stackedOnSeries"), h = i.isHorizontal(), v9 = ahe(a, i), d2 = jq(t2), m2 = t2.get("barMinHeight") || 0, b2 = c2 && e2.getDimensionIndex(c2), _ = e2.getLayout("size"), C = e2.getLayout("offset");
        return { progress: function(M, E) {
          for (var z9 = M.count, V = d2 && qd(z9 * 3), $ = d2 && u && qd(z9 * 3), U = d2 && qd(z9), H = n2.master.getRect(), q3 = h ? H.width : H.height, ee, oe = E.getStore(), ne = 0; (ee = M.next()) != null; ) {
            var be = oe.get(f2 ? b2 : o, ee), Ee = oe.get(s, ee), ye = v9, et = void 0;
            f2 && (et = +be - oe.get(o, ee));
            var Le = void 0, Fe = void 0, qe = void 0, st = void 0;
            if (h) {
              var dt = n2.dataToPoint([be, Ee]);
              if (f2) {
                var Ar = n2.dataToPoint([et, Ee]);
                ye = Ar[0];
              }
              Le = ye, Fe = dt[1] + C, qe = dt[0] - ye, st = _, Math.abs(qe) < m2 && (qe = (qe < 0 ? -1 : 1) * m2);
            } else {
              var dt = n2.dataToPoint([Ee, be]);
              if (f2) {
                var Ar = n2.dataToPoint([Ee, et]);
                ye = Ar[1];
              }
              Le = dt[0] + C, Fe = ye, qe = _, st = dt[1] - ye, Math.abs(st) < m2 && (st = (st <= 0 ? -1 : 1) * m2);
            }
            d2 ? (V[ne] = Le, V[ne + 1] = Fe, V[ne + 2] = h ? qe : st, $ && ($[ne] = h ? H.x : Le, $[ne + 1] = h ? Fe : H.y, $[ne + 2] = q3), U[ee] = ee) : E.setItemLayout(ee, { x: Le, y: Fe, width: qe, height: st }), ne += 3;
          }
          d2 && E.setLayout({ largePoints: V, largeDataIndices: U, largeBackgroundPoints: $, valueAxisHorizontal: h });
        } };
      }
    } };
  }
  function Vq(r2) {
    return r2.coordinateSystem && r2.coordinateSystem.type === "cartesian2d";
  }
  function jq(r2) {
    return r2.pipelineContext && r2.pipelineContext.large;
  }
  function ahe(r2, t2) {
    return t2.toGlobalCoord(t2.dataToCoord(t2.type === "log" ? 1 : 0));
  }
  var ihe = function(r2, t2, e2, n2) {
    for (; e2 < n2; ) {
      var a = e2 + n2 >>> 1;
      r2[a][1] < t2 ? e2 = a + 1 : n2 = a;
    }
    return e2;
  }, Bq = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "time", n2;
    }
    return t2.prototype.getLabel = function(e2) {
      var n2 = this.getSetting("useUTC");
      return i3(e2.value, V7[Aue(Zx(this._minLevelUnit))] || V7.second, n2, this.getSetting("locale"));
    }, t2.prototype.getFormattedLabel = function(e2, n2, a) {
      var i = this.getSetting("useUTC"), o = this.getSetting("locale");
      return Tue(e2, n2, a, o, i);
    }, t2.prototype.getTicks = function() {
      var e2 = this._interval, n2 = this._extent, a = [];
      if (!e2)
        return a;
      a.push({ value: n2[0], level: 0 });
      var i = this.getSetting("useUTC"), o = hhe(this._minLevelUnit, this._approxInterval, i, n2);
      return a = a.concat(o), a.push({ value: n2[1], level: 0 }), a;
    }, t2.prototype.calcNiceExtent = function(e2) {
      var n2 = this._extent;
      if (n2[0] === n2[1] && (n2[0] -= zh, n2[1] += zh), n2[1] === -1 / 0 && n2[0] === 1 / 0) {
        var a = new Date();
        n2[1] = +new Date(a.getFullYear(), a.getMonth(), a.getDate()), n2[0] = n2[1] - zh;
      }
      this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
    }, t2.prototype.calcNiceTicks = function(e2, n2, a) {
      e2 = e2 || 10;
      var i = this._extent, o = i[1] - i[0];
      this._approxInterval = o / e2, n2 != null && this._approxInterval < n2 && (this._approxInterval = n2), a != null && this._approxInterval > a && (this._approxInterval = a);
      var s = zM.length, u = Math.min(ihe(zM, this._approxInterval, 0, s), s - 1);
      this._interval = zM[u][1], this._minLevelUnit = zM[Math.max(u - 1, 0)][0];
    }, t2.prototype.parse = function(e2) {
      return Ai(e2) ? e2 : +rp(e2);
    }, t2.prototype.contain = function(e2) {
      return p3(this.parse(e2), this._extent);
    }, t2.prototype.normalize = function(e2) {
      return g3(this.parse(e2), this._extent);
    }, t2.prototype.scale = function(e2) {
      return y3(e2, this._extent);
    }, t2.type = "time", t2;
  }(xy), zM = [["second", lF], ["minute", cF], ["hour", jC], ["quarter-day", jC * 6], ["half-day", jC * 12], ["day", zh * 1.2], ["half-week", zh * 3.5], ["week", zh * 7], ["month", zh * 31], ["quarter", zh * 95], ["half-year", N7 / 2], ["year", N7]];
  function ohe(r2, t2, e2, n2) {
    var a = rp(t2), i = rp(e2), o = function(d2) {
      return j7(a, d2, n2) === j7(i, d2, n2);
    }, s = function() {
      return o("year");
    }, u = function() {
      return s() && o("month");
    }, l2 = function() {
      return u() && o("day");
    }, c2 = function() {
      return l2() && o("hour");
    }, f2 = function() {
      return c2() && o("minute");
    }, h = function() {
      return f2() && o("second");
    }, v9 = function() {
      return h() && o("millisecond");
    };
    switch (r2) {
      case "year":
        return s();
      case "month":
        return u();
      case "day":
        return l2();
      case "hour":
        return c2();
      case "minute":
        return f2();
      case "second":
        return h();
      case "millisecond":
        return v9();
    }
  }
  function she(r2, t2) {
    return r2 /= zh, r2 > 16 ? 16 : r2 > 7.5 ? 7 : r2 > 3.5 ? 4 : r2 > 1.5 ? 2 : 1;
  }
  function uhe(r2) {
    var t2 = 30 * zh;
    return r2 /= t2, r2 > 6 ? 6 : r2 > 3 ? 3 : r2 > 2 ? 2 : 1;
  }
  function lhe(r2) {
    return r2 /= jC, r2 > 12 ? 12 : r2 > 6 ? 6 : r2 > 3.5 ? 4 : r2 > 2 ? 2 : 1;
  }
  function KV(r2, t2) {
    return r2 /= t2 ? cF : lF, r2 > 30 ? 30 : r2 > 20 ? 20 : r2 > 15 ? 15 : r2 > 10 ? 10 : r2 > 5 ? 5 : r2 > 2 ? 2 : 1;
  }
  function che(r2) {
    return VW(r2, true);
  }
  function fhe(r2, t2, e2) {
    var n2 = new Date(r2);
    switch (Zx(t2)) {
      case "year":
      case "month":
        n2[QU(e2)](0);
      case "day":
        n2[eH(e2)](1);
      case "hour":
        n2[tH(e2)](0);
      case "minute":
        n2[rH(e2)](0);
      case "second":
        n2[nH(e2)](0), n2[aH(e2)](0);
    }
    return n2.getTime();
  }
  function hhe(r2, t2, e2, n2) {
    var a = 1e4, i = XU, o = 0;
    function s(q3, ee, oe, ne, be, Ee, ye) {
      for (var et = new Date(ee), Le = ee, Fe = et[ne](); Le < oe && Le <= n2[1]; )
        ye.push({ value: Le }), Fe += q3, et[be](Fe), Le = et.getTime();
      ye.push({ value: Le, notAdd: true });
    }
    function u(q3, ee, oe) {
      var ne = [], be = !ee.length;
      if (!ohe(Zx(q3), n2[0], n2[1], e2)) {
        be && (ee = [{ value: fhe(new Date(n2[0]), q3, e2) }, { value: n2[1] }]);
        for (var Ee = 0; Ee < ee.length - 1; Ee++) {
          var ye = ee[Ee].value, et = ee[Ee + 1].value;
          if (ye !== et) {
            var Le = void 0, Fe = void 0, qe = void 0, st = false;
            switch (q3) {
              case "year":
                Le = Math.max(1, Math.round(t2 / zh / 365)), Fe = fF(e2), qe = Mue(e2);
                break;
              case "half-year":
              case "quarter":
              case "month":
                Le = uhe(t2), Fe = Xx(e2), qe = QU(e2);
                break;
              case "week":
              case "half-week":
              case "day":
                Le = she(t2), Fe = o3(e2), qe = eH(e2), st = true;
                break;
              case "half-day":
              case "quarter-day":
              case "hour":
                Le = lhe(t2), Fe = oE(e2), qe = tH(e2);
                break;
              case "minute":
                Le = KV(t2, true), Fe = s3(e2), qe = rH(e2);
                break;
              case "second":
                Le = KV(t2, false), Fe = u3(e2), qe = nH(e2);
                break;
              case "millisecond":
                Le = che(t2), Fe = l3(e2), qe = aH(e2);
                break;
            }
            s(Le, ye, et, Fe, qe, st, ne), q3 === "year" && oe.length > 1 && Ee === 0 && oe.unshift({ value: oe[0].value - Le });
          }
        }
        for (var Ee = 0; Ee < ne.length; Ee++)
          oe.push(ne[Ee]);
        return ne;
      }
    }
    for (var l2 = [], c2 = [], f2 = 0, h = 0, v9 = 0; v9 < i.length && o++ < a; ++v9) {
      var d2 = Zx(i[v9]);
      if (!!Eue(i[v9])) {
        u(i[v9], l2[l2.length - 1] || [], c2);
        var m2 = i[v9 + 1] ? Zx(i[v9 + 1]) : null;
        if (d2 !== m2) {
          if (c2.length) {
            h = f2, c2.sort(function(q3, ee) {
              return q3.value - ee.value;
            });
            for (var b2 = [], _ = 0; _ < c2.length; ++_) {
              var C = c2[_].value;
              (_ === 0 || c2[_ - 1].value !== C) && (b2.push(c2[_]), C >= n2[0] && C <= n2[1] && f2++);
            }
            var M = (n2[1] - n2[0]) / t2;
            if (f2 > M * 1.5 && h > M / 1.5 || (l2.push(b2), f2 > M || r2 === i[v9]))
              break;
          }
          c2 = [];
        }
      }
    }
    for (var E = no(pr(l2, function(q3) {
      return no(q3, function(ee) {
        return ee.value >= n2[0] && ee.value <= n2[1] && !ee.notAdd;
      });
    }), function(q3) {
      return q3.length > 0;
    }), z9 = [], V = E.length - 1, v9 = 0; v9 < E.length; ++v9)
      for (var $ = E[v9], U = 0; U < $.length; ++U)
        z9.push({ value: $[U].value, level: V - v9 });
    z9.sort(function(q3, ee) {
      return q3.value - ee.value;
    });
    for (var H = [], v9 = 0; v9 < z9.length; ++v9)
      (v9 === 0 || z9[v9].value !== z9[v9 - 1].value) && H.push(z9[v9]);
    return H;
  }
  Rg.registerClass(Bq);
  var zq = Bq, ZV = Rg.prototype, GC = xy.prototype, vhe = Os, dhe = Math.floor, phe = Math.ceil, $M = Math.pow, Th = Math.log, kF = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "log", e2.base = 10, e2._originalScale = new xy(), e2._interval = 0, e2;
    }
    return t2.prototype.getTicks = function(e2) {
      var n2 = this._originalScale, a = this._extent, i = n2.getExtent(), o = GC.getTicks.call(this, e2);
      return pr(o, function(s) {
        var u = s.value, l2 = Os($M(this.base, u));
        return l2 = u === a[0] && this._fixMin ? GM(l2, i[0]) : l2, l2 = u === a[1] && this._fixMax ? GM(l2, i[1]) : l2, { value: l2 };
      }, this);
    }, t2.prototype.setExtent = function(e2, n2) {
      var a = this.base;
      e2 = Th(e2) / Th(a), n2 = Th(n2) / Th(a), GC.setExtent.call(this, e2, n2);
    }, t2.prototype.getExtent = function() {
      var e2 = this.base, n2 = ZV.getExtent.call(this);
      n2[0] = $M(e2, n2[0]), n2[1] = $M(e2, n2[1]);
      var a = this._originalScale, i = a.getExtent();
      return this._fixMin && (n2[0] = GM(n2[0], i[0])), this._fixMax && (n2[1] = GM(n2[1], i[1])), n2;
    }, t2.prototype.unionExtent = function(e2) {
      this._originalScale.unionExtent(e2);
      var n2 = this.base;
      e2[0] = Th(e2[0]) / Th(n2), e2[1] = Th(e2[1]) / Th(n2), ZV.unionExtent.call(this, e2);
    }, t2.prototype.unionExtentFromData = function(e2, n2) {
      this.unionExtent(e2.getApproximateExtent(n2));
    }, t2.prototype.calcNiceTicks = function(e2) {
      e2 = e2 || 10;
      var n2 = this._extent, a = n2[1] - n2[0];
      if (!(a === 1 / 0 || a <= 0)) {
        var i = qie(a), o = e2 / a * i;
        for (o <= 0.5 && (i *= 10); !isNaN(i) && Math.abs(i) < 1 && Math.abs(i) > 0; )
          i *= 10;
        var s = [Os(phe(n2[0] / i) * i), Os(dhe(n2[1] / i) * i)];
        this._interval = i, this._niceExtent = s;
      }
    }, t2.prototype.calcNiceExtent = function(e2) {
      GC.calcNiceExtent.call(this, e2), this._fixMin = e2.fixMin, this._fixMax = e2.fixMax;
    }, t2.prototype.parse = function(e2) {
      return e2;
    }, t2.prototype.contain = function(e2) {
      return e2 = Th(e2) / Th(this.base), p3(e2, this._extent);
    }, t2.prototype.normalize = function(e2) {
      return e2 = Th(e2) / Th(this.base), g3(e2, this._extent);
    }, t2.prototype.scale = function(e2) {
      return e2 = y3(e2, this._extent), $M(this.base, e2);
    }, t2.type = "log", t2;
  }(Rg), $q = kF.prototype;
  $q.getMinorTicks = GC.getMinorTicks;
  $q.getLabel = GC.getLabel;
  function GM(r2, t2) {
    return vhe(r2, Ud(t2));
  }
  Rg.registerClass(kF);
  var ghe = kF, yhe = function() {
    function r2(t2, e2, n2) {
      this._prepareParams(t2, e2, n2);
    }
    return r2.prototype._prepareParams = function(t2, e2, n2) {
      n2[1] < n2[0] && (n2 = [NaN, NaN]), this._dataMin = n2[0], this._dataMax = n2[1];
      var a = this._isOrdinal = t2.type === "ordinal";
      this._needCrossZero = t2.type === "interval" && e2.getNeedCrossZero && e2.getNeedCrossZero();
      var i = this._modelMinRaw = e2.get("min", true);
      xn(i) ? this._modelMinNum = WM(t2, i({ min: n2[0], max: n2[1] })) : i !== "dataMin" && (this._modelMinNum = WM(t2, i));
      var o = this._modelMaxRaw = e2.get("max", true);
      if (xn(o) ? this._modelMaxNum = WM(t2, o({ min: n2[0], max: n2[1] })) : o !== "dataMax" && (this._modelMaxNum = WM(t2, o)), a)
        this._axisDataLen = e2.getCategories().length;
      else {
        var s = e2.get("boundaryGap"), u = vr(s) ? s : [s || 0, s || 0];
        typeof u[0] == "boolean" || typeof u[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [Gv(u[0], 1), Gv(u[1], 1)];
      }
    }, r2.prototype.calculate = function() {
      var t2 = this._isOrdinal, e2 = this._dataMin, n2 = this._dataMax, a = this._axisDataLen, i = this._boundaryGapInner, o = t2 ? null : n2 - e2 || Math.abs(e2), s = this._modelMinRaw === "dataMin" ? e2 : this._modelMinNum, u = this._modelMaxRaw === "dataMax" ? n2 : this._modelMaxNum, l2 = s != null, c2 = u != null;
      s == null && (s = t2 ? a ? 0 : NaN : e2 - i[0] * o), u == null && (u = t2 ? a ? a - 1 : NaN : n2 + i[1] * o), (s == null || !isFinite(s)) && (s = NaN), (u == null || !isFinite(u)) && (u = NaN);
      var f2 = XC(s) || XC(u) || t2 && !a;
      this._needCrossZero && (s > 0 && u > 0 && !l2 && (s = 0), s < 0 && u < 0 && !c2 && (u = 0));
      var h = this._determinedMin, v9 = this._determinedMax;
      return h != null && (s = h, l2 = true), v9 != null && (u = v9, c2 = true), { min: s, max: u, minFixed: l2, maxFixed: c2, isBlank: f2 };
    }, r2.prototype.modifyDataMinMax = function(t2, e2) {
      this[bhe[t2]] = e2;
    }, r2.prototype.setDeterminedMinMax = function(t2, e2) {
      var n2 = mhe[t2];
      this[n2] = e2;
    }, r2.prototype.freeze = function() {
      this.frozen = true;
    }, r2;
  }(), mhe = { min: "_determinedMin", max: "_determinedMax" }, bhe = { min: "_dataMin", max: "_dataMax" };
  function Gq(r2, t2, e2) {
    var n2 = r2.rawExtentInfo;
    return n2 || (n2 = new yhe(r2, t2, e2), r2.rawExtentInfo = n2, n2);
  }
  function WM(r2, t2) {
    return t2 == null ? null : XC(t2) ? NaN : r2.parse(t2);
  }
  function Wq(r2, t2) {
    var e2 = r2.type, n2 = Gq(r2, t2, r2.getExtent()).calculate();
    r2.setBlank(n2.isBlank);
    var a = n2.min, i = n2.max, o = t2.ecModel;
    if (o && e2 === "time") {
      var s = Oq("bar", o), u = false;
      if (ae(s, function(f2) {
        u = u || f2.getBaseAxis() === t2.axis;
      }), u) {
        var l2 = kq(s), c2 = _he(a, i, t2, l2);
        a = c2.min, i = c2.max;
      }
    }
    return { extent: [a, i], fixMin: n2.minFixed, fixMax: n2.maxFixed };
  }
  function _he(r2, t2, e2, n2) {
    var a = e2.axis.getExtent(), i = a[1] - a[0], o = nhe(n2, e2.axis);
    if (o === void 0)
      return { min: r2, max: t2 };
    var s = 1 / 0;
    ae(o, function(v9) {
      s = Math.min(v9.offset, s);
    });
    var u = -1 / 0;
    ae(o, function(v9) {
      u = Math.max(v9.offset + v9.width, u);
    }), s = Math.abs(s), u = Math.abs(u);
    var l2 = s + u, c2 = t2 - r2, f2 = 1 - (s + u) / i, h = c2 / f2 - c2;
    return t2 += h * (u / l2), r2 -= h * (s / l2), { min: r2, max: t2 };
  }
  function aw(r2, t2) {
    var e2 = t2, n2 = Wq(r2, e2), a = n2.extent, i = e2.get("splitNumber");
    r2 instanceof ghe && (r2.base = e2.get("logBase"));
    var o = r2.type, s = e2.get("interval"), u = o === "interval" || o === "time";
    r2.setExtent(a[0], a[1]), r2.calcNiceExtent({ splitNumber: i, fixMin: n2.fixMin, fixMax: n2.fixMax, minInterval: u ? e2.get("minInterval") : null, maxInterval: u ? e2.get("maxInterval") : null }), s != null && r2.setInterval && r2.setInterval(s);
  }
  function m3(r2, t2) {
    if (t2 = t2 || r2.get("type"), t2)
      switch (t2) {
        case "category":
          return new IF({ ordinalMeta: r2.getOrdinalMeta ? r2.getOrdinalMeta() : r2.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new zq({ locale: r2.ecModel.getLocaleModel(), useUTC: r2.ecModel.get("useUTC") });
        default:
          return new (Rg.getClass(t2) || xy)();
      }
  }
  function xhe(r2) {
    var t2 = r2.scale.getExtent(), e2 = t2[0], n2 = t2[1];
    return !(e2 > 0 && n2 > 0 || e2 < 0 && n2 < 0);
  }
  function BE(r2) {
    var t2 = r2.getLabelModel().get("formatter"), e2 = r2.type === "category" ? r2.scale.getExtent()[0] : null;
    return r2.scale.type === "time" ? function(n2) {
      return function(a, i) {
        return r2.scale.getFormattedLabel(a, i, n2);
      };
    }(t2) : Zr(t2) ? function(n2) {
      return function(a) {
        var i = r2.scale.getLabel(a), o = n2.replace("{value}", i != null ? i : "");
        return o;
      };
    }(t2) : xn(t2) ? function(n2) {
      return function(a, i) {
        return e2 != null && (i = a.value - e2), n2(RF(r2, a), i, a.level != null ? { level: a.level } : null);
      };
    }(t2) : function(n2) {
      return r2.scale.getLabel(n2);
    };
  }
  function RF(r2, t2) {
    return r2.type === "category" ? r2.scale.getLabel(t2) : t2.value;
  }
  function whe(r2) {
    var t2 = r2.model, e2 = r2.scale;
    if (!(!t2.get(["axisLabel", "show"]) || e2.isBlank())) {
      var n2, a, i = e2.getExtent();
      e2 instanceof IF ? a = e2.count() : (n2 = e2.getTicks(), a = n2.length);
      var o = r2.getLabelModel(), s = BE(r2), u, l2 = 1;
      a > 40 && (l2 = Math.ceil(a / 40));
      for (var c2 = 0; c2 < a; c2 += l2) {
        var f2 = n2 ? n2[c2] : { value: i[0] + c2 }, h = s(f2, c2), v9 = o.getTextRect(h), d2 = She(v9, o.get("rotate") || 0);
        u ? u.union(d2) : u = d2;
      }
      return u;
    }
  }
  function She(r2, t2) {
    var e2 = t2 * Math.PI / 180, n2 = r2.width, a = r2.height, i = n2 * Math.abs(Math.cos(e2)) + Math.abs(a * Math.sin(e2)), o = n2 * Math.abs(Math.sin(e2)) + Math.abs(a * Math.cos(e2)), s = new da(r2.x, r2.y, i, o);
    return s;
  }
  function FF(r2) {
    var t2 = r2.get("interval");
    return t2 == null ? "auto" : t2;
  }
  function Uq(r2) {
    return r2.type === "category" && FF(r2.getLabelModel()) === 0;
  }
  function dP(r2, t2) {
    var e2 = {};
    return ae(r2.mapDimensionsAll(t2), function(n2) {
      e2[Tq(r2, n2)] = true;
    }), ja(e2);
  }
  function Che(r2, t2, e2) {
    t2 && ae(dP(t2, e2), function(n2) {
      var a = t2.getApproximateExtent(n2);
      a[0] < r2[0] && (r2[0] = a[0]), a[1] > r2[1] && (r2[1] = a[1]);
    });
  }
  var zE = function() {
    function r2() {
    }
    return r2.prototype.getNeedCrossZero = function() {
      var t2 = this.option;
      return !t2.scale;
    }, r2.prototype.getCoordSysModel = function() {
    }, r2;
  }(), Ehe = 1e-8;
  function XV(r2, t2) {
    return Math.abs(r2 - t2) < Ehe;
  }
  function kb(r2, t2, e2) {
    var n2 = 0, a = r2[0];
    if (!a)
      return false;
    for (var i = 1; i < r2.length; i++) {
      var o = r2[i];
      n2 += yg(a[0], a[1], o[0], o[1], t2, e2), a = o;
    }
    var s = r2[0];
    return (!XV(a[0], s[0]) || !XV(a[1], s[1])) && (n2 += yg(a[0], a[1], s[0], s[1], t2, e2)), n2 !== 0;
  }
  var Ahe = [];
  function rk(r2, t2) {
    for (var e2 = 0; e2 < r2.length; e2++)
      Nl(r2[e2], r2[e2], t2);
  }
  function JV(r2, t2, e2, n2) {
    for (var a = 0; a < r2.length; a++) {
      var i = r2[a];
      n2 && (i = n2.project(i)), i && isFinite(i[0]) && isFinite(i[1]) && (ry(t2, t2, i), ny(e2, e2, i));
    }
  }
  function The(r2) {
    for (var t2 = 0, e2 = 0, n2 = 0, a = r2.length, i = r2[a - 1][0], o = r2[a - 1][1], s = 0; s < a; s++) {
      var u = r2[s][0], l2 = r2[s][1], c2 = i * l2 - u * o;
      t2 += c2, e2 += (i + u) * c2, n2 += (o + l2) * c2, i = u, o = l2;
    }
    return t2 ? [e2 / t2 / 3, n2 / t2 / 3, t2] : [r2[0][0] || 0, r2[0][1] || 0];
  }
  var Hq = function() {
    function r2(t2) {
      this.name = t2;
    }
    return r2.prototype.setCenter = function(t2) {
      this._center = t2;
    }, r2.prototype.getCenter = function() {
      var t2 = this._center;
      return t2 || (t2 = this._center = this.calcCenter()), t2;
    }, r2;
  }(), QV = function() {
    function r2(t2, e2) {
      this.type = "polygon", this.exterior = t2, this.interiors = e2;
    }
    return r2;
  }(), ej = function() {
    function r2(t2) {
      this.type = "linestring", this.points = t2;
    }
    return r2;
  }(), qq = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this, e2) || this;
      return i.type = "geoJSON", i.geometries = n2, i._center = a && [a[0], a[1]], i;
    }
    return t2.prototype.calcCenter = function() {
      for (var e2 = this.geometries, n2, a = 0, i = 0; i < e2.length; i++) {
        var o = e2[i], s = o.exterior, u = s && s.length;
        u > a && (n2 = o, a = u);
      }
      if (n2)
        return The(n2.exterior);
      var l2 = this.getBoundingRect();
      return [l2.x + l2.width / 2, l2.y + l2.height / 2];
    }, t2.prototype.getBoundingRect = function(e2) {
      var n2 = this._rect;
      if (n2 && !e2)
        return n2;
      var a = [1 / 0, 1 / 0], i = [-1 / 0, -1 / 0], o = this.geometries;
      return ae(o, function(s) {
        s.type === "polygon" ? JV(s.exterior, a, i, e2) : ae(s.points, function(u) {
          JV(u, a, i, e2);
        });
      }), isFinite(a[0]) && isFinite(a[1]) && isFinite(i[0]) && isFinite(i[1]) || (a[0] = a[1] = i[0] = i[1] = 0), n2 = new da(a[0], a[1], i[0] - a[0], i[1] - a[1]), e2 || (this._rect = n2), n2;
    }, t2.prototype.contain = function(e2) {
      var n2 = this.getBoundingRect(), a = this.geometries;
      if (!n2.contain(e2[0], e2[1]))
        return false;
      e:
        for (var i = 0, o = a.length; i < o; i++) {
          var s = a[i];
          if (s.type === "polygon") {
            var u = s.exterior, l2 = s.interiors;
            if (kb(u, e2[0], e2[1])) {
              for (var c2 = 0; c2 < (l2 ? l2.length : 0); c2++)
                if (kb(l2[c2], e2[0], e2[1]))
                  continue e;
              return true;
            }
          }
        }
      return false;
    }, t2.prototype.transformTo = function(e2, n2, a, i) {
      var o = this.getBoundingRect(), s = o.width / o.height;
      a ? i || (i = a / s) : a = s * i;
      for (var u = new da(e2, n2, a, i), l2 = o.calculateTransform(u), c2 = this.geometries, f2 = 0; f2 < c2.length; f2++) {
        var h = c2[f2];
        h.type === "polygon" ? (rk(h.exterior, l2), ae(h.interiors, function(v9) {
          rk(v9, l2);
        })) : ae(h.points, function(v9) {
          rk(v9, l2);
        });
      }
      o = this._rect, o.copy(u), this._center = [o.x + o.width / 2, o.y + o.height / 2];
    }, t2.prototype.cloneShallow = function(e2) {
      e2 == null && (e2 = this.name);
      var n2 = new t2(e2, this.geometries, this._center);
      return n2._rect = this._rect, n2.transformTo = null, n2;
    }, t2;
  }(Hq), Mhe = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      var a = r2.call(this, e2) || this;
      return a.type = "geoSVG", a._elOnlyForCalculate = n2, a;
    }
    return t2.prototype.calcCenter = function() {
      for (var e2 = this._elOnlyForCalculate, n2 = e2.getBoundingRect(), a = [n2.x + n2.width / 2, n2.y + n2.height / 2], i = HP(Ahe), o = e2; o && !o.isGeoSVGGraphicRoot; )
        Sg(i, o.getLocalTransform(), i), o = o.parent;
      return fw(i, i), Nl(a, a, i), a;
    }, t2;
  }(Hq);
  function Phe(r2) {
    if (!r2.UTF8Encoding)
      return r2;
    var t2 = r2, e2 = t2.UTF8Scale;
    e2 == null && (e2 = 1024);
    var n2 = t2.features;
    return ae(n2, function(a) {
      var i = a.geometry, o = i.encodeOffsets, s = i.coordinates;
      if (!!o)
        switch (i.type) {
          case "LineString":
            i.coordinates = Yq(s, o, e2);
            break;
          case "Polygon":
            nk(s, o, e2);
            break;
          case "MultiLineString":
            nk(s, o, e2);
            break;
          case "MultiPolygon":
            ae(s, function(u, l2) {
              return nk(u, o[l2], e2);
            });
        }
    }), t2.UTF8Encoding = false, t2;
  }
  function nk(r2, t2, e2) {
    for (var n2 = 0; n2 < r2.length; n2++)
      r2[n2] = Yq(r2[n2], t2[n2], e2);
  }
  function Yq(r2, t2, e2) {
    for (var n2 = [], a = t2[0], i = t2[1], o = 0; o < r2.length; o += 2) {
      var s = r2.charCodeAt(o) - 64, u = r2.charCodeAt(o + 1) - 64;
      s = s >> 1 ^ -(s & 1), u = u >> 1 ^ -(u & 1), s += a, u += i, a = s, i = u, n2.push([s / e2, u / e2]);
    }
    return n2;
  }
  function Dhe(r2, t2) {
    return r2 = Phe(r2), pr(no(r2.features, function(e2) {
      return e2.geometry && e2.properties && e2.geometry.coordinates.length > 0;
    }), function(e2) {
      var n2 = e2.properties, a = e2.geometry, i = [];
      switch (a.type) {
        case "Polygon":
          var o = a.coordinates;
          i.push(new QV(o[0], o.slice(1)));
          break;
        case "MultiPolygon":
          ae(a.coordinates, function(u) {
            u[0] && i.push(new QV(u[0], u.slice(1)));
          });
          break;
        case "LineString":
          i.push(new ej([a.coordinates]));
          break;
        case "MultiLineString":
          i.push(new ej(a.coordinates));
      }
      var s = new qq(n2[t2 || "name"], i, n2.cp);
      return s.properties = n2, s;
    });
  }
  var vE = fi();
  function Ihe(r2) {
    return r2.type === "category" ? Ohe(r2) : Rhe(r2);
  }
  function Lhe(r2, t2) {
    return r2.type === "category" ? khe(r2, t2) : { ticks: pr(r2.scale.getTicks(), function(e2) {
      return e2.value;
    }) };
  }
  function Ohe(r2) {
    var t2 = r2.getLabelModel(), e2 = Kq(r2, t2);
    return !t2.get("show") || r2.scale.isBlank() ? { labels: [], labelCategoryInterval: e2.labelCategoryInterval } : e2;
  }
  function Kq(r2, t2) {
    var e2 = Zq(r2, "labels"), n2 = FF(t2), a = Xq(e2, n2);
    if (a)
      return a;
    var i, o;
    return xn(n2) ? i = eY(r2, n2) : (o = n2 === "auto" ? Fhe(r2) : n2, i = Qq(r2, o)), Jq(e2, n2, { labels: i, labelCategoryInterval: o });
  }
  function khe(r2, t2) {
    var e2 = Zq(r2, "ticks"), n2 = FF(t2), a = Xq(e2, n2);
    if (a)
      return a;
    var i, o;
    if ((!t2.get("show") || r2.scale.isBlank()) && (i = []), xn(n2))
      i = eY(r2, n2, true);
    else if (n2 === "auto") {
      var s = Kq(r2, r2.getLabelModel());
      o = s.labelCategoryInterval, i = pr(s.labels, function(u) {
        return u.tickValue;
      });
    } else
      o = n2, i = Qq(r2, o, true);
    return Jq(e2, n2, { ticks: i, tickCategoryInterval: o });
  }
  function Rhe(r2) {
    var t2 = r2.scale.getTicks(), e2 = BE(r2);
    return { labels: pr(t2, function(n2, a) {
      return { level: n2.level, formattedLabel: e2(n2, a), rawLabel: r2.scale.getLabel(n2), tickValue: n2.value };
    }) };
  }
  function Zq(r2, t2) {
    return vE(r2)[t2] || (vE(r2)[t2] = []);
  }
  function Xq(r2, t2) {
    for (var e2 = 0; e2 < r2.length; e2++)
      if (r2[e2].key === t2)
        return r2[e2].value;
  }
  function Jq(r2, t2, e2) {
    return r2.push({ key: t2, value: e2 }), e2;
  }
  function Fhe(r2) {
    var t2 = vE(r2).autoInterval;
    return t2 != null ? t2 : vE(r2).autoInterval = r2.calculateCategoryInterval();
  }
  function Nhe(r2) {
    var t2 = Vhe(r2), e2 = BE(r2), n2 = (t2.axisRotate - t2.labelRotate) / 180 * Math.PI, a = r2.scale, i = a.getExtent(), o = a.count();
    if (i[1] - i[0] < 1)
      return 0;
    var s = 1;
    o > 40 && (s = Math.max(1, Math.floor(o / 40)));
    for (var u = i[0], l2 = r2.dataToCoord(u + 1) - r2.dataToCoord(u), c2 = Math.abs(l2 * Math.cos(n2)), f2 = Math.abs(l2 * Math.sin(n2)), h = 0, v9 = 0; u <= i[1]; u += s) {
      var d2 = 0, m2 = 0, b2 = PE(e2({ value: u }), t2.font, "center", "top");
      d2 = b2.width * 1.3, m2 = b2.height * 1.3, h = Math.max(h, d2, 7), v9 = Math.max(v9, m2, 7);
    }
    var _ = h / c2, C = v9 / f2;
    isNaN(_) && (_ = 1 / 0), isNaN(C) && (C = 1 / 0);
    var M = Math.max(0, Math.floor(Math.min(_, C))), E = vE(r2.model), z9 = r2.getExtent(), V = E.lastAutoInterval, $ = E.lastTickCount;
    return V != null && $ != null && Math.abs(V - M) <= 1 && Math.abs($ - o) <= 1 && V > M && E.axisExtent0 === z9[0] && E.axisExtent1 === z9[1] ? M = V : (E.lastTickCount = o, E.lastAutoInterval = M, E.axisExtent0 = z9[0], E.axisExtent1 = z9[1]), M;
  }
  function Vhe(r2) {
    var t2 = r2.getLabelModel();
    return { axisRotate: r2.getRotate ? r2.getRotate() : r2.isHorizontal && !r2.isHorizontal() ? 90 : 0, labelRotate: t2.get("rotate") || 0, font: t2.getFont() };
  }
  function Qq(r2, t2, e2) {
    var n2 = BE(r2), a = r2.scale, i = a.getExtent(), o = r2.getLabelModel(), s = [], u = Math.max((t2 || 0) + 1, 1), l2 = i[0], c2 = a.count();
    l2 !== 0 && u > 1 && c2 / u > 2 && (l2 = Math.round(Math.ceil(l2 / u) * u));
    var f2 = Uq(r2), h = o.get("showMinLabel") || f2, v9 = o.get("showMaxLabel") || f2;
    h && l2 !== i[0] && m2(i[0]);
    for (var d2 = l2; d2 <= i[1]; d2 += u)
      m2(d2);
    v9 && d2 - u !== i[1] && m2(i[1]);
    function m2(b2) {
      var _ = { value: b2 };
      s.push(e2 ? b2 : { formattedLabel: n2(_), rawLabel: a.getLabel(_), tickValue: b2 });
    }
    return s;
  }
  function eY(r2, t2, e2) {
    var n2 = r2.scale, a = BE(r2), i = [];
    return ae(n2.getTicks(), function(o) {
      var s = n2.getLabel(o), u = o.value;
      t2(o.value, s) && i.push(e2 ? u : { formattedLabel: a(o), rawLabel: s, tickValue: u });
    }), i;
  }
  var tj = [0, 1], jhe = function() {
    function r2(t2, e2, n2) {
      this.onBand = false, this.inverse = false, this.dim = t2, this.scale = e2, this._extent = n2 || [0, 0];
    }
    return r2.prototype.contain = function(t2) {
      var e2 = this._extent, n2 = Math.min(e2[0], e2[1]), a = Math.max(e2[0], e2[1]);
      return t2 >= n2 && t2 <= a;
    }, r2.prototype.containData = function(t2) {
      return this.scale.contain(t2);
    }, r2.prototype.getExtent = function() {
      return this._extent.slice();
    }, r2.prototype.getPixelPrecision = function(t2) {
      return FW(t2 || this.scale.getExtent(), this._extent);
    }, r2.prototype.setExtent = function(t2, e2) {
      var n2 = this._extent;
      n2[0] = t2, n2[1] = e2;
    }, r2.prototype.dataToCoord = function(t2, e2) {
      var n2 = this._extent, a = this.scale;
      return t2 = a.normalize(t2), this.onBand && a.type === "ordinal" && (n2 = n2.slice(), rj(n2, a.count())), Gi(t2, tj, n2, e2);
    }, r2.prototype.coordToData = function(t2, e2) {
      var n2 = this._extent, a = this.scale;
      this.onBand && a.type === "ordinal" && (n2 = n2.slice(), rj(n2, a.count()));
      var i = Gi(t2, n2, tj, e2);
      return this.scale.scale(i);
    }, r2.prototype.pointToData = function(t2, e2) {
    }, r2.prototype.getTicksCoords = function(t2) {
      t2 = t2 || {};
      var e2 = t2.tickModel || this.getTickModel(), n2 = Lhe(this, e2), a = n2.ticks, i = pr(a, function(s) {
        return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(s) : s), tickValue: s };
      }, this), o = e2.get("alignWithLabel");
      return Bhe(this, i, o, t2.clamp), i;
    }, r2.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var t2 = this.model.getModel("minorTick"), e2 = t2.get("splitNumber");
      e2 > 0 && e2 < 100 || (e2 = 5);
      var n2 = this.scale.getMinorTicks(e2), a = pr(n2, function(i) {
        return pr(i, function(o) {
          return { coord: this.dataToCoord(o), tickValue: o };
        }, this);
      }, this);
      return a;
    }, r2.prototype.getViewLabels = function() {
      return Ihe(this).labels;
    }, r2.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, r2.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, r2.prototype.getBandWidth = function() {
      var t2 = this._extent, e2 = this.scale.getExtent(), n2 = e2[1] - e2[0] + (this.onBand ? 1 : 0);
      n2 === 0 && (n2 = 1);
      var a = Math.abs(t2[1] - t2[0]);
      return Math.abs(a) / n2;
    }, r2.prototype.calculateCategoryInterval = function() {
      return Nhe(this);
    }, r2;
  }();
  function rj(r2, t2) {
    var e2 = r2[1] - r2[0], n2 = t2, a = e2 / n2 / 2;
    r2[0] += a, r2[1] -= a;
  }
  function Bhe(r2, t2, e2, n2) {
    var a = t2.length;
    if (!r2.onBand || e2 || !a)
      return;
    var i = r2.getExtent(), o, s;
    if (a === 1)
      t2[0].coord = i[0], o = t2[1] = { coord: i[0] };
    else {
      var u = t2[a - 1].tickValue - t2[0].tickValue, l2 = (t2[a - 1].coord - t2[0].coord) / u;
      ae(t2, function(v9) {
        v9.coord -= l2 / 2;
      });
      var c2 = r2.scale.getExtent();
      s = 1 + c2[1] - t2[a - 1].tickValue, o = { coord: t2[a - 1].coord + l2 * s }, t2.push(o);
    }
    var f2 = i[0] > i[1];
    h(t2[0].coord, i[0]) && (n2 ? t2[0].coord = i[0] : t2.shift()), n2 && h(i[0], t2[0].coord) && t2.unshift({ coord: i[0] }), h(i[1], o.coord) && (n2 ? o.coord = i[1] : t2.pop()), n2 && h(o.coord, i[1]) && t2.push({ coord: i[1] });
    function h(v9, d2) {
      return v9 = Os(v9), d2 = Os(d2), f2 ? v9 > d2 : v9 < d2;
    }
  }
  var Hv = jhe, aC = Math.PI * 2, xb = np.CMD, zhe = ["top", "right", "bottom", "left"];
  function $he(r2, t2, e2, n2, a) {
    var i = e2.width, o = e2.height;
    switch (r2) {
      case "top":
        n2.set(e2.x + i / 2, e2.y - t2), a.set(0, -1);
        break;
      case "bottom":
        n2.set(e2.x + i / 2, e2.y + o + t2), a.set(0, 1);
        break;
      case "left":
        n2.set(e2.x - t2, e2.y + o / 2), a.set(-1, 0);
        break;
      case "right":
        n2.set(e2.x + i + t2, e2.y + o / 2), a.set(1, 0);
        break;
    }
  }
  function Ghe(r2, t2, e2, n2, a, i, o, s, u) {
    o -= r2, s -= t2;
    var l2 = Math.sqrt(o * o + s * s);
    o /= l2, s /= l2;
    var c2 = o * e2 + r2, f2 = s * e2 + t2;
    if (Math.abs(n2 - a) % aC < 1e-4)
      return u[0] = c2, u[1] = f2, l2 - e2;
    if (i) {
      var h = n2;
      n2 = sy(a), a = sy(h);
    } else
      n2 = sy(n2), a = sy(a);
    n2 > a && (a += aC);
    var v9 = Math.atan2(s, o);
    if (v9 < 0 && (v9 += aC), v9 >= n2 && v9 <= a || v9 + aC >= n2 && v9 + aC <= a)
      return u[0] = c2, u[1] = f2, l2 - e2;
    var d2 = e2 * Math.cos(n2) + r2, m2 = e2 * Math.sin(n2) + t2, b2 = e2 * Math.cos(a) + r2, _ = e2 * Math.sin(a) + t2, C = (d2 - o) * (d2 - o) + (m2 - s) * (m2 - s), M = (b2 - o) * (b2 - o) + (_ - s) * (_ - s);
    return C < M ? (u[0] = d2, u[1] = m2, Math.sqrt(C)) : (u[0] = b2, u[1] = _, Math.sqrt(M));
  }
  function pP(r2, t2, e2, n2, a, i, o, s) {
    var u = a - r2, l2 = i - t2, c2 = e2 - r2, f2 = n2 - t2, h = Math.sqrt(c2 * c2 + f2 * f2);
    c2 /= h, f2 /= h;
    var v9 = u * c2 + l2 * f2, d2 = v9 / h;
    s && (d2 = Math.min(Math.max(d2, 0), 1)), d2 *= h;
    var m2 = o[0] = r2 + d2 * c2, b2 = o[1] = t2 + d2 * f2;
    return Math.sqrt((m2 - a) * (m2 - a) + (b2 - i) * (b2 - i));
  }
  function tY(r2, t2, e2, n2, a, i, o) {
    e2 < 0 && (r2 = r2 + e2, e2 = -e2), n2 < 0 && (t2 = t2 + n2, n2 = -n2);
    var s = r2 + e2, u = t2 + n2, l2 = o[0] = Math.min(Math.max(a, r2), s), c2 = o[1] = Math.min(Math.max(i, t2), u);
    return Math.sqrt((l2 - a) * (l2 - a) + (c2 - i) * (c2 - i));
  }
  var Vv = [];
  function Whe(r2, t2, e2) {
    var n2 = tY(t2.x, t2.y, t2.width, t2.height, r2.x, r2.y, Vv);
    return e2.set(Vv[0], Vv[1]), n2;
  }
  function Uhe(r2, t2, e2) {
    for (var n2 = 0, a = 0, i = 0, o = 0, s, u, l2 = 1 / 0, c2 = t2.data, f2 = r2.x, h = r2.y, v9 = 0; v9 < c2.length; ) {
      var d2 = c2[v9++];
      v9 === 1 && (n2 = c2[v9], a = c2[v9 + 1], i = n2, o = a);
      var m2 = l2;
      switch (d2) {
        case xb.M:
          i = c2[v9++], o = c2[v9++], n2 = i, a = o;
          break;
        case xb.L:
          m2 = pP(n2, a, c2[v9], c2[v9 + 1], f2, h, Vv, true), n2 = c2[v9++], a = c2[v9++];
          break;
        case xb.C:
          m2 = yW(n2, a, c2[v9++], c2[v9++], c2[v9++], c2[v9++], c2[v9], c2[v9 + 1], f2, h, Vv), n2 = c2[v9++], a = c2[v9++];
          break;
        case xb.Q:
          m2 = bW(n2, a, c2[v9++], c2[v9++], c2[v9], c2[v9 + 1], f2, h, Vv), n2 = c2[v9++], a = c2[v9++];
          break;
        case xb.A:
          var b2 = c2[v9++], _ = c2[v9++], C = c2[v9++], M = c2[v9++], E = c2[v9++], z9 = c2[v9++];
          v9 += 1;
          var V = !!(1 - c2[v9++]);
          s = Math.cos(E) * C + b2, u = Math.sin(E) * M + _, v9 <= 1 && (i = s, o = u);
          var $ = (f2 - b2) * M / C + b2;
          m2 = Ghe(b2, _, M, E, E + z9, V, $, h, Vv), n2 = Math.cos(E + z9) * C + b2, a = Math.sin(E + z9) * M + _;
          break;
        case xb.R:
          i = n2 = c2[v9++], o = a = c2[v9++];
          var U = c2[v9++], H = c2[v9++];
          m2 = tY(i, o, U, H, f2, h, Vv);
          break;
        case xb.Z:
          m2 = pP(n2, a, i, o, f2, h, Vv, true), n2 = i, a = o;
          break;
      }
      m2 < l2 && (l2 = m2, e2.set(Vv[0], Vv[1]));
    }
    return l2;
  }
  var Bv = new Jn(), Ao = new Jn(), Us = new Jn(), Yd = new Jn(), Wd = new Jn();
  function nj(r2, t2) {
    if (!!r2) {
      var e2 = r2.getTextGuideLine(), n2 = r2.getTextContent();
      if (!!(n2 && e2)) {
        var a = r2.textGuideLineConfig || {}, i = [[0, 0], [0, 0], [0, 0]], o = a.candidates || zhe, s = n2.getBoundingRect().clone();
        s.applyTransform(n2.getComputedTransform());
        var u = 1 / 0, l2 = a.anchor, c2 = r2.getComputedTransform(), f2 = c2 && fw([], c2), h = t2.get("length2") || 0;
        l2 && Us.copy(l2);
        for (var v9 = 0; v9 < o.length; v9++) {
          var d2 = o[v9];
          $he(d2, 0, s, Bv, Yd), Jn.scaleAndAdd(Ao, Bv, Yd, h), Ao.transform(f2);
          var m2 = r2.getBoundingRect(), b2 = l2 ? l2.distance(Ao) : r2 instanceof xa ? Uhe(Ao, r2.path, Us) : Whe(Ao, m2, Us);
          b2 < u && (u = b2, Ao.transform(c2), Us.transform(c2), Us.toArray(i[0]), Ao.toArray(i[1]), Bv.toArray(i[2]));
        }
        rY(i, t2.get("minTurnAngle")), e2.setShape({ points: i });
      }
    }
  }
  var gP = [], kc = new Jn();
  function rY(r2, t2) {
    if (t2 <= 180 && t2 > 0) {
      t2 = t2 / 180 * Math.PI, Bv.fromArray(r2[0]), Ao.fromArray(r2[1]), Us.fromArray(r2[2]), Jn.sub(Yd, Bv, Ao), Jn.sub(Wd, Us, Ao);
      var e2 = Yd.len(), n2 = Wd.len();
      if (!(e2 < 1e-3 || n2 < 1e-3)) {
        Yd.scale(1 / e2), Wd.scale(1 / n2);
        var a = Yd.dot(Wd), i = Math.cos(t2);
        if (i < a) {
          var o = pP(Ao.x, Ao.y, Us.x, Us.y, Bv.x, Bv.y, gP, false);
          kc.fromArray(gP), kc.scaleAndAdd(Wd, o / Math.tan(Math.PI - t2));
          var s = Us.x !== Ao.x ? (kc.x - Ao.x) / (Us.x - Ao.x) : (kc.y - Ao.y) / (Us.y - Ao.y);
          if (isNaN(s))
            return;
          s < 0 ? Jn.copy(kc, Ao) : s > 1 && Jn.copy(kc, Us), kc.toArray(r2[1]);
        }
      }
    }
  }
  function Hhe(r2, t2, e2) {
    if (e2 <= 180 && e2 > 0) {
      e2 = e2 / 180 * Math.PI, Bv.fromArray(r2[0]), Ao.fromArray(r2[1]), Us.fromArray(r2[2]), Jn.sub(Yd, Ao, Bv), Jn.sub(Wd, Us, Ao);
      var n2 = Yd.len(), a = Wd.len();
      if (!(n2 < 1e-3 || a < 1e-3)) {
        Yd.scale(1 / n2), Wd.scale(1 / a);
        var i = Yd.dot(t2), o = Math.cos(e2);
        if (i < o) {
          var s = pP(Ao.x, Ao.y, Us.x, Us.y, Bv.x, Bv.y, gP, false);
          kc.fromArray(gP);
          var u = Math.PI / 2, l2 = Math.acos(Wd.dot(t2)), c2 = u + l2 - e2;
          if (c2 >= u)
            Jn.copy(kc, Us);
          else {
            kc.scaleAndAdd(Wd, s / Math.tan(Math.PI / 2 - c2));
            var f2 = Us.x !== Ao.x ? (kc.x - Ao.x) / (Us.x - Ao.x) : (kc.y - Ao.y) / (Us.y - Ao.y);
            if (isNaN(f2))
              return;
            f2 < 0 ? Jn.copy(kc, Ao) : f2 > 1 && Jn.copy(kc, Us);
          }
          kc.toArray(r2[1]);
        }
      }
    }
  }
  function aj(r2, t2, e2, n2) {
    var a = e2 === "normal", i = a ? r2 : r2.ensureState(e2);
    i.ignore = t2;
    var o = n2.get("smooth");
    o && o === true && (o = 0.3), i.shape = i.shape || {}, o > 0 && (i.shape.smooth = o);
    var s = n2.getModel("lineStyle").getLineStyle();
    a ? r2.useStyle(s) : i.style = s;
  }
  function qhe(r2, t2) {
    var e2 = t2.smooth, n2 = t2.points;
    if (!!n2)
      if (r2.moveTo(n2[0][0], n2[0][1]), e2 > 0 && n2.length >= 3) {
        var a = ty(n2[0], n2[1]), i = ty(n2[1], n2[2]);
        if (!a || !i) {
          r2.lineTo(n2[1][0], n2[1][1]), r2.lineTo(n2[2][0], n2[2][1]);
          return;
        }
        var o = Math.min(a, i) * e2, s = w5([], n2[1], n2[0], o / a), u = w5([], n2[1], n2[2], o / i), l2 = w5([], s, u, 0.5);
        r2.bezierCurveTo(s[0], s[1], s[0], s[1], l2[0], l2[1]), r2.bezierCurveTo(u[0], u[1], u[0], u[1], n2[2][0], n2[2][1]);
      } else
        for (var c2 = 1; c2 < n2.length; c2++)
          r2.lineTo(n2[c2][0], n2[c2][1]);
  }
  function NF(r2, t2, e2) {
    var n2 = r2.getTextGuideLine(), a = r2.getTextContent();
    if (!a) {
      n2 && r2.removeTextGuideLine();
      return;
    }
    for (var i = t2.normal, o = i.get("show"), s = a.ignore, u = 0; u < rE.length; u++) {
      var l2 = rE[u], c2 = t2[l2], f2 = l2 === "normal";
      if (c2) {
        var h = c2.get("show"), v9 = f2 ? s : ia(a.states[l2] && a.states[l2].ignore, s);
        if (v9 || !ia(h, o)) {
          var d2 = f2 ? n2 : n2 && n2.states.normal;
          d2 && (d2.ignore = true);
          continue;
        }
        n2 || (n2 = new yf(), r2.setTextGuideLine(n2), !f2 && (s || !o) && aj(n2, true, "normal", t2.normal), r2.stateProxy && (n2.stateProxy = r2.stateProxy)), aj(n2, false, l2, c2);
      }
    }
    if (n2) {
      En(n2.style, e2), n2.style.fill = null;
      var m2 = i.get("showAbove"), b2 = r2.textGuideLineConfig = r2.textGuideLineConfig || {};
      b2.showAbove = m2 || false, n2.buildPath = qhe;
    }
  }
  function VF(r2, t2) {
    t2 = t2 || "labelLine";
    for (var e2 = { normal: r2.getModel(t2) }, n2 = 0; n2 < Nc.length; n2++) {
      var a = Nc[n2];
      e2[a] = r2.getModel([a, t2]);
    }
    return e2;
  }
  function nY(r2) {
    for (var t2 = [], e2 = 0; e2 < r2.length; e2++) {
      var n2 = r2[e2];
      if (!n2.defaultAttr.ignore) {
        var a = n2.label, i = a.getComputedTransform(), o = a.getBoundingRect(), s = !i || i[1] < 1e-5 && i[2] < 1e-5, u = a.style.margin || 0, l2 = o.clone();
        l2.applyTransform(i), l2.x -= u / 2, l2.y -= u / 2, l2.width += u, l2.height += u;
        var c2 = s ? new eP(o, i) : null;
        t2.push({ label: a, labelLine: n2.labelLine, rect: l2, localRect: o, obb: c2, priority: n2.priority, defaultAttr: n2.defaultAttr, layoutOption: n2.computedLayoutOption, axisAligned: s, transform: i });
      }
    }
    return t2;
  }
  function aY(r2, t2, e2, n2, a, i) {
    var o = r2.length;
    if (o < 2)
      return;
    r2.sort(function(U, H) {
      return U.rect[t2] - H.rect[t2];
    });
    for (var s = 0, u, l2 = false, c2 = 0, f2 = 0; f2 < o; f2++) {
      var h = r2[f2], v9 = h.rect;
      u = v9[t2] - s, u < 0 && (v9[t2] -= u, h.label[t2] -= u, l2 = true);
      var d2 = Math.max(-u, 0);
      c2 += d2, s = v9[t2] + v9[e2];
    }
    c2 > 0 && i && z9(-c2 / o, 0, o);
    var m2 = r2[0], b2 = r2[o - 1], _, C;
    M(), _ < 0 && V(-_, 0.8), C < 0 && V(C, 0.8), M(), E(_, C, 1), E(C, _, -1), M(), _ < 0 && $(-_), C < 0 && $(C);
    function M() {
      _ = m2.rect[t2] - n2, C = a - b2.rect[t2] - b2.rect[e2];
    }
    function E(U, H, q3) {
      if (U < 0) {
        var ee = Math.min(H, -U);
        if (ee > 0) {
          z9(ee * q3, 0, o);
          var oe = ee + U;
          oe < 0 && V(-oe * q3, 1);
        } else
          V(-U * q3, 1);
      }
    }
    function z9(U, H, q3) {
      U !== 0 && (l2 = true);
      for (var ee = H; ee < q3; ee++) {
        var oe = r2[ee], ne = oe.rect;
        ne[t2] += U, oe.label[t2] += U;
      }
    }
    function V(U, H) {
      for (var q3 = [], ee = 0, oe = 1; oe < o; oe++) {
        var ne = r2[oe - 1].rect, be = Math.max(r2[oe].rect[t2] - ne[t2] - ne[e2], 0);
        q3.push(be), ee += be;
      }
      if (!!ee) {
        var Ee = Math.min(Math.abs(U) / ee, H);
        if (U > 0)
          for (var oe = 0; oe < o - 1; oe++) {
            var ye = q3[oe] * Ee;
            z9(ye, 0, oe + 1);
          }
        else
          for (var oe = o - 1; oe > 0; oe--) {
            var ye = q3[oe - 1] * Ee;
            z9(-ye, oe, o);
          }
      }
    }
    function $(U) {
      var H = U < 0 ? -1 : 1;
      U = Math.abs(U);
      for (var q3 = Math.ceil(U / (o - 1)), ee = 0; ee < o - 1; ee++)
        if (H > 0 ? z9(q3, 0, ee + 1) : z9(-q3, o - ee - 1, o), U -= q3, U <= 0)
          return;
    }
    return l2;
  }
  function Yhe(r2, t2, e2, n2) {
    return aY(r2, "x", "width", t2, e2, n2);
  }
  function iY(r2, t2, e2, n2) {
    return aY(r2, "y", "height", t2, e2, n2);
  }
  function oY(r2) {
    var t2 = [];
    r2.sort(function(m2, b2) {
      return b2.priority - m2.priority;
    });
    var e2 = new da(0, 0, 0, 0);
    function n2(m2) {
      if (!m2.ignore) {
        var b2 = m2.ensureState("emphasis");
        b2.ignore == null && (b2.ignore = false);
      }
      m2.ignore = true;
    }
    for (var a = 0; a < r2.length; a++) {
      var i = r2[a], o = i.axisAligned, s = i.localRect, u = i.transform, l2 = i.label, c2 = i.labelLine;
      e2.copy(i.rect), e2.width -= 0.1, e2.height -= 0.1, e2.x += 0.05, e2.y += 0.05;
      for (var f2 = i.obb, h = false, v9 = 0; v9 < t2.length; v9++) {
        var d2 = t2[v9];
        if (!!e2.intersect(d2.rect)) {
          if (o && d2.axisAligned) {
            h = true;
            break;
          }
          if (d2.obb || (d2.obb = new eP(d2.localRect, d2.transform)), f2 || (f2 = new eP(s, u)), f2.intersect(d2.obb)) {
            h = true;
            break;
          }
        }
      }
      h ? (n2(l2), c2 && n2(c2)) : (l2.attr("ignore", i.defaultAttr.ignore), c2 && c2.attr("ignore", i.defaultAttr.labelGuideIgnore), t2.push(i));
    }
  }
  function Khe(r2) {
    if (r2) {
      for (var t2 = [], e2 = 0; e2 < r2.length; e2++)
        t2.push(r2[e2].slice());
      return t2;
    }
  }
  function Zhe(r2, t2) {
    var e2 = r2.label, n2 = t2 && t2.getTextGuideLine();
    return { dataIndex: r2.dataIndex, dataType: r2.dataType, seriesIndex: r2.seriesModel.seriesIndex, text: r2.label.style.text, rect: r2.hostRect, labelRect: r2.rect, align: e2.style.align, verticalAlign: e2.style.verticalAlign, labelLinePoints: Khe(n2 && n2.shape.points) };
  }
  var ij = ["align", "verticalAlign", "width", "height", "fontSize"], Gf = new mg(), ak = fi(), Xhe = fi();
  function UM(r2, t2, e2) {
    for (var n2 = 0; n2 < e2.length; n2++) {
      var a = e2[n2];
      t2[a] != null && (r2[a] = t2[a]);
    }
  }
  var HM = ["x", "y", "rotation"], Jhe = function() {
    function r2() {
      this._labelList = [], this._chartViewList = [];
    }
    return r2.prototype.clearLabels = function() {
      this._labelList = [], this._chartViewList = [];
    }, r2.prototype._addLabel = function(t2, e2, n2, a, i) {
      var o = a.style, s = a.__hostTarget, u = s.textConfig || {}, l2 = a.getComputedTransform(), c2 = a.getBoundingRect().plain();
      da.applyTransform(c2, c2, l2), l2 ? Gf.setLocalTransform(l2) : (Gf.x = Gf.y = Gf.rotation = Gf.originX = Gf.originY = 0, Gf.scaleX = Gf.scaleY = 1);
      var f2 = a.__hostTarget, h;
      if (f2) {
        h = f2.getBoundingRect().plain();
        var v9 = f2.getComputedTransform();
        da.applyTransform(h, h, v9);
      }
      var d2 = h && f2.getTextGuideLine();
      this._labelList.push({ label: a, labelLine: d2, seriesModel: n2, dataIndex: t2, dataType: e2, layoutOption: i, computedLayoutOption: null, rect: c2, hostRect: h, priority: h ? h.width * h.height : 0, defaultAttr: { ignore: a.ignore, labelGuideIgnore: d2 && d2.ignore, x: Gf.x, y: Gf.y, scaleX: Gf.scaleX, scaleY: Gf.scaleY, rotation: Gf.rotation, style: { x: o.x, y: o.y, align: o.align, verticalAlign: o.verticalAlign, width: o.width, height: o.height, fontSize: o.fontSize }, cursor: a.cursor, attachedPos: u.position, attachedRot: u.rotation } });
    }, r2.prototype.addLabelsOfSeries = function(t2) {
      var e2 = this;
      this._chartViewList.push(t2);
      var n2 = t2.__model, a = n2.get("labelLayout");
      !(xn(a) || ja(a).length) || t2.group.traverse(function(i) {
        if (i.ignore)
          return true;
        var o = i.getTextContent(), s = zn(i);
        o && !o.disableLabelLayout && e2._addLabel(s.dataIndex, s.dataType, n2, o, a);
      });
    }, r2.prototype.updateLayoutConfig = function(t2) {
      var e2 = t2.getWidth(), n2 = t2.getHeight();
      function a(M, E) {
        return function() {
          nj(M, E);
        };
      }
      for (var i = 0; i < this._labelList.length; i++) {
        var o = this._labelList[i], s = o.label, u = s.__hostTarget, l2 = o.defaultAttr, c2 = void 0;
        xn(o.layoutOption) ? c2 = o.layoutOption(Zhe(o, u)) : c2 = o.layoutOption, c2 = c2 || {}, o.computedLayoutOption = c2;
        var f2 = Math.PI / 180;
        u && u.setTextConfig({ local: false, position: c2.x != null || c2.y != null ? null : l2.attachedPos, rotation: c2.rotate != null ? c2.rotate * f2 : l2.attachedRot, offset: [c2.dx || 0, c2.dy || 0] });
        var h = false;
        if (c2.x != null ? (s.x = qr(c2.x, e2), s.setStyle("x", 0), h = true) : (s.x = l2.x, s.setStyle("x", l2.style.x)), c2.y != null ? (s.y = qr(c2.y, n2), s.setStyle("y", 0), h = true) : (s.y = l2.y, s.setStyle("y", l2.style.y)), c2.labelLinePoints) {
          var v9 = u.getTextGuideLine();
          v9 && (v9.setShape({ points: c2.labelLinePoints }), h = false);
        }
        var d2 = ak(s);
        d2.needsUpdateLabelLine = h, s.rotation = c2.rotate != null ? c2.rotate * f2 : l2.rotation, s.scaleX = l2.scaleX, s.scaleY = l2.scaleY;
        for (var m2 = 0; m2 < ij.length; m2++) {
          var b2 = ij[m2];
          s.setStyle(b2, c2[b2] != null ? c2[b2] : l2.style[b2]);
        }
        if (c2.draggable) {
          if (s.draggable = true, s.cursor = "move", u) {
            var _ = o.seriesModel;
            if (o.dataIndex != null) {
              var C = o.seriesModel.getData(o.dataType);
              _ = C.getItemModel(o.dataIndex);
            }
            s.on("drag", a(u, _.getModel("labelLine")));
          }
        } else
          s.off("drag"), s.cursor = l2.cursor;
      }
    }, r2.prototype.layout = function(t2) {
      var e2 = t2.getWidth(), n2 = t2.getHeight(), a = nY(this._labelList), i = no(a, function(u) {
        return u.layoutOption.moveOverlap === "shiftX";
      }), o = no(a, function(u) {
        return u.layoutOption.moveOverlap === "shiftY";
      });
      Yhe(i, 0, e2), iY(o, 0, n2);
      var s = no(a, function(u) {
        return u.layoutOption.hideOverlap;
      });
      oY(s);
    }, r2.prototype.processLabelsOverall = function() {
      var t2 = this;
      ae(this._chartViewList, function(e2) {
        var n2 = e2.__model, a = e2.ignoreLabelLineUpdate, i = n2.isAnimationEnabled();
        e2.group.traverse(function(o) {
          if (o.ignore && !o.forceLabelAnimation)
            return true;
          var s = !a, u = o.getTextContent();
          !s && u && (s = ak(u).needsUpdateLabelLine), s && t2._updateLabelLine(o, n2), i && t2._animateLabels(o, n2);
        });
      });
    }, r2.prototype._updateLabelLine = function(t2, e2) {
      var n2 = t2.getTextContent(), a = zn(t2), i = a.dataIndex;
      if (n2 && i != null) {
        var o = e2.getData(a.dataType), s = o.getItemModel(i), u = {}, l2 = o.getItemVisual(i, "style"), c2 = o.getVisual("drawType");
        u.stroke = l2[c2];
        var f2 = s.getModel("labelLine");
        NF(t2, VF(s), u), nj(t2, f2);
      }
    }, r2.prototype._animateLabels = function(t2, e2) {
      var n2 = t2.getTextContent(), a = t2.getTextGuideLine();
      if (n2 && (t2.forceLabelAnimation || !n2.ignore && !n2.invisible && !t2.disableLabelAnimation && !Kx(t2))) {
        var i = ak(n2), o = i.oldLayout, s = zn(t2), u = s.dataIndex, l2 = { x: n2.x, y: n2.y, rotation: n2.rotation }, c2 = e2.getData(s.dataType);
        if (o) {
          n2.attr(o);
          var h = t2.prevStates;
          h && (va(h, "select") >= 0 && n2.attr(i.oldLayoutSelect), va(h, "emphasis") >= 0 && n2.attr(i.oldLayoutEmphasis)), ci(n2, l2, e2, u);
        } else if (n2.attr(l2), !gw(n2).valueAnimation) {
          var f2 = ia(n2.style.opacity, 1);
          n2.style.opacity = 0, rs(n2, { style: { opacity: f2 } }, e2, u);
        }
        if (i.oldLayout = l2, n2.states.select) {
          var v9 = i.oldLayoutSelect = {};
          UM(v9, l2, HM), UM(v9, n2.states.select, HM);
        }
        if (n2.states.emphasis) {
          var d2 = i.oldLayoutEmphasis = {};
          UM(d2, l2, HM), UM(d2, n2.states.emphasis, HM);
        }
        HU(n2, u, c2, e2, e2);
      }
      if (a && !a.ignore && !a.invisible) {
        var i = Xhe(a), o = i.oldLayout, m2 = { points: a.shape.points };
        o ? (a.attr({ shape: o }), ci(a, { shape: m2 }, e2)) : (a.setShape(m2), a.style.strokePercent = 0, rs(a, { style: { strokePercent: 1 } }, e2)), i.oldLayout = m2;
      }
    }, r2;
  }(), Qhe = Jhe, ik = fi();
  function eve(r2) {
    r2.registerUpdateLifecycle("series:beforeupdate", function(t2, e2, n2) {
      var a = ik(e2).labelManager;
      a || (a = ik(e2).labelManager = new Qhe()), a.clearLabels();
    }), r2.registerUpdateLifecycle("series:layoutlabels", function(t2, e2, n2) {
      var a = ik(e2).labelManager;
      n2.updatedSeries.forEach(function(i) {
        a.addLabelsOfSeries(e2.getViewOfSeriesModel(i));
      }), a.updateLayoutConfig(e2), a.layout(e2), a.processLabelsOverall();
    });
  }
  var ok = Math.sin, sk = Math.cos, sY = Math.PI, wb = Math.PI * 2, tve = 180 / sY, rve = function() {
    function r2() {
    }
    return r2.prototype.reset = function(t2) {
      this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, t2 || 4);
    }, r2.prototype.moveTo = function(t2, e2) {
      this._add("M", t2, e2);
    }, r2.prototype.lineTo = function(t2, e2) {
      this._add("L", t2, e2);
    }, r2.prototype.bezierCurveTo = function(t2, e2, n2, a, i, o) {
      this._add("C", t2, e2, n2, a, i, o);
    }, r2.prototype.quadraticCurveTo = function(t2, e2, n2, a) {
      this._add("Q", t2, e2, n2, a);
    }, r2.prototype.arc = function(t2, e2, n2, a, i, o) {
      this.ellipse(t2, e2, n2, n2, 0, a, i, o);
    }, r2.prototype.ellipse = function(t2, e2, n2, a, i, o, s, u) {
      var l2 = s - o, c2 = !u, f2 = Math.abs(l2), h = oy(f2 - wb) || (c2 ? l2 >= wb : -l2 >= wb), v9 = l2 > 0 ? l2 % wb : l2 % wb + wb, d2 = false;
      h ? d2 = true : oy(f2) ? d2 = false : d2 = v9 >= sY == !!c2;
      var m2 = t2 + n2 * sk(o), b2 = e2 + a * ok(o);
      this._start && this._add("M", m2, b2);
      var _ = Math.round(i * tve);
      if (h) {
        var C = 1 / this._p, M = (c2 ? 1 : -1) * (wb - C);
        this._add("A", n2, a, _, 1, +c2, t2 + n2 * sk(o + M), e2 + a * ok(o + M)), C > 0.01 && this._add("A", n2, a, _, 0, +c2, m2, b2);
      } else {
        var E = t2 + n2 * sk(s), z9 = e2 + a * ok(s);
        this._add("A", n2, a, _, +d2, +c2, E, z9);
      }
    }, r2.prototype.rect = function(t2, e2, n2, a) {
      this._add("M", t2, e2), this._add("l", n2, 0), this._add("l", 0, a), this._add("l", -n2, 0), this._add("Z");
    }, r2.prototype.closePath = function() {
      this._d.length > 0 && this._add("Z");
    }, r2.prototype._add = function(t2, e2, n2, a, i, o, s, u, l2) {
      for (var c2 = [], f2 = this._p, h = 1; h < arguments.length; h++) {
        var v9 = arguments[h];
        if (isNaN(v9)) {
          this._invalid = true;
          return;
        }
        c2.push(Math.round(v9 * f2) / f2);
      }
      this._d.push(t2 + c2.join(" ")), this._start = t2 === "Z";
    }, r2.prototype.generateStr = function() {
      this._str = this._invalid ? "" : this._d.join(""), this._d = [];
    }, r2.prototype.getStr = function() {
      return this._str;
    }, r2;
  }(), uY = rve, WC = "none", nve = Math.round;
  function ave(r2) {
    var t2 = r2.fill;
    return t2 != null && t2 !== WC;
  }
  function ive(r2) {
    var t2 = r2.stroke;
    return t2 != null && t2 !== WC;
  }
  var P4 = ["lineCap", "miterLimit", "lineJoin"], ove = pr(P4, function(r2) {
    return "stroke-" + r2.toLowerCase();
  });
  function sve(r2, t2, e2, n2) {
    var a = t2.opacity == null ? 1 : t2.opacity;
    if (e2 instanceof Bl) {
      r2("opacity", a);
      return;
    }
    if (ave(t2)) {
      var i = rw(t2.fill);
      r2("fill", i.color);
      var o = t2.fillOpacity != null ? t2.fillOpacity * i.opacity * a : i.opacity * a;
      (n2 || o < 1) && r2("fill-opacity", o);
    } else
      r2("fill", WC);
    if (ive(t2)) {
      var s = rw(t2.stroke);
      r2("stroke", s.color);
      var u = t2.strokeNoScale ? e2.getLineScale() : 1, l2 = u ? (t2.lineWidth || 0) / u : 0, c2 = t2.strokeOpacity != null ? t2.strokeOpacity * s.opacity * a : s.opacity * a, f2 = t2.strokeFirst;
      if ((n2 || l2 !== 1) && r2("stroke-width", l2), (n2 || f2) && r2("paint-order", f2 ? "stroke" : "fill"), (n2 || c2 < 1) && r2("stroke-opacity", c2), t2.lineDash) {
        var h = EF(e2), v9 = h[0], d2 = h[1];
        v9 && (d2 = nve(d2 || 0), r2("stroke-dasharray", v9.join(",")), (d2 || n2) && r2("stroke-dashoffset", d2));
      } else
        n2 && r2("stroke-dasharray", WC);
      for (var m2 = 0; m2 < P4.length; m2++) {
        var b2 = P4[m2];
        if (n2 || t2[b2] !== J5[b2]) {
          var _ = t2[b2] || J5[b2];
          _ && r2(ove[m2], _);
        }
      }
    } else
      n2 && r2("stroke", WC);
  }
  var lY = "http://www.w3.org/2000/svg", cY = "http://www.w3.org/1999/xlink", uve = "http://www.w3.org/2000/xmlns/", lve = "http://www.w3.org/XML/1998/namespace";
  function fY(r2) {
    return document.createElementNS(lY, r2);
  }
  function Uu(r2, t2, e2, n2, a) {
    return { tag: r2, attrs: e2 || {}, children: n2, text: a, key: t2 };
  }
  function cve(r2, t2) {
    var e2 = [];
    if (t2)
      for (var n2 in t2) {
        var a = t2[n2], i = n2;
        a !== false && (a !== true && a != null && (i += '="' + a + '"'), e2.push(i));
      }
    return "<" + r2 + " " + e2.join(" ") + ">";
  }
  function fve(r2) {
    return "</" + r2 + ">";
  }
  function jF(r2, t2) {
    t2 = t2 || {};
    var e2 = t2.newline ? `
` : "";
    function n2(a) {
      var i = a.children, o = a.tag, s = a.attrs;
      return cve(o, s) + (a.text || "") + (i ? "" + e2 + pr(i, function(u) {
        return n2(u);
      }).join(e2) + e2 : "") + fve(o);
    }
    return n2(r2);
  }
  function hve(r2, t2, e2) {
    e2 = e2 || {};
    var n2 = e2.newline ? `
` : "", a = " {" + n2, i = n2 + "}", o = pr(ja(r2), function(u) {
      return u + a + pr(ja(r2[u]), function(l2) {
        return l2 + ":" + r2[u][l2] + ";";
      }).join(n2) + i;
    }).join(n2), s = pr(ja(t2), function(u) {
      return "@keyframes " + u + a + pr(ja(t2[u]), function(l2) {
        return l2 + a + pr(ja(t2[u][l2]), function(c2) {
          var f2 = t2[u][l2][c2];
          return c2 === "d" && (f2 = 'path("' + f2 + '")'), c2 + ":" + f2 + ";";
        }).join(n2) + i;
      }).join(n2) + i;
    }).join(n2);
    return !o && !s ? "" : ["<![CDATA[", o, s, "]]>"].join(n2);
  }
  function D4(r2) {
    return { zrId: r2, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
  }
  function oj(r2, t2, e2, n2) {
    return Uu("svg", "root", { width: r2, height: t2, xmlns: lY, "xmlns:xlink": cY, version: "1.1", baseProfile: "full", viewBox: n2 ? "0 0 " + r2 + " " + t2 : false }, e2);
  }
  var sj = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, Tb = "transform-origin";
  function vve(r2, t2, e2) {
    var n2 = qt({}, r2.shape);
    qt(n2, t2), r2.buildPath(e2, n2);
    var a = new uY();
    return a.reset(EW(r2)), e2.rebuildPath(a, 1), a.generateStr(), a.getStr();
  }
  function dve(r2, t2) {
    var e2 = t2.originX, n2 = t2.originY;
    (e2 || n2) && (r2[Tb] = e2 + "px " + n2 + "px");
  }
  var pve = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
  function hY(r2, t2) {
    var e2 = t2.zrId + "-ani-" + t2.cssAnimIdx++;
    return t2.cssAnims[e2] = r2, e2;
  }
  function gve(r2, t2, e2) {
    var n2 = r2.shape.paths, a = {}, i, o;
    if (ae(n2, function(u) {
      var l2 = D4(e2.zrId);
      l2.animation = true, b3(u, {}, l2, true);
      var c2 = l2.cssAnims, f2 = l2.cssNodes, h = ja(c2), v9 = h.length;
      if (!!v9) {
        o = h[v9 - 1];
        var d2 = c2[o];
        for (var m2 in d2) {
          var b2 = d2[m2];
          a[m2] = a[m2] || { d: "" }, a[m2].d += b2.d || "";
        }
        for (var _ in f2) {
          var C = f2[_].animation;
          C.indexOf(o) >= 0 && (i = C);
        }
      }
    }), !!i) {
      t2.d = false;
      var s = hY(a, e2);
      return i.replace(o, s);
    }
  }
  function uj(r2) {
    return Zr(r2) ? sj[r2] ? "cubic-bezier(" + sj[r2] + ")" : z6(r2) ? r2 : "" : "";
  }
  function b3(r2, t2, e2, n2) {
    var a = r2.animators, i = a.length, o = [];
    if (r2 instanceof aF) {
      var s = gve(r2, t2, e2);
      if (s)
        o.push(s);
      else if (!i)
        return;
    } else if (!i)
      return;
    for (var u = {}, l2 = 0; l2 < i; l2++) {
      var c2 = a[l2], f2 = [c2.getMaxTime() / 1e3 + "s"], h = uj(c2.getClip().easing), v9 = c2.getDelay();
      h ? f2.push(h) : f2.push("linear"), v9 && f2.push(v9 / 1e3 + "s"), c2.getLoop() && f2.push("infinite");
      var d2 = f2.join(" ");
      u[d2] = u[d2] || [d2, []], u[d2][1].push(c2);
    }
    function m2(C) {
      var M = C[1], E = M.length, z9 = {}, V = {}, $ = {}, U = "animation-timing-function";
      function H(Wr, on, un) {
        for (var Xr = Wr.getTracks(), _n = Wr.getMaxTime(), Za = 0; Za < Xr.length; Za++) {
          var Dn = Xr[Za];
          if (Dn.needsAnimate()) {
            var ai = Dn.keyframes, wi = Dn.propName;
            if (un && (wi = un(wi)), wi)
              for (var hi = 0; hi < ai.length; hi++) {
                var qs = ai[hi], jo = Math.round(qs.time / _n * 100) + "%", Au = uj(qs.easing), Zi = qs.rawValue;
                (Zr(Zi) || Ai(Zi)) && (on[jo] = on[jo] || {}, on[jo][wi] = qs.rawValue, Au && (on[jo][U] = Au));
              }
          }
        }
      }
      for (var q3 = 0; q3 < E; q3++) {
        var ee = M[q3], oe = ee.targetName;
        oe ? oe === "shape" && H(ee, V) : !n2 && H(ee, z9);
      }
      for (var ne in z9) {
        var be = {};
        DW(be, r2), qt(be, z9[ne]);
        var Ee = AW(be), ye = z9[ne][U];
        $[ne] = Ee ? { transform: Ee } : {}, dve($[ne], be), ye && ($[ne][U] = ye);
      }
      var et, Le = true;
      for (var ne in V) {
        $[ne] = $[ne] || {};
        var Fe = !et, ye = V[ne][U];
        Fe && (et = new np());
        var qe = et.len();
        et.reset(), $[ne].d = vve(r2, V[ne], et);
        var st = et.len();
        if (!Fe && qe !== st) {
          Le = false;
          break;
        }
        ye && ($[ne][U] = ye);
      }
      if (!Le)
        for (var ne in $)
          delete $[ne].d;
      if (!n2)
        for (var q3 = 0; q3 < E; q3++) {
          var ee = M[q3], oe = ee.targetName;
          oe === "style" && H(ee, $, function(Xr) {
            return pve[Xr];
          });
        }
      for (var dt = ja($), Ar = true, Hr, q3 = 1; q3 < dt.length; q3++) {
        var hn = dt[q3 - 1], cn = dt[q3];
        if ($[hn][Tb] !== $[cn][Tb]) {
          Ar = false;
          break;
        }
        Hr = $[hn][Tb];
      }
      if (Ar && Hr) {
        for (var ne in $)
          $[ne][Tb] && delete $[ne][Tb];
        t2[Tb] = Hr;
      }
      if (no(dt, function(Wr) {
        return ja($[Wr]).length > 0;
      }).length) {
        var nn = hY($, e2);
        return nn + " " + C[0] + " both";
      }
    }
    for (var b2 in u) {
      var s = m2(u[b2]);
      s && o.push(s);
    }
    if (o.length) {
      var _ = e2.zrId + "-cls-" + e2.cssClassIdx++;
      e2.cssNodes["." + _] = { animation: o.join(",") }, t2.class = _;
    }
  }
  var dE = Math.round;
  function vY(r2) {
    return r2 && Zr(r2.src);
  }
  function dY(r2) {
    return r2 && xn(r2.toDataURL);
  }
  function BF(r2, t2, e2, n2) {
    sve(function(a, i) {
      var o = a === "fill" || a === "stroke";
      o && cie(i) ? Cve(t2, r2, a, n2) : o && lie(i) ? Eve(e2, r2, a, n2) : r2[a] = i;
    }, t2, e2, false), Sve(e2, r2, n2);
  }
  function lj(r2) {
    return oy(r2[0] - 1) && oy(r2[1]) && oy(r2[2]) && oy(r2[3] - 1);
  }
  function yve(r2) {
    return oy(r2[4]) && oy(r2[5]);
  }
  function zF(r2, t2, e2) {
    if (t2 && !(yve(t2) && lj(t2))) {
      var n2 = e2 ? 10 : 1e4;
      r2.transform = lj(t2) ? "translate(" + dE(t2[4] * n2) / n2 + " " + dE(t2[5] * n2) / n2 + ")" : nie(t2);
    }
  }
  function cj(r2, t2, e2) {
    for (var n2 = r2.points, a = [], i = 0; i < n2.length; i++)
      a.push(dE(n2[i][0] * e2) / e2), a.push(dE(n2[i][1] * e2) / e2);
    t2.points = a.join(" ");
  }
  function fj(r2) {
    return !r2.smooth;
  }
  function mve(r2) {
    var t2 = pr(r2, function(e2) {
      return typeof e2 == "string" ? [e2, e2] : e2;
    });
    return function(e2, n2, a) {
      for (var i = 0; i < t2.length; i++) {
        var o = t2[i], s = e2[o[0]];
        s != null && (n2[o[1]] = dE(s * a) / a);
      }
    };
  }
  var bve = { circle: [mve(["cx", "cy", "r"])], polyline: [cj, fj], polygon: [cj, fj] };
  function _ve(r2) {
    for (var t2 = r2.animators, e2 = 0; e2 < t2.length; e2++)
      if (t2[e2].targetName === "shape")
        return true;
    return false;
  }
  function pY(r2, t2) {
    var e2 = r2.style, n2 = r2.shape, a = bve[r2.type], i = {}, o = t2.animation, s = "path", u = r2.style.strokePercent, l2 = t2.compress && EW(r2) || 4;
    if (a && !t2.willUpdate && !(a[1] && !a[1](n2)) && !(o && _ve(r2)) && !(u < 1)) {
      s = r2.type;
      var c2 = Math.pow(10, l2);
      a[0](n2, i, c2);
    } else {
      r2.path || r2.createPathProxy();
      var f2 = r2.path;
      r2.shapeChanged() && (f2.beginPath(), r2.buildPath(f2, r2.shape), r2.pathUpdated());
      var h = f2.getVersion(), v9 = r2, d2 = v9.__svgPathBuilder;
      (v9.__svgPathVersion !== h || !d2 || u !== v9.__svgPathStrokePercent) && (d2 || (d2 = v9.__svgPathBuilder = new uY()), d2.reset(l2), f2.rebuildPath(d2, u), d2.generateStr(), v9.__svgPathVersion = h, v9.__svgPathStrokePercent = u), i.d = d2.getStr();
    }
    return zF(i, r2.transform), BF(i, e2, r2, t2), t2.animation && b3(r2, i, t2), Uu(s, r2.id + "", i);
  }
  function xve(r2, t2) {
    var e2 = r2.style, n2 = e2.image;
    if (n2 && !Zr(n2) && (vY(n2) ? n2 = n2.src : dY(n2) && (n2 = n2.toDataURL())), !!n2) {
      var a = e2.x || 0, i = e2.y || 0, o = e2.width, s = e2.height, u = { href: n2, width: o, height: s };
      return a && (u.x = a), i && (u.y = i), zF(u, r2.transform), BF(u, e2, r2, t2), t2.animation && b3(r2, u, t2), Uu("image", r2.id + "", u);
    }
  }
  function wve(r2, t2) {
    var e2 = r2.style, n2 = e2.text;
    if (n2 != null && (n2 += ""), !(!n2 || isNaN(e2.x) || isNaN(e2.y))) {
      var a = e2.font || gy, i = e2.x || 0, o = iie(e2.y || 0, qP(a), e2.textBaseline), s = aie[e2.textAlign] || e2.textAlign, u = { "dominant-baseline": "central", "text-anchor": s };
      if (uU(e2)) {
        var l2 = "", c2 = e2.fontStyle, f2 = sU(e2.fontSize);
        if (!parseFloat(f2))
          return;
        var h = e2.fontFamily || tW, v9 = e2.fontWeight;
        l2 += "font-size:" + f2 + ";font-family:" + h + ";", c2 && c2 !== "normal" && (l2 += "font-style:" + c2 + ";"), v9 && v9 !== "normal" && (l2 += "font-weight:" + v9 + ";"), u.style = l2;
      } else
        u.style = "font: " + a;
      return n2.match(/\s/) && (u["xml:space"] = "preserve"), i && (u.x = i), o && (u.y = o), zF(u, r2.transform), BF(u, e2, r2, t2), t2.animation && b3(r2, u, t2), Uu("text", r2.id + "", u, void 0, n2);
    }
  }
  function hj(r2, t2) {
    if (r2 instanceof xa)
      return pY(r2, t2);
    if (r2 instanceof Bl)
      return xve(r2, t2);
    if (r2 instanceof tE)
      return wve(r2, t2);
  }
  function Sve(r2, t2, e2) {
    var n2 = r2.style;
    if (oie(n2)) {
      var a = sie(r2), i = e2.shadowCache, o = i[a];
      if (!o) {
        var s = r2.getGlobalScale(), u = s[0], l2 = s[1];
        if (!u || !l2)
          return;
        var c2 = n2.shadowOffsetX || 0, f2 = n2.shadowOffsetY || 0, h = n2.shadowBlur, v9 = rw(n2.shadowColor), d2 = v9.opacity, m2 = v9.color, b2 = h / 2 / u, _ = h / 2 / l2, C = b2 + " " + _;
        o = e2.zrId + "-s" + e2.shadowIdx++, e2.defs[o] = Uu("filter", o, { id: o, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [Uu("feDropShadow", "", { dx: c2 / u, dy: f2 / l2, stdDeviation: C, "flood-color": m2, "flood-opacity": d2 })]), i[a] = o;
      }
      t2.filter = UP(o);
    }
  }
  function Cve(r2, t2, e2, n2) {
    var a = r2[e2], i, o = { gradientUnits: a.global ? "userSpaceOnUse" : "objectBoundingBox" };
    if (SW(a))
      i = "linearGradient", o.x1 = a.x, o.y1 = a.y, o.x2 = a.x2, o.y2 = a.y2;
    else if (CW(a))
      i = "radialGradient", o.cx = ia(a.x, 0.5), o.cy = ia(a.y, 0.5), o.r = ia(a.r, 0.5);
    else
      return;
    for (var s = a.colorStops, u = [], l2 = 0, c2 = s.length; l2 < c2; ++l2) {
      var f2 = WR(s[l2].offset) * 100 + "%", h = s[l2].color, v9 = rw(h), d2 = v9.color, m2 = v9.opacity, b2 = { offset: f2 };
      b2["stop-color"] = d2, m2 < 1 && (b2["stop-opacity"] = m2), u.push(Uu("stop", l2 + "", b2));
    }
    var _ = Uu(i, "", o, u), C = jF(_), M = n2.gradientCache, E = M[C];
    E || (E = n2.zrId + "-g" + n2.gradientIdx++, M[C] = E, o.id = E, n2.defs[E] = Uu(i, E, o, u)), t2[e2] = UP(E);
  }
  function Eve(r2, t2, e2, n2) {
    var a = r2.style[e2], i = { patternUnits: "userSpaceOnUse" }, o;
    if (wW(a)) {
      var s = a.imageWidth, u = a.imageHeight, l2 = void 0, c2 = a.image;
      if (Zr(c2) ? l2 = c2 : vY(c2) ? l2 = c2.src : dY(c2) && (l2 = c2.toDataURL()), typeof Image == "undefined") {
        var f2 = "Image width/height must been given explictly in svg-ssr renderer.";
        Fc(s, f2), Fc(u, f2);
      } else if (s == null || u == null) {
        var h = function(C, M) {
          if (C) {
            var E = C.elm, z9 = C.attrs.width = s || M.width, V = C.attrs.height = u || M.height;
            E && (E.setAttribute("width", z9), E.setAttribute("height", V));
          }
        }, v9 = Z6(l2, null, r2, function(C) {
          h(d2, C), h(o, C);
        });
        v9 && v9.width && v9.height && (s = s || v9.width, u = u || v9.height);
      }
      o = Uu("image", "img", { href: l2, width: s, height: u }), i.width = s, i.height = u;
    } else
      a.svgElement && (o = On(a.svgElement), i.width = a.svgWidth, i.height = a.svgHeight);
    if (!!o) {
      i.patternTransform = AW(a);
      var d2 = Uu("pattern", "", i, [o]), m2 = jF(d2), b2 = n2.patternCache, _ = b2[m2];
      _ || (_ = n2.zrId + "-p" + n2.patternIdx++, b2[m2] = _, i.id = _, d2 = n2.defs[_] = Uu("pattern", _, i, [o])), t2[e2] = UP(_);
    }
  }
  function Ave(r2, t2, e2) {
    var n2 = e2.clipPathCache, a = e2.defs, i = n2[r2.id];
    if (!i) {
      i = e2.zrId + "-c" + e2.clipPathIdx++;
      var o = { id: i };
      n2[r2.id] = i, a[i] = Uu("clipPath", i, o, [pY(r2, e2)]);
    }
    t2["clip-path"] = UP(i);
  }
  function vj(r2) {
    return document.createTextNode(r2);
  }
  function Rb(r2, t2, e2) {
    r2.insertBefore(t2, e2);
  }
  function dj(r2, t2) {
    r2.removeChild(t2);
  }
  function pj(r2, t2) {
    r2.appendChild(t2);
  }
  function gY(r2) {
    return r2.parentNode;
  }
  function yY(r2) {
    return r2.nextSibling;
  }
  function uk(r2, t2) {
    r2.textContent = t2;
  }
  var gj = 58, Tve = 120, Mve = Uu("", "");
  function I4(r2) {
    return r2 === void 0;
  }
  function $d(r2) {
    return r2 !== void 0;
  }
  function Pve(r2, t2, e2) {
    for (var n2 = {}, a = t2; a <= e2; ++a) {
      var i = r2[a].key;
      i !== void 0 && (n2[i] = a);
    }
    return n2;
  }
  function EC(r2, t2) {
    var e2 = r2.key === t2.key, n2 = r2.tag === t2.tag;
    return n2 && e2;
  }
  function pE(r2) {
    var t2, e2 = r2.children, n2 = r2.tag;
    if ($d(n2)) {
      var a = r2.elm = fY(n2);
      if ($F(Mve, r2), vr(e2))
        for (t2 = 0; t2 < e2.length; ++t2) {
          var i = e2[t2];
          i != null && pj(a, pE(i));
        }
      else
        $d(r2.text) && !Tn(r2.text) && pj(a, vj(r2.text));
    } else
      r2.elm = vj(r2.text);
    return r2.elm;
  }
  function mY(r2, t2, e2, n2, a) {
    for (; n2 <= a; ++n2) {
      var i = e2[n2];
      i != null && Rb(r2, pE(i), t2);
    }
  }
  function yP(r2, t2, e2, n2) {
    for (; e2 <= n2; ++e2) {
      var a = t2[e2];
      if (a != null)
        if ($d(a.tag)) {
          var i = gY(a.elm);
          dj(i, a.elm);
        } else
          dj(r2, a.elm);
    }
  }
  function $F(r2, t2) {
    var e2, n2 = t2.elm, a = r2 && r2.attrs || {}, i = t2.attrs || {};
    if (a !== i) {
      for (e2 in i) {
        var o = i[e2], s = a[e2];
        s !== o && (o === true ? n2.setAttribute(e2, "") : o === false ? n2.removeAttribute(e2) : e2.charCodeAt(0) !== Tve ? n2.setAttribute(e2, o) : e2 === "xmlns:xlink" || e2 === "xmlns" ? n2.setAttributeNS(uve, e2, o) : e2.charCodeAt(3) === gj ? n2.setAttributeNS(lve, e2, o) : e2.charCodeAt(5) === gj ? n2.setAttributeNS(cY, e2, o) : n2.setAttribute(e2, o));
      }
      for (e2 in a)
        e2 in i || n2.removeAttribute(e2);
    }
  }
  function Dve(r2, t2, e2) {
    for (var n2 = 0, a = 0, i = t2.length - 1, o = t2[0], s = t2[i], u = e2.length - 1, l2 = e2[0], c2 = e2[u], f2, h, v9, d2; n2 <= i && a <= u; )
      o == null ? o = t2[++n2] : s == null ? s = t2[--i] : l2 == null ? l2 = e2[++a] : c2 == null ? c2 = e2[--u] : EC(o, l2) ? (Fx(o, l2), o = t2[++n2], l2 = e2[++a]) : EC(s, c2) ? (Fx(s, c2), s = t2[--i], c2 = e2[--u]) : EC(o, c2) ? (Fx(o, c2), Rb(r2, o.elm, yY(s.elm)), o = t2[++n2], c2 = e2[--u]) : EC(s, l2) ? (Fx(s, l2), Rb(r2, s.elm, o.elm), s = t2[--i], l2 = e2[++a]) : (I4(f2) && (f2 = Pve(t2, n2, i)), h = f2[l2.key], I4(h) ? Rb(r2, pE(l2), o.elm) : (v9 = t2[h], v9.tag !== l2.tag ? Rb(r2, pE(l2), o.elm) : (Fx(v9, l2), t2[h] = void 0, Rb(r2, v9.elm, o.elm))), l2 = e2[++a]);
    (n2 <= i || a <= u) && (n2 > i ? (d2 = e2[u + 1] == null ? null : e2[u + 1].elm, mY(r2, d2, e2, a, u)) : yP(r2, t2, n2, i));
  }
  function Fx(r2, t2) {
    var e2 = t2.elm = r2.elm, n2 = r2.children, a = t2.children;
    r2 !== t2 && ($F(r2, t2), I4(t2.text) ? $d(n2) && $d(a) ? n2 !== a && Dve(e2, n2, a) : $d(a) ? ($d(r2.text) && uk(e2, ""), mY(e2, null, a, 0, a.length - 1)) : $d(n2) ? yP(e2, n2, 0, n2.length - 1) : $d(r2.text) && uk(e2, "") : r2.text !== t2.text && ($d(n2) && yP(e2, n2, 0, n2.length - 1), uk(e2, t2.text)));
  }
  function Ive(r2, t2) {
    if (EC(r2, t2))
      Fx(r2, t2);
    else {
      var e2 = r2.elm, n2 = gY(e2);
      pE(t2), n2 !== null && (Rb(n2, t2.elm, yY(e2)), yP(n2, [r2], 0, 0));
    }
    return t2;
  }
  var Lve = 0, Ove = function() {
    function r2(t2, e2, n2) {
      if (this.type = "svg", this.refreshHover = yj(), this.configLayer = yj(), this.storage = e2, this._opts = n2 = qt({}, n2), this.root = t2, this._id = "zr" + Lve++, this._oldVNode = oj(n2.width, n2.height), t2 && !n2.ssr) {
        var a = this._viewport = document.createElement("div");
        a.style.cssText = "position:relative;overflow:hidden";
        var i = this._svgDom = this._oldVNode.elm = fY("svg");
        $F(null, this._oldVNode), a.appendChild(i), t2.appendChild(a);
      }
      this.resize(n2.width, n2.height);
    }
    return r2.prototype.getType = function() {
      return this.type;
    }, r2.prototype.getViewportRoot = function() {
      return this._viewport;
    }, r2.prototype.getViewportRootOffset = function() {
      var t2 = this.getViewportRoot();
      if (t2)
        return { offsetLeft: t2.offsetLeft || 0, offsetTop: t2.offsetTop || 0 };
    }, r2.prototype.getSvgDom = function() {
      return this._svgDom;
    }, r2.prototype.refresh = function() {
      if (this.root) {
        var t2 = this.renderToVNode({ willUpdate: true });
        t2.attrs.style = "position:absolute;left:0;top:0;user-select:none", Ive(this._oldVNode, t2), this._oldVNode = t2;
      }
    }, r2.prototype.renderOneToVNode = function(t2) {
      return hj(t2, D4(this._id));
    }, r2.prototype.renderToVNode = function(t2) {
      t2 = t2 || {};
      var e2 = this.storage.getDisplayList(true), n2 = this._backgroundColor, a = this._width, i = this._height, o = D4(this._id);
      o.animation = t2.animation, o.willUpdate = t2.willUpdate, o.compress = t2.compress;
      var s = [];
      if (n2 && n2 !== "none") {
        var u = rw(n2), l2 = u.color, c2 = u.opacity;
        this._bgVNode = Uu("rect", "bg", { width: a, height: i, x: "0", y: "0", id: "0", fill: l2, "fill-opacity": c2 }), s.push(this._bgVNode);
      } else
        this._bgVNode = null;
      var f2 = t2.compress ? null : this._mainVNode = Uu("g", "main", {}, []);
      this._paintList(e2, o, f2 ? f2.children : s), f2 && s.push(f2);
      var h = pr(ja(o.defs), function(m2) {
        return o.defs[m2];
      });
      if (h.length && s.push(Uu("defs", "defs", {}, h)), t2.animation) {
        var v9 = hve(o.cssNodes, o.cssAnims, { newline: true });
        if (v9) {
          var d2 = Uu("style", "stl", {}, [], v9);
          s.push(d2);
        }
      }
      return oj(a, i, s, t2.useViewBox);
    }, r2.prototype.renderToString = function(t2) {
      return t2 = t2 || {}, jF(this.renderToVNode({ animation: ia(t2.cssAnimation, true), willUpdate: false, compress: true, useViewBox: ia(t2.useViewBox, true) }), { newline: true });
    }, r2.prototype.setBackgroundColor = function(t2) {
      this._backgroundColor = t2;
      var e2 = this._bgVNode;
      if (e2 && e2.elm) {
        var n2 = rw(t2), a = n2.color, i = n2.opacity;
        e2.elm.setAttribute("fill", a), i < 1 && e2.elm.setAttribute("fill-opacity", i);
      }
    }, r2.prototype.getSvgRoot = function() {
      return this._mainVNode && this._mainVNode.elm;
    }, r2.prototype._paintList = function(t2, e2, n2) {
      for (var a = t2.length, i = [], o = 0, s, u, l2 = 0, c2 = 0; c2 < a; c2++) {
        var f2 = t2[c2];
        if (!f2.invisible) {
          var h = f2.__clipPaths, v9 = h && h.length || 0, d2 = u && u.length || 0, m2 = void 0;
          for (m2 = Math.max(v9 - 1, d2 - 1); m2 >= 0 && !(h && u && h[m2] === u[m2]); m2--)
            ;
          for (var b2 = d2 - 1; b2 > m2; b2--)
            o--, s = i[o - 1];
          for (var _ = m2 + 1; _ < v9; _++) {
            var C = {};
            Ave(h[_], C, e2);
            var M = Uu("g", "clip-g-" + l2++, C, []);
            (s ? s.children : n2).push(M), i[o++] = M, s = M;
          }
          u = h;
          var E = hj(f2, e2);
          E && (s ? s.children : n2).push(E);
        }
      }
    }, r2.prototype.resize = function(t2, e2) {
      var n2 = this._opts, a = this.root, i = this._viewport;
      if (t2 != null && (n2.width = t2), e2 != null && (n2.height = e2), a && i && (i.style.display = "none", t2 = Gx(a, 0, n2), e2 = Gx(a, 1, n2), i.style.display = ""), this._width !== t2 || this._height !== e2) {
        if (this._width = t2, this._height = e2, i) {
          var o = i.style;
          o.width = t2 + "px", o.height = e2 + "px";
        }
        var s = this._svgDom;
        s && (s.setAttribute("width", t2), s.setAttribute("height", e2));
      }
    }, r2.prototype.getWidth = function() {
      return this._width;
    }, r2.prototype.getHeight = function() {
      return this._height;
    }, r2.prototype.dispose = function() {
      this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
    }, r2.prototype.clear = function() {
      this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
    }, r2.prototype.toDataURL = function(t2) {
      var e2 = encodeURIComponent(this.renderToString()), n2 = "data:image/svg+xml;";
      return t2 ? (e2 = fie(e2), e2 && n2 + "base64," + e2) : n2 + "charset=UTF-8," + e2;
    }, r2;
  }();
  function yj(r2) {
    return function() {
    };
  }
  var kve = Ove;
  function Rve(r2) {
    r2.registerPainter("svg", kve);
  }
  function mj(r2, t2, e2) {
    var n2 = Tg.createCanvas(), a = t2.getWidth(), i = t2.getHeight(), o = n2.style;
    return o && (o.position = "absolute", o.left = "0", o.top = "0", o.width = a + "px", o.height = i + "px", n2.setAttribute("data-zr-dom-id", r2)), n2.width = a * e2, n2.height = i * e2, n2;
  }
  var Fve = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this) || this;
      i.motionBlur = false, i.lastFrameAlpha = 0.7, i.dpr = 1, i.virtual = false, i.config = {}, i.incremental = false, i.zlevel = 0, i.maxRepaintRectCount = 5, i.__dirty = true, i.__firstTimePaint = true, i.__used = false, i.__drawIndex = 0, i.__startIndex = 0, i.__endIndex = 0, i.__prevStartIndex = null, i.__prevEndIndex = null;
      var o;
      a = a || K5, typeof e2 == "string" ? o = mj(e2, n2, a) : Tn(e2) && (o = e2, e2 = o.id), i.id = e2, i.dom = o;
      var s = o.style;
      return s && (oW(o), o.onselectstart = function() {
        return false;
      }, s.padding = "0", s.margin = "0", s.borderWidth = "0"), i.painter = n2, i.dpr = a, i;
    }
    return t2.prototype.getElementCount = function() {
      return this.__endIndex - this.__startIndex;
    }, t2.prototype.afterBrush = function() {
      this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
    }, t2.prototype.initContext = function() {
      this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
    }, t2.prototype.setUnpainted = function() {
      this.__firstTimePaint = true;
    }, t2.prototype.createBackBuffer = function() {
      var e2 = this.dpr;
      this.domBack = mj("back-" + this.id, this.painter, e2), this.ctxBack = this.domBack.getContext("2d"), e2 !== 1 && this.ctxBack.scale(e2, e2);
    }, t2.prototype.createRepaintRects = function(e2, n2, a, i) {
      if (this.__firstTimePaint)
        return this.__firstTimePaint = false, null;
      var o = [], s = this.maxRepaintRectCount, u = false, l2 = new da(0, 0, 0, 0);
      function c2(C) {
        if (!(!C.isFinite() || C.isZero()))
          if (o.length === 0) {
            var M = new da(0, 0, 0, 0);
            M.copy(C), o.push(M);
          } else {
            for (var E = false, z9 = 1 / 0, V = 0, $ = 0; $ < o.length; ++$) {
              var U = o[$];
              if (U.intersect(C)) {
                var H = new da(0, 0, 0, 0);
                H.copy(U), H.union(C), o[$] = H, E = true;
                break;
              } else if (u) {
                l2.copy(C), l2.union(U);
                var q3 = C.width * C.height, ee = U.width * U.height, oe = l2.width * l2.height, ne = oe - q3 - ee;
                ne < z9 && (z9 = ne, V = $);
              }
            }
            if (u && (o[V].union(C), E = true), !E) {
              var M = new da(0, 0, 0, 0);
              M.copy(C), o.push(M);
            }
            u || (u = o.length >= s);
          }
      }
      for (var f2 = this.__startIndex; f2 < this.__endIndex; ++f2) {
        var h = e2[f2];
        if (h) {
          var v9 = h.shouldBePainted(a, i, true, true), d2 = h.__isRendered && (h.__dirty & Kf || !v9) ? h.getPrevPaintRect() : null;
          d2 && c2(d2);
          var m2 = v9 && (h.__dirty & Kf || !h.__isRendered) ? h.getPaintRect() : null;
          m2 && c2(m2);
        }
      }
      for (var f2 = this.__prevStartIndex; f2 < this.__prevEndIndex; ++f2) {
        var h = n2[f2], v9 = h.shouldBePainted(a, i, true, true);
        if (h && (!v9 || !h.__zr) && h.__isRendered) {
          var d2 = h.getPrevPaintRect();
          d2 && c2(d2);
        }
      }
      var b2;
      do {
        b2 = false;
        for (var f2 = 0; f2 < o.length; ) {
          if (o[f2].isZero()) {
            o.splice(f2, 1);
            continue;
          }
          for (var _ = f2 + 1; _ < o.length; )
            o[f2].intersect(o[_]) ? (b2 = true, o[f2].union(o[_]), o.splice(_, 1)) : _++;
          f2++;
        }
      } while (b2);
      return this._paintRects = o, o;
    }, t2.prototype.debugGetPaintRects = function() {
      return (this._paintRects || []).slice();
    }, t2.prototype.resize = function(e2, n2) {
      var a = this.dpr, i = this.dom, o = i.style, s = this.domBack;
      o && (o.width = e2 + "px", o.height = n2 + "px"), i.width = e2 * a, i.height = n2 * a, s && (s.width = e2 * a, s.height = n2 * a, a !== 1 && this.ctxBack.scale(a, a));
    }, t2.prototype.clear = function(e2, n2, a) {
      var i = this.dom, o = this.ctx, s = i.width, u = i.height;
      n2 = n2 || this.clearColor;
      var l2 = this.motionBlur && !e2, c2 = this.lastFrameAlpha, f2 = this.dpr, h = this;
      l2 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(i, 0, 0, s / f2, u / f2));
      var v9 = this.domBack;
      function d2(m2, b2, _, C) {
        if (o.clearRect(m2, b2, _, C), n2 && n2 !== "transparent") {
          var M = void 0;
          GP(n2) ? (M = n2.__canvasGradient || x4(o, n2, { x: 0, y: 0, width: _, height: C }), n2.__canvasGradient = M) : gae(n2) && (M = w4(o, n2, { dirty: function() {
            h.setUnpainted(), h.__painter.refresh();
          } })), o.save(), o.fillStyle = M || n2, o.fillRect(m2, b2, _, C), o.restore();
        }
        l2 && (o.save(), o.globalAlpha = c2, o.drawImage(v9, m2, b2, _, C), o.restore());
      }
      !a || l2 ? d2(0, 0, s, u) : a.length && ae(a, function(m2) {
        d2(m2.x * f2, m2.y * f2, m2.width * f2, m2.height * f2);
      });
    }, t2;
  }(Yh), lk = Fve, bj = 1e5, Sb = 314159, qM = 0.01, Nve = 1e-3;
  function Vve(r2) {
    return r2 ? r2.__builtin__ ? true : !(typeof r2.resize != "function" || typeof r2.refresh != "function") : false;
  }
  function jve(r2, t2) {
    var e2 = document.createElement("div");
    return e2.style.cssText = ["position:relative", "width:" + r2 + "px", "height:" + t2 + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", e2;
  }
  var Bve = function() {
    function r2(t2, e2, n2, a) {
      this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
      var i = !t2.nodeName || t2.nodeName.toUpperCase() === "CANVAS";
      this._opts = n2 = qt({}, n2 || {}), this.dpr = n2.devicePixelRatio || K5, this._singleCanvas = i, this.root = t2;
      var o = t2.style;
      o && (oW(t2), t2.innerHTML = ""), this.storage = e2;
      var s = this._zlevelList;
      this._prevDisplayList = [];
      var u = this._layers;
      if (i) {
        var c2 = t2, f2 = c2.width, h = c2.height;
        n2.width != null && (f2 = n2.width), n2.height != null && (h = n2.height), this.dpr = n2.devicePixelRatio || 1, c2.width = f2 * this.dpr, c2.height = h * this.dpr, this._width = f2, this._height = h;
        var v9 = new lk(c2, this, this.dpr);
        v9.__builtin__ = true, v9.initContext(), u[Sb] = v9, v9.zlevel = Sb, s.push(Sb), this._domRoot = t2;
      } else {
        this._width = Gx(t2, 0, n2), this._height = Gx(t2, 1, n2);
        var l2 = this._domRoot = jve(this._width, this._height);
        t2.appendChild(l2);
      }
    }
    return r2.prototype.getType = function() {
      return "canvas";
    }, r2.prototype.isSingleCanvas = function() {
      return this._singleCanvas;
    }, r2.prototype.getViewportRoot = function() {
      return this._domRoot;
    }, r2.prototype.getViewportRootOffset = function() {
      var t2 = this.getViewportRoot();
      if (t2)
        return { offsetLeft: t2.offsetLeft || 0, offsetTop: t2.offsetTop || 0 };
    }, r2.prototype.refresh = function(t2) {
      var e2 = this.storage.getDisplayList(true), n2 = this._prevDisplayList, a = this._zlevelList;
      this._redrawId = Math.random(), this._paintList(e2, n2, t2, this._redrawId);
      for (var i = 0; i < a.length; i++) {
        var o = a[i], s = this._layers[o];
        if (!s.__builtin__ && s.refresh) {
          var u = i === 0 ? this._backgroundColor : null;
          s.refresh(u);
        }
      }
      return this._opts.useDirtyRect && (this._prevDisplayList = e2.slice()), this;
    }, r2.prototype.refreshHover = function() {
      this._paintHoverList(this.storage.getDisplayList(false));
    }, r2.prototype._paintHoverList = function(t2) {
      var e2 = t2.length, n2 = this._hoverlayer;
      if (n2 && n2.clear(), !!e2) {
        for (var a = { inHover: true, viewWidth: this._width, viewHeight: this._height }, i, o = 0; o < e2; o++) {
          var s = t2[o];
          s.__inHover && (n2 || (n2 = this._hoverlayer = this.getLayer(bj)), i || (i = n2.ctx, i.save()), $b(i, s, a, o === e2 - 1));
        }
        i && i.restore();
      }
    }, r2.prototype.getHoverLayer = function() {
      return this.getLayer(bj);
    }, r2.prototype.paintOne = function(t2, e2) {
      rq(t2, e2);
    }, r2.prototype._paintList = function(t2, e2, n2, a) {
      if (this._redrawId === a) {
        n2 = n2 || false, this._updateLayerStatus(t2);
        var i = this._doPaintList(t2, e2, n2), o = i.finished, s = i.needsRefreshHover;
        if (this._needsManuallyCompositing && this._compositeManually(), s && this._paintHoverList(t2), o)
          this.eachLayer(function(l2) {
            l2.afterBrush && l2.afterBrush();
          });
        else {
          var u = this;
          jR(function() {
            u._paintList(t2, e2, n2, a);
          });
        }
      }
    }, r2.prototype._compositeManually = function() {
      var t2 = this.getLayer(Sb).ctx, e2 = this._domRoot.width, n2 = this._domRoot.height;
      t2.clearRect(0, 0, e2, n2), this.eachBuiltinLayer(function(a) {
        a.virtual && t2.drawImage(a.dom, 0, 0, e2, n2);
      });
    }, r2.prototype._doPaintList = function(t2, e2, n2) {
      for (var a = this, i = [], o = this._opts.useDirtyRect, s = 0; s < this._zlevelList.length; s++) {
        var u = this._zlevelList[s], l2 = this._layers[u];
        l2.__builtin__ && l2 !== this._hoverlayer && (l2.__dirty || n2) && i.push(l2);
      }
      for (var c2 = true, f2 = false, h = function(m2) {
        var b2 = i[m2], _ = b2.ctx, C = o && b2.createRepaintRects(t2, e2, v9._width, v9._height), M = n2 ? b2.__startIndex : b2.__drawIndex, E = !n2 && b2.incremental && Date.now, z9 = E && Date.now(), V = b2.zlevel === v9._zlevelList[0] ? v9._backgroundColor : null;
        if (b2.__startIndex === b2.__endIndex)
          b2.clear(false, V, C);
        else if (M === b2.__startIndex) {
          var $ = t2[M];
          (!$.incremental || !$.notClear || n2) && b2.clear(false, V, C);
        }
        M === -1 && (console.error("For some unknown reason. drawIndex is -1"), M = b2.__startIndex);
        var U, H = function(ne) {
          var be = { inHover: false, allClipped: false, prevEl: null, viewWidth: a._width, viewHeight: a._height };
          for (U = M; U < b2.__endIndex; U++) {
            var Ee = t2[U];
            if (Ee.__inHover && (f2 = true), a._doPaintEl(Ee, b2, o, ne, be, U === b2.__endIndex - 1), E) {
              var ye = Date.now() - z9;
              if (ye > 15)
                break;
            }
          }
          be.prevElClipPaths && _.restore();
        };
        if (C)
          if (C.length === 0)
            U = b2.__endIndex;
          else
            for (var q3 = v9.dpr, ee = 0; ee < C.length; ++ee) {
              var oe = C[ee];
              _.save(), _.beginPath(), _.rect(oe.x * q3, oe.y * q3, oe.width * q3, oe.height * q3), _.clip(), H(oe), _.restore();
            }
        else
          _.save(), H(), _.restore();
        b2.__drawIndex = U, b2.__drawIndex < b2.__endIndex && (c2 = false);
      }, v9 = this, d2 = 0; d2 < i.length; d2++)
        h(d2);
      return Ei.wxa && ae(this._layers, function(m2) {
        m2 && m2.ctx && m2.ctx.draw && m2.ctx.draw();
      }), { finished: c2, needsRefreshHover: f2 };
    }, r2.prototype._doPaintEl = function(t2, e2, n2, a, i, o) {
      var s = e2.ctx;
      if (n2) {
        var u = t2.getPaintRect();
        (!a || u && u.intersect(a)) && ($b(s, t2, i, o), t2.setPrevPaintRect(u));
      } else
        $b(s, t2, i, o);
    }, r2.prototype.getLayer = function(t2, e2) {
      this._singleCanvas && !this._needsManuallyCompositing && (t2 = Sb);
      var n2 = this._layers[t2];
      return n2 || (n2 = new lk("zr_" + t2, this, this.dpr), n2.zlevel = t2, n2.__builtin__ = true, this._layerConfig[t2] ? ea(n2, this._layerConfig[t2], true) : this._layerConfig[t2 - qM] && ea(n2, this._layerConfig[t2 - qM], true), e2 && (n2.virtual = e2), this.insertLayer(t2, n2), n2.initContext()), n2;
    }, r2.prototype.insertLayer = function(t2, e2) {
      var n2 = this._layers, a = this._zlevelList, i = a.length, o = this._domRoot, s = null, u = -1;
      if (!n2[t2] && !!Vve(e2)) {
        if (i > 0 && t2 > a[0]) {
          for (u = 0; u < i - 1 && !(a[u] < t2 && a[u + 1] > t2); u++)
            ;
          s = n2[a[u]];
        }
        if (a.splice(u + 1, 0, t2), n2[t2] = e2, !e2.virtual)
          if (s) {
            var l2 = s.dom;
            l2.nextSibling ? o.insertBefore(e2.dom, l2.nextSibling) : o.appendChild(e2.dom);
          } else
            o.firstChild ? o.insertBefore(e2.dom, o.firstChild) : o.appendChild(e2.dom);
        e2.__painter = this;
      }
    }, r2.prototype.eachLayer = function(t2, e2) {
      for (var n2 = this._zlevelList, a = 0; a < n2.length; a++) {
        var i = n2[a];
        t2.call(e2, this._layers[i], i);
      }
    }, r2.prototype.eachBuiltinLayer = function(t2, e2) {
      for (var n2 = this._zlevelList, a = 0; a < n2.length; a++) {
        var i = n2[a], o = this._layers[i];
        o.__builtin__ && t2.call(e2, o, i);
      }
    }, r2.prototype.eachOtherLayer = function(t2, e2) {
      for (var n2 = this._zlevelList, a = 0; a < n2.length; a++) {
        var i = n2[a], o = this._layers[i];
        o.__builtin__ || t2.call(e2, o, i);
      }
    }, r2.prototype.getLayers = function() {
      return this._layers;
    }, r2.prototype._updateLayerStatus = function(t2) {
      this.eachBuiltinLayer(function(f2, h) {
        f2.__dirty = f2.__used = false;
      });
      function e2(f2) {
        i && (i.__endIndex !== f2 && (i.__dirty = true), i.__endIndex = f2);
      }
      if (this._singleCanvas)
        for (var n2 = 1; n2 < t2.length; n2++) {
          var a = t2[n2];
          if (a.zlevel !== t2[n2 - 1].zlevel || a.incremental) {
            this._needsManuallyCompositing = true;
            break;
          }
        }
      var i = null, o = 0, s, u;
      for (u = 0; u < t2.length; u++) {
        var a = t2[u], l2 = a.zlevel, c2 = void 0;
        s !== l2 && (s = l2, o = 0), a.incremental ? (c2 = this.getLayer(l2 + Nve, this._needsManuallyCompositing), c2.incremental = true, o = 1) : c2 = this.getLayer(l2 + (o > 0 ? qM : 0), this._needsManuallyCompositing), c2.__builtin__ || F6("ZLevel " + l2 + " has been used by unkown layer " + c2.id), c2 !== i && (c2.__used = true, c2.__startIndex !== u && (c2.__dirty = true), c2.__startIndex = u, c2.incremental ? c2.__drawIndex = -1 : c2.__drawIndex = u, e2(u), i = c2), a.__dirty & Kf && !a.__inHover && (c2.__dirty = true, c2.incremental && c2.__drawIndex < 0 && (c2.__drawIndex = u));
      }
      e2(u), this.eachBuiltinLayer(function(f2, h) {
        !f2.__used && f2.getElementCount() > 0 && (f2.__dirty = true, f2.__startIndex = f2.__endIndex = f2.__drawIndex = 0), f2.__dirty && f2.__drawIndex < 0 && (f2.__drawIndex = f2.__startIndex);
      });
    }, r2.prototype.clear = function() {
      return this.eachBuiltinLayer(this._clearLayer), this;
    }, r2.prototype._clearLayer = function(t2) {
      t2.clear();
    }, r2.prototype.setBackgroundColor = function(t2) {
      this._backgroundColor = t2, ae(this._layers, function(e2) {
        e2.setUnpainted();
      });
    }, r2.prototype.configLayer = function(t2, e2) {
      if (e2) {
        var n2 = this._layerConfig;
        n2[t2] ? ea(n2[t2], e2, true) : n2[t2] = e2;
        for (var a = 0; a < this._zlevelList.length; a++) {
          var i = this._zlevelList[a];
          if (i === t2 || i === t2 + qM) {
            var o = this._layers[i];
            ea(o, n2[t2], true);
          }
        }
      }
    }, r2.prototype.delLayer = function(t2) {
      var e2 = this._layers, n2 = this._zlevelList, a = e2[t2];
      !a || (a.dom.parentNode.removeChild(a.dom), delete e2[t2], n2.splice(va(n2, t2), 1));
    }, r2.prototype.resize = function(t2, e2) {
      if (this._domRoot.style) {
        var n2 = this._domRoot;
        n2.style.display = "none";
        var a = this._opts, i = this.root;
        if (t2 != null && (a.width = t2), e2 != null && (a.height = e2), t2 = Gx(i, 0, a), e2 = Gx(i, 1, a), n2.style.display = "", this._width !== t2 || e2 !== this._height) {
          n2.style.width = t2 + "px", n2.style.height = e2 + "px";
          for (var o in this._layers)
            this._layers.hasOwnProperty(o) && this._layers[o].resize(t2, e2);
          this.refresh(true);
        }
        this._width = t2, this._height = e2;
      } else {
        if (t2 == null || e2 == null)
          return;
        this._width = t2, this._height = e2, this.getLayer(Sb).resize(t2, e2);
      }
      return this;
    }, r2.prototype.clearLayer = function(t2) {
      var e2 = this._layers[t2];
      e2 && e2.clear();
    }, r2.prototype.dispose = function() {
      this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
    }, r2.prototype.getRenderedCanvas = function(t2) {
      if (t2 = t2 || {}, this._singleCanvas && !this._compositeManually)
        return this._layers[Sb].dom;
      var e2 = new lk("image", this, t2.pixelRatio || this.dpr);
      e2.initContext(), e2.clear(false, t2.backgroundColor || this._backgroundColor);
      var n2 = e2.ctx;
      if (t2.pixelRatio <= this.dpr) {
        this.refresh();
        var a = e2.dom.width, i = e2.dom.height;
        this.eachLayer(function(f2) {
          f2.__builtin__ ? n2.drawImage(f2.dom, 0, 0, a, i) : f2.renderToCanvas && (n2.save(), f2.renderToCanvas(n2), n2.restore());
        });
      } else
        for (var o = { inHover: false, viewWidth: this._width, viewHeight: this._height }, s = this.storage.getDisplayList(true), u = 0, l2 = s.length; u < l2; u++) {
          var c2 = s[u];
          $b(n2, c2, o, u === l2 - 1);
        }
      return e2.dom;
    }, r2.prototype.getWidth = function() {
      return this._width;
    }, r2.prototype.getHeight = function() {
      return this._height;
    }, r2;
  }(), zve = Bve;
  function $ve(r2) {
    r2.registerPainter("canvas", zve);
  }
  var Gve = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2;
    }
    return t2.prototype.getInitialData = function(e2) {
      return kg(null, this, { useEncodeDefaulter: true });
    }, t2.prototype.getLegendIcon = function(e2) {
      var n2 = new Fn(), a = cu("line", 0, e2.itemHeight / 2, e2.itemWidth, 0, e2.lineStyle.stroke, false);
      n2.add(a), a.setStyle(e2.lineStyle);
      var i = this.getData().getVisual("symbol"), o = this.getData().getVisual("symbolRotate"), s = i === "none" ? "circle" : i, u = e2.itemHeight * 0.8, l2 = cu(s, (e2.itemWidth - u) / 2, (e2.itemHeight - u) / 2, u, u, e2.itemStyle.fill);
      n2.add(l2), l2.setStyle(e2.itemStyle);
      var c2 = e2.iconRotate === "inherit" ? o : e2.iconRotate || 0;
      return l2.rotation = c2 * Math.PI / 180, l2.setOrigin([e2.itemWidth / 2, e2.itemHeight / 2]), s.indexOf("empty") > -1 && (l2.style.stroke = l2.style.fill, l2.style.fill = "#fff", l2.style.lineWidth = 2), n2;
    }, t2.type = "series.line", t2.dependencies = ["grid", "polar"], t2.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, t2;
  }(ns), Wve = Gve;
  function iw(r2, t2) {
    var e2 = r2.mapDimensionsAll("defaultedLabel"), n2 = e2.length;
    if (n2 === 1) {
      var a = nw(r2, t2, e2[0]);
      return a != null ? a + "" : null;
    } else if (n2) {
      for (var i = [], o = 0; o < e2.length; o++)
        i.push(nw(r2, t2, e2[o]));
      return i.join(" ");
    }
  }
  function bY(r2, t2) {
    var e2 = r2.mapDimensionsAll("defaultedLabel");
    if (!vr(t2))
      return t2 + "";
    for (var n2 = [], a = 0; a < e2.length; a++) {
      var i = r2.getDimensionIndex(e2[a]);
      i >= 0 && n2.push(t2[i]);
    }
    return n2.join(" ");
  }
  var Uve = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i) {
      var o = r2.call(this) || this;
      return o.updateData(e2, n2, a, i), o;
    }
    return t2.prototype._createSymbol = function(e2, n2, a, i, o) {
      this.removeAll();
      var s = cu(e2, -1, -1, 2, 2, null, o);
      s.attr({ z2: 100, culling: true, scaleX: i[0] / 2, scaleY: i[1] / 2 }), s.drift = Hve, this._symbolType = e2, this.add(s);
    }, t2.prototype.stopSymbolAnimation = function(e2) {
      this.childAt(0).stopAnimation(null, e2);
    }, t2.prototype.getSymbolType = function() {
      return this._symbolType;
    }, t2.prototype.getSymbolPath = function() {
      return this.childAt(0);
    }, t2.prototype.highlight = function() {
      Kd(this.childAt(0));
    }, t2.prototype.downplay = function() {
      Zd(this.childAt(0));
    }, t2.prototype.setZ = function(e2, n2) {
      var a = this.childAt(0);
      a.zlevel = e2, a.z = n2;
    }, t2.prototype.setDraggable = function(e2) {
      var n2 = this.childAt(0);
      n2.draggable = e2, n2.cursor = e2 ? "move" : n2.cursor;
    }, t2.prototype.updateData = function(e2, n2, a, i) {
      this.silent = false;
      var o = e2.getItemVisual(n2, "symbol") || "circle", s = e2.hostModel, u = t2.getSymbolSize(e2, n2), l2 = o !== this._symbolType, c2 = i && i.disableAnimation;
      if (l2) {
        var f2 = e2.getItemVisual(n2, "symbolKeepAspect");
        this._createSymbol(o, e2, n2, u, f2);
      } else {
        var h = this.childAt(0);
        h.silent = false;
        var v9 = { scaleX: u[0] / 2, scaleY: u[1] / 2 };
        c2 ? h.attr(v9) : ci(h, v9, s, n2), Wv(h);
      }
      if (this._updateCommon(e2, n2, u, a, i), l2) {
        var h = this.childAt(0);
        if (!c2) {
          var v9 = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: h.style.opacity } };
          h.scaleX = h.scaleY = 0, h.style.opacity = 0, rs(h, v9, s, n2);
        }
      }
      c2 && this.childAt(0).stopAnimation("leave");
    }, t2.prototype._updateCommon = function(e2, n2, a, i, o) {
      var s = this.childAt(0), u = e2.hostModel, l2, c2, f2, h, v9, d2, m2, b2, _;
      if (i && (l2 = i.emphasisItemStyle, c2 = i.blurItemStyle, f2 = i.selectItemStyle, h = i.focus, v9 = i.blurScope, m2 = i.labelStatesModels, b2 = i.hoverScale, _ = i.cursorStyle, d2 = i.emphasisDisabled), !i || e2.hasItemOption) {
        var C = i && i.itemModel ? i.itemModel : e2.getItemModel(n2), M = C.getModel("emphasis");
        l2 = M.getModel("itemStyle").getItemStyle(), f2 = C.getModel(["select", "itemStyle"]).getItemStyle(), c2 = C.getModel(["blur", "itemStyle"]).getItemStyle(), h = M.get("focus"), v9 = M.get("blurScope"), d2 = M.get("disabled"), m2 = _l(C), b2 = M.getShallow("scale"), _ = C.getShallow("cursor");
      }
      var E = e2.getItemVisual(n2, "symbolRotate");
      s.attr("rotation", (E || 0) * Math.PI / 180 || 0);
      var z9 = Cw(e2.getItemVisual(n2, "symbolOffset"), a);
      z9 && (s.x = z9[0], s.y = z9[1]), _ && s.attr("cursor", _);
      var V = e2.getItemVisual(n2, "style"), $ = V.fill;
      if (s instanceof Bl) {
        var U = s.style;
        s.useStyle(qt({ image: U.image, x: U.x, y: U.y, width: U.width, height: U.height }, V));
      } else
        s.__isEmptyBrush ? s.useStyle(qt({}, V)) : s.useStyle(V), s.style.decal = null, s.setColor($, o && o.symbolInnerColor), s.style.strokeNoScale = true;
      var H = e2.getItemVisual(n2, "liftZ"), q3 = this._z2;
      H != null ? q3 == null && (this._z2 = s.z2, s.z2 += H) : q3 != null && (s.z2 = q3, this._z2 = null);
      var ee = o && o.useNameLabel;
      fc(s, m2, { labelFetcher: u, labelDataIndex: n2, defaultText: oe, inheritColor: $, defaultOpacity: V.opacity });
      function oe(Ee) {
        return ee ? e2.getName(Ee) : iw(e2, Ee);
      }
      this._sizeX = a[0] / 2, this._sizeY = a[1] / 2;
      var ne = s.ensureState("emphasis");
      if (ne.style = l2, s.ensureState("select").style = f2, s.ensureState("blur").style = c2, b2) {
        var be = Math.max(1.1, 3 / this._sizeY);
        ne.scaleX = this._sizeX * be, ne.scaleY = this._sizeY * be;
      }
      this.setSymbolScale(1), ks(this, h, v9, d2);
    }, t2.prototype.setSymbolScale = function(e2) {
      this.scaleX = this.scaleY = e2;
    }, t2.prototype.fadeOut = function(e2, n2, a) {
      var i = this.childAt(0), o = zn(this).dataIndex, s = a && a.animation;
      if (this.silent = i.silent = true, a && a.fadeLabel) {
        var u = i.getTextContent();
        u && my(u, { style: { opacity: 0 } }, n2, { dataIndex: o, removeOpt: s, cb: function() {
          i.removeTextContent();
        } });
      } else
        i.removeTextContent();
      my(i, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, n2, { dataIndex: o, cb: e2, removeOpt: s });
    }, t2.getSymbolSize = function(e2, n2) {
      return VE(e2.getItemVisual(n2, "symbolSize"));
    }, t2;
  }(Fn);
  function Hve(r2, t2) {
    this.parent.drift(r2, t2);
  }
  var $E = Uve;
  function ck(r2, t2, e2, n2) {
    return t2 && !isNaN(t2[0]) && !isNaN(t2[1]) && !(n2.isIgnore && n2.isIgnore(e2)) && !(n2.clipShape && !n2.clipShape.contain(t2[0], t2[1])) && r2.getItemVisual(e2, "symbol") !== "none";
  }
  function _j(r2) {
    return r2 != null && !Tn(r2) && (r2 = { isIgnore: r2 }), r2 || {};
  }
  function xj(r2) {
    var t2 = r2.hostModel, e2 = t2.getModel("emphasis");
    return { emphasisItemStyle: e2.getModel("itemStyle").getItemStyle(), blurItemStyle: t2.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: t2.getModel(["select", "itemStyle"]).getItemStyle(), focus: e2.get("focus"), blurScope: e2.get("blurScope"), emphasisDisabled: e2.get("disabled"), hoverScale: e2.get("scale"), labelStatesModels: _l(t2), cursorStyle: t2.get("cursor") };
  }
  var qve = function() {
    function r2(t2) {
      this.group = new Fn(), this._SymbolCtor = t2 || $E;
    }
    return r2.prototype.updateData = function(t2, e2) {
      this._progressiveEls = null, e2 = _j(e2);
      var n2 = this.group, a = t2.hostModel, i = this._data, o = this._SymbolCtor, s = e2.disableAnimation, u = xj(t2), l2 = { disableAnimation: s }, c2 = e2.getSymbolPoint || function(f2) {
        return t2.getItemLayout(f2);
      };
      i || n2.removeAll(), t2.diff(i).add(function(f2) {
        var h = c2(f2);
        if (ck(t2, h, f2, e2)) {
          var v9 = new o(t2, f2, u, l2);
          v9.setPosition(h), t2.setItemGraphicEl(f2, v9), n2.add(v9);
        }
      }).update(function(f2, h) {
        var v9 = i.getItemGraphicEl(h), d2 = c2(f2);
        if (!ck(t2, d2, f2, e2)) {
          n2.remove(v9);
          return;
        }
        var m2 = t2.getItemVisual(f2, "symbol") || "circle", b2 = v9 && v9.getSymbolType && v9.getSymbolType();
        if (!v9 || b2 && b2 !== m2)
          n2.remove(v9), v9 = new o(t2, f2, u, l2), v9.setPosition(d2);
        else {
          v9.updateData(t2, f2, u, l2);
          var _ = { x: d2[0], y: d2[1] };
          s ? v9.attr(_) : ci(v9, _, a);
        }
        n2.add(v9), t2.setItemGraphicEl(f2, v9);
      }).remove(function(f2) {
        var h = i.getItemGraphicEl(f2);
        h && h.fadeOut(function() {
          n2.remove(h);
        }, a);
      }).execute(), this._getSymbolPoint = c2, this._data = t2;
    }, r2.prototype.updateLayout = function() {
      var t2 = this, e2 = this._data;
      e2 && e2.eachItemGraphicEl(function(n2, a) {
        var i = t2._getSymbolPoint(a);
        n2.setPosition(i), n2.markRedraw();
      });
    }, r2.prototype.incrementalPrepareUpdate = function(t2) {
      this._seriesScope = xj(t2), this._data = null, this.group.removeAll();
    }, r2.prototype.incrementalUpdate = function(t2, e2, n2) {
      this._progressiveEls = [], n2 = _j(n2);
      function a(u) {
        u.isGroup || (u.incremental = true, u.ensureState("emphasis").hoverLayer = true);
      }
      for (var i = t2.start; i < t2.end; i++) {
        var o = e2.getItemLayout(i);
        if (ck(e2, o, i, n2)) {
          var s = new this._SymbolCtor(e2, i, this._seriesScope);
          s.traverse(a), s.setPosition(o), this.group.add(s), e2.setItemGraphicEl(i, s), this._progressiveEls.push(s);
        }
      }
    }, r2.prototype.eachRendered = function(t2) {
      Ay(this._progressiveEls || this.group, t2);
    }, r2.prototype.remove = function(t2) {
      var e2 = this.group, n2 = this._data;
      n2 && t2 ? n2.eachItemGraphicEl(function(a) {
        a.fadeOut(function() {
          e2.remove(a);
        }, n2.hostModel);
      }) : e2.removeAll();
    }, r2;
  }(), GE = qve;
  function _Y(r2, t2, e2) {
    var n2 = r2.getBaseAxis(), a = r2.getOtherAxis(n2), i = Yve(a, e2), o = n2.dim, s = a.dim, u = t2.mapDimension(s), l2 = t2.mapDimension(o), c2 = s === "x" || s === "radius" ? 1 : 0, f2 = pr(r2.dimensions, function(d2) {
      return t2.mapDimension(d2);
    }), h = false, v9 = t2.getCalculationInfo("stackResultDimension");
    return _y(t2, f2[0]) && (h = true, f2[0] = v9), _y(t2, f2[1]) && (h = true, f2[1] = v9), { dataDimsForPoint: f2, valueStart: i, valueAxisDim: s, baseAxisDim: o, stacked: !!h, valueDim: u, baseDim: l2, baseDataOffset: c2, stackedOverDimension: t2.getCalculationInfo("stackedOverDimension") };
  }
  function Yve(r2, t2) {
    var e2 = 0, n2 = r2.scale.getExtent();
    return t2 === "start" ? e2 = n2[0] : t2 === "end" ? e2 = n2[1] : n2[0] > 0 ? e2 = n2[0] : n2[1] < 0 && (e2 = n2[1]), e2;
  }
  function xY(r2, t2, e2, n2) {
    var a = NaN;
    r2.stacked && (a = e2.get(e2.getCalculationInfo("stackedOverDimension"), n2)), isNaN(a) && (a = r2.valueStart);
    var i = r2.baseDataOffset, o = [];
    return o[i] = e2.get(r2.baseDim, n2), o[1 - i] = a, t2.dataToPoint(o);
  }
  function Kve(r2, t2) {
    var e2 = [];
    return t2.diff(r2).add(function(n2) {
      e2.push({ cmd: "+", idx: n2 });
    }).update(function(n2, a) {
      e2.push({ cmd: "=", idx: a, idx1: n2 });
    }).remove(function(n2) {
      e2.push({ cmd: "-", idx: n2 });
    }).execute(), e2;
  }
  function Zve(r2, t2, e2, n2, a, i, o, s) {
    for (var u = Kve(r2, t2), l2 = [], c2 = [], f2 = [], h = [], v9 = [], d2 = [], m2 = [], b2 = _Y(a, t2, o), _ = r2.getLayout("points") || [], C = t2.getLayout("points") || [], M = 0; M < u.length; M++) {
      var E = u[M], z9 = true, V = void 0, $ = void 0;
      switch (E.cmd) {
        case "=":
          V = E.idx * 2, $ = E.idx1 * 2;
          var U = _[V], H = _[V + 1], q3 = C[$], ee = C[$ + 1];
          (isNaN(U) || isNaN(H)) && (U = q3, H = ee), l2.push(U, H), c2.push(q3, ee), f2.push(e2[V], e2[V + 1]), h.push(n2[$], n2[$ + 1]), m2.push(t2.getRawIndex(E.idx1));
          break;
        case "+":
          var oe = E.idx, ne = b2.dataDimsForPoint, be = a.dataToPoint([t2.get(ne[0], oe), t2.get(ne[1], oe)]);
          $ = oe * 2, l2.push(be[0], be[1]), c2.push(C[$], C[$ + 1]);
          var Ee = xY(b2, a, t2, oe);
          f2.push(Ee[0], Ee[1]), h.push(n2[$], n2[$ + 1]), m2.push(t2.getRawIndex(oe));
          break;
        case "-":
          z9 = false;
      }
      z9 && (v9.push(E), d2.push(d2.length));
    }
    d2.sort(function(hn, cn) {
      return m2[hn] - m2[cn];
    });
    for (var ye = l2.length, et = qd(ye), Le = qd(ye), Fe = qd(ye), qe = qd(ye), st = [], M = 0; M < d2.length; M++) {
      var dt = d2[M], Ar = M * 2, Hr = dt * 2;
      et[Ar] = l2[Hr], et[Ar + 1] = l2[Hr + 1], Le[Ar] = c2[Hr], Le[Ar + 1] = c2[Hr + 1], Fe[Ar] = f2[Hr], Fe[Ar + 1] = f2[Hr + 1], qe[Ar] = h[Hr], qe[Ar + 1] = h[Hr + 1], st[M] = v9[dt];
    }
    return { current: et, next: Le, stackedOnCurrent: Fe, stackedOnNext: qe, status: st };
  }
  var Y0 = Math.min, K0 = Math.max;
  function Zb(r2, t2) {
    return isNaN(r2) || isNaN(t2);
  }
  function L4(r2, t2, e2, n2, a, i, o, s, u) {
    for (var l2, c2, f2, h, v9, d2, m2 = e2, b2 = 0; b2 < n2; b2++) {
      var _ = t2[m2 * 2], C = t2[m2 * 2 + 1];
      if (m2 >= a || m2 < 0)
        break;
      if (Zb(_, C)) {
        if (u) {
          m2 += i;
          continue;
        }
        break;
      }
      if (m2 === e2)
        r2[i > 0 ? "moveTo" : "lineTo"](_, C), f2 = _, h = C;
      else {
        var M = _ - l2, E = C - c2;
        if (M * M + E * E < 0.5) {
          m2 += i;
          continue;
        }
        if (o > 0) {
          for (var z9 = m2 + i, V = t2[z9 * 2], $ = t2[z9 * 2 + 1]; V === _ && $ === C && b2 < n2; )
            b2++, z9 += i, m2 += i, V = t2[z9 * 2], $ = t2[z9 * 2 + 1], _ = t2[m2 * 2], C = t2[m2 * 2 + 1], M = _ - l2, E = C - c2;
          var U = b2 + 1;
          if (u)
            for (; Zb(V, $) && U < n2; )
              U++, z9 += i, V = t2[z9 * 2], $ = t2[z9 * 2 + 1];
          var H = 0.5, q3 = 0, ee = 0, oe = void 0, ne = void 0;
          if (U >= n2 || Zb(V, $))
            v9 = _, d2 = C;
          else {
            q3 = V - l2, ee = $ - c2;
            var be = _ - l2, Ee = V - _, ye = C - c2, et = $ - C, Le = void 0, Fe = void 0;
            if (s === "x") {
              Le = Math.abs(be), Fe = Math.abs(Ee);
              var qe = q3 > 0 ? 1 : -1;
              v9 = _ - qe * Le * o, d2 = C, oe = _ + qe * Fe * o, ne = C;
            } else if (s === "y") {
              Le = Math.abs(ye), Fe = Math.abs(et);
              var st = ee > 0 ? 1 : -1;
              v9 = _, d2 = C - st * Le * o, oe = _, ne = C + st * Fe * o;
            } else
              Le = Math.sqrt(be * be + ye * ye), Fe = Math.sqrt(Ee * Ee + et * et), H = Fe / (Fe + Le), v9 = _ - q3 * o * (1 - H), d2 = C - ee * o * (1 - H), oe = _ + q3 * o * H, ne = C + ee * o * H, oe = Y0(oe, K0(V, _)), ne = Y0(ne, K0($, C)), oe = K0(oe, Y0(V, _)), ne = K0(ne, Y0($, C)), q3 = oe - _, ee = ne - C, v9 = _ - q3 * Le / Fe, d2 = C - ee * Le / Fe, v9 = Y0(v9, K0(l2, _)), d2 = Y0(d2, K0(c2, C)), v9 = K0(v9, Y0(l2, _)), d2 = K0(d2, Y0(c2, C)), q3 = _ - v9, ee = C - d2, oe = _ + q3 * Fe / Le, ne = C + ee * Fe / Le;
          }
          r2.bezierCurveTo(f2, h, v9, d2, _, C), f2 = oe, h = ne;
        } else
          r2.lineTo(_, C);
      }
      l2 = _, c2 = C, m2 += i;
    }
    return b2;
  }
  var wY = function() {
    function r2() {
      this.smooth = 0, this.smoothConstraint = true;
    }
    return r2;
  }(), Xve = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "ec-polyline", n2;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new wY();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.points, i = 0, o = a.length / 2;
      if (n2.connectNulls) {
        for (; o > 0 && Zb(a[o * 2 - 2], a[o * 2 - 1]); o--)
          ;
        for (; i < o && Zb(a[i * 2], a[i * 2 + 1]); i++)
          ;
      }
      for (; i < o; )
        i += L4(e2, a, i, o, o, 1, n2.smooth, n2.smoothMonotone, n2.connectNulls) + 1;
    }, t2.prototype.getPointOn = function(e2, n2) {
      this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
      for (var a = this.path, i = a.data, o = np.CMD, s, u, l2 = n2 === "x", c2 = [], f2 = 0; f2 < i.length; ) {
        var h = i[f2++], v9 = void 0, d2 = void 0, m2 = void 0, b2 = void 0, _ = void 0, C = void 0, M = void 0;
        switch (h) {
          case o.M:
            s = i[f2++], u = i[f2++];
            break;
          case o.L:
            if (v9 = i[f2++], d2 = i[f2++], M = l2 ? (e2 - s) / (v9 - s) : (e2 - u) / (d2 - u), M <= 1 && M >= 0) {
              var E = l2 ? (d2 - u) * M + u : (v9 - s) * M + s;
              return l2 ? [e2, E] : [E, e2];
            }
            s = v9, u = d2;
            break;
          case o.C:
            v9 = i[f2++], d2 = i[f2++], m2 = i[f2++], b2 = i[f2++], _ = i[f2++], C = i[f2++];
            var z9 = l2 ? U5(s, v9, m2, _, e2, c2) : U5(u, d2, b2, C, e2, c2);
            if (z9 > 0)
              for (var V = 0; V < z9; V++) {
                var $ = c2[V];
                if ($ <= 1 && $ >= 0) {
                  var E = l2 ? Wu(u, d2, b2, C, $) : Wu(s, v9, m2, _, $);
                  return l2 ? [e2, E] : [E, e2];
                }
              }
            s = _, u = C;
            break;
        }
      }
    }, t2;
  }(xa), Jve = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2;
  }(wY), SY = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "ec-polygon", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Jve();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.points, i = n2.stackedOnPoints, o = 0, s = a.length / 2, u = n2.smoothMonotone;
      if (n2.connectNulls) {
        for (; s > 0 && Zb(a[s * 2 - 2], a[s * 2 - 1]); s--)
          ;
        for (; o < s && Zb(a[o * 2], a[o * 2 + 1]); o++)
          ;
      }
      for (; o < s; ) {
        var l2 = L4(e2, a, o, s, s, 1, n2.smooth, u, n2.connectNulls);
        L4(e2, i, o + l2 - 1, l2, s, -1, n2.stackedOnSmooth, u, n2.connectNulls), o += l2 + 1, e2.closePath();
      }
    }, t2;
  }(xa);
  function CY(r2, t2, e2, n2, a) {
    var i = r2.getArea(), o = i.x, s = i.y, u = i.width, l2 = i.height, c2 = e2.get(["lineStyle", "width"]) || 2;
    o -= c2 / 2, s -= c2 / 2, u += c2, l2 += c2, o = Math.floor(o), u = Math.round(u);
    var f2 = new ni({ shape: { x: o, y: s, width: u, height: l2 } });
    if (t2) {
      var h = r2.getBaseAxis(), v9 = h.isHorizontal(), d2 = h.inverse;
      v9 ? (d2 && (f2.shape.x += u), f2.shape.width = 0) : (d2 || (f2.shape.y += l2), f2.shape.height = 0);
      var m2 = xn(a) ? function(b2) {
        a(b2, f2);
      } : null;
      rs(f2, { shape: { width: u, height: l2, x: o, y: s } }, e2, null, n2, m2);
    }
    return f2;
  }
  function EY(r2, t2, e2) {
    var n2 = r2.getArea(), a = Os(n2.r0, 1), i = Os(n2.r, 1), o = new pf({ shape: { cx: Os(r2.cx, 1), cy: Os(r2.cy, 1), r0: a, r: i, startAngle: n2.startAngle, endAngle: n2.endAngle, clockwise: n2.clockwise } });
    if (t2) {
      var s = r2.getBaseAxis().dim === "angle";
      s ? o.shape.endAngle = n2.startAngle : o.shape.r = a, rs(o, { shape: { endAngle: n2.endAngle, r: i } }, e2);
    }
    return o;
  }
  function _3(r2, t2, e2, n2, a) {
    if (r2) {
      if (r2.type === "polar")
        return EY(r2, t2, e2);
      if (r2.type === "cartesian2d")
        return CY(r2, t2, e2, n2, a);
    } else
      return null;
    return null;
  }
  function Cg(r2, t2) {
    return r2.type === t2;
  }
  function wj(r2, t2) {
    if (r2.length === t2.length) {
      for (var e2 = 0; e2 < r2.length; e2++)
        if (r2[e2] !== t2[e2])
          return;
      return true;
    }
  }
  function Sj(r2) {
    for (var t2 = 1 / 0, e2 = 1 / 0, n2 = -1 / 0, a = -1 / 0, i = 0; i < r2.length; ) {
      var o = r2[i++], s = r2[i++];
      isNaN(o) || (t2 = Math.min(o, t2), n2 = Math.max(o, n2)), isNaN(s) || (e2 = Math.min(s, e2), a = Math.max(s, a));
    }
    return [[t2, e2], [n2, a]];
  }
  function Cj(r2, t2) {
    var e2 = Sj(r2), n2 = e2[0], a = e2[1], i = Sj(t2), o = i[0], s = i[1];
    return Math.max(Math.abs(n2[0] - o[0]), Math.abs(n2[1] - o[1]), Math.abs(a[0] - s[0]), Math.abs(a[1] - s[1]));
  }
  function Ej(r2) {
    return Ai(r2) ? r2 : r2 ? 0.5 : 0;
  }
  function Qve(r2, t2, e2) {
    if (!e2.valueDim)
      return [];
    for (var n2 = t2.count(), a = qd(n2 * 2), i = 0; i < n2; i++) {
      var o = xY(e2, r2, t2, i);
      a[i * 2] = o[0], a[i * 2 + 1] = o[1];
    }
    return a;
  }
  function Z0(r2, t2, e2, n2) {
    var a = t2.getBaseAxis(), i = a.dim === "x" || a.dim === "radius" ? 0 : 1, o = [], s = 0, u = [], l2 = [], c2 = [], f2 = [];
    if (n2) {
      for (s = 0; s < r2.length; s += 2)
        !isNaN(r2[s]) && !isNaN(r2[s + 1]) && f2.push(r2[s], r2[s + 1]);
      r2 = f2;
    }
    for (s = 0; s < r2.length - 2; s += 2)
      switch (c2[0] = r2[s + 2], c2[1] = r2[s + 3], l2[0] = r2[s], l2[1] = r2[s + 1], o.push(l2[0], l2[1]), e2) {
        case "end":
          u[i] = c2[i], u[1 - i] = l2[1 - i], o.push(u[0], u[1]);
          break;
        case "middle":
          var h = (l2[i] + c2[i]) / 2, v9 = [];
          u[i] = v9[i] = h, u[1 - i] = l2[1 - i], v9[1 - i] = c2[1 - i], o.push(u[0], u[1]), o.push(v9[0], v9[1]);
          break;
        default:
          u[i] = l2[i], u[1 - i] = c2[1 - i], o.push(u[0], u[1]);
      }
    return o.push(r2[s++], r2[s++]), o;
  }
  function ede(r2, t2) {
    var e2 = [], n2 = r2.length, a, i;
    function o(c2, f2, h) {
      var v9 = c2.coord, d2 = (h - v9) / (f2.coord - v9), m2 = rie(d2, [c2.color, f2.color]);
      return { coord: h, color: m2 };
    }
    for (var s = 0; s < n2; s++) {
      var u = r2[s], l2 = u.coord;
      if (l2 < 0)
        a = u;
      else if (l2 > t2) {
        i ? e2.push(o(i, u, t2)) : a && e2.push(o(a, u, 0), o(a, u, t2));
        break;
      } else
        a && (e2.push(o(a, u, 0)), a = null), e2.push(u), i = u;
    }
    return e2;
  }
  function tde(r2, t2, e2) {
    var n2 = r2.getVisual("visualMeta");
    if (!(!n2 || !n2.length || !r2.count()) && t2.type === "cartesian2d") {
      for (var a, i, o = n2.length - 1; o >= 0; o--) {
        var s = r2.getDimensionInfo(n2[o].dimension);
        if (a = s && s.coordDim, a === "x" || a === "y") {
          i = n2[o];
          break;
        }
      }
      if (!!i) {
        var u = t2.getAxis(a), l2 = pr(i.stops, function(M) {
          return { coord: u.toGlobalCoord(u.dataToCoord(M.value)), color: M.color };
        }), c2 = l2.length, f2 = i.outerColors.slice();
        c2 && l2[0].coord > l2[c2 - 1].coord && (l2.reverse(), f2.reverse());
        var h = ede(l2, a === "x" ? e2.getWidth() : e2.getHeight()), v9 = h.length;
        if (!v9 && c2)
          return l2[0].coord < 0 ? f2[1] ? f2[1] : l2[c2 - 1].color : f2[0] ? f2[0] : l2[0].color;
        var d2 = 10, m2 = h[0].coord - d2, b2 = h[v9 - 1].coord + d2, _ = b2 - m2;
        if (_ < 1e-3)
          return "transparent";
        ae(h, function(M) {
          M.offset = (M.coord - m2) / _;
        }), h.push({ offset: v9 ? h[v9 - 1].offset : 0.5, color: f2[1] || "transparent" }), h.unshift({ offset: v9 ? h[0].offset : 0.5, color: f2[0] || "transparent" });
        var C = new LE(0, 0, 0, 0, h, true);
        return C[a] = m2, C[a + "2"] = b2, C;
      }
    }
  }
  function rde(r2, t2, e2) {
    var n2 = r2.get("showAllSymbol"), a = n2 === "auto";
    if (!(n2 && !a)) {
      var i = e2.getAxesByScale("ordinal")[0];
      if (!!i && !(a && nde(i, t2))) {
        var o = t2.mapDimension(i.dim), s = {};
        return ae(i.getViewLabels(), function(u) {
          var l2 = i.scale.getRawOrdinalNumber(u.tickValue);
          s[l2] = 1;
        }), function(u) {
          return !s.hasOwnProperty(t2.get(o, u));
        };
      }
    }
  }
  function nde(r2, t2) {
    var e2 = r2.getExtent(), n2 = Math.abs(e2[1] - e2[0]) / r2.scale.count();
    isNaN(n2) && (n2 = 0);
    for (var a = t2.count(), i = Math.max(1, Math.round(a / 5)), o = 0; o < a; o += i)
      if ($E.getSymbolSize(t2, o)[r2.isHorizontal() ? 1 : 0] * 1.5 > n2)
        return false;
    return true;
  }
  function ade(r2, t2) {
    return isNaN(r2) || isNaN(t2);
  }
  function ide(r2) {
    for (var t2 = r2.length / 2; t2 > 0 && ade(r2[t2 * 2 - 2], r2[t2 * 2 - 1]); t2--)
      ;
    return t2 - 1;
  }
  function Aj(r2, t2) {
    return [r2[t2 * 2], r2[t2 * 2 + 1]];
  }
  function ode(r2, t2, e2) {
    for (var n2 = r2.length / 2, a = e2 === "x" ? 0 : 1, i, o, s = 0, u = -1, l2 = 0; l2 < n2; l2++)
      if (o = r2[l2 * 2 + a], !(isNaN(o) || isNaN(r2[l2 * 2 + 1 - a]))) {
        if (l2 === 0) {
          i = o;
          continue;
        }
        if (i <= t2 && o >= t2 || i >= t2 && o <= t2) {
          u = l2;
          break;
        }
        s = l2, i = o;
      }
    return { range: [s, u], t: (t2 - i) / (o - i) };
  }
  function AY(r2) {
    if (r2.get(["endLabel", "show"]))
      return true;
    for (var t2 = 0; t2 < Nc.length; t2++)
      if (r2.get([Nc[t2], "endLabel", "show"]))
        return true;
    return false;
  }
  function fk(r2, t2, e2, n2) {
    if (Cg(t2, "cartesian2d")) {
      var a = n2.getModel("endLabel"), i = a.get("valueAnimation"), o = n2.getData(), s = { lastFrameIndex: 0 }, u = AY(n2) ? function(v9, d2) {
        r2._endLabelOnDuring(v9, d2, o, s, i, a, t2);
      } : null, l2 = t2.getBaseAxis().isHorizontal(), c2 = CY(t2, e2, n2, function() {
        var v9 = r2._endLabel;
        v9 && e2 && s.originalX != null && v9.attr({ x: s.originalX, y: s.originalY });
      }, u);
      if (!n2.get("clip", true)) {
        var f2 = c2.shape, h = Math.max(f2.width, f2.height);
        l2 ? (f2.y -= h, f2.height += h * 2) : (f2.x -= h, f2.width += h * 2);
      }
      return u && u(1, c2), c2;
    } else
      return EY(t2, e2, n2);
  }
  function sde(r2, t2) {
    var e2 = t2.getBaseAxis(), n2 = e2.isHorizontal(), a = e2.inverse, i = n2 ? a ? "right" : "left" : "center", o = n2 ? "middle" : a ? "top" : "bottom";
    return { normal: { align: r2.get("align") || i, verticalAlign: r2.get("verticalAlign") || o } };
  }
  var ude = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.init = function() {
      var e2 = new Fn(), n2 = new GE();
      this.group.add(n2.group), this._symbolDraw = n2, this._lineGroup = e2;
    }, t2.prototype.render = function(e2, n2, a) {
      var i = this, o = e2.coordinateSystem, s = this.group, u = e2.getData(), l2 = e2.getModel("lineStyle"), c2 = e2.getModel("areaStyle"), f2 = u.getLayout("points") || [], h = o.type === "polar", v9 = this._coordSys, d2 = this._symbolDraw, m2 = this._polyline, b2 = this._polygon, _ = this._lineGroup, C = e2.get("animation"), M = !c2.isEmpty(), E = c2.get("origin"), z9 = _Y(o, u, E), V = M && Qve(o, u, z9), $ = e2.get("showSymbol"), U = e2.get("connectNulls"), H = $ && !h && rde(e2, u, o), q3 = this._data;
      q3 && q3.eachItemGraphicEl(function(cn, nn) {
        cn.__temp && (s.remove(cn), q3.setItemGraphicEl(nn, null));
      }), $ || d2.remove(), s.add(_);
      var ee = h ? false : e2.get("step"), oe;
      o && o.getArea && e2.get("clip", true) && (oe = o.getArea(), oe.width != null ? (oe.x -= 0.1, oe.y -= 0.1, oe.width += 0.2, oe.height += 0.2) : oe.r0 && (oe.r0 -= 0.5, oe.r += 0.5)), this._clipShapeForSymbol = oe;
      var ne = tde(u, o, a) || u.getVisual("style")[u.getVisual("drawType")];
      if (!(m2 && v9.type === o.type && ee === this._step))
        $ && d2.updateData(u, { isIgnore: H, clipShape: oe, disableAnimation: true, getSymbolPoint: function(cn) {
          return [f2[cn * 2], f2[cn * 2 + 1]];
        } }), C && this._initSymbolLabelAnimation(u, o, oe), ee && (f2 = Z0(f2, o, ee, U), V && (V = Z0(V, o, ee, U))), m2 = this._newPolyline(f2), M && (b2 = this._newPolygon(f2, V)), h || this._initOrUpdateEndLabel(e2, o, n1(ne)), _.setClipPath(fk(this, o, true, e2));
      else {
        M && !b2 ? b2 = this._newPolygon(f2, V) : b2 && !M && (_.remove(b2), b2 = this._polygon = null), h || this._initOrUpdateEndLabel(e2, o, n1(ne));
        var be = _.getClipPath();
        if (be) {
          var Ee = fk(this, o, false, e2);
          rs(be, { shape: Ee.shape }, e2);
        } else
          _.setClipPath(fk(this, o, true, e2));
        $ && d2.updateData(u, { isIgnore: H, clipShape: oe, disableAnimation: true, getSymbolPoint: function(cn) {
          return [f2[cn * 2], f2[cn * 2 + 1]];
        } }), (!wj(this._stackedOnPoints, V) || !wj(this._points, f2)) && (C ? this._doUpdateAnimation(u, V, o, a, ee, E, U) : (ee && (f2 = Z0(f2, o, ee, U), V && (V = Z0(V, o, ee, U))), m2.setShape({ points: f2 }), b2 && b2.setShape({ points: f2, stackedOnPoints: V })));
      }
      var ye = e2.getModel("emphasis"), et = ye.get("focus"), Le = ye.get("blurScope"), Fe = ye.get("disabled");
      if (m2.useStyle(En(l2.getLineStyle(), { fill: "none", stroke: ne, lineJoin: "bevel" })), jl(m2, e2, "lineStyle"), m2.style.lineWidth > 0 && e2.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var qe = m2.getState("emphasis").style;
        qe.lineWidth = +m2.style.lineWidth + 1;
      }
      zn(m2).seriesIndex = e2.seriesIndex, ks(m2, et, Le, Fe);
      var st = Ej(e2.get("smooth")), dt = e2.get("smoothMonotone");
      if (m2.setShape({ smooth: st, smoothMonotone: dt, connectNulls: U }), b2) {
        var Ar = u.getCalculationInfo("stackedOnSeries"), Hr = 0;
        b2.useStyle(En(c2.getAreaStyle(), { fill: ne, opacity: 0.7, lineJoin: "bevel", decal: u.getVisual("style").decal })), Ar && (Hr = Ej(Ar.get("smooth"))), b2.setShape({ smooth: st, stackedOnSmooth: Hr, smoothMonotone: dt, connectNulls: U }), jl(b2, e2, "areaStyle"), zn(b2).seriesIndex = e2.seriesIndex, ks(b2, et, Le, Fe);
      }
      var hn = function(cn) {
        i._changePolyState(cn);
      };
      u.eachItemGraphicEl(function(cn) {
        cn && (cn.onHoverStateChange = hn);
      }), this._polyline.onHoverStateChange = hn, this._data = u, this._coordSys = o, this._stackedOnPoints = V, this._points = f2, this._step = ee, this._valueOrigin = E, e2.get("triggerLineEvent") && (this.packEventData(e2, m2), b2 && this.packEventData(e2, b2));
    }, t2.prototype.packEventData = function(e2, n2) {
      zn(n2).eventData = { componentType: "series", componentSubType: "line", componentIndex: e2.componentIndex, seriesIndex: e2.seriesIndex, seriesName: e2.name, seriesType: "line" };
    }, t2.prototype.highlight = function(e2, n2, a, i) {
      var o = e2.getData(), s = e1(o, i);
      if (this._changePolyState("emphasis"), !(s instanceof Array) && s != null && s >= 0) {
        var u = o.getLayout("points"), l2 = o.getItemGraphicEl(s);
        if (!l2) {
          var c2 = u[s * 2], f2 = u[s * 2 + 1];
          if (isNaN(c2) || isNaN(f2) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(c2, f2))
            return;
          var h = e2.get("zlevel"), v9 = e2.get("z");
          l2 = new $E(o, s), l2.x = c2, l2.y = f2, l2.setZ(h, v9);
          var d2 = l2.getSymbolPath().getTextContent();
          d2 && (d2.zlevel = h, d2.z = v9, d2.z2 = this._polyline.z2 + 1), l2.__temp = true, o.setItemGraphicEl(s, l2), l2.stopSymbolAnimation(true), this.group.add(l2);
        }
        l2.highlight();
      } else
        Mo.prototype.highlight.call(this, e2, n2, a, i);
    }, t2.prototype.downplay = function(e2, n2, a, i) {
      var o = e2.getData(), s = e1(o, i);
      if (this._changePolyState("normal"), s != null && s >= 0) {
        var u = o.getItemGraphicEl(s);
        u && (u.__temp ? (o.setItemGraphicEl(s, null), this.group.remove(u)) : u.downplay());
      } else
        Mo.prototype.downplay.call(this, e2, n2, a, i);
    }, t2.prototype._changePolyState = function(e2) {
      var n2 = this._polygon;
      Q5(this._polyline, e2), n2 && Q5(n2, e2);
    }, t2.prototype._newPolyline = function(e2) {
      var n2 = this._polyline;
      return n2 && this._lineGroup.remove(n2), n2 = new Xve({ shape: { points: e2 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(n2), this._polyline = n2, n2;
    }, t2.prototype._newPolygon = function(e2, n2) {
      var a = this._polygon;
      return a && this._lineGroup.remove(a), a = new SY({ shape: { points: e2, stackedOnPoints: n2 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(a), this._polygon = a, a;
    }, t2.prototype._initSymbolLabelAnimation = function(e2, n2, a) {
      var i, o, s = n2.getBaseAxis(), u = s.inverse;
      n2.type === "cartesian2d" ? (i = s.isHorizontal(), o = false) : n2.type === "polar" && (i = s.dim === "angle", o = true);
      var l2 = e2.hostModel, c2 = l2.get("animationDuration");
      xn(c2) && (c2 = c2(null));
      var f2 = l2.get("animationDelay") || 0, h = xn(f2) ? f2(null) : f2;
      e2.eachItemGraphicEl(function(v9, d2) {
        var m2 = v9;
        if (m2) {
          var b2 = [v9.x, v9.y], _ = void 0, C = void 0, M = void 0;
          if (a)
            if (o) {
              var E = a, z9 = n2.pointToCoord(b2);
              i ? (_ = E.startAngle, C = E.endAngle, M = -z9[1] / 180 * Math.PI) : (_ = E.r0, C = E.r, M = z9[0]);
            } else {
              var V = a;
              i ? (_ = V.x, C = V.x + V.width, M = v9.x) : (_ = V.y + V.height, C = V.y, M = v9.y);
            }
          var $ = C === _ ? 0 : (M - _) / (C - _);
          u && ($ = 1 - $);
          var U = xn(f2) ? f2(d2) : c2 * $ + h, H = m2.getSymbolPath(), q3 = H.getTextContent();
          m2.attr({ scaleX: 0, scaleY: 0 }), m2.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: U }), q3 && q3.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: U }), H.disableLabelAnimation = true;
        }
      });
    }, t2.prototype._initOrUpdateEndLabel = function(e2, n2, a) {
      var i = e2.getModel("endLabel");
      if (AY(e2)) {
        var o = e2.getData(), s = this._polyline, u = o.getLayout("points");
        if (!u) {
          s.removeTextContent(), this._endLabel = null;
          return;
        }
        var l2 = this._endLabel;
        l2 || (l2 = this._endLabel = new xi({ z2: 200 }), l2.ignoreClip = true, s.setTextContent(this._endLabel), s.disableLabelAnimation = true);
        var c2 = ide(u);
        c2 >= 0 && (fc(s, _l(e2, "endLabel"), { inheritColor: a, labelFetcher: e2, labelDataIndex: c2, defaultText: function(f2, h, v9) {
          return v9 != null ? bY(o, v9) : iw(o, f2);
        }, enableTextSetter: true }, sde(i, n2)), s.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, t2.prototype._endLabelOnDuring = function(e2, n2, a, i, o, s, u) {
      var l2 = this._endLabel, c2 = this._polyline;
      if (l2) {
        e2 < 1 && i.originalX == null && (i.originalX = l2.x, i.originalY = l2.y);
        var f2 = a.getLayout("points"), h = a.hostModel, v9 = h.get("connectNulls"), d2 = s.get("precision"), m2 = s.get("distance") || 0, b2 = u.getBaseAxis(), _ = b2.isHorizontal(), C = b2.inverse, M = n2.shape, E = C ? _ ? M.x : M.y + M.height : _ ? M.x + M.width : M.y, z9 = (_ ? m2 : 0) * (C ? -1 : 1), V = (_ ? 0 : -m2) * (C ? -1 : 1), $ = _ ? "x" : "y", U = ode(f2, E, $), H = U.range, q3 = H[1] - H[0], ee = void 0;
        if (q3 >= 1) {
          if (q3 > 1 && !v9) {
            var oe = Aj(f2, H[0]);
            l2.attr({ x: oe[0] + z9, y: oe[1] + V }), o && (ee = h.getRawValue(H[0]));
          } else {
            var oe = c2.getPointOn(E, $);
            oe && l2.attr({ x: oe[0] + z9, y: oe[1] + V });
            var ne = h.getRawValue(H[0]), be = h.getRawValue(H[1]);
            o && (ee = qW(a, d2, ne, be, U.t));
          }
          i.lastFrameIndex = H[0];
        } else {
          var Ee = e2 === 1 || i.lastFrameIndex > 0 ? H[0] : 0, oe = Aj(f2, Ee);
          o && (ee = h.getRawValue(Ee)), l2.attr({ x: oe[0] + z9, y: oe[1] + V });
        }
        o && gw(l2).setLabelText(ee);
      }
    }, t2.prototype._doUpdateAnimation = function(e2, n2, a, i, o, s, u) {
      var l2 = this._polyline, c2 = this._polygon, f2 = e2.hostModel, h = Zve(this._data, e2, this._stackedOnPoints, n2, this._coordSys, a, this._valueOrigin), v9 = h.current, d2 = h.stackedOnCurrent, m2 = h.next, b2 = h.stackedOnNext;
      if (o && (v9 = Z0(h.current, a, o, u), d2 = Z0(h.stackedOnCurrent, a, o, u), m2 = Z0(h.next, a, o, u), b2 = Z0(h.stackedOnNext, a, o, u)), Cj(v9, m2) > 3e3 || c2 && Cj(d2, b2) > 3e3) {
        l2.stopAnimation(), l2.setShape({ points: m2 }), c2 && (c2.stopAnimation(), c2.setShape({ points: m2, stackedOnPoints: b2 }));
        return;
      }
      l2.shape.__points = h.current, l2.shape.points = v9;
      var _ = { shape: { points: m2 } };
      h.current !== v9 && (_.shape.__points = h.next), l2.stopAnimation(), ci(l2, _, f2), c2 && (c2.setShape({ points: v9, stackedOnPoints: d2 }), c2.stopAnimation(), ci(c2, { shape: { stackedOnPoints: b2 } }, f2), l2.shape.points !== c2.shape.points && (c2.shape.points = l2.shape.points));
      for (var C = [], M = h.status, E = 0; E < M.length; E++) {
        var z9 = M[E].cmd;
        if (z9 === "=") {
          var V = e2.getItemGraphicEl(M[E].idx1);
          V && C.push({ el: V, ptIdx: E });
        }
      }
      l2.animators && l2.animators.length && l2.animators[0].during(function() {
        c2 && c2.dirtyShape();
        for (var $ = l2.shape.__points, U = 0; U < C.length; U++) {
          var H = C[U].el, q3 = C[U].ptIdx * 2;
          H.x = $[q3], H.y = $[q3 + 1], H.markRedraw();
        }
      });
    }, t2.prototype.remove = function(e2) {
      var n2 = this.group, a = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(true), a && a.eachItemGraphicEl(function(i, o) {
        i.__temp && (n2.remove(i), a.setItemGraphicEl(o, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, t2.type = "line", t2;
  }(Mo), lde = ude;
  function WE(r2, t2) {
    return { seriesType: r2, plan: ww(), reset: function(e2) {
      var n2 = e2.getData(), a = e2.coordinateSystem, i = e2.pipelineContext, o = t2 || i.large;
      if (!!a) {
        var s = pr(a.dimensions, function(v9) {
          return n2.mapDimension(v9);
        }).slice(0, 2), u = s.length, l2 = n2.getCalculationInfo("stackResultDimension");
        _y(n2, s[0]) && (s[0] = l2), _y(n2, s[1]) && (s[1] = l2);
        var c2 = n2.getStore(), f2 = n2.getDimensionIndex(s[0]), h = n2.getDimensionIndex(s[1]);
        return u && { progress: function(v9, d2) {
          for (var m2 = v9.end - v9.start, b2 = o && qd(m2 * u), _ = [], C = [], M = v9.start, E = 0; M < v9.end; M++) {
            var z9 = void 0;
            if (u === 1) {
              var V = c2.get(f2, M);
              z9 = a.dataToPoint(V, null, C);
            } else
              _[0] = c2.get(f2, M), _[1] = c2.get(h, M), z9 = a.dataToPoint(_, null, C);
            o ? (b2[E++] = z9[0], b2[E++] = z9[1]) : d2.setItemLayout(M, z9.slice());
          }
          o && d2.setLayout("points", b2);
        } };
      }
    } };
  }
  var cde = { average: function(r2) {
    for (var t2 = 0, e2 = 0, n2 = 0; n2 < r2.length; n2++)
      isNaN(r2[n2]) || (t2 += r2[n2], e2++);
    return e2 === 0 ? NaN : t2 / e2;
  }, sum: function(r2) {
    for (var t2 = 0, e2 = 0; e2 < r2.length; e2++)
      t2 += r2[e2] || 0;
    return t2;
  }, max: function(r2) {
    for (var t2 = -1 / 0, e2 = 0; e2 < r2.length; e2++)
      r2[e2] > t2 && (t2 = r2[e2]);
    return isFinite(t2) ? t2 : NaN;
  }, min: function(r2) {
    for (var t2 = 1 / 0, e2 = 0; e2 < r2.length; e2++)
      r2[e2] < t2 && (t2 = r2[e2]);
    return isFinite(t2) ? t2 : NaN;
  }, nearest: function(r2) {
    return r2[0];
  } }, fde = function(r2) {
    return Math.round(r2.length / 2);
  };
  function TY(r2) {
    return { seriesType: r2, reset: function(t2, e2, n2) {
      var a = t2.getData(), i = t2.get("sampling"), o = t2.coordinateSystem, s = a.count();
      if (s > 10 && o.type === "cartesian2d" && i) {
        var u = o.getBaseAxis(), l2 = o.getOtherAxis(u), c2 = u.getExtent(), f2 = n2.getDevicePixelRatio(), h = Math.abs(c2[1] - c2[0]) * (f2 || 1), v9 = Math.round(s / h);
        if (isFinite(v9) && v9 > 1) {
          i === "lttb" && t2.setData(a.lttbDownSample(a.mapDimension(l2.dim), 1 / v9));
          var d2 = void 0;
          Zr(i) ? d2 = cde[i] : xn(i) && (d2 = i), d2 && t2.setData(a.downSample(a.mapDimension(l2.dim), 1 / v9, d2, fde));
        }
      }
    } };
  }
  function hde(r2) {
    r2.registerChartView(lde), r2.registerSeriesModel(Wve), r2.registerLayout(WE("line", true)), r2.registerVisual({ seriesType: "line", reset: function(t2) {
      var e2 = t2.getData(), n2 = t2.getModel("lineStyle").getLineStyle();
      n2 && !n2.stroke && (n2.stroke = e2.getVisual("style").fill), e2.setVisual("legendLineStyle", n2);
    } }), r2.registerProcessor(r2.PRIORITY.PROCESSOR.STATISTIC, TY("line"));
  }
  var MY = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this, { useEncodeDefaulter: true });
    }, t2.prototype.getMarkerPosition = function(e2) {
      var n2 = this.coordinateSystem;
      if (n2 && n2.clampData) {
        var a = n2.dataToPoint(n2.clampData(e2)), i = this.getData(), o = i.getLayout("offset"), s = i.getLayout("size"), u = n2.getBaseAxis().isHorizontal() ? 0 : 1;
        return a[u] += o + s / 2, a;
      }
      return [NaN, NaN];
    }, t2.type = "series.__base_bar__", t2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, t2;
  }(ns);
  ns.registerClass(MY);
  var mP = MY, vde = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.getInitialData = function() {
      return kg(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
    }, t2.prototype.getProgressive = function() {
      return this.get("large") ? this.get("progressive") : false;
    }, t2.prototype.getProgressiveThreshold = function() {
      var e2 = this.get("progressiveThreshold"), n2 = this.get("largeThreshold");
      return n2 > e2 && (e2 = n2), e2;
    }, t2.prototype.brushSelector = function(e2, n2, a) {
      return a.rect(n2.getItemLayout(e2));
    }, t2.type = "series.bar", t2.dependencies = ["grid", "polar"], t2.defaultOption = Ty(mP.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), t2;
  }(mP), dde = vde, pde = function() {
    function r2() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return r2;
  }(), gde = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "sausage", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new pde();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.cx, i = n2.cy, o = Math.max(n2.r0 || 0, 0), s = Math.max(n2.r, 0), u = (s - o) * 0.5, l2 = o + u, c2 = n2.startAngle, f2 = n2.endAngle, h = n2.clockwise, v9 = Math.PI * 2, d2 = h ? f2 - c2 < v9 : c2 - f2 < v9;
      d2 || (c2 = f2 - (h ? v9 : -v9));
      var m2 = Math.cos(c2), b2 = Math.sin(c2), _ = Math.cos(f2), C = Math.sin(f2);
      d2 ? (e2.moveTo(m2 * o + a, b2 * o + i), e2.arc(m2 * l2 + a, b2 * l2 + i, u, -Math.PI + c2, c2, !h)) : e2.moveTo(m2 * s + a, b2 * s + i), e2.arc(a, i, s, c2, f2, !h), e2.arc(_ * l2 + a, C * l2 + i, u, f2 - Math.PI * 2, f2 - Math.PI, !h), o !== 0 && e2.arc(a, i, o, f2, c2, h);
    }, t2;
  }(xa), bP = gde;
  function yde(r2, t2) {
    t2 = t2 || {};
    var e2 = t2.isRoundCap;
    return function(n2, a, i) {
      var o = a.position;
      if (!o || o instanceof Array)
        return Z5(n2, a, i);
      var s = r2(o), u = a.distance != null ? a.distance : 5, l2 = this.shape, c2 = l2.cx, f2 = l2.cy, h = l2.r, v9 = l2.r0, d2 = (h + v9) / 2, m2 = l2.startAngle, b2 = l2.endAngle, _ = (m2 + b2) / 2, C = e2 ? Math.abs(h - v9) / 2 : 0, M = Math.cos, E = Math.sin, z9 = c2 + h * M(m2), V = f2 + h * E(m2), $ = "left", U = "top";
      switch (s) {
        case "startArc":
          z9 = c2 + (v9 - u) * M(_), V = f2 + (v9 - u) * E(_), $ = "center", U = "top";
          break;
        case "insideStartArc":
          z9 = c2 + (v9 + u) * M(_), V = f2 + (v9 + u) * E(_), $ = "center", U = "bottom";
          break;
        case "startAngle":
          z9 = c2 + d2 * M(m2) + YM(m2, u + C, false), V = f2 + d2 * E(m2) + KM(m2, u + C, false), $ = "right", U = "middle";
          break;
        case "insideStartAngle":
          z9 = c2 + d2 * M(m2) + YM(m2, -u + C, false), V = f2 + d2 * E(m2) + KM(m2, -u + C, false), $ = "left", U = "middle";
          break;
        case "middle":
          z9 = c2 + d2 * M(_), V = f2 + d2 * E(_), $ = "center", U = "middle";
          break;
        case "endArc":
          z9 = c2 + (h + u) * M(_), V = f2 + (h + u) * E(_), $ = "center", U = "bottom";
          break;
        case "insideEndArc":
          z9 = c2 + (h - u) * M(_), V = f2 + (h - u) * E(_), $ = "center", U = "top";
          break;
        case "endAngle":
          z9 = c2 + d2 * M(b2) + YM(b2, u + C, true), V = f2 + d2 * E(b2) + KM(b2, u + C, true), $ = "left", U = "middle";
          break;
        case "insideEndAngle":
          z9 = c2 + d2 * M(b2) + YM(b2, -u + C, true), V = f2 + d2 * E(b2) + KM(b2, -u + C, true), $ = "right", U = "middle";
          break;
        default:
          return Z5(n2, a, i);
      }
      return n2 = n2 || {}, n2.x = z9, n2.y = V, n2.align = $, n2.verticalAlign = U, n2;
    };
  }
  function mde(r2, t2, e2, n2) {
    if (Ai(n2)) {
      r2.setTextConfig({ rotation: n2 });
      return;
    } else if (vr(t2)) {
      r2.setTextConfig({ rotation: 0 });
      return;
    }
    var a = r2.shape, i = a.clockwise ? a.startAngle : a.endAngle, o = a.clockwise ? a.endAngle : a.startAngle, s = (i + o) / 2, u, l2 = e2(t2);
    switch (l2) {
      case "startArc":
      case "insideStartArc":
      case "middle":
      case "insideEndArc":
      case "endArc":
        u = s;
        break;
      case "startAngle":
      case "insideStartAngle":
        u = i;
        break;
      case "endAngle":
      case "insideEndAngle":
        u = o;
        break;
      default:
        r2.setTextConfig({ rotation: 0 });
        return;
    }
    var c2 = Math.PI * 1.5 - u;
    l2 === "middle" && c2 > Math.PI / 2 && c2 < Math.PI * 1.5 && (c2 -= Math.PI), r2.setTextConfig({ rotation: c2 });
  }
  function YM(r2, t2, e2) {
    return t2 * Math.sin(r2) * (e2 ? -1 : 1);
  }
  function KM(r2, t2, e2) {
    return t2 * Math.cos(r2) * (e2 ? 1 : -1);
  }
  var hk = Math.max, vk = Math.min;
  function bde(r2, t2) {
    var e2 = r2.getArea && r2.getArea();
    if (Cg(r2, "cartesian2d")) {
      var n2 = r2.getBaseAxis();
      if (n2.type !== "category" || !n2.onBand) {
        var a = t2.getLayout("bandWidth");
        n2.isHorizontal() ? (e2.x -= a, e2.width += a * 2) : (e2.y -= a, e2.height += a * 2);
      }
    }
    return e2;
  }
  var _de = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2.call(this) || this;
      return e2.type = t2.type, e2._isFirstFrame = true, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this._model = e2, this._removeOnRenderedListener(a), this._updateDrawMode(e2);
      var o = e2.get("coordinateSystem");
      (o === "cartesian2d" || o === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e2, n2, a) : this._renderNormal(e2, n2, a, i));
    }, t2.prototype.incrementalPrepareRender = function(e2) {
      this._clear(), this._updateDrawMode(e2), this._updateLargeClip(e2);
    }, t2.prototype.incrementalRender = function(e2, n2) {
      this._progressiveEls = [], this._incrementalRenderLarge(e2, n2);
    }, t2.prototype.eachRendered = function(e2) {
      Ay(this._progressiveEls || this.group, e2);
    }, t2.prototype._updateDrawMode = function(e2) {
      var n2 = e2.pipelineContext.large;
      (this._isLargeDraw == null || n2 !== this._isLargeDraw) && (this._isLargeDraw = n2, this._clear());
    }, t2.prototype._renderNormal = function(e2, n2, a, i) {
      var o = this.group, s = e2.getData(), u = this._data, l2 = e2.coordinateSystem, c2 = l2.getBaseAxis(), f2;
      l2.type === "cartesian2d" ? f2 = c2.isHorizontal() : l2.type === "polar" && (f2 = c2.dim === "angle");
      var h = e2.isAnimationEnabled() ? e2 : null, v9 = xde(e2, l2);
      v9 && this._enableRealtimeSort(v9, s, a);
      var d2 = e2.get("clip", true) || v9, m2 = bde(l2, s);
      o.removeClipPath();
      var b2 = e2.get("roundCap", true), _ = e2.get("showBackground", true), C = e2.getModel("backgroundStyle"), M = C.get("borderRadius") || 0, E = [], z9 = this._backgroundEls, V = i && i.isInitSort, $ = i && i.type === "changeAxisOrder";
      function U(ee) {
        var oe = ZM[l2.type](s, ee), ne = Mde(l2, f2, oe);
        return ne.useStyle(C.getItemStyle()), l2.type === "cartesian2d" && ne.setShape("r", M), E[ee] = ne, ne;
      }
      s.diff(u).add(function(ee) {
        var oe = s.getItemModel(ee), ne = ZM[l2.type](s, ee, oe);
        if (_ && U(ee), !(!s.hasValue(ee) || !Ij[l2.type](ne))) {
          var be = false;
          d2 && (be = Tj[l2.type](m2, ne));
          var Ee = Mj[l2.type](e2, s, ee, ne, f2, h, c2.model, false, b2);
          v9 && (Ee.forceLabelAnimation = true), Lj(Ee, s, ee, oe, ne, e2, f2, l2.type === "polar"), V ? Ee.attr({ shape: ne }) : v9 ? Pj(v9, h, Ee, ne, ee, f2, false, false) : rs(Ee, { shape: ne }, e2, ee), s.setItemGraphicEl(ee, Ee), o.add(Ee), Ee.ignore = be;
        }
      }).update(function(ee, oe) {
        var ne = s.getItemModel(ee), be = ZM[l2.type](s, ee, ne);
        if (_) {
          var Ee = void 0;
          z9.length === 0 ? Ee = U(oe) : (Ee = z9[oe], Ee.useStyle(C.getItemStyle()), l2.type === "cartesian2d" && Ee.setShape("r", M), E[ee] = Ee);
          var ye = ZM[l2.type](s, ee), et = DY(f2, ye, l2);
          ci(Ee, { shape: et }, h, ee);
        }
        var Le = u.getItemGraphicEl(oe);
        if (!s.hasValue(ee) || !Ij[l2.type](be)) {
          o.remove(Le);
          return;
        }
        var Fe = false;
        if (d2 && (Fe = Tj[l2.type](m2, be), Fe && o.remove(Le)), Le ? Wv(Le) : Le = Mj[l2.type](e2, s, ee, be, f2, h, c2.model, !!Le, b2), v9 && (Le.forceLabelAnimation = true), $) {
          var qe = Le.getTextContent();
          if (qe) {
            var st = gw(qe);
            st.prevValue != null && (st.prevValue = st.value);
          }
        } else
          Lj(Le, s, ee, ne, be, e2, f2, l2.type === "polar");
        V ? Le.attr({ shape: be }) : v9 ? Pj(v9, h, Le, be, ee, f2, true, $) : ci(Le, { shape: be }, e2, ee, null), s.setItemGraphicEl(ee, Le), Le.ignore = Fe, o.add(Le);
      }).remove(function(ee) {
        var oe = u.getItemGraphicEl(ee);
        oe && aE(oe, e2, ee);
      }).execute();
      var H = this._backgroundGroup || (this._backgroundGroup = new Fn());
      H.removeAll();
      for (var q3 = 0; q3 < E.length; ++q3)
        H.add(E[q3]);
      o.add(H), this._backgroundEls = E, this._data = s;
    }, t2.prototype._renderLarge = function(e2, n2, a) {
      this._clear(), kj(e2, this.group), this._updateLargeClip(e2);
    }, t2.prototype._incrementalRenderLarge = function(e2, n2) {
      this._removeBackground(), kj(n2, this.group, this._progressiveEls, true);
    }, t2.prototype._updateLargeClip = function(e2) {
      var n2 = e2.get("clip", true) && _3(e2.coordinateSystem, false, e2), a = this.group;
      n2 ? a.setClipPath(n2) : a.removeClipPath();
    }, t2.prototype._enableRealtimeSort = function(e2, n2, a) {
      var i = this;
      if (!!n2.count()) {
        var o = e2.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(n2, e2, a), this._isFirstFrame = false;
        else {
          var s = function(u) {
            var l2 = n2.getItemGraphicEl(u), c2 = l2 && l2.shape;
            return c2 && Math.abs(o.isHorizontal() ? c2.height : c2.width) || 0;
          };
          this._onRendered = function() {
            i._updateSortWithinSameData(n2, s, o, a);
          }, a.getZr().on("rendered", this._onRendered);
        }
      }
    }, t2.prototype._dataSort = function(e2, n2, a) {
      var i = [];
      return e2.each(e2.mapDimension(n2.dim), function(o, s) {
        var u = a(s);
        u = u == null ? NaN : u, i.push({ dataIndex: s, mappedValue: u, ordinalNumber: o });
      }), i.sort(function(o, s) {
        return s.mappedValue - o.mappedValue;
      }), { ordinalNumbers: pr(i, function(o) {
        return o.ordinalNumber;
      }) };
    }, t2.prototype._isOrderChangedWithinSameData = function(e2, n2, a) {
      for (var i = a.scale, o = e2.mapDimension(a.dim), s = Number.MAX_VALUE, u = 0, l2 = i.getOrdinalMeta().categories.length; u < l2; ++u) {
        var c2 = e2.rawIndexOf(o, i.getRawOrdinalNumber(u)), f2 = c2 < 0 ? Number.MIN_VALUE : n2(e2.indexOfRawIndex(c2));
        if (f2 > s)
          return true;
        s = f2;
      }
      return false;
    }, t2.prototype._isOrderDifferentInView = function(e2, n2) {
      for (var a = n2.scale, i = a.getExtent(), o = Math.max(0, i[0]), s = Math.min(i[1], a.getOrdinalMeta().categories.length - 1); o <= s; ++o)
        if (e2.ordinalNumbers[o] !== a.getRawOrdinalNumber(o))
          return true;
    }, t2.prototype._updateSortWithinSameData = function(e2, n2, a, i) {
      if (!!this._isOrderChangedWithinSameData(e2, n2, a)) {
        var o = this._dataSort(e2, a, n2);
        this._isOrderDifferentInView(o, a) && (this._removeOnRenderedListener(i), i.dispatchAction({ type: "changeAxisOrder", componentType: a.dim + "Axis", axisId: a.index, sortInfo: o }));
      }
    }, t2.prototype._dispatchInitSort = function(e2, n2, a) {
      var i = n2.baseAxis, o = this._dataSort(e2, i, function(s) {
        return e2.get(e2.mapDimension(n2.otherAxis.dim), s);
      });
      a.dispatchAction({ type: "changeAxisOrder", componentType: i.dim + "Axis", isInitSort: true, axisId: i.index, sortInfo: o });
    }, t2.prototype.remove = function(e2, n2) {
      this._clear(this._model), this._removeOnRenderedListener(n2);
    }, t2.prototype.dispose = function(e2, n2) {
      this._removeOnRenderedListener(n2);
    }, t2.prototype._removeOnRenderedListener = function(e2) {
      this._onRendered && (e2.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, t2.prototype._clear = function(e2) {
      var n2 = this.group, a = this._data;
      e2 && e2.isAnimationEnabled() && a && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], a.eachItemGraphicEl(function(i) {
        aE(i, e2, zn(i).dataIndex);
      })) : n2.removeAll(), this._data = null, this._isFirstFrame = true;
    }, t2.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, t2.type = "bar", t2;
  }(Mo), Tj = { cartesian2d: function(r2, t2) {
    var e2 = t2.width < 0 ? -1 : 1, n2 = t2.height < 0 ? -1 : 1;
    e2 < 0 && (t2.x += t2.width, t2.width = -t2.width), n2 < 0 && (t2.y += t2.height, t2.height = -t2.height);
    var a = r2.x + r2.width, i = r2.y + r2.height, o = hk(t2.x, r2.x), s = vk(t2.x + t2.width, a), u = hk(t2.y, r2.y), l2 = vk(t2.y + t2.height, i), c2 = s < o, f2 = l2 < u;
    return t2.x = c2 && o > a ? s : o, t2.y = f2 && u > i ? l2 : u, t2.width = c2 ? 0 : s - o, t2.height = f2 ? 0 : l2 - u, e2 < 0 && (t2.x += t2.width, t2.width = -t2.width), n2 < 0 && (t2.y += t2.height, t2.height = -t2.height), c2 || f2;
  }, polar: function(r2, t2) {
    var e2 = t2.r0 <= t2.r ? 1 : -1;
    if (e2 < 0) {
      var n2 = t2.r;
      t2.r = t2.r0, t2.r0 = n2;
    }
    var a = vk(t2.r, r2.r), i = hk(t2.r0, r2.r0);
    t2.r = a, t2.r0 = i;
    var o = a - i < 0;
    if (e2 < 0) {
      var n2 = t2.r;
      t2.r = t2.r0, t2.r0 = n2;
    }
    return o;
  } }, Mj = { cartesian2d: function(r2, t2, e2, n2, a, i, o, s, u) {
    var l2 = new ni({ shape: qt({}, n2), z2: 1 });
    if (l2.__dataIndex = e2, l2.name = "item", i) {
      var c2 = l2.shape, f2 = a ? "height" : "width";
      c2[f2] = 0;
    }
    return l2;
  }, polar: function(r2, t2, e2, n2, a, i, o, s, u) {
    var l2 = !a && u ? bP : pf, c2 = new l2({ shape: n2, z2: 1 });
    c2.name = "item";
    var f2 = PY(a);
    if (c2.calculateTextPosition = yde(f2, { isRoundCap: l2 === bP }), i) {
      var h = c2.shape, v9 = a ? "r" : "endAngle", d2 = {};
      h[v9] = a ? 0 : n2.startAngle, d2[v9] = n2[v9], (s ? ci : rs)(c2, { shape: d2 }, i);
    }
    return c2;
  } };
  function xde(r2, t2) {
    var e2 = r2.get("realtimeSort", true), n2 = t2.getBaseAxis();
    if (e2 && n2.type === "category" && t2.type === "cartesian2d")
      return { baseAxis: n2, otherAxis: t2.getOtherAxis(n2) };
  }
  function Pj(r2, t2, e2, n2, a, i, o, s) {
    var u, l2;
    i ? (l2 = { x: n2.x, width: n2.width }, u = { y: n2.y, height: n2.height }) : (l2 = { y: n2.y, height: n2.height }, u = { x: n2.x, width: n2.width }), s || (o ? ci : rs)(e2, { shape: u }, t2, a, null);
    var c2 = t2 ? r2.baseAxis.model : null;
    (o ? ci : rs)(e2, { shape: l2 }, c2, a);
  }
  function Dj(r2, t2) {
    for (var e2 = 0; e2 < t2.length; e2++)
      if (!isFinite(r2[t2[e2]]))
        return true;
    return false;
  }
  var wde = ["x", "y", "width", "height"], Sde = ["cx", "cy", "r", "startAngle", "endAngle"], Ij = { cartesian2d: function(r2) {
    return !Dj(r2, wde);
  }, polar: function(r2) {
    return !Dj(r2, Sde);
  } }, ZM = { cartesian2d: function(r2, t2, e2) {
    var n2 = r2.getItemLayout(t2), a = e2 ? Ede(e2, n2) : 0, i = n2.width > 0 ? 1 : -1, o = n2.height > 0 ? 1 : -1;
    return { x: n2.x + i * a / 2, y: n2.y + o * a / 2, width: n2.width - i * a, height: n2.height - o * a };
  }, polar: function(r2, t2, e2) {
    var n2 = r2.getItemLayout(t2);
    return { cx: n2.cx, cy: n2.cy, r0: n2.r0, r: n2.r, startAngle: n2.startAngle, endAngle: n2.endAngle, clockwise: n2.clockwise };
  } };
  function Cde(r2) {
    return r2.startAngle != null && r2.endAngle != null && r2.startAngle === r2.endAngle;
  }
  function PY(r2) {
    return function(t2) {
      var e2 = t2 ? "Arc" : "Angle";
      return function(n2) {
        switch (n2) {
          case "start":
          case "insideStart":
          case "end":
          case "insideEnd":
            return n2 + e2;
          default:
            return n2;
        }
      };
    }(r2);
  }
  function Lj(r2, t2, e2, n2, a, i, o, s) {
    var u = t2.getItemVisual(e2, "style");
    s || r2.setShape("r", n2.get(["itemStyle", "borderRadius"]) || 0), r2.useStyle(u);
    var l2 = n2.getShallow("cursor");
    l2 && r2.attr("cursor", l2);
    var c2 = s ? o ? a.r >= a.r0 ? "endArc" : "startArc" : a.endAngle >= a.startAngle ? "endAngle" : "startAngle" : o ? a.height >= 0 ? "bottom" : "top" : a.width >= 0 ? "right" : "left", f2 = _l(n2);
    fc(r2, f2, { labelFetcher: i, labelDataIndex: e2, defaultText: iw(i.getData(), e2), inheritColor: u.fill, defaultOpacity: u.opacity, defaultOutsidePosition: c2 });
    var h = r2.getTextContent();
    if (s && h) {
      var v9 = n2.get(["label", "position"]);
      r2.textConfig.inside = v9 === "middle" ? true : null, mde(r2, v9 === "outside" ? c2 : v9, PY(o), n2.get(["label", "rotate"]));
    }
    UU(h, f2, i.getRawValue(e2), function(m2) {
      return bY(t2, m2);
    });
    var d2 = n2.getModel(["emphasis"]);
    ks(r2, d2.get("focus"), d2.get("blurScope"), d2.get("disabled")), jl(r2, n2), Cde(a) && (r2.style.fill = "none", r2.style.stroke = "none", ae(r2.states, function(m2) {
      m2.style && (m2.style.fill = m2.style.stroke = "none");
    }));
  }
  function Ede(r2, t2) {
    var e2 = r2.get(["itemStyle", "borderColor"]);
    if (!e2 || e2 === "none")
      return 0;
    var n2 = r2.get(["itemStyle", "borderWidth"]) || 0, a = isNaN(t2.width) ? Number.MAX_VALUE : Math.abs(t2.width), i = isNaN(t2.height) ? Number.MAX_VALUE : Math.abs(t2.height);
    return Math.min(n2, a, i);
  }
  var Ade = function() {
    function r2() {
    }
    return r2;
  }(), Oj = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "largeBar", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Ade();
    }, t2.prototype.buildPath = function(e2, n2) {
      for (var a = n2.points, i = this.baseDimIdx, o = 1 - this.baseDimIdx, s = [], u = [], l2 = this.barWidth, c2 = 0; c2 < a.length; c2 += 3)
        u[i] = l2, u[o] = a[c2 + 2], s[i] = a[c2 + i], s[o] = a[c2 + o], e2.rect(s[0], s[1], u[0], u[1]);
    }, t2;
  }(xa);
  function kj(r2, t2, e2, n2) {
    var a = r2.getData(), i = a.getLayout("valueAxisHorizontal") ? 1 : 0, o = a.getLayout("largeDataIndices"), s = a.getLayout("size"), u = r2.getModel("backgroundStyle"), l2 = a.getLayout("largeBackgroundPoints");
    if (l2) {
      var c2 = new Oj({ shape: { points: l2 }, incremental: !!n2, silent: true, z2: 0 });
      c2.baseDimIdx = i, c2.largeDataIndices = o, c2.barWidth = s, c2.useStyle(u.getItemStyle()), t2.add(c2), e2 && e2.push(c2);
    }
    var f2 = new Oj({ shape: { points: a.getLayout("largePoints") }, incremental: !!n2, z2: 1 });
    f2.baseDimIdx = i, f2.largeDataIndices = o, f2.barWidth = s, t2.add(f2), f2.useStyle(a.getVisual("style")), zn(f2).seriesIndex = r2.seriesIndex, r2.get("silent") || (f2.on("mousedown", Rj), f2.on("mousemove", Rj)), e2 && e2.push(f2);
  }
  var Rj = SF(function(r2) {
    var t2 = this, e2 = Tde(t2, r2.offsetX, r2.offsetY);
    zn(t2).dataIndex = e2 >= 0 ? e2 : null;
  }, 30, false);
  function Tde(r2, t2, e2) {
    for (var n2 = r2.baseDimIdx, a = 1 - n2, i = r2.shape.points, o = r2.largeDataIndices, s = [], u = [], l2 = r2.barWidth, c2 = 0, f2 = i.length / 3; c2 < f2; c2++) {
      var h = c2 * 3;
      if (u[n2] = l2, u[a] = i[h + 2], s[n2] = i[h + n2], s[a] = i[h + a], u[a] < 0 && (s[a] += u[a], u[a] = -u[a]), t2 >= s[0] && t2 <= s[0] + u[0] && e2 >= s[1] && e2 <= s[1] + u[1])
        return o[c2];
    }
    return -1;
  }
  function DY(r2, t2, e2) {
    if (Cg(e2, "cartesian2d")) {
      var n2 = t2, a = e2.getArea();
      return { x: r2 ? n2.x : a.x, y: r2 ? a.y : n2.y, width: r2 ? n2.width : a.width, height: r2 ? a.height : n2.height };
    } else {
      var a = e2.getArea(), i = t2;
      return { cx: a.cx, cy: a.cy, r0: r2 ? a.r0 : i.r0, r: r2 ? a.r : i.r, startAngle: r2 ? i.startAngle : 0, endAngle: r2 ? i.endAngle : Math.PI * 2 };
    }
  }
  function Mde(r2, t2, e2) {
    var n2 = r2.type === "polar" ? pf : ni;
    return new n2({ shape: DY(t2, e2, r2), silent: true, z2: 0 });
  }
  var Pde = _de;
  function Dde(r2) {
    r2.registerChartView(Pde), r2.registerSeriesModel(dde), r2.registerLayout(r2.PRIORITY.VISUAL.LAYOUT, Gn(Fq, "bar")), r2.registerLayout(r2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, Nq("bar")), r2.registerProcessor(r2.PRIORITY.PROCESSOR.STATISTIC, TY("bar")), r2.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(t2, e2) {
      var n2 = t2.componentType || "series";
      e2.eachComponent({ mainType: n2, query: t2 }, function(a) {
        t2.sortInfo && a.axis.setCategorySortInfo(t2.sortInfo);
      });
    });
  }
  var XM = Math.PI * 2, Fj = Math.PI / 180;
  function IY(r2, t2) {
    return Eu(r2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() });
  }
  function LY(r2, t2) {
    var e2 = IY(r2, t2), n2 = r2.get("center"), a = r2.get("radius");
    vr(a) || (a = [0, a]), vr(n2) || (n2 = [n2, n2]);
    var i = qr(e2.width, t2.getWidth()), o = qr(e2.height, t2.getHeight()), s = Math.min(i, o), u = qr(n2[0], i) + e2.x, l2 = qr(n2[1], o) + e2.y, c2 = qr(a[0], s / 2), f2 = qr(a[1], s / 2);
    return { cx: u, cy: l2, r0: c2, r: f2 };
  }
  function Ide(r2, t2, e2) {
    t2.eachSeriesByType(r2, function(n2) {
      var a = n2.getData(), i = a.mapDimension("value"), o = IY(n2, e2), s = LY(n2, e2), u = s.cx, l2 = s.cy, c2 = s.r, f2 = s.r0, h = -n2.get("startAngle") * Fj, v9 = n2.get("minAngle") * Fj, d2 = 0;
      a.each(i, function(q3) {
        !isNaN(q3) && d2++;
      });
      var m2 = a.getSum(i), b2 = Math.PI / (m2 || d2) * 2, _ = n2.get("clockwise"), C = n2.get("roseType"), M = n2.get("stillShowZeroSum"), E = a.getDataExtent(i);
      E[0] = 0;
      var z9 = XM, V = 0, $ = h, U = _ ? 1 : -1;
      if (a.setLayout({ viewRect: o, r: c2 }), a.each(i, function(q3, ee) {
        var oe;
        if (isNaN(q3)) {
          a.setItemLayout(ee, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: _, cx: u, cy: l2, r0: f2, r: C ? NaN : c2 });
          return;
        }
        C !== "area" ? oe = m2 === 0 && M ? b2 : q3 * b2 : oe = XM / d2, oe < v9 ? (oe = v9, z9 -= v9) : V += q3;
        var ne = $ + U * oe;
        a.setItemLayout(ee, { angle: oe, startAngle: $, endAngle: ne, clockwise: _, cx: u, cy: l2, r0: f2, r: C ? Gi(q3, E, [f2, c2]) : c2 }), $ = ne;
      }), z9 < XM && d2)
        if (z9 <= 1e-3) {
          var H = XM / d2;
          a.each(i, function(q3, ee) {
            if (!isNaN(q3)) {
              var oe = a.getItemLayout(ee);
              oe.angle = H, oe.startAngle = h + U * ee * H, oe.endAngle = h + U * (ee + 1) * H;
            }
          });
        } else
          b2 = z9 / V, $ = h, a.each(i, function(q3, ee) {
            if (!isNaN(q3)) {
              var oe = a.getItemLayout(ee), ne = oe.angle === v9 ? v9 : q3 * b2;
              oe.startAngle = $, oe.endAngle = $ + U * ne, $ += U * ne;
            }
          });
    });
  }
  function UE(r2) {
    return { seriesType: r2, reset: function(t2, e2) {
      var n2 = e2.findComponents({ mainType: "legend" });
      if (!(!n2 || !n2.length)) {
        var a = t2.getData();
        a.filterSelf(function(i) {
          for (var o = a.getName(i), s = 0; s < n2.length; s++)
            if (!n2[s].isSelected(o))
              return false;
          return true;
        });
      }
    } };
  }
  var Lde = Math.PI / 180;
  function Nj(r2, t2, e2, n2, a, i, o, s, u, l2) {
    if (r2.length < 2)
      return;
    function c2(m2) {
      for (var b2 = m2.rB, _ = b2 * b2, C = 0; C < m2.list.length; C++) {
        var M = m2.list[C], E = Math.abs(M.label.y - e2), z9 = n2 + M.len, V = z9 * z9, $ = Math.sqrt((1 - Math.abs(E * E / _)) * V), U = t2 + ($ + M.len2) * a, H = U - M.label.x, q3 = M.targetTextWidth - H * a;
        OY(M, q3, true), M.label.x = U;
      }
    }
    function f2(m2) {
      for (var b2 = { list: [], maxY: 0 }, _ = { list: [], maxY: 0 }, C = 0; C < m2.length; C++)
        if (m2[C].labelAlignTo === "none") {
          var M = m2[C], E = M.label.y > e2 ? _ : b2, z9 = Math.abs(M.label.y - e2);
          if (z9 >= E.maxY) {
            var V = M.label.x - t2 - M.len2 * a, $ = n2 + M.len, U = Math.abs(V) < $ ? Math.sqrt(z9 * z9 / (1 - V * V / $ / $)) : $;
            E.rB = U, E.maxY = z9;
          }
          E.list.push(M);
        }
      c2(b2), c2(_);
    }
    for (var h = r2.length, v9 = 0; v9 < h; v9++)
      if (r2[v9].position === "outer" && r2[v9].labelAlignTo === "labelLine") {
        var d2 = r2[v9].label.x - l2;
        r2[v9].linePoints[1][0] += d2, r2[v9].label.x = l2;
      }
    iY(r2, u, u + o) && f2(r2);
  }
  function Ode(r2, t2, e2, n2, a, i, o, s) {
    for (var u = [], l2 = [], c2 = Number.MAX_VALUE, f2 = -Number.MAX_VALUE, h = 0; h < r2.length; h++) {
      var v9 = r2[h].label;
      dk(r2[h]) || (v9.x < t2 ? (c2 = Math.min(c2, v9.x), u.push(r2[h])) : (f2 = Math.max(f2, v9.x), l2.push(r2[h])));
    }
    for (var h = 0; h < r2.length; h++) {
      var d2 = r2[h];
      if (!dk(d2) && d2.linePoints) {
        if (d2.labelStyleWidth != null)
          continue;
        var v9 = d2.label, m2 = d2.linePoints, b2 = void 0;
        d2.labelAlignTo === "edge" ? v9.x < t2 ? b2 = m2[2][0] - d2.labelDistance - o - d2.edgeDistance : b2 = o + a - d2.edgeDistance - m2[2][0] - d2.labelDistance : d2.labelAlignTo === "labelLine" ? v9.x < t2 ? b2 = c2 - o - d2.bleedMargin : b2 = o + a - f2 - d2.bleedMargin : v9.x < t2 ? b2 = v9.x - o - d2.bleedMargin : b2 = o + a - v9.x - d2.bleedMargin, d2.targetTextWidth = b2, OY(d2, b2);
      }
    }
    Nj(l2, t2, e2, n2, 1, a, i, o, s, f2), Nj(u, t2, e2, n2, -1, a, i, o, s, c2);
    for (var h = 0; h < r2.length; h++) {
      var d2 = r2[h];
      if (!dk(d2) && d2.linePoints) {
        var v9 = d2.label, m2 = d2.linePoints, _ = d2.labelAlignTo === "edge", C = v9.style.padding, M = C ? C[1] + C[3] : 0, E = v9.style.backgroundColor ? 0 : M, z9 = d2.rect.width + E, V = m2[1][0] - m2[2][0];
        _ ? v9.x < t2 ? m2[2][0] = o + d2.edgeDistance + z9 + d2.labelDistance : m2[2][0] = o + a - d2.edgeDistance - z9 - d2.labelDistance : (v9.x < t2 ? m2[2][0] = v9.x + d2.labelDistance : m2[2][0] = v9.x - d2.labelDistance, m2[1][0] = m2[2][0] + V), m2[1][1] = m2[2][1] = v9.y;
      }
    }
  }
  function OY(r2, t2, e2) {
    if (e2 === void 0 && (e2 = false), r2.labelStyleWidth == null) {
      var n2 = r2.label, a = n2.style, i = r2.rect, o = a.backgroundColor, s = a.padding, u = s ? s[1] + s[3] : 0, l2 = a.overflow, c2 = i.width + (o ? 0 : u);
      if (t2 < c2 || e2) {
        var f2 = i.height;
        if (l2 && l2.match("break")) {
          n2.setStyle("backgroundColor", null), n2.setStyle("width", t2 - u);
          var h = n2.getBoundingRect();
          n2.setStyle("width", Math.ceil(h.width)), n2.setStyle("backgroundColor", o);
        } else {
          var v9 = t2 - u, d2 = t2 < c2 ? v9 : e2 ? v9 > r2.unconstrainedWidth ? null : v9 : null;
          n2.setStyle("width", d2);
        }
        var m2 = n2.getBoundingRect();
        i.width = m2.width;
        var b2 = (n2.style.margin || 0) + 2.1;
        i.height = m2.height + b2, i.y -= (i.height - f2) / 2;
      }
    }
  }
  function dk(r2) {
    return r2.position === "center";
  }
  function kde(r2) {
    var t2 = r2.getData(), e2 = [], n2, a, i = false, o = (r2.get("minShowLabelAngle") || 0) * Lde, s = t2.getLayout("viewRect"), u = t2.getLayout("r"), l2 = s.width, c2 = s.x, f2 = s.y, h = s.height;
    function v9(V) {
      V.ignore = true;
    }
    function d2(V) {
      if (!V.ignore)
        return true;
      for (var $ in V.states)
        if (V.states[$].ignore === false)
          return true;
      return false;
    }
    t2.each(function(V) {
      var $ = t2.getItemGraphicEl(V), U = $.shape, H = $.getTextContent(), q3 = $.getTextGuideLine(), ee = t2.getItemModel(V), oe = ee.getModel("label"), ne = oe.get("position") || ee.get(["emphasis", "label", "position"]), be = oe.get("distanceToLabelLine"), Ee = oe.get("alignTo"), ye = qr(oe.get("edgeDistance"), l2), et = oe.get("bleedMargin"), Le = ee.getModel("labelLine"), Fe = Le.get("length");
      Fe = qr(Fe, l2);
      var qe = Le.get("length2");
      if (qe = qr(qe, l2), Math.abs(U.endAngle - U.startAngle) < o) {
        ae(H.states, v9), H.ignore = true;
        return;
      }
      if (!!d2(H)) {
        var st = (U.startAngle + U.endAngle) / 2, dt = Math.cos(st), Ar = Math.sin(st), Hr, hn, cn, nn;
        n2 = U.cx, a = U.cy;
        var Wr = ne === "inside" || ne === "inner";
        if (ne === "center")
          Hr = U.cx, hn = U.cy, nn = "center";
        else {
          var on = (Wr ? (U.r + U.r0) / 2 * dt : U.r * dt) + n2, un = (Wr ? (U.r + U.r0) / 2 * Ar : U.r * Ar) + a;
          if (Hr = on + dt * 3, hn = un + Ar * 3, !Wr) {
            var Xr = on + dt * (Fe + u - U.r), _n = un + Ar * (Fe + u - U.r), Za = Xr + (dt < 0 ? -1 : 1) * qe, Dn = _n;
            Ee === "edge" ? Hr = dt < 0 ? c2 + ye : c2 + l2 - ye : Hr = Za + (dt < 0 ? -be : be), hn = Dn, cn = [[on, un], [Xr, _n], [Za, Dn]];
          }
          nn = Wr ? "center" : Ee === "edge" ? dt > 0 ? "right" : "left" : dt > 0 ? "left" : "right";
        }
        var ai = Math.PI, wi = 0, hi = oe.get("rotate");
        if (Ai(hi))
          wi = hi * (ai / 180);
        else if (ne === "center")
          wi = 0;
        else if (hi === "radial" || hi === true) {
          var qs = dt < 0 ? -st + ai : -st;
          wi = qs;
        } else if (hi === "tangential" && ne !== "outside" && ne !== "outer") {
          var jo = Math.atan2(dt, Ar);
          jo < 0 && (jo = ai * 2 + jo);
          var Au = Ar > 0;
          Au && (jo = ai + jo), wi = jo - ai;
        }
        if (i = !!wi, H.x = Hr, H.y = hn, H.rotation = wi, H.setStyle({ verticalAlign: "middle" }), Wr) {
          H.setStyle({ align: nn });
          var Do = H.states.select;
          Do && (Do.x += H.x, Do.y += H.y);
        } else {
          var Zi = H.getBoundingRect().clone();
          Zi.applyTransform(H.getComputedTransform());
          var ys = (H.style.margin || 0) + 2.1;
          Zi.y -= ys / 2, Zi.height += ys, e2.push({ label: H, labelLine: q3, position: ne, len: Fe, len2: qe, minTurnAngle: Le.get("minTurnAngle"), maxSurfaceAngle: Le.get("maxSurfaceAngle"), surfaceNormal: new Jn(dt, Ar), linePoints: cn, textAlign: nn, labelDistance: be, labelAlignTo: Ee, edgeDistance: ye, bleedMargin: et, rect: Zi, unconstrainedWidth: Zi.width, labelStyleWidth: H.style.width });
        }
        $.setTextConfig({ inside: Wr });
      }
    }), !i && r2.get("avoidLabelOverlap") && Ode(e2, n2, a, u, l2, h, c2, f2);
    for (var m2 = 0; m2 < e2.length; m2++) {
      var b2 = e2[m2], _ = b2.label, C = b2.labelLine, M = isNaN(_.x) || isNaN(_.y);
      if (_) {
        _.setStyle({ align: b2.textAlign }), M && (ae(_.states, v9), _.ignore = true);
        var E = _.states.select;
        E && (E.x += _.x, E.y += _.y);
      }
      if (C) {
        var z9 = b2.linePoints;
        M || !z9 ? (ae(C.states, v9), C.ignore = true) : (rY(z9, b2.minTurnAngle), Hhe(z9, b2.surfaceNormal, b2.maxSurfaceAngle), C.setShape({ points: z9 }), _.__hostTarget.textGuideLineConfig = { anchor: new Jn(z9[0][0], z9[0][1]) });
      }
    }
  }
  function Wx(r2, t2, e2) {
    var n2 = r2.get("borderRadius");
    if (n2 == null)
      return e2 ? { cornerRadius: 0 } : null;
    vr(n2) || (n2 = [n2, n2, n2, n2]);
    var a = Math.abs(t2.r || 0 - t2.r0 || 0);
    return { cornerRadius: pr(n2, function(i) {
      return Gv(i, a);
    }) };
  }
  var Rde = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this) || this;
      i.z2 = 2;
      var o = new xi();
      return i.setTextContent(o), i.updateData(e2, n2, a, true), i;
    }
    return t2.prototype.updateData = function(e2, n2, a, i) {
      var o = this, s = e2.hostModel, u = e2.getItemModel(n2), l2 = u.getModel("emphasis"), c2 = e2.getItemLayout(n2), f2 = qt(Wx(u.getModel("itemStyle"), c2, true), c2);
      if (isNaN(f2.startAngle)) {
        o.setShape(f2);
        return;
      }
      if (i) {
        o.setShape(f2);
        var h = s.getShallow("animationType");
        s.ecModel.ssr ? (rs(o, { scaleX: 0, scaleY: 0 }, s, { dataIndex: n2, isFrom: true }), o.originX = f2.cx, o.originY = f2.cy) : h === "scale" ? (o.shape.r = c2.r0, rs(o, { shape: { r: c2.r } }, s, n2)) : a != null ? (o.setShape({ startAngle: a, endAngle: a }), rs(o, { shape: { startAngle: c2.startAngle, endAngle: c2.endAngle } }, s, n2)) : (o.shape.endAngle = c2.startAngle, ci(o, { shape: { endAngle: c2.endAngle } }, s, n2));
      } else
        Wv(o), ci(o, { shape: f2 }, s, n2);
      o.useStyle(e2.getItemVisual(n2, "style")), jl(o, u);
      var v9 = (c2.startAngle + c2.endAngle) / 2, d2 = s.get("selectedOffset"), m2 = Math.cos(v9) * d2, b2 = Math.sin(v9) * d2, _ = u.getShallow("cursor");
      _ && o.attr("cursor", _), this._updateLabel(s, e2, n2), o.ensureState("emphasis").shape = qt({ r: c2.r + (l2.get("scale") && l2.get("scaleSize") || 0) }, Wx(l2.getModel("itemStyle"), c2)), qt(o.ensureState("select"), { x: m2, y: b2, shape: Wx(u.getModel(["select", "itemStyle"]), c2) }), qt(o.ensureState("blur"), { shape: Wx(u.getModel(["blur", "itemStyle"]), c2) });
      var C = o.getTextGuideLine(), M = o.getTextContent();
      C && qt(C.ensureState("select"), { x: m2, y: b2 }), qt(M.ensureState("select"), { x: m2, y: b2 }), ks(this, l2.get("focus"), l2.get("blurScope"), l2.get("disabled"));
    }, t2.prototype._updateLabel = function(e2, n2, a) {
      var i = this, o = n2.getItemModel(a), s = o.getModel("labelLine"), u = n2.getItemVisual(a, "style"), l2 = u && u.fill, c2 = u && u.opacity;
      fc(i, _l(o), { labelFetcher: n2.hostModel, labelDataIndex: a, inheritColor: l2, defaultOpacity: c2, defaultText: e2.getFormattedLabel(a, "normal") || n2.getName(a) });
      var f2 = i.getTextContent();
      i.setTextConfig({ position: null, rotation: null }), f2.attr({ z2: 10 });
      var h = e2.get(["label", "position"]);
      if (h !== "outside" && h !== "outer")
        i.removeTextGuideLine();
      else {
        var v9 = this.getTextGuideLine();
        v9 || (v9 = new yf(), this.setTextGuideLine(v9)), NF(this, VF(o), { stroke: l2, opacity: _g(s.get(["lineStyle", "opacity"]), c2, 1) });
      }
    }, t2;
  }(pf), Fde = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.ignoreLabelLineUpdate = true, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      var o = e2.getData(), s = this._data, u = this.group, l2;
      if (!s && o.count() > 0) {
        for (var c2 = o.getItemLayout(0), f2 = 1; isNaN(c2 && c2.startAngle) && f2 < o.count(); ++f2)
          c2 = o.getItemLayout(f2);
        c2 && (l2 = c2.startAngle);
      }
      if (this._emptyCircleSector && u.remove(this._emptyCircleSector), o.count() === 0 && e2.get("showEmptyCircle")) {
        var h = new pf({ shape: LY(e2, a) });
        h.useStyle(e2.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = h, u.add(h);
      }
      o.diff(s).add(function(v9) {
        var d2 = new Rde(o, v9, l2);
        o.setItemGraphicEl(v9, d2), u.add(d2);
      }).update(function(v9, d2) {
        var m2 = s.getItemGraphicEl(d2);
        m2.updateData(o, v9, l2), m2.off("click"), u.add(m2), o.setItemGraphicEl(v9, m2);
      }).remove(function(v9) {
        var d2 = s.getItemGraphicEl(v9);
        aE(d2, e2, v9);
      }).execute(), kde(e2), e2.get("animationTypeUpdate") !== "expansion" && (this._data = o);
    }, t2.prototype.dispose = function() {
    }, t2.prototype.containPoint = function(e2, n2) {
      var a = n2.getData(), i = a.getItemLayout(0);
      if (i) {
        var o = e2[0] - i.cx, s = e2[1] - i.cy, u = Math.sqrt(o * o + s * s);
        return u <= i.r && u >= i.r0;
      }
    }, t2.type = "pie", t2;
  }(Mo), Nde = Fde;
  function Ew(r2, t2, e2) {
    t2 = vr(t2) && { coordDimensions: t2 } || qt({ encodeDefine: r2.getEncode() }, t2);
    var n2 = r2.getSource(), a = jE(n2, t2).dimensions, i = new Rc(a, r2);
    return i.initData(n2, e2), i;
  }
  var Vde = function() {
    function r2(t2, e2) {
      this._getDataWithEncodedVisual = t2, this._getRawData = e2;
    }
    return r2.prototype.getAllNames = function() {
      var t2 = this._getRawData();
      return t2.mapArray(t2.getName);
    }, r2.prototype.containName = function(t2) {
      var e2 = this._getRawData();
      return e2.indexOfName(t2) >= 0;
    }, r2.prototype.indexOfName = function(t2) {
      var e2 = this._getDataWithEncodedVisual();
      return e2.indexOfName(t2);
    }, r2.prototype.getItemVisual = function(t2, e2) {
      var n2 = this._getDataWithEncodedVisual();
      return n2.getItemVisual(t2, e2);
    }, r2;
  }(), HE = Vde, jde = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.init = function(e2) {
      r2.prototype.init.apply(this, arguments), this.legendVisualProvider = new HE(en(this.getData, this), en(this.getRawData, this)), this._defaultLabelLine(e2);
    }, t2.prototype.mergeOption = function() {
      r2.prototype.mergeOption.apply(this, arguments);
    }, t2.prototype.getInitialData = function() {
      return Ew(this, { coordDimensions: ["value"], encodeDefaulter: Gn(vF, this) });
    }, t2.prototype.getDataParams = function(e2) {
      var n2 = this.getData(), a = r2.prototype.getDataParams.call(this, e2), i = [];
      return n2.each(n2.mapDimension("value"), function(o) {
        i.push(o);
      }), a.percent = Wie(i, e2, n2.hostModel.get("percentPrecision")), a.$vars.push("percent"), a;
    }, t2.prototype._defaultLabelLine = function(e2) {
      Qb(e2, "labelLine", ["show"]);
      var n2 = e2.labelLine, a = e2.emphasis.labelLine;
      n2.show = n2.show && e2.label.show, a.show = a.show && e2.emphasis.label.show;
    }, t2.type = "series.pie", t2.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, t2;
  }(ns), Bde = jde;
  function zde(r2) {
    return { seriesType: r2, reset: function(t2, e2) {
      var n2 = t2.getData();
      n2.filterSelf(function(a) {
        var i = n2.mapDimension("value"), o = n2.get(i, a);
        return !(Ai(o) && !isNaN(o) && o < 0);
      });
    } };
  }
  function $de(r2) {
    r2.registerChartView(Nde), r2.registerSeriesModel(Bde), QH("pie", r2.registerAction), r2.registerLayout(Gn(Ide, "pie")), r2.registerProcessor(UE("pie")), r2.registerProcessor(zde("pie"));
  }
  var Gde = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this, { useEncodeDefaulter: true });
    }, t2.prototype.getProgressive = function() {
      var e2 = this.option.progressive;
      return e2 == null ? this.option.large ? 5e3 : this.get("progressive") : e2;
    }, t2.prototype.getProgressiveThreshold = function() {
      var e2 = this.option.progressiveThreshold;
      return e2 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : e2;
    }, t2.prototype.brushSelector = function(e2, n2, a) {
      return a.point(n2.getItemLayout(e2));
    }, t2.prototype.getZLevelKey = function() {
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
    }, t2.type = "series.scatter", t2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], t2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, t2;
  }(ns), Wde = Gde, kY = 4, Ude = function() {
    function r2() {
    }
    return r2;
  }(), Hde = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2._off = 0, n2.hoverDataIdx = -1, n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Ude();
    }, t2.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.points, i = n2.size, o = this.symbolProxy, s = o.shape, u = e2.getContext ? e2.getContext() : e2, l2 = u && i[0] < kY, c2 = this.softClipShape, f2;
      if (l2) {
        this._ctx = u;
        return;
      }
      for (this._ctx = null, f2 = this._off; f2 < a.length; ) {
        var h = a[f2++], v9 = a[f2++];
        isNaN(h) || isNaN(v9) || c2 && !c2.contain(h, v9) || (s.x = h - i[0] / 2, s.y = v9 - i[1] / 2, s.width = i[0], s.height = i[1], o.buildPath(e2, s, true));
      }
      this.incremental && (this._off = f2, this.notClear = true);
    }, t2.prototype.afterBrush = function() {
      var e2 = this.shape, n2 = e2.points, a = e2.size, i = this._ctx, o = this.softClipShape, s;
      if (!!i) {
        for (s = this._off; s < n2.length; ) {
          var u = n2[s++], l2 = n2[s++];
          isNaN(u) || isNaN(l2) || o && !o.contain(u, l2) || i.fillRect(u - a[0] / 2, l2 - a[1] / 2, a[0], a[1]);
        }
        this.incremental && (this._off = s, this.notClear = true);
      }
    }, t2.prototype.findDataIndex = function(e2, n2) {
      for (var a = this.shape, i = a.points, o = a.size, s = Math.max(o[0], 4), u = Math.max(o[1], 4), l2 = i.length / 2 - 1; l2 >= 0; l2--) {
        var c2 = l2 * 2, f2 = i[c2] - s / 2, h = i[c2 + 1] - u / 2;
        if (e2 >= f2 && n2 >= h && e2 <= f2 + s && n2 <= h + u)
          return l2;
      }
      return -1;
    }, t2.prototype.contain = function(e2, n2) {
      var a = this.transformCoordToLocal(e2, n2), i = this.getBoundingRect();
      if (e2 = a[0], n2 = a[1], i.contain(e2, n2)) {
        var o = this.hoverDataIdx = this.findDataIndex(e2, n2);
        return o >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, t2.prototype.getBoundingRect = function() {
      var e2 = this._rect;
      if (!e2) {
        for (var n2 = this.shape, a = n2.points, i = n2.size, o = i[0], s = i[1], u = 1 / 0, l2 = 1 / 0, c2 = -1 / 0, f2 = -1 / 0, h = 0; h < a.length; ) {
          var v9 = a[h++], d2 = a[h++];
          u = Math.min(v9, u), c2 = Math.max(v9, c2), l2 = Math.min(d2, l2), f2 = Math.max(d2, f2);
        }
        e2 = this._rect = new da(u - o / 2, l2 - s / 2, c2 - u + o, f2 - l2 + s);
      }
      return e2;
    }, t2;
  }(xa), qde = function() {
    function r2() {
      this.group = new Fn();
    }
    return r2.prototype.updateData = function(t2, e2) {
      this._clear();
      var n2 = this._create();
      n2.setShape({ points: t2.getLayout("points") }), this._setCommon(n2, t2, e2);
    }, r2.prototype.updateLayout = function(t2) {
      var e2 = t2.getLayout("points");
      this.group.eachChild(function(n2) {
        if (n2.startIndex != null) {
          var a = (n2.endIndex - n2.startIndex) * 2, i = n2.startIndex * 4 * 2;
          e2 = new Float32Array(e2.buffer, i, a);
        }
        n2.setShape("points", e2), n2.reset();
      });
    }, r2.prototype.incrementalPrepareUpdate = function(t2) {
      this._clear();
    }, r2.prototype.incrementalUpdate = function(t2, e2, n2) {
      var a = this._newAdded[0], i = e2.getLayout("points"), o = a && a.shape.points;
      if (o && o.length < 2e4) {
        var s = o.length, u = new Float32Array(s + i.length);
        u.set(o), u.set(i, s), a.endIndex = t2.end, a.setShape({ points: u });
      } else {
        this._newAdded = [];
        var l2 = this._create();
        l2.startIndex = t2.start, l2.endIndex = t2.end, l2.incremental = true, l2.setShape({ points: i }), this._setCommon(l2, e2, n2);
      }
    }, r2.prototype.eachRendered = function(t2) {
      this._newAdded[0] && t2(this._newAdded[0]);
    }, r2.prototype._create = function() {
      var t2 = new Hde({ cursor: "default" });
      return this.group.add(t2), this._newAdded.push(t2), t2;
    }, r2.prototype._setCommon = function(t2, e2, n2) {
      var a = e2.hostModel;
      n2 = n2 || {};
      var i = e2.getVisual("symbolSize");
      t2.setShape("size", i instanceof Array ? i : [i, i]), t2.softClipShape = n2.clipShape || null, t2.symbolProxy = cu(e2.getVisual("symbol"), 0, 0, 0, 0), t2.setColor = t2.symbolProxy.setColor;
      var o = t2.shape.size[0] < kY;
      t2.useStyle(a.getModel("itemStyle").getItemStyle(o ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
      var s = e2.getVisual("style"), u = s && s.fill;
      u && t2.setColor(u);
      var l2 = zn(t2);
      l2.seriesIndex = a.seriesIndex, t2.on("mousemove", function(c2) {
        l2.dataIndex = null;
        var f2 = t2.hoverDataIdx;
        f2 >= 0 && (l2.dataIndex = f2 + (t2.startIndex || 0));
      });
    }, r2.prototype.remove = function() {
      this._clear();
    }, r2.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, r2;
  }(), Yde = qde, Kde = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this._updateSymbolDraw(i, e2);
      o.updateData(i, { clipShape: this._getClipShape(e2) }), this._finished = true;
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      var i = e2.getData(), o = this._updateSymbolDraw(i, e2);
      o.incrementalPrepareUpdate(i), this._finished = false;
    }, t2.prototype.incrementalRender = function(e2, n2, a) {
      this._symbolDraw.incrementalUpdate(e2, n2.getData(), { clipShape: this._getClipShape(n2) }), this._finished = e2.end === n2.getData().count();
    }, t2.prototype.updateTransform = function(e2, n2, a) {
      var i = e2.getData();
      if (this.group.dirty(), !this._finished || i.count() > 1e4)
        return { update: true };
      var o = WE("").reset(e2, n2, a);
      o.progress && o.progress({ start: 0, end: i.count(), count: i.count() }, i), this._symbolDraw.updateLayout(i);
    }, t2.prototype.eachRendered = function(e2) {
      this._symbolDraw && this._symbolDraw.eachRendered(e2);
    }, t2.prototype._getClipShape = function(e2) {
      var n2 = e2.coordinateSystem, a = n2 && n2.getArea && n2.getArea();
      return e2.get("clip", true) ? a : null;
    }, t2.prototype._updateSymbolDraw = function(e2, n2) {
      var a = this._symbolDraw, i = n2.pipelineContext, o = i.large;
      return (!a || o !== this._isLargeDraw) && (a && a.remove(), a = this._symbolDraw = o ? new Yde() : new GE(), this._isLargeDraw = o, this.group.removeAll()), this.group.add(a.group), a;
    }, t2.prototype.remove = function(e2, n2) {
      this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
    }, t2.prototype.dispose = function() {
    }, t2.type = "scatter", t2;
  }(Mo), Zde = Kde, Xde = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.type = "grid", t2.dependencies = ["xAxis", "yAxis"], t2.layoutMode = "box", t2.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, t2;
  }(li), Jde = Xde, O4 = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("grid", uu).models[0];
    }, t2.type = "cartesian2dAxis", t2;
  }(li);
  fu(O4, zE);
  var RY = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, Qde = ea({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, RY), GF = ea({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, RY), epe = ea({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, GF), tpe = En({ logBase: 10 }, GF), FY = { category: Qde, value: GF, time: epe, log: tpe }, rpe = { value: 1, category: 1, time: 1, log: 1 };
  function ow(r2, t2, e2, n2) {
    ae(rpe, function(a, i) {
      var o = ea(ea({}, FY[i], true), n2, true), s = function(u) {
        ot(l2, u);
        function l2() {
          var c2 = u !== null && u.apply(this, arguments) || this;
          return c2.type = t2 + "Axis." + i, c2;
        }
        return l2.prototype.mergeDefaultAndTheme = function(c2, f2) {
          var h = sE(this), v9 = h ? bw(c2) : {}, d2 = f2.getTheme();
          ea(c2, d2.get(i + "Axis")), ea(c2, this.getDefaultOption()), c2.type = Vj(c2), h && by(c2, v9, h);
        }, l2.prototype.optionUpdated = function() {
          var c2 = this.option;
          c2.type === "category" && (this.__ordinalMeta = A4.createByAxisModel(this));
        }, l2.prototype.getCategories = function(c2) {
          var f2 = this.option;
          if (f2.type === "category")
            return c2 ? f2.data : this.__ordinalMeta.categories;
        }, l2.prototype.getOrdinalMeta = function() {
          return this.__ordinalMeta;
        }, l2.type = t2 + "Axis." + i, l2.defaultOption = o, l2;
      }(e2);
      r2.registerComponentModel(s);
    }), r2.registerSubTypeDefaulter(t2 + "Axis", Vj);
  }
  function Vj(r2) {
    return r2.type || (r2.data ? "category" : "value");
  }
  var npe = function() {
    function r2(t2) {
      this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = t2 || "";
    }
    return r2.prototype.getAxis = function(t2) {
      return this._axes[t2];
    }, r2.prototype.getAxes = function() {
      return pr(this._dimList, function(t2) {
        return this._axes[t2];
      }, this);
    }, r2.prototype.getAxesByScale = function(t2) {
      return t2 = t2.toLowerCase(), no(this.getAxes(), function(e2) {
        return e2.scale.type === t2;
      });
    }, r2.prototype.addAxis = function(t2) {
      var e2 = t2.dim;
      this._axes[e2] = t2, this._dimList.push(e2);
    }, r2;
  }(), ape = npe, k4 = ["x", "y"];
  function jj(r2) {
    return r2.type === "interval" || r2.type === "time";
  }
  var ipe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "cartesian2d", e2.dimensions = k4, e2;
    }
    return t2.prototype.calcAffineTransform = function() {
      this._transform = this._invTransform = null;
      var e2 = this.getAxis("x").scale, n2 = this.getAxis("y").scale;
      if (!(!jj(e2) || !jj(n2))) {
        var a = e2.getExtent(), i = n2.getExtent(), o = this.dataToPoint([a[0], i[0]]), s = this.dataToPoint([a[1], i[1]]), u = a[1] - a[0], l2 = i[1] - i[0];
        if (!(!u || !l2)) {
          var c2 = (s[0] - o[0]) / u, f2 = (s[1] - o[1]) / l2, h = o[0] - a[0] * c2, v9 = o[1] - i[0] * f2, d2 = this._transform = [c2, 0, 0, f2, h, v9];
          this._invTransform = fw([], d2);
        }
      }
    }, t2.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
    }, t2.prototype.containPoint = function(e2) {
      var n2 = this.getAxis("x"), a = this.getAxis("y");
      return n2.contain(n2.toLocalCoord(e2[0])) && a.contain(a.toLocalCoord(e2[1]));
    }, t2.prototype.containData = function(e2) {
      return this.getAxis("x").containData(e2[0]) && this.getAxis("y").containData(e2[1]);
    }, t2.prototype.dataToPoint = function(e2, n2, a) {
      a = a || [];
      var i = e2[0], o = e2[1];
      if (this._transform && i != null && isFinite(i) && o != null && isFinite(o))
        return Nl(a, e2, this._transform);
      var s = this.getAxis("x"), u = this.getAxis("y");
      return a[0] = s.toGlobalCoord(s.dataToCoord(i, n2)), a[1] = u.toGlobalCoord(u.dataToCoord(o, n2)), a;
    }, t2.prototype.clampData = function(e2, n2) {
      var a = this.getAxis("x").scale, i = this.getAxis("y").scale, o = a.getExtent(), s = i.getExtent(), u = a.parse(e2[0]), l2 = i.parse(e2[1]);
      return n2 = n2 || [], n2[0] = Math.min(Math.max(Math.min(o[0], o[1]), u), Math.max(o[0], o[1])), n2[1] = Math.min(Math.max(Math.min(s[0], s[1]), l2), Math.max(s[0], s[1])), n2;
    }, t2.prototype.pointToData = function(e2, n2) {
      var a = [];
      if (this._invTransform)
        return Nl(a, e2, this._invTransform);
      var i = this.getAxis("x"), o = this.getAxis("y");
      return a[0] = i.coordToData(i.toLocalCoord(e2[0]), n2), a[1] = o.coordToData(o.toLocalCoord(e2[1]), n2), a;
    }, t2.prototype.getOtherAxis = function(e2) {
      return this.getAxis(e2.dim === "x" ? "y" : "x");
    }, t2.prototype.getArea = function() {
      var e2 = this.getAxis("x").getGlobalExtent(), n2 = this.getAxis("y").getGlobalExtent(), a = Math.min(e2[0], e2[1]), i = Math.min(n2[0], n2[1]), o = Math.max(e2[0], e2[1]) - a, s = Math.max(n2[0], n2[1]) - i;
      return new da(a, i, o, s);
    }, t2;
  }(ape), ope = ipe, spe = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i, o) {
      var s = r2.call(this, e2, n2, a) || this;
      return s.index = 0, s.type = i || "value", s.position = o || "bottom", s;
    }
    return t2.prototype.isHorizontal = function() {
      var e2 = this.position;
      return e2 === "top" || e2 === "bottom";
    }, t2.prototype.getGlobalExtent = function(e2) {
      var n2 = this.getExtent();
      return n2[0] = this.toGlobalCoord(n2[0]), n2[1] = this.toGlobalCoord(n2[1]), e2 && n2[0] > n2[1] && n2.reverse(), n2;
    }, t2.prototype.pointToData = function(e2, n2) {
      return this.coordToData(this.toLocalCoord(e2[this.dim === "x" ? 0 : 1]), n2);
    }, t2.prototype.setCategorySortInfo = function(e2) {
      if (this.type !== "category")
        return false;
      this.model.option.categorySortInfo = e2, this.scale.setSortInfo(e2);
    }, t2;
  }(Hv), upe = spe;
  function R4(r2, t2, e2) {
    e2 = e2 || {};
    var n2 = r2.coordinateSystem, a = t2.axis, i = {}, o = a.getAxesOnZeroOf()[0], s = a.position, u = o ? "onZero" : s, l2 = a.dim, c2 = n2.getRect(), f2 = [c2.x, c2.x + c2.width, c2.y, c2.y + c2.height], h = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, v9 = t2.get("offset") || 0, d2 = l2 === "x" ? [f2[2] - v9, f2[3] + v9] : [f2[0] - v9, f2[1] + v9];
    if (o) {
      var m2 = o.toGlobalCoord(o.dataToCoord(0));
      d2[h.onZero] = Math.max(Math.min(m2, d2[1]), d2[0]);
    }
    i.position = [l2 === "y" ? d2[h[u]] : f2[0], l2 === "x" ? d2[h[u]] : f2[3]], i.rotation = Math.PI / 2 * (l2 === "x" ? 0 : 1);
    var b2 = { top: -1, bottom: 1, left: -1, right: 1 };
    i.labelDirection = i.tickDirection = i.nameDirection = b2[s], i.labelOffset = o ? d2[h[s]] - d2[h.onZero] : 0, t2.get(["axisTick", "inside"]) && (i.tickDirection = -i.tickDirection), ml(e2.labelInside, t2.get(["axisLabel", "inside"])) && (i.labelDirection = -i.labelDirection);
    var _ = t2.get(["axisLabel", "rotate"]);
    return i.labelRotate = u === "top" ? -_ : _, i.z2 = 1, i;
  }
  function Bj(r2) {
    return r2.get("coordinateSystem") === "cartesian2d";
  }
  function zj(r2) {
    var t2 = { xAxisModel: null, yAxisModel: null };
    return ae(t2, function(e2, n2) {
      var a = n2.replace(/Model$/, ""), i = r2.getReferringComponents(a, uu).models[0];
      t2[n2] = i;
    }), t2;
  }
  var pk = Math.log;
  function NY(r2, t2, e2) {
    var n2 = xy.prototype, a = n2.getTicks.call(e2), i = n2.getTicks.call(e2, true), o = a.length - 1, s = n2.getInterval.call(e2), u = Wq(r2, t2), l2 = u.extent, c2 = u.fixMin, f2 = u.fixMax;
    if (r2.type === "log") {
      var h = pk(r2.base);
      l2 = [pk(l2[0]) / h, pk(l2[1]) / h];
    }
    r2.setExtent(l2[0], l2[1]), r2.calcNiceExtent({ splitNumber: o, fixMin: c2, fixMax: f2 });
    var v9 = n2.getExtent.call(r2);
    c2 && (l2[0] = v9[0]), f2 && (l2[1] = v9[1]);
    var d2 = n2.getInterval.call(r2), m2 = l2[0], b2 = l2[1];
    if (c2 && f2)
      d2 = (b2 - m2) / o;
    else if (c2)
      for (b2 = l2[0] + d2 * o; b2 < l2[1] && isFinite(b2) && isFinite(l2[1]); )
        d2 = tk(d2), b2 = l2[0] + d2 * o;
    else if (f2)
      for (m2 = l2[1] - d2 * o; m2 > l2[0] && isFinite(m2) && isFinite(l2[0]); )
        d2 = tk(d2), m2 = l2[1] - d2 * o;
    else {
      var _ = r2.getTicks().length - 1;
      _ > o && (d2 = tk(d2));
      var C = d2 * o;
      b2 = Math.ceil(l2[1] / d2) * d2, m2 = Os(b2 - C), m2 < 0 && l2[0] >= 0 ? (m2 = 0, b2 = Os(C)) : b2 > 0 && l2[1] <= 0 && (b2 = 0, m2 = -Os(C));
    }
    var M = (a[0].value - i[0].value) / s, E = (a[o].value - i[o].value) / s;
    n2.setExtent.call(r2, m2 + d2 * M, b2 + d2 * E), n2.setInterval.call(r2, d2), (M || E) && n2.setNiceExtent.call(r2, m2 + d2, b2 - d2);
  }
  var lpe = function() {
    function r2(t2, e2, n2) {
      this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = k4, this._initCartesian(t2, e2, n2), this.model = t2;
    }
    return r2.prototype.getRect = function() {
      return this._rect;
    }, r2.prototype.update = function(t2, e2) {
      var n2 = this._axesMap;
      this._updateScale(t2, this.model);
      function a(o) {
        var s, u = ja(o), l2 = u.length;
        if (!!l2) {
          for (var c2 = [], f2 = l2 - 1; f2 >= 0; f2--) {
            var h = +u[f2], v9 = o[h], d2 = v9.model, m2 = v9.scale;
            T4(m2) && d2.get("alignTicks") && d2.get("interval") == null ? c2.push(v9) : (aw(m2, d2), T4(m2) && (s = v9));
          }
          c2.length && (s || (s = c2.pop(), aw(s.scale, s.model)), ae(c2, function(b2) {
            NY(b2.scale, b2.model, s.scale);
          }));
        }
      }
      a(n2.x), a(n2.y);
      var i = {};
      ae(n2.x, function(o) {
        $j(n2, "y", o, i);
      }), ae(n2.y, function(o) {
        $j(n2, "x", o, i);
      }), this.resize(this.model, e2);
    }, r2.prototype.resize = function(t2, e2, n2) {
      var a = t2.getBoxLayoutParams(), i = !n2 && t2.get("containLabel"), o = Eu(a, { width: e2.getWidth(), height: e2.getHeight() });
      this._rect = o;
      var s = this._axesList;
      u(), i && (ae(s, function(l2) {
        if (!l2.model.get(["axisLabel", "inside"])) {
          var c2 = whe(l2);
          if (c2) {
            var f2 = l2.isHorizontal() ? "height" : "width", h = l2.model.get(["axisLabel", "margin"]);
            o[f2] -= c2[f2] + h, l2.position === "top" ? o.y += c2.height + h : l2.position === "left" && (o.x += c2.width + h);
          }
        }
      }), u()), ae(this._coordsList, function(l2) {
        l2.calcAffineTransform();
      });
      function u() {
        ae(s, function(l2) {
          var c2 = l2.isHorizontal(), f2 = c2 ? [0, o.width] : [0, o.height], h = l2.inverse ? 1 : 0;
          l2.setExtent(f2[h], f2[1 - h]), cpe(l2, c2 ? o.x : o.y);
        });
      }
    }, r2.prototype.getAxis = function(t2, e2) {
      var n2 = this._axesMap[t2];
      if (n2 != null)
        return n2[e2 || 0];
    }, r2.prototype.getAxes = function() {
      return this._axesList.slice();
    }, r2.prototype.getCartesian = function(t2, e2) {
      if (t2 != null && e2 != null) {
        var n2 = "x" + t2 + "y" + e2;
        return this._coordsMap[n2];
      }
      Tn(t2) && (e2 = t2.yAxisIndex, t2 = t2.xAxisIndex);
      for (var a = 0, i = this._coordsList; a < i.length; a++)
        if (i[a].getAxis("x").index === t2 || i[a].getAxis("y").index === e2)
          return i[a];
    }, r2.prototype.getCartesians = function() {
      return this._coordsList.slice();
    }, r2.prototype.convertToPixel = function(t2, e2, n2) {
      var a = this._findConvertTarget(e2);
      return a.cartesian ? a.cartesian.dataToPoint(n2) : a.axis ? a.axis.toGlobalCoord(a.axis.dataToCoord(n2)) : null;
    }, r2.prototype.convertFromPixel = function(t2, e2, n2) {
      var a = this._findConvertTarget(e2);
      return a.cartesian ? a.cartesian.pointToData(n2) : a.axis ? a.axis.coordToData(a.axis.toLocalCoord(n2)) : null;
    }, r2.prototype._findConvertTarget = function(t2) {
      var e2 = t2.seriesModel, n2 = t2.xAxisModel || e2 && e2.getReferringComponents("xAxis", uu).models[0], a = t2.yAxisModel || e2 && e2.getReferringComponents("yAxis", uu).models[0], i = t2.gridModel, o = this._coordsList, s, u;
      if (e2)
        s = e2.coordinateSystem, va(o, s) < 0 && (s = null);
      else if (n2 && a)
        s = this.getCartesian(n2.componentIndex, a.componentIndex);
      else if (n2)
        u = this.getAxis("x", n2.componentIndex);
      else if (a)
        u = this.getAxis("y", a.componentIndex);
      else if (i) {
        var l2 = i.coordinateSystem;
        l2 === this && (s = this._coordsList[0]);
      }
      return { cartesian: s, axis: u };
    }, r2.prototype.containPoint = function(t2) {
      var e2 = this._coordsList[0];
      if (e2)
        return e2.containPoint(t2);
    }, r2.prototype._initCartesian = function(t2, e2, n2) {
      var a = this, i = this, o = { left: false, right: false, top: false, bottom: false }, s = { x: {}, y: {} }, u = { x: 0, y: 0 };
      if (e2.eachComponent("xAxis", l2("x"), this), e2.eachComponent("yAxis", l2("y"), this), !u.x || !u.y) {
        this._axesMap = {}, this._axesList = [];
        return;
      }
      this._axesMap = s, ae(s.x, function(c2, f2) {
        ae(s.y, function(h, v9) {
          var d2 = "x" + f2 + "y" + v9, m2 = new ope(d2);
          m2.master = a, m2.model = t2, a._coordsMap[d2] = m2, a._coordsList.push(m2), m2.addAxis(c2), m2.addAxis(h);
        });
      });
      function l2(c2) {
        return function(f2, h) {
          if (!!gk(f2, t2)) {
            var v9 = f2.get("position");
            c2 === "x" ? v9 !== "top" && v9 !== "bottom" && (v9 = o.bottom ? "top" : "bottom") : v9 !== "left" && v9 !== "right" && (v9 = o.left ? "right" : "left"), o[v9] = true;
            var d2 = new upe(c2, m3(f2), [0, 0], f2.get("type"), v9), m2 = d2.type === "category";
            d2.onBand = m2 && f2.get("boundaryGap"), d2.inverse = f2.get("inverse"), f2.axis = d2, d2.model = f2, d2.grid = i, d2.index = h, i._axesList.push(d2), s[c2][h] = d2, u[c2]++;
          }
        };
      }
    }, r2.prototype._updateScale = function(t2, e2) {
      ae(this._axesList, function(a) {
        if (a.scale.setExtent(1 / 0, -1 / 0), a.type === "category") {
          var i = a.model.get("categorySortInfo");
          a.scale.setSortInfo(i);
        }
      }), t2.eachSeries(function(a) {
        if (Bj(a)) {
          var i = zj(a), o = i.xAxisModel, s = i.yAxisModel;
          if (!gk(o, e2) || !gk(s, e2))
            return;
          var u = this.getCartesian(o.componentIndex, s.componentIndex), l2 = a.getData(), c2 = u.getAxis("x"), f2 = u.getAxis("y");
          n2(l2, c2), n2(l2, f2);
        }
      }, this);
      function n2(a, i) {
        ae(dP(a, i.dim), function(o) {
          i.scale.unionExtentFromData(a, o);
        });
      }
    }, r2.prototype.getTooltipAxes = function(t2) {
      var e2 = [], n2 = [];
      return ae(this.getCartesians(), function(a) {
        var i = t2 != null && t2 !== "auto" ? a.getAxis(t2) : a.getBaseAxis(), o = a.getOtherAxis(i);
        va(e2, i) < 0 && e2.push(i), va(n2, o) < 0 && n2.push(o);
      }), { baseAxes: e2, otherAxes: n2 };
    }, r2.create = function(t2, e2) {
      var n2 = [];
      return t2.eachComponent("grid", function(a, i) {
        var o = new r2(a, t2, e2);
        o.name = "grid_" + i, o.resize(a, e2, true), a.coordinateSystem = o, n2.push(o);
      }), t2.eachSeries(function(a) {
        if (!!Bj(a)) {
          var i = zj(a), o = i.xAxisModel, s = i.yAxisModel, u = o.getCoordSysModel(), l2 = u.coordinateSystem;
          a.coordinateSystem = l2.getCartesian(o.componentIndex, s.componentIndex);
        }
      }), n2;
    }, r2.dimensions = k4, r2;
  }();
  function gk(r2, t2) {
    return r2.getCoordSysModel() === t2;
  }
  function $j(r2, t2, e2, n2) {
    e2.getAxesOnZeroOf = function() {
      return i ? [i] : [];
    };
    var a = r2[t2], i, o = e2.model, s = o.get(["axisLine", "onZero"]), u = o.get(["axisLine", "onZeroAxisIndex"]);
    if (!s)
      return;
    if (u != null)
      Gj(a[u]) && (i = a[u]);
    else
      for (var l2 in a)
        if (a.hasOwnProperty(l2) && Gj(a[l2]) && !n2[c2(a[l2])]) {
          i = a[l2];
          break;
        }
    i && (n2[c2(i)] = true);
    function c2(f2) {
      return f2.dim + "_" + f2.index;
    }
  }
  function Gj(r2) {
    return r2 && r2.type !== "category" && r2.type !== "time" && xhe(r2);
  }
  function cpe(r2, t2) {
    var e2 = r2.getExtent(), n2 = e2[0] + e2[1];
    r2.toGlobalCoord = r2.dim === "x" ? function(a) {
      return a + t2;
    } : function(a) {
      return n2 - a + t2;
    }, r2.toLocalCoord = r2.dim === "x" ? function(a) {
      return a - t2;
    } : function(a) {
      return n2 - a + t2;
    };
  }
  var fpe = lpe, uy = Math.PI, Xb = function() {
    function r2(t2, e2) {
      this.group = new Fn(), this.opt = e2, this.axisModel = t2, En(e2, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
        return true;
      } });
      var n2 = new Fn({ x: e2.position[0], y: e2.position[1], rotation: e2.rotation });
      n2.updateTransform(), this._transformGroup = n2;
    }
    return r2.prototype.hasBuilder = function(t2) {
      return !!Wj[t2];
    }, r2.prototype.add = function(t2) {
      Wj[t2](this.opt, this.axisModel, this.group, this._transformGroup);
    }, r2.prototype.getGroup = function() {
      return this.group;
    }, r2.innerTextLayout = function(t2, e2, n2) {
      var a = NW(e2 - t2), i, o;
      return X5(a) ? (o = n2 > 0 ? "top" : "bottom", i = "center") : X5(a - uy) ? (o = n2 > 0 ? "bottom" : "top", i = "center") : (o = "middle", a > 0 && a < uy ? i = n2 > 0 ? "right" : "left" : i = n2 > 0 ? "left" : "right"), { rotation: a, textAlign: i, textVerticalAlign: o };
    }, r2.makeAxisEventDataBase = function(t2) {
      var e2 = { componentType: t2.mainType, componentIndex: t2.componentIndex };
      return e2[t2.mainType + "Index"] = t2.componentIndex, e2;
    }, r2.isLabelSilent = function(t2) {
      var e2 = t2.get("tooltip");
      return t2.get("silent") || !(t2.get("triggerEvent") || e2 && e2.show);
    }, r2;
  }(), Wj = { axisLine: function(r2, t2, e2, n2) {
    var a = t2.get(["axisLine", "show"]);
    if (a === "auto" && r2.handleAutoShown && (a = r2.handleAutoShown("axisLine")), !!a) {
      var i = t2.axis.getExtent(), o = n2.transform, s = [i[0], 0], u = [i[1], 0];
      o && (Nl(s, s, o), Nl(u, u, o));
      var l2 = qt({ lineCap: "round" }, t2.getModel(["axisLine", "lineStyle"]).getLineStyle()), c2 = new bl({ subPixelOptimize: true, shape: { x1: s[0], y1: s[1], x2: u[0], y2: u[1] }, style: l2, strokeContainThreshold: r2.strokeContainThreshold || 5, silent: true, z2: 1 });
      c2.anid = "line", e2.add(c2);
      var f2 = t2.get(["axisLine", "symbol"]);
      if (f2 != null) {
        var h = t2.get(["axisLine", "symbolSize"]);
        Zr(f2) && (f2 = [f2, f2]), (Zr(h) || Ai(h)) && (h = [h, h]);
        var v9 = Cw(t2.get(["axisLine", "symbolOffset"]) || 0, h), d2 = h[0], m2 = h[1];
        ae([{ rotate: r2.rotation + Math.PI / 2, offset: v9[0], r: 0 }, { rotate: r2.rotation - Math.PI / 2, offset: v9[1], r: Math.sqrt((s[0] - u[0]) * (s[0] - u[0]) + (s[1] - u[1]) * (s[1] - u[1])) }], function(b2, _) {
          if (f2[_] !== "none" && f2[_] != null) {
            var C = cu(f2[_], -d2 / 2, -m2 / 2, d2, m2, l2.stroke, true), M = b2.r + b2.offset;
            C.attr({ rotation: b2.rotate, x: s[0] + M * Math.cos(r2.rotation), y: s[1] - M * Math.sin(r2.rotation), silent: true, z2: 11 }), e2.add(C);
          }
        });
      }
    }
  }, axisTickLabel: function(r2, t2, e2, n2) {
    var a = dpe(e2, n2, t2, r2), i = gpe(e2, n2, t2, r2);
    if (vpe(t2, i, a), ppe(e2, n2, t2, r2.tickDirection), t2.get(["axisLabel", "hideOverlap"])) {
      var o = nY(pr(i, function(s) {
        return { label: s, priority: s.z2, defaultAttr: { ignore: s.ignore } };
      }));
      oY(o);
    }
  }, axisName: function(r2, t2, e2, n2) {
    var a = ml(r2.axisName, t2.get("name"));
    if (!!a) {
      var i = t2.get("nameLocation"), o = r2.nameDirection, s = t2.getModel("nameTextStyle"), u = t2.get("nameGap") || 0, l2 = t2.axis.getExtent(), c2 = l2[0] > l2[1] ? -1 : 1, f2 = [i === "start" ? l2[0] - c2 * u : i === "end" ? l2[1] + c2 * u : (l2[0] + l2[1]) / 2, Hj(i) ? r2.labelOffset + o * u : 0], h, v9 = t2.get("nameRotate");
      v9 != null && (v9 = v9 * uy / 180);
      var d2;
      Hj(i) ? h = Xb.innerTextLayout(r2.rotation, v9 != null ? v9 : r2.rotation, o) : (h = hpe(r2.rotation, i, v9 || 0, l2), d2 = r2.axisNameAvailableWidth, d2 != null && (d2 = Math.abs(d2 / Math.sin(h.rotation)), !isFinite(d2) && (d2 = null)));
      var m2 = s.getFont(), b2 = t2.get("nameTruncate", true) || {}, _ = b2.ellipsis, C = ml(r2.nameTruncateMaxWidth, b2.maxWidth, d2), M = new xi({ x: f2[0], y: f2[1], rotation: h.rotation, silent: Xb.isLabelSilent(t2), style: Hs(s, { text: a, font: m2, overflow: "truncate", width: C, ellipsis: _, fill: s.getTextColor() || t2.get(["axisLine", "lineStyle", "color"]), align: s.get("align") || h.textAlign, verticalAlign: s.get("verticalAlign") || h.textVerticalAlign }), z2: 1 });
      if (pw({ el: M, componentModel: t2, itemName: a }), M.__fullText = a, M.anid = "name", t2.get("triggerEvent")) {
        var E = Xb.makeAxisEventDataBase(t2);
        E.targetType = "axisName", E.name = a, zn(M).eventData = E;
      }
      n2.add(M), M.updateTransform(), e2.add(M), M.decomposeTransform();
    }
  } };
  function hpe(r2, t2, e2, n2) {
    var a = NW(e2 - r2), i, o, s = n2[0] > n2[1], u = t2 === "start" && !s || t2 !== "start" && s;
    return X5(a - uy / 2) ? (o = u ? "bottom" : "top", i = "center") : X5(a - uy * 1.5) ? (o = u ? "top" : "bottom", i = "center") : (o = "middle", a < uy * 1.5 && a > uy / 2 ? i = u ? "left" : "right" : i = u ? "right" : "left"), { rotation: a, textAlign: i, textVerticalAlign: o };
  }
  function vpe(r2, t2, e2) {
    if (!Uq(r2.axis)) {
      var n2 = r2.get(["axisLabel", "showMinLabel"]), a = r2.get(["axisLabel", "showMaxLabel"]);
      t2 = t2 || [], e2 = e2 || [];
      var i = t2[0], o = t2[1], s = t2[t2.length - 1], u = t2[t2.length - 2], l2 = e2[0], c2 = e2[1], f2 = e2[e2.length - 1], h = e2[e2.length - 2];
      n2 === false ? (Mh(i), Mh(l2)) : Uj(i, o) && (n2 ? (Mh(o), Mh(c2)) : (Mh(i), Mh(l2))), a === false ? (Mh(s), Mh(f2)) : Uj(u, s) && (a ? (Mh(u), Mh(h)) : (Mh(s), Mh(f2)));
    }
  }
  function Mh(r2) {
    r2 && (r2.ignore = true);
  }
  function Uj(r2, t2) {
    var e2 = r2 && r2.getBoundingRect().clone(), n2 = t2 && t2.getBoundingRect().clone();
    if (!(!e2 || !n2)) {
      var a = HP([]);
      return s1(a, a, -r2.rotation), e2.applyTransform(Sg([], a, r2.getLocalTransform())), n2.applyTransform(Sg([], a, t2.getLocalTransform())), e2.intersect(n2);
    }
  }
  function Hj(r2) {
    return r2 === "middle" || r2 === "center";
  }
  function VY(r2, t2, e2, n2, a) {
    for (var i = [], o = [], s = [], u = 0; u < r2.length; u++) {
      var l2 = r2[u].coord;
      o[0] = l2, o[1] = 0, s[0] = l2, s[1] = e2, t2 && (Nl(o, o, t2), Nl(s, s, t2));
      var c2 = new bl({ subPixelOptimize: true, shape: { x1: o[0], y1: o[1], x2: s[0], y2: s[1] }, style: n2, z2: 2, autoBatch: true, silent: true });
      c2.anid = a + "_" + r2[u].tickValue, i.push(c2);
    }
    return i;
  }
  function dpe(r2, t2, e2, n2) {
    var a = e2.axis, i = e2.getModel("axisTick"), o = i.get("show");
    if (o === "auto" && n2.handleAutoShown && (o = n2.handleAutoShown("axisTick")), !(!o || a.scale.isBlank())) {
      for (var s = i.getModel("lineStyle"), u = n2.tickDirection * i.get("length"), l2 = a.getTicksCoords(), c2 = VY(l2, t2.transform, u, En(s.getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) }), "ticks"), f2 = 0; f2 < c2.length; f2++)
        r2.add(c2[f2]);
      return c2;
    }
  }
  function ppe(r2, t2, e2, n2) {
    var a = e2.axis, i = e2.getModel("minorTick");
    if (!(!i.get("show") || a.scale.isBlank())) {
      var o = a.getMinorTicksCoords();
      if (!!o.length)
        for (var s = i.getModel("lineStyle"), u = n2 * i.get("length"), l2 = En(s.getLineStyle(), En(e2.getModel("axisTick").getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) })), c2 = 0; c2 < o.length; c2++)
          for (var f2 = VY(o[c2], t2.transform, u, l2, "minorticks_" + c2), h = 0; h < f2.length; h++)
            r2.add(f2[h]);
    }
  }
  function gpe(r2, t2, e2, n2) {
    var a = e2.axis, i = ml(n2.axisLabelShow, e2.get(["axisLabel", "show"]));
    if (!(!i || a.scale.isBlank())) {
      var o = e2.getModel("axisLabel"), s = o.get("margin"), u = a.getViewLabels(), l2 = (ml(n2.labelRotate, o.get("rotate")) || 0) * uy / 180, c2 = Xb.innerTextLayout(n2.rotation, l2, n2.labelDirection), f2 = e2.getCategories && e2.getCategories(true), h = [], v9 = Xb.isLabelSilent(e2), d2 = e2.get("triggerEvent");
      return ae(u, function(m2, b2) {
        var _ = a.scale.type === "ordinal" ? a.scale.getRawOrdinalNumber(m2.tickValue) : m2.tickValue, C = m2.formattedLabel, M = m2.rawLabel, E = o;
        if (f2 && f2[_]) {
          var z9 = f2[_];
          Tn(z9) && z9.textStyle && (E = new To(z9.textStyle, o, e2.ecModel));
        }
        var V = E.getTextColor() || e2.get(["axisLine", "lineStyle", "color"]), $ = a.dataToCoord(_), U = new xi({ x: $, y: n2.labelOffset + n2.labelDirection * s, rotation: c2.rotation, silent: v9, z2: 10 + (m2.level || 0), style: Hs(E, { text: C, align: E.getShallow("align", true) || c2.textAlign, verticalAlign: E.getShallow("verticalAlign", true) || E.getShallow("baseline", true) || c2.textVerticalAlign, fill: xn(V) ? V(a.type === "category" ? M : a.type === "value" ? _ + "" : _, b2) : V }) });
        if (U.anid = "label_" + _, d2) {
          var H = Xb.makeAxisEventDataBase(e2);
          H.targetType = "axisLabel", H.value = M, H.tickIndex = b2, a.type === "category" && (H.dataIndex = _), zn(U).eventData = H;
        }
        t2.add(U), U.updateTransform(), h.push(U), r2.add(U), U.decomposeTransform();
      }), h;
    }
  }
  var Ig = Xb;
  function ype(r2, t2) {
    var e2 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
    return mpe(e2, r2, t2), e2.seriesInvolved && _pe(e2, r2), e2;
  }
  function mpe(r2, t2, e2) {
    var n2 = t2.getComponent("tooltip"), a = t2.getComponent("axisPointer"), i = a.get("link", true) || [], o = [];
    ae(e2.getCoordinateSystems(), function(s) {
      if (!s.axisPointerEnabled)
        return;
      var u = gE(s.model), l2 = r2.coordSysAxesInfo[u] = {};
      r2.coordSysMap[u] = s;
      var c2 = s.model, f2 = c2.getModel("tooltip", n2);
      if (ae(s.getAxes(), Gn(m2, false, null)), s.getTooltipAxes && n2 && f2.get("show")) {
        var h = f2.get("trigger") === "axis", v9 = f2.get(["axisPointer", "type"]) === "cross", d2 = s.getTooltipAxes(f2.get(["axisPointer", "axis"]));
        (h || v9) && ae(d2.baseAxes, Gn(m2, v9 ? "cross" : true, h)), v9 && ae(d2.otherAxes, Gn(m2, "cross", false));
      }
      function m2(b2, _, C) {
        var M = C.model.getModel("axisPointer", a), E = M.get("show");
        if (!(!E || E === "auto" && !b2 && !F4(M))) {
          _ == null && (_ = M.get("triggerTooltip")), M = b2 ? bpe(C, f2, a, t2, b2, _) : M;
          var z9 = M.get("snap"), V = gE(C.model), $ = _ || z9 || C.type === "category", U = r2.axesInfo[V] = { key: V, axis: C, coordSys: s, axisPointerModel: M, triggerTooltip: _, involveSeries: $, snap: z9, useHandle: F4(M), seriesModels: [], linkGroup: null };
          l2[V] = U, r2.seriesInvolved = r2.seriesInvolved || $;
          var H = xpe(i, C);
          if (H != null) {
            var q3 = o[H] || (o[H] = { axesInfo: {} });
            q3.axesInfo[V] = U, q3.mapper = i[H].mapper, U.linkGroup = q3;
          }
        }
      }
    });
  }
  function bpe(r2, t2, e2, n2, a, i) {
    var o = t2.getModel("axisPointer"), s = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], u = {};
    ae(s, function(h) {
      u[h] = On(o.get(h));
    }), u.snap = r2.type !== "category" && !!i, o.get("type") === "cross" && (u.type = "line");
    var l2 = u.label || (u.label = {});
    if (l2.show == null && (l2.show = false), a === "cross") {
      var c2 = o.get(["label", "show"]);
      if (l2.show = c2 != null ? c2 : true, !i) {
        var f2 = u.lineStyle = o.get("crossStyle");
        f2 && En(l2, f2.textStyle);
      }
    }
    return r2.model.getModel("axisPointer", new To(u, e2, n2));
  }
  function _pe(r2, t2) {
    t2.eachSeries(function(e2) {
      var n2 = e2.coordinateSystem, a = e2.get(["tooltip", "trigger"], true), i = e2.get(["tooltip", "show"], true);
      !n2 || a === "none" || a === false || a === "item" || i === false || e2.get(["axisPointer", "show"], true) === false || ae(r2.coordSysAxesInfo[gE(n2.model)], function(o) {
        var s = o.axis;
        n2.getAxis(s.dim) === s && (o.seriesModels.push(e2), o.seriesDataCount == null && (o.seriesDataCount = 0), o.seriesDataCount += e2.getData().count());
      });
    });
  }
  function xpe(r2, t2) {
    for (var e2 = t2.model, n2 = t2.dim, a = 0; a < r2.length; a++) {
      var i = r2[a] || {};
      if (yk(i[n2 + "AxisId"], e2.id) || yk(i[n2 + "AxisIndex"], e2.componentIndex) || yk(i[n2 + "AxisName"], e2.name))
        return a;
    }
  }
  function yk(r2, t2) {
    return r2 === "all" || vr(r2) && va(r2, t2) >= 0 || r2 === t2;
  }
  function wpe(r2) {
    var t2 = WF(r2);
    if (!!t2) {
      var e2 = t2.axisPointerModel, n2 = t2.axis.scale, a = e2.option, i = e2.get("status"), o = e2.get("value");
      o != null && (o = n2.parse(o));
      var s = F4(e2);
      i == null && (a.status = s ? "show" : "hide");
      var u = n2.getExtent().slice();
      u[0] > u[1] && u.reverse(), (o == null || o > u[1]) && (o = u[1]), o < u[0] && (o = u[0]), a.value = o, s && (a.status = t2.axis.scale.isBlank() ? "hide" : "show");
    }
  }
  function WF(r2) {
    var t2 = (r2.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
    return t2 && t2.axesInfo[gE(r2)];
  }
  function Spe(r2) {
    var t2 = WF(r2);
    return t2 && t2.axisPointerModel;
  }
  function F4(r2) {
    return !!r2.get(["handle", "show"]);
  }
  function gE(r2) {
    return r2.type + "||" + r2.id;
  }
  var qj = {}, Cpe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this.axisPointerClass && wpe(e2), r2.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(e2, a, true);
    }, t2.prototype.updateAxisPointer = function(e2, n2, a, i) {
      this._doUpdateAxisPointerClass(e2, a, false);
    }, t2.prototype.remove = function(e2, n2) {
      var a = this._axisPointer;
      a && a.remove(n2);
    }, t2.prototype.dispose = function(e2, n2) {
      this._disposeAxisPointer(n2), r2.prototype.dispose.apply(this, arguments);
    }, t2.prototype._doUpdateAxisPointerClass = function(e2, n2, a) {
      var i = t2.getAxisPointerClass(this.axisPointerClass);
      if (!!i) {
        var o = Spe(e2);
        o ? (this._axisPointer || (this._axisPointer = new i())).render(e2, o, n2, a) : this._disposeAxisPointer(n2);
      }
    }, t2.prototype._disposeAxisPointer = function(e2) {
      this._axisPointer && this._axisPointer.dispose(e2), this._axisPointer = null;
    }, t2.registerAxisPointerClass = function(e2, n2) {
      qj[e2] = n2;
    }, t2.getAxisPointerClass = function(e2) {
      return e2 && qj[e2];
    }, t2.type = "axis", t2;
  }(gs), c1 = Cpe, N4 = fi();
  function jY(r2, t2, e2, n2) {
    var a = e2.axis;
    if (!a.scale.isBlank()) {
      var i = e2.getModel("splitArea"), o = i.getModel("areaStyle"), s = o.get("color"), u = n2.coordinateSystem.getRect(), l2 = a.getTicksCoords({ tickModel: i, clamp: true });
      if (!!l2.length) {
        var c2 = s.length, f2 = N4(r2).splitAreaColors, h = mn(), v9 = 0;
        if (f2)
          for (var d2 = 0; d2 < l2.length; d2++) {
            var m2 = f2.get(l2[d2].tickValue);
            if (m2 != null) {
              v9 = (m2 + (c2 - 1) * d2) % c2;
              break;
            }
          }
        var b2 = a.toGlobalCoord(l2[0].coord), _ = o.getAreaStyle();
        s = vr(s) ? s : [s];
        for (var d2 = 1; d2 < l2.length; d2++) {
          var C = a.toGlobalCoord(l2[d2].coord), M = void 0, E = void 0, z9 = void 0, V = void 0;
          a.isHorizontal() ? (M = b2, E = u.y, z9 = C - M, V = u.height, b2 = M + z9) : (M = u.x, E = b2, z9 = u.width, V = C - E, b2 = E + V);
          var $ = l2[d2 - 1].tickValue;
          $ != null && h.set($, v9), t2.add(new ni({ anid: $ != null ? "area_" + $ : null, shape: { x: M, y: E, width: z9, height: V }, style: En({ fill: s[v9] }, _), autoBatch: true, silent: true })), v9 = (v9 + 1) % c2;
        }
        N4(r2).splitAreaColors = h;
      }
    }
  }
  function BY(r2) {
    N4(r2).splitAreaColors = null;
  }
  var Epe = ["axisLine", "axisTickLabel", "axisName"], Ape = ["splitArea", "splitLine", "minorSplitLine"], zY = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.axisPointerClass = "CartesianAxisPointer", e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this.group.removeAll();
      var o = this._axisGroup;
      if (this._axisGroup = new Fn(), this.group.add(this._axisGroup), !!e2.get("show")) {
        var s = e2.getCoordSysModel(), u = R4(s, e2), l2 = new Ig(e2, qt({ handleAutoShown: function(f2) {
          for (var h = s.coordinateSystem.getCartesians(), v9 = 0; v9 < h.length; v9++)
            if (T4(h[v9].getOtherAxis(e2.axis).scale))
              return true;
          return false;
        } }, u));
        ae(Epe, l2.add, l2), this._axisGroup.add(l2.getGroup()), ae(Ape, function(f2) {
          e2.get([f2, "show"]) && Tpe[f2](this, this._axisGroup, e2, s);
        }, this);
        var c2 = i && i.type === "changeAxisOrder" && i.isInitSort;
        c2 || OE(o, this._axisGroup, e2), r2.prototype.render.call(this, e2, n2, a, i);
      }
    }, t2.prototype.remove = function() {
      BY(this);
    }, t2.type = "cartesianAxis", t2;
  }(c1), Tpe = { splitLine: function(r2, t2, e2, n2) {
    var a = e2.axis;
    if (!a.scale.isBlank()) {
      var i = e2.getModel("splitLine"), o = i.getModel("lineStyle"), s = o.get("color");
      s = vr(s) ? s : [s];
      for (var u = n2.coordinateSystem.getRect(), l2 = a.isHorizontal(), c2 = 0, f2 = a.getTicksCoords({ tickModel: i }), h = [], v9 = [], d2 = o.getLineStyle(), m2 = 0; m2 < f2.length; m2++) {
        var b2 = a.toGlobalCoord(f2[m2].coord);
        l2 ? (h[0] = b2, h[1] = u.y, v9[0] = b2, v9[1] = u.y + u.height) : (h[0] = u.x, h[1] = b2, v9[0] = u.x + u.width, v9[1] = b2);
        var _ = c2++ % s.length, C = f2[m2].tickValue;
        t2.add(new bl({ anid: C != null ? "line_" + f2[m2].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: h[0], y1: h[1], x2: v9[0], y2: v9[1] }, style: En({ stroke: s[_] }, d2), silent: true }));
      }
    }
  }, minorSplitLine: function(r2, t2, e2, n2) {
    var a = e2.axis, i = e2.getModel("minorSplitLine"), o = i.getModel("lineStyle"), s = n2.coordinateSystem.getRect(), u = a.isHorizontal(), l2 = a.getMinorTicksCoords();
    if (!!l2.length)
      for (var c2 = [], f2 = [], h = o.getLineStyle(), v9 = 0; v9 < l2.length; v9++)
        for (var d2 = 0; d2 < l2[v9].length; d2++) {
          var m2 = a.toGlobalCoord(l2[v9][d2].coord);
          u ? (c2[0] = m2, c2[1] = s.y, f2[0] = m2, f2[1] = s.y + s.height) : (c2[0] = s.x, c2[1] = m2, f2[0] = s.x + s.width, f2[1] = m2), t2.add(new bl({ anid: "minor_line_" + l2[v9][d2].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: c2[0], y1: c2[1], x2: f2[0], y2: f2[1] }, style: h, silent: true }));
        }
  }, splitArea: function(r2, t2, e2, n2) {
    jY(r2, t2, e2, n2);
  } }, $Y = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "xAxis", t2;
  }(zY), Mpe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = $Y.type, e2;
    }
    return t2.type = "yAxis", t2;
  }(zY), Ppe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "grid", e2;
    }
    return t2.prototype.render = function(e2, n2) {
      this.group.removeAll(), e2.get("show") && this.group.add(new ni({ shape: e2.coordinateSystem.getRect(), style: En({ fill: e2.get("backgroundColor") }, e2.getItemStyle()), silent: true, z2: -1 }));
    }, t2.type = "grid", t2;
  }(gs), Yj = { offset: 0 };
  function GY(r2) {
    r2.registerComponentView(Ppe), r2.registerComponentModel(Jde), r2.registerCoordinateSystem("cartesian2d", fpe), ow(r2, "x", O4, Yj), ow(r2, "y", O4, Yj), r2.registerComponentView($Y), r2.registerComponentView(Mpe), r2.registerPreprocessor(function(t2) {
      t2.xAxis && t2.yAxis && !t2.grid && (t2.grid = {});
    });
  }
  function Dpe(r2) {
    ya(GY), r2.registerSeriesModel(Wde), r2.registerChartView(Zde), r2.registerLayout(WE("scatter"));
  }
  function Ipe(r2) {
    r2.eachSeriesByType("radar", function(t2) {
      var e2 = t2.getData(), n2 = [], a = t2.coordinateSystem;
      if (!!a) {
        var i = a.getIndicatorAxes();
        ae(i, function(o, s) {
          e2.each(e2.mapDimension(i[s].dim), function(u, l2) {
            n2[l2] = n2[l2] || [];
            var c2 = a.dataToPoint(u, s);
            n2[l2][s] = Kj(c2) ? c2 : Zj(a);
          });
        }), e2.each(function(o) {
          var s = dae(n2[o], function(u) {
            return Kj(u);
          }) || Zj(a);
          n2[o].push(s.slice()), e2.setItemLayout(o, n2[o]);
        });
      }
    });
  }
  function Kj(r2) {
    return !isNaN(r2[0]) && !isNaN(r2[1]);
  }
  function Zj(r2) {
    return [r2.cx, r2.cy];
  }
  function Lpe(r2) {
    var t2 = r2.polar;
    if (t2) {
      vr(t2) || (t2 = [t2]);
      var e2 = [];
      ae(t2, function(n2, a) {
        n2.indicator ? (n2.type && !n2.shape && (n2.shape = n2.type), r2.radar = r2.radar || [], vr(r2.radar) || (r2.radar = [r2.radar]), r2.radar.push(n2)) : e2.push(n2);
      }), r2.polar = e2;
    }
    ae(r2.series, function(n2) {
      n2 && n2.type === "radar" && n2.polarIndex && (n2.radarIndex = n2.polarIndex);
    });
  }
  var Ope = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.coordinateSystem, o = this.group, s = e2.getData(), u = this._data;
      function l2(h, v9) {
        var d2 = h.getItemVisual(v9, "symbol") || "circle";
        if (d2 !== "none") {
          var m2 = VE(h.getItemVisual(v9, "symbolSize")), b2 = cu(d2, -1, -1, 2, 2), _ = h.getItemVisual(v9, "symbolRotate") || 0;
          return b2.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: m2[0] / 2, scaleY: m2[1] / 2, rotation: _ * Math.PI / 180 || 0 }), b2;
        }
      }
      function c2(h, v9, d2, m2, b2, _) {
        d2.removeAll();
        for (var C = 0; C < v9.length - 1; C++) {
          var M = l2(m2, b2);
          M && (M.__dimIdx = C, h[C] ? (M.setPosition(h[C]), RE[_ ? "initProps" : "updateProps"](M, { x: v9[C][0], y: v9[C][1] }, e2, b2)) : M.setPosition(v9[C]), d2.add(M));
        }
      }
      function f2(h) {
        return pr(h, function(v9) {
          return [i.cx, i.cy];
        });
      }
      s.diff(u).add(function(h) {
        var v9 = s.getItemLayout(h);
        if (!!v9) {
          var d2 = new gf(), m2 = new yf(), b2 = { shape: { points: v9 } };
          d2.shape.points = f2(v9), m2.shape.points = f2(v9), rs(d2, b2, e2, h), rs(m2, b2, e2, h);
          var _ = new Fn(), C = new Fn();
          _.add(m2), _.add(d2), _.add(C), c2(m2.shape.points, v9, C, s, h, true), s.setItemGraphicEl(h, _);
        }
      }).update(function(h, v9) {
        var d2 = u.getItemGraphicEl(v9), m2 = d2.childAt(0), b2 = d2.childAt(1), _ = d2.childAt(2), C = { shape: { points: s.getItemLayout(h) } };
        !C.shape.points || (c2(m2.shape.points, C.shape.points, _, s, h, false), Wv(b2), Wv(m2), ci(m2, C, e2), ci(b2, C, e2), s.setItemGraphicEl(h, d2));
      }).remove(function(h) {
        o.remove(u.getItemGraphicEl(h));
      }).execute(), s.eachItemGraphicEl(function(h, v9) {
        var d2 = s.getItemModel(v9), m2 = h.childAt(0), b2 = h.childAt(1), _ = h.childAt(2), C = s.getItemVisual(v9, "style"), M = C.fill;
        o.add(h), m2.useStyle(En(d2.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: M })), jl(m2, d2, "lineStyle"), jl(b2, d2, "areaStyle");
        var E = d2.getModel("areaStyle"), z9 = E.isEmpty() && E.parentModel.isEmpty();
        b2.ignore = z9, ae(["emphasis", "select", "blur"], function(U) {
          var H = d2.getModel([U, "areaStyle"]), q3 = H.isEmpty() && H.parentModel.isEmpty();
          b2.ensureState(U).ignore = q3 && z9;
        }), b2.useStyle(En(E.getAreaStyle(), { fill: M, opacity: 0.7, decal: C.decal }));
        var V = d2.getModel("emphasis"), $ = V.getModel("itemStyle").getItemStyle();
        _.eachChild(function(U) {
          if (U instanceof Bl) {
            var H = U.style;
            U.useStyle(qt({ image: H.image, x: H.x, y: H.y, width: H.width, height: H.height }, C));
          } else
            U.useStyle(C), U.setColor(M), U.style.strokeNoScale = true;
          var q3 = U.ensureState("emphasis");
          q3.style = On($);
          var ee = s.getStore().get(s.getDimensionIndex(U.__dimIdx), v9);
          (ee == null || isNaN(ee)) && (ee = ""), fc(U, _l(d2), { labelFetcher: s.hostModel, labelDataIndex: v9, labelDimIndex: U.__dimIdx, defaultText: ee, inheritColor: M, defaultOpacity: C.opacity });
        }), ks(h, V.get("focus"), V.get("blurScope"), V.get("disabled"));
      }), this._data = s;
    }, t2.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, t2.type = "radar", t2;
  }(Mo), kpe = Ope, Rpe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2;
    }
    return t2.prototype.init = function(e2) {
      r2.prototype.init.apply(this, arguments), this.legendVisualProvider = new HE(en(this.getData, this), en(this.getRawData, this));
    }, t2.prototype.getInitialData = function(e2, n2) {
      return Ew(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      var i = this.getData(), o = this.coordinateSystem, s = o.getIndicatorAxes(), u = this.getData().getName(e2), l2 = u === "" ? this.name : u, c2 = zH(this, e2);
      return Hu("section", { header: l2, sortBlocks: true, blocks: pr(s, function(f2) {
        var h = i.get(i.mapDimension(f2.dim), e2);
        return Hu("nameValue", { markerType: "subItem", markerColor: c2, name: f2.name, value: h, sortParam: h });
      }) });
    }, t2.prototype.getTooltipPosition = function(e2) {
      if (e2 != null) {
        for (var n2 = this.getData(), a = this.coordinateSystem, i = n2.getValues(pr(a.dimensions, function(l2) {
          return n2.mapDimension(l2);
        }), e2), o = 0, s = i.length; o < s; o++)
          if (!isNaN(i[o])) {
            var u = a.getIndicatorAxes();
            return a.coordToPoint(u[o].dataToCoord(i[o]), o);
          }
      }
    }, t2.type = "series.radar", t2.dependencies = ["radar"], t2.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, t2;
  }(ns), Fpe = Rpe, iC = FY.value;
  function JM(r2, t2) {
    return En({ show: t2 }, r2);
  }
  var Npe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.optionUpdated = function() {
      var e2 = this.get("boundaryGap"), n2 = this.get("splitNumber"), a = this.get("scale"), i = this.get("axisLine"), o = this.get("axisTick"), s = this.get("axisLabel"), u = this.get("axisName"), l2 = this.get(["axisName", "show"]), c2 = this.get(["axisName", "formatter"]), f2 = this.get("axisNameGap"), h = this.get("triggerEvent"), v9 = pr(this.get("indicator") || [], function(d2) {
        d2.max != null && d2.max > 0 && !d2.min ? d2.min = 0 : d2.min != null && d2.min < 0 && !d2.max && (d2.max = 0);
        var m2 = u;
        d2.color != null && (m2 = En({ color: d2.color }, u));
        var b2 = ea(On(d2), { boundaryGap: e2, splitNumber: n2, scale: a, axisLine: i, axisTick: o, axisLabel: s, name: d2.text, showName: l2, nameLocation: "end", nameGap: f2, nameTextStyle: m2, triggerEvent: h }, false);
        if (l2 || (b2.name = ""), Zr(c2)) {
          var _ = b2.name;
          b2.name = c2.replace("{value}", _ != null ? _ : "");
        } else
          xn(c2) && (b2.name = c2(b2.name, b2));
        var C = new To(b2, null, this.ecModel);
        return fu(C, zE.prototype), C.mainType = "radar", C.componentIndex = this.componentIndex, C;
      }, this);
      this._indicatorModels = v9;
    }, t2.prototype.getIndicatorModels = function() {
      return this._indicatorModels;
    }, t2.type = "radar", t2.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: ea({ lineStyle: { color: "#bbb" } }, iC.axisLine), axisLabel: JM(iC.axisLabel, false), axisTick: JM(iC.axisTick, false), splitLine: JM(iC.splitLine, true), splitArea: JM(iC.splitArea, true), indicator: [] }, t2;
  }(li), Vpe = Npe, jpe = ["axisLine", "axisTickLabel", "axisName"], Bpe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = this.group;
      i.removeAll(), this._buildAxes(e2), this._buildSplitLineAndArea(e2);
    }, t2.prototype._buildAxes = function(e2) {
      var n2 = e2.coordinateSystem, a = n2.getIndicatorAxes(), i = pr(a, function(o) {
        var s = o.model.get("showName") ? o.name : "", u = new Ig(o.model, { axisName: s, position: [n2.cx, n2.cy], rotation: o.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
        return u;
      });
      ae(i, function(o) {
        ae(jpe, o.add, o), this.group.add(o.getGroup());
      }, this);
    }, t2.prototype._buildSplitLineAndArea = function(e2) {
      var n2 = e2.coordinateSystem, a = n2.getIndicatorAxes();
      if (!a.length)
        return;
      var i = e2.get("shape"), o = e2.getModel("splitLine"), s = e2.getModel("splitArea"), u = o.getModel("lineStyle"), l2 = s.getModel("areaStyle"), c2 = o.get("show"), f2 = s.get("show"), h = u.get("color"), v9 = l2.get("color"), d2 = vr(h) ? h : [h], m2 = vr(v9) ? v9 : [v9], b2 = [], _ = [];
      function C(Ee, ye, et) {
        var Le = et % ye.length;
        return Ee[Le] = Ee[Le] || [], Le;
      }
      if (i === "circle")
        for (var M = a[0].getTicksCoords(), E = n2.cx, z9 = n2.cy, V = 0; V < M.length; V++) {
          if (c2) {
            var $ = C(b2, d2, V);
            b2[$].push(new ap({ shape: { cx: E, cy: z9, r: M[V].coord } }));
          }
          if (f2 && V < M.length - 1) {
            var $ = C(_, m2, V);
            _[$].push(new e3({ shape: { cx: E, cy: z9, r0: M[V].coord, r: M[V + 1].coord } }));
          }
        }
      else
        for (var U, H = pr(a, function(Ee, ye) {
          var et = Ee.getTicksCoords();
          return U = U == null ? et.length - 1 : Math.min(et.length - 1, U), pr(et, function(Le) {
            return n2.coordToPoint(Le.coord, ye);
          });
        }), q3 = [], V = 0; V <= U; V++) {
          for (var ee = [], oe = 0; oe < a.length; oe++)
            ee.push(H[oe][V]);
          if (ee[0] && ee.push(ee[0].slice()), c2) {
            var $ = C(b2, d2, V);
            b2[$].push(new yf({ shape: { points: ee } }));
          }
          if (f2 && q3) {
            var $ = C(_, m2, V - 1);
            _[$].push(new gf({ shape: { points: ee.concat(q3) } }));
          }
          q3 = ee.slice().reverse();
        }
      var ne = u.getLineStyle(), be = l2.getAreaStyle();
      ae(_, function(Ee, ye) {
        this.group.add(Bh(Ee, { style: En({ stroke: "none", fill: m2[ye % m2.length] }, be), silent: true }));
      }, this), ae(b2, function(Ee, ye) {
        this.group.add(Bh(Ee, { style: En({ fill: "none", stroke: d2[ye % d2.length] }, ne), silent: true }));
      }, this);
    }, t2.type = "radar", t2;
  }(gs), zpe = Bpe, $pe = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this, e2, n2, a) || this;
      return i.type = "value", i.angle = 0, i.name = "", i;
    }
    return t2;
  }(Hv), Gpe = $pe, Wpe = function() {
    function r2(t2, e2, n2) {
      this.dimensions = [], this._model = t2, this._indicatorAxes = pr(t2.getIndicatorModels(), function(a, i) {
        var o = "indicator_" + i, s = new Gpe(o, new xy());
        return s.name = a.get("name"), s.model = a, a.axis = s, this.dimensions.push(o), s;
      }, this), this.resize(t2, n2);
    }
    return r2.prototype.getIndicatorAxes = function() {
      return this._indicatorAxes;
    }, r2.prototype.dataToPoint = function(t2, e2) {
      var n2 = this._indicatorAxes[e2];
      return this.coordToPoint(n2.dataToCoord(t2), e2);
    }, r2.prototype.coordToPoint = function(t2, e2) {
      var n2 = this._indicatorAxes[e2], a = n2.angle, i = this.cx + t2 * Math.cos(a), o = this.cy - t2 * Math.sin(a);
      return [i, o];
    }, r2.prototype.pointToData = function(t2) {
      var e2 = t2[0] - this.cx, n2 = t2[1] - this.cy, a = Math.sqrt(e2 * e2 + n2 * n2);
      e2 /= a, n2 /= a;
      for (var i = Math.atan2(-n2, e2), o = 1 / 0, s, u = -1, l2 = 0; l2 < this._indicatorAxes.length; l2++) {
        var c2 = this._indicatorAxes[l2], f2 = Math.abs(i - c2.angle);
        f2 < o && (s = c2, u = l2, o = f2);
      }
      return [u, +(s && s.coordToData(a))];
    }, r2.prototype.resize = function(t2, e2) {
      var n2 = t2.get("center"), a = e2.getWidth(), i = e2.getHeight(), o = Math.min(a, i) / 2;
      this.cx = qr(n2[0], a), this.cy = qr(n2[1], i), this.startAngle = t2.get("startAngle") * Math.PI / 180;
      var s = t2.get("radius");
      (Zr(s) || Ai(s)) && (s = [0, s]), this.r0 = qr(s[0], o), this.r = qr(s[1], o), ae(this._indicatorAxes, function(u, l2) {
        u.setExtent(this.r0, this.r);
        var c2 = this.startAngle + l2 * Math.PI * 2 / this._indicatorAxes.length;
        c2 = Math.atan2(Math.sin(c2), Math.cos(c2)), u.angle = c2;
      }, this);
    }, r2.prototype.update = function(t2, e2) {
      var n2 = this._indicatorAxes, a = this._model;
      ae(n2, function(s) {
        s.scale.setExtent(1 / 0, -1 / 0);
      }), t2.eachSeriesByType("radar", function(s, u) {
        if (!(s.get("coordinateSystem") !== "radar" || t2.getComponent("radar", s.get("radarIndex")) !== a)) {
          var l2 = s.getData();
          ae(n2, function(c2) {
            c2.scale.unionExtentFromData(l2, l2.mapDimension(c2.dim));
          });
        }
      }, this);
      var i = a.get("splitNumber"), o = new xy();
      o.setExtent(0, i), o.setInterval(1), ae(n2, function(s, u) {
        NY(s.scale, s.model, o);
      });
    }, r2.prototype.convertToPixel = function(t2, e2, n2) {
      return console.warn("Not implemented."), null;
    }, r2.prototype.convertFromPixel = function(t2, e2, n2) {
      return console.warn("Not implemented."), null;
    }, r2.prototype.containPoint = function(t2) {
      return console.warn("Not implemented."), false;
    }, r2.create = function(t2, e2) {
      var n2 = [];
      return t2.eachComponent("radar", function(a) {
        var i = new r2(a, t2, e2);
        n2.push(i), a.coordinateSystem = i;
      }), t2.eachSeriesByType("radar", function(a) {
        a.get("coordinateSystem") === "radar" && (a.coordinateSystem = n2[a.get("radarIndex") || 0]);
      }), n2;
    }, r2.dimensions = [], r2;
  }(), Upe = Wpe;
  function Hpe(r2) {
    r2.registerCoordinateSystem("radar", Upe), r2.registerComponentModel(Vpe), r2.registerComponentView(zpe), r2.registerVisual({ seriesType: "radar", reset: function(t2) {
      var e2 = t2.getData();
      e2.each(function(n2) {
        e2.setItemVisual(n2, "legendIcon", "roundRect");
      }), e2.setVisual("legendIcon", "roundRect");
    } });
  }
  function qpe(r2) {
    ya(Hpe), r2.registerChartView(kpe), r2.registerSeriesModel(Fpe), r2.registerLayout(Ipe), r2.registerProcessor(UE("radar")), r2.registerPreprocessor(Lpe);
  }
  var Xj = "\0_ec_interaction_mutex";
  function Ype(r2, t2, e2) {
    var n2 = UF(r2);
    n2[t2] = e2;
  }
  function Kpe(r2, t2, e2) {
    var n2 = UF(r2), a = n2[t2];
    a === e2 && (n2[t2] = null);
  }
  function Jj(r2, t2) {
    return !!UF(r2)[t2];
  }
  function UF(r2) {
    return r2[Xj] || (r2[Xj] = {});
  }
  op({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, lu);
  var Zpe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      n2._zr = e2;
      var a = en(n2._mousedownHandler, n2), i = en(n2._mousemoveHandler, n2), o = en(n2._mouseupHandler, n2), s = en(n2._mousewheelHandler, n2), u = en(n2._pinchHandler, n2);
      return n2.enable = function(l2, c2) {
        this.disable(), this._opt = En(On(c2) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), l2 == null && (l2 = true), (l2 === true || l2 === "move" || l2 === "pan") && (e2.on("mousedown", a), e2.on("mousemove", i), e2.on("mouseup", o)), (l2 === true || l2 === "scale" || l2 === "zoom") && (e2.on("mousewheel", s), e2.on("pinch", u));
      }, n2.disable = function() {
        e2.off("mousedown", a), e2.off("mousemove", i), e2.off("mouseup", o), e2.off("mousewheel", s), e2.off("pinch", u);
      }, n2;
    }
    return t2.prototype.isDragging = function() {
      return this._dragging;
    }, t2.prototype.isPinching = function() {
      return this._pinching;
    }, t2.prototype.setPointerChecker = function(e2) {
      this.pointerChecker = e2;
    }, t2.prototype.dispose = function() {
      this.disable();
    }, t2.prototype._mousedownHandler = function(e2) {
      if (!(E8(e2) || e2.target && e2.target.draggable)) {
        var n2 = e2.offsetX, a = e2.offsetY;
        this.pointerChecker && this.pointerChecker(e2, n2, a) && (this._x = n2, this._y = a, this._dragging = true);
      }
    }, t2.prototype._mousemoveHandler = function(e2) {
      if (!(!this._dragging || !F5("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || Jj(this._zr, "globalPan"))) {
        var n2 = e2.offsetX, a = e2.offsetY, i = this._x, o = this._y, s = n2 - i, u = a - o;
        this._x = n2, this._y = a, this._opt.preventDefaultMouseMove && Mg(e2.event), WY(this, "pan", "moveOnMouseMove", e2, { dx: s, dy: u, oldX: i, oldY: o, newX: n2, newY: a, isAvailableBehavior: null });
      }
    }, t2.prototype._mouseupHandler = function(e2) {
      E8(e2) || (this._dragging = false);
    }, t2.prototype._mousewheelHandler = function(e2) {
      var n2 = F5("zoomOnMouseWheel", e2, this._opt), a = F5("moveOnMouseWheel", e2, this._opt), i = e2.wheelDelta, o = Math.abs(i), s = e2.offsetX, u = e2.offsetY;
      if (!(i === 0 || !n2 && !a)) {
        if (n2) {
          var l2 = o > 3 ? 1.4 : o > 1 ? 1.2 : 1.1, c2 = i > 0 ? l2 : 1 / l2;
          mk(this, "zoom", "zoomOnMouseWheel", e2, { scale: c2, originX: s, originY: u, isAvailableBehavior: null });
        }
        if (a) {
          var f2 = Math.abs(i), h = (i > 0 ? 1 : -1) * (f2 > 3 ? 0.4 : f2 > 1 ? 0.15 : 0.05);
          mk(this, "scrollMove", "moveOnMouseWheel", e2, { scrollDelta: h, originX: s, originY: u, isAvailableBehavior: null });
        }
      }
    }, t2.prototype._pinchHandler = function(e2) {
      if (!Jj(this._zr, "globalPan")) {
        var n2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
        mk(this, "zoom", null, e2, { scale: n2, originX: e2.pinchX, originY: e2.pinchY, isAvailableBehavior: null });
      }
    }, t2;
  }(Yh);
  function mk(r2, t2, e2, n2, a) {
    r2.pointerChecker && r2.pointerChecker(n2, a.originX, a.originY) && (Mg(n2.event), WY(r2, t2, e2, n2, a));
  }
  function WY(r2, t2, e2, n2, a) {
    a.isAvailableBehavior = en(F5, null, e2, n2), r2.trigger(t2, a);
  }
  function F5(r2, t2, e2) {
    var n2 = e2[r2];
    return !r2 || n2 && (!Zr(n2) || t2.event[n2 + "Key"]);
  }
  var qE = Zpe;
  function HF(r2, t2, e2) {
    var n2 = r2.target;
    n2.x += t2, n2.y += e2, n2.dirty();
  }
  function qF(r2, t2, e2, n2) {
    var a = r2.target, i = r2.zoomLimit, o = r2.zoom = r2.zoom || 1;
    if (o *= t2, i) {
      var s = i.min || 0, u = i.max || 1 / 0;
      o = Math.max(Math.min(u, o), s);
    }
    var l2 = o / r2.zoom;
    r2.zoom = o, a.x -= (e2 - a.x) * (l2 - 1), a.y -= (n2 - a.y) * (l2 - 1), a.scaleX *= l2, a.scaleY *= l2, a.dirty();
  }
  var Xpe = { axisPointer: 1, tooltip: 1, brush: 1 };
  function x3(r2, t2, e2) {
    var n2 = t2.getComponentByElement(r2.topTarget), a = n2 && n2.coordinateSystem;
    return n2 && n2 !== e2 && !Xpe.hasOwnProperty(n2.mainType) && a && a.model !== e2;
  }
  function UY(r2) {
    if (Zr(r2)) {
      var t2 = new DOMParser();
      r2 = t2.parseFromString(r2, "text/xml");
    }
    var e2 = r2;
    for (e2.nodeType === 9 && (e2 = e2.firstChild); e2.nodeName.toLowerCase() !== "svg" || e2.nodeType !== 1; )
      e2 = e2.nextSibling;
    return e2;
  }
  var bk, _P = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, Qj = ja(_P), xP = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, eB = ja(xP), Jpe = function() {
    function r2() {
      this._defs = {}, this._root = null;
    }
    return r2.prototype.parse = function(t2, e2) {
      e2 = e2 || {};
      var n2 = UY(t2);
      this._defsUsePending = [];
      var a = new Fn();
      this._root = a;
      var i = [], o = n2.getAttribute("viewBox") || "", s = parseFloat(n2.getAttribute("width") || e2.width), u = parseFloat(n2.getAttribute("height") || e2.height);
      isNaN(s) && (s = null), isNaN(u) && (u = null), Wf(n2, a, null, true, false);
      for (var l2 = n2.firstChild; l2; )
        this._parseNode(l2, a, i, null, false, false), l2 = l2.nextSibling;
      tge(this._defs, this._defsUsePending), this._defsUsePending = [];
      var c2, f2;
      if (o) {
        var h = w3(o);
        h.length >= 4 && (c2 = { x: parseFloat(h[0] || 0), y: parseFloat(h[1] || 0), width: parseFloat(h[2]), height: parseFloat(h[3]) });
      }
      if (c2 && s != null && u != null && (f2 = qY(c2, { x: 0, y: 0, width: s, height: u }), !e2.ignoreViewBox)) {
        var v9 = a;
        a = new Fn(), a.add(v9), v9.scaleX = v9.scaleY = f2.scale, v9.x = f2.x, v9.y = f2.y;
      }
      return !e2.ignoreRootClip && s != null && u != null && a.setClipPath(new ni({ shape: { x: 0, y: 0, width: s, height: u } })), { root: a, width: s, height: u, viewBoxRect: c2, viewBoxTransform: f2, named: i };
    }, r2.prototype._parseNode = function(t2, e2, n2, a, i, o) {
      var s = t2.nodeName.toLowerCase(), u, l2 = a;
      if (s === "defs" && (i = true), s === "text" && (o = true), s === "defs" || s === "switch")
        u = e2;
      else {
        if (!i) {
          var c2 = bk[s];
          if (c2 && sn(bk, s)) {
            u = c2.call(this, t2, e2);
            var f2 = t2.getAttribute("name");
            if (f2) {
              var h = { name: f2, namedFrom: null, svgNodeTagLower: s, el: u };
              n2.push(h), s === "g" && (l2 = h);
            } else
              a && n2.push({ name: a.name, namedFrom: a, svgNodeTagLower: s, el: u });
            e2.add(u);
          }
        }
        var v9 = tB[s];
        if (v9 && sn(tB, s)) {
          var d2 = v9.call(this, t2), m2 = t2.getAttribute("id");
          m2 && (this._defs[m2] = d2);
        }
      }
      if (u && u.isGroup)
        for (var b2 = t2.firstChild; b2; )
          b2.nodeType === 1 ? this._parseNode(b2, u, n2, l2, i, o) : b2.nodeType === 3 && o && this._parseText(b2, u), b2 = b2.nextSibling;
    }, r2.prototype._parseText = function(t2, e2) {
      var n2 = new tE({ style: { text: t2.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
      Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), Qpe(n2, e2);
      var a = n2.style, i = a.fontSize;
      i && i < 9 && (a.fontSize = 9, n2.scaleX *= i / 9, n2.scaleY *= i / 9);
      var o = (a.fontSize || a.fontFamily) && [a.fontStyle, a.fontWeight, (a.fontSize || 12) + "px", a.fontFamily || "sans-serif"].join(" ");
      a.font = o;
      var s = n2.getBoundingRect();
      return this._textX += s.width, e2.add(n2), n2;
    }, r2.internalField = function() {
      bk = { g: function(t2, e2) {
        var n2 = new Fn();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2;
      }, rect: function(t2, e2) {
        var n2 = new ni();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2.setShape({ x: parseFloat(t2.getAttribute("x") || "0"), y: parseFloat(t2.getAttribute("y") || "0"), width: parseFloat(t2.getAttribute("width") || "0"), height: parseFloat(t2.getAttribute("height") || "0") }), n2.silent = true, n2;
      }, circle: function(t2, e2) {
        var n2 = new ap();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2.setShape({ cx: parseFloat(t2.getAttribute("cx") || "0"), cy: parseFloat(t2.getAttribute("cy") || "0"), r: parseFloat(t2.getAttribute("r") || "0") }), n2.silent = true, n2;
      }, line: function(t2, e2) {
        var n2 = new bl();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2.setShape({ x1: parseFloat(t2.getAttribute("x1") || "0"), y1: parseFloat(t2.getAttribute("y1") || "0"), x2: parseFloat(t2.getAttribute("x2") || "0"), y2: parseFloat(t2.getAttribute("y2") || "0") }), n2.silent = true, n2;
      }, ellipse: function(t2, e2) {
        var n2 = new rF();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2.setShape({ cx: parseFloat(t2.getAttribute("cx") || "0"), cy: parseFloat(t2.getAttribute("cy") || "0"), rx: parseFloat(t2.getAttribute("rx") || "0"), ry: parseFloat(t2.getAttribute("ry") || "0") }), n2.silent = true, n2;
      }, polygon: function(t2, e2) {
        var n2 = t2.getAttribute("points"), a;
        n2 && (a = aB(n2));
        var i = new gf({ shape: { points: a || [] }, silent: true });
        return Ph(e2, i), Wf(t2, i, this._defsUsePending, false, false), i;
      }, polyline: function(t2, e2) {
        var n2 = t2.getAttribute("points"), a;
        n2 && (a = aB(n2));
        var i = new yf({ shape: { points: a || [] }, silent: true });
        return Ph(e2, i), Wf(t2, i, this._defsUsePending, false, false), i;
      }, image: function(t2, e2) {
        var n2 = new Bl();
        return Ph(e2, n2), Wf(t2, n2, this._defsUsePending, false, false), n2.setStyle({ image: t2.getAttribute("xlink:href") || t2.getAttribute("href"), x: +t2.getAttribute("x"), y: +t2.getAttribute("y"), width: +t2.getAttribute("width"), height: +t2.getAttribute("height") }), n2.silent = true, n2;
      }, text: function(t2, e2) {
        var n2 = t2.getAttribute("x") || "0", a = t2.getAttribute("y") || "0", i = t2.getAttribute("dx") || "0", o = t2.getAttribute("dy") || "0";
        this._textX = parseFloat(n2) + parseFloat(i), this._textY = parseFloat(a) + parseFloat(o);
        var s = new Fn();
        return Ph(e2, s), Wf(t2, s, this._defsUsePending, false, true), s;
      }, tspan: function(t2, e2) {
        var n2 = t2.getAttribute("x"), a = t2.getAttribute("y");
        n2 != null && (this._textX = parseFloat(n2)), a != null && (this._textY = parseFloat(a));
        var i = t2.getAttribute("dx") || "0", o = t2.getAttribute("dy") || "0", s = new Fn();
        return Ph(e2, s), Wf(t2, s, this._defsUsePending, false, true), this._textX += parseFloat(i), this._textY += parseFloat(o), s;
      }, path: function(t2, e2) {
        var n2 = t2.getAttribute("d") || "", a = SU(n2);
        return Ph(e2, a), Wf(t2, a, this._defsUsePending, false, false), a.silent = true, a;
      } };
    }(), r2;
  }(), tB = { lineargradient: function(r2) {
    var t2 = parseInt(r2.getAttribute("x1") || "0", 10), e2 = parseInt(r2.getAttribute("y1") || "0", 10), n2 = parseInt(r2.getAttribute("x2") || "10", 10), a = parseInt(r2.getAttribute("y2") || "0", 10), i = new LE(t2, e2, n2, a);
    return rB(r2, i), nB(r2, i), i;
  }, radialgradient: function(r2) {
    var t2 = parseInt(r2.getAttribute("cx") || "0", 10), e2 = parseInt(r2.getAttribute("cy") || "0", 10), n2 = parseInt(r2.getAttribute("r") || "0", 10), a = new FU(t2, e2, n2);
    return rB(r2, a), nB(r2, a), a;
  } };
  function rB(r2, t2) {
    var e2 = r2.getAttribute("gradientUnits");
    e2 === "userSpaceOnUse" && (t2.global = true);
  }
  function nB(r2, t2) {
    for (var e2 = r2.firstChild; e2; ) {
      if (e2.nodeType === 1 && e2.nodeName.toLocaleLowerCase() === "stop") {
        var n2 = e2.getAttribute("offset"), a = void 0;
        n2 && n2.indexOf("%") > 0 ? a = parseInt(n2, 10) / 100 : n2 ? a = parseFloat(n2) : a = 0;
        var i = {};
        HY(e2, i, i);
        var o = i.stopColor || e2.getAttribute("stop-color") || "#000000";
        t2.colorStops.push({ offset: a, color: o });
      }
      e2 = e2.nextSibling;
    }
  }
  function Ph(r2, t2) {
    r2 && r2.__inheritedStyle && (t2.__inheritedStyle || (t2.__inheritedStyle = {}), En(t2.__inheritedStyle, r2.__inheritedStyle));
  }
  function aB(r2) {
    for (var t2 = w3(r2), e2 = [], n2 = 0; n2 < t2.length; n2 += 2) {
      var a = parseFloat(t2[n2]), i = parseFloat(t2[n2 + 1]);
      e2.push([a, i]);
    }
    return e2;
  }
  function Wf(r2, t2, e2, n2, a) {
    var i = t2, o = i.__inheritedStyle = i.__inheritedStyle || {}, s = {};
    r2.nodeType === 1 && (age(r2, t2), HY(r2, o, s), n2 || ige(r2, o, s)), i.style = i.style || {}, o.fill != null && (i.style.fill = iB(i, "fill", o.fill, e2)), o.stroke != null && (i.style.stroke = iB(i, "stroke", o.stroke, e2)), ae(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(u) {
      o[u] != null && (i.style[u] = parseFloat(o[u]));
    }), ae(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(u) {
      o[u] != null && (i.style[u] = o[u]);
    }), a && (i.__selfStyle = s), o.lineDash && (i.style.lineDash = pr(w3(o.lineDash), function(u) {
      return parseFloat(u);
    })), (o.visibility === "hidden" || o.visibility === "collapse") && (i.invisible = true), o.display === "none" && (i.ignore = true);
  }
  function Qpe(r2, t2) {
    var e2 = t2.__selfStyle;
    if (e2) {
      var n2 = e2.textBaseline, a = n2;
      !n2 || n2 === "auto" || n2 === "baseline" ? a = "alphabetic" : n2 === "before-edge" || n2 === "text-before-edge" ? a = "top" : n2 === "after-edge" || n2 === "text-after-edge" ? a = "bottom" : (n2 === "central" || n2 === "mathematical") && (a = "middle"), r2.style.textBaseline = a;
    }
    var i = t2.__inheritedStyle;
    if (i) {
      var o = i.textAlign, s = o;
      o && (o === "middle" && (s = "center"), r2.style.textAlign = s);
    }
  }
  var ege = /^url\(\s*#(.*?)\)/;
  function iB(r2, t2, e2, n2) {
    var a = e2 && e2.match(ege);
    if (a) {
      var i = jv(a[1]);
      n2.push([r2, t2, i]);
      return;
    }
    return e2 === "none" && (e2 = null), e2;
  }
  function tge(r2, t2) {
    for (var e2 = 0; e2 < t2.length; e2++) {
      var n2 = t2[e2];
      n2[0].style[n2[1]] = r2[n2[2]];
    }
  }
  var rge = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function w3(r2) {
    return r2.match(rge) || [];
  }
  var nge = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, _k = Math.PI / 180;
  function age(r2, t2) {
    var e2 = r2.getAttribute("transform");
    if (e2) {
      e2 = e2.replace(/,/g, " ");
      var n2 = [], a = null;
      e2.replace(nge, function(f2, h, v9) {
        return n2.push(h, v9), "";
      });
      for (var i = n2.length - 1; i > 0; i -= 2) {
        var o = n2[i], s = n2[i - 1], u = w3(o);
        switch (a = a || Hh(), s) {
          case "translate":
            ep(a, a, [parseFloat(u[0]), parseFloat(u[1] || "0")]);
            break;
          case "scale":
            W6(a, a, [parseFloat(u[0]), parseFloat(u[1] || u[0])]);
            break;
          case "rotate":
            s1(a, a, -parseFloat(u[0]) * _k);
            break;
          case "skewX":
            var l2 = Math.tan(parseFloat(u[0]) * _k);
            Sg(a, [1, 0, l2, 1, 0, 0], a);
            break;
          case "skewY":
            var c2 = Math.tan(parseFloat(u[0]) * _k);
            Sg(a, [1, c2, 0, 1, 0, 0], a);
            break;
          case "matrix":
            a[0] = parseFloat(u[0]), a[1] = parseFloat(u[1]), a[2] = parseFloat(u[2]), a[3] = parseFloat(u[3]), a[4] = parseFloat(u[4]), a[5] = parseFloat(u[5]);
            break;
        }
      }
      t2.setLocalTransform(a);
    }
  }
  var oB = /([^\s:;]+)\s*:\s*([^:;]+)/g;
  function HY(r2, t2, e2) {
    var n2 = r2.getAttribute("style");
    if (!!n2) {
      oB.lastIndex = 0;
      for (var a; (a = oB.exec(n2)) != null; ) {
        var i = a[1], o = sn(_P, i) ? _P[i] : null;
        o && (t2[o] = a[2]);
        var s = sn(xP, i) ? xP[i] : null;
        s && (e2[s] = a[2]);
      }
    }
  }
  function ige(r2, t2, e2) {
    for (var n2 = 0; n2 < Qj.length; n2++) {
      var a = Qj[n2], i = r2.getAttribute(a);
      i != null && (t2[_P[a]] = i);
    }
    for (var n2 = 0; n2 < eB.length; n2++) {
      var a = eB[n2], i = r2.getAttribute(a);
      i != null && (e2[xP[a]] = i);
    }
  }
  function qY(r2, t2) {
    var e2 = t2.width / r2.width, n2 = t2.height / r2.height, a = Math.min(e2, n2);
    return { scale: a, x: -(r2.x + r2.width / 2) * a + (t2.x + t2.width / 2), y: -(r2.y + r2.height / 2) * a + (t2.y + t2.height / 2) };
  }
  function oge(r2, t2) {
    var e2 = new Jpe();
    return e2.parse(r2, t2);
  }
  var sge = mn(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), uge = function() {
    function r2(t2, e2) {
      this.type = "geoSVG", this._usedGraphicMap = mn(), this._freedGraphics = [], this._mapName = t2, this._parsedXML = UY(e2);
    }
    return r2.prototype.load = function() {
      var t2 = this._firstGraphic;
      if (!t2) {
        t2 = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(t2), this._boundingRect = this._firstGraphic.boundingRect.clone();
        var e2 = cge(t2.named), n2 = e2.regions, a = e2.regionsMap;
        this._regions = n2, this._regionsMap = a;
      }
      return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
    }, r2.prototype._buildGraphic = function(t2) {
      var e2, n2;
      try {
        e2 = t2 && oge(t2, { ignoreViewBox: true, ignoreRootClip: true }) || {}, n2 = e2.root, Fc(n2 != null);
      } catch (b2) {
        throw new Error(`Invalid svg format
` + b2.message);
      }
      var a = new Fn();
      a.add(n2), a.isGeoSVGGraphicRoot = true;
      var i = e2.width, o = e2.height, s = e2.viewBoxRect, u = this._boundingRect;
      if (!u) {
        var l2 = void 0, c2 = void 0, f2 = void 0, h = void 0;
        if (i != null ? (l2 = 0, f2 = i) : s && (l2 = s.x, f2 = s.width), o != null ? (c2 = 0, h = o) : s && (c2 = s.y, h = s.height), l2 == null || c2 == null) {
          var v9 = n2.getBoundingRect();
          l2 == null && (l2 = v9.x, f2 = v9.width), c2 == null && (c2 = v9.y, h = v9.height);
        }
        u = this._boundingRect = new da(l2, c2, f2, h);
      }
      if (s) {
        var d2 = qY(s, u);
        n2.scaleX = n2.scaleY = d2.scale, n2.x = d2.x, n2.y = d2.y;
      }
      a.setClipPath(new ni({ shape: u.plain() }));
      var m2 = [];
      return ae(e2.named, function(b2) {
        sge.get(b2.svgNodeTagLower) != null && (m2.push(b2), lge(b2.el));
      }), { root: a, boundingRect: u, named: m2 };
    }, r2.prototype.useGraphic = function(t2) {
      var e2 = this._usedGraphicMap, n2 = e2.get(t2);
      return n2 || (n2 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), e2.set(t2, n2), n2);
    }, r2.prototype.freeGraphic = function(t2) {
      var e2 = this._usedGraphicMap, n2 = e2.get(t2);
      n2 && (e2.removeKey(t2), this._freedGraphics.push(n2));
    }, r2;
  }();
  function lge(r2) {
    r2.silent = false, r2.isGroup && r2.traverse(function(t2) {
      t2.silent = false;
    });
  }
  function cge(r2) {
    var t2 = [], e2 = mn();
    return ae(r2, function(n2) {
      if (n2.namedFrom == null) {
        var a = new Mhe(n2.name, n2.el);
        t2.push(a), e2.set(n2.name, a);
      }
    }), { regions: t2, regionsMap: e2 };
  }
  var V4 = [126, 25], sB = "\u5357\u6D77\u8BF8\u5C9B", Mb = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
  for (var Cb = 0; Cb < Mb.length; Cb++)
    for (var Cx = 0; Cx < Mb[Cb].length; Cx++)
      Mb[Cb][Cx][0] /= 10.5, Mb[Cb][Cx][1] /= -10.5 / 0.75, Mb[Cb][Cx][0] += V4[0], Mb[Cb][Cx][1] += V4[1];
  function fge(r2, t2) {
    if (r2 === "china") {
      for (var e2 = 0; e2 < t2.length; e2++)
        if (t2[e2].name === sB)
          return;
      t2.push(new qq(sB, pr(Mb, function(n2) {
        return { type: "polygon", exterior: n2 };
      }), V4));
    }
  }
  var hge = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
  function vge(r2, t2) {
    if (r2 === "china") {
      var e2 = hge[t2.name];
      if (e2) {
        var n2 = t2.getCenter();
        n2[0] += e2[0] / 10.5, n2[1] += -e2[1] / (10.5 / 0.75), t2.setCenter(n2);
      }
    }
  }
  var dge = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
  function pge(r2, t2) {
    r2 === "china" && t2.name === "\u53F0\u6E7E" && t2.geometries.push({ type: "polygon", exterior: dge[0] });
  }
  var gge = "name", yge = function() {
    function r2(t2, e2, n2) {
      this.type = "geoJSON", this._parsedMap = mn(), this._mapName = t2, this._specialAreas = n2, this._geoJSON = bge(e2);
    }
    return r2.prototype.load = function(t2, e2) {
      e2 = e2 || gge;
      var n2 = this._parsedMap.get(e2);
      if (!n2) {
        var a = this._parseToRegions(e2);
        n2 = this._parsedMap.set(e2, { regions: a, boundingRect: mge(a) });
      }
      var i = mn(), o = [];
      return ae(n2.regions, function(s) {
        var u = s.name;
        t2 && sn(t2, u) && (s = s.cloneShallow(u = t2[u])), o.push(s), i.set(u, s);
      }), { regions: o, boundingRect: n2.boundingRect || new da(0, 0, 0, 0), regionsMap: i };
    }, r2.prototype._parseToRegions = function(t2) {
      var e2 = this._mapName, n2 = this._geoJSON, a;
      try {
        a = n2 ? Dhe(n2, t2) : [];
      } catch (i) {
        throw new Error(`Invalid geoJson format
` + i.message);
      }
      return fge(e2, a), ae(a, function(i) {
        var o = i.name;
        vge(e2, i), pge(e2, i);
        var s = this._specialAreas && this._specialAreas[o];
        s && i.transformTo(s.left, s.top, s.width, s.height);
      }, this), a;
    }, r2.prototype.getMapForUser = function() {
      return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
    }, r2;
  }();
  function mge(r2) {
    for (var t2, e2 = 0; e2 < r2.length; e2++) {
      var n2 = r2[e2].getBoundingRect();
      t2 = t2 || n2.clone(), t2.union(n2);
    }
    return t2;
  }
  function bge(r2) {
    return Zr(r2) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(r2) : new Function("return (" + r2 + ");")() : r2;
  }
  var oC = mn(), Lg = { registerMap: function(r2, t2, e2) {
    if (t2.svg) {
      var n2 = new uge(r2, t2.svg);
      oC.set(r2, n2);
    } else {
      var a = t2.geoJson || t2.geoJSON;
      a && !t2.features ? e2 = t2.specialAreas : a = t2;
      var n2 = new yge(r2, a, e2);
      oC.set(r2, n2);
    }
  }, getGeoResource: function(r2) {
    return oC.get(r2);
  }, getMapForUser: function(r2) {
    var t2 = oC.get(r2);
    return t2 && t2.type === "geoJSON" && t2.getMapForUser();
  }, load: function(r2, t2, e2) {
    var n2 = oC.get(r2);
    if (!!n2)
      return n2.load(t2, e2);
  } }, YF = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], _ge = mn(YF), xge = mn(YF.concat(["g"])), wge = mn(YF.concat(["g"])), YY = fi();
  function QM(r2) {
    var t2 = r2.getItemStyle(), e2 = r2.get("areaColor");
    return e2 != null && (t2.fill = e2), t2;
  }
  function uB(r2) {
    var t2 = r2.style;
    t2 && (t2.stroke = t2.stroke || t2.fill, t2.fill = null);
  }
  var Sge = function() {
    function r2(t2) {
      var e2 = new Fn();
      this.uid = yw("ec_map_draw"), this._controller = new qE(t2.getZr()), this._controllerHost = { target: e2 }, this.group = e2, e2.add(this._regionsGroup = new Fn()), e2.add(this._svgGroup = new Fn());
    }
    return r2.prototype.draw = function(t2, e2, n2, a, i) {
      var o = t2.mainType === "geo", s = t2.getData && t2.getData();
      o && e2.eachComponent({ mainType: "series", subType: "map" }, function(_) {
        !s && _.getHostGeoModel() === t2 && (s = _.getData());
      });
      var u = t2.coordinateSystem, l2 = this._regionsGroup, c2 = this.group, f2 = u.getTransformInfo(), h = f2.raw, v9 = f2.roam, d2 = !l2.childAt(0) || i;
      d2 ? (c2.x = v9.x, c2.y = v9.y, c2.scaleX = v9.scaleX, c2.scaleY = v9.scaleY, c2.dirty()) : ci(c2, v9, t2);
      var m2 = s && s.getVisual("visualMeta") && s.getVisual("visualMeta").length > 0, b2 = { api: n2, geo: u, mapOrGeoModel: t2, data: s, isVisualEncodedByVisualMap: m2, isGeo: o, transformInfoRaw: h };
      u.resourceType === "geoJSON" ? this._buildGeoJSON(b2) : u.resourceType === "geoSVG" && this._buildSVG(b2), this._updateController(t2, e2, n2), this._updateMapSelectHandler(t2, l2, n2, a);
    }, r2.prototype._buildGeoJSON = function(t2) {
      var e2 = this._regionsGroupByName = mn(), n2 = mn(), a = this._regionsGroup, i = t2.transformInfoRaw, o = t2.mapOrGeoModel, s = t2.data, u = t2.geo.projection, l2 = u && u.stream;
      function c2(v9, d2) {
        return d2 && (v9 = d2(v9)), v9 && [v9[0] * i.scaleX + i.x, v9[1] * i.scaleY + i.y];
      }
      function f2(v9) {
        for (var d2 = [], m2 = !l2 && u && u.project, b2 = 0; b2 < v9.length; ++b2) {
          var _ = c2(v9[b2], m2);
          _ && d2.push(_);
        }
        return d2;
      }
      function h(v9) {
        return { shape: { points: f2(v9) } };
      }
      a.removeAll(), ae(t2.geo.regions, function(v9) {
        var d2 = v9.name, m2 = e2.get(d2), b2 = n2.get(d2) || {}, _ = b2.dataIdx, C = b2.regionModel;
        m2 || (m2 = e2.set(d2, new Fn()), a.add(m2), _ = s ? s.indexOfName(d2) : null, C = t2.isGeo ? o.getRegionModel(d2) : s ? s.getItemModel(_) : null, n2.set(d2, { dataIdx: _, regionModel: C }));
        var M = [], E = [];
        ae(v9.geometries, function($) {
          if ($.type === "polygon") {
            var U = [$.exterior].concat($.interiors || []);
            l2 && (U = dB(U, l2)), ae(U, function(q3) {
              M.push(new gf(h(q3)));
            });
          } else {
            var H = $.points;
            l2 && (H = dB(H, l2, true)), ae(H, function(q3) {
              E.push(new yf(h(q3)));
            });
          }
        });
        var z9 = c2(v9.getCenter(), u && u.project);
        function V($, U) {
          if (!!$.length) {
            var H = new aF({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: $ } });
            m2.add(H), lB(t2, H, _, C), cB(t2, H, d2, C, o, _, z9), U && (uB(H), ae(H.states, uB));
          }
        }
        V(M), V(E, true);
      }), e2.each(function(v9, d2) {
        var m2 = n2.get(d2), b2 = m2.dataIdx, _ = m2.regionModel;
        fB(t2, v9, d2, _, o, b2), hB(t2, v9, d2, _, o), vB(t2, v9, d2, _, o);
      }, this);
    }, r2.prototype._buildSVG = function(t2) {
      var e2 = t2.geo.map, n2 = t2.transformInfoRaw;
      this._svgGroup.x = n2.x, this._svgGroup.y = n2.y, this._svgGroup.scaleX = n2.scaleX, this._svgGroup.scaleY = n2.scaleY, this._svgResourceChanged(e2) && (this._freeSVG(), this._useSVG(e2));
      var a = this._svgDispatcherMap = mn(), i = false;
      ae(this._svgGraphicRecord.named, function(o) {
        var s = o.name, u = t2.mapOrGeoModel, l2 = t2.data, c2 = o.svgNodeTagLower, f2 = o.el, h = l2 ? l2.indexOfName(s) : null, v9 = u.getRegionModel(s);
        if (_ge.get(c2) != null && f2 instanceof qh && lB(t2, f2, h, v9), f2 instanceof qh && (f2.culling = true), f2.z2EmphasisLift = 0, !o.namedFrom && (wge.get(c2) != null && cB(t2, f2, s, v9, u, h, null), fB(t2, f2, s, v9, u, h), hB(t2, f2, s, v9, u), xge.get(c2) != null)) {
          var d2 = vB(t2, f2, s, v9, u);
          d2 === "self" && (i = true);
          var m2 = a.get(s) || a.set(s, []);
          m2.push(f2);
        }
      }, this), this._enableBlurEntireSVG(i, t2);
    }, r2.prototype._enableBlurEntireSVG = function(t2, e2) {
      if (t2 && e2.isGeo) {
        var n2 = e2.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), a = n2.opacity;
        this._svgGraphicRecord.root.traverse(function(i) {
          if (!i.isGroup) {
            r1(i);
            var o = i.ensureState("blur").style || {};
            o.opacity == null && a != null && (o.opacity = a), i.ensureState("emphasis");
          }
        });
      }
    }, r2.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, r2.prototype.findHighDownDispatchers = function(t2, e2) {
      if (t2 == null)
        return [];
      var n2 = e2.coordinateSystem;
      if (n2.resourceType === "geoJSON") {
        var a = this._regionsGroupByName;
        if (a) {
          var i = a.get(t2);
          return i ? [i] : [];
        }
      } else if (n2.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(t2) || [];
    }, r2.prototype._svgResourceChanged = function(t2) {
      return this._svgMapName !== t2;
    }, r2.prototype._useSVG = function(t2) {
      var e2 = Lg.getGeoResource(t2);
      if (e2 && e2.type === "geoSVG") {
        var n2 = e2.useGraphic(this.uid);
        this._svgGroup.add(n2.root), this._svgGraphicRecord = n2, this._svgMapName = t2;
      }
    }, r2.prototype._freeSVG = function() {
      var t2 = this._svgMapName;
      if (t2 != null) {
        var e2 = Lg.getGeoResource(t2);
        e2 && e2.type === "geoSVG" && e2.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, r2.prototype._updateController = function(t2, e2, n2) {
      var a = t2.coordinateSystem, i = this._controller, o = this._controllerHost;
      o.zoomLimit = t2.get("scaleLimit"), o.zoom = a.getZoom(), i.enable(t2.get("roam") || false);
      var s = t2.mainType;
      function u() {
        var l2 = { type: "geoRoam", componentType: s };
        return l2[s + "Id"] = t2.id, l2;
      }
      i.off("pan").on("pan", function(l2) {
        this._mouseDownFlag = false, HF(o, l2.dx, l2.dy), n2.dispatchAction(qt(u(), { dx: l2.dx, dy: l2.dy, animation: { duration: 0 } }));
      }, this), i.off("zoom").on("zoom", function(l2) {
        this._mouseDownFlag = false, qF(o, l2.scale, l2.originX, l2.originY), n2.dispatchAction(qt(u(), { zoom: l2.scale, originX: l2.originX, originY: l2.originY, animation: { duration: 0 } }));
      }, this), i.setPointerChecker(function(l2, c2, f2) {
        return a.containPoint([c2, f2]) && !x3(l2, n2, t2);
      });
    }, r2.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(t2) {
        var e2 = t2.getTextContent();
        e2 && (e2.ignore = YY(e2).ignore);
      });
    }, r2.prototype._updateMapSelectHandler = function(t2, e2, n2, a) {
      var i = this;
      e2.off("mousedown"), e2.off("click"), t2.get("selectedMode") && (e2.on("mousedown", function() {
        i._mouseDownFlag = true;
      }), e2.on("click", function(o) {
        !i._mouseDownFlag || (i._mouseDownFlag = false);
      }));
    }, r2;
  }();
  function lB(r2, t2, e2, n2) {
    var a = n2.getModel("itemStyle"), i = n2.getModel(["emphasis", "itemStyle"]), o = n2.getModel(["blur", "itemStyle"]), s = n2.getModel(["select", "itemStyle"]), u = QM(a), l2 = QM(i), c2 = QM(s), f2 = QM(o), h = r2.data;
    if (h) {
      var v9 = h.getItemVisual(e2, "style"), d2 = h.getItemVisual(e2, "decal");
      r2.isVisualEncodedByVisualMap && v9.fill && (u.fill = v9.fill), d2 && (u.decal = hE(d2, r2.api));
    }
    t2.setStyle(u), t2.style.strokeNoScale = true, t2.ensureState("emphasis").style = l2, t2.ensureState("select").style = c2, t2.ensureState("blur").style = f2, r1(t2);
  }
  function cB(r2, t2, e2, n2, a, i, o) {
    var s = r2.data, u = r2.isGeo, l2 = s && isNaN(s.get(s.mapDimension("value"), i)), c2 = s && s.getItemLayout(i);
    if (u || l2 || c2 && c2.showLabel) {
      var f2 = u ? e2 : i, h = void 0;
      (!s || i >= 0) && (h = a);
      var v9 = o ? { normal: { align: "center", verticalAlign: "middle" } } : null;
      fc(t2, _l(n2), { labelFetcher: h, labelDataIndex: f2, defaultText: e2 }, v9);
      var d2 = t2.getTextContent();
      if (d2 && (YY(d2).ignore = d2.ignore, t2.textConfig && o)) {
        var m2 = t2.getBoundingRect().clone();
        t2.textConfig.layoutRect = m2, t2.textConfig.position = [(o[0] - m2.x) / m2.width * 100 + "%", (o[1] - m2.y) / m2.height * 100 + "%"];
      }
      t2.disableLabelAnimation = true;
    } else
      t2.removeTextContent(), t2.removeTextConfig(), t2.disableLabelAnimation = null;
  }
  function fB(r2, t2, e2, n2, a, i) {
    r2.data ? r2.data.setItemGraphicEl(i, t2) : zn(t2).eventData = { componentType: "geo", componentIndex: a.componentIndex, geoIndex: a.componentIndex, name: e2, region: n2 && n2.option || {} };
  }
  function hB(r2, t2, e2, n2, a) {
    r2.data || pw({ el: t2, componentModel: a, itemName: e2, itemTooltipOption: n2.get("tooltip") });
  }
  function vB(r2, t2, e2, n2, a) {
    t2.highDownSilentOnTouch = !!a.get("selectedMode");
    var i = n2.getModel("emphasis"), o = i.get("focus");
    return ks(t2, o, i.get("blurScope"), i.get("disabled")), r2.isGeo && xse(t2, a, e2), o;
  }
  function dB(r2, t2, e2) {
    var n2 = [], a;
    function i() {
      a = [];
    }
    function o() {
      a.length && (n2.push(a), a = []);
    }
    var s = t2({ polygonStart: i, polygonEnd: o, lineStart: i, lineEnd: o, point: function(u, l2) {
      isFinite(u) && isFinite(l2) && a.push([u, l2]);
    }, sphere: function() {
    } });
    return !e2 && s.polygonStart(), ae(r2, function(u) {
      s.lineStart();
      for (var l2 = 0; l2 < u.length; l2++)
        s.point(u[l2][0], u[l2][1]);
      s.lineEnd();
    }), !e2 && s.polygonEnd(), n2;
  }
  var KY = Sge, Cge = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      if (!(i && i.type === "mapToggleSelect" && i.from === this.uid)) {
        var o = this.group;
        if (o.removeAll(), !e2.getHostGeoModel()) {
          if (this._mapDraw && i && i.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), i && i.type === "geoRoam" && i.componentType === "series" && i.seriesId === e2.id) {
            var s = this._mapDraw;
            s && o.add(s.group);
          } else if (e2.needsDrawMap) {
            var s = this._mapDraw || new KY(a);
            o.add(s.group), s.draw(e2, n2, a, this, i), this._mapDraw = s;
          } else
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          e2.get("showLegendSymbol") && n2.getComponent("legend") && this._renderSymbols(e2, n2, a);
        }
      }
    }, t2.prototype.remove = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
    }, t2.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
    }, t2.prototype._renderSymbols = function(e2, n2, a) {
      var i = e2.originalData, o = this.group;
      i.each(i.mapDimension("value"), function(s, u) {
        if (!isNaN(s)) {
          var l2 = i.getItemLayout(u);
          if (!(!l2 || !l2.point)) {
            var c2 = l2.point, f2 = l2.offset, h = new ap({ style: { fill: e2.getData().getVisual("style").fill }, shape: { cx: c2[0] + f2 * 9, cy: c2[1], r: 3 }, silent: true, z2: 8 + (f2 ? 0 : vw + 1) });
            if (!f2) {
              var v9 = e2.mainSeries.getData(), d2 = i.getName(u), m2 = v9.indexOfName(d2), b2 = i.getItemModel(u), _ = b2.getModel("label"), C = v9.getItemGraphicEl(m2);
              fc(h, _l(b2), { labelFetcher: { getFormattedLabel: function(M, E) {
                return e2.getFormattedLabel(m2, E);
              } }, defaultText: d2 }), h.disableLabelAnimation = true, _.get("position") || h.setTextConfig({ position: "bottom" }), C.onHoverStateChange = function(M) {
                Q5(h, M);
              };
            }
            o.add(h);
          }
        }
      });
    }, t2.type = "map", t2;
  }(Mo), Ege = Cge, Age = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.needsDrawMap = false, e2.seriesGroup = [], e2.getTooltipPosition = function(n2) {
        if (n2 != null) {
          var a = this.getData().getName(n2), i = this.coordinateSystem, o = i.getRegion(a);
          return o && i.dataToPoint(o.getCenter());
        }
      }, e2;
    }
    return t2.prototype.getInitialData = function(e2) {
      for (var n2 = Ew(this, { coordDimensions: ["value"], encodeDefaulter: Gn(vF, this) }), a = mn(), i = [], o = 0, s = n2.count(); o < s; o++) {
        var u = n2.getName(o);
        a.set(u, true);
      }
      var l2 = Lg.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return ae(l2.regions, function(c2) {
        var f2 = c2.name;
        a.get(f2) || i.push(f2);
      }), n2.appendValues([], i), n2;
    }, t2.prototype.getHostGeoModel = function() {
      var e2 = this.option.geoIndex;
      return e2 != null ? this.ecModel.getComponent("geo", e2) : null;
    }, t2.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, t2.prototype.getRawValue = function(e2) {
      var n2 = this.getData();
      return n2.get(n2.mapDimension("value"), e2);
    }, t2.prototype.getRegionModel = function(e2) {
      var n2 = this.getData();
      return n2.getItemModel(n2.indexOfName(e2));
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      for (var i = this.getData(), o = this.getRawValue(e2), s = i.getName(e2), u = this.seriesGroup, l2 = [], c2 = 0; c2 < u.length; c2++) {
        var f2 = u[c2].originalData.indexOfName(s), h = i.mapDimension("value");
        isNaN(u[c2].originalData.get(h, f2)) || l2.push(u[c2].name);
      }
      return Hu("section", { header: l2.join(", "), noHeader: !l2.length, blocks: [Hu("nameValue", { name: s, value: o })] });
    }, t2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, t2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, t2.prototype.getLegendIcon = function(e2) {
      var n2 = e2.icon || "roundRect", a = cu(n2, 0, 0, e2.itemWidth, e2.itemHeight, e2.itemStyle.fill);
      return a.setStyle(e2.itemStyle), a.style.stroke = "none", n2.indexOf("empty") > -1 && (a.style.stroke = a.style.fill, a.style.fill = "#fff", a.style.lineWidth = 2), a;
    }, t2.type = "series.map", t2.dependencies = ["geo"], t2.layoutMode = "box", t2.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, t2;
  }(ns), Tge = Age;
  function Mge(r2, t2) {
    var e2 = {};
    return ae(r2, function(n2) {
      n2.each(n2.mapDimension("value"), function(a, i) {
        var o = "ec-" + n2.getName(i);
        e2[o] = e2[o] || [], isNaN(a) || e2[o].push(a);
      });
    }), r2[0].map(r2[0].mapDimension("value"), function(n2, a) {
      for (var i = "ec-" + r2[0].getName(a), o = 0, s = 1 / 0, u = -1 / 0, l2 = e2[i].length, c2 = 0; c2 < l2; c2++)
        s = Math.min(s, e2[i][c2]), u = Math.max(u, e2[i][c2]), o += e2[i][c2];
      var f2;
      return t2 === "min" ? f2 = s : t2 === "max" ? f2 = u : t2 === "average" ? f2 = o / l2 : f2 = o, l2 === 0 ? NaN : f2;
    });
  }
  function Pge(r2) {
    var t2 = {};
    r2.eachSeriesByType("map", function(e2) {
      var n2 = e2.getHostGeoModel(), a = n2 ? "o" + n2.id : "i" + e2.getMapType();
      (t2[a] = t2[a] || []).push(e2);
    }), ae(t2, function(e2, n2) {
      for (var a = Mge(pr(e2, function(o) {
        return o.getData();
      }), e2[0].get("mapValueCalculation")), i = 0; i < e2.length; i++)
        e2[i].originalData = e2[i].getData();
      for (var i = 0; i < e2.length; i++)
        e2[i].seriesGroup = e2, e2[i].needsDrawMap = i === 0 && !e2[i].getHostGeoModel(), e2[i].setData(a.cloneShallow()), e2[i].mainSeries = e2[0];
    });
  }
  function Dge(r2) {
    var t2 = {};
    r2.eachSeriesByType("map", function(e2) {
      var n2 = e2.getMapType();
      if (!(e2.getHostGeoModel() || t2[n2])) {
        var a = {};
        ae(e2.seriesGroup, function(o) {
          var s = o.coordinateSystem, u = o.originalData;
          o.get("showLegendSymbol") && r2.getComponent("legend") && u.each(u.mapDimension("value"), function(l2, c2) {
            var f2 = u.getName(c2), h = s.getRegion(f2);
            if (!(!h || isNaN(l2))) {
              var v9 = a[f2] || 0, d2 = s.dataToPoint(h.getCenter());
              a[f2] = v9 + 1, u.setItemLayout(c2, { point: d2, offset: v9 });
            }
          });
        });
        var i = e2.getData();
        i.each(function(o) {
          var s = i.getName(o), u = i.getItemLayout(o) || {};
          u.showLabel = !a[s], i.setItemLayout(o, u);
        }), t2[n2] = true;
      }
    });
  }
  var pB = Nl, Ige = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      return n2.type = "view", n2.dimensions = ["x", "y"], n2._roamTransformable = new mg(), n2._rawTransformable = new mg(), n2.name = e2, n2;
    }
    return t2.prototype.setBoundingRect = function(e2, n2, a, i) {
      return this._rect = new da(e2, n2, a, i), this._rect;
    }, t2.prototype.getBoundingRect = function() {
      return this._rect;
    }, t2.prototype.setViewRect = function(e2, n2, a, i) {
      this._transformTo(e2, n2, a, i), this._viewRect = new da(e2, n2, a, i);
    }, t2.prototype._transformTo = function(e2, n2, a, i) {
      var o = this.getBoundingRect(), s = this._rawTransformable;
      s.transform = o.calculateTransform(new da(e2, n2, a, i));
      var u = s.parent;
      s.parent = null, s.decomposeTransform(), s.parent = u, this._updateTransform();
    }, t2.prototype.setCenter = function(e2) {
      !e2 || (this._center = e2, this._updateCenterAndZoom());
    }, t2.prototype.setZoom = function(e2) {
      e2 = e2 || 1;
      var n2 = this.zoomLimit;
      n2 && (n2.max != null && (e2 = Math.min(n2.max, e2)), n2.min != null && (e2 = Math.max(n2.min, e2))), this._zoom = e2, this._updateCenterAndZoom();
    }, t2.prototype.getDefaultCenter = function() {
      var e2 = this.getBoundingRect(), n2 = e2.x + e2.width / 2, a = e2.y + e2.height / 2;
      return [n2, a];
    }, t2.prototype.getCenter = function() {
      return this._center || this.getDefaultCenter();
    }, t2.prototype.getZoom = function() {
      return this._zoom || 1;
    }, t2.prototype.getRoamTransform = function() {
      return this._roamTransformable.getLocalTransform();
    }, t2.prototype._updateCenterAndZoom = function() {
      var e2 = this._rawTransformable.getLocalTransform(), n2 = this._roamTransformable, a = this.getDefaultCenter(), i = this.getCenter(), o = this.getZoom();
      i = Nl([], i, e2), a = Nl([], a, e2), n2.originX = i[0], n2.originY = i[1], n2.x = a[0] - i[0], n2.y = a[1] - i[1], n2.scaleX = n2.scaleY = o, this._updateTransform();
    }, t2.prototype._updateTransform = function() {
      var e2 = this._roamTransformable, n2 = this._rawTransformable;
      n2.parent = e2, e2.updateTransform(), n2.updateTransform(), G6(this.transform || (this.transform = []), n2.transform || Hh()), this._rawTransform = n2.getLocalTransform(), this.invTransform = this.invTransform || [], fw(this.invTransform, this.transform), this.decomposeTransform();
    }, t2.prototype.getTransformInfo = function() {
      var e2 = this._rawTransformable, n2 = this._roamTransformable, a = new mg();
      return a.transform = n2.transform, a.decomposeTransform(), { roam: { x: a.x, y: a.y, scaleX: a.scaleX, scaleY: a.scaleY }, raw: { x: e2.x, y: e2.y, scaleX: e2.scaleX, scaleY: e2.scaleY } };
    }, t2.prototype.getViewRect = function() {
      return this._viewRect;
    }, t2.prototype.getViewRectAfterRoam = function() {
      var e2 = this.getBoundingRect().clone();
      return e2.applyTransform(this.transform), e2;
    }, t2.prototype.dataToPoint = function(e2, n2, a) {
      var i = n2 ? this._rawTransform : this.transform;
      return a = a || [], i ? pB(a, e2, i) : Lc(a, e2);
    }, t2.prototype.pointToData = function(e2) {
      var n2 = this.invTransform;
      return n2 ? pB([], e2, n2) : [e2[0], e2[1]];
    }, t2.prototype.convertToPixel = function(e2, n2, a) {
      var i = gB(n2);
      return i === this ? i.dataToPoint(a) : null;
    }, t2.prototype.convertFromPixel = function(e2, n2, a) {
      var i = gB(n2);
      return i === this ? i.pointToData(a) : null;
    }, t2.prototype.containPoint = function(e2) {
      return this.getViewRectAfterRoam().contain(e2[0], e2[1]);
    }, t2.dimensions = ["x", "y"], t2;
  }(mg);
  function gB(r2) {
    var t2 = r2.seriesModel;
    return t2 ? t2.coordinateSystem : null;
  }
  var YE = Ige, Lge = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, ZY = ["lng", "lat"], XY2 = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this, e2) || this;
      i.dimensions = ZY, i.type = "geo", i._nameCoordMap = mn(), i.map = n2;
      var o = a.projection, s = Lg.load(n2, a.nameMap, a.nameProperty), u = Lg.getGeoResource(n2);
      i.resourceType = u ? u.type : null;
      var l2 = i.regions = s.regions, c2 = Lge[u.type];
      i._regionsMap = s.regionsMap, i.regions = s.regions, i.projection = o;
      var f2;
      if (o)
        for (var h = 0; h < l2.length; h++) {
          var v9 = l2[h].getBoundingRect(o);
          f2 = f2 || v9.clone(), f2.union(v9);
        }
      else
        f2 = s.boundingRect;
      return i.setBoundingRect(f2.x, f2.y, f2.width, f2.height), i.aspectScale = o ? 1 : ia(a.aspectScale, c2.aspectScale), i._invertLongitute = o ? false : c2.invertLongitute, i;
    }
    return t2.prototype._transformTo = function(e2, n2, a, i) {
      var o = this.getBoundingRect(), s = this._invertLongitute;
      o = o.clone(), s && (o.y = -o.y - o.height);
      var u = this._rawTransformable;
      u.transform = o.calculateTransform(new da(e2, n2, a, i));
      var l2 = u.parent;
      u.parent = null, u.decomposeTransform(), u.parent = l2, s && (u.scaleY = -u.scaleY), this._updateTransform();
    }, t2.prototype.getRegion = function(e2) {
      return this._regionsMap.get(e2);
    }, t2.prototype.getRegionByCoord = function(e2) {
      for (var n2 = this.regions, a = 0; a < n2.length; a++) {
        var i = n2[a];
        if (i.type === "geoJSON" && i.contain(e2))
          return n2[a];
      }
    }, t2.prototype.addGeoCoord = function(e2, n2) {
      this._nameCoordMap.set(e2, n2);
    }, t2.prototype.getGeoCoord = function(e2) {
      var n2 = this._regionsMap.get(e2);
      return this._nameCoordMap.get(e2) || n2 && n2.getCenter();
    }, t2.prototype.dataToPoint = function(e2, n2, a) {
      if (Zr(e2) && (e2 = this.getGeoCoord(e2)), e2) {
        var i = this.projection;
        return i && (e2 = i.project(e2)), e2 && this.projectedToPoint(e2);
      }
    }, t2.prototype.pointToData = function(e2) {
      var n2 = this.projection;
      return n2 && (e2 = n2.unproject(e2)), e2 && this.pointToProjected(e2);
    }, t2.prototype.pointToProjected = function(e2) {
      return r2.prototype.pointToData.call(this, e2);
    }, t2.prototype.projectedToPoint = function(e2, n2, a) {
      return r2.prototype.dataToPoint.call(this, e2, n2, a);
    }, t2.prototype.convertToPixel = function(e2, n2, a) {
      var i = yB(n2);
      return i === this ? i.dataToPoint(a) : null;
    }, t2.prototype.convertFromPixel = function(e2, n2, a) {
      var i = yB(n2);
      return i === this ? i.pointToData(a) : null;
    }, t2;
  }(YE);
  fu(XY2, YE);
  function yB(r2) {
    var t2 = r2.geoModel, e2 = r2.seriesModel;
    return t2 ? t2.coordinateSystem : e2 ? e2.coordinateSystem || (e2.getReferringComponents("geo", uu).models[0] || {}).coordinateSystem : null;
  }
  var mB = XY2;
  function bB(r2, t2) {
    var e2 = r2.get("boundingCoords");
    if (e2 != null) {
      var n2 = e2[0], a = e2[1];
      if (isFinite(n2[0]) && isFinite(n2[1]) && isFinite(a[0]) && isFinite(a[1])) {
        var i = this.projection;
        if (i) {
          var o = n2[0], s = n2[1], u = a[0], l2 = a[1];
          n2 = [1 / 0, 1 / 0], a = [-1 / 0, -1 / 0];
          var c2 = function(V, $, U, H) {
            for (var q3 = U - V, ee = H - $, oe = 0; oe <= 100; oe++) {
              var ne = oe / 100, be = i.project([V + q3 * ne, $ + ee * ne]);
              ry(n2, n2, be), ny(a, a, be);
            }
          };
          c2(o, s, u, s), c2(u, s, u, l2), c2(u, l2, o, l2), c2(o, l2, u, s);
        }
        this.setBoundingRect(n2[0], n2[1], a[0] - n2[0], a[1] - n2[1]);
      }
    }
    var f2 = this.getBoundingRect(), h = r2.get("layoutCenter"), v9 = r2.get("layoutSize"), d2 = t2.getWidth(), m2 = t2.getHeight(), b2 = f2.width / f2.height * this.aspectScale, _ = false, C, M;
    h && v9 && (C = [qr(h[0], d2), qr(h[1], m2)], M = qr(v9, Math.min(d2, m2)), !isNaN(C[0]) && !isNaN(C[1]) && !isNaN(M) && (_ = true));
    var E;
    if (_)
      E = {}, b2 > 1 ? (E.width = M, E.height = M / b2) : (E.height = M, E.width = M * b2), E.y = C[1] - E.height / 2, E.x = C[0] - E.width / 2;
    else {
      var z9 = r2.getBoxLayoutParams();
      z9.aspect = b2, E = Eu(z9, { width: d2, height: m2 });
    }
    this.setViewRect(E.x, E.y, E.width, E.height), this.setCenter(r2.get("center")), this.setZoom(r2.get("zoom"));
  }
  function Oge(r2, t2) {
    ae(t2.get("geoCoord"), function(e2, n2) {
      r2.addGeoCoord(n2, e2);
    });
  }
  var kge = function() {
    function r2() {
      this.dimensions = ZY;
    }
    return r2.prototype.create = function(t2, e2) {
      var n2 = [];
      function a(o) {
        return { nameProperty: o.get("nameProperty"), aspectScale: o.get("aspectScale"), projection: o.get("projection") };
      }
      t2.eachComponent("geo", function(o, s) {
        var u = o.get("map"), l2 = new mB(u + s, u, qt({ nameMap: o.get("nameMap") }, a(o)));
        l2.zoomLimit = o.get("scaleLimit"), n2.push(l2), o.coordinateSystem = l2, l2.model = o, l2.resize = bB, l2.resize(o, e2);
      }), t2.eachSeries(function(o) {
        var s = o.get("coordinateSystem");
        if (s === "geo") {
          var u = o.get("geoIndex") || 0;
          o.coordinateSystem = n2[u];
        }
      });
      var i = {};
      return t2.eachSeriesByType("map", function(o) {
        if (!o.getHostGeoModel()) {
          var s = o.getMapType();
          i[s] = i[s] || [], i[s].push(o);
        }
      }), ae(i, function(o, s) {
        var u = pr(o, function(c2) {
          return c2.get("nameMap");
        }), l2 = new mB(s, s, qt({ nameMap: N6(u) }, a(o[0])));
        l2.zoomLimit = ml.apply(null, pr(o, function(c2) {
          return c2.get("scaleLimit");
        })), n2.push(l2), l2.resize = bB, l2.resize(o[0], e2), ae(o, function(c2) {
          c2.coordinateSystem = l2, Oge(l2, c2);
        });
      }), n2;
    }, r2.prototype.getFilledRegions = function(t2, e2, n2, a) {
      for (var i = (t2 || []).slice(), o = mn(), s = 0; s < i.length; s++)
        o.set(i[s].name, i[s]);
      var u = Lg.load(e2, n2, a);
      return ae(u.regions, function(l2) {
        var c2 = l2.name;
        !o.get(c2) && i.push({ name: c2 });
      }), i;
    }, r2;
  }(), Rge = new kge(), JY = Rge, Fge = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      var i = Lg.getGeoResource(e2.map);
      if (i && i.type === "geoJSON") {
        var o = e2.itemStyle = e2.itemStyle || {};
        "color" in o || (o.color = "#eee");
      }
      this.mergeDefaultAndTheme(e2, a), Qb(e2, "label", ["show"]);
    }, t2.prototype.optionUpdated = function() {
      var e2 = this, n2 = this.option;
      n2.regions = JY.getFilledRegions(n2.regions, n2.map, n2.nameMap, n2.nameProperty);
      var a = {};
      this._optionModelMap = Qd(n2.regions || [], function(i, o) {
        var s = o.name;
        return s && (i.set(s, new To(o, e2, e2.ecModel)), o.selected && (a[s] = true)), i;
      }, mn()), n2.selectedMap || (n2.selectedMap = a);
    }, t2.prototype.getRegionModel = function(e2) {
      return this._optionModelMap.get(e2) || new To(null, this, this.ecModel);
    }, t2.prototype.getFormattedLabel = function(e2, n2) {
      var a = this.getRegionModel(e2), i = n2 === "normal" ? a.get(["label", "formatter"]) : a.get(["emphasis", "label", "formatter"]), o = { name: e2 };
      if (xn(i))
        return o.status = n2, i(o);
      if (Zr(i))
        return i.replace("{a}", e2 != null ? e2 : "");
    }, t2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, t2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, t2.prototype.select = function(e2) {
      var n2 = this.option, a = n2.selectedMode;
      if (!!a) {
        a !== "multiple" && (n2.selectedMap = null);
        var i = n2.selectedMap || (n2.selectedMap = {});
        i[e2] = true;
      }
    }, t2.prototype.unSelect = function(e2) {
      var n2 = this.option.selectedMap;
      n2 && (n2[e2] = false);
    }, t2.prototype.toggleSelected = function(e2) {
      this[this.isSelected(e2) ? "unSelect" : "select"](e2);
    }, t2.prototype.isSelected = function(e2) {
      var n2 = this.option.selectedMap;
      return !!(n2 && n2[e2]);
    }, t2.type = "geo", t2.layoutMode = "box", t2.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, t2;
  }(li), Nge = Fge;
  function _B(r2, t2) {
    return r2.pointToProjected ? r2.pointToProjected(t2) : r2.pointToData(t2);
  }
  function KF(r2, t2, e2) {
    var n2 = r2.getZoom(), a = r2.getCenter(), i = t2.zoom, o = r2.projectedToPoint ? r2.projectedToPoint(a) : r2.dataToPoint(a);
    if (t2.dx != null && t2.dy != null && (o[0] -= t2.dx, o[1] -= t2.dy, r2.setCenter(_B(r2, o))), i != null) {
      if (e2) {
        var s = e2.min || 0, u = e2.max || 1 / 0;
        i = Math.max(Math.min(n2 * i, u), s) / n2;
      }
      r2.scaleX *= i, r2.scaleY *= i;
      var l2 = (t2.originX - r2.x) * (i - 1), c2 = (t2.originY - r2.y) * (i - 1);
      r2.x -= l2, r2.y -= c2, r2.updateTransform(), r2.setCenter(_B(r2, o)), r2.setZoom(i * n2);
    }
    return { center: r2.getCenter(), zoom: r2.getZoom() };
  }
  var Vge = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.focusBlurEnabled = true, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this._api = n2;
    }, t2.prototype.render = function(e2, n2, a, i) {
      if (this._model = e2, !e2.get("show")) {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        return;
      }
      this._mapDraw || (this._mapDraw = new KY(a));
      var o = this._mapDraw;
      o.draw(e2, n2, a, this, i), o.group.on("click", this._handleRegionClick, this), o.group.silent = e2.get("silent"), this.group.add(o.group), this.updateSelectStatus(e2, n2, a);
    }, t2.prototype._handleRegionClick = function(e2) {
      var n2;
      $x(e2.target, function(a) {
        return (n2 = zn(a).eventData) != null;
      }, true), n2 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: n2.name });
    }, t2.prototype.updateSelectStatus = function(e2, n2, a) {
      var i = this;
      this._mapDraw.group.traverse(function(o) {
        var s = zn(o).eventData;
        if (s)
          return i._model.isSelected(s.name) ? a.enterSelect(o) : a.leaveSelect(o), true;
      });
    }, t2.prototype.findHighDownDispatchers = function(e2) {
      return this._mapDraw && this._mapDraw.findHighDownDispatchers(e2, this._model);
    }, t2.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove();
    }, t2.type = "geo", t2;
  }(gs), jge = Vge;
  function Bge(r2, t2, e2) {
    Lg.registerMap(r2, t2, e2);
  }
  function QY(r2) {
    r2.registerCoordinateSystem("geo", JY), r2.registerComponentModel(Nge), r2.registerComponentView(jge), r2.registerImpl("registerMap", Bge), r2.registerImpl("getMap", function(e2) {
      return Lg.getMapForUser(e2);
    });
    function t2(e2, n2) {
      n2.update = "geo:updateSelectStatus", r2.registerAction(n2, function(a, i) {
        var o = {}, s = [];
        return i.eachComponent({ mainType: "geo", query: a }, function(u) {
          u[e2](a.name);
          var l2 = u.coordinateSystem;
          ae(l2.regions, function(f2) {
            o[f2.name] = u.isSelected(f2.name) || false;
          });
          var c2 = [];
          ae(o, function(f2, h) {
            o[h] && c2.push(h);
          }), s.push({ geoIndex: u.componentIndex, name: c2 });
        }), { selected: o, allSelected: s, name: a.name };
      });
    }
    t2("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), t2("select", { type: "geoSelect", event: "geoselected" }), t2("unSelect", { type: "geoUnSelect", event: "geounselected" }), r2.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(e2, n2) {
      var a = e2.componentType || "series";
      n2.eachComponent({ mainType: a, query: e2 }, function(i) {
        var o = i.coordinateSystem;
        if (o.type === "geo") {
          var s = KF(o, e2, i.get("scaleLimit"));
          i.setCenter && i.setCenter(s.center), i.setZoom && i.setZoom(s.zoom), a === "series" && ae(i.seriesGroup, function(u) {
            u.setCenter(s.center), u.setZoom(s.zoom);
          });
        }
      });
    });
  }
  function zge(r2) {
    ya(QY), r2.registerChartView(Ege), r2.registerSeriesModel(Tge), r2.registerLayout(Dge), r2.registerProcessor(r2.PRIORITY.PROCESSOR.STATISTIC, Pge), QH("map", r2.registerAction);
  }
  function $ge(r2) {
    var t2 = r2;
    t2.hierNode = { defaultAncestor: null, ancestor: t2, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
    for (var e2 = [t2], n2, a; n2 = e2.pop(); )
      if (a = n2.children, n2.isExpand && a.length)
        for (var i = a.length, o = i - 1; o >= 0; o--) {
          var s = a[o];
          s.hierNode = { defaultAncestor: null, ancestor: s, prelim: 0, modifier: 0, change: 0, shift: 0, i: o, thread: null }, e2.push(s);
        }
  }
  function Gge(r2, t2) {
    var e2 = r2.isExpand ? r2.children : [], n2 = r2.parentNode.children, a = r2.hierNode.i ? n2[r2.hierNode.i - 1] : null;
    if (e2.length) {
      Hge(r2);
      var i = (e2[0].hierNode.prelim + e2[e2.length - 1].hierNode.prelim) / 2;
      a ? (r2.hierNode.prelim = a.hierNode.prelim + t2(r2, a), r2.hierNode.modifier = r2.hierNode.prelim - i) : r2.hierNode.prelim = i;
    } else
      a && (r2.hierNode.prelim = a.hierNode.prelim + t2(r2, a));
    r2.parentNode.hierNode.defaultAncestor = qge(r2, a, r2.parentNode.hierNode.defaultAncestor || n2[0], t2);
  }
  function Wge(r2) {
    var t2 = r2.hierNode.prelim + r2.parentNode.hierNode.modifier;
    r2.setLayout({ x: t2 }, true), r2.hierNode.modifier += r2.parentNode.hierNode.modifier;
  }
  function xB(r2) {
    return arguments.length ? r2 : Zge;
  }
  function AC(r2, t2) {
    return r2 -= Math.PI / 2, { x: t2 * Math.cos(r2), y: t2 * Math.sin(r2) };
  }
  function Uge(r2, t2) {
    return Eu(r2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() });
  }
  function Hge(r2) {
    for (var t2 = r2.children, e2 = t2.length, n2 = 0, a = 0; --e2 >= 0; ) {
      var i = t2[e2];
      i.hierNode.prelim += n2, i.hierNode.modifier += n2, a += i.hierNode.change, n2 += i.hierNode.shift + a;
    }
  }
  function qge(r2, t2, e2, n2) {
    if (t2) {
      for (var a = r2, i = r2, o = i.parentNode.children[0], s = t2, u = a.hierNode.modifier, l2 = i.hierNode.modifier, c2 = o.hierNode.modifier, f2 = s.hierNode.modifier; s = xk(s), i = wk(i), s && i; ) {
        a = xk(a), o = wk(o), a.hierNode.ancestor = r2;
        var h = s.hierNode.prelim + f2 - i.hierNode.prelim - l2 + n2(s, i);
        h > 0 && (Kge(Yge(s, r2, e2), r2, h), l2 += h, u += h), f2 += s.hierNode.modifier, l2 += i.hierNode.modifier, u += a.hierNode.modifier, c2 += o.hierNode.modifier;
      }
      s && !xk(a) && (a.hierNode.thread = s, a.hierNode.modifier += f2 - u), i && !wk(o) && (o.hierNode.thread = i, o.hierNode.modifier += l2 - c2, e2 = r2);
    }
    return e2;
  }
  function xk(r2) {
    var t2 = r2.children;
    return t2.length && r2.isExpand ? t2[t2.length - 1] : r2.hierNode.thread;
  }
  function wk(r2) {
    var t2 = r2.children;
    return t2.length && r2.isExpand ? t2[0] : r2.hierNode.thread;
  }
  function Yge(r2, t2, e2) {
    return r2.hierNode.ancestor.parentNode === t2.parentNode ? r2.hierNode.ancestor : e2;
  }
  function Kge(r2, t2, e2) {
    var n2 = e2 / (t2.hierNode.i - r2.hierNode.i);
    t2.hierNode.change -= n2, t2.hierNode.shift += e2, t2.hierNode.modifier += e2, t2.hierNode.prelim += e2, r2.hierNode.change += n2;
  }
  function Zge(r2, t2) {
    return r2.parentNode === t2.parentNode ? 1 : 2;
  }
  var Xge = function() {
    function r2() {
      this.parentPoint = [], this.childPoints = [];
    }
    return r2;
  }(), Jge = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new Xge();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.childPoints, i = a.length, o = n2.parentPoint, s = a[0], u = a[i - 1];
      if (i === 1) {
        e2.moveTo(o[0], o[1]), e2.lineTo(s[0], s[1]);
        return;
      }
      var l2 = n2.orient, c2 = l2 === "TB" || l2 === "BT" ? 0 : 1, f2 = 1 - c2, h = qr(n2.forkPosition, 1), v9 = [];
      v9[c2] = o[c2], v9[f2] = o[f2] + (u[f2] - o[f2]) * h, e2.moveTo(o[0], o[1]), e2.lineTo(v9[0], v9[1]), e2.moveTo(s[0], s[1]), v9[c2] = s[c2], e2.lineTo(v9[0], v9[1]), v9[c2] = u[c2], e2.lineTo(v9[0], v9[1]), e2.lineTo(u[0], u[1]);
      for (var d2 = 1; d2 < i - 1; d2++) {
        var m2 = a[d2];
        e2.moveTo(m2[0], m2[1]), v9[c2] = m2[c2], e2.lineTo(v9[0], v9[1]);
      }
    }, t2;
  }(xa), Qge = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._mainGroup = new Fn(), e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this._controller = new qE(n2.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
    }, t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = e2.layoutInfo, s = this._mainGroup, u = e2.get("layout");
      u === "radial" ? (s.x = o.x + o.width / 2, s.y = o.y + o.height / 2) : (s.x = o.x, s.y = o.y), this._updateViewCoordSys(e2), this._updateController(e2, n2, a);
      var l2 = this._data;
      i.diff(l2).add(function(c2) {
        wB(i, c2) && SB(i, c2, null, s, e2);
      }).update(function(c2, f2) {
        var h = l2.getItemGraphicEl(f2);
        if (!wB(i, c2)) {
          h && EB(l2, f2, h, s, e2);
          return;
        }
        SB(i, c2, h, s, e2);
      }).remove(function(c2) {
        var f2 = l2.getItemGraphicEl(c2);
        f2 && EB(l2, c2, f2, s, e2);
      }).execute(), this._nodeScaleRatio = e2.get("nodeScaleRatio"), this._updateNodeAndLinkScale(e2), e2.get("expandAndCollapse") === true && i.eachItemGraphicEl(function(c2, f2) {
        c2.off("click").on("click", function() {
          a.dispatchAction({ type: "treeExpandAndCollapse", seriesId: e2.id, dataIndex: f2 });
        });
      }), this._data = i;
    }, t2.prototype._updateViewCoordSys = function(e2) {
      var n2 = e2.getData(), a = [];
      n2.each(function(c2) {
        var f2 = n2.getItemLayout(c2);
        f2 && !isNaN(f2.x) && !isNaN(f2.y) && a.push([+f2.x, +f2.y]);
      });
      var i = [], o = [];
      XP(a, i, o);
      var s = this._min, u = this._max;
      o[0] - i[0] === 0 && (i[0] = s ? s[0] : i[0] - 1, o[0] = u ? u[0] : o[0] + 1), o[1] - i[1] === 0 && (i[1] = s ? s[1] : i[1] - 1, o[1] = u ? u[1] : o[1] + 1);
      var l2 = e2.coordinateSystem = new YE();
      l2.zoomLimit = e2.get("scaleLimit"), l2.setBoundingRect(i[0], i[1], o[0] - i[0], o[1] - i[1]), l2.setCenter(e2.get("center")), l2.setZoom(e2.get("zoom")), this.group.attr({ x: l2.x, y: l2.y, scaleX: l2.scaleX, scaleY: l2.scaleY }), this._min = i, this._max = o;
    }, t2.prototype._updateController = function(e2, n2, a) {
      var i = this, o = this._controller, s = this._controllerHost, u = this.group;
      o.setPointerChecker(function(l2, c2, f2) {
        var h = u.getBoundingRect();
        return h.applyTransform(u.transform), h.contain(c2, f2) && !x3(l2, a, e2);
      }), o.enable(e2.get("roam")), s.zoomLimit = e2.get("scaleLimit"), s.zoom = e2.coordinateSystem.getZoom(), o.off("pan").off("zoom").on("pan", function(l2) {
        HF(s, l2.dx, l2.dy), a.dispatchAction({ seriesId: e2.id, type: "treeRoam", dx: l2.dx, dy: l2.dy });
      }).on("zoom", function(l2) {
        qF(s, l2.scale, l2.originX, l2.originY), a.dispatchAction({ seriesId: e2.id, type: "treeRoam", zoom: l2.scale, originX: l2.originX, originY: l2.originY }), i._updateNodeAndLinkScale(e2), a.updateLabelLayout();
      });
    }, t2.prototype._updateNodeAndLinkScale = function(e2) {
      var n2 = e2.getData(), a = this._getNodeGlobalScale(e2);
      n2.eachItemGraphicEl(function(i, o) {
        i.setSymbolScale(a);
      });
    }, t2.prototype._getNodeGlobalScale = function(e2) {
      var n2 = e2.coordinateSystem;
      if (n2.type !== "view")
        return 1;
      var a = this._nodeScaleRatio, i = n2.scaleX || 1, o = n2.getZoom(), s = (o - 1) * a + 1;
      return s / i;
    }, t2.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, t2.prototype.remove = function() {
      this._mainGroup.removeAll(), this._data = null;
    }, t2.type = "tree", t2;
  }(Mo);
  function wB(r2, t2) {
    var e2 = r2.getItemLayout(t2);
    return e2 && !isNaN(e2.x) && !isNaN(e2.y);
  }
  function SB(r2, t2, e2, n2, a) {
    var i = !e2, o = r2.tree.getNodeByDataIndex(t2), s = o.getModel(), u = o.getVisual("style").fill, l2 = o.isExpand === false && o.children.length !== 0 ? u : "#fff", c2 = r2.tree.root, f2 = o.parentNode === c2 ? o : o.parentNode || o, h = r2.getItemGraphicEl(f2.dataIndex), v9 = f2.getLayout(), d2 = h ? { x: h.__oldX, y: h.__oldY, rawX: h.__radialOldRawX, rawY: h.__radialOldRawY } : v9, m2 = o.getLayout();
    i ? (e2 = new $E(r2, t2, null, { symbolInnerColor: l2, useNameLabel: true }), e2.x = d2.x, e2.y = d2.y) : e2.updateData(r2, t2, null, { symbolInnerColor: l2, useNameLabel: true }), e2.__radialOldRawX = e2.__radialRawX, e2.__radialOldRawY = e2.__radialRawY, e2.__radialRawX = m2.rawX, e2.__radialRawY = m2.rawY, n2.add(e2), r2.setItemGraphicEl(t2, e2), e2.__oldX = e2.x, e2.__oldY = e2.y, ci(e2, { x: m2.x, y: m2.y }, a);
    var b2 = e2.getSymbolPath();
    if (a.get("layout") === "radial") {
      var _ = c2.children[0], C = _.getLayout(), M = _.children.length, E = void 0, z9 = void 0;
      if (m2.x === C.x && o.isExpand === true) {
        var V = { x: (_.children[0].getLayout().x + _.children[M - 1].getLayout().x) / 2, y: (_.children[0].getLayout().y + _.children[M - 1].getLayout().y) / 2 };
        E = Math.atan2(V.y - C.y, V.x - C.x), E < 0 && (E = Math.PI * 2 + E), z9 = V.x < C.x, z9 && (E = E - Math.PI);
      } else
        E = Math.atan2(m2.y - C.y, m2.x - C.x), E < 0 && (E = Math.PI * 2 + E), o.children.length === 0 || o.children.length !== 0 && o.isExpand === false ? (z9 = m2.x < C.x, z9 && (E = E - Math.PI)) : (z9 = m2.x > C.x, z9 || (E = E - Math.PI));
      var $ = z9 ? "left" : "right", U = s.getModel("label"), H = U.get("rotate"), q3 = H * (Math.PI / 180), ee = b2.getTextContent();
      ee && (b2.setTextConfig({ position: U.get("position") || $, rotation: H == null ? -E : q3, origin: "center" }), ee.setStyle("verticalAlign", "middle"));
    }
    var oe = s.get(["emphasis", "focus"]), ne = oe === "ancestor" ? o.getAncestorsIndices() : oe === "descendant" ? o.getDescendantIndices() : null;
    ne && (zn(e2).focus = ne), e0e(a, o, c2, e2, d2, v9, m2, n2), e2.__edge && (e2.onHoverStateChange = function(be) {
      if (be !== "blur") {
        var Ee = o.parentNode && r2.getItemGraphicEl(o.parentNode.dataIndex);
        Ee && Ee.hoverState === IE || Q5(e2.__edge, be);
      }
    });
  }
  function e0e(r2, t2, e2, n2, a, i, o, s) {
    var u = t2.getModel(), l2 = r2.get("edgeShape"), c2 = r2.get("layout"), f2 = r2.getOrient(), h = r2.get(["lineStyle", "curveness"]), v9 = r2.get("edgeForkPosition"), d2 = u.getModel("lineStyle").getLineStyle(), m2 = n2.__edge;
    if (l2 === "curve")
      t2.parentNode && t2.parentNode !== e2 && (m2 || (m2 = n2.__edge = new t3({ shape: j4(c2, f2, h, a, a) })), ci(m2, { shape: j4(c2, f2, h, i, o) }, r2));
    else if (l2 === "polyline" && c2 === "orthogonal" && t2 !== e2 && t2.children && t2.children.length !== 0 && t2.isExpand === true) {
      for (var b2 = t2.children, _ = [], C = 0; C < b2.length; C++) {
        var M = b2[C].getLayout();
        _.push([M.x, M.y]);
      }
      m2 || (m2 = n2.__edge = new Jge({ shape: { parentPoint: [o.x, o.y], childPoints: [[o.x, o.y]], orient: f2, forkPosition: v9 } })), ci(m2, { shape: { parentPoint: [o.x, o.y], childPoints: _ } }, r2);
    }
    m2 && (m2.useStyle(En({ strokeNoScale: true, fill: null }, d2)), jl(m2, u, "lineStyle"), r1(m2), s.add(m2));
  }
  function CB(r2, t2, e2, n2, a) {
    var i = t2.tree.root, o = eK(i, r2), s = o.source, u = o.sourceLayout, l2 = t2.getItemGraphicEl(r2.dataIndex);
    if (!!l2) {
      var c2 = t2.getItemGraphicEl(s.dataIndex), f2 = c2.__edge, h = l2.__edge || (s.isExpand === false || s.children.length === 1 ? f2 : void 0), v9 = n2.get("edgeShape"), d2 = n2.get("layout"), m2 = n2.get("orient"), b2 = n2.get(["lineStyle", "curveness"]);
      h && (v9 === "curve" ? my(h, { shape: j4(d2, m2, b2, u, u), style: { opacity: 0 } }, n2, { cb: function() {
        e2.remove(h);
      }, removeOpt: a }) : v9 === "polyline" && n2.get("layout") === "orthogonal" && my(h, { shape: { parentPoint: [u.x, u.y], childPoints: [[u.x, u.y]] }, style: { opacity: 0 } }, n2, { cb: function() {
        e2.remove(h);
      }, removeOpt: a }));
    }
  }
  function eK(r2, t2) {
    for (var e2 = t2.parentNode === r2 ? t2 : t2.parentNode || t2, n2; n2 = e2.getLayout(), n2 == null; )
      e2 = e2.parentNode === r2 ? e2 : e2.parentNode || e2;
    return { source: e2, sourceLayout: n2 };
  }
  function EB(r2, t2, e2, n2, a) {
    var i = r2.tree.getNodeByDataIndex(t2), o = r2.tree.root, s = eK(o, i).sourceLayout, u = { duration: a.get("animationDurationUpdate"), easing: a.get("animationEasingUpdate") };
    my(e2, { x: s.x + 1, y: s.y + 1 }, a, { cb: function() {
      n2.remove(e2), r2.setItemGraphicEl(t2, null);
    }, removeOpt: u }), e2.fadeOut(null, r2.hostModel, { fadeLabel: true, animation: u }), i.children.forEach(function(l2) {
      CB(l2, r2, n2, a, u);
    }), CB(i, r2, n2, a, u);
  }
  function j4(r2, t2, e2, n2, a) {
    var i, o, s, u, l2, c2, f2, h;
    if (r2 === "radial") {
      l2 = n2.rawX, f2 = n2.rawY, c2 = a.rawX, h = a.rawY;
      var v9 = AC(l2, f2), d2 = AC(l2, f2 + (h - f2) * e2), m2 = AC(c2, h + (f2 - h) * e2), b2 = AC(c2, h);
      return { x1: v9.x || 0, y1: v9.y || 0, x2: b2.x || 0, y2: b2.y || 0, cpx1: d2.x || 0, cpy1: d2.y || 0, cpx2: m2.x || 0, cpy2: m2.y || 0 };
    } else
      l2 = n2.x, f2 = n2.y, c2 = a.x, h = a.y, (t2 === "LR" || t2 === "RL") && (i = l2 + (c2 - l2) * e2, o = f2, s = c2 + (l2 - c2) * e2, u = h), (t2 === "TB" || t2 === "BT") && (i = l2, o = f2 + (h - f2) * e2, s = c2, u = h + (f2 - h) * e2);
    return { x1: l2, y1: f2, x2: c2, y2: h, cpx1: i, cpy1: o, cpx2: s, cpy2: u };
  }
  var t0e = Qge, Gh = fi();
  function tK(r2) {
    var t2 = r2.mainData, e2 = r2.datas;
    e2 || (e2 = { main: t2 }, r2.datasAttr = { main: "data" }), r2.datas = r2.mainData = null, rK(t2, e2, r2), ae(e2, function(n2) {
      ae(t2.TRANSFERABLE_METHODS, function(a) {
        n2.wrapMethod(a, Gn(r0e, r2));
      });
    }), t2.wrapMethod("cloneShallow", Gn(a0e, r2)), ae(t2.CHANGABLE_METHODS, function(n2) {
      t2.wrapMethod(n2, Gn(n0e, r2));
    }), Fc(e2[t2.dataType] === t2);
  }
  function r0e(r2, t2) {
    if (s0e(this)) {
      var e2 = qt({}, Gh(this).datas);
      e2[this.dataType] = t2, rK(t2, e2, r2);
    } else
      ZF(t2, this.dataType, Gh(this).mainData, r2);
    return t2;
  }
  function n0e(r2, t2) {
    return r2.struct && r2.struct.update(), t2;
  }
  function a0e(r2, t2) {
    return ae(Gh(t2).datas, function(e2, n2) {
      e2 !== t2 && ZF(e2.cloneShallow(), n2, t2, r2);
    }), t2;
  }
  function i0e(r2) {
    var t2 = Gh(this).mainData;
    return r2 == null || t2 == null ? t2 : Gh(t2).datas[r2];
  }
  function o0e() {
    var r2 = Gh(this).mainData;
    return r2 == null ? [{ data: r2 }] : pr(ja(Gh(r2).datas), function(t2) {
      return { type: t2, data: Gh(r2).datas[t2] };
    });
  }
  function s0e(r2) {
    return Gh(r2).mainData === r2;
  }
  function rK(r2, t2, e2) {
    Gh(r2).datas = {}, ae(t2, function(n2, a) {
      ZF(n2, a, r2, e2);
    });
  }
  function ZF(r2, t2, e2, n2) {
    Gh(e2).datas[t2] = r2, Gh(r2).mainData = e2, r2.dataType = t2, n2.struct && (r2[n2.structAttr] = n2.struct, n2.struct[n2.datasAttr[t2]] = r2), r2.getLinkedData = i0e, r2.getLinkedDataAll = o0e;
  }
  var u0e = function() {
    function r2(t2, e2) {
      this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = t2 || "", this.hostTree = e2;
    }
    return r2.prototype.isRemoved = function() {
      return this.dataIndex < 0;
    }, r2.prototype.eachNode = function(t2, e2, n2) {
      xn(t2) && (n2 = e2, e2 = t2, t2 = null), t2 = t2 || {}, Zr(t2) && (t2 = { order: t2 });
      var a = t2.order || "preorder", i = this[t2.attr || "children"], o;
      a === "preorder" && (o = e2.call(n2, this));
      for (var s = 0; !o && s < i.length; s++)
        i[s].eachNode(t2, e2, n2);
      a === "postorder" && e2.call(n2, this);
    }, r2.prototype.updateDepthAndHeight = function(t2) {
      var e2 = 0;
      this.depth = t2;
      for (var n2 = 0; n2 < this.children.length; n2++) {
        var a = this.children[n2];
        a.updateDepthAndHeight(t2 + 1), a.height > e2 && (e2 = a.height);
      }
      this.height = e2 + 1;
    }, r2.prototype.getNodeById = function(t2) {
      if (this.getId() === t2)
        return this;
      for (var e2 = 0, n2 = this.children, a = n2.length; e2 < a; e2++) {
        var i = n2[e2].getNodeById(t2);
        if (i)
          return i;
      }
    }, r2.prototype.contains = function(t2) {
      if (t2 === this)
        return true;
      for (var e2 = 0, n2 = this.children, a = n2.length; e2 < a; e2++) {
        var i = n2[e2].contains(t2);
        if (i)
          return i;
      }
    }, r2.prototype.getAncestors = function(t2) {
      for (var e2 = [], n2 = t2 ? this : this.parentNode; n2; )
        e2.push(n2), n2 = n2.parentNode;
      return e2.reverse(), e2;
    }, r2.prototype.getAncestorsIndices = function() {
      for (var t2 = [], e2 = this; e2; )
        t2.push(e2.dataIndex), e2 = e2.parentNode;
      return t2.reverse(), t2;
    }, r2.prototype.getDescendantIndices = function() {
      var t2 = [];
      return this.eachNode(function(e2) {
        t2.push(e2.dataIndex);
      }), t2;
    }, r2.prototype.getValue = function(t2) {
      var e2 = this.hostTree.data;
      return e2.getStore().get(e2.getDimensionIndex(t2 || "value"), this.dataIndex);
    }, r2.prototype.setLayout = function(t2, e2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, t2, e2);
    }, r2.prototype.getLayout = function() {
      return this.hostTree.data.getItemLayout(this.dataIndex);
    }, r2.prototype.getModel = function(t2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostTree, n2 = e2.data.getItemModel(this.dataIndex);
        return n2.getModel(t2);
      }
    }, r2.prototype.getLevelModel = function() {
      return (this.hostTree.levelModels || [])[this.depth];
    }, r2.prototype.setVisual = function(t2, e2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, t2, e2);
    }, r2.prototype.getVisual = function(t2) {
      return this.hostTree.data.getItemVisual(this.dataIndex, t2);
    }, r2.prototype.getRawIndex = function() {
      return this.hostTree.data.getRawIndex(this.dataIndex);
    }, r2.prototype.getId = function() {
      return this.hostTree.data.getId(this.dataIndex);
    }, r2.prototype.getChildIndex = function() {
      if (this.parentNode) {
        for (var t2 = this.parentNode.children, e2 = 0; e2 < t2.length; ++e2)
          if (t2[e2] === this)
            return e2;
        return -1;
      }
      return -1;
    }, r2.prototype.isAncestorOf = function(t2) {
      for (var e2 = t2.parentNode; e2; ) {
        if (e2 === this)
          return true;
        e2 = e2.parentNode;
      }
      return false;
    }, r2.prototype.isDescendantOf = function(t2) {
      return t2 !== this && t2.isAncestorOf(this);
    }, r2;
  }(), l0e = function() {
    function r2(t2) {
      this.type = "tree", this._nodes = [], this.hostModel = t2;
    }
    return r2.prototype.eachNode = function(t2, e2, n2) {
      this.root.eachNode(t2, e2, n2);
    }, r2.prototype.getNodeByDataIndex = function(t2) {
      var e2 = this.data.getRawIndex(t2);
      return this._nodes[e2];
    }, r2.prototype.getNodeById = function(t2) {
      return this.root.getNodeById(t2);
    }, r2.prototype.update = function() {
      for (var t2 = this.data, e2 = this._nodes, n2 = 0, a = e2.length; n2 < a; n2++)
        e2[n2].dataIndex = -1;
      for (var n2 = 0, a = t2.count(); n2 < a; n2++)
        e2[t2.getRawIndex(n2)].dataIndex = n2;
    }, r2.prototype.clearLayouts = function() {
      this.data.clearItemLayouts();
    }, r2.createTree = function(t2, e2, n2) {
      var a = new r2(e2), i = [], o = 1;
      s(t2);
      function s(c2, f2) {
        var h = c2.value;
        o = Math.max(o, vr(h) ? h.length : 1), i.push(c2);
        var v9 = new u0e(Cu(c2.name, ""), a);
        f2 ? c0e(v9, f2) : a.root = v9, a._nodes.push(v9);
        var d2 = c2.children;
        if (d2)
          for (var m2 = 0; m2 < d2.length; m2++)
            s(d2[m2], v9);
      }
      a.root.updateDepthAndHeight(0);
      var u = jE(i, { coordDimensions: ["value"], dimensionsCount: o }).dimensions, l2 = new Rc(u, e2);
      return l2.initData(i), n2 && n2(l2), tK({ mainData: l2, struct: a, structAttr: "tree" }), a.update(), a;
    }, r2;
  }();
  function c0e(r2, t2) {
    var e2 = t2.children;
    r2.parentNode !== t2 && (e2.push(r2), r2.parentNode = t2);
  }
  var XF = l0e;
  function yE(r2, t2, e2) {
    if (r2 && va(t2, r2.type) >= 0) {
      var n2 = e2.getData().tree.root, a = r2.targetNode;
      if (Zr(a) && (a = n2.getNodeById(a)), a && n2.contains(a))
        return { node: a };
      var i = r2.targetNodeId;
      if (i != null && (a = n2.getNodeById(i)))
        return { node: a };
    }
  }
  function nK(r2) {
    for (var t2 = []; r2; )
      r2 = r2.parentNode, r2 && t2.push(r2);
    return t2.reverse();
  }
  function JF(r2, t2) {
    var e2 = nK(r2);
    return va(e2, t2) >= 0;
  }
  function S3(r2, t2) {
    for (var e2 = []; r2; ) {
      var n2 = r2.dataIndex;
      e2.push({ name: r2.name, dataIndex: n2, value: t2.getRawValue(n2) }), r2 = r2.parentNode;
    }
    return e2.reverse(), e2;
  }
  var f0e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.hasSymbolVisual = true, e2.ignoreStyleOnData = true, e2;
    }
    return t2.prototype.getInitialData = function(e2) {
      var n2 = { name: e2.name, children: e2.data }, a = e2.leaves || {}, i = new To(a, this, this.ecModel), o = XF.createTree(n2, this, s);
      function s(f2) {
        f2.wrapMethod("getItemModel", function(h, v9) {
          var d2 = o.getNodeByDataIndex(v9);
          return d2 && d2.children.length && d2.isExpand || (h.parentModel = i), h;
        });
      }
      var u = 0;
      o.eachNode("preorder", function(f2) {
        f2.depth > u && (u = f2.depth);
      });
      var l2 = e2.expandAndCollapse, c2 = l2 && e2.initialTreeDepth >= 0 ? e2.initialTreeDepth : u;
      return o.root.eachNode("preorder", function(f2) {
        var h = f2.hostTree.data.getRawDataItem(f2.dataIndex);
        f2.isExpand = h && h.collapsed != null ? !h.collapsed : f2.depth <= c2;
      }), o.data;
    }, t2.prototype.getOrient = function() {
      var e2 = this.get("orient");
      return e2 === "horizontal" ? e2 = "LR" : e2 === "vertical" && (e2 = "TB"), e2;
    }, t2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, t2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      for (var i = this.getData().tree, o = i.root.children[0], s = i.getNodeByDataIndex(e2), u = s.getValue(), l2 = s.name; s && s !== o; )
        l2 = s.parentNode.name + "." + l2, s = s.parentNode;
      return Hu("nameValue", { name: l2, value: u, noValue: isNaN(u) || u == null });
    }, t2.prototype.getDataParams = function(e2) {
      var n2 = r2.prototype.getDataParams.apply(this, arguments), a = this.getData().tree.getNodeByDataIndex(e2);
      return n2.treeAncestors = S3(a, this), n2;
    }, t2.type = "series.tree", t2.layoutMode = "box", t2.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, t2;
  }(ns), h0e = f0e;
  function v0e(r2, t2, e2) {
    for (var n2 = [r2], a = [], i; i = n2.pop(); )
      if (a.push(i), i.isExpand) {
        var o = i.children;
        if (o.length)
          for (var s = 0; s < o.length; s++)
            n2.push(o[s]);
      }
    for (; i = a.pop(); )
      t2(i, e2);
  }
  function sC(r2, t2) {
    for (var e2 = [r2], n2; n2 = e2.pop(); )
      if (t2(n2), n2.isExpand) {
        var a = n2.children;
        if (a.length)
          for (var i = a.length - 1; i >= 0; i--)
            e2.push(a[i]);
      }
  }
  function d0e(r2, t2) {
    r2.eachSeriesByType("tree", function(e2) {
      p0e(e2, t2);
    });
  }
  function p0e(r2, t2) {
    var e2 = Uge(r2, t2);
    r2.layoutInfo = e2;
    var n2 = r2.get("layout"), a = 0, i = 0, o = null;
    n2 === "radial" ? (a = 2 * Math.PI, i = Math.min(e2.height, e2.width) / 2, o = xB(function(M, E) {
      return (M.parentNode === E.parentNode ? 1 : 2) / M.depth;
    })) : (a = e2.width, i = e2.height, o = xB());
    var s = r2.getData().tree.root, u = s.children[0];
    if (u) {
      $ge(s), v0e(u, Gge, o), s.hierNode.modifier = -u.hierNode.prelim, sC(u, Wge);
      var l2 = u, c2 = u, f2 = u;
      sC(u, function(M) {
        var E = M.getLayout().x;
        E < l2.getLayout().x && (l2 = M), E > c2.getLayout().x && (c2 = M), M.depth > f2.depth && (f2 = M);
      });
      var h = l2 === c2 ? 1 : o(l2, c2) / 2, v9 = h - l2.getLayout().x, d2 = 0, m2 = 0, b2 = 0, _ = 0;
      if (n2 === "radial")
        d2 = a / (c2.getLayout().x + h + v9), m2 = i / (f2.depth - 1 || 1), sC(u, function(M) {
          b2 = (M.getLayout().x + v9) * d2, _ = (M.depth - 1) * m2;
          var E = AC(b2, _);
          M.setLayout({ x: E.x, y: E.y, rawX: b2, rawY: _ }, true);
        });
      else {
        var C = r2.getOrient();
        C === "RL" || C === "LR" ? (m2 = i / (c2.getLayout().x + h + v9), d2 = a / (f2.depth - 1 || 1), sC(u, function(M) {
          _ = (M.getLayout().x + v9) * m2, b2 = C === "LR" ? (M.depth - 1) * d2 : a - (M.depth - 1) * d2, M.setLayout({ x: b2, y: _ }, true);
        })) : (C === "TB" || C === "BT") && (d2 = a / (c2.getLayout().x + h + v9), m2 = i / (f2.depth - 1 || 1), sC(u, function(M) {
          b2 = (M.getLayout().x + v9) * d2, _ = C === "TB" ? (M.depth - 1) * m2 : i - (M.depth - 1) * m2, M.setLayout({ x: b2, y: _ }, true);
        }));
      }
    }
  }
  function g0e(r2) {
    r2.eachSeriesByType("tree", function(t2) {
      var e2 = t2.getData(), n2 = e2.tree;
      n2.eachNode(function(a) {
        var i = a.getModel(), o = i.getModel("itemStyle").getItemStyle(), s = e2.ensureUniqueItemVisual(a.dataIndex, "style");
        qt(s, o);
      });
    });
  }
  function y0e(r2) {
    r2.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(t2, e2) {
      e2.eachComponent({ mainType: "series", subType: "tree", query: t2 }, function(n2) {
        var a = t2.dataIndex, i = n2.getData().tree, o = i.getNodeByDataIndex(a);
        o.isExpand = !o.isExpand;
      });
    }), r2.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(t2, e2) {
      e2.eachComponent({ mainType: "series", subType: "tree", query: t2 }, function(n2) {
        var a = n2.coordinateSystem, i = KF(a, t2);
        n2.setCenter && n2.setCenter(i.center), n2.setZoom && n2.setZoom(i.zoom);
      });
    });
  }
  function m0e(r2) {
    r2.registerChartView(t0e), r2.registerSeriesModel(h0e), r2.registerLayout(d0e), r2.registerVisual(g0e), y0e(r2);
  }
  var AB = ["treemapZoomToNode", "treemapRender", "treemapMove"];
  function b0e(r2) {
    for (var t2 = 0; t2 < AB.length; t2++)
      r2.registerAction({ type: AB[t2], update: "updateView" }, lu);
    r2.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(e2, n2) {
      n2.eachComponent({ mainType: "series", subType: "treemap", query: e2 }, a);
      function a(i, o) {
        var s = ["treemapZoomToNode", "treemapRootToNode"], u = yE(e2, s, i);
        if (u) {
          var l2 = i.getViewRoot();
          l2 && (e2.direction = JF(l2, u.node) ? "rollUp" : "drillDown"), i.resetViewRoot(u.node);
        }
      }
    });
  }
  function aK(r2) {
    var t2 = r2.getData(), e2 = t2.tree, n2 = {};
    e2.eachNode(function(a) {
      for (var i = a; i && i.depth > 1; )
        i = i.parentNode;
      var o = d4(r2.ecModel, i.name || i.dataIndex + "", n2);
      a.setVisual("decal", o);
    });
  }
  var _0e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.preventUsingHoverLayer = true, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      var a = { name: e2.name, children: e2.data };
      iK(a);
      var i = e2.levels || [], o = this.designatedVisualItemStyle = {}, s = new To({ itemStyle: o }, this, n2);
      i = e2.levels = x0e(i, n2);
      var u = pr(i || [], function(f2) {
        return new To(f2, s, n2);
      }, this), l2 = XF.createTree(a, this, c2);
      function c2(f2) {
        f2.wrapMethod("getItemModel", function(h, v9) {
          var d2 = l2.getNodeByDataIndex(v9), m2 = d2 ? u[d2.depth] : null;
          return h.parentModel = m2 || s, h;
        });
      }
      return l2.data;
    }, t2.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      var i = this.getData(), o = this.getRawValue(e2), s = i.getName(e2);
      return Hu("nameValue", { name: s, value: o });
    }, t2.prototype.getDataParams = function(e2) {
      var n2 = r2.prototype.getDataParams.apply(this, arguments), a = this.getData().tree.getNodeByDataIndex(e2);
      return n2.treeAncestors = S3(a, this), n2.treePathInfo = n2.treeAncestors, n2;
    }, t2.prototype.setLayoutInfo = function(e2) {
      this.layoutInfo = this.layoutInfo || {}, qt(this.layoutInfo, e2);
    }, t2.prototype.mapIdToIndex = function(e2) {
      var n2 = this._idIndexMap;
      n2 || (n2 = this._idIndexMap = mn(), this._idIndexMapCount = 0);
      var a = n2.get(e2);
      return a == null && n2.set(e2, a = this._idIndexMapCount++), a;
    }, t2.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, t2.prototype.resetViewRoot = function(e2) {
      e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
      var n2 = this.getRawData().tree.root;
      (!e2 || e2 !== n2 && !n2.contains(e2)) && (this._viewRoot = n2);
    }, t2.prototype.enableAriaDecal = function() {
      aK(this);
    }, t2.type = "series.treemap", t2.layoutMode = "box", t2.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, t2;
  }(ns);
  function iK(r2) {
    var t2 = 0;
    ae(r2.children, function(n2) {
      iK(n2);
      var a = n2.value;
      vr(a) && (a = a[0]), t2 += a;
    });
    var e2 = r2.value;
    vr(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = t2), e2 < 0 && (e2 = 0), vr(r2.value) ? r2.value[0] = e2 : r2.value = e2;
  }
  function x0e(r2, t2) {
    var e2 = ao(t2.get("color")), n2 = ao(t2.get(["aria", "decal", "decals"]));
    if (!!e2) {
      r2 = r2 || [];
      var a, i;
      ae(r2, function(s) {
        var u = new To(s), l2 = u.get("color"), c2 = u.get("decal");
        (u.get(["itemStyle", "color"]) || l2 && l2 !== "none") && (a = true), (u.get(["itemStyle", "decal"]) || c2 && c2 !== "none") && (i = true);
      });
      var o = r2[0] || (r2[0] = {});
      return a || (o.color = e2.slice()), !i && n2 && (o.decal = n2.slice()), r2;
    }
  }
  var w0e = _0e, S0e = 8, TB = 8, Sk = 5, C0e = function() {
    function r2(t2) {
      this.group = new Fn(), t2.add(this.group);
    }
    return r2.prototype.render = function(t2, e2, n2, a) {
      var i = t2.getModel("breadcrumb"), o = this.group;
      if (o.removeAll(), !(!i.get("show") || !n2)) {
        var s = i.getModel("itemStyle"), u = s.getModel("textStyle"), l2 = { pos: { left: i.get("left"), right: i.get("right"), top: i.get("top"), bottom: i.get("bottom") }, box: { width: e2.getWidth(), height: e2.getHeight() }, emptyItemWidth: i.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
        this._prepare(n2, l2, u), this._renderContent(t2, l2, s, u, a), c3(o, l2.pos, l2.box);
      }
    }, r2.prototype._prepare = function(t2, e2, n2) {
      for (var a = t2; a; a = a.parentNode) {
        var i = Cu(a.getModel().get("name"), ""), o = n2.getTextRect(i), s = Math.max(o.width + S0e * 2, e2.emptyItemWidth);
        e2.totalWidth += s + TB, e2.renderList.push({ node: a, text: i, width: s });
      }
    }, r2.prototype._renderContent = function(t2, e2, n2, a, i) {
      for (var o = 0, s = e2.emptyItemWidth, u = t2.get(["breadcrumb", "height"]), l2 = Oue(e2.pos, e2.box), c2 = e2.totalWidth, f2 = e2.renderList, h = f2.length - 1; h >= 0; h--) {
        var v9 = f2[h], d2 = v9.node, m2 = v9.width, b2 = v9.text;
        c2 > l2.width && (c2 -= m2 - s, m2 = s, b2 = null);
        var _ = new gf({ shape: { points: E0e(o, 0, m2, u, h === f2.length - 1, h === 0) }, style: En(n2.getItemStyle(), { lineJoin: "bevel" }), textContent: new xi({ style: { text: b2, fill: a.getTextColor(), font: a.getFont() } }), textConfig: { position: "inside" }, z2: vw * 1e4, onclick: Gn(i, d2) });
        _.disableLabelAnimation = true, this.group.add(_), A0e(_, t2, d2), o += m2 + TB;
      }
    }, r2.prototype.remove = function() {
      this.group.removeAll();
    }, r2;
  }();
  function E0e(r2, t2, e2, n2, a, i) {
    var o = [[a ? r2 : r2 - Sk, t2], [r2 + e2, t2], [r2 + e2, t2 + n2], [a ? r2 : r2 - Sk, t2 + n2]];
    return !i && o.splice(2, 0, [r2 + e2 + Sk, t2 + n2 / 2]), !a && o.push([r2, t2 + n2 / 2]), o;
  }
  function A0e(r2, t2, e2) {
    zn(r2).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: t2.componentIndex, seriesIndex: t2.seriesIndex, seriesName: t2.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: e2 && e2.dataIndex, name: e2 && e2.name }, treePathInfo: e2 && S3(e2, t2) };
  }
  var T0e = C0e, M0e = function() {
    function r2() {
      this._storage = [], this._elExistsMap = {};
    }
    return r2.prototype.add = function(t2, e2, n2, a, i) {
      return this._elExistsMap[t2.id] ? false : (this._elExistsMap[t2.id] = true, this._storage.push({ el: t2, target: e2, duration: n2, delay: a, easing: i }), true);
    }, r2.prototype.finished = function(t2) {
      return this._finishedCallback = t2, this;
    }, r2.prototype.start = function() {
      for (var t2 = this, e2 = this._storage.length, n2 = function() {
        e2--, e2 <= 0 && (t2._storage.length = 0, t2._elExistsMap = {}, t2._finishedCallback && t2._finishedCallback());
      }, a = 0, i = this._storage.length; a < i; a++) {
        var o = this._storage[a];
        o.el.animateTo(o.target, { duration: o.duration, delay: o.delay, easing: o.easing, setToFinal: true, done: n2, aborted: n2 });
      }
      return this;
    }, r2;
  }();
  function P0e() {
    return new M0e();
  }
  var B4 = Fn, MB = ni, PB = 3, DB = "label", IB = "upperLabel", D0e = vw * 10, I0e = vw * 2, L0e = vw * 3, Pb = t1([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), LB = function(r2) {
    var t2 = Pb(r2);
    return t2.stroke = t2.fill = t2.lineWidth = null, t2;
  }, wP = fi(), O0e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._state = "ready", e2._storage = uC(), e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      var o = n2.findComponents({ mainType: "series", subType: "treemap", query: i });
      if (!(va(o, e2) < 0)) {
        this.seriesModel = e2, this.api = a, this.ecModel = n2;
        var s = ["treemapZoomToNode", "treemapRootToNode"], u = yE(i, s, e2), l2 = i && i.type, c2 = e2.layoutInfo, f2 = !this._oldTree, h = this._storage, v9 = l2 === "treemapRootToNode" && u && h ? { rootNodeGroup: h.nodeGroup[u.node.getRawIndex()], direction: i.direction } : null, d2 = this._giveContainerGroup(c2), m2 = e2.get("animation"), b2 = this._doRender(d2, e2, v9);
        m2 && !f2 && (!l2 || l2 === "treemapZoomToNode" || l2 === "treemapRootToNode") ? this._doAnimation(d2, b2, e2, v9) : b2.renderFinally(), this._resetController(a), this._renderBreadcrumb(e2, a, u);
      }
    }, t2.prototype._giveContainerGroup = function(e2) {
      var n2 = this._containerGroup;
      return n2 || (n2 = this._containerGroup = new B4(), this._initEvents(n2), this.group.add(n2)), n2.x = e2.x, n2.y = e2.y, n2;
    }, t2.prototype._doRender = function(e2, n2, a) {
      var i = n2.getData().tree, o = this._oldTree, s = uC(), u = uC(), l2 = this._storage, c2 = [];
      function f2(b2, _, C, M) {
        return k0e(n2, u, l2, a, s, c2, b2, _, C, M);
      }
      v9(i.root ? [i.root] : [], o && o.root ? [o.root] : [], e2, i === o || !o, 0);
      var h = d2(l2);
      return this._oldTree = i, this._storage = u, { lastsForAnimation: s, willDeleteEls: h, renderFinally: m2 };
      function v9(b2, _, C, M, E) {
        M ? (_ = b2, ae(b2, function($, U) {
          !$.isRemoved() && V(U, U);
        })) : new Dg(_, b2, z9, z9).add(V).update(V).remove(Gn(V, null)).execute();
        function z9($) {
          return $.getId();
        }
        function V($, U) {
          var H = $ != null ? b2[$] : null, q3 = U != null ? _[U] : null, ee = f2(H, q3, C, E);
          ee && v9(H && H.viewChildren || [], q3 && q3.viewChildren || [], ee, M, E + 1);
        }
      }
      function d2(b2) {
        var _ = uC();
        return b2 && ae(b2, function(C, M) {
          var E = _[M];
          ae(C, function(z9) {
            z9 && (E.push(z9), wP(z9).willDelete = true);
          });
        }), _;
      }
      function m2() {
        ae(h, function(b2) {
          ae(b2, function(_) {
            _.parent && _.parent.remove(_);
          });
        }), ae(c2, function(b2) {
          b2.invisible = true, b2.dirty();
        });
      }
    }, t2.prototype._doAnimation = function(e2, n2, a, i) {
      var o = a.get("animationDurationUpdate"), s = a.get("animationEasing"), u = (xn(o) ? 0 : o) || 0, l2 = (xn(s) ? null : s) || "cubicOut", c2 = P0e();
      ae(n2.willDeleteEls, function(f2, h) {
        ae(f2, function(v9, d2) {
          if (!v9.invisible) {
            var m2 = v9.parent, b2, _ = wP(m2);
            if (i && i.direction === "drillDown")
              b2 = m2 === i.rootNodeGroup ? { shape: { x: 0, y: 0, width: _.nodeWidth, height: _.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
            else {
              var C = 0, M = 0;
              _.willDelete || (C = _.nodeWidth / 2, M = _.nodeHeight / 2), b2 = h === "nodeGroup" ? { x: C, y: M, style: { opacity: 0 } } : { shape: { x: C, y: M, width: 0, height: 0 }, style: { opacity: 0 } };
            }
            b2 && c2.add(v9, b2, u, 0, l2);
          }
        });
      }), ae(this._storage, function(f2, h) {
        ae(f2, function(v9, d2) {
          var m2 = n2.lastsForAnimation[h][d2], b2 = {};
          !m2 || (v9 instanceof Fn ? m2.oldX != null && (b2.x = v9.x, b2.y = v9.y, v9.x = m2.oldX, v9.y = m2.oldY) : (m2.oldShape && (b2.shape = qt({}, v9.shape), v9.setShape(m2.oldShape)), m2.fadein ? (v9.setStyle("opacity", 0), b2.style = { opacity: 1 }) : v9.style.opacity !== 1 && (b2.style = { opacity: 1 })), c2.add(v9, b2, u, 0, l2));
        });
      }, this), this._state = "animating", c2.finished(en(function() {
        this._state = "ready", n2.renderFinally();
      }, this)).start();
    }, t2.prototype._resetController = function(e2) {
      var n2 = this._controller;
      n2 || (n2 = this._controller = new qE(e2.getZr()), n2.enable(this.seriesModel.get("roam")), n2.on("pan", en(this._onPan, this)), n2.on("zoom", en(this._onZoom, this)));
      var a = new da(0, 0, e2.getWidth(), e2.getHeight());
      n2.setPointerChecker(function(i, o, s) {
        return a.contain(o, s);
      });
    }, t2.prototype._clearController = function() {
      var e2 = this._controller;
      e2 && (e2.dispose(), e2 = null);
    }, t2.prototype._onPan = function(e2) {
      if (this._state !== "animating" && (Math.abs(e2.dx) > PB || Math.abs(e2.dy) > PB)) {
        var n2 = this.seriesModel.getData().tree.root;
        if (!n2)
          return;
        var a = n2.getLayout();
        if (!a)
          return;
        this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: a.x + e2.dx, y: a.y + e2.dy, width: a.width, height: a.height } });
      }
    }, t2.prototype._onZoom = function(e2) {
      var n2 = e2.originX, a = e2.originY;
      if (this._state !== "animating") {
        var i = this.seriesModel.getData().tree.root;
        if (!i)
          return;
        var o = i.getLayout();
        if (!o)
          return;
        var s = new da(o.x, o.y, o.width, o.height), u = this.seriesModel.layoutInfo;
        n2 -= u.x, a -= u.y;
        var l2 = Hh();
        ep(l2, l2, [-n2, -a]), W6(l2, l2, [e2.scale, e2.scale]), ep(l2, l2, [n2, a]), s.applyTransform(l2), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: s.x, y: s.y, width: s.width, height: s.height } });
      }
    }, t2.prototype._initEvents = function(e2) {
      var n2 = this;
      e2.on("click", function(a) {
        if (n2._state === "ready") {
          var i = n2.seriesModel.get("nodeClick", true);
          if (!!i) {
            var o = n2.findTarget(a.offsetX, a.offsetY);
            if (!!o) {
              var s = o.node;
              if (s.getLayout().isLeafRoot)
                n2._rootToNode(o);
              else if (i === "zoomToNode")
                n2._zoomToNode(o);
              else if (i === "link") {
                var u = s.hostTree.data.getItemModel(s.dataIndex), l2 = u.get("link", true), c2 = u.get("target", true) || "blank";
                l2 && iP(l2, c2);
              }
            }
          }
        }
      }, this);
    }, t2.prototype._renderBreadcrumb = function(e2, n2, a) {
      var i = this;
      a || (a = e2.get("leafDepth", true) != null ? { node: e2.getViewRoot() } : this.findTarget(n2.getWidth() / 2, n2.getHeight() / 2), a || (a = { node: e2.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new T0e(this.group))).render(e2, n2, a.node, function(o) {
        i._state !== "animating" && (JF(e2.getViewRoot(), o) ? i._rootToNode({ node: o }) : i._zoomToNode({ node: o }));
      });
    }, t2.prototype.remove = function() {
      this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = uC(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
    }, t2.prototype.dispose = function() {
      this._clearController();
    }, t2.prototype._zoomToNode = function(e2) {
      this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
    }, t2.prototype._rootToNode = function(e2) {
      this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
    }, t2.prototype.findTarget = function(e2, n2) {
      var a, i = this.seriesModel.getViewRoot();
      return i.eachNode({ attr: "viewChildren", order: "preorder" }, function(o) {
        var s = this._storage.background[o.getRawIndex()];
        if (s) {
          var u = s.transformCoordToLocal(e2, n2), l2 = s.shape;
          if (l2.x <= u[0] && u[0] <= l2.x + l2.width && l2.y <= u[1] && u[1] <= l2.y + l2.height)
            a = { node: o, offsetX: u[0], offsetY: u[1] };
          else
            return false;
        }
      }, this), a;
    }, t2.type = "treemap", t2;
  }(Mo);
  function uC() {
    return { nodeGroup: [], background: [], content: [] };
  }
  function k0e(r2, t2, e2, n2, a, i, o, s, u, l2) {
    if (!o)
      return;
    var c2 = o.getLayout(), f2 = r2.getData(), h = o.getModel();
    if (f2.setItemGraphicEl(o.dataIndex, null), !c2 || !c2.isInView)
      return;
    var v9 = c2.width, d2 = c2.height, m2 = c2.borderWidth, b2 = c2.invisible, _ = o.getRawIndex(), C = s && s.getRawIndex(), M = o.viewChildren, E = c2.upperHeight, z9 = M && M.length, V = h.getModel("itemStyle"), $ = h.getModel(["emphasis", "itemStyle"]), U = h.getModel(["blur", "itemStyle"]), H = h.getModel(["select", "itemStyle"]), q3 = V.get("borderRadius") || 0, ee = Hr("nodeGroup", B4);
    if (!ee)
      return;
    if (u.add(ee), ee.x = c2.x || 0, ee.y = c2.y || 0, ee.markRedraw(), wP(ee).nodeWidth = v9, wP(ee).nodeHeight = d2, c2.isAboveViewRoot)
      return ee;
    var oe = Hr("background", MB, l2, I0e);
    oe && Fe(ee, oe, z9 && c2.upperLabelHeight);
    var ne = h.getModel("emphasis"), be = ne.get("focus"), Ee = ne.get("blurScope"), ye = ne.get("disabled"), et = be === "ancestor" ? o.getAncestorsIndices() : be === "descendant" ? o.getDescendantIndices() : be;
    if (z9)
      nE(ee) && Bb(ee, false), oe && (Bb(oe, !ye), f2.setItemGraphicEl(o.dataIndex, oe), o4(oe, et, Ee));
    else {
      var Le = Hr("content", MB, l2, L0e);
      Le && qe(ee, Le), oe.disableMorphing = true, oe && nE(oe) && Bb(oe, false), Bb(ee, !ye), f2.setItemGraphicEl(o.dataIndex, ee), o4(ee, et, Ee);
    }
    return ee;
    function Fe(nn, Wr, on) {
      var un = zn(Wr);
      if (un.dataIndex = o.dataIndex, un.seriesIndex = r2.seriesIndex, Wr.setShape({ x: 0, y: 0, width: v9, height: d2, r: q3 }), b2)
        st(Wr);
      else {
        Wr.invisible = false;
        var Xr = o.getVisual("style"), _n = Xr.stroke, Za = LB(V);
        Za.fill = _n;
        var Dn = Pb($);
        Dn.fill = $.get("borderColor");
        var ai = Pb(U);
        ai.fill = U.get("borderColor");
        var wi = Pb(H);
        if (wi.fill = H.get("borderColor"), on) {
          var hi = v9 - 2 * m2;
          dt(Wr, _n, Xr.opacity, { x: m2, y: 0, width: hi, height: E });
        } else
          Wr.removeTextContent();
        Wr.setStyle(Za), Wr.ensureState("emphasis").style = Dn, Wr.ensureState("blur").style = ai, Wr.ensureState("select").style = wi, r1(Wr);
      }
      nn.add(Wr);
    }
    function qe(nn, Wr) {
      var on = zn(Wr);
      on.dataIndex = o.dataIndex, on.seriesIndex = r2.seriesIndex;
      var un = Math.max(v9 - 2 * m2, 0), Xr = Math.max(d2 - 2 * m2, 0);
      if (Wr.culling = true, Wr.setShape({ x: m2, y: m2, width: un, height: Xr, r: q3 }), b2)
        st(Wr);
      else {
        Wr.invisible = false;
        var _n = o.getVisual("style"), Za = _n.fill, Dn = LB(V);
        Dn.fill = Za, Dn.decal = _n.decal;
        var ai = Pb($), wi = Pb(U), hi = Pb(H);
        dt(Wr, Za, _n.opacity, null), Wr.setStyle(Dn), Wr.ensureState("emphasis").style = ai, Wr.ensureState("blur").style = wi, Wr.ensureState("select").style = hi, r1(Wr);
      }
      nn.add(Wr);
    }
    function st(nn) {
      !nn.invisible && i.push(nn);
    }
    function dt(nn, Wr, on, un) {
      var Xr = h.getModel(un ? IB : DB), _n = Cu(h.get("name"), null), Za = Xr.getShallow("show");
      fc(nn, _l(h, un ? IB : DB), { defaultText: Za ? _n : null, inheritColor: Wr, defaultOpacity: on, labelFetcher: r2, labelDataIndex: o.dataIndex });
      var Dn = nn.getTextContent();
      if (!!Dn) {
        var ai = Dn.style, wi = j6(ai.padding || 0);
        un && (nn.setTextConfig({ layoutRect: un }), Dn.disableLabelLayout = true), Dn.beforeUpdate = function() {
          var qs = Math.max((un ? un.width : nn.shape.width) - wi[1] - wi[3], 0), jo = Math.max((un ? un.height : nn.shape.height) - wi[0] - wi[2], 0);
          (ai.width !== qs || ai.height !== jo) && Dn.setStyle({ width: qs, height: jo });
        }, ai.truncateMinChar = 2, ai.lineOverflow = "truncate", Ar(ai, un, c2);
        var hi = Dn.getState("emphasis");
        Ar(hi ? hi.style : null, un, c2);
      }
    }
    function Ar(nn, Wr, on) {
      var un = nn ? nn.text : null;
      if (!Wr && on.isLeafRoot && un != null) {
        var Xr = r2.get("drillDownIcon", true);
        nn.text = Xr ? Xr + " " + un : un;
      }
    }
    function Hr(nn, Wr, on, un) {
      var Xr = C != null && e2[nn][C], _n = a[nn];
      return Xr ? (e2[nn][C] = null, hn(_n, Xr)) : b2 || (Xr = new Wr(), Xr instanceof qh && (Xr.z2 = R0e(on, un)), cn(_n, Xr)), t2[nn][_] = Xr;
    }
    function hn(nn, Wr) {
      var on = nn[_] = {};
      Wr instanceof B4 ? (on.oldX = Wr.x, on.oldY = Wr.y) : on.oldShape = qt({}, Wr.shape);
    }
    function cn(nn, Wr) {
      var on = nn[_] = {}, un = o.parentNode, Xr = Wr instanceof Fn;
      if (un && (!n2 || n2.direction === "drillDown")) {
        var _n = 0, Za = 0, Dn = a.background[un.getRawIndex()];
        !n2 && Dn && Dn.oldShape && (_n = Dn.oldShape.width, Za = Dn.oldShape.height), Xr ? (on.oldX = 0, on.oldY = Za) : on.oldShape = { x: _n, y: Za, width: 0, height: 0 };
      }
      on.fadein = !Xr;
    }
  }
  function R0e(r2, t2) {
    return r2 * D0e + t2;
  }
  var F0e = O0e, mE = ae, N0e = Tn, SP = -1, QF = function() {
    function r2(t2) {
      var e2 = t2.mappingMethod, n2 = t2.type, a = this.option = On(t2);
      this.type = n2, this.mappingMethod = e2, this._normalizeData = B0e[e2];
      var i = r2.visualHandlers[n2];
      this.applyVisual = i.applyVisual, this.getColorMapper = i.getColorMapper, this._normalizedToVisual = i._normalizedToVisual[e2], e2 === "piecewise" ? (Ck(a), V0e(a)) : e2 === "category" ? a.categories ? j0e(a) : Ck(a, true) : (Fc(e2 !== "linear" || a.dataExtent), Ck(a));
    }
    return r2.prototype.mapValueToVisual = function(t2) {
      var e2 = this._normalizeData(t2);
      return this._normalizedToVisual(e2, t2);
    }, r2.prototype.getNormalizer = function() {
      return en(this._normalizeData, this);
    }, r2.listVisualTypes = function() {
      return ja(r2.visualHandlers);
    }, r2.isValidType = function(t2) {
      return r2.visualHandlers.hasOwnProperty(t2);
    }, r2.eachVisual = function(t2, e2, n2) {
      Tn(t2) ? ae(t2, e2, n2) : e2.call(n2, t2);
    }, r2.mapVisual = function(t2, e2, n2) {
      var a, i = vr(t2) ? [] : Tn(t2) ? {} : (a = true, null);
      return r2.eachVisual(t2, function(o, s) {
        var u = e2.call(n2, o, s);
        a ? i = u : i[s] = u;
      }), i;
    }, r2.retrieveVisuals = function(t2) {
      var e2 = {}, n2;
      return t2 && mE(r2.visualHandlers, function(a, i) {
        t2.hasOwnProperty(i) && (e2[i] = t2[i], n2 = true);
      }), n2 ? e2 : null;
    }, r2.prepareVisualTypes = function(t2) {
      if (vr(t2))
        t2 = t2.slice();
      else if (N0e(t2)) {
        var e2 = [];
        mE(t2, function(n2, a) {
          e2.push(a);
        }), t2 = e2;
      } else
        return [];
      return t2.sort(function(n2, a) {
        return a === "color" && n2 !== "color" && n2.indexOf("color") === 0 ? 1 : -1;
      }), t2;
    }, r2.dependsOn = function(t2, e2) {
      return e2 === "color" ? !!(t2 && t2.indexOf(e2) === 0) : t2 === e2;
    }, r2.findPieceIndex = function(t2, e2, n2) {
      for (var a, i = 1 / 0, o = 0, s = e2.length; o < s; o++) {
        var u = e2[o].value;
        if (u != null) {
          if (u === t2 || Zr(u) && u === t2 + "")
            return o;
          n2 && h(u, o);
        }
      }
      for (var o = 0, s = e2.length; o < s; o++) {
        var l2 = e2[o], c2 = l2.interval, f2 = l2.close;
        if (c2) {
          if (c2[0] === -1 / 0) {
            if (t5(f2[1], t2, c2[1]))
              return o;
          } else if (c2[1] === 1 / 0) {
            if (t5(f2[0], c2[0], t2))
              return o;
          } else if (t5(f2[0], c2[0], t2) && t5(f2[1], t2, c2[1]))
            return o;
          n2 && h(c2[0], o), n2 && h(c2[1], o);
        }
      }
      if (n2)
        return t2 === 1 / 0 ? e2.length - 1 : t2 === -1 / 0 ? 0 : a;
      function h(v9, d2) {
        var m2 = Math.abs(v9 - t2);
        m2 < i && (i = m2, a = d2);
      }
    }, r2.visualHandlers = { color: { applyVisual: lC("color"), getColorMapper: function() {
      var t2 = this.option;
      return en(t2.mappingMethod === "category" ? function(e2, n2) {
        return !n2 && (e2 = this._normalizeData(e2)), TC.call(this, e2);
      } : function(e2, n2, a) {
        var i = !!a;
        return !n2 && (e2 = this._normalizeData(e2)), a = iO(e2, t2.parsedVisual, a), i ? a : wg(a, "rgba");
      }, this);
    }, _normalizedToVisual: { linear: function(t2) {
      return wg(iO(t2, this.option.parsedVisual), "rgba");
    }, category: TC, piecewise: function(t2, e2) {
      var n2 = $4.call(this, e2);
      return n2 == null && (n2 = wg(iO(t2, this.option.parsedVisual), "rgba")), n2;
    }, fixed: Db } }, colorHue: e5(function(t2, e2) {
      return LC(t2, e2);
    }), colorSaturation: e5(function(t2, e2) {
      return LC(t2, null, e2);
    }), colorLightness: e5(function(t2, e2) {
      return LC(t2, null, null, e2);
    }), colorAlpha: e5(function(t2, e2) {
      return H5(t2, e2);
    }), decal: { applyVisual: lC("decal"), _normalizedToVisual: { linear: null, category: TC, piecewise: null, fixed: null } }, opacity: { applyVisual: lC("opacity"), _normalizedToVisual: z4([0, 1]) }, liftZ: { applyVisual: lC("liftZ"), _normalizedToVisual: { linear: Db, category: Db, piecewise: Db, fixed: Db } }, symbol: { applyVisual: function(t2, e2, n2) {
      var a = this.mapValueToVisual(t2);
      n2("symbol", a);
    }, _normalizedToVisual: { linear: OB, category: TC, piecewise: function(t2, e2) {
      var n2 = $4.call(this, e2);
      return n2 == null && (n2 = OB.call(this, t2)), n2;
    }, fixed: Db } }, symbolSize: { applyVisual: lC("symbolSize"), _normalizedToVisual: z4([0, 1]) } }, r2;
  }();
  function V0e(r2) {
    var t2 = r2.pieceList;
    r2.hasSpecialVisual = false, ae(t2, function(e2, n2) {
      e2.originIndex = n2, e2.visual != null && (r2.hasSpecialVisual = true);
    });
  }
  function j0e(r2) {
    var t2 = r2.categories, e2 = r2.categoryMap = {}, n2 = r2.visual;
    if (mE(t2, function(o, s) {
      e2[o] = s;
    }), !vr(n2)) {
      var a = [];
      Tn(n2) ? mE(n2, function(o, s) {
        var u = e2[s];
        a[u != null ? u : SP] = o;
      }) : a[SP] = n2, n2 = oK(r2, a);
    }
    for (var i = t2.length - 1; i >= 0; i--)
      n2[i] == null && (delete e2[t2[i]], t2.pop());
  }
  function Ck(r2, t2) {
    var e2 = r2.visual, n2 = [];
    Tn(e2) ? mE(e2, function(i) {
      n2.push(i);
    }) : e2 != null && n2.push(e2);
    var a = { color: 1, symbol: 1 };
    !t2 && n2.length === 1 && !a.hasOwnProperty(r2.type) && (n2[1] = n2[0]), oK(r2, n2);
  }
  function e5(r2) {
    return { applyVisual: function(t2, e2, n2) {
      var a = this.mapValueToVisual(t2);
      n2("color", r2(e2("color"), a));
    }, _normalizedToVisual: z4([0, 1]) };
  }
  function OB(r2) {
    var t2 = this.option.visual;
    return t2[Math.round(Gi(r2, [0, 1], [0, t2.length - 1], true))] || {};
  }
  function lC(r2) {
    return function(t2, e2, n2) {
      n2(r2, this.mapValueToVisual(t2));
    };
  }
  function TC(r2) {
    var t2 = this.option.visual;
    return t2[this.option.loop && r2 !== SP ? r2 % t2.length : r2];
  }
  function Db() {
    return this.option.visual[0];
  }
  function z4(r2) {
    return { linear: function(t2) {
      return Gi(t2, r2, this.option.visual, true);
    }, category: TC, piecewise: function(t2, e2) {
      var n2 = $4.call(this, e2);
      return n2 == null && (n2 = Gi(t2, r2, this.option.visual, true)), n2;
    }, fixed: Db };
  }
  function $4(r2) {
    var t2 = this.option, e2 = t2.pieceList;
    if (t2.hasSpecialVisual) {
      var n2 = QF.findPieceIndex(r2, e2), a = e2[n2];
      if (a && a.visual)
        return a.visual[this.type];
    }
  }
  function oK(r2, t2) {
    return r2.visual = t2, r2.type === "color" && (r2.parsedVisual = pr(t2, function(e2) {
      return Xf(e2);
    })), t2;
  }
  var B0e = { linear: function(r2) {
    return Gi(r2, this.option.dataExtent, [0, 1], true);
  }, piecewise: function(r2) {
    var t2 = this.option.pieceList, e2 = QF.findPieceIndex(r2, t2, true);
    if (e2 != null)
      return Gi(e2, [0, t2.length - 1], [0, 1], true);
  }, category: function(r2) {
    var t2 = this.option.categories ? this.option.categoryMap[r2] : r2;
    return t2 == null ? SP : t2;
  }, fixed: lu };
  function t5(r2, t2, e2) {
    return r2 ? t2 <= e2 : t2 < e2;
  }
  var Vl = QF, z0e = "itemStyle", sK = fi(), $0e = { seriesType: "treemap", reset: function(r2) {
    var t2 = r2.getData().tree, e2 = t2.root;
    e2.isRemoved() || uK(e2, {}, r2.getViewRoot().getAncestors(), r2);
  } };
  function uK(r2, t2, e2, n2) {
    var a = r2.getModel(), i = r2.getLayout(), o = r2.hostTree.data;
    if (!(!i || i.invisible || !i.isInView)) {
      var s = a.getModel(z0e), u = G0e(s, t2, n2), l2 = o.ensureUniqueItemVisual(r2.dataIndex, "style"), c2 = s.get("borderColor"), f2 = s.get("borderColorSaturation"), h;
      f2 != null && (h = kB(u), c2 = W0e(f2, h)), l2.stroke = c2;
      var v9 = r2.viewChildren;
      if (!v9 || !v9.length)
        h = kB(u), l2.fill = h;
      else {
        var d2 = U0e(r2, a, i, s, u, v9);
        ae(v9, function(m2, b2) {
          if (m2.depth >= e2.length || m2 === e2[m2.depth]) {
            var _ = H0e(a, u, m2, b2, d2, n2);
            uK(m2, _, e2, n2);
          }
        });
      }
    }
  }
  function G0e(r2, t2, e2) {
    var n2 = qt({}, t2), a = e2.designatedVisualItemStyle;
    return ae(["color", "colorAlpha", "colorSaturation"], function(i) {
      a[i] = t2[i];
      var o = r2.get(i);
      a[i] = null, o != null && (n2[i] = o);
    }), n2;
  }
  function kB(r2) {
    var t2 = Ek(r2, "color");
    if (t2) {
      var e2 = Ek(r2, "colorAlpha"), n2 = Ek(r2, "colorSaturation");
      return n2 && (t2 = LC(t2, null, null, n2)), e2 && (t2 = H5(t2, e2)), t2;
    }
  }
  function W0e(r2, t2) {
    return t2 != null ? LC(t2, null, null, r2) : null;
  }
  function Ek(r2, t2) {
    var e2 = r2[t2];
    if (e2 != null && e2 !== "none")
      return e2;
  }
  function U0e(r2, t2, e2, n2, a, i) {
    if (!(!i || !i.length)) {
      var o = Ak(t2, "color") || a.color != null && a.color !== "none" && (Ak(t2, "colorAlpha") || Ak(t2, "colorSaturation"));
      if (!!o) {
        var s = t2.get("visualMin"), u = t2.get("visualMax"), l2 = e2.dataExtent.slice();
        s != null && s < l2[0] && (l2[0] = s), u != null && u > l2[1] && (l2[1] = u);
        var c2 = t2.get("colorMappingBy"), f2 = { type: o.name, dataExtent: l2, visual: o.range };
        f2.type === "color" && (c2 === "index" || c2 === "id") ? (f2.mappingMethod = "category", f2.loop = true) : f2.mappingMethod = "linear";
        var h = new Vl(f2);
        return sK(h).drColorMappingBy = c2, h;
      }
    }
  }
  function Ak(r2, t2) {
    var e2 = r2.get(t2);
    return vr(e2) && e2.length ? { name: t2, range: e2 } : null;
  }
  function H0e(r2, t2, e2, n2, a, i) {
    var o = qt({}, t2);
    if (a) {
      var s = a.type, u = s === "color" && sK(a).drColorMappingBy, l2 = u === "index" ? n2 : u === "id" ? i.mapIdToIndex(e2.getId()) : e2.getValue(r2.get("visualDimension"));
      o[s] = a.mapValueToVisual(l2);
    }
    return o;
  }
  var bE = Math.max, CP = Math.min, RB = ml, eN = ae, lK = ["itemStyle", "borderWidth"], q0e = ["itemStyle", "gapWidth"], Y0e = ["upperLabel", "show"], K0e = ["upperLabel", "height"], Z0e = { seriesType: "treemap", reset: function(r2, t2, e2, n2) {
    var a = e2.getWidth(), i = e2.getHeight(), o = r2.option, s = Eu(r2.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), u = o.size || [], l2 = qr(RB(s.width, u[0]), a), c2 = qr(RB(s.height, u[1]), i), f2 = n2 && n2.type, h = ["treemapZoomToNode", "treemapRootToNode"], v9 = yE(n2, h, r2), d2 = f2 === "treemapRender" || f2 === "treemapMove" ? n2.rootRect : null, m2 = r2.getViewRoot(), b2 = nK(m2);
    if (f2 !== "treemapMove") {
      var _ = f2 === "treemapZoomToNode" ? rye(r2, v9, m2, l2, c2) : d2 ? [d2.width, d2.height] : [l2, c2], C = o.sort;
      C && C !== "asc" && C !== "desc" && (C = "desc");
      var M = { squareRatio: o.squareRatio, sort: C, leafDepth: o.leafDepth };
      m2.hostTree.clearLayouts();
      var E = { x: 0, y: 0, width: _[0], height: _[1], area: _[0] * _[1] };
      m2.setLayout(E), cK(m2, M, false, 0), E = m2.getLayout(), eN(b2, function(V, $) {
        var U = (b2[$ + 1] || m2).getValue();
        V.setLayout(qt({ dataExtent: [U, U], borderWidth: 0, upperHeight: 0 }, E));
      });
    }
    var z9 = r2.getData().tree.root;
    z9.setLayout(nye(s, d2, v9), true), r2.setLayoutInfo(s), fK(z9, new da(-s.x, -s.y, a, i), b2, m2, 0);
  } };
  function cK(r2, t2, e2, n2) {
    var a, i;
    if (!r2.isRemoved()) {
      var o = r2.getLayout();
      a = o.width, i = o.height;
      var s = r2.getModel(), u = s.get(lK), l2 = s.get(q0e) / 2, c2 = hK(s), f2 = Math.max(u, c2), h = u - l2, v9 = f2 - l2;
      r2.setLayout({ borderWidth: u, upperHeight: f2, upperLabelHeight: c2 }, true), a = bE(a - 2 * h, 0), i = bE(i - h - v9, 0);
      var d2 = a * i, m2 = X0e(r2, s, d2, t2, e2, n2);
      if (!!m2.length) {
        var b2 = { x: h, y: v9, width: a, height: i }, _ = CP(a, i), C = 1 / 0, M = [];
        M.area = 0;
        for (var E = 0, z9 = m2.length; E < z9; ) {
          var V = m2[E];
          M.push(V), M.area += V.getLayout().area;
          var $ = tye(M, _, t2.squareRatio);
          $ <= C ? (E++, C = $) : (M.area -= M.pop().getLayout().area, FB(M, _, b2, l2, false), _ = CP(b2.width, b2.height), M.length = M.area = 0, C = 1 / 0);
        }
        if (M.length && FB(M, _, b2, l2, true), !e2) {
          var U = s.get("childrenVisibleMin");
          U != null && d2 < U && (e2 = true);
        }
        for (var E = 0, z9 = m2.length; E < z9; E++)
          cK(m2[E], t2, e2, n2 + 1);
      }
    }
  }
  function X0e(r2, t2, e2, n2, a, i) {
    var o = r2.children || [], s = n2.sort;
    s !== "asc" && s !== "desc" && (s = null);
    var u = n2.leafDepth != null && n2.leafDepth <= i;
    if (a && !u)
      return r2.viewChildren = [];
    o = no(o, function(v9) {
      return !v9.isRemoved();
    }), Q0e(o, s);
    var l2 = eye(t2, o, s);
    if (l2.sum === 0)
      return r2.viewChildren = [];
    if (l2.sum = J0e(t2, e2, l2.sum, s, o), l2.sum === 0)
      return r2.viewChildren = [];
    for (var c2 = 0, f2 = o.length; c2 < f2; c2++) {
      var h = o[c2].getValue() / l2.sum * e2;
      o[c2].setLayout({ area: h });
    }
    return u && (o.length && r2.setLayout({ isLeafRoot: true }, true), o.length = 0), r2.viewChildren = o, r2.setLayout({ dataExtent: l2.dataExtent }, true), o;
  }
  function J0e(r2, t2, e2, n2, a) {
    if (!n2)
      return e2;
    for (var i = r2.get("visibleMin"), o = a.length, s = o, u = o - 1; u >= 0; u--) {
      var l2 = a[n2 === "asc" ? o - u - 1 : u].getValue();
      l2 / e2 * t2 < i && (s = u, e2 -= l2);
    }
    return n2 === "asc" ? a.splice(0, o - s) : a.splice(s, o - s), e2;
  }
  function Q0e(r2, t2) {
    return t2 && r2.sort(function(e2, n2) {
      var a = t2 === "asc" ? e2.getValue() - n2.getValue() : n2.getValue() - e2.getValue();
      return a === 0 ? t2 === "asc" ? e2.dataIndex - n2.dataIndex : n2.dataIndex - e2.dataIndex : a;
    }), r2;
  }
  function eye(r2, t2, e2) {
    for (var n2 = 0, a = 0, i = t2.length; a < i; a++)
      n2 += t2[a].getValue();
    var o = r2.get("visualDimension"), s;
    return !t2 || !t2.length ? s = [NaN, NaN] : o === "value" && e2 ? (s = [t2[t2.length - 1].getValue(), t2[0].getValue()], e2 === "asc" && s.reverse()) : (s = [1 / 0, -1 / 0], eN(t2, function(u) {
      var l2 = u.getValue(o);
      l2 < s[0] && (s[0] = l2), l2 > s[1] && (s[1] = l2);
    })), { sum: n2, dataExtent: s };
  }
  function tye(r2, t2, e2) {
    for (var n2 = 0, a = 1 / 0, i = 0, o = void 0, s = r2.length; i < s; i++)
      o = r2[i].getLayout().area, o && (o < a && (a = o), o > n2 && (n2 = o));
    var u = r2.area * r2.area, l2 = t2 * t2 * e2;
    return u ? bE(l2 * n2 / u, u / (l2 * a)) : 1 / 0;
  }
  function FB(r2, t2, e2, n2, a) {
    var i = t2 === e2.width ? 0 : 1, o = 1 - i, s = ["x", "y"], u = ["width", "height"], l2 = e2[s[i]], c2 = t2 ? r2.area / t2 : 0;
    (a || c2 > e2[u[o]]) && (c2 = e2[u[o]]);
    for (var f2 = 0, h = r2.length; f2 < h; f2++) {
      var v9 = r2[f2], d2 = {}, m2 = c2 ? v9.getLayout().area / c2 : 0, b2 = d2[u[o]] = bE(c2 - 2 * n2, 0), _ = e2[s[i]] + e2[u[i]] - l2, C = f2 === h - 1 || _ < m2 ? _ : m2, M = d2[u[i]] = bE(C - 2 * n2, 0);
      d2[s[o]] = e2[s[o]] + CP(n2, b2 / 2), d2[s[i]] = l2 + CP(n2, M / 2), l2 += C, v9.setLayout(d2, true);
    }
    e2[s[o]] += c2, e2[u[o]] -= c2;
  }
  function rye(r2, t2, e2, n2, a) {
    var i = (t2 || {}).node, o = [n2, a];
    if (!i || i === e2)
      return o;
    for (var s, u = n2 * a, l2 = u * r2.option.zoomToNodeRatio; s = i.parentNode; ) {
      for (var c2 = 0, f2 = s.children, h = 0, v9 = f2.length; h < v9; h++)
        c2 += f2[h].getValue();
      var d2 = i.getValue();
      if (d2 === 0)
        return o;
      l2 *= c2 / d2;
      var m2 = s.getModel(), b2 = m2.get(lK), _ = Math.max(b2, hK(m2));
      l2 += 4 * b2 * b2 + (3 * b2 + _) * Math.pow(l2, 0.5), l2 > q8 && (l2 = q8), i = s;
    }
    l2 < u && (l2 = u);
    var C = Math.pow(l2 / u, 0.5);
    return [n2 * C, a * C];
  }
  function nye(r2, t2, e2) {
    if (t2)
      return { x: t2.x, y: t2.y };
    var n2 = { x: 0, y: 0 };
    if (!e2)
      return n2;
    var a = e2.node, i = a.getLayout();
    if (!i)
      return n2;
    for (var o = [i.width / 2, i.height / 2], s = a; s; ) {
      var u = s.getLayout();
      o[0] += u.x, o[1] += u.y, s = s.parentNode;
    }
    return { x: r2.width / 2 - o[0], y: r2.height / 2 - o[1] };
  }
  function fK(r2, t2, e2, n2, a) {
    var i = r2.getLayout(), o = e2[a], s = o && o === r2;
    if (!(o && !s || a === e2.length && r2 !== n2)) {
      r2.setLayout({ isInView: true, invisible: !s && !t2.intersect(i), isAboveViewRoot: s }, true);
      var u = new da(t2.x - i.x, t2.y - i.y, t2.width, t2.height);
      eN(r2.viewChildren || [], function(l2) {
        fK(l2, u, e2, n2, a + 1);
      });
    }
  }
  function hK(r2) {
    return r2.get(Y0e) ? r2.get(K0e) : 0;
  }
  function aye(r2) {
    r2.registerSeriesModel(w0e), r2.registerChartView(F0e), r2.registerVisual($0e), r2.registerLayout(Z0e), b0e(r2);
  }
  function iye(r2) {
    var t2 = r2.findComponents({ mainType: "legend" });
    !t2 || !t2.length || r2.eachSeriesByType("graph", function(e2) {
      var n2 = e2.getCategoriesData(), a = e2.getGraph(), i = a.data, o = n2.mapArray(n2.getName);
      i.filterSelf(function(s) {
        var u = i.getItemModel(s), l2 = u.getShallow("category");
        if (l2 != null) {
          Ai(l2) && (l2 = o[l2]);
          for (var c2 = 0; c2 < t2.length; c2++)
            if (!t2[c2].isSelected(l2))
              return false;
        }
        return true;
      });
    });
  }
  function oye(r2) {
    var t2 = {};
    r2.eachSeriesByType("graph", function(e2) {
      var n2 = e2.getCategoriesData(), a = e2.getData(), i = {};
      n2.each(function(o) {
        var s = n2.getName(o);
        i["ec-" + s] = o;
        var u = n2.getItemModel(o), l2 = u.getModel("itemStyle").getItemStyle();
        l2.fill || (l2.fill = e2.getColorFromPalette(s, t2)), n2.setItemVisual(o, "style", l2);
        for (var c2 = ["symbol", "symbolSize", "symbolKeepAspect"], f2 = 0; f2 < c2.length; f2++) {
          var h = u.getShallow(c2[f2], true);
          h != null && n2.setItemVisual(o, c2[f2], h);
        }
      }), n2.count() && a.each(function(o) {
        var s = a.getItemModel(o), u = s.getShallow("category");
        if (u != null) {
          Zr(u) && (u = i["ec-" + u]);
          var l2 = n2.getItemVisual(u, "style"), c2 = a.ensureUniqueItemVisual(o, "style");
          qt(c2, l2);
          for (var f2 = ["symbol", "symbolSize", "symbolKeepAspect"], h = 0; h < f2.length; h++)
            a.setItemVisual(o, f2[h], n2.getItemVisual(u, f2[h]));
        }
      });
    });
  }
  function r5(r2) {
    return r2 instanceof Array || (r2 = [r2, r2]), r2;
  }
  function sye(r2) {
    r2.eachSeriesByType("graph", function(t2) {
      var e2 = t2.getGraph(), n2 = t2.getEdgeData(), a = r5(t2.get("edgeSymbol")), i = r5(t2.get("edgeSymbolSize"));
      n2.setVisual("fromSymbol", a && a[0]), n2.setVisual("toSymbol", a && a[1]), n2.setVisual("fromSymbolSize", i && i[0]), n2.setVisual("toSymbolSize", i && i[1]), n2.setVisual("style", t2.getModel("lineStyle").getLineStyle()), n2.each(function(o) {
        var s = n2.getItemModel(o), u = e2.getEdgeByIndex(o), l2 = r5(s.getShallow("symbol", true)), c2 = r5(s.getShallow("symbolSize", true)), f2 = s.getModel("lineStyle").getLineStyle(), h = n2.ensureUniqueItemVisual(o, "style");
        switch (qt(h, f2), h.stroke) {
          case "source": {
            var v9 = u.node1.getVisual("style");
            h.stroke = v9 && v9.fill;
            break;
          }
          case "target": {
            var v9 = u.node2.getVisual("style");
            h.stroke = v9 && v9.fill;
            break;
          }
        }
        l2[0] && u.setVisual("fromSymbol", l2[0]), l2[1] && u.setVisual("toSymbol", l2[1]), c2[0] && u.setVisual("fromSymbolSize", c2[0]), c2[1] && u.setVisual("toSymbolSize", c2[1]);
      });
    });
  }
  var G4 = "-->", C3 = function(r2) {
    return r2.get("autoCurveness") || null;
  }, vK = function(r2, t2) {
    var e2 = C3(r2), n2 = 20, a = [];
    if (Ai(e2))
      n2 = e2;
    else if (vr(e2)) {
      r2.__curvenessList = e2;
      return;
    }
    t2 > n2 && (n2 = t2);
    var i = n2 % 2 ? n2 + 2 : n2 + 3;
    a = [];
    for (var o = 0; o < i; o++)
      a.push((o % 2 ? o + 1 : o) / 10 * (o % 2 ? -1 : 1));
    r2.__curvenessList = a;
  }, _E = function(r2, t2, e2) {
    var n2 = [r2.id, r2.dataIndex].join("."), a = [t2.id, t2.dataIndex].join(".");
    return [e2.uid, n2, a].join(G4);
  }, dK = function(r2) {
    var t2 = r2.split(G4);
    return [t2[0], t2[2], t2[1]].join(G4);
  }, uye = function(r2, t2) {
    var e2 = _E(r2.node1, r2.node2, t2);
    return t2.__edgeMap[e2];
  }, lye = function(r2, t2) {
    var e2 = W4(_E(r2.node1, r2.node2, t2), t2), n2 = W4(_E(r2.node2, r2.node1, t2), t2);
    return e2 + n2;
  }, W4 = function(r2, t2) {
    var e2 = t2.__edgeMap;
    return e2[r2] ? e2[r2].length : 0;
  };
  function cye(r2) {
    !C3(r2) || (r2.__curvenessList = [], r2.__edgeMap = {}, vK(r2));
  }
  function fye(r2, t2, e2, n2) {
    if (!!C3(e2)) {
      var a = _E(r2, t2, e2), i = e2.__edgeMap, o = i[dK(a)];
      i[a] && !o ? i[a].isForward = true : o && i[a] && (o.isForward = true, i[a].isForward = false), i[a] = i[a] || [], i[a].push(n2);
    }
  }
  function tN(r2, t2, e2, n2) {
    var a = C3(t2), i = vr(a);
    if (!a)
      return null;
    var o = uye(r2, t2);
    if (!o)
      return null;
    for (var s = -1, u = 0; u < o.length; u++)
      if (o[u] === e2) {
        s = u;
        break;
      }
    var l2 = lye(r2, t2);
    vK(t2, l2), r2.lineStyle = r2.lineStyle || {};
    var c2 = _E(r2.node1, r2.node2, t2), f2 = t2.__curvenessList, h = i || l2 % 2 ? 0 : 1;
    if (o.isForward)
      return f2[h + s];
    var v9 = dK(c2), d2 = W4(v9, t2), m2 = f2[s + d2 + h];
    return n2 ? i ? a && a[0] === 0 ? (d2 + h) % 2 ? m2 : -m2 : ((d2 % 2 ? 0 : 1) + h) % 2 ? m2 : -m2 : (d2 + h) % 2 ? m2 : -m2 : f2[s + d2 + h];
  }
  function pK(r2) {
    var t2 = r2.coordinateSystem;
    if (!(t2 && t2.type !== "view")) {
      var e2 = r2.getGraph();
      e2.eachNode(function(n2) {
        var a = n2.getModel();
        n2.setLayout([+a.get("x"), +a.get("y")]);
      }), gK(e2, r2);
    }
  }
  function gK(r2, t2) {
    r2.eachEdge(function(e2, n2) {
      var a = _g(e2.getModel().get(["lineStyle", "curveness"]), -tN(e2, t2, n2, true), 0), i = xg(e2.node1.getLayout()), o = xg(e2.node2.getLayout()), s = [i, o];
      +a && s.push([(i[0] + o[0]) / 2 - (i[1] - o[1]) * a, (i[1] + o[1]) / 2 - (o[0] - i[0]) * a]), e2.setLayout(s);
    });
  }
  function hye(r2, t2) {
    r2.eachSeriesByType("graph", function(e2) {
      var n2 = e2.get("layout"), a = e2.coordinateSystem;
      if (a && a.type !== "view") {
        var i = e2.getData(), o = [];
        ae(a.dimensions, function(h) {
          o = o.concat(i.mapDimensionsAll(h));
        });
        for (var s = 0; s < i.count(); s++) {
          for (var u = [], l2 = false, c2 = 0; c2 < o.length; c2++) {
            var f2 = i.get(o[c2], s);
            isNaN(f2) || (l2 = true), u.push(f2);
          }
          l2 ? i.setItemLayout(s, a.dataToPoint(u)) : i.setItemLayout(s, [NaN, NaN]);
        }
        gK(i.graph, e2);
      } else
        (!n2 || n2 === "none") && pK(e2);
    });
  }
  function MC(r2) {
    var t2 = r2.coordinateSystem;
    if (t2.type !== "view")
      return 1;
    var e2 = r2.option.nodeScaleRatio, n2 = t2.scaleX, a = t2.getZoom(), i = (a - 1) * e2 + 1;
    return i / n2;
  }
  function PC(r2) {
    var t2 = r2.getVisual("symbolSize");
    return t2 instanceof Array && (t2 = (t2[0] + t2[1]) / 2), +t2;
  }
  var NB = Math.PI, Tk = [];
  function yK(r2, t2) {
    var e2 = r2.coordinateSystem;
    if (!(e2 && e2.type !== "view")) {
      var n2 = e2.getBoundingRect(), a = r2.getData(), i = a.graph, o = n2.width / 2 + n2.x, s = n2.height / 2 + n2.y, u = Math.min(n2.width, n2.height) / 2, l2 = a.count();
      a.setLayout({ cx: o, cy: s }), l2 && (vye[t2](r2, i, a, u, o, s, l2), i.eachEdge(function(c2, f2) {
        var h = _g(c2.getModel().get(["lineStyle", "curveness"]), tN(c2, r2, f2), 0), v9 = xg(c2.node1.getLayout()), d2 = xg(c2.node2.getLayout()), m2, b2 = (v9[0] + d2[0]) / 2, _ = (v9[1] + d2[1]) / 2;
        +h && (h *= 3, m2 = [o * h + b2 * (1 - h), s * h + _ * (1 - h)]), c2.setLayout([v9, d2, m2]);
      }));
    }
  }
  var vye = { value: function(r2, t2, e2, n2, a, i, o) {
    var s = 0, u = e2.getSum("value"), l2 = Math.PI * 2 / (u || o);
    t2.eachNode(function(c2) {
      var f2 = c2.getValue("value"), h = l2 * (u ? f2 : 1) / 2;
      s += h, c2.setLayout([n2 * Math.cos(s) + a, n2 * Math.sin(s) + i]), s += h;
    });
  }, symbolSize: function(r2, t2, e2, n2, a, i, o) {
    var s = 0;
    Tk.length = o;
    var u = MC(r2);
    t2.eachNode(function(f2) {
      var h = PC(f2);
      isNaN(h) && (h = 2), h < 0 && (h = 0), h *= u;
      var v9 = Math.asin(h / 2 / n2);
      isNaN(v9) && (v9 = NB / 2), Tk[f2.dataIndex] = v9, s += v9 * 2;
    });
    var l2 = (2 * NB - s) / o / 2, c2 = 0;
    t2.eachNode(function(f2) {
      var h = l2 + Tk[f2.dataIndex];
      c2 += h, f2.setLayout([n2 * Math.cos(c2) + a, n2 * Math.sin(c2) + i]), c2 += h;
    });
  } };
  function dye(r2) {
    r2.eachSeriesByType("graph", function(t2) {
      t2.get("layout") === "circular" && yK(t2, "symbolSize");
    });
  }
  var Ex = LR;
  function pye(r2, t2, e2) {
    for (var n2 = r2, a = t2, i = e2.rect, o = i.width, s = i.height, u = [i.x + o / 2, i.y + s / 2], l2 = e2.gravity == null ? 0.1 : e2.gravity, c2 = 0; c2 < n2.length; c2++) {
      var f2 = n2[c2];
      f2.p || (f2.p = o1(o * (Math.random() - 0.5) + u[0], s * (Math.random() - 0.5) + u[1])), f2.pp = xg(f2.p), f2.edges = null;
    }
    var h = e2.friction == null ? 0.6 : e2.friction, v9 = h, d2, m2;
    return { warmUp: function() {
      v9 = h * 0.8;
    }, setFixed: function(b2) {
      n2[b2].fixed = true;
    }, setUnfixed: function(b2) {
      n2[b2].fixed = false;
    }, beforeStep: function(b2) {
      d2 = b2;
    }, afterStep: function(b2) {
      m2 = b2;
    }, step: function(b2) {
      d2 && d2(n2, a);
      for (var _ = [], C = n2.length, M = 0; M < a.length; M++) {
        var E = a[M];
        if (!E.ignoreForceLayout) {
          var z9 = E.n1, V = E.n2;
          Vb(_, V.p, z9.p);
          var $ = OR(_) - E.d, U = V.w / (z9.w + V.w);
          isNaN(U) && (U = 0), TE(_, _), !z9.fixed && Ex(z9.p, z9.p, _, U * $ * v9), !V.fixed && Ex(V.p, V.p, _, -(1 - U) * $ * v9);
        }
      }
      for (var M = 0; M < C; M++) {
        var H = n2[M];
        H.fixed || (Vb(_, u, H.p), Ex(H.p, H.p, _, l2 * v9));
      }
      for (var M = 0; M < C; M++)
        for (var z9 = n2[M], q3 = M + 1; q3 < C; q3++) {
          var V = n2[q3];
          Vb(_, V.p, z9.p);
          var $ = OR(_);
          $ === 0 && (bae(_, Math.random() - 0.5, Math.random() - 0.5), $ = 1);
          var ee = (z9.rep + V.rep) / $ / $;
          !z9.fixed && Ex(z9.pp, z9.pp, _, ee), !V.fixed && Ex(V.pp, V.pp, _, -ee);
        }
      for (var oe = [], M = 0; M < C; M++) {
        var H = n2[M];
        H.fixed || (Vb(oe, H.p, H.pp), Ex(H.p, H.p, oe, v9), Lc(H.pp, H.p));
      }
      v9 = v9 * 0.992;
      var ne = v9 < 0.01;
      m2 && m2(n2, a, ne), b2 && b2(ne);
    } };
  }
  function gye(r2) {
    r2.eachSeriesByType("graph", function(t2) {
      var e2 = t2.coordinateSystem;
      if (!(e2 && e2.type !== "view"))
        if (t2.get("layout") === "force") {
          var n2 = t2.preservedPoints || {}, a = t2.getGraph(), i = a.data, o = a.edgeData, s = t2.getModel("force"), u = s.get("initLayout");
          t2.preservedPoints ? i.each(function(M) {
            var E = i.getId(M);
            i.setItemLayout(M, n2[E] || [NaN, NaN]);
          }) : !u || u === "none" ? pK(t2) : u === "circular" && yK(t2, "value");
          var l2 = i.getDataExtent("value"), c2 = o.getDataExtent("value"), f2 = s.get("repulsion"), h = s.get("edgeLength"), v9 = vr(f2) ? f2 : [f2, f2], d2 = vr(h) ? h : [h, h];
          d2 = [d2[1], d2[0]];
          var m2 = i.mapArray("value", function(M, E) {
            var z9 = i.getItemLayout(E), V = Gi(M, l2, v9);
            return isNaN(V) && (V = (v9[0] + v9[1]) / 2), { w: V, rep: V, fixed: i.getItemModel(E).get("fixed"), p: !z9 || isNaN(z9[0]) || isNaN(z9[1]) ? null : z9 };
          }), b2 = o.mapArray("value", function(M, E) {
            var z9 = a.getEdgeByIndex(E), V = Gi(M, c2, d2);
            isNaN(V) && (V = (d2[0] + d2[1]) / 2);
            var $ = z9.getModel(), U = _g(z9.getModel().get(["lineStyle", "curveness"]), -tN(z9, t2, E, true), 0);
            return { n1: m2[z9.node1.dataIndex], n2: m2[z9.node2.dataIndex], d: V, curveness: U, ignoreForceLayout: $.get("ignoreForceLayout") };
          }), _ = e2.getBoundingRect(), C = pye(m2, b2, { rect: _, gravity: s.get("gravity"), friction: s.get("friction") });
          C.beforeStep(function(M, E) {
            for (var z9 = 0, V = M.length; z9 < V; z9++)
              M[z9].fixed && Lc(M[z9].p, a.getNodeByIndex(z9).getLayout());
          }), C.afterStep(function(M, E, z9) {
            for (var V = 0, $ = M.length; V < $; V++)
              M[V].fixed || a.getNodeByIndex(V).setLayout(M[V].p), n2[i.getId(V)] = M[V].p;
            for (var V = 0, $ = E.length; V < $; V++) {
              var U = E[V], H = a.getEdgeByIndex(V), q3 = U.n1.p, ee = U.n2.p, oe = H.getLayout();
              oe = oe ? oe.slice() : [], oe[0] = oe[0] || [], oe[1] = oe[1] || [], Lc(oe[0], q3), Lc(oe[1], ee), +U.curveness && (oe[2] = [(q3[0] + ee[0]) / 2 - (q3[1] - ee[1]) * U.curveness, (q3[1] + ee[1]) / 2 - (ee[0] - q3[0]) * U.curveness]), H.setLayout(oe);
            }
          }), t2.forceLayout = C, t2.preservedPoints = n2, C.step();
        } else
          t2.forceLayout = null;
    });
  }
  function yye(r2, t2, e2) {
    var n2 = qt(r2.getBoxLayoutParams(), { aspect: e2 });
    return Eu(n2, { width: t2.getWidth(), height: t2.getHeight() });
  }
  function mye(r2, t2) {
    var e2 = [];
    return r2.eachSeriesByType("graph", function(n2) {
      var a = n2.get("coordinateSystem");
      if (!a || a === "view") {
        var i = n2.getData(), o = i.mapArray(function(b2) {
          var _ = i.getItemModel(b2);
          return [+_.get("x"), +_.get("y")];
        }), s = [], u = [];
        XP(o, s, u), u[0] - s[0] === 0 && (u[0] += 1, s[0] -= 1), u[1] - s[1] === 0 && (u[1] += 1, s[1] -= 1);
        var l2 = (u[0] - s[0]) / (u[1] - s[1]), c2 = yye(n2, t2, l2);
        isNaN(l2) && (s = [c2.x, c2.y], u = [c2.x + c2.width, c2.y + c2.height]);
        var f2 = u[0] - s[0], h = u[1] - s[1], v9 = c2.width, d2 = c2.height, m2 = n2.coordinateSystem = new YE();
        m2.zoomLimit = n2.get("scaleLimit"), m2.setBoundingRect(s[0], s[1], f2, h), m2.setViewRect(c2.x, c2.y, v9, d2), m2.setCenter(n2.get("center")), m2.setZoom(n2.get("zoom")), e2.push(m2);
      }
    }), e2;
  }
  var VB = bl.prototype, Mk = t3.prototype, mK = function() {
    function r2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return r2;
  }();
  (function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2;
  })(mK);
  function Pk(r2) {
    return isNaN(+r2.cpx1) || isNaN(+r2.cpy1);
  }
  var bye = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "ec-line", n2;
    }
    return t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new mK();
    }, t2.prototype.buildPath = function(e2, n2) {
      Pk(n2) ? VB.buildPath.call(this, e2, n2) : Mk.buildPath.call(this, e2, n2);
    }, t2.prototype.pointAt = function(e2) {
      return Pk(this.shape) ? VB.pointAt.call(this, e2) : Mk.pointAt.call(this, e2);
    }, t2.prototype.tangentAt = function(e2) {
      var n2 = this.shape, a = Pk(n2) ? [n2.x2 - n2.x1, n2.y2 - n2.y1] : Mk.tangentAt.call(this, e2);
      return TE(a, a);
    }, t2;
  }(xa), _ye = bye, Dk = ["fromSymbol", "toSymbol"];
  function jB(r2) {
    return "_" + r2 + "Type";
  }
  function BB(r2, t2, e2) {
    var n2 = t2.getItemVisual(e2, r2);
    if (!(!n2 || n2 === "none")) {
      var a = t2.getItemVisual(e2, r2 + "Size"), i = t2.getItemVisual(e2, r2 + "Rotate"), o = t2.getItemVisual(e2, r2 + "Offset"), s = t2.getItemVisual(e2, r2 + "KeepAspect"), u = VE(a), l2 = Cw(o || 0, u), c2 = cu(n2, -u[0] / 2 + l2[0], -u[1] / 2 + l2[1], u[0], u[1], null, s);
      return c2.__specifiedRotation = i == null || isNaN(i) ? void 0 : +i * Math.PI / 180 || 0, c2.name = r2, c2;
    }
  }
  function xye(r2) {
    var t2 = new _ye({ name: "line", subPixelOptimize: true });
    return U4(t2.shape, r2), t2;
  }
  function U4(r2, t2) {
    r2.x1 = t2[0][0], r2.y1 = t2[0][1], r2.x2 = t2[1][0], r2.y2 = t2[1][1], r2.percent = 1;
    var e2 = t2[2];
    e2 ? (r2.cpx1 = e2[0], r2.cpy1 = e2[1]) : (r2.cpx1 = NaN, r2.cpy1 = NaN);
  }
  var wye = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this) || this;
      return i._createLine(e2, n2, a), i;
    }
    return t2.prototype._createLine = function(e2, n2, a) {
      var i = e2.hostModel, o = e2.getItemLayout(n2), s = xye(o);
      s.shape.percent = 0, rs(s, { shape: { percent: 1 } }, i, n2), this.add(s), ae(Dk, function(u) {
        var l2 = BB(u, e2, n2);
        this.add(l2), this[jB(u)] = e2.getItemVisual(n2, u);
      }, this), this._updateCommonStl(e2, n2, a);
    }, t2.prototype.updateData = function(e2, n2, a) {
      var i = e2.hostModel, o = this.childOfName("line"), s = e2.getItemLayout(n2), u = { shape: {} };
      U4(u.shape, s), ci(o, u, i, n2), ae(Dk, function(l2) {
        var c2 = e2.getItemVisual(n2, l2), f2 = jB(l2);
        if (this[f2] !== c2) {
          this.remove(this.childOfName(l2));
          var h = BB(l2, e2, n2);
          this.add(h);
        }
        this[f2] = c2;
      }, this), this._updateCommonStl(e2, n2, a);
    }, t2.prototype.getLinePath = function() {
      return this.childAt(0);
    }, t2.prototype._updateCommonStl = function(e2, n2, a) {
      var i = e2.hostModel, o = this.childOfName("line"), s = a && a.emphasisLineStyle, u = a && a.blurLineStyle, l2 = a && a.selectLineStyle, c2 = a && a.labelStatesModels, f2 = a && a.emphasisDisabled, h = a && a.focus, v9 = a && a.blurScope;
      if (!a || e2.hasItemOption) {
        var d2 = e2.getItemModel(n2), m2 = d2.getModel("emphasis");
        s = m2.getModel("lineStyle").getLineStyle(), u = d2.getModel(["blur", "lineStyle"]).getLineStyle(), l2 = d2.getModel(["select", "lineStyle"]).getLineStyle(), f2 = m2.get("disabled"), h = m2.get("focus"), v9 = m2.get("blurScope"), c2 = _l(d2);
      }
      var b2 = e2.getItemVisual(n2, "style"), _ = b2.stroke;
      o.useStyle(b2), o.style.fill = null, o.style.strokeNoScale = true, o.ensureState("emphasis").style = s, o.ensureState("blur").style = u, o.ensureState("select").style = l2, ae(Dk, function(V) {
        var $ = this.childOfName(V);
        if ($) {
          $.setColor(_), $.style.opacity = b2.opacity;
          for (var U = 0; U < Nc.length; U++) {
            var H = Nc[U], q3 = o.getState(H);
            if (q3) {
              var ee = q3.style || {}, oe = $.ensureState(H), ne = oe.style || (oe.style = {});
              ee.stroke != null && (ne[$.__isEmptyBrush ? "stroke" : "fill"] = ee.stroke), ee.opacity != null && (ne.opacity = ee.opacity);
            }
          }
          $.markRedraw();
        }
      }, this);
      var C = i.getRawValue(n2);
      fc(this, c2, { labelDataIndex: n2, labelFetcher: { getFormattedLabel: function(V, $) {
        return i.getFormattedLabel(V, $, e2.dataType);
      } }, inheritColor: _ || "#000", defaultOpacity: b2.opacity, defaultText: (C == null ? e2.getName(n2) : isFinite(C) ? Os(C) : C) + "" });
      var M = this.getTextContent();
      if (M) {
        var E = c2.normal;
        M.__align = M.style.align, M.__verticalAlign = M.style.verticalAlign, M.__position = E.get("position") || "middle";
        var z9 = E.get("distance");
        vr(z9) || (z9 = [z9, z9]), M.__labelDistance = z9;
      }
      this.setTextConfig({ position: null, local: true, inside: false }), ks(this, h, v9, f2);
    }, t2.prototype.highlight = function() {
      Kd(this);
    }, t2.prototype.downplay = function() {
      Zd(this);
    }, t2.prototype.updateLayout = function(e2, n2) {
      this.setLinePoints(e2.getItemLayout(n2));
    }, t2.prototype.setLinePoints = function(e2) {
      var n2 = this.childOfName("line");
      U4(n2.shape, e2), n2.dirty();
    }, t2.prototype.beforeUpdate = function() {
      var e2 = this, n2 = e2.childOfName("fromSymbol"), a = e2.childOfName("toSymbol"), i = e2.getTextContent();
      if (!n2 && !a && (!i || i.ignore))
        return;
      for (var o = 1, s = this.parent; s; )
        s.scaleX && (o /= s.scaleX), s = s.parent;
      var u = e2.childOfName("line");
      if (!this.__dirty && !u.__dirty)
        return;
      var l2 = u.shape.percent, c2 = u.pointAt(0), f2 = u.pointAt(l2), h = Vb([], f2, c2);
      TE(h, h);
      function v9(q3, ee) {
        var oe = q3.__specifiedRotation;
        if (oe == null) {
          var ne = u.tangentAt(ee);
          q3.attr("rotation", (ee === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(ne[1], ne[0]));
        } else
          q3.attr("rotation", oe);
      }
      if (n2 && (n2.setPosition(c2), v9(n2, 0), n2.scaleX = n2.scaleY = o * l2, n2.markRedraw()), a && (a.setPosition(f2), v9(a, 1), a.scaleX = a.scaleY = o * l2, a.markRedraw()), i && !i.ignore) {
        i.x = i.y = 0, i.originX = i.originY = 0;
        var d2 = void 0, m2 = void 0, b2 = i.__labelDistance, _ = b2[0] * o, C = b2[1] * o, M = l2 / 2, E = u.tangentAt(M), z9 = [E[1], -E[0]], V = u.pointAt(M);
        z9[1] > 0 && (z9[0] = -z9[0], z9[1] = -z9[1]);
        var $ = E[0] < 0 ? -1 : 1;
        if (i.__position !== "start" && i.__position !== "end") {
          var U = -Math.atan2(E[1], E[0]);
          f2[0] < c2[0] && (U = Math.PI + U), i.rotation = U;
        }
        var H = void 0;
        switch (i.__position) {
          case "insideStartTop":
          case "insideMiddleTop":
          case "insideEndTop":
          case "middle":
            H = -C, m2 = "bottom";
            break;
          case "insideStartBottom":
          case "insideMiddleBottom":
          case "insideEndBottom":
            H = C, m2 = "top";
            break;
          default:
            H = 0, m2 = "middle";
        }
        switch (i.__position) {
          case "end":
            i.x = h[0] * _ + f2[0], i.y = h[1] * C + f2[1], d2 = h[0] > 0.8 ? "left" : h[0] < -0.8 ? "right" : "center", m2 = h[1] > 0.8 ? "top" : h[1] < -0.8 ? "bottom" : "middle";
            break;
          case "start":
            i.x = -h[0] * _ + c2[0], i.y = -h[1] * C + c2[1], d2 = h[0] > 0.8 ? "right" : h[0] < -0.8 ? "left" : "center", m2 = h[1] > 0.8 ? "bottom" : h[1] < -0.8 ? "top" : "middle";
            break;
          case "insideStartTop":
          case "insideStart":
          case "insideStartBottom":
            i.x = _ * $ + c2[0], i.y = c2[1] + H, d2 = E[0] < 0 ? "right" : "left", i.originX = -_ * $, i.originY = -H;
            break;
          case "insideMiddleTop":
          case "insideMiddle":
          case "insideMiddleBottom":
          case "middle":
            i.x = V[0], i.y = V[1] + H, d2 = "center", i.originY = -H;
            break;
          case "insideEndTop":
          case "insideEnd":
          case "insideEndBottom":
            i.x = -_ * $ + f2[0], i.y = f2[1] + H, d2 = E[0] >= 0 ? "right" : "left", i.originX = _ * $, i.originY = -H;
            break;
        }
        i.scaleX = i.scaleY = o, i.setStyle({ verticalAlign: i.__verticalAlign || m2, align: i.__align || d2 });
      }
    }, t2;
  }(Fn), rN = wye, Sye = function() {
    function r2(t2) {
      this.group = new Fn(), this._LineCtor = t2 || rN;
    }
    return r2.prototype.updateData = function(t2) {
      var e2 = this;
      this._progressiveEls = null;
      var n2 = this, a = n2.group, i = n2._lineData;
      n2._lineData = t2, i || a.removeAll();
      var o = zB(t2);
      t2.diff(i).add(function(s) {
        e2._doAdd(t2, s, o);
      }).update(function(s, u) {
        e2._doUpdate(i, t2, u, s, o);
      }).remove(function(s) {
        a.remove(i.getItemGraphicEl(s));
      }).execute();
    }, r2.prototype.updateLayout = function() {
      var t2 = this._lineData;
      !t2 || t2.eachItemGraphicEl(function(e2, n2) {
        e2.updateLayout(t2, n2);
      }, this);
    }, r2.prototype.incrementalPrepareUpdate = function(t2) {
      this._seriesScope = zB(t2), this._lineData = null, this.group.removeAll();
    }, r2.prototype.incrementalUpdate = function(t2, e2) {
      this._progressiveEls = [];
      function n2(s) {
        !s.isGroup && !Cye(s) && (s.incremental = true, s.ensureState("emphasis").hoverLayer = true);
      }
      for (var a = t2.start; a < t2.end; a++) {
        var i = e2.getItemLayout(a);
        if (Ik(i)) {
          var o = new this._LineCtor(e2, a, this._seriesScope);
          o.traverse(n2), this.group.add(o), e2.setItemGraphicEl(a, o), this._progressiveEls.push(o);
        }
      }
    }, r2.prototype.remove = function() {
      this.group.removeAll();
    }, r2.prototype.eachRendered = function(t2) {
      Ay(this._progressiveEls || this.group, t2);
    }, r2.prototype._doAdd = function(t2, e2, n2) {
      var a = t2.getItemLayout(e2);
      if (!!Ik(a)) {
        var i = new this._LineCtor(t2, e2, n2);
        t2.setItemGraphicEl(e2, i), this.group.add(i);
      }
    }, r2.prototype._doUpdate = function(t2, e2, n2, a, i) {
      var o = t2.getItemGraphicEl(n2);
      if (!Ik(e2.getItemLayout(a))) {
        this.group.remove(o);
        return;
      }
      o ? o.updateData(e2, a, i) : o = new this._LineCtor(e2, a, i), e2.setItemGraphicEl(a, o), this.group.add(o);
    }, r2;
  }();
  function Cye(r2) {
    return r2.animators && r2.animators.length > 0;
  }
  function zB(r2) {
    var t2 = r2.hostModel, e2 = t2.getModel("emphasis");
    return { lineStyle: t2.getModel("lineStyle").getLineStyle(), emphasisLineStyle: e2.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: t2.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: t2.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: e2.get("disabled"), blurScope: e2.get("blurScope"), focus: e2.get("focus"), labelStatesModels: _l(t2) };
  }
  function $B(r2) {
    return isNaN(r2[0]) || isNaN(r2[1]);
  }
  function Ik(r2) {
    return r2 && !$B(r2[0]) && !$B(r2[1]);
  }
  var nN = Sye, Lk = [], Ok = [], kk = [], Ax = yl, Rk = Wb, GB = Math.abs;
  function WB(r2, t2, e2) {
    for (var n2 = r2[0], a = r2[1], i = r2[2], o = 1 / 0, s, u = e2 * e2, l2 = 0.1, c2 = 0.1; c2 <= 0.9; c2 += 0.1) {
      Lk[0] = Ax(n2[0], a[0], i[0], c2), Lk[1] = Ax(n2[1], a[1], i[1], c2);
      var f2 = GB(Rk(Lk, t2) - u);
      f2 < o && (o = f2, s = c2);
    }
    for (var h = 0; h < 32; h++) {
      var v9 = s + l2;
      Ok[0] = Ax(n2[0], a[0], i[0], s), Ok[1] = Ax(n2[1], a[1], i[1], s), kk[0] = Ax(n2[0], a[0], i[0], v9), kk[1] = Ax(n2[1], a[1], i[1], v9);
      var f2 = Rk(Ok, t2) - u;
      if (GB(f2) < 0.01)
        break;
      var d2 = Rk(kk, t2) - u;
      l2 /= 2, f2 < 0 ? d2 >= 0 ? s = s + l2 : s = s - l2 : d2 >= 0 ? s = s - l2 : s = s + l2;
    }
    return s;
  }
  function Fk(r2, t2) {
    var e2 = [], n2 = JC, a = [[], [], []], i = [[], []], o = [];
    t2 /= 2, r2.eachEdge(function(s, u) {
      var l2 = s.getLayout(), c2 = s.getVisual("fromSymbol"), f2 = s.getVisual("toSymbol");
      l2.__original || (l2.__original = [xg(l2[0]), xg(l2[1])], l2[2] && l2.__original.push(xg(l2[2])));
      var h = l2.__original;
      if (l2[2] != null) {
        if (Lc(a[0], h[0]), Lc(a[1], h[2]), Lc(a[2], h[1]), c2 && c2 !== "none") {
          var v9 = PC(s.node1), d2 = WB(a, h[0], v9 * t2);
          n2(a[0][0], a[1][0], a[2][0], d2, e2), a[0][0] = e2[3], a[1][0] = e2[4], n2(a[0][1], a[1][1], a[2][1], d2, e2), a[0][1] = e2[3], a[1][1] = e2[4];
        }
        if (f2 && f2 !== "none") {
          var v9 = PC(s.node2), d2 = WB(a, h[1], v9 * t2);
          n2(a[0][0], a[1][0], a[2][0], d2, e2), a[1][0] = e2[1], a[2][0] = e2[2], n2(a[0][1], a[1][1], a[2][1], d2, e2), a[1][1] = e2[1], a[2][1] = e2[2];
        }
        Lc(l2[0], a[0]), Lc(l2[1], a[2]), Lc(l2[2], a[1]);
      } else {
        if (Lc(i[0], h[0]), Lc(i[1], h[1]), Vb(o, i[1], i[0]), TE(o, o), c2 && c2 !== "none") {
          var v9 = PC(s.node1);
          LR(i[0], i[0], o, v9 * t2);
        }
        if (f2 && f2 !== "none") {
          var v9 = PC(s.node2);
          LR(i[1], i[1], o, -v9 * t2);
        }
        Lc(l2[0], i[0]), Lc(l2[1], i[1]);
      }
    });
  }
  function UB(r2) {
    return r2.type === "view";
  }
  var Eye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      var a = new GE(), i = new nN(), o = this.group;
      this._controller = new qE(n2.getZr()), this._controllerHost = { target: o }, o.add(a.group), o.add(i.group), this._symbolDraw = a, this._lineDraw = i, this._firstRender = true;
    }, t2.prototype.render = function(e2, n2, a) {
      var i = this, o = e2.coordinateSystem;
      this._model = e2;
      var s = this._symbolDraw, u = this._lineDraw, l2 = this.group;
      if (UB(o)) {
        var c2 = { x: o.x, y: o.y, scaleX: o.scaleX, scaleY: o.scaleY };
        this._firstRender ? l2.attr(c2) : ci(l2, c2, e2);
      }
      Fk(e2.getGraph(), MC(e2));
      var f2 = e2.getData();
      s.updateData(f2);
      var h = e2.getEdgeData();
      u.updateData(h), this._updateNodeAndLinkScale(), this._updateController(e2, n2, a), clearTimeout(this._layoutTimeout);
      var v9 = e2.forceLayout, d2 = e2.get(["force", "layoutAnimation"]);
      v9 && this._startForceLayoutIteration(v9, d2), f2.graph.eachNode(function(C) {
        var M = C.dataIndex, E = C.getGraphicEl(), z9 = C.getModel();
        if (!!E) {
          E.off("drag").off("dragend");
          var V = z9.get("draggable");
          V && E.on("drag", function() {
            v9 && (v9.warmUp(), !i._layouting && i._startForceLayoutIteration(v9, d2), v9.setFixed(M), f2.setItemLayout(M, [E.x, E.y]));
          }).on("dragend", function() {
            v9 && v9.setUnfixed(M);
          }), E.setDraggable(V && !!v9);
          var $ = z9.get(["emphasis", "focus"]);
          $ === "adjacency" && (zn(E).focus = C.getAdjacentDataIndices());
        }
      }), f2.graph.eachEdge(function(C) {
        var M = C.getGraphicEl(), E = C.getModel().get(["emphasis", "focus"]);
        !M || E === "adjacency" && (zn(M).focus = { edge: [C.dataIndex], node: [C.node1.dataIndex, C.node2.dataIndex] });
      });
      var m2 = e2.get("layout") === "circular" && e2.get(["circular", "rotateLabel"]), b2 = f2.getLayout("cx"), _ = f2.getLayout("cy");
      f2.eachItemGraphicEl(function(C, M) {
        var E = f2.getItemModel(M), z9 = E.get(["label", "rotate"]) || 0, V = C.getSymbolPath();
        if (m2) {
          var $ = f2.getItemLayout(M), U = Math.atan2($[1] - _, $[0] - b2);
          U < 0 && (U = Math.PI * 2 + U);
          var H = $[0] < b2;
          H && (U = U - Math.PI);
          var q3 = H ? "left" : "right";
          V.setTextConfig({ rotation: -U, position: q3, origin: "center" });
          var ee = V.ensureState("emphasis");
          qt(ee.textConfig || (ee.textConfig = {}), { position: q3 });
        } else
          V.setTextConfig({ rotation: z9 *= Math.PI / 180 });
      }), this._firstRender = false;
    }, t2.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, t2.prototype._startForceLayoutIteration = function(e2, n2) {
      var a = this;
      (function i() {
        e2.step(function(o) {
          a.updateLayout(a._model), (a._layouting = !o) && (n2 ? a._layoutTimeout = setTimeout(i, 16) : i());
        });
      })();
    }, t2.prototype._updateController = function(e2, n2, a) {
      var i = this, o = this._controller, s = this._controllerHost, u = this.group;
      if (o.setPointerChecker(function(l2, c2, f2) {
        var h = u.getBoundingRect();
        return h.applyTransform(u.transform), h.contain(c2, f2) && !x3(l2, a, e2);
      }), !UB(e2.coordinateSystem)) {
        o.disable();
        return;
      }
      o.enable(e2.get("roam")), s.zoomLimit = e2.get("scaleLimit"), s.zoom = e2.coordinateSystem.getZoom(), o.off("pan").off("zoom").on("pan", function(l2) {
        HF(s, l2.dx, l2.dy), a.dispatchAction({ seriesId: e2.id, type: "graphRoam", dx: l2.dx, dy: l2.dy });
      }).on("zoom", function(l2) {
        qF(s, l2.scale, l2.originX, l2.originY), a.dispatchAction({ seriesId: e2.id, type: "graphRoam", zoom: l2.scale, originX: l2.originX, originY: l2.originY }), i._updateNodeAndLinkScale(), Fk(e2.getGraph(), MC(e2)), i._lineDraw.updateLayout(), a.updateLabelLayout();
      });
    }, t2.prototype._updateNodeAndLinkScale = function() {
      var e2 = this._model, n2 = e2.getData(), a = MC(e2);
      n2.eachItemGraphicEl(function(i, o) {
        i && i.setSymbolScale(a);
      });
    }, t2.prototype.updateLayout = function(e2) {
      Fk(e2.getGraph(), MC(e2)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
    }, t2.prototype.remove = function(e2, n2) {
      this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
    }, t2.type = "graph", t2;
  }(Mo), Aye = Eye;
  function Tx(r2) {
    return "_EC_" + r2;
  }
  var Tye = function() {
    function r2(t2) {
      this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = t2 || false;
    }
    return r2.prototype.isDirected = function() {
      return this._directed;
    }, r2.prototype.addNode = function(t2, e2) {
      t2 = t2 == null ? "" + e2 : "" + t2;
      var n2 = this._nodesMap;
      if (!n2[Tx(t2)]) {
        var a = new Ib(t2, e2);
        return a.hostGraph = this, this.nodes.push(a), n2[Tx(t2)] = a, a;
      }
    }, r2.prototype.getNodeByIndex = function(t2) {
      var e2 = this.data.getRawIndex(t2);
      return this.nodes[e2];
    }, r2.prototype.getNodeById = function(t2) {
      return this._nodesMap[Tx(t2)];
    }, r2.prototype.addEdge = function(t2, e2, n2) {
      var a = this._nodesMap, i = this._edgesMap;
      if (Ai(t2) && (t2 = this.nodes[t2]), Ai(e2) && (e2 = this.nodes[e2]), t2 instanceof Ib || (t2 = a[Tx(t2)]), e2 instanceof Ib || (e2 = a[Tx(e2)]), !(!t2 || !e2)) {
        var o = t2.id + "-" + e2.id, s = new bK(t2, e2, n2);
        return s.hostGraph = this, this._directed && (t2.outEdges.push(s), e2.inEdges.push(s)), t2.edges.push(s), t2 !== e2 && e2.edges.push(s), this.edges.push(s), i[o] = s, s;
      }
    }, r2.prototype.getEdgeByIndex = function(t2) {
      var e2 = this.edgeData.getRawIndex(t2);
      return this.edges[e2];
    }, r2.prototype.getEdge = function(t2, e2) {
      t2 instanceof Ib && (t2 = t2.id), e2 instanceof Ib && (e2 = e2.id);
      var n2 = this._edgesMap;
      return this._directed ? n2[t2 + "-" + e2] : n2[t2 + "-" + e2] || n2[e2 + "-" + t2];
    }, r2.prototype.eachNode = function(t2, e2) {
      for (var n2 = this.nodes, a = n2.length, i = 0; i < a; i++)
        n2[i].dataIndex >= 0 && t2.call(e2, n2[i], i);
    }, r2.prototype.eachEdge = function(t2, e2) {
      for (var n2 = this.edges, a = n2.length, i = 0; i < a; i++)
        n2[i].dataIndex >= 0 && n2[i].node1.dataIndex >= 0 && n2[i].node2.dataIndex >= 0 && t2.call(e2, n2[i], i);
    }, r2.prototype.breadthFirstTraverse = function(t2, e2, n2, a) {
      if (e2 instanceof Ib || (e2 = this._nodesMap[Tx(e2)]), !!e2) {
        for (var i = n2 === "out" ? "outEdges" : n2 === "in" ? "inEdges" : "edges", o = 0; o < this.nodes.length; o++)
          this.nodes[o].__visited = false;
        if (!t2.call(a, e2, null))
          for (var s = [e2]; s.length; )
            for (var u = s.shift(), l2 = u[i], o = 0; o < l2.length; o++) {
              var c2 = l2[o], f2 = c2.node1 === u ? c2.node2 : c2.node1;
              if (!f2.__visited) {
                if (t2.call(a, f2, u))
                  return;
                s.push(f2), f2.__visited = true;
              }
            }
      }
    }, r2.prototype.update = function() {
      for (var t2 = this.data, e2 = this.edgeData, n2 = this.nodes, a = this.edges, i = 0, o = n2.length; i < o; i++)
        n2[i].dataIndex = -1;
      for (var i = 0, o = t2.count(); i < o; i++)
        n2[t2.getRawIndex(i)].dataIndex = i;
      e2.filterSelf(function(s) {
        var u = a[e2.getRawIndex(s)];
        return u.node1.dataIndex >= 0 && u.node2.dataIndex >= 0;
      });
      for (var i = 0, o = a.length; i < o; i++)
        a[i].dataIndex = -1;
      for (var i = 0, o = e2.count(); i < o; i++)
        a[e2.getRawIndex(i)].dataIndex = i;
    }, r2.prototype.clone = function() {
      for (var t2 = new r2(this._directed), e2 = this.nodes, n2 = this.edges, a = 0; a < e2.length; a++)
        t2.addNode(e2[a].id, e2[a].dataIndex);
      for (var a = 0; a < n2.length; a++) {
        var i = n2[a];
        t2.addEdge(i.node1.id, i.node2.id, i.dataIndex);
      }
      return t2;
    }, r2;
  }(), Ib = function() {
    function r2(t2, e2) {
      this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = t2 == null ? "" : t2, this.dataIndex = e2 == null ? -1 : e2;
    }
    return r2.prototype.degree = function() {
      return this.edges.length;
    }, r2.prototype.inDegree = function() {
      return this.inEdges.length;
    }, r2.prototype.outDegree = function() {
      return this.outEdges.length;
    }, r2.prototype.getModel = function(t2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostGraph, n2 = e2.data.getItemModel(this.dataIndex);
        return n2.getModel(t2);
      }
    }, r2.prototype.getAdjacentDataIndices = function() {
      for (var t2 = { edge: [], node: [] }, e2 = 0; e2 < this.edges.length; e2++) {
        var n2 = this.edges[e2];
        n2.dataIndex < 0 || (t2.edge.push(n2.dataIndex), t2.node.push(n2.node1.dataIndex, n2.node2.dataIndex));
      }
      return t2;
    }, r2;
  }(), bK = function() {
    function r2(t2, e2, n2) {
      this.dataIndex = -1, this.node1 = t2, this.node2 = e2, this.dataIndex = n2 == null ? -1 : n2;
    }
    return r2.prototype.getModel = function(t2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostGraph, n2 = e2.edgeData.getItemModel(this.dataIndex);
        return n2.getModel(t2);
      }
    }, r2.prototype.getAdjacentDataIndices = function() {
      return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
    }, r2;
  }();
  function _K(r2, t2) {
    return { getValue: function(e2) {
      var n2 = this[r2][t2];
      return n2.getStore().get(n2.getDimensionIndex(e2 || "value"), this.dataIndex);
    }, setVisual: function(e2, n2) {
      this.dataIndex >= 0 && this[r2][t2].setItemVisual(this.dataIndex, e2, n2);
    }, getVisual: function(e2) {
      return this[r2][t2].getItemVisual(this.dataIndex, e2);
    }, setLayout: function(e2, n2) {
      this.dataIndex >= 0 && this[r2][t2].setItemLayout(this.dataIndex, e2, n2);
    }, getLayout: function() {
      return this[r2][t2].getItemLayout(this.dataIndex);
    }, getGraphicEl: function() {
      return this[r2][t2].getItemGraphicEl(this.dataIndex);
    }, getRawIndex: function() {
      return this[r2][t2].getRawIndex(this.dataIndex);
    } };
  }
  fu(Ib, _K("hostGraph", "data"));
  fu(bK, _K("hostGraph", "edgeData"));
  var Mye = Tye;
  function xK(r2, t2, e2, n2, a) {
    for (var i = new Mye(n2), o = 0; o < r2.length; o++)
      i.addNode(ml(r2[o].id, r2[o].name, o), o);
    for (var s = [], u = [], l2 = 0, o = 0; o < t2.length; o++) {
      var c2 = t2[o], f2 = c2.source, h = c2.target;
      i.addEdge(f2, h, l2) && (u.push(c2), s.push(ml(Cu(c2.id, null), f2 + " > " + h)), l2++);
    }
    var v9 = e2.get("coordinateSystem"), d2;
    if (v9 === "cartesian2d" || v9 === "polar")
      d2 = kg(r2, e2);
    else {
      var m2 = FE.get(v9), b2 = m2 ? m2.dimensions || [] : [];
      va(b2, "value") < 0 && b2.concat(["value"]);
      var _ = jE(r2, { coordDimensions: b2, encodeDefine: e2.getEncode() }).dimensions;
      d2 = new Rc(_, e2), d2.initData(r2);
    }
    var C = new Rc(["value"], e2);
    return C.initData(u, s), a && a(d2, C), tK({ mainData: d2, struct: i, structAttr: "graph", datas: { node: d2, edge: C }, datasAttr: { node: "data", edge: "edgeData" } }), i.update(), i;
  }
  var Pye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2;
    }
    return t2.prototype.init = function(e2) {
      r2.prototype.init.apply(this, arguments);
      var n2 = this;
      function a() {
        return n2._categoriesData;
      }
      this.legendVisualProvider = new HE(a, a), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
    }, t2.prototype.mergeOption = function(e2) {
      r2.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
    }, t2.prototype.mergeDefaultAndTheme = function(e2) {
      r2.prototype.mergeDefaultAndTheme.apply(this, arguments), Qb(e2, "edgeLabel", ["show"]);
    }, t2.prototype.getInitialData = function(e2, n2) {
      var a = e2.edges || e2.links || [], i = e2.data || e2.nodes || [], o = this;
      if (i && a) {
        cye(this);
        var s = xK(i, a, this, true, u);
        return ae(s.edges, function(l2) {
          fye(l2.node1, l2.node2, this, l2.dataIndex);
        }, this), s.data;
      }
      function u(l2, c2) {
        l2.wrapMethod("getItemModel", function(d2) {
          var m2 = o._categoriesModels, b2 = d2.getShallow("category"), _ = m2[b2];
          return _ && (_.parentModel = d2.parentModel, d2.parentModel = _), d2;
        });
        var f2 = To.prototype.getModel;
        function h(d2, m2) {
          var b2 = f2.call(this, d2, m2);
          return b2.resolveParentPath = v9, b2;
        }
        c2.wrapMethod("getItemModel", function(d2) {
          return d2.resolveParentPath = v9, d2.getModel = h, d2;
        });
        function v9(d2) {
          if (d2 && (d2[0] === "label" || d2[1] === "label")) {
            var m2 = d2.slice();
            return d2[0] === "label" ? m2[0] = "edgeLabel" : d2[1] === "label" && (m2[1] = "edgeLabel"), m2;
          }
          return d2;
        }
      }
    }, t2.prototype.getGraph = function() {
      return this.getData().graph;
    }, t2.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, t2.prototype.getCategoriesData = function() {
      return this._categoriesData;
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      if (a === "edge") {
        var i = this.getData(), o = this.getDataParams(e2, a), s = i.graph.getEdgeByIndex(e2), u = i.getName(s.node1.dataIndex), l2 = i.getName(s.node2.dataIndex), c2 = [];
        return u != null && c2.push(u), l2 != null && c2.push(l2), Hu("nameValue", { name: c2.join(" > "), value: o.value, noValue: o.value == null });
      }
      var f2 = GH({ series: this, dataIndex: e2, multipleSeries: n2 });
      return f2;
    }, t2.prototype._updateCategoriesData = function() {
      var e2 = pr(this.option.categories || [], function(a) {
        return a.value != null ? a : qt({ value: 0 }, a);
      }), n2 = new Rc(["value"], this);
      n2.initData(e2), this._categoriesData = n2, this._categoriesModels = n2.mapArray(function(a) {
        return n2.getItemModel(a);
      });
    }, t2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, t2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, t2.prototype.isAnimationEnabled = function() {
      return r2.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
    }, t2.type = "series.graph", t2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], t2.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, t2;
  }(ns), Dye = Pye, Iye = { type: "graphRoam", event: "graphRoam", update: "none" };
  function Lye(r2) {
    r2.registerChartView(Aye), r2.registerSeriesModel(Dye), r2.registerProcessor(iye), r2.registerVisual(oye), r2.registerVisual(sye), r2.registerLayout(hye), r2.registerLayout(r2.PRIORITY.VISUAL.POST_CHART_LAYOUT, dye), r2.registerLayout(gye), r2.registerCoordinateSystem("graphView", { dimensions: YE.dimensions, create: mye }), r2.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, lu), r2.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, lu), r2.registerAction(Iye, function(t2, e2) {
      e2.eachComponent({ mainType: "series", query: t2 }, function(n2) {
        var a = n2.coordinateSystem, i = KF(a, t2);
        n2.setCenter && n2.setCenter(i.center), n2.setZoom && n2.setZoom(i.zoom);
      });
    });
  }
  var Oye = function() {
    function r2() {
      this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
    }
    return r2;
  }(), kye = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "pointer", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Oye();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = Math.cos, i = Math.sin, o = n2.r, s = n2.width, u = n2.angle, l2 = n2.x - a(u) * s * (s >= o / 3 ? 1 : 2), c2 = n2.y - i(u) * s * (s >= o / 3 ? 1 : 2);
      u = n2.angle - Math.PI / 2, e2.moveTo(l2, c2), e2.lineTo(n2.x + a(u) * s, n2.y + i(u) * s), e2.lineTo(n2.x + a(n2.angle) * o, n2.y + i(n2.angle) * o), e2.lineTo(n2.x - a(u) * s, n2.y - i(u) * s), e2.lineTo(l2, c2);
    }, t2;
  }(xa), Rye = kye;
  function Fye(r2, t2) {
    var e2 = r2.get("center"), n2 = t2.getWidth(), a = t2.getHeight(), i = Math.min(n2, a), o = qr(e2[0], t2.getWidth()), s = qr(e2[1], t2.getHeight()), u = qr(r2.get("radius"), i / 2);
    return { cx: o, cy: s, r: u };
  }
  function n5(r2, t2) {
    var e2 = r2 == null ? "" : r2 + "";
    return t2 && (Zr(t2) ? e2 = t2.replace("{value}", e2) : xn(t2) && (e2 = t2(r2))), e2;
  }
  var Nk = Math.PI * 2, Nye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      this.group.removeAll();
      var i = e2.get(["axisLine", "lineStyle", "color"]), o = Fye(e2, a);
      this._renderMain(e2, n2, a, i, o), this._data = e2.getData();
    }, t2.prototype.dispose = function() {
    }, t2.prototype._renderMain = function(e2, n2, a, i, o) {
      for (var s = this.group, u = e2.get("clockwise"), l2 = -e2.get("startAngle") / 180 * Math.PI, c2 = -e2.get("endAngle") / 180 * Math.PI, f2 = e2.getModel("axisLine"), h = f2.get("roundCap"), v9 = h ? bP : pf, d2 = f2.get("show"), m2 = f2.getModel("lineStyle"), b2 = m2.get("width"), _ = !((c2 - l2) % Nk) && c2 !== l2 ? Nk : (c2 - l2) % Nk, C = l2, M = 0; d2 && M < i.length; M++) {
        var E = Math.min(Math.max(i[M][0], 0), 1);
        c2 = l2 + _ * E;
        var z9 = new v9({ shape: { startAngle: C, endAngle: c2, cx: o.cx, cy: o.cy, clockwise: u, r0: o.r - b2, r: o.r }, silent: true });
        z9.setStyle({ fill: i[M][1] }), z9.setStyle(m2.getLineStyle(["color", "width"])), s.add(z9), C = c2;
      }
      var V = function(U) {
        if (U <= 0)
          return i[0][1];
        var H;
        for (H = 0; H < i.length; H++)
          if (i[H][0] >= U && (H === 0 ? 0 : i[H - 1][0]) < U)
            return i[H][1];
        return i[H - 1][1];
      };
      if (!u) {
        var $ = l2;
        l2 = c2, c2 = $;
      }
      this._renderTicks(e2, n2, a, V, o, l2, c2, u, b2), this._renderTitleAndDetail(e2, n2, a, V, o), this._renderAnchor(e2, o), this._renderPointer(e2, n2, a, V, o, l2, c2, u, b2);
    }, t2.prototype._renderTicks = function(e2, n2, a, i, o, s, u, l2, c2) {
      for (var f2 = this.group, h = o.cx, v9 = o.cy, d2 = o.r, m2 = +e2.get("min"), b2 = +e2.get("max"), _ = e2.getModel("splitLine"), C = e2.getModel("axisTick"), M = e2.getModel("axisLabel"), E = e2.get("splitNumber"), z9 = C.get("splitNumber"), V = qr(_.get("length"), d2), $ = qr(C.get("length"), d2), U = s, H = (u - s) / E, q3 = H / z9, ee = _.getModel("lineStyle").getLineStyle(), oe = C.getModel("lineStyle").getLineStyle(), ne = _.get("distance"), be, Ee, ye = 0; ye <= E; ye++) {
        if (be = Math.cos(U), Ee = Math.sin(U), _.get("show")) {
          var et = ne ? ne + c2 : c2, Le = new bl({ shape: { x1: be * (d2 - et) + h, y1: Ee * (d2 - et) + v9, x2: be * (d2 - V - et) + h, y2: Ee * (d2 - V - et) + v9 }, style: ee, silent: true });
          ee.stroke === "auto" && Le.setStyle({ stroke: i(ye / E) }), f2.add(Le);
        }
        if (M.get("show")) {
          var et = M.get("distance") + ne, Fe = n5(Os(ye / E * (b2 - m2) + m2), M.get("formatter")), qe = i(ye / E);
          f2.add(new xi({ style: Hs(M, { text: Fe, x: be * (d2 - V - et) + h, y: Ee * (d2 - V - et) + v9, verticalAlign: Ee < -0.8 ? "top" : Ee > 0.8 ? "bottom" : "middle", align: be < -0.4 ? "left" : be > 0.4 ? "right" : "center" }, { inheritColor: qe }), silent: true }));
        }
        if (C.get("show") && ye !== E) {
          var et = C.get("distance");
          et = et ? et + c2 : c2;
          for (var st = 0; st <= z9; st++) {
            be = Math.cos(U), Ee = Math.sin(U);
            var dt = new bl({ shape: { x1: be * (d2 - et) + h, y1: Ee * (d2 - et) + v9, x2: be * (d2 - $ - et) + h, y2: Ee * (d2 - $ - et) + v9 }, silent: true, style: oe });
            oe.stroke === "auto" && dt.setStyle({ stroke: i((ye + st / z9) / E) }), f2.add(dt), U += q3;
          }
          U -= q3;
        } else
          U += H;
      }
    }, t2.prototype._renderPointer = function(e2, n2, a, i, o, s, u, l2, c2) {
      var f2 = this.group, h = this._data, v9 = this._progressEls, d2 = [], m2 = e2.get(["pointer", "show"]), b2 = e2.getModel("progress"), _ = b2.get("show"), C = e2.getData(), M = C.mapDimension("value"), E = +e2.get("min"), z9 = +e2.get("max"), V = [E, z9], $ = [s, u];
      function U(q3, ee) {
        var oe = C.getItemModel(q3), ne = oe.getModel("pointer"), be = qr(ne.get("width"), o.r), Ee = qr(ne.get("length"), o.r), ye = e2.get(["pointer", "icon"]), et = ne.get("offsetCenter"), Le = qr(et[0], o.r), Fe = qr(et[1], o.r), qe = ne.get("keepAspect"), st;
        return ye ? st = cu(ye, Le - be / 2, Fe - Ee, be, Ee, null, qe) : st = new Rye({ shape: { angle: -Math.PI / 2, width: be, r: Ee, x: Le, y: Fe } }), st.rotation = -(ee + Math.PI / 2), st.x = o.cx, st.y = o.cy, st;
      }
      function H(q3, ee) {
        var oe = b2.get("roundCap"), ne = oe ? bP : pf, be = b2.get("overlap"), Ee = be ? b2.get("width") : c2 / C.count(), ye = be ? o.r - Ee : o.r - (q3 + 1) * Ee, et = be ? o.r : o.r - q3 * Ee, Le = new ne({ shape: { startAngle: s, endAngle: ee, cx: o.cx, cy: o.cy, clockwise: l2, r0: ye, r: et } });
        return be && (Le.z2 = z9 - C.get(M, q3) % z9), Le;
      }
      (_ || m2) && (C.diff(h).add(function(q3) {
        var ee = C.get(M, q3);
        if (m2) {
          var oe = U(q3, s);
          rs(oe, { rotation: -((isNaN(+ee) ? $[0] : Gi(ee, V, $, true)) + Math.PI / 2) }, e2), f2.add(oe), C.setItemGraphicEl(q3, oe);
        }
        if (_) {
          var ne = H(q3, s), be = b2.get("clip");
          rs(ne, { shape: { endAngle: Gi(ee, V, $, be) } }, e2), f2.add(ne), n4(e2.seriesIndex, C.dataType, q3, ne), d2[q3] = ne;
        }
      }).update(function(q3, ee) {
        var oe = C.get(M, q3);
        if (m2) {
          var ne = h.getItemGraphicEl(ee), be = ne ? ne.rotation : s, Ee = U(q3, be);
          Ee.rotation = be, ci(Ee, { rotation: -((isNaN(+oe) ? $[0] : Gi(oe, V, $, true)) + Math.PI / 2) }, e2), f2.add(Ee), C.setItemGraphicEl(q3, Ee);
        }
        if (_) {
          var ye = v9[ee], et = ye ? ye.shape.endAngle : s, Le = H(q3, et), Fe = b2.get("clip");
          ci(Le, { shape: { endAngle: Gi(oe, V, $, Fe) } }, e2), f2.add(Le), n4(e2.seriesIndex, C.dataType, q3, Le), d2[q3] = Le;
        }
      }).execute(), C.each(function(q3) {
        var ee = C.getItemModel(q3), oe = ee.getModel("emphasis"), ne = oe.get("focus"), be = oe.get("blurScope"), Ee = oe.get("disabled");
        if (m2) {
          var ye = C.getItemGraphicEl(q3), et = C.getItemVisual(q3, "style"), Le = et.fill;
          if (ye instanceof Bl) {
            var Fe = ye.style;
            ye.useStyle(qt({ image: Fe.image, x: Fe.x, y: Fe.y, width: Fe.width, height: Fe.height }, et));
          } else
            ye.useStyle(et), ye.type !== "pointer" && ye.setColor(Le);
          ye.setStyle(ee.getModel(["pointer", "itemStyle"]).getItemStyle()), ye.style.fill === "auto" && ye.setStyle("fill", i(Gi(C.get(M, q3), V, [0, 1], true))), ye.z2EmphasisLift = 0, jl(ye, ee), ks(ye, ne, be, Ee);
        }
        if (_) {
          var qe = d2[q3];
          qe.useStyle(C.getItemVisual(q3, "style")), qe.setStyle(ee.getModel(["progress", "itemStyle"]).getItemStyle()), qe.z2EmphasisLift = 0, jl(qe, ee), ks(qe, ne, be, Ee);
        }
      }), this._progressEls = d2);
    }, t2.prototype._renderAnchor = function(e2, n2) {
      var a = e2.getModel("anchor"), i = a.get("show");
      if (i) {
        var o = a.get("size"), s = a.get("icon"), u = a.get("offsetCenter"), l2 = a.get("keepAspect"), c2 = cu(s, n2.cx - o / 2 + qr(u[0], n2.r), n2.cy - o / 2 + qr(u[1], n2.r), o, o, null, l2);
        c2.z2 = a.get("showAbove") ? 1 : 0, c2.setStyle(a.getModel("itemStyle").getItemStyle()), this.group.add(c2);
      }
    }, t2.prototype._renderTitleAndDetail = function(e2, n2, a, i, o) {
      var s = this, u = e2.getData(), l2 = u.mapDimension("value"), c2 = +e2.get("min"), f2 = +e2.get("max"), h = new Fn(), v9 = [], d2 = [], m2 = e2.isAnimationEnabled(), b2 = e2.get(["pointer", "showAbove"]);
      u.diff(this._data).add(function(_) {
        v9[_] = new xi({ silent: true }), d2[_] = new xi({ silent: true });
      }).update(function(_, C) {
        v9[_] = s._titleEls[C], d2[_] = s._detailEls[C];
      }).execute(), u.each(function(_) {
        var C = u.getItemModel(_), M = u.get(l2, _), E = new Fn(), z9 = i(Gi(M, [c2, f2], [0, 1], true)), V = C.getModel("title");
        if (V.get("show")) {
          var $ = V.get("offsetCenter"), U = o.cx + qr($[0], o.r), H = o.cy + qr($[1], o.r), q3 = v9[_];
          q3.attr({ z2: b2 ? 0 : 2, style: Hs(V, { x: U, y: H, text: u.getName(_), align: "center", verticalAlign: "middle" }, { inheritColor: z9 }) }), E.add(q3);
        }
        var ee = C.getModel("detail");
        if (ee.get("show")) {
          var oe = ee.get("offsetCenter"), ne = o.cx + qr(oe[0], o.r), be = o.cy + qr(oe[1], o.r), Ee = qr(ee.get("width"), o.r), ye = qr(ee.get("height"), o.r), et = e2.get(["progress", "show"]) ? u.getItemVisual(_, "style").fill : z9, q3 = d2[_], Le = ee.get("formatter");
          q3.attr({ z2: b2 ? 0 : 2, style: Hs(ee, { x: ne, y: be, text: n5(M, Le), width: isNaN(Ee) ? null : Ee, height: isNaN(ye) ? null : ye, align: "center", verticalAlign: "middle" }, { inheritColor: et }) }), UU(q3, { normal: ee }, M, function(qe) {
            return n5(qe, Le);
          }), m2 && HU(q3, _, u, e2, { getFormattedLabel: function(qe, st, dt, Ar, Hr, hn) {
            return n5(hn ? hn.interpolatedValue : M, Le);
          } }), E.add(q3);
        }
        h.add(E);
      }), this.group.add(h), this._titleEls = v9, this._detailEls = d2;
    }, t2.type = "gauge", t2;
  }(Mo), Vye = Nye, jye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.visualStyleAccessPath = "itemStyle", e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return Ew(this, ["value"]);
    }, t2.type = "series.gauge", t2.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, t2;
  }(ns), Bye = jye;
  function zye(r2) {
    r2.registerChartView(Vye), r2.registerSeriesModel(Bye);
  }
  var $ye = ["itemStyle", "opacity"], Gye = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      var a = r2.call(this) || this, i = a, o = new yf(), s = new xi();
      return i.setTextContent(s), a.setTextGuideLine(o), a.updateData(e2, n2, true), a;
    }
    return t2.prototype.updateData = function(e2, n2, a) {
      var i = this, o = e2.hostModel, s = e2.getItemModel(n2), u = e2.getItemLayout(n2), l2 = s.getModel("emphasis"), c2 = s.get($ye);
      c2 = c2 == null ? 1 : c2, a || Wv(i), i.useStyle(e2.getItemVisual(n2, "style")), i.style.lineJoin = "round", a ? (i.setShape({ points: u.points }), i.style.opacity = 0, rs(i, { style: { opacity: c2 } }, o, n2)) : ci(i, { style: { opacity: c2 }, shape: { points: u.points } }, o, n2), jl(i, s), this._updateLabel(e2, n2), ks(this, l2.get("focus"), l2.get("blurScope"), l2.get("disabled"));
    }, t2.prototype._updateLabel = function(e2, n2) {
      var a = this, i = this.getTextGuideLine(), o = a.getTextContent(), s = e2.hostModel, u = e2.getItemModel(n2), l2 = e2.getItemLayout(n2), c2 = l2.label, f2 = e2.getItemVisual(n2, "style"), h = f2.fill;
      fc(o, _l(u), { labelFetcher: e2.hostModel, labelDataIndex: n2, defaultOpacity: f2.opacity, defaultText: e2.getName(n2) }, { normal: { align: c2.textAlign, verticalAlign: c2.verticalAlign } }), a.setTextConfig({ local: true, inside: !!c2.inside, insideStroke: h, outsideFill: h });
      var v9 = c2.linePoints;
      i.setShape({ points: v9 }), a.textGuideLineConfig = { anchor: v9 ? new Jn(v9[0][0], v9[0][1]) : null }, ci(o, { style: { x: c2.x, y: c2.y } }, s, n2), o.attr({ rotation: c2.rotation, originX: c2.x, originY: c2.y, z2: 10 }), NF(a, VF(u), { stroke: h });
    }, t2;
  }(gf), Wye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.ignoreLabelLineUpdate = true, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this._data, s = this.group;
      i.diff(o).add(function(u) {
        var l2 = new Gye(i, u);
        i.setItemGraphicEl(u, l2), s.add(l2);
      }).update(function(u, l2) {
        var c2 = o.getItemGraphicEl(l2);
        c2.updateData(i, u), s.add(c2), i.setItemGraphicEl(u, c2);
      }).remove(function(u) {
        var l2 = o.getItemGraphicEl(u);
        aE(l2, e2, u);
      }).execute(), this._data = i;
    }, t2.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, t2.prototype.dispose = function() {
    }, t2.type = "funnel", t2;
  }(Mo), Uye = Wye, Hye = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2) {
      r2.prototype.init.apply(this, arguments), this.legendVisualProvider = new HE(en(this.getData, this), en(this.getRawData, this)), this._defaultLabelLine(e2);
    }, t2.prototype.getInitialData = function(e2, n2) {
      return Ew(this, { coordDimensions: ["value"], encodeDefaulter: Gn(vF, this) });
    }, t2.prototype._defaultLabelLine = function(e2) {
      Qb(e2, "labelLine", ["show"]);
      var n2 = e2.labelLine, a = e2.emphasis.labelLine;
      n2.show = n2.show && e2.label.show, a.show = a.show && e2.emphasis.label.show;
    }, t2.prototype.getDataParams = function(e2) {
      var n2 = this.getData(), a = r2.prototype.getDataParams.call(this, e2), i = n2.mapDimension("value"), o = n2.getSum(i);
      return a.percent = o ? +(n2.get(i, e2) / o * 100).toFixed(2) : 0, a.$vars.push("percent"), a;
    }, t2.type = "series.funnel", t2.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, t2;
  }(ns), qye = Hye;
  function Yye(r2, t2) {
    return Eu(r2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() });
  }
  function Kye(r2, t2) {
    for (var e2 = r2.mapDimension("value"), n2 = r2.mapArray(e2, function(u) {
      return u;
    }), a = [], i = t2 === "ascending", o = 0, s = r2.count(); o < s; o++)
      a[o] = o;
    return xn(t2) ? a.sort(t2) : t2 !== "none" && a.sort(function(u, l2) {
      return i ? n2[u] - n2[l2] : n2[l2] - n2[u];
    }), a;
  }
  function Zye(r2) {
    var t2 = r2.hostModel, e2 = t2.get("orient");
    r2.each(function(n2) {
      var a = r2.getItemModel(n2), i = a.getModel("label"), o = i.get("position"), s = a.getModel("labelLine"), u = r2.getItemLayout(n2), l2 = u.points, c2 = o === "inner" || o === "inside" || o === "center" || o === "insideLeft" || o === "insideRight", f2, h, v9, d2;
      if (c2)
        o === "insideLeft" ? (h = (l2[0][0] + l2[3][0]) / 2 + 5, v9 = (l2[0][1] + l2[3][1]) / 2, f2 = "left") : o === "insideRight" ? (h = (l2[1][0] + l2[2][0]) / 2 - 5, v9 = (l2[1][1] + l2[2][1]) / 2, f2 = "right") : (h = (l2[0][0] + l2[1][0] + l2[2][0] + l2[3][0]) / 4, v9 = (l2[0][1] + l2[1][1] + l2[2][1] + l2[3][1]) / 4, f2 = "center"), d2 = [[h, v9], [h, v9]];
      else {
        var m2 = void 0, b2 = void 0, _ = void 0, C = void 0, M = s.get("length");
        o === "left" ? (m2 = (l2[3][0] + l2[0][0]) / 2, b2 = (l2[3][1] + l2[0][1]) / 2, _ = m2 - M, h = _ - 5, f2 = "right") : o === "right" ? (m2 = (l2[1][0] + l2[2][0]) / 2, b2 = (l2[1][1] + l2[2][1]) / 2, _ = m2 + M, h = _ + 5, f2 = "left") : o === "top" ? (m2 = (l2[3][0] + l2[0][0]) / 2, b2 = (l2[3][1] + l2[0][1]) / 2, C = b2 - M, v9 = C - 5, f2 = "center") : o === "bottom" ? (m2 = (l2[1][0] + l2[2][0]) / 2, b2 = (l2[1][1] + l2[2][1]) / 2, C = b2 + M, v9 = C + 5, f2 = "center") : o === "rightTop" ? (m2 = e2 === "horizontal" ? l2[3][0] : l2[1][0], b2 = e2 === "horizontal" ? l2[3][1] : l2[1][1], e2 === "horizontal" ? (C = b2 - M, v9 = C - 5, f2 = "center") : (_ = m2 + M, h = _ + 5, f2 = "top")) : o === "rightBottom" ? (m2 = l2[2][0], b2 = l2[2][1], e2 === "horizontal" ? (C = b2 + M, v9 = C + 5, f2 = "center") : (_ = m2 + M, h = _ + 5, f2 = "bottom")) : o === "leftTop" ? (m2 = l2[0][0], b2 = e2 === "horizontal" ? l2[0][1] : l2[1][1], e2 === "horizontal" ? (C = b2 - M, v9 = C - 5, f2 = "center") : (_ = m2 - M, h = _ - 5, f2 = "right")) : o === "leftBottom" ? (m2 = e2 === "horizontal" ? l2[1][0] : l2[3][0], b2 = e2 === "horizontal" ? l2[1][1] : l2[2][1], e2 === "horizontal" ? (C = b2 + M, v9 = C + 5, f2 = "center") : (_ = m2 - M, h = _ - 5, f2 = "right")) : (m2 = (l2[1][0] + l2[2][0]) / 2, b2 = (l2[1][1] + l2[2][1]) / 2, e2 === "horizontal" ? (C = b2 + M, v9 = C + 5, f2 = "center") : (_ = m2 + M, h = _ + 5, f2 = "left")), e2 === "horizontal" ? (_ = m2, h = _) : (C = b2, v9 = C), d2 = [[m2, b2], [_, C]];
      }
      u.label = { linePoints: d2, x: h, y: v9, verticalAlign: "middle", textAlign: f2, inside: c2 };
    });
  }
  function Xye(r2, t2) {
    r2.eachSeriesByType("funnel", function(e2) {
      var n2 = e2.getData(), a = n2.mapDimension("value"), i = e2.get("sort"), o = Yye(e2, t2), s = e2.get("orient"), u = o.width, l2 = o.height, c2 = Kye(n2, i), f2 = o.x, h = o.y, v9 = s === "horizontal" ? [qr(e2.get("minSize"), l2), qr(e2.get("maxSize"), l2)] : [qr(e2.get("minSize"), u), qr(e2.get("maxSize"), u)], d2 = n2.getDataExtent(a), m2 = e2.get("min"), b2 = e2.get("max");
      m2 == null && (m2 = Math.min(d2[0], 0)), b2 == null && (b2 = d2[1]);
      var _ = e2.get("funnelAlign"), C = e2.get("gap"), M = s === "horizontal" ? u : l2, E = (M - C * (n2.count() - 1)) / n2.count(), z9 = function(be, Ee) {
        if (s === "horizontal") {
          var ye = n2.get(a, be) || 0, et = Gi(ye, [m2, b2], v9, true), Le = void 0;
          switch (_) {
            case "top":
              Le = h;
              break;
            case "center":
              Le = h + (l2 - et) / 2;
              break;
            case "bottom":
              Le = h + (l2 - et);
              break;
          }
          return [[Ee, Le], [Ee, Le + et]];
        }
        var Fe = n2.get(a, be) || 0, qe = Gi(Fe, [m2, b2], v9, true), st;
        switch (_) {
          case "left":
            st = f2;
            break;
          case "center":
            st = f2 + (u - qe) / 2;
            break;
          case "right":
            st = f2 + u - qe;
            break;
        }
        return [[st, Ee], [st + qe, Ee]];
      };
      i === "ascending" && (E = -E, C = -C, s === "horizontal" ? f2 += u : h += l2, c2 = c2.reverse());
      for (var V = 0; V < c2.length; V++) {
        var $ = c2[V], U = c2[V + 1], H = n2.getItemModel($);
        if (s === "horizontal") {
          var q3 = H.get(["itemStyle", "width"]);
          q3 == null ? q3 = E : (q3 = qr(q3, u), i === "ascending" && (q3 = -q3));
          var ee = z9($, f2), oe = z9(U, f2 + q3);
          f2 += q3 + C, n2.setItemLayout($, { points: ee.concat(oe.slice().reverse()) });
        } else {
          var ne = H.get(["itemStyle", "height"]);
          ne == null ? ne = E : (ne = qr(ne, l2), i === "ascending" && (ne = -ne));
          var ee = z9($, h), oe = z9(U, h + ne);
          h += ne + C, n2.setItemLayout($, { points: ee.concat(oe.slice().reverse()) });
        }
      }
      Zye(n2);
    });
  }
  function Jye(r2) {
    r2.registerChartView(Uye), r2.registerSeriesModel(qye), r2.registerLayout(Xye), r2.registerProcessor(UE("funnel"));
  }
  var Qye = 0.3, eme = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._dataGroup = new Fn(), e2._initialized = false, e2;
    }
    return t2.prototype.init = function() {
      this.group.add(this._dataGroup);
    }, t2.prototype.render = function(e2, n2, a, i) {
      this._progressiveEls = null;
      var o = this._dataGroup, s = e2.getData(), u = this._data, l2 = e2.coordinateSystem, c2 = l2.dimensions, f2 = qB(e2);
      s.diff(u).add(h).update(v9).remove(d2).execute();
      function h(b2) {
        var _ = HB(s, o, b2, c2, l2);
        Vk(_, s, b2, f2);
      }
      function v9(b2, _) {
        var C = u.getItemGraphicEl(_), M = wK(s, b2, c2, l2);
        s.setItemGraphicEl(b2, C), ci(C, { shape: { points: M } }, e2, b2), Wv(C), Vk(C, s, b2, f2);
      }
      function d2(b2) {
        var _ = u.getItemGraphicEl(b2);
        o.remove(_);
      }
      if (!this._initialized) {
        this._initialized = true;
        var m2 = tme(l2, e2, function() {
          setTimeout(function() {
            o.removeClipPath();
          });
        });
        o.setClipPath(m2);
      }
      this._data = s;
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      this._initialized = true, this._data = null, this._dataGroup.removeAll();
    }, t2.prototype.incrementalRender = function(e2, n2, a) {
      for (var i = n2.getData(), o = n2.coordinateSystem, s = o.dimensions, u = qB(n2), l2 = this._progressiveEls = [], c2 = e2.start; c2 < e2.end; c2++) {
        var f2 = HB(i, this._dataGroup, c2, s, o);
        f2.incremental = true, Vk(f2, i, c2, u), l2.push(f2);
      }
    }, t2.prototype.remove = function() {
      this._dataGroup && this._dataGroup.removeAll(), this._data = null;
    }, t2.type = "parallel", t2;
  }(Mo);
  function tme(r2, t2, e2) {
    var n2 = r2.model, a = r2.getRect(), i = new ni({ shape: { x: a.x, y: a.y, width: a.width, height: a.height } }), o = n2.get("layout") === "horizontal" ? "width" : "height";
    return i.setShape(o, 0), rs(i, { shape: { width: a.width, height: a.height } }, t2, e2), i;
  }
  function wK(r2, t2, e2, n2) {
    for (var a = [], i = 0; i < e2.length; i++) {
      var o = e2[i], s = r2.get(r2.mapDimension(o), t2);
      rme(s, n2.getAxis(o).type) || a.push(n2.dataToPoint(s, o));
    }
    return a;
  }
  function HB(r2, t2, e2, n2, a) {
    var i = wK(r2, e2, n2, a), o = new yf({ shape: { points: i }, z2: 10 });
    return t2.add(o), r2.setItemGraphicEl(e2, o), o;
  }
  function qB(r2) {
    var t2 = r2.get("smooth", true);
    return t2 === true && (t2 = Qye), t2 = Pg(t2), XC(t2) && (t2 = 0), { smooth: t2 };
  }
  function Vk(r2, t2, e2, n2) {
    r2.useStyle(t2.getItemVisual(e2, "style")), r2.style.fill = null, r2.setShape("smooth", n2.smooth);
    var a = t2.getItemModel(e2), i = a.getModel("emphasis");
    jl(r2, a, "lineStyle"), ks(r2, i.get("focus"), i.get("blurScope"), i.get("disabled"));
  }
  function rme(r2, t2) {
    return t2 === "category" ? r2 == null : r2 == null || isNaN(r2);
  }
  var nme = eme, ame = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this, { useEncodeDefaulter: en(ime, null, this) });
    }, t2.prototype.getRawIndicesByActiveState = function(e2) {
      var n2 = this.coordinateSystem, a = this.getData(), i = [];
      return n2.eachActiveState(a, function(o, s) {
        e2 === o && i.push(a.getRawIndex(s));
      }), i;
    }, t2.type = "series.parallel", t2.dependencies = ["parallel"], t2.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, t2;
  }(ns);
  function ime(r2) {
    var t2 = r2.ecModel.getComponent("parallel", r2.get("parallelIndex"));
    if (!!t2) {
      var e2 = {};
      return ae(t2.dimensions, function(n2) {
        var a = ome(n2);
        e2[n2] = a;
      }), e2;
    }
  }
  function ome(r2) {
    return +r2.replace("dim", "");
  }
  var sme = ame, ume = ["lineStyle", "opacity"], lme = { seriesType: "parallel", reset: function(r2, t2) {
    var e2 = r2.coordinateSystem, n2 = { normal: r2.get(["lineStyle", "opacity"]), active: r2.get("activeOpacity"), inactive: r2.get("inactiveOpacity") };
    return { progress: function(a, i) {
      e2.eachActiveState(i, function(o, s) {
        var u = n2[o];
        if (o === "normal" && i.hasItemOption) {
          var l2 = i.getItemModel(s).get(ume, true);
          l2 != null && (u = l2);
        }
        var c2 = i.ensureUniqueItemVisual(s, "style");
        c2.opacity = u;
      }, a.start, a.end);
    } };
  } }, cme = lme;
  function fme(r2) {
    hme(r2), vme(r2);
  }
  function hme(r2) {
    if (!r2.parallel) {
      var t2 = false;
      ae(r2.series, function(e2) {
        e2 && e2.type === "parallel" && (t2 = true);
      }), t2 && (r2.parallel = [{}]);
    }
  }
  function vme(r2) {
    var t2 = ao(r2.parallelAxis);
    ae(t2, function(e2) {
      if (!!Tn(e2)) {
        var n2 = e2.parallelIndex || 0, a = ao(r2.parallel)[n2];
        a && a.parallelAxisDefault && ea(e2, a.parallelAxisDefault, false);
      }
    });
  }
  var dme = 5, pme = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      this._model = e2, this._api = a, this._handlers || (this._handlers = {}, ae(gme, function(i, o) {
        a.getZr().on(o, this._handlers[o] = en(i, this));
      }, this)), Sw(this, "_throttledDispatchExpand", e2.get("axisExpandRate"), "fixRate");
    }, t2.prototype.dispose = function(e2, n2) {
      lE(this, "_throttledDispatchExpand"), ae(this._handlers, function(a, i) {
        n2.getZr().off(i, a);
      }), this._handlers = null;
    }, t2.prototype._throttledDispatchExpand = function(e2) {
      this._dispatchExpand(e2);
    }, t2.prototype._dispatchExpand = function(e2) {
      e2 && this._api.dispatchAction(qt({ type: "parallelAxisExpand" }, e2));
    }, t2.type = "parallel", t2;
  }(gs), gme = { mousedown: function(r2) {
    jk(this, "click") && (this._mouseDownPoint = [r2.offsetX, r2.offsetY]);
  }, mouseup: function(r2) {
    var t2 = this._mouseDownPoint;
    if (jk(this, "click") && t2) {
      var e2 = [r2.offsetX, r2.offsetY], n2 = Math.pow(t2[0] - e2[0], 2) + Math.pow(t2[1] - e2[1], 2);
      if (n2 > dme)
        return;
      var a = this._model.coordinateSystem.getSlidedAxisExpandWindow([r2.offsetX, r2.offsetY]);
      a.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: a.axisExpandWindow });
    }
    this._mouseDownPoint = null;
  }, mousemove: function(r2) {
    if (!(this._mouseDownPoint || !jk(this, "mousemove"))) {
      var t2 = this._model, e2 = t2.coordinateSystem.getSlidedAxisExpandWindow([r2.offsetX, r2.offsetY]), n2 = e2.behavior;
      n2 === "jump" && this._throttledDispatchExpand.debounceNextCall(t2.get("axisExpandDebounce")), this._throttledDispatchExpand(n2 === "none" ? null : { axisExpandWindow: e2.axisExpandWindow, animation: n2 === "jump" ? null : { duration: 0 } });
    }
  } };
  function jk(r2, t2) {
    var e2 = r2._model;
    return e2.get("axisExpandable") && e2.get("axisExpandTriggerOn") === t2;
  }
  var yme = pme, mme = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function() {
      r2.prototype.init.apply(this, arguments), this.mergeOption({});
    }, t2.prototype.mergeOption = function(e2) {
      var n2 = this.option;
      e2 && ea(n2, e2, true), this._initDimensions();
    }, t2.prototype.contains = function(e2, n2) {
      var a = e2.get("parallelIndex");
      return a != null && n2.getComponent("parallel", a) === this;
    }, t2.prototype.setAxisExpand = function(e2) {
      ae(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(n2) {
        e2.hasOwnProperty(n2) && (this.option[n2] = e2[n2]);
      }, this);
    }, t2.prototype._initDimensions = function() {
      var e2 = this.dimensions = [], n2 = this.parallelAxisIndex = [], a = no(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(i) {
        return (i.get("parallelIndex") || 0) === this.componentIndex;
      }, this);
      ae(a, function(i) {
        e2.push("dim" + i.get("dim")), n2.push(i.componentIndex);
      });
    }, t2.type = "parallel", t2.dependencies = ["parallelAxis"], t2.layoutMode = "box", t2.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, t2;
  }(li), bme = mme, _me = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i, o) {
      var s = r2.call(this, e2, n2, a) || this;
      return s.type = i || "value", s.axisIndex = o, s;
    }
    return t2.prototype.isHorizontal = function() {
      return this.coordinateSystem.getModel().get("layout") !== "horizontal";
    }, t2;
  }(Hv), xme = _me;
  function f1(r2, t2, e2, n2, a, i) {
    r2 = r2 || 0;
    var o = e2[1] - e2[0];
    if (a != null && (a = Mx(a, [0, o])), i != null && (i = Math.max(i, a != null ? a : 0)), n2 === "all") {
      var s = Math.abs(t2[1] - t2[0]);
      s = Mx(s, [0, o]), a = i = Mx(s, [a, i]), n2 = 0;
    }
    t2[0] = Mx(t2[0], e2), t2[1] = Mx(t2[1], e2);
    var u = Bk(t2, n2);
    t2[n2] += r2;
    var l2 = a || 0, c2 = e2.slice();
    u.sign < 0 ? c2[0] += l2 : c2[1] -= l2, t2[n2] = Mx(t2[n2], c2);
    var f2;
    return f2 = Bk(t2, n2), a != null && (f2.sign !== u.sign || f2.span < a) && (t2[1 - n2] = t2[n2] + u.sign * a), f2 = Bk(t2, n2), i != null && f2.span > i && (t2[1 - n2] = t2[n2] + f2.sign * i), t2;
  }
  function Bk(r2, t2) {
    var e2 = r2[t2] - r2[1 - t2];
    return { span: Math.abs(e2), sign: e2 > 0 ? -1 : e2 < 0 ? 1 : t2 ? -1 : 1 };
  }
  function Mx(r2, t2) {
    return Math.min(t2[1] != null ? t2[1] : 1 / 0, Math.max(t2[0] != null ? t2[0] : -1 / 0, r2));
  }
  var zk = ae, SK = Math.min, CK = Math.max, YB = Math.floor, wme = Math.ceil, KB = Os, Sme = Math.PI, Cme = function() {
    function r2(t2, e2, n2) {
      this.type = "parallel", this._axesMap = mn(), this._axesLayout = {}, this.dimensions = t2.dimensions, this._model = t2, this._init(t2, e2, n2);
    }
    return r2.prototype._init = function(t2, e2, n2) {
      var a = t2.dimensions, i = t2.parallelAxisIndex;
      zk(a, function(o, s) {
        var u = i[s], l2 = e2.getComponent("parallelAxis", u), c2 = this._axesMap.set(o, new xme(o, m3(l2), [0, 0], l2.get("type"), u)), f2 = c2.type === "category";
        c2.onBand = f2 && l2.get("boundaryGap"), c2.inverse = l2.get("inverse"), l2.axis = c2, c2.model = l2, c2.coordinateSystem = l2.coordinateSystem = this;
      }, this);
    }, r2.prototype.update = function(t2, e2) {
      this._updateAxesFromSeries(this._model, t2);
    }, r2.prototype.containPoint = function(t2) {
      var e2 = this._makeLayoutInfo(), n2 = e2.axisBase, a = e2.layoutBase, i = e2.pixelDimIndex, o = t2[1 - i], s = t2[i];
      return o >= n2 && o <= n2 + e2.axisLength && s >= a && s <= a + e2.layoutLength;
    }, r2.prototype.getModel = function() {
      return this._model;
    }, r2.prototype._updateAxesFromSeries = function(t2, e2) {
      e2.eachSeries(function(n2) {
        if (!!t2.contains(n2, e2)) {
          var a = n2.getData();
          zk(this.dimensions, function(i) {
            var o = this._axesMap.get(i);
            o.scale.unionExtentFromData(a, a.mapDimension(i)), aw(o.scale, o.model);
          }, this);
        }
      }, this);
    }, r2.prototype.resize = function(t2, e2) {
      this._rect = Eu(t2.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), this._layoutAxes();
    }, r2.prototype.getRect = function() {
      return this._rect;
    }, r2.prototype._makeLayoutInfo = function() {
      var t2 = this._model, e2 = this._rect, n2 = ["x", "y"], a = ["width", "height"], i = t2.get("layout"), o = i === "horizontal" ? 0 : 1, s = e2[a[o]], u = [0, s], l2 = this.dimensions.length, c2 = a5(t2.get("axisExpandWidth"), u), f2 = a5(t2.get("axisExpandCount") || 0, [0, l2]), h = t2.get("axisExpandable") && l2 > 3 && l2 > f2 && f2 > 1 && c2 > 0 && s > 0, v9 = t2.get("axisExpandWindow"), d2;
      if (v9)
        d2 = a5(v9[1] - v9[0], u), v9[1] = v9[0] + d2;
      else {
        d2 = a5(c2 * (f2 - 1), u);
        var m2 = t2.get("axisExpandCenter") || YB(l2 / 2);
        v9 = [c2 * m2 - d2 / 2], v9[1] = v9[0] + d2;
      }
      var b2 = (s - d2) / (l2 - f2);
      b2 < 3 && (b2 = 0);
      var _ = [YB(KB(v9[0] / c2, 1)) + 1, wme(KB(v9[1] / c2, 1)) - 1], C = b2 / c2 * v9[0];
      return { layout: i, pixelDimIndex: o, layoutBase: e2[n2[o]], layoutLength: s, axisBase: e2[n2[1 - o]], axisLength: e2[a[1 - o]], axisExpandable: h, axisExpandWidth: c2, axisCollapseWidth: b2, axisExpandWindow: v9, axisCount: l2, winInnerIndices: _, axisExpandWindow0Pos: C };
    }, r2.prototype._layoutAxes = function() {
      var t2 = this._rect, e2 = this._axesMap, n2 = this.dimensions, a = this._makeLayoutInfo(), i = a.layout;
      e2.each(function(o) {
        var s = [0, a.axisLength], u = o.inverse ? 1 : 0;
        o.setExtent(s[u], s[1 - u]);
      }), zk(n2, function(o, s) {
        var u = (a.axisExpandable ? Ame : Eme)(s, a), l2 = { horizontal: { x: u.position, y: a.axisLength }, vertical: { x: 0, y: u.position } }, c2 = { horizontal: Sme / 2, vertical: 0 }, f2 = [l2[i].x + t2.x, l2[i].y + t2.y], h = c2[i], v9 = Hh();
        s1(v9, v9, h), ep(v9, v9, f2), this._axesLayout[o] = { position: f2, rotation: h, transform: v9, axisNameAvailableWidth: u.axisNameAvailableWidth, axisLabelShow: u.axisLabelShow, nameTruncateMaxWidth: u.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
      }, this);
    }, r2.prototype.getAxis = function(t2) {
      return this._axesMap.get(t2);
    }, r2.prototype.dataToPoint = function(t2, e2) {
      return this.axisCoordToPoint(this._axesMap.get(e2).dataToCoord(t2), e2);
    }, r2.prototype.eachActiveState = function(t2, e2, n2, a) {
      n2 == null && (n2 = 0), a == null && (a = t2.count());
      var i = this._axesMap, o = this.dimensions, s = [], u = [];
      ae(o, function(b2) {
        s.push(t2.mapDimension(b2)), u.push(i.get(b2).model);
      });
      for (var l2 = this.hasAxisBrushed(), c2 = n2; c2 < a; c2++) {
        var f2 = void 0;
        if (!l2)
          f2 = "normal";
        else {
          f2 = "active";
          for (var h = t2.getValues(s, c2), v9 = 0, d2 = o.length; v9 < d2; v9++) {
            var m2 = u[v9].getActiveState(h[v9]);
            if (m2 === "inactive") {
              f2 = "inactive";
              break;
            }
          }
        }
        e2(f2, c2);
      }
    }, r2.prototype.hasAxisBrushed = function() {
      for (var t2 = this.dimensions, e2 = this._axesMap, n2 = false, a = 0, i = t2.length; a < i; a++)
        e2.get(t2[a]).model.getActiveState() !== "normal" && (n2 = true);
      return n2;
    }, r2.prototype.axisCoordToPoint = function(t2, e2) {
      var n2 = this._axesLayout[e2];
      return $v([t2, 0], n2.transform);
    }, r2.prototype.getAxisLayout = function(t2) {
      return On(this._axesLayout[t2]);
    }, r2.prototype.getSlidedAxisExpandWindow = function(t2) {
      var e2 = this._makeLayoutInfo(), n2 = e2.pixelDimIndex, a = e2.axisExpandWindow.slice(), i = a[1] - a[0], o = [0, e2.axisExpandWidth * (e2.axisCount - 1)];
      if (!this.containPoint(t2))
        return { behavior: "none", axisExpandWindow: a };
      var s = t2[n2] - e2.layoutBase - e2.axisExpandWindow0Pos, u, l2 = "slide", c2 = e2.axisCollapseWidth, f2 = this._model.get("axisExpandSlideTriggerArea"), h = f2[0] != null;
      if (c2)
        h && c2 && s < i * f2[0] ? (l2 = "jump", u = s - i * f2[2]) : h && c2 && s > i * (1 - f2[0]) ? (l2 = "jump", u = s - i * (1 - f2[2])) : (u = s - i * f2[1]) >= 0 && (u = s - i * (1 - f2[1])) <= 0 && (u = 0), u *= e2.axisExpandWidth / c2, u ? f1(u, a, o, "all") : l2 = "none";
      else {
        var v9 = a[1] - a[0], d2 = o[1] * s / v9;
        a = [CK(0, d2 - v9 / 2)], a[1] = SK(o[1], a[0] + v9), a[0] = a[1] - v9;
      }
      return { axisExpandWindow: a, behavior: l2 };
    }, r2;
  }();
  function a5(r2, t2) {
    return SK(CK(r2, t2[0]), t2[1]);
  }
  function Eme(r2, t2) {
    var e2 = t2.layoutLength / (t2.axisCount - 1);
    return { position: e2 * r2, axisNameAvailableWidth: e2, axisLabelShow: true };
  }
  function Ame(r2, t2) {
    var e2 = t2.layoutLength, n2 = t2.axisExpandWidth, a = t2.axisCount, i = t2.axisCollapseWidth, o = t2.winInnerIndices, s, u = i, l2 = false, c2;
    return r2 < o[0] ? (s = r2 * i, c2 = i) : r2 <= o[1] ? (s = t2.axisExpandWindow0Pos + r2 * n2 - t2.axisExpandWindow[0], u = n2, l2 = true) : (s = e2 - (a - 1 - r2) * i, c2 = i), { position: s, axisNameAvailableWidth: u, axisLabelShow: l2, nameTruncateMaxWidth: c2 };
  }
  var Tme = Cme;
  function Mme(r2, t2) {
    var e2 = [];
    return r2.eachComponent("parallel", function(n2, a) {
      var i = new Tme(n2, r2, t2);
      i.name = "parallel_" + a, i.resize(n2, t2), n2.coordinateSystem = i, i.model = n2, e2.push(i);
    }), r2.eachSeries(function(n2) {
      if (n2.get("coordinateSystem") === "parallel") {
        var a = n2.getReferringComponents("parallel", uu).models[0];
        n2.coordinateSystem = a.coordinateSystem;
      }
    }), e2;
  }
  var Pme = { create: Mme }, Dme = Pme, EK = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.activeIntervals = [], e2;
    }
    return t2.prototype.getAreaSelectStyle = function() {
      return t1([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
    }, t2.prototype.setActiveIntervals = function(e2) {
      var n2 = this.activeIntervals = On(e2);
      if (n2)
        for (var a = n2.length - 1; a >= 0; a--)
          $h(n2[a]);
    }, t2.prototype.getActiveState = function(e2) {
      var n2 = this.activeIntervals;
      if (!n2.length)
        return "normal";
      if (e2 == null || isNaN(+e2))
        return "inactive";
      if (n2.length === 1) {
        var a = n2[0];
        if (a[0] <= e2 && e2 <= a[1])
          return "active";
      } else
        for (var i = 0, o = n2.length; i < o; i++)
          if (n2[i][0] <= e2 && e2 <= n2[i][1])
            return "active";
      return "inactive";
    }, t2;
  }(li);
  fu(EK, zE);
  var ZB = EK, a1 = true, xE = Math.min, sw = Math.max, Ime = Math.pow, Lme = 1e4, Ome = 6, kme = 6, XB = "globalPan", Rme = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, Fme = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, JB = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, Nme = 0, Vme = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this) || this;
      return n2._track = [], n2._covers = [], n2._handlers = {}, n2._zr = e2, n2.group = new Fn(), n2._uid = "brushController_" + Nme++, ae(Ume, function(a, i) {
        this._handlers[i] = en(a, this);
      }, n2), n2;
    }
    return t2.prototype.enableBrush = function(e2) {
      return this._brushType && this._doDisableBrush(), e2.brushType && this._doEnableBrush(e2), this;
    }, t2.prototype._doEnableBrush = function(e2) {
      var n2 = this._zr;
      this._enableGlobalPan || Ype(n2, XB, this._uid), ae(this._handlers, function(a, i) {
        n2.on(i, a);
      }), this._brushType = e2.brushType, this._brushOption = ea(On(JB), e2, true);
    }, t2.prototype._doDisableBrush = function() {
      var e2 = this._zr;
      Kpe(e2, XB, this._uid), ae(this._handlers, function(n2, a) {
        e2.off(a, n2);
      }), this._brushType = this._brushOption = null;
    }, t2.prototype.setPanels = function(e2) {
      if (e2 && e2.length) {
        var n2 = this._panels = {};
        ae(e2, function(a) {
          n2[a.panelId] = On(a);
        });
      } else
        this._panels = null;
      return this;
    }, t2.prototype.mount = function(e2) {
      e2 = e2 || {}, this._enableGlobalPan = e2.enableGlobalPan;
      var n2 = this.group;
      return this._zr.add(n2), n2.attr({ x: e2.x || 0, y: e2.y || 0, rotation: e2.rotation || 0, scaleX: e2.scaleX || 1, scaleY: e2.scaleY || 1 }), this._transform = n2.getLocalTransform(), this;
    }, t2.prototype.updateCovers = function(e2) {
      e2 = pr(e2, function(h) {
        return ea(On(JB), h, true);
      });
      var n2 = "\0-brush-index-", a = this._covers, i = this._covers = [], o = this, s = this._creatingCover;
      return new Dg(a, e2, l2, u).add(c2).update(c2).remove(f2).execute(), this;
      function u(h, v9) {
        return (h.id != null ? h.id : n2 + v9) + "-" + h.brushType;
      }
      function l2(h, v9) {
        return u(h.__brushOption, v9);
      }
      function c2(h, v9) {
        var d2 = e2[h];
        if (v9 != null && a[v9] === s)
          i[h] = a[v9];
        else {
          var m2 = i[h] = v9 != null ? (a[v9].__brushOption = d2, a[v9]) : TK(o, AK(o, d2));
          aN(o, m2);
        }
      }
      function f2(h) {
        a[h] !== s && o.group.remove(a[h]);
      }
    }, t2.prototype.unmount = function() {
      return this.enableBrush(false), H4(this), this._zr.remove(this.group), this;
    }, t2.prototype.dispose = function() {
      this.unmount(), this.off();
    }, t2;
  }(Yh);
  function AK(r2, t2) {
    var e2 = E3[t2.brushType].createCover(r2, t2);
    return e2.__brushOption = t2, PK(e2, t2), r2.group.add(e2), e2;
  }
  function TK(r2, t2) {
    var e2 = iN(t2);
    return e2.endCreating && (e2.endCreating(r2, t2), PK(t2, t2.__brushOption)), t2;
  }
  function MK(r2, t2) {
    var e2 = t2.__brushOption;
    iN(t2).updateCoverShape(r2, t2, e2.range, e2);
  }
  function PK(r2, t2) {
    var e2 = t2.z;
    e2 == null && (e2 = Lme), r2.traverse(function(n2) {
      n2.z = e2, n2.z2 = e2;
    });
  }
  function aN(r2, t2) {
    iN(t2).updateCommon(r2, t2), MK(r2, t2);
  }
  function iN(r2) {
    return E3[r2.__brushOption.brushType];
  }
  function oN(r2, t2, e2) {
    var n2 = r2._panels;
    if (!n2)
      return a1;
    var a, i = r2._transform;
    return ae(n2, function(o) {
      o.isTargetByCursor(t2, e2, i) && (a = o);
    }), a;
  }
  function DK(r2, t2) {
    var e2 = r2._panels;
    if (!e2)
      return a1;
    var n2 = t2.__brushOption.panelId;
    return n2 != null ? e2[n2] : a1;
  }
  function H4(r2) {
    var t2 = r2._covers, e2 = t2.length;
    return ae(t2, function(n2) {
      r2.group.remove(n2);
    }, r2), t2.length = 0, !!e2;
  }
  function i1(r2, t2) {
    var e2 = pr(r2._covers, function(n2) {
      var a = n2.__brushOption, i = On(a.range);
      return { brushType: a.brushType, panelId: a.panelId, range: i };
    });
    r2.trigger("brush", { areas: e2, isEnd: !!t2.isEnd, removeOnClick: !!t2.removeOnClick });
  }
  function jme(r2) {
    var t2 = r2._track;
    if (!t2.length)
      return false;
    var e2 = t2[t2.length - 1], n2 = t2[0], a = e2[0] - n2[0], i = e2[1] - n2[1], o = Ime(a * a + i * i, 0.5);
    return o > Ome;
  }
  function IK(r2) {
    var t2 = r2.length - 1;
    return t2 < 0 && (t2 = 0), [r2[0], r2[t2]];
  }
  function LK(r2, t2, e2, n2) {
    var a = new Fn();
    return a.add(new ni({ name: "main", style: sN(e2), silent: true, draggable: true, cursor: "move", drift: Gn(QB, r2, t2, a, ["n", "s", "w", "e"]), ondragend: Gn(i1, t2, { isEnd: true }) })), ae(n2, function(i) {
      a.add(new ni({ name: i.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: Gn(QB, r2, t2, a, i), ondragend: Gn(i1, t2, { isEnd: true }) }));
    }), a;
  }
  function OK(r2, t2, e2, n2) {
    var a = n2.brushStyle.lineWidth || 0, i = sw(a, kme), o = e2[0][0], s = e2[1][0], u = o - a / 2, l2 = s - a / 2, c2 = e2[0][1], f2 = e2[1][1], h = c2 - i + a / 2, v9 = f2 - i + a / 2, d2 = c2 - o, m2 = f2 - s, b2 = d2 + a, _ = m2 + a;
    dg(r2, t2, "main", o, s, d2, m2), n2.transformable && (dg(r2, t2, "w", u, l2, i, _), dg(r2, t2, "e", h, l2, i, _), dg(r2, t2, "n", u, l2, b2, i), dg(r2, t2, "s", u, v9, b2, i), dg(r2, t2, "nw", u, l2, i, i), dg(r2, t2, "ne", h, l2, i, i), dg(r2, t2, "sw", u, v9, i, i), dg(r2, t2, "se", h, v9, i, i));
  }
  function q4(r2, t2) {
    var e2 = t2.__brushOption, n2 = e2.transformable, a = t2.childAt(0);
    a.useStyle(sN(e2)), a.attr({ silent: !n2, cursor: n2 ? "move" : "default" }), ae([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(i) {
      var o = t2.childOfName(i.join("")), s = i.length === 1 ? Y4(r2, i[0]) : zme(r2, i);
      o && o.attr({ silent: !n2, invisible: !n2, cursor: n2 ? Fme[s] + "-resize" : null });
    });
  }
  function dg(r2, t2, e2, n2, a, i, o) {
    var s = t2.childOfName(e2);
    s && s.setShape(Gme(uN(r2, t2, [[n2, a], [n2 + i, a + o]])));
  }
  function sN(r2) {
    return En({ strokeNoScale: true }, r2.brushStyle);
  }
  function kK(r2, t2, e2, n2) {
    var a = [xE(r2, e2), xE(t2, n2)], i = [sw(r2, e2), sw(t2, n2)];
    return [[a[0], i[0]], [a[1], i[1]]];
  }
  function Bme(r2) {
    return Yb(r2.group);
  }
  function Y4(r2, t2) {
    var e2 = { w: "left", e: "right", n: "top", s: "bottom" }, n2 = { left: "w", right: "e", top: "n", bottom: "s" }, a = n3(e2[t2], Bme(r2));
    return n2[a];
  }
  function zme(r2, t2) {
    var e2 = [Y4(r2, t2[0]), Y4(r2, t2[1])];
    return (e2[0] === "e" || e2[0] === "w") && e2.reverse(), e2.join("");
  }
  function QB(r2, t2, e2, n2, a, i) {
    var o = e2.__brushOption, s = r2.toRectRange(o.range), u = RK(t2, a, i);
    ae(n2, function(l2) {
      var c2 = Rme[l2];
      s[c2[0]][c2[1]] += u[c2[0]];
    }), o.range = r2.fromRectRange(kK(s[0][0], s[1][0], s[0][1], s[1][1])), aN(t2, e2), i1(t2, { isEnd: false });
  }
  function $me(r2, t2, e2, n2) {
    var a = t2.__brushOption.range, i = RK(r2, e2, n2);
    ae(a, function(o) {
      o[0] += i[0], o[1] += i[1];
    }), aN(r2, t2), i1(r2, { isEnd: false });
  }
  function RK(r2, t2, e2) {
    var n2 = r2.group, a = n2.transformCoordToLocal(t2, e2), i = n2.transformCoordToLocal(0, 0);
    return [a[0] - i[0], a[1] - i[1]];
  }
  function uN(r2, t2, e2) {
    var n2 = DK(r2, t2);
    return n2 && n2 !== a1 ? n2.clipPath(e2, r2._transform) : On(e2);
  }
  function Gme(r2) {
    var t2 = xE(r2[0][0], r2[1][0]), e2 = xE(r2[0][1], r2[1][1]), n2 = sw(r2[0][0], r2[1][0]), a = sw(r2[0][1], r2[1][1]);
    return { x: t2, y: e2, width: n2 - t2, height: a - e2 };
  }
  function Wme(r2, t2, e2) {
    if (!(!r2._brushType || Hme(r2, t2.offsetX, t2.offsetY))) {
      var n2 = r2._zr, a = r2._covers, i = oN(r2, t2, e2);
      if (!r2._dragging)
        for (var o = 0; o < a.length; o++) {
          var s = a[o].__brushOption;
          if (i && (i === a1 || s.panelId === i.panelId) && E3[s.brushType].contain(a[o], e2[0], e2[1]))
            return;
        }
      i && n2.setCursorStyle("crosshair");
    }
  }
  function K4(r2) {
    var t2 = r2.event;
    t2.preventDefault && t2.preventDefault();
  }
  function Z4(r2, t2, e2) {
    return r2.childOfName("main").contain(t2, e2);
  }
  function FK(r2, t2, e2, n2) {
    var a = r2._creatingCover, i = r2._creatingPanel, o = r2._brushOption, s;
    if (r2._track.push(e2.slice()), jme(r2) || a) {
      if (i && !a) {
        o.brushMode === "single" && H4(r2);
        var u = On(o);
        u.brushType = ez(u.brushType, i), u.panelId = i === a1 ? null : i.panelId, a = r2._creatingCover = AK(r2, u), r2._covers.push(a);
      }
      if (a) {
        var l2 = E3[ez(r2._brushType, i)], c2 = a.__brushOption;
        c2.range = l2.getCreatingRange(uN(r2, a, r2._track)), n2 && (TK(r2, a), l2.updateCommon(r2, a)), MK(r2, a), s = { isEnd: n2 };
      }
    } else
      n2 && o.brushMode === "single" && o.removeOnClick && oN(r2, t2, e2) && H4(r2) && (s = { isEnd: n2, removeOnClick: true });
    return s;
  }
  function ez(r2, t2) {
    return r2 === "auto" ? t2.defaultBrushType : r2;
  }
  var Ume = { mousedown: function(r2) {
    if (this._dragging)
      tz(this, r2);
    else if (!r2.target || !r2.target.draggable) {
      K4(r2);
      var t2 = this.group.transformCoordToLocal(r2.offsetX, r2.offsetY);
      this._creatingCover = null;
      var e2 = this._creatingPanel = oN(this, r2, t2);
      e2 && (this._dragging = true, this._track = [t2.slice()]);
    }
  }, mousemove: function(r2) {
    var t2 = r2.offsetX, e2 = r2.offsetY, n2 = this.group.transformCoordToLocal(t2, e2);
    if (Wme(this, r2, n2), this._dragging) {
      K4(r2);
      var a = FK(this, r2, n2, false);
      a && i1(this, a);
    }
  }, mouseup: function(r2) {
    tz(this, r2);
  } };
  function tz(r2, t2) {
    if (r2._dragging) {
      K4(t2);
      var e2 = t2.offsetX, n2 = t2.offsetY, a = r2.group.transformCoordToLocal(e2, n2), i = FK(r2, t2, a, true);
      r2._dragging = false, r2._track = [], r2._creatingCover = null, i && i1(r2, i);
    }
  }
  function Hme(r2, t2, e2) {
    var n2 = r2._zr;
    return t2 < 0 || t2 > n2.getWidth() || e2 < 0 || e2 > n2.getHeight();
  }
  var E3 = { lineX: rz(0), lineY: rz(1), rect: { createCover: function(r2, t2) {
    function e2(n2) {
      return n2;
    }
    return LK({ toRectRange: e2, fromRectRange: e2 }, r2, t2, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
  }, getCreatingRange: function(r2) {
    var t2 = IK(r2);
    return kK(t2[1][0], t2[1][1], t2[0][0], t2[0][1]);
  }, updateCoverShape: function(r2, t2, e2, n2) {
    OK(r2, t2, e2, n2);
  }, updateCommon: q4, contain: Z4 }, polygon: { createCover: function(r2, t2) {
    var e2 = new Fn();
    return e2.add(new yf({ name: "main", style: sN(t2), silent: true })), e2;
  }, getCreatingRange: function(r2) {
    return r2;
  }, endCreating: function(r2, t2) {
    t2.remove(t2.childAt(0)), t2.add(new gf({ name: "main", draggable: true, drift: Gn($me, r2, t2), ondragend: Gn(i1, r2, { isEnd: true }) }));
  }, updateCoverShape: function(r2, t2, e2, n2) {
    t2.childAt(0).setShape({ points: uN(r2, t2, e2) });
  }, updateCommon: q4, contain: Z4 } };
  function rz(r2) {
    return { createCover: function(t2, e2) {
      return LK({ toRectRange: function(n2) {
        var a = [n2, [0, 100]];
        return r2 && a.reverse(), a;
      }, fromRectRange: function(n2) {
        return n2[r2];
      } }, t2, e2, [[["w"], ["e"]], [["n"], ["s"]]][r2]);
    }, getCreatingRange: function(t2) {
      var e2 = IK(t2), n2 = xE(e2[0][r2], e2[1][r2]), a = sw(e2[0][r2], e2[1][r2]);
      return [n2, a];
    }, updateCoverShape: function(t2, e2, n2, a) {
      var i, o = DK(t2, e2);
      if (o !== a1 && o.getLinearBrushOtherExtent)
        i = o.getLinearBrushOtherExtent(r2);
      else {
        var s = t2._zr;
        i = [0, [s.getWidth(), s.getHeight()][1 - r2]];
      }
      var u = [n2, i];
      r2 && u.reverse(), OK(t2, e2, u, a);
    }, updateCommon: q4, contain: Z4 };
  }
  var lN = Vme;
  function NK(r2) {
    return r2 = cN(r2), function(t2) {
      return zU(t2, r2);
    };
  }
  function VK(r2, t2) {
    return r2 = cN(r2), function(e2) {
      var n2 = t2 != null ? t2 : e2, a = n2 ? r2.width : r2.height, i = n2 ? r2.x : r2.y;
      return [i, i + (a || 0)];
    };
  }
  function jK(r2, t2, e2) {
    var n2 = cN(r2);
    return function(a, i) {
      return n2.contain(i[0], i[1]) && !x3(a, t2, e2);
    };
  }
  function cN(r2) {
    return da.create(r2);
  }
  var qme = ["axisLine", "axisTickLabel", "axisName"], Yme = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      r2.prototype.init.apply(this, arguments), (this._brushController = new lN(n2.getZr())).on("brush", en(this._onBrush, this));
    }, t2.prototype.render = function(e2, n2, a, i) {
      if (!Kme(e2, n2, i)) {
        this.axisModel = e2, this.api = a, this.group.removeAll();
        var o = this._axisGroup;
        if (this._axisGroup = new Fn(), this.group.add(this._axisGroup), !!e2.get("show")) {
          var s = Xme(e2, n2), u = s.coordinateSystem, l2 = e2.getAreaSelectStyle(), c2 = l2.width, f2 = e2.axis.dim, h = u.getAxisLayout(f2), v9 = qt({ strokeContainThreshold: c2 }, h), d2 = new Ig(e2, v9);
          ae(qme, d2.add, d2), this._axisGroup.add(d2.getGroup()), this._refreshBrushController(v9, l2, e2, s, c2, a), OE(o, this._axisGroup, e2);
        }
      }
    }, t2.prototype._refreshBrushController = function(e2, n2, a, i, o, s) {
      var u = a.axis.getExtent(), l2 = u[1] - u[0], c2 = Math.min(30, Math.abs(l2) * 0.1), f2 = da.create({ x: u[0], y: -o / 2, width: l2, height: o });
      f2.x -= c2, f2.width += 2 * c2, this._brushController.mount({ enableGlobalPan: true, rotation: e2.rotation, x: e2.position[0], y: e2.position[1] }).setPanels([{ panelId: "pl", clipPath: NK(f2), isTargetByCursor: jK(f2, s, i), getLinearBrushOtherExtent: VK(f2, 0) }]).enableBrush({ brushType: "lineX", brushStyle: n2, removeOnClick: true }).updateCovers(Zme(a));
    }, t2.prototype._onBrush = function(e2) {
      var n2 = e2.areas, a = this.axisModel, i = a.axis, o = pr(n2, function(s) {
        return [i.coordToData(s.range[0], true), i.coordToData(s.range[1], true)];
      });
      (!a.option.realtime === e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: a.id, intervals: o });
    }, t2.prototype.dispose = function() {
      this._brushController.dispose();
    }, t2.type = "parallelAxis", t2;
  }(gs);
  function Kme(r2, t2, e2) {
    return e2 && e2.type === "axisAreaSelect" && t2.findComponents({ mainType: "parallelAxis", query: e2 })[0] === r2;
  }
  function Zme(r2) {
    var t2 = r2.axis;
    return pr(r2.activeIntervals, function(e2) {
      return { brushType: "lineX", panelId: "pl", range: [t2.dataToCoord(e2[0], true), t2.dataToCoord(e2[1], true)] };
    });
  }
  function Xme(r2, t2) {
    return t2.getComponent("parallel", r2.get("parallelIndex"));
  }
  var Jme = Yme, Qme = { type: "axisAreaSelect", event: "axisAreaSelected" };
  function ebe(r2) {
    r2.registerAction(Qme, function(t2, e2) {
      e2.eachComponent({ mainType: "parallelAxis", query: t2 }, function(n2) {
        n2.axis.model.setActiveIntervals(t2.intervals);
      });
    }), r2.registerAction("parallelAxisExpand", function(t2, e2) {
      e2.eachComponent({ mainType: "parallel", query: t2 }, function(n2) {
        n2.setAxisExpand(t2);
      });
    });
  }
  var tbe = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
  function BK(r2) {
    r2.registerComponentView(yme), r2.registerComponentModel(bme), r2.registerCoordinateSystem("parallel", Dme), r2.registerPreprocessor(fme), r2.registerComponentModel(ZB), r2.registerComponentView(Jme), ow(r2, "parallel", ZB, tbe), ebe(r2);
  }
  function rbe(r2) {
    ya(BK), r2.registerChartView(nme), r2.registerSeriesModel(sme), r2.registerVisual(r2.PRIORITY.VISUAL.BRUSH, cme);
  }
  var nbe = function() {
    function r2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
    }
    return r2;
  }(), abe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      return r2.call(this, e2) || this;
    }
    return t2.prototype.getDefaultShape = function() {
      return new nbe();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.extent;
      e2.moveTo(n2.x1, n2.y1), e2.bezierCurveTo(n2.cpx1, n2.cpy1, n2.cpx2, n2.cpy2, n2.x2, n2.y2), n2.orient === "vertical" ? (e2.lineTo(n2.x2 + a, n2.y2), e2.bezierCurveTo(n2.cpx2 + a, n2.cpy2, n2.cpx1 + a, n2.cpy1, n2.x1 + a, n2.y1)) : (e2.lineTo(n2.x2, n2.y2 + a), e2.bezierCurveTo(n2.cpx2, n2.cpy2 + a, n2.cpx1, n2.cpy1 + a, n2.x1, n2.y1 + a)), e2.closePath();
    }, t2.prototype.highlight = function() {
      Kd(this);
    }, t2.prototype.downplay = function() {
      Zd(this);
    }, t2;
  }(xa), ibe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._focusAdjacencyDisabled = false, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = this, o = e2.getGraph(), s = this.group, u = e2.layoutInfo, l2 = u.width, c2 = u.height, f2 = e2.getData(), h = e2.getData("edge"), v9 = e2.get("orient");
      this._model = e2, s.removeAll(), s.x = u.x, s.y = u.y, o.eachEdge(function(d2) {
        var m2 = new abe(), b2 = zn(m2);
        b2.dataIndex = d2.dataIndex, b2.seriesIndex = e2.seriesIndex, b2.dataType = "edge";
        var _ = d2.getModel(), C = _.getModel("lineStyle"), M = C.get("curveness"), E = d2.node1.getLayout(), z9 = d2.node1.getModel(), V = z9.get("localX"), $ = z9.get("localY"), U = d2.node2.getLayout(), H = d2.node2.getModel(), q3 = H.get("localX"), ee = H.get("localY"), oe = d2.getLayout(), ne, be, Ee, ye, et, Le, Fe, qe;
        switch (m2.shape.extent = Math.max(1, oe.dy), m2.shape.orient = v9, v9 === "vertical" ? (ne = (V != null ? V * l2 : E.x) + oe.sy, be = ($ != null ? $ * c2 : E.y) + E.dy, Ee = (q3 != null ? q3 * l2 : U.x) + oe.ty, ye = ee != null ? ee * c2 : U.y, et = ne, Le = be * (1 - M) + ye * M, Fe = Ee, qe = be * M + ye * (1 - M)) : (ne = (V != null ? V * l2 : E.x) + E.dx, be = ($ != null ? $ * c2 : E.y) + oe.sy, Ee = q3 != null ? q3 * l2 : U.x, ye = (ee != null ? ee * c2 : U.y) + oe.ty, et = ne * (1 - M) + Ee * M, Le = be, Fe = ne * M + Ee * (1 - M), qe = ye), m2.setShape({ x1: ne, y1: be, x2: Ee, y2: ye, cpx1: et, cpy1: Le, cpx2: Fe, cpy2: qe }), m2.useStyle(C.getItemStyle()), m2.style.fill) {
          case "source":
            m2.style.fill = d2.node1.getVisual("color"), m2.style.decal = d2.node1.getVisual("style").decal;
            break;
          case "target":
            m2.style.fill = d2.node2.getVisual("color"), m2.style.decal = d2.node2.getVisual("style").decal;
            break;
          case "gradient":
            var st = d2.node1.getVisual("color"), dt = d2.node2.getVisual("color");
            Zr(st) && Zr(dt) && (m2.style.fill = new LE(0, 0, +(v9 === "horizontal"), +(v9 === "vertical"), [{ color: st, offset: 0 }, { color: dt, offset: 1 }]));
        }
        var Ar = _.getModel("emphasis");
        jl(m2, _, "lineStyle", function(hn) {
          return hn.getItemStyle();
        }), s.add(m2), h.setItemGraphicEl(d2.dataIndex, m2);
        var Hr = Ar.get("focus");
        ks(m2, Hr === "adjacency" ? d2.getAdjacentDataIndices() : Hr, Ar.get("blurScope"), Ar.get("disabled")), zn(m2).dataType = "edge";
      }), o.eachNode(function(d2) {
        var m2 = d2.getLayout(), b2 = d2.getModel(), _ = b2.get("localX"), C = b2.get("localY"), M = b2.getModel("emphasis"), E = new ni({ shape: { x: _ != null ? _ * l2 : m2.x, y: C != null ? C * c2 : m2.y, width: m2.dx, height: m2.dy }, style: b2.getModel("itemStyle").getItemStyle(), z2: 10 });
        fc(E, _l(b2), { labelFetcher: e2, labelDataIndex: d2.dataIndex, defaultText: d2.id }), E.disableLabelAnimation = true, E.setStyle("fill", d2.getVisual("color")), E.setStyle("decal", d2.getVisual("style").decal), jl(E, b2), s.add(E), f2.setItemGraphicEl(d2.dataIndex, E), zn(E).dataType = "node";
        var z9 = M.get("focus");
        ks(E, z9 === "adjacency" ? d2.getAdjacentDataIndices() : z9, M.get("blurScope"), M.get("disabled"));
      }), f2.eachItemGraphicEl(function(d2, m2) {
        var b2 = f2.getItemModel(m2);
        b2.get("draggable") && (d2.drift = function(_, C) {
          i._focusAdjacencyDisabled = true, this.shape.x += _, this.shape.y += C, this.dirty(), a.dispatchAction({ type: "dragNode", seriesId: e2.id, dataIndex: f2.getRawIndex(m2), localX: this.shape.x / l2, localY: this.shape.y / c2 });
        }, d2.ondragend = function() {
          i._focusAdjacencyDisabled = false;
        }, d2.draggable = true, d2.cursor = "move");
      }), !this._data && e2.isAnimationEnabled() && s.setClipPath(obe(s.getBoundingRect(), e2, function() {
        s.removeClipPath();
      })), this._data = e2.getData();
    }, t2.prototype.dispose = function() {
    }, t2.type = "sankey", t2;
  }(Mo);
  function obe(r2, t2, e2) {
    var n2 = new ni({ shape: { x: r2.x - 10, y: r2.y - 10, width: 0, height: r2.height + 20 } });
    return rs(n2, { shape: { width: r2.width + 20 } }, t2, e2), n2;
  }
  var sbe = ibe, ube = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      var a = e2.edges || e2.links, i = e2.data || e2.nodes, o = e2.levels;
      this.levelModels = [];
      for (var s = this.levelModels, u = 0; u < o.length; u++)
        o[u].depth != null && o[u].depth >= 0 && (s[o[u].depth] = new To(o[u], this, n2));
      if (i && a) {
        var l2 = xK(i, a, this, true, c2);
        return l2.data;
      }
      function c2(f2, h) {
        f2.wrapMethod("getItemModel", function(v9, d2) {
          var m2 = v9.parentModel, b2 = m2.getData().getItemLayout(d2);
          if (b2) {
            var _ = b2.depth, C = m2.levelModels[_];
            C && (v9.parentModel = C);
          }
          return v9;
        }), h.wrapMethod("getItemModel", function(v9, d2) {
          var m2 = v9.parentModel, b2 = m2.getGraph().getEdgeByIndex(d2), _ = b2.node1.getLayout();
          if (_) {
            var C = _.depth, M = m2.levelModels[C];
            M && (v9.parentModel = M);
          }
          return v9;
        });
      }
    }, t2.prototype.setNodePosition = function(e2, n2) {
      var a = this.option.data || this.option.nodes, i = a[e2];
      i.localX = n2[0], i.localY = n2[1];
    }, t2.prototype.getGraph = function() {
      return this.getData().graph;
    }, t2.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      function i(v9) {
        return isNaN(v9) || v9 == null;
      }
      if (a === "edge") {
        var o = this.getDataParams(e2, a), s = o.data, u = o.value, l2 = s.source + " -- " + s.target;
        return Hu("nameValue", { name: l2, value: u, noValue: i(u) });
      } else {
        var c2 = this.getGraph().getNodeByIndex(e2), f2 = c2.getLayout().value, h = this.getDataParams(e2, a).data.name;
        return Hu("nameValue", { name: h != null ? h + "" : null, value: f2, noValue: i(f2) });
      }
    }, t2.prototype.optionUpdated = function() {
    }, t2.prototype.getDataParams = function(e2, n2) {
      var a = r2.prototype.getDataParams.call(this, e2, n2);
      if (a.value == null && n2 === "node") {
        var i = this.getGraph().getNodeByIndex(e2), o = i.getLayout().value;
        a.value = o;
      }
      return a;
    }, t2.type = "series.sankey", t2.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, t2;
  }(ns), lbe = ube;
  function cbe(r2, t2) {
    r2.eachSeriesByType("sankey", function(e2) {
      var n2 = e2.get("nodeWidth"), a = e2.get("nodeGap"), i = fbe(e2, t2);
      e2.layoutInfo = i;
      var o = i.width, s = i.height, u = e2.getGraph(), l2 = u.nodes, c2 = u.edges;
      vbe(l2);
      var f2 = no(l2, function(m2) {
        return m2.getLayout().value === 0;
      }), h = f2.length !== 0 ? 0 : e2.get("layoutIterations"), v9 = e2.get("orient"), d2 = e2.get("nodeAlign");
      hbe(l2, c2, n2, a, o, s, h, v9, d2);
    });
  }
  function fbe(r2, t2) {
    return Eu(r2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() });
  }
  function hbe(r2, t2, e2, n2, a, i, o, s, u) {
    dbe(r2, t2, e2, a, i, s, u), mbe(r2, t2, i, a, n2, o, s), Tbe(r2, s);
  }
  function vbe(r2) {
    ae(r2, function(t2) {
      var e2 = py(t2.outEdges, EP), n2 = py(t2.inEdges, EP), a = t2.getValue() || 0, i = Math.max(e2, n2, a);
      t2.setLayout({ value: i }, true);
    });
  }
  function dbe(r2, t2, e2, n2, a, i, o) {
    for (var s = [], u = [], l2 = [], c2 = [], f2 = 0, h = 0; h < t2.length; h++)
      s[h] = 1;
    for (var h = 0; h < r2.length; h++)
      u[h] = r2[h].inEdges.length, u[h] === 0 && l2.push(r2[h]);
    for (var v9 = -1; l2.length; ) {
      for (var d2 = 0; d2 < l2.length; d2++) {
        var m2 = l2[d2], b2 = m2.hostGraph.data.getRawDataItem(m2.dataIndex), _ = b2.depth != null && b2.depth >= 0;
        _ && b2.depth > v9 && (v9 = b2.depth), m2.setLayout({ depth: _ ? b2.depth : f2 }, true), i === "vertical" ? m2.setLayout({ dy: e2 }, true) : m2.setLayout({ dx: e2 }, true);
        for (var C = 0; C < m2.outEdges.length; C++) {
          var M = m2.outEdges[C], E = t2.indexOf(M);
          s[E] = 0;
          var z9 = M.node2, V = r2.indexOf(z9);
          --u[V] === 0 && c2.indexOf(z9) < 0 && c2.push(z9);
        }
      }
      ++f2, l2 = c2, c2 = [];
    }
    for (var h = 0; h < s.length; h++)
      if (s[h] === 1)
        throw new Error("Sankey is a DAG, the original data has cycle!");
    var $ = v9 > f2 - 1 ? v9 : f2 - 1;
    o && o !== "left" && pbe(r2, o, i, $);
    var U = i === "vertical" ? (a - e2) / $ : (n2 - e2) / $;
    ybe(r2, U, i);
  }
  function zK(r2) {
    var t2 = r2.hostGraph.data.getRawDataItem(r2.dataIndex);
    return t2.depth != null && t2.depth >= 0;
  }
  function pbe(r2, t2, e2, n2) {
    if (t2 === "right") {
      for (var a = [], i = r2, o = 0; i.length; ) {
        for (var s = 0; s < i.length; s++) {
          var u = i[s];
          u.setLayout({ skNodeHeight: o }, true);
          for (var l2 = 0; l2 < u.inEdges.length; l2++) {
            var c2 = u.inEdges[l2];
            a.indexOf(c2.node1) < 0 && a.push(c2.node1);
          }
        }
        i = a, a = [], ++o;
      }
      ae(r2, function(f2) {
        zK(f2) || f2.setLayout({ depth: Math.max(0, n2 - f2.getLayout().skNodeHeight) }, true);
      });
    } else
      t2 === "justify" && gbe(r2, n2);
  }
  function gbe(r2, t2) {
    ae(r2, function(e2) {
      !zK(e2) && !e2.outEdges.length && e2.setLayout({ depth: t2 }, true);
    });
  }
  function ybe(r2, t2, e2) {
    ae(r2, function(n2) {
      var a = n2.getLayout().depth * t2;
      e2 === "vertical" ? n2.setLayout({ y: a }, true) : n2.setLayout({ x: a }, true);
    });
  }
  function mbe(r2, t2, e2, n2, a, i, o) {
    var s = bbe(r2, o);
    _be(s, t2, e2, n2, a, o), $k(s, a, e2, n2, o);
    for (var u = 1; i > 0; i--)
      u *= 0.99, xbe(s, u, o), $k(s, a, e2, n2, o), Abe(s, u, o), $k(s, a, e2, n2, o);
  }
  function bbe(r2, t2) {
    var e2 = [], n2 = t2 === "vertical" ? "y" : "x", a = QR(r2, function(i) {
      return i.getLayout()[n2];
    });
    return a.keys.sort(function(i, o) {
      return i - o;
    }), ae(a.keys, function(i) {
      e2.push(a.buckets.get(i));
    }), e2;
  }
  function _be(r2, t2, e2, n2, a, i) {
    var o = 1 / 0;
    ae(r2, function(s) {
      var u = s.length, l2 = 0;
      ae(s, function(f2) {
        l2 += f2.getLayout().value;
      });
      var c2 = i === "vertical" ? (n2 - (u - 1) * a) / l2 : (e2 - (u - 1) * a) / l2;
      c2 < o && (o = c2);
    }), ae(r2, function(s) {
      ae(s, function(u, l2) {
        var c2 = u.getLayout().value * o;
        i === "vertical" ? (u.setLayout({ x: l2 }, true), u.setLayout({ dx: c2 }, true)) : (u.setLayout({ y: l2 }, true), u.setLayout({ dy: c2 }, true));
      });
    }), ae(t2, function(s) {
      var u = +s.getValue() * o;
      s.setLayout({ dy: u }, true);
    });
  }
  function $k(r2, t2, e2, n2, a) {
    var i = a === "vertical" ? "x" : "y";
    ae(r2, function(o) {
      o.sort(function(m2, b2) {
        return m2.getLayout()[i] - b2.getLayout()[i];
      });
      for (var s, u, l2, c2 = 0, f2 = o.length, h = a === "vertical" ? "dx" : "dy", v9 = 0; v9 < f2; v9++)
        u = o[v9], l2 = c2 - u.getLayout()[i], l2 > 0 && (s = u.getLayout()[i] + l2, a === "vertical" ? u.setLayout({ x: s }, true) : u.setLayout({ y: s }, true)), c2 = u.getLayout()[i] + u.getLayout()[h] + t2;
      var d2 = a === "vertical" ? n2 : e2;
      if (l2 = c2 - t2 - d2, l2 > 0) {
        s = u.getLayout()[i] - l2, a === "vertical" ? u.setLayout({ x: s }, true) : u.setLayout({ y: s }, true), c2 = s;
        for (var v9 = f2 - 2; v9 >= 0; --v9)
          u = o[v9], l2 = u.getLayout()[i] + u.getLayout()[h] + t2 - c2, l2 > 0 && (s = u.getLayout()[i] - l2, a === "vertical" ? u.setLayout({ x: s }, true) : u.setLayout({ y: s }, true)), c2 = u.getLayout()[i];
      }
    });
  }
  function xbe(r2, t2, e2) {
    ae(r2.slice().reverse(), function(n2) {
      ae(n2, function(a) {
        if (a.outEdges.length) {
          var i = py(a.outEdges, wbe, e2) / py(a.outEdges, EP);
          if (isNaN(i)) {
            var o = a.outEdges.length;
            i = o ? py(a.outEdges, Sbe, e2) / o : 0;
          }
          if (e2 === "vertical") {
            var s = a.getLayout().x + (i - wy(a, e2)) * t2;
            a.setLayout({ x: s }, true);
          } else {
            var u = a.getLayout().y + (i - wy(a, e2)) * t2;
            a.setLayout({ y: u }, true);
          }
        }
      });
    });
  }
  function wbe(r2, t2) {
    return wy(r2.node2, t2) * r2.getValue();
  }
  function Sbe(r2, t2) {
    return wy(r2.node2, t2);
  }
  function Cbe(r2, t2) {
    return wy(r2.node1, t2) * r2.getValue();
  }
  function Ebe(r2, t2) {
    return wy(r2.node1, t2);
  }
  function wy(r2, t2) {
    return t2 === "vertical" ? r2.getLayout().x + r2.getLayout().dx / 2 : r2.getLayout().y + r2.getLayout().dy / 2;
  }
  function EP(r2) {
    return r2.getValue();
  }
  function py(r2, t2, e2) {
    for (var n2 = 0, a = r2.length, i = -1; ++i < a; ) {
      var o = +t2(r2[i], e2);
      isNaN(o) || (n2 += o);
    }
    return n2;
  }
  function Abe(r2, t2, e2) {
    ae(r2, function(n2) {
      ae(n2, function(a) {
        if (a.inEdges.length) {
          var i = py(a.inEdges, Cbe, e2) / py(a.inEdges, EP);
          if (isNaN(i)) {
            var o = a.inEdges.length;
            i = o ? py(a.inEdges, Ebe, e2) / o : 0;
          }
          if (e2 === "vertical") {
            var s = a.getLayout().x + (i - wy(a, e2)) * t2;
            a.setLayout({ x: s }, true);
          } else {
            var u = a.getLayout().y + (i - wy(a, e2)) * t2;
            a.setLayout({ y: u }, true);
          }
        }
      });
    });
  }
  function Tbe(r2, t2) {
    var e2 = t2 === "vertical" ? "x" : "y";
    ae(r2, function(n2) {
      n2.outEdges.sort(function(a, i) {
        return a.node2.getLayout()[e2] - i.node2.getLayout()[e2];
      }), n2.inEdges.sort(function(a, i) {
        return a.node1.getLayout()[e2] - i.node1.getLayout()[e2];
      });
    }), ae(r2, function(n2) {
      var a = 0, i = 0;
      ae(n2.outEdges, function(o) {
        o.setLayout({ sy: a }, true), a += o.getLayout().dy;
      }), ae(n2.inEdges, function(o) {
        o.setLayout({ ty: i }, true), i += o.getLayout().dy;
      });
    });
  }
  function Mbe(r2) {
    r2.eachSeriesByType("sankey", function(t2) {
      var e2 = t2.getGraph(), n2 = e2.nodes;
      if (n2.length) {
        var a = 1 / 0, i = -1 / 0;
        ae(n2, function(o) {
          var s = o.getLayout().value;
          s < a && (a = s), s > i && (i = s);
        }), ae(n2, function(o) {
          var s = new Vl({ type: "color", mappingMethod: "linear", dataExtent: [a, i], visual: t2.get("color") }), u = s.mapValueToVisual(o.getLayout().value), l2 = o.getModel().get(["itemStyle", "color"]);
          l2 != null ? (o.setVisual("color", l2), o.setVisual("style", { fill: l2 })) : (o.setVisual("color", u), o.setVisual("style", { fill: u }));
        });
      }
    });
  }
  function Pbe(r2) {
    r2.registerChartView(sbe), r2.registerSeriesModel(lbe), r2.registerLayout(cbe), r2.registerVisual(Mbe), r2.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(t2, e2) {
      e2.eachComponent({ mainType: "series", subType: "sankey", query: t2 }, function(n2) {
        n2.setNodePosition(t2.dataIndex, [t2.localX, t2.localY]);
      });
    });
  }
  var $K = function() {
    function r2() {
    }
    return r2.prototype.getInitialData = function(t2, e2) {
      var n2, a = e2.getComponent("xAxis", this.get("xAxisIndex")), i = e2.getComponent("yAxis", this.get("yAxisIndex")), o = a.get("type"), s = i.get("type"), u;
      o === "category" ? (t2.layout = "horizontal", n2 = a.getOrdinalMeta(), u = true) : s === "category" ? (t2.layout = "vertical", n2 = i.getOrdinalMeta(), u = true) : t2.layout = t2.layout || "horizontal";
      var l2 = ["x", "y"], c2 = t2.layout === "horizontal" ? 0 : 1, f2 = this._baseAxisDim = l2[c2], h = l2[1 - c2], v9 = [a, i], d2 = v9[c2].get("type"), m2 = v9[1 - c2].get("type"), b2 = t2.data;
      if (b2 && u) {
        var _ = [];
        ae(b2, function(E, z9) {
          var V;
          vr(E) ? (V = E.slice(), E.unshift(z9)) : vr(E.value) ? (V = qt({}, E), V.value = V.value.slice(), E.value.unshift(z9)) : V = E, _.push(V);
        }), t2.data = _;
      }
      var C = this.defaultValueDimensions, M = [{ name: f2, type: vP(d2), ordinalMeta: n2, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: h, type: vP(m2), dimsDef: C.slice() }];
      return Ew(this, { coordDimensions: M, dimensionsCount: C.length + 1, encodeDefaulter: Gn(dH, M, this) });
    }, r2.prototype.getBaseAxis = function() {
      var t2 = this._baseAxisDim;
      return this.ecModel.getComponent(t2 + "Axis", this.get(t2 + "AxisIndex")).axis;
    }, r2;
  }(), GK = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], e2.visualDrawType = "stroke", e2;
    }
    return t2.type = "series.boxplot", t2.dependencies = ["xAxis", "yAxis", "grid"], t2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, t2;
  }(ns);
  fu(GK, $K, true);
  var Dbe = GK, Ibe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this.group, s = this._data;
      this._data || o.removeAll();
      var u = e2.get("layout") === "horizontal" ? 1 : 0;
      i.diff(s).add(function(l2) {
        if (i.hasValue(l2)) {
          var c2 = i.getItemLayout(l2), f2 = nz(c2, i, l2, u, true);
          i.setItemGraphicEl(l2, f2), o.add(f2);
        }
      }).update(function(l2, c2) {
        var f2 = s.getItemGraphicEl(c2);
        if (!i.hasValue(l2)) {
          o.remove(f2);
          return;
        }
        var h = i.getItemLayout(l2);
        f2 ? (Wv(f2), WK(h, f2, i, l2)) : f2 = nz(h, i, l2, u), o.add(f2), i.setItemGraphicEl(l2, f2);
      }).remove(function(l2) {
        var c2 = s.getItemGraphicEl(l2);
        c2 && o.remove(c2);
      }).execute(), this._data = i;
    }, t2.prototype.remove = function(e2) {
      var n2 = this.group, a = this._data;
      this._data = null, a && a.eachItemGraphicEl(function(i) {
        i && n2.remove(i);
      });
    }, t2.type = "boxplot", t2;
  }(Mo), Lbe = function() {
    function r2() {
    }
    return r2;
  }(), Obe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "boxplotBoxPath", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Lbe();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.points, i = 0;
      for (e2.moveTo(a[i][0], a[i][1]), i++; i < 4; i++)
        e2.lineTo(a[i][0], a[i][1]);
      for (e2.closePath(); i < a.length; i++)
        e2.moveTo(a[i][0], a[i][1]), i++, e2.lineTo(a[i][0], a[i][1]);
    }, t2;
  }(xa);
  function nz(r2, t2, e2, n2, a) {
    var i = r2.ends, o = new Obe({ shape: { points: a ? kbe(i, n2, r2) : i } });
    return WK(r2, o, t2, e2, a), o;
  }
  function WK(r2, t2, e2, n2, a) {
    var i = e2.hostModel, o = RE[a ? "initProps" : "updateProps"];
    o(t2, { shape: { points: r2.ends } }, i, n2), t2.useStyle(e2.getItemVisual(n2, "style")), t2.style.strokeNoScale = true, t2.z2 = 100;
    var s = e2.getItemModel(n2), u = s.getModel("emphasis");
    jl(t2, s), ks(t2, u.get("focus"), u.get("blurScope"), u.get("disabled"));
  }
  function kbe(r2, t2, e2) {
    return pr(r2, function(n2) {
      return n2 = n2.slice(), n2[t2] = e2.initBaseline, n2;
    });
  }
  var Rbe = Ibe;
  function Fbe(r2, t2) {
  }
  var UC = ae;
  function Nbe(r2) {
    var t2 = Vbe(r2);
    UC(t2, function(e2) {
      var n2 = e2.seriesModels;
      !n2.length || (jbe(e2), UC(n2, function(a, i) {
        Bbe(a, e2.boxOffsetList[i], e2.boxWidthList[i]);
      }));
    });
  }
  function Vbe(r2) {
    var t2 = [], e2 = [];
    return r2.eachSeriesByType("boxplot", function(n2) {
      var a = n2.getBaseAxis(), i = va(e2, a);
      i < 0 && (i = e2.length, e2[i] = a, t2[i] = { axis: a, seriesModels: [] }), t2[i].seriesModels.push(n2);
    }), t2;
  }
  function jbe(r2) {
    var t2 = r2.axis, e2 = r2.seriesModels, n2 = e2.length, a = r2.boxWidthList = [], i = r2.boxOffsetList = [], o = [], s;
    if (t2.type === "category")
      s = t2.getBandWidth();
    else {
      var u = 0;
      UC(e2, function(d2) {
        u = Math.max(u, d2.getData().count());
      });
      var l2 = t2.getExtent();
      s = Math.abs(l2[1] - l2[0]) / u;
    }
    UC(e2, function(d2) {
      var m2 = d2.get("boxWidth");
      vr(m2) || (m2 = [m2, m2]), o.push([qr(m2[0], s) || 0, qr(m2[1], s) || 0]);
    });
    var c2 = s * 0.8 - 2, f2 = c2 / n2 * 0.3, h = (c2 - f2 * (n2 - 1)) / n2, v9 = h / 2 - c2 / 2;
    UC(e2, function(d2, m2) {
      i.push(v9), v9 += f2 + h, a.push(Math.min(Math.max(h, o[m2][0]), o[m2][1]));
    });
  }
  function Bbe(r2, t2, e2) {
    var n2 = r2.coordinateSystem, a = r2.getData(), i = e2 / 2, o = r2.get("layout") === "horizontal" ? 0 : 1, s = 1 - o, u = ["x", "y"], l2 = a.mapDimension(u[o]), c2 = a.mapDimensionsAll(u[s]);
    if (l2 == null || c2.length < 5)
      return;
    for (var f2 = 0; f2 < a.count(); f2++) {
      var h = a.get(l2, f2), v9 = M(h, c2[2], f2), d2 = M(h, c2[0], f2), m2 = M(h, c2[1], f2), b2 = M(h, c2[3], f2), _ = M(h, c2[4], f2), C = [];
      E(C, m2, false), E(C, b2, true), C.push(d2, m2, _, b2), z9(C, d2), z9(C, _), z9(C, v9), a.setItemLayout(f2, { initBaseline: v9[s], ends: C });
    }
    function M(V, $, U) {
      var H = a.get($, U), q3 = [];
      q3[o] = V, q3[s] = H;
      var ee;
      return isNaN(V) || isNaN(H) ? ee = [NaN, NaN] : (ee = n2.dataToPoint(q3), ee[o] += t2), ee;
    }
    function E(V, $, U) {
      var H = $.slice(), q3 = $.slice();
      H[o] += i, q3[o] -= i, U ? V.push(H, q3) : V.push(q3, H);
    }
    function z9(V, $) {
      var U = $.slice(), H = $.slice();
      U[o] -= i, H[o] += i, V.push(U, H);
    }
  }
  function zbe(r2, t2) {
    t2 = t2 || {};
    for (var e2 = [], n2 = [], a = t2.boundIQR, i = a === "none" || a === 0, o = 0; o < r2.length; o++) {
      var s = $h(r2[o].slice()), u = yO(s, 0.25), l2 = yO(s, 0.5), c2 = yO(s, 0.75), f2 = s[0], h = s[s.length - 1], v9 = (a == null ? 1.5 : a) * (c2 - u), d2 = i ? f2 : Math.max(f2, u - v9), m2 = i ? h : Math.min(h, c2 + v9), b2 = t2.itemNameFormatter, _ = xn(b2) ? b2({ value: o }) : Zr(b2) ? b2.replace("{value}", o + "") : o + "";
      e2.push([_, d2, u, l2, c2, m2]);
      for (var C = 0; C < s.length; C++) {
        var M = s[C];
        if (M < d2 || M > m2) {
          var E = [_, M];
          n2.push(E);
        }
      }
    }
    return { boxData: e2, outliers: n2 };
  }
  var $be = { type: "echarts:boxplot", transform: function(t2) {
    var e2 = t2.upstream;
    if (e2.sourceFormat !== cc) {
      var n2 = "";
      Ii(n2);
    }
    var a = zbe(e2.getRawData(), t2.config);
    return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: a.boxData }, { data: a.outliers }];
  } };
  function Gbe(r2) {
    r2.registerSeriesModel(Dbe), r2.registerChartView(Rbe), r2.registerVisual(Fbe), r2.registerLayout(Nbe), r2.registerTransform($be);
  }
  var Wbe = ["color", "borderColor"], Ube = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(e2), this._isLargeDraw ? this._renderLarge(e2) : this._renderNormal(e2);
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      this._clear(), this._updateDrawMode(e2);
    }, t2.prototype.incrementalRender = function(e2, n2, a, i) {
      this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(e2, n2) : this._incrementalRenderNormal(e2, n2);
    }, t2.prototype.eachRendered = function(e2) {
      Ay(this._progressiveEls || this.group, e2);
    }, t2.prototype._updateDrawMode = function(e2) {
      var n2 = e2.pipelineContext.large;
      (this._isLargeDraw == null || n2 !== this._isLargeDraw) && (this._isLargeDraw = n2, this._clear());
    }, t2.prototype._renderNormal = function(e2) {
      var n2 = e2.getData(), a = this._data, i = this.group, o = n2.getLayout("isSimpleBox"), s = e2.get("clip", true), u = e2.coordinateSystem, l2 = u.getArea && u.getArea();
      this._data || i.removeAll(), n2.diff(a).add(function(c2) {
        if (n2.hasValue(c2)) {
          var f2 = n2.getItemLayout(c2);
          if (s && az(l2, f2))
            return;
          var h = Gk(f2, c2, true);
          rs(h, { shape: { points: f2.ends } }, e2, c2), Wk(h, n2, c2, o), i.add(h), n2.setItemGraphicEl(c2, h);
        }
      }).update(function(c2, f2) {
        var h = a.getItemGraphicEl(f2);
        if (!n2.hasValue(c2)) {
          i.remove(h);
          return;
        }
        var v9 = n2.getItemLayout(c2);
        if (s && az(l2, v9)) {
          i.remove(h);
          return;
        }
        h ? (ci(h, { shape: { points: v9.ends } }, e2, c2), Wv(h)) : h = Gk(v9), Wk(h, n2, c2, o), i.add(h), n2.setItemGraphicEl(c2, h);
      }).remove(function(c2) {
        var f2 = a.getItemGraphicEl(c2);
        f2 && i.remove(f2);
      }).execute(), this._data = n2;
    }, t2.prototype._renderLarge = function(e2) {
      this._clear(), oz(e2, this.group);
      var n2 = e2.get("clip", true) ? _3(e2.coordinateSystem, false, e2) : null;
      n2 ? this.group.setClipPath(n2) : this.group.removeClipPath();
    }, t2.prototype._incrementalRenderNormal = function(e2, n2) {
      for (var a = n2.getData(), i = a.getLayout("isSimpleBox"), o; (o = e2.next()) != null; ) {
        var s = a.getItemLayout(o), u = Gk(s);
        Wk(u, a, o, i), u.incremental = true, this.group.add(u), this._progressiveEls.push(u);
      }
    }, t2.prototype._incrementalRenderLarge = function(e2, n2) {
      oz(n2, this.group, this._progressiveEls, true);
    }, t2.prototype.remove = function(e2) {
      this._clear();
    }, t2.prototype._clear = function() {
      this.group.removeAll(), this._data = null;
    }, t2.type = "candlestick", t2;
  }(Mo), Hbe = function() {
    function r2() {
    }
    return r2;
  }(), qbe = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "normalCandlestickBox", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Hbe();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.points;
      this.__simpleBox ? (e2.moveTo(a[4][0], a[4][1]), e2.lineTo(a[6][0], a[6][1])) : (e2.moveTo(a[0][0], a[0][1]), e2.lineTo(a[1][0], a[1][1]), e2.lineTo(a[2][0], a[2][1]), e2.lineTo(a[3][0], a[3][1]), e2.closePath(), e2.moveTo(a[4][0], a[4][1]), e2.lineTo(a[5][0], a[5][1]), e2.moveTo(a[6][0], a[6][1]), e2.lineTo(a[7][0], a[7][1]));
    }, t2;
  }(xa);
  function Gk(r2, t2, e2) {
    var n2 = r2.ends;
    return new qbe({ shape: { points: e2 ? Ybe(n2, r2) : n2 }, z2: 100 });
  }
  function az(r2, t2) {
    for (var e2 = true, n2 = 0; n2 < t2.ends.length; n2++)
      if (r2.contain(t2.ends[n2][0], t2.ends[n2][1])) {
        e2 = false;
        break;
      }
    return e2;
  }
  function Wk(r2, t2, e2, n2) {
    var a = t2.getItemModel(e2);
    r2.useStyle(t2.getItemVisual(e2, "style")), r2.style.strokeNoScale = true, r2.__simpleBox = n2, jl(r2, a);
  }
  function Ybe(r2, t2) {
    return pr(r2, function(e2) {
      return e2 = e2.slice(), e2[1] = t2.initBaseline, e2;
    });
  }
  var Kbe = function() {
    function r2() {
    }
    return r2;
  }(), iz = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2.type = "largeCandlestickBox", n2;
    }
    return t2.prototype.getDefaultShape = function() {
      return new Kbe();
    }, t2.prototype.buildPath = function(e2, n2) {
      for (var a = n2.points, i = 0; i < a.length; )
        if (this.__sign === a[i++]) {
          var o = a[i++];
          e2.moveTo(o, a[i++]), e2.lineTo(o, a[i++]);
        } else
          i += 3;
    }, t2;
  }(xa);
  function oz(r2, t2, e2, n2) {
    var a = r2.getData(), i = a.getLayout("largePoints"), o = new iz({ shape: { points: i }, __sign: 1 });
    t2.add(o);
    var s = new iz({ shape: { points: i }, __sign: -1 });
    t2.add(s), sz(1, o, r2), sz(-1, s, r2), n2 && (o.incremental = true, s.incremental = true), e2 && e2.push(o, s);
  }
  function sz(r2, t2, e2, n2) {
    var a = e2.get(["itemStyle", r2 > 0 ? "borderColor" : "borderColor0"]) || e2.get(["itemStyle", r2 > 0 ? "color" : "color0"]), i = e2.getModel("itemStyle").getItemStyle(Wbe);
    t2.useStyle(i), t2.style.fill = null, t2.style.stroke = a;
  }
  var Zbe = Ube, UK = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], e2;
    }
    return t2.prototype.getShadowDim = function() {
      return "open";
    }, t2.prototype.brushSelector = function(e2, n2, a) {
      var i = n2.getItemLayout(e2);
      return i && a.rect(i.brushRect);
    }, t2.type = "series.candlestick", t2.dependencies = ["xAxis", "yAxis", "grid"], t2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, t2;
  }(ns);
  fu(UK, $K, true);
  var Xbe = UK;
  function Jbe(r2) {
    !r2 || !vr(r2.series) || ae(r2.series, function(t2) {
      Tn(t2) && t2.type === "k" && (t2.type = "candlestick");
    });
  }
  var Qbe = ["itemStyle", "borderColor"], e1e = ["itemStyle", "borderColor0"], t1e = ["itemStyle", "color"], r1e = ["itemStyle", "color0"], n1e = { seriesType: "candlestick", plan: ww(), performRawSeries: true, reset: function(r2, t2) {
    function e2(i, o) {
      return o.get(i > 0 ? t1e : r1e);
    }
    function n2(i, o) {
      return o.get(i > 0 ? Qbe : e1e);
    }
    if (!t2.isSeriesFiltered(r2)) {
      var a = r2.pipelineContext.large;
      return !a && { progress: function(i, o) {
        for (var s; (s = i.next()) != null; ) {
          var u = o.getItemModel(s), l2 = o.getItemLayout(s).sign, c2 = u.getItemStyle();
          c2.fill = e2(l2, u), c2.stroke = n2(l2, u) || c2.fill;
          var f2 = o.ensureUniqueItemVisual(s, "style");
          qt(f2, c2);
        }
      } };
    }
  } }, a1e = n1e, i1e = { seriesType: "candlestick", plan: ww(), reset: function(r2) {
    var t2 = r2.coordinateSystem, e2 = r2.getData(), n2 = o1e(r2, e2), a = 0, i = 1, o = ["x", "y"], s = e2.getDimensionIndex(e2.mapDimension(o[a])), u = pr(e2.mapDimensionsAll(o[i]), e2.getDimensionIndex, e2), l2 = u[0], c2 = u[1], f2 = u[2], h = u[3];
    if (e2.setLayout({ candleWidth: n2, isSimpleBox: n2 <= 1.3 }), s < 0 || u.length < 4)
      return;
    return { progress: r2.pipelineContext.large ? d2 : v9 };
    function v9(m2, b2) {
      for (var _, C = b2.getStore(); (_ = m2.next()) != null; ) {
        var M = C.get(s, _), E = C.get(l2, _), z9 = C.get(c2, _), V = C.get(f2, _), $ = C.get(h, _), U = Math.min(E, z9), H = Math.max(E, z9), q3 = Ee(U, M), ee = Ee(H, M), oe = Ee(V, M), ne = Ee($, M), be = [];
        ye(be, ee, 0), ye(be, q3, 1), be.push(Le(ne), Le(ee), Le(oe), Le(q3)), b2.setItemLayout(_, { sign: uz(C, _, E, z9, c2), initBaseline: E > z9 ? ee[i] : q3[i], ends: be, brushRect: et(V, $, M) });
      }
      function Ee(Fe, qe) {
        var st = [];
        return st[a] = qe, st[i] = Fe, isNaN(qe) || isNaN(Fe) ? [NaN, NaN] : t2.dataToPoint(st);
      }
      function ye(Fe, qe, st) {
        var dt = qe.slice(), Ar = qe.slice();
        dt[a] = I5(dt[a] + n2 / 2, 1, false), Ar[a] = I5(Ar[a] - n2 / 2, 1, true), st ? Fe.push(dt, Ar) : Fe.push(Ar, dt);
      }
      function et(Fe, qe, st) {
        var dt = Ee(Fe, st), Ar = Ee(qe, st);
        return dt[a] -= n2 / 2, Ar[a] -= n2 / 2, { x: dt[0], y: dt[1], width: n2, height: Ar[1] - dt[1] };
      }
      function Le(Fe) {
        return Fe[a] = I5(Fe[a], 1), Fe;
      }
    }
    function d2(m2, b2) {
      for (var _ = qd(m2.count * 4), C = 0, M, E = [], z9 = [], V, $ = b2.getStore(); (V = m2.next()) != null; ) {
        var U = $.get(s, V), H = $.get(l2, V), q3 = $.get(c2, V), ee = $.get(f2, V), oe = $.get(h, V);
        if (isNaN(U) || isNaN(ee) || isNaN(oe)) {
          _[C++] = NaN, C += 3;
          continue;
        }
        _[C++] = uz($, V, H, q3, c2), E[a] = U, E[i] = ee, M = t2.dataToPoint(E, null, z9), _[C++] = M ? M[0] : NaN, _[C++] = M ? M[1] : NaN, E[i] = oe, M = t2.dataToPoint(E, null, z9), _[C++] = M ? M[1] : NaN;
      }
      b2.setLayout("largePoints", _);
    }
  } };
  function uz(r2, t2, e2, n2, a) {
    var i;
    return e2 > n2 ? i = -1 : e2 < n2 ? i = 1 : i = t2 > 0 ? r2.get(a, t2 - 1) <= n2 ? 1 : -1 : 1, i;
  }
  function o1e(r2, t2) {
    var e2 = r2.getBaseAxis(), n2, a = e2.type === "category" ? e2.getBandWidth() : (n2 = e2.getExtent(), Math.abs(n2[1] - n2[0]) / t2.count()), i = qr(ia(r2.get("barMaxWidth"), a), a), o = qr(ia(r2.get("barMinWidth"), 1), a), s = r2.get("barWidth");
    return s != null ? qr(s, a) : Math.max(Math.min(a / 2, i), o);
  }
  var s1e = i1e;
  function u1e(r2) {
    r2.registerChartView(Zbe), r2.registerSeriesModel(Xbe), r2.registerPreprocessor(Jbe), r2.registerVisual(a1e), r2.registerLayout(s1e);
  }
  function lz(r2, t2) {
    var e2 = t2.rippleEffectColor || t2.color;
    r2.eachChild(function(n2) {
      n2.attr({ z: t2.z, zlevel: t2.zlevel, style: { stroke: t2.brushType === "stroke" ? e2 : null, fill: t2.brushType === "fill" ? e2 : null } });
    });
  }
  var l1e = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      var a = r2.call(this) || this, i = new $E(e2, n2), o = new Fn();
      return a.add(i), a.add(o), a.updateData(e2, n2), a;
    }
    return t2.prototype.stopEffectAnimation = function() {
      this.childAt(1).removeAll();
    }, t2.prototype.startEffectAnimation = function(e2) {
      for (var n2 = e2.symbolType, a = e2.color, i = e2.rippleNumber, o = this.childAt(1), s = 0; s < i; s++) {
        var u = cu(n2, -1, -1, 2, 2, a);
        u.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
        var l2 = -s / i * e2.period + e2.effectOffset;
        u.animate("", true).when(e2.period, { scaleX: e2.rippleScale / 2, scaleY: e2.rippleScale / 2 }).delay(l2).start(), u.animateStyle(true).when(e2.period, { opacity: 0 }).delay(l2).start(), o.add(u);
      }
      lz(o, e2);
    }, t2.prototype.updateEffectAnimation = function(e2) {
      for (var n2 = this._effectCfg, a = this.childAt(1), i = ["symbolType", "period", "rippleScale", "rippleNumber"], o = 0; o < i.length; o++) {
        var s = i[o];
        if (n2[s] !== e2[s]) {
          this.stopEffectAnimation(), this.startEffectAnimation(e2);
          return;
        }
      }
      lz(a, e2);
    }, t2.prototype.highlight = function() {
      Kd(this);
    }, t2.prototype.downplay = function() {
      Zd(this);
    }, t2.prototype.getSymbolType = function() {
      var e2 = this.childAt(0);
      return e2 && e2.getSymbolType();
    }, t2.prototype.updateData = function(e2, n2) {
      var a = this, i = e2.hostModel;
      this.childAt(0).updateData(e2, n2);
      var o = this.childAt(1), s = e2.getItemModel(n2), u = e2.getItemVisual(n2, "symbol"), l2 = VE(e2.getItemVisual(n2, "symbolSize")), c2 = e2.getItemVisual(n2, "style"), f2 = c2 && c2.fill, h = s.getModel("emphasis");
      o.setScale(l2), o.traverse(function(b2) {
        b2.setStyle("fill", f2);
      });
      var v9 = Cw(e2.getItemVisual(n2, "symbolOffset"), l2);
      v9 && (o.x = v9[0], o.y = v9[1]);
      var d2 = e2.getItemVisual(n2, "symbolRotate");
      o.rotation = (d2 || 0) * Math.PI / 180 || 0;
      var m2 = {};
      m2.showEffectOn = i.get("showEffectOn"), m2.rippleScale = s.get(["rippleEffect", "scale"]), m2.brushType = s.get(["rippleEffect", "brushType"]), m2.period = s.get(["rippleEffect", "period"]) * 1e3, m2.effectOffset = n2 / e2.count(), m2.z = i.getShallow("z") || 0, m2.zlevel = i.getShallow("zlevel") || 0, m2.symbolType = u, m2.color = f2, m2.rippleEffectColor = s.get(["rippleEffect", "color"]), m2.rippleNumber = s.get(["rippleEffect", "number"]), m2.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(m2) : this.startEffectAnimation(m2), this._effectCfg = m2) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(b2) {
        b2 === "emphasis" ? m2.showEffectOn !== "render" && a.startEffectAnimation(m2) : b2 === "normal" && m2.showEffectOn !== "render" && a.stopEffectAnimation();
      }), this._effectCfg = m2, ks(this, h.get("focus"), h.get("blurScope"), h.get("disabled"));
    }, t2.prototype.fadeOut = function(e2) {
      e2 && e2();
    }, t2;
  }(Fn), c1e = l1e, f1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function() {
      this._symbolDraw = new GE(c1e);
    }, t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this._symbolDraw;
      o.updateData(i, { clipShape: this._getClipShape(e2) }), this.group.add(o.group);
    }, t2.prototype._getClipShape = function(e2) {
      var n2 = e2.coordinateSystem, a = n2 && n2.getArea && n2.getArea();
      return e2.get("clip", true) ? a : null;
    }, t2.prototype.updateTransform = function(e2, n2, a) {
      var i = e2.getData();
      this.group.dirty();
      var o = WE("").reset(e2, n2, a);
      o.progress && o.progress({ start: 0, end: i.count(), count: i.count() }, i), this._symbolDraw.updateLayout();
    }, t2.prototype._updateGroupTransform = function(e2) {
      var n2 = e2.coordinateSystem;
      n2 && n2.getRoamTransform && (this.group.transform = Mie(n2.getRoamTransform()), this.group.decomposeTransform());
    }, t2.prototype.remove = function(e2, n2) {
      this._symbolDraw && this._symbolDraw.remove(true);
    }, t2.type = "effectScatter", t2;
  }(Mo), h1e = f1e, v1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this, { useEncodeDefaulter: true });
    }, t2.prototype.brushSelector = function(e2, n2, a) {
      return a.point(n2.getItemLayout(e2));
    }, t2.type = "series.effectScatter", t2.dependencies = ["grid", "polar"], t2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, t2;
  }(ns), d1e = v1e;
  function p1e(r2) {
    r2.registerChartView(h1e), r2.registerSeriesModel(d1e), r2.registerLayout(WE("effectScatter"));
  }
  var g1e = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this) || this;
      return i.add(i.createLine(e2, n2, a)), i._updateEffectSymbol(e2, n2), i;
    }
    return t2.prototype.createLine = function(e2, n2, a) {
      return new rN(e2, n2, a);
    }, t2.prototype._updateEffectSymbol = function(e2, n2) {
      var a = e2.getItemModel(n2), i = a.getModel("effect"), o = i.get("symbolSize"), s = i.get("symbol");
      vr(o) || (o = [o, o]);
      var u = e2.getItemVisual(n2, "style"), l2 = i.get("color") || u && u.stroke, c2 = this.childAt(1);
      this._symbolType !== s && (this.remove(c2), c2 = cu(s, -0.5, -0.5, 1, 1, l2), c2.z2 = 100, c2.culling = true, this.add(c2)), c2 && (c2.setStyle("shadowColor", l2), c2.setStyle(i.getItemStyle(["color"])), c2.scaleX = o[0], c2.scaleY = o[1], c2.setColor(l2), this._symbolType = s, this._symbolScale = o, this._updateEffectAnimation(e2, i, n2));
    }, t2.prototype._updateEffectAnimation = function(e2, n2, a) {
      var i = this.childAt(1);
      if (!!i) {
        var o = e2.getItemLayout(a), s = n2.get("period") * 1e3, u = n2.get("loop"), l2 = n2.get("constantSpeed"), c2 = ml(n2.get("delay"), function(h) {
          return h / e2.count() * s / 3;
        });
        if (i.ignore = true, this._updateAnimationPoints(i, o), l2 > 0 && (s = this._getLineLength(i) / l2 * 1e3), s !== this._period || u !== this._loop) {
          i.stopAnimation();
          var f2 = void 0;
          xn(c2) ? f2 = c2(a) : f2 = c2, i.__t > 0 && (f2 = -s * i.__t), this._animateSymbol(i, s, f2, u);
        }
        this._period = s, this._loop = u;
      }
    }, t2.prototype._animateSymbol = function(e2, n2, a, i) {
      if (n2 > 0) {
        e2.__t = 0;
        var o = this, s = e2.animate("", i).when(n2, { __t: 1 }).delay(a).during(function() {
          o._updateSymbolPosition(e2);
        });
        i || s.done(function() {
          o.remove(e2);
        }), s.start();
      }
    }, t2.prototype._getLineLength = function(e2) {
      return ty(e2.__p1, e2.__cp1) + ty(e2.__cp1, e2.__p2);
    }, t2.prototype._updateAnimationPoints = function(e2, n2) {
      e2.__p1 = n2[0], e2.__p2 = n2[1], e2.__cp1 = n2[2] || [(n2[0][0] + n2[1][0]) / 2, (n2[0][1] + n2[1][1]) / 2];
    }, t2.prototype.updateData = function(e2, n2, a) {
      this.childAt(0).updateData(e2, n2, a), this._updateEffectSymbol(e2, n2);
    }, t2.prototype._updateSymbolPosition = function(e2) {
      var n2 = e2.__p1, a = e2.__p2, i = e2.__cp1, o = e2.__t, s = [e2.x, e2.y], u = s.slice(), l2 = yl, c2 = BR;
      s[0] = l2(n2[0], i[0], a[0], o), s[1] = l2(n2[1], i[1], a[1], o);
      var f2 = c2(n2[0], i[0], a[0], o), h = c2(n2[1], i[1], a[1], o);
      e2.rotation = -Math.atan2(h, f2) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (e2.__lastT !== void 0 && e2.__lastT < e2.__t ? (e2.scaleY = ty(u, s) * 1.05, o === 1 && (s[0] = u[0] + (s[0] - u[0]) / 2, s[1] = u[1] + (s[1] - u[1]) / 2)) : e2.__lastT === 1 ? e2.scaleY = 2 * ty(n2, s) : e2.scaleY = this._symbolScale[1]), e2.__lastT = e2.__t, e2.ignore = false, e2.x = s[0], e2.y = s[1];
    }, t2.prototype.updateLayout = function(e2, n2) {
      this.childAt(0).updateLayout(e2, n2);
      var a = e2.getItemModel(n2).getModel("effect");
      this._updateEffectAnimation(e2, a, n2);
    }, t2;
  }(Fn), HK = g1e, y1e = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a) {
      var i = r2.call(this) || this;
      return i._createPolyline(e2, n2, a), i;
    }
    return t2.prototype._createPolyline = function(e2, n2, a) {
      var i = e2.getItemLayout(n2), o = new yf({ shape: { points: i } });
      this.add(o), this._updateCommonStl(e2, n2, a);
    }, t2.prototype.updateData = function(e2, n2, a) {
      var i = e2.hostModel, o = this.childAt(0), s = { shape: { points: e2.getItemLayout(n2) } };
      ci(o, s, i, n2), this._updateCommonStl(e2, n2, a);
    }, t2.prototype._updateCommonStl = function(e2, n2, a) {
      var i = this.childAt(0), o = e2.getItemModel(n2), s = a && a.emphasisLineStyle, u = a && a.focus, l2 = a && a.blurScope, c2 = a && a.emphasisDisabled;
      if (!a || e2.hasItemOption) {
        var f2 = o.getModel("emphasis");
        s = f2.getModel("lineStyle").getLineStyle(), c2 = f2.get("disabled"), u = f2.get("focus"), l2 = f2.get("blurScope");
      }
      i.useStyle(e2.getItemVisual(n2, "style")), i.style.fill = null, i.style.strokeNoScale = true;
      var h = i.ensureState("emphasis");
      h.style = s, ks(this, u, l2, c2);
    }, t2.prototype.updateLayout = function(e2, n2) {
      var a = this.childAt(0);
      a.setShape("points", e2.getItemLayout(n2));
    }, t2;
  }(Fn), qK = y1e, m1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2._lastFrame = 0, e2._lastFramePercent = 0, e2;
    }
    return t2.prototype.createLine = function(e2, n2, a) {
      return new qK(e2, n2, a);
    }, t2.prototype._updateAnimationPoints = function(e2, n2) {
      this._points = n2;
      for (var a = [0], i = 0, o = 1; o < n2.length; o++) {
        var s = n2[o - 1], u = n2[o];
        i += ty(s, u), a.push(i);
      }
      if (i === 0) {
        this._length = 0;
        return;
      }
      for (var o = 0; o < a.length; o++)
        a[o] /= i;
      this._offsets = a, this._length = i;
    }, t2.prototype._getLineLength = function() {
      return this._length;
    }, t2.prototype._updateSymbolPosition = function(e2) {
      var n2 = e2.__t, a = this._points, i = this._offsets, o = a.length;
      if (!!i) {
        var s = this._lastFrame, u;
        if (n2 < this._lastFramePercent) {
          var l2 = Math.min(s + 1, o - 1);
          for (u = l2; u >= 0 && !(i[u] <= n2); u--)
            ;
          u = Math.min(u, o - 2);
        } else {
          for (u = s; u < o && !(i[u] > n2); u++)
            ;
          u = Math.min(u - 1, o - 2);
        }
        var c2 = (n2 - i[u]) / (i[u + 1] - i[u]), f2 = a[u], h = a[u + 1];
        e2.x = f2[0] * (1 - c2) + c2 * h[0], e2.y = f2[1] * (1 - c2) + c2 * h[1];
        var v9 = h[0] - f2[0], d2 = h[1] - f2[1];
        e2.rotation = -Math.atan2(d2, v9) - Math.PI / 2, this._lastFrame = u, this._lastFramePercent = n2, e2.ignore = false;
      }
    }, t2;
  }(HK), b1e = m1e, _1e = function() {
    function r2() {
      this.polyline = false, this.curveness = 0, this.segs = [];
    }
    return r2;
  }(), x1e = function(r2) {
    ot(t2, r2);
    function t2(e2) {
      var n2 = r2.call(this, e2) || this;
      return n2._off = 0, n2.hoverDataIdx = -1, n2;
    }
    return t2.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, t2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, t2.prototype.getDefaultShape = function() {
      return new _1e();
    }, t2.prototype.buildPath = function(e2, n2) {
      var a = n2.segs, i = n2.curveness, o;
      if (n2.polyline)
        for (o = this._off; o < a.length; ) {
          var s = a[o++];
          if (s > 0) {
            e2.moveTo(a[o++], a[o++]);
            for (var u = 1; u < s; u++)
              e2.lineTo(a[o++], a[o++]);
          }
        }
      else
        for (o = this._off; o < a.length; ) {
          var l2 = a[o++], c2 = a[o++], f2 = a[o++], h = a[o++];
          if (e2.moveTo(l2, c2), i > 0) {
            var v9 = (l2 + f2) / 2 - (c2 - h) * i, d2 = (c2 + h) / 2 - (f2 - l2) * i;
            e2.quadraticCurveTo(v9, d2, f2, h);
          } else
            e2.lineTo(f2, h);
        }
      this.incremental && (this._off = o, this.notClear = true);
    }, t2.prototype.findDataIndex = function(e2, n2) {
      var a = this.shape, i = a.segs, o = a.curveness, s = this.style.lineWidth;
      if (a.polyline)
        for (var u = 0, l2 = 0; l2 < i.length; ) {
          var c2 = i[l2++];
          if (c2 > 0)
            for (var f2 = i[l2++], h = i[l2++], v9 = 1; v9 < c2; v9++) {
              var d2 = i[l2++], m2 = i[l2++];
              if (Q0(f2, h, d2, m2, s, e2, n2))
                return u;
            }
          u++;
        }
      else
        for (var u = 0, l2 = 0; l2 < i.length; ) {
          var f2 = i[l2++], h = i[l2++], d2 = i[l2++], m2 = i[l2++];
          if (o > 0) {
            var b2 = (f2 + d2) / 2 - (h - m2) * o, _ = (h + m2) / 2 - (d2 - f2) * o;
            if (QW(f2, h, b2, _, d2, m2, s, e2, n2))
              return u;
          } else if (Q0(f2, h, d2, m2, s, e2, n2))
            return u;
          u++;
        }
      return -1;
    }, t2.prototype.contain = function(e2, n2) {
      var a = this.transformCoordToLocal(e2, n2), i = this.getBoundingRect();
      if (e2 = a[0], n2 = a[1], i.contain(e2, n2)) {
        var o = this.hoverDataIdx = this.findDataIndex(e2, n2);
        return o >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, t2.prototype.getBoundingRect = function() {
      var e2 = this._rect;
      if (!e2) {
        for (var n2 = this.shape, a = n2.segs, i = 1 / 0, o = 1 / 0, s = -1 / 0, u = -1 / 0, l2 = 0; l2 < a.length; ) {
          var c2 = a[l2++], f2 = a[l2++];
          i = Math.min(c2, i), s = Math.max(c2, s), o = Math.min(f2, o), u = Math.max(f2, u);
        }
        e2 = this._rect = new da(i, o, s, u);
      }
      return e2;
    }, t2;
  }(xa), w1e = function() {
    function r2() {
      this.group = new Fn();
    }
    return r2.prototype.updateData = function(t2) {
      this._clear();
      var e2 = this._create();
      e2.setShape({ segs: t2.getLayout("linesPoints") }), this._setCommon(e2, t2);
    }, r2.prototype.incrementalPrepareUpdate = function(t2) {
      this.group.removeAll(), this._clear();
    }, r2.prototype.incrementalUpdate = function(t2, e2) {
      var n2 = this._newAdded[0], a = e2.getLayout("linesPoints"), i = n2 && n2.shape.segs;
      if (i && i.length < 2e4) {
        var o = i.length, s = new Float32Array(o + a.length);
        s.set(i), s.set(a, o), n2.setShape({ segs: s });
      } else {
        this._newAdded = [];
        var u = this._create();
        u.incremental = true, u.setShape({ segs: a }), this._setCommon(u, e2), u.__startIndex = t2.start;
      }
    }, r2.prototype.remove = function() {
      this._clear();
    }, r2.prototype.eachRendered = function(t2) {
      this._newAdded[0] && t2(this._newAdded[0]);
    }, r2.prototype._create = function() {
      var t2 = new x1e({ cursor: "default" });
      return this._newAdded.push(t2), this.group.add(t2), t2;
    }, r2.prototype._setCommon = function(t2, e2, n2) {
      var a = e2.hostModel;
      t2.setShape({ polyline: a.get("polyline"), curveness: a.get(["lineStyle", "curveness"]) }), t2.useStyle(a.getModel("lineStyle").getLineStyle()), t2.style.strokeNoScale = true;
      var i = e2.getVisual("style");
      i && i.stroke && t2.setStyle("stroke", i.stroke), t2.setStyle("fill", null);
      var o = zn(t2);
      o.seriesIndex = a.seriesIndex, t2.on("mousemove", function(s) {
        o.dataIndex = null;
        var u = t2.hoverDataIdx;
        u > 0 && (o.dataIndex = u + t2.__startIndex);
      });
    }, r2.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, r2;
  }(), S1e = w1e, C1e = { seriesType: "lines", plan: ww(), reset: function(r2) {
    var t2 = r2.coordinateSystem;
    if (!!t2) {
      var e2 = r2.get("polyline"), n2 = r2.pipelineContext.large;
      return { progress: function(a, i) {
        var o = [];
        if (n2) {
          var s = void 0, u = a.end - a.start;
          if (e2) {
            for (var l2 = 0, c2 = a.start; c2 < a.end; c2++)
              l2 += r2.getLineCoordsCount(c2);
            s = new Float32Array(u + l2 * 2);
          } else
            s = new Float32Array(u * 4);
          for (var f2 = 0, h = [], c2 = a.start; c2 < a.end; c2++) {
            var v9 = r2.getLineCoords(c2, o);
            e2 && (s[f2++] = v9);
            for (var d2 = 0; d2 < v9; d2++)
              h = t2.dataToPoint(o[d2], false, h), s[f2++] = h[0], s[f2++] = h[1];
          }
          i.setLayout("linesPoints", s);
        } else
          for (var c2 = a.start; c2 < a.end; c2++) {
            var m2 = i.getItemModel(c2), v9 = r2.getLineCoords(c2, o), b2 = [];
            if (e2)
              for (var _ = 0; _ < v9; _++)
                b2.push(t2.dataToPoint(o[_]));
            else {
              b2[0] = t2.dataToPoint(o[0]), b2[1] = t2.dataToPoint(o[1]);
              var C = m2.get(["lineStyle", "curveness"]);
              +C && (b2[2] = [(b2[0][0] + b2[1][0]) / 2 - (b2[0][1] - b2[1][1]) * C, (b2[0][1] + b2[1][1]) / 2 - (b2[1][0] - b2[0][0]) * C]);
            }
            i.setItemLayout(c2, b2);
          }
      } };
    }
  } }, YK = C1e, E1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this._updateLineDraw(i, e2), s = e2.get("zlevel"), u = e2.get(["effect", "trailLength"]), l2 = a.getZr(), c2 = l2.painter.getType() === "svg";
      c2 || l2.painter.getLayer(s).clear(true), this._lastZlevel != null && !c2 && l2.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(e2) && u > 0 && (c2 || l2.configLayer(s, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(u / 10 + 0.9, 1), 0) })), o.updateData(i);
      var f2 = e2.get("clip", true) && _3(e2.coordinateSystem, false, e2);
      f2 ? this.group.setClipPath(f2) : this.group.removeClipPath(), this._lastZlevel = s, this._finished = true;
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      var i = e2.getData(), o = this._updateLineDraw(i, e2);
      o.incrementalPrepareUpdate(i), this._clearLayer(a), this._finished = false;
    }, t2.prototype.incrementalRender = function(e2, n2, a) {
      this._lineDraw.incrementalUpdate(e2, n2.getData()), this._finished = e2.end === n2.getData().count();
    }, t2.prototype.eachRendered = function(e2) {
      this._lineDraw && this._lineDraw.eachRendered(e2);
    }, t2.prototype.updateTransform = function(e2, n2, a) {
      var i = e2.getData(), o = e2.pipelineContext;
      if (!this._finished || o.large || o.progressiveRender)
        return { update: true };
      var s = YK.reset(e2, n2, a);
      s.progress && s.progress({ start: 0, end: i.count(), count: i.count() }, i), this._lineDraw.updateLayout(), this._clearLayer(a);
    }, t2.prototype._updateLineDraw = function(e2, n2) {
      var a = this._lineDraw, i = this._showEffect(n2), o = !!n2.get("polyline"), s = n2.pipelineContext, u = s.large;
      return (!a || i !== this._hasEffet || o !== this._isPolyline || u !== this._isLargeDraw) && (a && a.remove(), a = this._lineDraw = u ? new S1e() : new nN(o ? i ? b1e : qK : i ? HK : rN), this._hasEffet = i, this._isPolyline = o, this._isLargeDraw = u), this.group.add(a.group), a;
    }, t2.prototype._showEffect = function(e2) {
      return !!e2.get(["effect", "show"]);
    }, t2.prototype._clearLayer = function(e2) {
      var n2 = e2.getZr(), a = n2.painter.getType() === "svg";
      !a && this._lastZlevel != null && n2.painter.getLayer(this._lastZlevel).clear(true);
    }, t2.prototype.remove = function(e2, n2) {
      this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(n2);
    }, t2.prototype.dispose = function(e2, n2) {
      this.remove(e2, n2);
    }, t2.type = "lines", t2;
  }(Mo), A1e = E1e, T1e = typeof Uint32Array == "undefined" ? Array : Uint32Array, M1e = typeof Float64Array == "undefined" ? Array : Float64Array;
  function cz(r2) {
    var t2 = r2.data;
    t2 && t2[0] && t2[0][0] && t2[0][0].coord && (r2.data = pr(t2, function(e2) {
      var n2 = [e2[0].coord, e2[1].coord], a = { coords: n2 };
      return e2[0].name && (a.fromName = e2[0].name), e2[1].name && (a.toName = e2[1].name), N6([a, e2[0], e2[1]]);
    }));
  }
  var P1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
    }
    return t2.prototype.init = function(e2) {
      e2.data = e2.data || [], cz(e2);
      var n2 = this._processFlatCoordsArray(e2.data);
      this._flatCoords = n2.flatCoords, this._flatCoordsOffset = n2.flatCoordsOffset, n2.flatCoords && (e2.data = new Float32Array(n2.count)), r2.prototype.init.apply(this, arguments);
    }, t2.prototype.mergeOption = function(e2) {
      if (cz(e2), e2.data) {
        var n2 = this._processFlatCoordsArray(e2.data);
        this._flatCoords = n2.flatCoords, this._flatCoordsOffset = n2.flatCoordsOffset, n2.flatCoords && (e2.data = new Float32Array(n2.count));
      }
      r2.prototype.mergeOption.apply(this, arguments);
    }, t2.prototype.appendData = function(e2) {
      var n2 = this._processFlatCoordsArray(e2.data);
      n2.flatCoords && (this._flatCoords ? (this._flatCoords = IR(this._flatCoords, n2.flatCoords), this._flatCoordsOffset = IR(this._flatCoordsOffset, n2.flatCoordsOffset)) : (this._flatCoords = n2.flatCoords, this._flatCoordsOffset = n2.flatCoordsOffset), e2.data = new Float32Array(n2.count)), this.getRawData().appendData(e2.data);
    }, t2.prototype._getCoordsFromItemModel = function(e2) {
      var n2 = this.getData().getItemModel(e2), a = n2.option instanceof Array ? n2.option : n2.getShallow("coords");
      return a;
    }, t2.prototype.getLineCoordsCount = function(e2) {
      return this._flatCoordsOffset ? this._flatCoordsOffset[e2 * 2 + 1] : this._getCoordsFromItemModel(e2).length;
    }, t2.prototype.getLineCoords = function(e2, n2) {
      if (this._flatCoordsOffset) {
        for (var a = this._flatCoordsOffset[e2 * 2], i = this._flatCoordsOffset[e2 * 2 + 1], o = 0; o < i; o++)
          n2[o] = n2[o] || [], n2[o][0] = this._flatCoords[a + o * 2], n2[o][1] = this._flatCoords[a + o * 2 + 1];
        return i;
      } else {
        for (var s = this._getCoordsFromItemModel(e2), o = 0; o < s.length; o++)
          n2[o] = n2[o] || [], n2[o][0] = s[o][0], n2[o][1] = s[o][1];
        return s.length;
      }
    }, t2.prototype._processFlatCoordsArray = function(e2) {
      var n2 = 0;
      if (this._flatCoords && (n2 = this._flatCoords.length), Ai(e2[0])) {
        for (var a = e2.length, i = new T1e(a), o = new M1e(a), s = 0, u = 0, l2 = 0, c2 = 0; c2 < a; ) {
          l2++;
          var f2 = e2[c2++];
          i[u++] = s + n2, i[u++] = f2;
          for (var h = 0; h < f2; h++) {
            var v9 = e2[c2++], d2 = e2[c2++];
            o[s++] = v9, o[s++] = d2;
          }
        }
        return { flatCoordsOffset: new Uint32Array(i.buffer, 0, u), flatCoords: o, count: l2 };
      }
      return { flatCoordsOffset: null, flatCoords: null, count: e2.length };
    }, t2.prototype.getInitialData = function(e2, n2) {
      var a = new Rc(["value"], this);
      return a.hasItemOption = false, a.initData(e2.data, [], function(i, o, s, u) {
        if (i instanceof Array)
          return NaN;
        a.hasItemOption = true;
        var l2 = i.value;
        if (l2 != null)
          return l2 instanceof Array ? l2[u] : l2;
      }), a;
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      var i = this.getData(), o = i.getItemModel(e2), s = o.get("name");
      if (s)
        return s;
      var u = o.get("fromName"), l2 = o.get("toName"), c2 = [];
      return u != null && c2.push(u), l2 != null && c2.push(l2), Hu("nameValue", { name: c2.join(" > ") });
    }, t2.prototype.preventIncremental = function() {
      return !!this.get(["effect", "show"]);
    }, t2.prototype.getProgressive = function() {
      var e2 = this.option.progressive;
      return e2 == null ? this.option.large ? 1e4 : this.get("progressive") : e2;
    }, t2.prototype.getProgressiveThreshold = function() {
      var e2 = this.option.progressiveThreshold;
      return e2 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : e2;
    }, t2.prototype.getZLevelKey = function() {
      var e2 = this.getModel("effect"), n2 = e2.get("trailLength");
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : e2.get("show") && n2 > 0 ? n2 + "" : "";
    }, t2.type = "series.lines", t2.dependencies = ["grid", "polar", "geo", "calendar"], t2.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, t2;
  }(ns), D1e = P1e;
  function i5(r2) {
    return r2 instanceof Array || (r2 = [r2, r2]), r2;
  }
  var I1e = { seriesType: "lines", reset: function(r2) {
    var t2 = i5(r2.get("symbol")), e2 = i5(r2.get("symbolSize")), n2 = r2.getData();
    n2.setVisual("fromSymbol", t2 && t2[0]), n2.setVisual("toSymbol", t2 && t2[1]), n2.setVisual("fromSymbolSize", e2 && e2[0]), n2.setVisual("toSymbolSize", e2 && e2[1]);
    function a(i, o) {
      var s = i.getItemModel(o), u = i5(s.getShallow("symbol", true)), l2 = i5(s.getShallow("symbolSize", true));
      u[0] && i.setItemVisual(o, "fromSymbol", u[0]), u[1] && i.setItemVisual(o, "toSymbol", u[1]), l2[0] && i.setItemVisual(o, "fromSymbolSize", l2[0]), l2[1] && i.setItemVisual(o, "toSymbolSize", l2[1]);
    }
    return { dataEach: n2.hasItemOption ? a : null };
  } }, L1e = I1e;
  function O1e(r2) {
    r2.registerChartView(A1e), r2.registerSeriesModel(D1e), r2.registerLayout(YK), r2.registerVisual(L1e);
  }
  var k1e = 256, R1e = function() {
    function r2() {
      this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
      var t2 = Tg.createCanvas();
      this.canvas = t2;
    }
    return r2.prototype.update = function(t2, e2, n2, a, i, o) {
      var s = this._getBrush(), u = this._getGradient(i, "inRange"), l2 = this._getGradient(i, "outOfRange"), c2 = this.pointSize + this.blurSize, f2 = this.canvas, h = f2.getContext("2d"), v9 = t2.length;
      f2.width = e2, f2.height = n2;
      for (var d2 = 0; d2 < v9; ++d2) {
        var m2 = t2[d2], b2 = m2[0], _ = m2[1], C = m2[2], M = a(C);
        h.globalAlpha = M, h.drawImage(s, b2 - c2, _ - c2);
      }
      if (!f2.width || !f2.height)
        return f2;
      for (var E = h.getImageData(0, 0, f2.width, f2.height), z9 = E.data, V = 0, $ = z9.length, U = this.minOpacity, H = this.maxOpacity, q3 = H - U; V < $; ) {
        var M = z9[V + 3] / 256, ee = Math.floor(M * (k1e - 1)) * 4;
        if (M > 0) {
          var oe = o(M) ? u : l2;
          M > 0 && (M = M * q3 + U), z9[V++] = oe[ee], z9[V++] = oe[ee + 1], z9[V++] = oe[ee + 2], z9[V++] = oe[ee + 3] * M * 256;
        } else
          V += 4;
      }
      return h.putImageData(E, 0, 0), f2;
    }, r2.prototype._getBrush = function() {
      var t2 = this._brushCanvas || (this._brushCanvas = Tg.createCanvas()), e2 = this.pointSize + this.blurSize, n2 = e2 * 2;
      t2.width = n2, t2.height = n2;
      var a = t2.getContext("2d");
      return a.clearRect(0, 0, n2, n2), a.shadowOffsetX = n2, a.shadowBlur = this.blurSize, a.shadowColor = "#000", a.beginPath(), a.arc(-e2, e2, this.pointSize, 0, Math.PI * 2, true), a.closePath(), a.fill(), t2;
    }, r2.prototype._getGradient = function(t2, e2) {
      for (var n2 = this._gradientPixels, a = n2[e2] || (n2[e2] = new Uint8ClampedArray(256 * 4)), i = [0, 0, 0, 0], o = 0, s = 0; s < 256; s++)
        t2[e2](s / 255, true, i), a[o++] = i[0], a[o++] = i[1], a[o++] = i[2], a[o++] = i[3];
      return a;
    }, r2;
  }(), F1e = R1e;
  function N1e(r2, t2, e2) {
    var n2 = r2[1] - r2[0];
    t2 = pr(t2, function(o) {
      return { interval: [(o.interval[0] - r2[0]) / n2, (o.interval[1] - r2[0]) / n2] };
    });
    var a = t2.length, i = 0;
    return function(o) {
      var s;
      for (s = i; s < a; s++) {
        var u = t2[s].interval;
        if (u[0] <= o && o <= u[1]) {
          i = s;
          break;
        }
      }
      if (s === a)
        for (s = i - 1; s >= 0; s--) {
          var u = t2[s].interval;
          if (u[0] <= o && o <= u[1]) {
            i = s;
            break;
          }
        }
      return s >= 0 && s < a && e2[s];
    };
  }
  function V1e(r2, t2) {
    var e2 = r2[1] - r2[0];
    return t2 = [(t2[0] - r2[0]) / e2, (t2[1] - r2[0]) / e2], function(n2) {
      return n2 >= t2[0] && n2 <= t2[1];
    };
  }
  function fz(r2) {
    var t2 = r2.dimensions;
    return t2[0] === "lng" && t2[1] === "lat";
  }
  var j1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i;
      n2.eachComponent("visualMap", function(s) {
        s.eachTargetSeries(function(u) {
          u === e2 && (i = s);
        });
      }), this._progressiveEls = null, this.group.removeAll();
      var o = e2.coordinateSystem;
      o.type === "cartesian2d" || o.type === "calendar" ? this._renderOnCartesianAndCalendar(e2, a, 0, e2.getData().count()) : fz(o) && this._renderOnGeo(o, e2, i, a);
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      this.group.removeAll();
    }, t2.prototype.incrementalRender = function(e2, n2, a, i) {
      var o = n2.coordinateSystem;
      o && (fz(o) ? this.render(n2, a, i) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(n2, i, e2.start, e2.end, true)));
    }, t2.prototype.eachRendered = function(e2) {
      Ay(this._progressiveEls || this.group, e2);
    }, t2.prototype._renderOnCartesianAndCalendar = function(e2, n2, a, i, o) {
      var s = e2.coordinateSystem, u, l2, c2, f2;
      if (Cg(s, "cartesian2d")) {
        var h = s.getAxis("x"), v9 = s.getAxis("y");
        u = h.getBandWidth(), l2 = v9.getBandWidth(), c2 = h.scale.getExtent(), f2 = v9.scale.getExtent();
      }
      for (var d2 = this.group, m2 = e2.getData(), b2 = e2.getModel(["emphasis", "itemStyle"]).getItemStyle(), _ = e2.getModel(["blur", "itemStyle"]).getItemStyle(), C = e2.getModel(["select", "itemStyle"]).getItemStyle(), M = e2.get(["itemStyle", "borderRadius"]), E = _l(e2), z9 = e2.getModel("emphasis"), V = z9.get("focus"), $ = z9.get("blurScope"), U = z9.get("disabled"), H = Cg(s, "cartesian2d") ? [m2.mapDimension("x"), m2.mapDimension("y"), m2.mapDimension("value")] : [m2.mapDimension("time"), m2.mapDimension("value")], q3 = a; q3 < i; q3++) {
        var ee = void 0, oe = m2.getItemVisual(q3, "style");
        if (Cg(s, "cartesian2d")) {
          var ne = m2.get(H[0], q3), be = m2.get(H[1], q3);
          if (isNaN(m2.get(H[2], q3)) || ne < c2[0] || ne > c2[1] || be < f2[0] || be > f2[1])
            continue;
          var Ee = s.dataToPoint([ne, be]);
          ee = new ni({ shape: { x: Math.floor(Math.round(Ee[0]) - u / 2), y: Math.floor(Math.round(Ee[1]) - l2 / 2), width: Math.ceil(u), height: Math.ceil(l2) }, style: oe });
        } else {
          if (isNaN(m2.get(H[1], q3)))
            continue;
          ee = new ni({ z2: 1, shape: s.dataToRect([m2.get(H[0], q3)]).contentShape, style: oe });
        }
        if (m2.hasItemOption) {
          var ye = m2.getItemModel(q3), et = ye.getModel("emphasis");
          b2 = et.getModel("itemStyle").getItemStyle(), _ = ye.getModel(["blur", "itemStyle"]).getItemStyle(), C = ye.getModel(["select", "itemStyle"]).getItemStyle(), M = ye.get(["itemStyle", "borderRadius"]), V = et.get("focus"), $ = et.get("blurScope"), U = et.get("disabled"), E = _l(ye);
        }
        ee.shape.r = M;
        var Le = e2.getRawValue(q3), Fe = "-";
        Le && Le[2] != null && (Fe = Le[2] + ""), fc(ee, E, { labelFetcher: e2, labelDataIndex: q3, defaultOpacity: oe.opacity, defaultText: Fe }), ee.ensureState("emphasis").style = b2, ee.ensureState("blur").style = _, ee.ensureState("select").style = C, ks(ee, V, $, U), ee.incremental = o, o && (ee.states.emphasis.hoverLayer = true), d2.add(ee), m2.setItemGraphicEl(q3, ee), this._progressiveEls && this._progressiveEls.push(ee);
      }
    }, t2.prototype._renderOnGeo = function(e2, n2, a, i) {
      var o = a.targetVisuals.inRange, s = a.targetVisuals.outOfRange, u = n2.getData(), l2 = this._hmLayer || this._hmLayer || new F1e();
      l2.blurSize = n2.get("blurSize"), l2.pointSize = n2.get("pointSize"), l2.minOpacity = n2.get("minOpacity"), l2.maxOpacity = n2.get("maxOpacity");
      var c2 = e2.getViewRect().clone(), f2 = e2.getRoamTransform();
      c2.applyTransform(f2);
      var h = Math.max(c2.x, 0), v9 = Math.max(c2.y, 0), d2 = Math.min(c2.width + c2.x, i.getWidth()), m2 = Math.min(c2.height + c2.y, i.getHeight()), b2 = d2 - h, _ = m2 - v9, C = [u.mapDimension("lng"), u.mapDimension("lat"), u.mapDimension("value")], M = u.mapArray(C, function($, U, H) {
        var q3 = e2.dataToPoint([$, U]);
        return q3[0] -= h, q3[1] -= v9, q3.push(H), q3;
      }), E = a.getExtent(), z9 = a.type === "visualMap.continuous" ? V1e(E, a.option.range) : N1e(E, a.getPieceList(), a.option.selected);
      l2.update(M, b2, _, o.color.getNormalizer(), { inRange: o.color.getColorMapper(), outOfRange: s.color.getColorMapper() }, z9);
      var V = new Bl({ style: { width: b2, height: _, x: h, y: v9, image: l2.canvas }, silent: true });
      this.group.add(V);
    }, t2.type = "heatmap", t2;
  }(Mo), B1e = j1e, z1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this, { generateCoord: "value" });
    }, t2.prototype.preventIncremental = function() {
      var e2 = FE.get(this.get("coordinateSystem"));
      if (e2 && e2.dimensions)
        return e2.dimensions[0] === "lng" && e2.dimensions[1] === "lat";
    }, t2.type = "series.heatmap", t2.dependencies = ["grid", "geo", "calendar"], t2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, t2;
  }(ns), $1e = z1e;
  function G1e(r2) {
    r2.registerChartView(B1e), r2.registerSeriesModel($1e);
  }
  var W1e = ["itemStyle", "borderWidth"], hz = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], Uk = new ap(), U1e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = this.group, o = e2.getData(), s = this._data, u = e2.coordinateSystem, l2 = u.getBaseAxis(), c2 = l2.isHorizontal(), f2 = u.master.getRect(), h = { ecSize: { width: a.getWidth(), height: a.getHeight() }, seriesModel: e2, coordSys: u, coordSysExtent: [[f2.x, f2.x + f2.width], [f2.y, f2.y + f2.height]], isHorizontal: c2, valueDim: hz[+c2], categoryDim: hz[1 - +c2] };
      return o.diff(s).add(function(v9) {
        if (!!o.hasValue(v9)) {
          var d2 = dz(o, v9), m2 = vz(o, v9, d2, h), b2 = pz(o, h, m2);
          o.setItemGraphicEl(v9, b2), i.add(b2), yz(b2, h, m2);
        }
      }).update(function(v9, d2) {
        var m2 = s.getItemGraphicEl(d2);
        if (!o.hasValue(v9)) {
          i.remove(m2);
          return;
        }
        var b2 = dz(o, v9), _ = vz(o, v9, b2, h), C = eZ(o, _);
        m2 && C !== m2.__pictorialShapeStr && (i.remove(m2), o.setItemGraphicEl(v9, null), m2 = null), m2 ? J1e(m2, h, _) : m2 = pz(o, h, _, true), o.setItemGraphicEl(v9, m2), m2.__pictorialSymbolMeta = _, i.add(m2), yz(m2, h, _);
      }).remove(function(v9) {
        var d2 = s.getItemGraphicEl(v9);
        d2 && gz(s, v9, d2.__pictorialSymbolMeta.animationModel, d2);
      }).execute(), this._data = o, this.group;
    }, t2.prototype.remove = function(e2, n2) {
      var a = this.group, i = this._data;
      e2.get("animation") ? i && i.eachItemGraphicEl(function(o) {
        gz(i, zn(o).dataIndex, e2, o);
      }) : a.removeAll();
    }, t2.type = "pictorialBar", t2;
  }(Mo);
  function vz(r2, t2, e2, n2) {
    var a = r2.getItemLayout(t2), i = e2.get("symbolRepeat"), o = e2.get("symbolClip"), s = e2.get("symbolPosition") || "start", u = e2.get("symbolRotate"), l2 = (u || 0) * Math.PI / 180 || 0, c2 = e2.get("symbolPatternSize") || 2, f2 = e2.isAnimationEnabled(), h = { dataIndex: t2, layout: a, itemModel: e2, symbolType: r2.getItemVisual(t2, "symbol") || "circle", style: r2.getItemVisual(t2, "style"), symbolClip: o, symbolRepeat: i, symbolRepeatDirection: e2.get("symbolRepeatDirection"), symbolPatternSize: c2, rotation: l2, animationModel: f2 ? e2 : null, hoverScale: f2 && e2.get(["emphasis", "scale"]), z2: e2.getShallow("z", true) || 0 };
    H1e(e2, i, a, n2, h), q1e(r2, t2, a, i, o, h.boundingLength, h.pxSign, c2, n2, h), Y1e(e2, h.symbolScale, l2, n2, h);
    var v9 = h.symbolSize, d2 = Cw(e2.get("symbolOffset"), v9);
    return K1e(e2, v9, a, i, o, d2, s, h.valueLineWidth, h.boundingLength, h.repeatCutLength, n2, h), h;
  }
  function H1e(r2, t2, e2, n2, a) {
    var i = n2.valueDim, o = r2.get("symbolBoundingData"), s = n2.coordSys.getOtherAxis(n2.coordSys.getBaseAxis()), u = s.toGlobalCoord(s.dataToCoord(0)), l2 = 1 - +(e2[i.wh] <= 0), c2;
    if (vr(o)) {
      var f2 = [Hk(s, o[0]) - u, Hk(s, o[1]) - u];
      f2[1] < f2[0] && f2.reverse(), c2 = f2[l2];
    } else
      o != null ? c2 = Hk(s, o) - u : t2 ? c2 = n2.coordSysExtent[i.index][l2] - u : c2 = e2[i.wh];
    a.boundingLength = c2, t2 && (a.repeatCutLength = e2[i.wh]), a.pxSign = c2 > 0 ? 1 : -1;
  }
  function Hk(r2, t2) {
    return r2.toGlobalCoord(r2.dataToCoord(r2.scale.parse(t2)));
  }
  function q1e(r2, t2, e2, n2, a, i, o, s, u, l2) {
    var c2 = u.valueDim, f2 = u.categoryDim, h = Math.abs(e2[f2.wh]), v9 = r2.getItemVisual(t2, "symbolSize"), d2;
    vr(v9) ? d2 = v9.slice() : v9 == null ? d2 = ["100%", "100%"] : d2 = [v9, v9], d2[f2.index] = qr(d2[f2.index], h), d2[c2.index] = qr(d2[c2.index], n2 ? h : Math.abs(i)), l2.symbolSize = d2;
    var m2 = l2.symbolScale = [d2[0] / s, d2[1] / s];
    m2[c2.index] *= (u.isHorizontal ? -1 : 1) * o;
  }
  function Y1e(r2, t2, e2, n2, a) {
    var i = r2.get(W1e) || 0;
    i && (Uk.attr({ scaleX: t2[0], scaleY: t2[1], rotation: e2 }), Uk.updateTransform(), i /= Uk.getLineScale(), i *= t2[n2.valueDim.index]), a.valueLineWidth = i || 0;
  }
  function K1e(r2, t2, e2, n2, a, i, o, s, u, l2, c2, f2) {
    var h = c2.categoryDim, v9 = c2.valueDim, d2 = f2.pxSign, m2 = Math.max(t2[v9.index] + s, 0), b2 = m2;
    if (n2) {
      var _ = Math.abs(u), C = ml(r2.get("symbolMargin"), "15%") + "", M = false;
      C.lastIndexOf("!") === C.length - 1 && (M = true, C = C.slice(0, C.length - 1));
      var E = qr(C, t2[v9.index]), z9 = Math.max(m2 + E * 2, 0), V = M ? 0 : E * 2, $ = jW(n2), U = $ ? n2 : mz((_ + V) / z9), H = _ - U * m2;
      E = H / 2 / (M ? U : Math.max(U - 1, 1)), z9 = m2 + E * 2, V = M ? 0 : E * 2, !$ && n2 !== "fixed" && (U = l2 ? mz((Math.abs(l2) + V) / z9) : 0), b2 = U * z9 - V, f2.repeatTimes = U, f2.symbolMargin = E;
    }
    var q3 = d2 * (b2 / 2), ee = f2.pathPosition = [];
    ee[h.index] = e2[h.wh] / 2, ee[v9.index] = o === "start" ? q3 : o === "end" ? u - q3 : u / 2, i && (ee[0] += i[0], ee[1] += i[1]);
    var oe = f2.bundlePosition = [];
    oe[h.index] = e2[h.xy], oe[v9.index] = e2[v9.xy];
    var ne = f2.barRectShape = qt({}, e2);
    ne[v9.wh] = d2 * Math.max(Math.abs(e2[v9.wh]), Math.abs(ee[v9.index] + q3)), ne[h.wh] = e2[h.wh];
    var be = f2.clipShape = {};
    be[h.xy] = -e2[h.xy], be[h.wh] = c2.ecSize[h.wh], be[v9.xy] = 0, be[v9.wh] = e2[v9.wh];
  }
  function KK(r2) {
    var t2 = r2.symbolPatternSize, e2 = cu(r2.symbolType, -t2 / 2, -t2 / 2, t2, t2);
    return e2.attr({ culling: true }), e2.type !== "image" && e2.setStyle({ strokeNoScale: true }), e2;
  }
  function ZK(r2, t2, e2, n2) {
    var a = r2.__pictorialBundle, i = e2.symbolSize, o = e2.valueLineWidth, s = e2.pathPosition, u = t2.valueDim, l2 = e2.repeatTimes || 0, c2 = 0, f2 = i[t2.valueDim.index] + o + e2.symbolMargin * 2;
    for (fN(r2, function(m2) {
      m2.__pictorialAnimationIndex = c2, m2.__pictorialRepeatTimes = l2, c2 < l2 ? Jx(m2, null, d2(c2), e2, n2) : Jx(m2, null, { scaleX: 0, scaleY: 0 }, e2, n2, function() {
        a.remove(m2);
      }), c2++;
    }); c2 < l2; c2++) {
      var h = KK(e2);
      h.__pictorialAnimationIndex = c2, h.__pictorialRepeatTimes = l2, a.add(h);
      var v9 = d2(c2);
      Jx(h, { x: v9.x, y: v9.y, scaleX: 0, scaleY: 0 }, { scaleX: v9.scaleX, scaleY: v9.scaleY, rotation: v9.rotation }, e2, n2);
    }
    function d2(m2) {
      var b2 = s.slice(), _ = e2.pxSign, C = m2;
      return (e2.symbolRepeatDirection === "start" ? _ > 0 : _ < 0) && (C = l2 - 1 - m2), b2[u.index] = f2 * (C - l2 / 2 + 0.5) + s[u.index], { x: b2[0], y: b2[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation };
    }
  }
  function XK(r2, t2, e2, n2) {
    var a = r2.__pictorialBundle, i = r2.__pictorialMainPath;
    i ? Jx(i, null, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation }, e2, n2) : (i = r2.__pictorialMainPath = KK(e2), a.add(i), Jx(i, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: 0, scaleY: 0, rotation: e2.rotation }, { scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1] }, e2, n2));
  }
  function JK(r2, t2, e2) {
    var n2 = qt({}, t2.barRectShape), a = r2.__pictorialBarRect;
    a ? Jx(a, null, { shape: n2 }, t2, e2) : (a = r2.__pictorialBarRect = new ni({ z2: 2, shape: n2, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), a.disableMorphing = true, r2.add(a));
  }
  function QK(r2, t2, e2, n2) {
    if (e2.symbolClip) {
      var a = r2.__pictorialClipPath, i = qt({}, e2.clipShape), o = t2.valueDim, s = e2.animationModel, u = e2.dataIndex;
      if (a)
        ci(a, { shape: i }, s, u);
      else {
        i[o.wh] = 0, a = new ni({ shape: i }), r2.__pictorialBundle.setClipPath(a), r2.__pictorialClipPath = a;
        var l2 = {};
        l2[o.wh] = e2.clipShape[o.wh], RE[n2 ? "updateProps" : "initProps"](a, { shape: l2 }, s, u);
      }
    }
  }
  function dz(r2, t2) {
    var e2 = r2.getItemModel(t2);
    return e2.getAnimationDelayParams = Z1e, e2.isAnimationEnabled = X1e, e2;
  }
  function Z1e(r2) {
    return { index: r2.__pictorialAnimationIndex, count: r2.__pictorialRepeatTimes };
  }
  function X1e() {
    return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
  }
  function pz(r2, t2, e2, n2) {
    var a = new Fn(), i = new Fn();
    return a.add(i), a.__pictorialBundle = i, i.x = e2.bundlePosition[0], i.y = e2.bundlePosition[1], e2.symbolRepeat ? ZK(a, t2, e2) : XK(a, t2, e2), JK(a, e2, n2), QK(a, t2, e2, n2), a.__pictorialShapeStr = eZ(r2, e2), a.__pictorialSymbolMeta = e2, a;
  }
  function J1e(r2, t2, e2) {
    var n2 = e2.animationModel, a = e2.dataIndex, i = r2.__pictorialBundle;
    ci(i, { x: e2.bundlePosition[0], y: e2.bundlePosition[1] }, n2, a), e2.symbolRepeat ? ZK(r2, t2, e2, true) : XK(r2, t2, e2, true), JK(r2, e2, true), QK(r2, t2, e2, true);
  }
  function gz(r2, t2, e2, n2) {
    var a = n2.__pictorialBarRect;
    a && a.removeTextContent();
    var i = [];
    fN(n2, function(o) {
      i.push(o);
    }), n2.__pictorialMainPath && i.push(n2.__pictorialMainPath), n2.__pictorialClipPath && (e2 = null), ae(i, function(o) {
      my(o, { scaleX: 0, scaleY: 0 }, e2, t2, function() {
        n2.parent && n2.parent.remove(n2);
      });
    }), r2.setItemGraphicEl(t2, null);
  }
  function eZ(r2, t2) {
    return [r2.getItemVisual(t2.dataIndex, "symbol") || "none", !!t2.symbolRepeat, !!t2.symbolClip].join(":");
  }
  function fN(r2, t2, e2) {
    ae(r2.__pictorialBundle.children(), function(n2) {
      n2 !== r2.__pictorialBarRect && t2.call(e2, n2);
    });
  }
  function Jx(r2, t2, e2, n2, a, i) {
    t2 && r2.attr(t2), n2.symbolClip && !a ? e2 && r2.attr(e2) : e2 && RE[a ? "updateProps" : "initProps"](r2, e2, n2.animationModel, n2.dataIndex, i);
  }
  function yz(r2, t2, e2) {
    var n2 = e2.dataIndex, a = e2.itemModel, i = a.getModel("emphasis"), o = i.getModel("itemStyle").getItemStyle(), s = a.getModel(["blur", "itemStyle"]).getItemStyle(), u = a.getModel(["select", "itemStyle"]).getItemStyle(), l2 = a.getShallow("cursor"), c2 = i.get("focus"), f2 = i.get("blurScope"), h = i.get("scale");
    fN(r2, function(m2) {
      if (m2 instanceof Bl) {
        var b2 = m2.style;
        m2.useStyle(qt({ image: b2.image, x: b2.x, y: b2.y, width: b2.width, height: b2.height }, e2.style));
      } else
        m2.useStyle(e2.style);
      var _ = m2.ensureState("emphasis");
      _.style = o, h && (_.scaleX = m2.scaleX * 1.1, _.scaleY = m2.scaleY * 1.1), m2.ensureState("blur").style = s, m2.ensureState("select").style = u, l2 && (m2.cursor = l2), m2.z2 = e2.z2;
    });
    var v9 = t2.valueDim.posDesc[+(e2.boundingLength > 0)], d2 = r2.__pictorialBarRect;
    fc(d2, _l(a), { labelFetcher: t2.seriesModel, labelDataIndex: n2, defaultText: iw(t2.seriesModel.getData(), n2), inheritColor: e2.style.fill, defaultOpacity: e2.style.opacity, defaultOutsidePosition: v9 }), ks(r2, c2, f2, i.get("disabled"));
  }
  function mz(r2) {
    var t2 = Math.round(r2);
    return Math.abs(r2 - t2) < 1e-4 ? t2 : Math.ceil(r2);
  }
  var Q1e = U1e, e_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.hasSymbolVisual = true, e2.defaultSymbol = "roundRect", e2;
    }
    return t2.prototype.getInitialData = function(e2) {
      return e2.stack = null, r2.prototype.getInitialData.apply(this, arguments);
    }, t2.type = "series.pictorialBar", t2.dependencies = ["grid"], t2.defaultOption = Ty(mP.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), t2;
  }(mP), t_e = e_e;
  function r_e(r2) {
    r2.registerChartView(Q1e), r2.registerSeriesModel(t_e), r2.registerLayout(r2.PRIORITY.VISUAL.LAYOUT, Gn(Fq, "pictorialBar")), r2.registerLayout(r2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, Nq("pictorialBar"));
  }
  var n_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._layers = [], e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = e2.getData(), o = this, s = this.group, u = e2.getLayerSeries(), l2 = i.getLayout("layoutInfo"), c2 = l2.rect, f2 = l2.boundaryGap;
      s.x = 0, s.y = c2.y + f2[0];
      function h(b2) {
        return b2.name;
      }
      var v9 = new Dg(this._layersSeries || [], u, h, h), d2 = [];
      v9.add(en(m2, this, "add")).update(en(m2, this, "update")).remove(en(m2, this, "remove")).execute();
      function m2(b2, _, C) {
        var M = o._layers;
        if (b2 === "remove") {
          s.remove(M[_]);
          return;
        }
        for (var E = [], z9 = [], V, $ = u[_].indices, U = 0; U < $.length; U++) {
          var H = i.getItemLayout($[U]), q3 = H.x, ee = H.y0, oe = H.y;
          E.push(q3, ee), z9.push(q3, ee + oe), V = i.getItemVisual($[U], "style");
        }
        var ne, be = i.getItemLayout($[0]), Ee = e2.getModel("label"), ye = Ee.get("margin"), et = e2.getModel("emphasis");
        if (b2 === "add") {
          var Le = d2[_] = new Fn();
          ne = new SY({ shape: { points: E, stackedOnPoints: z9, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), Le.add(ne), s.add(Le), e2.isAnimationEnabled() && ne.setClipPath(a_e(ne.getBoundingRect(), e2, function() {
            ne.removeClipPath();
          }));
        } else {
          var Le = M[C];
          ne = Le.childAt(0), s.add(Le), d2[_] = Le, ci(ne, { shape: { points: E, stackedOnPoints: z9 } }, e2), Wv(ne);
        }
        fc(ne, _l(e2), { labelDataIndex: $[U - 1], defaultText: i.getName($[U - 1]), inheritColor: V.fill }, { normal: { verticalAlign: "middle" } }), ne.setTextConfig({ position: null, local: true });
        var Fe = ne.getTextContent();
        Fe && (Fe.x = be.x - ye, Fe.y = be.y0 + be.y / 2), ne.useStyle(V), i.setItemGraphicEl(_, ne), jl(ne, e2), ks(ne, et.get("focus"), et.get("blurScope"), et.get("disabled"));
      }
      this._layersSeries = u, this._layers = d2;
    }, t2.type = "themeRiver", t2;
  }(Mo);
  function a_e(r2, t2, e2) {
    var n2 = new ni({ shape: { x: r2.x - 10, y: r2.y - 10, width: 0, height: r2.height + 20 } });
    return rs(n2, { shape: { x: r2.x - 50, width: r2.width + 100, height: r2.height + 20 } }, t2, e2), n2;
  }
  var i_e = n_e, qk = 2, o_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2) {
      r2.prototype.init.apply(this, arguments), this.legendVisualProvider = new HE(en(this.getData, this), en(this.getRawData, this));
    }, t2.prototype.fixData = function(e2) {
      var n2 = e2.length, a = {}, i = QR(e2, function(h) {
        return a.hasOwnProperty(h[0] + "") || (a[h[0] + ""] = -1), h[2];
      }), o = [];
      i.buckets.each(function(h, v9) {
        o.push({ name: v9, dataList: h });
      });
      for (var s = o.length, u = 0; u < s; ++u) {
        for (var l2 = o[u].name, c2 = 0; c2 < o[u].dataList.length; ++c2) {
          var f2 = o[u].dataList[c2][0] + "";
          a[f2] = u;
        }
        for (var f2 in a)
          a.hasOwnProperty(f2) && a[f2] !== u && (a[f2] = u, e2[n2] = [f2, 0, l2], n2++);
      }
      return e2;
    }, t2.prototype.getInitialData = function(e2, n2) {
      for (var a = this.getReferringComponents("singleAxis", uu).models[0], i = a.get("type"), o = no(e2.data, function(d2) {
        return d2[2] !== void 0;
      }), s = this.fixData(o || []), u = [], l2 = this.nameMap = mn(), c2 = 0, f2 = 0; f2 < s.length; ++f2)
        u.push(s[f2][qk]), l2.get(s[f2][qk]) || (l2.set(s[f2][qk], c2), c2++);
      var h = jE(s, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: vP(i) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, v9 = new Rc(h, this);
      return v9.initData(s), v9;
    }, t2.prototype.getLayerSeries = function() {
      for (var e2 = this.getData(), n2 = e2.count(), a = [], i = 0; i < n2; ++i)
        a[i] = i;
      var o = e2.mapDimension("single"), s = QR(a, function(l2) {
        return e2.get("name", l2);
      }), u = [];
      return s.buckets.each(function(l2, c2) {
        l2.sort(function(f2, h) {
          return e2.get(o, f2) - e2.get(o, h);
        }), u.push({ name: c2, indices: l2 });
      }), u;
    }, t2.prototype.getAxisTooltipData = function(e2, n2, a) {
      vr(e2) || (e2 = e2 ? [e2] : []);
      for (var i = this.getData(), o = this.getLayerSeries(), s = [], u = o.length, l2, c2 = 0; c2 < u; ++c2) {
        for (var f2 = Number.MAX_VALUE, h = -1, v9 = o[c2].indices.length, d2 = 0; d2 < v9; ++d2) {
          var m2 = i.get(e2[0], o[c2].indices[d2]), b2 = Math.abs(m2 - n2);
          b2 <= f2 && (l2 = m2, f2 = b2, h = o[c2].indices[d2]);
        }
        s.push(h);
      }
      return { dataIndices: s, nestestValue: l2 };
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      var i = this.getData(), o = i.getName(e2), s = i.get(i.mapDimension("value"), e2);
      return Hu("nameValue", { name: o, value: s });
    }, t2.type = "series.themeRiver", t2.dependencies = ["singleAxis"], t2.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, t2;
  }(ns), s_e = o_e;
  function u_e(r2, t2) {
    r2.eachSeriesByType("themeRiver", function(e2) {
      var n2 = e2.getData(), a = e2.coordinateSystem, i = {}, o = a.getRect();
      i.rect = o;
      var s = e2.get("boundaryGap"), u = a.getAxis();
      if (i.boundaryGap = s, u.orient === "horizontal") {
        s[0] = qr(s[0], o.height), s[1] = qr(s[1], o.height);
        var l2 = o.height - s[0] - s[1];
        bz(n2, e2, l2);
      } else {
        s[0] = qr(s[0], o.width), s[1] = qr(s[1], o.width);
        var c2 = o.width - s[0] - s[1];
        bz(n2, e2, c2);
      }
      n2.setLayout("layoutInfo", i);
    });
  }
  function bz(r2, t2, e2) {
    if (!!r2.count())
      for (var n2 = t2.coordinateSystem, a = t2.getLayerSeries(), i = r2.mapDimension("single"), o = r2.mapDimension("value"), s = pr(a, function(b2) {
        return pr(b2.indices, function(_) {
          var C = n2.dataToPoint(r2.get(i, _));
          return C[1] = r2.get(o, _), C;
        });
      }), u = l_e(s), l2 = u.y0, c2 = e2 / u.max, f2 = a.length, h = a[0].indices.length, v9, d2 = 0; d2 < h; ++d2) {
        v9 = l2[d2] * c2, r2.setItemLayout(a[0].indices[d2], { layerIndex: 0, x: s[0][d2][0], y0: v9, y: s[0][d2][1] * c2 });
        for (var m2 = 1; m2 < f2; ++m2)
          v9 += s[m2 - 1][d2][1] * c2, r2.setItemLayout(a[m2].indices[d2], { layerIndex: m2, x: s[m2][d2][0], y0: v9, y: s[m2][d2][1] * c2 });
      }
  }
  function l_e(r2) {
    for (var t2 = r2.length, e2 = r2[0].length, n2 = [], a = [], i = 0, o = 0; o < e2; ++o) {
      for (var s = 0, u = 0; u < t2; ++u)
        s += r2[u][o][1];
      s > i && (i = s), n2.push(s);
    }
    for (var l2 = 0; l2 < e2; ++l2)
      a[l2] = (i - n2[l2]) / 2;
    i = 0;
    for (var c2 = 0; c2 < e2; ++c2) {
      var f2 = n2[c2] + a[c2];
      f2 > i && (i = f2);
    }
    return { y0: a, max: i };
  }
  function c_e(r2) {
    r2.registerChartView(i_e), r2.registerSeriesModel(s_e), r2.registerLayout(u_e), r2.registerProcessor(UE("themeRiver"));
  }
  var f_e = 2, h_e = 4, v_e = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i) {
      var o = r2.call(this) || this;
      o.z2 = f_e, o.textConfig = { inside: true }, zn(o).seriesIndex = n2.seriesIndex;
      var s = new xi({ z2: h_e, silent: e2.getModel().get(["label", "silent"]) });
      return o.setTextContent(s), o.updateData(true, e2, n2, a, i), o;
    }
    return t2.prototype.updateData = function(e2, n2, a, i, o) {
      this.node = n2, n2.piece = this, a = a || this._seriesModel, i = i || this._ecModel;
      var s = this;
      zn(s).dataIndex = n2.dataIndex;
      var u = n2.getModel(), l2 = u.getModel("emphasis"), c2 = n2.getLayout(), f2 = qt({}, c2);
      f2.label = null;
      var h = n2.getVisual("style");
      h.lineJoin = "bevel";
      var v9 = n2.getVisual("decal");
      v9 && (h.decal = hE(v9, o));
      var d2 = Wx(u.getModel("itemStyle"), f2, true);
      qt(f2, d2), ae(Nc, function(C) {
        var M = s.ensureState(C), E = u.getModel([C, "itemStyle"]);
        M.style = E.getItemStyle();
        var z9 = Wx(E, f2);
        z9 && (M.shape = z9);
      }), e2 ? (s.setShape(f2), s.shape.r = c2.r0, ci(s, { shape: { r: c2.r } }, a, n2.dataIndex)) : (ci(s, { shape: f2 }, a), Wv(s)), s.useStyle(h), this._updateLabel(a);
      var m2 = u.getShallow("cursor");
      m2 && s.attr("cursor", m2), this._seriesModel = a || this._seriesModel, this._ecModel = i || this._ecModel;
      var b2 = l2.get("focus"), _ = b2 === "ancestor" ? n2.getAncestorsIndices() : b2 === "descendant" ? n2.getDescendantIndices() : b2;
      ks(this, _, l2.get("blurScope"), l2.get("disabled"));
    }, t2.prototype._updateLabel = function(e2) {
      var n2 = this, a = this.node.getModel(), i = a.getModel("label"), o = this.node.getLayout(), s = o.endAngle - o.startAngle, u = (o.startAngle + o.endAngle) / 2, l2 = Math.cos(u), c2 = Math.sin(u), f2 = this, h = f2.getTextContent(), v9 = this.node.dataIndex, d2 = i.get("minAngle") / 180 * Math.PI, m2 = i.get("show") && !(d2 != null && Math.abs(s) < d2);
      h.ignore = !m2, ae(rE, function(_) {
        var C = _ === "normal" ? a.getModel("label") : a.getModel([_, "label"]), M = _ === "normal", E = M ? h : h.ensureState(_), z9 = e2.getFormattedLabel(v9, _);
        M && (z9 = z9 || n2.node.name), E.style = Hs(C, {}, null, _ !== "normal", true), z9 && (E.style.text = z9);
        var V = C.get("show");
        V != null && !M && (E.ignore = !V);
        var $ = b2(C, "position"), U = M ? f2 : f2.states[_], H = U.style.fill;
        U.textConfig = { outsideFill: C.get("color") === "inherit" ? H : null, inside: $ !== "outside" };
        var q3, ee = b2(C, "distance") || 0, oe = b2(C, "align");
        $ === "outside" ? (q3 = o.r + ee, oe = u > Math.PI / 2 ? "right" : "left") : !oe || oe === "center" ? (s === 2 * Math.PI && o.r0 === 0 ? q3 = 0 : q3 = (o.r + o.r0) / 2, oe = "center") : oe === "left" ? (q3 = o.r0 + ee, u > Math.PI / 2 && (oe = "right")) : oe === "right" && (q3 = o.r - ee, u > Math.PI / 2 && (oe = "left")), E.style.align = oe, E.style.verticalAlign = b2(C, "verticalAlign") || "middle", E.x = q3 * l2 + o.cx, E.y = q3 * c2 + o.cy;
        var ne = b2(C, "rotate"), be = 0;
        ne === "radial" ? (be = -u, be < -Math.PI / 2 && (be += Math.PI)) : ne === "tangential" ? (be = Math.PI / 2 - u, be > Math.PI / 2 ? be -= Math.PI : be < -Math.PI / 2 && (be += Math.PI)) : Ai(ne) && (be = ne * Math.PI / 180), E.rotation = be;
      });
      function b2(_, C) {
        var M = _.get(C);
        return M == null ? i.get(C) : M;
      }
      h.dirtyStyle();
    }, t2;
  }(pf), _z = v_e, X4 = "sunburstRootToNode", xz = "sunburstHighlight", d_e = "sunburstUnhighlight";
  function p_e(r2) {
    r2.registerAction({ type: X4, update: "updateView" }, function(t2, e2) {
      e2.eachComponent({ mainType: "series", subType: "sunburst", query: t2 }, n2);
      function n2(a, i) {
        var o = yE(t2, [X4], a);
        if (o) {
          var s = a.getViewRoot();
          s && (t2.direction = JF(s, o.node) ? "rollUp" : "drillDown"), a.resetViewRoot(o.node);
        }
      }
    }), r2.registerAction({ type: xz, update: "none" }, function(t2, e2, n2) {
      t2 = qt({}, t2), e2.eachComponent({ mainType: "series", subType: "sunburst", query: t2 }, a);
      function a(i) {
        var o = yE(t2, [xz], i);
        o && (t2.dataIndex = o.node.dataIndex);
      }
      n2.dispatchAction(qt(t2, { type: "highlight" }));
    }), r2.registerAction({ type: d_e, update: "updateView" }, function(t2, e2, n2) {
      t2 = qt({}, t2), n2.dispatchAction(qt(t2, { type: "downplay" }));
    });
  }
  var g_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      var o = this;
      this.seriesModel = e2, this.api = a, this.ecModel = n2;
      var s = e2.getData(), u = s.tree.root, l2 = e2.getViewRoot(), c2 = this.group, f2 = e2.get("renderLabelForZeroData"), h = [];
      l2.eachNode(function(C) {
        h.push(C);
      });
      var v9 = this._oldChildren || [];
      d2(h, v9), _(u, l2), this._initEvents(), this._oldChildren = h;
      function d2(C, M) {
        if (C.length === 0 && M.length === 0)
          return;
        new Dg(M, C, E, E).add(z9).update(z9).remove(Gn(z9, null)).execute();
        function E(V) {
          return V.getId();
        }
        function z9(V, $) {
          var U = V == null ? null : C[V], H = $ == null ? null : M[$];
          m2(U, H);
        }
      }
      function m2(C, M) {
        if (!f2 && C && !C.getValue() && (C = null), C !== u && M !== u) {
          if (M && M.piece)
            C ? (M.piece.updateData(false, C, e2, n2, a), s.setItemGraphicEl(C.dataIndex, M.piece)) : b2(M);
          else if (C) {
            var E = new _z(C, e2, n2, a);
            c2.add(E), s.setItemGraphicEl(C.dataIndex, E);
          }
        }
      }
      function b2(C) {
        !C || C.piece && (c2.remove(C.piece), C.piece = null);
      }
      function _(C, M) {
        M.depth > 0 ? (o.virtualPiece ? o.virtualPiece.updateData(false, C, e2, n2, a) : (o.virtualPiece = new _z(C, e2, n2, a), c2.add(o.virtualPiece)), M.piece.off("click"), o.virtualPiece.on("click", function(E) {
          o._rootToNode(M.parentNode);
        })) : o.virtualPiece && (c2.remove(o.virtualPiece), o.virtualPiece = null);
      }
    }, t2.prototype._initEvents = function() {
      var e2 = this;
      this.group.off("click"), this.group.on("click", function(n2) {
        var a = false, i = e2.seriesModel.getViewRoot();
        i.eachNode(function(o) {
          if (!a && o.piece && o.piece === n2.target) {
            var s = o.getModel().get("nodeClick");
            if (s === "rootToNode")
              e2._rootToNode(o);
            else if (s === "link") {
              var u = o.getModel(), l2 = u.get("link");
              if (l2) {
                var c2 = u.get("target", true) || "_blank";
                iP(l2, c2);
              }
            }
            a = true;
          }
        });
      });
    }, t2.prototype._rootToNode = function(e2) {
      e2 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: X4, from: this.uid, seriesId: this.seriesModel.id, targetNode: e2 });
    }, t2.prototype.containPoint = function(e2, n2) {
      var a = n2.getData(), i = a.getItemLayout(0);
      if (i) {
        var o = e2[0] - i.cx, s = e2[1] - i.cy, u = Math.sqrt(o * o + s * s);
        return u <= i.r && u >= i.r0;
      }
    }, t2.type = "sunburst", t2;
  }(Mo), y_e = g_e, m_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.ignoreStyleOnData = true, e2;
    }
    return t2.prototype.getInitialData = function(e2, n2) {
      var a = { name: e2.name, children: e2.data };
      tZ(a);
      var i = this._levelModels = pr(e2.levels || [], function(u) {
        return new To(u, this, n2);
      }, this), o = XF.createTree(a, this, s);
      function s(u) {
        u.wrapMethod("getItemModel", function(l2, c2) {
          var f2 = o.getNodeByDataIndex(c2), h = i[f2.depth];
          return h && (l2.parentModel = h), l2;
        });
      }
      return o.data;
    }, t2.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, t2.prototype.getDataParams = function(e2) {
      var n2 = r2.prototype.getDataParams.apply(this, arguments), a = this.getData().tree.getNodeByDataIndex(e2);
      return n2.treePathInfo = S3(a, this), n2;
    }, t2.prototype.getLevelModel = function(e2) {
      return this._levelModels && this._levelModels[e2.depth];
    }, t2.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, t2.prototype.resetViewRoot = function(e2) {
      e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
      var n2 = this.getRawData().tree.root;
      (!e2 || e2 !== n2 && !n2.contains(e2)) && (this._viewRoot = n2);
    }, t2.prototype.enableAriaDecal = function() {
      aK(this);
    }, t2.type = "series.sunburst", t2.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, t2;
  }(ns);
  function tZ(r2) {
    var t2 = 0;
    ae(r2.children, function(n2) {
      tZ(n2);
      var a = n2.value;
      vr(a) && (a = a[0]), t2 += a;
    });
    var e2 = r2.value;
    vr(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = t2), e2 < 0 && (e2 = 0), vr(r2.value) ? r2.value[0] = e2 : r2.value = e2;
  }
  var b_e = m_e, wz = Math.PI / 180;
  function x_e(r2, t2, e2) {
    t2.eachSeriesByType(r2, function(n2) {
      var a = n2.get("center"), i = n2.get("radius");
      vr(i) || (i = [0, i]), vr(a) || (a = [a, a]);
      var o = e2.getWidth(), s = e2.getHeight(), u = Math.min(o, s), l2 = qr(a[0], o), c2 = qr(a[1], s), f2 = qr(i[0], u / 2), h = qr(i[1], u / 2), v9 = -n2.get("startAngle") * wz, d2 = n2.get("minAngle") * wz, m2 = n2.getData().tree.root, b2 = n2.getViewRoot(), _ = b2.depth, C = n2.get("sort");
      C != null && rZ(b2, C);
      var M = 0;
      ae(b2.children, function(ye) {
        !isNaN(ye.getValue()) && M++;
      });
      var E = b2.getValue(), z9 = Math.PI / (E || M) * 2, V = b2.depth > 0, $ = b2.height - (V ? -1 : 1), U = (h - f2) / ($ || 1), H = n2.get("clockwise"), q3 = n2.get("stillShowZeroSum"), ee = H ? 1 : -1, oe = function(ye, et) {
        if (!!ye) {
          var Le = et;
          if (ye !== m2) {
            var Fe = ye.getValue(), qe = E === 0 && q3 ? z9 : Fe * z9;
            qe < d2 && (qe = d2), Le = et + ee * qe;
            var st = ye.depth - _ - (V ? -1 : 1), dt = f2 + U * st, Ar = f2 + U * (st + 1), Hr = n2.getLevelModel(ye);
            if (Hr) {
              var hn = Hr.get("r0", true), cn = Hr.get("r", true), nn = Hr.get("radius", true);
              nn != null && (hn = nn[0], cn = nn[1]), hn != null && (dt = qr(hn, u / 2)), cn != null && (Ar = qr(cn, u / 2));
            }
            ye.setLayout({ angle: qe, startAngle: et, endAngle: Le, clockwise: H, cx: l2, cy: c2, r0: dt, r: Ar });
          }
          if (ye.children && ye.children.length) {
            var Wr = 0;
            ae(ye.children, function(on) {
              Wr += oe(on, et + Wr);
            });
          }
          return Le - et;
        }
      };
      if (V) {
        var ne = f2, be = f2 + U, Ee = Math.PI * 2;
        m2.setLayout({ angle: Ee, startAngle: v9, endAngle: v9 + Ee, clockwise: H, cx: l2, cy: c2, r0: ne, r: be });
      }
      oe(b2, v9);
    });
  }
  function rZ(r2, t2) {
    var e2 = r2.children || [];
    r2.children = w_e(e2, t2), e2.length && ae(r2.children, function(n2) {
      rZ(n2, t2);
    });
  }
  function w_e(r2, t2) {
    if (xn(t2)) {
      var e2 = pr(r2, function(a, i) {
        var o = a.getValue();
        return { params: { depth: a.depth, height: a.height, dataIndex: a.dataIndex, getValue: function() {
          return o;
        } }, index: i };
      });
      return e2.sort(function(a, i) {
        return t2(a.params, i.params);
      }), pr(e2, function(a) {
        return r2[a.index];
      });
    } else {
      var n2 = t2 === "asc";
      return r2.sort(function(a, i) {
        var o = (a.getValue() - i.getValue()) * (n2 ? 1 : -1);
        return o === 0 ? (a.dataIndex - i.dataIndex) * (n2 ? -1 : 1) : o;
      });
    }
  }
  function S_e(r2) {
    var t2 = {};
    function e2(n2, a, i) {
      for (var o = n2; o && o.depth > 1; )
        o = o.parentNode;
      var s = a.getColorFromPalette(o.name || o.dataIndex + "", t2);
      return n2.depth > 1 && Zr(s) && (s = GR(s, (n2.depth - 1) / (i - 1) * 0.5)), s;
    }
    r2.eachSeriesByType("sunburst", function(n2) {
      var a = n2.getData(), i = a.tree;
      i.eachNode(function(o) {
        var s = o.getModel(), u = s.getModel("itemStyle").getItemStyle();
        u.fill || (u.fill = e2(o, n2, i.root.height));
        var l2 = a.ensureUniqueItemVisual(o.dataIndex, "style");
        qt(l2, u);
      });
    });
  }
  function C_e(r2) {
    r2.registerChartView(y_e), r2.registerSeriesModel(b_e), r2.registerLayout(Gn(x_e, "sunburst")), r2.registerProcessor(Gn(UE, "sunburst")), r2.registerVisual(S_e), p_e(r2);
  }
  var Sz = { color: "fill", borderColor: "stroke" }, E_e = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, Eg = fi(), A_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.optionUpdated = function() {
      this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
    }, t2.prototype.getInitialData = function(e2, n2) {
      return kg(null, this);
    }, t2.prototype.getDataParams = function(e2, n2, a) {
      var i = r2.prototype.getDataParams.call(this, e2, n2);
      return a && (i.info = Eg(a).info), i;
    }, t2.type = "series.custom", t2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], t2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, t2;
  }(ns), T_e = A_e;
  function M_e(r2, t2) {
    return t2 = t2 || [0, 0], pr(["x", "y"], function(e2, n2) {
      var a = this.getAxis(e2), i = t2[n2], o = r2[n2] / 2;
      return a.type === "category" ? a.getBandWidth() : Math.abs(a.dataToCoord(i - o) - a.dataToCoord(i + o));
    }, this);
  }
  function P_e(r2) {
    var t2 = r2.master.getRect();
    return { coordSys: { type: "cartesian2d", x: t2.x, y: t2.y, width: t2.width, height: t2.height }, api: { coord: function(e2) {
      return r2.dataToPoint(e2);
    }, size: en(M_e, r2) } };
  }
  function D_e(r2, t2) {
    return t2 = t2 || [0, 0], pr([0, 1], function(e2) {
      var n2 = t2[e2], a = r2[e2] / 2, i = [], o = [];
      return i[e2] = n2 - a, o[e2] = n2 + a, i[1 - e2] = o[1 - e2] = t2[1 - e2], Math.abs(this.dataToPoint(i)[e2] - this.dataToPoint(o)[e2]);
    }, this);
  }
  function I_e(r2) {
    var t2 = r2.getBoundingRect();
    return { coordSys: { type: "geo", x: t2.x, y: t2.y, width: t2.width, height: t2.height, zoom: r2.getZoom() }, api: { coord: function(e2) {
      return r2.dataToPoint(e2);
    }, size: en(D_e, r2) } };
  }
  function L_e(r2, t2) {
    var e2 = this.getAxis(), n2 = t2 instanceof Array ? t2[0] : t2, a = (r2 instanceof Array ? r2[0] : r2) / 2;
    return e2.type === "category" ? e2.getBandWidth() : Math.abs(e2.dataToCoord(n2 - a) - e2.dataToCoord(n2 + a));
  }
  function O_e(r2) {
    var t2 = r2.getRect();
    return { coordSys: { type: "singleAxis", x: t2.x, y: t2.y, width: t2.width, height: t2.height }, api: { coord: function(e2) {
      return r2.dataToPoint(e2);
    }, size: en(L_e, r2) } };
  }
  function k_e(r2, t2) {
    return t2 = t2 || [0, 0], pr(["Radius", "Angle"], function(e2, n2) {
      var a = "get" + e2 + "Axis", i = this[a](), o = t2[n2], s = r2[n2] / 2, u = i.type === "category" ? i.getBandWidth() : Math.abs(i.dataToCoord(o - s) - i.dataToCoord(o + s));
      return e2 === "Angle" && (u = u * Math.PI / 180), u;
    }, this);
  }
  function R_e(r2) {
    var t2 = r2.getRadiusAxis(), e2 = r2.getAngleAxis(), n2 = t2.getExtent();
    return n2[0] > n2[1] && n2.reverse(), { coordSys: { type: "polar", cx: r2.cx, cy: r2.cy, r: n2[1], r0: n2[0] }, api: { coord: function(a) {
      var i = t2.dataToRadius(a[0]), o = e2.dataToAngle(a[1]), s = r2.coordToPoint([i, o]);
      return s.push(i, o * Math.PI / 180), s;
    }, size: en(k_e, r2) } };
  }
  function F_e(r2) {
    var t2 = r2.getRect(), e2 = r2.getRangeInfo();
    return { coordSys: { type: "calendar", x: t2.x, y: t2.y, width: t2.width, height: t2.height, cellWidth: r2.getCellWidth(), cellHeight: r2.getCellHeight(), rangeInfo: { start: e2.start, end: e2.end, weeks: e2.weeks, dayCount: e2.allDay } }, api: { coord: function(n2, a) {
      return r2.dataToPoint(n2, a);
    } } };
  }
  function nZ(r2, t2, e2, n2) {
    return r2 && (r2.legacy || r2.legacy !== false && !e2 && !n2 && t2 !== "tspan" && (t2 === "text" || sn(r2, "text")));
  }
  function aZ(r2, t2, e2) {
    var n2 = r2, a, i, o;
    if (t2 === "text")
      o = n2;
    else {
      o = {}, sn(n2, "text") && (o.text = n2.text), sn(n2, "rich") && (o.rich = n2.rich), sn(n2, "textFill") && (o.fill = n2.textFill), sn(n2, "textStroke") && (o.stroke = n2.textStroke), sn(n2, "fontFamily") && (o.fontFamily = n2.fontFamily), sn(n2, "fontSize") && (o.fontSize = n2.fontSize), sn(n2, "fontStyle") && (o.fontStyle = n2.fontStyle), sn(n2, "fontWeight") && (o.fontWeight = n2.fontWeight), i = { type: "text", style: o, silent: true }, a = {};
      var s = sn(n2, "textPosition");
      e2 ? a.position = s ? n2.textPosition : "inside" : s && (a.position = n2.textPosition), sn(n2, "textPosition") && (a.position = n2.textPosition), sn(n2, "textOffset") && (a.offset = n2.textOffset), sn(n2, "textRotation") && (a.rotation = n2.textRotation), sn(n2, "textDistance") && (a.distance = n2.textDistance);
    }
    return Cz(o, r2), ae(o.rich, function(u) {
      Cz(u, u);
    }), { textConfig: a, textContent: i };
  }
  function Cz(r2, t2) {
    !t2 || (t2.font = t2.textFont || t2.font, sn(t2, "textStrokeWidth") && (r2.lineWidth = t2.textStrokeWidth), sn(t2, "textAlign") && (r2.align = t2.textAlign), sn(t2, "textVerticalAlign") && (r2.verticalAlign = t2.textVerticalAlign), sn(t2, "textLineHeight") && (r2.lineHeight = t2.textLineHeight), sn(t2, "textWidth") && (r2.width = t2.textWidth), sn(t2, "textHeight") && (r2.height = t2.textHeight), sn(t2, "textBackgroundColor") && (r2.backgroundColor = t2.textBackgroundColor), sn(t2, "textPadding") && (r2.padding = t2.textPadding), sn(t2, "textBorderColor") && (r2.borderColor = t2.textBorderColor), sn(t2, "textBorderWidth") && (r2.borderWidth = t2.textBorderWidth), sn(t2, "textBorderRadius") && (r2.borderRadius = t2.textBorderRadius), sn(t2, "textBoxShadowColor") && (r2.shadowColor = t2.textBoxShadowColor), sn(t2, "textBoxShadowBlur") && (r2.shadowBlur = t2.textBoxShadowBlur), sn(t2, "textBoxShadowOffsetX") && (r2.shadowOffsetX = t2.textBoxShadowOffsetX), sn(t2, "textBoxShadowOffsetY") && (r2.shadowOffsetY = t2.textBoxShadowOffsetY));
  }
  function Ez(r2, t2, e2) {
    var n2 = r2;
    n2.textPosition = n2.textPosition || e2.position || "inside", e2.offset != null && (n2.textOffset = e2.offset), e2.rotation != null && (n2.textRotation = e2.rotation), e2.distance != null && (n2.textDistance = e2.distance);
    var a = n2.textPosition.indexOf("inside") >= 0, i = r2.fill || "#000";
    Az(n2, t2);
    var o = n2.textFill == null;
    return a ? o && (n2.textFill = e2.insideFill || "#fff", !n2.textStroke && e2.insideStroke && (n2.textStroke = e2.insideStroke), !n2.textStroke && (n2.textStroke = i), n2.textStrokeWidth == null && (n2.textStrokeWidth = 2)) : (o && (n2.textFill = r2.fill || e2.outsideFill || "#000"), !n2.textStroke && e2.outsideStroke && (n2.textStroke = e2.outsideStroke)), n2.text = t2.text, n2.rich = t2.rich, ae(t2.rich, function(s) {
      Az(s, s);
    }), n2;
  }
  function Az(r2, t2) {
    !t2 || (sn(t2, "fill") && (r2.textFill = t2.fill), sn(t2, "stroke") && (r2.textStroke = t2.fill), sn(t2, "lineWidth") && (r2.textStrokeWidth = t2.lineWidth), sn(t2, "font") && (r2.font = t2.font), sn(t2, "fontStyle") && (r2.fontStyle = t2.fontStyle), sn(t2, "fontWeight") && (r2.fontWeight = t2.fontWeight), sn(t2, "fontSize") && (r2.fontSize = t2.fontSize), sn(t2, "fontFamily") && (r2.fontFamily = t2.fontFamily), sn(t2, "align") && (r2.textAlign = t2.align), sn(t2, "verticalAlign") && (r2.textVerticalAlign = t2.verticalAlign), sn(t2, "lineHeight") && (r2.textLineHeight = t2.lineHeight), sn(t2, "width") && (r2.textWidth = t2.width), sn(t2, "height") && (r2.textHeight = t2.height), sn(t2, "backgroundColor") && (r2.textBackgroundColor = t2.backgroundColor), sn(t2, "padding") && (r2.textPadding = t2.padding), sn(t2, "borderColor") && (r2.textBorderColor = t2.borderColor), sn(t2, "borderWidth") && (r2.textBorderWidth = t2.borderWidth), sn(t2, "borderRadius") && (r2.textBorderRadius = t2.borderRadius), sn(t2, "shadowColor") && (r2.textBoxShadowColor = t2.shadowColor), sn(t2, "shadowBlur") && (r2.textBoxShadowBlur = t2.shadowBlur), sn(t2, "shadowOffsetX") && (r2.textBoxShadowOffsetX = t2.shadowOffsetX), sn(t2, "shadowOffsetY") && (r2.textBoxShadowOffsetY = t2.shadowOffsetY), sn(t2, "textShadowColor") && (r2.textShadowColor = t2.textShadowColor), sn(t2, "textShadowBlur") && (r2.textShadowBlur = t2.textShadowBlur), sn(t2, "textShadowOffsetX") && (r2.textShadowOffsetX = t2.textShadowOffsetX), sn(t2, "textShadowOffsetY") && (r2.textShadowOffsetY = t2.textShadowOffsetY));
  }
  var iZ = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, Tz = ja(iZ);
  Qd(tp, function(r2, t2) {
    return r2[t2] = 1, r2;
  }, {});
  tp.join(", ");
  var AP = ["", "style", "shape", "extra"], uw = fi();
  function hN(r2, t2, e2, n2, a) {
    var i = r2 + "Animation", o = dw(r2, n2, a) || {}, s = uw(t2).userDuring;
    return o.duration > 0 && (o.during = s ? en(z_e, { el: t2, userDuring: s }) : null, o.setToFinal = true, o.scope = r2), qt(o, e2[i]), o;
  }
  function N5(r2, t2, e2, n2) {
    n2 = n2 || {};
    var a = n2.dataIndex, i = n2.isInit, o = n2.clearStyle, s = e2.isAnimationEnabled(), u = uw(r2), l2 = t2.style;
    u.userDuring = t2.during;
    var c2 = {}, f2 = {};
    if (G_e(r2, t2, f2), Pz("shape", t2, f2), Pz("extra", t2, f2), !i && s && ($_e(r2, t2, c2), Mz("shape", r2, t2, c2), Mz("extra", r2, t2, c2), W_e(r2, t2, l2, c2)), f2.style = l2, N_e(r2, f2, o), j_e(r2, t2), s)
      if (i) {
        var h = {};
        ae(AP, function(d2) {
          var m2 = d2 ? t2[d2] : t2;
          m2 && m2.enterFrom && (d2 && (h[d2] = h[d2] || {}), qt(d2 ? h[d2] : h, m2.enterFrom));
        });
        var v9 = hN("enter", r2, t2, e2, a);
        v9.duration > 0 && r2.animateFrom(h, v9);
      } else
        V_e(r2, t2, a || 0, e2, c2);
    oZ(r2, t2), l2 ? r2.dirty() : r2.markRedraw();
  }
  function oZ(r2, t2) {
    for (var e2 = uw(r2).leaveToProps, n2 = 0; n2 < AP.length; n2++) {
      var a = AP[n2], i = a ? t2[a] : t2;
      i && i.leaveTo && (e2 || (e2 = uw(r2).leaveToProps = {}), a && (e2[a] = e2[a] || {}), qt(a ? e2[a] : e2, i.leaveTo));
    }
  }
  function A3(r2, t2, e2, n2) {
    if (r2) {
      var a = r2.parent, i = uw(r2).leaveToProps;
      if (i) {
        var o = hN("update", r2, t2, e2, 0);
        o.done = function() {
          a.remove(r2), n2 && n2();
        }, r2.animateTo(i, o);
      } else
        a.remove(r2), n2 && n2();
    }
  }
  function Jb(r2) {
    return r2 === "all";
  }
  function N_e(r2, t2, e2) {
    var n2 = t2.style;
    if (!r2.isGroup && n2) {
      if (e2) {
        r2.useStyle({});
        for (var a = r2.animators, i = 0; i < a.length; i++) {
          var o = a[i];
          o.targetName === "style" && o.changeTarget(r2.style);
        }
      }
      r2.setStyle(n2);
    }
    t2 && (t2.style = null, t2 && r2.attr(t2), t2.style = n2);
  }
  function V_e(r2, t2, e2, n2, a) {
    if (a) {
      var i = hN("update", r2, t2, n2, e2);
      i.duration > 0 && r2.animateFrom(a, i);
    }
  }
  function j_e(r2, t2) {
    sn(t2, "silent") && (r2.silent = t2.silent), sn(t2, "ignore") && (r2.ignore = t2.ignore), r2 instanceof qh && sn(t2, "invisible") && (r2.invisible = t2.invisible), r2 instanceof xa && sn(t2, "autoBatch") && (r2.autoBatch = t2.autoBatch);
  }
  var Bd = {}, B_e = { setTransform: function(r2, t2) {
    return Bd.el[r2] = t2, this;
  }, getTransform: function(r2) {
    return Bd.el[r2];
  }, setShape: function(r2, t2) {
    var e2 = Bd.el, n2 = e2.shape || (e2.shape = {});
    return n2[r2] = t2, e2.dirtyShape && e2.dirtyShape(), this;
  }, getShape: function(r2) {
    var t2 = Bd.el.shape;
    if (t2)
      return t2[r2];
  }, setStyle: function(r2, t2) {
    var e2 = Bd.el, n2 = e2.style;
    return n2 && (n2[r2] = t2, e2.dirtyStyle && e2.dirtyStyle()), this;
  }, getStyle: function(r2) {
    var t2 = Bd.el.style;
    if (t2)
      return t2[r2];
  }, setExtra: function(r2, t2) {
    var e2 = Bd.el.extra || (Bd.el.extra = {});
    return e2[r2] = t2, this;
  }, getExtra: function(r2) {
    var t2 = Bd.el.extra;
    if (t2)
      return t2[r2];
  } };
  function z_e() {
    var r2 = this, t2 = r2.el;
    if (!!t2) {
      var e2 = uw(t2).userDuring, n2 = r2.userDuring;
      if (e2 !== n2) {
        r2.el = r2.userDuring = null;
        return;
      }
      Bd.el = t2, n2(B_e);
    }
  }
  function Mz(r2, t2, e2, n2) {
    var a = e2[r2];
    if (!!a) {
      var i = t2[r2], o;
      if (i) {
        var s = e2.transition, u = a.transition;
        if (u)
          if (!o && (o = n2[r2] = {}), Jb(u))
            qt(o, i);
          else
            for (var l2 = ao(u), c2 = 0; c2 < l2.length; c2++) {
              var f2 = l2[c2], h = i[f2];
              o[f2] = h;
            }
        else if (Jb(s) || va(s, r2) >= 0) {
          !o && (o = n2[r2] = {});
          for (var v9 = ja(i), c2 = 0; c2 < v9.length; c2++) {
            var f2 = v9[c2], h = i[f2];
            U_e(a[f2], h) && (o[f2] = h);
          }
        }
      }
    }
  }
  function Pz(r2, t2, e2) {
    var n2 = t2[r2];
    if (!!n2)
      for (var a = e2[r2] = {}, i = ja(n2), o = 0; o < i.length; o++) {
        var s = i[o];
        a[s] = OC(n2[s]);
      }
  }
  function $_e(r2, t2, e2) {
    for (var n2 = t2.transition, a = Jb(n2) ? tp : ao(n2 || []), i = 0; i < a.length; i++) {
      var o = a[i];
      if (!(o === "style" || o === "shape" || o === "extra")) {
        var s = r2[o];
        e2[o] = s;
      }
    }
  }
  function G_e(r2, t2, e2) {
    for (var n2 = 0; n2 < Tz.length; n2++) {
      var a = Tz[n2], i = iZ[a], o = t2[a];
      o && (e2[i[0]] = o[0], e2[i[1]] = o[1]);
    }
    for (var n2 = 0; n2 < tp.length; n2++) {
      var s = tp[n2];
      t2[s] != null && (e2[s] = t2[s]);
    }
  }
  function W_e(r2, t2, e2, n2) {
    if (!!e2) {
      var a = r2.style, i;
      if (a) {
        var o = e2.transition, s = t2.transition;
        if (o && !Jb(o)) {
          var u = ao(o);
          !i && (i = n2.style = {});
          for (var l2 = 0; l2 < u.length; l2++) {
            var c2 = u[l2], f2 = a[c2];
            i[c2] = f2;
          }
        } else if (r2.getAnimationStyleProps && (Jb(s) || Jb(o) || va(s, "style") >= 0)) {
          var h = r2.getAnimationStyleProps(), v9 = h ? h.style : null;
          if (v9) {
            !i && (i = n2.style = {});
            for (var d2 = ja(e2), l2 = 0; l2 < d2.length; l2++) {
              var c2 = d2[l2];
              if (v9[c2]) {
                var f2 = a[c2];
                i[c2] = f2;
              }
            }
          }
        }
      }
    }
  }
  function U_e(r2, t2) {
    return lc(r2) ? r2 !== t2 : r2 != null && isFinite(r2);
  }
  var sZ = fi(), H_e = ["percent", "easing", "shape", "style", "extra"];
  function uZ(r2) {
    r2.stopAnimation("keyframe"), r2.attr(sZ(r2));
  }
  function TP(r2, t2, e2) {
    if (!(!e2.isAnimationEnabled() || !t2)) {
      if (vr(t2)) {
        ae(t2, function(s) {
          TP(r2, s, e2);
        });
        return;
      }
      var n2 = t2.keyframes, a = t2.duration;
      if (e2 && a == null) {
        var i = dw("enter", e2, 0);
        a = i && i.duration;
      }
      if (!(!n2 || !a)) {
        var o = sZ(r2);
        ae(AP, function(s) {
          if (!(s && !r2[s])) {
            var u;
            n2.sort(function(l2, c2) {
              return l2.percent - c2.percent;
            }), ae(n2, function(l2) {
              var c2 = r2.animators, f2 = s ? l2[s] : l2;
              if (!!f2) {
                var h = ja(f2);
                if (s || (h = no(h, function(m2) {
                  return va(H_e, m2) < 0;
                })), !!h.length) {
                  u || (u = r2.animate(s, t2.loop, true), u.scope = "keyframe");
                  for (var v9 = 0; v9 < c2.length; v9++)
                    c2[v9] !== u && c2[v9].targetName === u.targetName && c2[v9].stopTracks(h);
                  s && (o[s] = o[s] || {});
                  var d2 = s ? o[s] : o;
                  ae(h, function(m2) {
                    d2[m2] = ((s ? r2[s] : r2) || {})[m2];
                  }), u.whenWithKeys(a * l2.percent, f2, h, l2.easing);
                }
              }
            }), u && u.delay(t2.delay || 0).duration(a).start(t2.easing);
          }
        });
      }
    }
  }
  var Ag = "emphasis", ly = "normal", vN = "blur", dN = "select", Sy = [ly, Ag, vN, dN], Yk = { normal: ["itemStyle"], emphasis: [Ag, "itemStyle"], blur: [vN, "itemStyle"], select: [dN, "itemStyle"] }, Kk = { normal: ["label"], emphasis: [Ag, "label"], blur: [vN, "label"], select: [dN, "label"] }, q_e = ["x", "y"], Y_e = "e\0\0", Dh = { normal: {}, emphasis: {}, blur: {}, select: {} }, K_e = { cartesian2d: P_e, geo: I_e, singleAxis: O_e, polar: R_e, calendar: F_e };
  function J4(r2) {
    return r2 instanceof xa;
  }
  function Q4(r2) {
    return r2 instanceof qh;
  }
  function Z_e(r2, t2) {
    t2.copyTransform(r2), Q4(t2) && Q4(r2) && (t2.setStyle(r2.style), t2.z = r2.z, t2.z2 = r2.z2, t2.zlevel = r2.zlevel, t2.invisible = r2.invisible, t2.ignore = r2.ignore, J4(t2) && J4(r2) && t2.setShape(r2.shape));
  }
  var X_e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this._progressiveEls = null;
      var o = this._data, s = e2.getData(), u = this.group, l2 = Dz(e2, s, n2, a);
      o || u.removeAll(), s.diff(o).add(function(f2) {
        Zk(a, null, f2, l2(f2, i), e2, u, s);
      }).remove(function(f2) {
        var h = o.getItemGraphicEl(f2);
        A3(h, Eg(h).option, e2);
      }).update(function(f2, h) {
        var v9 = o.getItemGraphicEl(h);
        Zk(a, v9, f2, l2(f2, i), e2, u, s);
      }).execute();
      var c2 = e2.get("clip", true) ? _3(e2.coordinateSystem, false, e2) : null;
      c2 ? u.setClipPath(c2) : u.removeClipPath(), this._data = s;
    }, t2.prototype.incrementalPrepareRender = function(e2, n2, a) {
      this.group.removeAll(), this._data = null;
    }, t2.prototype.incrementalRender = function(e2, n2, a, i, o) {
      var s = n2.getData(), u = Dz(n2, s, a, i), l2 = this._progressiveEls = [];
      function c2(v9) {
        v9.isGroup || (v9.incremental = true, v9.ensureState("emphasis").hoverLayer = true);
      }
      for (var f2 = e2.start; f2 < e2.end; f2++) {
        var h = Zk(null, null, f2, u(f2, o), n2, this.group, s);
        h && (h.traverse(c2), l2.push(h));
      }
    }, t2.prototype.eachRendered = function(e2) {
      Ay(this._progressiveEls || this.group, e2);
    }, t2.prototype.filterForExposedEvent = function(e2, n2, a, i) {
      var o = n2.element;
      if (o == null || a.name === o)
        return true;
      for (; (a = a.__hostTarget || a.parent) && a !== this.group; )
        if (a.name === o)
          return true;
      return false;
    }, t2.type = "custom", t2;
  }(Mo), J_e = X_e;
  function pN(r2) {
    var t2 = r2.type, e2;
    if (t2 === "path") {
      var n2 = r2.shape, a = n2.width != null && n2.height != null ? { x: n2.x || 0, y: n2.y || 0, width: n2.width, height: n2.height } : null, i = fZ(n2);
      e2 = r3(i, null, a, n2.layout || "center"), Eg(e2).customPathData = i;
    } else if (t2 === "image")
      e2 = new Bl({}), Eg(e2).customImagePath = r2.style.image;
    else if (t2 === "text")
      e2 = new xi({});
    else if (t2 === "group")
      e2 = new Fn();
    else {
      if (t2 === "compoundPath")
        throw new Error('"compoundPath" is not supported yet.');
      var o = oF(t2);
      if (!o) {
        var s = "";
        Ii(s);
      }
      e2 = new o();
    }
    return Eg(e2).customGraphicType = t2, e2.name = r2.name, e2.z2EmphasisLift = 1, e2.z2SelectLift = 1, e2;
  }
  function gN(r2, t2, e2, n2, a, i, o) {
    uZ(t2);
    var s = a && a.normal.cfg;
    s && t2.setTextConfig(s), n2 && n2.transition == null && (n2.transition = q_e);
    var u = n2 && n2.style;
    if (u) {
      if (t2.type === "text") {
        var l2 = u;
        sn(l2, "textFill") && (l2.fill = l2.textFill), sn(l2, "textStroke") && (l2.stroke = l2.textStroke);
      }
      var c2 = void 0, f2 = J4(t2) ? u.decal : null;
      r2 && f2 && (f2.dirty = true, c2 = hE(f2, r2)), u.__decalPattern = c2;
    }
    if (Q4(t2) && u) {
      var c2 = u.__decalPattern;
      c2 && (u.decal = c2);
    }
    N5(t2, n2, i, { dataIndex: e2, isInit: o, clearStyle: true }), TP(t2, n2.keyframeAnimation, i);
  }
  function lZ(r2, t2, e2, n2, a) {
    var i = t2.isGroup ? null : t2, o = a && a[r2].cfg;
    if (i) {
      var s = i.ensureState(r2);
      if (n2 === false) {
        var u = i.getState(r2);
        u && (u.style = null);
      } else
        s.style = n2 || null;
      o && (s.textConfig = o), r1(i);
    }
  }
  function Q_e(r2, t2, e2) {
    if (!r2.isGroup) {
      var n2 = r2, a = e2.currentZ, i = e2.currentZLevel;
      n2.z = a, n2.zlevel = i;
      var o = t2.z2;
      o != null && (n2.z2 = o || 0);
      for (var s = 0; s < Sy.length; s++)
        exe(n2, t2, Sy[s]);
    }
  }
  function exe(r2, t2, e2) {
    var n2 = e2 === ly, a = n2 ? t2 : MP(t2, e2), i = a ? a.z2 : null, o;
    i != null && (o = n2 ? r2 : r2.ensureState(e2), o.z2 = i || 0);
  }
  function Dz(r2, t2, e2, n2) {
    var a = r2.get("renderItem"), i = r2.coordinateSystem, o = {};
    i && (o = i.prepareCustoms ? i.prepareCustoms(i) : K_e[i.type](i));
    for (var s = En({ getWidth: n2.getWidth, getHeight: n2.getHeight, getZr: n2.getZr, getDevicePixelRatio: n2.getDevicePixelRatio, value: E, style: V, ordinalRawValue: z9, styleEmphasis: $, visual: q3, barLayout: ee, currentSeriesIndices: oe, font: ne }, o.api || {}), u = { context: {}, seriesId: r2.id, seriesName: r2.name, seriesIndex: r2.seriesIndex, coordSys: o.coordSys, dataInsideLength: t2.count(), encode: txe(r2.getData()) }, l2, c2, f2 = {}, h = {}, v9 = {}, d2 = {}, m2 = 0; m2 < Sy.length; m2++) {
      var b2 = Sy[m2];
      v9[b2] = r2.getModel(Yk[b2]), d2[b2] = r2.getModel(Kk[b2]);
    }
    function _(be) {
      return be === l2 ? c2 || (c2 = t2.getItemModel(be)) : t2.getItemModel(be);
    }
    function C(be, Ee) {
      return t2.hasItemOption ? be === l2 ? f2[Ee] || (f2[Ee] = _(be).getModel(Yk[Ee])) : _(be).getModel(Yk[Ee]) : v9[Ee];
    }
    function M(be, Ee) {
      return t2.hasItemOption ? be === l2 ? h[Ee] || (h[Ee] = _(be).getModel(Kk[Ee])) : _(be).getModel(Kk[Ee]) : d2[Ee];
    }
    return function(be, Ee) {
      return l2 = be, c2 = null, f2 = {}, h = {}, a && a(En({ dataIndexInside: be, dataIndex: t2.getRawIndex(be), actionType: Ee ? Ee.type : null }, u), s);
    };
    function E(be, Ee) {
      return Ee == null && (Ee = l2), t2.getStore().get(t2.getDimensionIndex(be || 0), Ee);
    }
    function z9(be, Ee) {
      Ee == null && (Ee = l2), be = be || 0;
      var ye = t2.getDimensionInfo(be);
      if (!ye) {
        var et = t2.getDimensionIndex(be);
        return et >= 0 ? t2.getStore().get(et, Ee) : void 0;
      }
      var Le = t2.get(ye.name, Ee), Fe = ye && ye.ordinalMeta;
      return Fe ? Fe.categories[Le] : Le;
    }
    function V(be, Ee) {
      Ee == null && (Ee = l2);
      var ye = t2.getItemVisual(Ee, "style"), et = ye && ye.fill, Le = ye && ye.opacity, Fe = C(Ee, ly).getItemStyle();
      et != null && (Fe.fill = et), Le != null && (Fe.opacity = Le);
      var qe = { inheritColor: Zr(et) ? et : "#000" }, st = M(Ee, ly), dt = Hs(st, null, qe, false, true);
      dt.text = st.getShallow("show") ? ia(r2.getFormattedLabel(Ee, ly), iw(t2, Ee)) : null;
      var Ar = nP(st, qe, false);
      return H(be, Fe), Fe = Ez(Fe, dt, Ar), be && U(Fe, be), Fe.legacy = true, Fe;
    }
    function $(be, Ee) {
      Ee == null && (Ee = l2);
      var ye = C(Ee, Ag).getItemStyle(), et = M(Ee, Ag), Le = Hs(et, null, null, true, true);
      Le.text = et.getShallow("show") ? _g(r2.getFormattedLabel(Ee, Ag), r2.getFormattedLabel(Ee, ly), iw(t2, Ee)) : null;
      var Fe = nP(et, null, true);
      return H(be, ye), ye = Ez(ye, Le, Fe), be && U(ye, be), ye.legacy = true, ye;
    }
    function U(be, Ee) {
      for (var ye in Ee)
        sn(Ee, ye) && (be[ye] = Ee[ye]);
    }
    function H(be, Ee) {
      be && (be.textFill && (Ee.textFill = be.textFill), be.textPosition && (Ee.textPosition = be.textPosition));
    }
    function q3(be, Ee) {
      if (Ee == null && (Ee = l2), sn(Sz, be)) {
        var ye = t2.getItemVisual(Ee, "style");
        return ye ? ye[Sz[be]] : null;
      }
      if (sn(E_e, be))
        return t2.getItemVisual(Ee, be);
    }
    function ee(be) {
      if (i.type === "cartesian2d") {
        var Ee = i.getBaseAxis();
        return the(En({ axis: Ee }, be));
      }
    }
    function oe() {
      return e2.getCurrentSeriesIndices();
    }
    function ne(be) {
      return WU(be, e2);
    }
  }
  function txe(r2) {
    var t2 = {};
    return ae(r2.dimensions, function(e2) {
      var n2 = r2.getDimensionInfo(e2);
      if (!n2.isExtraCoord) {
        var a = n2.coordDim, i = t2[a] = t2[a] || [];
        i[n2.coordDimIndex] = r2.getDimensionIndex(e2);
      }
    }), t2;
  }
  function Zk(r2, t2, e2, n2, a, i, o) {
    if (!n2) {
      i.remove(t2);
      return;
    }
    var s = yN(r2, t2, e2, n2, a, i);
    return s && o.setItemGraphicEl(e2, s), s && ks(s, n2.focus, n2.blurScope, n2.emphasisDisabled), s;
  }
  function yN(r2, t2, e2, n2, a, i) {
    var o = -1, s = t2;
    t2 && cZ(t2, n2, a) && (o = va(i.childrenRef(), t2), t2 = null);
    var u = !t2, l2 = t2;
    l2 ? l2.clearStates() : (l2 = pN(n2), s && Z_e(s, l2)), n2.morph === false ? l2.disableMorphing = true : l2.disableMorphing && (l2.disableMorphing = false), Dh.normal.cfg = Dh.normal.conOpt = Dh.emphasis.cfg = Dh.emphasis.conOpt = Dh.blur.cfg = Dh.blur.conOpt = Dh.select.cfg = Dh.select.conOpt = null, Dh.isLegacy = false, nxe(l2, e2, n2, a, u, Dh), rxe(l2, e2, n2, a, u), gN(r2, l2, e2, n2, Dh, a, u), sn(n2, "info") && (Eg(l2).info = n2.info);
    for (var c2 = 0; c2 < Sy.length; c2++) {
      var f2 = Sy[c2];
      if (f2 !== ly) {
        var h = MP(n2, f2), v9 = mN(n2, h, f2);
        lZ(f2, l2, h, v9, Dh);
      }
    }
    return Q_e(l2, n2, a), n2.type === "group" && axe(r2, l2, e2, n2, a), o >= 0 ? i.replaceAt(l2, o) : i.add(l2), l2;
  }
  function cZ(r2, t2, e2) {
    var n2 = Eg(r2), a = t2.type, i = t2.shape, o = t2.style;
    return e2.isUniversalTransitionEnabled() || a != null && a !== n2.customGraphicType || a === "path" && sxe(i) && fZ(i) !== n2.customPathData || a === "image" && sn(o, "image") && o.image !== n2.customImagePath;
  }
  function rxe(r2, t2, e2, n2, a) {
    var i = e2.clipPath;
    if (i === false)
      r2 && r2.getClipPath() && r2.removeClipPath();
    else if (i) {
      var o = r2.getClipPath();
      o && cZ(o, i, n2) && (o = null), o || (o = pN(i), r2.setClipPath(o)), gN(null, o, t2, i, null, n2, a);
    }
  }
  function nxe(r2, t2, e2, n2, a, i) {
    if (!r2.isGroup) {
      Iz(e2, null, i), Iz(e2, Ag, i);
      var o = i.normal.conOpt, s = i.emphasis.conOpt, u = i.blur.conOpt, l2 = i.select.conOpt;
      if (o != null || s != null || l2 != null || u != null) {
        var c2 = r2.getTextContent();
        if (o === false)
          c2 && r2.removeTextContent();
        else {
          o = i.normal.conOpt = o || { type: "text" }, c2 ? c2.clearStates() : (c2 = pN(o), r2.setTextContent(c2)), gN(null, c2, t2, o, null, n2, a);
          for (var f2 = o && o.style, h = 0; h < Sy.length; h++) {
            var v9 = Sy[h];
            if (v9 !== ly) {
              var d2 = i[v9].conOpt;
              lZ(v9, c2, d2, mN(o, d2, v9), null);
            }
          }
          f2 ? c2.dirty() : c2.markRedraw();
        }
      }
    }
  }
  function Iz(r2, t2, e2) {
    var n2 = t2 ? MP(r2, t2) : r2, a = t2 ? mN(r2, n2, Ag) : r2.style, i = r2.type, o = n2 ? n2.textConfig : null, s = r2.textContent, u = s ? t2 ? MP(s, t2) : s : null;
    if (a && (e2.isLegacy || nZ(a, i, !!o, !!u))) {
      e2.isLegacy = true;
      var l2 = aZ(a, i, !t2);
      !o && l2.textConfig && (o = l2.textConfig), !u && l2.textContent && (u = l2.textContent);
    }
    if (!t2 && u) {
      var c2 = u;
      !c2.type && (c2.type = "text");
    }
    var f2 = t2 ? e2[t2] : e2.normal;
    f2.cfg = o, f2.conOpt = u;
  }
  function MP(r2, t2) {
    return t2 ? r2 ? r2[t2] : null : r2;
  }
  function mN(r2, t2, e2) {
    var n2 = t2 && t2.style;
    return n2 == null && e2 === Ag && r2 && (n2 = r2.styleEmphasis), n2;
  }
  function axe(r2, t2, e2, n2, a) {
    var i = n2.children, o = i ? i.length : 0, s = n2.$mergeChildren, u = s === "byName" || n2.diffChildrenByName, l2 = s === false;
    if (!(!o && !u && !l2)) {
      if (u) {
        ixe({ api: r2, oldChildren: t2.children() || [], newChildren: i || [], dataIndex: e2, seriesModel: a, group: t2 });
        return;
      }
      l2 && t2.removeAll();
      for (var c2 = 0; c2 < o; c2++)
        i[c2] && yN(r2, t2.childAt(c2), e2, i[c2], a, t2);
      for (var f2 = t2.childCount() - 1; f2 >= c2; f2--) {
        var h = t2.childAt(f2);
        A3(h, Eg(t2).option, a);
      }
    }
  }
  function ixe(r2) {
    new Dg(r2.oldChildren, r2.newChildren, Lz, Lz, r2).add(Oz).update(Oz).remove(oxe).execute();
  }
  function Lz(r2, t2) {
    var e2 = r2 && r2.name;
    return e2 != null ? e2 : Y_e + t2;
  }
  function Oz(r2, t2) {
    var e2 = this.context, n2 = r2 != null ? e2.newChildren[r2] : null, a = t2 != null ? e2.oldChildren[t2] : null;
    yN(e2.api, a, e2.dataIndex, n2, e2.seriesModel, e2.group);
  }
  function oxe(r2) {
    var t2 = this.context, e2 = t2.oldChildren[r2];
    A3(e2, Eg(e2).option, t2.seriesModel);
  }
  function fZ(r2) {
    return r2 && (r2.pathData || r2.d);
  }
  function sxe(r2) {
    return r2 && (sn(r2, "pathData") || sn(r2, "d"));
  }
  function uxe(r2) {
    r2.registerChartView(J_e), r2.registerSeriesModel(T_e);
  }
  var Fb = fi(), kz = On, Xk = en, lxe = function() {
    function r2() {
      this._dragging = false, this.animationThreshold = 15;
    }
    return r2.prototype.render = function(t2, e2, n2, a) {
      var i = e2.get("value"), o = e2.get("status");
      if (this._axisModel = t2, this._axisPointerModel = e2, this._api = n2, !(!a && this._lastValue === i && this._lastStatus === o)) {
        this._lastValue = i, this._lastStatus = o;
        var s = this._group, u = this._handle;
        if (!o || o === "hide") {
          s && s.hide(), u && u.hide();
          return;
        }
        s && s.show(), u && u.show();
        var l2 = {};
        this.makeElOption(l2, i, t2, e2, n2);
        var c2 = l2.graphicKey;
        c2 !== this._lastGraphicKey && this.clear(n2), this._lastGraphicKey = c2;
        var f2 = this._moveAnimation = this.determineAnimation(t2, e2);
        if (!s)
          s = this._group = new Fn(), this.createPointerEl(s, l2, t2, e2), this.createLabelEl(s, l2, t2, e2), n2.getZr().add(s);
        else {
          var h = Gn(Rz, e2, f2);
          this.updatePointerEl(s, l2, h), this.updateLabelEl(s, l2, h, e2);
        }
        Nz(s, e2, true), this._renderHandle(i);
      }
    }, r2.prototype.remove = function(t2) {
      this.clear(t2);
    }, r2.prototype.dispose = function(t2) {
      this.clear(t2);
    }, r2.prototype.determineAnimation = function(t2, e2) {
      var n2 = e2.get("animation"), a = t2.axis, i = a.type === "category", o = e2.get("snap");
      if (!o && !i)
        return false;
      if (n2 === "auto" || n2 == null) {
        var s = this.animationThreshold;
        if (i && a.getBandWidth() > s)
          return true;
        if (o) {
          var u = WF(t2).seriesDataCount, l2 = a.getExtent();
          return Math.abs(l2[0] - l2[1]) / u > s;
        }
        return false;
      }
      return n2 === true;
    }, r2.prototype.makeElOption = function(t2, e2, n2, a, i) {
    }, r2.prototype.createPointerEl = function(t2, e2, n2, a) {
      var i = e2.pointer;
      if (i) {
        var o = Fb(t2).pointerEl = new RE[i.type](kz(e2.pointer));
        t2.add(o);
      }
    }, r2.prototype.createLabelEl = function(t2, e2, n2, a) {
      if (e2.label) {
        var i = Fb(t2).labelEl = new xi(kz(e2.label));
        t2.add(i), Fz(i, a);
      }
    }, r2.prototype.updatePointerEl = function(t2, e2, n2) {
      var a = Fb(t2).pointerEl;
      a && e2.pointer && (a.setStyle(e2.pointer.style), n2(a, { shape: e2.pointer.shape }));
    }, r2.prototype.updateLabelEl = function(t2, e2, n2, a) {
      var i = Fb(t2).labelEl;
      i && (i.setStyle(e2.label.style), n2(i, { x: e2.label.x, y: e2.label.y }), Fz(i, a));
    }, r2.prototype._renderHandle = function(t2) {
      if (!(this._dragging || !this.updateHandleTransform)) {
        var e2 = this._axisPointerModel, n2 = this._api.getZr(), a = this._handle, i = e2.getModel("handle"), o = e2.get("status");
        if (!i.get("show") || !o || o === "hide") {
          a && n2.remove(a), this._handle = null;
          return;
        }
        var s;
        this._handle || (s = true, a = this._handle = kE(i.get("icon"), { cursor: "move", draggable: true, onmousemove: function(l2) {
          Mg(l2.event);
        }, onmousedown: Xk(this._onHandleDragMove, this, 0, 0), drift: Xk(this._onHandleDragMove, this), ondragend: Xk(this._onHandleDragEnd, this) }), n2.add(a)), Nz(a, e2, false), a.setStyle(i.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
        var u = i.get("size");
        vr(u) || (u = [u, u]), a.scaleX = u[0] / 2, a.scaleY = u[1] / 2, Sw(this, "_doDispatchAxisPointer", i.get("throttle") || 0, "fixRate"), this._moveHandleToValue(t2, s);
      }
    }, r2.prototype._moveHandleToValue = function(t2, e2) {
      Rz(this._axisPointerModel, !e2 && this._moveAnimation, this._handle, Jk(this.getHandleTransform(t2, this._axisModel, this._axisPointerModel)));
    }, r2.prototype._onHandleDragMove = function(t2, e2) {
      var n2 = this._handle;
      if (!!n2) {
        this._dragging = true;
        var a = this.updateHandleTransform(Jk(n2), [t2, e2], this._axisModel, this._axisPointerModel);
        this._payloadInfo = a, n2.stopAnimation(), n2.attr(Jk(a)), Fb(n2).lastProp = null, this._doDispatchAxisPointer();
      }
    }, r2.prototype._doDispatchAxisPointer = function() {
      var t2 = this._handle;
      if (!!t2) {
        var e2 = this._payloadInfo, n2 = this._axisModel;
        this._api.dispatchAction({ type: "updateAxisPointer", x: e2.cursorPoint[0], y: e2.cursorPoint[1], tooltipOption: e2.tooltipOption, axesInfo: [{ axisDim: n2.axis.dim, axisIndex: n2.componentIndex }] });
      }
    }, r2.prototype._onHandleDragEnd = function() {
      this._dragging = false;
      var t2 = this._handle;
      if (!!t2) {
        var e2 = this._axisPointerModel.get("value");
        this._moveHandleToValue(e2), this._api.dispatchAction({ type: "hideTip" });
      }
    }, r2.prototype.clear = function(t2) {
      this._lastValue = null, this._lastStatus = null;
      var e2 = t2.getZr(), n2 = this._group, a = this._handle;
      e2 && n2 && (this._lastGraphicKey = null, n2 && e2.remove(n2), a && e2.remove(a), this._group = null, this._handle = null, this._payloadInfo = null), lE(this, "_doDispatchAxisPointer");
    }, r2.prototype.doClear = function() {
    }, r2.prototype.buildLabel = function(t2, e2, n2) {
      return n2 = n2 || 0, { x: t2[n2], y: t2[1 - n2], width: e2[n2], height: e2[1 - n2] };
    }, r2;
  }();
  function Rz(r2, t2, e2, n2) {
    hZ(Fb(e2).lastProp, n2) || (Fb(e2).lastProp = n2, t2 ? ci(e2, n2, r2) : (e2.stopAnimation(), e2.attr(n2)));
  }
  function hZ(r2, t2) {
    if (Tn(r2) && Tn(t2)) {
      var e2 = true;
      return ae(t2, function(n2, a) {
        e2 = e2 && hZ(r2[a], n2);
      }), !!e2;
    } else
      return r2 === t2;
  }
  function Fz(r2, t2) {
    r2[t2.get(["label", "show"]) ? "show" : "hide"]();
  }
  function Jk(r2) {
    return { x: r2.x || 0, y: r2.y || 0, rotation: r2.rotation || 0 };
  }
  function Nz(r2, t2, e2) {
    var n2 = t2.get("z"), a = t2.get("zlevel");
    r2 && r2.traverse(function(i) {
      i.type !== "group" && (n2 != null && (i.z = n2), a != null && (i.zlevel = a), i.silent = e2);
    });
  }
  var bN = lxe;
  function _N(r2) {
    var t2 = r2.get("type"), e2 = r2.getModel(t2 + "Style"), n2;
    return t2 === "line" ? (n2 = e2.getLineStyle(), n2.fill = null) : t2 === "shadow" && (n2 = e2.getAreaStyle(), n2.stroke = null), n2;
  }
  function vZ(r2, t2, e2, n2, a) {
    var i = e2.get("value"), o = dZ(i, t2.axis, t2.ecModel, e2.get("seriesDataIndices"), { precision: e2.get(["label", "precision"]), formatter: e2.get(["label", "formatter"]) }), s = e2.getModel("label"), u = mw(s.get("padding") || 0), l2 = s.getFont(), c2 = PE(o, l2), f2 = a.position, h = c2.width + u[1] + u[3], v9 = c2.height + u[0] + u[2], d2 = a.align;
    d2 === "right" && (f2[0] -= h), d2 === "center" && (f2[0] -= h / 2);
    var m2 = a.verticalAlign;
    m2 === "bottom" && (f2[1] -= v9), m2 === "middle" && (f2[1] -= v9 / 2), cxe(f2, h, v9, n2);
    var b2 = s.get("backgroundColor");
    (!b2 || b2 === "auto") && (b2 = t2.get(["axisLine", "lineStyle", "color"])), r2.label = { x: f2[0], y: f2[1], style: Hs(s, { text: o, font: l2, fill: s.getTextColor(), padding: u, backgroundColor: b2 }), z2: 10 };
  }
  function cxe(r2, t2, e2, n2) {
    var a = n2.getWidth(), i = n2.getHeight();
    r2[0] = Math.min(r2[0] + t2, a) - t2, r2[1] = Math.min(r2[1] + e2, i) - e2, r2[0] = Math.max(r2[0], 0), r2[1] = Math.max(r2[1], 0);
  }
  function dZ(r2, t2, e2, n2, a) {
    r2 = t2.scale.parse(r2);
    var i = t2.scale.getLabel({ value: r2 }, { precision: a.precision }), o = a.formatter;
    if (o) {
      var s = { value: RF(t2, { value: r2 }), axisDimension: t2.dim, axisIndex: t2.index, seriesData: [] };
      ae(n2, function(u) {
        var l2 = e2.getSeriesByIndex(u.seriesIndex), c2 = u.dataIndexInside, f2 = l2 && l2.getDataParams(c2);
        f2 && s.seriesData.push(f2);
      }), Zr(o) ? i = o.replace("{value}", i) : xn(o) && (i = o(s));
    }
    return i;
  }
  function xN(r2, t2, e2) {
    var n2 = Hh();
    return s1(n2, n2, e2.rotation), ep(n2, n2, e2.position), $v([r2.dataToCoord(t2), (e2.labelOffset || 0) + (e2.labelDirection || 1) * (e2.labelMargin || 0)], n2);
  }
  function pZ(r2, t2, e2, n2, a, i) {
    var o = Ig.innerTextLayout(e2.rotation, 0, e2.labelDirection);
    e2.labelMargin = a.get(["label", "margin"]), vZ(t2, n2, a, i, { position: xN(n2.axis, r2, e2), align: o.textAlign, verticalAlign: o.textVerticalAlign });
  }
  function wN(r2, t2, e2) {
    return e2 = e2 || 0, { x1: r2[e2], y1: r2[1 - e2], x2: t2[e2], y2: t2[1 - e2] };
  }
  function gZ(r2, t2, e2) {
    return e2 = e2 || 0, { x: r2[e2], y: r2[1 - e2], width: t2[e2], height: t2[1 - e2] };
  }
  function Vz(r2, t2, e2, n2, a, i) {
    return { cx: r2, cy: t2, r0: e2, r: n2, startAngle: a, endAngle: i, clockwise: true };
  }
  var fxe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.makeElOption = function(e2, n2, a, i, o) {
      var s = a.axis, u = s.grid, l2 = i.get("type"), c2 = jz(u, s).getOtherAxis(s).getGlobalExtent(), f2 = s.toGlobalCoord(s.dataToCoord(n2, true));
      if (l2 && l2 !== "none") {
        var h = _N(i), v9 = hxe[l2](s, f2, c2);
        v9.style = h, e2.graphicKey = v9.type, e2.pointer = v9;
      }
      var d2 = R4(u.model, a);
      pZ(n2, e2, d2, a, i, o);
    }, t2.prototype.getHandleTransform = function(e2, n2, a) {
      var i = R4(n2.axis.grid.model, n2, { labelInside: false });
      i.labelMargin = a.get(["handle", "margin"]);
      var o = xN(n2.axis, e2, i);
      return { x: o[0], y: o[1], rotation: i.rotation + (i.labelDirection < 0 ? Math.PI : 0) };
    }, t2.prototype.updateHandleTransform = function(e2, n2, a, i) {
      var o = a.axis, s = o.grid, u = o.getGlobalExtent(true), l2 = jz(s, o).getOtherAxis(o).getGlobalExtent(), c2 = o.dim === "x" ? 0 : 1, f2 = [e2.x, e2.y];
      f2[c2] += n2[c2], f2[c2] = Math.min(u[1], f2[c2]), f2[c2] = Math.max(u[0], f2[c2]);
      var h = (l2[1] + l2[0]) / 2, v9 = [h, h];
      v9[c2] = f2[c2];
      var d2 = [{ verticalAlign: "middle" }, { align: "center" }];
      return { x: f2[0], y: f2[1], rotation: e2.rotation, cursorPoint: v9, tooltipOption: d2[c2] };
    }, t2;
  }(bN);
  function jz(r2, t2) {
    var e2 = {};
    return e2[t2.dim + "AxisIndex"] = t2.index, r2.getCartesian(e2);
  }
  var hxe = { line: function(r2, t2, e2) {
    var n2 = wN([t2, e2[0]], [t2, e2[1]], Bz(r2));
    return { type: "Line", subPixelOptimize: true, shape: n2 };
  }, shadow: function(r2, t2, e2) {
    var n2 = Math.max(1, r2.getBandWidth()), a = e2[1] - e2[0];
    return { type: "Rect", shape: gZ([t2 - n2 / 2, e2[0]], [n2, a], Bz(r2)) };
  } };
  function Bz(r2) {
    return r2.dim === "x" ? 0 : 1;
  }
  var vxe = fxe, dxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "axisPointer", t2.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, t2;
  }(li), pxe = dxe, bg = fi(), gxe = ae;
  function yZ(r2, t2, e2) {
    if (!Ei.node) {
      var n2 = t2.getZr();
      bg(n2).records || (bg(n2).records = {}), yxe(n2, t2);
      var a = bg(n2).records[r2] || (bg(n2).records[r2] = {});
      a.handler = e2;
    }
  }
  function yxe(r2, t2) {
    if (bg(r2).initialized)
      return;
    bg(r2).initialized = true, e2("click", Gn(zz, "click")), e2("mousemove", Gn(zz, "mousemove")), e2("globalout", bxe);
    function e2(n2, a) {
      r2.on(n2, function(i) {
        var o = _xe(t2);
        gxe(bg(r2).records, function(s) {
          s && a(s, i, o.dispatchAction);
        }), mxe(o.pendings, t2);
      });
    }
  }
  function mxe(r2, t2) {
    var e2 = r2.showTip.length, n2 = r2.hideTip.length, a;
    e2 ? a = r2.showTip[e2 - 1] : n2 && (a = r2.hideTip[n2 - 1]), a && (a.dispatchAction = null, t2.dispatchAction(a));
  }
  function bxe(r2, t2, e2) {
    r2.handler("leave", null, e2);
  }
  function zz(r2, t2, e2, n2) {
    t2.handler(r2, e2, n2);
  }
  function _xe(r2) {
    var t2 = { showTip: [], hideTip: [] }, e2 = function(n2) {
      var a = t2[n2.type];
      a ? a.push(n2) : (n2.dispatchAction = e2, r2.dispatchAction(n2));
    };
    return { dispatchAction: e2, pendings: t2 };
  }
  function e6(r2, t2) {
    if (!Ei.node) {
      var e2 = t2.getZr(), n2 = (bg(e2).records || {})[r2];
      n2 && (bg(e2).records[r2] = null);
    }
  }
  var xxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = n2.getComponent("tooltip"), o = e2.get("triggerOn") || i && i.get("triggerOn") || "mousemove|click";
      yZ("axisPointer", a, function(s, u, l2) {
        o !== "none" && (s === "leave" || o.indexOf(s) >= 0) && l2({ type: "updateAxisPointer", currTrigger: s, x: u && u.offsetX, y: u && u.offsetY });
      });
    }, t2.prototype.remove = function(e2, n2) {
      e6("axisPointer", n2);
    }, t2.prototype.dispose = function(e2, n2) {
      e6("axisPointer", n2);
    }, t2.type = "axisPointer", t2;
  }(gs), wxe = xxe;
  function mZ(r2, t2) {
    var e2 = [], n2 = r2.seriesIndex, a;
    if (n2 == null || !(a = t2.getSeriesByIndex(n2)))
      return { point: [] };
    var i = a.getData(), o = e1(i, r2);
    if (o == null || o < 0 || vr(o))
      return { point: [] };
    var s = i.getItemGraphicEl(o), u = a.coordinateSystem;
    if (a.getTooltipPosition)
      e2 = a.getTooltipPosition(o) || [];
    else if (u && u.dataToPoint)
      if (r2.isStacked) {
        var l2 = u.getBaseAxis(), c2 = u.getOtherAxis(l2), f2 = c2.dim, h = l2.dim, v9 = f2 === "x" || f2 === "radius" ? 1 : 0, d2 = i.mapDimension(h), m2 = [];
        m2[v9] = i.get(d2, o), m2[1 - v9] = i.get(i.getCalculationInfo("stackResultDimension"), o), e2 = u.dataToPoint(m2) || [];
      } else
        e2 = u.dataToPoint(i.getValues(pr(u.dimensions, function(_) {
          return i.mapDimension(_);
        }), o)) || [];
    else if (s) {
      var b2 = s.getBoundingRect().clone();
      b2.applyTransform(s.transform), e2 = [b2.x + b2.width / 2, b2.y + b2.height / 2];
    }
    return { point: e2, el: s };
  }
  var $z = fi();
  function Sxe(r2, t2, e2) {
    var n2 = r2.currTrigger, a = [r2.x, r2.y], i = r2, o = r2.dispatchAction || en(e2.dispatchAction, e2), s = t2.getComponent("axisPointer").coordSysAxesInfo;
    if (!!s) {
      V5(a) && (a = mZ({ seriesIndex: i.seriesIndex, dataIndex: i.dataIndex }, t2).point);
      var u = V5(a), l2 = i.axesInfo, c2 = s.axesInfo, f2 = n2 === "leave" || V5(a), h = {}, v9 = {}, d2 = { list: [], map: {} }, m2 = { showPointer: Gn(Exe, v9), showTooltip: Gn(Axe, d2) };
      ae(s.coordSysMap, function(_, C) {
        var M = u || _.containPoint(a);
        ae(s.coordSysAxesInfo[C], function(E, z9) {
          var V = E.axis, $ = Dxe(l2, E);
          if (!f2 && M && (!l2 || $)) {
            var U = $ && $.value;
            U == null && !u && (U = V.pointToData(a)), U != null && Gz(E, U, m2, false, h);
          }
        });
      });
      var b2 = {};
      return ae(c2, function(_, C) {
        var M = _.linkGroup;
        M && !v9[C] && ae(M.axesInfo, function(E, z9) {
          var V = v9[z9];
          if (E !== _ && V) {
            var $ = V.value;
            M.mapper && ($ = _.axis.scale.parse(M.mapper($, Wz(E), Wz(_)))), b2[_.key] = $;
          }
        });
      }), ae(b2, function(_, C) {
        Gz(c2[C], _, m2, true, h);
      }), Txe(v9, c2, h), Mxe(d2, a, r2, o), Pxe(c2, o, e2), h;
    }
  }
  function Gz(r2, t2, e2, n2, a) {
    var i = r2.axis;
    if (!(i.scale.isBlank() || !i.containData(t2))) {
      if (!r2.involveSeries) {
        e2.showPointer(r2, t2);
        return;
      }
      var o = Cxe(t2, r2), s = o.payloadBatch, u = o.snapToValue;
      s[0] && a.seriesIndex == null && qt(a, s[0]), !n2 && r2.snap && i.containData(u) && u != null && (t2 = u), e2.showPointer(r2, t2, s), e2.showTooltip(r2, o, u);
    }
  }
  function Cxe(r2, t2) {
    var e2 = t2.axis, n2 = e2.dim, a = r2, i = [], o = Number.MAX_VALUE, s = -1;
    return ae(t2.seriesModels, function(u, l2) {
      var c2 = u.getData().mapDimensionsAll(n2), f2, h;
      if (u.getAxisTooltipData) {
        var v9 = u.getAxisTooltipData(c2, r2, e2);
        h = v9.dataIndices, f2 = v9.nestestValue;
      } else {
        if (h = u.getData().indicesOfNearest(c2[0], r2, e2.type === "category" ? 0.5 : null), !h.length)
          return;
        f2 = u.getData().get(c2[0], h[0]);
      }
      if (!(f2 == null || !isFinite(f2))) {
        var d2 = r2 - f2, m2 = Math.abs(d2);
        m2 <= o && ((m2 < o || d2 >= 0 && s < 0) && (o = m2, s = d2, a = f2, i.length = 0), ae(h, function(b2) {
          i.push({ seriesIndex: u.seriesIndex, dataIndexInside: b2, dataIndex: u.getData().getRawIndex(b2) });
        }));
      }
    }), { payloadBatch: i, snapToValue: a };
  }
  function Exe(r2, t2, e2, n2) {
    r2[t2.key] = { value: e2, payloadBatch: n2 };
  }
  function Axe(r2, t2, e2, n2) {
    var a = e2.payloadBatch, i = t2.axis, o = i.model, s = t2.axisPointerModel;
    if (!(!t2.triggerTooltip || !a.length)) {
      var u = t2.coordSys.model, l2 = gE(u), c2 = r2.map[l2];
      c2 || (c2 = r2.map[l2] = { coordSysId: u.id, coordSysIndex: u.componentIndex, coordSysType: u.type, coordSysMainType: u.mainType, dataByAxis: [] }, r2.list.push(c2)), c2.dataByAxis.push({ axisDim: i.dim, axisIndex: o.componentIndex, axisType: o.type, axisId: o.id, value: n2, valueLabelOpt: { precision: s.get(["label", "precision"]), formatter: s.get(["label", "formatter"]) }, seriesDataIndices: a.slice() });
    }
  }
  function Txe(r2, t2, e2) {
    var n2 = e2.axesInfo = [];
    ae(t2, function(a, i) {
      var o = a.axisPointerModel.option, s = r2[i];
      s ? (!a.useHandle && (o.status = "show"), o.value = s.value, o.seriesDataIndices = (s.payloadBatch || []).slice()) : !a.useHandle && (o.status = "hide"), o.status === "show" && n2.push({ axisDim: a.axis.dim, axisIndex: a.axis.model.componentIndex, value: o.value });
    });
  }
  function Mxe(r2, t2, e2, n2) {
    if (V5(t2) || !r2.list.length) {
      n2({ type: "hideTip" });
      return;
    }
    var a = ((r2.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
    n2({ type: "showTip", escapeConnect: true, x: t2[0], y: t2[1], tooltipOption: e2.tooltipOption, position: e2.position, dataIndexInside: a.dataIndexInside, dataIndex: a.dataIndex, seriesIndex: a.seriesIndex, dataByCoordSys: r2.list });
  }
  function Pxe(r2, t2, e2) {
    var n2 = e2.getZr(), a = "axisPointerLastHighlights", i = $z(n2)[a] || {}, o = $z(n2)[a] = {};
    ae(r2, function(l2, c2) {
      var f2 = l2.axisPointerModel.option;
      f2.status === "show" && ae(f2.seriesDataIndices, function(h) {
        var v9 = h.seriesIndex + " | " + h.dataIndex;
        o[v9] = h;
      });
    });
    var s = [], u = [];
    ae(i, function(l2, c2) {
      !o[c2] && u.push(l2);
    }), ae(o, function(l2, c2) {
      !i[c2] && s.push(l2);
    }), u.length && e2.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: u }), s.length && e2.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: s });
  }
  function Dxe(r2, t2) {
    for (var e2 = 0; e2 < (r2 || []).length; e2++) {
      var n2 = r2[e2];
      if (t2.axis.dim === n2.axisDim && t2.axis.model.componentIndex === n2.axisIndex)
        return n2;
    }
  }
  function Wz(r2) {
    var t2 = r2.axis.model, e2 = {}, n2 = e2.axisDim = r2.axis.dim;
    return e2.axisIndex = e2[n2 + "AxisIndex"] = t2.componentIndex, e2.axisName = e2[n2 + "AxisName"] = t2.name, e2.axisId = e2[n2 + "AxisId"] = t2.id, e2;
  }
  function V5(r2) {
    return !r2 || r2[0] == null || isNaN(r2[0]) || r2[1] == null || isNaN(r2[1]);
  }
  function KE(r2) {
    c1.registerAxisPointerClass("CartesianAxisPointer", vxe), r2.registerComponentModel(pxe), r2.registerComponentView(wxe), r2.registerPreprocessor(function(t2) {
      if (t2) {
        (!t2.axisPointer || t2.axisPointer.length === 0) && (t2.axisPointer = {});
        var e2 = t2.axisPointer.link;
        e2 && !vr(e2) && (t2.axisPointer.link = [e2]);
      }
    }), r2.registerProcessor(r2.PRIORITY.PROCESSOR.STATISTIC, function(t2, e2) {
      t2.getComponent("axisPointer").coordSysAxesInfo = ype(t2, e2);
    }), r2.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, Sxe);
  }
  function Ixe(r2) {
    ya(GY), ya(KE);
  }
  var Lxe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.makeElOption = function(e2, n2, a, i, o) {
      var s = a.axis;
      s.dim === "angle" && (this.animationThreshold = Math.PI / 18);
      var u = s.polar, l2 = u.getOtherAxis(s), c2 = l2.getExtent(), f2 = s.dataToCoord(n2), h = i.get("type");
      if (h && h !== "none") {
        var v9 = _N(i), d2 = kxe[h](s, u, f2, c2);
        d2.style = v9, e2.graphicKey = d2.type, e2.pointer = d2;
      }
      var m2 = i.get(["label", "margin"]), b2 = Oxe(n2, a, i, u, m2);
      vZ(e2, a, i, o, b2);
    }, t2;
  }(bN);
  function Oxe(r2, t2, e2, n2, a) {
    var i = t2.axis, o = i.dataToCoord(r2), s = n2.getAngleAxis().getExtent()[0];
    s = s / 180 * Math.PI;
    var u = n2.getRadiusAxis().getExtent(), l2, c2, f2;
    if (i.dim === "radius") {
      var h = Hh();
      s1(h, h, s), ep(h, h, [n2.cx, n2.cy]), l2 = $v([o, -a], h);
      var v9 = t2.getModel("axisLabel").get("rotate") || 0, d2 = Ig.innerTextLayout(s, v9 * Math.PI / 180, -1);
      c2 = d2.textAlign, f2 = d2.textVerticalAlign;
    } else {
      var m2 = u[1];
      l2 = n2.coordToPoint([m2 + a, o]);
      var b2 = n2.cx, _ = n2.cy;
      c2 = Math.abs(l2[0] - b2) / m2 < 0.3 ? "center" : l2[0] > b2 ? "left" : "right", f2 = Math.abs(l2[1] - _) / m2 < 0.3 ? "middle" : l2[1] > _ ? "top" : "bottom";
    }
    return { position: l2, align: c2, verticalAlign: f2 };
  }
  var kxe = { line: function(r2, t2, e2, n2) {
    return r2.dim === "angle" ? { type: "Line", shape: wN(t2.coordToPoint([n2[0], e2]), t2.coordToPoint([n2[1], e2])) } : { type: "Circle", shape: { cx: t2.cx, cy: t2.cy, r: e2 } };
  }, shadow: function(r2, t2, e2, n2) {
    var a = Math.max(1, r2.getBandWidth()), i = Math.PI / 180;
    return r2.dim === "angle" ? { type: "Sector", shape: Vz(t2.cx, t2.cy, n2[0], n2[1], (-e2 - a / 2) * i, (-e2 + a / 2) * i) } : { type: "Sector", shape: Vz(t2.cx, t2.cy, e2 - a / 2, e2 + a / 2, 0, Math.PI * 2) };
  } }, Rxe = Lxe, Fxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.findAxisModel = function(e2) {
      var n2, a = this.ecModel;
      return a.eachComponent(e2, function(i) {
        i.getCoordSysModel() === this && (n2 = i);
      }, this), n2;
    }, t2.type = "polar", t2.dependencies = ["radiusAxis", "angleAxis"], t2.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, t2;
  }(li), Nxe = Fxe, SN = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("polar", uu).models[0];
    }, t2.type = "polarAxis", t2;
  }(li);
  fu(SN, zE);
  var Vxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "angleAxis", t2;
  }(SN), jxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "radiusAxis", t2;
  }(SN), CN = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      return r2.call(this, "radius", e2, n2) || this;
    }
    return t2.prototype.pointToData = function(e2, n2) {
      return this.polar.pointToData(e2, n2)[this.dim === "radius" ? 0 : 1];
    }, t2;
  }(Hv);
  CN.prototype.dataToRadius = Hv.prototype.dataToCoord;
  CN.prototype.radiusToData = Hv.prototype.coordToData;
  var Bxe = CN, zxe = fi(), EN = function(r2) {
    ot(t2, r2);
    function t2(e2, n2) {
      return r2.call(this, "angle", e2, n2 || [0, 360]) || this;
    }
    return t2.prototype.pointToData = function(e2, n2) {
      return this.polar.pointToData(e2, n2)[this.dim === "radius" ? 0 : 1];
    }, t2.prototype.calculateCategoryInterval = function() {
      var e2 = this, n2 = e2.getLabelModel(), a = e2.scale, i = a.getExtent(), o = a.count();
      if (i[1] - i[0] < 1)
        return 0;
      var s = i[0], u = e2.dataToCoord(s + 1) - e2.dataToCoord(s), l2 = Math.abs(u), c2 = PE(s == null ? "" : s + "", n2.getFont(), "center", "top"), f2 = Math.max(c2.height, 7), h = f2 / l2;
      isNaN(h) && (h = 1 / 0);
      var v9 = Math.max(0, Math.floor(h)), d2 = zxe(e2.model), m2 = d2.lastAutoInterval, b2 = d2.lastTickCount;
      return m2 != null && b2 != null && Math.abs(m2 - v9) <= 1 && Math.abs(b2 - o) <= 1 && m2 > v9 ? v9 = m2 : (d2.lastTickCount = o, d2.lastAutoInterval = v9), v9;
    }, t2;
  }(Hv);
  EN.prototype.dataToAngle = Hv.prototype.dataToCoord;
  EN.prototype.angleToData = Hv.prototype.coordToData;
  var $xe = EN, bZ = ["radius", "angle"], Gxe = function() {
    function r2(t2) {
      this.dimensions = bZ, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new Bxe(), this._angleAxis = new $xe(), this.axisPointerEnabled = true, this.name = t2 || "", this._radiusAxis.polar = this._angleAxis.polar = this;
    }
    return r2.prototype.containPoint = function(t2) {
      var e2 = this.pointToCoord(t2);
      return this._radiusAxis.contain(e2[0]) && this._angleAxis.contain(e2[1]);
    }, r2.prototype.containData = function(t2) {
      return this._radiusAxis.containData(t2[0]) && this._angleAxis.containData(t2[1]);
    }, r2.prototype.getAxis = function(t2) {
      var e2 = "_" + t2 + "Axis";
      return this[e2];
    }, r2.prototype.getAxes = function() {
      return [this._radiusAxis, this._angleAxis];
    }, r2.prototype.getAxesByScale = function(t2) {
      var e2 = [], n2 = this._angleAxis, a = this._radiusAxis;
      return n2.scale.type === t2 && e2.push(n2), a.scale.type === t2 && e2.push(a), e2;
    }, r2.prototype.getAngleAxis = function() {
      return this._angleAxis;
    }, r2.prototype.getRadiusAxis = function() {
      return this._radiusAxis;
    }, r2.prototype.getOtherAxis = function(t2) {
      var e2 = this._angleAxis;
      return t2 === e2 ? this._radiusAxis : e2;
    }, r2.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
    }, r2.prototype.getTooltipAxes = function(t2) {
      var e2 = t2 != null && t2 !== "auto" ? this.getAxis(t2) : this.getBaseAxis();
      return { baseAxes: [e2], otherAxes: [this.getOtherAxis(e2)] };
    }, r2.prototype.dataToPoint = function(t2, e2) {
      return this.coordToPoint([this._radiusAxis.dataToRadius(t2[0], e2), this._angleAxis.dataToAngle(t2[1], e2)]);
    }, r2.prototype.pointToData = function(t2, e2) {
      var n2 = this.pointToCoord(t2);
      return [this._radiusAxis.radiusToData(n2[0], e2), this._angleAxis.angleToData(n2[1], e2)];
    }, r2.prototype.pointToCoord = function(t2) {
      var e2 = t2[0] - this.cx, n2 = t2[1] - this.cy, a = this.getAngleAxis(), i = a.getExtent(), o = Math.min(i[0], i[1]), s = Math.max(i[0], i[1]);
      a.inverse ? o = s - 360 : s = o + 360;
      var u = Math.sqrt(e2 * e2 + n2 * n2);
      e2 /= u, n2 /= u;
      for (var l2 = Math.atan2(-n2, e2) / Math.PI * 180, c2 = l2 < o ? 1 : -1; l2 < o || l2 > s; )
        l2 += c2 * 360;
      return [u, l2];
    }, r2.prototype.coordToPoint = function(t2) {
      var e2 = t2[0], n2 = t2[1] / 180 * Math.PI, a = Math.cos(n2) * e2 + this.cx, i = -Math.sin(n2) * e2 + this.cy;
      return [a, i];
    }, r2.prototype.getArea = function() {
      var t2 = this.getAngleAxis(), e2 = this.getRadiusAxis(), n2 = e2.getExtent().slice();
      n2[0] > n2[1] && n2.reverse();
      var a = t2.getExtent(), i = Math.PI / 180;
      return { cx: this.cx, cy: this.cy, r0: n2[0], r: n2[1], startAngle: -a[0] * i, endAngle: -a[1] * i, clockwise: t2.inverse, contain: function(o, s) {
        var u = o - this.cx, l2 = s - this.cy, c2 = u * u + l2 * l2 - 1e-4, f2 = this.r, h = this.r0;
        return c2 <= f2 * f2 && c2 >= h * h;
      } };
    }, r2.prototype.convertToPixel = function(t2, e2, n2) {
      var a = Uz(e2);
      return a === this ? this.dataToPoint(n2) : null;
    }, r2.prototype.convertFromPixel = function(t2, e2, n2) {
      var a = Uz(e2);
      return a === this ? this.pointToData(n2) : null;
    }, r2;
  }();
  function Uz(r2) {
    var t2 = r2.seriesModel, e2 = r2.polarModel;
    return e2 && e2.coordinateSystem || t2 && t2.coordinateSystem;
  }
  var Wxe = Gxe;
  function Uxe(r2, t2, e2) {
    var n2 = t2.get("center"), a = e2.getWidth(), i = e2.getHeight();
    r2.cx = qr(n2[0], a), r2.cy = qr(n2[1], i);
    var o = r2.getRadiusAxis(), s = Math.min(a, i) / 2, u = t2.get("radius");
    u == null ? u = [0, "100%"] : vr(u) || (u = [0, u]);
    var l2 = [qr(u[0], s), qr(u[1], s)];
    o.inverse ? o.setExtent(l2[1], l2[0]) : o.setExtent(l2[0], l2[1]);
  }
  function Hxe(r2, t2) {
    var e2 = this, n2 = e2.getAngleAxis(), a = e2.getRadiusAxis();
    if (n2.scale.setExtent(1 / 0, -1 / 0), a.scale.setExtent(1 / 0, -1 / 0), r2.eachSeries(function(s) {
      if (s.coordinateSystem === e2) {
        var u = s.getData();
        ae(dP(u, "radius"), function(l2) {
          a.scale.unionExtentFromData(u, l2);
        }), ae(dP(u, "angle"), function(l2) {
          n2.scale.unionExtentFromData(u, l2);
        });
      }
    }), aw(n2.scale, n2.model), aw(a.scale, a.model), n2.type === "category" && !n2.onBand) {
      var i = n2.getExtent(), o = 360 / n2.scale.count();
      n2.inverse ? i[1] += o : i[1] -= o, n2.setExtent(i[0], i[1]);
    }
  }
  function qxe(r2) {
    return r2.mainType === "angleAxis";
  }
  function Hz(r2, t2) {
    if (r2.type = t2.get("type"), r2.scale = m3(t2), r2.onBand = t2.get("boundaryGap") && r2.type === "category", r2.inverse = t2.get("inverse"), qxe(t2)) {
      r2.inverse = r2.inverse !== t2.get("clockwise");
      var e2 = t2.get("startAngle");
      r2.setExtent(e2, e2 + (r2.inverse ? -360 : 360));
    }
    t2.axis = r2, r2.model = t2;
  }
  var Yxe = { dimensions: bZ, create: function(r2, t2) {
    var e2 = [];
    return r2.eachComponent("polar", function(n2, a) {
      var i = new Wxe(a + "");
      i.update = Hxe;
      var o = i.getRadiusAxis(), s = i.getAngleAxis(), u = n2.findAxisModel("radiusAxis"), l2 = n2.findAxisModel("angleAxis");
      Hz(o, u), Hz(s, l2), Uxe(i, n2, t2), e2.push(i), n2.coordinateSystem = i, i.model = n2;
    }), r2.eachSeries(function(n2) {
      if (n2.get("coordinateSystem") === "polar") {
        var a = n2.getReferringComponents("polar", uu).models[0];
        n2.coordinateSystem = a.coordinateSystem;
      }
    }), e2;
  } }, Kxe = Yxe, Zxe = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
  function o5(r2, t2, e2) {
    t2[1] > t2[0] && (t2 = t2.slice().reverse());
    var n2 = r2.coordToPoint([t2[0], e2]), a = r2.coordToPoint([t2[1], e2]);
    return { x1: n2[0], y1: n2[1], x2: a[0], y2: a[1] };
  }
  function s5(r2) {
    var t2 = r2.getRadiusAxis();
    return t2.inverse ? 0 : 1;
  }
  function qz(r2) {
    var t2 = r2[0], e2 = r2[r2.length - 1];
    t2 && e2 && Math.abs(Math.abs(t2.coord - e2.coord) - 360) < 1e-4 && r2.pop();
  }
  var Xxe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.axisPointerClass = "PolarAxisPointer", e2;
    }
    return t2.prototype.render = function(e2, n2) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var a = e2.axis, i = a.polar, o = i.getRadiusAxis().getExtent(), s = a.getTicksCoords(), u = a.getMinorTicksCoords(), l2 = pr(a.getViewLabels(), function(c2) {
          c2 = On(c2);
          var f2 = a.scale, h = f2.type === "ordinal" ? f2.getRawOrdinalNumber(c2.tickValue) : c2.tickValue;
          return c2.coord = a.dataToCoord(h), c2;
        });
        qz(l2), qz(s), ae(Zxe, function(c2) {
          e2.get([c2, "show"]) && (!a.scale.isBlank() || c2 === "axisLine") && Jxe[c2](this.group, e2, i, s, u, o, l2);
        }, this);
      }
    }, t2.type = "angleAxis", t2;
  }(c1), Jxe = { axisLine: function(r2, t2, e2, n2, a, i) {
    var o = t2.getModel(["axisLine", "lineStyle"]), s = s5(e2), u = s ? 0 : 1, l2;
    i[u] === 0 ? l2 = new ap({ shape: { cx: e2.cx, cy: e2.cy, r: i[s] }, style: o.getLineStyle(), z2: 1, silent: true }) : l2 = new e3({ shape: { cx: e2.cx, cy: e2.cy, r: i[s], r0: i[u] }, style: o.getLineStyle(), z2: 1, silent: true }), l2.style.fill = null, r2.add(l2);
  }, axisTick: function(r2, t2, e2, n2, a, i) {
    var o = t2.getModel("axisTick"), s = (o.get("inside") ? -1 : 1) * o.get("length"), u = i[s5(e2)], l2 = pr(n2, function(c2) {
      return new bl({ shape: o5(e2, [u, u + s], c2.coord) });
    });
    r2.add(Bh(l2, { style: En(o.getModel("lineStyle").getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) }) }));
  }, minorTick: function(r2, t2, e2, n2, a, i) {
    if (!!a.length) {
      for (var o = t2.getModel("axisTick"), s = t2.getModel("minorTick"), u = (o.get("inside") ? -1 : 1) * s.get("length"), l2 = i[s5(e2)], c2 = [], f2 = 0; f2 < a.length; f2++)
        for (var h = 0; h < a[f2].length; h++)
          c2.push(new bl({ shape: o5(e2, [l2, l2 + u], a[f2][h].coord) }));
      r2.add(Bh(c2, { style: En(s.getModel("lineStyle").getLineStyle(), En(o.getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) })) }));
    }
  }, axisLabel: function(r2, t2, e2, n2, a, i, o) {
    var s = t2.getCategories(true), u = t2.getModel("axisLabel"), l2 = u.get("margin"), c2 = t2.get("triggerEvent");
    ae(o, function(f2, h) {
      var v9 = u, d2 = f2.tickValue, m2 = i[s5(e2)], b2 = e2.coordToPoint([m2 + l2, f2.coord]), _ = e2.cx, C = e2.cy, M = Math.abs(b2[0] - _) / m2 < 0.3 ? "center" : b2[0] > _ ? "left" : "right", E = Math.abs(b2[1] - C) / m2 < 0.3 ? "middle" : b2[1] > C ? "top" : "bottom";
      if (s && s[d2]) {
        var z9 = s[d2];
        Tn(z9) && z9.textStyle && (v9 = new To(z9.textStyle, u, u.ecModel));
      }
      var V = new xi({ silent: Ig.isLabelSilent(t2), style: Hs(v9, { x: b2[0], y: b2[1], fill: v9.getTextColor() || t2.get(["axisLine", "lineStyle", "color"]), text: f2.formattedLabel, align: M, verticalAlign: E }) });
      if (r2.add(V), c2) {
        var $ = Ig.makeAxisEventDataBase(t2);
        $.targetType = "axisLabel", $.value = f2.rawLabel, zn(V).eventData = $;
      }
    }, this);
  }, splitLine: function(r2, t2, e2, n2, a, i) {
    var o = t2.getModel("splitLine"), s = o.getModel("lineStyle"), u = s.get("color"), l2 = 0;
    u = u instanceof Array ? u : [u];
    for (var c2 = [], f2 = 0; f2 < n2.length; f2++) {
      var h = l2++ % u.length;
      c2[h] = c2[h] || [], c2[h].push(new bl({ shape: o5(e2, i, n2[f2].coord) }));
    }
    for (var f2 = 0; f2 < c2.length; f2++)
      r2.add(Bh(c2[f2], { style: En({ stroke: u[f2 % u.length] }, s.getLineStyle()), silent: true, z: t2.get("z") }));
  }, minorSplitLine: function(r2, t2, e2, n2, a, i) {
    if (!!a.length) {
      for (var o = t2.getModel("minorSplitLine"), s = o.getModel("lineStyle"), u = [], l2 = 0; l2 < a.length; l2++)
        for (var c2 = 0; c2 < a[l2].length; c2++)
          u.push(new bl({ shape: o5(e2, i, a[l2][c2].coord) }));
      r2.add(Bh(u, { style: s.getLineStyle(), silent: true, z: t2.get("z") }));
    }
  }, splitArea: function(r2, t2, e2, n2, a, i) {
    if (!!n2.length) {
      var o = t2.getModel("splitArea"), s = o.getModel("areaStyle"), u = s.get("color"), l2 = 0;
      u = u instanceof Array ? u : [u];
      for (var c2 = [], f2 = Math.PI / 180, h = -n2[0].coord * f2, v9 = Math.min(i[0], i[1]), d2 = Math.max(i[0], i[1]), m2 = t2.get("clockwise"), b2 = 1, _ = n2.length; b2 <= _; b2++) {
        var C = b2 === _ ? n2[0].coord : n2[b2].coord, M = l2++ % u.length;
        c2[M] = c2[M] || [], c2[M].push(new pf({ shape: { cx: e2.cx, cy: e2.cy, r0: v9, r: d2, startAngle: h, endAngle: -C * f2, clockwise: m2 }, silent: true })), h = -C * f2;
      }
      for (var b2 = 0; b2 < c2.length; b2++)
        r2.add(Bh(c2[b2], { style: En({ fill: u[b2 % u.length] }, s.getAreaStyle()), silent: true }));
    }
  } }, Qxe = Xxe, ewe = ["axisLine", "axisTickLabel", "axisName"], twe = ["splitLine", "splitArea", "minorSplitLine"], rwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.axisPointerClass = "PolarAxisPointer", e2;
    }
    return t2.prototype.render = function(e2, n2) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var a = this._axisGroup, i = this._axisGroup = new Fn();
        this.group.add(i);
        var o = e2.axis, s = o.polar, u = s.getAngleAxis(), l2 = o.getTicksCoords(), c2 = o.getMinorTicksCoords(), f2 = u.getExtent()[0], h = o.getExtent(), v9 = awe(s, e2, f2), d2 = new Ig(e2, v9);
        ae(ewe, d2.add, d2), i.add(d2.getGroup()), OE(a, i, e2), ae(twe, function(m2) {
          e2.get([m2, "show"]) && !o.scale.isBlank() && nwe[m2](this.group, e2, s, f2, h, l2, c2);
        }, this);
      }
    }, t2.type = "radiusAxis", t2;
  }(c1), nwe = { splitLine: function(r2, t2, e2, n2, a, i) {
    var o = t2.getModel("splitLine"), s = o.getModel("lineStyle"), u = s.get("color"), l2 = 0;
    u = u instanceof Array ? u : [u];
    for (var c2 = [], f2 = 0; f2 < i.length; f2++) {
      var h = l2++ % u.length;
      c2[h] = c2[h] || [], c2[h].push(new ap({ shape: { cx: e2.cx, cy: e2.cy, r: i[f2].coord } }));
    }
    for (var f2 = 0; f2 < c2.length; f2++)
      r2.add(Bh(c2[f2], { style: En({ stroke: u[f2 % u.length], fill: null }, s.getLineStyle()), silent: true }));
  }, minorSplitLine: function(r2, t2, e2, n2, a, i, o) {
    if (!!o.length) {
      for (var s = t2.getModel("minorSplitLine"), u = s.getModel("lineStyle"), l2 = [], c2 = 0; c2 < o.length; c2++)
        for (var f2 = 0; f2 < o[c2].length; f2++)
          l2.push(new ap({ shape: { cx: e2.cx, cy: e2.cy, r: o[c2][f2].coord } }));
      r2.add(Bh(l2, { style: En({ fill: null }, u.getLineStyle()), silent: true }));
    }
  }, splitArea: function(r2, t2, e2, n2, a, i) {
    if (!!i.length) {
      var o = t2.getModel("splitArea"), s = o.getModel("areaStyle"), u = s.get("color"), l2 = 0;
      u = u instanceof Array ? u : [u];
      for (var c2 = [], f2 = i[0].coord, h = 1; h < i.length; h++) {
        var v9 = l2++ % u.length;
        c2[v9] = c2[v9] || [], c2[v9].push(new pf({ shape: { cx: e2.cx, cy: e2.cy, r0: f2, r: i[h].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), f2 = i[h].coord;
      }
      for (var h = 0; h < c2.length; h++)
        r2.add(Bh(c2[h], { style: En({ fill: u[h % u.length] }, s.getAreaStyle()), silent: true }));
    }
  } };
  function awe(r2, t2, e2) {
    return { position: [r2.cx, r2.cy], rotation: e2 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: t2.getModel("axisLabel").get("rotate"), z2: 1 };
  }
  var iwe = rwe;
  function _Z(r2) {
    return r2.get("stack") || "__ec_stack_" + r2.seriesIndex;
  }
  function xZ(r2, t2) {
    return t2.dim + r2.model.componentIndex;
  }
  function owe(r2, t2, e2) {
    var n2 = {}, a = swe(no(t2.getSeriesByType(r2), function(i) {
      return !t2.isSeriesFiltered(i) && i.coordinateSystem && i.coordinateSystem.type === "polar";
    }));
    t2.eachSeriesByType(r2, function(i) {
      if (i.coordinateSystem.type === "polar") {
        var o = i.getData(), s = i.coordinateSystem, u = s.getBaseAxis(), l2 = xZ(s, u), c2 = _Z(i), f2 = a[l2][c2], h = f2.offset, v9 = f2.width, d2 = s.getOtherAxis(u), m2 = i.coordinateSystem.cx, b2 = i.coordinateSystem.cy, _ = i.get("barMinHeight") || 0, C = i.get("barMinAngle") || 0;
        n2[c2] = n2[c2] || [];
        for (var M = o.mapDimension(d2.dim), E = o.mapDimension(u.dim), z9 = _y(o, M), V = u.dim !== "radius" || !i.get("roundCap", true), $ = d2.dataToCoord(0), U = 0, H = o.count(); U < H; U++) {
          var q3 = o.get(M, U), ee = o.get(E, U), oe = q3 >= 0 ? "p" : "n", ne = $;
          z9 && (n2[c2][ee] || (n2[c2][ee] = { p: $, n: $ }), ne = n2[c2][ee][oe]);
          var be = void 0, Ee = void 0, ye = void 0, et = void 0;
          if (d2.dim === "radius") {
            var Le = d2.dataToCoord(q3) - $, Fe = u.dataToCoord(ee);
            Math.abs(Le) < _ && (Le = (Le < 0 ? -1 : 1) * _), be = ne, Ee = ne + Le, ye = Fe - h, et = ye - v9, z9 && (n2[c2][ee][oe] = Ee);
          } else {
            var qe = d2.dataToCoord(q3, V) - $, st = u.dataToCoord(ee);
            Math.abs(qe) < C && (qe = (qe < 0 ? -1 : 1) * C), be = st + h, Ee = be + v9, ye = ne, et = ne + qe, z9 && (n2[c2][ee][oe] = et);
          }
          o.setItemLayout(U, { cx: m2, cy: b2, r0: be, r: Ee, startAngle: -ye * Math.PI / 180, endAngle: -et * Math.PI / 180, clockwise: ye >= et });
        }
      }
    });
  }
  function swe(r2) {
    var t2 = {};
    ae(r2, function(n2, a) {
      var i = n2.getData(), o = n2.coordinateSystem, s = o.getBaseAxis(), u = xZ(o, s), l2 = s.getExtent(), c2 = s.type === "category" ? s.getBandWidth() : Math.abs(l2[1] - l2[0]) / i.count(), f2 = t2[u] || { bandWidth: c2, remainedWidth: c2, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, h = f2.stacks;
      t2[u] = f2;
      var v9 = _Z(n2);
      h[v9] || f2.autoWidthCount++, h[v9] = h[v9] || { width: 0, maxWidth: 0 };
      var d2 = qr(n2.get("barWidth"), c2), m2 = qr(n2.get("barMaxWidth"), c2), b2 = n2.get("barGap"), _ = n2.get("barCategoryGap");
      d2 && !h[v9].width && (d2 = Math.min(f2.remainedWidth, d2), h[v9].width = d2, f2.remainedWidth -= d2), m2 && (h[v9].maxWidth = m2), b2 != null && (f2.gap = b2), _ != null && (f2.categoryGap = _);
    });
    var e2 = {};
    return ae(t2, function(n2, a) {
      e2[a] = {};
      var i = n2.stacks, o = n2.bandWidth, s = qr(n2.categoryGap, o), u = qr(n2.gap, 1), l2 = n2.remainedWidth, c2 = n2.autoWidthCount, f2 = (l2 - s) / (c2 + (c2 - 1) * u);
      f2 = Math.max(f2, 0), ae(i, function(m2, b2) {
        var _ = m2.maxWidth;
        _ && _ < f2 && (_ = Math.min(_, l2), m2.width && (_ = Math.min(_, m2.width)), l2 -= _, m2.width = _, c2--);
      }), f2 = (l2 - s) / (c2 + (c2 - 1) * u), f2 = Math.max(f2, 0);
      var h = 0, v9;
      ae(i, function(m2, b2) {
        m2.width || (m2.width = f2), v9 = m2, h += m2.width * (1 + u);
      }), v9 && (h -= v9.width * u);
      var d2 = -h / 2;
      ae(i, function(m2, b2) {
        e2[a][b2] = e2[a][b2] || { offset: d2, width: m2.width }, d2 += m2.width * (1 + u);
      });
    }), e2;
  }
  var uwe = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, lwe = { splitNumber: 5 }, cwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "polar", t2;
  }(gs);
  function fwe(r2) {
    ya(KE), c1.registerAxisPointerClass("PolarAxisPointer", Rxe), r2.registerCoordinateSystem("polar", Kxe), r2.registerComponentModel(Nxe), r2.registerComponentView(cwe), ow(r2, "angle", Vxe, uwe), ow(r2, "radius", jxe, lwe), r2.registerComponentView(Qxe), r2.registerComponentView(iwe), r2.registerLayout(Gn(owe, "bar"));
  }
  function t6(r2, t2) {
    t2 = t2 || {};
    var e2 = r2.coordinateSystem, n2 = r2.axis, a = {}, i = n2.position, o = n2.orient, s = e2.getRect(), u = [s.x, s.x + s.width, s.y, s.y + s.height], l2 = { horizontal: { top: u[2], bottom: u[3] }, vertical: { left: u[0], right: u[1] } };
    a.position = [o === "vertical" ? l2.vertical[i] : u[0], o === "horizontal" ? l2.horizontal[i] : u[3]];
    var c2 = { horizontal: 0, vertical: 1 };
    a.rotation = Math.PI / 2 * c2[o];
    var f2 = { top: -1, bottom: 1, right: 1, left: -1 };
    a.labelDirection = a.tickDirection = a.nameDirection = f2[i], r2.get(["axisTick", "inside"]) && (a.tickDirection = -a.tickDirection), ml(t2.labelInside, r2.get(["axisLabel", "inside"])) && (a.labelDirection = -a.labelDirection);
    var h = t2.rotate;
    return h == null && (h = r2.get(["axisLabel", "rotate"])), a.labelRotation = i === "top" ? -h : h, a.z2 = 1, a;
  }
  var hwe = ["axisLine", "axisTickLabel", "axisName"], vwe = ["splitArea", "splitLine"], dwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.axisPointerClass = "SingleAxisPointer", e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      var o = this.group;
      o.removeAll();
      var s = this._axisGroup;
      this._axisGroup = new Fn();
      var u = t6(e2), l2 = new Ig(e2, u);
      ae(hwe, l2.add, l2), o.add(this._axisGroup), o.add(l2.getGroup()), ae(vwe, function(c2) {
        e2.get([c2, "show"]) && pwe[c2](this, this.group, this._axisGroup, e2);
      }, this), OE(s, this._axisGroup, e2), r2.prototype.render.call(this, e2, n2, a, i);
    }, t2.prototype.remove = function() {
      BY(this);
    }, t2.type = "singleAxis", t2;
  }(c1), pwe = { splitLine: function(r2, t2, e2, n2) {
    var a = n2.axis;
    if (!a.scale.isBlank()) {
      var i = n2.getModel("splitLine"), o = i.getModel("lineStyle"), s = o.get("color");
      s = s instanceof Array ? s : [s];
      for (var u = n2.coordinateSystem.getRect(), l2 = a.isHorizontal(), c2 = [], f2 = 0, h = a.getTicksCoords({ tickModel: i }), v9 = [], d2 = [], m2 = 0; m2 < h.length; ++m2) {
        var b2 = a.toGlobalCoord(h[m2].coord);
        l2 ? (v9[0] = b2, v9[1] = u.y, d2[0] = b2, d2[1] = u.y + u.height) : (v9[0] = u.x, v9[1] = b2, d2[0] = u.x + u.width, d2[1] = b2);
        var _ = f2++ % s.length;
        c2[_] = c2[_] || [], c2[_].push(new bl({ subPixelOptimize: true, shape: { x1: v9[0], y1: v9[1], x2: d2[0], y2: d2[1] }, silent: true }));
      }
      for (var C = o.getLineStyle(["color"]), m2 = 0; m2 < c2.length; ++m2)
        t2.add(Bh(c2[m2], { style: En({ stroke: s[m2 % s.length] }, C), silent: true }));
    }
  }, splitArea: function(r2, t2, e2, n2) {
    jY(r2, e2, n2, n2);
  } }, gwe = dwe, wZ = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.getCoordSysModel = function() {
      return this;
    }, t2.type = "singleAxis", t2.layoutMode = "box", t2.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, t2;
  }(li);
  fu(wZ, zE.prototype);
  var Qk = wZ, ywe = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i, o) {
      var s = r2.call(this, e2, n2, a) || this;
      return s.type = i || "value", s.position = o || "bottom", s;
    }
    return t2.prototype.isHorizontal = function() {
      var e2 = this.position;
      return e2 === "top" || e2 === "bottom";
    }, t2.prototype.pointToData = function(e2, n2) {
      return this.coordinateSystem.pointToData(e2)[0];
    }, t2;
  }(Hv), mwe = ywe, SZ = ["single"], bwe = function() {
    function r2(t2, e2, n2) {
      this.type = "single", this.dimension = "single", this.dimensions = SZ, this.axisPointerEnabled = true, this.model = t2, this._init(t2, e2, n2);
    }
    return r2.prototype._init = function(t2, e2, n2) {
      var a = this.dimension, i = new mwe(a, m3(t2), [0, 0], t2.get("type"), t2.get("position")), o = i.type === "category";
      i.onBand = o && t2.get("boundaryGap"), i.inverse = t2.get("inverse"), i.orient = t2.get("orient"), t2.axis = i, i.model = t2, i.coordinateSystem = this, this._axis = i;
    }, r2.prototype.update = function(t2, e2) {
      t2.eachSeries(function(n2) {
        if (n2.coordinateSystem === this) {
          var a = n2.getData();
          ae(a.mapDimensionsAll(this.dimension), function(i) {
            this._axis.scale.unionExtentFromData(a, i);
          }, this), aw(this._axis.scale, this._axis.model);
        }
      }, this);
    }, r2.prototype.resize = function(t2, e2) {
      this._rect = Eu({ left: t2.get("left"), top: t2.get("top"), right: t2.get("right"), bottom: t2.get("bottom"), width: t2.get("width"), height: t2.get("height") }, { width: e2.getWidth(), height: e2.getHeight() }), this._adjustAxis();
    }, r2.prototype.getRect = function() {
      return this._rect;
    }, r2.prototype._adjustAxis = function() {
      var t2 = this._rect, e2 = this._axis, n2 = e2.isHorizontal(), a = n2 ? [0, t2.width] : [0, t2.height], i = e2.reverse ? 1 : 0;
      e2.setExtent(a[i], a[1 - i]), this._updateAxisTransform(e2, n2 ? t2.x : t2.y);
    }, r2.prototype._updateAxisTransform = function(t2, e2) {
      var n2 = t2.getExtent(), a = n2[0] + n2[1], i = t2.isHorizontal();
      t2.toGlobalCoord = i ? function(o) {
        return o + e2;
      } : function(o) {
        return a - o + e2;
      }, t2.toLocalCoord = i ? function(o) {
        return o - e2;
      } : function(o) {
        return a - o + e2;
      };
    }, r2.prototype.getAxis = function() {
      return this._axis;
    }, r2.prototype.getBaseAxis = function() {
      return this._axis;
    }, r2.prototype.getAxes = function() {
      return [this._axis];
    }, r2.prototype.getTooltipAxes = function() {
      return { baseAxes: [this.getAxis()], otherAxes: [] };
    }, r2.prototype.containPoint = function(t2) {
      var e2 = this.getRect(), n2 = this.getAxis(), a = n2.orient;
      return a === "horizontal" ? n2.contain(n2.toLocalCoord(t2[0])) && t2[1] >= e2.y && t2[1] <= e2.y + e2.height : n2.contain(n2.toLocalCoord(t2[1])) && t2[0] >= e2.y && t2[0] <= e2.y + e2.height;
    }, r2.prototype.pointToData = function(t2) {
      var e2 = this.getAxis();
      return [e2.coordToData(e2.toLocalCoord(t2[e2.orient === "horizontal" ? 0 : 1]))];
    }, r2.prototype.dataToPoint = function(t2) {
      var e2 = this.getAxis(), n2 = this.getRect(), a = [], i = e2.orient === "horizontal" ? 0 : 1;
      return t2 instanceof Array && (t2 = t2[0]), a[i] = e2.toGlobalCoord(e2.dataToCoord(+t2)), a[1 - i] = i === 0 ? n2.y + n2.height / 2 : n2.x + n2.width / 2, a;
    }, r2.prototype.convertToPixel = function(t2, e2, n2) {
      var a = Yz(e2);
      return a === this ? this.dataToPoint(n2) : null;
    }, r2.prototype.convertFromPixel = function(t2, e2, n2) {
      var a = Yz(e2);
      return a === this ? this.pointToData(n2) : null;
    }, r2;
  }();
  function Yz(r2) {
    var t2 = r2.seriesModel, e2 = r2.singleAxisModel;
    return e2 && e2.coordinateSystem || t2 && t2.coordinateSystem;
  }
  function _we(r2, t2) {
    var e2 = [];
    return r2.eachComponent("singleAxis", function(n2, a) {
      var i = new bwe(n2, r2, t2);
      i.name = "single_" + a, i.resize(n2, t2), n2.coordinateSystem = i, e2.push(i);
    }), r2.eachSeries(function(n2) {
      if (n2.get("coordinateSystem") === "singleAxis") {
        var a = n2.getReferringComponents("singleAxis", uu).models[0];
        n2.coordinateSystem = a && a.coordinateSystem;
      }
    }), e2;
  }
  var xwe = { create: _we, dimensions: SZ }, wwe = xwe, Kz = ["x", "y"], Swe = ["width", "height"], Cwe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.makeElOption = function(e2, n2, a, i, o) {
      var s = a.axis, u = s.coordinateSystem, l2 = eR(u, 1 - PP(s)), c2 = u.dataToPoint(n2)[0], f2 = i.get("type");
      if (f2 && f2 !== "none") {
        var h = _N(i), v9 = Ewe[f2](s, c2, l2);
        v9.style = h, e2.graphicKey = v9.type, e2.pointer = v9;
      }
      var d2 = t6(a);
      pZ(n2, e2, d2, a, i, o);
    }, t2.prototype.getHandleTransform = function(e2, n2, a) {
      var i = t6(n2, { labelInside: false });
      i.labelMargin = a.get(["handle", "margin"]);
      var o = xN(n2.axis, e2, i);
      return { x: o[0], y: o[1], rotation: i.rotation + (i.labelDirection < 0 ? Math.PI : 0) };
    }, t2.prototype.updateHandleTransform = function(e2, n2, a, i) {
      var o = a.axis, s = o.coordinateSystem, u = PP(o), l2 = eR(s, u), c2 = [e2.x, e2.y];
      c2[u] += n2[u], c2[u] = Math.min(l2[1], c2[u]), c2[u] = Math.max(l2[0], c2[u]);
      var f2 = eR(s, 1 - u), h = (f2[1] + f2[0]) / 2, v9 = [h, h];
      return v9[u] = c2[u], { x: c2[0], y: c2[1], rotation: e2.rotation, cursorPoint: v9, tooltipOption: { verticalAlign: "middle" } };
    }, t2;
  }(bN), Ewe = { line: function(r2, t2, e2) {
    var n2 = wN([t2, e2[0]], [t2, e2[1]], PP(r2));
    return { type: "Line", subPixelOptimize: true, shape: n2 };
  }, shadow: function(r2, t2, e2) {
    var n2 = r2.getBandWidth(), a = e2[1] - e2[0];
    return { type: "Rect", shape: gZ([t2 - n2 / 2, e2[0]], [n2, a], PP(r2)) };
  } };
  function PP(r2) {
    return r2.isHorizontal() ? 0 : 1;
  }
  function eR(r2, t2) {
    var e2 = r2.getRect();
    return [e2[Kz[t2]], e2[Kz[t2]] + e2[Swe[t2]]];
  }
  var Awe = Cwe, Twe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "single", t2;
  }(gs);
  function Mwe(r2) {
    ya(KE), c1.registerAxisPointerClass("SingleAxisPointer", Awe), r2.registerComponentView(Twe), r2.registerComponentView(gwe), r2.registerComponentModel(Qk), ow(r2, "single", Qk, Qk.defaultOption), r2.registerCoordinateSystem("single", wwe);
  }
  var Pwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      var i = bw(e2);
      r2.prototype.init.apply(this, arguments), Zz(e2, i);
    }, t2.prototype.mergeOption = function(e2) {
      r2.prototype.mergeOption.apply(this, arguments), Zz(this.option, e2);
    }, t2.prototype.getCellSize = function() {
      return this.option.cellSize;
    }, t2.type = "calendar", t2.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, t2;
  }(li);
  function Zz(r2, t2) {
    var e2 = r2.cellSize, n2;
    vr(e2) ? n2 = e2 : n2 = r2.cellSize = [e2, e2], n2.length === 1 && (n2[1] = n2[0]);
    var a = pr([0, 1], function(i) {
      return kue(t2, i) && (n2[i] = "auto"), n2[i] != null && n2[i] !== "auto";
    });
    by(r2, t2, { type: "box", ignoreSize: a });
  }
  var Dwe = Pwe, Iwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i = this.group;
      i.removeAll();
      var o = e2.coordinateSystem, s = o.getRangeInfo(), u = o.getOrient(), l2 = n2.getLocaleModel();
      this._renderDayRect(e2, s, i), this._renderLines(e2, s, u, i), this._renderYearText(e2, s, u, i), this._renderMonthText(e2, l2, u, i), this._renderWeekText(e2, l2, s, u, i);
    }, t2.prototype._renderDayRect = function(e2, n2, a) {
      for (var i = e2.coordinateSystem, o = e2.getModel("itemStyle").getItemStyle(), s = i.getCellWidth(), u = i.getCellHeight(), l2 = n2.start.time; l2 <= n2.end.time; l2 = i.getNextNDay(l2, 1).time) {
        var c2 = i.dataToRect([l2], false).tl, f2 = new ni({ shape: { x: c2[0], y: c2[1], width: s, height: u }, cursor: "default", style: o });
        a.add(f2);
      }
    }, t2.prototype._renderLines = function(e2, n2, a, i) {
      var o = this, s = e2.coordinateSystem, u = e2.getModel(["splitLine", "lineStyle"]).getLineStyle(), l2 = e2.get(["splitLine", "show"]), c2 = u.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var f2 = n2.start, h = 0; f2.time <= n2.end.time; h++) {
        d2(f2.formatedDate), h === 0 && (f2 = s.getDateInfo(n2.start.y + "-" + n2.start.m));
        var v9 = f2.date;
        v9.setMonth(v9.getMonth() + 1), f2 = s.getDateInfo(v9);
      }
      d2(s.getNextNDay(n2.end.time, 1).formatedDate);
      function d2(m2) {
        o._firstDayOfMonth.push(s.getDateInfo(m2)), o._firstDayPoints.push(s.dataToRect([m2], false).tl);
        var b2 = o._getLinePointsOfOneWeek(e2, m2, a);
        o._tlpoints.push(b2[0]), o._blpoints.push(b2[b2.length - 1]), l2 && o._drawSplitline(b2, u, i);
      }
      l2 && this._drawSplitline(o._getEdgesPoints(o._tlpoints, c2, a), u, i), l2 && this._drawSplitline(o._getEdgesPoints(o._blpoints, c2, a), u, i);
    }, t2.prototype._getEdgesPoints = function(e2, n2, a) {
      var i = [e2[0].slice(), e2[e2.length - 1].slice()], o = a === "horizontal" ? 0 : 1;
      return i[0][o] = i[0][o] - n2 / 2, i[1][o] = i[1][o] + n2 / 2, i;
    }, t2.prototype._drawSplitline = function(e2, n2, a) {
      var i = new yf({ z2: 20, shape: { points: e2 }, style: n2 });
      a.add(i);
    }, t2.prototype._getLinePointsOfOneWeek = function(e2, n2, a) {
      for (var i = e2.coordinateSystem, o = i.getDateInfo(n2), s = [], u = 0; u < 7; u++) {
        var l2 = i.getNextNDay(o.time, u), c2 = i.dataToRect([l2.time], false);
        s[2 * l2.day] = c2.tl, s[2 * l2.day + 1] = c2[a === "horizontal" ? "bl" : "tr"];
      }
      return s;
    }, t2.prototype._formatterLabel = function(e2, n2) {
      return Zr(e2) && e2 ? Iue(e2, n2) : xn(e2) ? e2(n2) : n2.nameMap;
    }, t2.prototype._yearTextPositionControl = function(e2, n2, a, i, o) {
      var s = n2[0], u = n2[1], l2 = ["center", "bottom"];
      i === "bottom" ? (u += o, l2 = ["center", "top"]) : i === "left" ? s -= o : i === "right" ? (s += o, l2 = ["center", "top"]) : u -= o;
      var c2 = 0;
      return (i === "left" || i === "right") && (c2 = Math.PI / 2), { rotation: c2, x: s, y: u, style: { align: l2[0], verticalAlign: l2[1] } };
    }, t2.prototype._renderYearText = function(e2, n2, a, i) {
      var o = e2.getModel("yearLabel");
      if (!!o.get("show")) {
        var s = o.get("margin"), u = o.get("position");
        u || (u = a !== "horizontal" ? "top" : "left");
        var l2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], c2 = (l2[0][0] + l2[1][0]) / 2, f2 = (l2[0][1] + l2[1][1]) / 2, h = a === "horizontal" ? 0 : 1, v9 = { top: [c2, l2[h][1]], bottom: [c2, l2[1 - h][1]], left: [l2[1 - h][0], f2], right: [l2[h][0], f2] }, d2 = n2.start.y;
        +n2.end.y > +n2.start.y && (d2 = d2 + "-" + n2.end.y);
        var m2 = o.get("formatter"), b2 = { start: n2.start.y, end: n2.end.y, nameMap: d2 }, _ = this._formatterLabel(m2, b2), C = new xi({ z2: 30, style: Hs(o, { text: _ }) });
        C.attr(this._yearTextPositionControl(C, v9[u], a, u, s)), i.add(C);
      }
    }, t2.prototype._monthTextPositionControl = function(e2, n2, a, i, o) {
      var s = "left", u = "top", l2 = e2[0], c2 = e2[1];
      return a === "horizontal" ? (c2 = c2 + o, n2 && (s = "center"), i === "start" && (u = "bottom")) : (l2 = l2 + o, n2 && (u = "middle"), i === "start" && (s = "right")), { x: l2, y: c2, align: s, verticalAlign: u };
    }, t2.prototype._renderMonthText = function(e2, n2, a, i) {
      var o = e2.getModel("monthLabel");
      if (!!o.get("show")) {
        var s = o.get("nameMap"), u = o.get("margin"), l2 = o.get("position"), c2 = o.get("align"), f2 = [this._tlpoints, this._blpoints];
        (!s || Zr(s)) && (s && (n2 = f4(s) || n2), s = n2.get(["time", "monthAbbr"]) || []);
        var h = l2 === "start" ? 0 : 1, v9 = a === "horizontal" ? 0 : 1;
        u = l2 === "start" ? -u : u;
        for (var d2 = c2 === "center", m2 = 0; m2 < f2[h].length - 1; m2++) {
          var b2 = f2[h][m2].slice(), _ = this._firstDayOfMonth[m2];
          if (d2) {
            var C = this._firstDayPoints[m2];
            b2[v9] = (C[v9] + f2[0][m2 + 1][v9]) / 2;
          }
          var M = o.get("formatter"), E = s[+_.m - 1], z9 = { yyyy: _.y, yy: (_.y + "").slice(2), MM: _.m, M: +_.m, nameMap: E }, V = this._formatterLabel(M, z9), $ = new xi({ z2: 30, style: qt(Hs(o, { text: V }), this._monthTextPositionControl(b2, d2, a, l2, u)) });
          i.add($);
        }
      }
    }, t2.prototype._weekTextPositionControl = function(e2, n2, a, i, o) {
      var s = "center", u = "middle", l2 = e2[0], c2 = e2[1], f2 = a === "start";
      return n2 === "horizontal" ? (l2 = l2 + i + (f2 ? 1 : -1) * o[0] / 2, s = f2 ? "right" : "left") : (c2 = c2 + i + (f2 ? 1 : -1) * o[1] / 2, u = f2 ? "bottom" : "top"), { x: l2, y: c2, align: s, verticalAlign: u };
    }, t2.prototype._renderWeekText = function(e2, n2, a, i, o) {
      var s = e2.getModel("dayLabel");
      if (!!s.get("show")) {
        var u = e2.coordinateSystem, l2 = s.get("position"), c2 = s.get("nameMap"), f2 = s.get("margin"), h = u.getFirstDayOfWeek();
        if (!c2 || Zr(c2)) {
          c2 && (n2 = f4(c2) || n2);
          var v9 = n2.get(["time", "dayOfWeekShort"]);
          c2 = v9 || pr(n2.get(["time", "dayOfWeekAbbr"]), function(z9) {
            return z9[0];
          });
        }
        var d2 = u.getNextNDay(a.end.time, 7 - a.lweek).time, m2 = [u.getCellWidth(), u.getCellHeight()];
        f2 = qr(f2, Math.min(m2[1], m2[0])), l2 === "start" && (d2 = u.getNextNDay(a.start.time, -(7 + a.fweek)).time, f2 = -f2);
        for (var b2 = 0; b2 < 7; b2++) {
          var _ = u.getNextNDay(d2, b2), C = u.dataToRect([_.time], false).center, M = b2;
          M = Math.abs((b2 + h) % 7);
          var E = new xi({ z2: 30, style: qt(Hs(s, { text: c2[M] }), this._weekTextPositionControl(C, i, l2, f2, m2)) });
          o.add(E);
        }
      }
    }, t2.type = "calendar", t2;
  }(gs), Lwe = Iwe, tR = 864e5, Owe = function() {
    function r2(t2, e2, n2) {
      this.type = "calendar", this.dimensions = r2.dimensions, this.getDimensionsInfo = r2.getDimensionsInfo, this._model = t2;
    }
    return r2.getDimensionsInfo = function() {
      return [{ name: "time", type: "time" }, "value"];
    }, r2.prototype.getRangeInfo = function() {
      return this._rangeInfo;
    }, r2.prototype.getModel = function() {
      return this._model;
    }, r2.prototype.getRect = function() {
      return this._rect;
    }, r2.prototype.getCellWidth = function() {
      return this._sw;
    }, r2.prototype.getCellHeight = function() {
      return this._sh;
    }, r2.prototype.getOrient = function() {
      return this._orient;
    }, r2.prototype.getFirstDayOfWeek = function() {
      return this._firstDayOfWeek;
    }, r2.prototype.getDateInfo = function(t2) {
      t2 = rp(t2);
      var e2 = t2.getFullYear(), n2 = t2.getMonth() + 1, a = n2 < 10 ? "0" + n2 : "" + n2, i = t2.getDate(), o = i < 10 ? "0" + i : "" + i, s = t2.getDay();
      return s = Math.abs((s + 7 - this.getFirstDayOfWeek()) % 7), { y: e2 + "", m: a, d: o, day: s, time: t2.getTime(), formatedDate: e2 + "-" + a + "-" + o, date: t2 };
    }, r2.prototype.getNextNDay = function(t2, e2) {
      return e2 = e2 || 0, e2 === 0 ? this.getDateInfo(t2) : (t2 = new Date(this.getDateInfo(t2).time), t2.setDate(t2.getDate() + e2), this.getDateInfo(t2));
    }, r2.prototype.update = function(t2, e2) {
      this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
      var n2 = this._rangeInfo.weeks || 1, a = ["width", "height"], i = this._model.getCellSize().slice(), o = this._model.getBoxLayoutParams(), s = this._orient === "horizontal" ? [n2, 7] : [7, n2];
      ae([0, 1], function(f2) {
        c2(i, f2) && (o[a[f2]] = i[f2] * s[f2]);
      });
      var u = { width: e2.getWidth(), height: e2.getHeight() }, l2 = this._rect = Eu(o, u);
      ae([0, 1], function(f2) {
        c2(i, f2) || (i[f2] = l2[a[f2]] / s[f2]);
      });
      function c2(f2, h) {
        return f2[h] != null && f2[h] !== "auto";
      }
      this._sw = i[0], this._sh = i[1];
    }, r2.prototype.dataToPoint = function(t2, e2) {
      vr(t2) && (t2 = t2[0]), e2 == null && (e2 = true);
      var n2 = this.getDateInfo(t2), a = this._rangeInfo, i = n2.formatedDate;
      if (e2 && !(n2.time >= a.start.time && n2.time < a.end.time + tR))
        return [NaN, NaN];
      var o = n2.day, s = this._getRangeInfo([a.start.time, i]).nthWeek;
      return this._orient === "vertical" ? [this._rect.x + o * this._sw + this._sw / 2, this._rect.y + s * this._sh + this._sh / 2] : [this._rect.x + s * this._sw + this._sw / 2, this._rect.y + o * this._sh + this._sh / 2];
    }, r2.prototype.pointToData = function(t2) {
      var e2 = this.pointToDate(t2);
      return e2 && e2.time;
    }, r2.prototype.dataToRect = function(t2, e2) {
      var n2 = this.dataToPoint(t2, e2);
      return { contentShape: { x: n2[0] - (this._sw - this._lineWidth) / 2, y: n2[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: n2, tl: [n2[0] - this._sw / 2, n2[1] - this._sh / 2], tr: [n2[0] + this._sw / 2, n2[1] - this._sh / 2], br: [n2[0] + this._sw / 2, n2[1] + this._sh / 2], bl: [n2[0] - this._sw / 2, n2[1] + this._sh / 2] };
    }, r2.prototype.pointToDate = function(t2) {
      var e2 = Math.floor((t2[0] - this._rect.x) / this._sw) + 1, n2 = Math.floor((t2[1] - this._rect.y) / this._sh) + 1, a = this._rangeInfo.range;
      return this._orient === "vertical" ? this._getDateByWeeksAndDay(n2, e2 - 1, a) : this._getDateByWeeksAndDay(e2, n2 - 1, a);
    }, r2.prototype.convertToPixel = function(t2, e2, n2) {
      var a = Xz(e2);
      return a === this ? a.dataToPoint(n2) : null;
    }, r2.prototype.convertFromPixel = function(t2, e2, n2) {
      var a = Xz(e2);
      return a === this ? a.pointToData(n2) : null;
    }, r2.prototype.containPoint = function(t2) {
      return console.warn("Not implemented."), false;
    }, r2.prototype._initRangeOption = function() {
      var t2 = this._model.get("range"), e2;
      if (vr(t2) && t2.length === 1 && (t2 = t2[0]), vr(t2))
        e2 = t2;
      else {
        var n2 = t2.toString();
        if (/^\d{4}$/.test(n2) && (e2 = [n2 + "-01-01", n2 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(n2)) {
          var a = this.getDateInfo(n2), i = a.date;
          i.setMonth(i.getMonth() + 1);
          var o = this.getNextNDay(i, -1);
          e2 = [a.formatedDate, o.formatedDate];
        }
        /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(n2) && (e2 = [n2, n2]);
      }
      if (!e2)
        return t2;
      var s = this._getRangeInfo(e2);
      return s.start.time > s.end.time && e2.reverse(), e2;
    }, r2.prototype._getRangeInfo = function(t2) {
      var e2 = [this.getDateInfo(t2[0]), this.getDateInfo(t2[1])], n2;
      e2[0].time > e2[1].time && (n2 = true, e2.reverse());
      var a = Math.floor(e2[1].time / tR) - Math.floor(e2[0].time / tR) + 1, i = new Date(e2[0].time), o = i.getDate(), s = e2[1].date.getDate();
      i.setDate(o + a - 1);
      var u = i.getDate();
      if (u !== s)
        for (var l2 = i.getTime() - e2[1].time > 0 ? 1 : -1; (u = i.getDate()) !== s && (i.getTime() - e2[1].time) * l2 > 0; )
          a -= l2, i.setDate(u - l2);
      var c2 = Math.floor((a + e2[0].day + 6) / 7), f2 = n2 ? -c2 + 1 : c2 - 1;
      return n2 && e2.reverse(), { range: [e2[0].formatedDate, e2[1].formatedDate], start: e2[0], end: e2[1], allDay: a, weeks: c2, nthWeek: f2, fweek: e2[0].day, lweek: e2[1].day };
    }, r2.prototype._getDateByWeeksAndDay = function(t2, e2, n2) {
      var a = this._getRangeInfo(n2);
      if (t2 > a.weeks || t2 === 0 && e2 < a.fweek || t2 === a.weeks && e2 > a.lweek)
        return null;
      var i = (t2 - 1) * 7 - a.fweek + e2, o = new Date(a.start.time);
      return o.setDate(+a.start.d + i), this.getDateInfo(o);
    }, r2.create = function(t2, e2) {
      var n2 = [];
      return t2.eachComponent("calendar", function(a) {
        var i = new r2(a, t2, e2);
        n2.push(i), a.coordinateSystem = i;
      }), t2.eachSeries(function(a) {
        a.get("coordinateSystem") === "calendar" && (a.coordinateSystem = n2[a.get("calendarIndex") || 0]);
      }), n2;
    }, r2.dimensions = ["time", "value"], r2;
  }();
  function Xz(r2) {
    var t2 = r2.calendarModel, e2 = r2.seriesModel, n2 = t2 ? t2.coordinateSystem : e2 ? e2.coordinateSystem : null;
    return n2;
  }
  var kwe = Owe;
  function Rwe(r2) {
    r2.registerComponentModel(Dwe), r2.registerComponentView(Lwe), r2.registerCoordinateSystem("calendar", kwe);
  }
  function Fwe(r2, t2) {
    var e2 = r2.existing;
    if (t2.id = r2.keyInfo.id, !t2.type && e2 && (t2.type = e2.type), t2.parentId == null) {
      var n2 = t2.parentOption;
      n2 ? t2.parentId = n2.id : e2 && (t2.parentId = e2.parentId);
    }
    t2.parentOption = null;
  }
  function Jz(r2, t2) {
    var e2;
    return ae(t2, function(n2) {
      r2[n2] != null && r2[n2] !== "auto" && (e2 = true);
    }), e2;
  }
  function Nwe(r2, t2, e2) {
    var n2 = qt({}, e2), a = r2[t2], i = e2.$action || "merge";
    i === "merge" ? a ? (ea(a, n2, true), by(a, n2, { ignoreSize: true }), lH(e2, a), u5(e2, a), u5(e2, a, "shape"), u5(e2, a, "style"), u5(e2, a, "extra"), e2.clipPath = a.clipPath) : r2[t2] = n2 : i === "replace" ? r2[t2] = n2 : i === "remove" && a && (r2[t2] = null);
  }
  var CZ = ["transition", "enterFrom", "leaveTo"], Vwe = CZ.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
  function u5(r2, t2, e2) {
    if (e2 && (!r2[e2] && t2[e2] && (r2[e2] = {}), r2 = r2[e2], t2 = t2[e2]), !(!r2 || !t2))
      for (var n2 = e2 ? CZ : Vwe, a = 0; a < n2.length; a++) {
        var i = n2[a];
        r2[i] == null && t2[i] != null && (r2[i] = t2[i]);
      }
  }
  function jwe(r2, t2) {
    if (!!r2 && (r2.hv = t2.hv = [Jz(t2, ["left", "right"]), Jz(t2, ["top", "bottom"])], r2.type === "group")) {
      var e2 = r2, n2 = t2;
      e2.width == null && (e2.width = n2.width = 0), e2.height == null && (e2.height = n2.height = 0);
    }
  }
  var Bwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.preventAutoZ = true, e2;
    }
    return t2.prototype.mergeOption = function(e2, n2) {
      var a = this.option.elements;
      this.option.elements = null, r2.prototype.mergeOption.call(this, e2, n2), this.option.elements = a;
    }, t2.prototype.optionUpdated = function(e2, n2) {
      var a = this.option, i = (n2 ? a : e2).elements, o = a.elements = n2 ? [] : a.elements, s = [];
      this._flatten(i, s, null);
      var u = WW(o, s, "normalMerge"), l2 = this._elOptionsToUpdate = [];
      ae(u, function(c2, f2) {
        var h = c2.newOption;
        !h || (l2.push(h), Fwe(c2, h), Nwe(o, f2, h), jwe(o[f2], h));
      }, this), a.elements = no(o, function(c2) {
        return c2 && delete c2.$action, c2 != null;
      });
    }, t2.prototype._flatten = function(e2, n2, a) {
      ae(e2, function(i) {
        if (!!i) {
          a && (i.parentOption = a), n2.push(i);
          var o = i.children;
          i.type === "group" && o && this._flatten(o, n2, i), delete i.children;
        }
      }, this);
    }, t2.prototype.useElOptionsToUpdate = function() {
      var e2 = this._elOptionsToUpdate;
      return this._elOptionsToUpdate = null, e2;
    }, t2.type = "graphic", t2.defaultOption = { elements: [] }, t2;
  }(li), Qz = { path: null, compoundPath: null, group: Fn, image: Bl, text: xi }, Fh = fi(), zwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function() {
      this._elMap = mn();
    }, t2.prototype.render = function(e2, n2, a) {
      e2 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = e2, this._updateElements(e2), this._relocate(e2, a);
    }, t2.prototype._updateElements = function(e2) {
      var n2 = e2.useElOptionsToUpdate();
      if (!!n2) {
        var a = this._elMap, i = this.group, o = e2.get("z"), s = e2.get("zlevel");
        ae(n2, function(u) {
          var l2 = Cu(u.id, null), c2 = l2 != null ? a.get(l2) : null, f2 = Cu(u.parentId, null), h = f2 != null ? a.get(f2) : i, v9 = u.type, d2 = u.style;
          v9 === "text" && d2 && u.hv && u.hv[1] && (d2.textVerticalAlign = d2.textBaseline = d2.verticalAlign = d2.align = null);
          var m2 = u.textContent, b2 = u.textConfig;
          if (d2 && nZ(d2, v9, !!b2, !!m2)) {
            var _ = aZ(d2, v9, true);
            !b2 && _.textConfig && (b2 = u.textConfig = _.textConfig), !m2 && _.textContent && (m2 = _.textContent);
          }
          var C = $we(u), M = u.$action || "merge", E = M === "merge", z9 = M === "replace";
          if (E) {
            var V = !c2, $ = c2;
            V ? $ = e$(l2, h, u.type, a) : ($ && (Fh($).isNew = false), uZ($)), $ && (N5($, C, e2, { isInit: V }), t$($, u, o, s));
          } else if (z9) {
            j5(c2, u, a, e2);
            var U = e$(l2, h, u.type, a);
            U && (N5(U, C, e2, { isInit: true }), t$(U, u, o, s));
          } else
            M === "remove" && (oZ(c2, u), j5(c2, u, a, e2));
          var H = a.get(l2);
          if (H && m2)
            if (E) {
              var q3 = H.getTextContent();
              q3 ? q3.attr(m2) : H.setTextContent(new xi(m2));
            } else
              z9 && H.setTextContent(new xi(m2));
          if (H) {
            var ee = u.clipPath;
            if (ee) {
              var oe = ee.type, ne = void 0, V = false;
              if (E) {
                var be = H.getClipPath();
                V = !be || Fh(be).type !== oe, ne = V ? r6(oe) : be;
              } else
                z9 && (V = true, ne = r6(oe));
              H.setClipPath(ne), N5(ne, ee, e2, { isInit: V }), TP(ne, ee.keyframeAnimation, e2);
            }
            var Ee = Fh(H);
            H.setTextConfig(b2), Ee.option = u, Gwe(H, e2, u), pw({ el: H, componentModel: e2, itemName: H.name, itemTooltipOption: u.tooltip }), TP(H, u.keyframeAnimation, e2);
          }
        });
      }
    }, t2.prototype._relocate = function(e2, n2) {
      for (var a = e2.option.elements, i = this.group, o = this._elMap, s = n2.getWidth(), u = n2.getHeight(), l2 = ["x", "y"], c2 = 0; c2 < a.length; c2++) {
        var f2 = a[c2], h = Cu(f2.id, null), v9 = h != null ? o.get(h) : null;
        if (!(!v9 || !v9.isGroup)) {
          var d2 = v9.parent, m2 = d2 === i, b2 = Fh(v9), _ = Fh(d2);
          b2.width = qr(b2.option.width, m2 ? s : _.width) || 0, b2.height = qr(b2.option.height, m2 ? u : _.height) || 0;
        }
      }
      for (var c2 = a.length - 1; c2 >= 0; c2--) {
        var f2 = a[c2], h = Cu(f2.id, null), v9 = h != null ? o.get(h) : null;
        if (!!v9) {
          var d2 = v9.parent, _ = Fh(d2), C = d2 === i ? { width: s, height: u } : { width: _.width, height: _.height }, M = {}, E = c3(v9, f2, C, null, { hv: f2.hv, boundingMode: f2.bounding }, M);
          if (!Fh(v9).isNew && E) {
            for (var z9 = f2.transition, V = {}, $ = 0; $ < l2.length; $++) {
              var U = l2[$], H = M[U];
              z9 && (Jb(z9) || va(z9, U) >= 0) ? V[U] = H : v9[U] = H;
            }
            ci(v9, V, e2, 0);
          } else
            v9.attr(M);
        }
      }
    }, t2.prototype._clear = function() {
      var e2 = this, n2 = this._elMap;
      n2.each(function(a) {
        j5(a, Fh(a).option, n2, e2._lastGraphicModel);
      }), this._elMap = mn();
    }, t2.prototype.dispose = function() {
      this._clear();
    }, t2.type = "graphic", t2;
  }(gs);
  function r6(r2) {
    var t2 = sn(Qz, r2) ? Qz[r2] : oF(r2), e2 = new t2({});
    return Fh(e2).type = r2, e2;
  }
  function e$(r2, t2, e2, n2) {
    var a = r6(e2);
    return t2.add(a), n2.set(r2, a), Fh(a).id = r2, Fh(a).isNew = true, a;
  }
  function j5(r2, t2, e2, n2) {
    var a = r2 && r2.parent;
    a && (r2.type === "group" && r2.traverse(function(i) {
      j5(i, t2, e2, n2);
    }), A3(r2, t2, n2), e2.removeKey(Fh(r2).id));
  }
  function t$(r2, t2, e2, n2) {
    if (!r2.isGroup) {
      var a = r2;
      a.cursor = ia(t2.cursor, qh.prototype.cursor), a.z = ia(t2.z, e2 || 0), a.zlevel = ia(t2.zlevel, n2 || 0);
      var i = t2.z2;
      i != null && (a.z2 = i || 0);
    }
    ae(ja(t2), function(o) {
      var s = t2[o];
      o.indexOf("on") === 0 && xn(s) && (r2[o] = s);
    }), r2.draggable = t2.draggable, t2.name != null && (r2.name = t2.name), t2.id != null && (r2.id = t2.id);
  }
  function $we(r2) {
    return r2 = qt({}, r2), ae(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(uH), function(t2) {
      delete r2[t2];
    }), r2;
  }
  function Gwe(r2, t2, e2) {
    var n2 = zn(r2).eventData;
    !r2.silent && !r2.ignore && !n2 && (n2 = zn(r2).eventData = { componentType: "graphic", componentIndex: t2.componentIndex, name: r2.name }), n2 && (n2.info = e2.info);
  }
  function Wwe(r2) {
    r2.registerComponentModel(Bwe), r2.registerComponentView(zwe), r2.registerPreprocessor(function(t2) {
      var e2 = t2.graphic;
      vr(e2) ? !e2[0] || !e2[0].elements ? t2.graphic = [{ elements: e2 }] : t2.graphic = [t2.graphic[0]] : e2 && !e2.elements && (t2.graphic = [{ elements: [e2] }]);
    });
  }
  var r$ = ["x", "y", "radius", "angle", "single"], Uwe = ["cartesian2d", "polar", "singleAxis"];
  function Hwe(r2) {
    var t2 = r2.get("coordinateSystem");
    return va(Uwe, t2) >= 0;
  }
  function cy(r2) {
    return r2 + "Axis";
  }
  function qwe(r2, t2) {
    var e2 = mn(), n2 = [], a = mn();
    r2.eachComponent({ mainType: "dataZoom", query: t2 }, function(c2) {
      a.get(c2.uid) || s(c2);
    });
    var i;
    do
      i = false, r2.eachComponent("dataZoom", o);
    while (i);
    function o(c2) {
      !a.get(c2.uid) && u(c2) && (s(c2), i = true);
    }
    function s(c2) {
      a.set(c2.uid, true), n2.push(c2), l2(c2);
    }
    function u(c2) {
      var f2 = false;
      return c2.eachTargetAxis(function(h, v9) {
        var d2 = e2.get(h);
        d2 && d2[v9] && (f2 = true);
      }), f2;
    }
    function l2(c2) {
      c2.eachTargetAxis(function(f2, h) {
        (e2.get(f2) || e2.set(f2, []))[h] = true;
      });
    }
    return n2;
  }
  function EZ(r2) {
    var t2 = r2.ecModel, e2 = { infoList: [], infoMap: mn() };
    return r2.eachTargetAxis(function(n2, a) {
      var i = t2.getComponent(cy(n2), a);
      if (!!i) {
        var o = i.getCoordSysModel();
        if (!!o) {
          var s = o.uid, u = e2.infoMap.get(s);
          u || (u = { model: o, axisModels: [] }, e2.infoList.push(u), e2.infoMap.set(s, u)), u.axisModels.push(i);
        }
      }
    }), e2;
  }
  var rR = function() {
    function r2() {
      this.indexList = [], this.indexMap = [];
    }
    return r2.prototype.add = function(t2) {
      this.indexMap[t2] || (this.indexList.push(t2), this.indexMap[t2] = true);
    }, r2;
  }(), Ywe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._autoThrottle = true, e2._noTarget = true, e2._rangePropMode = ["percent", "percent"], e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      var i = n$(e2);
      this.settledOption = i, this.mergeDefaultAndTheme(e2, a), this._doInit(i);
    }, t2.prototype.mergeOption = function(e2) {
      var n2 = n$(e2);
      ea(this.option, e2, true), ea(this.settledOption, n2, true), this._doInit(n2);
    }, t2.prototype._doInit = function(e2) {
      var n2 = this.option;
      this._setDefaultThrottle(e2), this._updateRangeUse(e2);
      var a = this.settledOption;
      ae([["start", "startValue"], ["end", "endValue"]], function(i, o) {
        this._rangePropMode[o] === "value" && (n2[i[0]] = a[i[0]] = null);
      }, this), this._resetTarget();
    }, t2.prototype._resetTarget = function() {
      var e2 = this.get("orient", true), n2 = this._targetAxisInfoMap = mn(), a = this._fillSpecifiedTargetAxis(n2);
      a ? this._orient = e2 || this._makeAutoOrientByTargetAxis() : (this._orient = e2 || "horizontal", this._fillAutoTargetAxisByOrient(n2, this._orient)), this._noTarget = true, n2.each(function(i) {
        i.indexList.length && (this._noTarget = false);
      }, this);
    }, t2.prototype._fillSpecifiedTargetAxis = function(e2) {
      var n2 = false;
      return ae(r$, function(a) {
        var i = this.getReferringComponents(cy(a), ooe);
        if (!!i.specified) {
          n2 = true;
          var o = new rR();
          ae(i.models, function(s) {
            o.add(s.componentIndex);
          }), e2.set(a, o);
        }
      }, this), n2;
    }, t2.prototype._fillAutoTargetAxisByOrient = function(e2, n2) {
      var a = this.ecModel, i = true;
      if (i) {
        var o = n2 === "vertical" ? "y" : "x", s = a.findComponents({ mainType: o + "Axis" });
        u(s, o);
      }
      if (i) {
        var s = a.findComponents({ mainType: "singleAxis", filter: function(c2) {
          return c2.get("orient", true) === n2;
        } });
        u(s, "single");
      }
      function u(l2, c2) {
        var f2 = l2[0];
        if (!!f2) {
          var h = new rR();
          if (h.add(f2.componentIndex), e2.set(c2, h), i = false, c2 === "x" || c2 === "y") {
            var v9 = f2.getReferringComponents("grid", uu).models[0];
            v9 && ae(l2, function(d2) {
              f2.componentIndex !== d2.componentIndex && v9 === d2.getReferringComponents("grid", uu).models[0] && h.add(d2.componentIndex);
            });
          }
        }
      }
      i && ae(r$, function(l2) {
        if (!!i) {
          var c2 = a.findComponents({ mainType: cy(l2), filter: function(h) {
            return h.get("type", true) === "category";
          } });
          if (c2[0]) {
            var f2 = new rR();
            f2.add(c2[0].componentIndex), e2.set(l2, f2), i = false;
          }
        }
      }, this);
    }, t2.prototype._makeAutoOrientByTargetAxis = function() {
      var e2;
      return this.eachTargetAxis(function(n2) {
        !e2 && (e2 = n2);
      }, this), e2 === "y" ? "vertical" : "horizontal";
    }, t2.prototype._setDefaultThrottle = function(e2) {
      if (e2.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
        var n2 = this.ecModel.option;
        this.option.throttle = n2.animation && n2.animationDurationUpdate > 0 ? 100 : 20;
      }
    }, t2.prototype._updateRangeUse = function(e2) {
      var n2 = this._rangePropMode, a = this.get("rangeMode");
      ae([["start", "startValue"], ["end", "endValue"]], function(i, o) {
        var s = e2[i[0]] != null, u = e2[i[1]] != null;
        s && !u ? n2[o] = "percent" : !s && u ? n2[o] = "value" : a ? n2[o] = a[o] : s && (n2[o] = "percent");
      });
    }, t2.prototype.noTarget = function() {
      return this._noTarget;
    }, t2.prototype.getFirstTargetAxisModel = function() {
      var e2;
      return this.eachTargetAxis(function(n2, a) {
        e2 == null && (e2 = this.ecModel.getComponent(cy(n2), a));
      }, this), e2;
    }, t2.prototype.eachTargetAxis = function(e2, n2) {
      this._targetAxisInfoMap.each(function(a, i) {
        ae(a.indexList, function(o) {
          e2.call(n2, i, o);
        });
      });
    }, t2.prototype.getAxisProxy = function(e2, n2) {
      var a = this.getAxisModel(e2, n2);
      if (a)
        return a.__dzAxisProxy;
    }, t2.prototype.getAxisModel = function(e2, n2) {
      var a = this._targetAxisInfoMap.get(e2);
      if (a && a.indexMap[n2])
        return this.ecModel.getComponent(cy(e2), n2);
    }, t2.prototype.setRawRange = function(e2) {
      var n2 = this.option, a = this.settledOption;
      ae([["start", "startValue"], ["end", "endValue"]], function(i) {
        (e2[i[0]] != null || e2[i[1]] != null) && (n2[i[0]] = a[i[0]] = e2[i[0]], n2[i[1]] = a[i[1]] = e2[i[1]]);
      }, this), this._updateRangeUse(e2);
    }, t2.prototype.setCalculatedRange = function(e2) {
      var n2 = this.option;
      ae(["start", "startValue", "end", "endValue"], function(a) {
        n2[a] = e2[a];
      });
    }, t2.prototype.getPercentRange = function() {
      var e2 = this.findRepresentativeAxisProxy();
      if (e2)
        return e2.getDataPercentWindow();
    }, t2.prototype.getValueRange = function(e2, n2) {
      if (e2 == null && n2 == null) {
        var a = this.findRepresentativeAxisProxy();
        if (a)
          return a.getDataValueWindow();
      } else
        return this.getAxisProxy(e2, n2).getDataValueWindow();
    }, t2.prototype.findRepresentativeAxisProxy = function(e2) {
      if (e2)
        return e2.__dzAxisProxy;
      for (var n2, a = this._targetAxisInfoMap.keys(), i = 0; i < a.length; i++)
        for (var o = a[i], s = this._targetAxisInfoMap.get(o), u = 0; u < s.indexList.length; u++) {
          var l2 = this.getAxisProxy(o, s.indexList[u]);
          if (l2.hostedBy(this))
            return l2;
          n2 || (n2 = l2);
        }
      return n2;
    }, t2.prototype.getRangePropMode = function() {
      return this._rangePropMode.slice();
    }, t2.prototype.getOrient = function() {
      return this._orient;
    }, t2.type = "dataZoom", t2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], t2.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, t2;
  }(li);
  function n$(r2) {
    var t2 = {};
    return ae(["start", "end", "startValue", "endValue", "throttle"], function(e2) {
      r2.hasOwnProperty(e2) && (t2[e2] = r2[e2]);
    }), t2;
  }
  var wE = Ywe, Kwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "dataZoom.select", t2;
  }(wE), Zwe = Kwe, Xwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this.dataZoomModel = e2, this.ecModel = n2, this.api = a;
    }, t2.type = "dataZoom", t2;
  }(gs), AN = Xwe, Jwe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "dataZoom.select", t2;
  }(AN), Qwe = Jwe, Nx = ae, a$ = $h, eSe = function() {
    function r2(t2, e2, n2, a) {
      this._dimName = t2, this._axisIndex = e2, this.ecModel = a, this._dataZoomModel = n2;
    }
    return r2.prototype.hostedBy = function(t2) {
      return this._dataZoomModel === t2;
    }, r2.prototype.getDataValueWindow = function() {
      return this._valueWindow.slice();
    }, r2.prototype.getDataPercentWindow = function() {
      return this._percentWindow.slice();
    }, r2.prototype.getTargetSeriesModels = function() {
      var t2 = [];
      return this.ecModel.eachSeries(function(e2) {
        if (Hwe(e2)) {
          var n2 = cy(this._dimName), a = e2.getReferringComponents(n2, uu).models[0];
          a && this._axisIndex === a.componentIndex && t2.push(e2);
        }
      }, this), t2;
    }, r2.prototype.getAxisModel = function() {
      return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
    }, r2.prototype.getMinMaxSpan = function() {
      return On(this._minMaxSpan);
    }, r2.prototype.calculateDataWindow = function(t2) {
      var e2 = this._dataExtent, n2 = this.getAxisModel(), a = n2.axis.scale, i = this._dataZoomModel.getRangePropMode(), o = [0, 100], s = [], u = [], l2;
      Nx(["start", "end"], function(h, v9) {
        var d2 = t2[h], m2 = t2[h + "Value"];
        i[v9] === "percent" ? (d2 == null && (d2 = o[v9]), m2 = a.parse(Gi(d2, o, e2))) : (l2 = true, m2 = m2 == null ? e2[v9] : a.parse(m2), d2 = Gi(m2, e2, o)), u[v9] = m2, s[v9] = d2;
      }), a$(u), a$(s);
      var c2 = this._minMaxSpan;
      l2 ? f2(u, s, e2, o, false) : f2(s, u, o, e2, true);
      function f2(h, v9, d2, m2, b2) {
        var _ = b2 ? "Span" : "ValueSpan";
        f1(0, h, d2, "all", c2["min" + _], c2["max" + _]);
        for (var C = 0; C < 2; C++)
          v9[C] = Gi(h[C], d2, m2, true), b2 && (v9[C] = a.parse(v9[C]));
      }
      return { valueWindow: u, percentWindow: s };
    }, r2.prototype.reset = function(t2) {
      if (t2 === this._dataZoomModel) {
        var e2 = this.getTargetSeriesModels();
        this._dataExtent = tSe(this, this._dimName, e2), this._updateMinMaxSpan();
        var n2 = this.calculateDataWindow(t2.settledOption);
        this._valueWindow = n2.valueWindow, this._percentWindow = n2.percentWindow, this._setAxisModel();
      }
    }, r2.prototype.filterData = function(t2, e2) {
      if (t2 !== this._dataZoomModel)
        return;
      var n2 = this._dimName, a = this.getTargetSeriesModels(), i = t2.get("filterMode"), o = this._valueWindow;
      if (i === "none")
        return;
      Nx(a, function(u) {
        var l2 = u.getData(), c2 = l2.mapDimensionsAll(n2);
        if (!!c2.length) {
          if (i === "weakFilter") {
            var f2 = l2.getStore(), h = pr(c2, function(v9) {
              return l2.getDimensionIndex(v9);
            }, l2);
            l2.filterSelf(function(v9) {
              for (var d2, m2, b2, _ = 0; _ < c2.length; _++) {
                var C = f2.get(h[_], v9), M = !isNaN(C), E = C < o[0], z9 = C > o[1];
                if (M && !E && !z9)
                  return true;
                M && (b2 = true), E && (d2 = true), z9 && (m2 = true);
              }
              return b2 && d2 && m2;
            });
          } else
            Nx(c2, function(v9) {
              if (i === "empty")
                u.setData(l2 = l2.map(v9, function(m2) {
                  return s(m2) ? m2 : NaN;
                }));
              else {
                var d2 = {};
                d2[v9] = o, l2.selectRange(d2);
              }
            });
          Nx(c2, function(v9) {
            l2.setApproximateExtent(o, v9);
          });
        }
      });
      function s(u) {
        return u >= o[0] && u <= o[1];
      }
    }, r2.prototype._updateMinMaxSpan = function() {
      var t2 = this._minMaxSpan = {}, e2 = this._dataZoomModel, n2 = this._dataExtent;
      Nx(["min", "max"], function(a) {
        var i = e2.get(a + "Span"), o = e2.get(a + "ValueSpan");
        o != null && (o = this.getAxisModel().axis.scale.parse(o)), o != null ? i = Gi(n2[0] + o, n2, [0, 100], true) : i != null && (o = Gi(i, [0, 100], n2, true) - n2[0]), t2[a + "Span"] = i, t2[a + "ValueSpan"] = o;
      }, this);
    }, r2.prototype._setAxisModel = function() {
      var t2 = this.getAxisModel(), e2 = this._percentWindow, n2 = this._valueWindow;
      if (!!e2) {
        var a = FW(n2, [0, 500]);
        a = Math.min(a, 20);
        var i = t2.axis.scale.rawExtentInfo;
        e2[0] !== 0 && i.setDeterminedMinMax("min", +n2[0].toFixed(a)), e2[1] !== 100 && i.setDeterminedMinMax("max", +n2[1].toFixed(a)), i.freeze();
      }
    }, r2;
  }();
  function tSe(r2, t2, e2) {
    var n2 = [1 / 0, -1 / 0];
    Nx(e2, function(o) {
      Che(n2, o.getData(), t2);
    });
    var a = r2.getAxisModel(), i = Gq(a.axis.scale, a, n2).calculate();
    return [i.min, i.max];
  }
  var rSe = eSe, nSe = { getTargetSeries: function(r2) {
    function t2(a) {
      r2.eachComponent("dataZoom", function(i) {
        i.eachTargetAxis(function(o, s) {
          var u = r2.getComponent(cy(o), s);
          a(o, s, u, i);
        });
      });
    }
    t2(function(a, i, o, s) {
      o.__dzAxisProxy = null;
    });
    var e2 = [];
    t2(function(a, i, o, s) {
      o.__dzAxisProxy || (o.__dzAxisProxy = new rSe(a, i, s, r2), e2.push(o.__dzAxisProxy));
    });
    var n2 = mn();
    return ae(e2, function(a) {
      ae(a.getTargetSeriesModels(), function(i) {
        n2.set(i.uid, i);
      });
    }), n2;
  }, overallReset: function(r2, t2) {
    r2.eachComponent("dataZoom", function(e2) {
      e2.eachTargetAxis(function(n2, a) {
        e2.getAxisProxy(n2, a).reset(e2);
      }), e2.eachTargetAxis(function(n2, a) {
        e2.getAxisProxy(n2, a).filterData(e2, t2);
      });
    }), r2.eachComponent("dataZoom", function(e2) {
      var n2 = e2.findRepresentativeAxisProxy();
      if (n2) {
        var a = n2.getDataPercentWindow(), i = n2.getDataValueWindow();
        e2.setCalculatedRange({ start: a[0], end: a[1], startValue: i[0], endValue: i[1] });
      }
    });
  } }, aSe = nSe;
  function iSe(r2) {
    r2.registerAction("dataZoom", function(t2, e2) {
      var n2 = qwe(e2, t2);
      ae(n2, function(a) {
        a.setRawRange({ start: t2.start, end: t2.end, startValue: t2.startValue, endValue: t2.endValue });
      });
    });
  }
  var i$ = false;
  function TN(r2) {
    i$ || (i$ = true, r2.registerProcessor(r2.PRIORITY.PROCESSOR.FILTER, aSe), iSe(r2), r2.registerSubTypeDefaulter("dataZoom", function() {
      return "slider";
    }));
  }
  function oSe(r2) {
    r2.registerComponentModel(Zwe), r2.registerComponentView(Qwe), TN(r2);
  }
  var Vh = function() {
    function r2() {
    }
    return r2;
  }(), AZ = {};
  function Vx(r2, t2) {
    AZ[r2] = t2;
  }
  function TZ(r2) {
    return AZ[r2];
  }
  var sSe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.optionUpdated = function() {
      r2.prototype.optionUpdated.apply(this, arguments);
      var e2 = this.ecModel;
      ae(this.option.feature, function(n2, a) {
        var i = TZ(a);
        i && (i.getDefaultOption && (i.defaultOption = i.getDefaultOption(e2)), ea(n2, i.defaultOption));
      });
    }, t2.type = "toolbox", t2.layoutMode = { type: "box", ignoreSize: true }, t2.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, t2;
  }(li), uSe = sSe;
  function lSe(r2, t2, e2) {
    var n2 = t2.getBoxLayoutParams(), a = t2.get("padding"), i = { width: e2.getWidth(), height: e2.getHeight() }, o = Eu(n2, i, a);
    Kb(t2.get("orient"), r2, t2.get("itemGap"), o.width, o.height), c3(r2, n2, i, a);
  }
  function MZ(r2, t2) {
    var e2 = mw(t2.get("padding")), n2 = t2.getItemStyle(["color", "opacity"]);
    return n2.fill = t2.get("backgroundColor"), r2 = new ni({ shape: { x: r2.x - e2[3], y: r2.y - e2[0], width: r2.width + e2[1] + e2[3], height: r2.height + e2[0] + e2[2], r: t2.get("borderRadius") }, style: n2, silent: true, z2: -1 }), r2;
  }
  var cSe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      var o = this.group;
      if (o.removeAll(), !e2.get("show"))
        return;
      var s = +e2.get("itemSize"), u = e2.get("feature") || {}, l2 = this._features || (this._features = {}), c2 = [];
      ae(u, function(v9, d2) {
        c2.push(d2);
      }), new Dg(this._featureNames || [], c2).add(f2).update(f2).remove(Gn(f2, null)).execute(), this._featureNames = c2;
      function f2(v9, d2) {
        var m2 = c2[v9], b2 = c2[d2], _ = u[m2], C = new To(_, e2, e2.ecModel), M;
        if (i && i.newTitle != null && i.featureName === m2 && (_.title = i.newTitle), m2 && !b2) {
          if (fSe(m2))
            M = { onclick: C.option.onclick, featureName: m2 };
          else {
            var E = TZ(m2);
            if (!E)
              return;
            M = new E();
          }
          l2[m2] = M;
        } else if (M = l2[b2], !M)
          return;
        M.uid = yw("toolbox-feature"), M.model = C, M.ecModel = n2, M.api = a;
        var z9 = M instanceof Vh;
        if (!m2 && b2) {
          z9 && M.dispose && M.dispose(n2, a);
          return;
        }
        if (!C.get("show") || z9 && M.unusable) {
          z9 && M.remove && M.remove(n2, a);
          return;
        }
        h(C, M, m2), C.setIconStatus = function(V, $) {
          var U = this.option, H = this.iconPaths;
          U.iconStatus = U.iconStatus || {}, U.iconStatus[V] = $, H[V] && ($ === "emphasis" ? Kd : Zd)(H[V]);
        }, M instanceof Vh && M.render && M.render(C, n2, a, i);
      }
      function h(v9, d2, m2) {
        var b2 = v9.getModel("iconStyle"), _ = v9.getModel(["emphasis", "iconStyle"]), C = d2 instanceof Vh && d2.getIcons ? d2.getIcons() : v9.get("icon"), M = v9.get("title") || {}, E, z9;
        Zr(C) ? (E = {}, E[m2] = C) : E = C, Zr(M) ? (z9 = {}, z9[m2] = M) : z9 = M;
        var V = v9.iconPaths = {};
        ae(E, function($, U) {
          var H = kE($, {}, { x: -s / 2, y: -s / 2, width: s, height: s });
          H.setStyle(b2.getItemStyle());
          var q3 = H.ensureState("emphasis");
          q3.style = _.getItemStyle();
          var ee = new xi({ style: { text: z9[U], align: _.get("textAlign"), borderRadius: _.get("textBorderRadius"), padding: _.get("textPadding"), fill: null }, ignore: true });
          H.setTextContent(ee), pw({ el: H, componentModel: e2, itemName: U, formatterParamsExtra: { title: z9[U] } }), H.__title = z9[U], H.on("mouseover", function() {
            var oe = _.getItemStyle(), ne = e2.get("orient") === "vertical" ? e2.get("right") == null ? "right" : "left" : e2.get("bottom") == null ? "bottom" : "top";
            ee.setStyle({ fill: _.get("textFill") || oe.fill || oe.stroke || "#000", backgroundColor: _.get("textBackgroundColor") }), H.setTextConfig({ position: _.get("textPosition") || ne }), ee.ignore = !e2.get("showTitle"), Kd(this);
          }).on("mouseout", function() {
            v9.get(["iconStatus", U]) !== "emphasis" && Zd(this), ee.hide();
          }), (v9.get(["iconStatus", U]) === "emphasis" ? Kd : Zd)(H), o.add(H), H.on("click", en(d2.onclick, d2, n2, a, U)), V[U] = H;
        });
      }
      lSe(o, e2, a), o.add(MZ(o.getBoundingRect(), e2)), o.eachChild(function(v9) {
        var d2 = v9.__title, m2 = v9.ensureState("emphasis"), b2 = m2.textConfig || (m2.textConfig = {}), _ = v9.getTextContent(), C = _ && _.states.emphasis;
        if (C && !xn(C) && d2) {
          var M = C.style || (C.style = {}), E = PE(d2, xi.makeFont(M)), z9 = v9.x + o.x, V = v9.y + o.y + s, $ = false;
          V + E.height > a.getHeight() && (b2.position = "top", $ = true);
          var U = $ ? -5 - E.height : s + 8;
          z9 + E.width / 2 > a.getWidth() ? (b2.position = ["100%", U], M.align = "right") : z9 - E.width / 2 < 0 && (b2.position = [0, U], M.align = "left");
        }
      });
    }, t2.prototype.updateView = function(e2, n2, a, i) {
      ae(this._features, function(o) {
        o instanceof Vh && o.updateView && o.updateView(o.model, n2, a, i);
      });
    }, t2.prototype.remove = function(e2, n2) {
      ae(this._features, function(a) {
        a instanceof Vh && a.remove && a.remove(e2, n2);
      }), this.group.removeAll();
    }, t2.prototype.dispose = function(e2, n2) {
      ae(this._features, function(a) {
        a instanceof Vh && a.dispose && a.dispose(e2, n2);
      });
    }, t2.type = "toolbox", t2;
  }(gs);
  function fSe(r2) {
    return r2.indexOf("my") === 0;
  }
  var hSe = cSe, vSe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.onclick = function(e2, n2) {
      var a = this.model, i = a.get("name") || e2.get("title.0.text") || "echarts", o = n2.getZr().painter.getType() === "svg", s = o ? "svg" : a.get("type", true) || "png", u = n2.getConnectedDataURL({ type: s, backgroundColor: a.get("backgroundColor", true) || e2.get("backgroundColor") || "#fff", connectedBackgroundColor: a.get("connectedBackgroundColor"), excludeComponents: a.get("excludeComponents"), pixelRatio: a.get("pixelRatio") }), l2 = Ei.browser;
      if (xn(MouseEvent) && (l2.newEdge || !l2.ie && !l2.edge)) {
        var c2 = document.createElement("a");
        c2.download = i + "." + s, c2.target = "_blank", c2.href = u;
        var f2 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
        c2.dispatchEvent(f2);
      } else if (window.navigator.msSaveOrOpenBlob || o) {
        var h = u.split(","), v9 = h[0].indexOf("base64") > -1, d2 = o ? decodeURIComponent(h[1]) : h[1];
        v9 && (d2 = window.atob(d2));
        var m2 = i + "." + s;
        if (window.navigator.msSaveOrOpenBlob) {
          for (var b2 = d2.length, _ = new Uint8Array(b2); b2--; )
            _[b2] = d2.charCodeAt(b2);
          var C = new Blob([_]);
          window.navigator.msSaveOrOpenBlob(C, m2);
        } else {
          var M = document.createElement("iframe");
          document.body.appendChild(M);
          var E = M.contentWindow, z9 = E.document;
          z9.open("image/svg+xml", "replace"), z9.write(d2), z9.close(), E.focus(), z9.execCommand("SaveAs", true, m2), document.body.removeChild(M);
        }
      } else {
        var V = a.get("lang"), $ = '<body style="margin:0;"><img src="' + u + '" style="max-width:100%;" title="' + (V && V[0] || "") + '" /></body>', U = window.open();
        U.document.write($), U.document.title = i;
      }
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: e2.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: e2.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
      return n2;
    }, t2;
  }(Vh), dSe = vSe, o$ = "__ec_magicType_stack__", pSe = [["line", "bar"], ["stack"]], gSe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.getIcons = function() {
      var e2 = this.model, n2 = e2.get("icon"), a = {};
      return ae(e2.get("type"), function(i) {
        n2[i] && (a[i] = n2[i]);
      }), a;
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: e2.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
      return n2;
    }, t2.prototype.onclick = function(e2, n2, a) {
      var i = this.model, o = i.get(["seriesIndex", a]);
      if (!!s$[a]) {
        var s = { series: [] }, u = function(f2) {
          var h = f2.subType, v9 = f2.id, d2 = s$[a](h, v9, f2, i);
          d2 && (En(d2, f2.option), s.series.push(d2));
          var m2 = f2.coordinateSystem;
          if (m2 && m2.type === "cartesian2d" && (a === "line" || a === "bar")) {
            var b2 = m2.getAxesByScale("ordinal")[0];
            if (b2) {
              var _ = b2.dim, C = _ + "Axis", M = f2.getReferringComponents(C, uu).models[0], E = M.componentIndex;
              s[C] = s[C] || [];
              for (var z9 = 0; z9 <= E; z9++)
                s[C][E] = s[C][E] || {};
              s[C][E].boundaryGap = a === "bar";
            }
          }
        };
        ae(pSe, function(f2) {
          va(f2, a) >= 0 && ae(f2, function(h) {
            i.setIconStatus(h, "normal");
          });
        }), i.setIconStatus(a, "emphasis"), e2.eachComponent({ mainType: "series", query: o == null ? null : { seriesIndex: o } }, u);
        var l2, c2 = a;
        a === "stack" && (l2 = ea({ stack: i.option.title.tiled, tiled: i.option.title.stack }, i.option.title), i.get(["iconStatus", a]) !== "emphasis" && (c2 = "tiled")), n2.dispatchAction({ type: "changeMagicType", currentType: c2, newOption: s, newTitle: l2, featureName: "magicType" });
      }
    }, t2;
  }(Vh), s$ = { line: function(r2, t2, e2, n2) {
    if (r2 === "bar")
      return ea({ id: t2, type: "line", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, n2.get(["option", "line"]) || {}, true);
  }, bar: function(r2, t2, e2, n2) {
    if (r2 === "line")
      return ea({ id: t2, type: "bar", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, n2.get(["option", "bar"]) || {}, true);
  }, stack: function(r2, t2, e2, n2) {
    var a = e2.get("stack") === o$;
    if (r2 === "line" || r2 === "bar")
      return n2.setIconStatus("stack", a ? "normal" : "emphasis"), ea({ id: t2, stack: a ? "" : o$ }, n2.get(["option", "stack"]) || {}, true);
  } };
  op({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(r2, t2) {
    t2.mergeOption(r2.newOption);
  });
  var ySe = gSe, T3 = new Array(60).join("-"), lw = "	";
  function mSe(r2) {
    var t2 = {}, e2 = [], n2 = [];
    return r2.eachRawSeries(function(a) {
      var i = a.coordinateSystem;
      if (i && (i.type === "cartesian2d" || i.type === "polar")) {
        var o = i.getBaseAxis();
        if (o.type === "category") {
          var s = o.dim + "_" + o.index;
          t2[s] || (t2[s] = { categoryAxis: o, valueAxis: i.getOtherAxis(o), series: [] }, n2.push({ axisDim: o.dim, axisIndex: o.index })), t2[s].series.push(a);
        } else
          e2.push(a);
      } else
        e2.push(a);
    }), { seriesGroupByCategoryAxis: t2, other: e2, meta: n2 };
  }
  function bSe(r2) {
    var t2 = [];
    return ae(r2, function(e2, n2) {
      var a = e2.categoryAxis, i = e2.valueAxis, o = i.dim, s = [" "].concat(pr(e2.series, function(v9) {
        return v9.name;
      })), u = [a.model.getCategories()];
      ae(e2.series, function(v9) {
        var d2 = v9.getRawData();
        u.push(v9.getRawData().mapArray(d2.mapDimension(o), function(m2) {
          return m2;
        }));
      });
      for (var l2 = [s.join(lw)], c2 = 0; c2 < u[0].length; c2++) {
        for (var f2 = [], h = 0; h < u.length; h++)
          f2.push(u[h][c2]);
        l2.push(f2.join(lw));
      }
      t2.push(l2.join(`
`));
    }), t2.join(`

` + T3 + `

`);
  }
  function _Se(r2) {
    return pr(r2, function(t2) {
      var e2 = t2.getRawData(), n2 = [t2.name], a = [];
      return e2.each(e2.dimensions, function() {
        for (var i = arguments.length, o = arguments[i - 1], s = e2.getName(o), u = 0; u < i - 1; u++)
          a[u] = arguments[u];
        n2.push((s ? s + lw : "") + a.join(lw));
      }), n2.join(`
`);
    }).join(`

` + T3 + `

`);
  }
  function xSe(r2) {
    var t2 = mSe(r2);
    return { value: no([bSe(t2.seriesGroupByCategoryAxis), _Se(t2.other)], function(e2) {
      return !!e2.replace(/[\n\t\s]/g, "");
    }).join(`

` + T3 + `

`), meta: t2.meta };
  }
  function DP(r2) {
    return r2.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
  }
  function wSe(r2) {
    var t2 = r2.slice(0, r2.indexOf(`
`));
    if (t2.indexOf(lw) >= 0)
      return true;
  }
  var n6 = new RegExp("[" + lw + "]+", "g");
  function SSe(r2) {
    for (var t2 = r2.split(/\n+/g), e2 = DP(t2.shift()).split(n6), n2 = [], a = pr(e2, function(u) {
      return { name: u, data: [] };
    }), i = 0; i < t2.length; i++) {
      var o = DP(t2[i]).split(n6);
      n2.push(o.shift());
      for (var s = 0; s < o.length; s++)
        a[s] && (a[s].data[i] = o[s]);
    }
    return { series: a, categories: n2 };
  }
  function CSe(r2) {
    for (var t2 = r2.split(/\n+/g), e2 = DP(t2.shift()), n2 = [], a = 0; a < t2.length; a++) {
      var i = DP(t2[a]);
      if (!!i) {
        var o = i.split(n6), s = "", u = void 0, l2 = false;
        isNaN(o[0]) ? (l2 = true, s = o[0], o = o.slice(1), n2[a] = { name: s, value: [] }, u = n2[a].value) : u = n2[a] = [];
        for (var c2 = 0; c2 < o.length; c2++)
          u.push(+o[c2]);
        u.length === 1 && (l2 ? n2[a].value = u[0] : n2[a] = u[0]);
      }
    }
    return { name: e2, data: n2 };
  }
  function ESe(r2, t2) {
    var e2 = r2.split(new RegExp(`
*` + T3 + `
*`, "g")), n2 = { series: [] };
    return ae(e2, function(a, i) {
      if (wSe(a)) {
        var o = SSe(a), s = t2[i], u = s.axisDim + "Axis";
        s && (n2[u] = n2[u] || [], n2[u][s.axisIndex] = { data: o.categories }, n2.series = n2.series.concat(o.series));
      } else {
        var o = CSe(a);
        n2.series.push(o);
      }
    }), n2;
  }
  var ASe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.onclick = function(e2, n2) {
      setTimeout(function() {
        n2.dispatchAction({ type: "hideTip" });
      });
      var a = n2.getDom(), i = this.model;
      this._dom && a.removeChild(this._dom);
      var o = document.createElement("div");
      o.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", o.style.backgroundColor = i.get("backgroundColor") || "#fff";
      var s = document.createElement("h4"), u = i.get("lang") || [];
      s.innerHTML = u[0] || i.get("title"), s.style.cssText = "margin:10px 20px", s.style.color = i.get("textColor");
      var l2 = document.createElement("div"), c2 = document.createElement("textarea");
      l2.style.cssText = "overflow:auto";
      var f2 = i.get("optionToContent"), h = i.get("contentToOption"), v9 = xSe(e2);
      if (xn(f2)) {
        var d2 = f2(n2.getOption());
        Zr(d2) ? l2.innerHTML = d2 : ZC(d2) && l2.appendChild(d2);
      } else {
        c2.readOnly = i.get("readOnly");
        var m2 = c2.style;
        m2.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", m2.color = i.get("textColor"), m2.borderColor = i.get("textareaBorderColor"), m2.backgroundColor = i.get("textareaColor"), c2.value = v9.value, l2.appendChild(c2);
      }
      var b2 = v9.meta, _ = document.createElement("div");
      _.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
      var C = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", M = document.createElement("div"), E = document.createElement("div");
      C += ";background-color:" + i.get("buttonColor"), C += ";color:" + i.get("buttonTextColor");
      var z9 = this;
      function V() {
        a.removeChild(o), z9._dom = null;
      }
      VR(M, "click", V), VR(E, "click", function() {
        if (h == null && f2 != null || h != null && f2 == null) {
          V();
          return;
        }
        var $;
        try {
          xn(h) ? $ = h(l2, n2.getOption()) : $ = ESe(c2.value, b2);
        } catch (U) {
          throw V(), new Error("Data view format error " + U);
        }
        $ && n2.dispatchAction({ type: "changeDataView", newOption: $ }), V();
      }), M.innerHTML = u[1], E.innerHTML = u[2], E.style.cssText = M.style.cssText = C, !i.get("readOnly") && _.appendChild(E), _.appendChild(M), o.appendChild(s), o.appendChild(l2), o.appendChild(_), l2.style.height = a.clientHeight - 80 + "px", a.appendChild(o), this._dom = o;
    }, t2.prototype.remove = function(e2, n2) {
      this._dom && n2.getDom().removeChild(this._dom);
    }, t2.prototype.dispose = function(e2, n2) {
      this.remove(e2, n2);
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: e2.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: e2.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
      return n2;
    }, t2;
  }(Vh);
  function TSe(r2, t2) {
    return pr(r2, function(e2, n2) {
      var a = t2 && t2[n2];
      if (Tn(a) && !vr(a)) {
        var i = Tn(e2) && !vr(e2);
        i || (e2 = { value: e2 });
        var o = a.name != null && e2.name == null;
        return e2 = En(e2, a), o && delete e2.name, e2;
      } else
        return e2;
    });
  }
  op({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(r2, t2) {
    var e2 = [];
    ae(r2.newOption.series, function(n2) {
      var a = t2.getSeriesByName(n2.name)[0];
      if (!a)
        e2.push(qt({ type: "scatter" }, n2));
      else {
        var i = a.get("data");
        e2.push({ name: n2.name, data: TSe(n2.data, i) });
      }
    }), t2.mergeOption(En({ series: e2 }, r2.newOption));
  });
  var MSe = ASe, PZ = ae, DZ = fi();
  function PSe(r2, t2) {
    var e2 = MN(r2);
    PZ(t2, function(n2, a) {
      for (var i = e2.length - 1; i >= 0; i--) {
        var o = e2[i];
        if (o[a])
          break;
      }
      if (i < 0) {
        var s = r2.queryComponents({ mainType: "dataZoom", subType: "select", id: a })[0];
        if (s) {
          var u = s.getPercentRange();
          e2[0][a] = { dataZoomId: a, start: u[0], end: u[1] };
        }
      }
    }), e2.push(t2);
  }
  function DSe(r2) {
    var t2 = MN(r2), e2 = t2[t2.length - 1];
    t2.length > 1 && t2.pop();
    var n2 = {};
    return PZ(e2, function(a, i) {
      for (var o = t2.length - 1; o >= 0; o--)
        if (a = t2[o][i], a) {
          n2[i] = a;
          break;
        }
    }), n2;
  }
  function ISe(r2) {
    DZ(r2).snapshots = null;
  }
  function LSe(r2) {
    return MN(r2).length;
  }
  function MN(r2) {
    var t2 = DZ(r2);
    return t2.snapshots || (t2.snapshots = [{}]), t2.snapshots;
  }
  var OSe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.onclick = function(e2, n2) {
      ISe(e2), n2.dispatchAction({ type: "restore", from: this.uid });
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: e2.getLocaleModel().get(["toolbox", "restore", "title"]) };
      return n2;
    }, t2;
  }(Vh);
  op({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(r2, t2) {
    t2.resetOption("recreate");
  });
  var kSe = OSe, RSe = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], FSe = function() {
    function r2(t2, e2, n2) {
      var a = this;
      this._targetInfoList = [];
      var i = u$(e2, t2);
      ae(NSe, function(o, s) {
        (!n2 || !n2.include || va(n2.include, s) >= 0) && o(i, a._targetInfoList);
      });
    }
    return r2.prototype.setOutputRanges = function(t2, e2) {
      return this.matchOutputRanges(t2, e2, function(n2, a, i) {
        if ((n2.coordRanges || (n2.coordRanges = [])).push(a), !n2.coordRange) {
          n2.coordRange = a;
          var o = nR[n2.brushType](0, i, a);
          n2.__rangeOffset = { offset: h$[n2.brushType](o.values, n2.range, [1, 1]), xyMinMax: o.xyMinMax };
        }
      }), t2;
    }, r2.prototype.matchOutputRanges = function(t2, e2, n2) {
      ae(t2, function(a) {
        var i = this.findTargetInfo(a, e2);
        i && i !== true && ae(i.coordSyses, function(o) {
          var s = nR[a.brushType](1, o, a.range, true);
          n2(a, s.values, o, e2);
        });
      }, this);
    }, r2.prototype.setInputRanges = function(t2, e2) {
      ae(t2, function(n2) {
        var a = this.findTargetInfo(n2, e2);
        if (n2.range = n2.range || [], a && a !== true) {
          n2.panelId = a.panelId;
          var i = nR[n2.brushType](0, a.coordSys, n2.coordRange), o = n2.__rangeOffset;
          n2.range = o ? h$[n2.brushType](i.values, o.offset, VSe(i.xyMinMax, o.xyMinMax)) : i.values;
        }
      }, this);
    }, r2.prototype.makePanelOpts = function(t2, e2) {
      return pr(this._targetInfoList, function(n2) {
        var a = n2.getPanelRect();
        return { panelId: n2.panelId, defaultBrushType: e2 ? e2(n2) : null, clipPath: NK(a), isTargetByCursor: jK(a, t2, n2.coordSysModel), getLinearBrushOtherExtent: VK(a) };
      });
    }, r2.prototype.controlSeries = function(t2, e2, n2) {
      var a = this.findTargetInfo(t2, n2);
      return a === true || a && va(a.coordSyses, e2.coordinateSystem) >= 0;
    }, r2.prototype.findTargetInfo = function(t2, e2) {
      for (var n2 = this._targetInfoList, a = u$(e2, t2), i = 0; i < n2.length; i++) {
        var o = n2[i], s = t2.panelId;
        if (s) {
          if (o.panelId === s)
            return o;
        } else
          for (var u = 0; u < l$.length; u++)
            if (l$[u](a, o))
              return o;
      }
      return true;
    }, r2;
  }();
  function a6(r2) {
    return r2[0] > r2[1] && r2.reverse(), r2;
  }
  function u$(r2, t2) {
    return RC(r2, t2, { includeMainTypes: RSe });
  }
  var NSe = { grid: function(r2, t2) {
    var e2 = r2.xAxisModels, n2 = r2.yAxisModels, a = r2.gridModels, i = mn(), o = {}, s = {};
    !e2 && !n2 && !a || (ae(e2, function(u) {
      var l2 = u.axis.grid.model;
      i.set(l2.id, l2), o[l2.id] = true;
    }), ae(n2, function(u) {
      var l2 = u.axis.grid.model;
      i.set(l2.id, l2), s[l2.id] = true;
    }), ae(a, function(u) {
      i.set(u.id, u), o[u.id] = true, s[u.id] = true;
    }), i.each(function(u) {
      var l2 = u.coordinateSystem, c2 = [];
      ae(l2.getCartesians(), function(f2, h) {
        (va(e2, f2.getAxis("x").model) >= 0 || va(n2, f2.getAxis("y").model) >= 0) && c2.push(f2);
      }), t2.push({ panelId: "grid--" + u.id, gridModel: u, coordSysModel: u, coordSys: c2[0], coordSyses: c2, getPanelRect: c$.grid, xAxisDeclared: o[u.id], yAxisDeclared: s[u.id] });
    }));
  }, geo: function(r2, t2) {
    ae(r2.geoModels, function(e2) {
      var n2 = e2.coordinateSystem;
      t2.push({ panelId: "geo--" + e2.id, geoModel: e2, coordSysModel: e2, coordSys: n2, coordSyses: [n2], getPanelRect: c$.geo });
    });
  } }, l$ = [function(r2, t2) {
    var e2 = r2.xAxisModel, n2 = r2.yAxisModel, a = r2.gridModel;
    return !a && e2 && (a = e2.axis.grid.model), !a && n2 && (a = n2.axis.grid.model), a && a === t2.gridModel;
  }, function(r2, t2) {
    var e2 = r2.geoModel;
    return e2 && e2 === t2.geoModel;
  }], c$ = { grid: function() {
    return this.coordSys.master.getRect().clone();
  }, geo: function() {
    var r2 = this.coordSys, t2 = r2.getBoundingRect().clone();
    return t2.applyTransform(Yb(r2)), t2;
  } }, nR = { lineX: Gn(f$, 0), lineY: Gn(f$, 1), rect: function(r2, t2, e2, n2) {
    var a = r2 ? t2.pointToData([e2[0][0], e2[1][0]], n2) : t2.dataToPoint([e2[0][0], e2[1][0]], n2), i = r2 ? t2.pointToData([e2[0][1], e2[1][1]], n2) : t2.dataToPoint([e2[0][1], e2[1][1]], n2), o = [a6([a[0], i[0]]), a6([a[1], i[1]])];
    return { values: o, xyMinMax: o };
  }, polygon: function(r2, t2, e2, n2) {
    var a = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], i = pr(e2, function(o) {
      var s = r2 ? t2.pointToData(o, n2) : t2.dataToPoint(o, n2);
      return a[0][0] = Math.min(a[0][0], s[0]), a[1][0] = Math.min(a[1][0], s[1]), a[0][1] = Math.max(a[0][1], s[0]), a[1][1] = Math.max(a[1][1], s[1]), s;
    });
    return { values: i, xyMinMax: a };
  } };
  function f$(r2, t2, e2, n2) {
    var a = e2.getAxis(["x", "y"][r2]), i = a6(pr([0, 1], function(s) {
      return t2 ? a.coordToData(a.toLocalCoord(n2[s]), true) : a.toGlobalCoord(a.dataToCoord(n2[s]));
    })), o = [];
    return o[r2] = i, o[1 - r2] = [NaN, NaN], { values: i, xyMinMax: o };
  }
  var h$ = { lineX: Gn(v$, 0), lineY: Gn(v$, 1), rect: function(r2, t2, e2) {
    return [[r2[0][0] - e2[0] * t2[0][0], r2[0][1] - e2[0] * t2[0][1]], [r2[1][0] - e2[1] * t2[1][0], r2[1][1] - e2[1] * t2[1][1]]];
  }, polygon: function(r2, t2, e2) {
    return pr(r2, function(n2, a) {
      return [n2[0] - e2[0] * t2[a][0], n2[1] - e2[1] * t2[a][1]];
    });
  } };
  function v$(r2, t2, e2, n2) {
    return [t2[0] - n2[r2] * e2[0], t2[1] - n2[r2] * e2[1]];
  }
  function VSe(r2, t2) {
    var e2 = d$(r2), n2 = d$(t2), a = [e2[0] / n2[0], e2[1] / n2[1]];
    return isNaN(a[0]) && (a[0] = 1), isNaN(a[1]) && (a[1] = 1), a;
  }
  function d$(r2) {
    return r2 ? [r2[0][1] - r2[0][0], r2[1][1] - r2[1][0]] : [NaN, NaN];
  }
  var PN = FSe, i6 = ae, jSe = toe("toolbox-dataZoom_"), BSe = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.render = function(e2, n2, a, i) {
      this._brushController || (this._brushController = new lN(a.getZr()), this._brushController.on("brush", en(this._onBrush, this)).mount()), GSe(e2, n2, this, i, a), $Se(e2, n2);
    }, t2.prototype.onclick = function(e2, n2, a) {
      zSe[a].call(this);
    }, t2.prototype.remove = function(e2, n2) {
      this._brushController && this._brushController.unmount();
    }, t2.prototype.dispose = function(e2, n2) {
      this._brushController && this._brushController.dispose();
    }, t2.prototype._onBrush = function(e2) {
      var n2 = e2.areas;
      if (!e2.isEnd || !n2.length)
        return;
      var a = {}, i = this.ecModel;
      this._brushController.updateCovers([]);
      var o = new PN(DN(this.model), i, { include: ["grid"] });
      o.matchOutputRanges(n2, i, function(l2, c2, f2) {
        if (f2.type === "cartesian2d") {
          var h = l2.brushType;
          h === "rect" ? (s("x", f2, c2[0]), s("y", f2, c2[1])) : s({ lineX: "x", lineY: "y" }[h], f2, c2);
        }
      }), PSe(i, a), this._dispatchZoomAction(a);
      function s(l2, c2, f2) {
        var h = c2.getAxis(l2), v9 = h.model, d2 = u(l2, v9, i), m2 = d2.findRepresentativeAxisProxy(v9).getMinMaxSpan();
        (m2.minValueSpan != null || m2.maxValueSpan != null) && (f2 = f1(0, f2.slice(), h.scale.getExtent(), 0, m2.minValueSpan, m2.maxValueSpan)), d2 && (a[d2.id] = { dataZoomId: d2.id, startValue: f2[0], endValue: f2[1] });
      }
      function u(l2, c2, f2) {
        var h;
        return f2.eachComponent({ mainType: "dataZoom", subType: "select" }, function(v9) {
          var d2 = v9.getAxisModel(l2, c2.componentIndex);
          d2 && (h = v9);
        }), h;
      }
    }, t2.prototype._dispatchZoomAction = function(e2) {
      var n2 = [];
      i6(e2, function(a, i) {
        n2.push(On(a));
      }), n2.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: n2 });
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: e2.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
      return n2;
    }, t2;
  }(Vh), zSe = { zoom: function() {
    var r2 = !this._isZoomActive;
    this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: r2 });
  }, back: function() {
    this._dispatchZoomAction(DSe(this.ecModel));
  } };
  function DN(r2) {
    var t2 = { xAxisIndex: r2.get("xAxisIndex", true), yAxisIndex: r2.get("yAxisIndex", true), xAxisId: r2.get("xAxisId", true), yAxisId: r2.get("yAxisId", true) };
    return t2.xAxisIndex == null && t2.xAxisId == null && (t2.xAxisIndex = "all"), t2.yAxisIndex == null && t2.yAxisId == null && (t2.yAxisIndex = "all"), t2;
  }
  function $Se(r2, t2) {
    r2.setIconStatus("back", LSe(t2) > 1 ? "emphasis" : "normal");
  }
  function GSe(r2, t2, e2, n2, a) {
    var i = e2._isZoomActive;
    n2 && n2.type === "takeGlobalCursor" && (i = n2.key === "dataZoomSelect" ? n2.dataZoomSelectActive : false), e2._isZoomActive = i, r2.setIconStatus("zoom", i ? "emphasis" : "normal");
    var o = new PN(DN(r2), t2, { include: ["grid"] }), s = o.makePanelOpts(a, function(u) {
      return u.xAxisDeclared && !u.yAxisDeclared ? "lineX" : !u.xAxisDeclared && u.yAxisDeclared ? "lineY" : "rect";
    });
    e2._brushController.setPanels(s).enableBrush(i && s.length ? { brushType: "auto", brushStyle: r2.getModel("brushStyle").getItemStyle() } : false);
  }
  Bue("dataZoom", function(r2) {
    var t2 = r2.getComponent("toolbox", 0), e2 = ["feature", "dataZoom"];
    if (!t2 || t2.get(e2) == null)
      return;
    var n2 = t2.getModel(e2), a = [], i = DN(n2), o = RC(r2, i);
    i6(o.xAxisModels, function(u) {
      return s(u, "xAxis", "xAxisIndex");
    }), i6(o.yAxisModels, function(u) {
      return s(u, "yAxis", "yAxisIndex");
    });
    function s(u, l2, c2) {
      var f2 = u.componentIndex, h = { type: "select", $fromToolbox: true, filterMode: n2.get("filterMode", true) || "filter", id: jSe + l2 + f2 };
      h[c2] = f2, a.push(h);
    }
    return a;
  });
  var WSe = BSe;
  function USe(r2) {
    r2.registerComponentModel(uSe), r2.registerComponentView(hSe), Vx("saveAsImage", dSe), Vx("magicType", ySe), Vx("dataView", MSe), Vx("dataZoom", WSe), Vx("restore", kSe), ya(oSe);
  }
  var HSe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "tooltip", t2.dependencies = ["axisPointer"], t2.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, t2;
  }(li), qSe = HSe;
  function IZ(r2) {
    var t2 = r2.get("confine");
    return t2 != null ? !!t2 : r2.get("renderMode") === "richText";
  }
  function LZ(r2) {
    if (!!Ei.domSupported) {
      for (var t2 = document.documentElement.style, e2 = 0, n2 = r2.length; e2 < n2; e2++)
        if (r2[e2] in t2)
          return r2[e2];
    }
  }
  var OZ = LZ(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), YSe = LZ(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
  function kZ(r2, t2) {
    if (!r2)
      return t2;
    t2 = oH(t2, true);
    var e2 = r2.indexOf(t2);
    return r2 = e2 === -1 ? t2 : "-" + r2.slice(0, e2) + "-" + t2, r2.toLowerCase();
  }
  function KSe(r2, t2) {
    var e2 = r2.currentStyle || document.defaultView && document.defaultView.getComputedStyle(r2);
    return e2 ? t2 ? e2[t2] : e2 : null;
  }
  var ZSe = kZ(YSe, "transition"), IN = kZ(OZ, "transform"), XSe = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (Ei.transform3dSupported ? "will-change:transform;" : "");
  function JSe(r2) {
    return r2 = r2 === "left" ? "right" : r2 === "right" ? "left" : r2 === "top" ? "bottom" : "top", r2;
  }
  function QSe(r2, t2, e2) {
    if (!Zr(e2) || e2 === "inside")
      return "";
    var n2 = r2.get("backgroundColor"), a = r2.get("borderWidth");
    t2 = n1(t2);
    var i = JSe(e2), o = Math.max(Math.round(a) * 1.5, 6), s = "", u = IN + ":", l2;
    va(["left", "right"], i) > -1 ? (s += "top:50%", u += "translateY(-50%) rotate(" + (l2 = i === "left" ? -225 : -45) + "deg)") : (s += "left:50%", u += "translateX(-50%) rotate(" + (l2 = i === "top" ? 225 : 45) + "deg)");
    var c2 = l2 * Math.PI / 180, f2 = o + a, h = f2 * Math.abs(Math.cos(c2)) + f2 * Math.abs(Math.sin(c2)), v9 = Math.round(((h - Math.SQRT2 * a) / 2 + Math.SQRT2 * a - (h - f2) / 2) * 100) / 100;
    s += ";" + i + ":-" + v9 + "px";
    var d2 = t2 + " solid " + a + "px;", m2 = ["position:absolute;width:" + o + "px;height:" + o + "px;", s + ";" + u + ";", "border-bottom:" + d2, "border-right:" + d2, "background-color:" + n2 + ";"];
    return '<div style="' + m2.join("") + '"></div>';
  }
  function e2e(r2, t2) {
    var e2 = "cubic-bezier(0.23,1,0.32,1)", n2 = " " + r2 / 2 + "s " + e2, a = "opacity" + n2 + ",visibility" + n2;
    return t2 || (n2 = " " + r2 + "s " + e2, a += Ei.transformSupported ? "," + IN + n2 : ",left" + n2 + ",top" + n2), ZSe + ":" + a;
  }
  function p$(r2, t2, e2) {
    var n2 = r2.toFixed(0) + "px", a = t2.toFixed(0) + "px";
    if (!Ei.transformSupported)
      return e2 ? "top:" + a + ";left:" + n2 + ";" : [["top", a], ["left", n2]];
    var i = Ei.transform3dSupported, o = "translate" + (i ? "3d" : "") + "(" + n2 + "," + a + (i ? ",0" : "") + ")";
    return e2 ? "top:0;left:0;" + IN + ":" + o + ";" : [["top", 0], ["left", 0], [OZ, o]];
  }
  function t2e(r2) {
    var t2 = [], e2 = r2.get("fontSize"), n2 = r2.getTextColor();
    n2 && t2.push("color:" + n2), t2.push("font:" + r2.getFont()), e2 && t2.push("line-height:" + Math.round(e2 * 3 / 2) + "px");
    var a = r2.get("textShadowColor"), i = r2.get("textShadowBlur") || 0, o = r2.get("textShadowOffsetX") || 0, s = r2.get("textShadowOffsetY") || 0;
    return a && i && t2.push("text-shadow:" + o + "px " + s + "px " + i + "px " + a), ae(["decoration", "align"], function(u) {
      var l2 = r2.get(u);
      l2 && t2.push("text-" + u + ":" + l2);
    }), t2.join(";");
  }
  function r2e(r2, t2, e2) {
    var n2 = [], a = r2.get("transitionDuration"), i = r2.get("backgroundColor"), o = r2.get("shadowBlur"), s = r2.get("shadowColor"), u = r2.get("shadowOffsetX"), l2 = r2.get("shadowOffsetY"), c2 = r2.getModel("textStyle"), f2 = $H(r2, "html"), h = u + "px " + l2 + "px " + o + "px " + s;
    return n2.push("box-shadow:" + h), t2 && a && n2.push(e2e(a, e2)), i && n2.push("background-color:" + i), ae(["width", "color", "radius"], function(v9) {
      var d2 = "border-" + v9, m2 = oH(d2), b2 = r2.get(m2);
      b2 != null && n2.push(d2 + ":" + b2 + (v9 === "color" ? "" : "px"));
    }), n2.push(t2e(c2)), f2 != null && n2.push("padding:" + mw(f2).join("px ") + "px"), n2.join(";") + ";";
  }
  function g$(r2, t2, e2, n2, a) {
    var i = t2 && t2.painter;
    if (e2) {
      var o = i && i.getViewportRoot();
      o && Aae(r2, o, document.body, n2, a);
    } else {
      r2[0] = n2, r2[1] = a;
      var s = i && i.getViewportRootOffset();
      s && (r2[0] += s.offsetLeft, r2[1] += s.offsetTop);
    }
    r2[2] = r2[0] / t2.getWidth(), r2[3] = r2[1] / t2.getHeight();
  }
  var n2e = function() {
    function r2(t2, e2, n2) {
      if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, Ei.wxa)
        return null;
      var a = document.createElement("div");
      a.domBelongToZr = true, this.el = a;
      var i = this._zr = e2.getZr(), o = this._appendToBody = n2 && n2.appendToBody;
      g$(this._styleCoord, i, o, e2.getWidth() / 2, e2.getHeight() / 2), o ? document.body.appendChild(a) : t2.appendChild(a), this._container = t2;
      var s = this;
      a.onmouseenter = function() {
        s._enterable && (clearTimeout(s._hideTimeout), s._show = true), s._inContent = true;
      }, a.onmousemove = function(u) {
        if (u = u || window.event, !s._enterable) {
          var l2 = i.handler, c2 = i.painter.getViewportRoot();
          Oh(c2, u, true), l2.dispatch("mousemove", u);
        }
      }, a.onmouseleave = function() {
        s._inContent = false, s._enterable && s._show && s.hideLater(s._hideDelay);
      };
    }
    return r2.prototype.update = function(t2) {
      var e2 = this._container, n2 = KSe(e2, "position"), a = e2.style;
      a.position !== "absolute" && n2 !== "absolute" && (a.position = "relative");
      var i = t2.get("alwaysShowContent");
      i && this._moveIfResized(), this.el.className = t2.get("className") || "";
    }, r2.prototype.show = function(t2, e2) {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var n2 = this.el, a = n2.style, i = this._styleCoord;
      n2.innerHTML ? a.cssText = XSe + r2e(t2, !this._firstShow, this._longHide) + p$(i[0], i[1], true) + ("border-color:" + n1(e2) + ";") + (t2.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : a.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
    }, r2.prototype.setContent = function(t2, e2, n2, a, i) {
      var o = this.el;
      if (t2 == null) {
        o.innerHTML = "";
        return;
      }
      var s = "";
      if (Zr(i) && n2.get("trigger") === "item" && !IZ(n2) && (s = QSe(n2, a, i)), Zr(t2))
        o.innerHTML = t2 + s;
      else if (t2) {
        o.innerHTML = "", vr(t2) || (t2 = [t2]);
        for (var u = 0; u < t2.length; u++)
          ZC(t2[u]) && t2[u].parentNode !== o && o.appendChild(t2[u]);
        if (s && o.childNodes.length) {
          var l2 = document.createElement("div");
          l2.innerHTML = s, o.appendChild(l2);
        }
      }
    }, r2.prototype.setEnterable = function(t2) {
      this._enterable = t2;
    }, r2.prototype.getSize = function() {
      var t2 = this.el;
      return [t2.offsetWidth, t2.offsetHeight];
    }, r2.prototype.moveTo = function(t2, e2) {
      var n2 = this._styleCoord;
      if (g$(n2, this._zr, this._appendToBody, t2, e2), n2[0] != null && n2[1] != null) {
        var a = this.el.style, i = p$(n2[0], n2[1]);
        ae(i, function(o) {
          a[o[0]] = o[1];
        });
      }
    }, r2.prototype._moveIfResized = function() {
      var t2 = this._styleCoord[2], e2 = this._styleCoord[3];
      this.moveTo(t2 * this._zr.getWidth(), e2 * this._zr.getHeight());
    }, r2.prototype.hide = function() {
      var t2 = this, e2 = this.el.style;
      e2.visibility = "hidden", e2.opacity = "0", Ei.transform3dSupported && (e2.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
        return t2._longHide = true;
      }, 500);
    }, r2.prototype.hideLater = function(t2) {
      this._show && !(this._inContent && this._enterable) && (t2 ? (this._hideDelay = t2, this._show = false, this._hideTimeout = setTimeout(en(this.hide, this), t2)) : this.hide());
    }, r2.prototype.isShow = function() {
      return this._show;
    }, r2.prototype.dispose = function() {
      this.el.parentNode.removeChild(this.el);
    }, r2;
  }(), a2e = n2e, i2e = function() {
    function r2(t2) {
      this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = t2.getZr(), m$(this._styleCoord, this._zr, t2.getWidth() / 2, t2.getHeight() / 2);
    }
    return r2.prototype.update = function(t2) {
      var e2 = t2.get("alwaysShowContent");
      e2 && this._moveIfResized();
    }, r2.prototype.show = function() {
      this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
    }, r2.prototype.setContent = function(t2, e2, n2, a, i) {
      var o = this;
      Tn(t2) && Ii(""), this.el && this._zr.remove(this.el);
      var s = n2.getModel("textStyle");
      this.el = new xi({ style: { rich: e2.richTextStyles, text: t2, lineHeight: 22, borderWidth: 1, borderColor: a, textShadowColor: s.get("textShadowColor"), fill: n2.get(["textStyle", "color"]), padding: $H(n2, "richText"), verticalAlign: "top", align: "left" }, z: n2.get("z") }), ae(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(l2) {
        o.el.style[l2] = n2.get(l2);
      }), ae(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(l2) {
        o.el.style[l2] = s.get(l2) || 0;
      }), this._zr.add(this.el);
      var u = this;
      this.el.on("mouseover", function() {
        u._enterable && (clearTimeout(u._hideTimeout), u._show = true), u._inContent = true;
      }), this.el.on("mouseout", function() {
        u._enterable && u._show && u.hideLater(u._hideDelay), u._inContent = false;
      });
    }, r2.prototype.setEnterable = function(t2) {
      this._enterable = t2;
    }, r2.prototype.getSize = function() {
      var t2 = this.el, e2 = this.el.getBoundingRect(), n2 = y$(t2.style);
      return [e2.width + n2.left + n2.right, e2.height + n2.top + n2.bottom];
    }, r2.prototype.moveTo = function(t2, e2) {
      var n2 = this.el;
      if (n2) {
        var a = this._styleCoord;
        m$(a, this._zr, t2, e2), t2 = a[0], e2 = a[1];
        var i = n2.style, o = J0(i.borderWidth || 0), s = y$(i);
        n2.x = t2 + o + s.left, n2.y = e2 + o + s.top, n2.markRedraw();
      }
    }, r2.prototype._moveIfResized = function() {
      var t2 = this._styleCoord[2], e2 = this._styleCoord[3];
      this.moveTo(t2 * this._zr.getWidth(), e2 * this._zr.getHeight());
    }, r2.prototype.hide = function() {
      this.el && this.el.hide(), this._show = false;
    }, r2.prototype.hideLater = function(t2) {
      this._show && !(this._inContent && this._enterable) && (t2 ? (this._hideDelay = t2, this._show = false, this._hideTimeout = setTimeout(en(this.hide, this), t2)) : this.hide());
    }, r2.prototype.isShow = function() {
      return this._show;
    }, r2.prototype.dispose = function() {
      this._zr.remove(this.el);
    }, r2;
  }();
  function J0(r2) {
    return Math.max(0, r2);
  }
  function y$(r2) {
    var t2 = J0(r2.shadowBlur || 0), e2 = J0(r2.shadowOffsetX || 0), n2 = J0(r2.shadowOffsetY || 0);
    return { left: J0(t2 - e2), right: J0(t2 + e2), top: J0(t2 - n2), bottom: J0(t2 + n2) };
  }
  function m$(r2, t2, e2, n2) {
    r2[0] = e2, r2[1] = n2, r2[2] = r2[0] / t2.getWidth(), r2[3] = r2[1] / t2.getHeight();
  }
  var o2e = i2e, s2e = new ni({ shape: { x: -1, y: -1, width: 2, height: 2 } }), u2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      if (!(Ei.node || !n2.getDom())) {
        var a = e2.getComponent("tooltip"), i = this._renderMode = uoe(a.get("renderMode"));
        this._tooltipContent = i === "richText" ? new o2e(n2) : new a2e(n2.getDom(), n2, { appendToBody: a.get("appendToBody", true) });
      }
    }, t2.prototype.render = function(e2, n2, a) {
      if (!(Ei.node || !a.getDom())) {
        this.group.removeAll(), this._tooltipModel = e2, this._ecModel = n2, this._api = a, this._alwaysShowContent = e2.get("alwaysShowContent");
        var i = this._tooltipContent;
        i.update(e2), i.setEnterable(e2.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && e2.get("transitionDuration") ? Sw(this, "_updatePosition", 50, "fixRate") : lE(this, "_updatePosition");
      }
    }, t2.prototype._initGlobalListener = function() {
      var e2 = this._tooltipModel, n2 = e2.get("triggerOn");
      yZ("itemTooltip", this._api, en(function(a, i, o) {
        n2 !== "none" && (n2.indexOf(a) >= 0 ? this._tryShow(i, o) : a === "leave" && this._hide(o));
      }, this));
    }, t2.prototype._keepShow = function() {
      var e2 = this._tooltipModel, n2 = this._ecModel, a = this._api;
      if (this._lastX != null && this._lastY != null && e2.get("triggerOn") !== "none") {
        var i = this;
        clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
          !a.isDisposed() && i.manuallyShowTip(e2, n2, a, { x: i._lastX, y: i._lastY, dataByCoordSys: i._lastDataByCoordSys });
        });
      }
    }, t2.prototype.manuallyShowTip = function(e2, n2, a, i) {
      if (!(i.from === this.uid || Ei.node || !a.getDom())) {
        var o = b$(i, a);
        this._ticket = "";
        var s = i.dataByCoordSys, u = h2e(i, n2, a);
        if (u) {
          var l2 = u.el.getBoundingRect().clone();
          l2.applyTransform(u.el.transform), this._tryShow({ offsetX: l2.x + l2.width / 2, offsetY: l2.y + l2.height / 2, target: u.el, position: i.position, positionDefault: "bottom" }, o);
        } else if (i.tooltip && i.x != null && i.y != null) {
          var c2 = s2e;
          c2.x = i.x, c2.y = i.y, c2.update(), zn(c2).tooltipConfig = { name: null, option: i.tooltip }, this._tryShow({ offsetX: i.x, offsetY: i.y, target: c2 }, o);
        } else if (s)
          this._tryShow({ offsetX: i.x, offsetY: i.y, position: i.position, dataByCoordSys: s, tooltipOption: i.tooltipOption }, o);
        else if (i.seriesIndex != null) {
          if (this._manuallyAxisShowTip(e2, n2, a, i))
            return;
          var f2 = mZ(i, n2), h = f2.point[0], v9 = f2.point[1];
          h != null && v9 != null && this._tryShow({ offsetX: h, offsetY: v9, target: f2.el, position: i.position, positionDefault: "bottom" }, o);
        } else
          i.x != null && i.y != null && (a.dispatchAction({ type: "updateAxisPointer", x: i.x, y: i.y }), this._tryShow({ offsetX: i.x, offsetY: i.y, position: i.position, target: a.getZr().findHover(i.x, i.y).target }, o));
      }
    }, t2.prototype.manuallyHideTip = function(e2, n2, a, i) {
      var o = this._tooltipContent;
      !this._alwaysShowContent && this._tooltipModel && o.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, i.from !== this.uid && this._hide(b$(i, a));
    }, t2.prototype._manuallyAxisShowTip = function(e2, n2, a, i) {
      var o = i.seriesIndex, s = i.dataIndex, u = n2.getComponent("axisPointer").coordSysAxesInfo;
      if (!(o == null || s == null || u == null)) {
        var l2 = n2.getSeriesByIndex(o);
        if (!!l2) {
          var c2 = l2.getData(), f2 = cC([c2.getItemModel(s), l2, (l2.coordinateSystem || {}).model], this._tooltipModel);
          if (f2.get("trigger") === "axis")
            return a.dispatchAction({ type: "updateAxisPointer", seriesIndex: o, dataIndex: s, position: i.position }), true;
        }
      }
    }, t2.prototype._tryShow = function(e2, n2) {
      var a = e2.target, i = this._tooltipModel;
      if (!!i) {
        this._lastX = e2.offsetX, this._lastY = e2.offsetY;
        var o = e2.dataByCoordSys;
        if (o && o.length)
          this._showAxisTooltip(o, e2);
        else if (a) {
          this._lastDataByCoordSys = null;
          var s, u;
          $x(a, function(l2) {
            if (zn(l2).dataIndex != null)
              return s = l2, true;
            if (zn(l2).tooltipConfig != null)
              return u = l2, true;
          }, true), s ? this._showSeriesItemTooltip(e2, s, n2) : u ? this._showComponentItemTooltip(e2, u, n2) : this._hide(n2);
        } else
          this._lastDataByCoordSys = null, this._hide(n2);
      }
    }, t2.prototype._showOrMove = function(e2, n2) {
      var a = e2.get("showDelay");
      n2 = en(n2, this), clearTimeout(this._showTimout), a > 0 ? this._showTimout = setTimeout(n2, a) : n2();
    }, t2.prototype._showAxisTooltip = function(e2, n2) {
      var a = this._ecModel, i = this._tooltipModel, o = [n2.offsetX, n2.offsetY], s = cC([n2.tooltipOption], i), u = this._renderMode, l2 = [], c2 = Hu("section", { blocks: [], noHeader: true }), f2 = [], h = new GO();
      ae(e2, function(C) {
        ae(C.dataByAxis, function(M) {
          var E = a.getComponent(M.axisDim + "Axis", M.axisIndex), z9 = M.value;
          if (!(!E || z9 == null)) {
            var V = dZ(z9, E.axis, a, M.seriesDataIndices, M.valueLabelOpt), $ = Hu("section", { header: V, noHeader: !jv(V), sortBlocks: true, blocks: [] });
            c2.blocks.push($), ae(M.seriesDataIndices, function(U) {
              var H = a.getSeriesByIndex(U.seriesIndex), q3 = U.dataIndexInside, ee = H.getDataParams(q3);
              if (!(ee.dataIndex < 0)) {
                ee.axisDim = M.axisDim, ee.axisIndex = M.axisIndex, ee.axisType = M.axisType, ee.axisId = M.axisId, ee.axisValue = RF(E.axis, { value: z9 }), ee.axisValueLabel = V, ee.marker = h.makeTooltipMarker("item", n1(ee.color), u);
                var oe = aV(H.formatTooltip(q3, true, null)), ne = oe.frag;
                if (ne) {
                  var be = cC([H], i).get("valueFormatter");
                  $.blocks.push(be ? qt({ valueFormatter: be }, ne) : ne);
                }
                oe.text && f2.push(oe.text), l2.push(ee);
              }
            });
          }
        });
      }), c2.blocks.reverse(), f2.reverse();
      var v9 = n2.position, d2 = s.get("order"), m2 = cV(c2, h, u, d2, a.get("useUTC"), s.get("textStyle"));
      m2 && f2.unshift(m2);
      var b2 = u === "richText" ? `

` : "<br/>", _ = f2.join(b2);
      this._showOrMove(s, function() {
        this._updateContentNotChangedOnAxis(e2, l2) ? this._updatePosition(s, v9, o[0], o[1], this._tooltipContent, l2) : this._showTooltipContent(s, _, l2, Math.random() + "", o[0], o[1], v9, null, h);
      });
    }, t2.prototype._showSeriesItemTooltip = function(e2, n2, a) {
      var i = this._ecModel, o = zn(n2), s = o.seriesIndex, u = i.getSeriesByIndex(s), l2 = o.dataModel || u, c2 = o.dataIndex, f2 = o.dataType, h = l2.getData(f2), v9 = this._renderMode, d2 = e2.positionDefault, m2 = cC([h.getItemModel(c2), l2, u && (u.coordinateSystem || {}).model], this._tooltipModel, d2 ? { position: d2 } : null), b2 = m2.get("trigger");
      if (!(b2 != null && b2 !== "item")) {
        var _ = l2.getDataParams(c2, f2), C = new GO();
        _.marker = C.makeTooltipMarker("item", n1(_.color), v9);
        var M = aV(l2.formatTooltip(c2, false, f2)), E = m2.get("order"), z9 = m2.get("valueFormatter"), V = M.frag, $ = V ? cV(z9 ? qt({ valueFormatter: z9 }, V) : V, C, v9, E, i.get("useUTC"), m2.get("textStyle")) : M.text, U = "item_" + l2.name + "_" + c2;
        this._showOrMove(m2, function() {
          this._showTooltipContent(m2, $, _, U, e2.offsetX, e2.offsetY, e2.position, e2.target, C);
        }), a({ type: "showTip", dataIndexInside: c2, dataIndex: h.getRawIndex(c2), seriesIndex: s, from: this.uid });
      }
    }, t2.prototype._showComponentItemTooltip = function(e2, n2, a) {
      var i = zn(n2), o = i.tooltipConfig, s = o.option || {};
      if (Zr(s)) {
        var u = s;
        s = { content: u, formatter: u };
      }
      var l2 = [s], c2 = this._ecModel.getComponent(i.componentMainType, i.componentIndex);
      c2 && l2.push(c2), l2.push({ formatter: s.content });
      var f2 = e2.positionDefault, h = cC(l2, this._tooltipModel, f2 ? { position: f2 } : null), v9 = h.get("content"), d2 = Math.random() + "", m2 = new GO();
      this._showOrMove(h, function() {
        var b2 = On(h.get("formatterParams") || {});
        this._showTooltipContent(h, v9, b2, d2, e2.offsetX, e2.offsetY, e2.position, n2, m2);
      }), a({ type: "showTip", from: this.uid });
    }, t2.prototype._showTooltipContent = function(e2, n2, a, i, o, s, u, l2, c2) {
      if (this._ticket = "", !(!e2.get("showContent") || !e2.get("show"))) {
        var f2 = this._tooltipContent;
        f2.setEnterable(e2.get("enterable"));
        var h = e2.get("formatter");
        u = u || e2.get("position");
        var v9 = n2, d2 = this._getNearestPoint([o, s], a, e2.get("trigger"), e2.get("borderColor")), m2 = d2.color;
        if (h)
          if (Zr(h)) {
            var b2 = e2.ecModel.get("useUTC"), _ = vr(a) ? a[0] : a, C = _ && _.axisType && _.axisType.indexOf("time") >= 0;
            v9 = h, C && (v9 = i3(_.axisValue, v9, b2)), v9 = sH(v9, a, true);
          } else if (xn(h)) {
            var M = en(function(E, z9) {
              E === this._ticket && (f2.setContent(z9, c2, e2, m2, u), this._updatePosition(e2, u, o, s, f2, a, l2));
            }, this);
            this._ticket = i, v9 = h(a, i, M);
          } else
            v9 = h;
        f2.setContent(v9, c2, e2, m2, u), f2.show(e2, m2), this._updatePosition(e2, u, o, s, f2, a, l2);
      }
    }, t2.prototype._getNearestPoint = function(e2, n2, a, i) {
      if (a === "axis" || vr(n2))
        return { color: i || (this._renderMode === "html" ? "#fff" : "none") };
      if (!vr(n2))
        return { color: i || n2.color || n2.borderColor };
    }, t2.prototype._updatePosition = function(e2, n2, a, i, o, s, u) {
      var l2 = this._api.getWidth(), c2 = this._api.getHeight();
      n2 = n2 || e2.get("position");
      var f2 = o.getSize(), h = e2.get("align"), v9 = e2.get("verticalAlign"), d2 = u && u.getBoundingRect().clone();
      if (u && d2.applyTransform(u.transform), xn(n2) && (n2 = n2([a, i], s, o.el, d2, { viewSize: [l2, c2], contentSize: f2.slice() })), vr(n2))
        a = qr(n2[0], l2), i = qr(n2[1], c2);
      else if (Tn(n2)) {
        var m2 = n2;
        m2.width = f2[0], m2.height = f2[1];
        var b2 = Eu(m2, { width: l2, height: c2 });
        a = b2.x, i = b2.y, h = null, v9 = null;
      } else if (Zr(n2) && u) {
        var _ = f2e(n2, d2, f2, e2.get("borderWidth"));
        a = _[0], i = _[1];
      } else {
        var _ = l2e(a, i, o, l2, c2, h ? null : 20, v9 ? null : 20);
        a = _[0], i = _[1];
      }
      if (h && (a -= _$(h) ? f2[0] / 2 : h === "right" ? f2[0] : 0), v9 && (i -= _$(v9) ? f2[1] / 2 : v9 === "bottom" ? f2[1] : 0), IZ(e2)) {
        var _ = c2e(a, i, o, l2, c2);
        a = _[0], i = _[1];
      }
      o.moveTo(a, i);
    }, t2.prototype._updateContentNotChangedOnAxis = function(e2, n2) {
      var a = this._lastDataByCoordSys, i = this._cbParamsList, o = !!a && a.length === e2.length;
      return o && ae(a, function(s, u) {
        var l2 = s.dataByAxis || [], c2 = e2[u] || {}, f2 = c2.dataByAxis || [];
        o = o && l2.length === f2.length, o && ae(l2, function(h, v9) {
          var d2 = f2[v9] || {}, m2 = h.seriesDataIndices || [], b2 = d2.seriesDataIndices || [];
          o = o && h.value === d2.value && h.axisType === d2.axisType && h.axisId === d2.axisId && m2.length === b2.length, o && ae(m2, function(_, C) {
            var M = b2[C];
            o = o && _.seriesIndex === M.seriesIndex && _.dataIndex === M.dataIndex;
          }), i && ae(h.seriesDataIndices, function(_) {
            var C = _.seriesIndex, M = n2[C], E = i[C];
            M && E && E.data !== M.data && (o = false);
          });
        });
      }), this._lastDataByCoordSys = e2, this._cbParamsList = n2, !!o;
    }, t2.prototype._hide = function(e2) {
      this._lastDataByCoordSys = null, e2({ type: "hideTip", from: this.uid });
    }, t2.prototype.dispose = function(e2, n2) {
      Ei.node || !n2.getDom() || (lE(this, "_updatePosition"), this._tooltipContent.dispose(), e6("itemTooltip", n2));
    }, t2.type = "tooltip", t2;
  }(gs);
  function cC(r2, t2, e2) {
    var n2 = t2.ecModel, a;
    e2 ? (a = new To(e2, n2, n2), a = new To(t2.option, a, n2)) : a = t2;
    for (var i = r2.length - 1; i >= 0; i--) {
      var o = r2[i];
      o && (o instanceof To && (o = o.get("tooltip", true)), Zr(o) && (o = { formatter: o }), o && (a = new To(o, a, n2)));
    }
    return a;
  }
  function b$(r2, t2) {
    return r2.dispatchAction || en(t2.dispatchAction, t2);
  }
  function l2e(r2, t2, e2, n2, a, i, o) {
    var s = e2.getSize(), u = s[0], l2 = s[1];
    return i != null && (r2 + u + i + 2 > n2 ? r2 -= u + i : r2 += i), o != null && (t2 + l2 + o > a ? t2 -= l2 + o : t2 += o), [r2, t2];
  }
  function c2e(r2, t2, e2, n2, a) {
    var i = e2.getSize(), o = i[0], s = i[1];
    return r2 = Math.min(r2 + o, n2) - o, t2 = Math.min(t2 + s, a) - s, r2 = Math.max(r2, 0), t2 = Math.max(t2, 0), [r2, t2];
  }
  function f2e(r2, t2, e2, n2) {
    var a = e2[0], i = e2[1], o = Math.ceil(Math.SQRT2 * n2) + 8, s = 0, u = 0, l2 = t2.width, c2 = t2.height;
    switch (r2) {
      case "inside":
        s = t2.x + l2 / 2 - a / 2, u = t2.y + c2 / 2 - i / 2;
        break;
      case "top":
        s = t2.x + l2 / 2 - a / 2, u = t2.y - i - o;
        break;
      case "bottom":
        s = t2.x + l2 / 2 - a / 2, u = t2.y + c2 + o;
        break;
      case "left":
        s = t2.x - a - o, u = t2.y + c2 / 2 - i / 2;
        break;
      case "right":
        s = t2.x + l2 + o, u = t2.y + c2 / 2 - i / 2;
    }
    return [s, u];
  }
  function _$(r2) {
    return r2 === "center" || r2 === "middle";
  }
  function h2e(r2, t2, e2) {
    var n2 = Y6(r2).queryOptionMap, a = n2.keys()[0];
    if (!(!a || a === "series")) {
      var i = DE(t2, a, n2.get(a), { useDefault: false, enableAll: false, enableNone: false }), o = i.models[0];
      if (!!o) {
        var s = e2.getViewOfComponentModel(o), u;
        if (s.group.traverse(function(l2) {
          var c2 = zn(l2).tooltipConfig;
          if (c2 && c2.name === r2.name)
            return u = l2, true;
        }), u)
          return { componentMainType: a, componentIndex: o.componentIndex, el: u };
      }
    }
  }
  var v2e = u2e;
  function d2e(r2) {
    ya(KE), r2.registerComponentModel(qSe), r2.registerComponentView(v2e), r2.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, lu), r2.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, lu);
  }
  var p2e = ["rect", "polygon", "keep", "clear"];
  function g2e(r2, t2) {
    var e2 = ao(r2 ? r2.brush : []);
    if (!!e2.length) {
      var n2 = [];
      ae(e2, function(u) {
        var l2 = u.hasOwnProperty("toolbox") ? u.toolbox : [];
        l2 instanceof Array && (n2 = n2.concat(l2));
      });
      var a = r2 && r2.toolbox;
      vr(a) && (a = a[0]), a || (a = { feature: {} }, r2.toolbox = [a]);
      var i = a.feature || (a.feature = {}), o = i.brush || (i.brush = {}), s = o.type || (o.type = []);
      s.push.apply(s, n2), y2e(s), t2 && !s.length && s.push.apply(s, p2e);
    }
  }
  function y2e(r2) {
    var t2 = {};
    ae(r2, function(e2) {
      t2[e2] = 1;
    }), r2.length = 0, ae(t2, function(e2, n2) {
      r2.push(n2);
    });
  }
  var x$ = ae;
  function w$(r2) {
    if (r2) {
      for (var t2 in r2)
        if (r2.hasOwnProperty(t2))
          return true;
    }
  }
  function o6(r2, t2, e2) {
    var n2 = {};
    return x$(t2, function(i) {
      var o = n2[i] = a();
      x$(r2[i], function(s, u) {
        if (!!Vl.isValidType(u)) {
          var l2 = { type: u, visual: s };
          e2 && e2(l2, i), o[u] = new Vl(l2), u === "opacity" && (l2 = On(l2), l2.type = "colorAlpha", o.__hidden.__alphaForOpacity = new Vl(l2));
        }
      });
    }), n2;
    function a() {
      var i = function() {
      };
      i.prototype.__hidden = i.prototype;
      var o = new i();
      return o;
    }
  }
  function RZ(r2, t2, e2) {
    var n2;
    ae(e2, function(a) {
      t2.hasOwnProperty(a) && w$(t2[a]) && (n2 = true);
    }), n2 && ae(e2, function(a) {
      t2.hasOwnProperty(a) && w$(t2[a]) ? r2[a] = On(t2[a]) : delete r2[a];
    });
  }
  function m2e(r2, t2, e2, n2, a, i) {
    var o = {};
    ae(r2, function(f2) {
      var h = Vl.prepareVisualTypes(t2[f2]);
      o[f2] = h;
    });
    var s;
    function u(f2) {
      return CF(e2, s, f2);
    }
    function l2(f2, h) {
      JH(e2, s, f2, h);
    }
    i == null ? e2.each(c2) : e2.each([i], c2);
    function c2(f2, h) {
      s = i == null ? f2 : h;
      var v9 = e2.getRawDataItem(s);
      if (!(v9 && v9.visualMap === false))
        for (var d2 = n2.call(a, f2), m2 = t2[d2], b2 = o[d2], _ = 0, C = b2.length; _ < C; _++) {
          var M = b2[_];
          m2[M] && m2[M].applyVisual(f2, u, l2);
        }
    }
  }
  function b2e(r2, t2, e2, n2) {
    var a = {};
    return ae(r2, function(i) {
      var o = Vl.prepareVisualTypes(t2[i]);
      a[i] = o;
    }), { progress: function(o, s) {
      var u;
      n2 != null && (u = s.getDimensionIndex(n2));
      function l2(z9) {
        return CF(s, f2, z9);
      }
      function c2(z9, V) {
        JH(s, f2, z9, V);
      }
      for (var f2, h = s.getStore(); (f2 = o.next()) != null; ) {
        var v9 = s.getRawDataItem(f2);
        if (!(v9 && v9.visualMap === false))
          for (var d2 = n2 != null ? h.get(u, f2) : f2, m2 = e2(d2), b2 = t2[m2], _ = a[m2], C = 0, M = _.length; C < M; C++) {
            var E = _[C];
            b2[E] && b2[E].applyVisual(d2, l2, c2);
          }
      }
    } };
  }
  function _2e(r2) {
    var t2 = r2.brushType, e2 = { point: function(n2) {
      return S$[t2].point(n2, e2, r2);
    }, rect: function(n2) {
      return S$[t2].rect(n2, e2, r2);
    } };
    return e2;
  }
  var S$ = { lineX: C$(0), lineY: C$(1), rect: { point: function(r2, t2, e2) {
    return r2 && e2.boundingRect.contain(r2[0], r2[1]);
  }, rect: function(r2, t2, e2) {
    return r2 && e2.boundingRect.intersect(r2);
  } }, polygon: { point: function(r2, t2, e2) {
    return r2 && e2.boundingRect.contain(r2[0], r2[1]) && kb(e2.range, r2[0], r2[1]);
  }, rect: function(r2, t2, e2) {
    var n2 = e2.range;
    if (!r2 || n2.length <= 1)
      return false;
    var a = r2.x, i = r2.y, o = r2.width, s = r2.height, u = n2[0];
    if (kb(n2, a, i) || kb(n2, a + o, i) || kb(n2, a, i + s) || kb(n2, a + o, i + s) || da.create(r2).contain(u[0], u[1]) || wC(a, i, a + o, i, n2) || wC(a, i, a, i + s, n2) || wC(a + o, i, a + o, i + s, n2) || wC(a, i + s, a + o, i + s, n2))
      return true;
  } } };
  function C$(r2) {
    var t2 = ["x", "y"], e2 = ["width", "height"];
    return { point: function(n2, a, i) {
      if (n2) {
        var o = i.range, s = n2[r2];
        return fC(s, o);
      }
    }, rect: function(n2, a, i) {
      if (n2) {
        var o = i.range, s = [n2[t2[r2]], n2[t2[r2]] + n2[e2[r2]]];
        return s[1] < s[0] && s.reverse(), fC(s[0], o) || fC(s[1], o) || fC(o[0], s) || fC(o[1], s);
      }
    } };
  }
  function fC(r2, t2) {
    return t2[0] <= r2 && r2 <= t2[1];
  }
  var E$ = ["inBrush", "outOfBrush"], aR = "__ecBrushSelect", s6 = "__ecInBrushSelectEvent";
  function FZ(r2) {
    r2.eachComponent({ mainType: "brush" }, function(t2) {
      var e2 = t2.brushTargetManager = new PN(t2.option, r2);
      e2.setInputRanges(t2.areas, r2);
    });
  }
  function x2e(r2, t2, e2) {
    var n2 = [], a, i;
    r2.eachComponent({ mainType: "brush" }, function(o) {
      e2 && e2.type === "takeGlobalCursor" && o.setBrushOption(e2.key === "brush" ? e2.brushOption : { brushType: false });
    }), FZ(r2), r2.eachComponent({ mainType: "brush" }, function(o, s) {
      var u = { brushId: o.id, brushIndex: s, brushName: o.name, areas: On(o.areas), selected: [] };
      n2.push(u);
      var l2 = o.option, c2 = l2.brushLink, f2 = [], h = [], v9 = [], d2 = false;
      s || (a = l2.throttleType, i = l2.throttleDelay);
      var m2 = pr(o.areas, function(z9) {
        var V = E2e[z9.brushType], $ = En({ boundingRect: V ? V(z9) : void 0 }, z9);
        return $.selectors = _2e($), $;
      }), b2 = o6(o.option, E$, function(z9) {
        z9.mappingMethod = "fixed";
      });
      vr(c2) && ae(c2, function(z9) {
        f2[z9] = 1;
      });
      function _(z9) {
        return c2 === "all" || !!f2[z9];
      }
      function C(z9) {
        return !!z9.length;
      }
      r2.eachSeries(function(z9, V) {
        var $ = v9[V] = [];
        z9.subType === "parallel" ? M(z9, V) : E(z9, V, $);
      });
      function M(z9, V) {
        var $ = z9.coordinateSystem;
        d2 = d2 || $.hasAxisBrushed(), _(V) && $.eachActiveState(z9.getData(), function(U, H) {
          U === "active" && (h[H] = 1);
        });
      }
      function E(z9, V, $) {
        if (!(!z9.brushSelector || C2e(o, V)) && (ae(m2, function(H) {
          o.brushTargetManager.controlSeries(H, z9, r2) && $.push(H), d2 = d2 || C($);
        }), _(V) && C($))) {
          var U = z9.getData();
          U.each(function(H) {
            A$(z9, $, U, H) && (h[H] = 1);
          });
        }
      }
      r2.eachSeries(function(z9, V) {
        var $ = { seriesId: z9.id, seriesIndex: V, seriesName: z9.name, dataIndex: [] };
        u.selected.push($);
        var U = v9[V], H = z9.getData(), q3 = _(V) ? function(ee) {
          return h[ee] ? ($.dataIndex.push(H.getRawIndex(ee)), "inBrush") : "outOfBrush";
        } : function(ee) {
          return A$(z9, U, H, ee) ? ($.dataIndex.push(H.getRawIndex(ee)), "inBrush") : "outOfBrush";
        };
        (_(V) ? d2 : C(U)) && m2e(E$, b2, H, q3);
      });
    }), w2e(t2, a, i, n2, e2);
  }
  function w2e(r2, t2, e2, n2, a) {
    if (!!a) {
      var i = r2.getZr();
      if (!i[s6]) {
        i[aR] || (i[aR] = S2e);
        var o = Sw(i, aR, e2, t2);
        o(r2, n2);
      }
    }
  }
  function S2e(r2, t2) {
    if (!r2.isDisposed()) {
      var e2 = r2.getZr();
      e2[s6] = true, r2.dispatchAction({ type: "brushSelect", batch: t2 }), e2[s6] = false;
    }
  }
  function A$(r2, t2, e2, n2) {
    for (var a = 0, i = t2.length; a < i; a++) {
      var o = t2[a];
      if (r2.brushSelector(n2, e2, o.selectors, o))
        return true;
    }
  }
  function C2e(r2, t2) {
    var e2 = r2.option.seriesIndex;
    return e2 != null && e2 !== "all" && (vr(e2) ? va(e2, t2) < 0 : t2 !== e2);
  }
  var E2e = { rect: function(r2) {
    return T$(r2.range);
  }, polygon: function(r2) {
    for (var t2, e2 = r2.range, n2 = 0, a = e2.length; n2 < a; n2++) {
      t2 = t2 || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
      var i = e2[n2];
      i[0] < t2[0][0] && (t2[0][0] = i[0]), i[0] > t2[0][1] && (t2[0][1] = i[0]), i[1] < t2[1][0] && (t2[1][0] = i[1]), i[1] > t2[1][1] && (t2[1][1] = i[1]);
    }
    return t2 && T$(t2);
  } };
  function T$(r2) {
    return new da(r2[0][0], r2[1][0], r2[0][1] - r2[0][0], r2[1][1] - r2[1][0]);
  }
  var A2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this.ecModel = e2, this.api = n2, this.model, (this._brushController = new lN(n2.getZr())).on("brush", en(this._onBrush, this)).mount();
    }, t2.prototype.render = function(e2, n2, a, i) {
      this.model = e2, this._updateController(e2, n2, a, i);
    }, t2.prototype.updateTransform = function(e2, n2, a, i) {
      FZ(n2), this._updateController(e2, n2, a, i);
    }, t2.prototype.updateVisual = function(e2, n2, a, i) {
      this.updateTransform(e2, n2, a, i);
    }, t2.prototype.updateView = function(e2, n2, a, i) {
      this._updateController(e2, n2, a, i);
    }, t2.prototype._updateController = function(e2, n2, a, i) {
      (!i || i.$from !== e2.id) && this._brushController.setPanels(e2.brushTargetManager.makePanelOpts(a)).enableBrush(e2.brushOption).updateCovers(e2.areas.slice());
    }, t2.prototype.dispose = function() {
      this._brushController.dispose();
    }, t2.prototype._onBrush = function(e2) {
      var n2 = this.model.id, a = this.model.brushTargetManager.setOutputRanges(e2.areas, this.ecModel);
      (!e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: n2, areas: On(a), $from: n2 }), e2.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: n2, areas: On(a), $from: n2 });
    }, t2.type = "brush", t2;
  }(gs), T2e = A2e, M2e = "#ddd", P2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.areas = [], e2.brushOption = {}, e2;
    }
    return t2.prototype.optionUpdated = function(e2, n2) {
      var a = this.option;
      !n2 && RZ(a, e2, ["inBrush", "outOfBrush"]);
      var i = a.inBrush = a.inBrush || {};
      a.outOfBrush = a.outOfBrush || { color: M2e }, i.hasOwnProperty("liftZ") || (i.liftZ = 5);
    }, t2.prototype.setAreas = function(e2) {
      !e2 || (this.areas = pr(e2, function(n2) {
        return M$(this.option, n2);
      }, this));
    }, t2.prototype.setBrushOption = function(e2) {
      this.brushOption = M$(this.option, e2), this.brushType = this.brushOption.brushType;
    }, t2.type = "brush", t2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], t2.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, t2;
  }(li);
  function M$(r2, t2) {
    return ea({ brushType: r2.brushType, brushMode: r2.brushMode, transformable: r2.transformable, brushStyle: new To(r2.brushStyle).getItemStyle(), removeOnClick: r2.removeOnClick, z: r2.z }, t2, true);
  }
  var D2e = P2e, I2e = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], L2e = function(r2) {
    ot(t2, r2);
    function t2() {
      return r2 !== null && r2.apply(this, arguments) || this;
    }
    return t2.prototype.render = function(e2, n2, a) {
      var i, o, s;
      n2.eachComponent({ mainType: "brush" }, function(u) {
        i = u.brushType, o = u.brushOption.brushMode || "single", s = s || !!u.areas.length;
      }), this._brushType = i, this._brushMode = o, ae(e2.get("type", true), function(u) {
        e2.setIconStatus(u, (u === "keep" ? o === "multiple" : u === "clear" ? s : u === i) ? "emphasis" : "normal");
      });
    }, t2.prototype.updateView = function(e2, n2, a) {
      this.render(e2, n2, a);
    }, t2.prototype.getIcons = function() {
      var e2 = this.model, n2 = e2.get("icon", true), a = {};
      return ae(e2.get("type", true), function(i) {
        n2[i] && (a[i] = n2[i]);
      }), a;
    }, t2.prototype.onclick = function(e2, n2, a) {
      var i = this._brushType, o = this._brushMode;
      a === "clear" ? (n2.dispatchAction({ type: "axisAreaSelect", intervals: [] }), n2.dispatchAction({ type: "brush", command: "clear", areas: [] })) : n2.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: a === "keep" ? i : i === a ? false : a, brushMode: a === "keep" ? o === "multiple" ? "single" : "multiple" : o } });
    }, t2.getDefaultOption = function(e2) {
      var n2 = { show: true, type: I2e.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: e2.getLocaleModel().get(["toolbox", "brush", "title"]) };
      return n2;
    }, t2;
  }(Vh), O2e = L2e;
  function k2e(r2) {
    r2.registerComponentView(T2e), r2.registerComponentModel(D2e), r2.registerPreprocessor(g2e), r2.registerVisual(r2.PRIORITY.VISUAL.BRUSH, x2e), r2.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(t2, e2) {
      e2.eachComponent({ mainType: "brush", query: t2 }, function(n2) {
        n2.setAreas(t2.areas);
      });
    }), r2.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, lu), r2.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, lu), Vx("brush", O2e);
  }
  var R2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
    }
    return t2.type = "title", t2.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, t2;
  }(li), F2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var i = this.group, o = e2.getModel("textStyle"), s = e2.getModel("subtextStyle"), u = e2.get("textAlign"), l2 = ia(e2.get("textBaseline"), e2.get("textVerticalAlign")), c2 = new xi({ style: Hs(o, { text: e2.get("text"), fill: o.getTextColor() }, { disableBox: true }), z2: 10 }), f2 = c2.getBoundingRect(), h = e2.get("subtext"), v9 = new xi({ style: Hs(s, { text: h, fill: s.getTextColor(), y: f2.height + e2.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), d2 = e2.get("link"), m2 = e2.get("sublink"), b2 = e2.get("triggerEvent", true);
        c2.silent = !d2 && !b2, v9.silent = !m2 && !b2, d2 && c2.on("click", function() {
          iP(d2, "_" + e2.get("target"));
        }), m2 && v9.on("click", function() {
          iP(m2, "_" + e2.get("subtarget"));
        }), zn(c2).eventData = zn(v9).eventData = b2 ? { componentType: "title", componentIndex: e2.componentIndex } : null, i.add(c2), h && i.add(v9);
        var _ = i.getBoundingRect(), C = e2.getBoxLayoutParams();
        C.width = _.width, C.height = _.height;
        var M = Eu(C, { width: a.getWidth(), height: a.getHeight() }, e2.get("padding"));
        u || (u = e2.get("left") || e2.get("right"), u === "middle" && (u = "center"), u === "right" ? M.x += M.width : u === "center" && (M.x += M.width / 2)), l2 || (l2 = e2.get("top") || e2.get("bottom"), l2 === "center" && (l2 = "middle"), l2 === "bottom" ? M.y += M.height : l2 === "middle" && (M.y += M.height / 2), l2 = l2 || "top"), i.x = M.x, i.y = M.y, i.markRedraw();
        var E = { align: u, verticalAlign: l2 };
        c2.setStyle(E), v9.setStyle(E), _ = i.getBoundingRect();
        var z9 = M.margin, V = e2.getItemStyle(["color", "opacity"]);
        V.fill = e2.get("backgroundColor");
        var $ = new ni({ shape: { x: _.x - z9[3], y: _.y - z9[0], width: _.width + z9[1] + z9[3], height: _.height + z9[0] + z9[2], r: e2.get("borderRadius") }, style: V, subPixelOptimize: true, silent: true });
        i.add($);
      }
    }, t2.type = "title", t2;
  }(gs);
  function N2e(r2) {
    r2.registerComponentModel(R2e), r2.registerComponentView(F2e);
  }
  var V2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.layoutMode = "box", e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.mergeDefaultAndTheme(e2, a), this._initData();
    }, t2.prototype.mergeOption = function(e2) {
      r2.prototype.mergeOption.apply(this, arguments), this._initData();
    }, t2.prototype.setCurrentIndex = function(e2) {
      e2 == null && (e2 = this.option.currentIndex);
      var n2 = this._data.count();
      this.option.loop ? e2 = (e2 % n2 + n2) % n2 : (e2 >= n2 && (e2 = n2 - 1), e2 < 0 && (e2 = 0)), this.option.currentIndex = e2;
    }, t2.prototype.getCurrentIndex = function() {
      return this.option.currentIndex;
    }, t2.prototype.isIndexMax = function() {
      return this.getCurrentIndex() >= this._data.count() - 1;
    }, t2.prototype.setPlayState = function(e2) {
      this.option.autoPlay = !!e2;
    }, t2.prototype.getPlayState = function() {
      return !!this.option.autoPlay;
    }, t2.prototype._initData = function() {
      var e2 = this.option, n2 = e2.data || [], a = e2.axisType, i = this._names = [], o;
      a === "category" ? (o = [], ae(n2, function(l2, c2) {
        var f2 = Cu(hw(l2), ""), h;
        Tn(l2) ? (h = On(l2), h.value = c2) : h = c2, o.push(h), i.push(f2);
      })) : o = n2;
      var s = { category: "ordinal", time: "time", value: "number" }[a] || "number", u = this._data = new Rc([{ name: "value", type: s }], this);
      u.initData(o, i);
    }, t2.prototype.getData = function() {
      return this._data;
    }, t2.prototype.getCategories = function() {
      if (this.get("axisType") === "category")
        return this._names.slice();
    }, t2.type = "timeline", t2.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, t2;
  }(li), P$ = V2e, NZ = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "timeline.slider", t2.defaultOption = Ty(P$.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), t2;
  }(P$);
  fu(NZ, bF.prototype);
  var j2e = NZ, B2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "timeline", t2;
  }(gs), z2e = B2e, $2e = function(r2) {
    ot(t2, r2);
    function t2(e2, n2, a, i) {
      var o = r2.call(this, e2, n2, a) || this;
      return o.type = i || "value", o;
    }
    return t2.prototype.getLabelModel = function() {
      return this.model.getModel("label");
    }, t2.prototype.isHorizontal = function() {
      return this.model.get("orient") === "horizontal";
    }, t2;
  }(Hv), G2e = $2e, iR = Math.PI, D$ = fi(), W2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this.api = n2;
    }, t2.prototype.render = function(e2, n2, a) {
      if (this.model = e2, this.api = a, this.ecModel = n2, this.group.removeAll(), e2.get("show", true)) {
        var i = this._layout(e2, a), o = this._createGroup("_mainGroup"), s = this._createGroup("_labelGroup"), u = this._axis = this._createAxis(i, e2);
        e2.formatTooltip = function(l2) {
          var c2 = u.scale.getLabel({ value: l2 });
          return Hu("nameValue", { noName: true, value: c2 });
        }, ae(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(l2) {
          this["_render" + l2](i, o, u, e2);
        }, this), this._renderAxisLabel(i, s, u, e2), this._position(i, e2);
      }
      this._doPlayStop(), this._updateTicksStatus();
    }, t2.prototype.remove = function() {
      this._clearTimer(), this.group.removeAll();
    }, t2.prototype.dispose = function() {
      this._clearTimer();
    }, t2.prototype._layout = function(e2, n2) {
      var a = e2.get(["label", "position"]), i = e2.get("orient"), o = H2e(e2, n2), s;
      a == null || a === "auto" ? s = i === "horizontal" ? o.y + o.height / 2 < n2.getHeight() / 2 ? "-" : "+" : o.x + o.width / 2 < n2.getWidth() / 2 ? "+" : "-" : Zr(a) ? s = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[i][a] : s = a;
      var u = { horizontal: "center", vertical: s >= 0 || s === "+" ? "left" : "right" }, l2 = { horizontal: s >= 0 || s === "+" ? "top" : "bottom", vertical: "middle" }, c2 = { horizontal: 0, vertical: iR / 2 }, f2 = i === "vertical" ? o.height : o.width, h = e2.getModel("controlStyle"), v9 = h.get("show", true), d2 = v9 ? h.get("itemSize") : 0, m2 = v9 ? h.get("itemGap") : 0, b2 = d2 + m2, _ = e2.get(["label", "rotate"]) || 0;
      _ = _ * iR / 180;
      var C, M, E, z9 = h.get("position", true), V = v9 && h.get("showPlayBtn", true), $ = v9 && h.get("showPrevBtn", true), U = v9 && h.get("showNextBtn", true), H = 0, q3 = f2;
      z9 === "left" || z9 === "bottom" ? (V && (C = [0, 0], H += b2), $ && (M = [H, 0], H += b2), U && (E = [q3 - d2, 0], q3 -= b2)) : (V && (C = [q3 - d2, 0], q3 -= b2), $ && (M = [0, 0], H += b2), U && (E = [q3 - d2, 0], q3 -= b2));
      var ee = [H, q3];
      return e2.get("inverse") && ee.reverse(), { viewRect: o, mainLength: f2, orient: i, rotation: c2[i], labelRotation: _, labelPosOpt: s, labelAlign: e2.get(["label", "align"]) || u[i], labelBaseline: e2.get(["label", "verticalAlign"]) || e2.get(["label", "baseline"]) || l2[i], playPosition: C, prevBtnPosition: M, nextBtnPosition: E, axisExtent: ee, controlSize: d2, controlGap: m2 };
    }, t2.prototype._position = function(e2, n2) {
      var a = this._mainGroup, i = this._labelGroup, o = e2.viewRect;
      if (e2.orient === "vertical") {
        var s = Hh(), u = o.x, l2 = o.y + o.height;
        ep(s, s, [-u, -l2]), s1(s, s, -iR / 2), ep(s, s, [u, l2]), o = o.clone(), o.applyTransform(s);
      }
      var c2 = C(o), f2 = C(a.getBoundingRect()), h = C(i.getBoundingRect()), v9 = [a.x, a.y], d2 = [i.x, i.y];
      d2[0] = v9[0] = c2[0][0];
      var m2 = e2.labelPosOpt;
      if (m2 == null || Zr(m2)) {
        var b2 = m2 === "+" ? 0 : 1;
        M(v9, f2, c2, 1, b2), M(d2, h, c2, 1, 1 - b2);
      } else {
        var b2 = m2 >= 0 ? 0 : 1;
        M(v9, f2, c2, 1, b2), d2[1] = v9[1] + m2;
      }
      a.setPosition(v9), i.setPosition(d2), a.rotation = i.rotation = e2.rotation, _(a), _(i);
      function _(E) {
        E.originX = c2[0][0] - E.x, E.originY = c2[1][0] - E.y;
      }
      function C(E) {
        return [[E.x, E.x + E.width], [E.y, E.y + E.height]];
      }
      function M(E, z9, V, $, U) {
        E[$] += V[$][U] - z9[$][U];
      }
    }, t2.prototype._createAxis = function(e2, n2) {
      var a = n2.getData(), i = n2.get("axisType"), o = U2e(n2, i);
      o.getTicks = function() {
        return a.mapArray(["value"], function(l2) {
          return { value: l2 };
        });
      };
      var s = a.getDataExtent("value");
      o.setExtent(s[0], s[1]), o.calcNiceTicks();
      var u = new G2e("value", o, e2.axisExtent, i);
      return u.model = n2, u;
    }, t2.prototype._createGroup = function(e2) {
      var n2 = this[e2] = new Fn();
      return this.group.add(n2), n2;
    }, t2.prototype._renderAxisLine = function(e2, n2, a, i) {
      var o = a.getExtent();
      if (!!i.get(["lineStyle", "show"])) {
        var s = new bl({ shape: { x1: o[0], y1: 0, x2: o[1], y2: 0 }, style: qt({ lineCap: "round" }, i.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
        n2.add(s);
        var u = this._progressLine = new bl({ shape: { x1: o[0], x2: this._currentPointer ? this._currentPointer.x : o[0], y1: 0, y2: 0 }, style: En({ lineCap: "round", lineWidth: s.style.lineWidth }, i.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
        n2.add(u);
      }
    }, t2.prototype._renderAxisTick = function(e2, n2, a, i) {
      var o = this, s = i.getData(), u = a.scale.getTicks();
      this._tickSymbols = [], ae(u, function(l2) {
        var c2 = a.dataToCoord(l2.value), f2 = s.getItemModel(l2.value), h = f2.getModel("itemStyle"), v9 = f2.getModel(["emphasis", "itemStyle"]), d2 = f2.getModel(["progress", "itemStyle"]), m2 = { x: c2, y: 0, onclick: en(o._changeTimeline, o, l2.value) }, b2 = I$(f2, h, n2, m2);
        b2.ensureState("emphasis").style = v9.getItemStyle(), b2.ensureState("progress").style = d2.getItemStyle(), qb(b2);
        var _ = zn(b2);
        f2.get("tooltip") ? (_.dataIndex = l2.value, _.dataModel = i) : _.dataIndex = _.dataModel = null, o._tickSymbols.push(b2);
      });
    }, t2.prototype._renderAxisLabel = function(e2, n2, a, i) {
      var o = this, s = a.getLabelModel();
      if (!!s.get("show")) {
        var u = i.getData(), l2 = a.getViewLabels();
        this._tickLabels = [], ae(l2, function(c2) {
          var f2 = c2.tickValue, h = u.getItemModel(f2), v9 = h.getModel("label"), d2 = h.getModel(["emphasis", "label"]), m2 = h.getModel(["progress", "label"]), b2 = a.dataToCoord(c2.tickValue), _ = new xi({ x: b2, y: 0, rotation: e2.labelRotation - e2.rotation, onclick: en(o._changeTimeline, o, f2), silent: false, style: Hs(v9, { text: c2.formattedLabel, align: e2.labelAlign, verticalAlign: e2.labelBaseline }) });
          _.ensureState("emphasis").style = Hs(d2), _.ensureState("progress").style = Hs(m2), n2.add(_), qb(_), D$(_).dataIndex = f2, o._tickLabels.push(_);
        });
      }
    }, t2.prototype._renderControl = function(e2, n2, a, i) {
      var o = e2.controlSize, s = e2.rotation, u = i.getModel("controlStyle").getItemStyle(), l2 = i.getModel(["emphasis", "controlStyle"]).getItemStyle(), c2 = i.getPlayState(), f2 = i.get("inverse", true);
      h(e2.nextBtnPosition, "next", en(this._changeTimeline, this, f2 ? "-" : "+")), h(e2.prevBtnPosition, "prev", en(this._changeTimeline, this, f2 ? "+" : "-")), h(e2.playPosition, c2 ? "stop" : "play", en(this._handlePlayClick, this, !c2), true);
      function h(v9, d2, m2, b2) {
        if (!!v9) {
          var _ = Gv(ia(i.get(["controlStyle", d2 + "BtnSize"]), o), o), C = [0, -_ / 2, _, _], M = q2e(i, d2 + "Icon", C, { x: v9[0], y: v9[1], originX: o / 2, originY: 0, rotation: b2 ? -s : 0, rectHover: true, style: u, onclick: m2 });
          M.ensureState("emphasis").style = l2, n2.add(M), qb(M);
        }
      }
    }, t2.prototype._renderCurrentPointer = function(e2, n2, a, i) {
      var o = i.getData(), s = i.getCurrentIndex(), u = o.getItemModel(s).getModel("checkpointStyle"), l2 = this, c2 = { onCreate: function(f2) {
        f2.draggable = true, f2.drift = en(l2._handlePointerDrag, l2), f2.ondragend = en(l2._handlePointerDragend, l2), L$(f2, l2._progressLine, s, a, i, true);
      }, onUpdate: function(f2) {
        L$(f2, l2._progressLine, s, a, i);
      } };
      this._currentPointer = I$(u, u, this._mainGroup, {}, this._currentPointer, c2);
    }, t2.prototype._handlePlayClick = function(e2) {
      this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: e2, from: this.uid });
    }, t2.prototype._handlePointerDrag = function(e2, n2, a) {
      this._clearTimer(), this._pointerChangeTimeline([a.offsetX, a.offsetY]);
    }, t2.prototype._handlePointerDragend = function(e2) {
      this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
    }, t2.prototype._pointerChangeTimeline = function(e2, n2) {
      var a = this._toAxisCoord(e2)[0], i = this._axis, o = $h(i.getExtent().slice());
      a > o[1] && (a = o[1]), a < o[0] && (a = o[0]), this._currentPointer.x = a, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = a, this._progressLine.dirty();
      var s = this._findNearestTick(a), u = this.model;
      (n2 || s !== u.getCurrentIndex() && u.get("realtime")) && this._changeTimeline(s);
    }, t2.prototype._doPlayStop = function() {
      var e2 = this;
      this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
        var n2 = e2.model;
        e2._changeTimeline(n2.getCurrentIndex() + (n2.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval")));
    }, t2.prototype._toAxisCoord = function(e2) {
      var n2 = this._mainGroup.getLocalTransform();
      return $v(e2, n2, true);
    }, t2.prototype._findNearestTick = function(e2) {
      var n2 = this.model.getData(), a = 1 / 0, i, o = this._axis;
      return n2.each(["value"], function(s, u) {
        var l2 = o.dataToCoord(s), c2 = Math.abs(l2 - e2);
        c2 < a && (a = c2, i = u);
      }), i;
    }, t2.prototype._clearTimer = function() {
      this._timer && (clearTimeout(this._timer), this._timer = null);
    }, t2.prototype._changeTimeline = function(e2) {
      var n2 = this.model.getCurrentIndex();
      e2 === "+" ? e2 = n2 + 1 : e2 === "-" && (e2 = n2 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: e2, from: this.uid });
    }, t2.prototype._updateTicksStatus = function() {
      var e2 = this.model.getCurrentIndex(), n2 = this._tickSymbols, a = this._tickLabels;
      if (n2)
        for (var i = 0; i < n2.length; i++)
          n2 && n2[i] && n2[i].toggleState("progress", i < e2);
      if (a)
        for (var i = 0; i < a.length; i++)
          a && a[i] && a[i].toggleState("progress", D$(a[i]).dataIndex <= e2);
    }, t2.type = "timeline.slider", t2;
  }(z2e);
  function U2e(r2, t2) {
    if (t2 = t2 || r2.get("type"), t2)
      switch (t2) {
        case "category":
          return new IF({ ordinalMeta: r2.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new zq({ locale: r2.ecModel.getLocaleModel(), useUTC: r2.ecModel.get("useUTC") });
        default:
          return new xy();
      }
  }
  function H2e(r2, t2) {
    return Eu(r2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() }, r2.get("padding"));
  }
  function q2e(r2, t2, e2, n2) {
    var a = n2.style, i = kE(r2.get(["controlStyle", t2]), n2 || {}, new da(e2[0], e2[1], e2[2], e2[3]));
    return a && i.setStyle(a), i;
  }
  function I$(r2, t2, e2, n2, a, i) {
    var o = t2.get("color");
    if (a)
      a.setColor(o), e2.add(a), i && i.onUpdate(a);
    else {
      var s = r2.get("symbol");
      a = cu(s, -1, -1, 2, 2, o), a.setStyle("strokeNoScale", true), e2.add(a), i && i.onCreate(a);
    }
    var u = t2.getItemStyle(["color"]);
    a.setStyle(u), n2 = ea({ rectHover: true, z2: 100 }, n2, true);
    var l2 = VE(r2.get("symbolSize"));
    n2.scaleX = l2[0] / 2, n2.scaleY = l2[1] / 2;
    var c2 = Cw(r2.get("symbolOffset"), l2);
    c2 && (n2.x = (n2.x || 0) + c2[0], n2.y = (n2.y || 0) + c2[1]);
    var f2 = r2.get("symbolRotate");
    return n2.rotation = (f2 || 0) * Math.PI / 180 || 0, a.attr(n2), a.updateTransform(), a;
  }
  function L$(r2, t2, e2, n2, a, i) {
    if (!r2.dragging) {
      var o = a.getModel("checkpointStyle"), s = n2.dataToCoord(a.getData().get("value", e2));
      if (i || !o.get("animation", true))
        r2.attr({ x: s, y: 0 }), t2 && t2.attr({ shape: { x2: s } });
      else {
        var u = { duration: o.get("animationDuration", true), easing: o.get("animationEasing", true) };
        r2.stopAnimation(null, true), r2.animateTo({ x: s, y: 0 }, u), t2 && t2.animateTo({ shape: { x2: s } }, u);
      }
    }
  }
  var Y2e = W2e;
  function K2e(r2) {
    r2.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(t2, e2, n2) {
      var a = e2.getComponent("timeline");
      return a && t2.currentIndex != null && (a.setCurrentIndex(t2.currentIndex), !a.get("loop", true) && a.isIndexMax() && a.getPlayState() && (a.setPlayState(false), n2.dispatchAction({ type: "timelinePlayChange", playState: false, from: t2.from }))), e2.resetOption("timeline", { replaceMerge: a.get("replaceMerge", true) }), En({ currentIndex: a.option.currentIndex }, t2);
    }), r2.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(t2, e2) {
      var n2 = e2.getComponent("timeline");
      n2 && t2.playState != null && n2.setPlayState(t2.playState);
    });
  }
  function Z2e(r2) {
    var t2 = r2 && r2.timeline;
    vr(t2) || (t2 = t2 ? [t2] : []), ae(t2, function(e2) {
      !e2 || X2e(e2);
    });
  }
  function X2e(r2) {
    var t2 = r2.type, e2 = { number: "value", time: "time" };
    if (e2[t2] && (r2.axisType = e2[t2], delete r2.type), O$(r2), Nb(r2, "controlPosition")) {
      var n2 = r2.controlStyle || (r2.controlStyle = {});
      Nb(n2, "position") || (n2.position = r2.controlPosition), n2.position === "none" && !Nb(n2, "show") && (n2.show = false, delete n2.position), delete r2.controlPosition;
    }
    ae(r2.data || [], function(a) {
      Tn(a) && !vr(a) && (!Nb(a, "value") && Nb(a, "name") && (a.value = a.name), O$(a));
    });
  }
  function O$(r2) {
    var t2 = r2.itemStyle || (r2.itemStyle = {}), e2 = t2.emphasis || (t2.emphasis = {}), n2 = r2.label || r2.label || {}, a = n2.normal || (n2.normal = {}), i = { normal: 1, emphasis: 1 };
    ae(n2, function(o, s) {
      !i[s] && !Nb(a, s) && (a[s] = o);
    }), e2.label && !Nb(n2, "emphasis") && (n2.emphasis = e2.label, delete e2.label);
  }
  function Nb(r2, t2) {
    return r2.hasOwnProperty(t2);
  }
  function J2e(r2) {
    r2.registerComponentModel(j2e), r2.registerComponentView(Y2e), r2.registerSubTypeDefaulter("timeline", function() {
      return "slider";
    }), K2e(r2), r2.registerPreprocessor(Z2e);
  }
  function LN(r2, t2) {
    if (!r2)
      return false;
    for (var e2 = vr(r2) ? r2 : [r2], n2 = 0; n2 < e2.length; n2++)
      if (e2[n2] && e2[n2][t2])
        return true;
    return false;
  }
  function l5(r2) {
    Qb(r2, "label", ["show"]);
  }
  var c5 = fi(), VZ = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.createdBySelf = false, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.mergeDefaultAndTheme(e2, a), this._mergeOption(e2, a, false, true);
    }, t2.prototype.isAnimationEnabled = function() {
      if (Ei.node)
        return false;
      var e2 = this.__hostSeries;
      return this.getShallow("animation") && e2 && e2.isAnimationEnabled();
    }, t2.prototype.mergeOption = function(e2, n2) {
      this._mergeOption(e2, n2, false, false);
    }, t2.prototype._mergeOption = function(e2, n2, a, i) {
      var o = this.mainType;
      a || n2.eachSeries(function(s) {
        var u = s.get(this.mainType, true), l2 = c5(s)[o];
        if (!u || !u.data) {
          c5(s)[o] = null;
          return;
        }
        l2 ? l2._mergeOption(u, n2, true) : (i && l5(u), ae(u.data, function(c2) {
          c2 instanceof Array ? (l5(c2[0]), l5(c2[1])) : l5(c2);
        }), l2 = this.createMarkerModelFromSeries(u, this, n2), qt(l2, { mainType: this.mainType, seriesIndex: s.seriesIndex, name: s.name, createdBySelf: true }), l2.__hostSeries = s), c5(s)[o] = l2;
      }, this);
    }, t2.prototype.formatTooltip = function(e2, n2, a) {
      var i = this.getData(), o = this.getRawValue(e2), s = i.getName(e2);
      return Hu("section", { header: this.name, blocks: [Hu("nameValue", { name: s, value: o, noName: !s, noValue: o == null })] });
    }, t2.prototype.getData = function() {
      return this._data;
    }, t2.prototype.setData = function(e2) {
      this._data = e2;
    }, t2.getMarkerModelFromSeries = function(e2, n2) {
      return c5(e2)[n2];
    }, t2.type = "marker", t2.dependencies = ["series", "grid", "polar", "geo"], t2;
  }(li);
  fu(VZ, bF.prototype);
  var Cy = VZ, Q2e = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.createMarkerModelFromSeries = function(e2, n2, a) {
      return new t2(e2, n2, a);
    }, t2.type = "markPoint", t2.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, t2;
  }(Cy), eCe = Q2e;
  function tCe(r2) {
    return !(isNaN(parseFloat(r2.x)) && isNaN(parseFloat(r2.y)));
  }
  function rCe(r2) {
    return !isNaN(parseFloat(r2.x)) && !isNaN(parseFloat(r2.y));
  }
  function f5(r2, t2, e2, n2, a, i) {
    var o = [], s = _y(t2, n2), u = s ? t2.getCalculationInfo("stackResultDimension") : n2, l2 = ON(t2, u, r2), c2 = t2.indicesOfNearest(u, l2)[0];
    o[a] = t2.get(e2, c2), o[i] = t2.get(u, c2);
    var f2 = t2.get(n2, c2), h = Ud(t2.get(n2, c2));
    return h = Math.min(h, 20), h >= 0 && (o[i] = +o[i].toFixed(h)), [o, f2];
  }
  var oR = { min: Gn(f5, "min"), max: Gn(f5, "max"), average: Gn(f5, "average"), median: Gn(f5, "median") };
  function SE(r2, t2) {
    var e2 = r2.getData(), n2 = r2.coordinateSystem;
    if (t2 && !rCe(t2) && !vr(t2.coord) && n2) {
      var a = n2.dimensions, i = jZ(t2, e2, n2, r2);
      if (t2 = On(t2), t2.type && oR[t2.type] && i.baseAxis && i.valueAxis) {
        var o = va(a, i.baseAxis.dim), s = va(a, i.valueAxis.dim), u = oR[t2.type](e2, i.baseDataDim, i.valueDataDim, o, s);
        t2.coord = u[0], t2.value = u[1];
      } else {
        for (var l2 = [t2.xAxis != null ? t2.xAxis : t2.radiusAxis, t2.yAxis != null ? t2.yAxis : t2.angleAxis], c2 = 0; c2 < 2; c2++)
          oR[l2[c2]] && (l2[c2] = ON(e2, e2.mapDimension(a[c2]), l2[c2]));
        t2.coord = l2;
      }
    }
    return t2;
  }
  function jZ(r2, t2, e2, n2) {
    var a = {};
    return r2.valueIndex != null || r2.valueDim != null ? (a.valueDataDim = r2.valueIndex != null ? t2.getDimension(r2.valueIndex) : r2.valueDim, a.valueAxis = e2.getAxis(nCe(n2, a.valueDataDim)), a.baseAxis = e2.getOtherAxis(a.valueAxis), a.baseDataDim = t2.mapDimension(a.baseAxis.dim)) : (a.baseAxis = n2.getBaseAxis(), a.valueAxis = e2.getOtherAxis(a.baseAxis), a.baseDataDim = t2.mapDimension(a.baseAxis.dim), a.valueDataDim = t2.mapDimension(a.valueAxis.dim)), a;
  }
  function nCe(r2, t2) {
    var e2 = r2.getData().getDimensionInfo(t2);
    return e2 && e2.coordDim;
  }
  function CE(r2, t2) {
    return r2 && r2.containData && t2.coord && !tCe(t2) ? r2.containData(t2.coord) : true;
  }
  function BZ(r2, t2) {
    return r2 ? function(e2, n2, a, i) {
      var o = i < 2 ? e2.coord && e2.coord[i] : e2.value;
      return dy(o, t2[i]);
    } : function(e2, n2, a, i) {
      return dy(e2.value, t2[i]);
    };
  }
  function ON(r2, t2, e2) {
    if (e2 === "average") {
      var n2 = 0, a = 0;
      return r2.each(t2, function(i, o) {
        isNaN(i) || (n2 += i, a++);
      }), n2 / a;
    } else
      return e2 === "median" ? r2.getMedian(t2) : r2.getDataExtent(t2)[e2 === "max" ? 1 : 0];
  }
  var sR = fi(), aCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.init = function() {
      this.markerGroupMap = mn();
    }, t2.prototype.render = function(e2, n2, a) {
      var i = this, o = this.markerGroupMap;
      o.each(function(s) {
        sR(s).keep = false;
      }), n2.eachSeries(function(s) {
        var u = Cy.getMarkerModelFromSeries(s, i.type);
        u && i.renderSeries(s, u, n2, a);
      }), o.each(function(s) {
        !sR(s).keep && i.group.remove(s.group);
      });
    }, t2.prototype.markKeep = function(e2) {
      sR(e2).keep = true;
    }, t2.prototype.blurSeries = function(e2) {
      var n2 = this;
      ae(e2, function(a) {
        var i = Cy.getMarkerModelFromSeries(a, n2.type);
        if (i) {
          var o = i.getData();
          o.eachItemGraphicEl(function(s) {
            s && vU(s);
          });
        }
      });
    }, t2.type = "marker", t2;
  }(gs), kN = aCe;
  function k$(r2, t2, e2) {
    var n2 = t2.coordinateSystem;
    r2.each(function(a) {
      var i = r2.getItemModel(a), o, s = qr(i.get("x"), e2.getWidth()), u = qr(i.get("y"), e2.getHeight());
      if (!isNaN(s) && !isNaN(u))
        o = [s, u];
      else if (t2.getMarkerPosition)
        o = t2.getMarkerPosition(r2.getValues(r2.dimensions, a));
      else if (n2) {
        var l2 = r2.get(n2.dimensions[0], a), c2 = r2.get(n2.dimensions[1], a);
        o = n2.dataToPoint([l2, c2]);
      }
      isNaN(s) || (o[0] = s), isNaN(u) || (o[1] = u), r2.setItemLayout(a, o);
    });
  }
  var iCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.updateTransform = function(e2, n2, a) {
      n2.eachSeries(function(i) {
        var o = Cy.getMarkerModelFromSeries(i, "markPoint");
        o && (k$(o.getData(), i, a), this.markerGroupMap.get(i.id).updateLayout());
      }, this);
    }, t2.prototype.renderSeries = function(e2, n2, a, i) {
      var o = e2.coordinateSystem, s = e2.id, u = e2.getData(), l2 = this.markerGroupMap, c2 = l2.get(s) || l2.set(s, new GE()), f2 = oCe(o, e2, n2);
      n2.setData(f2), k$(n2.getData(), e2, i), f2.each(function(h) {
        var v9 = f2.getItemModel(h), d2 = v9.getShallow("symbol"), m2 = v9.getShallow("symbolSize"), b2 = v9.getShallow("symbolRotate"), _ = v9.getShallow("symbolOffset"), C = v9.getShallow("symbolKeepAspect");
        if (xn(d2) || xn(m2) || xn(b2) || xn(_)) {
          var M = n2.getRawValue(h), E = n2.getDataParams(h);
          xn(d2) && (d2 = d2(M, E)), xn(m2) && (m2 = m2(M, E)), xn(b2) && (b2 = b2(M, E)), xn(_) && (_ = _(M, E));
        }
        var z9 = v9.getModel("itemStyle").getItemStyle(), V = NE(u, "color");
        z9.fill || (z9.fill = V), f2.setItemVisual(h, { symbol: d2, symbolSize: m2, symbolRotate: b2, symbolOffset: _, symbolKeepAspect: C, style: z9 });
      }), c2.updateData(f2), this.group.add(c2.group), f2.eachItemGraphicEl(function(h) {
        h.traverse(function(v9) {
          zn(v9).dataModel = n2;
        });
      }), this.markKeep(c2), c2.group.silent = n2.get("silent") || e2.get("silent");
    }, t2.type = "markPoint", t2;
  }(kN);
  function oCe(r2, t2, e2) {
    var n2;
    r2 ? n2 = pr(r2 && r2.dimensions, function(s) {
      var u = t2.getData().getDimensionInfo(t2.getData().mapDimension(s)) || {};
      return qt(qt({}, u), { name: s, ordinalMeta: null });
    }) : n2 = [{ name: "value", type: "float" }];
    var a = new Rc(n2, e2), i = pr(e2.get("data"), Gn(SE, t2));
    r2 && (i = no(i, Gn(CE, r2)));
    var o = BZ(!!r2, n2);
    return a.initData(i, null, o), a;
  }
  var sCe = iCe;
  function uCe(r2) {
    r2.registerComponentModel(eCe), r2.registerComponentView(sCe), r2.registerPreprocessor(function(t2) {
      LN(t2.series, "markPoint") && (t2.markPoint = t2.markPoint || {});
    });
  }
  var lCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.createMarkerModelFromSeries = function(e2, n2, a) {
      return new t2(e2, n2, a);
    }, t2.type = "markLine", t2.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, t2;
  }(Cy), cCe = lCe, h5 = fi(), fCe = function(r2, t2, e2, n2) {
    var a = r2.getData(), i;
    if (vr(n2))
      i = n2;
    else {
      var o = n2.type;
      if (o === "min" || o === "max" || o === "average" || o === "median" || n2.xAxis != null || n2.yAxis != null) {
        var s = void 0, u = void 0;
        if (n2.yAxis != null || n2.xAxis != null)
          s = t2.getAxis(n2.yAxis != null ? "y" : "x"), u = ml(n2.yAxis, n2.xAxis);
        else {
          var l2 = jZ(n2, a, t2, r2);
          s = l2.valueAxis;
          var c2 = Tq(a, l2.valueDataDim);
          u = ON(a, c2, o);
        }
        var f2 = s.dim === "x" ? 0 : 1, h = 1 - f2, v9 = On(n2), d2 = { coord: [] };
        v9.type = null, v9.coord = [], v9.coord[h] = -1 / 0, d2.coord[h] = 1 / 0;
        var m2 = e2.get("precision");
        m2 >= 0 && Ai(u) && (u = +u.toFixed(Math.min(m2, 20))), v9.coord[f2] = d2.coord[f2] = u, i = [v9, d2, { type: o, valueIndex: n2.valueIndex, value: u }];
      } else
        i = [];
    }
    var b2 = [SE(r2, i[0]), SE(r2, i[1]), qt({}, i[2])];
    return b2[2].type = b2[2].type || null, ea(b2[2], b2[0]), ea(b2[2], b2[1]), b2;
  };
  function IP(r2) {
    return !isNaN(r2) && !isFinite(r2);
  }
  function R$(r2, t2, e2, n2) {
    var a = 1 - r2, i = n2.dimensions[r2];
    return IP(t2[a]) && IP(e2[a]) && t2[r2] === e2[r2] && n2.getAxis(i).containData(t2[r2]);
  }
  function hCe(r2, t2) {
    if (r2.type === "cartesian2d") {
      var e2 = t2[0].coord, n2 = t2[1].coord;
      if (e2 && n2 && (R$(1, e2, n2, r2) || R$(0, e2, n2, r2)))
        return true;
    }
    return CE(r2, t2[0]) && CE(r2, t2[1]);
  }
  function uR(r2, t2, e2, n2, a) {
    var i = n2.coordinateSystem, o = r2.getItemModel(t2), s, u = qr(o.get("x"), a.getWidth()), l2 = qr(o.get("y"), a.getHeight());
    if (!isNaN(u) && !isNaN(l2))
      s = [u, l2];
    else {
      if (n2.getMarkerPosition)
        s = n2.getMarkerPosition(r2.getValues(r2.dimensions, t2));
      else {
        var c2 = i.dimensions, f2 = r2.get(c2[0], t2), h = r2.get(c2[1], t2);
        s = i.dataToPoint([f2, h]);
      }
      if (Cg(i, "cartesian2d")) {
        var v9 = i.getAxis("x"), d2 = i.getAxis("y"), c2 = i.dimensions;
        IP(r2.get(c2[0], t2)) ? s[0] = v9.toGlobalCoord(v9.getExtent()[e2 ? 0 : 1]) : IP(r2.get(c2[1], t2)) && (s[1] = d2.toGlobalCoord(d2.getExtent()[e2 ? 0 : 1]));
      }
      isNaN(u) || (s[0] = u), isNaN(l2) || (s[1] = l2);
    }
    r2.setItemLayout(t2, s);
  }
  var vCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.updateTransform = function(e2, n2, a) {
      n2.eachSeries(function(i) {
        var o = Cy.getMarkerModelFromSeries(i, "markLine");
        if (o) {
          var s = o.getData(), u = h5(o).from, l2 = h5(o).to;
          u.each(function(c2) {
            uR(u, c2, true, i, a), uR(l2, c2, false, i, a);
          }), s.each(function(c2) {
            s.setItemLayout(c2, [u.getItemLayout(c2), l2.getItemLayout(c2)]);
          }), this.markerGroupMap.get(i.id).updateLayout();
        }
      }, this);
    }, t2.prototype.renderSeries = function(e2, n2, a, i) {
      var o = e2.coordinateSystem, s = e2.id, u = e2.getData(), l2 = this.markerGroupMap, c2 = l2.get(s) || l2.set(s, new nN());
      this.group.add(c2.group);
      var f2 = dCe(o, e2, n2), h = f2.from, v9 = f2.to, d2 = f2.line;
      h5(n2).from = h, h5(n2).to = v9, n2.setData(d2);
      var m2 = n2.get("symbol"), b2 = n2.get("symbolSize"), _ = n2.get("symbolRotate"), C = n2.get("symbolOffset");
      vr(m2) || (m2 = [m2, m2]), vr(b2) || (b2 = [b2, b2]), vr(_) || (_ = [_, _]), vr(C) || (C = [C, C]), f2.from.each(function(E) {
        M(h, E, true), M(v9, E, false);
      }), d2.each(function(E) {
        var z9 = d2.getItemModel(E).getModel("lineStyle").getLineStyle();
        d2.setItemLayout(E, [h.getItemLayout(E), v9.getItemLayout(E)]), z9.stroke == null && (z9.stroke = h.getItemVisual(E, "style").fill), d2.setItemVisual(E, { fromSymbolKeepAspect: h.getItemVisual(E, "symbolKeepAspect"), fromSymbolOffset: h.getItemVisual(E, "symbolOffset"), fromSymbolRotate: h.getItemVisual(E, "symbolRotate"), fromSymbolSize: h.getItemVisual(E, "symbolSize"), fromSymbol: h.getItemVisual(E, "symbol"), toSymbolKeepAspect: v9.getItemVisual(E, "symbolKeepAspect"), toSymbolOffset: v9.getItemVisual(E, "symbolOffset"), toSymbolRotate: v9.getItemVisual(E, "symbolRotate"), toSymbolSize: v9.getItemVisual(E, "symbolSize"), toSymbol: v9.getItemVisual(E, "symbol"), style: z9 });
      }), c2.updateData(d2), f2.line.eachItemGraphicEl(function(E, z9) {
        E.traverse(function(V) {
          zn(V).dataModel = n2;
        });
      });
      function M(E, z9, V) {
        var $ = E.getItemModel(z9);
        uR(E, z9, V, e2, i);
        var U = $.getModel("itemStyle").getItemStyle();
        U.fill == null && (U.fill = NE(u, "color")), E.setItemVisual(z9, { symbolKeepAspect: $.get("symbolKeepAspect"), symbolOffset: ia($.get("symbolOffset", true), C[V ? 0 : 1]), symbolRotate: ia($.get("symbolRotate", true), _[V ? 0 : 1]), symbolSize: ia($.get("symbolSize"), b2[V ? 0 : 1]), symbol: ia($.get("symbol", true), m2[V ? 0 : 1]), style: U });
      }
      this.markKeep(c2), c2.group.silent = n2.get("silent") || e2.get("silent");
    }, t2.type = "markLine", t2;
  }(kN);
  function dCe(r2, t2, e2) {
    var n2;
    r2 ? n2 = pr(r2 && r2.dimensions, function(l2) {
      var c2 = t2.getData().getDimensionInfo(t2.getData().mapDimension(l2)) || {};
      return qt(qt({}, c2), { name: l2, ordinalMeta: null });
    }) : n2 = [{ name: "value", type: "float" }];
    var a = new Rc(n2, e2), i = new Rc(n2, e2), o = new Rc([], e2), s = pr(e2.get("data"), Gn(fCe, t2, r2, e2));
    r2 && (s = no(s, Gn(hCe, r2)));
    var u = BZ(!!r2, n2);
    return a.initData(pr(s, function(l2) {
      return l2[0];
    }), null, u), i.initData(pr(s, function(l2) {
      return l2[1];
    }), null, u), o.initData(pr(s, function(l2) {
      return l2[2];
    })), o.hasItemOption = true, { from: a, to: i, line: o };
  }
  var pCe = vCe;
  function gCe(r2) {
    r2.registerComponentModel(cCe), r2.registerComponentView(pCe), r2.registerPreprocessor(function(t2) {
      LN(t2.series, "markLine") && (t2.markLine = t2.markLine || {});
    });
  }
  var yCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.createMarkerModelFromSeries = function(e2, n2, a) {
      return new t2(e2, n2, a);
    }, t2.type = "markArea", t2.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, t2;
  }(Cy), mCe = yCe, v5 = fi(), bCe = function(r2, t2, e2, n2) {
    var a = SE(r2, n2[0]), i = SE(r2, n2[1]), o = a.coord, s = i.coord;
    o[0] = ml(o[0], -1 / 0), o[1] = ml(o[1], -1 / 0), s[0] = ml(s[0], 1 / 0), s[1] = ml(s[1], 1 / 0);
    var u = N6([{}, a, i]);
    return u.coord = [a.coord, i.coord], u.x0 = a.x, u.y0 = a.y, u.x1 = i.x, u.y1 = i.y, u;
  };
  function LP(r2) {
    return !isNaN(r2) && !isFinite(r2);
  }
  function F$(r2, t2, e2, n2) {
    var a = 1 - r2;
    return LP(t2[a]) && LP(e2[a]);
  }
  function _Ce(r2, t2) {
    var e2 = t2.coord[0], n2 = t2.coord[1];
    return Cg(r2, "cartesian2d") && e2 && n2 && (F$(1, e2, n2) || F$(0, e2, n2)) ? true : CE(r2, { coord: e2, x: t2.x0, y: t2.y0 }) || CE(r2, { coord: n2, x: t2.x1, y: t2.y1 });
  }
  function N$(r2, t2, e2, n2, a) {
    var i = n2.coordinateSystem, o = r2.getItemModel(t2), s, u = qr(o.get(e2[0]), a.getWidth()), l2 = qr(o.get(e2[1]), a.getHeight());
    if (!isNaN(u) && !isNaN(l2))
      s = [u, l2];
    else {
      if (n2.getMarkerPosition)
        s = n2.getMarkerPosition(r2.getValues(e2, t2));
      else {
        var c2 = r2.get(e2[0], t2), f2 = r2.get(e2[1], t2), h = [c2, f2];
        i.clampData && i.clampData(h, h), s = i.dataToPoint(h, true);
      }
      if (Cg(i, "cartesian2d")) {
        var v9 = i.getAxis("x"), d2 = i.getAxis("y"), c2 = r2.get(e2[0], t2), f2 = r2.get(e2[1], t2);
        LP(c2) ? s[0] = v9.toGlobalCoord(v9.getExtent()[e2[0] === "x0" ? 0 : 1]) : LP(f2) && (s[1] = d2.toGlobalCoord(d2.getExtent()[e2[1] === "y0" ? 0 : 1]));
      }
      isNaN(u) || (s[0] = u), isNaN(l2) || (s[1] = l2);
    }
    return s;
  }
  var V$ = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], xCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.updateTransform = function(e2, n2, a) {
      n2.eachSeries(function(i) {
        var o = Cy.getMarkerModelFromSeries(i, "markArea");
        if (o) {
          var s = o.getData();
          s.each(function(u) {
            var l2 = pr(V$, function(f2) {
              return N$(s, u, f2, i, a);
            });
            s.setItemLayout(u, l2);
            var c2 = s.getItemGraphicEl(u);
            c2.setShape("points", l2);
          });
        }
      }, this);
    }, t2.prototype.renderSeries = function(e2, n2, a, i) {
      var o = e2.coordinateSystem, s = e2.id, u = e2.getData(), l2 = this.markerGroupMap, c2 = l2.get(s) || l2.set(s, { group: new Fn() });
      this.group.add(c2.group), this.markKeep(c2);
      var f2 = wCe(o, e2, n2);
      n2.setData(f2), f2.each(function(h) {
        var v9 = pr(V$, function(U) {
          return N$(f2, h, U, e2, i);
        }), d2 = o.getAxis("x").scale, m2 = o.getAxis("y").scale, b2 = d2.getExtent(), _ = m2.getExtent(), C = [d2.parse(f2.get("x0", h)), d2.parse(f2.get("x1", h))], M = [m2.parse(f2.get("y0", h)), m2.parse(f2.get("y1", h))];
        $h(C), $h(M);
        var E = !(b2[0] > C[1] || b2[1] < C[0] || _[0] > M[1] || _[1] < M[0]), z9 = !E;
        f2.setItemLayout(h, { points: v9, allClipped: z9 });
        var V = f2.getItemModel(h).getModel("itemStyle").getItemStyle(), $ = NE(u, "color");
        V.fill || (V.fill = $, Zr(V.fill) && (V.fill = H5(V.fill, 0.4))), V.stroke || (V.stroke = $), f2.setItemVisual(h, "style", V);
      }), f2.diff(v5(c2).data).add(function(h) {
        var v9 = f2.getItemLayout(h);
        if (!v9.allClipped) {
          var d2 = new gf({ shape: { points: v9.points } });
          f2.setItemGraphicEl(h, d2), c2.group.add(d2);
        }
      }).update(function(h, v9) {
        var d2 = v5(c2).data.getItemGraphicEl(v9), m2 = f2.getItemLayout(h);
        m2.allClipped ? d2 && c2.group.remove(d2) : (d2 ? ci(d2, { shape: { points: m2.points } }, n2, h) : d2 = new gf({ shape: { points: m2.points } }), f2.setItemGraphicEl(h, d2), c2.group.add(d2));
      }).remove(function(h) {
        var v9 = v5(c2).data.getItemGraphicEl(h);
        c2.group.remove(v9);
      }).execute(), f2.eachItemGraphicEl(function(h, v9) {
        var d2 = f2.getItemModel(v9), m2 = f2.getItemVisual(v9, "style");
        h.useStyle(f2.getItemVisual(v9, "style")), fc(h, _l(d2), { labelFetcher: n2, labelDataIndex: v9, defaultText: f2.getName(v9) || "", inheritColor: Zr(m2.fill) ? H5(m2.fill, 1) : "#000" }), jl(h, d2), ks(h, null, null, d2.get(["emphasis", "disabled"])), zn(h).dataModel = n2;
      }), v5(c2).data = f2, c2.group.silent = n2.get("silent") || e2.get("silent");
    }, t2.type = "markArea", t2;
  }(kN);
  function wCe(r2, t2, e2) {
    var n2, a, i = ["x0", "y0", "x1", "y1"];
    if (r2) {
      var o = pr(r2 && r2.dimensions, function(l2) {
        var c2 = t2.getData(), f2 = c2.getDimensionInfo(c2.mapDimension(l2)) || {};
        return qt(qt({}, f2), { name: l2, ordinalMeta: null });
      });
      a = pr(i, function(l2, c2) {
        return { name: l2, type: o[c2 % 2].type };
      }), n2 = new Rc(a, e2);
    } else
      a = [{ name: "value", type: "float" }], n2 = new Rc(a, e2);
    var s = pr(e2.get("data"), Gn(bCe, t2, r2, e2));
    r2 && (s = no(s, Gn(_Ce, r2)));
    var u = r2 ? function(l2, c2, f2, h) {
      var v9 = l2.coord[Math.floor(h / 2)][h % 2];
      return dy(v9, a[h]);
    } : function(l2, c2, f2, h) {
      return dy(l2.value, a[h]);
    };
    return n2.initData(s, null, u), n2.hasItemOption = true, n2;
  }
  var SCe = xCe;
  function CCe(r2) {
    r2.registerComponentModel(mCe), r2.registerComponentView(SCe), r2.registerPreprocessor(function(t2) {
      LN(t2.series, "markArea") && (t2.markArea = t2.markArea || {});
    });
  }
  var ECe = function(r2, t2) {
    if (t2 === "all")
      return { type: "all", title: r2.getLocaleModel().get(["legend", "selector", "all"]) };
    if (t2 === "inverse")
      return { type: "inverse", title: r2.getLocaleModel().get(["legend", "selector", "inverse"]) };
  }, ACe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.mergeDefaultAndTheme(e2, a), e2.selected = e2.selected || {}, this._updateSelector(e2);
    }, t2.prototype.mergeOption = function(e2, n2) {
      r2.prototype.mergeOption.call(this, e2, n2), this._updateSelector(e2);
    }, t2.prototype._updateSelector = function(e2) {
      var n2 = e2.selector, a = this.ecModel;
      n2 === true && (n2 = e2.selector = ["all", "inverse"]), vr(n2) && ae(n2, function(i, o) {
        Zr(i) && (i = { type: i }), n2[o] = ea(i, ECe(a, i.type));
      });
    }, t2.prototype.optionUpdated = function() {
      this._updateData(this.ecModel);
      var e2 = this._data;
      if (e2[0] && this.get("selectedMode") === "single") {
        for (var n2 = false, a = 0; a < e2.length; a++) {
          var i = e2[a].get("name");
          if (this.isSelected(i)) {
            this.select(i), n2 = true;
            break;
          }
        }
        !n2 && this.select(e2[0].get("name"));
      }
    }, t2.prototype._updateData = function(e2) {
      var n2 = [], a = [];
      e2.eachRawSeries(function(s) {
        var u = s.name;
        a.push(u);
        var l2;
        if (s.legendVisualProvider) {
          var c2 = s.legendVisualProvider, f2 = c2.getAllNames();
          e2.isSeriesFiltered(s) || (a = a.concat(f2)), f2.length ? n2 = n2.concat(f2) : l2 = true;
        } else
          l2 = true;
        l2 && q6(s) && n2.push(s.name);
      }), this._availableNames = a;
      var i = this.get("data") || n2, o = pr(i, function(s) {
        return (Zr(s) || Ai(s)) && (s = { name: s }), new To(s, this, this.ecModel);
      }, this);
      this._data = o;
    }, t2.prototype.getData = function() {
      return this._data;
    }, t2.prototype.select = function(e2) {
      var n2 = this.option.selected, a = this.get("selectedMode");
      if (a === "single") {
        var i = this._data;
        ae(i, function(o) {
          n2[o.get("name")] = false;
        });
      }
      n2[e2] = true;
    }, t2.prototype.unSelect = function(e2) {
      this.get("selectedMode") !== "single" && (this.option.selected[e2] = false);
    }, t2.prototype.toggleSelected = function(e2) {
      var n2 = this.option.selected;
      n2.hasOwnProperty(e2) || (n2[e2] = true), this[n2[e2] ? "unSelect" : "select"](e2);
    }, t2.prototype.allSelect = function() {
      var e2 = this._data, n2 = this.option.selected;
      ae(e2, function(a) {
        n2[a.get("name", true)] = true;
      });
    }, t2.prototype.inverseSelect = function() {
      var e2 = this._data, n2 = this.option.selected;
      ae(e2, function(a) {
        var i = a.get("name", true);
        n2.hasOwnProperty(i) || (n2[i] = true), n2[i] = !n2[i];
      });
    }, t2.prototype.isSelected = function(e2) {
      var n2 = this.option.selected;
      return !(n2.hasOwnProperty(e2) && !n2[e2]) && va(this._availableNames, e2) >= 0;
    }, t2.prototype.getOrient = function() {
      return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
    }, t2.type = "legend.plain", t2.dependencies = ["series"], t2.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, t2;
  }(li), u6 = ACe, Px = Gn, l6 = ae, d5 = Fn, TCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.newlineDisabled = false, e2;
    }
    return t2.prototype.init = function() {
      this.group.add(this._contentGroup = new d5()), this.group.add(this._selectorGroup = new d5()), this._isFirstRender = true;
    }, t2.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, t2.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, t2.prototype.render = function(e2, n2, a) {
      var i = this._isFirstRender;
      if (this._isFirstRender = false, this.resetInner(), !!e2.get("show", true)) {
        var o = e2.get("align"), s = e2.get("orient");
        (!o || o === "auto") && (o = e2.get("left") === "right" && s === "vertical" ? "right" : "left");
        var u = e2.get("selector", true), l2 = e2.get("selectorPosition", true);
        u && (!l2 || l2 === "auto") && (l2 = s === "horizontal" ? "end" : "start"), this.renderInner(o, e2, n2, a, u, s, l2);
        var c2 = e2.getBoxLayoutParams(), f2 = { width: a.getWidth(), height: a.getHeight() }, h = e2.get("padding"), v9 = Eu(c2, f2, h), d2 = this.layoutInner(e2, o, v9, i, u, l2), m2 = Eu(En({ width: d2.width, height: d2.height }, c2), f2, h);
        this.group.x = m2.x - d2.x, this.group.y = m2.y - d2.y, this.group.markRedraw(), this.group.add(this._backgroundEl = MZ(d2, e2));
      }
    }, t2.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, t2.prototype.renderInner = function(e2, n2, a, i, o, s, u) {
      var l2 = this.getContentGroup(), c2 = mn(), f2 = n2.get("selectedMode"), h = [];
      a.eachRawSeries(function(v9) {
        !v9.get("legendHoverLink") && h.push(v9.id);
      }), l6(n2.getData(), function(v9, d2) {
        var m2 = v9.get("name");
        if (!this.newlineDisabled && (m2 === "" || m2 === `
`)) {
          var b2 = new d5();
          b2.newline = true, l2.add(b2);
          return;
        }
        var _ = a.getSeriesByName(m2)[0];
        if (!c2.get(m2))
          if (_) {
            var C = _.getData(), M = C.getVisual("legendLineStyle") || {}, E = C.getVisual("legendIcon"), z9 = C.getVisual("style"), V = this._createItem(_, m2, d2, v9, n2, e2, M, z9, E, f2);
            V.on("click", Px(j$, m2, null, i, h)).on("mouseover", Px(c6, _.name, null, i, h)).on("mouseout", Px(f6, _.name, null, i, h)), c2.set(m2, true);
          } else
            a.eachRawSeries(function($) {
              if (!c2.get(m2) && $.legendVisualProvider) {
                var U = $.legendVisualProvider;
                if (!U.containName(m2))
                  return;
                var H = U.indexOfName(m2), q3 = U.getItemVisual(H, "style"), ee = U.getItemVisual(H, "legendIcon"), oe = Xf(q3.fill);
                oe && oe[3] === 0 && (oe[3] = 0.2, q3 = qt(qt({}, q3), { fill: wg(oe, "rgba") }));
                var ne = this._createItem($, m2, d2, v9, n2, e2, {}, q3, ee, f2);
                ne.on("click", Px(j$, null, m2, i, h)).on("mouseover", Px(c6, null, m2, i, h)).on("mouseout", Px(f6, null, m2, i, h)), c2.set(m2, true);
              }
            }, this);
      }, this), o && this._createSelector(o, n2, i, s, u);
    }, t2.prototype._createSelector = function(e2, n2, a, i, o) {
      var s = this.getSelectorGroup();
      l6(e2, function(l2) {
        var c2 = l2.type, f2 = new xi({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
          a.dispatchAction({ type: c2 === "all" ? "legendAllSelect" : "legendInverseSelect" });
        } });
        s.add(f2);
        var h = n2.getModel("selectorLabel"), v9 = n2.getModel(["emphasis", "selectorLabel"]);
        fc(f2, { normal: h, emphasis: v9 }, { defaultText: l2.title }), qb(f2);
      });
    }, t2.prototype._createItem = function(e2, n2, a, i, o, s, u, l2, c2, f2) {
      var h = e2.visualDrawType, v9 = o.get("itemWidth"), d2 = o.get("itemHeight"), m2 = o.isSelected(n2), b2 = i.get("symbolRotate"), _ = i.get("symbolKeepAspect"), C = i.get("icon");
      c2 = C || c2 || "roundRect";
      var M = MCe(c2, i, u, l2, h, m2), E = new d5(), z9 = i.getModel("textStyle");
      if (xn(e2.getLegendIcon) && (!C || C === "inherit"))
        E.add(e2.getLegendIcon({ itemWidth: v9, itemHeight: d2, icon: c2, iconRotate: b2, itemStyle: M.itemStyle, lineStyle: M.lineStyle, symbolKeepAspect: _ }));
      else {
        var V = C === "inherit" && e2.getData().getVisual("symbol") ? b2 === "inherit" ? e2.getData().getVisual("symbolRotate") : b2 : 0;
        E.add(PCe({ itemWidth: v9, itemHeight: d2, icon: c2, iconRotate: V, itemStyle: M.itemStyle, lineStyle: M.lineStyle, symbolKeepAspect: _ }));
      }
      var $ = s === "left" ? v9 + 5 : -5, U = s, H = o.get("formatter"), q3 = n2;
      Zr(H) && H ? q3 = H.replace("{name}", n2 != null ? n2 : "") : xn(H) && (q3 = H(n2));
      var ee = i.get("inactiveColor");
      E.add(new xi({ style: Hs(z9, { text: q3, x: $, y: d2 / 2, fill: m2 ? z9.getTextColor() : ee, align: U, verticalAlign: "middle" }) }));
      var oe = new ni({ shape: E.getBoundingRect(), invisible: true }), ne = i.getModel("tooltip");
      return ne.get("show") && pw({ el: oe, componentModel: o, itemName: n2, itemTooltipOption: ne.option }), E.add(oe), E.eachChild(function(be) {
        be.silent = true;
      }), oe.silent = !f2, this.getContentGroup().add(E), qb(E), E.__legendDataIndex = a, E;
    }, t2.prototype.layoutInner = function(e2, n2, a, i, o, s) {
      var u = this.getContentGroup(), l2 = this.getSelectorGroup();
      Kb(e2.get("orient"), u, e2.get("itemGap"), a.width, a.height);
      var c2 = u.getBoundingRect(), f2 = [-c2.x, -c2.y];
      if (l2.markRedraw(), u.markRedraw(), o) {
        Kb("horizontal", l2, e2.get("selectorItemGap", true));
        var h = l2.getBoundingRect(), v9 = [-h.x, -h.y], d2 = e2.get("selectorButtonGap", true), m2 = e2.getOrient().index, b2 = m2 === 0 ? "width" : "height", _ = m2 === 0 ? "height" : "width", C = m2 === 0 ? "y" : "x";
        s === "end" ? v9[m2] += c2[b2] + d2 : f2[m2] += h[b2] + d2, v9[1 - m2] += c2[_] / 2 - h[_] / 2, l2.x = v9[0], l2.y = v9[1], u.x = f2[0], u.y = f2[1];
        var M = { x: 0, y: 0 };
        return M[b2] = c2[b2] + d2 + h[b2], M[_] = Math.max(c2[_], h[_]), M[C] = Math.min(0, h[C] + v9[1 - m2]), M;
      } else
        return u.x = f2[0], u.y = f2[1], this.group.getBoundingRect();
    }, t2.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = true;
    }, t2.type = "legend.plain", t2;
  }(gs);
  function MCe(r2, t2, e2, n2, a, i) {
    function o(d2, m2) {
      d2.lineWidth === "auto" && (d2.lineWidth = m2.lineWidth > 0 ? 2 : 0), l6(d2, function(b2, _) {
        d2[_] === "inherit" && (d2[_] = m2[_]);
      });
    }
    var s = t2.getModel("itemStyle"), u = s.getItemStyle(), l2 = r2.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
    u.decal = n2.decal, u.fill === "inherit" && (u.fill = n2[a]), u.stroke === "inherit" && (u.stroke = n2[l2]), u.opacity === "inherit" && (u.opacity = (a === "fill" ? n2 : e2).opacity), o(u, n2);
    var c2 = t2.getModel("lineStyle"), f2 = c2.getLineStyle();
    if (o(f2, e2), u.fill === "auto" && (u.fill = n2.fill), u.stroke === "auto" && (u.stroke = n2.fill), f2.stroke === "auto" && (f2.stroke = n2.fill), !i) {
      var h = t2.get("inactiveBorderWidth"), v9 = u[l2];
      u.lineWidth = h === "auto" ? n2.lineWidth > 0 && v9 ? 2 : 0 : u.lineWidth, u.fill = t2.get("inactiveColor"), u.stroke = t2.get("inactiveBorderColor"), f2.stroke = c2.get("inactiveColor"), f2.lineWidth = c2.get("inactiveWidth");
    }
    return { itemStyle: u, lineStyle: f2 };
  }
  function PCe(r2) {
    var t2 = r2.icon || "roundRect", e2 = cu(t2, 0, 0, r2.itemWidth, r2.itemHeight, r2.itemStyle.fill, r2.symbolKeepAspect);
    return e2.setStyle(r2.itemStyle), e2.rotation = (r2.iconRotate || 0) * Math.PI / 180, e2.setOrigin([r2.itemWidth / 2, r2.itemHeight / 2]), t2.indexOf("empty") > -1 && (e2.style.stroke = e2.style.fill, e2.style.fill = "#fff", e2.style.lineWidth = 2), e2;
  }
  function j$(r2, t2, e2, n2) {
    f6(r2, t2, e2, n2), e2.dispatchAction({ type: "legendToggleSelect", name: r2 != null ? r2 : t2 }), c6(r2, t2, e2, n2);
  }
  function zZ(r2) {
    for (var t2 = r2.getZr().storage.getDisplayList(), e2, n2 = 0, a = t2.length; n2 < a && !(e2 = t2[n2].states.emphasis); )
      n2++;
    return e2 && e2.hoverLayer;
  }
  function c6(r2, t2, e2, n2) {
    zZ(e2) || e2.dispatchAction({ type: "highlight", seriesName: r2, name: t2, excludeSeriesId: n2 });
  }
  function f6(r2, t2, e2, n2) {
    zZ(e2) || e2.dispatchAction({ type: "downplay", seriesName: r2, name: t2, excludeSeriesId: n2 });
  }
  var $Z = TCe;
  function DCe(r2) {
    var t2 = r2.findComponents({ mainType: "legend" });
    t2 && t2.length && r2.filterSeries(function(e2) {
      for (var n2 = 0; n2 < t2.length; n2++)
        if (!t2[n2].isSelected(e2.name))
          return false;
      return true;
    });
  }
  function hC(r2, t2, e2) {
    var n2 = {}, a = r2 === "toggleSelected", i;
    return e2.eachComponent("legend", function(o) {
      a && i != null ? o[i ? "select" : "unSelect"](t2.name) : r2 === "allSelect" || r2 === "inverseSelect" ? o[r2]() : (o[r2](t2.name), i = o.isSelected(t2.name));
      var s = o.getData();
      ae(s, function(u) {
        var l2 = u.get("name");
        if (!(l2 === `
` || l2 === "")) {
          var c2 = o.isSelected(l2);
          n2.hasOwnProperty(l2) ? n2[l2] = n2[l2] && c2 : n2[l2] = c2;
        }
      });
    }), r2 === "allSelect" || r2 === "inverseSelect" ? { selected: n2 } : { name: t2.name, selected: n2 };
  }
  function ICe(r2) {
    r2.registerAction("legendToggleSelect", "legendselectchanged", Gn(hC, "toggleSelected")), r2.registerAction("legendAllSelect", "legendselectall", Gn(hC, "allSelect")), r2.registerAction("legendInverseSelect", "legendinverseselect", Gn(hC, "inverseSelect")), r2.registerAction("legendSelect", "legendselected", Gn(hC, "select")), r2.registerAction("legendUnSelect", "legendunselected", Gn(hC, "unSelect"));
  }
  function GZ(r2) {
    r2.registerComponentModel(u6), r2.registerComponentView($Z), r2.registerProcessor(r2.PRIORITY.PROCESSOR.SERIES_FILTER, DCe), r2.registerSubTypeDefaulter("legend", function() {
      return "plain";
    }), ICe(r2);
  }
  var LCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.setScrollDataIndex = function(e2) {
      this.option.scrollDataIndex = e2;
    }, t2.prototype.init = function(e2, n2, a) {
      var i = bw(e2);
      r2.prototype.init.call(this, e2, n2, a), B$(this, e2, i);
    }, t2.prototype.mergeOption = function(e2, n2) {
      r2.prototype.mergeOption.call(this, e2, n2), B$(this, this.option, e2);
    }, t2.type = "legend.scroll", t2.defaultOption = Ty(u6.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), t2;
  }(u6);
  function B$(r2, t2, e2) {
    var n2 = r2.getOrient(), a = [1, 1];
    a[n2.index] = 0, by(t2, e2, { type: "box", ignoreSize: !!a });
  }
  var OCe = LCe, z$ = Fn, lR = ["width", "height"], cR = ["x", "y"], kCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.newlineDisabled = true, e2._currentIndex = 0, e2;
    }
    return t2.prototype.init = function() {
      r2.prototype.init.call(this), this.group.add(this._containerGroup = new z$()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new z$());
    }, t2.prototype.resetInner = function() {
      r2.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
    }, t2.prototype.renderInner = function(e2, n2, a, i, o, s, u) {
      var l2 = this;
      r2.prototype.renderInner.call(this, e2, n2, a, i, o, s, u);
      var c2 = this._controllerGroup, f2 = n2.get("pageIconSize", true), h = vr(f2) ? f2 : [f2, f2];
      d2("pagePrev", 0);
      var v9 = n2.getModel("pageTextStyle");
      c2.add(new xi({ name: "pageText", style: { text: "xx/xx", fill: v9.getTextColor(), font: v9.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), d2("pageNext", 1);
      function d2(m2, b2) {
        var _ = m2 + "DataIndex", C = kE(n2.get("pageIcons", true)[n2.getOrient().name][b2], { onclick: en(l2._pageGo, l2, _, n2, i) }, { x: -h[0] / 2, y: -h[1] / 2, width: h[0], height: h[1] });
        C.name = m2, c2.add(C);
      }
    }, t2.prototype.layoutInner = function(e2, n2, a, i, o, s) {
      var u = this.getSelectorGroup(), l2 = e2.getOrient().index, c2 = lR[l2], f2 = cR[l2], h = lR[1 - l2], v9 = cR[1 - l2];
      o && Kb("horizontal", u, e2.get("selectorItemGap", true));
      var d2 = e2.get("selectorButtonGap", true), m2 = u.getBoundingRect(), b2 = [-m2.x, -m2.y], _ = On(a);
      o && (_[c2] = a[c2] - m2[c2] - d2);
      var C = this._layoutContentAndController(e2, i, _, l2, c2, h, v9, f2);
      if (o) {
        if (s === "end")
          b2[l2] += C[c2] + d2;
        else {
          var M = m2[c2] + d2;
          b2[l2] -= M, C[f2] -= M;
        }
        C[c2] += m2[c2] + d2, b2[1 - l2] += C[v9] + C[h] / 2 - m2[h] / 2, C[h] = Math.max(C[h], m2[h]), C[v9] = Math.min(C[v9], m2[v9] + b2[1 - l2]), u.x = b2[0], u.y = b2[1], u.markRedraw();
      }
      return C;
    }, t2.prototype._layoutContentAndController = function(e2, n2, a, i, o, s, u, l2) {
      var c2 = this.getContentGroup(), f2 = this._containerGroup, h = this._controllerGroup;
      Kb(e2.get("orient"), c2, e2.get("itemGap"), i ? a.width : null, i ? null : a.height), Kb("horizontal", h, e2.get("pageButtonItemGap", true));
      var v9 = c2.getBoundingRect(), d2 = h.getBoundingRect(), m2 = this._showController = v9[o] > a[o], b2 = [-v9.x, -v9.y];
      n2 || (b2[i] = c2[l2]);
      var _ = [0, 0], C = [-d2.x, -d2.y], M = ia(e2.get("pageButtonGap", true), e2.get("itemGap", true));
      if (m2) {
        var E = e2.get("pageButtonPosition", true);
        E === "end" ? C[i] += a[o] - d2[o] : _[i] += d2[o] + M;
      }
      C[1 - i] += v9[s] / 2 - d2[s] / 2, c2.setPosition(b2), f2.setPosition(_), h.setPosition(C);
      var z9 = { x: 0, y: 0 };
      if (z9[o] = m2 ? a[o] : v9[o], z9[s] = Math.max(v9[s], d2[s]), z9[u] = Math.min(0, d2[u] + C[1 - i]), f2.__rectSize = a[o], m2) {
        var V = { x: 0, y: 0 };
        V[o] = Math.max(a[o] - d2[o] - M, 0), V[s] = z9[s], f2.setClipPath(new ni({ shape: V })), f2.__rectSize = V[o];
      } else
        h.eachChild(function(U) {
          U.attr({ invisible: true, silent: true });
        });
      var $ = this._getPageInfo(e2);
      return $.pageIndex != null && ci(c2, { x: $.contentPosition[0], y: $.contentPosition[1] }, m2 ? e2 : null), this._updatePageInfoView(e2, $), z9;
    }, t2.prototype._pageGo = function(e2, n2, a) {
      var i = this._getPageInfo(n2)[e2];
      i != null && a.dispatchAction({ type: "legendScroll", scrollDataIndex: i, legendId: n2.id });
    }, t2.prototype._updatePageInfoView = function(e2, n2) {
      var a = this._controllerGroup;
      ae(["pagePrev", "pageNext"], function(c2) {
        var f2 = c2 + "DataIndex", h = n2[f2] != null, v9 = a.childOfName(c2);
        v9 && (v9.setStyle("fill", h ? e2.get("pageIconColor", true) : e2.get("pageIconInactiveColor", true)), v9.cursor = h ? "pointer" : "default");
      });
      var i = a.childOfName("pageText"), o = e2.get("pageFormatter"), s = n2.pageIndex, u = s != null ? s + 1 : 0, l2 = n2.pageCount;
      i && o && i.setStyle("text", Zr(o) ? o.replace("{current}", u == null ? "" : u + "").replace("{total}", l2 == null ? "" : l2 + "") : o({ current: u, total: l2 }));
    }, t2.prototype._getPageInfo = function(e2) {
      var n2 = e2.get("scrollDataIndex", true), a = this.getContentGroup(), i = this._containerGroup.__rectSize, o = e2.getOrient().index, s = lR[o], u = cR[o], l2 = this._findTargetItemIndex(n2), c2 = a.children(), f2 = c2[l2], h = c2.length, v9 = h ? 1 : 0, d2 = { contentPosition: [a.x, a.y], pageCount: v9, pageIndex: v9 - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
      if (!f2)
        return d2;
      var m2 = E(f2);
      d2.contentPosition[o] = -m2.s;
      for (var b2 = l2 + 1, _ = m2, C = m2, M = null; b2 <= h; ++b2)
        M = E(c2[b2]), (!M && C.e > _.s + i || M && !z9(M, _.s)) && (C.i > _.i ? _ = C : _ = M, _ && (d2.pageNextDataIndex == null && (d2.pageNextDataIndex = _.i), ++d2.pageCount)), C = M;
      for (var b2 = l2 - 1, _ = m2, C = m2, M = null; b2 >= -1; --b2)
        M = E(c2[b2]), (!M || !z9(C, M.s)) && _.i < C.i && (C = _, d2.pagePrevDataIndex == null && (d2.pagePrevDataIndex = _.i), ++d2.pageCount, ++d2.pageIndex), _ = M;
      return d2;
      function E(V) {
        if (V) {
          var $ = V.getBoundingRect(), U = $[u] + V[u];
          return { s: U, e: U + $[s], i: V.__legendDataIndex };
        }
      }
      function z9(V, $) {
        return V.e >= $ && V.s <= $ + i;
      }
    }, t2.prototype._findTargetItemIndex = function(e2) {
      if (!this._showController)
        return 0;
      var n2, a = this.getContentGroup(), i;
      return a.eachChild(function(o, s) {
        var u = o.__legendDataIndex;
        i == null && u != null && (i = s), u === e2 && (n2 = s);
      }), n2 != null ? n2 : i;
    }, t2.type = "legend.scroll", t2;
  }($Z), RCe = kCe;
  function FCe(r2) {
    r2.registerAction("legendScroll", "legendscroll", function(t2, e2) {
      var n2 = t2.scrollDataIndex;
      n2 != null && e2.eachComponent({ mainType: "legend", subType: "scroll", query: t2 }, function(a) {
        a.setScrollDataIndex(n2);
      });
    });
  }
  function NCe(r2) {
    ya(GZ), r2.registerComponentModel(OCe), r2.registerComponentView(RCe), FCe(r2);
  }
  function VCe(r2) {
    ya(GZ), ya(NCe);
  }
  var jCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "dataZoom.inside", t2.defaultOption = Ty(wE.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), t2;
  }(wE), BCe = jCe, RN = fi();
  function zCe(r2, t2, e2) {
    RN(r2).coordSysRecordMap.each(function(n2) {
      var a = n2.dataZoomInfoMap.get(t2.uid);
      a && (a.getRange = e2);
    });
  }
  function $Ce(r2, t2) {
    for (var e2 = RN(r2).coordSysRecordMap, n2 = e2.keys(), a = 0; a < n2.length; a++) {
      var i = n2[a], o = e2.get(i), s = o.dataZoomInfoMap;
      if (s) {
        var u = t2.uid, l2 = s.get(u);
        l2 && (s.removeKey(u), s.keys().length || WZ(e2, o));
      }
    }
  }
  function WZ(r2, t2) {
    if (t2) {
      r2.removeKey(t2.model.uid);
      var e2 = t2.controller;
      e2 && e2.dispose();
    }
  }
  function GCe(r2, t2) {
    var e2 = { model: t2, containsPoint: Gn(UCe, t2), dispatchAction: Gn(WCe, r2), dataZoomInfoMap: null, controller: null }, n2 = e2.controller = new qE(r2.getZr());
    return ae(["pan", "zoom", "scrollMove"], function(a) {
      n2.on(a, function(i) {
        var o = [];
        e2.dataZoomInfoMap.each(function(s) {
          if (!!i.isAvailableBehavior(s.model.option)) {
            var u = (s.getRange || {})[a], l2 = u && u(s.dzReferCoordSysInfo, e2.model.mainType, e2.controller, i);
            !s.model.get("disabled", true) && l2 && o.push({ dataZoomId: s.model.id, start: l2[0], end: l2[1] });
          }
        }), o.length && e2.dispatchAction(o);
      });
    }), e2;
  }
  function WCe(r2, t2) {
    r2.isDisposed() || r2.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: t2 });
  }
  function UCe(r2, t2, e2, n2) {
    return r2.coordinateSystem.containPoint([e2, n2]);
  }
  function HCe(r2) {
    var t2, e2 = "type_", n2 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, a = true;
    return r2.each(function(i) {
      var o = i.model, s = o.get("disabled", true) ? false : o.get("zoomLock", true) ? "move" : true;
      n2[e2 + s] > n2[e2 + t2] && (t2 = s), a = a && o.get("preventDefaultMouseMove", true);
    }), { controlType: t2, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!a } };
  }
  function qCe(r2) {
    r2.registerProcessor(r2.PRIORITY.PROCESSOR.FILTER, function(t2, e2) {
      var n2 = RN(e2), a = n2.coordSysRecordMap || (n2.coordSysRecordMap = mn());
      a.each(function(i) {
        i.dataZoomInfoMap = null;
      }), t2.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(i) {
        var o = EZ(i);
        ae(o.infoList, function(s) {
          var u = s.model.uid, l2 = a.get(u) || a.set(u, GCe(e2, s.model)), c2 = l2.dataZoomInfoMap || (l2.dataZoomInfoMap = mn());
          c2.set(i.uid, { dzReferCoordSysInfo: s, model: i, getRange: null });
        });
      }), a.each(function(i) {
        var o = i.controller, s, u = i.dataZoomInfoMap;
        if (u) {
          var l2 = u.keys()[0];
          l2 != null && (s = u.get(l2));
        }
        if (!s) {
          WZ(a, i);
          return;
        }
        var c2 = HCe(u);
        o.enable(c2.controlType, c2.opt), o.setPointerChecker(i.containsPoint), Sw(i, "dispatchAction", s.model.get("throttle", true), "fixRate");
      });
    });
  }
  var YCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "dataZoom.inside", e2;
    }
    return t2.prototype.render = function(e2, n2, a) {
      if (r2.prototype.render.apply(this, arguments), e2.noTarget()) {
        this._clear();
        return;
      }
      this.range = e2.getPercentRange(), zCe(a, e2, { pan: en(fR.pan, this), zoom: en(fR.zoom, this), scrollMove: en(fR.scrollMove, this) });
    }, t2.prototype.dispose = function() {
      this._clear(), r2.prototype.dispose.apply(this, arguments);
    }, t2.prototype._clear = function() {
      $Ce(this.api, this.dataZoomModel), this.range = null;
    }, t2.type = "dataZoom.inside", t2;
  }(AN), fR = { zoom: function(r2, t2, e2, n2) {
    var a = this.range, i = a.slice(), o = r2.axisModels[0];
    if (!!o) {
      var s = hR[t2](null, [n2.originX, n2.originY], o, e2, r2), u = (s.signal > 0 ? s.pixelStart + s.pixelLength - s.pixel : s.pixel - s.pixelStart) / s.pixelLength * (i[1] - i[0]) + i[0], l2 = Math.max(1 / n2.scale, 0);
      i[0] = (i[0] - u) * l2 + u, i[1] = (i[1] - u) * l2 + u;
      var c2 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
      if (f1(0, i, [0, 100], 0, c2.minSpan, c2.maxSpan), this.range = i, a[0] !== i[0] || a[1] !== i[1])
        return i;
    }
  }, pan: $$(function(r2, t2, e2, n2, a, i) {
    var o = hR[n2]([i.oldX, i.oldY], [i.newX, i.newY], t2, a, e2);
    return o.signal * (r2[1] - r2[0]) * o.pixel / o.pixelLength;
  }), scrollMove: $$(function(r2, t2, e2, n2, a, i) {
    var o = hR[n2]([0, 0], [i.scrollDelta, i.scrollDelta], t2, a, e2);
    return o.signal * (r2[1] - r2[0]) * i.scrollDelta;
  }) };
  function $$(r2) {
    return function(t2, e2, n2, a) {
      var i = this.range, o = i.slice(), s = t2.axisModels[0];
      if (!!s) {
        var u = r2(o, s, t2, e2, n2, a);
        if (f1(u, o, [0, 100], "all"), this.range = o, i[0] !== o[0] || i[1] !== o[1])
          return o;
      }
    };
  }
  var hR = { grid: function(r2, t2, e2, n2, a) {
    var i = e2.axis, o = {}, s = a.model.coordinateSystem.getRect();
    return r2 = r2 || [0, 0], i.dim === "x" ? (o.pixel = t2[0] - r2[0], o.pixelLength = s.width, o.pixelStart = s.x, o.signal = i.inverse ? 1 : -1) : (o.pixel = t2[1] - r2[1], o.pixelLength = s.height, o.pixelStart = s.y, o.signal = i.inverse ? -1 : 1), o;
  }, polar: function(r2, t2, e2, n2, a) {
    var i = e2.axis, o = {}, s = a.model.coordinateSystem, u = s.getRadiusAxis().getExtent(), l2 = s.getAngleAxis().getExtent();
    return r2 = r2 ? s.pointToCoord(r2) : [0, 0], t2 = s.pointToCoord(t2), e2.mainType === "radiusAxis" ? (o.pixel = t2[0] - r2[0], o.pixelLength = u[1] - u[0], o.pixelStart = u[0], o.signal = i.inverse ? 1 : -1) : (o.pixel = t2[1] - r2[1], o.pixelLength = l2[1] - l2[0], o.pixelStart = l2[0], o.signal = i.inverse ? -1 : 1), o;
  }, singleAxis: function(r2, t2, e2, n2, a) {
    var i = e2.axis, o = a.model.coordinateSystem.getRect(), s = {};
    return r2 = r2 || [0, 0], i.orient === "horizontal" ? (s.pixel = t2[0] - r2[0], s.pixelLength = o.width, s.pixelStart = o.x, s.signal = i.inverse ? 1 : -1) : (s.pixel = t2[1] - r2[1], s.pixelLength = o.height, s.pixelStart = o.y, s.signal = i.inverse ? -1 : 1), s;
  } }, KCe = YCe;
  function UZ(r2) {
    TN(r2), r2.registerComponentModel(BCe), r2.registerComponentView(KCe), qCe(r2);
  }
  var ZCe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.type = "dataZoom.slider", t2.layoutMode = "box", t2.defaultOption = Ty(wE.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), t2;
  }(wE), XCe = ZCe, vC = ni, G$ = 7, JCe = 1, vR = 30, QCe = 7, dC = "horizontal", W$ = "vertical", eEe = 5, tEe = ["line", "bar", "candlestick", "scatter"], rEe = { easing: "cubicOut", duration: 100, delay: 0 }, nEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._displayables = {}, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this.api = n2, this._onBrush = en(this._onBrush, this), this._onBrushEnd = en(this._onBrushEnd, this);
    }, t2.prototype.render = function(e2, n2, a, i) {
      if (r2.prototype.render.apply(this, arguments), Sw(this, "_dispatchZoomAction", e2.get("throttle"), "fixRate"), this._orient = e2.getOrient(), e2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      if (e2.noTarget()) {
        this._clear(), this.group.removeAll();
        return;
      }
      (!i || i.type !== "dataZoom" || i.from !== this.uid) && this._buildView(), this._updateView();
    }, t2.prototype.dispose = function() {
      this._clear(), r2.prototype.dispose.apply(this, arguments);
    }, t2.prototype._clear = function() {
      lE(this, "_dispatchZoomAction");
      var e2 = this.api.getZr();
      e2.off("mousemove", this._onBrush), e2.off("mouseup", this._onBrushEnd);
    }, t2.prototype._buildView = function() {
      var e2 = this.group;
      e2.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
      var n2 = this._displayables.sliderGroup = new Fn();
      this._renderBackground(), this._renderHandle(), this._renderDataShadow(), e2.add(n2), this._positionGroup();
    }, t2.prototype._resetLocation = function() {
      var e2 = this.dataZoomModel, n2 = this.api, a = e2.get("brushSelect"), i = a ? QCe : 0, o = this._findCoordRect(), s = { width: n2.getWidth(), height: n2.getHeight() }, u = this._orient === dC ? { right: s.width - o.x - o.width, top: s.height - vR - G$ - i, width: o.width, height: vR } : { right: G$, top: o.y, width: vR, height: o.height }, l2 = bw(e2.option);
      ae(["right", "top", "width", "height"], function(f2) {
        l2[f2] === "ph" && (l2[f2] = u[f2]);
      });
      var c2 = Eu(l2, s);
      this._location = { x: c2.x, y: c2.y }, this._size = [c2.width, c2.height], this._orient === W$ && this._size.reverse();
    }, t2.prototype._positionGroup = function() {
      var e2 = this.group, n2 = this._location, a = this._orient, i = this.dataZoomModel.getFirstTargetAxisModel(), o = i && i.get("inverse"), s = this._displayables.sliderGroup, u = (this._dataShadowInfo || {}).otherAxisInverse;
      s.attr(a === dC && !o ? { scaleY: u ? 1 : -1, scaleX: 1 } : a === dC && o ? { scaleY: u ? 1 : -1, scaleX: -1 } : a === W$ && !o ? { scaleY: u ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: u ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
      var l2 = e2.getBoundingRect([s]);
      e2.x = n2.x - l2.x, e2.y = n2.y - l2.y, e2.markRedraw();
    }, t2.prototype._getViewExtent = function() {
      return [0, this._size[0]];
    }, t2.prototype._renderBackground = function() {
      var e2 = this.dataZoomModel, n2 = this._size, a = this._displayables.sliderGroup, i = e2.get("brushSelect");
      a.add(new vC({ silent: true, shape: { x: 0, y: 0, width: n2[0], height: n2[1] }, style: { fill: e2.get("backgroundColor") }, z2: -40 }));
      var o = new vC({ shape: { x: 0, y: 0, width: n2[0], height: n2[1] }, style: { fill: "transparent" }, z2: 0, onclick: en(this._onClickPanel, this) }), s = this.api.getZr();
      i ? (o.on("mousedown", this._onBrushStart, this), o.cursor = "crosshair", s.on("mousemove", this._onBrush), s.on("mouseup", this._onBrushEnd)) : (s.off("mousemove", this._onBrush), s.off("mouseup", this._onBrushEnd)), a.add(o);
    }, t2.prototype._renderDataShadow = function() {
      var e2 = this._dataShadowInfo = this._prepareDataShadowInfo();
      if (this._displayables.dataShadowSegs = [], !e2)
        return;
      var n2 = this._size, a = this._shadowSize || [], i = e2.series, o = i.getRawData(), s = i.getShadowDim ? i.getShadowDim() : e2.otherDim;
      if (s == null)
        return;
      var u = this._shadowPolygonPts, l2 = this._shadowPolylinePts;
      if (o !== this._shadowData || s !== this._shadowDim || n2[0] !== a[0] || n2[1] !== a[1]) {
        var c2 = o.getDataExtent(s), f2 = (c2[1] - c2[0]) * 0.3;
        c2 = [c2[0] - f2, c2[1] + f2];
        var h = [0, n2[1]], v9 = [0, n2[0]], d2 = [[n2[0], 0], [0, 0]], m2 = [], b2 = v9[1] / (o.count() - 1), _ = 0, C = Math.round(o.count() / n2[0]), M;
        o.each([s], function(U, H) {
          if (C > 0 && H % C) {
            _ += b2;
            return;
          }
          var q3 = U == null || isNaN(U) || U === "", ee = q3 ? 0 : Gi(U, c2, h, true);
          q3 && !M && H ? (d2.push([d2[d2.length - 1][0], 0]), m2.push([m2[m2.length - 1][0], 0])) : !q3 && M && (d2.push([_, 0]), m2.push([_, 0])), d2.push([_, ee]), m2.push([_, ee]), _ += b2, M = q3;
        }), u = this._shadowPolygonPts = d2, l2 = this._shadowPolylinePts = m2;
      }
      this._shadowData = o, this._shadowDim = s, this._shadowSize = [n2[0], n2[1]];
      var E = this.dataZoomModel;
      function z9(U) {
        var H = E.getModel(U ? "selectedDataBackground" : "dataBackground"), q3 = new Fn(), ee = new gf({ shape: { points: u }, segmentIgnoreThreshold: 1, style: H.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), oe = new yf({ shape: { points: l2 }, segmentIgnoreThreshold: 1, style: H.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
        return q3.add(ee), q3.add(oe), q3;
      }
      for (var V = 0; V < 3; V++) {
        var $ = z9(V === 1);
        this._displayables.sliderGroup.add($), this._displayables.dataShadowSegs.push($);
      }
    }, t2.prototype._prepareDataShadowInfo = function() {
      var e2 = this.dataZoomModel, n2 = e2.get("showDataShadow");
      if (n2 !== false) {
        var a, i = this.ecModel;
        return e2.eachTargetAxis(function(o, s) {
          var u = e2.getAxisProxy(o, s).getTargetSeriesModels();
          ae(u, function(l2) {
            if (!a && !(n2 !== true && va(tEe, l2.get("type")) < 0)) {
              var c2 = i.getComponent(cy(o), s).axis, f2 = aEe(o), h, v9 = l2.coordinateSystem;
              f2 != null && v9.getOtherAxis && (h = v9.getOtherAxis(c2).inverse), f2 = l2.getData().mapDimension(f2), a = { thisAxis: c2, series: l2, thisDim: o, otherDim: f2, otherAxisInverse: h };
            }
          }, this);
        }, this), a;
      }
    }, t2.prototype._renderHandle = function() {
      var e2 = this.group, n2 = this._displayables, a = n2.handles = [null, null], i = n2.handleLabels = [null, null], o = this._displayables.sliderGroup, s = this._size, u = this.dataZoomModel, l2 = this.api, c2 = u.get("borderRadius") || 0, f2 = u.get("brushSelect"), h = n2.filler = new vC({ silent: f2, style: { fill: u.get("fillerColor") }, textConfig: { position: "inside" } });
      o.add(h), o.add(new vC({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: s[0], height: s[1], r: c2 }, style: { stroke: u.get("dataBackgroundColor") || u.get("borderColor"), lineWidth: JCe, fill: "rgba(0,0,0,0)" } })), ae([0, 1], function(M) {
        var E = u.get("handleIcon");
        !uP[E] && E.indexOf("path://") < 0 && E.indexOf("image://") < 0 && (E = "path://" + E);
        var z9 = cu(E, -1, 0, 2, 2, null, true);
        z9.attr({ cursor: U$(this._orient), draggable: true, drift: en(this._onDragMove, this, M), ondragend: en(this._onDragEnd, this), onmouseover: en(this._showDataInfo, this, true), onmouseout: en(this._showDataInfo, this, false), z2: 5 });
        var V = z9.getBoundingRect(), $ = u.get("handleSize");
        this._handleHeight = qr($, this._size[1]), this._handleWidth = V.width / V.height * this._handleHeight, z9.setStyle(u.getModel("handleStyle").getItemStyle()), z9.style.strokeNoScale = true, z9.rectHover = true, z9.ensureState("emphasis").style = u.getModel(["emphasis", "handleStyle"]).getItemStyle(), qb(z9);
        var U = u.get("handleColor");
        U != null && (z9.style.fill = U), o.add(a[M] = z9);
        var H = u.getModel("textStyle");
        e2.add(i[M] = new xi({ silent: true, invisible: true, style: Hs(H, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: H.getTextColor(), font: H.getFont() }), z2: 10 }));
      }, this);
      var v9 = h;
      if (f2) {
        var d2 = qr(u.get("moveHandleSize"), s[1]), m2 = n2.moveHandle = new ni({ style: u.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: s[1] - 0.5, height: d2 } }), b2 = d2 * 0.8, _ = n2.moveHandleIcon = cu(u.get("moveHandleIcon"), -b2 / 2, -b2 / 2, b2, b2, "#fff", true);
        _.silent = true, _.y = s[1] + d2 / 2 - 0.5, m2.ensureState("emphasis").style = u.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
        var C = Math.min(s[1] / 2, Math.max(d2, 10));
        v9 = n2.moveZone = new ni({ invisible: true, shape: { y: s[1] - C, height: d2 + C } }), v9.on("mouseover", function() {
          l2.enterEmphasis(m2);
        }).on("mouseout", function() {
          l2.leaveEmphasis(m2);
        }), o.add(m2), o.add(_), o.add(v9);
      }
      v9.attr({ draggable: true, cursor: U$(this._orient), drift: en(this._onDragMove, this, "all"), ondragstart: en(this._showDataInfo, this, true), ondragend: en(this._onDragEnd, this), onmouseover: en(this._showDataInfo, this, true), onmouseout: en(this._showDataInfo, this, false) });
    }, t2.prototype._resetInterval = function() {
      var e2 = this._range = this.dataZoomModel.getPercentRange(), n2 = this._getViewExtent();
      this._handleEnds = [Gi(e2[0], [0, 100], n2, true), Gi(e2[1], [0, 100], n2, true)];
    }, t2.prototype._updateInterval = function(e2, n2) {
      var a = this.dataZoomModel, i = this._handleEnds, o = this._getViewExtent(), s = a.findRepresentativeAxisProxy().getMinMaxSpan(), u = [0, 100];
      f1(n2, i, o, a.get("zoomLock") ? "all" : e2, s.minSpan != null ? Gi(s.minSpan, u, o, true) : null, s.maxSpan != null ? Gi(s.maxSpan, u, o, true) : null);
      var l2 = this._range, c2 = this._range = $h([Gi(i[0], o, u, true), Gi(i[1], o, u, true)]);
      return !l2 || l2[0] !== c2[0] || l2[1] !== c2[1];
    }, t2.prototype._updateView = function(e2) {
      var n2 = this._displayables, a = this._handleEnds, i = $h(a.slice()), o = this._size;
      ae([0, 1], function(v9) {
        var d2 = n2.handles[v9], m2 = this._handleHeight;
        d2.attr({ scaleX: m2 / 2, scaleY: m2 / 2, x: a[v9] + (v9 ? -1 : 1), y: o[1] / 2 - m2 / 2 });
      }, this), n2.filler.setShape({ x: i[0], y: 0, width: i[1] - i[0], height: o[1] });
      var s = { x: i[0], width: i[1] - i[0] };
      n2.moveHandle && (n2.moveHandle.setShape(s), n2.moveZone.setShape(s), n2.moveZone.getBoundingRect(), n2.moveHandleIcon && n2.moveHandleIcon.attr("x", s.x + s.width / 2));
      for (var u = n2.dataShadowSegs, l2 = [0, i[0], i[1], o[0]], c2 = 0; c2 < u.length; c2++) {
        var f2 = u[c2], h = f2.getClipPath();
        h || (h = new ni(), f2.setClipPath(h)), h.setShape({ x: l2[c2], y: 0, width: l2[c2 + 1] - l2[c2], height: o[1] });
      }
      this._updateDataInfo(e2);
    }, t2.prototype._updateDataInfo = function(e2) {
      var n2 = this.dataZoomModel, a = this._displayables, i = a.handleLabels, o = this._orient, s = ["", ""];
      if (n2.get("showDetail")) {
        var u = n2.findRepresentativeAxisProxy();
        if (u) {
          var l2 = u.getAxisModel().axis, c2 = this._range, f2 = e2 ? u.calculateDataWindow({ start: c2[0], end: c2[1] }).valueWindow : u.getDataValueWindow();
          s = [this._formatLabel(f2[0], l2), this._formatLabel(f2[1], l2)];
        }
      }
      var h = $h(this._handleEnds.slice());
      v9.call(this, 0), v9.call(this, 1);
      function v9(d2) {
        var m2 = Yb(a.handles[d2].parent, this.group), b2 = n3(d2 === 0 ? "right" : "left", m2), _ = this._handleWidth / 2 + eEe, C = $v([h[d2] + (d2 === 0 ? -_ : _), this._size[1] / 2], m2);
        i[d2].setStyle({ x: C[0], y: C[1], verticalAlign: o === dC ? "middle" : b2, align: o === dC ? b2 : "center", text: s[d2] });
      }
    }, t2.prototype._formatLabel = function(e2, n2) {
      var a = this.dataZoomModel, i = a.get("labelFormatter"), o = a.get("labelPrecision");
      (o == null || o === "auto") && (o = n2.getPixelPrecision());
      var s = e2 == null || isNaN(e2) ? "" : n2.type === "category" || n2.type === "time" ? n2.scale.getLabel({ value: Math.round(e2) }) : e2.toFixed(Math.min(o, 20));
      return xn(i) ? i(e2, s) : Zr(i) ? i.replace("{value}", s) : s;
    }, t2.prototype._showDataInfo = function(e2) {
      e2 = this._dragging || e2;
      var n2 = this._displayables, a = n2.handleLabels;
      a[0].attr("invisible", !e2), a[1].attr("invisible", !e2), n2.moveHandle && this.api[e2 ? "enterEmphasis" : "leaveEmphasis"](n2.moveHandle, 1);
    }, t2.prototype._onDragMove = function(e2, n2, a, i) {
      this._dragging = true, Mg(i.event);
      var o = this._displayables.sliderGroup.getLocalTransform(), s = $v([n2, a], o, true), u = this._updateInterval(e2, s[0]), l2 = this.dataZoomModel.get("realtime");
      this._updateView(!l2), u && l2 && this._dispatchZoomAction(true);
    }, t2.prototype._onDragEnd = function() {
      this._dragging = false, this._showDataInfo(false);
      var e2 = this.dataZoomModel.get("realtime");
      !e2 && this._dispatchZoomAction(false);
    }, t2.prototype._onClickPanel = function(e2) {
      var n2 = this._size, a = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
      if (!(a[0] < 0 || a[0] > n2[0] || a[1] < 0 || a[1] > n2[1])) {
        var i = this._handleEnds, o = (i[0] + i[1]) / 2, s = this._updateInterval("all", a[0] - o);
        this._updateView(), s && this._dispatchZoomAction(false);
      }
    }, t2.prototype._onBrushStart = function(e2) {
      var n2 = e2.offsetX, a = e2.offsetY;
      this._brushStart = new Jn(n2, a), this._brushing = true, this._brushStartTime = +new Date();
    }, t2.prototype._onBrushEnd = function(e2) {
      if (!!this._brushing) {
        var n2 = this._displayables.brushRect;
        if (this._brushing = false, !!n2) {
          n2.attr("ignore", true);
          var a = n2.shape, i = +new Date();
          if (!(i - this._brushStartTime < 200 && Math.abs(a.width) < 5)) {
            var o = this._getViewExtent(), s = [0, 100];
            this._range = $h([Gi(a.x, o, s, true), Gi(a.x + a.width, o, s, true)]), this._handleEnds = [a.x, a.x + a.width], this._updateView(), this._dispatchZoomAction(false);
          }
        }
      }
    }, t2.prototype._onBrush = function(e2) {
      this._brushing && (Mg(e2.event), this._updateBrushRect(e2.offsetX, e2.offsetY));
    }, t2.prototype._updateBrushRect = function(e2, n2) {
      var a = this._displayables, i = this.dataZoomModel, o = a.brushRect;
      o || (o = a.brushRect = new vC({ silent: true, style: i.getModel("brushStyle").getItemStyle() }), a.sliderGroup.add(o)), o.attr("ignore", false);
      var s = this._brushStart, u = this._displayables.sliderGroup, l2 = u.transformCoordToLocal(e2, n2), c2 = u.transformCoordToLocal(s.x, s.y), f2 = this._size;
      l2[0] = Math.max(Math.min(f2[0], l2[0]), 0), o.setShape({ x: c2[0], y: 0, width: l2[0] - c2[0], height: f2[1] });
    }, t2.prototype._dispatchZoomAction = function(e2) {
      var n2 = this._range;
      this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: e2 ? rEe : null, start: n2[0], end: n2[1] });
    }, t2.prototype._findCoordRect = function() {
      var e2, n2 = EZ(this.dataZoomModel).infoList;
      if (!e2 && n2.length) {
        var a = n2[0].model.coordinateSystem;
        e2 = a.getRect && a.getRect();
      }
      if (!e2) {
        var i = this.api.getWidth(), o = this.api.getHeight();
        e2 = { x: i * 0.2, y: o * 0.2, width: i * 0.6, height: o * 0.6 };
      }
      return e2;
    }, t2.type = "dataZoom.slider", t2;
  }(AN);
  function aEe(r2) {
    var t2 = { x: "y", y: "x", radius: "angle", angle: "radius" };
    return t2[r2];
  }
  function U$(r2) {
    return r2 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var iEe = nEe;
  function HZ(r2) {
    r2.registerComponentModel(XCe), r2.registerComponentView(iEe), TN(r2);
  }
  function oEe(r2) {
    ya(UZ), ya(HZ);
  }
  var sEe = { get: function(r2, t2, e2) {
    var n2 = On((uEe[r2] || {})[t2]);
    return e2 && vr(n2) ? n2[n2.length - 1] : n2;
  } }, uEe = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, qZ = sEe, H$ = Vl.mapVisual, lEe = Vl.eachVisual, cEe = vr, q$ = ae, fEe = $h, hEe = Gi, vEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.stateList = ["inRange", "outOfRange"], e2.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], e2.layoutMode = { type: "box", ignoreSize: true }, e2.dataBound = [-1 / 0, 1 / 0], e2.targetVisuals = {}, e2.controllerVisuals = {}, e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      this.mergeDefaultAndTheme(e2, a);
    }, t2.prototype.optionUpdated = function(e2, n2) {
      var a = this.option;
      !n2 && RZ(a, e2, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
    }, t2.prototype.resetVisual = function(e2) {
      var n2 = this.stateList;
      e2 = en(e2, this), this.controllerVisuals = o6(this.option.controller, n2, e2), this.targetVisuals = o6(this.option.target, n2, e2);
    }, t2.prototype.getItemSymbol = function() {
      return null;
    }, t2.prototype.getTargetSeriesIndices = function() {
      var e2 = this.option.seriesIndex, n2 = [];
      return e2 == null || e2 === "all" ? this.ecModel.eachSeries(function(a, i) {
        n2.push(i);
      }) : n2 = ao(e2), n2;
    }, t2.prototype.eachTargetSeries = function(e2, n2) {
      ae(this.getTargetSeriesIndices(), function(a) {
        var i = this.ecModel.getSeriesByIndex(a);
        i && e2.call(n2, i);
      }, this);
    }, t2.prototype.isTargetSeries = function(e2) {
      var n2 = false;
      return this.eachTargetSeries(function(a) {
        a === e2 && (n2 = true);
      }), n2;
    }, t2.prototype.formatValueText = function(e2, n2, a) {
      var i = this.option, o = i.precision, s = this.dataBound, u = i.formatter, l2;
      a = a || ["<", ">"], vr(e2) && (e2 = e2.slice(), l2 = true);
      var c2 = n2 ? e2 : l2 ? [f2(e2[0]), f2(e2[1])] : f2(e2);
      if (Zr(u))
        return u.replace("{value}", l2 ? c2[0] : c2).replace("{value2}", l2 ? c2[1] : c2);
      if (xn(u))
        return l2 ? u(e2[0], e2[1]) : u(e2);
      if (l2)
        return e2[0] === s[0] ? a[0] + " " + c2[1] : e2[1] === s[1] ? a[1] + " " + c2[0] : c2[0] + " - " + c2[1];
      return c2;
      function f2(h) {
        return h === s[0] ? "min" : h === s[1] ? "max" : (+h).toFixed(Math.min(o, 20));
      }
    }, t2.prototype.resetExtent = function() {
      var e2 = this.option, n2 = fEe([e2.min, e2.max]);
      this._dataExtent = n2;
    }, t2.prototype.getDataDimensionIndex = function(e2) {
      var n2 = this.option.dimension;
      if (n2 != null)
        return e2.getDimensionIndex(n2);
      for (var a = e2.dimensions, i = a.length - 1; i >= 0; i--) {
        var o = a[i], s = e2.getDimensionInfo(o);
        if (!s.isCalculationCoord)
          return s.storeDimIndex;
      }
    }, t2.prototype.getExtent = function() {
      return this._dataExtent.slice();
    }, t2.prototype.completeVisualOption = function() {
      var e2 = this.ecModel, n2 = this.option, a = { inRange: n2.inRange, outOfRange: n2.outOfRange }, i = n2.target || (n2.target = {}), o = n2.controller || (n2.controller = {});
      ea(i, a), ea(o, a);
      var s = this.isCategory();
      u.call(this, i), u.call(this, o), l2.call(this, i, "inRange", "outOfRange"), c2.call(this, o);
      function u(f2) {
        cEe(n2.color) && !f2.inRange && (f2.inRange = { color: n2.color.slice().reverse() }), f2.inRange = f2.inRange || { color: e2.get("gradientColor") };
      }
      function l2(f2, h, v9) {
        var d2 = f2[h], m2 = f2[v9];
        d2 && !m2 && (m2 = f2[v9] = {}, q$(d2, function(b2, _) {
          if (!!Vl.isValidType(_)) {
            var C = qZ.get(_, "inactive", s);
            C != null && (m2[_] = C, _ === "color" && !m2.hasOwnProperty("opacity") && !m2.hasOwnProperty("colorAlpha") && (m2.opacity = [0, 0]));
          }
        }));
      }
      function c2(f2) {
        var h = (f2.inRange || {}).symbol || (f2.outOfRange || {}).symbol, v9 = (f2.inRange || {}).symbolSize || (f2.outOfRange || {}).symbolSize, d2 = this.get("inactiveColor"), m2 = this.getItemSymbol(), b2 = m2 || "roundRect";
        q$(this.stateList, function(_) {
          var C = this.itemSize, M = f2[_];
          M || (M = f2[_] = { color: s ? d2 : [d2] }), M.symbol == null && (M.symbol = h && On(h) || (s ? b2 : [b2])), M.symbolSize == null && (M.symbolSize = v9 && On(v9) || (s ? C[0] : [C[0], C[0]])), M.symbol = H$(M.symbol, function(V) {
            return V === "none" ? b2 : V;
          });
          var E = M.symbolSize;
          if (E != null) {
            var z9 = -1 / 0;
            lEe(E, function(V) {
              V > z9 && (z9 = V);
            }), M.symbolSize = H$(E, function(V) {
              return hEe(V, [0, z9], [0, C[0]], true);
            });
          }
        }, this);
      }
    }, t2.prototype.resetItemSize = function() {
      this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
    }, t2.prototype.isCategory = function() {
      return !!this.option.categories;
    }, t2.prototype.setSelected = function(e2) {
    }, t2.prototype.getSelected = function() {
      return null;
    }, t2.prototype.getValueState = function(e2) {
      return null;
    }, t2.prototype.getVisualMeta = function(e2) {
      return null;
    }, t2.type = "visualMap", t2.dependencies = ["series"], t2.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, t2;
  }(li), OP = vEe, Y$ = [20, 140], dEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.optionUpdated = function(e2, n2) {
      r2.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(a) {
        a.mappingMethod = "linear", a.dataExtent = this.getExtent();
      }), this._resetRange();
    }, t2.prototype.resetItemSize = function() {
      r2.prototype.resetItemSize.apply(this, arguments);
      var e2 = this.itemSize;
      (e2[0] == null || isNaN(e2[0])) && (e2[0] = Y$[0]), (e2[1] == null || isNaN(e2[1])) && (e2[1] = Y$[1]);
    }, t2.prototype._resetRange = function() {
      var e2 = this.getExtent(), n2 = this.option.range;
      !n2 || n2.auto ? (e2.auto = 1, this.option.range = e2) : vr(n2) && (n2[0] > n2[1] && n2.reverse(), n2[0] = Math.max(n2[0], e2[0]), n2[1] = Math.min(n2[1], e2[1]));
    }, t2.prototype.completeVisualOption = function() {
      r2.prototype.completeVisualOption.apply(this, arguments), ae(this.stateList, function(e2) {
        var n2 = this.option.controller[e2].symbolSize;
        n2 && n2[0] !== n2[1] && (n2[0] = n2[1] / 3);
      }, this);
    }, t2.prototype.setSelected = function(e2) {
      this.option.range = e2.slice(), this._resetRange();
    }, t2.prototype.getSelected = function() {
      var e2 = this.getExtent(), n2 = $h((this.get("range") || []).slice());
      return n2[0] > e2[1] && (n2[0] = e2[1]), n2[1] > e2[1] && (n2[1] = e2[1]), n2[0] < e2[0] && (n2[0] = e2[0]), n2[1] < e2[0] && (n2[1] = e2[0]), n2;
    }, t2.prototype.getValueState = function(e2) {
      var n2 = this.option.range, a = this.getExtent();
      return (n2[0] <= a[0] || n2[0] <= e2) && (n2[1] >= a[1] || e2 <= n2[1]) ? "inRange" : "outOfRange";
    }, t2.prototype.findTargetDataIndices = function(e2) {
      var n2 = [];
      return this.eachTargetSeries(function(a) {
        var i = [], o = a.getData();
        o.each(this.getDataDimensionIndex(o), function(s, u) {
          e2[0] <= s && s <= e2[1] && i.push(u);
        }, this), n2.push({ seriesId: a.id, dataIndex: i });
      }, this), n2;
    }, t2.prototype.getVisualMeta = function(e2) {
      var n2 = K$(this, "outOfRange", this.getExtent()), a = K$(this, "inRange", this.option.range.slice()), i = [];
      function o(v9, d2) {
        i.push({ value: v9, color: e2(v9, d2) });
      }
      for (var s = 0, u = 0, l2 = a.length, c2 = n2.length; u < c2 && (!a.length || n2[u] <= a[0]); u++)
        n2[u] < a[s] && o(n2[u], "outOfRange");
      for (var f2 = 1; s < l2; s++, f2 = 0)
        f2 && i.length && o(a[s], "outOfRange"), o(a[s], "inRange");
      for (var f2 = 1; u < c2; u++)
        (!a.length || a[a.length - 1] < n2[u]) && (f2 && (i.length && o(i[i.length - 1].value, "outOfRange"), f2 = 0), o(n2[u], "outOfRange"));
      var h = i.length;
      return { stops: i, outerColors: [h ? i[0].color : "transparent", h ? i[h - 1].color : "transparent"] };
    }, t2.type = "visualMap.continuous", t2.defaultOption = Ty(OP.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), t2;
  }(OP);
  function K$(r2, t2, e2) {
    if (e2[0] === e2[1])
      return e2.slice();
    for (var n2 = 200, a = (e2[1] - e2[0]) / n2, i = e2[0], o = [], s = 0; s <= n2 && i < e2[1]; s++)
      o.push(i), i += a;
    return o.push(e2[1]), o;
  }
  var pEe = dEe, gEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, e2;
    }
    return t2.prototype.init = function(e2, n2) {
      this.ecModel = e2, this.api = n2;
    }, t2.prototype.render = function(e2, n2, a, i) {
      if (this.visualMapModel = e2, e2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      this.doRender(e2, n2, a, i);
    }, t2.prototype.renderBackground = function(e2) {
      var n2 = this.visualMapModel, a = mw(n2.get("padding") || 0), i = e2.getBoundingRect();
      e2.add(new ni({ z2: -1, silent: true, shape: { x: i.x - a[3], y: i.y - a[0], width: i.width + a[3] + a[1], height: i.height + a[0] + a[2] }, style: { fill: n2.get("backgroundColor"), stroke: n2.get("borderColor"), lineWidth: n2.get("borderWidth") } }));
    }, t2.prototype.getControllerVisual = function(e2, n2, a) {
      a = a || {};
      var i = a.forceState, o = this.visualMapModel, s = {};
      if (n2 === "color") {
        var u = o.get("contentColor");
        s.color = u;
      }
      function l2(v9) {
        return s[v9];
      }
      function c2(v9, d2) {
        s[v9] = d2;
      }
      var f2 = o.controllerVisuals[i || o.getValueState(e2)], h = Vl.prepareVisualTypes(f2);
      return ae(h, function(v9) {
        var d2 = f2[v9];
        a.convertOpacityToAlpha && v9 === "opacity" && (v9 = "colorAlpha", d2 = f2.__alphaForOpacity), Vl.dependsOn(v9, n2) && d2 && d2.applyVisual(e2, l2, c2);
      }), s[n2];
    }, t2.prototype.positionGroup = function(e2) {
      var n2 = this.visualMapModel, a = this.api;
      c3(e2, n2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
    }, t2.prototype.doRender = function(e2, n2, a, i) {
    }, t2.type = "visualMap", t2;
  }(gs), YZ = gEe, Z$ = [["left", "right", "width"], ["top", "bottom", "height"]];
  function KZ(r2, t2, e2) {
    var n2 = r2.option, a = n2.align;
    if (a != null && a !== "auto")
      return a;
    for (var i = { width: t2.getWidth(), height: t2.getHeight() }, o = n2.orient === "horizontal" ? 1 : 0, s = Z$[o], u = [0, null, 10], l2 = {}, c2 = 0; c2 < 3; c2++)
      l2[Z$[1 - o][c2]] = u[c2], l2[s[c2]] = c2 === 2 ? e2[0] : n2[s[c2]];
    var f2 = [["x", "width", 3], ["y", "height", 0]][o], h = Eu(l2, i, n2.padding);
    return s[(h.margin[f2[2]] || 0) + h[f2[0]] + h[f2[1]] * 0.5 < i[f2[1]] * 0.5 ? 0 : 1];
  }
  function B5(r2, t2) {
    return ae(r2 || [], function(e2) {
      e2.dataIndex != null && (e2.dataIndexInside = e2.dataIndex, e2.dataIndex = null), e2.highlightKey = "visualMap" + (t2 ? t2.componentIndex : "");
    }), r2;
  }
  var zd = Gi, yEe = ae, X$ = Math.min, dR = Math.max, mEe = 12, bEe = 6, _Ee = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._shapes = {}, e2._dataInterval = [], e2._handleEnds = [], e2._hoverLinkDataIndices = [], e2;
    }
    return t2.prototype.doRender = function(e2, n2, a, i) {
      this._api = a, (!i || i.type !== "selectDataRange" || i.from !== this.uid) && this._buildView();
    }, t2.prototype._buildView = function() {
      this.group.removeAll();
      var e2 = this.visualMapModel, n2 = this.group;
      this._orient = e2.get("orient"), this._useHandle = e2.get("calculable"), this._resetInterval(), this._renderBar(n2);
      var a = e2.get("text");
      this._renderEndsText(n2, a, 0), this._renderEndsText(n2, a, 1), this._updateView(true), this.renderBackground(n2), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(n2);
    }, t2.prototype._renderEndsText = function(e2, n2, a) {
      if (!!n2) {
        var i = n2[1 - a];
        i = i != null ? i + "" : "";
        var o = this.visualMapModel, s = o.get("textGap"), u = o.itemSize, l2 = this._shapes.mainGroup, c2 = this._applyTransform([u[0] / 2, a === 0 ? -s : u[1] + s], l2), f2 = this._applyTransform(a === 0 ? "bottom" : "top", l2), h = this._orient, v9 = this.visualMapModel.textStyleModel;
        this.group.add(new xi({ style: { x: c2[0], y: c2[1], verticalAlign: h === "horizontal" ? "middle" : f2, align: h === "horizontal" ? f2 : "center", text: i, font: v9.getFont(), fill: v9.getTextColor() } }));
      }
    }, t2.prototype._renderBar = function(e2) {
      var n2 = this.visualMapModel, a = this._shapes, i = n2.itemSize, o = this._orient, s = this._useHandle, u = KZ(n2, this.api, i), l2 = a.mainGroup = this._createBarGroup(u), c2 = new Fn();
      l2.add(c2), c2.add(a.outOfRange = J$()), c2.add(a.inRange = J$(null, s ? eG(this._orient) : null, en(this._dragHandle, this, "all", false), en(this._dragHandle, this, "all", true))), c2.setClipPath(new ni({ shape: { x: 0, y: 0, width: i[0], height: i[1], r: 3 } }));
      var f2 = n2.textStyleModel.getTextRect("\u56FD"), h = dR(f2.width, f2.height);
      s && (a.handleThumbs = [], a.handleLabels = [], a.handleLabelPoints = [], this._createHandle(n2, l2, 0, i, h, o), this._createHandle(n2, l2, 1, i, h, o)), this._createIndicator(n2, l2, i, h, o), e2.add(l2);
    }, t2.prototype._createHandle = function(e2, n2, a, i, o, s) {
      var u = en(this._dragHandle, this, a, false), l2 = en(this._dragHandle, this, a, true), c2 = Gv(e2.get("handleSize"), i[0]), f2 = cu(e2.get("handleIcon"), -c2 / 2, -c2 / 2, c2, c2, null, true), h = eG(this._orient);
      f2.attr({ cursor: h, draggable: true, drift: u, ondragend: l2, onmousemove: function(_) {
        Mg(_.event);
      } }), f2.x = i[0] / 2, f2.useStyle(e2.getModel("handleStyle").getItemStyle()), f2.setStyle({ strokeNoScale: true, strokeFirst: true }), f2.style.lineWidth *= 2, f2.ensureState("emphasis").style = e2.getModel(["emphasis", "handleStyle"]).getItemStyle(), Bb(f2, true), n2.add(f2);
      var v9 = this.visualMapModel.textStyleModel, d2 = new xi({ cursor: h, draggable: true, drift: u, onmousemove: function(_) {
        Mg(_.event);
      }, ondragend: l2, style: { x: 0, y: 0, text: "", font: v9.getFont(), fill: v9.getTextColor() } });
      d2.ensureState("blur").style = { opacity: 0.1 }, d2.stateTransition = { duration: 200 }, this.group.add(d2);
      var m2 = [c2, 0], b2 = this._shapes;
      b2.handleThumbs[a] = f2, b2.handleLabelPoints[a] = m2, b2.handleLabels[a] = d2;
    }, t2.prototype._createIndicator = function(e2, n2, a, i, o) {
      var s = Gv(e2.get("indicatorSize"), a[0]), u = cu(e2.get("indicatorIcon"), -s / 2, -s / 2, s, s, null, true);
      u.attr({ cursor: "move", invisible: true, silent: true, x: a[0] / 2 });
      var l2 = e2.getModel("indicatorStyle").getItemStyle();
      if (u instanceof Bl) {
        var c2 = u.style;
        u.useStyle(qt({ image: c2.image, x: c2.x, y: c2.y, width: c2.width, height: c2.height }, l2));
      } else
        u.useStyle(l2);
      n2.add(u);
      var f2 = this.visualMapModel.textStyleModel, h = new xi({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: f2.getFont(), fill: f2.getTextColor() } });
      this.group.add(h);
      var v9 = [(o === "horizontal" ? i / 2 : bEe) + a[0] / 2, 0], d2 = this._shapes;
      d2.indicator = u, d2.indicatorLabel = h, d2.indicatorLabelPoint = v9, this._firstShowIndicator = true;
    }, t2.prototype._dragHandle = function(e2, n2, a, i) {
      if (!!this._useHandle) {
        if (this._dragging = !n2, !n2) {
          var o = this._applyTransform([a, i], this._shapes.mainGroup, true);
          this._updateInterval(e2, o[1]), this._hideIndicator(), this._updateView();
        }
        n2 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), n2 ? !this._hovering && this._clearHoverLinkToSeries() : Q$(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[e2], false);
      }
    }, t2.prototype._resetInterval = function() {
      var e2 = this.visualMapModel, n2 = this._dataInterval = e2.getSelected(), a = e2.getExtent(), i = [0, e2.itemSize[1]];
      this._handleEnds = [zd(n2[0], a, i, true), zd(n2[1], a, i, true)];
    }, t2.prototype._updateInterval = function(e2, n2) {
      n2 = n2 || 0;
      var a = this.visualMapModel, i = this._handleEnds, o = [0, a.itemSize[1]];
      f1(n2, i, o, e2, 0);
      var s = a.getExtent();
      this._dataInterval = [zd(i[0], o, s, true), zd(i[1], o, s, true)];
    }, t2.prototype._updateView = function(e2) {
      var n2 = this.visualMapModel, a = n2.getExtent(), i = this._shapes, o = [0, n2.itemSize[1]], s = e2 ? o : this._handleEnds, u = this._createBarVisual(this._dataInterval, a, s, "inRange"), l2 = this._createBarVisual(a, a, o, "outOfRange");
      i.inRange.setStyle({ fill: u.barColor }).setShape("points", u.barPoints), i.outOfRange.setStyle({ fill: l2.barColor }).setShape("points", l2.barPoints), this._updateHandle(s, u);
    }, t2.prototype._createBarVisual = function(e2, n2, a, i) {
      var o = { forceState: i, convertOpacityToAlpha: true }, s = this._makeColorGradient(e2, o), u = [this.getControllerVisual(e2[0], "symbolSize", o), this.getControllerVisual(e2[1], "symbolSize", o)], l2 = this._createBarPoints(a, u);
      return { barColor: new LE(0, 0, 0, 1, s), barPoints: l2, handlesColor: [s[0].color, s[s.length - 1].color] };
    }, t2.prototype._makeColorGradient = function(e2, n2) {
      var a = 100, i = [], o = (e2[1] - e2[0]) / a;
      i.push({ color: this.getControllerVisual(e2[0], "color", n2), offset: 0 });
      for (var s = 1; s < a; s++) {
        var u = e2[0] + o * s;
        if (u > e2[1])
          break;
        i.push({ color: this.getControllerVisual(u, "color", n2), offset: s / a });
      }
      return i.push({ color: this.getControllerVisual(e2[1], "color", n2), offset: 1 }), i;
    }, t2.prototype._createBarPoints = function(e2, n2) {
      var a = this.visualMapModel.itemSize;
      return [[a[0] - n2[0], e2[0]], [a[0], e2[0]], [a[0], e2[1]], [a[0] - n2[1], e2[1]]];
    }, t2.prototype._createBarGroup = function(e2) {
      var n2 = this._orient, a = this.visualMapModel.get("inverse");
      return new Fn(n2 === "horizontal" && !a ? { scaleX: e2 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : n2 === "horizontal" && a ? { scaleX: e2 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : n2 === "vertical" && !a ? { scaleX: e2 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: e2 === "left" ? 1 : -1 });
    }, t2.prototype._updateHandle = function(e2, n2) {
      if (!!this._useHandle) {
        var a = this._shapes, i = this.visualMapModel, o = a.handleThumbs, s = a.handleLabels, u = i.itemSize, l2 = i.getExtent();
        yEe([0, 1], function(c2) {
          var f2 = o[c2];
          f2.setStyle("fill", n2.handlesColor[c2]), f2.y = e2[c2];
          var h = zd(e2[c2], [0, u[1]], l2, true), v9 = this.getControllerVisual(h, "symbolSize");
          f2.scaleX = f2.scaleY = v9 / u[0], f2.x = u[0] - v9 / 2;
          var d2 = $v(a.handleLabelPoints[c2], Yb(f2, this.group));
          s[c2].setStyle({ x: d2[0], y: d2[1], text: i.formatValueText(this._dataInterval[c2]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", a.mainGroup) : "center" });
        }, this);
      }
    }, t2.prototype._showIndicator = function(e2, n2, a, i) {
      var o = this.visualMapModel, s = o.getExtent(), u = o.itemSize, l2 = [0, u[1]], c2 = this._shapes, f2 = c2.indicator;
      if (!!f2) {
        f2.attr("invisible", false);
        var h = { convertOpacityToAlpha: true }, v9 = this.getControllerVisual(e2, "color", h), d2 = this.getControllerVisual(e2, "symbolSize"), m2 = zd(e2, s, l2, true), b2 = u[0] - d2 / 2, _ = { x: f2.x, y: f2.y };
        f2.y = m2, f2.x = b2;
        var C = $v(c2.indicatorLabelPoint, Yb(f2, this.group)), M = c2.indicatorLabel;
        M.attr("invisible", false);
        var E = this._applyTransform("left", c2.mainGroup), z9 = this._orient, V = z9 === "horizontal";
        M.setStyle({ text: (a || "") + o.formatValueText(n2), verticalAlign: V ? E : "middle", align: V ? "center" : E });
        var $ = { x: b2, y: m2, style: { fill: v9 } }, U = { style: { x: C[0], y: C[1] } };
        if (o.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
          var H = { duration: 100, easing: "cubicInOut", additive: true };
          f2.x = _.x, f2.y = _.y, f2.animateTo($, H), M.animateTo(U, H);
        } else
          f2.attr($), M.attr(U);
        this._firstShowIndicator = false;
        var q3 = this._shapes.handleLabels;
        if (q3)
          for (var ee = 0; ee < q3.length; ee++)
            this._api.enterBlur(q3[ee]);
      }
    }, t2.prototype._enableHoverLinkToSeries = function() {
      var e2 = this;
      this._shapes.mainGroup.on("mousemove", function(n2) {
        if (e2._hovering = true, !e2._dragging) {
          var a = e2.visualMapModel.itemSize, i = e2._applyTransform([n2.offsetX, n2.offsetY], e2._shapes.mainGroup, true, true);
          i[1] = X$(dR(0, i[1]), a[1]), e2._doHoverLinkToSeries(i[1], 0 <= i[0] && i[0] <= a[0]);
        }
      }).on("mouseout", function() {
        e2._hovering = false, !e2._dragging && e2._clearHoverLinkToSeries();
      });
    }, t2.prototype._enableHoverLinkFromSeries = function() {
      var e2 = this.api.getZr();
      this.visualMapModel.option.hoverLink ? (e2.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), e2.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
    }, t2.prototype._doHoverLinkToSeries = function(e2, n2) {
      var a = this.visualMapModel, i = a.itemSize;
      if (!!a.option.hoverLink) {
        var o = [0, i[1]], s = a.getExtent();
        e2 = X$(dR(o[0], e2), o[1]);
        var u = xEe(a, s, o), l2 = [e2 - u, e2 + u], c2 = zd(e2, o, s, true), f2 = [zd(l2[0], o, s, true), zd(l2[1], o, s, true)];
        l2[0] < o[0] && (f2[0] = -1 / 0), l2[1] > o[1] && (f2[1] = 1 / 0), n2 && (f2[0] === -1 / 0 ? this._showIndicator(c2, f2[1], "< ", u) : f2[1] === 1 / 0 ? this._showIndicator(c2, f2[0], "> ", u) : this._showIndicator(c2, c2, "\u2248 ", u));
        var h = this._hoverLinkDataIndices, v9 = [];
        (n2 || Q$(a)) && (v9 = this._hoverLinkDataIndices = a.findTargetDataIndices(f2));
        var d2 = aoe(h, v9);
        this._dispatchHighDown("downplay", B5(d2[0], a)), this._dispatchHighDown("highlight", B5(d2[1], a));
      }
    }, t2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
      var n2 = e2.target, a = this.visualMapModel;
      if (!(!n2 || zn(n2).dataIndex == null)) {
        var i = zn(n2), o = this.ecModel.getSeriesByIndex(i.seriesIndex);
        if (!!a.isTargetSeries(o)) {
          var s = o.getData(i.dataType), u = s.getStore().get(a.getDataDimensionIndex(s), i.dataIndex);
          isNaN(u) || this._showIndicator(u, u);
        }
      }
    }, t2.prototype._hideIndicator = function() {
      var e2 = this._shapes;
      e2.indicator && e2.indicator.attr("invisible", true), e2.indicatorLabel && e2.indicatorLabel.attr("invisible", true);
      var n2 = this._shapes.handleLabels;
      if (n2)
        for (var a = 0; a < n2.length; a++)
          this._api.leaveBlur(n2[a]);
    }, t2.prototype._clearHoverLinkToSeries = function() {
      this._hideIndicator();
      var e2 = this._hoverLinkDataIndices;
      this._dispatchHighDown("downplay", B5(e2, this.visualMapModel)), e2.length = 0;
    }, t2.prototype._clearHoverLinkFromSeries = function() {
      this._hideIndicator();
      var e2 = this.api.getZr();
      e2.off("mouseover", this._hoverLinkFromSeriesMouseOver), e2.off("mouseout", this._hideIndicator);
    }, t2.prototype._applyTransform = function(e2, n2, a, i) {
      var o = Yb(n2, i ? null : this.group);
      return vr(e2) ? $v(e2, o, a) : n3(e2, o, a);
    }, t2.prototype._dispatchHighDown = function(e2, n2) {
      n2 && n2.length && this.api.dispatchAction({ type: e2, batch: n2 });
    }, t2.prototype.dispose = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, t2.prototype.remove = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, t2.type = "visualMap.continuous", t2;
  }(YZ);
  function J$(r2, t2, e2, n2) {
    return new gf({ shape: { points: r2 }, draggable: !!e2, cursor: t2, drift: e2, onmousemove: function(a) {
      Mg(a.event);
    }, ondragend: n2 });
  }
  function xEe(r2, t2, e2) {
    var n2 = mEe / 2, a = r2.get("hoverLinkDataSize");
    return a && (n2 = zd(a, t2, e2, true) / 2), n2;
  }
  function Q$(r2) {
    var t2 = r2.get("hoverLinkOnHandle");
    return !!(t2 == null ? r2.get("realtime") : t2);
  }
  function eG(r2) {
    return r2 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var wEe = _Ee, SEe = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, CEe = function(r2, t2) {
    t2.eachComponent({ mainType: "visualMap", query: r2 }, function(e2) {
      e2.setSelected(r2.selected);
    });
  }, EEe = [{ createOnAllSeries: true, reset: function(r2, t2) {
    var e2 = [];
    return t2.eachComponent("visualMap", function(n2) {
      var a = r2.pipelineContext;
      !n2.isTargetSeries(r2) || a && a.large || e2.push(b2e(n2.stateList, n2.targetVisuals, en(n2.getValueState, n2), n2.getDataDimensionIndex(r2.getData())));
    }), e2;
  } }, { createOnAllSeries: true, reset: function(r2, t2) {
    var e2 = r2.getData(), n2 = [];
    t2.eachComponent("visualMap", function(a) {
      if (a.isTargetSeries(r2)) {
        var i = a.getVisualMeta(en(AEe, null, r2, a)) || { stops: [], outerColors: [] }, o = a.getDataDimensionIndex(e2);
        o >= 0 && (i.dimension = o, n2.push(i));
      }
    }), r2.getData().setVisual("visualMeta", n2);
  } }];
  function AEe(r2, t2, e2, n2) {
    for (var a = t2.targetVisuals[n2], i = Vl.prepareVisualTypes(a), o = { color: NE(r2.getData(), "color") }, s = 0, u = i.length; s < u; s++) {
      var l2 = i[s], c2 = a[l2 === "opacity" ? "__alphaForOpacity" : l2];
      c2 && c2.applyVisual(e2, f2, h);
    }
    return o.color;
    function f2(v9) {
      return o[v9];
    }
    function h(v9, d2) {
      o[v9] = d2;
    }
  }
  var tG = ae;
  function TEe(r2) {
    var t2 = r2 && r2.visualMap;
    vr(t2) || (t2 = t2 ? [t2] : []), tG(t2, function(e2) {
      if (!!e2) {
        Dx(e2, "splitList") && !Dx(e2, "pieces") && (e2.pieces = e2.splitList, delete e2.splitList);
        var n2 = e2.pieces;
        n2 && vr(n2) && tG(n2, function(a) {
          Tn(a) && (Dx(a, "start") && !Dx(a, "min") && (a.min = a.start), Dx(a, "end") && !Dx(a, "max") && (a.max = a.end));
        });
      }
    });
  }
  function Dx(r2, t2) {
    return r2 && r2.hasOwnProperty && r2.hasOwnProperty(t2);
  }
  var rG = false;
  function ZZ(r2) {
    rG || (rG = true, r2.registerSubTypeDefaulter("visualMap", function(t2) {
      return !t2.categories && (!(t2.pieces ? t2.pieces.length > 0 : t2.splitNumber > 0) || t2.calculable) ? "continuous" : "piecewise";
    }), r2.registerAction(SEe, CEe), ae(EEe, function(t2) {
      r2.registerVisual(r2.PRIORITY.VISUAL.COMPONENT, t2);
    }), r2.registerPreprocessor(TEe));
  }
  function XZ(r2) {
    r2.registerComponentModel(pEe), r2.registerComponentView(wEe), ZZ(r2);
  }
  var MEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2._pieceList = [], e2;
    }
    return t2.prototype.optionUpdated = function(e2, n2) {
      r2.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
      var a = this._mode = this._determineMode();
      this._pieceList = [], PEe[this._mode].call(this, this._pieceList), this._resetSelected(e2, n2);
      var i = this.option.categories;
      this.resetVisual(function(o, s) {
        a === "categories" ? (o.mappingMethod = "category", o.categories = On(i)) : (o.dataExtent = this.getExtent(), o.mappingMethod = "piecewise", o.pieceList = pr(this._pieceList, function(u) {
          return u = On(u), s !== "inRange" && (u.visual = null), u;
        }));
      });
    }, t2.prototype.completeVisualOption = function() {
      var e2 = this.option, n2 = {}, a = Vl.listVisualTypes(), i = this.isCategory();
      ae(e2.pieces, function(s) {
        ae(a, function(u) {
          s.hasOwnProperty(u) && (n2[u] = 1);
        });
      }), ae(n2, function(s, u) {
        var l2 = false;
        ae(this.stateList, function(c2) {
          l2 = l2 || o(e2, c2, u) || o(e2.target, c2, u);
        }, this), !l2 && ae(this.stateList, function(c2) {
          (e2[c2] || (e2[c2] = {}))[u] = qZ.get(u, c2 === "inRange" ? "active" : "inactive", i);
        });
      }, this);
      function o(s, u, l2) {
        return s && s[u] && s[u].hasOwnProperty(l2);
      }
      r2.prototype.completeVisualOption.apply(this, arguments);
    }, t2.prototype._resetSelected = function(e2, n2) {
      var a = this.option, i = this._pieceList, o = (n2 ? a : e2).selected || {};
      if (a.selected = o, ae(i, function(u, l2) {
        var c2 = this.getSelectedMapKey(u);
        o.hasOwnProperty(c2) || (o[c2] = true);
      }, this), a.selectedMode === "single") {
        var s = false;
        ae(i, function(u, l2) {
          var c2 = this.getSelectedMapKey(u);
          o[c2] && (s ? o[c2] = false : s = true);
        }, this);
      }
    }, t2.prototype.getItemSymbol = function() {
      return this.get("itemSymbol");
    }, t2.prototype.getSelectedMapKey = function(e2) {
      return this._mode === "categories" ? e2.value + "" : e2.index + "";
    }, t2.prototype.getPieceList = function() {
      return this._pieceList;
    }, t2.prototype._determineMode = function() {
      var e2 = this.option;
      return e2.pieces && e2.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
    }, t2.prototype.setSelected = function(e2) {
      this.option.selected = On(e2);
    }, t2.prototype.getValueState = function(e2) {
      var n2 = Vl.findPieceIndex(e2, this._pieceList);
      return n2 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[n2])] ? "inRange" : "outOfRange";
    }, t2.prototype.findTargetDataIndices = function(e2) {
      var n2 = [], a = this._pieceList;
      return this.eachTargetSeries(function(i) {
        var o = [], s = i.getData();
        s.each(this.getDataDimensionIndex(s), function(u, l2) {
          var c2 = Vl.findPieceIndex(u, a);
          c2 === e2 && o.push(l2);
        }, this), n2.push({ seriesId: i.id, dataIndex: o });
      }, this), n2;
    }, t2.prototype.getRepresentValue = function(e2) {
      var n2;
      if (this.isCategory())
        n2 = e2.value;
      else if (e2.value != null)
        n2 = e2.value;
      else {
        var a = e2.interval || [];
        n2 = a[0] === -1 / 0 && a[1] === 1 / 0 ? 0 : (a[0] + a[1]) / 2;
      }
      return n2;
    }, t2.prototype.getVisualMeta = function(e2) {
      if (this.isCategory())
        return;
      var n2 = [], a = ["", ""], i = this;
      function o(c2, f2) {
        var h = i.getRepresentValue({ interval: c2 });
        f2 || (f2 = i.getValueState(h));
        var v9 = e2(h, f2);
        c2[0] === -1 / 0 ? a[0] = v9 : c2[1] === 1 / 0 ? a[1] = v9 : n2.push({ value: c2[0], color: v9 }, { value: c2[1], color: v9 });
      }
      var s = this._pieceList.slice();
      if (!s.length)
        s.push({ interval: [-1 / 0, 1 / 0] });
      else {
        var u = s[0].interval[0];
        u !== -1 / 0 && s.unshift({ interval: [-1 / 0, u] }), u = s[s.length - 1].interval[1], u !== 1 / 0 && s.push({ interval: [u, 1 / 0] });
      }
      var l2 = -1 / 0;
      return ae(s, function(c2) {
        var f2 = c2.interval;
        f2 && (f2[0] > l2 && o([l2, f2[0]], "outOfRange"), o(f2.slice()), l2 = f2[1]);
      }, this), { stops: n2, outerColors: a };
    }, t2.type = "visualMap.piecewise", t2.defaultOption = Ty(OP.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), t2;
  }(OP), PEe = { splitNumber: function(r2) {
    var t2 = this.option, e2 = Math.min(t2.precision, 20), n2 = this.getExtent(), a = t2.splitNumber;
    a = Math.max(parseInt(a, 10), 1), t2.splitNumber = a;
    for (var i = (n2[1] - n2[0]) / a; +i.toFixed(e2) !== i && e2 < 5; )
      e2++;
    t2.precision = e2, i = +i.toFixed(e2), t2.minOpen && r2.push({ interval: [-1 / 0, n2[0]], close: [0, 0] });
    for (var o = 0, s = n2[0]; o < a; s += i, o++) {
      var u = o === a - 1 ? n2[1] : s + i;
      r2.push({ interval: [s, u], close: [1, 1] });
    }
    t2.maxOpen && r2.push({ interval: [n2[1], 1 / 0], close: [0, 0] }), Y8(r2), ae(r2, function(l2, c2) {
      l2.index = c2, l2.text = this.formatValueText(l2.interval);
    }, this);
  }, categories: function(r2) {
    var t2 = this.option;
    ae(t2.categories, function(e2) {
      r2.push({ text: this.formatValueText(e2, true), value: e2 });
    }, this), nG(t2, r2);
  }, pieces: function(r2) {
    var t2 = this.option;
    ae(t2.pieces, function(e2, n2) {
      Tn(e2) || (e2 = { value: e2 });
      var a = { text: "", index: n2 };
      if (e2.label != null && (a.text = e2.label), e2.hasOwnProperty("value")) {
        var i = a.value = e2.value;
        a.interval = [i, i], a.close = [1, 1];
      } else {
        for (var o = a.interval = [], s = a.close = [0, 0], u = [1, 0, 1], l2 = [-1 / 0, 1 / 0], c2 = [], f2 = 0; f2 < 2; f2++) {
          for (var h = [["gte", "gt", "min"], ["lte", "lt", "max"]][f2], v9 = 0; v9 < 3 && o[f2] == null; v9++)
            o[f2] = e2[h[v9]], s[f2] = u[v9], c2[f2] = v9 === 2;
          o[f2] == null && (o[f2] = l2[f2]);
        }
        c2[0] && o[1] === 1 / 0 && (s[0] = 0), c2[1] && o[0] === -1 / 0 && (s[1] = 0), o[0] === o[1] && s[0] && s[1] && (a.value = o[0]);
      }
      a.visual = Vl.retrieveVisuals(e2), r2.push(a);
    }, this), nG(t2, r2), Y8(r2), ae(r2, function(e2) {
      var n2 = e2.close, a = [["<", "\u2264"][n2[1]], [">", "\u2265"][n2[0]]];
      e2.text = e2.text || this.formatValueText(e2.value != null ? e2.value : e2.interval, false, a);
    }, this);
  } };
  function nG(r2, t2) {
    var e2 = r2.inverse;
    (r2.orient === "vertical" ? !e2 : e2) && t2.reverse();
  }
  var DEe = MEe, IEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = t2.type, e2;
    }
    return t2.prototype.doRender = function() {
      var e2 = this.group;
      e2.removeAll();
      var n2 = this.visualMapModel, a = n2.get("textGap"), i = n2.textStyleModel, o = i.getFont(), s = i.getTextColor(), u = this._getItemAlign(), l2 = n2.itemSize, c2 = this._getViewData(), f2 = c2.endsText, h = ml(n2.get("showLabel", true), !f2);
      f2 && this._renderEndsText(e2, f2[0], l2, h, u), ae(c2.viewPieceList, function(v9) {
        var d2 = v9.piece, m2 = new Fn();
        m2.onclick = en(this._onItemClick, this, d2), this._enableHoverLink(m2, v9.indexInModelPieceList);
        var b2 = n2.getRepresentValue(d2);
        if (this._createItemSymbol(m2, b2, [0, 0, l2[0], l2[1]]), h) {
          var _ = this.visualMapModel.getValueState(b2);
          m2.add(new xi({ style: { x: u === "right" ? -a : l2[0] + a, y: l2[1] / 2, text: d2.text, verticalAlign: "middle", align: u, font: o, fill: s, opacity: _ === "outOfRange" ? 0.5 : 1 } }));
        }
        e2.add(m2);
      }, this), f2 && this._renderEndsText(e2, f2[1], l2, h, u), Kb(n2.get("orient"), e2, n2.get("itemGap")), this.renderBackground(e2), this.positionGroup(e2);
    }, t2.prototype._enableHoverLink = function(e2, n2) {
      var a = this;
      e2.on("mouseover", function() {
        return i("highlight");
      }).on("mouseout", function() {
        return i("downplay");
      });
      var i = function(o) {
        var s = a.visualMapModel;
        s.option.hoverLink && a.api.dispatchAction({ type: o, batch: B5(s.findTargetDataIndices(n2), s) });
      };
    }, t2.prototype._getItemAlign = function() {
      var e2 = this.visualMapModel, n2 = e2.option;
      if (n2.orient === "vertical")
        return KZ(e2, this.api, e2.itemSize);
      var a = n2.align;
      return (!a || a === "auto") && (a = "left"), a;
    }, t2.prototype._renderEndsText = function(e2, n2, a, i, o) {
      if (!!n2) {
        var s = new Fn(), u = this.visualMapModel.textStyleModel;
        s.add(new xi({ style: { x: i ? o === "right" ? a[0] : 0 : a[0] / 2, y: a[1] / 2, verticalAlign: "middle", align: i ? o : "center", text: n2, font: u.getFont(), fill: u.getTextColor() } })), e2.add(s);
      }
    }, t2.prototype._getViewData = function() {
      var e2 = this.visualMapModel, n2 = pr(e2.getPieceList(), function(s, u) {
        return { piece: s, indexInModelPieceList: u };
      }), a = e2.get("text"), i = e2.get("orient"), o = e2.get("inverse");
      return (i === "horizontal" ? o : !o) ? n2.reverse() : a && (a = a.slice().reverse()), { viewPieceList: n2, endsText: a };
    }, t2.prototype._createItemSymbol = function(e2, n2, a) {
      e2.add(cu(this.getControllerVisual(n2, "symbol"), a[0], a[1], a[2], a[3], this.getControllerVisual(n2, "color")));
    }, t2.prototype._onItemClick = function(e2) {
      var n2 = this.visualMapModel, a = n2.option, i = On(a.selected), o = n2.getSelectedMapKey(e2);
      a.selectedMode === "single" ? (i[o] = true, ae(i, function(s, u) {
        i[u] = u === o;
      })) : i[o] = !i[o], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: i });
    }, t2.type = "visualMap.piecewise", t2;
  }(YZ), LEe = IEe;
  function JZ(r2) {
    r2.registerComponentModel(DEe), r2.registerComponentView(LEe), ZZ(r2);
  }
  function OEe(r2) {
    ya(XZ), ya(JZ);
  }
  var kEe = { label: { enabled: true }, decal: { show: false } }, aG = fi(), REe = {};
  function FEe(r2, t2) {
    var e2 = r2.getModel("aria");
    if (!e2.get("enabled"))
      return;
    var n2 = On(kEe);
    ea(n2.label, r2.getLocaleModel().get("aria"), false), ea(e2.option, n2, false), a(), i();
    function a() {
      var l2 = e2.getModel("decal"), c2 = l2.get("show");
      if (c2) {
        var f2 = mn();
        r2.eachSeries(function(h) {
          if (!h.isColorBySeries()) {
            var v9 = f2.get(h.type);
            v9 || (v9 = {}, f2.set(h.type, v9)), aG(h).scope = v9;
          }
        }), r2.eachRawSeries(function(h) {
          if (r2.isSeriesFiltered(h))
            return;
          if (xn(h.enableAriaDecal)) {
            h.enableAriaDecal();
            return;
          }
          var v9 = h.getData();
          if (h.isColorBySeries()) {
            var C = d4(h.ecModel, h.name, REe, r2.getSeriesCount()), M = v9.getVisual("decal");
            v9.setVisual("decal", E(M, C));
          } else {
            var d2 = h.getRawData(), m2 = {}, b2 = aG(h).scope;
            v9.each(function(z9) {
              var V = v9.getRawIndex(z9);
              m2[V] = z9;
            });
            var _ = d2.count();
            d2.each(function(z9) {
              var V = m2[z9], $ = d2.getName(z9) || z9 + "", U = d4(h.ecModel, $, b2, _), H = v9.getItemVisual(V, "decal");
              v9.setItemVisual(V, "decal", E(H, U));
            });
          }
          function E(z9, V) {
            var $ = z9 ? qt(qt({}, V), z9) : V;
            return $.dirty = true, $;
          }
        });
      }
    }
    function i() {
      var l2 = r2.getLocaleModel().get("aria"), c2 = e2.getModel("label");
      if (c2.option = En(c2.option, l2), !!c2.get("enabled")) {
        var f2 = t2.getZr().dom;
        if (c2.get("description")) {
          f2.setAttribute("aria-label", c2.get("description"));
          return;
        }
        var h = r2.getSeriesCount(), v9 = c2.get(["data", "maxCount"]) || 10, d2 = c2.get(["series", "maxCount"]) || 10, m2 = Math.min(h, d2), b2;
        if (!(h < 1)) {
          var _ = s();
          if (_) {
            var C = c2.get(["general", "withTitle"]);
            b2 = o(C, { title: _ });
          } else
            b2 = c2.get(["general", "withoutTitle"]);
          var M = [], E = h > 1 ? c2.get(["series", "multiple", "prefix"]) : c2.get(["series", "single", "prefix"]);
          b2 += o(E, { seriesCount: h }), r2.eachSeries(function(U, H) {
            if (H < m2) {
              var q3 = void 0, ee = U.get("name"), oe = ee ? "withName" : "withoutName";
              q3 = h > 1 ? c2.get(["series", "multiple", oe]) : c2.get(["series", "single", oe]), q3 = o(q3, { seriesId: U.seriesIndex, seriesName: U.get("name"), seriesType: u(U.subType) });
              var ne = U.getData();
              if (ne.count() > v9) {
                var be = c2.get(["data", "partialData"]);
                q3 += o(be, { displayCnt: v9 });
              } else
                q3 += c2.get(["data", "allData"]);
              for (var Ee = c2.get(["data", "separator", "middle"]), ye = c2.get(["data", "separator", "end"]), et = [], Le = 0; Le < ne.count(); Le++)
                if (Le < v9) {
                  var Fe = ne.getName(Le), qe = ne.getValues(Le), st = c2.get(["data", Fe ? "withName" : "withoutName"]);
                  et.push(o(st, { name: Fe, value: qe.join(Ee) }));
                }
              q3 += et.join(Ee) + ye, M.push(q3);
            }
          });
          var z9 = c2.getModel(["series", "multiple", "separator"]), V = z9.get("middle"), $ = z9.get("end");
          b2 += M.join(V) + $, f2.setAttribute("aria-label", b2);
        }
      }
    }
    function o(l2, c2) {
      if (!Zr(l2))
        return l2;
      var f2 = l2;
      return ae(c2, function(h, v9) {
        f2 = f2.replace(new RegExp("\\{\\s*" + v9 + "\\s*\\}", "g"), h);
      }), f2;
    }
    function s() {
      var l2 = r2.get("title");
      return l2 && l2.length && (l2 = l2[0]), l2 && l2.text;
    }
    function u(l2) {
      return r2.getLocaleModel().get(["series", "typeNames"])[l2] || "\u81EA\u5B9A\u4E49\u56FE";
    }
  }
  function NEe(r2) {
    if (!(!r2 || !r2.aria)) {
      var t2 = r2.aria;
      t2.show != null && (t2.enabled = t2.show), t2.label = t2.label || {}, ae(["description", "general", "series", "data"], function(e2) {
        t2[e2] != null && (t2.label[e2] = t2[e2]);
      });
    }
  }
  function VEe(r2) {
    r2.registerPreprocessor(NEe), r2.registerVisual(r2.PRIORITY.VISUAL.ARIA, FEe);
  }
  var iG = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, jEe = function() {
    function r2(t2) {
      var e2 = this._condVal = Zr(t2) ? new RegExp(t2) : yae(t2) ? t2 : null;
      if (e2 == null) {
        var n2 = "";
        Ii(n2);
      }
    }
    return r2.prototype.evaluate = function(t2) {
      var e2 = typeof t2;
      return Zr(e2) ? this._condVal.test(t2) : Ai(e2) ? this._condVal.test(t2 + "") : false;
    }, r2;
  }(), BEe = function() {
    function r2() {
    }
    return r2.prototype.evaluate = function() {
      return this.value;
    }, r2;
  }(), zEe = function() {
    function r2() {
    }
    return r2.prototype.evaluate = function() {
      for (var t2 = this.children, e2 = 0; e2 < t2.length; e2++)
        if (!t2[e2].evaluate())
          return false;
      return true;
    }, r2;
  }(), $Ee = function() {
    function r2() {
    }
    return r2.prototype.evaluate = function() {
      for (var t2 = this.children, e2 = 0; e2 < t2.length; e2++)
        if (t2[e2].evaluate())
          return true;
      return false;
    }, r2;
  }(), GEe = function() {
    function r2() {
    }
    return r2.prototype.evaluate = function() {
      return !this.child.evaluate();
    }, r2;
  }(), WEe = function() {
    function r2() {
    }
    return r2.prototype.evaluate = function() {
      for (var t2 = !!this.valueParser, e2 = this.getValue, n2 = e2(this.valueGetterParam), a = t2 ? this.valueParser(n2) : null, i = 0; i < this.subCondList.length; i++)
        if (!this.subCondList[i].evaluate(t2 ? a : n2))
          return false;
      return true;
    }, r2;
  }();
  function FN(r2, t2) {
    if (r2 === true || r2 === false) {
      var e2 = new BEe();
      return e2.value = r2, e2;
    }
    var n2 = "";
    return QZ(r2) || Ii(n2), r2.and ? oG("and", r2, t2) : r2.or ? oG("or", r2, t2) : r2.not ? UEe(r2, t2) : HEe(r2, t2);
  }
  function oG(r2, t2, e2) {
    var n2 = t2[r2], a = "";
    vr(n2) || Ii(a), n2.length || Ii(a);
    var i = r2 === "and" ? new zEe() : new $Ee();
    return i.children = pr(n2, function(o) {
      return FN(o, e2);
    }), i.children.length || Ii(a), i;
  }
  function UEe(r2, t2) {
    var e2 = r2.not, n2 = "";
    QZ(e2) || Ii(n2);
    var a = new GEe();
    return a.child = FN(e2, t2), a.child || Ii(n2), a;
  }
  function HEe(r2, t2) {
    for (var e2 = "", n2 = t2.prepareGetValue(r2), a = [], i = ja(r2), o = r2.parser, s = o ? PH(o) : null, u = 0; u < i.length; u++) {
      var l2 = i[u];
      if (!(l2 === "parser" || t2.valueGetterAttrMap.get(l2))) {
        var c2 = sn(iG, l2) ? iG[l2] : l2, f2 = r2[l2], h = s ? s(f2) : f2, v9 = Cle(c2, h) || c2 === "reg" && new jEe(h);
        v9 || Ii(e2), a.push(v9);
      }
    }
    a.length || Ii(e2);
    var d2 = new WEe();
    return d2.valueGetterParam = n2, d2.valueParser = s, d2.getValue = t2.getValue, d2.subCondList = a, d2;
  }
  function QZ(r2) {
    return Tn(r2) && !lc(r2);
  }
  var qEe = function() {
    function r2(t2, e2) {
      this._cond = FN(t2, e2);
    }
    return r2.prototype.evaluate = function() {
      return this._cond.evaluate();
    }, r2;
  }();
  function YEe(r2, t2) {
    return new qEe(r2, t2);
  }
  var KEe = { type: "echarts:filter", transform: function(r2) {
    for (var t2 = r2.upstream, e2, n2 = YEe(r2.config, { valueGetterAttrMap: mn({ dimension: true }), prepareGetValue: function(s) {
      var u = "", l2 = s.dimension;
      sn(s, "dimension") || Ii(u);
      var c2 = t2.getDimensionInfo(l2);
      return c2 || Ii(u), { dimIdx: c2.index };
    }, getValue: function(s) {
      return t2.retrieveValueFromItem(e2, s.dimIdx);
    } }), a = [], i = 0, o = t2.count(); i < o; i++)
      e2 = t2.getRawDataItem(i), n2.evaluate() && a.push(e2);
    return { data: a };
  } }, ZEe = { type: "echarts:sort", transform: function(r2) {
    var t2 = r2.upstream, e2 = r2.config, n2 = "", a = ao(e2);
    a.length || Ii(n2);
    var i = [];
    ae(a, function(c2) {
      var f2 = c2.dimension, h = c2.order, v9 = c2.parser, d2 = c2.incomparable;
      if (f2 == null && Ii(n2), h !== "asc" && h !== "desc" && Ii(n2), d2 && d2 !== "min" && d2 !== "max") {
        var m2 = "";
        Ii(m2);
      }
      if (h !== "asc" && h !== "desc") {
        var b2 = "";
        Ii(b2);
      }
      var _ = t2.getDimensionInfo(f2);
      _ || Ii(n2);
      var C = v9 ? PH(v9) : null;
      v9 && !C && Ii(n2), i.push({ dimIdx: _.index, parser: C, comparator: new IH(h, d2) });
    });
    var o = t2.sourceFormat;
    o !== cc && o !== Zh && Ii(n2);
    for (var s = [], u = 0, l2 = t2.count(); u < l2; u++)
      s.push(t2.getRawDataItem(u));
    return s.sort(function(c2, f2) {
      for (var h = 0; h < i.length; h++) {
        var v9 = i[h], d2 = t2.retrieveValueFromItem(c2, v9.dimIdx), m2 = t2.retrieveValueFromItem(f2, v9.dimIdx);
        v9.parser && (d2 = v9.parser(d2), m2 = v9.parser(m2));
        var b2 = v9.comparator.evaluate(d2, m2);
        if (b2 !== 0)
          return b2;
      }
      return 0;
    }), { data: s };
  } };
  function XEe(r2) {
    r2.registerTransform(KEe), r2.registerTransform(ZEe);
  }
  var JEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "dataset", e2;
    }
    return t2.prototype.init = function(e2, n2, a) {
      r2.prototype.init.call(this, e2, n2, a), this._sourceManager = new RH(this), uV(this);
    }, t2.prototype.mergeOption = function(e2, n2) {
      r2.prototype.mergeOption.call(this, e2, n2), uV(this);
    }, t2.prototype.optionUpdated = function() {
      this._sourceManager.dirty();
    }, t2.prototype.getSourceManager = function() {
      return this._sourceManager;
    }, t2.type = "dataset", t2.defaultOption = { seriesLayoutBy: Xd }, t2;
  }(li), QEe = function(r2) {
    ot(t2, r2);
    function t2() {
      var e2 = r2 !== null && r2.apply(this, arguments) || this;
      return e2.type = "dataset", e2;
    }
    return t2.type = "dataset", t2;
  }(gs);
  function eAe(r2) {
    r2.registerComponentModel(JEe), r2.registerComponentView(QEe);
  }
  var jd = np.CMD;
  function Ux(r2, t2) {
    return Math.abs(r2 - t2) < 1e-5;
  }
  function h6(r2) {
    var t2 = r2.data, e2 = r2.len(), n2 = [], a, i = 0, o = 0, s = 0, u = 0;
    function l2(ne, be) {
      a && a.length > 2 && n2.push(a), a = [ne, be];
    }
    function c2(ne, be, Ee, ye) {
      Ux(ne, Ee) && Ux(be, ye) || a.push(ne, be, Ee, ye, Ee, ye);
    }
    function f2(ne, be, Ee, ye, et, Le) {
      var Fe = Math.abs(be - ne), qe = Math.tan(Fe / 4) * 4 / 3, st = be < ne ? -1 : 1, dt = Math.cos(ne), Ar = Math.sin(ne), Hr = Math.cos(be), hn = Math.sin(be), cn = dt * et + Ee, nn = Ar * Le + ye, Wr = Hr * et + Ee, on = hn * Le + ye, un = et * qe * st, Xr = Le * qe * st;
      a.push(cn - un * Ar, nn + Xr * dt, Wr + un * hn, on - Xr * Hr, Wr, on);
    }
    for (var h, v9, d2, m2, b2 = 0; b2 < e2; ) {
      var _ = t2[b2++], C = b2 === 1;
      switch (C && (i = t2[b2], o = t2[b2 + 1], s = i, u = o, (_ === jd.L || _ === jd.C || _ === jd.Q) && (a = [s, u])), _) {
        case jd.M:
          i = s = t2[b2++], o = u = t2[b2++], l2(s, u);
          break;
        case jd.L:
          h = t2[b2++], v9 = t2[b2++], c2(i, o, h, v9), i = h, o = v9;
          break;
        case jd.C:
          a.push(t2[b2++], t2[b2++], t2[b2++], t2[b2++], i = t2[b2++], o = t2[b2++]);
          break;
        case jd.Q:
          h = t2[b2++], v9 = t2[b2++], d2 = t2[b2++], m2 = t2[b2++], a.push(i + 2 / 3 * (h - i), o + 2 / 3 * (v9 - o), d2 + 2 / 3 * (h - d2), m2 + 2 / 3 * (v9 - m2), d2, m2), i = d2, o = m2;
          break;
        case jd.A:
          var M = t2[b2++], E = t2[b2++], z9 = t2[b2++], V = t2[b2++], $ = t2[b2++], U = t2[b2++] + $;
          b2 += 1;
          var H = !t2[b2++];
          h = Math.cos($) * z9 + M, v9 = Math.sin($) * V + E, C ? (s = h, u = v9, l2(s, u)) : c2(i, o, h, v9), i = Math.cos(U) * z9 + M, o = Math.sin(U) * V + E;
          for (var q3 = (H ? -1 : 1) * Math.PI / 2, ee = $; H ? ee > U : ee < U; ee += q3) {
            var oe = H ? Math.max(ee + q3, U) : Math.min(ee + q3, U);
            f2(ee, oe, M, E, z9, V);
          }
          break;
        case jd.R:
          s = i = t2[b2++], u = o = t2[b2++], h = s + t2[b2++], v9 = u + t2[b2++], l2(h, u), c2(h, u, h, v9), c2(h, v9, s, v9), c2(s, v9, s, u), c2(s, u, h, u);
          break;
        case jd.Z:
          a && c2(i, o, s, u), i = s, o = u;
          break;
      }
    }
    return a && a.length > 2 && n2.push(a), n2;
  }
  function v6(r2, t2, e2, n2, a, i, o, s, u, l2) {
    if (Ux(r2, e2) && Ux(t2, n2) && Ux(a, o) && Ux(i, s)) {
      u.push(o, s);
      return;
    }
    var c2 = 2 / l2, f2 = c2 * c2, h = o - r2, v9 = s - t2, d2 = Math.sqrt(h * h + v9 * v9);
    h /= d2, v9 /= d2;
    var m2 = e2 - r2, b2 = n2 - t2, _ = a - o, C = i - s, M = m2 * m2 + b2 * b2, E = _ * _ + C * C;
    if (M < f2 && E < f2) {
      u.push(o, s);
      return;
    }
    var z9 = h * m2 + v9 * b2, V = -h * _ - v9 * C, $ = M - z9 * z9, U = E - V * V;
    if ($ < f2 && z9 >= 0 && U < f2 && V >= 0) {
      u.push(o, s);
      return;
    }
    var H = [], q3 = [];
    yy(r2, e2, a, o, 0.5, H), yy(t2, n2, i, s, 0.5, q3), v6(H[0], q3[0], H[1], q3[1], H[2], q3[2], H[3], q3[3], u, l2), v6(H[4], q3[4], H[5], q3[5], H[6], q3[6], H[7], q3[7], u, l2);
  }
  function tAe(r2, t2) {
    var e2 = h6(r2), n2 = [];
    t2 = t2 || 1;
    for (var a = 0; a < e2.length; a++) {
      var i = e2[a], o = [], s = i[0], u = i[1];
      o.push(s, u);
      for (var l2 = 2; l2 < i.length; ) {
        var c2 = i[l2++], f2 = i[l2++], h = i[l2++], v9 = i[l2++], d2 = i[l2++], m2 = i[l2++];
        v6(s, u, c2, f2, h, v9, d2, m2, o, t2), s = d2, u = m2;
      }
      n2.push(o);
    }
    return n2;
  }
  function eX(r2, t2, e2) {
    var n2 = r2[t2], a = r2[1 - t2], i = Math.abs(n2 / a), o = Math.ceil(Math.sqrt(i * e2)), s = Math.floor(e2 / o);
    s === 0 && (s = 1, o = e2);
    for (var u = [], l2 = 0; l2 < o; l2++)
      u.push(s);
    var c2 = o * s, f2 = e2 - c2;
    if (f2 > 0)
      for (var l2 = 0; l2 < f2; l2++)
        u[l2 % o] += 1;
    return u;
  }
  function sG(r2, t2, e2) {
    for (var n2 = r2.r0, a = r2.r, i = r2.startAngle, o = r2.endAngle, s = Math.abs(o - i), u = s * a, l2 = a - n2, c2 = u > Math.abs(l2), f2 = eX([u, l2], c2 ? 0 : 1, t2), h = (c2 ? s : l2) / f2.length, v9 = 0; v9 < f2.length; v9++)
      for (var d2 = (c2 ? l2 : s) / f2[v9], m2 = 0; m2 < f2[v9]; m2++) {
        var b2 = {};
        c2 ? (b2.startAngle = i + h * v9, b2.endAngle = i + h * (v9 + 1), b2.r0 = n2 + d2 * m2, b2.r = n2 + d2 * (m2 + 1)) : (b2.startAngle = i + d2 * m2, b2.endAngle = i + d2 * (m2 + 1), b2.r0 = n2 + h * v9, b2.r = n2 + h * (v9 + 1)), b2.clockwise = r2.clockwise, b2.cx = r2.cx, b2.cy = r2.cy, e2.push(b2);
      }
  }
  function rAe(r2, t2, e2) {
    for (var n2 = r2.width, a = r2.height, i = n2 > a, o = eX([n2, a], i ? 0 : 1, t2), s = i ? "width" : "height", u = i ? "height" : "width", l2 = i ? "x" : "y", c2 = i ? "y" : "x", f2 = r2[s] / o.length, h = 0; h < o.length; h++)
      for (var v9 = r2[u] / o[h], d2 = 0; d2 < o[h]; d2++) {
        var m2 = {};
        m2[l2] = h * f2, m2[c2] = d2 * v9, m2[s] = f2, m2[u] = v9, m2.x += r2.x, m2.y += r2.y, e2.push(m2);
      }
  }
  function uG(r2, t2, e2, n2) {
    return r2 * n2 - e2 * t2;
  }
  function nAe(r2, t2, e2, n2, a, i, o, s) {
    var u = e2 - r2, l2 = n2 - t2, c2 = o - a, f2 = s - i, h = uG(c2, f2, u, l2);
    if (Math.abs(h) < 1e-6)
      return null;
    var v9 = r2 - a, d2 = t2 - i, m2 = uG(v9, d2, c2, f2) / h;
    return m2 < 0 || m2 > 1 ? null : new Jn(m2 * u + r2, m2 * l2 + t2);
  }
  function aAe(r2, t2, e2) {
    var n2 = new Jn();
    Jn.sub(n2, e2, t2), n2.normalize();
    var a = new Jn();
    Jn.sub(a, r2, t2);
    var i = a.dot(n2);
    return i;
  }
  function Ix(r2, t2) {
    var e2 = r2[r2.length - 1];
    e2 && e2[0] === t2[0] && e2[1] === t2[1] || r2.push(t2);
  }
  function iAe(r2, t2, e2) {
    for (var n2 = r2.length, a = [], i = 0; i < n2; i++) {
      var o = r2[i], s = r2[(i + 1) % n2], u = nAe(o[0], o[1], s[0], s[1], t2.x, t2.y, e2.x, e2.y);
      u && a.push({ projPt: aAe(u, t2, e2), pt: u, idx: i });
    }
    if (a.length < 2)
      return [{ points: r2 }, { points: r2 }];
    a.sort(function(b2, _) {
      return b2.projPt - _.projPt;
    });
    var l2 = a[0], c2 = a[a.length - 1];
    if (c2.idx < l2.idx) {
      var f2 = l2;
      l2 = c2, c2 = f2;
    }
    for (var h = [l2.pt.x, l2.pt.y], v9 = [c2.pt.x, c2.pt.y], d2 = [h], m2 = [v9], i = l2.idx + 1; i <= c2.idx; i++)
      Ix(d2, r2[i].slice());
    Ix(d2, v9), Ix(d2, h);
    for (var i = c2.idx + 1; i <= l2.idx + n2; i++)
      Ix(m2, r2[i % n2].slice());
    return Ix(m2, h), Ix(m2, v9), [{ points: d2 }, { points: m2 }];
  }
  function lG(r2) {
    var t2 = r2.points, e2 = [], n2 = [];
    XP(t2, e2, n2);
    var a = new da(e2[0], e2[1], n2[0] - e2[0], n2[1] - e2[1]), i = a.width, o = a.height, s = a.x, u = a.y, l2 = new Jn(), c2 = new Jn();
    return i > o ? (l2.x = c2.x = s + i / 2, l2.y = u, c2.y = u + o) : (l2.y = c2.y = u + o / 2, l2.x = s, c2.x = s + i), iAe(t2, l2, c2);
  }
  function kP(r2, t2, e2, n2) {
    if (e2 === 1)
      n2.push(t2);
    else {
      var a = Math.floor(e2 / 2), i = r2(t2);
      kP(r2, i[0], a, n2), kP(r2, i[1], e2 - a, n2);
    }
    return n2;
  }
  function oAe(r2, t2) {
    for (var e2 = [], n2 = 0; n2 < t2; n2++)
      e2.push(tF(r2));
    return e2;
  }
  function sAe(r2, t2) {
    t2.setStyle(r2.style), t2.z = r2.z, t2.z2 = r2.z2, t2.zlevel = r2.zlevel;
  }
  function uAe(r2) {
    for (var t2 = [], e2 = 0; e2 < r2.length; )
      t2.push([r2[e2++], r2[e2++]]);
    return t2;
  }
  function lAe(r2, t2) {
    var e2 = [], n2 = r2.shape, a;
    switch (r2.type) {
      case "rect":
        rAe(n2, t2, e2), a = ni;
        break;
      case "sector":
        sG(n2, t2, e2), a = pf;
        break;
      case "circle":
        sG({ r0: 0, r: n2.r, startAngle: 0, endAngle: Math.PI * 2, cx: n2.cx, cy: n2.cy }, t2, e2), a = pf;
        break;
      default:
        var i = r2.getComputedTransform(), o = i ? Math.sqrt(Math.max(i[0] * i[0] + i[1] * i[1], i[2] * i[2] + i[3] * i[3])) : 1, s = pr(tAe(r2.getUpdatedPathProxy(), o), function(_) {
          return uAe(_);
        }), u = s.length;
        if (u === 0)
          kP(lG, { points: s[0] }, t2, e2);
        else if (u === t2)
          for (var l2 = 0; l2 < u; l2++)
            e2.push({ points: s[l2] });
        else {
          var c2 = 0, f2 = pr(s, function(_) {
            var C = [], M = [];
            XP(_, C, M);
            var E = (M[1] - C[1]) * (M[0] - C[0]);
            return c2 += E, { poly: _, area: E };
          });
          f2.sort(function(_, C) {
            return C.area - _.area;
          });
          for (var h = t2, l2 = 0; l2 < u; l2++) {
            var v9 = f2[l2];
            if (h <= 0)
              break;
            var d2 = l2 === u - 1 ? h : Math.ceil(v9.area / c2 * t2);
            d2 < 0 || (kP(lG, { points: v9.poly }, d2, e2), h -= d2);
          }
        }
        a = gf;
        break;
    }
    if (!a)
      return oAe(r2, t2);
    for (var m2 = [], l2 = 0; l2 < e2.length; l2++) {
      var b2 = new a();
      b2.setShape(e2[l2]), sAe(r2, b2), m2.push(b2);
    }
    return m2;
  }
  function cAe(r2, t2) {
    var e2 = r2.length, n2 = t2.length;
    if (e2 === n2)
      return [r2, t2];
    for (var a = [], i = [], o = e2 < n2 ? r2 : t2, s = Math.min(e2, n2), u = Math.abs(n2 - e2) / 6, l2 = (s - 2) / 6, c2 = Math.ceil(u / l2) + 1, f2 = [o[0], o[1]], h = u, v9 = 2; v9 < s; ) {
      var d2 = o[v9 - 2], m2 = o[v9 - 1], b2 = o[v9++], _ = o[v9++], C = o[v9++], M = o[v9++], E = o[v9++], z9 = o[v9++];
      if (h <= 0) {
        f2.push(b2, _, C, M, E, z9);
        continue;
      }
      for (var V = Math.min(h, c2 - 1) + 1, $ = 1; $ <= V; $++) {
        var U = $ / V;
        yy(d2, b2, C, E, U, a), yy(m2, _, M, z9, U, i), d2 = a[3], m2 = i[3], f2.push(a[1], i[1], a[2], i[2], d2, m2), b2 = a[5], _ = i[5], C = a[6], M = i[6];
      }
      h -= V - 1;
    }
    return o === r2 ? [f2, t2] : [r2, f2];
  }
  function cG(r2, t2) {
    for (var e2 = r2.length, n2 = r2[e2 - 2], a = r2[e2 - 1], i = [], o = 0; o < t2.length; )
      i[o++] = n2, i[o++] = a;
    return i;
  }
  function fAe(r2, t2) {
    for (var e2, n2, a, i = [], o = [], s = 0; s < Math.max(r2.length, t2.length); s++) {
      var u = r2[s], l2 = t2[s], c2 = void 0, f2 = void 0;
      u ? l2 ? (e2 = cAe(u, l2), c2 = e2[0], f2 = e2[1], n2 = c2, a = f2) : (f2 = cG(a || u, u), c2 = u) : (c2 = cG(n2 || l2, l2), f2 = l2), i.push(c2), o.push(f2);
    }
    return [i, o];
  }
  function fG(r2) {
    for (var t2 = 0, e2 = 0, n2 = 0, a = r2.length, i = 0, o = a - 2; i < a; o = i, i += 2) {
      var s = r2[o], u = r2[o + 1], l2 = r2[i], c2 = r2[i + 1], f2 = s * c2 - l2 * u;
      t2 += f2, e2 += (s + l2) * f2, n2 += (u + c2) * f2;
    }
    return t2 === 0 ? [r2[0] || 0, r2[1] || 0] : [e2 / t2 / 3, n2 / t2 / 3, t2];
  }
  function hAe(r2, t2, e2, n2) {
    for (var a = (r2.length - 2) / 6, i = 1 / 0, o = 0, s = r2.length, u = s - 2, l2 = 0; l2 < a; l2++) {
      for (var c2 = l2 * 6, f2 = 0, h = 0; h < s; h += 2) {
        var v9 = h === 0 ? c2 : (c2 + h - 2) % u + 2, d2 = r2[v9] - e2[0], m2 = r2[v9 + 1] - e2[1], b2 = t2[h] - n2[0], _ = t2[h + 1] - n2[1], C = b2 - d2, M = _ - m2;
        f2 += C * C + M * M;
      }
      f2 < i && (i = f2, o = l2);
    }
    return o;
  }
  function vAe(r2) {
    for (var t2 = [], e2 = r2.length, n2 = 0; n2 < e2; n2 += 2)
      t2[n2] = r2[e2 - n2 - 2], t2[n2 + 1] = r2[e2 - n2 - 1];
    return t2;
  }
  function dAe(r2, t2, e2, n2) {
    for (var a = [], i, o = 0; o < r2.length; o++) {
      var s = r2[o], u = t2[o], l2 = fG(s), c2 = fG(u);
      i == null && (i = l2[2] < 0 != c2[2] < 0);
      var f2 = [], h = [], v9 = 0, d2 = 1 / 0, m2 = [], b2 = s.length;
      i && (s = vAe(s));
      for (var _ = hAe(s, u, l2, c2) * 6, C = b2 - 2, M = 0; M < C; M += 2) {
        var E = (_ + M) % C + 2;
        f2[M + 2] = s[E] - l2[0], f2[M + 3] = s[E + 1] - l2[1];
      }
      if (f2[0] = s[_] - l2[0], f2[1] = s[_ + 1] - l2[1], e2 > 0)
        for (var z9 = n2 / e2, V = -n2 / 2; V <= n2 / 2; V += z9) {
          for (var $ = Math.sin(V), U = Math.cos(V), H = 0, M = 0; M < s.length; M += 2) {
            var q3 = f2[M], ee = f2[M + 1], oe = u[M] - c2[0], ne = u[M + 1] - c2[1], be = oe * U - ne * $, Ee = oe * $ + ne * U;
            m2[M] = be, m2[M + 1] = Ee;
            var ye = be - q3, et = Ee - ee;
            H += ye * ye + et * et;
          }
          if (H < d2) {
            d2 = H, v9 = V;
            for (var Le = 0; Le < m2.length; Le++)
              h[Le] = m2[Le];
          }
        }
      else
        for (var Fe = 0; Fe < b2; Fe += 2)
          h[Fe] = u[Fe] - c2[0], h[Fe + 1] = u[Fe + 1] - c2[1];
      a.push({ from: f2, to: h, fromCp: l2, toCp: c2, rotation: -v9 });
    }
    return a;
  }
  function RP(r2) {
    return r2.__isCombineMorphing;
  }
  var tX = "__mOriginal_";
  function FP(r2, t2, e2) {
    var n2 = tX + t2, a = r2[n2] || r2[t2];
    r2[n2] || (r2[n2] = r2[t2]);
    var i = e2.replace, o = e2.after, s = e2.before;
    r2[t2] = function() {
      var u = arguments, l2;
      return s && s.apply(this, u), i ? l2 = i.apply(this, u) : l2 = a.apply(this, u), o && o.apply(this, u), l2;
    };
  }
  function HC(r2, t2) {
    var e2 = tX + t2;
    r2[e2] && (r2[t2] = r2[e2], r2[e2] = null);
  }
  function hG(r2, t2) {
    for (var e2 = 0; e2 < r2.length; e2++)
      for (var n2 = r2[e2], a = 0; a < n2.length; ) {
        var i = n2[a], o = n2[a + 1];
        n2[a++] = t2[0] * i + t2[2] * o + t2[4], n2[a++] = t2[1] * i + t2[3] * o + t2[5];
      }
  }
  function rX(r2, t2) {
    var e2 = r2.getUpdatedPathProxy(), n2 = t2.getUpdatedPathProxy(), a = fAe(h6(e2), h6(n2)), i = a[0], o = a[1], s = r2.getComputedTransform(), u = t2.getComputedTransform();
    function l2() {
      this.transform = null;
    }
    s && hG(i, s), u && hG(o, u), FP(t2, "updateTransform", { replace: l2 }), t2.transform = null;
    var c2 = dAe(i, o, 10, Math.PI), f2 = [];
    FP(t2, "buildPath", { replace: function(h) {
      for (var v9 = t2.__morphT, d2 = 1 - v9, m2 = [], b2 = 0; b2 < c2.length; b2++) {
        var _ = c2[b2], C = _.from, M = _.to, E = _.rotation * v9, z9 = _.fromCp, V = _.toCp, $ = Math.sin(E), U = Math.cos(E);
        w5(m2, z9, V, v9);
        for (var H = 0; H < C.length; H += 2) {
          var q3 = C[H], ee = C[H + 1], oe = M[H], ne = M[H + 1], be = q3 * d2 + oe * v9, Ee = ee * d2 + ne * v9;
          f2[H] = be * U - Ee * $ + m2[0], f2[H + 1] = be * $ + Ee * U + m2[1];
        }
        var ye = f2[0], et = f2[1];
        h.moveTo(ye, et);
        for (var H = 2; H < C.length; ) {
          var oe = f2[H++], ne = f2[H++], Le = f2[H++], Fe = f2[H++], qe = f2[H++], st = f2[H++];
          ye === oe && et === ne && Le === qe && Fe === st ? h.lineTo(qe, st) : h.bezierCurveTo(oe, ne, Le, Fe, qe, st), ye = qe, et = st;
        }
      }
    } });
  }
  function NN(r2, t2, e2) {
    if (!r2 || !t2)
      return t2;
    var n2 = e2.done, a = e2.during;
    rX(r2, t2), t2.__morphT = 0;
    function i() {
      HC(t2, "buildPath"), HC(t2, "updateTransform"), t2.__morphT = -1, t2.createPathProxy(), t2.dirtyShape();
    }
    return t2.animateTo({ __morphT: 1 }, En({ during: function(o) {
      t2.dirtyShape(), a && a(o);
    }, done: function() {
      i(), n2 && n2();
    } }, e2)), t2;
  }
  function pAe(r2, t2, e2, n2, a, i) {
    var o = 16;
    r2 = a === e2 ? 0 : Math.round(32767 * (r2 - e2) / (a - e2)), t2 = i === n2 ? 0 : Math.round(32767 * (t2 - n2) / (i - n2));
    for (var s = 0, u, l2 = (1 << o) / 2; l2 > 0; l2 /= 2) {
      var c2 = 0, f2 = 0;
      (r2 & l2) > 0 && (c2 = 1), (t2 & l2) > 0 && (f2 = 1), s += l2 * l2 * (3 * c2 ^ f2), f2 === 0 && (c2 === 1 && (r2 = l2 - 1 - r2, t2 = l2 - 1 - t2), u = r2, r2 = t2, t2 = u);
    }
    return s;
  }
  function NP(r2) {
    var t2 = 1 / 0, e2 = 1 / 0, n2 = -1 / 0, a = -1 / 0, i = pr(r2, function(s) {
      var u = s.getBoundingRect(), l2 = s.getComputedTransform(), c2 = u.x + u.width / 2 + (l2 ? l2[4] : 0), f2 = u.y + u.height / 2 + (l2 ? l2[5] : 0);
      return t2 = Math.min(c2, t2), e2 = Math.min(f2, e2), n2 = Math.max(c2, n2), a = Math.max(f2, a), [c2, f2];
    }), o = pr(i, function(s, u) {
      return { cp: s, z: pAe(s[0], s[1], t2, e2, n2, a), path: r2[u] };
    });
    return o.sort(function(s, u) {
      return s.z - u.z;
    }).map(function(s) {
      return s.path;
    });
  }
  function nX(r2) {
    return lAe(r2.path, r2.count);
  }
  function d6() {
    return { fromIndividuals: [], toIndividuals: [], count: 0 };
  }
  function gAe(r2, t2, e2) {
    var n2 = [];
    function a(z9) {
      for (var V = 0; V < z9.length; V++) {
        var $ = z9[V];
        RP($) ? a($.childrenRef()) : $ instanceof xa && n2.push($);
      }
    }
    a(r2);
    var i = n2.length;
    if (!i)
      return d6();
    var o = e2.dividePath || nX, s = o({ path: t2, count: i });
    if (s.length !== i)
      return console.error("Invalid morphing: unmatched splitted path"), d6();
    n2 = NP(n2), s = NP(s);
    for (var u = e2.done, l2 = e2.during, c2 = e2.individualDelay, f2 = new mg(), h = 0; h < i; h++) {
      var v9 = n2[h], d2 = s[h];
      d2.parent = t2, d2.copyTransform(f2), c2 || rX(v9, d2);
    }
    t2.__isCombineMorphing = true, t2.childrenRef = function() {
      return s;
    };
    function m2(z9) {
      for (var V = 0; V < s.length; V++)
        s[V].addSelfToZr(z9);
    }
    FP(t2, "addSelfToZr", { after: function(z9) {
      m2(z9);
    } }), FP(t2, "removeSelfFromZr", { after: function(z9) {
      for (var V = 0; V < s.length; V++)
        s[V].removeSelfFromZr(z9);
    } });
    function b2() {
      t2.__isCombineMorphing = false, t2.__morphT = -1, t2.childrenRef = null, HC(t2, "addSelfToZr"), HC(t2, "removeSelfFromZr");
    }
    var _ = s.length;
    if (c2)
      for (var C = _, M = function() {
        C--, C === 0 && (b2(), u && u());
      }, h = 0; h < _; h++) {
        var E = c2 ? En({ delay: (e2.delay || 0) + c2(h, _, n2[h], s[h]), done: M }, e2) : e2;
        NN(n2[h], s[h], E);
      }
    else
      t2.__morphT = 0, t2.animateTo({ __morphT: 1 }, En({ during: function(z9) {
        for (var V = 0; V < _; V++) {
          var $ = s[V];
          $.__morphT = t2.__morphT, $.dirtyShape();
        }
        l2 && l2(z9);
      }, done: function() {
        b2();
        for (var z9 = 0; z9 < r2.length; z9++)
          HC(r2[z9], "updateTransform");
        u && u();
      } }, e2));
    return t2.__zr && m2(t2.__zr), { fromIndividuals: n2, toIndividuals: s, count: _ };
  }
  function yAe(r2, t2, e2) {
    var n2 = t2.length, a = [], i = e2.dividePath || nX;
    function o(v9) {
      for (var d2 = 0; d2 < v9.length; d2++) {
        var m2 = v9[d2];
        RP(m2) ? o(m2.childrenRef()) : m2 instanceof xa && a.push(m2);
      }
    }
    if (RP(r2)) {
      o(r2.childrenRef());
      var s = a.length;
      if (s < n2)
        for (var u = 0, l2 = s; l2 < n2; l2++)
          a.push(tF(a[u++ % s]));
      a.length = n2;
    } else {
      a = i({ path: r2, count: n2 });
      for (var c2 = r2.getComputedTransform(), l2 = 0; l2 < a.length; l2++)
        a[l2].setLocalTransform(c2);
      if (a.length !== n2)
        return console.error("Invalid morphing: unmatched splitted path"), d6();
    }
    a = NP(a), t2 = NP(t2);
    for (var f2 = e2.individualDelay, l2 = 0; l2 < n2; l2++) {
      var h = f2 ? En({ delay: (e2.delay || 0) + f2(l2, n2, a[l2], t2[l2]) }, e2) : e2;
      NN(a[l2], t2[l2], h);
    }
    return { fromIndividuals: a, toIndividuals: t2, count: t2.length };
  }
  function vG(r2) {
    return vr(r2[0]);
  }
  function dG(r2, t2) {
    for (var e2 = [], n2 = r2.length, a = 0; a < n2; a++)
      e2.push({ one: r2[a], many: [] });
    for (var a = 0; a < t2.length; a++) {
      var i = t2[a].length, o = void 0;
      for (o = 0; o < i; o++)
        e2[o % n2].many.push(t2[a][o]);
    }
    for (var s = 0, a = n2 - 1; a >= 0; a--)
      if (!e2[a].many.length) {
        var u = e2[s].many;
        if (u.length <= 1)
          if (s)
            s = 0;
          else
            return e2;
        var i = u.length, l2 = Math.ceil(i / 2);
        e2[a].many = u.slice(l2, i), e2[s].many = u.slice(0, l2), s++;
      }
    return e2;
  }
  var mAe = { clone: function(r2) {
    for (var t2 = [], e2 = 1 - Math.pow(1 - r2.path.style.opacity, 1 / r2.count), n2 = 0; n2 < r2.count; n2++) {
      var a = tF(r2.path);
      a.setStyle("opacity", e2), t2.push(a);
    }
    return t2;
  }, split: null };
  function pR(r2, t2, e2, n2, a, i) {
    if (!r2.length || !t2.length)
      return;
    var o = dw("update", n2, a);
    if (!(o && o.duration > 0))
      return;
    var s = n2.getModel("universalTransition").get("delay"), u = Object.assign({ setToFinal: true }, o), l2, c2;
    vG(r2) && (l2 = r2, c2 = t2), vG(t2) && (l2 = t2, c2 = r2);
    function f2(_, C, M, E, z9) {
      var V = _.many, $ = _.one;
      if (V.length === 1 && !z9) {
        var U = C ? V[0] : $, H = C ? $ : V[0];
        if (RP(U))
          f2({ many: [U], one: H }, true, M, E, true);
        else {
          var q3 = s ? En({ delay: s(M, E) }, u) : u;
          NN(U, H, q3), i(U, H, U, H, q3);
        }
      } else
        for (var ee = En({ dividePath: mAe[e2], individualDelay: s && function(et, Le, Fe, qe) {
          return s(et + M, E);
        } }, u), oe = C ? gAe(V, $, ee) : yAe($, V, ee), ne = oe.fromIndividuals, be = oe.toIndividuals, Ee = ne.length, ye = 0; ye < Ee; ye++) {
          var q3 = s ? En({ delay: s(ye, Ee) }, u) : u;
          i(ne[ye], be[ye], C ? V[ye] : _.one, C ? _.one : V[ye], q3);
        }
    }
    for (var h = l2 ? l2 === r2 : r2.length > t2.length, v9 = l2 ? dG(c2, l2) : dG(h ? t2 : r2, [h ? r2 : t2]), d2 = 0, m2 = 0; m2 < v9.length; m2++)
      d2 += v9[m2].many.length;
    for (var b2 = 0, m2 = 0; m2 < v9.length; m2++)
      f2(v9[m2], h, b2, d2), b2 += v9[m2].many.length;
  }
  function Lb(r2) {
    if (!r2)
      return [];
    if (vr(r2)) {
      for (var t2 = [], e2 = 0; e2 < r2.length; e2++)
        t2.push(Lb(r2[e2]));
      return t2;
    }
    var n2 = [];
    return r2.traverse(function(a) {
      a instanceof xa && !a.disableMorphing && !a.invisible && !a.ignore && n2.push(a);
    }), n2;
  }
  var aX = 1e4, bAe = fi();
  function _Ae(r2) {
    for (var t2 = r2.dimensions, e2 = 0; e2 < t2.length; e2++) {
      var n2 = r2.getDimensionInfo(t2[e2]);
      if (n2 && n2.otherDims.itemGroupId === 0)
        return t2[e2];
    }
  }
  function pG(r2) {
    var t2 = [];
    return ae(r2, function(e2) {
      var n2 = e2.data;
      if (!(n2.count() > aX))
        for (var a = n2.getIndices(), i = _Ae(n2), o = 0; o < a.length; o++)
          t2.push({ data: n2, dim: e2.dim || i, divide: e2.divide, dataIndex: o });
    }), t2;
  }
  function gR(r2, t2, e2) {
    r2.traverse(function(n2) {
      n2 instanceof xa && rs(n2, { style: { opacity: 0 } }, t2, { dataIndex: e2, isFrom: true });
    });
  }
  function yR(r2) {
    if (r2.parent) {
      var t2 = r2.getComputedTransform();
      r2.setLocalTransform(t2), r2.parent.remove(r2);
    }
  }
  function Lx(r2) {
    r2.stopAnimation(), r2.isGroup && r2.traverse(function(t2) {
      t2.stopAnimation();
    });
  }
  function xAe(r2, t2, e2) {
    var n2 = dw("update", e2, t2);
    n2 && r2.traverse(function(a) {
      if (a instanceof qh) {
        var i = eue(a);
        i && a.animateFrom({ style: i }, n2);
      }
    });
  }
  function wAe(r2, t2) {
    var e2 = r2.length;
    if (e2 !== t2.length)
      return false;
    for (var n2 = 0; n2 < e2; n2++) {
      var a = r2[n2], i = t2[n2];
      if (a.data.getId(a.dataIndex) !== i.data.getId(i.dataIndex))
        return false;
    }
    return true;
  }
  function iX(r2, t2, e2) {
    var n2 = pG(r2), a = pG(t2);
    function i(_, C, M, E, z9) {
      (M || _) && C.animateFrom({ style: M && M !== _ ? qt(qt({}, M.style), _.style) : _.style }, z9);
    }
    function o(_) {
      for (var C = 0; C < _.length; C++)
        if (_[C].dim)
          return _[C].dim;
    }
    var s = o(n2), u = o(a), l2 = false;
    function c2(_, C) {
      return function(M) {
        var E = M.data, z9 = M.dataIndex;
        if (C)
          return E.getId(z9);
        var V = E.hostModel && E.hostModel.get("dataGroupId"), $ = _ ? s || u : u || s, U = $ && E.getDimensionInfo($), H = U && U.ordinalMeta;
        if (U) {
          var q3 = E.get(U.name, z9);
          return H && H.categories[q3] || q3 + "";
        }
        var ee = E.getRawDataItem(z9);
        return ee && ee.groupId ? ee.groupId + "" : V || E.getId(z9);
      };
    }
    var f2 = wAe(n2, a), h = {};
    if (!f2)
      for (var v9 = 0; v9 < a.length; v9++) {
        var d2 = a[v9], m2 = d2.data.getItemGraphicEl(d2.dataIndex);
        m2 && (h[m2.id] = true);
      }
    function b2(_, C) {
      var M = n2[C], E = a[_], z9 = E.data.hostModel, V = M.data.getItemGraphicEl(M.dataIndex), $ = E.data.getItemGraphicEl(E.dataIndex);
      if (V === $) {
        $ && xAe($, E.dataIndex, z9);
        return;
      }
      V && h[V.id] || $ && (Lx($), V ? (Lx(V), yR(V), l2 = true, pR(Lb(V), Lb($), E.divide, z9, _, i)) : gR($, z9, _));
    }
    new Dg(n2, a, c2(true, f2), c2(false, f2), null, "multiple").update(b2).updateManyToOne(function(_, C) {
      var M = a[_], E = M.data, z9 = E.hostModel, V = E.getItemGraphicEl(M.dataIndex), $ = no(pr(C, function(U) {
        return n2[U].data.getItemGraphicEl(n2[U].dataIndex);
      }), function(U) {
        return U && U !== V && !h[U.id];
      });
      V && (Lx(V), $.length ? (ae($, function(U) {
        Lx(U), yR(U);
      }), l2 = true, pR(Lb($), Lb(V), M.divide, z9, _, i)) : gR(V, z9, M.dataIndex));
    }).updateOneToMany(function(_, C) {
      var M = n2[C], E = M.data.getItemGraphicEl(M.dataIndex);
      if (!(E && h[E.id])) {
        var z9 = no(pr(_, function($) {
          return a[$].data.getItemGraphicEl(a[$].dataIndex);
        }), function($) {
          return $ && $ !== E;
        }), V = a[_[0]].data.hostModel;
        z9.length && (ae(z9, function($) {
          return Lx($);
        }), E ? (Lx(E), yR(E), l2 = true, pR(Lb(E), Lb(z9), M.divide, V, _[0], i)) : ae(z9, function($) {
          return gR($, V, _[0]);
        }));
      }
    }).updateManyToMany(function(_, C) {
      new Dg(C, _, function(M) {
        return n2[M].data.getId(n2[M].dataIndex);
      }, function(M) {
        return a[M].data.getId(a[M].dataIndex);
      }).update(function(M, E) {
        b2(_[M], C[E]);
      }).execute();
    }).execute(), l2 && ae(t2, function(_) {
      var C = _.data, M = C.hostModel, E = M && e2.getViewOfSeriesModel(M), z9 = dw("update", M, 0);
      E && M.isAnimationEnabled() && z9 && z9.duration > 0 && E.group.traverse(function(V) {
        V instanceof xa && !V.animators.length && V.animateFrom({ style: { opacity: 0 } }, z9);
      });
    });
  }
  function gG(r2) {
    var t2 = r2.getModel("universalTransition").get("seriesKey");
    return t2 || r2.id;
  }
  function yG(r2) {
    return vr(r2) ? r2.sort().join(",") : r2;
  }
  function ey(r2) {
    if (r2.hostModel)
      return r2.hostModel.getModel("universalTransition").get("divideShape");
  }
  function SAe(r2, t2) {
    var e2 = mn(), n2 = mn(), a = mn();
    return ae(r2.oldSeries, function(i, o) {
      var s = r2.oldData[o], u = gG(i), l2 = yG(u);
      n2.set(l2, s), vr(u) && ae(u, function(c2) {
        a.set(c2, { data: s, key: l2 });
      });
    }), ae(t2.updatedSeries, function(i) {
      if (i.isUniversalTransitionEnabled() && i.isAnimationEnabled()) {
        var o = i.getData(), s = gG(i), u = yG(s), l2 = n2.get(u);
        if (l2)
          e2.set(u, { oldSeries: [{ divide: ey(l2), data: l2 }], newSeries: [{ divide: ey(o), data: o }] });
        else if (vr(s)) {
          var c2 = [];
          ae(s, function(v9) {
            var d2 = n2.get(v9);
            d2 && c2.push({ divide: ey(d2), data: d2 });
          }), c2.length && e2.set(u, { oldSeries: c2, newSeries: [{ data: o, divide: ey(o) }] });
        } else {
          var f2 = a.get(s);
          if (f2) {
            var h = e2.get(f2.key);
            h || (h = { oldSeries: [{ data: f2.data, divide: ey(f2.data) }], newSeries: [] }, e2.set(f2.key, h)), h.newSeries.push({ data: o, divide: ey(o) });
          }
        }
      }
    }), e2;
  }
  function mG(r2, t2) {
    for (var e2 = 0; e2 < r2.length; e2++) {
      var n2 = t2.seriesIndex != null && t2.seriesIndex === r2[e2].seriesIndex || t2.seriesId != null && t2.seriesId === r2[e2].id;
      if (n2)
        return e2;
    }
  }
  function CAe(r2, t2, e2, n2) {
    var a = [], i = [];
    ae(ao(r2.from), function(o) {
      var s = mG(t2.oldSeries, o);
      s >= 0 && a.push({ data: t2.oldData[s], divide: ey(t2.oldData[s]), dim: o.dimension });
    }), ae(ao(r2.to), function(o) {
      var s = mG(e2.updatedSeries, o);
      if (s >= 0) {
        var u = e2.updatedSeries[s].getData();
        i.push({ data: u, divide: ey(u), dim: o.dimension });
      }
    }), a.length > 0 && i.length > 0 && iX(a, i, n2);
  }
  function EAe(r2) {
    r2.registerUpdateLifecycle("series:beforeupdate", function(t2, e2, n2) {
      ae(ao(n2.seriesTransition), function(a) {
        ae(ao(a.to), function(i) {
          for (var o = n2.updatedSeries, s = 0; s < o.length; s++)
            (i.seriesIndex != null && i.seriesIndex === o[s].seriesIndex || i.seriesId != null && i.seriesId === o[s].id) && (o[s][k5] = true);
        });
      });
    }), r2.registerUpdateLifecycle("series:transition", function(t2, e2, n2) {
      var a = bAe(e2);
      if (a.oldSeries && n2.updatedSeries && n2.optionChanged) {
        var i = n2.seriesTransition;
        if (i)
          ae(ao(i), function(h) {
            CAe(h, a, n2, e2);
          });
        else {
          var o = SAe(a, n2);
          ae(o.keys(), function(h) {
            var v9 = o.get(h);
            iX(v9.oldSeries, v9.newSeries, e2);
          });
        }
        ae(n2.updatedSeries, function(h) {
          h[k5] && (h[k5] = false);
        });
      }
      for (var s = t2.getSeries(), u = a.oldSeries = [], l2 = a.oldData = [], c2 = 0; c2 < s.length; c2++) {
        var f2 = s[c2].getData();
        f2.count() < aX && (u.push(s[c2]), l2.push(f2));
      }
    });
  }
  ya([$ve]);
  ya([Rve]);
  ya([hde, Dde, $de, Dpe, qpe, zge, m0e, aye, Lye, zye, Jye, rbe, Pbe, Gbe, u1e, p1e, O1e, G1e, r_e, c_e, C_e, uxe]);
  ya(Ixe);
  ya(fwe);
  ya(QY);
  ya(Mwe);
  ya(BK);
  ya(Rwe);
  ya(Wwe);
  ya(USe);
  ya(d2e);
  ya(KE);
  ya(k2e);
  ya(N2e);
  ya(J2e);
  ya(uCe);
  ya(gCe);
  ya(CCe);
  ya(VCe);
  ya(oEe);
  ya(UZ);
  ya(HZ);
  ya(OEe);
  ya(XZ);
  ya(JZ);
  ya(VEe);
  ya(XEe);
  ya(eAe);
  ya(EAe);
  ya(eve);
  function AAe(r2) {
    const { defaultOptions: t2 } = r2 != null ? r2 : {}, e2 = Li.useRef(null), n2 = Li.useRef(), a = Li.useRef(t2);
    return Li.useEffect(() => {
      if (!e2.current)
        return;
      const i = gfe(e2.current);
      n2.current = i, a.current && i.setOption(a.current);
    }, []), Li.useEffect(() => () => {
      var i, o, s, u;
      (o = (i = n2.current) == null ? void 0 : i.dispose) == null || o.call(i), (u = (s = n2.current) == null ? void 0 : s.off) == null || u.call(s, "*"), n2.current = void 0;
    }, []), eae("resize", () => {
      requestAnimationFrame(() => {
        var i, o;
        (o = (i = n2 == null ? void 0 : n2.current) == null ? void 0 : i.resize) == null || o.call(i);
      });
    }), { chart: n2, container: e2 };
  }
  class TAe {
    constructor() {
      lf(this, "chartsEmitters", /* @__PURE__ */ new Map());
      lf(this, "add", (t2, e2, n2, a) => {
        e2 && n2 ? this.chartsEmitters.set(t2, { chart: e2, option: n2, title: a }) : console.log("\u6DFB\u52A0\u5931\u8D25");
      });
      lf(this, "get", (t2) => this.chartsEmitters.get(t2));
      lf(this, "clear", () => {
        this.chartsEmitters.clear();
      });
      lf(this, "delete", (t2) => {
        this.chartsEmitters.delete(t2);
      });
      lf(this, "list", () => {
        var e2, n2, a;
        const t2 = [];
        for (const i of this.chartsEmitters.keys())
          t2.push({ id: i, chart: (e2 = this.chartsEmitters.get(i)) == null ? void 0 : e2.chart, option: (n2 = this.chartsEmitters.get(i)) == null ? void 0 : n2.option, title: (a = this.chartsEmitters.get(i)) == null ? void 0 : a.title });
        return t2;
      });
    }
  }
  const MAe = new TAe();
  var VP = { exports: {} };
  /**
  * @license
  * Lodash <https://lodash.com/>
  * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
  * Released under MIT license <https://lodash.com/license>
  * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
  * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
  */
  (function(r2, t2) {
    (function() {
      var e2, n2 = "4.17.21", a = 200, i = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", o = "Expected a function", s = "Invalid `variable` option passed into `_.template`", u = "__lodash_hash_undefined__", l2 = 500, c2 = "__lodash_placeholder__", f2 = 1, h = 2, v9 = 4, d2 = 1, m2 = 2, b2 = 1, _ = 2, C = 4, M = 8, E = 16, z9 = 32, V = 64, $ = 128, U = 256, H = 512, q3 = 30, ee = "...", oe = 800, ne = 16, be = 1, Ee = 2, ye = 3, et = 1 / 0, Le = 9007199254740991, Fe = 17976931348623157e292, qe = 0 / 0, st = 4294967295, dt = st - 1, Ar = st >>> 1, Hr = [["ary", $], ["bind", b2], ["bindKey", _], ["curry", M], ["curryRight", E], ["flip", H], ["partial", z9], ["partialRight", V], ["rearg", U]], hn = "[object Arguments]", cn = "[object Array]", nn = "[object AsyncFunction]", Wr = "[object Boolean]", on = "[object Date]", un = "[object DOMException]", Xr = "[object Error]", _n = "[object Function]", Za = "[object GeneratorFunction]", Dn = "[object Map]", ai = "[object Number]", wi = "[object Null]", hi = "[object Object]", qs = "[object Promise]", jo = "[object Proxy]", Au = "[object RegExp]", Zi = "[object Set]", ys = "[object String]", Do = "[object Symbol]", mf = "[object Undefined]", xr = "[object WeakMap]", jt = "[object WeakSet]", Ot = "[object ArrayBuffer]", wr = "[object DataView]", an = "[object Float32Array]", Mn = "[object Float64Array]", Fa = "[object Int8Array]", Ma = "[object Int16Array]", ji = "[object Int32Array]", Bo = "[object Uint8Array]", yo = "[object Uint8ClampedArray]", ms = "[object Uint16Array]", mo = "[object Uint32Array]", Yu = /\b__p \+= '';/g, wl = /\b(__p \+=) '' \+/g, hc = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Sl = /&(?:amp|lt|gt|quot|#39);/g, as = /[&<>"']/g, vi = RegExp(Sl.source), Ys = RegExp(as.source), Tu = /<%-([\s\S]+?)%>/g, Vc = /<%([\s\S]+?)%>/g, zl = /<%=([\s\S]+?)%>/g, Cl = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, vc = /^\w*$/, th = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, rh = /[\\^$.*+?()[\]{}|]/g, Mw = RegExp(rh.source), qv = /^\s+/, Pw = /\s/, Dw = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Iw = /\{\n\/\* \[wrapped with (.+)\] \*/, Lw = /,? & /, Fg = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Be = /[()=,{}\[\]\/\s]/, $e = /\\(\\)?/g, Se = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, ke = /\w*$/, Ie = /^[-+]0x[0-9a-f]+$/i, Mt = /^0b[01]+$/i, At = /^\[object .+?Constructor\]$/, Qt = /^0o[0-7]+$/i, xt = /^(?:0|[1-9]\d*)$/, Rr = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, wn = /($^)/, Ba = /['\n\r\u2028\u2029\\]/g, sa = "\\ud800-\\udfff", Xi = "\\u0300-\\u036f", ma = "\\ufe20-\\ufe2f", Wi = "\\u20d0-\\u20ff", io = Xi + ma + Wi, kn = "\\u2700-\\u27bf", Bi = "a-z\\xdf-\\xf6\\xf8-\\xff", El = "\\xac\\xb1\\xd7\\xf7", bf = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", Ng = "\\u2000-\\u206f", $l = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Xh = "A-Z\\xc0-\\xd6\\xd8-\\xde", Jh = "\\ufe0e\\ufe0f", bs = El + bf + Ng + $l, nh = "['\u2019]", sp = "[" + sa + "]", Qh = "[" + bs + "]", up = "[" + io + "]", Yv = "\\d+", Mu = "[" + kn + "]", lp = "[" + Bi + "]", ah = "[^" + sa + bs + Yv + kn + Bi + Xh + "]", cp = "\\ud83c[\\udffb-\\udfff]", Kv = "(?:" + up + "|" + cp + ")", jc = "[^" + sa + "]", Py = "(?:\\ud83c[\\udde6-\\uddff]){2}", Dy = "[\\ud800-\\udbff][\\udc00-\\udfff]", Ku = "[" + Xh + "]", eA = "\\u200d", ih = "(?:" + lp + "|" + ah + ")", h1 = "(?:" + Ku + "|" + ah + ")", Ow = "(?:" + nh + "(?:d|ll|m|re|s|t|ve))?", tA = "(?:" + nh + "(?:D|LL|M|RE|S|T|VE))?", rA = Kv + "?", nA = "[" + Jh + "]?", aA = "(?:" + eA + "(?:" + [jc, Py, Dy].join("|") + ")" + nA + rA + ")*", iA = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", G3 = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", kw = nA + rA + aA, v12 = "(?:" + [Mu, Py, Dy].join("|") + ")" + kw, W3 = "(?:" + [jc + up + "?", up, Py, Dy, sp].join("|") + ")", oA = RegExp(nh, "g"), sA = RegExp(up, "g"), d1 = RegExp(cp + "(?=" + cp + ")|" + W3 + kw, "g"), Rw = RegExp([Ku + "?" + lp + "+" + Ow + "(?=" + [Qh, Ku, "$"].join("|") + ")", h1 + "+" + tA + "(?=" + [Qh, Ku + ih, "$"].join("|") + ")", Ku + "?" + ih + "+" + Ow, Ku + "+" + tA, G3, iA, Yv, v12].join("|"), "g"), Fw = RegExp("[" + eA + sa + io + Jh + "]"), Zu = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Nw = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], uA = -1, zo = {};
      zo[an] = zo[Mn] = zo[Fa] = zo[Ma] = zo[ji] = zo[Bo] = zo[yo] = zo[ms] = zo[mo] = true, zo[hn] = zo[cn] = zo[Ot] = zo[Wr] = zo[wr] = zo[on] = zo[Xr] = zo[_n] = zo[Dn] = zo[ai] = zo[hi] = zo[Au] = zo[Zi] = zo[ys] = zo[xr] = false;
      var Io = {};
      Io[hn] = Io[cn] = Io[Ot] = Io[wr] = Io[Wr] = Io[on] = Io[an] = Io[Mn] = Io[Fa] = Io[Ma] = Io[ji] = Io[Dn] = Io[ai] = Io[hi] = Io[Au] = Io[Zi] = Io[ys] = Io[Do] = Io[Bo] = Io[yo] = Io[ms] = Io[mo] = true, Io[Xr] = Io[_n] = Io[xr] = false;
      var oh = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, lA = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, U3 = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, cA = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, Vw = parseFloat, fA = parseInt, p1 = typeof jh == "object" && jh && jh.Object === Object && jh, H3 = typeof self == "object" && self && self.Object === Object && self, hu = p1 || H3 || Function("return this")(), jw = t2 && !t2.nodeType && t2, Zv = jw && true && r2 && !r2.nodeType && r2, Bw = Zv && Zv.exports === jw, Iy = Bw && p1.process, dc = function() {
        try {
          var ft = Zv && Zv.require && Zv.require("util").types;
          return ft || Iy && Iy.binding && Iy.binding("util");
        } catch {
        }
      }(), zw = dc && dc.isArrayBuffer, hA = dc && dc.isDate, vA = dc && dc.isMap, dA = dc && dc.isRegExp, Vg = dc && dc.isSet, pA = dc && dc.isTypedArray;
      function pc(ft, cr, Zt) {
        switch (Zt.length) {
          case 0:
            return ft.call(cr);
          case 1:
            return ft.call(cr, Zt[0]);
          case 2:
            return ft.call(cr, Zt[0], Zt[1]);
          case 3:
            return ft.call(cr, Zt[0], Zt[1], Zt[2]);
        }
        return ft.apply(cr, Zt);
      }
      function g1(ft, cr, Zt, bn) {
        for (var ta = -1, Ui = ft == null ? 0 : ft.length; ++ta < Ui; ) {
          var _s = ft[ta];
          cr(bn, _s, Zt(_s), ft);
        }
        return bn;
      }
      function Gl(ft, cr) {
        for (var Zt = -1, bn = ft == null ? 0 : ft.length; ++Zt < bn && cr(ft[Zt], Zt, ft) !== false; )
          ;
        return ft;
      }
      function gA(ft, cr) {
        for (var Zt = ft == null ? 0 : ft.length; Zt-- && cr(ft[Zt], Zt, ft) !== false; )
          ;
        return ft;
      }
      function yA(ft, cr) {
        for (var Zt = -1, bn = ft == null ? 0 : ft.length; ++Zt < bn; )
          if (!cr(ft[Zt], Zt, ft))
            return false;
        return true;
      }
      function Xv(ft, cr) {
        for (var Zt = -1, bn = ft == null ? 0 : ft.length, ta = 0, Ui = []; ++Zt < bn; ) {
          var _s = ft[Zt];
          cr(_s, Zt, ft) && (Ui[ta++] = _s);
        }
        return Ui;
      }
      function fp(ft, cr) {
        var Zt = ft == null ? 0 : ft.length;
        return !!Zt && ev(ft, cr, 0) > -1;
      }
      function $w(ft, cr, Zt) {
        for (var bn = -1, ta = ft == null ? 0 : ft.length; ++bn < ta; )
          if (Zt(cr, ft[bn]))
            return true;
        return false;
      }
      function Ho(ft, cr) {
        for (var Zt = -1, bn = ft == null ? 0 : ft.length, ta = Array(bn); ++Zt < bn; )
          ta[Zt] = cr(ft[Zt], Zt, ft);
        return ta;
      }
      function Jv(ft, cr) {
        for (var Zt = -1, bn = cr.length, ta = ft.length; ++Zt < bn; )
          ft[ta + Zt] = cr[Zt];
        return ft;
      }
      function y1(ft, cr, Zt, bn) {
        var ta = -1, Ui = ft == null ? 0 : ft.length;
        for (bn && Ui && (Zt = ft[++ta]); ++ta < Ui; )
          Zt = cr(Zt, ft[ta], ta, ft);
        return Zt;
      }
      function q32(ft, cr, Zt, bn) {
        var ta = ft == null ? 0 : ft.length;
        for (bn && ta && (Zt = ft[--ta]); ta--; )
          Zt = cr(Zt, ft[ta], ta, ft);
        return Zt;
      }
      function cs(ft, cr) {
        for (var Zt = -1, bn = ft == null ? 0 : ft.length; ++Zt < bn; )
          if (cr(ft[Zt], Zt, ft))
            return true;
        return false;
      }
      var Ly = ky("length");
      function mA(ft) {
        return ft.split("");
      }
      function Oy(ft) {
        return ft.match(Fg) || [];
      }
      function m1(ft, cr, Zt) {
        var bn;
        return Zt(ft, function(ta, Ui, _s) {
          if (cr(ta, Ui, _s))
            return bn = Ui, false;
        }), bn;
      }
      function jg(ft, cr, Zt, bn) {
        for (var ta = ft.length, Ui = Zt + (bn ? 1 : -1); bn ? Ui-- : ++Ui < ta; )
          if (cr(ft[Ui], Ui, ft))
            return Ui;
        return -1;
      }
      function ev(ft, cr, Zt) {
        return cr === cr ? Q3(ft, cr, Zt) : jg(ft, b1, Zt);
      }
      function Y3(ft, cr, Zt, bn) {
        for (var ta = Zt - 1, Ui = ft.length; ++ta < Ui; )
          if (bn(ft[ta], cr))
            return ta;
        return -1;
      }
      function b1(ft) {
        return ft !== ft;
      }
      function bA(ft, cr) {
        var Zt = ft == null ? 0 : ft.length;
        return Zt ? Fy(ft, cr) / Zt : qe;
      }
      function ky(ft) {
        return function(cr) {
          return cr == null ? e2 : cr[ft];
        };
      }
      function Ry(ft) {
        return function(cr) {
          return ft == null ? e2 : ft[cr];
        };
      }
      function Ji(ft, cr, Zt, bn, ta) {
        return ta(ft, function(Ui, _s, Hi) {
          Zt = bn ? (bn = false, Ui) : cr(Zt, Ui, _s, Hi);
        }), Zt;
      }
      function vu(ft, cr) {
        var Zt = ft.length;
        for (ft.sort(cr); Zt--; )
          ft[Zt] = ft[Zt].value;
        return ft;
      }
      function Fy(ft, cr) {
        for (var Zt, bn = -1, ta = ft.length; ++bn < ta; ) {
          var Ui = cr(ft[bn]);
          Ui !== e2 && (Zt = Zt === e2 ? Ui : Zt + Ui);
        }
        return Zt;
      }
      function Ny(ft, cr) {
        for (var Zt = -1, bn = Array(ft); ++Zt < ft; )
          bn[Zt] = cr(Zt);
        return bn;
      }
      function _1(ft, cr) {
        return Ho(cr, function(Zt) {
          return [Zt, ft[Zt]];
        });
      }
      function Vy(ft) {
        return ft && ft.slice(0, Ww(ft) + 1).replace(qv, "");
      }
      function Xu(ft) {
        return function(cr) {
          return ft(cr);
        };
      }
      function Bg(ft, cr) {
        return Ho(cr, function(Zt) {
          return ft[Zt];
        });
      }
      function Qv(ft, cr) {
        return ft.has(cr);
      }
      function x1(ft, cr) {
        for (var Zt = -1, bn = ft.length; ++Zt < bn && ev(cr, ft[Zt], 0) > -1; )
          ;
        return Zt;
      }
      function jy(ft, cr) {
        for (var Zt = ft.length; Zt-- && ev(cr, ft[Zt], 0) > -1; )
          ;
        return Zt;
      }
      function w1(ft, cr) {
        for (var Zt = ft.length, bn = 0; Zt--; )
          ft[Zt] === cr && ++bn;
        return bn;
      }
      var S1 = Ry(oh), K3 = Ry(lA);
      function C1(ft) {
        return "\\" + cA[ft];
      }
      function E1(ft, cr) {
        return ft == null ? e2 : ft[cr];
      }
      function zg(ft) {
        return Fw.test(ft);
      }
      function Z3(ft) {
        return Zu.test(ft);
      }
      function X3(ft) {
        for (var cr, Zt = []; !(cr = ft.next()).done; )
          Zt.push(cr.value);
        return Zt;
      }
      function Gw(ft) {
        var cr = -1, Zt = Array(ft.size);
        return ft.forEach(function(bn, ta) {
          Zt[++cr] = [ta, bn];
        }), Zt;
      }
      function Wl(ft, cr) {
        return function(Zt) {
          return ft(cr(Zt));
        };
      }
      function tv(ft, cr) {
        for (var Zt = -1, bn = ft.length, ta = 0, Ui = []; ++Zt < bn; ) {
          var _s = ft[Zt];
          (_s === cr || _s === c2) && (ft[Zt] = c2, Ui[ta++] = Zt);
        }
        return Ui;
      }
      function $g(ft) {
        var cr = -1, Zt = Array(ft.size);
        return ft.forEach(function(bn) {
          Zt[++cr] = bn;
        }), Zt;
      }
      function J3(ft) {
        var cr = -1, Zt = Array(ft.size);
        return ft.forEach(function(bn) {
          Zt[++cr] = [bn, bn];
        }), Zt;
      }
      function Q3(ft, cr, Zt) {
        for (var bn = Zt - 1, ta = ft.length; ++bn < ta; )
          if (ft[bn] === cr)
            return bn;
        return -1;
      }
      function eD(ft, cr, Zt) {
        for (var bn = Zt + 1; bn--; )
          if (ft[bn] === cr)
            return bn;
        return bn;
      }
      function Gg(ft) {
        return zg(ft) ? Ti(ft) : Ly(ft);
      }
      function _f(ft) {
        return zg(ft) ? Wg(ft) : mA(ft);
      }
      function Ww(ft) {
        for (var cr = ft.length; cr-- && Pw.test(ft.charAt(cr)); )
          ;
        return cr;
      }
      var tD = Ry(U3);
      function Ti(ft) {
        for (var cr = d1.lastIndex = 0; d1.test(ft); )
          ++cr;
        return cr;
      }
      function Wg(ft) {
        return ft.match(d1) || [];
      }
      function $o(ft) {
        return ft.match(Rw) || [];
      }
      var By = function ft(cr) {
        cr = cr == null ? hu : ed.defaults(hu.Object(), cr, ed.pick(hu, Nw));
        var Zt = cr.Array, bn = cr.Date, ta = cr.Error, Ui = cr.Function, _s = cr.Math, Hi = cr.Object, Uw = cr.RegExp, A1 = cr.String, Bc = cr.TypeError, Ug = Zt.prototype, rD = Ui.prototype, Hg = Hi.prototype, qg = cr["__core-js_shared__"], Ju = rD.toString, oo = Hg.hasOwnProperty, Ks = 0, _A = function() {
          var p2 = /[^.]+$/.exec(qg && qg.keys && qg.keys.IE_PROTO || "");
          return p2 ? "Symbol(src)_1." + p2 : "";
        }(), zy = Hg.toString, nD = Ju.call(Hi), xA = hu._, aD = Uw("^" + Ju.call(oo).replace(rh, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), T1 = Bw ? cr.Buffer : e2, td = cr.Symbol, $y = cr.Uint8Array, Hw = T1 ? T1.allocUnsafe : e2, Gy = Wl(Hi.getPrototypeOf, Hi), wA = Hi.create, M1 = Hg.propertyIsEnumerable, rd = Ug.splice, SA = td ? td.isConcatSpreadable : e2, Wy = td ? td.iterator : e2, zc = td ? td.toStringTag : e2, P1 = function() {
          try {
            var p2 = so(Hi, "defineProperty");
            return p2({}, "", {}), p2;
          } catch {
          }
        }(), iD = cr.clearTimeout !== hu.clearTimeout && cr.clearTimeout, Si = bn && bn.now !== hu.Date.now && bn.now, oD = cr.setTimeout !== hu.setTimeout && cr.setTimeout, D1 = _s.ceil, I1 = _s.floor, qw = Hi.getOwnPropertySymbols, sD = T1 ? T1.isBuffer : e2, CA = cr.isFinite, uD = Ug.join, lD = Wl(Hi.keys, Hi), Zs = _s.max, Qu = _s.min, cD = bn.now, fD = cr.parseInt, EA = _s.random, hD = Ug.reverse, Uy = so(cr, "DataView"), Hy = so(cr, "Map"), hp = so(cr, "Promise"), nd = so(cr, "Set"), vp = so(cr, "WeakMap"), rv = so(Hi, "create"), el = vp && new vp(), dp = {}, AA = ze(Uy), vD = ze(Hy), TA = ze(hp), dD = ze(nd), Rs = ze(vp), nv = td ? td.prototype : e2, xf = nv ? nv.valueOf : e2, Yw = nv ? nv.toString : e2;
        function _e(p2) {
          if (xo(p2) && !Yn(p2) && !(p2 instanceof di)) {
            if (p2 instanceof Al)
              return p2;
            if (oo.call(p2, "__wrapped__"))
              return Oe(p2);
          }
          return new Al(p2);
        }
        var pp = function() {
          function p2() {
          }
          return function(x2) {
            if (!la(x2))
              return {};
            if (wA)
              return wA(x2);
            p2.prototype = x2;
            var k2 = new p2();
            return p2.prototype = e2, k2;
          };
        }();
        function qy() {
        }
        function Al(p2, x2) {
          this.__wrapped__ = p2, this.__actions__ = [], this.__chain__ = !!x2, this.__index__ = 0, this.__values__ = e2;
        }
        _e.templateSettings = { escape: Tu, evaluate: Vc, interpolate: zl, variable: "", imports: { _: _e } }, _e.prototype = qy.prototype, _e.prototype.constructor = _e, Al.prototype = pp(qy.prototype), Al.prototype.constructor = Al;
        function di(p2) {
          this.__wrapped__ = p2, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = st, this.__views__ = [];
        }
        function pD() {
          var p2 = new di(this.__wrapped__);
          return p2.__actions__ = Ze(this.__actions__), p2.__dir__ = this.__dir__, p2.__filtered__ = this.__filtered__, p2.__iteratees__ = Ze(this.__iteratees__), p2.__takeCount__ = this.__takeCount__, p2.__views__ = Ze(this.__views__), p2;
        }
        function gD() {
          if (this.__filtered__) {
            var p2 = new di(this);
            p2.__dir__ = -1, p2.__filtered__ = true;
          } else
            p2 = this.clone(), p2.__dir__ *= -1;
          return p2;
        }
        function MA() {
          var p2 = this.__wrapped__.value(), x2 = this.__dir__, k2 = Yn(p2), Y = x2 < 0, ue = k2 ? p2.length : 0, me = Nt(0, ue, this.__views__), Ye = me.start, tt = me.end, pt = tt - Ye, Cr = Y ? tt : Ye - 1, Tr = this.__iteratees__, Br = Tr.length, Jr = 0, Ln = Qu(pt, this.__takeCount__);
          if (!k2 || !Y && ue == pt && Ln == pt)
            return qA(p2, this.__actions__);
          var $n = [];
          e:
            for (; pt-- && Jr < Ln; ) {
              Cr += x2;
              for (var _a2 = -1, Un = p2[Cr]; ++_a2 < Br; ) {
                var Ya = Tr[_a2], aa = Ya.iteratee, hs = Ya.type, nu = aa(Un);
                if (hs == Ee)
                  Un = nu;
                else if (!nu) {
                  if (hs == be)
                    continue e;
                  break e;
                }
              }
              $n[Jr++] = Un;
            }
          return $n;
        }
        di.prototype = pp(qy.prototype), di.prototype.constructor = di;
        function gp(p2) {
          var x2 = -1, k2 = p2 == null ? 0 : p2.length;
          for (this.clear(); ++x2 < k2; ) {
            var Y = p2[x2];
            this.set(Y[0], Y[1]);
          }
        }
        function yD() {
          this.__data__ = rv ? rv(null) : {}, this.size = 0;
        }
        function Kw(p2) {
          var x2 = this.has(p2) && delete this.__data__[p2];
          return this.size -= x2 ? 1 : 0, x2;
        }
        function Zw(p2) {
          var x2 = this.__data__;
          if (rv) {
            var k2 = x2[p2];
            return k2 === u ? e2 : k2;
          }
          return oo.call(x2, p2) ? x2[p2] : e2;
        }
        function mD(p2) {
          var x2 = this.__data__;
          return rv ? x2[p2] !== e2 : oo.call(x2, p2);
        }
        function bD(p2, x2) {
          var k2 = this.__data__;
          return this.size += this.has(p2) ? 0 : 1, k2[p2] = rv && x2 === e2 ? u : x2, this;
        }
        gp.prototype.clear = yD, gp.prototype.delete = Kw, gp.prototype.get = Zw, gp.prototype.has = mD, gp.prototype.set = bD;
        function wf(p2) {
          var x2 = -1, k2 = p2 == null ? 0 : p2.length;
          for (this.clear(); ++x2 < k2; ) {
            var Y = p2[x2];
            this.set(Y[0], Y[1]);
          }
        }
        function _D() {
          this.__data__ = [], this.size = 0;
        }
        function Xw(p2) {
          var x2 = this.__data__, k2 = Xy(x2, p2);
          if (k2 < 0)
            return false;
          var Y = x2.length - 1;
          return k2 == Y ? x2.pop() : rd.call(x2, k2, 1), --this.size, true;
        }
        function xD(p2) {
          var x2 = this.__data__, k2 = Xy(x2, p2);
          return k2 < 0 ? e2 : x2[k2][1];
        }
        function $c(p2) {
          return Xy(this.__data__, p2) > -1;
        }
        function PA(p2, x2) {
          var k2 = this.__data__, Y = Xy(k2, p2);
          return Y < 0 ? (++this.size, k2.push([p2, x2])) : k2[Y][1] = x2, this;
        }
        wf.prototype.clear = _D, wf.prototype.delete = Xw, wf.prototype.get = xD, wf.prototype.has = $c, wf.prototype.set = PA;
        function Sf(p2) {
          var x2 = -1, k2 = p2 == null ? 0 : p2.length;
          for (this.clear(); ++x2 < k2; ) {
            var Y = p2[x2];
            this.set(Y[0], Y[1]);
          }
        }
        function DA() {
          this.size = 0, this.__data__ = { hash: new gp(), map: new (Hy || wf)(), string: new gp() };
        }
        function wD(p2) {
          var x2 = Tl(this, p2).delete(p2);
          return this.size -= x2 ? 1 : 0, x2;
        }
        function SD(p2) {
          return Tl(this, p2).get(p2);
        }
        function CD(p2) {
          return Tl(this, p2).has(p2);
        }
        function IA(p2, x2) {
          var k2 = Tl(this, p2), Y = k2.size;
          return k2.set(p2, x2), this.size += k2.size == Y ? 0 : 1, this;
        }
        Sf.prototype.clear = DA, Sf.prototype.delete = wD, Sf.prototype.get = SD, Sf.prototype.has = CD, Sf.prototype.set = IA;
        function av(p2) {
          var x2 = -1, k2 = p2 == null ? 0 : p2.length;
          for (this.__data__ = new Sf(); ++x2 < k2; )
            this.add(p2[x2]);
        }
        function Yy(p2) {
          return this.__data__.set(p2, u), this;
        }
        function ED(p2) {
          return this.__data__.has(p2);
        }
        av.prototype.add = av.prototype.push = Yy, av.prototype.has = ED;
        function Cf(p2) {
          var x2 = this.__data__ = new wf(p2);
          this.size = x2.size;
        }
        function LA() {
          this.__data__ = new wf(), this.size = 0;
        }
        function Jw(p2) {
          var x2 = this.__data__, k2 = x2.delete(p2);
          return this.size = x2.size, k2;
        }
        function AD(p2) {
          return this.__data__.get(p2);
        }
        function TD(p2) {
          return this.__data__.has(p2);
        }
        function MD(p2, x2) {
          var k2 = this.__data__;
          if (k2 instanceof wf) {
            var Y = k2.__data__;
            if (!Hy || Y.length < a - 1)
              return Y.push([p2, x2]), this.size = ++k2.size, this;
            k2 = this.__data__ = new Sf(Y);
          }
          return k2.set(p2, x2), this.size = k2.size, this;
        }
        Cf.prototype.clear = LA, Cf.prototype.delete = Jw, Cf.prototype.get = AD, Cf.prototype.has = TD, Cf.prototype.set = MD;
        function OA(p2, x2) {
          var k2 = Yn(p2), Y = !k2 && mh(p2), ue = !k2 && !Y && Bt(p2), me = !k2 && !Y && !ue && Kl(p2), Ye = k2 || Y || ue || me, tt = Ye ? Ny(p2.length, A1) : [], pt = tt.length;
          for (var Cr in p2)
            (x2 || oo.call(p2, Cr)) && !(Ye && (Cr == "length" || ue && (Cr == "offset" || Cr == "parent") || me && (Cr == "buffer" || Cr == "byteLength" || Cr == "byteOffset") || Mi(Cr, pt))) && tt.push(Cr);
          return tt;
        }
        function Ky(p2) {
          var x2 = p2.length;
          return x2 ? p2[fS(0, x2 - 1)] : e2;
        }
        function PD(p2, x2) {
          return sd(Ze(p2), yp(x2, 0, p2.length));
        }
        function DD(p2) {
          return sd(Ze(p2));
        }
        function Qw(p2, x2, k2) {
          (k2 !== e2 && !ii(p2[x2], k2) || k2 === e2 && !(x2 in p2)) && iv(p2, x2, k2);
        }
        function Zy(p2, x2, k2) {
          var Y = p2[x2];
          (!(oo.call(p2, x2) && ii(Y, k2)) || k2 === e2 && !(x2 in p2)) && iv(p2, x2, k2);
        }
        function Xy(p2, x2) {
          for (var k2 = p2.length; k2--; )
            if (ii(p2[k2][0], x2))
              return k2;
          return -1;
        }
        function ID(p2, x2, k2, Y) {
          return ad(p2, function(ue, me, Ye) {
            x2(Y, ue, k2(ue), Ye);
          }), Y;
        }
        function eS(p2, x2) {
          return p2 && it(x2, Wo(x2), p2);
        }
        function gc(p2, x2) {
          return p2 && it(x2, js(x2), p2);
        }
        function iv(p2, x2, k2) {
          x2 == "__proto__" && P1 ? P1(p2, x2, { configurable: true, enumerable: true, value: k2, writable: true }) : p2[x2] = k2;
        }
        function L1(p2, x2) {
          for (var k2 = -1, Y = x2.length, ue = Zt(Y), me = p2 == null; ++k2 < Y; )
            ue[k2] = me ? e2 : Xo(p2, x2[k2]);
          return ue;
        }
        function yp(p2, x2, k2) {
          return p2 === p2 && (k2 !== e2 && (p2 = p2 <= k2 ? p2 : k2), x2 !== e2 && (p2 = p2 >= x2 ? p2 : x2)), p2;
        }
        function Gc(p2, x2, k2, Y, ue, me) {
          var Ye, tt = x2 & f2, pt = x2 & h, Cr = x2 & v9;
          if (k2 && (Ye = ue ? k2(p2, Y, ue, me) : k2(p2)), Ye !== e2)
            return Ye;
          if (!la(p2))
            return p2;
          var Tr = Yn(p2);
          if (Tr) {
            if (Ye = tn(p2), !tt)
              return Ze(p2, Ye);
          } else {
            var Br = nr(p2), Jr = Br == _n || Br == Za;
            if (Bt(p2))
              return L(p2, tt);
            if (Br == hi || Br == hn || Jr && !ue) {
              if (Ye = pt || Jr ? {} : Sn(p2), !tt)
                return pt ? sr(p2, gc(Ye, p2)) : ct(p2, eS(Ye, p2));
            } else {
              if (!Io[Br])
                return ue ? p2 : {};
              Ye = Ca(p2, Br, tt);
            }
          }
          me || (me = new Cf());
          var Ln = me.get(p2);
          if (Ln)
            return Ln;
          me.set(p2, Ye), hv(p2) ? p2.forEach(function(Un) {
            Ye.add(Gc(Un, x2, k2, Un, p2, me));
          }) : hd(p2) && p2.forEach(function(Un, Ya) {
            Ye.set(Ya, Gc(Un, x2, k2, Ya, p2, me));
          });
          var $n = Cr ? pt ? qo : Xs : pt ? js : Wo, _a2 = Tr ? e2 : $n(p2);
          return Gl(_a2 || p2, function(Un, Ya) {
            _a2 && (Ya = Un, Un = p2[Ya]), Zy(Ye, Ya, Gc(Un, x2, k2, Ya, p2, me));
          }), Ye;
        }
        function tS(p2) {
          var x2 = Wo(p2);
          return function(k2) {
            return kA(k2, p2, x2);
          };
        }
        function kA(p2, x2, k2) {
          var Y = k2.length;
          if (p2 == null)
            return !Y;
          for (p2 = Hi(p2); Y--; ) {
            var ue = k2[Y], me = x2[ue], Ye = p2[ue];
            if (Ye === e2 && !(ue in p2) || !me(Ye))
              return false;
          }
          return true;
        }
        function RA(p2, x2, k2) {
          if (typeof p2 != "function")
            throw new Bc(o);
          return Hl(function() {
            p2.apply(e2, k2);
          }, x2);
        }
        function Jy(p2, x2, k2, Y) {
          var ue = -1, me = fp, Ye = true, tt = p2.length, pt = [], Cr = x2.length;
          if (!tt)
            return pt;
          k2 && (x2 = Ho(x2, Xu(k2))), Y ? (me = $w, Ye = false) : x2.length >= a && (me = Qv, Ye = false, x2 = new av(x2));
          e:
            for (; ++ue < tt; ) {
              var Tr = p2[ue], Br = k2 == null ? Tr : k2(Tr);
              if (Tr = Y || Tr !== 0 ? Tr : 0, Ye && Br === Br) {
                for (var Jr = Cr; Jr--; )
                  if (x2[Jr] === Br)
                    continue e;
                pt.push(Tr);
              } else
                me(x2, Br, Y) || pt.push(Tr);
            }
          return pt;
        }
        var ad = le(Du), FA = le(O1, true);
        function NA(p2, x2) {
          var k2 = true;
          return ad(p2, function(Y, ue, me) {
            return k2 = !!x2(Y, ue, me), k2;
          }), k2;
        }
        function Qy(p2, x2, k2) {
          for (var Y = -1, ue = p2.length; ++Y < ue; ) {
            var me = p2[Y], Ye = x2(me);
            if (Ye != null && (tt === e2 ? Ye === Ye && !sl(Ye) : k2(Ye, tt)))
              var tt = Ye, pt = me;
          }
          return pt;
        }
        function rS(p2, x2, k2, Y) {
          var ue = p2.length;
          for (k2 = La(k2), k2 < 0 && (k2 = -k2 > ue ? 0 : ue + k2), Y = Y === e2 || Y > ue ? ue : La(Y), Y < 0 && (Y += ue), Y = k2 > Y ? 0 : Np(Y); k2 < Y; )
            p2[k2++] = x2;
          return p2;
        }
        function Yg(p2, x2) {
          var k2 = [];
          return ad(p2, function(Y, ue, me) {
            x2(Y, ue, me) && k2.push(Y);
          }), k2;
        }
        function Pu(p2, x2, k2, Y, ue) {
          var me = -1, Ye = p2.length;
          for (k2 || (k2 = Di), ue || (ue = []); ++me < Ye; ) {
            var tt = p2[me];
            x2 > 0 && k2(tt) ? x2 > 1 ? Pu(tt, x2 - 1, k2, Y, ue) : Jv(ue, tt) : Y || (ue[ue.length] = tt);
          }
          return ue;
        }
        var nS = _t(), VA = _t(true);
        function Du(p2, x2) {
          return p2 && nS(p2, x2, Wo);
        }
        function O1(p2, x2) {
          return p2 && VA(p2, x2, Wo);
        }
        function k1(p2, x2) {
          return Xv(x2, function(k2) {
            return Ko(p2[k2]);
          });
        }
        function mp(p2, x2) {
          x2 = T(x2, p2);
          for (var k2 = 0, Y = x2.length; p2 != null && k2 < Y; )
            p2 = p2[De(x2[k2++])];
          return k2 && k2 == Y ? p2 : e2;
        }
        function aS(p2, x2, k2) {
          var Y = x2(p2);
          return Yn(p2) ? Y : Jv(Y, k2(p2));
        }
        function tl(p2) {
          return p2 == null ? p2 === e2 ? mf : wi : zc && zc in Hi(p2) ? Fs(p2) : Ou(p2);
        }
        function R1(p2, x2) {
          return p2 > x2;
        }
        function iS(p2, x2) {
          return p2 != null && oo.call(p2, x2);
        }
        function jA(p2, x2) {
          return p2 != null && x2 in Hi(p2);
        }
        function F1(p2, x2, k2) {
          return p2 >= Qu(x2, k2) && p2 < Zs(x2, k2);
        }
        function oS(p2, x2, k2) {
          for (var Y = k2 ? $w : fp, ue = p2[0].length, me = p2.length, Ye = me, tt = Zt(me), pt = 1 / 0, Cr = []; Ye--; ) {
            var Tr = p2[Ye];
            Ye && x2 && (Tr = Ho(Tr, Xu(x2))), pt = Qu(Tr.length, pt), tt[Ye] = !k2 && (x2 || ue >= 120 && Tr.length >= 120) ? new av(Ye && Tr) : e2;
          }
          Tr = p2[0];
          var Br = -1, Jr = tt[0];
          e:
            for (; ++Br < ue && Cr.length < pt; ) {
              var Ln = Tr[Br], $n = x2 ? x2(Ln) : Ln;
              if (Ln = k2 || Ln !== 0 ? Ln : 0, !(Jr ? Qv(Jr, $n) : Y(Cr, $n, k2))) {
                for (Ye = me; --Ye; ) {
                  var _a2 = tt[Ye];
                  if (!(_a2 ? Qv(_a2, $n) : Y(p2[Ye], $n, k2)))
                    continue e;
                }
                Jr && Jr.push($n), Cr.push(Ln);
              }
            }
          return Cr;
        }
        function ra(p2, x2, k2, Y) {
          return Du(p2, function(ue, me, Ye) {
            x2(Y, k2(ue), me, Ye);
          }), Y;
        }
        function Kg(p2, x2, k2) {
          x2 = T(x2, p2), p2 = il(p2, x2);
          var Y = p2 == null ? p2 : p2[De(ss(x2))];
          return Y == null ? e2 : pc(Y, p2, k2);
        }
        function BA(p2) {
          return xo(p2) && tl(p2) == hn;
        }
        function LD(p2) {
          return xo(p2) && tl(p2) == Ot;
        }
        function OD(p2) {
          return xo(p2) && tl(p2) == on;
        }
        function Zg(p2, x2, k2, Y, ue) {
          return p2 === x2 ? true : p2 == null || x2 == null || !xo(p2) && !xo(x2) ? p2 !== p2 && x2 !== x2 : N1(p2, x2, k2, Y, Zg, ue);
        }
        function N1(p2, x2, k2, Y, ue, me) {
          var Ye = Yn(p2), tt = Yn(x2), pt = Ye ? cn : nr(p2), Cr = tt ? cn : nr(x2);
          pt = pt == hn ? hi : pt, Cr = Cr == hn ? hi : Cr;
          var Tr = pt == hi, Br = Cr == hi, Jr = pt == Cr;
          if (Jr && Bt(p2)) {
            if (!Bt(x2))
              return false;
            Ye = true, Tr = false;
          }
          if (Jr && !Tr)
            return me || (me = new Cf()), Ye || Kl(p2) ? pi(p2, x2, k2, Y, ue, me) : Lo(p2, x2, pt, k2, Y, ue, me);
          if (!(k2 & d2)) {
            var Ln = Tr && oo.call(p2, "__wrapped__"), $n = Br && oo.call(x2, "__wrapped__");
            if (Ln || $n) {
              var _a2 = Ln ? p2.value() : p2, Un = $n ? x2.value() : x2;
              return me || (me = new Cf()), ue(_a2, Un, k2, Y, me);
            }
          }
          return Jr ? (me || (me = new Cf()), rl(p2, x2, k2, Y, ue, me)) : false;
        }
        function bp(p2) {
          return xo(p2) && nr(p2) == Dn;
        }
        function em(p2, x2, k2, Y) {
          var ue = k2.length, me = ue, Ye = !Y;
          if (p2 == null)
            return !me;
          for (p2 = Hi(p2); ue--; ) {
            var tt = k2[ue];
            if (Ye && tt[2] ? tt[1] !== p2[tt[0]] : !(tt[0] in p2))
              return false;
          }
          for (; ++ue < me; ) {
            tt = k2[ue];
            var pt = tt[0], Cr = p2[pt], Tr = tt[1];
            if (Ye && tt[2]) {
              if (Cr === e2 && !(pt in p2))
                return false;
            } else {
              var Br = new Cf();
              if (Y)
                var Jr = Y(Cr, Tr, pt, p2, x2, Br);
              if (!(Jr === e2 ? Zg(Tr, Cr, d2 | m2, Y, Br) : Jr))
                return false;
            }
          }
          return true;
        }
        function tm(p2) {
          if (!la(p2) || Lu(p2))
            return false;
          var x2 = Ko(p2) ? aD : At;
          return x2.test(ze(p2));
        }
        function kD(p2) {
          return xo(p2) && tl(p2) == Au;
        }
        function zA(p2) {
          return xo(p2) && nr(p2) == Zi;
        }
        function RD(p2) {
          return xo(p2) && s0(p2.length) && !!zo[tl(p2)];
        }
        function _p(p2) {
          return typeof p2 == "function" ? p2 : p2 == null ? bu : typeof p2 == "object" ? Yn(p2) ? j1(p2[0], p2[1]) : uS(p2) : M_(p2);
        }
        function Xg(p2) {
          if (!ws(p2))
            return lD(p2);
          var x2 = [];
          for (var k2 in Hi(p2))
            oo.call(p2, k2) && k2 != "constructor" && x2.push(k2);
          return x2;
        }
        function sS(p2) {
          if (!la(p2))
            return al(p2);
          var x2 = ws(p2), k2 = [];
          for (var Y in p2)
            Y == "constructor" && (x2 || !oo.call(p2, Y)) || k2.push(Y);
          return k2;
        }
        function V1(p2, x2) {
          return p2 < x2;
        }
        function $A(p2, x2) {
          var k2 = -1, Y = Yo(p2) ? Zt(p2.length) : [];
          return ad(p2, function(ue, me, Ye) {
            Y[++k2] = x2(ue, me, Ye);
          }), Y;
        }
        function uS(p2) {
          var x2 = Iu(p2);
          return x2.length == 1 && x2[0][2] ? qa(x2[0][0], x2[0][1]) : function(k2) {
            return k2 === p2 || em(k2, p2, x2);
          };
        }
        function j1(p2, x2) {
          return ko(p2) && Go(x2) ? qa(De(p2), x2) : function(k2) {
            var Y = Xo(k2, p2);
            return Y === e2 && Y === x2 ? Lf(k2, p2) : Zg(x2, Y, d2 | m2);
          };
        }
        function id2(p2, x2, k2, Y, ue) {
          p2 !== x2 && nS(x2, function(me, Ye) {
            if (ue || (ue = new Cf()), la(me))
              FD(p2, x2, Ye, k2, id2, Y, ue);
            else {
              var tt = Y ? Y(bc(p2, Ye), me, Ye + "", p2, x2, ue) : e2;
              tt === e2 && (tt = me), Qw(p2, Ye, tt);
            }
          }, js);
        }
        function FD(p2, x2, k2, Y, ue, me, Ye) {
          var tt = bc(p2, k2), pt = bc(x2, k2), Cr = Ye.get(pt);
          if (Cr) {
            Qw(p2, k2, Cr);
            return;
          }
          var Tr = me ? me(tt, pt, k2 + "", p2, x2, Ye) : e2, Br = Tr === e2;
          if (Br) {
            var Jr = Yn(pt), Ln = !Jr && Bt(pt), $n = !Jr && !Ln && Kl(pt);
            Tr = pt, Jr || Ln || $n ? Yn(tt) ? Tr = tt : rt2(tt) ? Tr = Ze(tt) : Ln ? (Br = false, Tr = L(pt, true)) : $n ? (Br = false, Tr = he(pt, true)) : Tr = [] : Pf(pt) || mh(pt) ? (Tr = tt, mh(tt) ? Tr = f0(tt) : (!la(tt) || Ko(tt)) && (Tr = Sn(pt))) : Br = false;
          }
          Br && (Ye.set(pt, Tr), ue(Tr, pt, Y, me, Ye), Ye.delete(pt)), Qw(p2, k2, Tr);
        }
        function lS(p2, x2) {
          var k2 = p2.length;
          if (!!k2)
            return x2 += x2 < 0 ? k2 : 0, Mi(x2, k2) ? p2[x2] : e2;
        }
        function cS(p2, x2, k2) {
          x2.length ? x2 = Ho(x2, function(me) {
            return Yn(me) ? function(Ye) {
              return mp(Ye, me.length === 1 ? me[0] : me);
            } : me;
          }) : x2 = [bu];
          var Y = -1;
          x2 = Ho(x2, Xu(Rn()));
          var ue = $A(p2, function(me, Ye, tt) {
            var pt = Ho(x2, function(Cr) {
              return Cr(me);
            });
            return { criteria: pt, index: ++Y, value: me };
          });
          return vu(ue, function(me, Ye) {
            return Ae(me, Ye, k2);
          });
        }
        function ND(p2, x2) {
          return GA(p2, x2, function(k2, Y) {
            return Lf(p2, Y);
          });
        }
        function GA(p2, x2, k2) {
          for (var Y = -1, ue = x2.length, me = {}; ++Y < ue; ) {
            var Ye = x2[Y], tt = mp(p2, Ye);
            k2(tt, Ye) && rm(me, T(Ye, p2), tt);
          }
          return me;
        }
        function VD(p2) {
          return function(x2) {
            return mp(x2, p2);
          };
        }
        function B1(p2, x2, k2, Y) {
          var ue = Y ? Y3 : ev, me = -1, Ye = x2.length, tt = p2;
          for (p2 === x2 && (x2 = Ze(x2)), k2 && (tt = Ho(p2, Xu(k2))); ++me < Ye; )
            for (var pt = 0, Cr = x2[me], Tr = k2 ? k2(Cr) : Cr; (pt = ue(tt, Tr, pt, Y)) > -1; )
              tt !== p2 && rd.call(tt, pt, 1), rd.call(p2, pt, 1);
          return p2;
        }
        function xp(p2, x2) {
          for (var k2 = p2 ? x2.length : 0, Y = k2 - 1; k2--; ) {
            var ue = x2[k2];
            if (k2 == Y || ue !== me) {
              var me = ue;
              Mi(ue) ? rd.call(p2, ue, 1) : vS(p2, ue);
            }
          }
          return p2;
        }
        function fS(p2, x2) {
          return p2 + I1(EA() * (x2 - p2 + 1));
        }
        function jD(p2, x2, k2, Y) {
          for (var ue = -1, me = Zs(D1((x2 - p2) / (k2 || 1)), 0), Ye = Zt(me); me--; )
            Ye[Y ? me : ++ue] = p2, p2 += k2;
          return Ye;
        }
        function z1(p2, x2) {
          var k2 = "";
          if (!p2 || x2 < 1 || x2 > Le)
            return k2;
          do
            x2 % 2 && (k2 += p2), x2 = I1(x2 / 2), x2 && (p2 += p2);
          while (x2);
          return k2;
        }
        function Xa(p2, x2) {
          return wp(pu(p2, x2, bu), p2 + "");
        }
        function $1(p2) {
          return Ky(yv(p2));
        }
        function BD(p2, x2) {
          var k2 = yv(p2);
          return sd(k2, yp(x2, 0, k2.length));
        }
        function rm(p2, x2, k2, Y) {
          if (!la(p2))
            return p2;
          x2 = T(x2, p2);
          for (var ue = -1, me = x2.length, Ye = me - 1, tt = p2; tt != null && ++ue < me; ) {
            var pt = De(x2[ue]), Cr = k2;
            if (pt === "__proto__" || pt === "constructor" || pt === "prototype")
              return p2;
            if (ue != Ye) {
              var Tr = tt[pt];
              Cr = Y ? Y(Tr, pt, tt) : e2, Cr === e2 && (Cr = la(Tr) ? Tr : Mi(x2[ue + 1]) ? [] : {});
            }
            Zy(tt, pt, Cr), tt = tt[pt];
          }
          return p2;
        }
        var WA = el ? function(p2, x2) {
          return el.set(p2, x2), p2;
        } : bu, UA = P1 ? function(p2, x2) {
          return P1(p2, "toString", { configurable: true, enumerable: false, value: xd(x2), writable: true });
        } : bu;
        function zD(p2) {
          return sd(yv(p2));
        }
        function Wc(p2, x2, k2) {
          var Y = -1, ue = p2.length;
          x2 < 0 && (x2 = -x2 > ue ? 0 : ue + x2), k2 = k2 > ue ? ue : k2, k2 < 0 && (k2 += ue), ue = x2 > k2 ? 0 : k2 - x2 >>> 0, x2 >>>= 0;
          for (var me = Zt(ue); ++Y < ue; )
            me[Y] = p2[Y + x2];
          return me;
        }
        function $D(p2, x2) {
          var k2;
          return ad(p2, function(Y, ue, me) {
            return k2 = x2(Y, ue, me), !k2;
          }), !!k2;
        }
        function G1(p2, x2, k2) {
          var Y = 0, ue = p2 == null ? Y : p2.length;
          if (typeof x2 == "number" && x2 === x2 && ue <= Ar) {
            for (; Y < ue; ) {
              var me = Y + ue >>> 1, Ye = p2[me];
              Ye !== null && !sl(Ye) && (k2 ? Ye <= x2 : Ye < x2) ? Y = me + 1 : ue = me;
            }
            return ue;
          }
          return W1(p2, x2, bu, k2);
        }
        function W1(p2, x2, k2, Y) {
          var ue = 0, me = p2 == null ? 0 : p2.length;
          if (me === 0)
            return 0;
          x2 = k2(x2);
          for (var Ye = x2 !== x2, tt = x2 === null, pt = sl(x2), Cr = x2 === e2; ue < me; ) {
            var Tr = I1((ue + me) / 2), Br = k2(p2[Tr]), Jr = Br !== e2, Ln = Br === null, $n = Br === Br, _a2 = sl(Br);
            if (Ye)
              var Un = Y || $n;
            else
              Cr ? Un = $n && (Y || Jr) : tt ? Un = $n && Jr && (Y || !Ln) : pt ? Un = $n && Jr && !Ln && (Y || !_a2) : Ln || _a2 ? Un = false : Un = Y ? Br <= x2 : Br < x2;
            Un ? ue = Tr + 1 : me = Tr;
          }
          return Qu(me, dt);
        }
        function HA(p2, x2) {
          for (var k2 = -1, Y = p2.length, ue = 0, me = []; ++k2 < Y; ) {
            var Ye = p2[k2], tt = x2 ? x2(Ye) : Ye;
            if (!k2 || !ii(tt, pt)) {
              var pt = tt;
              me[ue++] = Ye === 0 ? 0 : Ye;
            }
          }
          return me;
        }
        function hS(p2) {
          return typeof p2 == "number" ? p2 : sl(p2) ? qe : +p2;
        }
        function yc(p2) {
          if (typeof p2 == "string")
            return p2;
          if (Yn(p2))
            return Ho(p2, yc) + "";
          if (sl(p2))
            return Yw ? Yw.call(p2) : "";
          var x2 = p2 + "";
          return x2 == "0" && 1 / p2 == -et ? "-0" : x2;
        }
        function sh(p2, x2, k2) {
          var Y = -1, ue = fp, me = p2.length, Ye = true, tt = [], pt = tt;
          if (k2)
            Ye = false, ue = $w;
          else if (me >= a) {
            var Cr = x2 ? null : Qn(p2);
            if (Cr)
              return $g(Cr);
            Ye = false, ue = Qv, pt = new av();
          } else
            pt = x2 ? [] : tt;
          e:
            for (; ++Y < me; ) {
              var Tr = p2[Y], Br = x2 ? x2(Tr) : Tr;
              if (Tr = k2 || Tr !== 0 ? Tr : 0, Ye && Br === Br) {
                for (var Jr = pt.length; Jr--; )
                  if (pt[Jr] === Br)
                    continue e;
                x2 && pt.push(Br), tt.push(Tr);
              } else
                ue(pt, Br, k2) || (pt !== tt && pt.push(Br), tt.push(Tr));
            }
          return tt;
        }
        function vS(p2, x2) {
          return x2 = T(x2, p2), p2 = il(p2, x2), p2 == null || delete p2[De(ss(x2))];
        }
        function GD(p2, x2, k2, Y) {
          return rm(p2, x2, k2(mp(p2, x2)), Y);
        }
        function U1(p2, x2, k2, Y) {
          for (var ue = p2.length, me = Y ? ue : -1; (Y ? me-- : ++me < ue) && x2(p2[me], me, p2); )
            ;
          return k2 ? Wc(p2, Y ? 0 : me, Y ? me + 1 : ue) : Wc(p2, Y ? me + 1 : 0, Y ? ue : me);
        }
        function qA(p2, x2) {
          var k2 = p2;
          return k2 instanceof di && (k2 = k2.value()), y1(x2, function(Y, ue) {
            return ue.func.apply(ue.thisArg, Jv([Y], ue.args));
          }, k2);
        }
        function dS(p2, x2, k2) {
          var Y = p2.length;
          if (Y < 2)
            return Y ? sh(p2[0]) : [];
          for (var ue = -1, me = Zt(Y); ++ue < Y; )
            for (var Ye = p2[ue], tt = -1; ++tt < Y; )
              tt != ue && (me[ue] = Jy(me[ue] || Ye, p2[tt], x2, k2));
          return sh(Pu(me, 1), x2, k2);
        }
        function pS(p2, x2, k2) {
          for (var Y = -1, ue = p2.length, me = x2.length, Ye = {}; ++Y < ue; ) {
            var tt = Y < me ? x2[Y] : e2;
            k2(Ye, p2[Y], tt);
          }
          return Ye;
        }
        function gS(p2) {
          return rt2(p2) ? p2 : [];
        }
        function yS(p2) {
          return typeof p2 == "function" ? p2 : bu;
        }
        function T(p2, x2) {
          return Yn(p2) ? p2 : ko(p2, x2) ? [p2] : lh(Ri(p2));
        }
        var G = Xa;
        function P(p2, x2, k2) {
          var Y = p2.length;
          return k2 = k2 === e2 ? Y : k2, !x2 && k2 >= Y ? p2 : Wc(p2, x2, k2);
        }
        var I = iD || function(p2) {
          return hu.clearTimeout(p2);
        };
        function L(p2, x2) {
          if (x2)
            return p2.slice();
          var k2 = p2.length, Y = Hw ? Hw(k2) : new p2.constructor(k2);
          return p2.copy(Y), Y;
        }
        function j(p2) {
          var x2 = new p2.constructor(p2.byteLength);
          return new $y(x2).set(new $y(p2)), x2;
        }
        function J(p2, x2) {
          var k2 = x2 ? j(p2.buffer) : p2.buffer;
          return new p2.constructor(k2, p2.byteOffset, p2.byteLength);
        }
        function te(p2) {
          var x2 = new p2.constructor(p2.source, ke.exec(p2));
          return x2.lastIndex = p2.lastIndex, x2;
        }
        function Q(p2) {
          return xf ? Hi(xf.call(p2)) : {};
        }
        function he(p2, x2) {
          var k2 = x2 ? j(p2.buffer) : p2.buffer;
          return new p2.constructor(k2, p2.byteOffset, p2.length);
        }
        function de(p2, x2) {
          if (p2 !== x2) {
            var k2 = p2 !== e2, Y = p2 === null, ue = p2 === p2, me = sl(p2), Ye = x2 !== e2, tt = x2 === null, pt = x2 === x2, Cr = sl(x2);
            if (!tt && !Cr && !me && p2 > x2 || me && Ye && pt && !tt && !Cr || Y && Ye && pt || !k2 && pt || !ue)
              return 1;
            if (!Y && !me && !Cr && p2 < x2 || Cr && k2 && ue && !Y && !me || tt && k2 && ue || !Ye && ue || !pt)
              return -1;
          }
          return 0;
        }
        function Ae(p2, x2, k2) {
          for (var Y = -1, ue = p2.criteria, me = x2.criteria, Ye = ue.length, tt = k2.length; ++Y < Ye; ) {
            var pt = de(ue[Y], me[Y]);
            if (pt) {
              if (Y >= tt)
                return pt;
              var Cr = k2[Y];
              return pt * (Cr == "desc" ? -1 : 1);
            }
          }
          return p2.index - x2.index;
        }
        function We(p2, x2, k2, Y) {
          for (var ue = -1, me = p2.length, Ye = k2.length, tt = -1, pt = x2.length, Cr = Zs(me - Ye, 0), Tr = Zt(pt + Cr), Br = !Y; ++tt < pt; )
            Tr[tt] = x2[tt];
          for (; ++ue < Ye; )
            (Br || ue < me) && (Tr[k2[ue]] = p2[ue]);
          for (; Cr--; )
            Tr[tt++] = p2[ue++];
          return Tr;
        }
        function Xe(p2, x2, k2, Y) {
          for (var ue = -1, me = p2.length, Ye = -1, tt = k2.length, pt = -1, Cr = x2.length, Tr = Zs(me - tt, 0), Br = Zt(Tr + Cr), Jr = !Y; ++ue < Tr; )
            Br[ue] = p2[ue];
          for (var Ln = ue; ++pt < Cr; )
            Br[Ln + pt] = x2[pt];
          for (; ++Ye < tt; )
            (Jr || ue < me) && (Br[Ln + k2[Ye]] = p2[ue++]);
          return Br;
        }
        function Ze(p2, x2) {
          var k2 = -1, Y = p2.length;
          for (x2 || (x2 = Zt(Y)); ++k2 < Y; )
            x2[k2] = p2[k2];
          return x2;
        }
        function it(p2, x2, k2, Y) {
          var ue = !k2;
          k2 || (k2 = {});
          for (var me = -1, Ye = x2.length; ++me < Ye; ) {
            var tt = x2[me], pt = Y ? Y(k2[tt], p2[tt], tt, k2, p2) : e2;
            pt === e2 && (pt = p2[tt]), ue ? iv(k2, tt, pt) : Zy(k2, tt, pt);
          }
          return k2;
        }
        function ct(p2, x2) {
          return it(p2, Oo(p2), x2);
        }
        function sr(p2, x2) {
          return it(p2, mc(p2), x2);
        }
        function Yt(p2, x2) {
          return function(k2, Y) {
            var ue = Yn(k2) ? g1 : ID, me = x2 ? x2() : {};
            return ue(k2, p2, Rn(Y, 2), me);
          };
        }
        function Or(p2) {
          return Xa(function(x2, k2) {
            var Y = -1, ue = k2.length, me = ue > 1 ? k2[ue - 1] : e2, Ye = ue > 2 ? k2[2] : e2;
            for (me = p2.length > 3 && typeof me == "function" ? (ue--, me) : e2, Ye && Da(k2[0], k2[1], Ye) && (me = ue < 3 ? e2 : me, ue = 1), x2 = Hi(x2); ++Y < ue; ) {
              var tt = k2[Y];
              tt && p2(x2, tt, Y, me);
            }
            return x2;
          });
        }
        function le(p2, x2) {
          return function(k2, Y) {
            if (k2 == null)
              return k2;
            if (!Yo(k2))
              return p2(k2, Y);
            for (var ue = k2.length, me = x2 ? ue : -1, Ye = Hi(k2); (x2 ? me-- : ++me < ue) && Y(Ye[me], me, Ye) !== false; )
              ;
            return k2;
          };
        }
        function _t(p2) {
          return function(x2, k2, Y) {
            for (var ue = -1, me = Hi(x2), Ye = Y(x2), tt = Ye.length; tt--; ) {
              var pt = Ye[p2 ? tt : ++ue];
              if (k2(me[pt], pt, me) === false)
                break;
            }
            return x2;
          };
        }
        function Pt(p2, x2, k2) {
          var Y = x2 & b2, ue = St(p2);
          function me() {
            var Ye = this && this !== hu && this instanceof me ? ue : p2;
            return Ye.apply(Y ? k2 : this, arguments);
          }
          return me;
        }
        function er(p2) {
          return function(x2) {
            x2 = Ri(x2);
            var k2 = zg(x2) ? _f(x2) : e2, Y = k2 ? k2[0] : x2.charAt(0), ue = k2 ? P(k2, 1).join("") : x2.slice(1);
            return Y[p2]() + ue;
          };
        }
        function Kt(p2) {
          return function(x2) {
            return y1(b0(x_(x2).replace(oA, "")), p2, "");
          };
        }
        function St(p2) {
          return function() {
            var x2 = arguments;
            switch (x2.length) {
              case 0:
                return new p2();
              case 1:
                return new p2(x2[0]);
              case 2:
                return new p2(x2[0], x2[1]);
              case 3:
                return new p2(x2[0], x2[1], x2[2]);
              case 4:
                return new p2(x2[0], x2[1], x2[2], x2[3]);
              case 5:
                return new p2(x2[0], x2[1], x2[2], x2[3], x2[4]);
              case 6:
                return new p2(x2[0], x2[1], x2[2], x2[3], x2[4], x2[5]);
              case 7:
                return new p2(x2[0], x2[1], x2[2], x2[3], x2[4], x2[5], x2[6]);
            }
            var k2 = pp(p2.prototype), Y = p2.apply(k2, x2);
            return la(Y) ? Y : k2;
          };
        }
        function kt(p2, x2, k2) {
          var Y = St(p2);
          function ue() {
            for (var me = arguments.length, Ye = Zt(me), tt = me, pt = os(ue); tt--; )
              Ye[tt] = arguments[tt];
            var Cr = me < 3 && Ye[0] !== pt && Ye[me - 1] !== pt ? [] : tv(Ye, pt);
            if (me -= Cr.length, me < k2)
              return Yr(p2, x2, ht, ue.placeholder, e2, Ye, Cr, e2, e2, k2 - me);
            var Tr = this && this !== hu && this instanceof ue ? Y : p2;
            return pc(Tr, this, Ye);
          }
          return ue;
        }
        function dr(p2) {
          return function(x2, k2, Y) {
            var ue = Hi(x2);
            if (!Yo(x2)) {
              var me = Rn(k2, 3);
              x2 = Wo(x2), k2 = function(tt) {
                return me(ue[tt], tt, ue);
              };
            }
            var Ye = p2(x2, k2, Y);
            return Ye > -1 ? ue[me ? x2[Ye] : Ye] : e2;
          };
        }
        function Ir(p2) {
          return is(function(x2) {
            var k2 = x2.length, Y = k2, ue = Al.prototype.thru;
            for (p2 && x2.reverse(); Y--; ) {
              var me = x2[Y];
              if (typeof me != "function")
                throw new Bc(o);
              if (ue && !Ye && nl(me) == "wrapper")
                var Ye = new Al([], true);
            }
            for (Y = Ye ? Y : k2; ++Y < k2; ) {
              me = x2[Y];
              var tt = nl(me), pt = tt == "wrapper" ? du(me) : e2;
              pt && xs(pt[0]) && pt[1] == ($ | M | z9 | U) && !pt[4].length && pt[9] == 1 ? Ye = Ye[nl(pt[0])].apply(Ye, pt[3]) : Ye = me.length == 1 && xs(me) ? Ye[tt]() : Ye.thru(me);
            }
            return function() {
              var Cr = arguments, Tr = Cr[0];
              if (Ye && Cr.length == 1 && Yn(Tr))
                return Ye.plant(Tr).value();
              for (var Br = 0, Jr = k2 ? x2[Br].apply(this, Cr) : Tr; ++Br < k2; )
                Jr = x2[Br].call(this, Jr);
              return Jr;
            };
          });
        }
        function ht(p2, x2, k2, Y, ue, me, Ye, tt, pt, Cr) {
          var Tr = x2 & $, Br = x2 & b2, Jr = x2 & _, Ln = x2 & (M | E), $n = x2 & H, _a2 = Jr ? e2 : St(p2);
          function Un() {
            for (var Ya = arguments.length, aa = Zt(Ya), hs = Ya; hs--; )
              aa[hs] = arguments[hs];
            if (Ln)
              var nu = os(Un), ll = w1(aa, nu);
            if (Y && (aa = We(aa, Y, ue, Ln)), me && (aa = Xe(aa, me, Ye, Ln)), Ya -= ll, Ln && Ya < Cr) {
              var A2 = tv(aa, nu);
              return Yr(p2, x2, ht, Un.placeholder, k2, aa, A2, tt, pt, Cr - Ya);
            }
            var W = Br ? k2 : this, D = Jr ? W[p2] : p2;
            return Ya = aa.length, tt ? aa = uh(aa, tt) : $n && Ya > 1 && aa.reverse(), Tr && pt < Ya && (aa.length = pt), this && this !== hu && this instanceof Un && (D = _a2 || St(D)), D.apply(W, aa);
          }
          return Un;
        }
        function gn(p2, x2) {
          return function(k2, Y) {
            return ra(k2, p2, x2(Y), {});
          };
        }
        function ln(p2, x2) {
          return function(k2, Y) {
            var ue;
            if (k2 === e2 && Y === e2)
              return x2;
            if (k2 !== e2 && (ue = k2), Y !== e2) {
              if (ue === e2)
                return Y;
              typeof k2 == "string" || typeof Y == "string" ? (k2 = yc(k2), Y = yc(Y)) : (k2 = hS(k2), Y = hS(Y)), ue = p2(k2, Y);
            }
            return ue;
          };
        }
        function Jt(p2) {
          return is(function(x2) {
            return x2 = Ho(x2, Xu(Rn())), Xa(function(k2) {
              var Y = this;
              return p2(x2, function(ue) {
                return pc(ue, Y, k2);
              });
            });
          });
        }
        function In(p2, x2) {
          x2 = x2 === e2 ? " " : yc(x2);
          var k2 = x2.length;
          if (k2 < 2)
            return k2 ? z1(x2, p2) : x2;
          var Y = z1(x2, D1(p2 / Gg(x2)));
          return zg(x2) ? P(_f(Y), 0, p2).join("") : Y.slice(0, p2);
        }
        function ur(p2, x2, k2, Y) {
          var ue = x2 & b2, me = St(p2);
          function Ye() {
            for (var tt = -1, pt = arguments.length, Cr = -1, Tr = Y.length, Br = Zt(Tr + pt), Jr = this && this !== hu && this instanceof Ye ? me : p2; ++Cr < Tr; )
              Br[Cr] = Y[Cr];
            for (; pt--; )
              Br[Cr++] = arguments[++tt];
            return pc(Jr, ue ? k2 : this, Br);
          }
          return Ye;
        }
        function Gt(p2) {
          return function(x2, k2, Y) {
            return Y && typeof Y != "number" && Da(x2, k2, Y) && (k2 = Y = e2), x2 = Df(x2), k2 === e2 ? (k2 = x2, x2 = 0) : k2 = Df(k2), Y = Y === e2 ? x2 < k2 ? 1 : -1 : Df(Y), jD(x2, k2, Y, p2);
          };
        }
        function zt(p2) {
          return function(x2, k2) {
            return typeof x2 == "string" && typeof k2 == "string" || (x2 = Ru(x2), k2 = Ru(k2)), p2(x2, k2);
          };
        }
        function Yr(p2, x2, k2, Y, ue, me, Ye, tt, pt, Cr) {
          var Tr = x2 & M, Br = Tr ? Ye : e2, Jr = Tr ? e2 : Ye, Ln = Tr ? me : e2, $n = Tr ? e2 : me;
          x2 |= Tr ? z9 : V, x2 &= ~(Tr ? V : z9), x2 & C || (x2 &= ~(b2 | _));
          var _a2 = [p2, x2, ue, Ln, Br, $n, Jr, tt, pt, Cr], Un = k2.apply(e2, _a2);
          return xs(p2) && Jg(Un, _a2), Un.placeholder = Y, Qg(Un, p2, x2);
        }
        function Vr(p2) {
          var x2 = _s[p2];
          return function(k2, Y) {
            if (k2 = Ru(k2), Y = Y == null ? 0 : Qu(La(Y), 292), Y && CA(k2)) {
              var ue = (Ri(k2) + "e").split("e"), me = x2(ue[0] + "e" + (+ue[1] + Y));
              return ue = (Ri(me) + "e").split("e"), +(ue[0] + "e" + (+ue[1] - Y));
            }
            return x2(k2);
          };
        }
        var Qn = nd && 1 / $g(new nd([, -0]))[1] == et ? function(p2) {
          return new nd(p2);
        } : Up;
        function Ua(p2) {
          return function(x2) {
            var k2 = nr(x2);
            return k2 == Dn ? Gw(x2) : k2 == Zi ? J3(x2) : _1(x2, p2(x2));
          };
        }
        function ua(p2, x2, k2, Y, ue, me, Ye, tt) {
          var pt = x2 & _;
          if (!pt && typeof p2 != "function")
            throw new Bc(o);
          var Cr = Y ? Y.length : 0;
          if (Cr || (x2 &= ~(z9 | V), Y = ue = e2), Ye = Ye === e2 ? Ye : Zs(La(Ye), 0), tt = tt === e2 ? tt : La(tt), Cr -= ue ? ue.length : 0, x2 & V) {
            var Tr = Y, Br = ue;
            Y = ue = e2;
          }
          var Jr = pt ? e2 : du(p2), Ln = [p2, x2, k2, Y, ue, Tr, Br, me, Ye, tt];
          if (Jr && Js(Ln, Jr), p2 = Ln[0], x2 = Ln[1], k2 = Ln[2], Y = Ln[3], ue = Ln[4], tt = Ln[9] = Ln[9] === e2 ? pt ? 0 : p2.length : Zs(Ln[9] - Cr, 0), !tt && x2 & (M | E) && (x2 &= ~(M | E)), !x2 || x2 == b2)
            var $n = Pt(p2, x2, k2);
          else
            x2 == M || x2 == E ? $n = kt(p2, x2, tt) : (x2 == z9 || x2 == (b2 | z9)) && !ue.length ? $n = ur(p2, x2, k2, Y) : $n = ht.apply(e2, Ln);
          var _a2 = Jr ? WA : Jg;
          return Qg(_a2($n, Ln), p2, x2);
        }
        function Pa(p2, x2, k2, Y) {
          return p2 === e2 || ii(p2, Hg[k2]) && !oo.call(Y, k2) ? x2 : p2;
        }
        function qi(p2, x2, k2, Y, ue, me) {
          return la(p2) && la(x2) && (me.set(x2, p2), id2(p2, x2, e2, qi, me), me.delete(x2)), p2;
        }
        function Ha(p2) {
          return Pf(p2) ? e2 : p2;
        }
        function pi(p2, x2, k2, Y, ue, me) {
          var Ye = k2 & d2, tt = p2.length, pt = x2.length;
          if (tt != pt && !(Ye && pt > tt))
            return false;
          var Cr = me.get(p2), Tr = me.get(x2);
          if (Cr && Tr)
            return Cr == x2 && Tr == p2;
          var Br = -1, Jr = true, Ln = k2 & m2 ? new av() : e2;
          for (me.set(p2, x2), me.set(x2, p2); ++Br < tt; ) {
            var $n = p2[Br], _a2 = x2[Br];
            if (Y)
              var Un = Ye ? Y(_a2, $n, Br, x2, p2, me) : Y($n, _a2, Br, p2, x2, me);
            if (Un !== e2) {
              if (Un)
                continue;
              Jr = false;
              break;
            }
            if (Ln) {
              if (!cs(x2, function(Ya, aa) {
                if (!Qv(Ln, aa) && ($n === Ya || ue($n, Ya, k2, Y, me)))
                  return Ln.push(aa);
              })) {
                Jr = false;
                break;
              }
            } else if (!($n === _a2 || ue($n, _a2, k2, Y, me))) {
              Jr = false;
              break;
            }
          }
          return me.delete(p2), me.delete(x2), Jr;
        }
        function Lo(p2, x2, k2, Y, ue, me, Ye) {
          switch (k2) {
            case wr:
              if (p2.byteLength != x2.byteLength || p2.byteOffset != x2.byteOffset)
                return false;
              p2 = p2.buffer, x2 = x2.buffer;
            case Ot:
              return !(p2.byteLength != x2.byteLength || !me(new $y(p2), new $y(x2)));
            case Wr:
            case on:
            case ai:
              return ii(+p2, +x2);
            case Xr:
              return p2.name == x2.name && p2.message == x2.message;
            case Au:
            case ys:
              return p2 == x2 + "";
            case Dn:
              var tt = Gw;
            case Zi:
              var pt = Y & d2;
              if (tt || (tt = $g), p2.size != x2.size && !pt)
                return false;
              var Cr = Ye.get(p2);
              if (Cr)
                return Cr == x2;
              Y |= m2, Ye.set(p2, x2);
              var Tr = pi(tt(p2), tt(x2), Y, ue, me, Ye);
              return Ye.delete(p2), Tr;
            case Do:
              if (xf)
                return xf.call(p2) == xf.call(x2);
          }
          return false;
        }
        function rl(p2, x2, k2, Y, ue, me) {
          var Ye = k2 & d2, tt = Xs(p2), pt = tt.length, Cr = Xs(x2), Tr = Cr.length;
          if (pt != Tr && !Ye)
            return false;
          for (var Br = pt; Br--; ) {
            var Jr = tt[Br];
            if (!(Ye ? Jr in x2 : oo.call(x2, Jr)))
              return false;
          }
          var Ln = me.get(p2), $n = me.get(x2);
          if (Ln && $n)
            return Ln == x2 && $n == p2;
          var _a2 = true;
          me.set(p2, x2), me.set(x2, p2);
          for (var Un = Ye; ++Br < pt; ) {
            Jr = tt[Br];
            var Ya = p2[Jr], aa = x2[Jr];
            if (Y)
              var hs = Ye ? Y(aa, Ya, Jr, x2, p2, me) : Y(Ya, aa, Jr, p2, x2, me);
            if (!(hs === e2 ? Ya === aa || ue(Ya, aa, k2, Y, me) : hs)) {
              _a2 = false;
              break;
            }
            Un || (Un = Jr == "constructor");
          }
          if (_a2 && !Un) {
            var nu = p2.constructor, ll = x2.constructor;
            nu != ll && "constructor" in p2 && "constructor" in x2 && !(typeof nu == "function" && nu instanceof nu && typeof ll == "function" && ll instanceof ll) && (_a2 = false);
          }
          return me.delete(p2), me.delete(x2), _a2;
        }
        function is(p2) {
          return wp(pu(p2, e2, na), p2 + "");
        }
        function Xs(p2) {
          return aS(p2, Wo, Oo);
        }
        function qo(p2) {
          return aS(p2, js, mc);
        }
        var du = el ? function(p2) {
          return el.get(p2);
        } : Up;
        function nl(p2) {
          for (var x2 = p2.name + "", k2 = dp[x2], Y = oo.call(dp, x2) ? k2.length : 0; Y--; ) {
            var ue = k2[Y], me = ue.func;
            if (me == null || me == p2)
              return ue.name;
          }
          return x2;
        }
        function os(p2) {
          var x2 = oo.call(_e, "placeholder") ? _e : p2;
          return x2.placeholder;
        }
        function Rn() {
          var p2 = _e.iteratee || _0;
          return p2 = p2 === _0 ? _p : p2, arguments.length ? p2(arguments[0], arguments[1]) : p2;
        }
        function Tl(p2, x2) {
          var k2 = p2.__data__;
          return uo(x2) ? k2[typeof x2 == "string" ? "string" : "hash"] : k2.map;
        }
        function Iu(p2) {
          for (var x2 = Wo(p2), k2 = x2.length; k2--; ) {
            var Y = x2[k2], ue = p2[Y];
            x2[k2] = [Y, ue, Go(ue)];
          }
          return x2;
        }
        function so(p2, x2) {
          var k2 = E1(p2, x2);
          return tm(k2) ? k2 : e2;
        }
        function Fs(p2) {
          var x2 = oo.call(p2, zc), k2 = p2[zc];
          try {
            p2[zc] = e2;
            var Y = true;
          } catch {
          }
          var ue = zy.call(p2);
          return Y && (x2 ? p2[zc] = k2 : delete p2[zc]), ue;
        }
        var Oo = qw ? function(p2) {
          return p2 == null ? [] : (p2 = Hi(p2), Xv(qw(p2), function(x2) {
            return M1.call(p2, x2);
          }));
        } : qp, mc = qw ? function(p2) {
          for (var x2 = []; p2; )
            Jv(x2, Oo(p2)), p2 = Gy(p2);
          return x2;
        } : qp, nr = tl;
        (Uy && nr(new Uy(new ArrayBuffer(1))) != wr || Hy && nr(new Hy()) != Dn || hp && nr(hp.resolve()) != qs || nd && nr(new nd()) != Zi || vp && nr(new vp()) != xr) && (nr = function(p2) {
          var x2 = tl(p2), k2 = x2 == hi ? p2.constructor : e2, Y = k2 ? ze(k2) : "";
          if (Y)
            switch (Y) {
              case AA:
                return wr;
              case vD:
                return Dn;
              case TA:
                return qs;
              case dD:
                return Zi;
              case Rs:
                return xr;
            }
          return x2;
        });
        function Nt(p2, x2, k2) {
          for (var Y = -1, ue = k2.length; ++Y < ue; ) {
            var me = k2[Y], Ye = me.size;
            switch (me.type) {
              case "drop":
                p2 += Ye;
                break;
              case "dropRight":
                x2 -= Ye;
                break;
              case "take":
                x2 = Qu(x2, p2 + Ye);
                break;
              case "takeRight":
                p2 = Zs(p2, x2 - Ye);
                break;
            }
          }
          return { start: p2, end: x2 };
        }
        function Rt(p2) {
          var x2 = p2.match(Iw);
          return x2 ? x2[1].split(Lw) : [];
        }
        function _r(p2, x2, k2) {
          x2 = T(x2, p2);
          for (var Y = -1, ue = x2.length, me = false; ++Y < ue; ) {
            var Ye = De(x2[Y]);
            if (!(me = p2 != null && k2(p2, Ye)))
              break;
            p2 = p2[Ye];
          }
          return me || ++Y != ue ? me : (ue = p2 == null ? 0 : p2.length, !!ue && s0(ue) && Mi(Ye, ue) && (Yn(p2) || mh(p2)));
        }
        function tn(p2) {
          var x2 = p2.length, k2 = new p2.constructor(x2);
          return x2 && typeof p2[0] == "string" && oo.call(p2, "index") && (k2.index = p2.index, k2.input = p2.input), k2;
        }
        function Sn(p2) {
          return typeof p2.constructor == "function" && !ws(p2) ? pp(Gy(p2)) : {};
        }
        function Ca(p2, x2, k2) {
          var Y = p2.constructor;
          switch (x2) {
            case Ot:
              return j(p2);
            case Wr:
            case on:
              return new Y(+p2);
            case wr:
              return J(p2, k2);
            case an:
            case Mn:
            case Fa:
            case Ma:
            case ji:
            case Bo:
            case yo:
            case ms:
            case mo:
              return he(p2, k2);
            case Dn:
              return new Y();
            case ai:
            case ys:
              return new Y(p2);
            case Au:
              return te(p2);
            case Zi:
              return new Y();
            case Do:
              return Q(p2);
          }
        }
        function wa(p2, x2) {
          var k2 = x2.length;
          if (!k2)
            return p2;
          var Y = k2 - 1;
          return x2[Y] = (k2 > 1 ? "& " : "") + x2[Y], x2 = x2.join(k2 > 2 ? ", " : " "), p2.replace(Dw, `{
/* [wrapped with ` + x2 + `] */
`);
        }
        function Di(p2) {
          return Yn(p2) || mh(p2) || !!(SA && p2 && p2[SA]);
        }
        function Mi(p2, x2) {
          var k2 = typeof p2;
          return x2 = x2 == null ? Le : x2, !!x2 && (k2 == "number" || k2 != "symbol" && xt.test(p2)) && p2 > -1 && p2 % 1 == 0 && p2 < x2;
        }
        function Da(p2, x2, k2) {
          if (!la(k2))
            return false;
          var Y = typeof x2;
          return (Y == "number" ? Yo(k2) && Mi(x2, k2.length) : Y == "string" && x2 in k2) ? ii(k2[x2], p2) : false;
        }
        function ko(p2, x2) {
          if (Yn(p2))
            return false;
          var k2 = typeof p2;
          return k2 == "number" || k2 == "symbol" || k2 == "boolean" || p2 == null || sl(p2) ? true : vc.test(p2) || !Cl.test(p2) || x2 != null && p2 in Hi(x2);
        }
        function uo(p2) {
          var x2 = typeof p2;
          return x2 == "string" || x2 == "number" || x2 == "symbol" || x2 == "boolean" ? p2 !== "__proto__" : p2 === null;
        }
        function xs(p2) {
          var x2 = nl(p2), k2 = _e[x2];
          if (typeof k2 != "function" || !(x2 in di.prototype))
            return false;
          if (p2 === k2)
            return true;
          var Y = du(k2);
          return !!Y && p2 === Y[0];
        }
        function Lu(p2) {
          return !!_A && _A in p2;
        }
        var Ul = qg ? Ko : qc;
        function ws(p2) {
          var x2 = p2 && p2.constructor, k2 = typeof x2 == "function" && x2.prototype || Hg;
          return p2 === k2;
        }
        function Go(p2) {
          return p2 === p2 && !la(p2);
        }
        function qa(p2, x2) {
          return function(k2) {
            return k2 == null ? false : k2[p2] === x2 && (x2 !== e2 || p2 in Hi(k2));
          };
        }
        function Ss(p2) {
          var x2 = gh(p2, function(Y) {
            return k2.size === l2 && k2.clear(), Y;
          }), k2 = x2.cache;
          return x2;
        }
        function Js(p2, x2) {
          var k2 = p2[1], Y = x2[1], ue = k2 | Y, me = ue < (b2 | _ | $), Ye = Y == $ && k2 == M || Y == $ && k2 == U && p2[7].length <= x2[8] || Y == ($ | U) && x2[7].length <= x2[8] && k2 == M;
          if (!(me || Ye))
            return p2;
          Y & b2 && (p2[2] = x2[2], ue |= k2 & b2 ? 0 : C);
          var tt = x2[3];
          if (tt) {
            var pt = p2[3];
            p2[3] = pt ? We(pt, tt, x2[4]) : tt, p2[4] = pt ? tv(p2[3], c2) : x2[4];
          }
          return tt = x2[5], tt && (pt = p2[5], p2[5] = pt ? Xe(pt, tt, x2[6]) : tt, p2[6] = pt ? tv(p2[5], c2) : x2[6]), tt = x2[7], tt && (p2[7] = tt), Y & $ && (p2[8] = p2[8] == null ? x2[8] : Qu(p2[8], x2[8])), p2[9] == null && (p2[9] = x2[9]), p2[0] = x2[0], p2[1] = ue, p2;
        }
        function al(p2) {
          var x2 = [];
          if (p2 != null)
            for (var k2 in Hi(p2))
              x2.push(k2);
          return x2;
        }
        function Ou(p2) {
          return zy.call(p2);
        }
        function pu(p2, x2, k2) {
          return x2 = Zs(x2 === e2 ? p2.length - 1 : x2, 0), function() {
            for (var Y = arguments, ue = -1, me = Zs(Y.length - x2, 0), Ye = Zt(me); ++ue < me; )
              Ye[ue] = Y[x2 + ue];
            ue = -1;
            for (var tt = Zt(x2 + 1); ++ue < x2; )
              tt[ue] = Y[ue];
            return tt[x2] = k2(Ye), pc(p2, this, tt);
          };
        }
        function il(p2, x2) {
          return x2.length < 2 ? p2 : mp(p2, Wc(x2, 0, -1));
        }
        function uh(p2, x2) {
          for (var k2 = p2.length, Y = Qu(x2.length, k2), ue = Ze(p2); Y--; ) {
            var me = x2[Y];
            p2[Y] = Mi(me, k2) ? ue[me] : e2;
          }
          return p2;
        }
        function bc(p2, x2) {
          if (!(x2 === "constructor" && typeof p2[x2] == "function") && x2 != "__proto__")
            return p2[x2];
        }
        var Jg = od(WA), Hl = oD || function(p2, x2) {
          return hu.setTimeout(p2, x2);
        }, wp = od(UA);
        function Qg(p2, x2, k2) {
          var Y = x2 + "";
          return wp(p2, wa(Y, pe(Rt(Y), k2)));
        }
        function od(p2) {
          var x2 = 0, k2 = 0;
          return function() {
            var Y = cD(), ue = ne - (Y - k2);
            if (k2 = Y, ue > 0) {
              if (++x2 >= oe)
                return arguments[0];
            } else
              x2 = 0;
            return p2.apply(e2, arguments);
          };
        }
        function sd(p2, x2) {
          var k2 = -1, Y = p2.length, ue = Y - 1;
          for (x2 = x2 === e2 ? Y : x2; ++k2 < x2; ) {
            var me = fS(k2, ue), Ye = p2[me];
            p2[me] = p2[k2], p2[k2] = Ye;
          }
          return p2.length = x2, p2;
        }
        var lh = Ss(function(p2) {
          var x2 = [];
          return p2.charCodeAt(0) === 46 && x2.push(""), p2.replace(th, function(k2, Y, ue, me) {
            x2.push(ue ? me.replace($e, "$1") : Y || k2);
          }), x2;
        });
        function De(p2) {
          if (typeof p2 == "string" || sl(p2))
            return p2;
          var x2 = p2 + "";
          return x2 == "0" && 1 / p2 == -et ? "-0" : x2;
        }
        function ze(p2) {
          if (p2 != null) {
            try {
              return Ju.call(p2);
            } catch {
            }
            try {
              return p2 + "";
            } catch {
            }
          }
          return "";
        }
        function pe(p2, x2) {
          return Gl(Hr, function(k2) {
            var Y = "_." + k2[0];
            x2 & k2[1] && !fp(p2, Y) && p2.push(Y);
          }), p2.sort();
        }
        function Oe(p2) {
          if (p2 instanceof di)
            return p2.clone();
          var x2 = new Al(p2.__wrapped__, p2.__chain__);
          return x2.__actions__ = Ze(p2.__actions__), x2.__index__ = p2.__index__, x2.__values__ = p2.__values__, x2;
        }
        function Ve(p2, x2, k2) {
          (k2 ? Da(p2, x2, k2) : x2 === e2) ? x2 = 1 : x2 = Zs(La(x2), 0);
          var Y = p2 == null ? 0 : p2.length;
          if (!Y || x2 < 1)
            return [];
          for (var ue = 0, me = 0, Ye = Zt(D1(Y / x2)); ue < Y; )
            Ye[me++] = Wc(p2, ue, ue += x2);
          return Ye;
        }
        function Tt(p2) {
          for (var x2 = -1, k2 = p2 == null ? 0 : p2.length, Y = 0, ue = []; ++x2 < k2; ) {
            var me = p2[x2];
            me && (ue[Y++] = me);
          }
          return ue;
        }
        function hr() {
          var p2 = arguments.length;
          if (!p2)
            return [];
          for (var x2 = Zt(p2 - 1), k2 = arguments[0], Y = p2; Y--; )
            x2[Y - 1] = arguments[Y];
          return Jv(Yn(k2) ? Ze(k2) : [k2], Pu(x2, 1));
        }
        var Xt = Xa(function(p2, x2) {
          return rt2(p2) ? Jy(p2, Pu(x2, 1, rt2, true)) : [];
        }), lt2 = Xa(function(p2, x2) {
          var k2 = ss(x2);
          return rt2(k2) && (k2 = e2), rt2(p2) ? Jy(p2, Pu(x2, 1, rt2, true), Rn(k2, 2)) : [];
        }), Fr = Xa(function(p2, x2) {
          var k2 = ss(x2);
          return rt2(k2) && (k2 = e2), rt2(p2) ? Jy(p2, Pu(x2, 1, rt2, true), e2, k2) : [];
        });
        function yn(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          return Y ? (x2 = k2 || x2 === e2 ? 1 : La(x2), Wc(p2, x2 < 0 ? 0 : x2, Y)) : [];
        }
        function Ia(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          return Y ? (x2 = k2 || x2 === e2 ? 1 : La(x2), x2 = Y - x2, Wc(p2, 0, x2 < 0 ? 0 : x2)) : [];
        }
        function Ea(p2, x2) {
          return p2 && p2.length ? U1(p2, Rn(x2, 3), true, true) : [];
        }
        function pa(p2, x2) {
          return p2 && p2.length ? U1(p2, Rn(x2, 3), true) : [];
        }
        function Wn(p2, x2, k2, Y) {
          var ue = p2 == null ? 0 : p2.length;
          return ue ? (k2 && typeof k2 != "number" && Da(p2, x2, k2) && (k2 = 0, Y = ue), rS(p2, x2, k2, Y)) : [];
        }
        function ki(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          if (!Y)
            return -1;
          var ue = k2 == null ? 0 : La(k2);
          return ue < 0 && (ue = Zs(Y + ue, 0)), jg(p2, Rn(x2, 3), ue);
        }
        function bo(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          if (!Y)
            return -1;
          var ue = Y - 1;
          return k2 !== e2 && (ue = La(k2), ue = k2 < 0 ? Zs(Y + ue, 0) : Qu(ue, Y - 1)), jg(p2, Rn(x2, 3), ue, true);
        }
        function na(p2) {
          var x2 = p2 == null ? 0 : p2.length;
          return x2 ? Pu(p2, 1) : [];
        }
        function Ro(p2) {
          var x2 = p2 == null ? 0 : p2.length;
          return x2 ? Pu(p2, et) : [];
        }
        function Qs(p2, x2) {
          var k2 = p2 == null ? 0 : p2.length;
          return k2 ? (x2 = x2 === e2 ? 1 : La(x2), Pu(p2, x2)) : [];
        }
        function _c2(p2) {
          for (var x2 = -1, k2 = p2 == null ? 0 : p2.length, Y = {}; ++x2 < k2; ) {
            var ue = p2[x2];
            Y[ue[0]] = ue[1];
          }
          return Y;
        }
        function Ef(p2) {
          return p2 && p2.length ? p2[0] : e2;
        }
        function xc(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          if (!Y)
            return -1;
          var ue = k2 == null ? 0 : La(k2);
          return ue < 0 && (ue = Zs(Y + ue, 0)), ev(p2, x2, ue);
        }
        function ov(p2) {
          var x2 = p2 == null ? 0 : p2.length;
          return x2 ? Wc(p2, 0, -1) : [];
        }
        var Af = Xa(function(p2) {
          var x2 = Ho(p2, gS);
          return x2.length && x2[0] === p2[0] ? oS(x2) : [];
        }), Cs = Xa(function(p2) {
          var x2 = ss(p2), k2 = Ho(p2, gS);
          return x2 === ss(k2) ? x2 = e2 : k2.pop(), k2.length && k2[0] === p2[0] ? oS(k2, Rn(x2, 2)) : [];
        }), wc = Xa(function(p2) {
          var x2 = ss(p2), k2 = Ho(p2, gS);
          return x2 = typeof x2 == "function" ? x2 : e2, x2 && k2.pop(), k2.length && k2[0] === p2[0] ? oS(k2, e2, x2) : [];
        });
        function Es(p2, x2) {
          return p2 == null ? "" : uD.call(p2, x2);
        }
        function ss(p2) {
          var x2 = p2 == null ? 0 : p2.length;
          return x2 ? p2[x2 - 1] : e2;
        }
        function Sc(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          if (!Y)
            return -1;
          var ue = Y;
          return k2 !== e2 && (ue = La(k2), ue = ue < 0 ? Zs(Y + ue, 0) : Qu(ue, Y - 1)), x2 === x2 ? eD(p2, x2, ue) : jg(p2, b1, ue, true);
        }
        function sv(p2, x2) {
          return p2 && p2.length ? lS(p2, La(x2)) : e2;
        }
        var Sp = Xa(ol);
        function ol(p2, x2) {
          return p2 && p2.length && x2 && x2.length ? B1(p2, x2) : p2;
        }
        function ch(p2, x2, k2) {
          return p2 && p2.length && x2 && x2.length ? B1(p2, x2, Rn(k2, 2)) : p2;
        }
        function Tf(p2, x2, k2) {
          return p2 && p2.length && x2 && x2.length ? B1(p2, x2, e2, k2) : p2;
        }
        var Ns = is(function(p2, x2) {
          var k2 = p2 == null ? 0 : p2.length, Y = L1(p2, x2);
          return xp(p2, Ho(x2, function(ue) {
            return Mi(ue, k2) ? +ue : ue;
          }).sort(de)), Y;
        });
        function Cp(p2, x2) {
          var k2 = [];
          if (!(p2 && p2.length))
            return k2;
          var Y = -1, ue = [], me = p2.length;
          for (x2 = Rn(x2, 3); ++Y < me; ) {
            var Ye = p2[Y];
            x2(Ye, Y, p2) && (k2.push(Ye), ue.push(Y));
          }
          return xp(p2, ue), k2;
        }
        function Ml(p2) {
          return p2 == null ? p2 : hD.call(p2);
        }
        function ud(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          return Y ? (k2 && typeof k2 != "number" && Da(p2, x2, k2) ? (x2 = 0, k2 = Y) : (x2 = x2 == null ? 0 : La(x2), k2 = k2 === e2 ? Y : La(k2)), Wc(p2, x2, k2)) : [];
        }
        function uv(p2, x2) {
          return G1(p2, x2);
        }
        function H1(p2, x2, k2) {
          return W1(p2, x2, Rn(k2, 2));
        }
        function q1(p2, x2) {
          var k2 = p2 == null ? 0 : p2.length;
          if (k2) {
            var Y = G1(p2, x2);
            if (Y < k2 && ii(p2[Y], x2))
              return Y;
          }
          return -1;
        }
        function mS(p2, x2) {
          return G1(p2, x2, true);
        }
        function nm(p2, x2, k2) {
          return W1(p2, x2, Rn(k2, 2), true);
        }
        function am(p2, x2) {
          var k2 = p2 == null ? 0 : p2.length;
          if (k2) {
            var Y = G1(p2, x2, true) - 1;
            if (ii(p2[Y], x2))
              return Y;
          }
          return -1;
        }
        function Y1(p2) {
          return p2 && p2.length ? HA(p2) : [];
        }
        function im(p2, x2) {
          return p2 && p2.length ? HA(p2, Rn(x2, 2)) : [];
        }
        function e0(p2) {
          var x2 = p2 == null ? 0 : p2.length;
          return x2 ? Wc(p2, 1, x2) : [];
        }
        function bS(p2, x2, k2) {
          return p2 && p2.length ? (x2 = k2 || x2 === e2 ? 1 : La(x2), Wc(p2, 0, x2 < 0 ? 0 : x2)) : [];
        }
        function K1(p2, x2, k2) {
          var Y = p2 == null ? 0 : p2.length;
          return Y ? (x2 = k2 || x2 === e2 ? 1 : La(x2), x2 = Y - x2, Wc(p2, x2 < 0 ? 0 : x2, Y)) : [];
        }
        function om(p2, x2) {
          return p2 && p2.length ? U1(p2, Rn(x2, 3), false, true) : [];
        }
        function Z1(p2, x2) {
          return p2 && p2.length ? U1(p2, Rn(x2, 3)) : [];
        }
        var sm = Xa(function(p2) {
          return sh(Pu(p2, 1, rt2, true));
        }), um = Xa(function(p2) {
          var x2 = ss(p2);
          return rt2(x2) && (x2 = e2), sh(Pu(p2, 1, rt2, true), Rn(x2, 2));
        }), gu = Xa(function(p2) {
          var x2 = ss(p2);
          return x2 = typeof x2 == "function" ? x2 : e2, sh(Pu(p2, 1, rt2, true), e2, x2);
        });
        function Ep(p2) {
          return p2 && p2.length ? sh(p2) : [];
        }
        function X1(p2, x2) {
          return p2 && p2.length ? sh(p2, Rn(x2, 2)) : [];
        }
        function _S(p2, x2) {
          return x2 = typeof x2 == "function" ? x2 : e2, p2 && p2.length ? sh(p2, e2, x2) : [];
        }
        function lm(p2) {
          if (!(p2 && p2.length))
            return [];
          var x2 = 0;
          return p2 = Xv(p2, function(k2) {
            if (rt2(k2))
              return x2 = Zs(k2.length, x2), true;
          }), Ny(x2, function(k2) {
            return Ho(p2, ky(k2));
          });
        }
        function Cc(p2, x2) {
          if (!(p2 && p2.length))
            return [];
          var k2 = lm(p2);
          return x2 == null ? k2 : Ho(k2, function(Y) {
            return pc(x2, e2, Y);
          });
        }
        var J1 = Xa(function(p2, x2) {
          return rt2(p2) ? Jy(p2, x2) : [];
        }), _o = Xa(function(p2) {
          return dS(Xv(p2, rt2));
        }), lo = Xa(function(p2) {
          var x2 = ss(p2);
          return rt2(x2) && (x2 = e2), dS(Xv(p2, rt2), Rn(x2, 2));
        }), cm = Xa(function(p2) {
          var x2 = ss(p2);
          return x2 = typeof x2 == "function" ? x2 : e2, dS(Xv(p2, rt2), e2, x2);
        }), Q1 = Xa(lm);
        function fm(p2, x2) {
          return pS(p2 || [], x2 || [], Zy);
        }
        function xS(p2, x2) {
          return pS(p2 || [], x2 || [], rm);
        }
        var e_ = Xa(function(p2) {
          var x2 = p2.length, k2 = x2 > 1 ? p2[x2 - 1] : e2;
          return k2 = typeof k2 == "function" ? (p2.pop(), k2) : e2, Cc(p2, k2);
        });
        function t_(p2) {
          var x2 = _e(p2);
          return x2.__chain__ = true, x2;
        }
        function hm(p2, x2) {
          return x2(p2), p2;
        }
        function Ap(p2, x2) {
          return x2(p2);
        }
        var As = is(function(p2) {
          var x2 = p2.length, k2 = x2 ? p2[0] : 0, Y = this.__wrapped__, ue = function(me) {
            return L1(me, p2);
          };
          return x2 > 1 || this.__actions__.length || !(Y instanceof di) || !Mi(k2) ? this.thru(ue) : (Y = Y.slice(k2, +k2 + (x2 ? 1 : 0)), Y.__actions__.push({ func: Ap, args: [ue], thisArg: e2 }), new Al(Y, this.__chain__).thru(function(me) {
            return x2 && !me.length && me.push(e2), me;
          }));
        });
        function t0() {
          return t_(this);
        }
        function fh() {
          return new Al(this.value(), this.__chain__);
        }
        function r_() {
          this.__values__ === e2 && (this.__values__ = p_(this.value()));
          var p2 = this.__index__ >= this.__values__.length, x2 = p2 ? e2 : this.__values__[this.__index__++];
          return { done: p2, value: x2 };
        }
        function vm() {
          return this;
        }
        function ql(p2) {
          for (var x2, k2 = this; k2 instanceof qy; ) {
            var Y = Oe(k2);
            Y.__index__ = 0, Y.__values__ = e2, x2 ? ue.__wrapped__ = Y : x2 = Y;
            var ue = Y;
            k2 = k2.__wrapped__;
          }
          return ue.__wrapped__ = p2, x2;
        }
        function ld() {
          var p2 = this.__wrapped__;
          if (p2 instanceof di) {
            var x2 = p2;
            return this.__actions__.length && (x2 = new di(this)), x2 = x2.reverse(), x2.__actions__.push({ func: Ap, args: [Ml], thisArg: e2 }), new Al(x2, this.__chain__);
          }
          return this.thru(Ml);
        }
        function n_() {
          return qA(this.__wrapped__, this.__actions__);
        }
        var a_ = Yt(function(p2, x2, k2) {
          oo.call(p2, k2) ? ++p2[k2] : iv(p2, k2, 1);
        });
        function Tp(p2, x2, k2) {
          var Y = Yn(p2) ? yA : NA;
          return k2 && Da(p2, x2, k2) && (x2 = e2), Y(p2, Rn(x2, 3));
        }
        function r0(p2, x2) {
          var k2 = Yn(p2) ? Xv : Yg;
          return k2(p2, Rn(x2, 3));
        }
        var dm = dr(ki), Pl = dr(bo);
        function wS(p2, x2) {
          return Pu(lv(p2, x2), 1);
        }
        function ku(p2, x2) {
          return Pu(lv(p2, x2), et);
        }
        function SS(p2, x2, k2) {
          return k2 = k2 === e2 ? 1 : La(k2), Pu(lv(p2, x2), k2);
        }
        function pm(p2, x2) {
          var k2 = Yn(p2) ? Gl : ad;
          return k2(p2, Rn(x2, 3));
        }
        function Mf(p2, x2) {
          var k2 = Yn(p2) ? gA : FA;
          return k2(p2, Rn(x2, 3));
        }
        var Mp = Yt(function(p2, x2, k2) {
          oo.call(p2, k2) ? p2[k2].push(x2) : iv(p2, k2, [x2]);
        });
        function gm(p2, x2, k2, Y) {
          p2 = Yo(p2) ? p2 : yv(p2), k2 = k2 && !Y ? La(k2) : 0;
          var ue = p2.length;
          return k2 < 0 && (k2 = Zs(ue + k2, 0)), vv(p2) ? k2 <= ue && p2.indexOf(x2, k2) > -1 : !!ue && ev(p2, x2, k2) > -1;
        }
        var Sa = Xa(function(p2, x2, k2) {
          var Y = -1, ue = typeof x2 == "function", me = Yo(p2) ? Zt(p2.length) : [];
          return ad(p2, function(Ye) {
            me[++Y] = ue ? pc(x2, Ye, k2) : Kg(Ye, x2, k2);
          }), me;
        }), Yl = Yt(function(p2, x2, k2) {
          iv(p2, k2, x2);
        });
        function lv(p2, x2) {
          var k2 = Yn(p2) ? Ho : $A;
          return k2(p2, Rn(x2, 3));
        }
        function Pp(p2, x2, k2, Y) {
          return p2 == null ? [] : (Yn(x2) || (x2 = x2 == null ? [] : [x2]), k2 = Y ? e2 : k2, Yn(k2) || (k2 = k2 == null ? [] : [k2]), cS(p2, x2, k2));
        }
        var Dp = Yt(function(p2, x2, k2) {
          p2[k2 ? 0 : 1].push(x2);
        }, function() {
          return [[], []];
        });
        function ym(p2, x2, k2) {
          var Y = Yn(p2) ? y1 : Ji, ue = arguments.length < 3;
          return Y(p2, Rn(x2, 4), k2, ue, ad);
        }
        function n0(p2, x2, k2) {
          var Y = Yn(p2) ? q32 : Ji, ue = arguments.length < 3;
          return Y(p2, Rn(x2, 4), k2, ue, FA);
        }
        function CS(p2, x2) {
          var k2 = Yn(p2) ? Xv : Yg;
          return k2(p2, fv(Rn(x2, 3)));
        }
        function a0(p2) {
          var x2 = Yn(p2) ? Ky : $1;
          return x2(p2);
        }
        function i0(p2, x2, k2) {
          (k2 ? Da(p2, x2, k2) : x2 === e2) ? x2 = 1 : x2 = La(x2);
          var Y = Yn(p2) ? PD : BD;
          return Y(p2, x2);
        }
        function hh(p2) {
          var x2 = Yn(p2) ? DD : zD;
          return x2(p2);
        }
        function mm(p2) {
          if (p2 == null)
            return 0;
          if (Yo(p2))
            return vv(p2) ? Gg(p2) : p2.length;
          var x2 = nr(p2);
          return x2 == Dn || x2 == Zi ? p2.size : Xg(p2).length;
        }
        function zi(p2, x2, k2) {
          var Y = Yn(p2) ? cs : $D;
          return k2 && Da(p2, x2, k2) && (x2 = e2), Y(p2, Rn(x2, 3));
        }
        var Ts = Xa(function(p2, x2) {
          if (p2 == null)
            return [];
          var k2 = x2.length;
          return k2 > 1 && Da(p2, x2[0], x2[1]) ? x2 = [] : k2 > 2 && Da(x2[0], x2[1], x2[2]) && (x2 = [x2[0]]), cS(p2, Pu(x2, 1), []);
        }), vh = Si || function() {
          return hu.Date.now();
        };
        function Ip(p2, x2) {
          if (typeof x2 != "function")
            throw new Bc(o);
          return p2 = La(p2), function() {
            if (--p2 < 1)
              return x2.apply(this, arguments);
          };
        }
        function cd(p2, x2, k2) {
          return x2 = k2 ? e2 : x2, x2 = p2 && x2 == null ? p2.length : x2, ua(p2, $, e2, e2, e2, e2, x2);
        }
        function Lp(p2, x2) {
          var k2;
          if (typeof x2 != "function")
            throw new Bc(o);
          return p2 = La(p2), function() {
            return --p2 > 0 && (k2 = x2.apply(this, arguments)), p2 <= 1 && (x2 = e2), k2;
          };
        }
        var dh = Xa(function(p2, x2, k2) {
          var Y = b2;
          if (k2.length) {
            var ue = tv(k2, os(dh));
            Y |= z9;
          }
          return ua(p2, Y, x2, k2, ue);
        }), cv = Xa(function(p2, x2, k2) {
          var Y = b2 | _;
          if (k2.length) {
            var ue = tv(k2, os(cv));
            Y |= z9;
          }
          return ua(x2, Y, p2, k2, ue);
        });
        function Op(p2, x2, k2) {
          x2 = k2 ? e2 : x2;
          var Y = ua(p2, M, e2, e2, e2, e2, e2, x2);
          return Y.placeholder = Op.placeholder, Y;
        }
        function kp(p2, x2, k2) {
          x2 = k2 ? e2 : x2;
          var Y = ua(p2, E, e2, e2, e2, e2, e2, x2);
          return Y.placeholder = kp.placeholder, Y;
        }
        function eu(p2, x2, k2) {
          var Y, ue, me, Ye, tt, pt, Cr = 0, Tr = false, Br = false, Jr = true;
          if (typeof p2 != "function")
            throw new Bc(o);
          x2 = Ru(x2) || 0, la(k2) && (Tr = !!k2.leading, Br = "maxWait" in k2, me = Br ? Zs(Ru(k2.maxWait) || 0, x2) : me, Jr = "trailing" in k2 ? !!k2.trailing : Jr);
          function Ln(A2) {
            var W = Y, D = ue;
            return Y = ue = e2, Cr = A2, Ye = p2.apply(D, W), Ye;
          }
          function $n(A2) {
            return Cr = A2, tt = Hl(Ya, x2), Tr ? Ln(A2) : Ye;
          }
          function _a2(A2) {
            var W = A2 - pt, D = A2 - Cr, O = x2 - W;
            return Br ? Qu(O, me - D) : O;
          }
          function Un(A2) {
            var W = A2 - pt, D = A2 - Cr;
            return pt === e2 || W >= x2 || W < 0 || Br && D >= me;
          }
          function Ya() {
            var A2 = vh();
            if (Un(A2))
              return aa(A2);
            tt = Hl(Ya, _a2(A2));
          }
          function aa(A2) {
            return tt = e2, Jr && Y ? Ln(A2) : (Y = ue = e2, Ye);
          }
          function hs() {
            tt !== e2 && I(tt), Cr = 0, Y = pt = ue = tt = e2;
          }
          function nu() {
            return tt === e2 ? Ye : aa(vh());
          }
          function ll() {
            var A2 = vh(), W = Un(A2);
            if (Y = arguments, ue = this, pt = A2, W) {
              if (tt === e2)
                return $n(pt);
              if (Br)
                return I(tt), tt = Hl(Ya, x2), Ln(pt);
            }
            return tt === e2 && (tt = Hl(Ya, x2)), Ye;
          }
          return ll.cancel = hs, ll.flush = nu, ll;
        }
        var fd = Xa(function(p2, x2) {
          return RA(p2, 1, x2);
        }), ph = Xa(function(p2, x2, k2) {
          return RA(p2, Ru(x2) || 0, k2);
        });
        function i_(p2) {
          return ua(p2, H);
        }
        function gh(p2, x2) {
          if (typeof p2 != "function" || x2 != null && typeof x2 != "function")
            throw new Bc(o);
          var k2 = function() {
            var Y = arguments, ue = x2 ? x2.apply(this, Y) : Y[0], me = k2.cache;
            if (me.has(ue))
              return me.get(ue);
            var Ye = p2.apply(this, Y);
            return k2.cache = me.set(ue, Ye) || me, Ye;
          };
          return k2.cache = new (gh.Cache || Sf)(), k2;
        }
        gh.Cache = Sf;
        function fv(p2) {
          if (typeof p2 != "function")
            throw new Bc(o);
          return function() {
            var x2 = arguments;
            switch (x2.length) {
              case 0:
                return !p2.call(this);
              case 1:
                return !p2.call(this, x2[0]);
              case 2:
                return !p2.call(this, x2[0], x2[1]);
              case 3:
                return !p2.call(this, x2[0], x2[1], x2[2]);
            }
            return !p2.apply(this, x2);
          };
        }
        function ES(p2) {
          return Lp(2, p2);
        }
        var AS = G(function(p2, x2) {
          x2 = x2.length == 1 && Yn(x2[0]) ? Ho(x2[0], Xu(Rn())) : Ho(Pu(x2, 1), Xu(Rn()));
          var k2 = x2.length;
          return Xa(function(Y) {
            for (var ue = -1, me = Qu(Y.length, k2); ++ue < me; )
              Y[ue] = x2[ue].call(this, Y[ue]);
            return pc(p2, this, Y);
          });
        }), bm = Xa(function(p2, x2) {
          var k2 = tv(x2, os(bm));
          return ua(p2, z9, e2, x2, k2);
        }), o_ = Xa(function(p2, x2) {
          var k2 = tv(x2, os(o_));
          return ua(p2, V, e2, x2, k2);
        }), Vs = is(function(p2, x2) {
          return ua(p2, U, e2, e2, e2, x2);
        });
        function s_(p2, x2) {
          if (typeof p2 != "function")
            throw new Bc(o);
          return x2 = x2 === e2 ? x2 : La(x2), Xa(p2, x2);
        }
        function _m(p2, x2) {
          if (typeof p2 != "function")
            throw new Bc(o);
          return x2 = x2 == null ? 0 : Zs(La(x2), 0), Xa(function(k2) {
            var Y = k2[x2], ue = P(k2, 0, x2);
            return Y && Jv(ue, Y), pc(p2, this, ue);
          });
        }
        function xm(p2, x2, k2) {
          var Y = true, ue = true;
          if (typeof p2 != "function")
            throw new Bc(o);
          return la(k2) && (Y = "leading" in k2 ? !!k2.leading : Y, ue = "trailing" in k2 ? !!k2.trailing : ue), eu(p2, x2, { leading: Y, maxWait: x2, trailing: ue });
        }
        function u_(p2) {
          return cd(p2, 1);
        }
        function yh(p2, x2) {
          return bm(yS(x2), p2);
        }
        function o0() {
          if (!arguments.length)
            return [];
          var p2 = arguments[0];
          return Yn(p2) ? p2 : [p2];
        }
        function TS(p2) {
          return Gc(p2, v9);
        }
        function l_(p2, x2) {
          return x2 = typeof x2 == "function" ? x2 : e2, Gc(p2, v9, x2);
        }
        function MS(p2) {
          return Gc(p2, f2 | v9);
        }
        function Na(p2, x2) {
          return x2 = typeof x2 == "function" ? x2 : e2, Gc(p2, f2 | v9, x2);
        }
        function yu(p2, x2) {
          return x2 == null || kA(p2, x2, Wo(x2));
        }
        function ii(p2, x2) {
          return p2 === x2 || p2 !== p2 && x2 !== x2;
        }
        var Rp = zt(R1), wm = zt(function(p2, x2) {
          return p2 >= x2;
        }), mh = BA(function() {
          return arguments;
        }()) ? BA : function(p2) {
          return xo(p2) && oo.call(p2, "callee") && !M1.call(p2, "callee");
        }, Yn = Zt.isArray, c_ = zw ? Xu(zw) : LD;
        function Yo(p2) {
          return p2 != null && s0(p2.length) && !Ko(p2);
        }
        function rt2(p2) {
          return xo(p2) && Yo(p2);
        }
        function yr(p2) {
          return p2 === true || p2 === false || xo(p2) && tl(p2) == Wr;
        }
        var Bt = sD || qc, vn = hA ? Xu(hA) : OD;
        function ba(p2) {
          return xo(p2) && p2.nodeType === 1 && !Pf(p2);
        }
        function Ci(p2) {
          if (p2 == null)
            return true;
          if (Yo(p2) && (Yn(p2) || typeof p2 == "string" || typeof p2.splice == "function" || Bt(p2) || Kl(p2) || mh(p2)))
            return !p2.length;
          var x2 = nr(p2);
          if (x2 == Dn || x2 == Zi)
            return !p2.size;
          if (ws(p2))
            return !Xg(p2).length;
          for (var k2 in p2)
            if (oo.call(p2, k2))
              return false;
          return true;
        }
        function Ms(p2, x2) {
          return Zg(p2, x2);
        }
        function Yi(p2, x2, k2) {
          k2 = typeof k2 == "function" ? k2 : e2;
          var Y = k2 ? k2(p2, x2) : e2;
          return Y === e2 ? Zg(p2, x2, e2, k2) : !!Y;
        }
        function Fp(p2) {
          if (!xo(p2))
            return false;
          var x2 = tl(p2);
          return x2 == Xr || x2 == un || typeof p2.message == "string" && typeof p2.name == "string" && !Pf(p2);
        }
        function PS(p2) {
          return typeof p2 == "number" && CA(p2);
        }
        function Ko(p2) {
          if (!la(p2))
            return false;
          var x2 = tl(p2);
          return x2 == _n || x2 == Za || x2 == nn || x2 == jo;
        }
        function tu(p2) {
          return typeof p2 == "number" && p2 == La(p2);
        }
        function s0(p2) {
          return typeof p2 == "number" && p2 > -1 && p2 % 1 == 0 && p2 <= Le;
        }
        function la(p2) {
          var x2 = typeof p2;
          return p2 != null && (x2 == "object" || x2 == "function");
        }
        function xo(p2) {
          return p2 != null && typeof p2 == "object";
        }
        var hd = vA ? Xu(vA) : bp;
        function Ki(p2, x2) {
          return p2 === x2 || em(p2, x2, Iu(x2));
        }
        function f_(p2, x2, k2) {
          return k2 = typeof k2 == "function" ? k2 : e2, em(p2, x2, Iu(x2), k2);
        }
        function h_(p2) {
          return Sm(p2) && p2 != +p2;
        }
        function u0(p2) {
          if (Ul(p2))
            throw new ta(i);
          return tm(p2);
        }
        function DS(p2) {
          return p2 === null;
        }
        function v_(p2) {
          return p2 == null;
        }
        function Sm(p2) {
          return typeof p2 == "number" || xo(p2) && tl(p2) == ai;
        }
        function Pf(p2) {
          if (!xo(p2) || tl(p2) != hi)
            return false;
          var x2 = Gy(p2);
          if (x2 === null)
            return true;
          var k2 = oo.call(x2, "constructor") && x2.constructor;
          return typeof k2 == "function" && k2 instanceof k2 && Ju.call(k2) == nD;
        }
        var Uc = dA ? Xu(dA) : kD;
        function vd(p2) {
          return tu(p2) && p2 >= -Le && p2 <= Le;
        }
        var hv = Vg ? Xu(Vg) : zA;
        function vv(p2) {
          return typeof p2 == "string" || !Yn(p2) && xo(p2) && tl(p2) == ys;
        }
        function sl(p2) {
          return typeof p2 == "symbol" || xo(p2) && tl(p2) == Do;
        }
        var Kl = pA ? Xu(pA) : RD;
        function l0(p2) {
          return p2 === e2;
        }
        function d_(p2) {
          return xo(p2) && nr(p2) == xr;
        }
        function Va(p2) {
          return xo(p2) && tl(p2) == jt;
        }
        var dv = zt(V1), c0 = zt(function(p2, x2) {
          return p2 <= x2;
        });
        function p_(p2) {
          if (!p2)
            return [];
          if (Yo(p2))
            return vv(p2) ? _f(p2) : Ze(p2);
          if (Wy && p2[Wy])
            return X3(p2[Wy]());
          var x2 = nr(p2), k2 = x2 == Dn ? Gw : x2 == Zi ? $g : yv;
          return k2(p2);
        }
        function Df(p2) {
          if (!p2)
            return p2 === 0 ? p2 : 0;
          if (p2 = Ru(p2), p2 === et || p2 === -et) {
            var x2 = p2 < 0 ? -1 : 1;
            return x2 * Fe;
          }
          return p2 === p2 ? p2 : 0;
        }
        function La(p2) {
          var x2 = Df(p2), k2 = x2 % 1;
          return x2 === x2 ? k2 ? x2 - k2 : x2 : 0;
        }
        function Np(p2) {
          return p2 ? yp(La(p2), 0, st) : 0;
        }
        function Ru(p2) {
          if (typeof p2 == "number")
            return p2;
          if (sl(p2))
            return qe;
          if (la(p2)) {
            var x2 = typeof p2.valueOf == "function" ? p2.valueOf() : p2;
            p2 = la(x2) ? x2 + "" : x2;
          }
          if (typeof p2 != "string")
            return p2 === 0 ? p2 : +p2;
          p2 = Vy(p2);
          var k2 = Mt.test(p2);
          return k2 || Qt.test(p2) ? fA(p2.slice(2), k2 ? 2 : 8) : Ie.test(p2) ? qe : +p2;
        }
        function f0(p2) {
          return it(p2, js(p2));
        }
        function IS(p2) {
          return p2 ? yp(La(p2), -Le, Le) : p2 === 0 ? p2 : 0;
        }
        function Ri(p2) {
          return p2 == null ? "" : yc(p2);
        }
        var LS = Or(function(p2, x2) {
          if (ws(x2) || Yo(x2)) {
            it(x2, Wo(x2), p2);
            return;
          }
          for (var k2 in x2)
            oo.call(x2, k2) && Zy(p2, k2, x2[k2]);
        }), g_ = Or(function(p2, x2) {
          it(x2, js(x2), p2);
        }), Zo = Or(function(p2, x2, k2, Y) {
          it(x2, js(x2), p2, Y);
        }), mu = Or(function(p2, x2, k2, Y) {
          it(x2, Wo(x2), p2, Y);
        }), Cm = is(L1);
        function OS(p2, x2) {
          var k2 = pp(p2);
          return x2 == null ? k2 : eS(k2, x2);
        }
        var dd = Xa(function(p2, x2) {
          p2 = Hi(p2);
          var k2 = -1, Y = x2.length, ue = Y > 2 ? x2[2] : e2;
          for (ue && Da(x2[0], x2[1], ue) && (Y = 1); ++k2 < Y; )
            for (var me = x2[k2], Ye = js(me), tt = -1, pt = Ye.length; ++tt < pt; ) {
              var Cr = Ye[tt], Tr = p2[Cr];
              (Tr === e2 || ii(Tr, Hg[Cr]) && !oo.call(p2, Cr)) && (p2[Cr] = me[Cr]);
            }
          return p2;
        }), Em = Xa(function(p2) {
          return p2.push(e2, qi), pc(ul, e2, p2);
        });
        function Vp(p2, x2) {
          return m1(p2, Rn(x2, 3), Du);
        }
        function If(p2, x2) {
          return m1(p2, Rn(x2, 3), O1);
        }
        function Fu(p2, x2) {
          return p2 == null ? p2 : nS(p2, Rn(x2, 3), js);
        }
        function pv(p2, x2) {
          return p2 == null ? p2 : VA(p2, Rn(x2, 3), js);
        }
        function pd(p2, x2) {
          return p2 && Du(p2, Rn(x2, 3));
        }
        function jp(p2, x2) {
          return p2 && O1(p2, Rn(x2, 3));
        }
        function Bp(p2) {
          return p2 == null ? [] : k1(p2, Wo(p2));
        }
        function gd(p2) {
          return p2 == null ? [] : k1(p2, js(p2));
        }
        function Xo(p2, x2, k2) {
          var Y = p2 == null ? e2 : mp(p2, x2);
          return Y === e2 ? k2 : Y;
        }
        function yd(p2, x2) {
          return p2 != null && _r(p2, x2, iS);
        }
        function Lf(p2, x2) {
          return p2 != null && _r(p2, x2, jA);
        }
        var y_ = gn(function(p2, x2, k2) {
          x2 != null && typeof x2.toString != "function" && (x2 = zy.call(x2)), p2[x2] = k2;
        }, xd(bu)), zp = gn(function(p2, x2, k2) {
          x2 != null && typeof x2.toString != "function" && (x2 = zy.call(x2)), oo.call(p2, x2) ? p2[x2].push(k2) : p2[x2] = [k2];
        }, Rn), $p = Xa(Kg);
        function Wo(p2) {
          return Yo(p2) ? OA(p2) : Xg(p2);
        }
        function js(p2) {
          return Yo(p2) ? OA(p2, true) : sS(p2);
        }
        function xe(p2, x2) {
          var k2 = {};
          return x2 = Rn(x2, 3), Du(p2, function(Y, ue, me) {
            iv(k2, x2(Y, ue, me), Y);
          }), k2;
        }
        function md(p2, x2) {
          var k2 = {};
          return x2 = Rn(x2, 3), Du(p2, function(Y, ue, me) {
            iv(k2, ue, x2(Y, ue, me));
          }), k2;
        }
        var h0 = Or(function(p2, x2, k2) {
          id2(p2, x2, k2);
        }), ul = Or(function(p2, x2, k2, Y) {
          id2(p2, x2, k2, Y);
        }), oi = is(function(p2, x2) {
          var k2 = {};
          if (p2 == null)
            return k2;
          var Y = false;
          x2 = Ho(x2, function(me) {
            return me = T(me, p2), Y || (Y = me.length > 1), me;
          }), it(p2, qo(p2), k2), Y && (k2 = Gc(k2, f2 | h | v9, Ha));
          for (var ue = x2.length; ue--; )
            vS(k2, x2[ue]);
          return k2;
        });
        function kS(p2, x2) {
          return v0(p2, fv(Rn(x2)));
        }
        var Am = is(function(p2, x2) {
          return p2 == null ? {} : ND(p2, x2);
        });
        function v0(p2, x2) {
          if (p2 == null)
            return {};
          var k2 = Ho(qo(p2), function(Y) {
            return [Y];
          });
          return x2 = Rn(x2), GA(p2, k2, function(Y, ue) {
            return x2(Y, ue[0]);
          });
        }
        function gv(p2, x2, k2) {
          x2 = T(x2, p2);
          var Y = -1, ue = x2.length;
          for (ue || (ue = 1, p2 = e2); ++Y < ue; ) {
            var me = p2 == null ? e2 : p2[De(x2[Y])];
            me === e2 && (Y = ue, me = k2), p2 = Ko(me) ? me.call(p2) : me;
          }
          return p2;
        }
        function RS(p2, x2, k2) {
          return p2 == null ? p2 : rm(p2, x2, k2);
        }
        function Tm(p2, x2, k2, Y) {
          return Y = typeof Y == "function" ? Y : e2, p2 == null ? p2 : rm(p2, x2, k2, Y);
        }
        var m_ = Ua(Wo), d0 = Ua(js);
        function FS(p2, x2, k2) {
          var Y = Yn(p2), ue = Y || Bt(p2) || Kl(p2);
          if (x2 = Rn(x2, 4), k2 == null) {
            var me = p2 && p2.constructor;
            ue ? k2 = Y ? new me() : [] : la(p2) ? k2 = Ko(me) ? pp(Gy(p2)) : {} : k2 = {};
          }
          return (ue ? Gl : Du)(p2, function(Ye, tt, pt) {
            return x2(k2, Ye, tt, pt);
          }), k2;
        }
        function fs(p2, x2) {
          return p2 == null ? true : vS(p2, x2);
        }
        function b_(p2, x2, k2) {
          return p2 == null ? p2 : GD(p2, x2, yS(k2));
        }
        function Mm(p2, x2, k2, Y) {
          return Y = typeof Y == "function" ? Y : e2, p2 == null ? p2 : GD(p2, x2, yS(k2), Y);
        }
        function yv(p2) {
          return p2 == null ? [] : Bg(p2, Wo(p2));
        }
        function NS(p2) {
          return p2 == null ? [] : Bg(p2, js(p2));
        }
        function VS(p2, x2, k2) {
          return k2 === e2 && (k2 = x2, x2 = e2), k2 !== e2 && (k2 = Ru(k2), k2 = k2 === k2 ? k2 : 0), x2 !== e2 && (x2 = Ru(x2), x2 = x2 === x2 ? x2 : 0), yp(Ru(p2), x2, k2);
        }
        function Of(p2, x2, k2) {
          return x2 = Df(x2), k2 === e2 ? (k2 = x2, x2 = 0) : k2 = Df(k2), p2 = Ru(p2), F1(p2, x2, k2);
        }
        function __(p2, x2, k2) {
          if (k2 && typeof k2 != "boolean" && Da(p2, x2, k2) && (x2 = k2 = e2), k2 === e2 && (typeof x2 == "boolean" ? (k2 = x2, x2 = e2) : typeof p2 == "boolean" && (k2 = p2, p2 = e2)), p2 === e2 && x2 === e2 ? (p2 = 0, x2 = 1) : (p2 = Df(p2), x2 === e2 ? (x2 = p2, p2 = 0) : x2 = Df(x2)), p2 > x2) {
            var Y = p2;
            p2 = x2, x2 = Y;
          }
          if (k2 || p2 % 1 || x2 % 1) {
            var ue = EA();
            return Qu(p2 + ue * (x2 - p2 + Vw("1e-" + ((ue + "").length - 1))), x2);
          }
          return fS(p2, x2);
        }
        var Pm = Kt(function(p2, x2, k2) {
          return x2 = x2.toLowerCase(), p2 + (k2 ? bd(x2) : x2);
        });
        function bd(p2) {
          return m0(Ri(p2).toLowerCase());
        }
        function x_(p2) {
          return p2 = Ri(p2), p2 && p2.replace(Rr, S1).replace(sA, "");
        }
        function jS(p2, x2, k2) {
          p2 = Ri(p2), x2 = yc(x2);
          var Y = p2.length;
          k2 = k2 === e2 ? Y : yp(La(k2), 0, Y);
          var ue = k2;
          return k2 -= x2.length, k2 >= 0 && p2.slice(k2, ue) == x2;
        }
        function bh(p2) {
          return p2 = Ri(p2), p2 && Ys.test(p2) ? p2.replace(as, K3) : p2;
        }
        function Dm(p2) {
          return p2 = Ri(p2), p2 && Mw.test(p2) ? p2.replace(rh, "\\$&") : p2;
        }
        var BS = Kt(function(p2, x2, k2) {
          return p2 + (k2 ? "-" : "") + x2.toLowerCase();
        }), Ec = Kt(function(p2, x2, k2) {
          return p2 + (k2 ? " " : "") + x2.toLowerCase();
        }), zS = er("toLowerCase");
        function $S(p2, x2, k2) {
          p2 = Ri(p2), x2 = La(x2);
          var Y = x2 ? Gg(p2) : 0;
          if (!x2 || Y >= x2)
            return p2;
          var ue = (x2 - Y) / 2;
          return In(I1(ue), k2) + p2 + In(D1(ue), k2);
        }
        function p0(p2, x2, k2) {
          p2 = Ri(p2), x2 = La(x2);
          var Y = x2 ? Gg(p2) : 0;
          return x2 && Y < x2 ? p2 + In(x2 - Y, k2) : p2;
        }
        function GS(p2, x2, k2) {
          p2 = Ri(p2), x2 = La(x2);
          var Y = x2 ? Gg(p2) : 0;
          return x2 && Y < x2 ? In(x2 - Y, k2) + p2 : p2;
        }
        function WS(p2, x2, k2) {
          return k2 || x2 == null ? x2 = 0 : x2 && (x2 = +x2), fD(Ri(p2).replace(qv, ""), x2 || 0);
        }
        function w_(p2, x2, k2) {
          return (k2 ? Da(p2, x2, k2) : x2 === e2) ? x2 = 1 : x2 = La(x2), z1(Ri(p2), x2);
        }
        function S_() {
          var p2 = arguments, x2 = Ri(p2[0]);
          return p2.length < 3 ? x2 : x2.replace(p2[1], p2[2]);
        }
        var C_ = Kt(function(p2, x2, k2) {
          return p2 + (k2 ? "_" : "") + x2.toLowerCase();
        });
        function US(p2, x2, k2) {
          return k2 && typeof k2 != "number" && Da(p2, x2, k2) && (x2 = k2 = e2), k2 = k2 === e2 ? st : k2 >>> 0, k2 ? (p2 = Ri(p2), p2 && (typeof x2 == "string" || x2 != null && !Uc(x2)) && (x2 = yc(x2), !x2 && zg(p2)) ? P(_f(p2), 0, k2) : p2.split(x2, k2)) : [];
        }
        var g0 = Kt(function(p2, x2, k2) {
          return p2 + (k2 ? " " : "") + m0(x2);
        });
        function ru(p2, x2, k2) {
          return p2 = Ri(p2), k2 = k2 == null ? 0 : yp(La(k2), 0, p2.length), x2 = yc(x2), p2.slice(k2, k2 + x2.length) == x2;
        }
        function y0(p2, x2, k2) {
          var Y = _e.templateSettings;
          k2 && Da(p2, x2, k2) && (x2 = e2), p2 = Ri(p2), x2 = Zo({}, x2, Y, Pa);
          var ue = Zo({}, x2.imports, Y.imports, Pa), me = Wo(ue), Ye = Bg(ue, me), tt, pt, Cr = 0, Tr = x2.interpolate || wn, Br = "__p += '", Jr = Uw((x2.escape || wn).source + "|" + Tr.source + "|" + (Tr === zl ? Se : wn).source + "|" + (x2.evaluate || wn).source + "|$", "g"), Ln = "//# sourceURL=" + (oo.call(x2, "sourceURL") ? (x2.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++uA + "]") + `
`;
          p2.replace(Jr, function(Un, Ya, aa, hs, nu, ll) {
            return aa || (aa = hs), Br += p2.slice(Cr, ll).replace(Ba, C1), Ya && (tt = true, Br += `' +
__e(` + Ya + `) +
'`), nu && (pt = true, Br += `';
` + nu + `;
__p += '`), aa && (Br += `' +
((__t = (` + aa + `)) == null ? '' : __t) +
'`), Cr = ll + Un.length, Un;
          }), Br += `';
`;
          var $n = oo.call(x2, "variable") && x2.variable;
          if (!$n)
            Br = `with (obj) {
` + Br + `
}
`;
          else if (Be.test($n))
            throw new ta(s);
          Br = (pt ? Br.replace(Yu, "") : Br).replace(wl, "$1").replace(hc, "$1;"), Br = "function(" + ($n || "obj") + `) {
` + ($n ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (tt ? ", __e = _.escape" : "") + (pt ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Br + `return __p
}`;
          var _a2 = bv(function() {
            return Ui(me, Ln + "return " + Br).apply(e2, Ye);
          });
          if (_a2.source = Br, Fp(_a2))
            throw _a2;
          return _a2;
        }
        function E_(p2) {
          return Ri(p2).toLowerCase();
        }
        function A_(p2) {
          return Ri(p2).toUpperCase();
        }
        function HS(p2, x2, k2) {
          if (p2 = Ri(p2), p2 && (k2 || x2 === e2))
            return Vy(p2);
          if (!p2 || !(x2 = yc(x2)))
            return p2;
          var Y = _f(p2), ue = _f(x2), me = x1(Y, ue), Ye = jy(Y, ue) + 1;
          return P(Y, me, Ye).join("");
        }
        function Ac(p2, x2, k2) {
          if (p2 = Ri(p2), p2 && (k2 || x2 === e2))
            return p2.slice(0, Ww(p2) + 1);
          if (!p2 || !(x2 = yc(x2)))
            return p2;
          var Y = _f(p2), ue = jy(Y, _f(x2)) + 1;
          return P(Y, 0, ue).join("");
        }
        function Im(p2, x2, k2) {
          if (p2 = Ri(p2), p2 && (k2 || x2 === e2))
            return p2.replace(qv, "");
          if (!p2 || !(x2 = yc(x2)))
            return p2;
          var Y = _f(p2), ue = x1(Y, _f(x2));
          return P(Y, ue).join("");
        }
        function mv(p2, x2) {
          var k2 = q3, Y = ee;
          if (la(x2)) {
            var ue = "separator" in x2 ? x2.separator : ue;
            k2 = "length" in x2 ? La(x2.length) : k2, Y = "omission" in x2 ? yc(x2.omission) : Y;
          }
          p2 = Ri(p2);
          var me = p2.length;
          if (zg(p2)) {
            var Ye = _f(p2);
            me = Ye.length;
          }
          if (k2 >= me)
            return p2;
          var tt = k2 - Gg(Y);
          if (tt < 1)
            return Y;
          var pt = Ye ? P(Ye, 0, tt).join("") : p2.slice(0, tt);
          if (ue === e2)
            return pt + Y;
          if (Ye && (tt += pt.length - tt), Uc(ue)) {
            if (p2.slice(tt).search(ue)) {
              var Cr, Tr = pt;
              for (ue.global || (ue = Uw(ue.source, Ri(ke.exec(ue)) + "g")), ue.lastIndex = 0; Cr = ue.exec(Tr); )
                var Br = Cr.index;
              pt = pt.slice(0, Br === e2 ? tt : Br);
            }
          } else if (p2.indexOf(yc(ue), tt) != tt) {
            var Jr = pt.lastIndexOf(ue);
            Jr > -1 && (pt = pt.slice(0, Jr));
          }
          return pt + Y;
        }
        function Zl(p2) {
          return p2 = Ri(p2), p2 && vi.test(p2) ? p2.replace(Sl, tD) : p2;
        }
        var qS = Kt(function(p2, x2, k2) {
          return p2 + (k2 ? " " : "") + x2.toUpperCase();
        }), m0 = er("toUpperCase");
        function b0(p2, x2, k2) {
          return p2 = Ri(p2), x2 = k2 ? e2 : x2, x2 === e2 ? Z3(p2) ? $o(p2) : Oy(p2) : p2.match(x2) || [];
        }
        var bv = Xa(function(p2, x2) {
          try {
            return pc(p2, e2, x2);
          } catch (k2) {
            return Fp(k2) ? k2 : new ta(k2);
          }
        }), Hc = is(function(p2, x2) {
          return Gl(x2, function(k2) {
            k2 = De(k2), iv(p2, k2, dh(p2[k2], p2));
          }), p2;
        });
        function _d(p2) {
          var x2 = p2 == null ? 0 : p2.length, k2 = Rn();
          return p2 = x2 ? Ho(p2, function(Y) {
            if (typeof Y[1] != "function")
              throw new Bc(o);
            return [k2(Y[0]), Y[1]];
          }) : [], Xa(function(Y) {
            for (var ue = -1; ++ue < x2; ) {
              var me = p2[ue];
              if (pc(me[0], this, Y))
                return pc(me[1], this, Y);
            }
          });
        }
        function YS(p2) {
          return tS(Gc(p2, f2));
        }
        function xd(p2) {
          return function() {
            return p2;
          };
        }
        function KS(p2, x2) {
          return p2 == null || p2 !== p2 ? x2 : p2;
        }
        var kf = Ir(), Bs = Ir(true);
        function bu(p2) {
          return p2;
        }
        function _0(p2) {
          return _p(typeof p2 == "function" ? p2 : Gc(p2, f2));
        }
        function Tc(p2) {
          return uS(Gc(p2, f2));
        }
        function x0(p2, x2) {
          return j1(p2, Gc(x2, f2));
        }
        var Gp = Xa(function(p2, x2) {
          return function(k2) {
            return Kg(k2, p2, x2);
          };
        }), Rf = Xa(function(p2, x2) {
          return function(k2) {
            return Kg(p2, k2, x2);
          };
        });
        function Wp(p2, x2, k2) {
          var Y = Wo(x2), ue = k1(x2, Y);
          k2 == null && !(la(x2) && (ue.length || !Y.length)) && (k2 = x2, x2 = p2, p2 = this, ue = k1(x2, Wo(x2)));
          var me = !(la(k2) && "chain" in k2) || !!k2.chain, Ye = Ko(p2);
          return Gl(ue, function(tt) {
            var pt = x2[tt];
            p2[tt] = pt, Ye && (p2.prototype[tt] = function() {
              var Cr = this.__chain__;
              if (me || Cr) {
                var Tr = p2(this.__wrapped__), Br = Tr.__actions__ = Ze(this.__actions__);
                return Br.push({ func: pt, args: arguments, thisArg: p2 }), Tr.__chain__ = Cr, Tr;
              }
              return pt.apply(p2, Jv([this.value()], arguments));
            });
          }), p2;
        }
        function zs() {
          return hu._ === this && (hu._ = xA), this;
        }
        function Up() {
        }
        function Kn(p2) {
          return p2 = La(p2), Xa(function(x2) {
            return lS(x2, p2);
          });
        }
        var T_ = Jt(Ho), ZS = Jt(yA), Lm = Jt(cs);
        function M_(p2) {
          return ko(p2) ? ky(De(p2)) : VD(p2);
        }
        function wd(p2) {
          return function(x2) {
            return p2 == null ? e2 : mp(p2, x2);
          };
        }
        var Hp = Gt(), _v = Gt(true);
        function qp() {
          return [];
        }
        function qc() {
          return false;
        }
        function XS() {
          return {};
        }
        function P_() {
          return "";
        }
        function Om() {
          return true;
        }
        function xv(p2, x2) {
          if (p2 = La(p2), p2 < 1 || p2 > Le)
            return [];
          var k2 = st, Y = Qu(p2, st);
          x2 = Rn(x2), p2 -= st;
          for (var ue = Ny(Y, x2); ++k2 < p2; )
            x2(k2);
          return ue;
        }
        function w0(p2) {
          return Yn(p2) ? Ho(p2, De) : sl(p2) ? [p2] : Ze(lh(Ri(p2)));
        }
        function km(p2) {
          var x2 = ++Ks;
          return Ri(p2) + x2;
        }
        var D_ = ln(function(p2, x2) {
          return p2 + x2;
        }, 0), I_ = Vr("ceil"), S0 = ln(function(p2, x2) {
          return p2 / x2;
        }, 1), Rm = Vr("floor");
        function wv(p2) {
          return p2 && p2.length ? Qy(p2, bu, R1) : e2;
        }
        function L_(p2, x2) {
          return p2 && p2.length ? Qy(p2, Rn(x2, 2), R1) : e2;
        }
        function Fm(p2) {
          return bA(p2, bu);
        }
        function Nm(p2, x2) {
          return bA(p2, Rn(x2, 2));
        }
        function C0(p2) {
          return p2 && p2.length ? Qy(p2, bu, V1) : e2;
        }
        function JS(p2, x2) {
          return p2 && p2.length ? Qy(p2, Rn(x2, 2), V1) : e2;
        }
        var O_ = ln(function(p2, x2) {
          return p2 * x2;
        }, 1), Vm = Vr("round"), Sd = ln(function(p2, x2) {
          return p2 - x2;
        }, 0);
        function k_(p2) {
          return p2 && p2.length ? Fy(p2, bu) : 0;
        }
        function QS(p2, x2) {
          return p2 && p2.length ? Fy(p2, Rn(x2, 2)) : 0;
        }
        return _e.after = Ip, _e.ary = cd, _e.assign = LS, _e.assignIn = g_, _e.assignInWith = Zo, _e.assignWith = mu, _e.at = Cm, _e.before = Lp, _e.bind = dh, _e.bindAll = Hc, _e.bindKey = cv, _e.castArray = o0, _e.chain = t_, _e.chunk = Ve, _e.compact = Tt, _e.concat = hr, _e.cond = _d, _e.conforms = YS, _e.constant = xd, _e.countBy = a_, _e.create = OS, _e.curry = Op, _e.curryRight = kp, _e.debounce = eu, _e.defaults = dd, _e.defaultsDeep = Em, _e.defer = fd, _e.delay = ph, _e.difference = Xt, _e.differenceBy = lt2, _e.differenceWith = Fr, _e.drop = yn, _e.dropRight = Ia, _e.dropRightWhile = Ea, _e.dropWhile = pa, _e.fill = Wn, _e.filter = r0, _e.flatMap = wS, _e.flatMapDeep = ku, _e.flatMapDepth = SS, _e.flatten = na, _e.flattenDeep = Ro, _e.flattenDepth = Qs, _e.flip = i_, _e.flow = kf, _e.flowRight = Bs, _e.fromPairs = _c2, _e.functions = Bp, _e.functionsIn = gd, _e.groupBy = Mp, _e.initial = ov, _e.intersection = Af, _e.intersectionBy = Cs, _e.intersectionWith = wc, _e.invert = y_, _e.invertBy = zp, _e.invokeMap = Sa, _e.iteratee = _0, _e.keyBy = Yl, _e.keys = Wo, _e.keysIn = js, _e.map = lv, _e.mapKeys = xe, _e.mapValues = md, _e.matches = Tc, _e.matchesProperty = x0, _e.memoize = gh, _e.merge = h0, _e.mergeWith = ul, _e.method = Gp, _e.methodOf = Rf, _e.mixin = Wp, _e.negate = fv, _e.nthArg = Kn, _e.omit = oi, _e.omitBy = kS, _e.once = ES, _e.orderBy = Pp, _e.over = T_, _e.overArgs = AS, _e.overEvery = ZS, _e.overSome = Lm, _e.partial = bm, _e.partialRight = o_, _e.partition = Dp, _e.pick = Am, _e.pickBy = v0, _e.property = M_, _e.propertyOf = wd, _e.pull = Sp, _e.pullAll = ol, _e.pullAllBy = ch, _e.pullAllWith = Tf, _e.pullAt = Ns, _e.range = Hp, _e.rangeRight = _v, _e.rearg = Vs, _e.reject = CS, _e.remove = Cp, _e.rest = s_, _e.reverse = Ml, _e.sampleSize = i0, _e.set = RS, _e.setWith = Tm, _e.shuffle = hh, _e.slice = ud, _e.sortBy = Ts, _e.sortedUniq = Y1, _e.sortedUniqBy = im, _e.split = US, _e.spread = _m, _e.tail = e0, _e.take = bS, _e.takeRight = K1, _e.takeRightWhile = om, _e.takeWhile = Z1, _e.tap = hm, _e.throttle = xm, _e.thru = Ap, _e.toArray = p_, _e.toPairs = m_, _e.toPairsIn = d0, _e.toPath = w0, _e.toPlainObject = f0, _e.transform = FS, _e.unary = u_, _e.union = sm, _e.unionBy = um, _e.unionWith = gu, _e.uniq = Ep, _e.uniqBy = X1, _e.uniqWith = _S, _e.unset = fs, _e.unzip = lm, _e.unzipWith = Cc, _e.update = b_, _e.updateWith = Mm, _e.values = yv, _e.valuesIn = NS, _e.without = J1, _e.words = b0, _e.wrap = yh, _e.xor = _o, _e.xorBy = lo, _e.xorWith = cm, _e.zip = Q1, _e.zipObject = fm, _e.zipObjectDeep = xS, _e.zipWith = e_, _e.entries = m_, _e.entriesIn = d0, _e.extend = g_, _e.extendWith = Zo, Wp(_e, _e), _e.add = D_, _e.attempt = bv, _e.camelCase = Pm, _e.capitalize = bd, _e.ceil = I_, _e.clamp = VS, _e.clone = TS, _e.cloneDeep = MS, _e.cloneDeepWith = Na, _e.cloneWith = l_, _e.conformsTo = yu, _e.deburr = x_, _e.defaultTo = KS, _e.divide = S0, _e.endsWith = jS, _e.eq = ii, _e.escape = bh, _e.escapeRegExp = Dm, _e.every = Tp, _e.find = dm, _e.findIndex = ki, _e.findKey = Vp, _e.findLast = Pl, _e.findLastIndex = bo, _e.findLastKey = If, _e.floor = Rm, _e.forEach = pm, _e.forEachRight = Mf, _e.forIn = Fu, _e.forInRight = pv, _e.forOwn = pd, _e.forOwnRight = jp, _e.get = Xo, _e.gt = Rp, _e.gte = wm, _e.has = yd, _e.hasIn = Lf, _e.head = Ef, _e.identity = bu, _e.includes = gm, _e.indexOf = xc, _e.inRange = Of, _e.invoke = $p, _e.isArguments = mh, _e.isArray = Yn, _e.isArrayBuffer = c_, _e.isArrayLike = Yo, _e.isArrayLikeObject = rt2, _e.isBoolean = yr, _e.isBuffer = Bt, _e.isDate = vn, _e.isElement = ba, _e.isEmpty = Ci, _e.isEqual = Ms, _e.isEqualWith = Yi, _e.isError = Fp, _e.isFinite = PS, _e.isFunction = Ko, _e.isInteger = tu, _e.isLength = s0, _e.isMap = hd, _e.isMatch = Ki, _e.isMatchWith = f_, _e.isNaN = h_, _e.isNative = u0, _e.isNil = v_, _e.isNull = DS, _e.isNumber = Sm, _e.isObject = la, _e.isObjectLike = xo, _e.isPlainObject = Pf, _e.isRegExp = Uc, _e.isSafeInteger = vd, _e.isSet = hv, _e.isString = vv, _e.isSymbol = sl, _e.isTypedArray = Kl, _e.isUndefined = l0, _e.isWeakMap = d_, _e.isWeakSet = Va, _e.join = Es, _e.kebabCase = BS, _e.last = ss, _e.lastIndexOf = Sc, _e.lowerCase = Ec, _e.lowerFirst = zS, _e.lt = dv, _e.lte = c0, _e.max = wv, _e.maxBy = L_, _e.mean = Fm, _e.meanBy = Nm, _e.min = C0, _e.minBy = JS, _e.stubArray = qp, _e.stubFalse = qc, _e.stubObject = XS, _e.stubString = P_, _e.stubTrue = Om, _e.multiply = O_, _e.nth = sv, _e.noConflict = zs, _e.noop = Up, _e.now = vh, _e.pad = $S, _e.padEnd = p0, _e.padStart = GS, _e.parseInt = WS, _e.random = __, _e.reduce = ym, _e.reduceRight = n0, _e.repeat = w_, _e.replace = S_, _e.result = gv, _e.round = Vm, _e.runInContext = ft, _e.sample = a0, _e.size = mm, _e.snakeCase = C_, _e.some = zi, _e.sortedIndex = uv, _e.sortedIndexBy = H1, _e.sortedIndexOf = q1, _e.sortedLastIndex = mS, _e.sortedLastIndexBy = nm, _e.sortedLastIndexOf = am, _e.startCase = g0, _e.startsWith = ru, _e.subtract = Sd, _e.sum = k_, _e.sumBy = QS, _e.template = y0, _e.times = xv, _e.toFinite = Df, _e.toInteger = La, _e.toLength = Np, _e.toLower = E_, _e.toNumber = Ru, _e.toSafeInteger = IS, _e.toString = Ri, _e.toUpper = A_, _e.trim = HS, _e.trimEnd = Ac, _e.trimStart = Im, _e.truncate = mv, _e.unescape = Zl, _e.uniqueId = km, _e.upperCase = qS, _e.upperFirst = m0, _e.each = pm, _e.eachRight = Mf, _e.first = Ef, Wp(_e, function() {
          var p2 = {};
          return Du(_e, function(x2, k2) {
            oo.call(_e.prototype, k2) || (p2[k2] = x2);
          }), p2;
        }(), { chain: false }), _e.VERSION = n2, Gl(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(p2) {
          _e[p2].placeholder = _e;
        }), Gl(["drop", "take"], function(p2, x2) {
          di.prototype[p2] = function(k2) {
            k2 = k2 === e2 ? 1 : Zs(La(k2), 0);
            var Y = this.__filtered__ && !x2 ? new di(this) : this.clone();
            return Y.__filtered__ ? Y.__takeCount__ = Qu(k2, Y.__takeCount__) : Y.__views__.push({ size: Qu(k2, st), type: p2 + (Y.__dir__ < 0 ? "Right" : "") }), Y;
          }, di.prototype[p2 + "Right"] = function(k2) {
            return this.reverse()[p2](k2).reverse();
          };
        }), Gl(["filter", "map", "takeWhile"], function(p2, x2) {
          var k2 = x2 + 1, Y = k2 == be || k2 == ye;
          di.prototype[p2] = function(ue) {
            var me = this.clone();
            return me.__iteratees__.push({ iteratee: Rn(ue, 3), type: k2 }), me.__filtered__ = me.__filtered__ || Y, me;
          };
        }), Gl(["head", "last"], function(p2, x2) {
          var k2 = "take" + (x2 ? "Right" : "");
          di.prototype[p2] = function() {
            return this[k2](1).value()[0];
          };
        }), Gl(["initial", "tail"], function(p2, x2) {
          var k2 = "drop" + (x2 ? "" : "Right");
          di.prototype[p2] = function() {
            return this.__filtered__ ? new di(this) : this[k2](1);
          };
        }), di.prototype.compact = function() {
          return this.filter(bu);
        }, di.prototype.find = function(p2) {
          return this.filter(p2).head();
        }, di.prototype.findLast = function(p2) {
          return this.reverse().find(p2);
        }, di.prototype.invokeMap = Xa(function(p2, x2) {
          return typeof p2 == "function" ? new di(this) : this.map(function(k2) {
            return Kg(k2, p2, x2);
          });
        }), di.prototype.reject = function(p2) {
          return this.filter(fv(Rn(p2)));
        }, di.prototype.slice = function(p2, x2) {
          p2 = La(p2);
          var k2 = this;
          return k2.__filtered__ && (p2 > 0 || x2 < 0) ? new di(k2) : (p2 < 0 ? k2 = k2.takeRight(-p2) : p2 && (k2 = k2.drop(p2)), x2 !== e2 && (x2 = La(x2), k2 = x2 < 0 ? k2.dropRight(-x2) : k2.take(x2 - p2)), k2);
        }, di.prototype.takeRightWhile = function(p2) {
          return this.reverse().takeWhile(p2).reverse();
        }, di.prototype.toArray = function() {
          return this.take(st);
        }, Du(di.prototype, function(p2, x2) {
          var k2 = /^(?:filter|find|map|reject)|While$/.test(x2), Y = /^(?:head|last)$/.test(x2), ue = _e[Y ? "take" + (x2 == "last" ? "Right" : "") : x2], me = Y || /^find/.test(x2);
          !ue || (_e.prototype[x2] = function() {
            var Ye = this.__wrapped__, tt = Y ? [1] : arguments, pt = Ye instanceof di, Cr = tt[0], Tr = pt || Yn(Ye), Br = function(Ya) {
              var aa = ue.apply(_e, Jv([Ya], tt));
              return Y && Jr ? aa[0] : aa;
            };
            Tr && k2 && typeof Cr == "function" && Cr.length != 1 && (pt = Tr = false);
            var Jr = this.__chain__, Ln = !!this.__actions__.length, $n = me && !Jr, _a2 = pt && !Ln;
            if (!me && Tr) {
              Ye = _a2 ? Ye : new di(this);
              var Un = p2.apply(Ye, tt);
              return Un.__actions__.push({ func: Ap, args: [Br], thisArg: e2 }), new Al(Un, Jr);
            }
            return $n && _a2 ? p2.apply(this, tt) : (Un = this.thru(Br), $n ? Y ? Un.value()[0] : Un.value() : Un);
          });
        }), Gl(["pop", "push", "shift", "sort", "splice", "unshift"], function(p2) {
          var x2 = Ug[p2], k2 = /^(?:push|sort|unshift)$/.test(p2) ? "tap" : "thru", Y = /^(?:pop|shift)$/.test(p2);
          _e.prototype[p2] = function() {
            var ue = arguments;
            if (Y && !this.__chain__) {
              var me = this.value();
              return x2.apply(Yn(me) ? me : [], ue);
            }
            return this[k2](function(Ye) {
              return x2.apply(Yn(Ye) ? Ye : [], ue);
            });
          };
        }), Du(di.prototype, function(p2, x2) {
          var k2 = _e[x2];
          if (k2) {
            var Y = k2.name + "";
            oo.call(dp, Y) || (dp[Y] = []), dp[Y].push({ name: x2, func: k2 });
          }
        }), dp[ht(e2, _).name] = [{ name: "wrapper", func: e2 }], di.prototype.clone = pD, di.prototype.reverse = gD, di.prototype.value = MA, _e.prototype.at = As, _e.prototype.chain = t0, _e.prototype.commit = fh, _e.prototype.next = r_, _e.prototype.plant = ql, _e.prototype.reverse = ld, _e.prototype.toJSON = _e.prototype.valueOf = _e.prototype.value = n_, _e.prototype.first = _e.prototype.head, Wy && (_e.prototype[Wy] = vm), _e;
      }, ed = By();
      Zv ? ((Zv.exports = ed)._ = ed, jw._ = ed) : hu._ = ed;
    }).call(jh);
  })(VP, VP.exports);
  class oX {
    constructor() {
      lf(this, "subscriptions", /* @__PURE__ */ new Map());
      lf(this, "emitEffectCache", /* @__PURE__ */ new Map());
      lf(this, "useSubscription", (t2, e2) => {
        const n2 = Li.useRef();
        Li.useEffect(() => {
          var o, s;
          n2.current = e2;
          function a(u) {
            n2.current && n2.current(u);
          }
          const i = (s = (o = this.subscriptions) == null ? void 0 : o.get(t2)) != null ? s : [];
          return i.push(a), this.subscriptions.set(t2, i), this.emitEffect(t2), () => {
            this.subscriptions.delete(t2);
          };
        });
      });
      lf(this, "emit", (t2, ...e2) => {
        if (typeof t2 == "string" || typeof t2 == "number") {
          const n2 = this.subscriptions.get(t2);
          n2 == null || n2.forEach((a) => {
            a == null || a({ params: VP.exports.cloneDeep(e2), event: t2 });
          }), this.emitEffectCache.set(t2, { params: VP.exports.cloneDeep(e2), event: t2 });
        } else
          throw new TypeError("event must be string or number !");
      });
      lf(this, "emitEffect", (t2) => {
        const e2 = this.emitEffectCache.get(t2), n2 = this.subscriptions.get(t2);
        e2 && (n2 == null || n2.forEach((a) => {
          a == null || a(f8({}, e2));
        }));
      });
      lf(this, "removeListener", (t2) => {
        this.subscriptions.delete(t2);
      });
      lf(this, "clear", () => {
        this.subscriptions.clear();
      });
      this.clear();
    }
  }
  const PAe = new oX();
  function M3(r2) {
    const t2 = Li.useRef(), e2 = Li.useMemo(() => r2 != null ? r2 : { global: false }, [r2]);
    return t2.current || (t2.current = e2.global ? t2.current = PAe : t2.current = new oX()), Li.useEffect(() => () => {
      var n2;
      return (n2 = t2.current) == null ? void 0 : n2.clear();
    }, []), t2.current;
  }
  const VN = ({ id: r2, title: t2, chart: e2, option: n2 }, a) => {
    const i = Li.useRef(), o = M3({ global: true });
    i.current = Li.useMemo(() => {
      if (!i.current)
        return MAe;
    }, []);
    const { run: s } = Qne(() => {
      r2 && o.emit("list");
    }, { wait: 100 });
    return Li.useEffect(() => {
      console.log(e2 == null ? void 0 : e2.current), i.current && (e2 == null ? void 0 : e2.current) && r2 && n2 && (i.current.add(r2, e2 == null ? void 0 : e2.current, n2, t2), s());
    }, a), { tool: i.current };
  };
  var DAe = Li.createContext({}), sX = DAe;
  function go(r2, t2, e2) {
    return t2 in r2 ? Object.defineProperty(r2, t2, { value: e2, enumerable: true, configurable: true, writable: true }) : r2[t2] = e2, r2;
  }
  function bG(r2, t2) {
    var e2 = Object.keys(r2);
    if (Object.getOwnPropertySymbols) {
      var n2 = Object.getOwnPropertySymbols(r2);
      t2 && (n2 = n2.filter(function(a) {
        return Object.getOwnPropertyDescriptor(r2, a).enumerable;
      })), e2.push.apply(e2, n2);
    }
    return e2;
  }
  function Ra(r2) {
    for (var t2 = 1; t2 < arguments.length; t2++) {
      var e2 = arguments[t2] != null ? arguments[t2] : {};
      t2 % 2 ? bG(Object(e2), true).forEach(function(n2) {
        go(r2, n2, e2[n2]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(r2, Object.getOwnPropertyDescriptors(e2)) : bG(Object(e2)).forEach(function(n2) {
        Object.defineProperty(r2, n2, Object.getOwnPropertyDescriptor(e2, n2));
      });
    }
    return r2;
  }
  function uX(r2) {
    if (Array.isArray(r2))
      return r2;
  }
  function IAe(r2, t2) {
    var e2 = r2 == null ? null : typeof Symbol != "undefined" && r2[Symbol.iterator] || r2["@@iterator"];
    if (e2 != null) {
      var n2 = [], a = true, i = false, o, s;
      try {
        for (e2 = e2.call(r2); !(a = (o = e2.next()).done) && (n2.push(o.value), !(t2 && n2.length === t2)); a = true)
          ;
      } catch (u) {
        i = true, s = u;
      } finally {
        try {
          !a && e2.return != null && e2.return();
        } finally {
          if (i)
            throw s;
        }
      }
      return n2;
    }
  }
  function p6(r2, t2) {
    (t2 == null || t2 > r2.length) && (t2 = r2.length);
    for (var e2 = 0, n2 = new Array(t2); e2 < t2; e2++)
      n2[e2] = r2[e2];
    return n2;
  }
  function jN(r2, t2) {
    if (!!r2) {
      if (typeof r2 == "string")
        return p6(r2, t2);
      var e2 = Object.prototype.toString.call(r2).slice(8, -1);
      if (e2 === "Object" && r2.constructor && (e2 = r2.constructor.name), e2 === "Map" || e2 === "Set")
        return Array.from(r2);
      if (e2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(e2))
        return p6(r2, t2);
    }
  }
  function lX() {
    throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function Wh(r2, t2) {
    return uX(r2) || IAe(r2, t2) || jN(r2, t2) || lX();
  }
  function LAe(r2, t2) {
    if (r2 == null)
      return {};
    var e2 = {}, n2 = Object.keys(r2), a, i;
    for (i = 0; i < n2.length; i++)
      a = n2[i], !(t2.indexOf(a) >= 0) && (e2[a] = r2[a]);
    return e2;
  }
  function Aw(r2, t2) {
    if (r2 == null)
      return {};
    var e2 = LAe(r2, t2), n2, a;
    if (Object.getOwnPropertySymbols) {
      var i = Object.getOwnPropertySymbols(r2);
      for (a = 0; a < i.length; a++)
        n2 = i[a], !(t2.indexOf(n2) >= 0) && (!Object.prototype.propertyIsEnumerable.call(r2, n2) || (e2[n2] = r2[n2]));
    }
    return e2;
  }
  var cX = { exports: {} };
  /*!
    Copyright (c) 2018 Jed Watson.
    Licensed under the MIT License (MIT), see
    http://jedwatson.github.io/classnames
  */
  (function(r2) {
    (function() {
      var t2 = {}.hasOwnProperty;
      function e2() {
        for (var n2 = [], a = 0; a < arguments.length; a++) {
          var i = arguments[a];
          if (!!i) {
            var o = typeof i;
            if (o === "string" || o === "number")
              n2.push(i);
            else if (Array.isArray(i)) {
              if (i.length) {
                var s = e2.apply(null, i);
                s && n2.push(s);
              }
            } else if (o === "object")
              if (i.toString === Object.prototype.toString)
                for (var u in i)
                  t2.call(i, u) && i[u] && n2.push(u);
              else
                n2.push(i.toString());
          }
        }
        return n2.join(" ");
      }
      r2.exports ? (e2.default = e2, r2.exports = e2) : window.classNames = e2;
    })();
  })(cX);
  var Tw = cX.exports;
  function sc(r2) {
    return sc = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(t2) {
      return typeof t2;
    } : function(t2) {
      return t2 && typeof Symbol == "function" && t2.constructor === Symbol && t2 !== Symbol.prototype ? "symbol" : typeof t2;
    }, sc(r2);
  }
  function Uh(r2, t2) {
    OAe(r2) && (r2 = "100%");
    var e2 = kAe(r2);
    return r2 = t2 === 360 ? r2 : Math.min(t2, Math.max(0, parseFloat(r2))), e2 && (r2 = parseInt(String(r2 * t2), 10) / 100), Math.abs(r2 - t2) < 1e-6 ? 1 : (t2 === 360 ? r2 = (r2 < 0 ? r2 % t2 + t2 : r2 % t2) / parseFloat(String(t2)) : r2 = r2 % t2 / parseFloat(String(t2)), r2);
  }
  function OAe(r2) {
    return typeof r2 == "string" && r2.indexOf(".") !== -1 && parseFloat(r2) === 1;
  }
  function kAe(r2) {
    return typeof r2 == "string" && r2.indexOf("%") !== -1;
  }
  function RAe(r2) {
    return r2 = parseFloat(r2), (isNaN(r2) || r2 < 0 || r2 > 1) && (r2 = 1), r2;
  }
  function p5(r2) {
    return r2 <= 1 ? Number(r2) * 100 + "%" : r2;
  }
  function mR(r2) {
    return r2.length === 1 ? "0" + r2 : String(r2);
  }
  function FAe(r2, t2, e2) {
    return { r: Uh(r2, 255) * 255, g: Uh(t2, 255) * 255, b: Uh(e2, 255) * 255 };
  }
  function bR(r2, t2, e2) {
    return e2 < 0 && (e2 += 1), e2 > 1 && (e2 -= 1), e2 < 1 / 6 ? r2 + (t2 - r2) * (6 * e2) : e2 < 1 / 2 ? t2 : e2 < 2 / 3 ? r2 + (t2 - r2) * (2 / 3 - e2) * 6 : r2;
  }
  function NAe(r2, t2, e2) {
    var n2, a, i;
    if (r2 = Uh(r2, 360), t2 = Uh(t2, 100), e2 = Uh(e2, 100), t2 === 0)
      a = e2, i = e2, n2 = e2;
    else {
      var o = e2 < 0.5 ? e2 * (1 + t2) : e2 + t2 - e2 * t2, s = 2 * e2 - o;
      n2 = bR(s, o, r2 + 1 / 3), a = bR(s, o, r2), i = bR(s, o, r2 - 1 / 3);
    }
    return { r: n2 * 255, g: a * 255, b: i * 255 };
  }
  function VAe(r2, t2, e2) {
    r2 = Uh(r2, 255), t2 = Uh(t2, 255), e2 = Uh(e2, 255);
    var n2 = Math.max(r2, t2, e2), a = Math.min(r2, t2, e2), i = 0, o = n2, s = n2 - a, u = n2 === 0 ? 0 : s / n2;
    if (n2 === a)
      i = 0;
    else {
      switch (n2) {
        case r2:
          i = (t2 - e2) / s + (t2 < e2 ? 6 : 0);
          break;
        case t2:
          i = (e2 - r2) / s + 2;
          break;
        case e2:
          i = (r2 - t2) / s + 4;
          break;
      }
      i /= 6;
    }
    return { h: i, s: u, v: o };
  }
  function jAe(r2, t2, e2) {
    r2 = Uh(r2, 360) * 6, t2 = Uh(t2, 100), e2 = Uh(e2, 100);
    var n2 = Math.floor(r2), a = r2 - n2, i = e2 * (1 - t2), o = e2 * (1 - a * t2), s = e2 * (1 - (1 - a) * t2), u = n2 % 6, l2 = [e2, o, i, i, s, e2][u], c2 = [s, e2, e2, o, i, i][u], f2 = [i, i, s, e2, e2, o][u];
    return { r: l2 * 255, g: c2 * 255, b: f2 * 255 };
  }
  function BAe(r2, t2, e2, n2) {
    var a = [mR(Math.round(r2).toString(16)), mR(Math.round(t2).toString(16)), mR(Math.round(e2).toString(16))];
    return n2 && a[0].startsWith(a[0].charAt(1)) && a[1].startsWith(a[1].charAt(1)) && a[2].startsWith(a[2].charAt(1)) ? a[0].charAt(0) + a[1].charAt(0) + a[2].charAt(0) : a.join("");
  }
  function _G(r2) {
    return qf(r2) / 255;
  }
  function qf(r2) {
    return parseInt(r2, 16);
  }
  var xG = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
  function pC(r2) {
    var t2 = { r: 0, g: 0, b: 0 }, e2 = 1, n2 = null, a = null, i = null, o = false, s = false;
    return typeof r2 == "string" && (r2 = GAe(r2)), typeof r2 == "object" && (pg(r2.r) && pg(r2.g) && pg(r2.b) ? (t2 = FAe(r2.r, r2.g, r2.b), o = true, s = String(r2.r).substr(-1) === "%" ? "prgb" : "rgb") : pg(r2.h) && pg(r2.s) && pg(r2.v) ? (n2 = p5(r2.s), a = p5(r2.v), t2 = jAe(r2.h, n2, a), o = true, s = "hsv") : pg(r2.h) && pg(r2.s) && pg(r2.l) && (n2 = p5(r2.s), i = p5(r2.l), t2 = NAe(r2.h, n2, i), o = true, s = "hsl"), Object.prototype.hasOwnProperty.call(r2, "a") && (e2 = r2.a)), e2 = RAe(e2), { ok: o, format: r2.format || s, r: Math.min(255, Math.max(t2.r, 0)), g: Math.min(255, Math.max(t2.g, 0)), b: Math.min(255, Math.max(t2.b, 0)), a: e2 };
  }
  var zAe = "[-\\+]?\\d+%?", $Ae = "[-\\+]?\\d*\\.\\d+%?", fy = "(?:" + $Ae + ")|(?:" + zAe + ")", _R = "[\\s|\\(]+(" + fy + ")[,|\\s]+(" + fy + ")[,|\\s]+(" + fy + ")\\s*\\)?", xR = "[\\s|\\(]+(" + fy + ")[,|\\s]+(" + fy + ")[,|\\s]+(" + fy + ")[,|\\s]+(" + fy + ")\\s*\\)?", Rv = { CSS_UNIT: new RegExp(fy), rgb: new RegExp("rgb" + _R), rgba: new RegExp("rgba" + xR), hsl: new RegExp("hsl" + _R), hsla: new RegExp("hsla" + xR), hsv: new RegExp("hsv" + _R), hsva: new RegExp("hsva" + xR), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
  function GAe(r2) {
    if (r2 = r2.trim().toLowerCase(), r2.length === 0)
      return false;
    var t2 = false;
    if (xG[r2])
      r2 = xG[r2], t2 = true;
    else if (r2 === "transparent")
      return { r: 0, g: 0, b: 0, a: 0, format: "name" };
    var e2 = Rv.rgb.exec(r2);
    return e2 ? { r: e2[1], g: e2[2], b: e2[3] } : (e2 = Rv.rgba.exec(r2), e2 ? { r: e2[1], g: e2[2], b: e2[3], a: e2[4] } : (e2 = Rv.hsl.exec(r2), e2 ? { h: e2[1], s: e2[2], l: e2[3] } : (e2 = Rv.hsla.exec(r2), e2 ? { h: e2[1], s: e2[2], l: e2[3], a: e2[4] } : (e2 = Rv.hsv.exec(r2), e2 ? { h: e2[1], s: e2[2], v: e2[3] } : (e2 = Rv.hsva.exec(r2), e2 ? { h: e2[1], s: e2[2], v: e2[3], a: e2[4] } : (e2 = Rv.hex8.exec(r2), e2 ? { r: qf(e2[1]), g: qf(e2[2]), b: qf(e2[3]), a: _G(e2[4]), format: t2 ? "name" : "hex8" } : (e2 = Rv.hex6.exec(r2), e2 ? { r: qf(e2[1]), g: qf(e2[2]), b: qf(e2[3]), format: t2 ? "name" : "hex" } : (e2 = Rv.hex4.exec(r2), e2 ? { r: qf(e2[1] + e2[1]), g: qf(e2[2] + e2[2]), b: qf(e2[3] + e2[3]), a: _G(e2[4] + e2[4]), format: t2 ? "name" : "hex8" } : (e2 = Rv.hex3.exec(r2), e2 ? { r: qf(e2[1] + e2[1]), g: qf(e2[2] + e2[2]), b: qf(e2[3] + e2[3]), format: t2 ? "name" : "hex" } : false)))))))));
  }
  function pg(r2) {
    return Boolean(Rv.CSS_UNIT.exec(String(r2)));
  }
  var g5 = 2, wG = 0.16, WAe = 0.05, UAe = 0.05, HAe = 0.15, fX = 5, hX = 4, qAe = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
  function SG(r2) {
    var t2 = r2.r, e2 = r2.g, n2 = r2.b, a = VAe(t2, e2, n2);
    return { h: a.h * 360, s: a.s, v: a.v };
  }
  function y5(r2) {
    var t2 = r2.r, e2 = r2.g, n2 = r2.b;
    return "#".concat(BAe(t2, e2, n2, false));
  }
  function YAe(r2, t2, e2) {
    var n2 = e2 / 100, a = { r: (t2.r - r2.r) * n2 + r2.r, g: (t2.g - r2.g) * n2 + r2.g, b: (t2.b - r2.b) * n2 + r2.b };
    return a;
  }
  function CG(r2, t2, e2) {
    var n2;
    return Math.round(r2.h) >= 60 && Math.round(r2.h) <= 240 ? n2 = e2 ? Math.round(r2.h) - g5 * t2 : Math.round(r2.h) + g5 * t2 : n2 = e2 ? Math.round(r2.h) + g5 * t2 : Math.round(r2.h) - g5 * t2, n2 < 0 ? n2 += 360 : n2 >= 360 && (n2 -= 360), n2;
  }
  function EG(r2, t2, e2) {
    if (r2.h === 0 && r2.s === 0)
      return r2.s;
    var n2;
    return e2 ? n2 = r2.s - wG * t2 : t2 === hX ? n2 = r2.s + wG : n2 = r2.s + WAe * t2, n2 > 1 && (n2 = 1), e2 && t2 === fX && n2 > 0.1 && (n2 = 0.1), n2 < 0.06 && (n2 = 0.06), Number(n2.toFixed(2));
  }
  function AG(r2, t2, e2) {
    var n2;
    return e2 ? n2 = r2.v + UAe * t2 : n2 = r2.v - HAe * t2, n2 > 1 && (n2 = 1), Number(n2.toFixed(2));
  }
  function g6(r2) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [], n2 = pC(r2), a = fX; a > 0; a -= 1) {
      var i = SG(n2), o = y5(pC({ h: CG(i, a, true), s: EG(i, a, true), v: AG(i, a, true) }));
      e2.push(o);
    }
    e2.push(y5(n2));
    for (var s = 1; s <= hX; s += 1) {
      var u = SG(n2), l2 = y5(pC({ h: CG(u, s), s: EG(u, s), v: AG(u, s) }));
      e2.push(l2);
    }
    return t2.theme === "dark" ? qAe.map(function(c2) {
      var f2 = c2.index, h = c2.opacity, v9 = y5(YAe(pC(t2.backgroundColor || "#141414"), pC(e2[f2]), h * 100));
      return v9;
    }) : e2;
  }
  var wR = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, uc = {}, SR = {};
  Object.keys(wR).forEach(function(r2) {
    uc[r2] = g6(wR[r2]), uc[r2].primary = uc[r2][5], SR[r2] = g6(wR[r2], { theme: "dark", backgroundColor: "#141414" }), SR[r2].primary = SR[r2][5];
  });
  uc.red;
  uc.volcano;
  uc.gold;
  uc.orange;
  uc.yellow;
  uc.lime;
  uc.green;
  uc.cyan;
  uc.blue;
  uc.geekblue;
  uc.purple;
  uc.magenta;
  uc.grey;
  var TG = {};
  function KAe(r2, t2) {
  }
  function ZAe(r2, t2, e2) {
    !t2 && !TG[e2] && (r2(false, e2), TG[e2] = true);
  }
  function Jd(r2, t2) {
    ZAe(KAe, r2, t2);
  }
  function vX() {
    return !!(typeof window != "undefined" && window.document && window.document.createElement);
  }
  var XAe = "rc-util-key";
  function dX() {
    var r2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t2 = r2.mark;
    return t2 ? t2.startsWith("data-") ? t2 : "data-".concat(t2) : XAe;
  }
  function BN(r2) {
    if (r2.attachTo)
      return r2.attachTo;
    var t2 = document.querySelector("head");
    return t2 || document.body;
  }
  function MG(r2) {
    var t2, e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (!vX())
      return null;
    var n2 = document.createElement("style");
    if (!((t2 = e2.csp) === null || t2 === void 0) && t2.nonce) {
      var a;
      n2.nonce = (a = e2.csp) === null || a === void 0 ? void 0 : a.nonce;
    }
    n2.innerHTML = r2;
    var i = BN(e2), o = i.firstChild;
    return e2.prepend && i.prepend ? i.prepend(n2) : e2.prepend && o ? i.insertBefore(n2, o) : i.appendChild(n2), n2;
  }
  var y6 = /* @__PURE__ */ new Map();
  function JAe(r2) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = BN(t2);
    return Array.from(y6.get(e2).children).find(function(n2) {
      return n2.tagName === "STYLE" && n2.getAttribute(dX(t2)) === r2;
    });
  }
  function pX(r2, t2) {
    var e2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, n2 = BN(e2);
    if (!y6.has(n2)) {
      var a = MG("", e2), i = a.parentNode;
      y6.set(n2, i), i.removeChild(a);
    }
    var o = JAe(t2, e2);
    if (o) {
      var s, u;
      if (((s = e2.csp) === null || s === void 0 ? void 0 : s.nonce) && o.nonce !== ((u = e2.csp) === null || u === void 0 ? void 0 : u.nonce)) {
        var l2;
        o.nonce = (l2 = e2.csp) === null || l2 === void 0 ? void 0 : l2.nonce;
      }
      return o.innerHTML !== r2 && (o.innerHTML = r2), o;
    }
    var c2 = MG(r2, e2);
    return c2.setAttribute(dX(e2), t2), c2;
  }
  function QAe(r2, t2) {
    Jd(r2, "[@ant-design/icons] ".concat(t2));
  }
  function PG(r2) {
    return sc(r2) === "object" && typeof r2.name == "string" && typeof r2.theme == "string" && (sc(r2.icon) === "object" || typeof r2.icon == "function");
  }
  function DG() {
    var r2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return Object.keys(r2).reduce(function(t2, e2) {
      var n2 = r2[e2];
      switch (e2) {
        case "class":
          t2.className = n2, delete t2.class;
          break;
        default:
          t2[e2] = n2;
      }
      return t2;
    }, {});
  }
  function m6(r2, t2, e2) {
    return e2 ? ew.default.createElement(r2.tag, Ra(Ra({ key: t2 }, DG(r2.attrs)), e2), (r2.children || []).map(function(n2, a) {
      return m6(n2, "".concat(t2, "-").concat(r2.tag, "-").concat(a));
    })) : ew.default.createElement(r2.tag, Ra({ key: t2 }, DG(r2.attrs)), (r2.children || []).map(function(n2, a) {
      return m6(n2, "".concat(t2, "-").concat(r2.tag, "-").concat(a));
    }));
  }
  function gX(r2) {
    return g6(r2)[0];
  }
  function yX(r2) {
    return r2 ? Array.isArray(r2) ? r2 : [r2] : [];
  }
  var eTe = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, tTe = function() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : eTe, e2 = Li.useContext(sX), n2 = e2.csp;
    Li.useEffect(function() {
      pX(t2, "@ant-design-icons", { prepend: true, csp: n2 });
    }, []);
  }, rTe = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], qC = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
  function nTe(r2) {
    var t2 = r2.primaryColor, e2 = r2.secondaryColor;
    qC.primaryColor = t2, qC.secondaryColor = e2 || gX(t2), qC.calculated = !!e2;
  }
  function aTe() {
    return Ra({}, qC);
  }
  var P3 = function(t2) {
    var e2 = t2.icon, n2 = t2.className, a = t2.onClick, i = t2.style, o = t2.primaryColor, s = t2.secondaryColor, u = Aw(t2, rTe), l2 = qC;
    if (o && (l2 = { primaryColor: o, secondaryColor: s || gX(o) }), tTe(), QAe(PG(e2), "icon should be icon definiton, but got ".concat(e2)), !PG(e2))
      return null;
    var c2 = e2;
    return c2 && typeof c2.icon == "function" && (c2 = Ra(Ra({}, c2), {}, { icon: c2.icon(l2.primaryColor, l2.secondaryColor) })), m6(c2.icon, "svg-".concat(c2.name), Ra({ className: n2, onClick: a, style: i, "data-icon": c2.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, u));
  };
  P3.displayName = "IconReact";
  P3.getTwoToneColors = aTe;
  P3.setTwoToneColors = nTe;
  var zN = P3;
  function mX(r2) {
    var t2 = yX(r2), e2 = Wh(t2, 2), n2 = e2[0], a = e2[1];
    return zN.setTwoToneColors({ primaryColor: n2, secondaryColor: a });
  }
  function iTe() {
    var r2 = zN.getTwoToneColors();
    return r2.calculated ? [r2.primaryColor, r2.secondaryColor] : r2.primaryColor;
  }
  var oTe = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
  mX("#1890ff");
  var D3 = Lr.forwardRef(function(r2, t2) {
    var e2, n2 = r2.className, a = r2.icon, i = r2.spin, o = r2.rotate, s = r2.tabIndex, u = r2.onClick, l2 = r2.twoToneColor, c2 = Aw(r2, oTe), f2 = Lr.useContext(sX), h = f2.prefixCls, v9 = h === void 0 ? "anticon" : h, d2 = Tw(v9, (e2 = {}, go(e2, "".concat(v9, "-").concat(a.name), !!a.name), go(e2, "".concat(v9, "-spin"), !!i || a.name === "loading"), e2), n2), m2 = s;
    m2 === void 0 && u && (m2 = -1);
    var b2 = o ? { msTransform: "rotate(".concat(o, "deg)"), transform: "rotate(".concat(o, "deg)") } : void 0, _ = yX(l2), C = Wh(_, 2), M = C[0], E = C[1];
    return Lr.createElement("span", Ra(Ra({ role: "img", "aria-label": a.name }, c2), {}, { ref: t2, tabIndex: m2, onClick: u, className: d2 }), Lr.createElement(zN, { icon: a, primaryColor: M, secondaryColor: E, style: b2 }));
  });
  D3.displayName = "AntdIcon";
  D3.getTwoToneColor = iTe;
  D3.setTwoToneColor = mX;
  var sTe = D3, uTe = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, lTe = uTe, bX = function(t2, e2) {
    return Lr.createElement(sTe, Ra(Ra({}, t2), {}, { ref: e2, icon: lTe }));
  };
  bX.displayName = "LoadingOutlined";
  var cTe = Lr.forwardRef(bX);
  function Su() {
    return Su = Object.assign || function(r2) {
      for (var t2 = 1; t2 < arguments.length; t2++) {
        var e2 = arguments[t2];
        for (var n2 in e2)
          Object.prototype.hasOwnProperty.call(e2, n2) && (r2[n2] = e2[n2]);
      }
      return r2;
    }, Su.apply(this, arguments);
  }
  function ZE(r2, t2) {
    if (!(r2 instanceof t2))
      throw new TypeError("Cannot call a class as a function");
  }
  function IG(r2, t2) {
    for (var e2 = 0; e2 < t2.length; e2++) {
      var n2 = t2[e2];
      n2.enumerable = n2.enumerable || false, n2.configurable = true, "value" in n2 && (n2.writable = true), Object.defineProperty(r2, n2.key, n2);
    }
  }
  function XE(r2, t2, e2) {
    return t2 && IG(r2.prototype, t2), e2 && IG(r2, e2), Object.defineProperty(r2, "prototype", { writable: false }), r2;
  }
  function b6(r2, t2) {
    return b6 = Object.setPrototypeOf || function(n2, a) {
      return n2.__proto__ = a, n2;
    }, b6(r2, t2);
  }
  function $N(r2, t2) {
    if (typeof t2 != "function" && t2 !== null)
      throw new TypeError("Super expression must either be null or a function");
    r2.prototype = Object.create(t2 && t2.prototype, { constructor: { value: r2, writable: true, configurable: true } }), Object.defineProperty(r2, "prototype", { writable: false }), t2 && b6(r2, t2);
  }
  function jP(r2) {
    return jP = Object.setPrototypeOf ? Object.getPrototypeOf : function(e2) {
      return e2.__proto__ || Object.getPrototypeOf(e2);
    }, jP(r2);
  }
  function fTe() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function GN(r2) {
    if (r2 === void 0)
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return r2;
  }
  function hTe(r2, t2) {
    if (t2 && (sc(t2) === "object" || typeof t2 == "function"))
      return t2;
    if (t2 !== void 0)
      throw new TypeError("Derived constructors may only return object or undefined");
    return GN(r2);
  }
  function WN(r2) {
    var t2 = fTe();
    return function() {
      var n2 = jP(r2), a;
      if (t2) {
        var i = jP(this).constructor;
        a = Reflect.construct(n2, arguments, i);
      } else
        a = n2.apply(this, arguments);
      return hTe(this, a);
    };
  }
  var UN = { exports: {} }, Po = {};
  /** @license React v16.13.1
  * react-is.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var xl = typeof Symbol == "function" && Symbol.for, HN = xl ? Symbol.for("react.element") : 60103, qN = xl ? Symbol.for("react.portal") : 60106, I3 = xl ? Symbol.for("react.fragment") : 60107, L3 = xl ? Symbol.for("react.strict_mode") : 60108, O3 = xl ? Symbol.for("react.profiler") : 60114, k3 = xl ? Symbol.for("react.provider") : 60109, R3 = xl ? Symbol.for("react.context") : 60110, YN = xl ? Symbol.for("react.async_mode") : 60111, F3 = xl ? Symbol.for("react.concurrent_mode") : 60111, N3 = xl ? Symbol.for("react.forward_ref") : 60112, V3 = xl ? Symbol.for("react.suspense") : 60113, vTe = xl ? Symbol.for("react.suspense_list") : 60120, j3 = xl ? Symbol.for("react.memo") : 60115, B3 = xl ? Symbol.for("react.lazy") : 60116, dTe = xl ? Symbol.for("react.block") : 60121, pTe = xl ? Symbol.for("react.fundamental") : 60117, gTe = xl ? Symbol.for("react.responder") : 60118, yTe = xl ? Symbol.for("react.scope") : 60119;
  function eh(r2) {
    if (typeof r2 == "object" && r2 !== null) {
      var t2 = r2.$$typeof;
      switch (t2) {
        case HN:
          switch (r2 = r2.type, r2) {
            case YN:
            case F3:
            case I3:
            case O3:
            case L3:
            case V3:
              return r2;
            default:
              switch (r2 = r2 && r2.$$typeof, r2) {
                case R3:
                case N3:
                case B3:
                case j3:
                case k3:
                  return r2;
                default:
                  return t2;
              }
          }
        case qN:
          return t2;
      }
    }
  }
  function _X(r2) {
    return eh(r2) === F3;
  }
  Po.AsyncMode = YN;
  Po.ConcurrentMode = F3;
  Po.ContextConsumer = R3;
  Po.ContextProvider = k3;
  Po.Element = HN;
  Po.ForwardRef = N3;
  Po.Fragment = I3;
  Po.Lazy = B3;
  Po.Memo = j3;
  Po.Portal = qN;
  Po.Profiler = O3;
  Po.StrictMode = L3;
  Po.Suspense = V3;
  Po.isAsyncMode = function(r2) {
    return _X(r2) || eh(r2) === YN;
  };
  Po.isConcurrentMode = _X;
  Po.isContextConsumer = function(r2) {
    return eh(r2) === R3;
  };
  Po.isContextProvider = function(r2) {
    return eh(r2) === k3;
  };
  Po.isElement = function(r2) {
    return typeof r2 == "object" && r2 !== null && r2.$$typeof === HN;
  };
  Po.isForwardRef = function(r2) {
    return eh(r2) === N3;
  };
  Po.isFragment = function(r2) {
    return eh(r2) === I3;
  };
  Po.isLazy = function(r2) {
    return eh(r2) === B3;
  };
  Po.isMemo = function(r2) {
    return eh(r2) === j3;
  };
  Po.isPortal = function(r2) {
    return eh(r2) === qN;
  };
  Po.isProfiler = function(r2) {
    return eh(r2) === O3;
  };
  Po.isStrictMode = function(r2) {
    return eh(r2) === L3;
  };
  Po.isSuspense = function(r2) {
    return eh(r2) === V3;
  };
  Po.isValidElementType = function(r2) {
    return typeof r2 == "string" || typeof r2 == "function" || r2 === I3 || r2 === F3 || r2 === O3 || r2 === L3 || r2 === V3 || r2 === vTe || typeof r2 == "object" && r2 !== null && (r2.$$typeof === B3 || r2.$$typeof === j3 || r2.$$typeof === k3 || r2.$$typeof === R3 || r2.$$typeof === N3 || r2.$$typeof === pTe || r2.$$typeof === gTe || r2.$$typeof === yTe || r2.$$typeof === dTe);
  };
  Po.typeOf = eh;
  UN.exports = Po;
  function _6(r2) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [];
    return ew.default.Children.forEach(r2, function(n2) {
      n2 == null && !t2.keepEmpty || (Array.isArray(n2) ? e2 = e2.concat(_6(n2)) : UN.exports.isFragment(n2) && n2.props ? e2 = e2.concat(_6(n2.props.children, t2)) : e2.push(n2));
    }), e2;
  }
  function mTe(r2, t2) {
    typeof r2 == "function" ? r2(t2) : sc(r2) === "object" && r2 && "current" in r2 && (r2.current = t2);
  }
  function bTe() {
    for (var r2 = arguments.length, t2 = new Array(r2), e2 = 0; e2 < r2; e2++)
      t2[e2] = arguments[e2];
    var n2 = t2.filter(function(a) {
      return a;
    });
    return n2.length <= 1 ? n2[0] : function(a) {
      t2.forEach(function(i) {
        mTe(i, a);
      });
    };
  }
  function _Te(r2) {
    var t2, e2, n2 = UN.exports.isMemo(r2) ? r2.type.type : r2.type;
    return !(typeof n2 == "function" && !(!((t2 = n2.prototype) === null || t2 === void 0) && t2.render) || typeof r2 == "function" && !(!((e2 = r2.prototype) === null || e2 === void 0) && e2.render));
  }
  function CTe() {
    try {
      if (!Object.assign)
        return false;
      var r2 = new String("abc");
      if (r2[5] = "de", Object.getOwnPropertyNames(r2)[0] === "5")
        return false;
      for (var t2 = {}, e2 = 0; e2 < 10; e2++)
        t2["_" + String.fromCharCode(e2)] = e2;
      var n2 = Object.getOwnPropertyNames(t2).map(function(i) {
        return t2[i];
      });
      if (n2.join("") !== "0123456789")
        return false;
      var a = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(i) {
        a[i] = i;
      }), Object.keys(Object.assign({}, a)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return false;
    }
  }
  CTe();
  function ETe(r2) {
    if (Array.isArray(r2))
      return p6(r2);
  }
  function xX(r2) {
    if (typeof Symbol != "undefined" && r2[Symbol.iterator] != null || r2["@@iterator"] != null)
      return Array.from(r2);
  }
  function ATe() {
    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function Vi(r2) {
    return ETe(r2) || xX(r2) || jN(r2) || ATe();
  }
  var Hx = "RC_FORM_INTERNAL_HOOKS", ls = function() {
    Jd(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
  }, EE = Lr.createContext({ getFieldValue: ls, getFieldsValue: ls, getFieldError: ls, getFieldWarning: ls, getFieldsError: ls, isFieldsTouched: ls, isFieldTouched: ls, isFieldValidating: ls, isFieldsValidating: ls, resetFields: ls, setFields: ls, setFieldsValue: ls, validateFields: ls, submit: ls, getInternalHooks: function() {
    return ls(), { dispatch: ls, initEntityValue: ls, registerField: ls, useSubscribe: ls, setInitialValues: ls, setCallbacks: ls, getFields: ls, setValidateMessages: ls, setPreserve: ls, getInitialValue: ls };
  } });
  function x6(r2) {
    return r2 == null ? [] : Array.isArray(r2) ? r2 : [r2];
  }
  var wX = { exports: {} };
  (function(r2) {
    var t2 = function(e2) {
      var n2 = Object.prototype, a = n2.hasOwnProperty, i, o = typeof Symbol == "function" ? Symbol : {}, s = o.iterator || "@@iterator", u = o.asyncIterator || "@@asyncIterator", l2 = o.toStringTag || "@@toStringTag";
      function c2(Le, Fe, qe) {
        return Object.defineProperty(Le, Fe, { value: qe, enumerable: true, configurable: true, writable: true }), Le[Fe];
      }
      try {
        c2({}, "");
      } catch {
        c2 = function(Fe, qe, st) {
          return Fe[qe] = st;
        };
      }
      function f2(Le, Fe, qe, st) {
        var dt = Fe && Fe.prototype instanceof C ? Fe : C, Ar = Object.create(dt.prototype), Hr = new Ee(st || []);
        return Ar._invoke = ee(Le, qe, Hr), Ar;
      }
      e2.wrap = f2;
      function h(Le, Fe, qe) {
        try {
          return { type: "normal", arg: Le.call(Fe, qe) };
        } catch (st) {
          return { type: "throw", arg: st };
        }
      }
      var v9 = "suspendedStart", d2 = "suspendedYield", m2 = "executing", b2 = "completed", _ = {};
      function C() {
      }
      function M() {
      }
      function E() {
      }
      var z9 = {};
      c2(z9, s, function() {
        return this;
      });
      var V = Object.getPrototypeOf, $ = V && V(V(ye([])));
      $ && $ !== n2 && a.call($, s) && (z9 = $);
      var U = E.prototype = C.prototype = Object.create(z9);
      M.prototype = E, c2(U, "constructor", E), c2(E, "constructor", M), M.displayName = c2(E, l2, "GeneratorFunction");
      function H(Le) {
        ["next", "throw", "return"].forEach(function(Fe) {
          c2(Le, Fe, function(qe) {
            return this._invoke(Fe, qe);
          });
        });
      }
      e2.isGeneratorFunction = function(Le) {
        var Fe = typeof Le == "function" && Le.constructor;
        return Fe ? Fe === M || (Fe.displayName || Fe.name) === "GeneratorFunction" : false;
      }, e2.mark = function(Le) {
        return Object.setPrototypeOf ? Object.setPrototypeOf(Le, E) : (Le.__proto__ = E, c2(Le, l2, "GeneratorFunction")), Le.prototype = Object.create(U), Le;
      }, e2.awrap = function(Le) {
        return { __await: Le };
      };
      function q3(Le, Fe) {
        function qe(Ar, Hr, hn, cn) {
          var nn = h(Le[Ar], Le, Hr);
          if (nn.type === "throw")
            cn(nn.arg);
          else {
            var Wr = nn.arg, on = Wr.value;
            return on && typeof on == "object" && a.call(on, "__await") ? Fe.resolve(on.__await).then(function(un) {
              qe("next", un, hn, cn);
            }, function(un) {
              qe("throw", un, hn, cn);
            }) : Fe.resolve(on).then(function(un) {
              Wr.value = un, hn(Wr);
            }, function(un) {
              return qe("throw", un, hn, cn);
            });
          }
        }
        var st;
        function dt(Ar, Hr) {
          function hn() {
            return new Fe(function(cn, nn) {
              qe(Ar, Hr, cn, nn);
            });
          }
          return st = st ? st.then(hn, hn) : hn();
        }
        this._invoke = dt;
      }
      H(q3.prototype), c2(q3.prototype, u, function() {
        return this;
      }), e2.AsyncIterator = q3, e2.async = function(Le, Fe, qe, st, dt) {
        dt === void 0 && (dt = Promise);
        var Ar = new q3(f2(Le, Fe, qe, st), dt);
        return e2.isGeneratorFunction(Fe) ? Ar : Ar.next().then(function(Hr) {
          return Hr.done ? Hr.value : Ar.next();
        });
      };
      function ee(Le, Fe, qe) {
        var st = v9;
        return function(Ar, Hr) {
          if (st === m2)
            throw new Error("Generator is already running");
          if (st === b2) {
            if (Ar === "throw")
              throw Hr;
            return et();
          }
          for (qe.method = Ar, qe.arg = Hr; ; ) {
            var hn = qe.delegate;
            if (hn) {
              var cn = oe(hn, qe);
              if (cn) {
                if (cn === _)
                  continue;
                return cn;
              }
            }
            if (qe.method === "next")
              qe.sent = qe._sent = qe.arg;
            else if (qe.method === "throw") {
              if (st === v9)
                throw st = b2, qe.arg;
              qe.dispatchException(qe.arg);
            } else
              qe.method === "return" && qe.abrupt("return", qe.arg);
            st = m2;
            var nn = h(Le, Fe, qe);
            if (nn.type === "normal") {
              if (st = qe.done ? b2 : d2, nn.arg === _)
                continue;
              return { value: nn.arg, done: qe.done };
            } else
              nn.type === "throw" && (st = b2, qe.method = "throw", qe.arg = nn.arg);
          }
        };
      }
      function oe(Le, Fe) {
        var qe = Le.iterator[Fe.method];
        if (qe === i) {
          if (Fe.delegate = null, Fe.method === "throw") {
            if (Le.iterator.return && (Fe.method = "return", Fe.arg = i, oe(Le, Fe), Fe.method === "throw"))
              return _;
            Fe.method = "throw", Fe.arg = new TypeError("The iterator does not provide a 'throw' method");
          }
          return _;
        }
        var st = h(qe, Le.iterator, Fe.arg);
        if (st.type === "throw")
          return Fe.method = "throw", Fe.arg = st.arg, Fe.delegate = null, _;
        var dt = st.arg;
        if (!dt)
          return Fe.method = "throw", Fe.arg = new TypeError("iterator result is not an object"), Fe.delegate = null, _;
        if (dt.done)
          Fe[Le.resultName] = dt.value, Fe.next = Le.nextLoc, Fe.method !== "return" && (Fe.method = "next", Fe.arg = i);
        else
          return dt;
        return Fe.delegate = null, _;
      }
      H(U), c2(U, l2, "Generator"), c2(U, s, function() {
        return this;
      }), c2(U, "toString", function() {
        return "[object Generator]";
      });
      function ne(Le) {
        var Fe = { tryLoc: Le[0] };
        1 in Le && (Fe.catchLoc = Le[1]), 2 in Le && (Fe.finallyLoc = Le[2], Fe.afterLoc = Le[3]), this.tryEntries.push(Fe);
      }
      function be(Le) {
        var Fe = Le.completion || {};
        Fe.type = "normal", delete Fe.arg, Le.completion = Fe;
      }
      function Ee(Le) {
        this.tryEntries = [{ tryLoc: "root" }], Le.forEach(ne, this), this.reset(true);
      }
      e2.keys = function(Le) {
        var Fe = [];
        for (var qe in Le)
          Fe.push(qe);
        return Fe.reverse(), function st() {
          for (; Fe.length; ) {
            var dt = Fe.pop();
            if (dt in Le)
              return st.value = dt, st.done = false, st;
          }
          return st.done = true, st;
        };
      };
      function ye(Le) {
        if (Le) {
          var Fe = Le[s];
          if (Fe)
            return Fe.call(Le);
          if (typeof Le.next == "function")
            return Le;
          if (!isNaN(Le.length)) {
            var qe = -1, st = function dt() {
              for (; ++qe < Le.length; )
                if (a.call(Le, qe))
                  return dt.value = Le[qe], dt.done = false, dt;
              return dt.value = i, dt.done = true, dt;
            };
            return st.next = st;
          }
        }
        return { next: et };
      }
      e2.values = ye;
      function et() {
        return { value: i, done: true };
      }
      return Ee.prototype = { constructor: Ee, reset: function(Le) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = i, this.done = false, this.delegate = null, this.method = "next", this.arg = i, this.tryEntries.forEach(be), !Le)
          for (var Fe in this)
            Fe.charAt(0) === "t" && a.call(this, Fe) && !isNaN(+Fe.slice(1)) && (this[Fe] = i);
      }, stop: function() {
        this.done = true;
        var Le = this.tryEntries[0], Fe = Le.completion;
        if (Fe.type === "throw")
          throw Fe.arg;
        return this.rval;
      }, dispatchException: function(Le) {
        if (this.done)
          throw Le;
        var Fe = this;
        function qe(cn, nn) {
          return Ar.type = "throw", Ar.arg = Le, Fe.next = cn, nn && (Fe.method = "next", Fe.arg = i), !!nn;
        }
        for (var st = this.tryEntries.length - 1; st >= 0; --st) {
          var dt = this.tryEntries[st], Ar = dt.completion;
          if (dt.tryLoc === "root")
            return qe("end");
          if (dt.tryLoc <= this.prev) {
            var Hr = a.call(dt, "catchLoc"), hn = a.call(dt, "finallyLoc");
            if (Hr && hn) {
              if (this.prev < dt.catchLoc)
                return qe(dt.catchLoc, true);
              if (this.prev < dt.finallyLoc)
                return qe(dt.finallyLoc);
            } else if (Hr) {
              if (this.prev < dt.catchLoc)
                return qe(dt.catchLoc, true);
            } else if (hn) {
              if (this.prev < dt.finallyLoc)
                return qe(dt.finallyLoc);
            } else
              throw new Error("try statement without catch or finally");
          }
        }
      }, abrupt: function(Le, Fe) {
        for (var qe = this.tryEntries.length - 1; qe >= 0; --qe) {
          var st = this.tryEntries[qe];
          if (st.tryLoc <= this.prev && a.call(st, "finallyLoc") && this.prev < st.finallyLoc) {
            var dt = st;
            break;
          }
        }
        dt && (Le === "break" || Le === "continue") && dt.tryLoc <= Fe && Fe <= dt.finallyLoc && (dt = null);
        var Ar = dt ? dt.completion : {};
        return Ar.type = Le, Ar.arg = Fe, dt ? (this.method = "next", this.next = dt.finallyLoc, _) : this.complete(Ar);
      }, complete: function(Le, Fe) {
        if (Le.type === "throw")
          throw Le.arg;
        return Le.type === "break" || Le.type === "continue" ? this.next = Le.arg : Le.type === "return" ? (this.rval = this.arg = Le.arg, this.method = "return", this.next = "end") : Le.type === "normal" && Fe && (this.next = Fe), _;
      }, finish: function(Le) {
        for (var Fe = this.tryEntries.length - 1; Fe >= 0; --Fe) {
          var qe = this.tryEntries[Fe];
          if (qe.finallyLoc === Le)
            return this.complete(qe.completion, qe.afterLoc), be(qe), _;
        }
      }, catch: function(Le) {
        for (var Fe = this.tryEntries.length - 1; Fe >= 0; --Fe) {
          var qe = this.tryEntries[Fe];
          if (qe.tryLoc === Le) {
            var st = qe.completion;
            if (st.type === "throw") {
              var dt = st.arg;
              be(qe);
            }
            return dt;
          }
        }
        throw new Error("illegal catch attempt");
      }, delegateYield: function(Le, Fe, qe) {
        return this.delegate = { iterator: ye(Le), resultName: Fe, nextLoc: qe }, this.method === "next" && (this.arg = i), _;
      } }, e2;
    }(r2.exports);
    try {
      regeneratorRuntime = t2;
    } catch {
      typeof globalThis == "object" ? globalThis.regeneratorRuntime = t2 : Function("r", "regeneratorRuntime = r")(t2);
    }
  })(wX);
  var Ey = wX.exports;
  function OG(r2, t2, e2, n2, a, i, o) {
    try {
      var s = r2[i](o), u = s.value;
    } catch (l2) {
      e2(l2);
      return;
    }
    s.done ? t2(u) : Promise.resolve(u).then(n2, a);
  }
  function z3(r2) {
    return function() {
      var t2 = this, e2 = arguments;
      return new Promise(function(n2, a) {
        var i = r2.apply(t2, e2);
        function o(u) {
          OG(i, n2, a, o, s, "next", u);
        }
        function s(u) {
          OG(i, n2, a, o, s, "throw", u);
        }
        o(void 0);
      });
    };
  }
  function Gb() {
    return Gb = Object.assign || function(r2) {
      for (var t2 = 1; t2 < arguments.length; t2++) {
        var e2 = arguments[t2];
        for (var n2 in e2)
          Object.prototype.hasOwnProperty.call(e2, n2) && (r2[n2] = e2[n2]);
      }
      return r2;
    }, Gb.apply(this, arguments);
  }
  function TTe(r2, t2) {
    r2.prototype = Object.create(t2.prototype), r2.prototype.constructor = r2, AE(r2, t2);
  }
  function w6(r2) {
    return w6 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e2) {
      return e2.__proto__ || Object.getPrototypeOf(e2);
    }, w6(r2);
  }
  function AE(r2, t2) {
    return AE = Object.setPrototypeOf || function(n2, a) {
      return n2.__proto__ = a, n2;
    }, AE(r2, t2);
  }
  function MTe() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function z5(r2, t2, e2) {
    return MTe() ? z5 = Reflect.construct : z5 = function(a, i, o) {
      var s = [null];
      s.push.apply(s, i);
      var u = Function.bind.apply(a, s), l2 = new u();
      return o && AE(l2, o.prototype), l2;
    }, z5.apply(null, arguments);
  }
  function PTe(r2) {
    return Function.toString.call(r2).indexOf("[native code]") !== -1;
  }
  function S6(r2) {
    var t2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
    return S6 = function(n2) {
      if (n2 === null || !PTe(n2))
        return n2;
      if (typeof n2 != "function")
        throw new TypeError("Super expression must either be null or a function");
      if (typeof t2 != "undefined") {
        if (t2.has(n2))
          return t2.get(n2);
        t2.set(n2, a);
      }
      function a() {
        return z5(n2, arguments, w6(this).constructor);
      }
      return a.prototype = Object.create(n2.prototype, { constructor: { value: a, enumerable: false, writable: true, configurable: true } }), AE(a, n2);
    }, S6(r2);
  }
  var DTe = /%[sdj%]/g, ITe = function() {
  };
  typeof process != "undefined" && process.env;
  function C6(r2) {
    if (!r2 || !r2.length)
      return null;
    var t2 = {};
    return r2.forEach(function(e2) {
      var n2 = e2.field;
      t2[n2] = t2[n2] || [], t2[n2].push(e2);
    }), t2;
  }
  function Zf(r2) {
    for (var t2 = arguments.length, e2 = new Array(t2 > 1 ? t2 - 1 : 0), n2 = 1; n2 < t2; n2++)
      e2[n2 - 1] = arguments[n2];
    var a = 0, i = e2.length;
    if (typeof r2 == "function")
      return r2.apply(null, e2);
    if (typeof r2 == "string") {
      var o = r2.replace(DTe, function(s) {
        if (s === "%%")
          return "%";
        if (a >= i)
          return s;
        switch (s) {
          case "%s":
            return String(e2[a++]);
          case "%d":
            return Number(e2[a++]);
          case "%j":
            try {
              return JSON.stringify(e2[a++]);
            } catch {
              return "[Circular]";
            }
            break;
          default:
            return s;
        }
      });
      return o;
    }
    return r2;
  }
  function LTe(r2) {
    return r2 === "string" || r2 === "url" || r2 === "hex" || r2 === "email" || r2 === "date" || r2 === "pattern";
  }
  function qu(r2, t2) {
    return !!(r2 == null || t2 === "array" && Array.isArray(r2) && !r2.length || LTe(t2) && typeof r2 == "string" && !r2);
  }
  function OTe(r2, t2, e2) {
    var n2 = [], a = 0, i = r2.length;
    function o(s) {
      n2.push.apply(n2, s || []), a++, a === i && e2(n2);
    }
    r2.forEach(function(s) {
      t2(s, o);
    });
  }
  function kG(r2, t2, e2) {
    var n2 = 0, a = r2.length;
    function i(o) {
      if (o && o.length) {
        e2(o);
        return;
      }
      var s = n2;
      n2 = n2 + 1, s < a ? t2(r2[s], i) : e2([]);
    }
    i([]);
  }
  function kTe(r2) {
    var t2 = [];
    return Object.keys(r2).forEach(function(e2) {
      t2.push.apply(t2, r2[e2] || []);
    }), t2;
  }
  var RG = function(r2) {
    TTe(t2, r2);
    function t2(e2, n2) {
      var a;
      return a = r2.call(this, "Async Validation Error") || this, a.errors = e2, a.fields = n2, a;
    }
    return t2;
  }(S6(Error));
  function RTe(r2, t2, e2, n2, a) {
    if (t2.first) {
      var i = new Promise(function(h, v9) {
        var d2 = function(_) {
          return n2(_), _.length ? v9(new RG(_, C6(_))) : h(a);
        }, m2 = kTe(r2);
        kG(m2, e2, d2);
      });
      return i.catch(function(h) {
        return h;
      }), i;
    }
    var o = t2.firstFields === true ? Object.keys(r2) : t2.firstFields || [], s = Object.keys(r2), u = s.length, l2 = 0, c2 = [], f2 = new Promise(function(h, v9) {
      var d2 = function(b2) {
        if (c2.push.apply(c2, b2), l2++, l2 === u)
          return n2(c2), c2.length ? v9(new RG(c2, C6(c2))) : h(a);
      };
      s.length || (n2(c2), h(a)), s.forEach(function(m2) {
        var b2 = r2[m2];
        o.indexOf(m2) !== -1 ? kG(b2, e2, d2) : OTe(b2, e2, d2);
      });
    });
    return f2.catch(function(h) {
      return h;
    }), f2;
  }
  function FTe(r2) {
    return !!(r2 && r2.message !== void 0);
  }
  function NTe(r2, t2) {
    for (var e2 = r2, n2 = 0; n2 < t2.length; n2++) {
      if (e2 == null)
        return e2;
      e2 = e2[t2[n2]];
    }
    return e2;
  }
  function FG(r2, t2) {
    return function(e2) {
      var n2;
      return r2.fullFields ? n2 = NTe(t2, r2.fullFields) : n2 = t2[e2.field || r2.fullField], FTe(e2) ? (e2.field = e2.field || r2.fullField, e2.fieldValue = n2, e2) : { message: typeof e2 == "function" ? e2() : e2, fieldValue: n2, field: e2.field || r2.fullField };
    };
  }
  function NG(r2, t2) {
    if (t2) {
      for (var e2 in t2)
        if (t2.hasOwnProperty(e2)) {
          var n2 = t2[e2];
          typeof n2 == "object" && typeof r2[e2] == "object" ? r2[e2] = Gb({}, r2[e2], n2) : r2[e2] = n2;
        }
    }
    return r2;
  }
  var SX = function(t2, e2, n2, a, i, o) {
    t2.required && (!n2.hasOwnProperty(t2.field) || qu(e2, o || t2.type)) && a.push(Zf(i.messages.required, t2.fullField));
  }, VTe = function(t2, e2, n2, a, i) {
    (/^\s+$/.test(e2) || e2 === "") && a.push(Zf(i.messages.whitespace, t2.fullField));
  }, CR = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, DC = { integer: function(t2) {
    return DC.number(t2) && parseInt(t2, 10) === t2;
  }, float: function(t2) {
    return DC.number(t2) && !DC.integer(t2);
  }, array: function(t2) {
    return Array.isArray(t2);
  }, regexp: function(t2) {
    if (t2 instanceof RegExp)
      return true;
    try {
      return !!new RegExp(t2);
    } catch {
      return false;
    }
  }, date: function(t2) {
    return typeof t2.getTime == "function" && typeof t2.getMonth == "function" && typeof t2.getYear == "function" && !isNaN(t2.getTime());
  }, number: function(t2) {
    return isNaN(t2) ? false : typeof t2 == "number";
  }, object: function(t2) {
    return typeof t2 == "object" && !DC.array(t2);
  }, method: function(t2) {
    return typeof t2 == "function";
  }, email: function(t2) {
    return typeof t2 == "string" && t2.length <= 320 && !!t2.match(CR.email);
  }, url: function(t2) {
    return typeof t2 == "string" && t2.length <= 2048 && !!t2.match(CR.url);
  }, hex: function(t2) {
    return typeof t2 == "string" && !!t2.match(CR.hex);
  } }, jTe = function(t2, e2, n2, a, i) {
    if (t2.required && e2 === void 0) {
      SX(t2, e2, n2, a, i);
      return;
    }
    var o = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], s = t2.type;
    o.indexOf(s) > -1 ? DC[s](e2) || a.push(Zf(i.messages.types[s], t2.fullField, t2.type)) : s && typeof e2 !== t2.type && a.push(Zf(i.messages.types[s], t2.fullField, t2.type));
  }, BTe = function(t2, e2, n2, a, i) {
    var o = typeof t2.len == "number", s = typeof t2.min == "number", u = typeof t2.max == "number", l2 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, c2 = e2, f2 = null, h = typeof e2 == "number", v9 = typeof e2 == "string", d2 = Array.isArray(e2);
    if (h ? f2 = "number" : v9 ? f2 = "string" : d2 && (f2 = "array"), !f2)
      return false;
    d2 && (c2 = e2.length), v9 && (c2 = e2.replace(l2, "_").length), o ? c2 !== t2.len && a.push(Zf(i.messages[f2].len, t2.fullField, t2.len)) : s && !u && c2 < t2.min ? a.push(Zf(i.messages[f2].min, t2.fullField, t2.min)) : u && !s && c2 > t2.max ? a.push(Zf(i.messages[f2].max, t2.fullField, t2.max)) : s && u && (c2 < t2.min || c2 > t2.max) && a.push(Zf(i.messages[f2].range, t2.fullField, t2.min, t2.max));
  }, Ox = "enum", zTe = function(t2, e2, n2, a, i) {
    t2[Ox] = Array.isArray(t2[Ox]) ? t2[Ox] : [], t2[Ox].indexOf(e2) === -1 && a.push(Zf(i.messages[Ox], t2.fullField, t2[Ox].join(", ")));
  }, $Te = function(t2, e2, n2, a, i) {
    if (t2.pattern) {
      if (t2.pattern instanceof RegExp)
        t2.pattern.lastIndex = 0, t2.pattern.test(e2) || a.push(Zf(i.messages.pattern.mismatch, t2.fullField, e2, t2.pattern));
      else if (typeof t2.pattern == "string") {
        var o = new RegExp(t2.pattern);
        o.test(e2) || a.push(Zf(i.messages.pattern.mismatch, t2.fullField, e2, t2.pattern));
      }
    }
  }, Oi = { required: SX, whitespace: VTe, type: jTe, range: BTe, enum: zTe, pattern: $Te }, GTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2, "string") && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i, "string"), qu(e2, "string") || (Oi.type(t2, e2, a, o, i), Oi.range(t2, e2, a, o, i), Oi.pattern(t2, e2, a, o, i), t2.whitespace === true && Oi.whitespace(t2, e2, a, o, i));
    }
    n2(o);
  }, WTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && Oi.type(t2, e2, a, o, i);
    }
    n2(o);
  }, UTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (e2 === "" && (e2 = void 0), qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && (Oi.type(t2, e2, a, o, i), Oi.range(t2, e2, a, o, i));
    }
    n2(o);
  }, HTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && Oi.type(t2, e2, a, o, i);
    }
    n2(o);
  }, qTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), qu(e2) || Oi.type(t2, e2, a, o, i);
    }
    n2(o);
  }, YTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && (Oi.type(t2, e2, a, o, i), Oi.range(t2, e2, a, o, i));
    }
    n2(o);
  }, KTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && (Oi.type(t2, e2, a, o, i), Oi.range(t2, e2, a, o, i));
    }
    n2(o);
  }, ZTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (e2 == null && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i, "array"), e2 != null && (Oi.type(t2, e2, a, o, i), Oi.range(t2, e2, a, o, i));
    }
    n2(o);
  }, XTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && Oi.type(t2, e2, a, o, i);
    }
    n2(o);
  }, JTe = "enum", QTe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), e2 !== void 0 && Oi[JTe](t2, e2, a, o, i);
    }
    n2(o);
  }, eMe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2, "string") && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i), qu(e2, "string") || Oi.pattern(t2, e2, a, o, i);
    }
    n2(o);
  }, tMe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2, "date") && !t2.required)
        return n2();
      if (Oi.required(t2, e2, a, o, i), !qu(e2, "date")) {
        var u;
        e2 instanceof Date ? u = e2 : u = new Date(e2), Oi.type(t2, u, a, o, i), u && Oi.range(t2, u.getTime(), a, o, i);
      }
    }
    n2(o);
  }, rMe = function(t2, e2, n2, a, i) {
    var o = [], s = Array.isArray(e2) ? "array" : typeof e2;
    Oi.required(t2, e2, a, o, i, s), n2(o);
  }, ER = function(t2, e2, n2, a, i) {
    var o = t2.type, s = [], u = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (u) {
      if (qu(e2, o) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, s, i, o), qu(e2, o) || Oi.type(t2, e2, a, s, i);
    }
    n2(s);
  }, nMe = function(t2, e2, n2, a, i) {
    var o = [], s = t2.required || !t2.required && a.hasOwnProperty(t2.field);
    if (s) {
      if (qu(e2) && !t2.required)
        return n2();
      Oi.required(t2, e2, a, o, i);
    }
    n2(o);
  }, YC = { string: GTe, method: WTe, number: UTe, boolean: HTe, regexp: qTe, integer: YTe, float: KTe, array: ZTe, object: XTe, enum: QTe, pattern: eMe, date: tMe, url: ER, hex: ER, email: ER, required: rMe, any: nMe };
  function E6() {
    return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
      var t2 = JSON.parse(JSON.stringify(this));
      return t2.clone = this.clone, t2;
    } };
  }
  var A6 = E6(), JE = function() {
    function r2(e2) {
      this.rules = null, this._messages = A6, this.define(e2);
    }
    var t2 = r2.prototype;
    return t2.define = function(n2) {
      var a = this;
      if (!n2)
        throw new Error("Cannot configure a schema with no rules");
      if (typeof n2 != "object" || Array.isArray(n2))
        throw new Error("Rules must be an object");
      this.rules = {}, Object.keys(n2).forEach(function(i) {
        var o = n2[i];
        a.rules[i] = Array.isArray(o) ? o : [o];
      });
    }, t2.messages = function(n2) {
      return n2 && (this._messages = NG(E6(), n2)), this._messages;
    }, t2.validate = function(n2, a, i) {
      var o = this;
      a === void 0 && (a = {}), i === void 0 && (i = function() {
      });
      var s = n2, u = a, l2 = i;
      if (typeof u == "function" && (l2 = u, u = {}), !this.rules || Object.keys(this.rules).length === 0)
        return l2 && l2(null, s), Promise.resolve(s);
      function c2(m2) {
        var b2 = [], _ = {};
        function C(E) {
          if (Array.isArray(E)) {
            var z9;
            b2 = (z9 = b2).concat.apply(z9, E);
          } else
            b2.push(E);
        }
        for (var M = 0; M < m2.length; M++)
          C(m2[M]);
        b2.length ? (_ = C6(b2), l2(b2, _)) : l2(null, s);
      }
      if (u.messages) {
        var f2 = this.messages();
        f2 === A6 && (f2 = E6()), NG(f2, u.messages), u.messages = f2;
      } else
        u.messages = this.messages();
      var h = {}, v9 = u.keys || Object.keys(this.rules);
      v9.forEach(function(m2) {
        var b2 = o.rules[m2], _ = s[m2];
        b2.forEach(function(C) {
          var M = C;
          typeof M.transform == "function" && (s === n2 && (s = Gb({}, s)), _ = s[m2] = M.transform(_)), typeof M == "function" ? M = { validator: M } : M = Gb({}, M), M.validator = o.getValidationMethod(M), M.validator && (M.field = m2, M.fullField = M.fullField || m2, M.type = o.getType(M), h[m2] = h[m2] || [], h[m2].push({ rule: M, value: _, source: s, field: m2 }));
        });
      });
      var d2 = {};
      return RTe(h, u, function(m2, b2) {
        var _ = m2.rule, C = (_.type === "object" || _.type === "array") && (typeof _.fields == "object" || typeof _.defaultField == "object");
        C = C && (_.required || !_.required && m2.value), _.field = m2.field;
        function M(V, $) {
          return Gb({}, $, { fullField: _.fullField + "." + V, fullFields: _.fullFields ? [].concat(_.fullFields, [V]) : [V] });
        }
        function E(V) {
          V === void 0 && (V = []);
          var $ = Array.isArray(V) ? V : [V];
          !u.suppressWarning && $.length && r2.warning("async-validator:", $), $.length && _.message !== void 0 && ($ = [].concat(_.message));
          var U = $.map(FG(_, s));
          if (u.first && U.length)
            return d2[_.field] = 1, b2(U);
          if (!C)
            b2(U);
          else {
            if (_.required && !m2.value)
              return _.message !== void 0 ? U = [].concat(_.message).map(FG(_, s)) : u.error && (U = [u.error(_, Zf(u.messages.required, _.field))]), b2(U);
            var H = {};
            _.defaultField && Object.keys(m2.value).map(function(oe) {
              H[oe] = _.defaultField;
            }), H = Gb({}, H, m2.rule.fields);
            var q3 = {};
            Object.keys(H).forEach(function(oe) {
              var ne = H[oe], be = Array.isArray(ne) ? ne : [ne];
              q3[oe] = be.map(M.bind(null, oe));
            });
            var ee = new r2(q3);
            ee.messages(u.messages), m2.rule.options && (m2.rule.options.messages = u.messages, m2.rule.options.error = u.error), ee.validate(m2.value, m2.rule.options || u, function(oe) {
              var ne = [];
              U && U.length && ne.push.apply(ne, U), oe && oe.length && ne.push.apply(ne, oe), b2(ne.length ? ne : null);
            });
          }
        }
        var z9;
        _.asyncValidator ? z9 = _.asyncValidator(_, m2.value, E, m2.source, u) : _.validator && (z9 = _.validator(_, m2.value, E, m2.source, u), z9 === true ? E() : z9 === false ? E(typeof _.message == "function" ? _.message(_.fullField || _.field) : _.message || (_.fullField || _.field) + " fails") : z9 instanceof Array ? E(z9) : z9 instanceof Error && E(z9.message)), z9 && z9.then && z9.then(function() {
          return E();
        }, function(V) {
          return E(V);
        });
      }, function(m2) {
        c2(m2);
      }, s);
    }, t2.getType = function(n2) {
      if (n2.type === void 0 && n2.pattern instanceof RegExp && (n2.type = "pattern"), typeof n2.validator != "function" && n2.type && !YC.hasOwnProperty(n2.type))
        throw new Error(Zf("Unknown rule type %s", n2.type));
      return n2.type || "string";
    }, t2.getValidationMethod = function(n2) {
      if (typeof n2.validator == "function")
        return n2.validator;
      var a = Object.keys(n2), i = a.indexOf("message");
      return i !== -1 && a.splice(i, 1), a.length === 1 && a[0] === "required" ? YC.required : YC[this.getType(n2)] || void 0;
    }, r2;
  }();
  JE.register = function(t2, e2) {
    if (typeof e2 != "function")
      throw new Error("Cannot register a validator by type, validator is not a function");
    YC[t2] = e2;
  };
  JE.warning = ITe;
  JE.messages = A6;
  JE.validators = YC;
  var Uf = "'${name}' is not a valid ${type}", CX = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: Uf, method: Uf, array: Uf, object: Uf, number: Uf, date: Uf, boolean: Uf, integer: Uf, float: Uf, regexp: Uf, email: Uf, url: Uf, hex: Uf }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
  function EX(r2, t2) {
    for (var e2 = r2, n2 = 0; n2 < t2.length; n2 += 1) {
      if (e2 == null)
        return;
      e2 = e2[t2[n2]];
    }
    return e2;
  }
  function aMe(r2) {
    return uX(r2) || xX(r2) || jN(r2) || lX();
  }
  function AX(r2, t2, e2, n2) {
    if (!t2.length)
      return e2;
    var a = aMe(t2), i = a[0], o = a.slice(1), s;
    return !r2 && typeof i == "number" ? s = [] : Array.isArray(r2) ? s = Vi(r2) : s = Ra({}, r2), n2 && e2 === void 0 && o.length === 1 ? delete s[i][o[0]] : s[i] = AX(s[i], o, e2, n2), s;
  }
  function iMe(r2, t2, e2) {
    var n2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return t2.length && n2 && e2 === void 0 && !EX(r2, t2.slice(0, -1)) ? r2 : AX(r2, t2, e2, n2);
  }
  function wu(r2) {
    return x6(r2);
  }
  function qx(r2, t2) {
    var e2 = EX(r2, t2);
    return e2;
  }
  function Ob(r2, t2, e2) {
    var n2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, a = iMe(r2, t2, e2, n2);
    return a;
  }
  function VG(r2, t2) {
    var e2 = {};
    return t2.forEach(function(n2) {
      var a = qx(r2, n2);
      e2 = Ob(e2, n2, a);
    }), e2;
  }
  function KC(r2, t2) {
    return r2 && r2.some(function(e2) {
      return MX(e2, t2);
    });
  }
  function jG(r2) {
    return sc(r2) === "object" && r2 !== null && Object.getPrototypeOf(r2) === Object.prototype;
  }
  function TX(r2, t2) {
    var e2 = Array.isArray(r2) ? Vi(r2) : Ra({}, r2);
    return t2 && Object.keys(t2).forEach(function(n2) {
      var a = e2[n2], i = t2[n2], o = jG(a) && jG(i);
      e2[n2] = o ? TX(a, i || {}) : i;
    }), e2;
  }
  function $5(r2) {
    for (var t2 = arguments.length, e2 = new Array(t2 > 1 ? t2 - 1 : 0), n2 = 1; n2 < t2; n2++)
      e2[n2 - 1] = arguments[n2];
    return e2.reduce(function(a, i) {
      return TX(a, i);
    }, r2);
  }
  function MX(r2, t2) {
    return !r2 || !t2 || r2.length !== t2.length ? false : r2.every(function(e2, n2) {
      return t2[n2] === e2;
    });
  }
  function oMe(r2, t2) {
    if (r2 === t2)
      return true;
    if (!r2 && t2 || r2 && !t2 || !r2 || !t2 || sc(r2) !== "object" || sc(t2) !== "object")
      return false;
    var e2 = Object.keys(r2), n2 = Object.keys(t2), a = new Set([].concat(Vi(e2), Vi(n2)));
    return Vi(a).every(function(i) {
      var o = r2[i], s = t2[i];
      return typeof o == "function" && typeof s == "function" ? true : o === s;
    });
  }
  function sMe(r2) {
    var t2 = arguments.length <= 1 ? void 0 : arguments[1];
    return t2 && t2.target && sc(t2.target) === "object" && r2 in t2.target ? t2.target[r2] : t2;
  }
  function BG(r2, t2, e2) {
    var n2 = r2.length;
    if (t2 < 0 || t2 >= n2 || e2 < 0 || e2 >= n2)
      return r2;
    var a = r2[t2], i = t2 - e2;
    return i > 0 ? [].concat(Vi(r2.slice(0, e2)), [a], Vi(r2.slice(e2, t2)), Vi(r2.slice(t2 + 1, n2))) : i < 0 ? [].concat(Vi(r2.slice(0, t2)), Vi(r2.slice(t2 + 1, e2 + 1)), [a], Vi(r2.slice(e2 + 1, n2))) : r2;
  }
  var uMe = JE;
  function lMe(r2, t2) {
    return r2.replace(/\$\{\w+\}/g, function(e2) {
      var n2 = e2.slice(2, -1);
      return t2[n2];
    });
  }
  function T6(r2, t2, e2, n2, a) {
    return M6.apply(this, arguments);
  }
  function M6() {
    return M6 = z3(Ey.mark(function r2(t2, e2, n2, a, i) {
      var o, s, u, l2, c2, f2, h, v9;
      return Ey.wrap(function(m2) {
        for (; ; )
          switch (m2.prev = m2.next) {
            case 0:
              return o = Ra({}, n2), delete o.ruleIndex, s = null, o && o.type === "array" && o.defaultField && (s = o.defaultField, delete o.defaultField), u = new uMe(go({}, t2, [o])), l2 = $5({}, CX, a.validateMessages), u.messages(l2), c2 = [], m2.prev = 8, m2.next = 11, Promise.resolve(u.validate(go({}, t2, e2), Ra({}, a)));
            case 11:
              m2.next = 16;
              break;
            case 13:
              m2.prev = 13, m2.t0 = m2.catch(8), m2.t0.errors ? c2 = m2.t0.errors.map(function(b2, _) {
                var C = b2.message;
                return Lr.isValidElement(C) ? Lr.cloneElement(C, { key: "error_".concat(_) }) : C;
              }) : (console.error(m2.t0), c2 = [l2.default]);
            case 16:
              if (!(!c2.length && s)) {
                m2.next = 21;
                break;
              }
              return m2.next = 19, Promise.all(e2.map(function(b2, _) {
                return T6("".concat(t2, ".").concat(_), b2, s, a, i);
              }));
            case 19:
              return f2 = m2.sent, m2.abrupt("return", f2.reduce(function(b2, _) {
                return [].concat(Vi(b2), Vi(_));
              }, []));
            case 21:
              return h = Ra(Ra({}, n2), {}, { name: t2, enum: (n2.enum || []).join(", ") }, i), v9 = c2.map(function(b2) {
                return typeof b2 == "string" ? lMe(b2, h) : b2;
              }), m2.abrupt("return", v9);
            case 24:
            case "end":
              return m2.stop();
          }
      }, r2, null, [[8, 13]]);
    })), M6.apply(this, arguments);
  }
  function cMe(r2, t2, e2, n2, a, i) {
    var o = r2.join("."), s = e2.map(function(c2, f2) {
      var h = c2.validator, v9 = Ra(Ra({}, c2), {}, { ruleIndex: f2 });
      return h && (v9.validator = function(d2, m2, b2) {
        var _ = false, C = function() {
          for (var z9 = arguments.length, V = new Array(z9), $ = 0; $ < z9; $++)
            V[$] = arguments[$];
          Promise.resolve().then(function() {
            Jd(!_, "Your validator function has already return a promise. `callback` will be ignored."), _ || b2.apply(void 0, V);
          });
        }, M = h(d2, m2, C);
        _ = M && typeof M.then == "function" && typeof M.catch == "function", Jd(_, "`callback` is deprecated. Please return a promise instead."), _ && M.then(function() {
          b2();
        }).catch(function(E) {
          b2(E || " ");
        });
      }), v9;
    }).sort(function(c2, f2) {
      var h = c2.warningOnly, v9 = c2.ruleIndex, d2 = f2.warningOnly, m2 = f2.ruleIndex;
      return !!h == !!d2 ? v9 - m2 : h ? 1 : -1;
    }), u;
    if (a === true)
      u = new Promise(function() {
        var c2 = z3(Ey.mark(function f2(h, v9) {
          var d2, m2, b2;
          return Ey.wrap(function(C) {
            for (; ; )
              switch (C.prev = C.next) {
                case 0:
                  d2 = 0;
                case 1:
                  if (!(d2 < s.length)) {
                    C.next = 12;
                    break;
                  }
                  return m2 = s[d2], C.next = 5, T6(o, t2, m2, n2, i);
                case 5:
                  if (b2 = C.sent, !b2.length) {
                    C.next = 9;
                    break;
                  }
                  return v9([{ errors: b2, rule: m2 }]), C.abrupt("return");
                case 9:
                  d2 += 1, C.next = 1;
                  break;
                case 12:
                  h([]);
                case 13:
                case "end":
                  return C.stop();
              }
          }, f2);
        }));
        return function(f2, h) {
          return c2.apply(this, arguments);
        };
      }());
    else {
      var l2 = s.map(function(c2) {
        return T6(o, t2, c2, n2, i).then(function(f2) {
          return { errors: f2, rule: c2 };
        });
      });
      u = (a ? hMe(l2) : fMe(l2)).then(function(c2) {
        return Promise.reject(c2);
      });
    }
    return u.catch(function(c2) {
      return c2;
    }), u;
  }
  function fMe(r2) {
    return P6.apply(this, arguments);
  }
  function P6() {
    return P6 = z3(Ey.mark(function r2(t2) {
      return Ey.wrap(function(n2) {
        for (; ; )
          switch (n2.prev = n2.next) {
            case 0:
              return n2.abrupt("return", Promise.all(t2).then(function(a) {
                var i, o = (i = []).concat.apply(i, Vi(a));
                return o;
              }));
            case 1:
            case "end":
              return n2.stop();
          }
      }, r2);
    })), P6.apply(this, arguments);
  }
  function hMe(r2) {
    return D6.apply(this, arguments);
  }
  function D6() {
    return D6 = z3(Ey.mark(function r2(t2) {
      var e2;
      return Ey.wrap(function(a) {
        for (; ; )
          switch (a.prev = a.next) {
            case 0:
              return e2 = 0, a.abrupt("return", new Promise(function(i) {
                t2.forEach(function(o) {
                  o.then(function(s) {
                    s.errors.length && i([s]), e2 += 1, e2 === t2.length && i([]);
                  });
                });
              }));
            case 2:
            case "end":
              return a.stop();
          }
      }, r2);
    })), D6.apply(this, arguments);
  }
  var vMe = ["name"], Ih = [];
  function zG(r2, t2, e2, n2, a, i) {
    return typeof r2 == "function" ? r2(t2, e2, "source" in i ? { source: i.source } : {}) : n2 !== a;
  }
  var KN = function(r2) {
    $N(e2, r2);
    var t2 = WN(e2);
    function e2(n2) {
      var a;
      if (ZE(this, e2), a = t2.call(this, n2), a.state = { resetCount: 0 }, a.cancelRegisterFunc = null, a.mounted = false, a.touched = false, a.dirty = false, a.validatePromise = null, a.prevValidating = void 0, a.errors = Ih, a.warnings = Ih, a.cancelRegister = function() {
        var u = a.props, l2 = u.preserve, c2 = u.isListField, f2 = u.name;
        a.cancelRegisterFunc && a.cancelRegisterFunc(c2, l2, wu(f2)), a.cancelRegisterFunc = null;
      }, a.getNamePath = function() {
        var u = a.props, l2 = u.name, c2 = u.fieldContext, f2 = c2.prefixName, h = f2 === void 0 ? [] : f2;
        return l2 !== void 0 ? [].concat(Vi(h), Vi(l2)) : [];
      }, a.getRules = function() {
        var u = a.props, l2 = u.rules, c2 = l2 === void 0 ? [] : l2, f2 = u.fieldContext;
        return c2.map(function(h) {
          return typeof h == "function" ? h(f2) : h;
        });
      }, a.refresh = function() {
        !a.mounted || a.setState(function(u) {
          var l2 = u.resetCount;
          return { resetCount: l2 + 1 };
        });
      }, a.triggerMetaEvent = function(u) {
        var l2 = a.props.onMetaChange;
        l2 == null || l2(Ra(Ra({}, a.getMeta()), {}, { destroy: u }));
      }, a.onStoreChange = function(u, l2, c2) {
        var f2 = a.props, h = f2.shouldUpdate, v9 = f2.dependencies, d2 = v9 === void 0 ? [] : v9, m2 = f2.onReset, b2 = c2.store, _ = a.getNamePath(), C = a.getValue(u), M = a.getValue(b2), E = l2 && KC(l2, _);
        switch (c2.type === "valueUpdate" && c2.source === "external" && C !== M && (a.touched = true, a.dirty = true, a.validatePromise = null, a.errors = Ih, a.warnings = Ih, a.triggerMetaEvent()), c2.type) {
          case "reset":
            if (!l2 || E) {
              a.touched = false, a.dirty = false, a.validatePromise = null, a.errors = Ih, a.warnings = Ih, a.triggerMetaEvent(), m2 == null || m2(), a.refresh();
              return;
            }
            break;
          case "remove": {
            if (h) {
              a.reRender();
              return;
            }
            break;
          }
          case "setField": {
            if (E) {
              var z9 = c2.data;
              "touched" in z9 && (a.touched = z9.touched), "validating" in z9 && !("originRCField" in z9) && (a.validatePromise = z9.validating ? Promise.resolve([]) : null), "errors" in z9 && (a.errors = z9.errors || Ih), "warnings" in z9 && (a.warnings = z9.warnings || Ih), a.dirty = true, a.triggerMetaEvent(), a.reRender();
              return;
            }
            if (h && !_.length && zG(h, u, b2, C, M, c2)) {
              a.reRender();
              return;
            }
            break;
          }
          case "dependenciesUpdate": {
            var V = d2.map(wu);
            if (V.some(function($) {
              return KC(c2.relatedFields, $);
            })) {
              a.reRender();
              return;
            }
            break;
          }
          default:
            if (E || (!d2.length || _.length || h) && zG(h, u, b2, C, M, c2)) {
              a.reRender();
              return;
            }
            break;
        }
        h === true && a.reRender();
      }, a.validateRules = function(u) {
        var l2 = a.getNamePath(), c2 = a.getValue(), f2 = Promise.resolve().then(function() {
          if (!a.mounted)
            return [];
          var h = a.props, v9 = h.validateFirst, d2 = v9 === void 0 ? false : v9, m2 = h.messageVariables, b2 = u || {}, _ = b2.triggerName, C = a.getRules();
          _ && (C = C.filter(function(E) {
            var z9 = E.validateTrigger;
            if (!z9)
              return true;
            var V = x6(z9);
            return V.includes(_);
          }));
          var M = cMe(l2, c2, C, u, d2, m2);
          return M.catch(function(E) {
            return E;
          }).then(function() {
            var E = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Ih;
            if (a.validatePromise === f2) {
              a.validatePromise = null;
              var z9 = [], V = [];
              E.forEach(function($) {
                var U = $.rule.warningOnly, H = $.errors, q3 = H === void 0 ? Ih : H;
                U ? V.push.apply(V, Vi(q3)) : z9.push.apply(z9, Vi(q3));
              }), a.errors = z9, a.warnings = V, a.triggerMetaEvent(), a.reRender();
            }
          }), M;
        });
        return a.validatePromise = f2, a.dirty = true, a.errors = Ih, a.warnings = Ih, a.triggerMetaEvent(), a.reRender(), f2;
      }, a.isFieldValidating = function() {
        return !!a.validatePromise;
      }, a.isFieldTouched = function() {
        return a.touched;
      }, a.isFieldDirty = function() {
        if (a.dirty || a.props.initialValue !== void 0)
          return true;
        var u = a.props.fieldContext, l2 = u.getInternalHooks(Hx), c2 = l2.getInitialValue;
        return c2(a.getNamePath()) !== void 0;
      }, a.getErrors = function() {
        return a.errors;
      }, a.getWarnings = function() {
        return a.warnings;
      }, a.isListField = function() {
        return a.props.isListField;
      }, a.isList = function() {
        return a.props.isList;
      }, a.isPreserve = function() {
        return a.props.preserve;
      }, a.getMeta = function() {
        a.prevValidating = a.isFieldValidating();
        var u = { touched: a.isFieldTouched(), validating: a.prevValidating, errors: a.errors, warnings: a.warnings, name: a.getNamePath() };
        return u;
      }, a.getOnlyChild = function(u) {
        if (typeof u == "function") {
          var l2 = a.getMeta();
          return Ra(Ra({}, a.getOnlyChild(u(a.getControlled(), l2, a.props.fieldContext))), {}, { isFunction: true });
        }
        var c2 = _6(u);
        return c2.length !== 1 || !Lr.isValidElement(c2[0]) ? { child: c2, isFunction: false } : { child: c2[0], isFunction: false };
      }, a.getValue = function(u) {
        var l2 = a.props.fieldContext.getFieldsValue, c2 = a.getNamePath();
        return qx(u || l2(true), c2);
      }, a.getControlled = function() {
        var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, l2 = a.props, c2 = l2.trigger, f2 = l2.validateTrigger, h = l2.getValueFromEvent, v9 = l2.normalize, d2 = l2.valuePropName, m2 = l2.getValueProps, b2 = l2.fieldContext, _ = f2 !== void 0 ? f2 : b2.validateTrigger, C = a.getNamePath(), M = b2.getInternalHooks, E = b2.getFieldsValue, z9 = M(Hx), V = z9.dispatch, $ = a.getValue(), U = m2 || function(oe) {
          return go({}, d2, oe);
        }, H = u[c2], q3 = Ra(Ra({}, u), U($));
        q3[c2] = function() {
          a.touched = true, a.dirty = true, a.triggerMetaEvent();
          for (var oe, ne = arguments.length, be = new Array(ne), Ee = 0; Ee < ne; Ee++)
            be[Ee] = arguments[Ee];
          h ? oe = h.apply(void 0, be) : oe = sMe.apply(void 0, [d2].concat(be)), v9 && (oe = v9(oe, $, E(true))), V({ type: "updateValue", namePath: C, value: oe }), H && H.apply(void 0, be);
        };
        var ee = x6(_ || []);
        return ee.forEach(function(oe) {
          var ne = q3[oe];
          q3[oe] = function() {
            ne && ne.apply(void 0, arguments);
            var be = a.props.rules;
            be && be.length && V({ type: "validateField", namePath: C, triggerName: oe });
          };
        }), q3;
      }, n2.fieldContext) {
        var i = n2.fieldContext.getInternalHooks, o = i(Hx), s = o.initEntityValue;
        s(GN(a));
      }
      return a;
    }
    return XE(e2, [{ key: "componentDidMount", value: function() {
      var a = this.props, i = a.shouldUpdate, o = a.fieldContext;
      if (this.mounted = true, o) {
        var s = o.getInternalHooks, u = s(Hx), l2 = u.registerField;
        this.cancelRegisterFunc = l2(this);
      }
      i === true && this.reRender();
    } }, { key: "componentWillUnmount", value: function() {
      this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
    } }, { key: "reRender", value: function() {
      !this.mounted || this.forceUpdate();
    } }, { key: "render", value: function() {
      var a = this.state.resetCount, i = this.props.children, o = this.getOnlyChild(i), s = o.child, u = o.isFunction, l2;
      return u ? l2 = s : Lr.isValidElement(s) ? l2 = Lr.cloneElement(s, this.getControlled(s.props)) : (Jd(!s, "`children` of Field is not validate ReactElement."), l2 = s), Lr.createElement(Lr.Fragment, { key: a }, l2);
    } }]), e2;
  }(Lr.Component);
  KN.contextType = EE;
  KN.defaultProps = { trigger: "onChange", valuePropName: "value" };
  function PX(r2) {
    var t2 = r2.name, e2 = Aw(r2, vMe), n2 = Lr.useContext(EE), a = t2 !== void 0 ? wu(t2) : void 0, i = "keep";
    return e2.isListField || (i = "_".concat((a || []).join("_"))), Lr.createElement(KN, Su({ key: i, name: a }, e2, { fieldContext: n2 }));
  }
  var dMe = Lr.createContext(null), pMe = function(t2) {
    var e2 = t2.name, n2 = t2.initialValue, a = t2.children, i = t2.rules, o = t2.validateTrigger, s = Lr.useContext(EE), u = Lr.useRef({ keys: [], id: 0 }), l2 = u.current, c2 = Lr.useMemo(function() {
      var d2 = wu(s.prefixName) || [];
      return [].concat(Vi(d2), Vi(wu(e2)));
    }, [s.prefixName, e2]), f2 = Lr.useMemo(function() {
      return Ra(Ra({}, s), {}, { prefixName: c2 });
    }, [s, c2]), h = Lr.useMemo(function() {
      return { getKey: function(m2) {
        var b2 = c2.length, _ = m2[b2];
        return [l2.keys[_], m2.slice(b2 + 1)];
      } };
    }, [c2]);
    if (typeof a != "function")
      return Jd(false, "Form.List only accepts function as children."), null;
    var v9 = function(m2, b2, _) {
      var C = _.source;
      return C === "internal" ? false : m2 !== b2;
    };
    return Lr.createElement(dMe.Provider, { value: h }, Lr.createElement(EE.Provider, { value: f2 }, Lr.createElement(PX, { name: [], shouldUpdate: v9, rules: i, validateTrigger: o, initialValue: n2, isList: true }, function(d2, m2) {
      var b2 = d2.value, _ = b2 === void 0 ? [] : b2, C = d2.onChange, M = s.getFieldValue, E = function() {
        var U = M(c2 || []);
        return U || [];
      }, z9 = { add: function(U, H) {
        var q3 = E();
        H >= 0 && H <= q3.length ? (l2.keys = [].concat(Vi(l2.keys.slice(0, H)), [l2.id], Vi(l2.keys.slice(H))), C([].concat(Vi(q3.slice(0, H)), [U], Vi(q3.slice(H))))) : (l2.keys = [].concat(Vi(l2.keys), [l2.id]), C([].concat(Vi(q3), [U]))), l2.id += 1;
      }, remove: function(U) {
        var H = E(), q3 = new Set(Array.isArray(U) ? U : [U]);
        q3.size <= 0 || (l2.keys = l2.keys.filter(function(ee, oe) {
          return !q3.has(oe);
        }), C(H.filter(function(ee, oe) {
          return !q3.has(oe);
        })));
      }, move: function(U, H) {
        if (U !== H) {
          var q3 = E();
          U < 0 || U >= q3.length || H < 0 || H >= q3.length || (l2.keys = BG(l2.keys, U, H), C(BG(q3, U, H)));
        }
      } }, V = _ || [];
      return Array.isArray(V) || (V = []), a(V.map(function($, U) {
        var H = l2.keys[U];
        return H === void 0 && (l2.keys[U] = l2.id, H = l2.keys[U], l2.id += 1), { name: U, key: H, isListField: true };
      }), z9, m2);
    })));
  };
  function gMe(r2) {
    var t2 = false, e2 = r2.length, n2 = [];
    return r2.length ? new Promise(function(a, i) {
      r2.forEach(function(o, s) {
        o.catch(function(u) {
          return t2 = true, u;
        }).then(function(u) {
          e2 -= 1, n2[s] = u, !(e2 > 0) && (t2 && i(n2), a(n2));
        });
      });
    }) : Promise.resolve([]);
  }
  var DX = "__@field_split__";
  function AR(r2) {
    return r2.map(function(t2) {
      return "".concat(sc(t2), ":").concat(t2);
    }).join(DX);
  }
  var gC = function() {
    function r2() {
      ZE(this, r2), this.kvs = /* @__PURE__ */ new Map();
    }
    return XE(r2, [{ key: "set", value: function(e2, n2) {
      this.kvs.set(AR(e2), n2);
    } }, { key: "get", value: function(e2) {
      return this.kvs.get(AR(e2));
    } }, { key: "update", value: function(e2, n2) {
      var a = this.get(e2), i = n2(a);
      i ? this.set(e2, i) : this.delete(e2);
    } }, { key: "delete", value: function(e2) {
      this.kvs.delete(AR(e2));
    } }, { key: "map", value: function(e2) {
      return Vi(this.kvs.entries()).map(function(n2) {
        var a = Wh(n2, 2), i = a[0], o = a[1], s = i.split(DX);
        return e2({ key: s.map(function(u) {
          var l2 = u.match(/^([^:]*):(.*)$/), c2 = Wh(l2, 3), f2 = c2[1], h = c2[2];
          return f2 === "number" ? Number(h) : h;
        }), value: o });
      });
    } }, { key: "toJSON", value: function() {
      var e2 = {};
      return this.map(function(n2) {
        var a = n2.key, i = n2.value;
        return e2[a.join(".")] = i, null;
      }), e2;
    } }]), r2;
  }(), yMe = ["name", "errors"], mMe = XE(function r2(t2) {
    var e2 = this;
    ZE(this, r2), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
      return { getFieldValue: e2.getFieldValue, getFieldsValue: e2.getFieldsValue, getFieldError: e2.getFieldError, getFieldWarning: e2.getFieldWarning, getFieldsError: e2.getFieldsError, isFieldsTouched: e2.isFieldsTouched, isFieldTouched: e2.isFieldTouched, isFieldValidating: e2.isFieldValidating, isFieldsValidating: e2.isFieldsValidating, resetFields: e2.resetFields, setFields: e2.setFields, setFieldsValue: e2.setFieldsValue, validateFields: e2.validateFields, submit: e2.submit, getInternalHooks: e2.getInternalHooks };
    }, this.getInternalHooks = function(n2) {
      return n2 === Hx ? (e2.formHooked = true, { dispatch: e2.dispatch, initEntityValue: e2.initEntityValue, registerField: e2.registerField, useSubscribe: e2.useSubscribe, setInitialValues: e2.setInitialValues, setCallbacks: e2.setCallbacks, setValidateMessages: e2.setValidateMessages, getFields: e2.getFields, setPreserve: e2.setPreserve, getInitialValue: e2.getInitialValue }) : (Jd(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
    }, this.useSubscribe = function(n2) {
      e2.subscribable = n2;
    }, this.setInitialValues = function(n2, a) {
      e2.initialValues = n2 || {}, a && (e2.store = $5({}, n2, e2.store));
    }, this.getInitialValue = function(n2) {
      return qx(e2.initialValues, n2);
    }, this.setCallbacks = function(n2) {
      e2.callbacks = n2;
    }, this.setValidateMessages = function(n2) {
      e2.validateMessages = n2;
    }, this.setPreserve = function(n2) {
      e2.preserve = n2;
    }, this.timeoutId = null, this.warningUnhooked = function() {
    }, this.getFieldEntities = function() {
      var n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      return n2 ? e2.fieldEntities.filter(function(a) {
        return a.getNamePath().length;
      }) : e2.fieldEntities;
    }, this.getFieldsMap = function() {
      var n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, a = new gC();
      return e2.getFieldEntities(n2).forEach(function(i) {
        var o = i.getNamePath();
        a.set(o, i);
      }), a;
    }, this.getFieldEntitiesForNamePathList = function(n2) {
      if (!n2)
        return e2.getFieldEntities(true);
      var a = e2.getFieldsMap(true);
      return n2.map(function(i) {
        var o = wu(i);
        return a.get(o) || { INVALIDATE_NAME_PATH: wu(i) };
      });
    }, this.getFieldsValue = function(n2, a) {
      if (e2.warningUnhooked(), n2 === true && !a)
        return e2.store;
      var i = e2.getFieldEntitiesForNamePathList(Array.isArray(n2) ? n2 : null), o = [];
      return i.forEach(function(s) {
        var u, l2 = "INVALIDATE_NAME_PATH" in s ? s.INVALIDATE_NAME_PATH : s.getNamePath();
        if (!(!n2 && ((u = s.isListField) === null || u === void 0 ? void 0 : u.call(s))))
          if (!a)
            o.push(l2);
          else {
            var c2 = "getMeta" in s ? s.getMeta() : null;
            a(c2) && o.push(l2);
          }
      }), VG(e2.store, o.map(wu));
    }, this.getFieldValue = function(n2) {
      e2.warningUnhooked();
      var a = wu(n2);
      return qx(e2.store, a);
    }, this.getFieldsError = function(n2) {
      e2.warningUnhooked();
      var a = e2.getFieldEntitiesForNamePathList(n2);
      return a.map(function(i, o) {
        return i && !("INVALIDATE_NAME_PATH" in i) ? { name: i.getNamePath(), errors: i.getErrors(), warnings: i.getWarnings() } : { name: wu(n2[o]), errors: [], warnings: [] };
      });
    }, this.getFieldError = function(n2) {
      e2.warningUnhooked();
      var a = wu(n2), i = e2.getFieldsError([a])[0];
      return i.errors;
    }, this.getFieldWarning = function(n2) {
      e2.warningUnhooked();
      var a = wu(n2), i = e2.getFieldsError([a])[0];
      return i.warnings;
    }, this.isFieldsTouched = function() {
      e2.warningUnhooked();
      for (var n2 = arguments.length, a = new Array(n2), i = 0; i < n2; i++)
        a[i] = arguments[i];
      var o = a[0], s = a[1], u, l2 = false;
      a.length === 0 ? u = null : a.length === 1 ? Array.isArray(o) ? (u = o.map(wu), l2 = false) : (u = null, l2 = o) : (u = o.map(wu), l2 = s);
      var c2 = e2.getFieldEntities(true), f2 = function(b2) {
        return b2.isFieldTouched();
      };
      if (!u)
        return l2 ? c2.every(f2) : c2.some(f2);
      var h = new gC();
      u.forEach(function(m2) {
        h.set(m2, []);
      }), c2.forEach(function(m2) {
        var b2 = m2.getNamePath();
        u.forEach(function(_) {
          _.every(function(C, M) {
            return b2[M] === C;
          }) && h.update(_, function(C) {
            return [].concat(Vi(C), [m2]);
          });
        });
      });
      var v9 = function(b2) {
        return b2.some(f2);
      }, d2 = h.map(function(m2) {
        var b2 = m2.value;
        return b2;
      });
      return l2 ? d2.every(v9) : d2.some(v9);
    }, this.isFieldTouched = function(n2) {
      return e2.warningUnhooked(), e2.isFieldsTouched([n2]);
    }, this.isFieldsValidating = function(n2) {
      e2.warningUnhooked();
      var a = e2.getFieldEntities();
      if (!n2)
        return a.some(function(o) {
          return o.isFieldValidating();
        });
      var i = n2.map(wu);
      return a.some(function(o) {
        var s = o.getNamePath();
        return KC(i, s) && o.isFieldValidating();
      });
    }, this.isFieldValidating = function(n2) {
      return e2.warningUnhooked(), e2.isFieldsValidating([n2]);
    }, this.resetWithFieldInitialValue = function() {
      var n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, a = new gC(), i = e2.getFieldEntities(true);
      i.forEach(function(u) {
        var l2 = u.props.initialValue, c2 = u.getNamePath();
        if (l2 !== void 0) {
          var f2 = a.get(c2) || /* @__PURE__ */ new Set();
          f2.add({ entity: u, value: l2 }), a.set(c2, f2);
        }
      });
      var o = function(l2) {
        l2.forEach(function(c2) {
          var f2 = c2.props.initialValue;
          if (f2 !== void 0) {
            var h = c2.getNamePath(), v9 = e2.getInitialValue(h);
            if (v9 !== void 0)
              Jd(false, "Form already set 'initialValues' with path '".concat(h.join("."), "'. Field can not overwrite it."));
            else {
              var d2 = a.get(h);
              if (d2 && d2.size > 1)
                Jd(false, "Multiple Field with path '".concat(h.join("."), "' set 'initialValue'. Can not decide which one to pick."));
              else if (d2) {
                var m2 = e2.getFieldValue(h);
                (!n2.skipExist || m2 === void 0) && (e2.store = Ob(e2.store, h, Vi(d2)[0].value));
              }
            }
          }
        });
      }, s;
      n2.entities ? s = n2.entities : n2.namePathList ? (s = [], n2.namePathList.forEach(function(u) {
        var l2 = a.get(u);
        if (l2) {
          var c2;
          (c2 = s).push.apply(c2, Vi(Vi(l2).map(function(f2) {
            return f2.entity;
          })));
        }
      })) : s = i, o(s);
    }, this.resetFields = function(n2) {
      e2.warningUnhooked();
      var a = e2.store;
      if (!n2) {
        e2.store = $5({}, e2.initialValues), e2.resetWithFieldInitialValue(), e2.notifyObservers(a, null, { type: "reset" });
        return;
      }
      var i = n2.map(wu);
      i.forEach(function(o) {
        var s = e2.getInitialValue(o);
        e2.store = Ob(e2.store, o, s);
      }), e2.resetWithFieldInitialValue({ namePathList: i }), e2.notifyObservers(a, i, { type: "reset" });
    }, this.setFields = function(n2) {
      e2.warningUnhooked();
      var a = e2.store;
      n2.forEach(function(i) {
        var o = i.name;
        i.errors;
        var s = Aw(i, yMe), u = wu(o);
        "value" in s && (e2.store = Ob(e2.store, u, s.value)), e2.notifyObservers(a, [u], { type: "setField", data: i });
      });
    }, this.getFields = function() {
      var n2 = e2.getFieldEntities(true), a = n2.map(function(i) {
        var o = i.getNamePath(), s = i.getMeta(), u = Ra(Ra({}, s), {}, { name: o, value: e2.getFieldValue(o) });
        return Object.defineProperty(u, "originRCField", { value: true }), u;
      });
      return a;
    }, this.initEntityValue = function(n2) {
      var a = n2.props.initialValue;
      if (a !== void 0) {
        var i = n2.getNamePath(), o = qx(e2.store, i);
        o === void 0 && (e2.store = Ob(e2.store, i, a));
      }
    }, this.registerField = function(n2) {
      if (e2.fieldEntities.push(n2), n2.props.initialValue !== void 0) {
        var a = e2.store;
        e2.resetWithFieldInitialValue({ entities: [n2], skipExist: true }), e2.notifyObservers(a, [n2.getNamePath()], { type: "valueUpdate", source: "internal" });
      }
      return function(i, o) {
        var s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
        e2.fieldEntities = e2.fieldEntities.filter(function(h) {
          return h !== n2;
        });
        var u = o !== void 0 ? o : e2.preserve;
        if (u === false && (!i || s.length > 1)) {
          var l2 = n2.getNamePath(), c2 = i ? void 0 : qx(e2.initialValues, l2);
          if (l2.length && e2.getFieldValue(l2) !== c2 && e2.fieldEntities.every(function(h) {
            return !MX(h.getNamePath(), l2);
          })) {
            var f2 = e2.store;
            e2.store = Ob(f2, l2, c2, true), e2.notifyObservers(f2, [l2], { type: "remove" }), e2.triggerDependenciesUpdate(f2, l2);
          }
        }
      };
    }, this.dispatch = function(n2) {
      switch (n2.type) {
        case "updateValue": {
          var a = n2.namePath, i = n2.value;
          e2.updateValue(a, i);
          break;
        }
        case "validateField": {
          var o = n2.namePath, s = n2.triggerName;
          e2.validateFields([o], { triggerName: s });
          break;
        }
      }
    }, this.notifyObservers = function(n2, a, i) {
      if (e2.subscribable) {
        var o = Ra(Ra({}, i), {}, { store: e2.getFieldsValue(true) });
        e2.getFieldEntities().forEach(function(s) {
          var u = s.onStoreChange;
          u(n2, a, o);
        });
      } else
        e2.forceRootUpdate();
    }, this.triggerDependenciesUpdate = function(n2, a) {
      var i = e2.getDependencyChildrenFields(a);
      return i.length && e2.validateFields(i), e2.notifyObservers(n2, i, { type: "dependenciesUpdate", relatedFields: [a].concat(Vi(i)) }), i;
    }, this.updateValue = function(n2, a) {
      var i = wu(n2), o = e2.store;
      e2.store = Ob(e2.store, i, a), e2.notifyObservers(o, [i], { type: "valueUpdate", source: "internal" });
      var s = e2.triggerDependenciesUpdate(o, i), u = e2.callbacks.onValuesChange;
      if (u) {
        var l2 = VG(e2.store, [i]);
        u(l2, e2.getFieldsValue());
      }
      e2.triggerOnFieldsChange([i].concat(Vi(s)));
    }, this.setFieldsValue = function(n2) {
      e2.warningUnhooked();
      var a = e2.store;
      n2 && (e2.store = $5(e2.store, n2)), e2.notifyObservers(a, null, { type: "valueUpdate", source: "external" });
    }, this.getDependencyChildrenFields = function(n2) {
      var a = /* @__PURE__ */ new Set(), i = [], o = new gC();
      e2.getFieldEntities().forEach(function(u) {
        var l2 = u.props.dependencies;
        (l2 || []).forEach(function(c2) {
          var f2 = wu(c2);
          o.update(f2, function() {
            var h = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
            return h.add(u), h;
          });
        });
      });
      var s = function u(l2) {
        var c2 = o.get(l2) || /* @__PURE__ */ new Set();
        c2.forEach(function(f2) {
          if (!a.has(f2)) {
            a.add(f2);
            var h = f2.getNamePath();
            f2.isFieldDirty() && h.length && (i.push(h), u(h));
          }
        });
      };
      return s(n2), i;
    }, this.triggerOnFieldsChange = function(n2, a) {
      var i = e2.callbacks.onFieldsChange;
      if (i) {
        var o = e2.getFields();
        if (a) {
          var s = new gC();
          a.forEach(function(l2) {
            var c2 = l2.name, f2 = l2.errors;
            s.set(c2, f2);
          }), o.forEach(function(l2) {
            l2.errors = s.get(l2.name) || l2.errors;
          });
        }
        var u = o.filter(function(l2) {
          var c2 = l2.name;
          return KC(n2, c2);
        });
        i(u, o);
      }
    }, this.validateFields = function(n2, a) {
      e2.warningUnhooked();
      var i = !!n2, o = i ? n2.map(wu) : [], s = [];
      e2.getFieldEntities(true).forEach(function(c2) {
        if (i || o.push(c2.getNamePath()), (a == null ? void 0 : a.recursive) && i) {
          var f2 = c2.getNamePath();
          f2.every(function(d2, m2) {
            return n2[m2] === d2 || n2[m2] === void 0;
          }) && o.push(f2);
        }
        if (!(!c2.props.rules || !c2.props.rules.length)) {
          var h = c2.getNamePath();
          if (!i || KC(o, h)) {
            var v9 = c2.validateRules(Ra({ validateMessages: Ra(Ra({}, CX), e2.validateMessages) }, a));
            s.push(v9.then(function() {
              return { name: h, errors: [], warnings: [] };
            }).catch(function(d2) {
              var m2 = [], b2 = [];
              return d2.forEach(function(_) {
                var C = _.rule.warningOnly, M = _.errors;
                C ? b2.push.apply(b2, Vi(M)) : m2.push.apply(m2, Vi(M));
              }), m2.length ? Promise.reject({ name: h, errors: m2, warnings: b2 }) : { name: h, errors: m2, warnings: b2 };
            }));
          }
        }
      });
      var u = gMe(s);
      e2.lastValidatePromise = u, u.catch(function(c2) {
        return c2;
      }).then(function(c2) {
        var f2 = c2.map(function(h) {
          var v9 = h.name;
          return v9;
        });
        e2.notifyObservers(e2.store, f2, { type: "validateFinish" }), e2.triggerOnFieldsChange(f2, c2);
      });
      var l2 = u.then(function() {
        return e2.lastValidatePromise === u ? Promise.resolve(e2.getFieldsValue(o)) : Promise.reject([]);
      }).catch(function(c2) {
        var f2 = c2.filter(function(h) {
          return h && h.errors.length;
        });
        return Promise.reject({ values: e2.getFieldsValue(o), errorFields: f2, outOfDate: e2.lastValidatePromise !== u });
      });
      return l2.catch(function(c2) {
        return c2;
      }), l2;
    }, this.submit = function() {
      e2.warningUnhooked(), e2.validateFields().then(function(n2) {
        var a = e2.callbacks.onFinish;
        if (a)
          try {
            a(n2);
          } catch (i) {
            console.error(i);
          }
      }).catch(function(n2) {
        var a = e2.callbacks.onFinishFailed;
        a && a(n2);
      });
    }, this.forceRootUpdate = t2;
  });
  function IX(r2) {
    var t2 = Lr.useRef(), e2 = Lr.useState({}), n2 = Wh(e2, 2), a = n2[1];
    if (!t2.current)
      if (r2)
        t2.current = r2;
      else {
        var i = function() {
          a({});
        }, o = new mMe(i);
        t2.current = o.getForm();
      }
    return [t2.current];
  }
  var I6 = Lr.createContext({ triggerFormChange: function() {
  }, triggerFormFinish: function() {
  }, registerForm: function() {
  }, unregisterForm: function() {
  } }), bMe = function(t2) {
    var e2 = t2.validateMessages, n2 = t2.onFormChange, a = t2.onFormFinish, i = t2.children, o = Lr.useContext(I6), s = Lr.useRef({});
    return Lr.createElement(I6.Provider, { value: Ra(Ra({}, o), {}, { validateMessages: Ra(Ra({}, o.validateMessages), e2), triggerFormChange: function(l2, c2) {
      n2 && n2(l2, { changedFields: c2, forms: s.current }), o.triggerFormChange(l2, c2);
    }, triggerFormFinish: function(l2, c2) {
      a && a(l2, { values: c2, forms: s.current }), o.triggerFormFinish(l2, c2);
    }, registerForm: function(l2, c2) {
      l2 && (s.current = Ra(Ra({}, s.current), {}, go({}, l2, c2))), o.registerForm(l2, c2);
    }, unregisterForm: function(l2) {
      var c2 = Ra({}, s.current);
      delete c2[l2], s.current = c2, o.unregisterForm(l2);
    } }) }, i);
  }, _Me = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], xMe = function(t2, e2) {
    var n2 = t2.name, a = t2.initialValues, i = t2.fields, o = t2.form, s = t2.preserve, u = t2.children, l2 = t2.component, c2 = l2 === void 0 ? "form" : l2, f2 = t2.validateMessages, h = t2.validateTrigger, v9 = h === void 0 ? "onChange" : h, d2 = t2.onValuesChange, m2 = t2.onFieldsChange, b2 = t2.onFinish, _ = t2.onFinishFailed, C = Aw(t2, _Me), M = Lr.useContext(I6), E = IX(o), z9 = Wh(E, 1), V = z9[0], $ = V.getInternalHooks(Hx), U = $.useSubscribe, H = $.setInitialValues, q3 = $.setCallbacks, ee = $.setValidateMessages, oe = $.setPreserve;
    Lr.useImperativeHandle(e2, function() {
      return V;
    }), Lr.useEffect(function() {
      return M.registerForm(n2, V), function() {
        M.unregisterForm(n2);
      };
    }, [M, V, n2]), ee(Ra(Ra({}, M.validateMessages), f2)), q3({ onValuesChange: d2, onFieldsChange: function(st) {
      if (M.triggerFormChange(n2, st), m2) {
        for (var dt = arguments.length, Ar = new Array(dt > 1 ? dt - 1 : 0), Hr = 1; Hr < dt; Hr++)
          Ar[Hr - 1] = arguments[Hr];
        m2.apply(void 0, [st].concat(Ar));
      }
    }, onFinish: function(st) {
      M.triggerFormFinish(n2, st), b2 && b2(st);
    }, onFinishFailed: _ }), oe(s);
    var ne = Lr.useRef(null);
    H(a, !ne.current), ne.current || (ne.current = true);
    var be = u, Ee = typeof u == "function";
    if (Ee) {
      var ye = V.getFieldsValue(true);
      be = u(ye, V);
    }
    U(!Ee);
    var et = Lr.useRef();
    Lr.useEffect(function() {
      oMe(et.current || [], i || []) || V.setFields(i || []), et.current = i;
    }, [i, V]);
    var Le = Lr.useMemo(function() {
      return Ra(Ra({}, V), {}, { validateTrigger: v9 });
    }, [V, v9]), Fe = Lr.createElement(EE.Provider, { value: Le }, be);
    return c2 === false ? Fe : Lr.createElement(c2, Su({}, C, { onSubmit: function(st) {
      st.preventDefault(), st.stopPropagation(), V.submit();
    }, onReset: function(st) {
      var dt;
      st.preventDefault(), V.resetFields(), (dt = C.onReset) === null || dt === void 0 || dt.call(C, st);
    } }), Fe);
  }, wMe = Lr.forwardRef(xMe), $3 = wMe;
  $3.FormProvider = bMe;
  $3.Field = PX;
  $3.List = pMe;
  $3.useForm = IX;
  var SMe = function(r2, t2, e2) {
    Jd(r2, "[antd: ".concat(t2, "] ").concat(e2));
  }, CMe = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, EMe = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, AMe = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, LX = AMe, TMe = { lang: Su({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, EMe), timePickerLocale: Su({}, LX) }, $G = TMe, Hf = "${label} is not a valid ${type}", MMe = { locale: "en", Pagination: CMe, DatePicker: $G, TimePicker: LX, Calendar: $G, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: Hf, method: Hf, array: Hf, object: Hf, number: Hf, date: Hf, boolean: Hf, integer: Hf, float: Hf, regexp: Hf, email: Hf, url: Hf, hex: Hf }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, GG = MMe, PMe = Li.createContext(void 0), DMe = PMe, ZN = function(r2) {
    $N(e2, r2);
    var t2 = WN(e2);
    function e2() {
      return ZE(this, e2), t2.apply(this, arguments);
    }
    return XE(e2, [{ key: "getLocale", value: function() {
      var a = this.props, i = a.componentName, o = a.defaultLocale, s = o || GG[i != null ? i : "global"], u = this.context, l2 = i && u ? u[i] : {};
      return Su(Su({}, s instanceof Function ? s() : s), l2 || {});
    } }, { key: "getLocaleCode", value: function() {
      var a = this.context, i = a && a.locale;
      return a && a.exist && !i ? GG.locale : i;
    } }, { key: "render", value: function() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    } }]), e2;
  }(Lr.Component);
  ZN.defaultProps = { componentName: "global" };
  ZN.contextType = DMe;
  var IMe = function() {
    var t2 = Lr.useContext(My), e2 = t2.getPrefixCls, n2 = e2("empty-img-default");
    return Lr.createElement("svg", { className: n2, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Lr.createElement("g", { fill: "none", fillRule: "evenodd" }, Lr.createElement("g", { transform: "translate(24 31.67)" }, Lr.createElement("ellipse", { className: "".concat(n2, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Lr.createElement("path", { className: "".concat(n2, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Lr.createElement("path", { className: "".concat(n2, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Lr.createElement("path", { className: "".concat(n2, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Lr.createElement("path", { className: "".concat(n2, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Lr.createElement("path", { className: "".concat(n2, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Lr.createElement("g", { className: "".concat(n2, "-g"), transform: "translate(149.65 15.383)" }, Lr.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Lr.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
  }, LMe = IMe, OMe = function() {
    var t2 = Lr.useContext(My), e2 = t2.getPrefixCls, n2 = e2("empty-img-simple");
    return Lr.createElement("svg", { className: n2, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Lr.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Lr.createElement("ellipse", { className: "".concat(n2, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Lr.createElement("g", { className: "".concat(n2, "-g"), fillRule: "nonzero" }, Lr.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Lr.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(n2, "-path") }))));
  }, kMe = OMe, RMe = globalThis && globalThis.__rest || function(r2, t2) {
    var e2 = {};
    for (var n2 in r2)
      Object.prototype.hasOwnProperty.call(r2, n2) && t2.indexOf(n2) < 0 && (e2[n2] = r2[n2]);
    if (r2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var a = 0, n2 = Object.getOwnPropertySymbols(r2); a < n2.length; a++)
        t2.indexOf(n2[a]) < 0 && Object.prototype.propertyIsEnumerable.call(r2, n2[a]) && (e2[n2[a]] = r2[n2[a]]);
    return e2;
  }, OX = Lr.createElement(LMe, null), kX = Lr.createElement(kMe, null), XN = function(t2) {
    var e2 = t2.className, n2 = t2.prefixCls, a = t2.image, i = a === void 0 ? OX : a, o = t2.description, s = t2.children, u = t2.imageStyle, l2 = RMe(t2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), c2 = Lr.useContext(My), f2 = c2.getPrefixCls, h = c2.direction;
    return Lr.createElement(ZN, { componentName: "Empty" }, function(v9) {
      var d2, m2 = f2("empty", n2), b2 = typeof o != "undefined" ? o : v9.description, _ = typeof b2 == "string" ? b2 : "empty", C = null;
      return typeof i == "string" ? C = Lr.createElement("img", { alt: _, src: i }) : C = i, Lr.createElement("div", Su({ className: Tw(m2, (d2 = {}, go(d2, "".concat(m2, "-normal"), i === kX), go(d2, "".concat(m2, "-rtl"), h === "rtl"), d2), e2) }, l2), Lr.createElement("div", { className: "".concat(m2, "-image"), style: u }, C), b2 && Lr.createElement("div", { className: "".concat(m2, "-description") }, b2), s && Lr.createElement("div", { className: "".concat(m2, "-footer") }, s));
    });
  };
  XN.PRESENTED_IMAGE_DEFAULT = OX;
  XN.PRESENTED_IMAGE_SIMPLE = kX;
  var yC = XN, FMe = function(t2) {
    return Lr.createElement(RX, null, function(e2) {
      var n2 = e2.getPrefixCls, a = n2("empty");
      switch (t2) {
        case "Table":
        case "List":
          return Lr.createElement(yC, { image: yC.PRESENTED_IMAGE_SIMPLE });
        case "Select":
        case "TreeSelect":
        case "Cascader":
        case "Transfer":
        case "Mentions":
          return Lr.createElement(yC, { image: yC.PRESENTED_IMAGE_SIMPLE, className: "".concat(a, "-small") });
        default:
          return Lr.createElement(yC, null);
      }
    });
  }, NMe = FMe, VMe = function(t2, e2) {
    return e2 || (t2 ? "ant-".concat(t2) : "ant");
  }, My = Lr.createContext({ getPrefixCls: VMe, renderEmpty: NMe }), RX = My.Consumer, jMe = Lr.createContext(void 0), BMe = jMe, FX = function(t2) {
    return +setTimeout(t2, 16);
  }, NX = function(t2) {
    return clearTimeout(t2);
  };
  typeof window != "undefined" && "requestAnimationFrame" in window && (FX = function(t2) {
    return window.requestAnimationFrame(t2);
  }, NX = function(t2) {
    return window.cancelAnimationFrame(t2);
  });
  var WG = 0, JN = /* @__PURE__ */ new Map();
  function VX(r2) {
    JN.delete(r2);
  }
  function BP(r2) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    WG += 1;
    var e2 = WG;
    function n2(a) {
      if (a === 0)
        VX(e2), r2();
      else {
        var i = FX(function() {
          n2(a - 1);
        });
        JN.set(e2, i);
      }
    }
    return n2(t2), e2;
  }
  BP.cancel = function(r2) {
    var t2 = JN.get(r2);
    return VX(t2), NX(t2);
  };
  function zMe(r2, t2) {
    var e2 = t2 || {}, n2 = e2.defaultValue, a = e2.value, i = e2.onChange, o = e2.postState, s = Lr.useState(function() {
      return a !== void 0 ? a : n2 !== void 0 ? typeof n2 == "function" ? n2() : n2 : typeof r2 == "function" ? r2() : r2;
    }), u = Wh(s, 2), l2 = u[0], c2 = u[1], f2 = a !== void 0 ? a : l2;
    o && (f2 = o(f2));
    var h = Lr.useRef(i);
    h.current = i;
    var v9 = Lr.useCallback(function(m2) {
      c2(m2), f2 !== m2 && h.current && h.current(m2, f2);
    }, [f2, h]), d2 = Lr.useRef(true);
    return Lr.useEffect(function() {
      if (d2.current) {
        d2.current = false;
        return;
      }
      a === void 0 && c2(a);
    }, [a]), [f2, v9];
  }
  var ha = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(t2) {
    var e2 = t2.keyCode;
    if (t2.altKey && !t2.ctrlKey || t2.metaKey || e2 >= ha.F1 && e2 <= ha.F12)
      return false;
    switch (e2) {
      case ha.ALT:
      case ha.CAPS_LOCK:
      case ha.CONTEXT_MENU:
      case ha.CTRL:
      case ha.DOWN:
      case ha.END:
      case ha.ESC:
      case ha.HOME:
      case ha.INSERT:
      case ha.LEFT:
      case ha.MAC_FF_META:
      case ha.META:
      case ha.NUMLOCK:
      case ha.NUM_CENTER:
      case ha.PAGE_DOWN:
      case ha.PAGE_UP:
      case ha.PAUSE:
      case ha.PRINT_SCREEN:
      case ha.RIGHT:
      case ha.SHIFT:
      case ha.UP:
      case ha.WIN_KEY:
      case ha.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  }, isCharacterKey: function(t2) {
    if (t2 >= ha.ZERO && t2 <= ha.NINE || t2 >= ha.NUM_ZERO && t2 <= ha.NUM_MULTIPLY || t2 >= ha.A && t2 <= ha.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && t2 === 0)
      return true;
    switch (t2) {
      case ha.SPACE:
      case ha.QUESTION_MARK:
      case ha.NUM_PLUS:
      case ha.NUM_MINUS:
      case ha.NUM_PERIOD:
      case ha.NUM_DIVISION:
      case ha.SEMICOLON:
      case ha.DASH:
      case ha.EQUALS:
      case ha.COMMA:
      case ha.PERIOD:
      case ha.SLASH:
      case ha.APOSTROPHE:
      case ha.SINGLE_QUOTE:
      case ha.OPEN_SQUARE_BRACKET:
      case ha.BACKSLASH:
      case ha.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  } }, jX = function() {
    for (var t2 = arguments.length, e2 = new Array(t2), n2 = 0; n2 < t2; n2++)
      e2[n2] = arguments[n2];
    return e2;
  }, $Me = Lr.isValidElement;
  function GMe(r2, t2, e2) {
    return $Me(r2) ? Lr.cloneElement(r2, typeof e2 == "function" ? e2(r2.props || {}) : e2) : t2;
  }
  function WMe(r2, t2) {
    return GMe(r2, r2, t2);
  }
  var UG = ["xxl", "xl", "lg", "md", "sm", "xs"], m5 = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, Eb = /* @__PURE__ */ new Map(), TR = -1, b5 = {}, UMe = { matchHandlers: {}, dispatch: function(t2) {
    return b5 = t2, Eb.forEach(function(e2) {
      return e2(b5);
    }), Eb.size >= 1;
  }, subscribe: function(t2) {
    return Eb.size || this.register(), TR += 1, Eb.set(TR, t2), t2(b5), TR;
  }, unsubscribe: function(t2) {
    Eb.delete(t2), Eb.size || this.unregister();
  }, unregister: function() {
    var t2 = this;
    Object.keys(m5).forEach(function(e2) {
      var n2 = m5[e2], a = t2.matchHandlers[n2];
      a == null || a.mql.removeListener(a == null ? void 0 : a.listener);
    }), Eb.clear();
  }, register: function() {
    var t2 = this;
    Object.keys(m5).forEach(function(e2) {
      var n2 = m5[e2], a = function(s) {
        var u = s.matches;
        t2.dispatch(Su(Su({}, b5), go({}, e2, u)));
      }, i = window.matchMedia(n2);
      i.addListener(a), t2.matchHandlers[n2] = { mql: i, listener: a }, a(i);
    });
  } }, HG = UMe, HMe = 0, Qx = {};
  function zP(r2) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, e2 = HMe++, n2 = t2;
    function a() {
      n2 -= 1, n2 <= 0 ? (r2(), delete Qx[e2]) : Qx[e2] = BP(a);
    }
    return Qx[e2] = BP(a), e2;
  }
  zP.cancel = function(t2) {
    t2 !== void 0 && (BP.cancel(Qx[t2]), delete Qx[t2]);
  };
  zP.ids = Qx;
  var MR;
  function qG(r2) {
    return !r2 || r2.offsetParent === null || r2.hidden;
  }
  function qMe(r2) {
    var t2 = (r2 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
    return t2 && t2[1] && t2[2] && t2[3] ? !(t2[1] === t2[2] && t2[2] === t2[3]) : true;
  }
  var BX = function(r2) {
    $N(e2, r2);
    var t2 = WN(e2);
    function e2() {
      var n2;
      return ZE(this, e2), n2 = t2.apply(this, arguments), n2.containerRef = Lr.createRef(), n2.animationStart = false, n2.destroyed = false, n2.onClick = function(a, i) {
        var o, s, u = n2.props, l2 = u.insertExtraNode, c2 = u.disabled;
        if (!(c2 || !a || qG(a) || a.className.indexOf("-leave") >= 0)) {
          n2.extraNode = document.createElement("div");
          var f2 = GN(n2), h = f2.extraNode, v9 = n2.context.getPrefixCls;
          h.className = "".concat(v9(""), "-click-animating-node");
          var d2 = n2.getAttributeName();
          if (a.setAttribute(d2, "true"), i && i !== "#ffffff" && i !== "rgb(255, 255, 255)" && qMe(i) && !/rgba\((?:\d*, ){3}0\)/.test(i) && i !== "transparent") {
            h.style.borderColor = i;
            var m2 = ((o = a.getRootNode) === null || o === void 0 ? void 0 : o.call(a)) || a.ownerDocument, b2 = m2 instanceof Document ? m2.body : (s = m2.firstChild) !== null && s !== void 0 ? s : m2;
            MR = pX(`
      [`.concat(v9(""), "-click-animating-without-extra-node='true']::after, .").concat(v9(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(i, `;
      }`), "antd-wave", { csp: n2.csp, attachTo: b2 });
          }
          l2 && a.appendChild(h), ["transition", "animation"].forEach(function(_) {
            a.addEventListener("".concat(_, "start"), n2.onTransitionStart), a.addEventListener("".concat(_, "end"), n2.onTransitionEnd);
          });
        }
      }, n2.onTransitionStart = function(a) {
        if (!n2.destroyed) {
          var i = n2.containerRef.current;
          !a || a.target !== i || n2.animationStart || n2.resetEffect(i);
        }
      }, n2.onTransitionEnd = function(a) {
        !a || a.animationName !== "fadeEffect" || n2.resetEffect(a.target);
      }, n2.bindAnimationEvent = function(a) {
        if (!(!a || !a.getAttribute || a.getAttribute("disabled") || a.className.indexOf("disabled") >= 0)) {
          var i = function(s) {
            if (!(s.target.tagName === "INPUT" || qG(s.target))) {
              n2.resetEffect(a);
              var u = getComputedStyle(a).getPropertyValue("border-top-color") || getComputedStyle(a).getPropertyValue("border-color") || getComputedStyle(a).getPropertyValue("background-color");
              n2.clickWaveTimeoutId = window.setTimeout(function() {
                return n2.onClick(a, u);
              }, 0), zP.cancel(n2.animationStartId), n2.animationStart = true, n2.animationStartId = zP(function() {
                n2.animationStart = false;
              }, 10);
            }
          };
          return a.addEventListener("click", i, true), { cancel: function() {
            a.removeEventListener("click", i, true);
          } };
        }
      }, n2.renderWave = function(a) {
        var i = a.csp, o = n2.props.children;
        if (n2.csp = i, !Lr.isValidElement(o))
          return o;
        var s = n2.containerRef;
        return _Te(o) && (s = bTe(o.ref, n2.containerRef)), WMe(o, { ref: s });
      }, n2;
    }
    return XE(e2, [{ key: "componentDidMount", value: function() {
      var a = this.containerRef.current;
      !a || a.nodeType !== 1 || (this.instance = this.bindAnimationEvent(a));
    } }, { key: "componentWillUnmount", value: function() {
      this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
    } }, { key: "getAttributeName", value: function() {
      var a = this.context.getPrefixCls, i = this.props.insertExtraNode;
      return i ? "".concat(a(""), "-click-animating") : "".concat(a(""), "-click-animating-without-extra-node");
    } }, { key: "resetEffect", value: function(a) {
      var i = this;
      if (!(!a || a === this.extraNode || !(a instanceof Element))) {
        var o = this.props.insertExtraNode, s = this.getAttributeName();
        a.setAttribute(s, "false"), MR && (MR.innerHTML = ""), o && this.extraNode && a.contains(this.extraNode) && a.removeChild(this.extraNode), ["transition", "animation"].forEach(function(u) {
          a.removeEventListener("".concat(u, "start"), i.onTransitionStart), a.removeEventListener("".concat(u, "end"), i.onTransitionEnd);
        });
      }
    } }, { key: "render", value: function() {
      return Lr.createElement(RX, null, this.renderWave);
    } }]), e2;
  }(Lr.Component);
  BX.contextType = My;
  var QN = { exports: {} }, QE = {};
  /** @license React v17.0.2
  * react-jsx-runtime.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var YMe = ew.default, zX = 60103;
  QE.Fragment = 60107;
  if (typeof Symbol == "function" && Symbol.for) {
    var YG = Symbol.for;
    zX = YG("react.element"), QE.Fragment = YG("react.fragment");
  }
  var KMe = YMe.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, ZMe = Object.prototype.hasOwnProperty, XMe = { key: true, ref: true, __self: true, __source: true };
  function $X(r2, t2, e2) {
    var n2, a = {}, i = null, o = null;
    e2 !== void 0 && (i = "" + e2), t2.key !== void 0 && (i = "" + t2.key), t2.ref !== void 0 && (o = t2.ref);
    for (n2 in t2)
      ZMe.call(t2, n2) && !XMe.hasOwnProperty(n2) && (a[n2] = t2[n2]);
    if (r2 && r2.defaultProps)
      for (n2 in t2 = r2.defaultProps, t2)
        a[n2] === void 0 && (a[n2] = t2[n2]);
    return { $$typeof: zX, type: r2, key: i, ref: o, props: a, _owner: KMe.current };
  }
  QE.jsx = $X;
  QE.jsxs = $X;
  QN.exports = QE;
  const jx = QN.exports.jsx, JMe = QN.exports.jsxs;
  var QMe = Li.createContext({}), GX = QMe, e5e = function() {
    return vX() && window.document.documentElement;
  }, _5, t5e = function() {
    if (!e5e())
      return false;
    if (_5 !== void 0)
      return _5;
    var t2 = document.createElement("div");
    return t2.style.display = "flex", t2.style.flexDirection = "column", t2.style.rowGap = "1px", t2.appendChild(document.createElement("div")), t2.appendChild(document.createElement("div")), document.body.appendChild(t2), _5 = t2.scrollHeight === 1, document.body.removeChild(t2), _5;
  }, r5e = function() {
    var r2 = Lr.useState(false), t2 = Wh(r2, 2), e2 = t2[0], n2 = t2[1];
    return Lr.useEffect(function() {
      n2(t5e());
    }, []), e2;
  }, n5e = globalThis && globalThis.__rest || function(r2, t2) {
    var e2 = {};
    for (var n2 in r2)
      Object.prototype.hasOwnProperty.call(r2, n2) && t2.indexOf(n2) < 0 && (e2[n2] = r2[n2]);
    if (r2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var a = 0, n2 = Object.getOwnPropertySymbols(r2); a < n2.length; a++)
        t2.indexOf(n2[a]) < 0 && Object.prototype.propertyIsEnumerable.call(r2, n2[a]) && (e2[n2[a]] = r2[n2[a]]);
    return e2;
  };
  jX("top", "middle", "bottom", "stretch");
  jX("start", "end", "center", "space-around", "space-between");
  var WX = Lr.forwardRef(function(r2, t2) {
    var e2, n2 = r2.prefixCls, a = r2.justify, i = r2.align, o = r2.className, s = r2.style, u = r2.children, l2 = r2.gutter, c2 = l2 === void 0 ? 0 : l2, f2 = r2.wrap, h = n5e(r2, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), v9 = Lr.useContext(My), d2 = v9.getPrefixCls, m2 = v9.direction, b2 = Lr.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), _ = Wh(b2, 2), C = _[0], M = _[1], E = r5e(), z9 = Lr.useRef(c2);
    Lr.useEffect(function() {
      var Le = HG.subscribe(function(Fe) {
        var qe = z9.current || 0;
        (!Array.isArray(qe) && sc(qe) === "object" || Array.isArray(qe) && (sc(qe[0]) === "object" || sc(qe[1]) === "object")) && M(Fe);
      });
      return function() {
        return HG.unsubscribe(Le);
      };
    }, []);
    var V = function() {
      var Fe = [0, 0], qe = Array.isArray(c2) ? c2 : [c2, 0];
      return qe.forEach(function(st, dt) {
        if (sc(st) === "object")
          for (var Ar = 0; Ar < UG.length; Ar++) {
            var Hr = UG[Ar];
            if (C[Hr] && st[Hr] !== void 0) {
              Fe[dt] = st[Hr];
              break;
            }
          }
        else
          Fe[dt] = st || 0;
      }), Fe;
    }, $ = d2("row", n2), U = V(), H = Tw($, (e2 = {}, go(e2, "".concat($, "-no-wrap"), f2 === false), go(e2, "".concat($, "-").concat(a), a), go(e2, "".concat($, "-").concat(i), i), go(e2, "".concat($, "-rtl"), m2 === "rtl"), e2), o), q3 = {}, ee = U[0] > 0 ? U[0] / -2 : void 0, oe = U[1] > 0 ? U[1] / -2 : void 0;
    if (ee && (q3.marginLeft = ee, q3.marginRight = ee), E) {
      var ne = Wh(U, 2);
      q3.rowGap = ne[1];
    } else
      oe && (q3.marginTop = oe, q3.marginBottom = oe);
    var be = Wh(U, 2), Ee = be[0], ye = be[1], et = Lr.useMemo(function() {
      return { gutter: [Ee, ye], wrap: f2, supportFlexGap: E };
    }, [Ee, ye, f2, E]);
    return Lr.createElement(GX.Provider, { value: et }, Lr.createElement("div", Su({}, h, { className: H, style: Su(Su({}, q3), s), ref: t2 }), u));
  });
  WX.displayName = "Row";
  var a5e = WX, i5e = globalThis && globalThis.__rest || function(r2, t2) {
    var e2 = {};
    for (var n2 in r2)
      Object.prototype.hasOwnProperty.call(r2, n2) && t2.indexOf(n2) < 0 && (e2[n2] = r2[n2]);
    if (r2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var a = 0, n2 = Object.getOwnPropertySymbols(r2); a < n2.length; a++)
        t2.indexOf(n2[a]) < 0 && Object.prototype.propertyIsEnumerable.call(r2, n2[a]) && (e2[n2[a]] = r2[n2[a]]);
    return e2;
  };
  function o5e(r2) {
    return typeof r2 == "number" ? "".concat(r2, " ").concat(r2, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(r2) ? "0 0 ".concat(r2) : r2;
  }
  var s5e = ["xs", "sm", "md", "lg", "xl", "xxl"], UX = Lr.forwardRef(function(r2, t2) {
    var e2, n2 = Lr.useContext(My), a = n2.getPrefixCls, i = n2.direction, o = Lr.useContext(GX), s = o.gutter, u = o.wrap, l2 = o.supportFlexGap, c2 = r2.prefixCls, f2 = r2.span, h = r2.order, v9 = r2.offset, d2 = r2.push, m2 = r2.pull, b2 = r2.className, _ = r2.children, C = r2.flex, M = r2.style, E = i5e(r2, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), z9 = a("col", c2), V = {};
    s5e.forEach(function(ee) {
      var oe, ne = {}, be = r2[ee];
      typeof be == "number" ? ne.span = be : sc(be) === "object" && (ne = be || {}), delete E[ee], V = Su(Su({}, V), (oe = {}, go(oe, "".concat(z9, "-").concat(ee, "-").concat(ne.span), ne.span !== void 0), go(oe, "".concat(z9, "-").concat(ee, "-order-").concat(ne.order), ne.order || ne.order === 0), go(oe, "".concat(z9, "-").concat(ee, "-offset-").concat(ne.offset), ne.offset || ne.offset === 0), go(oe, "".concat(z9, "-").concat(ee, "-push-").concat(ne.push), ne.push || ne.push === 0), go(oe, "".concat(z9, "-").concat(ee, "-pull-").concat(ne.pull), ne.pull || ne.pull === 0), go(oe, "".concat(z9, "-rtl"), i === "rtl"), oe));
    });
    var $ = Tw(z9, (e2 = {}, go(e2, "".concat(z9, "-").concat(f2), f2 !== void 0), go(e2, "".concat(z9, "-order-").concat(h), h), go(e2, "".concat(z9, "-offset-").concat(v9), v9), go(e2, "".concat(z9, "-push-").concat(d2), d2), go(e2, "".concat(z9, "-pull-").concat(m2), m2), e2), b2, V), U = {};
    if (s && s[0] > 0) {
      var H = s[0] / 2;
      U.paddingLeft = H, U.paddingRight = H;
    }
    if (s && s[1] > 0 && !l2) {
      var q3 = s[1] / 2;
      U.paddingTop = q3, U.paddingBottom = q3;
    }
    return C && (U.flex = o5e(C), u === false && !U.minWidth && (U.minWidth = 0)), Lr.createElement("div", Su({}, E, { style: Su(Su({}, U), M), className: $, ref: t2 }), _);
  });
  UX.displayName = "Col";
  var u5e = UX, HX = Lr.forwardRef(function(r2, t2) {
    var e2, n2 = r2.prefixCls, a = n2 === void 0 ? "rc-switch" : n2, i = r2.className, o = r2.checked, s = r2.defaultChecked, u = r2.disabled, l2 = r2.loadingIcon, c2 = r2.checkedChildren, f2 = r2.unCheckedChildren, h = r2.onClick, v9 = r2.onChange, d2 = r2.onKeyDown, m2 = Aw(r2, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), b2 = zMe(false, { value: o, defaultValue: s }), _ = Wh(b2, 2), C = _[0], M = _[1];
    function E(U, H) {
      var q3 = C;
      return u || (q3 = U, M(q3), v9 == null || v9(q3, H)), q3;
    }
    function z9(U) {
      U.which === ha.LEFT ? E(false, U) : U.which === ha.RIGHT && E(true, U), d2 == null || d2(U);
    }
    function V(U) {
      var H = E(!C, U);
      h == null || h(H, U);
    }
    var $ = Tw(a, i, (e2 = {}, go(e2, "".concat(a, "-checked"), C), go(e2, "".concat(a, "-disabled"), u), e2));
    return Lr.createElement("button", Object.assign({}, m2, { type: "button", role: "switch", "aria-checked": C, disabled: u, className: $, ref: t2, onKeyDown: z9, onClick: V }), l2, Lr.createElement("span", { className: "".concat(a, "-inner") }, C ? c2 : f2));
  });
  HX.displayName = "Switch";
  var l5e = globalThis && globalThis.__rest || function(r2, t2) {
    var e2 = {};
    for (var n2 in r2)
      Object.prototype.hasOwnProperty.call(r2, n2) && t2.indexOf(n2) < 0 && (e2[n2] = r2[n2]);
    if (r2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var a = 0, n2 = Object.getOwnPropertySymbols(r2); a < n2.length; a++)
        t2.indexOf(n2[a]) < 0 && Object.prototype.propertyIsEnumerable.call(r2, n2[a]) && (e2[n2[a]] = r2[n2[a]]);
    return e2;
  }, e9 = Lr.forwardRef(function(r2, t2) {
    var e2, n2 = r2.prefixCls, a = r2.size, i = r2.loading, o = r2.className, s = o === void 0 ? "" : o, u = r2.disabled, l2 = l5e(r2, ["prefixCls", "size", "loading", "className", "disabled"]);
    SMe("checked" in l2 || !("value" in l2), "Switch", "`value` is not a valid prop, do you mean `checked`?");
    var c2 = Lr.useContext(My), f2 = c2.getPrefixCls, h = c2.direction, v9 = Lr.useContext(BMe), d2 = f2("switch", n2), m2 = Lr.createElement("div", { className: "".concat(d2, "-handle") }, i && Lr.createElement(cTe, { className: "".concat(d2, "-loading-icon") })), b2 = Tw((e2 = {}, go(e2, "".concat(d2, "-small"), (a || v9) === "small"), go(e2, "".concat(d2, "-loading"), i), go(e2, "".concat(d2, "-rtl"), h === "rtl"), e2), s);
    return Lr.createElement(BX, { insertExtraNode: true }, Lr.createElement(HX, Su({}, l2, { prefixCls: d2, className: b2, disabled: u || i, ref: t2, loadingIcon: m2 })));
  });
  e9.__ANT_SWITCH = true;
  e9.displayName = "Switch";
  var c5e = e9;
  const f5e = "_container_oi76t_1";
  var h5e = { container: f5e, function: "_function_oi76t_10" }, v5e = {};
  (function(r2) {
    var t2 = Object.defineProperty, e2 = Object.getOwnPropertySymbols, n2 = Object.prototype.hasOwnProperty, a = Object.prototype.propertyIsEnumerable, i = (T, G, P) => G in T ? t2(T, G, { enumerable: true, configurable: true, writable: true, value: P }) : T[G] = P, o = (T, G) => {
      for (var P in G || (G = {}))
        n2.call(G, P) && i(T, P, G[P]);
      if (e2)
        for (var P of e2(G))
          a.call(G, P) && i(T, P, G[P]);
      return T;
    }, s = (T, G, P) => (i(T, typeof G != "symbol" ? G + "" : G, P), P);
    Object.defineProperties(r2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
    var u = ew.default;
    function l2(T) {
      return T && typeof T == "object" && "default" in T ? T : { default: T };
    }
    function c2(T) {
      if (T && T.__esModule)
        return T;
      var G = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
      return T && Object.keys(T).forEach(function(P) {
        if (P !== "default") {
          var I = Object.getOwnPropertyDescriptor(T, P);
          Object.defineProperty(G, P, I.get ? I : { enumerable: true, get: function() {
            return T[P];
          } });
        }
      }), G.default = T, Object.freeze(G);
    }
    var f2 = l2(u), h = c2(u);
    class v9 {
      constructor() {
        s(this, "chartsEmitters", /* @__PURE__ */ new Map()), s(this, "add", (G, P, I, L) => {
          P && I ? this.chartsEmitters.set(G, { chart: P, option: I, title: L }) : console.log("\u6DFB\u52A0\u5931\u8D25");
        }), s(this, "get", (G) => this.chartsEmitters.get(G)), s(this, "clear", () => {
          this.chartsEmitters.clear();
        }), s(this, "delete", (G) => {
          this.chartsEmitters.delete(G);
        }), s(this, "list", () => {
          var G, P, I;
          const L = [];
          for (const j of this.chartsEmitters.keys())
            L.push({ id: j, chart: (G = this.chartsEmitters.get(j)) == null ? void 0 : G.chart, option: (P = this.chartsEmitters.get(j)) == null ? void 0 : P.option, title: (I = this.chartsEmitters.get(j)) == null ? void 0 : I.title });
          return L;
        });
      }
    }
    const d2 = new v9();
    var m2 = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof jh != "undefined" ? jh : typeof self != "undefined" ? self : {};
    function b2(T) {
      return T && T.__esModule && Object.prototype.hasOwnProperty.call(T, "default") ? T.default : T;
    }
    var _ = { exports: {} };
    /**
    * @license
    * Lodash <https://lodash.com/>
    * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
    * Released under MIT license <https://lodash.com/license>
    * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
    * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
    */
    (function(T, G) {
      (function() {
        var P, I = "4.17.21", L = 200, j = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", J = "Expected a function", te = "Invalid `variable` option passed into `_.template`", Q = "__lodash_hash_undefined__", he = 500, de = "__lodash_placeholder__", Ae = 1, We = 2, Xe = 4, Ze = 1, it = 2, ct = 1, sr = 2, Yt = 4, Or = 8, le = 16, _t = 32, Pt = 64, er = 128, Kt = 256, St = 512, kt = 30, dr = "...", Ir = 800, ht = 16, gn = 1, ln = 2, Jt = 3, In = 1 / 0, ur = 9007199254740991, Gt = 17976931348623157e292, zt = 0 / 0, Yr = 4294967295, Vr = Yr - 1, Qn = Yr >>> 1, Ua = [["ary", er], ["bind", ct], ["bindKey", sr], ["curry", Or], ["curryRight", le], ["flip", St], ["partial", _t], ["partialRight", Pt], ["rearg", Kt]], ua = "[object Arguments]", Pa = "[object Array]", qi = "[object AsyncFunction]", Ha = "[object Boolean]", pi = "[object Date]", Lo = "[object DOMException]", rl = "[object Error]", is = "[object Function]", Xs = "[object GeneratorFunction]", qo = "[object Map]", du = "[object Number]", nl = "[object Null]", os = "[object Object]", Rn = "[object Promise]", Tl = "[object Proxy]", Iu = "[object RegExp]", so = "[object Set]", Fs = "[object String]", Oo = "[object Symbol]", mc = "[object Undefined]", nr = "[object WeakMap]", Nt = "[object WeakSet]", Rt = "[object ArrayBuffer]", _r = "[object DataView]", tn = "[object Float32Array]", Sn = "[object Float64Array]", Ca = "[object Int8Array]", wa = "[object Int16Array]", Di = "[object Int32Array]", Mi = "[object Uint8Array]", Da = "[object Uint8ClampedArray]", ko = "[object Uint16Array]", uo = "[object Uint32Array]", xs = /\b__p \+= '';/g, Lu = /\b(__p \+=) '' \+/g, Ul = /(__e\(.*?\)|\b__t\)) \+\n'';/g, ws = /&(?:amp|lt|gt|quot|#39);/g, Go = /[&<>"']/g, qa = RegExp(ws.source), Ss = RegExp(Go.source), Js = /<%-([\s\S]+?)%>/g, al = /<%([\s\S]+?)%>/g, Ou = /<%=([\s\S]+?)%>/g, pu = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, il = /^\w*$/, uh = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, bc = /[\\^$.*+?()[\]{}|]/g, Jg = RegExp(bc.source), Hl = /^\s+/, wp = /\s/, Qg = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, od = /\{\n\/\* \[wrapped with (.+)\] \*/, sd = /,? & /, lh = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, De = /[()=,{}\[\]\/\s]/, ze = /\\(\\)?/g, pe = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, Oe = /\w*$/, Ve = /^[-+]0x[0-9a-f]+$/i, Tt = /^0b[01]+$/i, hr = /^\[object .+?Constructor\]$/, Xt = /^0o[0-7]+$/i, lt2 = /^(?:0|[1-9]\d*)$/, Fr = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, yn = /($^)/, Ia = /['\n\r\u2028\u2029\\]/g, Ea = "\\ud800-\\udfff", pa = "\\u0300-\\u036f", Wn = "\\ufe20-\\ufe2f", ki = "\\u20d0-\\u20ff", bo = pa + Wn + ki, na = "\\u2700-\\u27bf", Ro = "a-z\\xdf-\\xf6\\xf8-\\xff", Qs = "\\xac\\xb1\\xd7\\xf7", _c2 = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", Ef = "\\u2000-\\u206f", xc = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", ov = "A-Z\\xc0-\\xd6\\xd8-\\xde", Af = "\\ufe0e\\ufe0f", Cs = Qs + _c2 + Ef + xc, wc = "['\u2019]", Es = "[" + Ea + "]", ss = "[" + Cs + "]", Sc = "[" + bo + "]", sv = "\\d+", Sp = "[" + na + "]", ol = "[" + Ro + "]", ch = "[^" + Ea + Cs + sv + na + Ro + ov + "]", Tf = "\\ud83c[\\udffb-\\udfff]", Ns = "(?:" + Sc + "|" + Tf + ")", Cp = "[^" + Ea + "]", Ml = "(?:\\ud83c[\\udde6-\\uddff]){2}", ud = "[\\ud800-\\udbff][\\udc00-\\udfff]", uv = "[" + ov + "]", H1 = "\\u200d", q1 = "(?:" + ol + "|" + ch + ")", mS = "(?:" + uv + "|" + ch + ")", nm = "(?:" + wc + "(?:d|ll|m|re|s|t|ve))?", am = "(?:" + wc + "(?:D|LL|M|RE|S|T|VE))?", Y1 = Ns + "?", im = "[" + Af + "]?", e0 = "(?:" + H1 + "(?:" + [Cp, Ml, ud].join("|") + ")" + im + Y1 + ")*", bS = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", K1 = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", om = im + Y1 + e0, Z1 = "(?:" + [Sp, Ml, ud].join("|") + ")" + om, sm = "(?:" + [Cp + Sc + "?", Sc, Ml, ud, Es].join("|") + ")", um = RegExp(wc, "g"), gu = RegExp(Sc, "g"), Ep = RegExp(Tf + "(?=" + Tf + ")|" + sm + om, "g"), X1 = RegExp([uv + "?" + ol + "+" + nm + "(?=" + [ss, uv, "$"].join("|") + ")", mS + "+" + am + "(?=" + [ss, uv + q1, "$"].join("|") + ")", uv + "?" + q1 + "+" + nm, uv + "+" + am, K1, bS, sv, Z1].join("|"), "g"), _S = RegExp("[" + H1 + Ea + bo + Af + "]"), lm = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Cc = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], J1 = -1, _o = {};
        _o[tn] = _o[Sn] = _o[Ca] = _o[wa] = _o[Di] = _o[Mi] = _o[Da] = _o[ko] = _o[uo] = true, _o[ua] = _o[Pa] = _o[Rt] = _o[Ha] = _o[_r] = _o[pi] = _o[rl] = _o[is] = _o[qo] = _o[du] = _o[os] = _o[Iu] = _o[so] = _o[Fs] = _o[nr] = false;
        var lo = {};
        lo[ua] = lo[Pa] = lo[Rt] = lo[_r] = lo[Ha] = lo[pi] = lo[tn] = lo[Sn] = lo[Ca] = lo[wa] = lo[Di] = lo[qo] = lo[du] = lo[os] = lo[Iu] = lo[so] = lo[Fs] = lo[Oo] = lo[Mi] = lo[Da] = lo[ko] = lo[uo] = true, lo[rl] = lo[is] = lo[nr] = false;
        var cm = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, Q1 = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, fm = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, xS = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, e_ = parseFloat, t_ = parseInt, hm = typeof m2 == "object" && m2 && m2.Object === Object && m2, Ap = typeof self == "object" && self && self.Object === Object && self, As = hm || Ap || Function("return this")(), t0 = G && !G.nodeType && G, fh = t0 && true && T && !T.nodeType && T, r_ = fh && fh.exports === t0, vm = r_ && hm.process, ql = function() {
          try {
            var rt2 = fh && fh.require && fh.require("util").types;
            return rt2 || vm && vm.binding && vm.binding("util");
          } catch {
          }
        }(), ld = ql && ql.isArrayBuffer, n_ = ql && ql.isDate, a_ = ql && ql.isMap, Tp = ql && ql.isRegExp, r0 = ql && ql.isSet, dm = ql && ql.isTypedArray;
        function Pl(rt2, yr, Bt) {
          switch (Bt.length) {
            case 0:
              return rt2.call(yr);
            case 1:
              return rt2.call(yr, Bt[0]);
            case 2:
              return rt2.call(yr, Bt[0], Bt[1]);
            case 3:
              return rt2.call(yr, Bt[0], Bt[1], Bt[2]);
          }
          return rt2.apply(yr, Bt);
        }
        function wS(rt2, yr, Bt, vn) {
          for (var ba = -1, Ci = rt2 == null ? 0 : rt2.length; ++ba < Ci; ) {
            var Ms = rt2[ba];
            yr(vn, Ms, Bt(Ms), rt2);
          }
          return vn;
        }
        function ku(rt2, yr) {
          for (var Bt = -1, vn = rt2 == null ? 0 : rt2.length; ++Bt < vn && yr(rt2[Bt], Bt, rt2) !== false; )
            ;
          return rt2;
        }
        function SS(rt2, yr) {
          for (var Bt = rt2 == null ? 0 : rt2.length; Bt-- && yr(rt2[Bt], Bt, rt2) !== false; )
            ;
          return rt2;
        }
        function pm(rt2, yr) {
          for (var Bt = -1, vn = rt2 == null ? 0 : rt2.length; ++Bt < vn; )
            if (!yr(rt2[Bt], Bt, rt2))
              return false;
          return true;
        }
        function Mf(rt2, yr) {
          for (var Bt = -1, vn = rt2 == null ? 0 : rt2.length, ba = 0, Ci = []; ++Bt < vn; ) {
            var Ms = rt2[Bt];
            yr(Ms, Bt, rt2) && (Ci[ba++] = Ms);
          }
          return Ci;
        }
        function Mp(rt2, yr) {
          var Bt = rt2 == null ? 0 : rt2.length;
          return !!Bt && hh(rt2, yr, 0) > -1;
        }
        function gm(rt2, yr, Bt) {
          for (var vn = -1, ba = rt2 == null ? 0 : rt2.length; ++vn < ba; )
            if (Bt(yr, rt2[vn]))
              return true;
          return false;
        }
        function Sa(rt2, yr) {
          for (var Bt = -1, vn = rt2 == null ? 0 : rt2.length, ba = Array(vn); ++Bt < vn; )
            ba[Bt] = yr(rt2[Bt], Bt, rt2);
          return ba;
        }
        function Yl(rt2, yr) {
          for (var Bt = -1, vn = yr.length, ba = rt2.length; ++Bt < vn; )
            rt2[ba + Bt] = yr[Bt];
          return rt2;
        }
        function lv(rt2, yr, Bt, vn) {
          var ba = -1, Ci = rt2 == null ? 0 : rt2.length;
          for (vn && Ci && (Bt = rt2[++ba]); ++ba < Ci; )
            Bt = yr(Bt, rt2[ba], ba, rt2);
          return Bt;
        }
        function Pp(rt2, yr, Bt, vn) {
          var ba = rt2 == null ? 0 : rt2.length;
          for (vn && ba && (Bt = rt2[--ba]); ba--; )
            Bt = yr(Bt, rt2[ba], ba, rt2);
          return Bt;
        }
        function Dp(rt2, yr) {
          for (var Bt = -1, vn = rt2 == null ? 0 : rt2.length; ++Bt < vn; )
            if (yr(rt2[Bt], Bt, rt2))
              return true;
          return false;
        }
        var ym = vh("length");
        function n0(rt2) {
          return rt2.split("");
        }
        function CS(rt2) {
          return rt2.match(lh) || [];
        }
        function a0(rt2, yr, Bt) {
          var vn;
          return Bt(rt2, function(ba, Ci, Ms) {
            if (yr(ba, Ci, Ms))
              return vn = Ci, false;
          }), vn;
        }
        function i0(rt2, yr, Bt, vn) {
          for (var ba = rt2.length, Ci = Bt + (vn ? 1 : -1); vn ? Ci-- : ++Ci < ba; )
            if (yr(rt2[Ci], Ci, rt2))
              return Ci;
          return -1;
        }
        function hh(rt2, yr, Bt) {
          return yr === yr ? l_(rt2, yr, Bt) : i0(rt2, zi, Bt);
        }
        function mm(rt2, yr, Bt, vn) {
          for (var ba = Bt - 1, Ci = rt2.length; ++ba < Ci; )
            if (vn(rt2[ba], yr))
              return ba;
          return -1;
        }
        function zi(rt2) {
          return rt2 !== rt2;
        }
        function Ts(rt2, yr) {
          var Bt = rt2 == null ? 0 : rt2.length;
          return Bt ? dh(rt2, yr) / Bt : zt;
        }
        function vh(rt2) {
          return function(yr) {
            return yr == null ? P : yr[rt2];
          };
        }
        function Ip(rt2) {
          return function(yr) {
            return rt2 == null ? P : rt2[yr];
          };
        }
        function cd(rt2, yr, Bt, vn, ba) {
          return ba(rt2, function(Ci, Ms, Yi) {
            Bt = vn ? (vn = false, Ci) : yr(Bt, Ci, Ms, Yi);
          }), Bt;
        }
        function Lp(rt2, yr) {
          var Bt = rt2.length;
          for (rt2.sort(yr); Bt--; )
            rt2[Bt] = rt2[Bt].value;
          return rt2;
        }
        function dh(rt2, yr) {
          for (var Bt, vn = -1, ba = rt2.length; ++vn < ba; ) {
            var Ci = yr(rt2[vn]);
            Ci !== P && (Bt = Bt === P ? Ci : Bt + Ci);
          }
          return Bt;
        }
        function cv(rt2, yr) {
          for (var Bt = -1, vn = Array(rt2); ++Bt < rt2; )
            vn[Bt] = yr(Bt);
          return vn;
        }
        function Op(rt2, yr) {
          return Sa(yr, function(Bt) {
            return [Bt, rt2[Bt]];
          });
        }
        function kp(rt2) {
          return rt2 && rt2.slice(0, ii(rt2) + 1).replace(Hl, "");
        }
        function eu(rt2) {
          return function(yr) {
            return rt2(yr);
          };
        }
        function fd(rt2, yr) {
          return Sa(yr, function(Bt) {
            return rt2[Bt];
          });
        }
        function ph(rt2, yr) {
          return rt2.has(yr);
        }
        function i_(rt2, yr) {
          for (var Bt = -1, vn = rt2.length; ++Bt < vn && hh(yr, rt2[Bt], 0) > -1; )
            ;
          return Bt;
        }
        function gh(rt2, yr) {
          for (var Bt = rt2.length; Bt-- && hh(yr, rt2[Bt], 0) > -1; )
            ;
          return Bt;
        }
        function fv(rt2, yr) {
          for (var Bt = rt2.length, vn = 0; Bt--; )
            rt2[Bt] === yr && ++vn;
          return vn;
        }
        var ES = Ip(cm), AS = Ip(Q1);
        function bm(rt2) {
          return "\\" + xS[rt2];
        }
        function o_(rt2, yr) {
          return rt2 == null ? P : rt2[yr];
        }
        function Vs(rt2) {
          return _S.test(rt2);
        }
        function s_(rt2) {
          return lm.test(rt2);
        }
        function _m(rt2) {
          for (var yr, Bt = []; !(yr = rt2.next()).done; )
            Bt.push(yr.value);
          return Bt;
        }
        function xm(rt2) {
          var yr = -1, Bt = Array(rt2.size);
          return rt2.forEach(function(vn, ba) {
            Bt[++yr] = [ba, vn];
          }), Bt;
        }
        function u_(rt2, yr) {
          return function(Bt) {
            return rt2(yr(Bt));
          };
        }
        function yh(rt2, yr) {
          for (var Bt = -1, vn = rt2.length, ba = 0, Ci = []; ++Bt < vn; ) {
            var Ms = rt2[Bt];
            (Ms === yr || Ms === de) && (rt2[Bt] = de, Ci[ba++] = Bt);
          }
          return Ci;
        }
        function o0(rt2) {
          var yr = -1, Bt = Array(rt2.size);
          return rt2.forEach(function(vn) {
            Bt[++yr] = vn;
          }), Bt;
        }
        function TS(rt2) {
          var yr = -1, Bt = Array(rt2.size);
          return rt2.forEach(function(vn) {
            Bt[++yr] = [vn, vn];
          }), Bt;
        }
        function l_(rt2, yr, Bt) {
          for (var vn = Bt - 1, ba = rt2.length; ++vn < ba; )
            if (rt2[vn] === yr)
              return vn;
          return -1;
        }
        function MS(rt2, yr, Bt) {
          for (var vn = Bt + 1; vn--; )
            if (rt2[vn] === yr)
              return vn;
          return vn;
        }
        function Na(rt2) {
          return Vs(rt2) ? wm(rt2) : ym(rt2);
        }
        function yu(rt2) {
          return Vs(rt2) ? mh(rt2) : n0(rt2);
        }
        function ii(rt2) {
          for (var yr = rt2.length; yr-- && wp.test(rt2.charAt(yr)); )
            ;
          return yr;
        }
        var Rp = Ip(fm);
        function wm(rt2) {
          for (var yr = Ep.lastIndex = 0; Ep.test(rt2); )
            ++yr;
          return yr;
        }
        function mh(rt2) {
          return rt2.match(Ep) || [];
        }
        function Yn(rt2) {
          return rt2.match(X1) || [];
        }
        var c_ = function rt2(yr) {
          yr = yr == null ? As : Yo.defaults(As.Object(), yr, Yo.pick(As, Cc));
          var Bt = yr.Array, vn = yr.Date, ba = yr.Error, Ci = yr.Function, Ms = yr.Math, Yi = yr.Object, Fp = yr.RegExp, PS = yr.String, Ko = yr.TypeError, tu = Bt.prototype, s0 = Ci.prototype, la = Yi.prototype, xo = yr["__core-js_shared__"], hd = s0.toString, Ki = la.hasOwnProperty, f_ = 0, h_ = function() {
            var g9 = /[^.]+$/.exec(xo && xo.keys && xo.keys.IE_PROTO || "");
            return g9 ? "Symbol(src)_1." + g9 : "";
          }(), u0 = la.toString, DS = hd.call(Yi), v_ = As._, Sm = Fp("^" + hd.call(Ki).replace(bc, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), Pf = r_ ? yr.Buffer : P, Uc = yr.Symbol, vd = yr.Uint8Array, hv = Pf ? Pf.allocUnsafe : P, vv = u_(Yi.getPrototypeOf, Yi), sl = Yi.create, Kl = la.propertyIsEnumerable, l0 = tu.splice, d_ = Uc ? Uc.isConcatSpreadable : P, Va = Uc ? Uc.iterator : P, dv = Uc ? Uc.toStringTag : P, c0 = function() {
            try {
              var g9 = It(Yi, "defineProperty");
              return g9({}, "", {}), g9;
            } catch {
            }
          }(), p_ = yr.clearTimeout !== As.clearTimeout && yr.clearTimeout, Df = vn && vn.now !== As.Date.now && vn.now, La = yr.setTimeout !== As.setTimeout && yr.setTimeout, Np = Ms.ceil, Ru = Ms.floor, f0 = Yi.getOwnPropertySymbols, IS = Pf ? Pf.isBuffer : P, Ri = yr.isFinite, LS = tu.join, g_ = u_(Yi.keys, Yi), Zo = Ms.max, mu = Ms.min, Cm = vn.now, OS = yr.parseInt, dd = Ms.random, Em = tu.reverse, Vp = It(yr, "DataView"), If = It(yr, "Map"), Fu = It(yr, "Promise"), pv = It(yr, "Set"), pd = It(yr, "WeakMap"), jp = It(Yi, "create"), Bp = pd && new pd(), gd = {}, Xo = Ht(Vp), yd = Ht(If), Lf = Ht(Fu), y_ = Ht(pv), zp = Ht(pd), $p = Uc ? Uc.prototype : P, Wo = $p ? $p.valueOf : P, js = $p ? $p.toString : P;
          function xe(g9) {
            if (ps(g9) && !kr(g9) && !(g9 instanceof oi)) {
              if (g9 instanceof ul)
                return g9;
              if (Ki.call(g9, "__wrapped__"))
                return jr(g9);
            }
            return new ul(g9);
          }
          var md = function() {
            function g9() {
            }
            return function(w9) {
              if (!Vo(w9))
                return {};
              if (sl)
                return sl(w9);
              g9.prototype = w9;
              var R = new g9();
              return g9.prototype = P, R;
            };
          }();
          function h0() {
          }
          function ul(g9, w9) {
            this.__wrapped__ = g9, this.__actions__ = [], this.__chain__ = !!w9, this.__index__ = 0, this.__values__ = P;
          }
          xe.templateSettings = { escape: Js, evaluate: al, interpolate: Ou, variable: "", imports: { _: xe } }, xe.prototype = h0.prototype, xe.prototype.constructor = xe, ul.prototype = md(h0.prototype), ul.prototype.constructor = ul;
          function oi(g9) {
            this.__wrapped__ = g9, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = Yr, this.__views__ = [];
          }
          function kS() {
            var g9 = new oi(this.__wrapped__);
            return g9.__actions__ = se(this.__actions__), g9.__dir__ = this.__dir__, g9.__filtered__ = this.__filtered__, g9.__iteratees__ = se(this.__iteratees__), g9.__takeCount__ = this.__takeCount__, g9.__views__ = se(this.__views__), g9;
          }
          function Am() {
            if (this.__filtered__) {
              var g9 = new oi(this);
              g9.__dir__ = -1, g9.__filtered__ = true;
            } else
              g9 = this.clone(), g9.__dir__ *= -1;
            return g9;
          }
          function v0() {
            var g9 = this.__wrapped__.value(), w9 = this.__dir__, R = kr(g9), K = w9 < 0, ce = R ? g9.length : 0, Te = ka(0, ce, this.__views__), Ue = Te.start, nt = Te.end, bt = nt - Ue, Er = K ? nt : Ue - 1, Mr = this.__iteratees__, $r = Mr.length, Qr = 0, Cn = mu(bt, this.__takeCount__);
            if (!R || !K && ce == bt && Cn == bt)
              return W(g9, this.__actions__);
            var Xn = [];
            e:
              for (; bt-- && Qr < Cn; ) {
                Er += w9;
                for (var Ga = -1, qn = g9[Er]; ++Ga < $r; ) {
                  var si = Mr[Ga], _i = si.iteratee, rc = si.type, Gu = _i(qn);
                  if (rc == ln)
                    qn = Gu;
                  else if (!Gu) {
                    if (rc == gn)
                      continue e;
                    break e;
                  }
                }
                Xn[Qr++] = qn;
              }
            return Xn;
          }
          oi.prototype = md(h0.prototype), oi.prototype.constructor = oi;
          function gv(g9) {
            var w9 = -1, R = g9 == null ? 0 : g9.length;
            for (this.clear(); ++w9 < R; ) {
              var K = g9[w9];
              this.set(K[0], K[1]);
            }
          }
          function RS() {
            this.__data__ = jp ? jp(null) : {}, this.size = 0;
          }
          function Tm(g9) {
            var w9 = this.has(g9) && delete this.__data__[g9];
            return this.size -= w9 ? 1 : 0, w9;
          }
          function m_(g9) {
            var w9 = this.__data__;
            if (jp) {
              var R = w9[g9];
              return R === Q ? P : R;
            }
            return Ki.call(w9, g9) ? w9[g9] : P;
          }
          function d0(g9) {
            var w9 = this.__data__;
            return jp ? w9[g9] !== P : Ki.call(w9, g9);
          }
          function FS(g9, w9) {
            var R = this.__data__;
            return this.size += this.has(g9) ? 0 : 1, R[g9] = jp && w9 === P ? Q : w9, this;
          }
          gv.prototype.clear = RS, gv.prototype.delete = Tm, gv.prototype.get = m_, gv.prototype.has = d0, gv.prototype.set = FS;
          function fs(g9) {
            var w9 = -1, R = g9 == null ? 0 : g9.length;
            for (this.clear(); ++w9 < R; ) {
              var K = g9[w9];
              this.set(K[0], K[1]);
            }
          }
          function b_() {
            this.__data__ = [], this.size = 0;
          }
          function Mm(g9) {
            var w9 = this.__data__, R = y0(w9, g9);
            if (R < 0)
              return false;
            var K = w9.length - 1;
            return R == K ? w9.pop() : l0.call(w9, R, 1), --this.size, true;
          }
          function yv(g9) {
            var w9 = this.__data__, R = y0(w9, g9);
            return R < 0 ? P : w9[R][1];
          }
          function NS(g9) {
            return y0(this.__data__, g9) > -1;
          }
          function VS(g9, w9) {
            var R = this.__data__, K = y0(R, g9);
            return K < 0 ? (++this.size, R.push([g9, w9])) : R[K][1] = w9, this;
          }
          fs.prototype.clear = b_, fs.prototype.delete = Mm, fs.prototype.get = yv, fs.prototype.has = NS, fs.prototype.set = VS;
          function Of(g9) {
            var w9 = -1, R = g9 == null ? 0 : g9.length;
            for (this.clear(); ++w9 < R; ) {
              var K = g9[w9];
              this.set(K[0], K[1]);
            }
          }
          function __() {
            this.size = 0, this.__data__ = { hash: new gv(), map: new (If || fs)(), string: new gv() };
          }
          function Pm(g9) {
            var w9 = mr(this, g9).delete(g9);
            return this.size -= w9 ? 1 : 0, w9;
          }
          function bd(g9) {
            return mr(this, g9).get(g9);
          }
          function x_(g9) {
            return mr(this, g9).has(g9);
          }
          function jS(g9, w9) {
            var R = mr(this, g9), K = R.size;
            return R.set(g9, w9), this.size += R.size == K ? 0 : 1, this;
          }
          Of.prototype.clear = __, Of.prototype.delete = Pm, Of.prototype.get = bd, Of.prototype.has = x_, Of.prototype.set = jS;
          function bh(g9) {
            var w9 = -1, R = g9 == null ? 0 : g9.length;
            for (this.__data__ = new Of(); ++w9 < R; )
              this.add(g9[w9]);
          }
          function Dm(g9) {
            return this.__data__.set(g9, Q), this;
          }
          function BS(g9) {
            return this.__data__.has(g9);
          }
          bh.prototype.add = bh.prototype.push = Dm, bh.prototype.has = BS;
          function Ec(g9) {
            var w9 = this.__data__ = new fs(g9);
            this.size = w9.size;
          }
          function zS() {
            this.__data__ = new fs(), this.size = 0;
          }
          function $S(g9) {
            var w9 = this.__data__, R = w9.delete(g9);
            return this.size = w9.size, R;
          }
          function p0(g9) {
            return this.__data__.get(g9);
          }
          function GS(g9) {
            return this.__data__.has(g9);
          }
          function WS(g9, w9) {
            var R = this.__data__;
            if (R instanceof fs) {
              var K = R.__data__;
              if (!If || K.length < L - 1)
                return K.push([g9, w9]), this.size = ++R.size, this;
              R = this.__data__ = new Of(K);
            }
            return R.set(g9, w9), this.size = R.size, this;
          }
          Ec.prototype.clear = zS, Ec.prototype.delete = $S, Ec.prototype.get = p0, Ec.prototype.has = GS, Ec.prototype.set = WS;
          function w_(g9, w9) {
            var R = kr(g9), K = !R && $t(g9), ce = !R && !K && xh(g9), Te = !R && !K && !ce && R0(g9), Ue = R || K || ce || Te, nt = Ue ? cv(g9.length, PS) : [], bt = nt.length;
            for (var Er in g9)
              (w9 || Ki.call(g9, Er)) && !(Ue && (Er == "length" || ce && (Er == "offset" || Er == "parent") || Te && (Er == "buffer" || Er == "byteLength" || Er == "byteOffset") || Gs(Er, bt))) && nt.push(Er);
            return nt;
          }
          function S_(g9) {
            var w9 = g9.length;
            return w9 ? g9[k2(0, w9 - 1)] : P;
          }
          function C_(g9, w9) {
            return Ne(se(g9), mv(w9, 0, g9.length));
          }
          function US(g9) {
            return Ne(se(g9));
          }
          function g0(g9, w9, R) {
            (R !== P && !vl(g9[w9], R) || R === P && !(w9 in g9)) && Ac(g9, w9, R);
          }
          function ru(g9, w9, R) {
            var K = g9[w9];
            (!(Ki.call(g9, w9) && vl(K, R)) || R === P && !(w9 in g9)) && Ac(g9, w9, R);
          }
          function y0(g9, w9) {
            for (var R = g9.length; R--; )
              if (vl(g9[R][0], w9))
                return R;
            return -1;
          }
          function E_(g9, w9, R, K) {
            return Hc(g9, function(ce, Te, Ue) {
              w9(K, ce, R(ce), Ue);
            }), K;
          }
          function A_(g9, w9) {
            return g9 && vt(w9, Hn(w9), g9);
          }
          function HS(g9, w9) {
            return g9 && vt(w9, tc(w9), g9);
          }
          function Ac(g9, w9, R) {
            w9 == "__proto__" && c0 ? c0(g9, w9, { configurable: true, enumerable: true, value: R, writable: true }) : g9[w9] = R;
          }
          function Im(g9, w9) {
            for (var R = -1, K = w9.length, ce = Bt(K), Te = g9 == null; ++R < K; )
              ce[R] = Te ? P : eg(g9, w9[R]);
            return ce;
          }
          function mv(g9, w9, R) {
            return g9 === g9 && (R !== P && (g9 = g9 <= R ? g9 : R), w9 !== P && (g9 = g9 >= w9 ? g9 : w9)), g9;
          }
          function Zl(g9, w9, R, K, ce, Te) {
            var Ue, nt = w9 & Ae, bt = w9 & We, Er = w9 & Xe;
            if (R && (Ue = ce ? R(g9, K, ce, Te) : R(g9)), Ue !== P)
              return Ue;
            if (!Vo(g9))
              return g9;
            var Mr = kr(g9);
            if (Mr) {
              if (Ue = So(g9), !nt)
                return se(g9, Ue);
            } else {
              var $r = Bn(g9), Qr = $r == is || $r == Xs;
              if (xh(g9))
                return ge(g9, nt);
              if ($r == os || $r == ua || Qr && !ce) {
                if (Ue = bt || Qr ? {} : ds(g9), !nt)
                  return bt ? ar(g9, HS(Ue, g9)) : Lt(g9, A_(Ue, g9));
              } else {
                if (!lo[$r])
                  return ce ? g9 : {};
                Ue = Co(g9, $r, nt);
              }
            }
            Te || (Te = new Ec());
            var Cn = Te.get(g9);
            if (Cn)
              return Cn;
            Te.set(g9, Ue), k0(g9) ? g9.forEach(function(qn) {
              Ue.add(Zl(qn, w9, R, qn, g9, Te));
            }) : mT(g9) && g9.forEach(function(qn, si) {
              Ue.set(si, Zl(qn, w9, R, si, g9, Te));
            });
            var Xn = Er ? bt ? Jl : Kc : bt ? tc : Hn, Ga = Mr ? P : Xn(g9);
            return ku(Ga || g9, function(qn, si) {
              Ga && (si = qn, qn = g9[si]), ru(Ue, si, Zl(qn, w9, R, si, g9, Te));
            }), Ue;
          }
          function qS(g9) {
            var w9 = Hn(g9);
            return function(R) {
              return m0(R, g9, w9);
            };
          }
          function m0(g9, w9, R) {
            var K = R.length;
            if (g9 == null)
              return !K;
            for (g9 = Yi(g9); K--; ) {
              var ce = R[K], Te = w9[ce], Ue = g9[ce];
              if (Ue === P && !(ce in g9) || !Te(Ue))
                return false;
            }
            return true;
          }
          function b0(g9, w9, R) {
            if (typeof g9 != "function")
              throw new Ko(J);
            return je(function() {
              g9.apply(P, R);
            }, w9);
          }
          function bv(g9, w9, R, K) {
            var ce = -1, Te = Mp, Ue = true, nt = g9.length, bt = [], Er = w9.length;
            if (!nt)
              return bt;
            R && (w9 = Sa(w9, eu(R))), K ? (Te = gm, Ue = false) : w9.length >= L && (Te = ph, Ue = false, w9 = new bh(w9));
            e:
              for (; ++ce < nt; ) {
                var Mr = g9[ce], $r = R == null ? Mr : R(Mr);
                if (Mr = K || Mr !== 0 ? Mr : 0, Ue && $r === $r) {
                  for (var Qr = Er; Qr--; )
                    if (w9[Qr] === $r)
                      continue e;
                  bt.push(Mr);
                } else
                  Te(w9, $r, K) || bt.push(Mr);
              }
            return bt;
          }
          var Hc = Ft(Tc), _d = Ft(x0, true);
          function YS(g9, w9) {
            var R = true;
            return Hc(g9, function(K, ce, Te) {
              return R = !!w9(K, ce, Te), R;
            }), R;
          }
          function xd(g9, w9, R) {
            for (var K = -1, ce = g9.length; ++K < ce; ) {
              var Te = g9[K], Ue = w9(Te);
              if (Ue != null && (nt === P ? Ue === Ue && !dl(Ue) : R(Ue, nt)))
                var nt = Ue, bt = Te;
            }
            return bt;
          }
          function KS(g9, w9, R, K) {
            var ce = g9.length;
            for (R = $a(R), R < 0 && (R = -R > ce ? 0 : ce + R), K = K === P || K > ce ? ce : $a(K), K < 0 && (K += ce), K = R > K ? 0 : wT(K); R < K; )
              g9[R++] = w9;
            return g9;
          }
          function kf(g9, w9) {
            var R = [];
            return Hc(g9, function(K, ce, Te) {
              w9(K, ce, Te) && R.push(K);
            }), R;
          }
          function Bs(g9, w9, R, K, ce) {
            var Te = -1, Ue = g9.length;
            for (R || (R = Il), ce || (ce = []); ++Te < Ue; ) {
              var nt = g9[Te];
              w9 > 0 && R(nt) ? w9 > 1 ? Bs(nt, w9 - 1, R, K, ce) : Yl(ce, nt) : K || (ce[ce.length] = nt);
            }
            return ce;
          }
          var bu = gr(), _0 = gr(true);
          function Tc(g9, w9) {
            return g9 && bu(g9, w9, Hn);
          }
          function x0(g9, w9) {
            return g9 && _0(g9, w9, Hn);
          }
          function Gp(g9, w9) {
            return Mf(w9, function(R) {
              return bi(g9[R]);
            });
          }
          function Rf(g9, w9) {
            w9 = Z(w9, g9);
            for (var R = 0, K = w9.length; g9 != null && R < K; )
              g9 = g9[or(w9[R++])];
            return R && R == K ? g9 : P;
          }
          function Wp(g9, w9, R) {
            var K = w9(g9);
            return kr(g9) ? K : Yl(K, R(g9));
          }
          function zs(g9) {
            return g9 == null ? g9 === P ? mc : nl : dv && dv in Yi(g9) ? Sr(g9) : Ed(g9);
          }
          function Up(g9, w9) {
            return g9 > w9;
          }
          function Kn(g9, w9) {
            return g9 != null && Ki.call(g9, w9);
          }
          function T_(g9, w9) {
            return g9 != null && w9 in Yi(g9);
          }
          function ZS(g9, w9, R) {
            return g9 >= mu(w9, R) && g9 < Zo(w9, R);
          }
          function Lm(g9, w9, R) {
            for (var K = R ? gm : Mp, ce = g9[0].length, Te = g9.length, Ue = Te, nt = Bt(Te), bt = 1 / 0, Er = []; Ue--; ) {
              var Mr = g9[Ue];
              Ue && w9 && (Mr = Sa(Mr, eu(w9))), bt = mu(Mr.length, bt), nt[Ue] = !R && (w9 || ce >= 120 && Mr.length >= 120) ? new bh(Ue && Mr) : P;
            }
            Mr = g9[0];
            var $r = -1, Qr = nt[0];
            e:
              for (; ++$r < ce && Er.length < bt; ) {
                var Cn = Mr[$r], Xn = w9 ? w9(Cn) : Cn;
                if (Cn = R || Cn !== 0 ? Cn : 0, !(Qr ? ph(Qr, Xn) : K(Er, Xn, R))) {
                  for (Ue = Te; --Ue; ) {
                    var Ga = nt[Ue];
                    if (!(Ga ? ph(Ga, Xn) : K(g9[Ue], Xn, R)))
                      continue e;
                  }
                  Qr && Qr.push(Xn), Er.push(Cn);
                }
              }
            return Er;
          }
          function M_(g9, w9, R, K) {
            return Tc(g9, function(ce, Te, Ue) {
              w9(K, R(ce), Te, Ue);
            }), K;
          }
          function wd(g9, w9, R) {
            w9 = Z(w9, g9), g9 = F_(g9, w9);
            var K = g9 == null ? g9 : g9[or(xu(w9))];
            return K == null ? P : Pl(K, g9, R);
          }
          function Hp(g9) {
            return ps(g9) && zs(g9) == ua;
          }
          function _v(g9) {
            return ps(g9) && zs(g9) == Rt;
          }
          function qp(g9) {
            return ps(g9) && zs(g9) == pi;
          }
          function qc(g9, w9, R, K, ce) {
            return g9 === w9 ? true : g9 == null || w9 == null || !ps(g9) && !ps(w9) ? g9 !== g9 && w9 !== w9 : XS(g9, w9, R, K, qc, ce);
          }
          function XS(g9, w9, R, K, ce, Te) {
            var Ue = kr(g9), nt = kr(w9), bt = Ue ? Pa : Bn(g9), Er = nt ? Pa : Bn(w9);
            bt = bt == ua ? os : bt, Er = Er == ua ? os : Er;
            var Mr = bt == os, $r = Er == os, Qr = bt == Er;
            if (Qr && xh(g9)) {
              if (!xh(w9))
                return false;
              Ue = true, Mr = false;
            }
            if (Qr && !Mr)
              return Te || (Te = new Ec()), Ue || R0(g9) ? Dl(g9, w9, R, K, ce, Te) : Ff(g9, w9, bt, R, K, ce, Te);
            if (!(R & Ze)) {
              var Cn = Mr && Ki.call(g9, "__wrapped__"), Xn = $r && Ki.call(w9, "__wrapped__");
              if (Cn || Xn) {
                var Ga = Cn ? g9.value() : g9, qn = Xn ? w9.value() : w9;
                return Te || (Te = new Ec()), ce(Ga, qn, R, K, Te);
              }
            }
            return Qr ? (Te || (Te = new Ec()), cl(g9, w9, R, K, ce, Te)) : false;
          }
          function P_(g9) {
            return ps(g9) && Bn(g9) == qo;
          }
          function Om(g9, w9, R, K) {
            var ce = R.length, Te = ce, Ue = !K;
            if (g9 == null)
              return !Te;
            for (g9 = Yi(g9); ce--; ) {
              var nt = R[ce];
              if (Ue && nt[2] ? nt[1] !== g9[nt[0]] : !(nt[0] in g9))
                return false;
            }
            for (; ++ce < Te; ) {
              nt = R[ce];
              var bt = nt[0], Er = g9[bt], Mr = nt[1];
              if (Ue && nt[2]) {
                if (Er === P && !(bt in g9))
                  return false;
              } else {
                var $r = new Ec();
                if (K)
                  var Qr = K(Er, Mr, bt, g9, w9, $r);
                if (!(Qr === P ? qc(Mr, Er, Ze | it, K, $r) : Qr))
                  return false;
              }
            }
            return true;
          }
          function xv(g9) {
            if (!Vo(g9) || Vu(g9))
              return false;
            var w9 = bi(g9) ? Sm : hr;
            return w9.test(Ht(g9));
          }
          function w0(g9) {
            return ps(g9) && zs(g9) == Iu;
          }
          function km(g9) {
            return ps(g9) && Bn(g9) == so;
          }
          function D_(g9) {
            return ps(g9) && Gm(g9.length) && !!_o[zs(g9)];
          }
          function I_(g9) {
            return typeof g9 == "function" ? g9 : g9 == null ? kl : typeof g9 == "object" ? kr(g9) ? Nm(g9[0], g9[1]) : Fm(g9) : BT(g9);
          }
          function S0(g9) {
            if (!_u(g9))
              return g_(g9);
            var w9 = [];
            for (var R in Yi(g9))
              Ki.call(g9, R) && R != "constructor" && w9.push(R);
            return w9;
          }
          function Rm(g9) {
            if (!Vo(g9))
              return e22(g9);
            var w9 = _u(g9), R = [];
            for (var K in g9)
              K == "constructor" && (w9 || !Ki.call(g9, K)) || R.push(K);
            return R;
          }
          function wv(g9, w9) {
            return g9 < w9;
          }
          function L_(g9, w9) {
            var R = -1, K = Ta(g9) ? Bt(g9.length) : [];
            return Hc(g9, function(ce, Te, Ue) {
              K[++R] = w9(ce, Te, Ue);
            }), K;
          }
          function Fm(g9) {
            var w9 = Vt(g9);
            return w9.length == 1 && w9[0][2] ? Ql(w9[0][0], w9[0][1]) : function(R) {
              return R === g9 || Om(R, g9, w9);
            };
          }
          function Nm(g9, w9) {
            return Qo(g9) && hl(w9) ? Ql(or(g9), w9) : function(R) {
              var K = eg(R, g9);
              return K === P && K === w9 ? we(R, g9) : qc(w9, K, Ze | it);
            };
          }
          function C0(g9, w9, R, K, ce) {
            g9 !== w9 && bu(w9, function(Te, Ue) {
              if (ce || (ce = new Ec()), Vo(Te))
                JS(g9, w9, Ue, R, C0, K, ce);
              else {
                var nt = K ? K(jm(g9, Ue), Te, Ue + "", g9, w9, ce) : P;
                nt === P && (nt = Te), g0(g9, Ue, nt);
              }
            }, tc);
          }
          function JS(g9, w9, R, K, ce, Te, Ue) {
            var nt = jm(g9, R), bt = jm(w9, R), Er = Ue.get(bt);
            if (Er) {
              g0(g9, R, Er);
              return;
            }
            var Mr = Te ? Te(nt, bt, R + "", g9, w9, Ue) : P, $r = Mr === P;
            if ($r) {
              var Qr = kr(bt), Cn = !Qr && xh(bt), Xn = !Qr && !Cn && R0(bt);
              Mr = bt, Qr || Cn || Xn ? kr(nt) ? Mr = nt : ei(nt) ? Mr = se(nt) : Cn ? ($r = false, Mr = ge(bt, true)) : Xn ? ($r = false, Mr = ut(bt, true)) : Mr = [] : L0(bt) || $t(bt) ? (Mr = nt, $t(nt) ? Mr = Bu(nt) : (!Vo(nt) || bi(nt)) && (Mr = ds(bt))) : $r = false;
            }
            $r && (Ue.set(bt, Mr), ce(Mr, bt, K, Te, Ue), Ue.delete(bt)), g0(g9, R, Mr);
          }
          function O_(g9, w9) {
            var R = g9.length;
            if (R)
              return w9 += w9 < 0 ? R : 0, Gs(w9, R) ? g9[w9] : P;
          }
          function Vm(g9, w9, R) {
            w9.length ? w9 = Sa(w9, function(Te) {
              return kr(Te) ? function(Ue) {
                return Rf(Ue, Te.length === 1 ? Te[0] : Te);
              } : Te;
            }) : w9 = [kl];
            var K = -1;
            w9 = Sa(w9, eu(Nn()));
            var ce = L_(g9, function(Te, Ue, nt) {
              var bt = Sa(w9, function(Er) {
                return Er(Te);
              });
              return { criteria: bt, index: ++K, value: Te };
            });
            return Lp(ce, function(Te, Ue) {
              return lr(Te, Ue, R);
            });
          }
          function Sd(g9, w9) {
            return k_(g9, w9, function(R, K) {
              return we(g9, K);
            });
          }
          function k_(g9, w9, R) {
            for (var K = -1, ce = w9.length, Te = {}; ++K < ce; ) {
              var Ue = w9[K], nt = Rf(g9, Ue);
              R(nt, Ue) && pt(Te, Z(Ue, g9), nt);
            }
            return Te;
          }
          function QS(g9) {
            return function(w9) {
              return Rf(w9, g9);
            };
          }
          function p2(g9, w9, R, K) {
            var ce = K ? mm : hh, Te = -1, Ue = w9.length, nt = g9;
            for (g9 === w9 && (w9 = se(w9)), R && (nt = Sa(g9, eu(R))); ++Te < Ue; )
              for (var bt = 0, Er = w9[Te], Mr = R ? R(Er) : Er; (bt = ce(nt, Mr, bt, K)) > -1; )
                nt !== g9 && l0.call(nt, bt, 1), l0.call(g9, bt, 1);
            return g9;
          }
          function x2(g9, w9) {
            for (var R = g9 ? w9.length : 0, K = R - 1; R--; ) {
              var ce = w9[R];
              if (R == K || ce !== Te) {
                var Te = ce;
                Gs(ce) ? l0.call(g9, ce, 1) : nu(g9, ce);
              }
            }
            return g9;
          }
          function k2(g9, w9) {
            return g9 + Ru(dd() * (w9 - g9 + 1));
          }
          function Y(g9, w9, R, K) {
            for (var ce = -1, Te = Zo(Np((w9 - g9) / (R || 1)), 0), Ue = Bt(Te); Te--; )
              Ue[K ? Te : ++ce] = g9, g9 += R;
            return Ue;
          }
          function ue(g9, w9) {
            var R = "";
            if (!g9 || w9 < 1 || w9 > ur)
              return R;
            do
              w9 % 2 && (R += g9), w9 = Ru(w9 / 2), w9 && (g9 += g9);
            while (w9);
            return R;
          }
          function me(g9, w9) {
            return Ge(R_(g9, w9, kl), g9 + "");
          }
          function Ye(g9) {
            return S_(B0(g9));
          }
          function tt(g9, w9) {
            var R = B0(g9);
            return Ne(R, mv(w9, 0, R.length));
          }
          function pt(g9, w9, R, K) {
            if (!Vo(g9))
              return g9;
            w9 = Z(w9, g9);
            for (var ce = -1, Te = w9.length, Ue = Te - 1, nt = g9; nt != null && ++ce < Te; ) {
              var bt = or(w9[ce]), Er = R;
              if (bt === "__proto__" || bt === "constructor" || bt === "prototype")
                return g9;
              if (ce != Ue) {
                var Mr = nt[bt];
                Er = K ? K(Mr, bt, nt) : P, Er === P && (Er = Vo(Mr) ? Mr : Gs(w9[ce + 1]) ? [] : {});
              }
              ru(nt, bt, Er), nt = nt[bt];
            }
            return g9;
          }
          var Cr = Bp ? function(g9, w9) {
            return Bp.set(g9, w9), g9;
          } : kl, Tr = c0 ? function(g9, w9) {
            return c0(g9, "toString", { configurable: true, enumerable: false, value: nf(w9), writable: true });
          } : kl;
          function Br(g9) {
            return Ne(B0(g9));
          }
          function Jr(g9, w9, R) {
            var K = -1, ce = g9.length;
            w9 < 0 && (w9 = -w9 > ce ? 0 : ce + w9), R = R > ce ? ce : R, R < 0 && (R += ce), ce = w9 > R ? 0 : R - w9 >>> 0, w9 >>>= 0;
            for (var Te = Bt(ce); ++K < ce; )
              Te[K] = g9[K + w9];
            return Te;
          }
          function Ln(g9, w9) {
            var R;
            return Hc(g9, function(K, ce, Te) {
              return R = w9(K, ce, Te), !R;
            }), !!R;
          }
          function $n(g9, w9, R) {
            var K = 0, ce = g9 == null ? K : g9.length;
            if (typeof w9 == "number" && w9 === w9 && ce <= Qn) {
              for (; K < ce; ) {
                var Te = K + ce >>> 1, Ue = g9[Te];
                Ue !== null && !dl(Ue) && (R ? Ue <= w9 : Ue < w9) ? K = Te + 1 : ce = Te;
              }
              return ce;
            }
            return _a2(g9, w9, kl, R);
          }
          function _a2(g9, w9, R, K) {
            var ce = 0, Te = g9 == null ? 0 : g9.length;
            if (Te === 0)
              return 0;
            w9 = R(w9);
            for (var Ue = w9 !== w9, nt = w9 === null, bt = dl(w9), Er = w9 === P; ce < Te; ) {
              var Mr = Ru((ce + Te) / 2), $r = R(g9[Mr]), Qr = $r !== P, Cn = $r === null, Xn = $r === $r, Ga = dl($r);
              if (Ue)
                var qn = K || Xn;
              else
                Er ? qn = Xn && (K || Qr) : nt ? qn = Xn && Qr && (K || !Cn) : bt ? qn = Xn && Qr && !Cn && (K || !Ga) : Cn || Ga ? qn = false : qn = K ? $r <= w9 : $r < w9;
              qn ? ce = Mr + 1 : Te = Mr;
            }
            return mu(Te, Vr);
          }
          function Un(g9, w9) {
            for (var R = -1, K = g9.length, ce = 0, Te = []; ++R < K; ) {
              var Ue = g9[R], nt = w9 ? w9(Ue) : Ue;
              if (!R || !vl(nt, bt)) {
                var bt = nt;
                Te[ce++] = Ue === 0 ? 0 : Ue;
              }
            }
            return Te;
          }
          function Ya(g9) {
            return typeof g9 == "number" ? g9 : dl(g9) ? zt : +g9;
          }
          function aa(g9) {
            if (typeof g9 == "string")
              return g9;
            if (kr(g9))
              return Sa(g9, aa) + "";
            if (dl(g9))
              return js ? js.call(g9) : "";
            var w9 = g9 + "";
            return w9 == "0" && 1 / g9 == -In ? "-0" : w9;
          }
          function hs(g9, w9, R) {
            var K = -1, ce = Mp, Te = g9.length, Ue = true, nt = [], bt = nt;
            if (R)
              Ue = false, ce = gm;
            else if (Te >= L) {
              var Er = w9 ? null : Fi(g9);
              if (Er)
                return o0(Er);
              Ue = false, ce = ph, bt = new bh();
            } else
              bt = w9 ? [] : nt;
            e:
              for (; ++K < Te; ) {
                var Mr = g9[K], $r = w9 ? w9(Mr) : Mr;
                if (Mr = R || Mr !== 0 ? Mr : 0, Ue && $r === $r) {
                  for (var Qr = bt.length; Qr--; )
                    if (bt[Qr] === $r)
                      continue e;
                  w9 && bt.push($r), nt.push(Mr);
                } else
                  ce(bt, $r, R) || (bt !== nt && bt.push($r), nt.push(Mr));
              }
            return nt;
          }
          function nu(g9, w9) {
            return w9 = Z(w9, g9), g9 = F_(g9, w9), g9 == null || delete g9[or(xu(w9))];
          }
          function ll(g9, w9, R, K) {
            return pt(g9, w9, R(Rf(g9, w9)), K);
          }
          function A2(g9, w9, R, K) {
            for (var ce = g9.length, Te = K ? ce : -1; (K ? Te-- : ++Te < ce) && w9(g9[Te], Te, g9); )
              ;
            return R ? Jr(g9, K ? 0 : Te, K ? Te + 1 : ce) : Jr(g9, K ? Te + 1 : 0, K ? ce : Te);
          }
          function W(g9, w9) {
            var R = g9;
            return R instanceof oi && (R = R.value()), lv(w9, function(K, ce) {
              return ce.func.apply(ce.thisArg, Yl([K], ce.args));
            }, R);
          }
          function D(g9, w9, R) {
            var K = g9.length;
            if (K < 2)
              return K ? hs(g9[0]) : [];
            for (var ce = -1, Te = Bt(K); ++ce < K; )
              for (var Ue = g9[ce], nt = -1; ++nt < K; )
                nt != ce && (Te[ce] = bv(Te[ce] || Ue, g9[nt], w9, R));
            return hs(Bs(Te, 1), w9, R);
          }
          function O(g9, w9, R) {
            for (var K = -1, ce = g9.length, Te = w9.length, Ue = {}; ++K < ce; ) {
              var nt = K < Te ? w9[K] : P;
              R(Ue, g9[K], nt);
            }
            return Ue;
          }
          function F(g9) {
            return ei(g9) ? g9 : [];
          }
          function B(g9) {
            return typeof g9 == "function" ? g9 : kl;
          }
          function Z(g9, w9) {
            return kr(g9) ? g9 : Qo(g9, w9) ? [g9] : Dt(ro(g9));
          }
          var re = me;
          function ie(g9, w9, R) {
            var K = g9.length;
            return R = R === P ? K : R, !w9 && R >= K ? g9 : Jr(g9, w9, R);
          }
          var ve = p_ || function(g9) {
            return As.clearTimeout(g9);
          };
          function ge(g9, w9) {
            if (w9)
              return g9.slice();
            var R = g9.length, K = hv ? hv(R) : new g9.constructor(R);
            return g9.copy(K), K;
          }
          function Pe(g9) {
            var w9 = new g9.constructor(g9.byteLength);
            return new vd(w9).set(new vd(g9)), w9;
          }
          function He(g9, w9) {
            var R = w9 ? Pe(g9.buffer) : g9.buffer;
            return new g9.constructor(R, g9.byteOffset, g9.byteLength);
          }
          function Qe(g9) {
            var w9 = new g9.constructor(g9.source, Oe.exec(g9));
            return w9.lastIndex = g9.lastIndex, w9;
          }
          function Je(g9) {
            return Wo ? Yi(Wo.call(g9)) : {};
          }
          function ut(g9, w9) {
            var R = w9 ? Pe(g9.buffer) : g9.buffer;
            return new g9.constructor(R, g9.byteOffset, g9.length);
          }
          function gt(g9, w9) {
            if (g9 !== w9) {
              var R = g9 !== P, K = g9 === null, ce = g9 === g9, Te = dl(g9), Ue = w9 !== P, nt = w9 === null, bt = w9 === w9, Er = dl(w9);
              if (!nt && !Er && !Te && g9 > w9 || Te && Ue && bt && !nt && !Er || K && Ue && bt || !R && bt || !ce)
                return 1;
              if (!K && !Te && !Er && g9 < w9 || Er && R && ce && !K && !Te || nt && R && ce || !Ue && ce || !bt)
                return -1;
            }
            return 0;
          }
          function lr(g9, w9, R) {
            for (var K = -1, ce = g9.criteria, Te = w9.criteria, Ue = ce.length, nt = R.length; ++K < Ue; ) {
              var bt = gt(ce[K], Te[K]);
              if (bt) {
                if (K >= nt)
                  return bt;
                var Er = R[K];
                return bt * (Er == "desc" ? -1 : 1);
              }
            }
            return g9.index - w9.index;
          }
          function tr(g9, w9, R, K) {
            for (var ce = -1, Te = g9.length, Ue = R.length, nt = -1, bt = w9.length, Er = Zo(Te - Ue, 0), Mr = Bt(bt + Er), $r = !K; ++nt < bt; )
              Mr[nt] = w9[nt];
            for (; ++ce < Ue; )
              ($r || ce < Te) && (Mr[R[ce]] = g9[ce]);
            for (; Er--; )
              Mr[nt++] = g9[ce++];
            return Mr;
          }
          function Gr(g9, w9, R, K) {
            for (var ce = -1, Te = g9.length, Ue = -1, nt = R.length, bt = -1, Er = w9.length, Mr = Zo(Te - nt, 0), $r = Bt(Mr + Er), Qr = !K; ++ce < Mr; )
              $r[ce] = g9[ce];
            for (var Cn = ce; ++bt < Er; )
              $r[Cn + bt] = w9[bt];
            for (; ++Ue < nt; )
              (Qr || ce < Te) && ($r[Cn + R[Ue]] = g9[ce++]);
            return $r;
          }
          function se(g9, w9) {
            var R = -1, K = g9.length;
            for (w9 || (w9 = Bt(K)); ++R < K; )
              w9[R] = g9[R];
            return w9;
          }
          function vt(g9, w9, R, K) {
            var ce = !R;
            R || (R = {});
            for (var Te = -1, Ue = w9.length; ++Te < Ue; ) {
              var nt = w9[Te], bt = K ? K(R[nt], g9[nt], nt, R, g9) : P;
              bt === P && (bt = g9[nt]), ce ? Ac(R, nt, bt) : ru(R, nt, bt);
            }
            return R;
          }
          function Lt(g9, w9) {
            return vt(g9, rn(g9), w9);
          }
          function ar(g9, w9) {
            return vt(g9, An(g9), w9);
          }
          function rr(g9, w9) {
            return function(R, K) {
              var ce = kr(R) ? wS : E_, Te = w9 ? w9() : {};
              return ce(R, g9, Nn(K, 2), Te);
            };
          }
          function Ct(g9) {
            return me(function(w9, R) {
              var K = -1, ce = R.length, Te = ce > 1 ? R[ce - 1] : P, Ue = ce > 2 ? R[2] : P;
              for (Te = g9.length > 3 && typeof Te == "function" ? (ce--, Te) : P, Ue && fo(R[0], R[1], Ue) && (Te = ce < 3 ? P : Te, ce = 1), w9 = Yi(w9); ++K < ce; ) {
                var nt = R[K];
                nt && g9(w9, nt, K, Te);
              }
              return w9;
            });
          }
          function Ft(g9, w9) {
            return function(R, K) {
              if (R == null)
                return R;
              if (!Ta(R))
                return g9(R, K);
              for (var ce = R.length, Te = w9 ? ce : -1, Ue = Yi(R); (w9 ? Te-- : ++Te < ce) && K(Ue[Te], Te, Ue) !== false; )
                ;
              return R;
            };
          }
          function gr(g9) {
            return function(w9, R, K) {
              for (var ce = -1, Te = Yi(w9), Ue = K(w9), nt = Ue.length; nt--; ) {
                var bt = Ue[g9 ? nt : ++ce];
                if (R(Te[bt], bt, Te) === false)
                  break;
              }
              return w9;
            };
          }
          function Nr(g9, w9, R) {
            var K = w9 & ct, ce = fn(g9);
            function Te() {
              var Ue = this && this !== As && this instanceof Te ? ce : g9;
              return Ue.apply(K ? R : this, arguments);
            }
            return Te;
          }
          function mt(g9) {
            return function(w9) {
              w9 = ro(w9);
              var R = Vs(w9) ? yu(w9) : P, K = R ? R[0] : w9.charAt(0), ce = R ? ie(R, 1).join("") : w9.slice(1);
              return K[g9]() + ce;
            };
          }
          function dn(g9) {
            return function(w9) {
              return lv(NT(DT(w9).replace(um, "")), g9, "");
            };
          }
          function fn(g9) {
            return function() {
              var w9 = arguments;
              switch (w9.length) {
                case 0:
                  return new g9();
                case 1:
                  return new g9(w9[0]);
                case 2:
                  return new g9(w9[0], w9[1]);
                case 3:
                  return new g9(w9[0], w9[1], w9[2]);
                case 4:
                  return new g9(w9[0], w9[1], w9[2], w9[3]);
                case 5:
                  return new g9(w9[0], w9[1], w9[2], w9[3], w9[4]);
                case 6:
                  return new g9(w9[0], w9[1], w9[2], w9[3], w9[4], w9[5]);
                case 7:
                  return new g9(w9[0], w9[1], w9[2], w9[3], w9[4], w9[5], w9[6]);
              }
              var R = md(g9.prototype), K = g9.apply(R, w9);
              return Vo(K) ? K : R;
            };
          }
          function ir(g9, w9, R) {
            var K = fn(g9);
            function ce() {
              for (var Te = arguments.length, Ue = Bt(Te), nt = Te, bt = wo(ce); nt--; )
                Ue[nt] = arguments[nt];
              var Er = Te < 3 && Ue[0] !== bt && Ue[Te - 1] !== bt ? [] : yh(Ue, bt);
              if (Te -= Er.length, Te < R)
                return co(g9, w9, Wt, ce.placeholder, P, Ue, Er, P, P, R - Te);
              var Mr = this && this !== As && this instanceof ce ? K : g9;
              return Pl(Mr, this, Ue);
            }
            return ce;
          }
          function Vn(g9) {
            return function(w9, R, K) {
              var ce = Yi(w9);
              if (!Ta(w9)) {
                var Te = Nn(R, 3);
                w9 = Hn(w9), R = function(nt) {
                  return Te(ce[nt], nt, ce);
                };
              }
              var Ue = g9(w9, R, K);
              return Ue > -1 ? ce[Te ? w9[Ue] : Ue] : P;
            };
          }
          function fr(g9) {
            return Nu(function(w9) {
              var R = w9.length, K = R, ce = ul.prototype.thru;
              for (g9 && w9.reverse(); K--; ) {
                var Te = w9[K];
                if (typeof Te != "function")
                  throw new Ko(J);
                if (ce && !Ue && Ps(Te) == "wrapper")
                  var Ue = new ul([], true);
              }
              for (K = Ue ? K : R; ++K < R; ) {
                Te = w9[K];
                var nt = Ps(Te), bt = nt == "wrapper" ? us(Te) : P;
                bt && Ds(bt[0]) && bt[1] == (er | Or | _t | Kt) && !bt[4].length && bt[9] == 1 ? Ue = Ue[Ps(bt[0])].apply(Ue, bt[3]) : Ue = Te.length == 1 && Ds(Te) ? Ue[nt]() : Ue.thru(Te);
              }
              return function() {
                var Er = arguments, Mr = Er[0];
                if (Ue && Er.length == 1 && kr(Mr))
                  return Ue.plant(Mr).value();
                for (var $r = 0, Qr = R ? w9[$r].apply(this, Er) : Mr; ++$r < R; )
                  Qr = w9[$r].call(this, Qr);
                return Qr;
              };
            });
          }
          function Wt(g9, w9, R, K, ce, Te, Ue, nt, bt, Er) {
            var Mr = w9 & er, $r = w9 & ct, Qr = w9 & sr, Cn = w9 & (Or | le), Xn = w9 & St, Ga = Qr ? P : fn(g9);
            function qn() {
              for (var si = arguments.length, _i = Bt(si), rc = si; rc--; )
                _i[rc] = arguments[rc];
              if (Cn)
                var Gu = wo(qn), Rl = fv(_i, Gu);
              if (K && (_i = tr(_i, K, ce, Cn)), Te && (_i = Gr(_i, Te, Ue, Cn)), si -= Rl, Cn && si < Er) {
                var ho = yh(_i, Gu);
                return co(g9, w9, Wt, qn.placeholder, R, _i, ho, nt, bt, Er - si);
              }
              var jf = $r ? R : this, pl = Qr ? jf[g9] : g9;
              return si = _i.length, nt ? _i = t22(_i, nt) : Xn && si > 1 && _i.reverse(), Mr && bt < si && (_i.length = bt), this && this !== As && this instanceof qn && (pl = Ga || fn(pl)), pl.apply(jf, _i);
            }
            return qn;
          }
          function Ut(g9, w9) {
            return function(R, K) {
              return M_(R, g9, w9(K), {});
            };
          }
          function Kr(g9, w9) {
            return function(R, K) {
              var ce;
              if (R === P && K === P)
                return w9;
              if (R !== P && (ce = R), K !== P) {
                if (ce === P)
                  return K;
                typeof R == "string" || typeof K == "string" ? (R = aa(R), K = aa(K)) : (R = Ya(R), K = Ya(K)), ce = g9(R, K);
              }
              return ce;
            };
          }
          function zr(g9) {
            return Nu(function(w9) {
              return w9 = Sa(w9, eu(Nn())), me(function(R) {
                var K = this;
                return g9(w9, function(ce) {
                  return Pl(ce, K, R);
                });
              });
            });
          }
          function Zn(g9, w9) {
            w9 = w9 === P ? " " : aa(w9);
            var R = w9.length;
            if (R < 2)
              return R ? ue(w9, g9) : w9;
            var K = ue(w9, Np(g9 / Na(w9)));
            return Vs(w9) ? ie(yu(K), 0, g9).join("") : K.slice(0, g9);
          }
          function gi(g9, w9, R, K) {
            var ce = w9 & ct, Te = fn(g9);
            function Ue() {
              for (var nt = -1, bt = arguments.length, Er = -1, Mr = K.length, $r = Bt(Mr + bt), Qr = this && this !== As && this instanceof Ue ? Te : g9; ++Er < Mr; )
                $r[Er] = K[Er];
              for (; bt--; )
                $r[Er++] = arguments[++nt];
              return Pl(Qr, ce ? R : this, $r);
            }
            return Ue;
          }
          function Ja(g9) {
            return function(w9, R, K) {
              return K && typeof K != "number" && fo(w9, R, K) && (R = K = P), w9 = Sh(w9), R === P ? (R = w9, w9 = 0) : R = Sh(R), K = K === P ? w9 < R ? 1 : -1 : Sh(K), Y(w9, R, K, g9);
            };
          }
          function Oa(g9) {
            return function(w9, R) {
              return typeof w9 == "string" && typeof R == "string" || (w9 = to(w9), R = to(R)), g9(w9, R);
            };
          }
          function co(g9, w9, R, K, ce, Te, Ue, nt, bt, Er) {
            var Mr = w9 & Or, $r = Mr ? Ue : P, Qr = Mr ? P : Ue, Cn = Mr ? Te : P, Xn = Mr ? P : Te;
            w9 |= Mr ? _t : Pt, w9 &= ~(Mr ? Pt : _t), w9 & Yt || (w9 &= ~(ct | sr));
            var Ga = [g9, w9, ce, Cn, $r, Xn, Qr, nt, bt, Er], qn = R.apply(P, Ga);
            return Ds(g9) && Yp(qn, Ga), qn.placeholder = K, Ce(qn, g9, w9);
          }
          function Qa(g9) {
            var w9 = Ms[g9];
            return function(R, K) {
              if (R = to(R), K = K == null ? 0 : mu($a(K), 292), K && Ri(R)) {
                var ce = (ro(R) + "e").split("e"), Te = w9(ce[0] + "e" + (+ce[1] + K));
                return ce = (ro(Te) + "e").split("e"), +(ce[0] + "e" + (+ce[1] - K));
              }
              return w9(R);
            };
          }
          var Fi = pv && 1 / o0(new pv([, -0]))[1] == In ? function(g9) {
            return new pv(g9);
          } : ig;
          function Jo(g9) {
            return function(w9) {
              var R = Bn(w9);
              return R == qo ? xm(w9) : R == so ? TS(w9) : Op(w9, g9(w9));
            };
          }
          function vs(g9, w9, R, K, ce, Te, Ue, nt) {
            var bt = w9 & sr;
            if (!bt && typeof g9 != "function")
              throw new Ko(J);
            var Er = K ? K.length : 0;
            if (Er || (w9 &= ~(_t | Pt), K = ce = P), Ue = Ue === P ? Ue : Zo($a(Ue), 0), nt = nt === P ? nt : $a(nt), Er -= ce ? ce.length : 0, w9 & Pt) {
              var Mr = K, $r = ce;
              K = ce = P;
            }
            var Qr = bt ? P : us(g9), Cn = [g9, w9, R, K, ce, Mr, $r, Te, Ue, nt];
            if (Qr && Sv(Cn, Qr), g9 = Cn[0], w9 = Cn[1], R = Cn[2], K = Cn[3], ce = Cn[4], nt = Cn[9] = Cn[9] === P ? bt ? 0 : g9.length : Zo(Cn[9] - Er, 0), !nt && w9 & (Or | le) && (w9 &= ~(Or | le)), !w9 || w9 == ct)
              var Xn = Nr(g9, w9, R);
            else
              w9 == Or || w9 == le ? Xn = ir(g9, w9, nt) : (w9 == _t || w9 == (ct | _t)) && !ce.length ? Xn = gi(g9, w9, R, K) : Xn = Wt.apply(P, Cn);
            var Ga = Qr ? Cr : Yp;
            return Ce(Ga(Xn, Cn), g9, w9);
          }
          function Xl(g9, w9, R, K) {
            return g9 === P || vl(g9, la[R]) && !Ki.call(K, R) ? w9 : g9;
          }
          function Yc(g9, w9, R, K, ce, Te) {
            return Vo(g9) && Vo(w9) && (Te.set(w9, g9), C0(g9, w9, P, Yc, Te), Te.delete(w9)), g9;
          }
          function $s(g9) {
            return L0(g9) ? P : g9;
          }
          function Dl(g9, w9, R, K, ce, Te) {
            var Ue = R & Ze, nt = g9.length, bt = w9.length;
            if (nt != bt && !(Ue && bt > nt))
              return false;
            var Er = Te.get(g9), Mr = Te.get(w9);
            if (Er && Mr)
              return Er == w9 && Mr == g9;
            var $r = -1, Qr = true, Cn = R & it ? new bh() : P;
            for (Te.set(g9, w9), Te.set(w9, g9); ++$r < nt; ) {
              var Xn = g9[$r], Ga = w9[$r];
              if (K)
                var qn = Ue ? K(Ga, Xn, $r, w9, g9, Te) : K(Xn, Ga, $r, g9, w9, Te);
              if (qn !== P) {
                if (qn)
                  continue;
                Qr = false;
                break;
              }
              if (Cn) {
                if (!Dp(w9, function(si, _i) {
                  if (!ph(Cn, _i) && (Xn === si || ce(Xn, si, R, K, Te)))
                    return Cn.push(_i);
                })) {
                  Qr = false;
                  break;
                }
              } else if (!(Xn === Ga || ce(Xn, Ga, R, K, Te))) {
                Qr = false;
                break;
              }
            }
            return Te.delete(g9), Te.delete(w9), Qr;
          }
          function Ff(g9, w9, R, K, ce, Te, Ue) {
            switch (R) {
              case _r:
                if (g9.byteLength != w9.byteLength || g9.byteOffset != w9.byteOffset)
                  return false;
                g9 = g9.buffer, w9 = w9.buffer;
              case Rt:
                return !(g9.byteLength != w9.byteLength || !Te(new vd(g9), new vd(w9)));
              case Ha:
              case pi:
              case du:
                return vl(+g9, +w9);
              case rl:
                return g9.name == w9.name && g9.message == w9.message;
              case Iu:
              case Fs:
                return g9 == w9 + "";
              case qo:
                var nt = xm;
              case so:
                var bt = K & Ze;
                if (nt || (nt = o0), g9.size != w9.size && !bt)
                  return false;
                var Er = Ue.get(g9);
                if (Er)
                  return Er == w9;
                K |= it, Ue.set(g9, w9);
                var Mr = Dl(nt(g9), nt(w9), K, ce, Te, Ue);
                return Ue.delete(g9), Mr;
              case Oo:
                if (Wo)
                  return Wo.call(g9) == Wo.call(w9);
            }
            return false;
          }
          function cl(g9, w9, R, K, ce, Te) {
            var Ue = R & Ze, nt = Kc(g9), bt = nt.length, Er = Kc(w9), Mr = Er.length;
            if (bt != Mr && !Ue)
              return false;
            for (var $r = bt; $r--; ) {
              var Qr = nt[$r];
              if (!(Ue ? Qr in w9 : Ki.call(w9, Qr)))
                return false;
            }
            var Cn = Te.get(g9), Xn = Te.get(w9);
            if (Cn && Xn)
              return Cn == w9 && Xn == g9;
            var Ga = true;
            Te.set(g9, w9), Te.set(w9, g9);
            for (var qn = Ue; ++$r < bt; ) {
              Qr = nt[$r];
              var si = g9[Qr], _i = w9[Qr];
              if (K)
                var rc = Ue ? K(_i, si, Qr, w9, g9, Te) : K(si, _i, Qr, g9, w9, Te);
              if (!(rc === P ? si === _i || ce(si, _i, R, K, Te) : rc)) {
                Ga = false;
                break;
              }
              qn || (qn = Qr == "constructor");
            }
            if (Ga && !qn) {
              var Gu = g9.constructor, Rl = w9.constructor;
              Gu != Rl && "constructor" in g9 && "constructor" in w9 && !(typeof Gu == "function" && Gu instanceof Gu && typeof Rl == "function" && Rl instanceof Rl) && (Ga = false);
            }
            return Te.delete(g9), Te.delete(w9), Ga;
          }
          function Nu(g9) {
            return Ge(R_(g9, P, Ad), g9 + "");
          }
          function Kc(g9) {
            return Wp(g9, Hn, rn);
          }
          function Jl(g9) {
            return Wp(g9, tc, An);
          }
          var us = Bp ? function(g9) {
            return Bp.get(g9);
          } : ig;
          function Ps(g9) {
            for (var w9 = g9.name + "", R = gd[w9], K = Ki.call(gd, w9) ? R.length : 0; K--; ) {
              var ce = R[K], Te = ce.func;
              if (Te == null || Te == g9)
                return ce.name;
            }
            return w9;
          }
          function wo(g9) {
            var w9 = Ki.call(xe, "placeholder") ? xe : g9;
            return w9.placeholder;
          }
          function Nn() {
            var g9 = xe.iteratee || $u;
            return g9 = g9 === $u ? I_ : g9, arguments.length ? g9(arguments[0], arguments[1]) : g9;
          }
          function mr(g9, w9) {
            var R = g9.__data__;
            return yi(w9) ? R[typeof w9 == "string" ? "string" : "hash"] : R.map;
          }
          function Vt(g9) {
            for (var w9 = Hn(g9), R = w9.length; R--; ) {
              var K = w9[R], ce = g9[K];
              w9[R] = [K, ce, hl(ce)];
            }
            return w9;
          }
          function It(g9, w9) {
            var R = o_(g9, w9);
            return xv(R) ? R : P;
          }
          function Sr(g9) {
            var w9 = Ki.call(g9, dv), R = g9[dv];
            try {
              g9[dv] = P;
              var K = true;
            } catch {
            }
            var ce = u0.call(g9);
            return K && (w9 ? g9[dv] = R : delete g9[dv]), ce;
          }
          var rn = f0 ? function(g9) {
            return g9 == null ? [] : (g9 = Yi(g9), Mf(f0(g9), function(w9) {
              return Kl.call(g9, w9);
            }));
          } : T2, An = f0 ? function(g9) {
            for (var w9 = []; g9; )
              Yl(w9, rn(g9)), g9 = vv(g9);
            return w9;
          } : T2, Bn = zs;
          (Vp && Bn(new Vp(new ArrayBuffer(1))) != _r || If && Bn(new If()) != qo || Fu && Bn(Fu.resolve()) != Rn || pv && Bn(new pv()) != so || pd && Bn(new pd()) != nr) && (Bn = function(g9) {
            var w9 = zs(g9), R = w9 == os ? g9.constructor : P, K = R ? Ht(R) : "";
            if (K)
              switch (K) {
                case Xo:
                  return _r;
                case yd:
                  return qo;
                case Lf:
                  return Rn;
                case y_:
                  return so;
                case zp:
                  return nr;
              }
            return w9;
          });
          function ka(g9, w9, R) {
            for (var K = -1, ce = R.length; ++K < ce; ) {
              var Te = R[K], Ue = Te.size;
              switch (Te.type) {
                case "drop":
                  g9 += Ue;
                  break;
                case "dropRight":
                  w9 -= Ue;
                  break;
                case "take":
                  w9 = mu(w9, g9 + Ue);
                  break;
                case "takeRight":
                  g9 = Zo(g9, w9 - Ue);
                  break;
              }
            }
            return { start: g9, end: w9 };
          }
          function $i(g9) {
            var w9 = g9.match(od);
            return w9 ? w9[1].split(sd) : [];
          }
          function Fo(g9, w9, R) {
            w9 = Z(w9, g9);
            for (var K = -1, ce = w9.length, Te = false; ++K < ce; ) {
              var Ue = or(w9[K]);
              if (!(Te = g9 != null && R(g9, Ue)))
                break;
              g9 = g9[Ue];
            }
            return Te || ++K != ce ? Te : (ce = g9 == null ? 0 : g9.length, !!ce && Gm(ce) && Gs(Ue, ce) && (kr(g9) || $t(g9)));
          }
          function So(g9) {
            var w9 = g9.length, R = new g9.constructor(w9);
            return w9 && typeof g9[0] == "string" && Ki.call(g9, "index") && (R.index = g9.index, R.input = g9.input), R;
          }
          function ds(g9) {
            return typeof g9.constructor == "function" && !_u(g9) ? md(vv(g9)) : {};
          }
          function Co(g9, w9, R) {
            var K = g9.constructor;
            switch (w9) {
              case Rt:
                return Pe(g9);
              case Ha:
              case pi:
                return new K(+g9);
              case _r:
                return He(g9, R);
              case tn:
              case Sn:
              case Ca:
              case wa:
              case Di:
              case Mi:
              case Da:
              case ko:
              case uo:
                return ut(g9, R);
              case qo:
                return new K();
              case du:
              case Fs:
                return new K(g9);
              case Iu:
                return Qe(g9);
              case so:
                return new K();
              case Oo:
                return Je(g9);
            }
          }
          function fl(g9, w9) {
            var R = w9.length;
            if (!R)
              return g9;
            var K = R - 1;
            return w9[K] = (R > 1 ? "& " : "") + w9[K], w9 = w9.join(R > 2 ? ", " : " "), g9.replace(Qg, `{
/* [wrapped with ` + w9 + `] */
`);
          }
          function Il(g9) {
            return kr(g9) || $t(g9) || !!(d_ && g9 && g9[d_]);
          }
          function Gs(g9, w9) {
            var R = typeof g9;
            return w9 = w9 == null ? ur : w9, !!w9 && (R == "number" || R != "symbol" && lt2.test(g9)) && g9 > -1 && g9 % 1 == 0 && g9 < w9;
          }
          function fo(g9, w9, R) {
            if (!Vo(R))
              return false;
            var K = typeof w9;
            return (K == "number" ? Ta(R) && Gs(w9, R.length) : K == "string" && w9 in R) ? vl(R[w9], g9) : false;
          }
          function Qo(g9, w9) {
            if (kr(g9))
              return false;
            var R = typeof g9;
            return R == "number" || R == "symbol" || R == "boolean" || g9 == null || dl(g9) ? true : il.test(g9) || !pu.test(g9) || w9 != null && g9 in Yi(w9);
          }
          function yi(g9) {
            var w9 = typeof g9;
            return w9 == "string" || w9 == "number" || w9 == "symbol" || w9 == "boolean" ? g9 !== "__proto__" : g9 === null;
          }
          function Ds(g9) {
            var w9 = Ps(g9), R = xe[w9];
            if (typeof R != "function" || !(w9 in oi.prototype))
              return false;
            if (g9 === R)
              return true;
            var K = us(R);
            return !!K && g9 === K[0];
          }
          function Vu(g9) {
            return !!h_ && h_ in g9;
          }
          var Zc = xo ? bi : M2;
          function _u(g9) {
            var w9 = g9 && g9.constructor, R = typeof w9 == "function" && w9.prototype || la;
            return g9 === R;
          }
          function hl(g9) {
            return g9 === g9 && !Vo(g9);
          }
          function Ql(g9, w9) {
            return function(R) {
              return R == null ? false : R[g9] === w9 && (w9 !== P || g9 in Yi(R));
            };
          }
          function Cd(g9) {
            var w9 = Av(g9, function(K) {
              return R.size === he && R.clear(), K;
            }), R = w9.cache;
            return w9;
          }
          function Sv(g9, w9) {
            var R = g9[1], K = w9[1], ce = R | K, Te = ce < (ct | sr | er), Ue = K == er && R == Or || K == er && R == Kt && g9[7].length <= w9[8] || K == (er | Kt) && w9[7].length <= w9[8] && R == Or;
            if (!(Te || Ue))
              return g9;
            K & ct && (g9[2] = w9[2], ce |= R & ct ? 0 : Yt);
            var nt = w9[3];
            if (nt) {
              var bt = g9[3];
              g9[3] = bt ? tr(bt, nt, w9[4]) : nt, g9[4] = bt ? yh(g9[3], de) : w9[4];
            }
            return nt = w9[5], nt && (bt = g9[5], g9[5] = bt ? Gr(bt, nt, w9[6]) : nt, g9[6] = bt ? yh(g9[5], de) : w9[6]), nt = w9[7], nt && (g9[7] = nt), K & er && (g9[8] = g9[8] == null ? w9[8] : mu(g9[8], w9[8])), g9[9] == null && (g9[9] = w9[9]), g9[0] = w9[0], g9[1] = ce, g9;
          }
          function e22(g9) {
            var w9 = [];
            if (g9 != null)
              for (var R in Yi(g9))
                w9.push(R);
            return w9;
          }
          function Ed(g9) {
            return u0.call(g9);
          }
          function R_(g9, w9, R) {
            return w9 = Zo(w9 === P ? g9.length - 1 : w9, 0), function() {
              for (var K = arguments, ce = -1, Te = Zo(K.length - w9, 0), Ue = Bt(Te); ++ce < Te; )
                Ue[ce] = K[w9 + ce];
              ce = -1;
              for (var nt = Bt(w9 + 1); ++ce < w9; )
                nt[ce] = K[ce];
              return nt[w9] = R(Ue), Pl(g9, this, nt);
            };
          }
          function F_(g9, w9) {
            return w9.length < 2 ? g9 : Rf(g9, Jr(w9, 0, -1));
          }
          function t22(g9, w9) {
            for (var R = g9.length, K = mu(w9.length, R), ce = se(g9); K--; ) {
              var Te = w9[K];
              g9[K] = Gs(Te, R) ? ce[Te] : P;
            }
            return g9;
          }
          function jm(g9, w9) {
            if (!(w9 === "constructor" && typeof g9[w9] == "function") && w9 != "__proto__")
              return g9[w9];
          }
          var Yp = Re(Cr), je = La || function(g9, w9) {
            return As.setTimeout(g9, w9);
          }, Ge = Re(Tr);
          function Ce(g9, w9, R) {
            var K = w9 + "";
            return Ge(g9, fl(K, wt($i(K), R)));
          }
          function Re(g9) {
            var w9 = 0, R = 0;
            return function() {
              var K = Cm(), ce = ht - (K - R);
              if (R = K, ce > 0) {
                if (++w9 >= Ir)
                  return arguments[0];
              } else
                w9 = 0;
              return g9.apply(P, arguments);
            };
          }
          function Ne(g9, w9) {
            var R = -1, K = g9.length, ce = K - 1;
            for (w9 = w9 === P ? K : w9; ++R < w9; ) {
              var Te = k2(R, ce), Ue = g9[Te];
              g9[Te] = g9[R], g9[R] = Ue;
            }
            return g9.length = w9, g9;
          }
          var Dt = Cd(function(g9) {
            var w9 = [];
            return g9.charCodeAt(0) === 46 && w9.push(""), g9.replace(uh, function(R, K, ce, Te) {
              w9.push(ce ? Te.replace(ze, "$1") : K || R);
            }), w9;
          });
          function or(g9) {
            if (typeof g9 == "string" || dl(g9))
              return g9;
            var w9 = g9 + "";
            return w9 == "0" && 1 / g9 == -In ? "-0" : w9;
          }
          function Ht(g9) {
            if (g9 != null) {
              try {
                return hd.call(g9);
              } catch {
              }
              try {
                return g9 + "";
              } catch {
              }
            }
            return "";
          }
          function wt(g9, w9) {
            return ku(Ua, function(R) {
              var K = "_." + R[0];
              w9 & R[1] && !Mp(g9, K) && g9.push(K);
            }), g9.sort();
          }
          function jr(g9) {
            if (g9 instanceof oi)
              return g9.clone();
            var w9 = new ul(g9.__wrapped__, g9.__chain__);
            return w9.__actions__ = se(g9.__actions__), w9.__index__ = g9.__index__, w9.__values__ = g9.__values__, w9;
          }
          function Pn(g9, w9, R) {
            (R ? fo(g9, w9, R) : w9 === P) ? w9 = 1 : w9 = Zo($a(w9), 0);
            var K = g9 == null ? 0 : g9.length;
            if (!K || w9 < 1)
              return [];
            for (var ce = 0, Te = 0, Ue = Bt(Np(K / w9)); ce < K; )
              Ue[Te++] = Jr(g9, ce, ce += w9);
            return Ue;
          }
          function Ka(g9) {
            for (var w9 = -1, R = g9 == null ? 0 : g9.length, K = 0, ce = []; ++w9 < R; ) {
              var Te = g9[w9];
              Te && (ce[K++] = Te);
            }
            return ce;
          }
          function mi() {
            var g9 = arguments.length;
            if (!g9)
              return [];
            for (var w9 = Bt(g9 - 1), R = arguments[0], K = g9; K--; )
              w9[K - 1] = arguments[K];
            return Yl(kr(R) ? se(R) : [R], Bs(w9, 1));
          }
          var Qi = me(function(g9, w9) {
            return ei(g9) ? bv(g9, Bs(w9, 1, ei, true)) : [];
          }), za = me(function(g9, w9) {
            var R = xu(w9);
            return ei(R) && (R = P), ei(g9) ? bv(g9, Bs(w9, 1, ei, true), Nn(R, 2)) : [];
          }), eo = me(function(g9, w9) {
            var R = xu(w9);
            return ei(R) && (R = P), ei(g9) ? bv(g9, Bs(w9, 1, ei, true), P, R) : [];
          });
          function es(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            return K ? (w9 = R || w9 === P ? 1 : $a(w9), Jr(g9, w9 < 0 ? 0 : w9, K)) : [];
          }
          function ga(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            return K ? (w9 = R || w9 === P ? 1 : $a(w9), w9 = K - w9, Jr(g9, 0, w9 < 0 ? 0 : w9)) : [];
          }
          function Is(g9, w9) {
            return g9 && g9.length ? A2(g9, Nn(w9, 3), true, true) : [];
          }
          function Ll(g9, w9) {
            return g9 && g9.length ? A2(g9, Nn(w9, 3), true) : [];
          }
          function Nf(g9, w9, R, K) {
            var ce = g9 == null ? 0 : g9.length;
            return ce ? (R && typeof R != "number" && fo(g9, w9, R) && (R = 0, K = ce), KS(g9, w9, R, K)) : [];
          }
          function Kp(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            if (!K)
              return -1;
            var ce = R == null ? 0 : $a(R);
            return ce < 0 && (ce = Zo(K + ce, 0)), i0(g9, Nn(w9, 3), ce);
          }
          function Xc(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            if (!K)
              return -1;
            var ce = K - 1;
            return R !== P && (ce = $a(R), ce = R < 0 ? Zo(K + ce, 0) : mu(ce, K - 1)), i0(g9, Nn(w9, 3), ce, true);
          }
          function Ad(g9) {
            var w9 = g9 == null ? 0 : g9.length;
            return w9 ? Bs(g9, 1) : [];
          }
          function Cv(g9) {
            var w9 = g9 == null ? 0 : g9.length;
            return w9 ? Bs(g9, In) : [];
          }
          function au(g9, w9) {
            var R = g9 == null ? 0 : g9.length;
            return R ? (w9 = w9 === P ? 1 : $a(w9), Bs(g9, w9)) : [];
          }
          function _h(g9) {
            for (var w9 = -1, R = g9 == null ? 0 : g9.length, K = {}; ++w9 < R; ) {
              var ce = g9[w9];
              K[ce[0]] = ce[1];
            }
            return K;
          }
          function Td(g9) {
            return g9 && g9.length ? g9[0] : P;
          }
          function Ev(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            if (!K)
              return -1;
            var ce = R == null ? 0 : $a(R);
            return ce < 0 && (ce = Zo(K + ce, 0)), hh(g9, w9, ce);
          }
          function Zp(g9) {
            var w9 = g9 == null ? 0 : g9.length;
            return w9 ? Jr(g9, 0, -1) : [];
          }
          var Xp = me(function(g9) {
            var w9 = Sa(g9, F);
            return w9.length && w9[0] === g9[0] ? Lm(w9) : [];
          }), Bm = me(function(g9) {
            var w9 = xu(g9), R = Sa(g9, F);
            return w9 === xu(R) ? w9 = P : R.pop(), R.length && R[0] === g9[0] ? Lm(R, Nn(w9, 2)) : [];
          }), E0 = me(function(g9) {
            var w9 = xu(g9), R = Sa(g9, F);
            return w9 = typeof w9 == "function" ? w9 : P, w9 && R.pop(), R.length && R[0] === g9[0] ? Lm(R, P, w9) : [];
          });
          function A0(g9, w9) {
            return g9 == null ? "" : LS.call(g9, w9);
          }
          function xu(g9) {
            var w9 = g9 == null ? 0 : g9.length;
            return w9 ? g9[w9 - 1] : P;
          }
          function Md(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            if (!K)
              return -1;
            var ce = K;
            return R !== P && (ce = $a(R), ce = ce < 0 ? Zo(K + ce, 0) : mu(ce, K - 1)), w9 === w9 ? MS(g9, w9, ce) : i0(g9, zi, ce, true);
          }
          function zm(g9, w9) {
            return g9 && g9.length ? O_(g9, $a(w9)) : P;
          }
          var r22 = me(N_);
          function N_(g9, w9) {
            return g9 && g9.length && w9 && w9.length ? p2(g9, w9) : g9;
          }
          function T0(g9, w9, R) {
            return g9 && g9.length && w9 && w9.length ? p2(g9, w9, Nn(R, 2)) : g9;
          }
          function YA(g9, w9, R) {
            return g9 && g9.length && w9 && w9.length ? p2(g9, w9, P, R) : g9;
          }
          var KA = Nu(function(g9, w9) {
            var R = g9 == null ? 0 : g9.length, K = Im(g9, w9);
            return x2(g9, Sa(w9, function(ce) {
              return Gs(ce, R) ? +ce : ce;
            }).sort(gt)), K;
          });
          function WD(g9, w9) {
            var R = [];
            if (!(g9 && g9.length))
              return R;
            var K = -1, ce = [], Te = g9.length;
            for (w9 = Nn(w9, 3); ++K < Te; ) {
              var Ue = g9[K];
              w9(Ue, K, g9) && (R.push(Ue), ce.push(K));
            }
            return x2(g9, ce), R;
          }
          function V_(g9) {
            return g9 == null ? g9 : Em.call(g9);
          }
          function ZA(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            return K ? (R && typeof R != "number" && fo(g9, w9, R) ? (w9 = 0, R = K) : (w9 = w9 == null ? 0 : $a(w9), R = R === P ? K : $a(R)), Jr(g9, w9, R)) : [];
          }
          function XA(g9, w9) {
            return $n(g9, w9);
          }
          function JA(g9, w9, R) {
            return _a2(g9, w9, Nn(R, 2));
          }
          function UD(g9, w9) {
            var R = g9 == null ? 0 : g9.length;
            if (R) {
              var K = $n(g9, w9);
              if (K < R && vl(g9[K], w9))
                return K;
            }
            return -1;
          }
          function HD(g9, w9) {
            return $n(g9, w9, true);
          }
          function qD(g9, w9, R) {
            return _a2(g9, w9, Nn(R, 2), true);
          }
          function QA(g9, w9) {
            var R = g9 == null ? 0 : g9.length;
            if (R) {
              var K = $n(g9, w9, true) - 1;
              if (vl(g9[K], w9))
                return K;
            }
            return -1;
          }
          function YD(g9) {
            return g9 && g9.length ? Un(g9) : [];
          }
          function KD(g9, w9) {
            return g9 && g9.length ? Un(g9, Nn(w9, 2)) : [];
          }
          function ZD(g9) {
            var w9 = g9 == null ? 0 : g9.length;
            return w9 ? Jr(g9, 1, w9) : [];
          }
          function XD(g9, w9, R) {
            return g9 && g9.length ? (w9 = R || w9 === P ? 1 : $a(w9), Jr(g9, 0, w9 < 0 ? 0 : w9)) : [];
          }
          function n22(g9, w9, R) {
            var K = g9 == null ? 0 : g9.length;
            return K ? (w9 = R || w9 === P ? 1 : $a(w9), w9 = K - w9, Jr(g9, w9 < 0 ? 0 : w9, K)) : [];
          }
          function JD(g9, w9) {
            return g9 && g9.length ? A2(g9, Nn(w9, 3), false, true) : [];
          }
          function QD(g9, w9) {
            return g9 && g9.length ? A2(g9, Nn(w9, 3)) : [];
          }
          var eI = me(function(g9) {
            return hs(Bs(g9, 1, ei, true));
          }), tI = me(function(g9) {
            var w9 = xu(g9);
            return ei(w9) && (w9 = P), hs(Bs(g9, 1, ei, true), Nn(w9, 2));
          }), rI = me(function(g9) {
            var w9 = xu(g9);
            return w9 = typeof w9 == "function" ? w9 : P, hs(Bs(g9, 1, ei, true), P, w9);
          });
          function Uo(g9) {
            return g9 && g9.length ? hs(g9) : [];
          }
          function No(g9, w9) {
            return g9 && g9.length ? hs(g9, Nn(w9, 2)) : [];
          }
          function nI(g9, w9) {
            return w9 = typeof w9 == "function" ? w9 : P, g9 && g9.length ? hs(g9, P, w9) : [];
          }
          function a2(g9) {
            if (!(g9 && g9.length))
              return [];
            var w9 = 0;
            return g9 = Mf(g9, function(R) {
              if (ei(R))
                return w9 = Zo(R.length, w9), true;
            }), cv(w9, function(R) {
              return Sa(g9, vh(R));
            });
          }
          function eT(g9, w9) {
            if (!(g9 && g9.length))
              return [];
            var R = a2(g9);
            return w9 == null ? R : Sa(R, function(K) {
              return Pl(w9, P, K);
            });
          }
          var aI = me(function(g9, w9) {
            return ei(g9) ? bv(g9, w9) : [];
          }), iI = me(function(g9) {
            return D(Mf(g9, ei));
          }), oI = me(function(g9) {
            var w9 = xu(g9);
            return ei(w9) && (w9 = P), D(Mf(g9, ei), Nn(w9, 2));
          }), tT = me(function(g9) {
            var w9 = xu(g9);
            return w9 = typeof w9 == "function" ? w9 : P, D(Mf(g9, ei), P, w9);
          }), sI = me(a2);
          function ju(g9, w9) {
            return O(g9 || [], w9 || [], ru);
          }
          function i2(g9, w9) {
            return O(g9 || [], w9 || [], pt);
          }
          var Jp = me(function(g9) {
            var w9 = g9.length, R = w9 > 1 ? g9[w9 - 1] : P;
            return R = typeof R == "function" ? (g9.pop(), R) : P, eT(g9, R);
          });
          function o2(g9) {
            var w9 = xe(g9);
            return w9.__chain__ = true, w9;
          }
          function s2(g9, w9) {
            return w9(g9), g9;
          }
          function Ol(g9, w9) {
            return w9(g9);
          }
          var rT = Nu(function(g9) {
            var w9 = g9.length, R = w9 ? g9[0] : 0, K = this.__wrapped__, ce = function(Te) {
              return Im(Te, g9);
            };
            return w9 > 1 || this.__actions__.length || !(K instanceof oi) || !Gs(R) ? this.thru(ce) : (K = K.slice(R, +R + (w9 ? 1 : 0)), K.__actions__.push({ func: Ol, args: [ce], thisArg: P }), new ul(K, this.__chain__).thru(function(Te) {
              return w9 && !Te.length && Te.push(P), Te;
            }));
          });
          function nT() {
            return o2(this);
          }
          function aT() {
            return new ul(this.value(), this.__chain__);
          }
          function iT() {
            this.__values__ === P && (this.__values__ = xT(this.value()));
            var g9 = this.__index__ >= this.__values__.length, w9 = g9 ? P : this.__values__[this.__index__++];
            return { done: g9, value: w9 };
          }
          function oT() {
            return this;
          }
          function sT(g9) {
            for (var w9, R = this; R instanceof h0; ) {
              var K = jr(R);
              K.__index__ = 0, K.__values__ = P, w9 ? ce.__wrapped__ = K : w9 = K;
              var ce = K;
              R = R.__wrapped__;
            }
            return ce.__wrapped__ = g9, w9;
          }
          function Mc() {
            var g9 = this.__wrapped__;
            if (g9 instanceof oi) {
              var w9 = g9;
              return this.__actions__.length && (w9 = new oi(this)), w9 = w9.reverse(), w9.__actions__.push({ func: Ol, args: [V_], thisArg: P }), new ul(w9, this.__chain__);
            }
            return this.thru(V_);
          }
          function uI() {
            return W(this.__wrapped__, this.__actions__);
          }
          var Jc = rr(function(g9, w9, R) {
            Ki.call(g9, R) ? ++g9[R] : Ac(g9, R, 1);
          });
          function lI(g9, w9, R) {
            var K = kr(g9) ? pm : YS;
            return R && fo(g9, w9, R) && (w9 = P), K(g9, Nn(w9, 3));
          }
          function uT(g9, w9) {
            var R = kr(g9) ? Mf : kf;
            return R(g9, Nn(w9, 3));
          }
          var Pd = Vn(Kp), j_ = Vn(Xc);
          function u2(g9, w9) {
            return Bs($m(g9, w9), 1);
          }
          function ts(g9, w9) {
            return Bs($m(g9, w9), In);
          }
          function Dd(g9, w9, R) {
            return R = R === P ? 1 : $a(R), Bs($m(g9, w9), R);
          }
          function B_(g9, w9) {
            var R = kr(g9) ? ku : Hc;
            return R(g9, Nn(w9, 3));
          }
          function lT(g9, w9) {
            var R = kr(g9) ? SS : _d;
            return R(g9, Nn(w9, 3));
          }
          var l22 = rr(function(g9, w9, R) {
            Ki.call(g9, R) ? g9[R].push(w9) : Ac(g9, R, [w9]);
          });
          function cI(g9, w9, R, K) {
            g9 = Ta(g9) ? g9 : B0(g9), R = R && !K ? $a(R) : 0;
            var ce = g9.length;
            return R < 0 && (R = Zo(ce + R, 0)), wh(g9) ? R <= ce && g9.indexOf(w9, R) > -1 : !!ce && hh(g9, w9, R) > -1;
          }
          var fI = me(function(g9, w9, R) {
            var K = -1, ce = typeof w9 == "function", Te = Ta(g9) ? Bt(g9.length) : [];
            return Hc(g9, function(Ue) {
              Te[++K] = ce ? Pl(w9, Ue, R) : wd(Ue, w9, R);
            }), Te;
          }), hI = rr(function(g9, w9, R) {
            Ac(g9, R, w9);
          });
          function $m(g9, w9) {
            var R = kr(g9) ? Sa : L_;
            return R(g9, Nn(w9, 3));
          }
          function z_(g9, w9, R, K) {
            return g9 == null ? [] : (kr(w9) || (w9 = w9 == null ? [] : [w9]), R = K ? P : R, kr(R) || (R = R == null ? [] : [R]), Vm(g9, w9, R));
          }
          var M0 = rr(function(g9, w9, R) {
            g9[R ? 0 : 1].push(w9);
          }, function() {
            return [[], []];
          });
          function vI(g9, w9, R) {
            var K = kr(g9) ? lv : cd, ce = arguments.length < 3;
            return K(g9, Nn(w9, 4), R, ce, Hc);
          }
          function cT(g9, w9, R) {
            var K = kr(g9) ? Pp : cd, ce = arguments.length < 3;
            return K(g9, Nn(w9, 4), R, ce, _d);
          }
          function fT(g9, w9) {
            var R = kr(g9) ? Mf : kf;
            return R(g9, W_(Nn(w9, 3)));
          }
          function c22(g9) {
            var w9 = kr(g9) ? S_ : Ye;
            return w9(g9);
          }
          function f22(g9, w9, R) {
            (R ? fo(g9, w9, R) : w9 === P) ? w9 = 1 : w9 = $a(w9);
            var K = kr(g9) ? C_ : tt;
            return K(g9, w9);
          }
          function hT(g9) {
            var w9 = kr(g9) ? US : Br;
            return w9(g9);
          }
          function dI(g9) {
            if (g9 == null)
              return 0;
            if (Ta(g9))
              return wh(g9) ? Na(g9) : g9.length;
            var w9 = Bn(g9);
            return w9 == qo || w9 == so ? g9.size : S0(g9).length;
          }
          function h2(g9, w9, R) {
            var K = kr(g9) ? Dp : Ln;
            return R && fo(g9, w9, R) && (w9 = P), K(g9, Nn(w9, 3));
          }
          var v22 = me(function(g9, w9) {
            if (g9 == null)
              return [];
            var R = w9.length;
            return R > 1 && fo(g9, w9[0], w9[1]) ? w9 = [] : R > 2 && fo(w9[0], w9[1], w9[2]) && (w9 = [w9[0]]), Vm(g9, Bs(w9, 1), []);
          }), $_ = Df || function() {
            return As.Date.now();
          };
          function vT(g9, w9) {
            if (typeof w9 != "function")
              throw new Ko(J);
            return g9 = $a(g9), function() {
              if (--g9 < 1)
                return w9.apply(this, arguments);
            };
          }
          function ec(g9, w9, R) {
            return w9 = R ? P : w9, w9 = g9 && w9 == null ? g9.length : w9, vs(g9, er, P, P, P, P, w9);
          }
          function G_(g9, w9) {
            var R;
            if (typeof w9 != "function")
              throw new Ko(J);
            return g9 = $a(g9), function() {
              return --g9 > 0 && (R = w9.apply(this, arguments)), g9 <= 1 && (w9 = P), R;
            };
          }
          var Qp = me(function(g9, w9, R) {
            var K = ct;
            if (R.length) {
              var ce = yh(R, wo(Qp));
              K |= _t;
            }
            return vs(g9, K, w9, R, ce);
          }), d22 = me(function(g9, w9, R) {
            var K = ct | sr;
            if (R.length) {
              var ce = yh(R, wo(d22));
              K |= _t;
            }
            return vs(w9, K, g9, R, ce);
          });
          function p22(g9, w9, R) {
            w9 = R ? P : w9;
            var K = vs(g9, Or, P, P, P, P, P, w9);
            return K.placeholder = p22.placeholder, K;
          }
          function dT(g9, w9, R) {
            w9 = R ? P : w9;
            var K = vs(g9, le, P, P, P, P, P, w9);
            return K.placeholder = dT.placeholder, K;
          }
          function pT(g9, w9, R) {
            var K, ce, Te, Ue, nt, bt, Er = 0, Mr = false, $r = false, Qr = true;
            if (typeof g9 != "function")
              throw new Ko(J);
            w9 = to(w9) || 0, Vo(R) && (Mr = !!R.leading, $r = "maxWait" in R, Te = $r ? Zo(to(R.maxWait) || 0, w9) : Te, Qr = "trailing" in R ? !!R.trailing : Qr);
            function Cn(ho) {
              var jf = K, pl = ce;
              return K = ce = P, Er = ho, Ue = g9.apply(pl, jf), Ue;
            }
            function Xn(ho) {
              return Er = ho, nt = je(si, w9), Mr ? Cn(ho) : Ue;
            }
            function Ga(ho) {
              var jf = ho - bt, pl = ho - Er, k22 = w9 - jf;
              return $r ? mu(k22, Te - pl) : k22;
            }
            function qn(ho) {
              var jf = ho - bt, pl = ho - Er;
              return bt === P || jf >= w9 || jf < 0 || $r && pl >= Te;
            }
            function si() {
              var ho = $_();
              if (qn(ho))
                return _i(ho);
              nt = je(si, Ga(ho));
            }
            function _i(ho) {
              return nt = P, Qr && K ? Cn(ho) : (K = ce = P, Ue);
            }
            function rc() {
              nt !== P && ve(nt), Er = 0, K = bt = ce = nt = P;
            }
            function Gu() {
              return nt === P ? Ue : _i($_());
            }
            function Rl() {
              var ho = $_(), jf = qn(ho);
              if (K = arguments, ce = this, bt = ho, jf) {
                if (nt === P)
                  return Xn(bt);
                if ($r)
                  return ve(nt), nt = je(si, w9), Cn(bt);
              }
              return nt === P && (nt = je(si, w9)), Ue;
            }
            return Rl.cancel = rc, Rl.flush = Gu, Rl;
          }
          var pI = me(function(g9, w9) {
            return b0(g9, 1, w9);
          }), gI = me(function(g9, w9, R) {
            return b0(g9, to(w9) || 0, R);
          });
          function yI(g9) {
            return vs(g9, St);
          }
          function Av(g9, w9) {
            if (typeof g9 != "function" || w9 != null && typeof w9 != "function")
              throw new Ko(J);
            var R = function() {
              var K = arguments, ce = w9 ? w9.apply(this, K) : K[0], Te = R.cache;
              if (Te.has(ce))
                return Te.get(ce);
              var Ue = g9.apply(this, K);
              return R.cache = Te.set(ce, Ue) || Te, Ue;
            };
            return R.cache = new (Av.Cache || Of)(), R;
          }
          Av.Cache = Of;
          function W_(g9) {
            if (typeof g9 != "function")
              throw new Ko(J);
            return function() {
              var w9 = arguments;
              switch (w9.length) {
                case 0:
                  return !g9.call(this);
                case 1:
                  return !g9.call(this, w9[0]);
                case 2:
                  return !g9.call(this, w9[0], w9[1]);
                case 3:
                  return !g9.call(this, w9[0], w9[1], w9[2]);
              }
              return !g9.apply(this, w9);
            };
          }
          function mI(g9) {
            return G_(2, g9);
          }
          var g2 = re(function(g9, w9) {
            w9 = w9.length == 1 && kr(w9[0]) ? Sa(w9[0], eu(Nn())) : Sa(Bs(w9, 1), eu(Nn()));
            var R = w9.length;
            return me(function(K) {
              for (var ce = -1, Te = mu(K.length, R); ++ce < Te; )
                K[ce] = w9[ce].call(this, K[ce]);
              return Pl(g9, this, K);
            });
          }), U_ = me(function(g9, w9) {
            var R = yh(w9, wo(U_));
            return vs(g9, _t, P, w9, R);
          }), Tv = me(function(g9, w9) {
            var R = yh(w9, wo(Tv));
            return vs(g9, Pt, P, w9, R);
          }), H_ = Nu(function(g9, w9) {
            return vs(g9, Kt, P, P, P, w9);
          });
          function bI(g9, w9) {
            if (typeof g9 != "function")
              throw new Ko(J);
            return w9 = w9 === P ? w9 : $a(w9), me(g9, w9);
          }
          function _I(g9, w9) {
            if (typeof g9 != "function")
              throw new Ko(J);
            return w9 = w9 == null ? 0 : Zo($a(w9), 0), me(function(R) {
              var K = R[w9], ce = ie(R, 0, w9);
              return K && Yl(ce, K), Pl(g9, this, ce);
            });
          }
          function xI(g9, w9, R) {
            var K = true, ce = true;
            if (typeof g9 != "function")
              throw new Ko(J);
            return Vo(R) && (K = "leading" in R ? !!R.leading : K, ce = "trailing" in R ? !!R.trailing : ce), pT(g9, w9, { leading: K, maxWait: w9, trailing: ce });
          }
          function P0(g9) {
            return ec(g9, 1);
          }
          function Vf(g9, w9) {
            return U_(B(w9), g9);
          }
          function gT() {
            if (!arguments.length)
              return [];
            var g9 = arguments[0];
            return kr(g9) ? g9 : [g9];
          }
          function wI(g9) {
            return Zl(g9, Xe);
          }
          function SI(g9, w9) {
            return w9 = typeof w9 == "function" ? w9 : P, Zl(g9, Xe, w9);
          }
          function CI(g9) {
            return Zl(g9, Ae | Xe);
          }
          function EI(g9, w9) {
            return w9 = typeof w9 == "function" ? w9 : P, Zl(g9, Ae | Xe, w9);
          }
          function AI(g9, w9) {
            return w9 == null || m0(g9, w9, Hn(w9));
          }
          function vl(g9, w9) {
            return g9 === w9 || g9 !== g9 && w9 !== w9;
          }
          var yt = Oa(Up), br = Oa(function(g9, w9) {
            return g9 >= w9;
          }), $t = Hp(function() {
            return arguments;
          }()) ? Hp : function(g9) {
            return ps(g9) && Ki.call(g9, "callee") && !Kl.call(g9, "callee");
          }, kr = Bt.isArray, Aa = ld ? eu(ld) : _v;
          function Ta(g9) {
            return g9 != null && Gm(g9.length) && !bi(g9);
          }
          function ei(g9) {
            return ps(g9) && Ta(g9);
          }
          function Eo(g9) {
            return g9 === true || g9 === false || ps(g9) && zs(g9) == Ha;
          }
          var xh = IS || M2, TI = n_ ? eu(n_) : qp;
          function Qc(g9) {
            return ps(g9) && g9.nodeType === 1 && !L0(g9);
          }
          function q_(g9) {
            if (g9 == null)
              return true;
            if (Ta(g9) && (kr(g9) || typeof g9 == "string" || typeof g9.splice == "function" || xh(g9) || R0(g9) || $t(g9)))
              return !g9.length;
            var w9 = Bn(g9);
            if (w9 == qo || w9 == so)
              return !g9.size;
            if (_u(g9))
              return !S0(g9).length;
            for (var R in g9)
              if (Ki.call(g9, R))
                return false;
            return true;
          }
          function MI(g9, w9) {
            return qc(g9, w9);
          }
          function D0(g9, w9, R) {
            R = typeof R == "function" ? R : P;
            var K = R ? R(g9, w9) : P;
            return K === P ? qc(g9, w9, P, R) : !!K;
          }
          function I0(g9) {
            if (!ps(g9))
              return false;
            var w9 = zs(g9);
            return w9 == rl || w9 == Lo || typeof g9.message == "string" && typeof g9.name == "string" && !L0(g9);
          }
          function Y_(g9) {
            return typeof g9 == "number" && Ri(g9);
          }
          function bi(g9) {
            if (!Vo(g9))
              return false;
            var w9 = zs(g9);
            return w9 == is || w9 == Xs || w9 == qi || w9 == Tl;
          }
          function yT(g9) {
            return typeof g9 == "number" && g9 == $a(g9);
          }
          function Gm(g9) {
            return typeof g9 == "number" && g9 > -1 && g9 % 1 == 0 && g9 <= ur;
          }
          function Vo(g9) {
            var w9 = typeof g9;
            return g9 != null && (w9 == "object" || w9 == "function");
          }
          function ps(g9) {
            return g9 != null && typeof g9 == "object";
          }
          var mT = a_ ? eu(a_) : P_;
          function PI3(g9, w9) {
            return g9 === w9 || Om(g9, w9, Vt(w9));
          }
          function K_(g9, w9, R) {
            return R = typeof R == "function" ? R : P, Om(g9, w9, Vt(w9), R);
          }
          function Id(g9) {
            return y2(g9) && g9 != +g9;
          }
          function Z_(g9) {
            if (Zc(g9))
              throw new ba(j);
            return xv(g9);
          }
          function bT(g9) {
            return g9 === null;
          }
          function X_(g9) {
            return g9 == null;
          }
          function y2(g9) {
            return typeof g9 == "number" || ps(g9) && zs(g9) == du;
          }
          function L0(g9) {
            if (!ps(g9) || zs(g9) != os)
              return false;
            var w9 = vv(g9);
            if (w9 === null)
              return true;
            var R = Ki.call(w9, "constructor") && w9.constructor;
            return typeof R == "function" && R instanceof R && hd.call(R) == DS;
          }
          var O0 = Tp ? eu(Tp) : w0;
          function _T(g9) {
            return yT(g9) && g9 >= -ur && g9 <= ur;
          }
          var k0 = r0 ? eu(r0) : km;
          function wh(g9) {
            return typeof g9 == "string" || !kr(g9) && ps(g9) && zs(g9) == Fs;
          }
          function dl(g9) {
            return typeof g9 == "symbol" || ps(g9) && zs(g9) == Oo;
          }
          var R0 = dm ? eu(dm) : D_;
          function DI(g9) {
            return g9 === P;
          }
          function II(g9) {
            return ps(g9) && Bn(g9) == nr;
          }
          function J_(g9) {
            return ps(g9) && zs(g9) == Nt;
          }
          var Q_ = Oa(wv), m22 = Oa(function(g9, w9) {
            return g9 <= w9;
          });
          function xT(g9) {
            if (!g9)
              return [];
            if (Ta(g9))
              return wh(g9) ? yu(g9) : se(g9);
            if (Va && g9[Va])
              return _m(g9[Va]());
            var w9 = Bn(g9), R = w9 == qo ? xm : w9 == so ? o0 : B0;
            return R(g9);
          }
          function Sh(g9) {
            if (!g9)
              return g9 === 0 ? g9 : 0;
            if (g9 = to(g9), g9 === In || g9 === -In) {
              var w9 = g9 < 0 ? -1 : 1;
              return w9 * Gt;
            }
            return g9 === g9 ? g9 : 0;
          }
          function $a(g9) {
            var w9 = Sh(g9), R = w9 % 1;
            return w9 === w9 ? R ? w9 - R : w9 : 0;
          }
          function wT(g9) {
            return g9 ? mv($a(g9), 0, Yr) : 0;
          }
          function to(g9) {
            if (typeof g9 == "number")
              return g9;
            if (dl(g9))
              return zt;
            if (Vo(g9)) {
              var w9 = typeof g9.valueOf == "function" ? g9.valueOf() : g9;
              g9 = Vo(w9) ? w9 + "" : w9;
            }
            if (typeof g9 != "string")
              return g9 === 0 ? g9 : +g9;
            g9 = kp(g9);
            var R = Tt.test(g9);
            return R || Xt.test(g9) ? t_(g9.slice(2), R ? 2 : 8) : Ve.test(g9) ? zt : +g9;
          }
          function Bu(g9) {
            return vt(g9, tc(g9));
          }
          function LI(g9) {
            return g9 ? mv($a(g9), -ur, ur) : g9 === 0 ? g9 : 0;
          }
          function ro(g9) {
            return g9 == null ? "" : aa(g9);
          }
          var ST = Ct(function(g9, w9) {
            if (_u(w9) || Ta(w9)) {
              vt(w9, Hn(w9), g9);
              return;
            }
            for (var R in w9)
              Ki.call(w9, R) && ru(g9, R, w9[R]);
          }), CT = Ct(function(g9, w9) {
            vt(w9, tc(w9), g9);
          }), F0 = Ct(function(g9, w9, R, K) {
            vt(w9, tc(w9), g9, K);
          }), Wm = Ct(function(g9, w9, R, K) {
            vt(w9, Hn(w9), g9, K);
          }), b22 = Nu(Im);
          function N0(g9, w9) {
            var R = md(g9);
            return w9 == null ? R : A_(R, w9);
          }
          var Um = me(function(g9, w9) {
            g9 = Yi(g9);
            var R = -1, K = w9.length, ce = K > 2 ? w9[2] : P;
            for (ce && fo(w9[0], w9[1], ce) && (K = 1); ++R < K; )
              for (var Te = w9[R], Ue = tc(Te), nt = -1, bt = Ue.length; ++nt < bt; ) {
                var Er = Ue[nt], Mr = g9[Er];
                (Mr === P || vl(Mr, la[Er]) && !Ki.call(g9, Er)) && (g9[Er] = Te[Er]);
              }
            return g9;
          }), Hm = me(function(g9) {
            return g9.push(P, Yc), Pl(AT, P, g9);
          });
          function ex(g9, w9) {
            return a0(g9, Nn(w9, 3), Tc);
          }
          function V0(g9, w9) {
            return a0(g9, Nn(w9, 3), x0);
          }
          function OI(g9, w9) {
            return g9 == null ? g9 : bu(g9, Nn(w9, 3), tc);
          }
          function kI(g9, w9) {
            return g9 == null ? g9 : _0(g9, Nn(w9, 3), tc);
          }
          function RI(g9, w9) {
            return g9 && Tc(g9, Nn(w9, 3));
          }
          function FI(g9, w9) {
            return g9 && x0(g9, Nn(w9, 3));
          }
          function NI(g9) {
            return g9 == null ? [] : Gp(g9, Hn(g9));
          }
          function tx(g9) {
            return g9 == null ? [] : Gp(g9, tc(g9));
          }
          function eg(g9, w9, R) {
            var K = g9 == null ? P : Rf(g9, w9);
            return K === P ? R : K;
          }
          function ET(g9, w9) {
            return g9 != null && Fo(g9, w9, Kn);
          }
          function we(g9, w9) {
            return g9 != null && Fo(g9, w9, T_);
          }
          var j0 = Ut(function(g9, w9, R) {
            w9 != null && typeof w9.toString != "function" && (w9 = u0.call(w9)), g9[w9] = R;
          }, nf(kl)), rx = Ut(function(g9, w9, R) {
            w9 != null && typeof w9.toString != "function" && (w9 = u0.call(w9)), Ki.call(g9, w9) ? g9[w9].push(R) : g9[w9] = [R];
          }, Nn), ef = me(wd);
          function Hn(g9) {
            return Ta(g9) ? w_(g9) : S0(g9);
          }
          function tc(g9) {
            return Ta(g9) ? w_(g9, true) : Rm(g9);
          }
          function VI(g9, w9) {
            var R = {};
            return w9 = Nn(w9, 3), Tc(g9, function(K, ce, Te) {
              Ac(R, w9(K, ce, Te), K);
            }), R;
          }
          function jI(g9, w9) {
            var R = {};
            return w9 = Nn(w9, 3), Tc(g9, function(K, ce, Te) {
              Ac(R, ce, w9(K, ce, Te));
            }), R;
          }
          var tg = Ct(function(g9, w9, R) {
            C0(g9, w9, R);
          }), AT = Ct(function(g9, w9, R, K) {
            C0(g9, w9, R, K);
          }), BI = Nu(function(g9, w9) {
            var R = {};
            if (g9 == null)
              return R;
            var K = false;
            w9 = Sa(w9, function(Te) {
              return Te = Z(Te, g9), K || (K = Te.length > 1), Te;
            }), vt(g9, Jl(g9), R), K && (R = Zl(R, Ae | We | Xe, $s));
            for (var ce = w9.length; ce--; )
              nu(R, w9[ce]);
            return R;
          });
          function zI(g9, w9) {
            return TT(g9, W_(Nn(w9)));
          }
          var $I = Nu(function(g9, w9) {
            return g9 == null ? {} : Sd(g9, w9);
          });
          function TT(g9, w9) {
            if (g9 == null)
              return {};
            var R = Sa(Jl(g9), function(K) {
              return [K];
            });
            return w9 = Nn(w9), k_(g9, R, function(K, ce) {
              return w9(K, ce[0]);
            });
          }
          function Mv(g9, w9, R) {
            w9 = Z(w9, g9);
            var K = -1, ce = w9.length;
            for (ce || (ce = 1, g9 = P); ++K < ce; ) {
              var Te = g9 == null ? P : g9[or(w9[K])];
              Te === P && (K = ce, Te = R), g9 = bi(Te) ? Te.call(g9) : Te;
            }
            return g9;
          }
          function GI(g9, w9, R) {
            return g9 == null ? g9 : pt(g9, w9, R);
          }
          function WI(g9, w9, R, K) {
            return K = typeof K == "function" ? K : P, g9 == null ? g9 : pt(g9, w9, R, K);
          }
          var MT = Jo(Hn), PT = Jo(tc);
          function UI(g9, w9, R) {
            var K = kr(g9), ce = K || xh(g9) || R0(g9);
            if (w9 = Nn(w9, 4), R == null) {
              var Te = g9 && g9.constructor;
              ce ? R = K ? new Te() : [] : Vo(g9) ? R = bi(Te) ? md(vv(g9)) : {} : R = {};
            }
            return (ce ? ku : Tc)(g9, function(Ue, nt, bt) {
              return w9(R, Ue, nt, bt);
            }), R;
          }
          function Pv(g9, w9) {
            return g9 == null ? true : nu(g9, w9);
          }
          function HI(g9, w9, R) {
            return g9 == null ? g9 : ll(g9, w9, B(R));
          }
          function qI(g9, w9, R, K) {
            return K = typeof K == "function" ? K : P, g9 == null ? g9 : ll(g9, w9, B(R), K);
          }
          function B0(g9) {
            return g9 == null ? [] : fd(g9, Hn(g9));
          }
          function YI(g9) {
            return g9 == null ? [] : fd(g9, tc(g9));
          }
          function KI(g9, w9, R) {
            return R === P && (R = w9, w9 = P), R !== P && (R = to(R), R = R === R ? R : 0), w9 !== P && (w9 = to(w9), w9 = w9 === w9 ? w9 : 0), mv(to(g9), w9, R);
          }
          function rg(g9, w9, R) {
            return w9 = Sh(w9), R === P ? (R = w9, w9 = 0) : R = Sh(R), g9 = to(g9), ZS(g9, w9, R);
          }
          function ZI(g9, w9, R) {
            if (R && typeof R != "boolean" && fo(g9, w9, R) && (w9 = R = P), R === P && (typeof w9 == "boolean" ? (R = w9, w9 = P) : typeof g9 == "boolean" && (R = g9, g9 = P)), g9 === P && w9 === P ? (g9 = 0, w9 = 1) : (g9 = Sh(g9), w9 === P ? (w9 = g9, g9 = 0) : w9 = Sh(w9)), g9 > w9) {
              var K = g9;
              g9 = w9, w9 = K;
            }
            if (R || g9 % 1 || w9 % 1) {
              var ce = dd();
              return mu(g9 + ce * (w9 - g9 + e_("1e-" + ((ce + "").length - 1))), w9);
            }
            return k2(g9, w9);
          }
          var XI = dn(function(g9, w9, R) {
            return w9 = w9.toLowerCase(), g9 + (R ? tf(w9) : w9);
          });
          function tf(g9) {
            return z0(ro(g9).toLowerCase());
          }
          function DT(g9) {
            return g9 = ro(g9), g9 && g9.replace(Fr, ES).replace(gu, "");
          }
          function JI(g9, w9, R) {
            g9 = ro(g9), w9 = aa(w9);
            var K = g9.length;
            R = R === P ? K : mv($a(R), 0, K);
            var ce = R;
            return R -= w9.length, R >= 0 && g9.slice(R, ce) == w9;
          }
          function QI(g9) {
            return g9 = ro(g9), g9 && Ss.test(g9) ? g9.replace(Go, AS) : g9;
          }
          function eL(g9) {
            return g9 = ro(g9), g9 && Jg.test(g9) ? g9.replace(bc, "\\$&") : g9;
          }
          var tL = dn(function(g9, w9, R) {
            return g9 + (R ? "-" : "") + w9.toLowerCase();
          }), IT = dn(function(g9, w9, R) {
            return g9 + (R ? " " : "") + w9.toLowerCase();
          }), LT = mt("toLowerCase");
          function rL(g9, w9, R) {
            g9 = ro(g9), w9 = $a(w9);
            var K = w9 ? Na(g9) : 0;
            if (!w9 || K >= w9)
              return g9;
            var ce = (w9 - K) / 2;
            return Zn(Ru(ce), R) + g9 + Zn(Np(ce), R);
          }
          function nL(g9, w9, R) {
            g9 = ro(g9), w9 = $a(w9);
            var K = w9 ? Na(g9) : 0;
            return w9 && K < w9 ? g9 + Zn(w9 - K, R) : g9;
          }
          function _2(g9, w9, R) {
            g9 = ro(g9), w9 = $a(w9);
            var K = w9 ? Na(g9) : 0;
            return w9 && K < w9 ? Zn(w9 - K, R) + g9 : g9;
          }
          function qm(g9, w9, R) {
            return R || w9 == null ? w9 = 0 : w9 && (w9 = +w9), OS(ro(g9).replace(Hl, ""), w9 || 0);
          }
          function nx(g9, w9, R) {
            return (R ? fo(g9, w9, R) : w9 === P) ? w9 = 1 : w9 = $a(w9), ue(ro(g9), w9);
          }
          function aL() {
            var g9 = arguments, w9 = ro(g9[0]);
            return g9.length < 3 ? w9 : w9.replace(g9[1], g9[2]);
          }
          var OT = dn(function(g9, w9, R) {
            return g9 + (R ? "_" : "") + w9.toLowerCase();
          });
          function iL(g9, w9, R) {
            return R && typeof R != "number" && fo(g9, w9, R) && (w9 = R = P), R = R === P ? Yr : R >>> 0, R ? (g9 = ro(g9), g9 && (typeof w9 == "string" || w9 != null && !O0(w9)) && (w9 = aa(w9), !w9 && Vs(g9)) ? ie(yu(g9), 0, R) : g9.split(w9, R)) : [];
          }
          var Dv = dn(function(g9, w9, R) {
            return g9 + (R ? " " : "") + z0(w9);
          });
          function x22(g9, w9, R) {
            return g9 = ro(g9), R = R == null ? 0 : mv($a(R), 0, g9.length), w9 = aa(w9), g9.slice(R, R + w9.length) == w9;
          }
          function ng(g9, w9, R) {
            var K = xe.templateSettings;
            R && fo(g9, w9, R) && (w9 = P), g9 = ro(g9), w9 = F0({}, w9, K, Xl);
            var ce = F0({}, w9.imports, K.imports, Xl), Te = Hn(ce), Ue = fd(ce, Te), nt, bt, Er = 0, Mr = w9.interpolate || yn, $r = "__p += '", Qr = Fp((w9.escape || yn).source + "|" + Mr.source + "|" + (Mr === Ou ? pe : yn).source + "|" + (w9.evaluate || yn).source + "|$", "g"), Cn = "//# sourceURL=" + (Ki.call(w9, "sourceURL") ? (w9.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++J1 + "]") + `
`;
            g9.replace(Qr, function(qn, si, _i, rc, Gu, Rl) {
              return _i || (_i = rc), $r += g9.slice(Er, Rl).replace(Ia, bm), si && (nt = true, $r += `' +
__e(` + si + `) +
'`), Gu && (bt = true, $r += `';
` + Gu + `;
__p += '`), _i && ($r += `' +
((__t = (` + _i + `)) == null ? '' : __t) +
'`), Er = Rl + qn.length, qn;
            }), $r += `';
`;
            var Xn = Ki.call(w9, "variable") && w9.variable;
            if (!Xn)
              $r = `with (obj) {
` + $r + `
}
`;
            else if (De.test(Xn))
              throw new ba(te);
            $r = (bt ? $r.replace(xs, "") : $r).replace(Lu, "$1").replace(Ul, "$1;"), $r = "function(" + (Xn || "obj") + `) {
` + (Xn ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (nt ? ", __e = _.escape" : "") + (bt ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + $r + `return __p
}`;
            var Ga = w2(function() {
              return Ci(Te, Cn + "return " + $r).apply(P, Ue);
            });
            if (Ga.source = $r, I0(Ga))
              throw Ga;
            return Ga;
          }
          function rf(g9) {
            return ro(g9).toLowerCase();
          }
          function oL(g9) {
            return ro(g9).toUpperCase();
          }
          function kT(g9, w9, R) {
            if (g9 = ro(g9), g9 && (R || w9 === P))
              return kp(g9);
            if (!g9 || !(w9 = aa(w9)))
              return g9;
            var K = yu(g9), ce = yu(w9), Te = i_(K, ce), Ue = gh(K, ce) + 1;
            return ie(K, Te, Ue).join("");
          }
          function RT(g9, w9, R) {
            if (g9 = ro(g9), g9 && (R || w9 === P))
              return g9.slice(0, ii(g9) + 1);
            if (!g9 || !(w9 = aa(w9)))
              return g9;
            var K = yu(g9), ce = gh(K, yu(w9)) + 1;
            return ie(K, 0, ce).join("");
          }
          function Ym(g9, w9, R) {
            if (g9 = ro(g9), g9 && (R || w9 === P))
              return g9.replace(Hl, "");
            if (!g9 || !(w9 = aa(w9)))
              return g9;
            var K = yu(g9), ce = i_(K, yu(w9));
            return ie(K, ce).join("");
          }
          function Ld(g9, w9) {
            var R = kt, K = dr;
            if (Vo(w9)) {
              var ce = "separator" in w9 ? w9.separator : ce;
              R = "length" in w9 ? $a(w9.length) : R, K = "omission" in w9 ? aa(w9.omission) : K;
            }
            g9 = ro(g9);
            var Te = g9.length;
            if (Vs(g9)) {
              var Ue = yu(g9);
              Te = Ue.length;
            }
            if (R >= Te)
              return g9;
            var nt = R - Na(K);
            if (nt < 1)
              return K;
            var bt = Ue ? ie(Ue, 0, nt).join("") : g9.slice(0, nt);
            if (ce === P)
              return bt + K;
            if (Ue && (nt += bt.length - nt), O0(ce)) {
              if (g9.slice(nt).search(ce)) {
                var Er, Mr = bt;
                for (ce.global || (ce = Fp(ce.source, ro(Oe.exec(ce)) + "g")), ce.lastIndex = 0; Er = ce.exec(Mr); )
                  var $r = Er.index;
                bt = bt.slice(0, $r === P ? nt : $r);
              }
            } else if (g9.indexOf(aa(ce), nt) != nt) {
              var Qr = bt.lastIndexOf(ce);
              Qr > -1 && (bt = bt.slice(0, Qr));
            }
            return bt + K;
          }
          function FT(g9) {
            return g9 = ro(g9), g9 && qa.test(g9) ? g9.replace(ws, Rp) : g9;
          }
          var sL = dn(function(g9, w9, R) {
            return g9 + (R ? " " : "") + w9.toUpperCase();
          }), z0 = mt("toUpperCase");
          function NT(g9, w9, R) {
            return g9 = ro(g9), w9 = R ? P : w9, w9 === P ? s_(g9) ? Yn(g9) : CS(g9) : g9.match(w9) || [];
          }
          var w2 = me(function(g9, w9) {
            try {
              return Pl(g9, P, w9);
            } catch (R) {
              return I0(R) ? R : new ba(R);
            }
          }), zu = Nu(function(g9, w9) {
            return ku(w9, function(R) {
              R = or(R), Ac(g9, R, Qp(g9[R], g9));
            }), g9;
          });
          function S2(g9) {
            var w9 = g9 == null ? 0 : g9.length, R = Nn();
            return g9 = w9 ? Sa(g9, function(K) {
              if (typeof K[1] != "function")
                throw new Ko(J);
              return [R(K[0]), K[1]];
            }) : [], me(function(K) {
              for (var ce = -1; ++ce < w9; ) {
                var Te = g9[ce];
                if (Pl(Te[0], this, K))
                  return Pl(Te[1], this, K);
              }
            });
          }
          function VT(g9) {
            return qS(Zl(g9, Ae));
          }
          function nf(g9) {
            return function() {
              return g9;
            };
          }
          function C2(g9, w9) {
            return g9 == null || g9 !== g9 ? w9 : g9;
          }
          var ax = fr(), ag = fr(true);
          function kl(g9) {
            return g9;
          }
          function $u(g9) {
            return I_(typeof g9 == "function" ? g9 : Zl(g9, Ae));
          }
          function E2(g9) {
            return Fm(Zl(g9, Ae));
          }
          function uL(g9, w9) {
            return Nm(g9, Zl(w9, Ae));
          }
          var lL = me(function(g9, w9) {
            return function(R) {
              return wd(R, g9, w9);
            };
          }), cL = me(function(g9, w9) {
            return function(R) {
              return wd(g9, R, w9);
            };
          });
          function Km(g9, w9, R) {
            var K = Hn(w9), ce = Gp(w9, K);
            R == null && !(Vo(w9) && (ce.length || !K.length)) && (R = w9, w9 = g9, g9 = this, ce = Gp(w9, Hn(w9)));
            var Te = !(Vo(R) && "chain" in R) || !!R.chain, Ue = bi(g9);
            return ku(ce, function(nt) {
              var bt = w9[nt];
              g9[nt] = bt, Ue && (g9.prototype[nt] = function() {
                var Er = this.__chain__;
                if (Te || Er) {
                  var Mr = g9(this.__wrapped__), $r = Mr.__actions__ = se(this.__actions__);
                  return $r.push({ func: bt, args: arguments, thisArg: g9 }), Mr.__chain__ = Er, Mr;
                }
                return bt.apply(g9, Yl([this.value()], arguments));
              });
            }), g9;
          }
          function fL() {
            return As._ === this && (As._ = v_), this;
          }
          function ig() {
          }
          function jT(g9) {
            return g9 = $a(g9), me(function(w9) {
              return O_(w9, g9);
            });
          }
          var hL = zr(Sa), vL = zr(pm), Zm = zr(Dp);
          function BT(g9) {
            return Qo(g9) ? vh(or(g9)) : QS(g9);
          }
          function dL(g9) {
            return function(w9) {
              return g9 == null ? P : Rf(g9, w9);
            };
          }
          var A22 = Ja(), zT = Ja(true);
          function T2() {
            return [];
          }
          function M2() {
            return false;
          }
          function pL() {
            return {};
          }
          function $T() {
            return "";
          }
          function P2() {
            return true;
          }
          function gL(g9, w9) {
            if (g9 = $a(g9), g9 < 1 || g9 > ur)
              return [];
            var R = Yr, K = mu(g9, Yr);
            w9 = Nn(w9), g9 -= Yr;
            for (var ce = cv(K, w9); ++R < g9; )
              w9(R);
            return ce;
          }
          function D2(g9) {
            return kr(g9) ? Sa(g9, or) : dl(g9) ? [g9] : se(Dt(ro(g9)));
          }
          function GT(g9) {
            var w9 = ++f_;
            return ro(g9) + w9;
          }
          var WT = Kr(function(g9, w9) {
            return g9 + w9;
          }, 0), UT = Qa("ceil"), ix = Kr(function(g9, w9) {
            return g9 / w9;
          }, 1), yL = Qa("floor");
          function HT(g9) {
            return g9 && g9.length ? xd(g9, kl, Up) : P;
          }
          function qT(g9, w9) {
            return g9 && g9.length ? xd(g9, Nn(w9, 2), Up) : P;
          }
          function mL(g9) {
            return Ts(g9, kl);
          }
          function YT(g9, w9) {
            return Ts(g9, Nn(w9, 2));
          }
          function bL(g9) {
            return g9 && g9.length ? xd(g9, kl, wv) : P;
          }
          function I2(g9, w9) {
            return g9 && g9.length ? xd(g9, Nn(w9, 2), wv) : P;
          }
          var KT = Kr(function(g9, w9) {
            return g9 * w9;
          }, 1), L2 = Qa("round"), _L = Kr(function(g9, w9) {
            return g9 - w9;
          }, 0);
          function O2(g9) {
            return g9 && g9.length ? dh(g9, kl) : 0;
          }
          function ti(g9, w9) {
            return g9 && g9.length ? dh(g9, Nn(w9, 2)) : 0;
          }
          return xe.after = vT, xe.ary = ec, xe.assign = ST, xe.assignIn = CT, xe.assignInWith = F0, xe.assignWith = Wm, xe.at = b22, xe.before = G_, xe.bind = Qp, xe.bindAll = zu, xe.bindKey = d22, xe.castArray = gT, xe.chain = o2, xe.chunk = Pn, xe.compact = Ka, xe.concat = mi, xe.cond = S2, xe.conforms = VT, xe.constant = nf, xe.countBy = Jc, xe.create = N0, xe.curry = p22, xe.curryRight = dT, xe.debounce = pT, xe.defaults = Um, xe.defaultsDeep = Hm, xe.defer = pI, xe.delay = gI, xe.difference = Qi, xe.differenceBy = za, xe.differenceWith = eo, xe.drop = es, xe.dropRight = ga, xe.dropRightWhile = Is, xe.dropWhile = Ll, xe.fill = Nf, xe.filter = uT, xe.flatMap = u2, xe.flatMapDeep = ts, xe.flatMapDepth = Dd, xe.flatten = Ad, xe.flattenDeep = Cv, xe.flattenDepth = au, xe.flip = yI, xe.flow = ax, xe.flowRight = ag, xe.fromPairs = _h, xe.functions = NI, xe.functionsIn = tx, xe.groupBy = l22, xe.initial = Zp, xe.intersection = Xp, xe.intersectionBy = Bm, xe.intersectionWith = E0, xe.invert = j0, xe.invertBy = rx, xe.invokeMap = fI, xe.iteratee = $u, xe.keyBy = hI, xe.keys = Hn, xe.keysIn = tc, xe.map = $m, xe.mapKeys = VI, xe.mapValues = jI, xe.matches = E2, xe.matchesProperty = uL, xe.memoize = Av, xe.merge = tg, xe.mergeWith = AT, xe.method = lL, xe.methodOf = cL, xe.mixin = Km, xe.negate = W_, xe.nthArg = jT, xe.omit = BI, xe.omitBy = zI, xe.once = mI, xe.orderBy = z_, xe.over = hL, xe.overArgs = g2, xe.overEvery = vL, xe.overSome = Zm, xe.partial = U_, xe.partialRight = Tv, xe.partition = M0, xe.pick = $I, xe.pickBy = TT, xe.property = BT, xe.propertyOf = dL, xe.pull = r22, xe.pullAll = N_, xe.pullAllBy = T0, xe.pullAllWith = YA, xe.pullAt = KA, xe.range = A22, xe.rangeRight = zT, xe.rearg = H_, xe.reject = fT, xe.remove = WD, xe.rest = bI, xe.reverse = V_, xe.sampleSize = f22, xe.set = GI, xe.setWith = WI, xe.shuffle = hT, xe.slice = ZA, xe.sortBy = v22, xe.sortedUniq = YD, xe.sortedUniqBy = KD, xe.split = iL, xe.spread = _I, xe.tail = ZD, xe.take = XD, xe.takeRight = n22, xe.takeRightWhile = JD, xe.takeWhile = QD, xe.tap = s2, xe.throttle = xI, xe.thru = Ol, xe.toArray = xT, xe.toPairs = MT, xe.toPairsIn = PT, xe.toPath = D2, xe.toPlainObject = Bu, xe.transform = UI, xe.unary = P0, xe.union = eI, xe.unionBy = tI, xe.unionWith = rI, xe.uniq = Uo, xe.uniqBy = No, xe.uniqWith = nI, xe.unset = Pv, xe.unzip = a2, xe.unzipWith = eT, xe.update = HI, xe.updateWith = qI, xe.values = B0, xe.valuesIn = YI, xe.without = aI, xe.words = NT, xe.wrap = Vf, xe.xor = iI, xe.xorBy = oI, xe.xorWith = tT, xe.zip = sI, xe.zipObject = ju, xe.zipObjectDeep = i2, xe.zipWith = Jp, xe.entries = MT, xe.entriesIn = PT, xe.extend = CT, xe.extendWith = F0, Km(xe, xe), xe.add = WT, xe.attempt = w2, xe.camelCase = XI, xe.capitalize = tf, xe.ceil = UT, xe.clamp = KI, xe.clone = wI, xe.cloneDeep = CI, xe.cloneDeepWith = EI, xe.cloneWith = SI, xe.conformsTo = AI, xe.deburr = DT, xe.defaultTo = C2, xe.divide = ix, xe.endsWith = JI, xe.eq = vl, xe.escape = QI, xe.escapeRegExp = eL, xe.every = lI, xe.find = Pd, xe.findIndex = Kp, xe.findKey = ex, xe.findLast = j_, xe.findLastIndex = Xc, xe.findLastKey = V0, xe.floor = yL, xe.forEach = B_, xe.forEachRight = lT, xe.forIn = OI, xe.forInRight = kI, xe.forOwn = RI, xe.forOwnRight = FI, xe.get = eg, xe.gt = yt, xe.gte = br, xe.has = ET, xe.hasIn = we, xe.head = Td, xe.identity = kl, xe.includes = cI, xe.indexOf = Ev, xe.inRange = rg, xe.invoke = ef, xe.isArguments = $t, xe.isArray = kr, xe.isArrayBuffer = Aa, xe.isArrayLike = Ta, xe.isArrayLikeObject = ei, xe.isBoolean = Eo, xe.isBuffer = xh, xe.isDate = TI, xe.isElement = Qc, xe.isEmpty = q_, xe.isEqual = MI, xe.isEqualWith = D0, xe.isError = I0, xe.isFinite = Y_, xe.isFunction = bi, xe.isInteger = yT, xe.isLength = Gm, xe.isMap = mT, xe.isMatch = PI3, xe.isMatchWith = K_, xe.isNaN = Id, xe.isNative = Z_, xe.isNil = X_, xe.isNull = bT, xe.isNumber = y2, xe.isObject = Vo, xe.isObjectLike = ps, xe.isPlainObject = L0, xe.isRegExp = O0, xe.isSafeInteger = _T, xe.isSet = k0, xe.isString = wh, xe.isSymbol = dl, xe.isTypedArray = R0, xe.isUndefined = DI, xe.isWeakMap = II, xe.isWeakSet = J_, xe.join = A0, xe.kebabCase = tL, xe.last = xu, xe.lastIndexOf = Md, xe.lowerCase = IT, xe.lowerFirst = LT, xe.lt = Q_, xe.lte = m22, xe.max = HT, xe.maxBy = qT, xe.mean = mL, xe.meanBy = YT, xe.min = bL, xe.minBy = I2, xe.stubArray = T2, xe.stubFalse = M2, xe.stubObject = pL, xe.stubString = $T, xe.stubTrue = P2, xe.multiply = KT, xe.nth = zm, xe.noConflict = fL, xe.noop = ig, xe.now = $_, xe.pad = rL, xe.padEnd = nL, xe.padStart = _2, xe.parseInt = qm, xe.random = ZI, xe.reduce = vI, xe.reduceRight = cT, xe.repeat = nx, xe.replace = aL, xe.result = Mv, xe.round = L2, xe.runInContext = rt2, xe.sample = c22, xe.size = dI, xe.snakeCase = OT, xe.some = h2, xe.sortedIndex = XA, xe.sortedIndexBy = JA, xe.sortedIndexOf = UD, xe.sortedLastIndex = HD, xe.sortedLastIndexBy = qD, xe.sortedLastIndexOf = QA, xe.startCase = Dv, xe.startsWith = x22, xe.subtract = _L, xe.sum = O2, xe.sumBy = ti, xe.template = ng, xe.times = gL, xe.toFinite = Sh, xe.toInteger = $a, xe.toLength = wT, xe.toLower = rf, xe.toNumber = to, xe.toSafeInteger = LI, xe.toString = ro, xe.toUpper = oL, xe.trim = kT, xe.trimEnd = RT, xe.trimStart = Ym, xe.truncate = Ld, xe.unescape = FT, xe.uniqueId = GT, xe.upperCase = sL, xe.upperFirst = z0, xe.each = B_, xe.eachRight = lT, xe.first = Td, Km(xe, function() {
            var g9 = {};
            return Tc(xe, function(w9, R) {
              Ki.call(xe.prototype, R) || (g9[R] = w9);
            }), g9;
          }(), { chain: false }), xe.VERSION = I, ku(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(g9) {
            xe[g9].placeholder = xe;
          }), ku(["drop", "take"], function(g9, w9) {
            oi.prototype[g9] = function(R) {
              R = R === P ? 1 : Zo($a(R), 0);
              var K = this.__filtered__ && !w9 ? new oi(this) : this.clone();
              return K.__filtered__ ? K.__takeCount__ = mu(R, K.__takeCount__) : K.__views__.push({ size: mu(R, Yr), type: g9 + (K.__dir__ < 0 ? "Right" : "") }), K;
            }, oi.prototype[g9 + "Right"] = function(R) {
              return this.reverse()[g9](R).reverse();
            };
          }), ku(["filter", "map", "takeWhile"], function(g9, w9) {
            var R = w9 + 1, K = R == gn || R == Jt;
            oi.prototype[g9] = function(ce) {
              var Te = this.clone();
              return Te.__iteratees__.push({ iteratee: Nn(ce, 3), type: R }), Te.__filtered__ = Te.__filtered__ || K, Te;
            };
          }), ku(["head", "last"], function(g9, w9) {
            var R = "take" + (w9 ? "Right" : "");
            oi.prototype[g9] = function() {
              return this[R](1).value()[0];
            };
          }), ku(["initial", "tail"], function(g9, w9) {
            var R = "drop" + (w9 ? "" : "Right");
            oi.prototype[g9] = function() {
              return this.__filtered__ ? new oi(this) : this[R](1);
            };
          }), oi.prototype.compact = function() {
            return this.filter(kl);
          }, oi.prototype.find = function(g9) {
            return this.filter(g9).head();
          }, oi.prototype.findLast = function(g9) {
            return this.reverse().find(g9);
          }, oi.prototype.invokeMap = me(function(g9, w9) {
            return typeof g9 == "function" ? new oi(this) : this.map(function(R) {
              return wd(R, g9, w9);
            });
          }), oi.prototype.reject = function(g9) {
            return this.filter(W_(Nn(g9)));
          }, oi.prototype.slice = function(g9, w9) {
            g9 = $a(g9);
            var R = this;
            return R.__filtered__ && (g9 > 0 || w9 < 0) ? new oi(R) : (g9 < 0 ? R = R.takeRight(-g9) : g9 && (R = R.drop(g9)), w9 !== P && (w9 = $a(w9), R = w9 < 0 ? R.dropRight(-w9) : R.take(w9 - g9)), R);
          }, oi.prototype.takeRightWhile = function(g9) {
            return this.reverse().takeWhile(g9).reverse();
          }, oi.prototype.toArray = function() {
            return this.take(Yr);
          }, Tc(oi.prototype, function(g9, w9) {
            var R = /^(?:filter|find|map|reject)|While$/.test(w9), K = /^(?:head|last)$/.test(w9), ce = xe[K ? "take" + (w9 == "last" ? "Right" : "") : w9], Te = K || /^find/.test(w9);
            !ce || (xe.prototype[w9] = function() {
              var Ue = this.__wrapped__, nt = K ? [1] : arguments, bt = Ue instanceof oi, Er = nt[0], Mr = bt || kr(Ue), $r = function(si) {
                var _i = ce.apply(xe, Yl([si], nt));
                return K && Qr ? _i[0] : _i;
              };
              Mr && R && typeof Er == "function" && Er.length != 1 && (bt = Mr = false);
              var Qr = this.__chain__, Cn = !!this.__actions__.length, Xn = Te && !Qr, Ga = bt && !Cn;
              if (!Te && Mr) {
                Ue = Ga ? Ue : new oi(this);
                var qn = g9.apply(Ue, nt);
                return qn.__actions__.push({ func: Ol, args: [$r], thisArg: P }), new ul(qn, Qr);
              }
              return Xn && Ga ? g9.apply(this, nt) : (qn = this.thru($r), Xn ? K ? qn.value()[0] : qn.value() : qn);
            });
          }), ku(["pop", "push", "shift", "sort", "splice", "unshift"], function(g9) {
            var w9 = tu[g9], R = /^(?:push|sort|unshift)$/.test(g9) ? "tap" : "thru", K = /^(?:pop|shift)$/.test(g9);
            xe.prototype[g9] = function() {
              var ce = arguments;
              if (K && !this.__chain__) {
                var Te = this.value();
                return w9.apply(kr(Te) ? Te : [], ce);
              }
              return this[R](function(Ue) {
                return w9.apply(kr(Ue) ? Ue : [], ce);
              });
            };
          }), Tc(oi.prototype, function(g9, w9) {
            var R = xe[w9];
            if (R) {
              var K = R.name + "";
              Ki.call(gd, K) || (gd[K] = []), gd[K].push({ name: w9, func: R });
            }
          }), gd[Wt(P, sr).name] = [{ name: "wrapper", func: P }], oi.prototype.clone = kS, oi.prototype.reverse = Am, oi.prototype.value = v0, xe.prototype.at = rT, xe.prototype.chain = nT, xe.prototype.commit = aT, xe.prototype.next = iT, xe.prototype.plant = sT, xe.prototype.reverse = Mc, xe.prototype.toJSON = xe.prototype.valueOf = xe.prototype.value = uI, xe.prototype.first = xe.prototype.head, Va && (xe.prototype[Va] = oT), xe;
        }, Yo = c_();
        fh ? ((fh.exports = Yo)._ = Yo, t0._ = Yo) : As._ = Yo;
      }).call(m2);
    })(_, _.exports);
    class C {
      constructor() {
        s(this, "subscriptions", /* @__PURE__ */ new Map()), s(this, "emitEffectCache", /* @__PURE__ */ new Map()), s(this, "useSubscription", (G, P) => {
          const I = u.useRef();
          u.useEffect(() => {
            var L, j;
            I.current = P;
            function J(Q) {
              I.current && I.current(Q);
            }
            const te = (j = (L = this.subscriptions) == null ? void 0 : L.get(G)) != null ? j : [];
            return te.push(J), this.subscriptions.set(G, te), this.emitEffect(G), () => {
              this.subscriptions.delete(G);
            };
          });
        }), s(this, "emit", (G, ...P) => {
          if (typeof G == "string" || typeof G == "number") {
            const I = this.subscriptions.get(G);
            I == null || I.forEach((L) => {
              L == null || L({ params: _.exports.cloneDeep(P), event: G });
            }), this.emitEffectCache.set(G, { params: _.exports.cloneDeep(P), event: G });
          } else
            throw new TypeError("event must be string or number !");
        }), s(this, "emitEffect", (G) => {
          const P = this.emitEffectCache.get(G), I = this.subscriptions.get(G);
          P && (I == null || I.forEach((L) => {
            L == null || L(o({}, P));
          }));
        }), s(this, "removeListener", (G) => {
          this.subscriptions.delete(G);
        }), s(this, "clear", () => {
          this.subscriptions.clear();
        }), this.clear();
      }
    }
    const M = new C();
    function E(T) {
      const G = u.useRef(), P = u.useMemo(() => T != null ? T : { global: false }, [T]);
      return G.current || (G.current = P.global ? G.current = M : G.current = new C()), u.useEffect(() => () => {
        var I;
        return (I = G.current) == null ? void 0 : I.clear();
      }, []), G.current;
    }
    var z9 = globalThis && globalThis.__read || function(T, G) {
      var P = typeof Symbol == "function" && T[Symbol.iterator];
      if (!P)
        return T;
      var I = P.call(T), L, j = [], J;
      try {
        for (; (G === void 0 || G-- > 0) && !(L = I.next()).done; )
          j.push(L.value);
      } catch (te) {
        J = { error: te };
      } finally {
        try {
          L && !L.done && (P = I.return) && P.call(I);
        } finally {
          if (J)
            throw J.error;
        }
      }
      return j;
    };
    function V(T, G) {
      T === void 0 && (T = false);
      var P = z9(u.useState(T), 2), I = P[0], L = P[1], j = u.useMemo(function() {
        var J = G === void 0 ? !T : G, te = function() {
          return L(function(Ae) {
            return Ae === T ? J : T;
          });
        }, Q = function(Ae) {
          return L(Ae);
        }, he = function() {
          return L(T);
        }, de = function() {
          return L(J);
        };
        return { toggle: te, set: Q, setLeft: he, setRight: de };
      }, []);
      return [I, j];
    }
    var $ = globalThis && globalThis.__read || function(T, G) {
      var P = typeof Symbol == "function" && T[Symbol.iterator];
      if (!P)
        return T;
      var I = P.call(T), L, j = [], J;
      try {
        for (; (G === void 0 || G-- > 0) && !(L = I.next()).done; )
          j.push(L.value);
      } catch (te) {
        J = { error: te };
      } finally {
        try {
          L && !L.done && (P = I.return) && P.call(I);
        } finally {
          if (J)
            throw J.error;
        }
      }
      return j;
    };
    function U(T) {
      T === void 0 && (T = false);
      var G = $(V(T), 2), P = G[0], I = G[1], L = I.toggle, j = I.set, J = u.useMemo(function() {
        var te = function() {
          return j(true);
        }, Q = function() {
          return j(false);
        };
        return { toggle: L, set: function(he) {
          return j(!!he);
        }, setTrue: te, setFalse: Q };
      }, []);
      return [P, J];
    }
    function H(T) {
      var G = u.useRef(T);
      return G.current = T, G;
    }
    var q3 = function(T) {
      var G = H(T);
      u.useEffect(function() {
        return function() {
          G.current();
        };
      }, []);
    }, ee = q3;
    function oe(T) {
      var G = typeof T;
      return T != null && (G == "object" || G == "function");
    }
    var ne = oe, be = typeof m2 == "object" && m2 && m2.Object === Object && m2, Ee = be, ye = Ee, et = typeof self == "object" && self && self.Object === Object && self, Le = ye || et || Function("return this")(), Fe = Le, qe = Fe, st = function() {
      return qe.Date.now();
    }, dt = st, Ar = /\s/;
    function Hr(T) {
      for (var G = T.length; G-- && Ar.test(T.charAt(G)); )
        ;
      return G;
    }
    var hn = Hr, cn = hn, nn = /^\s+/;
    function Wr(T) {
      return T && T.slice(0, cn(T) + 1).replace(nn, "");
    }
    var on = Wr, un = Fe, Xr = un.Symbol, _n = Xr, Za = _n, Dn = Object.prototype, ai = Dn.hasOwnProperty, wi = Dn.toString, hi = Za ? Za.toStringTag : void 0;
    function qs(T) {
      var G = ai.call(T, hi), P = T[hi];
      try {
        T[hi] = void 0;
        var I = true;
      } catch {
      }
      var L = wi.call(T);
      return I && (G ? T[hi] = P : delete T[hi]), L;
    }
    var jo = qs, Au = Object.prototype, Zi = Au.toString;
    function ys(T) {
      return Zi.call(T);
    }
    var Do = ys, mf = _n, xr = jo, jt = Do, Ot = "[object Null]", wr = "[object Undefined]", an = mf ? mf.toStringTag : void 0;
    function Mn(T) {
      return T == null ? T === void 0 ? wr : Ot : an && an in Object(T) ? xr(T) : jt(T);
    }
    var Fa = Mn;
    function Ma(T) {
      return T != null && typeof T == "object";
    }
    var ji = Ma, Bo = Fa, yo = ji, ms = "[object Symbol]";
    function mo(T) {
      return typeof T == "symbol" || yo(T) && Bo(T) == ms;
    }
    var Yu = mo, wl = on, hc = ne, Sl = Yu, as = 0 / 0, vi = /^[-+]0x[0-9a-f]+$/i, Ys = /^0b[01]+$/i, Tu = /^0o[0-7]+$/i, Vc = parseInt;
    function zl(T) {
      if (typeof T == "number")
        return T;
      if (Sl(T))
        return as;
      if (hc(T)) {
        var G = typeof T.valueOf == "function" ? T.valueOf() : T;
        T = hc(G) ? G + "" : G;
      }
      if (typeof T != "string")
        return T === 0 ? T : +T;
      T = wl(T);
      var P = Ys.test(T);
      return P || Tu.test(T) ? Vc(T.slice(2), P ? 2 : 8) : vi.test(T) ? as : +T;
    }
    var Cl = zl, vc = ne, th = dt, rh = Cl, Mw = "Expected a function", qv = Math.max, Pw = Math.min;
    function Dw(T, G, P) {
      var I, L, j, J, te, Q, he = 0, de = false, Ae = false, We = true;
      if (typeof T != "function")
        throw new TypeError(Mw);
      G = rh(G) || 0, vc(P) && (de = !!P.leading, Ae = "maxWait" in P, j = Ae ? qv(rh(P.maxWait) || 0, G) : j, We = "trailing" in P ? !!P.trailing : We);
      function Xe(Pt) {
        var er = I, Kt = L;
        return I = L = void 0, he = Pt, J = T.apply(Kt, er), J;
      }
      function Ze(Pt) {
        return he = Pt, te = setTimeout(sr, G), de ? Xe(Pt) : J;
      }
      function it(Pt) {
        var er = Pt - Q, Kt = Pt - he, St = G - er;
        return Ae ? Pw(St, j - Kt) : St;
      }
      function ct(Pt) {
        var er = Pt - Q, Kt = Pt - he;
        return Q === void 0 || er >= G || er < 0 || Ae && Kt >= j;
      }
      function sr() {
        var Pt = th();
        if (ct(Pt))
          return Yt(Pt);
        te = setTimeout(sr, it(Pt));
      }
      function Yt(Pt) {
        return te = void 0, We && I ? Xe(Pt) : (I = L = void 0, J);
      }
      function Or() {
        te !== void 0 && clearTimeout(te), he = 0, I = Q = L = te = void 0;
      }
      function le() {
        return te === void 0 ? J : Yt(th());
      }
      function _t() {
        var Pt = th(), er = ct(Pt);
        if (I = arguments, L = this, Q = Pt, er) {
          if (te === void 0)
            return Ze(Q);
          if (Ae)
            return clearTimeout(te), te = setTimeout(sr, G), Xe(Q);
        }
        return te === void 0 && (te = setTimeout(sr, G)), J;
      }
      return _t.cancel = Or, _t.flush = le, _t;
    }
    var Iw = Dw, Lw = globalThis && globalThis.__read || function(T, G) {
      var P = typeof Symbol == "function" && T[Symbol.iterator];
      if (!P)
        return T;
      var I = P.call(T), L, j = [], J;
      try {
        for (; (G === void 0 || G-- > 0) && !(L = I.next()).done; )
          j.push(L.value);
      } catch (te) {
        J = { error: te };
      } finally {
        try {
          L && !L.done && (P = I.return) && P.call(I);
        } finally {
          if (J)
            throw J.error;
        }
      }
      return j;
    }, Fg = globalThis && globalThis.__spread || function() {
      for (var T = [], G = 0; G < arguments.length; G++)
        T = T.concat(Lw(arguments[G]));
      return T;
    };
    function Be(T, G) {
      var P, I = H(T), L = (P = G == null ? void 0 : G.wait) !== null && P !== void 0 ? P : 1e3, j = u.useMemo(function() {
        return Iw(function() {
          for (var J = [], te = 0; te < arguments.length; te++)
            J[te] = arguments[te];
          return I.current.apply(I, Fg(J));
        }, L, G);
      }, []);
      return ee(function() {
        j.cancel();
      }), { run: j, cancel: j.cancel, flush: j.flush };
    }
    const $e = ({ id: T, title: G, chart: P, option: I }, L) => {
      const j = u.useRef(), J = E({ global: true });
      j.current = u.useMemo(() => {
        if (!j.current)
          return d2;
      }, []);
      const { run: te } = Be(() => {
        T && J.emit("list");
      }, { wait: 100 });
      return u.useEffect(() => {
        console.log(P == null ? void 0 : P.current), j.current && (P == null ? void 0 : P.current) && T && I && (j.current.add(T, P == null ? void 0 : P.current, I, G), te());
      }, L), { tool: j.current };
    };
    var Se = u.createContext({}), ke = Se;
    function Ie(T, G, P) {
      return G in T ? Object.defineProperty(T, G, { value: P, enumerable: true, configurable: true, writable: true }) : T[G] = P, T;
    }
    function Mt(T, G) {
      var P = Object.keys(T);
      if (Object.getOwnPropertySymbols) {
        var I = Object.getOwnPropertySymbols(T);
        G && (I = I.filter(function(L) {
          return Object.getOwnPropertyDescriptor(T, L).enumerable;
        })), P.push.apply(P, I);
      }
      return P;
    }
    function At(T) {
      for (var G = 1; G < arguments.length; G++) {
        var P = arguments[G] != null ? arguments[G] : {};
        G % 2 ? Mt(Object(P), true).forEach(function(I) {
          Ie(T, I, P[I]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(T, Object.getOwnPropertyDescriptors(P)) : Mt(Object(P)).forEach(function(I) {
          Object.defineProperty(T, I, Object.getOwnPropertyDescriptor(P, I));
        });
      }
      return T;
    }
    function Qt(T) {
      if (Array.isArray(T))
        return T;
    }
    function xt(T, G) {
      var P = T == null ? null : typeof Symbol != "undefined" && T[Symbol.iterator] || T["@@iterator"];
      if (P != null) {
        var I = [], L = true, j = false, J, te;
        try {
          for (P = P.call(T); !(L = (J = P.next()).done) && (I.push(J.value), !(G && I.length === G)); L = true)
            ;
        } catch (Q) {
          j = true, te = Q;
        } finally {
          try {
            !L && P.return != null && P.return();
          } finally {
            if (j)
              throw te;
          }
        }
        return I;
      }
    }
    function Rr(T, G) {
      (G == null || G > T.length) && (G = T.length);
      for (var P = 0, I = new Array(G); P < G; P++)
        I[P] = T[P];
      return I;
    }
    function wn(T, G) {
      if (T) {
        if (typeof T == "string")
          return Rr(T, G);
        var P = Object.prototype.toString.call(T).slice(8, -1);
        if (P === "Object" && T.constructor && (P = T.constructor.name), P === "Map" || P === "Set")
          return Array.from(T);
        if (P === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(P))
          return Rr(T, G);
      }
    }
    function Ba() {
      throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function sa(T, G) {
      return Qt(T) || xt(T, G) || wn(T, G) || Ba();
    }
    function Xi(T, G) {
      if (T == null)
        return {};
      var P = {}, I = Object.keys(T), L, j;
      for (j = 0; j < I.length; j++)
        L = I[j], !(G.indexOf(L) >= 0) && (P[L] = T[L]);
      return P;
    }
    function ma(T, G) {
      if (T == null)
        return {};
      var P = Xi(T, G), I, L;
      if (Object.getOwnPropertySymbols) {
        var j = Object.getOwnPropertySymbols(T);
        for (L = 0; L < j.length; L++)
          I = j[L], !(G.indexOf(I) >= 0) && (!Object.prototype.propertyIsEnumerable.call(T, I) || (P[I] = T[I]));
      }
      return P;
    }
    var Wi = { exports: {} };
    /*!
      Copyright (c) 2018 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */
    (function(T) {
      (function() {
        var G = {}.hasOwnProperty;
        function P() {
          for (var I = [], L = 0; L < arguments.length; L++) {
            var j = arguments[L];
            if (j) {
              var J = typeof j;
              if (J === "string" || J === "number")
                I.push(j);
              else if (Array.isArray(j)) {
                if (j.length) {
                  var te = P.apply(null, j);
                  te && I.push(te);
                }
              } else if (J === "object")
                if (j.toString === Object.prototype.toString)
                  for (var Q in j)
                    G.call(j, Q) && j[Q] && I.push(Q);
                else
                  I.push(j.toString());
            }
          }
          return I.join(" ");
        }
        T.exports ? (P.default = P, T.exports = P) : window.classNames = P;
      })();
    })(Wi);
    var io = Wi.exports;
    function kn(T) {
      return kn = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(G) {
        return typeof G;
      } : function(G) {
        return G && typeof Symbol == "function" && G.constructor === Symbol && G !== Symbol.prototype ? "symbol" : typeof G;
      }, kn(T);
    }
    function Bi(T, G) {
      El(T) && (T = "100%");
      var P = bf(T);
      return T = G === 360 ? T : Math.min(G, Math.max(0, parseFloat(T))), P && (T = parseInt(String(T * G), 10) / 100), Math.abs(T - G) < 1e-6 ? 1 : (G === 360 ? T = (T < 0 ? T % G + G : T % G) / parseFloat(String(G)) : T = T % G / parseFloat(String(G)), T);
    }
    function El(T) {
      return typeof T == "string" && T.indexOf(".") !== -1 && parseFloat(T) === 1;
    }
    function bf(T) {
      return typeof T == "string" && T.indexOf("%") !== -1;
    }
    function Ng(T) {
      return T = parseFloat(T), (isNaN(T) || T < 0 || T > 1) && (T = 1), T;
    }
    function $l(T) {
      return T <= 1 ? Number(T) * 100 + "%" : T;
    }
    function Xh(T) {
      return T.length === 1 ? "0" + T : String(T);
    }
    function Jh(T, G, P) {
      return { r: Bi(T, 255) * 255, g: Bi(G, 255) * 255, b: Bi(P, 255) * 255 };
    }
    function bs(T, G, P) {
      return P < 0 && (P += 1), P > 1 && (P -= 1), P < 1 / 6 ? T + (G - T) * (6 * P) : P < 1 / 2 ? G : P < 2 / 3 ? T + (G - T) * (2 / 3 - P) * 6 : T;
    }
    function nh(T, G, P) {
      var I, L, j;
      if (T = Bi(T, 360), G = Bi(G, 100), P = Bi(P, 100), G === 0)
        L = P, j = P, I = P;
      else {
        var J = P < 0.5 ? P * (1 + G) : P + G - P * G, te = 2 * P - J;
        I = bs(te, J, T + 1 / 3), L = bs(te, J, T), j = bs(te, J, T - 1 / 3);
      }
      return { r: I * 255, g: L * 255, b: j * 255 };
    }
    function sp(T, G, P) {
      T = Bi(T, 255), G = Bi(G, 255), P = Bi(P, 255);
      var I = Math.max(T, G, P), L = Math.min(T, G, P), j = 0, J = I, te = I - L, Q = I === 0 ? 0 : te / I;
      if (I === L)
        j = 0;
      else {
        switch (I) {
          case T:
            j = (G - P) / te + (G < P ? 6 : 0);
            break;
          case G:
            j = (P - T) / te + 2;
            break;
          case P:
            j = (T - G) / te + 4;
            break;
        }
        j /= 6;
      }
      return { h: j, s: Q, v: J };
    }
    function Qh(T, G, P) {
      T = Bi(T, 360) * 6, G = Bi(G, 100), P = Bi(P, 100);
      var I = Math.floor(T), L = T - I, j = P * (1 - G), J = P * (1 - L * G), te = P * (1 - (1 - L) * G), Q = I % 6, he = [P, J, j, j, te, P][Q], de = [te, P, P, J, j, j][Q], Ae = [j, j, te, P, P, J][Q];
      return { r: he * 255, g: de * 255, b: Ae * 255 };
    }
    function up(T, G, P, I) {
      var L = [Xh(Math.round(T).toString(16)), Xh(Math.round(G).toString(16)), Xh(Math.round(P).toString(16))];
      return I && L[0].startsWith(L[0].charAt(1)) && L[1].startsWith(L[1].charAt(1)) && L[2].startsWith(L[2].charAt(1)) ? L[0].charAt(0) + L[1].charAt(0) + L[2].charAt(0) : L.join("");
    }
    function Yv(T) {
      return Mu(T) / 255;
    }
    function Mu(T) {
      return parseInt(T, 16);
    }
    var lp = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
    function ah(T) {
      var G = { r: 0, g: 0, b: 0 }, P = 1, I = null, L = null, j = null, J = false, te = false;
      return typeof T == "string" && (T = eA(T)), typeof T == "object" && (ih(T.r) && ih(T.g) && ih(T.b) ? (G = Jh(T.r, T.g, T.b), J = true, te = String(T.r).substr(-1) === "%" ? "prgb" : "rgb") : ih(T.h) && ih(T.s) && ih(T.v) ? (I = $l(T.s), L = $l(T.v), G = Qh(T.h, I, L), J = true, te = "hsv") : ih(T.h) && ih(T.s) && ih(T.l) && (I = $l(T.s), j = $l(T.l), G = nh(T.h, I, j), J = true, te = "hsl"), Object.prototype.hasOwnProperty.call(T, "a") && (P = T.a)), P = Ng(P), { ok: J, format: T.format || te, r: Math.min(255, Math.max(G.r, 0)), g: Math.min(255, Math.max(G.g, 0)), b: Math.min(255, Math.max(G.b, 0)), a: P };
    }
    var cp = "[-\\+]?\\d+%?", Kv = "[-\\+]?\\d*\\.\\d+%?", jc = "(?:" + Kv + ")|(?:" + cp + ")", Py = "[\\s|\\(]+(" + jc + ")[,|\\s]+(" + jc + ")[,|\\s]+(" + jc + ")\\s*\\)?", Dy = "[\\s|\\(]+(" + jc + ")[,|\\s]+(" + jc + ")[,|\\s]+(" + jc + ")[,|\\s]+(" + jc + ")\\s*\\)?", Ku = { CSS_UNIT: new RegExp(jc), rgb: new RegExp("rgb" + Py), rgba: new RegExp("rgba" + Dy), hsl: new RegExp("hsl" + Py), hsla: new RegExp("hsla" + Dy), hsv: new RegExp("hsv" + Py), hsva: new RegExp("hsva" + Dy), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
    function eA(T) {
      if (T = T.trim().toLowerCase(), T.length === 0)
        return false;
      var G = false;
      if (lp[T])
        T = lp[T], G = true;
      else if (T === "transparent")
        return { r: 0, g: 0, b: 0, a: 0, format: "name" };
      var P = Ku.rgb.exec(T);
      return P ? { r: P[1], g: P[2], b: P[3] } : (P = Ku.rgba.exec(T), P ? { r: P[1], g: P[2], b: P[3], a: P[4] } : (P = Ku.hsl.exec(T), P ? { h: P[1], s: P[2], l: P[3] } : (P = Ku.hsla.exec(T), P ? { h: P[1], s: P[2], l: P[3], a: P[4] } : (P = Ku.hsv.exec(T), P ? { h: P[1], s: P[2], v: P[3] } : (P = Ku.hsva.exec(T), P ? { h: P[1], s: P[2], v: P[3], a: P[4] } : (P = Ku.hex8.exec(T), P ? { r: Mu(P[1]), g: Mu(P[2]), b: Mu(P[3]), a: Yv(P[4]), format: G ? "name" : "hex8" } : (P = Ku.hex6.exec(T), P ? { r: Mu(P[1]), g: Mu(P[2]), b: Mu(P[3]), format: G ? "name" : "hex" } : (P = Ku.hex4.exec(T), P ? { r: Mu(P[1] + P[1]), g: Mu(P[2] + P[2]), b: Mu(P[3] + P[3]), a: Yv(P[4] + P[4]), format: G ? "name" : "hex8" } : (P = Ku.hex3.exec(T), P ? { r: Mu(P[1] + P[1]), g: Mu(P[2] + P[2]), b: Mu(P[3] + P[3]), format: G ? "name" : "hex" } : false)))))))));
    }
    function ih(T) {
      return Boolean(Ku.CSS_UNIT.exec(String(T)));
    }
    var h1 = 2, Ow = 0.16, tA = 0.05, rA = 0.05, nA = 0.15, aA = 5, iA = 4, G3 = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
    function kw(T) {
      var G = T.r, P = T.g, I = T.b, L = sp(G, P, I);
      return { h: L.h * 360, s: L.s, v: L.v };
    }
    function v12(T) {
      var G = T.r, P = T.g, I = T.b;
      return "#".concat(up(G, P, I, false));
    }
    function W3(T, G, P) {
      var I = P / 100, L = { r: (G.r - T.r) * I + T.r, g: (G.g - T.g) * I + T.g, b: (G.b - T.b) * I + T.b };
      return L;
    }
    function oA(T, G, P) {
      var I;
      return Math.round(T.h) >= 60 && Math.round(T.h) <= 240 ? I = P ? Math.round(T.h) - h1 * G : Math.round(T.h) + h1 * G : I = P ? Math.round(T.h) + h1 * G : Math.round(T.h) - h1 * G, I < 0 ? I += 360 : I >= 360 && (I -= 360), I;
    }
    function sA(T, G, P) {
      if (T.h === 0 && T.s === 0)
        return T.s;
      var I;
      return P ? I = T.s - Ow * G : G === iA ? I = T.s + Ow : I = T.s + tA * G, I > 1 && (I = 1), P && G === aA && I > 0.1 && (I = 0.1), I < 0.06 && (I = 0.06), Number(I.toFixed(2));
    }
    function d1(T, G, P) {
      var I;
      return P ? I = T.v + rA * G : I = T.v - nA * G, I > 1 && (I = 1), Number(I.toFixed(2));
    }
    function Rw(T) {
      for (var G = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, P = [], I = ah(T), L = aA; L > 0; L -= 1) {
        var j = kw(I), J = v12(ah({ h: oA(j, L, true), s: sA(j, L, true), v: d1(j, L, true) }));
        P.push(J);
      }
      P.push(v12(I));
      for (var te = 1; te <= iA; te += 1) {
        var Q = kw(I), he = v12(ah({ h: oA(Q, te), s: sA(Q, te), v: d1(Q, te) }));
        P.push(he);
      }
      return G.theme === "dark" ? G3.map(function(de) {
        var Ae = de.index, We = de.opacity, Xe = v12(W3(ah(G.backgroundColor || "#141414"), ah(P[Ae]), We * 100));
        return Xe;
      }) : P;
    }
    var Fw = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, Zu = {}, Nw = {};
    Object.keys(Fw).forEach(function(T) {
      Zu[T] = Rw(Fw[T]), Zu[T].primary = Zu[T][5], Nw[T] = Rw(Fw[T], { theme: "dark", backgroundColor: "#141414" }), Nw[T].primary = Nw[T][5];
    }), Zu.red, Zu.volcano, Zu.gold, Zu.orange, Zu.yellow, Zu.lime, Zu.green, Zu.cyan, Zu.blue, Zu.geekblue, Zu.purple, Zu.magenta, Zu.grey;
    var uA = {};
    function zo(T, G) {
    }
    function Io(T, G, P) {
      !G && !uA[P] && (T(false, P), uA[P] = true);
    }
    function oh(T, G) {
      Io(zo, T, G);
    }
    function lA() {
      return !!(typeof window != "undefined" && window.document && window.document.createElement);
    }
    var U3 = "rc-util-key";
    function cA() {
      var T = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, G = T.mark;
      return G ? G.startsWith("data-") ? G : "data-".concat(G) : U3;
    }
    function Vw(T) {
      if (T.attachTo)
        return T.attachTo;
      var G = document.querySelector("head");
      return G || document.body;
    }
    function fA(T) {
      var G, P = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      if (!lA())
        return null;
      var I = document.createElement("style");
      if (!((G = P.csp) === null || G === void 0) && G.nonce) {
        var L;
        I.nonce = (L = P.csp) === null || L === void 0 ? void 0 : L.nonce;
      }
      I.innerHTML = T;
      var j = Vw(P), J = j.firstChild;
      return P.prepend && j.prepend ? j.prepend(I) : P.prepend && J ? j.insertBefore(I, J) : j.appendChild(I), I;
    }
    var p1 = /* @__PURE__ */ new Map();
    function H3(T) {
      var G = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, P = Vw(G);
      return Array.from(p1.get(P).children).find(function(I) {
        return I.tagName === "STYLE" && I.getAttribute(cA(G)) === T;
      });
    }
    function hu(T, G) {
      var P = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, I = Vw(P);
      if (!p1.has(I)) {
        var L = fA("", P), j = L.parentNode;
        p1.set(I, j), j.removeChild(L);
      }
      var J = H3(G, P);
      if (J) {
        var te, Q;
        if (((te = P.csp) === null || te === void 0 ? void 0 : te.nonce) && J.nonce !== ((Q = P.csp) === null || Q === void 0 ? void 0 : Q.nonce)) {
          var he;
          J.nonce = (he = P.csp) === null || he === void 0 ? void 0 : he.nonce;
        }
        return J.innerHTML !== T && (J.innerHTML = T), J;
      }
      var de = fA(T, P);
      return de.setAttribute(cA(P), G), de;
    }
    function jw(T, G) {
      oh(T, "[@ant-design/icons] ".concat(G));
    }
    function Zv(T) {
      return kn(T) === "object" && typeof T.name == "string" && typeof T.theme == "string" && (kn(T.icon) === "object" || typeof T.icon == "function");
    }
    function Bw() {
      var T = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      return Object.keys(T).reduce(function(G, P) {
        var I = T[P];
        switch (P) {
          case "class":
            G.className = I, delete G.class;
            break;
          default:
            G[P] = I;
        }
        return G;
      }, {});
    }
    function Iy(T, G, P) {
      return P ? f2.default.createElement(T.tag, At(At({ key: G }, Bw(T.attrs)), P), (T.children || []).map(function(I, L) {
        return Iy(I, "".concat(G, "-").concat(T.tag, "-").concat(L));
      })) : f2.default.createElement(T.tag, At({ key: G }, Bw(T.attrs)), (T.children || []).map(function(I, L) {
        return Iy(I, "".concat(G, "-").concat(T.tag, "-").concat(L));
      }));
    }
    function dc(T) {
      return Rw(T)[0];
    }
    function zw(T) {
      return T ? Array.isArray(T) ? T : [T] : [];
    }
    var hA = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, vA = function() {
      var T = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : hA, G = u.useContext(ke), P = G.csp;
      u.useEffect(function() {
        hu(T, "@ant-design-icons", { prepend: true, csp: P });
      }, []);
    }, dA = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], Vg = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
    function pA(T) {
      var G = T.primaryColor, P = T.secondaryColor;
      Vg.primaryColor = G, Vg.secondaryColor = P || dc(G), Vg.calculated = !!P;
    }
    function pc() {
      return At({}, Vg);
    }
    var g1 = function(T) {
      var G = T.icon, P = T.className, I = T.onClick, L = T.style, j = T.primaryColor, J = T.secondaryColor, te = ma(T, dA), Q = Vg;
      if (j && (Q = { primaryColor: j, secondaryColor: J || dc(j) }), vA(), jw(Zv(G), "icon should be icon definiton, but got ".concat(G)), !Zv(G))
        return null;
      var he = G;
      return he && typeof he.icon == "function" && (he = At(At({}, he), {}, { icon: he.icon(Q.primaryColor, Q.secondaryColor) })), Iy(he.icon, "svg-".concat(he.name), At({ className: P, onClick: I, style: L, "data-icon": he.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, te));
    };
    g1.displayName = "IconReact", g1.getTwoToneColors = pc, g1.setTwoToneColors = pA;
    var Gl = g1;
    function gA(T) {
      var G = zw(T), P = sa(G, 2), I = P[0], L = P[1];
      return Gl.setTwoToneColors({ primaryColor: I, secondaryColor: L });
    }
    function yA() {
      var T = Gl.getTwoToneColors();
      return T.calculated ? [T.primaryColor, T.secondaryColor] : T.primaryColor;
    }
    var Xv = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
    gA("#1890ff");
    var fp = h.forwardRef(function(T, G) {
      var P, I = T.className, L = T.icon, j = T.spin, J = T.rotate, te = T.tabIndex, Q = T.onClick, he = T.twoToneColor, de = ma(T, Xv), Ae = h.useContext(ke), We = Ae.prefixCls, Xe = We === void 0 ? "anticon" : We, Ze = io(Xe, (P = {}, Ie(P, "".concat(Xe, "-").concat(L.name), !!L.name), Ie(P, "".concat(Xe, "-spin"), !!j || L.name === "loading"), P), I), it = te;
      it === void 0 && Q && (it = -1);
      var ct = J ? { msTransform: "rotate(".concat(J, "deg)"), transform: "rotate(".concat(J, "deg)") } : void 0, sr = zw(he), Yt = sa(sr, 2), Or = Yt[0], le = Yt[1];
      return h.createElement("span", At(At({ role: "img", "aria-label": L.name }, de), {}, { ref: G, tabIndex: it, onClick: Q, className: Ze }), h.createElement(Gl, { icon: L, primaryColor: Or, secondaryColor: le, style: ct }));
    });
    fp.displayName = "AntdIcon", fp.getTwoToneColor = yA, fp.setTwoToneColor = gA;
    var $w = fp, Ho = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, Jv = Ho, y1 = function(T, G) {
      return h.createElement($w, At(At({}, T), {}, { ref: G, icon: Jv }));
    };
    y1.displayName = "LoadingOutlined";
    var q32 = h.forwardRef(y1);
    function cs() {
      return cs = Object.assign || function(T) {
        for (var G = 1; G < arguments.length; G++) {
          var P = arguments[G];
          for (var I in P)
            Object.prototype.hasOwnProperty.call(P, I) && (T[I] = P[I]);
        }
        return T;
      }, cs.apply(this, arguments);
    }
    function Ly(T, G) {
      if (!(T instanceof G))
        throw new TypeError("Cannot call a class as a function");
    }
    function mA(T, G) {
      for (var P = 0; P < G.length; P++) {
        var I = G[P];
        I.enumerable = I.enumerable || false, I.configurable = true, "value" in I && (I.writable = true), Object.defineProperty(T, I.key, I);
      }
    }
    function Oy(T, G, P) {
      return G && mA(T.prototype, G), P && mA(T, P), Object.defineProperty(T, "prototype", { writable: false }), T;
    }
    function m1(T, G) {
      return m1 = Object.setPrototypeOf || function(P, I) {
        return P.__proto__ = I, P;
      }, m1(T, G);
    }
    function jg(T, G) {
      if (typeof G != "function" && G !== null)
        throw new TypeError("Super expression must either be null or a function");
      T.prototype = Object.create(G && G.prototype, { constructor: { value: T, writable: true, configurable: true } }), Object.defineProperty(T, "prototype", { writable: false }), G && m1(T, G);
    }
    function ev(T) {
      return ev = Object.setPrototypeOf ? Object.getPrototypeOf : function(G) {
        return G.__proto__ || Object.getPrototypeOf(G);
      }, ev(T);
    }
    function Y3() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function b1(T) {
      if (T === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return T;
    }
    function bA(T, G) {
      if (G && (kn(G) === "object" || typeof G == "function"))
        return G;
      if (G !== void 0)
        throw new TypeError("Derived constructors may only return object or undefined");
      return b1(T);
    }
    function ky(T) {
      var G = Y3();
      return function() {
        var P = ev(T), I;
        if (G) {
          var L = ev(this).constructor;
          I = Reflect.construct(P, arguments, L);
        } else
          I = P.apply(this, arguments);
        return bA(this, I);
      };
    }
    var Ry = { exports: {} }, Ji = {};
    /** @license React v16.13.1
    * react-is.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var vu = typeof Symbol == "function" && Symbol.for, Fy = vu ? Symbol.for("react.element") : 60103, Ny = vu ? Symbol.for("react.portal") : 60106, _1 = vu ? Symbol.for("react.fragment") : 60107, Vy = vu ? Symbol.for("react.strict_mode") : 60108, Xu = vu ? Symbol.for("react.profiler") : 60114, Bg = vu ? Symbol.for("react.provider") : 60109, Qv = vu ? Symbol.for("react.context") : 60110, x1 = vu ? Symbol.for("react.async_mode") : 60111, jy = vu ? Symbol.for("react.concurrent_mode") : 60111, w1 = vu ? Symbol.for("react.forward_ref") : 60112, S1 = vu ? Symbol.for("react.suspense") : 60113, K3 = vu ? Symbol.for("react.suspense_list") : 60120, C1 = vu ? Symbol.for("react.memo") : 60115, E1 = vu ? Symbol.for("react.lazy") : 60116, zg = vu ? Symbol.for("react.block") : 60121, Z3 = vu ? Symbol.for("react.fundamental") : 60117, X3 = vu ? Symbol.for("react.responder") : 60118, Gw = vu ? Symbol.for("react.scope") : 60119;
    function Wl(T) {
      if (typeof T == "object" && T !== null) {
        var G = T.$$typeof;
        switch (G) {
          case Fy:
            switch (T = T.type, T) {
              case x1:
              case jy:
              case _1:
              case Xu:
              case Vy:
              case S1:
                return T;
              default:
                switch (T = T && T.$$typeof, T) {
                  case Qv:
                  case w1:
                  case E1:
                  case C1:
                  case Bg:
                    return T;
                  default:
                    return G;
                }
            }
          case Ny:
            return G;
        }
      }
    }
    function tv(T) {
      return Wl(T) === jy;
    }
    Ji.AsyncMode = x1, Ji.ConcurrentMode = jy, Ji.ContextConsumer = Qv, Ji.ContextProvider = Bg, Ji.Element = Fy, Ji.ForwardRef = w1, Ji.Fragment = _1, Ji.Lazy = E1, Ji.Memo = C1, Ji.Portal = Ny, Ji.Profiler = Xu, Ji.StrictMode = Vy, Ji.Suspense = S1, Ji.isAsyncMode = function(T) {
      return tv(T) || Wl(T) === x1;
    }, Ji.isConcurrentMode = tv, Ji.isContextConsumer = function(T) {
      return Wl(T) === Qv;
    }, Ji.isContextProvider = function(T) {
      return Wl(T) === Bg;
    }, Ji.isElement = function(T) {
      return typeof T == "object" && T !== null && T.$$typeof === Fy;
    }, Ji.isForwardRef = function(T) {
      return Wl(T) === w1;
    }, Ji.isFragment = function(T) {
      return Wl(T) === _1;
    }, Ji.isLazy = function(T) {
      return Wl(T) === E1;
    }, Ji.isMemo = function(T) {
      return Wl(T) === C1;
    }, Ji.isPortal = function(T) {
      return Wl(T) === Ny;
    }, Ji.isProfiler = function(T) {
      return Wl(T) === Xu;
    }, Ji.isStrictMode = function(T) {
      return Wl(T) === Vy;
    }, Ji.isSuspense = function(T) {
      return Wl(T) === S1;
    }, Ji.isValidElementType = function(T) {
      return typeof T == "string" || typeof T == "function" || T === _1 || T === jy || T === Xu || T === Vy || T === S1 || T === K3 || typeof T == "object" && T !== null && (T.$$typeof === E1 || T.$$typeof === C1 || T.$$typeof === Bg || T.$$typeof === Qv || T.$$typeof === w1 || T.$$typeof === Z3 || T.$$typeof === X3 || T.$$typeof === Gw || T.$$typeof === zg);
    }, Ji.typeOf = Wl, Ry.exports = Ji;
    function $g(T) {
      var G = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, P = [];
      return f2.default.Children.forEach(T, function(I) {
        I == null && !G.keepEmpty || (Array.isArray(I) ? P = P.concat($g(I)) : Ry.exports.isFragment(I) && I.props ? P = P.concat($g(I.props.children, G)) : P.push(I));
      }), P;
    }
    function J3(T, G) {
      typeof T == "function" ? T(G) : kn(T) === "object" && T && "current" in T && (T.current = G);
    }
    function Q3() {
      for (var T = arguments.length, G = new Array(T), P = 0; P < T; P++)
        G[P] = arguments[P];
      var I = G.filter(function(L) {
        return L;
      });
      return I.length <= 1 ? I[0] : function(L) {
        G.forEach(function(j) {
          J3(j, L);
        });
      };
    }
    function eD(T) {
      var G, P, I = Ry.exports.isMemo(T) ? T.type.type : T.type;
      return !(typeof I == "function" && !(!((G = I.prototype) === null || G === void 0) && G.render) || typeof T == "function" && !(!((P = T.prototype) === null || P === void 0) && P.render));
    }
    function Gg() {
      try {
        if (!Object.assign)
          return false;
        var T = new String("abc");
        if (T[5] = "de", Object.getOwnPropertyNames(T)[0] === "5")
          return false;
        for (var G = {}, P = 0; P < 10; P++)
          G["_" + String.fromCharCode(P)] = P;
        var I = Object.getOwnPropertyNames(G).map(function(j) {
          return G[j];
        });
        if (I.join("") !== "0123456789")
          return false;
        var L = {};
        return "abcdefghijklmnopqrst".split("").forEach(function(j) {
          L[j] = j;
        }), Object.keys(Object.assign({}, L)).join("") === "abcdefghijklmnopqrst";
      } catch {
        return false;
      }
    }
    Gg();
    function _f(T) {
      if (Array.isArray(T))
        return Rr(T);
    }
    function Ww(T) {
      if (typeof Symbol != "undefined" && T[Symbol.iterator] != null || T["@@iterator"] != null)
        return Array.from(T);
    }
    function tD() {
      throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function Ti(T) {
      return _f(T) || Ww(T) || wn(T) || tD();
    }
    var Wg = "RC_FORM_INTERNAL_HOOKS", $o = function() {
      oh(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
    }, By = h.createContext({ getFieldValue: $o, getFieldsValue: $o, getFieldError: $o, getFieldWarning: $o, getFieldsError: $o, isFieldsTouched: $o, isFieldTouched: $o, isFieldValidating: $o, isFieldsValidating: $o, resetFields: $o, setFields: $o, setFieldsValue: $o, validateFields: $o, submit: $o, getInternalHooks: function() {
      return $o(), { dispatch: $o, initEntityValue: $o, registerField: $o, useSubscribe: $o, setInitialValues: $o, setCallbacks: $o, getFields: $o, setValidateMessages: $o, setPreserve: $o, getInitialValue: $o };
    } });
    function ed(T) {
      return T == null ? [] : Array.isArray(T) ? T : [T];
    }
    var ft = { exports: {} };
    (function(T) {
      var G = function(P) {
        var I = Object.prototype, L = I.hasOwnProperty, j, J = typeof Symbol == "function" ? Symbol : {}, te = J.iterator || "@@iterator", Q = J.asyncIterator || "@@asyncIterator", he = J.toStringTag || "@@toStringTag";
        function de(ur, Gt, zt) {
          return Object.defineProperty(ur, Gt, { value: zt, enumerable: true, configurable: true, writable: true }), ur[Gt];
        }
        try {
          de({}, "");
        } catch {
          de = function(ur, Gt, zt) {
            return ur[Gt] = zt;
          };
        }
        function Ae(ur, Gt, zt, Yr) {
          var Vr = Gt && Gt.prototype instanceof Yt ? Gt : Yt, Qn = Object.create(Vr.prototype), Ua = new ln(Yr || []);
          return Qn._invoke = dr(ur, zt, Ua), Qn;
        }
        P.wrap = Ae;
        function We(ur, Gt, zt) {
          try {
            return { type: "normal", arg: ur.call(Gt, zt) };
          } catch (Yr) {
            return { type: "throw", arg: Yr };
          }
        }
        var Xe = "suspendedStart", Ze = "suspendedYield", it = "executing", ct = "completed", sr = {};
        function Yt() {
        }
        function Or() {
        }
        function le() {
        }
        var _t = {};
        de(_t, te, function() {
          return this;
        });
        var Pt = Object.getPrototypeOf, er = Pt && Pt(Pt(Jt([])));
        er && er !== I && L.call(er, te) && (_t = er);
        var Kt = le.prototype = Yt.prototype = Object.create(_t);
        Or.prototype = le, de(Kt, "constructor", le), de(le, "constructor", Or), Or.displayName = de(le, he, "GeneratorFunction");
        function St(ur) {
          ["next", "throw", "return"].forEach(function(Gt) {
            de(ur, Gt, function(zt) {
              return this._invoke(Gt, zt);
            });
          });
        }
        P.isGeneratorFunction = function(ur) {
          var Gt = typeof ur == "function" && ur.constructor;
          return Gt ? Gt === Or || (Gt.displayName || Gt.name) === "GeneratorFunction" : false;
        }, P.mark = function(ur) {
          return Object.setPrototypeOf ? Object.setPrototypeOf(ur, le) : (ur.__proto__ = le, de(ur, he, "GeneratorFunction")), ur.prototype = Object.create(Kt), ur;
        }, P.awrap = function(ur) {
          return { __await: ur };
        };
        function kt(ur, Gt) {
          function zt(Qn, Ua, ua, Pa) {
            var qi = We(ur[Qn], ur, Ua);
            if (qi.type === "throw")
              Pa(qi.arg);
            else {
              var Ha = qi.arg, pi = Ha.value;
              return pi && typeof pi == "object" && L.call(pi, "__await") ? Gt.resolve(pi.__await).then(function(Lo) {
                zt("next", Lo, ua, Pa);
              }, function(Lo) {
                zt("throw", Lo, ua, Pa);
              }) : Gt.resolve(pi).then(function(Lo) {
                Ha.value = Lo, ua(Ha);
              }, function(Lo) {
                return zt("throw", Lo, ua, Pa);
              });
            }
          }
          var Yr;
          function Vr(Qn, Ua) {
            function ua() {
              return new Gt(function(Pa, qi) {
                zt(Qn, Ua, Pa, qi);
              });
            }
            return Yr = Yr ? Yr.then(ua, ua) : ua();
          }
          this._invoke = Vr;
        }
        St(kt.prototype), de(kt.prototype, Q, function() {
          return this;
        }), P.AsyncIterator = kt, P.async = function(ur, Gt, zt, Yr, Vr) {
          Vr === void 0 && (Vr = Promise);
          var Qn = new kt(Ae(ur, Gt, zt, Yr), Vr);
          return P.isGeneratorFunction(Gt) ? Qn : Qn.next().then(function(Ua) {
            return Ua.done ? Ua.value : Qn.next();
          });
        };
        function dr(ur, Gt, zt) {
          var Yr = Xe;
          return function(Vr, Qn) {
            if (Yr === it)
              throw new Error("Generator is already running");
            if (Yr === ct) {
              if (Vr === "throw")
                throw Qn;
              return In();
            }
            for (zt.method = Vr, zt.arg = Qn; ; ) {
              var Ua = zt.delegate;
              if (Ua) {
                var ua = Ir(Ua, zt);
                if (ua) {
                  if (ua === sr)
                    continue;
                  return ua;
                }
              }
              if (zt.method === "next")
                zt.sent = zt._sent = zt.arg;
              else if (zt.method === "throw") {
                if (Yr === Xe)
                  throw Yr = ct, zt.arg;
                zt.dispatchException(zt.arg);
              } else
                zt.method === "return" && zt.abrupt("return", zt.arg);
              Yr = it;
              var Pa = We(ur, Gt, zt);
              if (Pa.type === "normal") {
                if (Yr = zt.done ? ct : Ze, Pa.arg === sr)
                  continue;
                return { value: Pa.arg, done: zt.done };
              } else
                Pa.type === "throw" && (Yr = ct, zt.method = "throw", zt.arg = Pa.arg);
            }
          };
        }
        function Ir(ur, Gt) {
          var zt = ur.iterator[Gt.method];
          if (zt === j) {
            if (Gt.delegate = null, Gt.method === "throw") {
              if (ur.iterator.return && (Gt.method = "return", Gt.arg = j, Ir(ur, Gt), Gt.method === "throw"))
                return sr;
              Gt.method = "throw", Gt.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return sr;
          }
          var Yr = We(zt, ur.iterator, Gt.arg);
          if (Yr.type === "throw")
            return Gt.method = "throw", Gt.arg = Yr.arg, Gt.delegate = null, sr;
          var Vr = Yr.arg;
          if (!Vr)
            return Gt.method = "throw", Gt.arg = new TypeError("iterator result is not an object"), Gt.delegate = null, sr;
          if (Vr.done)
            Gt[ur.resultName] = Vr.value, Gt.next = ur.nextLoc, Gt.method !== "return" && (Gt.method = "next", Gt.arg = j);
          else
            return Vr;
          return Gt.delegate = null, sr;
        }
        St(Kt), de(Kt, he, "Generator"), de(Kt, te, function() {
          return this;
        }), de(Kt, "toString", function() {
          return "[object Generator]";
        });
        function ht(ur) {
          var Gt = { tryLoc: ur[0] };
          1 in ur && (Gt.catchLoc = ur[1]), 2 in ur && (Gt.finallyLoc = ur[2], Gt.afterLoc = ur[3]), this.tryEntries.push(Gt);
        }
        function gn(ur) {
          var Gt = ur.completion || {};
          Gt.type = "normal", delete Gt.arg, ur.completion = Gt;
        }
        function ln(ur) {
          this.tryEntries = [{ tryLoc: "root" }], ur.forEach(ht, this), this.reset(true);
        }
        P.keys = function(ur) {
          var Gt = [];
          for (var zt in ur)
            Gt.push(zt);
          return Gt.reverse(), function Yr() {
            for (; Gt.length; ) {
              var Vr = Gt.pop();
              if (Vr in ur)
                return Yr.value = Vr, Yr.done = false, Yr;
            }
            return Yr.done = true, Yr;
          };
        };
        function Jt(ur) {
          if (ur) {
            var Gt = ur[te];
            if (Gt)
              return Gt.call(ur);
            if (typeof ur.next == "function")
              return ur;
            if (!isNaN(ur.length)) {
              var zt = -1, Yr = function Vr() {
                for (; ++zt < ur.length; )
                  if (L.call(ur, zt))
                    return Vr.value = ur[zt], Vr.done = false, Vr;
                return Vr.value = j, Vr.done = true, Vr;
              };
              return Yr.next = Yr;
            }
          }
          return { next: In };
        }
        P.values = Jt;
        function In() {
          return { value: j, done: true };
        }
        return ln.prototype = { constructor: ln, reset: function(ur) {
          if (this.prev = 0, this.next = 0, this.sent = this._sent = j, this.done = false, this.delegate = null, this.method = "next", this.arg = j, this.tryEntries.forEach(gn), !ur)
            for (var Gt in this)
              Gt.charAt(0) === "t" && L.call(this, Gt) && !isNaN(+Gt.slice(1)) && (this[Gt] = j);
        }, stop: function() {
          this.done = true;
          var ur = this.tryEntries[0], Gt = ur.completion;
          if (Gt.type === "throw")
            throw Gt.arg;
          return this.rval;
        }, dispatchException: function(ur) {
          if (this.done)
            throw ur;
          var Gt = this;
          function zt(Pa, qi) {
            return Qn.type = "throw", Qn.arg = ur, Gt.next = Pa, qi && (Gt.method = "next", Gt.arg = j), !!qi;
          }
          for (var Yr = this.tryEntries.length - 1; Yr >= 0; --Yr) {
            var Vr = this.tryEntries[Yr], Qn = Vr.completion;
            if (Vr.tryLoc === "root")
              return zt("end");
            if (Vr.tryLoc <= this.prev) {
              var Ua = L.call(Vr, "catchLoc"), ua = L.call(Vr, "finallyLoc");
              if (Ua && ua) {
                if (this.prev < Vr.catchLoc)
                  return zt(Vr.catchLoc, true);
                if (this.prev < Vr.finallyLoc)
                  return zt(Vr.finallyLoc);
              } else if (Ua) {
                if (this.prev < Vr.catchLoc)
                  return zt(Vr.catchLoc, true);
              } else if (ua) {
                if (this.prev < Vr.finallyLoc)
                  return zt(Vr.finallyLoc);
              } else
                throw new Error("try statement without catch or finally");
            }
          }
        }, abrupt: function(ur, Gt) {
          for (var zt = this.tryEntries.length - 1; zt >= 0; --zt) {
            var Yr = this.tryEntries[zt];
            if (Yr.tryLoc <= this.prev && L.call(Yr, "finallyLoc") && this.prev < Yr.finallyLoc) {
              var Vr = Yr;
              break;
            }
          }
          Vr && (ur === "break" || ur === "continue") && Vr.tryLoc <= Gt && Gt <= Vr.finallyLoc && (Vr = null);
          var Qn = Vr ? Vr.completion : {};
          return Qn.type = ur, Qn.arg = Gt, Vr ? (this.method = "next", this.next = Vr.finallyLoc, sr) : this.complete(Qn);
        }, complete: function(ur, Gt) {
          if (ur.type === "throw")
            throw ur.arg;
          return ur.type === "break" || ur.type === "continue" ? this.next = ur.arg : ur.type === "return" ? (this.rval = this.arg = ur.arg, this.method = "return", this.next = "end") : ur.type === "normal" && Gt && (this.next = Gt), sr;
        }, finish: function(ur) {
          for (var Gt = this.tryEntries.length - 1; Gt >= 0; --Gt) {
            var zt = this.tryEntries[Gt];
            if (zt.finallyLoc === ur)
              return this.complete(zt.completion, zt.afterLoc), gn(zt), sr;
          }
        }, catch: function(ur) {
          for (var Gt = this.tryEntries.length - 1; Gt >= 0; --Gt) {
            var zt = this.tryEntries[Gt];
            if (zt.tryLoc === ur) {
              var Yr = zt.completion;
              if (Yr.type === "throw") {
                var Vr = Yr.arg;
                gn(zt);
              }
              return Vr;
            }
          }
          throw new Error("illegal catch attempt");
        }, delegateYield: function(ur, Gt, zt) {
          return this.delegate = { iterator: Jt(ur), resultName: Gt, nextLoc: zt }, this.method === "next" && (this.arg = j), sr;
        } }, P;
      }(T.exports);
      try {
        regeneratorRuntime = G;
      } catch {
        typeof globalThis == "object" ? globalThis.regeneratorRuntime = G : Function("r", "regeneratorRuntime = r")(G);
      }
    })(ft);
    var cr = ft.exports;
    function Zt(T, G, P, I, L, j, J) {
      try {
        var te = T[j](J), Q = te.value;
      } catch (he) {
        P(he);
        return;
      }
      te.done ? G(Q) : Promise.resolve(Q).then(I, L);
    }
    function bn(T) {
      return function() {
        var G = this, P = arguments;
        return new Promise(function(I, L) {
          var j = T.apply(G, P);
          function J(Q) {
            Zt(j, I, L, J, te, "next", Q);
          }
          function te(Q) {
            Zt(j, I, L, J, te, "throw", Q);
          }
          J(void 0);
        });
      };
    }
    function ta() {
      return ta = Object.assign || function(T) {
        for (var G = 1; G < arguments.length; G++) {
          var P = arguments[G];
          for (var I in P)
            Object.prototype.hasOwnProperty.call(P, I) && (T[I] = P[I]);
        }
        return T;
      }, ta.apply(this, arguments);
    }
    function Ui(T, G) {
      T.prototype = Object.create(G.prototype), T.prototype.constructor = T, Hi(T, G);
    }
    function _s(T) {
      return _s = Object.setPrototypeOf ? Object.getPrototypeOf : function(G) {
        return G.__proto__ || Object.getPrototypeOf(G);
      }, _s(T);
    }
    function Hi(T, G) {
      return Hi = Object.setPrototypeOf || function(P, I) {
        return P.__proto__ = I, P;
      }, Hi(T, G);
    }
    function Uw() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function A1(T, G, P) {
      return Uw() ? A1 = Reflect.construct : A1 = function(I, L, j) {
        var J = [null];
        J.push.apply(J, L);
        var te = Function.bind.apply(I, J), Q = new te();
        return j && Hi(Q, j.prototype), Q;
      }, A1.apply(null, arguments);
    }
    function Bc(T) {
      return Function.toString.call(T).indexOf("[native code]") !== -1;
    }
    function Ug(T) {
      var G = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
      return Ug = function(P) {
        if (P === null || !Bc(P))
          return P;
        if (typeof P != "function")
          throw new TypeError("Super expression must either be null or a function");
        if (typeof G != "undefined") {
          if (G.has(P))
            return G.get(P);
          G.set(P, I);
        }
        function I() {
          return A1(P, arguments, _s(this).constructor);
        }
        return I.prototype = Object.create(P.prototype, { constructor: { value: I, enumerable: false, writable: true, configurable: true } }), Hi(I, P);
      }, Ug(T);
    }
    var rD = /%[sdj%]/g, Hg = function() {
    };
    typeof process != "undefined" && process.env;
    function qg(T) {
      if (!T || !T.length)
        return null;
      var G = {};
      return T.forEach(function(P) {
        var I = P.field;
        G[I] = G[I] || [], G[I].push(P);
      }), G;
    }
    function Ju(T) {
      for (var G = arguments.length, P = new Array(G > 1 ? G - 1 : 0), I = 1; I < G; I++)
        P[I - 1] = arguments[I];
      var L = 0, j = P.length;
      if (typeof T == "function")
        return T.apply(null, P);
      if (typeof T == "string") {
        var J = T.replace(rD, function(te) {
          if (te === "%%")
            return "%";
          if (L >= j)
            return te;
          switch (te) {
            case "%s":
              return String(P[L++]);
            case "%d":
              return Number(P[L++]);
            case "%j":
              try {
                return JSON.stringify(P[L++]);
              } catch {
                return "[Circular]";
              }
              break;
            default:
              return te;
          }
        });
        return J;
      }
      return T;
    }
    function oo(T) {
      return T === "string" || T === "url" || T === "hex" || T === "email" || T === "date" || T === "pattern";
    }
    function Ks(T, G) {
      return !!(T == null || G === "array" && Array.isArray(T) && !T.length || oo(G) && typeof T == "string" && !T);
    }
    function _A(T, G, P) {
      var I = [], L = 0, j = T.length;
      function J(te) {
        I.push.apply(I, te || []), L++, L === j && P(I);
      }
      T.forEach(function(te) {
        G(te, J);
      });
    }
    function zy(T, G, P) {
      var I = 0, L = T.length;
      function j(J) {
        if (J && J.length) {
          P(J);
          return;
        }
        var te = I;
        I = I + 1, te < L ? G(T[te], j) : P([]);
      }
      j([]);
    }
    function nD(T) {
      var G = [];
      return Object.keys(T).forEach(function(P) {
        G.push.apply(G, T[P] || []);
      }), G;
    }
    var xA = function(T) {
      Ui(G, T);
      function G(P, I) {
        var L;
        return L = T.call(this, "Async Validation Error") || this, L.errors = P, L.fields = I, L;
      }
      return G;
    }(Ug(Error));
    function aD(T, G, P, I, L) {
      if (G.first) {
        var j = new Promise(function(We, Xe) {
          var Ze = function(ct) {
            return I(ct), ct.length ? Xe(new xA(ct, qg(ct))) : We(L);
          }, it = nD(T);
          zy(it, P, Ze);
        });
        return j.catch(function(We) {
          return We;
        }), j;
      }
      var J = G.firstFields === true ? Object.keys(T) : G.firstFields || [], te = Object.keys(T), Q = te.length, he = 0, de = [], Ae = new Promise(function(We, Xe) {
        var Ze = function(it) {
          if (de.push.apply(de, it), he++, he === Q)
            return I(de), de.length ? Xe(new xA(de, qg(de))) : We(L);
        };
        te.length || (I(de), We(L)), te.forEach(function(it) {
          var ct = T[it];
          J.indexOf(it) !== -1 ? zy(ct, P, Ze) : _A(ct, P, Ze);
        });
      });
      return Ae.catch(function(We) {
        return We;
      }), Ae;
    }
    function T1(T) {
      return !!(T && T.message !== void 0);
    }
    function td(T, G) {
      for (var P = T, I = 0; I < G.length; I++) {
        if (P == null)
          return P;
        P = P[G[I]];
      }
      return P;
    }
    function $y(T, G) {
      return function(P) {
        var I;
        return T.fullFields ? I = td(G, T.fullFields) : I = G[P.field || T.fullField], T1(P) ? (P.field = P.field || T.fullField, P.fieldValue = I, P) : { message: typeof P == "function" ? P() : P, fieldValue: I, field: P.field || T.fullField };
      };
    }
    function Hw(T, G) {
      if (G) {
        for (var P in G)
          if (G.hasOwnProperty(P)) {
            var I = G[P];
            typeof I == "object" && typeof T[P] == "object" ? T[P] = ta({}, T[P], I) : T[P] = I;
          }
      }
      return T;
    }
    var Gy = function(T, G, P, I, L, j) {
      T.required && (!P.hasOwnProperty(T.field) || Ks(G, j || T.type)) && I.push(Ju(L.messages.required, T.fullField));
    }, wA = function(T, G, P, I, L) {
      (/^\s+$/.test(G) || G === "") && I.push(Ju(L.messages.whitespace, T.fullField));
    }, M1 = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, rd = { integer: function(T) {
      return rd.number(T) && parseInt(T, 10) === T;
    }, float: function(T) {
      return rd.number(T) && !rd.integer(T);
    }, array: function(T) {
      return Array.isArray(T);
    }, regexp: function(T) {
      if (T instanceof RegExp)
        return true;
      try {
        return !!new RegExp(T);
      } catch {
        return false;
      }
    }, date: function(T) {
      return typeof T.getTime == "function" && typeof T.getMonth == "function" && typeof T.getYear == "function" && !isNaN(T.getTime());
    }, number: function(T) {
      return isNaN(T) ? false : typeof T == "number";
    }, object: function(T) {
      return typeof T == "object" && !rd.array(T);
    }, method: function(T) {
      return typeof T == "function";
    }, email: function(T) {
      return typeof T == "string" && T.length <= 320 && !!T.match(M1.email);
    }, url: function(T) {
      return typeof T == "string" && T.length <= 2048 && !!T.match(M1.url);
    }, hex: function(T) {
      return typeof T == "string" && !!T.match(M1.hex);
    } }, SA = function(T, G, P, I, L) {
      if (T.required && G === void 0) {
        Gy(T, G, P, I, L);
        return;
      }
      var j = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], J = T.type;
      j.indexOf(J) > -1 ? rd[J](G) || I.push(Ju(L.messages.types[J], T.fullField, T.type)) : J && typeof G !== T.type && I.push(Ju(L.messages.types[J], T.fullField, T.type));
    }, Wy = function(T, G, P, I, L) {
      var j = typeof T.len == "number", J = typeof T.min == "number", te = typeof T.max == "number", Q = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, he = G, de = null, Ae = typeof G == "number", We = typeof G == "string", Xe = Array.isArray(G);
      if (Ae ? de = "number" : We ? de = "string" : Xe && (de = "array"), !de)
        return false;
      Xe && (he = G.length), We && (he = G.replace(Q, "_").length), j ? he !== T.len && I.push(Ju(L.messages[de].len, T.fullField, T.len)) : J && !te && he < T.min ? I.push(Ju(L.messages[de].min, T.fullField, T.min)) : te && !J && he > T.max ? I.push(Ju(L.messages[de].max, T.fullField, T.max)) : J && te && (he < T.min || he > T.max) && I.push(Ju(L.messages[de].range, T.fullField, T.min, T.max));
    }, zc = "enum", P1 = function(T, G, P, I, L) {
      T[zc] = Array.isArray(T[zc]) ? T[zc] : [], T[zc].indexOf(G) === -1 && I.push(Ju(L.messages[zc], T.fullField, T[zc].join(", ")));
    }, iD = function(T, G, P, I, L) {
      if (T.pattern) {
        if (T.pattern instanceof RegExp)
          T.pattern.lastIndex = 0, T.pattern.test(G) || I.push(Ju(L.messages.pattern.mismatch, T.fullField, G, T.pattern));
        else if (typeof T.pattern == "string") {
          var j = new RegExp(T.pattern);
          j.test(G) || I.push(Ju(L.messages.pattern.mismatch, T.fullField, G, T.pattern));
        }
      }
    }, Si = { required: Gy, whitespace: wA, type: SA, range: Wy, enum: P1, pattern: iD }, oD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G, "string") && !T.required)
          return P();
        Si.required(T, G, I, j, L, "string"), Ks(G, "string") || (Si.type(T, G, I, j, L), Si.range(T, G, I, j, L), Si.pattern(T, G, I, j, L), T.whitespace === true && Si.whitespace(T, G, I, j, L));
      }
      P(j);
    }, D1 = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && Si.type(T, G, I, j, L);
      }
      P(j);
    }, I1 = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (G === "" && (G = void 0), Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && (Si.type(T, G, I, j, L), Si.range(T, G, I, j, L));
      }
      P(j);
    }, qw = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && Si.type(T, G, I, j, L);
      }
      P(j);
    }, sD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), Ks(G) || Si.type(T, G, I, j, L);
      }
      P(j);
    }, CA = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && (Si.type(T, G, I, j, L), Si.range(T, G, I, j, L));
      }
      P(j);
    }, uD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && (Si.type(T, G, I, j, L), Si.range(T, G, I, j, L));
      }
      P(j);
    }, lD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (G == null && !T.required)
          return P();
        Si.required(T, G, I, j, L, "array"), G != null && (Si.type(T, G, I, j, L), Si.range(T, G, I, j, L));
      }
      P(j);
    }, Zs = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && Si.type(T, G, I, j, L);
      }
      P(j);
    }, Qu = "enum", cD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L), G !== void 0 && Si[Qu](T, G, I, j, L);
      }
      P(j);
    }, fD = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G, "string") && !T.required)
          return P();
        Si.required(T, G, I, j, L), Ks(G, "string") || Si.pattern(T, G, I, j, L);
      }
      P(j);
    }, EA = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G, "date") && !T.required)
          return P();
        if (Si.required(T, G, I, j, L), !Ks(G, "date")) {
          var te;
          G instanceof Date ? te = G : te = new Date(G), Si.type(T, te, I, j, L), te && Si.range(T, te.getTime(), I, j, L);
        }
      }
      P(j);
    }, hD = function(T, G, P, I, L) {
      var j = [], J = Array.isArray(G) ? "array" : typeof G;
      Si.required(T, G, I, j, L, J), P(j);
    }, Uy = function(T, G, P, I, L) {
      var j = T.type, J = [], te = T.required || !T.required && I.hasOwnProperty(T.field);
      if (te) {
        if (Ks(G, j) && !T.required)
          return P();
        Si.required(T, G, I, J, L, j), Ks(G, j) || Si.type(T, G, I, J, L);
      }
      P(J);
    }, Hy = function(T, G, P, I, L) {
      var j = [], J = T.required || !T.required && I.hasOwnProperty(T.field);
      if (J) {
        if (Ks(G) && !T.required)
          return P();
        Si.required(T, G, I, j, L);
      }
      P(j);
    }, hp = { string: oD, method: D1, number: I1, boolean: qw, regexp: sD, integer: CA, float: uD, array: lD, object: Zs, enum: cD, pattern: fD, date: EA, url: Uy, hex: Uy, email: Uy, required: hD, any: Hy };
    function nd() {
      return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
        var T = JSON.parse(JSON.stringify(this));
        return T.clone = this.clone, T;
      } };
    }
    var vp = nd(), rv = function() {
      function T(P) {
        this.rules = null, this._messages = vp, this.define(P);
      }
      var G = T.prototype;
      return G.define = function(P) {
        var I = this;
        if (!P)
          throw new Error("Cannot configure a schema with no rules");
        if (typeof P != "object" || Array.isArray(P))
          throw new Error("Rules must be an object");
        this.rules = {}, Object.keys(P).forEach(function(L) {
          var j = P[L];
          I.rules[L] = Array.isArray(j) ? j : [j];
        });
      }, G.messages = function(P) {
        return P && (this._messages = Hw(nd(), P)), this._messages;
      }, G.validate = function(P, I, L) {
        var j = this;
        I === void 0 && (I = {}), L === void 0 && (L = function() {
        });
        var J = P, te = I, Q = L;
        if (typeof te == "function" && (Q = te, te = {}), !this.rules || Object.keys(this.rules).length === 0)
          return Q && Q(null, J), Promise.resolve(J);
        function he(Ze) {
          var it = [], ct = {};
          function sr(Or) {
            if (Array.isArray(Or)) {
              var le;
              it = (le = it).concat.apply(le, Or);
            } else
              it.push(Or);
          }
          for (var Yt = 0; Yt < Ze.length; Yt++)
            sr(Ze[Yt]);
          it.length ? (ct = qg(it), Q(it, ct)) : Q(null, J);
        }
        if (te.messages) {
          var de = this.messages();
          de === vp && (de = nd()), Hw(de, te.messages), te.messages = de;
        } else
          te.messages = this.messages();
        var Ae = {}, We = te.keys || Object.keys(this.rules);
        We.forEach(function(Ze) {
          var it = j.rules[Ze], ct = J[Ze];
          it.forEach(function(sr) {
            var Yt = sr;
            typeof Yt.transform == "function" && (J === P && (J = ta({}, J)), ct = J[Ze] = Yt.transform(ct)), typeof Yt == "function" ? Yt = { validator: Yt } : Yt = ta({}, Yt), Yt.validator = j.getValidationMethod(Yt), Yt.validator && (Yt.field = Ze, Yt.fullField = Yt.fullField || Ze, Yt.type = j.getType(Yt), Ae[Ze] = Ae[Ze] || [], Ae[Ze].push({ rule: Yt, value: ct, source: J, field: Ze }));
          });
        });
        var Xe = {};
        return aD(Ae, te, function(Ze, it) {
          var ct = Ze.rule, sr = (ct.type === "object" || ct.type === "array") && (typeof ct.fields == "object" || typeof ct.defaultField == "object");
          sr = sr && (ct.required || !ct.required && Ze.value), ct.field = Ze.field;
          function Yt(_t, Pt) {
            return ta({}, Pt, { fullField: ct.fullField + "." + _t, fullFields: ct.fullFields ? [].concat(ct.fullFields, [_t]) : [_t] });
          }
          function Or(_t) {
            _t === void 0 && (_t = []);
            var Pt = Array.isArray(_t) ? _t : [_t];
            !te.suppressWarning && Pt.length && T.warning("async-validator:", Pt), Pt.length && ct.message !== void 0 && (Pt = [].concat(ct.message));
            var er = Pt.map($y(ct, J));
            if (te.first && er.length)
              return Xe[ct.field] = 1, it(er);
            if (!sr)
              it(er);
            else {
              if (ct.required && !Ze.value)
                return ct.message !== void 0 ? er = [].concat(ct.message).map($y(ct, J)) : te.error && (er = [te.error(ct, Ju(te.messages.required, ct.field))]), it(er);
              var Kt = {};
              ct.defaultField && Object.keys(Ze.value).map(function(dr) {
                Kt[dr] = ct.defaultField;
              }), Kt = ta({}, Kt, Ze.rule.fields);
              var St = {};
              Object.keys(Kt).forEach(function(dr) {
                var Ir = Kt[dr], ht = Array.isArray(Ir) ? Ir : [Ir];
                St[dr] = ht.map(Yt.bind(null, dr));
              });
              var kt = new T(St);
              kt.messages(te.messages), Ze.rule.options && (Ze.rule.options.messages = te.messages, Ze.rule.options.error = te.error), kt.validate(Ze.value, Ze.rule.options || te, function(dr) {
                var Ir = [];
                er && er.length && Ir.push.apply(Ir, er), dr && dr.length && Ir.push.apply(Ir, dr), it(Ir.length ? Ir : null);
              });
            }
          }
          var le;
          ct.asyncValidator ? le = ct.asyncValidator(ct, Ze.value, Or, Ze.source, te) : ct.validator && (le = ct.validator(ct, Ze.value, Or, Ze.source, te), le === true ? Or() : le === false ? Or(typeof ct.message == "function" ? ct.message(ct.fullField || ct.field) : ct.message || (ct.fullField || ct.field) + " fails") : le instanceof Array ? Or(le) : le instanceof Error && Or(le.message)), le && le.then && le.then(function() {
            return Or();
          }, function(_t) {
            return Or(_t);
          });
        }, function(Ze) {
          he(Ze);
        }, J);
      }, G.getType = function(P) {
        if (P.type === void 0 && P.pattern instanceof RegExp && (P.type = "pattern"), typeof P.validator != "function" && P.type && !hp.hasOwnProperty(P.type))
          throw new Error(Ju("Unknown rule type %s", P.type));
        return P.type || "string";
      }, G.getValidationMethod = function(P) {
        if (typeof P.validator == "function")
          return P.validator;
        var I = Object.keys(P), L = I.indexOf("message");
        return L !== -1 && I.splice(L, 1), I.length === 1 && I[0] === "required" ? hp.required : hp[this.getType(P)] || void 0;
      }, T;
    }();
    rv.register = function(T, G) {
      if (typeof G != "function")
        throw new Error("Cannot register a validator by type, validator is not a function");
      hp[T] = G;
    }, rv.warning = Hg, rv.messages = vp, rv.validators = hp;
    var el = "'${name}' is not a valid ${type}", dp = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: el, method: el, array: el, object: el, number: el, date: el, boolean: el, integer: el, float: el, regexp: el, email: el, url: el, hex: el }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
    function AA(T, G) {
      for (var P = T, I = 0; I < G.length; I += 1) {
        if (P == null)
          return;
        P = P[G[I]];
      }
      return P;
    }
    function vD(T) {
      return Qt(T) || Ww(T) || wn(T) || Ba();
    }
    function TA(T, G, P, I) {
      if (!G.length)
        return P;
      var L = vD(G), j = L[0], J = L.slice(1), te;
      return !T && typeof j == "number" ? te = [] : Array.isArray(T) ? te = Ti(T) : te = At({}, T), I && P === void 0 && J.length === 1 ? delete te[j][J[0]] : te[j] = TA(te[j], J, P, I), te;
    }
    function dD(T, G, P) {
      var I = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
      return G.length && I && P === void 0 && !AA(T, G.slice(0, -1)) ? T : TA(T, G, P, I);
    }
    function Rs(T) {
      return ed(T);
    }
    function nv(T, G) {
      var P = AA(T, G);
      return P;
    }
    function xf(T, G, P) {
      var I = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, L = dD(T, G, P, I);
      return L;
    }
    function Yw(T, G) {
      var P = {};
      return G.forEach(function(I) {
        var L = nv(T, I);
        P = xf(P, I, L);
      }), P;
    }
    function _e(T, G) {
      return T && T.some(function(P) {
        return di(P, G);
      });
    }
    function pp(T) {
      return kn(T) === "object" && T !== null && Object.getPrototypeOf(T) === Object.prototype;
    }
    function qy(T, G) {
      var P = Array.isArray(T) ? Ti(T) : At({}, T);
      return G && Object.keys(G).forEach(function(I) {
        var L = P[I], j = G[I], J = pp(L) && pp(j);
        P[I] = J ? qy(L, j || {}) : j;
      }), P;
    }
    function Al(T) {
      for (var G = arguments.length, P = new Array(G > 1 ? G - 1 : 0), I = 1; I < G; I++)
        P[I - 1] = arguments[I];
      return P.reduce(function(L, j) {
        return qy(L, j);
      }, T);
    }
    function di(T, G) {
      return !T || !G || T.length !== G.length ? false : T.every(function(P, I) {
        return G[I] === P;
      });
    }
    function pD(T, G) {
      if (T === G)
        return true;
      if (!T && G || T && !G || !T || !G || kn(T) !== "object" || kn(G) !== "object")
        return false;
      var P = Object.keys(T), I = Object.keys(G), L = new Set([].concat(Ti(P), Ti(I)));
      return Ti(L).every(function(j) {
        var J = T[j], te = G[j];
        return typeof J == "function" && typeof te == "function" ? true : J === te;
      });
    }
    function gD(T) {
      var G = arguments.length <= 1 ? void 0 : arguments[1];
      return G && G.target && kn(G.target) === "object" && T in G.target ? G.target[T] : G;
    }
    function MA(T, G, P) {
      var I = T.length;
      if (G < 0 || G >= I || P < 0 || P >= I)
        return T;
      var L = T[G], j = G - P;
      return j > 0 ? [].concat(Ti(T.slice(0, P)), [L], Ti(T.slice(P, G)), Ti(T.slice(G + 1, I))) : j < 0 ? [].concat(Ti(T.slice(0, G)), Ti(T.slice(G + 1, P + 1)), [L], Ti(T.slice(P + 1, I))) : T;
    }
    var gp = rv;
    function yD(T, G) {
      return T.replace(/\$\{\w+\}/g, function(P) {
        var I = P.slice(2, -1);
        return G[I];
      });
    }
    function Kw(T, G, P, I, L) {
      return Zw.apply(this, arguments);
    }
    function Zw() {
      return Zw = bn(cr.mark(function T(G, P, I, L, j) {
        var J, te, Q, he, de, Ae, We, Xe;
        return cr.wrap(function(Ze) {
          for (; ; )
            switch (Ze.prev = Ze.next) {
              case 0:
                return J = At({}, I), delete J.ruleIndex, te = null, J && J.type === "array" && J.defaultField && (te = J.defaultField, delete J.defaultField), Q = new gp(Ie({}, G, [J])), he = Al({}, dp, L.validateMessages), Q.messages(he), de = [], Ze.prev = 8, Ze.next = 11, Promise.resolve(Q.validate(Ie({}, G, P), At({}, L)));
              case 11:
                Ze.next = 16;
                break;
              case 13:
                Ze.prev = 13, Ze.t0 = Ze.catch(8), Ze.t0.errors ? de = Ze.t0.errors.map(function(it, ct) {
                  var sr = it.message;
                  return h.isValidElement(sr) ? h.cloneElement(sr, { key: "error_".concat(ct) }) : sr;
                }) : (console.error(Ze.t0), de = [he.default]);
              case 16:
                if (!(!de.length && te)) {
                  Ze.next = 21;
                  break;
                }
                return Ze.next = 19, Promise.all(P.map(function(it, ct) {
                  return Kw("".concat(G, ".").concat(ct), it, te, L, j);
                }));
              case 19:
                return Ae = Ze.sent, Ze.abrupt("return", Ae.reduce(function(it, ct) {
                  return [].concat(Ti(it), Ti(ct));
                }, []));
              case 21:
                return We = At(At({}, I), {}, { name: G, enum: (I.enum || []).join(", ") }, j), Xe = de.map(function(it) {
                  return typeof it == "string" ? yD(it, We) : it;
                }), Ze.abrupt("return", Xe);
              case 24:
              case "end":
                return Ze.stop();
            }
        }, T, null, [[8, 13]]);
      })), Zw.apply(this, arguments);
    }
    function mD(T, G, P, I, L, j) {
      var J = T.join("."), te = P.map(function(de, Ae) {
        var We = de.validator, Xe = At(At({}, de), {}, { ruleIndex: Ae });
        return We && (Xe.validator = function(Ze, it, ct) {
          var sr = false, Yt = function() {
            for (var le = arguments.length, _t = new Array(le), Pt = 0; Pt < le; Pt++)
              _t[Pt] = arguments[Pt];
            Promise.resolve().then(function() {
              oh(!sr, "Your validator function has already return a promise. `callback` will be ignored."), sr || ct.apply(void 0, _t);
            });
          }, Or = We(Ze, it, Yt);
          sr = Or && typeof Or.then == "function" && typeof Or.catch == "function", oh(sr, "`callback` is deprecated. Please return a promise instead."), sr && Or.then(function() {
            ct();
          }).catch(function(le) {
            ct(le || " ");
          });
        }), Xe;
      }).sort(function(de, Ae) {
        var We = de.warningOnly, Xe = de.ruleIndex, Ze = Ae.warningOnly, it = Ae.ruleIndex;
        return !!We == !!Ze ? Xe - it : We ? 1 : -1;
      }), Q;
      if (L === true)
        Q = new Promise(function() {
          var de = bn(cr.mark(function Ae(We, Xe) {
            var Ze, it, ct;
            return cr.wrap(function(sr) {
              for (; ; )
                switch (sr.prev = sr.next) {
                  case 0:
                    Ze = 0;
                  case 1:
                    if (!(Ze < te.length)) {
                      sr.next = 12;
                      break;
                    }
                    return it = te[Ze], sr.next = 5, Kw(J, G, it, I, j);
                  case 5:
                    if (ct = sr.sent, !ct.length) {
                      sr.next = 9;
                      break;
                    }
                    return Xe([{ errors: ct, rule: it }]), sr.abrupt("return");
                  case 9:
                    Ze += 1, sr.next = 1;
                    break;
                  case 12:
                    We([]);
                  case 13:
                  case "end":
                    return sr.stop();
                }
            }, Ae);
          }));
          return function(Ae, We) {
            return de.apply(this, arguments);
          };
        }());
      else {
        var he = te.map(function(de) {
          return Kw(J, G, de, I, j).then(function(Ae) {
            return { errors: Ae, rule: de };
          });
        });
        Q = (L ? _D(he) : bD(he)).then(function(de) {
          return Promise.reject(de);
        });
      }
      return Q.catch(function(de) {
        return de;
      }), Q;
    }
    function bD(T) {
      return wf.apply(this, arguments);
    }
    function wf() {
      return wf = bn(cr.mark(function T(G) {
        return cr.wrap(function(P) {
          for (; ; )
            switch (P.prev = P.next) {
              case 0:
                return P.abrupt("return", Promise.all(G).then(function(I) {
                  var L, j = (L = []).concat.apply(L, Ti(I));
                  return j;
                }));
              case 1:
              case "end":
                return P.stop();
            }
        }, T);
      })), wf.apply(this, arguments);
    }
    function _D(T) {
      return Xw.apply(this, arguments);
    }
    function Xw() {
      return Xw = bn(cr.mark(function T(G) {
        var P;
        return cr.wrap(function(I) {
          for (; ; )
            switch (I.prev = I.next) {
              case 0:
                return P = 0, I.abrupt("return", new Promise(function(L) {
                  G.forEach(function(j) {
                    j.then(function(J) {
                      J.errors.length && L([J]), P += 1, P === G.length && L([]);
                    });
                  });
                }));
              case 2:
              case "end":
                return I.stop();
            }
        }, T);
      })), Xw.apply(this, arguments);
    }
    var xD = ["name"], $c = [];
    function PA(T, G, P, I, L, j) {
      return typeof T == "function" ? T(G, P, "source" in j ? { source: j.source } : {}) : I !== L;
    }
    var Sf = function(T) {
      jg(P, T);
      var G = ky(P);
      function P(I) {
        var L;
        if (Ly(this, P), L = G.call(this, I), L.state = { resetCount: 0 }, L.cancelRegisterFunc = null, L.mounted = false, L.touched = false, L.dirty = false, L.validatePromise = null, L.prevValidating = void 0, L.errors = $c, L.warnings = $c, L.cancelRegister = function() {
          var Q = L.props, he = Q.preserve, de = Q.isListField, Ae = Q.name;
          L.cancelRegisterFunc && L.cancelRegisterFunc(de, he, Rs(Ae)), L.cancelRegisterFunc = null;
        }, L.getNamePath = function() {
          var Q = L.props, he = Q.name, de = Q.fieldContext, Ae = de.prefixName, We = Ae === void 0 ? [] : Ae;
          return he !== void 0 ? [].concat(Ti(We), Ti(he)) : [];
        }, L.getRules = function() {
          var Q = L.props, he = Q.rules, de = he === void 0 ? [] : he, Ae = Q.fieldContext;
          return de.map(function(We) {
            return typeof We == "function" ? We(Ae) : We;
          });
        }, L.refresh = function() {
          !L.mounted || L.setState(function(Q) {
            var he = Q.resetCount;
            return { resetCount: he + 1 };
          });
        }, L.triggerMetaEvent = function(Q) {
          var he = L.props.onMetaChange;
          he == null || he(At(At({}, L.getMeta()), {}, { destroy: Q }));
        }, L.onStoreChange = function(Q, he, de) {
          var Ae = L.props, We = Ae.shouldUpdate, Xe = Ae.dependencies, Ze = Xe === void 0 ? [] : Xe, it = Ae.onReset, ct = de.store, sr = L.getNamePath(), Yt = L.getValue(Q), Or = L.getValue(ct), le = he && _e(he, sr);
          switch (de.type === "valueUpdate" && de.source === "external" && Yt !== Or && (L.touched = true, L.dirty = true, L.validatePromise = null, L.errors = $c, L.warnings = $c, L.triggerMetaEvent()), de.type) {
            case "reset":
              if (!he || le) {
                L.touched = false, L.dirty = false, L.validatePromise = null, L.errors = $c, L.warnings = $c, L.triggerMetaEvent(), it == null || it(), L.refresh();
                return;
              }
              break;
            case "remove": {
              if (We) {
                L.reRender();
                return;
              }
              break;
            }
            case "setField": {
              if (le) {
                var _t = de.data;
                "touched" in _t && (L.touched = _t.touched), "validating" in _t && !("originRCField" in _t) && (L.validatePromise = _t.validating ? Promise.resolve([]) : null), "errors" in _t && (L.errors = _t.errors || $c), "warnings" in _t && (L.warnings = _t.warnings || $c), L.dirty = true, L.triggerMetaEvent(), L.reRender();
                return;
              }
              if (We && !sr.length && PA(We, Q, ct, Yt, Or, de)) {
                L.reRender();
                return;
              }
              break;
            }
            case "dependenciesUpdate": {
              var Pt = Ze.map(Rs);
              if (Pt.some(function(er) {
                return _e(de.relatedFields, er);
              })) {
                L.reRender();
                return;
              }
              break;
            }
            default:
              if (le || (!Ze.length || sr.length || We) && PA(We, Q, ct, Yt, Or, de)) {
                L.reRender();
                return;
              }
              break;
          }
          We === true && L.reRender();
        }, L.validateRules = function(Q) {
          var he = L.getNamePath(), de = L.getValue(), Ae = Promise.resolve().then(function() {
            if (!L.mounted)
              return [];
            var We = L.props, Xe = We.validateFirst, Ze = Xe === void 0 ? false : Xe, it = We.messageVariables, ct = Q || {}, sr = ct.triggerName, Yt = L.getRules();
            sr && (Yt = Yt.filter(function(le) {
              var _t = le.validateTrigger;
              if (!_t)
                return true;
              var Pt = ed(_t);
              return Pt.includes(sr);
            }));
            var Or = mD(he, de, Yt, Q, Ze, it);
            return Or.catch(function(le) {
              return le;
            }).then(function() {
              var le = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : $c;
              if (L.validatePromise === Ae) {
                L.validatePromise = null;
                var _t = [], Pt = [];
                le.forEach(function(er) {
                  var Kt = er.rule.warningOnly, St = er.errors, kt = St === void 0 ? $c : St;
                  Kt ? Pt.push.apply(Pt, Ti(kt)) : _t.push.apply(_t, Ti(kt));
                }), L.errors = _t, L.warnings = Pt, L.triggerMetaEvent(), L.reRender();
              }
            }), Or;
          });
          return L.validatePromise = Ae, L.dirty = true, L.errors = $c, L.warnings = $c, L.triggerMetaEvent(), L.reRender(), Ae;
        }, L.isFieldValidating = function() {
          return !!L.validatePromise;
        }, L.isFieldTouched = function() {
          return L.touched;
        }, L.isFieldDirty = function() {
          if (L.dirty || L.props.initialValue !== void 0)
            return true;
          var Q = L.props.fieldContext, he = Q.getInternalHooks(Wg), de = he.getInitialValue;
          return de(L.getNamePath()) !== void 0;
        }, L.getErrors = function() {
          return L.errors;
        }, L.getWarnings = function() {
          return L.warnings;
        }, L.isListField = function() {
          return L.props.isListField;
        }, L.isList = function() {
          return L.props.isList;
        }, L.isPreserve = function() {
          return L.props.preserve;
        }, L.getMeta = function() {
          L.prevValidating = L.isFieldValidating();
          var Q = { touched: L.isFieldTouched(), validating: L.prevValidating, errors: L.errors, warnings: L.warnings, name: L.getNamePath() };
          return Q;
        }, L.getOnlyChild = function(Q) {
          if (typeof Q == "function") {
            var he = L.getMeta();
            return At(At({}, L.getOnlyChild(Q(L.getControlled(), he, L.props.fieldContext))), {}, { isFunction: true });
          }
          var de = $g(Q);
          return de.length !== 1 || !h.isValidElement(de[0]) ? { child: de, isFunction: false } : { child: de[0], isFunction: false };
        }, L.getValue = function(Q) {
          var he = L.props.fieldContext.getFieldsValue, de = L.getNamePath();
          return nv(Q || he(true), de);
        }, L.getControlled = function() {
          var Q = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, he = L.props, de = he.trigger, Ae = he.validateTrigger, We = he.getValueFromEvent, Xe = he.normalize, Ze = he.valuePropName, it = he.getValueProps, ct = he.fieldContext, sr = Ae !== void 0 ? Ae : ct.validateTrigger, Yt = L.getNamePath(), Or = ct.getInternalHooks, le = ct.getFieldsValue, _t = Or(Wg), Pt = _t.dispatch, er = L.getValue(), Kt = it || function(Ir) {
            return Ie({}, Ze, Ir);
          }, St = Q[de], kt = At(At({}, Q), Kt(er));
          kt[de] = function() {
            L.touched = true, L.dirty = true, L.triggerMetaEvent();
            for (var Ir, ht = arguments.length, gn = new Array(ht), ln = 0; ln < ht; ln++)
              gn[ln] = arguments[ln];
            We ? Ir = We.apply(void 0, gn) : Ir = gD.apply(void 0, [Ze].concat(gn)), Xe && (Ir = Xe(Ir, er, le(true))), Pt({ type: "updateValue", namePath: Yt, value: Ir }), St && St.apply(void 0, gn);
          };
          var dr = ed(sr || []);
          return dr.forEach(function(Ir) {
            var ht = kt[Ir];
            kt[Ir] = function() {
              ht && ht.apply(void 0, arguments);
              var gn = L.props.rules;
              gn && gn.length && Pt({ type: "validateField", namePath: Yt, triggerName: Ir });
            };
          }), kt;
        }, I.fieldContext) {
          var j = I.fieldContext.getInternalHooks, J = j(Wg), te = J.initEntityValue;
          te(b1(L));
        }
        return L;
      }
      return Oy(P, [{ key: "componentDidMount", value: function() {
        var I = this.props, L = I.shouldUpdate, j = I.fieldContext;
        if (this.mounted = true, j) {
          var J = j.getInternalHooks, te = J(Wg), Q = te.registerField;
          this.cancelRegisterFunc = Q(this);
        }
        L === true && this.reRender();
      } }, { key: "componentWillUnmount", value: function() {
        this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
      } }, { key: "reRender", value: function() {
        !this.mounted || this.forceUpdate();
      } }, { key: "render", value: function() {
        var I = this.state.resetCount, L = this.props.children, j = this.getOnlyChild(L), J = j.child, te = j.isFunction, Q;
        return te ? Q = J : h.isValidElement(J) ? Q = h.cloneElement(J, this.getControlled(J.props)) : (oh(!J, "`children` of Field is not validate ReactElement."), Q = J), h.createElement(h.Fragment, { key: I }, Q);
      } }]), P;
    }(h.Component);
    Sf.contextType = By, Sf.defaultProps = { trigger: "onChange", valuePropName: "value" };
    function DA(T) {
      var G = T.name, P = ma(T, xD), I = h.useContext(By), L = G !== void 0 ? Rs(G) : void 0, j = "keep";
      return P.isListField || (j = "_".concat((L || []).join("_"))), h.createElement(Sf, cs({ key: j, name: L }, P, { fieldContext: I }));
    }
    var wD = h.createContext(null), SD = function(T) {
      var G = T.name, P = T.initialValue, I = T.children, L = T.rules, j = T.validateTrigger, J = h.useContext(By), te = h.useRef({ keys: [], id: 0 }), Q = te.current, he = h.useMemo(function() {
        var Xe = Rs(J.prefixName) || [];
        return [].concat(Ti(Xe), Ti(Rs(G)));
      }, [J.prefixName, G]), de = h.useMemo(function() {
        return At(At({}, J), {}, { prefixName: he });
      }, [J, he]), Ae = h.useMemo(function() {
        return { getKey: function(Xe) {
          var Ze = he.length, it = Xe[Ze];
          return [Q.keys[it], Xe.slice(Ze + 1)];
        } };
      }, [he]);
      if (typeof I != "function")
        return oh(false, "Form.List only accepts function as children."), null;
      var We = function(Xe, Ze, it) {
        var ct = it.source;
        return ct === "internal" ? false : Xe !== Ze;
      };
      return h.createElement(wD.Provider, { value: Ae }, h.createElement(By.Provider, { value: de }, h.createElement(DA, { name: [], shouldUpdate: We, rules: L, validateTrigger: j, initialValue: P, isList: true }, function(Xe, Ze) {
        var it = Xe.value, ct = it === void 0 ? [] : it, sr = Xe.onChange, Yt = J.getFieldValue, Or = function() {
          var Pt = Yt(he || []);
          return Pt || [];
        }, le = { add: function(Pt, er) {
          var Kt = Or();
          er >= 0 && er <= Kt.length ? (Q.keys = [].concat(Ti(Q.keys.slice(0, er)), [Q.id], Ti(Q.keys.slice(er))), sr([].concat(Ti(Kt.slice(0, er)), [Pt], Ti(Kt.slice(er))))) : (Q.keys = [].concat(Ti(Q.keys), [Q.id]), sr([].concat(Ti(Kt), [Pt]))), Q.id += 1;
        }, remove: function(Pt) {
          var er = Or(), Kt = new Set(Array.isArray(Pt) ? Pt : [Pt]);
          Kt.size <= 0 || (Q.keys = Q.keys.filter(function(St, kt) {
            return !Kt.has(kt);
          }), sr(er.filter(function(St, kt) {
            return !Kt.has(kt);
          })));
        }, move: function(Pt, er) {
          if (Pt !== er) {
            var Kt = Or();
            Pt < 0 || Pt >= Kt.length || er < 0 || er >= Kt.length || (Q.keys = MA(Q.keys, Pt, er), sr(MA(Kt, Pt, er)));
          }
        } }, _t = ct || [];
        return Array.isArray(_t) || (_t = []), I(_t.map(function(Pt, er) {
          var Kt = Q.keys[er];
          return Kt === void 0 && (Q.keys[er] = Q.id, Kt = Q.keys[er], Q.id += 1), { name: er, key: Kt, isListField: true };
        }), le, Ze);
      })));
    };
    function CD(T) {
      var G = false, P = T.length, I = [];
      return T.length ? new Promise(function(L, j) {
        T.forEach(function(J, te) {
          J.catch(function(Q) {
            return G = true, Q;
          }).then(function(Q) {
            P -= 1, I[te] = Q, !(P > 0) && (G && j(I), L(I));
          });
        });
      }) : Promise.resolve([]);
    }
    var IA = "__@field_split__";
    function av(T) {
      return T.map(function(G) {
        return "".concat(kn(G), ":").concat(G);
      }).join(IA);
    }
    var Yy = function() {
      function T() {
        Ly(this, T), this.kvs = /* @__PURE__ */ new Map();
      }
      return Oy(T, [{ key: "set", value: function(G, P) {
        this.kvs.set(av(G), P);
      } }, { key: "get", value: function(G) {
        return this.kvs.get(av(G));
      } }, { key: "update", value: function(G, P) {
        var I = this.get(G), L = P(I);
        L ? this.set(G, L) : this.delete(G);
      } }, { key: "delete", value: function(G) {
        this.kvs.delete(av(G));
      } }, { key: "map", value: function(G) {
        return Ti(this.kvs.entries()).map(function(P) {
          var I = sa(P, 2), L = I[0], j = I[1], J = L.split(IA);
          return G({ key: J.map(function(te) {
            var Q = te.match(/^([^:]*):(.*)$/), he = sa(Q, 3), de = he[1], Ae = he[2];
            return de === "number" ? Number(Ae) : Ae;
          }), value: j });
        });
      } }, { key: "toJSON", value: function() {
        var G = {};
        return this.map(function(P) {
          var I = P.key, L = P.value;
          return G[I.join(".")] = L, null;
        }), G;
      } }]), T;
    }(), ED = ["name", "errors"], Cf = Oy(function T(G) {
      var P = this;
      Ly(this, T), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
        return { getFieldValue: P.getFieldValue, getFieldsValue: P.getFieldsValue, getFieldError: P.getFieldError, getFieldWarning: P.getFieldWarning, getFieldsError: P.getFieldsError, isFieldsTouched: P.isFieldsTouched, isFieldTouched: P.isFieldTouched, isFieldValidating: P.isFieldValidating, isFieldsValidating: P.isFieldsValidating, resetFields: P.resetFields, setFields: P.setFields, setFieldsValue: P.setFieldsValue, validateFields: P.validateFields, submit: P.submit, getInternalHooks: P.getInternalHooks };
      }, this.getInternalHooks = function(I) {
        return I === Wg ? (P.formHooked = true, { dispatch: P.dispatch, initEntityValue: P.initEntityValue, registerField: P.registerField, useSubscribe: P.useSubscribe, setInitialValues: P.setInitialValues, setCallbacks: P.setCallbacks, setValidateMessages: P.setValidateMessages, getFields: P.getFields, setPreserve: P.setPreserve, getInitialValue: P.getInitialValue }) : (oh(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
      }, this.useSubscribe = function(I) {
        P.subscribable = I;
      }, this.setInitialValues = function(I, L) {
        P.initialValues = I || {}, L && (P.store = Al({}, I, P.store));
      }, this.getInitialValue = function(I) {
        return nv(P.initialValues, I);
      }, this.setCallbacks = function(I) {
        P.callbacks = I;
      }, this.setValidateMessages = function(I) {
        P.validateMessages = I;
      }, this.setPreserve = function(I) {
        P.preserve = I;
      }, this.timeoutId = null, this.warningUnhooked = function() {
      }, this.getFieldEntities = function() {
        var I = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
        return I ? P.fieldEntities.filter(function(L) {
          return L.getNamePath().length;
        }) : P.fieldEntities;
      }, this.getFieldsMap = function() {
        var I = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, L = new Yy();
        return P.getFieldEntities(I).forEach(function(j) {
          var J = j.getNamePath();
          L.set(J, j);
        }), L;
      }, this.getFieldEntitiesForNamePathList = function(I) {
        if (!I)
          return P.getFieldEntities(true);
        var L = P.getFieldsMap(true);
        return I.map(function(j) {
          var J = Rs(j);
          return L.get(J) || { INVALIDATE_NAME_PATH: Rs(j) };
        });
      }, this.getFieldsValue = function(I, L) {
        if (P.warningUnhooked(), I === true && !L)
          return P.store;
        var j = P.getFieldEntitiesForNamePathList(Array.isArray(I) ? I : null), J = [];
        return j.forEach(function(te) {
          var Q, he = "INVALIDATE_NAME_PATH" in te ? te.INVALIDATE_NAME_PATH : te.getNamePath();
          if (!(!I && ((Q = te.isListField) === null || Q === void 0 ? void 0 : Q.call(te))))
            if (!L)
              J.push(he);
            else {
              var de = "getMeta" in te ? te.getMeta() : null;
              L(de) && J.push(he);
            }
        }), Yw(P.store, J.map(Rs));
      }, this.getFieldValue = function(I) {
        P.warningUnhooked();
        var L = Rs(I);
        return nv(P.store, L);
      }, this.getFieldsError = function(I) {
        P.warningUnhooked();
        var L = P.getFieldEntitiesForNamePathList(I);
        return L.map(function(j, J) {
          return j && !("INVALIDATE_NAME_PATH" in j) ? { name: j.getNamePath(), errors: j.getErrors(), warnings: j.getWarnings() } : { name: Rs(I[J]), errors: [], warnings: [] };
        });
      }, this.getFieldError = function(I) {
        P.warningUnhooked();
        var L = Rs(I), j = P.getFieldsError([L])[0];
        return j.errors;
      }, this.getFieldWarning = function(I) {
        P.warningUnhooked();
        var L = Rs(I), j = P.getFieldsError([L])[0];
        return j.warnings;
      }, this.isFieldsTouched = function() {
        P.warningUnhooked();
        for (var I = arguments.length, L = new Array(I), j = 0; j < I; j++)
          L[j] = arguments[j];
        var J = L[0], te = L[1], Q, he = false;
        L.length === 0 ? Q = null : L.length === 1 ? Array.isArray(J) ? (Q = J.map(Rs), he = false) : (Q = null, he = J) : (Q = J.map(Rs), he = te);
        var de = P.getFieldEntities(true), Ae = function(it) {
          return it.isFieldTouched();
        };
        if (!Q)
          return he ? de.every(Ae) : de.some(Ae);
        var We = new Yy();
        Q.forEach(function(it) {
          We.set(it, []);
        }), de.forEach(function(it) {
          var ct = it.getNamePath();
          Q.forEach(function(sr) {
            sr.every(function(Yt, Or) {
              return ct[Or] === Yt;
            }) && We.update(sr, function(Yt) {
              return [].concat(Ti(Yt), [it]);
            });
          });
        });
        var Xe = function(it) {
          return it.some(Ae);
        }, Ze = We.map(function(it) {
          var ct = it.value;
          return ct;
        });
        return he ? Ze.every(Xe) : Ze.some(Xe);
      }, this.isFieldTouched = function(I) {
        return P.warningUnhooked(), P.isFieldsTouched([I]);
      }, this.isFieldsValidating = function(I) {
        P.warningUnhooked();
        var L = P.getFieldEntities();
        if (!I)
          return L.some(function(J) {
            return J.isFieldValidating();
          });
        var j = I.map(Rs);
        return L.some(function(J) {
          var te = J.getNamePath();
          return _e(j, te) && J.isFieldValidating();
        });
      }, this.isFieldValidating = function(I) {
        return P.warningUnhooked(), P.isFieldsValidating([I]);
      }, this.resetWithFieldInitialValue = function() {
        var I = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, L = new Yy(), j = P.getFieldEntities(true);
        j.forEach(function(Q) {
          var he = Q.props.initialValue, de = Q.getNamePath();
          if (he !== void 0) {
            var Ae = L.get(de) || /* @__PURE__ */ new Set();
            Ae.add({ entity: Q, value: he }), L.set(de, Ae);
          }
        });
        var J = function(Q) {
          Q.forEach(function(he) {
            var de = he.props.initialValue;
            if (de !== void 0) {
              var Ae = he.getNamePath(), We = P.getInitialValue(Ae);
              if (We !== void 0)
                oh(false, "Form already set 'initialValues' with path '".concat(Ae.join("."), "'. Field can not overwrite it."));
              else {
                var Xe = L.get(Ae);
                if (Xe && Xe.size > 1)
                  oh(false, "Multiple Field with path '".concat(Ae.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                else if (Xe) {
                  var Ze = P.getFieldValue(Ae);
                  (!I.skipExist || Ze === void 0) && (P.store = xf(P.store, Ae, Ti(Xe)[0].value));
                }
              }
            }
          });
        }, te;
        I.entities ? te = I.entities : I.namePathList ? (te = [], I.namePathList.forEach(function(Q) {
          var he = L.get(Q);
          if (he) {
            var de;
            (de = te).push.apply(de, Ti(Ti(he).map(function(Ae) {
              return Ae.entity;
            })));
          }
        })) : te = j, J(te);
      }, this.resetFields = function(I) {
        P.warningUnhooked();
        var L = P.store;
        if (!I) {
          P.store = Al({}, P.initialValues), P.resetWithFieldInitialValue(), P.notifyObservers(L, null, { type: "reset" });
          return;
        }
        var j = I.map(Rs);
        j.forEach(function(J) {
          var te = P.getInitialValue(J);
          P.store = xf(P.store, J, te);
        }), P.resetWithFieldInitialValue({ namePathList: j }), P.notifyObservers(L, j, { type: "reset" });
      }, this.setFields = function(I) {
        P.warningUnhooked();
        var L = P.store;
        I.forEach(function(j) {
          var J = j.name;
          j.errors;
          var te = ma(j, ED), Q = Rs(J);
          "value" in te && (P.store = xf(P.store, Q, te.value)), P.notifyObservers(L, [Q], { type: "setField", data: j });
        });
      }, this.getFields = function() {
        var I = P.getFieldEntities(true), L = I.map(function(j) {
          var J = j.getNamePath(), te = j.getMeta(), Q = At(At({}, te), {}, { name: J, value: P.getFieldValue(J) });
          return Object.defineProperty(Q, "originRCField", { value: true }), Q;
        });
        return L;
      }, this.initEntityValue = function(I) {
        var L = I.props.initialValue;
        if (L !== void 0) {
          var j = I.getNamePath(), J = nv(P.store, j);
          J === void 0 && (P.store = xf(P.store, j, L));
        }
      }, this.registerField = function(I) {
        if (P.fieldEntities.push(I), I.props.initialValue !== void 0) {
          var L = P.store;
          P.resetWithFieldInitialValue({ entities: [I], skipExist: true }), P.notifyObservers(L, [I.getNamePath()], { type: "valueUpdate", source: "internal" });
        }
        return function(j, J) {
          var te = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
          P.fieldEntities = P.fieldEntities.filter(function(We) {
            return We !== I;
          });
          var Q = J !== void 0 ? J : P.preserve;
          if (Q === false && (!j || te.length > 1)) {
            var he = I.getNamePath(), de = j ? void 0 : nv(P.initialValues, he);
            if (he.length && P.getFieldValue(he) !== de && P.fieldEntities.every(function(We) {
              return !di(We.getNamePath(), he);
            })) {
              var Ae = P.store;
              P.store = xf(Ae, he, de, true), P.notifyObservers(Ae, [he], { type: "remove" }), P.triggerDependenciesUpdate(Ae, he);
            }
          }
        };
      }, this.dispatch = function(I) {
        switch (I.type) {
          case "updateValue": {
            var L = I.namePath, j = I.value;
            P.updateValue(L, j);
            break;
          }
          case "validateField": {
            var J = I.namePath, te = I.triggerName;
            P.validateFields([J], { triggerName: te });
            break;
          }
        }
      }, this.notifyObservers = function(I, L, j) {
        if (P.subscribable) {
          var J = At(At({}, j), {}, { store: P.getFieldsValue(true) });
          P.getFieldEntities().forEach(function(te) {
            var Q = te.onStoreChange;
            Q(I, L, J);
          });
        } else
          P.forceRootUpdate();
      }, this.triggerDependenciesUpdate = function(I, L) {
        var j = P.getDependencyChildrenFields(L);
        return j.length && P.validateFields(j), P.notifyObservers(I, j, { type: "dependenciesUpdate", relatedFields: [L].concat(Ti(j)) }), j;
      }, this.updateValue = function(I, L) {
        var j = Rs(I), J = P.store;
        P.store = xf(P.store, j, L), P.notifyObservers(J, [j], { type: "valueUpdate", source: "internal" });
        var te = P.triggerDependenciesUpdate(J, j), Q = P.callbacks.onValuesChange;
        if (Q) {
          var he = Yw(P.store, [j]);
          Q(he, P.getFieldsValue());
        }
        P.triggerOnFieldsChange([j].concat(Ti(te)));
      }, this.setFieldsValue = function(I) {
        P.warningUnhooked();
        var L = P.store;
        I && (P.store = Al(P.store, I)), P.notifyObservers(L, null, { type: "valueUpdate", source: "external" });
      }, this.getDependencyChildrenFields = function(I) {
        var L = /* @__PURE__ */ new Set(), j = [], J = new Yy();
        P.getFieldEntities().forEach(function(Q) {
          var he = Q.props.dependencies;
          (he || []).forEach(function(de) {
            var Ae = Rs(de);
            J.update(Ae, function() {
              var We = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
              return We.add(Q), We;
            });
          });
        });
        var te = function Q(he) {
          var de = J.get(he) || /* @__PURE__ */ new Set();
          de.forEach(function(Ae) {
            if (!L.has(Ae)) {
              L.add(Ae);
              var We = Ae.getNamePath();
              Ae.isFieldDirty() && We.length && (j.push(We), Q(We));
            }
          });
        };
        return te(I), j;
      }, this.triggerOnFieldsChange = function(I, L) {
        var j = P.callbacks.onFieldsChange;
        if (j) {
          var J = P.getFields();
          if (L) {
            var te = new Yy();
            L.forEach(function(he) {
              var de = he.name, Ae = he.errors;
              te.set(de, Ae);
            }), J.forEach(function(he) {
              he.errors = te.get(he.name) || he.errors;
            });
          }
          var Q = J.filter(function(he) {
            var de = he.name;
            return _e(I, de);
          });
          j(Q, J);
        }
      }, this.validateFields = function(I, L) {
        P.warningUnhooked();
        var j = !!I, J = j ? I.map(Rs) : [], te = [];
        P.getFieldEntities(true).forEach(function(de) {
          if (j || J.push(de.getNamePath()), (L == null ? void 0 : L.recursive) && j) {
            var Ae = de.getNamePath();
            Ae.every(function(Ze, it) {
              return I[it] === Ze || I[it] === void 0;
            }) && J.push(Ae);
          }
          if (!(!de.props.rules || !de.props.rules.length)) {
            var We = de.getNamePath();
            if (!j || _e(J, We)) {
              var Xe = de.validateRules(At({ validateMessages: At(At({}, dp), P.validateMessages) }, L));
              te.push(Xe.then(function() {
                return { name: We, errors: [], warnings: [] };
              }).catch(function(Ze) {
                var it = [], ct = [];
                return Ze.forEach(function(sr) {
                  var Yt = sr.rule.warningOnly, Or = sr.errors;
                  Yt ? ct.push.apply(ct, Ti(Or)) : it.push.apply(it, Ti(Or));
                }), it.length ? Promise.reject({ name: We, errors: it, warnings: ct }) : { name: We, errors: it, warnings: ct };
              }));
            }
          }
        });
        var Q = CD(te);
        P.lastValidatePromise = Q, Q.catch(function(de) {
          return de;
        }).then(function(de) {
          var Ae = de.map(function(We) {
            var Xe = We.name;
            return Xe;
          });
          P.notifyObservers(P.store, Ae, { type: "validateFinish" }), P.triggerOnFieldsChange(Ae, de);
        });
        var he = Q.then(function() {
          return P.lastValidatePromise === Q ? Promise.resolve(P.getFieldsValue(J)) : Promise.reject([]);
        }).catch(function(de) {
          var Ae = de.filter(function(We) {
            return We && We.errors.length;
          });
          return Promise.reject({ values: P.getFieldsValue(J), errorFields: Ae, outOfDate: P.lastValidatePromise !== Q });
        });
        return he.catch(function(de) {
          return de;
        }), he;
      }, this.submit = function() {
        P.warningUnhooked(), P.validateFields().then(function(I) {
          var L = P.callbacks.onFinish;
          if (L)
            try {
              L(I);
            } catch (j) {
              console.error(j);
            }
        }).catch(function(I) {
          var L = P.callbacks.onFinishFailed;
          L && L(I);
        });
      }, this.forceRootUpdate = G;
    });
    function LA(T) {
      var G = h.useRef(), P = h.useState({}), I = sa(P, 2), L = I[1];
      if (!G.current)
        if (T)
          G.current = T;
        else {
          var j = function() {
            L({});
          }, J = new Cf(j);
          G.current = J.getForm();
        }
      return [G.current];
    }
    var Jw = h.createContext({ triggerFormChange: function() {
    }, triggerFormFinish: function() {
    }, registerForm: function() {
    }, unregisterForm: function() {
    } }), AD = function(T) {
      var G = T.validateMessages, P = T.onFormChange, I = T.onFormFinish, L = T.children, j = h.useContext(Jw), J = h.useRef({});
      return h.createElement(Jw.Provider, { value: At(At({}, j), {}, { validateMessages: At(At({}, j.validateMessages), G), triggerFormChange: function(te, Q) {
        P && P(te, { changedFields: Q, forms: J.current }), j.triggerFormChange(te, Q);
      }, triggerFormFinish: function(te, Q) {
        I && I(te, { values: Q, forms: J.current }), j.triggerFormFinish(te, Q);
      }, registerForm: function(te, Q) {
        te && (J.current = At(At({}, J.current), {}, Ie({}, te, Q))), j.registerForm(te, Q);
      }, unregisterForm: function(te) {
        var Q = At({}, J.current);
        delete Q[te], J.current = Q, j.unregisterForm(te);
      } }) }, L);
    }, TD = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], MD = function(T, G) {
      var P = T.name, I = T.initialValues, L = T.fields, j = T.form, J = T.preserve, te = T.children, Q = T.component, he = Q === void 0 ? "form" : Q, de = T.validateMessages, Ae = T.validateTrigger, We = Ae === void 0 ? "onChange" : Ae, Xe = T.onValuesChange, Ze = T.onFieldsChange, it = T.onFinish, ct = T.onFinishFailed, sr = ma(T, TD), Yt = h.useContext(Jw), Or = LA(j), le = sa(Or, 1), _t = le[0], Pt = _t.getInternalHooks(Wg), er = Pt.useSubscribe, Kt = Pt.setInitialValues, St = Pt.setCallbacks, kt = Pt.setValidateMessages, dr = Pt.setPreserve;
      h.useImperativeHandle(G, function() {
        return _t;
      }), h.useEffect(function() {
        return Yt.registerForm(P, _t), function() {
          Yt.unregisterForm(P);
        };
      }, [Yt, _t, P]), kt(At(At({}, Yt.validateMessages), de)), St({ onValuesChange: Xe, onFieldsChange: function(Gt) {
        if (Yt.triggerFormChange(P, Gt), Ze) {
          for (var zt = arguments.length, Yr = new Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
            Yr[Vr - 1] = arguments[Vr];
          Ze.apply(void 0, [Gt].concat(Yr));
        }
      }, onFinish: function(Gt) {
        Yt.triggerFormFinish(P, Gt), it && it(Gt);
      }, onFinishFailed: ct }), dr(J);
      var Ir = h.useRef(null);
      Kt(I, !Ir.current), Ir.current || (Ir.current = true);
      var ht = te, gn = typeof te == "function";
      if (gn) {
        var ln = _t.getFieldsValue(true);
        ht = te(ln, _t);
      }
      er(!gn);
      var Jt = h.useRef();
      h.useEffect(function() {
        pD(Jt.current || [], L || []) || _t.setFields(L || []), Jt.current = L;
      }, [L, _t]);
      var In = h.useMemo(function() {
        return At(At({}, _t), {}, { validateTrigger: We });
      }, [_t, We]), ur = h.createElement(By.Provider, { value: In }, ht);
      return he === false ? ur : h.createElement(he, cs({}, sr, { onSubmit: function(Gt) {
        Gt.preventDefault(), Gt.stopPropagation(), _t.submit();
      }, onReset: function(Gt) {
        var zt;
        Gt.preventDefault(), _t.resetFields(), (zt = sr.onReset) === null || zt === void 0 || zt.call(sr, Gt);
      } }), ur);
    }, OA = h.forwardRef(MD), Ky = OA;
    Ky.FormProvider = AD, Ky.Field = DA, Ky.List = SD, Ky.useForm = LA;
    var PD = function(T, G, P) {
      oh(T, "[antd: ".concat(G, "] ").concat(P));
    }, DD = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, Qw = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, Zy = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, Xy = Zy, ID = { lang: cs({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, Qw), timePickerLocale: cs({}, Xy) }, eS = ID, gc = "${label} is not a valid ${type}", iv = { locale: "en", Pagination: DD, DatePicker: eS, TimePicker: Xy, Calendar: eS, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: gc, method: gc, array: gc, object: gc, number: gc, date: gc, boolean: gc, integer: gc, float: gc, regexp: gc, email: gc, url: gc, hex: gc }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, L1 = iv, yp = u.createContext(void 0), Gc = yp, tS = function(T) {
      jg(P, T);
      var G = ky(P);
      function P() {
        return Ly(this, P), G.apply(this, arguments);
      }
      return Oy(P, [{ key: "getLocale", value: function() {
        var I = this.props, L = I.componentName, j = I.defaultLocale, J = j || L1[L != null ? L : "global"], te = this.context, Q = L && te ? te[L] : {};
        return cs(cs({}, J instanceof Function ? J() : J), Q || {});
      } }, { key: "getLocaleCode", value: function() {
        var I = this.context, L = I && I.locale;
        return I && I.exist && !L ? L1.locale : L;
      } }, { key: "render", value: function() {
        return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
      } }]), P;
    }(h.Component);
    tS.defaultProps = { componentName: "global" }, tS.contextType = Gc;
    var kA = function() {
      var T = h.useContext(Du), G = T.getPrefixCls, P = G("empty-img-default");
      return h.createElement("svg", { className: P, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, h.createElement("g", { fill: "none", fillRule: "evenodd" }, h.createElement("g", { transform: "translate(24 31.67)" }, h.createElement("ellipse", { className: "".concat(P, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), h.createElement("path", { className: "".concat(P, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), h.createElement("path", { className: "".concat(P, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), h.createElement("path", { className: "".concat(P, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), h.createElement("path", { className: "".concat(P, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), h.createElement("path", { className: "".concat(P, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), h.createElement("g", { className: "".concat(P, "-g"), transform: "translate(149.65 15.383)" }, h.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), h.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
    }, RA = kA, Jy = function() {
      var T = h.useContext(Du), G = T.getPrefixCls, P = G("empty-img-simple");
      return h.createElement("svg", { className: P, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, h.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, h.createElement("ellipse", { className: "".concat(P, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), h.createElement("g", { className: "".concat(P, "-g"), fillRule: "nonzero" }, h.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), h.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(P, "-path") }))));
    }, ad = Jy, FA = globalThis && globalThis.__rest || function(T, G) {
      var P = {};
      for (var I in T)
        Object.prototype.hasOwnProperty.call(T, I) && G.indexOf(I) < 0 && (P[I] = T[I]);
      if (T != null && typeof Object.getOwnPropertySymbols == "function")
        for (var L = 0, I = Object.getOwnPropertySymbols(T); L < I.length; L++)
          G.indexOf(I[L]) < 0 && Object.prototype.propertyIsEnumerable.call(T, I[L]) && (P[I[L]] = T[I[L]]);
      return P;
    }, NA = h.createElement(RA, null), Qy = h.createElement(ad, null), rS = function(T) {
      var G = T.className, P = T.prefixCls, I = T.image, L = I === void 0 ? NA : I, j = T.description, J = T.children, te = T.imageStyle, Q = FA(T, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), he = h.useContext(Du), de = he.getPrefixCls, Ae = he.direction;
      return h.createElement(tS, { componentName: "Empty" }, function(We) {
        var Xe, Ze = de("empty", P), it = typeof j != "undefined" ? j : We.description, ct = typeof it == "string" ? it : "empty", sr = null;
        return typeof L == "string" ? sr = h.createElement("img", { alt: ct, src: L }) : sr = L, h.createElement("div", cs({ className: io(Ze, (Xe = {}, Ie(Xe, "".concat(Ze, "-normal"), L === Qy), Ie(Xe, "".concat(Ze, "-rtl"), Ae === "rtl"), Xe), G) }, Q), h.createElement("div", { className: "".concat(Ze, "-image"), style: te }, sr), it && h.createElement("div", { className: "".concat(Ze, "-description") }, it), J && h.createElement("div", { className: "".concat(Ze, "-footer") }, J));
      });
    };
    rS.PRESENTED_IMAGE_DEFAULT = NA, rS.PRESENTED_IMAGE_SIMPLE = Qy;
    var Yg = rS, Pu = function(T) {
      return h.createElement(O1, null, function(G) {
        var P = G.getPrefixCls, I = P("empty");
        switch (T) {
          case "Table":
          case "List":
            return h.createElement(Yg, { image: Yg.PRESENTED_IMAGE_SIMPLE });
          case "Select":
          case "TreeSelect":
          case "Cascader":
          case "Transfer":
          case "Mentions":
            return h.createElement(Yg, { image: Yg.PRESENTED_IMAGE_SIMPLE, className: "".concat(I, "-small") });
          default:
            return h.createElement(Yg, null);
        }
      });
    }, nS = Pu, VA = function(T, G) {
      return G || (T ? "ant-".concat(T) : "ant");
    }, Du = h.createContext({ getPrefixCls: VA, renderEmpty: nS }), O1 = Du.Consumer, k1 = h.createContext(void 0), mp = k1, aS = function(T) {
      return +setTimeout(T, 16);
    }, tl = function(T) {
      return clearTimeout(T);
    };
    typeof window != "undefined" && "requestAnimationFrame" in window && (aS = function(T) {
      return window.requestAnimationFrame(T);
    }, tl = function(T) {
      return window.cancelAnimationFrame(T);
    });
    var R1 = 0, iS = /* @__PURE__ */ new Map();
    function jA(T) {
      iS.delete(T);
    }
    function F1(T) {
      var G = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
      R1 += 1;
      var P = R1;
      function I(L) {
        if (L === 0)
          jA(P), T();
        else {
          var j = aS(function() {
            I(L - 1);
          });
          iS.set(P, j);
        }
      }
      return I(G), P;
    }
    F1.cancel = function(T) {
      var G = iS.get(T);
      return jA(G), tl(G);
    };
    function oS(T, G) {
      var P = G || {}, I = P.defaultValue, L = P.value, j = P.onChange, J = P.postState, te = h.useState(function() {
        return L !== void 0 ? L : I !== void 0 ? typeof I == "function" ? I() : I : typeof T == "function" ? T() : T;
      }), Q = sa(te, 2), he = Q[0], de = Q[1], Ae = L !== void 0 ? L : he;
      J && (Ae = J(Ae));
      var We = h.useRef(j);
      We.current = j;
      var Xe = h.useCallback(function(it) {
        de(it), Ae !== it && We.current && We.current(it, Ae);
      }, [Ae, We]), Ze = h.useRef(true);
      return h.useEffect(function() {
        if (Ze.current) {
          Ze.current = false;
          return;
        }
        L === void 0 && de(L);
      }, [L]), [Ae, Xe];
    }
    var ra = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(T) {
      var G = T.keyCode;
      if (T.altKey && !T.ctrlKey || T.metaKey || G >= ra.F1 && G <= ra.F12)
        return false;
      switch (G) {
        case ra.ALT:
        case ra.CAPS_LOCK:
        case ra.CONTEXT_MENU:
        case ra.CTRL:
        case ra.DOWN:
        case ra.END:
        case ra.ESC:
        case ra.HOME:
        case ra.INSERT:
        case ra.LEFT:
        case ra.MAC_FF_META:
        case ra.META:
        case ra.NUMLOCK:
        case ra.NUM_CENTER:
        case ra.PAGE_DOWN:
        case ra.PAGE_UP:
        case ra.PAUSE:
        case ra.PRINT_SCREEN:
        case ra.RIGHT:
        case ra.SHIFT:
        case ra.UP:
        case ra.WIN_KEY:
        case ra.WIN_KEY_RIGHT:
          return false;
        default:
          return true;
      }
    }, isCharacterKey: function(T) {
      if (T >= ra.ZERO && T <= ra.NINE || T >= ra.NUM_ZERO && T <= ra.NUM_MULTIPLY || T >= ra.A && T <= ra.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && T === 0)
        return true;
      switch (T) {
        case ra.SPACE:
        case ra.QUESTION_MARK:
        case ra.NUM_PLUS:
        case ra.NUM_MINUS:
        case ra.NUM_PERIOD:
        case ra.NUM_DIVISION:
        case ra.SEMICOLON:
        case ra.DASH:
        case ra.EQUALS:
        case ra.COMMA:
        case ra.PERIOD:
        case ra.SLASH:
        case ra.APOSTROPHE:
        case ra.SINGLE_QUOTE:
        case ra.OPEN_SQUARE_BRACKET:
        case ra.BACKSLASH:
        case ra.CLOSE_SQUARE_BRACKET:
          return true;
        default:
          return false;
      }
    } }, Kg = function() {
      for (var T = arguments.length, G = new Array(T), P = 0; P < T; P++)
        G[P] = arguments[P];
      return G;
    }, BA = h.isValidElement;
    function LD(T, G, P) {
      return BA(T) ? h.cloneElement(T, typeof P == "function" ? P(T.props || {}) : P) : G;
    }
    function OD(T, G) {
      return LD(T, T, G);
    }
    var Zg = ["xxl", "xl", "lg", "md", "sm", "xs"], N1 = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, bp = /* @__PURE__ */ new Map(), em = -1, tm = {}, kD = { matchHandlers: {}, dispatch: function(T) {
      return tm = T, bp.forEach(function(G) {
        return G(tm);
      }), bp.size >= 1;
    }, subscribe: function(T) {
      return bp.size || this.register(), em += 1, bp.set(em, T), T(tm), em;
    }, unsubscribe: function(T) {
      bp.delete(T), bp.size || this.unregister();
    }, unregister: function() {
      var T = this;
      Object.keys(N1).forEach(function(G) {
        var P = N1[G], I = T.matchHandlers[P];
        I == null || I.mql.removeListener(I == null ? void 0 : I.listener);
      }), bp.clear();
    }, register: function() {
      var T = this;
      Object.keys(N1).forEach(function(G) {
        var P = N1[G], I = function(j) {
          var J = j.matches;
          T.dispatch(cs(cs({}, tm), Ie({}, G, J)));
        }, L = window.matchMedia(P);
        L.addListener(I), T.matchHandlers[P] = { mql: L, listener: I }, I(L);
      });
    } }, zA = kD, RD = 0, _p = {};
    function Xg(T) {
      var G = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, P = RD++, I = G;
      function L() {
        I -= 1, I <= 0 ? (T(), delete _p[P]) : _p[P] = F1(L);
      }
      return _p[P] = F1(L), P;
    }
    Xg.cancel = function(T) {
      T !== void 0 && (F1.cancel(_p[T]), delete _p[T]);
    }, Xg.ids = _p;
    var sS;
    function V1(T) {
      return !T || T.offsetParent === null || T.hidden;
    }
    function $A(T) {
      var G = (T || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
      return G && G[1] && G[2] && G[3] ? !(G[1] === G[2] && G[2] === G[3]) : true;
    }
    var uS = function(T) {
      jg(P, T);
      var G = ky(P);
      function P() {
        var I;
        return Ly(this, P), I = G.apply(this, arguments), I.containerRef = h.createRef(), I.animationStart = false, I.destroyed = false, I.onClick = function(L, j) {
          var J, te, Q = I.props, he = Q.insertExtraNode, de = Q.disabled;
          if (!(de || !L || V1(L) || L.className.indexOf("-leave") >= 0)) {
            I.extraNode = document.createElement("div");
            var Ae = b1(I), We = Ae.extraNode, Xe = I.context.getPrefixCls;
            We.className = "".concat(Xe(""), "-click-animating-node");
            var Ze = I.getAttributeName();
            if (L.setAttribute(Ze, "true"), j && j !== "#ffffff" && j !== "rgb(255, 255, 255)" && $A(j) && !/rgba\((?:\d*, ){3}0\)/.test(j) && j !== "transparent") {
              We.style.borderColor = j;
              var it = ((J = L.getRootNode) === null || J === void 0 ? void 0 : J.call(L)) || L.ownerDocument, ct = it instanceof Document ? it.body : (te = it.firstChild) !== null && te !== void 0 ? te : it;
              sS = hu(`
      [`.concat(Xe(""), "-click-animating-without-extra-node='true']::after, .").concat(Xe(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(j, `;
      }`), "antd-wave", { csp: I.csp, attachTo: ct });
            }
            he && L.appendChild(We), ["transition", "animation"].forEach(function(sr) {
              L.addEventListener("".concat(sr, "start"), I.onTransitionStart), L.addEventListener("".concat(sr, "end"), I.onTransitionEnd);
            });
          }
        }, I.onTransitionStart = function(L) {
          if (!I.destroyed) {
            var j = I.containerRef.current;
            !L || L.target !== j || I.animationStart || I.resetEffect(j);
          }
        }, I.onTransitionEnd = function(L) {
          !L || L.animationName !== "fadeEffect" || I.resetEffect(L.target);
        }, I.bindAnimationEvent = function(L) {
          if (!(!L || !L.getAttribute || L.getAttribute("disabled") || L.className.indexOf("disabled") >= 0)) {
            var j = function(J) {
              if (!(J.target.tagName === "INPUT" || V1(J.target))) {
                I.resetEffect(L);
                var te = getComputedStyle(L).getPropertyValue("border-top-color") || getComputedStyle(L).getPropertyValue("border-color") || getComputedStyle(L).getPropertyValue("background-color");
                I.clickWaveTimeoutId = window.setTimeout(function() {
                  return I.onClick(L, te);
                }, 0), Xg.cancel(I.animationStartId), I.animationStart = true, I.animationStartId = Xg(function() {
                  I.animationStart = false;
                }, 10);
              }
            };
            return L.addEventListener("click", j, true), { cancel: function() {
              L.removeEventListener("click", j, true);
            } };
          }
        }, I.renderWave = function(L) {
          var j = L.csp, J = I.props.children;
          if (I.csp = j, !h.isValidElement(J))
            return J;
          var te = I.containerRef;
          return eD(J) && (te = Q3(J.ref, I.containerRef)), OD(J, { ref: te });
        }, I;
      }
      return Oy(P, [{ key: "componentDidMount", value: function() {
        var I = this.containerRef.current;
        !I || I.nodeType !== 1 || (this.instance = this.bindAnimationEvent(I));
      } }, { key: "componentWillUnmount", value: function() {
        this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
      } }, { key: "getAttributeName", value: function() {
        var I = this.context.getPrefixCls, L = this.props.insertExtraNode;
        return L ? "".concat(I(""), "-click-animating") : "".concat(I(""), "-click-animating-without-extra-node");
      } }, { key: "resetEffect", value: function(I) {
        var L = this;
        if (!(!I || I === this.extraNode || !(I instanceof Element))) {
          var j = this.props.insertExtraNode, J = this.getAttributeName();
          I.setAttribute(J, "false"), sS && (sS.innerHTML = ""), j && this.extraNode && I.contains(this.extraNode) && I.removeChild(this.extraNode), ["transition", "animation"].forEach(function(te) {
            I.removeEventListener("".concat(te, "start"), L.onTransitionStart), I.removeEventListener("".concat(te, "end"), L.onTransitionEnd);
          });
        }
      } }, { key: "render", value: function() {
        return h.createElement(O1, null, this.renderWave);
      } }]), P;
    }(h.Component);
    uS.contextType = Du;
    var j1 = { exports: {} }, id2 = {};
    /** @license React v17.0.2
    * react-jsx-runtime.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var FD = f2.default, lS = 60103;
    if (id2.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
      var cS = Symbol.for;
      lS = cS("react.element"), id2.Fragment = cS("react.fragment");
    }
    var ND = FD.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, GA = Object.prototype.hasOwnProperty, VD = { key: true, ref: true, __self: true, __source: true };
    function B1(T, G, P) {
      var I, L = {}, j = null, J = null;
      P !== void 0 && (j = "" + P), G.key !== void 0 && (j = "" + G.key), G.ref !== void 0 && (J = G.ref);
      for (I in G)
        GA.call(G, I) && !VD.hasOwnProperty(I) && (L[I] = G[I]);
      if (T && T.defaultProps)
        for (I in G = T.defaultProps, G)
          L[I] === void 0 && (L[I] = G[I]);
      return { $$typeof: lS, type: T, key: j, ref: J, props: L, _owner: ND.current };
    }
    id2.jsx = B1, id2.jsxs = B1, j1.exports = id2;
    const xp = j1.exports.jsx, fS = j1.exports.jsxs;
    var jD = u.createContext({}), z1 = jD, Xa = function() {
      return lA() && window.document.documentElement;
    }, $1, BD = function() {
      if (!Xa())
        return false;
      if ($1 !== void 0)
        return $1;
      var T = document.createElement("div");
      return T.style.display = "flex", T.style.flexDirection = "column", T.style.rowGap = "1px", T.appendChild(document.createElement("div")), T.appendChild(document.createElement("div")), document.body.appendChild(T), $1 = T.scrollHeight === 1, document.body.removeChild(T), $1;
    }, rm = function() {
      var T = h.useState(false), G = sa(T, 2), P = G[0], I = G[1];
      return h.useEffect(function() {
        I(BD());
      }, []), P;
    }, WA = globalThis && globalThis.__rest || function(T, G) {
      var P = {};
      for (var I in T)
        Object.prototype.hasOwnProperty.call(T, I) && G.indexOf(I) < 0 && (P[I] = T[I]);
      if (T != null && typeof Object.getOwnPropertySymbols == "function")
        for (var L = 0, I = Object.getOwnPropertySymbols(T); L < I.length; L++)
          G.indexOf(I[L]) < 0 && Object.prototype.propertyIsEnumerable.call(T, I[L]) && (P[I[L]] = T[I[L]]);
      return P;
    };
    Kg("top", "middle", "bottom", "stretch"), Kg("start", "end", "center", "space-around", "space-between");
    var UA = h.forwardRef(function(T, G) {
      var P, I = T.prefixCls, L = T.justify, j = T.align, J = T.className, te = T.style, Q = T.children, he = T.gutter, de = he === void 0 ? 0 : he, Ae = T.wrap, We = WA(T, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Xe = h.useContext(Du), Ze = Xe.getPrefixCls, it = Xe.direction, ct = h.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), sr = sa(ct, 2), Yt = sr[0], Or = sr[1], le = rm(), _t = h.useRef(de);
      h.useEffect(function() {
        var ur = zA.subscribe(function(Gt) {
          var zt = _t.current || 0;
          (!Array.isArray(zt) && kn(zt) === "object" || Array.isArray(zt) && (kn(zt[0]) === "object" || kn(zt[1]) === "object")) && Or(Gt);
        });
        return function() {
          return zA.unsubscribe(ur);
        };
      }, []);
      var Pt = function() {
        var ur = [0, 0], Gt = Array.isArray(de) ? de : [de, 0];
        return Gt.forEach(function(zt, Yr) {
          if (kn(zt) === "object")
            for (var Vr = 0; Vr < Zg.length; Vr++) {
              var Qn = Zg[Vr];
              if (Yt[Qn] && zt[Qn] !== void 0) {
                ur[Yr] = zt[Qn];
                break;
              }
            }
          else
            ur[Yr] = zt || 0;
        }), ur;
      }, er = Ze("row", I), Kt = Pt(), St = io(er, (P = {}, Ie(P, "".concat(er, "-no-wrap"), Ae === false), Ie(P, "".concat(er, "-").concat(L), L), Ie(P, "".concat(er, "-").concat(j), j), Ie(P, "".concat(er, "-rtl"), it === "rtl"), P), J), kt = {}, dr = Kt[0] > 0 ? Kt[0] / -2 : void 0, Ir = Kt[1] > 0 ? Kt[1] / -2 : void 0;
      if (dr && (kt.marginLeft = dr, kt.marginRight = dr), le) {
        var ht = sa(Kt, 2);
        kt.rowGap = ht[1];
      } else
        Ir && (kt.marginTop = Ir, kt.marginBottom = Ir);
      var gn = sa(Kt, 2), ln = gn[0], Jt = gn[1], In = h.useMemo(function() {
        return { gutter: [ln, Jt], wrap: Ae, supportFlexGap: le };
      }, [ln, Jt, Ae, le]);
      return h.createElement(z1.Provider, { value: In }, h.createElement("div", cs({}, We, { className: St, style: cs(cs({}, kt), te), ref: G }), Q));
    });
    UA.displayName = "Row";
    var zD = UA, Wc = globalThis && globalThis.__rest || function(T, G) {
      var P = {};
      for (var I in T)
        Object.prototype.hasOwnProperty.call(T, I) && G.indexOf(I) < 0 && (P[I] = T[I]);
      if (T != null && typeof Object.getOwnPropertySymbols == "function")
        for (var L = 0, I = Object.getOwnPropertySymbols(T); L < I.length; L++)
          G.indexOf(I[L]) < 0 && Object.prototype.propertyIsEnumerable.call(T, I[L]) && (P[I[L]] = T[I[L]]);
      return P;
    };
    function $D(T) {
      return typeof T == "number" ? "".concat(T, " ").concat(T, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(T) ? "0 0 ".concat(T) : T;
    }
    var G1 = ["xs", "sm", "md", "lg", "xl", "xxl"], W1 = h.forwardRef(function(T, G) {
      var P, I = h.useContext(Du), L = I.getPrefixCls, j = I.direction, J = h.useContext(z1), te = J.gutter, Q = J.wrap, he = J.supportFlexGap, de = T.prefixCls, Ae = T.span, We = T.order, Xe = T.offset, Ze = T.push, it = T.pull, ct = T.className, sr = T.children, Yt = T.flex, Or = T.style, le = Wc(T, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), _t = L("col", de), Pt = {};
      G1.forEach(function(dr) {
        var Ir, ht = {}, gn = T[dr];
        typeof gn == "number" ? ht.span = gn : kn(gn) === "object" && (ht = gn || {}), delete le[dr], Pt = cs(cs({}, Pt), (Ir = {}, Ie(Ir, "".concat(_t, "-").concat(dr, "-").concat(ht.span), ht.span !== void 0), Ie(Ir, "".concat(_t, "-").concat(dr, "-order-").concat(ht.order), ht.order || ht.order === 0), Ie(Ir, "".concat(_t, "-").concat(dr, "-offset-").concat(ht.offset), ht.offset || ht.offset === 0), Ie(Ir, "".concat(_t, "-").concat(dr, "-push-").concat(ht.push), ht.push || ht.push === 0), Ie(Ir, "".concat(_t, "-").concat(dr, "-pull-").concat(ht.pull), ht.pull || ht.pull === 0), Ie(Ir, "".concat(_t, "-rtl"), j === "rtl"), Ir));
      });
      var er = io(_t, (P = {}, Ie(P, "".concat(_t, "-").concat(Ae), Ae !== void 0), Ie(P, "".concat(_t, "-order-").concat(We), We), Ie(P, "".concat(_t, "-offset-").concat(Xe), Xe), Ie(P, "".concat(_t, "-push-").concat(Ze), Ze), Ie(P, "".concat(_t, "-pull-").concat(it), it), P), ct, Pt), Kt = {};
      if (te && te[0] > 0) {
        var St = te[0] / 2;
        Kt.paddingLeft = St, Kt.paddingRight = St;
      }
      if (te && te[1] > 0 && !he) {
        var kt = te[1] / 2;
        Kt.paddingTop = kt, Kt.paddingBottom = kt;
      }
      return Yt && (Kt.flex = $D(Yt), Q === false && !Kt.minWidth && (Kt.minWidth = 0)), h.createElement("div", cs({}, le, { style: cs(cs({}, Kt), Or), className: er, ref: G }), sr);
    });
    W1.displayName = "Col";
    var HA = W1, hS = h.forwardRef(function(T, G) {
      var P, I = T.prefixCls, L = I === void 0 ? "rc-switch" : I, j = T.className, J = T.checked, te = T.defaultChecked, Q = T.disabled, he = T.loadingIcon, de = T.checkedChildren, Ae = T.unCheckedChildren, We = T.onClick, Xe = T.onChange, Ze = T.onKeyDown, it = ma(T, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), ct = oS(false, { value: J, defaultValue: te }), sr = sa(ct, 2), Yt = sr[0], Or = sr[1];
      function le(Kt, St) {
        var kt = Yt;
        return Q || (kt = Kt, Or(kt), Xe == null || Xe(kt, St)), kt;
      }
      function _t(Kt) {
        Kt.which === ra.LEFT ? le(false, Kt) : Kt.which === ra.RIGHT && le(true, Kt), Ze == null || Ze(Kt);
      }
      function Pt(Kt) {
        var St = le(!Yt, Kt);
        We == null || We(St, Kt);
      }
      var er = io(L, j, (P = {}, Ie(P, "".concat(L, "-checked"), Yt), Ie(P, "".concat(L, "-disabled"), Q), P));
      return h.createElement("button", Object.assign({}, it, { type: "button", role: "switch", "aria-checked": Yt, disabled: Q, className: er, ref: G, onKeyDown: _t, onClick: Pt }), he, h.createElement("span", { className: "".concat(L, "-inner") }, Yt ? de : Ae));
    });
    hS.displayName = "Switch";
    var yc = globalThis && globalThis.__rest || function(T, G) {
      var P = {};
      for (var I in T)
        Object.prototype.hasOwnProperty.call(T, I) && G.indexOf(I) < 0 && (P[I] = T[I]);
      if (T != null && typeof Object.getOwnPropertySymbols == "function")
        for (var L = 0, I = Object.getOwnPropertySymbols(T); L < I.length; L++)
          G.indexOf(I[L]) < 0 && Object.prototype.propertyIsEnumerable.call(T, I[L]) && (P[I[L]] = T[I[L]]);
      return P;
    }, sh = h.forwardRef(function(T, G) {
      var P, I = T.prefixCls, L = T.size, j = T.loading, J = T.className, te = J === void 0 ? "" : J, Q = T.disabled, he = yc(T, ["prefixCls", "size", "loading", "className", "disabled"]);
      PD("checked" in he || !("value" in he), "Switch", "`value` is not a valid prop, do you mean `checked`?");
      var de = h.useContext(Du), Ae = de.getPrefixCls, We = de.direction, Xe = h.useContext(mp), Ze = Ae("switch", I), it = h.createElement("div", { className: "".concat(Ze, "-handle") }, j && h.createElement(q32, { className: "".concat(Ze, "-loading-icon") })), ct = io((P = {}, Ie(P, "".concat(Ze, "-small"), (L || Xe) === "small"), Ie(P, "".concat(Ze, "-loading"), j), Ie(P, "".concat(Ze, "-rtl"), We === "rtl"), P), te);
      return h.createElement(uS, { insertExtraNode: true }, h.createElement(hS, cs({}, he, { prefixCls: Ze, className: ct, disabled: Q || j, ref: G, loadingIcon: it })));
    });
    sh.__ANT_SWITCH = true, sh.displayName = "Switch";
    var vS = sh, U1 = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, qA = {};
    (function(T) {
      var G = Object.defineProperty, P = (A2, W, D) => W in A2 ? G(A2, W, { enumerable: true, configurable: true, writable: true, value: D }) : A2[W] = D, I = (A2, W, D) => (P(A2, typeof W != "symbol" ? W + "" : W, D), D);
      Object.defineProperties(T, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
      var L = f2.default;
      function j(A2) {
        return A2 && typeof A2 == "object" && "default" in A2 ? A2 : { default: A2 };
      }
      function J(A2) {
        if (A2 && A2.__esModule)
          return A2;
        var W = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
        return A2 && Object.keys(A2).forEach(function(D) {
          if (D !== "default") {
            var O = Object.getOwnPropertyDescriptor(A2, D);
            Object.defineProperty(W, D, O.get ? O : { enumerable: true, get: function() {
              return A2[D];
            } });
          }
        }), W.default = A2, Object.freeze(W);
      }
      var te = j(L), Q = J(L);
      class he {
        constructor() {
          I(this, "chartsEmitters", /* @__PURE__ */ new Map()), I(this, "add", (W, D, O, F) => {
            D && O ? this.chartsEmitters.set(W, { chart: D, option: O, title: F }) : console.log("\u6DFB\u52A0\u5931\u8D25");
          }), I(this, "get", (W) => this.chartsEmitters.get(W)), I(this, "clear", () => {
            this.chartsEmitters.clear();
          }), I(this, "delete", (W) => {
            this.chartsEmitters.delete(W);
          }), I(this, "list", () => {
            var W, D, O;
            const F = [];
            for (const B of this.chartsEmitters.keys())
              F.push({ id: B, chart: (W = this.chartsEmitters.get(B)) == null ? void 0 : W.chart, option: (D = this.chartsEmitters.get(B)) == null ? void 0 : D.option, title: (O = this.chartsEmitters.get(B)) == null ? void 0 : O.title });
            return F;
          });
        }
      }
      const de = new he();
      var Ae = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof m2 != "undefined" ? m2 : typeof self != "undefined" ? self : {};
      function We(A2) {
        return A2 && A2.__esModule && Object.prototype.hasOwnProperty.call(A2, "default") ? A2.default : A2;
      }
      var Xe = { exports: {} };
      /**
      * @license
      * Lodash <https://lodash.com/>
      * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
      * Released under MIT license <https://lodash.com/license>
      * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
      * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
      */
      (function(A2, W) {
        (function() {
          var D, O = "4.17.21", F = 200, B = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", Z = "Expected a function", re = "Invalid `variable` option passed into `_.template`", ie = "__lodash_hash_undefined__", ve = 500, ge = "__lodash_placeholder__", Pe = 1, He = 2, Qe = 4, Je = 1, ut = 2, gt = 1, lr = 2, tr = 4, Gr = 8, se = 16, vt = 32, Lt = 64, ar = 128, rr = 256, Ct = 512, Ft = 30, gr = "...", Nr = 800, mt = 16, dn = 1, fn = 2, ir = 3, Vn = 1 / 0, fr = 9007199254740991, Wt = 17976931348623157e292, Ut = 0 / 0, Kr = 4294967295, zr = Kr - 1, Zn = Kr >>> 1, gi = [["ary", ar], ["bind", gt], ["bindKey", lr], ["curry", Gr], ["curryRight", se], ["flip", Ct], ["partial", vt], ["partialRight", Lt], ["rearg", rr]], Ja = "[object Arguments]", Oa = "[object Array]", co = "[object AsyncFunction]", Qa = "[object Boolean]", Fi = "[object Date]", Jo = "[object DOMException]", vs = "[object Error]", Xl = "[object Function]", Yc = "[object GeneratorFunction]", $s = "[object Map]", Dl = "[object Number]", Ff = "[object Null]", cl = "[object Object]", Nu = "[object Promise]", Kc = "[object Proxy]", Jl = "[object RegExp]", us = "[object Set]", Ps = "[object String]", wo = "[object Symbol]", Nn = "[object Undefined]", mr = "[object WeakMap]", Vt = "[object WeakSet]", It = "[object ArrayBuffer]", Sr = "[object DataView]", rn = "[object Float32Array]", An = "[object Float64Array]", Bn = "[object Int8Array]", ka = "[object Int16Array]", $i = "[object Int32Array]", Fo = "[object Uint8Array]", So = "[object Uint8ClampedArray]", ds = "[object Uint16Array]", Co = "[object Uint32Array]", fl = /\b__p \+= '';/g, Il = /\b(__p \+=) '' \+/g, Gs = /(__e\(.*?\)|\b__t\)) \+\n'';/g, fo = /&(?:amp|lt|gt|quot|#39);/g, Qo = /[&<>"']/g, yi = RegExp(fo.source), Ds = RegExp(Qo.source), Vu = /<%-([\s\S]+?)%>/g, Zc = /<%([\s\S]+?)%>/g, _u = /<%=([\s\S]+?)%>/g, hl = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, Ql = /^\w*$/, Cd = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Sv = /[\\^$.*+?()[\]{}|]/g, e22 = RegExp(Sv.source), Ed = /^\s+/, R_ = /\s/, F_ = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, t22 = /\{\n\/\* \[wrapped with (.+)\] \*/, jm = /,? & /, Yp = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, je = /[()=,{}\[\]\/\s]/, Ge = /\\(\\)?/g, Ce = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, Re = /\w*$/, Ne = /^[-+]0x[0-9a-f]+$/i, Dt = /^0b[01]+$/i, or = /^\[object .+?Constructor\]$/, Ht = /^0o[0-7]+$/i, wt = /^(?:0|[1-9]\d*)$/, jr = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, Pn = /($^)/, Ka = /['\n\r\u2028\u2029\\]/g, mi = "\\ud800-\\udfff", Qi = "\\u0300-\\u036f", za = "\\ufe20-\\ufe2f", eo = "\\u20d0-\\u20ff", es = Qi + za + eo, ga = "\\u2700-\\u27bf", Is = "a-z\\xdf-\\xf6\\xf8-\\xff", Ll = "\\xac\\xb1\\xd7\\xf7", Nf = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", Kp = "\\u2000-\\u206f", Xc = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Ad = "A-Z\\xc0-\\xd6\\xd8-\\xde", Cv = "\\ufe0e\\ufe0f", au = Ll + Nf + Kp + Xc, _h = "['\u2019]", Td = "[" + mi + "]", Ev = "[" + au + "]", Zp = "[" + es + "]", Xp = "\\d+", Bm = "[" + ga + "]", E0 = "[" + Is + "]", A0 = "[^" + mi + au + Xp + ga + Is + Ad + "]", xu = "\\ud83c[\\udffb-\\udfff]", Md = "(?:" + Zp + "|" + xu + ")", zm = "[^" + mi + "]", r22 = "(?:\\ud83c[\\udde6-\\uddff]){2}", N_ = "[\\ud800-\\udbff][\\udc00-\\udfff]", T0 = "[" + Ad + "]", YA = "\\u200d", KA = "(?:" + E0 + "|" + A0 + ")", WD = "(?:" + T0 + "|" + A0 + ")", V_ = "(?:" + _h + "(?:d|ll|m|re|s|t|ve))?", ZA = "(?:" + _h + "(?:D|LL|M|RE|S|T|VE))?", XA = Md + "?", JA = "[" + Cv + "]?", UD = "(?:" + YA + "(?:" + [zm, r22, N_].join("|") + ")" + JA + XA + ")*", HD = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", qD = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", QA = JA + XA + UD, YD = "(?:" + [Bm, r22, N_].join("|") + ")" + QA, KD = "(?:" + [zm + Zp + "?", Zp, r22, N_, Td].join("|") + ")", ZD = RegExp(_h, "g"), XD = RegExp(Zp, "g"), n22 = RegExp(xu + "(?=" + xu + ")|" + KD + QA, "g"), JD = RegExp([T0 + "?" + E0 + "+" + V_ + "(?=" + [Ev, T0, "$"].join("|") + ")", WD + "+" + ZA + "(?=" + [Ev, T0 + KA, "$"].join("|") + ")", T0 + "?" + KA + "+" + V_, T0 + "+" + ZA, qD, HD, Xp, YD].join("|"), "g"), QD = RegExp("[" + YA + mi + es + Cv + "]"), eI = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, tI = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], rI = -1, Uo = {};
          Uo[rn] = Uo[An] = Uo[Bn] = Uo[ka] = Uo[$i] = Uo[Fo] = Uo[So] = Uo[ds] = Uo[Co] = true, Uo[Ja] = Uo[Oa] = Uo[It] = Uo[Qa] = Uo[Sr] = Uo[Fi] = Uo[vs] = Uo[Xl] = Uo[$s] = Uo[Dl] = Uo[cl] = Uo[Jl] = Uo[us] = Uo[Ps] = Uo[mr] = false;
          var No = {};
          No[Ja] = No[Oa] = No[It] = No[Sr] = No[Qa] = No[Fi] = No[rn] = No[An] = No[Bn] = No[ka] = No[$i] = No[$s] = No[Dl] = No[cl] = No[Jl] = No[us] = No[Ps] = No[wo] = No[Fo] = No[So] = No[ds] = No[Co] = true, No[vs] = No[Xl] = No[mr] = false;
          var nI = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, a2 = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, eT = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, aI = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, iI = parseFloat, oI = parseInt, tT = typeof Ae == "object" && Ae && Ae.Object === Object && Ae, sI = typeof self == "object" && self && self.Object === Object && self, ju = tT || sI || Function("return this")(), i2 = W && !W.nodeType && W, Jp = i2 && true && A2 && !A2.nodeType && A2, o2 = Jp && Jp.exports === i2, s2 = o2 && tT.process, Ol = function() {
            try {
              var yt = Jp && Jp.require && Jp.require("util").types;
              return yt || s2 && s2.binding && s2.binding("util");
            } catch {
            }
          }(), rT = Ol && Ol.isArrayBuffer, nT = Ol && Ol.isDate, aT = Ol && Ol.isMap, iT = Ol && Ol.isRegExp, oT = Ol && Ol.isSet, sT = Ol && Ol.isTypedArray;
          function Mc(yt, br, $t) {
            switch ($t.length) {
              case 0:
                return yt.call(br);
              case 1:
                return yt.call(br, $t[0]);
              case 2:
                return yt.call(br, $t[0], $t[1]);
              case 3:
                return yt.call(br, $t[0], $t[1], $t[2]);
            }
            return yt.apply(br, $t);
          }
          function uI(yt, br, $t, kr) {
            for (var Aa = -1, Ta = yt == null ? 0 : yt.length; ++Aa < Ta; ) {
              var ei = yt[Aa];
              br(kr, ei, $t(ei), yt);
            }
            return kr;
          }
          function Jc(yt, br) {
            for (var $t = -1, kr = yt == null ? 0 : yt.length; ++$t < kr && br(yt[$t], $t, yt) !== false; )
              ;
            return yt;
          }
          function lI(yt, br) {
            for (var $t = yt == null ? 0 : yt.length; $t-- && br(yt[$t], $t, yt) !== false; )
              ;
            return yt;
          }
          function uT(yt, br) {
            for (var $t = -1, kr = yt == null ? 0 : yt.length; ++$t < kr; )
              if (!br(yt[$t], $t, yt))
                return false;
            return true;
          }
          function Pd(yt, br) {
            for (var $t = -1, kr = yt == null ? 0 : yt.length, Aa = 0, Ta = []; ++$t < kr; ) {
              var ei = yt[$t];
              br(ei, $t, yt) && (Ta[Aa++] = ei);
            }
            return Ta;
          }
          function j_(yt, br) {
            var $t = yt == null ? 0 : yt.length;
            return !!$t && M0(yt, br, 0) > -1;
          }
          function u2(yt, br, $t) {
            for (var kr = -1, Aa = yt == null ? 0 : yt.length; ++kr < Aa; )
              if ($t(br, yt[kr]))
                return true;
            return false;
          }
          function ts(yt, br) {
            for (var $t = -1, kr = yt == null ? 0 : yt.length, Aa = Array(kr); ++$t < kr; )
              Aa[$t] = br(yt[$t], $t, yt);
            return Aa;
          }
          function Dd(yt, br) {
            for (var $t = -1, kr = br.length, Aa = yt.length; ++$t < kr; )
              yt[Aa + $t] = br[$t];
            return yt;
          }
          function B_(yt, br, $t, kr) {
            var Aa = -1, Ta = yt == null ? 0 : yt.length;
            for (kr && Ta && ($t = yt[++Aa]); ++Aa < Ta; )
              $t = br($t, yt[Aa], Aa, yt);
            return $t;
          }
          function lT(yt, br, $t, kr) {
            var Aa = yt == null ? 0 : yt.length;
            for (kr && Aa && ($t = yt[--Aa]); Aa--; )
              $t = br($t, yt[Aa], Aa, yt);
            return $t;
          }
          function l22(yt, br) {
            for (var $t = -1, kr = yt == null ? 0 : yt.length; ++$t < kr; )
              if (br(yt[$t], $t, yt))
                return true;
            return false;
          }
          var cI = c22("length");
          function fI(yt) {
            return yt.split("");
          }
          function hI(yt) {
            return yt.match(Yp) || [];
          }
          function $m(yt, br, $t) {
            var kr;
            return $t(yt, function(Aa, Ta, ei) {
              if (br(Aa, Ta, ei))
                return kr = Ta, false;
            }), kr;
          }
          function z_(yt, br, $t, kr) {
            for (var Aa = yt.length, Ta = $t + (kr ? 1 : -1); kr ? Ta-- : ++Ta < Aa; )
              if (br(yt[Ta], Ta, yt))
                return Ta;
            return -1;
          }
          function M0(yt, br, $t) {
            return br === br ? _I(yt, br, $t) : z_(yt, cT, $t);
          }
          function vI(yt, br, $t, kr) {
            for (var Aa = $t - 1, Ta = yt.length; ++Aa < Ta; )
              if (kr(yt[Aa], br))
                return Aa;
            return -1;
          }
          function cT(yt) {
            return yt !== yt;
          }
          function fT(yt, br) {
            var $t = yt == null ? 0 : yt.length;
            return $t ? h2(yt, br) / $t : Ut;
          }
          function c22(yt) {
            return function(br) {
              return br == null ? D : br[yt];
            };
          }
          function f22(yt) {
            return function(br) {
              return yt == null ? D : yt[br];
            };
          }
          function hT(yt, br, $t, kr, Aa) {
            return Aa(yt, function(Ta, ei, Eo) {
              $t = kr ? (kr = false, Ta) : br($t, Ta, ei, Eo);
            }), $t;
          }
          function dI(yt, br) {
            var $t = yt.length;
            for (yt.sort(br); $t--; )
              yt[$t] = yt[$t].value;
            return yt;
          }
          function h2(yt, br) {
            for (var $t, kr = -1, Aa = yt.length; ++kr < Aa; ) {
              var Ta = br(yt[kr]);
              Ta !== D && ($t = $t === D ? Ta : $t + Ta);
            }
            return $t;
          }
          function v22(yt, br) {
            for (var $t = -1, kr = Array(yt); ++$t < yt; )
              kr[$t] = br($t);
            return kr;
          }
          function $_(yt, br) {
            return ts(br, function($t) {
              return [$t, yt[$t]];
            });
          }
          function vT(yt) {
            return yt && yt.slice(0, gT(yt) + 1).replace(Ed, "");
          }
          function ec(yt) {
            return function(br) {
              return yt(br);
            };
          }
          function G_(yt, br) {
            return ts(br, function($t) {
              return yt[$t];
            });
          }
          function Qp(yt, br) {
            return yt.has(br);
          }
          function d22(yt, br) {
            for (var $t = -1, kr = yt.length; ++$t < kr && M0(br, yt[$t], 0) > -1; )
              ;
            return $t;
          }
          function p22(yt, br) {
            for (var $t = yt.length; $t-- && M0(br, yt[$t], 0) > -1; )
              ;
            return $t;
          }
          function dT(yt, br) {
            for (var $t = yt.length, kr = 0; $t--; )
              yt[$t] === br && ++kr;
            return kr;
          }
          var pT = f22(nI), pI = f22(a2);
          function gI(yt) {
            return "\\" + aI[yt];
          }
          function yI(yt, br) {
            return yt == null ? D : yt[br];
          }
          function Av(yt) {
            return QD.test(yt);
          }
          function W_(yt) {
            return eI.test(yt);
          }
          function mI(yt) {
            for (var br, $t = []; !(br = yt.next()).done; )
              $t.push(br.value);
            return $t;
          }
          function g2(yt) {
            var br = -1, $t = Array(yt.size);
            return yt.forEach(function(kr, Aa) {
              $t[++br] = [Aa, kr];
            }), $t;
          }
          function U_(yt, br) {
            return function($t) {
              return yt(br($t));
            };
          }
          function Tv(yt, br) {
            for (var $t = -1, kr = yt.length, Aa = 0, Ta = []; ++$t < kr; ) {
              var ei = yt[$t];
              (ei === br || ei === ge) && (yt[$t] = ge, Ta[Aa++] = $t);
            }
            return Ta;
          }
          function H_(yt) {
            var br = -1, $t = Array(yt.size);
            return yt.forEach(function(kr) {
              $t[++br] = kr;
            }), $t;
          }
          function bI(yt) {
            var br = -1, $t = Array(yt.size);
            return yt.forEach(function(kr) {
              $t[++br] = [kr, kr];
            }), $t;
          }
          function _I(yt, br, $t) {
            for (var kr = $t - 1, Aa = yt.length; ++kr < Aa; )
              if (yt[kr] === br)
                return kr;
            return -1;
          }
          function xI(yt, br, $t) {
            for (var kr = $t + 1; kr--; )
              if (yt[kr] === br)
                return kr;
            return kr;
          }
          function P0(yt) {
            return Av(yt) ? SI(yt) : cI(yt);
          }
          function Vf(yt) {
            return Av(yt) ? CI(yt) : fI(yt);
          }
          function gT(yt) {
            for (var br = yt.length; br-- && R_.test(yt.charAt(br)); )
              ;
            return br;
          }
          var wI = f22(eT);
          function SI(yt) {
            for (var br = n22.lastIndex = 0; n22.test(yt); )
              ++br;
            return br;
          }
          function CI(yt) {
            return yt.match(n22) || [];
          }
          function EI(yt) {
            return yt.match(JD) || [];
          }
          var AI = function yt(br) {
            br = br == null ? ju : vl.defaults(ju.Object(), br, vl.pick(ju, tI));
            var $t = br.Array, kr = br.Date, Aa = br.Error, Ta = br.Function, ei = br.Math, Eo = br.Object, xh = br.RegExp, TI = br.String, Qc = br.TypeError, q_ = $t.prototype, MI = Ta.prototype, D0 = Eo.prototype, I0 = br["__core-js_shared__"], Y_ = MI.toString, bi = D0.hasOwnProperty, yT = 0, Gm = function() {
              var y10 = /[^.]+$/.exec(I0 && I0.keys && I0.keys.IE_PROTO || "");
              return y10 ? "Symbol(src)_1." + y10 : "";
            }(), Vo = D0.toString, ps = Y_.call(Eo), mT = ju._, PI3 = xh("^" + Y_.call(bi).replace(Sv, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), K_ = o2 ? br.Buffer : D, Id = br.Symbol, Z_ = br.Uint8Array, bT = K_ ? K_.allocUnsafe : D, X_ = U_(Eo.getPrototypeOf, Eo), y2 = Eo.create, L0 = D0.propertyIsEnumerable, O0 = q_.splice, _T = Id ? Id.isConcatSpreadable : D, k0 = Id ? Id.iterator : D, wh = Id ? Id.toStringTag : D, dl = function() {
              try {
                var y10 = Xm(Eo, "defineProperty");
                return y10({}, "", {}), y10;
              } catch {
              }
            }(), R0 = br.clearTimeout !== ju.clearTimeout && br.clearTimeout, DI = kr && kr.now !== ju.Date.now && kr.now, II = br.setTimeout !== ju.setTimeout && br.setTimeout, J_ = ei.ceil, Q_ = ei.floor, m22 = Eo.getOwnPropertySymbols, xT = K_ ? K_.isBuffer : D, Sh = br.isFinite, $a = q_.join, wT = U_(Eo.keys, Eo), to = ei.max, Bu = ei.min, LI = kr.now, ro = br.parseInt, ST = ei.random, CT = q_.reverse, F0 = Xm(br, "DataView"), Wm = Xm(br, "Map"), b22 = Xm(br, "Promise"), N0 = Xm(br, "Set"), Um = Xm(br, "WeakMap"), Hm = Xm(Eo, "create"), ex = Um && new Um(), V0 = {}, OI = Jm(F0), kI = Jm(Wm), RI = Jm(b22), FI = Jm(N0), NI = Jm(Um), tx = Id ? Id.prototype : D, eg = tx ? tx.valueOf : D, ET = tx ? tx.toString : D;
            function we(y10) {
              if (Ws(y10) && !Wa(y10) && !(y10 instanceof Hn)) {
                if (y10 instanceof ef)
                  return y10;
                if (bi.call(y10, "__wrapped__"))
                  return P9(y10);
              }
              return new ef(y10);
            }
            var j0 = function() {
              function y10() {
              }
              return function(S) {
                if (!Ls(S))
                  return {};
                if (y2)
                  return y2(S);
                y10.prototype = S;
                var N = new y10();
                return y10.prototype = D, N;
              };
            }();
            function rx() {
            }
            function ef(y10, S) {
              this.__wrapped__ = y10, this.__actions__ = [], this.__chain__ = !!S, this.__index__ = 0, this.__values__ = D;
            }
            we.templateSettings = { escape: Vu, evaluate: Zc, interpolate: _u, variable: "", imports: { _: we } }, we.prototype = rx.prototype, we.prototype.constructor = we, ef.prototype = j0(rx.prototype), ef.prototype.constructor = ef;
            function Hn(y10) {
              this.__wrapped__ = y10, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = Kr, this.__views__ = [];
            }
            function tc() {
              var y10 = new Hn(this.__wrapped__);
              return y10.__actions__ = af(this.__actions__), y10.__dir__ = this.__dir__, y10.__filtered__ = this.__filtered__, y10.__iteratees__ = af(this.__iteratees__), y10.__takeCount__ = this.__takeCount__, y10.__views__ = af(this.__views__), y10;
            }
            function VI() {
              if (this.__filtered__) {
                var y10 = new Hn(this);
                y10.__dir__ = -1, y10.__filtered__ = true;
              } else
                y10 = this.clone(), y10.__dir__ *= -1;
              return y10;
            }
            function jI() {
              var y10 = this.__wrapped__.value(), S = this.__dir__, N = Wa(y10), X = S < 0, fe = N ? y10.length : 0, Me = uJ(0, fe, this.__views__), Ke = Me.start, at = Me.end, Et = at - Ke, Pr = X ? at : Ke - 1, Dr = this.__iteratees__, Ur = Dr.length, pn = 0, jn = Bu(Et, this.__takeCount__);
              if (!N || !X && fe == Et && jn == Et)
                return si(y10, this.__actions__);
              var ca = [];
              e:
                for (; Et-- && pn < jn; ) {
                  Pr += S;
                  for (var ui = -1, fa = y10[Pr]; ++ui < Ur; ) {
                    var Pi = Dr[ui], Ni = Pi.iteratee, zf = Pi.type, Dc = Ni(fa);
                    if (zf == fn)
                      fa = Dc;
                    else if (!Dc) {
                      if (zf == dn)
                        continue e;
                      break e;
                    }
                  }
                  ca[pn++] = fa;
                }
              return ca;
            }
            Hn.prototype = j0(rx.prototype), Hn.prototype.constructor = Hn;
            function tg(y10) {
              var S = -1, N = y10 == null ? 0 : y10.length;
              for (this.clear(); ++S < N; ) {
                var X = y10[S];
                this.set(X[0], X[1]);
              }
            }
            function AT() {
              this.__data__ = Hm ? Hm(null) : {}, this.size = 0;
            }
            function BI(y10) {
              var S = this.has(y10) && delete this.__data__[y10];
              return this.size -= S ? 1 : 0, S;
            }
            function zI(y10) {
              var S = this.__data__;
              if (Hm) {
                var N = S[y10];
                return N === ie ? D : N;
              }
              return bi.call(S, y10) ? S[y10] : D;
            }
            function $I(y10) {
              var S = this.__data__;
              return Hm ? S[y10] !== D : bi.call(S, y10);
            }
            function TT(y10, S) {
              var N = this.__data__;
              return this.size += this.has(y10) ? 0 : 1, N[y10] = Hm && S === D ? ie : S, this;
            }
            tg.prototype.clear = AT, tg.prototype.delete = BI, tg.prototype.get = zI, tg.prototype.has = $I, tg.prototype.set = TT;
            function Mv(y10) {
              var S = -1, N = y10 == null ? 0 : y10.length;
              for (this.clear(); ++S < N; ) {
                var X = y10[S];
                this.set(X[0], X[1]);
              }
            }
            function GI() {
              this.__data__ = [], this.size = 0;
            }
            function WI(y10) {
              var S = this.__data__, N = nx(S, y10);
              if (N < 0)
                return false;
              var X = S.length - 1;
              return N == X ? S.pop() : O0.call(S, N, 1), --this.size, true;
            }
            function MT(y10) {
              var S = this.__data__, N = nx(S, y10);
              return N < 0 ? D : S[N][1];
            }
            function PT(y10) {
              return nx(this.__data__, y10) > -1;
            }
            function UI(y10, S) {
              var N = this.__data__, X = nx(N, y10);
              return X < 0 ? (++this.size, N.push([y10, S])) : N[X][1] = S, this;
            }
            Mv.prototype.clear = GI, Mv.prototype.delete = WI, Mv.prototype.get = MT, Mv.prototype.has = PT, Mv.prototype.set = UI;
            function Pv(y10) {
              var S = -1, N = y10 == null ? 0 : y10.length;
              for (this.clear(); ++S < N; ) {
                var X = y10[S];
                this.set(X[0], X[1]);
              }
            }
            function HI() {
              this.size = 0, this.__data__ = { hash: new tg(), map: new (Wm || Mv)(), string: new tg() };
            }
            function qI(y10) {
              var S = rM(this, y10).delete(y10);
              return this.size -= S ? 1 : 0, S;
            }
            function B0(y10) {
              return rM(this, y10).get(y10);
            }
            function YI(y10) {
              return rM(this, y10).has(y10);
            }
            function KI(y10, S) {
              var N = rM(this, y10), X = N.size;
              return N.set(y10, S), this.size += N.size == X ? 0 : 1, this;
            }
            Pv.prototype.clear = HI, Pv.prototype.delete = qI, Pv.prototype.get = B0, Pv.prototype.has = YI, Pv.prototype.set = KI;
            function rg(y10) {
              var S = -1, N = y10 == null ? 0 : y10.length;
              for (this.__data__ = new Pv(); ++S < N; )
                this.add(y10[S]);
            }
            function ZI(y10) {
              return this.__data__.set(y10, ie), this;
            }
            function XI(y10) {
              return this.__data__.has(y10);
            }
            rg.prototype.add = rg.prototype.push = ZI, rg.prototype.has = XI;
            function tf(y10) {
              var S = this.__data__ = new Mv(y10);
              this.size = S.size;
            }
            function DT() {
              this.__data__ = new Mv(), this.size = 0;
            }
            function JI(y10) {
              var S = this.__data__, N = S.delete(y10);
              return this.size = S.size, N;
            }
            function QI(y10) {
              return this.__data__.get(y10);
            }
            function eL(y10) {
              return this.__data__.has(y10);
            }
            function tL(y10, S) {
              var N = this.__data__;
              if (N instanceof Mv) {
                var X = N.__data__;
                if (!Wm || X.length < F - 1)
                  return X.push([y10, S]), this.size = ++N.size, this;
                N = this.__data__ = new Pv(X);
              }
              return N.set(y10, S), this.size = N.size, this;
            }
            tf.prototype.clear = DT, tf.prototype.delete = JI, tf.prototype.get = QI, tf.prototype.has = eL, tf.prototype.set = tL;
            function IT(y10, S) {
              var N = Wa(y10), X = !N && Qm(y10), fe = !N && !X && $0(y10), Me = !N && !X && !fe && lx(y10), Ke = N || X || fe || Me, at = Ke ? v22(y10.length, TI) : [], Et = at.length;
              for (var Pr in y10)
                (S || bi.call(y10, Pr)) && !(Ke && (Pr == "length" || fe && (Pr == "offset" || Pr == "parent") || Me && (Pr == "buffer" || Pr == "byteLength" || Pr == "byteOffset") || ug(Pr, Et))) && at.push(Pr);
              return at;
            }
            function LT(y10) {
              var S = y10.length;
              return S ? y10[L2(0, S - 1)] : D;
            }
            function rL(y10, S) {
              return nM(af(y10), ng(S, 0, y10.length));
            }
            function nL(y10) {
              return nM(af(y10));
            }
            function _2(y10, S, N) {
              (N !== D && !Iv(y10[S], N) || N === D && !(S in y10)) && Dv(y10, S, N);
            }
            function qm(y10, S, N) {
              var X = y10[S];
              (!(bi.call(y10, S) && Iv(X, N)) || N === D && !(S in y10)) && Dv(y10, S, N);
            }
            function nx(y10, S) {
              for (var N = y10.length; N--; )
                if (Iv(y10[N][0], S))
                  return N;
              return -1;
            }
            function aL(y10, S, N, X) {
              return Ld(y10, function(fe, Me, Ke) {
                S(X, fe, N(fe), Ke);
              }), X;
            }
            function OT(y10, S) {
              return y10 && Od(S, gl(S), y10);
            }
            function iL(y10, S) {
              return y10 && Od(S, sf(S), y10);
            }
            function Dv(y10, S, N) {
              S == "__proto__" && dl ? dl(y10, S, { configurable: true, enumerable: true, value: N, writable: true }) : y10[S] = N;
            }
            function x22(y10, S) {
              for (var N = -1, X = S.length, fe = $t(X), Me = y10 == null; ++N < X; )
                fe[N] = Me ? D : jL(y10, S[N]);
              return fe;
            }
            function ng(y10, S, N) {
              return y10 === y10 && (N !== D && (y10 = y10 <= N ? y10 : N), S !== D && (y10 = y10 >= S ? y10 : S)), y10;
            }
            function rf(y10, S, N, X, fe, Me) {
              var Ke, at = S & Pe, Et = S & He, Pr = S & Qe;
              if (N && (Ke = fe ? N(y10, X, fe, Me) : N(y10)), Ke !== D)
                return Ke;
              if (!Ls(y10))
                return y10;
              var Dr = Wa(y10);
              if (Dr) {
                if (Ke = cJ(y10), !at)
                  return af(y10, Ke);
              } else {
                var Ur = nc(y10), pn = Ur == Xl || Ur == Yc;
                if ($0(y10))
                  return t9(y10, at);
                if (Ur == cl || Ur == Ja || pn && !fe) {
                  if (Ke = Et || pn ? {} : _9(y10), !at)
                    return Et ? QX(y10, iL(Ke, y10)) : JX(y10, OT(Ke, y10));
                } else {
                  if (!No[Ur])
                    return fe ? y10 : {};
                  Ke = fJ(y10, Ur, at);
                }
              }
              Me || (Me = new tf());
              var jn = Me.get(y10);
              if (jn)
                return jn;
              Me.set(y10, Ke), K9(y10) ? y10.forEach(function(fa) {
                Ke.add(rf(fa, S, N, fa, y10, Me));
              }) : q9(y10) && y10.forEach(function(fa, Pi) {
                Ke.set(Pi, rf(fa, S, N, Pi, y10, Me));
              });
              var ca = Pr ? Et ? EL : CL : Et ? sf : gl, ui = Dr ? D : ca(y10);
              return Jc(ui || y10, function(fa, Pi) {
                ui && (Pi = fa, fa = y10[Pi]), qm(Ke, Pi, rf(fa, S, N, Pi, y10, Me));
              }), Ke;
            }
            function oL(y10) {
              var S = gl(y10);
              return function(N) {
                return kT(N, y10, S);
              };
            }
            function kT(y10, S, N) {
              var X = N.length;
              if (y10 == null)
                return !X;
              for (y10 = Eo(y10); X--; ) {
                var fe = N[X], Me = S[fe], Ke = y10[fe];
                if (Ke === D && !(fe in y10) || !Me(Ke))
                  return false;
              }
              return true;
            }
            function RT(y10, S, N) {
              if (typeof y10 != "function")
                throw new Qc(Z);
              return N2(function() {
                y10.apply(D, N);
              }, S);
            }
            function Ym(y10, S, N, X) {
              var fe = -1, Me = j_, Ke = true, at = y10.length, Et = [], Pr = S.length;
              if (!at)
                return Et;
              N && (S = ts(S, ec(N))), X ? (Me = u2, Ke = false) : S.length >= F && (Me = Qp, Ke = false, S = new rg(S));
              e:
                for (; ++fe < at; ) {
                  var Dr = y10[fe], Ur = N == null ? Dr : N(Dr);
                  if (Dr = X || Dr !== 0 ? Dr : 0, Ke && Ur === Ur) {
                    for (var pn = Pr; pn--; )
                      if (S[pn] === Ur)
                        continue e;
                    Et.push(Dr);
                  } else
                    Me(S, Ur, X) || Et.push(Dr);
                }
              return Et;
            }
            var Ld = o9(nf), FT = o9(C2, true);
            function sL(y10, S) {
              var N = true;
              return Ld(y10, function(X, fe, Me) {
                return N = !!S(X, fe, Me), N;
              }), N;
            }
            function z0(y10, S, N) {
              for (var X = -1, fe = y10.length; ++X < fe; ) {
                var Me = y10[X], Ke = S(Me);
                if (Ke != null && (at === D ? Ke === Ke && !Bf(Ke) : N(Ke, at)))
                  var at = Ke, Et = Me;
              }
              return Et;
            }
            function NT(y10, S, N, X) {
              var fe = y10.length;
              for (N = ri(N), N < 0 && (N = -N > fe ? 0 : fe + N), X = X === D || X > fe ? fe : ri(X), X < 0 && (X += fe), X = N > X ? 0 : X9(X); N < X; )
                y10[N++] = S;
              return y10;
            }
            function w2(y10, S) {
              var N = [];
              return Ld(y10, function(X, fe, Me) {
                S(X, fe, Me) && N.push(X);
              }), N;
            }
            function zu(y10, S, N, X, fe) {
              var Me = -1, Ke = y10.length;
              for (N || (N = vJ), fe || (fe = []); ++Me < Ke; ) {
                var at = y10[Me];
                S > 0 && N(at) ? S > 1 ? zu(at, S - 1, N, X, fe) : Dd(fe, at) : X || (fe[fe.length] = at);
              }
              return fe;
            }
            var S2 = s9(), VT = s9(true);
            function nf(y10, S) {
              return y10 && S2(y10, S, gl);
            }
            function C2(y10, S) {
              return y10 && VT(y10, S, gl);
            }
            function ax(y10, S) {
              return Pd(S, function(N) {
                return lg(y10[N]);
              });
            }
            function ag(y10, S) {
              S = ho(S, y10);
              for (var N = 0, X = S.length; y10 != null && N < X; )
                y10 = y10[kd(S[N++])];
              return N && N == X ? y10 : D;
            }
            function kl(y10, S, N) {
              var X = S(y10);
              return Wa(y10) ? X : Dd(X, N(y10));
            }
            function $u(y10) {
              return y10 == null ? y10 === D ? Nn : Ff : wh && wh in Eo(y10) ? sJ(y10) : _J(y10);
            }
            function E2(y10, S) {
              return y10 > S;
            }
            function uL(y10, S) {
              return y10 != null && bi.call(y10, S);
            }
            function lL(y10, S) {
              return y10 != null && S in Eo(y10);
            }
            function cL(y10, S, N) {
              return y10 >= Bu(S, N) && y10 < to(S, N);
            }
            function Km(y10, S, N) {
              for (var X = N ? u2 : j_, fe = y10[0].length, Me = y10.length, Ke = Me, at = $t(Me), Et = 1 / 0, Pr = []; Ke--; ) {
                var Dr = y10[Ke];
                Ke && S && (Dr = ts(Dr, ec(S))), Et = Bu(Dr.length, Et), at[Ke] = !N && (S || fe >= 120 && Dr.length >= 120) ? new rg(Ke && Dr) : D;
              }
              Dr = y10[0];
              var Ur = -1, pn = at[0];
              e:
                for (; ++Ur < fe && Pr.length < Et; ) {
                  var jn = Dr[Ur], ca = S ? S(jn) : jn;
                  if (jn = N || jn !== 0 ? jn : 0, !(pn ? Qp(pn, ca) : X(Pr, ca, N))) {
                    for (Ke = Me; --Ke; ) {
                      var ui = at[Ke];
                      if (!(ui ? Qp(ui, ca) : X(y10[Ke], ca, N)))
                        continue e;
                    }
                    pn && pn.push(ca), Pr.push(jn);
                  }
                }
              return Pr;
            }
            function fL(y10, S, N, X) {
              return nf(y10, function(fe, Me, Ke) {
                S(X, N(fe), Me, Ke);
              }), X;
            }
            function ig(y10, S, N) {
              S = ho(S, y10), y10 = C9(y10, S);
              var X = y10 == null ? y10 : y10[kd(Ch(S))];
              return X == null ? D : Mc(X, y10, N);
            }
            function jT(y10) {
              return Ws(y10) && $u(y10) == Ja;
            }
            function hL(y10) {
              return Ws(y10) && $u(y10) == It;
            }
            function vL(y10) {
              return Ws(y10) && $u(y10) == Fi;
            }
            function Zm(y10, S, N, X, fe) {
              return y10 === S ? true : y10 == null || S == null || !Ws(y10) && !Ws(S) ? y10 !== y10 && S !== S : BT(y10, S, N, X, Zm, fe);
            }
            function BT(y10, S, N, X, fe, Me) {
              var Ke = Wa(y10), at = Wa(S), Et = Ke ? Oa : nc(y10), Pr = at ? Oa : nc(S);
              Et = Et == Ja ? cl : Et, Pr = Pr == Ja ? cl : Pr;
              var Dr = Et == cl, Ur = Pr == cl, pn = Et == Pr;
              if (pn && $0(y10)) {
                if (!$0(S))
                  return false;
                Ke = true, Dr = false;
              }
              if (pn && !Dr)
                return Me || (Me = new tf()), Ke || lx(y10) ? y9(y10, S, N, X, fe, Me) : iJ(y10, S, Et, N, X, fe, Me);
              if (!(N & Je)) {
                var jn = Dr && bi.call(y10, "__wrapped__"), ca = Ur && bi.call(S, "__wrapped__");
                if (jn || ca) {
                  var ui = jn ? y10.value() : y10, fa = ca ? S.value() : S;
                  return Me || (Me = new tf()), fe(ui, fa, N, X, Me);
                }
              }
              return pn ? (Me || (Me = new tf()), oJ(y10, S, N, X, fe, Me)) : false;
            }
            function dL(y10) {
              return Ws(y10) && nc(y10) == $s;
            }
            function A22(y10, S, N, X) {
              var fe = N.length, Me = fe, Ke = !X;
              if (y10 == null)
                return !Me;
              for (y10 = Eo(y10); fe--; ) {
                var at = N[fe];
                if (Ke && at[2] ? at[1] !== y10[at[0]] : !(at[0] in y10))
                  return false;
              }
              for (; ++fe < Me; ) {
                at = N[fe];
                var Et = at[0], Pr = y10[Et], Dr = at[1];
                if (Ke && at[2]) {
                  if (Pr === D && !(Et in y10))
                    return false;
                } else {
                  var Ur = new tf();
                  if (X)
                    var pn = X(Pr, Dr, Et, y10, S, Ur);
                  if (!(pn === D ? Zm(Dr, Pr, Je | ut, X, Ur) : pn))
                    return false;
                }
              }
              return true;
            }
            function zT(y10) {
              if (!Ls(y10) || pJ(y10))
                return false;
              var S = lg(y10) ? PI3 : or;
              return S.test(Jm(y10));
            }
            function T2(y10) {
              return Ws(y10) && $u(y10) == Jl;
            }
            function M2(y10) {
              return Ws(y10) && nc(y10) == us;
            }
            function pL(y10) {
              return Ws(y10) && lM(y10.length) && !!Uo[$u(y10)];
            }
            function $T(y10) {
              return typeof y10 == "function" ? y10 : y10 == null ? uf : typeof y10 == "object" ? Wa(y10) ? UT(y10[0], y10[1]) : WT(y10) : u8(y10);
            }
            function P2(y10) {
              if (!F2(y10))
                return wT(y10);
              var S = [];
              for (var N in Eo(y10))
                bi.call(y10, N) && N != "constructor" && S.push(N);
              return S;
            }
            function gL(y10) {
              if (!Ls(y10))
                return bJ(y10);
              var S = F2(y10), N = [];
              for (var X in y10)
                X == "constructor" && (S || !bi.call(y10, X)) || N.push(X);
              return N;
            }
            function D2(y10, S) {
              return y10 < S;
            }
            function GT(y10, S) {
              var N = -1, X = of(y10) ? $t(y10.length) : [];
              return Ld(y10, function(fe, Me, Ke) {
                X[++N] = S(fe, Me, Ke);
              }), X;
            }
            function WT(y10) {
              var S = TL(y10);
              return S.length == 1 && S[0][2] ? w92(S[0][0], S[0][1]) : function(N) {
                return N === y10 || A22(N, y10, S);
              };
            }
            function UT(y10, S) {
              return PL(y10) && x9(S) ? w92(kd(y10), S) : function(N) {
                var X = jL(N, y10);
                return X === D && X === S ? BL(N, y10) : Zm(S, X, Je | ut);
              };
            }
            function ix(y10, S, N, X, fe) {
              y10 !== S && S2(S, function(Me, Ke) {
                if (fe || (fe = new tf()), Ls(Me))
                  yL(y10, S, Ke, N, ix, X, fe);
                else {
                  var at = X ? X(IL(y10, Ke), Me, Ke + "", y10, S, fe) : D;
                  at === D && (at = Me), _2(y10, Ke, at);
                }
              }, sf);
            }
            function yL(y10, S, N, X, fe, Me, Ke) {
              var at = IL(y10, N), Et = IL(S, N), Pr = Ke.get(Et);
              if (Pr) {
                _2(y10, N, Pr);
                return;
              }
              var Dr = Me ? Me(at, Et, N + "", y10, S, Ke) : D, Ur = Dr === D;
              if (Ur) {
                var pn = Wa(Et), jn = !pn && $0(Et), ca = !pn && !jn && lx(Et);
                Dr = Et, pn || jn || ca ? Wa(at) ? Dr = at : iu(at) ? Dr = af(at) : jn ? (Ur = false, Dr = t9(Et, true)) : ca ? (Ur = false, Dr = r9(Et, true)) : Dr = [] : V2(Et) || Qm(Et) ? (Dr = at, Qm(at) ? Dr = J9(at) : (!Ls(at) || lg(at)) && (Dr = _9(Et))) : Ur = false;
              }
              Ur && (Ke.set(Et, Dr), fe(Dr, Et, X, Me, Ke), Ke.delete(Et)), _2(y10, N, Dr);
            }
            function HT(y10, S) {
              var N = y10.length;
              if (N)
                return S += S < 0 ? N : 0, ug(S, N) ? y10[S] : D;
            }
            function qT(y10, S, N) {
              S.length ? S = ts(S, function(Me) {
                return Wa(Me) ? function(Ke) {
                  return ag(Ke, Me.length === 1 ? Me[0] : Me);
                } : Me;
              }) : S = [uf];
              var X = -1;
              S = ts(S, ec(oa()));
              var fe = GT(y10, function(Me, Ke, at) {
                var Et = ts(S, function(Pr) {
                  return Pr(Me);
                });
                return { criteria: Et, index: ++X, value: Me };
              });
              return dI(fe, function(Me, Ke) {
                return XX(Me, Ke, N);
              });
            }
            function mL(y10, S) {
              return YT(y10, S, function(N, X) {
                return BL(y10, X);
              });
            }
            function YT(y10, S, N) {
              for (var X = -1, fe = S.length, Me = {}; ++X < fe; ) {
                var Ke = S[X], at = ag(y10, Ke);
                N(at, Ke) && R(Me, ho(Ke, y10), at);
              }
              return Me;
            }
            function bL(y10) {
              return function(S) {
                return ag(S, y10);
              };
            }
            function I2(y10, S, N, X) {
              var fe = X ? vI : M0, Me = -1, Ke = S.length, at = y10;
              for (y10 === S && (S = af(S)), N && (at = ts(y10, ec(N))); ++Me < Ke; )
                for (var Et = 0, Pr = S[Me], Dr = N ? N(Pr) : Pr; (Et = fe(at, Dr, Et, X)) > -1; )
                  at !== y10 && O0.call(at, Et, 1), O0.call(y10, Et, 1);
              return y10;
            }
            function KT(y10, S) {
              for (var N = y10 ? S.length : 0, X = N - 1; N--; ) {
                var fe = S[N];
                if (N == X || fe !== Me) {
                  var Me = fe;
                  ug(fe) ? O0.call(y10, fe, 1) : Xn(y10, fe);
                }
              }
              return y10;
            }
            function L2(y10, S) {
              return y10 + Q_(ST() * (S - y10 + 1));
            }
            function _L(y10, S, N, X) {
              for (var fe = -1, Me = to(J_((S - y10) / (N || 1)), 0), Ke = $t(Me); Me--; )
                Ke[X ? Me : ++fe] = y10, y10 += N;
              return Ke;
            }
            function O2(y10, S) {
              var N = "";
              if (!y10 || S < 1 || S > fr)
                return N;
              do
                S % 2 && (N += y10), S = Q_(S / 2), S && (y10 += y10);
              while (S);
              return N;
            }
            function ti(y10, S) {
              return LL(S9(y10, S, uf), y10 + "");
            }
            function g9(y10) {
              return LT(cx(y10));
            }
            function w9(y10, S) {
              var N = cx(y10);
              return nM(N, ng(S, 0, N.length));
            }
            function R(y10, S, N, X) {
              if (!Ls(y10))
                return y10;
              S = ho(S, y10);
              for (var fe = -1, Me = S.length, Ke = Me - 1, at = y10; at != null && ++fe < Me; ) {
                var Et = kd(S[fe]), Pr = N;
                if (Et === "__proto__" || Et === "constructor" || Et === "prototype")
                  return y10;
                if (fe != Ke) {
                  var Dr = at[Et];
                  Pr = X ? X(Dr, Et, at) : D, Pr === D && (Pr = Ls(Dr) ? Dr : ug(S[fe + 1]) ? [] : {});
                }
                qm(at, Et, Pr), at = at[Et];
              }
              return y10;
            }
            var K = ex ? function(y10, S) {
              return ex.set(y10, S), y10;
            } : uf, ce = dl ? function(y10, S) {
              return dl(y10, "toString", { configurable: true, enumerable: false, value: $L(S), writable: true });
            } : uf;
            function Te(y10) {
              return nM(cx(y10));
            }
            function Ue(y10, S, N) {
              var X = -1, fe = y10.length;
              S < 0 && (S = -S > fe ? 0 : fe + S), N = N > fe ? fe : N, N < 0 && (N += fe), fe = S > N ? 0 : N - S >>> 0, S >>>= 0;
              for (var Me = $t(fe); ++X < fe; )
                Me[X] = y10[X + S];
              return Me;
            }
            function nt(y10, S) {
              var N;
              return Ld(y10, function(X, fe, Me) {
                return N = S(X, fe, Me), !N;
              }), !!N;
            }
            function bt(y10, S, N) {
              var X = 0, fe = y10 == null ? X : y10.length;
              if (typeof S == "number" && S === S && fe <= Zn) {
                for (; X < fe; ) {
                  var Me = X + fe >>> 1, Ke = y10[Me];
                  Ke !== null && !Bf(Ke) && (N ? Ke <= S : Ke < S) ? X = Me + 1 : fe = Me;
                }
                return fe;
              }
              return Er(y10, S, uf, N);
            }
            function Er(y10, S, N, X) {
              var fe = 0, Me = y10 == null ? 0 : y10.length;
              if (Me === 0)
                return 0;
              S = N(S);
              for (var Ke = S !== S, at = S === null, Et = Bf(S), Pr = S === D; fe < Me; ) {
                var Dr = Q_((fe + Me) / 2), Ur = N(y10[Dr]), pn = Ur !== D, jn = Ur === null, ca = Ur === Ur, ui = Bf(Ur);
                if (Ke)
                  var fa = X || ca;
                else
                  Pr ? fa = ca && (X || pn) : at ? fa = ca && pn && (X || !jn) : Et ? fa = ca && pn && !jn && (X || !ui) : jn || ui ? fa = false : fa = X ? Ur <= S : Ur < S;
                fa ? fe = Dr + 1 : Me = Dr;
              }
              return Bu(Me, zr);
            }
            function Mr(y10, S) {
              for (var N = -1, X = y10.length, fe = 0, Me = []; ++N < X; ) {
                var Ke = y10[N], at = S ? S(Ke) : Ke;
                if (!N || !Iv(at, Et)) {
                  var Et = at;
                  Me[fe++] = Ke === 0 ? 0 : Ke;
                }
              }
              return Me;
            }
            function $r(y10) {
              return typeof y10 == "number" ? y10 : Bf(y10) ? Ut : +y10;
            }
            function Qr(y10) {
              if (typeof y10 == "string")
                return y10;
              if (Wa(y10))
                return ts(y10, Qr) + "";
              if (Bf(y10))
                return ET ? ET.call(y10) : "";
              var S = y10 + "";
              return S == "0" && 1 / y10 == -Vn ? "-0" : S;
            }
            function Cn(y10, S, N) {
              var X = -1, fe = j_, Me = y10.length, Ke = true, at = [], Et = at;
              if (N)
                Ke = false, fe = u2;
              else if (Me >= F) {
                var Pr = S ? null : nJ(y10);
                if (Pr)
                  return H_(Pr);
                Ke = false, fe = Qp, Et = new rg();
              } else
                Et = S ? [] : at;
              e:
                for (; ++X < Me; ) {
                  var Dr = y10[X], Ur = S ? S(Dr) : Dr;
                  if (Dr = N || Dr !== 0 ? Dr : 0, Ke && Ur === Ur) {
                    for (var pn = Et.length; pn--; )
                      if (Et[pn] === Ur)
                        continue e;
                    S && Et.push(Ur), at.push(Dr);
                  } else
                    fe(Et, Ur, N) || (Et !== at && Et.push(Ur), at.push(Dr));
                }
              return at;
            }
            function Xn(y10, S) {
              return S = ho(S, y10), y10 = C9(y10, S), y10 == null || delete y10[kd(Ch(S))];
            }
            function Ga(y10, S, N, X) {
              return R(y10, S, N(ag(y10, S)), X);
            }
            function qn(y10, S, N, X) {
              for (var fe = y10.length, Me = X ? fe : -1; (X ? Me-- : ++Me < fe) && S(y10[Me], Me, y10); )
                ;
              return N ? Ue(y10, X ? 0 : Me, X ? Me + 1 : fe) : Ue(y10, X ? Me + 1 : 0, X ? fe : Me);
            }
            function si(y10, S) {
              var N = y10;
              return N instanceof Hn && (N = N.value()), B_(S, function(X, fe) {
                return fe.func.apply(fe.thisArg, Dd([X], fe.args));
              }, N);
            }
            function _i(y10, S, N) {
              var X = y10.length;
              if (X < 2)
                return X ? Cn(y10[0]) : [];
              for (var fe = -1, Me = $t(X); ++fe < X; )
                for (var Ke = y10[fe], at = -1; ++at < X; )
                  at != fe && (Me[fe] = Ym(Me[fe] || Ke, y10[at], S, N));
              return Cn(zu(Me, 1), S, N);
            }
            function rc(y10, S, N) {
              for (var X = -1, fe = y10.length, Me = S.length, Ke = {}; ++X < fe; ) {
                var at = X < Me ? S[X] : D;
                N(Ke, y10[X], at);
              }
              return Ke;
            }
            function Gu(y10) {
              return iu(y10) ? y10 : [];
            }
            function Rl(y10) {
              return typeof y10 == "function" ? y10 : uf;
            }
            function ho(y10, S) {
              return Wa(y10) ? y10 : PL(y10, S) ? [y10] : M9(vo(y10));
            }
            var jf = ti;
            function pl(y10, S, N) {
              var X = y10.length;
              return N = N === D ? X : N, !S && N >= X ? y10 : Ue(y10, S, N);
            }
            var k22 = R0 || function(y10) {
              return ju.clearTimeout(y10);
            };
            function t9(y10, S) {
              if (S)
                return y10.slice();
              var N = y10.length, X = bT ? bT(N) : new y10.constructor(N);
              return y10.copy(X), X;
            }
            function xL(y10) {
              var S = new y10.constructor(y10.byteLength);
              return new Z_(S).set(new Z_(y10)), S;
            }
            function YX(y10, S) {
              var N = S ? xL(y10.buffer) : y10.buffer;
              return new y10.constructor(N, y10.byteOffset, y10.byteLength);
            }
            function KX(y10) {
              var S = new y10.constructor(y10.source, Re.exec(y10));
              return S.lastIndex = y10.lastIndex, S;
            }
            function ZX(y10) {
              return eg ? Eo(eg.call(y10)) : {};
            }
            function r9(y10, S) {
              var N = S ? xL(y10.buffer) : y10.buffer;
              return new y10.constructor(N, y10.byteOffset, y10.length);
            }
            function n9(y10, S) {
              if (y10 !== S) {
                var N = y10 !== D, X = y10 === null, fe = y10 === y10, Me = Bf(y10), Ke = S !== D, at = S === null, Et = S === S, Pr = Bf(S);
                if (!at && !Pr && !Me && y10 > S || Me && Ke && Et && !at && !Pr || X && Ke && Et || !N && Et || !fe)
                  return 1;
                if (!X && !Me && !Pr && y10 < S || Pr && N && fe && !X && !Me || at && N && fe || !Ke && fe || !Et)
                  return -1;
              }
              return 0;
            }
            function XX(y10, S, N) {
              for (var X = -1, fe = y10.criteria, Me = S.criteria, Ke = fe.length, at = N.length; ++X < Ke; ) {
                var Et = n9(fe[X], Me[X]);
                if (Et) {
                  if (X >= at)
                    return Et;
                  var Pr = N[X];
                  return Et * (Pr == "desc" ? -1 : 1);
                }
              }
              return y10.index - S.index;
            }
            function a9(y10, S, N, X) {
              for (var fe = -1, Me = y10.length, Ke = N.length, at = -1, Et = S.length, Pr = to(Me - Ke, 0), Dr = $t(Et + Pr), Ur = !X; ++at < Et; )
                Dr[at] = S[at];
              for (; ++fe < Ke; )
                (Ur || fe < Me) && (Dr[N[fe]] = y10[fe]);
              for (; Pr--; )
                Dr[at++] = y10[fe++];
              return Dr;
            }
            function i9(y10, S, N, X) {
              for (var fe = -1, Me = y10.length, Ke = -1, at = N.length, Et = -1, Pr = S.length, Dr = to(Me - at, 0), Ur = $t(Dr + Pr), pn = !X; ++fe < Dr; )
                Ur[fe] = y10[fe];
              for (var jn = fe; ++Et < Pr; )
                Ur[jn + Et] = S[Et];
              for (; ++Ke < at; )
                (pn || fe < Me) && (Ur[jn + N[Ke]] = y10[fe++]);
              return Ur;
            }
            function af(y10, S) {
              var N = -1, X = y10.length;
              for (S || (S = $t(X)); ++N < X; )
                S[N] = y10[N];
              return S;
            }
            function Od(y10, S, N, X) {
              var fe = !N;
              N || (N = {});
              for (var Me = -1, Ke = S.length; ++Me < Ke; ) {
                var at = S[Me], Et = X ? X(N[at], y10[at], at, N, y10) : D;
                Et === D && (Et = y10[at]), fe ? Dv(N, at, Et) : qm(N, at, Et);
              }
              return N;
            }
            function JX(y10, S) {
              return Od(y10, ML(y10), S);
            }
            function QX(y10, S) {
              return Od(y10, m9(y10), S);
            }
            function ZT(y10, S) {
              return function(N, X) {
                var fe = Wa(N) ? uI : aL, Me = S ? S() : {};
                return fe(N, y10, oa(X, 2), Me);
              };
            }
            function ox(y10) {
              return ti(function(S, N) {
                var X = -1, fe = N.length, Me = fe > 1 ? N[fe - 1] : D, Ke = fe > 2 ? N[2] : D;
                for (Me = y10.length > 3 && typeof Me == "function" ? (fe--, Me) : D, Ke && Pc(N[0], N[1], Ke) && (Me = fe < 3 ? D : Me, fe = 1), S = Eo(S); ++X < fe; ) {
                  var at = N[X];
                  at && y10(S, at, X, Me);
                }
                return S;
              });
            }
            function o9(y10, S) {
              return function(N, X) {
                if (N == null)
                  return N;
                if (!of(N))
                  return y10(N, X);
                for (var fe = N.length, Me = S ? fe : -1, Ke = Eo(N); (S ? Me-- : ++Me < fe) && X(Ke[Me], Me, Ke) !== false; )
                  ;
                return N;
              };
            }
            function s9(y10) {
              return function(S, N, X) {
                for (var fe = -1, Me = Eo(S), Ke = X(S), at = Ke.length; at--; ) {
                  var Et = Ke[y10 ? at : ++fe];
                  if (N(Me[Et], Et, Me) === false)
                    break;
                }
                return S;
              };
            }
            function eJ(y10, S, N) {
              var X = S & gt, fe = R2(y10);
              function Me() {
                var Ke = this && this !== ju && this instanceof Me ? fe : y10;
                return Ke.apply(X ? N : this, arguments);
              }
              return Me;
            }
            function u9(y10) {
              return function(S) {
                S = vo(S);
                var N = Av(S) ? Vf(S) : D, X = N ? N[0] : S.charAt(0), fe = N ? pl(N, 1).join("") : S.slice(1);
                return X[y10]() + fe;
              };
            }
            function sx(y10) {
              return function(S) {
                return B_(o8(i8(S).replace(ZD, "")), y10, "");
              };
            }
            function R2(y10) {
              return function() {
                var S = arguments;
                switch (S.length) {
                  case 0:
                    return new y10();
                  case 1:
                    return new y10(S[0]);
                  case 2:
                    return new y10(S[0], S[1]);
                  case 3:
                    return new y10(S[0], S[1], S[2]);
                  case 4:
                    return new y10(S[0], S[1], S[2], S[3]);
                  case 5:
                    return new y10(S[0], S[1], S[2], S[3], S[4]);
                  case 6:
                    return new y10(S[0], S[1], S[2], S[3], S[4], S[5]);
                  case 7:
                    return new y10(S[0], S[1], S[2], S[3], S[4], S[5], S[6]);
                }
                var N = j0(y10.prototype), X = y10.apply(N, S);
                return Ls(X) ? X : N;
              };
            }
            function tJ(y10, S, N) {
              var X = R2(y10);
              function fe() {
                for (var Me = arguments.length, Ke = $t(Me), at = Me, Et = ux(fe); at--; )
                  Ke[at] = arguments[at];
                var Pr = Me < 3 && Ke[0] !== Et && Ke[Me - 1] !== Et ? [] : Tv(Ke, Et);
                if (Me -= Pr.length, Me < N)
                  return v92(y10, S, XT, fe.placeholder, D, Ke, Pr, D, D, N - Me);
                var Dr = this && this !== ju && this instanceof fe ? X : y10;
                return Mc(Dr, this, Ke);
              }
              return fe;
            }
            function l9(y10) {
              return function(S, N, X) {
                var fe = Eo(S);
                if (!of(S)) {
                  var Me = oa(N, 3);
                  S = gl(S), N = function(at) {
                    return Me(fe[at], at, fe);
                  };
                }
                var Ke = y10(S, N, X);
                return Ke > -1 ? fe[Me ? S[Ke] : Ke] : D;
              };
            }
            function c9(y10) {
              return sg(function(S) {
                var N = S.length, X = N, fe = ef.prototype.thru;
                for (y10 && S.reverse(); X--; ) {
                  var Me = S[X];
                  if (typeof Me != "function")
                    throw new Qc(Z);
                  if (fe && !Ke && tM(Me) == "wrapper")
                    var Ke = new ef([], true);
                }
                for (X = Ke ? X : N; ++X < N; ) {
                  Me = S[X];
                  var at = tM(Me), Et = at == "wrapper" ? AL(Me) : D;
                  Et && DL(Et[0]) && Et[1] == (ar | Gr | vt | rr) && !Et[4].length && Et[9] == 1 ? Ke = Ke[tM(Et[0])].apply(Ke, Et[3]) : Ke = Me.length == 1 && DL(Me) ? Ke[at]() : Ke.thru(Me);
                }
                return function() {
                  var Pr = arguments, Dr = Pr[0];
                  if (Ke && Pr.length == 1 && Wa(Dr))
                    return Ke.plant(Dr).value();
                  for (var Ur = 0, pn = N ? S[Ur].apply(this, Pr) : Dr; ++Ur < N; )
                    pn = S[Ur].call(this, pn);
                  return pn;
                };
              });
            }
            function XT(y10, S, N, X, fe, Me, Ke, at, Et, Pr) {
              var Dr = S & ar, Ur = S & gt, pn = S & lr, jn = S & (Gr | se), ca = S & Ct, ui = pn ? D : R2(y10);
              function fa() {
                for (var Pi = arguments.length, Ni = $t(Pi), zf = Pi; zf--; )
                  Ni[zf] = arguments[zf];
                if (jn)
                  var Dc = ux(fa), $f = dT(Ni, Dc);
                if (X && (Ni = a9(Ni, X, fe, jn)), Me && (Ni = i9(Ni, Me, Ke, jn)), Pi -= $f, jn && Pi < Pr) {
                  var ou = Tv(Ni, Dc);
                  return v92(y10, S, XT, fa.placeholder, N, Ni, ou, at, Et, Pr - Pi);
                }
                var Lv = Ur ? N : this, fg = pn ? Lv[y10] : y10;
                return Pi = Ni.length, at ? Ni = xJ(Ni, at) : ca && Pi > 1 && Ni.reverse(), Dr && Et < Pi && (Ni.length = Et), this && this !== ju && this instanceof fa && (fg = ui || R2(fg)), fg.apply(Lv, Ni);
              }
              return fa;
            }
            function f9(y10, S) {
              return function(N, X) {
                return fL(N, y10, S(X), {});
              };
            }
            function JT(y10, S) {
              return function(N, X) {
                var fe;
                if (N === D && X === D)
                  return S;
                if (N !== D && (fe = N), X !== D) {
                  if (fe === D)
                    return X;
                  typeof N == "string" || typeof X == "string" ? (N = Qr(N), X = Qr(X)) : (N = $r(N), X = $r(X)), fe = y10(N, X);
                }
                return fe;
              };
            }
            function wL(y10) {
              return sg(function(S) {
                return S = ts(S, ec(oa())), ti(function(N) {
                  var X = this;
                  return y10(S, function(fe) {
                    return Mc(fe, X, N);
                  });
                });
              });
            }
            function QT(y10, S) {
              S = S === D ? " " : Qr(S);
              var N = S.length;
              if (N < 2)
                return N ? O2(S, y10) : S;
              var X = O2(S, J_(y10 / P0(S)));
              return Av(S) ? pl(Vf(X), 0, y10).join("") : X.slice(0, y10);
            }
            function rJ(y10, S, N, X) {
              var fe = S & gt, Me = R2(y10);
              function Ke() {
                for (var at = -1, Et = arguments.length, Pr = -1, Dr = X.length, Ur = $t(Dr + Et), pn = this && this !== ju && this instanceof Ke ? Me : y10; ++Pr < Dr; )
                  Ur[Pr] = X[Pr];
                for (; Et--; )
                  Ur[Pr++] = arguments[++at];
                return Mc(pn, fe ? N : this, Ur);
              }
              return Ke;
            }
            function h9(y10) {
              return function(S, N, X) {
                return X && typeof X != "number" && Pc(S, N, X) && (N = X = D), S = cg(S), N === D ? (N = S, S = 0) : N = cg(N), X = X === D ? S < N ? 1 : -1 : cg(X), _L(S, N, X, y10);
              };
            }
            function eM(y10) {
              return function(S, N) {
                return typeof S == "string" && typeof N == "string" || (S = Eh(S), N = Eh(N)), y10(S, N);
              };
            }
            function v92(y10, S, N, X, fe, Me, Ke, at, Et, Pr) {
              var Dr = S & Gr, Ur = Dr ? Ke : D, pn = Dr ? D : Ke, jn = Dr ? Me : D, ca = Dr ? D : Me;
              S |= Dr ? vt : Lt, S &= ~(Dr ? Lt : vt), S & tr || (S &= ~(gt | lr));
              var ui = [y10, S, fe, jn, Ur, ca, pn, at, Et, Pr], fa = N.apply(D, ui);
              return DL(y10) && E9(fa, ui), fa.placeholder = X, A9(fa, y10, S);
            }
            function SL(y10) {
              var S = ei[y10];
              return function(N, X) {
                if (N = Eh(N), X = X == null ? 0 : Bu(ri(X), 292), X && Sh(N)) {
                  var fe = (vo(N) + "e").split("e"), Me = S(fe[0] + "e" + (+fe[1] + X));
                  return fe = (vo(Me) + "e").split("e"), +(fe[0] + "e" + (+fe[1] - X));
                }
                return S(N);
              };
            }
            var nJ = N0 && 1 / H_(new N0([, -0]))[1] == Vn ? function(y10) {
              return new N0(y10);
            } : UL;
            function d9(y10) {
              return function(S) {
                var N = nc(S);
                return N == $s ? g2(S) : N == us ? bI(S) : $_(S, y10(S));
              };
            }
            function og(y10, S, N, X, fe, Me, Ke, at) {
              var Et = S & lr;
              if (!Et && typeof y10 != "function")
                throw new Qc(Z);
              var Pr = X ? X.length : 0;
              if (Pr || (S &= ~(vt | Lt), X = fe = D), Ke = Ke === D ? Ke : to(ri(Ke), 0), at = at === D ? at : ri(at), Pr -= fe ? fe.length : 0, S & Lt) {
                var Dr = X, Ur = fe;
                X = fe = D;
              }
              var pn = Et ? D : AL(y10), jn = [y10, S, N, X, fe, Dr, Ur, Me, Ke, at];
              if (pn && mJ(jn, pn), y10 = jn[0], S = jn[1], N = jn[2], X = jn[3], fe = jn[4], at = jn[9] = jn[9] === D ? Et ? 0 : y10.length : to(jn[9] - Pr, 0), !at && S & (Gr | se) && (S &= ~(Gr | se)), !S || S == gt)
                var ca = eJ(y10, S, N);
              else
                S == Gr || S == se ? ca = tJ(y10, S, at) : (S == vt || S == (gt | vt)) && !fe.length ? ca = rJ(y10, S, N, X) : ca = XT.apply(D, jn);
              var ui = pn ? K : E9;
              return A9(ui(ca, jn), y10, S);
            }
            function p9(y10, S, N, X) {
              return y10 === D || Iv(y10, D0[N]) && !bi.call(X, N) ? S : y10;
            }
            function g92(y10, S, N, X, fe, Me) {
              return Ls(y10) && Ls(S) && (Me.set(S, y10), ix(y10, S, D, g92, Me), Me.delete(S)), y10;
            }
            function aJ(y10) {
              return V2(y10) ? D : y10;
            }
            function y9(y10, S, N, X, fe, Me) {
              var Ke = N & Je, at = y10.length, Et = S.length;
              if (at != Et && !(Ke && Et > at))
                return false;
              var Pr = Me.get(y10), Dr = Me.get(S);
              if (Pr && Dr)
                return Pr == S && Dr == y10;
              var Ur = -1, pn = true, jn = N & ut ? new rg() : D;
              for (Me.set(y10, S), Me.set(S, y10); ++Ur < at; ) {
                var ca = y10[Ur], ui = S[Ur];
                if (X)
                  var fa = Ke ? X(ui, ca, Ur, S, y10, Me) : X(ca, ui, Ur, y10, S, Me);
                if (fa !== D) {
                  if (fa)
                    continue;
                  pn = false;
                  break;
                }
                if (jn) {
                  if (!l22(S, function(Pi, Ni) {
                    if (!Qp(jn, Ni) && (ca === Pi || fe(ca, Pi, N, X, Me)))
                      return jn.push(Ni);
                  })) {
                    pn = false;
                    break;
                  }
                } else if (!(ca === ui || fe(ca, ui, N, X, Me))) {
                  pn = false;
                  break;
                }
              }
              return Me.delete(y10), Me.delete(S), pn;
            }
            function iJ(y10, S, N, X, fe, Me, Ke) {
              switch (N) {
                case Sr:
                  if (y10.byteLength != S.byteLength || y10.byteOffset != S.byteOffset)
                    return false;
                  y10 = y10.buffer, S = S.buffer;
                case It:
                  return !(y10.byteLength != S.byteLength || !Me(new Z_(y10), new Z_(S)));
                case Qa:
                case Fi:
                case Dl:
                  return Iv(+y10, +S);
                case vs:
                  return y10.name == S.name && y10.message == S.message;
                case Jl:
                case Ps:
                  return y10 == S + "";
                case $s:
                  var at = g2;
                case us:
                  var Et = X & Je;
                  if (at || (at = H_), y10.size != S.size && !Et)
                    return false;
                  var Pr = Ke.get(y10);
                  if (Pr)
                    return Pr == S;
                  X |= ut, Ke.set(y10, S);
                  var Dr = y9(at(y10), at(S), X, fe, Me, Ke);
                  return Ke.delete(y10), Dr;
                case wo:
                  if (eg)
                    return eg.call(y10) == eg.call(S);
              }
              return false;
            }
            function oJ(y10, S, N, X, fe, Me) {
              var Ke = N & Je, at = CL(y10), Et = at.length, Pr = CL(S), Dr = Pr.length;
              if (Et != Dr && !Ke)
                return false;
              for (var Ur = Et; Ur--; ) {
                var pn = at[Ur];
                if (!(Ke ? pn in S : bi.call(S, pn)))
                  return false;
              }
              var jn = Me.get(y10), ca = Me.get(S);
              if (jn && ca)
                return jn == S && ca == y10;
              var ui = true;
              Me.set(y10, S), Me.set(S, y10);
              for (var fa = Ke; ++Ur < Et; ) {
                pn = at[Ur];
                var Pi = y10[pn], Ni = S[pn];
                if (X)
                  var zf = Ke ? X(Ni, Pi, pn, S, y10, Me) : X(Pi, Ni, pn, y10, S, Me);
                if (!(zf === D ? Pi === Ni || fe(Pi, Ni, N, X, Me) : zf)) {
                  ui = false;
                  break;
                }
                fa || (fa = pn == "constructor");
              }
              if (ui && !fa) {
                var Dc = y10.constructor, $f = S.constructor;
                Dc != $f && "constructor" in y10 && "constructor" in S && !(typeof Dc == "function" && Dc instanceof Dc && typeof $f == "function" && $f instanceof $f) && (ui = false);
              }
              return Me.delete(y10), Me.delete(S), ui;
            }
            function sg(y10) {
              return LL(S9(y10, D, L9), y10 + "");
            }
            function CL(y10) {
              return kl(y10, gl, ML);
            }
            function EL(y10) {
              return kl(y10, sf, m9);
            }
            var AL = ex ? function(y10) {
              return ex.get(y10);
            } : UL;
            function tM(y10) {
              for (var S = y10.name + "", N = V0[S], X = bi.call(V0, S) ? N.length : 0; X--; ) {
                var fe = N[X], Me = fe.func;
                if (Me == null || Me == y10)
                  return fe.name;
              }
              return S;
            }
            function ux(y10) {
              var S = bi.call(we, "placeholder") ? we : y10;
              return S.placeholder;
            }
            function oa() {
              var y10 = we.iteratee || GL;
              return y10 = y10 === GL ? $T : y10, arguments.length ? y10(arguments[0], arguments[1]) : y10;
            }
            function rM(y10, S) {
              var N = y10.__data__;
              return dJ(S) ? N[typeof S == "string" ? "string" : "hash"] : N.map;
            }
            function TL(y10) {
              for (var S = gl(y10), N = S.length; N--; ) {
                var X = S[N], fe = y10[X];
                S[N] = [X, fe, x9(fe)];
              }
              return S;
            }
            function Xm(y10, S) {
              var N = yI(y10, S);
              return zT(N) ? N : D;
            }
            function sJ(y10) {
              var S = bi.call(y10, wh), N = y10[wh];
              try {
                y10[wh] = D;
                var X = true;
              } catch {
              }
              var fe = Vo.call(y10);
              return X && (S ? y10[wh] = N : delete y10[wh]), fe;
            }
            var ML = m22 ? function(y10) {
              return y10 == null ? [] : (y10 = Eo(y10), Pd(m22(y10), function(S) {
                return L0.call(y10, S);
              }));
            } : HL, m9 = m22 ? function(y10) {
              for (var S = []; y10; )
                Dd(S, ML(y10)), y10 = X_(y10);
              return S;
            } : HL, nc = $u;
            (F0 && nc(new F0(new ArrayBuffer(1))) != Sr || Wm && nc(new Wm()) != $s || b22 && nc(b22.resolve()) != Nu || N0 && nc(new N0()) != us || Um && nc(new Um()) != mr) && (nc = function(y10) {
              var S = $u(y10), N = S == cl ? y10.constructor : D, X = N ? Jm(N) : "";
              if (X)
                switch (X) {
                  case OI:
                    return Sr;
                  case kI:
                    return $s;
                  case RI:
                    return Nu;
                  case FI:
                    return us;
                  case NI:
                    return mr;
                }
              return S;
            });
            function uJ(y10, S, N) {
              for (var X = -1, fe = N.length; ++X < fe; ) {
                var Me = N[X], Ke = Me.size;
                switch (Me.type) {
                  case "drop":
                    y10 += Ke;
                    break;
                  case "dropRight":
                    S -= Ke;
                    break;
                  case "take":
                    S = Bu(S, y10 + Ke);
                    break;
                  case "takeRight":
                    y10 = to(y10, S - Ke);
                    break;
                }
              }
              return { start: y10, end: S };
            }
            function lJ(y10) {
              var S = y10.match(t22);
              return S ? S[1].split(jm) : [];
            }
            function b9(y10, S, N) {
              S = ho(S, y10);
              for (var X = -1, fe = S.length, Me = false; ++X < fe; ) {
                var Ke = kd(S[X]);
                if (!(Me = y10 != null && N(y10, Ke)))
                  break;
                y10 = y10[Ke];
              }
              return Me || ++X != fe ? Me : (fe = y10 == null ? 0 : y10.length, !!fe && lM(fe) && ug(Ke, fe) && (Wa(y10) || Qm(y10)));
            }
            function cJ(y10) {
              var S = y10.length, N = new y10.constructor(S);
              return S && typeof y10[0] == "string" && bi.call(y10, "index") && (N.index = y10.index, N.input = y10.input), N;
            }
            function _9(y10) {
              return typeof y10.constructor == "function" && !F2(y10) ? j0(X_(y10)) : {};
            }
            function fJ(y10, S, N) {
              var X = y10.constructor;
              switch (S) {
                case It:
                  return xL(y10);
                case Qa:
                case Fi:
                  return new X(+y10);
                case Sr:
                  return YX(y10, N);
                case rn:
                case An:
                case Bn:
                case ka:
                case $i:
                case Fo:
                case So:
                case ds:
                case Co:
                  return r9(y10, N);
                case $s:
                  return new X();
                case Dl:
                case Ps:
                  return new X(y10);
                case Jl:
                  return KX(y10);
                case us:
                  return new X();
                case wo:
                  return ZX(y10);
              }
            }
            function hJ(y10, S) {
              var N = S.length;
              if (!N)
                return y10;
              var X = N - 1;
              return S[X] = (N > 1 ? "& " : "") + S[X], S = S.join(N > 2 ? ", " : " "), y10.replace(F_, `{
/* [wrapped with ` + S + `] */
`);
            }
            function vJ(y10) {
              return Wa(y10) || Qm(y10) || !!(_T && y10 && y10[_T]);
            }
            function ug(y10, S) {
              var N = typeof y10;
              return S = S == null ? fr : S, !!S && (N == "number" || N != "symbol" && wt.test(y10)) && y10 > -1 && y10 % 1 == 0 && y10 < S;
            }
            function Pc(y10, S, N) {
              if (!Ls(N))
                return false;
              var X = typeof S;
              return (X == "number" ? of(N) && ug(S, N.length) : X == "string" && S in N) ? Iv(N[S], y10) : false;
            }
            function PL(y10, S) {
              if (Wa(y10))
                return false;
              var N = typeof y10;
              return N == "number" || N == "symbol" || N == "boolean" || y10 == null || Bf(y10) ? true : Ql.test(y10) || !hl.test(y10) || S != null && y10 in Eo(S);
            }
            function dJ(y10) {
              var S = typeof y10;
              return S == "string" || S == "number" || S == "symbol" || S == "boolean" ? y10 !== "__proto__" : y10 === null;
            }
            function DL(y10) {
              var S = tM(y10), N = we[S];
              if (typeof N != "function" || !(S in Hn.prototype))
                return false;
              if (y10 === N)
                return true;
              var X = AL(N);
              return !!X && y10 === X[0];
            }
            function pJ(y10) {
              return !!Gm && Gm in y10;
            }
            var gJ = I0 ? lg : qL;
            function F2(y10) {
              var S = y10 && y10.constructor, N = typeof S == "function" && S.prototype || D0;
              return y10 === N;
            }
            function x9(y10) {
              return y10 === y10 && !Ls(y10);
            }
            function w92(y10, S) {
              return function(N) {
                return N == null ? false : N[y10] === S && (S !== D || y10 in Eo(N));
              };
            }
            function yJ(y10) {
              var S = sM(y10, function(X) {
                return N.size === ve && N.clear(), X;
              }), N = S.cache;
              return S;
            }
            function mJ(y10, S) {
              var N = y10[1], X = S[1], fe = N | X, Me = fe < (gt | lr | ar), Ke = X == ar && N == Gr || X == ar && N == rr && y10[7].length <= S[8] || X == (ar | rr) && S[7].length <= S[8] && N == Gr;
              if (!(Me || Ke))
                return y10;
              X & gt && (y10[2] = S[2], fe |= N & gt ? 0 : tr);
              var at = S[3];
              if (at) {
                var Et = y10[3];
                y10[3] = Et ? a9(Et, at, S[4]) : at, y10[4] = Et ? Tv(y10[3], ge) : S[4];
              }
              return at = S[5], at && (Et = y10[5], y10[5] = Et ? i9(Et, at, S[6]) : at, y10[6] = Et ? Tv(y10[5], ge) : S[6]), at = S[7], at && (y10[7] = at), X & ar && (y10[8] = y10[8] == null ? S[8] : Bu(y10[8], S[8])), y10[9] == null && (y10[9] = S[9]), y10[0] = S[0], y10[1] = fe, y10;
            }
            function bJ(y10) {
              var S = [];
              if (y10 != null)
                for (var N in Eo(y10))
                  S.push(N);
              return S;
            }
            function _J(y10) {
              return Vo.call(y10);
            }
            function S9(y10, S, N) {
              return S = to(S === D ? y10.length - 1 : S, 0), function() {
                for (var X = arguments, fe = -1, Me = to(X.length - S, 0), Ke = $t(Me); ++fe < Me; )
                  Ke[fe] = X[S + fe];
                fe = -1;
                for (var at = $t(S + 1); ++fe < S; )
                  at[fe] = X[fe];
                return at[S] = N(Ke), Mc(y10, this, at);
              };
            }
            function C9(y10, S) {
              return S.length < 2 ? y10 : ag(y10, Ue(S, 0, -1));
            }
            function xJ(y10, S) {
              for (var N = y10.length, X = Bu(S.length, N), fe = af(y10); X--; ) {
                var Me = S[X];
                y10[X] = ug(Me, N) ? fe[Me] : D;
              }
              return y10;
            }
            function IL(y10, S) {
              if (!(S === "constructor" && typeof y10[S] == "function") && S != "__proto__")
                return y10[S];
            }
            var E9 = T9(K), N2 = II || function(y10, S) {
              return ju.setTimeout(y10, S);
            }, LL = T9(ce);
            function A9(y10, S, N) {
              var X = S + "";
              return LL(y10, hJ(X, wJ(lJ(X), N)));
            }
            function T9(y10) {
              var S = 0, N = 0;
              return function() {
                var X = LI(), fe = mt - (X - N);
                if (N = X, fe > 0) {
                  if (++S >= Nr)
                    return arguments[0];
                } else
                  S = 0;
                return y10.apply(D, arguments);
              };
            }
            function nM(y10, S) {
              var N = -1, X = y10.length, fe = X - 1;
              for (S = S === D ? X : S; ++N < S; ) {
                var Me = L2(N, fe), Ke = y10[Me];
                y10[Me] = y10[N], y10[N] = Ke;
              }
              return y10.length = S, y10;
            }
            var M9 = yJ(function(y10) {
              var S = [];
              return y10.charCodeAt(0) === 46 && S.push(""), y10.replace(Cd, function(N, X, fe, Me) {
                S.push(fe ? Me.replace(Ge, "$1") : X || N);
              }), S;
            });
            function kd(y10) {
              if (typeof y10 == "string" || Bf(y10))
                return y10;
              var S = y10 + "";
              return S == "0" && 1 / y10 == -Vn ? "-0" : S;
            }
            function Jm(y10) {
              if (y10 != null) {
                try {
                  return Y_.call(y10);
                } catch {
                }
                try {
                  return y10 + "";
                } catch {
                }
              }
              return "";
            }
            function wJ(y10, S) {
              return Jc(gi, function(N) {
                var X = "_." + N[0];
                S & N[1] && !j_(y10, X) && y10.push(X);
              }), y10.sort();
            }
            function P9(y10) {
              if (y10 instanceof Hn)
                return y10.clone();
              var S = new ef(y10.__wrapped__, y10.__chain__);
              return S.__actions__ = af(y10.__actions__), S.__index__ = y10.__index__, S.__values__ = y10.__values__, S;
            }
            function SJ(y10, S, N) {
              (N ? Pc(y10, S, N) : S === D) ? S = 1 : S = to(ri(S), 0);
              var X = y10 == null ? 0 : y10.length;
              if (!X || S < 1)
                return [];
              for (var fe = 0, Me = 0, Ke = $t(J_(X / S)); fe < X; )
                Ke[Me++] = Ue(y10, fe, fe += S);
              return Ke;
            }
            function CJ(y10) {
              for (var S = -1, N = y10 == null ? 0 : y10.length, X = 0, fe = []; ++S < N; ) {
                var Me = y10[S];
                Me && (fe[X++] = Me);
              }
              return fe;
            }
            function EJ() {
              var y10 = arguments.length;
              if (!y10)
                return [];
              for (var S = $t(y10 - 1), N = arguments[0], X = y10; X--; )
                S[X - 1] = arguments[X];
              return Dd(Wa(N) ? af(N) : [N], zu(S, 1));
            }
            var AJ = ti(function(y10, S) {
              return iu(y10) ? Ym(y10, zu(S, 1, iu, true)) : [];
            }), TJ = ti(function(y10, S) {
              var N = Ch(S);
              return iu(N) && (N = D), iu(y10) ? Ym(y10, zu(S, 1, iu, true), oa(N, 2)) : [];
            }), MJ = ti(function(y10, S) {
              var N = Ch(S);
              return iu(N) && (N = D), iu(y10) ? Ym(y10, zu(S, 1, iu, true), D, N) : [];
            });
            function PJ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              return X ? (S = N || S === D ? 1 : ri(S), Ue(y10, S < 0 ? 0 : S, X)) : [];
            }
            function DJ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              return X ? (S = N || S === D ? 1 : ri(S), S = X - S, Ue(y10, 0, S < 0 ? 0 : S)) : [];
            }
            function IJ(y10, S) {
              return y10 && y10.length ? qn(y10, oa(S, 3), true, true) : [];
            }
            function LJ(y10, S) {
              return y10 && y10.length ? qn(y10, oa(S, 3), true) : [];
            }
            function OJ(y10, S, N, X) {
              var fe = y10 == null ? 0 : y10.length;
              return fe ? (N && typeof N != "number" && Pc(y10, S, N) && (N = 0, X = fe), NT(y10, S, N, X)) : [];
            }
            function D9(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              if (!X)
                return -1;
              var fe = N == null ? 0 : ri(N);
              return fe < 0 && (fe = to(X + fe, 0)), z_(y10, oa(S, 3), fe);
            }
            function I9(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              if (!X)
                return -1;
              var fe = X - 1;
              return N !== D && (fe = ri(N), fe = N < 0 ? to(X + fe, 0) : Bu(fe, X - 1)), z_(y10, oa(S, 3), fe, true);
            }
            function L9(y10) {
              var S = y10 == null ? 0 : y10.length;
              return S ? zu(y10, 1) : [];
            }
            function kJ(y10) {
              var S = y10 == null ? 0 : y10.length;
              return S ? zu(y10, Vn) : [];
            }
            function RJ(y10, S) {
              var N = y10 == null ? 0 : y10.length;
              return N ? (S = S === D ? 1 : ri(S), zu(y10, S)) : [];
            }
            function FJ(y10) {
              for (var S = -1, N = y10 == null ? 0 : y10.length, X = {}; ++S < N; ) {
                var fe = y10[S];
                X[fe[0]] = fe[1];
              }
              return X;
            }
            function O9(y10) {
              return y10 && y10.length ? y10[0] : D;
            }
            function NJ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              if (!X)
                return -1;
              var fe = N == null ? 0 : ri(N);
              return fe < 0 && (fe = to(X + fe, 0)), M0(y10, S, fe);
            }
            function VJ(y10) {
              var S = y10 == null ? 0 : y10.length;
              return S ? Ue(y10, 0, -1) : [];
            }
            var jJ = ti(function(y10) {
              var S = ts(y10, Gu);
              return S.length && S[0] === y10[0] ? Km(S) : [];
            }), BJ = ti(function(y10) {
              var S = Ch(y10), N = ts(y10, Gu);
              return S === Ch(N) ? S = D : N.pop(), N.length && N[0] === y10[0] ? Km(N, oa(S, 2)) : [];
            }), zJ = ti(function(y10) {
              var S = Ch(y10), N = ts(y10, Gu);
              return S = typeof S == "function" ? S : D, S && N.pop(), N.length && N[0] === y10[0] ? Km(N, D, S) : [];
            });
            function $J(y10, S) {
              return y10 == null ? "" : $a.call(y10, S);
            }
            function Ch(y10) {
              var S = y10 == null ? 0 : y10.length;
              return S ? y10[S - 1] : D;
            }
            function GJ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              if (!X)
                return -1;
              var fe = X;
              return N !== D && (fe = ri(N), fe = fe < 0 ? to(X + fe, 0) : Bu(fe, X - 1)), S === S ? xI(y10, S, fe) : z_(y10, cT, fe, true);
            }
            function WJ(y10, S) {
              return y10 && y10.length ? HT(y10, ri(S)) : D;
            }
            var UJ = ti(k9);
            function k9(y10, S) {
              return y10 && y10.length && S && S.length ? I2(y10, S) : y10;
            }
            function HJ(y10, S, N) {
              return y10 && y10.length && S && S.length ? I2(y10, S, oa(N, 2)) : y10;
            }
            function qJ(y10, S, N) {
              return y10 && y10.length && S && S.length ? I2(y10, S, D, N) : y10;
            }
            var YJ = sg(function(y10, S) {
              var N = y10 == null ? 0 : y10.length, X = x22(y10, S);
              return KT(y10, ts(S, function(fe) {
                return ug(fe, N) ? +fe : fe;
              }).sort(n9)), X;
            });
            function KJ(y10, S) {
              var N = [];
              if (!(y10 && y10.length))
                return N;
              var X = -1, fe = [], Me = y10.length;
              for (S = oa(S, 3); ++X < Me; ) {
                var Ke = y10[X];
                S(Ke, X, y10) && (N.push(Ke), fe.push(X));
              }
              return KT(y10, fe), N;
            }
            function OL(y10) {
              return y10 == null ? y10 : CT.call(y10);
            }
            function ZJ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              return X ? (N && typeof N != "number" && Pc(y10, S, N) ? (S = 0, N = X) : (S = S == null ? 0 : ri(S), N = N === D ? X : ri(N)), Ue(y10, S, N)) : [];
            }
            function XJ(y10, S) {
              return bt(y10, S);
            }
            function JJ(y10, S, N) {
              return Er(y10, S, oa(N, 2));
            }
            function QJ(y10, S) {
              var N = y10 == null ? 0 : y10.length;
              if (N) {
                var X = bt(y10, S);
                if (X < N && Iv(y10[X], S))
                  return X;
              }
              return -1;
            }
            function eQ(y10, S) {
              return bt(y10, S, true);
            }
            function tQ(y10, S, N) {
              return Er(y10, S, oa(N, 2), true);
            }
            function rQ(y10, S) {
              var N = y10 == null ? 0 : y10.length;
              if (N) {
                var X = bt(y10, S, true) - 1;
                if (Iv(y10[X], S))
                  return X;
              }
              return -1;
            }
            function nQ(y10) {
              return y10 && y10.length ? Mr(y10) : [];
            }
            function aQ(y10, S) {
              return y10 && y10.length ? Mr(y10, oa(S, 2)) : [];
            }
            function iQ(y10) {
              var S = y10 == null ? 0 : y10.length;
              return S ? Ue(y10, 1, S) : [];
            }
            function oQ(y10, S, N) {
              return y10 && y10.length ? (S = N || S === D ? 1 : ri(S), Ue(y10, 0, S < 0 ? 0 : S)) : [];
            }
            function sQ(y10, S, N) {
              var X = y10 == null ? 0 : y10.length;
              return X ? (S = N || S === D ? 1 : ri(S), S = X - S, Ue(y10, S < 0 ? 0 : S, X)) : [];
            }
            function uQ(y10, S) {
              return y10 && y10.length ? qn(y10, oa(S, 3), false, true) : [];
            }
            function lQ(y10, S) {
              return y10 && y10.length ? qn(y10, oa(S, 3)) : [];
            }
            var cQ = ti(function(y10) {
              return Cn(zu(y10, 1, iu, true));
            }), fQ = ti(function(y10) {
              var S = Ch(y10);
              return iu(S) && (S = D), Cn(zu(y10, 1, iu, true), oa(S, 2));
            }), hQ = ti(function(y10) {
              var S = Ch(y10);
              return S = typeof S == "function" ? S : D, Cn(zu(y10, 1, iu, true), D, S);
            });
            function vQ(y10) {
              return y10 && y10.length ? Cn(y10) : [];
            }
            function dQ(y10, S) {
              return y10 && y10.length ? Cn(y10, oa(S, 2)) : [];
            }
            function pQ(y10, S) {
              return S = typeof S == "function" ? S : D, y10 && y10.length ? Cn(y10, D, S) : [];
            }
            function kL(y10) {
              if (!(y10 && y10.length))
                return [];
              var S = 0;
              return y10 = Pd(y10, function(N) {
                if (iu(N))
                  return S = to(N.length, S), true;
              }), v22(S, function(N) {
                return ts(y10, c22(N));
              });
            }
            function R9(y10, S) {
              if (!(y10 && y10.length))
                return [];
              var N = kL(y10);
              return S == null ? N : ts(N, function(X) {
                return Mc(S, D, X);
              });
            }
            var gQ = ti(function(y10, S) {
              return iu(y10) ? Ym(y10, S) : [];
            }), yQ = ti(function(y10) {
              return _i(Pd(y10, iu));
            }), mQ = ti(function(y10) {
              var S = Ch(y10);
              return iu(S) && (S = D), _i(Pd(y10, iu), oa(S, 2));
            }), bQ = ti(function(y10) {
              var S = Ch(y10);
              return S = typeof S == "function" ? S : D, _i(Pd(y10, iu), D, S);
            }), _Q = ti(kL);
            function xQ(y10, S) {
              return rc(y10 || [], S || [], qm);
            }
            function wQ(y10, S) {
              return rc(y10 || [], S || [], R);
            }
            var SQ = ti(function(y10) {
              var S = y10.length, N = S > 1 ? y10[S - 1] : D;
              return N = typeof N == "function" ? (y10.pop(), N) : D, R9(y10, N);
            });
            function F9(y10) {
              var S = we(y10);
              return S.__chain__ = true, S;
            }
            function CQ(y10, S) {
              return S(y10), y10;
            }
            function aM(y10, S) {
              return S(y10);
            }
            var EQ = sg(function(y10) {
              var S = y10.length, N = S ? y10[0] : 0, X = this.__wrapped__, fe = function(Me) {
                return x22(Me, y10);
              };
              return S > 1 || this.__actions__.length || !(X instanceof Hn) || !ug(N) ? this.thru(fe) : (X = X.slice(N, +N + (S ? 1 : 0)), X.__actions__.push({ func: aM, args: [fe], thisArg: D }), new ef(X, this.__chain__).thru(function(Me) {
                return S && !Me.length && Me.push(D), Me;
              }));
            });
            function AQ() {
              return F9(this);
            }
            function TQ() {
              return new ef(this.value(), this.__chain__);
            }
            function MQ() {
              this.__values__ === D && (this.__values__ = Z9(this.value()));
              var y10 = this.__index__ >= this.__values__.length, S = y10 ? D : this.__values__[this.__index__++];
              return { done: y10, value: S };
            }
            function PQ() {
              return this;
            }
            function DQ(y10) {
              for (var S, N = this; N instanceof rx; ) {
                var X = P9(N);
                X.__index__ = 0, X.__values__ = D, S ? fe.__wrapped__ = X : S = X;
                var fe = X;
                N = N.__wrapped__;
              }
              return fe.__wrapped__ = y10, S;
            }
            function IQ() {
              var y10 = this.__wrapped__;
              if (y10 instanceof Hn) {
                var S = y10;
                return this.__actions__.length && (S = new Hn(this)), S = S.reverse(), S.__actions__.push({ func: aM, args: [OL], thisArg: D }), new ef(S, this.__chain__);
              }
              return this.thru(OL);
            }
            function LQ() {
              return si(this.__wrapped__, this.__actions__);
            }
            var OQ = ZT(function(y10, S, N) {
              bi.call(y10, N) ? ++y10[N] : Dv(y10, N, 1);
            });
            function kQ(y10, S, N) {
              var X = Wa(y10) ? uT : sL;
              return N && Pc(y10, S, N) && (S = D), X(y10, oa(S, 3));
            }
            function RQ(y10, S) {
              var N = Wa(y10) ? Pd : w2;
              return N(y10, oa(S, 3));
            }
            var FQ = l9(D9), NQ = l9(I9);
            function VQ(y10, S) {
              return zu(iM(y10, S), 1);
            }
            function jQ(y10, S) {
              return zu(iM(y10, S), Vn);
            }
            function BQ(y10, S, N) {
              return N = N === D ? 1 : ri(N), zu(iM(y10, S), N);
            }
            function N9(y10, S) {
              var N = Wa(y10) ? Jc : Ld;
              return N(y10, oa(S, 3));
            }
            function V9(y10, S) {
              var N = Wa(y10) ? lI : FT;
              return N(y10, oa(S, 3));
            }
            var zQ = ZT(function(y10, S, N) {
              bi.call(y10, N) ? y10[N].push(S) : Dv(y10, N, [S]);
            });
            function $Q(y10, S, N, X) {
              y10 = of(y10) ? y10 : cx(y10), N = N && !X ? ri(N) : 0;
              var fe = y10.length;
              return N < 0 && (N = to(fe + N, 0)), cM(y10) ? N <= fe && y10.indexOf(S, N) > -1 : !!fe && M0(y10, S, N) > -1;
            }
            var GQ = ti(function(y10, S, N) {
              var X = -1, fe = typeof S == "function", Me = of(y10) ? $t(y10.length) : [];
              return Ld(y10, function(Ke) {
                Me[++X] = fe ? Mc(S, Ke, N) : ig(Ke, S, N);
              }), Me;
            }), WQ = ZT(function(y10, S, N) {
              Dv(y10, N, S);
            });
            function iM(y10, S) {
              var N = Wa(y10) ? ts : GT;
              return N(y10, oa(S, 3));
            }
            function UQ(y10, S, N, X) {
              return y10 == null ? [] : (Wa(S) || (S = S == null ? [] : [S]), N = X ? D : N, Wa(N) || (N = N == null ? [] : [N]), qT(y10, S, N));
            }
            var HQ = ZT(function(y10, S, N) {
              y10[N ? 0 : 1].push(S);
            }, function() {
              return [[], []];
            });
            function qQ(y10, S, N) {
              var X = Wa(y10) ? B_ : hT, fe = arguments.length < 3;
              return X(y10, oa(S, 4), N, fe, Ld);
            }
            function YQ(y10, S, N) {
              var X = Wa(y10) ? lT : hT, fe = arguments.length < 3;
              return X(y10, oa(S, 4), N, fe, FT);
            }
            function KQ(y10, S) {
              var N = Wa(y10) ? Pd : w2;
              return N(y10, uM(oa(S, 3)));
            }
            function ZQ(y10) {
              var S = Wa(y10) ? LT : g9;
              return S(y10);
            }
            function XQ(y10, S, N) {
              (N ? Pc(y10, S, N) : S === D) ? S = 1 : S = ri(S);
              var X = Wa(y10) ? rL : w9;
              return X(y10, S);
            }
            function JQ(y10) {
              var S = Wa(y10) ? nL : Te;
              return S(y10);
            }
            function QQ(y10) {
              if (y10 == null)
                return 0;
              if (of(y10))
                return cM(y10) ? P0(y10) : y10.length;
              var S = nc(y10);
              return S == $s || S == us ? y10.size : P2(y10).length;
            }
            function eee(y10, S, N) {
              var X = Wa(y10) ? l22 : nt;
              return N && Pc(y10, S, N) && (S = D), X(y10, oa(S, 3));
            }
            var tee = ti(function(y10, S) {
              if (y10 == null)
                return [];
              var N = S.length;
              return N > 1 && Pc(y10, S[0], S[1]) ? S = [] : N > 2 && Pc(S[0], S[1], S[2]) && (S = [S[0]]), qT(y10, zu(S, 1), []);
            }), oM = DI || function() {
              return ju.Date.now();
            };
            function ree(y10, S) {
              if (typeof S != "function")
                throw new Qc(Z);
              return y10 = ri(y10), function() {
                if (--y10 < 1)
                  return S.apply(this, arguments);
              };
            }
            function j9(y10, S, N) {
              return S = N ? D : S, S = y10 && S == null ? y10.length : S, og(y10, ar, D, D, D, D, S);
            }
            function B9(y10, S) {
              var N;
              if (typeof S != "function")
                throw new Qc(Z);
              return y10 = ri(y10), function() {
                return --y10 > 0 && (N = S.apply(this, arguments)), y10 <= 1 && (S = D), N;
              };
            }
            var RL = ti(function(y10, S, N) {
              var X = gt;
              if (N.length) {
                var fe = Tv(N, ux(RL));
                X |= vt;
              }
              return og(y10, X, S, N, fe);
            }), z92 = ti(function(y10, S, N) {
              var X = gt | lr;
              if (N.length) {
                var fe = Tv(N, ux(z92));
                X |= vt;
              }
              return og(S, X, y10, N, fe);
            });
            function $9(y10, S, N) {
              S = N ? D : S;
              var X = og(y10, Gr, D, D, D, D, D, S);
              return X.placeholder = $9.placeholder, X;
            }
            function G9(y10, S, N) {
              S = N ? D : S;
              var X = og(y10, se, D, D, D, D, D, S);
              return X.placeholder = G9.placeholder, X;
            }
            function W9(y10, S, N) {
              var X, fe, Me, Ke, at, Et, Pr = 0, Dr = false, Ur = false, pn = true;
              if (typeof y10 != "function")
                throw new Qc(Z);
              S = Eh(S) || 0, Ls(N) && (Dr = !!N.leading, Ur = "maxWait" in N, Me = Ur ? to(Eh(N.maxWait) || 0, S) : Me, pn = "trailing" in N ? !!N.trailing : pn);
              function jn(ou) {
                var Lv = X, fg = fe;
                return X = fe = D, Pr = ou, Ke = y10.apply(fg, Lv), Ke;
              }
              function ca(ou) {
                return Pr = ou, at = N2(Pi, S), Dr ? jn(ou) : Ke;
              }
              function ui(ou) {
                var Lv = ou - Et, fg = ou - Pr, l8 = S - Lv;
                return Ur ? Bu(l8, Me - fg) : l8;
              }
              function fa(ou) {
                var Lv = ou - Et, fg = ou - Pr;
                return Et === D || Lv >= S || Lv < 0 || Ur && fg >= Me;
              }
              function Pi() {
                var ou = oM();
                if (fa(ou))
                  return Ni(ou);
                at = N2(Pi, ui(ou));
              }
              function Ni(ou) {
                return at = D, pn && X ? jn(ou) : (X = fe = D, Ke);
              }
              function zf() {
                at !== D && k22(at), Pr = 0, X = Et = fe = at = D;
              }
              function Dc() {
                return at === D ? Ke : Ni(oM());
              }
              function $f() {
                var ou = oM(), Lv = fa(ou);
                if (X = arguments, fe = this, Et = ou, Lv) {
                  if (at === D)
                    return ca(Et);
                  if (Ur)
                    return k22(at), at = N2(Pi, S), jn(Et);
                }
                return at === D && (at = N2(Pi, S)), Ke;
              }
              return $f.cancel = zf, $f.flush = Dc, $f;
            }
            var nee = ti(function(y10, S) {
              return RT(y10, 1, S);
            }), aee = ti(function(y10, S, N) {
              return RT(y10, Eh(S) || 0, N);
            });
            function iee(y10) {
              return og(y10, Ct);
            }
            function sM(y10, S) {
              if (typeof y10 != "function" || S != null && typeof S != "function")
                throw new Qc(Z);
              var N = function() {
                var X = arguments, fe = S ? S.apply(this, X) : X[0], Me = N.cache;
                if (Me.has(fe))
                  return Me.get(fe);
                var Ke = y10.apply(this, X);
                return N.cache = Me.set(fe, Ke) || Me, Ke;
              };
              return N.cache = new (sM.Cache || Pv)(), N;
            }
            sM.Cache = Pv;
            function uM(y10) {
              if (typeof y10 != "function")
                throw new Qc(Z);
              return function() {
                var S = arguments;
                switch (S.length) {
                  case 0:
                    return !y10.call(this);
                  case 1:
                    return !y10.call(this, S[0]);
                  case 2:
                    return !y10.call(this, S[0], S[1]);
                  case 3:
                    return !y10.call(this, S[0], S[1], S[2]);
                }
                return !y10.apply(this, S);
              };
            }
            function oee(y10) {
              return B9(2, y10);
            }
            var see = jf(function(y10, S) {
              S = S.length == 1 && Wa(S[0]) ? ts(S[0], ec(oa())) : ts(zu(S, 1), ec(oa()));
              var N = S.length;
              return ti(function(X) {
                for (var fe = -1, Me = Bu(X.length, N); ++fe < Me; )
                  X[fe] = S[fe].call(this, X[fe]);
                return Mc(y10, this, X);
              });
            }), FL = ti(function(y10, S) {
              var N = Tv(S, ux(FL));
              return og(y10, vt, D, S, N);
            }), U9 = ti(function(y10, S) {
              var N = Tv(S, ux(U9));
              return og(y10, Lt, D, S, N);
            }), uee = sg(function(y10, S) {
              return og(y10, rr, D, D, D, S);
            });
            function lee(y10, S) {
              if (typeof y10 != "function")
                throw new Qc(Z);
              return S = S === D ? S : ri(S), ti(y10, S);
            }
            function cee(y10, S) {
              if (typeof y10 != "function")
                throw new Qc(Z);
              return S = S == null ? 0 : to(ri(S), 0), ti(function(N) {
                var X = N[S], fe = pl(N, 0, S);
                return X && Dd(fe, X), Mc(y10, this, fe);
              });
            }
            function fee(y10, S, N) {
              var X = true, fe = true;
              if (typeof y10 != "function")
                throw new Qc(Z);
              return Ls(N) && (X = "leading" in N ? !!N.leading : X, fe = "trailing" in N ? !!N.trailing : fe), W9(y10, S, { leading: X, maxWait: S, trailing: fe });
            }
            function hee(y10) {
              return j9(y10, 1);
            }
            function vee(y10, S) {
              return FL(Rl(S), y10);
            }
            function dee() {
              if (!arguments.length)
                return [];
              var y10 = arguments[0];
              return Wa(y10) ? y10 : [y10];
            }
            function pee(y10) {
              return rf(y10, Qe);
            }
            function gee(y10, S) {
              return S = typeof S == "function" ? S : D, rf(y10, Qe, S);
            }
            function yee(y10) {
              return rf(y10, Pe | Qe);
            }
            function mee(y10, S) {
              return S = typeof S == "function" ? S : D, rf(y10, Pe | Qe, S);
            }
            function bee(y10, S) {
              return S == null || kT(y10, S, gl(S));
            }
            function Iv(y10, S) {
              return y10 === S || y10 !== y10 && S !== S;
            }
            var _ee = eM(E2), xee = eM(function(y10, S) {
              return y10 >= S;
            }), Qm = jT(function() {
              return arguments;
            }()) ? jT : function(y10) {
              return Ws(y10) && bi.call(y10, "callee") && !L0.call(y10, "callee");
            }, Wa = $t.isArray, wee = rT ? ec(rT) : hL;
            function of(y10) {
              return y10 != null && lM(y10.length) && !lg(y10);
            }
            function iu(y10) {
              return Ws(y10) && of(y10);
            }
            function See(y10) {
              return y10 === true || y10 === false || Ws(y10) && $u(y10) == Qa;
            }
            var $0 = xT || qL, Cee = nT ? ec(nT) : vL;
            function Eee(y10) {
              return Ws(y10) && y10.nodeType === 1 && !V2(y10);
            }
            function Aee(y10) {
              if (y10 == null)
                return true;
              if (of(y10) && (Wa(y10) || typeof y10 == "string" || typeof y10.splice == "function" || $0(y10) || lx(y10) || Qm(y10)))
                return !y10.length;
              var S = nc(y10);
              if (S == $s || S == us)
                return !y10.size;
              if (F2(y10))
                return !P2(y10).length;
              for (var N in y10)
                if (bi.call(y10, N))
                  return false;
              return true;
            }
            function Tee(y10, S) {
              return Zm(y10, S);
            }
            function Mee(y10, S, N) {
              N = typeof N == "function" ? N : D;
              var X = N ? N(y10, S) : D;
              return X === D ? Zm(y10, S, D, N) : !!X;
            }
            function NL(y10) {
              if (!Ws(y10))
                return false;
              var S = $u(y10);
              return S == vs || S == Jo || typeof y10.message == "string" && typeof y10.name == "string" && !V2(y10);
            }
            function Pee(y10) {
              return typeof y10 == "number" && Sh(y10);
            }
            function lg(y10) {
              if (!Ls(y10))
                return false;
              var S = $u(y10);
              return S == Xl || S == Yc || S == co || S == Kc;
            }
            function H9(y10) {
              return typeof y10 == "number" && y10 == ri(y10);
            }
            function lM(y10) {
              return typeof y10 == "number" && y10 > -1 && y10 % 1 == 0 && y10 <= fr;
            }
            function Ls(y10) {
              var S = typeof y10;
              return y10 != null && (S == "object" || S == "function");
            }
            function Ws(y10) {
              return y10 != null && typeof y10 == "object";
            }
            var q9 = aT ? ec(aT) : dL;
            function Dee(y10, S) {
              return y10 === S || A22(y10, S, TL(S));
            }
            function Iee(y10, S, N) {
              return N = typeof N == "function" ? N : D, A22(y10, S, TL(S), N);
            }
            function Lee(y10) {
              return Y9(y10) && y10 != +y10;
            }
            function Oee(y10) {
              if (gJ(y10))
                throw new Aa(B);
              return zT(y10);
            }
            function kee(y10) {
              return y10 === null;
            }
            function Ree(y10) {
              return y10 == null;
            }
            function Y9(y10) {
              return typeof y10 == "number" || Ws(y10) && $u(y10) == Dl;
            }
            function V2(y10) {
              if (!Ws(y10) || $u(y10) != cl)
                return false;
              var S = X_(y10);
              if (S === null)
                return true;
              var N = bi.call(S, "constructor") && S.constructor;
              return typeof N == "function" && N instanceof N && Y_.call(N) == ps;
            }
            var VL = iT ? ec(iT) : T2;
            function Fee(y10) {
              return H9(y10) && y10 >= -fr && y10 <= fr;
            }
            var K9 = oT ? ec(oT) : M2;
            function cM(y10) {
              return typeof y10 == "string" || !Wa(y10) && Ws(y10) && $u(y10) == Ps;
            }
            function Bf(y10) {
              return typeof y10 == "symbol" || Ws(y10) && $u(y10) == wo;
            }
            var lx = sT ? ec(sT) : pL;
            function Nee(y10) {
              return y10 === D;
            }
            function Vee(y10) {
              return Ws(y10) && nc(y10) == mr;
            }
            function jee(y10) {
              return Ws(y10) && $u(y10) == Vt;
            }
            var Bee = eM(D2), zee = eM(function(y10, S) {
              return y10 <= S;
            });
            function Z9(y10) {
              if (!y10)
                return [];
              if (of(y10))
                return cM(y10) ? Vf(y10) : af(y10);
              if (k0 && y10[k0])
                return mI(y10[k0]());
              var S = nc(y10), N = S == $s ? g2 : S == us ? H_ : cx;
              return N(y10);
            }
            function cg(y10) {
              if (!y10)
                return y10 === 0 ? y10 : 0;
              if (y10 = Eh(y10), y10 === Vn || y10 === -Vn) {
                var S = y10 < 0 ? -1 : 1;
                return S * Wt;
              }
              return y10 === y10 ? y10 : 0;
            }
            function ri(y10) {
              var S = cg(y10), N = S % 1;
              return S === S ? N ? S - N : S : 0;
            }
            function X9(y10) {
              return y10 ? ng(ri(y10), 0, Kr) : 0;
            }
            function Eh(y10) {
              if (typeof y10 == "number")
                return y10;
              if (Bf(y10))
                return Ut;
              if (Ls(y10)) {
                var S = typeof y10.valueOf == "function" ? y10.valueOf() : y10;
                y10 = Ls(S) ? S + "" : S;
              }
              if (typeof y10 != "string")
                return y10 === 0 ? y10 : +y10;
              y10 = vT(y10);
              var N = Dt.test(y10);
              return N || Ht.test(y10) ? oI(y10.slice(2), N ? 2 : 8) : Ne.test(y10) ? Ut : +y10;
            }
            function J9(y10) {
              return Od(y10, sf(y10));
            }
            function $ee(y10) {
              return y10 ? ng(ri(y10), -fr, fr) : y10 === 0 ? y10 : 0;
            }
            function vo(y10) {
              return y10 == null ? "" : Qr(y10);
            }
            var Gee = ox(function(y10, S) {
              if (F2(S) || of(S)) {
                Od(S, gl(S), y10);
                return;
              }
              for (var N in S)
                bi.call(S, N) && qm(y10, N, S[N]);
            }), Q9 = ox(function(y10, S) {
              Od(S, sf(S), y10);
            }), fM = ox(function(y10, S, N, X) {
              Od(S, sf(S), y10, X);
            }), Wee = ox(function(y10, S, N, X) {
              Od(S, gl(S), y10, X);
            }), Uee = sg(x22);
            function Hee(y10, S) {
              var N = j0(y10);
              return S == null ? N : OT(N, S);
            }
            var qee = ti(function(y10, S) {
              y10 = Eo(y10);
              var N = -1, X = S.length, fe = X > 2 ? S[2] : D;
              for (fe && Pc(S[0], S[1], fe) && (X = 1); ++N < X; )
                for (var Me = S[N], Ke = sf(Me), at = -1, Et = Ke.length; ++at < Et; ) {
                  var Pr = Ke[at], Dr = y10[Pr];
                  (Dr === D || Iv(Dr, D0[Pr]) && !bi.call(y10, Pr)) && (y10[Pr] = Me[Pr]);
                }
              return y10;
            }), Yee = ti(function(y10) {
              return y10.push(D, g92), Mc(e8, D, y10);
            });
            function Kee(y10, S) {
              return $m(y10, oa(S, 3), nf);
            }
            function Zee(y10, S) {
              return $m(y10, oa(S, 3), C2);
            }
            function Xee(y10, S) {
              return y10 == null ? y10 : S2(y10, oa(S, 3), sf);
            }
            function Jee(y10, S) {
              return y10 == null ? y10 : VT(y10, oa(S, 3), sf);
            }
            function Qee(y10, S) {
              return y10 && nf(y10, oa(S, 3));
            }
            function ete(y10, S) {
              return y10 && C2(y10, oa(S, 3));
            }
            function tte(y10) {
              return y10 == null ? [] : ax(y10, gl(y10));
            }
            function rte(y10) {
              return y10 == null ? [] : ax(y10, sf(y10));
            }
            function jL(y10, S, N) {
              var X = y10 == null ? D : ag(y10, S);
              return X === D ? N : X;
            }
            function nte(y10, S) {
              return y10 != null && b9(y10, S, uL);
            }
            function BL(y10, S) {
              return y10 != null && b9(y10, S, lL);
            }
            var ate = f9(function(y10, S, N) {
              S != null && typeof S.toString != "function" && (S = Vo.call(S)), y10[S] = N;
            }, $L(uf)), ite = f9(function(y10, S, N) {
              S != null && typeof S.toString != "function" && (S = Vo.call(S)), bi.call(y10, S) ? y10[S].push(N) : y10[S] = [N];
            }, oa), ote = ti(ig);
            function gl(y10) {
              return of(y10) ? IT(y10) : P2(y10);
            }
            function sf(y10) {
              return of(y10) ? IT(y10, true) : gL(y10);
            }
            function ste(y10, S) {
              var N = {};
              return S = oa(S, 3), nf(y10, function(X, fe, Me) {
                Dv(N, S(X, fe, Me), X);
              }), N;
            }
            function ute(y10, S) {
              var N = {};
              return S = oa(S, 3), nf(y10, function(X, fe, Me) {
                Dv(N, fe, S(X, fe, Me));
              }), N;
            }
            var lte = ox(function(y10, S, N) {
              ix(y10, S, N);
            }), e8 = ox(function(y10, S, N, X) {
              ix(y10, S, N, X);
            }), cte = sg(function(y10, S) {
              var N = {};
              if (y10 == null)
                return N;
              var X = false;
              S = ts(S, function(Me) {
                return Me = ho(Me, y10), X || (X = Me.length > 1), Me;
              }), Od(y10, EL(y10), N), X && (N = rf(N, Pe | He | Qe, aJ));
              for (var fe = S.length; fe--; )
                Xn(N, S[fe]);
              return N;
            });
            function fte(y10, S) {
              return t8(y10, uM(oa(S)));
            }
            var hte = sg(function(y10, S) {
              return y10 == null ? {} : mL(y10, S);
            });
            function t8(y10, S) {
              if (y10 == null)
                return {};
              var N = ts(EL(y10), function(X) {
                return [X];
              });
              return S = oa(S), YT(y10, N, function(X, fe) {
                return S(X, fe[0]);
              });
            }
            function vte(y10, S, N) {
              S = ho(S, y10);
              var X = -1, fe = S.length;
              for (fe || (fe = 1, y10 = D); ++X < fe; ) {
                var Me = y10 == null ? D : y10[kd(S[X])];
                Me === D && (X = fe, Me = N), y10 = lg(Me) ? Me.call(y10) : Me;
              }
              return y10;
            }
            function dte(y10, S, N) {
              return y10 == null ? y10 : R(y10, S, N);
            }
            function pte(y10, S, N, X) {
              return X = typeof X == "function" ? X : D, y10 == null ? y10 : R(y10, S, N, X);
            }
            var r8 = d9(gl), n8 = d9(sf);
            function gte(y10, S, N) {
              var X = Wa(y10), fe = X || $0(y10) || lx(y10);
              if (S = oa(S, 4), N == null) {
                var Me = y10 && y10.constructor;
                fe ? N = X ? new Me() : [] : Ls(y10) ? N = lg(Me) ? j0(X_(y10)) : {} : N = {};
              }
              return (fe ? Jc : nf)(y10, function(Ke, at, Et) {
                return S(N, Ke, at, Et);
              }), N;
            }
            function yte(y10, S) {
              return y10 == null ? true : Xn(y10, S);
            }
            function mte(y10, S, N) {
              return y10 == null ? y10 : Ga(y10, S, Rl(N));
            }
            function bte(y10, S, N, X) {
              return X = typeof X == "function" ? X : D, y10 == null ? y10 : Ga(y10, S, Rl(N), X);
            }
            function cx(y10) {
              return y10 == null ? [] : G_(y10, gl(y10));
            }
            function _te(y10) {
              return y10 == null ? [] : G_(y10, sf(y10));
            }
            function xte(y10, S, N) {
              return N === D && (N = S, S = D), N !== D && (N = Eh(N), N = N === N ? N : 0), S !== D && (S = Eh(S), S = S === S ? S : 0), ng(Eh(y10), S, N);
            }
            function wte(y10, S, N) {
              return S = cg(S), N === D ? (N = S, S = 0) : N = cg(N), y10 = Eh(y10), cL(y10, S, N);
            }
            function Ste(y10, S, N) {
              if (N && typeof N != "boolean" && Pc(y10, S, N) && (S = N = D), N === D && (typeof S == "boolean" ? (N = S, S = D) : typeof y10 == "boolean" && (N = y10, y10 = D)), y10 === D && S === D ? (y10 = 0, S = 1) : (y10 = cg(y10), S === D ? (S = y10, y10 = 0) : S = cg(S)), y10 > S) {
                var X = y10;
                y10 = S, S = X;
              }
              if (N || y10 % 1 || S % 1) {
                var fe = ST();
                return Bu(y10 + fe * (S - y10 + iI("1e-" + ((fe + "").length - 1))), S);
              }
              return L2(y10, S);
            }
            var Cte = sx(function(y10, S, N) {
              return S = S.toLowerCase(), y10 + (N ? a8(S) : S);
            });
            function a8(y10) {
              return zL(vo(y10).toLowerCase());
            }
            function i8(y10) {
              return y10 = vo(y10), y10 && y10.replace(jr, pT).replace(XD, "");
            }
            function Ete(y10, S, N) {
              y10 = vo(y10), S = Qr(S);
              var X = y10.length;
              N = N === D ? X : ng(ri(N), 0, X);
              var fe = N;
              return N -= S.length, N >= 0 && y10.slice(N, fe) == S;
            }
            function Ate(y10) {
              return y10 = vo(y10), y10 && Ds.test(y10) ? y10.replace(Qo, pI) : y10;
            }
            function Tte(y10) {
              return y10 = vo(y10), y10 && e22.test(y10) ? y10.replace(Sv, "\\$&") : y10;
            }
            var Mte = sx(function(y10, S, N) {
              return y10 + (N ? "-" : "") + S.toLowerCase();
            }), Pte = sx(function(y10, S, N) {
              return y10 + (N ? " " : "") + S.toLowerCase();
            }), Dte = u9("toLowerCase");
            function Ite(y10, S, N) {
              y10 = vo(y10), S = ri(S);
              var X = S ? P0(y10) : 0;
              if (!S || X >= S)
                return y10;
              var fe = (S - X) / 2;
              return QT(Q_(fe), N) + y10 + QT(J_(fe), N);
            }
            function Lte(y10, S, N) {
              y10 = vo(y10), S = ri(S);
              var X = S ? P0(y10) : 0;
              return S && X < S ? y10 + QT(S - X, N) : y10;
            }
            function Ote(y10, S, N) {
              y10 = vo(y10), S = ri(S);
              var X = S ? P0(y10) : 0;
              return S && X < S ? QT(S - X, N) + y10 : y10;
            }
            function kte(y10, S, N) {
              return N || S == null ? S = 0 : S && (S = +S), ro(vo(y10).replace(Ed, ""), S || 0);
            }
            function Rte(y10, S, N) {
              return (N ? Pc(y10, S, N) : S === D) ? S = 1 : S = ri(S), O2(vo(y10), S);
            }
            function Fte() {
              var y10 = arguments, S = vo(y10[0]);
              return y10.length < 3 ? S : S.replace(y10[1], y10[2]);
            }
            var Nte = sx(function(y10, S, N) {
              return y10 + (N ? "_" : "") + S.toLowerCase();
            });
            function Vte(y10, S, N) {
              return N && typeof N != "number" && Pc(y10, S, N) && (S = N = D), N = N === D ? Kr : N >>> 0, N ? (y10 = vo(y10), y10 && (typeof S == "string" || S != null && !VL(S)) && (S = Qr(S), !S && Av(y10)) ? pl(Vf(y10), 0, N) : y10.split(S, N)) : [];
            }
            var jte = sx(function(y10, S, N) {
              return y10 + (N ? " " : "") + zL(S);
            });
            function Bte(y10, S, N) {
              return y10 = vo(y10), N = N == null ? 0 : ng(ri(N), 0, y10.length), S = Qr(S), y10.slice(N, N + S.length) == S;
            }
            function zte(y10, S, N) {
              var X = we.templateSettings;
              N && Pc(y10, S, N) && (S = D), y10 = vo(y10), S = fM({}, S, X, p9);
              var fe = fM({}, S.imports, X.imports, p9), Me = gl(fe), Ke = G_(fe, Me), at, Et, Pr = 0, Dr = S.interpolate || Pn, Ur = "__p += '", pn = xh((S.escape || Pn).source + "|" + Dr.source + "|" + (Dr === _u ? Ce : Pn).source + "|" + (S.evaluate || Pn).source + "|$", "g"), jn = "//# sourceURL=" + (bi.call(S, "sourceURL") ? (S.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++rI + "]") + `
`;
              y10.replace(pn, function(fa, Pi, Ni, zf, Dc, $f) {
                return Ni || (Ni = zf), Ur += y10.slice(Pr, $f).replace(Ka, gI), Pi && (at = true, Ur += `' +
__e(` + Pi + `) +
'`), Dc && (Et = true, Ur += `';
` + Dc + `;
__p += '`), Ni && (Ur += `' +
((__t = (` + Ni + `)) == null ? '' : __t) +
'`), Pr = $f + fa.length, fa;
              }), Ur += `';
`;
              var ca = bi.call(S, "variable") && S.variable;
              if (!ca)
                Ur = `with (obj) {
` + Ur + `
}
`;
              else if (je.test(ca))
                throw new Aa(re);
              Ur = (Et ? Ur.replace(fl, "") : Ur).replace(Il, "$1").replace(Gs, "$1;"), Ur = "function(" + (ca || "obj") + `) {
` + (ca ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (at ? ", __e = _.escape" : "") + (Et ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Ur + `return __p
}`;
              var ui = s8(function() {
                return Ta(Me, jn + "return " + Ur).apply(D, Ke);
              });
              if (ui.source = Ur, NL(ui))
                throw ui;
              return ui;
            }
            function $te(y10) {
              return vo(y10).toLowerCase();
            }
            function Gte(y10) {
              return vo(y10).toUpperCase();
            }
            function Wte(y10, S, N) {
              if (y10 = vo(y10), y10 && (N || S === D))
                return vT(y10);
              if (!y10 || !(S = Qr(S)))
                return y10;
              var X = Vf(y10), fe = Vf(S), Me = d22(X, fe), Ke = p22(X, fe) + 1;
              return pl(X, Me, Ke).join("");
            }
            function Ute(y10, S, N) {
              if (y10 = vo(y10), y10 && (N || S === D))
                return y10.slice(0, gT(y10) + 1);
              if (!y10 || !(S = Qr(S)))
                return y10;
              var X = Vf(y10), fe = p22(X, Vf(S)) + 1;
              return pl(X, 0, fe).join("");
            }
            function Hte(y10, S, N) {
              if (y10 = vo(y10), y10 && (N || S === D))
                return y10.replace(Ed, "");
              if (!y10 || !(S = Qr(S)))
                return y10;
              var X = Vf(y10), fe = d22(X, Vf(S));
              return pl(X, fe).join("");
            }
            function qte(y10, S) {
              var N = Ft, X = gr;
              if (Ls(S)) {
                var fe = "separator" in S ? S.separator : fe;
                N = "length" in S ? ri(S.length) : N, X = "omission" in S ? Qr(S.omission) : X;
              }
              y10 = vo(y10);
              var Me = y10.length;
              if (Av(y10)) {
                var Ke = Vf(y10);
                Me = Ke.length;
              }
              if (N >= Me)
                return y10;
              var at = N - P0(X);
              if (at < 1)
                return X;
              var Et = Ke ? pl(Ke, 0, at).join("") : y10.slice(0, at);
              if (fe === D)
                return Et + X;
              if (Ke && (at += Et.length - at), VL(fe)) {
                if (y10.slice(at).search(fe)) {
                  var Pr, Dr = Et;
                  for (fe.global || (fe = xh(fe.source, vo(Re.exec(fe)) + "g")), fe.lastIndex = 0; Pr = fe.exec(Dr); )
                    var Ur = Pr.index;
                  Et = Et.slice(0, Ur === D ? at : Ur);
                }
              } else if (y10.indexOf(Qr(fe), at) != at) {
                var pn = Et.lastIndexOf(fe);
                pn > -1 && (Et = Et.slice(0, pn));
              }
              return Et + X;
            }
            function Yte(y10) {
              return y10 = vo(y10), y10 && yi.test(y10) ? y10.replace(fo, wI) : y10;
            }
            var Kte = sx(function(y10, S, N) {
              return y10 + (N ? " " : "") + S.toUpperCase();
            }), zL = u9("toUpperCase");
            function o8(y10, S, N) {
              return y10 = vo(y10), S = N ? D : S, S === D ? W_(y10) ? EI(y10) : hI(y10) : y10.match(S) || [];
            }
            var s8 = ti(function(y10, S) {
              try {
                return Mc(y10, D, S);
              } catch (N) {
                return NL(N) ? N : new Aa(N);
              }
            }), Zte = sg(function(y10, S) {
              return Jc(S, function(N) {
                N = kd(N), Dv(y10, N, RL(y10[N], y10));
              }), y10;
            });
            function Xte(y10) {
              var S = y10 == null ? 0 : y10.length, N = oa();
              return y10 = S ? ts(y10, function(X) {
                if (typeof X[1] != "function")
                  throw new Qc(Z);
                return [N(X[0]), X[1]];
              }) : [], ti(function(X) {
                for (var fe = -1; ++fe < S; ) {
                  var Me = y10[fe];
                  if (Mc(Me[0], this, X))
                    return Mc(Me[1], this, X);
                }
              });
            }
            function Jte(y10) {
              return oL(rf(y10, Pe));
            }
            function $L(y10) {
              return function() {
                return y10;
              };
            }
            function Qte(y10, S) {
              return y10 == null || y10 !== y10 ? S : y10;
            }
            var ere = c9(), tre = c9(true);
            function uf(y10) {
              return y10;
            }
            function GL(y10) {
              return $T(typeof y10 == "function" ? y10 : rf(y10, Pe));
            }
            function rre(y10) {
              return WT(rf(y10, Pe));
            }
            function nre(y10, S) {
              return UT(y10, rf(S, Pe));
            }
            var are = ti(function(y10, S) {
              return function(N) {
                return ig(N, y10, S);
              };
            }), ire = ti(function(y10, S) {
              return function(N) {
                return ig(y10, N, S);
              };
            });
            function WL(y10, S, N) {
              var X = gl(S), fe = ax(S, X);
              N == null && !(Ls(S) && (fe.length || !X.length)) && (N = S, S = y10, y10 = this, fe = ax(S, gl(S)));
              var Me = !(Ls(N) && "chain" in N) || !!N.chain, Ke = lg(y10);
              return Jc(fe, function(at) {
                var Et = S[at];
                y10[at] = Et, Ke && (y10.prototype[at] = function() {
                  var Pr = this.__chain__;
                  if (Me || Pr) {
                    var Dr = y10(this.__wrapped__), Ur = Dr.__actions__ = af(this.__actions__);
                    return Ur.push({ func: Et, args: arguments, thisArg: y10 }), Dr.__chain__ = Pr, Dr;
                  }
                  return Et.apply(y10, Dd([this.value()], arguments));
                });
              }), y10;
            }
            function ore() {
              return ju._ === this && (ju._ = mT), this;
            }
            function UL() {
            }
            function sre(y10) {
              return y10 = ri(y10), ti(function(S) {
                return HT(S, y10);
              });
            }
            var ure = wL(ts), lre = wL(uT), cre = wL(l22);
            function u8(y10) {
              return PL(y10) ? c22(kd(y10)) : bL(y10);
            }
            function fre(y10) {
              return function(S) {
                return y10 == null ? D : ag(y10, S);
              };
            }
            var hre = h9(), vre = h9(true);
            function HL() {
              return [];
            }
            function qL() {
              return false;
            }
            function dre() {
              return {};
            }
            function pre() {
              return "";
            }
            function gre() {
              return true;
            }
            function yre(y10, S) {
              if (y10 = ri(y10), y10 < 1 || y10 > fr)
                return [];
              var N = Kr, X = Bu(y10, Kr);
              S = oa(S), y10 -= Kr;
              for (var fe = v22(X, S); ++N < y10; )
                S(N);
              return fe;
            }
            function mre(y10) {
              return Wa(y10) ? ts(y10, kd) : Bf(y10) ? [y10] : af(M9(vo(y10)));
            }
            function bre(y10) {
              var S = ++yT;
              return vo(y10) + S;
            }
            var _re = JT(function(y10, S) {
              return y10 + S;
            }, 0), xre = SL("ceil"), wre = JT(function(y10, S) {
              return y10 / S;
            }, 1), Sre = SL("floor");
            function Cre(y10) {
              return y10 && y10.length ? z0(y10, uf, E2) : D;
            }
            function Ere(y10, S) {
              return y10 && y10.length ? z0(y10, oa(S, 2), E2) : D;
            }
            function Are(y10) {
              return fT(y10, uf);
            }
            function Tre(y10, S) {
              return fT(y10, oa(S, 2));
            }
            function Mre(y10) {
              return y10 && y10.length ? z0(y10, uf, D2) : D;
            }
            function Pre(y10, S) {
              return y10 && y10.length ? z0(y10, oa(S, 2), D2) : D;
            }
            var Dre = JT(function(y10, S) {
              return y10 * S;
            }, 1), Ire = SL("round"), Lre = JT(function(y10, S) {
              return y10 - S;
            }, 0);
            function Ore(y10) {
              return y10 && y10.length ? h2(y10, uf) : 0;
            }
            function kre(y10, S) {
              return y10 && y10.length ? h2(y10, oa(S, 2)) : 0;
            }
            return we.after = ree, we.ary = j9, we.assign = Gee, we.assignIn = Q9, we.assignInWith = fM, we.assignWith = Wee, we.at = Uee, we.before = B9, we.bind = RL, we.bindAll = Zte, we.bindKey = z92, we.castArray = dee, we.chain = F9, we.chunk = SJ, we.compact = CJ, we.concat = EJ, we.cond = Xte, we.conforms = Jte, we.constant = $L, we.countBy = OQ, we.create = Hee, we.curry = $9, we.curryRight = G9, we.debounce = W9, we.defaults = qee, we.defaultsDeep = Yee, we.defer = nee, we.delay = aee, we.difference = AJ, we.differenceBy = TJ, we.differenceWith = MJ, we.drop = PJ, we.dropRight = DJ, we.dropRightWhile = IJ, we.dropWhile = LJ, we.fill = OJ, we.filter = RQ, we.flatMap = VQ, we.flatMapDeep = jQ, we.flatMapDepth = BQ, we.flatten = L9, we.flattenDeep = kJ, we.flattenDepth = RJ, we.flip = iee, we.flow = ere, we.flowRight = tre, we.fromPairs = FJ, we.functions = tte, we.functionsIn = rte, we.groupBy = zQ, we.initial = VJ, we.intersection = jJ, we.intersectionBy = BJ, we.intersectionWith = zJ, we.invert = ate, we.invertBy = ite, we.invokeMap = GQ, we.iteratee = GL, we.keyBy = WQ, we.keys = gl, we.keysIn = sf, we.map = iM, we.mapKeys = ste, we.mapValues = ute, we.matches = rre, we.matchesProperty = nre, we.memoize = sM, we.merge = lte, we.mergeWith = e8, we.method = are, we.methodOf = ire, we.mixin = WL, we.negate = uM, we.nthArg = sre, we.omit = cte, we.omitBy = fte, we.once = oee, we.orderBy = UQ, we.over = ure, we.overArgs = see, we.overEvery = lre, we.overSome = cre, we.partial = FL, we.partialRight = U9, we.partition = HQ, we.pick = hte, we.pickBy = t8, we.property = u8, we.propertyOf = fre, we.pull = UJ, we.pullAll = k9, we.pullAllBy = HJ, we.pullAllWith = qJ, we.pullAt = YJ, we.range = hre, we.rangeRight = vre, we.rearg = uee, we.reject = KQ, we.remove = KJ, we.rest = lee, we.reverse = OL, we.sampleSize = XQ, we.set = dte, we.setWith = pte, we.shuffle = JQ, we.slice = ZJ, we.sortBy = tee, we.sortedUniq = nQ, we.sortedUniqBy = aQ, we.split = Vte, we.spread = cee, we.tail = iQ, we.take = oQ, we.takeRight = sQ, we.takeRightWhile = uQ, we.takeWhile = lQ, we.tap = CQ, we.throttle = fee, we.thru = aM, we.toArray = Z9, we.toPairs = r8, we.toPairsIn = n8, we.toPath = mre, we.toPlainObject = J9, we.transform = gte, we.unary = hee, we.union = cQ, we.unionBy = fQ, we.unionWith = hQ, we.uniq = vQ, we.uniqBy = dQ, we.uniqWith = pQ, we.unset = yte, we.unzip = kL, we.unzipWith = R9, we.update = mte, we.updateWith = bte, we.values = cx, we.valuesIn = _te, we.without = gQ, we.words = o8, we.wrap = vee, we.xor = yQ, we.xorBy = mQ, we.xorWith = bQ, we.zip = _Q, we.zipObject = xQ, we.zipObjectDeep = wQ, we.zipWith = SQ, we.entries = r8, we.entriesIn = n8, we.extend = Q9, we.extendWith = fM, WL(we, we), we.add = _re, we.attempt = s8, we.camelCase = Cte, we.capitalize = a8, we.ceil = xre, we.clamp = xte, we.clone = pee, we.cloneDeep = yee, we.cloneDeepWith = mee, we.cloneWith = gee, we.conformsTo = bee, we.deburr = i8, we.defaultTo = Qte, we.divide = wre, we.endsWith = Ete, we.eq = Iv, we.escape = Ate, we.escapeRegExp = Tte, we.every = kQ, we.find = FQ, we.findIndex = D9, we.findKey = Kee, we.findLast = NQ, we.findLastIndex = I9, we.findLastKey = Zee, we.floor = Sre, we.forEach = N9, we.forEachRight = V9, we.forIn = Xee, we.forInRight = Jee, we.forOwn = Qee, we.forOwnRight = ete, we.get = jL, we.gt = _ee, we.gte = xee, we.has = nte, we.hasIn = BL, we.head = O9, we.identity = uf, we.includes = $Q, we.indexOf = NJ, we.inRange = wte, we.invoke = ote, we.isArguments = Qm, we.isArray = Wa, we.isArrayBuffer = wee, we.isArrayLike = of, we.isArrayLikeObject = iu, we.isBoolean = See, we.isBuffer = $0, we.isDate = Cee, we.isElement = Eee, we.isEmpty = Aee, we.isEqual = Tee, we.isEqualWith = Mee, we.isError = NL, we.isFinite = Pee, we.isFunction = lg, we.isInteger = H9, we.isLength = lM, we.isMap = q9, we.isMatch = Dee, we.isMatchWith = Iee, we.isNaN = Lee, we.isNative = Oee, we.isNil = Ree, we.isNull = kee, we.isNumber = Y9, we.isObject = Ls, we.isObjectLike = Ws, we.isPlainObject = V2, we.isRegExp = VL, we.isSafeInteger = Fee, we.isSet = K9, we.isString = cM, we.isSymbol = Bf, we.isTypedArray = lx, we.isUndefined = Nee, we.isWeakMap = Vee, we.isWeakSet = jee, we.join = $J, we.kebabCase = Mte, we.last = Ch, we.lastIndexOf = GJ, we.lowerCase = Pte, we.lowerFirst = Dte, we.lt = Bee, we.lte = zee, we.max = Cre, we.maxBy = Ere, we.mean = Are, we.meanBy = Tre, we.min = Mre, we.minBy = Pre, we.stubArray = HL, we.stubFalse = qL, we.stubObject = dre, we.stubString = pre, we.stubTrue = gre, we.multiply = Dre, we.nth = WJ, we.noConflict = ore, we.noop = UL, we.now = oM, we.pad = Ite, we.padEnd = Lte, we.padStart = Ote, we.parseInt = kte, we.random = Ste, we.reduce = qQ, we.reduceRight = YQ, we.repeat = Rte, we.replace = Fte, we.result = vte, we.round = Ire, we.runInContext = yt, we.sample = ZQ, we.size = QQ, we.snakeCase = Nte, we.some = eee, we.sortedIndex = XJ, we.sortedIndexBy = JJ, we.sortedIndexOf = QJ, we.sortedLastIndex = eQ, we.sortedLastIndexBy = tQ, we.sortedLastIndexOf = rQ, we.startCase = jte, we.startsWith = Bte, we.subtract = Lre, we.sum = Ore, we.sumBy = kre, we.template = zte, we.times = yre, we.toFinite = cg, we.toInteger = ri, we.toLength = X9, we.toLower = $te, we.toNumber = Eh, we.toSafeInteger = $ee, we.toString = vo, we.toUpper = Gte, we.trim = Wte, we.trimEnd = Ute, we.trimStart = Hte, we.truncate = qte, we.unescape = Yte, we.uniqueId = bre, we.upperCase = Kte, we.upperFirst = zL, we.each = N9, we.eachRight = V9, we.first = O9, WL(we, function() {
              var y10 = {};
              return nf(we, function(S, N) {
                bi.call(we.prototype, N) || (y10[N] = S);
              }), y10;
            }(), { chain: false }), we.VERSION = O, Jc(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(y10) {
              we[y10].placeholder = we;
            }), Jc(["drop", "take"], function(y10, S) {
              Hn.prototype[y10] = function(N) {
                N = N === D ? 1 : to(ri(N), 0);
                var X = this.__filtered__ && !S ? new Hn(this) : this.clone();
                return X.__filtered__ ? X.__takeCount__ = Bu(N, X.__takeCount__) : X.__views__.push({ size: Bu(N, Kr), type: y10 + (X.__dir__ < 0 ? "Right" : "") }), X;
              }, Hn.prototype[y10 + "Right"] = function(N) {
                return this.reverse()[y10](N).reverse();
              };
            }), Jc(["filter", "map", "takeWhile"], function(y10, S) {
              var N = S + 1, X = N == dn || N == ir;
              Hn.prototype[y10] = function(fe) {
                var Me = this.clone();
                return Me.__iteratees__.push({ iteratee: oa(fe, 3), type: N }), Me.__filtered__ = Me.__filtered__ || X, Me;
              };
            }), Jc(["head", "last"], function(y10, S) {
              var N = "take" + (S ? "Right" : "");
              Hn.prototype[y10] = function() {
                return this[N](1).value()[0];
              };
            }), Jc(["initial", "tail"], function(y10, S) {
              var N = "drop" + (S ? "" : "Right");
              Hn.prototype[y10] = function() {
                return this.__filtered__ ? new Hn(this) : this[N](1);
              };
            }), Hn.prototype.compact = function() {
              return this.filter(uf);
            }, Hn.prototype.find = function(y10) {
              return this.filter(y10).head();
            }, Hn.prototype.findLast = function(y10) {
              return this.reverse().find(y10);
            }, Hn.prototype.invokeMap = ti(function(y10, S) {
              return typeof y10 == "function" ? new Hn(this) : this.map(function(N) {
                return ig(N, y10, S);
              });
            }), Hn.prototype.reject = function(y10) {
              return this.filter(uM(oa(y10)));
            }, Hn.prototype.slice = function(y10, S) {
              y10 = ri(y10);
              var N = this;
              return N.__filtered__ && (y10 > 0 || S < 0) ? new Hn(N) : (y10 < 0 ? N = N.takeRight(-y10) : y10 && (N = N.drop(y10)), S !== D && (S = ri(S), N = S < 0 ? N.dropRight(-S) : N.take(S - y10)), N);
            }, Hn.prototype.takeRightWhile = function(y10) {
              return this.reverse().takeWhile(y10).reverse();
            }, Hn.prototype.toArray = function() {
              return this.take(Kr);
            }, nf(Hn.prototype, function(y10, S) {
              var N = /^(?:filter|find|map|reject)|While$/.test(S), X = /^(?:head|last)$/.test(S), fe = we[X ? "take" + (S == "last" ? "Right" : "") : S], Me = X || /^find/.test(S);
              !fe || (we.prototype[S] = function() {
                var Ke = this.__wrapped__, at = X ? [1] : arguments, Et = Ke instanceof Hn, Pr = at[0], Dr = Et || Wa(Ke), Ur = function(Pi) {
                  var Ni = fe.apply(we, Dd([Pi], at));
                  return X && pn ? Ni[0] : Ni;
                };
                Dr && N && typeof Pr == "function" && Pr.length != 1 && (Et = Dr = false);
                var pn = this.__chain__, jn = !!this.__actions__.length, ca = Me && !pn, ui = Et && !jn;
                if (!Me && Dr) {
                  Ke = ui ? Ke : new Hn(this);
                  var fa = y10.apply(Ke, at);
                  return fa.__actions__.push({ func: aM, args: [Ur], thisArg: D }), new ef(fa, pn);
                }
                return ca && ui ? y10.apply(this, at) : (fa = this.thru(Ur), ca ? X ? fa.value()[0] : fa.value() : fa);
              });
            }), Jc(["pop", "push", "shift", "sort", "splice", "unshift"], function(y10) {
              var S = q_[y10], N = /^(?:push|sort|unshift)$/.test(y10) ? "tap" : "thru", X = /^(?:pop|shift)$/.test(y10);
              we.prototype[y10] = function() {
                var fe = arguments;
                if (X && !this.__chain__) {
                  var Me = this.value();
                  return S.apply(Wa(Me) ? Me : [], fe);
                }
                return this[N](function(Ke) {
                  return S.apply(Wa(Ke) ? Ke : [], fe);
                });
              };
            }), nf(Hn.prototype, function(y10, S) {
              var N = we[S];
              if (N) {
                var X = N.name + "";
                bi.call(V0, X) || (V0[X] = []), V0[X].push({ name: S, func: N });
              }
            }), V0[XT(D, lr).name] = [{ name: "wrapper", func: D }], Hn.prototype.clone = tc, Hn.prototype.reverse = VI, Hn.prototype.value = jI, we.prototype.at = EQ, we.prototype.chain = AQ, we.prototype.commit = TQ, we.prototype.next = MQ, we.prototype.plant = DQ, we.prototype.reverse = IQ, we.prototype.toJSON = we.prototype.valueOf = we.prototype.value = LQ, we.prototype.first = we.prototype.head, k0 && (we.prototype[k0] = PQ), we;
          }, vl = AI();
          Jp ? ((Jp.exports = vl)._ = vl, i2._ = vl) : ju._ = vl;
        }).call(Ae);
      })(Xe, Xe.exports);
      class Ze {
        constructor() {
          I(this, "subscriptions", /* @__PURE__ */ new Map()), I(this, "useSubscription", (W, D) => {
            const O = L.useRef();
            L.useEffect(() => {
              O.current = D;
              function F(B) {
                O.current && O.current(B);
              }
              return this.subscriptions.set(W, F), () => {
                this.subscriptions.delete(W);
              };
            }, []);
          }), I(this, "emit", (W, ...D) => {
            if (typeof W == "string" || typeof W == "number") {
              const O = this.subscriptions.get(W);
              O == null || O({ params: Xe.exports.cloneDeep(D), event: W });
            } else
              throw new TypeError("event must be string or number !");
          }), I(this, "removeListener", (W) => {
            this.subscriptions.delete(W);
          }), I(this, "clear", () => {
            this.subscriptions.clear();
          }), this.clear();
        }
      }
      const it = new Ze();
      function ct(A2) {
        const W = L.useRef(), D = L.useMemo(() => A2 != null ? A2 : { global: false }, [A2]);
        return W.current || (W.current = D.global ? W.current = it : W.current = new Ze()), L.useEffect(() => () => {
          var O;
          return (O = W.current) == null ? void 0 : O.clear();
        }, []), W.current;
      }
      var sr = globalThis && globalThis.__read || function(A2, W) {
        var D = typeof Symbol == "function" && A2[Symbol.iterator];
        if (!D)
          return A2;
        var O = D.call(A2), F, B = [], Z;
        try {
          for (; (W === void 0 || W-- > 0) && !(F = O.next()).done; )
            B.push(F.value);
        } catch (re) {
          Z = { error: re };
        } finally {
          try {
            F && !F.done && (D = O.return) && D.call(O);
          } finally {
            if (Z)
              throw Z.error;
          }
        }
        return B;
      };
      function Yt(A2, W) {
        A2 === void 0 && (A2 = false);
        var D = sr(L.useState(A2), 2), O = D[0], F = D[1], B = L.useMemo(function() {
          var Z = W === void 0 ? !A2 : W, re = function() {
            return F(function(Pe) {
              return Pe === A2 ? Z : A2;
            });
          }, ie = function(Pe) {
            return F(Pe);
          }, ve = function() {
            return F(A2);
          }, ge = function() {
            return F(Z);
          };
          return { toggle: re, set: ie, setLeft: ve, setRight: ge };
        }, []);
        return [O, B];
      }
      var Or = globalThis && globalThis.__read || function(A2, W) {
        var D = typeof Symbol == "function" && A2[Symbol.iterator];
        if (!D)
          return A2;
        var O = D.call(A2), F, B = [], Z;
        try {
          for (; (W === void 0 || W-- > 0) && !(F = O.next()).done; )
            B.push(F.value);
        } catch (re) {
          Z = { error: re };
        } finally {
          try {
            F && !F.done && (D = O.return) && D.call(O);
          } finally {
            if (Z)
              throw Z.error;
          }
        }
        return B;
      };
      function le(A2) {
        A2 === void 0 && (A2 = false);
        var W = Or(Yt(A2), 2), D = W[0], O = W[1], F = O.toggle, B = O.set, Z = L.useMemo(function() {
          var re = function() {
            return B(true);
          }, ie = function() {
            return B(false);
          };
          return { toggle: F, set: function(ve) {
            return B(!!ve);
          }, setTrue: re, setFalse: ie };
        }, []);
        return [D, Z];
      }
      function _t(A2) {
        var W = L.useRef(A2);
        return W.current = A2, W;
      }
      var Pt = function(A2) {
        var W = _t(A2);
        L.useEffect(function() {
          return function() {
            W.current();
          };
        }, []);
      }, er = Pt;
      function Kt(A2) {
        var W = typeof A2;
        return A2 != null && (W == "object" || W == "function");
      }
      var St = Kt, kt = typeof Ae == "object" && Ae && Ae.Object === Object && Ae, dr = kt, Ir = dr, ht = typeof self == "object" && self && self.Object === Object && self, gn = Ir || ht || Function("return this")(), ln = gn, Jt = ln, In = function() {
        return Jt.Date.now();
      }, ur = In, Gt = /\s/;
      function zt(A2) {
        for (var W = A2.length; W-- && Gt.test(A2.charAt(W)); )
          ;
        return W;
      }
      var Yr = zt, Vr = Yr, Qn = /^\s+/;
      function Ua(A2) {
        return A2 && A2.slice(0, Vr(A2) + 1).replace(Qn, "");
      }
      var ua = Ua, Pa = ln, qi = Pa.Symbol, Ha = qi, pi = Ha, Lo = Object.prototype, rl = Lo.hasOwnProperty, is = Lo.toString, Xs = pi ? pi.toStringTag : void 0;
      function qo(A2) {
        var W = rl.call(A2, Xs), D = A2[Xs];
        try {
          A2[Xs] = void 0;
          var O = true;
        } catch {
        }
        var F = is.call(A2);
        return O && (W ? A2[Xs] = D : delete A2[Xs]), F;
      }
      var du = qo, nl = Object.prototype, os = nl.toString;
      function Rn(A2) {
        return os.call(A2);
      }
      var Tl = Rn, Iu = Ha, so = du, Fs = Tl, Oo = "[object Null]", mc = "[object Undefined]", nr = Iu ? Iu.toStringTag : void 0;
      function Nt(A2) {
        return A2 == null ? A2 === void 0 ? mc : Oo : nr && nr in Object(A2) ? so(A2) : Fs(A2);
      }
      var Rt = Nt;
      function _r(A2) {
        return A2 != null && typeof A2 == "object";
      }
      var tn = _r, Sn = Rt, Ca = tn, wa = "[object Symbol]";
      function Di(A2) {
        return typeof A2 == "symbol" || Ca(A2) && Sn(A2) == wa;
      }
      var Mi = Di, Da = ua, ko = St, uo = Mi, xs = 0 / 0, Lu = /^[-+]0x[0-9a-f]+$/i, Ul = /^0b[01]+$/i, ws = /^0o[0-7]+$/i, Go = parseInt;
      function qa(A2) {
        if (typeof A2 == "number")
          return A2;
        if (uo(A2))
          return xs;
        if (ko(A2)) {
          var W = typeof A2.valueOf == "function" ? A2.valueOf() : A2;
          A2 = ko(W) ? W + "" : W;
        }
        if (typeof A2 != "string")
          return A2 === 0 ? A2 : +A2;
        A2 = Da(A2);
        var D = Ul.test(A2);
        return D || ws.test(A2) ? Go(A2.slice(2), D ? 2 : 8) : Lu.test(A2) ? xs : +A2;
      }
      var Ss = qa, Js = St, al = ur, Ou = Ss, pu = "Expected a function", il = Math.max, uh = Math.min;
      function bc(A2, W, D) {
        var O, F, B, Z, re, ie, ve = 0, ge = false, Pe = false, He = true;
        if (typeof A2 != "function")
          throw new TypeError(pu);
        W = Ou(W) || 0, Js(D) && (ge = !!D.leading, Pe = "maxWait" in D, B = Pe ? il(Ou(D.maxWait) || 0, W) : B, He = "trailing" in D ? !!D.trailing : He);
        function Qe(Lt) {
          var ar = O, rr = F;
          return O = F = void 0, ve = Lt, Z = A2.apply(rr, ar), Z;
        }
        function Je(Lt) {
          return ve = Lt, re = setTimeout(lr, W), ge ? Qe(Lt) : Z;
        }
        function ut(Lt) {
          var ar = Lt - ie, rr = Lt - ve, Ct = W - ar;
          return Pe ? uh(Ct, B - rr) : Ct;
        }
        function gt(Lt) {
          var ar = Lt - ie, rr = Lt - ve;
          return ie === void 0 || ar >= W || ar < 0 || Pe && rr >= B;
        }
        function lr() {
          var Lt = al();
          if (gt(Lt))
            return tr(Lt);
          re = setTimeout(lr, ut(Lt));
        }
        function tr(Lt) {
          return re = void 0, He && O ? Qe(Lt) : (O = F = void 0, Z);
        }
        function Gr() {
          re !== void 0 && clearTimeout(re), ve = 0, O = ie = F = re = void 0;
        }
        function se() {
          return re === void 0 ? Z : tr(al());
        }
        function vt() {
          var Lt = al(), ar = gt(Lt);
          if (O = arguments, F = this, ie = Lt, ar) {
            if (re === void 0)
              return Je(ie);
            if (Pe)
              return clearTimeout(re), re = setTimeout(lr, W), Qe(ie);
          }
          return re === void 0 && (re = setTimeout(lr, W)), Z;
        }
        return vt.cancel = Gr, vt.flush = se, vt;
      }
      var Jg = bc, Hl = globalThis && globalThis.__read || function(A2, W) {
        var D = typeof Symbol == "function" && A2[Symbol.iterator];
        if (!D)
          return A2;
        var O = D.call(A2), F, B = [], Z;
        try {
          for (; (W === void 0 || W-- > 0) && !(F = O.next()).done; )
            B.push(F.value);
        } catch (re) {
          Z = { error: re };
        } finally {
          try {
            F && !F.done && (D = O.return) && D.call(O);
          } finally {
            if (Z)
              throw Z.error;
          }
        }
        return B;
      }, wp = globalThis && globalThis.__spread || function() {
        for (var A2 = [], W = 0; W < arguments.length; W++)
          A2 = A2.concat(Hl(arguments[W]));
        return A2;
      };
      function Qg(A2, W) {
        var D, O = _t(A2), F = (D = W == null ? void 0 : W.wait) !== null && D !== void 0 ? D : 1e3, B = L.useMemo(function() {
          return Jg(function() {
            for (var Z = [], re = 0; re < arguments.length; re++)
              Z[re] = arguments[re];
            return O.current.apply(O, wp(Z));
          }, F, W);
        }, []);
        return er(function() {
          B.cancel();
        }), { run: B, cancel: B.cancel, flush: B.flush };
      }
      const od = ({ id: A2, title: W, chart: D, option: O }, F) => {
        const B = L.useRef(), Z = ct({ global: true });
        B.current = L.useMemo(() => {
          if (!B.current)
            return de;
        }, []);
        const { run: re } = Qg(() => {
          A2 && Z.emit("list");
        }, { wait: 100 });
        return L.useEffect(() => {
          console.log(D == null ? void 0 : D.current), B.current && (D == null ? void 0 : D.current) && A2 && O && (B.current.add(A2, D == null ? void 0 : D.current, O, W), re());
        }, F), { tool: B.current };
      };
      var sd = L.createContext({}), lh = sd;
      function De(A2, W, D) {
        return W in A2 ? Object.defineProperty(A2, W, { value: D, enumerable: true, configurable: true, writable: true }) : A2[W] = D, A2;
      }
      function ze(A2, W) {
        var D = Object.keys(A2);
        if (Object.getOwnPropertySymbols) {
          var O = Object.getOwnPropertySymbols(A2);
          W && (O = O.filter(function(F) {
            return Object.getOwnPropertyDescriptor(A2, F).enumerable;
          })), D.push.apply(D, O);
        }
        return D;
      }
      function pe(A2) {
        for (var W = 1; W < arguments.length; W++) {
          var D = arguments[W] != null ? arguments[W] : {};
          W % 2 ? ze(Object(D), true).forEach(function(O) {
            De(A2, O, D[O]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(A2, Object.getOwnPropertyDescriptors(D)) : ze(Object(D)).forEach(function(O) {
            Object.defineProperty(A2, O, Object.getOwnPropertyDescriptor(D, O));
          });
        }
        return A2;
      }
      function Oe(A2) {
        if (Array.isArray(A2))
          return A2;
      }
      function Ve(A2, W) {
        var D = A2 == null ? null : typeof Symbol != "undefined" && A2[Symbol.iterator] || A2["@@iterator"];
        if (D != null) {
          var O = [], F = true, B = false, Z, re;
          try {
            for (D = D.call(A2); !(F = (Z = D.next()).done) && (O.push(Z.value), !(W && O.length === W)); F = true)
              ;
          } catch (ie) {
            B = true, re = ie;
          } finally {
            try {
              !F && D.return != null && D.return();
            } finally {
              if (B)
                throw re;
            }
          }
          return O;
        }
      }
      function Tt(A2, W) {
        (W == null || W > A2.length) && (W = A2.length);
        for (var D = 0, O = new Array(W); D < W; D++)
          O[D] = A2[D];
        return O;
      }
      function hr(A2, W) {
        if (A2) {
          if (typeof A2 == "string")
            return Tt(A2, W);
          var D = Object.prototype.toString.call(A2).slice(8, -1);
          if (D === "Object" && A2.constructor && (D = A2.constructor.name), D === "Map" || D === "Set")
            return Array.from(A2);
          if (D === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(D))
            return Tt(A2, W);
        }
      }
      function Xt() {
        throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function lt2(A2, W) {
        return Oe(A2) || Ve(A2, W) || hr(A2, W) || Xt();
      }
      function Fr(A2, W) {
        if (A2 == null)
          return {};
        var D = {}, O = Object.keys(A2), F, B;
        for (B = 0; B < O.length; B++)
          F = O[B], !(W.indexOf(F) >= 0) && (D[F] = A2[F]);
        return D;
      }
      function yn(A2, W) {
        if (A2 == null)
          return {};
        var D = Fr(A2, W), O, F;
        if (Object.getOwnPropertySymbols) {
          var B = Object.getOwnPropertySymbols(A2);
          for (F = 0; F < B.length; F++)
            O = B[F], !(W.indexOf(O) >= 0) && (!Object.prototype.propertyIsEnumerable.call(A2, O) || (D[O] = A2[O]));
        }
        return D;
      }
      var Ia = { exports: {} };
      /*!
        Copyright (c) 2018 Jed Watson.
        Licensed under the MIT License (MIT), see
        http://jedwatson.github.io/classnames
      */
      (function(A2) {
        (function() {
          var W = {}.hasOwnProperty;
          function D() {
            for (var O = [], F = 0; F < arguments.length; F++) {
              var B = arguments[F];
              if (B) {
                var Z = typeof B;
                if (Z === "string" || Z === "number")
                  O.push(B);
                else if (Array.isArray(B)) {
                  if (B.length) {
                    var re = D.apply(null, B);
                    re && O.push(re);
                  }
                } else if (Z === "object")
                  if (B.toString === Object.prototype.toString)
                    for (var ie in B)
                      W.call(B, ie) && B[ie] && O.push(ie);
                  else
                    O.push(B.toString());
              }
            }
            return O.join(" ");
          }
          A2.exports ? (D.default = D, A2.exports = D) : window.classNames = D;
        })();
      })(Ia);
      var Ea = Ia.exports;
      function pa(A2) {
        return pa = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(W) {
          return typeof W;
        } : function(W) {
          return W && typeof Symbol == "function" && W.constructor === Symbol && W !== Symbol.prototype ? "symbol" : typeof W;
        }, pa(A2);
      }
      function Wn(A2, W) {
        ki(A2) && (A2 = "100%");
        var D = bo(A2);
        return A2 = W === 360 ? A2 : Math.min(W, Math.max(0, parseFloat(A2))), D && (A2 = parseInt(String(A2 * W), 10) / 100), Math.abs(A2 - W) < 1e-6 ? 1 : (W === 360 ? A2 = (A2 < 0 ? A2 % W + W : A2 % W) / parseFloat(String(W)) : A2 = A2 % W / parseFloat(String(W)), A2);
      }
      function ki(A2) {
        return typeof A2 == "string" && A2.indexOf(".") !== -1 && parseFloat(A2) === 1;
      }
      function bo(A2) {
        return typeof A2 == "string" && A2.indexOf("%") !== -1;
      }
      function na(A2) {
        return A2 = parseFloat(A2), (isNaN(A2) || A2 < 0 || A2 > 1) && (A2 = 1), A2;
      }
      function Ro(A2) {
        return A2 <= 1 ? Number(A2) * 100 + "%" : A2;
      }
      function Qs(A2) {
        return A2.length === 1 ? "0" + A2 : String(A2);
      }
      function _c2(A2, W, D) {
        return { r: Wn(A2, 255) * 255, g: Wn(W, 255) * 255, b: Wn(D, 255) * 255 };
      }
      function Ef(A2, W, D) {
        return D < 0 && (D += 1), D > 1 && (D -= 1), D < 1 / 6 ? A2 + (W - A2) * (6 * D) : D < 1 / 2 ? W : D < 2 / 3 ? A2 + (W - A2) * (2 / 3 - D) * 6 : A2;
      }
      function xc(A2, W, D) {
        var O, F, B;
        if (A2 = Wn(A2, 360), W = Wn(W, 100), D = Wn(D, 100), W === 0)
          F = D, B = D, O = D;
        else {
          var Z = D < 0.5 ? D * (1 + W) : D + W - D * W, re = 2 * D - Z;
          O = Ef(re, Z, A2 + 1 / 3), F = Ef(re, Z, A2), B = Ef(re, Z, A2 - 1 / 3);
        }
        return { r: O * 255, g: F * 255, b: B * 255 };
      }
      function ov(A2, W, D) {
        A2 = Wn(A2, 255), W = Wn(W, 255), D = Wn(D, 255);
        var O = Math.max(A2, W, D), F = Math.min(A2, W, D), B = 0, Z = O, re = O - F, ie = O === 0 ? 0 : re / O;
        if (O === F)
          B = 0;
        else {
          switch (O) {
            case A2:
              B = (W - D) / re + (W < D ? 6 : 0);
              break;
            case W:
              B = (D - A2) / re + 2;
              break;
            case D:
              B = (A2 - W) / re + 4;
              break;
          }
          B /= 6;
        }
        return { h: B, s: ie, v: Z };
      }
      function Af(A2, W, D) {
        A2 = Wn(A2, 360) * 6, W = Wn(W, 100), D = Wn(D, 100);
        var O = Math.floor(A2), F = A2 - O, B = D * (1 - W), Z = D * (1 - F * W), re = D * (1 - (1 - F) * W), ie = O % 6, ve = [D, Z, B, B, re, D][ie], ge = [re, D, D, Z, B, B][ie], Pe = [B, B, re, D, D, Z][ie];
        return { r: ve * 255, g: ge * 255, b: Pe * 255 };
      }
      function Cs(A2, W, D, O) {
        var F = [Qs(Math.round(A2).toString(16)), Qs(Math.round(W).toString(16)), Qs(Math.round(D).toString(16))];
        return O && F[0].startsWith(F[0].charAt(1)) && F[1].startsWith(F[1].charAt(1)) && F[2].startsWith(F[2].charAt(1)) ? F[0].charAt(0) + F[1].charAt(0) + F[2].charAt(0) : F.join("");
      }
      function wc(A2) {
        return Es(A2) / 255;
      }
      function Es(A2) {
        return parseInt(A2, 16);
      }
      var ss = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
      function Sc(A2) {
        var W = { r: 0, g: 0, b: 0 }, D = 1, O = null, F = null, B = null, Z = false, re = false;
        return typeof A2 == "string" && (A2 = Cp(A2)), typeof A2 == "object" && (Ml(A2.r) && Ml(A2.g) && Ml(A2.b) ? (W = _c2(A2.r, A2.g, A2.b), Z = true, re = String(A2.r).substr(-1) === "%" ? "prgb" : "rgb") : Ml(A2.h) && Ml(A2.s) && Ml(A2.v) ? (O = Ro(A2.s), F = Ro(A2.v), W = Af(A2.h, O, F), Z = true, re = "hsv") : Ml(A2.h) && Ml(A2.s) && Ml(A2.l) && (O = Ro(A2.s), B = Ro(A2.l), W = xc(A2.h, O, B), Z = true, re = "hsl"), Object.prototype.hasOwnProperty.call(A2, "a") && (D = A2.a)), D = na(D), { ok: Z, format: A2.format || re, r: Math.min(255, Math.max(W.r, 0)), g: Math.min(255, Math.max(W.g, 0)), b: Math.min(255, Math.max(W.b, 0)), a: D };
      }
      var sv = "[-\\+]?\\d+%?", Sp = "[-\\+]?\\d*\\.\\d+%?", ol = "(?:" + Sp + ")|(?:" + sv + ")", ch = "[\\s|\\(]+(" + ol + ")[,|\\s]+(" + ol + ")[,|\\s]+(" + ol + ")\\s*\\)?", Tf = "[\\s|\\(]+(" + ol + ")[,|\\s]+(" + ol + ")[,|\\s]+(" + ol + ")[,|\\s]+(" + ol + ")\\s*\\)?", Ns = { CSS_UNIT: new RegExp(ol), rgb: new RegExp("rgb" + ch), rgba: new RegExp("rgba" + Tf), hsl: new RegExp("hsl" + ch), hsla: new RegExp("hsla" + Tf), hsv: new RegExp("hsv" + ch), hsva: new RegExp("hsva" + Tf), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
      function Cp(A2) {
        if (A2 = A2.trim().toLowerCase(), A2.length === 0)
          return false;
        var W = false;
        if (ss[A2])
          A2 = ss[A2], W = true;
        else if (A2 === "transparent")
          return { r: 0, g: 0, b: 0, a: 0, format: "name" };
        var D = Ns.rgb.exec(A2);
        return D ? { r: D[1], g: D[2], b: D[3] } : (D = Ns.rgba.exec(A2), D ? { r: D[1], g: D[2], b: D[3], a: D[4] } : (D = Ns.hsl.exec(A2), D ? { h: D[1], s: D[2], l: D[3] } : (D = Ns.hsla.exec(A2), D ? { h: D[1], s: D[2], l: D[3], a: D[4] } : (D = Ns.hsv.exec(A2), D ? { h: D[1], s: D[2], v: D[3] } : (D = Ns.hsva.exec(A2), D ? { h: D[1], s: D[2], v: D[3], a: D[4] } : (D = Ns.hex8.exec(A2), D ? { r: Es(D[1]), g: Es(D[2]), b: Es(D[3]), a: wc(D[4]), format: W ? "name" : "hex8" } : (D = Ns.hex6.exec(A2), D ? { r: Es(D[1]), g: Es(D[2]), b: Es(D[3]), format: W ? "name" : "hex" } : (D = Ns.hex4.exec(A2), D ? { r: Es(D[1] + D[1]), g: Es(D[2] + D[2]), b: Es(D[3] + D[3]), a: wc(D[4] + D[4]), format: W ? "name" : "hex8" } : (D = Ns.hex3.exec(A2), D ? { r: Es(D[1] + D[1]), g: Es(D[2] + D[2]), b: Es(D[3] + D[3]), format: W ? "name" : "hex" } : false)))))))));
      }
      function Ml(A2) {
        return Boolean(Ns.CSS_UNIT.exec(String(A2)));
      }
      var ud = 2, uv = 0.16, H1 = 0.05, q1 = 0.05, mS = 0.15, nm = 5, am = 4, Y1 = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
      function im(A2) {
        var W = A2.r, D = A2.g, O = A2.b, F = ov(W, D, O);
        return { h: F.h * 360, s: F.s, v: F.v };
      }
      function e0(A2) {
        var W = A2.r, D = A2.g, O = A2.b;
        return "#".concat(Cs(W, D, O, false));
      }
      function bS(A2, W, D) {
        var O = D / 100, F = { r: (W.r - A2.r) * O + A2.r, g: (W.g - A2.g) * O + A2.g, b: (W.b - A2.b) * O + A2.b };
        return F;
      }
      function K1(A2, W, D) {
        var O;
        return Math.round(A2.h) >= 60 && Math.round(A2.h) <= 240 ? O = D ? Math.round(A2.h) - ud * W : Math.round(A2.h) + ud * W : O = D ? Math.round(A2.h) + ud * W : Math.round(A2.h) - ud * W, O < 0 ? O += 360 : O >= 360 && (O -= 360), O;
      }
      function om(A2, W, D) {
        if (A2.h === 0 && A2.s === 0)
          return A2.s;
        var O;
        return D ? O = A2.s - uv * W : W === am ? O = A2.s + uv : O = A2.s + H1 * W, O > 1 && (O = 1), D && W === nm && O > 0.1 && (O = 0.1), O < 0.06 && (O = 0.06), Number(O.toFixed(2));
      }
      function Z1(A2, W, D) {
        var O;
        return D ? O = A2.v + q1 * W : O = A2.v - mS * W, O > 1 && (O = 1), Number(O.toFixed(2));
      }
      function sm(A2) {
        for (var W = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, D = [], O = Sc(A2), F = nm; F > 0; F -= 1) {
          var B = im(O), Z = e0(Sc({ h: K1(B, F, true), s: om(B, F, true), v: Z1(B, F, true) }));
          D.push(Z);
        }
        D.push(e0(O));
        for (var re = 1; re <= am; re += 1) {
          var ie = im(O), ve = e0(Sc({ h: K1(ie, re), s: om(ie, re), v: Z1(ie, re) }));
          D.push(ve);
        }
        return W.theme === "dark" ? Y1.map(function(ge) {
          var Pe = ge.index, He = ge.opacity, Qe = e0(bS(Sc(W.backgroundColor || "#141414"), Sc(D[Pe]), He * 100));
          return Qe;
        }) : D;
      }
      var um = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, gu = {}, Ep = {};
      Object.keys(um).forEach(function(A2) {
        gu[A2] = sm(um[A2]), gu[A2].primary = gu[A2][5], Ep[A2] = sm(um[A2], { theme: "dark", backgroundColor: "#141414" }), Ep[A2].primary = Ep[A2][5];
      }), gu.red, gu.volcano, gu.gold, gu.orange, gu.yellow, gu.lime, gu.green, gu.cyan, gu.blue, gu.geekblue, gu.purple, gu.magenta, gu.grey;
      var X1 = {};
      function _S(A2, W) {
      }
      function lm(A2, W, D) {
        !W && !X1[D] && (A2(false, D), X1[D] = true);
      }
      function Cc(A2, W) {
        lm(_S, A2, W);
      }
      function J1() {
        return !!(typeof window != "undefined" && window.document && window.document.createElement);
      }
      var _o = "rc-util-key";
      function lo() {
        var A2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, W = A2.mark;
        return W ? W.startsWith("data-") ? W : "data-".concat(W) : _o;
      }
      function cm(A2) {
        if (A2.attachTo)
          return A2.attachTo;
        var W = document.querySelector("head");
        return W || document.body;
      }
      function Q1(A2) {
        var W, D = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        if (!J1())
          return null;
        var O = document.createElement("style");
        if (!((W = D.csp) === null || W === void 0) && W.nonce) {
          var F;
          O.nonce = (F = D.csp) === null || F === void 0 ? void 0 : F.nonce;
        }
        O.innerHTML = A2;
        var B = cm(D), Z = B.firstChild;
        return D.prepend && B.prepend ? B.prepend(O) : D.prepend && Z ? B.insertBefore(O, Z) : B.appendChild(O), O;
      }
      var fm = /* @__PURE__ */ new Map();
      function xS(A2) {
        var W = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, D = cm(W);
        return Array.from(fm.get(D).children).find(function(O) {
          return O.tagName === "STYLE" && O.getAttribute(lo(W)) === A2;
        });
      }
      function e_(A2, W) {
        var D = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, O = cm(D);
        if (!fm.has(O)) {
          var F = Q1("", D), B = F.parentNode;
          fm.set(O, B), B.removeChild(F);
        }
        var Z = xS(W, D);
        if (Z) {
          var re, ie;
          if (((re = D.csp) === null || re === void 0 ? void 0 : re.nonce) && Z.nonce !== ((ie = D.csp) === null || ie === void 0 ? void 0 : ie.nonce)) {
            var ve;
            Z.nonce = (ve = D.csp) === null || ve === void 0 ? void 0 : ve.nonce;
          }
          return Z.innerHTML !== A2 && (Z.innerHTML = A2), Z;
        }
        var ge = Q1(A2, D);
        return ge.setAttribute(lo(D), W), ge;
      }
      function t_(A2, W) {
        Cc(A2, "[@ant-design/icons] ".concat(W));
      }
      function hm(A2) {
        return pa(A2) === "object" && typeof A2.name == "string" && typeof A2.theme == "string" && (pa(A2.icon) === "object" || typeof A2.icon == "function");
      }
      function Ap() {
        var A2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        return Object.keys(A2).reduce(function(W, D) {
          var O = A2[D];
          switch (D) {
            case "class":
              W.className = O, delete W.class;
              break;
            default:
              W[D] = O;
          }
          return W;
        }, {});
      }
      function As(A2, W, D) {
        return D ? te.default.createElement(A2.tag, pe(pe({ key: W }, Ap(A2.attrs)), D), (A2.children || []).map(function(O, F) {
          return As(O, "".concat(W, "-").concat(A2.tag, "-").concat(F));
        })) : te.default.createElement(A2.tag, pe({ key: W }, Ap(A2.attrs)), (A2.children || []).map(function(O, F) {
          return As(O, "".concat(W, "-").concat(A2.tag, "-").concat(F));
        }));
      }
      function t0(A2) {
        return sm(A2)[0];
      }
      function fh(A2) {
        return A2 ? Array.isArray(A2) ? A2 : [A2] : [];
      }
      var r_ = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, vm = function() {
        var A2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : r_, W = L.useContext(lh), D = W.csp;
        L.useEffect(function() {
          e_(A2, "@ant-design-icons", { prepend: true, csp: D });
        }, []);
      }, ql = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], ld = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
      function n_(A2) {
        var W = A2.primaryColor, D = A2.secondaryColor;
        ld.primaryColor = W, ld.secondaryColor = D || t0(W), ld.calculated = !!D;
      }
      function a_() {
        return pe({}, ld);
      }
      var Tp = function(A2) {
        var W = A2.icon, D = A2.className, O = A2.onClick, F = A2.style, B = A2.primaryColor, Z = A2.secondaryColor, re = yn(A2, ql), ie = ld;
        if (B && (ie = { primaryColor: B, secondaryColor: Z || t0(B) }), vm(), t_(hm(W), "icon should be icon definiton, but got ".concat(W)), !hm(W))
          return null;
        var ve = W;
        return ve && typeof ve.icon == "function" && (ve = pe(pe({}, ve), {}, { icon: ve.icon(ie.primaryColor, ie.secondaryColor) })), As(ve.icon, "svg-".concat(ve.name), pe({ className: D, onClick: O, style: F, "data-icon": ve.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, re));
      };
      Tp.displayName = "IconReact", Tp.getTwoToneColors = a_, Tp.setTwoToneColors = n_;
      var r0 = Tp;
      function dm(A2) {
        var W = fh(A2), D = lt2(W, 2), O = D[0], F = D[1];
        return r0.setTwoToneColors({ primaryColor: O, secondaryColor: F });
      }
      function Pl() {
        var A2 = r0.getTwoToneColors();
        return A2.calculated ? [A2.primaryColor, A2.secondaryColor] : A2.primaryColor;
      }
      var wS = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
      dm("#1890ff");
      var ku = Q.forwardRef(function(A2, W) {
        var D, O = A2.className, F = A2.icon, B = A2.spin, Z = A2.rotate, re = A2.tabIndex, ie = A2.onClick, ve = A2.twoToneColor, ge = yn(A2, wS), Pe = Q.useContext(lh), He = Pe.prefixCls, Qe = He === void 0 ? "anticon" : He, Je = Ea(Qe, (D = {}, De(D, "".concat(Qe, "-").concat(F.name), !!F.name), De(D, "".concat(Qe, "-spin"), !!B || F.name === "loading"), D), O), ut = re;
        ut === void 0 && ie && (ut = -1);
        var gt = Z ? { msTransform: "rotate(".concat(Z, "deg)"), transform: "rotate(".concat(Z, "deg)") } : void 0, lr = fh(ve), tr = lt2(lr, 2), Gr = tr[0], se = tr[1];
        return Q.createElement("span", pe(pe({ role: "img", "aria-label": F.name }, ge), {}, { ref: W, tabIndex: ut, onClick: ie, className: Je }), Q.createElement(r0, { icon: F, primaryColor: Gr, secondaryColor: se, style: gt }));
      });
      ku.displayName = "AntdIcon", ku.getTwoToneColor = Pl, ku.setTwoToneColor = dm;
      var SS = ku, pm = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, Mf = pm, Mp = function(A2, W) {
        return Q.createElement(SS, pe(pe({}, A2), {}, { ref: W, icon: Mf }));
      };
      Mp.displayName = "LoadingOutlined";
      var gm = Q.forwardRef(Mp);
      function Sa() {
        return Sa = Object.assign || function(A2) {
          for (var W = 1; W < arguments.length; W++) {
            var D = arguments[W];
            for (var O in D)
              Object.prototype.hasOwnProperty.call(D, O) && (A2[O] = D[O]);
          }
          return A2;
        }, Sa.apply(this, arguments);
      }
      function Yl(A2, W) {
        if (!(A2 instanceof W))
          throw new TypeError("Cannot call a class as a function");
      }
      function lv(A2, W) {
        for (var D = 0; D < W.length; D++) {
          var O = W[D];
          O.enumerable = O.enumerable || false, O.configurable = true, "value" in O && (O.writable = true), Object.defineProperty(A2, O.key, O);
        }
      }
      function Pp(A2, W, D) {
        return W && lv(A2.prototype, W), D && lv(A2, D), Object.defineProperty(A2, "prototype", { writable: false }), A2;
      }
      function Dp(A2, W) {
        return Dp = Object.setPrototypeOf || function(D, O) {
          return D.__proto__ = O, D;
        }, Dp(A2, W);
      }
      function ym(A2, W) {
        if (typeof W != "function" && W !== null)
          throw new TypeError("Super expression must either be null or a function");
        A2.prototype = Object.create(W && W.prototype, { constructor: { value: A2, writable: true, configurable: true } }), Object.defineProperty(A2, "prototype", { writable: false }), W && Dp(A2, W);
      }
      function n0(A2) {
        return n0 = Object.setPrototypeOf ? Object.getPrototypeOf : function(W) {
          return W.__proto__ || Object.getPrototypeOf(W);
        }, n0(A2);
      }
      function CS() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function a0(A2) {
        if (A2 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return A2;
      }
      function i0(A2, W) {
        if (W && (pa(W) === "object" || typeof W == "function"))
          return W;
        if (W !== void 0)
          throw new TypeError("Derived constructors may only return object or undefined");
        return a0(A2);
      }
      function hh(A2) {
        var W = CS();
        return function() {
          var D = n0(A2), O;
          if (W) {
            var F = n0(this).constructor;
            O = Reflect.construct(D, arguments, F);
          } else
            O = D.apply(this, arguments);
          return i0(this, O);
        };
      }
      var mm = { exports: {} }, zi = {};
      /** @license React v16.13.1
      * react-is.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var Ts = typeof Symbol == "function" && Symbol.for, vh = Ts ? Symbol.for("react.element") : 60103, Ip = Ts ? Symbol.for("react.portal") : 60106, cd = Ts ? Symbol.for("react.fragment") : 60107, Lp = Ts ? Symbol.for("react.strict_mode") : 60108, dh = Ts ? Symbol.for("react.profiler") : 60114, cv = Ts ? Symbol.for("react.provider") : 60109, Op = Ts ? Symbol.for("react.context") : 60110, kp = Ts ? Symbol.for("react.async_mode") : 60111, eu = Ts ? Symbol.for("react.concurrent_mode") : 60111, fd = Ts ? Symbol.for("react.forward_ref") : 60112, ph = Ts ? Symbol.for("react.suspense") : 60113, i_ = Ts ? Symbol.for("react.suspense_list") : 60120, gh = Ts ? Symbol.for("react.memo") : 60115, fv = Ts ? Symbol.for("react.lazy") : 60116, ES = Ts ? Symbol.for("react.block") : 60121, AS = Ts ? Symbol.for("react.fundamental") : 60117, bm = Ts ? Symbol.for("react.responder") : 60118, o_ = Ts ? Symbol.for("react.scope") : 60119;
      function Vs(A2) {
        if (typeof A2 == "object" && A2 !== null) {
          var W = A2.$$typeof;
          switch (W) {
            case vh:
              switch (A2 = A2.type, A2) {
                case kp:
                case eu:
                case cd:
                case dh:
                case Lp:
                case ph:
                  return A2;
                default:
                  switch (A2 = A2 && A2.$$typeof, A2) {
                    case Op:
                    case fd:
                    case fv:
                    case gh:
                    case cv:
                      return A2;
                    default:
                      return W;
                  }
              }
            case Ip:
              return W;
          }
        }
      }
      function s_(A2) {
        return Vs(A2) === eu;
      }
      zi.AsyncMode = kp, zi.ConcurrentMode = eu, zi.ContextConsumer = Op, zi.ContextProvider = cv, zi.Element = vh, zi.ForwardRef = fd, zi.Fragment = cd, zi.Lazy = fv, zi.Memo = gh, zi.Portal = Ip, zi.Profiler = dh, zi.StrictMode = Lp, zi.Suspense = ph, zi.isAsyncMode = function(A2) {
        return s_(A2) || Vs(A2) === kp;
      }, zi.isConcurrentMode = s_, zi.isContextConsumer = function(A2) {
        return Vs(A2) === Op;
      }, zi.isContextProvider = function(A2) {
        return Vs(A2) === cv;
      }, zi.isElement = function(A2) {
        return typeof A2 == "object" && A2 !== null && A2.$$typeof === vh;
      }, zi.isForwardRef = function(A2) {
        return Vs(A2) === fd;
      }, zi.isFragment = function(A2) {
        return Vs(A2) === cd;
      }, zi.isLazy = function(A2) {
        return Vs(A2) === fv;
      }, zi.isMemo = function(A2) {
        return Vs(A2) === gh;
      }, zi.isPortal = function(A2) {
        return Vs(A2) === Ip;
      }, zi.isProfiler = function(A2) {
        return Vs(A2) === dh;
      }, zi.isStrictMode = function(A2) {
        return Vs(A2) === Lp;
      }, zi.isSuspense = function(A2) {
        return Vs(A2) === ph;
      }, zi.isValidElementType = function(A2) {
        return typeof A2 == "string" || typeof A2 == "function" || A2 === cd || A2 === eu || A2 === dh || A2 === Lp || A2 === ph || A2 === i_ || typeof A2 == "object" && A2 !== null && (A2.$$typeof === fv || A2.$$typeof === gh || A2.$$typeof === cv || A2.$$typeof === Op || A2.$$typeof === fd || A2.$$typeof === AS || A2.$$typeof === bm || A2.$$typeof === o_ || A2.$$typeof === ES);
      }, zi.typeOf = Vs, mm.exports = zi;
      function _m(A2) {
        var W = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, D = [];
        return te.default.Children.forEach(A2, function(O) {
          O == null && !W.keepEmpty || (Array.isArray(O) ? D = D.concat(_m(O)) : mm.exports.isFragment(O) && O.props ? D = D.concat(_m(O.props.children, W)) : D.push(O));
        }), D;
      }
      function xm(A2, W) {
        typeof A2 == "function" ? A2(W) : pa(A2) === "object" && A2 && "current" in A2 && (A2.current = W);
      }
      function u_() {
        for (var A2 = arguments.length, W = new Array(A2), D = 0; D < A2; D++)
          W[D] = arguments[D];
        var O = W.filter(function(F) {
          return F;
        });
        return O.length <= 1 ? O[0] : function(F) {
          W.forEach(function(B) {
            xm(B, F);
          });
        };
      }
      function yh(A2) {
        var W, D, O = mm.exports.isMemo(A2) ? A2.type.type : A2.type;
        return !(typeof O == "function" && !(!((W = O.prototype) === null || W === void 0) && W.render) || typeof A2 == "function" && !(!((D = A2.prototype) === null || D === void 0) && D.render));
      }
      function o0() {
        try {
          if (!Object.assign)
            return false;
          var A2 = new String("abc");
          if (A2[5] = "de", Object.getOwnPropertyNames(A2)[0] === "5")
            return false;
          for (var W = {}, D = 0; D < 10; D++)
            W["_" + String.fromCharCode(D)] = D;
          var O = Object.getOwnPropertyNames(W).map(function(B) {
            return W[B];
          });
          if (O.join("") !== "0123456789")
            return false;
          var F = {};
          return "abcdefghijklmnopqrst".split("").forEach(function(B) {
            F[B] = B;
          }), Object.keys(Object.assign({}, F)).join("") === "abcdefghijklmnopqrst";
        } catch {
          return false;
        }
      }
      o0();
      function TS(A2) {
        if (Array.isArray(A2))
          return Tt(A2);
      }
      function l_(A2) {
        if (typeof Symbol != "undefined" && A2[Symbol.iterator] != null || A2["@@iterator"] != null)
          return Array.from(A2);
      }
      function MS() {
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function Na(A2) {
        return TS(A2) || l_(A2) || hr(A2) || MS();
      }
      var yu = "RC_FORM_INTERNAL_HOOKS", ii = function() {
        Cc(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
      }, Rp = Q.createContext({ getFieldValue: ii, getFieldsValue: ii, getFieldError: ii, getFieldWarning: ii, getFieldsError: ii, isFieldsTouched: ii, isFieldTouched: ii, isFieldValidating: ii, isFieldsValidating: ii, resetFields: ii, setFields: ii, setFieldsValue: ii, validateFields: ii, submit: ii, getInternalHooks: function() {
        return ii(), { dispatch: ii, initEntityValue: ii, registerField: ii, useSubscribe: ii, setInitialValues: ii, setCallbacks: ii, getFields: ii, setValidateMessages: ii, setPreserve: ii, getInitialValue: ii };
      } });
      function wm(A2) {
        return A2 == null ? [] : Array.isArray(A2) ? A2 : [A2];
      }
      var mh = { exports: {} };
      (function(A2) {
        var W = function(D) {
          var O = Object.prototype, F = O.hasOwnProperty, B, Z = typeof Symbol == "function" ? Symbol : {}, re = Z.iterator || "@@iterator", ie = Z.asyncIterator || "@@asyncIterator", ve = Z.toStringTag || "@@toStringTag";
          function ge(fr, Wt, Ut) {
            return Object.defineProperty(fr, Wt, { value: Ut, enumerable: true, configurable: true, writable: true }), fr[Wt];
          }
          try {
            ge({}, "");
          } catch {
            ge = function(fr, Wt, Ut) {
              return fr[Wt] = Ut;
            };
          }
          function Pe(fr, Wt, Ut, Kr) {
            var zr = Wt && Wt.prototype instanceof tr ? Wt : tr, Zn = Object.create(zr.prototype), gi = new fn(Kr || []);
            return Zn._invoke = gr(fr, Ut, gi), Zn;
          }
          D.wrap = Pe;
          function He(fr, Wt, Ut) {
            try {
              return { type: "normal", arg: fr.call(Wt, Ut) };
            } catch (Kr) {
              return { type: "throw", arg: Kr };
            }
          }
          var Qe = "suspendedStart", Je = "suspendedYield", ut = "executing", gt = "completed", lr = {};
          function tr() {
          }
          function Gr() {
          }
          function se() {
          }
          var vt = {};
          ge(vt, re, function() {
            return this;
          });
          var Lt = Object.getPrototypeOf, ar = Lt && Lt(Lt(ir([])));
          ar && ar !== O && F.call(ar, re) && (vt = ar);
          var rr = se.prototype = tr.prototype = Object.create(vt);
          Gr.prototype = se, ge(rr, "constructor", se), ge(se, "constructor", Gr), Gr.displayName = ge(se, ve, "GeneratorFunction");
          function Ct(fr) {
            ["next", "throw", "return"].forEach(function(Wt) {
              ge(fr, Wt, function(Ut) {
                return this._invoke(Wt, Ut);
              });
            });
          }
          D.isGeneratorFunction = function(fr) {
            var Wt = typeof fr == "function" && fr.constructor;
            return Wt ? Wt === Gr || (Wt.displayName || Wt.name) === "GeneratorFunction" : false;
          }, D.mark = function(fr) {
            return Object.setPrototypeOf ? Object.setPrototypeOf(fr, se) : (fr.__proto__ = se, ge(fr, ve, "GeneratorFunction")), fr.prototype = Object.create(rr), fr;
          }, D.awrap = function(fr) {
            return { __await: fr };
          };
          function Ft(fr, Wt) {
            function Ut(Zn, gi, Ja, Oa) {
              var co = He(fr[Zn], fr, gi);
              if (co.type === "throw")
                Oa(co.arg);
              else {
                var Qa = co.arg, Fi = Qa.value;
                return Fi && typeof Fi == "object" && F.call(Fi, "__await") ? Wt.resolve(Fi.__await).then(function(Jo) {
                  Ut("next", Jo, Ja, Oa);
                }, function(Jo) {
                  Ut("throw", Jo, Ja, Oa);
                }) : Wt.resolve(Fi).then(function(Jo) {
                  Qa.value = Jo, Ja(Qa);
                }, function(Jo) {
                  return Ut("throw", Jo, Ja, Oa);
                });
              }
            }
            var Kr;
            function zr(Zn, gi) {
              function Ja() {
                return new Wt(function(Oa, co) {
                  Ut(Zn, gi, Oa, co);
                });
              }
              return Kr = Kr ? Kr.then(Ja, Ja) : Ja();
            }
            this._invoke = zr;
          }
          Ct(Ft.prototype), ge(Ft.prototype, ie, function() {
            return this;
          }), D.AsyncIterator = Ft, D.async = function(fr, Wt, Ut, Kr, zr) {
            zr === void 0 && (zr = Promise);
            var Zn = new Ft(Pe(fr, Wt, Ut, Kr), zr);
            return D.isGeneratorFunction(Wt) ? Zn : Zn.next().then(function(gi) {
              return gi.done ? gi.value : Zn.next();
            });
          };
          function gr(fr, Wt, Ut) {
            var Kr = Qe;
            return function(zr, Zn) {
              if (Kr === ut)
                throw new Error("Generator is already running");
              if (Kr === gt) {
                if (zr === "throw")
                  throw Zn;
                return Vn();
              }
              for (Ut.method = zr, Ut.arg = Zn; ; ) {
                var gi = Ut.delegate;
                if (gi) {
                  var Ja = Nr(gi, Ut);
                  if (Ja) {
                    if (Ja === lr)
                      continue;
                    return Ja;
                  }
                }
                if (Ut.method === "next")
                  Ut.sent = Ut._sent = Ut.arg;
                else if (Ut.method === "throw") {
                  if (Kr === Qe)
                    throw Kr = gt, Ut.arg;
                  Ut.dispatchException(Ut.arg);
                } else
                  Ut.method === "return" && Ut.abrupt("return", Ut.arg);
                Kr = ut;
                var Oa = He(fr, Wt, Ut);
                if (Oa.type === "normal") {
                  if (Kr = Ut.done ? gt : Je, Oa.arg === lr)
                    continue;
                  return { value: Oa.arg, done: Ut.done };
                } else
                  Oa.type === "throw" && (Kr = gt, Ut.method = "throw", Ut.arg = Oa.arg);
              }
            };
          }
          function Nr(fr, Wt) {
            var Ut = fr.iterator[Wt.method];
            if (Ut === B) {
              if (Wt.delegate = null, Wt.method === "throw") {
                if (fr.iterator.return && (Wt.method = "return", Wt.arg = B, Nr(fr, Wt), Wt.method === "throw"))
                  return lr;
                Wt.method = "throw", Wt.arg = new TypeError("The iterator does not provide a 'throw' method");
              }
              return lr;
            }
            var Kr = He(Ut, fr.iterator, Wt.arg);
            if (Kr.type === "throw")
              return Wt.method = "throw", Wt.arg = Kr.arg, Wt.delegate = null, lr;
            var zr = Kr.arg;
            if (!zr)
              return Wt.method = "throw", Wt.arg = new TypeError("iterator result is not an object"), Wt.delegate = null, lr;
            if (zr.done)
              Wt[fr.resultName] = zr.value, Wt.next = fr.nextLoc, Wt.method !== "return" && (Wt.method = "next", Wt.arg = B);
            else
              return zr;
            return Wt.delegate = null, lr;
          }
          Ct(rr), ge(rr, ve, "Generator"), ge(rr, re, function() {
            return this;
          }), ge(rr, "toString", function() {
            return "[object Generator]";
          });
          function mt(fr) {
            var Wt = { tryLoc: fr[0] };
            1 in fr && (Wt.catchLoc = fr[1]), 2 in fr && (Wt.finallyLoc = fr[2], Wt.afterLoc = fr[3]), this.tryEntries.push(Wt);
          }
          function dn(fr) {
            var Wt = fr.completion || {};
            Wt.type = "normal", delete Wt.arg, fr.completion = Wt;
          }
          function fn(fr) {
            this.tryEntries = [{ tryLoc: "root" }], fr.forEach(mt, this), this.reset(true);
          }
          D.keys = function(fr) {
            var Wt = [];
            for (var Ut in fr)
              Wt.push(Ut);
            return Wt.reverse(), function Kr() {
              for (; Wt.length; ) {
                var zr = Wt.pop();
                if (zr in fr)
                  return Kr.value = zr, Kr.done = false, Kr;
              }
              return Kr.done = true, Kr;
            };
          };
          function ir(fr) {
            if (fr) {
              var Wt = fr[re];
              if (Wt)
                return Wt.call(fr);
              if (typeof fr.next == "function")
                return fr;
              if (!isNaN(fr.length)) {
                var Ut = -1, Kr = function zr() {
                  for (; ++Ut < fr.length; )
                    if (F.call(fr, Ut))
                      return zr.value = fr[Ut], zr.done = false, zr;
                  return zr.value = B, zr.done = true, zr;
                };
                return Kr.next = Kr;
              }
            }
            return { next: Vn };
          }
          D.values = ir;
          function Vn() {
            return { value: B, done: true };
          }
          return fn.prototype = { constructor: fn, reset: function(fr) {
            if (this.prev = 0, this.next = 0, this.sent = this._sent = B, this.done = false, this.delegate = null, this.method = "next", this.arg = B, this.tryEntries.forEach(dn), !fr)
              for (var Wt in this)
                Wt.charAt(0) === "t" && F.call(this, Wt) && !isNaN(+Wt.slice(1)) && (this[Wt] = B);
          }, stop: function() {
            this.done = true;
            var fr = this.tryEntries[0], Wt = fr.completion;
            if (Wt.type === "throw")
              throw Wt.arg;
            return this.rval;
          }, dispatchException: function(fr) {
            if (this.done)
              throw fr;
            var Wt = this;
            function Ut(Oa, co) {
              return Zn.type = "throw", Zn.arg = fr, Wt.next = Oa, co && (Wt.method = "next", Wt.arg = B), !!co;
            }
            for (var Kr = this.tryEntries.length - 1; Kr >= 0; --Kr) {
              var zr = this.tryEntries[Kr], Zn = zr.completion;
              if (zr.tryLoc === "root")
                return Ut("end");
              if (zr.tryLoc <= this.prev) {
                var gi = F.call(zr, "catchLoc"), Ja = F.call(zr, "finallyLoc");
                if (gi && Ja) {
                  if (this.prev < zr.catchLoc)
                    return Ut(zr.catchLoc, true);
                  if (this.prev < zr.finallyLoc)
                    return Ut(zr.finallyLoc);
                } else if (gi) {
                  if (this.prev < zr.catchLoc)
                    return Ut(zr.catchLoc, true);
                } else if (Ja) {
                  if (this.prev < zr.finallyLoc)
                    return Ut(zr.finallyLoc);
                } else
                  throw new Error("try statement without catch or finally");
              }
            }
          }, abrupt: function(fr, Wt) {
            for (var Ut = this.tryEntries.length - 1; Ut >= 0; --Ut) {
              var Kr = this.tryEntries[Ut];
              if (Kr.tryLoc <= this.prev && F.call(Kr, "finallyLoc") && this.prev < Kr.finallyLoc) {
                var zr = Kr;
                break;
              }
            }
            zr && (fr === "break" || fr === "continue") && zr.tryLoc <= Wt && Wt <= zr.finallyLoc && (zr = null);
            var Zn = zr ? zr.completion : {};
            return Zn.type = fr, Zn.arg = Wt, zr ? (this.method = "next", this.next = zr.finallyLoc, lr) : this.complete(Zn);
          }, complete: function(fr, Wt) {
            if (fr.type === "throw")
              throw fr.arg;
            return fr.type === "break" || fr.type === "continue" ? this.next = fr.arg : fr.type === "return" ? (this.rval = this.arg = fr.arg, this.method = "return", this.next = "end") : fr.type === "normal" && Wt && (this.next = Wt), lr;
          }, finish: function(fr) {
            for (var Wt = this.tryEntries.length - 1; Wt >= 0; --Wt) {
              var Ut = this.tryEntries[Wt];
              if (Ut.finallyLoc === fr)
                return this.complete(Ut.completion, Ut.afterLoc), dn(Ut), lr;
            }
          }, catch: function(fr) {
            for (var Wt = this.tryEntries.length - 1; Wt >= 0; --Wt) {
              var Ut = this.tryEntries[Wt];
              if (Ut.tryLoc === fr) {
                var Kr = Ut.completion;
                if (Kr.type === "throw") {
                  var zr = Kr.arg;
                  dn(Ut);
                }
                return zr;
              }
            }
            throw new Error("illegal catch attempt");
          }, delegateYield: function(fr, Wt, Ut) {
            return this.delegate = { iterator: ir(fr), resultName: Wt, nextLoc: Ut }, this.method === "next" && (this.arg = B), lr;
          } }, D;
        }(A2.exports);
        try {
          regeneratorRuntime = W;
        } catch {
          typeof globalThis == "object" ? globalThis.regeneratorRuntime = W : Function("r", "regeneratorRuntime = r")(W);
        }
      })(mh);
      var Yn = mh.exports;
      function c_(A2, W, D, O, F, B, Z) {
        try {
          var re = A2[B](Z), ie = re.value;
        } catch (ve) {
          D(ve);
          return;
        }
        re.done ? W(ie) : Promise.resolve(ie).then(O, F);
      }
      function Yo(A2) {
        return function() {
          var W = this, D = arguments;
          return new Promise(function(O, F) {
            var B = A2.apply(W, D);
            function Z(ie) {
              c_(B, O, F, Z, re, "next", ie);
            }
            function re(ie) {
              c_(B, O, F, Z, re, "throw", ie);
            }
            Z(void 0);
          });
        };
      }
      function rt2() {
        return rt2 = Object.assign || function(A2) {
          for (var W = 1; W < arguments.length; W++) {
            var D = arguments[W];
            for (var O in D)
              Object.prototype.hasOwnProperty.call(D, O) && (A2[O] = D[O]);
          }
          return A2;
        }, rt2.apply(this, arguments);
      }
      function yr(A2, W) {
        A2.prototype = Object.create(W.prototype), A2.prototype.constructor = A2, vn(A2, W);
      }
      function Bt(A2) {
        return Bt = Object.setPrototypeOf ? Object.getPrototypeOf : function(W) {
          return W.__proto__ || Object.getPrototypeOf(W);
        }, Bt(A2);
      }
      function vn(A2, W) {
        return vn = Object.setPrototypeOf || function(D, O) {
          return D.__proto__ = O, D;
        }, vn(A2, W);
      }
      function ba() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function Ci(A2, W, D) {
        return ba() ? Ci = Reflect.construct : Ci = function(O, F, B) {
          var Z = [null];
          Z.push.apply(Z, F);
          var re = Function.bind.apply(O, Z), ie = new re();
          return B && vn(ie, B.prototype), ie;
        }, Ci.apply(null, arguments);
      }
      function Ms(A2) {
        return Function.toString.call(A2).indexOf("[native code]") !== -1;
      }
      function Yi(A2) {
        var W = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
        return Yi = function(D) {
          if (D === null || !Ms(D))
            return D;
          if (typeof D != "function")
            throw new TypeError("Super expression must either be null or a function");
          if (typeof W != "undefined") {
            if (W.has(D))
              return W.get(D);
            W.set(D, O);
          }
          function O() {
            return Ci(D, arguments, Bt(this).constructor);
          }
          return O.prototype = Object.create(D.prototype, { constructor: { value: O, enumerable: false, writable: true, configurable: true } }), vn(O, D);
        }, Yi(A2);
      }
      var Fp = /%[sdj%]/g, PS = function() {
      };
      typeof process != "undefined" && process.env;
      function Ko(A2) {
        if (!A2 || !A2.length)
          return null;
        var W = {};
        return A2.forEach(function(D) {
          var O = D.field;
          W[O] = W[O] || [], W[O].push(D);
        }), W;
      }
      function tu(A2) {
        for (var W = arguments.length, D = new Array(W > 1 ? W - 1 : 0), O = 1; O < W; O++)
          D[O - 1] = arguments[O];
        var F = 0, B = D.length;
        if (typeof A2 == "function")
          return A2.apply(null, D);
        if (typeof A2 == "string") {
          var Z = A2.replace(Fp, function(re) {
            if (re === "%%")
              return "%";
            if (F >= B)
              return re;
            switch (re) {
              case "%s":
                return String(D[F++]);
              case "%d":
                return Number(D[F++]);
              case "%j":
                try {
                  return JSON.stringify(D[F++]);
                } catch {
                  return "[Circular]";
                }
                break;
              default:
                return re;
            }
          });
          return Z;
        }
        return A2;
      }
      function s0(A2) {
        return A2 === "string" || A2 === "url" || A2 === "hex" || A2 === "email" || A2 === "date" || A2 === "pattern";
      }
      function la(A2, W) {
        return !!(A2 == null || W === "array" && Array.isArray(A2) && !A2.length || s0(W) && typeof A2 == "string" && !A2);
      }
      function xo(A2, W, D) {
        var O = [], F = 0, B = A2.length;
        function Z(re) {
          O.push.apply(O, re || []), F++, F === B && D(O);
        }
        A2.forEach(function(re) {
          W(re, Z);
        });
      }
      function hd(A2, W, D) {
        var O = 0, F = A2.length;
        function B(Z) {
          if (Z && Z.length) {
            D(Z);
            return;
          }
          var re = O;
          O = O + 1, re < F ? W(A2[re], B) : D([]);
        }
        B([]);
      }
      function Ki(A2) {
        var W = [];
        return Object.keys(A2).forEach(function(D) {
          W.push.apply(W, A2[D] || []);
        }), W;
      }
      var f_ = function(A2) {
        yr(W, A2);
        function W(D, O) {
          var F;
          return F = A2.call(this, "Async Validation Error") || this, F.errors = D, F.fields = O, F;
        }
        return W;
      }(Yi(Error));
      function h_(A2, W, D, O, F) {
        if (W.first) {
          var B = new Promise(function(He, Qe) {
            var Je = function(gt) {
              return O(gt), gt.length ? Qe(new f_(gt, Ko(gt))) : He(F);
            }, ut = Ki(A2);
            hd(ut, D, Je);
          });
          return B.catch(function(He) {
            return He;
          }), B;
        }
        var Z = W.firstFields === true ? Object.keys(A2) : W.firstFields || [], re = Object.keys(A2), ie = re.length, ve = 0, ge = [], Pe = new Promise(function(He, Qe) {
          var Je = function(ut) {
            if (ge.push.apply(ge, ut), ve++, ve === ie)
              return O(ge), ge.length ? Qe(new f_(ge, Ko(ge))) : He(F);
          };
          re.length || (O(ge), He(F)), re.forEach(function(ut) {
            var gt = A2[ut];
            Z.indexOf(ut) !== -1 ? hd(gt, D, Je) : xo(gt, D, Je);
          });
        });
        return Pe.catch(function(He) {
          return He;
        }), Pe;
      }
      function u0(A2) {
        return !!(A2 && A2.message !== void 0);
      }
      function DS(A2, W) {
        for (var D = A2, O = 0; O < W.length; O++) {
          if (D == null)
            return D;
          D = D[W[O]];
        }
        return D;
      }
      function v_(A2, W) {
        return function(D) {
          var O;
          return A2.fullFields ? O = DS(W, A2.fullFields) : O = W[D.field || A2.fullField], u0(D) ? (D.field = D.field || A2.fullField, D.fieldValue = O, D) : { message: typeof D == "function" ? D() : D, fieldValue: O, field: D.field || A2.fullField };
        };
      }
      function Sm(A2, W) {
        if (W) {
          for (var D in W)
            if (W.hasOwnProperty(D)) {
              var O = W[D];
              typeof O == "object" && typeof A2[D] == "object" ? A2[D] = rt2({}, A2[D], O) : A2[D] = O;
            }
        }
        return A2;
      }
      var Pf = function(A2, W, D, O, F, B) {
        A2.required && (!D.hasOwnProperty(A2.field) || la(W, B || A2.type)) && O.push(tu(F.messages.required, A2.fullField));
      }, Uc = function(A2, W, D, O, F) {
        (/^\s+$/.test(W) || W === "") && O.push(tu(F.messages.whitespace, A2.fullField));
      }, vd = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, hv = { integer: function(A2) {
        return hv.number(A2) && parseInt(A2, 10) === A2;
      }, float: function(A2) {
        return hv.number(A2) && !hv.integer(A2);
      }, array: function(A2) {
        return Array.isArray(A2);
      }, regexp: function(A2) {
        if (A2 instanceof RegExp)
          return true;
        try {
          return !!new RegExp(A2);
        } catch {
          return false;
        }
      }, date: function(A2) {
        return typeof A2.getTime == "function" && typeof A2.getMonth == "function" && typeof A2.getYear == "function" && !isNaN(A2.getTime());
      }, number: function(A2) {
        return isNaN(A2) ? false : typeof A2 == "number";
      }, object: function(A2) {
        return typeof A2 == "object" && !hv.array(A2);
      }, method: function(A2) {
        return typeof A2 == "function";
      }, email: function(A2) {
        return typeof A2 == "string" && A2.length <= 320 && !!A2.match(vd.email);
      }, url: function(A2) {
        return typeof A2 == "string" && A2.length <= 2048 && !!A2.match(vd.url);
      }, hex: function(A2) {
        return typeof A2 == "string" && !!A2.match(vd.hex);
      } }, vv = function(A2, W, D, O, F) {
        if (A2.required && W === void 0) {
          Pf(A2, W, D, O, F);
          return;
        }
        var B = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], Z = A2.type;
        B.indexOf(Z) > -1 ? hv[Z](W) || O.push(tu(F.messages.types[Z], A2.fullField, A2.type)) : Z && typeof W !== A2.type && O.push(tu(F.messages.types[Z], A2.fullField, A2.type));
      }, sl = function(A2, W, D, O, F) {
        var B = typeof A2.len == "number", Z = typeof A2.min == "number", re = typeof A2.max == "number", ie = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, ve = W, ge = null, Pe = typeof W == "number", He = typeof W == "string", Qe = Array.isArray(W);
        if (Pe ? ge = "number" : He ? ge = "string" : Qe && (ge = "array"), !ge)
          return false;
        Qe && (ve = W.length), He && (ve = W.replace(ie, "_").length), B ? ve !== A2.len && O.push(tu(F.messages[ge].len, A2.fullField, A2.len)) : Z && !re && ve < A2.min ? O.push(tu(F.messages[ge].min, A2.fullField, A2.min)) : re && !Z && ve > A2.max ? O.push(tu(F.messages[ge].max, A2.fullField, A2.max)) : Z && re && (ve < A2.min || ve > A2.max) && O.push(tu(F.messages[ge].range, A2.fullField, A2.min, A2.max));
      }, Kl = "enum", l0 = function(A2, W, D, O, F) {
        A2[Kl] = Array.isArray(A2[Kl]) ? A2[Kl] : [], A2[Kl].indexOf(W) === -1 && O.push(tu(F.messages[Kl], A2.fullField, A2[Kl].join(", ")));
      }, d_ = function(A2, W, D, O, F) {
        if (A2.pattern) {
          if (A2.pattern instanceof RegExp)
            A2.pattern.lastIndex = 0, A2.pattern.test(W) || O.push(tu(F.messages.pattern.mismatch, A2.fullField, W, A2.pattern));
          else if (typeof A2.pattern == "string") {
            var B = new RegExp(A2.pattern);
            B.test(W) || O.push(tu(F.messages.pattern.mismatch, A2.fullField, W, A2.pattern));
          }
        }
      }, Va = { required: Pf, whitespace: Uc, type: vv, range: sl, enum: l0, pattern: d_ }, dv = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W, "string") && !A2.required)
            return D();
          Va.required(A2, W, O, B, F, "string"), la(W, "string") || (Va.type(A2, W, O, B, F), Va.range(A2, W, O, B, F), Va.pattern(A2, W, O, B, F), A2.whitespace === true && Va.whitespace(A2, W, O, B, F));
        }
        D(B);
      }, c0 = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && Va.type(A2, W, O, B, F);
        }
        D(B);
      }, p_ = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (W === "" && (W = void 0), la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && (Va.type(A2, W, O, B, F), Va.range(A2, W, O, B, F));
        }
        D(B);
      }, Df = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && Va.type(A2, W, O, B, F);
        }
        D(B);
      }, La = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), la(W) || Va.type(A2, W, O, B, F);
        }
        D(B);
      }, Np = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && (Va.type(A2, W, O, B, F), Va.range(A2, W, O, B, F));
        }
        D(B);
      }, Ru = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && (Va.type(A2, W, O, B, F), Va.range(A2, W, O, B, F));
        }
        D(B);
      }, f0 = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (W == null && !A2.required)
            return D();
          Va.required(A2, W, O, B, F, "array"), W != null && (Va.type(A2, W, O, B, F), Va.range(A2, W, O, B, F));
        }
        D(B);
      }, IS = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && Va.type(A2, W, O, B, F);
        }
        D(B);
      }, Ri = "enum", LS = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), W !== void 0 && Va[Ri](A2, W, O, B, F);
        }
        D(B);
      }, g_ = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W, "string") && !A2.required)
            return D();
          Va.required(A2, W, O, B, F), la(W, "string") || Va.pattern(A2, W, O, B, F);
        }
        D(B);
      }, Zo = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W, "date") && !A2.required)
            return D();
          if (Va.required(A2, W, O, B, F), !la(W, "date")) {
            var re;
            W instanceof Date ? re = W : re = new Date(W), Va.type(A2, re, O, B, F), re && Va.range(A2, re.getTime(), O, B, F);
          }
        }
        D(B);
      }, mu = function(A2, W, D, O, F) {
        var B = [], Z = Array.isArray(W) ? "array" : typeof W;
        Va.required(A2, W, O, B, F, Z), D(B);
      }, Cm = function(A2, W, D, O, F) {
        var B = A2.type, Z = [], re = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (re) {
          if (la(W, B) && !A2.required)
            return D();
          Va.required(A2, W, O, Z, F, B), la(W, B) || Va.type(A2, W, O, Z, F);
        }
        D(Z);
      }, OS = function(A2, W, D, O, F) {
        var B = [], Z = A2.required || !A2.required && O.hasOwnProperty(A2.field);
        if (Z) {
          if (la(W) && !A2.required)
            return D();
          Va.required(A2, W, O, B, F);
        }
        D(B);
      }, dd = { string: dv, method: c0, number: p_, boolean: Df, regexp: La, integer: Np, float: Ru, array: f0, object: IS, enum: LS, pattern: g_, date: Zo, url: Cm, hex: Cm, email: Cm, required: mu, any: OS };
      function Em() {
        return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
          var A2 = JSON.parse(JSON.stringify(this));
          return A2.clone = this.clone, A2;
        } };
      }
      var Vp = Em(), If = function() {
        function A2(D) {
          this.rules = null, this._messages = Vp, this.define(D);
        }
        var W = A2.prototype;
        return W.define = function(D) {
          var O = this;
          if (!D)
            throw new Error("Cannot configure a schema with no rules");
          if (typeof D != "object" || Array.isArray(D))
            throw new Error("Rules must be an object");
          this.rules = {}, Object.keys(D).forEach(function(F) {
            var B = D[F];
            O.rules[F] = Array.isArray(B) ? B : [B];
          });
        }, W.messages = function(D) {
          return D && (this._messages = Sm(Em(), D)), this._messages;
        }, W.validate = function(D, O, F) {
          var B = this;
          O === void 0 && (O = {}), F === void 0 && (F = function() {
          });
          var Z = D, re = O, ie = F;
          if (typeof re == "function" && (ie = re, re = {}), !this.rules || Object.keys(this.rules).length === 0)
            return ie && ie(null, Z), Promise.resolve(Z);
          function ve(Je) {
            var ut = [], gt = {};
            function lr(Gr) {
              if (Array.isArray(Gr)) {
                var se;
                ut = (se = ut).concat.apply(se, Gr);
              } else
                ut.push(Gr);
            }
            for (var tr = 0; tr < Je.length; tr++)
              lr(Je[tr]);
            ut.length ? (gt = Ko(ut), ie(ut, gt)) : ie(null, Z);
          }
          if (re.messages) {
            var ge = this.messages();
            ge === Vp && (ge = Em()), Sm(ge, re.messages), re.messages = ge;
          } else
            re.messages = this.messages();
          var Pe = {}, He = re.keys || Object.keys(this.rules);
          He.forEach(function(Je) {
            var ut = B.rules[Je], gt = Z[Je];
            ut.forEach(function(lr) {
              var tr = lr;
              typeof tr.transform == "function" && (Z === D && (Z = rt2({}, Z)), gt = Z[Je] = tr.transform(gt)), typeof tr == "function" ? tr = { validator: tr } : tr = rt2({}, tr), tr.validator = B.getValidationMethod(tr), tr.validator && (tr.field = Je, tr.fullField = tr.fullField || Je, tr.type = B.getType(tr), Pe[Je] = Pe[Je] || [], Pe[Je].push({ rule: tr, value: gt, source: Z, field: Je }));
            });
          });
          var Qe = {};
          return h_(Pe, re, function(Je, ut) {
            var gt = Je.rule, lr = (gt.type === "object" || gt.type === "array") && (typeof gt.fields == "object" || typeof gt.defaultField == "object");
            lr = lr && (gt.required || !gt.required && Je.value), gt.field = Je.field;
            function tr(vt, Lt) {
              return rt2({}, Lt, { fullField: gt.fullField + "." + vt, fullFields: gt.fullFields ? [].concat(gt.fullFields, [vt]) : [vt] });
            }
            function Gr(vt) {
              vt === void 0 && (vt = []);
              var Lt = Array.isArray(vt) ? vt : [vt];
              !re.suppressWarning && Lt.length && A2.warning("async-validator:", Lt), Lt.length && gt.message !== void 0 && (Lt = [].concat(gt.message));
              var ar = Lt.map(v_(gt, Z));
              if (re.first && ar.length)
                return Qe[gt.field] = 1, ut(ar);
              if (!lr)
                ut(ar);
              else {
                if (gt.required && !Je.value)
                  return gt.message !== void 0 ? ar = [].concat(gt.message).map(v_(gt, Z)) : re.error && (ar = [re.error(gt, tu(re.messages.required, gt.field))]), ut(ar);
                var rr = {};
                gt.defaultField && Object.keys(Je.value).map(function(gr) {
                  rr[gr] = gt.defaultField;
                }), rr = rt2({}, rr, Je.rule.fields);
                var Ct = {};
                Object.keys(rr).forEach(function(gr) {
                  var Nr = rr[gr], mt = Array.isArray(Nr) ? Nr : [Nr];
                  Ct[gr] = mt.map(tr.bind(null, gr));
                });
                var Ft = new A2(Ct);
                Ft.messages(re.messages), Je.rule.options && (Je.rule.options.messages = re.messages, Je.rule.options.error = re.error), Ft.validate(Je.value, Je.rule.options || re, function(gr) {
                  var Nr = [];
                  ar && ar.length && Nr.push.apply(Nr, ar), gr && gr.length && Nr.push.apply(Nr, gr), ut(Nr.length ? Nr : null);
                });
              }
            }
            var se;
            gt.asyncValidator ? se = gt.asyncValidator(gt, Je.value, Gr, Je.source, re) : gt.validator && (se = gt.validator(gt, Je.value, Gr, Je.source, re), se === true ? Gr() : se === false ? Gr(typeof gt.message == "function" ? gt.message(gt.fullField || gt.field) : gt.message || (gt.fullField || gt.field) + " fails") : se instanceof Array ? Gr(se) : se instanceof Error && Gr(se.message)), se && se.then && se.then(function() {
              return Gr();
            }, function(vt) {
              return Gr(vt);
            });
          }, function(Je) {
            ve(Je);
          }, Z);
        }, W.getType = function(D) {
          if (D.type === void 0 && D.pattern instanceof RegExp && (D.type = "pattern"), typeof D.validator != "function" && D.type && !dd.hasOwnProperty(D.type))
            throw new Error(tu("Unknown rule type %s", D.type));
          return D.type || "string";
        }, W.getValidationMethod = function(D) {
          if (typeof D.validator == "function")
            return D.validator;
          var O = Object.keys(D), F = O.indexOf("message");
          return F !== -1 && O.splice(F, 1), O.length === 1 && O[0] === "required" ? dd.required : dd[this.getType(D)] || void 0;
        }, A2;
      }();
      If.register = function(A2, W) {
        if (typeof W != "function")
          throw new Error("Cannot register a validator by type, validator is not a function");
        dd[A2] = W;
      }, If.warning = PS, If.messages = Vp, If.validators = dd;
      var Fu = "'${name}' is not a valid ${type}", pv = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: Fu, method: Fu, array: Fu, object: Fu, number: Fu, date: Fu, boolean: Fu, integer: Fu, float: Fu, regexp: Fu, email: Fu, url: Fu, hex: Fu }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
      function pd(A2, W) {
        for (var D = A2, O = 0; O < W.length; O += 1) {
          if (D == null)
            return;
          D = D[W[O]];
        }
        return D;
      }
      function jp(A2) {
        return Oe(A2) || l_(A2) || hr(A2) || Xt();
      }
      function Bp(A2, W, D, O) {
        if (!W.length)
          return D;
        var F = jp(W), B = F[0], Z = F.slice(1), re;
        return !A2 && typeof B == "number" ? re = [] : Array.isArray(A2) ? re = Na(A2) : re = pe({}, A2), O && D === void 0 && Z.length === 1 ? delete re[B][Z[0]] : re[B] = Bp(re[B], Z, D, O), re;
      }
      function gd(A2, W, D) {
        var O = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
        return W.length && O && D === void 0 && !pd(A2, W.slice(0, -1)) ? A2 : Bp(A2, W, D, O);
      }
      function Xo(A2) {
        return wm(A2);
      }
      function yd(A2, W) {
        var D = pd(A2, W);
        return D;
      }
      function Lf(A2, W, D) {
        var O = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, F = gd(A2, W, D, O);
        return F;
      }
      function y_(A2, W) {
        var D = {};
        return W.forEach(function(O) {
          var F = yd(A2, O);
          D = Lf(D, O, F);
        }), D;
      }
      function zp(A2, W) {
        return A2 && A2.some(function(D) {
          return xe(D, W);
        });
      }
      function $p(A2) {
        return pa(A2) === "object" && A2 !== null && Object.getPrototypeOf(A2) === Object.prototype;
      }
      function Wo(A2, W) {
        var D = Array.isArray(A2) ? Na(A2) : pe({}, A2);
        return W && Object.keys(W).forEach(function(O) {
          var F = D[O], B = W[O], Z = $p(F) && $p(B);
          D[O] = Z ? Wo(F, B || {}) : B;
        }), D;
      }
      function js(A2) {
        for (var W = arguments.length, D = new Array(W > 1 ? W - 1 : 0), O = 1; O < W; O++)
          D[O - 1] = arguments[O];
        return D.reduce(function(F, B) {
          return Wo(F, B);
        }, A2);
      }
      function xe(A2, W) {
        return !A2 || !W || A2.length !== W.length ? false : A2.every(function(D, O) {
          return W[O] === D;
        });
      }
      function md(A2, W) {
        if (A2 === W)
          return true;
        if (!A2 && W || A2 && !W || !A2 || !W || pa(A2) !== "object" || pa(W) !== "object")
          return false;
        var D = Object.keys(A2), O = Object.keys(W), F = new Set([].concat(Na(D), Na(O)));
        return Na(F).every(function(B) {
          var Z = A2[B], re = W[B];
          return typeof Z == "function" && typeof re == "function" ? true : Z === re;
        });
      }
      function h0(A2) {
        var W = arguments.length <= 1 ? void 0 : arguments[1];
        return W && W.target && pa(W.target) === "object" && A2 in W.target ? W.target[A2] : W;
      }
      function ul(A2, W, D) {
        var O = A2.length;
        if (W < 0 || W >= O || D < 0 || D >= O)
          return A2;
        var F = A2[W], B = W - D;
        return B > 0 ? [].concat(Na(A2.slice(0, D)), [F], Na(A2.slice(D, W)), Na(A2.slice(W + 1, O))) : B < 0 ? [].concat(Na(A2.slice(0, W)), Na(A2.slice(W + 1, D + 1)), [F], Na(A2.slice(D + 1, O))) : A2;
      }
      var oi = If;
      function kS(A2, W) {
        return A2.replace(/\$\{\w+\}/g, function(D) {
          var O = D.slice(2, -1);
          return W[O];
        });
      }
      function Am(A2, W, D, O, F) {
        return v0.apply(this, arguments);
      }
      function v0() {
        return v0 = Yo(Yn.mark(function A2(W, D, O, F, B) {
          var Z, re, ie, ve, ge, Pe, He, Qe;
          return Yn.wrap(function(Je) {
            for (; ; )
              switch (Je.prev = Je.next) {
                case 0:
                  return Z = pe({}, O), delete Z.ruleIndex, re = null, Z && Z.type === "array" && Z.defaultField && (re = Z.defaultField, delete Z.defaultField), ie = new oi(De({}, W, [Z])), ve = js({}, pv, F.validateMessages), ie.messages(ve), ge = [], Je.prev = 8, Je.next = 11, Promise.resolve(ie.validate(De({}, W, D), pe({}, F)));
                case 11:
                  Je.next = 16;
                  break;
                case 13:
                  Je.prev = 13, Je.t0 = Je.catch(8), Je.t0.errors ? ge = Je.t0.errors.map(function(ut, gt) {
                    var lr = ut.message;
                    return Q.isValidElement(lr) ? Q.cloneElement(lr, { key: "error_".concat(gt) }) : lr;
                  }) : (console.error(Je.t0), ge = [ve.default]);
                case 16:
                  if (!(!ge.length && re)) {
                    Je.next = 21;
                    break;
                  }
                  return Je.next = 19, Promise.all(D.map(function(ut, gt) {
                    return Am("".concat(W, ".").concat(gt), ut, re, F, B);
                  }));
                case 19:
                  return Pe = Je.sent, Je.abrupt("return", Pe.reduce(function(ut, gt) {
                    return [].concat(Na(ut), Na(gt));
                  }, []));
                case 21:
                  return He = pe(pe({}, O), {}, { name: W, enum: (O.enum || []).join(", ") }, B), Qe = ge.map(function(ut) {
                    return typeof ut == "string" ? kS(ut, He) : ut;
                  }), Je.abrupt("return", Qe);
                case 24:
                case "end":
                  return Je.stop();
              }
          }, A2, null, [[8, 13]]);
        })), v0.apply(this, arguments);
      }
      function gv(A2, W, D, O, F, B) {
        var Z = A2.join("."), re = D.map(function(ge, Pe) {
          var He = ge.validator, Qe = pe(pe({}, ge), {}, { ruleIndex: Pe });
          return He && (Qe.validator = function(Je, ut, gt) {
            var lr = false, tr = function() {
              for (var se = arguments.length, vt = new Array(se), Lt = 0; Lt < se; Lt++)
                vt[Lt] = arguments[Lt];
              Promise.resolve().then(function() {
                Cc(!lr, "Your validator function has already return a promise. `callback` will be ignored."), lr || gt.apply(void 0, vt);
              });
            }, Gr = He(Je, ut, tr);
            lr = Gr && typeof Gr.then == "function" && typeof Gr.catch == "function", Cc(lr, "`callback` is deprecated. Please return a promise instead."), lr && Gr.then(function() {
              gt();
            }).catch(function(se) {
              gt(se || " ");
            });
          }), Qe;
        }).sort(function(ge, Pe) {
          var He = ge.warningOnly, Qe = ge.ruleIndex, Je = Pe.warningOnly, ut = Pe.ruleIndex;
          return !!He == !!Je ? Qe - ut : He ? 1 : -1;
        }), ie;
        if (F === true)
          ie = new Promise(function() {
            var ge = Yo(Yn.mark(function Pe(He, Qe) {
              var Je, ut, gt;
              return Yn.wrap(function(lr) {
                for (; ; )
                  switch (lr.prev = lr.next) {
                    case 0:
                      Je = 0;
                    case 1:
                      if (!(Je < re.length)) {
                        lr.next = 12;
                        break;
                      }
                      return ut = re[Je], lr.next = 5, Am(Z, W, ut, O, B);
                    case 5:
                      if (gt = lr.sent, !gt.length) {
                        lr.next = 9;
                        break;
                      }
                      return Qe([{ errors: gt, rule: ut }]), lr.abrupt("return");
                    case 9:
                      Je += 1, lr.next = 1;
                      break;
                    case 12:
                      He([]);
                    case 13:
                    case "end":
                      return lr.stop();
                  }
              }, Pe);
            }));
            return function(Pe, He) {
              return ge.apply(this, arguments);
            };
          }());
        else {
          var ve = re.map(function(ge) {
            return Am(Z, W, ge, O, B).then(function(Pe) {
              return { errors: Pe, rule: ge };
            });
          });
          ie = (F ? m_(ve) : RS(ve)).then(function(ge) {
            return Promise.reject(ge);
          });
        }
        return ie.catch(function(ge) {
          return ge;
        }), ie;
      }
      function RS(A2) {
        return Tm.apply(this, arguments);
      }
      function Tm() {
        return Tm = Yo(Yn.mark(function A2(W) {
          return Yn.wrap(function(D) {
            for (; ; )
              switch (D.prev = D.next) {
                case 0:
                  return D.abrupt("return", Promise.all(W).then(function(O) {
                    var F, B = (F = []).concat.apply(F, Na(O));
                    return B;
                  }));
                case 1:
                case "end":
                  return D.stop();
              }
          }, A2);
        })), Tm.apply(this, arguments);
      }
      function m_(A2) {
        return d0.apply(this, arguments);
      }
      function d0() {
        return d0 = Yo(Yn.mark(function A2(W) {
          var D;
          return Yn.wrap(function(O) {
            for (; ; )
              switch (O.prev = O.next) {
                case 0:
                  return D = 0, O.abrupt("return", new Promise(function(F) {
                    W.forEach(function(B) {
                      B.then(function(Z) {
                        Z.errors.length && F([Z]), D += 1, D === W.length && F([]);
                      });
                    });
                  }));
                case 2:
                case "end":
                  return O.stop();
              }
          }, A2);
        })), d0.apply(this, arguments);
      }
      var FS = ["name"], fs = [];
      function b_(A2, W, D, O, F, B) {
        return typeof A2 == "function" ? A2(W, D, "source" in B ? { source: B.source } : {}) : O !== F;
      }
      var Mm = function(A2) {
        ym(D, A2);
        var W = hh(D);
        function D(O) {
          var F;
          if (Yl(this, D), F = W.call(this, O), F.state = { resetCount: 0 }, F.cancelRegisterFunc = null, F.mounted = false, F.touched = false, F.dirty = false, F.validatePromise = null, F.prevValidating = void 0, F.errors = fs, F.warnings = fs, F.cancelRegister = function() {
            var ie = F.props, ve = ie.preserve, ge = ie.isListField, Pe = ie.name;
            F.cancelRegisterFunc && F.cancelRegisterFunc(ge, ve, Xo(Pe)), F.cancelRegisterFunc = null;
          }, F.getNamePath = function() {
            var ie = F.props, ve = ie.name, ge = ie.fieldContext, Pe = ge.prefixName, He = Pe === void 0 ? [] : Pe;
            return ve !== void 0 ? [].concat(Na(He), Na(ve)) : [];
          }, F.getRules = function() {
            var ie = F.props, ve = ie.rules, ge = ve === void 0 ? [] : ve, Pe = ie.fieldContext;
            return ge.map(function(He) {
              return typeof He == "function" ? He(Pe) : He;
            });
          }, F.refresh = function() {
            !F.mounted || F.setState(function(ie) {
              var ve = ie.resetCount;
              return { resetCount: ve + 1 };
            });
          }, F.triggerMetaEvent = function(ie) {
            var ve = F.props.onMetaChange;
            ve == null || ve(pe(pe({}, F.getMeta()), {}, { destroy: ie }));
          }, F.onStoreChange = function(ie, ve, ge) {
            var Pe = F.props, He = Pe.shouldUpdate, Qe = Pe.dependencies, Je = Qe === void 0 ? [] : Qe, ut = Pe.onReset, gt = ge.store, lr = F.getNamePath(), tr = F.getValue(ie), Gr = F.getValue(gt), se = ve && zp(ve, lr);
            switch (ge.type === "valueUpdate" && ge.source === "external" && tr !== Gr && (F.touched = true, F.dirty = true, F.validatePromise = null, F.errors = fs, F.warnings = fs, F.triggerMetaEvent()), ge.type) {
              case "reset":
                if (!ve || se) {
                  F.touched = false, F.dirty = false, F.validatePromise = null, F.errors = fs, F.warnings = fs, F.triggerMetaEvent(), ut == null || ut(), F.refresh();
                  return;
                }
                break;
              case "remove": {
                if (He) {
                  F.reRender();
                  return;
                }
                break;
              }
              case "setField": {
                if (se) {
                  var vt = ge.data;
                  "touched" in vt && (F.touched = vt.touched), "validating" in vt && !("originRCField" in vt) && (F.validatePromise = vt.validating ? Promise.resolve([]) : null), "errors" in vt && (F.errors = vt.errors || fs), "warnings" in vt && (F.warnings = vt.warnings || fs), F.dirty = true, F.triggerMetaEvent(), F.reRender();
                  return;
                }
                if (He && !lr.length && b_(He, ie, gt, tr, Gr, ge)) {
                  F.reRender();
                  return;
                }
                break;
              }
              case "dependenciesUpdate": {
                var Lt = Je.map(Xo);
                if (Lt.some(function(ar) {
                  return zp(ge.relatedFields, ar);
                })) {
                  F.reRender();
                  return;
                }
                break;
              }
              default:
                if (se || (!Je.length || lr.length || He) && b_(He, ie, gt, tr, Gr, ge)) {
                  F.reRender();
                  return;
                }
                break;
            }
            He === true && F.reRender();
          }, F.validateRules = function(ie) {
            var ve = F.getNamePath(), ge = F.getValue(), Pe = Promise.resolve().then(function() {
              if (!F.mounted)
                return [];
              var He = F.props, Qe = He.validateFirst, Je = Qe === void 0 ? false : Qe, ut = He.messageVariables, gt = ie || {}, lr = gt.triggerName, tr = F.getRules();
              lr && (tr = tr.filter(function(se) {
                var vt = se.validateTrigger;
                if (!vt)
                  return true;
                var Lt = wm(vt);
                return Lt.includes(lr);
              }));
              var Gr = gv(ve, ge, tr, ie, Je, ut);
              return Gr.catch(function(se) {
                return se;
              }).then(function() {
                var se = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : fs;
                if (F.validatePromise === Pe) {
                  F.validatePromise = null;
                  var vt = [], Lt = [];
                  se.forEach(function(ar) {
                    var rr = ar.rule.warningOnly, Ct = ar.errors, Ft = Ct === void 0 ? fs : Ct;
                    rr ? Lt.push.apply(Lt, Na(Ft)) : vt.push.apply(vt, Na(Ft));
                  }), F.errors = vt, F.warnings = Lt, F.triggerMetaEvent(), F.reRender();
                }
              }), Gr;
            });
            return F.validatePromise = Pe, F.dirty = true, F.errors = fs, F.warnings = fs, F.triggerMetaEvent(), F.reRender(), Pe;
          }, F.isFieldValidating = function() {
            return !!F.validatePromise;
          }, F.isFieldTouched = function() {
            return F.touched;
          }, F.isFieldDirty = function() {
            if (F.dirty || F.props.initialValue !== void 0)
              return true;
            var ie = F.props.fieldContext, ve = ie.getInternalHooks(yu), ge = ve.getInitialValue;
            return ge(F.getNamePath()) !== void 0;
          }, F.getErrors = function() {
            return F.errors;
          }, F.getWarnings = function() {
            return F.warnings;
          }, F.isListField = function() {
            return F.props.isListField;
          }, F.isList = function() {
            return F.props.isList;
          }, F.isPreserve = function() {
            return F.props.preserve;
          }, F.getMeta = function() {
            F.prevValidating = F.isFieldValidating();
            var ie = { touched: F.isFieldTouched(), validating: F.prevValidating, errors: F.errors, warnings: F.warnings, name: F.getNamePath() };
            return ie;
          }, F.getOnlyChild = function(ie) {
            if (typeof ie == "function") {
              var ve = F.getMeta();
              return pe(pe({}, F.getOnlyChild(ie(F.getControlled(), ve, F.props.fieldContext))), {}, { isFunction: true });
            }
            var ge = _m(ie);
            return ge.length !== 1 || !Q.isValidElement(ge[0]) ? { child: ge, isFunction: false } : { child: ge[0], isFunction: false };
          }, F.getValue = function(ie) {
            var ve = F.props.fieldContext.getFieldsValue, ge = F.getNamePath();
            return yd(ie || ve(true), ge);
          }, F.getControlled = function() {
            var ie = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, ve = F.props, ge = ve.trigger, Pe = ve.validateTrigger, He = ve.getValueFromEvent, Qe = ve.normalize, Je = ve.valuePropName, ut = ve.getValueProps, gt = ve.fieldContext, lr = Pe !== void 0 ? Pe : gt.validateTrigger, tr = F.getNamePath(), Gr = gt.getInternalHooks, se = gt.getFieldsValue, vt = Gr(yu), Lt = vt.dispatch, ar = F.getValue(), rr = ut || function(Nr) {
              return De({}, Je, Nr);
            }, Ct = ie[ge], Ft = pe(pe({}, ie), rr(ar));
            Ft[ge] = function() {
              F.touched = true, F.dirty = true, F.triggerMetaEvent();
              for (var Nr, mt = arguments.length, dn = new Array(mt), fn = 0; fn < mt; fn++)
                dn[fn] = arguments[fn];
              He ? Nr = He.apply(void 0, dn) : Nr = h0.apply(void 0, [Je].concat(dn)), Qe && (Nr = Qe(Nr, ar, se(true))), Lt({ type: "updateValue", namePath: tr, value: Nr }), Ct && Ct.apply(void 0, dn);
            };
            var gr = wm(lr || []);
            return gr.forEach(function(Nr) {
              var mt = Ft[Nr];
              Ft[Nr] = function() {
                mt && mt.apply(void 0, arguments);
                var dn = F.props.rules;
                dn && dn.length && Lt({ type: "validateField", namePath: tr, triggerName: Nr });
              };
            }), Ft;
          }, O.fieldContext) {
            var B = O.fieldContext.getInternalHooks, Z = B(yu), re = Z.initEntityValue;
            re(a0(F));
          }
          return F;
        }
        return Pp(D, [{ key: "componentDidMount", value: function() {
          var O = this.props, F = O.shouldUpdate, B = O.fieldContext;
          if (this.mounted = true, B) {
            var Z = B.getInternalHooks, re = Z(yu), ie = re.registerField;
            this.cancelRegisterFunc = ie(this);
          }
          F === true && this.reRender();
        } }, { key: "componentWillUnmount", value: function() {
          this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
        } }, { key: "reRender", value: function() {
          !this.mounted || this.forceUpdate();
        } }, { key: "render", value: function() {
          var O = this.state.resetCount, F = this.props.children, B = this.getOnlyChild(F), Z = B.child, re = B.isFunction, ie;
          return re ? ie = Z : Q.isValidElement(Z) ? ie = Q.cloneElement(Z, this.getControlled(Z.props)) : (Cc(!Z, "`children` of Field is not validate ReactElement."), ie = Z), Q.createElement(Q.Fragment, { key: O }, ie);
        } }]), D;
      }(Q.Component);
      Mm.contextType = Rp, Mm.defaultProps = { trigger: "onChange", valuePropName: "value" };
      function yv(A2) {
        var W = A2.name, D = yn(A2, FS), O = Q.useContext(Rp), F = W !== void 0 ? Xo(W) : void 0, B = "keep";
        return D.isListField || (B = "_".concat((F || []).join("_"))), Q.createElement(Mm, Sa({ key: B, name: F }, D, { fieldContext: O }));
      }
      var NS = Q.createContext(null), VS = function(A2) {
        var W = A2.name, D = A2.initialValue, O = A2.children, F = A2.rules, B = A2.validateTrigger, Z = Q.useContext(Rp), re = Q.useRef({ keys: [], id: 0 }), ie = re.current, ve = Q.useMemo(function() {
          var Qe = Xo(Z.prefixName) || [];
          return [].concat(Na(Qe), Na(Xo(W)));
        }, [Z.prefixName, W]), ge = Q.useMemo(function() {
          return pe(pe({}, Z), {}, { prefixName: ve });
        }, [Z, ve]), Pe = Q.useMemo(function() {
          return { getKey: function(Qe) {
            var Je = ve.length, ut = Qe[Je];
            return [ie.keys[ut], Qe.slice(Je + 1)];
          } };
        }, [ve]);
        if (typeof O != "function")
          return Cc(false, "Form.List only accepts function as children."), null;
        var He = function(Qe, Je, ut) {
          var gt = ut.source;
          return gt === "internal" ? false : Qe !== Je;
        };
        return Q.createElement(NS.Provider, { value: Pe }, Q.createElement(Rp.Provider, { value: ge }, Q.createElement(yv, { name: [], shouldUpdate: He, rules: F, validateTrigger: B, initialValue: D, isList: true }, function(Qe, Je) {
          var ut = Qe.value, gt = ut === void 0 ? [] : ut, lr = Qe.onChange, tr = Z.getFieldValue, Gr = function() {
            var Lt = tr(ve || []);
            return Lt || [];
          }, se = { add: function(Lt, ar) {
            var rr = Gr();
            ar >= 0 && ar <= rr.length ? (ie.keys = [].concat(Na(ie.keys.slice(0, ar)), [ie.id], Na(ie.keys.slice(ar))), lr([].concat(Na(rr.slice(0, ar)), [Lt], Na(rr.slice(ar))))) : (ie.keys = [].concat(Na(ie.keys), [ie.id]), lr([].concat(Na(rr), [Lt]))), ie.id += 1;
          }, remove: function(Lt) {
            var ar = Gr(), rr = new Set(Array.isArray(Lt) ? Lt : [Lt]);
            rr.size <= 0 || (ie.keys = ie.keys.filter(function(Ct, Ft) {
              return !rr.has(Ft);
            }), lr(ar.filter(function(Ct, Ft) {
              return !rr.has(Ft);
            })));
          }, move: function(Lt, ar) {
            if (Lt !== ar) {
              var rr = Gr();
              Lt < 0 || Lt >= rr.length || ar < 0 || ar >= rr.length || (ie.keys = ul(ie.keys, Lt, ar), lr(ul(rr, Lt, ar)));
            }
          } }, vt = gt || [];
          return Array.isArray(vt) || (vt = []), O(vt.map(function(Lt, ar) {
            var rr = ie.keys[ar];
            return rr === void 0 && (ie.keys[ar] = ie.id, rr = ie.keys[ar], ie.id += 1), { name: ar, key: rr, isListField: true };
          }), se, Je);
        })));
      };
      function Of(A2) {
        var W = false, D = A2.length, O = [];
        return A2.length ? new Promise(function(F, B) {
          A2.forEach(function(Z, re) {
            Z.catch(function(ie) {
              return W = true, ie;
            }).then(function(ie) {
              D -= 1, O[re] = ie, !(D > 0) && (W && B(O), F(O));
            });
          });
        }) : Promise.resolve([]);
      }
      var __ = "__@field_split__";
      function Pm(A2) {
        return A2.map(function(W) {
          return "".concat(pa(W), ":").concat(W);
        }).join(__);
      }
      var bd = function() {
        function A2() {
          Yl(this, A2), this.kvs = /* @__PURE__ */ new Map();
        }
        return Pp(A2, [{ key: "set", value: function(W, D) {
          this.kvs.set(Pm(W), D);
        } }, { key: "get", value: function(W) {
          return this.kvs.get(Pm(W));
        } }, { key: "update", value: function(W, D) {
          var O = this.get(W), F = D(O);
          F ? this.set(W, F) : this.delete(W);
        } }, { key: "delete", value: function(W) {
          this.kvs.delete(Pm(W));
        } }, { key: "map", value: function(W) {
          return Na(this.kvs.entries()).map(function(D) {
            var O = lt2(D, 2), F = O[0], B = O[1], Z = F.split(__);
            return W({ key: Z.map(function(re) {
              var ie = re.match(/^([^:]*):(.*)$/), ve = lt2(ie, 3), ge = ve[1], Pe = ve[2];
              return ge === "number" ? Number(Pe) : Pe;
            }), value: B });
          });
        } }, { key: "toJSON", value: function() {
          var W = {};
          return this.map(function(D) {
            var O = D.key, F = D.value;
            return W[O.join(".")] = F, null;
          }), W;
        } }]), A2;
      }(), x_ = ["name", "errors"], jS = Pp(function A2(W) {
        var D = this;
        Yl(this, A2), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
          return { getFieldValue: D.getFieldValue, getFieldsValue: D.getFieldsValue, getFieldError: D.getFieldError, getFieldWarning: D.getFieldWarning, getFieldsError: D.getFieldsError, isFieldsTouched: D.isFieldsTouched, isFieldTouched: D.isFieldTouched, isFieldValidating: D.isFieldValidating, isFieldsValidating: D.isFieldsValidating, resetFields: D.resetFields, setFields: D.setFields, setFieldsValue: D.setFieldsValue, validateFields: D.validateFields, submit: D.submit, getInternalHooks: D.getInternalHooks };
        }, this.getInternalHooks = function(O) {
          return O === yu ? (D.formHooked = true, { dispatch: D.dispatch, initEntityValue: D.initEntityValue, registerField: D.registerField, useSubscribe: D.useSubscribe, setInitialValues: D.setInitialValues, setCallbacks: D.setCallbacks, setValidateMessages: D.setValidateMessages, getFields: D.getFields, setPreserve: D.setPreserve, getInitialValue: D.getInitialValue }) : (Cc(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
        }, this.useSubscribe = function(O) {
          D.subscribable = O;
        }, this.setInitialValues = function(O, F) {
          D.initialValues = O || {}, F && (D.store = js({}, O, D.store));
        }, this.getInitialValue = function(O) {
          return yd(D.initialValues, O);
        }, this.setCallbacks = function(O) {
          D.callbacks = O;
        }, this.setValidateMessages = function(O) {
          D.validateMessages = O;
        }, this.setPreserve = function(O) {
          D.preserve = O;
        }, this.timeoutId = null, this.warningUnhooked = function() {
        }, this.getFieldEntities = function() {
          var O = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
          return O ? D.fieldEntities.filter(function(F) {
            return F.getNamePath().length;
          }) : D.fieldEntities;
        }, this.getFieldsMap = function() {
          var O = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, F = new bd();
          return D.getFieldEntities(O).forEach(function(B) {
            var Z = B.getNamePath();
            F.set(Z, B);
          }), F;
        }, this.getFieldEntitiesForNamePathList = function(O) {
          if (!O)
            return D.getFieldEntities(true);
          var F = D.getFieldsMap(true);
          return O.map(function(B) {
            var Z = Xo(B);
            return F.get(Z) || { INVALIDATE_NAME_PATH: Xo(B) };
          });
        }, this.getFieldsValue = function(O, F) {
          if (D.warningUnhooked(), O === true && !F)
            return D.store;
          var B = D.getFieldEntitiesForNamePathList(Array.isArray(O) ? O : null), Z = [];
          return B.forEach(function(re) {
            var ie, ve = "INVALIDATE_NAME_PATH" in re ? re.INVALIDATE_NAME_PATH : re.getNamePath();
            if (!(!O && ((ie = re.isListField) === null || ie === void 0 ? void 0 : ie.call(re))))
              if (!F)
                Z.push(ve);
              else {
                var ge = "getMeta" in re ? re.getMeta() : null;
                F(ge) && Z.push(ve);
              }
          }), y_(D.store, Z.map(Xo));
        }, this.getFieldValue = function(O) {
          D.warningUnhooked();
          var F = Xo(O);
          return yd(D.store, F);
        }, this.getFieldsError = function(O) {
          D.warningUnhooked();
          var F = D.getFieldEntitiesForNamePathList(O);
          return F.map(function(B, Z) {
            return B && !("INVALIDATE_NAME_PATH" in B) ? { name: B.getNamePath(), errors: B.getErrors(), warnings: B.getWarnings() } : { name: Xo(O[Z]), errors: [], warnings: [] };
          });
        }, this.getFieldError = function(O) {
          D.warningUnhooked();
          var F = Xo(O), B = D.getFieldsError([F])[0];
          return B.errors;
        }, this.getFieldWarning = function(O) {
          D.warningUnhooked();
          var F = Xo(O), B = D.getFieldsError([F])[0];
          return B.warnings;
        }, this.isFieldsTouched = function() {
          D.warningUnhooked();
          for (var O = arguments.length, F = new Array(O), B = 0; B < O; B++)
            F[B] = arguments[B];
          var Z = F[0], re = F[1], ie, ve = false;
          F.length === 0 ? ie = null : F.length === 1 ? Array.isArray(Z) ? (ie = Z.map(Xo), ve = false) : (ie = null, ve = Z) : (ie = Z.map(Xo), ve = re);
          var ge = D.getFieldEntities(true), Pe = function(ut) {
            return ut.isFieldTouched();
          };
          if (!ie)
            return ve ? ge.every(Pe) : ge.some(Pe);
          var He = new bd();
          ie.forEach(function(ut) {
            He.set(ut, []);
          }), ge.forEach(function(ut) {
            var gt = ut.getNamePath();
            ie.forEach(function(lr) {
              lr.every(function(tr, Gr) {
                return gt[Gr] === tr;
              }) && He.update(lr, function(tr) {
                return [].concat(Na(tr), [ut]);
              });
            });
          });
          var Qe = function(ut) {
            return ut.some(Pe);
          }, Je = He.map(function(ut) {
            var gt = ut.value;
            return gt;
          });
          return ve ? Je.every(Qe) : Je.some(Qe);
        }, this.isFieldTouched = function(O) {
          return D.warningUnhooked(), D.isFieldsTouched([O]);
        }, this.isFieldsValidating = function(O) {
          D.warningUnhooked();
          var F = D.getFieldEntities();
          if (!O)
            return F.some(function(Z) {
              return Z.isFieldValidating();
            });
          var B = O.map(Xo);
          return F.some(function(Z) {
            var re = Z.getNamePath();
            return zp(B, re) && Z.isFieldValidating();
          });
        }, this.isFieldValidating = function(O) {
          return D.warningUnhooked(), D.isFieldsValidating([O]);
        }, this.resetWithFieldInitialValue = function() {
          var O = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, F = new bd(), B = D.getFieldEntities(true);
          B.forEach(function(ie) {
            var ve = ie.props.initialValue, ge = ie.getNamePath();
            if (ve !== void 0) {
              var Pe = F.get(ge) || /* @__PURE__ */ new Set();
              Pe.add({ entity: ie, value: ve }), F.set(ge, Pe);
            }
          });
          var Z = function(ie) {
            ie.forEach(function(ve) {
              var ge = ve.props.initialValue;
              if (ge !== void 0) {
                var Pe = ve.getNamePath(), He = D.getInitialValue(Pe);
                if (He !== void 0)
                  Cc(false, "Form already set 'initialValues' with path '".concat(Pe.join("."), "'. Field can not overwrite it."));
                else {
                  var Qe = F.get(Pe);
                  if (Qe && Qe.size > 1)
                    Cc(false, "Multiple Field with path '".concat(Pe.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                  else if (Qe) {
                    var Je = D.getFieldValue(Pe);
                    (!O.skipExist || Je === void 0) && (D.store = Lf(D.store, Pe, Na(Qe)[0].value));
                  }
                }
              }
            });
          }, re;
          O.entities ? re = O.entities : O.namePathList ? (re = [], O.namePathList.forEach(function(ie) {
            var ve = F.get(ie);
            if (ve) {
              var ge;
              (ge = re).push.apply(ge, Na(Na(ve).map(function(Pe) {
                return Pe.entity;
              })));
            }
          })) : re = B, Z(re);
        }, this.resetFields = function(O) {
          D.warningUnhooked();
          var F = D.store;
          if (!O) {
            D.store = js({}, D.initialValues), D.resetWithFieldInitialValue(), D.notifyObservers(F, null, { type: "reset" });
            return;
          }
          var B = O.map(Xo);
          B.forEach(function(Z) {
            var re = D.getInitialValue(Z);
            D.store = Lf(D.store, Z, re);
          }), D.resetWithFieldInitialValue({ namePathList: B }), D.notifyObservers(F, B, { type: "reset" });
        }, this.setFields = function(O) {
          D.warningUnhooked();
          var F = D.store;
          O.forEach(function(B) {
            var Z = B.name;
            B.errors;
            var re = yn(B, x_), ie = Xo(Z);
            "value" in re && (D.store = Lf(D.store, ie, re.value)), D.notifyObservers(F, [ie], { type: "setField", data: B });
          });
        }, this.getFields = function() {
          var O = D.getFieldEntities(true), F = O.map(function(B) {
            var Z = B.getNamePath(), re = B.getMeta(), ie = pe(pe({}, re), {}, { name: Z, value: D.getFieldValue(Z) });
            return Object.defineProperty(ie, "originRCField", { value: true }), ie;
          });
          return F;
        }, this.initEntityValue = function(O) {
          var F = O.props.initialValue;
          if (F !== void 0) {
            var B = O.getNamePath(), Z = yd(D.store, B);
            Z === void 0 && (D.store = Lf(D.store, B, F));
          }
        }, this.registerField = function(O) {
          if (D.fieldEntities.push(O), O.props.initialValue !== void 0) {
            var F = D.store;
            D.resetWithFieldInitialValue({ entities: [O], skipExist: true }), D.notifyObservers(F, [O.getNamePath()], { type: "valueUpdate", source: "internal" });
          }
          return function(B, Z) {
            var re = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
            D.fieldEntities = D.fieldEntities.filter(function(He) {
              return He !== O;
            });
            var ie = Z !== void 0 ? Z : D.preserve;
            if (ie === false && (!B || re.length > 1)) {
              var ve = O.getNamePath(), ge = B ? void 0 : yd(D.initialValues, ve);
              if (ve.length && D.getFieldValue(ve) !== ge && D.fieldEntities.every(function(He) {
                return !xe(He.getNamePath(), ve);
              })) {
                var Pe = D.store;
                D.store = Lf(Pe, ve, ge, true), D.notifyObservers(Pe, [ve], { type: "remove" }), D.triggerDependenciesUpdate(Pe, ve);
              }
            }
          };
        }, this.dispatch = function(O) {
          switch (O.type) {
            case "updateValue": {
              var F = O.namePath, B = O.value;
              D.updateValue(F, B);
              break;
            }
            case "validateField": {
              var Z = O.namePath, re = O.triggerName;
              D.validateFields([Z], { triggerName: re });
              break;
            }
          }
        }, this.notifyObservers = function(O, F, B) {
          if (D.subscribable) {
            var Z = pe(pe({}, B), {}, { store: D.getFieldsValue(true) });
            D.getFieldEntities().forEach(function(re) {
              var ie = re.onStoreChange;
              ie(O, F, Z);
            });
          } else
            D.forceRootUpdate();
        }, this.triggerDependenciesUpdate = function(O, F) {
          var B = D.getDependencyChildrenFields(F);
          return B.length && D.validateFields(B), D.notifyObservers(O, B, { type: "dependenciesUpdate", relatedFields: [F].concat(Na(B)) }), B;
        }, this.updateValue = function(O, F) {
          var B = Xo(O), Z = D.store;
          D.store = Lf(D.store, B, F), D.notifyObservers(Z, [B], { type: "valueUpdate", source: "internal" });
          var re = D.triggerDependenciesUpdate(Z, B), ie = D.callbacks.onValuesChange;
          if (ie) {
            var ve = y_(D.store, [B]);
            ie(ve, D.getFieldsValue());
          }
          D.triggerOnFieldsChange([B].concat(Na(re)));
        }, this.setFieldsValue = function(O) {
          D.warningUnhooked();
          var F = D.store;
          O && (D.store = js(D.store, O)), D.notifyObservers(F, null, { type: "valueUpdate", source: "external" });
        }, this.getDependencyChildrenFields = function(O) {
          var F = /* @__PURE__ */ new Set(), B = [], Z = new bd();
          D.getFieldEntities().forEach(function(ie) {
            var ve = ie.props.dependencies;
            (ve || []).forEach(function(ge) {
              var Pe = Xo(ge);
              Z.update(Pe, function() {
                var He = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                return He.add(ie), He;
              });
            });
          });
          var re = function ie(ve) {
            var ge = Z.get(ve) || /* @__PURE__ */ new Set();
            ge.forEach(function(Pe) {
              if (!F.has(Pe)) {
                F.add(Pe);
                var He = Pe.getNamePath();
                Pe.isFieldDirty() && He.length && (B.push(He), ie(He));
              }
            });
          };
          return re(O), B;
        }, this.triggerOnFieldsChange = function(O, F) {
          var B = D.callbacks.onFieldsChange;
          if (B) {
            var Z = D.getFields();
            if (F) {
              var re = new bd();
              F.forEach(function(ve) {
                var ge = ve.name, Pe = ve.errors;
                re.set(ge, Pe);
              }), Z.forEach(function(ve) {
                ve.errors = re.get(ve.name) || ve.errors;
              });
            }
            var ie = Z.filter(function(ve) {
              var ge = ve.name;
              return zp(O, ge);
            });
            B(ie, Z);
          }
        }, this.validateFields = function(O, F) {
          D.warningUnhooked();
          var B = !!O, Z = B ? O.map(Xo) : [], re = [];
          D.getFieldEntities(true).forEach(function(ge) {
            if (B || Z.push(ge.getNamePath()), (F == null ? void 0 : F.recursive) && B) {
              var Pe = ge.getNamePath();
              Pe.every(function(Je, ut) {
                return O[ut] === Je || O[ut] === void 0;
              }) && Z.push(Pe);
            }
            if (!(!ge.props.rules || !ge.props.rules.length)) {
              var He = ge.getNamePath();
              if (!B || zp(Z, He)) {
                var Qe = ge.validateRules(pe({ validateMessages: pe(pe({}, pv), D.validateMessages) }, F));
                re.push(Qe.then(function() {
                  return { name: He, errors: [], warnings: [] };
                }).catch(function(Je) {
                  var ut = [], gt = [];
                  return Je.forEach(function(lr) {
                    var tr = lr.rule.warningOnly, Gr = lr.errors;
                    tr ? gt.push.apply(gt, Na(Gr)) : ut.push.apply(ut, Na(Gr));
                  }), ut.length ? Promise.reject({ name: He, errors: ut, warnings: gt }) : { name: He, errors: ut, warnings: gt };
                }));
              }
            }
          });
          var ie = Of(re);
          D.lastValidatePromise = ie, ie.catch(function(ge) {
            return ge;
          }).then(function(ge) {
            var Pe = ge.map(function(He) {
              var Qe = He.name;
              return Qe;
            });
            D.notifyObservers(D.store, Pe, { type: "validateFinish" }), D.triggerOnFieldsChange(Pe, ge);
          });
          var ve = ie.then(function() {
            return D.lastValidatePromise === ie ? Promise.resolve(D.getFieldsValue(Z)) : Promise.reject([]);
          }).catch(function(ge) {
            var Pe = ge.filter(function(He) {
              return He && He.errors.length;
            });
            return Promise.reject({ values: D.getFieldsValue(Z), errorFields: Pe, outOfDate: D.lastValidatePromise !== ie });
          });
          return ve.catch(function(ge) {
            return ge;
          }), ve;
        }, this.submit = function() {
          D.warningUnhooked(), D.validateFields().then(function(O) {
            var F = D.callbacks.onFinish;
            if (F)
              try {
                F(O);
              } catch (B) {
                console.error(B);
              }
          }).catch(function(O) {
            var F = D.callbacks.onFinishFailed;
            F && F(O);
          });
        }, this.forceRootUpdate = W;
      });
      function bh(A2) {
        var W = Q.useRef(), D = Q.useState({}), O = lt2(D, 2), F = O[1];
        if (!W.current)
          if (A2)
            W.current = A2;
          else {
            var B = function() {
              F({});
            }, Z = new jS(B);
            W.current = Z.getForm();
          }
        return [W.current];
      }
      var Dm = Q.createContext({ triggerFormChange: function() {
      }, triggerFormFinish: function() {
      }, registerForm: function() {
      }, unregisterForm: function() {
      } }), BS = function(A2) {
        var W = A2.validateMessages, D = A2.onFormChange, O = A2.onFormFinish, F = A2.children, B = Q.useContext(Dm), Z = Q.useRef({});
        return Q.createElement(Dm.Provider, { value: pe(pe({}, B), {}, { validateMessages: pe(pe({}, B.validateMessages), W), triggerFormChange: function(re, ie) {
          D && D(re, { changedFields: ie, forms: Z.current }), B.triggerFormChange(re, ie);
        }, triggerFormFinish: function(re, ie) {
          O && O(re, { values: ie, forms: Z.current }), B.triggerFormFinish(re, ie);
        }, registerForm: function(re, ie) {
          re && (Z.current = pe(pe({}, Z.current), {}, De({}, re, ie))), B.registerForm(re, ie);
        }, unregisterForm: function(re) {
          var ie = pe({}, Z.current);
          delete ie[re], Z.current = ie, B.unregisterForm(re);
        } }) }, F);
      }, Ec = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], zS = function(A2, W) {
        var D = A2.name, O = A2.initialValues, F = A2.fields, B = A2.form, Z = A2.preserve, re = A2.children, ie = A2.component, ve = ie === void 0 ? "form" : ie, ge = A2.validateMessages, Pe = A2.validateTrigger, He = Pe === void 0 ? "onChange" : Pe, Qe = A2.onValuesChange, Je = A2.onFieldsChange, ut = A2.onFinish, gt = A2.onFinishFailed, lr = yn(A2, Ec), tr = Q.useContext(Dm), Gr = bh(B), se = lt2(Gr, 1), vt = se[0], Lt = vt.getInternalHooks(yu), ar = Lt.useSubscribe, rr = Lt.setInitialValues, Ct = Lt.setCallbacks, Ft = Lt.setValidateMessages, gr = Lt.setPreserve;
        Q.useImperativeHandle(W, function() {
          return vt;
        }), Q.useEffect(function() {
          return tr.registerForm(D, vt), function() {
            tr.unregisterForm(D);
          };
        }, [tr, vt, D]), Ft(pe(pe({}, tr.validateMessages), ge)), Ct({ onValuesChange: Qe, onFieldsChange: function(Wt) {
          if (tr.triggerFormChange(D, Wt), Je) {
            for (var Ut = arguments.length, Kr = new Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
              Kr[zr - 1] = arguments[zr];
            Je.apply(void 0, [Wt].concat(Kr));
          }
        }, onFinish: function(Wt) {
          tr.triggerFormFinish(D, Wt), ut && ut(Wt);
        }, onFinishFailed: gt }), gr(Z);
        var Nr = Q.useRef(null);
        rr(O, !Nr.current), Nr.current || (Nr.current = true);
        var mt = re, dn = typeof re == "function";
        if (dn) {
          var fn = vt.getFieldsValue(true);
          mt = re(fn, vt);
        }
        ar(!dn);
        var ir = Q.useRef();
        Q.useEffect(function() {
          md(ir.current || [], F || []) || vt.setFields(F || []), ir.current = F;
        }, [F, vt]);
        var Vn = Q.useMemo(function() {
          return pe(pe({}, vt), {}, { validateTrigger: He });
        }, [vt, He]), fr = Q.createElement(Rp.Provider, { value: Vn }, mt);
        return ve === false ? fr : Q.createElement(ve, Sa({}, lr, { onSubmit: function(Wt) {
          Wt.preventDefault(), Wt.stopPropagation(), vt.submit();
        }, onReset: function(Wt) {
          var Ut;
          Wt.preventDefault(), vt.resetFields(), (Ut = lr.onReset) === null || Ut === void 0 || Ut.call(lr, Wt);
        } }), fr);
      }, $S = Q.forwardRef(zS), p0 = $S;
      p0.FormProvider = BS, p0.Field = yv, p0.List = VS, p0.useForm = bh;
      var GS = function(A2, W, D) {
        Cc(A2, "[antd: ".concat(W, "] ").concat(D));
      }, WS = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, w_ = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, S_ = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, C_ = S_, US = { lang: Sa({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, w_), timePickerLocale: Sa({}, C_) }, g0 = US, ru = "${label} is not a valid ${type}", y0 = { locale: "en", Pagination: WS, DatePicker: g0, TimePicker: C_, Calendar: g0, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: ru, method: ru, array: ru, object: ru, number: ru, date: ru, boolean: ru, integer: ru, float: ru, regexp: ru, email: ru, url: ru, hex: ru }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, E_ = y0, A_ = L.createContext(void 0), HS = A_, Ac = function(A2) {
        ym(D, A2);
        var W = hh(D);
        function D() {
          return Yl(this, D), W.apply(this, arguments);
        }
        return Pp(D, [{ key: "getLocale", value: function() {
          var O = this.props, F = O.componentName, B = O.defaultLocale, Z = B || E_[F != null ? F : "global"], re = this.context, ie = F && re ? re[F] : {};
          return Sa(Sa({}, Z instanceof Function ? Z() : Z), ie || {});
        } }, { key: "getLocaleCode", value: function() {
          var O = this.context, F = O && O.locale;
          return O && O.exist && !F ? E_.locale : F;
        } }, { key: "render", value: function() {
          return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
        } }]), D;
      }(Q.Component);
      Ac.defaultProps = { componentName: "global" }, Ac.contextType = HS;
      var Im = function() {
        var A2 = Q.useContext(kf), W = A2.getPrefixCls, D = W("empty-img-default");
        return Q.createElement("svg", { className: D, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Q.createElement("g", { fill: "none", fillRule: "evenodd" }, Q.createElement("g", { transform: "translate(24 31.67)" }, Q.createElement("ellipse", { className: "".concat(D, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Q.createElement("path", { className: "".concat(D, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Q.createElement("path", { className: "".concat(D, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Q.createElement("path", { className: "".concat(D, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Q.createElement("path", { className: "".concat(D, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Q.createElement("path", { className: "".concat(D, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Q.createElement("g", { className: "".concat(D, "-g"), transform: "translate(149.65 15.383)" }, Q.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Q.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
      }, mv = Im, Zl = function() {
        var A2 = Q.useContext(kf), W = A2.getPrefixCls, D = W("empty-img-simple");
        return Q.createElement("svg", { className: D, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Q.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Q.createElement("ellipse", { className: "".concat(D, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Q.createElement("g", { className: "".concat(D, "-g"), fillRule: "nonzero" }, Q.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Q.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(D, "-path") }))));
      }, qS = Zl, m0 = globalThis && globalThis.__rest || function(A2, W) {
        var D = {};
        for (var O in A2)
          Object.prototype.hasOwnProperty.call(A2, O) && W.indexOf(O) < 0 && (D[O] = A2[O]);
        if (A2 != null && typeof Object.getOwnPropertySymbols == "function")
          for (var F = 0, O = Object.getOwnPropertySymbols(A2); F < O.length; F++)
            W.indexOf(O[F]) < 0 && Object.prototype.propertyIsEnumerable.call(A2, O[F]) && (D[O[F]] = A2[O[F]]);
        return D;
      }, b0 = Q.createElement(mv, null), bv = Q.createElement(qS, null), Hc = function(A2) {
        var W = A2.className, D = A2.prefixCls, O = A2.image, F = O === void 0 ? b0 : O, B = A2.description, Z = A2.children, re = A2.imageStyle, ie = m0(A2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), ve = Q.useContext(kf), ge = ve.getPrefixCls, Pe = ve.direction;
        return Q.createElement(Ac, { componentName: "Empty" }, function(He) {
          var Qe, Je = ge("empty", D), ut = typeof B != "undefined" ? B : He.description, gt = typeof ut == "string" ? ut : "empty", lr = null;
          return typeof F == "string" ? lr = Q.createElement("img", { alt: gt, src: F }) : lr = F, Q.createElement("div", Sa({ className: Ea(Je, (Qe = {}, De(Qe, "".concat(Je, "-normal"), F === bv), De(Qe, "".concat(Je, "-rtl"), Pe === "rtl"), Qe), W) }, ie), Q.createElement("div", { className: "".concat(Je, "-image"), style: re }, lr), ut && Q.createElement("div", { className: "".concat(Je, "-description") }, ut), Z && Q.createElement("div", { className: "".concat(Je, "-footer") }, Z));
        });
      };
      Hc.PRESENTED_IMAGE_DEFAULT = b0, Hc.PRESENTED_IMAGE_SIMPLE = bv;
      var _d = Hc, YS = function(A2) {
        return Q.createElement(Bs, null, function(W) {
          var D = W.getPrefixCls, O = D("empty");
          switch (A2) {
            case "Table":
            case "List":
              return Q.createElement(_d, { image: _d.PRESENTED_IMAGE_SIMPLE });
            case "Select":
            case "TreeSelect":
            case "Cascader":
            case "Transfer":
            case "Mentions":
              return Q.createElement(_d, { image: _d.PRESENTED_IMAGE_SIMPLE, className: "".concat(O, "-small") });
            default:
              return Q.createElement(_d, null);
          }
        });
      }, xd = YS, KS = function(A2, W) {
        return W || (A2 ? "ant-".concat(A2) : "ant");
      }, kf = Q.createContext({ getPrefixCls: KS, renderEmpty: xd }), Bs = kf.Consumer, bu = Q.createContext(void 0), _0 = bu, Tc = function(A2) {
        return +setTimeout(A2, 16);
      }, x0 = function(A2) {
        return clearTimeout(A2);
      };
      typeof window != "undefined" && "requestAnimationFrame" in window && (Tc = function(A2) {
        return window.requestAnimationFrame(A2);
      }, x0 = function(A2) {
        return window.cancelAnimationFrame(A2);
      });
      var Gp = 0, Rf = /* @__PURE__ */ new Map();
      function Wp(A2) {
        Rf.delete(A2);
      }
      function zs(A2) {
        var W = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
        Gp += 1;
        var D = Gp;
        function O(F) {
          if (F === 0)
            Wp(D), A2();
          else {
            var B = Tc(function() {
              O(F - 1);
            });
            Rf.set(D, B);
          }
        }
        return O(W), D;
      }
      zs.cancel = function(A2) {
        var W = Rf.get(A2);
        return Wp(W), x0(W);
      };
      function Up(A2, W) {
        var D = W || {}, O = D.defaultValue, F = D.value, B = D.onChange, Z = D.postState, re = Q.useState(function() {
          return F !== void 0 ? F : O !== void 0 ? typeof O == "function" ? O() : O : typeof A2 == "function" ? A2() : A2;
        }), ie = lt2(re, 2), ve = ie[0], ge = ie[1], Pe = F !== void 0 ? F : ve;
        Z && (Pe = Z(Pe));
        var He = Q.useRef(B);
        He.current = B;
        var Qe = Q.useCallback(function(ut) {
          ge(ut), Pe !== ut && He.current && He.current(ut, Pe);
        }, [Pe, He]), Je = Q.useRef(true);
        return Q.useEffect(function() {
          if (Je.current) {
            Je.current = false;
            return;
          }
          F === void 0 && ge(F);
        }, [F]), [Pe, Qe];
      }
      var Kn = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(A2) {
        var W = A2.keyCode;
        if (A2.altKey && !A2.ctrlKey || A2.metaKey || W >= Kn.F1 && W <= Kn.F12)
          return false;
        switch (W) {
          case Kn.ALT:
          case Kn.CAPS_LOCK:
          case Kn.CONTEXT_MENU:
          case Kn.CTRL:
          case Kn.DOWN:
          case Kn.END:
          case Kn.ESC:
          case Kn.HOME:
          case Kn.INSERT:
          case Kn.LEFT:
          case Kn.MAC_FF_META:
          case Kn.META:
          case Kn.NUMLOCK:
          case Kn.NUM_CENTER:
          case Kn.PAGE_DOWN:
          case Kn.PAGE_UP:
          case Kn.PAUSE:
          case Kn.PRINT_SCREEN:
          case Kn.RIGHT:
          case Kn.SHIFT:
          case Kn.UP:
          case Kn.WIN_KEY:
          case Kn.WIN_KEY_RIGHT:
            return false;
          default:
            return true;
        }
      }, isCharacterKey: function(A2) {
        if (A2 >= Kn.ZERO && A2 <= Kn.NINE || A2 >= Kn.NUM_ZERO && A2 <= Kn.NUM_MULTIPLY || A2 >= Kn.A && A2 <= Kn.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && A2 === 0)
          return true;
        switch (A2) {
          case Kn.SPACE:
          case Kn.QUESTION_MARK:
          case Kn.NUM_PLUS:
          case Kn.NUM_MINUS:
          case Kn.NUM_PERIOD:
          case Kn.NUM_DIVISION:
          case Kn.SEMICOLON:
          case Kn.DASH:
          case Kn.EQUALS:
          case Kn.COMMA:
          case Kn.PERIOD:
          case Kn.SLASH:
          case Kn.APOSTROPHE:
          case Kn.SINGLE_QUOTE:
          case Kn.OPEN_SQUARE_BRACKET:
          case Kn.BACKSLASH:
          case Kn.CLOSE_SQUARE_BRACKET:
            return true;
          default:
            return false;
        }
      } }, T_ = function() {
        for (var A2 = arguments.length, W = new Array(A2), D = 0; D < A2; D++)
          W[D] = arguments[D];
        return W;
      }, ZS = Q.isValidElement;
      function Lm(A2, W, D) {
        return ZS(A2) ? Q.cloneElement(A2, typeof D == "function" ? D(A2.props || {}) : D) : W;
      }
      function M_(A2, W) {
        return Lm(A2, A2, W);
      }
      var wd = ["xxl", "xl", "lg", "md", "sm", "xs"], Hp = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, _v = /* @__PURE__ */ new Map(), qp = -1, qc = {}, XS = { matchHandlers: {}, dispatch: function(A2) {
        return qc = A2, _v.forEach(function(W) {
          return W(qc);
        }), _v.size >= 1;
      }, subscribe: function(A2) {
        return _v.size || this.register(), qp += 1, _v.set(qp, A2), A2(qc), qp;
      }, unsubscribe: function(A2) {
        _v.delete(A2), _v.size || this.unregister();
      }, unregister: function() {
        var A2 = this;
        Object.keys(Hp).forEach(function(W) {
          var D = Hp[W], O = A2.matchHandlers[D];
          O == null || O.mql.removeListener(O == null ? void 0 : O.listener);
        }), _v.clear();
      }, register: function() {
        var A2 = this;
        Object.keys(Hp).forEach(function(W) {
          var D = Hp[W], O = function(B) {
            var Z = B.matches;
            A2.dispatch(Sa(Sa({}, qc), De({}, W, Z)));
          }, F = window.matchMedia(D);
          F.addListener(O), A2.matchHandlers[D] = { mql: F, listener: O }, O(F);
        });
      } }, P_ = XS, Om = 0, xv = {};
      function w0(A2) {
        var W = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, D = Om++, O = W;
        function F() {
          O -= 1, O <= 0 ? (A2(), delete xv[D]) : xv[D] = zs(F);
        }
        return xv[D] = zs(F), D;
      }
      w0.cancel = function(A2) {
        A2 !== void 0 && (zs.cancel(xv[A2]), delete xv[A2]);
      }, w0.ids = xv;
      var km;
      function D_(A2) {
        return !A2 || A2.offsetParent === null || A2.hidden;
      }
      function I_(A2) {
        var W = (A2 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
        return W && W[1] && W[2] && W[3] ? !(W[1] === W[2] && W[2] === W[3]) : true;
      }
      var S0 = function(A2) {
        ym(D, A2);
        var W = hh(D);
        function D() {
          var O;
          return Yl(this, D), O = W.apply(this, arguments), O.containerRef = Q.createRef(), O.animationStart = false, O.destroyed = false, O.onClick = function(F, B) {
            var Z, re, ie = O.props, ve = ie.insertExtraNode, ge = ie.disabled;
            if (!(ge || !F || D_(F) || F.className.indexOf("-leave") >= 0)) {
              O.extraNode = document.createElement("div");
              var Pe = a0(O), He = Pe.extraNode, Qe = O.context.getPrefixCls;
              He.className = "".concat(Qe(""), "-click-animating-node");
              var Je = O.getAttributeName();
              if (F.setAttribute(Je, "true"), B && B !== "#ffffff" && B !== "rgb(255, 255, 255)" && I_(B) && !/rgba\((?:\d*, ){3}0\)/.test(B) && B !== "transparent") {
                He.style.borderColor = B;
                var ut = ((Z = F.getRootNode) === null || Z === void 0 ? void 0 : Z.call(F)) || F.ownerDocument, gt = ut instanceof Document ? ut.body : (re = ut.firstChild) !== null && re !== void 0 ? re : ut;
                km = e_(`
      [`.concat(Qe(""), "-click-animating-without-extra-node='true']::after, .").concat(Qe(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(B, `;
      }`), "antd-wave", { csp: O.csp, attachTo: gt });
              }
              ve && F.appendChild(He), ["transition", "animation"].forEach(function(lr) {
                F.addEventListener("".concat(lr, "start"), O.onTransitionStart), F.addEventListener("".concat(lr, "end"), O.onTransitionEnd);
              });
            }
          }, O.onTransitionStart = function(F) {
            if (!O.destroyed) {
              var B = O.containerRef.current;
              !F || F.target !== B || O.animationStart || O.resetEffect(B);
            }
          }, O.onTransitionEnd = function(F) {
            !F || F.animationName !== "fadeEffect" || O.resetEffect(F.target);
          }, O.bindAnimationEvent = function(F) {
            if (!(!F || !F.getAttribute || F.getAttribute("disabled") || F.className.indexOf("disabled") >= 0)) {
              var B = function(Z) {
                if (!(Z.target.tagName === "INPUT" || D_(Z.target))) {
                  O.resetEffect(F);
                  var re = getComputedStyle(F).getPropertyValue("border-top-color") || getComputedStyle(F).getPropertyValue("border-color") || getComputedStyle(F).getPropertyValue("background-color");
                  O.clickWaveTimeoutId = window.setTimeout(function() {
                    return O.onClick(F, re);
                  }, 0), w0.cancel(O.animationStartId), O.animationStart = true, O.animationStartId = w0(function() {
                    O.animationStart = false;
                  }, 10);
                }
              };
              return F.addEventListener("click", B, true), { cancel: function() {
                F.removeEventListener("click", B, true);
              } };
            }
          }, O.renderWave = function(F) {
            var B = F.csp, Z = O.props.children;
            if (O.csp = B, !Q.isValidElement(Z))
              return Z;
            var re = O.containerRef;
            return yh(Z) && (re = u_(Z.ref, O.containerRef)), M_(Z, { ref: re });
          }, O;
        }
        return Pp(D, [{ key: "componentDidMount", value: function() {
          var O = this.containerRef.current;
          !O || O.nodeType !== 1 || (this.instance = this.bindAnimationEvent(O));
        } }, { key: "componentWillUnmount", value: function() {
          this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
        } }, { key: "getAttributeName", value: function() {
          var O = this.context.getPrefixCls, F = this.props.insertExtraNode;
          return F ? "".concat(O(""), "-click-animating") : "".concat(O(""), "-click-animating-without-extra-node");
        } }, { key: "resetEffect", value: function(O) {
          var F = this;
          if (!(!O || O === this.extraNode || !(O instanceof Element))) {
            var B = this.props.insertExtraNode, Z = this.getAttributeName();
            O.setAttribute(Z, "false"), km && (km.innerHTML = ""), B && this.extraNode && O.contains(this.extraNode) && O.removeChild(this.extraNode), ["transition", "animation"].forEach(function(re) {
              O.removeEventListener("".concat(re, "start"), F.onTransitionStart), O.removeEventListener("".concat(re, "end"), F.onTransitionEnd);
            });
          }
        } }, { key: "render", value: function() {
          return Q.createElement(Bs, null, this.renderWave);
        } }]), D;
      }(Q.Component);
      S0.contextType = kf;
      var Rm = { exports: {} }, wv = {};
      /** @license React v17.0.2
      * react-jsx-runtime.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var L_ = te.default, Fm = 60103;
      if (wv.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
        var Nm = Symbol.for;
        Fm = Nm("react.element"), wv.Fragment = Nm("react.fragment");
      }
      var C0 = L_.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, JS = Object.prototype.hasOwnProperty, O_ = { key: true, ref: true, __self: true, __source: true };
      function Vm(A2, W, D) {
        var O, F = {}, B = null, Z = null;
        D !== void 0 && (B = "" + D), W.key !== void 0 && (B = "" + W.key), W.ref !== void 0 && (Z = W.ref);
        for (O in W)
          JS.call(W, O) && !O_.hasOwnProperty(O) && (F[O] = W[O]);
        if (A2 && A2.defaultProps)
          for (O in W = A2.defaultProps, W)
            F[O] === void 0 && (F[O] = W[O]);
        return { $$typeof: Fm, type: A2, key: B, ref: Z, props: F, _owner: C0.current };
      }
      wv.jsx = Vm, wv.jsxs = Vm, Rm.exports = wv;
      const Sd = Rm.exports.jsx, k_ = Rm.exports.jsxs;
      var QS = L.createContext({}), p2 = QS, x2 = function() {
        return J1() && window.document.documentElement;
      }, k2, Y = function() {
        if (!x2())
          return false;
        if (k2 !== void 0)
          return k2;
        var A2 = document.createElement("div");
        return A2.style.display = "flex", A2.style.flexDirection = "column", A2.style.rowGap = "1px", A2.appendChild(document.createElement("div")), A2.appendChild(document.createElement("div")), document.body.appendChild(A2), k2 = A2.scrollHeight === 1, document.body.removeChild(A2), k2;
      }, ue = function() {
        var A2 = Q.useState(false), W = lt2(A2, 2), D = W[0], O = W[1];
        return Q.useEffect(function() {
          O(Y());
        }, []), D;
      }, me = globalThis && globalThis.__rest || function(A2, W) {
        var D = {};
        for (var O in A2)
          Object.prototype.hasOwnProperty.call(A2, O) && W.indexOf(O) < 0 && (D[O] = A2[O]);
        if (A2 != null && typeof Object.getOwnPropertySymbols == "function")
          for (var F = 0, O = Object.getOwnPropertySymbols(A2); F < O.length; F++)
            W.indexOf(O[F]) < 0 && Object.prototype.propertyIsEnumerable.call(A2, O[F]) && (D[O[F]] = A2[O[F]]);
        return D;
      };
      T_("top", "middle", "bottom", "stretch"), T_("start", "end", "center", "space-around", "space-between");
      var Ye = Q.forwardRef(function(A2, W) {
        var D, O = A2.prefixCls, F = A2.justify, B = A2.align, Z = A2.className, re = A2.style, ie = A2.children, ve = A2.gutter, ge = ve === void 0 ? 0 : ve, Pe = A2.wrap, He = me(A2, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Qe = Q.useContext(kf), Je = Qe.getPrefixCls, ut = Qe.direction, gt = Q.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), lr = lt2(gt, 2), tr = lr[0], Gr = lr[1], se = ue(), vt = Q.useRef(ge);
        Q.useEffect(function() {
          var fr = P_.subscribe(function(Wt) {
            var Ut = vt.current || 0;
            (!Array.isArray(Ut) && pa(Ut) === "object" || Array.isArray(Ut) && (pa(Ut[0]) === "object" || pa(Ut[1]) === "object")) && Gr(Wt);
          });
          return function() {
            return P_.unsubscribe(fr);
          };
        }, []);
        var Lt = function() {
          var fr = [0, 0], Wt = Array.isArray(ge) ? ge : [ge, 0];
          return Wt.forEach(function(Ut, Kr) {
            if (pa(Ut) === "object")
              for (var zr = 0; zr < wd.length; zr++) {
                var Zn = wd[zr];
                if (tr[Zn] && Ut[Zn] !== void 0) {
                  fr[Kr] = Ut[Zn];
                  break;
                }
              }
            else
              fr[Kr] = Ut || 0;
          }), fr;
        }, ar = Je("row", O), rr = Lt(), Ct = Ea(ar, (D = {}, De(D, "".concat(ar, "-no-wrap"), Pe === false), De(D, "".concat(ar, "-").concat(F), F), De(D, "".concat(ar, "-").concat(B), B), De(D, "".concat(ar, "-rtl"), ut === "rtl"), D), Z), Ft = {}, gr = rr[0] > 0 ? rr[0] / -2 : void 0, Nr = rr[1] > 0 ? rr[1] / -2 : void 0;
        if (gr && (Ft.marginLeft = gr, Ft.marginRight = gr), se) {
          var mt = lt2(rr, 2);
          Ft.rowGap = mt[1];
        } else
          Nr && (Ft.marginTop = Nr, Ft.marginBottom = Nr);
        var dn = lt2(rr, 2), fn = dn[0], ir = dn[1], Vn = Q.useMemo(function() {
          return { gutter: [fn, ir], wrap: Pe, supportFlexGap: se };
        }, [fn, ir, Pe, se]);
        return Q.createElement(p2.Provider, { value: Vn }, Q.createElement("div", Sa({}, He, { className: Ct, style: Sa(Sa({}, Ft), re), ref: W }), ie));
      });
      Ye.displayName = "Row";
      var tt = Ye, pt = globalThis && globalThis.__rest || function(A2, W) {
        var D = {};
        for (var O in A2)
          Object.prototype.hasOwnProperty.call(A2, O) && W.indexOf(O) < 0 && (D[O] = A2[O]);
        if (A2 != null && typeof Object.getOwnPropertySymbols == "function")
          for (var F = 0, O = Object.getOwnPropertySymbols(A2); F < O.length; F++)
            W.indexOf(O[F]) < 0 && Object.prototype.propertyIsEnumerable.call(A2, O[F]) && (D[O[F]] = A2[O[F]]);
        return D;
      };
      function Cr(A2) {
        return typeof A2 == "number" ? "".concat(A2, " ").concat(A2, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(A2) ? "0 0 ".concat(A2) : A2;
      }
      var Tr = ["xs", "sm", "md", "lg", "xl", "xxl"], Br = Q.forwardRef(function(A2, W) {
        var D, O = Q.useContext(kf), F = O.getPrefixCls, B = O.direction, Z = Q.useContext(p2), re = Z.gutter, ie = Z.wrap, ve = Z.supportFlexGap, ge = A2.prefixCls, Pe = A2.span, He = A2.order, Qe = A2.offset, Je = A2.push, ut = A2.pull, gt = A2.className, lr = A2.children, tr = A2.flex, Gr = A2.style, se = pt(A2, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), vt = F("col", ge), Lt = {};
        Tr.forEach(function(gr) {
          var Nr, mt = {}, dn = A2[gr];
          typeof dn == "number" ? mt.span = dn : pa(dn) === "object" && (mt = dn || {}), delete se[gr], Lt = Sa(Sa({}, Lt), (Nr = {}, De(Nr, "".concat(vt, "-").concat(gr, "-").concat(mt.span), mt.span !== void 0), De(Nr, "".concat(vt, "-").concat(gr, "-order-").concat(mt.order), mt.order || mt.order === 0), De(Nr, "".concat(vt, "-").concat(gr, "-offset-").concat(mt.offset), mt.offset || mt.offset === 0), De(Nr, "".concat(vt, "-").concat(gr, "-push-").concat(mt.push), mt.push || mt.push === 0), De(Nr, "".concat(vt, "-").concat(gr, "-pull-").concat(mt.pull), mt.pull || mt.pull === 0), De(Nr, "".concat(vt, "-rtl"), B === "rtl"), Nr));
        });
        var ar = Ea(vt, (D = {}, De(D, "".concat(vt, "-").concat(Pe), Pe !== void 0), De(D, "".concat(vt, "-order-").concat(He), He), De(D, "".concat(vt, "-offset-").concat(Qe), Qe), De(D, "".concat(vt, "-push-").concat(Je), Je), De(D, "".concat(vt, "-pull-").concat(ut), ut), D), gt, Lt), rr = {};
        if (re && re[0] > 0) {
          var Ct = re[0] / 2;
          rr.paddingLeft = Ct, rr.paddingRight = Ct;
        }
        if (re && re[1] > 0 && !ve) {
          var Ft = re[1] / 2;
          rr.paddingTop = Ft, rr.paddingBottom = Ft;
        }
        return tr && (rr.flex = Cr(tr), ie === false && !rr.minWidth && (rr.minWidth = 0)), Q.createElement("div", Sa({}, se, { style: Sa(Sa({}, rr), Gr), className: ar, ref: W }), lr);
      });
      Br.displayName = "Col";
      var Jr = Br, Ln = Q.forwardRef(function(A2, W) {
        var D, O = A2.prefixCls, F = O === void 0 ? "rc-switch" : O, B = A2.className, Z = A2.checked, re = A2.defaultChecked, ie = A2.disabled, ve = A2.loadingIcon, ge = A2.checkedChildren, Pe = A2.unCheckedChildren, He = A2.onClick, Qe = A2.onChange, Je = A2.onKeyDown, ut = yn(A2, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), gt = Up(false, { value: Z, defaultValue: re }), lr = lt2(gt, 2), tr = lr[0], Gr = lr[1];
        function se(rr, Ct) {
          var Ft = tr;
          return ie || (Ft = rr, Gr(Ft), Qe == null || Qe(Ft, Ct)), Ft;
        }
        function vt(rr) {
          rr.which === Kn.LEFT ? se(false, rr) : rr.which === Kn.RIGHT && se(true, rr), Je == null || Je(rr);
        }
        function Lt(rr) {
          var Ct = se(!tr, rr);
          He == null || He(Ct, rr);
        }
        var ar = Ea(F, B, (D = {}, De(D, "".concat(F, "-checked"), tr), De(D, "".concat(F, "-disabled"), ie), D));
        return Q.createElement("button", Object.assign({}, ut, { type: "button", role: "switch", "aria-checked": tr, disabled: ie, className: ar, ref: W, onKeyDown: vt, onClick: Lt }), ve, Q.createElement("span", { className: "".concat(F, "-inner") }, tr ? ge : Pe));
      });
      Ln.displayName = "Switch";
      var $n = globalThis && globalThis.__rest || function(A2, W) {
        var D = {};
        for (var O in A2)
          Object.prototype.hasOwnProperty.call(A2, O) && W.indexOf(O) < 0 && (D[O] = A2[O]);
        if (A2 != null && typeof Object.getOwnPropertySymbols == "function")
          for (var F = 0, O = Object.getOwnPropertySymbols(A2); F < O.length; F++)
            W.indexOf(O[F]) < 0 && Object.prototype.propertyIsEnumerable.call(A2, O[F]) && (D[O[F]] = A2[O[F]]);
        return D;
      }, _a2 = Q.forwardRef(function(A2, W) {
        var D, O = A2.prefixCls, F = A2.size, B = A2.loading, Z = A2.className, re = Z === void 0 ? "" : Z, ie = A2.disabled, ve = $n(A2, ["prefixCls", "size", "loading", "className", "disabled"]);
        GS("checked" in ve || !("value" in ve), "Switch", "`value` is not a valid prop, do you mean `checked`?");
        var ge = Q.useContext(kf), Pe = ge.getPrefixCls, He = ge.direction, Qe = Q.useContext(_0), Je = Pe("switch", O), ut = Q.createElement("div", { className: "".concat(Je, "-handle") }, B && Q.createElement(gm, { className: "".concat(Je, "-loading-icon") })), gt = Ea((D = {}, De(D, "".concat(Je, "-small"), (F || Qe) === "small"), De(D, "".concat(Je, "-loading"), B), De(D, "".concat(Je, "-rtl"), He === "rtl"), D), re);
        return Q.createElement(S0, { insertExtraNode: true }, Q.createElement(Ln, Sa({}, ve, { prefixCls: Je, className: gt, disabled: ie || B, ref: W, loadingIcon: ut })));
      });
      _a2.__ANT_SWITCH = true, _a2.displayName = "Switch";
      var Un = _a2, Ya = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, aa = { exports: {} };
      (function(A2, W) {
        (function(D, O) {
          A2.exports = O(te.default);
        })(Ae, function(D) {
          return function(O) {
            var F = {};
            function B(Z) {
              if (F[Z])
                return F[Z].exports;
              var re = F[Z] = { i: Z, l: false, exports: {} };
              return O[Z].call(re.exports, re, re.exports, B), re.l = true, re.exports;
            }
            return B.m = O, B.c = F, B.d = function(Z, re, ie) {
              B.o(Z, re) || Object.defineProperty(Z, re, { enumerable: true, get: ie });
            }, B.r = function(Z) {
              typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(Z, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(Z, "__esModule", { value: true });
            }, B.t = function(Z, re) {
              if (1 & re && (Z = B(Z)), 8 & re || 4 & re && typeof Z == "object" && Z && Z.__esModule)
                return Z;
              var ie = /* @__PURE__ */ Object.create(null);
              if (B.r(ie), Object.defineProperty(ie, "default", { enumerable: true, value: Z }), 2 & re && typeof Z != "string")
                for (var ve in Z)
                  B.d(ie, ve, function(ge) {
                    return Z[ge];
                  }.bind(null, ve));
              return ie;
            }, B.n = function(Z) {
              var re = Z && Z.__esModule ? function() {
                return Z.default;
              } : function() {
                return Z;
              };
              return B.d(re, "a", re), re;
            }, B.o = function(Z, re) {
              return Object.prototype.hasOwnProperty.call(Z, re);
            }, B.p = "", B(B.s = 48);
          }([function(O, F) {
            O.exports = D;
          }, function(O, F) {
            var B = O.exports = { version: "2.6.12" };
            typeof __e == "number" && (__e = B);
          }, function(O, F, B) {
            var Z = B(26)("wks"), re = B(17), ie = B(3).Symbol, ve = typeof ie == "function";
            (O.exports = function(ge) {
              return Z[ge] || (Z[ge] = ve && ie[ge] || (ve ? ie : re)("Symbol." + ge));
            }).store = Z;
          }, function(O, F) {
            var B = O.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
            typeof __g == "number" && (__g = B);
          }, function(O, F, B) {
            O.exports = !B(8)(function() {
              return Object.defineProperty({}, "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(O, F) {
            var B = {}.hasOwnProperty;
            O.exports = function(Z, re) {
              return B.call(Z, re);
            };
          }, function(O, F, B) {
            var Z = B(7), re = B(16);
            O.exports = B(4) ? function(ie, ve, ge) {
              return Z.f(ie, ve, re(1, ge));
            } : function(ie, ve, ge) {
              return ie[ve] = ge, ie;
            };
          }, function(O, F, B) {
            var Z = B(10), re = B(35), ie = B(23), ve = Object.defineProperty;
            F.f = B(4) ? Object.defineProperty : function(ge, Pe, He) {
              if (Z(ge), Pe = ie(Pe, true), Z(He), re)
                try {
                  return ve(ge, Pe, He);
                } catch {
                }
              if ("get" in He || "set" in He)
                throw TypeError("Accessors not supported!");
              return "value" in He && (ge[Pe] = He.value), ge;
            };
          }, function(O, F) {
            O.exports = function(B) {
              try {
                return !!B();
              } catch {
                return true;
              }
            };
          }, function(O, F, B) {
            var Z = B(40), re = B(22);
            O.exports = function(ie) {
              return Z(re(ie));
            };
          }, function(O, F, B) {
            var Z = B(11);
            O.exports = function(re) {
              if (!Z(re))
                throw TypeError(re + " is not an object!");
              return re;
            };
          }, function(O, F) {
            O.exports = function(B) {
              return typeof B == "object" ? B !== null : typeof B == "function";
            };
          }, function(O, F) {
            O.exports = {};
          }, function(O, F, B) {
            var Z = B(39), re = B(27);
            O.exports = Object.keys || function(ie) {
              return Z(ie, re);
            };
          }, function(O, F) {
            O.exports = true;
          }, function(O, F, B) {
            var Z = B(3), re = B(1), ie = B(53), ve = B(6), ge = B(5), Pe = function(He, Qe, Je) {
              var ut, gt, lr, tr = He & Pe.F, Gr = He & Pe.G, se = He & Pe.S, vt = He & Pe.P, Lt = He & Pe.B, ar = He & Pe.W, rr = Gr ? re : re[Qe] || (re[Qe] = {}), Ct = rr.prototype, Ft = Gr ? Z : se ? Z[Qe] : (Z[Qe] || {}).prototype;
              for (ut in Gr && (Je = Qe), Je)
                (gt = !tr && Ft && Ft[ut] !== void 0) && ge(rr, ut) || (lr = gt ? Ft[ut] : Je[ut], rr[ut] = Gr && typeof Ft[ut] != "function" ? Je[ut] : Lt && gt ? ie(lr, Z) : ar && Ft[ut] == lr ? function(gr) {
                  var Nr = function(mt, dn, fn) {
                    if (this instanceof gr) {
                      switch (arguments.length) {
                        case 0:
                          return new gr();
                        case 1:
                          return new gr(mt);
                        case 2:
                          return new gr(mt, dn);
                      }
                      return new gr(mt, dn, fn);
                    }
                    return gr.apply(this, arguments);
                  };
                  return Nr.prototype = gr.prototype, Nr;
                }(lr) : vt && typeof lr == "function" ? ie(Function.call, lr) : lr, vt && ((rr.virtual || (rr.virtual = {}))[ut] = lr, He & Pe.R && Ct && !Ct[ut] && ve(Ct, ut, lr)));
            };
            Pe.F = 1, Pe.G = 2, Pe.S = 4, Pe.P = 8, Pe.B = 16, Pe.W = 32, Pe.U = 64, Pe.R = 128, O.exports = Pe;
          }, function(O, F) {
            O.exports = function(B, Z) {
              return { enumerable: !(1 & B), configurable: !(2 & B), writable: !(4 & B), value: Z };
            };
          }, function(O, F) {
            var B = 0, Z = Math.random();
            O.exports = function(re) {
              return "Symbol(".concat(re === void 0 ? "" : re, ")_", (++B + Z).toString(36));
            };
          }, function(O, F, B) {
            var Z = B(22);
            O.exports = function(re) {
              return Object(Z(re));
            };
          }, function(O, F) {
            F.f = {}.propertyIsEnumerable;
          }, function(O, F, B) {
            var Z = B(52)(true);
            B(34)(String, "String", function(re) {
              this._t = String(re), this._i = 0;
            }, function() {
              var re, ie = this._t, ve = this._i;
              return ve >= ie.length ? { value: void 0, done: true } : (re = Z(ie, ve), this._i += re.length, { value: re, done: false });
            });
          }, function(O, F) {
            var B = Math.ceil, Z = Math.floor;
            O.exports = function(re) {
              return isNaN(re = +re) ? 0 : (re > 0 ? Z : B)(re);
            };
          }, function(O, F) {
            O.exports = function(B) {
              if (B == null)
                throw TypeError("Can't call method on  " + B);
              return B;
            };
          }, function(O, F, B) {
            var Z = B(11);
            O.exports = function(re, ie) {
              if (!Z(re))
                return re;
              var ve, ge;
              if (ie && typeof (ve = re.toString) == "function" && !Z(ge = ve.call(re)) || typeof (ve = re.valueOf) == "function" && !Z(ge = ve.call(re)) || !ie && typeof (ve = re.toString) == "function" && !Z(ge = ve.call(re)))
                return ge;
              throw TypeError("Can't convert object to primitive value");
            };
          }, function(O, F) {
            var B = {}.toString;
            O.exports = function(Z) {
              return B.call(Z).slice(8, -1);
            };
          }, function(O, F, B) {
            var Z = B(26)("keys"), re = B(17);
            O.exports = function(ie) {
              return Z[ie] || (Z[ie] = re(ie));
            };
          }, function(O, F, B) {
            var Z = B(1), re = B(3), ie = re["__core-js_shared__"] || (re["__core-js_shared__"] = {});
            (O.exports = function(ve, ge) {
              return ie[ve] || (ie[ve] = ge !== void 0 ? ge : {});
            })("versions", []).push({ version: Z.version, mode: B(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
          }, function(O, F) {
            O.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
          }, function(O, F, B) {
            var Z = B(7).f, re = B(5), ie = B(2)("toStringTag");
            O.exports = function(ve, ge, Pe) {
              ve && !re(ve = Pe ? ve : ve.prototype, ie) && Z(ve, ie, { configurable: true, value: ge });
            };
          }, function(O, F, B) {
            B(62);
            for (var Z = B(3), re = B(6), ie = B(12), ve = B(2)("toStringTag"), ge = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), Pe = 0; Pe < ge.length; Pe++) {
              var He = ge[Pe], Qe = Z[He], Je = Qe && Qe.prototype;
              Je && !Je[ve] && re(Je, ve, He), ie[He] = ie.Array;
            }
          }, function(O, F, B) {
            F.f = B(2);
          }, function(O, F, B) {
            var Z = B(3), re = B(1), ie = B(14), ve = B(30), ge = B(7).f;
            O.exports = function(Pe) {
              var He = re.Symbol || (re.Symbol = ie ? {} : Z.Symbol || {});
              Pe.charAt(0) == "_" || Pe in He || ge(He, Pe, { value: ve.f(Pe) });
            };
          }, function(O, F) {
            F.f = Object.getOwnPropertySymbols;
          }, function(O, F) {
            O.exports = function(B, Z, re) {
              return Math.min(Math.max(B, Z), re);
            };
          }, function(O, F, B) {
            var Z = B(14), re = B(15), ie = B(37), ve = B(6), ge = B(12), Pe = B(55), He = B(28), Qe = B(61), Je = B(2)("iterator"), ut = !([].keys && "next" in [].keys()), gt = function() {
              return this;
            };
            O.exports = function(lr, tr, Gr, se, vt, Lt, ar) {
              Pe(Gr, tr, se);
              var rr, Ct, Ft, gr = function(Ut) {
                if (!ut && Ut in fn)
                  return fn[Ut];
                switch (Ut) {
                  case "keys":
                  case "values":
                    return function() {
                      return new Gr(this, Ut);
                    };
                }
                return function() {
                  return new Gr(this, Ut);
                };
              }, Nr = tr + " Iterator", mt = vt == "values", dn = false, fn = lr.prototype, ir = fn[Je] || fn["@@iterator"] || vt && fn[vt], Vn = ir || gr(vt), fr = vt ? mt ? gr("entries") : Vn : void 0, Wt = tr == "Array" && fn.entries || ir;
              if (Wt && (Ft = Qe(Wt.call(new lr()))) !== Object.prototype && Ft.next && (He(Ft, Nr, true), Z || typeof Ft[Je] == "function" || ve(Ft, Je, gt)), mt && ir && ir.name !== "values" && (dn = true, Vn = function() {
                return ir.call(this);
              }), Z && !ar || !ut && !dn && fn[Je] || ve(fn, Je, Vn), ge[tr] = Vn, ge[Nr] = gt, vt)
                if (rr = { values: mt ? Vn : gr("values"), keys: Lt ? Vn : gr("keys"), entries: fr }, ar)
                  for (Ct in rr)
                    Ct in fn || ie(fn, Ct, rr[Ct]);
                else
                  re(re.P + re.F * (ut || dn), tr, rr);
              return rr;
            };
          }, function(O, F, B) {
            O.exports = !B(4) && !B(8)(function() {
              return Object.defineProperty(B(36)("div"), "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(O, F, B) {
            var Z = B(11), re = B(3).document, ie = Z(re) && Z(re.createElement);
            O.exports = function(ve) {
              return ie ? re.createElement(ve) : {};
            };
          }, function(O, F, B) {
            O.exports = B(6);
          }, function(O, F, B) {
            var Z = B(10), re = B(56), ie = B(27), ve = B(25)("IE_PROTO"), ge = function() {
            }, Pe = function() {
              var He, Qe = B(36)("iframe"), Je = ie.length;
              for (Qe.style.display = "none", B(60).appendChild(Qe), Qe.src = "javascript:", (He = Qe.contentWindow.document).open(), He.write("<script>document.F=Object<\/script>"), He.close(), Pe = He.F; Je--; )
                delete Pe.prototype[ie[Je]];
              return Pe();
            };
            O.exports = Object.create || function(He, Qe) {
              var Je;
              return He !== null ? (ge.prototype = Z(He), Je = new ge(), ge.prototype = null, Je[ve] = He) : Je = Pe(), Qe === void 0 ? Je : re(Je, Qe);
            };
          }, function(O, F, B) {
            var Z = B(5), re = B(9), ie = B(57)(false), ve = B(25)("IE_PROTO");
            O.exports = function(ge, Pe) {
              var He, Qe = re(ge), Je = 0, ut = [];
              for (He in Qe)
                He != ve && Z(Qe, He) && ut.push(He);
              for (; Pe.length > Je; )
                Z(Qe, He = Pe[Je++]) && (~ie(ut, He) || ut.push(He));
              return ut;
            };
          }, function(O, F, B) {
            var Z = B(24);
            O.exports = Object("z").propertyIsEnumerable(0) ? Object : function(re) {
              return Z(re) == "String" ? re.split("") : Object(re);
            };
          }, function(O, F, B) {
            var Z = B(39), re = B(27).concat("length", "prototype");
            F.f = Object.getOwnPropertyNames || function(ie) {
              return Z(ie, re);
            };
          }, function(O, F, B) {
            var Z = B(24), re = B(2)("toStringTag"), ie = Z(function() {
              return arguments;
            }()) == "Arguments";
            O.exports = function(ve) {
              var ge, Pe, He;
              return ve === void 0 ? "Undefined" : ve === null ? "Null" : typeof (Pe = function(Qe, Je) {
                try {
                  return Qe[Je];
                } catch {
                }
              }(ge = Object(ve), re)) == "string" ? Pe : ie ? Z(ge) : (He = Z(ge)) == "Object" && typeof ge.callee == "function" ? "Arguments" : He;
            };
          }, function(O, F) {
            var B;
            B = function() {
              return this;
            }();
            try {
              B = B || new Function("return this")();
            } catch {
              typeof window == "object" && (B = window);
            }
            O.exports = B;
          }, function(O, F) {
            var B = /-?\d+(\.\d+)?%?/g;
            O.exports = function(Z) {
              return Z.match(B);
            };
          }, function(O, F, B) {
            Object.defineProperty(F, "__esModule", { value: true }), F.getBase16Theme = F.createStyling = F.invertTheme = void 0;
            var Z = gt(B(49)), re = gt(B(76)), ie = gt(B(81)), ve = gt(B(89)), ge = gt(B(93)), Pe = function(Ct) {
              if (Ct && Ct.__esModule)
                return Ct;
              var Ft = {};
              if (Ct != null)
                for (var gr in Ct)
                  Object.prototype.hasOwnProperty.call(Ct, gr) && (Ft[gr] = Ct[gr]);
              return Ft.default = Ct, Ft;
            }(B(94)), He = gt(B(132)), Qe = gt(B(133)), Je = gt(B(138)), ut = B(139);
            function gt(Ct) {
              return Ct && Ct.__esModule ? Ct : { default: Ct };
            }
            var lr = Pe.default, tr = (0, ve.default)(lr), Gr = (0, Je.default)(Qe.default, ut.rgb2yuv, function(Ct) {
              var Ft, gr = (0, ie.default)(Ct, 3), Nr = gr[0], mt = gr[1], dn = gr[2];
              return [(Ft = Nr, Ft < 0.25 ? 1 : Ft < 0.5 ? 0.9 - Ft : 1.1 - Ft), mt, dn];
            }, ut.yuv2rgb, He.default), se = function(Ct) {
              return function(Ft) {
                return { className: [Ft.className, Ct.className].filter(Boolean).join(" "), style: (0, re.default)({}, Ft.style || {}, Ct.style || {}) };
              };
            }, vt = function(Ct, Ft) {
              var gr = (0, ve.default)(Ft);
              for (var Nr in Ct)
                gr.indexOf(Nr) === -1 && gr.push(Nr);
              return gr.reduce(function(mt, dn) {
                return mt[dn] = function(fn, ir) {
                  if (fn === void 0)
                    return ir;
                  if (ir === void 0)
                    return fn;
                  var Vn = fn === void 0 ? "undefined" : (0, Z.default)(fn), fr = ir === void 0 ? "undefined" : (0, Z.default)(ir);
                  switch (Vn) {
                    case "string":
                      switch (fr) {
                        case "string":
                          return [ir, fn].filter(Boolean).join(" ");
                        case "object":
                          return se({ className: fn, style: ir });
                        case "function":
                          return function(Wt) {
                            for (var Ut = arguments.length, Kr = Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
                              Kr[zr - 1] = arguments[zr];
                            return se({ className: fn })(ir.apply(void 0, [Wt].concat(Kr)));
                          };
                      }
                    case "object":
                      switch (fr) {
                        case "string":
                          return se({ className: ir, style: fn });
                        case "object":
                          return (0, re.default)({}, ir, fn);
                        case "function":
                          return function(Wt) {
                            for (var Ut = arguments.length, Kr = Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
                              Kr[zr - 1] = arguments[zr];
                            return se({ style: fn })(ir.apply(void 0, [Wt].concat(Kr)));
                          };
                      }
                    case "function":
                      switch (fr) {
                        case "string":
                          return function(Wt) {
                            for (var Ut = arguments.length, Kr = Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
                              Kr[zr - 1] = arguments[zr];
                            return fn.apply(void 0, [se(Wt)({ className: ir })].concat(Kr));
                          };
                        case "object":
                          return function(Wt) {
                            for (var Ut = arguments.length, Kr = Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
                              Kr[zr - 1] = arguments[zr];
                            return fn.apply(void 0, [se(Wt)({ style: ir })].concat(Kr));
                          };
                        case "function":
                          return function(Wt) {
                            for (var Ut = arguments.length, Kr = Array(Ut > 1 ? Ut - 1 : 0), zr = 1; zr < Ut; zr++)
                              Kr[zr - 1] = arguments[zr];
                            return fn.apply(void 0, [ir.apply(void 0, [Wt].concat(Kr))].concat(Kr));
                          };
                      }
                  }
                }(Ct[dn], Ft[dn]), mt;
              }, {});
            }, Lt = function(Ct, Ft) {
              for (var gr = arguments.length, Nr = Array(gr > 2 ? gr - 2 : 0), mt = 2; mt < gr; mt++)
                Nr[mt - 2] = arguments[mt];
              if (Ft === null)
                return Ct;
              Array.isArray(Ft) || (Ft = [Ft]);
              var dn = Ft.map(function(ir) {
                return Ct[ir];
              }).filter(Boolean), fn = dn.reduce(function(ir, Vn) {
                return typeof Vn == "string" ? ir.className = [ir.className, Vn].filter(Boolean).join(" ") : (Vn === void 0 ? "undefined" : (0, Z.default)(Vn)) === "object" ? ir.style = (0, re.default)({}, ir.style, Vn) : typeof Vn == "function" && (ir = (0, re.default)({}, ir, Vn.apply(void 0, [ir].concat(Nr)))), ir;
              }, { className: "", style: {} });
              return fn.className || delete fn.className, (0, ve.default)(fn.style).length === 0 && delete fn.style, fn;
            }, ar = F.invertTheme = function(Ct) {
              return (0, ve.default)(Ct).reduce(function(Ft, gr) {
                return Ft[gr] = /^base/.test(gr) ? Gr(Ct[gr]) : gr === "scheme" ? Ct[gr] + ":inverted" : Ct[gr], Ft;
              }, {});
            }, rr = (F.createStyling = (0, ge.default)(function(Ct) {
              for (var Ft = arguments.length, gr = Array(Ft > 3 ? Ft - 3 : 0), Nr = 3; Nr < Ft; Nr++)
                gr[Nr - 3] = arguments[Nr];
              var mt = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, dn = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, fn = mt.defaultBase16, ir = fn === void 0 ? lr : fn, Vn = mt.base16Themes, fr = Vn === void 0 ? null : Vn, Wt = rr(dn, fr);
              Wt && (dn = (0, re.default)({}, Wt, dn));
              var Ut = tr.reduce(function(gi, Ja) {
                return gi[Ja] = dn[Ja] || ir[Ja], gi;
              }, {}), Kr = (0, ve.default)(dn).reduce(function(gi, Ja) {
                return tr.indexOf(Ja) === -1 && (gi[Ja] = dn[Ja]), gi;
              }, {}), zr = Ct(Ut), Zn = vt(Kr, zr);
              return (0, ge.default)(Lt, 2).apply(void 0, [Zn].concat(gr));
            }, 3), F.getBase16Theme = function(Ct, Ft) {
              if (Ct && Ct.extend && (Ct = Ct.extend), typeof Ct == "string") {
                var gr = Ct.split(":"), Nr = (0, ie.default)(gr, 2), mt = Nr[0], dn = Nr[1];
                Ct = (Ft || {})[mt] || Pe[mt], dn === "inverted" && (Ct = ar(Ct));
              }
              return Ct && Ct.hasOwnProperty("base00") ? Ct : void 0;
            });
          }, function(O, F, B) {
            var Z, re = typeof Reflect == "object" ? Reflect : null, ie = re && typeof re.apply == "function" ? re.apply : function(se, vt, Lt) {
              return Function.prototype.apply.call(se, vt, Lt);
            };
            Z = re && typeof re.ownKeys == "function" ? re.ownKeys : Object.getOwnPropertySymbols ? function(se) {
              return Object.getOwnPropertyNames(se).concat(Object.getOwnPropertySymbols(se));
            } : function(se) {
              return Object.getOwnPropertyNames(se);
            };
            var ve = Number.isNaN || function(se) {
              return se != se;
            };
            function ge() {
              ge.init.call(this);
            }
            O.exports = ge, O.exports.once = function(se, vt) {
              return new Promise(function(Lt, ar) {
                function rr() {
                  Ct !== void 0 && se.removeListener("error", Ct), Lt([].slice.call(arguments));
                }
                var Ct;
                vt !== "error" && (Ct = function(Ft) {
                  se.removeListener(vt, rr), ar(Ft);
                }, se.once("error", Ct)), se.once(vt, rr);
              });
            }, ge.EventEmitter = ge, ge.prototype._events = void 0, ge.prototype._eventsCount = 0, ge.prototype._maxListeners = void 0;
            var Pe = 10;
            function He(se) {
              if (typeof se != "function")
                throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof se);
            }
            function Qe(se) {
              return se._maxListeners === void 0 ? ge.defaultMaxListeners : se._maxListeners;
            }
            function Je(se, vt, Lt, ar) {
              var rr, Ct, Ft, gr;
              if (He(Lt), (Ct = se._events) === void 0 ? (Ct = se._events = /* @__PURE__ */ Object.create(null), se._eventsCount = 0) : (Ct.newListener !== void 0 && (se.emit("newListener", vt, Lt.listener ? Lt.listener : Lt), Ct = se._events), Ft = Ct[vt]), Ft === void 0)
                Ft = Ct[vt] = Lt, ++se._eventsCount;
              else if (typeof Ft == "function" ? Ft = Ct[vt] = ar ? [Lt, Ft] : [Ft, Lt] : ar ? Ft.unshift(Lt) : Ft.push(Lt), (rr = Qe(se)) > 0 && Ft.length > rr && !Ft.warned) {
                Ft.warned = true;
                var Nr = new Error("Possible EventEmitter memory leak detected. " + Ft.length + " " + String(vt) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                Nr.name = "MaxListenersExceededWarning", Nr.emitter = se, Nr.type = vt, Nr.count = Ft.length, gr = Nr, console && console.warn && console.warn(gr);
              }
              return se;
            }
            function ut() {
              if (!this.fired)
                return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
            }
            function gt(se, vt, Lt) {
              var ar = { fired: false, wrapFn: void 0, target: se, type: vt, listener: Lt }, rr = ut.bind(ar);
              return rr.listener = Lt, ar.wrapFn = rr, rr;
            }
            function lr(se, vt, Lt) {
              var ar = se._events;
              if (ar === void 0)
                return [];
              var rr = ar[vt];
              return rr === void 0 ? [] : typeof rr == "function" ? Lt ? [rr.listener || rr] : [rr] : Lt ? function(Ct) {
                for (var Ft = new Array(Ct.length), gr = 0; gr < Ft.length; ++gr)
                  Ft[gr] = Ct[gr].listener || Ct[gr];
                return Ft;
              }(rr) : Gr(rr, rr.length);
            }
            function tr(se) {
              var vt = this._events;
              if (vt !== void 0) {
                var Lt = vt[se];
                if (typeof Lt == "function")
                  return 1;
                if (Lt !== void 0)
                  return Lt.length;
              }
              return 0;
            }
            function Gr(se, vt) {
              for (var Lt = new Array(vt), ar = 0; ar < vt; ++ar)
                Lt[ar] = se[ar];
              return Lt;
            }
            Object.defineProperty(ge, "defaultMaxListeners", { enumerable: true, get: function() {
              return Pe;
            }, set: function(se) {
              if (typeof se != "number" || se < 0 || ve(se))
                throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + se + ".");
              Pe = se;
            } }), ge.init = function() {
              this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
            }, ge.prototype.setMaxListeners = function(se) {
              if (typeof se != "number" || se < 0 || ve(se))
                throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + se + ".");
              return this._maxListeners = se, this;
            }, ge.prototype.getMaxListeners = function() {
              return Qe(this);
            }, ge.prototype.emit = function(se) {
              for (var vt = [], Lt = 1; Lt < arguments.length; Lt++)
                vt.push(arguments[Lt]);
              var ar = se === "error", rr = this._events;
              if (rr !== void 0)
                ar = ar && rr.error === void 0;
              else if (!ar)
                return false;
              if (ar) {
                var Ct;
                if (vt.length > 0 && (Ct = vt[0]), Ct instanceof Error)
                  throw Ct;
                var Ft = new Error("Unhandled error." + (Ct ? " (" + Ct.message + ")" : ""));
                throw Ft.context = Ct, Ft;
              }
              var gr = rr[se];
              if (gr === void 0)
                return false;
              if (typeof gr == "function")
                ie(gr, this, vt);
              else {
                var Nr = gr.length, mt = Gr(gr, Nr);
                for (Lt = 0; Lt < Nr; ++Lt)
                  ie(mt[Lt], this, vt);
              }
              return true;
            }, ge.prototype.addListener = function(se, vt) {
              return Je(this, se, vt, false);
            }, ge.prototype.on = ge.prototype.addListener, ge.prototype.prependListener = function(se, vt) {
              return Je(this, se, vt, true);
            }, ge.prototype.once = function(se, vt) {
              return He(vt), this.on(se, gt(this, se, vt)), this;
            }, ge.prototype.prependOnceListener = function(se, vt) {
              return He(vt), this.prependListener(se, gt(this, se, vt)), this;
            }, ge.prototype.removeListener = function(se, vt) {
              var Lt, ar, rr, Ct, Ft;
              if (He(vt), (ar = this._events) === void 0)
                return this;
              if ((Lt = ar[se]) === void 0)
                return this;
              if (Lt === vt || Lt.listener === vt)
                --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete ar[se], ar.removeListener && this.emit("removeListener", se, Lt.listener || vt));
              else if (typeof Lt != "function") {
                for (rr = -1, Ct = Lt.length - 1; Ct >= 0; Ct--)
                  if (Lt[Ct] === vt || Lt[Ct].listener === vt) {
                    Ft = Lt[Ct].listener, rr = Ct;
                    break;
                  }
                if (rr < 0)
                  return this;
                rr === 0 ? Lt.shift() : function(gr, Nr) {
                  for (; Nr + 1 < gr.length; Nr++)
                    gr[Nr] = gr[Nr + 1];
                  gr.pop();
                }(Lt, rr), Lt.length === 1 && (ar[se] = Lt[0]), ar.removeListener !== void 0 && this.emit("removeListener", se, Ft || vt);
              }
              return this;
            }, ge.prototype.off = ge.prototype.removeListener, ge.prototype.removeAllListeners = function(se) {
              var vt, Lt, ar;
              if ((Lt = this._events) === void 0)
                return this;
              if (Lt.removeListener === void 0)
                return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Lt[se] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Lt[se]), this;
              if (arguments.length === 0) {
                var rr, Ct = Object.keys(Lt);
                for (ar = 0; ar < Ct.length; ++ar)
                  (rr = Ct[ar]) !== "removeListener" && this.removeAllListeners(rr);
                return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
              }
              if (typeof (vt = Lt[se]) == "function")
                this.removeListener(se, vt);
              else if (vt !== void 0)
                for (ar = vt.length - 1; ar >= 0; ar--)
                  this.removeListener(se, vt[ar]);
              return this;
            }, ge.prototype.listeners = function(se) {
              return lr(this, se, true);
            }, ge.prototype.rawListeners = function(se) {
              return lr(this, se, false);
            }, ge.listenerCount = function(se, vt) {
              return typeof se.listenerCount == "function" ? se.listenerCount(vt) : tr.call(se, vt);
            }, ge.prototype.listenerCount = tr, ge.prototype.eventNames = function() {
              return this._eventsCount > 0 ? Z(this._events) : [];
            };
          }, function(O, F, B) {
            O.exports.Dispatcher = B(140);
          }, function(O, F, B) {
            O.exports = B(142);
          }, function(O, F, B) {
            F.__esModule = true;
            var Z = ve(B(50)), re = ve(B(65)), ie = typeof re.default == "function" && typeof Z.default == "symbol" ? function(ge) {
              return typeof ge;
            } : function(ge) {
              return ge && typeof re.default == "function" && ge.constructor === re.default && ge !== re.default.prototype ? "symbol" : typeof ge;
            };
            function ve(ge) {
              return ge && ge.__esModule ? ge : { default: ge };
            }
            F.default = typeof re.default == "function" && ie(Z.default) === "symbol" ? function(ge) {
              return ge === void 0 ? "undefined" : ie(ge);
            } : function(ge) {
              return ge && typeof re.default == "function" && ge.constructor === re.default && ge !== re.default.prototype ? "symbol" : ge === void 0 ? "undefined" : ie(ge);
            };
          }, function(O, F, B) {
            O.exports = { default: B(51), __esModule: true };
          }, function(O, F, B) {
            B(20), B(29), O.exports = B(30).f("iterator");
          }, function(O, F, B) {
            var Z = B(21), re = B(22);
            O.exports = function(ie) {
              return function(ve, ge) {
                var Pe, He, Qe = String(re(ve)), Je = Z(ge), ut = Qe.length;
                return Je < 0 || Je >= ut ? ie ? "" : void 0 : (Pe = Qe.charCodeAt(Je)) < 55296 || Pe > 56319 || Je + 1 === ut || (He = Qe.charCodeAt(Je + 1)) < 56320 || He > 57343 ? ie ? Qe.charAt(Je) : Pe : ie ? Qe.slice(Je, Je + 2) : He - 56320 + (Pe - 55296 << 10) + 65536;
              };
            };
          }, function(O, F, B) {
            var Z = B(54);
            O.exports = function(re, ie, ve) {
              if (Z(re), ie === void 0)
                return re;
              switch (ve) {
                case 1:
                  return function(ge) {
                    return re.call(ie, ge);
                  };
                case 2:
                  return function(ge, Pe) {
                    return re.call(ie, ge, Pe);
                  };
                case 3:
                  return function(ge, Pe, He) {
                    return re.call(ie, ge, Pe, He);
                  };
              }
              return function() {
                return re.apply(ie, arguments);
              };
            };
          }, function(O, F) {
            O.exports = function(B) {
              if (typeof B != "function")
                throw TypeError(B + " is not a function!");
              return B;
            };
          }, function(O, F, B) {
            var Z = B(38), re = B(16), ie = B(28), ve = {};
            B(6)(ve, B(2)("iterator"), function() {
              return this;
            }), O.exports = function(ge, Pe, He) {
              ge.prototype = Z(ve, { next: re(1, He) }), ie(ge, Pe + " Iterator");
            };
          }, function(O, F, B) {
            var Z = B(7), re = B(10), ie = B(13);
            O.exports = B(4) ? Object.defineProperties : function(ve, ge) {
              re(ve);
              for (var Pe, He = ie(ge), Qe = He.length, Je = 0; Qe > Je; )
                Z.f(ve, Pe = He[Je++], ge[Pe]);
              return ve;
            };
          }, function(O, F, B) {
            var Z = B(9), re = B(58), ie = B(59);
            O.exports = function(ve) {
              return function(ge, Pe, He) {
                var Qe, Je = Z(ge), ut = re(Je.length), gt = ie(He, ut);
                if (ve && Pe != Pe) {
                  for (; ut > gt; )
                    if ((Qe = Je[gt++]) != Qe)
                      return true;
                } else
                  for (; ut > gt; gt++)
                    if ((ve || gt in Je) && Je[gt] === Pe)
                      return ve || gt || 0;
                return !ve && -1;
              };
            };
          }, function(O, F, B) {
            var Z = B(21), re = Math.min;
            O.exports = function(ie) {
              return ie > 0 ? re(Z(ie), 9007199254740991) : 0;
            };
          }, function(O, F, B) {
            var Z = B(21), re = Math.max, ie = Math.min;
            O.exports = function(ve, ge) {
              return (ve = Z(ve)) < 0 ? re(ve + ge, 0) : ie(ve, ge);
            };
          }, function(O, F, B) {
            var Z = B(3).document;
            O.exports = Z && Z.documentElement;
          }, function(O, F, B) {
            var Z = B(5), re = B(18), ie = B(25)("IE_PROTO"), ve = Object.prototype;
            O.exports = Object.getPrototypeOf || function(ge) {
              return ge = re(ge), Z(ge, ie) ? ge[ie] : typeof ge.constructor == "function" && ge instanceof ge.constructor ? ge.constructor.prototype : ge instanceof Object ? ve : null;
            };
          }, function(O, F, B) {
            var Z = B(63), re = B(64), ie = B(12), ve = B(9);
            O.exports = B(34)(Array, "Array", function(ge, Pe) {
              this._t = ve(ge), this._i = 0, this._k = Pe;
            }, function() {
              var ge = this._t, Pe = this._k, He = this._i++;
              return !ge || He >= ge.length ? (this._t = void 0, re(1)) : re(0, Pe == "keys" ? He : Pe == "values" ? ge[He] : [He, ge[He]]);
            }, "values"), ie.Arguments = ie.Array, Z("keys"), Z("values"), Z("entries");
          }, function(O, F) {
            O.exports = function() {
            };
          }, function(O, F) {
            O.exports = function(B, Z) {
              return { value: Z, done: !!B };
            };
          }, function(O, F, B) {
            O.exports = { default: B(66), __esModule: true };
          }, function(O, F, B) {
            B(67), B(73), B(74), B(75), O.exports = B(1).Symbol;
          }, function(O, F, B) {
            var Z = B(3), re = B(5), ie = B(4), ve = B(15), ge = B(37), Pe = B(68).KEY, He = B(8), Qe = B(26), Je = B(28), ut = B(17), gt = B(2), lr = B(30), tr = B(31), Gr = B(69), se = B(70), vt = B(10), Lt = B(11), ar = B(18), rr = B(9), Ct = B(23), Ft = B(16), gr = B(38), Nr = B(71), mt = B(72), dn = B(32), fn = B(7), ir = B(13), Vn = mt.f, fr = fn.f, Wt = Nr.f, Ut = Z.Symbol, Kr = Z.JSON, zr = Kr && Kr.stringify, Zn = gt("_hidden"), gi = gt("toPrimitive"), Ja = {}.propertyIsEnumerable, Oa = Qe("symbol-registry"), co = Qe("symbols"), Qa = Qe("op-symbols"), Fi = Object.prototype, Jo = typeof Ut == "function" && !!dn.f, vs = Z.QObject, Xl = !vs || !vs.prototype || !vs.prototype.findChild, Yc = ie && He(function() {
              return gr(fr({}, "a", { get: function() {
                return fr(this, "a", { value: 7 }).a;
              } })).a != 7;
            }) ? function(It, Sr, rn) {
              var An = Vn(Fi, Sr);
              An && delete Fi[Sr], fr(It, Sr, rn), An && It !== Fi && fr(Fi, Sr, An);
            } : fr, $s = function(It) {
              var Sr = co[It] = gr(Ut.prototype);
              return Sr._k = It, Sr;
            }, Dl = Jo && typeof Ut.iterator == "symbol" ? function(It) {
              return typeof It == "symbol";
            } : function(It) {
              return It instanceof Ut;
            }, Ff = function(It, Sr, rn) {
              return It === Fi && Ff(Qa, Sr, rn), vt(It), Sr = Ct(Sr, true), vt(rn), re(co, Sr) ? (rn.enumerable ? (re(It, Zn) && It[Zn][Sr] && (It[Zn][Sr] = false), rn = gr(rn, { enumerable: Ft(0, false) })) : (re(It, Zn) || fr(It, Zn, Ft(1, {})), It[Zn][Sr] = true), Yc(It, Sr, rn)) : fr(It, Sr, rn);
            }, cl = function(It, Sr) {
              vt(It);
              for (var rn, An = Gr(Sr = rr(Sr)), Bn = 0, ka = An.length; ka > Bn; )
                Ff(It, rn = An[Bn++], Sr[rn]);
              return It;
            }, Nu = function(It) {
              var Sr = Ja.call(this, It = Ct(It, true));
              return !(this === Fi && re(co, It) && !re(Qa, It)) && (!(Sr || !re(this, It) || !re(co, It) || re(this, Zn) && this[Zn][It]) || Sr);
            }, Kc = function(It, Sr) {
              if (It = rr(It), Sr = Ct(Sr, true), It !== Fi || !re(co, Sr) || re(Qa, Sr)) {
                var rn = Vn(It, Sr);
                return !rn || !re(co, Sr) || re(It, Zn) && It[Zn][Sr] || (rn.enumerable = true), rn;
              }
            }, Jl = function(It) {
              for (var Sr, rn = Wt(rr(It)), An = [], Bn = 0; rn.length > Bn; )
                re(co, Sr = rn[Bn++]) || Sr == Zn || Sr == Pe || An.push(Sr);
              return An;
            }, us = function(It) {
              for (var Sr, rn = It === Fi, An = Wt(rn ? Qa : rr(It)), Bn = [], ka = 0; An.length > ka; )
                !re(co, Sr = An[ka++]) || rn && !re(Fi, Sr) || Bn.push(co[Sr]);
              return Bn;
            };
            Jo || (ge((Ut = function() {
              if (this instanceof Ut)
                throw TypeError("Symbol is not a constructor!");
              var It = ut(arguments.length > 0 ? arguments[0] : void 0), Sr = function(rn) {
                this === Fi && Sr.call(Qa, rn), re(this, Zn) && re(this[Zn], It) && (this[Zn][It] = false), Yc(this, It, Ft(1, rn));
              };
              return ie && Xl && Yc(Fi, It, { configurable: true, set: Sr }), $s(It);
            }).prototype, "toString", function() {
              return this._k;
            }), mt.f = Kc, fn.f = Ff, B(41).f = Nr.f = Jl, B(19).f = Nu, dn.f = us, ie && !B(14) && ge(Fi, "propertyIsEnumerable", Nu, true), lr.f = function(It) {
              return $s(gt(It));
            }), ve(ve.G + ve.W + ve.F * !Jo, { Symbol: Ut });
            for (var Ps = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), wo = 0; Ps.length > wo; )
              gt(Ps[wo++]);
            for (var Nn = ir(gt.store), mr = 0; Nn.length > mr; )
              tr(Nn[mr++]);
            ve(ve.S + ve.F * !Jo, "Symbol", { for: function(It) {
              return re(Oa, It += "") ? Oa[It] : Oa[It] = Ut(It);
            }, keyFor: function(It) {
              if (!Dl(It))
                throw TypeError(It + " is not a symbol!");
              for (var Sr in Oa)
                if (Oa[Sr] === It)
                  return Sr;
            }, useSetter: function() {
              Xl = true;
            }, useSimple: function() {
              Xl = false;
            } }), ve(ve.S + ve.F * !Jo, "Object", { create: function(It, Sr) {
              return Sr === void 0 ? gr(It) : cl(gr(It), Sr);
            }, defineProperty: Ff, defineProperties: cl, getOwnPropertyDescriptor: Kc, getOwnPropertyNames: Jl, getOwnPropertySymbols: us });
            var Vt = He(function() {
              dn.f(1);
            });
            ve(ve.S + ve.F * Vt, "Object", { getOwnPropertySymbols: function(It) {
              return dn.f(ar(It));
            } }), Kr && ve(ve.S + ve.F * (!Jo || He(function() {
              var It = Ut();
              return zr([It]) != "[null]" || zr({ a: It }) != "{}" || zr(Object(It)) != "{}";
            })), "JSON", { stringify: function(It) {
              for (var Sr, rn, An = [It], Bn = 1; arguments.length > Bn; )
                An.push(arguments[Bn++]);
              if (rn = Sr = An[1], (Lt(Sr) || It !== void 0) && !Dl(It))
                return se(Sr) || (Sr = function(ka, $i) {
                  if (typeof rn == "function" && ($i = rn.call(this, ka, $i)), !Dl($i))
                    return $i;
                }), An[1] = Sr, zr.apply(Kr, An);
            } }), Ut.prototype[gi] || B(6)(Ut.prototype, gi, Ut.prototype.valueOf), Je(Ut, "Symbol"), Je(Math, "Math", true), Je(Z.JSON, "JSON", true);
          }, function(O, F, B) {
            var Z = B(17)("meta"), re = B(11), ie = B(5), ve = B(7).f, ge = 0, Pe = Object.isExtensible || function() {
              return true;
            }, He = !B(8)(function() {
              return Pe(Object.preventExtensions({}));
            }), Qe = function(ut) {
              ve(ut, Z, { value: { i: "O" + ++ge, w: {} } });
            }, Je = O.exports = { KEY: Z, NEED: false, fastKey: function(ut, gt) {
              if (!re(ut))
                return typeof ut == "symbol" ? ut : (typeof ut == "string" ? "S" : "P") + ut;
              if (!ie(ut, Z)) {
                if (!Pe(ut))
                  return "F";
                if (!gt)
                  return "E";
                Qe(ut);
              }
              return ut[Z].i;
            }, getWeak: function(ut, gt) {
              if (!ie(ut, Z)) {
                if (!Pe(ut))
                  return true;
                if (!gt)
                  return false;
                Qe(ut);
              }
              return ut[Z].w;
            }, onFreeze: function(ut) {
              return He && Je.NEED && Pe(ut) && !ie(ut, Z) && Qe(ut), ut;
            } };
          }, function(O, F, B) {
            var Z = B(13), re = B(32), ie = B(19);
            O.exports = function(ve) {
              var ge = Z(ve), Pe = re.f;
              if (Pe)
                for (var He, Qe = Pe(ve), Je = ie.f, ut = 0; Qe.length > ut; )
                  Je.call(ve, He = Qe[ut++]) && ge.push(He);
              return ge;
            };
          }, function(O, F, B) {
            var Z = B(24);
            O.exports = Array.isArray || function(re) {
              return Z(re) == "Array";
            };
          }, function(O, F, B) {
            var Z = B(9), re = B(41).f, ie = {}.toString, ve = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
            O.exports.f = function(ge) {
              return ve && ie.call(ge) == "[object Window]" ? function(Pe) {
                try {
                  return re(Pe);
                } catch {
                  return ve.slice();
                }
              }(ge) : re(Z(ge));
            };
          }, function(O, F, B) {
            var Z = B(19), re = B(16), ie = B(9), ve = B(23), ge = B(5), Pe = B(35), He = Object.getOwnPropertyDescriptor;
            F.f = B(4) ? He : function(Qe, Je) {
              if (Qe = ie(Qe), Je = ve(Je, true), Pe)
                try {
                  return He(Qe, Je);
                } catch {
                }
              if (ge(Qe, Je))
                return re(!Z.f.call(Qe, Je), Qe[Je]);
            };
          }, function(O, F) {
          }, function(O, F, B) {
            B(31)("asyncIterator");
          }, function(O, F, B) {
            B(31)("observable");
          }, function(O, F, B) {
            F.__esModule = true;
            var Z, re = B(77), ie = (Z = re) && Z.__esModule ? Z : { default: Z };
            F.default = ie.default || function(ve) {
              for (var ge = 1; ge < arguments.length; ge++) {
                var Pe = arguments[ge];
                for (var He in Pe)
                  Object.prototype.hasOwnProperty.call(Pe, He) && (ve[He] = Pe[He]);
              }
              return ve;
            };
          }, function(O, F, B) {
            O.exports = { default: B(78), __esModule: true };
          }, function(O, F, B) {
            B(79), O.exports = B(1).Object.assign;
          }, function(O, F, B) {
            var Z = B(15);
            Z(Z.S + Z.F, "Object", { assign: B(80) });
          }, function(O, F, B) {
            var Z = B(4), re = B(13), ie = B(32), ve = B(19), ge = B(18), Pe = B(40), He = Object.assign;
            O.exports = !He || B(8)(function() {
              var Qe = {}, Je = {}, ut = Symbol(), gt = "abcdefghijklmnopqrst";
              return Qe[ut] = 7, gt.split("").forEach(function(lr) {
                Je[lr] = lr;
              }), He({}, Qe)[ut] != 7 || Object.keys(He({}, Je)).join("") != gt;
            }) ? function(Qe, Je) {
              for (var ut = ge(Qe), gt = arguments.length, lr = 1, tr = ie.f, Gr = ve.f; gt > lr; )
                for (var se, vt = Pe(arguments[lr++]), Lt = tr ? re(vt).concat(tr(vt)) : re(vt), ar = Lt.length, rr = 0; ar > rr; )
                  se = Lt[rr++], Z && !Gr.call(vt, se) || (ut[se] = vt[se]);
              return ut;
            } : He;
          }, function(O, F, B) {
            F.__esModule = true;
            var Z = ie(B(82)), re = ie(B(85));
            function ie(ve) {
              return ve && ve.__esModule ? ve : { default: ve };
            }
            F.default = function(ve, ge) {
              if (Array.isArray(ve))
                return ve;
              if ((0, Z.default)(Object(ve)))
                return function(Pe, He) {
                  var Qe = [], Je = true, ut = false, gt = void 0;
                  try {
                    for (var lr, tr = (0, re.default)(Pe); !(Je = (lr = tr.next()).done) && (Qe.push(lr.value), !He || Qe.length !== He); Je = true)
                      ;
                  } catch (Gr) {
                    ut = true, gt = Gr;
                  } finally {
                    try {
                      !Je && tr.return && tr.return();
                    } finally {
                      if (ut)
                        throw gt;
                    }
                  }
                  return Qe;
                }(ve, ge);
              throw new TypeError("Invalid attempt to destructure non-iterable instance");
            };
          }, function(O, F, B) {
            O.exports = { default: B(83), __esModule: true };
          }, function(O, F, B) {
            B(29), B(20), O.exports = B(84);
          }, function(O, F, B) {
            var Z = B(42), re = B(2)("iterator"), ie = B(12);
            O.exports = B(1).isIterable = function(ve) {
              var ge = Object(ve);
              return ge[re] !== void 0 || "@@iterator" in ge || ie.hasOwnProperty(Z(ge));
            };
          }, function(O, F, B) {
            O.exports = { default: B(86), __esModule: true };
          }, function(O, F, B) {
            B(29), B(20), O.exports = B(87);
          }, function(O, F, B) {
            var Z = B(10), re = B(88);
            O.exports = B(1).getIterator = function(ie) {
              var ve = re(ie);
              if (typeof ve != "function")
                throw TypeError(ie + " is not iterable!");
              return Z(ve.call(ie));
            };
          }, function(O, F, B) {
            var Z = B(42), re = B(2)("iterator"), ie = B(12);
            O.exports = B(1).getIteratorMethod = function(ve) {
              if (ve != null)
                return ve[re] || ve["@@iterator"] || ie[Z(ve)];
            };
          }, function(O, F, B) {
            O.exports = { default: B(90), __esModule: true };
          }, function(O, F, B) {
            B(91), O.exports = B(1).Object.keys;
          }, function(O, F, B) {
            var Z = B(18), re = B(13);
            B(92)("keys", function() {
              return function(ie) {
                return re(Z(ie));
              };
            });
          }, function(O, F, B) {
            var Z = B(15), re = B(1), ie = B(8);
            O.exports = function(ve, ge) {
              var Pe = (re.Object || {})[ve] || Object[ve], He = {};
              He[ve] = ge(Pe), Z(Z.S + Z.F * ie(function() {
                Pe(1);
              }), "Object", He);
            };
          }, function(O, F, B) {
            (function(Z) {
              var re = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], ie = /^\s+|\s+$/g, ve = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, ge = /\{\n\/\* \[wrapped with (.+)\] \*/, Pe = /,? & /, He = /^[-+]0x[0-9a-f]+$/i, Qe = /^0b[01]+$/i, Je = /^\[object .+?Constructor\]$/, ut = /^0o[0-7]+$/i, gt = /^(?:0|[1-9]\d*)$/, lr = parseInt, tr = typeof Z == "object" && Z && Z.Object === Object && Z, Gr = typeof self == "object" && self && self.Object === Object && self, se = tr || Gr || Function("return this")();
              function vt(mr, Vt, It) {
                switch (It.length) {
                  case 0:
                    return mr.call(Vt);
                  case 1:
                    return mr.call(Vt, It[0]);
                  case 2:
                    return mr.call(Vt, It[0], It[1]);
                  case 3:
                    return mr.call(Vt, It[0], It[1], It[2]);
                }
                return mr.apply(Vt, It);
              }
              function Lt(mr, Vt) {
                return !!(mr && mr.length) && function(It, Sr, rn) {
                  if (Sr != Sr)
                    return function(ka, $i, Fo, So) {
                      for (var ds = ka.length, Co = Fo + (So ? 1 : -1); So ? Co-- : ++Co < ds; )
                        if ($i(ka[Co], Co, ka))
                          return Co;
                      return -1;
                    }(It, ar, rn);
                  for (var An = rn - 1, Bn = It.length; ++An < Bn; )
                    if (It[An] === Sr)
                      return An;
                  return -1;
                }(mr, Vt, 0) > -1;
              }
              function ar(mr) {
                return mr != mr;
              }
              function rr(mr, Vt) {
                for (var It = mr.length, Sr = 0; It--; )
                  mr[It] === Vt && Sr++;
                return Sr;
              }
              function Ct(mr, Vt) {
                for (var It = -1, Sr = mr.length, rn = 0, An = []; ++It < Sr; ) {
                  var Bn = mr[It];
                  Bn !== Vt && Bn !== "__lodash_placeholder__" || (mr[It] = "__lodash_placeholder__", An[rn++] = It);
                }
                return An;
              }
              var Ft, gr, Nr, mt = Function.prototype, dn = Object.prototype, fn = se["__core-js_shared__"], ir = (Ft = /[^.]+$/.exec(fn && fn.keys && fn.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Ft : "", Vn = mt.toString, fr = dn.hasOwnProperty, Wt = dn.toString, Ut = RegExp("^" + Vn.call(fr).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), Kr = Object.create, zr = Math.max, Zn = Math.min, gi = (gr = $s(Object, "defineProperty"), (Nr = $s.name) && Nr.length > 2 ? gr : void 0);
              function Ja(mr) {
                return Ps(mr) ? Kr(mr) : {};
              }
              function Oa(mr) {
                return !(!Ps(mr) || function(Vt) {
                  return !!ir && ir in Vt;
                }(mr)) && (function(Vt) {
                  var It = Ps(Vt) ? Wt.call(Vt) : "";
                  return It == "[object Function]" || It == "[object GeneratorFunction]";
                }(mr) || function(Vt) {
                  var It = false;
                  if (Vt != null && typeof Vt.toString != "function")
                    try {
                      It = !!(Vt + "");
                    } catch {
                    }
                  return It;
                }(mr) ? Ut : Je).test(function(Vt) {
                  if (Vt != null) {
                    try {
                      return Vn.call(Vt);
                    } catch {
                    }
                    try {
                      return Vt + "";
                    } catch {
                    }
                  }
                  return "";
                }(mr));
              }
              function co(mr, Vt, It, Sr) {
                for (var rn = -1, An = mr.length, Bn = It.length, ka = -1, $i = Vt.length, Fo = zr(An - Bn, 0), So = Array($i + Fo), ds = !Sr; ++ka < $i; )
                  So[ka] = Vt[ka];
                for (; ++rn < Bn; )
                  (ds || rn < An) && (So[It[rn]] = mr[rn]);
                for (; Fo--; )
                  So[ka++] = mr[rn++];
                return So;
              }
              function Qa(mr, Vt, It, Sr) {
                for (var rn = -1, An = mr.length, Bn = -1, ka = It.length, $i = -1, Fo = Vt.length, So = zr(An - ka, 0), ds = Array(So + Fo), Co = !Sr; ++rn < So; )
                  ds[rn] = mr[rn];
                for (var fl = rn; ++$i < Fo; )
                  ds[fl + $i] = Vt[$i];
                for (; ++Bn < ka; )
                  (Co || rn < An) && (ds[fl + It[Bn]] = mr[rn++]);
                return ds;
              }
              function Fi(mr) {
                return function() {
                  var Vt = arguments;
                  switch (Vt.length) {
                    case 0:
                      return new mr();
                    case 1:
                      return new mr(Vt[0]);
                    case 2:
                      return new mr(Vt[0], Vt[1]);
                    case 3:
                      return new mr(Vt[0], Vt[1], Vt[2]);
                    case 4:
                      return new mr(Vt[0], Vt[1], Vt[2], Vt[3]);
                    case 5:
                      return new mr(Vt[0], Vt[1], Vt[2], Vt[3], Vt[4]);
                    case 6:
                      return new mr(Vt[0], Vt[1], Vt[2], Vt[3], Vt[4], Vt[5]);
                    case 7:
                      return new mr(Vt[0], Vt[1], Vt[2], Vt[3], Vt[4], Vt[5], Vt[6]);
                  }
                  var It = Ja(mr.prototype), Sr = mr.apply(It, Vt);
                  return Ps(Sr) ? Sr : It;
                };
              }
              function Jo(mr, Vt, It, Sr, rn, An, Bn, ka, $i, Fo) {
                var So = 128 & Vt, ds = 1 & Vt, Co = 2 & Vt, fl = 24 & Vt, Il = 512 & Vt, Gs = Co ? void 0 : Fi(mr);
                return function fo() {
                  for (var Qo = arguments.length, yi = Array(Qo), Ds = Qo; Ds--; )
                    yi[Ds] = arguments[Ds];
                  if (fl)
                    var Vu = Yc(fo), Zc = rr(yi, Vu);
                  if (Sr && (yi = co(yi, Sr, rn, fl)), An && (yi = Qa(yi, An, Bn, fl)), Qo -= Zc, fl && Qo < Fo) {
                    var _u = Ct(yi, Vu);
                    return vs(mr, Vt, Jo, fo.placeholder, It, yi, _u, ka, $i, Fo - Qo);
                  }
                  var hl = ds ? It : this, Ql = Co ? hl[mr] : mr;
                  return Qo = yi.length, ka ? yi = Nu(yi, ka) : Il && Qo > 1 && yi.reverse(), So && $i < Qo && (yi.length = $i), this && this !== se && this instanceof fo && (Ql = Gs || Fi(Ql)), Ql.apply(hl, yi);
                };
              }
              function vs(mr, Vt, It, Sr, rn, An, Bn, ka, $i, Fo) {
                var So = 8 & Vt;
                Vt |= So ? 32 : 64, 4 & (Vt &= ~(So ? 64 : 32)) || (Vt &= -4);
                var ds = It(mr, Vt, rn, So ? An : void 0, So ? Bn : void 0, So ? void 0 : An, So ? void 0 : Bn, ka, $i, Fo);
                return ds.placeholder = Sr, Kc(ds, mr, Vt);
              }
              function Xl(mr, Vt, It, Sr, rn, An, Bn, ka) {
                var $i = 2 & Vt;
                if (!$i && typeof mr != "function")
                  throw new TypeError("Expected a function");
                var Fo = Sr ? Sr.length : 0;
                if (Fo || (Vt &= -97, Sr = rn = void 0), Bn = Bn === void 0 ? Bn : zr(Nn(Bn), 0), ka = ka === void 0 ? ka : Nn(ka), Fo -= rn ? rn.length : 0, 64 & Vt) {
                  var So = Sr, ds = rn;
                  Sr = rn = void 0;
                }
                var Co = [mr, Vt, It, Sr, rn, So, ds, An, Bn, ka];
                if (mr = Co[0], Vt = Co[1], It = Co[2], Sr = Co[3], rn = Co[4], !(ka = Co[9] = Co[9] == null ? $i ? 0 : mr.length : zr(Co[9] - Fo, 0)) && 24 & Vt && (Vt &= -25), Vt && Vt != 1)
                  fl = Vt == 8 || Vt == 16 ? function(Il, Gs, fo) {
                    var Qo = Fi(Il);
                    return function yi() {
                      for (var Ds = arguments.length, Vu = Array(Ds), Zc = Ds, _u = Yc(yi); Zc--; )
                        Vu[Zc] = arguments[Zc];
                      var hl = Ds < 3 && Vu[0] !== _u && Vu[Ds - 1] !== _u ? [] : Ct(Vu, _u);
                      if ((Ds -= hl.length) < fo)
                        return vs(Il, Gs, Jo, yi.placeholder, void 0, Vu, hl, void 0, void 0, fo - Ds);
                      var Ql = this && this !== se && this instanceof yi ? Qo : Il;
                      return vt(Ql, this, Vu);
                    };
                  }(mr, Vt, ka) : Vt != 32 && Vt != 33 || rn.length ? Jo.apply(void 0, Co) : function(Il, Gs, fo, Qo) {
                    var yi = 1 & Gs, Ds = Fi(Il);
                    return function Vu() {
                      for (var Zc = -1, _u = arguments.length, hl = -1, Ql = Qo.length, Cd = Array(Ql + _u), Sv = this && this !== se && this instanceof Vu ? Ds : Il; ++hl < Ql; )
                        Cd[hl] = Qo[hl];
                      for (; _u--; )
                        Cd[hl++] = arguments[++Zc];
                      return vt(Sv, yi ? fo : this, Cd);
                    };
                  }(mr, Vt, It, Sr);
                else
                  var fl = function(Il, Gs, fo) {
                    var Qo = 1 & Gs, yi = Fi(Il);
                    return function Ds() {
                      var Vu = this && this !== se && this instanceof Ds ? yi : Il;
                      return Vu.apply(Qo ? fo : this, arguments);
                    };
                  }(mr, Vt, It);
                return Kc(fl, mr, Vt);
              }
              function Yc(mr) {
                return mr.placeholder;
              }
              function $s(mr, Vt) {
                var It = function(Sr, rn) {
                  return Sr == null ? void 0 : Sr[rn];
                }(mr, Vt);
                return Oa(It) ? It : void 0;
              }
              function Dl(mr) {
                var Vt = mr.match(ge);
                return Vt ? Vt[1].split(Pe) : [];
              }
              function Ff(mr, Vt) {
                var It = Vt.length, Sr = It - 1;
                return Vt[Sr] = (It > 1 ? "& " : "") + Vt[Sr], Vt = Vt.join(It > 2 ? ", " : " "), mr.replace(ve, `{
/* [wrapped with ` + Vt + `] */
`);
              }
              function cl(mr, Vt) {
                return !!(Vt = Vt == null ? 9007199254740991 : Vt) && (typeof mr == "number" || gt.test(mr)) && mr > -1 && mr % 1 == 0 && mr < Vt;
              }
              function Nu(mr, Vt) {
                for (var It = mr.length, Sr = Zn(Vt.length, It), rn = function(Bn, ka) {
                  var $i = -1, Fo = Bn.length;
                  for (ka || (ka = Array(Fo)); ++$i < Fo; )
                    ka[$i] = Bn[$i];
                  return ka;
                }(mr); Sr--; ) {
                  var An = Vt[Sr];
                  mr[Sr] = cl(An, It) ? rn[An] : void 0;
                }
                return mr;
              }
              var Kc = gi ? function(mr, Vt, It) {
                var Sr, rn = Vt + "";
                return gi(mr, "toString", { configurable: true, enumerable: false, value: (Sr = Ff(rn, Jl(Dl(rn), It)), function() {
                  return Sr;
                }) });
              } : function(mr) {
                return mr;
              };
              function Jl(mr, Vt) {
                return function(It, Sr) {
                  for (var rn = -1, An = It ? It.length : 0; ++rn < An && Sr(It[rn], rn, It) !== false; )
                    ;
                }(re, function(It) {
                  var Sr = "_." + It[0];
                  Vt & It[1] && !Lt(mr, Sr) && mr.push(Sr);
                }), mr.sort();
              }
              function us(mr, Vt, It) {
                var Sr = Xl(mr, 8, void 0, void 0, void 0, void 0, void 0, Vt = It ? void 0 : Vt);
                return Sr.placeholder = us.placeholder, Sr;
              }
              function Ps(mr) {
                var Vt = typeof mr;
                return !!mr && (Vt == "object" || Vt == "function");
              }
              function wo(mr) {
                return mr ? (mr = function(Vt) {
                  if (typeof Vt == "number")
                    return Vt;
                  if (function(rn) {
                    return typeof rn == "symbol" || function(An) {
                      return !!An && typeof An == "object";
                    }(rn) && Wt.call(rn) == "[object Symbol]";
                  }(Vt))
                    return NaN;
                  if (Ps(Vt)) {
                    var It = typeof Vt.valueOf == "function" ? Vt.valueOf() : Vt;
                    Vt = Ps(It) ? It + "" : It;
                  }
                  if (typeof Vt != "string")
                    return Vt === 0 ? Vt : +Vt;
                  Vt = Vt.replace(ie, "");
                  var Sr = Qe.test(Vt);
                  return Sr || ut.test(Vt) ? lr(Vt.slice(2), Sr ? 2 : 8) : He.test(Vt) ? NaN : +Vt;
                }(mr)) === 1 / 0 || mr === -1 / 0 ? 17976931348623157e292 * (mr < 0 ? -1 : 1) : mr == mr ? mr : 0 : mr === 0 ? mr : 0;
              }
              function Nn(mr) {
                var Vt = wo(mr), It = Vt % 1;
                return Vt == Vt ? It ? Vt - It : Vt : 0;
              }
              us.placeholder = {}, O.exports = us;
            }).call(this, B(43));
          }, function(O, F, B) {
            function Z(Qa) {
              return Qa && Qa.__esModule ? Qa.default : Qa;
            }
            F.__esModule = true;
            var re = B(95);
            F.threezerotwofour = Z(re);
            var ie = B(96);
            F.apathy = Z(ie);
            var ve = B(97);
            F.ashes = Z(ve);
            var ge = B(98);
            F.atelierDune = Z(ge);
            var Pe = B(99);
            F.atelierForest = Z(Pe);
            var He = B(100);
            F.atelierHeath = Z(He);
            var Qe = B(101);
            F.atelierLakeside = Z(Qe);
            var Je = B(102);
            F.atelierSeaside = Z(Je);
            var ut = B(103);
            F.bespin = Z(ut);
            var gt = B(104);
            F.brewer = Z(gt);
            var lr = B(105);
            F.bright = Z(lr);
            var tr = B(106);
            F.chalk = Z(tr);
            var Gr = B(107);
            F.codeschool = Z(Gr);
            var se = B(108);
            F.colors = Z(se);
            var vt = B(109);
            F.default = Z(vt);
            var Lt = B(110);
            F.eighties = Z(Lt);
            var ar = B(111);
            F.embers = Z(ar);
            var rr = B(112);
            F.flat = Z(rr);
            var Ct = B(113);
            F.google = Z(Ct);
            var Ft = B(114);
            F.grayscale = Z(Ft);
            var gr = B(115);
            F.greenscreen = Z(gr);
            var Nr = B(116);
            F.harmonic = Z(Nr);
            var mt = B(117);
            F.hopscotch = Z(mt);
            var dn = B(118);
            F.isotope = Z(dn);
            var fn = B(119);
            F.marrakesh = Z(fn);
            var ir = B(120);
            F.mocha = Z(ir);
            var Vn = B(121);
            F.monokai = Z(Vn);
            var fr = B(122);
            F.ocean = Z(fr);
            var Wt = B(123);
            F.paraiso = Z(Wt);
            var Ut = B(124);
            F.pop = Z(Ut);
            var Kr = B(125);
            F.railscasts = Z(Kr);
            var zr = B(126);
            F.shapeshifter = Z(zr);
            var Zn = B(127);
            F.solarized = Z(Zn);
            var gi = B(128);
            F.summerfruit = Z(gi);
            var Ja = B(129);
            F.tomorrow = Z(Ja);
            var Oa = B(130);
            F.tube = Z(Oa);
            var co = B(131);
            F.twilight = Z(co);
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, O.exports = F.default;
          }, function(O, F, B) {
            F.__esModule = true, F.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, O.exports = F.default;
          }, function(O, F, B) {
            var Z = B(33);
            function re(ie) {
              var ve = Math.round(Z(ie, 0, 255)).toString(16);
              return ve.length == 1 ? "0" + ve : ve;
            }
            O.exports = function(ie) {
              var ve = ie.length === 4 ? re(255 * ie[3]) : "";
              return "#" + re(ie[0]) + re(ie[1]) + re(ie[2]) + ve;
            };
          }, function(O, F, B) {
            var Z = B(134), re = B(135), ie = B(136), ve = B(137), ge = { "#": re, hsl: function(He) {
              var Qe = Z(He), Je = ve(Qe);
              return Qe.length === 4 && Je.push(Qe[3]), Je;
            }, rgb: ie };
            function Pe(He) {
              for (var Qe in ge)
                if (He.indexOf(Qe) === 0)
                  return ge[Qe](He);
            }
            Pe.rgb = ie, Pe.hsl = Z, Pe.hex = re, O.exports = Pe;
          }, function(O, F, B) {
            var Z = B(44), re = B(33);
            function ie(ve, ge) {
              switch (ve = parseFloat(ve), ge) {
                case 0:
                  return re(ve, 0, 360);
                case 1:
                case 2:
                  return re(ve, 0, 100);
                case 3:
                  return re(ve, 0, 1);
              }
            }
            O.exports = function(ve) {
              return Z(ve).map(ie);
            };
          }, function(O, F) {
            O.exports = function(B) {
              B.length !== 4 && B.length !== 5 || (B = function(ie) {
                for (var ve = "#", ge = 1; ge < ie.length; ge++) {
                  var Pe = ie.charAt(ge);
                  ve += Pe + Pe;
                }
                return ve;
              }(B));
              var Z = [parseInt(B.substring(1, 3), 16), parseInt(B.substring(3, 5), 16), parseInt(B.substring(5, 7), 16)];
              if (B.length === 9) {
                var re = parseFloat((parseInt(B.substring(7, 9), 16) / 255).toFixed(2));
                Z.push(re);
              }
              return Z;
            };
          }, function(O, F, B) {
            var Z = B(44), re = B(33);
            function ie(ve, ge) {
              return ge < 3 ? ve.indexOf("%") != -1 ? Math.round(255 * re(parseInt(ve, 10), 0, 100) / 100) : re(parseInt(ve, 10), 0, 255) : re(parseFloat(ve), 0, 1);
            }
            O.exports = function(ve) {
              return Z(ve).map(ie);
            };
          }, function(O, F) {
            O.exports = function(B) {
              var Z, re, ie, ve, ge, Pe = B[0] / 360, He = B[1] / 100, Qe = B[2] / 100;
              if (He == 0)
                return [ge = 255 * Qe, ge, ge];
              Z = 2 * Qe - (re = Qe < 0.5 ? Qe * (1 + He) : Qe + He - Qe * He), ve = [0, 0, 0];
              for (var Je = 0; Je < 3; Je++)
                (ie = Pe + 1 / 3 * -(Je - 1)) < 0 && ie++, ie > 1 && ie--, ge = 6 * ie < 1 ? Z + 6 * (re - Z) * ie : 2 * ie < 1 ? re : 3 * ie < 2 ? Z + (re - Z) * (2 / 3 - ie) * 6 : Z, ve[Je] = 255 * ge;
              return ve;
            };
          }, function(O, F, B) {
            (function(Z) {
              var re = typeof Z == "object" && Z && Z.Object === Object && Z, ie = typeof self == "object" && self && self.Object === Object && self, ve = re || ie || Function("return this")();
              function ge(Ct, Ft, gr) {
                switch (gr.length) {
                  case 0:
                    return Ct.call(Ft);
                  case 1:
                    return Ct.call(Ft, gr[0]);
                  case 2:
                    return Ct.call(Ft, gr[0], gr[1]);
                  case 3:
                    return Ct.call(Ft, gr[0], gr[1], gr[2]);
                }
                return Ct.apply(Ft, gr);
              }
              function Pe(Ct, Ft) {
                for (var gr = -1, Nr = Ft.length, mt = Ct.length; ++gr < Nr; )
                  Ct[mt + gr] = Ft[gr];
                return Ct;
              }
              var He = Object.prototype, Qe = He.hasOwnProperty, Je = He.toString, ut = ve.Symbol, gt = He.propertyIsEnumerable, lr = ut ? ut.isConcatSpreadable : void 0, tr = Math.max;
              function Gr(Ct) {
                return se(Ct) || function(Ft) {
                  return function(gr) {
                    return function(Nr) {
                      return !!Nr && typeof Nr == "object";
                    }(gr) && function(Nr) {
                      return Nr != null && function(mt) {
                        return typeof mt == "number" && mt > -1 && mt % 1 == 0 && mt <= 9007199254740991;
                      }(Nr.length) && !function(mt) {
                        var dn = function(fn) {
                          var ir = typeof fn;
                          return !!fn && (ir == "object" || ir == "function");
                        }(mt) ? Je.call(mt) : "";
                        return dn == "[object Function]" || dn == "[object GeneratorFunction]";
                      }(Nr);
                    }(gr);
                  }(Ft) && Qe.call(Ft, "callee") && (!gt.call(Ft, "callee") || Je.call(Ft) == "[object Arguments]");
                }(Ct) || !!(lr && Ct && Ct[lr]);
              }
              var se = Array.isArray, vt, Lt, ar, rr = (Lt = function(Ct) {
                var Ft = (Ct = function Nr(mt, dn, fn, ir, Vn) {
                  var fr = -1, Wt = mt.length;
                  for (fn || (fn = Gr), Vn || (Vn = []); ++fr < Wt; ) {
                    var Ut = mt[fr];
                    dn > 0 && fn(Ut) ? dn > 1 ? Nr(Ut, dn - 1, fn, ir, Vn) : Pe(Vn, Ut) : ir || (Vn[Vn.length] = Ut);
                  }
                  return Vn;
                }(Ct, 1)).length, gr = Ft;
                for (vt; gr--; )
                  if (typeof Ct[gr] != "function")
                    throw new TypeError("Expected a function");
                return function() {
                  for (var Nr = 0, mt = Ft ? Ct[Nr].apply(this, arguments) : arguments[0]; ++Nr < Ft; )
                    mt = Ct[Nr].call(this, mt);
                  return mt;
                };
              }, ar = tr(ar === void 0 ? Lt.length - 1 : ar, 0), function() {
                for (var Ct = arguments, Ft = -1, gr = tr(Ct.length - ar, 0), Nr = Array(gr); ++Ft < gr; )
                  Nr[Ft] = Ct[ar + Ft];
                Ft = -1;
                for (var mt = Array(ar + 1); ++Ft < ar; )
                  mt[Ft] = Ct[Ft];
                return mt[ar] = Nr, ge(Lt, this, mt);
              });
              O.exports = rr;
            }).call(this, B(43));
          }, function(O, F, B) {
            Object.defineProperty(F, "__esModule", { value: true }), F.yuv2rgb = function(Z) {
              var re, ie, ve, ge = Z[0], Pe = Z[1], He = Z[2];
              return re = 1 * ge + 0 * Pe + 1.13983 * He, ie = 1 * ge + -0.39465 * Pe + -0.5806 * He, ve = 1 * ge + 2.02311 * Pe + 0 * He, re = Math.min(Math.max(0, re), 1), ie = Math.min(Math.max(0, ie), 1), ve = Math.min(Math.max(0, ve), 1), [255 * re, 255 * ie, 255 * ve];
            }, F.rgb2yuv = function(Z) {
              var re = Z[0] / 255, ie = Z[1] / 255, ve = Z[2] / 255;
              return [0.299 * re + 0.587 * ie + 0.114 * ve, -0.14713 * re + -0.28886 * ie + 0.436 * ve, 0.615 * re + -0.51499 * ie + -0.10001 * ve];
            };
          }, function(O, F, B) {
            function Z(ve, ge, Pe) {
              return ge in ve ? Object.defineProperty(ve, ge, { value: Pe, enumerable: true, configurable: true, writable: true }) : ve[ge] = Pe, ve;
            }
            var re = B(141), ie = function() {
              function ve() {
                Z(this, "_callbacks", void 0), Z(this, "_isDispatching", void 0), Z(this, "_isHandled", void 0), Z(this, "_isPending", void 0), Z(this, "_lastID", void 0), Z(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
              }
              var ge = ve.prototype;
              return ge.register = function(Pe) {
                var He = "ID_" + this._lastID++;
                return this._callbacks[He] = Pe, He;
              }, ge.unregister = function(Pe) {
                this._callbacks[Pe] || re(false), delete this._callbacks[Pe];
              }, ge.waitFor = function(Pe) {
                this._isDispatching || re(false);
                for (var He = 0; He < Pe.length; He++) {
                  var Qe = Pe[He];
                  this._isPending[Qe] ? this._isHandled[Qe] || re(false) : (this._callbacks[Qe] || re(false), this._invokeCallback(Qe));
                }
              }, ge.dispatch = function(Pe) {
                this._isDispatching && re(false), this._startDispatching(Pe);
                try {
                  for (var He in this._callbacks)
                    this._isPending[He] || this._invokeCallback(He);
                } finally {
                  this._stopDispatching();
                }
              }, ge.isDispatching = function() {
                return this._isDispatching;
              }, ge._invokeCallback = function(Pe) {
                this._isPending[Pe] = true, this._callbacks[Pe](this._pendingPayload), this._isHandled[Pe] = true;
              }, ge._startDispatching = function(Pe) {
                for (var He in this._callbacks)
                  this._isPending[He] = false, this._isHandled[He] = false;
                this._pendingPayload = Pe, this._isDispatching = true;
              }, ge._stopDispatching = function() {
                delete this._pendingPayload, this._isDispatching = false;
              }, ve;
            }();
            O.exports = ie;
          }, function(O, F, B) {
            O.exports = function(Z, re) {
              for (var ie = arguments.length, ve = new Array(ie > 2 ? ie - 2 : 0), ge = 2; ge < ie; ge++)
                ve[ge - 2] = arguments[ge];
              if (!Z) {
                var Pe;
                if (re === void 0)
                  Pe = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                else {
                  var He = 0;
                  (Pe = new Error(re.replace(/%s/g, function() {
                    return String(ve[He++]);
                  }))).name = "Invariant Violation";
                }
                throw Pe.framesToPop = 1, Pe;
              }
            };
          }, function(O, F, B) {
            function Z(je, Ge, Ce) {
              return Ge in je ? Object.defineProperty(je, Ge, { value: Ce, enumerable: true, configurable: true, writable: true }) : je[Ge] = Ce, je;
            }
            function re(je, Ge) {
              var Ce = Object.keys(je);
              if (Object.getOwnPropertySymbols) {
                var Re = Object.getOwnPropertySymbols(je);
                Ge && (Re = Re.filter(function(Ne) {
                  return Object.getOwnPropertyDescriptor(je, Ne).enumerable;
                })), Ce.push.apply(Ce, Re);
              }
              return Ce;
            }
            function ie(je) {
              for (var Ge = 1; Ge < arguments.length; Ge++) {
                var Ce = arguments[Ge] != null ? arguments[Ge] : {};
                Ge % 2 ? re(Object(Ce), true).forEach(function(Re) {
                  Z(je, Re, Ce[Re]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(je, Object.getOwnPropertyDescriptors(Ce)) : re(Object(Ce)).forEach(function(Re) {
                  Object.defineProperty(je, Re, Object.getOwnPropertyDescriptor(Ce, Re));
                });
              }
              return je;
            }
            function ve(je, Ge) {
              if (!(je instanceof Ge))
                throw new TypeError("Cannot call a class as a function");
            }
            function ge(je, Ge) {
              for (var Ce = 0; Ce < Ge.length; Ce++) {
                var Re = Ge[Ce];
                Re.enumerable = Re.enumerable || false, Re.configurable = true, "value" in Re && (Re.writable = true), Object.defineProperty(je, Re.key, Re);
              }
            }
            function Pe(je, Ge, Ce) {
              return Ge && ge(je.prototype, Ge), Ce && ge(je, Ce), je;
            }
            function He(je, Ge) {
              return (He = Object.setPrototypeOf || function(Ce, Re) {
                return Ce.__proto__ = Re, Ce;
              })(je, Ge);
            }
            function Qe(je, Ge) {
              if (typeof Ge != "function" && Ge !== null)
                throw new TypeError("Super expression must either be null or a function");
              je.prototype = Object.create(Ge && Ge.prototype, { constructor: { value: je, writable: true, configurable: true } }), Ge && He(je, Ge);
            }
            function Je(je) {
              return (Je = Object.setPrototypeOf ? Object.getPrototypeOf : function(Ge) {
                return Ge.__proto__ || Object.getPrototypeOf(Ge);
              })(je);
            }
            function ut(je) {
              return (ut = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Ge) {
                return typeof Ge;
              } : function(Ge) {
                return Ge && typeof Symbol == "function" && Ge.constructor === Symbol && Ge !== Symbol.prototype ? "symbol" : typeof Ge;
              })(je);
            }
            function gt(je) {
              if (je === void 0)
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return je;
            }
            function lr(je, Ge) {
              return !Ge || ut(Ge) !== "object" && typeof Ge != "function" ? gt(je) : Ge;
            }
            function tr(je) {
              var Ge = function() {
                if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                  return false;
                if (typeof Proxy == "function")
                  return true;
                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                  })), true;
                } catch {
                  return false;
                }
              }();
              return function() {
                var Ce, Re = Je(je);
                if (Ge) {
                  var Ne = Je(this).constructor;
                  Ce = Reflect.construct(Re, arguments, Ne);
                } else
                  Ce = Re.apply(this, arguments);
                return lr(this, Ce);
              };
            }
            B.r(F);
            var Gr = B(0), se = B.n(Gr);
            function vt() {
              var je = this.constructor.getDerivedStateFromProps(this.props, this.state);
              je != null && this.setState(je);
            }
            function Lt(je) {
              this.setState(function(Ge) {
                var Ce = this.constructor.getDerivedStateFromProps(je, Ge);
                return Ce != null ? Ce : null;
              }.bind(this));
            }
            function ar(je, Ge) {
              try {
                var Ce = this.props, Re = this.state;
                this.props = je, this.state = Ge, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Ce, Re);
              } finally {
                this.props = Ce, this.state = Re;
              }
            }
            function rr(je) {
              var Ge = je.prototype;
              if (!Ge || !Ge.isReactComponent)
                throw new Error("Can only polyfill class components");
              if (typeof je.getDerivedStateFromProps != "function" && typeof Ge.getSnapshotBeforeUpdate != "function")
                return je;
              var Ce = null, Re = null, Ne = null;
              if (typeof Ge.componentWillMount == "function" ? Ce = "componentWillMount" : typeof Ge.UNSAFE_componentWillMount == "function" && (Ce = "UNSAFE_componentWillMount"), typeof Ge.componentWillReceiveProps == "function" ? Re = "componentWillReceiveProps" : typeof Ge.UNSAFE_componentWillReceiveProps == "function" && (Re = "UNSAFE_componentWillReceiveProps"), typeof Ge.componentWillUpdate == "function" ? Ne = "componentWillUpdate" : typeof Ge.UNSAFE_componentWillUpdate == "function" && (Ne = "UNSAFE_componentWillUpdate"), Ce !== null || Re !== null || Ne !== null) {
                var Dt = je.displayName || je.name, or = typeof je.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Dt + " uses " + or + " but also contains the following legacy lifecycles:" + (Ce !== null ? `
  ` + Ce : "") + (Re !== null ? `
  ` + Re : "") + (Ne !== null ? `
  ` + Ne : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
              }
              if (typeof je.getDerivedStateFromProps == "function" && (Ge.componentWillMount = vt, Ge.componentWillReceiveProps = Lt), typeof Ge.getSnapshotBeforeUpdate == "function") {
                if (typeof Ge.componentDidUpdate != "function")
                  throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                Ge.componentWillUpdate = ar;
                var Ht = Ge.componentDidUpdate;
                Ge.componentDidUpdate = function(wt, jr, Pn) {
                  var Ka = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : Pn;
                  Ht.call(this, wt, jr, Ka);
                };
              }
              return je;
            }
            function Ct(je, Ge) {
              if (je == null)
                return {};
              var Ce, Re, Ne = function(or, Ht) {
                if (or == null)
                  return {};
                var wt, jr, Pn = {}, Ka = Object.keys(or);
                for (jr = 0; jr < Ka.length; jr++)
                  wt = Ka[jr], Ht.indexOf(wt) >= 0 || (Pn[wt] = or[wt]);
                return Pn;
              }(je, Ge);
              if (Object.getOwnPropertySymbols) {
                var Dt = Object.getOwnPropertySymbols(je);
                for (Re = 0; Re < Dt.length; Re++)
                  Ce = Dt[Re], Ge.indexOf(Ce) >= 0 || Object.prototype.propertyIsEnumerable.call(je, Ce) && (Ne[Ce] = je[Ce]);
              }
              return Ne;
            }
            function Ft(je) {
              var Ge = function(Ce) {
                return {}.toString.call(Ce).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
              }(je);
              return Ge === "number" && (Ge = isNaN(je) ? "nan" : (0 | je) != je ? "float" : "integer"), Ge;
            }
            vt.__suppressDeprecationWarning = true, Lt.__suppressDeprecationWarning = true, ar.__suppressDeprecationWarning = true;
            var gr = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Nr = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, mt = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, dn = B(45), fn = function(je) {
              var Ge = function(Ce) {
                return { backgroundColor: Ce.base00, ellipsisColor: Ce.base09, braceColor: Ce.base07, expandedIcon: Ce.base0D, collapsedIcon: Ce.base0E, keyColor: Ce.base07, arrayKeyColor: Ce.base0C, objectSize: Ce.base04, copyToClipboard: Ce.base0F, copyToClipboardCheck: Ce.base0D, objectBorder: Ce.base02, dataTypes: { boolean: Ce.base0E, date: Ce.base0D, float: Ce.base0B, function: Ce.base0D, integer: Ce.base0F, string: Ce.base09, nan: Ce.base08, null: Ce.base0A, undefined: Ce.base05, regexp: Ce.base0A, background: Ce.base02 }, editVariable: { editIcon: Ce.base0E, cancelIcon: Ce.base09, removeIcon: Ce.base09, addIcon: Ce.base0E, checkIcon: Ce.base0E, background: Ce.base01, color: Ce.base0A, border: Ce.base07 }, addKeyModal: { background: Ce.base05, border: Ce.base04, color: Ce.base0A, labelColor: Ce.base01 }, validationFailure: { background: Ce.base09, iconColor: Ce.base01, fontColor: Ce.base01 } };
              }(je);
              return { "app-container": { fontFamily: mt.globalFontFamily, cursor: mt.globalCursor, backgroundColor: Ge.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Ge.ellipsisColor, fontSize: mt.ellipsisFontSize, lineHeight: mt.ellipsisLineHeight, cursor: mt.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: mt.braceCursor, fontWeight: mt.braceFontWeight, color: Ge.braceColor }, "expanded-icon": { color: Ge.expandedIcon }, "collapsed-icon": { color: Ge.collapsedIcon }, colon: { display: "inline-block", margin: mt.keyMargin, color: Ge.keyColor, verticalAlign: "top" }, objectKeyVal: function(Ce, Re) {
                return { style: ie({ paddingTop: mt.keyValPaddingTop, paddingRight: mt.keyValPaddingRight, paddingBottom: mt.keyValPaddingBottom, borderLeft: mt.keyValBorderLeft + " " + Ge.objectBorder, ":hover": { paddingLeft: Re.paddingLeft - 1 + "px", borderLeft: mt.keyValBorderHover + " " + Ge.objectBorder } }, Re) };
              }, "object-key-val-no-border": { padding: mt.keyValPadding }, "pushed-content": { marginLeft: mt.pushedContentMarginLeft }, variableValue: function(Ce, Re) {
                return { style: ie({ display: "inline-block", paddingRight: mt.variableValuePaddingRight, position: "relative" }, Re) };
              }, "object-name": { display: "inline-block", color: Ge.keyColor, letterSpacing: mt.keyLetterSpacing, fontStyle: mt.keyFontStyle, verticalAlign: mt.keyVerticalAlign, opacity: mt.keyOpacity, ":hover": { opacity: mt.keyOpacityHover } }, "array-key": { display: "inline-block", color: Ge.arrayKeyColor, letterSpacing: mt.keyLetterSpacing, fontStyle: mt.keyFontStyle, verticalAlign: mt.keyVerticalAlign, opacity: mt.keyOpacity, ":hover": { opacity: mt.keyOpacityHover } }, "object-size": { color: Ge.objectSize, borderRadius: mt.objectSizeBorderRadius, fontStyle: mt.objectSizeFontStyle, margin: mt.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: mt.dataTypeFontSize, marginRight: mt.dataTypeMarginRight, opacity: mt.datatypeOpacity }, boolean: { display: "inline-block", color: Ge.dataTypes.boolean }, date: { display: "inline-block", color: Ge.dataTypes.date }, "date-value": { marginLeft: mt.dateValueMarginLeft }, float: { display: "inline-block", color: Ge.dataTypes.float }, function: { display: "inline-block", color: Ge.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Ge.dataTypes.integer }, string: { display: "inline-block", color: Ge.dataTypes.string }, nan: { display: "inline-block", color: Ge.dataTypes.nan, fontSize: mt.nanFontSize, fontWeight: mt.nanFontWeight, backgroundColor: Ge.dataTypes.background, padding: mt.nanPadding, borderRadius: mt.nanBorderRadius }, null: { display: "inline-block", color: Ge.dataTypes.null, fontSize: mt.nullFontSize, fontWeight: mt.nullFontWeight, backgroundColor: Ge.dataTypes.background, padding: mt.nullPadding, borderRadius: mt.nullBorderRadius }, undefined: { display: "inline-block", color: Ge.dataTypes.undefined, fontSize: mt.undefinedFontSize, padding: mt.undefinedPadding, borderRadius: mt.undefinedBorderRadius, backgroundColor: Ge.dataTypes.background }, regexp: { display: "inline-block", color: Ge.dataTypes.regexp }, "copy-to-clipboard": { cursor: mt.clipboardCursor }, "copy-icon": { color: Ge.copyToClipboard, fontSize: mt.iconFontSize, marginRight: mt.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Ge.copyToClipboardCheck, marginLeft: mt.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: mt.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: mt.metaDataPadding }, "icon-container": { display: "inline-block", width: mt.iconContainerWidth }, tooltip: { padding: mt.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Ge.editVariable.removeIcon, cursor: mt.iconCursor, fontSize: mt.iconFontSize, marginRight: mt.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Ge.editVariable.addIcon, cursor: mt.iconCursor, fontSize: mt.iconFontSize, marginRight: mt.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Ge.editVariable.editIcon, cursor: mt.iconCursor, fontSize: mt.iconFontSize, marginRight: mt.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: mt.iconCursor, color: Ge.editVariable.checkIcon, fontSize: mt.iconFontSize, paddingRight: mt.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: mt.iconCursor, color: Ge.editVariable.cancelIcon, fontSize: mt.iconFontSize, paddingRight: mt.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: mt.editInputMinWidth, borderRadius: mt.editInputBorderRadius, backgroundColor: Ge.editVariable.background, color: Ge.editVariable.color, padding: mt.editInputPadding, marginRight: mt.editInputMarginRight, fontFamily: mt.editInputFontFamily }, "detected-row": { paddingTop: mt.detectedRowPaddingTop }, "key-modal-request": { position: mt.addKeyCoverPosition, top: mt.addKeyCoverPositionPx, left: mt.addKeyCoverPositionPx, right: mt.addKeyCoverPositionPx, bottom: mt.addKeyCoverPositionPx, backgroundColor: mt.addKeyCoverBackground }, "key-modal": { width: mt.addKeyModalWidth, backgroundColor: Ge.addKeyModal.background, marginLeft: mt.addKeyModalMargin, marginRight: mt.addKeyModalMargin, padding: mt.addKeyModalPadding, borderRadius: mt.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Ge.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Ge.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Ge.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Ge.addKeyModal.labelColor, fontSize: mt.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Ge.editVariable.addIcon, fontSize: mt.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Ge.ellipsisColor, fontSize: mt.ellipsisFontSize, lineHeight: mt.ellipsisLineHeight, cursor: mt.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Ge.validationFailure.fontColor, backgroundColor: Ge.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Ge.validationFailure.iconColor, fontSize: mt.iconFontSize, transform: "rotate(45deg)" } };
            };
            function ir(je, Ge, Ce) {
              return je || console.error("theme has not been set"), function(Re) {
                var Ne = gr;
                return Re !== false && Re !== "none" || (Ne = Nr), Object(dn.createStyling)(fn, { defaultBase16: Ne })(Re);
              }(je)(Ge, Ce);
            }
            var Vn = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = (Re.rjvId, Re.type_name), Dt = Re.displayDataTypes, or = Re.theme;
                return Dt ? se.a.createElement("span", Object.assign({ className: "data-type-label" }, ir(or, "data-type-label")), Ne) : null;
              } }]), Ce;
            }(se.a.PureComponent), fr = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props;
                return se.a.createElement("div", ir(Re.theme, "boolean"), se.a.createElement(Vn, Object.assign({ type_name: "bool" }, Re)), Re.value ? "true" : "false");
              } }]), Ce;
            }(se.a.PureComponent), Wt = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props;
                return se.a.createElement("div", ir(Re.theme, "date"), se.a.createElement(Vn, Object.assign({ type_name: "date" }, Re)), se.a.createElement("span", Object.assign({ className: "date-value" }, ir(Re.theme, "date-value")), Re.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
              } }]), Ce;
            }(se.a.PureComponent), Ut = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props;
                return se.a.createElement("div", ir(Re.theme, "float"), se.a.createElement(Vn, Object.assign({ type_name: "float" }, Re)), this.props.value);
              } }]), Ce;
            }(se.a.PureComponent);
            function Kr(je, Ge) {
              (Ge == null || Ge > je.length) && (Ge = je.length);
              for (var Ce = 0, Re = new Array(Ge); Ce < Ge; Ce++)
                Re[Ce] = je[Ce];
              return Re;
            }
            function zr(je, Ge) {
              if (je) {
                if (typeof je == "string")
                  return Kr(je, Ge);
                var Ce = Object.prototype.toString.call(je).slice(8, -1);
                return Ce === "Object" && je.constructor && (Ce = je.constructor.name), Ce === "Map" || Ce === "Set" ? Array.from(je) : Ce === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce) ? Kr(je, Ge) : void 0;
              }
            }
            function Zn(je, Ge) {
              var Ce;
              if (typeof Symbol == "undefined" || je[Symbol.iterator] == null) {
                if (Array.isArray(je) || (Ce = zr(je)) || Ge && je && typeof je.length == "number") {
                  Ce && (je = Ce);
                  var Re = 0, Ne = function() {
                  };
                  return { s: Ne, n: function() {
                    return Re >= je.length ? { done: true } : { done: false, value: je[Re++] };
                  }, e: function(wt) {
                    throw wt;
                  }, f: Ne };
                }
                throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }
              var Dt, or = true, Ht = false;
              return { s: function() {
                Ce = je[Symbol.iterator]();
              }, n: function() {
                var wt = Ce.next();
                return or = wt.done, wt;
              }, e: function(wt) {
                Ht = true, Dt = wt;
              }, f: function() {
                try {
                  or || Ce.return == null || Ce.return();
                } finally {
                  if (Ht)
                    throw Dt;
                }
              } };
            }
            function gi(je) {
              return function(Ge) {
                if (Array.isArray(Ge))
                  return Kr(Ge);
              }(je) || function(Ge) {
                if (typeof Symbol != "undefined" && Symbol.iterator in Object(Ge))
                  return Array.from(Ge);
              }(je) || zr(je) || function() {
                throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }();
            }
            var Ja = B(46), Oa = new (B(47)).Dispatcher(), co = new (function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                var Re;
                ve(this, Ce);
                for (var Ne = arguments.length, Dt = new Array(Ne), or = 0; or < Ne; or++)
                  Dt[or] = arguments[or];
                return (Re = Ge.call.apply(Ge, [this].concat(Dt))).objects = {}, Re.set = function(Ht, wt, jr, Pn) {
                  Re.objects[Ht] === void 0 && (Re.objects[Ht] = {}), Re.objects[Ht][wt] === void 0 && (Re.objects[Ht][wt] = {}), Re.objects[Ht][wt][jr] = Pn;
                }, Re.get = function(Ht, wt, jr, Pn) {
                  return Re.objects[Ht] === void 0 || Re.objects[Ht][wt] === void 0 || Re.objects[Ht][wt][jr] == null ? Pn : Re.objects[Ht][wt][jr];
                }, Re.handleAction = function(Ht) {
                  var wt = Ht.rjvId, jr = Ht.data;
                  switch (Ht.name) {
                    case "RESET":
                      Re.emit("reset-" + wt);
                      break;
                    case "VARIABLE_UPDATED":
                      Ht.data.updated_src = Re.updateSrc(wt, jr), Re.set(wt, "action", "variable-update", ie(ie({}, jr), {}, { type: "variable-edited" })), Re.emit("variable-update-" + wt);
                      break;
                    case "VARIABLE_REMOVED":
                      Ht.data.updated_src = Re.updateSrc(wt, jr), Re.set(wt, "action", "variable-update", ie(ie({}, jr), {}, { type: "variable-removed" })), Re.emit("variable-update-" + wt);
                      break;
                    case "VARIABLE_ADDED":
                      Ht.data.updated_src = Re.updateSrc(wt, jr), Re.set(wt, "action", "variable-update", ie(ie({}, jr), {}, { type: "variable-added" })), Re.emit("variable-update-" + wt);
                      break;
                    case "ADD_VARIABLE_KEY_REQUEST":
                      Re.set(wt, "action", "new-key-request", jr), Re.emit("add-key-request-" + wt);
                  }
                }, Re.updateSrc = function(Ht, wt) {
                  var jr = wt.name, Pn = wt.namespace, Ka = wt.new_value, mi = (wt.existing_value, wt.variable_removed);
                  Pn.shift();
                  var Qi, za = Re.get(Ht, "global", "src"), eo = Re.deepCopy(za, gi(Pn)), es = eo, ga = Zn(Pn);
                  try {
                    for (ga.s(); !(Qi = ga.n()).done; )
                      es = es[Qi.value];
                  } catch (Is) {
                    ga.e(Is);
                  } finally {
                    ga.f();
                  }
                  return mi ? Ft(es) == "array" ? es.splice(jr, 1) : delete es[jr] : jr !== null ? es[jr] = Ka : eo = Ka, Re.set(Ht, "global", "src", eo), eo;
                }, Re.deepCopy = function(Ht, wt) {
                  var jr, Pn = Ft(Ht), Ka = wt.shift();
                  return Pn == "array" ? jr = gi(Ht) : Pn == "object" && (jr = ie({}, Ht)), Ka !== void 0 && (jr[Ka] = Re.deepCopy(Ht[Ka], wt)), jr;
                }, Re;
              }
              return Ce;
            }(Ja.EventEmitter))();
            Oa.register(co.handleAction.bind(co));
            var Qa = co, Fi = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).toggleCollapsed = function() {
                  Ne.setState({ collapsed: !Ne.state.collapsed }, function() {
                    Qa.set(Ne.props.rjvId, Ne.props.namespace, "collapsed", Ne.state.collapsed);
                  });
                }, Ne.getFunctionDisplay = function(Dt) {
                  var or = gt(Ne).props;
                  return Dt ? se.a.createElement("span", null, Ne.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), se.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, se.a.createElement("span", null, "{"), se.a.createElement("span", ir(or.theme, "ellipsis"), "..."), se.a.createElement("span", null, "}"))) : Ne.props.value.toString().slice(9, -1);
                }, Ne.state = { collapsed: Qa.get(Re.rjvId, Re.namespace, "collapsed", true) }, Ne;
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = this.state.collapsed;
                return se.a.createElement("div", ir(Re.theme, "function"), se.a.createElement(Vn, Object.assign({ type_name: "function" }, Re)), se.a.createElement("span", Object.assign({}, ir(Re.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Ne)));
              } }]), Ce;
            }(se.a.PureComponent), Jo = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                return se.a.createElement("div", ir(this.props.theme, "nan"), "NaN");
              } }]), Ce;
            }(se.a.PureComponent), vs = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                return se.a.createElement("div", ir(this.props.theme, "null"), "NULL");
              } }]), Ce;
            }(se.a.PureComponent), Xl = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props;
                return se.a.createElement("div", ir(Re.theme, "integer"), se.a.createElement(Vn, Object.assign({ type_name: "int" }, Re)), this.props.value);
              } }]), Ce;
            }(se.a.PureComponent), Yc = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props;
                return se.a.createElement("div", ir(Re.theme, "regexp"), se.a.createElement(Vn, Object.assign({ type_name: "regexp" }, Re)), this.props.value.toString());
              } }]), Ce;
            }(se.a.PureComponent), $s = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).toggleCollapsed = function() {
                  Ne.setState({ collapsed: !Ne.state.collapsed }, function() {
                    Qa.set(Ne.props.rjvId, Ne.props.namespace, "collapsed", Ne.state.collapsed);
                  });
                }, Ne.state = { collapsed: Qa.get(Re.rjvId, Re.namespace, "collapsed", true) }, Ne;
              }
              return Pe(Ce, [{ key: "render", value: function() {
                this.state.collapsed;
                var Re = this.props, Ne = Re.collapseStringsAfterLength, Dt = Re.theme, or = Re.value, Ht = { style: { cursor: "default" } };
                return Ft(Ne) === "integer" && or.length > Ne && (Ht.style.cursor = "pointer", this.state.collapsed && (or = se.a.createElement("span", null, or.substring(0, Ne), se.a.createElement("span", ir(Dt, "ellipsis"), " ...")))), se.a.createElement("div", ir(Dt, "string"), se.a.createElement(Vn, Object.assign({ type_name: "string" }, Re)), se.a.createElement("span", Object.assign({ className: "string-value" }, Ht, { onClick: this.toggleCollapsed }), '"', or, '"'));
              } }]), Ce;
            }(se.a.PureComponent), Dl = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                return se.a.createElement("div", ir(this.props.theme, "undefined"), "undefined");
              } }]), Ce;
            }(se.a.PureComponent);
            function Ff() {
              return (Ff = Object.assign || function(je) {
                for (var Ge = 1; Ge < arguments.length; Ge++) {
                  var Ce = arguments[Ge];
                  for (var Re in Ce)
                    Object.prototype.hasOwnProperty.call(Ce, Re) && (je[Re] = Ce[Re]);
                }
                return je;
              }).apply(this, arguments);
            }
            var cl = Gr.useLayoutEffect, Nu = function(je) {
              var Ge = Object(Gr.useRef)(je);
              return cl(function() {
                Ge.current = je;
              }), Ge;
            }, Kc = function(je, Ge) {
              typeof je != "function" ? je.current = Ge : je(Ge);
            }, Jl = function(je, Ge) {
              var Ce = Object(Gr.useRef)();
              return Object(Gr.useCallback)(function(Re) {
                je.current = Re, Ce.current && Kc(Ce.current, null), Ce.current = Ge, Ge && Kc(Ge, Re);
              }, [Ge]);
            }, us = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Ps = function(je) {
              Object.keys(us).forEach(function(Ge) {
                je.style.setProperty(Ge, us[Ge], "important");
              });
            }, wo = null, Nn = function() {
            }, mr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Vt = !!document.documentElement.currentStyle, It = function(je, Ge) {
              var Ce = je.cacheMeasurements, Re = je.maxRows, Ne = je.minRows, Dt = je.onChange, or = Dt === void 0 ? Nn : Dt, Ht = je.onHeightChange, wt = Ht === void 0 ? Nn : Ht, jr = function(ga, Is) {
                if (ga == null)
                  return {};
                var Ll, Nf, Kp = {}, Xc = Object.keys(ga);
                for (Nf = 0; Nf < Xc.length; Nf++)
                  Ll = Xc[Nf], Is.indexOf(Ll) >= 0 || (Kp[Ll] = ga[Ll]);
                return Kp;
              }(je, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), Pn, Ka = jr.value !== void 0, mi = Object(Gr.useRef)(null), Qi = Jl(mi, Ge), za = Object(Gr.useRef)(0), eo = Object(Gr.useRef)(), es = function() {
                var ga = mi.current, Is = Ce && eo.current ? eo.current : function(Xc) {
                  var Ad = window.getComputedStyle(Xc);
                  if (Ad === null)
                    return null;
                  var Cv, au = (Cv = Ad, mr.reduce(function(Td, Ev) {
                    return Td[Ev] = Cv[Ev], Td;
                  }, {})), _h = au.boxSizing;
                  return _h === "" ? null : (Vt && _h === "border-box" && (au.width = parseFloat(au.width) + parseFloat(au.borderRightWidth) + parseFloat(au.borderLeftWidth) + parseFloat(au.paddingRight) + parseFloat(au.paddingLeft) + "px"), { sizingStyle: au, paddingSize: parseFloat(au.paddingBottom) + parseFloat(au.paddingTop), borderSize: parseFloat(au.borderBottomWidth) + parseFloat(au.borderTopWidth) });
                }(ga);
                if (Is) {
                  eo.current = Is;
                  var Ll = function(Xc, Ad, Cv, au) {
                    Cv === void 0 && (Cv = 1), au === void 0 && (au = 1 / 0), wo || ((wo = document.createElement("textarea")).setAttribute("tab-index", "-1"), wo.setAttribute("aria-hidden", "true"), Ps(wo)), wo.parentNode === null && document.body.appendChild(wo);
                    var _h = Xc.paddingSize, Td = Xc.borderSize, Ev = Xc.sizingStyle, Zp = Ev.boxSizing;
                    Object.keys(Ev).forEach(function(xu) {
                      var Md = xu;
                      wo.style[Md] = Ev[Md];
                    }), Ps(wo), wo.value = Ad;
                    var Xp = function(xu, Md) {
                      var zm = xu.scrollHeight;
                      return Md.sizingStyle.boxSizing === "border-box" ? zm + Md.borderSize : zm - Md.paddingSize;
                    }(wo, Xc);
                    wo.value = "x";
                    var Bm = wo.scrollHeight - _h, E0 = Bm * Cv;
                    Zp === "border-box" && (E0 = E0 + _h + Td), Xp = Math.max(E0, Xp);
                    var A0 = Bm * au;
                    return Zp === "border-box" && (A0 = A0 + _h + Td), [Xp = Math.min(A0, Xp), Bm];
                  }(Is, ga.value || ga.placeholder || "x", Ne, Re), Nf = Ll[0], Kp = Ll[1];
                  za.current !== Nf && (za.current = Nf, ga.style.setProperty("height", Nf + "px", "important"), wt(Nf, { rowHeight: Kp }));
                }
              };
              return Object(Gr.useLayoutEffect)(es), Pn = Nu(es), Object(Gr.useLayoutEffect)(function() {
                var ga = function(Is) {
                  Pn.current(Is);
                };
                return window.addEventListener("resize", ga), function() {
                  window.removeEventListener("resize", ga);
                };
              }, []), Object(Gr.createElement)("textarea", Ff({}, jr, { onChange: function(ga) {
                Ka || es(), or(ga);
              }, ref: Qi }));
            }, Sr = Object(Gr.forwardRef)(It);
            function rn(je) {
              je = je.trim();
              try {
                if ((je = JSON.stringify(JSON.parse(je)))[0] === "[")
                  return An("array", JSON.parse(je));
                if (je[0] === "{")
                  return An("object", JSON.parse(je));
                if (je.match(/\-?\d+\.\d+/) && je.match(/\-?\d+\.\d+/)[0] === je)
                  return An("float", parseFloat(je));
                if (je.match(/\-?\d+e-\d+/) && je.match(/\-?\d+e-\d+/)[0] === je)
                  return An("float", Number(je));
                if (je.match(/\-?\d+/) && je.match(/\-?\d+/)[0] === je)
                  return An("integer", parseInt(je));
                if (je.match(/\-?\d+e\+\d+/) && je.match(/\-?\d+e\+\d+/)[0] === je)
                  return An("integer", Number(je));
              } catch {
              }
              switch (je = je.toLowerCase()) {
                case "undefined":
                  return An("undefined", void 0);
                case "nan":
                  return An("nan", NaN);
                case "null":
                  return An("null", null);
                case "true":
                  return An("boolean", true);
                case "false":
                  return An("boolean", false);
                default:
                  if (je = Date.parse(je))
                    return An("date", new Date(je));
              }
              return An(false, null);
            }
            function An(je, Ge) {
              return { type: je, value: Ge };
            }
            var Bn = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
              } }]), Ce;
            }(se.a.PureComponent), ka = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
              } }]), Ce;
            }(se.a.PureComponent), $i = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]), or = yi(Ne).style;
                return se.a.createElement("span", Dt, se.a.createElement("svg", { fill: or.color, width: or.height, height: or.width, style: or, viewBox: "0 0 1792 1792" }, se.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Ce;
            }(se.a.PureComponent), Fo = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]), or = yi(Ne).style;
                return se.a.createElement("span", Dt, se.a.createElement("svg", { fill: or.color, width: or.height, height: or.width, style: or, viewBox: "0 0 1792 1792" }, se.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Ce;
            }(se.a.PureComponent), So = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", { style: ie(ie({}, yi(Ne).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, se.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
              } }]), Ce;
            }(se.a.PureComponent), ds = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", { style: ie(ie({}, yi(Ne).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, se.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
              } }]), Ce;
            }(se.a.PureComponent), Co = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
              } }]), Ce;
            }(se.a.PureComponent), fl = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Ce;
            }(se.a.PureComponent), Il = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Ce;
            }(se.a.PureComponent), Gs = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
              } }]), Ce;
            }(se.a.PureComponent), fo = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
              } }]), Ce;
            }(se.a.PureComponent), Qo = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.style, Dt = Ct(Re, ["style"]);
                return se.a.createElement("span", Dt, se.a.createElement("svg", Object.assign({}, yi(Ne), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), se.a.createElement("g", null, se.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Ce;
            }(se.a.PureComponent);
            function yi(je) {
              return je || (je = {}), { style: ie(ie({ verticalAlign: "middle" }, je), {}, { color: je.color ? je.color : "#000000", height: "1em", width: "1em" }) };
            }
            var Ds = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).copiedTimer = null, Ne.handleCopy = function() {
                  var Dt = document.createElement("textarea"), or = Ne.props, Ht = or.clickCallback, wt = or.src, jr = or.namespace;
                  Dt.innerHTML = JSON.stringify(Ne.clipboardValue(wt), null, "  "), document.body.appendChild(Dt), Dt.select(), document.execCommand("copy"), document.body.removeChild(Dt), Ne.copiedTimer = setTimeout(function() {
                    Ne.setState({ copied: false });
                  }, 5500), Ne.setState({ copied: true }, function() {
                    typeof Ht == "function" && Ht({ src: wt, namespace: jr, name: jr[jr.length - 1] });
                  });
                }, Ne.getClippyIcon = function() {
                  var Dt = Ne.props.theme;
                  return Ne.state.copied ? se.a.createElement("span", null, se.a.createElement(Co, Object.assign({ className: "copy-icon" }, ir(Dt, "copy-icon"))), se.a.createElement("span", ir(Dt, "copy-icon-copied"), "\u2714")) : se.a.createElement(Co, Object.assign({ className: "copy-icon" }, ir(Dt, "copy-icon")));
                }, Ne.clipboardValue = function(Dt) {
                  switch (Ft(Dt)) {
                    case "function":
                    case "regexp":
                      return Dt.toString();
                    default:
                      return Dt;
                  }
                }, Ne.state = { copied: false }, Ne;
              }
              return Pe(Ce, [{ key: "componentWillUnmount", value: function() {
                this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
              } }, { key: "render", value: function() {
                var Re = this.props, Ne = (Re.src, Re.theme), Dt = Re.hidden, or = Re.rowHovered, Ht = ir(Ne, "copy-to-clipboard").style, wt = "inline";
                return Dt && (wt = "none"), se.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: or ? "inline-block" : "none" } }, se.a.createElement("span", { style: ie(ie({}, Ht), {}, { display: wt }), onClick: this.handleCopy }, this.getClippyIcon()));
              } }]), Ce;
            }(se.a.PureComponent), Vu = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).getEditIcon = function() {
                  var Dt = Ne.props, or = Dt.variable, Ht = Dt.theme;
                  return se.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Ne.state.hovered ? "inline-block" : "none" } }, se.a.createElement(fo, Object.assign({ className: "click-to-edit-icon" }, ir(Ht, "editVarIcon"), { onClick: function() {
                    Ne.prepopInput(or);
                  } })));
                }, Ne.prepopInput = function(Dt) {
                  if (Ne.props.onEdit !== false) {
                    var or = function(wt) {
                      var jr;
                      switch (Ft(wt)) {
                        case "undefined":
                          jr = "undefined";
                          break;
                        case "nan":
                          jr = "NaN";
                          break;
                        case "string":
                          jr = wt;
                          break;
                        case "date":
                        case "function":
                        case "regexp":
                          jr = wt.toString();
                          break;
                        default:
                          try {
                            jr = JSON.stringify(wt, null, "  ");
                          } catch {
                            jr = "";
                          }
                      }
                      return jr;
                    }(Dt.value), Ht = rn(or);
                    Ne.setState({ editMode: true, editValue: or, parsedInput: { type: Ht.type, value: Ht.value } });
                  }
                }, Ne.getRemoveIcon = function() {
                  var Dt = Ne.props, or = Dt.variable, Ht = Dt.namespace, wt = Dt.theme, jr = Dt.rjvId;
                  return se.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Ne.state.hovered ? "inline-block" : "none" } }, se.a.createElement(fl, Object.assign({ className: "click-to-remove-icon" }, ir(wt, "removeVarIcon"), { onClick: function() {
                    Oa.dispatch({ name: "VARIABLE_REMOVED", rjvId: jr, data: { name: or.name, namespace: Ht, existing_value: or.value, variable_removed: true } });
                  } })));
                }, Ne.getValue = function(Dt, or) {
                  var Ht = !or && Dt.type, wt = gt(Ne).props;
                  switch (Ht) {
                    case false:
                      return Ne.getEditInput();
                    case "string":
                      return se.a.createElement($s, Object.assign({ value: Dt.value }, wt));
                    case "integer":
                      return se.a.createElement(Xl, Object.assign({ value: Dt.value }, wt));
                    case "float":
                      return se.a.createElement(Ut, Object.assign({ value: Dt.value }, wt));
                    case "boolean":
                      return se.a.createElement(fr, Object.assign({ value: Dt.value }, wt));
                    case "function":
                      return se.a.createElement(Fi, Object.assign({ value: Dt.value }, wt));
                    case "null":
                      return se.a.createElement(vs, wt);
                    case "nan":
                      return se.a.createElement(Jo, wt);
                    case "undefined":
                      return se.a.createElement(Dl, wt);
                    case "date":
                      return se.a.createElement(Wt, Object.assign({ value: Dt.value }, wt));
                    case "regexp":
                      return se.a.createElement(Yc, Object.assign({ value: Dt.value }, wt));
                    default:
                      return se.a.createElement("div", { className: "object-value" }, JSON.stringify(Dt.value));
                  }
                }, Ne.getEditInput = function() {
                  var Dt = Ne.props.theme, or = Ne.state.editValue;
                  return se.a.createElement("div", null, se.a.createElement(Sr, Object.assign({ type: "text", inputRef: function(Ht) {
                    return Ht && Ht.focus();
                  }, value: or, className: "variable-editor", onChange: function(Ht) {
                    var wt = Ht.target.value, jr = rn(wt);
                    Ne.setState({ editValue: wt, parsedInput: { type: jr.type, value: jr.value } });
                  }, onKeyDown: function(Ht) {
                    switch (Ht.key) {
                      case "Escape":
                        Ne.setState({ editMode: false, editValue: "" });
                        break;
                      case "Enter":
                        (Ht.ctrlKey || Ht.metaKey) && Ne.submitEdit(true);
                    }
                    Ht.stopPropagation();
                  }, placeholder: "update this value", minRows: 2 }, ir(Dt, "edit-input"))), se.a.createElement("div", ir(Dt, "edit-icon-container"), se.a.createElement(fl, Object.assign({ className: "edit-cancel" }, ir(Dt, "cancel-icon"), { onClick: function() {
                    Ne.setState({ editMode: false, editValue: "" });
                  } })), se.a.createElement(Qo, Object.assign({ className: "edit-check string-value" }, ir(Dt, "check-icon"), { onClick: function() {
                    Ne.submitEdit();
                  } })), se.a.createElement("div", null, Ne.showDetected())));
                }, Ne.submitEdit = function(Dt) {
                  var or = Ne.props, Ht = or.variable, wt = or.namespace, jr = or.rjvId, Pn = Ne.state, Ka = Pn.editValue, mi = Pn.parsedInput, Qi = Ka;
                  Dt && mi.type && (Qi = mi.value), Ne.setState({ editMode: false }), Oa.dispatch({ name: "VARIABLE_UPDATED", rjvId: jr, data: { name: Ht.name, namespace: wt, existing_value: Ht.value, new_value: Qi, variable_removed: false } });
                }, Ne.showDetected = function() {
                  var Dt = Ne.props, or = Dt.theme, Ht = (Dt.variable, Dt.namespace, Dt.rjvId, Ne.state.parsedInput), wt = (Ht.type, Ht.value, Ne.getDetectedInput());
                  if (wt)
                    return se.a.createElement("div", null, se.a.createElement("div", ir(or, "detected-row"), wt, se.a.createElement(Qo, { className: "edit-check detected", style: ie({ verticalAlign: "top", paddingLeft: "3px" }, ir(or, "check-icon").style), onClick: function() {
                      Ne.submitEdit(true);
                    } })));
                }, Ne.getDetectedInput = function() {
                  var Dt = Ne.state.parsedInput, or = Dt.type, Ht = Dt.value, wt = gt(Ne).props, jr = wt.theme;
                  if (or !== false)
                    switch (or.toLowerCase()) {
                      case "object":
                        return se.a.createElement("span", null, se.a.createElement("span", { style: ie(ie({}, ir(jr, "brace").style), {}, { cursor: "default" }) }, "{"), se.a.createElement("span", { style: ie(ie({}, ir(jr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), se.a.createElement("span", { style: ie(ie({}, ir(jr, "brace").style), {}, { cursor: "default" }) }, "}"));
                      case "array":
                        return se.a.createElement("span", null, se.a.createElement("span", { style: ie(ie({}, ir(jr, "brace").style), {}, { cursor: "default" }) }, "["), se.a.createElement("span", { style: ie(ie({}, ir(jr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), se.a.createElement("span", { style: ie(ie({}, ir(jr, "brace").style), {}, { cursor: "default" }) }, "]"));
                      case "string":
                        return se.a.createElement($s, Object.assign({ value: Ht }, wt));
                      case "integer":
                        return se.a.createElement(Xl, Object.assign({ value: Ht }, wt));
                      case "float":
                        return se.a.createElement(Ut, Object.assign({ value: Ht }, wt));
                      case "boolean":
                        return se.a.createElement(fr, Object.assign({ value: Ht }, wt));
                      case "function":
                        return se.a.createElement(Fi, Object.assign({ value: Ht }, wt));
                      case "null":
                        return se.a.createElement(vs, wt);
                      case "nan":
                        return se.a.createElement(Jo, wt);
                      case "undefined":
                        return se.a.createElement(Dl, wt);
                      case "date":
                        return se.a.createElement(Wt, Object.assign({ value: new Date(Ht) }, wt));
                    }
                }, Ne.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Ne;
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this, Ne = this.props, Dt = Ne.variable, or = Ne.singleIndent, Ht = Ne.type, wt = Ne.theme, jr = Ne.namespace, Pn = Ne.indentWidth, Ka = Ne.enableClipboard, mi = Ne.onEdit, Qi = Ne.onDelete, za = Ne.onSelect, eo = Ne.displayArrayKey, es = Ne.quotesOnKeys, ga = this.state.editMode;
                return se.a.createElement("div", Object.assign({}, ir(wt, "objectKeyVal", { paddingLeft: Pn * or }), { onMouseEnter: function() {
                  return Re.setState(ie(ie({}, Re.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return Re.setState(ie(ie({}, Re.state), {}, { hovered: false }));
                }, className: "variable-row", key: Dt.name }), Ht == "array" ? eo ? se.a.createElement("span", Object.assign({}, ir(wt, "array-key"), { key: Dt.name + "_" + jr }), Dt.name, se.a.createElement("div", ir(wt, "colon"), ":")) : null : se.a.createElement("span", null, se.a.createElement("span", Object.assign({}, ir(wt, "object-name"), { className: "object-key", key: Dt.name + "_" + jr }), !!es && se.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), se.a.createElement("span", { style: { display: "inline-block" } }, Dt.name), !!es && se.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), se.a.createElement("span", ir(wt, "colon"), ":")), se.a.createElement("div", Object.assign({ className: "variable-value", onClick: za === false && mi === false ? null : function(Is) {
                  var Ll = gi(jr);
                  (Is.ctrlKey || Is.metaKey) && mi !== false ? Re.prepopInput(Dt) : za !== false && (Ll.shift(), za(ie(ie({}, Dt), {}, { namespace: Ll })));
                } }, ir(wt, "variableValue", { cursor: za === false ? "default" : "pointer" })), this.getValue(Dt, ga)), Ka ? se.a.createElement(Ds, { rowHovered: this.state.hovered, hidden: ga, src: Dt.value, clickCallback: Ka, theme: wt, namespace: [].concat(gi(jr), [Dt.name]) }) : null, mi !== false && ga == 0 ? this.getEditIcon() : null, Qi !== false && ga == 0 ? this.getRemoveIcon() : null);
              } }]), Ce;
            }(se.a.PureComponent), Zc = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                var Re;
                ve(this, Ce);
                for (var Ne = arguments.length, Dt = new Array(Ne), or = 0; or < Ne; or++)
                  Dt[or] = arguments[or];
                return (Re = Ge.call.apply(Ge, [this].concat(Dt))).getObjectSize = function() {
                  var Ht = Re.props, wt = Ht.size, jr = Ht.theme;
                  if (Ht.displayObjectSize)
                    return se.a.createElement("span", Object.assign({ className: "object-size" }, ir(jr, "object-size")), wt, " item", wt === 1 ? "" : "s");
                }, Re.getAddAttribute = function(Ht) {
                  var wt = Re.props, jr = wt.theme, Pn = wt.namespace, Ka = wt.name, mi = wt.src, Qi = wt.rjvId, za = wt.depth;
                  return se.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Ht ? "inline-block" : "none" } }, se.a.createElement(Il, Object.assign({ className: "click-to-add-icon" }, ir(jr, "addVarIcon"), { onClick: function() {
                    var eo = { name: za > 0 ? Ka : null, namespace: Pn.splice(0, Pn.length - 1), existing_value: mi, variable_removed: false, key_name: null };
                    Ft(mi) === "object" ? Oa.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Qi, data: eo }) : Oa.dispatch({ name: "VARIABLE_ADDED", rjvId: Qi, data: ie(ie({}, eo), {}, { new_value: [].concat(gi(mi), [null]) }) });
                  } })));
                }, Re.getRemoveObject = function(Ht) {
                  var wt = Re.props, jr = wt.theme, Pn = (wt.hover, wt.namespace), Ka = wt.name, mi = wt.src, Qi = wt.rjvId;
                  if (Pn.length !== 1)
                    return se.a.createElement("span", { className: "click-to-remove", style: { display: Ht ? "inline-block" : "none" } }, se.a.createElement(fl, Object.assign({ className: "click-to-remove-icon" }, ir(jr, "removeVarIcon"), { onClick: function() {
                      Oa.dispatch({ name: "VARIABLE_REMOVED", rjvId: Qi, data: { name: Ka, namespace: Pn.splice(0, Pn.length - 1), existing_value: mi, variable_removed: true } });
                    } })));
                }, Re.render = function() {
                  var Ht = Re.props, wt = Ht.theme, jr = Ht.onDelete, Pn = Ht.onAdd, Ka = Ht.enableClipboard, mi = Ht.src, Qi = Ht.namespace, za = Ht.rowHovered;
                  return se.a.createElement("div", Object.assign({}, ir(wt, "object-meta-data"), { className: "object-meta-data", onClick: function(eo) {
                    eo.stopPropagation();
                  } }), Re.getObjectSize(), Ka ? se.a.createElement(Ds, { rowHovered: za, clickCallback: Ka, src: mi, theme: wt, namespace: Qi }) : null, Pn !== false ? Re.getAddAttribute(za) : null, jr !== false ? Re.getRemoveObject(za) : null);
                }, Re;
              }
              return Ce;
            }(se.a.PureComponent);
            function _u(je) {
              var Ge = je.parent_type, Ce = je.namespace, Re = je.quotesOnKeys, Ne = je.theme, Dt = je.jsvRoot, or = je.name, Ht = je.displayArrayKey, wt = je.name ? je.name : "";
              return !Dt || or !== false && or !== null ? Ge == "array" ? Ht ? se.a.createElement("span", Object.assign({}, ir(Ne, "array-key"), { key: Ce }), se.a.createElement("span", { className: "array-key" }, wt), se.a.createElement("span", ir(Ne, "colon"), ":")) : se.a.createElement("span", null) : se.a.createElement("span", Object.assign({}, ir(Ne, "object-name"), { key: Ce }), se.a.createElement("span", { className: "object-key" }, Re && se.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), se.a.createElement("span", null, wt), Re && se.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), se.a.createElement("span", ir(Ne, "colon"), ":")) : se.a.createElement("span", null);
            }
            function hl(je) {
              var Ge = je.theme;
              switch (je.iconStyle) {
                case "triangle":
                  return se.a.createElement(ds, Object.assign({}, ir(Ge, "expanded-icon"), { className: "expanded-icon" }));
                case "square":
                  return se.a.createElement($i, Object.assign({}, ir(Ge, "expanded-icon"), { className: "expanded-icon" }));
                default:
                  return se.a.createElement(Bn, Object.assign({}, ir(Ge, "expanded-icon"), { className: "expanded-icon" }));
              }
            }
            function Ql(je) {
              var Ge = je.theme;
              switch (je.iconStyle) {
                case "triangle":
                  return se.a.createElement(So, Object.assign({}, ir(Ge, "collapsed-icon"), { className: "collapsed-icon" }));
                case "square":
                  return se.a.createElement(Fo, Object.assign({}, ir(Ge, "collapsed-icon"), { className: "collapsed-icon" }));
                default:
                  return se.a.createElement(ka, Object.assign({}, ir(Ge, "collapsed-icon"), { className: "collapsed-icon" }));
              }
            }
            var Cd = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).toggleCollapsed = function(Dt) {
                  var or = [];
                  for (var Ht in Ne.state.expanded)
                    or.push(Ne.state.expanded[Ht]);
                  or[Dt] = !or[Dt], Ne.setState({ expanded: or });
                }, Ne.state = { expanded: [] }, Ne;
              }
              return Pe(Ce, [{ key: "getExpandedIcon", value: function(Re) {
                var Ne = this.props, Dt = Ne.theme, or = Ne.iconStyle;
                return this.state.expanded[Re] ? se.a.createElement(hl, { theme: Dt, iconStyle: or }) : se.a.createElement(Ql, { theme: Dt, iconStyle: or });
              } }, { key: "render", value: function() {
                var Re = this, Ne = this.props, Dt = Ne.src, or = Ne.groupArraysAfterLength, Ht = (Ne.depth, Ne.name), wt = Ne.theme, jr = Ne.jsvRoot, Pn = Ne.namespace, Ka = (Ne.parent_type, Ct(Ne, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), mi = 0, Qi = 5 * this.props.indentWidth;
                jr || (mi = 5 * this.props.indentWidth);
                var za = or, eo = Math.ceil(Dt.length / za);
                return se.a.createElement("div", Object.assign({ className: "object-key-val" }, ir(wt, jr ? "jsv-root" : "objectKeyVal", { paddingLeft: mi })), se.a.createElement(_u, this.props), se.a.createElement("span", null, se.a.createElement(Zc, Object.assign({ size: Dt.length }, this.props))), gi(Array(eo)).map(function(es, ga) {
                  return se.a.createElement("div", Object.assign({ key: ga, className: "object-key-val array-group" }, ir(wt, "objectKeyVal", { marginLeft: 6, paddingLeft: Qi })), se.a.createElement("span", ir(wt, "brace-row"), se.a.createElement("div", Object.assign({ className: "icon-container" }, ir(wt, "icon-container"), { onClick: function(Is) {
                    Re.toggleCollapsed(ga);
                  } }), Re.getExpandedIcon(ga)), Re.state.expanded[ga] ? se.a.createElement(Ed, Object.assign({ key: Ht + ga, depth: 0, name: false, collapsed: false, groupArraysAfterLength: za, index_offset: ga * za, src: Dt.slice(ga * za, ga * za + za), namespace: Pn, type: "array", parent_type: "array_group", theme: wt }, Ka)) : se.a.createElement("span", Object.assign({}, ir(wt, "brace"), { onClick: function(Is) {
                    Re.toggleCollapsed(ga);
                  }, className: "array-group-brace" }), "[", se.a.createElement("div", Object.assign({}, ir(wt, "array-group-meta-data"), { className: "array-group-meta-data" }), se.a.createElement("span", Object.assign({ className: "object-size" }, ir(wt, "object-size")), ga * za, " - ", ga * za + za > Dt.length ? Dt.length : ga * za + za)), "]")));
                }));
              } }]), Ce;
            }(se.a.PureComponent), Sv = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                ve(this, Ce), (Ne = Ge.call(this, Re)).toggleCollapsed = function() {
                  Ne.setState({ expanded: !Ne.state.expanded }, function() {
                    Qa.set(Ne.props.rjvId, Ne.props.namespace, "expanded", Ne.state.expanded);
                  });
                }, Ne.getObjectContent = function(or, Ht, wt) {
                  return se.a.createElement("div", { className: "pushed-content object-container" }, se.a.createElement("div", Object.assign({ className: "object-content" }, ir(Ne.props.theme, "pushed-content")), Ne.renderObjectContents(Ht, wt)));
                }, Ne.getEllipsis = function() {
                  return Ne.state.size === 0 ? null : se.a.createElement("div", Object.assign({}, ir(Ne.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Ne.toggleCollapsed }), "...");
                }, Ne.getObjectMetaData = function(or) {
                  var Ht = Ne.props, wt = (Ht.rjvId, Ht.theme, Ne.state), jr = wt.size, Pn = wt.hovered;
                  return se.a.createElement(Zc, Object.assign({ rowHovered: Pn, size: jr }, Ne.props));
                }, Ne.renderObjectContents = function(or, Ht) {
                  var wt, jr = Ne.props, Pn = jr.depth, Ka = jr.parent_type, mi = jr.index_offset, Qi = jr.groupArraysAfterLength, za = jr.namespace, eo = Ne.state.object_type, es = [], ga = Object.keys(or || {});
                  return Ne.props.sortKeys && eo !== "array" && (ga = ga.sort()), ga.forEach(function(Is) {
                    if (wt = new e22(Is, or[Is]), Ka === "array_group" && mi && (wt.name = parseInt(wt.name) + mi), or.hasOwnProperty(Is))
                      if (wt.type === "object")
                        es.push(se.a.createElement(Ed, Object.assign({ key: wt.name, depth: Pn + 1, name: wt.name, src: wt.value, namespace: za.concat(wt.name), parent_type: eo }, Ht)));
                      else if (wt.type === "array") {
                        var Ll = Ed;
                        Qi && wt.value.length > Qi && (Ll = Cd), es.push(se.a.createElement(Ll, Object.assign({ key: wt.name, depth: Pn + 1, name: wt.name, src: wt.value, namespace: za.concat(wt.name), type: "array", parent_type: eo }, Ht)));
                      } else
                        es.push(se.a.createElement(Vu, Object.assign({ key: wt.name + "_" + za, variable: wt, singleIndent: 5, namespace: za, type: Ne.props.type }, Ht)));
                  }), es;
                };
                var Dt = Ce.getState(Re);
                return Ne.state = ie(ie({}, Dt), {}, { prevProps: {} }), Ne;
              }
              return Pe(Ce, [{ key: "getBraceStart", value: function(Re, Ne) {
                var Dt = this, or = this.props, Ht = or.src, wt = or.theme, jr = or.iconStyle;
                if (or.parent_type === "array_group")
                  return se.a.createElement("span", null, se.a.createElement("span", ir(wt, "brace"), Re === "array" ? "[" : "{"), Ne ? this.getObjectMetaData(Ht) : null);
                var Pn = Ne ? hl : Ql;
                return se.a.createElement("span", null, se.a.createElement("span", Object.assign({ onClick: function(Ka) {
                  Dt.toggleCollapsed();
                } }, ir(wt, "brace-row")), se.a.createElement("div", Object.assign({ className: "icon-container" }, ir(wt, "icon-container")), se.a.createElement(Pn, { theme: wt, iconStyle: jr })), se.a.createElement(_u, this.props), se.a.createElement("span", ir(wt, "brace"), Re === "array" ? "[" : "{")), Ne ? this.getObjectMetaData(Ht) : null);
              } }, { key: "render", value: function() {
                var Re = this, Ne = this.props, Dt = Ne.depth, or = Ne.src, Ht = (Ne.namespace, Ne.name, Ne.type, Ne.parent_type), wt = Ne.theme, jr = Ne.jsvRoot, Pn = Ne.iconStyle, Ka = Ct(Ne, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), mi = this.state, Qi = mi.object_type, za = mi.expanded, eo = {};
                return jr || Ht === "array_group" ? Ht === "array_group" && (eo.borderLeft = 0, eo.display = "inline") : eo.paddingLeft = 5 * this.props.indentWidth, se.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                  return Re.setState(ie(ie({}, Re.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return Re.setState(ie(ie({}, Re.state), {}, { hovered: false }));
                } }, ir(wt, jr ? "jsv-root" : "objectKeyVal", eo)), this.getBraceStart(Qi, za), za ? this.getObjectContent(Dt, or, ie({ theme: wt, iconStyle: Pn }, Ka)) : this.getEllipsis(), se.a.createElement("span", { className: "brace-row" }, se.a.createElement("span", { style: ie(ie({}, ir(wt, "brace").style), {}, { paddingLeft: za ? "3px" : "0px" }) }, Qi === "array" ? "]" : "}"), za ? null : this.getObjectMetaData(or)));
              } }], [{ key: "getDerivedStateFromProps", value: function(Re, Ne) {
                var Dt = Ne.prevProps;
                return Re.src !== Dt.src || Re.collapsed !== Dt.collapsed || Re.name !== Dt.name || Re.namespace !== Dt.namespace || Re.rjvId !== Dt.rjvId ? ie(ie({}, Ce.getState(Re)), {}, { prevProps: Re }) : null;
              } }]), Ce;
            }(se.a.PureComponent);
            Sv.getState = function(je) {
              var Ge = Object.keys(je.src).length, Ce = (je.collapsed === false || je.collapsed !== true && je.collapsed > je.depth) && (!je.shouldCollapse || je.shouldCollapse({ name: je.name, src: je.src, type: Ft(je.src), namespace: je.namespace }) === false) && Ge !== 0;
              return { expanded: Qa.get(je.rjvId, je.namespace, "expanded", Ce), object_type: je.type === "array" ? "array" : "object", parent_type: je.type === "array" ? "array" : "object", size: Ge, hovered: false };
            };
            var e22 = function je(Ge, Ce) {
              ve(this, je), this.name = Ge, this.value = Ce, this.type = Ft(Ce);
            };
            rr(Sv);
            var Ed = Sv, R_ = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                var Re;
                ve(this, Ce);
                for (var Ne = arguments.length, Dt = new Array(Ne), or = 0; or < Ne; or++)
                  Dt[or] = arguments[or];
                return (Re = Ge.call.apply(Ge, [this].concat(Dt))).render = function() {
                  var Ht = gt(Re).props, wt = [Ht.name], jr = Ed;
                  return Array.isArray(Ht.src) && Ht.groupArraysAfterLength && Ht.src.length > Ht.groupArraysAfterLength && (jr = Cd), se.a.createElement("div", { className: "pretty-json-container object-container" }, se.a.createElement("div", { className: "object-content" }, se.a.createElement(jr, Object.assign({ namespace: wt, depth: 0, jsvRoot: true }, Ht))));
                }, Re;
              }
              return Ce;
            }(se.a.PureComponent), F_ = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).closeModal = function() {
                  Oa.dispatch({ rjvId: Ne.props.rjvId, name: "RESET" });
                }, Ne.submit = function() {
                  Ne.props.submit(Ne.state.input);
                }, Ne.state = { input: Re.input ? Re.input : "" }, Ne;
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this, Ne = this.props, Dt = Ne.theme, or = Ne.rjvId, Ht = Ne.isValid, wt = this.state.input, jr = Ht(wt);
                return se.a.createElement("div", Object.assign({ className: "key-modal-request" }, ir(Dt, "key-modal-request"), { onClick: this.closeModal }), se.a.createElement("div", Object.assign({}, ir(Dt, "key-modal"), { onClick: function(Pn) {
                  Pn.stopPropagation();
                } }), se.a.createElement("div", ir(Dt, "key-modal-label"), "Key Name:"), se.a.createElement("div", { style: { position: "relative" } }, se.a.createElement("input", Object.assign({}, ir(Dt, "key-modal-input"), { className: "key-modal-input", ref: function(Pn) {
                  return Pn && Pn.focus();
                }, spellCheck: false, value: wt, placeholder: "...", onChange: function(Pn) {
                  Re.setState({ input: Pn.target.value });
                }, onKeyPress: function(Pn) {
                  jr && Pn.key === "Enter" ? Re.submit() : Pn.key === "Escape" && Re.closeModal();
                } })), jr ? se.a.createElement(Qo, Object.assign({}, ir(Dt, "key-modal-submit"), { className: "key-modal-submit", onClick: function(Pn) {
                  return Re.submit();
                } })) : null), se.a.createElement("span", ir(Dt, "key-modal-cancel"), se.a.createElement(Gs, Object.assign({}, ir(Dt, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                  Oa.dispatch({ rjvId: or, name: "RESET" });
                } })))));
              } }]), Ce;
            }(se.a.PureComponent), t22 = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                var Re;
                ve(this, Ce);
                for (var Ne = arguments.length, Dt = new Array(Ne), or = 0; or < Ne; or++)
                  Dt[or] = arguments[or];
                return (Re = Ge.call.apply(Ge, [this].concat(Dt))).isValid = function(Ht) {
                  var wt = Re.props.rjvId, jr = Qa.get(wt, "action", "new-key-request");
                  return Ht != "" && Object.keys(jr.existing_value).indexOf(Ht) === -1;
                }, Re.submit = function(Ht) {
                  var wt = Re.props.rjvId, jr = Qa.get(wt, "action", "new-key-request");
                  jr.new_value = ie({}, jr.existing_value), jr.new_value[Ht] = Re.props.defaultValue, Oa.dispatch({ name: "VARIABLE_ADDED", rjvId: wt, data: jr });
                }, Re;
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.active, Dt = Re.theme, or = Re.rjvId;
                return Ne ? se.a.createElement(F_, { rjvId: or, theme: Dt, isValid: this.isValid, submit: this.submit }) : null;
              } }]), Ce;
            }(se.a.PureComponent), jm = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce() {
                return ve(this, Ce), Ge.apply(this, arguments);
              }
              return Pe(Ce, [{ key: "render", value: function() {
                var Re = this.props, Ne = Re.message, Dt = Re.active, or = Re.theme, Ht = Re.rjvId;
                return Dt ? se.a.createElement("div", Object.assign({ className: "validation-failure" }, ir(or, "validation-failure"), { onClick: function() {
                  Oa.dispatch({ rjvId: Ht, name: "RESET" });
                } }), se.a.createElement("span", ir(or, "validation-failure-label"), Ne), se.a.createElement(Gs, ir(or, "validation-failure-clear"))) : null;
              } }]), Ce;
            }(se.a.PureComponent), Yp = function(je) {
              Qe(Ce, je);
              var Ge = tr(Ce);
              function Ce(Re) {
                var Ne;
                return ve(this, Ce), (Ne = Ge.call(this, Re)).rjvId = Date.now().toString(), Ne.getListeners = function() {
                  return { reset: Ne.resetState, "variable-update": Ne.updateSrc, "add-key-request": Ne.addKeyRequest };
                }, Ne.updateSrc = function() {
                  var Dt, or = Qa.get(Ne.rjvId, "action", "variable-update"), Ht = or.name, wt = or.namespace, jr = or.new_value, Pn = or.existing_value, Ka = (or.variable_removed, or.updated_src), mi = or.type, Qi = Ne.props, za = Qi.onEdit, eo = Qi.onDelete, es = Qi.onAdd, ga = { existing_src: Ne.state.src, new_value: jr, updated_src: Ka, name: Ht, namespace: wt, existing_value: Pn };
                  switch (mi) {
                    case "variable-added":
                      Dt = es(ga);
                      break;
                    case "variable-edited":
                      Dt = za(ga);
                      break;
                    case "variable-removed":
                      Dt = eo(ga);
                  }
                  Dt !== false ? (Qa.set(Ne.rjvId, "global", "src", Ka), Ne.setState({ src: Ka })) : Ne.setState({ validationFailure: true });
                }, Ne.addKeyRequest = function() {
                  Ne.setState({ addKeyRequest: true });
                }, Ne.resetState = function() {
                  Ne.setState({ validationFailure: false, addKeyRequest: false });
                }, Ne.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Ce.defaultProps.src, name: Ce.defaultProps.name, theme: Ce.defaultProps.theme, validationMessage: Ce.defaultProps.validationMessage, prevSrc: Ce.defaultProps.src, prevName: Ce.defaultProps.name, prevTheme: Ce.defaultProps.theme }, Ne;
              }
              return Pe(Ce, [{ key: "componentDidMount", value: function() {
                Qa.set(this.rjvId, "global", "src", this.state.src);
                var Re = this.getListeners();
                for (var Ne in Re)
                  Qa.on(Ne + "-" + this.rjvId, Re[Ne]);
                this.setState({ addKeyRequest: false, editKeyRequest: false });
              } }, { key: "componentDidUpdate", value: function(Re, Ne) {
                Ne.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Ne.editKeyRequest !== false && this.setState({ editKeyRequest: false }), Re.src !== this.state.src && Qa.set(this.rjvId, "global", "src", this.state.src);
              } }, { key: "componentWillUnmount", value: function() {
                var Re = this.getListeners();
                for (var Ne in Re)
                  Qa.removeListener(Ne + "-" + this.rjvId, Re[Ne]);
              } }, { key: "render", value: function() {
                var Re = this.state, Ne = Re.validationFailure, Dt = Re.validationMessage, or = Re.addKeyRequest, Ht = Re.theme, wt = Re.src, jr = Re.name, Pn = this.props, Ka = Pn.style, mi = Pn.defaultValue;
                return se.a.createElement("div", { className: "react-json-view", style: ie(ie({}, ir(Ht, "app-container").style), Ka) }, se.a.createElement(jm, { message: Dt, active: Ne, theme: Ht, rjvId: this.rjvId }), se.a.createElement(R_, Object.assign({}, this.props, { src: wt, name: jr, theme: Ht, type: Ft(wt), rjvId: this.rjvId })), se.a.createElement(t22, { active: or, theme: Ht, rjvId: this.rjvId, defaultValue: mi }));
              } }], [{ key: "getDerivedStateFromProps", value: function(Re, Ne) {
                if (Re.src !== Ne.prevSrc || Re.name !== Ne.prevName || Re.theme !== Ne.prevTheme) {
                  var Dt = { src: Re.src, name: Re.name, theme: Re.theme, validationMessage: Re.validationMessage, prevSrc: Re.src, prevName: Re.name, prevTheme: Re.theme };
                  return Ce.validateState(Dt);
                }
                return null;
              } }]), Ce;
            }(se.a.PureComponent);
            Yp.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Yp.validateState = function(je) {
              var Ge = {};
              return Ft(je.theme) !== "object" || function(Ce) {
                var Re = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                if (Ft(Ce) === "object") {
                  for (var Ne = 0; Ne < Re.length; Ne++)
                    if (!(Re[Ne] in Ce))
                      return false;
                  return true;
                }
                return false;
              }(je.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Ge.theme = "rjv-default"), Ft(je.src) !== "object" && Ft(je.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Ge.name = "ERROR", Ge.src = { message: "src property must be a valid json object" }), ie(ie({}, je), Ge);
            }, rr(Yp), F.default = Yp;
          }]);
        });
      })(aa);
      var hs = We(aa.exports);
      const nu = ({ id: A2, title: W, chart: D, option: O }) => {
        const { tool: F } = od({}), B = ct({ global: true }), [Z, { set: re }] = le(true), ie = (ve) => {
          const { updated_src: ge } = ve;
          D == null || D.setOption(ge), F == null || F.add(A2, D, ge, W), B.emit("list");
        };
        return k_("div", { children: [Sd(tt, { children: Sd(Jr, { children: Sd(Un, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (ve) => {
          re(!ve);
        } }) }) }), Sd("br", {}), O && Sd(hs, { src: O, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: Z, iconStyle: "triangle", enableClipboard: true, onEdit: ie, onAdd: ie, onDelete: ie })] });
      }, ll = () => {
        const A2 = ct({ global: true }), W = L.useRef(0), { tool: D } = od({});
        L.useState(false), L.useState("right");
        const [O, F] = L.useState([]), [B, Z] = L.useState();
        return A2.useSubscription("list", () => {
          var re;
          D != null && D.list().length && (Z((re = D == null ? void 0 : D.list()) == null ? void 0 : re[W.current]), F(D == null ? void 0 : D.list()));
        }), Sd("div", { className: Ya.container, children: false });
      };
      T.EchartTool = ll, T.ReactEchartsJson = nu, T.useEchartsTool = od, T.useEventEmitter = ct;
    })(qA);
    const dS = () => {
      const T = E({ global: true }), G = u.useRef(0), { tool: P } = $e({});
      u.useState(false), u.useState("right");
      const [I, L] = u.useState([]), [j, J] = u.useState();
      return T.useSubscription("list", () => {
        var te;
        P != null && P.list().length && (J((te = P == null ? void 0 : P.list()) == null ? void 0 : te[G.current]), L(P == null ? void 0 : P.list()));
      }), xp("div", { className: U1.container, children: false });
    };
    var pS = { exports: {} };
    (function(T, G) {
      (function(P, I) {
        T.exports = I(f2.default);
      })(m2, function(P) {
        return function(I) {
          var L = {};
          function j(J) {
            if (L[J])
              return L[J].exports;
            var te = L[J] = { i: J, l: false, exports: {} };
            return I[J].call(te.exports, te, te.exports, j), te.l = true, te.exports;
          }
          return j.m = I, j.c = L, j.d = function(J, te, Q) {
            j.o(J, te) || Object.defineProperty(J, te, { enumerable: true, get: Q });
          }, j.r = function(J) {
            typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(J, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(J, "__esModule", { value: true });
          }, j.t = function(J, te) {
            if (1 & te && (J = j(J)), 8 & te || 4 & te && typeof J == "object" && J && J.__esModule)
              return J;
            var Q = /* @__PURE__ */ Object.create(null);
            if (j.r(Q), Object.defineProperty(Q, "default", { enumerable: true, value: J }), 2 & te && typeof J != "string")
              for (var he in J)
                j.d(Q, he, function(de) {
                  return J[de];
                }.bind(null, he));
            return Q;
          }, j.n = function(J) {
            var te = J && J.__esModule ? function() {
              return J.default;
            } : function() {
              return J;
            };
            return j.d(te, "a", te), te;
          }, j.o = function(J, te) {
            return Object.prototype.hasOwnProperty.call(J, te);
          }, j.p = "", j(j.s = 48);
        }([function(I, L) {
          I.exports = P;
        }, function(I, L) {
          var j = I.exports = { version: "2.6.12" };
          typeof __e == "number" && (__e = j);
        }, function(I, L, j) {
          var J = j(26)("wks"), te = j(17), Q = j(3).Symbol, he = typeof Q == "function";
          (I.exports = function(de) {
            return J[de] || (J[de] = he && Q[de] || (he ? Q : te)("Symbol." + de));
          }).store = J;
        }, function(I, L) {
          var j = I.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
          typeof __g == "number" && (__g = j);
        }, function(I, L, j) {
          I.exports = !j(8)(function() {
            return Object.defineProperty({}, "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(I, L) {
          var j = {}.hasOwnProperty;
          I.exports = function(J, te) {
            return j.call(J, te);
          };
        }, function(I, L, j) {
          var J = j(7), te = j(16);
          I.exports = j(4) ? function(Q, he, de) {
            return J.f(Q, he, te(1, de));
          } : function(Q, he, de) {
            return Q[he] = de, Q;
          };
        }, function(I, L, j) {
          var J = j(10), te = j(35), Q = j(23), he = Object.defineProperty;
          L.f = j(4) ? Object.defineProperty : function(de, Ae, We) {
            if (J(de), Ae = Q(Ae, true), J(We), te)
              try {
                return he(de, Ae, We);
              } catch {
              }
            if ("get" in We || "set" in We)
              throw TypeError("Accessors not supported!");
            return "value" in We && (de[Ae] = We.value), de;
          };
        }, function(I, L) {
          I.exports = function(j) {
            try {
              return !!j();
            } catch {
              return true;
            }
          };
        }, function(I, L, j) {
          var J = j(40), te = j(22);
          I.exports = function(Q) {
            return J(te(Q));
          };
        }, function(I, L, j) {
          var J = j(11);
          I.exports = function(te) {
            if (!J(te))
              throw TypeError(te + " is not an object!");
            return te;
          };
        }, function(I, L) {
          I.exports = function(j) {
            return typeof j == "object" ? j !== null : typeof j == "function";
          };
        }, function(I, L) {
          I.exports = {};
        }, function(I, L, j) {
          var J = j(39), te = j(27);
          I.exports = Object.keys || function(Q) {
            return J(Q, te);
          };
        }, function(I, L) {
          I.exports = true;
        }, function(I, L, j) {
          var J = j(3), te = j(1), Q = j(53), he = j(6), de = j(5), Ae = function(We, Xe, Ze) {
            var it, ct, sr, Yt = We & Ae.F, Or = We & Ae.G, le = We & Ae.S, _t = We & Ae.P, Pt = We & Ae.B, er = We & Ae.W, Kt = Or ? te : te[Xe] || (te[Xe] = {}), St = Kt.prototype, kt = Or ? J : le ? J[Xe] : (J[Xe] || {}).prototype;
            for (it in Or && (Ze = Xe), Ze)
              (ct = !Yt && kt && kt[it] !== void 0) && de(Kt, it) || (sr = ct ? kt[it] : Ze[it], Kt[it] = Or && typeof kt[it] != "function" ? Ze[it] : Pt && ct ? Q(sr, J) : er && kt[it] == sr ? function(dr) {
                var Ir = function(ht, gn, ln) {
                  if (this instanceof dr) {
                    switch (arguments.length) {
                      case 0:
                        return new dr();
                      case 1:
                        return new dr(ht);
                      case 2:
                        return new dr(ht, gn);
                    }
                    return new dr(ht, gn, ln);
                  }
                  return dr.apply(this, arguments);
                };
                return Ir.prototype = dr.prototype, Ir;
              }(sr) : _t && typeof sr == "function" ? Q(Function.call, sr) : sr, _t && ((Kt.virtual || (Kt.virtual = {}))[it] = sr, We & Ae.R && St && !St[it] && he(St, it, sr)));
          };
          Ae.F = 1, Ae.G = 2, Ae.S = 4, Ae.P = 8, Ae.B = 16, Ae.W = 32, Ae.U = 64, Ae.R = 128, I.exports = Ae;
        }, function(I, L) {
          I.exports = function(j, J) {
            return { enumerable: !(1 & j), configurable: !(2 & j), writable: !(4 & j), value: J };
          };
        }, function(I, L) {
          var j = 0, J = Math.random();
          I.exports = function(te) {
            return "Symbol(".concat(te === void 0 ? "" : te, ")_", (++j + J).toString(36));
          };
        }, function(I, L, j) {
          var J = j(22);
          I.exports = function(te) {
            return Object(J(te));
          };
        }, function(I, L) {
          L.f = {}.propertyIsEnumerable;
        }, function(I, L, j) {
          var J = j(52)(true);
          j(34)(String, "String", function(te) {
            this._t = String(te), this._i = 0;
          }, function() {
            var te, Q = this._t, he = this._i;
            return he >= Q.length ? { value: void 0, done: true } : (te = J(Q, he), this._i += te.length, { value: te, done: false });
          });
        }, function(I, L) {
          var j = Math.ceil, J = Math.floor;
          I.exports = function(te) {
            return isNaN(te = +te) ? 0 : (te > 0 ? J : j)(te);
          };
        }, function(I, L) {
          I.exports = function(j) {
            if (j == null)
              throw TypeError("Can't call method on  " + j);
            return j;
          };
        }, function(I, L, j) {
          var J = j(11);
          I.exports = function(te, Q) {
            if (!J(te))
              return te;
            var he, de;
            if (Q && typeof (he = te.toString) == "function" && !J(de = he.call(te)) || typeof (he = te.valueOf) == "function" && !J(de = he.call(te)) || !Q && typeof (he = te.toString) == "function" && !J(de = he.call(te)))
              return de;
            throw TypeError("Can't convert object to primitive value");
          };
        }, function(I, L) {
          var j = {}.toString;
          I.exports = function(J) {
            return j.call(J).slice(8, -1);
          };
        }, function(I, L, j) {
          var J = j(26)("keys"), te = j(17);
          I.exports = function(Q) {
            return J[Q] || (J[Q] = te(Q));
          };
        }, function(I, L, j) {
          var J = j(1), te = j(3), Q = te["__core-js_shared__"] || (te["__core-js_shared__"] = {});
          (I.exports = function(he, de) {
            return Q[he] || (Q[he] = de !== void 0 ? de : {});
          })("versions", []).push({ version: J.version, mode: j(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
        }, function(I, L) {
          I.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
        }, function(I, L, j) {
          var J = j(7).f, te = j(5), Q = j(2)("toStringTag");
          I.exports = function(he, de, Ae) {
            he && !te(he = Ae ? he : he.prototype, Q) && J(he, Q, { configurable: true, value: de });
          };
        }, function(I, L, j) {
          j(62);
          for (var J = j(3), te = j(6), Q = j(12), he = j(2)("toStringTag"), de = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), Ae = 0; Ae < de.length; Ae++) {
            var We = de[Ae], Xe = J[We], Ze = Xe && Xe.prototype;
            Ze && !Ze[he] && te(Ze, he, We), Q[We] = Q.Array;
          }
        }, function(I, L, j) {
          L.f = j(2);
        }, function(I, L, j) {
          var J = j(3), te = j(1), Q = j(14), he = j(30), de = j(7).f;
          I.exports = function(Ae) {
            var We = te.Symbol || (te.Symbol = Q ? {} : J.Symbol || {});
            Ae.charAt(0) == "_" || Ae in We || de(We, Ae, { value: he.f(Ae) });
          };
        }, function(I, L) {
          L.f = Object.getOwnPropertySymbols;
        }, function(I, L) {
          I.exports = function(j, J, te) {
            return Math.min(Math.max(j, J), te);
          };
        }, function(I, L, j) {
          var J = j(14), te = j(15), Q = j(37), he = j(6), de = j(12), Ae = j(55), We = j(28), Xe = j(61), Ze = j(2)("iterator"), it = !([].keys && "next" in [].keys()), ct = function() {
            return this;
          };
          I.exports = function(sr, Yt, Or, le, _t, Pt, er) {
            Ae(Or, Yt, le);
            var Kt, St, kt, dr = function(zt) {
              if (!it && zt in ln)
                return ln[zt];
              switch (zt) {
                case "keys":
                case "values":
                  return function() {
                    return new Or(this, zt);
                  };
              }
              return function() {
                return new Or(this, zt);
              };
            }, Ir = Yt + " Iterator", ht = _t == "values", gn = false, ln = sr.prototype, Jt = ln[Ze] || ln["@@iterator"] || _t && ln[_t], In = Jt || dr(_t), ur = _t ? ht ? dr("entries") : In : void 0, Gt = Yt == "Array" && ln.entries || Jt;
            if (Gt && (kt = Xe(Gt.call(new sr()))) !== Object.prototype && kt.next && (We(kt, Ir, true), J || typeof kt[Ze] == "function" || he(kt, Ze, ct)), ht && Jt && Jt.name !== "values" && (gn = true, In = function() {
              return Jt.call(this);
            }), J && !er || !it && !gn && ln[Ze] || he(ln, Ze, In), de[Yt] = In, de[Ir] = ct, _t)
              if (Kt = { values: ht ? In : dr("values"), keys: Pt ? In : dr("keys"), entries: ur }, er)
                for (St in Kt)
                  St in ln || Q(ln, St, Kt[St]);
              else
                te(te.P + te.F * (it || gn), Yt, Kt);
            return Kt;
          };
        }, function(I, L, j) {
          I.exports = !j(4) && !j(8)(function() {
            return Object.defineProperty(j(36)("div"), "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(I, L, j) {
          var J = j(11), te = j(3).document, Q = J(te) && J(te.createElement);
          I.exports = function(he) {
            return Q ? te.createElement(he) : {};
          };
        }, function(I, L, j) {
          I.exports = j(6);
        }, function(I, L, j) {
          var J = j(10), te = j(56), Q = j(27), he = j(25)("IE_PROTO"), de = function() {
          }, Ae = function() {
            var We, Xe = j(36)("iframe"), Ze = Q.length;
            for (Xe.style.display = "none", j(60).appendChild(Xe), Xe.src = "javascript:", (We = Xe.contentWindow.document).open(), We.write("<script>document.F=Object<\/script>"), We.close(), Ae = We.F; Ze--; )
              delete Ae.prototype[Q[Ze]];
            return Ae();
          };
          I.exports = Object.create || function(We, Xe) {
            var Ze;
            return We !== null ? (de.prototype = J(We), Ze = new de(), de.prototype = null, Ze[he] = We) : Ze = Ae(), Xe === void 0 ? Ze : te(Ze, Xe);
          };
        }, function(I, L, j) {
          var J = j(5), te = j(9), Q = j(57)(false), he = j(25)("IE_PROTO");
          I.exports = function(de, Ae) {
            var We, Xe = te(de), Ze = 0, it = [];
            for (We in Xe)
              We != he && J(Xe, We) && it.push(We);
            for (; Ae.length > Ze; )
              J(Xe, We = Ae[Ze++]) && (~Q(it, We) || it.push(We));
            return it;
          };
        }, function(I, L, j) {
          var J = j(24);
          I.exports = Object("z").propertyIsEnumerable(0) ? Object : function(te) {
            return J(te) == "String" ? te.split("") : Object(te);
          };
        }, function(I, L, j) {
          var J = j(39), te = j(27).concat("length", "prototype");
          L.f = Object.getOwnPropertyNames || function(Q) {
            return J(Q, te);
          };
        }, function(I, L, j) {
          var J = j(24), te = j(2)("toStringTag"), Q = J(function() {
            return arguments;
          }()) == "Arguments";
          I.exports = function(he) {
            var de, Ae, We;
            return he === void 0 ? "Undefined" : he === null ? "Null" : typeof (Ae = function(Xe, Ze) {
              try {
                return Xe[Ze];
              } catch {
              }
            }(de = Object(he), te)) == "string" ? Ae : Q ? J(de) : (We = J(de)) == "Object" && typeof de.callee == "function" ? "Arguments" : We;
          };
        }, function(I, L) {
          var j;
          j = function() {
            return this;
          }();
          try {
            j = j || new Function("return this")();
          } catch {
            typeof window == "object" && (j = window);
          }
          I.exports = j;
        }, function(I, L) {
          var j = /-?\d+(\.\d+)?%?/g;
          I.exports = function(J) {
            return J.match(j);
          };
        }, function(I, L, j) {
          Object.defineProperty(L, "__esModule", { value: true }), L.getBase16Theme = L.createStyling = L.invertTheme = void 0;
          var J = ct(j(49)), te = ct(j(76)), Q = ct(j(81)), he = ct(j(89)), de = ct(j(93)), Ae = function(St) {
            if (St && St.__esModule)
              return St;
            var kt = {};
            if (St != null)
              for (var dr in St)
                Object.prototype.hasOwnProperty.call(St, dr) && (kt[dr] = St[dr]);
            return kt.default = St, kt;
          }(j(94)), We = ct(j(132)), Xe = ct(j(133)), Ze = ct(j(138)), it = j(139);
          function ct(St) {
            return St && St.__esModule ? St : { default: St };
          }
          var sr = Ae.default, Yt = (0, he.default)(sr), Or = (0, Ze.default)(Xe.default, it.rgb2yuv, function(St) {
            var kt, dr = (0, Q.default)(St, 3), Ir = dr[0], ht = dr[1], gn = dr[2];
            return [(kt = Ir, kt < 0.25 ? 1 : kt < 0.5 ? 0.9 - kt : 1.1 - kt), ht, gn];
          }, it.yuv2rgb, We.default), le = function(St) {
            return function(kt) {
              return { className: [kt.className, St.className].filter(Boolean).join(" "), style: (0, te.default)({}, kt.style || {}, St.style || {}) };
            };
          }, _t = function(St, kt) {
            var dr = (0, he.default)(kt);
            for (var Ir in St)
              dr.indexOf(Ir) === -1 && dr.push(Ir);
            return dr.reduce(function(ht, gn) {
              return ht[gn] = function(ln, Jt) {
                if (ln === void 0)
                  return Jt;
                if (Jt === void 0)
                  return ln;
                var In = ln === void 0 ? "undefined" : (0, J.default)(ln), ur = Jt === void 0 ? "undefined" : (0, J.default)(Jt);
                switch (In) {
                  case "string":
                    switch (ur) {
                      case "string":
                        return [Jt, ln].filter(Boolean).join(" ");
                      case "object":
                        return le({ className: ln, style: Jt });
                      case "function":
                        return function(Gt) {
                          for (var zt = arguments.length, Yr = Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
                            Yr[Vr - 1] = arguments[Vr];
                          return le({ className: ln })(Jt.apply(void 0, [Gt].concat(Yr)));
                        };
                    }
                  case "object":
                    switch (ur) {
                      case "string":
                        return le({ className: Jt, style: ln });
                      case "object":
                        return (0, te.default)({}, Jt, ln);
                      case "function":
                        return function(Gt) {
                          for (var zt = arguments.length, Yr = Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
                            Yr[Vr - 1] = arguments[Vr];
                          return le({ style: ln })(Jt.apply(void 0, [Gt].concat(Yr)));
                        };
                    }
                  case "function":
                    switch (ur) {
                      case "string":
                        return function(Gt) {
                          for (var zt = arguments.length, Yr = Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
                            Yr[Vr - 1] = arguments[Vr];
                          return ln.apply(void 0, [le(Gt)({ className: Jt })].concat(Yr));
                        };
                      case "object":
                        return function(Gt) {
                          for (var zt = arguments.length, Yr = Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
                            Yr[Vr - 1] = arguments[Vr];
                          return ln.apply(void 0, [le(Gt)({ style: Jt })].concat(Yr));
                        };
                      case "function":
                        return function(Gt) {
                          for (var zt = arguments.length, Yr = Array(zt > 1 ? zt - 1 : 0), Vr = 1; Vr < zt; Vr++)
                            Yr[Vr - 1] = arguments[Vr];
                          return ln.apply(void 0, [Jt.apply(void 0, [Gt].concat(Yr))].concat(Yr));
                        };
                    }
                }
              }(St[gn], kt[gn]), ht;
            }, {});
          }, Pt = function(St, kt) {
            for (var dr = arguments.length, Ir = Array(dr > 2 ? dr - 2 : 0), ht = 2; ht < dr; ht++)
              Ir[ht - 2] = arguments[ht];
            if (kt === null)
              return St;
            Array.isArray(kt) || (kt = [kt]);
            var gn = kt.map(function(Jt) {
              return St[Jt];
            }).filter(Boolean), ln = gn.reduce(function(Jt, In) {
              return typeof In == "string" ? Jt.className = [Jt.className, In].filter(Boolean).join(" ") : (In === void 0 ? "undefined" : (0, J.default)(In)) === "object" ? Jt.style = (0, te.default)({}, Jt.style, In) : typeof In == "function" && (Jt = (0, te.default)({}, Jt, In.apply(void 0, [Jt].concat(Ir)))), Jt;
            }, { className: "", style: {} });
            return ln.className || delete ln.className, (0, he.default)(ln.style).length === 0 && delete ln.style, ln;
          }, er = L.invertTheme = function(St) {
            return (0, he.default)(St).reduce(function(kt, dr) {
              return kt[dr] = /^base/.test(dr) ? Or(St[dr]) : dr === "scheme" ? St[dr] + ":inverted" : St[dr], kt;
            }, {});
          }, Kt = (L.createStyling = (0, de.default)(function(St) {
            for (var kt = arguments.length, dr = Array(kt > 3 ? kt - 3 : 0), Ir = 3; Ir < kt; Ir++)
              dr[Ir - 3] = arguments[Ir];
            var ht = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, gn = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, ln = ht.defaultBase16, Jt = ln === void 0 ? sr : ln, In = ht.base16Themes, ur = In === void 0 ? null : In, Gt = Kt(gn, ur);
            Gt && (gn = (0, te.default)({}, Gt, gn));
            var zt = Yt.reduce(function(Ua, ua) {
              return Ua[ua] = gn[ua] || Jt[ua], Ua;
            }, {}), Yr = (0, he.default)(gn).reduce(function(Ua, ua) {
              return Yt.indexOf(ua) === -1 && (Ua[ua] = gn[ua]), Ua;
            }, {}), Vr = St(zt), Qn = _t(Yr, Vr);
            return (0, de.default)(Pt, 2).apply(void 0, [Qn].concat(dr));
          }, 3), L.getBase16Theme = function(St, kt) {
            if (St && St.extend && (St = St.extend), typeof St == "string") {
              var dr = St.split(":"), Ir = (0, Q.default)(dr, 2), ht = Ir[0], gn = Ir[1];
              St = (kt || {})[ht] || Ae[ht], gn === "inverted" && (St = er(St));
            }
            return St && St.hasOwnProperty("base00") ? St : void 0;
          });
        }, function(I, L, j) {
          var J, te = typeof Reflect == "object" ? Reflect : null, Q = te && typeof te.apply == "function" ? te.apply : function(le, _t, Pt) {
            return Function.prototype.apply.call(le, _t, Pt);
          };
          J = te && typeof te.ownKeys == "function" ? te.ownKeys : Object.getOwnPropertySymbols ? function(le) {
            return Object.getOwnPropertyNames(le).concat(Object.getOwnPropertySymbols(le));
          } : function(le) {
            return Object.getOwnPropertyNames(le);
          };
          var he = Number.isNaN || function(le) {
            return le != le;
          };
          function de() {
            de.init.call(this);
          }
          I.exports = de, I.exports.once = function(le, _t) {
            return new Promise(function(Pt, er) {
              function Kt() {
                St !== void 0 && le.removeListener("error", St), Pt([].slice.call(arguments));
              }
              var St;
              _t !== "error" && (St = function(kt) {
                le.removeListener(_t, Kt), er(kt);
              }, le.once("error", St)), le.once(_t, Kt);
            });
          }, de.EventEmitter = de, de.prototype._events = void 0, de.prototype._eventsCount = 0, de.prototype._maxListeners = void 0;
          var Ae = 10;
          function We(le) {
            if (typeof le != "function")
              throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof le);
          }
          function Xe(le) {
            return le._maxListeners === void 0 ? de.defaultMaxListeners : le._maxListeners;
          }
          function Ze(le, _t, Pt, er) {
            var Kt, St, kt, dr;
            if (We(Pt), (St = le._events) === void 0 ? (St = le._events = /* @__PURE__ */ Object.create(null), le._eventsCount = 0) : (St.newListener !== void 0 && (le.emit("newListener", _t, Pt.listener ? Pt.listener : Pt), St = le._events), kt = St[_t]), kt === void 0)
              kt = St[_t] = Pt, ++le._eventsCount;
            else if (typeof kt == "function" ? kt = St[_t] = er ? [Pt, kt] : [kt, Pt] : er ? kt.unshift(Pt) : kt.push(Pt), (Kt = Xe(le)) > 0 && kt.length > Kt && !kt.warned) {
              kt.warned = true;
              var Ir = new Error("Possible EventEmitter memory leak detected. " + kt.length + " " + String(_t) + " listeners added. Use emitter.setMaxListeners() to increase limit");
              Ir.name = "MaxListenersExceededWarning", Ir.emitter = le, Ir.type = _t, Ir.count = kt.length, dr = Ir, console && console.warn && console.warn(dr);
            }
            return le;
          }
          function it() {
            if (!this.fired)
              return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
          }
          function ct(le, _t, Pt) {
            var er = { fired: false, wrapFn: void 0, target: le, type: _t, listener: Pt }, Kt = it.bind(er);
            return Kt.listener = Pt, er.wrapFn = Kt, Kt;
          }
          function sr(le, _t, Pt) {
            var er = le._events;
            if (er === void 0)
              return [];
            var Kt = er[_t];
            return Kt === void 0 ? [] : typeof Kt == "function" ? Pt ? [Kt.listener || Kt] : [Kt] : Pt ? function(St) {
              for (var kt = new Array(St.length), dr = 0; dr < kt.length; ++dr)
                kt[dr] = St[dr].listener || St[dr];
              return kt;
            }(Kt) : Or(Kt, Kt.length);
          }
          function Yt(le) {
            var _t = this._events;
            if (_t !== void 0) {
              var Pt = _t[le];
              if (typeof Pt == "function")
                return 1;
              if (Pt !== void 0)
                return Pt.length;
            }
            return 0;
          }
          function Or(le, _t) {
            for (var Pt = new Array(_t), er = 0; er < _t; ++er)
              Pt[er] = le[er];
            return Pt;
          }
          Object.defineProperty(de, "defaultMaxListeners", { enumerable: true, get: function() {
            return Ae;
          }, set: function(le) {
            if (typeof le != "number" || le < 0 || he(le))
              throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + le + ".");
            Ae = le;
          } }), de.init = function() {
            this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
          }, de.prototype.setMaxListeners = function(le) {
            if (typeof le != "number" || le < 0 || he(le))
              throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + le + ".");
            return this._maxListeners = le, this;
          }, de.prototype.getMaxListeners = function() {
            return Xe(this);
          }, de.prototype.emit = function(le) {
            for (var _t = [], Pt = 1; Pt < arguments.length; Pt++)
              _t.push(arguments[Pt]);
            var er = le === "error", Kt = this._events;
            if (Kt !== void 0)
              er = er && Kt.error === void 0;
            else if (!er)
              return false;
            if (er) {
              var St;
              if (_t.length > 0 && (St = _t[0]), St instanceof Error)
                throw St;
              var kt = new Error("Unhandled error." + (St ? " (" + St.message + ")" : ""));
              throw kt.context = St, kt;
            }
            var dr = Kt[le];
            if (dr === void 0)
              return false;
            if (typeof dr == "function")
              Q(dr, this, _t);
            else {
              var Ir = dr.length, ht = Or(dr, Ir);
              for (Pt = 0; Pt < Ir; ++Pt)
                Q(ht[Pt], this, _t);
            }
            return true;
          }, de.prototype.addListener = function(le, _t) {
            return Ze(this, le, _t, false);
          }, de.prototype.on = de.prototype.addListener, de.prototype.prependListener = function(le, _t) {
            return Ze(this, le, _t, true);
          }, de.prototype.once = function(le, _t) {
            return We(_t), this.on(le, ct(this, le, _t)), this;
          }, de.prototype.prependOnceListener = function(le, _t) {
            return We(_t), this.prependListener(le, ct(this, le, _t)), this;
          }, de.prototype.removeListener = function(le, _t) {
            var Pt, er, Kt, St, kt;
            if (We(_t), (er = this._events) === void 0)
              return this;
            if ((Pt = er[le]) === void 0)
              return this;
            if (Pt === _t || Pt.listener === _t)
              --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete er[le], er.removeListener && this.emit("removeListener", le, Pt.listener || _t));
            else if (typeof Pt != "function") {
              for (Kt = -1, St = Pt.length - 1; St >= 0; St--)
                if (Pt[St] === _t || Pt[St].listener === _t) {
                  kt = Pt[St].listener, Kt = St;
                  break;
                }
              if (Kt < 0)
                return this;
              Kt === 0 ? Pt.shift() : function(dr, Ir) {
                for (; Ir + 1 < dr.length; Ir++)
                  dr[Ir] = dr[Ir + 1];
                dr.pop();
              }(Pt, Kt), Pt.length === 1 && (er[le] = Pt[0]), er.removeListener !== void 0 && this.emit("removeListener", le, kt || _t);
            }
            return this;
          }, de.prototype.off = de.prototype.removeListener, de.prototype.removeAllListeners = function(le) {
            var _t, Pt, er;
            if ((Pt = this._events) === void 0)
              return this;
            if (Pt.removeListener === void 0)
              return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Pt[le] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Pt[le]), this;
            if (arguments.length === 0) {
              var Kt, St = Object.keys(Pt);
              for (er = 0; er < St.length; ++er)
                (Kt = St[er]) !== "removeListener" && this.removeAllListeners(Kt);
              return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
            }
            if (typeof (_t = Pt[le]) == "function")
              this.removeListener(le, _t);
            else if (_t !== void 0)
              for (er = _t.length - 1; er >= 0; er--)
                this.removeListener(le, _t[er]);
            return this;
          }, de.prototype.listeners = function(le) {
            return sr(this, le, true);
          }, de.prototype.rawListeners = function(le) {
            return sr(this, le, false);
          }, de.listenerCount = function(le, _t) {
            return typeof le.listenerCount == "function" ? le.listenerCount(_t) : Yt.call(le, _t);
          }, de.prototype.listenerCount = Yt, de.prototype.eventNames = function() {
            return this._eventsCount > 0 ? J(this._events) : [];
          };
        }, function(I, L, j) {
          I.exports.Dispatcher = j(140);
        }, function(I, L, j) {
          I.exports = j(142);
        }, function(I, L, j) {
          L.__esModule = true;
          var J = he(j(50)), te = he(j(65)), Q = typeof te.default == "function" && typeof J.default == "symbol" ? function(de) {
            return typeof de;
          } : function(de) {
            return de && typeof te.default == "function" && de.constructor === te.default && de !== te.default.prototype ? "symbol" : typeof de;
          };
          function he(de) {
            return de && de.__esModule ? de : { default: de };
          }
          L.default = typeof te.default == "function" && Q(J.default) === "symbol" ? function(de) {
            return de === void 0 ? "undefined" : Q(de);
          } : function(de) {
            return de && typeof te.default == "function" && de.constructor === te.default && de !== te.default.prototype ? "symbol" : de === void 0 ? "undefined" : Q(de);
          };
        }, function(I, L, j) {
          I.exports = { default: j(51), __esModule: true };
        }, function(I, L, j) {
          j(20), j(29), I.exports = j(30).f("iterator");
        }, function(I, L, j) {
          var J = j(21), te = j(22);
          I.exports = function(Q) {
            return function(he, de) {
              var Ae, We, Xe = String(te(he)), Ze = J(de), it = Xe.length;
              return Ze < 0 || Ze >= it ? Q ? "" : void 0 : (Ae = Xe.charCodeAt(Ze)) < 55296 || Ae > 56319 || Ze + 1 === it || (We = Xe.charCodeAt(Ze + 1)) < 56320 || We > 57343 ? Q ? Xe.charAt(Ze) : Ae : Q ? Xe.slice(Ze, Ze + 2) : We - 56320 + (Ae - 55296 << 10) + 65536;
            };
          };
        }, function(I, L, j) {
          var J = j(54);
          I.exports = function(te, Q, he) {
            if (J(te), Q === void 0)
              return te;
            switch (he) {
              case 1:
                return function(de) {
                  return te.call(Q, de);
                };
              case 2:
                return function(de, Ae) {
                  return te.call(Q, de, Ae);
                };
              case 3:
                return function(de, Ae, We) {
                  return te.call(Q, de, Ae, We);
                };
            }
            return function() {
              return te.apply(Q, arguments);
            };
          };
        }, function(I, L) {
          I.exports = function(j) {
            if (typeof j != "function")
              throw TypeError(j + " is not a function!");
            return j;
          };
        }, function(I, L, j) {
          var J = j(38), te = j(16), Q = j(28), he = {};
          j(6)(he, j(2)("iterator"), function() {
            return this;
          }), I.exports = function(de, Ae, We) {
            de.prototype = J(he, { next: te(1, We) }), Q(de, Ae + " Iterator");
          };
        }, function(I, L, j) {
          var J = j(7), te = j(10), Q = j(13);
          I.exports = j(4) ? Object.defineProperties : function(he, de) {
            te(he);
            for (var Ae, We = Q(de), Xe = We.length, Ze = 0; Xe > Ze; )
              J.f(he, Ae = We[Ze++], de[Ae]);
            return he;
          };
        }, function(I, L, j) {
          var J = j(9), te = j(58), Q = j(59);
          I.exports = function(he) {
            return function(de, Ae, We) {
              var Xe, Ze = J(de), it = te(Ze.length), ct = Q(We, it);
              if (he && Ae != Ae) {
                for (; it > ct; )
                  if ((Xe = Ze[ct++]) != Xe)
                    return true;
              } else
                for (; it > ct; ct++)
                  if ((he || ct in Ze) && Ze[ct] === Ae)
                    return he || ct || 0;
              return !he && -1;
            };
          };
        }, function(I, L, j) {
          var J = j(21), te = Math.min;
          I.exports = function(Q) {
            return Q > 0 ? te(J(Q), 9007199254740991) : 0;
          };
        }, function(I, L, j) {
          var J = j(21), te = Math.max, Q = Math.min;
          I.exports = function(he, de) {
            return (he = J(he)) < 0 ? te(he + de, 0) : Q(he, de);
          };
        }, function(I, L, j) {
          var J = j(3).document;
          I.exports = J && J.documentElement;
        }, function(I, L, j) {
          var J = j(5), te = j(18), Q = j(25)("IE_PROTO"), he = Object.prototype;
          I.exports = Object.getPrototypeOf || function(de) {
            return de = te(de), J(de, Q) ? de[Q] : typeof de.constructor == "function" && de instanceof de.constructor ? de.constructor.prototype : de instanceof Object ? he : null;
          };
        }, function(I, L, j) {
          var J = j(63), te = j(64), Q = j(12), he = j(9);
          I.exports = j(34)(Array, "Array", function(de, Ae) {
            this._t = he(de), this._i = 0, this._k = Ae;
          }, function() {
            var de = this._t, Ae = this._k, We = this._i++;
            return !de || We >= de.length ? (this._t = void 0, te(1)) : te(0, Ae == "keys" ? We : Ae == "values" ? de[We] : [We, de[We]]);
          }, "values"), Q.Arguments = Q.Array, J("keys"), J("values"), J("entries");
        }, function(I, L) {
          I.exports = function() {
          };
        }, function(I, L) {
          I.exports = function(j, J) {
            return { value: J, done: !!j };
          };
        }, function(I, L, j) {
          I.exports = { default: j(66), __esModule: true };
        }, function(I, L, j) {
          j(67), j(73), j(74), j(75), I.exports = j(1).Symbol;
        }, function(I, L, j) {
          var J = j(3), te = j(5), Q = j(4), he = j(15), de = j(37), Ae = j(68).KEY, We = j(8), Xe = j(26), Ze = j(28), it = j(17), ct = j(2), sr = j(30), Yt = j(31), Or = j(69), le = j(70), _t = j(10), Pt = j(11), er = j(18), Kt = j(9), St = j(23), kt = j(16), dr = j(38), Ir = j(71), ht = j(72), gn = j(32), ln = j(7), Jt = j(13), In = ht.f, ur = ln.f, Gt = Ir.f, zt = J.Symbol, Yr = J.JSON, Vr = Yr && Yr.stringify, Qn = ct("_hidden"), Ua = ct("toPrimitive"), ua = {}.propertyIsEnumerable, Pa = Xe("symbol-registry"), qi = Xe("symbols"), Ha = Xe("op-symbols"), pi = Object.prototype, Lo = typeof zt == "function" && !!gn.f, rl = J.QObject, is = !rl || !rl.prototype || !rl.prototype.findChild, Xs = Q && We(function() {
            return dr(ur({}, "a", { get: function() {
              return ur(this, "a", { value: 7 }).a;
            } })).a != 7;
          }) ? function(Rt, _r, tn) {
            var Sn = In(pi, _r);
            Sn && delete pi[_r], ur(Rt, _r, tn), Sn && Rt !== pi && ur(pi, _r, Sn);
          } : ur, qo = function(Rt) {
            var _r = qi[Rt] = dr(zt.prototype);
            return _r._k = Rt, _r;
          }, du = Lo && typeof zt.iterator == "symbol" ? function(Rt) {
            return typeof Rt == "symbol";
          } : function(Rt) {
            return Rt instanceof zt;
          }, nl = function(Rt, _r, tn) {
            return Rt === pi && nl(Ha, _r, tn), _t(Rt), _r = St(_r, true), _t(tn), te(qi, _r) ? (tn.enumerable ? (te(Rt, Qn) && Rt[Qn][_r] && (Rt[Qn][_r] = false), tn = dr(tn, { enumerable: kt(0, false) })) : (te(Rt, Qn) || ur(Rt, Qn, kt(1, {})), Rt[Qn][_r] = true), Xs(Rt, _r, tn)) : ur(Rt, _r, tn);
          }, os = function(Rt, _r) {
            _t(Rt);
            for (var tn, Sn = Or(_r = Kt(_r)), Ca = 0, wa = Sn.length; wa > Ca; )
              nl(Rt, tn = Sn[Ca++], _r[tn]);
            return Rt;
          }, Rn = function(Rt) {
            var _r = ua.call(this, Rt = St(Rt, true));
            return !(this === pi && te(qi, Rt) && !te(Ha, Rt)) && (!(_r || !te(this, Rt) || !te(qi, Rt) || te(this, Qn) && this[Qn][Rt]) || _r);
          }, Tl = function(Rt, _r) {
            if (Rt = Kt(Rt), _r = St(_r, true), Rt !== pi || !te(qi, _r) || te(Ha, _r)) {
              var tn = In(Rt, _r);
              return !tn || !te(qi, _r) || te(Rt, Qn) && Rt[Qn][_r] || (tn.enumerable = true), tn;
            }
          }, Iu = function(Rt) {
            for (var _r, tn = Gt(Kt(Rt)), Sn = [], Ca = 0; tn.length > Ca; )
              te(qi, _r = tn[Ca++]) || _r == Qn || _r == Ae || Sn.push(_r);
            return Sn;
          }, so = function(Rt) {
            for (var _r, tn = Rt === pi, Sn = Gt(tn ? Ha : Kt(Rt)), Ca = [], wa = 0; Sn.length > wa; )
              !te(qi, _r = Sn[wa++]) || tn && !te(pi, _r) || Ca.push(qi[_r]);
            return Ca;
          };
          Lo || (de((zt = function() {
            if (this instanceof zt)
              throw TypeError("Symbol is not a constructor!");
            var Rt = it(arguments.length > 0 ? arguments[0] : void 0), _r = function(tn) {
              this === pi && _r.call(Ha, tn), te(this, Qn) && te(this[Qn], Rt) && (this[Qn][Rt] = false), Xs(this, Rt, kt(1, tn));
            };
            return Q && is && Xs(pi, Rt, { configurable: true, set: _r }), qo(Rt);
          }).prototype, "toString", function() {
            return this._k;
          }), ht.f = Tl, ln.f = nl, j(41).f = Ir.f = Iu, j(19).f = Rn, gn.f = so, Q && !j(14) && de(pi, "propertyIsEnumerable", Rn, true), sr.f = function(Rt) {
            return qo(ct(Rt));
          }), he(he.G + he.W + he.F * !Lo, { Symbol: zt });
          for (var Fs = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Oo = 0; Fs.length > Oo; )
            ct(Fs[Oo++]);
          for (var mc = Jt(ct.store), nr = 0; mc.length > nr; )
            Yt(mc[nr++]);
          he(he.S + he.F * !Lo, "Symbol", { for: function(Rt) {
            return te(Pa, Rt += "") ? Pa[Rt] : Pa[Rt] = zt(Rt);
          }, keyFor: function(Rt) {
            if (!du(Rt))
              throw TypeError(Rt + " is not a symbol!");
            for (var _r in Pa)
              if (Pa[_r] === Rt)
                return _r;
          }, useSetter: function() {
            is = true;
          }, useSimple: function() {
            is = false;
          } }), he(he.S + he.F * !Lo, "Object", { create: function(Rt, _r) {
            return _r === void 0 ? dr(Rt) : os(dr(Rt), _r);
          }, defineProperty: nl, defineProperties: os, getOwnPropertyDescriptor: Tl, getOwnPropertyNames: Iu, getOwnPropertySymbols: so });
          var Nt = We(function() {
            gn.f(1);
          });
          he(he.S + he.F * Nt, "Object", { getOwnPropertySymbols: function(Rt) {
            return gn.f(er(Rt));
          } }), Yr && he(he.S + he.F * (!Lo || We(function() {
            var Rt = zt();
            return Vr([Rt]) != "[null]" || Vr({ a: Rt }) != "{}" || Vr(Object(Rt)) != "{}";
          })), "JSON", { stringify: function(Rt) {
            for (var _r, tn, Sn = [Rt], Ca = 1; arguments.length > Ca; )
              Sn.push(arguments[Ca++]);
            if (tn = _r = Sn[1], (Pt(_r) || Rt !== void 0) && !du(Rt))
              return le(_r) || (_r = function(wa, Di) {
                if (typeof tn == "function" && (Di = tn.call(this, wa, Di)), !du(Di))
                  return Di;
              }), Sn[1] = _r, Vr.apply(Yr, Sn);
          } }), zt.prototype[Ua] || j(6)(zt.prototype, Ua, zt.prototype.valueOf), Ze(zt, "Symbol"), Ze(Math, "Math", true), Ze(J.JSON, "JSON", true);
        }, function(I, L, j) {
          var J = j(17)("meta"), te = j(11), Q = j(5), he = j(7).f, de = 0, Ae = Object.isExtensible || function() {
            return true;
          }, We = !j(8)(function() {
            return Ae(Object.preventExtensions({}));
          }), Xe = function(it) {
            he(it, J, { value: { i: "O" + ++de, w: {} } });
          }, Ze = I.exports = { KEY: J, NEED: false, fastKey: function(it, ct) {
            if (!te(it))
              return typeof it == "symbol" ? it : (typeof it == "string" ? "S" : "P") + it;
            if (!Q(it, J)) {
              if (!Ae(it))
                return "F";
              if (!ct)
                return "E";
              Xe(it);
            }
            return it[J].i;
          }, getWeak: function(it, ct) {
            if (!Q(it, J)) {
              if (!Ae(it))
                return true;
              if (!ct)
                return false;
              Xe(it);
            }
            return it[J].w;
          }, onFreeze: function(it) {
            return We && Ze.NEED && Ae(it) && !Q(it, J) && Xe(it), it;
          } };
        }, function(I, L, j) {
          var J = j(13), te = j(32), Q = j(19);
          I.exports = function(he) {
            var de = J(he), Ae = te.f;
            if (Ae)
              for (var We, Xe = Ae(he), Ze = Q.f, it = 0; Xe.length > it; )
                Ze.call(he, We = Xe[it++]) && de.push(We);
            return de;
          };
        }, function(I, L, j) {
          var J = j(24);
          I.exports = Array.isArray || function(te) {
            return J(te) == "Array";
          };
        }, function(I, L, j) {
          var J = j(9), te = j(41).f, Q = {}.toString, he = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
          I.exports.f = function(de) {
            return he && Q.call(de) == "[object Window]" ? function(Ae) {
              try {
                return te(Ae);
              } catch {
                return he.slice();
              }
            }(de) : te(J(de));
          };
        }, function(I, L, j) {
          var J = j(19), te = j(16), Q = j(9), he = j(23), de = j(5), Ae = j(35), We = Object.getOwnPropertyDescriptor;
          L.f = j(4) ? We : function(Xe, Ze) {
            if (Xe = Q(Xe), Ze = he(Ze, true), Ae)
              try {
                return We(Xe, Ze);
              } catch {
              }
            if (de(Xe, Ze))
              return te(!J.f.call(Xe, Ze), Xe[Ze]);
          };
        }, function(I, L) {
        }, function(I, L, j) {
          j(31)("asyncIterator");
        }, function(I, L, j) {
          j(31)("observable");
        }, function(I, L, j) {
          L.__esModule = true;
          var J, te = j(77), Q = (J = te) && J.__esModule ? J : { default: J };
          L.default = Q.default || function(he) {
            for (var de = 1; de < arguments.length; de++) {
              var Ae = arguments[de];
              for (var We in Ae)
                Object.prototype.hasOwnProperty.call(Ae, We) && (he[We] = Ae[We]);
            }
            return he;
          };
        }, function(I, L, j) {
          I.exports = { default: j(78), __esModule: true };
        }, function(I, L, j) {
          j(79), I.exports = j(1).Object.assign;
        }, function(I, L, j) {
          var J = j(15);
          J(J.S + J.F, "Object", { assign: j(80) });
        }, function(I, L, j) {
          var J = j(4), te = j(13), Q = j(32), he = j(19), de = j(18), Ae = j(40), We = Object.assign;
          I.exports = !We || j(8)(function() {
            var Xe = {}, Ze = {}, it = Symbol(), ct = "abcdefghijklmnopqrst";
            return Xe[it] = 7, ct.split("").forEach(function(sr) {
              Ze[sr] = sr;
            }), We({}, Xe)[it] != 7 || Object.keys(We({}, Ze)).join("") != ct;
          }) ? function(Xe, Ze) {
            for (var it = de(Xe), ct = arguments.length, sr = 1, Yt = Q.f, Or = he.f; ct > sr; )
              for (var le, _t = Ae(arguments[sr++]), Pt = Yt ? te(_t).concat(Yt(_t)) : te(_t), er = Pt.length, Kt = 0; er > Kt; )
                le = Pt[Kt++], J && !Or.call(_t, le) || (it[le] = _t[le]);
            return it;
          } : We;
        }, function(I, L, j) {
          L.__esModule = true;
          var J = Q(j(82)), te = Q(j(85));
          function Q(he) {
            return he && he.__esModule ? he : { default: he };
          }
          L.default = function(he, de) {
            if (Array.isArray(he))
              return he;
            if ((0, J.default)(Object(he)))
              return function(Ae, We) {
                var Xe = [], Ze = true, it = false, ct = void 0;
                try {
                  for (var sr, Yt = (0, te.default)(Ae); !(Ze = (sr = Yt.next()).done) && (Xe.push(sr.value), !We || Xe.length !== We); Ze = true)
                    ;
                } catch (Or) {
                  it = true, ct = Or;
                } finally {
                  try {
                    !Ze && Yt.return && Yt.return();
                  } finally {
                    if (it)
                      throw ct;
                  }
                }
                return Xe;
              }(he, de);
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          };
        }, function(I, L, j) {
          I.exports = { default: j(83), __esModule: true };
        }, function(I, L, j) {
          j(29), j(20), I.exports = j(84);
        }, function(I, L, j) {
          var J = j(42), te = j(2)("iterator"), Q = j(12);
          I.exports = j(1).isIterable = function(he) {
            var de = Object(he);
            return de[te] !== void 0 || "@@iterator" in de || Q.hasOwnProperty(J(de));
          };
        }, function(I, L, j) {
          I.exports = { default: j(86), __esModule: true };
        }, function(I, L, j) {
          j(29), j(20), I.exports = j(87);
        }, function(I, L, j) {
          var J = j(10), te = j(88);
          I.exports = j(1).getIterator = function(Q) {
            var he = te(Q);
            if (typeof he != "function")
              throw TypeError(Q + " is not iterable!");
            return J(he.call(Q));
          };
        }, function(I, L, j) {
          var J = j(42), te = j(2)("iterator"), Q = j(12);
          I.exports = j(1).getIteratorMethod = function(he) {
            if (he != null)
              return he[te] || he["@@iterator"] || Q[J(he)];
          };
        }, function(I, L, j) {
          I.exports = { default: j(90), __esModule: true };
        }, function(I, L, j) {
          j(91), I.exports = j(1).Object.keys;
        }, function(I, L, j) {
          var J = j(18), te = j(13);
          j(92)("keys", function() {
            return function(Q) {
              return te(J(Q));
            };
          });
        }, function(I, L, j) {
          var J = j(15), te = j(1), Q = j(8);
          I.exports = function(he, de) {
            var Ae = (te.Object || {})[he] || Object[he], We = {};
            We[he] = de(Ae), J(J.S + J.F * Q(function() {
              Ae(1);
            }), "Object", We);
          };
        }, function(I, L, j) {
          (function(J) {
            var te = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], Q = /^\s+|\s+$/g, he = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, de = /\{\n\/\* \[wrapped with (.+)\] \*/, Ae = /,? & /, We = /^[-+]0x[0-9a-f]+$/i, Xe = /^0b[01]+$/i, Ze = /^\[object .+?Constructor\]$/, it = /^0o[0-7]+$/i, ct = /^(?:0|[1-9]\d*)$/, sr = parseInt, Yt = typeof J == "object" && J && J.Object === Object && J, Or = typeof self == "object" && self && self.Object === Object && self, le = Yt || Or || Function("return this")();
            function _t(nr, Nt, Rt) {
              switch (Rt.length) {
                case 0:
                  return nr.call(Nt);
                case 1:
                  return nr.call(Nt, Rt[0]);
                case 2:
                  return nr.call(Nt, Rt[0], Rt[1]);
                case 3:
                  return nr.call(Nt, Rt[0], Rt[1], Rt[2]);
              }
              return nr.apply(Nt, Rt);
            }
            function Pt(nr, Nt) {
              return !!(nr && nr.length) && function(Rt, _r, tn) {
                if (_r != _r)
                  return function(wa, Di, Mi, Da) {
                    for (var ko = wa.length, uo = Mi + (Da ? 1 : -1); Da ? uo-- : ++uo < ko; )
                      if (Di(wa[uo], uo, wa))
                        return uo;
                    return -1;
                  }(Rt, er, tn);
                for (var Sn = tn - 1, Ca = Rt.length; ++Sn < Ca; )
                  if (Rt[Sn] === _r)
                    return Sn;
                return -1;
              }(nr, Nt, 0) > -1;
            }
            function er(nr) {
              return nr != nr;
            }
            function Kt(nr, Nt) {
              for (var Rt = nr.length, _r = 0; Rt--; )
                nr[Rt] === Nt && _r++;
              return _r;
            }
            function St(nr, Nt) {
              for (var Rt = -1, _r = nr.length, tn = 0, Sn = []; ++Rt < _r; ) {
                var Ca = nr[Rt];
                Ca !== Nt && Ca !== "__lodash_placeholder__" || (nr[Rt] = "__lodash_placeholder__", Sn[tn++] = Rt);
              }
              return Sn;
            }
            var kt, dr, Ir, ht = Function.prototype, gn = Object.prototype, ln = le["__core-js_shared__"], Jt = (kt = /[^.]+$/.exec(ln && ln.keys && ln.keys.IE_PROTO || "")) ? "Symbol(src)_1." + kt : "", In = ht.toString, ur = gn.hasOwnProperty, Gt = gn.toString, zt = RegExp("^" + In.call(ur).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), Yr = Object.create, Vr = Math.max, Qn = Math.min, Ua = (dr = qo(Object, "defineProperty"), (Ir = qo.name) && Ir.length > 2 ? dr : void 0);
            function ua(nr) {
              return Fs(nr) ? Yr(nr) : {};
            }
            function Pa(nr) {
              return !(!Fs(nr) || function(Nt) {
                return !!Jt && Jt in Nt;
              }(nr)) && (function(Nt) {
                var Rt = Fs(Nt) ? Gt.call(Nt) : "";
                return Rt == "[object Function]" || Rt == "[object GeneratorFunction]";
              }(nr) || function(Nt) {
                var Rt = false;
                if (Nt != null && typeof Nt.toString != "function")
                  try {
                    Rt = !!(Nt + "");
                  } catch {
                  }
                return Rt;
              }(nr) ? zt : Ze).test(function(Nt) {
                if (Nt != null) {
                  try {
                    return In.call(Nt);
                  } catch {
                  }
                  try {
                    return Nt + "";
                  } catch {
                  }
                }
                return "";
              }(nr));
            }
            function qi(nr, Nt, Rt, _r) {
              for (var tn = -1, Sn = nr.length, Ca = Rt.length, wa = -1, Di = Nt.length, Mi = Vr(Sn - Ca, 0), Da = Array(Di + Mi), ko = !_r; ++wa < Di; )
                Da[wa] = Nt[wa];
              for (; ++tn < Ca; )
                (ko || tn < Sn) && (Da[Rt[tn]] = nr[tn]);
              for (; Mi--; )
                Da[wa++] = nr[tn++];
              return Da;
            }
            function Ha(nr, Nt, Rt, _r) {
              for (var tn = -1, Sn = nr.length, Ca = -1, wa = Rt.length, Di = -1, Mi = Nt.length, Da = Vr(Sn - wa, 0), ko = Array(Da + Mi), uo = !_r; ++tn < Da; )
                ko[tn] = nr[tn];
              for (var xs = tn; ++Di < Mi; )
                ko[xs + Di] = Nt[Di];
              for (; ++Ca < wa; )
                (uo || tn < Sn) && (ko[xs + Rt[Ca]] = nr[tn++]);
              return ko;
            }
            function pi(nr) {
              return function() {
                var Nt = arguments;
                switch (Nt.length) {
                  case 0:
                    return new nr();
                  case 1:
                    return new nr(Nt[0]);
                  case 2:
                    return new nr(Nt[0], Nt[1]);
                  case 3:
                    return new nr(Nt[0], Nt[1], Nt[2]);
                  case 4:
                    return new nr(Nt[0], Nt[1], Nt[2], Nt[3]);
                  case 5:
                    return new nr(Nt[0], Nt[1], Nt[2], Nt[3], Nt[4]);
                  case 6:
                    return new nr(Nt[0], Nt[1], Nt[2], Nt[3], Nt[4], Nt[5]);
                  case 7:
                    return new nr(Nt[0], Nt[1], Nt[2], Nt[3], Nt[4], Nt[5], Nt[6]);
                }
                var Rt = ua(nr.prototype), _r = nr.apply(Rt, Nt);
                return Fs(_r) ? _r : Rt;
              };
            }
            function Lo(nr, Nt, Rt, _r, tn, Sn, Ca, wa, Di, Mi) {
              var Da = 128 & Nt, ko = 1 & Nt, uo = 2 & Nt, xs = 24 & Nt, Lu = 512 & Nt, Ul = uo ? void 0 : pi(nr);
              return function ws() {
                for (var Go = arguments.length, qa = Array(Go), Ss = Go; Ss--; )
                  qa[Ss] = arguments[Ss];
                if (xs)
                  var Js = Xs(ws), al = Kt(qa, Js);
                if (_r && (qa = qi(qa, _r, tn, xs)), Sn && (qa = Ha(qa, Sn, Ca, xs)), Go -= al, xs && Go < Mi) {
                  var Ou = St(qa, Js);
                  return rl(nr, Nt, Lo, ws.placeholder, Rt, qa, Ou, wa, Di, Mi - Go);
                }
                var pu = ko ? Rt : this, il = uo ? pu[nr] : nr;
                return Go = qa.length, wa ? qa = Rn(qa, wa) : Lu && Go > 1 && qa.reverse(), Da && Di < Go && (qa.length = Di), this && this !== le && this instanceof ws && (il = Ul || pi(il)), il.apply(pu, qa);
              };
            }
            function rl(nr, Nt, Rt, _r, tn, Sn, Ca, wa, Di, Mi) {
              var Da = 8 & Nt;
              Nt |= Da ? 32 : 64, 4 & (Nt &= ~(Da ? 64 : 32)) || (Nt &= -4);
              var ko = Rt(nr, Nt, tn, Da ? Sn : void 0, Da ? Ca : void 0, Da ? void 0 : Sn, Da ? void 0 : Ca, wa, Di, Mi);
              return ko.placeholder = _r, Tl(ko, nr, Nt);
            }
            function is(nr, Nt, Rt, _r, tn, Sn, Ca, wa) {
              var Di = 2 & Nt;
              if (!Di && typeof nr != "function")
                throw new TypeError("Expected a function");
              var Mi = _r ? _r.length : 0;
              if (Mi || (Nt &= -97, _r = tn = void 0), Ca = Ca === void 0 ? Ca : Vr(mc(Ca), 0), wa = wa === void 0 ? wa : mc(wa), Mi -= tn ? tn.length : 0, 64 & Nt) {
                var Da = _r, ko = tn;
                _r = tn = void 0;
              }
              var uo = [nr, Nt, Rt, _r, tn, Da, ko, Sn, Ca, wa];
              if (nr = uo[0], Nt = uo[1], Rt = uo[2], _r = uo[3], tn = uo[4], !(wa = uo[9] = uo[9] == null ? Di ? 0 : nr.length : Vr(uo[9] - Mi, 0)) && 24 & Nt && (Nt &= -25), Nt && Nt != 1)
                xs = Nt == 8 || Nt == 16 ? function(Lu, Ul, ws) {
                  var Go = pi(Lu);
                  return function qa() {
                    for (var Ss = arguments.length, Js = Array(Ss), al = Ss, Ou = Xs(qa); al--; )
                      Js[al] = arguments[al];
                    var pu = Ss < 3 && Js[0] !== Ou && Js[Ss - 1] !== Ou ? [] : St(Js, Ou);
                    if ((Ss -= pu.length) < ws)
                      return rl(Lu, Ul, Lo, qa.placeholder, void 0, Js, pu, void 0, void 0, ws - Ss);
                    var il = this && this !== le && this instanceof qa ? Go : Lu;
                    return _t(il, this, Js);
                  };
                }(nr, Nt, wa) : Nt != 32 && Nt != 33 || tn.length ? Lo.apply(void 0, uo) : function(Lu, Ul, ws, Go) {
                  var qa = 1 & Ul, Ss = pi(Lu);
                  return function Js() {
                    for (var al = -1, Ou = arguments.length, pu = -1, il = Go.length, uh = Array(il + Ou), bc = this && this !== le && this instanceof Js ? Ss : Lu; ++pu < il; )
                      uh[pu] = Go[pu];
                    for (; Ou--; )
                      uh[pu++] = arguments[++al];
                    return _t(bc, qa ? ws : this, uh);
                  };
                }(nr, Nt, Rt, _r);
              else
                var xs = function(Lu, Ul, ws) {
                  var Go = 1 & Ul, qa = pi(Lu);
                  return function Ss() {
                    var Js = this && this !== le && this instanceof Ss ? qa : Lu;
                    return Js.apply(Go ? ws : this, arguments);
                  };
                }(nr, Nt, Rt);
              return Tl(xs, nr, Nt);
            }
            function Xs(nr) {
              return nr.placeholder;
            }
            function qo(nr, Nt) {
              var Rt = function(_r, tn) {
                return _r == null ? void 0 : _r[tn];
              }(nr, Nt);
              return Pa(Rt) ? Rt : void 0;
            }
            function du(nr) {
              var Nt = nr.match(de);
              return Nt ? Nt[1].split(Ae) : [];
            }
            function nl(nr, Nt) {
              var Rt = Nt.length, _r = Rt - 1;
              return Nt[_r] = (Rt > 1 ? "& " : "") + Nt[_r], Nt = Nt.join(Rt > 2 ? ", " : " "), nr.replace(he, `{
/* [wrapped with ` + Nt + `] */
`);
            }
            function os(nr, Nt) {
              return !!(Nt = Nt == null ? 9007199254740991 : Nt) && (typeof nr == "number" || ct.test(nr)) && nr > -1 && nr % 1 == 0 && nr < Nt;
            }
            function Rn(nr, Nt) {
              for (var Rt = nr.length, _r = Qn(Nt.length, Rt), tn = function(Ca, wa) {
                var Di = -1, Mi = Ca.length;
                for (wa || (wa = Array(Mi)); ++Di < Mi; )
                  wa[Di] = Ca[Di];
                return wa;
              }(nr); _r--; ) {
                var Sn = Nt[_r];
                nr[_r] = os(Sn, Rt) ? tn[Sn] : void 0;
              }
              return nr;
            }
            var Tl = Ua ? function(nr, Nt, Rt) {
              var _r, tn = Nt + "";
              return Ua(nr, "toString", { configurable: true, enumerable: false, value: (_r = nl(tn, Iu(du(tn), Rt)), function() {
                return _r;
              }) });
            } : function(nr) {
              return nr;
            };
            function Iu(nr, Nt) {
              return function(Rt, _r) {
                for (var tn = -1, Sn = Rt ? Rt.length : 0; ++tn < Sn && _r(Rt[tn], tn, Rt) !== false; )
                  ;
              }(te, function(Rt) {
                var _r = "_." + Rt[0];
                Nt & Rt[1] && !Pt(nr, _r) && nr.push(_r);
              }), nr.sort();
            }
            function so(nr, Nt, Rt) {
              var _r = is(nr, 8, void 0, void 0, void 0, void 0, void 0, Nt = Rt ? void 0 : Nt);
              return _r.placeholder = so.placeholder, _r;
            }
            function Fs(nr) {
              var Nt = typeof nr;
              return !!nr && (Nt == "object" || Nt == "function");
            }
            function Oo(nr) {
              return nr ? (nr = function(Nt) {
                if (typeof Nt == "number")
                  return Nt;
                if (function(tn) {
                  return typeof tn == "symbol" || function(Sn) {
                    return !!Sn && typeof Sn == "object";
                  }(tn) && Gt.call(tn) == "[object Symbol]";
                }(Nt))
                  return NaN;
                if (Fs(Nt)) {
                  var Rt = typeof Nt.valueOf == "function" ? Nt.valueOf() : Nt;
                  Nt = Fs(Rt) ? Rt + "" : Rt;
                }
                if (typeof Nt != "string")
                  return Nt === 0 ? Nt : +Nt;
                Nt = Nt.replace(Q, "");
                var _r = Xe.test(Nt);
                return _r || it.test(Nt) ? sr(Nt.slice(2), _r ? 2 : 8) : We.test(Nt) ? NaN : +Nt;
              }(nr)) === 1 / 0 || nr === -1 / 0 ? 17976931348623157e292 * (nr < 0 ? -1 : 1) : nr == nr ? nr : 0 : nr === 0 ? nr : 0;
            }
            function mc(nr) {
              var Nt = Oo(nr), Rt = Nt % 1;
              return Nt == Nt ? Rt ? Nt - Rt : Nt : 0;
            }
            so.placeholder = {}, I.exports = so;
          }).call(this, j(43));
        }, function(I, L, j) {
          function J(Ha) {
            return Ha && Ha.__esModule ? Ha.default : Ha;
          }
          L.__esModule = true;
          var te = j(95);
          L.threezerotwofour = J(te);
          var Q = j(96);
          L.apathy = J(Q);
          var he = j(97);
          L.ashes = J(he);
          var de = j(98);
          L.atelierDune = J(de);
          var Ae = j(99);
          L.atelierForest = J(Ae);
          var We = j(100);
          L.atelierHeath = J(We);
          var Xe = j(101);
          L.atelierLakeside = J(Xe);
          var Ze = j(102);
          L.atelierSeaside = J(Ze);
          var it = j(103);
          L.bespin = J(it);
          var ct = j(104);
          L.brewer = J(ct);
          var sr = j(105);
          L.bright = J(sr);
          var Yt = j(106);
          L.chalk = J(Yt);
          var Or = j(107);
          L.codeschool = J(Or);
          var le = j(108);
          L.colors = J(le);
          var _t = j(109);
          L.default = J(_t);
          var Pt = j(110);
          L.eighties = J(Pt);
          var er = j(111);
          L.embers = J(er);
          var Kt = j(112);
          L.flat = J(Kt);
          var St = j(113);
          L.google = J(St);
          var kt = j(114);
          L.grayscale = J(kt);
          var dr = j(115);
          L.greenscreen = J(dr);
          var Ir = j(116);
          L.harmonic = J(Ir);
          var ht = j(117);
          L.hopscotch = J(ht);
          var gn = j(118);
          L.isotope = J(gn);
          var ln = j(119);
          L.marrakesh = J(ln);
          var Jt = j(120);
          L.mocha = J(Jt);
          var In = j(121);
          L.monokai = J(In);
          var ur = j(122);
          L.ocean = J(ur);
          var Gt = j(123);
          L.paraiso = J(Gt);
          var zt = j(124);
          L.pop = J(zt);
          var Yr = j(125);
          L.railscasts = J(Yr);
          var Vr = j(126);
          L.shapeshifter = J(Vr);
          var Qn = j(127);
          L.solarized = J(Qn);
          var Ua = j(128);
          L.summerfruit = J(Ua);
          var ua = j(129);
          L.tomorrow = J(ua);
          var Pa = j(130);
          L.tube = J(Pa);
          var qi = j(131);
          L.twilight = J(qi);
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, I.exports = L.default;
        }, function(I, L, j) {
          L.__esModule = true, L.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, I.exports = L.default;
        }, function(I, L, j) {
          var J = j(33);
          function te(Q) {
            var he = Math.round(J(Q, 0, 255)).toString(16);
            return he.length == 1 ? "0" + he : he;
          }
          I.exports = function(Q) {
            var he = Q.length === 4 ? te(255 * Q[3]) : "";
            return "#" + te(Q[0]) + te(Q[1]) + te(Q[2]) + he;
          };
        }, function(I, L, j) {
          var J = j(134), te = j(135), Q = j(136), he = j(137), de = { "#": te, hsl: function(We) {
            var Xe = J(We), Ze = he(Xe);
            return Xe.length === 4 && Ze.push(Xe[3]), Ze;
          }, rgb: Q };
          function Ae(We) {
            for (var Xe in de)
              if (We.indexOf(Xe) === 0)
                return de[Xe](We);
          }
          Ae.rgb = Q, Ae.hsl = J, Ae.hex = te, I.exports = Ae;
        }, function(I, L, j) {
          var J = j(44), te = j(33);
          function Q(he, de) {
            switch (he = parseFloat(he), de) {
              case 0:
                return te(he, 0, 360);
              case 1:
              case 2:
                return te(he, 0, 100);
              case 3:
                return te(he, 0, 1);
            }
          }
          I.exports = function(he) {
            return J(he).map(Q);
          };
        }, function(I, L) {
          I.exports = function(j) {
            j.length !== 4 && j.length !== 5 || (j = function(Q) {
              for (var he = "#", de = 1; de < Q.length; de++) {
                var Ae = Q.charAt(de);
                he += Ae + Ae;
              }
              return he;
            }(j));
            var J = [parseInt(j.substring(1, 3), 16), parseInt(j.substring(3, 5), 16), parseInt(j.substring(5, 7), 16)];
            if (j.length === 9) {
              var te = parseFloat((parseInt(j.substring(7, 9), 16) / 255).toFixed(2));
              J.push(te);
            }
            return J;
          };
        }, function(I, L, j) {
          var J = j(44), te = j(33);
          function Q(he, de) {
            return de < 3 ? he.indexOf("%") != -1 ? Math.round(255 * te(parseInt(he, 10), 0, 100) / 100) : te(parseInt(he, 10), 0, 255) : te(parseFloat(he), 0, 1);
          }
          I.exports = function(he) {
            return J(he).map(Q);
          };
        }, function(I, L) {
          I.exports = function(j) {
            var J, te, Q, he, de, Ae = j[0] / 360, We = j[1] / 100, Xe = j[2] / 100;
            if (We == 0)
              return [de = 255 * Xe, de, de];
            J = 2 * Xe - (te = Xe < 0.5 ? Xe * (1 + We) : Xe + We - Xe * We), he = [0, 0, 0];
            for (var Ze = 0; Ze < 3; Ze++)
              (Q = Ae + 1 / 3 * -(Ze - 1)) < 0 && Q++, Q > 1 && Q--, de = 6 * Q < 1 ? J + 6 * (te - J) * Q : 2 * Q < 1 ? te : 3 * Q < 2 ? J + (te - J) * (2 / 3 - Q) * 6 : J, he[Ze] = 255 * de;
            return he;
          };
        }, function(I, L, j) {
          (function(J) {
            var te = typeof J == "object" && J && J.Object === Object && J, Q = typeof self == "object" && self && self.Object === Object && self, he = te || Q || Function("return this")();
            function de(St, kt, dr) {
              switch (dr.length) {
                case 0:
                  return St.call(kt);
                case 1:
                  return St.call(kt, dr[0]);
                case 2:
                  return St.call(kt, dr[0], dr[1]);
                case 3:
                  return St.call(kt, dr[0], dr[1], dr[2]);
              }
              return St.apply(kt, dr);
            }
            function Ae(St, kt) {
              for (var dr = -1, Ir = kt.length, ht = St.length; ++dr < Ir; )
                St[ht + dr] = kt[dr];
              return St;
            }
            var We = Object.prototype, Xe = We.hasOwnProperty, Ze = We.toString, it = he.Symbol, ct = We.propertyIsEnumerable, sr = it ? it.isConcatSpreadable : void 0, Yt = Math.max;
            function Or(St) {
              return le(St) || function(kt) {
                return function(dr) {
                  return function(Ir) {
                    return !!Ir && typeof Ir == "object";
                  }(dr) && function(Ir) {
                    return Ir != null && function(ht) {
                      return typeof ht == "number" && ht > -1 && ht % 1 == 0 && ht <= 9007199254740991;
                    }(Ir.length) && !function(ht) {
                      var gn = function(ln) {
                        var Jt = typeof ln;
                        return !!ln && (Jt == "object" || Jt == "function");
                      }(ht) ? Ze.call(ht) : "";
                      return gn == "[object Function]" || gn == "[object GeneratorFunction]";
                    }(Ir);
                  }(dr);
                }(kt) && Xe.call(kt, "callee") && (!ct.call(kt, "callee") || Ze.call(kt) == "[object Arguments]");
              }(St) || !!(sr && St && St[sr]);
            }
            var le = Array.isArray, _t, Pt, er, Kt = (Pt = function(St) {
              var kt = (St = function Ir(ht, gn, ln, Jt, In) {
                var ur = -1, Gt = ht.length;
                for (ln || (ln = Or), In || (In = []); ++ur < Gt; ) {
                  var zt = ht[ur];
                  gn > 0 && ln(zt) ? gn > 1 ? Ir(zt, gn - 1, ln, Jt, In) : Ae(In, zt) : Jt || (In[In.length] = zt);
                }
                return In;
              }(St, 1)).length, dr = kt;
              for (_t; dr--; )
                if (typeof St[dr] != "function")
                  throw new TypeError("Expected a function");
              return function() {
                for (var Ir = 0, ht = kt ? St[Ir].apply(this, arguments) : arguments[0]; ++Ir < kt; )
                  ht = St[Ir].call(this, ht);
                return ht;
              };
            }, er = Yt(er === void 0 ? Pt.length - 1 : er, 0), function() {
              for (var St = arguments, kt = -1, dr = Yt(St.length - er, 0), Ir = Array(dr); ++kt < dr; )
                Ir[kt] = St[er + kt];
              kt = -1;
              for (var ht = Array(er + 1); ++kt < er; )
                ht[kt] = St[kt];
              return ht[er] = Ir, de(Pt, this, ht);
            });
            I.exports = Kt;
          }).call(this, j(43));
        }, function(I, L, j) {
          Object.defineProperty(L, "__esModule", { value: true }), L.yuv2rgb = function(J) {
            var te, Q, he, de = J[0], Ae = J[1], We = J[2];
            return te = 1 * de + 0 * Ae + 1.13983 * We, Q = 1 * de + -0.39465 * Ae + -0.5806 * We, he = 1 * de + 2.02311 * Ae + 0 * We, te = Math.min(Math.max(0, te), 1), Q = Math.min(Math.max(0, Q), 1), he = Math.min(Math.max(0, he), 1), [255 * te, 255 * Q, 255 * he];
          }, L.rgb2yuv = function(J) {
            var te = J[0] / 255, Q = J[1] / 255, he = J[2] / 255;
            return [0.299 * te + 0.587 * Q + 0.114 * he, -0.14713 * te + -0.28886 * Q + 0.436 * he, 0.615 * te + -0.51499 * Q + -0.10001 * he];
          };
        }, function(I, L, j) {
          function J(he, de, Ae) {
            return de in he ? Object.defineProperty(he, de, { value: Ae, enumerable: true, configurable: true, writable: true }) : he[de] = Ae, he;
          }
          var te = j(141), Q = function() {
            function he() {
              J(this, "_callbacks", void 0), J(this, "_isDispatching", void 0), J(this, "_isHandled", void 0), J(this, "_isPending", void 0), J(this, "_lastID", void 0), J(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
            }
            var de = he.prototype;
            return de.register = function(Ae) {
              var We = "ID_" + this._lastID++;
              return this._callbacks[We] = Ae, We;
            }, de.unregister = function(Ae) {
              this._callbacks[Ae] || te(false), delete this._callbacks[Ae];
            }, de.waitFor = function(Ae) {
              this._isDispatching || te(false);
              for (var We = 0; We < Ae.length; We++) {
                var Xe = Ae[We];
                this._isPending[Xe] ? this._isHandled[Xe] || te(false) : (this._callbacks[Xe] || te(false), this._invokeCallback(Xe));
              }
            }, de.dispatch = function(Ae) {
              this._isDispatching && te(false), this._startDispatching(Ae);
              try {
                for (var We in this._callbacks)
                  this._isPending[We] || this._invokeCallback(We);
              } finally {
                this._stopDispatching();
              }
            }, de.isDispatching = function() {
              return this._isDispatching;
            }, de._invokeCallback = function(Ae) {
              this._isPending[Ae] = true, this._callbacks[Ae](this._pendingPayload), this._isHandled[Ae] = true;
            }, de._startDispatching = function(Ae) {
              for (var We in this._callbacks)
                this._isPending[We] = false, this._isHandled[We] = false;
              this._pendingPayload = Ae, this._isDispatching = true;
            }, de._stopDispatching = function() {
              delete this._pendingPayload, this._isDispatching = false;
            }, he;
          }();
          I.exports = Q;
        }, function(I, L, j) {
          I.exports = function(J, te) {
            for (var Q = arguments.length, he = new Array(Q > 2 ? Q - 2 : 0), de = 2; de < Q; de++)
              he[de - 2] = arguments[de];
            if (!J) {
              var Ae;
              if (te === void 0)
                Ae = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
              else {
                var We = 0;
                (Ae = new Error(te.replace(/%s/g, function() {
                  return String(he[We++]);
                }))).name = "Invariant Violation";
              }
              throw Ae.framesToPop = 1, Ae;
            }
          };
        }, function(I, L, j) {
          function J(De, ze, pe) {
            return ze in De ? Object.defineProperty(De, ze, { value: pe, enumerable: true, configurable: true, writable: true }) : De[ze] = pe, De;
          }
          function te(De, ze) {
            var pe = Object.keys(De);
            if (Object.getOwnPropertySymbols) {
              var Oe = Object.getOwnPropertySymbols(De);
              ze && (Oe = Oe.filter(function(Ve) {
                return Object.getOwnPropertyDescriptor(De, Ve).enumerable;
              })), pe.push.apply(pe, Oe);
            }
            return pe;
          }
          function Q(De) {
            for (var ze = 1; ze < arguments.length; ze++) {
              var pe = arguments[ze] != null ? arguments[ze] : {};
              ze % 2 ? te(Object(pe), true).forEach(function(Oe) {
                J(De, Oe, pe[Oe]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(De, Object.getOwnPropertyDescriptors(pe)) : te(Object(pe)).forEach(function(Oe) {
                Object.defineProperty(De, Oe, Object.getOwnPropertyDescriptor(pe, Oe));
              });
            }
            return De;
          }
          function he(De, ze) {
            if (!(De instanceof ze))
              throw new TypeError("Cannot call a class as a function");
          }
          function de(De, ze) {
            for (var pe = 0; pe < ze.length; pe++) {
              var Oe = ze[pe];
              Oe.enumerable = Oe.enumerable || false, Oe.configurable = true, "value" in Oe && (Oe.writable = true), Object.defineProperty(De, Oe.key, Oe);
            }
          }
          function Ae(De, ze, pe) {
            return ze && de(De.prototype, ze), pe && de(De, pe), De;
          }
          function We(De, ze) {
            return (We = Object.setPrototypeOf || function(pe, Oe) {
              return pe.__proto__ = Oe, pe;
            })(De, ze);
          }
          function Xe(De, ze) {
            if (typeof ze != "function" && ze !== null)
              throw new TypeError("Super expression must either be null or a function");
            De.prototype = Object.create(ze && ze.prototype, { constructor: { value: De, writable: true, configurable: true } }), ze && We(De, ze);
          }
          function Ze(De) {
            return (Ze = Object.setPrototypeOf ? Object.getPrototypeOf : function(ze) {
              return ze.__proto__ || Object.getPrototypeOf(ze);
            })(De);
          }
          function it(De) {
            return (it = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(ze) {
              return typeof ze;
            } : function(ze) {
              return ze && typeof Symbol == "function" && ze.constructor === Symbol && ze !== Symbol.prototype ? "symbol" : typeof ze;
            })(De);
          }
          function ct(De) {
            if (De === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return De;
          }
          function sr(De, ze) {
            return !ze || it(ze) !== "object" && typeof ze != "function" ? ct(De) : ze;
          }
          function Yt(De) {
            var ze = function() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                })), true;
              } catch {
                return false;
              }
            }();
            return function() {
              var pe, Oe = Ze(De);
              if (ze) {
                var Ve = Ze(this).constructor;
                pe = Reflect.construct(Oe, arguments, Ve);
              } else
                pe = Oe.apply(this, arguments);
              return sr(this, pe);
            };
          }
          j.r(L);
          var Or = j(0), le = j.n(Or);
          function _t() {
            var De = this.constructor.getDerivedStateFromProps(this.props, this.state);
            De != null && this.setState(De);
          }
          function Pt(De) {
            this.setState(function(ze) {
              var pe = this.constructor.getDerivedStateFromProps(De, ze);
              return pe != null ? pe : null;
            }.bind(this));
          }
          function er(De, ze) {
            try {
              var pe = this.props, Oe = this.state;
              this.props = De, this.state = ze, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(pe, Oe);
            } finally {
              this.props = pe, this.state = Oe;
            }
          }
          function Kt(De) {
            var ze = De.prototype;
            if (!ze || !ze.isReactComponent)
              throw new Error("Can only polyfill class components");
            if (typeof De.getDerivedStateFromProps != "function" && typeof ze.getSnapshotBeforeUpdate != "function")
              return De;
            var pe = null, Oe = null, Ve = null;
            if (typeof ze.componentWillMount == "function" ? pe = "componentWillMount" : typeof ze.UNSAFE_componentWillMount == "function" && (pe = "UNSAFE_componentWillMount"), typeof ze.componentWillReceiveProps == "function" ? Oe = "componentWillReceiveProps" : typeof ze.UNSAFE_componentWillReceiveProps == "function" && (Oe = "UNSAFE_componentWillReceiveProps"), typeof ze.componentWillUpdate == "function" ? Ve = "componentWillUpdate" : typeof ze.UNSAFE_componentWillUpdate == "function" && (Ve = "UNSAFE_componentWillUpdate"), pe !== null || Oe !== null || Ve !== null) {
              var Tt = De.displayName || De.name, hr = typeof De.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Tt + " uses " + hr + " but also contains the following legacy lifecycles:" + (pe !== null ? `
  ` + pe : "") + (Oe !== null ? `
  ` + Oe : "") + (Ve !== null ? `
  ` + Ve : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
            }
            if (typeof De.getDerivedStateFromProps == "function" && (ze.componentWillMount = _t, ze.componentWillReceiveProps = Pt), typeof ze.getSnapshotBeforeUpdate == "function") {
              if (typeof ze.componentDidUpdate != "function")
                throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
              ze.componentWillUpdate = er;
              var Xt = ze.componentDidUpdate;
              ze.componentDidUpdate = function(lt2, Fr, yn) {
                var Ia = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : yn;
                Xt.call(this, lt2, Fr, Ia);
              };
            }
            return De;
          }
          function St(De, ze) {
            if (De == null)
              return {};
            var pe, Oe, Ve = function(hr, Xt) {
              if (hr == null)
                return {};
              var lt2, Fr, yn = {}, Ia = Object.keys(hr);
              for (Fr = 0; Fr < Ia.length; Fr++)
                lt2 = Ia[Fr], Xt.indexOf(lt2) >= 0 || (yn[lt2] = hr[lt2]);
              return yn;
            }(De, ze);
            if (Object.getOwnPropertySymbols) {
              var Tt = Object.getOwnPropertySymbols(De);
              for (Oe = 0; Oe < Tt.length; Oe++)
                pe = Tt[Oe], ze.indexOf(pe) >= 0 || Object.prototype.propertyIsEnumerable.call(De, pe) && (Ve[pe] = De[pe]);
            }
            return Ve;
          }
          function kt(De) {
            var ze = function(pe) {
              return {}.toString.call(pe).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
            }(De);
            return ze === "number" && (ze = isNaN(De) ? "nan" : (0 | De) != De ? "float" : "integer"), ze;
          }
          _t.__suppressDeprecationWarning = true, Pt.__suppressDeprecationWarning = true, er.__suppressDeprecationWarning = true;
          var dr = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Ir = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, ht = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, gn = j(45), ln = function(De) {
            var ze = function(pe) {
              return { backgroundColor: pe.base00, ellipsisColor: pe.base09, braceColor: pe.base07, expandedIcon: pe.base0D, collapsedIcon: pe.base0E, keyColor: pe.base07, arrayKeyColor: pe.base0C, objectSize: pe.base04, copyToClipboard: pe.base0F, copyToClipboardCheck: pe.base0D, objectBorder: pe.base02, dataTypes: { boolean: pe.base0E, date: pe.base0D, float: pe.base0B, function: pe.base0D, integer: pe.base0F, string: pe.base09, nan: pe.base08, null: pe.base0A, undefined: pe.base05, regexp: pe.base0A, background: pe.base02 }, editVariable: { editIcon: pe.base0E, cancelIcon: pe.base09, removeIcon: pe.base09, addIcon: pe.base0E, checkIcon: pe.base0E, background: pe.base01, color: pe.base0A, border: pe.base07 }, addKeyModal: { background: pe.base05, border: pe.base04, color: pe.base0A, labelColor: pe.base01 }, validationFailure: { background: pe.base09, iconColor: pe.base01, fontColor: pe.base01 } };
            }(De);
            return { "app-container": { fontFamily: ht.globalFontFamily, cursor: ht.globalCursor, backgroundColor: ze.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: ze.ellipsisColor, fontSize: ht.ellipsisFontSize, lineHeight: ht.ellipsisLineHeight, cursor: ht.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: ht.braceCursor, fontWeight: ht.braceFontWeight, color: ze.braceColor }, "expanded-icon": { color: ze.expandedIcon }, "collapsed-icon": { color: ze.collapsedIcon }, colon: { display: "inline-block", margin: ht.keyMargin, color: ze.keyColor, verticalAlign: "top" }, objectKeyVal: function(pe, Oe) {
              return { style: Q({ paddingTop: ht.keyValPaddingTop, paddingRight: ht.keyValPaddingRight, paddingBottom: ht.keyValPaddingBottom, borderLeft: ht.keyValBorderLeft + " " + ze.objectBorder, ":hover": { paddingLeft: Oe.paddingLeft - 1 + "px", borderLeft: ht.keyValBorderHover + " " + ze.objectBorder } }, Oe) };
            }, "object-key-val-no-border": { padding: ht.keyValPadding }, "pushed-content": { marginLeft: ht.pushedContentMarginLeft }, variableValue: function(pe, Oe) {
              return { style: Q({ display: "inline-block", paddingRight: ht.variableValuePaddingRight, position: "relative" }, Oe) };
            }, "object-name": { display: "inline-block", color: ze.keyColor, letterSpacing: ht.keyLetterSpacing, fontStyle: ht.keyFontStyle, verticalAlign: ht.keyVerticalAlign, opacity: ht.keyOpacity, ":hover": { opacity: ht.keyOpacityHover } }, "array-key": { display: "inline-block", color: ze.arrayKeyColor, letterSpacing: ht.keyLetterSpacing, fontStyle: ht.keyFontStyle, verticalAlign: ht.keyVerticalAlign, opacity: ht.keyOpacity, ":hover": { opacity: ht.keyOpacityHover } }, "object-size": { color: ze.objectSize, borderRadius: ht.objectSizeBorderRadius, fontStyle: ht.objectSizeFontStyle, margin: ht.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: ht.dataTypeFontSize, marginRight: ht.dataTypeMarginRight, opacity: ht.datatypeOpacity }, boolean: { display: "inline-block", color: ze.dataTypes.boolean }, date: { display: "inline-block", color: ze.dataTypes.date }, "date-value": { marginLeft: ht.dateValueMarginLeft }, float: { display: "inline-block", color: ze.dataTypes.float }, function: { display: "inline-block", color: ze.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: ze.dataTypes.integer }, string: { display: "inline-block", color: ze.dataTypes.string }, nan: { display: "inline-block", color: ze.dataTypes.nan, fontSize: ht.nanFontSize, fontWeight: ht.nanFontWeight, backgroundColor: ze.dataTypes.background, padding: ht.nanPadding, borderRadius: ht.nanBorderRadius }, null: { display: "inline-block", color: ze.dataTypes.null, fontSize: ht.nullFontSize, fontWeight: ht.nullFontWeight, backgroundColor: ze.dataTypes.background, padding: ht.nullPadding, borderRadius: ht.nullBorderRadius }, undefined: { display: "inline-block", color: ze.dataTypes.undefined, fontSize: ht.undefinedFontSize, padding: ht.undefinedPadding, borderRadius: ht.undefinedBorderRadius, backgroundColor: ze.dataTypes.background }, regexp: { display: "inline-block", color: ze.dataTypes.regexp }, "copy-to-clipboard": { cursor: ht.clipboardCursor }, "copy-icon": { color: ze.copyToClipboard, fontSize: ht.iconFontSize, marginRight: ht.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: ze.copyToClipboardCheck, marginLeft: ht.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: ht.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: ht.metaDataPadding }, "icon-container": { display: "inline-block", width: ht.iconContainerWidth }, tooltip: { padding: ht.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: ze.editVariable.removeIcon, cursor: ht.iconCursor, fontSize: ht.iconFontSize, marginRight: ht.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: ze.editVariable.addIcon, cursor: ht.iconCursor, fontSize: ht.iconFontSize, marginRight: ht.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: ze.editVariable.editIcon, cursor: ht.iconCursor, fontSize: ht.iconFontSize, marginRight: ht.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: ht.iconCursor, color: ze.editVariable.checkIcon, fontSize: ht.iconFontSize, paddingRight: ht.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: ht.iconCursor, color: ze.editVariable.cancelIcon, fontSize: ht.iconFontSize, paddingRight: ht.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: ht.editInputMinWidth, borderRadius: ht.editInputBorderRadius, backgroundColor: ze.editVariable.background, color: ze.editVariable.color, padding: ht.editInputPadding, marginRight: ht.editInputMarginRight, fontFamily: ht.editInputFontFamily }, "detected-row": { paddingTop: ht.detectedRowPaddingTop }, "key-modal-request": { position: ht.addKeyCoverPosition, top: ht.addKeyCoverPositionPx, left: ht.addKeyCoverPositionPx, right: ht.addKeyCoverPositionPx, bottom: ht.addKeyCoverPositionPx, backgroundColor: ht.addKeyCoverBackground }, "key-modal": { width: ht.addKeyModalWidth, backgroundColor: ze.addKeyModal.background, marginLeft: ht.addKeyModalMargin, marginRight: ht.addKeyModalMargin, padding: ht.addKeyModalPadding, borderRadius: ht.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: ze.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: ze.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: ze.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: ze.addKeyModal.labelColor, fontSize: ht.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: ze.editVariable.addIcon, fontSize: ht.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: ze.ellipsisColor, fontSize: ht.ellipsisFontSize, lineHeight: ht.ellipsisLineHeight, cursor: ht.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: ze.validationFailure.fontColor, backgroundColor: ze.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: ze.validationFailure.iconColor, fontSize: ht.iconFontSize, transform: "rotate(45deg)" } };
          };
          function Jt(De, ze, pe) {
            return De || console.error("theme has not been set"), function(Oe) {
              var Ve = dr;
              return Oe !== false && Oe !== "none" || (Ve = Ir), Object(gn.createStyling)(ln, { defaultBase16: Ve })(Oe);
            }(De)(ze, pe);
          }
          var In = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = (Oe.rjvId, Oe.type_name), Tt = Oe.displayDataTypes, hr = Oe.theme;
              return Tt ? le.a.createElement("span", Object.assign({ className: "data-type-label" }, Jt(hr, "data-type-label")), Ve) : null;
            } }]), pe;
          }(le.a.PureComponent), ur = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props;
              return le.a.createElement("div", Jt(Oe.theme, "boolean"), le.a.createElement(In, Object.assign({ type_name: "bool" }, Oe)), Oe.value ? "true" : "false");
            } }]), pe;
          }(le.a.PureComponent), Gt = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props;
              return le.a.createElement("div", Jt(Oe.theme, "date"), le.a.createElement(In, Object.assign({ type_name: "date" }, Oe)), le.a.createElement("span", Object.assign({ className: "date-value" }, Jt(Oe.theme, "date-value")), Oe.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
            } }]), pe;
          }(le.a.PureComponent), zt = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props;
              return le.a.createElement("div", Jt(Oe.theme, "float"), le.a.createElement(In, Object.assign({ type_name: "float" }, Oe)), this.props.value);
            } }]), pe;
          }(le.a.PureComponent);
          function Yr(De, ze) {
            (ze == null || ze > De.length) && (ze = De.length);
            for (var pe = 0, Oe = new Array(ze); pe < ze; pe++)
              Oe[pe] = De[pe];
            return Oe;
          }
          function Vr(De, ze) {
            if (De) {
              if (typeof De == "string")
                return Yr(De, ze);
              var pe = Object.prototype.toString.call(De).slice(8, -1);
              return pe === "Object" && De.constructor && (pe = De.constructor.name), pe === "Map" || pe === "Set" ? Array.from(De) : pe === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe) ? Yr(De, ze) : void 0;
            }
          }
          function Qn(De, ze) {
            var pe;
            if (typeof Symbol == "undefined" || De[Symbol.iterator] == null) {
              if (Array.isArray(De) || (pe = Vr(De)) || ze && De && typeof De.length == "number") {
                pe && (De = pe);
                var Oe = 0, Ve = function() {
                };
                return { s: Ve, n: function() {
                  return Oe >= De.length ? { done: true } : { done: false, value: De[Oe++] };
                }, e: function(lt2) {
                  throw lt2;
                }, f: Ve };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            var Tt, hr = true, Xt = false;
            return { s: function() {
              pe = De[Symbol.iterator]();
            }, n: function() {
              var lt2 = pe.next();
              return hr = lt2.done, lt2;
            }, e: function(lt2) {
              Xt = true, Tt = lt2;
            }, f: function() {
              try {
                hr || pe.return == null || pe.return();
              } finally {
                if (Xt)
                  throw Tt;
              }
            } };
          }
          function Ua(De) {
            return function(ze) {
              if (Array.isArray(ze))
                return Yr(ze);
            }(De) || function(ze) {
              if (typeof Symbol != "undefined" && Symbol.iterator in Object(ze))
                return Array.from(ze);
            }(De) || Vr(De) || function() {
              throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }();
          }
          var ua = j(46), Pa = new (j(47)).Dispatcher(), qi = new (function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              var Oe;
              he(this, pe);
              for (var Ve = arguments.length, Tt = new Array(Ve), hr = 0; hr < Ve; hr++)
                Tt[hr] = arguments[hr];
              return (Oe = ze.call.apply(ze, [this].concat(Tt))).objects = {}, Oe.set = function(Xt, lt2, Fr, yn) {
                Oe.objects[Xt] === void 0 && (Oe.objects[Xt] = {}), Oe.objects[Xt][lt2] === void 0 && (Oe.objects[Xt][lt2] = {}), Oe.objects[Xt][lt2][Fr] = yn;
              }, Oe.get = function(Xt, lt2, Fr, yn) {
                return Oe.objects[Xt] === void 0 || Oe.objects[Xt][lt2] === void 0 || Oe.objects[Xt][lt2][Fr] == null ? yn : Oe.objects[Xt][lt2][Fr];
              }, Oe.handleAction = function(Xt) {
                var lt2 = Xt.rjvId, Fr = Xt.data;
                switch (Xt.name) {
                  case "RESET":
                    Oe.emit("reset-" + lt2);
                    break;
                  case "VARIABLE_UPDATED":
                    Xt.data.updated_src = Oe.updateSrc(lt2, Fr), Oe.set(lt2, "action", "variable-update", Q(Q({}, Fr), {}, { type: "variable-edited" })), Oe.emit("variable-update-" + lt2);
                    break;
                  case "VARIABLE_REMOVED":
                    Xt.data.updated_src = Oe.updateSrc(lt2, Fr), Oe.set(lt2, "action", "variable-update", Q(Q({}, Fr), {}, { type: "variable-removed" })), Oe.emit("variable-update-" + lt2);
                    break;
                  case "VARIABLE_ADDED":
                    Xt.data.updated_src = Oe.updateSrc(lt2, Fr), Oe.set(lt2, "action", "variable-update", Q(Q({}, Fr), {}, { type: "variable-added" })), Oe.emit("variable-update-" + lt2);
                    break;
                  case "ADD_VARIABLE_KEY_REQUEST":
                    Oe.set(lt2, "action", "new-key-request", Fr), Oe.emit("add-key-request-" + lt2);
                }
              }, Oe.updateSrc = function(Xt, lt2) {
                var Fr = lt2.name, yn = lt2.namespace, Ia = lt2.new_value, Ea = (lt2.existing_value, lt2.variable_removed);
                yn.shift();
                var pa, Wn = Oe.get(Xt, "global", "src"), ki = Oe.deepCopy(Wn, Ua(yn)), bo = ki, na = Qn(yn);
                try {
                  for (na.s(); !(pa = na.n()).done; )
                    bo = bo[pa.value];
                } catch (Ro) {
                  na.e(Ro);
                } finally {
                  na.f();
                }
                return Ea ? kt(bo) == "array" ? bo.splice(Fr, 1) : delete bo[Fr] : Fr !== null ? bo[Fr] = Ia : ki = Ia, Oe.set(Xt, "global", "src", ki), ki;
              }, Oe.deepCopy = function(Xt, lt2) {
                var Fr, yn = kt(Xt), Ia = lt2.shift();
                return yn == "array" ? Fr = Ua(Xt) : yn == "object" && (Fr = Q({}, Xt)), Ia !== void 0 && (Fr[Ia] = Oe.deepCopy(Xt[Ia], lt2)), Fr;
              }, Oe;
            }
            return pe;
          }(ua.EventEmitter))();
          Pa.register(qi.handleAction.bind(qi));
          var Ha = qi, pi = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).toggleCollapsed = function() {
                Ve.setState({ collapsed: !Ve.state.collapsed }, function() {
                  Ha.set(Ve.props.rjvId, Ve.props.namespace, "collapsed", Ve.state.collapsed);
                });
              }, Ve.getFunctionDisplay = function(Tt) {
                var hr = ct(Ve).props;
                return Tt ? le.a.createElement("span", null, Ve.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), le.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, le.a.createElement("span", null, "{"), le.a.createElement("span", Jt(hr.theme, "ellipsis"), "..."), le.a.createElement("span", null, "}"))) : Ve.props.value.toString().slice(9, -1);
              }, Ve.state = { collapsed: Ha.get(Oe.rjvId, Oe.namespace, "collapsed", true) }, Ve;
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = this.state.collapsed;
              return le.a.createElement("div", Jt(Oe.theme, "function"), le.a.createElement(In, Object.assign({ type_name: "function" }, Oe)), le.a.createElement("span", Object.assign({}, Jt(Oe.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Ve)));
            } }]), pe;
          }(le.a.PureComponent), Lo = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              return le.a.createElement("div", Jt(this.props.theme, "nan"), "NaN");
            } }]), pe;
          }(le.a.PureComponent), rl = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              return le.a.createElement("div", Jt(this.props.theme, "null"), "NULL");
            } }]), pe;
          }(le.a.PureComponent), is = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props;
              return le.a.createElement("div", Jt(Oe.theme, "integer"), le.a.createElement(In, Object.assign({ type_name: "int" }, Oe)), this.props.value);
            } }]), pe;
          }(le.a.PureComponent), Xs = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props;
              return le.a.createElement("div", Jt(Oe.theme, "regexp"), le.a.createElement(In, Object.assign({ type_name: "regexp" }, Oe)), this.props.value.toString());
            } }]), pe;
          }(le.a.PureComponent), qo = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).toggleCollapsed = function() {
                Ve.setState({ collapsed: !Ve.state.collapsed }, function() {
                  Ha.set(Ve.props.rjvId, Ve.props.namespace, "collapsed", Ve.state.collapsed);
                });
              }, Ve.state = { collapsed: Ha.get(Oe.rjvId, Oe.namespace, "collapsed", true) }, Ve;
            }
            return Ae(pe, [{ key: "render", value: function() {
              this.state.collapsed;
              var Oe = this.props, Ve = Oe.collapseStringsAfterLength, Tt = Oe.theme, hr = Oe.value, Xt = { style: { cursor: "default" } };
              return kt(Ve) === "integer" && hr.length > Ve && (Xt.style.cursor = "pointer", this.state.collapsed && (hr = le.a.createElement("span", null, hr.substring(0, Ve), le.a.createElement("span", Jt(Tt, "ellipsis"), " ...")))), le.a.createElement("div", Jt(Tt, "string"), le.a.createElement(In, Object.assign({ type_name: "string" }, Oe)), le.a.createElement("span", Object.assign({ className: "string-value" }, Xt, { onClick: this.toggleCollapsed }), '"', hr, '"'));
            } }]), pe;
          }(le.a.PureComponent), du = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              return le.a.createElement("div", Jt(this.props.theme, "undefined"), "undefined");
            } }]), pe;
          }(le.a.PureComponent);
          function nl() {
            return (nl = Object.assign || function(De) {
              for (var ze = 1; ze < arguments.length; ze++) {
                var pe = arguments[ze];
                for (var Oe in pe)
                  Object.prototype.hasOwnProperty.call(pe, Oe) && (De[Oe] = pe[Oe]);
              }
              return De;
            }).apply(this, arguments);
          }
          var os = Or.useLayoutEffect, Rn = function(De) {
            var ze = Object(Or.useRef)(De);
            return os(function() {
              ze.current = De;
            }), ze;
          }, Tl = function(De, ze) {
            typeof De != "function" ? De.current = ze : De(ze);
          }, Iu = function(De, ze) {
            var pe = Object(Or.useRef)();
            return Object(Or.useCallback)(function(Oe) {
              De.current = Oe, pe.current && Tl(pe.current, null), pe.current = ze, ze && Tl(ze, Oe);
            }, [ze]);
          }, so = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Fs = function(De) {
            Object.keys(so).forEach(function(ze) {
              De.style.setProperty(ze, so[ze], "important");
            });
          }, Oo = null, mc = function() {
          }, nr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Nt = !!document.documentElement.currentStyle, Rt = function(De, ze) {
            var pe = De.cacheMeasurements, Oe = De.maxRows, Ve = De.minRows, Tt = De.onChange, hr = Tt === void 0 ? mc : Tt, Xt = De.onHeightChange, lt2 = Xt === void 0 ? mc : Xt, Fr = function(na, Ro) {
              if (na == null)
                return {};
              var Qs, _c2, Ef = {}, xc = Object.keys(na);
              for (_c2 = 0; _c2 < xc.length; _c2++)
                Qs = xc[_c2], Ro.indexOf(Qs) >= 0 || (Ef[Qs] = na[Qs]);
              return Ef;
            }(De, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), yn, Ia = Fr.value !== void 0, Ea = Object(Or.useRef)(null), pa = Iu(Ea, ze), Wn = Object(Or.useRef)(0), ki = Object(Or.useRef)(), bo = function() {
              var na = Ea.current, Ro = pe && ki.current ? ki.current : function(xc) {
                var ov = window.getComputedStyle(xc);
                if (ov === null)
                  return null;
                var Af, Cs = (Af = ov, nr.reduce(function(Es, ss) {
                  return Es[ss] = Af[ss], Es;
                }, {})), wc = Cs.boxSizing;
                return wc === "" ? null : (Nt && wc === "border-box" && (Cs.width = parseFloat(Cs.width) + parseFloat(Cs.borderRightWidth) + parseFloat(Cs.borderLeftWidth) + parseFloat(Cs.paddingRight) + parseFloat(Cs.paddingLeft) + "px"), { sizingStyle: Cs, paddingSize: parseFloat(Cs.paddingBottom) + parseFloat(Cs.paddingTop), borderSize: parseFloat(Cs.borderBottomWidth) + parseFloat(Cs.borderTopWidth) });
              }(na);
              if (Ro) {
                ki.current = Ro;
                var Qs = function(xc, ov, Af, Cs) {
                  Af === void 0 && (Af = 1), Cs === void 0 && (Cs = 1 / 0), Oo || ((Oo = document.createElement("textarea")).setAttribute("tab-index", "-1"), Oo.setAttribute("aria-hidden", "true"), Fs(Oo)), Oo.parentNode === null && document.body.appendChild(Oo);
                  var wc = xc.paddingSize, Es = xc.borderSize, ss = xc.sizingStyle, Sc = ss.boxSizing;
                  Object.keys(ss).forEach(function(Tf) {
                    var Ns = Tf;
                    Oo.style[Ns] = ss[Ns];
                  }), Fs(Oo), Oo.value = ov;
                  var sv = function(Tf, Ns) {
                    var Cp = Tf.scrollHeight;
                    return Ns.sizingStyle.boxSizing === "border-box" ? Cp + Ns.borderSize : Cp - Ns.paddingSize;
                  }(Oo, xc);
                  Oo.value = "x";
                  var Sp = Oo.scrollHeight - wc, ol = Sp * Af;
                  Sc === "border-box" && (ol = ol + wc + Es), sv = Math.max(ol, sv);
                  var ch = Sp * Cs;
                  return Sc === "border-box" && (ch = ch + wc + Es), [sv = Math.min(ch, sv), Sp];
                }(Ro, na.value || na.placeholder || "x", Ve, Oe), _c2 = Qs[0], Ef = Qs[1];
                Wn.current !== _c2 && (Wn.current = _c2, na.style.setProperty("height", _c2 + "px", "important"), lt2(_c2, { rowHeight: Ef }));
              }
            };
            return Object(Or.useLayoutEffect)(bo), yn = Rn(bo), Object(Or.useLayoutEffect)(function() {
              var na = function(Ro) {
                yn.current(Ro);
              };
              return window.addEventListener("resize", na), function() {
                window.removeEventListener("resize", na);
              };
            }, []), Object(Or.createElement)("textarea", nl({}, Fr, { onChange: function(na) {
              Ia || bo(), hr(na);
            }, ref: pa }));
          }, _r = Object(Or.forwardRef)(Rt);
          function tn(De) {
            De = De.trim();
            try {
              if ((De = JSON.stringify(JSON.parse(De)))[0] === "[")
                return Sn("array", JSON.parse(De));
              if (De[0] === "{")
                return Sn("object", JSON.parse(De));
              if (De.match(/\-?\d+\.\d+/) && De.match(/\-?\d+\.\d+/)[0] === De)
                return Sn("float", parseFloat(De));
              if (De.match(/\-?\d+e-\d+/) && De.match(/\-?\d+e-\d+/)[0] === De)
                return Sn("float", Number(De));
              if (De.match(/\-?\d+/) && De.match(/\-?\d+/)[0] === De)
                return Sn("integer", parseInt(De));
              if (De.match(/\-?\d+e\+\d+/) && De.match(/\-?\d+e\+\d+/)[0] === De)
                return Sn("integer", Number(De));
            } catch {
            }
            switch (De = De.toLowerCase()) {
              case "undefined":
                return Sn("undefined", void 0);
              case "nan":
                return Sn("nan", NaN);
              case "null":
                return Sn("null", null);
              case "true":
                return Sn("boolean", true);
              case "false":
                return Sn("boolean", false);
              default:
                if (De = Date.parse(De))
                  return Sn("date", new Date(De));
            }
            return Sn(false, null);
          }
          function Sn(De, ze) {
            return { type: De, value: ze };
          }
          var Ca = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
            } }]), pe;
          }(le.a.PureComponent), wa = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
            } }]), pe;
          }(le.a.PureComponent), Di = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]), hr = qa(Ve).style;
              return le.a.createElement("span", Tt, le.a.createElement("svg", { fill: hr.color, width: hr.height, height: hr.width, style: hr, viewBox: "0 0 1792 1792" }, le.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), pe;
          }(le.a.PureComponent), Mi = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]), hr = qa(Ve).style;
              return le.a.createElement("span", Tt, le.a.createElement("svg", { fill: hr.color, width: hr.height, height: hr.width, style: hr, viewBox: "0 0 1792 1792" }, le.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), pe;
          }(le.a.PureComponent), Da = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", { style: Q(Q({}, qa(Ve).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, le.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
            } }]), pe;
          }(le.a.PureComponent), ko = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", { style: Q(Q({}, qa(Ve).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, le.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
            } }]), pe;
          }(le.a.PureComponent), uo = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
            } }]), pe;
          }(le.a.PureComponent), xs = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), pe;
          }(le.a.PureComponent), Lu = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), pe;
          }(le.a.PureComponent), Ul = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
            } }]), pe;
          }(le.a.PureComponent), ws = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
            } }]), pe;
          }(le.a.PureComponent), Go = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.style, Tt = St(Oe, ["style"]);
              return le.a.createElement("span", Tt, le.a.createElement("svg", Object.assign({}, qa(Ve), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), le.a.createElement("g", null, le.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), pe;
          }(le.a.PureComponent);
          function qa(De) {
            return De || (De = {}), { style: Q(Q({ verticalAlign: "middle" }, De), {}, { color: De.color ? De.color : "#000000", height: "1em", width: "1em" }) };
          }
          var Ss = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).copiedTimer = null, Ve.handleCopy = function() {
                var Tt = document.createElement("textarea"), hr = Ve.props, Xt = hr.clickCallback, lt2 = hr.src, Fr = hr.namespace;
                Tt.innerHTML = JSON.stringify(Ve.clipboardValue(lt2), null, "  "), document.body.appendChild(Tt), Tt.select(), document.execCommand("copy"), document.body.removeChild(Tt), Ve.copiedTimer = setTimeout(function() {
                  Ve.setState({ copied: false });
                }, 5500), Ve.setState({ copied: true }, function() {
                  typeof Xt == "function" && Xt({ src: lt2, namespace: Fr, name: Fr[Fr.length - 1] });
                });
              }, Ve.getClippyIcon = function() {
                var Tt = Ve.props.theme;
                return Ve.state.copied ? le.a.createElement("span", null, le.a.createElement(uo, Object.assign({ className: "copy-icon" }, Jt(Tt, "copy-icon"))), le.a.createElement("span", Jt(Tt, "copy-icon-copied"), "\u2714")) : le.a.createElement(uo, Object.assign({ className: "copy-icon" }, Jt(Tt, "copy-icon")));
              }, Ve.clipboardValue = function(Tt) {
                switch (kt(Tt)) {
                  case "function":
                  case "regexp":
                    return Tt.toString();
                  default:
                    return Tt;
                }
              }, Ve.state = { copied: false }, Ve;
            }
            return Ae(pe, [{ key: "componentWillUnmount", value: function() {
              this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
            } }, { key: "render", value: function() {
              var Oe = this.props, Ve = (Oe.src, Oe.theme), Tt = Oe.hidden, hr = Oe.rowHovered, Xt = Jt(Ve, "copy-to-clipboard").style, lt2 = "inline";
              return Tt && (lt2 = "none"), le.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: hr ? "inline-block" : "none" } }, le.a.createElement("span", { style: Q(Q({}, Xt), {}, { display: lt2 }), onClick: this.handleCopy }, this.getClippyIcon()));
            } }]), pe;
          }(le.a.PureComponent), Js = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).getEditIcon = function() {
                var Tt = Ve.props, hr = Tt.variable, Xt = Tt.theme;
                return le.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Ve.state.hovered ? "inline-block" : "none" } }, le.a.createElement(ws, Object.assign({ className: "click-to-edit-icon" }, Jt(Xt, "editVarIcon"), { onClick: function() {
                  Ve.prepopInput(hr);
                } })));
              }, Ve.prepopInput = function(Tt) {
                if (Ve.props.onEdit !== false) {
                  var hr = function(lt2) {
                    var Fr;
                    switch (kt(lt2)) {
                      case "undefined":
                        Fr = "undefined";
                        break;
                      case "nan":
                        Fr = "NaN";
                        break;
                      case "string":
                        Fr = lt2;
                        break;
                      case "date":
                      case "function":
                      case "regexp":
                        Fr = lt2.toString();
                        break;
                      default:
                        try {
                          Fr = JSON.stringify(lt2, null, "  ");
                        } catch {
                          Fr = "";
                        }
                    }
                    return Fr;
                  }(Tt.value), Xt = tn(hr);
                  Ve.setState({ editMode: true, editValue: hr, parsedInput: { type: Xt.type, value: Xt.value } });
                }
              }, Ve.getRemoveIcon = function() {
                var Tt = Ve.props, hr = Tt.variable, Xt = Tt.namespace, lt2 = Tt.theme, Fr = Tt.rjvId;
                return le.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Ve.state.hovered ? "inline-block" : "none" } }, le.a.createElement(xs, Object.assign({ className: "click-to-remove-icon" }, Jt(lt2, "removeVarIcon"), { onClick: function() {
                  Pa.dispatch({ name: "VARIABLE_REMOVED", rjvId: Fr, data: { name: hr.name, namespace: Xt, existing_value: hr.value, variable_removed: true } });
                } })));
              }, Ve.getValue = function(Tt, hr) {
                var Xt = !hr && Tt.type, lt2 = ct(Ve).props;
                switch (Xt) {
                  case false:
                    return Ve.getEditInput();
                  case "string":
                    return le.a.createElement(qo, Object.assign({ value: Tt.value }, lt2));
                  case "integer":
                    return le.a.createElement(is, Object.assign({ value: Tt.value }, lt2));
                  case "float":
                    return le.a.createElement(zt, Object.assign({ value: Tt.value }, lt2));
                  case "boolean":
                    return le.a.createElement(ur, Object.assign({ value: Tt.value }, lt2));
                  case "function":
                    return le.a.createElement(pi, Object.assign({ value: Tt.value }, lt2));
                  case "null":
                    return le.a.createElement(rl, lt2);
                  case "nan":
                    return le.a.createElement(Lo, lt2);
                  case "undefined":
                    return le.a.createElement(du, lt2);
                  case "date":
                    return le.a.createElement(Gt, Object.assign({ value: Tt.value }, lt2));
                  case "regexp":
                    return le.a.createElement(Xs, Object.assign({ value: Tt.value }, lt2));
                  default:
                    return le.a.createElement("div", { className: "object-value" }, JSON.stringify(Tt.value));
                }
              }, Ve.getEditInput = function() {
                var Tt = Ve.props.theme, hr = Ve.state.editValue;
                return le.a.createElement("div", null, le.a.createElement(_r, Object.assign({ type: "text", inputRef: function(Xt) {
                  return Xt && Xt.focus();
                }, value: hr, className: "variable-editor", onChange: function(Xt) {
                  var lt2 = Xt.target.value, Fr = tn(lt2);
                  Ve.setState({ editValue: lt2, parsedInput: { type: Fr.type, value: Fr.value } });
                }, onKeyDown: function(Xt) {
                  switch (Xt.key) {
                    case "Escape":
                      Ve.setState({ editMode: false, editValue: "" });
                      break;
                    case "Enter":
                      (Xt.ctrlKey || Xt.metaKey) && Ve.submitEdit(true);
                  }
                  Xt.stopPropagation();
                }, placeholder: "update this value", minRows: 2 }, Jt(Tt, "edit-input"))), le.a.createElement("div", Jt(Tt, "edit-icon-container"), le.a.createElement(xs, Object.assign({ className: "edit-cancel" }, Jt(Tt, "cancel-icon"), { onClick: function() {
                  Ve.setState({ editMode: false, editValue: "" });
                } })), le.a.createElement(Go, Object.assign({ className: "edit-check string-value" }, Jt(Tt, "check-icon"), { onClick: function() {
                  Ve.submitEdit();
                } })), le.a.createElement("div", null, Ve.showDetected())));
              }, Ve.submitEdit = function(Tt) {
                var hr = Ve.props, Xt = hr.variable, lt2 = hr.namespace, Fr = hr.rjvId, yn = Ve.state, Ia = yn.editValue, Ea = yn.parsedInput, pa = Ia;
                Tt && Ea.type && (pa = Ea.value), Ve.setState({ editMode: false }), Pa.dispatch({ name: "VARIABLE_UPDATED", rjvId: Fr, data: { name: Xt.name, namespace: lt2, existing_value: Xt.value, new_value: pa, variable_removed: false } });
              }, Ve.showDetected = function() {
                var Tt = Ve.props, hr = Tt.theme, Xt = (Tt.variable, Tt.namespace, Tt.rjvId, Ve.state.parsedInput), lt2 = (Xt.type, Xt.value, Ve.getDetectedInput());
                if (lt2)
                  return le.a.createElement("div", null, le.a.createElement("div", Jt(hr, "detected-row"), lt2, le.a.createElement(Go, { className: "edit-check detected", style: Q({ verticalAlign: "top", paddingLeft: "3px" }, Jt(hr, "check-icon").style), onClick: function() {
                    Ve.submitEdit(true);
                  } })));
              }, Ve.getDetectedInput = function() {
                var Tt = Ve.state.parsedInput, hr = Tt.type, Xt = Tt.value, lt2 = ct(Ve).props, Fr = lt2.theme;
                if (hr !== false)
                  switch (hr.toLowerCase()) {
                    case "object":
                      return le.a.createElement("span", null, le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "brace").style), {}, { cursor: "default" }) }, "{"), le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "brace").style), {}, { cursor: "default" }) }, "}"));
                    case "array":
                      return le.a.createElement("span", null, le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "brace").style), {}, { cursor: "default" }) }, "["), le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), le.a.createElement("span", { style: Q(Q({}, Jt(Fr, "brace").style), {}, { cursor: "default" }) }, "]"));
                    case "string":
                      return le.a.createElement(qo, Object.assign({ value: Xt }, lt2));
                    case "integer":
                      return le.a.createElement(is, Object.assign({ value: Xt }, lt2));
                    case "float":
                      return le.a.createElement(zt, Object.assign({ value: Xt }, lt2));
                    case "boolean":
                      return le.a.createElement(ur, Object.assign({ value: Xt }, lt2));
                    case "function":
                      return le.a.createElement(pi, Object.assign({ value: Xt }, lt2));
                    case "null":
                      return le.a.createElement(rl, lt2);
                    case "nan":
                      return le.a.createElement(Lo, lt2);
                    case "undefined":
                      return le.a.createElement(du, lt2);
                    case "date":
                      return le.a.createElement(Gt, Object.assign({ value: new Date(Xt) }, lt2));
                  }
              }, Ve.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Ve;
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this, Ve = this.props, Tt = Ve.variable, hr = Ve.singleIndent, Xt = Ve.type, lt2 = Ve.theme, Fr = Ve.namespace, yn = Ve.indentWidth, Ia = Ve.enableClipboard, Ea = Ve.onEdit, pa = Ve.onDelete, Wn = Ve.onSelect, ki = Ve.displayArrayKey, bo = Ve.quotesOnKeys, na = this.state.editMode;
              return le.a.createElement("div", Object.assign({}, Jt(lt2, "objectKeyVal", { paddingLeft: yn * hr }), { onMouseEnter: function() {
                return Oe.setState(Q(Q({}, Oe.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return Oe.setState(Q(Q({}, Oe.state), {}, { hovered: false }));
              }, className: "variable-row", key: Tt.name }), Xt == "array" ? ki ? le.a.createElement("span", Object.assign({}, Jt(lt2, "array-key"), { key: Tt.name + "_" + Fr }), Tt.name, le.a.createElement("div", Jt(lt2, "colon"), ":")) : null : le.a.createElement("span", null, le.a.createElement("span", Object.assign({}, Jt(lt2, "object-name"), { className: "object-key", key: Tt.name + "_" + Fr }), !!bo && le.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), le.a.createElement("span", { style: { display: "inline-block" } }, Tt.name), !!bo && le.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), le.a.createElement("span", Jt(lt2, "colon"), ":")), le.a.createElement("div", Object.assign({ className: "variable-value", onClick: Wn === false && Ea === false ? null : function(Ro) {
                var Qs = Ua(Fr);
                (Ro.ctrlKey || Ro.metaKey) && Ea !== false ? Oe.prepopInput(Tt) : Wn !== false && (Qs.shift(), Wn(Q(Q({}, Tt), {}, { namespace: Qs })));
              } }, Jt(lt2, "variableValue", { cursor: Wn === false ? "default" : "pointer" })), this.getValue(Tt, na)), Ia ? le.a.createElement(Ss, { rowHovered: this.state.hovered, hidden: na, src: Tt.value, clickCallback: Ia, theme: lt2, namespace: [].concat(Ua(Fr), [Tt.name]) }) : null, Ea !== false && na == 0 ? this.getEditIcon() : null, pa !== false && na == 0 ? this.getRemoveIcon() : null);
            } }]), pe;
          }(le.a.PureComponent), al = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              var Oe;
              he(this, pe);
              for (var Ve = arguments.length, Tt = new Array(Ve), hr = 0; hr < Ve; hr++)
                Tt[hr] = arguments[hr];
              return (Oe = ze.call.apply(ze, [this].concat(Tt))).getObjectSize = function() {
                var Xt = Oe.props, lt2 = Xt.size, Fr = Xt.theme;
                if (Xt.displayObjectSize)
                  return le.a.createElement("span", Object.assign({ className: "object-size" }, Jt(Fr, "object-size")), lt2, " item", lt2 === 1 ? "" : "s");
              }, Oe.getAddAttribute = function(Xt) {
                var lt2 = Oe.props, Fr = lt2.theme, yn = lt2.namespace, Ia = lt2.name, Ea = lt2.src, pa = lt2.rjvId, Wn = lt2.depth;
                return le.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Xt ? "inline-block" : "none" } }, le.a.createElement(Lu, Object.assign({ className: "click-to-add-icon" }, Jt(Fr, "addVarIcon"), { onClick: function() {
                  var ki = { name: Wn > 0 ? Ia : null, namespace: yn.splice(0, yn.length - 1), existing_value: Ea, variable_removed: false, key_name: null };
                  kt(Ea) === "object" ? Pa.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: pa, data: ki }) : Pa.dispatch({ name: "VARIABLE_ADDED", rjvId: pa, data: Q(Q({}, ki), {}, { new_value: [].concat(Ua(Ea), [null]) }) });
                } })));
              }, Oe.getRemoveObject = function(Xt) {
                var lt2 = Oe.props, Fr = lt2.theme, yn = (lt2.hover, lt2.namespace), Ia = lt2.name, Ea = lt2.src, pa = lt2.rjvId;
                if (yn.length !== 1)
                  return le.a.createElement("span", { className: "click-to-remove", style: { display: Xt ? "inline-block" : "none" } }, le.a.createElement(xs, Object.assign({ className: "click-to-remove-icon" }, Jt(Fr, "removeVarIcon"), { onClick: function() {
                    Pa.dispatch({ name: "VARIABLE_REMOVED", rjvId: pa, data: { name: Ia, namespace: yn.splice(0, yn.length - 1), existing_value: Ea, variable_removed: true } });
                  } })));
              }, Oe.render = function() {
                var Xt = Oe.props, lt2 = Xt.theme, Fr = Xt.onDelete, yn = Xt.onAdd, Ia = Xt.enableClipboard, Ea = Xt.src, pa = Xt.namespace, Wn = Xt.rowHovered;
                return le.a.createElement("div", Object.assign({}, Jt(lt2, "object-meta-data"), { className: "object-meta-data", onClick: function(ki) {
                  ki.stopPropagation();
                } }), Oe.getObjectSize(), Ia ? le.a.createElement(Ss, { rowHovered: Wn, clickCallback: Ia, src: Ea, theme: lt2, namespace: pa }) : null, yn !== false ? Oe.getAddAttribute(Wn) : null, Fr !== false ? Oe.getRemoveObject(Wn) : null);
              }, Oe;
            }
            return pe;
          }(le.a.PureComponent);
          function Ou(De) {
            var ze = De.parent_type, pe = De.namespace, Oe = De.quotesOnKeys, Ve = De.theme, Tt = De.jsvRoot, hr = De.name, Xt = De.displayArrayKey, lt2 = De.name ? De.name : "";
            return !Tt || hr !== false && hr !== null ? ze == "array" ? Xt ? le.a.createElement("span", Object.assign({}, Jt(Ve, "array-key"), { key: pe }), le.a.createElement("span", { className: "array-key" }, lt2), le.a.createElement("span", Jt(Ve, "colon"), ":")) : le.a.createElement("span", null) : le.a.createElement("span", Object.assign({}, Jt(Ve, "object-name"), { key: pe }), le.a.createElement("span", { className: "object-key" }, Oe && le.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), le.a.createElement("span", null, lt2), Oe && le.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), le.a.createElement("span", Jt(Ve, "colon"), ":")) : le.a.createElement("span", null);
          }
          function pu(De) {
            var ze = De.theme;
            switch (De.iconStyle) {
              case "triangle":
                return le.a.createElement(ko, Object.assign({}, Jt(ze, "expanded-icon"), { className: "expanded-icon" }));
              case "square":
                return le.a.createElement(Di, Object.assign({}, Jt(ze, "expanded-icon"), { className: "expanded-icon" }));
              default:
                return le.a.createElement(Ca, Object.assign({}, Jt(ze, "expanded-icon"), { className: "expanded-icon" }));
            }
          }
          function il(De) {
            var ze = De.theme;
            switch (De.iconStyle) {
              case "triangle":
                return le.a.createElement(Da, Object.assign({}, Jt(ze, "collapsed-icon"), { className: "collapsed-icon" }));
              case "square":
                return le.a.createElement(Mi, Object.assign({}, Jt(ze, "collapsed-icon"), { className: "collapsed-icon" }));
              default:
                return le.a.createElement(wa, Object.assign({}, Jt(ze, "collapsed-icon"), { className: "collapsed-icon" }));
            }
          }
          var uh = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).toggleCollapsed = function(Tt) {
                var hr = [];
                for (var Xt in Ve.state.expanded)
                  hr.push(Ve.state.expanded[Xt]);
                hr[Tt] = !hr[Tt], Ve.setState({ expanded: hr });
              }, Ve.state = { expanded: [] }, Ve;
            }
            return Ae(pe, [{ key: "getExpandedIcon", value: function(Oe) {
              var Ve = this.props, Tt = Ve.theme, hr = Ve.iconStyle;
              return this.state.expanded[Oe] ? le.a.createElement(pu, { theme: Tt, iconStyle: hr }) : le.a.createElement(il, { theme: Tt, iconStyle: hr });
            } }, { key: "render", value: function() {
              var Oe = this, Ve = this.props, Tt = Ve.src, hr = Ve.groupArraysAfterLength, Xt = (Ve.depth, Ve.name), lt2 = Ve.theme, Fr = Ve.jsvRoot, yn = Ve.namespace, Ia = (Ve.parent_type, St(Ve, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Ea = 0, pa = 5 * this.props.indentWidth;
              Fr || (Ea = 5 * this.props.indentWidth);
              var Wn = hr, ki = Math.ceil(Tt.length / Wn);
              return le.a.createElement("div", Object.assign({ className: "object-key-val" }, Jt(lt2, Fr ? "jsv-root" : "objectKeyVal", { paddingLeft: Ea })), le.a.createElement(Ou, this.props), le.a.createElement("span", null, le.a.createElement(al, Object.assign({ size: Tt.length }, this.props))), Ua(Array(ki)).map(function(bo, na) {
                return le.a.createElement("div", Object.assign({ key: na, className: "object-key-val array-group" }, Jt(lt2, "objectKeyVal", { marginLeft: 6, paddingLeft: pa })), le.a.createElement("span", Jt(lt2, "brace-row"), le.a.createElement("div", Object.assign({ className: "icon-container" }, Jt(lt2, "icon-container"), { onClick: function(Ro) {
                  Oe.toggleCollapsed(na);
                } }), Oe.getExpandedIcon(na)), Oe.state.expanded[na] ? le.a.createElement(Hl, Object.assign({ key: Xt + na, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Wn, index_offset: na * Wn, src: Tt.slice(na * Wn, na * Wn + Wn), namespace: yn, type: "array", parent_type: "array_group", theme: lt2 }, Ia)) : le.a.createElement("span", Object.assign({}, Jt(lt2, "brace"), { onClick: function(Ro) {
                  Oe.toggleCollapsed(na);
                }, className: "array-group-brace" }), "[", le.a.createElement("div", Object.assign({}, Jt(lt2, "array-group-meta-data"), { className: "array-group-meta-data" }), le.a.createElement("span", Object.assign({ className: "object-size" }, Jt(lt2, "object-size")), na * Wn, " - ", na * Wn + Wn > Tt.length ? Tt.length : na * Wn + Wn)), "]")));
              }));
            } }]), pe;
          }(le.a.PureComponent), bc = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              he(this, pe), (Ve = ze.call(this, Oe)).toggleCollapsed = function() {
                Ve.setState({ expanded: !Ve.state.expanded }, function() {
                  Ha.set(Ve.props.rjvId, Ve.props.namespace, "expanded", Ve.state.expanded);
                });
              }, Ve.getObjectContent = function(hr, Xt, lt2) {
                return le.a.createElement("div", { className: "pushed-content object-container" }, le.a.createElement("div", Object.assign({ className: "object-content" }, Jt(Ve.props.theme, "pushed-content")), Ve.renderObjectContents(Xt, lt2)));
              }, Ve.getEllipsis = function() {
                return Ve.state.size === 0 ? null : le.a.createElement("div", Object.assign({}, Jt(Ve.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Ve.toggleCollapsed }), "...");
              }, Ve.getObjectMetaData = function(hr) {
                var Xt = Ve.props, lt2 = (Xt.rjvId, Xt.theme, Ve.state), Fr = lt2.size, yn = lt2.hovered;
                return le.a.createElement(al, Object.assign({ rowHovered: yn, size: Fr }, Ve.props));
              }, Ve.renderObjectContents = function(hr, Xt) {
                var lt2, Fr = Ve.props, yn = Fr.depth, Ia = Fr.parent_type, Ea = Fr.index_offset, pa = Fr.groupArraysAfterLength, Wn = Fr.namespace, ki = Ve.state.object_type, bo = [], na = Object.keys(hr || {});
                return Ve.props.sortKeys && ki !== "array" && (na = na.sort()), na.forEach(function(Ro) {
                  if (lt2 = new Jg(Ro, hr[Ro]), Ia === "array_group" && Ea && (lt2.name = parseInt(lt2.name) + Ea), hr.hasOwnProperty(Ro))
                    if (lt2.type === "object")
                      bo.push(le.a.createElement(Hl, Object.assign({ key: lt2.name, depth: yn + 1, name: lt2.name, src: lt2.value, namespace: Wn.concat(lt2.name), parent_type: ki }, Xt)));
                    else if (lt2.type === "array") {
                      var Qs = Hl;
                      pa && lt2.value.length > pa && (Qs = uh), bo.push(le.a.createElement(Qs, Object.assign({ key: lt2.name, depth: yn + 1, name: lt2.name, src: lt2.value, namespace: Wn.concat(lt2.name), type: "array", parent_type: ki }, Xt)));
                    } else
                      bo.push(le.a.createElement(Js, Object.assign({ key: lt2.name + "_" + Wn, variable: lt2, singleIndent: 5, namespace: Wn, type: Ve.props.type }, Xt)));
                }), bo;
              };
              var Tt = pe.getState(Oe);
              return Ve.state = Q(Q({}, Tt), {}, { prevProps: {} }), Ve;
            }
            return Ae(pe, [{ key: "getBraceStart", value: function(Oe, Ve) {
              var Tt = this, hr = this.props, Xt = hr.src, lt2 = hr.theme, Fr = hr.iconStyle;
              if (hr.parent_type === "array_group")
                return le.a.createElement("span", null, le.a.createElement("span", Jt(lt2, "brace"), Oe === "array" ? "[" : "{"), Ve ? this.getObjectMetaData(Xt) : null);
              var yn = Ve ? pu : il;
              return le.a.createElement("span", null, le.a.createElement("span", Object.assign({ onClick: function(Ia) {
                Tt.toggleCollapsed();
              } }, Jt(lt2, "brace-row")), le.a.createElement("div", Object.assign({ className: "icon-container" }, Jt(lt2, "icon-container")), le.a.createElement(yn, { theme: lt2, iconStyle: Fr })), le.a.createElement(Ou, this.props), le.a.createElement("span", Jt(lt2, "brace"), Oe === "array" ? "[" : "{")), Ve ? this.getObjectMetaData(Xt) : null);
            } }, { key: "render", value: function() {
              var Oe = this, Ve = this.props, Tt = Ve.depth, hr = Ve.src, Xt = (Ve.namespace, Ve.name, Ve.type, Ve.parent_type), lt2 = Ve.theme, Fr = Ve.jsvRoot, yn = Ve.iconStyle, Ia = St(Ve, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Ea = this.state, pa = Ea.object_type, Wn = Ea.expanded, ki = {};
              return Fr || Xt === "array_group" ? Xt === "array_group" && (ki.borderLeft = 0, ki.display = "inline") : ki.paddingLeft = 5 * this.props.indentWidth, le.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                return Oe.setState(Q(Q({}, Oe.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return Oe.setState(Q(Q({}, Oe.state), {}, { hovered: false }));
              } }, Jt(lt2, Fr ? "jsv-root" : "objectKeyVal", ki)), this.getBraceStart(pa, Wn), Wn ? this.getObjectContent(Tt, hr, Q({ theme: lt2, iconStyle: yn }, Ia)) : this.getEllipsis(), le.a.createElement("span", { className: "brace-row" }, le.a.createElement("span", { style: Q(Q({}, Jt(lt2, "brace").style), {}, { paddingLeft: Wn ? "3px" : "0px" }) }, pa === "array" ? "]" : "}"), Wn ? null : this.getObjectMetaData(hr)));
            } }], [{ key: "getDerivedStateFromProps", value: function(Oe, Ve) {
              var Tt = Ve.prevProps;
              return Oe.src !== Tt.src || Oe.collapsed !== Tt.collapsed || Oe.name !== Tt.name || Oe.namespace !== Tt.namespace || Oe.rjvId !== Tt.rjvId ? Q(Q({}, pe.getState(Oe)), {}, { prevProps: Oe }) : null;
            } }]), pe;
          }(le.a.PureComponent);
          bc.getState = function(De) {
            var ze = Object.keys(De.src).length, pe = (De.collapsed === false || De.collapsed !== true && De.collapsed > De.depth) && (!De.shouldCollapse || De.shouldCollapse({ name: De.name, src: De.src, type: kt(De.src), namespace: De.namespace }) === false) && ze !== 0;
            return { expanded: Ha.get(De.rjvId, De.namespace, "expanded", pe), object_type: De.type === "array" ? "array" : "object", parent_type: De.type === "array" ? "array" : "object", size: ze, hovered: false };
          };
          var Jg = function De(ze, pe) {
            he(this, De), this.name = ze, this.value = pe, this.type = kt(pe);
          };
          Kt(bc);
          var Hl = bc, wp = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              var Oe;
              he(this, pe);
              for (var Ve = arguments.length, Tt = new Array(Ve), hr = 0; hr < Ve; hr++)
                Tt[hr] = arguments[hr];
              return (Oe = ze.call.apply(ze, [this].concat(Tt))).render = function() {
                var Xt = ct(Oe).props, lt2 = [Xt.name], Fr = Hl;
                return Array.isArray(Xt.src) && Xt.groupArraysAfterLength && Xt.src.length > Xt.groupArraysAfterLength && (Fr = uh), le.a.createElement("div", { className: "pretty-json-container object-container" }, le.a.createElement("div", { className: "object-content" }, le.a.createElement(Fr, Object.assign({ namespace: lt2, depth: 0, jsvRoot: true }, Xt))));
              }, Oe;
            }
            return pe;
          }(le.a.PureComponent), Qg = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).closeModal = function() {
                Pa.dispatch({ rjvId: Ve.props.rjvId, name: "RESET" });
              }, Ve.submit = function() {
                Ve.props.submit(Ve.state.input);
              }, Ve.state = { input: Oe.input ? Oe.input : "" }, Ve;
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this, Ve = this.props, Tt = Ve.theme, hr = Ve.rjvId, Xt = Ve.isValid, lt2 = this.state.input, Fr = Xt(lt2);
              return le.a.createElement("div", Object.assign({ className: "key-modal-request" }, Jt(Tt, "key-modal-request"), { onClick: this.closeModal }), le.a.createElement("div", Object.assign({}, Jt(Tt, "key-modal"), { onClick: function(yn) {
                yn.stopPropagation();
              } }), le.a.createElement("div", Jt(Tt, "key-modal-label"), "Key Name:"), le.a.createElement("div", { style: { position: "relative" } }, le.a.createElement("input", Object.assign({}, Jt(Tt, "key-modal-input"), { className: "key-modal-input", ref: function(yn) {
                return yn && yn.focus();
              }, spellCheck: false, value: lt2, placeholder: "...", onChange: function(yn) {
                Oe.setState({ input: yn.target.value });
              }, onKeyPress: function(yn) {
                Fr && yn.key === "Enter" ? Oe.submit() : yn.key === "Escape" && Oe.closeModal();
              } })), Fr ? le.a.createElement(Go, Object.assign({}, Jt(Tt, "key-modal-submit"), { className: "key-modal-submit", onClick: function(yn) {
                return Oe.submit();
              } })) : null), le.a.createElement("span", Jt(Tt, "key-modal-cancel"), le.a.createElement(Ul, Object.assign({}, Jt(Tt, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                Pa.dispatch({ rjvId: hr, name: "RESET" });
              } })))));
            } }]), pe;
          }(le.a.PureComponent), od = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              var Oe;
              he(this, pe);
              for (var Ve = arguments.length, Tt = new Array(Ve), hr = 0; hr < Ve; hr++)
                Tt[hr] = arguments[hr];
              return (Oe = ze.call.apply(ze, [this].concat(Tt))).isValid = function(Xt) {
                var lt2 = Oe.props.rjvId, Fr = Ha.get(lt2, "action", "new-key-request");
                return Xt != "" && Object.keys(Fr.existing_value).indexOf(Xt) === -1;
              }, Oe.submit = function(Xt) {
                var lt2 = Oe.props.rjvId, Fr = Ha.get(lt2, "action", "new-key-request");
                Fr.new_value = Q({}, Fr.existing_value), Fr.new_value[Xt] = Oe.props.defaultValue, Pa.dispatch({ name: "VARIABLE_ADDED", rjvId: lt2, data: Fr });
              }, Oe;
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.active, Tt = Oe.theme, hr = Oe.rjvId;
              return Ve ? le.a.createElement(Qg, { rjvId: hr, theme: Tt, isValid: this.isValid, submit: this.submit }) : null;
            } }]), pe;
          }(le.a.PureComponent), sd = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe() {
              return he(this, pe), ze.apply(this, arguments);
            }
            return Ae(pe, [{ key: "render", value: function() {
              var Oe = this.props, Ve = Oe.message, Tt = Oe.active, hr = Oe.theme, Xt = Oe.rjvId;
              return Tt ? le.a.createElement("div", Object.assign({ className: "validation-failure" }, Jt(hr, "validation-failure"), { onClick: function() {
                Pa.dispatch({ rjvId: Xt, name: "RESET" });
              } }), le.a.createElement("span", Jt(hr, "validation-failure-label"), Ve), le.a.createElement(Ul, Jt(hr, "validation-failure-clear"))) : null;
            } }]), pe;
          }(le.a.PureComponent), lh = function(De) {
            Xe(pe, De);
            var ze = Yt(pe);
            function pe(Oe) {
              var Ve;
              return he(this, pe), (Ve = ze.call(this, Oe)).rjvId = Date.now().toString(), Ve.getListeners = function() {
                return { reset: Ve.resetState, "variable-update": Ve.updateSrc, "add-key-request": Ve.addKeyRequest };
              }, Ve.updateSrc = function() {
                var Tt, hr = Ha.get(Ve.rjvId, "action", "variable-update"), Xt = hr.name, lt2 = hr.namespace, Fr = hr.new_value, yn = hr.existing_value, Ia = (hr.variable_removed, hr.updated_src), Ea = hr.type, pa = Ve.props, Wn = pa.onEdit, ki = pa.onDelete, bo = pa.onAdd, na = { existing_src: Ve.state.src, new_value: Fr, updated_src: Ia, name: Xt, namespace: lt2, existing_value: yn };
                switch (Ea) {
                  case "variable-added":
                    Tt = bo(na);
                    break;
                  case "variable-edited":
                    Tt = Wn(na);
                    break;
                  case "variable-removed":
                    Tt = ki(na);
                }
                Tt !== false ? (Ha.set(Ve.rjvId, "global", "src", Ia), Ve.setState({ src: Ia })) : Ve.setState({ validationFailure: true });
              }, Ve.addKeyRequest = function() {
                Ve.setState({ addKeyRequest: true });
              }, Ve.resetState = function() {
                Ve.setState({ validationFailure: false, addKeyRequest: false });
              }, Ve.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: pe.defaultProps.src, name: pe.defaultProps.name, theme: pe.defaultProps.theme, validationMessage: pe.defaultProps.validationMessage, prevSrc: pe.defaultProps.src, prevName: pe.defaultProps.name, prevTheme: pe.defaultProps.theme }, Ve;
            }
            return Ae(pe, [{ key: "componentDidMount", value: function() {
              Ha.set(this.rjvId, "global", "src", this.state.src);
              var Oe = this.getListeners();
              for (var Ve in Oe)
                Ha.on(Ve + "-" + this.rjvId, Oe[Ve]);
              this.setState({ addKeyRequest: false, editKeyRequest: false });
            } }, { key: "componentDidUpdate", value: function(Oe, Ve) {
              Ve.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Ve.editKeyRequest !== false && this.setState({ editKeyRequest: false }), Oe.src !== this.state.src && Ha.set(this.rjvId, "global", "src", this.state.src);
            } }, { key: "componentWillUnmount", value: function() {
              var Oe = this.getListeners();
              for (var Ve in Oe)
                Ha.removeListener(Ve + "-" + this.rjvId, Oe[Ve]);
            } }, { key: "render", value: function() {
              var Oe = this.state, Ve = Oe.validationFailure, Tt = Oe.validationMessage, hr = Oe.addKeyRequest, Xt = Oe.theme, lt2 = Oe.src, Fr = Oe.name, yn = this.props, Ia = yn.style, Ea = yn.defaultValue;
              return le.a.createElement("div", { className: "react-json-view", style: Q(Q({}, Jt(Xt, "app-container").style), Ia) }, le.a.createElement(sd, { message: Tt, active: Ve, theme: Xt, rjvId: this.rjvId }), le.a.createElement(wp, Object.assign({}, this.props, { src: lt2, name: Fr, theme: Xt, type: kt(lt2), rjvId: this.rjvId })), le.a.createElement(od, { active: hr, theme: Xt, rjvId: this.rjvId, defaultValue: Ea }));
            } }], [{ key: "getDerivedStateFromProps", value: function(Oe, Ve) {
              if (Oe.src !== Ve.prevSrc || Oe.name !== Ve.prevName || Oe.theme !== Ve.prevTheme) {
                var Tt = { src: Oe.src, name: Oe.name, theme: Oe.theme, validationMessage: Oe.validationMessage, prevSrc: Oe.src, prevName: Oe.name, prevTheme: Oe.theme };
                return pe.validateState(Tt);
              }
              return null;
            } }]), pe;
          }(le.a.PureComponent);
          lh.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, lh.validateState = function(De) {
            var ze = {};
            return kt(De.theme) !== "object" || function(pe) {
              var Oe = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
              if (kt(pe) === "object") {
                for (var Ve = 0; Ve < Oe.length; Ve++)
                  if (!(Oe[Ve] in pe))
                    return false;
                return true;
              }
              return false;
            }(De.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), ze.theme = "rjv-default"), kt(De.src) !== "object" && kt(De.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), ze.name = "ERROR", ze.src = { message: "src property must be a valid json object" }), Q(Q({}, De), ze);
          }, Kt(lh), L.default = lh;
        }]);
      });
    })(pS);
    var gS = b2(pS.exports);
    const yS = ({ id: T, title: G, chart: P, option: I }) => {
      const { tool: L } = $e({}), j = E({ global: true }), [J, { set: te }] = U(true);
      console.log("option", I);
      const Q = (he) => {
        const { updated_src: de } = he;
        P == null || P.setOption(de), L == null || L.add(T, P, de, G), j.emit("list");
      };
      return fS("div", { children: [xp(zD, { children: xp(HA, { children: xp(vS, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (he) => {
        te(!he);
      } }) }) }), xp("br", {}), I && xp(gS, { src: I, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: J, iconStyle: "triangle", enableClipboard: true, onEdit: Q, onAdd: Q, onDelete: Q })] });
    };
    r2.EchartTool = dS, r2.ReactEchartsJson = yS, r2.useEchartsTool = $e, r2.useEventEmitter = E;
  })(v5e);
  const d5e = () => {
    const r2 = M3({ global: true }), t2 = Li.useRef(0), { tool: e2 } = VN({});
    Li.useState(false), Li.useState("right");
    const [n2, a] = Li.useState([]), [i, o] = Li.useState();
    return r2.useSubscription("list", () => {
      var s;
      e2 != null && e2.list().length && (o((s = e2 == null ? void 0 : e2.list()) == null ? void 0 : s[t2.current]), a(e2 == null ? void 0 : e2.list()));
    }), jx("div", { className: h5e.container, children: false });
  };
  var qX = { exports: {} };
  (function(r2, t2) {
    (function(e2, n2) {
      r2.exports = n2(ew.default);
    })(jh, function(e2) {
      return function(n2) {
        var a = {};
        function i(o) {
          if (a[o])
            return a[o].exports;
          var s = a[o] = { i: o, l: false, exports: {} };
          return n2[o].call(s.exports, s, s.exports, i), s.l = true, s.exports;
        }
        return i.m = n2, i.c = a, i.d = function(o, s, u) {
          i.o(o, s) || Object.defineProperty(o, s, { enumerable: true, get: u });
        }, i.r = function(o) {
          typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(o, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(o, "__esModule", { value: true });
        }, i.t = function(o, s) {
          if (1 & s && (o = i(o)), 8 & s || 4 & s && typeof o == "object" && o && o.__esModule)
            return o;
          var u = /* @__PURE__ */ Object.create(null);
          if (i.r(u), Object.defineProperty(u, "default", { enumerable: true, value: o }), 2 & s && typeof o != "string")
            for (var l2 in o)
              i.d(u, l2, function(c2) {
                return o[c2];
              }.bind(null, l2));
          return u;
        }, i.n = function(o) {
          var s = o && o.__esModule ? function() {
            return o.default;
          } : function() {
            return o;
          };
          return i.d(s, "a", s), s;
        }, i.o = function(o, s) {
          return Object.prototype.hasOwnProperty.call(o, s);
        }, i.p = "", i(i.s = 48);
      }([function(n2, a) {
        n2.exports = e2;
      }, function(n2, a) {
        var i = n2.exports = { version: "2.6.12" };
        typeof __e == "number" && (__e = i);
      }, function(n2, a, i) {
        var o = i(26)("wks"), s = i(17), u = i(3).Symbol, l2 = typeof u == "function";
        (n2.exports = function(c2) {
          return o[c2] || (o[c2] = l2 && u[c2] || (l2 ? u : s)("Symbol." + c2));
        }).store = o;
      }, function(n2, a) {
        var i = n2.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
        typeof __g == "number" && (__g = i);
      }, function(n2, a, i) {
        n2.exports = !i(8)(function() {
          return Object.defineProperty({}, "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(n2, a) {
        var i = {}.hasOwnProperty;
        n2.exports = function(o, s) {
          return i.call(o, s);
        };
      }, function(n2, a, i) {
        var o = i(7), s = i(16);
        n2.exports = i(4) ? function(u, l2, c2) {
          return o.f(u, l2, s(1, c2));
        } : function(u, l2, c2) {
          return u[l2] = c2, u;
        };
      }, function(n2, a, i) {
        var o = i(10), s = i(35), u = i(23), l2 = Object.defineProperty;
        a.f = i(4) ? Object.defineProperty : function(c2, f2, h) {
          if (o(c2), f2 = u(f2, true), o(h), s)
            try {
              return l2(c2, f2, h);
            } catch {
            }
          if ("get" in h || "set" in h)
            throw TypeError("Accessors not supported!");
          return "value" in h && (c2[f2] = h.value), c2;
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          try {
            return !!i();
          } catch {
            return true;
          }
        };
      }, function(n2, a, i) {
        var o = i(40), s = i(22);
        n2.exports = function(u) {
          return o(s(u));
        };
      }, function(n2, a, i) {
        var o = i(11);
        n2.exports = function(s) {
          if (!o(s))
            throw TypeError(s + " is not an object!");
          return s;
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          return typeof i == "object" ? i !== null : typeof i == "function";
        };
      }, function(n2, a) {
        n2.exports = {};
      }, function(n2, a, i) {
        var o = i(39), s = i(27);
        n2.exports = Object.keys || function(u) {
          return o(u, s);
        };
      }, function(n2, a) {
        n2.exports = true;
      }, function(n2, a, i) {
        var o = i(3), s = i(1), u = i(53), l2 = i(6), c2 = i(5), f2 = function(h, v9, d2) {
          var m2, b2, _, C = h & f2.F, M = h & f2.G, E = h & f2.S, z9 = h & f2.P, V = h & f2.B, $ = h & f2.W, U = M ? s : s[v9] || (s[v9] = {}), H = U.prototype, q3 = M ? o : E ? o[v9] : (o[v9] || {}).prototype;
          for (m2 in M && (d2 = v9), d2)
            (b2 = !C && q3 && q3[m2] !== void 0) && c2(U, m2) || (_ = b2 ? q3[m2] : d2[m2], U[m2] = M && typeof q3[m2] != "function" ? d2[m2] : V && b2 ? u(_, o) : $ && q3[m2] == _ ? function(ee) {
              var oe = function(ne, be, Ee) {
                if (this instanceof ee) {
                  switch (arguments.length) {
                    case 0:
                      return new ee();
                    case 1:
                      return new ee(ne);
                    case 2:
                      return new ee(ne, be);
                  }
                  return new ee(ne, be, Ee);
                }
                return ee.apply(this, arguments);
              };
              return oe.prototype = ee.prototype, oe;
            }(_) : z9 && typeof _ == "function" ? u(Function.call, _) : _, z9 && ((U.virtual || (U.virtual = {}))[m2] = _, h & f2.R && H && !H[m2] && l2(H, m2, _)));
        };
        f2.F = 1, f2.G = 2, f2.S = 4, f2.P = 8, f2.B = 16, f2.W = 32, f2.U = 64, f2.R = 128, n2.exports = f2;
      }, function(n2, a) {
        n2.exports = function(i, o) {
          return { enumerable: !(1 & i), configurable: !(2 & i), writable: !(4 & i), value: o };
        };
      }, function(n2, a) {
        var i = 0, o = Math.random();
        n2.exports = function(s) {
          return "Symbol(".concat(s === void 0 ? "" : s, ")_", (++i + o).toString(36));
        };
      }, function(n2, a, i) {
        var o = i(22);
        n2.exports = function(s) {
          return Object(o(s));
        };
      }, function(n2, a) {
        a.f = {}.propertyIsEnumerable;
      }, function(n2, a, i) {
        var o = i(52)(true);
        i(34)(String, "String", function(s) {
          this._t = String(s), this._i = 0;
        }, function() {
          var s, u = this._t, l2 = this._i;
          return l2 >= u.length ? { value: void 0, done: true } : (s = o(u, l2), this._i += s.length, { value: s, done: false });
        });
      }, function(n2, a) {
        var i = Math.ceil, o = Math.floor;
        n2.exports = function(s) {
          return isNaN(s = +s) ? 0 : (s > 0 ? o : i)(s);
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          if (i == null)
            throw TypeError("Can't call method on  " + i);
          return i;
        };
      }, function(n2, a, i) {
        var o = i(11);
        n2.exports = function(s, u) {
          if (!o(s))
            return s;
          var l2, c2;
          if (u && typeof (l2 = s.toString) == "function" && !o(c2 = l2.call(s)) || typeof (l2 = s.valueOf) == "function" && !o(c2 = l2.call(s)) || !u && typeof (l2 = s.toString) == "function" && !o(c2 = l2.call(s)))
            return c2;
          throw TypeError("Can't convert object to primitive value");
        };
      }, function(n2, a) {
        var i = {}.toString;
        n2.exports = function(o) {
          return i.call(o).slice(8, -1);
        };
      }, function(n2, a, i) {
        var o = i(26)("keys"), s = i(17);
        n2.exports = function(u) {
          return o[u] || (o[u] = s(u));
        };
      }, function(n2, a, i) {
        var o = i(1), s = i(3), u = s["__core-js_shared__"] || (s["__core-js_shared__"] = {});
        (n2.exports = function(l2, c2) {
          return u[l2] || (u[l2] = c2 !== void 0 ? c2 : {});
        })("versions", []).push({ version: o.version, mode: i(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
      }, function(n2, a) {
        n2.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
      }, function(n2, a, i) {
        var o = i(7).f, s = i(5), u = i(2)("toStringTag");
        n2.exports = function(l2, c2, f2) {
          l2 && !s(l2 = f2 ? l2 : l2.prototype, u) && o(l2, u, { configurable: true, value: c2 });
        };
      }, function(n2, a, i) {
        i(62);
        for (var o = i(3), s = i(6), u = i(12), l2 = i(2)("toStringTag"), c2 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), f2 = 0; f2 < c2.length; f2++) {
          var h = c2[f2], v9 = o[h], d2 = v9 && v9.prototype;
          d2 && !d2[l2] && s(d2, l2, h), u[h] = u.Array;
        }
      }, function(n2, a, i) {
        a.f = i(2);
      }, function(n2, a, i) {
        var o = i(3), s = i(1), u = i(14), l2 = i(30), c2 = i(7).f;
        n2.exports = function(f2) {
          var h = s.Symbol || (s.Symbol = u ? {} : o.Symbol || {});
          f2.charAt(0) == "_" || f2 in h || c2(h, f2, { value: l2.f(f2) });
        };
      }, function(n2, a) {
        a.f = Object.getOwnPropertySymbols;
      }, function(n2, a) {
        n2.exports = function(i, o, s) {
          return Math.min(Math.max(i, o), s);
        };
      }, function(n2, a, i) {
        var o = i(14), s = i(15), u = i(37), l2 = i(6), c2 = i(12), f2 = i(55), h = i(28), v9 = i(61), d2 = i(2)("iterator"), m2 = !([].keys && "next" in [].keys()), b2 = function() {
          return this;
        };
        n2.exports = function(_, C, M, E, z9, V, $) {
          f2(M, C, E);
          var U, H, q3, ee = function(qe) {
            if (!m2 && qe in Ee)
              return Ee[qe];
            switch (qe) {
              case "keys":
              case "values":
                return function() {
                  return new M(this, qe);
                };
            }
            return function() {
              return new M(this, qe);
            };
          }, oe = C + " Iterator", ne = z9 == "values", be = false, Ee = _.prototype, ye = Ee[d2] || Ee["@@iterator"] || z9 && Ee[z9], et = ye || ee(z9), Le = z9 ? ne ? ee("entries") : et : void 0, Fe = C == "Array" && Ee.entries || ye;
          if (Fe && (q3 = v9(Fe.call(new _()))) !== Object.prototype && q3.next && (h(q3, oe, true), o || typeof q3[d2] == "function" || l2(q3, d2, b2)), ne && ye && ye.name !== "values" && (be = true, et = function() {
            return ye.call(this);
          }), o && !$ || !m2 && !be && Ee[d2] || l2(Ee, d2, et), c2[C] = et, c2[oe] = b2, z9)
            if (U = { values: ne ? et : ee("values"), keys: V ? et : ee("keys"), entries: Le }, $)
              for (H in U)
                H in Ee || u(Ee, H, U[H]);
            else
              s(s.P + s.F * (m2 || be), C, U);
          return U;
        };
      }, function(n2, a, i) {
        n2.exports = !i(4) && !i(8)(function() {
          return Object.defineProperty(i(36)("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(n2, a, i) {
        var o = i(11), s = i(3).document, u = o(s) && o(s.createElement);
        n2.exports = function(l2) {
          return u ? s.createElement(l2) : {};
        };
      }, function(n2, a, i) {
        n2.exports = i(6);
      }, function(n2, a, i) {
        var o = i(10), s = i(56), u = i(27), l2 = i(25)("IE_PROTO"), c2 = function() {
        }, f2 = function() {
          var h, v9 = i(36)("iframe"), d2 = u.length;
          for (v9.style.display = "none", i(60).appendChild(v9), v9.src = "javascript:", (h = v9.contentWindow.document).open(), h.write("<script>document.F=Object<\/script>"), h.close(), f2 = h.F; d2--; )
            delete f2.prototype[u[d2]];
          return f2();
        };
        n2.exports = Object.create || function(h, v9) {
          var d2;
          return h !== null ? (c2.prototype = o(h), d2 = new c2(), c2.prototype = null, d2[l2] = h) : d2 = f2(), v9 === void 0 ? d2 : s(d2, v9);
        };
      }, function(n2, a, i) {
        var o = i(5), s = i(9), u = i(57)(false), l2 = i(25)("IE_PROTO");
        n2.exports = function(c2, f2) {
          var h, v9 = s(c2), d2 = 0, m2 = [];
          for (h in v9)
            h != l2 && o(v9, h) && m2.push(h);
          for (; f2.length > d2; )
            o(v9, h = f2[d2++]) && (~u(m2, h) || m2.push(h));
          return m2;
        };
      }, function(n2, a, i) {
        var o = i(24);
        n2.exports = Object("z").propertyIsEnumerable(0) ? Object : function(s) {
          return o(s) == "String" ? s.split("") : Object(s);
        };
      }, function(n2, a, i) {
        var o = i(39), s = i(27).concat("length", "prototype");
        a.f = Object.getOwnPropertyNames || function(u) {
          return o(u, s);
        };
      }, function(n2, a, i) {
        var o = i(24), s = i(2)("toStringTag"), u = o(function() {
          return arguments;
        }()) == "Arguments";
        n2.exports = function(l2) {
          var c2, f2, h;
          return l2 === void 0 ? "Undefined" : l2 === null ? "Null" : typeof (f2 = function(v9, d2) {
            try {
              return v9[d2];
            } catch {
            }
          }(c2 = Object(l2), s)) == "string" ? f2 : u ? o(c2) : (h = o(c2)) == "Object" && typeof c2.callee == "function" ? "Arguments" : h;
        };
      }, function(n2, a) {
        var i;
        i = function() {
          return this;
        }();
        try {
          i = i || new Function("return this")();
        } catch {
          typeof window == "object" && (i = window);
        }
        n2.exports = i;
      }, function(n2, a) {
        var i = /-?\d+(\.\d+)?%?/g;
        n2.exports = function(o) {
          return o.match(i);
        };
      }, function(n2, a, i) {
        Object.defineProperty(a, "__esModule", { value: true }), a.getBase16Theme = a.createStyling = a.invertTheme = void 0;
        var o = b2(i(49)), s = b2(i(76)), u = b2(i(81)), l2 = b2(i(89)), c2 = b2(i(93)), f2 = function(H) {
          if (H && H.__esModule)
            return H;
          var q3 = {};
          if (H != null)
            for (var ee in H)
              Object.prototype.hasOwnProperty.call(H, ee) && (q3[ee] = H[ee]);
          return q3.default = H, q3;
        }(i(94)), h = b2(i(132)), v9 = b2(i(133)), d2 = b2(i(138)), m2 = i(139);
        function b2(H) {
          return H && H.__esModule ? H : { default: H };
        }
        var _ = f2.default, C = (0, l2.default)(_), M = (0, d2.default)(v9.default, m2.rgb2yuv, function(H) {
          var q3, ee = (0, u.default)(H, 3), oe = ee[0], ne = ee[1], be = ee[2];
          return [(q3 = oe, q3 < 0.25 ? 1 : q3 < 0.5 ? 0.9 - q3 : 1.1 - q3), ne, be];
        }, m2.yuv2rgb, h.default), E = function(H) {
          return function(q3) {
            return { className: [q3.className, H.className].filter(Boolean).join(" "), style: (0, s.default)({}, q3.style || {}, H.style || {}) };
          };
        }, z9 = function(H, q3) {
          var ee = (0, l2.default)(q3);
          for (var oe in H)
            ee.indexOf(oe) === -1 && ee.push(oe);
          return ee.reduce(function(ne, be) {
            return ne[be] = function(Ee, ye) {
              if (Ee === void 0)
                return ye;
              if (ye === void 0)
                return Ee;
              var et = Ee === void 0 ? "undefined" : (0, o.default)(Ee), Le = ye === void 0 ? "undefined" : (0, o.default)(ye);
              switch (et) {
                case "string":
                  switch (Le) {
                    case "string":
                      return [ye, Ee].filter(Boolean).join(" ");
                    case "object":
                      return E({ className: Ee, style: ye });
                    case "function":
                      return function(Fe) {
                        for (var qe = arguments.length, st = Array(qe > 1 ? qe - 1 : 0), dt = 1; dt < qe; dt++)
                          st[dt - 1] = arguments[dt];
                        return E({ className: Ee })(ye.apply(void 0, [Fe].concat(st)));
                      };
                  }
                case "object":
                  switch (Le) {
                    case "string":
                      return E({ className: ye, style: Ee });
                    case "object":
                      return (0, s.default)({}, ye, Ee);
                    case "function":
                      return function(Fe) {
                        for (var qe = arguments.length, st = Array(qe > 1 ? qe - 1 : 0), dt = 1; dt < qe; dt++)
                          st[dt - 1] = arguments[dt];
                        return E({ style: Ee })(ye.apply(void 0, [Fe].concat(st)));
                      };
                  }
                case "function":
                  switch (Le) {
                    case "string":
                      return function(Fe) {
                        for (var qe = arguments.length, st = Array(qe > 1 ? qe - 1 : 0), dt = 1; dt < qe; dt++)
                          st[dt - 1] = arguments[dt];
                        return Ee.apply(void 0, [E(Fe)({ className: ye })].concat(st));
                      };
                    case "object":
                      return function(Fe) {
                        for (var qe = arguments.length, st = Array(qe > 1 ? qe - 1 : 0), dt = 1; dt < qe; dt++)
                          st[dt - 1] = arguments[dt];
                        return Ee.apply(void 0, [E(Fe)({ style: ye })].concat(st));
                      };
                    case "function":
                      return function(Fe) {
                        for (var qe = arguments.length, st = Array(qe > 1 ? qe - 1 : 0), dt = 1; dt < qe; dt++)
                          st[dt - 1] = arguments[dt];
                        return Ee.apply(void 0, [ye.apply(void 0, [Fe].concat(st))].concat(st));
                      };
                  }
              }
            }(H[be], q3[be]), ne;
          }, {});
        }, V = function(H, q3) {
          for (var ee = arguments.length, oe = Array(ee > 2 ? ee - 2 : 0), ne = 2; ne < ee; ne++)
            oe[ne - 2] = arguments[ne];
          if (q3 === null)
            return H;
          Array.isArray(q3) || (q3 = [q3]);
          var be = q3.map(function(ye) {
            return H[ye];
          }).filter(Boolean), Ee = be.reduce(function(ye, et) {
            return typeof et == "string" ? ye.className = [ye.className, et].filter(Boolean).join(" ") : (et === void 0 ? "undefined" : (0, o.default)(et)) === "object" ? ye.style = (0, s.default)({}, ye.style, et) : typeof et == "function" && (ye = (0, s.default)({}, ye, et.apply(void 0, [ye].concat(oe)))), ye;
          }, { className: "", style: {} });
          return Ee.className || delete Ee.className, (0, l2.default)(Ee.style).length === 0 && delete Ee.style, Ee;
        }, $ = a.invertTheme = function(H) {
          return (0, l2.default)(H).reduce(function(q3, ee) {
            return q3[ee] = /^base/.test(ee) ? M(H[ee]) : ee === "scheme" ? H[ee] + ":inverted" : H[ee], q3;
          }, {});
        }, U = (a.createStyling = (0, c2.default)(function(H) {
          for (var q3 = arguments.length, ee = Array(q3 > 3 ? q3 - 3 : 0), oe = 3; oe < q3; oe++)
            ee[oe - 3] = arguments[oe];
          var ne = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, be = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Ee = ne.defaultBase16, ye = Ee === void 0 ? _ : Ee, et = ne.base16Themes, Le = et === void 0 ? null : et, Fe = U(be, Le);
          Fe && (be = (0, s.default)({}, Fe, be));
          var qe = C.reduce(function(Hr, hn) {
            return Hr[hn] = be[hn] || ye[hn], Hr;
          }, {}), st = (0, l2.default)(be).reduce(function(Hr, hn) {
            return C.indexOf(hn) === -1 && (Hr[hn] = be[hn]), Hr;
          }, {}), dt = H(qe), Ar = z9(st, dt);
          return (0, c2.default)(V, 2).apply(void 0, [Ar].concat(ee));
        }, 3), a.getBase16Theme = function(H, q3) {
          if (H && H.extend && (H = H.extend), typeof H == "string") {
            var ee = H.split(":"), oe = (0, u.default)(ee, 2), ne = oe[0], be = oe[1];
            H = (q3 || {})[ne] || f2[ne], be === "inverted" && (H = $(H));
          }
          return H && H.hasOwnProperty("base00") ? H : void 0;
        });
      }, function(n2, a, i) {
        var o, s = typeof Reflect == "object" ? Reflect : null, u = s && typeof s.apply == "function" ? s.apply : function(E, z9, V) {
          return Function.prototype.apply.call(E, z9, V);
        };
        o = s && typeof s.ownKeys == "function" ? s.ownKeys : Object.getOwnPropertySymbols ? function(E) {
          return Object.getOwnPropertyNames(E).concat(Object.getOwnPropertySymbols(E));
        } : function(E) {
          return Object.getOwnPropertyNames(E);
        };
        var l2 = Number.isNaN || function(E) {
          return E != E;
        };
        function c2() {
          c2.init.call(this);
        }
        n2.exports = c2, n2.exports.once = function(E, z9) {
          return new Promise(function(V, $) {
            function U() {
              H !== void 0 && E.removeListener("error", H), V([].slice.call(arguments));
            }
            var H;
            z9 !== "error" && (H = function(q3) {
              E.removeListener(z9, U), $(q3);
            }, E.once("error", H)), E.once(z9, U);
          });
        }, c2.EventEmitter = c2, c2.prototype._events = void 0, c2.prototype._eventsCount = 0, c2.prototype._maxListeners = void 0;
        var f2 = 10;
        function h(E) {
          if (typeof E != "function")
            throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof E);
        }
        function v9(E) {
          return E._maxListeners === void 0 ? c2.defaultMaxListeners : E._maxListeners;
        }
        function d2(E, z9, V, $) {
          var U, H, q3, ee;
          if (h(V), (H = E._events) === void 0 ? (H = E._events = /* @__PURE__ */ Object.create(null), E._eventsCount = 0) : (H.newListener !== void 0 && (E.emit("newListener", z9, V.listener ? V.listener : V), H = E._events), q3 = H[z9]), q3 === void 0)
            q3 = H[z9] = V, ++E._eventsCount;
          else if (typeof q3 == "function" ? q3 = H[z9] = $ ? [V, q3] : [q3, V] : $ ? q3.unshift(V) : q3.push(V), (U = v9(E)) > 0 && q3.length > U && !q3.warned) {
            q3.warned = true;
            var oe = new Error("Possible EventEmitter memory leak detected. " + q3.length + " " + String(z9) + " listeners added. Use emitter.setMaxListeners() to increase limit");
            oe.name = "MaxListenersExceededWarning", oe.emitter = E, oe.type = z9, oe.count = q3.length, ee = oe, console && console.warn && console.warn(ee);
          }
          return E;
        }
        function m2() {
          if (!this.fired)
            return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
        }
        function b2(E, z9, V) {
          var $ = { fired: false, wrapFn: void 0, target: E, type: z9, listener: V }, U = m2.bind($);
          return U.listener = V, $.wrapFn = U, U;
        }
        function _(E, z9, V) {
          var $ = E._events;
          if ($ === void 0)
            return [];
          var U = $[z9];
          return U === void 0 ? [] : typeof U == "function" ? V ? [U.listener || U] : [U] : V ? function(H) {
            for (var q3 = new Array(H.length), ee = 0; ee < q3.length; ++ee)
              q3[ee] = H[ee].listener || H[ee];
            return q3;
          }(U) : M(U, U.length);
        }
        function C(E) {
          var z9 = this._events;
          if (z9 !== void 0) {
            var V = z9[E];
            if (typeof V == "function")
              return 1;
            if (V !== void 0)
              return V.length;
          }
          return 0;
        }
        function M(E, z9) {
          for (var V = new Array(z9), $ = 0; $ < z9; ++$)
            V[$] = E[$];
          return V;
        }
        Object.defineProperty(c2, "defaultMaxListeners", { enumerable: true, get: function() {
          return f2;
        }, set: function(E) {
          if (typeof E != "number" || E < 0 || l2(E))
            throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + E + ".");
          f2 = E;
        } }), c2.init = function() {
          this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
        }, c2.prototype.setMaxListeners = function(E) {
          if (typeof E != "number" || E < 0 || l2(E))
            throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + E + ".");
          return this._maxListeners = E, this;
        }, c2.prototype.getMaxListeners = function() {
          return v9(this);
        }, c2.prototype.emit = function(E) {
          for (var z9 = [], V = 1; V < arguments.length; V++)
            z9.push(arguments[V]);
          var $ = E === "error", U = this._events;
          if (U !== void 0)
            $ = $ && U.error === void 0;
          else if (!$)
            return false;
          if ($) {
            var H;
            if (z9.length > 0 && (H = z9[0]), H instanceof Error)
              throw H;
            var q3 = new Error("Unhandled error." + (H ? " (" + H.message + ")" : ""));
            throw q3.context = H, q3;
          }
          var ee = U[E];
          if (ee === void 0)
            return false;
          if (typeof ee == "function")
            u(ee, this, z9);
          else {
            var oe = ee.length, ne = M(ee, oe);
            for (V = 0; V < oe; ++V)
              u(ne[V], this, z9);
          }
          return true;
        }, c2.prototype.addListener = function(E, z9) {
          return d2(this, E, z9, false);
        }, c2.prototype.on = c2.prototype.addListener, c2.prototype.prependListener = function(E, z9) {
          return d2(this, E, z9, true);
        }, c2.prototype.once = function(E, z9) {
          return h(z9), this.on(E, b2(this, E, z9)), this;
        }, c2.prototype.prependOnceListener = function(E, z9) {
          return h(z9), this.prependListener(E, b2(this, E, z9)), this;
        }, c2.prototype.removeListener = function(E, z9) {
          var V, $, U, H, q3;
          if (h(z9), ($ = this._events) === void 0)
            return this;
          if ((V = $[E]) === void 0)
            return this;
          if (V === z9 || V.listener === z9)
            --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete $[E], $.removeListener && this.emit("removeListener", E, V.listener || z9));
          else if (typeof V != "function") {
            for (U = -1, H = V.length - 1; H >= 0; H--)
              if (V[H] === z9 || V[H].listener === z9) {
                q3 = V[H].listener, U = H;
                break;
              }
            if (U < 0)
              return this;
            U === 0 ? V.shift() : function(ee, oe) {
              for (; oe + 1 < ee.length; oe++)
                ee[oe] = ee[oe + 1];
              ee.pop();
            }(V, U), V.length === 1 && ($[E] = V[0]), $.removeListener !== void 0 && this.emit("removeListener", E, q3 || z9);
          }
          return this;
        }, c2.prototype.off = c2.prototype.removeListener, c2.prototype.removeAllListeners = function(E) {
          var z9, V, $;
          if ((V = this._events) === void 0)
            return this;
          if (V.removeListener === void 0)
            return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : V[E] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete V[E]), this;
          if (arguments.length === 0) {
            var U, H = Object.keys(V);
            for ($ = 0; $ < H.length; ++$)
              (U = H[$]) !== "removeListener" && this.removeAllListeners(U);
            return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
          }
          if (typeof (z9 = V[E]) == "function")
            this.removeListener(E, z9);
          else if (z9 !== void 0)
            for ($ = z9.length - 1; $ >= 0; $--)
              this.removeListener(E, z9[$]);
          return this;
        }, c2.prototype.listeners = function(E) {
          return _(this, E, true);
        }, c2.prototype.rawListeners = function(E) {
          return _(this, E, false);
        }, c2.listenerCount = function(E, z9) {
          return typeof E.listenerCount == "function" ? E.listenerCount(z9) : C.call(E, z9);
        }, c2.prototype.listenerCount = C, c2.prototype.eventNames = function() {
          return this._eventsCount > 0 ? o(this._events) : [];
        };
      }, function(n2, a, i) {
        n2.exports.Dispatcher = i(140);
      }, function(n2, a, i) {
        n2.exports = i(142);
      }, function(n2, a, i) {
        a.__esModule = true;
        var o = l2(i(50)), s = l2(i(65)), u = typeof s.default == "function" && typeof o.default == "symbol" ? function(c2) {
          return typeof c2;
        } : function(c2) {
          return c2 && typeof s.default == "function" && c2.constructor === s.default && c2 !== s.default.prototype ? "symbol" : typeof c2;
        };
        function l2(c2) {
          return c2 && c2.__esModule ? c2 : { default: c2 };
        }
        a.default = typeof s.default == "function" && u(o.default) === "symbol" ? function(c2) {
          return c2 === void 0 ? "undefined" : u(c2);
        } : function(c2) {
          return c2 && typeof s.default == "function" && c2.constructor === s.default && c2 !== s.default.prototype ? "symbol" : c2 === void 0 ? "undefined" : u(c2);
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(51), __esModule: true };
      }, function(n2, a, i) {
        i(20), i(29), n2.exports = i(30).f("iterator");
      }, function(n2, a, i) {
        var o = i(21), s = i(22);
        n2.exports = function(u) {
          return function(l2, c2) {
            var f2, h, v9 = String(s(l2)), d2 = o(c2), m2 = v9.length;
            return d2 < 0 || d2 >= m2 ? u ? "" : void 0 : (f2 = v9.charCodeAt(d2)) < 55296 || f2 > 56319 || d2 + 1 === m2 || (h = v9.charCodeAt(d2 + 1)) < 56320 || h > 57343 ? u ? v9.charAt(d2) : f2 : u ? v9.slice(d2, d2 + 2) : h - 56320 + (f2 - 55296 << 10) + 65536;
          };
        };
      }, function(n2, a, i) {
        var o = i(54);
        n2.exports = function(s, u, l2) {
          if (o(s), u === void 0)
            return s;
          switch (l2) {
            case 1:
              return function(c2) {
                return s.call(u, c2);
              };
            case 2:
              return function(c2, f2) {
                return s.call(u, c2, f2);
              };
            case 3:
              return function(c2, f2, h) {
                return s.call(u, c2, f2, h);
              };
          }
          return function() {
            return s.apply(u, arguments);
          };
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          if (typeof i != "function")
            throw TypeError(i + " is not a function!");
          return i;
        };
      }, function(n2, a, i) {
        var o = i(38), s = i(16), u = i(28), l2 = {};
        i(6)(l2, i(2)("iterator"), function() {
          return this;
        }), n2.exports = function(c2, f2, h) {
          c2.prototype = o(l2, { next: s(1, h) }), u(c2, f2 + " Iterator");
        };
      }, function(n2, a, i) {
        var o = i(7), s = i(10), u = i(13);
        n2.exports = i(4) ? Object.defineProperties : function(l2, c2) {
          s(l2);
          for (var f2, h = u(c2), v9 = h.length, d2 = 0; v9 > d2; )
            o.f(l2, f2 = h[d2++], c2[f2]);
          return l2;
        };
      }, function(n2, a, i) {
        var o = i(9), s = i(58), u = i(59);
        n2.exports = function(l2) {
          return function(c2, f2, h) {
            var v9, d2 = o(c2), m2 = s(d2.length), b2 = u(h, m2);
            if (l2 && f2 != f2) {
              for (; m2 > b2; )
                if ((v9 = d2[b2++]) != v9)
                  return true;
            } else
              for (; m2 > b2; b2++)
                if ((l2 || b2 in d2) && d2[b2] === f2)
                  return l2 || b2 || 0;
            return !l2 && -1;
          };
        };
      }, function(n2, a, i) {
        var o = i(21), s = Math.min;
        n2.exports = function(u) {
          return u > 0 ? s(o(u), 9007199254740991) : 0;
        };
      }, function(n2, a, i) {
        var o = i(21), s = Math.max, u = Math.min;
        n2.exports = function(l2, c2) {
          return (l2 = o(l2)) < 0 ? s(l2 + c2, 0) : u(l2, c2);
        };
      }, function(n2, a, i) {
        var o = i(3).document;
        n2.exports = o && o.documentElement;
      }, function(n2, a, i) {
        var o = i(5), s = i(18), u = i(25)("IE_PROTO"), l2 = Object.prototype;
        n2.exports = Object.getPrototypeOf || function(c2) {
          return c2 = s(c2), o(c2, u) ? c2[u] : typeof c2.constructor == "function" && c2 instanceof c2.constructor ? c2.constructor.prototype : c2 instanceof Object ? l2 : null;
        };
      }, function(n2, a, i) {
        var o = i(63), s = i(64), u = i(12), l2 = i(9);
        n2.exports = i(34)(Array, "Array", function(c2, f2) {
          this._t = l2(c2), this._i = 0, this._k = f2;
        }, function() {
          var c2 = this._t, f2 = this._k, h = this._i++;
          return !c2 || h >= c2.length ? (this._t = void 0, s(1)) : s(0, f2 == "keys" ? h : f2 == "values" ? c2[h] : [h, c2[h]]);
        }, "values"), u.Arguments = u.Array, o("keys"), o("values"), o("entries");
      }, function(n2, a) {
        n2.exports = function() {
        };
      }, function(n2, a) {
        n2.exports = function(i, o) {
          return { value: o, done: !!i };
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(66), __esModule: true };
      }, function(n2, a, i) {
        i(67), i(73), i(74), i(75), n2.exports = i(1).Symbol;
      }, function(n2, a, i) {
        var o = i(3), s = i(5), u = i(4), l2 = i(15), c2 = i(37), f2 = i(68).KEY, h = i(8), v9 = i(26), d2 = i(28), m2 = i(17), b2 = i(2), _ = i(30), C = i(31), M = i(69), E = i(70), z9 = i(10), V = i(11), $ = i(18), U = i(9), H = i(23), q3 = i(16), ee = i(38), oe = i(71), ne = i(72), be = i(32), Ee = i(7), ye = i(13), et = ne.f, Le = Ee.f, Fe = oe.f, qe = o.Symbol, st = o.JSON, dt = st && st.stringify, Ar = b2("_hidden"), Hr = b2("toPrimitive"), hn = {}.propertyIsEnumerable, cn = v9("symbol-registry"), nn = v9("symbols"), Wr = v9("op-symbols"), on = Object.prototype, un = typeof qe == "function" && !!be.f, Xr = o.QObject, _n = !Xr || !Xr.prototype || !Xr.prototype.findChild, Za = u && h(function() {
          return ee(Le({}, "a", { get: function() {
            return Le(this, "a", { value: 7 }).a;
          } })).a != 7;
        }) ? function(Ot, wr, an) {
          var Mn = et(on, wr);
          Mn && delete on[wr], Le(Ot, wr, an), Mn && Ot !== on && Le(on, wr, Mn);
        } : Le, Dn = function(Ot) {
          var wr = nn[Ot] = ee(qe.prototype);
          return wr._k = Ot, wr;
        }, ai = un && typeof qe.iterator == "symbol" ? function(Ot) {
          return typeof Ot == "symbol";
        } : function(Ot) {
          return Ot instanceof qe;
        }, wi = function(Ot, wr, an) {
          return Ot === on && wi(Wr, wr, an), z9(Ot), wr = H(wr, true), z9(an), s(nn, wr) ? (an.enumerable ? (s(Ot, Ar) && Ot[Ar][wr] && (Ot[Ar][wr] = false), an = ee(an, { enumerable: q3(0, false) })) : (s(Ot, Ar) || Le(Ot, Ar, q3(1, {})), Ot[Ar][wr] = true), Za(Ot, wr, an)) : Le(Ot, wr, an);
        }, hi = function(Ot, wr) {
          z9(Ot);
          for (var an, Mn = M(wr = U(wr)), Fa = 0, Ma = Mn.length; Ma > Fa; )
            wi(Ot, an = Mn[Fa++], wr[an]);
          return Ot;
        }, qs = function(Ot) {
          var wr = hn.call(this, Ot = H(Ot, true));
          return !(this === on && s(nn, Ot) && !s(Wr, Ot)) && (!(wr || !s(this, Ot) || !s(nn, Ot) || s(this, Ar) && this[Ar][Ot]) || wr);
        }, jo = function(Ot, wr) {
          if (Ot = U(Ot), wr = H(wr, true), Ot !== on || !s(nn, wr) || s(Wr, wr)) {
            var an = et(Ot, wr);
            return !an || !s(nn, wr) || s(Ot, Ar) && Ot[Ar][wr] || (an.enumerable = true), an;
          }
        }, Au = function(Ot) {
          for (var wr, an = Fe(U(Ot)), Mn = [], Fa = 0; an.length > Fa; )
            s(nn, wr = an[Fa++]) || wr == Ar || wr == f2 || Mn.push(wr);
          return Mn;
        }, Zi = function(Ot) {
          for (var wr, an = Ot === on, Mn = Fe(an ? Wr : U(Ot)), Fa = [], Ma = 0; Mn.length > Ma; )
            !s(nn, wr = Mn[Ma++]) || an && !s(on, wr) || Fa.push(nn[wr]);
          return Fa;
        };
        un || (c2((qe = function() {
          if (this instanceof qe)
            throw TypeError("Symbol is not a constructor!");
          var Ot = m2(arguments.length > 0 ? arguments[0] : void 0), wr = function(an) {
            this === on && wr.call(Wr, an), s(this, Ar) && s(this[Ar], Ot) && (this[Ar][Ot] = false), Za(this, Ot, q3(1, an));
          };
          return u && _n && Za(on, Ot, { configurable: true, set: wr }), Dn(Ot);
        }).prototype, "toString", function() {
          return this._k;
        }), ne.f = jo, Ee.f = wi, i(41).f = oe.f = Au, i(19).f = qs, be.f = Zi, u && !i(14) && c2(on, "propertyIsEnumerable", qs, true), _.f = function(Ot) {
          return Dn(b2(Ot));
        }), l2(l2.G + l2.W + l2.F * !un, { Symbol: qe });
        for (var ys = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Do = 0; ys.length > Do; )
          b2(ys[Do++]);
        for (var mf = ye(b2.store), xr = 0; mf.length > xr; )
          C(mf[xr++]);
        l2(l2.S + l2.F * !un, "Symbol", { for: function(Ot) {
          return s(cn, Ot += "") ? cn[Ot] : cn[Ot] = qe(Ot);
        }, keyFor: function(Ot) {
          if (!ai(Ot))
            throw TypeError(Ot + " is not a symbol!");
          for (var wr in cn)
            if (cn[wr] === Ot)
              return wr;
        }, useSetter: function() {
          _n = true;
        }, useSimple: function() {
          _n = false;
        } }), l2(l2.S + l2.F * !un, "Object", { create: function(Ot, wr) {
          return wr === void 0 ? ee(Ot) : hi(ee(Ot), wr);
        }, defineProperty: wi, defineProperties: hi, getOwnPropertyDescriptor: jo, getOwnPropertyNames: Au, getOwnPropertySymbols: Zi });
        var jt = h(function() {
          be.f(1);
        });
        l2(l2.S + l2.F * jt, "Object", { getOwnPropertySymbols: function(Ot) {
          return be.f($(Ot));
        } }), st && l2(l2.S + l2.F * (!un || h(function() {
          var Ot = qe();
          return dt([Ot]) != "[null]" || dt({ a: Ot }) != "{}" || dt(Object(Ot)) != "{}";
        })), "JSON", { stringify: function(Ot) {
          for (var wr, an, Mn = [Ot], Fa = 1; arguments.length > Fa; )
            Mn.push(arguments[Fa++]);
          if (an = wr = Mn[1], (V(wr) || Ot !== void 0) && !ai(Ot))
            return E(wr) || (wr = function(Ma, ji) {
              if (typeof an == "function" && (ji = an.call(this, Ma, ji)), !ai(ji))
                return ji;
            }), Mn[1] = wr, dt.apply(st, Mn);
        } }), qe.prototype[Hr] || i(6)(qe.prototype, Hr, qe.prototype.valueOf), d2(qe, "Symbol"), d2(Math, "Math", true), d2(o.JSON, "JSON", true);
      }, function(n2, a, i) {
        var o = i(17)("meta"), s = i(11), u = i(5), l2 = i(7).f, c2 = 0, f2 = Object.isExtensible || function() {
          return true;
        }, h = !i(8)(function() {
          return f2(Object.preventExtensions({}));
        }), v9 = function(m2) {
          l2(m2, o, { value: { i: "O" + ++c2, w: {} } });
        }, d2 = n2.exports = { KEY: o, NEED: false, fastKey: function(m2, b2) {
          if (!s(m2))
            return typeof m2 == "symbol" ? m2 : (typeof m2 == "string" ? "S" : "P") + m2;
          if (!u(m2, o)) {
            if (!f2(m2))
              return "F";
            if (!b2)
              return "E";
            v9(m2);
          }
          return m2[o].i;
        }, getWeak: function(m2, b2) {
          if (!u(m2, o)) {
            if (!f2(m2))
              return true;
            if (!b2)
              return false;
            v9(m2);
          }
          return m2[o].w;
        }, onFreeze: function(m2) {
          return h && d2.NEED && f2(m2) && !u(m2, o) && v9(m2), m2;
        } };
      }, function(n2, a, i) {
        var o = i(13), s = i(32), u = i(19);
        n2.exports = function(l2) {
          var c2 = o(l2), f2 = s.f;
          if (f2)
            for (var h, v9 = f2(l2), d2 = u.f, m2 = 0; v9.length > m2; )
              d2.call(l2, h = v9[m2++]) && c2.push(h);
          return c2;
        };
      }, function(n2, a, i) {
        var o = i(24);
        n2.exports = Array.isArray || function(s) {
          return o(s) == "Array";
        };
      }, function(n2, a, i) {
        var o = i(9), s = i(41).f, u = {}.toString, l2 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
        n2.exports.f = function(c2) {
          return l2 && u.call(c2) == "[object Window]" ? function(f2) {
            try {
              return s(f2);
            } catch {
              return l2.slice();
            }
          }(c2) : s(o(c2));
        };
      }, function(n2, a, i) {
        var o = i(19), s = i(16), u = i(9), l2 = i(23), c2 = i(5), f2 = i(35), h = Object.getOwnPropertyDescriptor;
        a.f = i(4) ? h : function(v9, d2) {
          if (v9 = u(v9), d2 = l2(d2, true), f2)
            try {
              return h(v9, d2);
            } catch {
            }
          if (c2(v9, d2))
            return s(!o.f.call(v9, d2), v9[d2]);
        };
      }, function(n2, a) {
      }, function(n2, a, i) {
        i(31)("asyncIterator");
      }, function(n2, a, i) {
        i(31)("observable");
      }, function(n2, a, i) {
        a.__esModule = true;
        var o, s = i(77), u = (o = s) && o.__esModule ? o : { default: o };
        a.default = u.default || function(l2) {
          for (var c2 = 1; c2 < arguments.length; c2++) {
            var f2 = arguments[c2];
            for (var h in f2)
              Object.prototype.hasOwnProperty.call(f2, h) && (l2[h] = f2[h]);
          }
          return l2;
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(78), __esModule: true };
      }, function(n2, a, i) {
        i(79), n2.exports = i(1).Object.assign;
      }, function(n2, a, i) {
        var o = i(15);
        o(o.S + o.F, "Object", { assign: i(80) });
      }, function(n2, a, i) {
        var o = i(4), s = i(13), u = i(32), l2 = i(19), c2 = i(18), f2 = i(40), h = Object.assign;
        n2.exports = !h || i(8)(function() {
          var v9 = {}, d2 = {}, m2 = Symbol(), b2 = "abcdefghijklmnopqrst";
          return v9[m2] = 7, b2.split("").forEach(function(_) {
            d2[_] = _;
          }), h({}, v9)[m2] != 7 || Object.keys(h({}, d2)).join("") != b2;
        }) ? function(v9, d2) {
          for (var m2 = c2(v9), b2 = arguments.length, _ = 1, C = u.f, M = l2.f; b2 > _; )
            for (var E, z9 = f2(arguments[_++]), V = C ? s(z9).concat(C(z9)) : s(z9), $ = V.length, U = 0; $ > U; )
              E = V[U++], o && !M.call(z9, E) || (m2[E] = z9[E]);
          return m2;
        } : h;
      }, function(n2, a, i) {
        a.__esModule = true;
        var o = u(i(82)), s = u(i(85));
        function u(l2) {
          return l2 && l2.__esModule ? l2 : { default: l2 };
        }
        a.default = function(l2, c2) {
          if (Array.isArray(l2))
            return l2;
          if ((0, o.default)(Object(l2)))
            return function(f2, h) {
              var v9 = [], d2 = true, m2 = false, b2 = void 0;
              try {
                for (var _, C = (0, s.default)(f2); !(d2 = (_ = C.next()).done) && (v9.push(_.value), !h || v9.length !== h); d2 = true)
                  ;
              } catch (M) {
                m2 = true, b2 = M;
              } finally {
                try {
                  !d2 && C.return && C.return();
                } finally {
                  if (m2)
                    throw b2;
                }
              }
              return v9;
            }(l2, c2);
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(83), __esModule: true };
      }, function(n2, a, i) {
        i(29), i(20), n2.exports = i(84);
      }, function(n2, a, i) {
        var o = i(42), s = i(2)("iterator"), u = i(12);
        n2.exports = i(1).isIterable = function(l2) {
          var c2 = Object(l2);
          return c2[s] !== void 0 || "@@iterator" in c2 || u.hasOwnProperty(o(c2));
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(86), __esModule: true };
      }, function(n2, a, i) {
        i(29), i(20), n2.exports = i(87);
      }, function(n2, a, i) {
        var o = i(10), s = i(88);
        n2.exports = i(1).getIterator = function(u) {
          var l2 = s(u);
          if (typeof l2 != "function")
            throw TypeError(u + " is not iterable!");
          return o(l2.call(u));
        };
      }, function(n2, a, i) {
        var o = i(42), s = i(2)("iterator"), u = i(12);
        n2.exports = i(1).getIteratorMethod = function(l2) {
          if (l2 != null)
            return l2[s] || l2["@@iterator"] || u[o(l2)];
        };
      }, function(n2, a, i) {
        n2.exports = { default: i(90), __esModule: true };
      }, function(n2, a, i) {
        i(91), n2.exports = i(1).Object.keys;
      }, function(n2, a, i) {
        var o = i(18), s = i(13);
        i(92)("keys", function() {
          return function(u) {
            return s(o(u));
          };
        });
      }, function(n2, a, i) {
        var o = i(15), s = i(1), u = i(8);
        n2.exports = function(l2, c2) {
          var f2 = (s.Object || {})[l2] || Object[l2], h = {};
          h[l2] = c2(f2), o(o.S + o.F * u(function() {
            f2(1);
          }), "Object", h);
        };
      }, function(n2, a, i) {
        (function(o) {
          var s = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], u = /^\s+|\s+$/g, l2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, c2 = /\{\n\/\* \[wrapped with (.+)\] \*/, f2 = /,? & /, h = /^[-+]0x[0-9a-f]+$/i, v9 = /^0b[01]+$/i, d2 = /^\[object .+?Constructor\]$/, m2 = /^0o[0-7]+$/i, b2 = /^(?:0|[1-9]\d*)$/, _ = parseInt, C = typeof o == "object" && o && o.Object === Object && o, M = typeof self == "object" && self && self.Object === Object && self, E = C || M || Function("return this")();
          function z9(xr, jt, Ot) {
            switch (Ot.length) {
              case 0:
                return xr.call(jt);
              case 1:
                return xr.call(jt, Ot[0]);
              case 2:
                return xr.call(jt, Ot[0], Ot[1]);
              case 3:
                return xr.call(jt, Ot[0], Ot[1], Ot[2]);
            }
            return xr.apply(jt, Ot);
          }
          function V(xr, jt) {
            return !!(xr && xr.length) && function(Ot, wr, an) {
              if (wr != wr)
                return function(Ma, ji, Bo, yo) {
                  for (var ms = Ma.length, mo = Bo + (yo ? 1 : -1); yo ? mo-- : ++mo < ms; )
                    if (ji(Ma[mo], mo, Ma))
                      return mo;
                  return -1;
                }(Ot, $, an);
              for (var Mn = an - 1, Fa = Ot.length; ++Mn < Fa; )
                if (Ot[Mn] === wr)
                  return Mn;
              return -1;
            }(xr, jt, 0) > -1;
          }
          function $(xr) {
            return xr != xr;
          }
          function U(xr, jt) {
            for (var Ot = xr.length, wr = 0; Ot--; )
              xr[Ot] === jt && wr++;
            return wr;
          }
          function H(xr, jt) {
            for (var Ot = -1, wr = xr.length, an = 0, Mn = []; ++Ot < wr; ) {
              var Fa = xr[Ot];
              Fa !== jt && Fa !== "__lodash_placeholder__" || (xr[Ot] = "__lodash_placeholder__", Mn[an++] = Ot);
            }
            return Mn;
          }
          var q3, ee, oe, ne = Function.prototype, be = Object.prototype, Ee = E["__core-js_shared__"], ye = (q3 = /[^.]+$/.exec(Ee && Ee.keys && Ee.keys.IE_PROTO || "")) ? "Symbol(src)_1." + q3 : "", et = ne.toString, Le = be.hasOwnProperty, Fe = be.toString, qe = RegExp("^" + et.call(Le).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), st = Object.create, dt = Math.max, Ar = Math.min, Hr = (ee = Dn(Object, "defineProperty"), (oe = Dn.name) && oe.length > 2 ? ee : void 0);
          function hn(xr) {
            return ys(xr) ? st(xr) : {};
          }
          function cn(xr) {
            return !(!ys(xr) || function(jt) {
              return !!ye && ye in jt;
            }(xr)) && (function(jt) {
              var Ot = ys(jt) ? Fe.call(jt) : "";
              return Ot == "[object Function]" || Ot == "[object GeneratorFunction]";
            }(xr) || function(jt) {
              var Ot = false;
              if (jt != null && typeof jt.toString != "function")
                try {
                  Ot = !!(jt + "");
                } catch {
                }
              return Ot;
            }(xr) ? qe : d2).test(function(jt) {
              if (jt != null) {
                try {
                  return et.call(jt);
                } catch {
                }
                try {
                  return jt + "";
                } catch {
                }
              }
              return "";
            }(xr));
          }
          function nn(xr, jt, Ot, wr) {
            for (var an = -1, Mn = xr.length, Fa = Ot.length, Ma = -1, ji = jt.length, Bo = dt(Mn - Fa, 0), yo = Array(ji + Bo), ms = !wr; ++Ma < ji; )
              yo[Ma] = jt[Ma];
            for (; ++an < Fa; )
              (ms || an < Mn) && (yo[Ot[an]] = xr[an]);
            for (; Bo--; )
              yo[Ma++] = xr[an++];
            return yo;
          }
          function Wr(xr, jt, Ot, wr) {
            for (var an = -1, Mn = xr.length, Fa = -1, Ma = Ot.length, ji = -1, Bo = jt.length, yo = dt(Mn - Ma, 0), ms = Array(yo + Bo), mo = !wr; ++an < yo; )
              ms[an] = xr[an];
            for (var Yu = an; ++ji < Bo; )
              ms[Yu + ji] = jt[ji];
            for (; ++Fa < Ma; )
              (mo || an < Mn) && (ms[Yu + Ot[Fa]] = xr[an++]);
            return ms;
          }
          function on(xr) {
            return function() {
              var jt = arguments;
              switch (jt.length) {
                case 0:
                  return new xr();
                case 1:
                  return new xr(jt[0]);
                case 2:
                  return new xr(jt[0], jt[1]);
                case 3:
                  return new xr(jt[0], jt[1], jt[2]);
                case 4:
                  return new xr(jt[0], jt[1], jt[2], jt[3]);
                case 5:
                  return new xr(jt[0], jt[1], jt[2], jt[3], jt[4]);
                case 6:
                  return new xr(jt[0], jt[1], jt[2], jt[3], jt[4], jt[5]);
                case 7:
                  return new xr(jt[0], jt[1], jt[2], jt[3], jt[4], jt[5], jt[6]);
              }
              var Ot = hn(xr.prototype), wr = xr.apply(Ot, jt);
              return ys(wr) ? wr : Ot;
            };
          }
          function un(xr, jt, Ot, wr, an, Mn, Fa, Ma, ji, Bo) {
            var yo = 128 & jt, ms = 1 & jt, mo = 2 & jt, Yu = 24 & jt, wl = 512 & jt, hc = mo ? void 0 : on(xr);
            return function Sl() {
              for (var as = arguments.length, vi = Array(as), Ys = as; Ys--; )
                vi[Ys] = arguments[Ys];
              if (Yu)
                var Tu = Za(Sl), Vc = U(vi, Tu);
              if (wr && (vi = nn(vi, wr, an, Yu)), Mn && (vi = Wr(vi, Mn, Fa, Yu)), as -= Vc, Yu && as < Bo) {
                var zl = H(vi, Tu);
                return Xr(xr, jt, un, Sl.placeholder, Ot, vi, zl, Ma, ji, Bo - as);
              }
              var Cl = ms ? Ot : this, vc = mo ? Cl[xr] : xr;
              return as = vi.length, Ma ? vi = qs(vi, Ma) : wl && as > 1 && vi.reverse(), yo && ji < as && (vi.length = ji), this && this !== E && this instanceof Sl && (vc = hc || on(vc)), vc.apply(Cl, vi);
            };
          }
          function Xr(xr, jt, Ot, wr, an, Mn, Fa, Ma, ji, Bo) {
            var yo = 8 & jt;
            jt |= yo ? 32 : 64, 4 & (jt &= ~(yo ? 64 : 32)) || (jt &= -4);
            var ms = Ot(xr, jt, an, yo ? Mn : void 0, yo ? Fa : void 0, yo ? void 0 : Mn, yo ? void 0 : Fa, Ma, ji, Bo);
            return ms.placeholder = wr, jo(ms, xr, jt);
          }
          function _n(xr, jt, Ot, wr, an, Mn, Fa, Ma) {
            var ji = 2 & jt;
            if (!ji && typeof xr != "function")
              throw new TypeError("Expected a function");
            var Bo = wr ? wr.length : 0;
            if (Bo || (jt &= -97, wr = an = void 0), Fa = Fa === void 0 ? Fa : dt(mf(Fa), 0), Ma = Ma === void 0 ? Ma : mf(Ma), Bo -= an ? an.length : 0, 64 & jt) {
              var yo = wr, ms = an;
              wr = an = void 0;
            }
            var mo = [xr, jt, Ot, wr, an, yo, ms, Mn, Fa, Ma];
            if (xr = mo[0], jt = mo[1], Ot = mo[2], wr = mo[3], an = mo[4], !(Ma = mo[9] = mo[9] == null ? ji ? 0 : xr.length : dt(mo[9] - Bo, 0)) && 24 & jt && (jt &= -25), jt && jt != 1)
              Yu = jt == 8 || jt == 16 ? function(wl, hc, Sl) {
                var as = on(wl);
                return function vi() {
                  for (var Ys = arguments.length, Tu = Array(Ys), Vc = Ys, zl = Za(vi); Vc--; )
                    Tu[Vc] = arguments[Vc];
                  var Cl = Ys < 3 && Tu[0] !== zl && Tu[Ys - 1] !== zl ? [] : H(Tu, zl);
                  if ((Ys -= Cl.length) < Sl)
                    return Xr(wl, hc, un, vi.placeholder, void 0, Tu, Cl, void 0, void 0, Sl - Ys);
                  var vc = this && this !== E && this instanceof vi ? as : wl;
                  return z9(vc, this, Tu);
                };
              }(xr, jt, Ma) : jt != 32 && jt != 33 || an.length ? un.apply(void 0, mo) : function(wl, hc, Sl, as) {
                var vi = 1 & hc, Ys = on(wl);
                return function Tu() {
                  for (var Vc = -1, zl = arguments.length, Cl = -1, vc = as.length, th = Array(vc + zl), rh = this && this !== E && this instanceof Tu ? Ys : wl; ++Cl < vc; )
                    th[Cl] = as[Cl];
                  for (; zl--; )
                    th[Cl++] = arguments[++Vc];
                  return z9(rh, vi ? Sl : this, th);
                };
              }(xr, jt, Ot, wr);
            else
              var Yu = function(wl, hc, Sl) {
                var as = 1 & hc, vi = on(wl);
                return function Ys() {
                  var Tu = this && this !== E && this instanceof Ys ? vi : wl;
                  return Tu.apply(as ? Sl : this, arguments);
                };
              }(xr, jt, Ot);
            return jo(Yu, xr, jt);
          }
          function Za(xr) {
            return xr.placeholder;
          }
          function Dn(xr, jt) {
            var Ot = function(wr, an) {
              return wr == null ? void 0 : wr[an];
            }(xr, jt);
            return cn(Ot) ? Ot : void 0;
          }
          function ai(xr) {
            var jt = xr.match(c2);
            return jt ? jt[1].split(f2) : [];
          }
          function wi(xr, jt) {
            var Ot = jt.length, wr = Ot - 1;
            return jt[wr] = (Ot > 1 ? "& " : "") + jt[wr], jt = jt.join(Ot > 2 ? ", " : " "), xr.replace(l2, `{
/* [wrapped with ` + jt + `] */
`);
          }
          function hi(xr, jt) {
            return !!(jt = jt == null ? 9007199254740991 : jt) && (typeof xr == "number" || b2.test(xr)) && xr > -1 && xr % 1 == 0 && xr < jt;
          }
          function qs(xr, jt) {
            for (var Ot = xr.length, wr = Ar(jt.length, Ot), an = function(Fa, Ma) {
              var ji = -1, Bo = Fa.length;
              for (Ma || (Ma = Array(Bo)); ++ji < Bo; )
                Ma[ji] = Fa[ji];
              return Ma;
            }(xr); wr--; ) {
              var Mn = jt[wr];
              xr[wr] = hi(Mn, Ot) ? an[Mn] : void 0;
            }
            return xr;
          }
          var jo = Hr ? function(xr, jt, Ot) {
            var wr, an = jt + "";
            return Hr(xr, "toString", { configurable: true, enumerable: false, value: (wr = wi(an, Au(ai(an), Ot)), function() {
              return wr;
            }) });
          } : function(xr) {
            return xr;
          };
          function Au(xr, jt) {
            return function(Ot, wr) {
              for (var an = -1, Mn = Ot ? Ot.length : 0; ++an < Mn && wr(Ot[an], an, Ot) !== false; )
                ;
            }(s, function(Ot) {
              var wr = "_." + Ot[0];
              jt & Ot[1] && !V(xr, wr) && xr.push(wr);
            }), xr.sort();
          }
          function Zi(xr, jt, Ot) {
            var wr = _n(xr, 8, void 0, void 0, void 0, void 0, void 0, jt = Ot ? void 0 : jt);
            return wr.placeholder = Zi.placeholder, wr;
          }
          function ys(xr) {
            var jt = typeof xr;
            return !!xr && (jt == "object" || jt == "function");
          }
          function Do(xr) {
            return xr ? (xr = function(jt) {
              if (typeof jt == "number")
                return jt;
              if (function(an) {
                return typeof an == "symbol" || function(Mn) {
                  return !!Mn && typeof Mn == "object";
                }(an) && Fe.call(an) == "[object Symbol]";
              }(jt))
                return NaN;
              if (ys(jt)) {
                var Ot = typeof jt.valueOf == "function" ? jt.valueOf() : jt;
                jt = ys(Ot) ? Ot + "" : Ot;
              }
              if (typeof jt != "string")
                return jt === 0 ? jt : +jt;
              jt = jt.replace(u, "");
              var wr = v9.test(jt);
              return wr || m2.test(jt) ? _(jt.slice(2), wr ? 2 : 8) : h.test(jt) ? NaN : +jt;
            }(xr)) === 1 / 0 || xr === -1 / 0 ? 17976931348623157e292 * (xr < 0 ? -1 : 1) : xr == xr ? xr : 0 : xr === 0 ? xr : 0;
          }
          function mf(xr) {
            var jt = Do(xr), Ot = jt % 1;
            return jt == jt ? Ot ? jt - Ot : jt : 0;
          }
          Zi.placeholder = {}, n2.exports = Zi;
        }).call(this, i(43));
      }, function(n2, a, i) {
        function o(Wr) {
          return Wr && Wr.__esModule ? Wr.default : Wr;
        }
        a.__esModule = true;
        var s = i(95);
        a.threezerotwofour = o(s);
        var u = i(96);
        a.apathy = o(u);
        var l2 = i(97);
        a.ashes = o(l2);
        var c2 = i(98);
        a.atelierDune = o(c2);
        var f2 = i(99);
        a.atelierForest = o(f2);
        var h = i(100);
        a.atelierHeath = o(h);
        var v9 = i(101);
        a.atelierLakeside = o(v9);
        var d2 = i(102);
        a.atelierSeaside = o(d2);
        var m2 = i(103);
        a.bespin = o(m2);
        var b2 = i(104);
        a.brewer = o(b2);
        var _ = i(105);
        a.bright = o(_);
        var C = i(106);
        a.chalk = o(C);
        var M = i(107);
        a.codeschool = o(M);
        var E = i(108);
        a.colors = o(E);
        var z9 = i(109);
        a.default = o(z9);
        var V = i(110);
        a.eighties = o(V);
        var $ = i(111);
        a.embers = o($);
        var U = i(112);
        a.flat = o(U);
        var H = i(113);
        a.google = o(H);
        var q3 = i(114);
        a.grayscale = o(q3);
        var ee = i(115);
        a.greenscreen = o(ee);
        var oe = i(116);
        a.harmonic = o(oe);
        var ne = i(117);
        a.hopscotch = o(ne);
        var be = i(118);
        a.isotope = o(be);
        var Ee = i(119);
        a.marrakesh = o(Ee);
        var ye = i(120);
        a.mocha = o(ye);
        var et = i(121);
        a.monokai = o(et);
        var Le = i(122);
        a.ocean = o(Le);
        var Fe = i(123);
        a.paraiso = o(Fe);
        var qe = i(124);
        a.pop = o(qe);
        var st = i(125);
        a.railscasts = o(st);
        var dt = i(126);
        a.shapeshifter = o(dt);
        var Ar = i(127);
        a.solarized = o(Ar);
        var Hr = i(128);
        a.summerfruit = o(Hr);
        var hn = i(129);
        a.tomorrow = o(hn);
        var cn = i(130);
        a.tube = o(cn);
        var nn = i(131);
        a.twilight = o(nn);
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, n2.exports = a.default;
      }, function(n2, a, i) {
        a.__esModule = true, a.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, n2.exports = a.default;
      }, function(n2, a, i) {
        var o = i(33);
        function s(u) {
          var l2 = Math.round(o(u, 0, 255)).toString(16);
          return l2.length == 1 ? "0" + l2 : l2;
        }
        n2.exports = function(u) {
          var l2 = u.length === 4 ? s(255 * u[3]) : "";
          return "#" + s(u[0]) + s(u[1]) + s(u[2]) + l2;
        };
      }, function(n2, a, i) {
        var o = i(134), s = i(135), u = i(136), l2 = i(137), c2 = { "#": s, hsl: function(h) {
          var v9 = o(h), d2 = l2(v9);
          return v9.length === 4 && d2.push(v9[3]), d2;
        }, rgb: u };
        function f2(h) {
          for (var v9 in c2)
            if (h.indexOf(v9) === 0)
              return c2[v9](h);
        }
        f2.rgb = u, f2.hsl = o, f2.hex = s, n2.exports = f2;
      }, function(n2, a, i) {
        var o = i(44), s = i(33);
        function u(l2, c2) {
          switch (l2 = parseFloat(l2), c2) {
            case 0:
              return s(l2, 0, 360);
            case 1:
            case 2:
              return s(l2, 0, 100);
            case 3:
              return s(l2, 0, 1);
          }
        }
        n2.exports = function(l2) {
          return o(l2).map(u);
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          i.length !== 4 && i.length !== 5 || (i = function(u) {
            for (var l2 = "#", c2 = 1; c2 < u.length; c2++) {
              var f2 = u.charAt(c2);
              l2 += f2 + f2;
            }
            return l2;
          }(i));
          var o = [parseInt(i.substring(1, 3), 16), parseInt(i.substring(3, 5), 16), parseInt(i.substring(5, 7), 16)];
          if (i.length === 9) {
            var s = parseFloat((parseInt(i.substring(7, 9), 16) / 255).toFixed(2));
            o.push(s);
          }
          return o;
        };
      }, function(n2, a, i) {
        var o = i(44), s = i(33);
        function u(l2, c2) {
          return c2 < 3 ? l2.indexOf("%") != -1 ? Math.round(255 * s(parseInt(l2, 10), 0, 100) / 100) : s(parseInt(l2, 10), 0, 255) : s(parseFloat(l2), 0, 1);
        }
        n2.exports = function(l2) {
          return o(l2).map(u);
        };
      }, function(n2, a) {
        n2.exports = function(i) {
          var o, s, u, l2, c2, f2 = i[0] / 360, h = i[1] / 100, v9 = i[2] / 100;
          if (h == 0)
            return [c2 = 255 * v9, c2, c2];
          o = 2 * v9 - (s = v9 < 0.5 ? v9 * (1 + h) : v9 + h - v9 * h), l2 = [0, 0, 0];
          for (var d2 = 0; d2 < 3; d2++)
            (u = f2 + 1 / 3 * -(d2 - 1)) < 0 && u++, u > 1 && u--, c2 = 6 * u < 1 ? o + 6 * (s - o) * u : 2 * u < 1 ? s : 3 * u < 2 ? o + (s - o) * (2 / 3 - u) * 6 : o, l2[d2] = 255 * c2;
          return l2;
        };
      }, function(n2, a, i) {
        (function(o) {
          var s = typeof o == "object" && o && o.Object === Object && o, u = typeof self == "object" && self && self.Object === Object && self, l2 = s || u || Function("return this")();
          function c2(H, q3, ee) {
            switch (ee.length) {
              case 0:
                return H.call(q3);
              case 1:
                return H.call(q3, ee[0]);
              case 2:
                return H.call(q3, ee[0], ee[1]);
              case 3:
                return H.call(q3, ee[0], ee[1], ee[2]);
            }
            return H.apply(q3, ee);
          }
          function f2(H, q3) {
            for (var ee = -1, oe = q3.length, ne = H.length; ++ee < oe; )
              H[ne + ee] = q3[ee];
            return H;
          }
          var h = Object.prototype, v9 = h.hasOwnProperty, d2 = h.toString, m2 = l2.Symbol, b2 = h.propertyIsEnumerable, _ = m2 ? m2.isConcatSpreadable : void 0, C = Math.max;
          function M(H) {
            return E(H) || function(q3) {
              return function(ee) {
                return function(oe) {
                  return !!oe && typeof oe == "object";
                }(ee) && function(oe) {
                  return oe != null && function(ne) {
                    return typeof ne == "number" && ne > -1 && ne % 1 == 0 && ne <= 9007199254740991;
                  }(oe.length) && !function(ne) {
                    var be = function(Ee) {
                      var ye = typeof Ee;
                      return !!Ee && (ye == "object" || ye == "function");
                    }(ne) ? d2.call(ne) : "";
                    return be == "[object Function]" || be == "[object GeneratorFunction]";
                  }(oe);
                }(ee);
              }(q3) && v9.call(q3, "callee") && (!b2.call(q3, "callee") || d2.call(q3) == "[object Arguments]");
            }(H) || !!(_ && H && H[_]);
          }
          var E = Array.isArray, z9, V, $, U = (V = function(H) {
            var q3 = (H = function oe(ne, be, Ee, ye, et) {
              var Le = -1, Fe = ne.length;
              for (Ee || (Ee = M), et || (et = []); ++Le < Fe; ) {
                var qe = ne[Le];
                be > 0 && Ee(qe) ? be > 1 ? oe(qe, be - 1, Ee, ye, et) : f2(et, qe) : ye || (et[et.length] = qe);
              }
              return et;
            }(H, 1)).length, ee = q3;
            for (z9; ee--; )
              if (typeof H[ee] != "function")
                throw new TypeError("Expected a function");
            return function() {
              for (var oe = 0, ne = q3 ? H[oe].apply(this, arguments) : arguments[0]; ++oe < q3; )
                ne = H[oe].call(this, ne);
              return ne;
            };
          }, $ = C($ === void 0 ? V.length - 1 : $, 0), function() {
            for (var H = arguments, q3 = -1, ee = C(H.length - $, 0), oe = Array(ee); ++q3 < ee; )
              oe[q3] = H[$ + q3];
            q3 = -1;
            for (var ne = Array($ + 1); ++q3 < $; )
              ne[q3] = H[q3];
            return ne[$] = oe, c2(V, this, ne);
          });
          n2.exports = U;
        }).call(this, i(43));
      }, function(n2, a, i) {
        Object.defineProperty(a, "__esModule", { value: true }), a.yuv2rgb = function(o) {
          var s, u, l2, c2 = o[0], f2 = o[1], h = o[2];
          return s = 1 * c2 + 0 * f2 + 1.13983 * h, u = 1 * c2 + -0.39465 * f2 + -0.5806 * h, l2 = 1 * c2 + 2.02311 * f2 + 0 * h, s = Math.min(Math.max(0, s), 1), u = Math.min(Math.max(0, u), 1), l2 = Math.min(Math.max(0, l2), 1), [255 * s, 255 * u, 255 * l2];
        }, a.rgb2yuv = function(o) {
          var s = o[0] / 255, u = o[1] / 255, l2 = o[2] / 255;
          return [0.299 * s + 0.587 * u + 0.114 * l2, -0.14713 * s + -0.28886 * u + 0.436 * l2, 0.615 * s + -0.51499 * u + -0.10001 * l2];
        };
      }, function(n2, a, i) {
        function o(l2, c2, f2) {
          return c2 in l2 ? Object.defineProperty(l2, c2, { value: f2, enumerable: true, configurable: true, writable: true }) : l2[c2] = f2, l2;
        }
        var s = i(141), u = function() {
          function l2() {
            o(this, "_callbacks", void 0), o(this, "_isDispatching", void 0), o(this, "_isHandled", void 0), o(this, "_isPending", void 0), o(this, "_lastID", void 0), o(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
          }
          var c2 = l2.prototype;
          return c2.register = function(f2) {
            var h = "ID_" + this._lastID++;
            return this._callbacks[h] = f2, h;
          }, c2.unregister = function(f2) {
            this._callbacks[f2] || s(false), delete this._callbacks[f2];
          }, c2.waitFor = function(f2) {
            this._isDispatching || s(false);
            for (var h = 0; h < f2.length; h++) {
              var v9 = f2[h];
              this._isPending[v9] ? this._isHandled[v9] || s(false) : (this._callbacks[v9] || s(false), this._invokeCallback(v9));
            }
          }, c2.dispatch = function(f2) {
            this._isDispatching && s(false), this._startDispatching(f2);
            try {
              for (var h in this._callbacks)
                this._isPending[h] || this._invokeCallback(h);
            } finally {
              this._stopDispatching();
            }
          }, c2.isDispatching = function() {
            return this._isDispatching;
          }, c2._invokeCallback = function(f2) {
            this._isPending[f2] = true, this._callbacks[f2](this._pendingPayload), this._isHandled[f2] = true;
          }, c2._startDispatching = function(f2) {
            for (var h in this._callbacks)
              this._isPending[h] = false, this._isHandled[h] = false;
            this._pendingPayload = f2, this._isDispatching = true;
          }, c2._stopDispatching = function() {
            delete this._pendingPayload, this._isDispatching = false;
          }, l2;
        }();
        n2.exports = u;
      }, function(n2, a, i) {
        n2.exports = function(o, s) {
          for (var u = arguments.length, l2 = new Array(u > 2 ? u - 2 : 0), c2 = 2; c2 < u; c2++)
            l2[c2 - 2] = arguments[c2];
          if (!o) {
            var f2;
            if (s === void 0)
              f2 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
            else {
              var h = 0;
              (f2 = new Error(s.replace(/%s/g, function() {
                return String(l2[h++]);
              }))).name = "Invariant Violation";
            }
            throw f2.framesToPop = 1, f2;
          }
        };
      }, function(n2, a, i) {
        function o(Be, $e, Se) {
          return $e in Be ? Object.defineProperty(Be, $e, { value: Se, enumerable: true, configurable: true, writable: true }) : Be[$e] = Se, Be;
        }
        function s(Be, $e) {
          var Se = Object.keys(Be);
          if (Object.getOwnPropertySymbols) {
            var ke = Object.getOwnPropertySymbols(Be);
            $e && (ke = ke.filter(function(Ie) {
              return Object.getOwnPropertyDescriptor(Be, Ie).enumerable;
            })), Se.push.apply(Se, ke);
          }
          return Se;
        }
        function u(Be) {
          for (var $e = 1; $e < arguments.length; $e++) {
            var Se = arguments[$e] != null ? arguments[$e] : {};
            $e % 2 ? s(Object(Se), true).forEach(function(ke) {
              o(Be, ke, Se[ke]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Be, Object.getOwnPropertyDescriptors(Se)) : s(Object(Se)).forEach(function(ke) {
              Object.defineProperty(Be, ke, Object.getOwnPropertyDescriptor(Se, ke));
            });
          }
          return Be;
        }
        function l2(Be, $e) {
          if (!(Be instanceof $e))
            throw new TypeError("Cannot call a class as a function");
        }
        function c2(Be, $e) {
          for (var Se = 0; Se < $e.length; Se++) {
            var ke = $e[Se];
            ke.enumerable = ke.enumerable || false, ke.configurable = true, "value" in ke && (ke.writable = true), Object.defineProperty(Be, ke.key, ke);
          }
        }
        function f2(Be, $e, Se) {
          return $e && c2(Be.prototype, $e), Se && c2(Be, Se), Be;
        }
        function h(Be, $e) {
          return (h = Object.setPrototypeOf || function(Se, ke) {
            return Se.__proto__ = ke, Se;
          })(Be, $e);
        }
        function v9(Be, $e) {
          if (typeof $e != "function" && $e !== null)
            throw new TypeError("Super expression must either be null or a function");
          Be.prototype = Object.create($e && $e.prototype, { constructor: { value: Be, writable: true, configurable: true } }), $e && h(Be, $e);
        }
        function d2(Be) {
          return (d2 = Object.setPrototypeOf ? Object.getPrototypeOf : function($e) {
            return $e.__proto__ || Object.getPrototypeOf($e);
          })(Be);
        }
        function m2(Be) {
          return (m2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function($e) {
            return typeof $e;
          } : function($e) {
            return $e && typeof Symbol == "function" && $e.constructor === Symbol && $e !== Symbol.prototype ? "symbol" : typeof $e;
          })(Be);
        }
        function b2(Be) {
          if (Be === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return Be;
        }
        function _(Be, $e) {
          return !$e || m2($e) !== "object" && typeof $e != "function" ? b2(Be) : $e;
        }
        function C(Be) {
          var $e = function() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }();
          return function() {
            var Se, ke = d2(Be);
            if ($e) {
              var Ie = d2(this).constructor;
              Se = Reflect.construct(ke, arguments, Ie);
            } else
              Se = ke.apply(this, arguments);
            return _(this, Se);
          };
        }
        i.r(a);
        var M = i(0), E = i.n(M);
        function z9() {
          var Be = this.constructor.getDerivedStateFromProps(this.props, this.state);
          Be != null && this.setState(Be);
        }
        function V(Be) {
          this.setState(function($e) {
            var Se = this.constructor.getDerivedStateFromProps(Be, $e);
            return Se != null ? Se : null;
          }.bind(this));
        }
        function $(Be, $e) {
          try {
            var Se = this.props, ke = this.state;
            this.props = Be, this.state = $e, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Se, ke);
          } finally {
            this.props = Se, this.state = ke;
          }
        }
        function U(Be) {
          var $e = Be.prototype;
          if (!$e || !$e.isReactComponent)
            throw new Error("Can only polyfill class components");
          if (typeof Be.getDerivedStateFromProps != "function" && typeof $e.getSnapshotBeforeUpdate != "function")
            return Be;
          var Se = null, ke = null, Ie = null;
          if (typeof $e.componentWillMount == "function" ? Se = "componentWillMount" : typeof $e.UNSAFE_componentWillMount == "function" && (Se = "UNSAFE_componentWillMount"), typeof $e.componentWillReceiveProps == "function" ? ke = "componentWillReceiveProps" : typeof $e.UNSAFE_componentWillReceiveProps == "function" && (ke = "UNSAFE_componentWillReceiveProps"), typeof $e.componentWillUpdate == "function" ? Ie = "componentWillUpdate" : typeof $e.UNSAFE_componentWillUpdate == "function" && (Ie = "UNSAFE_componentWillUpdate"), Se !== null || ke !== null || Ie !== null) {
            var Mt = Be.displayName || Be.name, At = typeof Be.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
            throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Mt + " uses " + At + " but also contains the following legacy lifecycles:" + (Se !== null ? `
  ` + Se : "") + (ke !== null ? `
  ` + ke : "") + (Ie !== null ? `
  ` + Ie : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
          }
          if (typeof Be.getDerivedStateFromProps == "function" && ($e.componentWillMount = z9, $e.componentWillReceiveProps = V), typeof $e.getSnapshotBeforeUpdate == "function") {
            if (typeof $e.componentDidUpdate != "function")
              throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
            $e.componentWillUpdate = $;
            var Qt = $e.componentDidUpdate;
            $e.componentDidUpdate = function(xt, Rr, wn) {
              var Ba = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : wn;
              Qt.call(this, xt, Rr, Ba);
            };
          }
          return Be;
        }
        function H(Be, $e) {
          if (Be == null)
            return {};
          var Se, ke, Ie = function(At, Qt) {
            if (At == null)
              return {};
            var xt, Rr, wn = {}, Ba = Object.keys(At);
            for (Rr = 0; Rr < Ba.length; Rr++)
              xt = Ba[Rr], Qt.indexOf(xt) >= 0 || (wn[xt] = At[xt]);
            return wn;
          }(Be, $e);
          if (Object.getOwnPropertySymbols) {
            var Mt = Object.getOwnPropertySymbols(Be);
            for (ke = 0; ke < Mt.length; ke++)
              Se = Mt[ke], $e.indexOf(Se) >= 0 || Object.prototype.propertyIsEnumerable.call(Be, Se) && (Ie[Se] = Be[Se]);
          }
          return Ie;
        }
        function q3(Be) {
          var $e = function(Se) {
            return {}.toString.call(Se).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
          }(Be);
          return $e === "number" && ($e = isNaN(Be) ? "nan" : (0 | Be) != Be ? "float" : "integer"), $e;
        }
        z9.__suppressDeprecationWarning = true, V.__suppressDeprecationWarning = true, $.__suppressDeprecationWarning = true;
        var ee = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, oe = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, ne = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, be = i(45), Ee = function(Be) {
          var $e = function(Se) {
            return { backgroundColor: Se.base00, ellipsisColor: Se.base09, braceColor: Se.base07, expandedIcon: Se.base0D, collapsedIcon: Se.base0E, keyColor: Se.base07, arrayKeyColor: Se.base0C, objectSize: Se.base04, copyToClipboard: Se.base0F, copyToClipboardCheck: Se.base0D, objectBorder: Se.base02, dataTypes: { boolean: Se.base0E, date: Se.base0D, float: Se.base0B, function: Se.base0D, integer: Se.base0F, string: Se.base09, nan: Se.base08, null: Se.base0A, undefined: Se.base05, regexp: Se.base0A, background: Se.base02 }, editVariable: { editIcon: Se.base0E, cancelIcon: Se.base09, removeIcon: Se.base09, addIcon: Se.base0E, checkIcon: Se.base0E, background: Se.base01, color: Se.base0A, border: Se.base07 }, addKeyModal: { background: Se.base05, border: Se.base04, color: Se.base0A, labelColor: Se.base01 }, validationFailure: { background: Se.base09, iconColor: Se.base01, fontColor: Se.base01 } };
          }(Be);
          return { "app-container": { fontFamily: ne.globalFontFamily, cursor: ne.globalCursor, backgroundColor: $e.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: $e.ellipsisColor, fontSize: ne.ellipsisFontSize, lineHeight: ne.ellipsisLineHeight, cursor: ne.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: ne.braceCursor, fontWeight: ne.braceFontWeight, color: $e.braceColor }, "expanded-icon": { color: $e.expandedIcon }, "collapsed-icon": { color: $e.collapsedIcon }, colon: { display: "inline-block", margin: ne.keyMargin, color: $e.keyColor, verticalAlign: "top" }, objectKeyVal: function(Se, ke) {
            return { style: u({ paddingTop: ne.keyValPaddingTop, paddingRight: ne.keyValPaddingRight, paddingBottom: ne.keyValPaddingBottom, borderLeft: ne.keyValBorderLeft + " " + $e.objectBorder, ":hover": { paddingLeft: ke.paddingLeft - 1 + "px", borderLeft: ne.keyValBorderHover + " " + $e.objectBorder } }, ke) };
          }, "object-key-val-no-border": { padding: ne.keyValPadding }, "pushed-content": { marginLeft: ne.pushedContentMarginLeft }, variableValue: function(Se, ke) {
            return { style: u({ display: "inline-block", paddingRight: ne.variableValuePaddingRight, position: "relative" }, ke) };
          }, "object-name": { display: "inline-block", color: $e.keyColor, letterSpacing: ne.keyLetterSpacing, fontStyle: ne.keyFontStyle, verticalAlign: ne.keyVerticalAlign, opacity: ne.keyOpacity, ":hover": { opacity: ne.keyOpacityHover } }, "array-key": { display: "inline-block", color: $e.arrayKeyColor, letterSpacing: ne.keyLetterSpacing, fontStyle: ne.keyFontStyle, verticalAlign: ne.keyVerticalAlign, opacity: ne.keyOpacity, ":hover": { opacity: ne.keyOpacityHover } }, "object-size": { color: $e.objectSize, borderRadius: ne.objectSizeBorderRadius, fontStyle: ne.objectSizeFontStyle, margin: ne.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: ne.dataTypeFontSize, marginRight: ne.dataTypeMarginRight, opacity: ne.datatypeOpacity }, boolean: { display: "inline-block", color: $e.dataTypes.boolean }, date: { display: "inline-block", color: $e.dataTypes.date }, "date-value": { marginLeft: ne.dateValueMarginLeft }, float: { display: "inline-block", color: $e.dataTypes.float }, function: { display: "inline-block", color: $e.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: $e.dataTypes.integer }, string: { display: "inline-block", color: $e.dataTypes.string }, nan: { display: "inline-block", color: $e.dataTypes.nan, fontSize: ne.nanFontSize, fontWeight: ne.nanFontWeight, backgroundColor: $e.dataTypes.background, padding: ne.nanPadding, borderRadius: ne.nanBorderRadius }, null: { display: "inline-block", color: $e.dataTypes.null, fontSize: ne.nullFontSize, fontWeight: ne.nullFontWeight, backgroundColor: $e.dataTypes.background, padding: ne.nullPadding, borderRadius: ne.nullBorderRadius }, undefined: { display: "inline-block", color: $e.dataTypes.undefined, fontSize: ne.undefinedFontSize, padding: ne.undefinedPadding, borderRadius: ne.undefinedBorderRadius, backgroundColor: $e.dataTypes.background }, regexp: { display: "inline-block", color: $e.dataTypes.regexp }, "copy-to-clipboard": { cursor: ne.clipboardCursor }, "copy-icon": { color: $e.copyToClipboard, fontSize: ne.iconFontSize, marginRight: ne.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: $e.copyToClipboardCheck, marginLeft: ne.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: ne.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: ne.metaDataPadding }, "icon-container": { display: "inline-block", width: ne.iconContainerWidth }, tooltip: { padding: ne.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: $e.editVariable.removeIcon, cursor: ne.iconCursor, fontSize: ne.iconFontSize, marginRight: ne.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: $e.editVariable.addIcon, cursor: ne.iconCursor, fontSize: ne.iconFontSize, marginRight: ne.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: $e.editVariable.editIcon, cursor: ne.iconCursor, fontSize: ne.iconFontSize, marginRight: ne.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: ne.iconCursor, color: $e.editVariable.checkIcon, fontSize: ne.iconFontSize, paddingRight: ne.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: ne.iconCursor, color: $e.editVariable.cancelIcon, fontSize: ne.iconFontSize, paddingRight: ne.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: ne.editInputMinWidth, borderRadius: ne.editInputBorderRadius, backgroundColor: $e.editVariable.background, color: $e.editVariable.color, padding: ne.editInputPadding, marginRight: ne.editInputMarginRight, fontFamily: ne.editInputFontFamily }, "detected-row": { paddingTop: ne.detectedRowPaddingTop }, "key-modal-request": { position: ne.addKeyCoverPosition, top: ne.addKeyCoverPositionPx, left: ne.addKeyCoverPositionPx, right: ne.addKeyCoverPositionPx, bottom: ne.addKeyCoverPositionPx, backgroundColor: ne.addKeyCoverBackground }, "key-modal": { width: ne.addKeyModalWidth, backgroundColor: $e.addKeyModal.background, marginLeft: ne.addKeyModalMargin, marginRight: ne.addKeyModalMargin, padding: ne.addKeyModalPadding, borderRadius: ne.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: $e.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: $e.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: $e.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: $e.addKeyModal.labelColor, fontSize: ne.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: $e.editVariable.addIcon, fontSize: ne.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: $e.ellipsisColor, fontSize: ne.ellipsisFontSize, lineHeight: ne.ellipsisLineHeight, cursor: ne.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: $e.validationFailure.fontColor, backgroundColor: $e.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: $e.validationFailure.iconColor, fontSize: ne.iconFontSize, transform: "rotate(45deg)" } };
        };
        function ye(Be, $e, Se) {
          return Be || console.error("theme has not been set"), function(ke) {
            var Ie = ee;
            return ke !== false && ke !== "none" || (Ie = oe), Object(be.createStyling)(Ee, { defaultBase16: Ie })(ke);
          }(Be)($e, Se);
        }
        var et = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = (ke.rjvId, ke.type_name), Mt = ke.displayDataTypes, At = ke.theme;
            return Mt ? E.a.createElement("span", Object.assign({ className: "data-type-label" }, ye(At, "data-type-label")), Ie) : null;
          } }]), Se;
        }(E.a.PureComponent), Le = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props;
            return E.a.createElement("div", ye(ke.theme, "boolean"), E.a.createElement(et, Object.assign({ type_name: "bool" }, ke)), ke.value ? "true" : "false");
          } }]), Se;
        }(E.a.PureComponent), Fe = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props;
            return E.a.createElement("div", ye(ke.theme, "date"), E.a.createElement(et, Object.assign({ type_name: "date" }, ke)), E.a.createElement("span", Object.assign({ className: "date-value" }, ye(ke.theme, "date-value")), ke.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
          } }]), Se;
        }(E.a.PureComponent), qe = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props;
            return E.a.createElement("div", ye(ke.theme, "float"), E.a.createElement(et, Object.assign({ type_name: "float" }, ke)), this.props.value);
          } }]), Se;
        }(E.a.PureComponent);
        function st(Be, $e) {
          ($e == null || $e > Be.length) && ($e = Be.length);
          for (var Se = 0, ke = new Array($e); Se < $e; Se++)
            ke[Se] = Be[Se];
          return ke;
        }
        function dt(Be, $e) {
          if (Be) {
            if (typeof Be == "string")
              return st(Be, $e);
            var Se = Object.prototype.toString.call(Be).slice(8, -1);
            return Se === "Object" && Be.constructor && (Se = Be.constructor.name), Se === "Map" || Se === "Set" ? Array.from(Be) : Se === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se) ? st(Be, $e) : void 0;
          }
        }
        function Ar(Be, $e) {
          var Se;
          if (typeof Symbol == "undefined" || Be[Symbol.iterator] == null) {
            if (Array.isArray(Be) || (Se = dt(Be)) || $e && Be && typeof Be.length == "number") {
              Se && (Be = Se);
              var ke = 0, Ie = function() {
              };
              return { s: Ie, n: function() {
                return ke >= Be.length ? { done: true } : { done: false, value: Be[ke++] };
              }, e: function(xt) {
                throw xt;
              }, f: Ie };
            }
            throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          var Mt, At = true, Qt = false;
          return { s: function() {
            Se = Be[Symbol.iterator]();
          }, n: function() {
            var xt = Se.next();
            return At = xt.done, xt;
          }, e: function(xt) {
            Qt = true, Mt = xt;
          }, f: function() {
            try {
              At || Se.return == null || Se.return();
            } finally {
              if (Qt)
                throw Mt;
            }
          } };
        }
        function Hr(Be) {
          return function($e) {
            if (Array.isArray($e))
              return st($e);
          }(Be) || function($e) {
            if (typeof Symbol != "undefined" && Symbol.iterator in Object($e))
              return Array.from($e);
          }(Be) || dt(Be) || function() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }();
        }
        var hn = i(46), cn = new (i(47)).Dispatcher(), nn = new (function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            var ke;
            l2(this, Se);
            for (var Ie = arguments.length, Mt = new Array(Ie), At = 0; At < Ie; At++)
              Mt[At] = arguments[At];
            return (ke = $e.call.apply($e, [this].concat(Mt))).objects = {}, ke.set = function(Qt, xt, Rr, wn) {
              ke.objects[Qt] === void 0 && (ke.objects[Qt] = {}), ke.objects[Qt][xt] === void 0 && (ke.objects[Qt][xt] = {}), ke.objects[Qt][xt][Rr] = wn;
            }, ke.get = function(Qt, xt, Rr, wn) {
              return ke.objects[Qt] === void 0 || ke.objects[Qt][xt] === void 0 || ke.objects[Qt][xt][Rr] == null ? wn : ke.objects[Qt][xt][Rr];
            }, ke.handleAction = function(Qt) {
              var xt = Qt.rjvId, Rr = Qt.data;
              switch (Qt.name) {
                case "RESET":
                  ke.emit("reset-" + xt);
                  break;
                case "VARIABLE_UPDATED":
                  Qt.data.updated_src = ke.updateSrc(xt, Rr), ke.set(xt, "action", "variable-update", u(u({}, Rr), {}, { type: "variable-edited" })), ke.emit("variable-update-" + xt);
                  break;
                case "VARIABLE_REMOVED":
                  Qt.data.updated_src = ke.updateSrc(xt, Rr), ke.set(xt, "action", "variable-update", u(u({}, Rr), {}, { type: "variable-removed" })), ke.emit("variable-update-" + xt);
                  break;
                case "VARIABLE_ADDED":
                  Qt.data.updated_src = ke.updateSrc(xt, Rr), ke.set(xt, "action", "variable-update", u(u({}, Rr), {}, { type: "variable-added" })), ke.emit("variable-update-" + xt);
                  break;
                case "ADD_VARIABLE_KEY_REQUEST":
                  ke.set(xt, "action", "new-key-request", Rr), ke.emit("add-key-request-" + xt);
              }
            }, ke.updateSrc = function(Qt, xt) {
              var Rr = xt.name, wn = xt.namespace, Ba = xt.new_value, sa = (xt.existing_value, xt.variable_removed);
              wn.shift();
              var Xi, ma = ke.get(Qt, "global", "src"), Wi = ke.deepCopy(ma, Hr(wn)), io = Wi, kn = Ar(wn);
              try {
                for (kn.s(); !(Xi = kn.n()).done; )
                  io = io[Xi.value];
              } catch (Bi) {
                kn.e(Bi);
              } finally {
                kn.f();
              }
              return sa ? q3(io) == "array" ? io.splice(Rr, 1) : delete io[Rr] : Rr !== null ? io[Rr] = Ba : Wi = Ba, ke.set(Qt, "global", "src", Wi), Wi;
            }, ke.deepCopy = function(Qt, xt) {
              var Rr, wn = q3(Qt), Ba = xt.shift();
              return wn == "array" ? Rr = Hr(Qt) : wn == "object" && (Rr = u({}, Qt)), Ba !== void 0 && (Rr[Ba] = ke.deepCopy(Qt[Ba], xt)), Rr;
            }, ke;
          }
          return Se;
        }(hn.EventEmitter))();
        cn.register(nn.handleAction.bind(nn));
        var Wr = nn, on = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).toggleCollapsed = function() {
              Ie.setState({ collapsed: !Ie.state.collapsed }, function() {
                Wr.set(Ie.props.rjvId, Ie.props.namespace, "collapsed", Ie.state.collapsed);
              });
            }, Ie.getFunctionDisplay = function(Mt) {
              var At = b2(Ie).props;
              return Mt ? E.a.createElement("span", null, Ie.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), E.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, E.a.createElement("span", null, "{"), E.a.createElement("span", ye(At.theme, "ellipsis"), "..."), E.a.createElement("span", null, "}"))) : Ie.props.value.toString().slice(9, -1);
            }, Ie.state = { collapsed: Wr.get(ke.rjvId, ke.namespace, "collapsed", true) }, Ie;
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = this.state.collapsed;
            return E.a.createElement("div", ye(ke.theme, "function"), E.a.createElement(et, Object.assign({ type_name: "function" }, ke)), E.a.createElement("span", Object.assign({}, ye(ke.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Ie)));
          } }]), Se;
        }(E.a.PureComponent), un = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            return E.a.createElement("div", ye(this.props.theme, "nan"), "NaN");
          } }]), Se;
        }(E.a.PureComponent), Xr = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            return E.a.createElement("div", ye(this.props.theme, "null"), "NULL");
          } }]), Se;
        }(E.a.PureComponent), _n = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props;
            return E.a.createElement("div", ye(ke.theme, "integer"), E.a.createElement(et, Object.assign({ type_name: "int" }, ke)), this.props.value);
          } }]), Se;
        }(E.a.PureComponent), Za = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props;
            return E.a.createElement("div", ye(ke.theme, "regexp"), E.a.createElement(et, Object.assign({ type_name: "regexp" }, ke)), this.props.value.toString());
          } }]), Se;
        }(E.a.PureComponent), Dn = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).toggleCollapsed = function() {
              Ie.setState({ collapsed: !Ie.state.collapsed }, function() {
                Wr.set(Ie.props.rjvId, Ie.props.namespace, "collapsed", Ie.state.collapsed);
              });
            }, Ie.state = { collapsed: Wr.get(ke.rjvId, ke.namespace, "collapsed", true) }, Ie;
          }
          return f2(Se, [{ key: "render", value: function() {
            this.state.collapsed;
            var ke = this.props, Ie = ke.collapseStringsAfterLength, Mt = ke.theme, At = ke.value, Qt = { style: { cursor: "default" } };
            return q3(Ie) === "integer" && At.length > Ie && (Qt.style.cursor = "pointer", this.state.collapsed && (At = E.a.createElement("span", null, At.substring(0, Ie), E.a.createElement("span", ye(Mt, "ellipsis"), " ...")))), E.a.createElement("div", ye(Mt, "string"), E.a.createElement(et, Object.assign({ type_name: "string" }, ke)), E.a.createElement("span", Object.assign({ className: "string-value" }, Qt, { onClick: this.toggleCollapsed }), '"', At, '"'));
          } }]), Se;
        }(E.a.PureComponent), ai = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            return E.a.createElement("div", ye(this.props.theme, "undefined"), "undefined");
          } }]), Se;
        }(E.a.PureComponent);
        function wi() {
          return (wi = Object.assign || function(Be) {
            for (var $e = 1; $e < arguments.length; $e++) {
              var Se = arguments[$e];
              for (var ke in Se)
                Object.prototype.hasOwnProperty.call(Se, ke) && (Be[ke] = Se[ke]);
            }
            return Be;
          }).apply(this, arguments);
        }
        var hi = M.useLayoutEffect, qs = function(Be) {
          var $e = Object(M.useRef)(Be);
          return hi(function() {
            $e.current = Be;
          }), $e;
        }, jo = function(Be, $e) {
          typeof Be != "function" ? Be.current = $e : Be($e);
        }, Au = function(Be, $e) {
          var Se = Object(M.useRef)();
          return Object(M.useCallback)(function(ke) {
            Be.current = ke, Se.current && jo(Se.current, null), Se.current = $e, $e && jo($e, ke);
          }, [$e]);
        }, Zi = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, ys = function(Be) {
          Object.keys(Zi).forEach(function($e) {
            Be.style.setProperty($e, Zi[$e], "important");
          });
        }, Do = null, mf = function() {
        }, xr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], jt = !!document.documentElement.currentStyle, Ot = function(Be, $e) {
          var Se = Be.cacheMeasurements, ke = Be.maxRows, Ie = Be.minRows, Mt = Be.onChange, At = Mt === void 0 ? mf : Mt, Qt = Be.onHeightChange, xt = Qt === void 0 ? mf : Qt, Rr = function(kn, Bi) {
            if (kn == null)
              return {};
            var El, bf, Ng = {}, $l = Object.keys(kn);
            for (bf = 0; bf < $l.length; bf++)
              El = $l[bf], Bi.indexOf(El) >= 0 || (Ng[El] = kn[El]);
            return Ng;
          }(Be, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), wn, Ba = Rr.value !== void 0, sa = Object(M.useRef)(null), Xi = Au(sa, $e), ma = Object(M.useRef)(0), Wi = Object(M.useRef)(), io = function() {
            var kn = sa.current, Bi = Se && Wi.current ? Wi.current : function($l) {
              var Xh = window.getComputedStyle($l);
              if (Xh === null)
                return null;
              var Jh, bs = (Jh = Xh, xr.reduce(function(sp, Qh) {
                return sp[Qh] = Jh[Qh], sp;
              }, {})), nh = bs.boxSizing;
              return nh === "" ? null : (jt && nh === "border-box" && (bs.width = parseFloat(bs.width) + parseFloat(bs.borderRightWidth) + parseFloat(bs.borderLeftWidth) + parseFloat(bs.paddingRight) + parseFloat(bs.paddingLeft) + "px"), { sizingStyle: bs, paddingSize: parseFloat(bs.paddingBottom) + parseFloat(bs.paddingTop), borderSize: parseFloat(bs.borderBottomWidth) + parseFloat(bs.borderTopWidth) });
            }(kn);
            if (Bi) {
              Wi.current = Bi;
              var El = function($l, Xh, Jh, bs) {
                Jh === void 0 && (Jh = 1), bs === void 0 && (bs = 1 / 0), Do || ((Do = document.createElement("textarea")).setAttribute("tab-index", "-1"), Do.setAttribute("aria-hidden", "true"), ys(Do)), Do.parentNode === null && document.body.appendChild(Do);
                var nh = $l.paddingSize, sp = $l.borderSize, Qh = $l.sizingStyle, up = Qh.boxSizing;
                Object.keys(Qh).forEach(function(cp) {
                  var Kv = cp;
                  Do.style[Kv] = Qh[Kv];
                }), ys(Do), Do.value = Xh;
                var Yv = function(cp, Kv) {
                  var jc = cp.scrollHeight;
                  return Kv.sizingStyle.boxSizing === "border-box" ? jc + Kv.borderSize : jc - Kv.paddingSize;
                }(Do, $l);
                Do.value = "x";
                var Mu = Do.scrollHeight - nh, lp = Mu * Jh;
                up === "border-box" && (lp = lp + nh + sp), Yv = Math.max(lp, Yv);
                var ah = Mu * bs;
                return up === "border-box" && (ah = ah + nh + sp), [Yv = Math.min(ah, Yv), Mu];
              }(Bi, kn.value || kn.placeholder || "x", Ie, ke), bf = El[0], Ng = El[1];
              ma.current !== bf && (ma.current = bf, kn.style.setProperty("height", bf + "px", "important"), xt(bf, { rowHeight: Ng }));
            }
          };
          return Object(M.useLayoutEffect)(io), wn = qs(io), Object(M.useLayoutEffect)(function() {
            var kn = function(Bi) {
              wn.current(Bi);
            };
            return window.addEventListener("resize", kn), function() {
              window.removeEventListener("resize", kn);
            };
          }, []), Object(M.createElement)("textarea", wi({}, Rr, { onChange: function(kn) {
            Ba || io(), At(kn);
          }, ref: Xi }));
        }, wr = Object(M.forwardRef)(Ot);
        function an(Be) {
          Be = Be.trim();
          try {
            if ((Be = JSON.stringify(JSON.parse(Be)))[0] === "[")
              return Mn("array", JSON.parse(Be));
            if (Be[0] === "{")
              return Mn("object", JSON.parse(Be));
            if (Be.match(/\-?\d+\.\d+/) && Be.match(/\-?\d+\.\d+/)[0] === Be)
              return Mn("float", parseFloat(Be));
            if (Be.match(/\-?\d+e-\d+/) && Be.match(/\-?\d+e-\d+/)[0] === Be)
              return Mn("float", Number(Be));
            if (Be.match(/\-?\d+/) && Be.match(/\-?\d+/)[0] === Be)
              return Mn("integer", parseInt(Be));
            if (Be.match(/\-?\d+e\+\d+/) && Be.match(/\-?\d+e\+\d+/)[0] === Be)
              return Mn("integer", Number(Be));
          } catch {
          }
          switch (Be = Be.toLowerCase()) {
            case "undefined":
              return Mn("undefined", void 0);
            case "nan":
              return Mn("nan", NaN);
            case "null":
              return Mn("null", null);
            case "true":
              return Mn("boolean", true);
            case "false":
              return Mn("boolean", false);
            default:
              if (Be = Date.parse(Be))
                return Mn("date", new Date(Be));
          }
          return Mn(false, null);
        }
        function Mn(Be, $e) {
          return { type: Be, value: $e };
        }
        var Fa = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
          } }]), Se;
        }(E.a.PureComponent), Ma = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
          } }]), Se;
        }(E.a.PureComponent), ji = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]), At = vi(Ie).style;
            return E.a.createElement("span", Mt, E.a.createElement("svg", { fill: At.color, width: At.height, height: At.width, style: At, viewBox: "0 0 1792 1792" }, E.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), Se;
        }(E.a.PureComponent), Bo = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]), At = vi(Ie).style;
            return E.a.createElement("span", Mt, E.a.createElement("svg", { fill: At.color, width: At.height, height: At.width, style: At, viewBox: "0 0 1792 1792" }, E.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), Se;
        }(E.a.PureComponent), yo = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", { style: u(u({}, vi(Ie).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, E.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
          } }]), Se;
        }(E.a.PureComponent), ms = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", { style: u(u({}, vi(Ie).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, E.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
          } }]), Se;
        }(E.a.PureComponent), mo = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
          } }]), Se;
        }(E.a.PureComponent), Yu = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Se;
        }(E.a.PureComponent), wl = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Se;
        }(E.a.PureComponent), hc = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
          } }]), Se;
        }(E.a.PureComponent), Sl = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
          } }]), Se;
        }(E.a.PureComponent), as = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.style, Mt = H(ke, ["style"]);
            return E.a.createElement("span", Mt, E.a.createElement("svg", Object.assign({}, vi(Ie), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), E.a.createElement("g", null, E.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Se;
        }(E.a.PureComponent);
        function vi(Be) {
          return Be || (Be = {}), { style: u(u({ verticalAlign: "middle" }, Be), {}, { color: Be.color ? Be.color : "#000000", height: "1em", width: "1em" }) };
        }
        var Ys = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).copiedTimer = null, Ie.handleCopy = function() {
              var Mt = document.createElement("textarea"), At = Ie.props, Qt = At.clickCallback, xt = At.src, Rr = At.namespace;
              Mt.innerHTML = JSON.stringify(Ie.clipboardValue(xt), null, "  "), document.body.appendChild(Mt), Mt.select(), document.execCommand("copy"), document.body.removeChild(Mt), Ie.copiedTimer = setTimeout(function() {
                Ie.setState({ copied: false });
              }, 5500), Ie.setState({ copied: true }, function() {
                typeof Qt == "function" && Qt({ src: xt, namespace: Rr, name: Rr[Rr.length - 1] });
              });
            }, Ie.getClippyIcon = function() {
              var Mt = Ie.props.theme;
              return Ie.state.copied ? E.a.createElement("span", null, E.a.createElement(mo, Object.assign({ className: "copy-icon" }, ye(Mt, "copy-icon"))), E.a.createElement("span", ye(Mt, "copy-icon-copied"), "\u2714")) : E.a.createElement(mo, Object.assign({ className: "copy-icon" }, ye(Mt, "copy-icon")));
            }, Ie.clipboardValue = function(Mt) {
              switch (q3(Mt)) {
                case "function":
                case "regexp":
                  return Mt.toString();
                default:
                  return Mt;
              }
            }, Ie.state = { copied: false }, Ie;
          }
          return f2(Se, [{ key: "componentWillUnmount", value: function() {
            this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
          } }, { key: "render", value: function() {
            var ke = this.props, Ie = (ke.src, ke.theme), Mt = ke.hidden, At = ke.rowHovered, Qt = ye(Ie, "copy-to-clipboard").style, xt = "inline";
            return Mt && (xt = "none"), E.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: At ? "inline-block" : "none" } }, E.a.createElement("span", { style: u(u({}, Qt), {}, { display: xt }), onClick: this.handleCopy }, this.getClippyIcon()));
          } }]), Se;
        }(E.a.PureComponent), Tu = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).getEditIcon = function() {
              var Mt = Ie.props, At = Mt.variable, Qt = Mt.theme;
              return E.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Ie.state.hovered ? "inline-block" : "none" } }, E.a.createElement(Sl, Object.assign({ className: "click-to-edit-icon" }, ye(Qt, "editVarIcon"), { onClick: function() {
                Ie.prepopInput(At);
              } })));
            }, Ie.prepopInput = function(Mt) {
              if (Ie.props.onEdit !== false) {
                var At = function(xt) {
                  var Rr;
                  switch (q3(xt)) {
                    case "undefined":
                      Rr = "undefined";
                      break;
                    case "nan":
                      Rr = "NaN";
                      break;
                    case "string":
                      Rr = xt;
                      break;
                    case "date":
                    case "function":
                    case "regexp":
                      Rr = xt.toString();
                      break;
                    default:
                      try {
                        Rr = JSON.stringify(xt, null, "  ");
                      } catch {
                        Rr = "";
                      }
                  }
                  return Rr;
                }(Mt.value), Qt = an(At);
                Ie.setState({ editMode: true, editValue: At, parsedInput: { type: Qt.type, value: Qt.value } });
              }
            }, Ie.getRemoveIcon = function() {
              var Mt = Ie.props, At = Mt.variable, Qt = Mt.namespace, xt = Mt.theme, Rr = Mt.rjvId;
              return E.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Ie.state.hovered ? "inline-block" : "none" } }, E.a.createElement(Yu, Object.assign({ className: "click-to-remove-icon" }, ye(xt, "removeVarIcon"), { onClick: function() {
                cn.dispatch({ name: "VARIABLE_REMOVED", rjvId: Rr, data: { name: At.name, namespace: Qt, existing_value: At.value, variable_removed: true } });
              } })));
            }, Ie.getValue = function(Mt, At) {
              var Qt = !At && Mt.type, xt = b2(Ie).props;
              switch (Qt) {
                case false:
                  return Ie.getEditInput();
                case "string":
                  return E.a.createElement(Dn, Object.assign({ value: Mt.value }, xt));
                case "integer":
                  return E.a.createElement(_n, Object.assign({ value: Mt.value }, xt));
                case "float":
                  return E.a.createElement(qe, Object.assign({ value: Mt.value }, xt));
                case "boolean":
                  return E.a.createElement(Le, Object.assign({ value: Mt.value }, xt));
                case "function":
                  return E.a.createElement(on, Object.assign({ value: Mt.value }, xt));
                case "null":
                  return E.a.createElement(Xr, xt);
                case "nan":
                  return E.a.createElement(un, xt);
                case "undefined":
                  return E.a.createElement(ai, xt);
                case "date":
                  return E.a.createElement(Fe, Object.assign({ value: Mt.value }, xt));
                case "regexp":
                  return E.a.createElement(Za, Object.assign({ value: Mt.value }, xt));
                default:
                  return E.a.createElement("div", { className: "object-value" }, JSON.stringify(Mt.value));
              }
            }, Ie.getEditInput = function() {
              var Mt = Ie.props.theme, At = Ie.state.editValue;
              return E.a.createElement("div", null, E.a.createElement(wr, Object.assign({ type: "text", inputRef: function(Qt) {
                return Qt && Qt.focus();
              }, value: At, className: "variable-editor", onChange: function(Qt) {
                var xt = Qt.target.value, Rr = an(xt);
                Ie.setState({ editValue: xt, parsedInput: { type: Rr.type, value: Rr.value } });
              }, onKeyDown: function(Qt) {
                switch (Qt.key) {
                  case "Escape":
                    Ie.setState({ editMode: false, editValue: "" });
                    break;
                  case "Enter":
                    (Qt.ctrlKey || Qt.metaKey) && Ie.submitEdit(true);
                }
                Qt.stopPropagation();
              }, placeholder: "update this value", minRows: 2 }, ye(Mt, "edit-input"))), E.a.createElement("div", ye(Mt, "edit-icon-container"), E.a.createElement(Yu, Object.assign({ className: "edit-cancel" }, ye(Mt, "cancel-icon"), { onClick: function() {
                Ie.setState({ editMode: false, editValue: "" });
              } })), E.a.createElement(as, Object.assign({ className: "edit-check string-value" }, ye(Mt, "check-icon"), { onClick: function() {
                Ie.submitEdit();
              } })), E.a.createElement("div", null, Ie.showDetected())));
            }, Ie.submitEdit = function(Mt) {
              var At = Ie.props, Qt = At.variable, xt = At.namespace, Rr = At.rjvId, wn = Ie.state, Ba = wn.editValue, sa = wn.parsedInput, Xi = Ba;
              Mt && sa.type && (Xi = sa.value), Ie.setState({ editMode: false }), cn.dispatch({ name: "VARIABLE_UPDATED", rjvId: Rr, data: { name: Qt.name, namespace: xt, existing_value: Qt.value, new_value: Xi, variable_removed: false } });
            }, Ie.showDetected = function() {
              var Mt = Ie.props, At = Mt.theme, Qt = (Mt.variable, Mt.namespace, Mt.rjvId, Ie.state.parsedInput), xt = (Qt.type, Qt.value, Ie.getDetectedInput());
              if (xt)
                return E.a.createElement("div", null, E.a.createElement("div", ye(At, "detected-row"), xt, E.a.createElement(as, { className: "edit-check detected", style: u({ verticalAlign: "top", paddingLeft: "3px" }, ye(At, "check-icon").style), onClick: function() {
                  Ie.submitEdit(true);
                } })));
            }, Ie.getDetectedInput = function() {
              var Mt = Ie.state.parsedInput, At = Mt.type, Qt = Mt.value, xt = b2(Ie).props, Rr = xt.theme;
              if (At !== false)
                switch (At.toLowerCase()) {
                  case "object":
                    return E.a.createElement("span", null, E.a.createElement("span", { style: u(u({}, ye(Rr, "brace").style), {}, { cursor: "default" }) }, "{"), E.a.createElement("span", { style: u(u({}, ye(Rr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), E.a.createElement("span", { style: u(u({}, ye(Rr, "brace").style), {}, { cursor: "default" }) }, "}"));
                  case "array":
                    return E.a.createElement("span", null, E.a.createElement("span", { style: u(u({}, ye(Rr, "brace").style), {}, { cursor: "default" }) }, "["), E.a.createElement("span", { style: u(u({}, ye(Rr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), E.a.createElement("span", { style: u(u({}, ye(Rr, "brace").style), {}, { cursor: "default" }) }, "]"));
                  case "string":
                    return E.a.createElement(Dn, Object.assign({ value: Qt }, xt));
                  case "integer":
                    return E.a.createElement(_n, Object.assign({ value: Qt }, xt));
                  case "float":
                    return E.a.createElement(qe, Object.assign({ value: Qt }, xt));
                  case "boolean":
                    return E.a.createElement(Le, Object.assign({ value: Qt }, xt));
                  case "function":
                    return E.a.createElement(on, Object.assign({ value: Qt }, xt));
                  case "null":
                    return E.a.createElement(Xr, xt);
                  case "nan":
                    return E.a.createElement(un, xt);
                  case "undefined":
                    return E.a.createElement(ai, xt);
                  case "date":
                    return E.a.createElement(Fe, Object.assign({ value: new Date(Qt) }, xt));
                }
            }, Ie.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Ie;
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this, Ie = this.props, Mt = Ie.variable, At = Ie.singleIndent, Qt = Ie.type, xt = Ie.theme, Rr = Ie.namespace, wn = Ie.indentWidth, Ba = Ie.enableClipboard, sa = Ie.onEdit, Xi = Ie.onDelete, ma = Ie.onSelect, Wi = Ie.displayArrayKey, io = Ie.quotesOnKeys, kn = this.state.editMode;
            return E.a.createElement("div", Object.assign({}, ye(xt, "objectKeyVal", { paddingLeft: wn * At }), { onMouseEnter: function() {
              return ke.setState(u(u({}, ke.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return ke.setState(u(u({}, ke.state), {}, { hovered: false }));
            }, className: "variable-row", key: Mt.name }), Qt == "array" ? Wi ? E.a.createElement("span", Object.assign({}, ye(xt, "array-key"), { key: Mt.name + "_" + Rr }), Mt.name, E.a.createElement("div", ye(xt, "colon"), ":")) : null : E.a.createElement("span", null, E.a.createElement("span", Object.assign({}, ye(xt, "object-name"), { className: "object-key", key: Mt.name + "_" + Rr }), !!io && E.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), E.a.createElement("span", { style: { display: "inline-block" } }, Mt.name), !!io && E.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), E.a.createElement("span", ye(xt, "colon"), ":")), E.a.createElement("div", Object.assign({ className: "variable-value", onClick: ma === false && sa === false ? null : function(Bi) {
              var El = Hr(Rr);
              (Bi.ctrlKey || Bi.metaKey) && sa !== false ? ke.prepopInput(Mt) : ma !== false && (El.shift(), ma(u(u({}, Mt), {}, { namespace: El })));
            } }, ye(xt, "variableValue", { cursor: ma === false ? "default" : "pointer" })), this.getValue(Mt, kn)), Ba ? E.a.createElement(Ys, { rowHovered: this.state.hovered, hidden: kn, src: Mt.value, clickCallback: Ba, theme: xt, namespace: [].concat(Hr(Rr), [Mt.name]) }) : null, sa !== false && kn == 0 ? this.getEditIcon() : null, Xi !== false && kn == 0 ? this.getRemoveIcon() : null);
          } }]), Se;
        }(E.a.PureComponent), Vc = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            var ke;
            l2(this, Se);
            for (var Ie = arguments.length, Mt = new Array(Ie), At = 0; At < Ie; At++)
              Mt[At] = arguments[At];
            return (ke = $e.call.apply($e, [this].concat(Mt))).getObjectSize = function() {
              var Qt = ke.props, xt = Qt.size, Rr = Qt.theme;
              if (Qt.displayObjectSize)
                return E.a.createElement("span", Object.assign({ className: "object-size" }, ye(Rr, "object-size")), xt, " item", xt === 1 ? "" : "s");
            }, ke.getAddAttribute = function(Qt) {
              var xt = ke.props, Rr = xt.theme, wn = xt.namespace, Ba = xt.name, sa = xt.src, Xi = xt.rjvId, ma = xt.depth;
              return E.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Qt ? "inline-block" : "none" } }, E.a.createElement(wl, Object.assign({ className: "click-to-add-icon" }, ye(Rr, "addVarIcon"), { onClick: function() {
                var Wi = { name: ma > 0 ? Ba : null, namespace: wn.splice(0, wn.length - 1), existing_value: sa, variable_removed: false, key_name: null };
                q3(sa) === "object" ? cn.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Xi, data: Wi }) : cn.dispatch({ name: "VARIABLE_ADDED", rjvId: Xi, data: u(u({}, Wi), {}, { new_value: [].concat(Hr(sa), [null]) }) });
              } })));
            }, ke.getRemoveObject = function(Qt) {
              var xt = ke.props, Rr = xt.theme, wn = (xt.hover, xt.namespace), Ba = xt.name, sa = xt.src, Xi = xt.rjvId;
              if (wn.length !== 1)
                return E.a.createElement("span", { className: "click-to-remove", style: { display: Qt ? "inline-block" : "none" } }, E.a.createElement(Yu, Object.assign({ className: "click-to-remove-icon" }, ye(Rr, "removeVarIcon"), { onClick: function() {
                  cn.dispatch({ name: "VARIABLE_REMOVED", rjvId: Xi, data: { name: Ba, namespace: wn.splice(0, wn.length - 1), existing_value: sa, variable_removed: true } });
                } })));
            }, ke.render = function() {
              var Qt = ke.props, xt = Qt.theme, Rr = Qt.onDelete, wn = Qt.onAdd, Ba = Qt.enableClipboard, sa = Qt.src, Xi = Qt.namespace, ma = Qt.rowHovered;
              return E.a.createElement("div", Object.assign({}, ye(xt, "object-meta-data"), { className: "object-meta-data", onClick: function(Wi) {
                Wi.stopPropagation();
              } }), ke.getObjectSize(), Ba ? E.a.createElement(Ys, { rowHovered: ma, clickCallback: Ba, src: sa, theme: xt, namespace: Xi }) : null, wn !== false ? ke.getAddAttribute(ma) : null, Rr !== false ? ke.getRemoveObject(ma) : null);
            }, ke;
          }
          return Se;
        }(E.a.PureComponent);
        function zl(Be) {
          var $e = Be.parent_type, Se = Be.namespace, ke = Be.quotesOnKeys, Ie = Be.theme, Mt = Be.jsvRoot, At = Be.name, Qt = Be.displayArrayKey, xt = Be.name ? Be.name : "";
          return !Mt || At !== false && At !== null ? $e == "array" ? Qt ? E.a.createElement("span", Object.assign({}, ye(Ie, "array-key"), { key: Se }), E.a.createElement("span", { className: "array-key" }, xt), E.a.createElement("span", ye(Ie, "colon"), ":")) : E.a.createElement("span", null) : E.a.createElement("span", Object.assign({}, ye(Ie, "object-name"), { key: Se }), E.a.createElement("span", { className: "object-key" }, ke && E.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), E.a.createElement("span", null, xt), ke && E.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), E.a.createElement("span", ye(Ie, "colon"), ":")) : E.a.createElement("span", null);
        }
        function Cl(Be) {
          var $e = Be.theme;
          switch (Be.iconStyle) {
            case "triangle":
              return E.a.createElement(ms, Object.assign({}, ye($e, "expanded-icon"), { className: "expanded-icon" }));
            case "square":
              return E.a.createElement(ji, Object.assign({}, ye($e, "expanded-icon"), { className: "expanded-icon" }));
            default:
              return E.a.createElement(Fa, Object.assign({}, ye($e, "expanded-icon"), { className: "expanded-icon" }));
          }
        }
        function vc(Be) {
          var $e = Be.theme;
          switch (Be.iconStyle) {
            case "triangle":
              return E.a.createElement(yo, Object.assign({}, ye($e, "collapsed-icon"), { className: "collapsed-icon" }));
            case "square":
              return E.a.createElement(Bo, Object.assign({}, ye($e, "collapsed-icon"), { className: "collapsed-icon" }));
            default:
              return E.a.createElement(Ma, Object.assign({}, ye($e, "collapsed-icon"), { className: "collapsed-icon" }));
          }
        }
        var th = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).toggleCollapsed = function(Mt) {
              var At = [];
              for (var Qt in Ie.state.expanded)
                At.push(Ie.state.expanded[Qt]);
              At[Mt] = !At[Mt], Ie.setState({ expanded: At });
            }, Ie.state = { expanded: [] }, Ie;
          }
          return f2(Se, [{ key: "getExpandedIcon", value: function(ke) {
            var Ie = this.props, Mt = Ie.theme, At = Ie.iconStyle;
            return this.state.expanded[ke] ? E.a.createElement(Cl, { theme: Mt, iconStyle: At }) : E.a.createElement(vc, { theme: Mt, iconStyle: At });
          } }, { key: "render", value: function() {
            var ke = this, Ie = this.props, Mt = Ie.src, At = Ie.groupArraysAfterLength, Qt = (Ie.depth, Ie.name), xt = Ie.theme, Rr = Ie.jsvRoot, wn = Ie.namespace, Ba = (Ie.parent_type, H(Ie, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), sa = 0, Xi = 5 * this.props.indentWidth;
            Rr || (sa = 5 * this.props.indentWidth);
            var ma = At, Wi = Math.ceil(Mt.length / ma);
            return E.a.createElement("div", Object.assign({ className: "object-key-val" }, ye(xt, Rr ? "jsv-root" : "objectKeyVal", { paddingLeft: sa })), E.a.createElement(zl, this.props), E.a.createElement("span", null, E.a.createElement(Vc, Object.assign({ size: Mt.length }, this.props))), Hr(Array(Wi)).map(function(io, kn) {
              return E.a.createElement("div", Object.assign({ key: kn, className: "object-key-val array-group" }, ye(xt, "objectKeyVal", { marginLeft: 6, paddingLeft: Xi })), E.a.createElement("span", ye(xt, "brace-row"), E.a.createElement("div", Object.assign({ className: "icon-container" }, ye(xt, "icon-container"), { onClick: function(Bi) {
                ke.toggleCollapsed(kn);
              } }), ke.getExpandedIcon(kn)), ke.state.expanded[kn] ? E.a.createElement(qv, Object.assign({ key: Qt + kn, depth: 0, name: false, collapsed: false, groupArraysAfterLength: ma, index_offset: kn * ma, src: Mt.slice(kn * ma, kn * ma + ma), namespace: wn, type: "array", parent_type: "array_group", theme: xt }, Ba)) : E.a.createElement("span", Object.assign({}, ye(xt, "brace"), { onClick: function(Bi) {
                ke.toggleCollapsed(kn);
              }, className: "array-group-brace" }), "[", E.a.createElement("div", Object.assign({}, ye(xt, "array-group-meta-data"), { className: "array-group-meta-data" }), E.a.createElement("span", Object.assign({ className: "object-size" }, ye(xt, "object-size")), kn * ma, " - ", kn * ma + ma > Mt.length ? Mt.length : kn * ma + ma)), "]")));
            }));
          } }]), Se;
        }(E.a.PureComponent), rh = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            l2(this, Se), (Ie = $e.call(this, ke)).toggleCollapsed = function() {
              Ie.setState({ expanded: !Ie.state.expanded }, function() {
                Wr.set(Ie.props.rjvId, Ie.props.namespace, "expanded", Ie.state.expanded);
              });
            }, Ie.getObjectContent = function(At, Qt, xt) {
              return E.a.createElement("div", { className: "pushed-content object-container" }, E.a.createElement("div", Object.assign({ className: "object-content" }, ye(Ie.props.theme, "pushed-content")), Ie.renderObjectContents(Qt, xt)));
            }, Ie.getEllipsis = function() {
              return Ie.state.size === 0 ? null : E.a.createElement("div", Object.assign({}, ye(Ie.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Ie.toggleCollapsed }), "...");
            }, Ie.getObjectMetaData = function(At) {
              var Qt = Ie.props, xt = (Qt.rjvId, Qt.theme, Ie.state), Rr = xt.size, wn = xt.hovered;
              return E.a.createElement(Vc, Object.assign({ rowHovered: wn, size: Rr }, Ie.props));
            }, Ie.renderObjectContents = function(At, Qt) {
              var xt, Rr = Ie.props, wn = Rr.depth, Ba = Rr.parent_type, sa = Rr.index_offset, Xi = Rr.groupArraysAfterLength, ma = Rr.namespace, Wi = Ie.state.object_type, io = [], kn = Object.keys(At || {});
              return Ie.props.sortKeys && Wi !== "array" && (kn = kn.sort()), kn.forEach(function(Bi) {
                if (xt = new Mw(Bi, At[Bi]), Ba === "array_group" && sa && (xt.name = parseInt(xt.name) + sa), At.hasOwnProperty(Bi))
                  if (xt.type === "object")
                    io.push(E.a.createElement(qv, Object.assign({ key: xt.name, depth: wn + 1, name: xt.name, src: xt.value, namespace: ma.concat(xt.name), parent_type: Wi }, Qt)));
                  else if (xt.type === "array") {
                    var El = qv;
                    Xi && xt.value.length > Xi && (El = th), io.push(E.a.createElement(El, Object.assign({ key: xt.name, depth: wn + 1, name: xt.name, src: xt.value, namespace: ma.concat(xt.name), type: "array", parent_type: Wi }, Qt)));
                  } else
                    io.push(E.a.createElement(Tu, Object.assign({ key: xt.name + "_" + ma, variable: xt, singleIndent: 5, namespace: ma, type: Ie.props.type }, Qt)));
              }), io;
            };
            var Mt = Se.getState(ke);
            return Ie.state = u(u({}, Mt), {}, { prevProps: {} }), Ie;
          }
          return f2(Se, [{ key: "getBraceStart", value: function(ke, Ie) {
            var Mt = this, At = this.props, Qt = At.src, xt = At.theme, Rr = At.iconStyle;
            if (At.parent_type === "array_group")
              return E.a.createElement("span", null, E.a.createElement("span", ye(xt, "brace"), ke === "array" ? "[" : "{"), Ie ? this.getObjectMetaData(Qt) : null);
            var wn = Ie ? Cl : vc;
            return E.a.createElement("span", null, E.a.createElement("span", Object.assign({ onClick: function(Ba) {
              Mt.toggleCollapsed();
            } }, ye(xt, "brace-row")), E.a.createElement("div", Object.assign({ className: "icon-container" }, ye(xt, "icon-container")), E.a.createElement(wn, { theme: xt, iconStyle: Rr })), E.a.createElement(zl, this.props), E.a.createElement("span", ye(xt, "brace"), ke === "array" ? "[" : "{")), Ie ? this.getObjectMetaData(Qt) : null);
          } }, { key: "render", value: function() {
            var ke = this, Ie = this.props, Mt = Ie.depth, At = Ie.src, Qt = (Ie.namespace, Ie.name, Ie.type, Ie.parent_type), xt = Ie.theme, Rr = Ie.jsvRoot, wn = Ie.iconStyle, Ba = H(Ie, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), sa = this.state, Xi = sa.object_type, ma = sa.expanded, Wi = {};
            return Rr || Qt === "array_group" ? Qt === "array_group" && (Wi.borderLeft = 0, Wi.display = "inline") : Wi.paddingLeft = 5 * this.props.indentWidth, E.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
              return ke.setState(u(u({}, ke.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return ke.setState(u(u({}, ke.state), {}, { hovered: false }));
            } }, ye(xt, Rr ? "jsv-root" : "objectKeyVal", Wi)), this.getBraceStart(Xi, ma), ma ? this.getObjectContent(Mt, At, u({ theme: xt, iconStyle: wn }, Ba)) : this.getEllipsis(), E.a.createElement("span", { className: "brace-row" }, E.a.createElement("span", { style: u(u({}, ye(xt, "brace").style), {}, { paddingLeft: ma ? "3px" : "0px" }) }, Xi === "array" ? "]" : "}"), ma ? null : this.getObjectMetaData(At)));
          } }], [{ key: "getDerivedStateFromProps", value: function(ke, Ie) {
            var Mt = Ie.prevProps;
            return ke.src !== Mt.src || ke.collapsed !== Mt.collapsed || ke.name !== Mt.name || ke.namespace !== Mt.namespace || ke.rjvId !== Mt.rjvId ? u(u({}, Se.getState(ke)), {}, { prevProps: ke }) : null;
          } }]), Se;
        }(E.a.PureComponent);
        rh.getState = function(Be) {
          var $e = Object.keys(Be.src).length, Se = (Be.collapsed === false || Be.collapsed !== true && Be.collapsed > Be.depth) && (!Be.shouldCollapse || Be.shouldCollapse({ name: Be.name, src: Be.src, type: q3(Be.src), namespace: Be.namespace }) === false) && $e !== 0;
          return { expanded: Wr.get(Be.rjvId, Be.namespace, "expanded", Se), object_type: Be.type === "array" ? "array" : "object", parent_type: Be.type === "array" ? "array" : "object", size: $e, hovered: false };
        };
        var Mw = function Be($e, Se) {
          l2(this, Be), this.name = $e, this.value = Se, this.type = q3(Se);
        };
        U(rh);
        var qv = rh, Pw = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            var ke;
            l2(this, Se);
            for (var Ie = arguments.length, Mt = new Array(Ie), At = 0; At < Ie; At++)
              Mt[At] = arguments[At];
            return (ke = $e.call.apply($e, [this].concat(Mt))).render = function() {
              var Qt = b2(ke).props, xt = [Qt.name], Rr = qv;
              return Array.isArray(Qt.src) && Qt.groupArraysAfterLength && Qt.src.length > Qt.groupArraysAfterLength && (Rr = th), E.a.createElement("div", { className: "pretty-json-container object-container" }, E.a.createElement("div", { className: "object-content" }, E.a.createElement(Rr, Object.assign({ namespace: xt, depth: 0, jsvRoot: true }, Qt))));
            }, ke;
          }
          return Se;
        }(E.a.PureComponent), Dw = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).closeModal = function() {
              cn.dispatch({ rjvId: Ie.props.rjvId, name: "RESET" });
            }, Ie.submit = function() {
              Ie.props.submit(Ie.state.input);
            }, Ie.state = { input: ke.input ? ke.input : "" }, Ie;
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this, Ie = this.props, Mt = Ie.theme, At = Ie.rjvId, Qt = Ie.isValid, xt = this.state.input, Rr = Qt(xt);
            return E.a.createElement("div", Object.assign({ className: "key-modal-request" }, ye(Mt, "key-modal-request"), { onClick: this.closeModal }), E.a.createElement("div", Object.assign({}, ye(Mt, "key-modal"), { onClick: function(wn) {
              wn.stopPropagation();
            } }), E.a.createElement("div", ye(Mt, "key-modal-label"), "Key Name:"), E.a.createElement("div", { style: { position: "relative" } }, E.a.createElement("input", Object.assign({}, ye(Mt, "key-modal-input"), { className: "key-modal-input", ref: function(wn) {
              return wn && wn.focus();
            }, spellCheck: false, value: xt, placeholder: "...", onChange: function(wn) {
              ke.setState({ input: wn.target.value });
            }, onKeyPress: function(wn) {
              Rr && wn.key === "Enter" ? ke.submit() : wn.key === "Escape" && ke.closeModal();
            } })), Rr ? E.a.createElement(as, Object.assign({}, ye(Mt, "key-modal-submit"), { className: "key-modal-submit", onClick: function(wn) {
              return ke.submit();
            } })) : null), E.a.createElement("span", ye(Mt, "key-modal-cancel"), E.a.createElement(hc, Object.assign({}, ye(Mt, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
              cn.dispatch({ rjvId: At, name: "RESET" });
            } })))));
          } }]), Se;
        }(E.a.PureComponent), Iw = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            var ke;
            l2(this, Se);
            for (var Ie = arguments.length, Mt = new Array(Ie), At = 0; At < Ie; At++)
              Mt[At] = arguments[At];
            return (ke = $e.call.apply($e, [this].concat(Mt))).isValid = function(Qt) {
              var xt = ke.props.rjvId, Rr = Wr.get(xt, "action", "new-key-request");
              return Qt != "" && Object.keys(Rr.existing_value).indexOf(Qt) === -1;
            }, ke.submit = function(Qt) {
              var xt = ke.props.rjvId, Rr = Wr.get(xt, "action", "new-key-request");
              Rr.new_value = u({}, Rr.existing_value), Rr.new_value[Qt] = ke.props.defaultValue, cn.dispatch({ name: "VARIABLE_ADDED", rjvId: xt, data: Rr });
            }, ke;
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.active, Mt = ke.theme, At = ke.rjvId;
            return Ie ? E.a.createElement(Dw, { rjvId: At, theme: Mt, isValid: this.isValid, submit: this.submit }) : null;
          } }]), Se;
        }(E.a.PureComponent), Lw = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se() {
            return l2(this, Se), $e.apply(this, arguments);
          }
          return f2(Se, [{ key: "render", value: function() {
            var ke = this.props, Ie = ke.message, Mt = ke.active, At = ke.theme, Qt = ke.rjvId;
            return Mt ? E.a.createElement("div", Object.assign({ className: "validation-failure" }, ye(At, "validation-failure"), { onClick: function() {
              cn.dispatch({ rjvId: Qt, name: "RESET" });
            } }), E.a.createElement("span", ye(At, "validation-failure-label"), Ie), E.a.createElement(hc, ye(At, "validation-failure-clear"))) : null;
          } }]), Se;
        }(E.a.PureComponent), Fg = function(Be) {
          v9(Se, Be);
          var $e = C(Se);
          function Se(ke) {
            var Ie;
            return l2(this, Se), (Ie = $e.call(this, ke)).rjvId = Date.now().toString(), Ie.getListeners = function() {
              return { reset: Ie.resetState, "variable-update": Ie.updateSrc, "add-key-request": Ie.addKeyRequest };
            }, Ie.updateSrc = function() {
              var Mt, At = Wr.get(Ie.rjvId, "action", "variable-update"), Qt = At.name, xt = At.namespace, Rr = At.new_value, wn = At.existing_value, Ba = (At.variable_removed, At.updated_src), sa = At.type, Xi = Ie.props, ma = Xi.onEdit, Wi = Xi.onDelete, io = Xi.onAdd, kn = { existing_src: Ie.state.src, new_value: Rr, updated_src: Ba, name: Qt, namespace: xt, existing_value: wn };
              switch (sa) {
                case "variable-added":
                  Mt = io(kn);
                  break;
                case "variable-edited":
                  Mt = ma(kn);
                  break;
                case "variable-removed":
                  Mt = Wi(kn);
              }
              Mt !== false ? (Wr.set(Ie.rjvId, "global", "src", Ba), Ie.setState({ src: Ba })) : Ie.setState({ validationFailure: true });
            }, Ie.addKeyRequest = function() {
              Ie.setState({ addKeyRequest: true });
            }, Ie.resetState = function() {
              Ie.setState({ validationFailure: false, addKeyRequest: false });
            }, Ie.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Se.defaultProps.src, name: Se.defaultProps.name, theme: Se.defaultProps.theme, validationMessage: Se.defaultProps.validationMessage, prevSrc: Se.defaultProps.src, prevName: Se.defaultProps.name, prevTheme: Se.defaultProps.theme }, Ie;
          }
          return f2(Se, [{ key: "componentDidMount", value: function() {
            Wr.set(this.rjvId, "global", "src", this.state.src);
            var ke = this.getListeners();
            for (var Ie in ke)
              Wr.on(Ie + "-" + this.rjvId, ke[Ie]);
            this.setState({ addKeyRequest: false, editKeyRequest: false });
          } }, { key: "componentDidUpdate", value: function(ke, Ie) {
            Ie.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Ie.editKeyRequest !== false && this.setState({ editKeyRequest: false }), ke.src !== this.state.src && Wr.set(this.rjvId, "global", "src", this.state.src);
          } }, { key: "componentWillUnmount", value: function() {
            var ke = this.getListeners();
            for (var Ie in ke)
              Wr.removeListener(Ie + "-" + this.rjvId, ke[Ie]);
          } }, { key: "render", value: function() {
            var ke = this.state, Ie = ke.validationFailure, Mt = ke.validationMessage, At = ke.addKeyRequest, Qt = ke.theme, xt = ke.src, Rr = ke.name, wn = this.props, Ba = wn.style, sa = wn.defaultValue;
            return E.a.createElement("div", { className: "react-json-view", style: u(u({}, ye(Qt, "app-container").style), Ba) }, E.a.createElement(Lw, { message: Mt, active: Ie, theme: Qt, rjvId: this.rjvId }), E.a.createElement(Pw, Object.assign({}, this.props, { src: xt, name: Rr, theme: Qt, type: q3(xt), rjvId: this.rjvId })), E.a.createElement(Iw, { active: At, theme: Qt, rjvId: this.rjvId, defaultValue: sa }));
          } }], [{ key: "getDerivedStateFromProps", value: function(ke, Ie) {
            if (ke.src !== Ie.prevSrc || ke.name !== Ie.prevName || ke.theme !== Ie.prevTheme) {
              var Mt = { src: ke.src, name: ke.name, theme: ke.theme, validationMessage: ke.validationMessage, prevSrc: ke.src, prevName: ke.name, prevTheme: ke.theme };
              return Se.validateState(Mt);
            }
            return null;
          } }]), Se;
        }(E.a.PureComponent);
        Fg.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Fg.validateState = function(Be) {
          var $e = {};
          return q3(Be.theme) !== "object" || function(Se) {
            var ke = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
            if (q3(Se) === "object") {
              for (var Ie = 0; Ie < ke.length; Ie++)
                if (!(ke[Ie] in Se))
                  return false;
              return true;
            }
            return false;
          }(Be.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), $e.theme = "rjv-default"), q3(Be.src) !== "object" && q3(Be.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), $e.name = "ERROR", $e.src = { message: "src property must be a valid json object" }), u(u({}, Be), $e);
        }, U(Fg), a.default = Fg;
      }]);
    });
  })(qX);
  var p5e = Xre(qX.exports);
  const g5e = ({ id: r2, title: t2, chart: e2, option: n2 }) => {
    const { tool: a } = VN({}), i = M3({ global: true }), [o, { set: s }] = Gre(true);
    console.log("option", n2);
    const u = (l2) => {
      const { updated_src: c2 } = l2;
      e2 == null || e2.setOption(c2), a == null || a.add(r2, e2, c2, t2), i.emit("list");
    };
    return JMe("div", { children: [jx(a5e, { children: jx(u5e, { children: jx(c5e, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (l2) => {
      s(!l2);
    } }) }) }), jx("br", {}), n2 && jx(p5e, { src: n2, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: o, iconStyle: "triangle", enableClipboard: true, onEdit: u, onAdd: u, onDelete: u })] });
  };
  exports.EchartTool = d5e;
  exports.ReactEchartsJson = g5e;
  exports.useEcharts = AAe;
  exports.useEchartsTool = VN;
  exports.useEventEmitter = M3;
})(reactEchartsJson_cjs);
const EchartTool = () => {
  const event = useEventEmitter({
    global: true
  });
  const currentIndex = useRef(0);
  const {
    tool
  } = useEchartsTool({});
  useState(false);
  useState("right");
  const [chartList, setChartList] = useState([]);
  const [currentChart, setCurrentChart] = useState();
  event.useSubscription("list", () => {
    var _a2;
    if (tool == null ? void 0 : tool.list().length) {
      setCurrentChart((_a2 = tool == null ? void 0 : tool.list()) == null ? void 0 : _a2[currentIndex.current]);
      setChartList(tool == null ? void 0 : tool.list());
    }
  });
  return /* @__PURE__ */ jsx("div", {
    className: styles.container,
    children: false
  });
};
var index = "";
var main = { exports: {} };
(function(module, exports) {
  !function(e2, t2) {
    module.exports = t2(React__default);
  }(commonjsGlobal, function(e2) {
    return function(e3) {
      var t2 = {};
      function n2(a) {
        if (t2[a])
          return t2[a].exports;
        var r2 = t2[a] = { i: a, l: false, exports: {} };
        return e3[a].call(r2.exports, r2, r2.exports, n2), r2.l = true, r2.exports;
      }
      return n2.m = e3, n2.c = t2, n2.d = function(e4, t3, a) {
        n2.o(e4, t3) || Object.defineProperty(e4, t3, { enumerable: true, get: a });
      }, n2.r = function(e4) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e4, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e4, "__esModule", { value: true });
      }, n2.t = function(e4, t3) {
        if (1 & t3 && (e4 = n2(e4)), 8 & t3)
          return e4;
        if (4 & t3 && typeof e4 == "object" && e4 && e4.__esModule)
          return e4;
        var a = /* @__PURE__ */ Object.create(null);
        if (n2.r(a), Object.defineProperty(a, "default", { enumerable: true, value: e4 }), 2 & t3 && typeof e4 != "string")
          for (var r2 in e4)
            n2.d(a, r2, function(t4) {
              return e4[t4];
            }.bind(null, r2));
        return a;
      }, n2.n = function(e4) {
        var t3 = e4 && e4.__esModule ? function() {
          return e4.default;
        } : function() {
          return e4;
        };
        return n2.d(t3, "a", t3), t3;
      }, n2.o = function(e4, t3) {
        return Object.prototype.hasOwnProperty.call(e4, t3);
      }, n2.p = "", n2(n2.s = 48);
    }([function(t2, n2) {
      t2.exports = e2;
    }, function(e3, t2) {
      var n2 = e3.exports = { version: "2.6.12" };
      typeof __e == "number" && (__e = n2);
    }, function(e3, t2, n2) {
      var a = n2(26)("wks"), r2 = n2(17), o = n2(3).Symbol, i = typeof o == "function";
      (e3.exports = function(e4) {
        return a[e4] || (a[e4] = i && o[e4] || (i ? o : r2)("Symbol." + e4));
      }).store = a;
    }, function(e3, t2) {
      var n2 = e3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n2);
    }, function(e3, t2, n2) {
      e3.exports = !n2(8)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2) {
      var n2 = {}.hasOwnProperty;
      e3.exports = function(e4, t3) {
        return n2.call(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(16);
      e3.exports = n2(4) ? function(e4, t3, n3) {
        return a.f(e4, t3, r2(1, n3));
      } : function(e4, t3, n3) {
        return e4[t3] = n3, e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(35), o = n2(23), i = Object.defineProperty;
      t2.f = n2(4) ? Object.defineProperty : function(e4, t3, n3) {
        if (a(e4), t3 = o(t3, true), a(n3), r2)
          try {
            return i(e4, t3, n3);
          } catch (e5) {
          }
        if ("get" in n3 || "set" in n3)
          throw TypeError("Accessors not supported!");
        return "value" in n3 && (e4[t3] = n3.value), e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        try {
          return !!e4();
        } catch (e5) {
          return true;
        }
      };
    }, function(e3, t2, n2) {
      var a = n2(40), r2 = n2(22);
      e3.exports = function(e4) {
        return a(r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4) {
        if (!a(e4))
          throw TypeError(e4 + " is not an object!");
        return e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        return typeof e4 == "object" ? e4 !== null : typeof e4 == "function";
      };
    }, function(e3, t2) {
      e3.exports = {};
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27);
      e3.exports = Object.keys || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2) {
      e3.exports = true;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(53), i = n2(6), s = n2(5), c2 = function(e4, t3, n3) {
        var l2, u, f2, p2 = e4 & c2.F, d2 = e4 & c2.G, b2 = e4 & c2.S, h = e4 & c2.P, v4 = e4 & c2.B, m2 = e4 & c2.W, y2 = d2 ? r2 : r2[t3] || (r2[t3] = {}), g2 = y2.prototype, E = d2 ? a : b2 ? a[t3] : (a[t3] || {}).prototype;
        for (l2 in d2 && (n3 = t3), n3)
          (u = !p2 && E && E[l2] !== void 0) && s(y2, l2) || (f2 = u ? E[l2] : n3[l2], y2[l2] = d2 && typeof E[l2] != "function" ? n3[l2] : v4 && u ? o(f2, a) : m2 && E[l2] == f2 ? function(e5) {
            var t4 = function(t5, n4, a2) {
              if (this instanceof e5) {
                switch (arguments.length) {
                  case 0:
                    return new e5();
                  case 1:
                    return new e5(t5);
                  case 2:
                    return new e5(t5, n4);
                }
                return new e5(t5, n4, a2);
              }
              return e5.apply(this, arguments);
            };
            return t4.prototype = e5.prototype, t4;
          }(f2) : h && typeof f2 == "function" ? o(Function.call, f2) : f2, h && ((y2.virtual || (y2.virtual = {}))[l2] = f2, e4 & c2.R && g2 && !g2[l2] && i(g2, l2, f2)));
      };
      c2.F = 1, c2.G = 2, c2.S = 4, c2.P = 8, c2.B = 16, c2.W = 32, c2.U = 64, c2.R = 128, e3.exports = c2;
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { enumerable: !(1 & e4), configurable: !(2 & e4), writable: !(4 & e4), value: t3 };
      };
    }, function(e3, t2) {
      var n2 = 0, a = Math.random();
      e3.exports = function(e4) {
        return "Symbol(".concat(e4 === void 0 ? "" : e4, ")_", (++n2 + a).toString(36));
      };
    }, function(e3, t2, n2) {
      var a = n2(22);
      e3.exports = function(e4) {
        return Object(a(e4));
      };
    }, function(e3, t2) {
      t2.f = {}.propertyIsEnumerable;
    }, function(e3, t2, n2) {
      var a = n2(52)(true);
      n2(34)(String, "String", function(e4) {
        this._t = String(e4), this._i = 0;
      }, function() {
        var e4, t3 = this._t, n3 = this._i;
        return n3 >= t3.length ? { value: void 0, done: true } : (e4 = a(t3, n3), this._i += e4.length, { value: e4, done: false });
      });
    }, function(e3, t2) {
      var n2 = Math.ceil, a = Math.floor;
      e3.exports = function(e4) {
        return isNaN(e4 = +e4) ? 0 : (e4 > 0 ? a : n2)(e4);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (e4 == null)
          throw TypeError("Can't call method on  " + e4);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4, t3) {
        if (!a(e4))
          return e4;
        var n3, r2;
        if (t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (typeof (n3 = e4.valueOf) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (!t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e3, t2) {
      var n2 = {}.toString;
      e3.exports = function(e4) {
        return n2.call(e4).slice(8, -1);
      };
    }, function(e3, t2, n2) {
      var a = n2(26)("keys"), r2 = n2(17);
      e3.exports = function(e4) {
        return a[e4] || (a[e4] = r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(1), r2 = n2(3), o = r2["__core-js_shared__"] || (r2["__core-js_shared__"] = {});
      (e3.exports = function(e4, t3) {
        return o[e4] || (o[e4] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: a.version, mode: n2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, function(e3, t2) {
      e3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e3, t2, n2) {
      var a = n2(7).f, r2 = n2(5), o = n2(2)("toStringTag");
      e3.exports = function(e4, t3, n3) {
        e4 && !r2(e4 = n3 ? e4 : e4.prototype, o) && a(e4, o, { configurable: true, value: t3 });
      };
    }, function(e3, t2, n2) {
      n2(62);
      for (var a = n2(3), r2 = n2(6), o = n2(12), i = n2(2)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c2 = 0; c2 < s.length; c2++) {
        var l2 = s[c2], u = a[l2], f2 = u && u.prototype;
        f2 && !f2[i] && r2(f2, i, l2), o[l2] = o.Array;
      }
    }, function(e3, t2, n2) {
      t2.f = n2(2);
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(14), i = n2(30), s = n2(7).f;
      e3.exports = function(e4) {
        var t3 = r2.Symbol || (r2.Symbol = o ? {} : a.Symbol || {});
        e4.charAt(0) == "_" || e4 in t3 || s(t3, e4, { value: i.f(e4) });
      };
    }, function(e3, t2) {
      t2.f = Object.getOwnPropertySymbols;
    }, function(e3, t2) {
      e3.exports = function(e4, t3, n2) {
        return Math.min(Math.max(e4, t3), n2);
      };
    }, function(e3, t2, n2) {
      var a = n2(14), r2 = n2(15), o = n2(37), i = n2(6), s = n2(12), c2 = n2(55), l2 = n2(28), u = n2(61), f2 = n2(2)("iterator"), p2 = !([].keys && "next" in [].keys()), d2 = function() {
        return this;
      };
      e3.exports = function(e4, t3, n3, b2, h, v4, m2) {
        c2(n3, t3, b2);
        var y2, g2, E, j = function(e5) {
          if (!p2 && e5 in O)
            return O[e5];
          switch (e5) {
            case "keys":
            case "values":
              return function() {
                return new n3(this, e5);
              };
          }
          return function() {
            return new n3(this, e5);
          };
        }, x2 = t3 + " Iterator", _ = h == "values", k2 = false, O = e4.prototype, C = O[f2] || O["@@iterator"] || h && O[h], S = C || j(h), w2 = h ? _ ? j("entries") : S : void 0, A2 = t3 == "Array" && O.entries || C;
        if (A2 && (E = u(A2.call(new e4()))) !== Object.prototype && E.next && (l2(E, x2, true), a || typeof E[f2] == "function" || i(E, f2, d2)), _ && C && C.name !== "values" && (k2 = true, S = function() {
          return C.call(this);
        }), a && !m2 || !p2 && !k2 && O[f2] || i(O, f2, S), s[t3] = S, s[x2] = d2, h)
          if (y2 = { values: _ ? S : j("values"), keys: v4 ? S : j("keys"), entries: w2 }, m2)
            for (g2 in y2)
              g2 in O || o(O, g2, y2[g2]);
          else
            r2(r2.P + r2.F * (p2 || k2), t3, y2);
        return y2;
      };
    }, function(e3, t2, n2) {
      e3.exports = !n2(4) && !n2(8)(function() {
        return Object.defineProperty(n2(36)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2, n2) {
      var a = n2(11), r2 = n2(3).document, o = a(r2) && a(r2.createElement);
      e3.exports = function(e4) {
        return o ? r2.createElement(e4) : {};
      };
    }, function(e3, t2, n2) {
      e3.exports = n2(6);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(56), o = n2(27), i = n2(25)("IE_PROTO"), s = function() {
      }, c2 = function() {
        var e4, t3 = n2(36)("iframe"), a2 = o.length;
        for (t3.style.display = "none", n2(60).appendChild(t3), t3.src = "javascript:", (e4 = t3.contentWindow.document).open(), e4.write("<script>document.F=Object<\/script>"), e4.close(), c2 = e4.F; a2--; )
          delete c2.prototype[o[a2]];
        return c2();
      };
      e3.exports = Object.create || function(e4, t3) {
        var n3;
        return e4 !== null ? (s.prototype = a(e4), n3 = new s(), s.prototype = null, n3[i] = e4) : n3 = c2(), t3 === void 0 ? n3 : r2(n3, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(9), o = n2(57)(false), i = n2(25)("IE_PROTO");
      e3.exports = function(e4, t3) {
        var n3, s = r2(e4), c2 = 0, l2 = [];
        for (n3 in s)
          n3 != i && a(s, n3) && l2.push(n3);
        for (; t3.length > c2; )
          a(s, n3 = t3[c2++]) && (~o(l2, n3) || l2.push(n3));
        return l2;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e4) {
        return a(e4) == "String" ? e4.split("") : Object(e4);
      };
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27).concat("length", "prototype");
      t2.f = Object.getOwnPropertyNames || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2, n2) {
      var a = n2(24), r2 = n2(2)("toStringTag"), o = a(function() {
        return arguments;
      }()) == "Arguments";
      e3.exports = function(e4) {
        var t3, n3, i;
        return e4 === void 0 ? "Undefined" : e4 === null ? "Null" : typeof (n3 = function(e5, t4) {
          try {
            return e5[t4];
          } catch (e6) {
          }
        }(t3 = Object(e4), r2)) == "string" ? n3 : o ? a(t3) : (i = a(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : i;
      };
    }, function(e3, t2) {
      var n2;
      n2 = function() {
        return this;
      }();
      try {
        n2 = n2 || new Function("return this")();
      } catch (e4) {
        typeof window == "object" && (n2 = window);
      }
      e3.exports = n2;
    }, function(e3, t2) {
      var n2 = /-?\d+(\.\d+)?%?/g;
      e3.exports = function(e4) {
        return e4.match(n2);
      };
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.getBase16Theme = t2.createStyling = t2.invertTheme = void 0;
      var a = d2(n2(49)), r2 = d2(n2(76)), o = d2(n2(81)), i = d2(n2(89)), s = d2(n2(93)), c2 = function(e4) {
        if (e4 && e4.__esModule)
          return e4;
        var t3 = {};
        if (e4 != null)
          for (var n3 in e4)
            Object.prototype.hasOwnProperty.call(e4, n3) && (t3[n3] = e4[n3]);
        return t3.default = e4, t3;
      }(n2(94)), l2 = d2(n2(132)), u = d2(n2(133)), f2 = d2(n2(138)), p2 = n2(139);
      function d2(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      var b2 = c2.default, h = (0, i.default)(b2), v4 = (0, f2.default)(u.default, p2.rgb2yuv, function(e4) {
        var t3, n3 = (0, o.default)(e4, 3), a2 = n3[0], r3 = n3[1], i2 = n3[2];
        return [(t3 = a2, t3 < 0.25 ? 1 : t3 < 0.5 ? 0.9 - t3 : 1.1 - t3), r3, i2];
      }, p2.yuv2rgb, l2.default), m2 = function(e4) {
        return function(t3) {
          return { className: [t3.className, e4.className].filter(Boolean).join(" "), style: (0, r2.default)({}, t3.style || {}, e4.style || {}) };
        };
      }, y2 = function(e4, t3) {
        var n3 = (0, i.default)(t3);
        for (var o2 in e4)
          n3.indexOf(o2) === -1 && n3.push(o2);
        return n3.reduce(function(n4, o3) {
          return n4[o3] = function(e5, t4) {
            if (e5 === void 0)
              return t4;
            if (t4 === void 0)
              return e5;
            var n5 = e5 === void 0 ? "undefined" : (0, a.default)(e5), o4 = t4 === void 0 ? "undefined" : (0, a.default)(t4);
            switch (n5) {
              case "string":
                switch (o4) {
                  case "string":
                    return [t4, e5].filter(Boolean).join(" ");
                  case "object":
                    return m2({ className: e5, style: t4 });
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ className: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "object":
                switch (o4) {
                  case "string":
                    return m2({ className: t4, style: e5 });
                  case "object":
                    return (0, r2.default)({}, t4, e5);
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ style: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "function":
                switch (o4) {
                  case "string":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ className: t4 })].concat(r3));
                    };
                  case "object":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ style: t4 })].concat(r3));
                    };
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [t4.apply(void 0, [n6].concat(r3))].concat(r3));
                    };
                }
            }
          }(e4[o3], t3[o3]), n4;
        }, {});
      }, g2 = function(e4, t3) {
        for (var n3 = arguments.length, o2 = Array(n3 > 2 ? n3 - 2 : 0), s2 = 2; s2 < n3; s2++)
          o2[s2 - 2] = arguments[s2];
        if (t3 === null)
          return e4;
        Array.isArray(t3) || (t3 = [t3]);
        var c3 = t3.map(function(t4) {
          return e4[t4];
        }).filter(Boolean), l3 = c3.reduce(function(e5, t4) {
          return typeof t4 == "string" ? e5.className = [e5.className, t4].filter(Boolean).join(" ") : (t4 === void 0 ? "undefined" : (0, a.default)(t4)) === "object" ? e5.style = (0, r2.default)({}, e5.style, t4) : typeof t4 == "function" && (e5 = (0, r2.default)({}, e5, t4.apply(void 0, [e5].concat(o2)))), e5;
        }, { className: "", style: {} });
        return l3.className || delete l3.className, (0, i.default)(l3.style).length === 0 && delete l3.style, l3;
      }, E = t2.invertTheme = function(e4) {
        return (0, i.default)(e4).reduce(function(t3, n3) {
          return t3[n3] = /^base/.test(n3) ? v4(e4[n3]) : n3 === "scheme" ? e4[n3] + ":inverted" : e4[n3], t3;
        }, {});
      }, j = (t2.createStyling = (0, s.default)(function(e4) {
        for (var t3 = arguments.length, n3 = Array(t3 > 3 ? t3 - 3 : 0), a2 = 3; a2 < t3; a2++)
          n3[a2 - 3] = arguments[a2];
        var o2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, c3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, l3 = o2.defaultBase16, u2 = l3 === void 0 ? b2 : l3, f3 = o2.base16Themes, p3 = f3 === void 0 ? null : f3, d3 = j(c3, p3);
        d3 && (c3 = (0, r2.default)({}, d3, c3));
        var v5 = h.reduce(function(e5, t4) {
          return e5[t4] = c3[t4] || u2[t4], e5;
        }, {}), m3 = (0, i.default)(c3).reduce(function(e5, t4) {
          return h.indexOf(t4) === -1 ? (e5[t4] = c3[t4], e5) : e5;
        }, {}), E2 = e4(v5), x2 = y2(m3, E2);
        return (0, s.default)(g2, 2).apply(void 0, [x2].concat(n3));
      }, 3), t2.getBase16Theme = function(e4, t3) {
        if (e4 && e4.extend && (e4 = e4.extend), typeof e4 == "string") {
          var n3 = e4.split(":"), a2 = (0, o.default)(n3, 2), r3 = a2[0], i2 = a2[1];
          e4 = (t3 || {})[r3] || c2[r3], i2 === "inverted" && (e4 = E(e4));
        }
        return e4 && e4.hasOwnProperty("base00") ? e4 : void 0;
      });
    }, function(e3, t2, n2) {
      var a, r2 = typeof Reflect == "object" ? Reflect : null, o = r2 && typeof r2.apply == "function" ? r2.apply : function(e4, t3, n3) {
        return Function.prototype.apply.call(e4, t3, n3);
      };
      a = r2 && typeof r2.ownKeys == "function" ? r2.ownKeys : Object.getOwnPropertySymbols ? function(e4) {
        return Object.getOwnPropertyNames(e4).concat(Object.getOwnPropertySymbols(e4));
      } : function(e4) {
        return Object.getOwnPropertyNames(e4);
      };
      var i = Number.isNaN || function(e4) {
        return e4 != e4;
      };
      function s() {
        s.init.call(this);
      }
      e3.exports = s, e3.exports.once = function(e4, t3) {
        return new Promise(function(n3, a2) {
          function r3() {
            o2 !== void 0 && e4.removeListener("error", o2), n3([].slice.call(arguments));
          }
          var o2;
          t3 !== "error" && (o2 = function(n4) {
            e4.removeListener(t3, r3), a2(n4);
          }, e4.once("error", o2)), e4.once(t3, r3);
        });
      }, s.EventEmitter = s, s.prototype._events = void 0, s.prototype._eventsCount = 0, s.prototype._maxListeners = void 0;
      var c2 = 10;
      function l2(e4) {
        if (typeof e4 != "function")
          throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e4);
      }
      function u(e4) {
        return e4._maxListeners === void 0 ? s.defaultMaxListeners : e4._maxListeners;
      }
      function f2(e4, t3, n3, a2) {
        var r3, o2, i2, s2;
        if (l2(n3), (o2 = e4._events) === void 0 ? (o2 = e4._events = /* @__PURE__ */ Object.create(null), e4._eventsCount = 0) : (o2.newListener !== void 0 && (e4.emit("newListener", t3, n3.listener ? n3.listener : n3), o2 = e4._events), i2 = o2[t3]), i2 === void 0)
          i2 = o2[t3] = n3, ++e4._eventsCount;
        else if (typeof i2 == "function" ? i2 = o2[t3] = a2 ? [n3, i2] : [i2, n3] : a2 ? i2.unshift(n3) : i2.push(n3), (r3 = u(e4)) > 0 && i2.length > r3 && !i2.warned) {
          i2.warned = true;
          var c3 = new Error("Possible EventEmitter memory leak detected. " + i2.length + " " + String(t3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
          c3.name = "MaxListenersExceededWarning", c3.emitter = e4, c3.type = t3, c3.count = i2.length, s2 = c3, console && console.warn && console.warn(s2);
        }
        return e4;
      }
      function p2() {
        if (!this.fired)
          return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
      }
      function d2(e4, t3, n3) {
        var a2 = { fired: false, wrapFn: void 0, target: e4, type: t3, listener: n3 }, r3 = p2.bind(a2);
        return r3.listener = n3, a2.wrapFn = r3, r3;
      }
      function b2(e4, t3, n3) {
        var a2 = e4._events;
        if (a2 === void 0)
          return [];
        var r3 = a2[t3];
        return r3 === void 0 ? [] : typeof r3 == "function" ? n3 ? [r3.listener || r3] : [r3] : n3 ? function(e5) {
          for (var t4 = new Array(e5.length), n4 = 0; n4 < t4.length; ++n4)
            t4[n4] = e5[n4].listener || e5[n4];
          return t4;
        }(r3) : v4(r3, r3.length);
      }
      function h(e4) {
        var t3 = this._events;
        if (t3 !== void 0) {
          var n3 = t3[e4];
          if (typeof n3 == "function")
            return 1;
          if (n3 !== void 0)
            return n3.length;
        }
        return 0;
      }
      function v4(e4, t3) {
        for (var n3 = new Array(t3), a2 = 0; a2 < t3; ++a2)
          n3[a2] = e4[a2];
        return n3;
      }
      Object.defineProperty(s, "defaultMaxListeners", { enumerable: true, get: function() {
        return c2;
      }, set: function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        c2 = e4;
      } }), s.init = function() {
        this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
      }, s.prototype.setMaxListeners = function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        return this._maxListeners = e4, this;
      }, s.prototype.getMaxListeners = function() {
        return u(this);
      }, s.prototype.emit = function(e4) {
        for (var t3 = [], n3 = 1; n3 < arguments.length; n3++)
          t3.push(arguments[n3]);
        var a2 = e4 === "error", r3 = this._events;
        if (r3 !== void 0)
          a2 = a2 && r3.error === void 0;
        else if (!a2)
          return false;
        if (a2) {
          var i2;
          if (t3.length > 0 && (i2 = t3[0]), i2 instanceof Error)
            throw i2;
          var s2 = new Error("Unhandled error." + (i2 ? " (" + i2.message + ")" : ""));
          throw s2.context = i2, s2;
        }
        var c3 = r3[e4];
        if (c3 === void 0)
          return false;
        if (typeof c3 == "function")
          o(c3, this, t3);
        else {
          var l3 = c3.length, u2 = v4(c3, l3);
          for (n3 = 0; n3 < l3; ++n3)
            o(u2[n3], this, t3);
        }
        return true;
      }, s.prototype.addListener = function(e4, t3) {
        return f2(this, e4, t3, false);
      }, s.prototype.on = s.prototype.addListener, s.prototype.prependListener = function(e4, t3) {
        return f2(this, e4, t3, true);
      }, s.prototype.once = function(e4, t3) {
        return l2(t3), this.on(e4, d2(this, e4, t3)), this;
      }, s.prototype.prependOnceListener = function(e4, t3) {
        return l2(t3), this.prependListener(e4, d2(this, e4, t3)), this;
      }, s.prototype.removeListener = function(e4, t3) {
        var n3, a2, r3, o2, i2;
        if (l2(t3), (a2 = this._events) === void 0)
          return this;
        if ((n3 = a2[e4]) === void 0)
          return this;
        if (n3 === t3 || n3.listener === t3)
          --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a2[e4], a2.removeListener && this.emit("removeListener", e4, n3.listener || t3));
        else if (typeof n3 != "function") {
          for (r3 = -1, o2 = n3.length - 1; o2 >= 0; o2--)
            if (n3[o2] === t3 || n3[o2].listener === t3) {
              i2 = n3[o2].listener, r3 = o2;
              break;
            }
          if (r3 < 0)
            return this;
          r3 === 0 ? n3.shift() : function(e5, t4) {
            for (; t4 + 1 < e5.length; t4++)
              e5[t4] = e5[t4 + 1];
            e5.pop();
          }(n3, r3), n3.length === 1 && (a2[e4] = n3[0]), a2.removeListener !== void 0 && this.emit("removeListener", e4, i2 || t3);
        }
        return this;
      }, s.prototype.off = s.prototype.removeListener, s.prototype.removeAllListeners = function(e4) {
        var t3, n3, a2;
        if ((n3 = this._events) === void 0)
          return this;
        if (n3.removeListener === void 0)
          return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : n3[e4] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete n3[e4]), this;
        if (arguments.length === 0) {
          var r3, o2 = Object.keys(n3);
          for (a2 = 0; a2 < o2.length; ++a2)
            (r3 = o2[a2]) !== "removeListener" && this.removeAllListeners(r3);
          return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
        }
        if (typeof (t3 = n3[e4]) == "function")
          this.removeListener(e4, t3);
        else if (t3 !== void 0)
          for (a2 = t3.length - 1; a2 >= 0; a2--)
            this.removeListener(e4, t3[a2]);
        return this;
      }, s.prototype.listeners = function(e4) {
        return b2(this, e4, true);
      }, s.prototype.rawListeners = function(e4) {
        return b2(this, e4, false);
      }, s.listenerCount = function(e4, t3) {
        return typeof e4.listenerCount == "function" ? e4.listenerCount(t3) : h.call(e4, t3);
      }, s.prototype.listenerCount = h, s.prototype.eventNames = function() {
        return this._eventsCount > 0 ? a(this._events) : [];
      };
    }, function(e3, t2, n2) {
      e3.exports.Dispatcher = n2(140);
    }, function(e3, t2, n2) {
      e3.exports = n2(142);
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = i(n2(50)), r2 = i(n2(65)), o = typeof r2.default == "function" && typeof a.default == "symbol" ? function(e4) {
        return typeof e4;
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : typeof e4;
      };
      function i(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = typeof r2.default == "function" && o(a.default) === "symbol" ? function(e4) {
        return e4 === void 0 ? "undefined" : o(e4);
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : e4 === void 0 ? "undefined" : o(e4);
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(51), __esModule: true };
    }, function(e3, t2, n2) {
      n2(20), n2(29), e3.exports = n2(30).f("iterator");
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = n2(22);
      e3.exports = function(e4) {
        return function(t3, n3) {
          var o, i, s = String(r2(t3)), c2 = a(n3), l2 = s.length;
          return c2 < 0 || c2 >= l2 ? e4 ? "" : void 0 : (o = s.charCodeAt(c2)) < 55296 || o > 56319 || c2 + 1 === l2 || (i = s.charCodeAt(c2 + 1)) < 56320 || i > 57343 ? e4 ? s.charAt(c2) : o : e4 ? s.slice(c2, c2 + 2) : i - 56320 + (o - 55296 << 10) + 65536;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(54);
      e3.exports = function(e4, t3, n3) {
        if (a(e4), t3 === void 0)
          return e4;
        switch (n3) {
          case 1:
            return function(n4) {
              return e4.call(t3, n4);
            };
          case 2:
            return function(n4, a2) {
              return e4.call(t3, n4, a2);
            };
          case 3:
            return function(n4, a2, r2) {
              return e4.call(t3, n4, a2, r2);
            };
        }
        return function() {
          return e4.apply(t3, arguments);
        };
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (typeof e4 != "function")
          throw TypeError(e4 + " is not a function!");
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(38), r2 = n2(16), o = n2(28), i = {};
      n2(6)(i, n2(2)("iterator"), function() {
        return this;
      }), e3.exports = function(e4, t3, n3) {
        e4.prototype = a(i, { next: r2(1, n3) }), o(e4, t3 + " Iterator");
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(10), o = n2(13);
      e3.exports = n2(4) ? Object.defineProperties : function(e4, t3) {
        r2(e4);
        for (var n3, i = o(t3), s = i.length, c2 = 0; s > c2; )
          a.f(e4, n3 = i[c2++], t3[n3]);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(58), o = n2(59);
      e3.exports = function(e4) {
        return function(t3, n3, i) {
          var s, c2 = a(t3), l2 = r2(c2.length), u = o(i, l2);
          if (e4 && n3 != n3) {
            for (; l2 > u; )
              if ((s = c2[u++]) != s)
                return true;
          } else
            for (; l2 > u; u++)
              if ((e4 || u in c2) && c2[u] === n3)
                return e4 || u || 0;
          return !e4 && -1;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.min;
      e3.exports = function(e4) {
        return e4 > 0 ? r2(a(e4), 9007199254740991) : 0;
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.max, o = Math.min;
      e3.exports = function(e4, t3) {
        return (e4 = a(e4)) < 0 ? r2(e4 + t3, 0) : o(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(3).document;
      e3.exports = a && a.documentElement;
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(18), o = n2(25)("IE_PROTO"), i = Object.prototype;
      e3.exports = Object.getPrototypeOf || function(e4) {
        return e4 = r2(e4), a(e4, o) ? e4[o] : typeof e4.constructor == "function" && e4 instanceof e4.constructor ? e4.constructor.prototype : e4 instanceof Object ? i : null;
      };
    }, function(e3, t2, n2) {
      var a = n2(63), r2 = n2(64), o = n2(12), i = n2(9);
      e3.exports = n2(34)(Array, "Array", function(e4, t3) {
        this._t = i(e4), this._i = 0, this._k = t3;
      }, function() {
        var e4 = this._t, t3 = this._k, n3 = this._i++;
        return !e4 || n3 >= e4.length ? (this._t = void 0, r2(1)) : r2(0, t3 == "keys" ? n3 : t3 == "values" ? e4[n3] : [n3, e4[n3]]);
      }, "values"), o.Arguments = o.Array, a("keys"), a("values"), a("entries");
    }, function(e3, t2) {
      e3.exports = function() {
      };
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { value: t3, done: !!e4 };
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(66), __esModule: true };
    }, function(e3, t2, n2) {
      n2(67), n2(73), n2(74), n2(75), e3.exports = n2(1).Symbol;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(5), o = n2(4), i = n2(15), s = n2(37), c2 = n2(68).KEY, l2 = n2(8), u = n2(26), f2 = n2(28), p2 = n2(17), d2 = n2(2), b2 = n2(30), h = n2(31), v4 = n2(69), m2 = n2(70), y2 = n2(10), g2 = n2(11), E = n2(18), j = n2(9), x2 = n2(23), _ = n2(16), k2 = n2(38), O = n2(71), C = n2(72), S = n2(32), w2 = n2(7), A2 = n2(13), M = C.f, P = w2.f, F = O.f, D = a.Symbol, I = a.JSON, R = I && I.stringify, L = d2("_hidden"), B = d2("toPrimitive"), N = {}.propertyIsEnumerable, z2 = u("symbol-registry"), T = u("symbols"), q2 = u("op-symbols"), V = Object.prototype, K = typeof D == "function" && !!S.f, W = a.QObject, H = !W || !W.prototype || !W.prototype.findChild, U = o && l2(function() {
        return k2(P({}, "a", { get: function() {
          return P(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e4, t3, n3) {
        var a2 = M(V, t3);
        a2 && delete V[t3], P(e4, t3, n3), a2 && e4 !== V && P(V, t3, a2);
      } : P, G = function(e4) {
        var t3 = T[e4] = k2(D.prototype);
        return t3._k = e4, t3;
      }, J = K && typeof D.iterator == "symbol" ? function(e4) {
        return typeof e4 == "symbol";
      } : function(e4) {
        return e4 instanceof D;
      }, Y = function(e4, t3, n3) {
        return e4 === V && Y(q2, t3, n3), y2(e4), t3 = x2(t3, true), y2(n3), r2(T, t3) ? (n3.enumerable ? (r2(e4, L) && e4[L][t3] && (e4[L][t3] = false), n3 = k2(n3, { enumerable: _(0, false) })) : (r2(e4, L) || P(e4, L, _(1, {})), e4[L][t3] = true), U(e4, t3, n3)) : P(e4, t3, n3);
      }, $ = function(e4, t3) {
        y2(e4);
        for (var n3, a2 = v4(t3 = j(t3)), r3 = 0, o2 = a2.length; o2 > r3; )
          Y(e4, n3 = a2[r3++], t3[n3]);
        return e4;
      }, Q = function(e4) {
        var t3 = N.call(this, e4 = x2(e4, true));
        return !(this === V && r2(T, e4) && !r2(q2, e4)) && (!(t3 || !r2(this, e4) || !r2(T, e4) || r2(this, L) && this[L][e4]) || t3);
      }, Z = function(e4, t3) {
        if (e4 = j(e4), t3 = x2(t3, true), e4 !== V || !r2(T, t3) || r2(q2, t3)) {
          var n3 = M(e4, t3);
          return !n3 || !r2(T, t3) || r2(e4, L) && e4[L][t3] || (n3.enumerable = true), n3;
        }
      }, X = function(e4) {
        for (var t3, n3 = F(j(e4)), a2 = [], o2 = 0; n3.length > o2; )
          r2(T, t3 = n3[o2++]) || t3 == L || t3 == c2 || a2.push(t3);
        return a2;
      }, ee = function(e4) {
        for (var t3, n3 = e4 === V, a2 = F(n3 ? q2 : j(e4)), o2 = [], i2 = 0; a2.length > i2; )
          !r2(T, t3 = a2[i2++]) || n3 && !r2(V, t3) || o2.push(T[t3]);
        return o2;
      };
      K || (s((D = function() {
        if (this instanceof D)
          throw TypeError("Symbol is not a constructor!");
        var e4 = p2(arguments.length > 0 ? arguments[0] : void 0), t3 = function(n3) {
          this === V && t3.call(q2, n3), r2(this, L) && r2(this[L], e4) && (this[L][e4] = false), U(this, e4, _(1, n3));
        };
        return o && H && U(V, e4, { configurable: true, set: t3 }), G(e4);
      }).prototype, "toString", function() {
        return this._k;
      }), C.f = Z, w2.f = Y, n2(41).f = O.f = X, n2(19).f = Q, S.f = ee, o && !n2(14) && s(V, "propertyIsEnumerable", Q, true), b2.f = function(e4) {
        return G(d2(e4));
      }), i(i.G + i.W + i.F * !K, { Symbol: D });
      for (var te = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ne = 0; te.length > ne; )
        d2(te[ne++]);
      for (var ae = A2(d2.store), re = 0; ae.length > re; )
        h(ae[re++]);
      i(i.S + i.F * !K, "Symbol", { for: function(e4) {
        return r2(z2, e4 += "") ? z2[e4] : z2[e4] = D(e4);
      }, keyFor: function(e4) {
        if (!J(e4))
          throw TypeError(e4 + " is not a symbol!");
        for (var t3 in z2)
          if (z2[t3] === e4)
            return t3;
      }, useSetter: function() {
        H = true;
      }, useSimple: function() {
        H = false;
      } }), i(i.S + i.F * !K, "Object", { create: function(e4, t3) {
        return t3 === void 0 ? k2(e4) : $(k2(e4), t3);
      }, defineProperty: Y, defineProperties: $, getOwnPropertyDescriptor: Z, getOwnPropertyNames: X, getOwnPropertySymbols: ee });
      var oe = l2(function() {
        S.f(1);
      });
      i(i.S + i.F * oe, "Object", { getOwnPropertySymbols: function(e4) {
        return S.f(E(e4));
      } }), I && i(i.S + i.F * (!K || l2(function() {
        var e4 = D();
        return R([e4]) != "[null]" || R({ a: e4 }) != "{}" || R(Object(e4)) != "{}";
      })), "JSON", { stringify: function(e4) {
        for (var t3, n3, a2 = [e4], r3 = 1; arguments.length > r3; )
          a2.push(arguments[r3++]);
        if (n3 = t3 = a2[1], (g2(t3) || e4 !== void 0) && !J(e4))
          return m2(t3) || (t3 = function(e5, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e5, t4)), !J(t4))
              return t4;
          }), a2[1] = t3, R.apply(I, a2);
      } }), D.prototype[B] || n2(6)(D.prototype, B, D.prototype.valueOf), f2(D, "Symbol"), f2(Math, "Math", true), f2(a.JSON, "JSON", true);
    }, function(e3, t2, n2) {
      var a = n2(17)("meta"), r2 = n2(11), o = n2(5), i = n2(7).f, s = 0, c2 = Object.isExtensible || function() {
        return true;
      }, l2 = !n2(8)(function() {
        return c2(Object.preventExtensions({}));
      }), u = function(e4) {
        i(e4, a, { value: { i: "O" + ++s, w: {} } });
      }, f2 = e3.exports = { KEY: a, NEED: false, fastKey: function(e4, t3) {
        if (!r2(e4))
          return typeof e4 == "symbol" ? e4 : (typeof e4 == "string" ? "S" : "P") + e4;
        if (!o(e4, a)) {
          if (!c2(e4))
            return "F";
          if (!t3)
            return "E";
          u(e4);
        }
        return e4[a].i;
      }, getWeak: function(e4, t3) {
        if (!o(e4, a)) {
          if (!c2(e4))
            return true;
          if (!t3)
            return false;
          u(e4);
        }
        return e4[a].w;
      }, onFreeze: function(e4) {
        return l2 && f2.NEED && c2(e4) && !o(e4, a) && u(e4), e4;
      } };
    }, function(e3, t2, n2) {
      var a = n2(13), r2 = n2(32), o = n2(19);
      e3.exports = function(e4) {
        var t3 = a(e4), n3 = r2.f;
        if (n3)
          for (var i, s = n3(e4), c2 = o.f, l2 = 0; s.length > l2; )
            c2.call(e4, i = s[l2++]) && t3.push(i);
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Array.isArray || function(e4) {
        return a(e4) == "Array";
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(41).f, o = {}.toString, i = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      e3.exports.f = function(e4) {
        return i && o.call(e4) == "[object Window]" ? function(e5) {
          try {
            return r2(e5);
          } catch (e6) {
            return i.slice();
          }
        }(e4) : r2(a(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(19), r2 = n2(16), o = n2(9), i = n2(23), s = n2(5), c2 = n2(35), l2 = Object.getOwnPropertyDescriptor;
      t2.f = n2(4) ? l2 : function(e4, t3) {
        if (e4 = o(e4), t3 = i(t3, true), c2)
          try {
            return l2(e4, t3);
          } catch (e5) {
          }
        if (s(e4, t3))
          return r2(!a.f.call(e4, t3), e4[t3]);
      };
    }, function(e3, t2) {
    }, function(e3, t2, n2) {
      n2(31)("asyncIterator");
    }, function(e3, t2, n2) {
      n2(31)("observable");
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a, r2 = n2(77), o = (a = r2) && a.__esModule ? a : { default: a };
      t2.default = o.default || function(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3];
          for (var a2 in n3)
            Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
        }
        return e4;
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(78), __esModule: true };
    }, function(e3, t2, n2) {
      n2(79), e3.exports = n2(1).Object.assign;
    }, function(e3, t2, n2) {
      var a = n2(15);
      a(a.S + a.F, "Object", { assign: n2(80) });
    }, function(e3, t2, n2) {
      var a = n2(4), r2 = n2(13), o = n2(32), i = n2(19), s = n2(18), c2 = n2(40), l2 = Object.assign;
      e3.exports = !l2 || n2(8)(function() {
        var e4 = {}, t3 = {}, n3 = Symbol(), a2 = "abcdefghijklmnopqrst";
        return e4[n3] = 7, a2.split("").forEach(function(e5) {
          t3[e5] = e5;
        }), l2({}, e4)[n3] != 7 || Object.keys(l2({}, t3)).join("") != a2;
      }) ? function(e4, t3) {
        for (var n3 = s(e4), l3 = arguments.length, u = 1, f2 = o.f, p2 = i.f; l3 > u; )
          for (var d2, b2 = c2(arguments[u++]), h = f2 ? r2(b2).concat(f2(b2)) : r2(b2), v4 = h.length, m2 = 0; v4 > m2; )
            d2 = h[m2++], a && !p2.call(b2, d2) || (n3[d2] = b2[d2]);
        return n3;
      } : l2;
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = o(n2(82)), r2 = o(n2(85));
      function o(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = function(e4, t3) {
        if (Array.isArray(e4))
          return e4;
        if ((0, a.default)(Object(e4)))
          return function(e5, t4) {
            var n3 = [], a2 = true, o2 = false, i = void 0;
            try {
              for (var s, c2 = (0, r2.default)(e5); !(a2 = (s = c2.next()).done) && (n3.push(s.value), !t4 || n3.length !== t4); a2 = true)
                ;
            } catch (e6) {
              o2 = true, i = e6;
            } finally {
              try {
                !a2 && c2.return && c2.return();
              } finally {
                if (o2)
                  throw i;
              }
            }
            return n3;
          }(e4, t3);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(83), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(84);
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).isIterable = function(e4) {
        var t3 = Object(e4);
        return t3[r2] !== void 0 || "@@iterator" in t3 || o.hasOwnProperty(a(t3));
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(86), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(87);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(88);
      e3.exports = n2(1).getIterator = function(e4) {
        var t3 = r2(e4);
        if (typeof t3 != "function")
          throw TypeError(e4 + " is not iterable!");
        return a(t3.call(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).getIteratorMethod = function(e4) {
        if (e4 != null)
          return e4[r2] || e4["@@iterator"] || o[a(e4)];
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(90), __esModule: true };
    }, function(e3, t2, n2) {
      n2(91), e3.exports = n2(1).Object.keys;
    }, function(e3, t2, n2) {
      var a = n2(18), r2 = n2(13);
      n2(92)("keys", function() {
        return function(e4) {
          return r2(a(e4));
        };
      });
    }, function(e3, t2, n2) {
      var a = n2(15), r2 = n2(1), o = n2(8);
      e3.exports = function(e4, t3) {
        var n3 = (r2.Object || {})[e4] || Object[e4], i = {};
        i[e4] = t3(n3), a(a.S + a.F * o(function() {
          n3(1);
        }), "Object", i);
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], a = /^\s+|\s+$/g, r2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, o = /\{\n\/\* \[wrapped with (.+)\] \*/, i = /,? & /, s = /^[-+]0x[0-9a-f]+$/i, c2 = /^0b[01]+$/i, l2 = /^\[object .+?Constructor\]$/, u = /^0o[0-7]+$/i, f2 = /^(?:0|[1-9]\d*)$/, p2 = parseInt, d2 = typeof t3 == "object" && t3 && t3.Object === Object && t3, b2 = typeof self == "object" && self && self.Object === Object && self, h = d2 || b2 || Function("return this")();
        function v4(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function m2(e4, t4) {
          return !!(e4 ? e4.length : 0) && function(e5, t5, n4) {
            if (t5 != t5)
              return function(e6, t6, n5, a3) {
                var r4 = e6.length, o2 = n5 + (a3 ? 1 : -1);
                for (; a3 ? o2-- : ++o2 < r4; )
                  if (t6(e6[o2], o2, e6))
                    return o2;
                return -1;
              }(e5, y2, n4);
            var a2 = n4 - 1, r3 = e5.length;
            for (; ++a2 < r3; )
              if (e5[a2] === t5)
                return a2;
            return -1;
          }(e4, t4, 0) > -1;
        }
        function y2(e4) {
          return e4 != e4;
        }
        function g2(e4, t4) {
          for (var n4 = e4.length, a2 = 0; n4--; )
            e4[n4] === t4 && a2++;
          return a2;
        }
        function E(e4, t4) {
          for (var n4 = -1, a2 = e4.length, r3 = 0, o2 = []; ++n4 < a2; ) {
            var i2 = e4[n4];
            i2 !== t4 && i2 !== "__lodash_placeholder__" || (e4[n4] = "__lodash_placeholder__", o2[r3++] = n4);
          }
          return o2;
        }
        var j, x2, _, k2 = Function.prototype, O = Object.prototype, C = h["__core-js_shared__"], S = (j = /[^.]+$/.exec(C && C.keys && C.keys.IE_PROTO || "")) ? "Symbol(src)_1." + j : "", w2 = k2.toString, A2 = O.hasOwnProperty, M = O.toString, P = RegExp("^" + w2.call(A2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), F = Object.create, D = Math.max, I = Math.min, R = (x2 = H(Object, "defineProperty"), (_ = H.name) && _.length > 2 ? x2 : void 0);
        function L(e4) {
          return X(e4) ? F(e4) : {};
        }
        function B(e4) {
          return !(!X(e4) || function(e5) {
            return !!S && S in e5;
          }(e4)) && (function(e5) {
            var t4 = X(e5) ? M.call(e5) : "";
            return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
          }(e4) || function(e5) {
            var t4 = false;
            if (e5 != null && typeof e5.toString != "function")
              try {
                t4 = !!(e5 + "");
              } catch (e6) {
              }
            return t4;
          }(e4) ? P : l2).test(function(e5) {
            if (e5 != null) {
              try {
                return w2.call(e5);
              } catch (e6) {
              }
              try {
                return e5 + "";
              } catch (e6) {
              }
            }
            return "";
          }(e4));
        }
        function N(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = n4.length, s2 = -1, c3 = t4.length, l3 = D(o2 - i2, 0), u2 = Array(c3 + l3), f3 = !a2; ++s2 < c3; )
            u2[s2] = t4[s2];
          for (; ++r3 < i2; )
            (f3 || r3 < o2) && (u2[n4[r3]] = e4[r3]);
          for (; l3--; )
            u2[s2++] = e4[r3++];
          return u2;
        }
        function z2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = -1, s2 = n4.length, c3 = -1, l3 = t4.length, u2 = D(o2 - s2, 0), f3 = Array(u2 + l3), p3 = !a2; ++r3 < u2; )
            f3[r3] = e4[r3];
          for (var d3 = r3; ++c3 < l3; )
            f3[d3 + c3] = t4[c3];
          for (; ++i2 < s2; )
            (p3 || r3 < o2) && (f3[d3 + n4[i2]] = e4[r3++]);
          return f3;
        }
        function T(e4) {
          return function() {
            var t4 = arguments;
            switch (t4.length) {
              case 0:
                return new e4();
              case 1:
                return new e4(t4[0]);
              case 2:
                return new e4(t4[0], t4[1]);
              case 3:
                return new e4(t4[0], t4[1], t4[2]);
              case 4:
                return new e4(t4[0], t4[1], t4[2], t4[3]);
              case 5:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4]);
              case 6:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5]);
              case 7:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5], t4[6]);
            }
            var n4 = L(e4.prototype), a2 = e4.apply(n4, t4);
            return X(a2) ? a2 : n4;
          };
        }
        function q2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 128 & t4, f3 = 1 & t4, p3 = 2 & t4, d3 = 24 & t4, b3 = 512 & t4, v5 = p3 ? void 0 : T(e4);
          return function m3() {
            for (var y3 = arguments.length, j2 = Array(y3), x3 = y3; x3--; )
              j2[x3] = arguments[x3];
            if (d3)
              var _2 = W(m3), k3 = g2(j2, _2);
            if (a2 && (j2 = N(j2, a2, r3, d3)), o2 && (j2 = z2(j2, o2, i2, d3)), y3 -= k3, d3 && y3 < l3) {
              var O2 = E(j2, _2);
              return V(e4, t4, q2, m3.placeholder, n4, j2, O2, s2, c3, l3 - y3);
            }
            var C2 = f3 ? n4 : this, S2 = p3 ? C2[e4] : e4;
            return y3 = j2.length, s2 ? j2 = Y(j2, s2) : b3 && y3 > 1 && j2.reverse(), u2 && c3 < y3 && (j2.length = c3), this && this !== h && this instanceof m3 && (S2 = v5 || T(S2)), S2.apply(C2, j2);
          };
        }
        function V(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 8 & t4;
          t4 |= u2 ? 32 : 64, 4 & (t4 &= ~(u2 ? 64 : 32)) || (t4 &= -4);
          var f3 = n4(e4, t4, r3, u2 ? o2 : void 0, u2 ? i2 : void 0, u2 ? void 0 : o2, u2 ? void 0 : i2, s2, c3, l3);
          return f3.placeholder = a2, $(f3, e4, t4);
        }
        function K(e4, t4, n4, a2, r3, o2, i2, s2) {
          var c3 = 2 & t4;
          if (!c3 && typeof e4 != "function")
            throw new TypeError("Expected a function");
          var l3 = a2 ? a2.length : 0;
          if (l3 || (t4 &= -97, a2 = r3 = void 0), i2 = i2 === void 0 ? i2 : D(te(i2), 0), s2 = s2 === void 0 ? s2 : te(s2), l3 -= r3 ? r3.length : 0, 64 & t4) {
            var u2 = a2, f3 = r3;
            a2 = r3 = void 0;
          }
          var p3 = [e4, t4, n4, a2, r3, u2, f3, o2, i2, s2];
          if (e4 = p3[0], t4 = p3[1], n4 = p3[2], a2 = p3[3], r3 = p3[4], !(s2 = p3[9] = p3[9] == null ? c3 ? 0 : e4.length : D(p3[9] - l3, 0)) && 24 & t4 && (t4 &= -25), t4 && t4 != 1)
            d3 = t4 == 8 || t4 == 16 ? function(e5, t5, n5) {
              var a3 = T(e5);
              return function r4() {
                for (var o3 = arguments.length, i3 = Array(o3), s3 = o3, c4 = W(r4); s3--; )
                  i3[s3] = arguments[s3];
                var l4 = o3 < 3 && i3[0] !== c4 && i3[o3 - 1] !== c4 ? [] : E(i3, c4);
                if ((o3 -= l4.length) < n5)
                  return V(e5, t5, q2, r4.placeholder, void 0, i3, l4, void 0, void 0, n5 - o3);
                var u3 = this && this !== h && this instanceof r4 ? a3 : e5;
                return v4(u3, this, i3);
              };
            }(e4, t4, s2) : t4 != 32 && t4 != 33 || r3.length ? q2.apply(void 0, p3) : function(e5, t5, n5, a3) {
              var r4 = 1 & t5, o3 = T(e5);
              return function t6() {
                for (var i3 = -1, s3 = arguments.length, c4 = -1, l4 = a3.length, u3 = Array(l4 + s3), f4 = this && this !== h && this instanceof t6 ? o3 : e5; ++c4 < l4; )
                  u3[c4] = a3[c4];
                for (; s3--; )
                  u3[c4++] = arguments[++i3];
                return v4(f4, r4 ? n5 : this, u3);
              };
            }(e4, t4, n4, a2);
          else
            var d3 = function(e5, t5, n5) {
              var a3 = 1 & t5, r4 = T(e5);
              return function t6() {
                var o3 = this && this !== h && this instanceof t6 ? r4 : e5;
                return o3.apply(a3 ? n5 : this, arguments);
              };
            }(e4, t4, n4);
          return $(d3, e4, t4);
        }
        function W(e4) {
          return e4.placeholder;
        }
        function H(e4, t4) {
          var n4 = function(e5, t5) {
            return e5 == null ? void 0 : e5[t5];
          }(e4, t4);
          return B(n4) ? n4 : void 0;
        }
        function U(e4) {
          var t4 = e4.match(o);
          return t4 ? t4[1].split(i) : [];
        }
        function G(e4, t4) {
          var n4 = t4.length, a2 = n4 - 1;
          return t4[a2] = (n4 > 1 ? "& " : "") + t4[a2], t4 = t4.join(n4 > 2 ? ", " : " "), e4.replace(r2, "{\n/* [wrapped with " + t4 + "] */\n");
        }
        function J(e4, t4) {
          return !!(t4 = t4 == null ? 9007199254740991 : t4) && (typeof e4 == "number" || f2.test(e4)) && e4 > -1 && e4 % 1 == 0 && e4 < t4;
        }
        function Y(e4, t4) {
          for (var n4 = e4.length, a2 = I(t4.length, n4), r3 = function(e5, t5) {
            var n5 = -1, a3 = e5.length;
            for (t5 || (t5 = Array(a3)); ++n5 < a3; )
              t5[n5] = e5[n5];
            return t5;
          }(e4); a2--; ) {
            var o2 = t4[a2];
            e4[a2] = J(o2, n4) ? r3[o2] : void 0;
          }
          return e4;
        }
        var $ = R ? function(e4, t4, n4) {
          var a2, r3 = t4 + "";
          return R(e4, "toString", { configurable: true, enumerable: false, value: (a2 = G(r3, Q(U(r3), n4)), function() {
            return a2;
          }) });
        } : function(e4) {
          return e4;
        };
        function Q(e4, t4) {
          return function(e5, t5) {
            for (var n4 = -1, a2 = e5 ? e5.length : 0; ++n4 < a2 && t5(e5[n4], n4, e5) !== false; )
              ;
          }(n3, function(n4) {
            var a2 = "_." + n4[0];
            t4 & n4[1] && !m2(e4, a2) && e4.push(a2);
          }), e4.sort();
        }
        function Z(e4, t4, n4) {
          var a2 = K(e4, 8, void 0, void 0, void 0, void 0, void 0, t4 = n4 ? void 0 : t4);
          return a2.placeholder = Z.placeholder, a2;
        }
        function X(e4) {
          var t4 = typeof e4;
          return !!e4 && (t4 == "object" || t4 == "function");
        }
        function ee(e4) {
          return e4 ? (e4 = function(e5) {
            if (typeof e5 == "number")
              return e5;
            if (function(e6) {
              return typeof e6 == "symbol" || function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && M.call(e6) == "[object Symbol]";
            }(e5))
              return NaN;
            if (X(e5)) {
              var t4 = typeof e5.valueOf == "function" ? e5.valueOf() : e5;
              e5 = X(t4) ? t4 + "" : t4;
            }
            if (typeof e5 != "string")
              return e5 === 0 ? e5 : +e5;
            e5 = e5.replace(a, "");
            var n4 = c2.test(e5);
            return n4 || u.test(e5) ? p2(e5.slice(2), n4 ? 2 : 8) : s.test(e5) ? NaN : +e5;
          }(e4)) === 1 / 0 || e4 === -1 / 0 ? 17976931348623157e292 * (e4 < 0 ? -1 : 1) : e4 == e4 ? e4 : 0 : e4 === 0 ? e4 : 0;
        }
        function te(e4) {
          var t4 = ee(e4), n4 = t4 % 1;
          return t4 == t4 ? n4 ? t4 - n4 : t4 : 0;
        }
        Z.placeholder = {}, e3.exports = Z;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      function a(e4) {
        return e4 && e4.__esModule ? e4.default : e4;
      }
      t2.__esModule = true;
      var r2 = n2(95);
      t2.threezerotwofour = a(r2);
      var o = n2(96);
      t2.apathy = a(o);
      var i = n2(97);
      t2.ashes = a(i);
      var s = n2(98);
      t2.atelierDune = a(s);
      var c2 = n2(99);
      t2.atelierForest = a(c2);
      var l2 = n2(100);
      t2.atelierHeath = a(l2);
      var u = n2(101);
      t2.atelierLakeside = a(u);
      var f2 = n2(102);
      t2.atelierSeaside = a(f2);
      var p2 = n2(103);
      t2.bespin = a(p2);
      var d2 = n2(104);
      t2.brewer = a(d2);
      var b2 = n2(105);
      t2.bright = a(b2);
      var h = n2(106);
      t2.chalk = a(h);
      var v4 = n2(107);
      t2.codeschool = a(v4);
      var m2 = n2(108);
      t2.colors = a(m2);
      var y2 = n2(109);
      t2.default = a(y2);
      var g2 = n2(110);
      t2.eighties = a(g2);
      var E = n2(111);
      t2.embers = a(E);
      var j = n2(112);
      t2.flat = a(j);
      var x2 = n2(113);
      t2.google = a(x2);
      var _ = n2(114);
      t2.grayscale = a(_);
      var k2 = n2(115);
      t2.greenscreen = a(k2);
      var O = n2(116);
      t2.harmonic = a(O);
      var C = n2(117);
      t2.hopscotch = a(C);
      var S = n2(118);
      t2.isotope = a(S);
      var w2 = n2(119);
      t2.marrakesh = a(w2);
      var A2 = n2(120);
      t2.mocha = a(A2);
      var M = n2(121);
      t2.monokai = a(M);
      var P = n2(122);
      t2.ocean = a(P);
      var F = n2(123);
      t2.paraiso = a(F);
      var D = n2(124);
      t2.pop = a(D);
      var I = n2(125);
      t2.railscasts = a(I);
      var R = n2(126);
      t2.shapeshifter = a(R);
      var L = n2(127);
      t2.solarized = a(L);
      var B = n2(128);
      t2.summerfruit = a(B);
      var N = n2(129);
      t2.tomorrow = a(N);
      var z2 = n2(130);
      t2.tube = a(z2);
      var T = n2(131);
      t2.twilight = a(T);
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      var a = n2(33);
      function r2(e4) {
        var t3 = Math.round(a(e4, 0, 255)).toString(16);
        return t3.length == 1 ? "0" + t3 : t3;
      }
      e3.exports = function(e4) {
        var t3 = e4.length === 4 ? r2(255 * e4[3]) : "";
        return "#" + r2(e4[0]) + r2(e4[1]) + r2(e4[2]) + t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(134), r2 = n2(135), o = n2(136), i = n2(137);
      var s = { "#": r2, hsl: function(e4) {
        var t3 = a(e4), n3 = i(t3);
        return t3.length === 4 && n3.push(t3[3]), n3;
      }, rgb: o };
      function c2(e4) {
        for (var t3 in s)
          if (e4.indexOf(t3) === 0)
            return s[t3](e4);
      }
      c2.rgb = o, c2.hsl = a, c2.hex = r2, e3.exports = c2;
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        switch (e4 = parseFloat(e4), t3) {
          case 0:
            return r2(e4, 0, 360);
          case 1:
          case 2:
            return r2(e4, 0, 100);
          case 3:
            return r2(e4, 0, 1);
        }
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        e4.length !== 4 && e4.length !== 5 || (e4 = function(e5) {
          for (var t4 = "#", n3 = 1; n3 < e5.length; n3++) {
            var a = e5.charAt(n3);
            t4 += a + a;
          }
          return t4;
        }(e4));
        var t3 = [parseInt(e4.substring(1, 3), 16), parseInt(e4.substring(3, 5), 16), parseInt(e4.substring(5, 7), 16)];
        if (e4.length === 9) {
          var n2 = parseFloat((parseInt(e4.substring(7, 9), 16) / 255).toFixed(2));
          t3.push(n2);
        }
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        return t3 < 3 ? e4.indexOf("%") != -1 ? Math.round(255 * r2(parseInt(e4, 10), 0, 100) / 100) : r2(parseInt(e4, 10), 0, 255) : r2(parseFloat(e4), 0, 1);
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        var t3, n2, a, r2, o, i = e4[0] / 360, s = e4[1] / 100, c2 = e4[2] / 100;
        if (s == 0)
          return [o = 255 * c2, o, o];
        t3 = 2 * c2 - (n2 = c2 < 0.5 ? c2 * (1 + s) : c2 + s - c2 * s), r2 = [0, 0, 0];
        for (var l2 = 0; l2 < 3; l2++)
          (a = i + 1 / 3 * -(l2 - 1)) < 0 && a++, a > 1 && a--, o = 6 * a < 1 ? t3 + 6 * (n2 - t3) * a : 2 * a < 1 ? n2 : 3 * a < 2 ? t3 + (n2 - t3) * (2 / 3 - a) * 6 : t3, r2[l2] = 255 * o;
        return r2;
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = typeof t3 == "object" && t3 && t3.Object === Object && t3, a = typeof self == "object" && self && self.Object === Object && self, r2 = n3 || a || Function("return this")();
        function o(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function i(e4, t4) {
          for (var n4 = -1, a2 = t4.length, r3 = e4.length; ++n4 < a2; )
            e4[r3 + n4] = t4[n4];
          return e4;
        }
        var s = Object.prototype, c2 = s.hasOwnProperty, l2 = s.toString, u = r2.Symbol, f2 = s.propertyIsEnumerable, p2 = u ? u.isConcatSpreadable : void 0, d2 = Math.max;
        function b2(e4) {
          return h(e4) || function(e5) {
            return function(e6) {
              return function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && function(e7) {
                return e7 != null && function(e8) {
                  return typeof e8 == "number" && e8 > -1 && e8 % 1 == 0 && e8 <= 9007199254740991;
                }(e7.length) && !function(e8) {
                  var t4 = function(e9) {
                    var t5 = typeof e9;
                    return !!e9 && (t5 == "object" || t5 == "function");
                  }(e8) ? l2.call(e8) : "";
                  return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
                }(e7);
              }(e6);
            }(e5) && c2.call(e5, "callee") && (!f2.call(e5, "callee") || l2.call(e5) == "[object Arguments]");
          }(e4) || !!(p2 && e4 && e4[p2]);
        }
        var h = Array.isArray;
        var v4, m2, y2, g2 = (m2 = function(e4) {
          var t4 = (e4 = function e5(t5, n5, a2, r3, o2) {
            var s2 = -1, c3 = t5.length;
            for (a2 || (a2 = b2), o2 || (o2 = []); ++s2 < c3; ) {
              var l3 = t5[s2];
              n5 > 0 && a2(l3) ? n5 > 1 ? e5(l3, n5 - 1, a2, r3, o2) : i(o2, l3) : r3 || (o2[o2.length] = l3);
            }
            return o2;
          }(e4, 1)).length, n4 = t4;
          for (v4; n4--; )
            if (typeof e4[n4] != "function")
              throw new TypeError("Expected a function");
          return function() {
            for (var n5 = 0, a2 = t4 ? e4[n5].apply(this, arguments) : arguments[0]; ++n5 < t4; )
              a2 = e4[n5].call(this, a2);
            return a2;
          };
        }, y2 = d2(y2 === void 0 ? m2.length - 1 : y2, 0), function() {
          for (var e4 = arguments, t4 = -1, n4 = d2(e4.length - y2, 0), a2 = Array(n4); ++t4 < n4; )
            a2[t4] = e4[y2 + t4];
          t4 = -1;
          for (var r3 = Array(y2 + 1); ++t4 < y2; )
            r3[t4] = e4[t4];
          return r3[y2] = a2, o(m2, this, r3);
        });
        e3.exports = g2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.yuv2rgb = function(e4) {
        var t3, n3, a, r2 = e4[0], o = e4[1], i = e4[2];
        return t3 = 1 * r2 + 0 * o + 1.13983 * i, n3 = 1 * r2 + -0.39465 * o + -0.5806 * i, a = 1 * r2 + 2.02311 * o + 0 * i, t3 = Math.min(Math.max(0, t3), 1), n3 = Math.min(Math.max(0, n3), 1), a = Math.min(Math.max(0, a), 1), [255 * t3, 255 * n3, 255 * a];
      }, t2.rgb2yuv = function(e4) {
        var t3 = e4[0] / 255, n3 = e4[1] / 255, a = e4[2] / 255;
        return [0.299 * t3 + 0.587 * n3 + 0.114 * a, -0.14713 * t3 + -0.28886 * n3 + 0.436 * a, 0.615 * t3 + -0.51499 * n3 + -0.10001 * a];
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      var r2 = n2(141), o = function() {
        function e4() {
          a(this, "_callbacks", void 0), a(this, "_isDispatching", void 0), a(this, "_isHandled", void 0), a(this, "_isPending", void 0), a(this, "_lastID", void 0), a(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
        }
        var t3 = e4.prototype;
        return t3.register = function(e5) {
          var t4 = "ID_" + this._lastID++;
          return this._callbacks[t4] = e5, t4;
        }, t3.unregister = function(e5) {
          this._callbacks[e5] || r2(false), delete this._callbacks[e5];
        }, t3.waitFor = function(e5) {
          this._isDispatching || r2(false);
          for (var t4 = 0; t4 < e5.length; t4++) {
            var n3 = e5[t4];
            this._isPending[n3] ? this._isHandled[n3] || r2(false) : (this._callbacks[n3] || r2(false), this._invokeCallback(n3));
          }
        }, t3.dispatch = function(e5) {
          this._isDispatching && r2(false), this._startDispatching(e5);
          try {
            for (var t4 in this._callbacks)
              this._isPending[t4] || this._invokeCallback(t4);
          } finally {
            this._stopDispatching();
          }
        }, t3.isDispatching = function() {
          return this._isDispatching;
        }, t3._invokeCallback = function(e5) {
          this._isPending[e5] = true, this._callbacks[e5](this._pendingPayload), this._isHandled[e5] = true;
        }, t3._startDispatching = function(e5) {
          for (var t4 in this._callbacks)
            this._isPending[t4] = false, this._isHandled[t4] = false;
          this._pendingPayload = e5, this._isDispatching = true;
        }, t3._stopDispatching = function() {
          delete this._pendingPayload, this._isDispatching = false;
        }, e4;
      }();
      e3.exports = o;
    }, function(e3, t2, n2) {
      e3.exports = function(e4, t3) {
        for (var n3 = arguments.length, r2 = new Array(n3 > 2 ? n3 - 2 : 0), o = 2; o < n3; o++)
          r2[o - 2] = arguments[o];
        if (!e4) {
          var i;
          if (t3 === void 0)
            i = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
          else {
            var s = 0;
            (i = new Error(t3.replace(/%s/g, function() {
              return String(r2[s++]);
            }))).name = "Invariant Violation";
          }
          throw i.framesToPop = 1, i;
        }
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      function r2(e4, t3) {
        var n3 = Object.keys(e4);
        if (Object.getOwnPropertySymbols) {
          var a2 = Object.getOwnPropertySymbols(e4);
          t3 && (a2 = a2.filter(function(t4) {
            return Object.getOwnPropertyDescriptor(e4, t4).enumerable;
          })), n3.push.apply(n3, a2);
        }
        return n3;
      }
      function o(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3] != null ? arguments[t3] : {};
          t3 % 2 ? r2(Object(n3), true).forEach(function(t4) {
            a(e4, t4, n3[t4]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e4, Object.getOwnPropertyDescriptors(n3)) : r2(Object(n3)).forEach(function(t4) {
            Object.defineProperty(e4, t4, Object.getOwnPropertyDescriptor(n3, t4));
          });
        }
        return e4;
      }
      function i(e4, t3) {
        if (!(e4 instanceof t3))
          throw new TypeError("Cannot call a class as a function");
      }
      function s(e4, t3) {
        for (var n3 = 0; n3 < t3.length; n3++) {
          var a2 = t3[n3];
          a2.enumerable = a2.enumerable || false, a2.configurable = true, "value" in a2 && (a2.writable = true), Object.defineProperty(e4, a2.key, a2);
        }
      }
      function c2(e4, t3, n3) {
        return t3 && s(e4.prototype, t3), n3 && s(e4, n3), e4;
      }
      function l2(e4, t3) {
        return (l2 = Object.setPrototypeOf || function(e5, t4) {
          return e5.__proto__ = t4, e5;
        })(e4, t3);
      }
      function u(e4, t3) {
        if (typeof t3 != "function" && t3 !== null)
          throw new TypeError("Super expression must either be null or a function");
        e4.prototype = Object.create(t3 && t3.prototype, { constructor: { value: e4, writable: true, configurable: true } }), t3 && l2(e4, t3);
      }
      function f2(e4) {
        return (f2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e5) {
          return e5.__proto__ || Object.getPrototypeOf(e5);
        })(e4);
      }
      function p2(e4) {
        return (p2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e5) {
          return typeof e5;
        } : function(e5) {
          return e5 && typeof Symbol == "function" && e5.constructor === Symbol && e5 !== Symbol.prototype ? "symbol" : typeof e5;
        })(e4);
      }
      function d2(e4) {
        if (e4 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return e4;
      }
      function b2(e4, t3) {
        return !t3 || p2(t3) !== "object" && typeof t3 != "function" ? d2(e4) : t3;
      }
      function h(e4) {
        var t3 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e5) {
            return false;
          }
        }();
        return function() {
          var n3, a2 = f2(e4);
          if (t3) {
            var r3 = f2(this).constructor;
            n3 = Reflect.construct(a2, arguments, r3);
          } else
            n3 = a2.apply(this, arguments);
          return b2(this, n3);
        };
      }
      n2.r(t2);
      var v4 = n2(0), m2 = n2.n(v4);
      function y2() {
        var e4 = this.constructor.getDerivedStateFromProps(this.props, this.state);
        e4 != null && this.setState(e4);
      }
      function g2(e4) {
        this.setState(function(t3) {
          var n3 = this.constructor.getDerivedStateFromProps(e4, t3);
          return n3 != null ? n3 : null;
        }.bind(this));
      }
      function E(e4, t3) {
        try {
          var n3 = this.props, a2 = this.state;
          this.props = e4, this.state = t3, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(n3, a2);
        } finally {
          this.props = n3, this.state = a2;
        }
      }
      function j(e4) {
        var t3 = e4.prototype;
        if (!t3 || !t3.isReactComponent)
          throw new Error("Can only polyfill class components");
        if (typeof e4.getDerivedStateFromProps != "function" && typeof t3.getSnapshotBeforeUpdate != "function")
          return e4;
        var n3 = null, a2 = null, r3 = null;
        if (typeof t3.componentWillMount == "function" ? n3 = "componentWillMount" : typeof t3.UNSAFE_componentWillMount == "function" && (n3 = "UNSAFE_componentWillMount"), typeof t3.componentWillReceiveProps == "function" ? a2 = "componentWillReceiveProps" : typeof t3.UNSAFE_componentWillReceiveProps == "function" && (a2 = "UNSAFE_componentWillReceiveProps"), typeof t3.componentWillUpdate == "function" ? r3 = "componentWillUpdate" : typeof t3.UNSAFE_componentWillUpdate == "function" && (r3 = "UNSAFE_componentWillUpdate"), n3 !== null || a2 !== null || r3 !== null) {
          var o2 = e4.displayName || e4.name, i2 = typeof e4.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
          throw Error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n" + o2 + " uses " + i2 + " but also contains the following legacy lifecycles:" + (n3 !== null ? "\n  " + n3 : "") + (a2 !== null ? "\n  " + a2 : "") + (r3 !== null ? "\n  " + r3 : "") + "\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-async-component-lifecycle-hooks");
        }
        if (typeof e4.getDerivedStateFromProps == "function" && (t3.componentWillMount = y2, t3.componentWillReceiveProps = g2), typeof t3.getSnapshotBeforeUpdate == "function") {
          if (typeof t3.componentDidUpdate != "function")
            throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
          t3.componentWillUpdate = E;
          var s2 = t3.componentDidUpdate;
          t3.componentDidUpdate = function(e5, t4, n4) {
            var a3 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : n4;
            s2.call(this, e5, t4, a3);
          };
        }
        return e4;
      }
      function x2(e4, t3) {
        if (e4 == null)
          return {};
        var n3, a2, r3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, t3);
        if (Object.getOwnPropertySymbols) {
          var o2 = Object.getOwnPropertySymbols(e4);
          for (a2 = 0; a2 < o2.length; a2++)
            n3 = o2[a2], t3.indexOf(n3) >= 0 || Object.prototype.propertyIsEnumerable.call(e4, n3) && (r3[n3] = e4[n3]);
        }
        return r3;
      }
      function _(e4) {
        var t3 = function(e5) {
          return {}.toString.call(e5).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
        }(e4);
        return t3 === "number" && (t3 = isNaN(e4) ? "nan" : (0 | e4) != e4 ? "float" : "integer"), t3;
      }
      y2.__suppressDeprecationWarning = true, g2.__suppressDeprecationWarning = true, E.__suppressDeprecationWarning = true;
      var k2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, O = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, C = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, S = n2(45), w2 = function(e4) {
        var t3 = function(e5) {
          return { backgroundColor: e5.base00, ellipsisColor: e5.base09, braceColor: e5.base07, expandedIcon: e5.base0D, collapsedIcon: e5.base0E, keyColor: e5.base07, arrayKeyColor: e5.base0C, objectSize: e5.base04, copyToClipboard: e5.base0F, copyToClipboardCheck: e5.base0D, objectBorder: e5.base02, dataTypes: { boolean: e5.base0E, date: e5.base0D, float: e5.base0B, function: e5.base0D, integer: e5.base0F, string: e5.base09, nan: e5.base08, null: e5.base0A, undefined: e5.base05, regexp: e5.base0A, background: e5.base02 }, editVariable: { editIcon: e5.base0E, cancelIcon: e5.base09, removeIcon: e5.base09, addIcon: e5.base0E, checkIcon: e5.base0E, background: e5.base01, color: e5.base0A, border: e5.base07 }, addKeyModal: { background: e5.base05, border: e5.base04, color: e5.base0A, labelColor: e5.base01 }, validationFailure: { background: e5.base09, iconColor: e5.base01, fontColor: e5.base01 } };
        }(e4);
        return { "app-container": { fontFamily: C.globalFontFamily, cursor: C.globalCursor, backgroundColor: t3.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: C.braceCursor, fontWeight: C.braceFontWeight, color: t3.braceColor }, "expanded-icon": { color: t3.expandedIcon }, "collapsed-icon": { color: t3.collapsedIcon }, colon: { display: "inline-block", margin: C.keyMargin, color: t3.keyColor, verticalAlign: "top" }, objectKeyVal: function(e5, n3) {
          return { style: o({ paddingTop: C.keyValPaddingTop, paddingRight: C.keyValPaddingRight, paddingBottom: C.keyValPaddingBottom, borderLeft: C.keyValBorderLeft + " " + t3.objectBorder, ":hover": { paddingLeft: n3.paddingLeft - 1 + "px", borderLeft: C.keyValBorderHover + " " + t3.objectBorder } }, n3) };
        }, "object-key-val-no-border": { padding: C.keyValPadding }, "pushed-content": { marginLeft: C.pushedContentMarginLeft }, variableValue: function(e5, t4) {
          return { style: o({ display: "inline-block", paddingRight: C.variableValuePaddingRight, position: "relative" }, t4) };
        }, "object-name": { display: "inline-block", color: t3.keyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "array-key": { display: "inline-block", color: t3.arrayKeyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "object-size": { color: t3.objectSize, borderRadius: C.objectSizeBorderRadius, fontStyle: C.objectSizeFontStyle, margin: C.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: C.dataTypeFontSize, marginRight: C.dataTypeMarginRight, opacity: C.datatypeOpacity }, boolean: { display: "inline-block", color: t3.dataTypes.boolean }, date: { display: "inline-block", color: t3.dataTypes.date }, "date-value": { marginLeft: C.dateValueMarginLeft }, float: { display: "inline-block", color: t3.dataTypes.float }, function: { display: "inline-block", color: t3.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: t3.dataTypes.integer }, string: { display: "inline-block", color: t3.dataTypes.string }, nan: { display: "inline-block", color: t3.dataTypes.nan, fontSize: C.nanFontSize, fontWeight: C.nanFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nanPadding, borderRadius: C.nanBorderRadius }, null: { display: "inline-block", color: t3.dataTypes.null, fontSize: C.nullFontSize, fontWeight: C.nullFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nullPadding, borderRadius: C.nullBorderRadius }, undefined: { display: "inline-block", color: t3.dataTypes.undefined, fontSize: C.undefinedFontSize, padding: C.undefinedPadding, borderRadius: C.undefinedBorderRadius, backgroundColor: t3.dataTypes.background }, regexp: { display: "inline-block", color: t3.dataTypes.regexp }, "copy-to-clipboard": { cursor: C.clipboardCursor }, "copy-icon": { color: t3.copyToClipboard, fontSize: C.iconFontSize, marginRight: C.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: t3.copyToClipboardCheck, marginLeft: C.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: C.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: C.metaDataPadding }, "icon-container": { display: "inline-block", width: C.iconContainerWidth }, tooltip: { padding: C.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.removeIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.addIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.editIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.checkIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.cancelIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: C.editInputMinWidth, borderRadius: C.editInputBorderRadius, backgroundColor: t3.editVariable.background, color: t3.editVariable.color, padding: C.editInputPadding, marginRight: C.editInputMarginRight, fontFamily: C.editInputFontFamily }, "detected-row": { paddingTop: C.detectedRowPaddingTop }, "key-modal-request": { position: C.addKeyCoverPosition, top: C.addKeyCoverPositionPx, left: C.addKeyCoverPositionPx, right: C.addKeyCoverPositionPx, bottom: C.addKeyCoverPositionPx, backgroundColor: C.addKeyCoverBackground }, "key-modal": { width: C.addKeyModalWidth, backgroundColor: t3.addKeyModal.background, marginLeft: C.addKeyModalMargin, marginRight: C.addKeyModalMargin, padding: C.addKeyModalPadding, borderRadius: C.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: t3.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: t3.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: t3.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: t3.addKeyModal.labelColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: t3.editVariable.addIcon, fontSize: C.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: t3.validationFailure.fontColor, backgroundColor: t3.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: t3.validationFailure.iconColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" } };
      };
      function A2(e4, t3, n3) {
        return e4 || console.error("theme has not been set"), function(e5) {
          var t4 = k2;
          return e5 !== false && e5 !== "none" || (t4 = O), Object(S.createStyling)(w2, { defaultBase16: t4 })(e5);
        }(e4)(t3, n3);
      }
      var M = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = (e5.rjvId, e5.type_name), n4 = e5.displayDataTypes, a2 = e5.theme;
          return n4 ? m2.a.createElement("span", Object.assign({ className: "data-type-label" }, A2(a2, "data-type-label")), t4) : null;
        } }]), n3;
      }(m2.a.PureComponent), P = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "boolean"), m2.a.createElement(M, Object.assign({ type_name: "bool" }, e5)), e5.value ? "true" : "false");
        } }]), n3;
      }(m2.a.PureComponent), F = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "date"), m2.a.createElement(M, Object.assign({ type_name: "date" }, e5)), m2.a.createElement("span", Object.assign({ className: "date-value" }, A2(e5.theme, "date-value")), e5.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
        } }]), n3;
      }(m2.a.PureComponent), D = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "float"), m2.a.createElement(M, Object.assign({ type_name: "float" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent);
      function I(e4, t3) {
        (t3 == null || t3 > e4.length) && (t3 = e4.length);
        for (var n3 = 0, a2 = new Array(t3); n3 < t3; n3++)
          a2[n3] = e4[n3];
        return a2;
      }
      function R(e4, t3) {
        if (e4) {
          if (typeof e4 == "string")
            return I(e4, t3);
          var n3 = Object.prototype.toString.call(e4).slice(8, -1);
          return n3 === "Object" && e4.constructor && (n3 = e4.constructor.name), n3 === "Map" || n3 === "Set" ? Array.from(e4) : n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3) ? I(e4, t3) : void 0;
        }
      }
      function L(e4, t3) {
        var n3;
        if (typeof Symbol == "undefined" || e4[Symbol.iterator] == null) {
          if (Array.isArray(e4) || (n3 = R(e4)) || t3 && e4 && typeof e4.length == "number") {
            n3 && (e4 = n3);
            var a2 = 0, r3 = function() {
            };
            return { s: r3, n: function() {
              return a2 >= e4.length ? { done: true } : { done: false, value: e4[a2++] };
            }, e: function(e5) {
              throw e5;
            }, f: r3 };
          }
          throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }
        var o2, i2 = true, s2 = false;
        return { s: function() {
          n3 = e4[Symbol.iterator]();
        }, n: function() {
          var e5 = n3.next();
          return i2 = e5.done, e5;
        }, e: function(e5) {
          s2 = true, o2 = e5;
        }, f: function() {
          try {
            i2 || n3.return == null || n3.return();
          } finally {
            if (s2)
              throw o2;
          }
        } };
      }
      function B(e4) {
        return function(e5) {
          if (Array.isArray(e5))
            return I(e5);
        }(e4) || function(e5) {
          if (typeof Symbol != "undefined" && Symbol.iterator in Object(e5))
            return Array.from(e5);
        }(e4) || R(e4) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }();
      }
      var N = n2(46), z2 = new (n2(47)).Dispatcher(), T = new (function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).objects = {}, e5.set = function(t4, n4, a3, r4) {
            e5.objects[t4] === void 0 && (e5.objects[t4] = {}), e5.objects[t4][n4] === void 0 && (e5.objects[t4][n4] = {}), e5.objects[t4][n4][a3] = r4;
          }, e5.get = function(t4, n4, a3, r4) {
            return e5.objects[t4] === void 0 || e5.objects[t4][n4] === void 0 || e5.objects[t4][n4][a3] == null ? r4 : e5.objects[t4][n4][a3];
          }, e5.handleAction = function(t4) {
            var n4 = t4.rjvId, a3 = t4.data;
            switch (t4.name) {
              case "RESET":
                e5.emit("reset-" + n4);
                break;
              case "VARIABLE_UPDATED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-edited" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_REMOVED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-removed" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_ADDED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-added" })), e5.emit("variable-update-" + n4);
                break;
              case "ADD_VARIABLE_KEY_REQUEST":
                e5.set(n4, "action", "new-key-request", a3), e5.emit("add-key-request-" + n4);
            }
          }, e5.updateSrc = function(t4, n4) {
            var a3 = n4.name, r4 = n4.namespace, o2 = n4.new_value, i2 = (n4.existing_value, n4.variable_removed);
            r4.shift();
            var s3, c3 = e5.get(t4, "global", "src"), l3 = e5.deepCopy(c3, B(r4)), u2 = l3, f3 = L(r4);
            try {
              for (f3.s(); !(s3 = f3.n()).done; ) {
                u2 = u2[s3.value];
              }
            } catch (e6) {
              f3.e(e6);
            } finally {
              f3.f();
            }
            return i2 ? _(u2) == "array" ? u2.splice(a3, 1) : delete u2[a3] : a3 !== null ? u2[a3] = o2 : l3 = o2, e5.set(t4, "global", "src", l3), l3;
          }, e5.deepCopy = function(t4, n4) {
            var a3, r4 = _(t4), i2 = n4.shift();
            return r4 == "array" ? a3 = B(t4) : r4 == "object" && (a3 = o({}, t4)), i2 !== void 0 && (a3[i2] = e5.deepCopy(t4[i2], n4)), a3;
          }, e5;
        }
        return n3;
      }(N.EventEmitter))();
      z2.register(T.handleAction.bind(T));
      var q2 = T, V = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.getFunctionDisplay = function(e6) {
            var t4 = d2(a2).props;
            return e6 ? m2.a.createElement("span", null, a2.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), m2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, m2.a.createElement("span", null, "{"), m2.a.createElement("span", A2(t4.theme, "ellipsis"), "..."), m2.a.createElement("span", null, "}"))) : a2.props.value.toString().slice(9, -1);
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = this.state.collapsed;
          return m2.a.createElement("div", A2(e5.theme, "function"), m2.a.createElement(M, Object.assign({ type_name: "function" }, e5)), m2.a.createElement("span", Object.assign({}, A2(e5.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(t4)));
        } }]), n3;
      }(m2.a.PureComponent), K = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "nan"), "NaN");
        } }]), n3;
      }(m2.a.PureComponent), W = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "null"), "NULL");
        } }]), n3;
      }(m2.a.PureComponent), H = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "integer"), m2.a.createElement(M, Object.assign({ type_name: "int" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent), U = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "regexp"), m2.a.createElement(M, Object.assign({ type_name: "regexp" }, e5)), this.props.value.toString());
        } }]), n3;
      }(m2.a.PureComponent), G = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          this.state.collapsed;
          var e5 = this.props, t4 = e5.collapseStringsAfterLength, n4 = e5.theme, a2 = e5.value, r3 = { style: { cursor: "default" } };
          return _(t4) === "integer" && a2.length > t4 && (r3.style.cursor = "pointer", this.state.collapsed && (a2 = m2.a.createElement("span", null, a2.substring(0, t4), m2.a.createElement("span", A2(n4, "ellipsis"), " ...")))), m2.a.createElement("div", A2(n4, "string"), m2.a.createElement(M, Object.assign({ type_name: "string" }, e5)), m2.a.createElement("span", Object.assign({ className: "string-value" }, r3, { onClick: this.toggleCollapsed }), '"', a2, '"'));
        } }]), n3;
      }(m2.a.PureComponent), J = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "undefined"), "undefined");
        } }]), n3;
      }(m2.a.PureComponent);
      function Y() {
        return (Y = Object.assign || function(e4) {
          for (var t3 = 1; t3 < arguments.length; t3++) {
            var n3 = arguments[t3];
            for (var a2 in n3)
              Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
          }
          return e4;
        }).apply(this, arguments);
      }
      var $ = v4.useLayoutEffect, Q = function(e4) {
        var t3 = Object(v4.useRef)(e4);
        return $(function() {
          t3.current = e4;
        }), t3;
      }, Z = function(e4, t3) {
        typeof e4 != "function" ? e4.current = t3 : e4(t3);
      }, X = function(e4, t3) {
        var n3 = Object(v4.useRef)();
        return Object(v4.useCallback)(function(a2) {
          e4.current = a2, n3.current && Z(n3.current, null), n3.current = t3, t3 && Z(t3, a2);
        }, [t3]);
      }, ee = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, te = function(e4) {
        Object.keys(ee).forEach(function(t3) {
          e4.style.setProperty(t3, ee[t3], "important");
        });
      }, ne = null;
      var ae = function() {
      }, re = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oe = !!document.documentElement.currentStyle, ie = function(e4, t3) {
        var n3 = e4.cacheMeasurements, a2 = e4.maxRows, r3 = e4.minRows, o2 = e4.onChange, i2 = o2 === void 0 ? ae : o2, s2 = e4.onHeightChange, c3 = s2 === void 0 ? ae : s2, l3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]);
        var u2, f3 = l3.value !== void 0, p3 = Object(v4.useRef)(null), d3 = X(p3, t3), b3 = Object(v4.useRef)(0), h2 = Object(v4.useRef)(), m3 = function() {
          var e5 = p3.current, t4 = n3 && h2.current ? h2.current : function(e6) {
            var t5 = window.getComputedStyle(e6);
            if (t5 === null)
              return null;
            var n4, a3 = (n4 = t5, re.reduce(function(e7, t6) {
              return e7[t6] = n4[t6], e7;
            }, {})), r4 = a3.boxSizing;
            return r4 === "" ? null : (oe && r4 === "border-box" && (a3.width = parseFloat(a3.width) + parseFloat(a3.borderRightWidth) + parseFloat(a3.borderLeftWidth) + parseFloat(a3.paddingRight) + parseFloat(a3.paddingLeft) + "px"), { sizingStyle: a3, paddingSize: parseFloat(a3.paddingBottom) + parseFloat(a3.paddingTop), borderSize: parseFloat(a3.borderBottomWidth) + parseFloat(a3.borderTopWidth) });
          }(e5);
          if (t4) {
            h2.current = t4;
            var o3 = function(e6, t5, n4, a3) {
              n4 === void 0 && (n4 = 1), a3 === void 0 && (a3 = 1 / 0), ne || ((ne = document.createElement("textarea")).setAttribute("tab-index", "-1"), ne.setAttribute("aria-hidden", "true"), te(ne)), ne.parentNode === null && document.body.appendChild(ne);
              var r4 = e6.paddingSize, o4 = e6.borderSize, i4 = e6.sizingStyle, s4 = i4.boxSizing;
              Object.keys(i4).forEach(function(e7) {
                var t6 = e7;
                ne.style[t6] = i4[t6];
              }), te(ne), ne.value = t5;
              var c4 = function(e7, t6) {
                var n5 = e7.scrollHeight;
                return t6.sizingStyle.boxSizing === "border-box" ? n5 + t6.borderSize : n5 - t6.paddingSize;
              }(ne, e6);
              ne.value = "x";
              var l4 = ne.scrollHeight - r4, u3 = l4 * n4;
              s4 === "border-box" && (u3 = u3 + r4 + o4), c4 = Math.max(u3, c4);
              var f4 = l4 * a3;
              return s4 === "border-box" && (f4 = f4 + r4 + o4), [c4 = Math.min(f4, c4), l4];
            }(t4, e5.value || e5.placeholder || "x", r3, a2), i3 = o3[0], s3 = o3[1];
            b3.current !== i3 && (b3.current = i3, e5.style.setProperty("height", i3 + "px", "important"), c3(i3, { rowHeight: s3 }));
          }
        };
        return Object(v4.useLayoutEffect)(m3), u2 = Q(m3), Object(v4.useLayoutEffect)(function() {
          var e5 = function(e6) {
            u2.current(e6);
          };
          return window.addEventListener("resize", e5), function() {
            window.removeEventListener("resize", e5);
          };
        }, []), Object(v4.createElement)("textarea", Y({}, l3, { onChange: function(e5) {
          f3 || m3(), i2(e5);
        }, ref: d3 }));
      }, se = Object(v4.forwardRef)(ie);
      function ce(e4) {
        e4 = e4.trim();
        try {
          if ((e4 = JSON.stringify(JSON.parse(e4)))[0] === "[")
            return le("array", JSON.parse(e4));
          if (e4[0] === "{")
            return le("object", JSON.parse(e4));
          if (e4.match(/\-?\d+\.\d+/) && e4.match(/\-?\d+\.\d+/)[0] === e4)
            return le("float", parseFloat(e4));
          if (e4.match(/\-?\d+e-\d+/) && e4.match(/\-?\d+e-\d+/)[0] === e4)
            return le("float", Number(e4));
          if (e4.match(/\-?\d+/) && e4.match(/\-?\d+/)[0] === e4)
            return le("integer", parseInt(e4));
          if (e4.match(/\-?\d+e\+\d+/) && e4.match(/\-?\d+e\+\d+/)[0] === e4)
            return le("integer", Number(e4));
        } catch (e5) {
        }
        switch (e4 = e4.toLowerCase()) {
          case "undefined":
            return le("undefined", void 0);
          case "nan":
            return le("nan", NaN);
          case "null":
            return le("null", null);
          case "true":
            return le("boolean", true);
          case "false":
            return le("boolean", false);
          default:
            if (e4 = Date.parse(e4))
              return le("date", new Date(e4));
        }
        return le(false, null);
      }
      function le(e4, t3) {
        return { type: e4, value: t3 };
      }
      var ue = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
        } }]), n3;
      }(m2.a.PureComponent), fe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
        } }]), n3;
      }(m2.a.PureComponent), pe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), de = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), he = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), ve = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ye = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ge = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
        } }]), n3;
      }(m2.a.PureComponent), Ee = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), je = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent);
      function xe(e4) {
        return e4 || (e4 = {}), { style: o(o({ verticalAlign: "middle" }, e4), {}, { color: e4.color ? e4.color : "#000000", height: "1em", width: "1em" }) };
      }
      var _e = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).copiedTimer = null, a2.handleCopy = function() {
            var e6 = document.createElement("textarea"), t4 = a2.props, n4 = t4.clickCallback, r3 = t4.src, o2 = t4.namespace;
            e6.innerHTML = JSON.stringify(a2.clipboardValue(r3), null, "  "), document.body.appendChild(e6), e6.select(), document.execCommand("copy"), document.body.removeChild(e6), a2.copiedTimer = setTimeout(function() {
              a2.setState({ copied: false });
            }, 5500), a2.setState({ copied: true }, function() {
              typeof n4 == "function" && n4({ src: r3, namespace: o2, name: o2[o2.length - 1] });
            });
          }, a2.getClippyIcon = function() {
            var e6 = a2.props.theme;
            return a2.state.copied ? m2.a.createElement("span", null, m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon"))), m2.a.createElement("span", A2(e6, "copy-icon-copied"), "\u2714")) : m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon")));
          }, a2.clipboardValue = function(e6) {
            switch (_(e6)) {
              case "function":
              case "regexp":
                return e6.toString();
              default:
                return e6;
            }
          }, a2.state = { copied: false }, a2;
        }
        return c2(n3, [{ key: "componentWillUnmount", value: function() {
          this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
        } }, { key: "render", value: function() {
          var e5 = this.props, t4 = (e5.src, e5.theme), n4 = e5.hidden, a2 = e5.rowHovered, r3 = A2(t4, "copy-to-clipboard").style, i2 = "inline";
          return n4 && (i2 = "none"), m2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: a2 ? "inline-block" : "none" } }, m2.a.createElement("span", { style: o(o({}, r3), {}, { display: i2 }), onClick: this.handleCopy }, this.getClippyIcon()));
        } }]), n3;
      }(m2.a.PureComponent), ke = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).getEditIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.theme;
            return m2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(Ee, Object.assign({ className: "click-to-edit-icon" }, A2(n4, "editVarIcon"), { onClick: function() {
              a2.prepopInput(t4);
            } })));
          }, a2.prepopInput = function(e6) {
            if (a2.props.onEdit !== false) {
              var t4 = function(e7) {
                var t5;
                switch (_(e7)) {
                  case "undefined":
                    t5 = "undefined";
                    break;
                  case "nan":
                    t5 = "NaN";
                    break;
                  case "string":
                    t5 = e7;
                    break;
                  case "date":
                  case "function":
                  case "regexp":
                    t5 = e7.toString();
                    break;
                  default:
                    try {
                      t5 = JSON.stringify(e7, null, "  ");
                    } catch (e8) {
                      t5 = "";
                    }
                }
                return t5;
              }(e6.value), n4 = ce(t4);
              a2.setState({ editMode: true, editValue: t4, parsedInput: { type: n4.type, value: n4.value } });
            }
          }, a2.getRemoveIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.namespace, r3 = e6.theme, o2 = e6.rjvId;
            return m2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(r3, "removeVarIcon"), { onClick: function() {
              z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: o2, data: { name: t4.name, namespace: n4, existing_value: t4.value, variable_removed: true } });
            } })));
          }, a2.getValue = function(e6, t4) {
            var n4 = !t4 && e6.type, r3 = d2(a2).props;
            switch (n4) {
              case false:
                return a2.getEditInput();
              case "string":
                return m2.a.createElement(G, Object.assign({ value: e6.value }, r3));
              case "integer":
                return m2.a.createElement(H, Object.assign({ value: e6.value }, r3));
              case "float":
                return m2.a.createElement(D, Object.assign({ value: e6.value }, r3));
              case "boolean":
                return m2.a.createElement(P, Object.assign({ value: e6.value }, r3));
              case "function":
                return m2.a.createElement(V, Object.assign({ value: e6.value }, r3));
              case "null":
                return m2.a.createElement(W, r3);
              case "nan":
                return m2.a.createElement(K, r3);
              case "undefined":
                return m2.a.createElement(J, r3);
              case "date":
                return m2.a.createElement(F, Object.assign({ value: e6.value }, r3));
              case "regexp":
                return m2.a.createElement(U, Object.assign({ value: e6.value }, r3));
              default:
                return m2.a.createElement("div", { className: "object-value" }, JSON.stringify(e6.value));
            }
          }, a2.getEditInput = function() {
            var e6 = a2.props.theme, t4 = a2.state.editValue;
            return m2.a.createElement("div", null, m2.a.createElement(se, Object.assign({ type: "text", inputRef: function(e7) {
              return e7 && e7.focus();
            }, value: t4, className: "variable-editor", onChange: function(e7) {
              var t5 = e7.target.value, n4 = ce(t5);
              a2.setState({ editValue: t5, parsedInput: { type: n4.type, value: n4.value } });
            }, onKeyDown: function(e7) {
              switch (e7.key) {
                case "Escape":
                  a2.setState({ editMode: false, editValue: "" });
                  break;
                case "Enter":
                  (e7.ctrlKey || e7.metaKey) && a2.submitEdit(true);
              }
              e7.stopPropagation();
            }, placeholder: "update this value", minRows: 2 }, A2(e6, "edit-input"))), m2.a.createElement("div", A2(e6, "edit-icon-container"), m2.a.createElement(me, Object.assign({ className: "edit-cancel" }, A2(e6, "cancel-icon"), { onClick: function() {
              a2.setState({ editMode: false, editValue: "" });
            } })), m2.a.createElement(je, Object.assign({ className: "edit-check string-value" }, A2(e6, "check-icon"), { onClick: function() {
              a2.submitEdit();
            } })), m2.a.createElement("div", null, a2.showDetected())));
          }, a2.submitEdit = function(e6) {
            var t4 = a2.props, n4 = t4.variable, r3 = t4.namespace, o2 = t4.rjvId, i2 = a2.state, s2 = i2.editValue, c3 = i2.parsedInput, l3 = s2;
            e6 && c3.type && (l3 = c3.value), a2.setState({ editMode: false }), z2.dispatch({ name: "VARIABLE_UPDATED", rjvId: o2, data: { name: n4.name, namespace: r3, existing_value: n4.value, new_value: l3, variable_removed: false } });
          }, a2.showDetected = function() {
            var e6 = a2.props, t4 = e6.theme, n4 = (e6.variable, e6.namespace, e6.rjvId, a2.state.parsedInput), r3 = (n4.type, n4.value, a2.getDetectedInput());
            if (r3)
              return m2.a.createElement("div", null, m2.a.createElement("div", A2(t4, "detected-row"), r3, m2.a.createElement(je, { className: "edit-check detected", style: o({ verticalAlign: "top", paddingLeft: "3px" }, A2(t4, "check-icon").style), onClick: function() {
                a2.submitEdit(true);
              } })));
          }, a2.getDetectedInput = function() {
            var e6 = a2.state.parsedInput, t4 = e6.type, n4 = e6.value, r3 = d2(a2).props, i2 = r3.theme;
            if (t4 !== false)
              switch (t4.toLowerCase()) {
                case "object":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "{"), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "}"));
                case "array":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "["), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "]"));
                case "string":
                  return m2.a.createElement(G, Object.assign({ value: n4 }, r3));
                case "integer":
                  return m2.a.createElement(H, Object.assign({ value: n4 }, r3));
                case "float":
                  return m2.a.createElement(D, Object.assign({ value: n4 }, r3));
                case "boolean":
                  return m2.a.createElement(P, Object.assign({ value: n4 }, r3));
                case "function":
                  return m2.a.createElement(V, Object.assign({ value: n4 }, r3));
                case "null":
                  return m2.a.createElement(W, r3);
                case "nan":
                  return m2.a.createElement(K, r3);
                case "undefined":
                  return m2.a.createElement(J, r3);
                case "date":
                  return m2.a.createElement(F, Object.assign({ value: new Date(n4) }, r3));
              }
          }, a2.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.variable, a2 = t4.singleIndent, r3 = t4.type, i2 = t4.theme, s2 = t4.namespace, c3 = t4.indentWidth, l3 = t4.enableClipboard, u2 = t4.onEdit, f3 = t4.onDelete, p3 = t4.onSelect, d3 = t4.displayArrayKey, b3 = t4.quotesOnKeys, h2 = this.state.editMode;
          return m2.a.createElement("div", Object.assign({}, A2(i2, "objectKeyVal", { paddingLeft: c3 * a2 }), { onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          }, className: "variable-row", key: n4.name }), r3 == "array" ? d3 ? m2.a.createElement("span", Object.assign({}, A2(i2, "array-key"), { key: n4.name + "_" + s2 }), n4.name, m2.a.createElement("div", A2(i2, "colon"), ":")) : null : m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({}, A2(i2, "object-name"), { className: "object-key", key: n4.name + "_" + s2 }), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", { style: { display: "inline-block" } }, n4.name), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(i2, "colon"), ":")), m2.a.createElement("div", Object.assign({ className: "variable-value", onClick: p3 === false && u2 === false ? null : function(t5) {
            var a3 = B(s2);
            (t5.ctrlKey || t5.metaKey) && u2 !== false ? e5.prepopInput(n4) : p3 !== false && (a3.shift(), p3(o(o({}, n4), {}, { namespace: a3 })));
          } }, A2(i2, "variableValue", { cursor: p3 === false ? "default" : "pointer" })), this.getValue(n4, h2)), l3 ? m2.a.createElement(_e, { rowHovered: this.state.hovered, hidden: h2, src: n4.value, clickCallback: l3, theme: i2, namespace: [].concat(B(s2), [n4.name]) }) : null, u2 !== false && h2 == 0 ? this.getEditIcon() : null, f3 !== false && h2 == 0 ? this.getRemoveIcon() : null);
        } }]), n3;
      }(m2.a.PureComponent), Oe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).getObjectSize = function() {
            var t4 = e5.props, n4 = t4.size, a3 = t4.theme;
            if (t4.displayObjectSize)
              return m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(a3, "object-size")), n4, " item", n4 === 1 ? "" : "s");
          }, e5.getAddAttribute = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = n4.namespace, i2 = n4.name, s3 = n4.src, c3 = n4.rjvId, l3 = n4.depth;
            return m2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: t4 ? "inline-block" : "none" } }, m2.a.createElement(ye, Object.assign({ className: "click-to-add-icon" }, A2(a3, "addVarIcon"), { onClick: function() {
              var e6 = { name: l3 > 0 ? i2 : null, namespace: r4.splice(0, r4.length - 1), existing_value: s3, variable_removed: false, key_name: null };
              _(s3) === "object" ? z2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: c3, data: e6 }) : z2.dispatch({ name: "VARIABLE_ADDED", rjvId: c3, data: o(o({}, e6), {}, { new_value: [].concat(B(s3), [null]) }) });
            } })));
          }, e5.getRemoveObject = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = (n4.hover, n4.namespace), o2 = n4.name, i2 = n4.src, s3 = n4.rjvId;
            if (r4.length !== 1)
              return m2.a.createElement("span", { className: "click-to-remove", style: { display: t4 ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(a3, "removeVarIcon"), { onClick: function() {
                z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: s3, data: { name: o2, namespace: r4.splice(0, r4.length - 1), existing_value: i2, variable_removed: true } });
              } })));
          }, e5.render = function() {
            var t4 = e5.props, n4 = t4.theme, a3 = t4.onDelete, r4 = t4.onAdd, o2 = t4.enableClipboard, i2 = t4.src, s3 = t4.namespace, c3 = t4.rowHovered;
            return m2.a.createElement("div", Object.assign({}, A2(n4, "object-meta-data"), { className: "object-meta-data", onClick: function(e6) {
              e6.stopPropagation();
            } }), e5.getObjectSize(), o2 ? m2.a.createElement(_e, { rowHovered: c3, clickCallback: o2, src: i2, theme: n4, namespace: s3 }) : null, r4 !== false ? e5.getAddAttribute(c3) : null, a3 !== false ? e5.getRemoveObject(c3) : null);
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent);
      function Ce(e4) {
        var t3 = e4.parent_type, n3 = e4.namespace, a2 = e4.quotesOnKeys, r3 = e4.theme, o2 = e4.jsvRoot, i2 = e4.name, s2 = e4.displayArrayKey, c3 = e4.name ? e4.name : "";
        return !o2 || i2 !== false && i2 !== null ? t3 == "array" ? s2 ? m2.a.createElement("span", Object.assign({}, A2(r3, "array-key"), { key: n3 }), m2.a.createElement("span", { className: "array-key" }, c3), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null) : m2.a.createElement("span", Object.assign({}, A2(r3, "object-name"), { key: n3 }), m2.a.createElement("span", { className: "object-key" }, a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", null, c3), a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null);
      }
      function Se(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(he, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          case "square":
            return m2.a.createElement(pe, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          default:
            return m2.a.createElement(ue, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
        }
      }
      function we(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(be, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          case "square":
            return m2.a.createElement(de, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          default:
            return m2.a.createElement(fe, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
        }
      }
      var Ae = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function(e6) {
            var t4 = [];
            for (var n4 in a2.state.expanded)
              t4.push(a2.state.expanded[n4]);
            t4[e6] = !t4[e6], a2.setState({ expanded: t4 });
          }, a2.state = { expanded: [] }, a2;
        }
        return c2(n3, [{ key: "getExpandedIcon", value: function(e5) {
          var t4 = this.props, n4 = t4.theme, a2 = t4.iconStyle;
          return this.state.expanded[e5] ? m2.a.createElement(Se, { theme: n4, iconStyle: a2 }) : m2.a.createElement(we, { theme: n4, iconStyle: a2 });
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.src, a2 = t4.groupArraysAfterLength, r3 = (t4.depth, t4.name), o2 = t4.theme, i2 = t4.jsvRoot, s2 = t4.namespace, c3 = (t4.parent_type, x2(t4, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), l3 = 0, u2 = 5 * this.props.indentWidth;
          i2 || (l3 = 5 * this.props.indentWidth);
          var f3 = a2, p3 = Math.ceil(n4.length / f3);
          return m2.a.createElement("div", Object.assign({ className: "object-key-val" }, A2(o2, i2 ? "jsv-root" : "objectKeyVal", { paddingLeft: l3 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", null, m2.a.createElement(Oe, Object.assign({ size: n4.length }, this.props))), B(Array(p3)).map(function(t5, a3) {
            return m2.a.createElement("div", Object.assign({ key: a3, className: "object-key-val array-group" }, A2(o2, "objectKeyVal", { marginLeft: 6, paddingLeft: u2 })), m2.a.createElement("span", A2(o2, "brace-row"), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            } }), e5.getExpandedIcon(a3)), e5.state.expanded[a3] ? m2.a.createElement(Fe, Object.assign({ key: r3 + a3, depth: 0, name: false, collapsed: false, groupArraysAfterLength: f3, index_offset: a3 * f3, src: n4.slice(a3 * f3, a3 * f3 + f3), namespace: s2, type: "array", parent_type: "array_group", theme: o2 }, c3)) : m2.a.createElement("span", Object.assign({}, A2(o2, "brace"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            }, className: "array-group-brace" }), "[", m2.a.createElement("div", Object.assign({}, A2(o2, "array-group-meta-data"), { className: "array-group-meta-data" }), m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(o2, "object-size")), a3 * f3, " - ", a3 * f3 + f3 > n4.length ? n4.length : a3 * f3 + f3)), "]")));
          }));
        } }]), n3;
      }(m2.a.PureComponent), Me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ expanded: !a2.state.expanded }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "expanded", a2.state.expanded);
            });
          }, a2.getObjectContent = function(e6, t4, n4) {
            return m2.a.createElement("div", { className: "pushed-content object-container" }, m2.a.createElement("div", Object.assign({ className: "object-content" }, A2(a2.props.theme, "pushed-content")), a2.renderObjectContents(t4, n4)));
          }, a2.getEllipsis = function() {
            return a2.state.size === 0 ? null : m2.a.createElement("div", Object.assign({}, A2(a2.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: a2.toggleCollapsed }), "...");
          }, a2.getObjectMetaData = function(e6) {
            var t4 = a2.props, n4 = (t4.rjvId, t4.theme, a2.state), r4 = n4.size, o2 = n4.hovered;
            return m2.a.createElement(Oe, Object.assign({ rowHovered: o2, size: r4 }, a2.props));
          }, a2.renderObjectContents = function(e6, t4) {
            var n4, r4 = a2.props, o2 = r4.depth, i2 = r4.parent_type, s2 = r4.index_offset, c3 = r4.groupArraysAfterLength, l3 = r4.namespace, u2 = a2.state.object_type, f3 = [], p3 = Object.keys(e6 || {});
            return a2.props.sortKeys && u2 !== "array" && (p3 = p3.sort()), p3.forEach(function(r5) {
              if (n4 = new Pe(r5, e6[r5]), i2 === "array_group" && s2 && (n4.name = parseInt(n4.name) + s2), e6.hasOwnProperty(r5))
                if (n4.type === "object")
                  f3.push(m2.a.createElement(Fe, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), parent_type: u2 }, t4)));
                else if (n4.type === "array") {
                  var p4 = Fe;
                  c3 && n4.value.length > c3 && (p4 = Ae), f3.push(m2.a.createElement(p4, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), type: "array", parent_type: u2 }, t4)));
                } else
                  f3.push(m2.a.createElement(ke, Object.assign({ key: n4.name + "_" + l3, variable: n4, singleIndent: 5, namespace: l3, type: a2.props.type }, t4)));
            }), f3;
          };
          var r3 = n3.getState(e5);
          return a2.state = o(o({}, r3), {}, { prevProps: {} }), a2;
        }
        return c2(n3, [{ key: "getBraceStart", value: function(e5, t4) {
          var n4 = this, a2 = this.props, r3 = a2.src, o2 = a2.theme, i2 = a2.iconStyle;
          if (a2.parent_type === "array_group")
            return m2.a.createElement("span", null, m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{"), t4 ? this.getObjectMetaData(r3) : null);
          var s2 = t4 ? Se : we;
          return m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({ onClick: function(e6) {
            n4.toggleCollapsed();
          } }, A2(o2, "brace-row")), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container")), m2.a.createElement(s2, { theme: o2, iconStyle: i2 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{")), t4 ? this.getObjectMetaData(r3) : null);
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.depth, a2 = t4.src, r3 = (t4.namespace, t4.name, t4.type, t4.parent_type), i2 = t4.theme, s2 = t4.jsvRoot, c3 = t4.iconStyle, l3 = x2(t4, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), u2 = this.state, f3 = u2.object_type, p3 = u2.expanded, d3 = {};
          return s2 || r3 === "array_group" ? r3 === "array_group" && (d3.borderLeft = 0, d3.display = "inline") : d3.paddingLeft = 5 * this.props.indentWidth, m2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          } }, A2(i2, s2 ? "jsv-root" : "objectKeyVal", d3)), this.getBraceStart(f3, p3), p3 ? this.getObjectContent(n4, a2, o({ theme: i2, iconStyle: c3 }, l3)) : this.getEllipsis(), m2.a.createElement("span", { className: "brace-row" }, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { paddingLeft: p3 ? "3px" : "0px" }) }, f3 === "array" ? "]" : "}"), p3 ? null : this.getObjectMetaData(a2)));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          var a2 = t4.prevProps;
          return e5.src !== a2.src || e5.collapsed !== a2.collapsed || e5.name !== a2.name || e5.namespace !== a2.namespace || e5.rjvId !== a2.rjvId ? o(o({}, n3.getState(e5)), {}, { prevProps: e5 }) : null;
        } }]), n3;
      }(m2.a.PureComponent);
      Me.getState = function(e4) {
        var t3 = Object.keys(e4.src).length, n3 = (e4.collapsed === false || e4.collapsed !== true && e4.collapsed > e4.depth) && (!e4.shouldCollapse || e4.shouldCollapse({ name: e4.name, src: e4.src, type: _(e4.src), namespace: e4.namespace }) === false) && t3 !== 0;
        return { expanded: q2.get(e4.rjvId, e4.namespace, "expanded", n3), object_type: e4.type === "array" ? "array" : "object", parent_type: e4.type === "array" ? "array" : "object", size: t3, hovered: false };
      };
      var Pe = function e4(t3, n3) {
        i(this, e4), this.name = t3, this.value = n3, this.type = _(n3);
      };
      j(Me);
      var Fe = Me, De = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), o2 = 0; o2 < a2; o2++)
            r3[o2] = arguments[o2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).render = function() {
            var t4 = d2(e5).props, n4 = [t4.name], a3 = Fe;
            return Array.isArray(t4.src) && t4.groupArraysAfterLength && t4.src.length > t4.groupArraysAfterLength && (a3 = Ae), m2.a.createElement("div", { className: "pretty-json-container object-container" }, m2.a.createElement("div", { className: "object-content" }, m2.a.createElement(a3, Object.assign({ namespace: n4, depth: 0, jsvRoot: true }, t4))));
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent), Ie = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).closeModal = function() {
            z2.dispatch({ rjvId: a2.props.rjvId, name: "RESET" });
          }, a2.submit = function() {
            a2.props.submit(a2.state.input);
          }, a2.state = { input: e5.input ? e5.input : "" }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.theme, a2 = t4.rjvId, r3 = t4.isValid, o2 = this.state.input, i2 = r3(o2);
          return m2.a.createElement("div", Object.assign({ className: "key-modal-request" }, A2(n4, "key-modal-request"), { onClick: this.closeModal }), m2.a.createElement("div", Object.assign({}, A2(n4, "key-modal"), { onClick: function(e6) {
            e6.stopPropagation();
          } }), m2.a.createElement("div", A2(n4, "key-modal-label"), "Key Name:"), m2.a.createElement("div", { style: { position: "relative" } }, m2.a.createElement("input", Object.assign({}, A2(n4, "key-modal-input"), { className: "key-modal-input", ref: function(e6) {
            return e6 && e6.focus();
          }, spellCheck: false, value: o2, placeholder: "...", onChange: function(t5) {
            e5.setState({ input: t5.target.value });
          }, onKeyPress: function(t5) {
            i2 && t5.key === "Enter" ? e5.submit() : t5.key === "Escape" && e5.closeModal();
          } })), i2 ? m2.a.createElement(je, Object.assign({}, A2(n4, "key-modal-submit"), { className: "key-modal-submit", onClick: function(t5) {
            return e5.submit();
          } })) : null), m2.a.createElement("span", A2(n4, "key-modal-cancel"), m2.a.createElement(ge, Object.assign({}, A2(n4, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
            z2.dispatch({ rjvId: a2, name: "RESET" });
          } })))));
        } }]), n3;
      }(m2.a.PureComponent), Re = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).isValid = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            return t4 != "" && Object.keys(a3.existing_value).indexOf(t4) === -1;
          }, e5.submit = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            a3.new_value = o({}, a3.existing_value), a3.new_value[t4] = e5.props.defaultValue, z2.dispatch({ name: "VARIABLE_ADDED", rjvId: n4, data: a3 });
          }, e5;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.active, n4 = e5.theme, a2 = e5.rjvId;
          return t4 ? m2.a.createElement(Ie, { rjvId: a2, theme: n4, isValid: this.isValid, submit: this.submit }) : null;
        } }]), n3;
      }(m2.a.PureComponent), Le = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.message, n4 = e5.active, a2 = e5.theme, r3 = e5.rjvId;
          return n4 ? m2.a.createElement("div", Object.assign({ className: "validation-failure" }, A2(a2, "validation-failure"), { onClick: function() {
            z2.dispatch({ rjvId: r3, name: "RESET" });
          } }), m2.a.createElement("span", A2(a2, "validation-failure-label"), t4), m2.a.createElement(ge, A2(a2, "validation-failure-clear"))) : null;
        } }]), n3;
      }(m2.a.PureComponent), Be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).rjvId = Date.now().toString(), a2.getListeners = function() {
            return { reset: a2.resetState, "variable-update": a2.updateSrc, "add-key-request": a2.addKeyRequest };
          }, a2.updateSrc = function() {
            var e6, t4 = q2.get(a2.rjvId, "action", "variable-update"), n4 = t4.name, r3 = t4.namespace, o2 = t4.new_value, i2 = t4.existing_value, s2 = (t4.variable_removed, t4.updated_src), c3 = t4.type, l3 = a2.props, u2 = l3.onEdit, f3 = l3.onDelete, p3 = l3.onAdd, d3 = { existing_src: a2.state.src, new_value: o2, updated_src: s2, name: n4, namespace: r3, existing_value: i2 };
            switch (c3) {
              case "variable-added":
                e6 = p3(d3);
                break;
              case "variable-edited":
                e6 = u2(d3);
                break;
              case "variable-removed":
                e6 = f3(d3);
            }
            e6 !== false ? (q2.set(a2.rjvId, "global", "src", s2), a2.setState({ src: s2 })) : a2.setState({ validationFailure: true });
          }, a2.addKeyRequest = function() {
            a2.setState({ addKeyRequest: true });
          }, a2.resetState = function() {
            a2.setState({ validationFailure: false, addKeyRequest: false });
          }, a2.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: n3.defaultProps.src, name: n3.defaultProps.name, theme: n3.defaultProps.theme, validationMessage: n3.defaultProps.validationMessage, prevSrc: n3.defaultProps.src, prevName: n3.defaultProps.name, prevTheme: n3.defaultProps.theme }, a2;
        }
        return c2(n3, [{ key: "componentDidMount", value: function() {
          q2.set(this.rjvId, "global", "src", this.state.src);
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.on(t4 + "-" + this.rjvId, e5[t4]);
          this.setState({ addKeyRequest: false, editKeyRequest: false });
        } }, { key: "componentDidUpdate", value: function(e5, t4) {
          t4.addKeyRequest !== false && this.setState({ addKeyRequest: false }), t4.editKeyRequest !== false && this.setState({ editKeyRequest: false }), e5.src !== this.state.src && q2.set(this.rjvId, "global", "src", this.state.src);
        } }, { key: "componentWillUnmount", value: function() {
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.removeListener(t4 + "-" + this.rjvId, e5[t4]);
        } }, { key: "render", value: function() {
          var e5 = this.state, t4 = e5.validationFailure, n4 = e5.validationMessage, a2 = e5.addKeyRequest, r3 = e5.theme, i2 = e5.src, s2 = e5.name, c3 = this.props, l3 = c3.style, u2 = c3.defaultValue;
          return m2.a.createElement("div", { className: "react-json-view", style: o(o({}, A2(r3, "app-container").style), l3) }, m2.a.createElement(Le, { message: n4, active: t4, theme: r3, rjvId: this.rjvId }), m2.a.createElement(De, Object.assign({}, this.props, { src: i2, name: s2, theme: r3, type: _(i2), rjvId: this.rjvId })), m2.a.createElement(Re, { active: a2, theme: r3, rjvId: this.rjvId, defaultValue: u2 }));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          if (e5.src !== t4.prevSrc || e5.name !== t4.prevName || e5.theme !== t4.prevTheme) {
            var a2 = { src: e5.src, name: e5.name, theme: e5.theme, validationMessage: e5.validationMessage, prevSrc: e5.src, prevName: e5.name, prevTheme: e5.theme };
            return n3.validateState(a2);
          }
          return null;
        } }]), n3;
      }(m2.a.PureComponent);
      Be.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Be.validateState = function(e4) {
        var t3 = {};
        return _(e4.theme) !== "object" || function(e5) {
          var t4 = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
          if (_(e5) === "object") {
            for (var n3 = 0; n3 < t4.length; n3++)
              if (!(t4[n3] in e5))
                return false;
            return true;
          }
          return false;
        }(e4.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), t3.theme = "rjv-default"), _(e4.src) !== "object" && _(e4.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), t3.name = "ERROR", t3.src = { message: "src property must be a valid json object" }), o(o({}, e4), t3);
      }, j(Be);
      t2.default = Be;
    }]);
  });
})(main);
var ReactJson = /* @__PURE__ */ getDefaultExportFromCjs(main.exports);
const OptionView = ({
  id: id2,
  title,
  chart,
  option
}) => {
  const {
    tool
  } = useEchartsTool({});
  const event = useEventEmitter({
    global: true
  });
  const [collapsed, {
    set: toggleCollapsed
  }] = useBoolean(true);
  console.log("option", option);
  const optionChange = (ctrl) => {
    const {
      updated_src
    } = ctrl;
    chart == null ? void 0 : chart.setOption(updated_src);
    tool == null ? void 0 : tool.add(id2, chart, updated_src, title);
    event.emit("list");
  };
  return /* @__PURE__ */ jsxs("div", {
    children: [/* @__PURE__ */ jsx(Row$1, {
      children: /* @__PURE__ */ jsx(Col$1, {
        children: /* @__PURE__ */ jsx(Switch$1, {
          checkedChildren: "\u5C55\u5F00\u914D\u7F6E",
          unCheckedChildren: "\u6298\u53E0\u914D\u7F6E",
          defaultChecked: false,
          onChange: (e2) => {
            toggleCollapsed(!e2);
          }
        })
      })
    }), /* @__PURE__ */ jsx("br", {}), option && /* @__PURE__ */ jsx(ReactJson, {
      src: option,
      theme: "pop",
      displayObjectSize: false,
      displayDataTypes: false,
      collapsed,
      iconStyle: "triangle",
      enableClipboard: true,
      onEdit: optionChange,
      onAdd: optionChange,
      onDelete: optionChange
    })]
  });
};
export { EchartTool, OptionView as ReactEchartsJson, useEcharts, useEchartsTool, useEventEmitter };
